/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/errors","vs/base/common/lifecycle","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(q){for(var t=[],D=0,k=q.length;D<k;D++)t[D]=Z[q[D]];return t},Ue=this,Oe=typeof global=="object"?global:{},ue;(function(q){q.global=Ue;var t=function(){function D(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(D.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),D.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=D._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},D._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},D}();q.Environment=t})(ue||(ue={}));var ue;(function(q){var t=function(){function i(u,y,b){this.type=u,this.detail=y,this.timestamp=b}return i}();q.LoaderEvent=t;var D=function(){function i(u){this._events=[new t(1,"",u)]}return i.prototype.record=function(u,y){this._events.push(new t(u,y,q.Utilities.getHighPerformanceTimestamp()))},i.prototype.getEvents=function(){return this._events},i}();q.LoaderEventRecorder=D;var k=function(){function i(){}return i.prototype.record=function(u,y){},i.prototype.getEvents=function(){return[]},i.INSTANCE=new i,i}();q.NullLoaderEventRecorder=k})(ue||(ue={}));var ue;(function(q){var t=function(){function D(){}return D.fileUriToFilePath=function(k,i){if(i=decodeURI(i).replace(/%23/g,"#"),k){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i},D.startsWith=function(k,i){return k.length>=i.length&&k.substr(0,i.length)===i},D.endsWith=function(k,i){return k.length>=i.length&&k.substr(k.length-i.length)===i},D.containsQueryString=function(k){return/^[^\#]*\?/gi.test(k)},D.isAbsolutePath=function(k){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(k)},D.forEachProperty=function(k,i){if(k){var u=void 0;for(u in k)k.hasOwnProperty(u)&&i(u,k[u])}},D.isEmpty=function(k){var i=!0;return D.forEachProperty(k,function(){i=!1}),i},D.recursiveClone=function(k){if(!k||typeof k!="object"||k instanceof RegExp||!Array.isArray(k)&&Object.getPrototypeOf(k)!==Object.prototype)return k;var i=Array.isArray(k)?[]:{};return D.forEachProperty(k,function(u,y){y&&typeof y=="object"?i[u]=D.recursiveClone(y):i[u]=y}),i},D.generateAnonymousModule=function(){return"===anonymous"+D.NEXT_ANONYMOUS_ID+++"==="},D.isAnonymousModule=function(k){return D.startsWith(k,"===anonymous")},D.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()},D.NEXT_ANONYMOUS_ID=1,D.PERFORMANCE_NOW_PROBED=!1,D.HAS_PERFORMANCE_NOW=!1,D}();q.Utilities=t})(ue||(ue={}));var ue;(function(q){function t(i){if(i instanceof Error)return i;var u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}q.ensureError=t;var D=function(){function i(){}return i.validateConfigurationOptions=function(u){function y(a){if(a.phase==="loading"){console.error('Loading "'+a.moduleId+'" failed'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}if(a.phase==="factory"){console.error('The factory function of "'+a.moduleId+'" has thrown an exception'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=y),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(q.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){var b=t(new Error("INVALID cached data configuration, 'path' MUST be set"));b.phase="configuration",u.onError(b),u.nodeCachedData=void 0}return u},i.mergeConfigurationOptions=function(u,y){u===void 0&&(u=null),y===void 0&&(y=null);var b=q.Utilities.recursiveClone(y||{});return q.Utilities.forEachProperty(u,function(a,f){a==="ignoreDuplicateModules"&&typeof b.ignoreDuplicateModules<"u"?b.ignoreDuplicateModules=b.ignoreDuplicateModules.concat(f):a==="paths"&&typeof b.paths<"u"?q.Utilities.forEachProperty(f,function(N,M){return b.paths[N]=M}):a==="config"&&typeof b.config<"u"?q.Utilities.forEachProperty(f,function(N,M){return b.config[N]=M}):b[a]=q.Utilities.recursiveClone(f)}),i.validateConfigurationOptions(b)},i}();q.ConfigurationOptionsUtil=D;var k=function(){function i(u,y){if(this._env=u,this.options=D.mergeConfigurationOptions(y),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var b=this.options.nodeRequire.main.filename,a=Math.max(b.lastIndexOf("/"),b.lastIndexOf("\\"));this.options.baseUrl=b.substring(0,a+1)}}return i.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0},i.prototype._createSortedPathsRules=function(){var u=this;this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,function(y,b){Array.isArray(b)?u.sortedPathsRules.push({from:y,to:b}):u.sortedPathsRules.push({from:y,to:[b]})}),this.sortedPathsRules.sort(function(y,b){return b.from.length-y.from.length})},i.prototype.cloneAndMerge=function(u){return new i(this._env,D.mergeConfigurationOptions(u,this.options))},i.prototype.getOptionsLiteral=function(){return this.options},i.prototype._applyPaths=function(u){for(var y,b=0,a=this.sortedPathsRules.length;b<a;b++)if(y=this.sortedPathsRules[b],q.Utilities.startsWith(u,y.from)){for(var f=[],N=0,M=y.to.length;N<M;N++)f.push(y.to[N]+u.substr(y.from.length));return f}return[u]},i.prototype._addUrlArgsToUrl=function(u){return q.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs},i.prototype._addUrlArgsIfNecessaryToUrl=function(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u},i.prototype._addUrlArgsIfNecessaryToUrls=function(u){if(this.options.urlArgs)for(var y=0,b=u.length;y<b;y++)u[y]=this._addUrlArgsToUrl(u[y]);return u},i.prototype.moduleIdToPaths=function(u){if(this._env.isNode){var y=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u);if(y)return this.isBuild()?["empty:"]:["node|"+u]}var b=u,a;if(!q.Utilities.endsWith(b,".js")&&!q.Utilities.isAbsolutePath(b)){a=this._applyPaths(b);for(var f=0,N=a.length;f<N;f++)this.isBuild()&&a[f]==="empty:"||(q.Utilities.isAbsolutePath(a[f])||(a[f]=this.options.baseUrl+a[f]),!q.Utilities.endsWith(a[f],".js")&&!q.Utilities.containsQueryString(a[f])&&(a[f]=a[f]+".js"))}else!q.Utilities.endsWith(b,".js")&&!q.Utilities.containsQueryString(b)&&(b=b+".js"),a=[b];return this._addUrlArgsIfNecessaryToUrls(a)},i.prototype.requireToUrl=function(u){var y=u;return q.Utilities.isAbsolutePath(y)||(y=this._applyPaths(y)[0],q.Utilities.isAbsolutePath(y)||(y=this.options.baseUrl+y)),this._addUrlArgsIfNecessaryToUrl(y)},i.prototype.isBuild=function(){return this.options.isBuild},i.prototype.shouldInvokeFactory=function(u){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])},i.prototype.isDuplicateMessageIgnoredFor=function(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)},i.prototype.getConfigForModule=function(u){if(this.options.config)return this.options.config[u]},i.prototype.shouldCatchError=function(){return this.options.catchError},i.prototype.shouldRecordStats=function(){return this.options.recordStats},i.prototype.onError=function(u){this.options.onError(u)},i}();q.Configuration=k})(ue||(ue={}));var ue;(function(q){var t=function(){function a(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return a.prototype.load=function(f,N,M,p){var v=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){var e=f.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new D:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new D;var A={callback:M,errorback:p};if(this._callbackMap.hasOwnProperty(N)){this._callbackMap[N].push(A);return}this._callbackMap[N]=[A],this._scriptLoader.load(f,N,function(){return v.triggerCallback(N)},function(F){return v.triggerErrorback(N,F)})},a.prototype.triggerCallback=function(f){var N=this._callbackMap[f];delete this._callbackMap[f];for(var M=0;M<N.length;M++)N[M].callback()},a.prototype.triggerErrorback=function(f,N){var M=this._callbackMap[f];delete this._callbackMap[f];for(var p=0;p<M.length;p++)M[p].errorback(N)},a}(),D=function(){function a(){}return a.prototype.attachListeners=function(f,N,M){var p=function(){f.removeEventListener("load",v),f.removeEventListener("error",e)},v=function(A){p(),N()},e=function(A){p(),M(A)};f.addEventListener("load",v),f.addEventListener("error",e)},a.prototype.load=function(f,N,M,p){if(/^node\|/.test(N)){var v=f.getConfig().getOptionsLiteral(),e=y(f.getRecorder(),v.nodeRequire||q.global.nodeRequire),A=N.split("|"),F=null;try{F=e(A[1])}catch(m){p(m);return}f.enqueueDefineAnonymousModule([],function(){return F}),M()}else{var E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript"),this.attachListeners(E,M,p);var L=f.getConfig().getOptionsLiteral().trustedTypesPolicy;L&&(N=L.createScriptURL(N)),E.setAttribute("src",N);var g=f.getConfig().getOptionsLiteral().cspNonce;g&&E.setAttribute("nonce",g),document.getElementsByTagName("head")[0].appendChild(E)}},a}();function k(a){var f=a.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var N=f?self.eval(f.createScript("","true")):new Function("true");return N.call(self),!0}catch{return!1}}var i=function(){function a(){this._cachedCanUseEval=null}return a.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=k(f)),this._cachedCanUseEval},a.prototype.load=function(f,N,M,p){if(/^node\|/.test(N)){var v=f.getConfig().getOptionsLiteral(),e=y(f.getRecorder(),v.nodeRequire||q.global.nodeRequire),A=N.split("|"),F=null;try{F=e(A[1])}catch(g){p(g);return}f.enqueueDefineAnonymousModule([],function(){return F}),M()}else{var E=f.getConfig().getOptionsLiteral().trustedTypesPolicy,L=/^((http:)|(https:)|(file:))/.test(N)&&N.substring(0,self.origin.length)!==self.origin;if(!L&&this._canUseEval(f)){fetch(N).then(function(g){if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(function(g){g=g+`
//# sourceURL=`+N;var m=E?self.eval(E.createScript("",g)):new Function(g);m.call(self),M()}).then(void 0,p);return}try{E&&(N=E.createScriptURL(N)),importScripts(N),M()}catch(g){p(g)}}},a}(),u=function(){function a(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return a.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},a.prototype._initNodeRequire=function(f,N){var M=N.getConfig().getOptionsLiteral().nodeCachedData;if(!M||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var p=this,v=f("module");function e(A){var F=A.constructor,E=function(g){try{return A.require(g)}finally{}};return E.resolve=function(g,m){return F._resolveFilename(g,A,!1,m)},E.resolve.paths=function(g){return F._resolveLookupPaths(g,A)},E.main=process.mainModule,E.extensions=F._extensions,E.cache=F._cache,E}v.prototype._compile=function(A,F){var E=v.wrap(A.replace(/^#!.*/,"")),L=N.getRecorder(),g=p._getCachedDataPath(M,F),m={filename:F},l;try{var r=p._fs.readFileSync(g);l=r.slice(0,16),m.cachedData=r.slice(16),L.record(60,g)}catch{L.record(61,g)}var s=new p._vm.Script(E,m),d=s.runInThisContext(m),c=p._path.dirname(F),w=e(this),_=[this.exports,w,this,F,c,process,Oe,Buffer],h=d.apply(this.exports,_);return p._handleCachedData(s,E,g,!m.cachedData,N),p._verifyCachedData(s,E,g,l,N),h}},a.prototype.load=function(f,N,M,p){var v=this,e=f.getConfig().getOptionsLiteral(),A=y(f.getRecorder(),e.nodeRequire||q.global.nodeRequire),F=e.nodeInstrumenter||function(d){return d};this._init(A),this._initNodeRequire(A,f);var E=f.getRecorder();if(/^node\|/.test(N)){var L=N.split("|"),g=null;try{g=A(L[1])}catch(d){p(d);return}f.enqueueDefineAnonymousModule([],function(){return g}),M()}else{N=q.Utilities.fileUriToFilePath(this._env.isWindows,N);var m=this._path.normalize(N),l=this._getElectronRendererScriptPathOrUri(m),r=Boolean(e.nodeCachedData),s=r?this._getCachedDataPath(e.nodeCachedData,N):void 0;this._readSourceAndCachedData(m,s,E,function(d,c,w,_){if(d){p(d);return}var h;c.charCodeAt(0)===a._BOM?h=a._PREFIX+c.substring(1)+a._SUFFIX:h=a._PREFIX+c+a._SUFFIX,h=F(h,m);var o={filename:l,cachedData:w},R=v._createAndEvalScript(f,h,o,M,p);v._handleCachedData(R,h,s,r&&!w,f),v._verifyCachedData(R,h,s,_,f)})}},a.prototype._createAndEvalScript=function(f,N,M,p,v){var e=f.getRecorder();e.record(31,M.filename);var A=new this._vm.Script(N,M),F=A.runInThisContext(M),E=f.getGlobalAMDDefineFunc(),L=!1,g=function(){return L=!0,E.apply(null,arguments)};return g.amd=E.amd,F.call(q.global,f.getGlobalAMDRequireFunc(),g,M.filename,this._path.dirname(M.filename)),e.record(32,M.filename),L?p():v(new Error("Didn't receive define call in "+M.filename+"!")),A},a.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var N=f.match(/^([a-z])\:(.*)/i);return N?"file:///"+(N[1].toUpperCase()+":"+N[2]).replace(/\\/g,"/"):"file://"+f},a.prototype._getCachedDataPath=function(f,N){var M=this._crypto.createHash("md5").update(N,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),p=this._path.basename(N).replace(/\.js$/,"");return this._path.join(f.path,p+"-"+M+".code")},a.prototype._handleCachedData=function(f,N,M,p,v){var e=this;f.cachedDataRejected?this._fs.unlink(M,function(A){v.getRecorder().record(62,M),e._createAndWriteCachedData(f,N,M,v),A&&v.getConfig().onError(A)}):p&&this._createAndWriteCachedData(f,N,M,v)},a.prototype._createAndWriteCachedData=function(f,N,M,p){var v=this,e=Math.ceil(p.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),A=-1,F=0,E=void 0,L=function(){setTimeout(function(){E||(E=v._crypto.createHash("md5").update(N,"utf8").digest());var g=f.createCachedData();if(!(g.length===0||g.length===A||F>=5)){if(g.length<A){L();return}A=g.length,v._fs.writeFile(M,Buffer.concat([E,g]),function(m){m&&p.getConfig().onError(m),p.getRecorder().record(63,M),L()})}},e*Math.pow(4,F++))};L()},a.prototype._readSourceAndCachedData=function(f,N,M,p){if(!N)this._fs.readFile(f,{encoding:"utf8"},p);else{var v=void 0,e=void 0,A=void 0,F=2,E=function(L){L?p(L):--F===0&&p(void 0,v,e,A)};this._fs.readFile(f,{encoding:"utf8"},function(L,g){v=g,E(L)}),this._fs.readFile(N,function(L,g){!L&&g&&g.length>0?(A=g.slice(0,16),e=g.slice(16),M.record(60,N)):M.record(61,N),E()})}},a.prototype._verifyCachedData=function(f,N,M,p,v){var e=this;!p||f.cachedDataRejected||setTimeout(function(){var A=e._crypto.createHash("md5").update(N,"utf8").digest();p.equals(A)||(v.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+M+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(M,function(F){F&&v.getConfig().onError(F)}))},Math.ceil(5e3*(1+Math.random())))},a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`,a}();function y(a,f){if(f.__$__isRecorded)return f;var N=function(p){a.record(33,p);try{return f(p)}finally{a.record(34,p)}};return N.__$__isRecorded=!0,N}q.ensureRecordedNodeRequire=y;function b(a){return new t(a)}q.createScriptLoader=b})(ue||(ue={}));var ue;(function(q){var t=function(){function b(a){var f=a.lastIndexOf("/");f!==-1?this.fromModulePath=a.substr(0,f+1):this.fromModulePath=""}return b._normalizeModuleId=function(a){var f=a,N;for(N=/\/\.\//;N.test(f);)f=f.replace(N,"/");for(f=f.replace(/^\.\//g,""),N=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;N.test(f);)f=f.replace(N,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},b.prototype.resolveModule=function(a){var f=a;return q.Utilities.isAbsolutePath(f)||(q.Utilities.startsWith(f,"./")||q.Utilities.startsWith(f,"../"))&&(f=b._normalizeModuleId(this.fromModulePath+f)),f},b.ROOT=new b(""),b}();q.ModuleIdResolver=t;var D=function(){function b(a,f,N,M,p,v){this.id=a,this.strId=f,this.dependencies=N,this._callback=M,this._errorback=p,this.moduleIdResolver=v,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return b._safeInvokeFunction=function(a,f){try{return{returnedValue:a.apply(q.global,f),producedError:null}}catch(N){return{returnedValue:null,producedError:N}}},b._invokeFactory=function(a,f,N,M){return a.shouldInvokeFactory(f)?a.shouldCatchError()?this._safeInvokeFunction(N,M):{returnedValue:N.apply(q.global,M),producedError:null}:{returnedValue:null,producedError:null}},b.prototype.complete=function(a,f,N,M){this._isComplete=!0;var p=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);var v=b._invokeFactory(f,this.strId,this._callback,N);p=v.producedError,a.record(22,this.strId),!p&&typeof v.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=v.returnedValue)}else this.exports=this._callback;if(p){var e=q.ensureError(p);e.phase="factory",e.moduleId=this.strId,e.neededBy=M(this.id),this.error=e,f.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},b.prototype.onDependencyError=function(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1},b.prototype.isComplete=function(){return this._isComplete},b}();q.Module=D;var k=function(){function b(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return b.prototype.getMaxModuleId=function(){return this._nextId},b.prototype.getModuleId=function(a){var f=this._strModuleIdToIntModuleId.get(a);return typeof f>"u"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(a,f),this._intModuleIdToStrModuleId[f]=a),f},b.prototype.getStrModuleId=function(a){return this._intModuleIdToStrModuleId[a]},b}(),i=function(){function b(a){this.id=a}return b.EXPORTS=new b(0),b.MODULE=new b(1),b.REQUIRE=new b(2),b}();q.RegularDependency=i;var u=function(){function b(a,f,N){this.id=a,this.pluginId=f,this.pluginParam=N}return b}();q.PluginDependency=u;var y=function(){function b(a,f,N,M,p){p===void 0&&(p=0),this._env=a,this._scriptLoader=f,this._loaderAvailableTimestamp=p,this._defineFunc=N,this._requireFunc=M,this._moduleIdProvider=new k,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return b.prototype.reset=function(){return new b(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},b.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},b.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},b._findRelevantLocationInStack=function(a,f){for(var N=function(m){return m.replace(/\\/g,"/")},M=N(a),p=f.split(/\n/),v=0;v<p.length;v++){var e=p[v].match(/(.*):(\d+):(\d+)\)?$/);if(e){var A=e[1],F=e[2],E=e[3],L=Math.max(A.lastIndexOf(" ")+1,A.lastIndexOf("(")+1);if(A=A.substr(L),A=N(A),A===M){var g={line:parseInt(F,10),col:parseInt(E,10)};return g.line===1&&(g.col-=53),g}}}throw new Error("Could not correlate define call site for needle "+a)},b.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var a=[],f=0,N=0,M=this._modules2.length;N<M;N++){var p=this._modules2[N];if(!!p){var v=this._buildInfoPath[p.id]||null,e=this._buildInfoDefineStack[p.id]||null,A=this._buildInfoDependencies[p.id];a[f++]={id:p.strId,path:v,defineLocation:v&&e?b._findRelevantLocationInStack(v,e):null,dependencies:A,shim:null,exports:p.exports}}}return a},b.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder},b.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},b.prototype.enqueueDefineAnonymousModule=function(a,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var N=null;this._config.isBuild()&&(N=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:N,dependencies:a,callback:f}},b.prototype.defineModule=function(a,f,N,M,p,v){var e=this;v===void 0&&(v=new t(a));var A=this._moduleIdProvider.getModuleId(a);if(this._modules2[A]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}var F=new D(A,a,this._normalizeDependencies(f,v),N,M,v);this._modules2[A]=F,this._config.isBuild()&&(this._buildInfoDefineStack[A]=p,this._buildInfoDependencies[A]=(F.dependencies||[]).map(function(E){return e._moduleIdProvider.getStrModuleId(E.id)})),this._resolve(F)},b.prototype._normalizeDependency=function(a,f){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;var N=a.indexOf("!");if(N>=0){var M=f.resolveModule(a.substr(0,N)),p=f.resolveModule(a.substr(N+1)),v=this._moduleIdProvider.getModuleId(M+"!"+p),e=this._moduleIdProvider.getModuleId(M);return new u(v,e,p)}return new i(this._moduleIdProvider.getModuleId(f.resolveModule(a)))},b.prototype._normalizeDependencies=function(a,f){for(var N=[],M=0,p=0,v=a.length;p<v;p++)N[M++]=this._normalizeDependency(a[p],f);return N},b.prototype._relativeRequire=function(a,f,N,M){if(typeof f=="string")return this.synchronousRequire(f,a);this.defineModule(q.Utilities.generateAnonymousModule(),f,N,M,null,a)},b.prototype.synchronousRequire=function(a,f){f===void 0&&(f=new t(a));var N=this._normalizeDependency(a,f),M=this._modules2[N.id];if(!M)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!M.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(M.error)throw M.error;return M.exports},b.prototype.configure=function(a,f){var N=this._config.shouldRecordStats();f?this._config=new q.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!N&&(this._recorder=null)},b.prototype.getConfig=function(){return this._config},b.prototype._onLoad=function(a){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),f.dependencies,f.callback,null,f.stack)}},b.prototype._createLoadError=function(a,f){var N=this,M=this._moduleIdProvider.getStrModuleId(a),p=(this._inverseDependencies2[a]||[]).map(function(e){return N._moduleIdProvider.getStrModuleId(e)}),v=q.ensureError(f);return v.phase="loading",v.moduleId=M,v.neededBy=p,v},b.prototype._onLoadError=function(a,f){var N=this._createLoadError(a,f);this._modules2[a]||(this._modules2[a]=new D(a,this._moduleIdProvider.getStrModuleId(a),[],function(){},null,null));for(var M=[],p=0,v=this._moduleIdProvider.getMaxModuleId();p<v;p++)M[p]=!1;var e=!1,A=[];for(A.push(a),M[a]=!0;A.length>0;){var F=A.shift(),E=this._modules2[F];E&&(e=E.onDependencyError(N)||e);var L=this._inverseDependencies2[F];if(L)for(var p=0,v=L.length;p<v;p++){var g=L[p];M[g]||(A.push(g),M[g]=!0)}}e||this._config.onError(N)},b.prototype._hasDependencyPath=function(a,f){var N=this._modules2[a];if(!N)return!1;for(var M=[],p=0,v=this._moduleIdProvider.getMaxModuleId();p<v;p++)M[p]=!1;var e=[];for(e.push(N),M[a]=!0;e.length>0;){var A=e.shift(),F=A.dependencies;if(F)for(var p=0,v=F.length;p<v;p++){var E=F[p];if(E.id===f)return!0;var L=this._modules2[E.id];L&&!M[E.id]&&(M[E.id]=!0,e.push(L))}}return!1},b.prototype._findCyclePath=function(a,f,N){if(a===f||N===50)return[a];var M=this._modules2[a];if(!M)return null;var p=M.dependencies;if(p)for(var v=0,e=p.length;v<e;v++){var A=this._findCyclePath(p[v].id,f,N+1);if(A!==null)return A.push(a),A}return null},b.prototype._createRequire=function(a){var f=this,N=function(M,p,v){return f._relativeRequire(a,M,p,v)};return N.toUrl=function(M){return f._config.requireToUrl(a.resolveModule(M))},N.getStats=function(){return f.getLoaderEvents()},N.hasDependencyCycle=function(){return f._hasDependencyCycle},N.config=function(M,p){p===void 0&&(p=!1),f.configure(M,p)},N.__$__nodeRequire=q.global.nodeRequire,N},b.prototype._loadModule=function(a){var f=this;if(!(this._modules2[a]||this._knownModules2[a])){this._knownModules2[a]=!0;var N=this._moduleIdProvider.getStrModuleId(a),M=this._config.moduleIdToPaths(N),p=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(N.indexOf("/")===-1||p.test(N))&&M.push("node|"+N);var v=-1,e=function(A){if(v++,v>=M.length)f._onLoadError(a,A);else{var F=M[v],E=f.getRecorder();if(f._config.isBuild()&&F==="empty:"){f._buildInfoPath[a]=F,f.defineModule(f._moduleIdProvider.getStrModuleId(a),[],null,null,null),f._onLoad(a);return}E.record(10,F),f._scriptLoader.load(f,F,function(){f._config.isBuild()&&(f._buildInfoPath[a]=F),E.record(11,F),f._onLoad(a)},function(L){E.record(12,F),e(L)})}};e(null)}},b.prototype._loadPluginDependency=function(a,f){var N=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var M=function(p){N.defineModule(N._moduleIdProvider.getStrModuleId(f.id),[],p,null,null)};M.error=function(p){N._config.onError(N._createLoadError(f.id,p))},a.load(f.pluginParam,this._createRequire(t.ROOT),M,this._config.getOptionsLiteral())}},b.prototype._resolve=function(a){var f=this,N=a.dependencies;if(N)for(var M=0,p=N.length;M<p;M++){var v=N[M];if(v===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(v===i.MODULE){a.unresolvedDependenciesCount--;continue}if(v===i.REQUIRE){a.unresolvedDependenciesCount--;continue}var e=this._modules2[v.id];if(e&&e.isComplete()){if(e.error){a.onDependencyError(e.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(v.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(v.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");var A=this._findCyclePath(v.id,a.id,0)||[];A.reverse(),A.push(v.id),console.warn(A.map(function(L){return f._moduleIdProvider.getStrModuleId(L)}).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[v.id]=this._inverseDependencies2[v.id]||[],this._inverseDependencies2[v.id].push(a.id),v instanceof u){var F=this._modules2[v.pluginId];if(F&&F.isComplete()){this._loadPluginDependency(F.exports,v);continue}var E=this._inversePluginDependencies2.get(v.pluginId);E||(E=[],this._inversePluginDependencies2.set(v.pluginId,E)),E.push(v),this._loadModule(v.pluginId);continue}this._loadModule(v.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)},b.prototype._onModuleComplete=function(a){var f=this,N=this.getRecorder();if(!a.isComplete()){var M=a.dependencies,p=[];if(M)for(var v=0,e=M.length;v<e;v++){var A=M[v];if(A===i.EXPORTS){p[v]=a.exports;continue}if(A===i.MODULE){p[v]={id:a.strId,config:function(){return f._config.getConfigForModule(a.strId)}};continue}if(A===i.REQUIRE){p[v]=this._createRequire(a.moduleIdResolver);continue}var F=this._modules2[A.id];if(F){p[v]=F.exports;continue}p[v]=null}var E=function(r){return(f._inverseDependencies2[r]||[]).map(function(s){return f._moduleIdProvider.getStrModuleId(s)})};a.complete(N,this._config,p,E);var L=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,L)for(var v=0,e=L.length;v<e;v++){var g=L[v],m=this._modules2[g];m.unresolvedDependenciesCount--,m.unresolvedDependenciesCount===0&&this._onModuleComplete(m)}var l=this._inversePluginDependencies2.get(a.id);if(l){this._inversePluginDependencies2.delete(a.id);for(var v=0,e=l.length;v<e;v++)this._loadPluginDependency(a.exports,l[v])}}},b}();q.ModuleManager=y})(ue||(ue={}));var Y,ue;(function(q){var t=new q.Environment,D=null,k=function(b,a,f){typeof b!="string"&&(f=a,a=b,b=null),(typeof a!="object"||!Array.isArray(a))&&(f=a,a=null),a||(a=["require","exports","module"]),b?D.defineModule(b,a,f,null,null):D.enqueueDefineAnonymousModule(a,f)};k.amd={jQuery:!0};var i=function(b,a){a===void 0&&(a=!1),D.configure(b,a)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return D.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){D.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return D.getConfig().getOptionsLiteral()},u.reset=function(){D=D.reset()},u.getBuildInfo=function(){return D.getBuildInfo()},u.getStats=function(){return D.getLoaderEvents()},u.define=k;function y(){if(typeof q.global.require<"u"||typeof require<"u"){var b=q.global.require||require;if(typeof b=="function"&&typeof b.resolve=="function"){var a=q.ensureRecordedNodeRequire(D.getRecorder(),b);q.global.nodeRequire=a,u.nodeRequire=a,u.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=u:(t.isElectronRenderer||(q.global.define=k),q.global.require=u)}q.init=y,(typeof q.global.define!="function"||!q.global.define.amd)&&(D=new q.ModuleManager(t,q.createScriptLoader(t),k,u,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&u.config(q.global.require),Y=function(){return k.apply(null,arguments)},Y.amd=k.amd,typeof doNotInitLoader>"u"&&y())})(ue||(ue={})),Y(Z[54],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function D(b,a,f,N){if(N=N||{},(N["vs/css"]||{}).disabled){f({});return}const p=a.toUrl(b+".css");k(b,p,()=>{f({})},v=>{typeof f.error=="function"&&f.error("Could not find "+p+".")})}t.load=D;function k(b,a,f,N){if(i(b,a)){f();return}u(b,a,f,N)}function i(b,a){const f=document.getElementsByTagName("link");for(let N=0,M=f.length;N<M;N++){const p=f[N].getAttribute("data-name"),v=f[N].getAttribute("href");if(p===b||v===a)return!0}return!1}function u(b,a,f,N){const M=document.createElement("link");M.setAttribute("rel","stylesheet"),M.setAttribute("type","text/css"),M.setAttribute("data-name",b),y(b,M,f,N),M.setAttribute("href",a),(document.head||document.getElementsByTagName("head")[0]).appendChild(M)}function y(b,a,f,N){const M=()=>{a.removeEventListener("load",p),a.removeEventListener("error",v)},p=e=>{M(),f()},v=e=>{M(),N(e)};a.addEventListener("load",p),a.addEventListener("error",v)}}),Y("vs/nls",["require","exports"],function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let D=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const k="i-default";function i(e,A){let F;return A.length===0?F=e:F=e.replace(/\{(\d+)\}/g,(E,L)=>{const g=L[0],m=A[g];let l=E;return typeof m=="string"?l=m:(typeof m=="number"||typeof m=="boolean"||m===void 0||m===null)&&(l=String(m)),l}),D&&(F="\uFF3B"+F.replace(/[aouei]/g,"$&$&")+"\uFF3D"),F}function u(e,A){let F=e[A];return F||(F=e["*"],F)?F:null}function y(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function b(e,A,F){const E=y(e)+y(A)+"vscode/"+y(F),L=await fetch(E);if(L.ok)return await L.json();throw new Error(`${L.status} - ${L.statusText}`)}function a(e){return function(A,F){const E=Array.prototype.slice.call(arguments,2);return i(e[A],E)}}function f(e,A,...F){return i(A,F)}t.localize=f;function N(e){}t.getConfiguredDefaultLocale=N;function M(e){D=e}t.setPseudoTranslation=M;function p(e,A){return{localize:a(A[e]),getConfiguredDefaultLocale:A.getConfiguredDefaultLocale??(F=>{})}}t.create=p;function v(e,A,F,E){const L=E["vs/nls"]??{};if(!e||e.length===0)return F({localize:f,getConfiguredDefaultLocale:()=>L.availableLanguages?.["*"]});const g=L.availableLanguages?u(L.availableLanguages,e):null,m=g===null||g===k;let l=".nls";m||(l=l+"."+g);const r=s=>{Array.isArray(s)?s.localize=a(s):s.localize=a(s[e]),s.getConfiguredDefaultLocale=()=>L.availableLanguages?.["*"],F(s)};typeof L.loadBundle=="function"?L.loadBundle(e,g,(s,d)=>{s?A([e+".nls"],r):r(d)}):L.translationServiceUrl&&!m?(async()=>{try{const s=await b(L.translationServiceUrl,g,e);return r(s)}catch(s){if(!g.includes("-"))return console.error(s),A([e+".nls"],r);try{const d=g.split("-")[0],c=await b(L.translationServiceUrl,d,e);return L.availableLanguages??={},L.availableLanguages["*"]=d,r(c)}catch(d){return console.error(d),A([e+".nls"],r)}}})():A([e+l],r,s=>{if(l===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${g}. Falling back to the default language:`,s),A([e+".nls"],r)})}t.load=v}),function(){const q=self.MonacoEnvironment,t=q&&q.baseUrl?q.baseUrl:"../../../",D=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:f=>f,createScript:(f,...N)=>{const M=N.slice(0,-1).join(","),p=N.pop().toString();return`(function anonymous(${M}) { ${p}
})`}}):void 0;function k(){try{return(D?self.eval(D.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function i(){return new Promise((f,N)=>{if(typeof self.define=="function"&&self.define.amd)return f();const M=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(M)&&M.substring(0,self.origin.length)!==self.origin)&&k()){fetch(M).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${M}`,(D?self.eval(D.createScript("",v)):new Function(v)).call(self),f()}).then(void 0,N);return}D?importScripts(D.createScriptURL(M)):importScripts(M),f()})}function u(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function y(f){i().then(()=>{u(),require([f],function(N){setTimeout(function(){const M=N.create((p,v)=>{self.postMessage(p,v)},null);for(self.onmessage=p=>M.onmessage(p.data,p.ports);a.length>0;)self.onmessage(a.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&u();let b=!0;const a=[];self.onmessage=f=>{if(!b){a.push(f);return}b=!1,y(f.data)}}(),Y(Z[25],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class D{constructor(i,u,y,b){this.originalStart=i,this.originalLength=u,this.modifiedStart=y,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=D}),Y(Z[6],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?m.isErrorNoTelemetry(s)?new m(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(d=>{d(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}t.ErrorHandler=D,t.errorHandler=new D;function k(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=k;function i(r){if(!r||typeof r!="object")return!1;const s=r;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function u(r){f(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=u;function y(r){f(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=y;function b(r){if(r instanceof Error){const{name:s,message:d}=r,c=r.stacktrace||r.stack;return{$isError:!0,name:s,message:d,stack:c,noTelemetry:m.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=b;const a="Canceled";function f(r){return r instanceof N?!0:r instanceof Error&&r.name===a&&r.message===a}t.isCancellationError=f;class N extends Error{constructor(){super(a),this.name=this.message}}t.CancellationError=N;function M(){const r=new Error(a);return r.name=r.message,r}t.canceled=M;function p(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=p;function v(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=v;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function A(r){const s=new Error(`${r} has been disposed`);return s.name="DISPOSED",s}t.disposed=A;function F(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=F;class E extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.NotImplementedError=E;class L extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.NotSupportedError=L;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=g;class m extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof m)return s;const d=new m;return d.message=s.message,d.stack=s.stack,d}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.ErrorNoTelemetry=m;class l extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype);debugger}}t.BugIndicatingError=l}),Y(Z[26],K([0,1,6]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function k(S,T=0){return S[S.length-(1+T)]}t.tail=k;function i(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}t.tail2=i;function u(S,T,C=(W,x)=>W===x){if(S===T)return!0;if(!S||!T||S.length!==T.length)return!1;for(let W=0,x=S.length;W<x;W++)if(!C(S[W],T[W]))return!1;return!0}t.equals=u;function y(S,T){const C=S.length-1;T<C&&(S[T]=S[C]),S.pop()}t.removeFastWithoutKeepingOrder=y;function b(S,T,C){return a(S.length,W=>C(S[W],T))}t.binarySearch=b;function a(S,T){let C=0,W=S-1;for(;C<=W;){const x=(C+W)/2|0,ie=T(x);if(ie<0)C=x+1;else if(ie>0)W=x-1;else return x}return-(C+1)}t.binarySearch2=a;function f(S,T){let C=0,W=S.length;if(W===0)return 0;for(;C<W;){const x=Math.floor((C+W)/2);T(S[x])?W=x:C=x+1}return C}t.findFirstInSorted=f;function N(S,T,C){if(S=S|0,S>=T.length)throw new TypeError("invalid index");const W=T[Math.floor(T.length*Math.random())],x=[],ie=[],re=[];for(const oe of T){const ae=C(oe,W);ae<0?x.push(oe):ae>0?ie.push(oe):re.push(oe)}return S<x.length?N(S,x,C):S<x.length+re.length?re[0]:N(S-(x.length+re.length),ie,C)}t.quickSelect=N;function M(S,T){const C=[];let W;for(const x of S.slice(0).sort(T))!W||T(W[0],x)!==0?(W=[x],C.push(W)):W.push(x);return C}t.groupBy=M;function p(S,T,C){const W=[];function x(oe,ae,fe){if(ae===0&&fe.length===0)return;const he=W[W.length-1];he&&he.start+he.deleteCount===oe?(he.deleteCount+=ae,he.toInsert.push(...fe)):W.push({start:oe,deleteCount:ae,toInsert:fe})}let ie=0,re=0;for(;;){if(ie===S.length){x(ie,0,T.slice(re));break}if(re===T.length){x(ie,S.length-ie,[]);break}const oe=S[ie],ae=T[re],fe=C(oe,ae);fe===0?(ie+=1,re+=1):fe<0?(x(ie,1,[]),ie+=1):fe>0&&(x(ie,0,[ae]),re+=1)}return W}t.sortedDiff=p;function v(S,T,C){const W=p(S,T,C),x=[],ie=[];for(const re of W)x.push(...S.slice(re.start,re.start+re.deleteCount)),ie.push(...re.toInsert);return{removed:x,added:ie}}t.delta=v;function e(S,T,C){if(C===0)return[];const W=S.slice(0,C).sort(T);return F(S,T,W,C,S.length),W}t.top=e;function A(S,T,C,W,x){return C===0?Promise.resolve([]):new Promise((ie,re)=>{(async()=>{const oe=S.length,ae=S.slice(0,C).sort(T);for(let fe=C,he=Math.min(C+W,oe);fe<oe;fe=he,he=Math.min(he+W,oe)){if(fe>C&&await new Promise(Se=>setTimeout(Se)),x&&x.isCancellationRequested)throw new D.CancellationError;F(S,T,ae,fe,he)}return ae})().then(ie,re)})}t.topAsync=A;function F(S,T,C,W,x){for(const ie=C.length;W<x;W++){const re=S[W];if(T(re,C[ie-1])<0){C.pop();const oe=f(C,ae=>T(re,ae)<0);C.splice(oe,0,re)}}}function E(S){return S.filter(T=>!!T)}t.coalesce=E;function L(S){let T=0;for(let C=0;C<S.length;C++)S[C]&&(S[T]=S[C],T+=1);S.length=T}t.coalesceInPlace=L;function g(S,T,C){S.splice(C,0,S.splice(T,1)[0])}t.move=g;function m(S){return!Array.isArray(S)||S.length===0}t.isFalsyOrEmpty=m;function l(S){return Array.isArray(S)&&S.length>0}t.isNonEmptyArray=l;function r(S,T=C=>C){const C=new Set;return S.filter(W=>{const x=T(W);return C.has(x)?!1:(C.add(x),!0)})}t.distinct=r;function s(S){const T=new Set;return C=>{const W=S(C);return T.has(W)?!1:(T.add(W),!0)}}t.uniqueFilter=s;function d(S,T){const C=c(S,T);if(C!==-1)return S[C]}t.findLast=d;function c(S,T){for(let C=S.length-1;C>=0;C--){const W=S[C];if(T(W))return C}return-1}t.lastIndex=c;function w(S,T){return S.length>0?S[0]:T}t.firstOrDefault=w;function _(S,T){return S.length>0?S[S.length-1]:T}t.lastOrDefault=_;function h(S,T,C=(W,x)=>W===x){let W=0;for(let x=0,ie=Math.min(S.length,T.length);x<ie&&C(S[x],T[x]);x++)W++;return W}t.commonPrefixLength=h;function o(S){return[].concat(...S)}t.flatten=o;function R(S,T){let C=typeof T=="number"?S:0;typeof T=="number"?C=S:(C=0,T=S);const W=[];if(C<=T)for(let x=C;x<T;x++)W.push(x);else for(let x=C;x>T;x--)W.push(x);return W}t.range=R;function I(S,T,C){return S.reduce((W,x)=>(W[T(x)]=C?C(x):x,W),Object.create(null))}t.index=I;function O(S,T){return S.push(T),()=>U(S,T)}t.insert=O;function U(S,T){const C=S.indexOf(T);if(C>-1)return S.splice(C,1),T}t.remove=U;function H(S,T,C){const W=S.slice(0,T),x=S.slice(T);return W.concat(C,x)}t.arrayInsert=H;function z(S,T){let C;if(typeof T=="number"){let W=T;C=()=>{const x=Math.sin(W++)*179426549;return x-Math.floor(x)}}else C=Math.random;for(let W=S.length-1;W>0;W-=1){const x=Math.floor(C()*(W+1)),ie=S[W];S[W]=S[x],S[x]=ie}}t.shuffle=z;function ee(S,T){const C=S.indexOf(T);C>-1&&(S.splice(C,1),S.unshift(T))}t.pushToStart=ee;function ne(S,T){const C=S.indexOf(T);C>-1&&(S.splice(C,1),S.push(T))}t.pushToEnd=ne;function X(S,T){for(const C of T)S.push(C)}t.pushMany=X;function J(S,T){return Array.isArray(S)?S.map(T):T(S)}t.mapArrayOrNot=J;function n(S){return Array.isArray(S)?S:[S]}t.asArray=n;function ve(S){return S[Math.floor(Math.random()*S.length)]}t.getRandomElement=ve;function Ne(S,T){for(const C of S){const W=T(C);if(W!==void 0)return W}}t.mapFind=Ne;function de(S,T,C){const W=Le(S,T),x=S.length,ie=C.length;S.length=x+ie;for(let re=x-1;re>=W;re--)S[re+ie]=S[re];for(let re=0;re<ie;re++)S[re+W]=C[re]}t.insertInto=de;function Ae(S,T,C,W){const x=Le(S,T),ie=S.splice(x,C);return de(S,x,W),ie}t.splice=Ae;function Le(S,T){return T<0?Math.max(T+S.length,0):Math.min(T,S.length)}var pe;(function(S){function T(x){return x<0}S.isLessThan=T;function C(x){return x>0}S.isGreaterThan=C;function W(x){return x===0}S.isNeitherLessOrGreaterThan=W,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(pe=t.CompareResult||(t.CompareResult={}));function Me(S,T){return(C,W)=>T(S(C),S(W))}t.compareBy=Me;function De(...S){return(T,C)=>{for(const W of S){const x=W(T,C);if(!pe.isNeitherLessOrGreaterThan(x))return x}return pe.neitherLessOrGreaterThan}}t.tieBreakComparators=De;const Fe=(S,T)=>S-T;t.numberComparator=Fe;function Ee(S,T){if(S.length===0)return;let C=S[0];for(let W=1;W<S.length;W++){const x=S[W];T(x,C)>0&&(C=x)}return C}t.findMaxBy=Ee;function Pe(S,T){if(S.length===0)return;let C=S[0];for(let W=1;W<S.length;W++){const x=S[W];T(x,C)>=0&&(C=x)}return C}t.findLastMaxBy=Pe;function te(S,T){return Ee(S,(C,W)=>-T(C,W))}t.findMinBy=te;class ${constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let C=this.firstIdx;for(;C<this.items.length&&T(this.items[C]);)C++;const W=C===this.firstIdx?null:this.items.slice(this.firstIdx,C);return this.firstIdx=C,W}takeFromEndWhile(T){let C=this.lastIdx;for(;C>=0&&T(this.items[C]);)C--;const W=C===this.lastIdx?null:this.items.slice(C+1,this.lastIdx+1);return this.lastIdx=C,W}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}removeLast(){const T=this.items[this.lastIdx];return this.lastIdx--,T}takeCount(T){const C=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,C}}t.ArrayQueue=$;class Q{constructor(T){this.iterate=T}forEach(T){this.iterate(C=>(T(C),!0))}toArray(){const T=[];return this.iterate(C=>(T.push(C),!0)),T}filter(T){return new Q(C=>this.iterate(W=>T(W)?C(W):!0))}map(T){return new Q(C=>this.iterate(W=>C(T(W))))}some(T){let C=!1;return this.iterate(W=>(C=T(W),!C)),C}findFirst(T){let C;return this.iterate(W=>T(W)?(C=W,!1):!0),C}findLast(T){let C;return this.iterate(W=>(T(W)&&(C=W),!0)),C}findLastMaxBy(T){let C,W=!0;return this.iterate(x=>((W||pe.isGreaterThan(T(x,C)))&&(W=!1,C=x),!0)),C}}Q.empty=new Q(S=>{}),t.CallbackIterable=Q}),Y(Z[10],K([0,1,6]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function k(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}t.ok=k;function i(a,f="Unreachable"){throw new Error(f)}t.assertNever=i;function u(a){if(!a)throw new D.BugIndicatingError("Assertion Failed")}t.assert=u;function y(a){if(!a()){debugger;a(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}t.assertFn=y;function b(a,f){let N=0;for(;N<a.length-1;){const M=a[N],p=a[N+1];if(!f(M,p))return!1;N++}return!0}t.checkAdjacentItems=b}),Y(Z[13],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function D(k){const i=this;let u=!1,y;return function(){return u||(u=!0,y=k.apply(i,arguments)),y}}t.once=D}),Y(Z[14],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var D;(function(k){function i(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}k.is=i;const u=Object.freeze([]);function y(){return u}k.empty=y;function*b(m){yield m}k.single=b;function a(m){return i(m)?m:b(m)}k.wrap=a;function f(m){return m||u}k.from=f;function N(m){return!m||m[Symbol.iterator]().next().done===!0}k.isEmpty=N;function M(m){return m[Symbol.iterator]().next().value}k.first=M;function p(m,l){for(const r of m)if(l(r))return!0;return!1}k.some=p;function v(m,l){for(const r of m)if(l(r))return r}k.find=v;function*e(m,l){for(const r of m)l(r)&&(yield r)}k.filter=e;function*A(m,l){let r=0;for(const s of m)yield l(s,r++)}k.map=A;function*F(...m){for(const l of m)for(const r of l)yield r}k.concat=F;function E(m,l,r){let s=r;for(const d of m)s=l(s,d);return s}k.reduce=E;function*L(m,l,r=m.length){for(l<0&&(l+=m.length),r<0?r+=m.length:r>m.length&&(r=m.length);l<r;l++)yield m[l]}k.slice=L;function g(m,l=Number.POSITIVE_INFINITY){const r=[];if(l===0)return[r,m];const s=m[Symbol.iterator]();for(let d=0;d<l;d++){const c=s.next();if(c.done)return[r,k.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return s}}]}k.consume=g})(D=t.Iterable||(t.Iterable={}))}),Y(Z[27],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(D=t.KeyCode||(t.KeyCode={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k=t.ScanCode||(t.ScanCode={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(A,F){this._keyCodeToStr[A]=F,this._strToKeyCode[F.toLowerCase()]=A}keyCodeToStr(A){return this._keyCodeToStr[A]}strToKeyCode(A){return this._strToKeyCode[A.toLowerCase()]||0}}const u=new i,y=new i,b=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],f=Object.create(null),N=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>N[e]||0,toEnum:e=>f[e]||0,toString:e=>a[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",A=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],F=[],E=[];for(const L of A){const[g,m,l,r,s,d,c,w,_,h]=L;if(E[l]||(E[l]=!0,a[l]=r,f[r]=l,N[r.toLowerCase()]=l,m&&(t.IMMUTABLE_CODE_TO_KEY_CODE[l]=s,s!==0&&s!==3&&s!==5&&s!==4&&s!==6&&s!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[s]=l))),!F[s]){if(F[s]=!0,!d)throw new Error(`String representation missing for key code ${s} around scan code ${r}`);u.define(s,d),y.define(s,_||d),b.define(s,h||_||d)}c&&(t.EVENT_KEY_CODE_MAP[c]=s),w&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[w]=s)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function A(l){return u.keyCodeToStr(l)}e.toString=A;function F(l){return u.strToKeyCode(l)}e.fromString=F;function E(l){return y.keyCodeToStr(l)}e.toUserSettingsUS=E;function L(l){return b.keyCodeToStr(l)}e.toUserSettingsGeneral=L;function g(l){return y.strToKeyCode(l)||b.strToKeyCode(l)}e.fromUserSettings=g;function m(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(l)}e.toElectronAccelerator=m})(M=t.KeyCodeUtils||(t.KeyCodeUtils={}));var p;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(p=t.KeyMod||(t.KeyMod={}));function v(e,A){const F=(A&65535)<<16>>>0;return(e|F)>>>0}t.KeyChord=v}),Y(Z[28],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class D{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=D}),Y(Z[7],K([0,1,13,14]),function(q,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let u=null;function y(_){u=_}if(t.setDisposableTracker=y,i){const _="__is_disposable_tracked__";y(new class{trackDisposable(h){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[_]||console.log(o)},3e3)}setParent(h,o){if(h&&h!==L.None)try{h[_]=!0}catch{}}markAsDisposed(h){if(h&&h!==L.None)try{h[_]=!0}catch{}}markAsSingleton(h){}})}function b(_){return u?.trackDisposable(_),_}function a(_){u?.markAsDisposed(_)}function f(_,h){u?.setParent(_,h)}function N(_,h){if(!!u)for(const o of _)u.setParent(o,h)}function M(_){return u?.markAsSingleton(_),_}t.markAsSingleton=M;function p(_){return typeof _.dispose=="function"&&_.dispose.length===0}t.isDisposable=p;function v(_){if(k.Iterable.is(_)){const h=[];for(const o of _)if(o)try{o.dispose()}catch(R){h.push(R)}if(h.length===1)throw h[0];if(h.length>1)throw new AggregateError(h,"Encountered errors while disposing of store");return Array.isArray(_)?[]:_}else if(_)return _.dispose(),_}t.dispose=v;function e(_){for(const h of _)p(h)&&h.dispose();return[]}t.disposeIfDisposable=e;function A(..._){const h=F(()=>v(_));return N(_,h),h}t.combinedDisposable=A;function F(_){const h=b({dispose:(0,D.once)(()=>{a(h),_()})});return h}t.toDisposable=F;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{v(this._toDispose)}finally{this._toDispose.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return f(h,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(h),h}}E.DISABLE_DISPOSED_WARNING=!1,t.DisposableStore=E;class L{constructor(){this._store=new E,b(this),f(this._store,this)}dispose(){a(this),this._store.dispose()}_register(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(h)}}L.None=Object.freeze({dispose(){}}),t.Disposable=L;class g{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(h){this._isDisposed||h===this._value||(this._value?.dispose(),h&&f(h,this),this._value=h)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,a(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const h=this._value;return this._value=void 0,h&&f(h,null),h}}t.MutableDisposable=g;class m{constructor(h){this._disposable=h,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=m;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(h){let o=h;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,a(this))},this}}t.SafeDisposable=l;class r{constructor(){this.references=new Map}acquire(h,...o){let R=this.references.get(h);R||(R={counter:0,object:this.createReferencedObject(h,...o)},this.references.set(h,R));const{object:I}=R,O=(0,D.once)(()=>{--R.counter===0&&(this.destroyReferencedObject(h,R.object),this.references.delete(h))});return R.counter++,{object:I,dispose:O}}}t.ReferenceCollection=r;class s{constructor(h){this.referenceCollection=h}async acquire(h,...o){const R=this.referenceCollection.acquire(h,...o);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(I){throw R.dispose(),I}}}t.AsyncReferenceCollection=s;class d{constructor(h){this.object=h}dispose(){}}t.ImmortalReference=d;function c(_){const h=new E;try{_(h)}finally{h.dispose()}}t.disposeOnReturn=c;class w{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){a(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{v(this._store.values())}finally{this._store.clear()}}has(h){return this._store.has(h)}get(h){return this._store.get(h)}set(h,o,R=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this._store.get(h)?.dispose(),this._store.set(h,o)}deleteAndDispose(h){this._store.get(h)?.dispose(),this._store.delete(h)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=w}),Y(Z[15],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class D{constructor(u){this.element=u,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class k{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let u=this._first;for(;u!==D.Undefined;){const y=u.next;u.prev=D.Undefined,u.next=D.Undefined,u=y}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,y){const b=new D(u);if(this._first===D.Undefined)this._first=b,this._last=b;else if(y){const f=this._last;this._last=b,b.prev=f,f.next=b}else{const f=this._first;this._first=b,b.next=f,f.prev=b}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(b))}}shift(){if(this._first!==D.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==D.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==D.Undefined&&u.next!==D.Undefined){const y=u.prev;y.next=u.next,u.next.prev=y}else u.prev===D.Undefined&&u.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):u.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):u.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==D.Undefined;)yield u.element,u=u.next}}t.LinkedList=k}),Y(Z[16],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function D(s){return typeof s=="string"}t.isString=D;function k(s){return Array.isArray(s)&&s.every(d=>D(d))}t.isStringArray=k;function i(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}t.isObject=i;function u(s){const d=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof d}t.isTypedArray=u;function y(s){return typeof s=="number"&&!isNaN(s)}t.isNumber=y;function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}t.isIterable=b;function a(s){return s===!0||s===!1}t.isBoolean=a;function f(s){return typeof s>"u"}t.isUndefined=f;function N(s){return!M(s)}t.isDefined=N;function M(s){return f(s)||s===null}t.isUndefinedOrNull=M;function p(s,d){if(!s)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}t.assertType=p;function v(s){if(M(s))throw new Error("Assertion Failed: argument is undefined or null");return s}t.assertIsDefined=v;function e(...s){const d=[];for(let c=0;c<s.length;c++){const w=s[c];if(M(w))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);d.push(w)}return d}t.assertAllDefined=e;const A=Object.prototype.hasOwnProperty;function F(s){if(!i(s))return!1;for(const d in s)if(A.call(s,d))return!1;return!0}t.isEmptyObject=F;function E(s){return typeof s=="function"}t.isFunction=E;function L(...s){return s.length>0&&s.every(E)}t.areFunctions=L;function g(s,d){const c=Math.min(s.length,d.length);for(let w=0;w<c;w++)m(s[w],d[w])}t.validateConstraints=g;function m(s,d){if(D(d)){if(typeof s!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(E(d)){try{if(s instanceof d)return}catch{}if(!M(s)&&s.constructor===d||d.length===1&&d.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=m;function l(s){return s===null?void 0:s}t.withNullAsUndefined=l;function r(s){return typeof s>"u"?null:s}t.withUndefinedAsNull=r}),Y(Z[29],K([0,1,16]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const k=Object.create(null);function i(b,a){if((0,D.isString)(a)){const f=k[a];if(f===void 0)throw new Error(`${b} references an unknown codicon: ${a}`);a=f}return k[b]=a,{id:b}}function u(){return k}t.getCodiconFontCharacters=u;function y(){return Object.values(t.Codicon)}t.getAllCodicons=y,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Y(Z[11],K([0,1,16]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function k(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const L=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([g,m])=>{L[g]=m&&typeof m=="object"?k(m):m}),L}t.deepClone=k;function i(E){if(!E||typeof E!="object")return E;const L=[E];for(;L.length>0;){const g=L.shift();Object.freeze(g);for(const m in g)if(u.call(g,m)){const l=g[m];typeof l=="object"&&!Object.isFrozen(l)&&!(0,D.isTypedArray)(l)&&L.push(l)}}return E}t.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function y(E,L){return b(E,L,new Set)}t.cloneAndChange=y;function b(E,L,g){if((0,D.isUndefinedOrNull)(E))return E;const m=L(E);if(typeof m<"u")return m;if(Array.isArray(E)){const l=[];for(const r of E)l.push(b(r,L,g));return l}if((0,D.isObject)(E)){if(g.has(E))throw new Error("Cannot clone recursive data-structure");g.add(E);const l={};for(const r in E)u.call(E,r)&&(l[r]=b(E[r],L,g));return g.delete(E),l}return E}function a(E,L,g=!0){return(0,D.isObject)(E)?((0,D.isObject)(L)&&Object.keys(L).forEach(m=>{m in E?g&&((0,D.isObject)(E[m])&&(0,D.isObject)(L[m])?a(E[m],L[m],g):E[m]=L[m]):E[m]=L[m]}),E):L}t.mixin=a;function f(E,L){if(E===L)return!0;if(E==null||L===null||L===void 0||typeof E!=typeof L||typeof E!="object"||Array.isArray(E)!==Array.isArray(L))return!1;let g,m;if(Array.isArray(E)){if(E.length!==L.length)return!1;for(g=0;g<E.length;g++)if(!f(E[g],L[g]))return!1}else{const l=[];for(m in E)l.push(m);l.sort();const r=[];for(m in L)r.push(m);if(r.sort(),!f(l,r))return!1;for(g=0;g<l.length;g++)if(!f(E[l[g]],L[l[g]]))return!1}return!0}t.equals=f;function N(E){const L=new Set;return JSON.stringify(E,(g,m)=>{if((0,D.isObject)(m)||Array.isArray(m)){if(L.has(m))return"[Circular]";L.add(m)}return m})}t.safeStringify=N;function M(E,L){const g=Object.create(null);return!E||!L||Object.keys(L).forEach(l=>{const r=E[l],s=L[l];f(r,s)||(g[l]=s)}),g}t.distinct=M;function p(E,L){const g=L.toLowerCase(),m=Object.keys(E).find(l=>l.toLowerCase()===g);return m?E[m]:E[L]}t.getCaseInsensitive=p;function v(E,L){const g=Object.create(null);for(const[m,l]of Object.entries(E))L(m,l)&&(g[m]=l);return g}t.filter=v;function e(E){let L=[],g=Object.getPrototypeOf(E);for(;Object.prototype!==g;)L=L.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return L}t.getAllPropertyNames=e;function A(E){const L=[];for(const g of e(E))typeof E[g]=="function"&&L.push(g);return L}t.getAllMethodNames=A;function F(E,L){const g=l=>function(){const r=Array.prototype.slice.call(arguments,0);return L(l,r)},m={};for(const l of E)m[l]=g(l);return m}t.createProxyObject=F}),Y(Z[17],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var D;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D=t.Constants||(t.Constants={}));function k(u){return u<0?0:u>255?255:u|0}t.toUint8=k;function i(u){return u<0?0:u>4294967295?4294967295:u|0}t.toUint32=i}),Y(Z[18],K([0,1,17]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class k{constructor(b){const a=(0,D.toUint8)(b);this._defaultValue=a,this._asciiMap=k._createAsciiMap(a),this._map=new Map}static _createAsciiMap(b){const a=new Uint8Array(256);return a.fill(b),a}set(b,a){const f=(0,D.toUint8)(a);b>=0&&b<256?this._asciiMap[b]=f:this._map.set(b,f)}get(b){return b>=0&&b<256?this._asciiMap[b]:this._map.get(b)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=k;var i;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(i||(i={}));class u{constructor(){this._actual=new k(0)}add(b){this._actual.set(b,1)}has(b){return this._actual.get(b)===1}clear(){return this._actual.clear()}}t.CharacterSet=u}),Y(Z[3],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class D{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new D(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return D.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return D.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return D.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const y=i.lineNumber|0,b=u.lineNumber|0;if(y===b){const a=i.column|0,f=u.column|0;return a-f}return y-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new D(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=D}),Y(Z[2],K([0,1,3]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class k{constructor(u,y,b,a){u>b||u===b&&y>a?(this.startLineNumber=b,this.startColumn=a,this.endLineNumber=u,this.endColumn=y):(this.startLineNumber=u,this.startColumn=y,this.endLineNumber=b,this.endColumn=a)}isEmpty(){return k.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return k.containsPosition(this,u)}static containsPosition(u,y){return!(y.lineNumber<u.startLineNumber||y.lineNumber>u.endLineNumber||y.lineNumber===u.startLineNumber&&y.column<u.startColumn||y.lineNumber===u.endLineNumber&&y.column>u.endColumn)}static strictContainsPosition(u,y){return!(y.lineNumber<u.startLineNumber||y.lineNumber>u.endLineNumber||y.lineNumber===u.startLineNumber&&y.column<=u.startColumn||y.lineNumber===u.endLineNumber&&y.column>=u.endColumn)}containsRange(u){return k.containsRange(this,u)}static containsRange(u,y){return!(y.startLineNumber<u.startLineNumber||y.endLineNumber<u.startLineNumber||y.startLineNumber>u.endLineNumber||y.endLineNumber>u.endLineNumber||y.startLineNumber===u.startLineNumber&&y.startColumn<u.startColumn||y.endLineNumber===u.endLineNumber&&y.endColumn>u.endColumn)}strictContainsRange(u){return k.strictContainsRange(this,u)}static strictContainsRange(u,y){return!(y.startLineNumber<u.startLineNumber||y.endLineNumber<u.startLineNumber||y.startLineNumber>u.endLineNumber||y.endLineNumber>u.endLineNumber||y.startLineNumber===u.startLineNumber&&y.startColumn<=u.startColumn||y.endLineNumber===u.endLineNumber&&y.endColumn>=u.endColumn)}plusRange(u){return k.plusRange(this,u)}static plusRange(u,y){let b,a,f,N;return y.startLineNumber<u.startLineNumber?(b=y.startLineNumber,a=y.startColumn):y.startLineNumber===u.startLineNumber?(b=y.startLineNumber,a=Math.min(y.startColumn,u.startColumn)):(b=u.startLineNumber,a=u.startColumn),y.endLineNumber>u.endLineNumber?(f=y.endLineNumber,N=y.endColumn):y.endLineNumber===u.endLineNumber?(f=y.endLineNumber,N=Math.max(y.endColumn,u.endColumn)):(f=u.endLineNumber,N=u.endColumn),new k(b,a,f,N)}intersectRanges(u){return k.intersectRanges(this,u)}static intersectRanges(u,y){let b=u.startLineNumber,a=u.startColumn,f=u.endLineNumber,N=u.endColumn;const M=y.startLineNumber,p=y.startColumn,v=y.endLineNumber,e=y.endColumn;return b<M?(b=M,a=p):b===M&&(a=Math.max(a,p)),f>v?(f=v,N=e):f===v&&(N=Math.min(N,e)),b>f||b===f&&a>N?null:new k(b,a,f,N)}equalsRange(u){return k.equalsRange(this,u)}static equalsRange(u,y){return!u&&!y?!0:!!u&&!!y&&u.startLineNumber===y.startLineNumber&&u.startColumn===y.startColumn&&u.endLineNumber===y.endLineNumber&&u.endColumn===y.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(u){return new D.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(u){return new D.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,y){return new k(this.startLineNumber,this.startColumn,u,y)}setStartPosition(u,y){return new k(u,y,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(u){return new k(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return k.collapseToEnd(this)}static collapseToEnd(u){return new k(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new k(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,y=u){return new k(u.lineNumber,u.column,y.lineNumber,y.column)}static lift(u){return u?new k(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,y){return!(u.endLineNumber<y.startLineNumber||u.endLineNumber===y.startLineNumber&&u.endColumn<y.startColumn||y.endLineNumber<u.startLineNumber||y.endLineNumber===u.startLineNumber&&y.endColumn<u.startColumn)}static areIntersecting(u,y){return!(u.endLineNumber<y.startLineNumber||u.endLineNumber===y.startLineNumber&&u.endColumn<=y.startColumn||y.endLineNumber<u.startLineNumber||y.endLineNumber===u.startLineNumber&&y.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,y){if(u&&y){const f=u.startLineNumber|0,N=y.startLineNumber|0;if(f===N){const M=u.startColumn|0,p=y.startColumn|0;if(M===p){const v=u.endLineNumber|0,e=y.endLineNumber|0;if(v===e){const A=u.endColumn|0,F=y.endColumn|0;return A-F}return v-e}return M-p}return f-N}return(u?1:0)-(y?1:0)}static compareRangesUsingEnds(u,y){return u.endLineNumber===y.endLineNumber?u.endColumn===y.endColumn?u.startLineNumber===y.startLineNumber?u.startColumn-y.startColumn:u.startLineNumber-y.startLineNumber:u.endColumn-y.endColumn:u.endLineNumber-y.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}t.Range=k}),Y(Z[30],K([0,1,3,2]),function(q,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(i=t.SelectionDirection||(t.SelectionDirection={}));class u extends k.Range{constructor(b,a,f,N){super(b,a,f,N),this.selectionStartLineNumber=b,this.selectionStartColumn=a,this.positionLineNumber=f,this.positionColumn=N}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return u.selectionsEqual(this,b)}static selectionsEqual(b,a){return b.selectionStartLineNumber===a.selectionStartLineNumber&&b.selectionStartColumn===a.selectionStartColumn&&b.positionLineNumber===a.positionLineNumber&&b.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,a){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,b,a):new u(b,a,this.startLineNumber,this.startColumn)}getPosition(){return new D.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,a){return this.getDirection()===0?new u(b,a,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,b,a)}static fromPositions(b,a=b){return new u(b.lineNumber,b.column,a.lineNumber,a.column)}static fromRange(b,a){return a===0?new u(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new u(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new u(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,a){if(b&&!a||!b&&a)return!1;if(!b&&!a)return!0;if(b.length!==a.length)return!1;for(let f=0,N=b.length;f<N;f++)if(!this.selectionsEqual(b[f],a[f]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,a,f,N,M){return M===0?new u(b,a,f,N):new u(f,N,b,a)}}t.Selection=u}),Y(Z[31],K([0,1,18]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var k;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(k=t.WordCharacterClass||(t.WordCharacterClass={}));class i extends D.CharacterClassifier{constructor(b){super(0);for(let a=0,f=b.length;a<f;a++)this.set(b.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function u(y){const b={};return a=>(b.hasOwnProperty(a)||(b[a]=y(a)),b[a])}t.getMapForWordSeparators=u(y=>new i(y))}),Y(Z[19],K([0,1,14,7,15]),function(q,t,D,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(M=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const v of t.USUAL_WORD_SEPARATORS)M.indexOf(v)>=0||(p+="\\"+v);return p+="\\s]+)",new RegExp(p,"g")}t.DEFAULT_WORD_REGEXP=u();function y(M){let p=t.DEFAULT_WORD_REGEXP;if(M&&M instanceof RegExp)if(M.global)p=M;else{let v="g";M.ignoreCase&&(v+="i"),M.multiline&&(v+="m"),M.unicode&&(v+="u"),p=new RegExp(M.source,v)}return p.lastIndex=0,p}t.ensureValidWordDefinition=y;const b=new i.LinkedList;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(M){const p=b.unshift(M);return(0,k.toDisposable)(p)}t.setDefaultGetWordAtTextConfig=a;function f(M,p,v,e,A){if(A||(A=D.Iterable.first(b)),v.length>A.maxLen){let m=M-A.maxLen/2;return m<0?m=0:e+=m,v=v.substring(m,M+A.maxLen/2),f(M,p,v,e,A)}const F=Date.now(),E=M-1-e;let L=-1,g=null;for(let m=1;!(Date.now()-F>=A.timeBudget);m++){const l=E-A.windowSize*m;p.lastIndex=Math.max(0,l);const r=N(p,v,E,L);if(!r&&g||(g=r,l<=0))break;L=l}if(g){const m={word:g[0],startColumn:e+1+g.index,endColumn:e+1+g.index+g[0].length};return p.lastIndex=0,m}return null}t.getWordAtText=f;function N(M,p,v,e){let A;for(;A=M.exec(p);){const F=A.index||0;if(F<=v&&M.lastIndex>=v)return A;if(e>0&&F>e)return null}return null}}),Y(Z[8],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=t.SequenceDiff=void 0;class D{constructor(u,y){this.seq1Range=u,this.seq2Range=y}reverse(){return new D(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}t.SequenceDiff=D;class k{constructor(u,y){this.start=u,this.endExclusive=y}get isEmpty(){return this.start===this.endExclusive}delta(u){return new k(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(u){return new k(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}}t.OffsetRange=k}),Y(Z[32],K([0,1,8]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function k(a,f,N){let M=N;return M=u(a,f,M),M=y(a,f,M),M}t.optimizeSequenceDiffs=k;function i(a,f,N){const M=[];for(const p of N){const v=M[M.length-1];if(!v){M.push(p);continue}p.seq1Range.start-v.seq1Range.endExclusive<=2||p.seq2Range.start-v.seq2Range.endExclusive<=2?M[M.length-1]=new D.SequenceDiff(v.seq1Range.join(p.seq1Range),v.seq2Range.join(p.seq2Range)):M.push(p)}return M}t.smoothenSequenceDiffs=i;function u(a,f,N){const M=[];N.length>0&&M.push(N[0]);for(let p=1;p<N.length;p++){const v=M[M.length-1],e=N[p];if(e.seq1Range.isEmpty){let A=!0;const F=e.seq1Range.start-v.seq1Range.endExclusive;for(let E=1;E<=F;E++)if(f.getElement(e.seq2Range.start-E)!==f.getElement(e.seq2Range.endExclusive-E)){A=!1;break}if(A){M[M.length-1]=new D.SequenceDiff(v.seq1Range,new D.OffsetRange(v.seq2Range.start,e.seq2Range.endExclusive-F));continue}}M.push(e)}return M}t.joinSequenceDiffs=u;function y(a,f,N){if(!a.getBoundaryScore||!f.getBoundaryScore)return N;for(let M=0;M<N.length;M++){const p=N[M];if(p.seq1Range.isEmpty){const v=M>0?N[M-1].seq2Range.endExclusive:-1,e=M+1<N.length?N[M+1].seq2Range.start:f.length;N[M]=b(p,a,f,e,v)}else if(p.seq2Range.isEmpty){const v=M>0?N[M-1].seq1Range.endExclusive:-1,e=M+1<N.length?N[M+1].seq1Range.start:a.length;N[M]=b(p.reverse(),f,a,e,v).reverse()}}return N}t.shiftSequenceDiffs=y;function b(a,f,N,M,p){let e=1;for(;a.seq2Range.start-e>p&&N.getElement(a.seq2Range.start-e)===N.getElement(a.seq2Range.endExclusive-e)&&e<20;)e++;e--;let A=0;for(;a.seq2Range.start+A<M&&N.getElement(a.seq2Range.start+A)===N.getElement(a.seq2Range.endExclusive+A)&&A<20;)A++;if(e===0&&A===0)return a;let F=0,E=-1;for(let L=-e;L<=A;L++){const g=a.seq2Range.start+L,m=a.seq2Range.endExclusive+L,l=a.seq1Range.start+L,r=f.getBoundaryScore(l)+N.getBoundaryScore(g)+N.getBoundaryScore(m);r>E&&(E=r,F=L)}return F!==0?new D.SequenceDiff(a.seq1Range.delta(F),a.seq2Range.delta(F)):a}}),Y(Z[33],K([0,1,8]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class k{compute(a,f){if(a.length===0)return[new D.SequenceDiff(new D.OffsetRange(0,0),new D.OffsetRange(0,f.length))];if(f.length===0)return[new D.SequenceDiff(new D.OffsetRange(0,a.length),new D.OffsetRange(0,0))];function N(g,m){for(;g<a.length&&m<f.length&&a.getElement(g)===f.getElement(m);)g++,m++;return g}let M=0;const p=new u;p.set(0,N(0,0));const v=new y;v.set(0,p.get(0)===0?null:new i(null,0,0,p.get(0)));let e=0;e:for(;;)for(M++,e=-M;e<=M;e+=2){const g=e===M?-1:p.get(e+1),m=e===-M?-1:p.get(e-1)+1,l=Math.min(Math.max(g,m),a.length),r=l-e,s=N(l,r);p.set(e,s);const d=l===g?v.get(e+1):v.get(e-1);if(v.set(e,s!==l?new i(d,l,r,s-l):d),p.get(e)===a.length&&p.get(e)-e===f.length)break e}let A=v.get(e);const F=[];let E=a.length,L=f.length;for(;;){const g=A?A.x+A.length:0,m=A?A.y+A.length:0;if((g!==E||m!==L)&&F.push(new D.SequenceDiff(new D.OffsetRange(g,E),new D.OffsetRange(m,L))),!A)break;E=A.x,L=A.y,A=A.prev}return F.reverse(),F}}t.MyersDiffAlgorithm=k;class i{constructor(a,f,N,M){this.prev=a,this.x=f,this.y=N,this.length=M}}class u{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,f){if(a<0){if(a=-a-1,a>=this.negativeArr.length){const N=this.negativeArr;this.negativeArr=new Int32Array(N.length*2),this.negativeArr.set(N)}this.negativeArr[a]=f}else{if(a>=this.positiveArr.length){const N=this.positiveArr;this.positiveArr=new Int32Array(N.length*2),this.positiveArr.set(N)}this.positiveArr[a]=f}}}class y{constructor(){this.positiveArr=[],this.negativeArr=[]}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,f){a<0?(a=-a-1,this.negativeArr[a]=f):this.positiveArr[a]=f}}}),Y(Z[34],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class D{constructor(i,u){this.width=i,this.height=u,this.array=[],this.array=new Array(i*u)}get(i,u){return this.array[i+u*this.width]}set(i,u,y){this.array[i+u*this.width]=y}}t.Array2D=D}),Y(Z[35],K([0,1,8,34]),function(q,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class i{compute(y,b,a){const f=new k.Array2D(y.length,b.length),N=new k.Array2D(y.length,b.length),M=new k.Array2D(y.length,b.length);for(let L=0;L<y.length;L++)for(let g=0;g<b.length;g++){const m=L===0?0:f.get(L-1,g),l=g===0?0:f.get(L,g-1);let r;y.getElement(L)===b.getElement(g)?(L===0||g===0?r=0:r=f.get(L-1,g-1),L>0&&g>0&&N.get(L-1,g-1)===3&&(r+=M.get(L-1,g-1)),r+=a?a(L,g):1):r=-1;const s=Math.max(m,l,r);if(s===r){const d=L>0&&g>0?M.get(L-1,g-1):0;M.set(L,g,d+1),N.set(L,g,3)}else s===m?(M.set(L,g,0),N.set(L,g,1)):s===l&&(M.set(L,g,0),N.set(L,g,2));f.set(L,g,s)}const p=[];let v=y.length,e=b.length;function A(L,g){(L+1!==v||g+1!==e)&&p.push(new D.SequenceDiff(new D.OffsetRange(L+1,v),new D.OffsetRange(g+1,e))),v=L,e=g}let F=y.length-1,E=b.length-1;for(;F>=0&&E>=0;)N.get(F,E)===3?(A(F,E),F--,E--):N.get(F,E)===1?F--:E--;return A(-1,-1),p.reverse(),p}}t.DynamicProgrammingDiffing=i}),Y(Z[20],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=t.RangeMapping=t.LineRangeMapping=void 0;class D{constructor(y,b,a){this.originalRange=y,this.modifiedRange=b,this.innerChanges=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.LineRangeMapping=D;class k{constructor(y,b){this.originalRange=y,this.modifiedRange=b}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.RangeMapping=k;class i{constructor(y,b){this.startLineNumber=y,this.endLineNumberExclusive=b}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(y){return new i(this.startLineNumber+y,this.endLineNumberExclusive+y)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(y){return new i(Math.min(this.startLineNumber,y.startLineNumber),Math.max(this.endLineNumberExclusive,y.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}t.LineRange=i}),Y(Z[36],K([0,1,10,3,2,8,35,32,33,20]),function(q,t,D,k,i,u,y,b,a,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class N{constructor(){this.dynamicProgrammingDiffing=new y.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new a.MyersDiffAlgorithm}computeDiff(r,s,d){const c=new Map;function w(ne){let X=c.get(ne);return X===void 0&&(X=c.size,c.set(ne,X)),X}const _=r.map(ne=>w(ne.trim())),h=s.map(ne=>w(ne.trim())),o=new v(_,r),R=new v(h,s);let I=(()=>o.length+R.length<1500?this.dynamicProgrammingDiffing.compute(o,R,(ne,X)=>r[ne]===s[X]?s[X].length===0?.1:1+Math.log(1+s[X].length):.99):this.myersDiffingAlgorithm.compute(o,R))();I=(0,b.optimizeSequenceDiffs)(o,R,I);const O=[],U=ne=>{for(let X=0;X<ne;X++){const J=H+X,n=z+X;if(r[J]!==s[n]){const ve=this.refineDiff(r,s,new u.SequenceDiff(new u.OffsetRange(J,J+1),new u.OffsetRange(n,n+1)));for(const Ne of ve)O.push(Ne)}}};let H=0,z=0;for(const ne of I){(0,D.assertFn)(()=>ne.seq1Range.start-H===ne.seq2Range.start-z);const X=ne.seq1Range.start-H;U(X),H=ne.seq1Range.endExclusive,z=ne.seq2Range.endExclusive;const J=this.refineDiff(r,s,ne);for(const n of J)O.push(n)}U(r.length-H);const ee=M(O);return{quitEarly:!1,changes:ee}}refineDiff(r,s,d){const c=new A(r,d.seq1Range),w=new A(s,d.seq2Range),_=c.length+w.length<500?this.dynamicProgrammingDiffing.compute(c,w):this.myersDiffingAlgorithm.compute(c,w);let h=(0,b.optimizeSequenceDiffs)(c,w,_);return h=(0,b.smoothenSequenceDiffs)(c,w,h),h.map(R=>new f.RangeMapping(c.translateRange(R.seq1Range).delta(d.seq1Range.start),w.translateRange(R.seq2Range).delta(d.seq2Range.start)))}}t.StandardLinesDiffComputer=N;function M(l){const r=[];for(const s of p(l,(d,c)=>c.originalRange.startLineNumber-(d.originalRange.endLineNumber-(d.originalRange.endColumn>1?0:1))<=1||c.modifiedRange.startLineNumber-(d.modifiedRange.endLineNumber-(d.modifiedRange.endColumn>1?0:1))<=1)){const d=s[0],c=s[s.length-1];r.push(new f.LineRangeMapping(new f.LineRange(d.originalRange.startLineNumber,c.originalRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),new f.LineRange(d.modifiedRange.startLineNumber,c.modifiedRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),s))}return(0,D.assertFn)(()=>(0,D.checkAdjacentItems)(r,(s,d)=>d.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===d.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<d.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<d.modifiedRange.startLineNumber)),r}t.lineRangeMappingFromRangeMappings=M;function*p(l,r){let s,d;for(const c of l)d!==void 0&&r(d,c)?s.push(c):(s&&(yield s),s=[c]),d=c;s&&(yield s)}class v{constructor(r,s){this.trimmedHash=r,this.lines=s}getElement(r){return this.trimmedHash[r]}get length(){return this.trimmedHash.length}getBoundaryScore(r){const s=r===0?0:e(this.lines[r-1]),d=r===this.lines.length?0:e(this.lines[r]);return 1e3-(s+d)}}t.LineSequence=v;function e(l){let r=0;for(;r<l.length&&(l.charCodeAt(r)===32||l.charCodeAt(r)===9);)r++;return r}class A{constructor(r,s){this.lines=r,this.lineRange=s;let d=0;this.firstCharOnLineOffsets=new Int32Array(s.length);for(let w=s.start;w<s.endExclusive;w++)d+=r[w].length,this.firstCharOnLineOffsets[w-s.start]=d+1,d++;this.elements=new Int32Array(d);let c=0;for(let w=s.start;w<s.endExclusive;w++){const _=r[w];for(let h=0;h<_.length;h++)this.elements[c+h]=_.charCodeAt(h);c+=_.length,w<r.length-1&&(this.elements[c]=`
`.charCodeAt(0),c+=1)}}get text(){return[...this.elements].map(r=>String.fromCharCode(r)).join("")}getElement(r){return this.elements[r]}get length(){return this.elements.length}getBoundaryScore(r){const s=g(r>0?this.elements[r-1]:-1),d=g(r<this.elements.length?this.elements[r]:-1);if(s===6&&d===7)return 0;let c=0;return s!==d&&(c+=10,d===1&&(c+=1)),c+=L(s),c+=L(d),c}translateOffset(r){let s=0,d=this.firstCharOnLineOffsets.length;for(;s<d;){const w=Math.floor((s+d)/2);this.firstCharOnLineOffsets[w]>r?d=w:s=w+1}const c=s===0?0:this.firstCharOnLineOffsets[s-1];return new k.Position(s+1,r-c+1)}translateRange(r){return i.Range.fromPositions(this.translateOffset(r.start),this.translateOffset(r.endExclusive))}}var F;(function(l){l[l.WordLower=0]="WordLower",l[l.WordUpper=1]="WordUpper",l[l.WordNumber=2]="WordNumber",l[l.End=3]="End",l[l.Other=4]="Other",l[l.Space=5]="Space",l[l.LineBreakCR=6]="LineBreakCR",l[l.LineBreakLF=7]="LineBreakLF"})(F||(F={}));const E={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function L(l){return E[l]}function g(l){return l===10?7:l===13?6:m(l)?5:l>=97&&l<=122?0:l>=65&&l<=90?1:l>=48&&l<=57?2:l===-1?3:4}function m(l){return l===32||l===9}}),Y(Z[37],K([0,1,18]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var k;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(k=t.State||(t.State={}));class i{constructor(e,A,F){const E=new Uint8Array(e*A);for(let L=0,g=e*A;L<g;L++)E[L]=F;this._data=E,this.rows=e,this.cols=A}get(e,A){return this._data[e*this.cols+A]}set(e,A,F){this._data[e*this.cols+A]=F}}class u{constructor(e){let A=0,F=0;for(let L=0,g=e.length;L<g;L++){const[m,l,r]=e[L];l>A&&(A=l),m>F&&(F=m),r>F&&(F=r)}A++,F++;const E=new i(F,A,0);for(let L=0,g=e.length;L<g;L++){const[m,l,r]=e[L];E.set(m,l,r)}this._states=E,this._maxCharCode=A}nextState(e,A){return A<0||A>=this._maxCharCode?0:this._states.get(e,A)}}t.StateMachine=u;let y=null;function b(){return y===null&&(y=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var a;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let f=null;function N(){if(f===null){f=new D.CharacterClassifier(0);const v=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let A=0;A<v.length;A++)f.set(v.charCodeAt(A),1);const e=".;:";for(let A=0;A<e.length;A++)f.set(e.charCodeAt(A),2)}return f}class M{static _createLink(e,A,F,E,L){let g=L-1;do{const m=A.charCodeAt(g);if(e.get(m)!==2)break;g--}while(g>E);if(E>0){const m=A.charCodeAt(E-1),l=A.charCodeAt(g);(m===40&&l===41||m===91&&l===93||m===123&&l===125)&&g--}return{range:{startLineNumber:F,startColumn:E+1,endLineNumber:F,endColumn:g+2},url:A.substring(E,g+1)}}static computeLinks(e,A=b()){const F=N(),E=[];for(let L=1,g=e.getLineCount();L<=g;L++){const m=e.getLineContent(L),l=m.length;let r=0,s=0,d=0,c=1,w=!1,_=!1,h=!1,o=!1;for(;r<l;){let R=!1;const I=m.charCodeAt(r);if(c===13){let O;switch(I){case 40:w=!0,O=0;break;case 41:O=w?0:1;break;case 91:h=!0,_=!0,O=0;break;case 93:h=!1,O=_?0:1;break;case 123:o=!0,O=0;break;case 125:O=o?0:1;break;case 39:case 34:case 96:d===I?O=1:d===39||d===34||d===96?O=0:O=1;break;case 42:O=d===42?1:0;break;case 124:O=d===124?1:0;break;case 32:O=h?0:1;break;default:O=F.get(I)}O===1&&(E.push(M._createLink(F,m,L,s,r)),R=!0)}else if(c===12){let O;I===91?(_=!0,O=0):O=F.get(I),O===1?R=!0:c=13}else c=A.nextState(c,I),c===0&&(R=!0);R&&(c=1,w=!1,_=!1,o=!1,s=r+1,d=I),r++}c===13&&E.push(M._createLink(F,m,L,s,l))}return E}}t.LinkComputer=M;function p(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:M.computeLinks(v)}t.computeLinks=p}),Y(Z[38],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class D{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,y,b,a){if(i&&u){const f=this.doNavigateValueSet(u,a);if(f)return{range:i,value:f}}if(y&&b){const f=this.doNavigateValueSet(b,a);if(f)return{range:y,value:f}}return null}doNavigateValueSet(i,u){const y=this.numberReplace(i,u);return y!==null?y:this.textReplace(i,u)}numberReplace(i,u){const y=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let b=Number(i);const a=parseFloat(i);return!isNaN(b)&&!isNaN(a)&&b===a?b===0&&!u?null:(b=Math.floor(b*y),b+=u?y:-y,String(b/y)):null}textReplace(i,u){return this.valueSetsReplace(this._defaultValueSet,i,u)}valueSetsReplace(i,u,y){let b=null;for(let a=0,f=i.length;b===null&&a<f;a++)b=this.valueSetReplace(i[a],u,y);return b}valueSetReplace(i,u,y){let b=i.indexOf(u);return b>=0?(b+=y?1:-1,b<0?b=i.length-1:b%=i.length,i[b]):null}}D.INSTANCE=new D,t.BasicInplaceReplace=D}),Y(Z[39],K([0,1,11]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.OverviewRulerLane=void 0;var k;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(k=t.OverviewRulerLane||(t.OverviewRulerLane={}));var i;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(i=t.MinimapPosition||(t.MinimapPosition={}));var u;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(u=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var y;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(y=t.EndOfLinePreference||(t.EndOfLinePreference={}));var b;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(b=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var a;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(a=t.EndOfLineSequence||(t.EndOfLineSequence={}));class f{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,m.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace),this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this._indentSizeIsTabSize===m._indentSizeIsTabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,D.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}t.TextModelResolvedOptions=f;class N{constructor(m,l){this._findMatchBrand=void 0,this.range=m,this.matches=l}}t.FindMatch=N;var M;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(M=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));function p(g){return g&&typeof g.read=="function"}t.isITextSnapshot=p;var v;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(v=t.PositionAffinity||(t.PositionAffinity={}));var e;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=t.ModelConstants||(t.ModelConstants={}));class A{constructor(m,l,r,s,d,c){this.identifier=m,this.range=l,this.text=r,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=d,this._isTracked=c}}t.ValidAnnotatedEditOperation=A;class F{constructor(m,l,r){this.regex=m,this.wordSeparators=l,this.simpleSearch=r}}t.SearchData=F;class E{constructor(m,l,r){this.reverseEdits=m,this.changes=l,this.trimAutoWhitespaceLineNumbers=r}}t.ApplyEditsResult=E;function L(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}t.shouldSynchronizeModel=L}),Y(Z[40],K([0,1,26,17]),function(q,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(a){this.values=a,this.prefixSum=new Uint32Array(a.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(a,f){a=(0,k.toUint32)(a);const N=this.values,M=this.prefixSum,p=f.length;return p===0?!1:(this.values=new Uint32Array(N.length+p),this.values.set(N.subarray(0,a),0),this.values.set(N.subarray(a),a+p),this.values.set(f,a),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(a,f){return a=(0,k.toUint32)(a),f=(0,k.toUint32)(f),this.values[a]===f?!1:(this.values[a]=f,a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),!0)}removeValues(a,f){a=(0,k.toUint32)(a),f=(0,k.toUint32)(f);const N=this.values,M=this.prefixSum;if(a>=N.length)return!1;const p=N.length-a;return f>=p&&(f=p),f===0?!1:(this.values=new Uint32Array(N.length-f),this.values.set(N.subarray(0,a),0),this.values.set(N.subarray(a+f),a),this.prefixSum=new Uint32Array(this.values.length),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(a){return a<0?0:(a=(0,k.toUint32)(a),this._getPrefixSum(a))}_getPrefixSum(a){if(a<=this.prefixSumValidIndex[0])return this.prefixSum[a];let f=this.prefixSumValidIndex[0]+1;f===0&&(this.prefixSum[0]=this.values[0],f++),a>=this.values.length&&(a=this.values.length-1);for(let N=f;N<=a;N++)this.prefixSum[N]=this.prefixSum[N-1]+this.values[N];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],a),this.prefixSum[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let f=0,N=this.values.length-1,M=0,p=0,v=0;for(;f<=N;)if(M=f+(N-f)/2|0,p=this.prefixSum[M],v=p-this.values[M],a<v)N=M-1;else if(a>=p)f=M+1;else break;return new y(M,a-v)}}t.PrefixSumComputer=i;class u{constructor(a){this._values=a,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(a){return this._ensureValid(),a===0?0:this._prefixSum[a-1]}getIndexOf(a){this._ensureValid();const f=this._indexBySum[a],N=f>0?this._prefixSum[f-1]:0;return new y(f,a-N)}removeValues(a,f){this._values.splice(a,f),this._invalidate(a)}insertValues(a,f){this._values=(0,D.arrayInsert)(this._values,a,f),this._invalidate(a)}_invalidate(a){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,a-1)}_ensureValid(){if(!this._isValid){for(let a=this._validEndIndex+1,f=this._values.length;a<f;a++){const N=this._values[a],M=a>0?this._prefixSum[a-1]:0;this._prefixSum[a]=M+N;for(let p=0;p<N;p++)this._indexBySum[M+p]=a}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(a,f){this._values[a]!==f&&(this._values[a]=f,this._invalidate(a))}}t.ConstantTimePrefixSumComputer=u;class y{constructor(a,f){this.index=a,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=f}}t.PrefixSumIndexOfResult=y}),Y(Z[41],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var D;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(D=t.AccessibilitySupport||(t.AccessibilitySupport={}));var k;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(k=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var u;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(u=t.CompletionItemKind||(t.CompletionItemKind={}));var y;(function(n){n[n.Deprecated=1]="Deprecated"})(y=t.CompletionItemTag||(t.CompletionItemTag={}));var b;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var f;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(f=t.CursorChangeReason||(t.CursorChangeReason={}));var N;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(N=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var M;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(M=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var p;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(p=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var v;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.colorDecoratorsLimit=18]="colorDecoratorsLimit",n[n.columnSelection=19]="columnSelection",n[n.comments=20]="comments",n[n.contextmenu=21]="contextmenu",n[n.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",n[n.cursorBlinking=23]="cursorBlinking",n[n.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",n[n.cursorStyle=25]="cursorStyle",n[n.cursorSurroundingLines=26]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",n[n.cursorWidth=28]="cursorWidth",n[n.disableLayerHinting=29]="disableLayerHinting",n[n.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",n[n.domReadOnly=31]="domReadOnly",n[n.dragAndDrop=32]="dragAndDrop",n[n.dropIntoEditor=33]="dropIntoEditor",n[n.emptySelectionClipboard=34]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",n[n.extraEditorClassName=36]="extraEditorClassName",n[n.fastScrollSensitivity=37]="fastScrollSensitivity",n[n.find=38]="find",n[n.fixedOverflowWidgets=39]="fixedOverflowWidgets",n[n.folding=40]="folding",n[n.foldingStrategy=41]="foldingStrategy",n[n.foldingHighlight=42]="foldingHighlight",n[n.foldingImportsByDefault=43]="foldingImportsByDefault",n[n.foldingMaximumRegions=44]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=46]="fontFamily",n[n.fontInfo=47]="fontInfo",n[n.fontLigatures=48]="fontLigatures",n[n.fontSize=49]="fontSize",n[n.fontWeight=50]="fontWeight",n[n.fontVariations=51]="fontVariations",n[n.formatOnPaste=52]="formatOnPaste",n[n.formatOnType=53]="formatOnType",n[n.glyphMargin=54]="glyphMargin",n[n.gotoLocation=55]="gotoLocation",n[n.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",n[n.hover=57]="hover",n[n.inDiffEditor=58]="inDiffEditor",n[n.inlineSuggest=59]="inlineSuggest",n[n.letterSpacing=60]="letterSpacing",n[n.lightbulb=61]="lightbulb",n[n.lineDecorationsWidth=62]="lineDecorationsWidth",n[n.lineHeight=63]="lineHeight",n[n.lineNumbers=64]="lineNumbers",n[n.lineNumbersMinChars=65]="lineNumbersMinChars",n[n.linkedEditing=66]="linkedEditing",n[n.links=67]="links",n[n.matchBrackets=68]="matchBrackets",n[n.minimap=69]="minimap",n[n.mouseStyle=70]="mouseStyle",n[n.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=72]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",n[n.multiCursorModifier=74]="multiCursorModifier",n[n.multiCursorPaste=75]="multiCursorPaste",n[n.multiCursorLimit=76]="multiCursorLimit",n[n.occurrencesHighlight=77]="occurrencesHighlight",n[n.overviewRulerBorder=78]="overviewRulerBorder",n[n.overviewRulerLanes=79]="overviewRulerLanes",n[n.padding=80]="padding",n[n.parameterHints=81]="parameterHints",n[n.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",n[n.quickSuggestions=84]="quickSuggestions",n[n.quickSuggestionsDelay=85]="quickSuggestionsDelay",n[n.readOnly=86]="readOnly",n[n.renameOnType=87]="renameOnType",n[n.renderControlCharacters=88]="renderControlCharacters",n[n.renderFinalNewline=89]="renderFinalNewline",n[n.renderLineHighlight=90]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=92]="renderValidationDecorations",n[n.renderWhitespace=93]="renderWhitespace",n[n.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",n[n.roundedSelection=95]="roundedSelection",n[n.rulers=96]="rulers",n[n.scrollbar=97]="scrollbar",n[n.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=99]="scrollBeyondLastLine",n[n.scrollPredominantAxis=100]="scrollPredominantAxis",n[n.selectionClipboard=101]="selectionClipboard",n[n.selectionHighlight=102]="selectionHighlight",n[n.selectOnLineNumbers=103]="selectOnLineNumbers",n[n.showFoldingControls=104]="showFoldingControls",n[n.showUnused=105]="showUnused",n[n.snippetSuggestions=106]="snippetSuggestions",n[n.smartSelect=107]="smartSelect",n[n.smoothScrolling=108]="smoothScrolling",n[n.stickyScroll=109]="stickyScroll",n[n.stickyTabStops=110]="stickyTabStops",n[n.stopRenderingLineAfter=111]="stopRenderingLineAfter",n[n.suggest=112]="suggest",n[n.suggestFontSize=113]="suggestFontSize",n[n.suggestLineHeight=114]="suggestLineHeight",n[n.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",n[n.suggestSelection=116]="suggestSelection",n[n.tabCompletion=117]="tabCompletion",n[n.tabIndex=118]="tabIndex",n[n.unicodeHighlighting=119]="unicodeHighlighting",n[n.unusualLineTerminators=120]="unusualLineTerminators",n[n.useShadowDOM=121]="useShadowDOM",n[n.useTabStops=122]="useTabStops",n[n.wordBreak=123]="wordBreak",n[n.wordSeparators=124]="wordSeparators",n[n.wordWrap=125]="wordWrap",n[n.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=128]="wordWrapColumn",n[n.wordWrapOverride1=129]="wordWrapOverride1",n[n.wordWrapOverride2=130]="wordWrapOverride2",n[n.wrappingIndent=131]="wrappingIndent",n[n.wrappingStrategy=132]="wrappingStrategy",n[n.showDeprecated=133]="showDeprecated",n[n.inlayHints=134]="inlayHints",n[n.editorClassName=135]="editorClassName",n[n.pixelRatio=136]="pixelRatio",n[n.tabFocusMode=137]="tabFocusMode",n[n.layoutInfo=138]="layoutInfo",n[n.wrappingInfo=139]="wrappingInfo"})(v=t.EditorOption||(t.EditorOption={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e=t.EndOfLinePreference||(t.EndOfLinePreference={}));var A;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(A=t.EndOfLineSequence||(t.EndOfLineSequence={}));var F;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(F=t.IndentAction||(t.IndentAction={}));var E;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(E=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var L;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(L=t.InlayHintKind||(t.InlayHintKind={}));var g;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(g=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(m=t.KeyCode||(t.KeyCode={}));var l;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(l=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d=t.MouseTargetType||(t.MouseTargetType={}));var c;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(c=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var w;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(w=t.OverviewRulerLane||(t.OverviewRulerLane={}));var _;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(_=t.PositionAffinity||(t.PositionAffinity={}));var h;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(h=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var o;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(o=t.RenderMinimap||(t.RenderMinimap={}));var R;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(R=t.ScrollType||(t.ScrollType={}));var I;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(I=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var O;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(O=t.SelectionDirection||(t.SelectionDirection={}));var U;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(U=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var H;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(H=t.SymbolKind||(t.SymbolKind={}));var z;(function(n){n[n.Deprecated=1]="Deprecated"})(z=t.SymbolTag||(t.SymbolTag={}));var ee;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(ee=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var ne;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(ne=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var X;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(X=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var J;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(J=t.WrappingIndent||(t.WrappingIndent={}))}),Y(Z[42],K([55,56]),function(q,t){return q.create("vs/base/common/platform",t)}),Y(Z[5],K([0,1,42]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let k=!1,i=!1,u=!1,y=!1,b=!1,a=!1,f=!1,N=!1,M=!1,p=!1,v,e=t.LANGUAGE_DEFAULT,A,F;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?E=t.globals.vscode.process:typeof process<"u"&&(E=process);const L=typeof E?.versions?.electron=="string",g=L&&E?.type==="renderer";if(typeof navigator=="object"&&!g)F=navigator.userAgent,k=F.indexOf("Windows")>=0,i=F.indexOf("Macintosh")>=0,N=(F.indexOf("Macintosh")>=0||F.indexOf("iPad")>=0||F.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=F.indexOf("Linux")>=0,p=F?.indexOf("Mobi")>=0,a=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||t.LANGUAGE_DEFAULT,e=v;else if(typeof E=="object"){k=E.platform==="win32",i=E.platform==="darwin",u=E.platform==="linux",y=u&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,f=L,M=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const h=E.env.VSCODE_NLS_CONFIG;if(h)try{const o=JSON.parse(h),R=o.availableLanguages["*"];v=o.locale,e=R||t.LANGUAGE_DEFAULT,A=o._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var m;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(m=t.Platform||(t.Platform={}));function l(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=l;let r=0;i?r=1:k?r=3:u&&(r=2),t.isWindows=k,t.isMacintosh=i,t.isLinux=u,t.isLinuxSnap=y,t.isNative=b,t.isElectron=f,t.isWeb=a,t.isWebWorker=a&&typeof t.globals.importScripts=="function",t.isIOS=N,t.isMobile=p,t.isCI=M,t.platform=r,t.userAgent=F,t.language=e;var s;(function(h){function o(){return t.language}h.value=o;function R(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}h.isDefaultVariant=R;function I(){return t.language==="en"}h.isDefault=I})(s=t.Language||(t.Language={})),t.locale=v,t.translationsConfigFile=A,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const h=[];t.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let I=0,O=h.length;I<O;I++){const U=h[I];if(U.id===R.data.vscodeScheduleAsyncWork){h.splice(I,1),U.callback();return}}});let o=0;return R=>{const I=++o;h.push({id:I,callback:R}),t.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return h=>setTimeout(h)})();var d;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(d=t.OperatingSystem||(t.OperatingSystem={})),t.OS=i||N?2:k?1:3;let c=!0,w=!1;function _(){if(!w){w=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,c=new Uint16Array(h.buffer)[0]===(2<<8)+1}return c}t.isLittleEndian=_,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),Y(Z[43],K([0,1,5]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let k;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const i=D.globals.vscode.process;k={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.platform=k.platform,t.arch=k.arch}),Y(Z[44],K([0,1,43]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const k=65,i=97,u=90,y=122,b=46,a=47,f=92,N=58,M=63;class p extends Error{constructor(s,d,c){let w;typeof d=="string"&&d.indexOf("not ")===0?(w="must not be",d=d.replace(/^not /,"")):w="must be";const _=s.indexOf(".")!==-1?"property":"argument";let h=`The "${s}" ${_} ${w} of type ${d}`;h+=`. Received type ${typeof c}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function v(r,s){if(r===null||typeof r!="object")throw new p(s,"Object",r)}function e(r,s){if(typeof r!="string")throw new p(s,"string",r)}const A=D.platform==="win32";function F(r){return r===a||r===f}function E(r){return r===a}function L(r){return r>=k&&r<=u||r>=i&&r<=y}function g(r,s,d,c){let w="",_=0,h=-1,o=0,R=0;for(let I=0;I<=r.length;++I){if(I<r.length)R=r.charCodeAt(I);else{if(c(R))break;R=a}if(c(R)){if(!(h===I-1||o===1))if(o===2){if(w.length<2||_!==2||w.charCodeAt(w.length-1)!==b||w.charCodeAt(w.length-2)!==b){if(w.length>2){const O=w.lastIndexOf(d);O===-1?(w="",_=0):(w=w.slice(0,O),_=w.length-1-w.lastIndexOf(d)),h=I,o=0;continue}else if(w.length!==0){w="",_=0,h=I,o=0;continue}}s&&(w+=w.length>0?`${d}..`:"..",_=2)}else w.length>0?w+=`${d}${r.slice(h+1,I)}`:w=r.slice(h+1,I),_=I-h-1;h=I,o=0}else R===b&&o!==-1?++o:o=-1}return w}function m(r,s){v(s,"pathObject");const d=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${c}`:`${d}${r}${c}`:c}t.win32={resolve(...r){let s="",d="",c=!1;for(let w=r.length-1;w>=-1;w--){let _;if(w>=0){if(_=r[w],e(_,"path"),_.length===0)continue}else s.length===0?_=D.cwd():(_=D.env[`=${s}`]||D.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==s.toLowerCase()&&_.charCodeAt(2)===f)&&(_=`${s}\\`));const h=_.length;let o=0,R="",I=!1;const O=_.charCodeAt(0);if(h===1)F(O)&&(o=1,I=!0);else if(F(O))if(I=!0,F(_.charCodeAt(1))){let U=2,H=U;for(;U<h&&!F(_.charCodeAt(U));)U++;if(U<h&&U!==H){const z=_.slice(H,U);for(H=U;U<h&&F(_.charCodeAt(U));)U++;if(U<h&&U!==H){for(H=U;U<h&&!F(_.charCodeAt(U));)U++;(U===h||U!==H)&&(R=`\\\\${z}\\${_.slice(H,U)}`,o=U)}}}else o=1;else L(O)&&_.charCodeAt(1)===N&&(R=_.slice(0,2),o=2,h>2&&F(_.charCodeAt(2))&&(I=!0,o=3));if(R.length>0)if(s.length>0){if(R.toLowerCase()!==s.toLowerCase())continue}else s=R;if(c){if(s.length>0)break}else if(d=`${_.slice(o)}\\${d}`,c=I,I&&s.length>0)break}return d=g(d,!c,"\\",F),c?`${s}\\${d}`:`${s}${d}`||"."},normalize(r){e(r,"path");const s=r.length;if(s===0)return".";let d=0,c,w=!1;const _=r.charCodeAt(0);if(s===1)return E(_)?"\\":r;if(F(_))if(w=!0,F(r.charCodeAt(1))){let o=2,R=o;for(;o<s&&!F(r.charCodeAt(o));)o++;if(o<s&&o!==R){const I=r.slice(R,o);for(R=o;o<s&&F(r.charCodeAt(o));)o++;if(o<s&&o!==R){for(R=o;o<s&&!F(r.charCodeAt(o));)o++;if(o===s)return`\\\\${I}\\${r.slice(R)}\\`;o!==R&&(c=`\\\\${I}\\${r.slice(R,o)}`,d=o)}}}else d=1;else L(_)&&r.charCodeAt(1)===N&&(c=r.slice(0,2),d=2,s>2&&F(r.charCodeAt(2))&&(w=!0,d=3));let h=d<s?g(r.slice(d),!w,"\\",F):"";return h.length===0&&!w&&(h="."),h.length>0&&F(r.charCodeAt(s-1))&&(h+="\\"),c===void 0?w?`\\${h}`:h:w?`${c}\\${h}`:`${c}${h}`},isAbsolute(r){e(r,"path");const s=r.length;if(s===0)return!1;const d=r.charCodeAt(0);return F(d)||s>2&&L(d)&&r.charCodeAt(1)===N&&F(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,d;for(let _=0;_<r.length;++_){const h=r[_];e(h,"path"),h.length>0&&(s===void 0?s=d=h:s+=`\\${h}`)}if(s===void 0)return".";let c=!0,w=0;if(typeof d=="string"&&F(d.charCodeAt(0))){++w;const _=d.length;_>1&&F(d.charCodeAt(1))&&(++w,_>2&&(F(d.charCodeAt(2))?++w:c=!1))}if(c){for(;w<s.length&&F(s.charCodeAt(w));)w++;w>=2&&(s=`\\${s.slice(w)}`)}return t.win32.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s)return"";const d=t.win32.resolve(r),c=t.win32.resolve(s);if(d===c||(r=d.toLowerCase(),s=c.toLowerCase(),r===s))return"";let w=0;for(;w<r.length&&r.charCodeAt(w)===f;)w++;let _=r.length;for(;_-1>w&&r.charCodeAt(_-1)===f;)_--;const h=_-w;let o=0;for(;o<s.length&&s.charCodeAt(o)===f;)o++;let R=s.length;for(;R-1>o&&s.charCodeAt(R-1)===f;)R--;const I=R-o,O=h<I?h:I;let U=-1,H=0;for(;H<O;H++){const ee=r.charCodeAt(w+H);if(ee!==s.charCodeAt(o+H))break;ee===f&&(U=H)}if(H!==O){if(U===-1)return c}else{if(I>O){if(s.charCodeAt(o+H)===f)return c.slice(o+H+1);if(H===2)return c.slice(o+H)}h>O&&(r.charCodeAt(w+H)===f?U=H:H===2&&(U=3)),U===-1&&(U=0)}let z="";for(H=w+U+1;H<=_;++H)(H===_||r.charCodeAt(H)===f)&&(z+=z.length===0?"..":"\\..");return o+=U,z.length>0?`${z}${c.slice(o,R)}`:(c.charCodeAt(o)===f&&++o,c.slice(o,R))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=t.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===f){if(s.charCodeAt(1)===f){const d=s.charCodeAt(2);if(d!==M&&d!==b)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(L(s.charCodeAt(0))&&s.charCodeAt(1)===N&&s.charCodeAt(2)===f)return`\\\\?\\${s}`;return r},dirname(r){e(r,"path");const s=r.length;if(s===0)return".";let d=-1,c=0;const w=r.charCodeAt(0);if(s===1)return F(w)?r:".";if(F(w)){if(d=c=1,F(r.charCodeAt(1))){let o=2,R=o;for(;o<s&&!F(r.charCodeAt(o));)o++;if(o<s&&o!==R){for(R=o;o<s&&F(r.charCodeAt(o));)o++;if(o<s&&o!==R){for(R=o;o<s&&!F(r.charCodeAt(o));)o++;if(o===s)return r;o!==R&&(d=c=o+1)}}}}else L(w)&&r.charCodeAt(1)===N&&(d=s>2&&F(r.charCodeAt(2))?3:2,c=d);let _=-1,h=!0;for(let o=s-1;o>=c;--o)if(F(r.charCodeAt(o))){if(!h){_=o;break}}else h=!1;if(_===-1){if(d===-1)return".";_=d}return r.slice(0,_)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let d=0,c=-1,w=!0,_;if(r.length>=2&&L(r.charCodeAt(0))&&r.charCodeAt(1)===N&&(d=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let h=s.length-1,o=-1;for(_=r.length-1;_>=d;--_){const R=r.charCodeAt(_);if(F(R)){if(!w){d=_+1;break}}else o===-1&&(w=!1,o=_+1),h>=0&&(R===s.charCodeAt(h)?--h===-1&&(c=_):(h=-1,c=o))}return d===c?c=o:c===-1&&(c=r.length),r.slice(d,c)}for(_=r.length-1;_>=d;--_)if(F(r.charCodeAt(_))){if(!w){d=_+1;break}}else c===-1&&(w=!1,c=_+1);return c===-1?"":r.slice(d,c)},extname(r){e(r,"path");let s=0,d=-1,c=0,w=-1,_=!0,h=0;r.length>=2&&r.charCodeAt(1)===N&&L(r.charCodeAt(0))&&(s=c=2);for(let o=r.length-1;o>=s;--o){const R=r.charCodeAt(o);if(F(R)){if(!_){c=o+1;break}continue}w===-1&&(_=!1,w=o+1),R===b?d===-1?d=o:h!==1&&(h=1):d!==-1&&(h=-1)}return d===-1||w===-1||h===0||h===1&&d===w-1&&d===c+1?"":r.slice(d,w)},format:m.bind(null,"\\"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const d=r.length;let c=0,w=r.charCodeAt(0);if(d===1)return F(w)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(F(w)){if(c=1,F(r.charCodeAt(1))){let U=2,H=U;for(;U<d&&!F(r.charCodeAt(U));)U++;if(U<d&&U!==H){for(H=U;U<d&&F(r.charCodeAt(U));)U++;if(U<d&&U!==H){for(H=U;U<d&&!F(r.charCodeAt(U));)U++;U===d?c=U:U!==H&&(c=U+1)}}}}else if(L(w)&&r.charCodeAt(1)===N){if(d<=2)return s.root=s.dir=r,s;if(c=2,F(r.charCodeAt(2))){if(d===3)return s.root=s.dir=r,s;c=3}}c>0&&(s.root=r.slice(0,c));let _=-1,h=c,o=-1,R=!0,I=r.length-1,O=0;for(;I>=c;--I){if(w=r.charCodeAt(I),F(w)){if(!R){h=I+1;break}continue}o===-1&&(R=!1,o=I+1),w===b?_===-1?_=I:O!==1&&(O=1):_!==-1&&(O=-1)}return o!==-1&&(_===-1||O===0||O===1&&_===o-1&&_===h+1?s.base=s.name=r.slice(h,o):(s.name=r.slice(h,_),s.base=r.slice(h,o),s.ext=r.slice(_,o))),h>0&&h!==c?s.dir=r.slice(0,h-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(A){const r=/\\/g;return()=>{const s=D.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>D.cwd()})();t.posix={resolve(...r){let s="",d=!1;for(let c=r.length-1;c>=-1&&!d;c--){const w=c>=0?r[c]:l();e(w,"path"),w.length!==0&&(s=`${w}/${s}`,d=w.charCodeAt(0)===a)}return s=g(s,!d,"/",E),d?`/${s}`:s.length>0?s:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a,d=r.charCodeAt(r.length-1)===a;return r=g(r,!s,"/",E),r.length===0?s?"/":d?"./":".":(d&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let s;for(let d=0;d<r.length;++d){const c=r[d];e(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":t.posix.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s||(r=t.posix.resolve(r),s=t.posix.resolve(s),r===s))return"";const d=1,c=r.length,w=c-d,_=1,h=s.length-_,o=w<h?w:h;let R=-1,I=0;for(;I<o;I++){const U=r.charCodeAt(d+I);if(U!==s.charCodeAt(_+I))break;U===a&&(R=I)}if(I===o)if(h>o){if(s.charCodeAt(_+I)===a)return s.slice(_+I+1);if(I===0)return s.slice(_+I)}else w>o&&(r.charCodeAt(d+I)===a?R=I:I===0&&(R=0));let O="";for(I=d+R+1;I<=c;++I)(I===c||r.charCodeAt(I)===a)&&(O+=O.length===0?"..":"/..");return`${O}${s.slice(_+R)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a;let d=-1,c=!0;for(let w=r.length-1;w>=1;--w)if(r.charCodeAt(w)===a){if(!c){d=w;break}}else c=!1;return d===-1?s?"/":".":s&&d===1?"//":r.slice(0,d)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let d=0,c=-1,w=!0,_;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let h=s.length-1,o=-1;for(_=r.length-1;_>=0;--_){const R=r.charCodeAt(_);if(R===a){if(!w){d=_+1;break}}else o===-1&&(w=!1,o=_+1),h>=0&&(R===s.charCodeAt(h)?--h===-1&&(c=_):(h=-1,c=o))}return d===c?c=o:c===-1&&(c=r.length),r.slice(d,c)}for(_=r.length-1;_>=0;--_)if(r.charCodeAt(_)===a){if(!w){d=_+1;break}}else c===-1&&(w=!1,c=_+1);return c===-1?"":r.slice(d,c)},extname(r){e(r,"path");let s=-1,d=0,c=-1,w=!0,_=0;for(let h=r.length-1;h>=0;--h){const o=r.charCodeAt(h);if(o===a){if(!w){d=h+1;break}continue}c===-1&&(w=!1,c=h+1),o===b?s===-1?s=h:_!==1&&(_=1):s!==-1&&(_=-1)}return s===-1||c===-1||_===0||_===1&&s===c-1&&s===d+1?"":r.slice(s,c)},format:m.bind(null,"/"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const d=r.charCodeAt(0)===a;let c;d?(s.root="/",c=1):c=0;let w=-1,_=0,h=-1,o=!0,R=r.length-1,I=0;for(;R>=c;--R){const O=r.charCodeAt(R);if(O===a){if(!o){_=R+1;break}continue}h===-1&&(o=!1,h=R+1),O===b?w===-1?w=R:I!==1&&(I=1):w!==-1&&(I=-1)}if(h!==-1){const O=_===0&&d?1:_;w===-1||I===0||I===1&&w===h-1&&w===_+1?s.base=s.name=r.slice(O,h):(s.name=r.slice(O,w),s.base=r.slice(O,h),s.ext=r.slice(w,h))}return _>0?s.dir=r.slice(0,_-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=A?t.win32.normalize:t.posix.normalize,t.isAbsolute=A?t.win32.isAbsolute:t.posix.isAbsolute,t.join=A?t.win32.join:t.posix.join,t.resolve=A?t.win32.resolve:t.posix.resolve,t.relative=A?t.win32.relative:t.posix.relative,t.dirname=A?t.win32.dirname:t.posix.dirname,t.basename=A?t.win32.basename:t.posix.basename,t.extname=A?t.win32.extname:t.posix.extname,t.format=A?t.win32.format:t.posix.format,t.parse=A?t.win32.parse:t.posix.parse,t.toNamespacedPath=A?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=A?t.win32.sep:t.posix.sep,t.delimiter=A?t.win32.delimiter:t.posix.delimiter}),Y(Z[21],K([0,1,5]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const k=D.globals.performance&&typeof D.globals.performance.now=="function";class i{static create(y=!0){return new i(y)}constructor(y){this._highResolution=k&&y,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}t.StopWatch=i}),Y(Z[9],K([0,1,6,13,7,15,21]),function(q,t,D,k,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const b=!1,a=!1;var f;(function(_){_.None=()=>i.Disposable.None;function h(te){if(a){const{onDidAddListener:$}=te,Q=e.create();let S=0;te.onDidAddListener=()=>{++S===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),$?.()}}}function o(te,$){return X(te,()=>{},0,void 0,void 0,$)}_.defer=o;function R(te){return($,Q=null,S)=>{let T=!1,C;return C=te(W=>{if(!T)return C?C.dispose():T=!0,$.call(Q,W)},null,S),T&&C.dispose(),C}}_.once=R;function I(te,$,Q){return ne((S,T=null,C)=>te(W=>S.call(T,$(W)),null,C),Q)}_.map=I;function O(te,$,Q){return ne((S,T=null,C)=>te(W=>{$(W),S.call(T,W)},null,C),Q)}_.forEach=O;function U(te,$,Q){return ne((S,T=null,C)=>te(W=>$(W)&&S.call(T,W),null,C),Q)}_.filter=U;function H(te){return te}_.signal=H;function z(...te){return($,Q=null,S)=>(0,i.combinedDisposable)(...te.map(T=>T(C=>$.call(Q,C),null,S)))}_.any=z;function ee(te,$,Q,S){let T=Q;return I(te,C=>(T=$(T,C),T),S)}_.reduce=ee;function ne(te,$){let Q;const S={onWillAddFirstListener(){Q=te(T.fire,T)},onDidRemoveLastListener(){Q?.dispose()}};$||h(S);const T=new F(S);return $?.add(T),T.event}function X(te,$,Q=100,S=!1,T,C){let W,x,ie,re=0;const oe={leakWarningThreshold:T,onWillAddFirstListener(){W=te(fe=>{re++,x=$(x,fe),S&&!ie&&(ae.fire(x),x=void 0);const he=()=>{const Se=x;x=void 0,ie=void 0,(!S||re>1)&&ae.fire(Se),re=0};typeof Q=="number"?(clearTimeout(ie),ie=setTimeout(he,Q)):ie===void 0&&(ie=0,queueMicrotask(he))})},onDidRemoveLastListener(){W.dispose()}};C||h(oe);const ae=new F(oe);return C?.add(ae),ae.event}_.debounce=X;function J(te,$=0,Q){return _.debounce(te,(S,T)=>S?(S.push(T),S):[T],$,void 0,void 0,Q)}_.accumulate=J;function n(te,$=(S,T)=>S===T,Q){let S=!0,T;return U(te,C=>{const W=S||!$(C,T);return S=!1,T=C,W},Q)}_.latch=n;function ve(te,$,Q){return[_.filter(te,$,Q),_.filter(te,S=>!$(S),Q)]}_.split=ve;function Ne(te,$=!1,Q=[]){let S=Q.slice(),T=te(x=>{S?S.push(x):W.fire(x)});const C=()=>{S?.forEach(x=>W.fire(x)),S=null},W=new F({onWillAddFirstListener(){T||(T=te(x=>W.fire(x)))},onDidAddFirstListener(){S&&($?setTimeout(C):C())},onDidRemoveLastListener(){T&&T.dispose(),T=null}});return W.event}_.buffer=Ne;class de{constructor($){this.event=$,this.disposables=new i.DisposableStore}map($){return new de(I(this.event,$,this.disposables))}forEach($){return new de(O(this.event,$,this.disposables))}filter($){return new de(U(this.event,$,this.disposables))}reduce($,Q){return new de(ee(this.event,$,Q,this.disposables))}latch(){return new de(n(this.event,void 0,this.disposables))}debounce($,Q=100,S=!1,T){return new de(X(this.event,$,Q,S,T,this.disposables))}on($,Q,S){return this.event($,Q,S)}once($,Q,S){return R(this.event)($,Q,S)}dispose(){this.disposables.dispose()}}function Ae(te){return new de(te)}_.chain=Ae;function Le(te,$,Q=S=>S){const S=(...x)=>W.fire(Q(...x)),T=()=>te.on($,S),C=()=>te.removeListener($,S),W=new F({onWillAddFirstListener:T,onDidRemoveLastListener:C});return W.event}_.fromNodeEventEmitter=Le;function pe(te,$,Q=S=>S){const S=(...x)=>W.fire(Q(...x)),T=()=>te.addEventListener($,S),C=()=>te.removeEventListener($,S),W=new F({onWillAddFirstListener:T,onDidRemoveLastListener:C});return W.event}_.fromDOMEventEmitter=pe;function Me(te){return new Promise($=>R(te)($))}_.toPromise=Me;function De(te,$){return $(void 0),te(Q=>$(Q))}_.runAndSubscribe=De;function Fe(te,$){let Q=null;function S(C){Q?.dispose(),Q=new i.DisposableStore,$(C,Q)}S(void 0);const T=te(C=>S(C));return(0,i.toDisposable)(()=>{T.dispose(),Q?.dispose()})}_.runAndSubscribeWithStore=Fe;class Ee{constructor($,Q){this.obs=$,this._counter=0,this._hasChanged=!1;const S={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Q||h(S),this.emitter=new F(S),Q&&Q.add(this.emitter)}beginUpdate($){this._counter++}handleChange($,Q){this._hasChanged=!0}endUpdate($){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Pe(te,$){return new Ee(te,$).emitter.event}_.fromObservable=Pe})(f=t.Event||(t.Event={}));class N{constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${N._idPool++}`,N.all.add(this)}start(h){this._stopWatch=new y.StopWatch(!0),this.listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this._stopWatch=void 0}}}N.all=new Set,N._idPool=0,t.EventProfiling=N;let M=-1;function p(_){const h=M;return M=_,{dispose(){M=h}}}t.setGlobalLeakWarningThreshold=p;class v{constructor(h,o=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=o,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(h,o){const R=this.threshold;if(R<=0||o<R)return;this._stacks||(this._stacks=new Map);const I=this._stacks.get(h.value)||0;if(this._stacks.set(h.value,I+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=R*.5;let O,U=0;for(const[H,z]of this._stacks)(!O||U<z)&&(O=H,U=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${U}):`),console.warn(O)}return()=>{const O=this._stacks.get(h.value)||0;this._stacks.set(h.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class A{constructor(h,o,R){this.callback=h,this.callbackThis=o,this.stack=R,this.subscription=new i.SafeDisposable}invoke(h){this.callback.call(this.callbackThis,h)}}class F{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=M>0||this._options?.leakWarningThreshold?new v(this._options?.leakWarningThreshold??M):void 0,this._perfMon=this._options?._profName?new N(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const h=Array.from(this._listeners);queueMicrotask(()=>{for(const o of h)o.subscription.isset()&&(o.subscription.unset(),o.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(h,o,R)=>{if(this._listeners||(this._listeners=new u.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const I=this._listeners.isEmpty();I&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let O,U;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(U=e.create(),O=this._leakageMon.check(U,this._listeners.size+1)),b&&(U=U??e.create());const H=new A(h,o,U),z=this._listeners.push(H);I&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,h,o);const ee=H.subscription.set(()=>{O?.(),this._disposed||(z(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return R instanceof i.DisposableStore?R.add(ee):Array.isArray(R)&&R.push(ee),ee}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L);for(const o of this._listeners)this._deliveryQueue.push(this,o,h);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=F;class E{constructor(){this._queue=new u.LinkedList}get size(){return this._queue.size}push(h,o,R){this._queue.push(new g(h,o,R))}clear(h){const o=new u.LinkedList;for(const R of this._queue)R.emitter!==h&&o.push(R);this._queue=o}deliver(){for(;this._queue.size>0;){const h=this._queue.shift();try{h.listener.invoke(h.event)}catch(o){(0,D.onUnexpectedError)(o)}}}}t.EventDeliveryQueue=E;class L extends E{clear(h){this._queue.clear()}}class g{constructor(h,o,R){this.emitter=h,this.listener=o,this.event=R}}class m extends F{async fireAsync(h,o,R){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new u.LinkedList);for(const I of this._listeners)this._asyncDeliveryQueue.push([I,h]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[I,O]=this._asyncDeliveryQueue.shift(),U=[],H={...O,token:o,waitUntil:z=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");R&&(z=R(z,I.callback)),U.push(z)}};try{I.invoke(H)}catch(z){(0,D.onUnexpectedError)(z);continue}Object.freeze(U),await Promise.allSettled(U).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,D.onUnexpectedError)(ee.reason)})}}}}t.AsyncEmitter=m;class l extends F{constructor(h){super(h),this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}t.PauseableEmitter=l;class r extends l{constructor(h){super(h),this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}t.DebounceEmitter=r;class s extends F{constructor(h){super(h),this._queuedEvents=[],this._mergeFn=h?.merge}fire(h){!this.hasListeners()||(this._queuedEvents.push(h),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=s;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new F({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const o={event:h,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const R=()=>{this.hasListeners&&this.unhook(o);const I=this.events.indexOf(o);this.events.splice(I,1)};return(0,i.toDisposable)((0,k.once)(R))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(o=>this.emitter.fire(o))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=d;class c{constructor(){this.buffers=[]}wrapEvent(h){return(o,R,I)=>h(O=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>o.call(R,O)):o.call(R,O)},void 0,I)}bufferEvents(h){const o=[];this.buffers.push(o);const R=h();return this.buffers.pop(),o.forEach(I=>I()),R}}t.EventBufferer=c;class w{constructor(){this.listening=!1,this.inputEvent=f.None,this.inputEventListener=i.Disposable.None,this.emitter=new F({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=w}),Y(Z[22],K([0,1,9]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const k=Object.freeze(function(b,a){const f=setTimeout(b.bind(a),0);return{dispose(){clearTimeout(f)}}});var i;(function(b){function a(f){return f===b.None||f===b.Cancelled||f instanceof u?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}b.isCancellationToken=a,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(i=t.CancellationToken||(t.CancellationToken={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=i.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=y}),Y(Z[45],K([0,1,22]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class k{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new D.CancellationTokenSource,a=this.task(b.token);return this.result={promise:a,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}t.Cache=k;class i{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const a=JSON.stringify(b);return this.lastArgKey!==a&&(this.lastArgKey=a,this.lastCache=this.fn(b)),this.lastCache}}t.LRUCachedFunction=i;class u{get cachedValues(){return this._map}constructor(b){this.fn=b,this._map=new Map}get(b){if(this._map.has(b))return this._map.get(b);const a=this.fn(b);return this._map.set(b,a),a}}t.CachedFunction=u}),Y(Z[4],K([0,1,45,28]),function(q,t,D,k){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function u(P){return!P||typeof P!="string"?!0:P.trim().length===0}t.isFalsyOrWhitespace=u;const y=/{(\d+)}/g;function b(P,...B){return B.length===0?P:P.replace(y,function(V,j){const G=parseInt(j,10);return isNaN(G)||G<0||G>=B.length?V:B[G]})}t.format=b;const a=/{([^}]+)}/g;function f(P,B){return P.replace(a,(V,j)=>B[j]??V)}t.format2=f;function N(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.escape=N;function M(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=M;function p(P,B){let V=0;const j=B.charCodeAt(0);for(let G=P.length-1;G>=0;G--)P.charCodeAt(G)===j&&V++;return V}t.count=p;function v(P,B,V="\u2026"){return P.length<=B?P:`${P.substr(0,B)}${V}`}t.truncate=v;function e(P,B=" "){const V=A(P,B);return F(V,B)}t.trim=e;function A(P,B){if(!P||!B)return P;const V=B.length;if(V===0||P.length===0)return P;let j=0;for(;P.indexOf(B,j)===j;)j=j+V;return P.substring(j)}t.ltrim=A;function F(P,B){if(!P||!B)return P;const V=B.length,j=P.length;if(V===0||j===0)return P;let G=j,se=-1;for(;se=P.lastIndexOf(B,G-1),!(se===-1||se+V!==G);){if(se===0)return"";G=se}return P.substring(0,G)}t.rtrim=F;function E(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=E;function L(P){return P.replace(/\*/g,"")}t.stripWildcards=L;function g(P,B,V={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=M(P)),V.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let j="";return V.global&&(j+="g"),V.matchCase||(j+="i"),V.multiline&&(j+="m"),V.unicode&&(j+="u"),new RegExp(P,j)}t.createRegExp=g;function m(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}t.regExpLeadsToEndlessLoop=m;function l(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=l;function r(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}t.regExpFlags=r;function s(P){return P.split(/\r\n|\r|\n/)}t.splitLines=s;function d(P){for(let B=0,V=P.length;B<V;B++){const j=P.charCodeAt(B);if(j!==32&&j!==9)return B}return-1}t.firstNonWhitespaceIndex=d;function c(P,B=0,V=P.length){for(let j=B;j<V;j++){const G=P.charCodeAt(j);if(G!==32&&G!==9)return P.substring(B,j)}return P.substring(B,V)}t.getLeadingWhitespace=c;function w(P,B=P.length-1){for(let V=B;V>=0;V--){const j=P.charCodeAt(V);if(j!==32&&j!==9)return V}return-1}t.lastNonWhitespaceIndex=w;function _(P,B,V){const j=[];let G=0;for(const se of P.matchAll(B)){if(j.push(P.slice(G,se.index)),se.index===void 0)throw new Error("match.index should be defined");G=se.index+se[0].length,j.push(V(se[0],...se.slice(1),se.index,P,se.groups))}return j.push(P.slice(G)),Promise.all(j).then(se=>se.join(""))}t.replaceAsync=_;function h(P,B){return P<B?-1:P>B?1:0}t.compare=h;function o(P,B,V=0,j=P.length,G=0,se=B.length){for(;V<j&&G<se;V++,G++){const be=P.charCodeAt(V),le=B.charCodeAt(G);if(be<le)return-1;if(be>le)return 1}const ce=j-V,ye=se-G;return ce<ye?-1:ce>ye?1:0}t.compareSubstring=o;function R(P,B){return I(P,B,0,P.length,0,B.length)}t.compareIgnoreCase=R;function I(P,B,V=0,j=P.length,G=0,se=B.length){for(;V<j&&G<se;V++,G++){let be=P.charCodeAt(V),le=B.charCodeAt(G);if(be===le)continue;if(be>=128||le>=128)return o(P.toLowerCase(),B.toLowerCase(),V,j,G,se);U(be)&&(be-=32),U(le)&&(le-=32);const ge=be-le;if(ge!==0)return ge}const ce=j-V,ye=se-G;return ce<ye?-1:ce>ye?1:0}t.compareSubstringIgnoreCase=I;function O(P){return P>=48&&P<=57}t.isAsciiDigit=O;function U(P){return P>=97&&P<=122}t.isLowerAsciiLetter=U;function H(P){return P>=65&&P<=90}t.isUpperAsciiLetter=H;function z(P,B){return P.length===B.length&&I(P,B)===0}t.equalsIgnoreCase=z;function ee(P,B){const V=B.length;return B.length>P.length?!1:I(P,B,0,V)===0}t.startsWithIgnoreCase=ee;function ne(P,B){const V=Math.min(P.length,B.length);let j;for(j=0;j<V;j++)if(P.charCodeAt(j)!==B.charCodeAt(j))return j;return V}t.commonPrefixLength=ne;function X(P,B){const V=Math.min(P.length,B.length);let j;const G=P.length-1,se=B.length-1;for(j=0;j<V;j++)if(P.charCodeAt(G-j)!==B.charCodeAt(se-j))return j;return V}t.commonSuffixLength=X;function J(P){return 55296<=P&&P<=56319}t.isHighSurrogate=J;function n(P){return 56320<=P&&P<=57343}t.isLowSurrogate=n;function ve(P,B){return(P-55296<<10)+(B-56320)+65536}t.computeCodePoint=ve;function Ne(P,B,V){const j=P.charCodeAt(V);if(J(j)&&V+1<B){const G=P.charCodeAt(V+1);if(n(G))return ve(j,G)}return j}t.getNextCodePoint=Ne;function de(P,B){const V=P.charCodeAt(B-1);if(n(V)&&B>1){const j=P.charCodeAt(B-2);if(J(j))return ve(j,V)}return V}class Ae{get offset(){return this._offset}constructor(B,V=0){this._str=B,this._len=B.length,this._offset=V}setOffset(B){this._offset=B}prevCodePoint(){const B=de(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=Ne(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}t.CodePointIterator=Ae;class Le{get offset(){return this._iterator.offset}constructor(B,V=0){this._iterator=new Ae(B,V)}nextGraphemeLength(){const B=we.getInstance(),V=this._iterator,j=V.offset;let G=B.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const se=V.offset,ce=B.getGraphemeBreakType(V.nextCodePoint());if(Te(G,ce)){V.setOffset(se);break}G=ce}return V.offset-j}prevGraphemeLength(){const B=we.getInstance(),V=this._iterator,j=V.offset;let G=B.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const se=V.offset,ce=B.getGraphemeBreakType(V.prevCodePoint());if(Te(ce,G)){V.setOffset(se);break}G=ce}return j-V.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=Le;function pe(P,B){return new Le(P,B).nextGraphemeLength()}t.nextCharLength=pe;function Me(P,B){return new Le(P,B).prevGraphemeLength()}t.prevCharLength=Me;function De(P,B){B>0&&n(P.charCodeAt(B))&&B--;const V=B+pe(P,B);return[V-Me(P,V),V]}t.getCharContainingOffset=De;function Fe(P){const B=new Le(P);let V=0;for(;!B.eol();)V++,B.nextGraphemeLength();return V}t.charCount=Fe;let Ee;function Pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function te(P){return Ee||(Ee=Pe()),Ee.test(P)}t.containsRTL=te;const $=/^[\t\n\r\x20-\x7E]*$/;function Q(P){return $.test(P)}t.isBasicASCII=Q,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function S(P){return t.UNUSUAL_LINE_TERMINATORS.test(P)}t.containsUnusualLineTerminators=S;function T(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}t.isFullWidthCharacter=T;function C(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}t.isEmojiImprecise=C;function W(P,B){if(P.length<B)return P;const V=/\b/g;let j=0;for(;V.test(P)&&!(P.length-V.lastIndex<B);)j=V.lastIndex,V.lastIndex+=1;return P.substring(j).replace(/^\s/,"")}t.lcut=W;const x=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function oe(P){return P&&(P=P.replace(x,""),P=P.replace(ie,""),P=P.replace(re,"")),P}t.removeAnsiEscapeCodes=oe,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ae;function fe(P){return ae(P)?P.substr(1):P}t.stripUTF8BOM=fe;function he(P,B){if(!P||!B||P.length<B.length)return!1;const V=B.length,j=P.toLowerCase();let G=0,se=-1;for(;G<V;){const ce=j.indexOf(B[G],se+1);if(ce<0)return!1;se=ce,G++}return!0}t.fuzzyContains=he;function Se(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}t.containsUppercaseCharacter=Se;function Be(P){return P.charAt(0).toUpperCase()+P.slice(1)}t.uppercaseFirstLetter=Be;function qe(P,B=1){if(B===0)return"";let V=-1;do V=P.indexOf(`
`,V+1),B--;while(B>0&&V>=0);return V===-1?P:(P[V-1]==="\r"&&V--,P.substr(0,V))}t.getNLines=qe;function We(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}t.singleLetterHash=We;function Ve(P){return we.getInstance().getGraphemeBreakType(P)}t.getGraphemeBreakType=Ve;function Te(P,B){return P===0?B!==5&&B!==7:P===2&&B===3?!1:P===4||P===2||P===3||B===4||B===2||B===3?!0:!(P===8&&(B===8||B===9||B===11||B===12)||(P===11||P===9)&&(B===9||B===10)||(P===12||P===10)&&B===10||B===5||B===13||B===7||P===1||P===13&&B===14||P===6&&B===6)}var He;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(He=t.GraphemeBreakType||(t.GraphemeBreakType={}));class we{static getInstance(){return we._INSTANCE||(we._INSTANCE=new we),we._INSTANCE}constructor(){this._data=xe()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const V=this._data,j=V.length/3;let G=1;for(;G<=j;)if(B<V[3*G])G=2*G;else if(B>V[3*G+1])G=2*G+1;else return V[3*G+2];return 0}}we._INSTANCE=null;function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(P,B){if(P===0)return 0;const V=je(P,B);if(V!==void 0)return V;const j=new Ae(B,P);return j.prevCodePoint(),j.offset}t.getLeftDeleteOffset=ze;function je(P,B){const V=new Ae(B,P);let j=V.prevCodePoint();for(;$e(j)||j===65039||j===8419;){if(V.offset===0)return;j=V.prevCodePoint()}if(!C(j))return;let G=V.offset;return G>0&&V.prevCodePoint()===8205&&(G=V.offset),G}function $e(P){return 127995<=P&&P<=127999}var Ce;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={})),t.noBreakWhitespace="\xA0";class me{static getInstance(B){return me.cache.get(Array.from(B))}static getLocales(){return me._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}i=me,me.ambiguousCharacterData=new k.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),me.cache=new D.LRUCachedFunction(P=>{function B(le){const ge=new Map;for(let _e=0;_e<le.length;_e+=2)ge.set(le[_e],le[_e+1]);return ge}function V(le,ge){const _e=new Map(le);for(const[ke,Ie]of ge)_e.set(ke,Ie);return _e}function j(le,ge){if(!le)return ge;const _e=new Map;for(const[ke,Ie]of le)ge.has(ke)&&_e.set(ke,Ie);return _e}const G=i.ambiguousCharacterData.value;let se=P.filter(le=>!le.startsWith("_")&&le in G);se.length===0&&(se=["_default"]);let ce;for(const le of se){const ge=B(G[le]);ce=j(ce,ge)}const ye=B(G._common),be=V(ye,ce);return new me(be)}),me._locales=new k.Lazy(()=>Object.keys(me.ambiguousCharacterData.value).filter(P=>!P.startsWith("_"))),t.AmbiguousCharacters=me;class Re{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Re.getRawData())),this._data}static isInvisibleCharacter(B){return Re.getData().has(B)}static get codePoints(){return Re.getData()}}Re._data=void 0,t.InvisibleCharacters=Re}),Y(Z[46],K([0,1,4]),function(q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function k(E){return i(E,0)}t.hash=k;function i(E,L){switch(typeof E){case"object":return E===null?u(349,L):Array.isArray(E)?a(E,L):f(E,L);case"string":return b(E,L);case"boolean":return y(E,L);case"number":return u(E,L);case"undefined":return u(937,L);default:return u(617,L)}}t.doHash=i;function u(E,L){return(L<<5)-L+E|0}t.numberHash=u;function y(E,L){return u(E?433:863,L)}function b(E,L){L=u(149417,L);for(let g=0,m=E.length;g<m;g++)L=u(E.charCodeAt(g),L);return L}t.stringHash=b;function a(E,L){return L=u(104579,L),E.reduce((g,m)=>i(m,g),L)}function f(E,L){return L=u(181387,L),Object.keys(E).sort().reduce((g,m)=>(g=b(m,g),i(E[m],g)),L)}class N{constructor(){this._value=0}get value(){return this._value}hash(L){return this._value=i(L,this._value),this._value}}t.Hasher=N;var M;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function p(E,L,g=32){const m=g-L,l=~((1<<m)-1);return(E<<L|(l&E)>>>m)>>>0}function v(E,L=0,g=E.byteLength,m=0){for(let l=0;l<g;l++)E[L+l]=m}function e(E,L,g="0"){for(;E.length<L;)E=g+E;return E}function A(E,L=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(g=>g.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),L/4)}t.toHexString=A;class F{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(L){const g=L.length;if(g===0)return;const m=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,s,d;for(r!==0?(s=r,d=-1,r=0):(s=L.charCodeAt(0),d=0);;){let c=s;if(D.isHighSurrogate(s))if(d+1<g){const w=L.charCodeAt(d+1);D.isLowSurrogate(w)?(d++,c=D.computeCodePoint(s,w)):c=65533}else{r=s;break}else D.isLowSurrogate(s)&&(c=65533);if(l=this._push(m,l,c),d++,d<g)s=L.charCodeAt(d);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(L,g,m){return m<128?L[g++]=m:m<2048?(L[g++]=192|(m&1984)>>>6,L[g++]=128|(m&63)>>>0):m<65536?(L[g++]=224|(m&61440)>>>12,L[g++]=128|(m&4032)>>>6,L[g++]=128|(m&63)>>>0):(L[g++]=240|(m&1835008)>>>18,L[g++]=128|(m&258048)>>>12,L[g++]=128|(m&4032)>>>6,L[g++]=128|(m&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,L[0]=L[64+0],L[1]=L[64+1],L[2]=L[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),A(this._h0)+A(this._h1)+A(this._h2)+A(this._h3)+A(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const L=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(L/4294967296),!1),this._buffDV.setUint32(60,L%4294967296,!1),this._step()}_step(){const L=F._bigBlock32,g=this._buffDV;for(let h=0;h<64;h+=4)L.setUint32(h,g.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)L.setUint32(h,p(L.getUint32(h-12,!1)^L.getUint32(h-32,!1)^L.getUint32(h-56,!1)^L.getUint32(h-64,!1),1),!1);let m=this._h0,l=this._h1,r=this._h2,s=this._h3,d=this._h4,c,w,_;for(let h=0;h<80;h++)h<20?(c=l&r|~l&s,w=1518500249):h<40?(c=l^r^s,w=1859775393):h<60?(c=l&r|l&s|r&s,w=2400959708):(c=l^r^s,w=3395469782),_=p(m,5)+c+d+w+L.getUint32(h*4,!1)&4294967295,d=s,s=r,r=p(l,30),l=m,m=_;this._h0=this._h0+m&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+d&4294967295}}F._bigBlock32=new DataView(new ArrayBuffer(320)),t.StringSHA1=F}),Y(Z[23],K([0,1,25,46]),function(q,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(p){this.source=p}getElements(){const p=this.source,v=new Int32Array(p.length);for(let e=0,A=p.length;e<A;e++)v[e]=p.charCodeAt(e);return v}}t.StringDiffSequence=i;function u(M,p,v){return new N(new i(M),new i(p)).ComputeDiff(v).changes}t.stringDiff=u;class y{static Assert(p,v){if(!p)throw new Error(v)}}class b{static Copy(p,v,e,A,F){for(let E=0;E<F;E++)e[A+E]=p[v+E]}static Copy2(p,v,e,A,F){for(let E=0;E<F;E++)e[A+E]=p[v+E]}}var a;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class f{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new D.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(p,v){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,v),this.m_originalCount++}AddModifiedElement(p,v){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,v),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class N{constructor(p,v,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=p,this._modifiedSequence=v;const[A,F,E]=N._getElements(p),[L,g,m]=N._getElements(v);this._hasStrings=E&&m,this._originalStringElements=A,this._originalElementsOrHash=F,this._modifiedStringElements=L,this._modifiedElementsOrHash=g,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(p){return p.length>0&&typeof p[0]=="string"}static _getElements(p){const v=p.getElements();if(N._isStringArray(v)){const e=new Int32Array(v.length);for(let A=0,F=v.length;A<F;A++)e[A]=(0,k.stringHash)(v[A],0);return[v,e,!0]}return v instanceof Int32Array?[[],v,!1]:[[],new Int32Array(v),!1]}ElementsAreEqual(p,v){return this._originalElementsOrHash[p]!==this._modifiedElementsOrHash[v]?!1:this._hasStrings?this._originalStringElements[p]===this._modifiedStringElements[v]:!0}ElementsAreStrictEqual(p,v){if(!this.ElementsAreEqual(p,v))return!1;const e=N._getStrictElement(this._originalSequence,p),A=N._getStrictElement(this._modifiedSequence,v);return e===A}static _getStrictElement(p,v){return typeof p.getStrictElement=="function"?p.getStrictElement(v):null}OriginalElementsAreEqual(p,v){return this._originalElementsOrHash[p]!==this._originalElementsOrHash[v]?!1:this._hasStrings?this._originalStringElements[p]===this._originalStringElements[v]:!0}ModifiedElementsAreEqual(p,v){return this._modifiedElementsOrHash[p]!==this._modifiedElementsOrHash[v]?!1:this._hasStrings?this._modifiedStringElements[p]===this._modifiedStringElements[v]:!0}ComputeDiff(p){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,p)}_ComputeDiff(p,v,e,A,F){const E=[!1];let L=this.ComputeDiffRecursive(p,v,e,A,E);return F&&(L=this.PrettifyChanges(L)),{quitEarly:E[0],changes:L}}ComputeDiffRecursive(p,v,e,A,F){for(F[0]=!1;p<=v&&e<=A&&this.ElementsAreEqual(p,e);)p++,e++;for(;v>=p&&A>=e&&this.ElementsAreEqual(v,A);)v--,A--;if(p>v||e>A){let r;return e<=A?(y.Assert(p===v+1,"originalStart should only be one more than originalEnd"),r=[new D.DiffChange(p,0,e,A-e+1)]):p<=v?(y.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[new D.DiffChange(p,v-p+1,e,0)]):(y.Assert(p===v+1,"originalStart should only be one more than originalEnd"),y.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const E=[0],L=[0],g=this.ComputeRecursionPoint(p,v,e,A,E,L,F),m=E[0],l=L[0];if(g!==null)return g;if(!F[0]){const r=this.ComputeDiffRecursive(p,m,e,l,F);let s=[];return F[0]?s=[new D.DiffChange(m+1,v-(m+1)+1,l+1,A-(l+1)+1)]:s=this.ComputeDiffRecursive(m+1,v,l+1,A,F),this.ConcatenateChanges(r,s)}return[new D.DiffChange(p,v-p+1,e,A-e+1)]}WALKTRACE(p,v,e,A,F,E,L,g,m,l,r,s,d,c,w,_,h,o){let R=null,I=null,O=new f,U=v,H=e,z=d[0]-_[0]-A,ee=-1073741824,ne=this.m_forwardHistory.length-1;do{const X=z+p;X===U||X<H&&m[X-1]<m[X+1]?(r=m[X+1],c=r-z-A,r<ee&&O.MarkNextChange(),ee=r,O.AddModifiedElement(r+1,c),z=X+1-p):(r=m[X-1]+1,c=r-z-A,r<ee&&O.MarkNextChange(),ee=r-1,O.AddOriginalElement(r,c+1),z=X-1-p),ne>=0&&(m=this.m_forwardHistory[ne],p=m[0],U=1,H=m.length-1)}while(--ne>=-1);if(R=O.getReverseChanges(),o[0]){let X=d[0]+1,J=_[0]+1;if(R!==null&&R.length>0){const n=R[R.length-1];X=Math.max(X,n.getOriginalEnd()),J=Math.max(J,n.getModifiedEnd())}I=[new D.DiffChange(X,s-X+1,J,w-J+1)]}else{O=new f,U=E,H=L,z=d[0]-_[0]-g,ee=1073741824,ne=h?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const X=z+F;X===U||X<H&&l[X-1]>=l[X+1]?(r=l[X+1]-1,c=r-z-g,r>ee&&O.MarkNextChange(),ee=r+1,O.AddOriginalElement(r+1,c+1),z=X+1-F):(r=l[X-1],c=r-z-g,r>ee&&O.MarkNextChange(),ee=r,O.AddModifiedElement(r+1,c+1),z=X-1-F),ne>=0&&(l=this.m_reverseHistory[ne],F=l[0],U=1,H=l.length-1)}while(--ne>=-1);I=O.getChanges()}return this.ConcatenateChanges(R,I)}ComputeRecursionPoint(p,v,e,A,F,E,L){let g=0,m=0,l=0,r=0,s=0,d=0;p--,e--,F[0]=0,E[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const c=v-p+(A-e),w=c+1,_=new Int32Array(w),h=new Int32Array(w),o=A-e,R=v-p,I=p-e,O=v-A,H=(R-o)%2===0;_[o]=p,h[R]=v,L[0]=!1;for(let z=1;z<=c/2+1;z++){let ee=0,ne=0;l=this.ClipDiagonalBound(o-z,z,o,w),r=this.ClipDiagonalBound(o+z,z,o,w);for(let J=l;J<=r;J+=2){J===l||J<r&&_[J-1]<_[J+1]?g=_[J+1]:g=_[J-1]+1,m=g-(J-o)-I;const n=g;for(;g<v&&m<A&&this.ElementsAreEqual(g+1,m+1);)g++,m++;if(_[J]=g,g+m>ee+ne&&(ee=g,ne=m),!H&&Math.abs(J-R)<=z-1&&g>=h[J])return F[0]=g,E[0]=m,n<=h[J]&&1447>0&&z<=1447+1?this.WALKTRACE(o,l,r,I,R,s,d,O,_,h,g,v,F,m,A,E,H,L):null}const X=(ee-p+(ne-e)-z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ee,X))return L[0]=!0,F[0]=ee,E[0]=ne,X>0&&1447>0&&z<=1447+1?this.WALKTRACE(o,l,r,I,R,s,d,O,_,h,g,v,F,m,A,E,H,L):(p++,e++,[new D.DiffChange(p,v-p+1,e,A-e+1)]);s=this.ClipDiagonalBound(R-z,z,R,w),d=this.ClipDiagonalBound(R+z,z,R,w);for(let J=s;J<=d;J+=2){J===s||J<d&&h[J-1]>=h[J+1]?g=h[J+1]-1:g=h[J-1],m=g-(J-R)-O;const n=g;for(;g>p&&m>e&&this.ElementsAreEqual(g,m);)g--,m--;if(h[J]=g,H&&Math.abs(J-o)<=z&&g<=_[J])return F[0]=g,E[0]=m,n>=_[J]&&1447>0&&z<=1447+1?this.WALKTRACE(o,l,r,I,R,s,d,O,_,h,g,v,F,m,A,E,H,L):null}if(z<=1447){let J=new Int32Array(r-l+2);J[0]=o-l+1,b.Copy2(_,l,J,1,r-l+1),this.m_forwardHistory.push(J),J=new Int32Array(d-s+2),J[0]=R-s+1,b.Copy2(h,s,J,1,d-s+1),this.m_reverseHistory.push(J)}}return this.WALKTRACE(o,l,r,I,R,s,d,O,_,h,g,v,F,m,A,E,H,L)}PrettifyChanges(p){for(let v=0;v<p.length;v++){const e=p[v],A=v<p.length-1?p[v+1].originalStart:this._originalElementsOrHash.length,F=v<p.length-1?p[v+1].modifiedStart:this._modifiedElementsOrHash.length,E=e.originalLength>0,L=e.modifiedLength>0;for(;e.originalStart+e.originalLength<A&&e.modifiedStart+e.modifiedLength<F&&(!E||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!L||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const m=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!m)break;e.originalStart++,e.modifiedStart++}const g=[null];if(v<p.length-1&&this.ChangesOverlap(p[v],p[v+1],g)){p[v]=g[0],p.splice(v+1,1),v--;continue}}for(let v=p.length-1;v>=0;v--){const e=p[v];let A=0,F=0;if(v>0){const r=p[v-1];A=r.originalStart+r.originalLength,F=r.modifiedStart+r.modifiedLength}const E=e.originalLength>0,L=e.modifiedLength>0;let g=0,m=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const s=e.originalStart-r,d=e.modifiedStart-r;if(s<A||d<F||E&&!this.OriginalElementsAreEqual(s,s+e.originalLength)||L&&!this.ModifiedElementsAreEqual(d,d+e.modifiedLength))break;const w=(s===A&&d===F?5:0)+this._boundaryScore(s,e.originalLength,d,e.modifiedLength);w>m&&(m=w,g=r)}e.originalStart-=g,e.modifiedStart-=g;const l=[null];if(v>0&&this.ChangesOverlap(p[v-1],p[v],l)){p[v-1]=l[0],p.splice(v,1),v++;continue}}if(this._hasStrings)for(let v=1,e=p.length;v<e;v++){const A=p[v-1],F=p[v],E=F.originalStart-A.originalStart-A.originalLength,L=A.originalStart,g=F.originalStart+F.originalLength,m=g-L,l=A.modifiedStart,r=F.modifiedStart+F.modifiedLength,s=r-l;if(E<5&&m<20&&s<20){const d=this._findBetterContiguousSequence(L,m,l,s,E);if(d){const[c,w]=d;(c!==A.originalStart+A.originalLength||w!==A.modifiedStart+A.modifiedLength)&&(A.originalLength=c-A.originalStart,A.modifiedLength=w-A.modifiedStart,F.originalStart=c+E,F.modifiedStart=w+E,F.originalLength=g-F.originalStart,F.modifiedLength=r-F.modifiedStart)}}}return p}_findBetterContiguousSequence(p,v,e,A,F){if(v<F||A<F)return null;const E=p+v-F+1,L=e+A-F+1;let g=0,m=0,l=0;for(let r=p;r<E;r++)for(let s=e;s<L;s++){const d=this._contiguousSequenceScore(r,s,F);d>0&&d>g&&(g=d,m=r,l=s)}return g>0?[m,l]:null}_contiguousSequenceScore(p,v,e){let A=0;for(let F=0;F<e;F++){if(!this.ElementsAreEqual(p+F,v+F))return 0;A+=this._originalStringElements[p+F].length}return A}_OriginalIsBoundary(p){return p<=0||p>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[p])}_OriginalRegionIsBoundary(p,v){if(this._OriginalIsBoundary(p)||this._OriginalIsBoundary(p-1))return!0;if(v>0){const e=p+v;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(p){return p<=0||p>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[p])}_ModifiedRegionIsBoundary(p,v){if(this._ModifiedIsBoundary(p)||this._ModifiedIsBoundary(p-1))return!0;if(v>0){const e=p+v;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(p,v,e,A){const F=this._OriginalRegionIsBoundary(p,v)?1:0,E=this._ModifiedRegionIsBoundary(e,A)?1:0;return F+E}ConcatenateChanges(p,v){const e=[];if(p.length===0||v.length===0)return v.length>0?v:p;if(this.ChangesOverlap(p[p.length-1],v[0],e)){const A=new Array(p.length+v.length-1);return b.Copy(p,0,A,0,p.length-1),A[p.length-1]=e[0],b.Copy(v,1,A,p.length,v.length-1),A}else{const A=new Array(p.length+v.length);return b.Copy(p,0,A,0,p.length),b.Copy(v,0,A,p.length,v.length),A}}ChangesOverlap(p,v,e){if(y.Assert(p.originalStart<=v.originalStart,"Left change is not less than or equal to right change"),y.Assert(p.modifiedStart<=v.modifiedStart,"Left change is not less than or equal to right change"),p.originalStart+p.originalLength>=v.originalStart||p.modifiedStart+p.modifiedLength>=v.modifiedStart){const A=p.originalStart;let F=p.originalLength;const E=p.modifiedStart;let L=p.modifiedLength;return p.originalStart+p.originalLength>=v.originalStart&&(F=v.originalStart+v.originalLength-p.originalStart),p.modifiedStart+p.modifiedLength>=v.modifiedStart&&(L=v.modifiedStart+v.modifiedLength-p.modifiedStart),e[0]=new D.DiffChange(A,F,E,L),!0}else return e[0]=null,!1}ClipDiagonalBound(p,v,e,A){if(p>=0&&p<A)return p;const F=e,E=A-e-1,L=v%2===0;if(p<0){const g=F%2===0;return L===g?0:1}else{const g=E%2===0;return L===g?A-1:A-2}}}t.LcsDiff=N}),Y(Z[12],K([0,1,44,5]),function(q,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,y=/^\/\//;function b(d,c){if(!d.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!i.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!u.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,c){return!d&&!c?"file":d}function f(d,c){switch(d){case"https":case"http":case"file":c?c[0]!==M&&(c=M+c):c=M;break}return c}const N="",M="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(c){return c instanceof v?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,w,_,h,o,R=!1){typeof c=="object"?(this.scheme=c.scheme||N,this.authority=c.authority||N,this.path=c.path||N,this.query=c.query||N,this.fragment=c.fragment||N):(this.scheme=a(c,R),this.authority=w||N,this.path=f(this.scheme,_||N),this.query=h||N,this.fragment=o||N,b(this,R))}get fsPath(){return g(this,!1)}with(c){if(!c)return this;let{scheme:w,authority:_,path:h,query:o,fragment:R}=c;return w===void 0?w=this.scheme:w===null&&(w=N),_===void 0?_=this.authority:_===null&&(_=N),h===void 0?h=this.path:h===null&&(h=N),o===void 0?o=this.query:o===null&&(o=N),R===void 0?R=this.fragment:R===null&&(R=N),w===this.scheme&&_===this.authority&&h===this.path&&o===this.query&&R===this.fragment?this:new A(w,_,h,o,R)}static parse(c,w=!1){const _=p.exec(c);return _?new A(_[2]||N,s(_[4]||N),s(_[5]||N),s(_[7]||N),s(_[9]||N),w):new A(N,N,N,N,N)}static file(c){let w=N;if(k.isWindows&&(c=c.replace(/\\/g,M)),c[0]===M&&c[1]===M){const _=c.indexOf(M,2);_===-1?(w=c.substring(2),c=M):(w=c.substring(2,_),c=c.substring(_)||M)}return new A("file",w,c,N,N)}static from(c){const w=new A(c.scheme,c.authority,c.path,c.query,c.fragment);return b(w,!0),w}static joinPath(c,...w){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let _;return k.isWindows&&c.scheme==="file"?_=v.file(D.win32.join(g(c,!0),...w)).path:_=D.posix.join(c.path,...w),c.with({path:_})}toString(c=!1){return m(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof v)return c;{const w=new A(c);return w._formatted=c.external,w._fsPath=c._sep===e?c.fsPath:null,w}}else return c}}t.URI=v;const e=k.isWindows?1:void 0;class A extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(c=!1){return c?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=e),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const F={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(d,c,w){let _,h=-1;for(let o=0;o<d.length;o++){const R=d.charCodeAt(o);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||c&&R===47||w&&R===91||w&&R===93||w&&R===58)h!==-1&&(_+=encodeURIComponent(d.substring(h,o)),h=-1),_!==void 0&&(_+=d.charAt(o));else{_===void 0&&(_=d.substr(0,o));const I=F[R];I!==void 0?(h!==-1&&(_+=encodeURIComponent(d.substring(h,o)),h=-1),_+=I):h===-1&&(h=o)}}return h!==-1&&(_+=encodeURIComponent(d.substring(h))),_!==void 0?_:d}function L(d){let c;for(let w=0;w<d.length;w++){const _=d.charCodeAt(w);_===35||_===63?(c===void 0&&(c=d.substr(0,w)),c+=F[_]):c!==void 0&&(c+=d[w])}return c!==void 0?c:d}function g(d,c){let w;return d.authority&&d.path.length>1&&d.scheme==="file"?w=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?c?w=d.path.substr(1):w=d.path[1].toLowerCase()+d.path.substr(2):w=d.path,k.isWindows&&(w=w.replace(/\//g,"\\")),w}t.uriToFsPath=g;function m(d,c){const w=c?L:E;let _="",{scheme:h,authority:o,path:R,query:I,fragment:O}=d;if(h&&(_+=h,_+=":"),(o||h==="file")&&(_+=M,_+=M),o){let U=o.indexOf("@");if(U!==-1){const H=o.substr(0,U);o=o.substr(U+1),U=H.lastIndexOf(":"),U===-1?_+=w(H,!1,!1):(_+=w(H.substr(0,U),!1,!1),_+=":",_+=w(H.substr(U+1),!1,!0)),_+="@"}o=o.toLowerCase(),U=o.lastIndexOf(":"),U===-1?_+=w(o,!1,!0):(_+=w(o.substr(0,U),!1,!0),_+=o.substr(U))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const U=R.charCodeAt(1);U>=65&&U<=90&&(R=`/${String.fromCharCode(U+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const U=R.charCodeAt(0);U>=65&&U<=90&&(R=`${String.fromCharCode(U+32)}:${R.substr(2)}`)}_+=w(R,!0,!1)}return I&&(_+="?",_+=w(I,!1,!1)),O&&(_+="#",_+=c?O:E(O,!1,!1)),_}function l(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+l(d.substr(3)):d}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(d){return d.match(r)?d.replace(r,c=>l(c)):d}}),Y(Z[57],K([0,1,6,9,7,11,5,4]),function(q,t,D,k,i,u,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let f=!1;function N(d){!y.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(d.message))}t.logOnceWebWorkerWarning=N;var M;(function(d){d[d.Request=0]="Request",d[d.Reply=1]="Reply",d[d.SubscribeEvent=2]="SubscribeEvent",d[d.Event=3]="Event",d[d.UnsubscribeEvent=4]="UnsubscribeEvent"})(M||(M={}));class p{constructor(c,w,_,h){this.vsWorker=c,this.req=w,this.method=_,this.args=h,this.type=0}}class v{constructor(c,w,_,h){this.vsWorker=c,this.seq=w,this.res=_,this.err=h,this.type=1}}class e{constructor(c,w,_,h){this.vsWorker=c,this.req=w,this.eventName=_,this.arg=h,this.type=2}}class A{constructor(c,w,_){this.vsWorker=c,this.req=w,this.event=_,this.type=3}}class F{constructor(c,w){this.vsWorker=c,this.req=w,this.type=4}}class E{constructor(c){this._workerId=-1,this._handler=c,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(c){this._workerId=c}sendMessage(c,w){const _=String(++this._lastSentReq);return new Promise((h,o)=>{this._pendingReplies[_]={resolve:h,reject:o},this._send(new p(this._workerId,_,c,w))})}listen(c,w){let _=null;const h=new k.Emitter({onWillAddFirstListener:()=>{_=String(++this._lastSentReq),this._pendingEmitters.set(_,h),this._send(new e(this._workerId,_,c,w))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(_),this._send(new F(this._workerId,_)),_=null}});return h.event}handleMessage(c){!c||!c.vsWorker||this._workerId!==-1&&c.vsWorker!==this._workerId||this._handleMessage(c)}_handleMessage(c){switch(c.type){case 1:return this._handleReplyMessage(c);case 0:return this._handleRequestMessage(c);case 2:return this._handleSubscribeEventMessage(c);case 3:return this._handleEventMessage(c);case 4:return this._handleUnsubscribeEventMessage(c)}}_handleReplyMessage(c){if(!this._pendingReplies[c.seq]){console.warn("Got reply to unknown seq");return}const w=this._pendingReplies[c.seq];if(delete this._pendingReplies[c.seq],c.err){let _=c.err;c.err.$isError&&(_=new Error,_.name=c.err.name,_.message=c.err.message,_.stack=c.err.stack),w.reject(_);return}w.resolve(c.res)}_handleRequestMessage(c){const w=c.req;this._handler.handleMessage(c.method,c.args).then(h=>{this._send(new v(this._workerId,w,h,void 0))},h=>{h.detail instanceof Error&&(h.detail=(0,D.transformErrorForSerialization)(h.detail)),this._send(new v(this._workerId,w,void 0,(0,D.transformErrorForSerialization)(h)))})}_handleSubscribeEventMessage(c){const w=c.req,_=this._handler.handleEvent(c.eventName,c.arg)(h=>{this._send(new A(this._workerId,w,h))});this._pendingEvents.set(w,_)}_handleEventMessage(c){if(!this._pendingEmitters.has(c.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(c.req).fire(c.event)}_handleUnsubscribeEventMessage(c){if(!this._pendingEvents.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(c.req).dispose(),this._pendingEvents.delete(c.req)}_send(c){const w=[];if(c.type===0)for(let _=0;_<c.args.length;_++)c.args[_]instanceof ArrayBuffer&&w.push(c.args[_]);else c.type===1&&c.res instanceof ArrayBuffer&&w.push(c.res);this._handler.sendMessage(c,w)}}class L extends i.Disposable{constructor(c,w,_){super();let h=null;this._worker=this._register(c.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{h?.(U)})),this._protocol=new E({sendMessage:(U,H)=>{this._worker.postMessage(U,H)},handleMessage:(U,H)=>{if(typeof _[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(_[U].apply(_,H))}catch(z){return Promise.reject(z)}},handleEvent:(U,H)=>{if(m(U)){const z=_[U].call(_,H);if(typeof z!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return z}if(g(U)){const z=_[U];if(typeof z!="function")throw new Error(`Missing event ${U} on main thread host.`);return z}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let o=null;typeof y.globals.require<"u"&&typeof y.globals.require.getConfig=="function"?o=y.globals.require.getConfig():typeof y.globals.requirejs<"u"&&(o=y.globals.requirejs.s.contexts._.config);const R=(0,u.getAllMethodNames)(_);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(o)),w,R]);const I=(U,H)=>this._request(U,H),O=(U,H)=>this._protocol.listen(U,H);this._lazyProxy=new Promise((U,H)=>{h=H,this._onModuleLoaded.then(z=>{U(l(z,I,O))},z=>{H(z),this._onError("Worker failed to load "+w,z)})})}getProxyObject(){return this._lazyProxy}_request(c,w){return new Promise((_,h)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(c,w).then(_,h)},h)})}_onError(c,w){console.error(c),console.info(w)}}t.SimpleWorkerClient=L;function g(d){return d[0]==="o"&&d[1]==="n"&&b.isUpperAsciiLetter(d.charCodeAt(2))}function m(d){return/^onDynamic/.test(d)&&b.isUpperAsciiLetter(d.charCodeAt(9))}function l(d,c,w){const _=R=>function(){const I=Array.prototype.slice.call(arguments,0);return c(R,I)},h=R=>function(I){return w(R,I)},o={};for(const R of d){if(m(R)){o[R]=h(R);continue}if(g(R)){o[R]=w(R,void 0);continue}o[R]=_(R)}return o}class r{constructor(c,w){this._requestHandlerFactory=w,this._requestHandler=null,this._protocol=new E({sendMessage:(_,h)=>{c(_,h)},handleMessage:(_,h)=>this._handleMessage(_,h),handleEvent:(_,h)=>this._handleEvent(_,h)})}onmessage(c){this._protocol.handleMessage(c)}_handleMessage(c,w){if(c===a)return this.initialize(w[0],w[1],w[2],w[3]);if(!this._requestHandler||typeof this._requestHandler[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this._requestHandler[c].apply(this._requestHandler,w))}catch(_){return Promise.reject(_)}}_handleEvent(c,w){if(!this._requestHandler)throw new Error("Missing requestHandler");if(m(c)){const _=this._requestHandler[c].call(this._requestHandler,w);if(typeof _!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return _}if(g(c)){const _=this._requestHandler[c];if(typeof _!="function")throw new Error(`Missing event ${c} on request handler.`);return _}throw new Error(`Malformed event name ${c}`)}initialize(c,w,_,h){this._protocol.setWorkerId(c);const I=l(h,(O,U)=>this._protocol.sendMessage(O,U),(O,U)=>this._protocol.listen(O,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(I),Promise.resolve((0,u.getAllMethodNames)(this._requestHandler))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy!==void 0&&delete w.trustedTypesPolicy,w.catchError=!0,y.globals.require.config(w)),new Promise((O,U)=>{(y.globals.require||q)([_],z=>{if(this._requestHandler=z.create(I),!this._requestHandler){U(new Error("No RequestHandler!"));return}O((0,u.getAllMethodNames)(this._requestHandler))},U)}))}}t.SimpleWorkerServer=r;function s(d){return new r(d,null)}t.create=s}),Y(Z[24],K([0,1,23,20,4,2,10]),function(q,t,D,k,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const b=3;class a{computeDiff(m,l,r){const d=new A(m,l,{maxComputationTime:r.maxComputationTimeMs,shouldIgnoreTrimWhitespace:r.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),c=[];let w=null;for(const _ of d.changes){let h;_.originalEndLineNumber===0?h=new k.LineRange(_.originalStartLineNumber+1,_.originalStartLineNumber+1):h=new k.LineRange(_.originalStartLineNumber,_.originalEndLineNumber+1);let o;_.modifiedEndLineNumber===0?o=new k.LineRange(_.modifiedStartLineNumber+1,_.modifiedStartLineNumber+1):o=new k.LineRange(_.modifiedStartLineNumber,_.modifiedEndLineNumber+1);let R=new k.LineRangeMapping(h,o,_.charChanges?.map(I=>new k.RangeMapping(new u.Range(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new u.Range(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));w&&(w.modifiedRange.endLineNumberExclusive===R.modifiedRange.startLineNumber||w.originalRange.endLineNumberExclusive===R.originalRange.startLineNumber)&&(R=new k.LineRangeMapping(w.originalRange.join(R.originalRange),w.modifiedRange.join(R.modifiedRange),w.innerChanges&&R.innerChanges?w.innerChanges.concat(R.innerChanges):void 0),c.pop()),c.push(R),w=R}return(0,y.assertFn)(()=>(0,y.checkAdjacentItems)(c,(_,h)=>h.originalRange.startLineNumber-_.originalRange.endLineNumberExclusive===h.modifiedRange.startLineNumber-_.modifiedRange.endLineNumberExclusive&&_.originalRange.endLineNumberExclusive<h.originalRange.startLineNumber&&_.modifiedRange.endLineNumberExclusive<h.modifiedRange.startLineNumber)),{quitEarly:d.quitEarly,changes:c}}}t.SmartLinesDiffComputer=a;function f(g,m,l,r){return new D.LcsDiff(g,m,l).ComputeDiff(r)}class N{constructor(m){const l=[],r=[];for(let s=0,d=m.length;s<d;s++)l[s]=F(m[s],1),r[s]=E(m[s],1);this.lines=m,this._startColumns=l,this._endColumns=r}getElements(){const m=[];for(let l=0,r=this.lines.length;l<r;l++)m[l]=this.lines[l].substring(this._startColumns[l]-1,this._endColumns[l]-1);return m}getStrictElement(m){return this.lines[m]}getStartLineNumber(m){return m+1}getEndLineNumber(m){return m+1}createCharSequence(m,l,r){const s=[],d=[],c=[];let w=0;for(let _=l;_<=r;_++){const h=this.lines[_],o=m?this._startColumns[_]:1,R=m?this._endColumns[_]:h.length+1;for(let I=o;I<R;I++)s[w]=h.charCodeAt(I-1),d[w]=_+1,c[w]=I,w++;!m&&_<r&&(s[w]=10,d[w]=_+1,c[w]=h.length+1,w++)}return new M(s,d,c)}}class M{constructor(m,l,r){this._charCodes=m,this._lineNumbers=l,this._columns=r}toString(){return"["+this._charCodes.map((m,l)=>(m===10?"\\n":String.fromCharCode(m))+`-(${this._lineNumbers[l]},${this._columns[l]})`).join(", ")+"]"}_assertIndex(m,l){if(m<0||m>=l.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(m){return m>0&&m===this._lineNumbers.length?this.getEndLineNumber(m-1):(this._assertIndex(m,this._lineNumbers),this._lineNumbers[m])}getEndLineNumber(m){return m===-1?this.getStartLineNumber(m+1):(this._assertIndex(m,this._lineNumbers),this._charCodes[m]===10?this._lineNumbers[m]+1:this._lineNumbers[m])}getStartColumn(m){return m>0&&m===this._columns.length?this.getEndColumn(m-1):(this._assertIndex(m,this._columns),this._columns[m])}getEndColumn(m){return m===-1?this.getStartColumn(m+1):(this._assertIndex(m,this._columns),this._charCodes[m]===10?1:this._columns[m]+1)}}class p{constructor(m,l,r,s,d,c,w,_){this.originalStartLineNumber=m,this.originalStartColumn=l,this.originalEndLineNumber=r,this.originalEndColumn=s,this.modifiedStartLineNumber=d,this.modifiedStartColumn=c,this.modifiedEndLineNumber=w,this.modifiedEndColumn=_}static createFromDiffChange(m,l,r){const s=l.getStartLineNumber(m.originalStart),d=l.getStartColumn(m.originalStart),c=l.getEndLineNumber(m.originalStart+m.originalLength-1),w=l.getEndColumn(m.originalStart+m.originalLength-1),_=r.getStartLineNumber(m.modifiedStart),h=r.getStartColumn(m.modifiedStart),o=r.getEndLineNumber(m.modifiedStart+m.modifiedLength-1),R=r.getEndColumn(m.modifiedStart+m.modifiedLength-1);return new p(s,d,c,w,_,h,o,R)}}function v(g){if(g.length<=1)return g;const m=[g[0]];let l=m[0];for(let r=1,s=g.length;r<s;r++){const d=g[r],c=d.originalStart-(l.originalStart+l.originalLength),w=d.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(c,w)<b?(l.originalLength=d.originalStart+d.originalLength-l.originalStart,l.modifiedLength=d.modifiedStart+d.modifiedLength-l.modifiedStart):(m.push(d),l=d)}return m}class e{constructor(m,l,r,s,d){this.originalStartLineNumber=m,this.originalEndLineNumber=l,this.modifiedStartLineNumber=r,this.modifiedEndLineNumber=s,this.charChanges=d}static createFromDiffResult(m,l,r,s,d,c,w){let _,h,o,R,I;if(l.originalLength===0?(_=r.getStartLineNumber(l.originalStart)-1,h=0):(_=r.getStartLineNumber(l.originalStart),h=r.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(o=s.getStartLineNumber(l.modifiedStart)-1,R=0):(o=s.getStartLineNumber(l.modifiedStart),R=s.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),c&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&d()){const O=r.createCharSequence(m,l.originalStart,l.originalStart+l.originalLength-1),U=s.createCharSequence(m,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(O.getElements().length>0&&U.getElements().length>0){let H=f(O,U,d,!0).changes;w&&(H=v(H)),I=[];for(let z=0,ee=H.length;z<ee;z++)I.push(p.createFromDiffChange(H[z],O,U))}}return new e(_,h,o,R,I)}}class A{constructor(m,l,r){this.shouldComputeCharChanges=r.shouldComputeCharChanges,this.shouldPostProcessCharChanges=r.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=r.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=r.shouldMakePrettyDiff,this.originalLines=m,this.modifiedLines=l,this.original=new N(m),this.modified=new N(l),this.continueLineDiff=L(r.maxComputationTime),this.continueCharDiff=L(r.maxComputationTime===0?0:Math.min(r.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const m=f(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),l=m.changes,r=m.quitEarly;if(this.shouldIgnoreTrimWhitespace){const w=[];for(let _=0,h=l.length;_<h;_++)w.push(e.createFromDiffResult(this.shouldIgnoreTrimWhitespace,l[_],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:r,changes:w}}const s=[];let d=0,c=0;for(let w=-1,_=l.length;w<_;w++){const h=w+1<_?l[w+1]:null,o=h?h.originalStart:this.originalLines.length,R=h?h.modifiedStart:this.modifiedLines.length;for(;d<o&&c<R;){const I=this.originalLines[d],O=this.modifiedLines[c];if(I!==O){{let U=F(I,1),H=F(O,1);for(;U>1&&H>1;){const z=I.charCodeAt(U-2),ee=O.charCodeAt(H-2);if(z!==ee)break;U--,H--}(U>1||H>1)&&this._pushTrimWhitespaceCharChange(s,d+1,1,U,c+1,1,H)}{let U=E(I,1),H=E(O,1);const z=I.length+1,ee=O.length+1;for(;U<z&&H<ee;){const ne=I.charCodeAt(U-1),X=I.charCodeAt(H-1);if(ne!==X)break;U++,H++}(U<z||H<ee)&&this._pushTrimWhitespaceCharChange(s,d+1,U,z,c+1,H,ee)}}d++,c++}h&&(s.push(e.createFromDiffResult(this.shouldIgnoreTrimWhitespace,h,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),d+=h.originalLength,c+=h.modifiedLength)}return{quitEarly:r,changes:s}}_pushTrimWhitespaceCharChange(m,l,r,s,d,c,w){if(this._mergeTrimWhitespaceCharChange(m,l,r,s,d,c,w))return;let _;this.shouldComputeCharChanges&&(_=[new p(l,r,l,s,d,c,d,w)]),m.push(new e(l,l,d,d,_))}_mergeTrimWhitespaceCharChange(m,l,r,s,d,c,w){const _=m.length;if(_===0)return!1;const h=m[_-1];return h.originalEndLineNumber===0||h.modifiedEndLineNumber===0?!1:h.originalEndLineNumber===l&&h.modifiedEndLineNumber===d?(this.shouldComputeCharChanges&&h.charChanges&&h.charChanges.push(new p(l,r,l,s,d,c,d,w)),!0):h.originalEndLineNumber+1===l&&h.modifiedEndLineNumber+1===d?(h.originalEndLineNumber=l,h.modifiedEndLineNumber=d,this.shouldComputeCharChanges&&h.charChanges&&h.charChanges.push(new p(l,r,l,s,d,c,d,w)),!0):!1}}t.DiffComputer=A;function F(g,m){const l=i.firstNonWhitespaceIndex(g);return l===-1?m:l+1}function E(g,m){const l=i.lastNonWhitespaceIndex(g);return l===-1?m:l+2}function L(g){if(g===0)return()=>!0;const m=Date.now();return()=>Date.now()-m<g}}),Y(Z[47],K([0,1,24,36]),function(q,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={smart:new D.SmartLinesDiffComputer,experimental:new k.StandardLinesDiffComputer}}),Y(Z[48],K([0,1,4,3,40]),function(q,t,D,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class u{constructor(b,a,f,N){this._uri=b,this._lines=a,this._eol=f,this._versionId=N,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(b){b.eol&&b.eol!==this._eol&&(this._eol=b.eol,this._lineStarts=null);const a=b.changes;for(const f of a)this._acceptDeleteRange(f.range),this._acceptInsertText(new k.Position(f.range.startLineNumber,f.range.startColumn),f.text);this._versionId=b.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const b=this._eol.length,a=this._lines.length,f=new Uint32Array(a);for(let N=0;N<a;N++)f[N]=this._lines[N].length+b;this._lineStarts=new i.PrefixSumComputer(f)}}_setLineText(b,a){this._lines[b]=a,this._lineStarts&&this._lineStarts.setValue(b,this._lines[b].length+this._eol.length)}_acceptDeleteRange(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.startLineNumber-1].substring(b.endColumn-1));return}this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.endLineNumber-1].substring(b.endColumn-1)),this._lines.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}_acceptInsertText(b,a){if(a.length===0)return;const f=(0,D.splitLines)(a);if(f.length===1){this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+f[0]+this._lines[b.lineNumber-1].substring(b.column-1));return}f[f.length-1]+=this._lines[b.lineNumber-1].substring(b.column-1),this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+f[0]);const N=new Uint32Array(f.length-1);for(let M=1;M<f.length;M++)this._lines.splice(b.lineNumber+M-1,0,f[M]),N[M-1]=f[M].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(b.lineNumber,N)}}t.MirrorTextModel=u}),Y(Z[49],K([0,1,4,31,3,2,39]),function(q,t,D,k,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const b=999;class a{constructor(L,g,m,l){this.searchString=L,this.isRegex=g,this.matchCase=m,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=f(this.searchString):L=this.searchString.indexOf(`
`)>=0;let g=null;try{g=D.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!g)return null;let m=!this.isRegex&&!L;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new y.SearchData(g,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}t.SearchParams=a;function f(E){if(!E||E.length===0)return!1;for(let L=0,g=E.length;L<g;L++){const m=E.charCodeAt(L);if(m===10)return!0;if(m===92){if(L++,L>=g)break;const l=E.charCodeAt(L);if(l===110||l===114||l===87)return!0}}return!1}t.isMultilineRegexSource=f;function N(E,L,g){if(!g)return new y.FindMatch(E,null);const m=[];for(let l=0,r=L.length;l<r;l++)m[l]=L[l];return new y.FindMatch(E,m)}t.createFindMatch=N;class M{constructor(L){const g=[];let m=0;for(let l=0,r=L.length;l<r;l++)L.charCodeAt(l)===10&&(g[m++]=l);this._lineFeedsOffsets=g}findLineFeedCountBeforeOffset(L){const g=this._lineFeedsOffsets;let m=0,l=g.length-1;if(l===-1||L<=g[0])return 0;for(;m<l;){const r=m+((l-m)/2>>0);g[r]>=L?l=r-1:g[r+1]>=L?(m=r,l=r):m=r+1}return m+1}}class p{static findMatches(L,g,m,l,r){const s=g.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(L,m,new F(s.wordSeparators,s.regex),l,r):this._doFindMatchesLineByLine(L,m,s,l,r):[]}static _getMultilineMatchRange(L,g,m,l,r,s){let d,c=0;l?(c=l.findLineFeedCountBeforeOffset(r),d=g+r+c):d=g+r;let w;if(l){const R=l.findLineFeedCountBeforeOffset(r+s.length)-c;w=d+s.length+R}else w=d+s.length;const _=L.getPositionAt(d),h=L.getPositionAt(w);return new u.Range(_.lineNumber,_.column,h.lineNumber,h.column)}static _doFindMatchesMultiline(L,g,m,l,r){const s=L.getOffsetAt(g.getStartPosition()),d=L.getValueInRange(g,1),c=L.getEOL()===`\r
`?new M(d):null,w=[];let _=0,h;for(m.reset(0);h=m.next(d);)if(w[_++]=N(this._getMultilineMatchRange(L,s,d,c,h.index,h[0]),h,l),_>=r)return w;return w}static _doFindMatchesLineByLine(L,g,m,l,r){const s=[];let d=0;if(g.startLineNumber===g.endLineNumber){const w=L.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return d=this._findMatchesInLine(m,w,g.startLineNumber,g.startColumn-1,d,s,l,r),s}const c=L.getLineContent(g.startLineNumber).substring(g.startColumn-1);d=this._findMatchesInLine(m,c,g.startLineNumber,g.startColumn-1,d,s,l,r);for(let w=g.startLineNumber+1;w<g.endLineNumber&&d<r;w++)d=this._findMatchesInLine(m,L.getLineContent(w),w,0,d,s,l,r);if(d<r){const w=L.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);d=this._findMatchesInLine(m,w,g.endLineNumber,0,d,s,l,r)}return s}static _findMatchesInLine(L,g,m,l,r,s,d,c){const w=L.wordSeparators;if(!d&&L.simpleSearch){const o=L.simpleSearch,R=o.length,I=g.length;let O=-R;for(;(O=g.indexOf(o,O+R))!==-1;)if((!w||A(w,g,I,O,R))&&(s[r++]=new y.FindMatch(new u.Range(m,O+1+l,m,O+1+R+l),null),r>=c))return r;return r}const _=new F(L.wordSeparators,L.regex);let h;_.reset(0);do if(h=_.next(g),h&&(s[r++]=N(new u.Range(m,h.index+1+l,m,h.index+1+h[0].length+l),h,d),r>=c))return r;while(h);return r}static findNextMatch(L,g,m,l){const r=g.parseSearchRequest();if(!r)return null;const s=new F(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(L,m,s,l):this._doFindNextMatchLineByLine(L,m,s,l)}static _doFindNextMatchMultiline(L,g,m,l){const r=new i.Position(g.lineNumber,1),s=L.getOffsetAt(r),d=L.getLineCount(),c=L.getValueInRange(new u.Range(r.lineNumber,r.column,d,L.getLineMaxColumn(d)),1),w=L.getEOL()===`\r
`?new M(c):null;m.reset(g.column-1);const _=m.next(c);return _?N(this._getMultilineMatchRange(L,s,c,w,_.index,_[0]),_,l):g.lineNumber!==1||g.column!==1?this._doFindNextMatchMultiline(L,new i.Position(1,1),m,l):null}static _doFindNextMatchLineByLine(L,g,m,l){const r=L.getLineCount(),s=g.lineNumber,d=L.getLineContent(s),c=this._findFirstMatchInLine(m,d,s,g.column,l);if(c)return c;for(let w=1;w<=r;w++){const _=(s+w-1)%r,h=L.getLineContent(_+1),o=this._findFirstMatchInLine(m,h,_+1,1,l);if(o)return o}return null}static _findFirstMatchInLine(L,g,m,l,r){L.reset(l-1);const s=L.next(g);return s?N(new u.Range(m,s.index+1,m,s.index+1+s[0].length),s,r):null}static findPreviousMatch(L,g,m,l){const r=g.parseSearchRequest();if(!r)return null;const s=new F(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(L,m,s,l):this._doFindPreviousMatchLineByLine(L,m,s,l)}static _doFindPreviousMatchMultiline(L,g,m,l){const r=this._doFindMatchesMultiline(L,new u.Range(1,1,g.lineNumber,g.column),m,l,10*b);if(r.length>0)return r[r.length-1];const s=L.getLineCount();return g.lineNumber!==s||g.column!==L.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(L,new i.Position(s,L.getLineMaxColumn(s)),m,l):null}static _doFindPreviousMatchLineByLine(L,g,m,l){const r=L.getLineCount(),s=g.lineNumber,d=L.getLineContent(s).substring(0,g.column-1),c=this._findLastMatchInLine(m,d,s,l);if(c)return c;for(let w=1;w<=r;w++){const _=(r+s-w-1)%r,h=L.getLineContent(_+1),o=this._findLastMatchInLine(m,h,_+1,l);if(o)return o}return null}static _findLastMatchInLine(L,g,m,l){let r=null,s;for(L.reset(0);s=L.next(g);)r=N(new u.Range(m,s.index+1,m,s.index+1+s[0].length),s,l);return r}}t.TextModelSearch=p;function v(E,L,g,m,l){if(m===0)return!0;const r=L.charCodeAt(m-1);if(E.get(r)!==0||r===13||r===10)return!0;if(l>0){const s=L.charCodeAt(m);if(E.get(s)!==0)return!0}return!1}function e(E,L,g,m,l){if(m+l===g)return!0;const r=L.charCodeAt(m+l);if(E.get(r)!==0||r===13||r===10)return!0;if(l>0){const s=L.charCodeAt(m+l-1);if(E.get(s)!==0)return!0}return!1}function A(E,L,g,m,l){return v(E,L,g,m,l)&&e(E,L,g,m,l)}t.isValidMatch=A;class F{constructor(L,g){this._wordSeparators=L,this._searchRegex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(L){this._searchRegex.lastIndex=L,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(L){const g=L.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===g||(m=this._searchRegex.exec(L),!m))return null;const l=m.index,r=m[0].length;if(l===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){D.getNextCodePoint(L,g,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=l,this._prevMatchLength=r,!this._wordSeparators||A(this._wordSeparators,L,g,l,r))return m}while(m);return null}}t.Searcher=F}),Y(Z[50],K([0,1,2,49,4,10,19]),function(q,t,D,k,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class b{static computeUnicodeHighlights(e,A,F){const E=F?F.startLineNumber:1,L=F?F.endLineNumber:e.getLineCount(),g=new N(A),m=g.getCandidateCodePoints();let l;m==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(m))}`,"g");const r=new k.Searcher(null,l),s=[];let d=!1,c,w=0,_=0,h=0;e:for(let o=E,R=L;o<=R;o++){const I=e.getLineContent(o),O=I.length;r.reset(0);do if(c=r.next(I),c){let U=c.index,H=c.index+c[0].length;if(U>0){const X=I.charCodeAt(U-1);i.isHighSurrogate(X)&&U--}if(H+1<O){const X=I.charCodeAt(H-1);i.isHighSurrogate(X)&&H++}const z=I.substring(U,H);let ee=(0,y.getWordAtText)(U+1,y.DEFAULT_WORD_REGEXP,I,0);ee&&ee.endColumn<=U+1&&(ee=null);const ne=g.shouldHighlightNonBasicASCII(z,ee?ee.word:null);if(ne!==0){ne===3?w++:ne===2?_++:ne===1?h++:(0,u.assertNever)(ne);const X=1e3;if(s.length>=X){d=!0;break e}s.push(new D.Range(o,U+1,o,H+1))}}while(c)}return{ranges:s,hasMore:d,ambiguousCharacterCount:w,invisibleCharacterCount:_,nonBasicAsciiCharacterCount:h}}static computeUnicodeHighlightReason(e,A){const F=new N(A);switch(F.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const L=e.codePointAt(0),g=F.ambiguousCharacters.getPrimaryConfusable(L),m=i.AmbiguousCharacters.getLocales().filter(l=>!i.AmbiguousCharacters.getInstance(new Set([...A.allowedLocales,l])).isAmbiguous(L));return{kind:0,confusableWith:String.fromCodePoint(g),notAmbiguousInLocales:m}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=b;function a(v,e){return`[${i.escapeRegExpCharacters(v.map(F=>String.fromCodePoint(F)).join(""))}]`}var f;(function(v){v[v.Ambiguous=0]="Ambiguous",v[v.Invisible=1]="Invisible",v[v.NonBasicAscii=2]="NonBasicAscii"})(f=t.UnicodeHighlighterReasonKind||(t.UnicodeHighlighterReasonKind={}));class N{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const A of i.InvisibleCharacters.codePoints)M(String.fromCodePoint(A))||e.add(A);if(this.options.ambiguousCharacters)for(const A of this.ambiguousCharacters.getConfusableCodePoints())e.add(A);for(const A of this.allowedCodePoints)e.delete(A);return e}shouldHighlightNonBasicASCII(e,A){const F=e.codePointAt(0);if(this.allowedCodePoints.has(F))return 0;if(this.options.nonBasicASCII)return 1;let E=!1,L=!1;if(A)for(const g of A){const m=g.codePointAt(0),l=i.isBasicASCII(g);E=E||l,!l&&!this.ambiguousCharacters.isAmbiguous(m)&&!i.InvisibleCharacters.isInvisibleCharacter(m)&&(L=!0)}return!E&&L?0:this.options.invisibleCharacters&&!M(e)&&i.InvisibleCharacters.isInvisibleCharacter(F)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(F)?3:0}}function M(v){return v===" "||v===`
`||v==="	"}var p;(function(v){v[v.None=0]="None",v[v.NonBasicASCII=1]="NonBasicASCII",v[v.Invisible=2]="Invisible",v[v.Ambiguous=3]="Ambiguous"})(p||(p={}))}),Y(Z[51],K([0,1,9,7]),function(q,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(b){this._onDidChange.fire({changedLanguages:b,changedColorMap:!1})}register(b,a){return this._map.set(b,a),this.fire([b]),(0,k.toDisposable)(()=>{this._map.get(b)===a&&(this._map.delete(b),this.fire([b]))})}registerFactory(b,a){this._factories.get(b)?.dispose();const f=new u(this,b,a);return this._factories.set(b,f),(0,k.toDisposable)(()=>{const N=this._factories.get(b);!N||N!==f||(this._factories.delete(b),N.dispose())})}async getOrCreate(b){const a=this.get(b);if(a)return a;const f=this._factories.get(b);return!f||f.isResolved?null:(await f.resolve(),this.get(b))}get(b){return this._map.get(b)||null}isResolved(b){if(this.get(b))return!0;const f=this._factories.get(b);return!!(!f||f.isResolved)}setColorMap(b){this._colorMap=b,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=i;class u extends k.Disposable{get isResolved(){return this._isResolved}constructor(b,a,f){super(),this._registry=b,this._languageId=a,this._factory=f,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const b=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,b&&!this._isDisposed&&this._register(this._registry.register(this._languageId,b))}}}),Y(Z[52],K([0,1,29,12,2,51]),function(q,t,D,k,i,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.InlayHintKind=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class y{constructor(R,I,O){this._tokenBrand=void 0,this.offset=R,this.type=I,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=y;class b{constructor(R,I){this._tokenizationResultBrand=void 0,this.tokens=R,this.endState=I}}t.TokenizationResult=b;class a{constructor(R,I){this._encodedTokenizationResultBrand=void 0,this.tokens=R,this.endState=I}}t.EncodedTokenizationResult=a;var f;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(f=t.CompletionItemKind||(t.CompletionItemKind={}));var N;(function(o){const R=new Map;R.set(0,D.Codicon.symbolMethod),R.set(1,D.Codicon.symbolFunction),R.set(2,D.Codicon.symbolConstructor),R.set(3,D.Codicon.symbolField),R.set(4,D.Codicon.symbolVariable),R.set(5,D.Codicon.symbolClass),R.set(6,D.Codicon.symbolStruct),R.set(7,D.Codicon.symbolInterface),R.set(8,D.Codicon.symbolModule),R.set(9,D.Codicon.symbolProperty),R.set(10,D.Codicon.symbolEvent),R.set(11,D.Codicon.symbolOperator),R.set(12,D.Codicon.symbolUnit),R.set(13,D.Codicon.symbolValue),R.set(15,D.Codicon.symbolEnum),R.set(14,D.Codicon.symbolConstant),R.set(15,D.Codicon.symbolEnum),R.set(16,D.Codicon.symbolEnumMember),R.set(17,D.Codicon.symbolKeyword),R.set(27,D.Codicon.symbolSnippet),R.set(18,D.Codicon.symbolText),R.set(19,D.Codicon.symbolColor),R.set(20,D.Codicon.symbolFile),R.set(21,D.Codicon.symbolReference),R.set(22,D.Codicon.symbolCustomColor),R.set(23,D.Codicon.symbolFolder),R.set(24,D.Codicon.symbolTypeParameter),R.set(25,D.Codicon.account),R.set(26,D.Codicon.issues);function I(H){let z=R.get(H);return z||(console.info("No codicon found for CompletionItemKind "+H),z=D.Codicon.symbolProperty),z}o.toIcon=I;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function U(H,z){let ee=O.get(H);return typeof ee>"u"&&!z&&(ee=9),ee}o.fromString=U})(N=t.CompletionItemKinds||(t.CompletionItemKinds={}));var M;(function(o){o[o.Deprecated=1]="Deprecated"})(M=t.CompletionItemTag||(t.CompletionItemTag={}));var p;(function(o){o[o.None=0]="None",o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(p=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var v;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var e;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(e=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var A;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(A=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var F;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(F=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var E;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(E=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));function L(o){return o&&k.URI.isUri(o.uri)&&i.Range.isIRange(o.range)&&(i.Range.isIRange(o.originSelectionRange)||i.Range.isIRange(o.targetSelectionRange))}t.isLocationLink=L;var g;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(g=t.SymbolKind||(t.SymbolKind={}));var m;(function(o){o[o.Deprecated=1]="Deprecated"})(m=t.SymbolTag||(t.SymbolTag={}));var l;(function(o){const R=new Map;R.set(0,D.Codicon.symbolFile),R.set(1,D.Codicon.symbolModule),R.set(2,D.Codicon.symbolNamespace),R.set(3,D.Codicon.symbolPackage),R.set(4,D.Codicon.symbolClass),R.set(5,D.Codicon.symbolMethod),R.set(6,D.Codicon.symbolProperty),R.set(7,D.Codicon.symbolField),R.set(8,D.Codicon.symbolConstructor),R.set(9,D.Codicon.symbolEnum),R.set(10,D.Codicon.symbolInterface),R.set(11,D.Codicon.symbolFunction),R.set(12,D.Codicon.symbolVariable),R.set(13,D.Codicon.symbolConstant),R.set(14,D.Codicon.symbolString),R.set(15,D.Codicon.symbolNumber),R.set(16,D.Codicon.symbolBoolean),R.set(17,D.Codicon.symbolArray),R.set(18,D.Codicon.symbolObject),R.set(19,D.Codicon.symbolKey),R.set(20,D.Codicon.symbolNull),R.set(21,D.Codicon.symbolEnumMember),R.set(22,D.Codicon.symbolStruct),R.set(23,D.Codicon.symbolEvent),R.set(24,D.Codicon.symbolOperator),R.set(25,D.Codicon.symbolTypeParameter);function I(O){let U=R.get(O);return U||(console.info("No codicon found for SymbolKind "+O),U=D.Codicon.symbolProperty),U}o.toIcon=I})(l=t.SymbolKinds||(t.SymbolKinds={}));class r{constructor(R){this.value=R}}r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region"),t.FoldingRangeKind=r;var s;(function(o){function R(I){return!I||typeof I!="object"?!1:typeof I.id=="string"&&typeof I.title=="string"}o.is=R})(s=t.Command||(t.Command={}));var d;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(d=t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={}));var c;(function(o){o[o.Unresolved=0]="Unresolved",o[o.Resolved=1]="Resolved"})(c=t.CommentThreadState||(t.CommentThreadState={}));var w;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(w=t.CommentMode||(t.CommentMode={}));var _;(function(o){o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(_=t.InlayHintKind||(t.InlayHintKind={})),t.TokenizationRegistry=new u.TokenizationRegistry;var h;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(h=t.ExternalUriOpenerPriority||(t.ExternalUriOpenerPriority={}))}),Y(Z[53],K([0,1,22,9,27,12,3,2,30,52,41]),function(q,t,D,k,i,u,y,b,a,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class M{static chord(e,A){return(0,i.KeyChord)(e,A)}}M.CtrlCmd=2048,M.Shift=1024,M.Alt=512,M.WinCtrl=256,t.KeyMod=M;function p(){return{editor:void 0,languages:void 0,CancellationTokenSource:D.CancellationTokenSource,Emitter:k.Emitter,KeyCode:N.KeyCode,KeyMod:M,Position:y.Position,Range:b.Range,Selection:a.Selection,SelectionDirection:N.SelectionDirection,MarkerSeverity:N.MarkerSeverity,MarkerTag:N.MarkerTag,Uri:u.URI,Token:f.Token}}t.createMonacoBaseAPI=p}),Y(Z[58],K([0,1,23,5,12,3,2,48,19,37,38,53,21,50,24,47,11]),function(q,t,D,k,i,u,y,b,a,f,N,M,p,v,e,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class E extends b.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(l){return this._lines[l-1]}getWordAtPosition(l,r){const s=(0,a.getWordAtText)(l.column,(0,a.ensureValidWordDefinition)(r),this._lines[l.lineNumber-1],0);return s?new y.Range(l.lineNumber,s.startColumn,l.lineNumber,s.endColumn):null}getWordUntilPosition(l,r){const s=this.getWordAtPosition(l,r);return s?{word:this._lines[l.lineNumber-1].substring(s.startColumn-1,l.column-1),startColumn:s.startColumn,endColumn:l.column}:{word:"",startColumn:l.column,endColumn:l.column}}words(l){const r=this._lines,s=this._wordenize.bind(this);let d=0,c="",w=0,_=[];return{*[Symbol.iterator](){for(;;)if(w<_.length){const h=c.substring(_[w].start,_[w].end);w+=1,yield h}else if(d<r.length)c=r[d],_=s(c,l),w=0,d+=1;else break}}}getLineWords(l,r){const s=this._lines[l-1],d=this._wordenize(s,r),c=[];for(const w of d)c.push({word:s.substring(w.start,w.end),startColumn:w.start+1,endColumn:w.end+1});return c}_wordenize(l,r){const s=[];let d;for(r.lastIndex=0;(d=r.exec(l))&&d[0].length!==0;)s.push({start:d.index,end:d.index+d[0].length});return s}getValueInRange(l){if(l=this._validateRange(l),l.startLineNumber===l.endLineNumber)return this._lines[l.startLineNumber-1].substring(l.startColumn-1,l.endColumn-1);const r=this._eol,s=l.startLineNumber-1,d=l.endLineNumber-1,c=[];c.push(this._lines[s].substring(l.startColumn-1));for(let w=s+1;w<d;w++)c.push(this._lines[w]);return c.push(this._lines[d].substring(0,l.endColumn-1)),c.join(r)}offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.lineNumber-2)+(l.column-1)}positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const r=this._lineStarts.getIndexOf(l),s=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}_validateRange(l){const r=this._validatePosition({lineNumber:l.startLineNumber,column:l.startColumn}),s=this._validatePosition({lineNumber:l.endLineNumber,column:l.endColumn});return r.lineNumber!==l.startLineNumber||r.column!==l.startColumn||s.lineNumber!==l.endLineNumber||s.column!==l.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:l}_validatePosition(l){if(!u.Position.isIPosition(l))throw new Error("bad position");let{lineNumber:r,column:s}=l,d=!1;if(r<1)r=1,s=1,d=!0;else if(r>this._lines.length)r=this._lines.length,s=this._lines[r-1].length+1,d=!0;else{const c=this._lines[r-1].length+1;s<1?(s=1,d=!0):s>c&&(s=c,d=!0)}return d?{lineNumber:r,column:s}:l}}class L{constructor(l,r){this._host=l,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(l){return this._models[l]}_getModels(){const l=[];return Object.keys(this._models).forEach(r=>l.push(this._models[r])),l}acceptNewModel(l){this._models[l.url]=new E(i.URI.parse(l.url),l.lines,l.EOL,l.versionId)}acceptModelChanged(l,r){if(!this._models[l])return;this._models[l].onEvents(r)}acceptRemovedModel(l){!this._models[l]||delete this._models[l]}async computeUnicodeHighlights(l,r,s){const d=this._getModel(l);return d?v.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,r,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(l,r,s,d){const c=this._getModel(l),w=this._getModel(r);return!c||!w?null:L.computeDiff(c,w,s,d)}static computeDiff(l,r,s,d){const c=d==="experimental"?A.linesDiffComputers.experimental:A.linesDiffComputers.smart,w=l.getLinesContent(),_=r.getLinesContent(),h=c.computeDiff(w,_,s);return{identical:h.changes.length>0?!1:this._modelsAreIdentical(l,r),quitEarly:h.quitEarly,changes:h.changes.map(R=>[R.originalRange.startLineNumber,R.originalRange.endLineNumberExclusive,R.modifiedRange.startLineNumber,R.modifiedRange.endLineNumberExclusive,R.innerChanges?.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])])}}static _modelsAreIdentical(l,r){const s=l.getLineCount(),d=r.getLineCount();if(s!==d)return!1;for(let c=1;c<=s;c++){const w=l.getLineContent(c),_=r.getLineContent(c);if(w!==_)return!1}return!0}async computeDirtyDiff(l,r,s){const d=this._getModel(l),c=this._getModel(r);if(!d||!c)return null;const w=d.getLinesContent(),_=c.getLinesContent();return new e.DiffComputer(w,_,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(l,r){const s=this._getModel(l);if(!s)return r;const d=[];let c;r=r.slice(0).sort((w,_)=>{if(w.range&&_.range)return y.Range.compareRangesUsingStarts(w.range,_.range);const h=w.range?0:1,o=_.range?0:1;return h-o});for(let{range:w,text:_,eol:h}of r){if(typeof h=="number"&&(c=h),y.Range.isEmpty(w)&&!_)continue;const o=s.getValueInRange(w);if(_=_.replace(/\r\n|\n|\r/g,s.eol),o===_)continue;if(Math.max(_.length,o.length)>L._diffLimit){d.push({range:w,text:_});continue}const R=(0,D.stringDiff)(o,_,!1),I=s.offsetAt(y.Range.lift(w).getStartPosition());for(const O of R){const U=s.positionAt(I+O.originalStart),H=s.positionAt(I+O.originalStart+O.originalLength),z={text:_.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:U.lineNumber,startColumn:U.column,endLineNumber:H.lineNumber,endColumn:H.column}};s.getValueInRange(z.range)!==z.text&&d.push(z)}}return typeof c=="number"&&d.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),d}async computeLinks(l){const r=this._getModel(l);return r?(0,f.computeLinks)(r):null}async textualSuggest(l,r,s,d){const c=new p.StopWatch(!0),w=new RegExp(s,d),_=new Set;e:for(const h of l){const o=this._getModel(h);if(!!o){for(const R of o.words(w))if(!(R===r||!isNaN(Number(R)))&&(_.add(R),_.size>L._suggestionsLimit))break e}}return{words:Array.from(_),duration:c.elapsed()}}async computeWordRanges(l,r,s,d){const c=this._getModel(l);if(!c)return Object.create(null);const w=new RegExp(s,d),_=Object.create(null);for(let h=r.startLineNumber;h<r.endLineNumber;h++){const o=c.getLineWords(h,w);for(const R of o){if(!isNaN(Number(R.word)))continue;let I=_[R.word];I||(I=[],_[R.word]=I),I.push({startLineNumber:h,startColumn:R.startColumn,endLineNumber:h,endColumn:R.endColumn})}}return _}async navigateValueSet(l,r,s,d,c){const w=this._getModel(l);if(!w)return null;const _=new RegExp(d,c);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});const h=w.getValueInRange(r),o=w.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},_);if(!o)return null;const R=w.getValueInRange(o);return N.BasicInplaceReplace.INSTANCE.navigateValueSet(r,h,o,R,s)}loadForeignModule(l,r,s){const d=(_,h)=>this._host.fhr(_,h),w={host:(0,F.createProxyObject)(s,d),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(w,r),Promise.resolve((0,F.getAllMethodNames)(this._foreignModule))):new Promise((_,h)=>{q([l],o=>{this._foreignModule=o.create(w,r),_((0,F.getAllMethodNames)(this._foreignModule))},h)})}fmr(l,r){if(!this._foreignModule||typeof this._foreignModule[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this._foreignModule[l].apply(this._foreignModule,r))}catch(s){return Promise.reject(s)}}}L._diffLimit=1e5,L._suggestionsLimit=1e4,t.EditorSimpleWorker=L;function g(m){return new L(m,null)}t.create=g,typeof importScripts=="function"&&(k.globals.monaco=(0,M.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c6a9727b801542499d2b59cb7db4224e060fc578/core/vs/base/worker/workerMain.js.map
