/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],oe=function(Z){for(var e=[],R=0,_=Z.length;R<_;R++)e[R]=se[Z[R]];return e};define(se[63],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function R(L){return(D,C,w)=>{let P=null,y=null;if(typeof w.value=="function"?(P="value",y=w.value):typeof w.get=="function"&&(P="get",y=w.get),!y)throw new Error("not supported");w[P]=L(y,C)}}function _(L,D,C){let w=null,P=null;if(typeof C.value=="function"?(w="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(w="get",P=C.get),!P)throw new Error("not supported");const y=`$memoize$${D}`;C[w]=function(...g){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,g)}),this[y]}}e.memoize=_;function c(L,D,C){return R((w,P)=>{const y=`$debounce$${P}`,g=`$debounce$result$${P}`;return function(...S){this[g]||(this[g]=C?C():void 0),clearTimeout(this[y]),D&&(this[g]=D(this[g],...S),S=[this[g]]),this[y]=setTimeout(()=>{w.apply(this,S),this[g]=C?C():void 0},L)}})}e.debounce=c;function T(L,D,C){return R((w,P)=>{const y=`$throttle$timer$${P}`,g=`$throttle$result$${P}`,S=`$throttle$lastRun$${P}`,d=`$throttle$pending$${P}`;return function(...p){if(this[g]||(this[g]=C?C():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),D&&(this[g]=D(this[g],...p)),this[d])return;const h=this[S]+L;h<=Date.now()?(this[S]=Date.now(),w.apply(this,[this[g]]),this[g]=C?C():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),w.apply(this,[this[g]]),this[g]=C?C():void 0},h-Date.now()))}})}e.throttle=T}),define(se[9],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?b.isErrorNoTelemetry(s)?new b(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(t=>{t(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=R,e.errorHandler=new R;function _(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=_;function c(i){if(!i||typeof i!="object")return!1;const s=i;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=c;function T(i){w(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=T;function L(i){w(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=L;function D(i){if(i instanceof Error){const{name:s,message:t}=i,n=i.stacktrace||i.stack;return{$isError:!0,name:s,message:t,stack:n,noTelemetry:b.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=D;const C="Canceled";function w(i){return i instanceof P?!0:i instanceof Error&&i.name===C&&i.message===C}e.isCancellationError=w;class P extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=P;function y(){const i=new Error(C);return i.name=i.message,i}e.canceled=y;function g(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=g;function S(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=S;function d(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function p(i){const s=new Error(`${i} has been disposed`);return s.name="DISPOSED",s}e.disposed=p;function h(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=h;class u extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=u;class f extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=f;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class b extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof b)return s;const t=new b;return t.message=s.message,t.stack=s.stack,t}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class I extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,I.prototype);debugger}}e.BugIndicatingError=I}),define(se[21],oe([0,1,9]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function _(H,X=0){return H[H.length-(1+X)]}e.tail=_;function c(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=c;function T(H,X,te=(le,he)=>le===he){if(H===X)return!0;if(!H||!X||H.length!==X.length)return!1;for(let le=0,he=H.length;le<he;le++)if(!te(H[le],X[le]))return!1;return!0}e.equals=T;function L(H,X){const te=H.length-1;X<te&&(H[X]=H[te]),H.pop()}e.removeFastWithoutKeepingOrder=L;function D(H,X,te){return C(H.length,le=>te(H[le],X))}e.binarySearch=D;function C(H,X){let te=0,le=H-1;for(;te<=le;){const he=(te+le)/2|0,me=X(he);if(me<0)te=he+1;else if(me>0)le=he-1;else return he}return-(te+1)}e.binarySearch2=C;function w(H,X){let te=0,le=H.length;if(le===0)return 0;for(;te<le;){const he=Math.floor((te+le)/2);X(H[he])?le=he:te=he+1}return te}e.findFirstInSorted=w;function P(H,X,te){if(H=H|0,H>=X.length)throw new TypeError("invalid index");const le=X[Math.floor(X.length*Math.random())],he=[],me=[],pe=[];for(const Ee of X){const be=te(Ee,le);be<0?he.push(Ee):be>0?me.push(Ee):pe.push(Ee)}return H<he.length?P(H,he,te):H<he.length+pe.length?pe[0]:P(H-(he.length+pe.length),me,te)}e.quickSelect=P;function y(H,X){const te=[];let le;for(const he of H.slice(0).sort(X))!le||X(le[0],he)!==0?(le=[he],te.push(le)):le.push(he);return te}e.groupBy=y;function g(H,X,te){const le=[];function he(Ee,be,Re){if(be===0&&Re.length===0)return;const ke=le[le.length-1];ke&&ke.start+ke.deleteCount===Ee?(ke.deleteCount+=be,ke.toInsert.push(...Re)):le.push({start:Ee,deleteCount:be,toInsert:Re})}let me=0,pe=0;for(;;){if(me===H.length){he(me,0,X.slice(pe));break}if(pe===X.length){he(me,H.length-me,[]);break}const Ee=H[me],be=X[pe],Re=te(Ee,be);Re===0?(me+=1,pe+=1):Re<0?(he(me,1,[]),me+=1):Re>0&&(he(me,0,[be]),pe+=1)}return le}e.sortedDiff=g;function S(H,X,te){const le=g(H,X,te),he=[],me=[];for(const pe of le)he.push(...H.slice(pe.start,pe.start+pe.deleteCount)),me.push(...pe.toInsert);return{removed:he,added:me}}e.delta=S;function d(H,X,te){if(te===0)return[];const le=H.slice(0,te).sort(X);return h(H,X,le,te,H.length),le}e.top=d;function p(H,X,te,le,he){return te===0?Promise.resolve([]):new Promise((me,pe)=>{(async()=>{const Ee=H.length,be=H.slice(0,te).sort(X);for(let Re=te,ke=Math.min(te+le,Ee);Re<Ee;Re=ke,ke=Math.min(ke+le,Ee)){if(Re>te&&await new Promise(We=>setTimeout(We)),he&&he.isCancellationRequested)throw new R.CancellationError;h(H,X,be,Re,ke)}return be})().then(me,pe)})}e.topAsync=p;function h(H,X,te,le,he){for(const me=te.length;le<he;le++){const pe=H[le];if(X(pe,te[me-1])<0){te.pop();const Ee=w(te,be=>X(pe,be)<0);te.splice(Ee,0,pe)}}}function u(H){return H.filter(X=>!!X)}e.coalesce=u;function f(H){let X=0;for(let te=0;te<H.length;te++)H[te]&&(H[X]=H[te],X+=1);H.length=X}e.coalesceInPlace=f;function v(H,X,te){H.splice(te,0,H.splice(X,1)[0])}e.move=v;function b(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=b;function I(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=I;function i(H,X=te=>te){const te=new Set;return H.filter(le=>{const he=X(le);return te.has(he)?!1:(te.add(he),!0)})}e.distinct=i;function s(H){const X=new Set;return te=>{const le=H(te);return X.has(le)?!1:(X.add(le),!0)}}e.uniqueFilter=s;function t(H,X){const te=n(H,X);if(te!==-1)return H[te]}e.findLast=t;function n(H,X){for(let te=H.length-1;te>=0;te--){const le=H[te];if(X(le))return te}return-1}e.lastIndex=n;function r(H,X){return H.length>0?H[0]:X}e.firstOrDefault=r;function a(H,X){return H.length>0?H[H.length-1]:X}e.lastOrDefault=a;function o(H,X,te=(le,he)=>le===he){let le=0;for(let he=0,me=Math.min(H.length,X.length);he<me&&te(H[he],X[he]);he++)le++;return le}e.commonPrefixLength=o;function l(H){return[].concat(...H)}e.flatten=l;function m(H,X){let te=typeof X=="number"?H:0;typeof X=="number"?te=H:(te=0,X=H);const le=[];if(te<=X)for(let he=te;he<X;he++)le.push(he);else for(let he=te;he>X;he--)le.push(he);return le}e.range=m;function E(H,X,te){return H.reduce((le,he)=>(le[X(he)]=te?te(he):he,le),Object.create(null))}e.index=E;function A(H,X){return H.push(X),()=>O(H,X)}e.insert=A;function O(H,X){const te=H.indexOf(X);if(te>-1)return H.splice(te,1),X}e.remove=O;function F(H,X,te){const le=H.slice(0,X),he=H.slice(X);return le.concat(te,he)}e.arrayInsert=F;function M(H,X){let te;if(typeof X=="number"){let le=X;te=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else te=Math.random;for(let le=H.length-1;le>0;le-=1){const he=Math.floor(te()*(le+1)),me=H[le];H[le]=H[he],H[he]=me}}e.shuffle=M;function k(H,X){const te=H.indexOf(X);te>-1&&(H.splice(te,1),H.unshift(X))}e.pushToStart=k;function N(H,X){const te=H.indexOf(X);te>-1&&(H.splice(te,1),H.push(X))}e.pushToEnd=N;function z(H,X){for(const te of X)H.push(te)}e.pushMany=z;function j(H,X){return Array.isArray(H)?H.map(X):X(H)}e.mapArrayOrNot=j;function J(H){return Array.isArray(H)?H:[H]}e.asArray=J;function ne(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=ne;function G(H,X){for(const te of H){const le=X(te);if(le!==void 0)return le}}e.mapFind=G;function q(H,X,te){const le=Y(H,X),he=H.length,me=te.length;H.length=he+me;for(let pe=he-1;pe>=le;pe--)H[pe+me]=H[pe];for(let pe=0;pe<me;pe++)H[pe+le]=te[pe]}e.insertInto=q;function x(H,X,te,le){const he=Y(H,X),me=H.splice(he,te);return q(H,he,le),me}e.splice=x;function Y(H,X){return X<0?Math.max(X+H.length,0):Math.min(X,H.length)}var ee;(function(H){function X(he){return he<0}H.isLessThan=X;function te(he){return he>0}H.isGreaterThan=te;function le(he){return he===0}H.isNeitherLessOrGreaterThan=le,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function re(H,X){return(te,le)=>X(H(te),H(le))}e.compareBy=re;function ae(...H){return(X,te)=>{for(const le of H){const he=le(X,te);if(!ee.isNeitherLessOrGreaterThan(he))return he}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const V=(H,X)=>H-X;e.numberComparator=V;function $(H,X){if(H.length===0)return;let te=H[0];for(let le=1;le<H.length;le++){const he=H[le];X(he,te)>0&&(te=he)}return te}e.findMaxBy=$;function U(H,X){if(H.length===0)return;let te=H[0];for(let le=1;le<H.length;le++){const he=H[le];X(he,te)>=0&&(te=he)}return te}e.findLastMaxBy=U;function W(H,X){return $(H,(te,le)=>-X(te,le))}e.findMinBy=W;class B{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let te=this.firstIdx;for(;te<this.items.length&&X(this.items[te]);)te++;const le=te===this.firstIdx?null:this.items.slice(this.firstIdx,te);return this.firstIdx=te,le}takeFromEndWhile(X){let te=this.lastIdx;for(;te>=0&&X(this.items[te]);)te--;const le=te===this.lastIdx?null:this.items.slice(te+1,this.lastIdx+1);return this.lastIdx=te,le}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}removeLast(){const X=this.items[this.lastIdx];return this.lastIdx--,X}takeCount(X){const te=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,te}}e.ArrayQueue=B;class Q{constructor(X){this.iterate=X}forEach(X){this.iterate(te=>(X(te),!0))}toArray(){const X=[];return this.iterate(te=>(X.push(te),!0)),X}filter(X){return new Q(te=>this.iterate(le=>X(le)?te(le):!0))}map(X){return new Q(te=>this.iterate(le=>te(X(le))))}some(X){let te=!1;return this.iterate(le=>(te=X(le),!te)),te}findFirst(X){let te;return this.iterate(le=>X(le)?(te=le,!1):!0),te}findLast(X){let te;return this.iterate(le=>(X(le)&&(te=le),!0)),te}findLastMaxBy(X){let te,le=!0;return this.iterate(he=>((le||ee.isGreaterThan(X(he,te)))&&(le=!1,te=he),!0)),te}}Q.empty=new Q(H=>{}),e.CallbackIterable=Q}),define(se[129],oe([0,1,9]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function _(C,w){if(!C)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=_;function c(C,w="Unreachable"){throw new Error(w)}e.assertNever=c;function T(C){if(!C)throw new R.BugIndicatingError("Assertion Failed")}e.assert=T;function L(C){if(!C()){debugger;C(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function D(C,w){let P=0;for(;P<C.length-1;){const y=C[P],g=C[P+1];if(!w(y,g))return!1;P++}return!0}e.checkAdjacentItems=D}),define(se[82],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(_){const c=this;let T=!1,L;return function(){return T||(T=!0,L=_.apply(c,arguments)),L}}e.once=R}),define(se[64],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(_){function c(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}_.is=c;const T=Object.freeze([]);function L(){return T}_.empty=L;function*D(b){yield b}_.single=D;function C(b){return c(b)?b:D(b)}_.wrap=C;function w(b){return b||T}_.from=w;function P(b){return!b||b[Symbol.iterator]().next().done===!0}_.isEmpty=P;function y(b){return b[Symbol.iterator]().next().value}_.first=y;function g(b,I){for(const i of b)if(I(i))return!0;return!1}_.some=g;function S(b,I){for(const i of b)if(I(i))return i}_.find=S;function*d(b,I){for(const i of b)I(i)&&(yield i)}_.filter=d;function*p(b,I){let i=0;for(const s of b)yield I(s,i++)}_.map=p;function*h(...b){for(const I of b)for(const i of I)yield i}_.concat=h;function u(b,I,i){let s=i;for(const t of b)s=I(s,t);return s}_.reduce=u;function*f(b,I,i=b.length){for(I<0&&(I+=b.length),i<0?i+=b.length:i>b.length&&(i=b.length);I<i;I++)yield b[I]}_.slice=f;function v(b,I=Number.POSITIVE_INFINITY){const i=[];if(I===0)return[i,b];const s=b[Symbol.iterator]();for(let t=0;t<I;t++){const n=s.next();if(n.done)return[i,_.empty()];i.push(n.value)}return[i,{[Symbol.iterator](){return s}}]}_.consume=v})(R=e.Iterable||(e.Iterable={}))}),define(se[35],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var _;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(_=e.SyntaxKind||(e.SyntaxKind={}));var c;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(c=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function L(i,s=!1){let t=0;const n=i.length;let r="",a=0,o=16,l=0;function m(N){let z=0,j=0;for(;z<N;){const J=i.charCodeAt(t);if(J>=48&&J<=57)j=j*16+J-48;else if(J>=65&&J<=70)j=j*16+J-65+10;else if(J>=97&&J<=102)j=j*16+J-97+10;else break;t++,z++}return z<N&&(j=-1),j}function E(N){t=N,r="",a=0,o=16,l=0}function A(){const N=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&w(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&w(i.charCodeAt(t)))for(t++;t<i.length&&w(i.charCodeAt(t));)t++;else return l=3,i.substring(N,t);let z=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&w(i.charCodeAt(t))){for(t++;t<i.length&&w(i.charCodeAt(t));)t++;z=t}else l=3;return i.substring(N,z)}function O(){let N="",z=t;for(;;){if(t>=n){N+=i.substring(z,t),l=2;break}const j=i.charCodeAt(t);if(j===34){N+=i.substring(z,t),t++;break}if(j===92){if(N+=i.substring(z,t),t++,t>=n){l=2;break}switch(i.charCodeAt(t++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const ne=m(4);ne>=0?N+=String.fromCharCode(ne):l=4;break}default:l=5}z=t;continue}if(j>=0&&j<=31)if(C(j)){N+=i.substring(z,t),l=2;break}else l=6;t++}return N}function F(){if(r="",l=0,a=t,t>=n)return a=n,o=17;let N=i.charCodeAt(t);if(D(N)){do t++,r+=String.fromCharCode(N),N=i.charCodeAt(t);while(D(N));return o=15}if(C(N))return t++,r+=String.fromCharCode(N),N===13&&i.charCodeAt(t)===10&&(t++,r+=`
`),o=14;switch(N){case 123:return t++,o=1;case 125:return t++,o=2;case 91:return t++,o=3;case 93:return t++,o=4;case 58:return t++,o=6;case 44:return t++,o=5;case 34:return t++,r=O(),o=10;case 47:{const z=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!C(i.charCodeAt(t));)t++;return r=i.substring(z,t),o=12}if(i.charCodeAt(t+1)===42){t+=2;const j=n-1;let J=!1;for(;t<j;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,J=!0;break}t++}return J||(t++,l=1),r=i.substring(z,t),o=13}return r+=String.fromCharCode(N),t++,o=16}case 45:if(r+=String.fromCharCode(N),t++,t===n||!w(i.charCodeAt(t)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=A(),o=11;default:for(;t<n&&M(N);)t++,N=i.charCodeAt(t);if(a!==t){switch(r=i.substring(a,t),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(N),t++,o=16}}function M(N){if(D(N)||C(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let N;do N=F();while(N>=12&&N<=15);return N}return{setPosition:E,getPosition:()=>t,scan:s?k:F,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>l}}e.createScanner=L;function D(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function C(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function y(i,s){const t=[],n=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(m,E,A,O){a.value=m,a.offset=E,a.length=A,a.type=O,a.colonOffset=void 0,r=a}try{v(i,{onObjectBegin:(m,E)=>{if(s<=m)throw n;r=void 0,o=s>m,t.push("")},onObjectProperty:(m,E,A)=>{if(s<E||(l(m,E,A,"property"),t[t.length-1]=m,s<=E+A))throw n},onObjectEnd:(m,E)=>{if(s<=m)throw n;r=void 0,t.pop()},onArrayBegin:(m,E)=>{if(s<=m)throw n;r=void 0,t.push(0)},onArrayEnd:(m,E)=>{if(s<=m)throw n;r=void 0,t.pop()},onLiteralValue:(m,E,A)=>{if(s<E||(l(m,E,A,I(m)),s<=E+A))throw n},onSeparator:(m,E,A)=>{if(s<=E)throw n;if(m===":"&&r&&r.type==="property")r.colonOffset=E,o=!1,r=void 0;else if(m===","){const O=t[t.length-1];typeof O=="number"?t[t.length-1]=O+1:(o=!0,t[t.length-1]=""),r=void 0}}})}catch(m){if(m!==n)throw m}return{path:t,previousNode:r,isAtPropertyKey:o,matches:m=>{let E=0;for(let A=0;E<m.length&&A<t.length;A++)if(m[E]===t[A]||m[E]==="*")E++;else if(m[E]!=="**")return!1;return E===m.length}}}e.getLocation=y;function g(i,s=[],t=T.DEFAULT){let n=null,r=[];const a=[];function o(m){Array.isArray(r)?r.push(m):n!==null&&(r[n]=m)}return v(i,{onObjectBegin:()=>{const m={};o(m),a.push(r),r=m,n=null},onObjectProperty:m=>{n=m},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const m=[];o(m),a.push(r),r=m,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:o,onError:(m,E,A)=>{s.push({error:m,offset:E,length:A})}},t),r[0]}e.parse=g;function S(i,s=[],t=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(m){n.type==="property"&&(n.length=m-n.offset,n=n.parent)}function a(m){return n.children.push(m),m}v(i,{onObjectBegin:m=>{n=a({type:"object",offset:m,length:-1,parent:n,children:[]})},onObjectProperty:(m,E,A)=>{n=a({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:m,offset:E,length:A,parent:n})},onObjectEnd:(m,E)=>{n.length=m+E-n.offset,n=n.parent,r(m+E)},onArrayBegin:(m,E)=>{n=a({type:"array",offset:m,length:-1,parent:n,children:[]})},onArrayEnd:(m,E)=>{n.length=m+E-n.offset,n=n.parent,r(m+E)},onLiteralValue:(m,E,A)=>{a({type:I(m),offset:E,length:A,parent:n,value:m}),r(E+A)},onSeparator:(m,E,A)=>{n.type==="property"&&(m===":"?n.colonOffset=E:m===","&&r(E))},onError:(m,E,A)=>{s.push({error:m,offset:E,length:A})}},t);const l=n.children[0];return l&&delete l.parent,l}e.parseTree=S;function d(i,s){if(!i)return;let t=i;for(const n of s)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===n){t=a.children[1],r=!0;break}if(!r)return}else{const r=n;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}e.findNodeAtLocation=d;function p(i){if(!i.parent||!i.parent.children)return[];const s=p(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;s.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&s.push(t)}return s}e.getNodePath=p;function h(i){switch(i.type){case"array":return i.children.map(h);case"object":{const s=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(s[t.children[0].value]=h(n))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=h;function u(i,s,t=!1){return s>=i.offset&&s<i.offset+i.length||t&&s===i.offset+i.length}e.contains=u;function f(i,s,t=!1){if(u(i,s,t)){const n=i.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const a=f(n[r],s,t);if(a)return a}return i}}e.findNodeAtOffset=f;function v(i,s,t=T.DEFAULT){const n=L(i,!1);function r(re){return re?()=>re(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(re){return re?ae=>re(ae,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=r(s.onObjectBegin),l=a(s.onObjectProperty),m=r(s.onObjectEnd),E=r(s.onArrayBegin),A=r(s.onArrayEnd),O=a(s.onLiteralValue),F=a(s.onSeparator),M=r(s.onComment),k=a(s.onError),N=t&&t.disallowComments,z=t&&t.allowTrailingComma;function j(){for(;;){const re=n.scan();switch(n.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:N||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(re){case 12:case 13:N?J(10):M();break;case 16:J(1);break;case 15:case 14:break;default:return re}}}function J(re,ae=[],V=[]){if(k(re),ae.length+V.length>0){let $=n.getToken();for(;$!==17;){if(ae.indexOf($)!==-1){j();break}else if(V.indexOf($)!==-1)break;$=j()}}}function ne(re){const ae=n.getTokenValue();return re?O(ae):l(ae),j(),!0}function G(){switch(n.getToken()){case 11:{let re=0;try{re=JSON.parse(n.getTokenValue()),typeof re!="number"&&(J(2),re=0)}catch{J(2)}O(re);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return j(),!0}function q(){return n.getToken()!==10?(J(3,[],[2,5]),!1):(ne(!1),n.getToken()===6?(F(":"),j(),ee()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function x(){o(),j();let re=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(re||J(4,[],[]),F(","),j(),n.getToken()===2&&z)break}else re&&J(6,[],[]);q()||J(4,[],[2,5]),re=!0}return m(),n.getToken()!==2?J(7,[2],[]):j(),!0}function Y(){E(),j();let re=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(re||J(4,[],[]),F(","),j(),n.getToken()===4&&z)break}else re&&J(6,[],[]);ee()||J(4,[],[4,5]),re=!0}return A(),n.getToken()!==4?J(8,[4],[]):j(),!0}function ee(){switch(n.getToken()){case 3:return Y();case 1:return x();case 10:return ne(!0);default:return G()}}return j(),n.getToken()===17?t.allowEmptyContent?!0:(J(4,[],[]),!1):ee()?(n.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=v;function b(i,s){const t=L(i),n=[];let r,a=0,o;do switch(o=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:a!==o&&n.push(i.substring(a,o)),s!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,s)),a=t.getPosition();break}while(r!==17);return n.join("")}e.stripComments=b;function I(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),define(se[43],oe([0,1,35]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function _(w,P,y){let g,S,d,p,h;if(P){for(p=P.offset,h=p+P.length,d=p;d>0&&!C(w,d-1);)d--;let o=h;for(;o<w.length&&!C(w,o);)o++;S=w.substring(d,o),g=L(S,y)}else S=w,g=0,d=0,p=0,h=w.length;const u=D(y,w);let f=!1,v=0,b;y.insertSpaces?b=T(" ",y.tabSize||4):b="	";const I=(0,R.createScanner)(S,!1);let i=!1;function s(){return u+T(b,g+v)}function t(){let o=I.scan();for(f=!1;o===15||o===14;)f=f||o===14,o=I.scan();return i=o===16||I.getTokenError()!==0,o}const n=[];function r(o,l,m){!i&&l<h&&m>p&&w.substring(l,m)!==o&&n.push({offset:l,length:m-l,content:o})}let a=t();if(a!==17){const o=I.getTokenOffset()+d,l=T(b,g);r(l,d,o)}for(;a!==17;){let o=I.getTokenOffset()+I.getTokenLength()+d,l=t(),m="";for(;!f&&(l===12||l===13);){const A=I.getTokenOffset()+d;r(" ",o,A),o=I.getTokenOffset()+I.getTokenLength()+d,m=l===12?s():"",l=t()}if(l===2)a!==1&&(v--,m=s());else if(l===4)a!==3&&(v--,m=s());else{switch(a){case 3:case 1:v++,m=s();break;case 5:case 12:m=s();break;case 13:f?m=s():m=" ";break;case 6:m=" ";break;case 10:if(l===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?m=" ":l!==5&&l!==17&&(i=!0);break;case 16:i=!0;break}f&&(l===12||l===13)&&(m=s())}const E=I.getTokenOffset()+d;r(m,o,E),a=l}return n}e.format=_;function c(w,P){const y=JSON.stringify(w,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?y.replace(/\r\n|\r|\n/g,P.eol):y}e.toFormattedString=c;function T(w,P){let y="";for(let g=0;g<P;g++)y+=w;return y}function L(w,P){let y=0,g=0;const S=P.tabSize||4;for(;y<w.length;){const d=w.charAt(y);if(d===" ")g++;else if(d==="	")g+=S;else break;y++}return Math.floor(g/S)}function D(w,P){for(let y=0;y<P.length;y++){const g=P.charAt(y);if(g==="\r")return y+1<P.length&&P.charAt(y+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=D;function C(w,P){return`\r
`.indexOf(w.charAt(P))!==-1}e.isEOL=C}),define(se[83],oe([0,1,35,43]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function c(w,P,y){return T(w,P,void 0,y)}e.removeProperty=c;function T(w,P,y,g,S){const d=P.slice(),p=[],h=(0,R.parseTree)(w,p);let u,f;for(;d.length>0&&(f=d.pop(),u=(0,R.findNodeAtLocation)(h,d),u===void 0&&y!==void 0);)typeof f=="string"?y={[f]:y}:y=[y];if(u)if(u.type==="object"&&typeof f=="string"&&Array.isArray(u.children)){const v=(0,R.findNodeAtLocation)(u,[f]);if(v!==void 0)if(y===void 0){if(!v.parent)throw new Error("Malformed AST");const b=u.children.indexOf(v.parent);let I,i=v.parent.offset+v.parent.length;if(b>0){const s=u.children[b-1];I=s.offset+s.length}else I=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return L(w,{offset:I,length:i-I,content:""},g)}else return L(w,{offset:v.offset,length:v.length,content:JSON.stringify(y)},g);else{if(y===void 0)return[];const b=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,I=S?S(u.children.map(s=>s.children[0].value)):u.children.length;let i;if(I>0){const s=u.children[I-1];i={offset:s.offset+s.length,length:0,content:","+b}}else u.children.length===0?i={offset:u.offset+1,length:0,content:b}:i={offset:u.offset+1,length:0,content:b+","};return L(w,i,g)}}else if(u.type==="array"&&typeof f=="number"&&Array.isArray(u.children))if(y!==void 0){const v=`${JSON.stringify(y)}`;let b;if(u.children.length===0||f===0)b={offset:u.offset+1,length:0,content:u.children.length===0?v:v+","};else{const I=f===-1||f>u.children.length?u.children.length:f,i=u.children[I-1];b={offset:i.offset+i.length,length:0,content:","+v}}return L(w,b,g)}else{const v=f,b=u.children[v];let I;if(u.children.length===1)I={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===v){const i=u.children[v-1],s=i.offset+i.length,t=u.offset+u.length;I={offset:s,length:t-2-s,content:""}}else I={offset:b.offset,length:u.children[v+1].offset-b.offset,content:""};return L(w,I,g)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${u.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return L(w,{offset:h?h.offset:0,length:h?h.length:0,content:JSON.stringify(y)},g)}}e.setProperty=T;function L(w,P,y){let g=D(w,P),S=P.offset,d=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;S>0&&!(0,_.isEOL)(g,S-1);)S--;for(;d<g.length&&!(0,_.isEOL)(g,d);)d++}const p=(0,_.format)(g,{offset:S,length:d-S},y);for(let u=p.length-1;u>=0;u--){const f=p[u];g=D(g,f),S=Math.min(S,f.offset),d=Math.max(d,f.offset+f.length),d+=f.content.length-f.length}const h=w.length-(g.length-d)-S;return[{offset:S,length:h,content:g.substring(S,d)}]}e.withFormatting=L;function D(w,P){return w.substring(0,P.offset)+P.content+w.substring(P.offset+P.length)}e.applyEdit=D;function C(w,P){const y=P.slice(0).sort((S,d)=>{const p=S.offset-d.offset;return p===0?S.length-d.length:p});let g=w.length;for(let S=y.length-1;S>=0;S--){const d=y[S];if(d.offset+d.length<=g)w=D(w,d);else throw new Error("Overlapping edit");g=d.offset}return w}e.applyEdits=C}),define(se[130],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(c){this.executor=c,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(c){this._error=c}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=R}),define(se[2],oe([0,1,82,64]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const c=!1;let T=null;function L(a){T=a}if(e.setDisposableTracker=L,c){const a="__is_disposable_tracked__";L(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[a]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==f.None)try{o[a]=!0}catch{}}markAsDisposed(o){if(o&&o!==f.None)try{o[a]=!0}catch{}}markAsSingleton(o){}})}function D(a){return T?.trackDisposable(a),a}function C(a){T?.markAsDisposed(a)}function w(a,o){T?.setParent(a,o)}function P(a,o){if(!!T)for(const l of a)T.setParent(l,o)}function y(a){return T?.markAsSingleton(a),a}e.markAsSingleton=y;function g(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=g;function S(a){if(_.Iterable.is(a)){const o=[];for(const l of a)if(l)try{l.dispose()}catch(m){o.push(m)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=S;function d(a){for(const o of a)g(o)&&o.dispose();return[]}e.disposeIfDisposable=d;function p(...a){const o=h(()=>S(a));return P(a,o),o}e.combinedDisposable=p;function h(a){const o=D({dispose:(0,R.once)(()=>{C(o),a()})});return o}e.toDisposable=h;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{S(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return w(o,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class f{constructor(){this._store=new u,D(this),w(this._store,this)}dispose(){C(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}f.None=Object.freeze({dispose(){}}),e.Disposable=f;class v{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&w(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&w(o,null),o}}e.MutableDisposable=v;class b{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=b;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(o){let l=o;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,C(this))},this}}e.SafeDisposable=I;class i{constructor(){this.references=new Map}acquire(o,...l){let m=this.references.get(o);m||(m={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,m));const{object:E}=m,A=(0,R.once)(()=>{--m.counter===0&&(this.destroyReferencedObject(o,m.object),this.references.delete(o))});return m.counter++,{object:E,dispose:A}}}e.ReferenceCollection=i;class s{constructor(o){this.referenceCollection=o}async acquire(o,...l){const m=this.referenceCollection.acquire(o,...l);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(E){throw m.dispose(),E}}}e.AsyncReferenceCollection=s;class t{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=t;function n(a){const o=new u;try{a(o)}finally{o.dispose()}}e.disposeOnReturn=n;class r{constructor(){this._store=new Map,this._isDisposed=!1,D(this)}dispose(){C(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{S(this._store.values())}finally{this._store.clear()}}has(o){return this._store.has(o)}get(o){return this._store.get(o)}set(o,l,m=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this._store.get(o)?.dispose(),this._store.set(o,l)}deleteAndDispose(o){this._store.get(o)?.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(se[84],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class _{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const L=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=L}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,L){const D=new R(T);if(this._first===R.Undefined)this._first=D,this._last=D;else if(L){const w=this._last;this._last=D,D.prev=w,w.next=D}else{const w=this._first;this._first=D,D.next=w,w.prev=D}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(D))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const L=T.prev;L.next=T.next,T.next.prev=L}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=_}),define(se[37],oe([0,1]),function(Z,e){"use strict";var R,_,c;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function T(d,p,h){let u=d.get(p);return u===void 0&&(u=h,d.set(p,u)),u}e.getOrSet=T;function L(d){const p=[];return d.forEach((h,u)=>{p.push(`${u} => ${h}`)}),`Map(${d.size}) {${p.join(", ")}}`}e.mapToString=L;function D(d){const p=[];return d.forEach(h=>{p.push(h)}),`Set(${d.size}) {${p.join(", ")}}`}e.setToString=D;class C{constructor(p,h){this.uri=p,this.value=h}}class w{constructor(p,h){this[R]="ResourceMap",p instanceof w?(this.map=new Map(p.map),this.toKey=h??w.defaultToKey):(this.map=new Map,this.toKey=p??w.defaultToKey)}set(p,h){return this.map.set(this.toKey(p),new C(p,h)),this}get(p){return this.map.get(this.toKey(p))?.value}has(p){return this.map.has(this.toKey(p))}get size(){return this.map.size}clear(){this.map.clear()}delete(p){return this.map.delete(this.toKey(p))}forEach(p,h){typeof h<"u"&&(p=p.bind(h));for(const[u,f]of this.map)p(f.value,f.uri,this)}*values(){for(const p of this.map.values())yield p.value}*keys(){for(const p of this.map.values())yield p.uri}*entries(){for(const p of this.map.values())yield[p.uri,p.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.map)yield[p.uri,p.value]}}w.defaultToKey=d=>d.toString(),e.ResourceMap=w;class P{constructor(p,h){this[_]="ResourceSet",!p||typeof p=="function"?this._map=new w(p):(this._map=new w(h),p.forEach(this.add,this))}get size(){return this._map.size}add(p){return this._map.set(p,p),this}clear(){this._map.clear()}delete(p){return this._map.delete(p)}forEach(p,h){this._map.forEach((u,f)=>p.call(h,f,f,this))}has(p){return this._map.has(p)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var y;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class g{constructor(){this[c]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(p){return this._map.has(p)}get(p,h=0){const u=this._map.get(p);if(!!u)return h!==0&&this.touch(u,h),u.value}set(p,h,u=0){let f=this._map.get(p);if(f)f.value=h,u!==0&&this.touch(f,u);else{switch(f={key:p,value:h,next:void 0,previous:void 0},u){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(p,f),this._size++}return this}delete(p){return!!this.remove(p)}remove(p){const h=this._map.get(p);if(!!h)return this._map.delete(p),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const p=this._head;return this._map.delete(p.key),this.removeItem(p),this._size--,p.value}forEach(p,h){const u=this._state;let f=this._head;for(;f;){if(h?p.bind(h)(f.value,f.key,this):p(f.value,f.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const p=this,h=this._state;let u=this._head;const f={[Symbol.iterator](){return f},next(){if(p._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:u.key,done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return f}values(){const p=this,h=this._state;let u=this._head;const f={[Symbol.iterator](){return f},next(){if(p._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:u.value,done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return f}entries(){const p=this,h=this._state;let u=this._head;const f={[Symbol.iterator](){return f},next(){if(p._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:[u.key,u.value],done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return f}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(p){if(p>=this.size)return;if(p===0){this.clear();return}let h=this._head,u=this.size;for(;h&&u>p;)this._map.delete(h.key),h=h.next,u--;this._head=h,this._size=u,h&&(h.previous=void 0),this._state++}addItemFirst(p){if(!this._head&&!this._tail)this._tail=p;else if(this._head)p.next=this._head,this._head.previous=p;else throw new Error("Invalid list");this._head=p,this._state++}addItemLast(p){if(!this._head&&!this._tail)this._head=p;else if(this._tail)p.previous=this._tail,this._tail.next=p;else throw new Error("Invalid list");this._tail=p,this._state++}removeItem(p){if(p===this._head&&p===this._tail)this._head=void 0,this._tail=void 0;else if(p===this._head){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this._head=p.next}else if(p===this._tail){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this._tail=p.previous}else{const h=p.next,u=p.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}p.next=void 0,p.previous=void 0,this._state++}touch(p,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(p===this._head)return;const u=p.next,f=p.previous;p===this._tail?(f.next=void 0,this._tail=f):(u.previous=f,f.next=u),p.previous=void 0,p.next=this._head,this._head.previous=p,this._head=p,this._state++}else if(h===2){if(p===this._tail)return;const u=p.next,f=p.previous;p===this._head?(u.previous=void 0,this._head=u):(u.previous=f,f.next=u),p.next=void 0,p.previous=this._tail,this._tail.next=p,this._tail=p,this._state++}}}toJSON(){const p=[];return this.forEach((h,u)=>{p.push([u,h])}),p}fromJSON(p){this.clear();for(const[h,u]of p)this.set(h,u)}}e.LinkedMap=g;class S extends g{constructor(p,h=1){super(),this._limit=p,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(p){this._limit=p,this.checkTrim()}get ratio(){return this._ratio}set ratio(p){this._ratio=Math.min(Math.max(0,p),1),this.checkTrim()}get(p,h=2){return super.get(p,h)}peek(p){return super.get(p,0)}set(p,h){return super.set(p,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=S}),define(se[85],oe([0,1,37]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const _=new R.LRUCache(1e4);function c(w){return C(w,"NFC",_)}e.normalizeNFC=c;const T=new R.LRUCache(1e4);function L(w){return C(w,"NFD",T)}e.normalizeNFD=L;const D=/[^\u0000-\u0080]/;function C(w,P,y){if(!w)return w;const g=y.get(w);if(g)return g;let S;return D.test(w)?S=w.normalize(P):S=w,y.set(w,S),S}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(P){return L(P).replace(w,"")}}()}),define(se[131],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function R(D,C,w){return Math.min(Math.max(D,C),w)}e.clamp=R;function _(D,C){return(C+D%C)%C}e.rot=_;class c{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=c;class T{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=T;class L{constructor(C){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(C),this._values.fill(0,0,C)}update(C){const w=this._values[this._index];return this._values[this._index]=C,this._index=(this._index+1)%this._values.length,this._sum-=w,this._sum+=C,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=L}),function(){function Z(c){const T=[];typeof c=="number"&&T.push("code/timeOrigin",c);function L(C){T.push(C,Date.now())}function D(){const C=[];for(let w=0;w<T.length;w+=2)C.push({name:T[w],startTime:T[w+1]});return C}return{mark:L,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(c){performance.mark(c)},getMarks(){let c=performance.timeOrigin;typeof c!="number"&&(c=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(c)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(c+L.startTime)});return T}};if(typeof process=="object"){const c=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(c)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function R(c){return c.MonacoPerformanceMarks||(c.MonacoPerformanceMarks=e()),c.MonacoPerformanceMarks}var _;typeof global=="object"?_=global:typeof self=="object"?_=self:_={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(_)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(_):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),_.perf=R(_))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var _ in R)(typeof exports=="object"?exports:Z)[_]=R[_]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function R(_){if(e[_])return e[_].exports;var c=e[_]={i:_,l:!1,exports:{}};return Z[_].call(c.exports,c,c.exports,R),c.l=!0,c.exports}return R.m=Z,R.c=e,R.d=function(_,c,T){R.o(_,c)||Object.defineProperty(_,c,{enumerable:!0,get:T})},R.r=function(_){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(_,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(_,"__esModule",{value:!0})},R.t=function(_,c){if(1&c&&(_=R(_)),8&c||4&c&&typeof _=="object"&&_&&_.__esModule)return _;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:_}),2&c&&typeof _!="string")for(var L in _)R.d(T,L,function(D){return _[D]}.bind(null,L));return T},R.n=function(_){var c=_&&_.__esModule?function(){return _.default}:function(){return _};return R.d(c,"a",c),c},R.o=function(_,c){return Object.prototype.hasOwnProperty.call(_,c)},R.p="",R(R.s=0)}([function(Z,e,R){(function(_){var c;e=Z.exports=V,c=typeof _=="object"&&_.env&&_.env.NODE_DEBUG&&/\bsemver\b/i.test(_.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],C=e.src=[],w=0,P=w++;C[P]="0|[1-9]\\d*";var y=w++;C[y]="[0-9]+";var g=w++;C[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=w++;C[S]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var d=w++;C[d]="("+C[y]+")\\.("+C[y]+")\\.("+C[y]+")";var p=w++;C[p]="(?:"+C[P]+"|"+C[g]+")";var h=w++;C[h]="(?:"+C[y]+"|"+C[g]+")";var u=w++;C[u]="(?:-("+C[p]+"(?:\\."+C[p]+")*))";var f=w++;C[f]="(?:-?("+C[h]+"(?:\\."+C[h]+")*))";var v=w++;C[v]="[0-9A-Za-z-]+";var b=w++;C[b]="(?:\\+("+C[v]+"(?:\\."+C[v]+")*))";var I=w++,i="v?"+C[S]+C[u]+"?"+C[b]+"?";C[I]="^"+i+"$";var s="[v=\\s]*"+C[d]+C[f]+"?"+C[b]+"?",t=w++;C[t]="^"+s+"$";var n=w++;C[n]="((?:<|>)?=?)";var r=w++;C[r]=C[y]+"|x|X|\\*";var a=w++;C[a]=C[P]+"|x|X|\\*";var o=w++;C[o]="[v=\\s]*("+C[a]+")(?:\\.("+C[a]+")(?:\\.("+C[a]+")(?:"+C[u]+")?"+C[b]+"?)?)?";var l=w++;C[l]="[v=\\s]*("+C[r]+")(?:\\.("+C[r]+")(?:\\.("+C[r]+")(?:"+C[f]+")?"+C[b]+"?)?)?";var m=w++;C[m]="^"+C[n]+"\\s*"+C[o]+"$";var E=w++;C[E]="^"+C[n]+"\\s*"+C[l]+"$";var A=w++;C[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;C[O]="(?:~>?)";var F=w++;C[F]="(\\s*)"+C[O]+"\\s+",D[F]=new RegExp(C[F],"g");var M=w++;C[M]="^"+C[O]+C[o]+"$";var k=w++;C[k]="^"+C[O]+C[l]+"$";var N=w++;C[N]="(?:\\^)";var z=w++;C[z]="(\\s*)"+C[N]+"\\s+",D[z]=new RegExp(C[z],"g");var j=w++;C[j]="^"+C[N]+C[o]+"$";var J=w++;C[J]="^"+C[N]+C[l]+"$";var ne=w++;C[ne]="^"+C[n]+"\\s*("+s+")$|^$";var G=w++;C[G]="^"+C[n]+"\\s*("+i+")$|^$";var q=w++;C[q]="(\\s*)"+C[n]+"\\s*("+s+"|"+C[o]+")",D[q]=new RegExp(C[q],"g");var x=w++;C[x]="^\\s*("+C[o]+")\\s+-\\s+("+C[o]+")\\s*$";var Y=w++;C[Y]="^\\s*("+C[l]+")\\s+-\\s+("+C[l]+")\\s*$";var ee=w++;C[ee]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)c(re,C[re]),D[re]||(D[re]=new RegExp(C[re]));function ae(ce,fe){if(ce instanceof V)return ce;if(typeof ce!="string"||ce.length>T||!(fe?D[t]:D[I]).test(ce))return null;try{return new V(ce,fe)}catch{return null}}function V(ce,fe){if(ce instanceof V){if(ce.loose===fe)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof V))return new V(ce,fe);c("SemVer",ce,fe),this.loose=fe;var ge=ce.trim().match(fe?D[t]:D[I]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ie=+Ce;if(Ie>=0&&Ie<L)return Ie}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ce,fe){var ge=ae(ce,fe);return ge?ge.version:null},e.clean=function(ce,fe){var ge=ae(ce.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(ce){return c("SemVer.compare",this.version,this.loose,ce),ce instanceof V||(ce=new V(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},V.prototype.compareMain=function(ce){return ce instanceof V||(ce=new V(ce,this.loose)),U(this.major,ce.major)||U(this.minor,ce.minor)||U(this.patch,ce.patch)},V.prototype.comparePre=function(ce){if(ce instanceof V||(ce=new V(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ce=ce.prerelease[fe];if(c("prerelease compare",fe,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return U(ge,Ce)}while(++fe)},V.prototype.inc=function(ce,fe){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,fe,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new V(ce,ge).inc(fe,Ce).version}catch{return null}},e.diff=function(ce,fe){if(H(ce,fe))return null;var ge=ae(ce),Ce=ae(fe);if(ge.prerelease.length||Ce.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Ce[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Ce[Ie])return Ie},e.compareIdentifiers=U;var $=/^[0-9]+$/;function U(ce,fe){var ge=$.test(ce),Ce=$.test(fe);return ge&&Ce&&(ce=+ce,fe=+fe),ge&&!Ce?-1:Ce&&!ge?1:ce<fe?-1:ce>fe?1:0}function W(ce,fe,ge){return new V(ce,ge).compare(new V(fe,ge))}function B(ce,fe,ge){return W(ce,fe,ge)>0}function Q(ce,fe,ge){return W(ce,fe,ge)<0}function H(ce,fe,ge){return W(ce,fe,ge)===0}function X(ce,fe,ge){return W(ce,fe,ge)!==0}function te(ce,fe,ge){return W(ce,fe,ge)>=0}function le(ce,fe,ge){return W(ce,fe,ge)<=0}function he(ce,fe,ge,Ce){var Ie;switch(fe){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Ie=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Ie=ce!==ge;break;case"":case"=":case"==":Ie=H(ce,ge,Ce);break;case"!=":Ie=X(ce,ge,Ce);break;case">":Ie=B(ce,ge,Ce);break;case">=":Ie=te(ce,ge,Ce);break;case"<":Ie=Q(ce,ge,Ce);break;case"<=":Ie=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function me(ce,fe){if(ce instanceof me){if(ce.loose===fe)return ce;ce=ce.value}if(!(this instanceof me))return new me(ce,fe);c("comparator",ce,fe),this.loose=fe,this.parse(ce),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,c("comp",this)}e.rcompareIdentifiers=function(ce,fe){return U(fe,ce)},e.major=function(ce,fe){return new V(ce,fe).major},e.minor=function(ce,fe){return new V(ce,fe).minor},e.patch=function(ce,fe){return new V(ce,fe).patch},e.compare=W,e.compareLoose=function(ce,fe){return W(ce,fe,!0)},e.rcompare=function(ce,fe,ge){return W(fe,ce,ge)},e.sort=function(ce,fe){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,fe)})},e.rsort=function(ce,fe){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,fe)})},e.gt=B,e.lt=Q,e.eq=H,e.neq=X,e.gte=te,e.lte=le,e.cmp=he,e.Comparator=me;var pe={};function Ee(ce,fe){if(ce instanceof Ee)return ce.loose===fe?ce:new Ee(ce.raw,fe);if(ce instanceof me)return new Ee(ce.value,fe);if(!(this instanceof Ee))return new Ee(ce,fe);if(this.loose=fe,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function be(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Re(ce,fe,ge,Ce,Ie,_e,Le,Fe,Oe,Ne,ze,Te,Ue){return((fe=be(ge)?"":be(Ce)?">="+ge+".0.0":be(Ie)?">="+ge+"."+Ce+".0":">="+fe)+" "+(Fe=be(Oe)?"":be(Ne)?"<"+(+Oe+1)+".0.0":be(ze)?"<"+Oe+"."+(+Ne+1)+".0":Te?"<="+Oe+"."+Ne+"."+ze+"-"+Te:"<="+Fe)).trim()}function ke(ce,fe){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ce.length;ge++)if(c(ce[ge].semver),ce[ge].semver!==pe&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===fe.major&&Ce.minor===fe.minor&&Ce.patch===fe.patch)return!0}return!1}return!0}function We(ce,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ce)}function $e(ce,fe,ge,Ce){var Ie,_e,Le,Fe,Oe;switch(ce=new V(ce,Ce),fe=new Ee(fe,Ce),ge){case">":Ie=B,_e=le,Le=Q,Fe=">",Oe=">=";break;case"<":Ie=Q,_e=te,Le=B,Fe="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(ce,fe,Ce))return!1;for(var Ne=0;Ne<fe.set.length;++Ne){var ze=fe.set[Ne],Te=null,Ue=null;if(ze.forEach(function(ie){ie.semver===pe&&(ie=new me(">=0.0.0")),Te=Te||ie,Ue=Ue||ie,Ie(ie.semver,Te.semver,Ce)?Te=ie:Le(ie.semver,Ue.semver,Ce)&&(Ue=ie)}),Te.operator===Fe||Te.operator===Oe||(!Ue.operator||Ue.operator===Fe)&&_e(ce,Ue.semver)||Ue.operator===Oe&&Le(ce,Ue.semver))return!1}return!0}me.prototype.parse=function(ce){var fe=this.loose?D[ne]:D[G],ge=ce.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new V(ge[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(ce){return c("Comparator.test",ce,this.loose),this.semver===pe||(typeof ce=="string"&&(ce=new V(ce,this.loose)),he(ce,this.operator,this.semver,this.loose))},me.prototype.intersects=function(ce,fe){if(!(ce instanceof me))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ce.value,fe),We(this.value,ge,fe);if(ce.operator==="")return ge=new Ee(this.value,fe),We(ce.semver,ge,fe);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),_e=this.semver.version===ce.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Fe=he(this.semver,"<",ce.semver,fe)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Oe=he(this.semver,">",ce.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Ie||_e&&Le||Fe||Oe},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ce){var fe=this.loose;ce=ce.trim(),c("range",ce,fe);var ge=fe?D[Y]:D[x];ce=ce.replace(ge,Re),c("hyphen replace",ce),ce=ce.replace(D[q],"$1$2$3"),c("comparator trim",ce,D[q]),ce=(ce=(ce=ce.replace(D[F],"$1~")).replace(D[z],"$1^")).split(/\s+/).join(" ");var Ce=fe?D[ne]:D[G],Ie=ce.split(" ").map(function(_e){return function(Le,Fe){return c("comp",Le),Le=function(Oe,Ne){return Oe.trim().split(/\s+/).map(function(ze){return function(Te,Ue){c("caret",Te,Ue);var ie=Ue?D[J]:D[j];return Te.replace(ie,function(ue,de,ve,ye,Pe){var De;return c("caret",Te,ue,de,ve,ye,Pe),be(de)?De="":be(ve)?De=">="+de+".0.0 <"+(+de+1)+".0.0":be(ye)?De=de==="0"?">="+de+"."+ve+".0 <"+de+"."+(+ve+1)+".0":">="+de+"."+ve+".0 <"+(+de+1)+".0.0":Pe?(c("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=de==="0"?ve==="0"?">="+de+"."+ve+"."+ye+Pe+" <"+de+"."+ve+"."+(+ye+1):">="+de+"."+ve+"."+ye+Pe+" <"+de+"."+(+ve+1)+".0":">="+de+"."+ve+"."+ye+Pe+" <"+(+de+1)+".0.0"):(c("no pr"),De=de==="0"?ve==="0"?">="+de+"."+ve+"."+ye+" <"+de+"."+ve+"."+(+ye+1):">="+de+"."+ve+"."+ye+" <"+de+"."+(+ve+1)+".0":">="+de+"."+ve+"."+ye+" <"+(+de+1)+".0.0"),c("caret return",De),De})}(ze,Ne)}).join(" ")}(Le,Fe),c("caret",Le),Le=function(Oe,Ne){return Oe.trim().split(/\s+/).map(function(ze){return function(Te,Ue){var ie=Ue?D[k]:D[M];return Te.replace(ie,function(ue,de,ve,ye,Pe){var De;return c("tilde",Te,ue,de,ve,ye,Pe),be(de)?De="":be(ve)?De=">="+de+".0.0 <"+(+de+1)+".0.0":be(ye)?De=">="+de+"."+ve+".0 <"+de+"."+(+ve+1)+".0":Pe?(c("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=">="+de+"."+ve+"."+ye+Pe+" <"+de+"."+(+ve+1)+".0"):De=">="+de+"."+ve+"."+ye+" <"+de+"."+(+ve+1)+".0",c("tilde return",De),De})}(ze,Ne)}).join(" ")}(Le,Fe),c("tildes",Le),Le=function(Oe,Ne){return c("replaceXRanges",Oe,Ne),Oe.split(/\s+/).map(function(ze){return function(Te,Ue){Te=Te.trim();var ie=Ue?D[E]:D[m];return Te.replace(ie,function(ue,de,ve,ye,Pe,De){c("xRange",Te,ue,de,ve,ye,Pe,De);var Be=be(ve),xe=Be||be(ye),Ae=xe||be(Pe);return de==="="&&Ae&&(de=""),Be?ue=de===">"||de==="<"?"<0.0.0":"*":de&&Ae?(xe&&(ye=0),Ae&&(Pe=0),de===">"?(de=">=",xe?(ve=+ve+1,ye=0,Pe=0):Ae&&(ye=+ye+1,Pe=0)):de==="<="&&(de="<",xe?ve=+ve+1:ye=+ye+1),ue=de+ve+"."+ye+"."+Pe):xe?ue=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ae&&(ue=">="+ve+"."+ye+".0 <"+ve+"."+(+ye+1)+".0"),c("xRange return",ue),ue})}(ze,Ne)}).join(" ")}(Le,Fe),c("xrange",Le),Le=function(Oe,Ne){return c("replaceStars",Oe,Ne),Oe.trim().replace(D[ee],"")}(Le,Fe),c("stars",Le),Le}(_e,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(_e){return!!_e.match(Ce)})),Ie=Ie.map(function(_e){return new me(_e,fe)})},Ee.prototype.intersects=function(ce,fe){if(!(ce instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Ie){return Ie.every(function(_e){return Ce.intersects(_e,fe)})})})})},e.toComparators=function(ce,fe){return new Ee(ce,fe).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new V(ce,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],ce))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(ce,fe,ge){var Ce=null,Ie=null;try{var _e=new Ee(fe,ge)}catch{return null}return ce.forEach(function(Le){_e.test(Le)&&(Ce&&Ie.compare(Le)!==-1||(Ie=new V(Ce=Le,ge)))}),Ce},e.minSatisfying=function(ce,fe,ge){var Ce=null,Ie=null;try{var _e=new Ee(fe,ge)}catch{return null}return ce.forEach(function(Le){_e.test(Le)&&(Ce&&Ie.compare(Le)!==1||(Ie=new V(Ce=Le,ge)))}),Ce},e.validRange=function(ce,fe){try{return new Ee(ce,fe).range||"*"}catch{return null}},e.ltr=function(ce,fe,ge){return $e(ce,fe,"<",ge)},e.gtr=function(ce,fe,ge){return $e(ce,fe,">",ge)},e.outside=$e,e.prerelease=function(ce,fe){var ge=ae(ce,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,fe,ge){return ce=new Ee(ce,ge),fe=new Ee(fe,ge),ce.intersects(fe)},e.coerce=function(ce){if(ce instanceof V)return ce;if(typeof ce!="string")return null;var fe=ce.match(D[A]);return fe==null?null:ae((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,R(1))},function(Z,e){var R,_,c=Z.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function D(h){if(R===setTimeout)return setTimeout(h,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(h,0);try{return R(h,0)}catch{try{return R.call(null,h,0)}catch{return R.call(this,h,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch{R=T}try{_=typeof clearTimeout=="function"?clearTimeout:L}catch{_=L}})();var C,w=[],P=!1,y=-1;function g(){P&&C&&(P=!1,C.length?w=C.concat(w):y=-1,w.length&&S())}function S(){if(!P){var h=D(g);P=!0;for(var u=w.length;u;){for(C=w,w=[];++y<u;)C&&C[y].run();y=-1,u=w.length}C=null,P=!1,function(f){if(_===clearTimeout)return clearTimeout(f);if((_===L||!_)&&clearTimeout)return _=clearTimeout,clearTimeout(f);try{_(f)}catch{try{return _.call(null,f)}catch{return _.call(this,f)}}}(h)}}function d(h,u){this.fun=h,this.array=u}function p(){}c.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)u[f-1]=arguments[f];w.push(new d(h,u)),w.length!==1||P||D(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},c.title="browser",c.browser=!0,c.env={},c.argv=[],c.version="",c.versions={},c.on=p,c.addListener=p,c.once=p,c.off=p,c.removeListener=p,c.removeAllListeners=p,c.emit=p,c.prependListener=p,c.prependOnceListener=p,c.listeners=function(h){return[]},c.binding=function(h){throw new Error("process.binding is not supported")},c.cwd=function(){return"/"},c.chdir=function(h){throw new Error("process.chdir is not supported")},c.umask=function(){return 0}}])}),define(se[132],oe([0,1]),function(Z,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class _{constructor(D,C,w){this.level=D,this.key=C,this.value=w,this.forward=[]}}const c=void 0;class T{constructor(D,C=2**16){this.comparator=D,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new _(this._maxLevel,c,c)}get size(){return this._size}clear(){this._header=new _(this._maxLevel,c,c)}has(D){return Boolean(T._search(this,D,this.comparator))}get(D){return T._search(this,D,this.comparator)?.value}set(D,C){return T._insert(this,D,C,this.comparator)&&(this._size+=1),this}delete(D){const C=T._delete(this,D,this.comparator);return C&&(this._size-=1),C}forEach(D,C){let w=this._header.forward[0];for(;w;)D.call(C,w.value,w.key,this),w=w.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",C=this._header.forward[0];for(;C;)D+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return D}static _search(D,C,w){let P=D._header;for(let y=D._level-1;y>=0;y--)for(;P.forward[y]&&w(P.forward[y].key,C)<0;)P=P.forward[y];if(P=P.forward[0],P&&w(P.key,C)===0)return P}static _insert(D,C,w,P){const y=[];let g=D._header;for(let S=D._level-1;S>=0;S--){for(;g.forward[S]&&P(g.forward[S].key,C)<0;)g=g.forward[S];y[S]=g}if(g=g.forward[0],g&&P(g.key,C)===0)return g.value=w,!1;{const S=T._randomLevel(D);if(S>D._level){for(let d=D._level;d<S;d++)y[d]=D._header;D._level=S}g=new _(S,C,w);for(let d=0;d<S;d++)g.forward[d]=y[d].forward[d],y[d].forward[d]=g;return!0}}static _randomLevel(D,C=.5){let w=1;for(;Math.random()<C&&w<D._maxLevel;)w+=1;return w}static _delete(D,C,w){const P=[];let y=D._header;for(let g=D._level-1;g>=0;g--){for(;y.forward[g]&&w(y.forward[g].key,C)<0;)y=y.forward[g];P[g]=y}if(y=y.forward[0],!y||w(y.key,C)!==0)return!1;for(let g=0;g<D._level&&P[g].forward[g]===y;g++)P[g].forward[g]=y.forward[g];for(;D._level>0&&D._header.forward[D._level-1]===c;)D._level-=1;return!0}}e.SkipList=T}),define(se[44],oe([0,1,9,2]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function c(b){const I=b;return I?typeof I.read=="function":!1}e.isReadable=c;function T(b){const I=b;return I?[I.on,I.pause,I.resume,I.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=T;function L(b){const I=b;return I?T(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.isReadableBufferedStream=L;function D(b,I){return new C(b,I)}e.newWriteableStream=D;class C{constructor(I,i){this.reducer=I,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(I){if(!this.state.destroyed){if(this.state.flowing)this.emitData(I);else if(this.buffer.data.push(I),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(I){this.state.destroyed||(this.state.flowing?this.emitError(I):this.buffer.error.push(I))}end(I){this.state.destroyed||(typeof I<"u"&&this.write(I),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(I){this.listeners.data.slice(0).forEach(i=>i(I))}emitError(I){this.listeners.error.length===0?(0,R.onUnexpectedError)(I):this.listeners.error.slice(0).forEach(i=>i(I))}emitEnd(){this.listeners.end.slice(0).forEach(I=>I())}on(I,i){if(!this.state.destroyed)switch(I){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(I,i){if(this.state.destroyed)return;let s;switch(I){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(i);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const I=this.reducer(this.buffer.data);this.emitData(I),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const I of this.buffer.error)this.emitError(I);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(b,I){const i=[];let s;for(;(s=b.read())!==null;)i.push(s);return I(i)}e.consumeReadable=w;function P(b,I,i){const s=[];let t;for(;(t=b.read())!==null&&s.length<i;)s.push(t);return t===null&&s.length>0?I(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return b.read()}}}e.peekReadable=P;function y(b,I){return new Promise((i,s)=>{const t=[];g(b,{onData:n=>{I&&t.push(n)},onError:n=>{I?s(n):i(void 0)},onEnd:()=>{i(I?I(t):void 0)}})})}e.consumeStream=y;function g(b,I){let i=!1;return b.on("error",s=>{i||I.onError(s)}),b.on("end",()=>{i||I.onEnd()}),b.on("data",s=>{i||I.onData(s)}),(0,_.toDisposable)(()=>i=!0)}e.listenStream=g;function S(b,I){return new Promise((i,s)=>{const t=new _.DisposableStore,n=[],r=l=>{if(n.push(l),n.length>I)return t.dispose(),b.pause(),i({stream:b,buffer:n,ended:!1})},a=l=>s(l),o=()=>i({stream:b,buffer:n,ended:!0});t.add((0,_.toDisposable)(()=>b.removeListener("error",a))),b.on("error",a),t.add((0,_.toDisposable)(()=>b.removeListener("end",o))),b.on("end",o),t.add((0,_.toDisposable)(()=>b.removeListener("data",r))),b.on("data",r)})}e.peekStream=S;function d(b,I){const i=D(I);return i.end(b),i}e.toStream=d;function p(){const b=D(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=p;function h(b){let I=!1;return{read:()=>I?null:(I=!0,b)}}e.toReadable=h;function u(b,I,i){const s=D(i);return g(b,{onData:t=>s.write(I.data(t)),onError:t=>s.error(I.error?I.error(t):t),onEnd:()=>s.end()}),s}e.transform=u;function f(b,I,i){let s=!1;return{read:()=>{const t=I.read();return s?t:(s=!0,t!==null?i([b,t]):b)}}}e.prefixedReadable=f;function v(b,I,i){let s=!1;const t=D(i);return g(I,{onData:n=>s?t.write(n):(s=!0,t.write(i([b,n]))),onError:n=>t.error(n),onEnd:()=>{s||(s=!0,t.write(b)),t.end()}}),t}e.prefixedStream=v}),define(se[17],oe([0,1,44]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const _=typeof Buffer<"u";let c,T;class L{static alloc(l){return _?new L(Buffer.allocUnsafe(l)):new L(new Uint8Array(l))}static wrap(l){return _&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new L(l)}static fromString(l,m){return!(m?.dontUseNodeBuffer||!1)&&_?new L(Buffer.from(l)):(c||(c=new TextEncoder),new L(c.encode(l)))}static fromByteArray(l){const m=L.alloc(l.length);for(let E=0,A=l.length;E<A;E++)m.buffer[E]=l[E];return m}static concat(l,m){if(typeof m>"u"){m=0;for(let O=0,F=l.length;O<F;O++)m+=l[O].byteLength}const E=L.alloc(m);let A=0;for(let O=0,F=l.length;O<F;O++){const M=l[O];E.set(M,A),A+=M.byteLength}return E}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=L.alloc(this.byteLength);return l.set(this),l}toString(){return _?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(l,m){return new L(this.buffer.subarray(l,m))}set(l,m){if(l instanceof L)this.buffer.set(l.buffer,m);else if(l instanceof Uint8Array)this.buffer.set(l,m);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),m);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return w(this.buffer,l)}writeUInt32BE(l,m){P(this.buffer,l,m)}readUInt32LE(l){return y(this.buffer,l)}writeUInt32LE(l,m){g(this.buffer,l,m)}readUInt8(l){return S(this.buffer,l)}writeUInt8(l,m){d(this.buffer,l,m)}}e.VSBuffer=L;function D(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=D;function C(o,l,m){o[m+0]=l&255,l=l>>>8,o[m+1]=l&255}e.writeUInt16LE=C;function w(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=w;function P(o,l,m){o[m+3]=l,l=l>>>8,o[m+2]=l,l=l>>>8,o[m+1]=l,l=l>>>8,o[m]=l}e.writeUInt32BE=P;function y(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=y;function g(o,l,m){o[m+0]=l&255,l=l>>>8,o[m+1]=l&255,l=l>>>8,o[m+2]=l&255,l=l>>>8,o[m+3]=l&255}e.writeUInt32LE=g;function S(o,l){return o[l]}e.readUInt8=S;function d(o,l,m){o[m]=l}e.writeUInt8=d;function p(o){return R.consumeReadable(o,l=>L.concat(l))}e.readableToBuffer=p;function h(o){return R.toReadable(o)}e.bufferToReadable=h;function u(o){return R.consumeStream(o,l=>L.concat(l))}e.streamToBuffer=u;async function f(o){return o.ended?L.concat(o.buffer):L.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=f;function v(o){return R.toStream(o,l=>L.concat(l))}e.bufferToStream=v;function b(o){return R.transform(o,{data:l=>typeof l=="string"?L.fromString(l):L.wrap(l)},l=>L.concat(l))}e.streamToBufferReadableStream=b;function I(o){return R.newWriteableStream(l=>L.concat(l),o)}e.newWriteableBufferStream=I;function i(o,l){return R.prefixedReadable(o,l,m=>L.concat(m))}e.prefixedBufferReadable=i;function s(o,l){return R.prefixedStream(o,l,m=>L.concat(m))}e.prefixedBufferStream=s;function t(o){let l=0,m=0,E=0;const A=new Uint8Array(Math.floor(o.length/4*3)),O=M=>{switch(m){case 3:A[E++]=l|M,m=0;break;case 2:A[E++]=l|M>>>2,l=M<<6,m=3;break;case 1:A[E++]=l|M>>>4,l=M<<4,m=2;break;default:l=M<<2,m=1}};for(let M=0;M<o.length;M++){const k=o.charCodeAt(M);if(k>=65&&k<=90)O(k-65);else if(k>=97&&k<=122)O(k-97+26);else if(k>=48&&k<=57)O(k-48+52);else if(k===43||k===45)O(62);else if(k===47||k===95)O(63);else{if(k===61)break;throw new SyntaxError(`Unexpected base64 character ${o[M]}`)}}const F=E;for(;m>0;)O(0);return L.wrap(A).slice(0,F)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},l=!0,m=!1){const E=m?r:n;let A="";const O=o.byteLength%3;let F=0;for(;F<o.byteLength-O;F+=3){const M=o[F+0],k=o[F+1],N=o[F+2];A+=E[M>>>2],A+=E[(M<<4|k>>>4)&63],A+=E[(k<<2|N>>>6)&63],A+=E[N&63]}if(O===1){const M=o[F+0];A+=E[M>>>2],A+=E[M<<4&63],l&&(A+="==")}else if(O===2){const M=o[F+0],k=o[F+1];A+=E[M>>>2],A+=E[(M<<4|k>>>4)&63],A+=E[k<<2&63],l&&(A+="=")}return A}e.encodeBase64=a}),define(se[133],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(se[12],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function R(s){return typeof s=="string"}e.isString=R;function _(s){return Array.isArray(s)&&s.every(t=>R(t))}e.isStringArray=_;function c(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=c;function T(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.isTypedArray=T;function L(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=L;function D(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=D;function C(s){return s===!0||s===!1}e.isBoolean=C;function w(s){return typeof s>"u"}e.isUndefined=w;function P(s){return!y(s)}e.isDefined=P;function y(s){return w(s)||s===null}e.isUndefinedOrNull=y;function g(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=g;function S(s){if(y(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=S;function d(...s){const t=[];for(let n=0;n<s.length;n++){const r=s[n];if(y(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(r)}return t}e.assertAllDefined=d;const p=Object.prototype.hasOwnProperty;function h(s){if(!c(s))return!1;for(const t in s)if(p.call(s,t))return!1;return!0}e.isEmptyObject=h;function u(s){return typeof s=="function"}e.isFunction=u;function f(...s){return s.length>0&&s.every(u)}e.areFunctions=f;function v(s,t){const n=Math.min(s.length,t.length);for(let r=0;r<n;r++)b(s[r],t[r])}e.validateConstraints=v;function b(s,t){if(R(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(s instanceof t)return}catch{}if(!y(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=b;function I(s){return s===null?void 0:s}e.withNullAsUndefined=I;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(se[52],oe([0,1,12]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const _=Object.create(null);function c(D,C){if((0,R.isString)(C)){const w=_[C];if(w===void 0)throw new Error(`${D} references an unknown codicon: ${C}`);C=w}return _[D]=C,{id:D}}function T(){return _}e.getCodiconFontCharacters=T;function L(){return Object.values(e.Codicon)}e.getAllCodicons=L,e.Codicon={add:c("add",6e4),plus:c("plus",6e4),gistNew:c("gist-new",6e4),repoCreate:c("repo-create",6e4),lightbulb:c("lightbulb",60001),lightBulb:c("light-bulb",60001),repo:c("repo",60002),repoDelete:c("repo-delete",60002),gistFork:c("gist-fork",60003),repoForked:c("repo-forked",60003),gitPullRequest:c("git-pull-request",60004),gitPullRequestAbandoned:c("git-pull-request-abandoned",60004),recordKeys:c("record-keys",60005),keyboard:c("keyboard",60005),tag:c("tag",60006),tagAdd:c("tag-add",60006),tagRemove:c("tag-remove",60006),person:c("person",60007),personFollow:c("person-follow",60007),personOutline:c("person-outline",60007),personFilled:c("person-filled",60007),gitBranch:c("git-branch",60008),gitBranchCreate:c("git-branch-create",60008),gitBranchDelete:c("git-branch-delete",60008),sourceControl:c("source-control",60008),mirror:c("mirror",60009),mirrorPublic:c("mirror-public",60009),star:c("star",60010),starAdd:c("star-add",60010),starDelete:c("star-delete",60010),starEmpty:c("star-empty",60010),comment:c("comment",60011),commentAdd:c("comment-add",60011),alert:c("alert",60012),warning:c("warning",60012),search:c("search",60013),searchSave:c("search-save",60013),logOut:c("log-out",60014),signOut:c("sign-out",60014),logIn:c("log-in",60015),signIn:c("sign-in",60015),eye:c("eye",60016),eyeUnwatch:c("eye-unwatch",60016),eyeWatch:c("eye-watch",60016),circleFilled:c("circle-filled",60017),primitiveDot:c("primitive-dot",60017),closeDirty:c("close-dirty",60017),debugBreakpoint:c("debug-breakpoint",60017),debugBreakpointDisabled:c("debug-breakpoint-disabled",60017),debugHint:c("debug-hint",60017),primitiveSquare:c("primitive-square",60018),edit:c("edit",60019),pencil:c("pencil",60019),info:c("info",60020),issueOpened:c("issue-opened",60020),gistPrivate:c("gist-private",60021),gitForkPrivate:c("git-fork-private",60021),lock:c("lock",60021),mirrorPrivate:c("mirror-private",60021),close:c("close",60022),removeClose:c("remove-close",60022),x:c("x",60022),repoSync:c("repo-sync",60023),sync:c("sync",60023),clone:c("clone",60024),desktopDownload:c("desktop-download",60024),beaker:c("beaker",60025),microscope:c("microscope",60025),vm:c("vm",60026),deviceDesktop:c("device-desktop",60026),file:c("file",60027),fileText:c("file-text",60027),more:c("more",60028),ellipsis:c("ellipsis",60028),kebabHorizontal:c("kebab-horizontal",60028),mailReply:c("mail-reply",60029),reply:c("reply",60029),organization:c("organization",60030),organizationFilled:c("organization-filled",60030),organizationOutline:c("organization-outline",60030),newFile:c("new-file",60031),fileAdd:c("file-add",60031),newFolder:c("new-folder",60032),fileDirectoryCreate:c("file-directory-create",60032),trash:c("trash",60033),trashcan:c("trashcan",60033),history:c("history",60034),clock:c("clock",60034),folder:c("folder",60035),fileDirectory:c("file-directory",60035),symbolFolder:c("symbol-folder",60035),logoGithub:c("logo-github",60036),markGithub:c("mark-github",60036),github:c("github",60036),terminal:c("terminal",60037),console:c("console",60037),repl:c("repl",60037),zap:c("zap",60038),symbolEvent:c("symbol-event",60038),error:c("error",60039),stop:c("stop",60039),variable:c("variable",60040),symbolVariable:c("symbol-variable",60040),array:c("array",60042),symbolArray:c("symbol-array",60042),symbolModule:c("symbol-module",60043),symbolPackage:c("symbol-package",60043),symbolNamespace:c("symbol-namespace",60043),symbolObject:c("symbol-object",60043),symbolMethod:c("symbol-method",60044),symbolFunction:c("symbol-function",60044),symbolConstructor:c("symbol-constructor",60044),symbolBoolean:c("symbol-boolean",60047),symbolNull:c("symbol-null",60047),symbolNumeric:c("symbol-numeric",60048),symbolNumber:c("symbol-number",60048),symbolStructure:c("symbol-structure",60049),symbolStruct:c("symbol-struct",60049),symbolParameter:c("symbol-parameter",60050),symbolTypeParameter:c("symbol-type-parameter",60050),symbolKey:c("symbol-key",60051),symbolText:c("symbol-text",60051),symbolReference:c("symbol-reference",60052),goToFile:c("go-to-file",60052),symbolEnum:c("symbol-enum",60053),symbolValue:c("symbol-value",60053),symbolRuler:c("symbol-ruler",60054),symbolUnit:c("symbol-unit",60054),activateBreakpoints:c("activate-breakpoints",60055),archive:c("archive",60056),arrowBoth:c("arrow-both",60057),arrowDown:c("arrow-down",60058),arrowLeft:c("arrow-left",60059),arrowRight:c("arrow-right",60060),arrowSmallDown:c("arrow-small-down",60061),arrowSmallLeft:c("arrow-small-left",60062),arrowSmallRight:c("arrow-small-right",60063),arrowSmallUp:c("arrow-small-up",60064),arrowUp:c("arrow-up",60065),bell:c("bell",60066),bold:c("bold",60067),book:c("book",60068),bookmark:c("bookmark",60069),debugBreakpointConditionalUnverified:c("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:c("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:c("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:c("debug-breakpoint-data-unverified",60072),debugBreakpointData:c("debug-breakpoint-data",60073),debugBreakpointDataDisabled:c("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:c("debug-breakpoint-log-unverified",60074),debugBreakpointLog:c("debug-breakpoint-log",60075),debugBreakpointLogDisabled:c("debug-breakpoint-log-disabled",60075),briefcase:c("briefcase",60076),broadcast:c("broadcast",60077),browser:c("browser",60078),bug:c("bug",60079),calendar:c("calendar",60080),caseSensitive:c("case-sensitive",60081),check:c("check",60082),checklist:c("checklist",60083),chevronDown:c("chevron-down",60084),dropDownButton:c("drop-down-button",60084),chevronLeft:c("chevron-left",60085),chevronRight:c("chevron-right",60086),chevronUp:c("chevron-up",60087),chromeClose:c("chrome-close",60088),chromeMaximize:c("chrome-maximize",60089),chromeMinimize:c("chrome-minimize",60090),chromeRestore:c("chrome-restore",60091),circle:c("circle",60092),circleOutline:c("circle-outline",60092),debugBreakpointUnverified:c("debug-breakpoint-unverified",60092),circleSlash:c("circle-slash",60093),circuitBoard:c("circuit-board",60094),clearAll:c("clear-all",60095),clippy:c("clippy",60096),closeAll:c("close-all",60097),cloudDownload:c("cloud-download",60098),cloudUpload:c("cloud-upload",60099),code:c("code",60100),collapseAll:c("collapse-all",60101),colorMode:c("color-mode",60102),commentDiscussion:c("comment-discussion",60103),compareChanges:c("compare-changes",60157),creditCard:c("credit-card",60105),dash:c("dash",60108),dashboard:c("dashboard",60109),database:c("database",60110),debugContinue:c("debug-continue",60111),debugDisconnect:c("debug-disconnect",60112),debugPause:c("debug-pause",60113),debugRestart:c("debug-restart",60114),debugStart:c("debug-start",60115),debugStepInto:c("debug-step-into",60116),debugStepOut:c("debug-step-out",60117),debugStepOver:c("debug-step-over",60118),debugStop:c("debug-stop",60119),debug:c("debug",60120),deviceCameraVideo:c("device-camera-video",60121),deviceCamera:c("device-camera",60122),deviceMobile:c("device-mobile",60123),diffAdded:c("diff-added",60124),diffIgnored:c("diff-ignored",60125),diffModified:c("diff-modified",60126),diffRemoved:c("diff-removed",60127),diffRenamed:c("diff-renamed",60128),diff:c("diff",60129),discard:c("discard",60130),editorLayout:c("editor-layout",60131),emptyWindow:c("empty-window",60132),exclude:c("exclude",60133),extensions:c("extensions",60134),eyeClosed:c("eye-closed",60135),fileBinary:c("file-binary",60136),fileCode:c("file-code",60137),fileMedia:c("file-media",60138),filePdf:c("file-pdf",60139),fileSubmodule:c("file-submodule",60140),fileSymlinkDirectory:c("file-symlink-directory",60141),fileSymlinkFile:c("file-symlink-file",60142),fileZip:c("file-zip",60143),files:c("files",60144),filter:c("filter",60145),flame:c("flame",60146),foldDown:c("fold-down",60147),foldUp:c("fold-up",60148),fold:c("fold",60149),folderActive:c("folder-active",60150),folderOpened:c("folder-opened",60151),gear:c("gear",60152),gift:c("gift",60153),gistSecret:c("gist-secret",60154),gist:c("gist",60155),gitCommit:c("git-commit",60156),gitCompare:c("git-compare",60157),gitMerge:c("git-merge",60158),githubAction:c("github-action",60159),githubAlt:c("github-alt",60160),globe:c("globe",60161),grabber:c("grabber",60162),graph:c("graph",60163),gripper:c("gripper",60164),heart:c("heart",60165),home:c("home",60166),horizontalRule:c("horizontal-rule",60167),hubot:c("hubot",60168),inbox:c("inbox",60169),issueClosed:c("issue-closed",60324),issueReopened:c("issue-reopened",60171),issues:c("issues",60172),italic:c("italic",60173),jersey:c("jersey",60174),json:c("json",60175),bracket:c("bracket",60175),kebabVertical:c("kebab-vertical",60176),key:c("key",60177),law:c("law",60178),lightbulbAutofix:c("lightbulb-autofix",60179),linkExternal:c("link-external",60180),link:c("link",60181),listOrdered:c("list-ordered",60182),listUnordered:c("list-unordered",60183),liveShare:c("live-share",60184),loading:c("loading",60185),location:c("location",60186),mailRead:c("mail-read",60187),mail:c("mail",60188),markdown:c("markdown",60189),megaphone:c("megaphone",60190),mention:c("mention",60191),milestone:c("milestone",60192),mortarBoard:c("mortar-board",60193),move:c("move",60194),multipleWindows:c("multiple-windows",60195),mute:c("mute",60196),noNewline:c("no-newline",60197),note:c("note",60198),octoface:c("octoface",60199),openPreview:c("open-preview",60200),package_:c("package",60201),paintcan:c("paintcan",60202),pin:c("pin",60203),play:c("play",60204),run:c("run",60204),plug:c("plug",60205),preserveCase:c("preserve-case",60206),preview:c("preview",60207),project:c("project",60208),pulse:c("pulse",60209),question:c("question",60210),quote:c("quote",60211),radioTower:c("radio-tower",60212),reactions:c("reactions",60213),references:c("references",60214),refresh:c("refresh",60215),regex:c("regex",60216),remoteExplorer:c("remote-explorer",60217),remote:c("remote",60218),remove:c("remove",60219),replaceAll:c("replace-all",60220),replace:c("replace",60221),repoClone:c("repo-clone",60222),repoForcePush:c("repo-force-push",60223),repoPull:c("repo-pull",60224),repoPush:c("repo-push",60225),report:c("report",60226),requestChanges:c("request-changes",60227),rocket:c("rocket",60228),rootFolderOpened:c("root-folder-opened",60229),rootFolder:c("root-folder",60230),rss:c("rss",60231),ruby:c("ruby",60232),saveAll:c("save-all",60233),saveAs:c("save-as",60234),save:c("save",60235),screenFull:c("screen-full",60236),screenNormal:c("screen-normal",60237),searchStop:c("search-stop",60238),server:c("server",60240),settingsGear:c("settings-gear",60241),settings:c("settings",60242),shield:c("shield",60243),smiley:c("smiley",60244),sortPrecedence:c("sort-precedence",60245),splitHorizontal:c("split-horizontal",60246),splitVertical:c("split-vertical",60247),squirrel:c("squirrel",60248),starFull:c("star-full",60249),starHalf:c("star-half",60250),symbolClass:c("symbol-class",60251),symbolColor:c("symbol-color",60252),symbolCustomColor:c("symbol-customcolor",60252),symbolConstant:c("symbol-constant",60253),symbolEnumMember:c("symbol-enum-member",60254),symbolField:c("symbol-field",60255),symbolFile:c("symbol-file",60256),symbolInterface:c("symbol-interface",60257),symbolKeyword:c("symbol-keyword",60258),symbolMisc:c("symbol-misc",60259),symbolOperator:c("symbol-operator",60260),symbolProperty:c("symbol-property",60261),wrench:c("wrench",60261),wrenchSubaction:c("wrench-subaction",60261),symbolSnippet:c("symbol-snippet",60262),tasklist:c("tasklist",60263),telescope:c("telescope",60264),textSize:c("text-size",60265),threeBars:c("three-bars",60266),thumbsdown:c("thumbsdown",60267),thumbsup:c("thumbsup",60268),tools:c("tools",60269),triangleDown:c("triangle-down",60270),triangleLeft:c("triangle-left",60271),triangleRight:c("triangle-right",60272),triangleUp:c("triangle-up",60273),twitter:c("twitter",60274),unfold:c("unfold",60275),unlock:c("unlock",60276),unmute:c("unmute",60277),unverified:c("unverified",60278),verified:c("verified",60279),versions:c("versions",60280),vmActive:c("vm-active",60281),vmOutline:c("vm-outline",60282),vmRunning:c("vm-running",60283),watch:c("watch",60284),whitespace:c("whitespace",60285),wholeWord:c("whole-word",60286),window:c("window",60287),wordWrap:c("word-wrap",60288),zoomIn:c("zoom-in",60289),zoomOut:c("zoom-out",60290),listFilter:c("list-filter",60291),listFlat:c("list-flat",60292),listSelection:c("list-selection",60293),selection:c("selection",60293),listTree:c("list-tree",60294),debugBreakpointFunctionUnverified:c("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:c("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:c("debug-breakpoint-function-disabled",60296),debugStackframeActive:c("debug-stackframe-active",60297),circleSmallFilled:c("circle-small-filled",60298),debugStackframeDot:c("debug-stackframe-dot",60298),debugStackframe:c("debug-stackframe",60299),debugStackframeFocused:c("debug-stackframe-focused",60299),debugBreakpointUnsupported:c("debug-breakpoint-unsupported",60300),symbolString:c("symbol-string",60301),debugReverseContinue:c("debug-reverse-continue",60302),debugStepBack:c("debug-step-back",60303),debugRestartFrame:c("debug-restart-frame",60304),callIncoming:c("call-incoming",60306),callOutgoing:c("call-outgoing",60307),menu:c("menu",60308),expandAll:c("expand-all",60309),feedback:c("feedback",60310),groupByRefType:c("group-by-ref-type",60311),ungroupByRefType:c("ungroup-by-ref-type",60312),account:c("account",60313),bellDot:c("bell-dot",60314),debugConsole:c("debug-console",60315),library:c("library",60316),output:c("output",60317),runAll:c("run-all",60318),syncIgnored:c("sync-ignored",60319),pinned:c("pinned",60320),githubInverted:c("github-inverted",60321),debugAlt:c("debug-alt",60305),serverProcess:c("server-process",60322),serverEnvironment:c("server-environment",60323),pass:c("pass",60324),stopCircle:c("stop-circle",60325),playCircle:c("play-circle",60326),record:c("record",60327),debugAltSmall:c("debug-alt-small",60328),vmConnect:c("vm-connect",60329),cloud:c("cloud",60330),merge:c("merge",60331),exportIcon:c("export",60332),graphLeft:c("graph-left",60333),magnet:c("magnet",60334),notebook:c("notebook",60335),redo:c("redo",60336),checkAll:c("check-all",60337),pinnedDirty:c("pinned-dirty",60338),passFilled:c("pass-filled",60339),circleLargeFilled:c("circle-large-filled",60340),circleLarge:c("circle-large",60341),circleLargeOutline:c("circle-large-outline",60341),combine:c("combine",60342),gather:c("gather",60342),table:c("table",60343),variableGroup:c("variable-group",60344),typeHierarchy:c("type-hierarchy",60345),typeHierarchySub:c("type-hierarchy-sub",60346),typeHierarchySuper:c("type-hierarchy-super",60347),gitPullRequestCreate:c("git-pull-request-create",60348),runAbove:c("run-above",60349),runBelow:c("run-below",60350),notebookTemplate:c("notebook-template",60351),debugRerun:c("debug-rerun",60352),workspaceTrusted:c("workspace-trusted",60353),workspaceUntrusted:c("workspace-untrusted",60354),workspaceUnspecified:c("workspace-unspecified",60355),terminalCmd:c("terminal-cmd",60356),terminalDebian:c("terminal-debian",60357),terminalLinux:c("terminal-linux",60358),terminalPowershell:c("terminal-powershell",60359),terminalTmux:c("terminal-tmux",60360),terminalUbuntu:c("terminal-ubuntu",60361),terminalBash:c("terminal-bash",60362),arrowSwap:c("arrow-swap",60363),copy:c("copy",60364),personAdd:c("person-add",60365),filterFilled:c("filter-filled",60366),wand:c("wand",60367),debugLineByLine:c("debug-line-by-line",60368),inspect:c("inspect",60369),layers:c("layers",60370),layersDot:c("layers-dot",60371),layersActive:c("layers-active",60372),compass:c("compass",60373),compassDot:c("compass-dot",60374),compassActive:c("compass-active",60375),azure:c("azure",60376),issueDraft:c("issue-draft",60377),gitPullRequestClosed:c("git-pull-request-closed",60378),gitPullRequestDraft:c("git-pull-request-draft",60379),debugAll:c("debug-all",60380),debugCoverage:c("debug-coverage",60381),runErrors:c("run-errors",60382),folderLibrary:c("folder-library",60383),debugContinueSmall:c("debug-continue-small",60384),beakerStop:c("beaker-stop",60385),graphLine:c("graph-line",60386),graphScatter:c("graph-scatter",60387),pieChart:c("pie-chart",60388),bracketDot:c("bracket-dot",60389),bracketError:c("bracket-error",60390),lockSmall:c("lock-small",60391),azureDevops:c("azure-devops",60392),verifiedFilled:c("verified-filled",60393),newLine:c("newline",60394),layout:c("layout",60395),layoutActivitybarLeft:c("layout-activitybar-left",60396),layoutActivitybarRight:c("layout-activitybar-right",60397),layoutPanelLeft:c("layout-panel-left",60398),layoutPanelCenter:c("layout-panel-center",60399),layoutPanelJustify:c("layout-panel-justify",60400),layoutPanelRight:c("layout-panel-right",60401),layoutPanel:c("layout-panel",60402),layoutSidebarLeft:c("layout-sidebar-left",60403),layoutSidebarRight:c("layout-sidebar-right",60404),layoutStatusbar:c("layout-statusbar",60405),layoutMenubar:c("layout-menubar",60406),layoutCentered:c("layout-centered",60407),layoutSidebarRightOff:c("layout-sidebar-right-off",60416),layoutPanelOff:c("layout-panel-off",60417),layoutSidebarLeftOff:c("layout-sidebar-left-off",60418),target:c("target",60408),indent:c("indent",60409),recordSmall:c("record-small",60410),errorSmall:c("error-small",60411),arrowCircleDown:c("arrow-circle-down",60412),arrowCircleLeft:c("arrow-circle-left",60413),arrowCircleRight:c("arrow-circle-right",60414),arrowCircleUp:c("arrow-circle-up",60415),heartFilled:c("heart-filled",60420),map:c("map",60421),mapFilled:c("map-filled",60422),circleSmall:c("circle-small",60423),bellSlash:c("bell-slash",60424),bellSlashDot:c("bell-slash-dot",60425),commentUnresolved:c("comment-unresolved",60426),gitPullRequestGoToChanges:c("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:c("git-pull-request-new-changes",60428),searchFuzzy:c("search-fuzzy",60429),commentDraft:c("comment-draft",60430),dialogError:c("dialog-error","error"),dialogWarning:c("dialog-warning","warning"),dialogInfo:c("dialog-info","info"),dialogClose:c("dialog-close","close"),treeItemExpanded:c("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:c("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:c("tree-filter-on-type-off","list-selection"),treeFilterClear:c("tree-filter-clear","close"),treeItemLoading:c("tree-item-loading","loading"),menuSelection:c("menu-selection","check"),menuSubmenu:c("menu-submenu","chevron-right"),menuBarMore:c("menubar-more","more"),scrollbarButtonLeft:c("scrollbar-button-left","triangle-left"),scrollbarButtonRight:c("scrollbar-button-right","triangle-right"),scrollbarButtonUp:c("scrollbar-button-up","triangle-up"),scrollbarButtonDown:c("scrollbar-button-down","triangle-down"),toolBarMore:c("toolbar-more","more"),quickInputBack:c("quick-input-back","arrow-left")}}),define(se[32],oe([0,1,12]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function _(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const f=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([v,b])=>{f[v]=b&&typeof b=="object"?_(b):b}),f}e.deepClone=_;function c(u){if(!u||typeof u!="object")return u;const f=[u];for(;f.length>0;){const v=f.shift();Object.freeze(v);for(const b in v)if(T.call(v,b)){const I=v[b];typeof I=="object"&&!Object.isFrozen(I)&&!(0,R.isTypedArray)(I)&&f.push(I)}}return u}e.deepFreeze=c;const T=Object.prototype.hasOwnProperty;function L(u,f){return D(u,f,new Set)}e.cloneAndChange=L;function D(u,f,v){if((0,R.isUndefinedOrNull)(u))return u;const b=f(u);if(typeof b<"u")return b;if(Array.isArray(u)){const I=[];for(const i of u)I.push(D(i,f,v));return I}if((0,R.isObject)(u)){if(v.has(u))throw new Error("Cannot clone recursive data-structure");v.add(u);const I={};for(const i in u)T.call(u,i)&&(I[i]=D(u[i],f,v));return v.delete(u),I}return u}function C(u,f,v=!0){return(0,R.isObject)(u)?((0,R.isObject)(f)&&Object.keys(f).forEach(b=>{b in u?v&&((0,R.isObject)(u[b])&&(0,R.isObject)(f[b])?C(u[b],f[b],v):u[b]=f[b]):u[b]=f[b]}),u):f}e.mixin=C;function w(u,f){if(u===f)return!0;if(u==null||f===null||f===void 0||typeof u!=typeof f||typeof u!="object"||Array.isArray(u)!==Array.isArray(f))return!1;let v,b;if(Array.isArray(u)){if(u.length!==f.length)return!1;for(v=0;v<u.length;v++)if(!w(u[v],f[v]))return!1}else{const I=[];for(b in u)I.push(b);I.sort();const i=[];for(b in f)i.push(b);if(i.sort(),!w(I,i))return!1;for(v=0;v<I.length;v++)if(!w(u[I[v]],f[I[v]]))return!1}return!0}e.equals=w;function P(u){const f=new Set;return JSON.stringify(u,(v,b)=>{if((0,R.isObject)(b)||Array.isArray(b)){if(f.has(b))return"[Circular]";f.add(b)}return b})}e.safeStringify=P;function y(u,f){const v=Object.create(null);return!u||!f||Object.keys(f).forEach(I=>{const i=u[I],s=f[I];w(i,s)||(v[I]=s)}),v}e.distinct=y;function g(u,f){const v=f.toLowerCase(),b=Object.keys(u).find(I=>I.toLowerCase()===v);return b?u[b]:u[f]}e.getCaseInsensitive=g;function S(u,f){const v=Object.create(null);for(const[b,I]of Object.entries(u))f(b,I)&&(v[b]=I);return v}e.filter=S;function d(u){let f=[],v=Object.getPrototypeOf(u);for(;Object.prototype!==v;)f=f.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return f}e.getAllPropertyNames=d;function p(u){const f=[];for(const v of d(u))typeof u[v]=="function"&&f.push(v);return f}e.getAllMethodNames=p;function h(u,f){const v=I=>function(){const i=Array.prototype.slice.call(arguments,0);return f(I,i)},b={};for(const I of u)b[I]=v(I);return b}e.createProxyObject=h}),define(se[134],oe([0,1,52]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var _;(function(L){function D(C){return C&&typeof C=="object"&&typeof C.id=="string"}L.isThemeColor=D})(_=e.ThemeColor||(e.ThemeColor={}));function c(L){return{id:L}}e.themeColorFromId=c;var T;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function C(f){const v=D.exec(f.id);if(!v)return C(R.Codicon.error);const[,b,I]=v,i=["codicon","codicon-"+b];return I&&i.push("codicon-modifier-"+I.substring(1)),i}L.asClassNameArray=C;function w(f){return C(f).join(" ")}L.asClassName=w;function P(f){return"."+C(f).join(".")}L.asCSSSelector=P;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||_.isThemeColor(f.color))}L.isThemeIcon=y;const g=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function S(f){const v=g.exec(f);if(!v)return;const[,b]=v;return{id:b}}L.fromString=S;function d(f){return{id:f}}L.fromId=d;function p(f,v){let b=f.id;const I=b.lastIndexOf("~");return I!==-1&&(b=b.substring(0,I)),v&&(b=`${b}~${v}`),{id:b}}L.modify=p;function h(f){const v=f.id.lastIndexOf("~");if(v!==-1)return f.id.substring(v+1)}L.getModifier=h;function u(f,v){return f.id===v.id&&f.color?.id===v.color?.id}L.isEqual=u})(T=e.ThemeIcon||(e.ThemeIcon={}))}),define(se[31],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function _(c){return R.test(c)}e.isUUID=_,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let c;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?c=crypto.getRandomValues.bind(crypto):c=function(D){for(let C=0;C<D.length;C++)D[C]=Math.floor(Math.random()*256);return D};const T=new Uint8Array(16),L=[];for(let D=0;D<256;D++)L.push(D.toString(16).padStart(2,"0"));return function(){c(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let C=0,w="";return w+=L[T[C++]],w+=L[T[C++]],w+=L[T[C++]],w+=L[T[C++]],w+="-",w+=L[T[C++]],w+=L[T[C++]],w+="-",w+=L[T[C++]],w+=L[T[C++]],w+="-",w+=L[T[C++]],w+=L[T[C++]],w+="-",w+=L[T[C++]],w+=L[T[C++]],w+=L[T[C++]],w+=L[T[C++]],w+=L[T[C++]],w+=L[T[C++]],w}}()}),define(se[135],oe([0,1,34]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const _=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function c(L){const D=L.replace(/\-/g,":").toLowerCase();return!_.has(D)}function T(){const L=(0,R.networkInterfaces)();for(const D in L){const C=L[D];if(C){for(const{mac:w}of C)if(c(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(se[136],oe([0,1,86]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function _(D,C,w,P=1){let y=!1;return new Promise(g=>{const S=setTimeout(()=>{if(!y)return y=!0,g(0)},w);c(D,C,P,d=>{if(!y)return y=!0,clearTimeout(S),g(d)})})}e.findFreePort=_;function c(D,C,w,P){if(C===0)return P(0);const y=new R.Socket;y.once("connect",()=>(L(y),c(D+w,C-1,w,P))),y.once("data",()=>{}),y.once("error",g=>(L(y),g.code!=="ECONNREFUSED"?c(D+w,C-1,w,P):P(D))),y.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(D,C,w,P="127.0.0.1"){let y=!1,g,S=1;const d=R.createServer({pauseOnConnect:!0});function p(h,u){y||(y=!0,d.removeAllListeners(),d.close(),g&&clearTimeout(g),u(h))}return new Promise(h=>{g=setTimeout(()=>{p(0,h)},w),d.on("listening",()=>{p(D,h)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&S<C?(D++,S++,d.listen(D,P)):p(0,h)}),d.on("close",()=>{p(0,h)}),d.listen(D,P)})}e.findFreePortFaster=T;function L(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(C){console.error(C)}}}),define(se[137],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function _(T){return T instanceof c?!0:T instanceof Error&&T.name===R&&T.message===R}e.isOfflineError=_;class c extends Error{constructor(){super(R),this.name=this.message}}e.OfflineError=c}),define(se[138],oe([0,1,17,9,137]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(C,w){if(!navigator.onLine)throw new c.OfflineError;C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const P=new XMLHttpRequest;return new Promise((y,g)=>{P.open(C.type||"GET",C.url||"",!0,C.user,C.password),L(P,C),P.responseType="arraybuffer",P.onerror=S=>g(new Error(P.statusText&&"XHR failed: "+P.statusText||"XHR failed")),P.onload=S=>{y({res:{statusCode:P.status,headers:D(P)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(P.response)))})},P.ontimeout=S=>g(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(P.timeout=C.timeout),P.send(C.data),w.onCancellationRequested(()=>{P.abort(),g((0,_.canceled)())})})}e.request=T;function L(C,w){if(w.headers){e:for(const P in w.headers){switch(P){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(P,w.headers[P])}}}function D(C){const w=Object.create(null);for(const P of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(P){const y=P.indexOf(":");w[P.substr(0,y).trim().toLowerCase()]=P.substr(y+1).trim()}return w}}),define(se[139],oe([10,7]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(se[65],oe([0,1,139]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const _=60,c=_*60,T=c*24,L=T*7,D=T*30,C=T*365;function w(y,g,S,d){typeof y!="number"&&(y=y.getTime());const p=Math.round((new Date().getTime()-y)/1e3);if(p<-30)return(0,R.localize)(0,null,w(new Date().getTime()+p*1e3,!1));if(!d&&p<30)return(0,R.localize)(1,null);let h;return p<_?(h=p,g?h===1?S?(0,R.localize)(2,null,h):(0,R.localize)(3,null,h):S?(0,R.localize)(4,null,h):(0,R.localize)(5,null,h):h===1?S?(0,R.localize)(6,null,h):(0,R.localize)(7,null,h):S?(0,R.localize)(8,null,h):(0,R.localize)(9,null,h)):p<c?(h=Math.floor(p/_),g?h===1?S?(0,R.localize)(10,null,h):(0,R.localize)(11,null,h):S?(0,R.localize)(12,null,h):(0,R.localize)(13,null,h):h===1?S?(0,R.localize)(14,null,h):(0,R.localize)(15,null,h):S?(0,R.localize)(16,null,h):(0,R.localize)(17,null,h)):p<T?(h=Math.floor(p/c),g?h===1?S?(0,R.localize)(18,null,h):(0,R.localize)(19,null,h):S?(0,R.localize)(20,null,h):(0,R.localize)(21,null,h):h===1?S?(0,R.localize)(22,null,h):(0,R.localize)(23,null,h):S?(0,R.localize)(24,null,h):(0,R.localize)(25,null,h)):p<L?(h=Math.floor(p/T),g?h===1?(0,R.localize)(26,null,h):(0,R.localize)(27,null,h):h===1?(0,R.localize)(28,null,h):(0,R.localize)(29,null,h)):p<D?(h=Math.floor(p/L),g?h===1?S?(0,R.localize)(30,null,h):(0,R.localize)(31,null,h):S?(0,R.localize)(32,null,h):(0,R.localize)(33,null,h):h===1?S?(0,R.localize)(34,null,h):(0,R.localize)(35,null,h):S?(0,R.localize)(36,null,h):(0,R.localize)(37,null,h)):p<C?(h=Math.floor(p/D),g?h===1?S?(0,R.localize)(38,null,h):(0,R.localize)(39,null,h):S?(0,R.localize)(40,null,h):(0,R.localize)(41,null,h):h===1?S?(0,R.localize)(42,null,h):(0,R.localize)(43,null,h):S?(0,R.localize)(44,null,h):(0,R.localize)(45,null,h)):(h=Math.floor(p/C),g?h===1?S?(0,R.localize)(46,null,h):(0,R.localize)(47,null,h):S?(0,R.localize)(48,null,h):(0,R.localize)(49,null,h):h===1?S?(0,R.localize)(50,null,h):(0,R.localize)(51,null,h):S?(0,R.localize)(52,null,h):(0,R.localize)(53,null,h))}e.fromNow=w;function P(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(se[140],oe([10,7]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(se[38],oe([0,1,21,12,140]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(y,g){return g&&(y.stack||y.stacktrace)?c.localize(0,null,D(y),L(y.stack)||L(y.stacktrace)):D(y)}function L(y){return Array.isArray(y)?y.join(`
`):y}function D(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?c.localize(1,null,y.message):y.message||c.localize(2,null)}function C(y=null,g=!1){if(!y)return c.localize(3,null);if(Array.isArray(y)){const S=R.coalesce(y),d=C(S[0],g);return S.length>1?c.localize(4,null,d,S.length):d}if(_.isString(y))return y;if(y.detail){const S=y.detail;if(S.error)return T(S.error,g);if(S.exception)return T(S.exception,g)}return y.stack?T(y,g):y.message?y.message:c.localize(5,null)}e.toErrorMessage=C;function w(y){const g=y;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=w;function P(y,g){let S;return typeof y=="string"?S=new Error(y):S=y,S.actions=g,S}e.createErrorWithActions=P}),define(se[141],oe([10,7]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(se[142],oe([0,1,141]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function _(c){switch(c){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=_}),define(se[143],oe([10,7]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(se[4],oe([0,1,143]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let _=!1,c=!1,T=!1,L=!1,D=!1,C=!1,w=!1,P=!1,y=!1,g=!1,S,d=e.LANGUAGE_DEFAULT,p,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const f=typeof u?.versions?.electron=="string",v=f&&u?.type==="renderer";if(typeof navigator=="object"&&!v)h=navigator.userAgent,_=h.indexOf("Windows")>=0,c=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=h.indexOf("Linux")>=0,g=h?.indexOf("Mobi")>=0,C=!0,S=R.getConfiguredDefaultLocale(R.localize(0,null))||e.LANGUAGE_DEFAULT,d=S;else if(typeof u=="object"){_=u.platform==="win32",c=u.platform==="darwin",T=u.platform==="linux",L=T&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,w=f,y=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const l=JSON.parse(o),m=l.availableLanguages["*"];S=l.locale,d=m||e.LANGUAGE_DEFAULT,p=l._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var b;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function I(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let i=0;c?i=1:_?i=3:T&&(i=2),e.isWindows=_,e.isMacintosh=c,e.isLinux=T,e.isLinuxSnap=L,e.isNative=D,e.isElectron=w,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=g,e.isCI=y,e.platform=i,e.userAgent=h,e.language=d;var s;(function(o){function l(){return e.language}o.value=l;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=m;function E(){return e.language==="en"}o.isDefault=E})(s=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let E=0,A=o.length;E<A;E++){const O=o[E];if(O.id===m.data.vscodeScheduleAsyncWork){o.splice(E,1),O.callback();return}}});let l=0;return m=>{const E=++l;o.push({id:E,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return o=>setTimeout(o)})();var t;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=c||P?2:_?1:3;let n=!0,r=!1;function a(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,n=new Uint16Array(o.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(se[36],oe([0,1,4]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let _;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const c=R.globals.vscode.process;_={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?_={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:_={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=_.cwd,e.env=_.env,e.platform=_.platform,e.arch=_.arch}),define(se[13],oe([0,1,36]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const _=65,c=97,T=90,L=122,D=46,C=47,w=92,P=58,y=63;class g extends Error{constructor(s,t,n){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const a=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${a} ${r} of type ${t}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function S(i,s){if(i===null||typeof i!="object")throw new g(s,"Object",i)}function d(i,s){if(typeof i!="string")throw new g(s,"string",i)}const p=R.platform==="win32";function h(i){return i===C||i===w}function u(i){return i===C}function f(i){return i>=_&&i<=T||i>=c&&i<=L}function v(i,s,t,n){let r="",a=0,o=-1,l=0,m=0;for(let E=0;E<=i.length;++E){if(E<i.length)m=i.charCodeAt(E);else{if(n(m))break;m=C}if(n(m)){if(!(o===E-1||l===1))if(l===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==D||r.charCodeAt(r.length-2)!==D){if(r.length>2){const A=r.lastIndexOf(t);A===-1?(r="",a=0):(r=r.slice(0,A),a=r.length-1-r.lastIndexOf(t)),o=E,l=0;continue}else if(r.length!==0){r="",a=0,o=E,l=0;continue}}s&&(r+=r.length>0?`${t}..`:"..",a=2)}else r.length>0?r+=`${t}${i.slice(o+1,E)}`:r=i.slice(o+1,E),a=E-o-1;o=E,l=0}else m===D&&l!==-1?++l:l=-1}return r}function b(i,s){S(s,"pathObject");const t=s.dir||s.root,n=s.base||`${s.name||""}${s.ext||""}`;return t?t===s.root?`${t}${n}`:`${t}${i}${n}`:n}e.win32={resolve(...i){let s="",t="",n=!1;for(let r=i.length-1;r>=-1;r--){let a;if(r>=0){if(a=i[r],d(a,"path"),a.length===0)continue}else s.length===0?a=R.cwd():(a=R.env[`=${s}`]||R.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==s.toLowerCase()&&a.charCodeAt(2)===w)&&(a=`${s}\\`));const o=a.length;let l=0,m="",E=!1;const A=a.charCodeAt(0);if(o===1)h(A)&&(l=1,E=!0);else if(h(A))if(E=!0,h(a.charCodeAt(1))){let O=2,F=O;for(;O<o&&!h(a.charCodeAt(O));)O++;if(O<o&&O!==F){const M=a.slice(F,O);for(F=O;O<o&&h(a.charCodeAt(O));)O++;if(O<o&&O!==F){for(F=O;O<o&&!h(a.charCodeAt(O));)O++;(O===o||O!==F)&&(m=`\\\\${M}\\${a.slice(F,O)}`,l=O)}}}else l=1;else f(A)&&a.charCodeAt(1)===P&&(m=a.slice(0,2),l=2,o>2&&h(a.charCodeAt(2))&&(E=!0,l=3));if(m.length>0)if(s.length>0){if(m.toLowerCase()!==s.toLowerCase())continue}else s=m;if(n){if(s.length>0)break}else if(t=`${a.slice(l)}\\${t}`,n=E,E&&s.length>0)break}return t=v(t,!n,"\\",h),n?`${s}\\${t}`:`${s}${t}`||"."},normalize(i){d(i,"path");const s=i.length;if(s===0)return".";let t=0,n,r=!1;const a=i.charCodeAt(0);if(s===1)return u(a)?"\\":i;if(h(a))if(r=!0,h(i.charCodeAt(1))){let l=2,m=l;for(;l<s&&!h(i.charCodeAt(l));)l++;if(l<s&&l!==m){const E=i.slice(m,l);for(m=l;l<s&&h(i.charCodeAt(l));)l++;if(l<s&&l!==m){for(m=l;l<s&&!h(i.charCodeAt(l));)l++;if(l===s)return`\\\\${E}\\${i.slice(m)}\\`;l!==m&&(n=`\\\\${E}\\${i.slice(m,l)}`,t=l)}}}else t=1;else f(a)&&i.charCodeAt(1)===P&&(n=i.slice(0,2),t=2,s>2&&h(i.charCodeAt(2))&&(r=!0,t=3));let o=t<s?v(i.slice(t),!r,"\\",h):"";return o.length===0&&!r&&(o="."),o.length>0&&h(i.charCodeAt(s-1))&&(o+="\\"),n===void 0?r?`\\${o}`:o:r?`${n}\\${o}`:`${n}${o}`},isAbsolute(i){d(i,"path");const s=i.length;if(s===0)return!1;const t=i.charCodeAt(0);return h(t)||s>2&&f(t)&&i.charCodeAt(1)===P&&h(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,t;for(let a=0;a<i.length;++a){const o=i[a];d(o,"path"),o.length>0&&(s===void 0?s=t=o:s+=`\\${o}`)}if(s===void 0)return".";let n=!0,r=0;if(typeof t=="string"&&h(t.charCodeAt(0))){++r;const a=t.length;a>1&&h(t.charCodeAt(1))&&(++r,a>2&&(h(t.charCodeAt(2))?++r:n=!1))}if(n){for(;r<s.length&&h(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.win32.normalize(s)},relative(i,s){if(d(i,"from"),d(s,"to"),i===s)return"";const t=e.win32.resolve(i),n=e.win32.resolve(s);if(t===n||(i=t.toLowerCase(),s=n.toLowerCase(),i===s))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===w;)r++;let a=i.length;for(;a-1>r&&i.charCodeAt(a-1)===w;)a--;const o=a-r;let l=0;for(;l<s.length&&s.charCodeAt(l)===w;)l++;let m=s.length;for(;m-1>l&&s.charCodeAt(m-1)===w;)m--;const E=m-l,A=o<E?o:E;let O=-1,F=0;for(;F<A;F++){const k=i.charCodeAt(r+F);if(k!==s.charCodeAt(l+F))break;k===w&&(O=F)}if(F!==A){if(O===-1)return n}else{if(E>A){if(s.charCodeAt(l+F)===w)return n.slice(l+F+1);if(F===2)return n.slice(l+F)}o>A&&(i.charCodeAt(r+F)===w?O=F:F===2&&(O=3)),O===-1&&(O=0)}let M="";for(F=r+O+1;F<=a;++F)(F===a||i.charCodeAt(F)===w)&&(M+=M.length===0?"..":"\\..");return l+=O,M.length>0?`${M}${n.slice(l,m)}`:(n.charCodeAt(l)===w&&++l,n.slice(l,m))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===w){if(s.charCodeAt(1)===w){const t=s.charCodeAt(2);if(t!==y&&t!==D)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(f(s.charCodeAt(0))&&s.charCodeAt(1)===P&&s.charCodeAt(2)===w)return`\\\\?\\${s}`;return i},dirname(i){d(i,"path");const s=i.length;if(s===0)return".";let t=-1,n=0;const r=i.charCodeAt(0);if(s===1)return h(r)?i:".";if(h(r)){if(t=n=1,h(i.charCodeAt(1))){let l=2,m=l;for(;l<s&&!h(i.charCodeAt(l));)l++;if(l<s&&l!==m){for(m=l;l<s&&h(i.charCodeAt(l));)l++;if(l<s&&l!==m){for(m=l;l<s&&!h(i.charCodeAt(l));)l++;if(l===s)return i;l!==m&&(t=n=l+1)}}}}else f(r)&&i.charCodeAt(1)===P&&(t=s>2&&h(i.charCodeAt(2))?3:2,n=t);let a=-1,o=!0;for(let l=s-1;l>=n;--l)if(h(i.charCodeAt(l))){if(!o){a=l;break}}else o=!1;if(a===-1){if(t===-1)return".";a=t}return i.slice(0,a)},basename(i,s){s!==void 0&&d(s,"ext"),d(i,"path");let t=0,n=-1,r=!0,a;if(i.length>=2&&f(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(t=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let o=s.length-1,l=-1;for(a=i.length-1;a>=t;--a){const m=i.charCodeAt(a);if(h(m)){if(!r){t=a+1;break}}else l===-1&&(r=!1,l=a+1),o>=0&&(m===s.charCodeAt(o)?--o===-1&&(n=a):(o=-1,n=l))}return t===n?n=l:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=t;--a)if(h(i.charCodeAt(a))){if(!r){t=a+1;break}}else n===-1&&(r=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){d(i,"path");let s=0,t=-1,n=0,r=-1,a=!0,o=0;i.length>=2&&i.charCodeAt(1)===P&&f(i.charCodeAt(0))&&(s=n=2);for(let l=i.length-1;l>=s;--l){const m=i.charCodeAt(l);if(h(m)){if(!a){n=l+1;break}continue}r===-1&&(a=!1,r=l+1),m===D?t===-1?t=l:o!==1&&(o=1):t!==-1&&(o=-1)}return t===-1||r===-1||o===0||o===1&&t===r-1&&t===n+1?"":i.slice(t,r)},format:b.bind(null,"\\"),parse(i){d(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const t=i.length;let n=0,r=i.charCodeAt(0);if(t===1)return h(r)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(h(r)){if(n=1,h(i.charCodeAt(1))){let O=2,F=O;for(;O<t&&!h(i.charCodeAt(O));)O++;if(O<t&&O!==F){for(F=O;O<t&&h(i.charCodeAt(O));)O++;if(O<t&&O!==F){for(F=O;O<t&&!h(i.charCodeAt(O));)O++;O===t?n=O:O!==F&&(n=O+1)}}}}else if(f(r)&&i.charCodeAt(1)===P){if(t<=2)return s.root=s.dir=i,s;if(n=2,h(i.charCodeAt(2))){if(t===3)return s.root=s.dir=i,s;n=3}}n>0&&(s.root=i.slice(0,n));let a=-1,o=n,l=-1,m=!0,E=i.length-1,A=0;for(;E>=n;--E){if(r=i.charCodeAt(E),h(r)){if(!m){o=E+1;break}continue}l===-1&&(m=!1,l=E+1),r===D?a===-1?a=E:A!==1&&(A=1):a!==-1&&(A=-1)}return l!==-1&&(a===-1||A===0||A===1&&a===l-1&&a===o+1?s.base=s.name=i.slice(o,l):(s.name=i.slice(o,a),s.base=i.slice(o,l),s.ext=i.slice(a,l))),o>0&&o!==n?s.dir=i.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(p){const i=/\\/g;return()=>{const s=R.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>R.cwd()})();e.posix={resolve(...i){let s="",t=!1;for(let n=i.length-1;n>=-1&&!t;n--){const r=n>=0?i[n]:I();d(r,"path"),r.length!==0&&(s=`${r}/${s}`,t=r.charCodeAt(0)===C)}return s=v(s,!t,"/",u),t?`/${s}`:s.length>0?s:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===C,t=i.charCodeAt(i.length-1)===C;return i=v(i,!s,"/",u),i.length===0?s?"/":t?"./":".":(t&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===C},join(...i){if(i.length===0)return".";let s;for(let t=0;t<i.length;++t){const n=i[t];d(n,"path"),n.length>0&&(s===void 0?s=n:s+=`/${n}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(d(i,"from"),d(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const t=1,n=i.length,r=n-t,a=1,o=s.length-a,l=r<o?r:o;let m=-1,E=0;for(;E<l;E++){const O=i.charCodeAt(t+E);if(O!==s.charCodeAt(a+E))break;O===C&&(m=E)}if(E===l)if(o>l){if(s.charCodeAt(a+E)===C)return s.slice(a+E+1);if(E===0)return s.slice(a+E)}else r>l&&(i.charCodeAt(t+E)===C?m=E:E===0&&(m=0));let A="";for(E=t+m+1;E<=n;++E)(E===n||i.charCodeAt(E)===C)&&(A+=A.length===0?"..":"/..");return`${A}${s.slice(a+m)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===C;let t=-1,n=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===C){if(!n){t=r;break}}else n=!1;return t===-1?s?"/":".":s&&t===1?"//":i.slice(0,t)},basename(i,s){s!==void 0&&d(s,"ext"),d(i,"path");let t=0,n=-1,r=!0,a;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let o=s.length-1,l=-1;for(a=i.length-1;a>=0;--a){const m=i.charCodeAt(a);if(m===C){if(!r){t=a+1;break}}else l===-1&&(r=!1,l=a+1),o>=0&&(m===s.charCodeAt(o)?--o===-1&&(n=a):(o=-1,n=l))}return t===n?n=l:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===C){if(!r){t=a+1;break}}else n===-1&&(r=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){d(i,"path");let s=-1,t=0,n=-1,r=!0,a=0;for(let o=i.length-1;o>=0;--o){const l=i.charCodeAt(o);if(l===C){if(!r){t=o+1;break}continue}n===-1&&(r=!1,n=o+1),l===D?s===-1?s=o:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||n===-1||a===0||a===1&&s===n-1&&s===t+1?"":i.slice(s,n)},format:b.bind(null,"/"),parse(i){d(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const t=i.charCodeAt(0)===C;let n;t?(s.root="/",n=1):n=0;let r=-1,a=0,o=-1,l=!0,m=i.length-1,E=0;for(;m>=n;--m){const A=i.charCodeAt(m);if(A===C){if(!l){a=m+1;break}continue}o===-1&&(l=!1,o=m+1),A===D?r===-1?r=m:E!==1&&(E=1):r!==-1&&(E=-1)}if(o!==-1){const A=a===0&&t?1:a;r===-1||E===0||E===1&&r===o-1&&r===a+1?s.base=s.name=i.slice(A,o):(s.name=i.slice(A,r),s.base=i.slice(A,o),s.ext=i.slice(r,o))}return a>0?s.dir=i.slice(0,a-1):t&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(se[144],oe([0,1,13]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(P){const y=(0,R.extname)(P),g=_[y.toLowerCase()];return g!==void 0?g:L(P)}e.getMediaOrTextMime=T;function L(P){const y=(0,R.extname)(P);return c[y.toLowerCase()]}e.getMediaMime=L;function D(P){for(const y in c)if(c[y]===P)return y}e.getExtensionForMimeType=D;const C=/^(.+)\/(.+?)(;.+)?$/;function w(P,y){const g=C.exec(P);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:y?void 0:P}e.normalizeMimeType=w}),define(se[87],oe([0,1,4]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var c;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(c=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(D,...C){const w=C.reduce((g,S)=>(g[S]=!0,g),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(g=>!w[g]).forEach(g=>{for(let S=0;S<P.length;S++)if(g.search(P[S])!==-1){delete D[g];break}})}e.sanitizeProcessEnvironment=T;function L(D){!D||(delete D.DEBUG,R.isMacintosh&&delete D.DYLD_LIBRARY_PATH,R.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(se[88],oe([0,1,4]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const _=R.globals.performance&&typeof R.globals.performance.now=="function";class c{static create(L=!0){return new c(L)}constructor(L){this._highResolution=_&&L,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=c}),define(se[3],oe([0,1,9,82,2,84,88]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const D=!1,C=!1;var w;(function(a){a.None=()=>c.Disposable.None;function o(W){if(C){const{onDidAddListener:B}=W,Q=d.create();let H=0;W.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),B?.()}}}function l(W,B){return z(W,()=>{},0,void 0,void 0,B)}a.defer=l;function m(W){return(B,Q=null,H)=>{let X=!1,te;return te=W(le=>{if(!X)return te?te.dispose():X=!0,B.call(Q,le)},null,H),X&&te.dispose(),te}}a.once=m;function E(W,B,Q){return N((H,X=null,te)=>W(le=>H.call(X,B(le)),null,te),Q)}a.map=E;function A(W,B,Q){return N((H,X=null,te)=>W(le=>{B(le),H.call(X,le)},null,te),Q)}a.forEach=A;function O(W,B,Q){return N((H,X=null,te)=>W(le=>B(le)&&H.call(X,le),null,te),Q)}a.filter=O;function F(W){return W}a.signal=F;function M(...W){return(B,Q=null,H)=>(0,c.combinedDisposable)(...W.map(X=>X(te=>B.call(Q,te),null,H)))}a.any=M;function k(W,B,Q,H){let X=Q;return E(W,te=>(X=B(X,te),X),H)}a.reduce=k;function N(W,B){let Q;const H={onWillAddFirstListener(){Q=W(X.fire,X)},onDidRemoveLastListener(){Q?.dispose()}};B||o(H);const X=new h(H);return B?.add(X),X.event}function z(W,B,Q=100,H=!1,X,te){let le,he,me,pe=0;const Ee={leakWarningThreshold:X,onWillAddFirstListener(){le=W(Re=>{pe++,he=B(he,Re),H&&!me&&(be.fire(he),he=void 0);const ke=()=>{const We=he;he=void 0,me=void 0,(!H||pe>1)&&be.fire(We),pe=0};typeof Q=="number"?(clearTimeout(me),me=setTimeout(ke,Q)):me===void 0&&(me=0,queueMicrotask(ke))})},onDidRemoveLastListener(){le.dispose()}};te||o(Ee);const be=new h(Ee);return te?.add(be),be.event}a.debounce=z;function j(W,B=0,Q){return a.debounce(W,(H,X)=>H?(H.push(X),H):[X],B,void 0,void 0,Q)}a.accumulate=j;function J(W,B=(H,X)=>H===X,Q){let H=!0,X;return O(W,te=>{const le=H||!B(te,X);return H=!1,X=te,le},Q)}a.latch=J;function ne(W,B,Q){return[a.filter(W,B,Q),a.filter(W,H=>!B(H),Q)]}a.split=ne;function G(W,B=!1,Q=[]){let H=Q.slice(),X=W(he=>{H?H.push(he):le.fire(he)});const te=()=>{H?.forEach(he=>le.fire(he)),H=null},le=new h({onWillAddFirstListener(){X||(X=W(he=>le.fire(he)))},onDidAddFirstListener(){H&&(B?setTimeout(te):te())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return le.event}a.buffer=G;class q{constructor(B){this.event=B,this.disposables=new c.DisposableStore}map(B){return new q(E(this.event,B,this.disposables))}forEach(B){return new q(A(this.event,B,this.disposables))}filter(B){return new q(O(this.event,B,this.disposables))}reduce(B,Q){return new q(k(this.event,B,Q,this.disposables))}latch(){return new q(J(this.event,void 0,this.disposables))}debounce(B,Q=100,H=!1,X){return new q(z(this.event,B,Q,H,X,this.disposables))}on(B,Q,H){return this.event(B,Q,H)}once(B,Q,H){return m(this.event)(B,Q,H)}dispose(){this.disposables.dispose()}}function x(W){return new q(W)}a.chain=x;function Y(W,B,Q=H=>H){const H=(...he)=>le.fire(Q(...he)),X=()=>W.on(B,H),te=()=>W.removeListener(B,H),le=new h({onWillAddFirstListener:X,onDidRemoveLastListener:te});return le.event}a.fromNodeEventEmitter=Y;function ee(W,B,Q=H=>H){const H=(...he)=>le.fire(Q(...he)),X=()=>W.addEventListener(B,H),te=()=>W.removeEventListener(B,H),le=new h({onWillAddFirstListener:X,onDidRemoveLastListener:te});return le.event}a.fromDOMEventEmitter=ee;function re(W){return new Promise(B=>m(W)(B))}a.toPromise=re;function ae(W,B){return B(void 0),W(Q=>B(Q))}a.runAndSubscribe=ae;function V(W,B){let Q=null;function H(te){Q?.dispose(),Q=new c.DisposableStore,B(te,Q)}H(void 0);const X=W(te=>H(te));return(0,c.toDisposable)(()=>{X.dispose(),Q?.dispose()})}a.runAndSubscribeWithStore=V;class ${constructor(B,Q){this.obs=B,this._counter=0,this._hasChanged=!1;const H={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};Q||o(H),this.emitter=new h(H),Q&&Q.add(this.emitter)}beginUpdate(B){this._counter++}handleChange(B,Q){this._hasChanged=!0}endUpdate(B){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function U(W,B){return new $(W,B).emitter.event}a.fromObservable=U})(w=e.Event||(e.Event={}));class P{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${P._idPool++}`,P.all.add(this)}start(o){this._stopWatch=new L.StopWatch(!0),this.listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this._stopWatch=void 0}}}P.all=new Set,P._idPool=0,e.EventProfiling=P;let y=-1;function g(a){const o=y;return y=a,{dispose(){y=o}}}e.setGlobalLeakWarningThreshold=g;class S{constructor(o,l=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(o,l){const m=this.threshold;if(m<=0||l<m)return;this._stacks||(this._stacks=new Map);const E=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,E+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let A,O=0;for(const[F,M]of this._stacks)(!A||O<M)&&(A=F,O=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${O}):`),console.warn(A)}return()=>{const A=this._stacks.get(o.value)||0;this._stacks.set(o.value,A-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(o,l,m){this.callback=o,this.callbackThis=l,this.stack=m,this.subscription=new c.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class h{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=y>0||this._options?.leakWarningThreshold?new S(this._options?.leakWarningThreshold??y):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const l of o)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,l,m)=>{if(this._listeners||(this._listeners=new T.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),c.Disposable.None;const E=this._listeners.isEmpty();E&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let A,O;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(O=d.create(),A=this._leakageMon.check(O,this._listeners.size+1)),D&&(O=O??d.create());const F=new p(o,l,O),M=this._listeners.push(F);E&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,o,l);const k=F.subscription.set(()=>{A?.(),this._disposed||(M(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return m instanceof c.DisposableStore?m.add(k):Array.isArray(m)&&m.push(k),k}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new f);for(const l of this._listeners)this._deliveryQueue.push(this,l,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=h;class u{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(o,l,m){this._queue.push(new v(o,l,m))}clear(o){const l=new T.LinkedList;for(const m of this._queue)m.emitter!==o&&l.push(m);this._queue=l}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(l){(0,R.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=u;class f extends u{clear(o){this._queue.clear()}}class v{constructor(o,l,m){this.emitter=o,this.listener=l,this.event=m}}class b extends h{async fireAsync(o,l,m){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const E of this._listeners)this._asyncDeliveryQueue.push([E,o]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[E,A]=this._asyncDeliveryQueue.shift(),O=[],F={...A,token:l,waitUntil:M=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");m&&(M=m(M,E.callback)),O.push(M)}};try{E.invoke(F)}catch(M){(0,R.onUnexpectedError)(M);continue}Object.freeze(O),await Promise.allSettled(O).then(M=>{for(const k of M)k.status==="rejected"&&(0,R.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=b;class I extends h{constructor(o){super(o),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=I;class i extends I{constructor(o){super(o),this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=i;class s extends h{constructor(o){super(o),this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){!this.hasListeners()||(this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const m=()=>{this.hasListeners&&this.unhook(l);const E=this.events.indexOf(l);this.events.splice(E,1)};return(0,c.toDisposable)((0,_.once)(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.buffers=[]}wrapEvent(o){return(l,m,E)=>o(A=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>l.call(m,A)):l.call(m,A)},void 0,E)}bufferEvents(o){const l=[];this.buffers.push(l);const m=o();return this.buffers.pop(),l.forEach(E=>E()),m}}e.EventBufferer=n;class r{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=c.Disposable.None,this.emitter=new h({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(se[25],oe([0,1,3]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const _=Object.freeze(function(D,C){const w=setTimeout(D.bind(C),0);return{dispose(){clearTimeout(w)}}});var c;(function(D){function C(w){return w===D.None||w===D.Cancelled||w instanceof T?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}D.isCancellationToken=C,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:_})})(c=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?_:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=c.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=c.None}}e.CancellationTokenSource=L}),define(se[145],oe([0,1,25]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class _{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new R.CancellationTokenSource,C=this.task(D.token);return this.result={promise:C,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=_;class c{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const C=JSON.stringify(D);return this.lastArgKey!==C&&(this.lastArgKey=C,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=c;class T{get cachedValues(){return this._map}constructor(D){this.fn=D,this._map=new Map}get(D){if(this._map.has(D))return this._map.get(D);const C=this.fn(D);return this._map.set(D,C),C}}e.CachedFunction=T}),define(se[27],oe([0,1,145,130]),function(Z,e,R,_){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=T;const L=/{(\d+)}/g;function D(ie,...ue){return ue.length===0?ie:ie.replace(L,function(de,ve){const ye=parseInt(ve,10);return isNaN(ye)||ye<0||ye>=ue.length?de:ue[ye]})}e.format=D;const C=/{([^}]+)}/g;function w(ie,ue){return ie.replace(C,(de,ve)=>ue[ve]??de)}e.format2=w;function P(ie){return ie.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=P;function y(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function g(ie,ue){let de=0;const ve=ue.charCodeAt(0);for(let ye=ie.length-1;ye>=0;ye--)ie.charCodeAt(ye)===ve&&de++;return de}e.count=g;function S(ie,ue,de="\u2026"){return ie.length<=ue?ie:`${ie.substr(0,ue)}${de}`}e.truncate=S;function d(ie,ue=" "){const de=p(ie,ue);return h(de,ue)}e.trim=d;function p(ie,ue){if(!ie||!ue)return ie;const de=ue.length;if(de===0||ie.length===0)return ie;let ve=0;for(;ie.indexOf(ue,ve)===ve;)ve=ve+de;return ie.substring(ve)}e.ltrim=p;function h(ie,ue){if(!ie||!ue)return ie;const de=ue.length,ve=ie.length;if(de===0||ve===0)return ie;let ye=ve,Pe=-1;for(;Pe=ie.lastIndexOf(ue,ye-1),!(Pe===-1||Pe+de!==ye);){if(Pe===0)return"";ye=Pe}return ie.substring(0,ye)}e.rtrim=h;function u(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function f(ie){return ie.replace(/\*/g,"")}e.stripWildcards=f;function v(ie,ue,de={}){if(!ie)throw new Error("Cannot create regex from empty string");ue||(ie=y(ie)),de.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ve="";return de.global&&(ve+="g"),de.matchCase||(ve+="i"),de.multiline&&(ve+="m"),de.unicode&&(ve+="u"),new RegExp(ie,ve)}e.createRegExp=v;function b(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function I(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function i(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=i;function s(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=s;function t(ie){for(let ue=0,de=ie.length;ue<de;ue++){const ve=ie.charCodeAt(ue);if(ve!==32&&ve!==9)return ue}return-1}e.firstNonWhitespaceIndex=t;function n(ie,ue=0,de=ie.length){for(let ve=ue;ve<de;ve++){const ye=ie.charCodeAt(ve);if(ye!==32&&ye!==9)return ie.substring(ue,ve)}return ie.substring(ue,de)}e.getLeadingWhitespace=n;function r(ie,ue=ie.length-1){for(let de=ue;de>=0;de--){const ve=ie.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}e.lastNonWhitespaceIndex=r;function a(ie,ue,de){const ve=[];let ye=0;for(const Pe of ie.matchAll(ue)){if(ve.push(ie.slice(ye,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");ye=Pe.index+Pe[0].length,ve.push(de(Pe[0],...Pe.slice(1),Pe.index,ie,Pe.groups))}return ve.push(ie.slice(ye)),Promise.all(ve).then(Pe=>Pe.join(""))}e.replaceAsync=a;function o(ie,ue){return ie<ue?-1:ie>ue?1:0}e.compare=o;function l(ie,ue,de=0,ve=ie.length,ye=0,Pe=ue.length){for(;de<ve&&ye<Pe;de++,ye++){const xe=ie.charCodeAt(de),Ae=ue.charCodeAt(ye);if(xe<Ae)return-1;if(xe>Ae)return 1}const De=ve-de,Be=Pe-ye;return De<Be?-1:De>Be?1:0}e.compareSubstring=l;function m(ie,ue){return E(ie,ue,0,ie.length,0,ue.length)}e.compareIgnoreCase=m;function E(ie,ue,de=0,ve=ie.length,ye=0,Pe=ue.length){for(;de<ve&&ye<Pe;de++,ye++){let xe=ie.charCodeAt(de),Ae=ue.charCodeAt(ye);if(xe===Ae)continue;if(xe>=128||Ae>=128)return l(ie.toLowerCase(),ue.toLowerCase(),de,ve,ye,Pe);O(xe)&&(xe-=32),O(Ae)&&(Ae-=32);const qe=xe-Ae;if(qe!==0)return qe}const De=ve-de,Be=Pe-ye;return De<Be?-1:De>Be?1:0}e.compareSubstringIgnoreCase=E;function A(ie){return ie>=48&&ie<=57}e.isAsciiDigit=A;function O(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=O;function F(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=F;function M(ie,ue){return ie.length===ue.length&&E(ie,ue)===0}e.equalsIgnoreCase=M;function k(ie,ue){const de=ue.length;return ue.length>ie.length?!1:E(ie,ue,0,de)===0}e.startsWithIgnoreCase=k;function N(ie,ue){const de=Math.min(ie.length,ue.length);let ve;for(ve=0;ve<de;ve++)if(ie.charCodeAt(ve)!==ue.charCodeAt(ve))return ve;return de}e.commonPrefixLength=N;function z(ie,ue){const de=Math.min(ie.length,ue.length);let ve;const ye=ie.length-1,Pe=ue.length-1;for(ve=0;ve<de;ve++)if(ie.charCodeAt(ye-ve)!==ue.charCodeAt(Pe-ve))return ve;return de}e.commonSuffixLength=z;function j(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=j;function J(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=J;function ne(ie,ue){return(ie-55296<<10)+(ue-56320)+65536}e.computeCodePoint=ne;function G(ie,ue,de){const ve=ie.charCodeAt(de);if(j(ve)&&de+1<ue){const ye=ie.charCodeAt(de+1);if(J(ye))return ne(ve,ye)}return ve}e.getNextCodePoint=G;function q(ie,ue){const de=ie.charCodeAt(ue-1);if(J(de)&&ue>1){const ve=ie.charCodeAt(ue-2);if(j(ve))return ne(ve,de)}return de}class x{get offset(){return this._offset}constructor(ue,de=0){this._str=ue,this._len=ue.length,this._offset=de}setOffset(ue){this._offset=ue}prevCodePoint(){const ue=q(this._str,this._offset);return this._offset-=ue>=65536?2:1,ue}nextCodePoint(){const ue=G(this._str,this._len,this._offset);return this._offset+=ue>=65536?2:1,ue}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class Y{get offset(){return this._iterator.offset}constructor(ue,de=0){this._iterator=new x(ue,de)}nextGraphemeLength(){const ue=_e.getInstance(),de=this._iterator,ve=de.offset;let ye=ue.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const Pe=de.offset,De=ue.getGraphemeBreakType(de.nextCodePoint());if(Ce(ye,De)){de.setOffset(Pe);break}ye=De}return de.offset-ve}prevGraphemeLength(){const ue=_e.getInstance(),de=this._iterator,ve=de.offset;let ye=ue.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const Pe=de.offset,De=ue.getGraphemeBreakType(de.prevCodePoint());if(Ce(De,ye)){de.setOffset(Pe);break}ye=De}return ve-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function ee(ie,ue){return new Y(ie,ue).nextGraphemeLength()}e.nextCharLength=ee;function re(ie,ue){return new Y(ie,ue).prevGraphemeLength()}e.prevCharLength=re;function ae(ie,ue){ue>0&&J(ie.charCodeAt(ue))&&ue--;const de=ue+ee(ie,ue);return[de-re(ie,de),de]}e.getCharContainingOffset=ae;function V(ie){const ue=new Y(ie);let de=0;for(;!ue.eol();)de++,ue.nextGraphemeLength();return de}e.charCount=V;let $;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(ie){return $||($=U()),$.test(ie)}e.containsRTL=W;const B=/^[\t\n\r\x20-\x7E]*$/;function Q(ie){return B.test(ie)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=H;function X(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=X;function te(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=te;function le(ie,ue){if(ie.length<ue)return ie;const de=/\b/g;let ve=0;for(;de.test(ie)&&!(ie.length-de.lastIndex<ue);)ve=de.lastIndex,de.lastIndex+=1;return ie.substring(ve).replace(/^\s/,"")}e.lcut=le;const he=/\x1B\x5B[12]?K/g,me=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function Ee(ie){return ie&&(ie=ie.replace(he,""),ie=ie.replace(me,""),ie=ie.replace(pe,"")),ie}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Re(ie){return be(ie)?ie.substr(1):ie}e.stripUTF8BOM=Re;function ke(ie,ue){if(!ie||!ue||ie.length<ue.length)return!1;const de=ue.length,ve=ie.toLowerCase();let ye=0,Pe=-1;for(;ye<de;){const De=ve.indexOf(ue[ye],Pe+1);if(De<0)return!1;Pe=De,ye++}return!0}e.fuzzyContains=ke;function We(ie,ue=!1){return ie?(ue&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=We;function $e(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=$e;function ce(ie,ue=1){if(ue===0)return"";let de=-1;do de=ie.indexOf(`
`,de+1),ue--;while(ue>0&&de>=0);return de===-1?ie:(ie[de-1]==="\r"&&de--,ie.substr(0,de))}e.getNLines=ce;function fe(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=fe;function ge(ie){return _e.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=ge;function Ce(ie,ue){return ie===0?ue!==5&&ue!==7:ie===2&&ue===3?!1:ie===4||ie===2||ie===3||ue===4||ue===2||ue===3?!0:!(ie===8&&(ue===8||ue===9||ue===11||ue===12)||(ie===11||ie===9)&&(ue===9||ue===10)||(ie===12||ie===10)&&ue===10||ue===5||ue===13||ue===7||ie===1||ie===13&&ue===14||ie===6&&ue===6)}var Ie;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class _e{static getInstance(){return _e._INSTANCE||(_e._INSTANCE=new _e),_e._INSTANCE}constructor(){this._data=Le()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const de=this._data,ve=de.length/3;let ye=1;for(;ye<=ve;)if(ue<de[3*ye])ye=2*ye;else if(ue>de[3*ye+1])ye=2*ye+1;else return de[3*ye+2];return 0}}_e._INSTANCE=null;function Le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ie,ue){if(ie===0)return 0;const de=Oe(ie,ue);if(de!==void 0)return de;const ve=new x(ue,ie);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=Fe;function Oe(ie,ue){const de=new x(ue,ie);let ve=de.prevCodePoint();for(;Ne(ve)||ve===65039||ve===8419;){if(de.offset===0)return;ve=de.prevCodePoint()}if(!te(ve))return;let ye=de.offset;return ye>0&&de.prevCodePoint()===8205&&(ye=de.offset),ye}function Ne(ie){return 127995<=ie&&ie<=127999}var ze;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class Te{static getInstance(ue){return Te.cache.get(Array.from(ue))}static getLocales(){return Te._locales.value}constructor(ue){this.confusableDictionary=ue}isAmbiguous(ue){return this.confusableDictionary.has(ue)}getPrimaryConfusable(ue){return this.confusableDictionary.get(ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}c=Te,Te.ambiguousCharacterData=new _.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.cache=new R.LRUCachedFunction(ie=>{function ue(Ae){const qe=new Map;for(let He=0;He<Ae.length;He+=2)qe.set(Ae[He],Ae[He+1]);return qe}function de(Ae,qe){const He=new Map(Ae);for(const[et,st]of qe)He.set(et,st);return He}function ve(Ae,qe){if(!Ae)return qe;const He=new Map;for(const[et,st]of Ae)qe.has(et)&&He.set(et,st);return He}const ye=c.ambiguousCharacterData.value;let Pe=ie.filter(Ae=>!Ae.startsWith("_")&&Ae in ye);Pe.length===0&&(Pe=["_default"]);let De;for(const Ae of Pe){const qe=ue(ye[Ae]);De=ve(De,qe)}const Be=ue(ye._common),xe=de(Be,De);return new Te(xe)}),Te._locales=new _.Lazy(()=>Object.keys(Te.ambiguousCharacterData.value).filter(ie=>!ie.startsWith("_"))),e.AmbiguousCharacters=Te;class Ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ue.getRawData())),this._data}static isInvisibleCharacter(ue){return Ue.getData().has(ue)}static get codePoints(){return Ue.getData()}}Ue._data=void 0,e.InvisibleCharacters=Ue}),define(se[48],oe([0,1,13,4,27,12]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(r){return r===47||r===92}e.isPathSeparator=L;function D(r){return r.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=D;function C(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=C;function w(r,a=R.posix.sep){if(!r)return"";const o=r.length,l=r.charCodeAt(0);if(L(l)){if(L(r.charCodeAt(1))&&!L(r.charCodeAt(2))){let E=3;const A=E;for(;E<o&&!L(r.charCodeAt(E));E++);if(A!==E&&!L(r.charCodeAt(E+1))){for(E+=1;E<o;E++)if(L(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,a)}}return a}else if(u(l)&&r.charCodeAt(1)===58)return L(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(L(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=w;function P(r){if(!_.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let o=2;const l=o;for(;o<r.length&&(a=r.charCodeAt(o),a!==92);o++);return!(l===o||(a=r.charCodeAt(o+1),isNaN(a)||a===92))}e.isUNC=P;const y=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,a=_.isWindows){const o=a?y:g;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||a&&S.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function p(r,a,o){const l=r===a;return!o||l?l:!r||!a?!1:(0,c.equalsIgnoreCase)(r,a)}e.isEqual=p;function h(r,a,o,l=R.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(o){if(!(0,c.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let E=a.length;return a.charAt(a.length-1)===l&&E--,r.charAt(E)===l}return a.charAt(a.length-1)!==l&&(a+=l),r.indexOf(a)===0}e.isEqualOrParent=h;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function f(r,a){return _.isWindows&&r.endsWith(":")&&(r+=R.sep),(0,R.isAbsolute)(r)||(r=(0,R.join)(a,r)),r=(0,R.normalize)(r),_.isWindows?(r=(0,c.rtrim)(r,R.sep),r.endsWith(":")&&(r+=R.sep)):(r=(0,c.rtrim)(r,R.sep),r||(r=R.sep)),r}e.sanitizeFilePath=f;function v(r){const a=(0,R.normalize)(r);return _.isWindows?r.length>3?!1:b(a)&&(r.length===2||a.charCodeAt(2)===92):a===R.posix.sep}e.isRootOrDriveLetter=v;function b(r,a=_.isWindows){return a?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function I(r){return b(r)?r[0]:void 0}e.getDriveLetter=I;function i(r,a,o){return a.length>r.length?-1:r===a?0:(o&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=i;function s(r){const a=r.split(":");let o,l,m;for(const E of a){const A=Number(E);(0,T.isNumber)(A)?l===void 0?l=A:m===void 0&&(m=A):o=o?[o,E].join(":"):E}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:m!==void 0?m:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,a,o=8){let l="";for(let E=0;E<o;E++)l+=t.charAt(Math.floor(Math.random()*t.length));let m;return a?m=`${a}-${l}`:m=l,r?(0,R.join)(r,m):m}e.randomPath=n}),define(se[66],oe([0,1,27]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function _(u){return c(u,0)}e.hash=_;function c(u,f){switch(typeof u){case"object":return u===null?T(349,f):Array.isArray(u)?C(u,f):w(u,f);case"string":return D(u,f);case"boolean":return L(u,f);case"number":return T(u,f);case"undefined":return T(937,f);default:return T(617,f)}}e.doHash=c;function T(u,f){return(f<<5)-f+u|0}e.numberHash=T;function L(u,f){return T(u?433:863,f)}function D(u,f){f=T(149417,f);for(let v=0,b=u.length;v<b;v++)f=T(u.charCodeAt(v),f);return f}e.stringHash=D;function C(u,f){return f=T(104579,f),u.reduce((v,b)=>c(b,v),f)}function w(u,f){return f=T(181387,f),Object.keys(u).sort().reduce((v,b)=>(v=D(b,v),c(u[b],v)),f)}class P{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=c(f,this._value),this._value}}e.Hasher=P;var y;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function g(u,f,v=32){const b=v-f,I=~((1<<b)-1);return(u<<f|(I&u)>>>b)>>>0}function S(u,f=0,v=u.byteLength,b=0){for(let I=0;I<v;I++)u[f+I]=b}function d(u,f,v="0"){for(;u.length<f;)u=v+u;return u}function p(u,f=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(v=>v.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),f/4)}e.toHexString=p;class h{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const v=f.length;if(v===0)return;const b=this._buff;let I=this._buffLen,i=this._leftoverHighSurrogate,s,t;for(i!==0?(s=i,t=-1,i=0):(s=f.charCodeAt(0),t=0);;){let n=s;if(R.isHighSurrogate(s))if(t+1<v){const r=f.charCodeAt(t+1);R.isLowSurrogate(r)?(t++,n=R.computeCodePoint(s,r)):n=65533}else{i=s;break}else R.isLowSurrogate(s)&&(n=65533);if(I=this._push(b,I,n),t++,t<v)s=f.charCodeAt(t);else break}this._buffLen=I,this._leftoverHighSurrogate=i}_push(f,v,b){return b<128?f[v++]=b:b<2048?(f[v++]=192|(b&1984)>>>6,f[v++]=128|(b&63)>>>0):b<65536?(f[v++]=224|(b&61440)>>>12,f[v++]=128|(b&4032)>>>6,f[v++]=128|(b&63)>>>0):(f[v++]=240|(b&1835008)>>>18,f[v++]=128|(b&258048)>>>12,f[v++]=128|(b&4032)>>>6,f[v++]=128|(b&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=h._bigBlock32,v=this._buffDV;for(let o=0;o<64;o+=4)f.setUint32(o,v.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)f.setUint32(o,g(f.getUint32(o-12,!1)^f.getUint32(o-32,!1)^f.getUint32(o-56,!1)^f.getUint32(o-64,!1),1),!1);let b=this._h0,I=this._h1,i=this._h2,s=this._h3,t=this._h4,n,r,a;for(let o=0;o<80;o++)o<20?(n=I&i|~I&s,r=1518500249):o<40?(n=I^i^s,r=1859775393):o<60?(n=I&i|I&s|i&s,r=2400959708):(n=I^i^s,r=3395469782),a=g(b,5)+n+t+r+f.getUint32(o*4,!1)&4294967295,t=s,s=i,i=g(I,30),I=b,b=a;this._h0=this._h0+b&4294967295,this._h1=this._h1+I&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}h._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=h}),define(se[89],oe([0,1,27]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var _;(function(c){c[c.Ignore=0]="Ignore",c[c.Info=1]="Info",c[c.Warning=2]="Warning",c[c.Error=3]="Error"})(_||(_={})),function(c){const T="error",L="warning",D="warn",C="info",w="ignore";function P(g){return g?R.equalsIgnoreCase(T,g)?c.Error:R.equalsIgnoreCase(L,g)||R.equalsIgnoreCase(D,g)?c.Warning:R.equalsIgnoreCase(C,g)?c.Info:c.Ignore:c.Ignore}c.fromValue=P;function y(g){switch(g){case c.Error:return T;case c.Warning:return L;case c.Info:return C;default:return w}}c.toString=y}(_||(_={})),e.default=_}),define(se[49],oe([0,1,21,27]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class c{constructor(){this._value="",this._pos=0}reset(S){return this._value=S,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(S){const d=S.charCodeAt(0),p=this._value.charCodeAt(this._pos);return d-p}value(){return this._value[this._pos]}}e.StringIterator=c;class T{constructor(S=!0){this._caseSensitive=S}reset(S){return this._value=S,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let S=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(S)this._from++;else break;else S=!1;return this}cmp(S){return this._caseSensitive?(0,_.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class L{constructor(S=!0,d=!0){this._splitOnBackslash=S,this._caseSensitive=d}reset(S){this._from=0,this._to=0,this._value=S,this._valueLen=S.length;for(let d=S.length-1;d>=0;d--,this._valueLen--){const p=this._value.charCodeAt(d);if(!(p===47||this._splitOnBackslash&&p===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let S=!0;for(;this._to<this._valueLen;this._to++){const d=this._value.charCodeAt(this._to);if(d===47||this._splitOnBackslash&&d===92)if(S)this._from++;else break;else S=!1}return this}cmp(S){return this._caseSensitive?(0,_.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=L;var D;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(D||(D={}));class C{constructor(S,d){this._ignorePathCasing=S,this._ignoreQueryAndFragment=d,this._states=[],this._stateIdx=0}reset(S){return this._value=S,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new L(!1,!this._ignorePathCasing(S)),this._pathIterator.reset(S.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(S)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(S){if(this._states[this._stateIdx]===1)return(0,_.compareIgnoreCase)(S,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,_.compareIgnoreCase)(S,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(S);if(this._states[this._stateIdx]===4)return(0,_.compare)(S,this._value.query);if(this._states[this._stateIdx]===5)return(0,_.compare)(S,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=C;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(P||(P={}));class y{static forUris(S=()=>!1,d=()=>!1){return new y(new C(S,d))}static forPaths(S=!1){return new y(new L(void 0,!S))}static forStrings(){return new y(new c)}static forConfigKeys(){return new y(new T)}constructor(S){this._iter=S}clear(){this._root=void 0}fill(S,d){if(d){const p=d.slice(0);(0,R.shuffle)(p);for(const h of p)this.set(h,S)}else{const p=S.slice(0);(0,R.shuffle)(p);for(const h of p)this.set(h[0],h[1])}}set(S,d){const p=this._iter.reset(S);let h;this._root||(this._root=new w,this._root.segment=p.value());const u=[];for(h=this._root;;){const v=p.cmp(h.segment);if(v>0)h.left||(h.left=new w,h.left.segment=p.value()),u.push([-1,h]),h=h.left;else if(v<0)h.right||(h.right=new w,h.right.segment=p.value()),u.push([1,h]),h=h.right;else if(p.hasNext())p.next(),h.mid||(h.mid=new w,h.mid.segment=p.value()),u.push([0,h]),h=h.mid;else break}const f=h.value;h.value=d,h.key=S;for(let v=u.length-1;v>=0;v--){const b=u[v][1];b.updateHeight();const I=b.balanceFactor();if(I<-1||I>1){const i=u[v][0],s=u[v+1][0];if(i===1&&s===1)u[v][1]=b.rotateLeft();else if(i===-1&&s===-1)u[v][1]=b.rotateRight();else if(i===1&&s===-1)b.right=u[v+1][1]=u[v+1][1].rotateRight(),u[v][1]=b.rotateLeft();else if(i===-1&&s===1)b.left=u[v+1][1]=u[v+1][1].rotateLeft(),u[v][1]=b.rotateRight();else throw new Error;if(v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}return f}get(S){return this._getNode(S)?.value}_getNode(S){const d=this._iter.reset(S);let p=this._root;for(;p;){const h=d.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(d.hasNext())d.next(),p=p.mid;else break}return p}has(S){const d=this._getNode(S);return!(d?.value===void 0&&d?.mid===void 0)}delete(S){return this._delete(S,!1)}deleteSuperstr(S){return this._delete(S,!0)}_delete(S,d){const p=this._iter.reset(S),h=[];let u=this._root;for(;u;){const f=p.cmp(u.segment);if(f>0)h.push([-1,u]),u=u.left;else if(f<0)h.push([1,u]),u=u.right;else if(p.hasNext())p.next(),h.push([0,u]),u=u.mid;else break}if(!!u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const f=this._min(u.right);if(f.key){const{key:v,value:b,segment:I}=f;this._delete(f.key,!1),u.key=v,u.value=b,u.segment=I}}else{const f=u.left??u.right;if(h.length>0){const[v,b]=h[h.length-1];switch(v){case-1:b.left=f;break;case 0:b.mid=f;break;case 1:b.right=f;break}}else this._root=f}for(let f=h.length-1;f>=0;f--){const v=h[f][1];v.updateHeight();const b=v.balanceFactor();if(b>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),h[f][1]=v.rotateLeft()):b<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),h[f][1]=v.rotateRight()),f>0)switch(h[f-1][0]){case-1:h[f-1][1].left=h[f][1];break;case 1:h[f-1][1].right=h[f][1];break;case 0:h[f-1][1].mid=h[f][1];break}else this._root=h[0][1]}}}_min(S){for(;S.left;)S=S.left;return S}findSubstr(S){const d=this._iter.reset(S);let p=this._root,h;for(;p;){const u=d.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(d.hasNext())d.next(),h=p.value||h,p=p.mid;else break}return p&&p.value||h}findSuperstr(S){return this._findSuperstrOrElement(S,!1)}_findSuperstrOrElement(S,d){const p=this._iter.reset(S);let h=this._root;for(;h;){const u=p.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else return h.mid?this._entries(h.mid):d?h.value:void 0}}hasElementOrSubtree(S){return this._findSuperstrOrElement(S,!0)!==void 0}forEach(S){for(const[d,p]of this)S(p,d)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(S){const d=[];return this._dfsEntries(S,d),d[Symbol.iterator]()}_dfsEntries(S,d){!S||(S.left&&this._dfsEntries(S.left,d),S.value&&d.push([S.key,S.value]),S.mid&&this._dfsEntries(S.mid,d),S.right&&this._dfsEntries(S.right,d))}_isBalanced(){const S=d=>{if(!d)return!0;const p=d.balanceFactor();return p<-1||p>1?!1:S(d.left)&&S(d.right)};return S(this._root)}}e.TernarySearchTree=y}),define(se[11],oe([0,1,13,4]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const c=/^\w[\w\d+.-]*$/,T=/^\//,L=/^\/\//;function D(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!c.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!T.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(t,n){return!t&&!n?"file":t}function w(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==y&&(n=y+n):n=y;break}return n}const P="",y="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(n){return n instanceof S?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,a,o,l,m=!1){typeof n=="object"?(this.scheme=n.scheme||P,this.authority=n.authority||P,this.path=n.path||P,this.query=n.query||P,this.fragment=n.fragment||P):(this.scheme=C(n,m),this.authority=r||P,this.path=w(this.scheme,a||P),this.query=o||P,this.fragment=l||P,D(this,m))}get fsPath(){return v(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:a,path:o,query:l,fragment:m}=n;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),o===void 0?o=this.path:o===null&&(o=P),l===void 0?l=this.query:l===null&&(l=P),m===void 0?m=this.fragment:m===null&&(m=P),r===this.scheme&&a===this.authority&&o===this.path&&l===this.query&&m===this.fragment?this:new p(r,a,o,l,m)}static parse(n,r=!1){const a=g.exec(n);return a?new p(a[2]||P,s(a[4]||P),s(a[5]||P),s(a[7]||P),s(a[9]||P),r):new p(P,P,P,P,P)}static file(n){let r=P;if(_.isWindows&&(n=n.replace(/\\/g,y)),n[0]===y&&n[1]===y){const a=n.indexOf(y,2);a===-1?(r=n.substring(2),n=y):(r=n.substring(2,a),n=n.substring(a)||y)}return new p("file",r,n,P,P)}static from(n){const r=new p(n.scheme,n.authority,n.path,n.query,n.fragment);return D(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return _.isWindows&&n.scheme==="file"?a=S.file(R.win32.join(v(n,!0),...r)).path:a=R.posix.join(n.path,...r),n.with({path:a})}toString(n=!1){return b(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof S)return n;{const r=new p(n);return r._formatted=n.external,r._fsPath=n._sep===d?n.fsPath:null,r}}else return n}}e.URI=S;const d=_.isWindows?1:void 0;class p extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(n=!1){return n?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,n,r){let a,o=-1;for(let l=0;l<t.length;l++){const m=t.charCodeAt(l);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||n&&m===47||r&&m===91||r&&m===93||r&&m===58)o!==-1&&(a+=encodeURIComponent(t.substring(o,l)),o=-1),a!==void 0&&(a+=t.charAt(l));else{a===void 0&&(a=t.substr(0,l));const E=h[m];E!==void 0?(o!==-1&&(a+=encodeURIComponent(t.substring(o,l)),o=-1),a+=E):o===-1&&(o=l)}}return o!==-1&&(a+=encodeURIComponent(t.substring(o))),a!==void 0?a:t}function f(t){let n;for(let r=0;r<t.length;r++){const a=t.charCodeAt(r);a===35||a===63?(n===void 0&&(n=t.substr(0,r)),n+=h[a]):n!==void 0&&(n+=t[r])}return n!==void 0?n:t}function v(t,n){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,_.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=v;function b(t,n){const r=n?f:u;let a="",{scheme:o,authority:l,path:m,query:E,fragment:A}=t;if(o&&(a+=o,a+=":"),(l||o==="file")&&(a+=y,a+=y),l){let O=l.indexOf("@");if(O!==-1){const F=l.substr(0,O);l=l.substr(O+1),O=F.lastIndexOf(":"),O===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,O),!1,!1),a+=":",a+=r(F.substr(O+1),!1,!0)),a+="@"}l=l.toLowerCase(),O=l.lastIndexOf(":"),O===-1?a+=r(l,!1,!0):(a+=r(l.substr(0,O),!1,!0),a+=l.substr(O))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const O=m.charCodeAt(1);O>=65&&O<=90&&(m=`/${String.fromCharCode(O+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const O=m.charCodeAt(0);O>=65&&O<=90&&(m=`${String.fromCharCode(O+32)}:${m.substr(2)}`)}a+=r(m,!0,!1)}return E&&(a+="?",a+=r(E,!1,!1)),A&&(a+="#",a+=n?A:u(A,!1,!1)),a}function I(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+I(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(i)?t.replace(i,n=>I(n)):t}}),define(se[146],oe([0,1,11]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function _(w){const P=w;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=_;function c(w){const P=[];let y;try{const g=JSON.parse(w.arguments),S=g[g.length-1];S&&S.__$stack&&(g.pop(),y=S.__$stack),P.push(...g)}catch{P.push("Unable to log remote console arguments",w.arguments)}return{args:P,stack:y}}e.parse=c;function T(w){if(typeof w!="string")return T(c(w).stack);const P=w;if(P){const y=L(P),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(g&&g.length===4)return{uri:R.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=T;function L(w){if(!w)return w;const P=w.indexOf(`
`);return P===-1?w:w.substring(0,P)}function D(w,P){const{args:y,stack:g}=c(w),S=typeof y[0]=="string"&&y.length===1;let d=L(g);d&&(d=`(${d.trim()})`);let p=[];if(typeof y[0]=="string"?d&&S?p=[`%c[${P}] %c${y[0]} %c${d}`,C("blue"),C(""),C("grey")]:p=[`%c[${P}] %c${y[0]}`,C("blue"),C(""),...y.slice(1)]:p=[`%c[${P}]%`,C("blue"),...y],d&&!S&&p.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,p)}e.log=D;function C(w){return`color: ${w}`}}),define(se[67],oe([0,1,17,27,11]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(w){return JSON.stringify(w,D)}e.stringify=T;function L(w){let P=JSON.parse(w);return P=C(P),P}e.parse=L;function D(w,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,_.regExpFlags)(P)}:P}function C(w,P=0){if(!w||P>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return c.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof R.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let y=0;y<w.length;++y)w[y]=C(w[y],P+1);else for(const y in w)Object.hasOwnProperty.call(w,y)&&(w[y]=C(w[y],P+1))}return w}e.revive=C}),define(se[22],oe([0,1,9,4,11]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var T;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(T=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${T.vscodeRemoteResource}`}set(P,y,g){this._hosts[P]=y,this._ports[P]=g}setConnectionToken(P,y){this._connectionTokens[P]=y}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)try{return this._delegate(P)}catch(h){return R.onUnexpectedError(h),P}const y=P.authority;let g=this._hosts[y];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const S=this._ports[y],d=this._connectionTokens[y];let p=`path=${encodeURIComponent(P.path)}`;return typeof d=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),c.URI.from({scheme:_.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${g}:${S}`,path:this._remoteResourcesPath,query:p})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(P){const y=this.toUri(P,Z);return this.uriToBrowserUri(y)}uriToBrowserUri(P){return P.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===T.file&&(_.isNative||_.isWebWorker&&_.globals.origin===`${T.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?P.with({scheme:T.vscodeFileResource,authority:P.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(P){const y=this.toUri(P,Z);return this.uriToFileUri(y)}uriToFileUri(P){return P.scheme===T.vscodeFileResource?P.with({scheme:T.file,authority:P.authority!==D.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(P,y){return c.URI.isUri(P)?P:c.URI.parse(y.toUrl(P))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var C;(function(w){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(P.get("3"));const y="vscode-coi";function g(d){let p;typeof d=="string"?p=new URL(d).searchParams:d instanceof URL?p=d.searchParams:c.URI.isUri(d)&&(p=new URL(d.toString(!0)).searchParams);const h=p?.get(y);if(!!h)return P.get(h)}w.getHeadersFromQuery=g;function S(d,p,h){if(!globalThis.crossOriginIsolated)return;const u=p&&h?"3":h?"2":"1";d instanceof URLSearchParams?d.set(y,u):d[y]=u}w.addSearchParam=S})(C=e.COI||(e.COI={}))}),define(se[23],oe([0,1,48,22,13,4,27,11]),function(Z,e,R,_,c,T,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(S){return(0,D.uriToFsPath)(S,!0)}e.originalFSPath=C;class w{constructor(d){this._ignorePathCasing=d}compare(d,p,h=!1){return d===p?0:(0,L.compare)(this.getComparisonKey(d,h),this.getComparisonKey(p,h))}isEqual(d,p,h=!1){return d===p?!0:!d||!p?!1:this.getComparisonKey(d,h)===this.getComparisonKey(p,h)}getComparisonKey(d,p=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,p,h=!1){if(d.scheme===p.scheme){if(d.scheme===_.Schemas.file)return R.isEqualOrParent(C(d),C(p),this._ignorePathCasing(d))&&d.query===p.query&&(h||d.fragment===p.fragment);if((0,e.isEqualAuthority)(d.authority,p.authority))return R.isEqualOrParent(d.path,p.path,this._ignorePathCasing(d),"/")&&d.query===p.query&&(h||d.fragment===p.fragment)}return!1}joinPath(d,...p){return D.URI.joinPath(d,...p)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return c.posix.basename(d.path)}extname(d){return c.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let p;return d.scheme===_.Schemas.file?p=D.URI.file(c.dirname(C(d))).path:(p=c.posix.dirname(d.path),d.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),p="/")),d.with({path:p})}normalizePath(d){if(!d.path.length)return d;let p;return d.scheme===_.Schemas.file?p=D.URI.file(c.normalize(C(d))).path:p=c.posix.normalize(d.path),d.with({path:p})}relativePath(d,p){if(d.scheme!==p.scheme||!(0,e.isEqualAuthority)(d.authority,p.authority))return;if(d.scheme===_.Schemas.file){const f=c.relative(C(d),C(p));return T.isWindows?R.toSlashes(f):f}let h=d.path||"/";const u=p.path||"/";if(this._ignorePathCasing(d)){let f=0;for(const v=Math.min(h.length,u.length);f<v&&!(h.charCodeAt(f)!==u.charCodeAt(f)&&h.charAt(f).toLowerCase()!==u.charAt(f).toLowerCase());f++);h=u.substr(0,f)+h.substr(f)}return c.posix.relative(h,u)}resolvePath(d,p){if(d.scheme===_.Schemas.file){const h=D.URI.file(c.resolve(C(d),p));return d.with({authority:h.authority,path:h.path})}return p=R.toPosixPath(p),d.with({path:c.posix.resolve(d.path,p)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,p){return d===p||d!==void 0&&p!==void 0&&(0,L.equalsIgnoreCase)(d,p)}hasTrailingPathSeparator(d,p=c.sep){if(d.scheme===_.Schemas.file){const h=C(d);return h.length>R.getRoot(h).length&&h[h.length-1]===p}else{const h=d.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,p=c.sep){return(0,e.hasTrailingPathSeparator)(d,p)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,p=c.sep){let h=!1;if(d.scheme===_.Schemas.file){const u=C(d);h=u!==void 0&&u.length===R.getRoot(u).length&&u[u.length-1]===p}else{p="/";const u=d.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(d,p)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(S=>S.scheme===_.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new w(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(S,d){const p=[];for(let h=0;h<S.length;h++){const u=d(S[h]);S.some((f,v)=>v===h?!1:(0,e.isEqualOrParent)(u,d(f)))||p.push(S[h])}return p}e.distinctParents=P;var y;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function d(p){const h=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(v=>{const[b,I]=v.split(":");b&&I&&h.set(b,I)});const f=p.path.substring(0,p.path.indexOf(";"));return f&&h.set(S.META_DATA_MIME,f),h}S.parseMetaData=d})(y=e.DataUri||(e.DataUri={}));function g(S,d,p){if(d){let h=S.path;return h&&h[0]!==c.posix.sep&&(h=c.posix.sep+h),S.with({scheme:p,authority:d,path:h})}return S.with({scheme:p})}e.toLocalResource=g}),define(se[6],oe([0,1,25,9,3,2,23,4,133]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(V){return!!V&&typeof V.then=="function"}e.isThenable=w;function P(V){const $=new R.CancellationTokenSource,U=V($.token),W=new Promise((B,Q)=>{const H=$.token.onCancellationRequested(()=>{H.dispose(),$.dispose(),Q(new _.CancellationError)});Promise.resolve(U).then(X=>{H.dispose(),$.dispose(),B(X)},X=>{H.dispose(),$.dispose(),Q(X)})});return new class{cancel(){$.cancel()}then(B,Q){return W.then(B,Q)}catch(B){return this.then(void 0,B)}finally(B){return W.finally(B)}}}e.createCancelablePromise=P;function y(V,$,U){return new Promise((W,B)=>{const Q=$.onCancellationRequested(()=>{Q.dispose(),W(U)});V.then(W,B).finally(()=>Q.dispose())})}e.raceCancellation=y;function g(V,$){return new Promise((U,W)=>{const B=$.onCancellationRequested(()=>{B.dispose(),W(new _.CancellationError)});V.then(U,W).finally(()=>B.dispose())})}e.raceCancellationError=g;async function S(V){let $=-1;const U=V.map((B,Q)=>B.then(H=>($=Q,H))),W=await Promise.race(U);return V.forEach((B,Q)=>{Q!==$&&B.cancel()}),W}e.raceCancellablePromises=S;function d(V,$,U){let W;const B=setTimeout(()=>{W?.(void 0),U?.()},$);return Promise.race([V.finally(()=>clearTimeout(B)),new Promise(Q=>W=Q)])}e.raceTimeout=d;function p(V){return new Promise(($,U)=>{const W=V();w(W)?W.then($,U):$(W)})}e.asPromise=p;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(U,U).then(W)})}return new Promise((U,W)=>{this.queuedPromise.then(U,W)})}return this.activePromise=$(),new Promise((U,W)=>{this.activePromise.then(B=>{this.activePromise=null,U(B)},B=>{this.activePromise=null,W(B)})})}}e.Throttler=h;class u{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=u;class f{constructor(){this.promiseMap=new Map}queue($,U){const B=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get($)===B&&this.promiseMap.delete($)});return this.promiseMap.set($,B),B}}e.SequencerByKey=f;const v=(V,$)=>{let U=!0;const W=setTimeout(()=>{U=!1,$()},V);return{isTriggered:()=>U,dispose:()=>{clearTimeout(W),U=!1}}},b=V=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,V())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class I{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,U=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,Q)=>{this.doResolve=B,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const W=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===C.MicrotaskDelay?b(W):v(U,W),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new _.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=I;class i{constructor($){this.delayer=new I($),this.throttler=new h}trigger($,U){return this.delayer.trigger(()=>this.throttler.queue($),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=i;class s{constructor(){this._isOpen=!1,this._promise=new Promise(($,U)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class t extends s{constructor($){super(),this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=t;function n(V,$){return $?new Promise((U,W)=>{const B=setTimeout(()=>{Q.dispose(),U()},V),Q=$.onCancellationRequested(()=>{clearTimeout(B),Q.dispose(),W(new _.CancellationError)})}):P(U=>n(V,U))}e.timeout=n;function r(V,$=0){const U=setTimeout(V,$);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=r;function a(V){const $=[];let U=0;const W=V.length;function B(){return U<W?V[U++]():null}function Q(H){H!=null&&$.push(H);const X=B();return X?X.then(Q):Promise.resolve($)}return Promise.resolve(null).then(Q)}e.sequence=a;function o(V,$=W=>!!W,U=null){let W=0;const B=V.length,Q=()=>{if(W>=B)return Promise.resolve(U);const H=V[W++];return Promise.resolve(H()).then(te=>$(te)?Promise.resolve(te):Q())};return Q()}e.first=o;function l(V,$=W=>!!W,U=null){if(V.length===0)return Promise.resolve(U);let W=V.length;const B=()=>{W=-1;for(const Q of V)Q.cancel?.()};return new Promise((Q,H)=>{for(const X of V)X.then(te=>{--W>=0&&$(te)?(B(),Q(te)):W===0&&Q(U)}).catch(te=>{--W>=0&&(B(),H(te))})})}e.firstParallel=l;class m{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new c.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue($){return this._size++,new Promise((U,W)=>{this.outstandingPromises.push({factory:$,c:U,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const U=$.factory();U.then($.c,$.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class E extends m{constructor(){super(1)}}e.Queue=E;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const $=new q;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueFor($,U=L.extUri){const W=U.getComparisonKey($);let B=this.queues.get(W);return B||(B=new E,c.Event.once(B.onDrained)(()=>{B?.dispose(),this.queues.delete(W),this.onDidQueueDrain()}),this.queues.set(W,B)),B}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class O{constructor($,U){this._token=-1,typeof $=="function"&&typeof U=="number"&&this.setIfNotSet($,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},U)}setIfNotSet($,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},U))}}e.TimeoutTimer=O;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,U){this.cancel(),this._token=setInterval(()=>{$()},U)}}e.IntervalTimer=F;class M{constructor($,U){this.timeoutToken=-1,this.runner=$,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class k{constructor($,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class N extends M{constructor($,U){super($,U),this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner?.($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class z extends T.Disposable{constructor($,U){super(),this.options=$,this.handler=U,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const U of $)this.pendingWork.push(U);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,D.setTimeout0)(()=>{if($)return;const U=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let $=!1;return{dispose(){$||($=!0)}}}:e.runWhenIdle=(V,$)=>{const U=requestIdleCallback(V,typeof $=="number"?{timeout:$}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(U))}}}}();class j{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function J(V,$,U){let W;for(let B=0;B<U;B++)try{return await V()}catch(Q){W=Q,await n($)}throw W}e.retry=J;class ne{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending($,U,W){return this._pending={taskId:$,cancel:()=>W?.(),promise:U},U.then(()=>this.donePending($),()=>this.donePending($)),U}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let U,W;const B=new Promise((Q,H)=>{U=Q,W=H});this._next={run:$,promise:B,promiseResolve:U,promiseReject:W}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=ne;class G{constructor($,U=()=>Date.now()){this.interval=$,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class q{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,U)=>{this.completeCallback=$,this.errorCallback=U})}complete($){return new Promise(U=>{this.completeCallback($),this.resolved=!0,U()})}error($){return new Promise(U=>{this.errorCallback($),this.rejected=!0,U()})}cancel(){new Promise($=>{this.errorCallback(new _.CancellationError),this.rejected=!0,$()})}}e.DeferredPromise=q;var x;(function(V){async function $(W){let B;const Q=await Promise.all(W.map(H=>H.then(X=>X,X=>{B||(B=X)})));if(typeof B<"u")throw B;return Q}V.settled=$;function U(W){return new Promise(async(B,Q)=>{try{await W(B,Q)}catch(H){Q(H)}})}V.withAsyncBody=U})(x=e.Promises||(e.Promises={}));var Y;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(Y||(Y={}));class ee{static fromArray($){return new ee(U=>{U.emitMany($)})}static fromPromise($){return new ee(async U=>{U.emitMany(await $)})}static fromPromises($){return new ee(async U=>{await Promise.all($.map(async W=>U.emitOne(await W)))})}static merge($){return new ee(async U=>{await Promise.all($.map(async W=>{for await(const B of W)U.emitOne(B)}))})}constructor($){this._state=0,this._results=[],this._error=null,this._onStateChanged=new c.Emitter,queueMicrotask(async()=>{const U={emitOne:W=>this.emitOne(W),emitMany:W=>this.emitMany(W),reject:W=>this.reject(W)};try{await Promise.resolve($(U)),this.resolve()}catch(W){this.reject(W)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===2)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===1)return{done:!0,value:void 0};await c.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map($,U){return new ee(async W=>{for await(const B of $)W.emitOne(U(B))})}map($){return ee.map(this,$)}static filter($,U){return new ee(async W=>{for await(const B of $)U(B)&&W.emitOne(B)})}filter($){return ee.filter(this,$)}static coalesce($){return ee.filter($,U=>!!U)}coalesce(){return ee.coalesce(this)}static async toPromise($){const U=[];for await(const W of $)U.push(W);return U}toPromise(){return ee.toPromise(this)}emitOne($){this._state===0&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===0&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject($){this._state===0&&(this._state=2,this._error=$,this._onStateChanged.fire())}}ee.EMPTY=ee.fromArray([]),e.AsyncIterableObject=ee;class re extends ee{constructor($,U){super(U),this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function ae(V){const $=new R.CancellationTokenSource,U=V($.token);return new re($,async W=>{const B=$.token.onCancellationRequested(()=>{B.dispose(),$.dispose(),W.reject(new _.CancellationError)});try{for await(const Q of U){if($.token.isCancellationRequested)return;W.emitOne(Q)}B.dispose(),$.dispose()}catch(Q){B.dispose(),$.dispose(),W.reject(Q)}})}e.createCancelableAsyncIterable=ae}),define(se[90],oe([0,1,21,6,48,37,13,4,27]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",y="[^/\\\\]",g=/\//g;function S(G,q){switch(G){case 0:return"";case 1:return`${y}*?`;default:return`(?:${P}|${y}+${P}${q?`|${P}${y}+`:""})*?`}}function d(G,q){if(!G)return[];const x=[];let Y=!1,ee=!1,re="";for(const ae of G){switch(ae){case q:if(!Y&&!ee){x.push(re),re="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}re+=ae}return re&&x.push(re),x}e.splitGlobAware=d;function p(G){if(!G)return"";let q="";const x=d(G,e.GLOB_SPLIT);if(x.every(Y=>Y===e.GLOBSTAR))q=".*";else{let Y=!1;x.forEach((ee,re)=>{if(ee===e.GLOBSTAR){if(Y)return;q+=S(2,re===x.length-1)}else{let ae=!1,V="",$=!1,U="";for(const W of ee){if(W!=="}"&&ae){V+=W;continue}if($&&(W!=="]"||!U)){let B;W==="-"?B=W:(W==="^"||W==="!")&&!U?B="^":W===e.GLOB_SPLIT?B="":B=(0,C.escapeRegExpCharacters)(W),U+=B;continue}switch(W){case"{":ae=!0;continue;case"[":$=!0;continue;case"}":{q+=`(?:${d(V,",").map(H=>p(H)).join("|")})`,ae=!1,V="";break}case"]":{q+="["+U+"]",$=!1,U="";break}case"?":q+=y;continue;case"*":q+=S(1);continue;default:q+=(0,C.escapeRegExpCharacters)(W)}}re<x.length-1&&(x[re+1]!==e.GLOBSTAR||re+2<x.length)&&(q+=P)}Y=ee===e.GLOBSTAR})}return q}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.LRUCache(1e4),s=function(){return!1},t=function(){return null};function n(G,q){if(!G)return t;let x;typeof G!="string"?x=G.pattern:x=G,x=x.trim();const Y=`${x}_${!!q.trimForExclusions}`;let ee=i.get(Y);if(ee)return r(ee,G);let re;return h.test(x)?ee=o(x.substr(4),x):(re=u.exec(a(x,q)))?ee=l(re[1],x):(q.trimForExclusions?v:f).test(x)?ee=m(x,q):(re=b.exec(a(x,q)))?ee=E(re[1].substr(1),x,!0):(re=I.exec(a(x,q)))?ee=E(re[1],x,!1):ee=A(x),i.set(Y,ee),r(ee,G)}function r(G,q){if(typeof q=="string")return G;const x=function(Y,ee){return(0,c.isEqualOrParent)(Y,q.base,!D.isLinux)?G((0,C.ltrim)(Y.substr(q.base.length),L.sep),ee):null};return x.allBasenames=G.allBasenames,x.allPaths=G.allPaths,x.basenames=G.basenames,x.patterns=G.patterns,x}function a(G,q){return q.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function o(G,q){return function(x,Y){return typeof x=="string"&&x.endsWith(G)?q:null}}function l(G,q){const x=`/${G}`,Y=`\\${G}`,ee=function(ae,V){return typeof ae!="string"?null:V?V===G?q:null:ae===G||ae.endsWith(x)||ae.endsWith(Y)?q:null},re=[G];return ee.basenames=re,ee.patterns=[q],ee.allBasenames=re,ee}function m(G,q){const x=J(G.slice(1,-1).split(",").map(V=>n(V,q)).filter(V=>V!==t),G),Y=x.length;if(!Y)return t;if(Y===1)return x[0];const ee=function(V,$){for(let U=0,W=x.length;U<W;U++)if(x[U](V,$))return G;return null},re=x.find(V=>!!V.allBasenames);re&&(ee.allBasenames=re.allBasenames);const ae=x.reduce((V,$)=>$.allPaths?V.concat($.allPaths):V,[]);return ae.length&&(ee.allPaths=ae),ee}function E(G,q,x){const Y=L.sep===L.posix.sep,ee=Y?G:G.replace(g,L.sep),re=L.sep+ee,ae=L.posix.sep+G;let V;return x?V=function($,U){return typeof $=="string"&&($===ee||$.endsWith(re)||!Y&&($===G||$.endsWith(ae)))?q:null}:V=function($,U){return typeof $=="string"&&($===ee||!Y&&$===G)?q:null},V.allPaths=[(x?"*/":"./")+G],V}function A(G){try{const q=new RegExp(`^${p(G)}$`);return function(x){return q.lastIndex=0,typeof x=="string"&&q.test(x)?G:null}}catch{return t}}function O(G,q,x){return!G||typeof q!="string"?!1:F(G)(q,void 0,x)}e.match=O;function F(G,q={}){if(!G)return s;if(typeof G=="string"||M(G)){const x=n(G,q);if(x===t)return s;const Y=function(ee,re){return!!x(ee,re)};return x.allBasenames&&(Y.allBasenames=x.allBasenames),x.allPaths&&(Y.allPaths=x.allPaths),Y}return z(G,q)}e.parse=F;function M(G){const q=G;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=M;function k(G){return G.allBasenames||[]}e.getBasenameTerms=k;function N(G){return G.allPaths||[]}e.getPathTerms=N;function z(G,q){const x=J(Object.getOwnPropertyNames(G).map(V=>j(V,G[V],q)).filter(V=>V!==t)),Y=x.length;if(!Y)return t;if(!x.some(V=>!!V.requiresSiblings)){if(Y===1)return x[0];const V=function(W,B){let Q;for(let H=0,X=x.length;H<X;H++){const te=x[H](W,B);if(typeof te=="string")return te;(0,_.isThenable)(te)&&(Q||(Q=[]),Q.push(te))}return Q?(async()=>{for(const H of Q){const X=await H;if(typeof X=="string")return X}return null})():null},$=x.find(W=>!!W.allBasenames);$&&(V.allBasenames=$.allBasenames);const U=x.reduce((W,B)=>B.allPaths?W.concat(B.allPaths):W,[]);return U.length&&(V.allPaths=U),V}const ee=function(V,$,U){let W,B;for(let Q=0,H=x.length;Q<H;Q++){const X=x[Q];X.requiresSiblings&&U&&($||($=(0,L.basename)(V)),W||(W=$.substr(0,$.length-(0,L.extname)(V).length)));const te=X(V,$,W,U);if(typeof te=="string")return te;(0,_.isThenable)(te)&&(B||(B=[]),B.push(te))}return B?(async()=>{for(const Q of B){const H=await Q;if(typeof H=="string")return H}return null})():null},re=x.find(V=>!!V.allBasenames);re&&(ee.allBasenames=re.allBasenames);const ae=x.reduce((V,$)=>$.allPaths?V.concat($.allPaths):V,[]);return ae.length&&(ee.allPaths=ae),ee}function j(G,q,x){if(q===!1)return t;const Y=n(G,x);if(Y===t)return t;if(typeof q=="boolean")return Y;if(q){const ee=q.when;if(typeof ee=="string"){const re=(ae,V,$,U)=>{if(!U||!Y(ae,V))return null;const W=ee.replace("$(basename)",()=>$),B=U(W);return(0,_.isThenable)(B)?B.then(Q=>Q?G:null):B?G:null};return re.requiresSiblings=!0,re}}return Y}function J(G,q){const x=G.filter(V=>!!V.basenames);if(x.length<2)return G;const Y=x.reduce((V,$)=>{const U=$.basenames;return U?V.concat(U):V},[]);let ee;if(q){ee=[];for(let V=0,$=Y.length;V<$;V++)ee.push(q)}else ee=x.reduce((V,$)=>{const U=$.patterns;return U?V.concat(U):V},[]);const re=function(V,$){if(typeof V!="string")return null;if(!$){let W;for(W=V.length;W>0;W--){const B=V.charCodeAt(W-1);if(B===47||B===92)break}$=V.substr(W)}const U=Y.indexOf($);return U!==-1?ee[U]:null};re.basenames=Y,re.patterns=ee,re.allBasenames=Y;const ae=G.filter(V=>!V.basenames);return ae.push(re),ae}function ne(G,q){return(0,R.equals)(G,q,(x,Y)=>typeof x=="string"&&typeof Y=="string"?x===Y:typeof x!="string"&&typeof Y!="string"?x.base===Y.base&&x.pattern===Y.pattern:!1)}e.patternsEquals=ne}),define(se[147],oe([0,1,17,11]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function c(y){return y.toJSON()}class T{constructor(g){this._uriTransformer=g}transformIncoming(g){const S=this._uriTransformer.transformIncoming(g);return S===g?g:c(_.URI.from(S))}transformOutgoing(g){const S=this._uriTransformer.transformOutgoing(g);return S===g?g:c(_.URI.from(S))}transformOutgoingURI(g){const S=this._uriTransformer.transformOutgoing(g);return S===g?g:_.URI.from(S)}transformOutgoingScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function L(y,g,S){if(!y||S>200)return null;if(typeof y=="object"){if(y instanceof _.URI)return g.transformOutgoing(y);for(const d in y)if(Object.hasOwnProperty.call(y,d)){const p=L(y[d],g,S+1);p!==null&&(y[d]=p)}}return null}function D(y,g){const S=L(y,g,0);return S===null?y:S}e.transformOutgoingURIs=D;function C(y,g,S,d){if(!y||d>200)return null;if(typeof y=="object"){if(y.$mid===1)return S?_.URI.revive(g.transformIncoming(y)):g.transformIncoming(y);if(y instanceof R.VSBuffer)return null;for(const p in y)if(Object.hasOwnProperty.call(y,p)){const h=C(y[p],g,S,d+1);h!==null&&(y[p]=h)}}return null}function w(y,g){const S=C(y,g,!1,0);return S===null?y:S}e.transformIncomingURIs=w;function P(y,g){const S=C(y,g,!0,0);return S===null?y:S}e.transformAndReviveIncomingURIs=P}),define(se[148],oe([0,1,34,9,49,31,135]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=c.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,y=0;const g=(0,R.networkInterfaces)();for(const S in g){const d=g[S];if(d)for(const{mac:p,internal:h}of d)h||(y+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(P+=1))}this._value=y>0?P/y:0}return this._value}};let D;async function C(){return D||(D=(async()=>await w()||T.generateUuid())()),D}e.getMachineId=C;async function w(){try{const P=await new Promise((g,S)=>{Z(["crypto"],g,S)}),y=(0,L.getMac)();return P.createHash("sha256").update(y,"utf8").digest("hex")}catch(P){_.onUnexpectedError(P);return}}}),define(se[28],oe([0,1,53,34,291,6,48,85,13,4,23,11]),function(Z,e,R,_,c,T,L,D,C,w,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function S(z,j=g.UNLINK){if((0,L.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return j===g.UNLINK?p(z):d(z)}async function d(z){try{const j=(0,L.randomPath)((0,_.tmpdir)());try{await R.promises.rename(z,j)}catch(J){return J.code==="ENOENT"?void 0:p(z)}p(j).catch(J=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function p(z){return(0,c.promisify)(R.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function h(z){if((0,L.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function u(z,j){return b(await(j?f(z):(0,c.promisify)(R.readdir)(z)))}async function f(z){try{return await(0,c.promisify)(R.readdir)(z,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const j=[],J=await u(z);for(const ne of J){let G=!1,q=!1,x=!1;try{const Y=await e.Promises.lstat((0,C.join)(z,ne));G=Y.isFile(),q=Y.isDirectory(),x=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}j.push({name:ne,isFile:()=>G,isDirectory:()=>q,isSymbolicLink:()=>x})}return j}function v(z){return b(R.readdirSync(z))}e.readdirSync=v;function b(z){return z.map(j=>typeof j=="string"?w.isMacintosh?(0,D.normalizeNFC)(j):j:(j.name=w.isMacintosh?(0,D.normalizeNFC)(j.name):j.name,j))}async function I(z){const j=await u(z),J=[];for(const ne of j)await s.existsDirectory((0,C.join)(z,ne))&&J.push(ne);return J}function i(z,j=1e3){return new Promise(J=>{let ne=!1;const G=setInterval(()=>{ne||(ne=!0,R.access(z,q=>{ne=!1,q&&(clearInterval(G),J(void 0))}))},j)})}e.whenDeleted=i;var s;(function(z){async function j(G){let q;try{if(q=await e.Promises.lstat(G),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(w.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw Y}throw x}}z.stat=j;async function J(G){try{const{stat:q,symbolicLink:x}=await z.stat(G);return q.isFile()&&x?.dangling!==!0}catch{}return!1}z.existsFile=J;async function ne(G){try{const{stat:q,symbolicLink:x}=await z.stat(G);return q.isDirectory()&&x?.dangling!==!0}catch{}return!1}z.existsDirectory=ne})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new T.ResourceQueue;function n(z,j,J){return t.queueFor(y.URI.file(z),P.extUriBiasedIgnorePathCase).queue(()=>{const ne=m(J);return new Promise((G,q)=>o(z,j,ne,x=>x?q(x):G()))})}let r=!0;function a(z){r=z}e.configureFlushOnWrite=a;function o(z,j,J,ne){if(!r)return R.writeFile(z,j,{mode:J.mode,flag:J.flag},ne);R.open(z,J.flag,J.mode,(G,q)=>{if(G)return ne(G);R.writeFile(q,j,x=>{if(x)return R.close(q,()=>ne(x));R.fdatasync(q,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),a(!1)),R.close(q,ee=>ne(ee))))})})}function l(z,j,J){const ne=m(J);if(!r)return R.writeFileSync(z,j,{mode:ne.mode,flag:ne.flag});const G=R.openSync(z,ne.flag,ne.mode);try{R.writeFileSync(G,j);try{R.fdatasyncSync(G)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),a(!1)}}finally{R.closeSync(G)}}e.writeFileSync=l;function m(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function E(z,j){if(z!==j)try{await e.Promises.rename(z,j)}catch(J){if(z.toLowerCase()!==j.toLowerCase()&&J.code==="EXDEV"||z.endsWith("."))await A(z,j,{preserveSymlinks:!1}),await S(z,g.MOVE);else throw J}}async function A(z,j,J){return F(z,j,{root:{source:z,target:j},options:J,handledSourcePaths:new Set})}const O=511;async function F(z,j,J){if(J.handledSourcePaths.has(z))return;J.handledSourcePaths.add(z);const{stat:ne,symbolicLink:G}=await s.stat(z);if(G){if(J.options.preserveSymlinks)try{return await N(z,j,J)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(G.dangling)return}return ne.isDirectory()?M(z,j,ne.mode&O,J):k(z,j,ne.mode&O)}async function M(z,j,J,ne){await e.Promises.mkdir(j,{recursive:!0,mode:J});const G=await u(z);for(const q of G)await F((0,C.join)(z,q),(0,C.join)(j,q),ne)}async function k(z,j,J){await e.Promises.copyFile(z,j),await e.Promises.chmod(j,J)}async function N(z,j,J){let ne=await e.Promises.readlink(z);(0,L.isEqualOrParent)(ne,J.root.source,!w.isLinux)&&(ne=(0,C.join)(J.root.target,ne.substr(J.root.source.length+1))),await e.Promises.symlink(ne,j)}e.Promises=new class{get access(){return(0,c.promisify)(R.access)}get stat(){return(0,c.promisify)(R.stat)}get lstat(){return(0,c.promisify)(R.lstat)}get utimes(){return(0,c.promisify)(R.utimes)}get read(){return(z,j,J,ne,G)=>new Promise((q,x)=>{R.read(z,j,J,ne,G,(Y,ee,re)=>Y?x(Y):q({bytesRead:ee,buffer:re}))})}get readFile(){return(0,c.promisify)(R.readFile)}get write(){return(z,j,J,ne,G)=>new Promise((q,x)=>{R.write(z,j,J,ne,G,(Y,ee,re)=>Y?x(Y):q({bytesWritten:ee,buffer:re}))})}get appendFile(){return(0,c.promisify)(R.appendFile)}get fdatasync(){return(0,c.promisify)(R.fdatasync)}get truncate(){return(0,c.promisify)(R.truncate)}get rename(){return(0,c.promisify)(R.rename)}get copyFile(){return(0,c.promisify)(R.copyFile)}get open(){return(0,c.promisify)(R.open)}get close(){return(0,c.promisify)(R.close)}get symlink(){return(0,c.promisify)(R.symlink)}get readlink(){return(0,c.promisify)(R.readlink)}get chmod(){return(0,c.promisify)(R.chmod)}get mkdir(){return(0,c.promisify)(R.mkdir)}get unlink(){return(0,c.promisify)(R.unlink)}get rmdir(){return(0,c.promisify)(R.rmdir)}get realpath(){return(0,c.promisify)(R.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return I}get writeFile(){return n}get rm(){return S}get move(){return E}get copy(){return A}}}),define(se[149],oe([0,1,53,13,4,27,28]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(g){if(c.isLinux)return g;const S=(0,_.dirname)(g);if(g===S)return g;const d=((0,_.basename)(g)||g).toLowerCase();try{const h=(0,L.readdirSync)(S).filter(u=>u.toLowerCase()===d);if(h.length===1){const u=D(S);if(u)return(0,_.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(d);if(u>=0){const f=D(S);if(f)return(0,_.join)(f,h[u])}}}catch{}return null}e.realcaseSync=D;async function C(g){if(c.isLinux)return g;const S=(0,_.dirname)(g);if(g===S)return g;const d=((0,_.basename)(g)||g).toLowerCase();try{const h=(await L.Promises.readdir(S)).filter(u=>u.toLowerCase()===d);if(h.length===1){const u=await C(S);if(u)return(0,_.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(d);if(u>=0){const f=await C(S);if(f)return(0,_.join)(f,h[u])}}}catch{}return null}e.realcase=C;async function w(g){try{return await L.Promises.realpath(g)}catch{const d=y(g);return await L.Promises.access(d,R.constants.R_OK),d}}e.realpath=w;function P(g){try{return R.realpathSync(g)}catch{const d=y(g);return R.accessSync(d,R.constants.R_OK),d}}e.realpathSync=P;function y(g){return(0,T.rtrim)((0,_.normalize)(g),_.sep)}}),define(se[91],oe([0,1,34,13,28]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,L=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var C;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(C||(C={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class y{constructor(I,i,s){this.exePath=I,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await c.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:b=!1}={}){return b?w===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:b=!1,findPreview:I=!1}={}){const i=g({useAlternateBitness:b});if(!i)return null;const s=_.join(i,"PowerShell");if(!await c.SymlinkSupport.existsDirectory(s))return null;let t=-1,n=null;for(const o of await c.Promises.readdir(s)){let l=-1;if(I){const E=o.indexOf("-");if(E<0)continue;const A=o.substring(0,E);if(!T.test(A)||o.substring(E+1)!=="preview")continue;l=parseInt(A,10)}else{if(!T.test(o))continue;l=parseInt(o,10)}if(l<=t)continue;const m=_.join(s,o,"pwsh.exe");!await c.SymlinkSupport.existsFile(m)||(n=m,t=l)}if(!n)return null;const r=i.includes("x86")?" (x86)":"",a=I?" Preview":"";return new y(n,`PowerShell${a}${r}`,!0)}async function d({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const I=_.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await c.SymlinkSupport.existsDirectory(I))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=b?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await c.Promises.readdir(I))if(i.test(t)){const n=_.join(I,t,"pwsh.exe");return new y(n,s)}return null}function p(){const b=_.join(R.homedir(),".dotnet","tools","pwsh.exe");return new y(b,".NET Core PowerShell Global Tool")}function h(){const b=_.join(process.env.windir,w===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(b,"Windows PowerShell",!0)}async function*u(){let b=await S();b&&(yield b),b=await S({useAlternateBitness:!0}),b&&(yield b),b=await d(),b&&(yield b),b=p(),b&&(yield b),b=await S({findPreview:!0}),b&&(yield b),b=await d({findPreview:!0}),b&&(yield b),b=await S({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=h(),b&&(yield b)}async function*f(){for await(const b of u())await b.exists()&&(yield b)}e.enumeratePowerShellInstallations=f;async function v(){for await(const b of f())return b;return null}e.getFirstAvailablePowerShellInstallation=v}),define(se[92],oe([0,1,13,4,36,87,12,28]),function(Z,e,R,_,c,T,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function C(y=c.env){return y.comspec||"cmd.exe"}e.getWindowsShell=C;function w(y){let g=[],S=!1;const d=function(p){if(S){g.push(p);return}(!y.send(p,u=>{if(u&&console.error(u),S=!1,g.length>0){const f=g.slice(0);g=[],f.forEach(v=>d(v))}})||_.isWindows)&&(S=!0)};return{send:d}}e.createQueuedSender=w;var P;(function(y){async function g(S,d,p){if(R.isAbsolute(S))return S;if(d===void 0&&(d=c.cwd()),R.dirname(S)!=="."||(p===void 0&&L.isString(c.env.PATH)&&(p=c.env.PATH.split(R.delimiter)),p===void 0||p.length===0))return R.join(d,S);async function u(f){if(await D.Promises.exists(f)){let v;try{v=await D.Promises.stat(f)}catch(b){b.message.startsWith("EACCES")&&(v=await D.Promises.lstat(f))}return v?!v.isDirectory():!1}return!1}for(const f of p){let v;if(R.isAbsolute(f)?v=R.join(f,S):v=R.join(d,f,S),await u(v))return v;let b=v+".com";if(await u(b)||(b=v+".exe",await u(b)))return b}return R.join(d,S)}y.findExecutable=g})(P=e.win32||(e.win32={}))}),define(se[150],oe([0,1,50,22]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function c(L){return new Promise((D,C)=>{let w;const P=new Map;function y(S,d,p,h,u){const f=P.get(d);if(S===L||f){const v={name:g(p),cmd:p,pid:S,ppid:d,load:h,mem:u};P.set(S,v),S===L&&(w=v),f&&(f.children||(f.children=[]),f.children.push(v),f.children.length>1&&(f.children=f.children.sort((b,I)=>b.pid-I.pid)))}}function g(S){const d=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,h=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,f=/--utility-sub-type=node.mojom.NodeService/,v=/--crashes-directory/,b=/\\pipe\\winpty-control/,I=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(v.exec(S))return"electron-crash-reporter";if(b.exec(S))return"winpty-process";if(I.exec(S))return"console-window-host (Windows internal process)";let s=i.exec(S);if(s&&s.length===2){if(s[1]==="renderer")return d.exec(S)?"shared-process":p.exec(S)?"issue-reporter":h.exec(S)?"process-explorer":"window";if(s[1]==="utility"){if(u.exec(S))return"utility-network-service";if(f.exec(S))return"extension-host"}else if(s[1]==="extensionHost")return"extension-host";return s[1]}const t=/[a-zA-Z-]+\.js/g;let n="";do s=t.exec(S),s&&(n+=s+" ");while(s);return n&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${n}`:S}if(process.platform==="win32"){const S=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,p)=>{Z(["windows-process-tree"],d,p)}).then(d=>{d.getProcessList(L,p=>{if(!p){C(new Error(`Root process ${L} not found`));return}d.getProcessCpuUsage(p,h=>{const u=new Map;h.forEach(f=>{const v=S(f.commandLine||"");u.set(f.pid,{name:g(v),cmd:v,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),w=u.get(L),w?(u.forEach(f=>{const v=u.get(f.ppid);v&&(v.children||(v.children=[]),v.children.push(f))}),u.forEach(f=>{f.children&&(f.children=f.children.sort((v,b)=>v.pid-b.pid))}),D(w)):C(new Error(`Root process ${L} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let S=function(){let d=[w];const p=[];for(;d.length;){const u=d.shift();u&&(p.push(u.pid),u.children&&(d=d.concat(u.children)))}let h=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);h+=" "+p.join(" "),(0,R.exec)(h,{},(u,f,v)=>{if(u||v)C(u||new Error(v.toString()));else{const b=f.toString().split(`
`);for(let I=0;I<p.length;I++){const i=P.get(p[I]);i.load=parseFloat(b[I])}if(!w){C(new Error(`Root process ${L} not found`));return}D(w)}})};(0,R.exec)("which ps",{},(d,p,h)=>{if(d||h)if(process.platform!=="linux")C(d||new Error(h.toString()));else{const u=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(u,{},(f,v,b)=>{f||b?C(f||new Error(b.toString())):(T(v,y),S())})}else{const u=p.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${u} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,b,I)=>{v||I&&!I.includes("screen size is bogus")?C(v||new Error(I.toString())):(T(b,y),process.platform==="linux"?S():w?D(w):C(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=c;function T(L,D){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=L.toString().split(`
`);for(const P of w){const y=C.exec(P.trim());y&&y.length===6&&D(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(se[151],oe([0,1,34,4,91,92]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function L(y,g){return y===1?_.isWindows?P():T.getWindowsShell(g):C(y,g)}e.getSystemShell=L;let D=null;function C(y,g){if(_.isLinux&&y===2||_.isMacintosh&&y===3)return"/bin/bash";if(!D){let S;if(_.isWindows)S="/bin/bash";else{if(S=g.SHELL,!S)try{S=(0,R.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}D=S}return D}let w=null;async function P(){return w||(w=(await(0,c.getFirstAvailablePowerShellInstallation)()).exePath),w}});var Se=this&&this.__decorate||function(Z,e,R,_){var c=arguments.length,T=c<3?e:_===null?_=Object.getOwnPropertyDescriptor(e,R):_,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Z,e,R,_);else for(var D=Z.length-1;D>=0;D--)(L=Z[D])&&(T=(c<3?L(T):c>3?L(e,R,T):L(e,R))||T);return c>3&&T&&Object.defineProperty(e,R,T),T};define(se[39],oe([0,1,21,6,17,25,63,9,3,2,67,27,12]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var S;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(S||(S={}));function d(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p||(p={}));function h(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(u||(u={}));function f(q){let x=0;for(let Y=0;;Y+=7){const ee=q.read(1);if(x|=(ee.buffer[0]&127)<<Y,!(ee.buffer[0]&128))return x}}const v=t(0);function b(q,x){if(x===0){q.write(v);return}let Y=0;for(let re=x;re!==0;re=re>>>7)Y++;const ee=c.VSBuffer.alloc(Y);for(let re=0;x!==0;re++)ee.buffer[re]=x&127,x=x>>>7,x>0&&(ee.buffer[re]|=128);q.write(ee)}class I{constructor(x){this.buffer=x,this.pos=0}read(x){const Y=this.buffer.slice(this.pos,this.pos+x);return this.pos+=Y.byteLength,Y}}e.BufferReader=I;class i{constructor(){this.buffers=[]}get buffer(){return c.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}e.BufferWriter=i;var s;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(s||(s={}));function t(q){const x=c.VSBuffer.alloc(1);return x.writeUInt8(q,0),x}const n={Undefined:t(s.Undefined),String:t(s.String),Buffer:t(s.Buffer),VSBuffer:t(s.VSBuffer),Array:t(s.Array),Object:t(s.Object),Uint:t(s.Int)},r=typeof Buffer<"u";function a(q,x){if(typeof x>"u")q.write(n.Undefined);else if(typeof x=="string"){const Y=c.VSBuffer.fromString(x);q.write(n.String),b(q,Y.byteLength),q.write(Y)}else if(r&&Buffer.isBuffer(x)){const Y=c.VSBuffer.wrap(x);q.write(n.Buffer),b(q,Y.byteLength),q.write(Y)}else if(x instanceof c.VSBuffer)q.write(n.VSBuffer),b(q,x.byteLength),q.write(x);else if(Array.isArray(x)){q.write(n.Array),b(q,x.length);for(const Y of x)a(q,Y)}else if(typeof x=="number"&&(x|0)===x)q.write(n.Uint),b(q,x);else{const Y=c.VSBuffer.fromString(JSON.stringify(x));q.write(n.Object),b(q,Y.byteLength),q.write(Y)}}e.serialize=a;function o(q){switch(q.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return q.read(f(q)).toString();case s.Buffer:return q.read(f(q)).buffer;case s.VSBuffer:return q.read(f(q));case s.Array:{const Y=f(q),ee=[];for(let re=0;re<Y;re++)ee.push(o(q));return ee}case s.Object:return JSON.parse(q.read(f(q)).toString());case s.Int:return f(q)}}e.deserialize=o;class l{constructor(x,Y,ee=null,re=1e3){this.protocol=x,this.ctx=Y,this.logger=ee,this.timeoutDelay=re,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(x,Y){this.channels.set(x,Y),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const Y=this.send([x.type]);this.logger?.logOutgoing(Y,0,1,h(x.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(Y,x.id,1,h(x.type),x.data);return}}}send(x,Y=void 0){const ee=new i;return a(ee,x),a(ee,Y),this.sendBuffer(ee.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const Y=new I(x),ee=o(Y),re=o(Y),ae=ee[0];switch(ae){case 100:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${d(ae)}: ${ee[2]}.${ee[3]}`,re),this.onPromise({type:ae,id:ee[1],channelName:ee[2],name:ee[3],arg:re});case 102:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${d(ae)}: ${ee[2]}.${ee[3]}`,re),this.onEventListen({type:ae,id:ee[1],channelName:ee[2],name:ee[3],arg:re});case 101:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${d(ae)}`),this.disposeActiveRequest({type:ae,id:ee[1]});case 103:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${d(ae)}`),this.disposeActiveRequest({type:ae,id:ee[1]})}}onPromise(x){const Y=this.channels.get(x.channelName);if(!Y){this.collectPendingRequest(x);return}const ee=new T.CancellationTokenSource;let re;try{re=Y.call(this.ctx,x.name,x.arg,ee.token)}catch($){re=Promise.reject($)}const ae=x.id;re.then($=>{this.sendResponse({id:ae,data:$,type:201}),this.activeRequests.delete(x.id)},$=>{$ instanceof Error?this.sendResponse({id:ae,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:ae,data:$,type:203}),this.activeRequests.delete(x.id)});const V=(0,w.toDisposable)(()=>ee.cancel());this.activeRequests.set(x.id,V)}onEventListen(x){const Y=this.channels.get(x.channelName);if(!Y){this.collectPendingRequest(x);return}const ee=x.id,ae=Y.listen(this.ctx,x.name,x.arg)(V=>this.sendResponse({id:ee,data:V,type:204}));this.activeRequests.set(x.id,ae)}disposeActiveRequest(x){const Y=this.activeRequests.get(x.id);Y&&(Y.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let Y=this.pendingRequests.get(x.channelName);Y||(Y=[],this.pendingRequests.set(x.channelName,Y));const ee=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:x,timeoutTimer:ee})}flushPendingRequests(x){const Y=this.pendingRequests.get(x);if(Y){for(const ee of Y)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var m;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(x,Y=null){this.protocol=x,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=Y}getChannel(x){const Y=this;return{call(ee,re,ae){return Y.isDisposed?Promise.reject(new D.CancellationError):Y.requestPromise(x,ee,re,ae)},listen(ee,re){return Y.isDisposed?C.Event.None:Y.requestEvent(x,ee,re)}}}requestPromise(x,Y,ee,re=T.CancellationToken.None){const ae=this.lastRequestId++,$={id:ae,type:100,channelName:x,name:Y,arg:ee};if(re.isCancellationRequested)return Promise.reject(new D.CancellationError);let U;return new Promise((B,Q)=>{if(re.isCancellationRequested)return Q(new D.CancellationError);const H=()=>{const he=me=>{switch(me.type){case 201:this.handlers.delete(ae),B(me.data);break;case 202:{this.handlers.delete(ae);const pe=new Error(me.data.message);pe.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,pe.name=me.data.name,Q(pe);break}case 203:this.handlers.delete(ae),Q(me.data);break}};this.handlers.set(ae,he),this.sendRequest($)};let X=null;this.state===u.Idle?H():(X=(0,_.createCancelablePromise)(he=>this.whenInitialized()),X.then(()=>{X=null,H()}));const te=()=>{X?(X.cancel(),X=null):this.sendRequest({id:ae,type:101}),Q(new D.CancellationError)},le=re.onCancellationRequested(te);U=(0,w.combinedDisposable)((0,w.toDisposable)(te),le),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(x,Y,ee){const re=this.lastRequestId++,V={id:re,type:102,channelName:x,name:Y,arg:ee};let $=null;const U=new C.Emitter({onWillAddFirstListener:()=>{$=(0,_.createCancelablePromise)(B=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(U),this.sendRequest(V)})},onDidRemoveLastListener:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(U),this.sendRequest({id:re,type:103}))}}),W=B=>U.fire(B.data);return this.handlers.set(re,W),U.event}sendRequest(x){switch(x.type){case 100:case 102:{const Y=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(Y,x.id,0,`${d(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const Y=this.send([x.type,x.id]);this.logger?.logOutgoing(Y,x.id,0,d(x.type));return}}}send(x,Y=void 0){const ee=new i;return a(ee,x),a(ee,Y),this.sendBuffer(ee.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const Y=new I(x),ee=o(Y),re=o(Y),ae=ee[0];switch(ae){case 200:return this.logger?.logIncoming(x.byteLength,0,0,h(ae)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,ee[1],0,h(ae),re),this.onResponse({type:ee[0],id:ee[1],data:re})}}onResponse(x){if(x.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Se([L.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class A{get connections(){const x=[];return this._connections.forEach(Y=>x.push(Y)),x}constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:Y,onDidClientDisconnect:ee})=>{C.Event.once(Y.onMessage)(ae=>{const V=new I(ae),$=o(V),U=new l(Y,$),W=new E(Y);this.channels.forEach((Q,H)=>U.registerChannel(H,Q));const B={channelServer:U,channelClient:W,ctx:$};this._connections.add(B),this._onDidAddConnection.fire(B),ee(()=>{U.dispose(),W.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}getChannel(x,Y){const ee=this;return{call(re,ae,V){let $;if((0,g.isFunction)(Y)){const W=(0,R.getRandomElement)(ee.connections.filter(Y));$=W?Promise.resolve(W):C.Event.toPromise(C.Event.filter(ee.onDidAddConnection,Y))}else $=Y.routeCall(ee,re,ae);const U=$.then(W=>W.channelClient.getChannel(x));return F(U).call(re,ae,V)},listen(re,ae){if((0,g.isFunction)(Y))return ee.getMulticastEvent(x,Y,re,ae);const V=Y.routeEvent(ee,re,ae).then($=>$.channelClient.getChannel(x));return F(V).listen(re,ae)}}}getMulticastEvent(x,Y,ee,re){const ae=this;let V=new w.DisposableStore;const $=new C.Emitter({onWillAddFirstListener:()=>{V=new w.DisposableStore;const U=new C.EventMultiplexer,W=new Map,B=H=>{const te=H.channelClient.getChannel(x).listen(ee,re),le=U.add(te);W.set(H,le)},Q=H=>{const X=W.get(H);!X||(X.dispose(),W.delete(H))};ae.connections.filter(Y).forEach(B),C.Event.filter(ae.onDidAddConnection,Y)(B,void 0,V),ae.onDidRemoveConnection(Q,void 0,V),U.event($.fire,$,V),V.add(U)},onDidRemoveLastListener:()=>{V.dispose()}});return $.event}registerChannel(x,Y){this.channels.set(x,Y),this._connections.forEach(ee=>{ee.channelServer.registerChannel(x,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(x,Y,ee=null){const re=new i;a(re,Y),x.send(re.buffer),this.channelClient=new E(x,ee),this.channelServer=new l(x,Y,ee)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,Y){this.channelServer.registerChannel(x,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function F(q){return{call(x,Y,ee){return q.then(re=>re.call(x,Y,ee))},listen(x,Y){const ee=new C.Relay;return q.then(re=>ee.input=re.listen(x,Y)),ee.event}}}e.getDelayedChannel=F;function M(q){let x=!1;return{call(Y,ee,re){return x?q.call(Y,ee,re):(0,_.timeout)(0).then(()=>x=!0).then(()=>q.call(Y,ee,re))},listen(Y,ee){if(x)return q.listen(Y,ee);const re=new C.Relay;return(0,_.timeout)(0).then(()=>x=!0).then(()=>re.input=q.listen(Y,ee)),re.event}}}e.getNextTickChannel=M;class k{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const Y of x.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await C.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=k;var N;(function(q){function x(ae,V){const $=ae,U=V&&V.disableMarshalling,W=new Map;for(const B in $)ee(B)&&W.set(B,C.Event.buffer($[B],!0));return new class{listen(B,Q,H){const X=W.get(Q);if(X)return X;if(re(Q)){const te=$[Q];if(typeof te=="function")return te.call($,H)}throw new Error(`Event not found: ${Q}`)}call(B,Q,H){const X=$[Q];if(typeof X=="function"){if(!U&&Array.isArray(H))for(let te=0;te<H.length;te++)H[te]=(0,P.revive)(H[te]);return X.apply($,H)}throw new Error(`Method not found: ${Q}`)}}}q.fromService=x;function Y(ae,V){const $=V&&V.disableMarshalling;return new Proxy({},{get(U,W){if(typeof W=="string")return V?.properties?.has(W)?V.properties.get(W):re(W)?function(B){return ae.listen(W,B)}:ee(W)?ae.listen(W):async function(...B){let Q;V&&!(0,g.isUndefinedOrNull)(V.context)?Q=[V.context,...B]:Q=B;const H=await ae.call(W,Q);return $?H:(0,P.revive)(H)};throw new Error(`Property not found: ${String(W)}`)}})}q.toService=Y;function ee(ae){return ae[0]==="o"&&ae[1]==="n"&&y.isUpperAsciiLetter(ae.charCodeAt(2))}function re(ae){return/^onDynamic/.test(ae)&&y.isUpperAsciiLetter(ae.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const x=q.toString();if(x!=="[object Object]")return x}return q}function J(q){return Array.isArray(q)?q.map(j):j(q)}function ne(q,x,Y,ee,re,ae,V){V=J(V);const $=z[re],U=$[ee%$.length];let W=[`%c[${q}]%c[${String(x).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ae)?(W=W.concat(V),W.push(")")):W.push(V),console.log.apply(console,W)}class G{constructor(x,Y){this._outgoingPrefix=x,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,Y,ee,re,ae){this._totalOutgoing+=x,ne(this._outgoingPrefix,this._totalOutgoing,x,Y,ee,re,ae)}logIncoming(x,Y,ee,re,ae){this._totalIncoming+=x,ne(this._incomingPrefix,this._totalIncoming,x,Y,ee,re,ae)}}e.IPCLogger=G}),define(se[152],oe([0,1,17,3,39]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(C){this.port=C,this.onMessage=_.Event.fromDOMEventEmitter(this.port,"message",w=>R.VSBuffer.wrap(w.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class L extends c.IPCClient{constructor(C,w){const P=new T(C);super(P,w),this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=L}),define(se[93],oe([0,1,6,17,3,2,39]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(E){E.enableDiagnostics=!1,E.records=[];const A=new WeakMap;let O=0;function F(k,N){if(!A.has(k)){const z=String(++O);A.set(k,z)}return A.get(k)}function M(k,N,z,j){if(!E.enableDiagnostics)return;const J=F(k,N);if(j instanceof _.VSBuffer||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const ne=_.VSBuffer.alloc(j.byteLength);ne.set(j),E.records.push({timestamp:Date.now(),id:J,label:N,type:z,buff:ne})}else E.records.push({timestamp:Date.now(),id:J,label:N,type:z,data:j})}E.traceSocketEvent=M})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function y(){return P||(P=_.VSBuffer.alloc(0)),P}class g{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(A){this._chunks.push(A),this._totalLength+=A.byteLength}read(A){return this._read(A,!0)}peek(A){return this._read(A,!1)}_read(A,O){if(A===0)return y();if(A>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===A){const N=this._chunks[0];return O&&(this._chunks.shift(),this._totalLength-=A),N}if(this._chunks[0].byteLength>A){const N=this._chunks[0].slice(0,A);return O&&(this._chunks[0]=this._chunks[0].slice(A),this._totalLength-=A),N}const F=_.VSBuffer.alloc(A);let M=0,k=0;for(;A>0;){const N=this._chunks[k];if(N.byteLength>A){const z=N.slice(0,A);F.set(z,M),M+=A,O&&(this._chunks[k]=N.slice(A),this._totalLength-=A),A-=A}else F.set(N,M),M+=N.byteLength,O?(this._chunks.shift(),this._totalLength-=N.byteLength):k++,A-=N.byteLength}return F}}e.ChunkStream=g;var S;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(S||(S={}));function d(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(A,O,F,M){this.type=A,this.id=O,this.ack=F,this.data=M,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends T.Disposable{constructor(A){super(),this._onMessage=this._register(new c.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=A,this._isDisposed=!1,this._incomingData=new g,this._register(this._socket.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(A){if(!(!A||A.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(A);this._incomingData.byteLength>=this._state.readLen;){const O=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=O.readUInt32BE(9),this._state.messageType=O.readUInt8(0),this._state.id=O.readUInt32BE(1),this._state.ack=O.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:d(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const F=this._state.messageType,M=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",O),this._onMessage.fire(new h(F,M,k,O)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(A){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=A,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(A){if(this._isDisposed)return;A.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=_.VSBuffer.alloc(13);O.writeUInt8(A.type,0),O.writeUInt32BE(A.id,1),O.writeUInt32BE(A.ack,5),O.writeUInt32BE(A.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:d(A.type),id:A.id,ack:A.ack,messageSize:A.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",A.data),this._writeSoon(O,A.data)}_bufferAdd(A,O){const F=this._totalLength===0;return this._data.push(A,O),this._totalLength+=A.byteLength+O.byteLength,F}_bufferTake(){const A=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,A}_writeSoon(A,O){this._bufferAdd(A,O)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const A=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:A.byteLength}),this._socket.write(A)}}class v extends T.Disposable{constructor(A){super(),this._onMessage=new c.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new c.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=A,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(O=>{O.type===1&&this._onMessage.fire(O.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(A){this._socketWriter.write(new h(1,0,0,A))}}e.Protocol=v;class b extends L.IPCClient{static fromSocket(A,O){return new b(new v(A),O)}get onDidDispose(){return this.protocol.onDidDispose}constructor(A,O,F=null){super(A,O,F),this.protocol=A}dispose(){super.dispose();const A=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),A.end()}}e.Client=b;class I{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new c.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(A){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(A):this._emitter.fire(A):this._bufferedMessages.push(A)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=I;class i{constructor(A){this.data=A,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let A=0,O=this._first;for(;O;)O=O.next,A++;return A}peek(){return this._first?this._first.data:null}toArray(){const A=[];let O=0,F=this._first;for(;F;)A[O++]=F.data,F=F.next;return A}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(A){const O=new i(A);if(!this._first){this._first=O,this._last=O;return}this._last.next=O,this._last=O}}class t{static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}constructor(){this.lastRuns=[];const A=Date.now();for(let O=0;O<t._HISTORY_LENGTH;O++)this.lastRuns[O]=A-1e3*O;setInterval(()=>{for(let O=t._HISTORY_LENGTH;O>=1;O--)this.lastRuns[O]=this.lastRuns[O-1];this.lastRuns[0]=Date.now()},1e3)}load(){const A=Date.now(),O=(1+t._HISTORY_LENGTH)*1e3;let F=0;for(let M=0;M<t._HISTORY_LENGTH;M++)A-this.lastRuns[M]<=O&&F++;return 1-F/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;var n;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function r(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class a{constructor(A){this.connectionHealth=A}}e.ConnectionHealthChangedEvent=a;class o{constructor(A,O){this.roundTripTime=A,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=o;class l{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(A){this._onControlMessage=new I,this.onControlMessage=this._onControlMessage.event,this._onMessage=new I,this.onMessage=this._onMessage.event,this._onDidDispose=new I,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new I,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new I,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new I,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new I,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=A.loadEstimator??t.getInstance(),this._measureRoundTripTime=A.measureRoundTripTime??!1,this._shouldSendKeepAlive=A.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new T.DisposableStore,this._socket=A.socket,this._socketWriter=this._socketDisposables.add(new f(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(O=>this._receiveMessage(O))),this._socketDisposables.add(this._socket.onClose(O=>this._onSocketClose.fire(O))),this._socketLatencyMonitor=this._socketDisposables.add(new m),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(O=>this._sendLatencyMeasurementRequest(O))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(O=>this._onHighRoundTripTime.fire(O))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(O=>this._onDidChangeConnectionHealth.fire(O))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),A.initialChunk&&this._socketReader.acceptChunk(A.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const A=new h(5,0,0,y());this._socketWriter.write(A),this._socketWriter.flush()}sendPause(){const A=new h(7,0,0,y());this._socketWriter.write(A)}sendResume(){const A=new h(8,0,0,y());this._socketWriter.write(A)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(A,O){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new T.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=A,this._socketWriter=this._socketDisposables.add(new f(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(F=>this._receiveMessage(F))),this._socketDisposables.add(this._socket.onClose(F=>this._onSocketClose.fire(F))),this._socketLatencyMonitor=this._socketDisposables.add(new m),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(F=>this._sendLatencyMeasurementRequest(F))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(F=>this._onHighRoundTripTime.fire(F))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(F=>this._onDidChangeConnectionHealth.fire(F))),this._socketReader.acceptChunk(O)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const A=new h(3,0,this._incomingAckId,y());this._socketWriter.write(A);const O=this._outgoingUnackMsg.toArray();for(let F=0,M=O.length;F<M;F++)this._socketWriter.write(O[F]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(A){if(A.ack>this._outgoingAckId){this._outgoingAckId=A.ack;do{const O=this._outgoingUnackMsg.peek();if(O&&O.id<=A.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(A.type){case 0:break;case 1:{if(A.id>this._incomingMsgId)if(A.id!==this._incomingMsgId+1){const O=Date.now();O-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=O,this._socketWriter.write(new h(6,0,0,y())))}else this._incomingMsgId=A.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(A.data);break}case 2:{this._onControlMessage.fire(A.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const O=this._outgoingUnackMsg.toArray();for(let F=0,M=O.length;F<M;F++)this._socketWriter.write(O[F]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(A.data);break}case 11:{this._socketLatencyMonitor.handleResponse(A.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(A){const O=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const F=new h(1,O,this._incomingAckId,A);this._outgoingUnackMsg.push(F),this._isReconnecting||(this._socketWriter.write(F),this._recvAckCheck())}sendControl(A){const O=new h(2,0,0,A);this._socketWriter.write(O)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const A=Date.now()-this._incomingMsgLastTime;if(A>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-A+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const A=this._outgoingUnackMsg.peek(),O=Date.now()-A.writtenTime,F=Date.now()-this._socketReader.lastReadTime,M=Date.now()-this._lastSocketTimeoutTime;if(O>=2e4&&F>=2e4&&M>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:F});return}const k=Math.max(2e4-O,2e4-F,2e4-M,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const A=new h(3,0,this._incomingAckId,y());this._socketWriter.write(A)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const A=new h(9,0,this._incomingAckId,y());this._socketWriter.write(A)}_sendLatencyMeasurementRequest(A){this._incomingAckId=this._incomingMsgId;const O=new h(10,0,this._incomingAckId,A);this._socketWriter.write(O)}_sendLatencyMeasurementResponse(A){this._incomingAckId=this._incomingMsgId;const O=new h(11,0,this._incomingAckId,A);this._socketWriter.write(O)}}e.PersistentProtocol=l;class m extends T.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new c.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new c.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new c.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new R.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},A=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const A=++this._lastLatencyMeasurementId,O=_.VSBuffer.alloc(4);O.writeUInt32BE(A,0),this._onSendLatencyRequest.fire(O)},6e4)}handleResponse(A){if(A.byteLength!==4)return;const O=A.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||O!==this._lastLatencyMeasurementId)return;const F=Date.now()-this._lastLatencyMeasurementSent,M=this._latencySampleIndex++;this._latencySamples[M%this._latencySamples.length]=F;const k=this._connectionHealth,N=this._latencySamples.filter(z=>z>=1e3).length;this._connectionHealth=N>=3?1:0,F>1e3&&this._onHighRoundTripTime.fire(new o(F,N)),k!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(se[153],oe([0,1,94,3,39,152]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends c.IPCServer{static getOnDidClientConnect(){const C=_.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(w,P)=>P);return _.Event.map(C,w=>{const{port1:P,port2:y}=new MessageChannel,S={protocol:new T.Protocol(P),onDidClientDisconnect:_.Event.fromDOMEventEmitter(P,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[y]),S})}constructor(){super(L.getOnDidClientConnect())}}e.Server=L}),define(se[68],oe([0,1,50,6,17,25,146,9,3,2,32,92,87,39]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends S.ChannelServer{constructor(u){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",f=>c.VSBuffer.wrap(Buffer.from(f,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=d;class p{constructor(u,f){this.modulePath=u,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new _.Delayer(v),this.child=null,this._client=null}getChannel(u){const f=this;return{call(v,b,I){return f.requestPromise(u,v,b,I)},listen(v,b){return f.requestEvent(u,v,b)}}}requestPromise(u,f,v,b=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const I=this.getCachedChannel(u),i=(0,_.createCancelablePromise)(n=>I.call(f,v,n)),s=b.onCancellationRequested(()=>i.cancel()),t=(0,w.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(u,f,v){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let b;const I=new C.Emitter({onWillAddFirstListener:()=>{b=this.getCachedChannel(u).listen(f,v)(I.fire,I),this.activeRequests.add(b)},onDidRemoveLastListener:()=>{this.activeRequests.delete(b),b.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return I.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,g.removeDangerousEnvVariables)(f.env),this.child=(0,R.fork)(this.modulePath,u,f);const v=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,L.isRemoteConsoleLog)(r)){(0,L.log)(r,`IPC Library: ${this.options.serverName}`);return}v.fire(c.VSBuffer.wrap(Buffer.from(r,"base64")))});const I=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,i=r=>this.child&&this.child.connected&&I.send(r.buffer.toString("base64")),s=v.event,t={send:i,onMessage:s};this._client=new S.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,w.dispose)(o)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(u){let f=this.channels.get(u);return f||(f=this.client.getChannel(u),this.channels.set(u,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(se[154],oe([0,1,17,9,3,2,13,4,31,39,93]),function(Z,e,R,_,c,T,L,D,C,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class g{traceSocketEvent(o,l){P.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,l)}constructor(o,l=""){this._canWrite=!0,this.debugLabel=l,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=m=>{if(this.traceSocketEvent("error",{code:m?.code,message:m?.message}),m){if(m.code==="EPIPE")return;(0,_.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener),this._closeListener=m=>{this.traceSocketEvent("close",{hadError:m}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(o){const l=m=>{this.traceSocketEvent("read",m),o(R.VSBuffer.wrap(m))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(o){const l=m=>{o({type:0,hadError:m,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(o){const l=()=>{o()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(o){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,_.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,_.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=g;var S;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class p extends T.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,l){this.socket.traceSocketEvent(o,l)}constructor(o,l,m,E){super(),this._onData=this._register(new c.Emitter),this._onClose=this._register(new c.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:m?.byteLength||0,recordInflateBytes:E}),this._flowManager=this._register(new h(this,l,m,E,this._onData,(A,O)=>this._write(A,O))),this._register(this._flowManager.onError(A=>{console.error(A),(0,_.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})})),this._incomingData=new P.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._flowManager.writeMessage(o)}_write(o,l){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let m=2;o.byteLength<126?m+=0:o.byteLength<2**16?m+=2:m+=8;const E=R.VSBuffer.alloc(m);if(l?E.writeUInt8(194,0):E.writeUInt8(130,0),o.byteLength<126)E.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){E.writeUInt8(126,1);let A=1;E.writeUInt8(o.byteLength>>>8&255,++A),E.writeUInt8(o.byteLength>>>0&255,++A)}else{E.writeUInt8(127,1);let A=1;E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(o.byteLength>>>24&255,++A),E.writeUInt8(o.byteLength>>>16&255,++A),E.writeUInt8(o.byteLength>>>8&255,++A),E.writeUInt8(o.byteLength>>>0&255,++A)}this.socket.write(R.VSBuffer.concat([E,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const l=this._incomingData.peek(this._state.readLen),m=l.readUInt8(0),E=(m&128)>>>7,A=(m&64)>>>6,O=l.readUInt8(1),F=(O&128)>>>7,M=O&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(M===126?2:0)+(M===127?8:0),this._state.fin=E,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(A)),this._state.firstFrameOfMessage=Boolean(E),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const l=this._incomingData.read(this._state.readLen),m=l.readUInt8(1),E=(m&128)>>>7;let A=m&127,O=1;A===126?A=l.readUInt8(++O)*2**8+l.readUInt8(++O):A===127&&(A=l.readUInt8(++O)*0+l.readUInt8(++O)*0+l.readUInt8(++O)*0+l.readUInt8(++O)*0+l.readUInt8(++O)*2**24+l.readUInt8(++O)*2**16+l.readUInt8(++O)*2**8+l.readUInt8(++O));let F=0;E&&(F=l.readUInt8(++O)*2**24+l.readUInt8(++O)*2**16+l.readUInt8(++O)*2**8+l.readUInt8(++O)),this._state.state=3,this._state.readLen=A,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const l=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),v(l,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(l,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await c.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class h extends T.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(o,l,m,E,A,O){super(),this._tracer=o,this._onData=A,this._writeFn=O,this._onError=this._register(new c.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new c.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,l?(this._zlibInflateStream=this._register(new u(this._tracer,E,m,{windowBits:15})),this._zlibDeflateStream=this._register(new f(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const l=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(l,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,l){return new Promise((m,E)=>{o.write(l),o.flush(A=>m(A))})}acceptFrame(o,l,m){this._readQueue.push({data:o,isCompressed:l,isLastFrameOfMessage:m}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const l=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(l)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1}}_inflateFrame(o,l,m){return new Promise((E,A)=>{o.write(l),m&&o.write(R.VSBuffer.fromByteArray([0,0,255,255])),o.flush(O=>E(O))})}}class u extends T.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(o,l,m,E){super(),this._tracer=o,this._recordInflateBytes=l,this._onError=this._register(new c.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=y().zlib.createInflateRaw(E),this._zlibInflate.on("error",A=>{this._tracer.traceSocketEvent("zlibInflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibInflate.on("data",A=>{this._tracer.traceSocketEvent("zlibInflateData",A),this._pendingInflateData.push(R.VSBuffer.wrap(A))}),m&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",m.buffer),this._zlibInflate.write(m.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const l=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(l)})}}class f extends T.Disposable{constructor(o,l){super(),this._tracer=o,this._onError=this._register(new c.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=y().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",m=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:m?.message,code:m?.code}),this._onError.fire(m)}),this._zlibDeflate.on("data",m=>{this._tracer.traceSocketEvent("zlibDeflateData",m),this._pendingDeflateData.push(R.VSBuffer.wrap(m))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let l=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,l=l.slice(0,l.byteLength-4),o(l)})}}function v(a,o){if(o===0)return;const l=a.byteLength>>>2;for(let M=0;M<l;M++){const k=a.readUInt32BE(M*4);a.writeUInt32BE(k^o,M*4)}const m=l*4,E=a.byteLength-m,A=o>>>24&255,O=o>>>16&255,F=o>>>8&255;E>=1&&a.writeUInt8(a.readUInt8(m)^A,m),E>=2&&a.writeUInt8(a.readUInt8(m+1)^O,m+1),E>=3&&a.writeUInt8(a.readUInt8(m+2)^F,m+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const b={[2]:107,[1]:103};function I(){const a=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):o=(0,L.join)(y().os.tmpdir(),`vscode-ipc-${a}.sock`),s(o),o}e.createRandomIPCHandle=I;function i(a,o,l){const m=y().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${l}-${o}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${l}-${o}.sock`):E=(0,L.join)(a,`${l}-${o}.sock`),s(E),E}e.createStaticIPCHandle=i;function s(a){const o=b[D.platform];typeof o=="number"&&a.length>=o&&console.warn(`WARNING: IPC handle "${a}" is longer than ${o} chars, try a shorter --user-data-dir`)}class t extends w.IPCServer{static toClientConnectionEvent(o){const l=c.Event.fromNodeEventEmitter(o,"connection");return c.Event.map(l,m=>({protocol:new P.Protocol(new g(m,"ipc-server-connection")),onDidClientDisconnect:c.Event.once(c.Event.fromNodeEventEmitter(m,"close"))}))}constructor(o){super(t.toClientConnectionEvent(o)),this.server=o}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function n(a){return new Promise((o,l)=>{const m=y().net.createServer();m.on("error",l),m.listen(a,()=>{m.removeListener("error",l),o(new t(m))})})}e.serve=n;function r(a,o){return new Promise((l,m)=>{const E=y().net.createConnection(a,()=>{E.removeListener("error",m),l(P.Client.fromSocket(new g(E,`ipc-client${o}`),o))});E.once("error",m)})}e.connect=r}),define(se[69],oe([0,1,6,3,2,12]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(L=e.StorageHint||(e.StorageHint={}));function D(y){const g=y;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=D;var C;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(C=e.StorageState||(e.StorageState={}));class w extends c.Disposable{constructor(g,S=Object.create(null)){super(),this.database=g,this.options=S,this._onDidChangeStorage=this._register(new _.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((S,d)=>this.accept(d,S)),g.deleted?.forEach(S=>this.accept(S,void 0))}accept(g,S){if(this.state===C.Closed)return;let d=!1;(0,T.isUndefinedOrNull)(S)?d=this.cache.delete(g):this.cache.get(g)!==S&&(this.cache.set(g,S),d=!0),d&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,S){const d=this.cache.get(g);return(0,T.isUndefinedOrNull)(d)?S:d}getBoolean(g,S){const d=this.get(g);return(0,T.isUndefinedOrNull)(d)?S:d==="true"}getNumber(g,S){const d=this.get(g);return(0,T.isUndefinedOrNull)(d)?S:parseInt(d,10)}async set(g,S){if(this.state===C.Closed)return;if((0,T.isUndefinedOrNull)(S))return this.delete(g);const d=String(S);if(this.cache.get(g)!==d)return this.cache.set(g,d),this.pendingInserts.set(g,d),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===C.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}isInMemory(){return this.options.hint===L.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}w.DEFAULT_FLUSH_DELAY=100,e.Storage=w;class P{constructor(){this.onDidChangeItemsExternal=_.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert?.forEach((S,d)=>this.items.set(d,S)),g.delete?.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=P}),define(se[155],oe([10,7]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(se[156],oe([10,7]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[157],oe([10,7]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(se[158],oe([10,7]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(se[159],oe([10,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[160],oe([10,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[161],oe([10,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[162],oe([10,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[163],oe([10,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(se[164],oe([10,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[165],oe([10,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[166],oe([10,7]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[167],oe([10,7]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(se[168],oe([10,7]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(se[169],oe([10,7]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(se[170],oe([10,7]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[171],oe([10,7]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[172],oe([10,7]),function(Z,e){return Z.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(se[173],oe([10,7]),function(Z,e){return Z.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(se[174],oe([10,7]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(se[175],oe([10,7]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(se[176],oe([10,7]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(se[177],oe([10,7]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[178],oe([10,7]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(se[179],oe([10,7]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(se[180],oe([10,7]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[181],oe([10,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(se[182],oe([10,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(se[183],oe([10,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(se[184],oe([10,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(se[185],oe([10,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(se[186],oe([10,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(se[187],oe([10,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(se[188],oe([10,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(se[189],oe([10,7]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(se[95],oe([0,1,65,63,22,13,36,23,11]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,T.dirname)(c.FileAccess.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return C.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(C.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=L.env.VSCODE_PORTABLE;return d?C.URI.file((0,T.join)(d,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,T.resolve)(d):(0,T.normalize)((0,T.join)(c.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?C.URI.file((0,T.resolve)(d)):C.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,T.resolve)(d);const p=L.env.VSCODE_EXTENSIONS;if(p)return p;const h=L.env.VSCODE_PORTABLE;return h?(0,T.join)(h,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(p=>/^[^:/?#]+?:\/\//.test(p)?C.URI.parse(p):C.URI.file((0,T.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?C.URI.parse(d):C.URI.file((0,T.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const p of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);h&&h[1]&&h[2]&&d.push([h[1],h[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,D.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return C.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=L.env.VSCODE_PORTABLE;return d?C.URI.file((0,T.join)(d,"policy.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this._args}constructor(d,p,h){this._args=d,this.paths=p,this.productService=h,this.editSessionId=this.args.editSessionId}}Se([_.memoize],w.prototype,"appRoot",null),Se([_.memoize],w.prototype,"userHome",null),Se([_.memoize],w.prototype,"userDataPath",null),Se([_.memoize],w.prototype,"appSettingsHome",null),Se([_.memoize],w.prototype,"tmpDir",null),Se([_.memoize],w.prototype,"cacheHome",null),Se([_.memoize],w.prototype,"stateResource",null),Se([_.memoize],w.prototype,"userRoamingDataHome",null),Se([_.memoize],w.prototype,"userDataSyncHome",null),Se([_.memoize],w.prototype,"userDataSyncLogResource",null),Se([_.memoize],w.prototype,"editSessionsLogResource",null),Se([_.memoize],w.prototype,"sync",null),Se([_.memoize],w.prototype,"machineSettingsResource",null),Se([_.memoize],w.prototype,"workspaceStorageHome",null),Se([_.memoize],w.prototype,"localHistoryHome",null),Se([_.memoize],w.prototype,"keyboardLayoutResource",null),Se([_.memoize],w.prototype,"argvResource",null),Se([_.memoize],w.prototype,"isExtensionDevelopment",null),Se([_.memoize],w.prototype,"untitledWorkspacesHome",null),Se([_.memoize],w.prototype,"installSourcePath",null),Se([_.memoize],w.prototype,"builtinExtensionsPath",null),Se([_.memoize],w.prototype,"extensionsPath",null),Se([_.memoize],w.prototype,"extensionDevelopmentLocationURI",null),Se([_.memoize],w.prototype,"extensionDevelopmentKind",null),Se([_.memoize],w.prototype,"extensionTestsLocationURI",null),Se([_.memoize],w.prototype,"debugExtensionHost",null),Se([_.memoize],w.prototype,"logLevel",null),Se([_.memoize],w.prototype,"extensionLogLevel",null),Se([_.memoize],w.prototype,"serviceMachineIdResource",null),Se([_.memoize],w.prototype,"telemetryLogResource",null),Se([_.memoize],w.prototype,"disableWorkspaceTrust",null),Se([_.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function P(S,d){return g(S["inspect-extensions"],S["inspect-brk-extensions"],5870,d,S.debugId,S.extensionEnvironment)}e.parseExtensionHostPort=P;function y(S,d){return g(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,d,S.extensionEnvironment)}e.parsePtyHostPort=y;function g(S,d,p,h,u,f){const b=Number(d||S)||(h?null:p),I=b?Boolean(!!d):!1;let i;if(f)try{i=JSON.parse(f)}catch{}return{port:b,break:I,debugId:u,env:i}}}),define(se[190],oe([0,1,292,4,157]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,c.localize)(0,null),e:(0,c.localize)(1,null),t:(0,c.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,c.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,c.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,c.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,c.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,c.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,c.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,c.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,c.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,c.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,c.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,c.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,c.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,c.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,c.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,c.localize)(17,null)},category:{type:"string",cat:"e",description:(0,c.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,c.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,c.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,c.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,c.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,c.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,c.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,c.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,c.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,c.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,c.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,c.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,c.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,c.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,c.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,c.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,c.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,c.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function D(p,h,u=L){const f=p.find(a=>a.length>0&&a[0]!=="-"),v={},b=["_"],I=[],i={};let s;for(const a in h){const o=h[a];o.type==="subcommand"?a===f&&(s=o):(o.alias&&(v[a]=o.alias),o.type==="string"||o.type==="string[]"?(b.push(a),o.deprecates&&b.push(...o.deprecates)):o.type==="boolean"&&(I.push(a),o.deprecates&&I.push(...o.deprecates)),o.global&&(i[a]=o))}if(s&&f){const a=i;for(const E in s.options)a[E]=s.options[E];const o=p.filter(E=>E!==f),l=u.getSubcommandReporter?u.getSubcommandReporter(f):void 0,m=D(o,a,l);return{[f]:m,_:[]}}const t=R(p,{string:b,boolean:I,alias:v}),n={},r=t;n._=t._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(const a in h){const o=h[a];if(o.type==="subcommand")continue;o.alias&&delete r[o.alias];let l=r[a];if(o.deprecates)for(const m of o.deprecates)r.hasOwnProperty(m)&&(l||(l=r[m],l&&u.onDeprecatedOption(m,o.deprecationMessage||(0,c.localize)(36,null,a))),delete r[m]);if(typeof l<"u"){if(o.type==="string[]"){if(Array.isArray(l)||(l=[l]),!o.allowEmptyValue){const m=l.filter(E=>E.length>0);m.length!==l.length&&(u.onEmptyValue(a),l=m.length>0?m:void 0)}}else o.type==="string"&&(Array.isArray(l)?(l=l.pop(),u.onMultipleValues(a,l)):!l&&!o.allowEmptyValue&&(u.onEmptyValue(a),l=void 0));n[a]=l,o.deprecationMessage&&u.onDeprecatedOption(a,o.deprecationMessage)}delete r[a]}for(const a in r)u.onUnknownOption(a);return n}e.parseArgs=D;function C(p,h){let u="";return h.args&&(Array.isArray(h.args)?u=` <${h.args.join("> <")}>`:u=` <${h.args}>`),h.alias?`-${h.alias} --${p}${u}`:`--${p}${u}`}function w(p,h){const u=[];for(const f in p){const v=p[f],b=C(f,v);u.push([b,v.description])}return P(u,h)}e.formatOptions=w;function P(p,h){const f=p.reduce((I,i)=>Math.max(I,i[0].length),12)+2+1;if(h-f<25)return p.reduce((I,i)=>I.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const v=h-f-1,b=[];for(const I of p){const i=I[0],s=g(I[1],v),t=y(f-i.length-2);b.push("  "+i+t+s[0]);for(let n=1;n<s.length;n++)b.push(y(f)+s[n])}return b}function y(p){return" ".repeat(p)}function g(p,h){const u=[];for(;p.length;){const f=p.length<h?p.length:p.lastIndexOf(" ",h),v=p.slice(0,f).trim();p=p.slice(f),u.push(v)}return u}function S(p,h,u,f,v){const b=process.stdout.isTTY&&process.stdout.columns||80,I=v?.noInputFiles!==!0?`[${(0,c.localize)(37,null)}...]`:"",i=[`${p} ${u}`];i.push(""),i.push(`${(0,c.localize)(38,null)}: ${h} [${(0,c.localize)(39,null)}]${I}`),i.push(""),v?.noPipe!==!0&&(_.isWindows?i.push((0,c.localize)(40,null,h)):i.push((0,c.localize)(41,null,h)),i.push(""));const s={},t=[];for(const n in f){const r=f[n];if(r.type==="subcommand")r.description&&t.push({command:n,description:r.description});else if(r.description&&r.cat){let a=s[r.cat];a||(s[r.cat]=a={}),a[n]=r}}for(const n in s){const r=n,a=s[r];a&&(i.push(T[r]),i.push(...w(a,b)),i.push(""))}return t.length&&(i.push((0,c.localize)(42,null)),i.push(...P(t.map(n=>[n.command,n.description]),b)),i.push("")),i.join(`
`)}e.buildHelpMessage=S;function d(p,h){return`${p||(0,c.localize)(43,null)}
${h||(0,c.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(se[191],oe([0,1,293,158,190]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function L(g,S){const d=(b,I)=>{console.warn((0,_.localize)(0,null,b,I))},p=b=>{console.warn((0,_.localize)(1,null,b))},h=(b,I)=>{console.warn((0,_.localize)(2,null,b,I))},u=b=>({onUnknownOption:I=>{b!=="tunnel"&&console.warn((0,_.localize)(3,null,I,b))},onMultipleValues:d,onEmptyValue:p,onDeprecatedOption:h,getSubcommandReporter:b!=="tunnel"?u:void 0}),f={onUnknownOption:b=>{console.warn((0,_.localize)(4,null,b))},onMultipleValues:d,onEmptyValue:p,onDeprecatedOption:h,getSubcommandReporter:u},v=(0,c.parseArgs)(g,c.OPTIONS,S?f:void 0);return v.goto&&v._.forEach(b=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,_.localize)(5,null))),v["max-memory"]&&R(parseInt(v["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),v}function D(g){const S=g.findIndex(d=>!/^-/.test(d));if(S>-1)return[...g.slice(0,S),...g.slice(S+1)]}function C(g){let[,...S]=g;process.env.VSCODE_DEV&&(S=D(S)||[]);const d=!y(process.env);return L(S,d)}e.parseMainProcessArgv=C;function w(g){let[,,...S]=g;return process.env.VSCODE_DEV&&(S=D(S)||[]),L(S,!0)}e.parseCLIProcessArgv=w;function P(g,...S){const d=g.indexOf("--");return d===-1?g.push(...S):g.splice(d,0,...S),g}e.addArg=P;function y(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function Z(e,R,_){function c(L,D){const C=T(L,D),w=[C];return e.isAbsolute(C)||w.unshift(_),e.resolve(...w)}function T(L,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,D);const P=L["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(y,"AppData","Roaming")}break;case"darwin":w=e.join(R.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,D)}return{getUserDataPath:c}}if(typeof define=="function")define(se[96],oe([294,34,36]),function(e,R,_){return Z(e,R,_.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=Z(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[192],oe([0,1,34,95,96]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends _.AbstractNativeEnvironmentService{constructor(D,C){super(D,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,c.getUserDataPath)(D,C.nameShort)},C)}}e.NativeEnvironmentService=T}),define(se[193],oe([0,1,11]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const _=/^([^@:]+@)?([^:]+):/,c=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,D=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(h){const u=h.match(L);return u?u[1]:null}function P(h){if(h.indexOf("://")===-1){const u=h.match(_);return u?w(u[2]):null}try{const u=R.URI.parse(h);if(u.authority)return w(u.authority)}catch{}return null}function y(h,u){const f=new Set;let v;for(;v=D.exec(h);){const I=P(v[1]);I&&f.add(I)}const b=new Set(u);return Array.from(f).map(I=>b.has(I)?I:I.replace(C,"a"))}e.getDomainsOfRemotes=y;function g(h){const u=h.match(T);return u?u[2]:null}function S(h,u,f){return h&&u?(f&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${h}${u}`:`${h}/${u}`):null}function d(h,u){if(h.indexOf("://")===-1){const f=h.match(c);if(f)return S(f[2],f[3],u)}try{const f=R.URI.parse(h);if(f.authority)return S(g(f.authority),f.path,u)}catch{}return null}function p(h,u=!1){const f=[];let v;for(;v=D.exec(h);){const b=d(v[1],u);b&&f.push(b)}return f}e.getRemotes=p}),define(se[194],oe([0,1,12,161]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function c(L,D,C){try{T(L,D,C)}catch(w){console.error(w?.message??w)}return L}e.localizeManifest=c;function T(L,D,C){const w=(P,y,g)=>{const S=P[y];if((0,R.isString)(S)){const d=S,p=d.length;if(p>1&&d[0]==="%"&&d[p-1]==="%"){const h=d.substr(1,p-2);let u=D[h];u===void 0&&C&&(u=C[h]);const f=typeof u=="string"?u:u?.message,v=C?.[h],b=typeof v=="string"?v:v?.message;if(!f){b||console.warn(`[${L.name}]: ${(0,_.localize)(0,null,h)}`);return}if(g&&(y==="title"||y==="category")&&b&&b!==f){const I={value:f,original:b};P[y]=I}else P[y]=f}}else if((0,R.isObject)(S))for(const d in S)S.hasOwnProperty(d)&&(d==="commands"?w(S,d,!0):w(S,d,g));else if(Array.isArray(S))for(let d=0;d<S.length;d++)w(S,d,g)};for(const P in L)L.hasOwnProperty(P)&&w(L,P)}}),define(se[195],oe([0,1,9]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class _{constructor(){this._generators=new Map}register(T,L){this._generators.set(T,L)}updateManifest(T){if(!(typeof T.main>"u"&&typeof T.browser>"u")&&(T.activationEvents===void 0&&Object.assign(T,{activationEvents:[]}),!(!Array.isArray(T.activationEvents)||!T.contributes)))for(const L in T.contributes){const D=this._generators.get(L);if(!D)continue;const C=T.contributes[L],w=Array.isArray(C)?C:[C];try{D(w,T.activationEvents)}catch(P){(0,R.onUnexpectedError)(P)}}}}e.ImplicitActivationEventsImpl=_,e.ImplicitActivationEvents=new _}),define(se[196],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,L,D,C){return this.channel.call("promptImportantExtensionsInstallNotification",[T,L,D,C])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class _{constructor(T){this.service=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,D){switch(L){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(D[0],D[1],D[2],D[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=_}),define(se[70],oe([0,1,23,89,166,54]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=C;function w(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=u.match(L);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=w;function P(u){if(!u)return null;const f=u.majorBase,v=u.majorMustEqual,b=u.minorBase;let I=u.minorMustEqual;const i=u.patchBase;let s=u.patchMustEqual;u.hasCaret&&(f===0||(I=!1),s=!1);let t=0;if(u.preRelease){const n=D.exec(u.preRelease);if(n){const[,r,a,o]=n;t=Date.UTC(Number(r),Number(a)-1,Number(o))}}return{majorBase:f,majorMustEqual:v,minorBase:b,minorMustEqual:I,patchBase:i,patchMustEqual:s,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=P;function y(u,f,v){let b;typeof u=="string"?b=P(w(u)):b=u;let I;f instanceof Date?I=f.getTime():typeof f=="string"&&(I=new Date(f).getTime());let i;if(typeof v=="string"?i=P(w(v)):i=v,!b||!i)return!1;const s=b.majorBase,t=b.minorBase,n=b.patchBase;let r=i.majorBase,a=i.minorBase,o=i.patchBase;const l=i.notBefore;let m=i.majorMustEqual,E=i.minorMustEqual,A=i.patchMustEqual;return i.isMinimum?s>r?!0:s<r?!1:t>a?!0:t<a||I&&I<l?!1:n>=o:(s===1&&r===0&&(!m||!E||!A)&&(r=1,a=0,o=0,m=!0,E=!1,A=!1),s<r?!1:s>r?!m:t<a?!1:t>a?!E:n<o?!1:n>o?!A:!(I&&I<l))}e.isValidVersion=y;function g(u,f,v,b,I){const i=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return i.push([_.default.Error,c.localize(0,null)]),i;if(typeof b.name!="string")return i.push([_.default.Error,c.localize(1,null,"name")]),i;if(typeof b.version!="string")return i.push([_.default.Error,c.localize(2,null,"version")]),i;if(!b.engines)return i.push([_.default.Error,c.localize(3,null,"engines")]),i;if(typeof b.engines.vscode!="string")return i.push([_.default.Error,c.localize(4,null,"engines.vscode")]),i;if(typeof b.extensionDependencies<"u"&&!h(b.extensionDependencies))return i.push([_.default.Error,c.localize(5,null,"extensionDependencies")]),i;if(typeof b.activationEvents<"u"){if(!h(b.activationEvents))return i.push([_.default.Error,c.localize(6,null,"activationEvents")]),i;if(typeof b.main>"u"&&typeof b.browser>"u")return i.push([_.default.Error,c.localize(7,null,"activationEvents","main")]),i}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&i.push([_.default.Warning,c.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return i.push([_.default.Error,c.localize(9,null,"main")]),i;{const n=(0,R.joinPath)(v,b.main);(0,R.isEqualOrParent)(n,v)||i.push([_.default.Warning,c.localize(10,null,n.path,v.path)])}if(typeof b.activationEvents>"u")return i.push([_.default.Error,c.localize(11,null,"activationEvents","main")]),i}if(typeof b.browser<"u"){if(typeof b.browser!="string")return i.push([_.default.Error,c.localize(12,null,"browser")]),i;{const n=(0,R.joinPath)(v,b.browser);(0,R.isEqualOrParent)(n,v)||i.push([_.default.Warning,c.localize(13,null,n.path,v.path)])}if(typeof b.activationEvents>"u")return i.push([_.default.Error,c.localize(14,null,"activationEvents","browser")]),i}if(!T.valid(b.version))return i.push([_.default.Error,c.localize(15,null)]),i;const s=[];if(!S(u,f,b,I,s))for(const n of s)i.push([_.default.Error,n]);return i}e.validateExtensionManifest=g;function S(u,f,v,b,I){return b||typeof v.main>"u"&&typeof v.browser>"u"?!0:p(u,f,v.engines.vscode,I)}e.isValidExtensionVersion=S;function d(u,f,v){return u==="*"||p(f,v,u)}e.isEngineValid=d;function p(u,f,v,b=[]){const I=P(w(v));if(!I)return b.push(c.localize(16,null,v)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return b.push(c.localize(17,null,v)),!1}else if(!I.majorMustEqual)return b.push(c.localize(18,null,v)),!1;return y(u,f,I)?!0:(b.push(c.localize(19,null,u,v)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let f=0,v=u.length;f<v;f++)if(typeof u[f]!="string")return!1;return!0}}),define(se[45],oe([0,1,17,31]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function c(T,L,D){let C=D&&D.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const P=(await L.readFile(T.serviceMachineIdResource)).value.toString();C=(0,_.isUUID)(P)?P:null}catch{C=null}if(!C){C=(0,_.generateUuid)();try{await L.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(C))}catch{}}return D?.store("storage.serviceMachineId",C,-1,1),C}e.getServiceMachineId=c}),define(se[55],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(c,T=[],L=!1){this.ctor=c,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=R}),define(se[71],oe([0,1,55]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const _=[];var c;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(c=e.InstantiationType||(e.InstantiationType={}));function T(D,C,w){C instanceof R.SyncDescriptor||(C=new R.SyncDescriptor(C,[],Boolean(w))),_.push([D,C])}e.registerSingleton=T;function L(){return _}e.getSingletonServiceDescriptors=L}),define(se[197],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T,L){this.key=T,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=R;class _{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const L of this._nodes.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const D=this.lookupOrInsertNode(T),C=this.lookupOrInsertNode(L);D.outgoing.set(C.key,C),C.incoming.set(D.key,D)}removeNode(T){const L=this._hashFn(T);this._nodes.delete(L);for(const D of this._nodes.values())D.outgoing.delete(L),D.incoming.delete(L)}lookupOrInsertNode(T){const L=this._hashFn(T);let D=this._nodes.get(L);return D||(D=new R(L,T),this._nodes.set(L,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[L,D]of this._nodes)T.push(`${L}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,L]of this._nodes){const D=new Set([T]),C=this._findCycle(L,D);if(C)return C}}_findCycle(T,L){for(const[D,C]of T.outgoing){if(L.has(D))return[...L,D].join(" -> ");L.add(D);const w=this._findCycle(C,L);if(w)return w;L.delete(D)}}}e.Graph=_}),define(se[5],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function D(C){return C[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=D})(R=e._util||(e._util={})),e.IInstantiationService=c("instantiationService");function _(L,D,C){D[R.DI_TARGET]===D?D[R.DI_DEPENDENCIES].push({id:L,index:C}):(D[R.DI_DEPENDENCIES]=[{id:L,index:C}],D[R.DI_TARGET]=D)}function c(L){if(R.serviceIds.has(L))return R.serviceIds.get(L);const D=function(C,w,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");_(D,C,P)};return D.toString=()=>L,R.serviceIds.set(L,D),D}e.createDecorator=c;function T(L){return L}e.refineServiceDecorator=T}),define(se[198],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(se[16],oe([0,1,12,11,5]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,c.createDecorator)("configurationService");function T(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof _.URI)}e.isConfigurationOverrides=T;function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof _.URI)}e.isConfigurationUpdateOverrides=L;var D;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=C;function w(h,u){const f=Object.create(null);for(const v in h)P(f,v,h[v],u);return f}e.toValuesTree=w;function P(h,u,f,v){const b=u.split("."),I=b.pop();let i=h;for(let s=0;s<b.length;s++){const t=b[s];let n=i[t];switch(typeof n){case"undefined":n=i[t]=Object.create(null);break;case"object":break;default:v(`Ignoring ${u} as ${b.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[I]=f}catch{v(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(i)}`)}else v(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=P;function y(h,u){const f=u.split(".");g(h,f)}e.removeFromValueTree=y;function g(h,u){const f=u.shift();if(u.length===0){delete h[f];return}if(Object.keys(h).indexOf(f)!==-1){const v=h[f];typeof v=="object"&&!Array.isArray(v)&&(g(v,u),Object.keys(v).length===0&&delete h[f])}}function S(h,u,f){function v(i,s){let t=i;for(const n of s){if(typeof t!="object"||t===null)return;t=t[n]}return t}const b=u.split("."),I=v(h,b);return typeof I>"u"?f:I}e.getConfigurationValue=S;function d(h,u,f){Object.keys(u).forEach(v=>{v!=="__proto__"&&(v in h?R.isObject(h[v])&&R.isObject(u[v])?d(h[v],u[v],f):f&&(h[v]=u[v]):h[v]=u[v])})}e.merge=d;function p(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(se[199],oe([0,1,4,27,5]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",R.isMacintosh),T.set("isLinux",R.isLinux),T.set("isWindows",R.isWindows),T.set("isWeb",R.isWeb),T.set("isMacNative",R.isMacintosh&&!R.isWeb),T.set("isEdge",R.isEdge),T.set("isFirefox",R.isFirefox),T.set("isChrome",R.isChrome),T.set("isSafari",R.isSafari);const L=Object.prototype.hasOwnProperty;var D;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return y.INSTANCE}static true(){return g.INSTANCE}static has(k){return S.create(k)}static equals(k,N){return d.create(k,N)}static notEquals(k,N){return u.create(k,N)}static regex(k,N){return t.create(k,N)}static in(k,N){return p.create(k,N)}static notIn(k,N){return h.create(k,N)}static not(k){return f.create(k)}static and(...k){return a.create(k,null,!0)}static or(...k){return o.create(k,null,!0)}static greater(k,N){return b.create(k,N)}static greaterEquals(k,N){return I.create(k,N)}static smaller(k,N){return i.create(k,N)}static smallerEquals(k,N){return s.create(k,N)}static deserialize(k,N=!1){if(!!k)return this._deserializeOrExpression(k,N)}static _deserializeOrExpression(k,N){const z=k.split("||");return o.create(z.map(j=>this._deserializeAndExpression(j,N)),null,!0)}static _deserializeAndExpression(k,N){const z=k.split("&&");return a.create(z.map(j=>this._deserializeOne(j,N)),null,!0)}static _deserializeOne(k,N){if(k=k.trim(),k.indexOf("!=")>=0){const z=k.split("!=");return u.create(z[0].trim(),this._deserializeValue(z[1],N))}if(k.indexOf("==")>=0){const z=k.split("==");return d.create(z[0].trim(),this._deserializeValue(z[1],N))}if(k.indexOf("=~")>=0){const z=k.split("=~");return t.create(z[0].trim(),this._deserializeRegexValue(z[1],N))}if(k.indexOf(" not in ")>=0){const z=k.split(" not in ");return h.create(z[0].trim(),this._deserializeValue(z[1],N))}if(k.indexOf(" in ")>=0){const z=k.split(" in ");return p.create(z[0].trim(),this._deserializeValue(z[1],N))}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const z=k.split(">=");return I.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const z=k.split(">");return b.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const z=k.split("<=");return s.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const z=k.split("<");return i.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(k)?f.create(k.substr(1).trim()):S.create(k)}static _deserializeValue(k,N){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const z=/^'([^']*)'$/.exec(k);return z?z[1].trim():k}static _deserializeRegexValue(k,N){if((0,_.isFalsyOrWhitespace)(k)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=k.indexOf("/"),j=k.lastIndexOf("/");if(z===j||z<0){if(N)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const J=k.slice(z+1,j),ne=k[j+1]==="i"?"i":"";try{return new RegExp(J,ne)}catch(G){if(N)throw new Error(`bad regexp-value '${k}', parse error: ${G}`);return console.warn(`bad regexp-value '${k}', parse error: ${G}`),null}}}e.ContextKeyExpr=C;function w(M,k){const N=M?M.substituteConstants():void 0,z=k?k.substituteConstants():void 0;return!N&&!z?!0:!N||!z?!1:N.equals(z)}e.expressionsAreEqualWithConstantSubstitution=w;function P(M,k){return M.cmp(k)}class y{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return g.INSTANCE}}y.INSTANCE=new y,e.ContextKeyFalseExpr=y;class g{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return y.INSTANCE}}g.INSTANCE=new g,e.ContextKeyTrueExpr=g;class S{static create(k,N=null){const z=T.get(k);return typeof z=="boolean"?z?g.INSTANCE:y.INSTANCE:new S(k,N)}constructor(k,N){this.key=k,this.negated=N,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:m(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?g.INSTANCE:y.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class d{static create(k,N,z=null){if(typeof N=="boolean")return N?S.create(k,z):f.create(k,z);const j=T.get(k);return typeof j=="boolean"?N===(j?"true":"false")?g.INSTANCE:y.INSTANCE:new d(k,N,z)}constructor(k,N,z){this.key=k,this.value=N,this.negated=z,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const N=k?"true":"false";return this.value===N?g.INSTANCE:y.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class p{static create(k,N){return new p(k,N)}constructor(k,N){this.key=k,this.valueKey=N,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const N=k.getValue(this.valueKey),z=k.getValue(this.key);return Array.isArray(N)?N.includes(z):typeof z=="string"&&typeof N=="object"&&N!==null?L.call(N,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class h{static create(k,N){return new h(k,N)}constructor(k,N){this.key=k,this.valueKey=N,this.type=11,this._negated=p.create(k,N)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=h;class u{static create(k,N,z=null){if(typeof N=="boolean")return N?f.create(k,z):S.create(k,z);const j=T.get(k);return typeof j=="boolean"?N===(j?"true":"false")?y.INSTANCE:g.INSTANCE:new u(k,N,z)}constructor(k,N,z){this.key=k,this.value=N,this.negated=z,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const N=k?"true":"false";return this.value===N?y.INSTANCE:g.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class f{static create(k,N=null){const z=T.get(k);return typeof z=="boolean"?z?y.INSTANCE:g.INSTANCE:new f(k,N)}constructor(k,N){this.key=k,this.negated=N,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:m(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?y.INSTANCE:g.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function v(M,k){if(typeof M=="string"){const N=parseFloat(M);isNaN(N)||(M=N)}return typeof M=="string"||typeof M=="number"?k(M):y.INSTANCE}class b{static create(k,N,z=null){return v(N,j=>new b(k,j,z))}constructor(k,N,z){this.key=k,this.value=N,this.negated=z,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=b;class I{static create(k,N,z=null){return v(N,j=>new I(k,j,z))}constructor(k,N,z){this.key=k,this.value=N,this.negated=z,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=I;class i{static create(k,N,z=null){return v(N,j=>new i(k,j,z))}constructor(k,N,z){this.key=k,this.value=N,this.negated=z,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class s{static create(k,N,z=null){return v(N,j=>new s(k,j,z))}constructor(k,N,z){this.key=k,this.value=N,this.negated=z,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class t{static create(k,N){return new t(k,N)}constructor(k,N){this.key=k,this.regexp=N,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const N=this.regexp?this.regexp.source:"",z=k.regexp?k.regexp.source:"";return N<z?-1:N>z?1:0}equals(k){if(k.type===this.type){const N=this.regexp?this.regexp.source:"",z=k.regexp?k.regexp.source:"";return this.key===k.key&&N===z}return!1}substituteConstants(){return this}evaluate(k){const N=k.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class n{static create(k){return new n(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new n(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function r(M){let k=null;for(let N=0,z=M.length;N<z;N++){const j=M[N].substituteConstants();if(M[N]!==j&&k===null){k=[];for(let J=0;J<N;J++)k[J]=M[J]}k!==null&&(k[N]=j)}return k===null?M:k}class a{static create(k,N,z){return a._normalizeArr(k,N,z)}constructor(k,N){this.expr=k,this.negated=N,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const j=P(this.expr[N],k.expr[N]);if(j!==0)return j}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(k.expr[N]))return!1;return!0}return!1}substituteConstants(){const k=r(this.expr);return k===this.expr?this:a.create(k,this.negated,!1)}evaluate(k){for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].evaluate(k))return!1;return!0}static _normalizeArr(k,N,z){const j=[];let J=!1;for(const ne of k)if(!!ne){if(ne.type===1){J=!0;continue}if(ne.type===0)return y.INSTANCE;if(ne.type===6){j.push(...ne.expr);continue}j.push(ne)}if(j.length===0&&J)return g.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(P);for(let ne=1;ne<j.length;ne++)j[ne-1].equals(j[ne])&&(j.splice(ne,1),ne--);if(j.length===1)return j[0];for(;j.length>1;){const ne=j[j.length-1];if(ne.type!==9)break;j.pop();const G=j.pop(),q=j.length===0,x=o.create(ne.expr.map(Y=>a.create([Y,G],null,z)),null,q);x&&(j.push(x),j.sort(P))}if(j.length===1)return j[0];if(z){for(let ne=0;ne<j.length;ne++)for(let G=ne+1;G<j.length;G++)if(j[ne].negate().equals(j[G]))return y.INSTANCE;if(j.length===1)return j[0]}return new a(j,N)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const N of this.expr)k.push(...N.keys());return k}map(k){return new a(this.expr.map(N=>N.map(k)),null)}negate(){if(!this.negated){const k=[];for(const N of this.expr)k.push(N.negate());this.negated=o.create(k,this,!0)}return this.negated}}class o{static create(k,N,z){return o._normalizeArr(k,N,z)}constructor(k,N){this.expr=k,this.negated=N,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const j=P(this.expr[N],k.expr[N]);if(j!==0)return j}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(k.expr[N]))return!1;return!0}return!1}substituteConstants(){const k=r(this.expr);return k===this.expr?this:o.create(k,this.negated,!1)}evaluate(k){for(let N=0,z=this.expr.length;N<z;N++)if(this.expr[N].evaluate(k))return!0;return!1}static _normalizeArr(k,N,z){let j=[],J=!1;if(k){for(let ne=0,G=k.length;ne<G;ne++){const q=k[ne];if(!!q){if(q.type===0){J=!0;continue}if(q.type===1)return g.INSTANCE;if(q.type===9){j=j.concat(q.expr);continue}j.push(q)}}if(j.length===0&&J)return y.INSTANCE;j.sort(P)}if(j.length!==0){if(j.length===1)return j[0];for(let ne=1;ne<j.length;ne++)j[ne-1].equals(j[ne])&&(j.splice(ne,1),ne--);if(j.length===1)return j[0];if(z){for(let ne=0;ne<j.length;ne++)for(let G=ne+1;G<j.length;G++)if(j[ne].negate().equals(j[G]))return g.INSTANCE;if(j.length===1)return j[0]}return new o(j,N)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const N of this.expr)k.push(...N.keys());return k}map(k){return new o(this.expr.map(N=>N.map(k)),null)}negate(){if(!this.negated){const k=[];for(const N of this.expr)k.push(N.negate());for(;k.length>1;){const N=k.shift(),z=k.shift(),j=[];for(const J of F(N))for(const ne of F(z))j.push(a.create([J,ne],null,!1));k.unshift(o.create(j,null,!1))}this.negated=o.create(k,this,!0)}return this.negated}}class l extends S{static all(){return l._info.values()}constructor(k,N,z){super(k,null),this._defaultValue=N,typeof z=="object"?l._info.push({...z,key:k}):z!==!0&&l._info.push({key:k,description:z,type:N!=null?typeof N:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return d.create(this.key,k)}notEqualsTo(k){return u.create(this.key,k)}}l._info=[],e.RawContextKey=l,e.IContextKeyService=(0,c.createDecorator)("contextKeyService");function m(M,k){return M<k?-1:M>k?1:0}function E(M,k,N,z){return M<N?-1:M>N?1:k<z?-1:k>z?1:0}function A(M,k){if(M.type===0||k.type===1)return!0;if(M.type===9)return k.type===9?O(M.expr,k.expr):!1;if(k.type===9){for(const N of k.expr)if(A(M,N))return!0;return!1}if(M.type===6){if(k.type===6)return O(k.expr,M.expr);for(const N of M.expr)if(A(N,k))return!0;return!1}return M.equals(k)}e.implies=A;function O(M,k){let N=0,z=0;for(;N<M.length&&z<k.length;){const j=M[N].cmp(k[z]);if(j<0)return!1;j===0&&N++,z++}return N===M.length}function F(M){return M.type===9?M.expr:[M]}}),define(se[97],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function _(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=_;class c{async getPerformanceInfo(L,D){return{}}async getSystemInfo(L,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,D){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=c}),define(se[98],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(se[15],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(se[30],oe([0,1,160,5]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function c(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=c;function T(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function L(u,f){switch(u){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function D(u,f){return f==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function C(u,f,v){return D(f,v)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===v?!0:w(v).includes(u)}e.isTargetPlatformCompatible=C;function w(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var y;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var g;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var S;(function(u){u.Install="install",u.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,_.createDecorator)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(f,v){super(f),this.code=v,this.name=v}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,_.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,_.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,_.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(se[200],oe([0,1,3,2,67,32,11,147,30]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(h,u){return L.URI.revive(u?u.transformIncoming(h):h)}function P(h,u){return u?u.transformOutgoingURI(h):h}function y(h,u){u=u||D.DefaultURITransformer;const f=h.manifest;return{...(0,D.transformAndReviveIncomingURIs)({...h,manifest:void 0},u),manifest:f}}function g(h,u){return u?(0,T.cloneAndChange)(h,f=>f instanceof L.URI?u.transformOutgoingURI(f):void 0):h}class S{constructor(u,f){this.service=u,this.getUriTransformer=f,this.onInstallExtension=R.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,f){const v=this.getUriTransformer(u);switch(f){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,b=>b.map(I=>({...I,local:I.local?g(I.local,v):I.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension;case"onDidUpdateExtensionMetadata":return this.onDidUpdateExtensionMetadata}throw new Error("Invalid listen")}call(u,f,v){const b=this.getUriTransformer(u);switch(f){case"zip":return this.service.zip(y(v[0],b)).then(I=>P(I,b));case"unzip":return this.service.unzip(w(v[0],b));case"install":return this.service.install(w(v[0],b),(0,c.revive)(v[1]));case"installFromLocation":return this.service.installFromLocation(w(v[0],b),L.URI.revive(v[1]));case"getManifest":return this.service.getManifest(w(v[0],b));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],(0,c.revive)(v[1]));case"uninstall":return this.service.uninstall(y(v[0],b),(0,c.revive)(v[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(y(v[0],b));case"getInstalled":return this.service.getInstalled(v[0],L.URI.revive(v[1])).then(I=>I.map(i=>g(i,b)));case"getMetadata":return this.service.getMetadata(y(v[0],b),L.URI.revive(v[1]));case"updateMetadata":return this.service.updateMetadata(y(v[0],b),v[1],L.URI.revive(v[2])).then(I=>g(I,b));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(v[0],v[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=S;class d extends _.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._onDidUpdateExtensionMetadata=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(f=>this._onInstallExtension.fire({identifier:f.identifier,source:this.isUriComponents(f.source)?L.URI.revive(f.source):f.source,profileLocation:L.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(f=>this._onDidInstallExtensions.fire(f.map(v=>({...v,local:v.local?y(v.local,null):v.local,source:this.isUriComponents(v.source)?L.URI.revive(v.source):v.source,profileLocation:L.URI.revive(v.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(f=>this._onUninstallExtension.fire({identifier:f.identifier,profileLocation:L.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(f=>this._onDidUninstallExtension.fire({...f,profileLocation:L.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(f=>this._onDidUpdateExtensionMetadata.fire(y(f,null))))}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const f=await this.getTargetPlatform();return u.allTargetPlatforms.some(v=>(0,C.isTargetPlatformCompatible)(v,u.allTargetPlatforms,f))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(f=>L.URI.revive(f)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,f){return Promise.resolve(this.channel.call("install",[u,f])).then(v=>y(v,null))}installFromLocation(u,f){return Promise.resolve(this.channel.call("installFromLocation",[u,f])).then(v=>y(v,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,f){return Promise.resolve(this.channel.call("installFromGallery",[u,f])).then(v=>y(v,null))}uninstall(u,f){return Promise.resolve(this.channel.call("uninstall",[u,f]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u])).then(f=>y(f,null))}getInstalled(u=null,f){return Promise.resolve(this.channel.call("getInstalled",[u,f])).then(v=>v.map(b=>y(b,null)))}getMetadata(u,f){return Promise.resolve(this.channel.call("getMetadata",[u,f]))}updateMetadata(u,f,v){return Promise.resolve(this.channel.call("updateMetadata",[u,f,v])).then(b=>y(b,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,f){const v=await this.channel.call("download",[u,f]);return L.URI.revive(v)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class p{constructor(u){this.service=u}listen(u,f){throw new Error("Invalid listen")}call(u,f,v){switch(f){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(se[99],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,R.createDecorator)("IExtensionSignatureVerificationService");class _{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((T,L)=>Z(["node-vsce-sign"],async D=>T(D),L))),this.moduleLoadingPromise}async verify(T,L){let D;try{D=await this.vsceSign()}catch{return!1}return D.verify(T,L)}}e.ExtensionSignatureVerificationService=_}),define(se[100],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var _;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(_=e.RecommendationSource||(e.RecommendationSource={}));function c(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=c;var T;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(se[14],oe([0,1,49,13,27,12,11,168,5,4,22]),function(Z,e,R,_,c,T,L,D,C,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function y(x){return x.create===!0}e.isFileOpenForWriteOptions=y;var g;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(g=e.FileType||(e.FileType={}));var S;(function(x){x[x.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var d;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileClone=32768]="FileClone"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=p;function h(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=h;function u(x){return!!(x.capabilities&32768)}e.hasFileCloneCapability=u;function f(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function v(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=v;function b(x){return p(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var I;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{constructor(Y,ee){super(Y),this.code=ee}}e.FileSystemProviderError=i;function s(x,Y){const ee=new i(x.toString(),Y);return n(ee,Y),ee}e.createFileSystemProviderError=s;function t(x){return x||s((0,D.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=t;function n(x,Y){return x.name=Y?`${Y} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=n;function r(x){if(!x)return I.Unknown;if(x instanceof i)return x.code;const Y=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!Y)return I.Unknown;switch(Y[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=r;function a(x){if(x instanceof O)return x.fileOperationResult;switch(r(x)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var o;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class l{constructor(Y,ee,re){this.resource=Y,this.operation=ee,this.target=re}isOperation(Y){return this.operation===Y}}e.FileOperationEvent=l;var m;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class E{constructor(Y,ee){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const ae of Y){const V=re.get(ae.type);switch(V?V.push([ae.resource,ae]):re.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,V]of re)switch(ae){case 1:this.added=R.TernarySearchTree.forUris(()=>ee),this.added.fill(V);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>ee),this.updated.fill(V);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>ee),this.deleted.fill(V);break}}contains(Y,...ee){return this.doContains(Y,{includeChildren:!1},...ee)}affects(Y,...ee){return this.doContains(Y,{includeChildren:!0},...ee)}doContains(Y,ee,...re){if(!Y)return!1;const ae=re.length>0;return!!((!ae||re.includes(1))&&(this.added?.get(Y)||ee.includeChildren&&this.added?.findSuperstr(Y))||(!ae||re.includes(0))&&(this.updated?.get(Y)||ee.includeChildren&&this.updated?.findSuperstr(Y))||(!ae||re.includes(2))&&(this.deleted?.findSubstr(Y)||ee.includeChildren&&this.deleted?.findSuperstr(Y)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=E;function A(x,Y,ee){return!x||!Y||x===Y||Y.length>x.length?!1:(Y.charAt(Y.length-1)!==_.sep&&(Y+=_.sep),ee?(0,c.startsWithIgnoreCase)(x,Y):x.indexOf(Y)===0)}e.isParent=A;class O extends Error{constructor(Y,ee,re){super(Y),this.fileOperationResult=ee,this.options=re}}e.FileOperationError=O;class F extends O{constructor(Y,ee,re,ae){super(Y,ee,ae),this.fileOperationResult=ee,this.size=re}}e.TooLargeFileOperationError=F;class M extends O{constructor(Y,ee,re){super(Y,2,re),this.stat=ee}}e.NotModifiedSinceFileOperationError=M;var k;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function z(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=z;async function j(x,Y){if(!Y.hasProvider(L.URI.from({scheme:x.scheme})))return new Promise(ee=>{const re=Y.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===x.scheme&&ae.added&&(re.dispose(),ee())})})}e.whenProviderRegistered=j,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(Y){return(0,T.isNumber)(Y)||(Y=0),Y<J.KB?(0,D.localize)(1,null,Y.toFixed(0)):Y<J.MB?(0,D.localize)(2,null,(Y/J.KB).toFixed(2)):Y<J.GB?(0,D.localize)(3,null,(Y/J.MB).toFixed(2)):Y<J.TB?(0,D.localize)(4,null,(Y/J.GB).toFixed(2)):(0,D.localize)(5,null,(Y/J.TB).toFixed(2))}}J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB,e.ByteSize=J;var ne;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function G(x){return{maxFileSize:x===0?300*J.MB:16*J.GB,maxHeapSize:x===0?700*J.MB:2*700*J.MB}}e.getPlatformFileLimits=G;function q(x){const Y=typeof x=="string"||x?.scheme===P.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===P.Schemas.file?1024*J.MB:Y?10*J.MB:w.isWeb?50*J.MB:1024*J.MB}e.getLargeFileConfirmationLimit=q});var K=this&&this.__param||function(Z,e){return function(R,_){e(R,_,Z)}};define(se[201],oe([0,1,101,44,14]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(D){this.fileService=D}async checksum(D){const C=(await this.fileService.readFileStream(D)).value;return new Promise((w,P)=>{const y=(0,R.createHash)("md5");(0,_.listenStream)(C,{onData:g=>y.update(g.buffer),onError:g=>P(g),onEnd:()=>w(y.digest("base64").replace(/=+$/,""))})})}};T=Se([K(0,c.IFileService)],T),e.ChecksumService=T}),define(se[202],oe([0,1,17,38,9,3,2,44,11,31,14]),function(Z,e,R,_,c,T,L,D,C,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends L.Disposable{constructor(S,d){super(),this.channel=S,this.extraCapabilities=d,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,d){const{buffer:p}=await this.channel.call("readFile",[S,d]);return p}readFileStream(S,d,p){const h=(0,D.newWriteableStream)(f=>R.VSBuffer.concat(f.map(v=>R.VSBuffer.wrap(v))).buffer),u=this.channel.listen("readFileStream",[S,d])(f=>{if(f instanceof R.VSBuffer)h.write(f.buffer);else{if(f==="end")h.end();else{let v;if(f instanceof Error)v=f;else{const b=f;v=(0,P.createFileSystemProviderError)(b.message??(0,_.toErrorMessage)(b),b.code??P.FileSystemProviderErrorCode.Unknown)}h.error(v),h.end()}u.dispose()}});return p.onCancellationRequested(()=>{h.error((0,c.canceled)()),h.end(),u.dispose()}),h}writeFile(S,d,p){return this.channel.call("writeFile",[S,R.VSBuffer.wrap(d),p])}open(S,d){return this.channel.call("open",[S,d])}close(S){return this.channel.call("close",[S])}async read(S,d,p,h,u){const[f,v]=await this.channel.call("read",[S,d,u]);return p.set(f.buffer.slice(0,v),h),v}write(S,d,p,h,u){return this.channel.call("write",[S,d,R.VSBuffer.wrap(p),h,u])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,d){return this.channel.call("delete",[S,d])}rename(S,d,p){return this.channel.call("rename",[S,d,p])}copy(S,d,p){return this.channel.call("copy",[S,d,p])}cloneFile(S,d){return this.channel.call("cloneFile",[S,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const d=S;this._onDidChange.fire(d.map(p=>({resource:C.URI.revive(p.resource),type:p.type})))}else{const d=S;this._onDidWatchError.fire(d)}}))}watch(S,d){const p=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,p,S,d]),(0,L.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=y}),define(se[102],oe([0,1,17,9,169,14]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(P,y,g,S,d,p){let h;try{await D(P,y,g,S,d,p)}catch(u){h=u}finally{h&&d.errorTransformer&&(h=d.errorTransformer(h)),typeof h<"u"&&g.error(h),g.end()}}e.readFileIntoStream=L;async function D(P,y,g,S,d,p){C(p);const h=await P.open(y,{create:!1});try{C(p);let u=0,f=0,v=d&&typeof d.length=="number"?d.length:void 0,b=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof v=="number"?v:d.bufferSize)),I=d&&typeof d.position=="number"?d.position:0,i=0;do f=await P.read(h,I,b.buffer,i,b.byteLength-i),I+=f,i+=f,u+=f,typeof v=="number"&&(v-=f),i===b.byteLength&&(await g.write(S(b)),b=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof v=="number"?v:d.bufferSize)),i=0);while(f>0&&(typeof v!="number"||v>0)&&C(p)&&w(u,d));if(i>0){let s=i;typeof v=="number"&&(s=Math.min(i,v)),g.write(S(b.slice(0,s)))}}catch(u){throw(0,T.ensureFileSystemProviderError)(u)}finally{await P.close(h)}}function C(P){if(P.isCancellationRequested)throw(0,_.canceled)();return!0}function w(P,y){if(y?.limits){if(typeof y.limits.memory=="number"&&P>y.limits.memory)throw(0,T.createFileSystemProviderError)((0,c.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&P>y.limits.size)throw(0,T.createFileSystemProviderError)((0,c.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(se[56],oe([0,1,90,2,13,4,11,14]),function(Z,e,R,_,c,T,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function C(u){return u.recursive===!0}e.isRecursiveWatchRequest=C;class w extends _.Disposable{constructor(f,v,b,I){super(),this.onFileChanges=f,this.onLogMessage=v,this.verboseLogging=b,this.options=I,this.watcherDisposables=this._register(new _.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const f=new _.DisposableStore;this.watcherDisposables.value=f,this.watcher=this.createWatcher(f),this.watcher.setVerboseLogging(this.verboseLogging),f.add(this.watcher.onDidChangeFile(v=>this.onFileChanges(v))),f.add(this.watcher.onDidLogMessage(v=>this.onLogMessage(v))),f.add(this.watcher.onDidError(v=>this.onError(v)))}onError(f){this.options.restartOnError?this.restartCounter<w.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${f}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${f}`):this.error(f)}restart(f){this.restartCounter++,this.init(),this.watch(f)}async watch(f){this.requests=f,await this.watcher?.watch(f)}async setVerboseLogging(f){this.verboseLogging=f,await this.watcher?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${f}`})}dispose(){return this.watcher=void 0,super.dispose()}}w.MAX_RESTARTS=5,e.AbstractWatcherClient=w;class P extends w{constructor(f,v,b){super(f,v,b,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class y extends w{constructor(f,v,b){super(f,v,b,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function g(u){return u.map(f=>({type:f.type,resource:L.URI.file(f.path)}))}e.toFileChanges=g;function S(u){const f=new h;for(const v of u)f.processEvent(v);return f.coalesce()}e.coalesceEvents=S;function d(u,f){return typeof f=="string"&&!f.startsWith(R.GLOBSTAR)&&!(0,c.isAbsolute)(f)?{base:u,pattern:f}:f}e.normalizeWatcherPattern=d;function p(u,f){const v=[];for(const b of f)v.push((0,R.parse)(d(u,b)));return v}e.parseWatcherPatterns=p;class h{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(f){return T.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const v=this.mapPathToChange.get(this.toKey(f));let b=!1;if(v){const I=v.type,i=f.type;v.path!==f.path&&(f.type===2||f.type===1)?b=!0:I===1&&i===2?(this.mapPathToChange.delete(this.toKey(f)),this.coalesced.delete(v)):I===2&&i===1?v.type=0:I===1&&i===0||(v.type=i)}else b=!0;b&&(this.coalesced.add(f),this.mapPathToChange.set(this.toKey(f),f))}coalesce(){const f=[],v=[];return Array.from(this.coalesced).filter(b=>b.type!==2?(f.push(b),!1):!0).sort((b,I)=>b.path.length-I.path.length).filter(b=>v.some(I=>(0,D.isParent)(b.path,I,!T.isLinux))?!1:(v.push(b.path),!0)).concat(f)}}}),define(se[203],oe([0,1,53,6,25,48,2,85,13,4,149,28,56]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class S extends L.Disposable{constructor(h,u,f,v){super(),this.request=h,this.onDidFilesChange=u,this.onLogMessage=f,this.verboseLogging=v,this.throttledFileChangesEmitter=this._register(new _.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.onDidFilesChange(b))),this.fileChangesAggregator=this._register(new _.RunOnceWorker(b=>this.handleFileChanges(b),S.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,g.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,g.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new c.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const h=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await y.Promises.stat(h);this._register(await this.doWatch(h,u.isDirectory()))}catch(h){h.code!=="ENOENT"?this.error(h):this.trace(h)}}async normalizePath(h){let u=h.path;try{u=await y.Promises.realpath(h.path),h.path===u&&(u=await(0,P.realcase)(h.path)??h.path),h.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${u})`)}catch{}return u}async doWatch(h,u){if(w.isMacintosh&&(0,T.isEqualOrParent)(h,"/Volumes/",!0))return this.error(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const f=new c.CancellationTokenSource(this.cts.token),v=new L.DisposableStore;try{const b=(0,C.basename)(h),I=(0,R.watch)(h);v.add((0,L.toDisposable)(()=>{I.removeAllListeners(),I.close()})),this.trace(`Started watching: '${h}'`);const i=new Set;if(u)try{for(const t of await y.Promises.readdir(h))i.add(t)}catch(t){this.error(t)}const s=new Map;v.add((0,L.toDisposable)(()=>{for(const[,t]of s)t.dispose();s.clear()})),I.on("error",(t,n)=>{this.error(`Failed to watch ${h} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),I.on("change",(t,n)=>{if(f.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${n}`);let r="";if(n&&(r=n.toString(),w.isMacintosh&&(r=(0,D.normalizeNFC)(r))),!(!r||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){s.get(r)?.dispose();const a=setTimeout(async()=>{if(s.delete(r),r===b&&!await y.Promises.exists(h)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,C.join)(h,r));if(f.token.isCancellationRequested)return;let l;o?i.has(r)?l=0:(l=1,i.add(r)):(i.delete(r),l=2),this.onFileChange({path:(0,C.join)(this.request.path,r),type:l})},S.FILE_DELETE_HANDLER_DELAY);s.set(r,(0,L.toDisposable)(()=>clearTimeout(a)))}else{let a;i.has(r)?a=0:(a=1,i.add(r)),this.onFileChange({path:(0,C.join)(this.request.path,r),type:a})}else if(t==="rename"||r!==b){const a=setTimeout(async()=>{const o=await y.Promises.exists(h);f.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),v.add(await this.doWatch(h,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},S.FILE_DELETE_HANDLER_DELAY);v.clear(),v.add((0,L.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(b){await y.Promises.exists(h)&&!f.token.isCancellationRequested&&this.error(`Failed to watch ${h} for changes using fs.watch() (${b.toString()})`)}return(0,L.toDisposable)(()=>{f.dispose(!0),v.dispose()})}onFileChange(h,u=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!u&&this.excludes.some(f=>f(h.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${h.path}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(f=>f(h.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${h.path}`):this.fileChangesAggregator.work(h))}handleFileChanges(h){const u=(0,g.coalesceEvents)(h);if(u.length>0){if(this.verboseLogging)for(const v of u)this.trace(`>> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`);this.throttledFileChangesEmitter.work(u)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(h){if(w.isLinux)return y.Promises.exists(h);try{const u=(0,C.basename)(h);return(await y.Promises.readdir((0,C.dirname)(h))).some(v=>v===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(h){this.verboseLogging=h}error(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}warn(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}trace(h){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}S.FILE_DELETE_HANDLER_DELAY=100,S.FILE_CHANGES_HANDLER_DELAY=75,e.NodeJSFileWatcherLibrary=S;async function d(p,h,u,f,v=512){const b=await y.Promises.open(p,"r"),I=Buffer.allocUnsafe(v),i=new c.CancellationTokenSource(f);let s,t=!1;const n={path:p,excludes:[],recursive:!1},r=new S(n,a=>{(async()=>{for(const{type:o}of a)if(o===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:l}=await y.Promises.read(b,I,0,v,null);if(!l||i.token.isCancellationRequested)break;h(I.slice(0,l))}}catch(l){s=new Error(l),i.dispose(!0)}finally{t=!1}}})()});return await r.ready,u(),new Promise((a,o)=>{i.token.onCancellationRequested(async()=>{r.dispose();try{await y.Promises.close(b)}catch(l){s=new Error(l)}s?o(s):a()})})}e.watchFileContents=d}),define(se[204],oe([0,1,3,90,2,4,203]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends c.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(w){const P=this.normalizeRequests(w),y=P.filter(S=>{const d=this.watchers.get(S.path);return d?!(0,_.patternsEquals)(d.request.excludes,S.excludes)||!(0,_.patternsEquals)(d.request.includes,S.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:S})=>!P.find(d=>d.path===S.path&&(0,_.patternsEquals)(d.excludes,S.excludes)&&(0,_.patternsEquals)(d.includes,S.includes))).map(({request:S})=>S.path);y.length&&this.trace(`Request to start watching: ${y.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const S of g)this.stopWatching(S);for(const S of y)this.startWatching(S)}startWatching(w){const P=new L.NodeJSFileWatcherLibrary(w,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),y={request:w,instance:P};this.watchers.set(w.path,y)}async stop(){for(const[w]of this.watchers)this.stopWatching(w);this.watchers.clear()}stopWatching(w){const P=this.watchers.get(w);P&&(this.watchers.delete(w),P.instance.dispose())}normalizeRequests(w){const P=new Map;for(const y of w){const g=T.isLinux?y.path:y.path.toLowerCase();P.set(g,y)}return Array.from(P.values())}async setVerboseLogging(w){this.verboseLogging=w;for(const[,P]of this.watchers)P.instance.setVerboseLogging(w)}trace(w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(w)})}toMessage(w,P){return P?`[File Watcher (node.js)] ${w} (path: ${P.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=D}),define(se[205],oe([0,1,56,204]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class c extends R.AbstractNonRecursiveWatcherClient{constructor(L,D,C){super(L,D,C),this.init()}createWatcher(){return new _.NodeJSWatcher}}e.NodeJSWatcherClient=c}),define(se[206],oe([0,1,22,39,68,56]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends T.AbstractUniversalWatcherClient{constructor(C,w,P){super(C,w,P),this.init()}createWatcher(C){const w=C.add(new c.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(w.onDidProcessExit(({code:P,signal:y})=>this.onError(`terminated by itself with code ${P}, signal: ${y}`))),_.ProxyChannel.toService((0,_.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(se[72],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...c){this._entries=new Map;for(const[T,L]of c)this.set(T,L)}set(c,T){const L=this._entries.get(c);return this._entries.set(c,T),L}has(c){return this._entries.has(c)}get(c){return this._entries.get(c)}}e.ServiceCollection=R}),define(se[207],oe([0,1,6,9,2,55,197,5,72,84]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class y extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class g{constructor(h=new C.ServiceCollection,u=!1,f,v=P){this._services=h,this._strict=u,this._parent=f,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(D.IInstantiationService,this),this._globalGraph=v?f?._globalGraph??new L.Graph(b=>b):void 0}createChild(h){return new g(h,this._strict,this,this._enableTracing)}invokeFunction(h,...u){const f=d.traceInvocation(this._enableTracing,h);let v=!1;try{return h({get:I=>{if(v)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(I,f);if(!i)throw new Error(`[invokeFunction] unknown service '${I}'`);return i}},...u)}finally{v=!0,f.stop()}}createInstance(h,...u){let f,v;return h instanceof T.SyncDescriptor?(f=d.traceCreation(this._enableTracing,h.ctor),v=this._createInstance(h.ctor,h.staticArguments.concat(u),f)):(f=d.traceCreation(this._enableTracing,h),v=this._createInstance(h,u,f)),f.stop(),v}_createInstance(h,u=[],f){const v=D._util.getServiceDependencies(h).sort((i,s)=>i.index-s.index),b=[];for(const i of v){const s=this._getOrCreateServiceInstance(i.id,f);s||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${i.id}.`,!1),b.push(s)}const I=v.length>0?v[0].index:u.length;if(u.length!==I){console.trace(`[createInstance] First service dependency of ${h.name} at position ${I+1} conflicts with ${u.length} static arguments`);const i=I-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,I)}return Reflect.construct(h,u.concat(b))}_setServiceInstance(h,u){if(this._services.get(h)instanceof T.SyncDescriptor)this._services.set(h,u);else if(this._parent)this._parent._setServiceInstance(h,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const u=this._services.get(h);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):u}_getOrCreateServiceInstance(h,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const f=this._getServiceInstanceOrDescriptor(h);return f instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,f,u.branch(h,!0)):(u.branch(h,!1),f)}_safeCreateAndCacheServiceInstance(h,u,f){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,u,f)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,u,f){const v=new L.Graph(i=>i.id.toString());let b=0;const I=[{id:h,desc:u,_trace:f}];for(;I.length;){const i=I.pop();if(v.lookupOrInsertNode(i),b++>1e3)throw new y(v);for(const s of D._util.getServiceDependencies(i.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${h} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),t instanceof T.SyncDescriptor){const n={id:s.id,desc:t,_trace:i._trace.branch(s.id,!0)};v.insertEdge(i,n),I.push(n)}}}for(;;){const i=v.roots();if(i.length===0){if(!v.isEmpty())throw new y(v);break}for(const{data:s}of i){if(this._getServiceInstanceOrDescriptor(s.id)instanceof T.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,u,f=[],v,b){if(this._services.get(h)instanceof T.SyncDescriptor)return this._createServiceInstance(h,u,f,v,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,u,f,v,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(h,u,f=[],v,b){if(v){const I=new g(void 0,this._strict,this,this._enableTracing);I._globalGraphImplicitDependency=String(h);const i=new Map,s=new R.IdleValue(()=>{const t=I._createInstance(u,f,b);for(const[n,r]of i){const a=t[n];if(typeof a=="function")for(const o of r)a.apply(t,o)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=i.get(n);return o||(o=new w.LinkedList,i.set(n,o)),(m,E,A)=>{const O=o.push([m,E,A]);return(0,c.toDisposable)(O)}}if(n in t)return t[n];const r=s.value;let a=r[n];return typeof a!="function"||(a=a.bind(r),t[n]=a),a},set(t,n,r){return s.value[n]=r,!0},getPrototypeOf(t){return u.prototype}})}else return this._createInstance(u,f,b)}_throwIfStrict(h,u){if(u&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=g;var S;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(S||(S={}));class d{static traceInvocation(h,u){return h?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d._None}static traceCreation(h,u){return h?new d(1,u.name):d._None}constructor(h,u){this.type=h,this.name=u,this._start=Date.now(),this._dep=[]}branch(h,u){const f=new d(3,h.toString());return this._dep.push([h,u,f]),f}stop(){const h=Date.now()-this._start;d._totals+=h;let u=!1;function f(b,I){const i=[],s=new Array(b+1).join("	");for(const[t,n,r]of I._dep)if(n&&r){u=!0,i.push(`${s}CREATES -> ${t}`);const a=f(b+1,r);a&&i.push(a)}else i.push(`${s}uses -> ${t}`);return i.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||u)&&d.all.add(v.join(`
`))}}d.all=new Set,d._None=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d._totals=0,e.Trace=d}),define(se[208],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(c,T){this.server=c,this.router=T}getChannel(c){return this.server.getChannel(c,this.router)}registerChannel(c,T){this.server.registerChannel(c,T)}}e.MessagePortMainProcessService=R}),define(se[57],oe([0,1,39,55,71,5]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(S,d,p,h){const u=p.getChannel(S);return D(d)?h.createInstance(new _.SyncDescriptor(d.channelClientCtor,[u])):R.ProxyChannel.toService(u,d?.proxyOptions)}}function D(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let C=class extends L{constructor(S,d,p,h){super(S,d,p,h)}};C=Se([K(2,e.IMainProcessService),K(3,T.IInstantiationService)],C);function w(g,S,d){(0,c.registerSingleton)(g,new _.SyncDescriptor(C,[S,d],!0))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let P=class extends L{constructor(S,d,p,h){super(S,d,p,h)}};P=Se([K(2,e.ISharedProcessService),K(3,T.IInstantiationService)],P);function y(g,S,d){(0,c.registerSingleton)(g,new _.SyncDescriptor(P,[S,d],!0))}e.registerSharedProcessRemoteService=y}),define(se[73],oe([0,1,25,2,4,171,30,5]),function(Z,e,R,_,c,T,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function C(P){return P.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=C,e.ILanguagePackService=(0,D.createDecorator)("languagePackService");let w=class extends _.Disposable{constructor(y){super(),this.extensionGalleryService=y}async getAvailableLanguages(){const y=new R.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let g;try{g=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const d=g.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(h=>h.startsWith("lp-"))).map(p=>{const h=p.properties.localizedLanguages?.[0],u=C(p);return{...this.createQuickPickItem(u,h,p),extensionId:p.identifier.id,galleryExtension:p}});return d.push(this.createQuickPickItem("en","English")),d}createQuickPickItem(y,g,S){const d=g??y;let p;if(d!==y&&(p=`(${y})`),y.toLowerCase()===c.language.toLowerCase()&&(p??="",p+=(0,T.localize)(0,null)),S?.installCount){p??="";const h=S.installCount;let u;h>1e6?u=`${Math.floor(h/1e5)/10}M`:h>1e3?u=`${Math.floor(h/1e3)}K`:u=String(h),p+=` $(cloud-download) ${u}`}return{id:y,label:d,description:p}}};w=Se([K(0,L.IExtensionGalleryService)],w),e.LanguagePackBaseService=w}),define(se[209],oe([0,1,2,73]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let c=class extends R.Disposable{constructor(L){super(),this.localizationsService=L,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};c=Se([K(0,_.ILanguagePackService)],c),e.LocalizationsUpdater=c}),define(se[8],oe([0,1,38,3,2,37,4,12,11,5]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function P(){return new Date().toISOString()}function y(o){return(0,D.isNumber)(o)}e.isLogLevel=y;var g;(function(o){o[o.Off=0]="Off",o[o.Trace=1]="Trace",o[o.Debug=2]="Debug",o[o.Info=3]="Info",o[o.Warning=4]="Warning",o[o.Error=5]="Error"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;function S(o,l,m){switch(l){case g.Trace:o.trace(m);break;case g.Debug:o.debug(m);break;case g.Info:o.info(m);break;case g.Warning:o.warn(m);break;case g.Error:o.error(m);break;case g.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=S;function d(o){let l="";for(let m=0;m<o.length;m++){let E=o[m];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}l+=(m>0?" ":"")+E}return l}e.format=d;class p extends c.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(l){this.level!==l&&(this.level=l,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(l){return this.level!==g.Off&&this.level<=l}}e.AbstractLogger=p;class h extends p{constructor(l){super(),this.logAlways=l}checkLogLevel(l){return this.logAlways||super.checkLogLevel(l)}trace(l,...m){this.checkLogLevel(g.Trace)&&this.log(g.Trace,d([l,...m]))}debug(l,...m){this.checkLogLevel(g.Debug)&&this.log(g.Debug,d([l,...m]))}info(l,...m){this.checkLogLevel(g.Info)&&this.log(g.Info,d([l,...m]))}warn(l,...m){this.checkLogLevel(g.Warning)&&this.log(g.Warning,d([l,...m]))}error(l,...m){if(this.checkLogLevel(g.Error))if(l instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=l.stack,this.log(g.Error,d(E))}else this.log(g.Error,d([l,...m]))}flush(){}}e.AbstractMessageLogger=h;class u extends p{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.useColors=!L.isWindows}trace(l,...m){this.checkLogLevel(g.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,l,...m):console.log(`[main ${P()}]`,l,...m))}debug(l,...m){this.checkLogLevel(g.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,l,...m):console.log(`[main ${P()}]`,l,...m))}info(l,...m){this.checkLogLevel(g.Info)&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,l,...m):console.log(`[main ${P()}]`,l,...m))}warn(l,...m){this.checkLogLevel(g.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,l,...m):console.warn(`[main ${P()}]`,l,...m))}error(l,...m){this.checkLogLevel(g.Error)&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,l,...m):console.error(`[main ${P()}]`,l,...m))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class f extends p{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...m){this.checkLogLevel(g.Trace)&&console.log("%cTRACE","color: #888",l,...m)}debug(l,...m){this.checkLogLevel(g.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...m)}info(l,...m){this.checkLogLevel(g.Info)&&console.log("%c INFO","color: #33f",l,...m)}warn(l,...m){this.checkLogLevel(g.Warning)&&console.log("%c WARN","color: #993",l,...m)}error(l,...m){this.checkLogLevel(g.Error)&&console.log("%c  ERR","color: #f33",l,...m)}dispose(){}flush(){}}e.ConsoleLogger=f;class v extends p{constructor(l,m=e.DEFAULT_LOG_LEVEL){super(),this.adapter=l,this.setLevel(m)}trace(l,...m){this.checkLogLevel(g.Trace)&&this.adapter.log(g.Trace,[this.extractMessage(l),...m])}debug(l,...m){this.checkLogLevel(g.Debug)&&this.adapter.log(g.Debug,[this.extractMessage(l),...m])}info(l,...m){this.checkLogLevel(g.Info)&&this.adapter.log(g.Info,[this.extractMessage(l),...m])}warn(l,...m){this.checkLogLevel(g.Warning)&&this.adapter.log(g.Warning,[this.extractMessage(l),...m])}error(l,...m){this.checkLogLevel(g.Error)&&this.adapter.log(g.Error,[this.extractMessage(l),...m])}extractMessage(l){return typeof l=="string"?l:(0,R.toErrorMessage)(l,this.checkLogLevel(g.Trace))}dispose(){}flush(){}}e.AdapterLogger=v;class b extends p{constructor(l){super(),this.loggers=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const m of this.loggers)m.setLevel(l);super.setLevel(l)}trace(l,...m){for(const E of this.loggers)E.trace(l,...m)}debug(l,...m){for(const E of this.loggers)E.debug(l,...m)}info(l,...m){for(const E of this.loggers)E.info(l,...m)}warn(l,...m){for(const E of this.loggers)E.warn(l,...m)}error(l,...m){for(const E of this.loggers)E.error(l,...m)}flush(){for(const l of this.loggers)l.flush()}dispose(){for(const l of this.loggers)l.dispose()}}e.MultiplexLogger=b;class I extends c.Disposable{constructor(l,m){if(super(),this.logLevel=l,this._loggers=new T.ResourceMap,this._loggerResources=new T.ResourceMap,this._onDidChangeLoggers=this._register(new _.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,m)for(const E of m)this._loggerResources.set(E.resource,E)}getLogger(l){return this._loggers.get(l)}createLogger(l,m){let E=this._loggers.get(l);const A=m?.logLevel==="always"?g.Trace:m?.logLevel;return E||(E=this.doCreateLogger(l,A??this.getLogLevel(l)??this.logLevel,m),this._loggers.set(l,E)),this.registerLogger({resource:l,id:m?.id??l.toString(),logLevel:A,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId}),E}setLogLevel(l,m){if(C.URI.isUri(l)){const E=l,A=m,O=this._loggerResources.get(E);O&&A!==O.logLevel&&(O.logLevel=A===this.logLevel?void 0:A,this._loggers.get(E)?.setLevel(A),this._loggerResources.set(O.resource,O),this._onDidChangeLogLevel.fire([E,A]))}else{this.logLevel=l;for(const[E,A]of this._loggers.entries())this._loggerResources.get(E)?.logLevel===void 0&&A.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(l,m){const E=this._loggerResources.get(l);E&&m!==!E.hidden&&(E.hidden=!m,this._loggerResources.set(E.resource,E),this._onDidChangeVisibility.fire([l,m]))}getLogLevel(l){let m;return l&&(m=this._loggerResources.get(l)?.logLevel),m??this.logLevel}registerLogger(l){const m=this._loggerResources.get(l.resource);m?m.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this._loggerResources.set(l.resource,l),this._onDidChangeLoggers.fire({added:[l],removed:[]}))}deregisterLogger(l){const m=this._loggerResources.get(l);if(m){this._loggerResources.delete(l);const E=this._loggers.get(l);E&&(this._loggers.delete(l),E.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[m]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(l){return this._loggerResources.get(l)}dispose(){this._loggers.forEach(l=>l.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=I;class i{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(l){}getLevel(){return g.Info}trace(l,...m){}debug(l,...m){}info(l,...m){}warn(l,...m){}error(l,...m){}critical(l,...m){}dispose(){}flush(){}}e.NullLogger=i;class s extends i{}e.NullLogService=s;class t extends I{constructor(){super(g.Info)}doCreateLogger(l,m,E){return new i}}e.NullLoggerService=t;function n(o){if(o.verbose)return g.Trace;if(typeof o.logLevel=="string"){const l=a(o.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(o){switch(o){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.LogLevelToString=r;function a(o){switch(o){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.parseLogLevel=a}),define(se[210],oe([0,1,6,9,2,13,28,15,8]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends c.Disposable{constructor(y,g){super(),this.environmentService=y,this.logService=g,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const y=(0,T.basename)(this.environmentService.logsPath),g=(0,T.dirname)(this.environmentService.logsPath),p=(await L.Promises.readdir(g)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==y),h=p.slice(0,Math.max(0,p.length-9));h.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${h.join(", ")}'`),await Promise.all(h.map(u=>L.Promises.rm((0,T.join)(g,u)))))}catch(y){(0,_.onUnexpectedError)(y)}}};w=Se([K(0,D.IEnvironmentService),K(1,C.ILogService)],w),e.LogsDataCleaner=w}),define(se[211],oe([0,1,21,6,9,3,2,13,56,8]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends L.Disposable{constructor(g,S){super(),this.logService=g,this.options=S,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new _.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new _.ThrottledDelayer(0))}watch(g,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,S):this.watchNonRecursive(g,S)}watchUniversal(g,S){const d={path:this.toFilePath(g),excludes:S.excludes,includes:S.includes,recursive:S.recursive},p=(0,R.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,c.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,C.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const S of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const S of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(S)&&g.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,S){const d={path:this.toFilePath(g),excludes:S.excludes,includes:S.includes,recursive:!1},p=(0,R.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,c.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,C.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,D.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(se[212],oe([0,1,21,6,17,25,3,66,64,2,49,22,103,23,44,167,14,102,8,9]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=class extends w.Disposable{constructor(i){super(),this.logService=i,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new _.ResourceQueue)}registerProvider(i,s){if(this.provider.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${i}`);const t=new w.DisposableStore;return this.provider.set(i,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:i,provider:s}),t.add(s.onDidChangeFile(n=>this._onDidFilesChange.fire(new h.FileChangesEvent(n,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&t.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:i}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:i,provider:s}),this.provider.delete(i),(0,w.dispose)(t)})}getProvider(i){return this.provider.get(i)}async activateProvider(i){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:i,join(t){s.push(t)}}),!this.provider.has(i)&&await _.Promises.settled(s)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.provider.has(i.scheme)}hasCapability(i,s){const t=this.provider.get(i.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return C.Iterable.map(this.provider,([i,s])=>({scheme:i,capabilities:s.capabilities}))}async withProvider(i){if(!(0,S.isAbsolutePath)(i))throw new h.FileOperationError((0,p.localize)(0,null,this.resourceForError(i)),8);await this.activateProvider(i.scheme);const s=this.provider.get(i.scheme);if(!s){const t=new v.ErrorNoTelemetry;throw t.message=(0,p.localize)(1,null,i.toString()),t}return s}async withReadProvider(i){const s=await this.withProvider(i);if((0,h.hasOpenReadWriteCloseCapability)(s)||(0,h.hasReadWriteCapability)(s)||(0,h.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(i){const s=await this.withProvider(i);if((0,h.hasOpenReadWriteCloseCapability)(s)||(0,h.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,s){try{return await this.doResolveFile(i,s)}catch(t){throw(0,h.toFileSystemProviderErrorCode)(t)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,p.localize)(2,null,this.resourceForError(i)),1):(0,h.ensureFileSystemProviderError)(t)}}async doResolveFile(i,s){const t=await this.withProvider(i),n=this.isPathCaseSensitive(t),r=s?.resolveTo,a=s?.resolveSingleChildDescendants,o=s?.resolveMetadata,l=await t.stat(i);let m;return this.toFileStat(t,i,l,void 0,!!o,(E,A)=>(m||(m=P.TernarySearchTree.forUris(()=>!n),m.set(i,!0),r&&m.fill(!0,r)),m.get(E.resource)||m.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&a?A===1:!1))}async toFileStat(i,s,t,n,r,a){const{providerExtUri:o}=this.getExtUri(i),l={resource:s,name:o.basename(s),isFile:(t.type&h.FileType.File)!==0,isDirectory:(t.type&h.FileType.Directory)!==0,isSymbolicLink:(t.type&h.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&h.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,h.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(l.isDirectory&&a(l,n)){try{const m=await i.readdir(s),E=await _.Promises.settled(m.map(async([A,O])=>{try{const F=o.joinPath(s,A),M=r?await i.stat(F):{type:O};return await this.toFileStat(i,F,M,m.length,r,a)}catch(F){return this.logService.trace(F),null}}));l.children=(0,R.coalesce)(E)}catch(m){this.logService.trace(m),l.children=[]}return l}return l}async resolveAll(i){return _.Promises.settled(i.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const s=await this.withProvider(i),t=await s.stat(i);return this.toFileStat(s,i,t,void 0,!0,()=>!1)}async exists(i){const s=await this.withProvider(i);try{return!!await s.stat(i)}catch{return!1}}async canCreateFile(i,s){try{await this.doValidateCreateFile(i,s)}catch(t){return t}return!0}async doValidateCreateFile(i,s){if(!s?.overwrite&&await this.exists(i))throw new h.FileOperationError((0,p.localize)(3,null,this.resourceForError(i)),3,s)}async createFile(i,s=c.VSBuffer.fromString(""),t){await this.doValidateCreateFile(i,t);const n=await this.writeFile(i,s);return this._onDidRunOperation.fire(new h.FileOperationEvent(i,0,n)),n}async writeFile(i,s,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,i,t)||await this.mkdirp(n,r.dirname(i));let o;if((0,h.hasReadWriteCapability)(n)&&!(s instanceof c.VSBuffer))if((0,d.isReadableStream)(s)){const l=await(0,d.peekStream)(s,3);l.ended?o=c.VSBuffer.concat(l.buffer):o=l}else o=(0,d.peekReadable)(s,l=>c.VSBuffer.concat(l),3);else o=s;!(0,h.hasOpenReadWriteCloseCapability)(n)||(0,h.hasReadWriteCapability)(n)&&o instanceof c.VSBuffer?await this.doWriteUnbuffered(n,i,t,o):await this.doWriteBuffered(n,i,t,o instanceof c.VSBuffer?(0,c.bufferToReadable)(o):o),this._onDidRunOperation.fire(new h.FileOperationEvent(i,4))}catch(a){throw new h.FileOperationError((0,p.localize)(4,null,this.resourceForError(i),(0,h.ensureFileSystemProviderError)(a).toString()),(0,h.toFileOperationResult)(a),t)}return this.resolve(i,{resolveMetadata:!0})}async validateWriteFile(i,s,t){if(!!t?.unlock&&!(i.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(s)));let r;try{r=await i.stat(s)}catch{return}if((r.type&h.FileType.Directory)!==0)throw new h.FileOperationError((0,p.localize)(6,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==h.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,h.etag)({mtime:t.mtime,size:r.size}))throw new h.FileOperationError((0,p.localize)(7,null),3,t);return r}async readFile(i,s,t){const n=await this.withReadProvider(i);return s?.atomic?this.doReadFileAtomic(n,i,s,t):this.doReadFile(n,i,s,t)}async doReadFileAtomic(i,s,t,n){return new Promise((r,a)=>{this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(i,s,t,n);r(o)}catch(o){a(o)}})})}async doReadFile(i,s,t,n){const r=await this.doReadFileStream(i,s,{...t,preferUnbuffered:!0},n);return{...r,value:await(0,c.streamToBuffer)(r.value)}}async readFileStream(i,s,t){const n=await this.withReadProvider(i);return this.doReadFileStream(n,i,s,t)}async doReadFileStream(i,s,t,n){const r=new T.CancellationTokenSource(n),a=this.validateReadFile(s,t).then(l=>l,l=>{throw r.cancel(),l});let o;try{return typeof t?.etag=="string"&&t.etag!==h.ETAG_DISABLED&&await a,t?.atomic&&(0,h.hasFileAtomicReadCapability)(i)||!((0,h.hasOpenReadWriteCloseCapability)(i)||(0,h.hasFileReadStreamCapability)(i))||(0,h.hasReadWriteCapability)(i)&&t?.preferUnbuffered?o=this.readFileUnbuffered(i,s,t):(0,h.hasFileReadStreamCapability)(i)?o=this.readFileStreamed(i,s,r.token,t):o=this.readFileBuffered(i,s,r.token,t),{...await a,value:o}}catch(l){throw o&&await(0,d.consumeStream)(o),this.restoreReadError(l,s,t)}}restoreReadError(i,s,t){const n=(0,p.localize)(8,null,this.resourceForError(s),(0,h.ensureFileSystemProviderError)(i).toString());return i instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(n,i.stat,t):i instanceof h.TooLargeFileOperationError?new h.TooLargeFileOperationError(n,i.fileOperationResult,i.size,i.options):new h.FileOperationError(n,(0,h.toFileOperationResult)(i),t)}readFileStreamed(i,s,t,n=Object.create(null)){const r=i.readFileStream(s,n,t);return(0,d.transform)(r,{data:a=>a instanceof c.VSBuffer?a:c.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,s,n)},a=>c.VSBuffer.concat(a))}readFileBuffered(i,s,t,n=Object.create(null)){const r=(0,c.newWriteableBufferStream)();return(0,u.readFileIntoStream)(i,s,r,a=>a,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,s,n)},t),r}readFileUnbuffered(i,s,t){const n=(0,d.newWriteableStream)(r=>c.VSBuffer.concat(r));return(async()=>{try{let r;t?.atomic&&(0,h.hasFileAtomicReadCapability)(i)?r=await i.readFile(s,{atomic:!0}):r=await i.readFile(s),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(s,r.byteLength,t),n.end(c.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(i,s){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new h.FileOperationError((0,p.localize)(9,null,this.resourceForError(i)),0,s);if(typeof s?.etag=="string"&&s.etag!==h.ETAG_DISABLED&&s.etag===t.etag)throw new h.NotModifiedSinceFileOperationError((0,p.localize)(10,null),t,s);return this.validateReadFileLimits(i,t.size,s),t}validateReadFileLimits(i,s,t){if(t?.limits){let n;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&s>t.limits.size&&(n=7),typeof n=="number")throw new h.TooLargeFileOperationError((0,p.localize)(11,null,this.resourceForError(i)),n,s,t)}}async canMove(i,s,t){return this.doCanMoveCopy(i,s,"move",t)}async canCopy(i,s,t){return this.doCanMoveCopy(i,s,"copy",t)}async doCanMoveCopy(i,s,t,n){if(i.toString()!==s.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i):await this.withReadProvider(i),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(r,i,a,s,t,n)}catch(r){return r}return!0}async move(i,s,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(n,i,r,s,"move",!!t),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(i,a==="move"?2:3,o)),o}async copy(i,s,t){const n=await this.withReadProvider(i),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(n,i,r,s,"copy",!!t),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(i,a==="copy"?3:2,o)),o}async doMoveCopy(i,s,t,n,r,a){if(s.toString()===n.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(i,s,t,n,r,a);if(o&&!l&&a&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),r==="copy"){if(i===t&&(0,h.hasFileFolderCopyCapability)(i))await i.copy(s,n,{overwrite:a});else{const m=await this.resolve(s);m.isDirectory?await this.doCopyFolder(i,m,t,n):await this.doCopyFile(i,s,t,n)}return r}else return i===t?(await i.rename(s,n,{overwrite:a}),r):(await this.doMoveCopy(i,s,t,n,"copy",a),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(i,s,t,n){if((0,h.hasOpenReadWriteCloseCapability)(i)&&(0,h.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(i,s,t,n);if((0,h.hasOpenReadWriteCloseCapability)(i)&&(0,h.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(i,s,t,n);if((0,h.hasReadWriteCapability)(i)&&(0,h.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(i,s,t,n);if((0,h.hasReadWriteCapability)(i)&&(0,h.hasReadWriteCapability)(t))return this.doPipeUnbuffered(i,s,t,n)}async doCopyFolder(i,s,t,n){await t.mkdir(n),Array.isArray(s.children)&&await _.Promises.settled(s.children.map(async r=>{const a=this.getExtUri(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(i,await this.resolve(r.resource),t,a):this.doCopyFile(i,r.resource,t,a)}))}async doValidateMoveCopy(i,s,t,n,r,a){let o=!1;if(i===t){const{providerExtUri:m,isPathCaseSensitive:E}=this.getExtUri(i);if(E||(o=m.isEqual(s,n)),o&&r==="copy")throw new Error((0,p.localize)(12,null,this.resourceForError(s),this.resourceForError(n)));if(!o&&m.isEqualOrParent(n,s))throw new Error((0,p.localize)(13,null,this.resourceForError(s),this.resourceForError(n)))}const l=await this.exists(n);if(l&&!o){if(!a)throw new h.FileOperationError((0,p.localize)(14,null,this.resourceForError(s),this.resourceForError(n)),4);if(i===t){const{providerExtUri:m}=this.getExtUri(i);if(m.isEqualOrParent(s,n))throw new Error((0,p.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:o}}getExtUri(i){const s=this.isPathCaseSensitive(i);return{providerExtUri:s?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(i){return!!(i.capabilities&1024)}async createFolder(i){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i);await this.mkdirp(s,i);const t=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(i,0,t)),t}async mkdirp(i,s){const t=[],{providerExtUri:n}=this.getExtUri(i);for(;!n.isEqual(s,n.dirname(s));)try{if(((await i.stat(s)).type&h.FileType.Directory)===0)throw new Error((0,p.localize)(16,null,this.resourceForError(s)));break}catch(r){if((0,h.toFileSystemProviderErrorCode)(r)!==h.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(s)),s=n.dirname(s)}for(let r=t.length-1;r>=0;r--){s=n.joinPath(s,t[r]);try{await i.mkdir(s)}catch(a){if((0,h.toFileSystemProviderErrorCode)(a)!==h.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,s){try{await this.doValidateDelete(i,s)}catch(t){return t}return!0}async doValidateDelete(i,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i);if(!!s?.useTrash&&!(t.capabilities&4096))throw new Error((0,p.localize)(17,null,this.resourceForError(i)));let r;try{r=await t.stat(i)}catch{}if(r)this.throwIfFileIsReadonly(i,r);else throw new h.FileOperationError((0,p.localize)(18,null,this.resourceForError(i)),1);if(!!!s?.recursive){const o=await this.resolve(i);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,p.localize)(19,null,this.resourceForError(i)))}return t}async del(i,s){const t=await this.doValidateDelete(i,s),n=!!s?.useTrash,r=!!s?.recursive;await t.delete(i,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new h.FileOperationEvent(i,1))}async cloneFile(i,s){const t=await this.withProvider(i),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(t===n&&this.getExtUri(t).providerExtUri.isEqual(i,s))return;if(t===n&&(0,h.hasFileCloneCapability)(t))return t.cloneFile(i,s);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s));const r=this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri);return t===n&&(0,h.hasFileFolderCopyCapability)(t)?r.queue(()=>t.copy(i,s,{overwrite:!0})):r.queue(()=>this.doCopyFile(t,i,n,s))}watch(i,s={recursive:!1,excludes:[]}){const t=new w.DisposableStore;let n=!1,r=()=>{n=!0};return t.add((0,w.toDisposable)(()=>r())),(async()=>{try{const a=await this.doWatch(i,s);n?(0,w.dispose)(a):r=()=>(0,w.dispose)(a)}catch(a){this.logService.error(a)}})(),t}async doWatch(i,s){const t=await this.withProvider(i),n=(0,D.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(i),s]);let r=this.activeWatchers.get(n);return r||(r={count:0,disposable:t.watch(i,s)},this.activeWatchers.set(n,r)),r.count+=1,(0,w.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,w.dispose)(r.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,i]of this.activeWatchers)(0,w.dispose)(i.disposable);this.activeWatchers.clear()}async doWriteBuffered(i,s,t,n){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(async()=>{const r=await i.open(s,{create:!0,unlock:t?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(i,r,n):await this.doWriteReadableBufferedQueued(i,r,n)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await i.close(r)}})}async doWriteStreamBufferedQueued(i,s,t){let n=0,r;if((0,d.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=c.VSBuffer.concat(t.buffer);await this.doWriteBuffer(i,s,a,a.byteLength,n,0),n+=a.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((a,o)=>{(0,d.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(i,s,l,l.byteLength,n,0)}catch(m){return o(m)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>o(l),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(i,s,t){let n=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(i,s,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(i,s,t,n,r,a){let o=0;for(;o<n;)o+=await i.write(s,r+o,t.buffer,a+o,n-o)}async doWriteUnbuffered(i,s,t,n){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(i,s,t,n))}async doWriteUnbufferedQueued(i,s,t,n){let r;n instanceof c.VSBuffer?r=n:(0,d.isReadableStream)(n)?r=await(0,c.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?r=await(0,c.bufferedStreamToBuffer)(n):r=(0,c.readableToBuffer)(n),await i.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(i,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(i,s,t,n))}async doPipeBufferedQueued(i,s,t,n){let r,a;try{r=await i.open(s,{create:!1}),a=await t.open(n,{create:!0,unlock:!1});const o=c.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,m=0,E=0;do E=await i.read(r,l,o.buffer,m,o.byteLength-m),await this.doWriteBuffer(t,a,o,E,l,m),l+=E,m+=E,m===o.byteLength&&(m=0);while(E>0)}catch(o){throw(0,h.ensureFileSystemProviderError)(o)}finally{await _.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(i,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(i,s,t,n))}async doPipeUnbufferedQueued(i,s,t,n){return t.writeFile(n,await i.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(i,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(i,s,t,n))}async doPipeUnbufferedToBufferedQueued(i,s,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const a=await i.readFile(s);await this.doWriteBuffer(t,r,c.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(i,s,t,n){const r=await(0,c.streamToBuffer)(this.readFileBuffered(i,s,T.CancellationToken.None));await this.doWriteUnbuffered(t,n,void 0,r)}throwIfFileSystemIsReadonly(i,s){if(i.capabilities&2048)throw new h.FileOperationError((0,p.localize)(20,null,this.resourceForError(s)),6);return i}throwIfFileIsReadonly(i,s){if((s.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,p.localize)(21,null,this.resourceForError(i)),6)}resourceForError(i){return i.scheme===y.Schemas.file?i.fsPath:i.toString(!0)}};b=Se([K(0,f.ILogService)],b),e.FileService=b}),define(se[213],oe([0,1,53,295,6,37,17,3,48,2,13,4,23,44,28,170,14,102,211,38,206,205]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,_.gracefulify)(R)}catch(s){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(s)}`)}})();class i extends f.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new T.ResourceMap(r=>g.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,y.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:r}=await d.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await d.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,g.joinPath)(t,a.name))).type:o=this.toType(a),r.push([a.name,o])}catch(o){this.logService.trace(o)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let r;return n?.dangling?r=h.FileType.Unknown:t.isFile()?r=h.FileType.File:t.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,n&&(r|=h.FileType.SymbolicLink),r}async createResourceLock(t){const n=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const a=new c.Barrier;return this.resourceLocks.set(t,a),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,w.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===a&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(t,n){let r;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),r=await this.createResourceLock(t));const a=this.toFilePath(t);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}traceLock(t){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,n,r){const a=(0,S.newWriteableStream)(o=>L.VSBuffer.concat(o.map(l=>L.VSBuffer.wrap(l))).buffer);return(0,u.readFileIntoStream)(this,t,a,o=>o.buffer,{...n,bufferSize:256*1024},r),a}async writeFile(t,n,r){let a;try{const o=this.toFilePath(t);if(!r.create||!r.overwrite){if(await d.Promises.exists(o)){if(!r.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(t,{create:!0,unlock:r.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(t,o)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(t){i.canFlush=t}async open(t,n){const r=this.toFilePath(t);let a;(0,h.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(t));let o;try{if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:m}=await d.SymlinkSupport.stat(r);m.mode&128||await d.Promises.chmod(r,m.mode|128)}catch(m){this.logService.trace(m)}let l;if((0,h.isFileOpenForWriteOptions)(n)){if(y.isWindows)try{await d.Promises.truncate(r,0),l="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}l||(l="w")}else l="r";o=await d.Promises.open(r,l)}catch(l){throw a?.dispose(),(0,h.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(o,0),(0,h.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(o,t),a){const l=this.mapHandleToLock.get(o);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.mapHandleToLock.set(o,a),l&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),l.dispose())}return o}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await d.Promises.fdatasync(t)}catch(r){i.configureFlushOnWrite(!1),this.logService.error(r)}return await d.Promises.close(t)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,r,a,o){const l=this.normalizePos(t,n);let m=null;try{m=(await d.Promises.read(t,r,a,o,l)).bytesRead}catch(E){throw this.toFileSystemProviderError(E)}finally{this.updatePos(t,l,m)}return m}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,r){const a=this.mapHandleToPos.get(t);typeof a=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(t,a+r):this.mapHandleToPos.delete(t)))}async write(t,n,r,a,o){return(0,c.retry)(()=>this.doWrite(t,n,r,a,o),100,3)}async doWrite(t,n,r,a,o){const l=this.normalizePos(t,n);let m=null;try{m=(await d.Promises.write(t,r,a,o,l)).bytesWritten}catch(E){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),E)}finally{this.updatePos(t,l,m)}return m}async mkdir(t){try{await d.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const r=this.toFilePath(t);n.recursive?await d.Promises.rm(r,d.RimRafMode.MOVE):await d.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(t,n,r){const a=this.toFilePath(t),o=this.toFilePath(n);if(a!==o)try{await this.validateTargetDeleted(t,n,"move",r.overwrite),await d.Promises.move(a,o)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,p.localize)(2,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(t,n,r){const a=this.toFilePath(t),o=this.toFilePath(n);if(a!==o)try{await this.validateTargetDeleted(t,n,"copy",r.overwrite),await d.Promises.copy(a,o,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,p.localize)(3,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(t,n,r,a){const o=this.toFilePath(t),l=this.toFilePath(n);let m=!1;if(!!(this.capabilities&1024)||(m=(0,C.isEqual)(o,l,!0)),m&&r==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!m&&await d.Promises.exists(l)){if(!a)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,r){const a=this.toFilePath(t),o=this.toFilePath(n),l=!!(this.capabilities&1024);if((0,C.isEqual)(a,o,!l))return;const m=new w.DisposableStore;try{const[E,A]=await Promise.all([this.createResourceLock(t),this.createResourceLock(n)]);m.add(E),m.add(A),r&&await d.Promises.mkdir((0,P.dirname)(o),{recursive:!0}),await d.Promises.copyFile(a,o)}catch(E){if(E.code==="ENOENT"&&!r)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(E)}finally{m.dispose()}}createUniversalWatcher(t,n,r){return new b.UniversalWatcherClient(a=>t(a),a=>n(a),r)}createNonRecursiveWatcher(t,n,r){return new I.NodeJSWatcherClient(a=>t(a),a=>n(a),r)}toFileSystemProviderError(t){if(t instanceof h.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let r=this.toFileSystemProviderError(n);if(t&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(t));a.mode&128||(r=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0,e.DiskFileSystemProvider=i}),define(se[104],oe([0,1,6,3,2,5,8]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,T.createDecorator)("lifecycleSharedProcessService");let D=class extends c.Disposable{constructor(w){super(),this.logService=w,this.pendingWillShutdownPromise=void 0,this._onWillShutdown=this._register(new _.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const w=[];return this._onWillShutdown.fire({join(P){w.push(P)}}),this.pendingWillShutdownPromise=(async()=>{try{await R.Promises.settled(w)}catch(P){this.logService.error(P)}})(),this.pendingWillShutdownPromise}};D=Se([K(0,L.ILogService)],D),e.SharedProcessLifecycleService=D}),define(se[105],oe([0,1,11,3,8,2]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class L extends c.AbstractLoggerService{constructor(y,g,S,d){super(g,S),this.windowId=y,this.channel=d,this._register(d.listen("onDidChangeLogLevel",y)(p=>{(0,c.isLogLevel)(p)?super.setLogLevel(p):super.setLogLevel(R.URI.revive(p[0]),p[1])})),this._register(d.listen("onDidChangeVisibility",y)(([p,h])=>super.setVisibility(R.URI.revive(p),h))),this._register(d.listen("onDidChangeLoggers",y)(({added:p,removed:h})=>{for(const u of p)super.registerLogger({...u,resource:R.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new c.AdapterLogger({log:(y,g)=>{this.channel.call("consoleLog",[y,g])}})}registerLogger(y){super.registerLogger(y),this.channel.call("registerLogger",[y,this.windowId])}deregisterLogger(y){super.deregisterLogger(y),this.channel.call("deregisterLogger",[y,this.windowId])}setLogLevel(y,g){super.setLogLevel(y,g),this.channel.call("setLogLevel",[y,g])}setVisibility(y,g){super.setVisibility(y,g),this.channel.call("setVisibility",[y,g])}doCreateLogger(y,g,S){return new D(this.channel,y,g,S,this.windowId)}static setLogLevel(y,g,S){return y.call("setLogLevel",[g,S])}}e.LoggerChannelClient=L;class D extends c.AbstractMessageLogger{constructor(y,g,S,d,p){super(d?.logLevel==="always"),this.channel=y,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.channel.call("createLogger",[g,d,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,g){const S=[[y,g]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(y){this.channel.call("log",[this.file,y])}}class C{constructor(y,g){this.loggerService=y,this.getUriTransformer=g}listen(y,g){const S=this.getUriTransformer(y);switch(g){case"onDidChangeLoggers":return _.Event.map(this.loggerService.onDidChangeLoggers,d=>({added:[...d.added].map(p=>this.transformLogger(p,S)),removed:[...d.removed].map(p=>this.transformLogger(p,S))}));case"onDidChangeVisibility":return _.Event.map(this.loggerService.onDidChangeVisibility,d=>[S.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return _.Event.map(this.loggerService.onDidChangeLogLevel,d=>(0,c.isLogLevel)(d)?d:[S.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${g}`)}async call(y,g,S){const d=this.getUriTransformer(y);switch(g){case"setLogLevel":return(0,c.isLogLevel)(S[0])?this.loggerService.setLogLevel(S[0]):this.loggerService.setLogLevel(R.URI.revive(d.transformIncoming(S[0][0])),S[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(p=>this.transformLogger(p,d)))}throw new Error(`Call not found: ${g}`)}transformLogger(y,g){return{...y,resource:g.transformOutgoingURI(y.resource)}}}e.LoggerChannel=C;class w extends T.Disposable{constructor(y,g){super(),g.call("setLogLevel",[y.getLogLevel()]),this._register(y.onDidChangeLogLevel(S=>g.call("setLogLevel",[S]))),g.call("getRegisteredLoggers").then(S=>{for(const d of S)y.registerLogger({...d,resource:R.URI.revive(d.resource)})}),this._register(g.listen("onDidChangeVisibility")(([S,d])=>y.setVisibility(R.URI.revive(S),d))),this._register(g.listen("onDidChangeLoggers")(({added:S,removed:d})=>{for(const p of S)y.registerLogger({...p,resource:R.URI.revive(p.resource)});for(const p of d)y.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=w}),define(se[214],oe([0,1,2,8]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class c extends R.Disposable{constructor(L,D=[]){super(),this.logger=new _.MultiplexLogger([L,...D]),this._register(L.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(L){this.logger.setLevel(L)}getLevel(){return this.logger.getLevel()}trace(L,...D){this.logger.trace(L,...D)}debug(L,...D){this.logger.debug(L,...D)}info(L,...D){this.logger.info(L,...D)}warn(L,...D){this.logger.warn(L,...D)}error(L,...D){this.logger.error(L,...D)}flush(){this.logger.flush()}}e.LogService=c}),define(se[58],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(se[59],oe([0,1,3,64,2,5]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class L extends c.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(w){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...w,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(w),_.Iterable.reduce(this.policies.entries(),(y,[g,S])=>({...y,[g]:S}),{})}getPolicyValue(w){return this.policies.get(w)}serialize(){return _.Iterable.reduce(Object.entries(this.policyDefinitions),(w,[P,y])=>({...w,[P]:{definition:y,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=L;class D{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=D}),define(se[215],oe([0,1,3,2,59]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(C){this.service=C,this.disposables=new _.DisposableStore}listen(C,w){switch(w){case"onDidChange":return R.Event.map(this.service.onDidChange,P=>P.reduce((y,g)=>({...y,[g]:this.service.getPolicyValue(g)??null}),{}),this.disposables)}throw new Error(`Event not found: ${w}`)}call(C,w,P){switch(w){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${w}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class L extends c.AbstractPolicyService{constructor(C,w){super(),this.channel=w;for(const P in C){const{definition:y,value:g}=C[P];this.policyDefinitions[P]=y,g!==void 0&&this.policies.set(P,g)}this.channel.listen("onDidChange")(P=>{for(const y in P){const g=P[y];g===null?this.policies.delete(y):this.policies.set(y,g)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(C){const w=await this.channel.call("updatePolicyDefinitions",C);for(const P in w)this.policies.set(P,w[P])}}e.PolicyChannelClient=L}),define(se[106],oe([0,1,22,4,36,96]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof _.globals.vscode<"u"&&typeof _.globals.vscode.context<"u"){const D=_.globals.vscode.context.configuration();if(D)L=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){L=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:D,searchUrl:C,itemUrl:w,controlUrl:P}=L.extensionsGallery||{};Object.assign(L,{extensionsGallery:{serviceUrl:c.env.VSCODE_GALLERY_SERVICE_URL||D,searchUrl:c.env.VSCODE_GALLERY_SEARCH_URL||C,itemUrl:c.env.VSCODE_GALLERY_ITEM_URL||w,controlUrl:c.env.VSCODE_GALLERY_CONTROL_URL||P}});try{const y=(...p)=>p.reduce((h,u)=>(Object.keys(u).forEach(f=>{Array.isArray(h[f])&&Array.isArray(u[f])?h[f]=u[f]:typeof h[f]=="object"&&typeof u[f]=="object"?h[f]=y(h[f],u[f]):h[f]=u[f]}),h),{}),g=(0,T.getUserDataPath)({},L.nameShort),S=_.isWindows?`file:///${g}/product.json`:`file://${g}/product.json`,d=Z.__$__nodeRequire(R.FileAccess.asFileUri(S).fsPath);L=y(L,d)}catch{}if(c.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const y=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:y.version,release:y.release})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(se[26],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(se[216],oe([0,1,6,9,2,13,28,8,26]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends c.Disposable{constructor(y,g,S){super(),this.productService=g,this.logService=S,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(y)},3e4)).schedule()}async cleanUpCodeCaches(y){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),S=(0,T.dirname)(y),d=(0,T.basename)(y),p=await L.Promises.readdir(S);await Promise.all(p.map(async h=>{if(h===d)return;const u=(0,T.join)(S,h),f=await L.Promises.stat(u);if(f.isDirectory()&&g-f.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${h}.`),L.Promises.rm(u)}))}catch(g){(0,_.onUnexpectedError)(g)}}};w=Se([K(1,C.IProductService),K(2,D.ILogService)],w),e.CodeCacheCleaner=w}),define(se[217],oe([0,1,6,9,2,13,28,15,8,26]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends c.Disposable{constructor(g,S,d){super(),this.environmentService=g,this.logService=S,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),S=JSON.parse(await L.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(S)){const v=S[f];g[`${v.hash}.${f}`]=!0}const d=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(d))return;const h=await L.Promises.readdir(d);for(const f of h){if(g[f]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await L.Promises.rm((0,T.join)(d,f))}const u=Date.now();for(const f of Object.keys(g)){const v=(0,T.join)(d,f),b=await L.Promises.readdir(v);for(const I of b){if(I==="tcf.json")continue;const i=(0,T.join)(v,I),s=await L.Promises.stat(i);s.isDirectory()&&u-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(f,I)}`),await L.Promises.rm(i))}}}catch(g){(0,_.onUnexpectedError)(g)}}};P=Se([K(0,D.INativeEnvironmentService),K(1,C.ILogService),K(2,w.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(se[218],oe([0,1,21,2,23,193,14,26]),function(Z,e,R,_,c,T,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=class extends _.Disposable{constructor(P,y){super(),this.fileService=P,this.productService=y,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,g])=>this.allConfigBasedTips.set(g.configPath,g))}getConfigBasedTips(P){return this.getValidConfigBasedTips(P)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(P){const y=[];for(const[g,S]of this.allConfigBasedTips)if(!(S.configScheme&&S.configScheme!==P.scheme))try{const d=await this.fileService.readFile((0,c.joinPath)(P,g)),p=new Map;Object.entries(S.recommendations).forEach(([u,f])=>{if((0,R.isNonEmptyArray)(f.remotes))for(const v of f.remotes)p.set(v,{extensionId:u,extensionName:f.name,configName:S.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled});else y.push({extensionId:u,extensionName:f.name,configName:S.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled})});const h=(0,T.getDomainsOfRemotes)(d.value.toString(),[...p.keys()]);for(const u of h){const f=p.get(u);f&&y.push(f)}}catch{}return y}};C=Se([K(0,L.IFileService),K(1,D.IProductService)],C),e.ExtensionTipsService=C}),define(se[219],oe([0,1,13,5]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,_.createDecorator)("IV8InspectProfilingService");var c;(function(T){function L(C){return Boolean(C.samples&&C.timeDeltas)}T.isValidProfile=L;function D(C,w="noAbsolutePaths"){for(const P of C.nodes)P.callFrame&&P.callFrame.url&&((0,R.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,R.join)(w,(0,R.basename)(P.callFrame.url)));return C}T.rewriteAbsolutePaths=D})(c=e.Utils||(e.Utils={}))}),define(se[220],oe([0,1,31]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class _{constructor(){this._sessions=new Map}async startProfiling(T){const D=await(await new Promise((w,P)=>{Z(["v8-inspect-profiler"],w,P)})).startProfiling({port:T.port,checkForPaused:!0}),C=(0,R.generateUuid)();return this._sessions.set(C,D),C}async stopProfiling(T){const L=this._sessions.get(T);if(!L)throw new Error(`UNKNOWN session '${T}'`);const D=await L.stop();return this._sessions.delete(T),D.profile}}e.InspectProfilingService=_}),define(se[40],oe([0,1,129,12]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class c{constructor(){this.data=new Map}add(L,D){R.ok(_.isString(L)),R.ok(_.isObject(D)),R.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,D)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new c}),define(se[107],oe([0,1,3,40]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function c(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,w){this.schemasById[c(C)]=w,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new T;_.Registry.add(e.Extensions.JSONContribution,L)}),define(se[46],oe([0,1,21,3,12,156,16,107,40]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=C.Registry.as(D.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new _.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new _.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const t=new Set;this.doRegisterConfigurations(i,s,t),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const s=new Set;this.doDeregisterConfigurations(i,s),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:i,remove:s}){const t=new Set;this.doDeregisterConfigurations(s,t),this.doRegisterConfigurations(i,!1,t),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(i){const s=new Set;this.doRegisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,s){const t=[];for(const{overrides:n,source:r}of i)for(const a in n)if(s.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.configurationDefaultsOverrides.get(a),l=o?.valuesSources??new Map;if(r)for(const O of Object.keys(n[a]))l.set(O,r);const m={...o?.value||{},...n[a]};this.configurationDefaultsOverrides.set(a,{source:r,value:m,valuesSources:l});const E=(0,L.getLanguageTagSettingPlainKey)(a),A={type:"object",default:m,description:T.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:c.isString(r)?void 0:r,defaultValueSource:r};t.push(...p(a)),this.configurationProperties[a]=A,this.defaultLanguageConfigurationOverridesNode.properties[a]=A}else{this.configurationDefaultsOverrides.set(a,{value:n[a],source:r});const o=this.configurationProperties[a];o&&(this.updatePropertyDefaultValue(a,o),this.updateSchema(a,o))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(i){const s=new Set;this.doDeregisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,s){for(const{overrides:t,source:n}of i)for(const r in t){const a=this.configurationDefaultsOverrides.get(r),o=c.isString(n)?n:n?.id,l=c.isString(a?.source)?a?.source:a?.source?.id;if(o===l)if(s.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const m=this.configurationProperties[r];m&&(this.updatePropertyDefaultValue(r,m),this.updateSchema(r,m))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let s=!1;const t=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,t),s=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,t),s=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,t),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const s of i)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,s,t){i.forEach(n=>{this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties,void 0,t),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(i,s){const t=n=>{if(n.properties)for(const r in n.properties){s.add(r);const a=this.configurationProperties[r];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,n.properties[r])}n.allOf?.forEach(r=>t(r))};for(const n of i){t(n);const r=this.configurationContributors.indexOf(n);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(i,s=!0,t,n,r=3,a){r=c.isUndefinedOrNull(i.scope)?r:i.scope;const o=i.properties;if(o)for(const m in o){const E=o[m];if(s&&v(m,E)){delete o[m];continue}if(E.source=t,E.defaultDefaultValue=o[m].default,this.updatePropertyDefaultValue(m,E),e.OVERRIDE_PROPERTY_REGEX.test(m)?E.scope=void 0:(E.scope=c.isUndefinedOrNull(E.scope)?r:E.scope,E.restricted=c.isUndefinedOrNull(E.restricted)?!!n?.includes(m):E.restricted),o[m].hasOwnProperty("included")&&!o[m].included){this.excludedConfigurationProperties[m]=o[m],delete o[m];continue}else this.configurationProperties[m]=o[m],o[m].policy?.name&&this.policyConfigurations.set(o[m].policy.name,m);!o[m].deprecationMessage&&o[m].markdownDeprecationMessage&&(o[m].deprecationMessage=o[m].markdownDeprecationMessage),a.add(m)}const l=i.allOf;if(l)for(const m of l)this.validateAndRegisterProperties(m,s,t,n,r,a)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const s=t=>{const n=t.properties;if(n)for(const a in n)this.updateSchema(a,n[a]);t.allOf?.forEach(s)};s(i)}updateSchema(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.resourceLanguageSettingsSchema.properties[i]=s;break}}removeFromSchema(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const s=`[${i}]`,t={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}}registerOverridePropertyPatternKey(){const i={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,s){const t=this.configurationDefaultsOverrides.get(i);let n=t?.value,r=t?.source;c.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),c.isUndefined(n)&&(n=u(s.type)),s.default=n,s.defaultValueSource=r}}const S="\\[([^\\]]+)\\]",d=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(I){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(I)){let s=d.exec(I);for(;s?.length;){const t=s[1].trim();t&&i.push(t),s=d.exec(I)}}return(0,R.distinct)(i)}e.overrideIdentifiersFromKey=p;function h(I){return I.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=h;function u(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const f=new g;C.Registry.add(e.Extensions.Configuration,f);function v(I,i){return I.trim()?e.OVERRIDE_PROPERTY_REGEX.test(I)?T.localize(7,null,I):f.getConfigurationProperties()[I]!==void 0?T.localize(8,null,I):i.policy?.name&&f.getPolicyConfigurations().get(i.policy?.name)!==void 0?T.localize(9,null,I,i.policy?.name,f.getPolicyConfigurations().get(i.policy?.name)):null:T.localize(6,null)}e.validateProperty=v;function b(){const I=[],i=f.getConfigurationProperties();for(const s of Object.keys(i))I.push([s,i[s].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=b}),define(se[74],oe([0,1,21,3,35,2,37,32,12,11,16,46,40]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function S(s){return Object.isFrozen(s)?s:D.deepFreeze(s)}class d{constructor(t={},n=[],r=[],a){this._contents=t,this._keys=n,this._overrides=r,this.raw=a,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof d)return n;const r=new p("");return r.parseRaw(n),r.configurationModel});this._rawConfiguration=t.reduce((n,r)=>r===n?r:n.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}inspect(t,n){const r=this.rawConfiguration.getValue(t),a=n?this.rawConfiguration.getOverrideValue(t,n):void 0,o=n?this.rawConfiguration.override(n).getValue(t):r;return{value:r,override:a,merged:o}}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,P.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const r of this.overrides)r.identifiers.includes(t)&&n.push(...r.keys);return R.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return R.distinct(t)}override(t){let n=this.overrideConfigurations.get(t);return n||(n=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,n)),n}merge(...t){const n=D.deepClone(this.contents),r=D.deepClone(this.overrides),a=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const l of t)if(o.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.mergeContents(n,l.contents);for(const m of l.overrides){const[E]=r.filter(A=>R.equals(A.identifiers,m.identifiers));E?(this.mergeContents(E.contents,m.contents),E.keys.push(...m.keys),E.keys=R.distinct(E.keys)):r.push(D.deepClone(m))}for(const m of l.keys)a.indexOf(m)===-1&&a.push(m)}return new d(n,a,r,o.every(l=>l instanceof d)?void 0:o)}createOverrideConfigurationModel(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const a of R.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[a];const l=n[a];l&&(typeof o=="object"&&typeof l=="object"?(o=D.deepClone(o),this.mergeContents(o,l)):o=l),r[a]=o}return new d(r,this.keys,this.overrides)}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&C.isObject(t[r])&&C.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=D.deepClone(n[r])}}getContentsForOverrideIdentifer(t){let n=null,r=null;const a=o=>{o&&(r?this.mergeContents(r,o):r=D.deepClone(o))};for(const o of this.overrides)R.equals(o.identifiers,[t])?n=o.contents:o.identifiers.includes(t)&&a(o.contents);return a(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.updateValue(t,n,!0)}setValue(t,n){this.updateValue(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,P.removeFromValueTree)(this.contents,t),y.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>R.equals(r.identifiers,(0,y.overrideIdentifiersFromKey)(t))),1))}updateValue(t,n,r){(0,P.addToValueTree)(this.contents,t,n,a=>console.error(a)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),y.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,P.toValuesTree)(this.contents[t],a=>console.error(a))})}}e.ConfigurationModel=d;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!C.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:r,keys:a,overrides:o,restricted:l,hasExcludedProperties:m}=this.doParseRaw(t,n);this._configurationModel=new d(r,a,o,m?[t]:void 0),this._restrictedConfigurations=l||[]}doParseContent(t){let n={},r=null,a=[];const o=[],l=[];function m(A){Array.isArray(a)?a.push(A):r!==null&&(a[r]=A)}const E={onObjectBegin:()=>{const A={};m(A),o.push(a),a=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const A=[];m(A),o.push(a),a=A,r=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:m,onError:(A,O,F)=>{l.push({error:A,offset:O,length:F})}};if(t)try{c.visit(t,E),n=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(t,n){const r=g.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,r,!0,n);t=a.raw;const o=(0,P.toValuesTree)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),l=Object.keys(t),m=this.toOverrides(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:l,overrides:m,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(t,n,r,a){let o=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:o};const l={},m=[];for(const E in t)if(y.OVERRIDE_PROPERTY_REGEX.test(E)&&r){const A=this.filter(t[E],n,!1,a);l[E]=A.raw,o=o||A.hasExcludedProperties,m.push(...A.restricted)}else{const A=n[E],O=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&m.push(E),(O===void 0||a.scopes===void 0||a.scopes.includes(O))&&!(a.skipRestricted&&A?.restricted)?l[E]=t[E]:o=!0}return{raw:l,restricted:m,hasExcludedProperties:o}}toOverrides(t,n){const r=[];for(const a of Object.keys(t))if(y.OVERRIDE_PROPERTY_REGEX.test(a)){const o={};for(const l in t[a])o[l]=t[a][l];r.push({identifiers:(0,y.overrideIdentifiersFromKey)(a),keys:Object.keys(o),contents:(0,P.toValuesTree)(o,n)})}return r}}e.ConfigurationModelParser=p;class h extends T.Disposable{constructor(t,n,r,a){super(),this.userSettingsResource=t,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(_.Event.any(_.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),_.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class u{constructor(t,n,r,a,o,l,m,E,A,O,F,M,k){this.key=t,this.overrides=n,this._value=r,this.overrideIdentifiers=a,this.defaultConfiguration=o,this.policyConfiguration=l,this.applicationConfiguration=m,this.userConfiguration=E,this.localUserConfiguration=A,this.remoteUserConfiguration=O,this.workspaceConfiguration=F,this.folderConfigurationModel=M,this.memoryConfigurationModel=k}get value(){return S(this._value)}inspect(t,n,r){const a=t.inspect(n,r);return{get value(){return S(a.value)},get override(){return S(a.override)},get merged(){return S(a.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class f{constructor(t,n,r,a,o=new d,l=new d,m=new L.ResourceMap,E=new d,A=new L.ResourceMap){this._defaultConfiguration=t,this._policyConfiguration=n,this._applicationConfiguration=r,this._localUserConfiguration=a,this._remoteUserConfiguration=o,this._workspaceConfiguration=l,this._folderConfigurations=m,this._memoryConfiguration=E,this._memoryConfigurationByResource=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidatedConfigurationModel(t,n,r).getValue(t)}updateValue(t,n,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new d,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(t):a.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const a=this.getConsolidatedConfigurationModel(t,n,r),o=this.getFolderConfigurationModelForResource(n.resource,r),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,m=new Set;for(const E of a.overrides)for(const A of E.identifiers)a.getOverrideValue(t,A)!==void 0&&m.add(A);return new u(t,n,a.getValue(t),m.size?[...m]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,o||void 0,l)}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=[];if(!n){const{added:a,updated:o,removed:l}=I(this._defaultConfiguration,t);n=[...a,...o,...l]}for(const a of n)for(const o of(0,y.overrideIdentifiersFromKey)(a)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(o),m=t.getKeysForOverrideIdentifier(o),E=[...m.filter(A=>l.indexOf(A)===-1),...l.filter(A=>m.indexOf(A)===-1),...l.filter(A=>!D.equals(this._defaultConfiguration.override(o).getValue(A),t.override(o).getValue(A)))];r.push([o,E])}return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:r,removed:a}=I(this._policyConfiguration,t),o=[...n,...r,...a];return o.length&&this.updatePolicyConfiguration(t),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:r,removed:a,overrides:o}=I(this.applicationConfiguration,t),l=[...n,...r,...a];return l.length&&this.updateApplicationConfiguration(t),{keys:l,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:a,overrides:o}=I(this.localUserConfiguration,t),l=[...n,...r,...a];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:a,overrides:o}=I(this.remoteUserConfiguration,t),l=[...n,...r,...a];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:a,overrides:o}=I(this.workspaceConfiguration,t),l=[...n,...r,...a];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:a,updated:o,removed:l,overrides:m}=I(r,n),E=[...a,...o,...l];return(E.length||!r)&&this.updateFolderConfiguration(t,n),{keys:E,overrides:m}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:a,removed:o,overrides:l}=I(n,void 0);return{keys:[...r,...a,...o],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,n,r){let a=this.getConsolidatedConfigurationModelForResource(n,r);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const a=n.getFolder(t);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const o=this._memoryConfigurationByResource.get(t);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(n=r.merge(a),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:a,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:a,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this._workspaceConfiguration.keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.policy),a=this.parseConfigurationModel(t.application),o=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),m=t.folders.reduce((E,A)=>(E.set(w.URI.revive(A[0]),this.parseConfigurationModel(A[1])),E),new L.ResourceMap);return new f(n,r,a,o,new d,l,m,new d,new L.ResourceMap)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides)}}e.Configuration=f;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,n=new Map;for(const a of s)a.keys.forEach(o=>t.add(o)),a.overrides.forEach(([o,l])=>{const m=(0,L.getOrSet)(n,o,new Set);l.forEach(E=>m.add(E))});const r=[];return n.forEach((a,o)=>r.push([o,[...a.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=v;class b{constructor(t,n,r,a){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=a,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const o of t.keys)this.affectedKeys.add(o);for(const[,o]of t.overrides)for(const l of o)this.affectedKeys.add(l);this._affectsConfigStr=this._marker;for(const o of this.affectedKeys)this._affectsConfigStr+=o+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){const r=this._marker+t,a=this._affectsConfigStr.indexOf(r);if(a<0)return!1;const o=a+r.length;if(o>=this._affectsConfigStr.length)return!1;const l=this._affectsConfigStr.charCodeAt(o);if(l!==this._markerCode1&&l!==this._markerCode2)return!1;if(n){const m=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.previous?.workspace):void 0,E=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!D.equals(m,E)}return!0}}e.ConfigurationChangeEvent=b;function I(s,t){const{added:n,removed:r,updated:a}=i(t?.rawConfiguration,s?.rawConfiguration),o=[],l=s?.getAllOverrideIdentifiers()||[],m=t?.getAllOverrideIdentifiers()||[];if(t){const E=m.filter(A=>!l.includes(A));for(const A of E)o.push([A,t.getKeysForOverrideIdentifier(A)])}if(s){const E=l.filter(A=>!m.includes(A));for(const A of E)o.push([A,s.getKeysForOverrideIdentifier(A)])}if(t&&s){for(const E of l)if(m.includes(E)){const A=i({contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)},{contents:t.getOverrideValue(void 0,E)||{},keys:t.getKeysForOverrideIdentifier(E)});o.push([E,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:r,updated:a,overrides:o}}function i(s,t){const n=s?t?s.keys.filter(o=>t.keys.indexOf(o)===-1):[...s.keys]:[],r=t?s?t.keys.filter(o=>s.keys.indexOf(o)===-1):[...t.keys]:[],a=[];if(s&&t){for(const o of t.keys)if(s.keys.indexOf(o)!==-1){const l=(0,P.getConfigurationValue)(t.contents,o),m=(0,P.getConfigurationValue)(s.contents,o);D.equals(l,m)||a.push(o)}}return{added:n,removed:r,updated:a}}}),define(se[221],oe([0,1,21,3,2,32,12,74,46,8,59,40]),function(Z,e,R,_,c,T,L,D,C,w,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends c.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new D.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(y.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:u})=>this.onDidUpdateConfiguration(Array.from(h),u))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(h,u){this.updateConfigurationModel(h,y.Registry.as(C.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:h})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new D.ConfigurationModel;const h=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(h),h)}updateConfigurationModel(h,u){const f=this.getConfigurationDefaultOverrides();for(const v of h){const b=f[v],I=u[v];b!==void 0?this._configurationModel.addValue(v,b):I?this._configurationModel.addValue(v,I.default):this._configurationModel.removeValue(v)}}}e.DefaultConfiguration=g;class S{constructor(){this.onDidChangeConfiguration=_.Event.None,this.configurationModel=new D.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let d=class extends c.Disposable{get configurationModel(){return this._configurationModel}constructor(h,u,f){super(),this.defaultConfiguration=h,this.policyService=u,this.logService=f,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new D.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(h=>this.onDidChangePolicies(h))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:h})=>this.update(await this.updatePolicyDefinitions(h),!0))),this._configurationModel}async updatePolicyDefinitions(h){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",h);const u={},f=[],v=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(const b of h){const I=v[b];if(!I){f.push(b);continue}if(I.policy){if(I.type!=="string"&&I.type!=="number"){this.logService.warn(`Policy ${I.policy.name} has unsupported type ${I.type}`);continue}f.push(b),u[I.policy.name]={type:I.type}}}return(0,L.isEmptyObject)(u)||await this.policyService.updatePolicyDefinitions(u),f}onDidChangePolicies(h){this.logService.trace("PolicyConfiguration#onDidChangePolicies",h);const u=y.Registry.as(C.Extensions.Configuration).getPolicyConfigurations(),f=(0,R.coalesce)(h.map(v=>u.get(v)));this.update(f,!0)}update(h,u){this.logService.trace("PolicyConfiguration#update",h);const f=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),v=[],b=this._configurationModel.isEmpty();for(const I of h){const i=f[I]?.policy?.name;if(i){const s=this.policyService.getPolicyValue(i);(b?s!==void 0:!(0,T.equals)(this._configurationModel.getValue(I),s))&&v.push([I,s])}else this._configurationModel.getValue(I)!==void 0&&v.push([I,void 0])}if(v.length){this.logService.trace("PolicyConfiguration#changed",v);const I=this._configurationModel;this._configurationModel=new D.ConfigurationModel;for(const i of I.keys)this._configurationModel.setValue(i,I.getValue(i));for(const[i,s]of v)s===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,s);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};d=Se([K(1,P.IPolicyService),K(2,w.ILogService)],d),e.PolicyConfiguration=d}),define(se[222],oe([0,1,6,3,2,23,16,74,221,59]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends c.Disposable{constructor(g,S,d,p){super(),this.settingsResource=g,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new C.DefaultConfiguration),this.policyConfiguration=d instanceof w.NullPolicyService?new C.NullPolicyConfiguration:this._register(new C.PolicyConfiguration(this.defaultConfiguration,d,p)),this.userConfiguration=this._register(new D.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,S)),this.configuration=new D.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new D.ConfigurationModel,new D.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:h,properties:u})=>this.onDidDefaultConfigurationChange(h,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(h=>this.onDidPolicyConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,S,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new D.Configuration(g,S,new D.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(g,S){const d=typeof g=="string"?g:void 0,p=(0,L.isConfigurationOverrides)(g)?g:(0,L.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(d,p,void 0)}updateValue(g,S,d,p){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(d,S,2)}onDidDefaultConfigurationChange(g,S){const d=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(g,S);this.trigger(p,d,7)}onDidPolicyConfigurationChange(g){const S=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(d,S,7)}trigger(g,S,d){const p=new D.ConfigurationChangeEvent(g,{data:S},this.configuration);p.source=d,p.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(g){switch(g){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(se[223],oe([0,1,9,5]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var c;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(c=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends R.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof T&&C._code===c.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof T&&C._code===c.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof T&&C._code===c.NoResolverFound}static isHandled(C){return C instanceof T&&C.isHandled}constructor(C,w=c.Unknown,P){super(C),this._message=C,this._code=w,this._detail=P,this.isHandled=w===c.NotAvailable&&P===!0,Object.setPrototypeOf(this,T.prototype)}}e.RemoteAuthorityResolverError=T;function L(D){const C=D.indexOf("+");return C===-1?D:D.substring(0,C)}e.getRemoteAuthorityPrefix=L}),define(se[75],oe([0,1,22]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function _(w){return w.scheme===R.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=_;function c(w){if(!w)return;const P=w.indexOf("+");return P<0?w:w.substr(0,P)}e.getRemoteName=c;function T(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=T;function L(w){const{host:P,port:y}=C(w);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:y}}e.parseAuthorityWithPort=L;function D(w,P){let{host:y,port:g}=C(w);return typeof g>"u"&&(g=P),{host:y,port:g}}e.parseAuthorityWithOptionalPort=D;function C(w){const P=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const y=w.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const g=w.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:w,port:void 0}}}),define(se[42],oe([0,1,27,5,75]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=T;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var C;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p>"u"||p===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){const u=typeof p=="string"?p:p.value,f=typeof h=="string"?h:h.value;return R.equalsIgnoreCase(u,f)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=w;function P(d){return y(d)}e.isApplicationScopedExtension=P;function y(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function g(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function S(d,p){if(p){const h=`onResolveRemoteAuthority:${(0,c.getRemoteName)(p)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,_.createDecorator)("IBuiltinExtensionsScannerService")}),define(se[224],oe([0,1,2,13,28,42]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends R.Disposable{constructor(C,w){super(),this.environmentService=C,this.extensionsManifestCache=(0,_.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(w.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(C){C.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){c.Promises.rm(this.extensionsManifestCache,c.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(se[225],oe([0,1,6,17,25,9,3,2,103,88,31,93,223,75]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const d=30*1e3;var p;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function h(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(U){const W=new c.CancellationTokenSource;return setTimeout(()=>W.cancel(),U),W.token}function f(U,W){if(U.isCancellationRequested||W.isCancellationRequested)return c.CancellationToken.Cancelled;const B=new c.CancellationTokenSource;return U.onCancellationRequested(()=>B.cancel()),W.onCancellationRequested(()=>B.cancel()),B.token}class v{get didTimeout(){return this._state==="timedout"}constructor(W){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((B,Q)=>{this._resolvePromise=B,this._rejectPromise=Q}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function b(U,W){const B=new v(W);return B.registerDisposable(U.onControlMessage(Q=>{const H=JSON.parse(Q.toString()),X=Y(H);X?B.reject(X):B.resolve(H)})),B.promise}function I(U,W,B,Q,H,X,te,le,he){const me=new v(he),pe=w.StopWatch.create(!1);return U.info(`Creating a socket (${le})...`),C.mark(`code/willCreateSocket/${te}`),W.connect(B,Q,H,X,le,(Ee,be)=>{me.didTimeout?(C.mark(`code/didCreateSocketError/${te}`),U.info(`Creating a socket (${le}) finished after ${pe.elapsed()} ms, but this is too late and has timed out already.`),Ee&&U.error(Ee),be?.dispose()):Ee||!be?(C.mark(`code/didCreateSocketError/${te}`),U.info(`Creating a socket (${le}) returned an error after ${pe.elapsed()} ms.`),me.reject(Ee)):(C.mark(`code/didCreateSocketOK/${te}`),U.info(`Creating a socket (${le}) was successful after ${pe.elapsed()} ms.`),me.resolve(be))}),me.promise}function i(U,W){const B=new v(W);return U.then(Q=>{B.didTimeout||B.resolve(Q)},Q=>{B.didTimeout||B.reject(Q)}),B.promise}async function s(U,W,B,Q){const H=V(U,W);U.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let X;try{X=await I(U.logService,U.socketFactory,U.host,U.port,(0,S.getRemoteServerRootPath)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,h(W),`renderer-${h(W)}-${U.reconnectionToken}`,Q)}catch(pe){throw U.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),U.logService.error(pe),pe}U.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let te,le;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(X,null),te=U.reconnectionProtocol,le=!1):(te=new y.PersistentProtocol({socket:X,measureRoundTripTime:!0}),le=!0),U.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const he=await i(U.signService.createNewMessage((0,P.generateUuid)()),Q),me={type:"auth",auth:U.connectionToken||"00000000000000000000",data:he.data};te.sendControl(_.VSBuffer.fromString(JSON.stringify(me)));try{const pe=await b(te,f(Q,u(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(U.logService.trace(`${H} 4/6. received SignRequest control message.`),!await i(U.signService.validate(he,pe.signedData),Q)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const be=await i(U.signService.sign(pe.data),Q),Re={type:"connectionType",commit:U.commit,signedData:be,desiredConnectionType:W};return B&&(Re.args=B),U.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(_.VSBuffer.fromString(JSON.stringify(Re))),{protocol:te,ownsProtocol:le}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(U.logService.error(`${H} the handshake timed out. Error:`),U.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${H} received error control message when negotiating connection. Error:`),U.logService.error(pe)),le&&x(te),pe}}async function t(U,W,B,Q){const H=Date.now(),X=V(U,W),{protocol:te,ownsProtocol:le}=await s(U,W,B,Q),he=new v(Q);return he.registerDisposable(te.onControlMessage(me=>{const pe=JSON.parse(me.toString()),Ee=Y(pe);Ee?(U.logService.error(`${X} received error control message when negotiating connection. Error:`),U.logService.error(Ee),le&&x(te),he.reject(Ee)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${$(H)}!`),he.resolve({protocol:te,firstMessage:pe}))})),he.promise}async function n(U,W){const{protocol:B}=await t(U,1,void 0,W);return{protocol:B}}async function r(U,W,B){const{protocol:Q,firstMessage:H}=await t(U,2,W,B),X=H&&H.debugPort;return{protocol:Q,debugPort:X}}async function a(U,W,B){const Q=Date.now(),H=V(U,3),{protocol:X}=await s(U,3,W,B);return U.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${$(Q)}!`),X}async function o(U,W,B){const{host:Q,port:H,connectionToken:X}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,host:Q,port:H,connectionToken:X,reconnectionToken:W,reconnectionProtocol:B,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function l(U,W,B){return E(U,async Q=>{const{protocol:H}=await n(Q,c.CancellationToken.None);return new G(U,W,B,Q.reconnectionToken,H)})}e.connectRemoteAgentManagement=l;async function m(U,W){return E(U,async B=>{const{protocol:Q,debugPort:H}=await r(B,W,c.CancellationToken.None);return new q(U,W,B.reconnectionToken,Q,H)})}e.connectRemoteAgentExtensionHost=m;async function E(U,W){for(let Q=1;;Q++)try{const H=(0,P.generateUuid)(),X=await o(U,H,null);return await W(X)}catch(H){if(Q<5)U.logService.error(`[remote-connection][attempt ${Q}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(H);else throw U.logService.error(`[remote-connection][attempt ${Q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(H),ne.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(H)),H}}async function A(U,W,B){const Q=await o(U,(0,P.generateUuid)(),null);return await a(Q,{host:W,port:B},c.CancellationToken.None)}e.connectRemoteAgentTunnel=A;function O(U){return(0,R.createCancelablePromise)(W=>new Promise((B,Q)=>{const H=setTimeout(B,U*1e3);W.onCancellationRequested(()=>{clearTimeout(H),B()})}))}var F;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain",U[U.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class M{constructor(W,B){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=M;class k{constructor(W,B,Q,H){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.durationSeconds=Q,this.cancellableTimer=H,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=k;class N{constructor(W,B,Q){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=N;class z{constructor(W,B,Q){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=z;class j{constructor(W,B){this.reconnectionToken=W,this.connectionHealth=B,this.type=5}}e.ConnectionHealthChangedEvent=j;class J{constructor(W,B,Q,H){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.attempt=Q,this.handled=H,this.type=3}}e.ReconnectionPermanentFailureEvent=J;class ne extends D.Disposable{static triggerPermanentFailure(W,B,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=B,this._permanentFailureHandled=Q,this._instances.forEach(H=>H._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(W=>W._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(W=>W._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||ne._permanentFailure}constructor(W,B,Q,H,X){super(),this._connectionType=W,this._options=B,this.reconnectionToken=Q,this.protocol=H,this._reconnectionFailureIsFatal=X,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new z(this.reconnectionToken,0,0)),this._register(H.onSocketClose(te=>{const le=ae(this._connectionType,this.reconnectionToken,!0);te?te.type===0?(this._options.logService.info(`${le} received socket close event (hadError: ${te.hadError}).`),te.error&&this._options.logService.error(te.error)):(this._options.logService.info(`${le} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this._options.logService.error(te.event)):this._options.logService.info(`${le} received socket close event.`),this._beginReconnecting()})),this._register(H.onSocketTimeout(te=>{const le=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(H.onHighRoundTripTime(te=>{const le=re(this._connectionType,this.reconnectionToken);this._options.logService.info(`${le} high roundtrip time: ${te.roundTripTime}ms (${te.recentHighRoundTripCount} of ${5} recent samples)`)})),this._register(H.onDidChangeConnectionHealth(te=>{this._onDidStateChange.fire(new j(this.reconnectionToken,te))})),ne._instances.push(this),this._register((0,D.toDisposable)(()=>{const te=ne._instances.indexOf(this);te>=0&&ne._instances.splice(te,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ne._permanentFailureMillisSinceLastIncomingData,ne._permanentFailureAttempt,ne._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const W=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const H=Q<B.length?B[Q]:B[B.length-1];try{if(H>0){const te=O(H);this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,te)),this._options.logService.info(`${W} waiting for ${H} seconds before reconnecting...`);try{await te}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${W} resolving connection...`);const X=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${X.host}:${X.port}...`),await this._reconnect(X,u(d)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((0,T.isCancellationError)(X)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if(X instanceof g.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,g.RemoteAuthorityResolverError.isHandled(X));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(W,B,Q){this._reconnectionFailureIsFatal?ne.triggerPermanentFailure(W,B,Q):this._gotoPermanentFailure(W,B,Q)}_gotoPermanentFailure(W,B,Q){this._onDidStateChange.fire(new J(this.reconnectionToken,W,B,Q)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}ne._permanentFailure=!1,ne._permanentFailureMillisSinceLastIncomingData=0,ne._permanentFailureAttempt=0,ne._permanentFailureHandled=!1,ne._instances=[],e.PersistentConnection=ne;class G extends ne{constructor(W,B,Q,H,X){super(1,W,H,X,!0),this.client=this._register(new y.Client(X,{remoteAuthority:B,clientId:Q},W.ipcLogger))}async _reconnect(W,B){await n(W,B)}}e.ManagementPersistentConnection=G;class q extends ne{constructor(W,B,Q,H,X){super(2,W,Q,H,!1),this._startArguments=B,this.debugPort=X}async _reconnect(W,B){await r(W,this._startArguments,B)}}e.ExtensionHostPersistentConnection=q;function x(U){try{U.acceptDisconnect();const W=U.getSocket();U.dispose(),W.dispose()}catch(W){(0,T.onUnexpectedError)(W)}}function Y(U){if(U&&U.type==="error"){const W=new Error(`Connection error: ${U.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function ee(U,W){for(;U.length<W;)U+=" ";return U}function re(U,W){return`[remote-connection][${ee(h(U),13)}][${W.substr(0,5)}\u2026]`}function ae(U,W,B){return`${re(U,W)}[${B?"reconnect":"initial"}]`}function V(U,W){return`${ae(W,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function $(U){return`${Date.now()-U} ms`}}),define(se[226],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(se[227],oe([0,1,86,154]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(c,T,L,D,C,w){const P=g=>w(g,void 0),y=R.createConnection({host:c,port:T},()=>{y.removeListener("error",P);const g=Buffer.alloc(16);for(let h=0;h<16;h++)g[h]=Math.round(Math.random()*256);const S=g.toString("base64"),d=[`GET ws://${/:/.test(c)?`[${c}]`:c}:${T}${L}?${D}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`];y.write(d.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",p),w(void 0,new _.NodeSocket(y,C)))};y.on("data",p)});y.setNoDelay(!0),y.once("error",P)}}}),define(se[108],oe([0,1,5,172]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,R.createDecorator)("IRemoteTunnelService");var c;(function(T){T.disconnected={type:"disconnected"},T.uninitialized={type:"uninitialized"},T.connected=L=>({type:"connected",info:L}),T.connecting=L=>({type:"connecting",progress:L})})(c=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME=(0,_.localize)(0,null),e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(se[228],oe([0,1,138,16,8]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(D,C){this.configurationService=D,this.logService=C}async request(D,C){this.logService.trace("RequestService#request (browser) - begin",D.url),D.proxyAuthorization||(D.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const w=await(0,R.request)(D,C);return this.logService.trace("RequestService#request (browser) - success",D.url),w}catch(w){throw this.logService.error("RequestService#request (browser) - error",D.url,w),w}}async resolveProxy(D){}};T=Se([K(0,_.IConfigurationService),K(1,c.ILogService)],T),e.RequestService=T}),define(se[60],oe([0,1,17,174,46,5,40]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function D(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=D;function C(p){return p.res.statusCode===204}async function w(p){return C(p)?null:(await(0,R.streamToBuffer)(p.stream)).toString()}e.asText=w;async function P(p){if(!D(p))throw new Error("Server returned "+p.res.statusCode);return w(p)}e.asTextOrError=P;async function y(p){if(!D(p))throw new Error("Server returned "+p.res.statusCode);if(C(p))return null;const u=(await(0,R.streamToBuffer)(p.stream)).toString();try{return JSON.parse(u)}catch(f){throw f.message+=`:
`+u,f}}e.asJson=y;function g(p){d(p)}e.updateProxyConfigurationsScope=g;let S;function d(p){const h=L.Registry.as(c.Extensions.Configuration),u=S;S={id:"http",order:15,title:(0,_.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(4,null),(0,_.localize)(5,null),(0,_.localize)(6,null),(0,_.localize)(7,null)],default:"override",description:(0,_.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[S],remove:u?[u]:[]})}d(2)}),define(se[229],oe([0,1,25,22,14,60]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(C,w){this.requestService=C,this.fileService=w}async download(C,w,P=R.CancellationToken.None){if(C.scheme===_.Schemas.file||C.scheme===_.Schemas.vscodeRemote){await this.fileService.copy(C,w);return}const y={type:"GET",url:C.toString(!0)},g=await this.requestService.request(y,P);if(g.res.statusCode===200)await this.fileService.writeFile(w,g.stream);else{const S=await(0,T.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${S}`)}}};L=Se([K(0,T.IRequestService),K(1,c.IFileService)],L),e.DownloadService=L}),define(se[230],oe([0,1,17,25]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class c{constructor(D){this.service=D}listen(D,C){throw new Error("Invalid listen")}call(D,C,w,P=_.CancellationToken.None){switch(C){case"request":return this.service.request(w[0],P).then(async({res:y,stream:g})=>{const S=await(0,R.streamToBuffer)(g);return[{statusCode:y.statusCode,headers:y.headers},S]});case"resolveProxy":return this.service.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=c;class T{constructor(D){this.channel=D}async request(D,C){const[w,P]=await this.channel.call("request",[D],C);return{res:w,stream:(0,R.bufferToStream)(P)}}async resolveProxy(D){return this.channel.call("resolveProxy",[D])}}e.RequestChannelClient=T}),define(se[231],oe([0,1,12,228,230]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class T{constructor(D,C,w,P){this.configurationService=C,this.productService=w,this.logService=P,this.browserRequestService=new _.RequestService(C,P),this.mainRequestService=new c.RequestChannelClient(D.getChannel("request"))}request(D,C){return this.getRequestService().request(D,C)}async resolveProxy(D){return this.getRequestService().resolveProxy(D)}getRequestService(){return this.isMainRequestServiceEnabled()?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}isMainRequestServiceEnabled(){const D=this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,R.isBoolean)(D)?D:this.productService.quality!=="stable"}}e.SharedProcessRequestService=T}),define(se[109],oe([0,1,66,5]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function c(T){return(0,R.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=c,e.ISharedProcessWorkerService=(0,_.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(se[232],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(_){_.Spawn="vscode:shared-process->shared-process-worker=spawn",_.Terminate="vscode:shared-process->shared-process-worker=terminate",_.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",_.Ready="vscode:shared-process-worker->shared-process=ready",_.Ack="vscode:shared-process-worker->shared-process=ack",_.Trace="vscode:shared-process-worker->shared-process=trace",_.Info="vscode:shared-process-worker->shared-process=info",_.Warn="vscode:shared-process-worker->shared-process=warn",_.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(se[233],oe([0,1,94,6,25,3,2,22,31,8,109,232]),function(Z,e,R,_,c,T,L,D,C,w,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let g=class{constructor(p){this.logService=p,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(p){const h=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${h})`);const u=(0,P.hash)(p);this.processeDisposables.has(u)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${h})`),this.doDisposeWorker(p));const f=new c.CancellationTokenSource;let v,b,I;this.processeDisposables.set(u,n=>{f.dispose(!0),v?.terminate(p,c.CancellationToken.None),b?.close(),I?.close(),this.processeDisposables.delete(u);const r=this.processResolvers.get(u);r&&(this.processResolvers.delete(u),r({reason:n}))}),v=await this.getOrCreateWebWorker(p);const i=new Promise(n=>{this.processResolvers.set(u,n)});if(f.token.isCancellationRequested)return i;const{port1:s,port2:t}=new MessageChannel;return b=s,I=t,await v.spawn(p,I,f.token),f.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${h})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",p,[b])),i}getOrCreateWebWorker(p){let h=this.workers.get(p.process.moduleId);if(!h){this.logService.trace(`SharedProcess: creating new web worker (${p.process.moduleId})`);const u=new S(p.process.type,this.logService);h=u.init(),u.onDidProcessSelfTerminate(({configuration:f,reason:v})=>{this.doDisposeWorker(f,v)}),this.workers.set(p.process.moduleId,h)}return h}async disposeWorker(p){return this.doDisposeWorker(p)}doDisposeWorker(p,h){const u=this.processeDisposables.get((0,P.hash)(p));u&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),u(h))}};g=Se([K(0,w.ILogService)],g),e.SharedProcessWorkerService=g;class S extends L.Disposable{constructor(p,h){super(),this.type=p,this.logService=h,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const p=new _.DeferredPromise,h=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return h.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},h.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},h.onmessage=u=>{const{id:f,message:v,configuration:b,nonce:I}=u.data;switch(f){case y.SharedProcessWorkerMessages.Ready:p.complete(h);break;case y.SharedProcessWorkerMessages.Ack:if(I){const i=this.mapMessageNonceToPendingMessageResolve.get(I);i&&(this.mapMessageNonceToPendingMessageResolve.delete(I),i())}break;case y.SharedProcessWorkerMessages.SelfTerminated:b&&v&&this._onDidProcessSelfTerminate.fire({configuration:b,reason:JSON.parse(v)});break;case y.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,v);break;case y.SharedProcessWorkerMessages.Info:v&&this.logService.info(v);break;case y.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,v);break;case y.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,v);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},h.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),p.p}async send(p,h,u){const f=await this.workerReady;if(!h.isCancellationRequested)return new Promise(v=>{const b=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(b,v);const I={...p,nonce:b};u?f.postMessage(I,[u]):f.postMessage(I),h.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(b)&&v()})})}spawn(p,h,u){const f={id:y.SharedProcessWorkerMessages.Spawn,configuration:p,environment:{bootstrapPath:D.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.send(f,u,h)}terminate(p,h){const u={id:y.SharedProcessWorkerMessages.Terminate,configuration:p};return this.send(u,h)}}}),define(se[234],oe([0,1,63,22,192]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends c.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:_.Schemas.vscodeUserData})}}Se([R.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(se[235],oe([0,1,50,13,175,25,38,9,4,31,151,191,6,131]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let d;async function p(u,f,v,b){return v["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(b)&&!v["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(b)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=g.Promises.withAsyncBody(async(I,i)=>{const s=new T.CancellationTokenSource;let t=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,S.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),i(new Error((0,c.localize)(0,null)))},t);try{I(await h(f,s.token))}catch(a){!(0,D.isCancellationError)(a)&&!s.token.isCancellationRequested?i(new Error((0,c.localize)(1,null,(0,L.toErrorMessage)(a)))):I({})}finally{clearTimeout(r),s.dispose()}})),d)}e.getResolvedShellEnv=p;async function h(u,f){const v=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",v);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",b);const I=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(I+"({.*})"+I),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",s);const t=await(0,P.getSystemShell)(C.OS,s);return u.trace("getUnixShellEnvironment#shell",t),new Promise((n,r)=>{if(f.isCancellationRequested)return r(new D.CancellationError);const a=(0,_.basename)(t);let o,l;const m=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(o=`& '${process.execPath}' ${m} -p '''${I}'' + JSON.stringify(process.env) + ''${I}'''`,l=["-Login","-Command"]):(o=`'${process.execPath}' ${m} -p '"${I}" + JSON.stringify(process.env) + "${I}"'`,a==="tcsh"||a==="csh"?l=["-ic"]:l=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),o);const E=(0,R.spawn)(t,[...l,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});f.onCancellationRequested(()=>(E.kill(),r(new D.CancellationError))),E.on("error",F=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(F)),r(F)});const A=[];E.stdout.on("data",F=>A.push(F));const O=[];E.stderr.on("data",F=>O.push(F)),E.on("close",(F,M)=>{const k=Buffer.concat(A).toString("utf8");u.trace("getUnixShellEnvironment#raw",k);const N=Buffer.concat(O).toString("utf8");if(N.trim()&&u.trace("getUnixShellEnvironment#stderr",N),F||M)return r(new Error((0,c.localize)(2,null,F,M)));const z=i.exec(k),j=z?z[1]:"{}";try{const J=JSON.parse(j);v?J.ELECTRON_RUN_AS_NODE=v:delete J.ELECTRON_RUN_AS_NODE,b?J.ELECTRON_NO_ATTACH_CONSOLE=b:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.VSCODE_RESOLVING_ENVIRONMENT,delete J.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",J),n(J)}catch(J){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(J)),r(J)}})})}}),define(se[110],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(se[236],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((c,T)=>Z(["vsda"],c,T))}async createNewMessage(c){try{const T=await this.vsda(),L=new T.validator;if(L){const D=String(R._nextId++);return this.validators.set(D,L),{id:D,data:L.createNewMessage(c)}}}catch{}return{id:"",data:c}}async validate(c,T){if(!c.id)return!0;const L=this.validators.get(c.id);if(!L)return!1;this.validators.delete(c.id);try{return L.validate(T)==="ok"}catch{return!1}}async sign(c){try{const T=await this.vsda(),L=new T.signer;if(L)return L.sign(c)}catch{}return c}}R._nextId=1,e.SignService=R}),define(se[76],oe([0,1,3,2]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class c extends _.Disposable{constructor(y,g,S){super(),this.channel=y,this.profile=g,this.workspace=S}async getItems(){const y={profile:this.profile,workspace:this.workspace},g=await this.channel.call("getItems",y);return new Map(g)}updateItems(y){const g={profile:this.profile,workspace:this.workspace};return y.insert&&(g.insert=Array.from(y.insert.entries())),y.delete&&(g.delete=Array.from(y.delete.values())),this.channel.call("updateItems",g)}}class T extends c{constructor(y,g){super(y,g,void 0),this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(y=>this.onDidChangeStorage(y)))}onDidChangeStorage(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this._onDidChangeItemsExternal.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}}class L extends T{constructor(y){super(y,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=L;class D extends T{constructor(y,g){super(y,g)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=D;class C extends c{constructor(y,g){super(y,void 0,g),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=C;class w{constructor(y){this.channel=y}isUsed(y){const g={payload:y,profile:void 0,workspace:void 0};return this.channel.call("isUsed",g)}}e.StorageClient=w}),define(se[111],oe([0,1,4,36,11,31]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(w){if(R.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function D(w,P,y,g,S,d,p,h,u,f){const v=Object.create(null);v["common.machineId"]=p,v.sessionID=(0,T.generateUuid)()+Date.now(),v.commitHash=S,v.version=d,v["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,R.PlatformToString)(R.platform),v["common.nodePlatform"]=_.platform,v["common.nodeArch"]=g,v["common.product"]=f||"desktop",h&&(v["common.msftInternal"]=h);let b=0;const I=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),R.isLinuxSnap&&(v["common.snap"]="true");const i=L(y);i&&(v["common.platformDetail"]=i);try{const s=await w.readFile(c.URI.file(u));v["common.source"]=s.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=D;function C(w){const P=_.env.USERDNSDOMAIN;if(!P)return!1;const y=P.toLowerCase();return w.some(g=>y===g)}e.verifyMicrosoftInternalDomain=C}),define(se[19],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var _;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(_=e.TelemetryLevel||(e.TelemetryLevel={}));var c;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(c=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(se[237],oe([0,1,34,6,35,22,13,4,11,148,28,150,97,14,26,19]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function u(i,s){const t=`${i}::${s.join(":")}`,n=h.get(t);if(n)return n;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,o=new Map,l=2e4;function m(A,O,F,M){const k=O.substring(A.length+1);return _.Promises.withAsyncBody(async N=>{let z;try{z=await P.Promises.readdir(O,{withFileTypes:!0})}catch{N();return}if(M.count>=l){M.count+=z.length,M.maxReached=!0,N();return}let j=z.length;if(j===0){N();return}let J=z;M.count+z.length>l&&(M.maxReached=!0,j=l-M.count,J=z.slice(0,j)),M.count+=z.length;for(const ne of J)if(ne.isDirectory()){if(F.includes(ne.name)||await m(A,(0,L.join)(O,ne.name),F,M),--j===0){N();return}}else{const G=ne.name.lastIndexOf(".");if(G>=0){const q=ne.name.substring(G+1);q&&a.set(q,(a.get(q)??0)+1)}for(const q of r)q.relativePathPattern?.test(k)!==!1&&q.filePattern.test(ne.name)&&o.set(q.tag,(o.get(q.tag)??0)+1);if(--j===0){N();return}}})}const E=_.Promises.withAsyncBody(async A=>{const O={count:0,maxReached:!1};await m(i,i,s,O);const F=await b(i);A({configFiles:f(o),fileTypes:f(a),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:F})});return h.set(t,E),E}e.collectWorkspaceStats=u;function f(i){return Array.from(i.entries(),([s,t])=>({name:s,count:t})).sort((s,t)=>t.count-s.count)}function v(){const i={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},s=R.cpus();return s&&s.length>0&&(i.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),i}e.getMachineInfo=v;async function b(i){try{const s=new Map,t=(0,L.join)(i,".vscode","launch.json"),n=await P.Promises.readFile(t),r=[],a=(0,c.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${t}`),[];if((0,c.getNodeType)(a)==="object"&&a.configurations)for(const o of a.configurations){const l=o.type;l&&(s.has(l)?s.set(l,s.get(l)+1):s.set(l,1))}return f(s)}catch{return[]}}e.collectLaunchConfigs=b;let I=class{constructor(s,t){this.telemetryService=s,this.productService=t}formatMachineInfo(s){const t=[];return t.push(`OS Version:       ${s.os}`),t.push(`CPUs:             ${s.cpus}`),t.push(`Memory (System):  ${s.memory}`),t.push(`VM:               ${s.vmHint}`),t.join(`
`)}formatEnvironment(s){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const n=R.cpus();return n&&n.length>0&&t.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),t.push(`Memory (System):  ${(R.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||t.push(`Load (avg):       ${R.loadavg().map(r=>Math.round(r)).join(", ")}`),t.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${s.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(s,t){return Promise.all([(0,y.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async n=>{let[r,a]=n,o=this.formatProcessList(s,r);return t.forEach(l=>{if((0,g.isRemoteDiagnosticError)(l))o+=`
${l.errorMessage}`,a+=`
${l.errorMessage}`;else if(o+=`

Remote: ${l.hostName}`,l.processes&&(o+=`
${this.formatProcessList(s,l.processes)}`),l.workspaceMetadata){a+=`
|  Remote: ${l.hostName}`;for(const m of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[m];let A=`${E.fileCount} files`;E.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${m}): ${A}`,a+=this.formatWorkspaceStats(E)}}}),{processInfo:o,workspaceInfo:a}})}async getSystemInfo(s,t){const{memory:n,vmHint:r,os:a,cpus:o}=v(),l={os:a,memory:n,cpus:o,vmHint:r,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:t};return D.isWindows||(l.load=`${R.loadavg().map(m=>Math.round(m)).join(", ")}`),D.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(s,t){const n=[];return(0,y.listProcesses)(s.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(s)),n.push(""),n.push(this.formatProcessList(s,r)),s.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(s))),t.forEach(a=>{if((0,g.isRemoteDiagnosticError)(a))n.push(`
${a.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${a.hostName}`),n.push(this.formatMachineInfo(a.machineInfo)),a.processes&&n.push(this.formatProcessList(s,a.processes)),a.workspaceMetadata)for(const o of Object.keys(a.workspaceMetadata)){const l=a.workspaceMetadata[o];let m=`${l.fileCount} files`;l.maxFilesReached&&(m=`more than ${m}`),n.push(`Folder (${o}): ${m}`),n.push(this.formatWorkspaceStats(l))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(s){const t=[];let r=0;const a=(E,A)=>{const O=` ${E}(${A})`;r+O.length>60?(t.push(o),o="|                 ",r=o.length):r+=O.length,o+=O};let o="|      File types:";const l=10,m=s.fileTypes.length>l?l:s.fileTypes.length;for(let E=0;E<m;E++){const A=s.fileTypes[E];a(A.name,A.count)}if(t.push(o),s.configFiles.length>=0&&(o="|      Conf files:",r=0,s.configFiles.forEach(E=>{a(E.name,E.count)}),t.push(o)),s.launchConfigFiles.length>0){let E="|      Launch Configs:";s.launchConfigFiles.forEach(A=>{E+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),t.push(E)}return t.join(`
`)}expandGPUFeatures(s){const t=Math.max(...Object.keys(s).map(n=>n.length));return Object.keys(s).map(n=>`${n}:  ${" ".repeat(t-n.length)}  ${s[n]}`).join(`
                  `)}formatWorkspaceMetadata(s){const t=[],n=[];return s.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(t.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const o=C.URI.revive(a);if(o.scheme===T.Schemas.file){const l=o.fsPath;n.push(u(l,["node_modules",".git"]).then(m=>{let E=`${m.fileCount} files`;m.maxFilesReached&&(E=`more than ${E}`),t.push(`|    Folder (${(0,L.basename)(l)}): ${E}`),t.push(this.formatWorkspaceStats(m))}).catch(m=>{t.push(`|      Error: Unable to collect workspace stats for folder ${l} (${m.toString()})`)}))}else t.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>t.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(s,t){const n=new Map;s.windows.forEach(a=>n.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(s.mainPID,n,r,t,0),r.join(`
`)}formatProcessItem(s,t,n,r,a){const o=a===0;let l;o?l=r.pid===s?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(l=`${l} (${t.get(r.pid)})`));const m=process.platform==="win32"?r.mem:R.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(m/S.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(r.children)&&r.children.forEach(E=>this.formatProcessItem(s,t,n,E,a+1))}async getWorkspaceFileExtensions(s){const t=new Set;for(const{uri:n}of s.folders){const r=C.URI.revive(n);if(r.scheme!==T.Schemas.file)continue;const a=r.fsPath;try{(await u(a,["node_modules",".git"])).fileTypes.forEach(l=>t.add(l.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(s){for(const{uri:t}of s.folders){const n=C.URI.revive(t);if(n.scheme!==T.Schemas.file)continue;const r=n.fsPath;try{const a=await u(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),a.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),a.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),a.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};I=Se([K(0,p.ITelemetryService),K(1,d.IProductService)],I),e.DiagnosticsService=I}),define(se[238],oe([0,1,108,3,19,15,2,8,13,50,26,4,6,104,16,173,34,11]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const f=[R.CONFIGURATION_KEY_HOST_NAME,R.CONFIGURATION_KEY_PREVENT_SLEEP];let v=class extends L.Disposable{constructor(I,i,s,t,n,r){super(),this.telemetryService=I,this.productService=i,this.environmentService=s,this.configurationService=r,this._onDidTokenFailedEmitter=new _.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new _.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeAccountEmitter=new _.Emitter,this.onDidChangeAccount=this._onDidChangeAccountEmitter.event,this._tunnelStatus=R.TunnelStates.disconnected;const a=u.URI.file((0,C.join)(s.logsPath,R.LOG_FILE_NAME));this._logger=this._register(t.createLogger(a,{name:R.LOGGER_NAME,id:R.LOG_CHANNEL_ID})),this._startTunnelProcessDelayer=new g.Delayer(100),this._register(this._logger.onDidChangeLogLevel(o=>this._logger.info("Log level changed to "+(0,D.LogLevelToString)(o)))),this._register(n.onWillShutdown(o=>{this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this.dispose()})),this._register(r.onDidChangeConfiguration(o=>{f.some(l=>o.affectsConfiguration(l))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}))}async getAccount(){return this._account}async updateAccount(I){if(I&&this._account?I.token!==this._account.token||I.providerId!==this._account.providerId:I!==this._account){this._account=I,this._onDidChangeAccountEmitter.fire(I),I?this._logger.info(`Account updated: ${I.accountLabel} (${I.providerId})`):this._logger.info("Account reset"),this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!I});try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(i){this._logger.error(i)}}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let I;y.isMacintosh?I=this.environmentService.appRoot:I=(0,C.dirname)((0,C.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,C.join)(I,"bin",`${this.productService.tunnelApplicationName}${y.isWindows?".exe":""}`)}return this._tunnelCommand}async updateTunnelProcess(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._account){this.setTunnelStatus(R.TunnelStates.disconnected);return}const{token:I,providerId:i,accountLabel:s}=this._account;this.setTunnelStatus(R.TunnelStates.connecting((0,p.localize)(0,null,s,i)));const t=(l,m)=>{l=l.replaceAll(I,"*".repeat(4)),m?this._logger.error(l):this._logger.info(l),!this.environmentService.isBuilt&&l.startsWith("   Compiling")&&this.setTunnelStatus(R.TunnelStates.connecting((0,p.localize)(1,null)))},n=this.runCodeTunneCommand("login",["user","login","--provider",i,"--access-token",I,"--log",(0,D.LogLevelToString)(this._logger.getLevel())],t);this._tunnelProcess=n;try{if(await n,this._tunnelProcess!==n)return}catch(l){this._logger.error(l),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(R.TunnelStates.disconnected);return}const r=this._getHostName();r?this.setTunnelStatus(R.TunnelStates.connecting((0,p.localize)(2,null,r))):this.setTunnelStatus(R.TunnelStates.connecting((0,p.localize)(3,null)));const a=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,D.LogLevelToString)(this._logger.getLevel())];r?a.push("--name",r):a.push("--random-name"),this._preventSleep()&&a.push("--no-sleep");const o=this.runCodeTunneCommand("tunnel",a,(l,m)=>{m?this._logger.error(l):this._logger.info(l);const E=l.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(E){const A={link:E[1],domain:E[2],hostName:E[4]};this.setTunnelStatus(R.TunnelStates.connected(A))}else l.match(/error refreshing token/)&&(o.cancel(),this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(R.TunnelStates.disconnected))});this._tunnelProcess=o,o.finally(()=>{o===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._account=void 0,this.setTunnelStatus(R.TunnelStates.disconnected))})}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(I){this._tunnelStatus=I,this._onDidChangeTunnelStatusEmitter.fire(I)}runCodeTunneCommand(I,i,s=()=>{}){return(0,g.createCancelablePromise)(t=>new Promise((n,r)=>{t.isCancellationRequested&&n();let a;if(t.onCancellationRequested(()=>{a&&(this._logger.info(`${I} terminating(${a.pid})`),a.kill())}),!this.environmentService.isBuilt)s("Building tunnel CLI from sources and run",!1),s(`${I} Spawning: cargo run -- tunnel ${i.join(" ")}`,!1),a=(0,w.spawn)("cargo",["run","--","tunnel",...i],{cwd:(0,C.join)(this.environmentService.appRoot,"cli")});else{s("Running tunnel CLI",!1);const o=this.getTunnelCommandLocation();s(`${I} Spawning: ${o} tunnel ${i.join(" ")}`,!1),a=(0,w.spawn)(o,["tunnel",...i],{cwd:(0,h.homedir)()})}a.stdout.on("data",o=>{if(a){const l=o.toString();s(l,!1)}}),a.stderr.on("data",o=>{if(a){const l=o.toString();s(l,!0)}}),a.on("exit",o=>{a&&(s(`${I} exit(${a.pid}): + ${o} `,!1),a=void 0,o===0?n():r())}),a.on("error",o=>{a&&(s(`${I} error(${a.pid}): + ${o} `,!0),a=void 0,r())})}))}async getHostName(){return this._getHostName()}_preventSleep(){return!!this.configurationService.getValue(R.CONFIGURATION_KEY_PREVENT_SLEEP)}_getHostName(){let I=this.configurationService.getValue(R.CONFIGURATION_KEY_HOST_NAME)||(0,h.hostname)();return I=I.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),I||void 0}};v=Se([K(0,c.ITelemetryService),K(1,P.IProductService),K(2,T.INativeEnvironmentService),K(3,D.ILoggerService),K(4,S.ISharedProcessLifecycleService),K(5,d.IConfigurationService)],v),e.RemoteTunnelService=v}),define(se[112],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appenders=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,{eventName:D,data:C}){return this.appenders.forEach(w=>w.log(D,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class _{constructor(T){this.channel=T}log(T,L){return this.channel.call("log",{eventName:T,data:L}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=_}),define(se[47],oe([0,1,32,12,3,16,75,111,19]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class w{constructor(o){this.value=o}}e.TelemetryTrustedValue=w;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,l){return Promise.resolve(void 0)}publicLog2(o,l){return this.publicLog(o,l)}publicLogError(o,l){return Promise.resolve(void 0)}publicLogError2(o,l){return this.publicLogError(o,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class y{async publicLog(o,l,m){}async publicLogError(o,l,m){}}e.NullEndpointTelemetryService=y,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(a,o){return c.Event.debounce(o.onDidChangeConfiguration,(m,E)=>{const A=m?new Set([...m.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:A}},1e3,!0)(m=>{m.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(m.source),configurationKeys:b(m.affectedKeys)})})}e.configurationTelemetry=g;function S(a,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!a.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=S;function d(a,o){return!(o.isBuilt||o.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=d;function p(a){const o=a.getValue(C.TELEMETRY_SETTING_ID),l=a.getValue(C.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function h(a){const o={},l={},m={};v(a,m);for(let E in m){E=E.length>150?E.substr(E.length-149):E;const A=m[E];typeof A=="number"?l[E]=A:typeof A=="boolean"?l[E]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${A.length}`),o[E]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(o[E]=A)}return{properties:o,measurements:l}}e.validateTelemetryData=h;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function f(a){if(!a)return"none";const o=(0,L.getRemoteName)(a);return u.has(o)?o:"other"}e.cleanRemoteAuthority=f;function v(a,o,l=0,m){if(!!a)for(const E of Object.getOwnPropertyNames(a)){const A=a[E],O=m?m+E:E;Array.isArray(A)?o[O]=(0,R.safeStringify)(A):A instanceof Date?o[O]=A.toISOString():(0,_.isObject)(A)?l<2?v(A,o,l+1,O+"."):o[O]=(0,R.safeStringify)(A):o[O]=A}}function b(a){if(!a)return[];const o=[];return I(o,"",a),o}function I(a,o,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(m=>I(a,o?`${o}.${m}`:m,l[m])):a.push(o)}function i(a,o){const l=a.msftInternalDomains||[],m=o.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(l)||m}e.isInternalTelemetry=i;function s(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=s;function t(a,o){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let l=a;const m=[];for(const F of o)for(;;){const M=F.exec(a);if(!M)break;m.push([M.index,F.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let O=0;for(l="";;){const F=A.exec(a);if(!F)break;const M=m.some(([k,N])=>F.index<N&&k<A.lastIndex);!E.test(F[0])&&!M&&(l+=a.substring(O,F.index)+"<REDACTED: user-file-path>",O=A.lastIndex)}return O<a.length&&(l+=a.substr(O)),l}function n(a){if(!a)return a;const o=a.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of l)if(m.regex.test(o))return`<REDACTED: ${m.label}>`;return a}function r(a,o){return(0,R.cloneAndChange)(a,l=>{if(l instanceof w)return l.value;if(typeof l=="string"){let m=l.replaceAll("%20"," ");m=t(m,o);for(const E of o)m=m.replace(E,"");return m=n(m),m}})}e.cleanData=r}),define(se[33],oe([0,1,27,30,42,4,11,9,36,47]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,R.compareIgnoreCase)(t.id,n.id)===0}e.areSameExtensions=P;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const r=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,r,a)}static parse(n){const r=y.exec(n);return r&&r[1]&&r[2]?new g({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,a="undefined"){this.version=r,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=g;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(t){const n=S.exec(t);return n&&n[1]?[h(n[1]),n[2]]:[h(t),void 0]}e.getIdAndVersion=d;function p(t,n){return`${t}.${n}`}e.getExtensionId=p;function h(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function u(t,n){return h(p(t,n))}e.getGalleryExtensionId=u;function f(t,n){const r=[],a=o=>{for(const l of r)if(l.some(m=>P(n(m),n(o))))return l;return null};for(const o of t){const l=a(o);l?l.push(o):r.push([o])}return r}e.groupByExtension=f;function v(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function b(t){return{id:new w.TelemetryTrustedValue(t.identifier.id),name:new w.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new c.ExtensionIdentifier("pprice.better-merge");function I(t,n){const r=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const o=a.shift();if(o&&r.every(l=>!P(l.identifier,{id:o}))){const l=t.filter(m=>P(m.identifier,{id:o}));l.length===1&&(r.push(l[0]),a.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=I;async function i(t,n){if(!T.isLinux)return!1;let r;try{r=(await t.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await t.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(o))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function s(t,n){const r=await i(t,n),a=(0,_.getTargetPlatform)(r?"alpine":T.platform,C.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=s}),define(se[239],oe([0,1,25,33]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function c(T,L,D,C,w){try{const P=await T.getExtensionsControlManifest();if(!P.deprecated)return;const y=await T.getInstalled(1);for(const[g,S]of Object.entries(P.deprecated)){if(!S?.extension)continue;const{id:d,autoMigrate:p,preRelease:h}=S.extension;if(!p)continue;const u=y.find(v=>(0,_.areSameExtensions)(v.identifier,{id:g}));if(!u)continue;const f=(await L.getExtensions([{id:d,preRelease:h}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!f){w.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{w.info(`Migrating '${u.identifier.id}' extension to '${d}' extension...`);const v=!C.getDisabledExtensions().some(I=>(0,_.areSameExtensions)(I,u.identifier));await T.uninstall(u),w.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let b=y.find(I=>(0,_.areSameExtensions)(I.identifier,{id:d}));(!b||!b.isPreReleaseVersion&&v)&&(b=await T.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),w.info(`Installed the pre-release extension '${b.identifier.id}'`),v||(await C.disableExtension(b.identifier),w.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),p.storage&&(D.addToMigrationList((0,_.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,_.getExtensionId)(b.manifest.publisher,b.manifest.name)),w.info("Added pre-release extension to the storage migration list"))),w.info(`Migrated '${u.identifier.id}' extension to '${d}' extension.`)}catch(v){w.error(v)}}}catch(P){w.error(P)}}e.migrateUnsupportedExtensions=c}),define(se[240],oe([0,1,6,9,2,22,4,23,54,12,31,28,16,15,30,33,99,14,8]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class St extends c.Disposable{constructor(I,i,s,t,n,r){super(),this.fileService=i,this.extensionGalleryService=s,this.configurationService=t,this.extensionSignatureVerificationService=n,this.logService=r,this.extensionsDownloadDir=I.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(I,i){await this.cleanUpPromise;const s=(0,D.joinPath)(this.extensionsDownloadDir,this.getName(I));try{await this.downloadFile(I,s,n=>this.extensionGalleryService.download(I,n,i))}catch(n){throw new d.ExtensionManagementError(n.message,d.ExtensionManagementErrorCode.Download)}let t="Unverified";if(await this.shouldVerifySignature(I)){const n=await this.downloadSignatureArchive(I);try{await this.extensionSignatureVerificationService.verify(s.fsPath,n.fsPath)&&(t="Verified"),this.logService.info(`Extension signature verification: ${I.identifier.id}. Verification status: ${t}.`)}catch(r){const a=r,o=a.code;if(o==="UnknownError")t="UnknownError",this.logService.warn(`Extension signature verification: ${I.identifier.id}. Verification status: ${t}.`);else if(!a.didExecute)this.logService.warn(`Extension signature verification: ${I.identifier.id}. Verification status: ${t} (${o})`);else throw await this.delete(n),await this.delete(s),new d.ExtensionManagementError(o,d.ExtensionManagementErrorCode.Signature)}}return{location:s,verificationStatus:t}}async shouldVerifySignature(I){if(!I.isSigned)return!1;const i=this.configurationService.getValue("extensions.verifySignature");return(0,w.isBoolean)(i)?i:!0}async downloadSignatureArchive(I){await this.cleanUpPromise;const i=(0,D.joinPath)(this.extensionsDownloadDir,`${this.getName(I)}${St.SignatureArchiveExtension}`);return await this.downloadFile(I,i,s=>this.extensionGalleryService.downloadSignatureArchive(I,s)),i}async downloadFile(I,i,s){if(await this.fileService.exists(i))return;if(i.scheme!==T.Schemas.file){await s(i);return}const t=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(t)||await s(t);try{await this.rename(t,i,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(t)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",I.identifier.id,i.path);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(n)}. Deleted the file from downloaded location`,t.path),n}}async delete(I){await this.cleanUpPromise,await this.fileService.del(I)}async rename(I,i,s){try{await y.Promises.rename(I.fsPath,i.fsPath)}catch(t){if(L.isWindows&&t&&t.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${I} to ${i} with 'EPERM' error. Trying again...`),this.rename(I,i,s);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const I=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(I.children){const i=[],s=[],t=[];for(const a of I.children)if(a.name.endsWith(St.SignatureArchiveExtension))t.push(a.resource);else{const o=p.ExtensionKey.parse(a.name);o&&s.push([o,a])}const n=(0,p.groupByExtension)(s,([a])=>a),r=[];for(const a of n)a.sort((o,l)=>C.rcompare(o[0].version,l[0].version)),i.push(...a.slice(1).map(o=>o[1].resource)),r.push(a[0][1]);r.sort((a,o)=>a.mtime-o.mtime),i.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(a=>a.resource)),i.push(...t),await R.Promises.settled(i.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(I){this.logService.error(I)}}getName(I){return this.cache?p.ExtensionKey.create(I).toString().toLowerCase():(0,P.generateUuid)()}};v.SignatureArchiveExtension=".sigzip",v=Se([K(0,S.INativeEnvironmentService),K(1,u.IFileService),K(2,d.IExtensionGalleryService),K(3,g.IConfigurationService),K(4,h.IExtensionSignatureVerificationService),K(5,f.ILogService)],v),e.ExtensionsDownloader=v}),define(se[241],oe([0,1,3,2,37,33,42]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class D extends _.Disposable{constructor(w,P,y,g,S,d,p){super(),this.extensionManagementService=w,this.extensionsScannerService=P,this.userDataProfilesService=y,this.extensionsProfileScannerService=g,this.uriIdentityService=S,this.fileService=d,this.logService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new _.DisposableMap),this.initialize().then(null,h=>p.error(h))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(w=>this.onDidChangeProfiles(w.added,w.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(w=>this.onAddExtensions(w))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(w=>this.onDidAddExtensions(w))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(w=>this.onRemoveExtensions(w))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(w=>this.onDidRemoveExtensions(w))),this._register(this.fileService.onDidFilesChange(w=>this.onDidFilesChange(w)))}async onDidChangeProfiles(w,P){try{await Promise.all(P.map(y=>(this.extensionsProfileWatchDisposables.deleteAndDispose(y.id),this.removeExtensionsFromProfile(y.extensionsResource)))),w.length&&await Promise.all(w.map(y=>(this.extensionsProfileWatchDisposables.set(y.id,(0,_.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(y.extensionsResource)),this.fileService.watch(y.extensionsResource))),this.populateExtensionsFromProfile(y.extensionsResource))))}catch(y){throw this.logService.error(y),y}}async onAddExtensions(w){for(const P of w.extensions)this.addExtensionWithKey(this.getKey(P.identifier,P.version),w.profileLocation)}async onDidAddExtensions(w){for(const P of w.extensions){const y=this.getKey(P.identifier,P.version);w.error?this.removeExtensionWithKey(y,w.profileLocation):this.addExtensionWithKey(y,w.profileLocation)}}async onRemoveExtensions(w){for(const P of w.extensions)this.removeExtensionWithKey(this.getKey(P.identifier,P.version),w.profileLocation)}async onDidRemoveExtensions(w){let P=!1;for(const y of w.extensions){const g=this.getKey(y.identifier,y.version);w.error?this.addExtensionWithKey(g,w.profileLocation):(this.removeExtensionWithKey(g,w.profileLocation),P=P||!this.allExtensions.has(g))}P&&await this.uninstallExtensionsNotInProfiles()}onDidFilesChange(w){for(const P of this.userDataProfilesService.profiles)w.contains(P.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(P.extensionsResource)}async onDidExtensionsProfileChange(w){const P=[],y=[],g=await this.extensionsProfileScannerService.scanProfileExtensions(w),S=new Set,d=new Set;for(const[p,h]of this.allExtensions)h.has(w)&&d.add(p);for(const p of g){const h=this.getKey(p.identifier,p.version);S.add(h),d.has(h)||(P.push(p.identifier),this.addExtensionWithKey(h,w))}for(const p of d)if(!S.has(p)){const h=this.fromKey(p);h&&(y.push(h.identifier),this.removeExtensionWithKey(p,w))}(P.length||y.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P.length?{extensions:P,profileLocation:w}:void 0,removed:y.length?{extensions:y,profileLocation:w}:void 0})}async populateExtensionsFromProfile(w){const P=await this.extensionsProfileScannerService.scanProfileExtensions(w);for(const y of P)this.addExtensionWithKey(this.getKey(y.identifier,y.version),w)}async removeExtensionsFromProfile(w){for(const P of[...this.allExtensions.keys()])this.removeExtensionWithKey(P,w);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(){const P=(await this.extensionManagementService.getAllUserInstalled()).filter(y=>y.installedTimestamp&&!this.allExtensions.has(this.getKey(y.identifier,y.manifest.version)));P.length&&await this.extensionManagementService.markAsUninstalled(...P)}addExtensionWithKey(w,P){let y=this.allExtensions.get(w);y||this.allExtensions.set(w,y=new c.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(g))),y.add(P)}removeExtensionWithKey(w,P){const y=this.allExtensions.get(w);y&&y.delete(P),y?.size||this.allExtensions.delete(w)}getKey(w,P){return`${L.ExtensionIdentifier.toKey(w.id)}@${P}`}fromKey(w){const[P,y]=(0,T.getIdAndVersion)(w);return y?{identifier:{id:P},version:y}:void 0}}e.ExtensionsWatcher=D}),define(se[242],oe([0,1,45,47]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function c(T,L,D,C,w,P,y){const g={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${L.nameShort})`};if((0,_.supportsTelemetry)(L,D)&&(0,_.getTelemetryLevel)(C)===3){const S=await(0,R.getServiceMachineId)(D,w,P),{machineId:d}=await y.getTelemetryInfo();g["X-Market-User-Id"]=S,g["VSCode-SessionId"]=d||S}return g}e.resolveMarketplaceHeaders=c}),define(se[243],oe([0,1,101,21,6,2,22,13,28,15,30,33,8,73,4,11]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends S.LanguagePackBaseService{constructor(b,I,i,s){super(i),this.extensionManagementService=b,this.logService=s,this.cache=this._register(new u(I,s)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getBuiltInExtensionTranslationsUri(b){const i=(await this.cache.getLanguagePacks())[d.Language.value()];if(!i){this.logService.warn(`No language pack found for ${d.Language.value()}`);return}const s=i.translations[b];return s?p.URI.file(s):void 0}async getInstalledLanguages(){const b=await this.cache.getLanguagePacks(),I=Object.keys(b).map(i=>{const s=b[i];return{...this.createQuickPickItem(i,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return I.push(this.createQuickPickItem("en","English")),I.sort((i,s)=>i.label.localeCompare(s.label)),I}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const I=await this.cache.getLanguagePacks();Object.keys(I).some(i=>I[i]&&I[i].extensions.some(s=>(0,y.areSameExtensions)(s.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,I]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(I);return!(0,_.equals)(Object.keys(b),Object.keys(i))}};h=Se([K(0,P.IExtensionManagementService),K(1,w.INativeEnvironmentService),K(2,P.IExtensionGalleryService),K(3,g.ILogService)],h),e.NativeLanguagePackService=h;let u=class extends T.Disposable{constructor(b,I){super(),this.logService=I,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new c.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(I=>{Object.keys(I).forEach(i=>delete I[i]),this.createLanguagePacksFromExtensions(I,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...I){for(const i of I)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,i);Object.keys(b).forEach(i=>this.updateHash(b[i]))}createLanguagePacksFromExtension(b,I){const i=I.identifier,s=I.manifest.contributes&&I.manifest.contributes.localizations?I.manifest.contributes.localizations:[];for(const t of s)if(I.location.scheme===L.Schemas.file&&f(t)){let n=b[t.languageId];n||(n={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},b[t.languageId]=n);const r=n.extensions.filter(a=>(0,y.areSameExtensions)(a.extensionIdentifier,i))[0];r?r.version=I.manifest.version:n.extensions.push({extensionIdentifier:i,version:I.manifest.version});for(const a of t.translations)n.translations[a.id]=(0,D.join)(I.location.fsPath,a.path)}}updateHash(b){if(b){const I=(0,R.createHash)("md5");for(const i of b.extensions)I.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);b.hash=I.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let I=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(I=b(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.languagePacks=i,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),C.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>I,i=>this.logService.error(i))})}};u=Se([K(0,w.INativeEnvironmentService),K(1,g.ILogService)],u);function f(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const b of v.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(se[244],oe([0,1,9,32,47]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://0.0.0.0/OneCollector/1.0",L="https://0.0.0.0/ping";async function D(w,P,y){const g=await new Promise((u,f)=>{Z(["@microsoft/1ds-core-js"],u,f)}),S=await new Promise((u,f)=>{Z(["@microsoft/1ds-post-js"],u,f)}),d=new g.AppInsightsCore,p=new S.PostChannel,h={instrumentationKey:w,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(y){h.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:y};h.extensionConfig[p.identifier]=u}return d.initialize(h,[]),d.addTelemetryInitializer(u=>{P&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),d}class C{constructor(P,y,g,S,d){this._isInternalTelemetry=P,this._eventPrefix=y,this._defaultData=g,this._xhrOverride=d,this.endPointUrl=T,this.endPointHealthUrl=L,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(P){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=D(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(y=>{P(y)},y=>{(0,R.onUnexpectedError)(y),console.error(y)})}}log(P,y){if(!this._aiCoreOrKey)return;y=(0,_.mixin)(y,this._defaultData),y=(0,c.validateTelemetryData)(y);const g=this._eventPrefix+"/"+P;try{this._withAIClient(S=>{S.pluginVersionString=y?.properties.version??"Unknown",S.track({name:g,baseData:{name:g,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(y=>{y.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=C}),define(se[113],oe([0,1,2,176,15,8,26,47]),function(Z,e,R,_,c,T,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let C=class extends R.Disposable{constructor(P,y,g,S,d=""){super(),this.prefix=d;const p=y.getLogger(g.telemetryLogResource);if(p)this.logger=this._register(p);else{const u=(0,D.isLoggingOnly)(S,g)?" (Not Sent)":"",f=g.telemetryLogResource,v=()=>(0,D.supportsTelemetry)(S,g)&&P.getLevel()===T.LogLevel.Trace;this.logger=this._register(y.createLogger(f,{id:D.telemetryLogChannelId,name:(0,_.localize)(0,null,u),hidden:!v()})),this._register(P.onDidChangeLogLevel(()=>y.setVisibility(f,v()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,y){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,D.validateTelemetryData)(y))}};C=Se([K(0,T.ILogService),K(1,T.ILoggerService),K(2,c.IEnvironmentService),K(3,L.IProductService)],C),e.TelemetryLogAppender=C}),define(se[114],oe([0,1,2,32,4,27,177,16,46,106,26,40,19,47]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(u,f,v){this._configurationService=f,this._productService=v,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(b),"gi")),b.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(b.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(b=>{(b.affectsConfiguration(g.TELEMETRY_SETTING_ID)||b.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||b.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(u,f){this._experimentProperties[u]=f}_updateTelemetryLevel(){let u=(0,S.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const v=f.usage?3:f.error?2:0;u=Math.min(u,v)}this._telemetryLevel=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const u=await this._commonProperties,f=u.sessionID,v=u["common.machineId"],b=u["common.firstSessionDate"],I=u["common.msftInternal"];return{sessionId:f,machineId:v,firstSessionDate:b,msftInternal:I}}dispose(){this._disposables.dispose()}_log(u,f,v){return this._telemetryLevel<f?Promise.resolve(void 0):this._commonProperties.then(b=>{v=(0,_.mixin)(v,this._experimentProperties),v=(0,S.cleanData)(v,this._cleanupPatterns),v=(0,_.mixin)(v,b),this._appenders.forEach(I=>I.log(u,v))},b=>{console.error(b)})}publicLog(u,f){return this._log(u,3,f)}publicLog2(u,f){return this.publicLog(u,f)}publicLogError(u,f){return this._sendErrorTelemetry?this._log(u,2,f):Promise.resolve(void 0)}publicLogError2(u,f){return this.publicLogError(u,f)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=Se([K(1,D.IConfigurationService),K(2,P.IProductService)],d),e.TelemetryService=d;function p(){const h=(0,L.localize)(0,null,w.default.nameLong),u=w.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=c.isWeb?"":(0,L.localize)(3,null),v=(0,L.localize)(4,null),b=(0,L.localize)(5,null),I=(0,L.localize)(6,null),i=(0,L.localize)(7,null),s=`
|       | ${v} | ${b} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,L.localize)(8,null);return`
${h} ${u} ${f}

&nbsp;

${i}
${s}

&nbsp;

${t}
`}y.Registry.as(C.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:p(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(C.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,L.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,L.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[245],oe([0,1,296,244]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class c extends _.AbstractOneDataSystemAppender{constructor(L,D,C,w){const P={sendPOST:(y,g)=>{const S={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const d=R.request(y.urlString,S,p=>{p.on("data",function(h){g(p.statusCode??200,p.headers,h.toString())}),p.on("error",function(h){g(0,{})})});d.write(y.data),d.end()}catch{g(0,{})}}};super(L,D,C,w,P)}}e.OneDataSystemAppender=c}),define(se[246],oe([0,1,22,68,16,15,8,26,19,112,113,114]),function(Z,e,R,_,c,T,L,D,C,w,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(d,p,h,u,f,v){this.configurationService=d,this.telemetryService=p,this.logService=h,this.loggerService=u,this.environmentService=f,this.productService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(d){if(!this.customTelemetryServices.has(d.id)){const{machineId:p,sessionId:h}=await this.telemetryService.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=p,u["common.vscodesessionid"]=h;const f=[d.id,JSON.stringify(u),d.aiKey],b=new _.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new w.TelemetryAppenderClient(b),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${d.id}] `)];this.customTelemetryServices.set(d.id,new y.TelemetryService({appenders:I,sendErrorTelemetry:d.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(d.id)}async publicLog(d,p,h){await(await this.getCustomTelemetryService(d)).publicLog(p,h)}async publicLogError(d,p,h){await(await this.getCustomTelemetryService(d)).publicLogError(p,h)}};g=Se([K(0,c.IConfigurationService),K(1,C.ITelemetryService),K(2,L.ILogService),K(3,L.ILoggerService),K(4,T.IEnvironmentService),K(5,D.IProductService)],g),e.CustomEndpointTelemetryService=g}),define(se[115],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var R;(function(_){_[_.Replace=1]="Replace",_[_.Append=2]="Append",_[_.Prepend=3]="Prepend"})(R=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(se[247],oe([0,1,4,115]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class c{constructor(C){this.collections=C,this.map=new Map,C.forEach((w,P)=>{const y=w.map.entries();let g=y.next();for(;!g.done;){const S=g.value[0];let d=this.map.get(S);if(d||(d=[],this.map.set(S,d)),d.length>0&&d[0].type===_.EnvironmentVariableMutatorType.Replace){g=y.next();continue}const p=g.value[1];d.unshift({extensionIdentifier:P,value:p.value,type:p.type}),g=y.next()}})}async applyToProcessEnvironment(C,w){let P;R.isWindows&&(P={},Object.keys(C).forEach(y=>P[y.toLowerCase()]=y));for(const[y,g]of this.map){const S=R.isWindows&&P[y.toLowerCase()]||y;for(const d of g){const p=w?await w(d.value):d.value;switch(d.type){case _.EnvironmentVariableMutatorType.Append:C[S]=(C[S]||"")+p;break;case _.EnvironmentVariableMutatorType.Prepend:C[S]=p+(C[S]||"");break;case _.EnvironmentVariableMutatorType.Replace:C[S]=p;break}}}}diff(C){const w=new Map,P=new Map,y=new Map;if(C.map.forEach((g,S)=>{const d=this.map.get(S),p=T(g,d);p&&w.set(S,p)}),this.map.forEach((g,S)=>{const d=C.map.get(S),p=T(g,d);p&&y.set(S,p)}),this.map.forEach((g,S)=>{const d=C.map.get(S),p=L(g,d);p&&P.set(S,p)}),!(w.size===0&&P.size===0&&y.size===0))return{added:w,changed:P,removed:y}}}e.MergedEnvironmentVariableCollection=c;function T(D,C){if(!C)return D;const w=new Set;C.forEach(y=>w.add(y.extensionIdentifier));const P=[];return D.forEach(y=>{w.has(y.extensionIdentifier)||P.push(y)}),P.length===0?void 0:P}function L(D,C){if(!C)return;const w=new Map;C.forEach(y=>w.set(y.extensionIdentifier,y));const P=[];return D.forEach(y=>{const g=w.get(y.extensionIdentifier);g&&(y.type!==g.type||y.value!==g.value)&&P.push(g)}),P.length===0?void 0:P}}),define(se[248],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function R(L){return[...L.entries()]}e.serializeEnvironmentVariableCollection=R;function _(L){return new Map(L)}e.deserializeEnvironmentVariableCollection=_;function c(L){return Array.from(L.entries()).map(D=>[D[0],R(D[1].map)])}e.serializeEnvironmentVariableCollections=c;function T(L){return new Map(L.map(D=>[D[0],{map:_(D[1])}]))}e.deserializeEnvironmentVariableCollections=T}),define(se[249],oe([0,1,6,25,3,2,8]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let D=class extends T.Disposable{constructor(w,P){super(),this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new c.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=w===void 0?15e3:w}createRequest(w){return new Promise((P,y)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,P),this._onCreateRequest.fire({requestId:g,...w});const S=new _.CancellationTokenSource;(0,R.timeout)(this._timeout,S.token).then(()=>y(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,T.toDisposable)(()=>S.cancel())])})}acceptReply(w,P){const y=this._pendingRequests.get(w);y?(this._pendingRequests.delete(w),(0,T.dispose)(this._pendingRequestDisposables.get(w)||[]),this._pendingRequestDisposables.delete(w),y(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};D=Se([K(1,L.ILogService)],D),e.RequestStore=D}),define(se[116],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var _;(function(v){v.Shell="terminal.integrated.shell.",v.ShellArgs="terminal.integrated.shellArgs.",v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(_=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var c;(function(v){v.ShellLinux="terminal.integrated.shell.linux",v.ShellMacOs="terminal.integrated.shell.osx",v.ShellWindows="terminal.integrated.shell.windows",v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationShellLinux="terminal.integrated.automationShell.linux",v.AutomationShellMacOs="terminal.integrated.automationShell.osx",v.AutomationShellWindows="terminal.integrated.automationShell.windows",v.AutomationProfileLinux="terminal.integrated.automationProfile.linux",v.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",v.AutomationProfileWindows="terminal.integrated.automationProfile.windows",v.ShellArgsLinux="terminal.integrated.shellArgs.linux",v.ShellArgsMacOs="terminal.integrated.shellArgs.osx",v.ShellArgsWindows="terminal.integrated.shellArgs.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsDefaultColor="terminal.integrated.tabs.defaultColor",v.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.TabStopWidth="terminal.integrated.tabStopWidth",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.TerminalTitleSeparator="terminal.integrated.tabs.separator",v.TerminalTitle="terminal.integrated.tabs.title",v.TerminalDescription="terminal.integrated.tabs.description",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoEnabled="terminal.integrated.localEchoEnabled",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",v.CustomGlyphs="terminal.integrated.customGlyphs",v.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover",v.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",v.AutoReplies="terminal.integrated.autoReplies",v.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",v.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",v.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",v.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",v.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",v.SmoothScrolling="terminal.integrated.smoothScrolling"})(c=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(v){v.FileName="ptyhost"})(T=e.TerminalLogConstants||(e.TerminalLogConstants={}));var L;(function(v){v.PowerShell="pwsh",v.Bash="bash",v.Fish="fish",v.Sh="sh",v.Csh="csh",v.Ksh="ksh",v.Zsh="zsh"})(L=e.PosixShellType||(e.PosixShellType={}));var D;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(D=e.WindowsShellType||(e.WindowsShellType={}));var C;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence",v[v.Config=3]="Config"})(C=e.TitleEventSource||(e.TitleEventSource={}));var w;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.Logger="logger",v.Heartbeat="heartbeat"})(w=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var P;(function(v){v.Cwd="cwd",v.InitialCwd="initialCwd",v.FixedDimensions="fixedDimensions",v.Title="title",v.ShellType="shellType",v.HasChildProcesses="hasChildProcesses",v.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",v.OverrideDimensions="overrideDimensions",v.FailedShellIntegrationActivation="failedShellIntegrationActivation",v.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var y;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y=e.HeartbeatConstants||(e.HeartbeatConstants={}));var g;(function(v){v[v.Panel=1]="Panel",v[v.Editor=2]="Editor"})(g=e.TerminalLocation||(e.TerminalLocation={}));var S;(function(v){v.TerminalView="view",v.Editor="editor"})(S=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var h;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(h=e.ProfileSource||(e.ProfileSource={}));var u;(function(v){v[v.Off=0]="Off",v[v.FinalTerm=1]="FinalTerm",v[v.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var f;(function(v){v[v.Unknown=0]="Unknown",v[v.Shutdown=1]="Shutdown",v[v.Process=2]="Process",v[v.User=3]="User",v[v.Extension=4]="Extension"})(f=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(se[250],oe([0,1,52,11,179,134]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(g,S){const d=[{name:null,description:(0,c.localize)(0,null)}];return d.push(...g.map(p=>({name:p.profileName,description:D(p)}))),S&&d.push(...S.map(p=>({name:p.title,description:C(p)}))),{values:d.map(p=>p.name),markdownDescriptions:d.map(p=>p.description)}}e.createProfileSchemaEnums=L;function D(g){let S=`$(${T.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:R.Codicon.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?S+=`
- args: "${g.args}"`:S+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(S+=`
- overrideName: ${g.overrideName}`),g.color&&(S+=`
- color: ${g.color}`),g.env&&(S+=`
- env: ${JSON.stringify(g.env)}`),S}function C(g){return`$(${T.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:R.Codicon.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function w(g,S){if(!g&&!S)return!0;if(typeof g=="string"&&typeof S=="string")return g===S;if(Array.isArray(g)&&Array.isArray(S)){if(g.length!==S.length)return!1;for(let d=0;d<g.length;d++)if(g[d]!==S[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function P(g,S){if(!g&&!S)return!0;if(!g||!S)return!1;if(T.ThemeIcon.isThemeIcon(g)&&T.ThemeIcon.isThemeIcon(S))return g.id===S.id&&g.color===S.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof S=="object"&&"light"in S&&"dark"in S){const d=g,p=S;if((_.URI.isUri(d.light)||y(d.light))&&(_.URI.isUri(d.dark)||y(d.dark))&&(_.URI.isUri(p.light)||y(p.light))&&(_.URI.isUri(p.dark)||y(p.dark)))return d.light.path===p.light.path&&d.dark.path===p.dark.path}if(_.URI.isUri(g)&&_.URI.isUri(S)||y(g)||y(S)){const d=g,p=S;return d.path===p.path&&d.scheme===p.scheme}return!1}e.terminalIconsEqual=P;function y(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}e.isUriComponents=y}),define(se[251],oe([0,1,52,178,46,40,250]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,R.getAllCodicons)(),b=>b.id),markdownEnumDescriptions:Array.from((0,R.getAllCodicons)(),b=>`$(${b.id})`)};const D={args:{description:(0,_.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,_.localize)(1,null),type:"boolean"},icon:{description:(0,_.localize)(2,null),...e.terminalIconSchema},color:{description:(0,_.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,_.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(5,null),type:["string","array"],items:{type:"string"}},...D}},w={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(6,null),type:["string"],items:{type:"string"}},...D}},P=(0,_.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),y=(0,_.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,_.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,_.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,_.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,_.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),h={id:"terminal",order:100,title:(0,_.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:y},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,_.localize)(26,null)}},{type:"string",markdownDescription:(0,_.localize)(27,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,_.localize)(29,null),enum:["PowerShell","Git Bash"]},...D}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(30,null),type:"string"},id:{description:(0,_.localize)(31,null),type:"string"},title:{description:(0,_.localize)(32,null),type:"string"},...D}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(34,null),type:"string"},id:{description:(0,_.localize)(35,null),type:"string"},title:{description:(0,_.localize)(36,null),type:"string"},...D}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(38,null),type:"string"},id:{description:(0,_.localize)(39,null),type:"string"},title:{description:(0,_.localize)(40,null),type:"string"},...D}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,_.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,_.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,_.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,_.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,_.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){T.Registry.as(c.Extensions.Configuration).registerConfiguration(h),v()}e.registerTerminalPlatformConfiguration=u;let f;function v(b,I){const i=T.Registry.as(c.Extensions.Configuration);let s;b&&(s=(0,L.createProfileSchemaEnums)(b?.profiles,I));const t=f;f={id:"terminal",order:100,title:(0,_.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?s?.values:void 0,markdownEnumDescriptions:b?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?s?.values:void 0,markdownEnumDescriptions:b?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?s?.values:void 0,markdownEnumDescriptions:b?.os===1?s?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[f],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=v}),define(se[252],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(se[253],oe([0,1,34,22,32,13,4,36,27,12,28,115,248,247]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function d(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let r=0;return n&&n.length===4&&(r=parseInt(n[3])),r}e.getWindowsBuildNumber=d;async function p(n,r,a,o=D.env,l=P.Promises.exists){if(T.isAbsolute(n))return await l(n)?n:void 0;if(r===void 0&&(r=D.cwd()),T.dirname(n)!=="."){const O=T.join(r,n);return await l(O)?O:void 0}const E=(0,c.getCaseInsensitive)(o,"PATH");if(a===void 0&&(0,w.isString)(E)&&(a=E.split(T.delimiter)),a===void 0||a.length===0){const O=T.join(r,n);return await l(O)?O:void 0}for(const O of a){let F;if(T.isAbsolute(O)?F=T.join(O,n):F=T.join(r,O,n),await l(F))return F;if(L.isWindows){let M=F+".com";if(await l(M)||(M=F+".exe",await l(M)))return M}}const A=T.join(r,n);return await l(A)?A:void 0}e.findExecutable=p;function h(n,r,a,o,l){if(!r.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||L.isWindows&&!r.windowsEnableConpty)return;const m=n.args,E=D.platform==="win32"?T.basename(n.executable).toLowerCase():T.basename(n.executable),A=T.dirname(_.FileAccess.asFileUri("").fsPath);let O;const F={VSCODE_INJECTION:"1"};if(L.isWindows){if(E==="pwsh.exe"||E==="powershell.exe")return!m||s(m)?O=v.get(f.WindowsPwsh):i(m)&&(O=v.get(f.WindowsPwshLogin)),O?(O=[...O],O[O.length-1]=(0,C.format)(O[O.length-1],A,""),r.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:O,envMixin:F}):void 0;o.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(E){case"bash":return!m||m.length===0?O=v.get(f.Bash):t(m)&&(F.VSCODE_SHELL_LOGIN="1",u(r,F),O=v.get(f.Bash)),O?(O=[...O],O[O.length-1]=(0,C.format)(O[O.length-1],A),{newArgs:O,envMixin:F}):void 0;case"fish":{const M=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",k=T.join(A,"out/vs/workbench/contrib/xdg_data");return F.XDG_DATA_DIRS=`${M}:${k}`,u(r,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!m||s(m)?O=v.get(f.Pwsh):i(m)&&(O=v.get(f.PwshLogin)),O?(r.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),O=[...O],O[O.length-1]=(0,C.format)(O[O.length-1],A,""),{newArgs:O,envMixin:F}):void 0;case"zsh":{if(!m||m.length===0?O=v.get(f.Zsh):t(m)?(O=v.get(f.ZshLogin),u(r,F)):(m===v.get(f.Zsh)||m===v.get(f.ZshLogin))&&(O=m),!O)return;O=[...O],O[O.length-1]=(0,C.format)(O[O.length-1],A);let M;try{M=R.userInfo().username}catch{M="unknown"}const k=T.join(R.tmpdir(),`${M}-${l.applicationName}-zsh`);F.ZDOTDIR=k;const N=a?.ZDOTDIR??R.homedir()??"~";F.USER_ZDOTDIR=N;const z=[];return z.push({source:T.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(k,".zshrc")}),z.push({source:T.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(k,".zprofile")}),z.push({source:T.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(k,".zshenv")}),z.push({source:T.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(k,".zlogin")}),{newArgs:O,envMixin:F,filesToCopy:z}}}o.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=h;function u(n,r){if(L.isMacintosh&&n.environmentVariableCollections){const a=(0,g.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),l=new S.MergedEnvironmentVariableCollection(a).map.get("PATH"),m=[];if(l)for(const E of l)E.type===y.EnvironmentVariableMutatorType.Prepend&&m.push(E.value);m.length>0&&(r.VSCODE_PATH_PREFIX=m.join(""))}}var f;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(f||(f={}));const v=new Map;v.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(f.Zsh,["-i"]),v.set(f.ZshLogin,["-il"]),v.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],I=["-nol","-nologo"];function i(n){return typeof n=="string"?b.includes(n.toLowerCase()):n.length===1&&b.includes(n[0].toLowerCase())||n.length===2&&(b.includes(n[0].toLowerCase())||b.includes(n[1].toLowerCase()))&&(I.includes(n[0].toLowerCase())||I.includes(n[1].toLowerCase()))}function s(n){return typeof n=="string"?I.includes(n.toLowerCase()):n.length===0||n?.length===1&&I.includes(n[0].toLowerCase())}function t(n){return n==="string"&&b.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&b.includes(n[0].toLowerCase())}}),define(se[254],oe([0,1,50,52,13,4,12,28,91,253]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,y=!0;function g(s,t,n,r,a=process.env,o,l,m,E){return o=o||{existsFile:D.SymlinkSupport.existsFile,readFile:D.Promises.readFile},T.isWindows?S(n,o,a,l,r.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:r.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:r.getValue("terminal.integrated.defaultProfile.windows"),E,m):b(o,l,n,s&&typeof s=="object"?{...s}:r.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:r.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),E,m,a)}e.detectAvailableProfiles=g;async function S(s,t,n,r,a,o,l,m,E){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let F=!1;(0,w.getWindowsBuildNumber)()>=16299&&(F=!0),await h(m);const M=new Map;if(s){M.set("PowerShell",{source:"PowerShell",icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),M.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:_.Codicon.terminalCmd,isAutoDetected:!0}),M.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),M.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:_.Codicon.terminalBash,isAutoDetected:!0});const N=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;M.set("Cmder",{path:`${O}\\cmd.exe`,args:["/K",N],requiresPath:process.env.CMDER_ROOT?N:{path:N,isUnsafe:!0},isAutoDetected:!0})}I(o,M);const k=await d(M.entries(),l,t,n,r,E);if(s||a)try{const N=await f(`${O}\\${F?"wsl":"bash"}.exe`,l);for(const z of N)(!o||!(z.profileName in o))&&k.push(z)}catch{y&&(r?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return k}async function d(s,t,n,r=process.env,a,o){const l=[];for(const[m,E]of s){if(E===null)continue;let A,O,F;if("source"in E){const z=P?.get(E.source);if(!z)continue;A=z.paths,O=E.args||z.args,E.icon?F=p(E.icon):z.icon&&(F=z.icon)}else A=Array.isArray(E.path)?E.path:[E.path],O=T.isWindows||Array.isArray(E.args)?E.args:void 0,F=p(E.icon);let M;if(o){const z=A.map(J=>typeof J=="string"?J:J.path),j=await o(z);M=new Array(A.length);for(let J=0;J<A.length;J++)typeof A[J]=="string"?M[J]=j[J]:M[J]={path:j[J],isUnsafe:!0}}else M=A.slice();let k;if(E.requiresPath){let z;if((0,L.isString)(E.requiresPath)?z=E.requiresPath:(z=E.requiresPath.path,E.requiresPath.isUnsafe&&(k=z)),!await n.existsFile(z))continue}const N=await i(m,t,M,n,r,O,E.env,E.overrideName,E.isAutoDetected,k);N?(N.isAutoDetected=E.isAutoDetected,N.icon=F,N.color=E.color,l.push(N)):a?.debug("Terminal profile not validated",m,A)}return a?.debug("Validated terminal profiles",l),l}function p(s){return typeof s=="string"?{id:s}:s}async function h(s){P&&!s||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),P.set("PowerShell",{profileName:"PowerShell",paths:s||await u(),icon:_.Codicon.terminalPowershell}))}async function u(){const s=[];for await(const t of(0,C.enumeratePowerShellInstallations)())s.push(t.exePath);return s}async function f(s,t){const n=[],r=await new Promise((l,m)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(E,A)=>{if(E)return m("Problem occurred when getting wsl distros");l(A)})});if(!r)return[];const a=new RegExp(/[\r?\n]/),o=r.split(a).filter(l=>l.trim().length>0&&l!=="");for(const l of o){if(l===""||l.startsWith("docker-desktop"))continue;const m=`${l} (WSL)`,E={profileName:m,path:s,args:["-d",`${l}`],isDefault:m===t,icon:v(l),isAutoDetected:!1};n.push(E)}return n}function v(s){return s.includes("Ubuntu")?_.Codicon.terminalUbuntu:s.includes("Debian")?_.Codicon.terminalDebian:_.Codicon.terminalLinux}async function b(s,t,n,r,a,o,l,m){const E=new Map;if(n){const A=(await s.readFile("/etc/shells")).toString(),O=o||A.split(`
`).filter(M=>M.trim().includes("#")&&M.trim().length>0),F=new Map;for(const M of O){let k=(0,c.basename)(M),N=F.get(k)||0;N++,N>1&&(k=`${k} (${N})`),F.set(k,N),E.set(k,{path:M,isAutoDetected:!0})}}return I(r,E),await d(E.entries(),a,s,m,t,l)}function I(s,t){if(!!s)for(const[n,r]of Object.entries(s))r===null||!("path"in r)&&!("source"in r)?t.delete(n):(r.icon=r.icon||t.get(n)?.icon,t.set(n,r))}async function i(s,t,n,r,a,o,l,m,E,A){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return i(s,t,n,r,a,o,l,m,E);const F=typeof O!="string"&&O.isUnsafe,M=typeof O=="string"?O:O.path,k={profileName:s,path:M,args:o,env:l,overrideName:m,isAutoDetected:E,isDefault:s===t,isUnsafePath:F,requiresUnsafePath:A};if((0,c.basename)(M)===M){const z=a.PATH?a.PATH.split(c.delimiter):void 0,j=await(0,w.findExecutable)(M,void 0,z,void 0,r.existsFile);return j?(k.path=j,k.isFromPath=!0,k):i(s,t,n,r,a,o)}return await r.existsFile((0,c.normalize)(M))?k:i(s,t,n,r,a,o,l,m,E)}}),define(se[255],oe([0,1,3,2,22,4,39,68,16,15,95,235,8,249,116,251,254,105]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let v=0,b=class extends _.Disposable{constructor(i,s,t,n,r,a){super(),this._reconnectConstants=i,this.loggerName=s,this._configurationService=t,this._environmentService=n,this._logService=r,this._loggerService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,p.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,_.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,y.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:v,VSCODE_PTY_LOG_NAME:this.loggerName,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},s=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);s&&(s.break&&s.port?i.debugBrk=s.port:!s.break&&s.port&&(i.debug=s.port));const t=new D.Client(c.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this._onPtyHostStart.fire(),L.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))})),this._register(new u.RemoteLoggerChannelClient(this._loggerService,t.getChannel(d.TerminalIpcChannels.Logger)));const r=L.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this._register(r.onProcessData(a=>this._onProcessData.fire(a))),this._register(r.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(r.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(r.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(r.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(r.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(r.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,r]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,s,t,n,r,a,o,l,m,E,A){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),d.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(i,s,t,n,r,a,o,l,m,E,A);return clearTimeout(O),v=Math.max(v,F),F}updateTitle(i,s,t){return this._proxy.updateTitle(i,s,t)}updateIcon(i,s,t,n){return this._proxy.updateIcon(i,s,t,n)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,s){return this._proxy.detachFromProcess(i,s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,s){return this._proxy.shutdown(i,s)}input(i,s){return this._proxy.input(i,s)}processBinary(i,s){return this._proxy.processBinary(i,s)}resize(i,s,t){return this._proxy.resize(i,s,t)}acknowledgeDataEvent(i,s){return this._proxy.acknowledgeDataEvent(i,s)}setUnicodeVersion(i,s){return this._proxy.setUnicodeVersion(i,s)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,s){return this._proxy.installAutoReply(i,s)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,s,t,n=!1){const r=await this._shellEnv;return(0,h.detectAvailableProfiles)(s,t,n,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i,s){return this._proxy.getWslPath(i,s)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,s){return this._proxy.requestDetachInstance(i,s)}async acceptDetachInstanceReply(i,s){return this._proxy.acceptDetachInstanceReply(i,s)}async freePortKillProcess(i){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(i)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,s){return this._proxy.reviveTerminalProcesses(i,s)}async refreshProperty(i,s){return this._proxy.refreshProperty(i,s)}async updateProperty(i,s,t){return this._proxy.updateProperty(i,s,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,s){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:s})}async acceptPtyHostResolvedVariables(i,s){this._resolveVariablesRequestStore.acceptReply(i,s)}};b=Se([K(2,C.IConfigurationService),K(3,w.IEnvironmentService),K(4,g.ILogService),K(5,g.ILoggerService)],b),e.PtyHostService=b}),define(se[77],oe([0,1,3,16,5,8]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,c.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,c.createDecorator)("sharedTunnelsService");var L;(function(p){p.Http="http",p.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=y;function g(p,h,u,f){if(u===1)return!1;if(u===2&&y(h)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(v?.length===4&&parseInt(v[1])>=18)return!1}return p<1024}e.isPortPrivileged=g;class S{constructor(h,u,f){this.remoteAddress=h,this.localAddress=u,this._dispose=f,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=S;let d=class{constructor(h,u){this.logService=h,this.configurationService=u,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const h=this.configurationService.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],u=Array.from(this._tunnels.values());for(const f of u){const v=Array.from(f.values());for(const b of v){const I=await b.value;I&&h.push(I)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:u}of h.values())await u.then(f=>f?.dispose());h.clear()}this._tunnels.clear()}setEnvironmentTunnel(h,u,f,v,b){this.addTunnelToMap(h,u,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:u,localAddress:f,privacy:v,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,u){(y(h)||P(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const f=this.getTunnelFromMap(h,u);if(f)return++f.refcount,f.value}openTunnel(h,u,f,v,b,I=!1,i,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${f} on local port ${b}.`),!h)return;if(u||(u="localhost"),v||(v=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(f)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(h,u,f,v,b,I,i,s);return t?t.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,f);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==f)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const u=this._tunnels.get(h.tunnelRemoteHost);if(u){const f=u.get(h.tunnelRemotePort);f&&(f.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,f))}}}}async tryDisposeTunnel(h,u,f){if(f.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${u}.`);const v=f.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(u),v}}async closeTunnel(h,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${u} `);const f=this._tunnels.get(h);if(f&&f.has(u)){const v=f.get(u);v.refcount=0,await this.tryDisposeTunnel(h,u,v)}}addTunnelToMap(h,u,f){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(u,{refcount:1,value:f})}async removeEmptyTunnelFromMap(h,u){const f=this._tunnels.get(h);f&&(await f.get(u)||f.delete(u),f.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,u){const f=[h];P(h)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):y(h)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const v=f.map(b=>this._tunnels.get(b));for(const b of v){const I=b?.get(u);if(I)return I}}canTunnel(h){return!!w(h)}createWithProvider(h,u,f,v,b,I,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${f} on local port ${v}.`);const s=f;this._factoryInProgress.add(s);const t=v===void 0?f:v,n={elevationRequired:b?this.isPortPrivileged(t):!1},r={remoteAddress:{host:u,port:f},localAddressPort:v,privacy:I,public:I?I!==D.Private:void 0,protocol:i},a=h.forwardPort(r,n);return a?(this.addTunnelToMap(u,f,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),a}};d=Se([K(0,T.ILogService),K(1,_.IConfigurationService)],d),e.AbstractTunnelService=d}),define(se[256],oe([0,1,8,77,2,9,6]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class D extends c.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new L.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let C=class kt extends c.Disposable{constructor(P,y){super(),this._tunnelService=P,this._logService=y,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++kt._lastId)}}async startTunnel(P,y,g,S,d,p,h){const u=new D,f=await Promise.resolve(this._tunnelService.openTunnel(P,u,g,S,d,p,h));if(!f)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${S} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(y))throw this._disposedTunnels.delete(y),u.dispose(),await f.dispose(),(0,T.canceled)();return u.setTunnel(f),this._tunnels.set(y,u),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${y}: ${f.localAddress} (local) to ${g}:${S} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(P,y){const g=this._tunnels.get(P);!g||g.setAddress(y)}async destroyTunnel(P){const y=this._tunnels.get(P);if(y){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await y.dispose();return}this._disposedTunnels.add(P)}};C._lastId=0,C=Se([K(0,_.ISharedTunnelsService),K(1,R.ILogService)],C),e.SharedProcessTunnelService=C}),define(se[257],oe([0,1,86,34,136,227,6,2,16,8,26,225,77,110,4]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(b,I,i,s,t){let n;for(let r=3;r&&(n?.dispose(),n=await new h(b,I,i,s,t).waitForReady(),!(t&&c.BROWSER_RESTRICTED_PORTS[t]||!c.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));r--);return n}class h extends D.Disposable{constructor(I,i,s,t,n){super(),this.defaultTunnelHost=i,this.suggestedLocalPort=n,this.privacy=g.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=I,this._server=R.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(i=>{i()})}async waitForReady(){const I=this.suggestedLocalPort??this.tunnelRemotePort,i=(0,g.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let s=await(0,c.findFreePortFaster)(I,2,1e3,i),t=null;return this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(s=0,this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(I){I.pause();const i=(0,g.isLocalhost)(this.tunnelRemoteHost)||(0,g.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,y.connectRemoteAgentTunnel)(this._options,i,this.tunnelRemotePort),t=s.getSocket().socket,n=s.readEntireBuffer();s.dispose(),n.byteLength>0&&I.write(n.buffer),I.on("end",()=>{I.localAddress&&this._socketsDispose.delete(I.localAddress),t.end()}),I.on("close",()=>t.end()),I.on("error",()=>{I.localAddress&&this._socketsDispose.delete(I.localAddress),t.destroy()}),t.on("end",()=>I.end()),t.on("close",()=>I.end()),t.on("error",()=>{I.destroy()}),I.pipe(t),t.pipe(I),I.localAddress&&this._socketsDispose.set(I.localAddress,()=>{I.end(),t.end()})}}let u=class extends g.AbstractTunnelService{constructor(I,i,s,t,n){super(i,n),this.socketFactory=I,this.signService=s,this.productService=t}isPortPrivileged(I){return(0,g.isPortPrivileged)(I,this.defaultTunnelHost,d.OS,_.release())}retainOrCreateTunnel(I,i,s,t,n,r,a,o){const l=this.getTunnelFromMap(i,s);if(l)return++l.refcount,l.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,i,s,n,r,a,o);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${s} on local port ${n}.`);const m={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:I,signService:this.signService,logService:this.logService,ipcLogger:null},E=p(m,t,i,s,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(i,s,E),E}}};u=Se([K(1,w.ILogService),K(2,S.ISignService),K(3,P.IProductService),K(4,C.IConfigurationService)],u),e.BaseTunnelService=u;let f=class extends u{constructor(I,i,s,t){super(T.nodeSocketFactory,I,i,s,t)}};f=Se([K(0,w.ILogService),K(1,S.ISignService),K(2,P.IProductService),K(3,C.IConfigurationService)],f),e.TunnelService=f;let v=class extends D.Disposable{constructor(I,i,s,t){super(),this.logService=I,this.productService=i,this.signService=s,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(I,i,s,t,n,r,a,o,l){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${r}.`),!this._tunnelServices.has(I)){const m=new f(this.logService,this.signService,this.productService,this.configurationService);this._register(m),this._tunnelServices.set(I,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this._tunnelServices.delete(I))})}return this._tunnelServices.get(I).openTunnel(i,s,t,n,r,a,o,l)}};v=Se([K(0,w.ILogService),K(1,P.IProductService),K(2,S.ISignService),K(3,C.IConfigurationService)],v),e.SharedTunnelsService=v}),define(se[29],oe([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(se[258],oe([0,1,29,71,14,23,132,3,2]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(g){this.uri=g,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let P=class{constructor(g){this._fileService=g,this._dispooables=new C.DisposableStore,this._limit=2**16;const S=new Map,d=p=>{let h=S.get(p.scheme);return h===void 0&&(h=g.hasProvider(p)&&!this._fileService.hasCapability(p,1024),S.set(p.scheme,h)),h};this._dispooables.add(D.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(p=>{S.delete(p.scheme)})),this.extUri=new T.ExtUri(d),this._canonicalUris=new L.SkipList((p,h)=>this.extUri.compare(p,h,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,T.normalizePath)(g));const S=this._canonicalUris.get(g);return S?S.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new w(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((d,p)=>d[1].touch<p[1].touch?1:d[1].touch>p[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let d=0;d<S;d++)this._canonicalUris.set(g[d][0],g[d][1].touch())}};P=Se([K(0,c.IFileService)],P),e.UriIdentityService=P,(0,_.registerSingleton)(R.IUriIdentityService,P,1)}),define(se[259],oe([0,1,3,2,14,44,49,17]),function(Z,e,R,_,c,T,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends _.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(P,y,g,S){super(),this.fileSystemScheme=P,this.fileSystemProvider=y,this.userDataScheme=g,this.logService=S,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(d=>this.handleFileChanges(d)))}watch(P,y){this.watchResources.set(P,P);const g=this.fileSystemProvider.watch(this.toFileSystemResource(P),y);return(0,_.toDisposable)(()=>{this.watchResources.delete(P),g.dispose()})}stat(P){return this.fileSystemProvider.stat(this.toFileSystemResource(P))}mkdir(P){return this.fileSystemProvider.mkdir(this.toFileSystemResource(P))}rename(P,y,g){return this.fileSystemProvider.rename(this.toFileSystemResource(P),this.toFileSystemResource(y),g)}readFile(P){return this.fileSystemProvider.readFile(this.toFileSystemResource(P),{atomic:!0})}readFileStream(P,y,g){const S=(0,T.newWriteableStream)(d=>D.VSBuffer.concat(d.map(p=>D.VSBuffer.wrap(p))).buffer);return(async()=>{try{const d=await this.readFile(P);S.end(d)}catch(d){S.error(d),S.end()}})(),S}readdir(P){return this.fileSystemProvider.readdir(this.toFileSystemResource(P))}writeFile(P,y,g){return this.fileSystemProvider.writeFile(this.toFileSystemResource(P),y,g)}delete(P,y){return this.fileSystemProvider.delete(this.toFileSystemResource(P),y)}copy(P,y,g){if((0,c.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(P),this.toFileSystemResource(y),g);throw new Error("copy not supported")}handleFileChanges(P){const y=[];for(const g of P){if(g.resource.scheme!==this.fileSystemScheme)continue;const S=this.toUserDataResource(g.resource);this.watchResources.findSubstr(S)&&y.push({resource:S,type:g.type})}y.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(y))}toFileSystemResource(P){return P.with({scheme:this.fileSystemScheme})}toUserDataResource(P){return P.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=C}),define(se[61],oe([0,1,83]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function _(L,D,C,w){const P=(0,R.setProperty)(L,D,C,w)[0];return P&&(L=L.substring(0,P.offset)+P.content+L.substring(P.offset+P.length)),L}e.edit=_;function c(L,D,C){let w=C;for(;w>=0;){if(L.charAt(w)===D.charAt(D.length-1)&&D.length===1)return w+1;if(w--,D.length===2&&w>=0&&L.charAt(w)===D.charAt(0))return w+2}return 0}e.getLineStartOffset=c;function T(L,D,C){let w=C;for(;w>=0;)if(L.charAt(w)===D.charAt(D.length-1)&&D.length===1||(w++,D.length===2&&w>=0&&L.charAt(w)===D.charAt(1)))return w;return L.length-1}e.getLineEndOffset=T}),define(se[260],oe([0,1,32,54,12]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(S,d,p,h,u,f){const v=[],b=[],I=[];if(!d){const N=S.filter(({identifier:z})=>u.every(j=>j.toLowerCase()!==z.id.toLowerCase()));return{local:{added:v,removed:b,updated:I},remote:N.length>0?{added:N,updated:[],removed:[],all:N}:null}}S=S.map(y),d=d.map(y),p=p?p.map(y):null;const i=new Map,s=N=>{N.uuid&&i.set(N.id.toLowerCase(),N.uuid)};S.forEach(({identifier:N})=>s(N)),d.forEach(({identifier:N})=>s(N)),p?.forEach(({identifier:N})=>s(N));const t=N=>{const z=N.identifier.uuid||i.get(N.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${N.identifier.id.toLowerCase()}`},n=(N,z)=>(N.set(t(z),z),N),r=S.reduce(n,new Map),a=d.reduce(n,new Map),o=d.reduce((N,z)=>n(N,(0,R.deepClone)(z)),new Map),l=p?p.reduce(n,new Map):null,m=h.reduce(n,new Map),E=u.reduce((N,z)=>{const j=i.get(z.toLowerCase());return N.add(j?`uuid:${j}`:`id:${z.toLowerCase()}`)},new Set),A=f?f.reduce((N,{id:z,uuid:j})=>(j=j??i.get(z.toLowerCase()),N.add(j?`uuid:${j}`:`id:${z.toLowerCase()}`)),new Set):null,O=L(r,a,E,!1);if(O.added.size>0||O.removed.size>0||O.updated.size>0){const N=L(l,r,E,!1),z=L(l,a,E,!0),j=(J,ne,G,q)=>{let x,Y,ee;return ne.installed?(x=q.pinned,ee=q.preRelease,x&&(Y=q.version)):(x=G.pinned,ee=G.preRelease,x&&(Y=G.version)),x===void 0&&(x=ne.pinned,x&&(Y=ne.version)),ee===void 0&&(ee=ne.preRelease),{...q,installed:ne.installed||G.installed,pinned:x,preRelease:ee,version:Y??(G.version&&(!ne.installed||_.gt(G.version,ne.version))?G.version:ne.version),state:C(ne,G,l?.get(J))}};for(const J of z.removed.values()){const ne=r.get(J);if(!ne)continue;const G=(0,c.assertIsDefined)(l?.get(J)),q=A&&!A.has(J)&&G.installed;ne.installed&&q?b.push(ne.identifier):o.set(J,ne)}for(const J of z.added.values()){const ne=(0,c.assertIsDefined)(a.get(J)),G=r.get(J);if(G){if(O.updated.has(J)){const q=j(J,G,ne,ne);D(G,ne,!1,!1)||I.push(g(q,J)),o.set(J,q)}}else ne.installed&&v.push(g(ne,J))}for(const J of z.updated.values()){const ne=(0,c.assertIsDefined)(a.get(J)),G=(0,c.assertIsDefined)(l?.get(J)),q=r.get(J);if(q)if(A&&!A.has(J)&&G.installed&&q.installed&&!ne.installed)b.push(q.identifier);else{const Y=j(J,q,ne,ne);I.push(g(Y,J)),o.set(J,Y)}else ne.installed&&v.push(g(ne,J))}for(const J of N.added.values())z.added.has(J)||o.set(J,(0,c.assertIsDefined)(r.get(J)));for(const J of N.updated.values()){if(z.removed.has(J)||z.updated.has(J))continue;const ne=(0,c.assertIsDefined)(r.get(J)),G=(0,c.assertIsDefined)(a.get(J));o.set(J,j(J,ne,G,ne))}for(const J of N.removed.values())z.updated.has(J)||z.removed.has(J)||m.has(J)||!(0,c.assertIsDefined)(a.get(J)).installed||!A||A.has(J)||!(0,c.assertIsDefined)(l?.get(J)).installed||o.delete(J)}const F=[],M=L(a,o,new Set,!0),k=M.added.size>0||M.updated.size>0||M.removed.size>0;return k&&o.forEach((N,z)=>F.push(g(N,z))),{local:{added:v,removed:b,updated:I},remote:k?{added:[...M.added].map(N=>o.get(N)),updated:[...M.updated].map(N=>o.get(N)),removed:[...M.removed].map(N=>a.get(N)),all:F}:null}}e.merge=T;function L(S,d,p,h){const u=S?[...S.keys()].filter(i=>!p.has(i)):[],f=[...d.keys()].filter(i=>!p.has(i)),v=f.filter(i=>u.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),b=u.filter(i=>f.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),I=new Set;for(const i of u){if(b.has(i))continue;const s=S.get(i),t=d.get(i);(!t||!D(s,t,h,!0))&&I.add(i)}return{added:v,removed:b,updated:I}}function D(S,d,p,h){return!(S.disabled!==d.disabled||h&&S.installed!==d.installed||S.installed&&d.installed&&(S.preRelease!==d.preRelease||S.pinned!==d.pinned||d.pinned&&S.version!==d.version)||!P(S.state,d.state)||p&&S.version!==d.version)}function C(S,d,p){const h=S.state,u=d.state,f=p?.state;if(!d.version||h&&_.gt(S.version,d.version))return h;if(u&&_.gt(d.version,S.version)||!h)return u;if(!u)return h;const v=(0,R.deepClone)(h),b=f?w(f,u):{added:Object.keys(u).reduce((i,s)=>(i.add(s),i),new Set),removed:new Set,updated:new Set},I=f?w(f,h):{added:Object.keys(h).reduce((i,s)=>(i.add(s),i),new Set),removed:new Set,updated:new Set};for(const i of[...b.added.values(),...b.updated.values()])v[i]=u[i];for(const i of b.removed.values())I.updated.has(i)||delete v[i];return v}function w(S,d){const p=Object.keys(S),h=Object.keys(d),u=h.filter(b=>p.indexOf(b)===-1).reduce((b,I)=>(b.add(I),b),new Set),f=p.filter(b=>h.indexOf(b)===-1).reduce((b,I)=>(b.add(I),b),new Set),v=new Set;for(const b of p){if(f.has(b))continue;const I=S[b],i=d[b];(0,R.equals)(I,i)||v.add(b)}return{added:u,removed:f,updated:v}}function P(S={},d={}){const{added:p,removed:h,updated:u}=w(S,d);return p.size===0&&h.size===0&&u.size===0}function y(S){return{...S,disabled:!!S.disabled,installed:!!S.installed}}function g(S,d){const p={identifier:{id:S.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},version:S.version,preRelease:!!S.preRelease,pinned:!!S.pinned};return S.disabled&&(p.disabled=!0),S.installed&&(p.installed=!0),S.state&&(p.state=S.state),p}}),define(se[117],oe([0,1,21,16,5]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,c.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(D){this.configurationService=D}hasToNeverSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,C){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==D&&P!==`-${D}`),C&&w.push(D.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}updateSynchronizedExtensions(D,C){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==D&&P!==`-${D}`),C&&w.push(`-${D.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}getIgnoredExtensions(D){const C=D.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),P=[],y=[];if(Array.isArray(w))for(const g of w)g.startsWith("-")?y.push(g.substring(1)):P.push(g);return(0,R.distinct)([...C,...P].filter(g=>y.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let D=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.configurationService.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};T=Se([K(0,_.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(se[261],oe([0,1,21,35,32,199,61]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function D(b){return(0,_.parse)(b)||[]}e.parseKeybindings=D;async function C(b,I,i,s,t){const n=D(b),r=D(I),a=i?D(i):null,o=[...n,...r,...a||[]].map(j=>j.key),l=await t.resolveUserBindings(o),m=P(n,r,a,l);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:I,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const E=g(n),A=g(r),O=a?g(a):null,F=d(E,A,l),M=O?d(O,E,l):{added:[...E.keys()].reduce((j,J)=>(j.add(J),j),new Set),removed:new Set,updated:new Set},k=O?d(O,A,l):{added:[...A.keys()].reduce((j,J)=>(j.add(J),j),new Set),removed:new Set,updated:new Set},N=w(F,M,k);let z=b;for(const j of N.removed.values())N.conflicts.has(j)||(z=f(z,j,s));for(const j of N.added.values()){if(N.conflicts.has(j))continue;const J=A.get(j);if(J.some(ne=>ne.command!==`-${j}`&&m.conflicts.has(l[ne.key]))){N.conflicts.add(j);continue}z=u(z,J,s)}for(const j of N.updated.values()){if(N.conflicts.has(j))continue;const J=A.get(j);if(J.some(ne=>ne.command!==`-${j}`&&m.conflicts.has(l[ne.key]))){N.conflicts.add(j);continue}z=v(z,j,J,s)}return{mergeContent:z,hasChanges:!0,hasConflicts:N.conflicts.size>0}}e.merge=C;function w(b,I,i){const s=new Set,t=new Set,n=new Set,r=new Set;for(const a of I.removed.values())i.updated.has(a)&&r.add(a);for(const a of i.removed.values())r.has(a)||(I.updated.has(a)?r.add(a):t.add(a));for(const a of I.added.values())r.has(a)||i.added.has(a)&&b.updated.has(a)&&r.add(a);for(const a of i.added.values())r.has(a)||(I.added.has(a)?b.updated.has(a)&&r.add(a):s.add(a));for(const a of I.updated.values())r.has(a)||i.updated.has(a)&&b.updated.has(a)&&r.add(a);for(const a of i.updated.values())r.has(a)||(I.updated.has(a)?b.updated.has(a)&&r.add(a):n.add(a));return{added:s,removed:t,updated:n,conflicts:r}}function P(b,I,i,s){const t=new Set,n=y(b,s),r=y(I,s),a=i?y(i,s):null,o=S(n,r);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const l=a?S(a,n):{added:[...n.keys()].reduce((M,k)=>(M.add(k),M),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const m=a?S(a,r):{added:[...r.keys()].reduce((M,k)=>(M.add(k),M),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:E,removed:A,updated:O,conflicts:F}=w(o,l,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:E,removed:A,updated:O,conflicts:F}}function y(b,I){const i=new Map;for(const s of b){const t=I[s.key];let n=i.get(t);n||(n=[],i.set(t,n)),n.push(s)}return i}function g(b){const I=new Map;for(const i of b){const s=i.command[0]==="-"?i.command.substring(1):i.command;let t=I.get(s);t||(t=[],I.set(s,t)),t.push(i)}return I}function S(b,I){const i=[...b.keys()],s=[...I.keys()],t=s.filter(a=>i.indexOf(a)===-1).reduce((a,o)=>(a.add(o),a),new Set),n=i.filter(a=>s.indexOf(a)===-1).reduce((a,o)=>(a.add(o),a),new Set),r=new Set;for(const a of i){if(n.has(a))continue;const o=b.get(a).map(m=>({...m,key:a})),l=I.get(a).map(m=>({...m,key:a}));(0,R.equals)(o,l,(m,E)=>h(m,E))||r.add(a)}return{added:t,removed:n,updated:r}}function d(b,I,i){const s=[...b.keys()],t=[...I.keys()],n=t.filter(o=>s.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),r=s.filter(o=>t.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),a=new Set;for(const o of s){if(r.has(o))continue;const l=b.get(o).map(E=>({...E,key:i[E.key]})),m=I.get(o).map(E=>({...E,key:i[E.key]}));p(l,m)||a.add(o)}return{added:n,removed:r,updated:a}}function p(b,I){return!(!(0,R.equals)(b.filter(({command:i})=>i[0]!=="-"),I.filter(({command:i})=>i[0]!=="-"),(i,s)=>h(i,s))||!(0,R.equals)(b.filter(({command:i})=>i[0]==="-"),I.filter(({command:i})=>i[0]==="-"),(i,s)=>h(i,s)))}function h(b,I){if(b.command!==I.command||b.key!==I.key)return!1;const i=T.ContextKeyExpr.deserialize(b.when),s=T.ContextKeyExpr.deserialize(I.when);return!(i&&!s||!i&&s||i&&s&&!i.equals(s)||!c.equals(b.args,I.args))}function u(b,I,i){for(const s of I)b=L.edit(b,[-1],s,i);return b}function f(b,I,i){const s=D(b);for(let t=s.length-1;t>=0;t--)(s[t].command===I||s[t].command===`-${I}`)&&(b=L.edit(b,[t],void 0,i));return b}function v(b,I,i,s){const t=D(b),n=t.findIndex(r=>r.command===I||r.command===`-${I}`);for(let r=t.length-1;r>=0;r--)(t[r].command===I||t[r].command===`-${I}`)&&(b=L.edit(b,[r],void 0,s));for(let r=i.length-1;r>=0;r--)b=L.edit(b,[n],i[r],s);return b}}),define(se[262],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,L,D){const C={},w={},P=new Set;if(!L)return{local:{added:C,updated:w,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const y=_(T,L);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:C,updated:w,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=_(D,T),S=_(D,L),d={},p={},h=new Set,u=new Set;for(const f of g.removed.values())S.updated.has(f)?C[f]=L[f]:h.add(f);for(const f of S.removed.values())u.has(f)||(g.updated.has(f)?u.add(f):P.add(f));for(const f of g.updated.values())u.has(f)||(S.updated.has(f)?y.updated.has(f)&&u.add(f):p[f]=T[f]);for(const f of S.updated.values())u.has(f)||(g.updated.has(f)?y.updated.has(f)&&u.add(f):T[f]!==void 0&&(w[f]=L[f]));for(const f of g.added.values())u.has(f)||(S.added.has(f)?y.updated.has(f)&&u.add(f):d[f]=T[f]);for(const f of S.added.values())u.has(f)||(g.added.has(f)?y.updated.has(f)&&u.add(f):C[f]=L[f]);return{local:{added:C,removed:[...P.values()],updated:w},remote:{added:d,removed:[...h.values()],updated:p},conflicts:[...u.values()]}}e.merge=R;function _(T,L){const D=T?Object.keys(T):[],C=L?Object.keys(L):[],w=C.filter(g=>D.indexOf(g)===-1).reduce((g,S)=>(g.add(S),g),new Set),P=D.filter(g=>C.indexOf(g)===-1).reduce((g,S)=>(g.add(S),g),new Set),y=new Set;for(const g of D){if(P.has(g))continue;const S=T[g],d=L[g];S!==d&&y.add(g)}return{added:w,removed:P,updated:y}}function c(T,L){const{added:D,removed:C,updated:w}=_(T,L);return D.size===0&&C.size===0&&w.size===0}e.areSame=c}),define(se[263],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(c,T,L,D){const C={added:[],removed:[],updated:[]};let w={added:[],removed:[],updated:[]};if(!T){const y=c.filter(({id:g})=>!D.includes(g));return y.length?w.added=y:w=null,{local:C,remote:w}}const P=_(c,T,D);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const y=_(L,c,D),g=_(L,T,D);for(const S of g.removed){const d=c.find(p=>p.id===S);d&&C.removed.push(d)}for(const S of g.added){const d=T.find(p=>p.id===S);y.added.includes(S)?P.updated.includes(S)&&C.updated.push(d):C.added.push(d)}for(const S of g.updated)C.updated.push(T.find(d=>d.id===S));for(const S of y.added)g.added.includes(S)||w.added.push(c.find(d=>d.id===S));for(const S of y.updated)g.removed.includes(S)||g.updated.includes(S)||w.updated.push(c.find(d=>d.id===S));for(const S of y.removed){const d=T.find(p=>p.id===S);d&&w.removed.push(d)}}return w.added.length===0&&w.removed.length===0&&w.updated.length===0&&(w=null),{local:C,remote:w}}e.merge=R;function _(c,T,L){c=c?c.filter(({id:g})=>!L.includes(g)):[],T=T.filter(({id:g})=>!L.includes(g));const D=c.map(({id:g})=>g),C=T.map(({id:g})=>g),w=C.filter(g=>D.indexOf(g)===-1),P=D.filter(g=>C.indexOf(g)===-1),y=[];for(const{id:g,name:S,shortName:d}of c){if(P.includes(g))continue;const p=T.find(h=>h.id===g);(!p||p.name!==S||p.shortName!==d)&&y.push(g)}return{added:w,removed:P,updated:y}}}),define(se[24],oe([0,1,21,12,185,46,30,5,107,40]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const r=w.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(a=>!!r[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function y(){const r=w.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(r).filter(m=>!!r[m].ignoreSync),o=Object.keys(r).filter(m=>r[m].scope===2||r[m].scope===6),l=P();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...o,...l])}e.getDefaultIgnoredSettings=y,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function g(){const r="vscode://schemas/ignoredSettings",a=w.Registry.as(T.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,c.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,c.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,c.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,c.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,c.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=w.Registry.as(C.Extensions.JSONContribution),l=()=>{const m=P(),E=y().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),A=Object.keys(T.allSettings.properties).filter(M=>E.indexOf(M)===-1),O=E.filter(M=>m.indexOf(M)===-1),F={items:{type:"string",enum:[...A,...O.map(M=>`-${M}`)]}};o.registerSchema(r,F)};return a.onDidUpdateConfiguration(()=>l())}e.registerConfiguration=g;function S(r){return r&&(0,_.isObject)(r)&&(0,_.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=S;var d;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(d=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(r,...a){return r?[r,...a]:a}e.getPathSegments=p;function h(r,a,o,l){return l.joinPath(o.userDataSyncHome,...p(r,a,`lastSync${a}.json`))}e.getLastSyncResourceUri=h,e.IUserDataSyncStoreManagementService=(0,D.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,D.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,D.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(r){const a={};return a[e.HEADER_EXECUTION_ID]=r,a}e.createSyncHeaders=u;var f;(function(r){r.Unauthorized="Unauthorized",r.NotFound="NotFound",r.MethodNotFound="MethodNotFound",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyProfiles="LocalTooManyProfiles",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.Unknown="Unknown"})(f=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class v extends Error{constructor(a,o,l,m){super(a),this.code=o,this.resource=l,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class b extends v{constructor(a,o,l,m,E){super(a,l,void 0,E),this.url=o,this.serverCode=m}}e.UserDataSyncStoreError=b;class I extends v{constructor(a,o){super(a,o)}}e.UserDataAutoSyncError=I,function(r){function a(o){if(o instanceof r)return o;const l=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(l&&l[1]){const m=l[2]==="unknown"?void 0:l[2],E=l[3]==="unknown"?void 0:l[3];return new r(o.message,l[1],m,E)}return new r(o.message,"Unknown")}r.toUserDataSyncError=a}(v=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var s;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var t;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(r){return`sync.enable.${r}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,D.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,D.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,D.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,D.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,D.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,D.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSyncLog",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(se[264],oe([0,1,32,24]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function c(L,D,C,w,P){if(!D)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const y=T(L,D);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=C?T(C,D):{added:Object.keys(D).reduce((f,v)=>(f.add(v),f),new Set),removed:new Set,updated:new Set},S=C?T(C,L):{added:Object.keys(L).reduce((f,v)=>(f.add(v),f),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},p=R.deepClone(D),h=!C;for(const f of S.added.values())f!==_.SYNC_SERVICE_URL_TYPE&&h&&g.added.has(f)||(p[f]=L[f]);for(const f of S.updated.values())p[f]=L[f];for(const f of S.removed.values())w.unregistered.includes(f)||delete p[f];for(const f of g.added.values()){const v=D[f];if(w.machine.includes(f)){P.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(C&&S.added.has(f))continue;const b=L[f];b&&b.value===v.value||f===_.SYNC_SERVICE_URL_TYPE&&h&&S.added.has(f)||(b?d.updated[f]=v:d.added[f]=v)}for(const f of g.updated.values()){const v=D[f];if(w.machine.includes(f)){P.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(S.updated.has(f)||S.removed.has(f))continue;const b=L[f];b&&b.value===v.value||(d.updated[f]=v)}for(const f of g.removed.values()){if(w.machine.includes(f)){P.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}S.updated.has(f)||S.removed.has(f)||d.removed.push(f)}const u=T(D,p);return{local:d,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:p}}}e.merge=c;function T(L,D){const C=Object.keys(L),w=Object.keys(D),P=w.filter(S=>C.indexOf(S)===-1).reduce((S,d)=>(S.add(d),S),new Set),y=C.filter(S=>w.indexOf(S)===-1).reduce((S,d)=>(S.add(d),S),new Set),g=new Set;for(const S of C){if(y.has(S))continue;const d=L[S],p=D[S];R.equals(d,p)||g.add(S)}return{added:P,removed:y,updated:g}}}),define(se[265],oe([0,1,21,35,83,43,32,61,24]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function w(o,l,m){let E=[];m?E=y(m):E=P(l);const A=[],O=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const F of E)F.startsWith("-")?O.push(F.substring(1)):A.push(F);return(0,R.distinct)([...o,...A].filter(F=>O.indexOf(F)===-1))}e.getIgnoredSettings=w;function P(o){let l=o.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=o.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:o.getValue("settingsSync.ignoredSettings")||[]}function y(o){const l=(0,_.parse)(o);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function g(o,l){const m=(0,_.parse)(o)||{};let E="{}";for(const A of Object.keys(m)){const O=(0,c.setProperty)(E,[A],m[A],l);E=(0,c.applyEdits)(E,O)}return E}e.removeComments=g;function S(o,l,m,E){if(m.length){const A=a(l),O=(0,_.parse)(l)||{},F=(0,_.parse)(o);if(!F)return o;const M=[];for(const k of m){const N=O[k],z=F[k];N===void 0?o=D.edit(o,[k],void 0,E):z!==void 0?o=D.edit(o,[k],N,E):M.push(i(k,A))}M.sort((k,N)=>k.startOffset-N.startOffset),M.forEach(k=>o=f(k.setting.key,l,o,E))}return o}e.updateIgnoredSettings=S;function d(o,l,m,E,A,O){const F=S(o,l,E,O),M=m!==F,k=m!==l;if(!M&&!k)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!k)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(k&&!M)return{conflictsSettings:[],localContent:S(l,o,E,O),remoteContent:null,hasConflicts:!1};if(m===null&&h(o)){const W=p(o,l,E)?null:S(l,o,E,O);return{conflictsSettings:[],localContent:W,remoteContent:null,hasConflicts:!1}}let N=o,z=l;const j=(0,_.parse)(o),J=(0,_.parse)(l),ne=m?(0,_.parse)(m):null,G=E.reduce((W,B)=>(W.add(B),W),new Set),q=u(j,J,G),x=u(ne,j,G),Y=u(ne,J,G),ee=new Map,re=new Set,ae=W=>{re.add(W);const B=A.filter(({key:Q})=>Q===W)[0];B?(N=D.edit(N,[W],B.value,O),z=D.edit(z,[W],B.value,O)):ee.set(W,{key:W,localValue:j[W],remoteValue:J[W]})};for(const W of x.removed.values())Y.updated.has(W)?ae(W):z=D.edit(z,[W],void 0,O);for(const W of Y.removed.values())re.has(W)||(x.updated.has(W)?ae(W):N=D.edit(N,[W],void 0,O));for(const W of x.updated.values())re.has(W)||(Y.updated.has(W)?q.updated.has(W)&&ae(W):z=D.edit(z,[W],j[W],O));for(const W of Y.updated.values())re.has(W)||(x.updated.has(W)?q.updated.has(W)&&ae(W):N=D.edit(N,[W],J[W],O));for(const W of x.added.values())re.has(W)||(Y.added.has(W)?q.updated.has(W)&&ae(W):z=f(W,N,z,O));for(const W of Y.added.values())re.has(W)||(x.added.has(W)?q.updated.has(W)&&ae(W):N=f(W,z,N,O));const V=ee.size>0||!p(N,z,E),$=V||!p(N,o,[]),U=V||!p(z,l,[]);return{localContent:$?N:null,remoteContent:U?z:null,conflictsSettings:[...ee.values()],hasConflicts:V}}e.merge=d;function p(o,l,m){if(o===l)return!0;const E=(0,_.parse)(o),A=(0,_.parse)(l),O=m.reduce((k,N)=>(k.add(N),k),new Set),F=a(o).filter(k=>!(k.setting&&O.has(k.setting.key))),M=a(l).filter(k=>!(k.setting&&O.has(k.setting.key)));if(F.length!==M.length)return!1;for(let k=0;k<F.length;k++){const N=F[k],z=M[k];if(N.setting&&z.setting){if(N.setting.key!==z.setting.key||!L.equals(E[N.setting.key],A[N.setting.key]))return!1}else if(!N.setting&&!z.setting){if(N.value!==z.value)return!1}else return!1}return!0}e.areSame=p;function h(o){return o?a(o).length===0:!0}e.isEmpty=h;function u(o,l,m){const E=o?Object.keys(o).filter(k=>!m.has(k)):[],A=Object.keys(l).filter(k=>!m.has(k)),O=A.filter(k=>E.indexOf(k)===-1).reduce((k,N)=>(k.add(N),k),new Set),F=E.filter(k=>A.indexOf(k)===-1).reduce((k,N)=>(k.add(N),k),new Set),M=new Set;if(o)for(const k of E){if(F.has(k))continue;const N=o[k],z=l[k];L.equals(N,z)||M.add(k)}return{added:O,removed:F,updated:M}}function f(o,l,m,E){const A=(0,_.parse)(l),O=a(l),F=a(m),M=v(o,O,F);return b(m,o,A[o],M,F,E)}e.addSetting=f;function v(o,l,m){const E=l.findIndex(O=>O.setting?.key===o),A=l[E-1];if(A){if(A.setting){const F=i(A.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!0}}else{const F=s(E,l);if(F){const M=i(F.setting.key,m);if(M){const k=t(m.indexOf(M),m),N=n(l,F,l[E]);if(k){const z=n(m,M,k),j=r(N,z);return j?{index:m.indexOf(j),insertAfter:!0}:{index:m.indexOf(k),insertAfter:!1}}else{const z=n(m,M,m[m.length-1]),j=r(N,z);return j?{index:m.indexOf(j),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const O=l[E+1];if(O)if(O.setting){const F=i(O.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!1}}else{const F=t(E,l);if(F){const M=i(F.setting.key,m);if(M){const k=s(m.indexOf(M),m),N=n(l,l[E],F);if(k){const z=n(m,k,M),j=r(N.reverse(),z.reverse());return j?{index:m.indexOf(j),insertAfter:!1}:{index:m.indexOf(k),insertAfter:!0}}else{const z=n(m,m[0],M),j=r(N.reverse(),z.reverse());return j?{index:m.indexOf(j),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function b(o,l,m,E,A,O){let F;return E.index===-1?F=(0,c.setProperty)(o,[l],m,O):F=I(o,l,m,E,A,O).map(M=>(0,c.withFormatting)(o,M,O)[0]),(0,c.applyEdits)(o,F)}function I(o,l,m,E,A,O){const F=`${JSON.stringify(l)}: ${JSON.stringify(m)}`,M=(0,T.getEOL)(O,o),k=A[E.index];if(E.insertAfter){const N=[];if(k.setting)N.push({offset:k.endOffset,length:0,content:","+F});else{const z=t(E.index,A),j=s(E.index,A),J=j?.setting?.commaOffset;j&&J===void 0&&N.push({offset:j.endOffset,length:0,content:","});const ne=J!==void 0&&J>k.endOffset;N.push({offset:ne?J+1:k.endOffset,length:0,content:z?M+F+",":M+F})}return N}else{if(k.setting)return[{offset:k.startOffset,length:0,content:F+","}];const N=(A[E.index-1]&&!A[E.index-1].setting?M:"")+F+(t(E.index,A)?",":"")+M;return[{offset:k.startOffset,length:0,content:N}]}}function i(o,l){return l.filter(m=>m.setting?.key===o)[0]}function s(o,l){for(let m=o-1;m>=0;m--)if(l[m].setting)return l[m]}function t(o,l){for(let m=o+1;m<l.length;m++)if(l[m].setting)return l[m]}function n(o,l,m){const E=o.indexOf(l),A=o.indexOf(m);return o.filter((O,F)=>E<F&&F<A)}function r(o,l){if(o.length&&l.length){let m=0;for(;m<l.length&&m<o.length;m++)if(o[m].value!==l[m].value)return l[m-1];return l[m-1]}}function a(o){const l=[];let m=-1,E,A;const O={onObjectBegin:F=>{m++},onObjectProperty:(F,M,k)=>{m===0&&(E=M,A=F)},onObjectEnd:(F,M)=>{m--,m===0&&l.push({startOffset:E,endOffset:F+M,value:o.substring(E,F+M),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(F,M)=>{m++},onArrayEnd:(F,M)=>{m--,m===0&&l.push({startOffset:E,endOffset:F+M,value:o.substring(E,F+M),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(F,M,k)=>{m===0&&l.push({startOffset:E,endOffset:M+k,value:o.substring(E,M+k),setting:{key:A,commaOffset:void 0}})},onSeparator:(F,M,k)=>{if(m===0&&F===","){let N=l.length-1;for(;N>=0&&!l[N].setting;N--);const z=l[N];z&&l.splice(N,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:M}})}},onComment:(F,M)=>{m===0&&l.push({startOffset:F,endOffset:F+M,value:o.substring(F,F+M)})}};return(0,_.visit)(o,O),l}}),define(se[78],oe([0,1,3,2,5,24]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,c.createDecorator)("IUserDataSyncAccountService");let L=class extends _.Disposable{get account(){return this._account}constructor(C,w){super(),this.userDataSyncStoreService=C,this.logService=w,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};L=Se([K(0,T.IUserDataSyncStoreService),K(1,T.IUserDataSyncLogService)],L),e.UserDataSyncAccountService=L}),define(se[266],oe([0,1,2,11]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class c{constructor(g){this.service=g}listen(g,S){switch(S){case"onError":return this.service.onError}throw new Error(`Event not found: ${S}`)}call(g,S,d){switch(S){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=c;class T{constructor(g){this.service=g}listen(g,S){throw new Error(`Event not found: ${S}`)}call(g,S,d){switch(S){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(_.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class L{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=L;class D{constructor(g){this.service=g}listen(g,S){switch(S){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${S}`)}async call(g,S,d){switch(S){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=D;class C{constructor(g){this.service=g}listen(g,S){switch(S){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${S}`)}call(g,S,d){switch(S){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class w{constructor(g){this.service=g}listen(g,S){switch(S){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${S}`)}call(g,S,d){switch(S){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class P extends R.Disposable{constructor(g){super(),this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:_.URI.revive(g.url),type:g.type,defaultUrl:_.URI.revive(g.defaultUrl),insidersUrl:_.URI.revive(g.insidersUrl),stableUrl:_.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(se[267],oe([0,1,186,15,8,24]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends c.AbstractLogger{constructor(C,w){super(),this.logger=this._register(C.createLogger(w.userDataSyncLogResource,{id:T.USER_DATA_SYNC_LOG_ID,name:(0,R.localize)(0,null)}))}trace(C,...w){this.logger.trace(C,...w)}debug(C,...w){this.logger.debug(C,...w)}info(C,...w){this.logger.info(C,...w)}warn(C,...w){this.logger.warn(C,...w)}error(C,...w){this.logger.error(C,...w)}flush(){this.logger.flush()}};L=Se([K(0,c.ILoggerService),K(1,_.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(se[268],oe([0,1,6,3,2]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends c.Disposable{constructor({onDidOpenWindow:D,onDidFocusWindow:C,getActiveWindowId:w}){super(),this.disposables=this._register(new c.DisposableStore),_.Event.latch(_.Event.any(D,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>w()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(D){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=D}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(se[118],oe([0,1,189,13,49,23,11,5,22]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function w(t){const n=t;return typeof n?.id=="string"&&L.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=w;function P(t){return typeof t?.id=="string"&&!w(t)&&!g(t)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,_.basename)(t)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=y;function g(t){const n=t;return typeof n?.id=="string"&&L.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=g;function S(t){const n=t;if(n?.uri)return{id:n.id,uri:L.URI.revive(n.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=S;var d;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function p(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=p;function h(t){const n=t;return!!(n&&typeof n=="object"&&L.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=h;class u{constructor(n,r,a,o,l){this._id=n,this._transient=a,this._configuration=o,this._ignorePathCasing=l,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class f{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,T.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function v(t){return new f({uri:t,index:0,name:(0,T.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(t,n){return T.extUriBiasedIgnorePathCase.isEqualOrParent(t,n.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function I(t){let n;return L.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===C.Schemas.tmp}e.isTemporaryWorkspace=I;function i(t,n){return!b(t,n)&&!I(t)}e.isSavedWorkspace=i;function s(t){return(typeof t=="string"?(0,_.extname)(t):(0,T.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(se[18],oe([0,1,66,3,2,23,11,180,15,14,5,8,118,37,29,6,31,27,12]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function v(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&L.URI.isUri(n.location)&&L.URI.isUri(n.globalStorageHome)&&L.URI.isUri(n.settingsResource)&&L.URI.isUri(n.keybindingsResource)&&L.URI.isUri(n.tasksResource)&&L.URI.isUri(n.snippetsHome)&&L.URI.isUri(n.extensionsResource))}e.isUserDataProfile=v,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function b(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:L.URI.revive(t.location).with({scheme:n}),globalStorageHome:L.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:L.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:L.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:L.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:L.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:L.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=b;function I(t,n,r,a){return{id:t,name:n,location:r,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,T.joinPath)(r,"globalStorage"),settingsResource:(0,T.joinPath)(r,"settings.json"),keybindingsResource:(0,T.joinPath)(r,"keybindings.json"),tasksResource:(0,T.joinPath)(r,"tasks.json"),snippetsHome:(0,T.joinPath)(r,"snippets"),extensionsResource:(0,T.joinPath)(r,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=I;let i=class extends c.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,r,a,o){super(),this.environmentService=n,this.fileService=r,this.uriIdentityService=a,this.logService=o,this.enabled=!0,this._onDidChangeProfiles=this._register(new _.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new _.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new _.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new _.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new S.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=[];if(this.enabled)for(const l of this.getStoredProfiles()){if(!l.name||!(0,f.isString)(l.name)||!l.location){this.logService.warn("Skipping the invalid stored profile",l.location||l.name);continue}n.push(I((0,T.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}const r=new S.ResourceMap,a=new Map,o=this.createDefaultProfile();if(n.unshift({...o,extensionsResource:this.getDefaultProfileExtensionsLocation()??o.extensionsResource,isDefault:!0}),n.length){const l=this.getStoredProfileAssociations();if(l.workspaces)for(const[m,E]of Object.entries(l.workspaces)){const A=L.URI.parse(m),O=n.find(F=>F.id===E);O&&r.set(A,O)}if(l.emptyWindows)for(const[m,E]of Object.entries(l.emptyWindows)){const A=n.find(O=>O.id===E);A&&a.set(m,A)}}this._profilesObject={profiles:n,workspaces:r,emptyWindows:a}}return this._profilesObject}createDefaultProfile(){return I("__default__profile__",(0,D.localize)(0,null),this.environmentService.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let o=0;for(const m of this.profiles){const E=a.exec(m.name),A=E?parseInt(E[1]):0;o=A>o?A:o}const l=`${r} ${o+1}`;return this.createProfile((0,R.hash)((0,h.generateUuid)()).toString(16),l,{transient:!0},n)}async createNamedProfile(n,r,a){return this.createProfile((0,R.hash)((0,h.generateUuid)()).toString(16),n,r,a)}async createProfile(n,r,a,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const l=await this.doCreateProfile(n,r,a);return o&&await this.setProfileForWorkspace(o,l),l}async doCreateProfile(n,r,a){if(!(0,f.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.profileCreationPromises.get(r);return o||(o=(async()=>{try{const l=this.profiles.find(A=>A.name===r||A.id===n);if(l)return l;const m=I(n,r,(0,T.joinPath)(this.profilesHome,n),a);await this.fileService.createFolder(m.location);const E=[];return this._onWillCreateProfile.fire({profile:m,join(A){E.push(A)}}),await p.Promises.settled(E),this.updateProfiles([m],[],[]),m}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,o)),o}async updateProfile(n,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(o=>o.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=I(a.id,r.name??a.name,a.location,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags}),this.updateProfiles([],[],[a]),a}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(o=>o.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(o){a.push(o)}});try{await Promise.allSettled(a)}catch(o){this.logService.error(o)}for(const o of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(o)?.id&&this.profilesObject.emptyWindows.delete(o);for(const o of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(o){this.logService.error(o)}}async setProfileForWorkspace(n,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(o=>o.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(n,a)}unsetWorkspace(n,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.getWorkspace(n);return L.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location)))}updateProfiles(n,r,a){const o=[...this.profiles,...n],l=[];this.transientProfilesObject.profiles=[];for(let m of o)m.isDefault||r.some(E=>m.id===E.id)||(m=a.find(E=>m.id===E.id)??m,m.isTransient?this.transientProfilesObject.profiles.push(m):l.push({location:m.location,name:m.name,shortName:m.shortName,useDefaultFlags:m.useDefaultFlags}));this.saveStoredProfiles(l),this._profilesObject=void 0,this.triggerProfilesChanges(n,r,a)}triggerProfilesChanges(n,r,a){this._onDidChangeProfiles.fire({added:n,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(n,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(n,void 0,!0);const o=this.getWorkspace(n),l=a?this.transientProfilesObject:this.profilesObject;L.URI.isUri(o)?(l.workspaces.delete(o),r&&l.workspaces.set(o,r)):(l.emptyWindows.delete(o),r&&l.emptyWindows.set(o,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[a,o]of this.profilesObject.workspaces.entries())n[a.toString()]=o.id;const r={};for(const[a,o]of this.profilesObject.emptyWindows.entries())r[a.toString()]=o.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const r={},a=this.createDefaultProfile();if(n.workspaces)for(const[l,m]of Object.entries(n.workspaces)){const E=L.URI.parse(m);r[l]=this.uriIdentityService.extUri.isEqual(E,a.location)?a.id:this.uriIdentityService.extUri.basename(E)}const o={};if(n.emptyWindows)for(const[l,m]of Object.entries(n.emptyWindows)){const E=L.URI.parse(m);o[l]=this.uriIdentityService.extUri.isEqual(E,a.location)?a.id:this.uriIdentityService.extUri.basename(E)}return{workspaces:r,emptyWindows:o}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=Se([K(0,C.IEnvironmentService),K(1,w.IFileService),K(2,d.IUriIdentityService),K(3,y.ILogService)],i),e.UserDataProfilesService=i;class s extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(se[269],oe([0,1,6,2,18]),function(Z,e,R,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=class extends _.Disposable{constructor(D){super(),this._register(new R.RunOnceScheduler(()=>{D.cleanUp()},10*1e3)).schedule()}};T=Se([K(0,c.IUserDataProfilesService)],T),e.UserDataProfilesCleaner=T}),define(se[270],oe([0,1,21,6,25,9,3,2,4,11,159,30,33,42,8,26,19,18]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var f;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(f=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let v=class extends D.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(n,r,a,o,l){super(),this.galleryService=n,this.telemetryService=r,this.logService=a,this.productService=o,this.userDataProfilesService=l,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(({task:m})=>m.cancel()),this.uninstallingExtensions.forEach(m=>m.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,y.isTargetPlatformCompatible)(a,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.galleryService.isEnabled())throw new y.ExtensionManagementError(P.localize(0,null),y.ExtensionManagementErrorCode.Internal);const a=await this.checkAndGetCompatibleVersion(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(a.manifest,a.extension,r)}catch(a){throw i(this.telemetryService,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(n),error:a}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(a),I(a)}}async uninstall(n,r={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,r,a){const o={...a,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,S.isApplicationScopedExtension)(n)?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},l=M=>`${g.ExtensionKey.create(M).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!w.URI.isUri(r)){const M=this.installingExtensions.get(l(r));if(M){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:k}=await M.task.waitUntilTaskIsFinished();return k}}const m=[],E=[],A=[],O=this.createInstallExtensionTask(n,r,o);w.URI.isUri(r)||this.installingExtensions.set(l(r),{task:O,waitingTasks:[]}),this._onInstallExtension.fire({identifier:O.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",O.identifier.id),m.push({task:O,manifest:n});let F=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const k=await this.getAllDepsAndPackExtensions(O.identifier,n,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),N=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:z,manifest:j}of(0,R.distinct)(k,({gallery:J})=>J.identifier.id)){F=F||!!j.extensionDependencies?.some(G=>(0,g.areSameExtensions)({id:G},O.identifier));const J=l(z),ne=this.installingExtensions.get(J);if(ne){if(this.canWaitForTask(O,ne.task)){const G=ne.task.identifier;this.logService.info("Waiting for already requested installing extension",G.id,O.identifier.id),ne.waitingTasks.push(O),E.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,q=>q.some(x=>(0,g.areSameExtensions)(x.identifier,G)))).then(q=>{if(this.logService.info("Finished waiting for already requested installing extension",G.id,O.identifier.id),!q.find(Y=>(0,g.areSameExtensions)(Y.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!N.some(({identifier:G})=>(0,g.areSameExtensions)(G,z.identifier))){const G=this.createInstallExtensionTask(j,z,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(J,{task:G,waitingTasks:[O]}),this._onInstallExtension.fire({identifier:G.identifier,source:z,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",G.identifier.id,O.identifier.id),m.push({task:G,manifest:j})}}}catch(k){if(w.URI.isUri(O.source))(0,R.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",O.identifier.id,k.message),(0,R.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",O.identifier.id,k.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),k}const M=m.reduce((k,{task:N,manifest:z})=>(k.set(N.identifier.id.toLowerCase(),{task:N,manifest:z}),k),new Map);for(;M.size;){let k;const N=[...M.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(j=>M.has(j.toLowerCase())));N.length?k=M.size===1?N:N.filter(({task:z})=>!(z===O&&!F)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:z})=>z.identifier.id)),k=[...M.values()]),await this.joinAllSettled(k.map(async({task:z})=>{const j=new Date().getTime();try{const{local:J}=await z.run();if(await this.joinAllSettled(this.participants.map(ne=>ne.postInstall(J,z.source,o,c.CancellationToken.None))),!w.URI.isUri(z.source)){const ne=z.operation===3,G=ne?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(i(this.telemetryService,ne?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-j,durationSinceUpdate:G}),C.isWeb&&z.operation!==3)try{await this.galleryService.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}A.push({local:J,identifier:z.identifier,operation:z.operation,source:z.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw w.URI.isUri(z.source)||i(this.telemetryService,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-j,error:J}),this.logService.error("Error while installing the extension:",z.identifier.id),J}finally{M.delete(z.identifier.id.toLowerCase())}}))}return E.length&&await this.joinAllSettled(E),A.forEach(({identifier:k})=>this.logService.info("Extension installed successfully:",k.id)),this._onDidInstallExtensions.fire(A),A.filter(({identifier:k})=>(0,g.areSameExtensions)(k,O.identifier))[0].local}catch(M){if(m.forEach(({task:k})=>k.cancel()),A.length)try{const k=await Promise.allSettled(A.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let N=0;N<k.length;N++){const z=k[N],{identifier:j}=A[N];z.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",j.id):this.logService.warn("Rollback: Error while uninstalling extension",j.id,(0,T.getErrorMessage)(z.reason))}}catch(k){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(k),A.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(m.map(({task:k})=>({identifier:k.identifier,operation:2,source:k.source,context:o.context,profileLocation:o.profileLocation}))),M}finally{for(const{task:M}of m)M.source&&!w.URI.isUri(M.source)&&this.installingExtensions.delete(l(M.source))}}canWaitForTask(n,r){for(const[,{task:a,waitingTasks:o}]of this.installingExtensions.entries())if(a===n&&(o.includes(r)||o.some(l=>this.canWaitForTask(l,r)))||a===r&&o[0]&&!this.canWaitForTask(n,o[0]))return!1;return!0}async joinAllSettled(n){const r=[],a=[],o=await Promise.allSettled(n);for(const l of o)l.status==="fulfilled"?r.push(l.value):a.push(l.reason);if(a.length)throw b(a);return r}async getAllDepsAndPackExtensions(n,r,a,o,l){if(!this.galleryService.isEnabled())return[];const m=await this.getInstalled(void 0,l),E=[],A=[],O=async(F,M)=>{E.push(F);const k=M.extensionDependencies||[],N=[...k];if(M.extensionPack){const z=a?m.find(j=>(0,g.areSameExtensions)(j.identifier,F)):void 0;for(const j of M.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(J=>(0,g.areSameExtensions)({id:J},{id:j}))||N.every(J=>!(0,g.areSameExtensions)({id:J},{id:j}))&&N.push(j)}if(N.length){const z=N.filter(j=>E.every(J=>!(0,g.areSameExtensions)(J,{id:j})));if(z.length){const j=await this.galleryService.getExtensions(z.map(J=>({id:J,preRelease:o})),c.CancellationToken.None);for(const J of j){if(E.find(q=>(0,g.areSameExtensions)(q,J.identifier)))continue;const ne=k.some(q=>(0,g.areSameExtensions)({id:q},J.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(J,!1,o)}catch(q){if(q instanceof y.ExtensionManagementError&&q.code===y.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ne){this.logService.info("Skipping the packed extension as it cannot be installed",J.identifier.id);continue}else throw q}A.push({gallery:G.extension,manifest:G.manifest}),await O(G.extension.identifier,G.manifest)}}}};return await O(n,r),A}async checkAndGetCompatibleVersion(n,r,a){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,g.areSameExtensions)(n.identifier,E)))throw new y.ExtensionManagementError(P.localize(1,null,n.identifier.id),y.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const E=await this.getTargetPlatform();throw new y.ExtensionManagementError(P.localize(2,null,n.identifier.id,this.productService.nameLong,(0,y.TargetPlatformToString)(E)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(n,r,a);if(l){if(a&&!r&&n.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new y.ExtensionManagementError(P.localize(3,null,n.identifier.id,this.productService.nameLong,this.productService.version),y.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],c.CancellationToken.None))[0]?new y.ExtensionManagementError(P.localize(4,null,n.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.ExtensionManagementError(P.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),y.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const m=await this.galleryService.getManifest(l,c.CancellationToken.None);if(m===null)throw new y.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(m.version!==l.version)throw new y.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:m}}async getCompatibleVersion(n,r,a){const o=await this.getTargetPlatform();let l=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(l=(await this.galleryService.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:o,compatible:!0},c.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(n,a,o)&&(l=n),l||(r?l=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},c.CancellationToken.None))[0]||null:l=await this.galleryService.getCompatibleExtension(n,a,o)),l}async uninstallExtension(n,r){const a={...r,profileLocation:n.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},o=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,l=this.uninstallingExtensions.get(o(n.identifier));if(l)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),l.waitUntilTaskIsFinished();const m=F=>{const M=this.createUninstallExtensionTask(F,a);return this.uninstallingExtensions.set(o(M.extension.identifier),M),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this._onUninstallExtension.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},E=(F,M)=>{M?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.logService.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),i(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(F),error:M}),this._onDidUninstallExtension.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},A=[],O=[];try{A.push(m(n));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const M=this.getAllPackExtensionsToUninstall(n,F);for(const k of M)this.uninstallingExtensions.has(o(k.identifier))?this.logService.info("Extensions is already requested to uninstall",k.identifier.id):A.push(m(k))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(A.map(M=>M.extension),F,n),await this.joinAllSettled(A.map(async M=>{try{if(await M.run(),await this.joinAllSettled(this.participants.map(k=>k.postUninstall(M.extension,a,c.CancellationToken.None))),M.extension.identifier.uuid)try{await this.galleryService.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}E(M.extension)}catch(k){const N=k instanceof y.ExtensionManagementError?k:new y.ExtensionManagementError((0,T.getErrorMessage)(k),y.ExtensionManagementErrorCode.Internal);throw E(M.extension,N),N}finally{O.push(M)}}))}catch(F){const M=F instanceof y.ExtensionManagementError?F:new y.ExtensionManagementError((0,T.getErrorMessage)(F),y.ExtensionManagementErrorCode.Internal);for(const k of A){try{k.cancel()}catch{}O.includes(k)||E(k.extension,M)}throw M}finally{for(const F of A)this.uninstallingExtensions.delete(o(F.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}checkForDependents(n,r,a){for(const o of n){const l=this.getDependents(o,r);if(l.length){const m=l.filter(E=>!n.some(A=>(0,g.areSameExtensions)(A.identifier,E.identifier)));if(m.length)throw new Error(this.getDependentsErrorMessage(o,m,a))}}}getDependentsErrorMessage(n,r,a){return a===n?r.length===1?P.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?P.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(n,r,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const l=r.filter(E=>!E.isBuiltin&&o.some(A=>(0,g.areSameExtensions)({id:A},E.identifier))),m=[];for(const E of l)m.push(...this.getAllPackExtensionsToUninstall(E,r,a));return[...l,...m]}return[]}getDependents(n,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(o=>(0,g.areSameExtensions)({id:o},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};v=Se([K(0,y.IExtensionGalleryService),K(1,h.ITelemetryService),K(2,d.ILogService),K(3,p.IProductService),K(4,u.IUserDataProfilesService)],v),e.AbstractExtensionManagementService=v;function b(t){const n=Array.isArray(t)?t:[t];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=b;function I(t){if(t instanceof y.ExtensionManagementError)return t;const n=new y.ExtensionManagementError(t.message,y.ExtensionManagementErrorCode.Internal);return n.stack=t.stack,n}function i(t,n,{extensionData:r,verificationStatus:a,duration:o,error:l,durationSinceUpdate:m}){let E,A;l&&(l instanceof y.ExtensionManagementError?(E=l.code,l.code===y.ExtensionManagementErrorCode.Signature&&(A=l.message)):E=y.ExtensionManagementErrorCode.Internal),t.publicLog(n,{...r,verificationStatus:a,success:!l,duration:o,errorcode:E,errorcodeDetail:A,durationSinceUpdate:m})}e.reportTelemetry=i;class s{constructor(){this.barrier=new _.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(n=>new Promise((r,a)=>{const o=n.onCancellationRequested(()=>{o.dispose(),a(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=s}),define(se[51],oe([0,1,6,17,2,3,37,11,33,42,14,5,8,18,29,12,9,19]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class v extends Error{constructor(t,n){super(t),this.code=n}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let b=class extends c.Disposable{constructor(t,n,r,a,o,l){super(),this.extensionsLocation=t,this.fileService=n,this.userDataProfilesService=r,this.uriIdentityService=a,this.telemetryService=o,this.logService=l,this._onAddExtensions=this._register(new T.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new T.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new T.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new T.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(t,n){return this.withProfileExtensions(t,void 0,n)}async addExtensionsToProfile(t,n){const r=[],a=[];try{return await this.withProfileExtensions(n,o=>{const l=[];for(const m of o)t.some(([E])=>(0,C.areSameExtensions)(E.identifier,m.identifier)&&E.manifest.version!==m.version)?r.push(m):l.push(m);for(const[m,E]of t)if(!l.some(A=>(0,C.areSameExtensions)(A.identifier,m.identifier)&&A.version===m.manifest.version)){const A={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:E};a.push(A),l.push(A)}return a.length&&this._onAddExtensions.fire({extensions:a,profileLocation:n}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),l}),a.length&&this._onDidAddExtensions.fire({extensions:a,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n}),a}catch(o){throw a.length&&this._onDidAddExtensions.fire({extensions:a,error:o,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:o,profileLocation:n}),o}}async updateMetadata(t,n){const r=[];return await this.withProfileExtensions(n,a=>{const o=[];for(const l of a){const m=t.find(([E])=>(0,C.areSameExtensions)(E.identifier,l.identifier)&&E.manifest.version===l.version);m&&(l.metadata={...l.metadata,...m[1]},r.push(l)),o.push(l)}return o}),r}async removeExtensionFromProfile(t,n){const r=[];this._onRemoveExtensions.fire({extensions:r,profileLocation:n});try{await this.withProfileExtensions(n,a=>{const o=[];for(const l of a)(0,C.areSameExtensions)(l.identifier,t.identifier)?r.push(l):o.push(l);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),o}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n})}catch(a){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:a,profileLocation:n}),a}}async withProfileExtensions(t,n,r){return this.getResourceAccessQueue(t).queue(async()=>{let a=[],o;try{const l=await this.fileService.readFile(t);o=JSON.parse(l.value.toString())}catch(l){if((0,P.toFileOperationResult)(l)!==1)throw l;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(o=await this.migrateFromOldDefaultProfileExtensionsLocation()),!o&&r?.bailOutWhenFileNotFound)throw new v((0,h.getErrorMessage)(l),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.reportAndThrowInvalidConentError(t);let l=!1;for(const m of o){I(m)||this.reportAndThrowInvalidConentError(t);let E;if((0,p.isString)(m.relativeLocation))E=this.resolveExtensionLocation(m.relativeLocation);else if((0,p.isString)(m.location))E=this.resolveExtensionLocation(m.location),l=!0,m.relativeLocation=m.location,m.location=E.toJSON();else{E=D.URI.revive(m.location);const A=this.toRelativePath(E);A&&(l=!0,m.relativeLocation=A)}a.push({identifier:m.identifier,location:E,version:m.version,metadata:m.metadata})}l&&await this.fileService.writeFile(t,_.VSBuffer.fromString(JSON.stringify(o)))}if(n){a=n(a);const l=a.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.toRelativePath(m.location),metadata:m.metadata}));await this.fileService.writeFile(t,_.VSBuffer.fromString(JSON.stringify(l)))}return a})}reportAndThrowInvalidConentError(t){const n=new v(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(t){return this.uriIdentityService.extUri.isEqualOrParent(t,this.extensionsLocation)?this.uriIdentityService.extUri.relativePath(this.extensionsLocation,t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json");let n;try{n=(await this.fileService.readFile(t)).value.toString()}catch(a){if((0,P.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",t.toString());let r;try{const a=JSON.parse(n);Array.isArray(a)&&a.every(o=>I(o))?r=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,_.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(t)}catch(a){(0,P.toFileOperationResult)(a)!==1&&this.logService.error(a)}return r})()),this._migrationPromise}getResourceAccessQueue(t){let n=this.resourcesAccessQueueMap.get(t);return n||(n=new R.Queue,this.resourcesAccessQueueMap.set(t,n)),n}};b=Se([K(1,P.IFileService),K(2,S.IUserDataProfilesService),K(3,d.IUriIdentityService),K(4,u.ITelemetryService),K(5,g.ILogService)],b),e.AbstractExtensionsProfileScannerService=b;function I(s){return(0,p.isObject)(s)&&(0,w.isIExtensionIdentifier)(s.identifier)&&(i(s.location)||(0,p.isString)(s.location))&&((0,p.isUndefined)(s.relativeLocation)||(0,p.isString)(s.relativeLocation))&&s.version&&(0,p.isString)(s.version)}function i(s){return s?(0,p.isString)(s.path)&&(0,p.isString)(s.scheme):!1}}),define(se[79],oe([0,1,21,6,32,17,9,35,142,2,22,13,4,23,54,89,12,11,162,15,33,42,70,14,5,8,26,3,67,51,18,29,194,195]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b,I,i,s,t,n,r,a,o,l,m,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(ne){function G(q,x){if(q===x)return!0;const Y=Object.keys(q),ee=new Set;for(const re of Object.keys(x))ee.add(re);if(Y.length!==ee.size)return!1;for(const re of Y){if(q[re]!==x[re])return!1;ee.delete(re)}return ee.size===0}ne.equals=G})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let M=class extends w.Disposable{constructor(G,q,x,Y,ee,re,ae,V,$,U,W,B){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=q,this.extensionsControlLocation=x,this.cacheLocation=Y,this.userDataProfilesService=ee,this.extensionsProfileScannerService=re,this.fileService=ae,this.logService=V,this.environmentService=$,this.productService=U,this.uriIdentityService=W,this.instantiationService=B,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,S.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,(0,S.joinPath)(this.cacheLocation,I.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,(0,S.joinPath)(this.cacheLocation,I.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(N,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,b.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,q,x){const[Y,ee]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(q)]),re=x?await this.scanExtensionsUnderDevelopment(G,[...Y,...ee]):[];return this.dedupExtensions(Y,ee,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const q=[];q.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),q.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[x,Y]=await Promise.all(q);return this.applyScanOptions([...x,...Y],0,G,!1)}async scanUserExtensions(G){const q=G.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",q);const x=this.uriIdentityService.extUri.isEqual(G.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,Y=await this.createExtensionScannerInput(q,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,x),ee=G.useCache&&!Y.devMode&&Y.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let re;try{re=await ee.scanExtensions(Y)}catch(ae){if(ae instanceof l.ExtensionsProfileScanningError&&ae.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),re=await ee.scanExtensions(Y);else throw ae}return re=await this.applyScanOptions(re,1,G,!0),this.logService.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(G,q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(Y=>Y.scheme===P.Schemas.file).map(async Y=>{const ee=await this.createExtensionScannerInput(Y,!1,1,!0,G.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ee)).map(ae=>(ae.type=q.find(V=>(0,b.areSameExtensions)(V.identifier,ae.identifier))?.type??ae.type,this.extensionsScanner.validate(ae,ee)))}))).flat();return this.applyScanOptions(x,"development",G,!0)}return[]}async scanExistingExtension(G,q,x){const Y=await this.createExtensionScannerInput(G,!1,q,!0,x.language,!0,void 0),ee=await this.extensionsScanner.scanExtension(Y);return!ee||!x.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(G,q,x){const Y=await this.createExtensionScannerInput(G,!1,q,!0,x.language,!0,void 0),ee=await this.extensionsScanner.scanOneOrMultipleExtensions(Y);return this.applyScanOptions(ee,q,x,!0)}async scanMetadata(G){const q=(0,S.joinPath)(G,"package.json"),x=(await this.fileService.readFile(q)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(G,q){const x=(0,S.joinPath)(G,"package.json"),Y=(await this.fileService.readFile(x)).value.toString(),ee=JSON.parse(Y);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.installedTimestamp=q.installedTimestamp||void 0,ee.__metadata={...ee.__metadata,...q},await this.fileService.writeFile((0,S.joinPath)(G,"package.json"),T.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof l.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw G}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.extensionsProfileScannerService.addExtensionsToProfile(G.map(q=>[q,q.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify([])))}catch(q){(0,s.toFileOperationResult)(q)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(q))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.logService.error(G)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(G,q,x,Y){return x.includeAllVersions||(G=this.dedupExtensions(q===0?G:void 0,q===1?G:void 0,q==="development"?G:void 0,await this.getTargetPlatform(),Y)),x.includeInvalid||(G=G.filter(ee=>ee.isValid)),G.sort((ee,re)=>{const ae=y.basename(ee.location.fsPath),V=y.basename(re.location.fsPath);return ae<V?-1:ae>V?1:0})}dedupExtensions(G,q,x,Y,ee){const re=(V,$,U)=>{if(V.isValid&&!$.isValid)return!1;if(V.isValid===$.isValid){if(ee&&d.gt(V.manifest.version,$.manifest.version))return this.logService.debug(`Skipping extension ${$.location.path} with lower version ${$.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(d.eq(V.manifest.version,$.manifest.version)){if(V.type===0)return this.logService.debug(`Skipping extension ${$.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===Y)return this.logService.debug(`Skipping extension ${$.location.path} from different target platform ${$.targetPlatform}`),!1}}return U?this.logService.warn(`Overwriting user extension ${V.location.path} with ${$.location.path}.`):this.logService.debug(`Overwriting user extension ${V.location.path} with ${$.location.path}.`),!0},ae=new Map;return G?.forEach(V=>{const $=I.ExtensionIdentifier.toKey(V.identifier.id),U=ae.get($);(!U||re(U,V,!1))&&ae.set($,V)}),q?.forEach(V=>{const $=I.ExtensionIdentifier.toKey(V.identifier.id),U=ae.get($);if(!U&&G&&V.type===0){this.logService.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!U||re(U,V,!1))&&ae.set($,V)}),x?.forEach(V=>{const $=I.ExtensionIdentifier.toKey(V.identifier.id),U=ae.get($);(!U||re(U,V,!0))&&ae.set($,V),ae.set($,V)}),[...ae.values()]}async scanDefaultSystemExtensions(G,q){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,q,!0,void 0),ee=await(G&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",ee.length),ee}async scanDevSystemExtensions(G,q){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const Y=q?await this.getBuiltInExtensionControl():{},ee=[],re=u.URI.file(y.normalize(y.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of x){const $=Y[V.name]||"marketplace";switch($){case"disabled":break;case"marketplace":ee.push((0,S.joinPath)(re,V.name));break;default:ee.push(u.URI.file($));break}}const ae=await Promise.all(ee.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,!1,0,!0,G,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",ae.length),(0,R.coalesce)(ae)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,q,x,Y,ee,re,ae){const V=await this.getTranslations(ee??g.language),$=await this.getMtime(G),U=q&&!this.uriIdentityService.extUri.isEqual(G,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,W=U?await this.getMtime(U):void 0;return new k(G,$,U,W,q,ae,x,Y,re,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ee,V)}async getMtime(G){try{const q=await this.fileService.stat(G);if(typeof q.mtime=="number")return q.mtime}catch{}}};M=Se([K(4,m.IUserDataProfilesService),K(5,l.IExtensionsProfileScannerService),K(6,s.IFileService),K(7,n.ILogService),K(8,v.IEnvironmentService),K(9,r.IProductService),K(10,E.IUriIdentityService),K(11,t.IInstantiationService)],M),e.AbstractExtensionsScannerService=M;class k{constructor(G,q,x,Y,ee,re,ae,V,$,U,W,B,Q,H,X){this.location=G,this.mtime=q,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=Y,this.profile=ee,this.profileScanOptions=re,this.type=ae,this.excludeObsolete=V,this.validate=$,this.productVersion=U,this.productDate=W,this.productCommit=B,this.devMode=Q,this.language=H,this.translations=X}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,q){return(0,S.isEqual)(G.location,q.location)&&G.mtime===q.mtime&&(0,S.isEqual)(G.applicationExtensionslocation,q.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&G.profile===q.profile&&c.equals(G.profileScanOptions,q.profileScanOptions)&&G.type===q.type&&G.excludeObsolete===q.excludeObsolete&&G.validate===q.validate&&G.productVersion===q.productVersion&&G.productDate===q.productDate&&G.productCommit===q.productCommit&&G.devMode===q.devMode&&G.language===q.language&&F.equals(G.translations,q.translations)}}e.ExtensionScannerInput=k;let N=class extends w.Disposable{constructor(G,q,x,Y,ee){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=q,this.uriIdentityService=x,this.fileService=Y,this.logService=ee}async scanExtensions(G){const q=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let x={};if(G.excludeObsolete&&G.type===1)try{const Y=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(Y)}catch{}return(0,h.isEmptyObject)(x)?q:q.filter(Y=>!x[b.ExtensionKey.create(Y).toString()])}async scanExtensionsFromLocation(G){const q=await this.fileService.resolve(G.location);if(!q.children?.length)return[];const x=await Promise.all(q.children.map(async Y=>{if(!Y.isDirectory||G.type===1&&(0,S.basename)(Y.resource).indexOf(".")===0)return null;const ee=new k(Y.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ee)}));return(0,R.coalesce)(x).sort((Y,ee)=>Y.location.path<ee.location.path?-1:1)}async scanExtensionsFromProfile(G){let q=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){q=q.filter(Y=>!Y.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,Y=>!!Y.metadata?.isApplicationScoped,G);q.push(...x)}return q}async scanExtensionsFromProfileResource(G,q,x){const Y=await this.extensionsProfileScannerService.scanProfileExtensions(G,x.profileScanOptions);if(!Y.length)return[];const ee=await Promise.all(Y.map(async re=>{if(q(re)){const ae=new k(re.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(ae,re.metadata)}return null}));return(0,R.coalesce)(ee)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,S.joinPath)(G.location,"package.json"))){const q=await this.scanExtension(G);return q?[q]:[]}else return await this.scanExtensions(G)}catch(q){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,L.getErrorMessage)(q)),[]}}async scanExtension(G,q){try{let x=await this.scanExtensionManifest(G.location);if(x){x.publisher||(x.publisher=I.UNDEFINED_PUBLISHER),q=q??x.__metadata,delete x.__metadata;const Y=(0,b.getGalleryExtensionId)(x.publisher,x.name),ee=q?.id?{id:Y,uuid:q.id}:{id:Y},re=q?.isSystem?0:G.type,ae=re===0||!!q?.isBuiltin;O.ImplicitActivationEvents.updateManifest(x),x=await this.translateManifest(G.location,x,k.createNlsConfiguration(G));const V={type:re,identifier:ee,manifest:x,location:G.location,isBuiltin:ae,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return G.validate?this.validate(V,G):V}}catch(x){G.type!==0&&this.logService.error(x)}return null}validate(G,q){let x=!0;const Y=(0,i.validateExtensionManifest)(q.productVersion,q.productDate,q.location,G.manifest,G.isBuiltin);for(const[ee,re]of Y)ee===p.default.Error&&(x=!1,this.logService.error(this.formatMessage(q.location,re)));return G.isValid=x,G.validations=Y,G}async scanExtensionManifest(G){const q=(0,S.joinPath)(G,"package.json");let x;try{x=(await this.fileService.readFile(q)).value.toString()}catch(ee){return(0,s.toFileOperationResult)(ee)!==1&&this.logService.error(this.formatMessage(G,(0,f.localize)(0,null,q.path,ee.message))),null}let Y;try{Y=JSON.parse(x)}catch{const re=[];(0,D.parse)(x,re);for(const ae of re)this.logService.error(this.formatMessage(G,(0,f.localize)(1,null,q.path,ae.offset,ae.length,(0,C.getParseErrorMessage)(ae.error))));return null}return(0,D.getNodeType)(Y)!=="object"?(this.logService.error(this.formatMessage(G,(0,f.localize)(2,null,q.path))),null):Y}async translateManifest(G,q,x){const Y=await this.getLocalizedMessages(G,q,x);if(Y)try{const ee=[],re=await this.resolveOriginalMessageBundle(Y.default,ee);if(ee.length>0)return ee.forEach(V=>{this.logService.error(this.formatMessage(G,(0,f.localize)(3,null,Y.default?.path,(0,C.getParseErrorMessage)(V.error))))}),q;if((0,D.getNodeType)(Y)!=="object")return this.logService.error(this.formatMessage(G,(0,f.localize)(4,null,Y.default?.path))),q;const ae=Y.values||Object.create(null);return(0,A.localizeManifest)(q,ae,re)}catch{}return q}async getLocalizedMessages(G,q,x){const Y=(0,S.joinPath)(G,"package.nls.json"),ee=($,U)=>{U.forEach(W=>{this.logService.error(this.formatMessage(G,(0,f.localize)(5,null,$?.path,(0,C.getParseErrorMessage)(W.error))))})},re=$=>{this.logService.error(this.formatMessage(G,(0,f.localize)(6,null,$?.path)))},ae=`${q.publisher}.${q.name}`,V=x.translations[ae];if(V)try{const $=u.URI.file(V),U=(await this.fileService.readFile($)).value.toString(),W=[],B=(0,D.parse)(U,W);return W.length>0?(ee($,W),{values:void 0,default:Y}):(0,D.getNodeType)(B)!=="object"?(re($),{values:void 0,default:Y}):{values:B.contents?B.contents.package:void 0,default:Y}}catch{return{values:void 0,default:Y}}else{if(!await this.fileService.exists(Y))return;let U;try{U=await this.findMessageBundles(G,x)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const W=(await this.fileService.readFile(U.localized)).value.toString(),B=[],Q=(0,D.parse)(W,B);return B.length>0?(ee(U.localized,B),{values:void 0,default:U.original}):(0,D.getNodeType)(Q)!=="object"?(re(U.localized),{values:void 0,default:U.original}):{values:Q,default:U.original}}catch{return{values:void 0,default:U.original}}}}async resolveOriginalMessageBundle(G,q){if(G)try{const x=(await this.fileService.readFile(G)).value.toString();return(0,D.parse)(x,q)}catch{}}findMessageBundles(G,q){return new Promise((x,Y)=>{const ee=re=>{const ae=(0,S.joinPath)(G,`package.nls.${re}.json`);this.fileService.exists(ae).then(V=>{V&&x({localized:ae,original:(0,S.joinPath)(G,"package.nls.json")});const $=re.lastIndexOf("-");$===-1?x({localized:(0,S.joinPath)(G,"package.nls.json"),original:null}):(re=re.substring(0,$),ee(re))})};if(q.devMode||q.pseudo||!q.language)return x({localized:(0,S.joinPath)(G,"package.nls.json"),original:null});ee(q.language)})}formatMessage(G,q){return`[${G.path}]: ${q}`}};N=Se([K(1,l.IExtensionsProfileScannerService),K(2,E.IUriIdentityService),K(3,s.IFileService),K(4,n.ILogService)],N);let z=class extends N{constructor(G,q,x,Y,ee,re){super(q,x,Y,ee,re),this.cacheFile=G,this.cacheValidatorThrottler=this._register(new _.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const q=await this.readExtensionCache();if(this.input=G,q&&q.input&&k.equals(q.input,this.input))return this.logService.debug("Using cached extensions scan result",G.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),q.result.map(Y=>(Y.location=u.URI.revive(Y.location),Y));const x=await super.scanExtensions(G);return await this.writeExtensionCache({input:G,result:x}),x}async readExtensionCache(){try{const G=await this.fileService.readFile(this.cacheFile),q=JSON.parse(G.value.toString());return{result:q.result,input:(0,o.revive)(q.input)}}catch(G){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(G))}return null}async writeExtensionCache(G){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(G)))}catch(q){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(q))}}async validateCache(){if(!this.input)return;const G=await this.readExtensionCache();if(!G)return;const q=G.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!c.equals(x,q))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(Y){this.logService.error(Y)}}};z=Se([K(2,l.IExtensionsProfileScannerService),K(3,E.IUriIdentityService),K(4,s.IFileService),K(5,n.ILogService)],z);function j(ne,G){const q=(0,b.getExtensionId)(ne.manifest.publisher,ne.manifest.name);return{id:q,identifier:new I.ExtensionIdentifier(q),isBuiltin:ne.type===0,isUserBuiltin:ne.type===1&&ne.isBuiltin,isUnderDevelopment:G,extensionLocation:ne.location,uuid:ne.identifier.uuid,targetPlatform:ne.targetPlatform,...ne.manifest}}e.toExtensionDescription=j;class J extends M{constructor(G,q,x,Y,ee,re,ae,V,$,U,W,B){super(G,q,(0,S.joinPath)(x,".vscode-oss-dev","extensions","control.json"),(0,S.joinPath)(Y,I.MANIFEST_CACHE_FOLDER),ee,re,ae,V,$,U,W,B),this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const Q=await this.fileService.readFile(u.URI.file(g.translationsConfigFile));return JSON.parse(Q.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(se[271],oe([0,1,8,18,29,19,51,14,15,11]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends L.AbstractExtensionsProfileScannerService{constructor(g,S,d,p,h,u){super(w.URI.file(g.extensionsPath),S,d,p,h,u)}};P=Se([K(0,C.INativeEnvironmentService),K(1,D.IFileService),K(2,_.IUserDataProfilesService),K(3,c.IUriIdentityService),K(4,T.ITelemetryService),K(5,R.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(se[272],oe([0,1,50,6,38,3,2,22,13,28,8,18]),function(Z,e,R,_,c,T,L,D,C,w,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends L.Disposable{constructor(d,p){super(),this.userDataProfilesService=d,this.logService=p,this.processesLimiter=new _.Limiter(5)}async postUninstall(d){const p=this.parseScript(d,"uninstall");return p&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),h=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${h}`)))),w.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,h=>this.logService.error("Error while removing extension storage path",h))}parseScript(d,p){const h=`vscode:${p}`;if(d.location.scheme===D.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[h]=="string"){const u=d.manifest.scripts[h].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${h} should be a node script`),null):{script:(0,C.join)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(d,p,h,u,f){return new Promise((v,b)=>{const I=this.start(d,p,h,f);let i;const s=t=>{i&&(clearTimeout(i),i=null),t?b(t):v(void 0)};I.on("error",t=>{s((0,c.toErrorMessage)(t)||"Unknown")}),I.on("exit",(t,n)=>{s(t?`post-${p} process exited with code ${t}`:void 0)}),u&&(i=setTimeout(()=>{i=null,I.kill(),b("timed out")},5e3))})}start(d,p,h,u){const f={silent:!0,execArgv:void 0},v=(0,R.fork)(d,[`--type=extension-post-${p}`,...h],f);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const b=T.Event.fromNodeEventEmitter(v.stdout,"data"),I=T.Event.fromNodeEventEmitter(v.stderr,"data");b(t=>this.logService.info(u.identifier.id,u.manifest.version,`post-${p}`,t)),I(t=>this.logService.error(u.identifier.id,u.manifest.version,`post-${p}`,t));const i=T.Event.any(T.Event.map(b,t=>({data:`%c${t}`,format:[""]})),T.Event.map(I,t=>({data:`%c${t}`,format:["color: red"]})));return T.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}getExtensionStoragePath(d){return(0,C.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};g=Se([K(0,y.IUserDataProfilesService),K(1,P.ILogService)],g),e.ExtensionsLifecycle=g}),define(se[273],oe([0,1,11,15,51,79,14,5,8,26,29,18]),function(Z,e,R,_,c,T,L,D,C,w,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends T.NativeExtensionsScannerService{constructor(d,p,h,u,f,v,b,I){super(R.URI.file(f.builtinExtensionsPath),R.URI.file(f.extensionsPath),f.userHome,R.URI.file(f.userDataPath),d,p,h,u,f,v,b,I)}};g=Se([K(0,y.IUserDataProfilesService),K(1,c.IExtensionsProfileScannerService),K(2,L.IFileService),K(3,C.ILogService),K(4,_.INativeEnvironmentService),K(5,w.IProductService),K(6,P.IUriIdentityService),K(7,D.IInstantiationService)],g),e.ExtensionsScannerService=g}),define(se[20],oe([0,1,6,3,2,103,12,69,5,18]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,C.createDecorator)("storageService");var P;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var g;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));function S(f){const v=f.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=S;class d extends c.Disposable{constructor(v={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=v,this._onDidChangeValue=this._register(new _.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new _.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new _.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new c.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,c.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,b){if(b===e.TARGET_KEY){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:b,target:this.getKeyTargets(v)[b]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,b,I){return this.getStorage(b)?.get(v,I)}getBoolean(v,b,I){return this.getStorage(b)?.getBoolean(v,I)}getNumber(v,b,I){return this.getStorage(b)?.getNumber(v,I)}store(v,b,I,i){if((0,L.isUndefinedOrNull)(b)){this.remove(v,I);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,I,i),this.getStorage(I)?.set(v,b)})}remove(v,b){this.withPausedEmitters(()=>{this.updateKeyTarget(v,b,void 0),this.getStorage(b)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,b){const I=[],i=this.getKeyTargets(v);for(const s of Object.keys(i))i[s]===b&&I.push(s);return I}updateKeyTarget(v,b,I){const i=this.getKeyTargets(b);typeof I=="number"?i[v]!==I&&(i[v]=I,this.getStorage(b)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[v]=="number"&&(delete i[v],this.getStorage(b)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const b=this.getStorage(v);return b?S(b):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=P.NONE){this._onWillSaveState.fire({reason:v});const b=this.getStorage(-1),I=this.getStorage(0),i=this.getStorage(1);switch(v){case P.NONE:await R.Promises.settled([b?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await R.Promises.settled([b?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,b=this.getStorage(0)?.items??new Map,I=this.getStorage(1)?.items??new Map;return u(v,b,I,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(v,b){return this.emitWillSaveState(P.NONE),(0,w.isUserDataProfile)(v)?this.switchToProfile(v,b):this.switchToWorkspace(v,b)}canSwitchProfile(v,b){return!(v.id===b.id||p(b)&&p(v))}switchData(v,b,I,i){this.withPausedEmitters(()=>{if(i)for(const[s,t]of v)b.set(s,t);else{const s=new Set;for(const[t,n]of v)s.add(t),b.get(t)!==n&&this.emitDidChangeValue(I,t);for(const[t]of b.items)s.has(t)||this.emitDidChangeValue(I,t)}})}}d.DEFAULT_FLUSH_INTERVAL=60*1e3,e.AbstractStorageService=d;function p(f){return f.isDefault||!!f.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class h extends d{constructor(){super(),this.applicationStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(v){return!1}}e.InMemoryStorageService=h;async function u(f,v,b,I,i,s){const t=O=>{try{return JSON.parse(O)}catch{return O}},n=new Map,r=new Map;f.forEach((O,F)=>{n.set(F,O),r.set(F,t(O))});const a=new Map,o=new Map;v.forEach((O,F)=>{a.set(F,O),o.set(F,t(O))});const l=new Map,m=new Map;b.forEach((O,F)=>{l.set(F,O),m.set(F,t(O))}),console.group(I!==i?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const E=[];if(n.forEach((O,F)=>{E.push({key:F,value:O})}),console.table(E),console.groupEnd(),console.log(r),I!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const O=[];a.forEach((F,M)=>{O.push({key:M,value:F})}),console.table(O),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${s})`);const A=[];l.forEach((O,F)=>{A.push({key:F,value:O})}),console.table(A),console.groupEnd(),console.log(m)}e.logStorage=u}),define(se[119],oe([0,1,3,2,12,30,33,20]),function(Z,e,R,_,c,T,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends _.Disposable{constructor(y,g){super(),this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(y)),this._register(this.storageManger.onDidChange(S=>this._onDidChangeEnablement.fire({extensions:S,source:"storage"}))),this._register(g.onDidInstallExtensions(S=>S.forEach(({local:d,operation:p})=>{d&&p===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(y,g){return this._removeFromDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:g}),!0):!1}async disableExtension(y,g){return this._addToDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(y){const g=this.getDisabledExtensions();return g.every(S=>!(0,L.areSameExtensions)(S,y))?(g.push(y),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(y){const g=this.getDisabledExtensions();for(let S=0;S<g.length;S++){const d=g[S];if((0,L.areSameExtensions)(d,y))return g.splice(S,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(y){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,y)}_getExtensions(y){return this.storageManger.get(y,0)}_setExtensions(y,g){this.storageManger.set(y,g,0)}};C=Se([K(0,D.IStorageService),K(1,T.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class w extends _.Disposable{constructor(y){super(),this.storageService=y,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(y.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(y,g){let S;return g===0?((0,c.isUndefinedOrNull)(this.storage[y])&&(this.storage[y]=this._get(y,g)),S=this.storage[y]):S=this._get(y,g),JSON.parse(S)}set(y,g,S){const d=JSON.stringify(g.map(({id:h,uuid:u})=>({id:h,uuid:u})));this._get(y,S)!==d&&(S===0&&(g.length?this.storage[y]=d:delete this.storage[y]),this._set(y,g.length?d:void 0,S))}onDidStorageChange(y){if(y.scope===0&&!(0,c.isUndefinedOrNull)(this.storage[y.key])&&this._get(y.key,y.scope)!==this.storage[y.key]){const S=this.get(y.key,y.scope);delete this.storage[y.key];const d=this.get(y.key,y.scope),p=S.filter(u=>!d.some(f=>(0,L.areSameExtensions)(u,f))),h=d.filter(u=>!S.some(f=>(0,L.areSameExtensions)(f,u)));(p.length||h.length)&&this._onDidChange.fire([...p,...h])}}_get(y,g){return this.storageService.get(y,g,"[]")}_set(y,g,S){g?this.storageService.store(y,g,S,1):this.storageService.remove(y,S)}}e.StorageManager=w}),define(se[274],oe([0,1,21,25,9,4,36,12,11,16,15,30,33,70,14,8,26,60,242,20,19]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const I=T.isWeb?"web":(0,y.getTargetPlatform)(T.platform,L.arch),i="X-Market-Search-Activity-Id";var s;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function t(...$){return String($.reduce((U,W)=>U|W,0))}var n;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class m{constructor(U=l){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(U,W=this.state.pageSize){return new m({...this.state,pageNumber:U,pageSize:W})}withFilter(U,...W){const B=[...this.state.criteria,...W.length?W.map(Q=>({filterType:U,value:Q})):[{filterType:U}]];return new m({...this.state,criteria:B})}withSortBy(U){return new m({...this.state,sortBy:U})}withSortOrder(U){return new m({...this.state,sortOrder:U})}withFlags(...U){return new m({...this.state,flags:U.reduce((W,B)=>W|B,0)})}withAssetTypes(...U){return new m({...this.state,assetTypes:U})}withSource(U){return new m({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:W,pageSize:B,sortBy:Q,sortOrder:H,flags:X,assetTypes:te}=this.state;return{filters:[{criteria:U,pageNumber:W,pageSize:B,sortBy:Q,sortOrder:H}],assetTypes:te,flags:X}}get searchText(){const U=this.state.criteria.filter(W=>W.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function E($,U){const W=($||[]).filter(B=>B.statisticName===U)[0];return W?W.value:0}function A($){const U="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(B=>B.assetType.indexOf(U)===0).reduce((B,Q)=>{const H=M($,Q.assetType);return H&&B.push([Q.assetType.substring(U.length),H]),B},[])}function O($){if($.properties){const U=$.properties.filter(Q=>Q.key===r.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=U.filter(Q=>W.test(Q.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return M($,r.Repository)}function F($){return{uri:`${$.fallbackAssetUri}/${r.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${r.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function M($,U){return $.files.filter(B=>B.assetType===U)[0]?{uri:`${$.assetUri}/${U}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${U}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function k($,U){const W=$.properties?$.properties.filter(Q=>Q.key===U):[],B=W.length>0&&W[0].value;return B?B.split(",").map(Q=>(0,g.adoptToGalleryExtensionId)(Q)):[]}function N($){const U=$.properties?$.properties.filter(W=>W.key===a.Engine):[];return U.length>0&&U[0].value||""}function z($){const U=$.properties?$.properties.filter(W=>W.key===a.PreRelease):[];return U.length>0&&U[0].value==="true"}function j($){const U=$.properties?$.properties.filter(B=>B.key===a.LocalizedLanguages):[],W=U.length>0&&U[0].value||"";return W?W.split(","):[]}function J($){return $.properties?.find(U=>U.key===a.SponsorLink)?.value}function ne($){return $.indexOf("preview")!==-1}function G($){return $.targetPlatform?(0,y.toTargetPlatform)($.targetPlatform):"undefined"}function q($){const U=(0,R.distinct)($.versions.map(G)),W=!!$.tags?.includes(y.WEB_EXTENSION_TAG),B=U.indexOf("web");return W?B===-1&&U.push("web"):B!==-1&&U.splice(B,1),U}function x($,U){const W=(0,y.getFallbackTargetPlarforms)(U);for(let B=0;B<$.length;B++){const Q=$[B];if(Q.version===$[B-1]?.version){let H=B;const X=G(Q);if(X===U)for(;H>0&&$[H-1].version===Q.version;)H--;else if(W.includes(X))for(;H>0&&$[H-1].version===Q.version&&G($[H-1])!==U;)H--;H!==B&&($.splice(B,1),$.splice(H,0,Q))}}return $}e.sortExtensionVersions=x;function Y($,U,W){$.telemetryData={index:U,querySource:W,queryActivityId:$.queryContext?.[i]}}function ee($,U,W,B){const Q=$.versions[0],H={manifest:M(U,r.Manifest),readme:M(U,r.Details),changelog:M(U,r.Changelog),license:M(U,r.License),repository:O(U),download:F(U),icon:M(U,r.Icon),signature:M(U,r.Signature),coreTranslations:A(U)};return{identifier:{id:(0,g.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:U.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(Q),description:$.shortDescription||"",installCount:E($.statistics,"install"),rating:E($.statistics,"averagerating"),ratingCount:E($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:W,assets:H,properties:{dependencies:k(U,a.Dependency),extensionPack:k(U,a.ExtensionPack),engine:N(U),localizedLanguages:j(U),targetPlatform:G(U),isPreReleaseVersion:z(U)},hasPreReleaseVersion:z(Q),hasReleaseVersion:!0,preview:ne($.flags),isSigned:!!H.signature,queryContext:B}}let re=class{constructor(U,W,B,Q,H,X,te,le){this.requestService=W,this.logService=B,this.environmentService=Q,this.telemetryService=H,this.fileService=X,this.productService=te,this.configurationService=le;const he=te.extensionsGallery,me=he?.servicePPEUrl&&le.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=me?he.servicePPEUrl:he?.serviceUrl,this.extensionsGallerySearchUrl=me?void 0:he?.searchUrl,this.extensionsControlUrl=he?.controlUrl,this.commonHeadersPromise=(0,f.resolveMarketplaceHeaders)(te.version,te,this.environmentService,this.configurationService,this.fileService,U,this.telemetryService)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,W,B){const Q=_.CancellationToken.isCancellationToken(W)?{}:W,H=_.CancellationToken.isCancellationToken(W)?W:B,X=[],te=[],le=[],he=[];let me=!0;for(const be of U){be.uuid?te.push(be.uuid):X.push(be.id);const Re=!!(be.version||be.preRelease);le.push({id:be.id,uuid:be.uuid,includePreRelease:Re}),be.version&&he.push({id:be.id,uuid:be.uuid,version:be.version}),me=me&&!!be.hasPreRelease&&!Re}if(!te.length&&!X.length)return[];let pe=new m().withPage(1,U.length);te.length&&(pe=pe.withFilter(n.ExtensionId,...te)),X.length&&(pe=pe.withFilter(n.ExtensionName,...X)),(Q.queryAllVersions||me)&&(pe=pe.withFlags(pe.flags,s.IncludeVersions)),Q.source&&(pe=pe.withSource(Q.source));const{extensions:Ee}=await this.queryGalleryExtensions(pe,{targetPlatform:Q.targetPlatform??I,includePreRelease:le,versions:he,compatible:!!Q.compatible},H);return Q.source&&Ee.forEach((be,Re)=>Y(be,Re,Q.source)),Ee}async getCompatibleExtension(U,W,B){if((0,y.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(U,W,B))return U;const Q=new m().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:H}=await this.queryGalleryExtensions(Q,{targetPlatform:B,compatible:!0,includePreRelease:W},_.CancellationToken.None);return H[0]||null}async isExtensionCompatible(U,W,B){if(!(0,y.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,B)||!W&&U.properties.isPreReleaseVersion)return!1;let Q=U.properties.engine;if(!Q){const H=await this.getManifest(U,_.CancellationToken.None);if(!H)throw new Error("Manifest was not found");Q=H.engines.vscode}return(0,S.isEngineValid)(Q,this.productService.version,this.productService.date)}async isValidVersion(U,W,B,Q,H){if(!(0,y.isTargetPlatformCompatible)(G(U),Q,H)||W!=="any"&&z(U)!==(W==="prerelease"))return!1;if(B)try{const X=await this.getEngine(U);if(!(0,S.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${U.version}.`,(0,c.getErrorMessage)(X)),!1}return!0}async query(U,W){let B=U.text||"";const Q=U.pageSize??50;let H=new m().withPage(1,Q);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,Ee)=>(H=H.withFilter(n.Category,Ee||pe),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,Ee)=>(H=H.withFilter(n.Tag,Ee||pe),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),H=H.withFilter(n.SearchText,B)),H=H.withSortBy(0)):U.ids?H=H.withFilter(n.ExtensionId,...U.ids):U.names?H=H.withFilter(n.ExtensionName,...U.names):H=H.withSortBy(4),typeof U.sortBy=="number"&&(H=H.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(H=H.withSortOrder(U.sortOrder)),U.source&&(H=H.withSource(U.source));const X=async(me,pe)=>{const{extensions:Ee,total:be}=await this.queryGalleryExtensions(me,{targetPlatform:I,compatible:!1,includePreRelease:!!U.includePreRelease},pe);return Ee.forEach((Re,ke)=>Y(Re,(me.pageNumber-1)*me.pageSize+ke,U.source)),{extensions:Ee,total:be}},{extensions:te,total:le}=await X(H,W),he=async(me,pe)=>{if(pe.isCancellationRequested)throw new c.CancellationError;const{extensions:Ee}=await X(H.withPage(me+1),pe);return Ee};return{firstPage:te,total:le,pageSize:H.pageSize,getPage:he}}async queryGalleryExtensions(U,W,B){const Q=U.flags;!!(U.flags&s.IncludeLatestVersionOnly)&&!!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(U.flags&s.IncludeLatestVersionOnly)&&!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags,s.IncludeLatestVersionOnly)),W.versions?.length&&(U=U.withFlags(U.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),U=U.withFlags(U.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:H,total:X,context:te}=await this.queryRawGalleryExtensions(U,B);if(!(U.flags&s.IncludeLatestVersionOnly)){const pe=[];for(const Ee of H){const be=await this.toGalleryExtensionWithCriteria(Ee,W,te);be&&pe.push(be)}return{extensions:pe,total:X}}const he=[],me=new Map;for(let pe=0;pe<H.length;pe++){const Ee=H[pe],be={id:(0,g.getGalleryExtensionId)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Re=(0,D.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(We=>(0,g.areSameExtensions)(We,be))?.includePreRelease;if(W.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(q(Ee),W.targetPlatform))continue;const ke=await this.toGalleryExtensionWithCriteria(Ee,W,te);!ke||ke.properties.isPreReleaseVersion&&(!Re||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==W.targetPlatform&&ke.hasPreReleaseVersion?me.set(Ee.extensionId,pe):he.push([pe,ke])}if(me.size){const pe=new Date().getTime(),Ee=new m().withFlags(Q&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,me.size).withFilter(n.ExtensionId,...me.keys()),{extensions:be}=await this.queryGalleryExtensions(Ee,W,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:me.size});for(const Re of be){const ke=me.get(Re.identifier.uuid);he.push([ke,Re])}}return{extensions:he.sort((pe,Ee)=>pe[0]-Ee[0]).map(([,pe])=>pe),total:X}}async toGalleryExtensionWithCriteria(U,W,B){const Q={id:(0,g.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},H=W.versions?.find(he=>(0,g.areSameExtensions)(he,Q))?.version,X=(0,D.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(he=>(0,g.areSameExtensions)(he,Q))?.includePreRelease,te=q(U),le=x(U.versions,W.targetPlatform);if(W.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(te,W.targetPlatform))return null;for(let he=0;he<le.length;he++){const me=le[he];if(!(H&&me.version!==H)){if(await this.isValidVersion(me,X?"any":"release",W.compatible,te,W.targetPlatform))return ee(U,me,te,B);if(H&&me.version===H)return null}}return H||W.compatible?null:ee(U,U.versions[0],te)}async queryRawGalleryExtensions(U,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,t(s.Unpublished));const B=await this.commonHeadersPromise,Q=JSON.stringify(U.raw),H={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},X=new Date().getTime();let te,le,he=0;try{if(te=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&U.criteria.some(pe=>pe.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:Q,headers:H},W),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:he};const me=await(0,u.asJson)(te);if(me){const pe=me.results[0],Ee=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return he=be&&be.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:he,context:{[i]:te.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(me){throw le=me,me}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-X,success:!!te&&(0,u.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:le?(0,c.isCancellationError)(le)?"canceled":(0,c.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(U,W,B,Q){if(!this.isEnabled())return;const H=T.isWeb?this.api(`/itemName/${U}.${W}/version/${B}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${W}/${B}/stats?statType=${Q}`),X=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:H,headers:le},_.CancellationToken.None)}catch{}}async download(U,W,B){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const Q=(0,g.getGalleryExtensionTelemetryData)(U),H=new Date().getTime(),X=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Q,duration:pe}),te=B===2?"install":B===3?"update":"",le=te?{uri:`${U.assets.download.uri}${C.URI.parse(U.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${U.assets.download.fallbackUri}${C.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:U.assets.download,he=U.queryContext?.[i]?{[i]:U.queryContext[i]}:void 0,me=await this.getAsset(le,he?{headers:he}:void 0);await this.fileService.writeFile(W,me.stream),X(new Date().getTime()-H)}async downloadSignatureArchive(U,W){if(!U.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const B=await this.getAsset(U.assets.signature);await this.fileService.writeFile(W,B.stream)}async getReadme(U,W){if(U.assets.readme){const B=await this.getAsset(U.assets.readme,{},W);return await(0,u.asTextOrError)(B)||""}return""}async getManifest(U,W){if(U.assets.manifest){const B=await this.getAsset(U.assets.manifest,{},W),Q=await(0,u.asTextOrError)(B);return Q?JSON.parse(Q):null}return null}async getManifestFromRawExtensionVersion(U,W){const B=M(U,r.Manifest);if(!B)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},H=await this.getAsset(B,{headers:Q});return await(0,u.asJson)(H)}async getCoreTranslation(U,W){const B=U.assets.coreTranslations.filter(Q=>Q[0]===W.toUpperCase())[0];if(B){const Q=await this.getAsset(B[1]),H=await(0,u.asTextOrError)(Q);return H?JSON.parse(H):null}return null}async getChangelog(U,W){if(U.assets.changelog){const B=await this.getAsset(U.assets.changelog,{},W);return await(0,u.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(U,W,B){let Q=new m().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?Q=Q.withFilter(n.ExtensionId,U.identifier.uuid):Q=Q.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:H}=await this.queryRawGalleryExtensions(Q,_.CancellationToken.None);if(!H.length)return[];const X=q(H[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(X,B))return[];const te=[];await Promise.all(H[0].versions.map(async me=>{try{await this.isValidVersion(me,W?"any":"release",!0,X,B)&&te.push(me)}catch{}}));const le=[],he=new Set;for(const me of x(te,B))he.has(me.version)||(he.add(me.version),le.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:z(me)}));return le}async getAsset(U,W={},B=_.CancellationToken.None){const Q=await this.commonHeadersPromise,H={type:"GET"},X={...Q,...W.headers||{}};W={...W,...H,headers:X};const te=U.uri,le=U.fallbackUri,he={...W,url:te};try{const me=await this.requestService.request(he,B);if(me.res.statusCode===200)return me;const pe=await(0,u.asTextOrError)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${pe}`)}catch(me){if((0,c.isCancellationError)(me))throw me;const pe=(0,c.getErrorMessage)(me);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:te,message:pe});const Ee={...W,url:le};return this.requestService.request(Ee,B)}}async getEngine(U){let W=N(U);if(!W){const B=await this.getManifestFromRawExtensionVersion(U,_.CancellationToken.None);if(!B)throw new Error("Manifest was not found");W=B.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},_.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,u.asJson)(U),B=[],Q={};if(W){for(const H of W.malicious)B.push({id:H});if(W.migrateToPreRelease)for(const[H,X]of Object.entries(W.migrateToPreRelease))(!X.engine||(0,S.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(Q[H.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[H,X]of Object.entries(W.deprecated))X&&(Q[H.toLowerCase()]=(0,D.isBoolean)(X)?{}:X)}return{malicious:B,deprecated:Q}}};re=Se([K(1,u.IRequestService),K(2,p.ILogService),K(3,P.IEnvironmentService),K(4,b.ITelemetryService),K(5,d.IFileService),K(6,h.IProductService),K(7,w.IConfigurationService)],re);let ae=class extends re{constructor(U,W,B,Q,H,X,te,le){super(U,W,B,Q,H,X,te,le)}};ae=Se([K(0,v.IStorageService),K(1,u.IRequestService),K(2,p.ILogService),K(3,P.IEnvironmentService),K(4,b.ITelemetryService),K(5,d.IFileService),K(6,h.IProductService),K(7,w.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let V=class extends re{constructor(U,W,B,Q,H,X,te){super(void 0,U,W,B,Q,H,X,te)}};V=Se([K(0,u.IRequestService),K(1,p.ILogService),K(2,P.IEnvironmentService),K(3,b.ITelemetryService),K(4,d.IFileService),K(5,h.IProductService),K(6,w.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(se[80],oe([0,1,5,3,2,20,33,26,21,8,12]),function(Z,e,R,_,c,T,L,D,C,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const y=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class Qe extends c.Disposable{static toKey(d){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const p=y.exec(d);if(p&&p[1])return{id:p[1],version:p[2]}}static async removeOutdatedExtensionVersions(d,p){const h=await d.getInstalled(),u=[];for(const[f,v]of Qe.readAllExtensionsWithKeysForSync(p)){const b=h.find(I=>(0,L.areSameExtensions)(I.identifier,{id:f}))?.manifest.version;for(const I of v)b!==I&&u.push(Qe.toKey({id:f,version:I}))}for(const f of u)p.remove(f,0)}static readAllExtensionsWithKeysForSync(d){const p=new Map,h=d.keys(0,1);for(const u of h){const f=Qe.fromKey(u);if(f){let v=p.get(f.id.toLowerCase());v||p.set(f.id.toLowerCase(),v=[]),v.push(f.version)}}return p}constructor(d,p,h){super(),this.storageService=d,this.productService=p,this.logService=h,this._onDidChangeExtensionStorageToSync=this._register(new _.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(d),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const p=Qe.fromKey(d.key);if(p){if(this.storageService.get(d.key,0)===void 0)this.extensionsWithKeysForSync.delete(p.id.toLowerCase());else{let h=this.extensionsWithKeysForSync.get(p.id.toLowerCase());h||this.extensionsWithKeysForSync.set(p.id.toLowerCase(),h=[]),h.push(p.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(d){if((0,P.isString)(d))return d;const p=d.manifest?d.manifest.publisher:d.publisher,h=d.manifest?d.manifest.name:d.name;return(0,L.getExtensionId)(p,h)}getExtensionState(d,p){const h=this.getExtensionId(d),u=this.getExtensionStateRaw(d,p);if(u)try{return JSON.parse(u)}catch(f){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${p}): ${f}`)}}getExtensionStateRaw(d,p){const h=this.getExtensionId(d),u=this.storageService.get(h,p?0:1);return u&&u?.length>Qe.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${p}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(d,p,h){const u=this.getExtensionId(d);p===void 0?this.storageService.remove(u,h?0:1):this.storageService.store(u,JSON.stringify(p),h?0:1,1)}setKeysForSync(d,p){this.storageService.store(Qe.toKey(d),JSON.stringify(p),0,1)}getKeysForSync(d){const p=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(Qe.toKey(d),0),u=h?JSON.parse(h):void 0;return u&&p?(0,C.distinct)([...u,...p]):u||p}addToMigrationList(d,p){if(d!==p){const h=this.migrationList.filter(u=>!u.includes(d)&&!u.includes(p));h.push([d,p]),this.migrationList=h}}getSourceExtensionToMigrate(d){const p=this.migrationList.find(([,h])=>d===h);return p?p[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const p=JSON.parse(d);if(Array.isArray(p))return p}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};g.LARGE_STATE_WARNING_THRESHOLD=512*1024,g=Se([K(0,T.IStorageService),K(1,D.IProductService),K(2,w.ILogService)],g),e.ExtensionStorageService=g}),define(se[275],oe([0,1,21,6,3,13,4,36,11,163,15,30,33,218,100,14,58,26,20,19]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const b="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";let i=class extends S.ExtensionTipsService{constructor(t,n,r,a,o,l,m,E){super(m,E),this.environmentService=t,this.telemetryService=n,this.extensionManagementService=r,this.storageService=a,this.nativeHostService=o,this.extensionRecommendationNotificationService=l,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,E.exeBasedExtensionTips&&Object.entries(E.exeBasedExtensionTips).forEach(([A,O])=>{const F=[],M=[],k=[];Object.entries(O.recommendations).forEach(([N,z])=>{z.important?O.important?F.push({extensionId:N,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):M.push({extensionId:N,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):k.push({extensionId:N,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),F.length&&this.highImportanceExecutableTips.set(A,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:F}),M.length&&this.mediumImportanceExecutableTips.set(A,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:M}),k.length&&this.allOtherExecutableTips.set(A,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:k})}),(0,_.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const t=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),n=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...t,...n]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const t=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),n=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),r=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(t,r),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(n,r)}groupImportantTipsByExe(t,n){const r=new Map;t.forEach(E=>r.set(E.extensionId.toLowerCase(),E));const{installed:a,uninstalled:o}=this.groupByInstalled([...r.keys()],n);for(const E of a){const A=r.get(E);A&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:E,exeName:A.exeName})}for(const E of o){const A=r.get(E);A&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:E,exeName:A.exeName})}const l=this.getPromptedExecutableTips(),m=new Map;for(const E of o){const A=r.get(E);if(A&&(!l[A.exeName]||!l[A.exeName].includes(A.extensionId))){let O=m.get(A.exeName);O||(O=[],m.set(A.exeName,O)),O.push(A)}}return m}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[t,n]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(n).then(r=>{switch(r){case"reacted":this.addToRecommendedExecutables(n[0].exeName,n);break;case"ignored":this.highImportanceTipsByExe.delete(t);break;case"incompatibleWindow":{const a=c.Event.once(c.Event.latch(c.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(a(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const a=this._register((0,_.disposableTimeout)(()=>{a.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const t=this.getLastPromptedMediumExeTime(),n=Date.now()-t,r=7*24*60*60*1e3;if(n<r){const l=this._register((0,_.disposableTimeout)(()=>{l.dispose(),this.promptMediumImportanceExeBasedTip()},r-n));return}const[a,o]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(l=>{switch(l){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(a),this.addToRecommendedExecutables(o[0].exeName,o);const m=this._register((0,_.disposableTimeout)(()=>{m.dispose(),this.promptMediumImportanceExeBasedTip()},r));break}case"ignored":this.mediumImportanceTipsByExe.delete(a),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const m=c.Event.once(c.Event.latch(c.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(m(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const m=this._register((0,_.disposableTimeout)(()=>{m.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(t){const n=await this.extensionManagementService.getInstalled(1),r=t.filter(o=>!o.whenNotInstalled||o.whenNotInstalled.every(l=>n.every(m=>!(0,g.areSameExtensions)(m.identifier,{id:l})))).map(({extensionId:o})=>o.toLowerCase()),a=(0,w.localize)(0,null,t[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(r,a,`@exe:"${t[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let t=this.storageService.getNumber(I,-1);return t||(t=Date.now(),this.updateLastPromptedMediumExeTime(t)),t}updateLastPromptedMediumExeTime(t){this.storageService.store(I,t,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(b,-1,"{}"))}addToRecommendedExecutables(t,n){const r=this.getPromptedExecutableTips();r[t]=n.map(({extensionId:a})=>a.toLowerCase()),this.storageService.store(b,JSON.stringify(r),-1,0)}groupByInstalled(t,n){const r=[],a=[],o=n.reduce((l,m)=>(l.add(m.identifier.id.toLowerCase()),l),new Set);return t.forEach(l=>{o.has(l.toLowerCase())?r.push(l):a.push(l)}),{installed:r,uninstalled:a}}async getValidExecutableBasedExtensionTips(t){const n=[],r=new Map;for(const a of t.keys()){const o=t.get(a);if(!o||!(0,R.isNonEmptyArray)(o.recommendations))continue;const l=[];L.isWindows?o.windowsPath&&l.push(o.windowsPath.replace("%USERPROFILE%",()=>D.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>D.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>D.env.ProgramFiles).replace("%APPDATA%",()=>D.env.APPDATA).replace("%WINDIR%",()=>D.env.WINDIR)):(l.push((0,T.join)("/usr/local/bin",a)),l.push((0,T.join)("/usr/bin",a)),l.push((0,T.join)(this.environmentService.userHome.fsPath,a)));for(const m of l){let E=r.get(m);if(E===void 0&&(E=await this.fileService.exists(C.URI.file(m)),r.set(m,E)),E)for(const{extensionId:A,extensionName:O,isExtensionPack:F,whenNotInstalled:M}of o.recommendations)n.push({extensionId:A,extensionName:O,isExtensionPack:F,exeName:a,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:M})}}return n}};i=Se([K(0,P.INativeEnvironmentService),K(1,v.ITelemetryService),K(2,y.IExtensionManagementService),K(3,f.IStorageService),K(4,h.INativeHostService),K(5,d.IExtensionRecommendationNotificationService),K(6,p.IFileService),K(7,u.IProductService)],i),e.ExtensionTipsService=i}),define(se[276],oe([0,1,6,2,23,69,20,76,18]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends L.AbstractStorageService{constructor(y,g,S,d){super(),this.initialWorkspace=y,this.initialProfiles=g,this.mainProcessService=S,this.environmentService=d,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new _.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new _.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const y=this._register(new D.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),g=this._register(new T.Storage(y));return this._register(g.onDidChangeStorage(S=>this.emitDidChangeValue(-1,S))),g}createProfileStorage(y){this.profileStorageDisposables.clear(),this.profileStorageProfile=y;let g;if((0,L.isProfileUsingDefaultStorage)(y))g=this.applicationStorage;else{const S=this.profileStorageDisposables.add(new D.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),y));g=this.profileStorageDisposables.add(new T.Storage(S))}return this.profileStorageDisposables.add(g.onDidChangeStorage(S=>this.emitDidChangeValue(0,S))),g}createWorkspaceStorage(y){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=y?.id;let g;if(y){const S=this.workspaceStorageDisposables.add(new D.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),y));g=this.workspaceStorageDisposables.add(new T.Storage(S)),this.workspaceStorageDisposables.add(g.onDidChangeStorage(d=>this.emitDidChangeValue(1,d)))}return g}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,c.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(y,g){if(!this.canSwitchProfile(this.profileStorageProfile,y))return;const S=this.profileStorage,d=S.items;S!==this.applicationStorage&&await S.close(),this.profileStorage=this.createProfileStorage(y),await this.profileStorage.init(),this.switchData(d,this.profileStorage,0,g)}async switchToWorkspace(y,g){const S=this.workspaceStorage,d=S?.items??new Map;await S?.close(),this.workspaceStorage=this.createWorkspaceStorage(y),await this.workspaceStorage.init(),this.switchData(d,this.workspaceStorage,1,g)}hasScope(y){return(0,C.isUserDataProfile)(y)?this.profileStorageProfile.id===y.id:this.workspaceStorageId===y.id}}e.NativeStorageService=w}),define(se[62],oe([0,1,2,69,5,20]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,c.createDecorator)("IUserDataProfileStorageService");let L=class extends R.Disposable{constructor(w){super(),this.storageService=w}async readStorageData(w){return this.withProfileScopedStorageService(w,async P=>this.getItems(P))}async updateStorageData(w,P,y){return this.withProfileScopedStorageService(w,async g=>this.writeItems(g,P,y))}async withProfileScopedStorageService(w,P){if(this.storageService.hasScope(w))return P(this.storageService);const y=await this.createStorageDatabase(w),g=new D(y);try{await g.initialize();const S=await P(g);return await g.flush(),S}finally{g.dispose(),await this.closeAndDispose(y)}}getItems(w){const P=new Map,y=g=>{for(const S of w.keys(0,g))P.set(S,{value:w.get(S,0),target:g})};return y(0),y(1),P}writeItems(w,P,y){for(const[g,S]of P)w.store(g,S,0,y)}async closeAndDispose(w){try{await w.close()}finally{(0,R.isDisposable)(w)&&w.dispose()}}};L=Se([K(0,T.IStorageService)],L),e.AbstractUserDataProfileStorageService=L;class D extends T.AbstractStorageService{constructor(w){super({flushInterval:100}),this.profileStorage=this._register(new _.Storage(w))}doInitialize(){return this.profileStorage.init()}getStorage(w){return w===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(se[277],oe([0,1,3,2,23,15,57,18]),function(Z,e,R,_,c,T,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let C=class extends _.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(P,y,g){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this.channel=y.getChannel("userDataProfiles"),this.profilesHome=(0,c.joinPath)(g.userRoamingDataHome,"profiles"),this._profiles=P.map(S=>(0,D.reviveProfile)(S,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(S=>{const d=S.added.map(u=>(0,D.reviveProfile)(u,this.profilesHome.scheme)),p=S.removed.map(u=>(0,D.reviveProfile)(u,this.profilesHome.scheme)),h=S.updated.map(u=>(0,D.reviveProfile)(u,this.profilesHome.scheme));this._profiles=S.all.map(u=>(0,D.reviveProfile)(u,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:d,removed:p,updated:h,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(P){this.enabled=P}isEnabled(){return this.enabled}async createNamedProfile(P,y,g){const S=await this.channel.call("createNamedProfile",[P,y,g]);return(0,D.reviveProfile)(S,this.profilesHome.scheme)}async createProfile(P,y,g,S){const d=await this.channel.call("createProfile",[P,y,g,S]);return(0,D.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(P){const y=await this.channel.call("createTransientProfile",[P]);return(0,D.reviveProfile)(y,this.profilesHome.scheme)}async setProfileForWorkspace(P,y){await this.channel.call("setProfileForWorkspace",[P,y])}removeProfile(P){return this.channel.call("removeProfile",[P])}async updateProfile(P,y){const g=await this.channel.call("updateProfile",[P,y]);return(0,D.reviveProfile)(g,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};C=Se([K(1,L.IMainProcessService),K(2,T.IEnvironmentService)],C),e.UserDataProfilesNativeService=C}),define(se[278],oe([0,1,3,2,57,8,62,20,76,18,71]),function(Z,e,R,_,c,T,L,D,C,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let y=class extends L.AbstractUserDataProfileStorageService{constructor(S,d,p,h){super(p),this.mainProcessService=S;const u=S.getChannel("profileStorageListener"),f=this._register(new _.MutableDisposable);this._onDidChange=this._register(new R.Emitter({onWillAddFirstListener:()=>{f.value=u.listen("onDidChange")(v=>{h.trace("profile storage changes",v),this._onDidChange.fire({targetChanges:v.targetChanges.map(b=>(0,w.reviveProfile)(b,d.profilesHome.scheme)),valueChanges:v.valueChanges.map(b=>({...b,profile:(0,w.reviveProfile)(b.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(S){const d=this.mainProcessService.getChannel("storage");return(0,D.isProfileUsingDefaultStorage)(S)?new C.ApplicationStorageDatabaseClient(d):new C.ProfileStorageDatabaseClient(d,S)}};y=Se([K(0,c.IMainProcessService),K(1,w.IUserDataProfilesService),K(2,D.IStorageService),K(3,T.ILogService)],y),e.UserDataProfileStorageService=y,(0,P.registerSingleton)(L.IUserDataProfileStorageService,y,1)}),define(se[41],oe([0,1,21,6,17,25,3,35,2,27,12,181,16,15,14,8,45,20,19,29,24,18]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(l){return!!(l&&l.ref!==void 0&&typeof l.ref=="string"&&l.ref!==""&&l.syncData!==void 0&&(l.syncData===null||s(l.syncData)))}e.isRemoteUserData=i;function s(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=s;function t(l,m){return`${(0,w.uppercaseFirstLetter)(l)}${m.isDefault?"":` (${m.name})`}`}e.getSyncResourceLogLabel=t;let n=class extends C.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(m,E,A,O,F,M,k,N,z,j,J,ne){super(),this.syncResource=m,this.collection=E,this.fileService=A,this.environmentService=O,this.storageService=F,this.userDataSyncStoreService=M,this.userDataSyncBackupStoreService=k,this.userDataSyncEnablementService=N,this.telemetryService=z,this.logService=j,this.configurationService=J,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new _.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=t(m.syncResource,m.profile),this.extUri=ne.extUri,this.syncFolder=this.extUri.joinPath(O.userDataSyncHome,...(0,b.getPathSegments)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,b.PREVIEW_DIR_NAME),this.lastSyncResource=(0,b.getLastSyncResourceUri)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,O,this.extUri),this.currentMachineIdPromise=(0,h.getServiceMachineId)(O,A,F)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const m=await this.syncPreviewPromise;this.syncPreviewPromise=null;const E=await this.performSync(m.remoteUserData,m.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(E)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.hasRemoteChanged(m):!0)&&this._onDidChangeLocal.fire()}}setStatus(m){this._status!==m&&(this._status=m,this._onDidChangStatus.fire(m))}async sync(m,E={}){await this._sync(m,!0,this.getUserDataSyncConfiguration(),E)}async preview(m,E,A={}){return this._sync(m,!1,E,A)}async apply(m,E={}){try{this.syncHeaders={...E};const A=await this.doApply(m);return this.setStatus(A),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(m,E,A,O){try{if(this.syncHeaders={...O},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let F="idle";try{const M=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(m,M);return F=await this.performSync(k,M,E,A),F==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(F)}}finally{this.syncHeaders={}}}async replace(m){const E=this.parseSyncData(m);if(!E)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const A=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,A),F=await this.isRemoteDataFromCurrentMachine(O),M=await this.generateSyncPreview({ref:O.ref,syncData:E},A,F,this.getUserDataSyncConfiguration(),T.CancellationToken.None),k=[];for(const N of M){const z=await this.getAcceptResult(N,N.remoteResource,void 0,T.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(N,N.previewResource,N.remoteContent,T.CancellationToken.None);k.push([N,{...z,remoteChange:j!==0?j:2}])}await this.applyResult(O,A,k,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(m){const E=await this.currentMachineIdPromise;return!!m.syncData?.machineId&&m.syncData.machineId===E}async getLatestRemoteUserData(m,E){if(E){const A=m?m[this.resource]:void 0;if(E.ref===A||A===void 0&&E.syncData===null)return E}return this.getRemoteUserData(E)}async performSync(m,E,A,O){if(m.syncData&&m.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new b.UserDataSyncError((0,y.localize)(0,null,this.resource,this.version,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(m,E,A,O)}catch(F){if(F instanceof b.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(m,E,A,O);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),E=await this.getLastSyncUserData(),this.performSync(m,E,A,O)}throw F}}async doSync(m,E,A,O){try{const F=await this.isRemoteDataFromCurrentMachine(m),M=!F&&E===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,k=A&&!M;this.syncPreviewPromise||(this.syncPreviewPromise=(0,_.createCancelablePromise)(z=>this.doGenerateSyncResourcePreview(m,E,F,k,O,z)));let N=await this.syncPreviewPromise;if(A&&M){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of N.resourcePreviews)N=await this.accept(z.remoteResource)||N}return this.updateConflicts(N.resourcePreviews),N.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":A?await this.doApply(!1):"syncing"}catch(F){throw this.syncPreviewPromise=null,F}}async merge(m){return await this.updateSyncResourcePreview(m,async E=>{const A=await this.getMergeResult(E,T.CancellationToken.None);await this.fileService.writeFile(E.previewResource,c.VSBuffer.fromString(A?.content||""));const O=A&&!A.hasConflicts?await this.getAcceptResult(E,E.previewResource,void 0,T.CancellationToken.None):void 0;return E.acceptResult=O,E.mergeState=A.hasConflicts?"conflict":O?"accepted":"preview",E.localChange=O?O.localChange:A.localChange,E.remoteChange=O?O.remoteChange:A.remoteChange,E}),this.syncPreviewPromise}async accept(m,E){return await this.updateSyncResourcePreview(m,async A=>{const O=await this.getAcceptResult(A,m,E,T.CancellationToken.None);return A.acceptResult=O,A.mergeState="accepted",A.localChange=O.localChange,A.remoteChange=O.remoteChange,A}),this.syncPreviewPromise}async discard(m){return await this.updateSyncResourcePreview(m,async E=>{const A=await this.getMergeResult(E,T.CancellationToken.None);return await this.fileService.writeFile(E.previewResource,c.VSBuffer.fromString(A.content||"")),E.acceptResult=void 0,E.mergeState="preview",E.localChange=A.localChange,E.remoteChange=A.remoteChange,E}),this.syncPreviewPromise}async updateSyncResourcePreview(m,E){if(!this.syncPreviewPromise)return;let A=await this.syncPreviewPromise;const O=A.resourcePreviews.findIndex(({localResource:F,remoteResource:M,previewResource:k})=>this.extUri.isEqual(F,m)||this.extUri.isEqual(M,m)||this.extUri.isEqual(k,m));O!==-1&&(this.syncPreviewPromise=(0,_.createCancelablePromise)(async F=>{const M=[...A.resourcePreviews];return M[O]=await E(M[O]),{...A,resourcePreviews:M}}),A=await this.syncPreviewPromise,this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(m){if(!this.syncPreviewPromise)return"idle";const E=await this.syncPreviewPromise;return E.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":E.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.applyResult(E.remoteUserData,E.lastSyncUserData,E.resourcePreviews.map(A=>[A,A.acceptResult]),m),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(m){const E=m.filter(({mergeState:A})=>A==="conflict");(0,R.equals)(this._conflicts,E,(A,O)=>this.extUri.isEqual(A.previewResource,O.previewResource))||(this._conflicts=E,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async resolvePreviewContent(m){const E=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(E)for(const A of E.resourcePreviews){if(this.extUri.isEqual(A.acceptedResource,m))return A.acceptResult?A.acceptResult.content:null;if(this.extUri.isEqual(A.remoteResource,m))return A.remoteContent;if(this.extUri.isEqual(A.localResource,m))return A.localContent;if(this.extUri.isEqual(A.baseResource,m))return A.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(m){(0,d.toFileOperationResult)(m)!==1&&this.logService.error(m)}}async doGenerateSyncResourcePreview(m,E,A,O,F,M){const k=await this.generateSyncPreview(m,E,A,F,M),N=[];for(const z of k){const j=z.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)N.push({...z,acceptedResource:j,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=O?await this.getMergeResult(z,M):void 0;if(M.isCancellationRequested)break;await this.fileService.writeFile(z.previewResource,c.VSBuffer.fromString(J?.content||""));const ne=J&&!J.hasConflicts?await this.getAcceptResult(z,z.previewResource,void 0,M):void 0;N.push({...z,acceptResult:ne,mergeState:J?.hasConflicts?"conflict":ne?"accepted":"preview",localChange:ne?ne.localChange:J?J.localChange:z.localChange,remoteChange:ne?ne.remoteChange:J?J.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:E,resourcePreviews:N,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){let m=this.getStoredLastSyncUserDataStateContent();if(m||(m=await this.migrateLastSyncUserData()),!m)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const E=JSON.parse(m),A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!E.version&&!!A&&E.version!==A,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${E.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;let O,F=1;for(;O===void 0&&F++<6;)try{const M=await this.readLastSyncStoredRemoteUserData();M&&(M.ref===E.ref?O=M.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof d.FileOperationError&&M.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(M instanceof b.UserDataSyncError)throw M;this.logService.error(M,F)}}if(O===void 0)try{const M=await this.userDataSyncStoreService.resolveResourceContent(this.resource,E.ref,this.collection,this.syncHeaders);O=M===null?null:this.parseSyncData(M),await this.writeLastSyncStoredRemoteUserData({ref:E.ref,syncData:O})}catch(M){if(M instanceof b.UserDataSyncError&&M.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw M}return O===void 0?null:{...E,syncData:O}}async updateLastSyncUserData(m,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),O={ref:m.ref,version:A,...E};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(O),-1,1),await this.writeLastSyncStoredRemoteUserData(m)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const m=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const E=m?JSON.parse(m):void 0;if(i(E))return E}catch(E){this.logService.error(E)}}async writeLastSyncStoredRemoteUserData(m){await this.fileService.writeFile(this.lastSyncResource,c.VSBuffer.fromString(JSON.stringify(m)))}async migrateLastSyncUserData(){try{const m=await this.fileService.readFile(this.lastSyncResource),E=JSON.parse(m.value.toString());await this.fileService.del(this.lastSyncResource),E.ref&&E.content!==void 0&&(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...E,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:E.ref,syncData:E.content===null?null:JSON.parse(E.content)}))}catch(m){m instanceof d.FileOperationError&&m.fileOperationResult===1?this.logService.debug(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(m)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(m){const{ref:E,content:A}=await this.getUserData(m);let O=null;return A!==null&&(O=this.parseSyncData(A)),{ref:E,syncData:O}}parseSyncData(m){try{const E=JSON.parse(m);if(s(E))return E}catch(E){this.logService.error(E)}throw new b.UserDataSyncError((0,y.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(m){const E=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,E,this.collection,this.syncHeaders)}async updateRemoteUserData(m,E){const A=await this.currentMachineIdPromise,O={version:this.version,machineId:A,content:m};try{return E=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(O),E,this.collection,this.syncHeaders),{ref:E,syncData:O}}catch(F){throw F instanceof b.UserDataSyncError&&F.code==="TooLarge"&&(F=new b.UserDataSyncError(F.message,F.code,this.resource)),F}}async backupLocal(m){const E={version:this.version,content:m};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(E))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(b.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=Se([K(2,d.IFileService),K(3,S.IEnvironmentService),K(4,u.IStorageService),K(5,b.IUserDataSyncStoreService),K(6,b.IUserDataSyncBackupStoreService),K(7,b.IUserDataSyncEnablementService),K(8,f.ITelemetryService),K(9,b.IUserDataSyncLogService),K(10,g.IConfigurationService),K(11,v.IUriIdentityService)],n),e.AbstractSynchroniser=n;let r=class extends n{constructor(m,E,A,O,F,M,k,N,z,j,J,ne,G){super(E,A,O,F,M,k,N,z,j,J,ne,G),this.file=m,this._register(this.fileService.watch(this.extUri.dirname(m))),this._register(this.fileService.onDidFilesChange(q=>this.onFileChanges(q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(m,E,A){try{E?await this.fileService.writeFile(this.file,c.VSBuffer.fromString(m),A?void 0:E):await this.fileService.createFile(this.file,c.VSBuffer.fromString(m),{overwrite:A})}catch(O){throw O instanceof d.FileOperationError&&O.fileOperationResult===1||O instanceof d.FileOperationError&&O.fileOperationResult===3?new b.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(m){if(!(m instanceof d.FileOperationError&&m.fileOperationResult===1))throw m}}onFileChanges(m){!m.contains(this.file)||this.triggerLocalChange()}};r=Se([K(3,d.IFileService),K(4,S.IEnvironmentService),K(5,u.IStorageService),K(6,b.IUserDataSyncStoreService),K(7,b.IUserDataSyncBackupStoreService),K(8,b.IUserDataSyncEnablementService),K(9,f.ITelemetryService),K(10,b.IUserDataSyncLogService),K(11,g.IConfigurationService),K(12,v.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let a=class extends r{constructor(m,E,A,O,F,M,k,N,z,j,J,ne,G,q){super(m,E,A,O,F,M,k,N,z,j,J,G,q),this.userDataSyncUtilService=ne,this._formattingOptions=void 0}hasErrors(m,E){const A=[],O=(0,D.parse)(m,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,P.isUndefined)(O)&&E!==Array.isArray(O)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};a=Se([K(3,d.IFileService),K(4,S.IEnvironmentService),K(5,u.IStorageService),K(6,b.IUserDataSyncStoreService),K(7,b.IUserDataSyncBackupStoreService),K(8,b.IUserDataSyncEnablementService),K(9,f.ITelemetryService),K(10,b.IUserDataSyncLogService),K(11,b.IUserDataSyncUtilService),K(12,g.IConfigurationService),K(13,v.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let o=class{constructor(m,E,A,O,F,M,k){this.resource=m,this.userDataProfilesService=E,this.environmentService=A,this.logService=O,this.fileService=F,this.storageService=M,this.extUri=k.extUri,this.lastSyncResource=(0,b.getLastSyncResourceUri)(void 0,this.resource,A,this.extUri)}async initialize({ref:m,content:E}){if(!E){this.logService.info("Remote content does not exist.",this.resource);return}const A=this.parseSyncData(E);if(!!A)try{await this.doInitialize({ref:m,syncData:A})}catch(O){this.logService.error(O)}}parseSyncData(m){try{const E=JSON.parse(m);if(s(E))return E}catch(E){this.logService.error(E)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(m,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const A={ref:m.ref,version:void 0,...E};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(A),-1,1),await this.fileService.writeFile(this.lastSyncResource,c.VSBuffer.fromString(JSON.stringify(m)))}};o=Se([K(1,I.IUserDataProfilesService),K(2,S.IEnvironmentService),K(3,p.ILogService),K(4,d.IFileService),K(5,u.IStorageService),K(6,v.IUriIdentityService)],o),e.AbstractInitializer=o}),define(se[120],oe([0,1,6,25,9,3,43,2,27,16,15,119,30,33,80,14,5,72,8,20,19,29,18,41,260,117,24,62]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b,I,i,s,t,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function o(F,M){const k=JSON.parse(F.content);if(F.version===1||F.version===2){const N=(await M.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of k)F.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),F.version===2&&N.every(j=>!(0,S.areSameExtensions)(j.identifier,z.identifier))&&(z.installed=!0)}return k}function l(F){return JSON.parse(F.content)}e.parseExtensions=l;function m(F,M){return F.sort((k,N)=>!k.identifier.uuid&&N.identifier.uuid?-1:k.identifier.uuid&&!N.identifier.uuid?1:(0,C.compare)(k.identifier.id,N.identifier.id)),M?(0,L.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=m;let E=class extends s.AbstractSynchroniser{constructor(M,k,N,z,j,J,ne,G,q,x,Y,ee,re,ae,V,$,U){super({syncResource:"extensions",profile:M},k,z,N,j,J,ne,ee,re,x,Y,V),this.extensionManagementService=G,this.ignoredExtensionsManagementService=q,this.instantiationService=U,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(A),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,W=>W.some(({local:B})=>!!B)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,W=>!W.error),T.Event.filter($.onDidChange,W=>W.valueChanges.some(({profile:B,changes:Q})=>this.syncResource.profile.id===B.id&&Q.some(H=>H.key===g.DISABLED_EXTENSIONS_STORAGE_PATH))),ae.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(M,k){const N=M.syncData?await o(M.syncData,this.extensionManagementService):null,z=k?.skippedExtensions??[],j=k?.builtinExtensions??null,J=k?.syncData?await o(k.syncData,this.extensionManagementService):null,{localExtensions:ne,ignoredExtensions:G}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);N?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:x}=(0,t.merge)(ne,N,J,z,G,j),Y={local:q,remote:x,content:this.getPreviewContent(ne,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:x!==null?2:0},ee=this.stringify(ne,!1);return[{skippedExtensions:z,builtinExtensions:j,baseResource:this.baseResource,baseContent:J?this.stringify(J,!1):ee,localResource:this.localResource,localContent:ee,localExtensions:ne,remoteResource:this.remoteResource,remoteExtensions:N,remoteContent:N?this.stringify(N,!1):null,previewResource:this.previewResource,previewResult:Y,localChange:Y.localChange,remoteChange:Y.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(M){const k=M.syncData?await o(M.syncData,this.extensionManagementService):null,{localExtensions:N,ignoredExtensions:z}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:j}=(0,t.merge)(N,k,k,M.skippedExtensions||[],z,M.builtinExtensions||[]);return j!==null}getPreviewContent(M,k,N,z){const j=[...k,...N],J=new Set,ne=G=>{J.add(G.id.toLowerCase()),G.uuid&&J.add(G.uuid)};j.forEach(({identifier:G})=>ne(G)),z.forEach(ne);for(const G of M)J.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&J.has(G.identifier.uuid)||j.push(G);return this.stringify(j,!1)}async getMergeResult(M,k){return{...M.previewResult,hasConflicts:!1}}async getAcceptResult(M,k,N,z){if(this.extUri.isEqual(k,this.localResource))return this.acceptLocal(M);if(this.extUri.isEqual(k,this.remoteResource))return this.acceptRemote(M);if(this.extUri.isEqual(k,this.previewResource))return M.previewResult;throw new Error(`Invalid Resource: ${k.toString()}`)}async acceptLocal(M){const k=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),z=(0,t.merge)(M.localExtensions,null,null,M.skippedExtensions,N,M.builtinExtensions),{local:j,remote:J}=z;return{content:M.localContent,local:j,remote:J,localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:J!==null?2:0}}async acceptRemote(M){const k=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),z=M.remoteContent?JSON.parse(M.remoteContent):null;if(z!==null){const j=(0,t.merge)(M.localExtensions,z,M.localExtensions,[],N,M.builtinExtensions),{local:J,remote:ne}=j;return{content:M.remoteContent,local:J,remote:ne,localChange:J.added.length>0||J.removed.length>0||J.updated.length>0?2:0,remoteChange:ne!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(M,k,N,z){let{skippedExtensions:j,builtinExtensions:J,localExtensions:ne}=N[0][0];const{local:G,remote:q,localChange:x,remoteChange:Y}=N[0][1];if(x===0&&Y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),x!==0&&(await this.backupLocal(JSON.stringify(ne)),j=await this.localExtensionsProvider.updateLocalExtensions(G.added,G.removed,G.updated,j,this.syncResource.profile)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ee=JSON.stringify(q.all);M=await this.updateRemoteUserData(ee,z?null:M.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(re=>re.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(re=>re.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(re=>re.identifier.id))}.`:""}`)}k?.ref!==M.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),J=this.computeBuiltinExtensions(ne,J),await this.updateLastSyncUserData(M,{skippedExtensions:j,builtinExtensions:J}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${j.length?` Skipped: ${JSON.stringify(j.map(ee=>ee.identifier.id))}.`:""}`))}computeBuiltinExtensions(M,k){const N=new Set,z=[];for(const j of M)N.add(j.identifier.id.toLowerCase()),j.installed||z.push(j.identifier);if(k)for(const j of k)N.has(j.id.toLowerCase())||z.push(j);return z}async resolveContent(M){if(this.extUri.isEqual(this.remoteResource,M)||this.extUri.isEqual(this.baseResource,M)||this.extUri.isEqual(this.localResource,M)||this.extUri.isEqual(this.acceptedResource,M)){const k=await this.resolvePreviewContent(M);return k&&this.stringify(JSON.parse(k),!0)}return null}stringify(M,k){return m(M,k)}async hasLocalData(){try{const{localExtensions:M}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(M.some(k=>k.installed||k.disabled))return!0}catch{}return!1}};E=Se([K(2,P.IEnvironmentService),K(3,p.IFileService),K(4,v.IStorageService),K(5,r.IUserDataSyncStoreService),K(6,r.IUserDataSyncBackupStoreService),K(7,g.IExtensionManagementService),K(8,n.IIgnoredExtensionsManagementService),K(9,r.IUserDataSyncLogService),K(10,w.IConfigurationService),K(11,r.IUserDataSyncEnablementService),K(12,b.ITelemetryService),K(13,d.IExtensionStorageService),K(14,I.IUriIdentityService),K(15,a.IUserDataProfileStorageService),K(16,h.IInstantiationService)],E),e.ExtensionsSynchroniser=E;let A=class{constructor(M,k,N,z,j,J){this.extensionManagementService=M,this.userDataProfileStorageService=k,this.extensionGalleryService=N,this.ignoredExtensionsManagementService=z,this.instantiationService=j,this.logService=J}async getLocalExtensions(M){const k=await this.extensionManagementService.getInstalled(void 0,M.extensionsResource),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(k);return{localExtensions:await this.withProfileScopedServices(M,async(j,J)=>{const ne=j.getDisabledExtensions();return k.map(G=>{const{identifier:q,isBuiltin:x,manifest:Y,preRelease:ee,pinned:re}=G,ae={identifier:q,preRelease:ee,version:Y.version,pinned:!!re};ne.some(V=>(0,S.areSameExtensions)(V,q))&&(ae.disabled=!0),x||(ae.installed=!0);try{const V=J.getKeysForSync({id:q.id,version:Y.version});if(V){const $=J.getExtensionState(G,!0)||{};ae.state=Object.keys($).reduce((U,W)=>(V.includes(W)&&(U[W]=$[W]),U),{})}}catch(V){this.logService.info(`${(0,s.getSyncResourceLogLabel)("extensions",M)}: Error while parsing extension state`,(0,c.getErrorMessage)(V))}return ae})}),ignoredExtensions:N}}async updateLocalExtensions(M,k,N,z,j){const J=(0,s.getSyncResourceLogLabel)("extensions",j),ne=[],G=[],q=[],x=await this.extensionManagementService.getInstalled(void 0,j.extensionsResource);if((M.length||N.length)&&await this.withProfileScopedServices(j,async(ee,re)=>{await R.Promises.settled([...M,...N].map(async ae=>{const V=x.find(W=>(0,S.areSameExtensions)(W.identifier,ae.identifier));if(V&&V.isBuiltin){ae.state&&V.manifest.version===ae.version&&this.updateExtensionState(ae.state,V,V.manifest.version,re),ee.getDisabledExtensions().some(B=>(0,S.areSameExtensions)(B,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.logService.trace(`${J}: Disabling extension...`,ae.identifier.id),await ee.disableExtension(ae.identifier),this.logService.info(`${J}: Disabled extension`,ae.identifier.id)):(this.logService.trace(`${J}: Enabling extension...`,ae.identifier.id),await ee.enableExtension(ae.identifier),this.logService.info(`${J}: Enabled extension`,ae.identifier.id))),G.push(ae.identifier);return}const $=ae.pinned?ae.version:void 0,U=(await this.extensionGalleryService.getExtensions([{...ae.identifier,version:$,preRelease:$?void 0:ae.preRelease}],_.CancellationToken.None))[0];if(ae.state&&(V?V.manifest.version===ae.version:!!U)&&this.updateExtensionState(ae.state,V||U,V?.manifest.version,re),U)try{ee.getDisabledExtensions().some(B=>(0,S.areSameExtensions)(B,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.logService.trace(`${J}: Disabling extension...`,ae.identifier.id,U.version),await ee.disableExtension(U.identifier),this.logService.info(`${J}: Disabled extension`,ae.identifier.id,U.version)):(this.logService.trace(`${J}: Enabling extension...`,ae.identifier.id,U.version),await ee.enableExtension(U.identifier),this.logService.info(`${J}: Enabled extension`,ae.identifier.id,U.version))),(!V||V.preRelease!==ae.preRelease||V.pinned!==ae.pinned||$&&V.manifest.version!==$)&&(await this.extensionManagementService.canInstall(U)?ne.push([ae,U]):(this.logService.info(`${J}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),q.push(ae)))}catch(W){q.push(ae),this.logService.error(W),this.logService.info(`${J}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else q.push(ae),this.logService.info(`${J}: Skipped synchronizing extension because the extension is not found.`,ae.identifier.id)}))}),k.length){const ee=x.filter(({identifier:re,isBuiltin:ae})=>!ae&&k.some(V=>(0,S.areSameExtensions)(re,V)));await R.Promises.settled(ee.map(async re=>{this.logService.trace(`${J}: Uninstalling local extension...`,re.identifier.id),await this.extensionManagementService.uninstall(re,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:j.extensionsResource}),this.logService.info(`${J}: Uninstalled local extension.`,re.identifier.id),G.push(re.identifier)}))}for(const[ee,re]of ne)try{this.logService.trace(`${J}: Installing extension...`,re.identifier.id,re.version),await this.extensionManagementService.installFromGallery(re,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ee.pinned&&!!ee.version,installPreReleaseVersion:ee.preRelease,profileLocation:j.extensionsResource,context:{[g.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[g.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.logService.info(`${J}: Installed extension.`,re.identifier.id,re.version),G.push(re.identifier)}catch(ae){q.push(ee),ae instanceof g.ExtensionManagementError&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatiblePreRelease,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ae.code)?this.logService.info(`${J}: Skipped synchronizing extension because the compatible extension is not found.`,re.displayName||re.identifier.id):(this.logService.error(ae),this.logService.info(`${J}: Skipped synchronizing extension`,re.displayName||re.identifier.id))}const Y=[];for(const ee of z)G.some(re=>(0,S.areSameExtensions)(re,ee.identifier))||Y.push(ee);for(const ee of q)Y.some(re=>(0,S.areSameExtensions)(re.identifier,ee.identifier))||Y.push(ee);return Y}updateExtensionState(M,k,N,z){const j=z.getExtensionState(k,!0)||{},J=N?z.getKeysForSync({id:k.identifier.id,version:N}):void 0;J?J.forEach(ne=>{j[ne]=M[ne]}):Object.keys(M).forEach(ne=>j[ne]=M[ne]),z.setExtensionState(k,j,!0)}async withProfileScopedServices(M,k){return this.userDataProfileStorageService.withProfileScopedStorageService(M,async N=>{const z=new D.DisposableStore,j=this.instantiationService.createChild(new u.ServiceCollection([v.IStorageService,N])),J=z.add(j.createInstance(y.GlobalExtensionEnablementService)),ne=z.add(j.createInstance(d.ExtensionStorageService));try{return await k(J,ne)}finally{z.dispose()}})}};A=Se([K(0,g.IExtensionManagementService),K(1,a.IUserDataProfileStorageService),K(2,g.IExtensionGalleryService),K(3,n.IIgnoredExtensionsManagementService),K(4,h.IInstantiationService),K(5,r.IUserDataSyncLogService)],A),e.LocalExtensionsProvider=A;let O=class extends s.AbstractInitializer{constructor(M,k,N,z,j,J,ne,G){super("extensions",z,j,J,N,ne,G),this.extensionManagementService=M,this.ignoredExtensionsManagementService=k}async parseExtensions(M){return M.syncData?await o(M.syncData,this.extensionManagementService):null}generatePreview(M,k){const N=[],z=[],j=[];for(const J of M){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(J.identifier.id))continue;const ne=k.find(G=>(0,S.areSameExtensions)(G.identifier,J.identifier));ne?(N.push(ne),J.disabled&&j.push(J.identifier)):J.installed&&(z.push({...J.identifier,preRelease:!!J.preRelease}),J.disabled&&j.push(J.identifier))}return{installedExtensions:N,newExtensions:z,disabledExtensions:j,remoteExtensions:M}}};O=Se([K(0,g.IExtensionManagementService),K(1,n.IIgnoredExtensionsManagementService),K(2,p.IFileService),K(3,i.IUserDataProfilesService),K(4,P.IEnvironmentService),K(5,f.ILogService),K(6,v.IStorageService),K(7,I.IUriIdentityService)],O),e.AbstractExtensionsInitializer=O}),define(se[121],oe([0,1,17,9,3,35,43,4,31,16,15,14,8,45,20,19,29,41,61,264,24,18,62,5]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b,I,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",n=["locale"];function r(A,O){const F=A.storage?Object.keys(A.storage).sort():[],M={};return F.forEach(k=>M[k]=A.storage[k]),A.storage=M,O?(0,L.toFormattedString)(A,{}):JSON.stringify(A)}e.stringify=r;const a=1;let o=class extends u.AbstractSynchroniser{constructor(O,F,M,k,N,z,j,J,ne,G,q,x,Y,ee){super({syncResource:"globalState",profile:O},F,k,J,x,N,z,ne,G,j,q,Y),this.userDataProfileStorageService=M,this.version=a,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ee.createInstance(l),this._register(k.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(c.Event.any(c.Event.filter(k.onDidFilesChange,re=>re.contains(this.environmentService.argvResource)),c.Event.filter(M.onDidChange,re=>!!(re.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||re.valueChanges.some(({profile:ae,changes:V})=>this.syncResource.profile.id===ae.id&&V.some($=>$.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(O,F,M){const k=O.syncData?JSON.parse(O.syncData.content):null;F=F===null&&M?O:F;const N=F&&F.syncData?JSON.parse(F.syncData.content):null,z=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const j=await this.getStorageKeys(N),{local:J,remote:ne}=(0,v.merge)(z.storage,k?k.storage:null,N?N.storage:null,j,this.logService),G={content:null,local:J,remote:ne,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:ne.all!==null?2:0},q=r(z,!1);return[{baseResource:this.baseResource,baseContent:N?r(N,!1):q,localResource:this.localResource,localContent:q,localUserData:z,remoteResource:this.remoteResource,remoteContent:k?r(k,!1):null,previewResource:this.previewResource,previewResult:G,localChange:G.localChange,remoteChange:G.remoteChange,acceptedResource:this.acceptedResource,storageKeys:j}]}async hasRemoteChanged(O){const F=O.syncData?JSON.parse(O.syncData.content):null;if(F===null)return!0;const M=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),k=await this.getStorageKeys(F),{remote:N}=(0,v.merge)(M.storage,F.storage,F.storage,k,this.logService);return N.all!==null}async getMergeResult(O,F){return{...O.previewResult,hasConflicts:!1}}async getAcceptResult(O,F,M,k){if(this.extUri.isEqual(F,this.localResource))return this.acceptLocal(O);if(this.extUri.isEqual(F,this.remoteResource))return this.acceptRemote(O);if(this.extUri.isEqual(F,this.previewResource))return O.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async acceptLocal(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(O){if(O.remoteContent!==null){const F=JSON.parse(O.remoteContent),{local:M,remote:k}=(0,v.merge)(O.localUserData.storage,F.storage,null,O.storageKeys,this.logService);return{content:O.remoteContent,local:M,remote:k,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(O,F,M,k){const{localUserData:N}=M[0][0],{local:z,remote:j,localChange:J,remoteChange:ne}=M[0][1];if(J===0&&ne===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.localGlobalStateProvider.writeLocalGlobalState(z,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),ne!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const G=JSON.stringify({storage:j.all});O=await this.updateRemoteUserData(G,k?null:O.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${j.added.length?` Added: ${j.added}.`:""}${j.updated.length?` Updated: ${j.updated}.`:""}${j.removed.length?` Removed: ${j.removed}.`:""}`)}F?.ref!==O.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(O),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(O){if(this.extUri.isEqual(this.remoteResource,O)||this.extUri.isEqual(this.baseResource,O)||this.extUri.isEqual(this.localResource,O)||this.extUri.isEqual(this.acceptedResource,O)){const F=await this.resolvePreviewContent(O);return F&&r(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:O}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(O){const F=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),M=[],k=[];for(const[j,J]of F)J.target===0?M.push(j):J.target===1&&k.push(j);const N=[...M,...k],z=O?.storage?Object.keys(O.storage).filter(j=>!j.startsWith(t)&&!N.includes(j)&&F.get(j)!==void 0):[];if(!D.isWeb){const j=[...b.ALL_SYNC_RESOURCES.map(J=>(0,b.getEnablementKey)(J)),b.SYNC_SERVICE_URL_TYPE];z.push(...j),k.push(...j)}return{user:M,machine:k,unregistered:z}}};o=Se([K(2,i.IUserDataProfileStorageService),K(3,y.IFileService),K(4,b.IUserDataSyncStoreService),K(5,b.IUserDataSyncBackupStoreService),K(6,b.IUserDataSyncLogService),K(7,P.IEnvironmentService),K(8,b.IUserDataSyncEnablementService),K(9,p.ITelemetryService),K(10,w.IConfigurationService),K(11,d.IStorageService),K(12,h.IUriIdentityService),K(13,s.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let l=class{constructor(O,F,M,k){this.fileService=O,this.environmentService=F,this.userDataProfileStorageService=M,this.logService=k}async getLocalGlobalState(O){const F={};if(O.isDefault){const k=await this.getLocalArgvContent(),N=(0,T.parse)(k);for(const z of n)N[z]!==void 0&&(F[`${t}${z}`]={version:1,value:N[z]})}const M=await this.userDataProfileStorageService.readStorageData(O);for(const[k,N]of M)N.value&&N.target===0&&(F[k]={version:1,value:N.value});return{storage:F}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const O=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),O.value.toString()}catch(O){this.logService.debug((0,_.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:F,updated:M},k){const N=(0,u.getSyncResourceLogLabel)("globalState",k),z={},j=new Map,J=await this.userDataProfileStorageService.readStorageData(k),ne=(G,q)=>{for(const x of G){if(x.startsWith(t)){z[x.substring(t.length)]=q?q[x].value:void 0;continue}if(q){const Y=q[x];Y.value!==J.get(x)?.value&&j.set(x,Y.value)}else J.get(x)!==void 0&&j.set(x,void 0)}};if(ne(Object.keys(O),O),ne(Object.keys(M),M),ne(F),Object.keys(z).length){this.logService.trace(`${N}: Updating locale...`);const G=await this.getLocalArgvContent();let q=G;for(const x of Object.keys(z))q=(0,f.edit)(q,[x],z[x],{});G!==q&&(this.logService.trace(`${N}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(q)),this.logService.info(`${N}: Updated locale.`)),this.logService.info(`${N}: Updated locale`)}j.size&&(this.logService.trace(`${N}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(k,j,0),this.logService.info(`${N}: Updated global state`,[...j.keys()]))}};l=Se([K(0,y.IFileService),K(1,P.IEnvironmentService),K(2,i.IUserDataProfileStorageService),K(3,b.IUserDataSyncLogService)],l),e.LocalGlobalStateProvider=l;let m=class extends u.AbstractInitializer{constructor(O,F,M,k,N,z){super("globalState",M,k,N,F,O,z)}async doInitialize(O){const F=O.syncData?JSON.parse(O.syncData.content):null;if(!F){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},k={};for(const N of Object.keys(F.storage))N.startsWith(t)?M[N.substring(t.length)]=F.storage[N].value:this.storageService.get(N,0)===void 0&&(k[N]=F.storage[N].value);if(Object.keys(M).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const z of Object.keys(M))N=(0,f.edit)(N,[z],M[z],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(N))}if(Object.keys(k).length)for(const N of Object.keys(k))this.storageService.store(N,k[N],0,0)}};m=Se([K(0,d.IStorageService),K(1,y.IFileService),K(2,I.IUserDataProfilesService),K(3,P.IEnvironmentService),K(4,b.IUserDataSyncLogService),K(5,h.IUriIdentityService)],m),e.GlobalStateInitializer=m;let E=class{constructor(O,F,M,k,N){this.userDataSyncStoreClient=O,this.storageService=F,this.environmentService=M,this.fileService=k,this.logService=N}getSyncStoreType(O){return this.parseGlobalState(O)?.storage[b.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const F=(0,b.createSyncHeaders)((0,C.generateUuid)());try{return await this.doSync(O,F)}catch(M){if(M instanceof b.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(O,F)}throw M}}async doSync(O,F){const M=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,F),k=this.parseGlobalState(M)||{storage:{}};k.storage[b.SYNC_SERVICE_URL_TYPE]={value:O,version:a};const N=await(0,S.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),z={version:a,machineId:N,content:r(k,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(z),M.ref,void 0,F)}parseGlobalState({content:O}){if(!O)return null;const F=JSON.parse(O);if((0,u.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};E=Se([K(1,d.IStorageService),K(2,P.IEnvironmentService),K(3,y.IFileService),K(4,g.ILogService)],E),e.UserDataSyncStoreTypeSynchronizer=E}),define(se[122],oe([0,1,21,17,3,35,4,12,182,16,15,14,20,19,29,18,41,261,24]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function v(i,s,t){try{const n=JSON.parse(i);if(!s)return(0,D.isUndefined)(n.all)?null:n.all;switch(L.OS){case 2:return(0,D.isUndefined)(n.mac)?null:n.mac;case 3:return(0,D.isUndefined)(n.linux)?null:n.linux;case 1:return(0,D.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=v;let b=class extends h.AbstractJsonFileSynchroniser{constructor(s,t,n,r,a,o,l,m,E,A,O,F,M){super(s.keybindingsResource,{syncResource:"keybindings",profile:s},t,m,E,A,n,r,l,F,a,O,o,M),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(c.Event.filter(o.onDidChangeConfiguration,k=>k.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,n,r){const a=s.syncData?v(s.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&n?s:t;const o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),m=await this.getFormattingOptions();let E=null,A=!1,O=!1,F=!1;if(a){let N=l?l.value.toString():"[]";if(N=N||"[]",this.hasErrors(N,!0))throw new f.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==N||o!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,u.merge)(N,a,o,m,this.userDataSyncUtilService);z.hasChanges&&(E=z.mergeContent,F=z.hasConflicts,A=F||z.mergeContent!==N,O=F||z.mergeContent!==a)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),E=l.value.toString(),O=!0);const M={content:F?o:E,localChange:A?l?2:1:0,remoteChange:O?2:0,hasConflicts:F},k=l?l.value.toString():null;return[{fileContent:l,baseResource:this.baseResource,baseContent:o,localResource:this.localResource,localContent:k,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getKeybindingsContentFromLastSyncUserData(s);if(t===null)return!0;const n=await this.getLocalFileContent(),r=n?n.value.toString():"",a=await this.getFormattingOptions(),o=await(0,u.merge)(r||"[]",t,t,a,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==t}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,n,r){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,n,r){const{fileContent:a}=n[0][0];let{content:o,localChange:l,remoteChange:m}=n[0][1];if(l===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o,!0)))throw new f.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(o||"[]",a,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),m!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const E=this.toSyncContent(o||"[]",s.syncData?.content);s=await this.updateRemoteUserData(E,r?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,T.parse)(s.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.baseResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)?this.resolvePreviewContent(s):null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:v(s.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(s,t){let n={};try{n=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=s,L.OS){case 2:n.mac=s;break;case 3:n.linux=s;break;case 1:n.windows=s;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(f.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};b=Se([K(2,f.IUserDataSyncStoreService),K(3,f.IUserDataSyncBackupStoreService),K(4,f.IUserDataSyncLogService),K(5,w.IConfigurationService),K(6,f.IUserDataSyncEnablementService),K(7,y.IFileService),K(8,P.IEnvironmentService),K(9,g.IStorageService),K(10,f.IUserDataSyncUtilService),K(11,S.ITelemetryService),K(12,d.IUriIdentityService)],b),e.KeybindingsSynchroniser=b;let I=class extends h.AbstractInitializer{constructor(s,t,n,r,a,o){super("keybindings",t,n,r,s,a,o)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,_.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,T.parse)(s.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return v(s,!0,this.logService)}catch(t){return this.logService.error(t),null}}};I=Se([K(0,y.IFileService),K(1,p.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,f.IUserDataSyncLogService),K(4,g.IStorageService),K(5,d.IUriIdentityService)],I),e.KeybindingsInitializer=I}),define(se[123],oe([0,1,17,3,183,16,74,15,30,14,20,19,29,18,41,61,265,24]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function v(i){const s=JSON.parse(i);return f(s)?s:{settings:i}}e.parseSettingsSyncContent=v;let b=class extends d.AbstractJsonFileSynchroniser{constructor(s,t,n,r,a,o,l,m,E,A,O,F,M,k){super(s.settingsResource,{syncResource:"settings",profile:s},t,n,r,a,o,l,O,F,m,E,A,k),this.extensionManagementService=M,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(s,t),r=this.getSettingsSyncContent(n),a=new L.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return r?.settings&&a.parse(r.settings),a.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,t,n){const r=await this.getLocalFileContent(),a=await this.getFormattingOptions(),o=this.getSettingsSyncContent(s);t=t===null&&n?s:t;const l=t?this.getSettingsSyncContent(t):null,m=await this.getIgnoredSettings();let E=null,A=!1,O=!1,F=!1;if(o){let z=r?r.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const j=(0,h.merge)(z,o.settings,l?l.settings:null,m,[],a);E=j.localContent||j.remoteContent,A=j.localContent!==null,O=j.remoteContent!==null,F=j.hasConflicts}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),E=r.value.toString().trim()||"{}",this.validateContent(E),O=!0);const M=r?r.value.toString():null,k=l?.settings??null,N={content:F?k:E,localChange:A?2:0,remoteChange:O?2:0,hasConflicts:F};return[{fileContent:r,baseResource:this.baseResource,baseContent:k,localResource:this.localResource,localContent:M,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getSettingsSyncContent(s);if(t===null)return!0;const n=await this.getLocalFileContent(),r=n?n.value.toString().trim():"",a=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,h.merge)(r||"{}",t.settings,t.settings,a,[],o).remoteContent!==null}async getMergeResult(s,t){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,h.updateIgnoredSettings)(s.previewResult.content,"{}",r,n):null}}async getAcceptResult(s,t,n,r){const a=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?(0,h.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",o,a):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,h.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",o,a):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,h.updateIgnoredSettings)(n,s.fileContent?s.fileContent.value.toString():"{}",o,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,n,r){const{fileContent:a}=n[0][0];let{content:o,localChange:l,remoteChange:m}=n[0][1];if(l===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),a&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(a.value.toString()))),await this.updateLocalFileContent(o,a,r),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),m!==0){const E=await this.getFormattingOptions(),A=this.getSettingsSyncContent(s),O=await this.getIgnoredSettings(o);o=(0,h.updateIgnoredSettings)(o,A?A.settings:"{}",O,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),r?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=await this.getFormattingOptions(),n=(0,p.edit)(s.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,h.isEmpty)(n)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s)?this.resolvePreviewContent(s):null}async resolvePreviewContent(s){let t=await super.resolvePreviewContent(s);if(t){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();t=(0,h.updateIgnoredSettings)(t,"{}",r,n)}return t}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return v(s)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:a})=>!!a)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,h.getIgnoredSettings)(t,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new u.UserDataSyncError((0,c.localize)(0,null),"LocalInvalidContent",this.resource)}};b=Se([K(2,w.IFileService),K(3,D.IEnvironmentService),K(4,P.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncBackupStoreService),K(7,u.IUserDataSyncLogService),K(8,u.IUserDataSyncUtilService),K(9,T.IConfigurationService),K(10,u.IUserDataSyncEnablementService),K(11,y.ITelemetryService),K(12,C.IExtensionManagementService),K(13,g.IUriIdentityService)],b),e.SettingsSynchroniser=b;let I=class extends d.AbstractInitializer{constructor(s,t,n,r,a,o){super("settings",t,n,r,s,a,o)}async doInitialize(s){const t=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,R.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,h.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return v(s)}catch(t){this.logService.error(t)}return null}};I=Se([K(0,w.IFileService),K(1,S.IUserDataProfilesService),K(2,D.IEnvironmentService),K(3,u.IUserDataSyncLogService),K(4,P.IStorageService),K(5,g.IUriIdentityService)],I),e.SettingsInitializer=I}),define(se[124],oe([0,1,17,3,32,16,15,14,20,19,29,18,41,262,24]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function p(f){return JSON.parse(f.content)}e.parseSnippets=p;let h=class extends g.AbstractSynchroniser{constructor(v,b,I,i,s,t,n,r,a,o,l,m){super({syncResource:"snippets",profile:v},b,i,I,s,t,n,o,l,r,a,m),this.version=1,this.snippetsFolder=v.snippetsHome,this._register(this.fileService.watch(I.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(_.Event.filter(this.fileService.onDidFilesChange,E=>E.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(v,b,I){const i=await this.getSnippetsFileContents(),s=this.toSnippetsContents(i),t=v.syncData?this.parseSnippets(v.syncData):null;b=b===null&&I?v:b;const n=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,S.merge)(s,t,n);return this.getResourcePreviews(r,i,t||{},n||{})}async hasRemoteChanged(v){const b=v.syncData?this.parseSnippets(v.syncData):null;if(b===null)return!0;const I=await this.getSnippetsFileContents(),i=this.toSnippetsContents(I),s=(0,S.merge)(i,b,b);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async getMergeResult(v,b){return v.previewResult}async getAcceptResult(v,b,I,i){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:v.fileContent?v.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:v.remoteContent,localChange:v.remoteContent!==null?v.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return I===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:I,localChange:I===null?v.fileContent!==null?3:0:2,remoteChange:I===null?v.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(v,b,I,i){const s=I.map(([t,n])=>({...t,acceptResult:n}));s.every(({localChange:t,remoteChange:n})=>t===0&&n===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,i)),s.some(({remoteChange:t})=>t!==0)&&(v=await this.updateRemoteSnippets(s,v,i)),b?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of s)try{await this.fileService.del(t)}catch{}}getResourcePreviews(v,b,I,i){const s=new Map;for(const t of Object.keys(v.local.added)){const n={content:v.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v.local.updated)){const n={content:v.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},r=b[t]?b[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of v.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},r=b[t]?b[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v.remote.added)){const n={content:v.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},r=b[t]?b[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v.remote.updated)){const n={content:v.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},r=b[t]?b[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of v.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of v.conflicts){const n={content:i[t]??null,hasConflicts:!0,localChange:b[t]?2:1,remoteChange:I[t]?2:1},r=b[t]?b[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(b))if(!s.has(t)){const n={content:b[t]?b[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},r=b[t]?b[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...s.values()]}async resolveContent(v){return this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(v):null}async hasLocalData(){try{const v=await this.getSnippetsFileContents();if(Object.keys(v).length)return!0}catch{}return!1}async updateLocalBackup(v){const b={};for(const I of v)I.fileContent&&(b[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(v,b){for(const{fileContent:I,acceptResult:i,localResource:s,remoteResource:t,localChange:n}of v)if(n!==0){const r=t?this.extUri.basename(t):this.extUri.basename(s),a=this.extUri.joinPath(this.snippetsFolder,r);n===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(a)),await this.fileService.del(a),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(a))):n===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(a)),await this.fileService.createFile(a,R.VSBuffer.fromString(i.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(a))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(a)),await this.fileService.writeFile(a,R.VSBuffer.fromString(i.content),b?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(a)))}}async updateRemoteSnippets(v,b,I){const i=b.syncData?this.parseSnippets(b.syncData):{},s=(0,c.deepClone)(i);for(const{acceptResult:t,localResource:n,remoteResource:r,remoteChange:a}of v)if(a!==0){const o=n?this.extUri.basename(n):this.extUri.basename(r);a===3?delete s[o]:s[o]=t.content}return(0,S.areSame)(i,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(s),I?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(v){return p(v)}toSnippetsContents(v){const b={};for(const I of Object.keys(v))b[I]=v[I].value.toString();return b}async getSnippetsFileContents(){const v={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof D.FileOperationError&&I.fileOperationResult===1)return v;throw I}for(const I of b.children||[]){const i=I.resource,s=this.extUri.extname(i);if(s===".json"||s===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,i),n=await this.fileService.readFile(i);v[t]=n}}return v}};h=Se([K(2,L.IEnvironmentService),K(3,D.IFileService),K(4,C.IStorageService),K(5,d.IUserDataSyncStoreService),K(6,d.IUserDataSyncBackupStoreService),K(7,d.IUserDataSyncLogService),K(8,T.IConfigurationService),K(9,d.IUserDataSyncEnablementService),K(10,w.ITelemetryService),K(11,P.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let u=class extends g.AbstractInitializer{constructor(v,b,I,i,s,t){super("snippets",b,I,i,v,s,t)}async doInitialize(v){const b=v.syncData?JSON.parse(v.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(b)){const s=b[i];if(s){const t=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,i);await this.fileService.createFile(t,R.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(v)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(v){return v.fileOperationResult===1}}};u=Se([K(0,D.IFileService),K(1,y.IUserDataProfilesService),K(2,L.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,C.IStorageService),K(5,P.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(se[125],oe([0,1,17,16,15,14,20,19,29,18,41,24]),function(Z,e,R,_,c,T,L,D,C,w,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function g(h,u){try{return JSON.parse(h).tasks??null}catch(f){return u.error(f),null}}e.getTasksContentFromSyncContent=g;let S=class extends P.AbstractFileSynchroniser{constructor(u,f,v,b,I,i,s,t,n,r,a,o){super(u.tasksResource,{syncResource:"tasks",profile:u},f,t,n,r,v,b,s,a,I,i,o),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,f,v,b){const I=u.syncData?g(u.syncData.content,this.logService):null;f=f===null&&v?u:f;const i=f?.syncData?g(f.syncData.content,this.logService):null,s=await this.getLocalFileContent();let t=null,n=!1,r=!1,a=!1;if(u.syncData){const m=s?s.value.toString():null;if(!i||i!==m||i!==I){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const E=p(m,I,i);t=E.content,a=E.hasConflicts,n=E.hasLocalChanged,r=E.hasRemoteChanged}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=s.value.toString(),r=!0);const o={content:a?i:t,localChange:n?s?2:1:0,remoteChange:r?2:0,hasConflicts:a},l=s?s.value.toString():null;return[{fileContent:s,baseResource:this.baseResource,baseContent:i,localResource:this.localResource,localContent:l,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:I,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const f=u?.syncData?g(u.syncData.content,this.logService):null;if(f===null)return!0;const v=await this.getLocalFileContent(),b=v?v.value.toString():null,I=p(b,f,f);return I.hasLocalChanged||I.hasRemoteChanged}async getMergeResult(u,f){return u.previewResult}async getAcceptResult(u,f,v,b){if(this.extUri.isEqual(f,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(f,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(f,this.previewResource))return v===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:v,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async applyResult(u,f,v,b){const{fileContent:I}=v[0][0],{content:i,localChange:s,remoteChange:t}=v[0][1];if(s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),I&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(I.value.toString()))),i?await this.updateLocalFileContent(i,I,b):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const n=JSON.stringify(this.toTasksSyncContent(i));u=await this.updateRemoteUserData(n,b?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}f?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(u){return this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)?this.resolvePreviewContent(u):null}toTasksSyncContent(u){return u?{tasks:u}:{}}};S=Se([K(2,y.IUserDataSyncStoreService),K(3,y.IUserDataSyncBackupStoreService),K(4,y.IUserDataSyncLogService),K(5,_.IConfigurationService),K(6,y.IUserDataSyncEnablementService),K(7,T.IFileService),K(8,c.IEnvironmentService),K(9,L.IStorageService),K(10,D.ITelemetryService),K(11,C.IUriIdentityService)],S),e.TasksSynchroniser=S;let d=class extends P.AbstractInitializer{constructor(u,f,v,b,I,i){super("tasks",f,v,b,u,I,i),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const f=u.syncData?g(u.syncData.content,this.logService):null;if(!f){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(f)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};d=Se([K(0,T.IFileService),K(1,w.IUserDataProfilesService),K(2,c.IEnvironmentService),K(3,y.IUserDataSyncLogService),K(4,L.IStorageService),K(5,C.IUriIdentityService)],d),e.TasksInitializer=d;function p(h,u,f){if(h===null&&u===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(h===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const v=f!==h,b=f!==u;return!v&&!b?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:v&&!b?{content:h,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:b&&!v?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:h,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(se[126],oe([0,1,43,16,15,14,20,19,29,18,41,263,24]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let S=class extends P.AbstractSynchroniser{constructor(u,f,v,b,I,i,s,t,n,r,a,o,l){super({syncResource:"profiles",profile:u},f,b,I,i,s,t,a,o,n,r,l),this.userDataProfilesService=v,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?p(u.syncData):null}async getRemoteSyncedProfiles(u){const f=await this.getLastSyncUserData(),v=await this.getLatestRemoteUserData(u,f);return v?.syncData?p(v.syncData):null}async generateSyncPreview(u,f,v){if(!this.userDataProfilesService.isEnabled())throw new g.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const b=u.syncData?p(u.syncData):null,I=f?.syncData?p(f.syncData):null,i=this.getLocalUserDataProfiles(),{local:s,remote:t}=(0,y.merge)(i,b,I,[]),n={local:s,remote:t,content:I?this.stringifyRemoteProfiles(I):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:t!==null?2:0},r=d(i,!1);return[{baseResource:this.baseResource,baseContent:I?this.stringifyRemoteProfiles(I):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:b?this.stringifyRemoteProfiles(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const f=u?.syncData?p(u.syncData):null,v=this.getLocalUserDataProfiles(),{remote:b}=(0,y.merge)(v,f,f,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async getMergeResult(u,f){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,f,v,b){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(f,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(u){const f=this.getLocalUserDataProfiles(),v=(0,y.merge)(f,null,null,[]),{local:b,remote:I}=v;return{content:u.localContent,local:b,remote:I,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:I!==null?2:0}}async acceptRemote(u){const f=u.remoteContent?JSON.parse(u.remoteContent):null,v=[],b=[];for(const I of this.getLocalUserDataProfiles()){const i=f?.find(s=>s.id===I.id);i&&(v.push({id:I.id,name:I.name,collection:i.collection}),b.push(I))}if(f!==null){const I=(0,y.merge)(b,f,v,[]),{local:i,remote:s}=I;return{content:u.remoteContent,local:i,remote:s,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:s!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,f,v,b){const{local:I,remote:i,localChange:s,remoteChange:t}=v[0][1];s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const n=v[0][0].remoteProfiles||[];if(n.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new g.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(s!==0){await this.backupLocal(d(this.getLocalUserDataProfiles(),!1));const r=[];for(const a of I.added)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${a.name}' profile...`),await this.userDataProfilesService.createProfile(a.id,a.name,{shortName:a.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${a.name}'.`)})());for(const a of I.removed)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${a.name}' profile...`),await this.userDataProfilesService.removeProfile(a),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${a.name}'.`)})());for(const a of I.updated){const o=this.userDataProfilesService.profiles.find(l=>l.id===a.id);o?r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${a.name}' profile...`),await this.userDataProfilesService.updateProfile(o,{name:a.name,shortName:a.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${a.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${a.id}' to update.`)}await Promise.all(r)}if(t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const r=[],a=n.length+(i?.added.length??0)<=20;if(a)for(const o of i?.added||[]){const l=await this.userDataSyncStoreService.createCollection(this.syncHeaders);r.push(l),n.push({id:o.id,name:o.name,collection:l,shortName:o.shortName})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const o of i?.removed||[])n.splice(n.findIndex(({id:l})=>o.id===l),1);for(const o of i?.updated||[]){const l=n.find(({id:m})=>o.id===m);l&&n.splice(n.indexOf(l),1,{id:o.id,name:o.name,collection:l.collection,shortName:o.shortName})}try{u=await this.updateRemoteProfiles(n,b?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${a&&i?.added.length?` Added: ${JSON.stringify(i.added.map(o=>o.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(o=>o.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(o=>o.name))}.`:""}`)}catch(o){if(r.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const l of r)await this.userDataSyncStoreService.deleteCollection(l,this.syncHeaders)}throw o}for(const o of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(o.collection,this.syncHeaders)}f?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,f){return this.updateRemoteUserData(this.stringifyRemoteProfiles(u),f)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const f=await this.resolvePreviewContent(u);return f&&(0,R.toFormattedString)(JSON.parse(f),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((f,v)=>f.name.localeCompare(v.name)))}};S=Se([K(2,w.IUserDataProfilesService),K(3,T.IFileService),K(4,c.IEnvironmentService),K(5,L.IStorageService),K(6,g.IUserDataSyncStoreService),K(7,g.IUserDataSyncBackupStoreService),K(8,g.IUserDataSyncLogService),K(9,_.IConfigurationService),K(10,g.IUserDataSyncEnablementService),K(11,D.ITelemetryService),K(12,C.IUriIdentityService)],S),e.UserDataProfilesManifestSynchroniser=S;function d(h,u){const f=[...h].sort((v,b)=>v.name.localeCompare(b.name)).map(v=>({id:v.id,name:v.name}));return u?(0,R.toFormattedString)(f,{}):JSON.stringify(f)}e.stringifyLocalProfiles=d;function p(h){return JSON.parse(h.content)}e.parseUserDataProfilesManifest=p}),define(se[279],oe([0,1,6,17,65,2,23,16,15,14,18,24]),function(Z,e,R,_,c,T,L,D,C,w,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let g=class extends T.Disposable{constructor(d,p,h,u,f){super(),this.environmentService=d,this.fileService=p,this.configurationService=h,this.logService=u,this.userDataProfilesService=f,this.cleanUp()}async cleanUp(){for(const p of this.userDataProfilesService.profiles)for(const h of y.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(p,h))}catch(u){this.logService.error(u)}let d;try{d=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(p){(0,w.toFileOperationResult)(p)!==1&&this.logService.error(p);return}if(d.children){for(const p of d.children)if(p.isDirectory&&!this.userDataProfilesService.profiles.some(h=>h.id===p.name))try{this.logService.info("Deleting non existing profile from backup",p.resource.path),await this.fileService.del(p.resource,{recursive:!0})}catch(h){this.logService.error(h)}}}async getAllRefs(d,p){const h=this.getResourceBackupHome(d,p);try{const u=await this.fileService.resolve(h);if(u.children)return u.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort().reverse().map(v=>({ref:v.name,created:this.getCreationTime(v)}))}catch(u){if((0,w.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(d,p,h){const u=this.getResourceBackupHome(d,p),f=(0,L.joinPath)(u,h);try{return(await this.fileService.readFile(f)).value.toString()}catch(v){return this.logService.error(v),null}}async backup(d,p,h){const u=this.getResourceBackupHome(d,p),f=(0,L.joinPath)(u,`${(0,c.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,_.VSBuffer.fromString(h))}catch(v){this.logService.error(v)}try{this.cleanUpBackup(u)}catch{}}getResourceBackupHome(d,p){return(0,L.joinPath)(this.environmentService.userDataSyncHome,...d.isDefault?[p]:[d.id,p])}async cleanUpBackup(d){try{try{if(!await this.fileService.exists(d))return}catch{return}const p=await this.fileService.resolve(d);if(p.children){const h=p.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let f=h.filter(b=>Date.now()-this.getCreationTime(b)>u);const v=h.length-f.length;v<10&&(f=f.slice(10-v)),await R.Promises.settled(f.map(async b=>{this.logService.info("Deleting from backup",b.resource.path),await this.fileService.del(b.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};g=Se([K(0,C.IEnvironmentService),K(1,w.IFileService),K(2,D.IConfigurationService),K(3,y.IUserDataSyncLogService),K(4,P.IUserDataProfilesService)],g),e.UserDataSyncBackupStoreService=g}),define(se[280],oe([0,1,3,2,4,15,20,19,24]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const w="sync.enable";let P=class extends _.Disposable{constructor(g,S,d,p){super(),this.storageService=g,this.telemetryService=S,this.environmentService=d,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(g.onDidChangeValue(h=>this.onDidStorageChange(h)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(w,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(w,{enabled:g}),this.storageService.store(w,g,-1,1))}isResourceEnabled(g){return this.storageService.getBoolean((0,C.getEnablementKey)(g),-1,!0)}setResourceEnablement(g,S){if(this.isResourceEnabled(g)!==S){const d=(0,C.getEnablementKey)(g);this.storeResourceEnablement(d,S)}}getResourceSyncStateVersion(g){}storeResourceEnablement(g,S){this.storageService.store(g,S,-1,c.isWeb?0:1)}onDidStorageChange(g){if(g.scope!==-1)return;if(w===g.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const S=C.ALL_SYNC_RESOURCES.filter(d=>(0,C.getEnablementKey)(d)===g.key)[0];if(S){this._onDidChangeResourceEnablement.fire([S,this.isResourceEnabled(S)]);return}}};P=Se([K(0,L.IStorageService),K(1,D.ITelemetryService),K(2,T.IEnvironmentService),K(3,C.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(se[81],oe([0,1,3,2,4,27,187,15,14,5,26,45,20,24]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",p="Safari",h="Chrome",u="Edge",f="Firefox",v="Android";function b(s){switch(s){case p:case h:case u:case f:case v:case(0,c.PlatformToString)(0):return!0}return!1}e.isWebPlatform=b;function I(){return c.isSafari?p:c.isChrome?h:c.isEdge?u:c.isFirefox?f:c.isAndroid?v:(0,c.PlatformToString)(c.isWeb?0:c.platform)}let i=class rt extends _.Disposable{constructor(t,n,r,a,o,l){super(),this.storageService=r,this.userDataSyncStoreService=a,this.logService=o,this.productService=l,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,y.getServiceMachineId)(t,n,r)}async getMachines(t){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(a=>({...a,isCurrent:a.id===n}))}async addCurrentMachine(t){const n=await this.currentMachineIdPromise,r=await this.readMachinesData(t);r.machines.some(({id:a})=>a===n)||(r.machines.push({id:n,name:this.computeCurrentMachineName(r.machines),platform:I()}),await this.writeMachinesData(r))}async removeCurrentMachine(t){const n=await this.currentMachineIdPromise,r=await this.readMachinesData(t),a=r.machines.filter(({id:o})=>o!==n);a.length!==r.machines.length&&(r.machines=a,await this.writeMachinesData(r))}async renameMachine(t,n,r){const a=await this.readMachinesData(r),o=a.machines.find(({id:l})=>l===t);if(o){o.name=n,await this.writeMachinesData(a);const l=await this.currentMachineIdPromise;t===l&&this.storageService.store(d,n,-1,1)}}async setEnablements(t){const n=await this.readMachinesData();for(const[r,a]of t){const o=n.machines.find(l=>l.id===r);o&&(o.disabled=a?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(t){const n=this.storageService.get(d,-1);if(n)return n;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${I()} (${this.productService.nameShort})`,a=new RegExp(`${(0,T.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let o=0;for(const l of t){const m=a.exec(l.name),E=m?parseInt(m[1]):0;o=E>o?E:o}return`${r} #${o+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const n=this.parse(this.userData);if(n.version!==rt.VERSION)throw new Error((0,L.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(t){const n=JSON.stringify(t),r=await this.userDataSyncStoreService.writeResource(rt.RESOURCE,n,this.userData?.ref||null);this.userData={ref:r,content:n},this._onDidChange.fire()}async readUserData(t){if(this.userData){const n=t&&t.latest?t.latest[rt.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(rt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.logService.error(n)}return{version:rt.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=Se([K(0,D.IEnvironmentService),K(1,C.IFileService),K(2,g.IStorageService),K(3,S.IUserDataSyncStoreService),K(4,S.IUserDataSyncLogService),K(5,P.IProductService)],i),e.UserDataSyncMachinesService=i}),define(se[281],oe([0,1,6,65,38,9,3,2,4,23,11,184,26,20,19,24,78,81]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const f="sync.disableMachineEventually",v="sync.sessionId",b="sync.storeUrl",I="sync.productQuality";let i=class extends D.Disposable{get syncUrl(){const n=this.storageService.get(b,-1);return n?P.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(b,n.toString(),-1,1):this.storageService.remove(b,-1)}get productQuality(){return this.storageService.get(I,-1)}set productQuality(n){n?this.storageService.store(I,n,-1,1):this.storageService.remove(I,-1)}constructor(n,r,a,o,l,m,E,A,O,F){super(),this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=a,this.userDataSyncEnablementService=o,this.userDataSyncService=l,this.logService=m,this.userDataSyncAccountService=E,this.telemetryService=A,this.userDataSyncMachinesService=O,this.storageService=F,this.autoSync=this._register(new D.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(r.onDidChangeUserDataSyncStore(()=>{(0,w.isEqual)(this.syncUrl,r.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(E.onDidChangeAccount(()=>this.updateAutoSync())),this._register(a.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this._register(L.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:n,message:r}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(a=>this.onDidFinishSync(a))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(r&&this.logService.info(r),this.autoSync.clear()):r&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(r))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,_.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,r,a){try{this.userDataSyncAccountService.account&&!a&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(v,-1),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(o){if(this.logService.error(o),r)this.updateEnablement(!1);else throw o}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const r=p.UserDataSyncError.toUserDataSyncError(n);r instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:r.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?C.isWeb&&r.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(r),this.successiveFailures++),this._onError.fire(r)}async disableMachineEventually(){this.storageService.store(f,!0,-1,1),await(0,R.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(f,-1)}async triggerSync(n,r,a){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(r&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const o=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:o}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",a)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=Se([K(0,g.IProductService),K(1,p.IUserDataSyncStoreManagementService),K(2,p.IUserDataSyncStoreService),K(3,p.IUserDataSyncEnablementService),K(4,p.IUserDataSyncService),K(5,p.IUserDataSyncLogService),K(6,h.IUserDataSyncAccountService),K(7,d.ITelemetryService),K(8,u.IUserDataSyncMachinesService),K(9,S.IStorageService)],i),e.UserDataAutoSyncService=i;class s extends D.Disposable{constructor(n,r,a,o,l,m,E,A){super(),this.lastSyncUrl=n,this.interval=r,this.userDataSyncStoreManagementService=a,this.userDataSyncStoreService=o,this.userDataSyncService=l,this.userDataSyncMachinesService=m,this.logService=E,this.storageService=A,this.intervalHandler=this._register(new D.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,D.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(n,r){const a=(0,R.createCancelablePromise)(async o=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,T.isCancellationError)(l))return}return this.doSync(n,r,o)});return this.syncPromise=a,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,w.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),r=this.userDataSyncStoreManagementService.userDataSyncStore;return!!r&&!!n&&(!(0,w.isEqual)(r.defaultUrl,n.defaultUrl)||!(0,w.isEqual)(r.insidersUrl,n.insidersUrl)||!(0,w.isEqual)(r.stableUrl,n.stableUrl))}async doSync(n,r,a){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let o;try{await this.createAndRunSyncTask(r,a)}catch(l){if(this.logService.error(l),o=l,p.UserDataSyncError.toUserDataSyncError(l).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(r,a),o=void 0}catch(m){this.logService.error(m),o=m}}this._onDidFinishSync.fire(o)}async createAndRunSyncTask(n,r){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,n),r.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,y.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,y.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,y.localize)(2,null),"TurnedOff");const a=this.storageService.get(v,-1);if(a&&this.manifest&&a!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,y.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,y.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,y.localize)(5,null),"SessionExpired");const o=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(r.isCancellationRequested)return;const l=o.find(m=>m.isCurrent);if(l?.disabled)throw new p.UserDataAutoSyncError((0,y.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(m){throw new p.UserDataAutoSyncError((0,c.toErrorMessage)(m),m instanceof p.UserDataSyncError?m.code:"Unknown")}this.manifest&&this.manifest.session!==a&&this.storageService.store(v,this.manifest.session,-1,1),!r.isCancellationRequested&&(l||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(n){return super._register(n)}}s.INTERVAL_SYNCING="Interval"}),define(se[282],oe([0,1,11,188,15,14,45,20,29,24,18,41,124,123,122,16,125,120,121,5,126,43]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let i=class Ve{constructor(t,n,r,a,o,l,m,E,A,O){this.userDataSyncStoreService=t,this.userDataSyncBackupStoreService=n,this.logService=r,this.environmentService=o,this.storageService=l,this.fileService=m,this.userDataProfilesService=E,this.configurationService=A,this.instantiationService=O,this.extUri=a.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const n=this.parseSyncData(t.content,"profiles");return(0,b.parseUserDataProfilesManifest)(n)}return[]}async getRemoteSyncResourceHandles(t,n){return(await this.userDataSyncStoreService.getAllResourceRefs(t,n?.collection)).map(({created:a,ref:o})=>({created:a,uri:this.toUri({remote:!0,syncResource:t,profile:n?.id??this.userDataProfilesService.defaultProfile.id,collection:n?.collection,ref:o,node:void 0})}))}async getLocalSyncResourceHandles(t,n){return(await this.userDataSyncBackupStoreService.getAllRefs(n,t)).map(({created:a,ref:o})=>({created:a,uri:this.toUri({remote:!1,syncResource:t,profile:n.id,collection:void 0,ref:o,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const n=this.resolveUri(t),r=n?this.userDataProfilesService.profiles.find(a=>a.id===n.profile):void 0;return n&&r?{profile:r,syncResource:n?.syncResource}:void 0}async getAssociatedResources({uri:t}){const n=this.resolveUri(t);if(!n)return[];const r=this.userDataProfilesService.profiles.find(a=>a.id===n.profile);switch(n.syncResource){case"settings":return this.getSettingsAssociatedResources(t,r);case"keybindings":return this.getKeybindingsAssociatedResources(t,r);case"tasks":return this.getTasksAssociatedResources(t,r);case"snippets":return this.getSnippetsAssociatedResources(t,r);case"globalState":return this.getGlobalStateAssociatedResources(t,r);case"extensions":return this.getExtensionsAssociatedResources(t,r);case"profiles":return this.getProfilesAssociatedResources(t,r)}}async getMachineId({uri:t}){const n=this.resolveUri(t);if(!!n){if(n.remote){if(n.ref){const{content:r}=await this.getUserData(n.syncResource,n.ref,n.collection);if(r)return this.parseSyncData(r,n.syncResource)?.machineId}return}return(0,L.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const n=this.resolveUri(t);if(!n||n.node===Ve.NOT_EXISTING_RESOURCE)return null;if(n.ref){const r=await this.getContentFromStore(n.remote,n.syncResource,n.profile,n.collection,n.ref);return n.node&&r?this.resolveNodeContent(n.syncResource,r,n.node):r}return!n.remote&&!n.node?this.resolveLatestContent(n.syncResource,n.profile):null}async getContentFromStore(t,n,r,a,o){if(t){const{content:m}=await this.getUserData(n,o,a);return m}const l=this.userDataProfilesService.profiles.find(m=>m.id===r);return l?this.userDataSyncBackupStoreService.resolveContent(l,n,o):null}resolveNodeContent(t,n,r){const a=this.parseSyncData(n,t);switch(t){case"settings":return this.resolveSettingsNodeContent(a,r);case"keybindings":return this.resolveKeybindingsNodeContent(a,r);case"tasks":return this.resolveTasksNodeContent(a,r);case"snippets":return this.resolveSnippetsNodeContent(a,r);case"globalState":return this.resolveGlobalStateNodeContent(a,r);case"extensions":return this.resolveExtensionsNodeContent(a,r);case"profiles":return this.resolveProfileNodeContent(a,r)}}async resolveLatestContent(t,n){const r=this.userDataProfilesService.profiles.find(a=>a.id===n);if(!r)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(r);case"extensions":return this.resolveLatestExtensionsContent(r);case"profiles":return this.resolveLatestProfilesContent(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}getSettingsAssociatedResources(t,n){const r=this.extUri.joinPath(t,"settings.json"),a=n?n.settingsResource:this.extUri.joinPath(t,Ve.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveSettingsNodeContent(t,n){switch(n){case"settings.json":return(0,S.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,n){const r=this.extUri.joinPath(t,"keybindings.json"),a=n?n.keybindingsResource:this.extUri.joinPath(t,Ve.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveKeybindingsNodeContent(t,n){switch(n){case"keybindings.json":return(0,d.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(w.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,n){const r=this.extUri.joinPath(t,"tasks.json"),a=n?n.tasksResource:this.extUri.joinPath(t,Ve.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveTasksNodeContent(t,n){switch(n){case"tasks.json":return(0,h.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,n){const r=await this.resolveContent(t);if(r){const a=this.parseSyncData(r,"snippets");if(a){const o=(0,g.parseSnippets)(a),l=[];for(const m of Object.keys(o)){const E=this.extUri.joinPath(t,m),A=n?this.extUri.joinPath(n.snippetsHome,m):this.extUri.joinPath(t,Ve.NOT_EXISTING_RESOURCE);l.push({resource:E,comparableResource:A})}return l}}return[]}resolveSnippetsNodeContent(t,n){return(0,g.parseSnippets)(t)[n]||null}getExtensionsAssociatedResources(t,n){const r=this.extUri.joinPath(t,"extensions.json"),a=n?this.toUri({remote:!1,syncResource:"extensions",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,Ve.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveExtensionsNodeContent(t,n){switch(n){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:n}=await this.instantiationService.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(n,!0)}getGlobalStateAssociatedResources(t,n){const r=this.extUri.joinPath(t,"globalState.json"),a=n?this.toUri({remote:!1,syncResource:"globalState",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,Ve.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveGlobalStateNodeContent(t,n){switch(n){case"globalState.json":return(0,f.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const n=await this.instantiationService.createInstance(f.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,f.stringify)(n,!0)}getProfilesAssociatedResources(t,n){const r=this.extUri.joinPath(t,"profiles.json"),a=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:a}]}resolveProfileNodeContent(t,n){switch(n){case"profiles.json":return(0,I.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,b.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(n=>!n.isDefault&&!n.isTransient),!0)}toUri(t){const n=t.remote?Ve.REMOTE_BACKUP_AUTHORITY:Ve.LOCAL_BACKUP_AUTHORITY,r=[t.syncResource,t.profile];return t.collection&&r.push(`collection:${t.collection}`),t.ref&&r.push(`ref:${t.ref}`),t.node&&r.push(t.node),this.extUri.joinPath(R.URI.from({scheme:w.USER_DATA_SYNC_SCHEME,authority:n,path:"/"}),...r)}resolveUri(t){if(t.scheme!==w.USER_DATA_SYNC_SCHEME||t.authority!==Ve.LOCAL_BACKUP_AUTHORITY&&t.authority!==Ve.REMOTE_BACKUP_AUTHORITY)return;const n=[];for(;t.path!=="/";)n.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(n.length<2)return;const r=t.authority===Ve.REMOTE_BACKUP_AUTHORITY,a=n.shift(),o=n.shift();let l,m,E;for(;n.length;){const A=n.shift();A.startsWith("collection:")?l=A.substring(11):A.startsWith("ref:")?m=A.substring(4):E=A}return{remote:r,syncResource:a,profile:o,collection:l,ref:m,node:E}}parseSyncData(t,n){try{const r=JSON.parse(t);if((0,y.isSyncData)(r))return r}catch(r){this.logService.error(r)}throw new w.UserDataSyncError((0,_.localize)(0,null),"IncompatibleRemoteContent",n)}async getUserData(t,n,r){const a=await this.userDataSyncStoreService.resolveResourceContent(t,n,r);return{ref:n,content:a}}};i.NOT_EXISTING_RESOURCE="not-existing-resource",i.REMOTE_BACKUP_AUTHORITY="remote-backup",i.LOCAL_BACKUP_AUTHORITY="local-backup",i=Se([K(0,w.IUserDataSyncStoreService),K(1,w.IUserDataSyncBackupStoreService),K(2,w.IUserDataSyncLogService),K(3,C.IUriIdentityService),K(4,c.IEnvironmentService),K(5,D.IStorageService),K(6,T.IFileService),K(7,P.IUserDataProfilesService),K(8,p.IConfigurationService),K(9,v.IInstantiationService)],i),e.UserDataSyncResourceProviderService=i}),define(se[283],oe([0,1,21,6,25,38,3,2,23,12,31,16,30,5,20,19,18,120,121,122,123,124,125,126,24]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b,I,i,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let r=class extends D.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(E,A,O,F,M,k,N,z,j){super(),this.userDataSyncStoreService=E,this.userDataSyncStoreManagementService=A,this.instantiationService=O,this.logService=F,this.telemetryService=M,this.storageService=k,this.userDataSyncEnablementService=N,this.userDataProfilesService=z,this.userDataSyncResourceProviderService=j,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=A.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(n,-1,void 0),this._register((0,D.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(E,A){this.checkEnablement(),this.logService.info("Sync started.");const O=new Date().getTime(),F=(0,P.generateUuid)();try{const z=(0,t.createSyncHeaders)(F);A&&(z["Cache-Control"]="no-cache"),E=await this.userDataSyncStoreService.manifest(E,z)}catch(z){const j=t.UserDataSyncError.toUserDataSyncError(z);throw l(j,F,this.userDataSyncStoreManagementService,this.telemetryService),j}const M=!1,k=this;let N;return{manifest:E,async run(){if(M)throw new Error("Can run a task only once");N=(0,_.createCancelablePromise)(z=>k.sync(E,!1,F,z)),await N.finally(()=>N=void 0),k.logService.info(`Sync done. Took ${new Date().getTime()-O}ms`),k.updateLastSyncTime()},stop(){return N?.cancel(),k.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const E=new Date().getTime(),A=(0,P.generateUuid)(),O=(0,t.createSyncHeaders)(A);let F;try{F=await this.userDataSyncStoreService.manifest(null,O)}catch(N){const z=t.UserDataSyncError.toUserDataSyncError(N);throw l(z,A,this.userDataSyncStoreManagementService,this.telemetryService),z}await this.resetLocal();const M=this,k=new c.CancellationTokenSource;return{id:A,async merge(){return M.sync(F,!0,A,k.token)},async apply(){try{try{await M.applyManualSync(F,A,k.token)}catch(N){if(t.UserDataSyncError.toUserDataSyncError(N).code==="MethodNotFound")M.logService.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.logService.info("Applying manual sync again..."),await M.applyManualSync(F,A,k.token);else throw N}}catch(N){throw M.logService.error(N),N}M.logService.info(`Sync done. Took ${new Date().getTime()-E}ms`),M.updateLastSyncTime()},async stop(){k.cancel(),await M.stop(),await M.resetLocal()}}}async sync(E,A,O,F){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(M,E,A,O,F));const k=M.enabled.find(N=>N.resource==="profiles");if(k){const N=await k.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.syncRemoteProfiles(N,E,A,O,F)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(E,A,O,F,M){for(const k of E){if(M.isCancellationRequested)return;const N=this.userDataProfilesService.profiles.find(j=>j.id===k.id);if(!N){this.logService.error(`Profile with id:${k.id} and name: ${k.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",k.name);const z=this.getOrCreateActiveProfileSynchronizer(N,k);this._syncErrors.push(...await this.syncProfile(z,A,O,F,M))}for(const[k,N]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(z=>z.id===N[0].profile.id)||(N[1].dispose(),this.activeProfileSynchronizers.delete(k))}async applyManualSync(E,A,O){const F=this.getActiveProfileSynchronizers();for(const j of F){if(O.isCancellationRequested)return;await j.apply(A,O)}const M=F.find(j=>j.profile.isDefault);if(!M)return;const k=M.enabled.find(j=>j.resource==="profiles");if(!k)return;const z=(await k.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(j=>F.every(J=>J.profile.id!==j.id));z.length&&await this.syncRemoteProfiles(z,E,!1,A,O)}async syncProfile(E,A,O,F,M){return(await E.sync(A,O,F,M)).map(([N,z])=>({profile:E.profile,syncResource:N,error:z}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(E=>E.stop()))}async resolveContent(E){const A=await this.userDataSyncResourceProviderService.resolveContent(E);if(A)return A;for(const O of this.getActiveProfileSynchronizers())for(const F of O.enabled){const M=await F.resolveContent(E);if(M)return M}return null}async replace(E){this.checkEnablement();const A=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(E);if(!A)return;const O=await this.resolveContent(E.uri);!O||await this.performAction(A.profile,async F=>{if(A.syncResource===F.resource)return await F.replace(O),!0})}async accept(E,A,O,F){this.checkEnablement(),await this.performAction(E.profile,async M=>{if(E.syncResource===M.resource)return await M.accept(A,O),F&&await M.apply((0,w.isBoolean)(F)?!1:F.force,(0,t.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(E,A){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(E,A)}async getLocalSyncResourceHandles(E,A){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(E,A??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(E){return this.userDataSyncResourceProviderService.getAssociatedResources(E)}async getMachineId(E){return this.userDataSyncResourceProviderService.getMachineId(E)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async A=>{if(A.resource!=="globalState"&&await A.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async A=>{if(await A.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(E){this.logService.error(E)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(n,-1);for(const[E]of this.activeProfileSynchronizers.values())try{await E.resetLocal()}catch(A){this.logService.error(A)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),A=E.map(k=>k.collection),O=await this.userDataSyncStoreService.getAllCollections(),F=O.filter(k=>!A.includes(k));F.length&&(this.logService.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(k=>this.userDataSyncStoreService.deleteCollection(k))),this.logService.info("Deleted redundant collections on server"));const M=E.filter(k=>O.includes(k.collection));if(M.length!==E.length){this.logService.info("Updating remote profiles with invalid collections on server");const k=this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{await k.updateRemoteProfiles(M,null),this.logService.info("Updated remote profiles on server")}finally{k.dispose()}}}async performAction(E,A){const O=new D.DisposableStore;try{const F=this.activeProfileSynchronizers.get(E.id);if(F){const j=await this.performActionWithProfileSynchronizer(F[0],A,O);return(0,w.isUndefined)(j)?null:j}if(E.isDefault){const j=O.add(this.instantiationService.createInstance(a,E,void 0)),J=await this.performActionWithProfileSynchronizer(j,A,O);return(0,w.isUndefined)(J)?null:J}if(this.userDataProfilesService.isEnabled())return null;const M=O.add(this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,E,void 0)),k=await this.userDataSyncStoreService.manifest(null),z=(await M.getRemoteSyncedProfiles(k?.latest??null)||[]).find(j=>j.id===E.id);if(z){const j=O.add(this.instantiationService.createInstance(a,E,z.collection)),J=await this.performActionWithProfileSynchronizer(j,A,O);return(0,w.isUndefined)(J)?null:J}return null}finally{O.dispose()}}async performActionWithProfileSynchronizer(E,A,O){const F=[...E.enabled,...E.disabled.map(M=>O.add(E.createSynchronizer(M)))];for(const M of F){const k=await A(M);if(!(0,w.isUndefined)(k))return k}}setStatus(E){const A=this._status;this._status!==E&&(this._status=E,this._onDidChangeStatus.fire(E),A==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const E=this.getActiveProfileSynchronizers().map(A=>A.conflicts).flat();(0,R.equals)(this._conflicts,E,(A,O)=>A.profile.id===O.profile.id&&A.syncResource===O.syncResource&&(0,R.equals)(A.conflicts,O.conflicts,(F,M)=>(0,C.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=E,this._onDidChangeConflicts.fire(E))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(n,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(E,A){let O=this.activeProfileSynchronizers.get(E.id);if(O&&O[0].collection!==A?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.activeProfileSynchronizers.delete(E.id)),!O){const F=new D.DisposableStore,M=F.add(this.instantiationService.createInstance(a,E,A?.collection));F.add(M.onDidChangeStatus(k=>this.setStatus(k))),F.add(M.onDidChangeConflicts(k=>this.updateConflicts())),F.add(M.onDidChangeLocal(k=>this._onDidChangeLocal.fire(k))),this.activeProfileSynchronizers.set(E.id,O=[M,F])}return O[0]}getActiveProfileSynchronizers(){const E=[];for(const[A]of this.activeProfileSynchronizers.values())E.push(A);return E}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,E])=>E.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=Se([K(0,t.IUserDataSyncStoreService),K(1,t.IUserDataSyncStoreManagementService),K(2,S.IInstantiationService),K(3,t.IUserDataSyncLogService),K(4,p.ITelemetryService),K(5,d.IStorageService),K(6,t.IUserDataSyncEnablementService),K(7,h.IUserDataProfilesService),K(8,t.IUserDataSyncResourceProviderService)],r),e.UserDataSyncService=r;let a=class extends D.Disposable{get enabled(){return this._enabled.sort((E,A)=>E[1]-A[1]).map(([E])=>E)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(E=>!this.userDataSyncEnablementService.isResourceEnabled(E))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(E,A,O,F,M,k,N,z,j,J){super(),this.profile=E,this.collection=A,this.userDataSyncEnablementService=O,this.instantiationService=F,this.extensionGalleryService=M,this.userDataSyncStoreManagementService=k,this.telemetryService=N,this.logService=z,this.userDataProfilesService=j,this.configurationService=J,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(O.onDidChangeResourceEnablement(([ne,G])=>this.onDidChangeResourceEnablement(ne,G))),this._register((0,D.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,ne])=>ne.dispose())));for(const ne of t.ALL_SYNC_RESOURCES)O.isResourceEnabled(ne)&&this.registerSynchronizer(ne)}onDidChangeResourceEnablement(E,A){A?this.registerSynchronizer(E):this.deRegisterSynchronizer(E)}registerSynchronizer(E){if(this._enabled.some(([M])=>M.resource===E))return;if(E==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled()))return;const A=new D.DisposableStore,O=A.add(this.createSynchronizer(E));A.add(O.onDidChangeStatus(()=>this.updateStatus())),A.add(O.onDidChangeConflicts(()=>this.updateConflicts())),A.add(O.onDidChangeLocal(()=>this._onDidChangeLocal.fire(E)));const F=this.getOrder(E);this._enabled.push([O,F,A])}deRegisterSynchronizer(E){const A=this._enabled.findIndex(([O])=>O.resource===E);if(A!==-1){const[[O,,F]]=this._enabled.splice(A,1);F.dispose(),this.updateStatus(),Promise.allSettled([O.stop(),O.resetLocal()]).then(null,M=>this.logService.error(M))}}createSynchronizer(E){switch(E){case"settings":return this.instantiationService.createInstance(b.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(v.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(I.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(i.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(f.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(E,A,O,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const k=[],N=(0,t.createSyncHeaders)(O),z=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,j=A?await this.getUserDataSyncConfiguration(z):{};for(const J of M){if(F.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(J.resource))return[];try{if(A){const ne=await J.preview(z,j,N);if(ne)for(const G of ne.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await J.merge(G.previewResource)}else await J.sync(z,N)}catch(ne){const G=t.UserDataSyncError.toUserDataSyncError(ne);if(l(G,O,this.userDataSyncStoreManagementService,this.telemetryService),o(ne))throw G;this.logService.error(ne),this.logService.error(`${J.resource}: ${(0,T.toErrorMessage)(ne)}`),k.push([J.resource,G])}}return k}finally{this.updateStatus()}}async apply(E,A){const O=(0,t.createSyncHeaders)(E);for(const F of this.enabled){if(A.isCancellationRequested)return;try{await F.apply(!1,O)}catch(M){const k=t.UserDataSyncError.toUserDataSyncError(M);if(l(k,E,this.userDataSyncStoreManagementService,this.telemetryService),o(M))throw k;this.logService.error(M),this.logService.error(`${F.resource}: ${(0,T.toErrorMessage)(M)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(A){this.logService.error(A)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(A){this.logService.error(`${E.resource}: ${(0,T.toErrorMessage)(A)}`),this.logService.error(A)}}async getUserDataSyncConfiguration(E){if(!this.profile.isDefault)return{};const A=this.configurationService.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),O=this.enabled.find(F=>F instanceof b.SettingsSynchroniser);if(O){const F=await O.getRemoteUserDataSyncConfiguration(E);return{...A,...F}}return A}setStatus(E){this._status!==E&&(this._status=E,this._onDidChangeStatus.fire(E))}updateStatus(){return this.updateConflicts(),this.enabled.some(E=>E.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const E=this.enabled.filter(A=>A.status==="hasConflicts").filter(A=>A.conflicts.conflicts.length>0).map(A=>A.conflicts);(0,R.equals)(this._conflicts,E,(A,O)=>A.syncResource===O.syncResource&&(0,R.equals)(A.conflicts,O.conflicts,(F,M)=>(0,C.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=E,this._onDidChangeConflicts.fire(E))}getOrder(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};a=Se([K(2,t.IUserDataSyncEnablementService),K(3,S.IInstantiationService),K(4,g.IExtensionGalleryService),K(5,t.IUserDataSyncStoreManagementService),K(6,p.ITelemetryService),K(7,t.IUserDataSyncLogService),K(8,h.IUserDataProfilesService),K(9,y.IConfigurationService)],a);function o(m){if(m instanceof t.UserDataSyncError)switch(m.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function l(m,E,A,O){O.publicLog2("sync/error",{code:m.code,serverCode:m instanceof t.UserDataSyncStoreError?String(m.serverCode):void 0,url:m instanceof t.UserDataSyncStoreError?m.url:void 0,resource:m.resource,executionId:E,service:A.userDataSyncStore.url.toString()})}}),define(se[284],oe([0,1,3,2,11,18,24]),function(Z,e,R,_,c,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function D(g,S){return{...g,profile:(0,T.reviveProfile)(g.profile,S.profilesHome.scheme)}}function C(g){return{created:g.created,uri:c.URI.revive(g.uri)}}class w{constructor(S,d,p){this.service=S,this.userDataProfilesService=d,this.logService=p,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(S,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(S,d,p){try{return await this._call(S,d,p)}catch(h){throw this.logService.error(h),h}}async _call(S,d,p){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(c.URI.revive(p[0]));case"accept":return this.service.accept(D(p[0],this.userDataProfilesService),c.URI.revive(p[1]),p[2],p[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0],p[1]?(0,T.reviveProfile)(p[1],this.userDataProfilesService.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0],p[1]);case"replace":return this.service.replace(C(p[0]));case"getAssociatedResources":return this.service.getAssociatedResources(C(p[0]));case"getMachineId":return this.service.getMachineId(C(p[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring(11),u=p[0],f=this.getManualSyncTask(u);switch(p=p.slice(1),h){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.manualSyncTasks.delete(this.createKey(f.id)));case"stop":return f.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(f.id)))}}throw new Error("Invalid call")}getManualSyncTask(S){const d=this.manualSyncTasks.get(this.createKey(S));if(!d)throw new Error(`Manual sync taks not found: ${S}`);return d}async createManualSyncTask(){const S=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(S.id),S),S.id}createKey(S){return`manualSyncTask-${S}`}}e.UserDataSyncChannel=w;let P=class extends _.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(S,d){super(),this.userDataProfilesService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(p,h,u){return S.call(p,h,u).then(null,f=>{throw L.UserDataSyncError.toUserDataSyncError(f)})},listen(p,h){return S.listen(p,h)}},this.channel.call("_getInitialData").then(([p,h,u])=>{this.updateStatus(p),this.updateConflicts(h),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(f=>this.updateStatus(f))),this._register(this.channel.listen("onDidChangeLastSyncTime")(f=>this.updateLastSyncTime(f)))}),this._register(this.channel.listen("onDidChangeConflicts")(p=>this.updateConflicts(p))),this._register(this.channel.listen("onSyncErrors")(p=>this._onSyncErrors.fire(p.map(h=>({...h,error:L.UserDataSyncError.toUserDataSyncError(h.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const S=await this.channel.call("createManualSyncTask"),d=this;return new y(S,{async call(h,u,f){return d.channel.call(`manualSync/${h}`,[S,...Array.isArray(u)?u:[u]],f)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(S,d,p,h){return this.channel.call("accept",[S,d,p,h])}resolveContent(S){return this.channel.call("resolveContent",[S])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(S,d){return(await this.channel.call("getLocalSyncResourceHandles",[S,d])).map(({created:h,uri:u})=>({created:h,uri:c.URI.revive(u)}))}async getRemoteSyncResourceHandles(S,d){return(await this.channel.call("getRemoteSyncResourceHandles",[S,d])).map(({created:h,uri:u})=>({created:h,uri:c.URI.revive(u)}))}async getAssociatedResources(S){return(await this.channel.call("getAssociatedResources",[S])).map(({resource:p,comparableResource:h})=>({resource:c.URI.revive(p),comparableResource:c.URI.revive(h)}))}getMachineId(S){return this.channel.call("getMachineId",[S])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(S){return this.channel.call("replace",[S])}async updateStatus(S){this._status=S,this._onDidChangeStatus.fire(S)}async updateConflicts(S){this._conflicts=S.map(d=>({syncResource:d.syncResource,profile:(0,T.reviveProfile)(d.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:d.conflicts.map(p=>({...p,baseResource:c.URI.revive(p.baseResource),localResource:c.URI.revive(p.localResource),remoteResource:c.URI.revive(p.remoteResource),previewResource:c.URI.revive(p.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(S){this._lastSyncTime!==S&&(this._lastSyncTime=S,this._onDidChangeLastSyncTime.fire(S))}};P=Se([K(1,T.IUserDataProfilesService)],P),e.UserDataSyncChannelClient=P;class y extends _.Disposable{constructor(S,d){super(),this.id=S,this.channel=d}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(se[285],oe([0,1,6,25,9,3,2,144,4,23,12,11,31,16,15,14,26,60,45,20,24]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const I="sync.previous.store",i="sync.donot-make-requests-until",s="sync.user-session-id",t="sync.machine-session-id",n=100,r=1e3*60*5;let a=class extends L.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(b.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(O){this.storageService.store(b.SYNC_SERVICE_URL_TYPE,O,-1,C.isWeb?0:1)}constructor(O,F,M){super(),this.productService=O,this.configurationService=F,this.storageService=M,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(M.onDidChangeValue,k=>k.key===b.SYNC_SERVICE_URL_TYPE&&k.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[b.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(b.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,F){O=C.isWeb&&O?.web?{...O,...O.web}:O;const M={...O||{},...F||{}};if(M&&(0,P.isString)(M.url)&&(0,P.isObject)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(k=>Array.isArray(M.authenticationProviders[k].scopes))){const k=M,N=!!k.canSwitch&&!F?.url,z=k.url===k.insidersUrl?"insiders":"stable",j=(N?this.userDataSyncStoreType:void 0)||z,J=F?.url||(j==="insiders"?k.insidersUrl:j==="stable"?k.stableUrl:k.url);return{url:y.URI.parse(J),type:j,defaultType:z,defaultUrl:y.URI.parse(k.url),stableUrl:y.URI.parse(k.stableUrl),insidersUrl:y.URI.parse(k.insidersUrl),canSwitch:N,authenticationProviders:Object.keys(k.authenticationProviders).reduce((ne,G)=>(ne.push({id:G,scopes:k.authenticationProviders[G].scopes}),ne),[])}}}};a=Se([K(0,h.IProductService),K(1,S.IConfigurationService),K(2,v.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let o=class extends a{constructor(O,F,M){super(O,F,M);const k=this.storageService.get(I,-1);k&&(this.previousConfigurationSyncStore=JSON.parse(k));const N=this.productService[b.CONFIGURATION_SYNC_STORE_KEY];N?this.storageService.store(I,JSON.stringify(N),-1,1):this.storageService.remove(I,-1)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};o=Se([K(0,h.IProductService),K(1,S.IConfigurationService),K(2,v.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let l=class extends L.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(O,F,M,k,N,z,j){super(),this.requestService=M,this.logService=k,this.storageService=j,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,f.getServiceMachineId)(N,z,j).then(J=>{const ne={"X-Client-Name":`${F.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ne["X-Client-Commit"]=F.commit),ne}),this.session=new E(n,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,L.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(O,F){this.authToken={token:O,type:F}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,w.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(i,-1);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(F=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(i,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]="application/json";const M=await this.request(F,{type:"GET",headers:O},[],_.CancellationToken.None);return(await(0,u.asJson)(M))?.map(({id:k})=>k)||[]}async createCollection(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]=D.Mimes.text;const M=await this.request(F,{type:"POST",headers:O},[],_.CancellationToken.None),k=await(0,u.asTextOrError)(M);if(!k)throw new b.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[b.HEADER_OPERATION_ID]);return k}async deleteCollection(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=O?(0,w.joinPath)(this.userDataSyncStoreUrl,"collection",O).toString():(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},await this.request(M,{type:"DELETE",headers:F},[],_.CancellationToken.None)}async getAllResourceRefs(O,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=this.getResourceUrl(this.userDataSyncStoreUrl,F,O),k={},N=await this.request(M.toString(),{type:"GET",headers:k},[],_.CancellationToken.None);return(await(0,u.asJson)(N)||[]).map(({url:j,created:J})=>({ref:(0,w.relativePath)(M,M.with({path:j})),created:J*1e3}))}async resolveResourceContent(O,F,M,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,O),F).toString();k={...k},k["Cache-Control"]="no-cache";const z=await this.request(N,{type:"GET",headers:k},[],_.CancellationToken.None);return await(0,u.asTextOrError)(z)}async deleteResource(O,F,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=F!==null?(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,O),F).toString():this.getResourceUrl(this.userDataSyncStoreUrl,M,O).toString(),N={};await this.request(k,{type:"DELETE",headers:N},[],_.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":D.Mimes.text};await this.request(O,{type:"DELETE",headers:F},[],_.CancellationToken.None)}async readResource(O,F,M,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,O),"latest").toString();k={...k},k["Cache-Control"]="no-cache",F&&(k["If-None-Match"]=F.ref);const z=await this.request(N,{type:"GET",headers:k},[304],_.CancellationToken.None);let j=null;if(z.res.statusCode===304&&(j=F),j===null){const J=z.res.headers.etag;if(!J)throw new b.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",z.res.statusCode,z.res.headers[b.HEADER_OPERATION_ID]);const ne=await(0,u.asTextOrError)(z);if(!ne&&z.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",N,"EmptyResponse",z.res.statusCode,z.res.headers[b.HEADER_OPERATION_ID]);j={ref:J,content:ne}}return j}async writeResource(O,F,M,k,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=this.getResourceUrl(this.userDataSyncStoreUrl,k,O).toString();N={...N},N["Content-Type"]=D.Mimes.text,M&&(N["If-Match"]=M);const j=await this.request(z,{type:"POST",data:F,headers:N},[],_.CancellationToken.None),J=j.res.headers.etag;if(!J)throw new b.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",j.res.statusCode,j.res.headers[b.HEADER_OPERATION_ID]);return J}async manifest(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,w.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",O&&(F["If-None-Match"]=O.ref);const k=await this.request(M,{type:"GET",headers:F},[304],_.CancellationToken.None);let N=null;if(k.res.statusCode===304&&(N=O),!N){const j=k.res.headers.etag;if(!j)throw new b.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",k.res.statusCode,k.res.headers[b.HEADER_OPERATION_ID]);const J=await(0,u.asTextOrError)(k);if(!J&&k.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",M,"EmptyResponse",k.res.statusCode,k.res.headers[b.HEADER_OPERATION_ID]);J&&(N={...JSON.parse(J),ref:j})}const z=this.storageService.get(s,-1);return z&&N&&z!==N.session&&this.clearSession(),N===null&&z&&this.clearSession(),N&&this.storageService.store(s,N.session,-1,1),N}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}getResourceUrl(O,F,M){return F?(0,w.joinPath)(O,"collection",F,"resource",M):(0,w.joinPath)(O,"resource",M)}clearSession(){this.storageService.remove(s,-1),this.storageService.remove(t,-1)}async request(O,F,M,k){if(!this.authToken)throw new b.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new b.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const N=await this.commonHeadersPromise;F.headers={...F.headers||{},...N,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:O,type:F.type,headers:{...F.headers,authorization:void 0}});let z;try{z=await this.session.request(O,F,k)}catch(q){if(!(q instanceof b.UserDataSyncStoreError)){let x="RequestFailed";const Y=(0,c.getErrorMessage)(q).toLowerCase();Y.includes("xhr timeout")?x="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?x="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?x="RequestPathNotEscaped":Y.includes("headers must be an object")?x="RequestHeadersNotObject":(0,c.isCancellationError)(q)&&(x="RequestCanceled"),q=new b.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,x,void 0,void 0)}throw this.logService.info("Request failed",O),q}const j=z.res.headers[b.HEADER_OPERATION_ID],J={url:O,status:z.res.statusCode,"execution-id":F.headers[b.HEADER_EXECUTION_ID],"operation-id":j},ne=(0,u.isSuccess)(z)||z.res.statusCode&&M.indexOf(z.res.statusCode)!==-1;let G="";if(ne?this.logService.trace("Request succeeded",J):(this.logService.info("Request failed",J),G=await(0,u.asText)(z)||""),z.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new b.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",z.res.statusCode,j);if(this._onTokenSucceed.fire(),z.res.statusCode===404)throw new b.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not found (404).`,O,"NotFound",z.res.statusCode,j);if(z.res.statusCode===405)throw new b.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested endpoint is not found (405). ${G}`,O,"MethodNotFound",z.res.statusCode,j);if(z.res.statusCode===409)throw new b.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",z.res.statusCode,j);if(z.res.statusCode===410)throw new b.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",z.res.statusCode,j);if(z.res.statusCode===412)throw new b.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",z.res.statusCode,j);if(z.res.statusCode===413)throw new b.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",z.res.statusCode,j);if(z.res.statusCode===426)throw new b.UserDataSyncStoreError(`${F.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",z.res.statusCode,j);if(z.res.statusCode===429){const q=z.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new b.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",z.res.statusCode,j)):new b.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",z.res.statusCode,j)}if(!ne)throw new b.UserDataSyncStoreError("Server returned "+z.res.statusCode,O,"Unknown",z.res.statusCode,j);return z}addSessionHeaders(O){let F=this.storageService.get(t,-1);F===void 0&&(F=(0,g.generateUuid)(),this.storageService.store(t,F,-1,1)),O["X-Machine-Session-Id"]=F;const M=this.storageService.get(s,-1);M!==void 0&&(O["X-User-Session-Id"]=M)}};l=Se([K(1,h.IProductService),K(2,u.IRequestService),K(3,b.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,p.IFileService),K(6,v.IStorageService)],l),e.UserDataSyncStoreClient=l;let m=class extends l{constructor(O,F,M,k,N,z,j){super(O.userDataSyncStore?.url,F,M,k,N,z,j),this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};m=Se([K(0,b.IUserDataSyncStoreManagementService),K(1,h.IProductService),K(2,u.IRequestService),K(3,b.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,p.IFileService),K(6,v.IStorageService)],m),e.UserDataSyncStoreService=m;class E{constructor(O,F,M,k){this.limit=O,this.interval=F,this.requestService=M,this.logService=k,this.requests=[],this.startTime=void 0}request(O,F,M){if(this.isExpired()&&this.reset(),F.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new b.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(F,M)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=E}),define(se[286],oe([0,1,3,58,26,20,19,281,24,78,81]),function(Z,e,R,_,c,T,L,D,C,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let y=class extends D.UserDataAutoSyncService{constructor(S,d,p,h,u,f,v,b,I,i,s){super(S,d,p,h,u,v,b,I,i,s),this._register(R.Event.debounce(R.Event.any(R.Event.map(f.onDidFocusWindow,()=>"windowFocus"),R.Event.map(f.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};y=Se([K(0,c.IProductService),K(1,C.IUserDataSyncStoreManagementService),K(2,C.IUserDataSyncStoreService),K(3,C.IUserDataSyncEnablementService),K(4,C.IUserDataSyncService),K(5,_.INativeHostService),K(6,C.IUserDataSyncLogService),K(7,w.IUserDataSyncAccountService),K(8,L.ITelemetryService),K(9,P.IUserDataSyncMachinesService),K(10,T.IStorageService)],y),e.UserDataAutoSyncService=y}),define(se[287],oe([0,1,101,22,4,23]),function(Z,e,R,_,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(w){function P(){let y=w.scheme===_.Schemas.file?(0,T.originalFSPath)(w):w.toString();return c.isLinux||(y=y.toLowerCase()),(0,R.createHash)("md5").update(y).digest("hex")}return{id:P(),configPath:w}}e.getWorkspaceIdentifier=L;function D(w,P){function y(){if(w.scheme!==_.Schemas.file)return(0,R.createHash)("md5").update(w.toString()).digest("hex");if(!P)return;let S;return c.isLinux?S=P.ino:c.isMacintosh?S=P.birthtime.getTime():c.isWindows&&(typeof P.birthtimeMs=="number"?S=Math.floor(P.birthtimeMs):S=P.birthtime.getTime()),(0,R.createHash)("md5").update(w.fsPath).update(S?String(S):"").digest("hex")}const g=y();if(typeof g=="string")return{id:g,uri:w}}e.getSingleFolderWorkspaceIdentifier=D;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=C}),define(se[288],oe([0,1,6,9,2,13,28,15,57,8,58,76,118,287]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let d=class extends c.Disposable{constructor(h,u,f,v){super(),this.environmentService=h,this.logService=u,this.nativeHostService=f,this.mainProcessService=v,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=await L.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),u=new y.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(h.map(async f=>{const v=(0,T.join)(this.environmentService.workspaceStorageHome.fsPath,f);f.length===S.NON_EMPTY_WORKSPACE_ID_LENGTH||f===g.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(i=>i.workspace?.id===f)||await u.isUsed(v)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${f} as it seems to be an unused empty workspace.`),await L.Promises.rm(v))}))}catch(h){(0,_.onUnexpectedError)(h)}}};d=Se([K(0,D.INativeEnvironmentService),K(1,w.ILogService),K(2,P.INativeHostService),K(3,C.IMainProcessService)],d),e.UnusedWorkspaceStorageDataCleaner=d}),define(se[127],oe([0,1,53,6,13,12,28,155,297,298]),function(Z,e,R,_,c,T,L,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(i,s){let t=s.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=s}}e.ExtractError=P;function y(I){const i=I.externalFileAttributes>>16||33188;return[448,56,7].map(s=>i&s).reduce((s,t)=>s+t,i&61440)}function g(I){if(I instanceof P)return I;let i;return/end of central directory record signature not found/.test(I.message)&&(i="CorruptZip"),new P(i,I)}function S(I,i,s,t,n,r){const a=c.dirname(i),o=c.join(t,a);if(!o.startsWith(t))return Promise.reject(new Error(D.localize(0,null,i)));const l=c.join(t,i);let m;return r.onCancellationRequested(()=>{m?.destroy()}),Promise.resolve(L.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((E,A)=>{if(!r.isCancellationRequested)try{m=(0,R.createWriteStream)(l,{mode:s}),m.once("close",()=>E()),m.once("error",A),I.once("error",A),I.pipe(m)}catch(O){A(O)}}))}function d(I,i,s,t){let n=(0,_.createCancelablePromise)(()=>Promise.resolve()),r=0;return t.onCancellationRequested(()=>{n.cancel(),I.close()}),new Promise((a,o)=>{const l=new _.Sequencer,m=E=>{E.isCancellationRequested||(r++,I.readEntry())};I.once("error",o),I.once("close",()=>n.then(()=>{t.isCancellationRequested||I.entryCount===r?a():o(new P("Incomplete",new Error(D.localize(1,null,r,I.entryCount))))},o)),I.readEntry(),I.on("entry",E=>{if(t.isCancellationRequested)return;if(!s.sourcePathRegex.test(E.fileName)){m(t);return}const A=E.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(A)){const M=c.join(i,A);n=(0,_.createCancelablePromise)(k=>L.Promises.mkdir(M,{recursive:!0}).then(()=>m(k)).then(void 0,o));return}const O=h(I,E),F=y(E);n=(0,_.createCancelablePromise)(M=>l.queue(()=>O.then(k=>S(k,A,F,i,s,M).then(()=>m(M)))).then(null,o))})})}function p(I,i=!1){return new Promise((s,t)=>{(0,C.open)(I,i?{lazyEntries:!0}:void 0,(n,r)=>{n?t(g(n)):s((0,T.assertIsDefined)(r))})})}function h(I,i){return new Promise((s,t)=>{I.openReadStream(i,(n,r)=>{n?t(g(n)):s((0,T.assertIsDefined)(r))})})}function u(I,i){return new Promise((s,t)=>{const n=new w.ZipFile;i.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const r=(0,R.createWriteStream)(I);n.outputStream.pipe(r),n.outputStream.once("error",t),r.once("error",t),r.once("finish",()=>s(I))})}e.zip=u;function f(I,i,s={},t){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=p(I,!0);return s.overwrite&&(r=r.then(a=>L.Promises.rm(i).then(()=>a))),r.then(a=>d(a,i,{sourcePathRegex:n},t))}e.extract=f;function v(I,i){return p(I).then(s=>new Promise((t,n)=>{s.on("entry",r=>{r.fileName===i&&h(s,r).then(a=>t(a),a=>n(a))}),s.once("close",()=>n(new Error(D.localize(2,null,i))))}))}function b(I,i){return v(I,i).then(s=>new Promise((t,n)=>{const r=[];s.once("error",n),s.on("data",a=>r.push(a)),s.on("end",()=>t(Buffer.concat(r)))}))}e.buffer=b}),define(se[289],oe([0,1,127,165]),function(Z,e,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function c(T){return(0,R.buffer)(T,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,_.localize)(0,null))}})}e.getManifest=c}),define(se[128],oe([0,1,6,25,38,9,3,2,37,22,13,4,23,54,12,11,31,28,127,164,98,15,270,30,33,51,79,240,272,289,224,241,42,70,14,5,8,26,19,29,18]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b,I,i,s,t,n,r,a,o,l,m,E,A,O,F,M,k,N,z,j,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(s.IExtensionManagementService);let ne=class extends i.AbstractExtensionManagementService{constructor(V,$,U,W,B,Q,H,X,te,le,he,me){super(V,$,U,le,me),this.extensionsScannerService=B,this.extensionsProfileScannerService=Q,this.downloadService=H,this.fileService=te,this.uriIdentityService=he,this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new C.ResourceSet;const pe=this._register(X.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(G,be=>pe.postUninstall(be))),this.manifestCache=this._register(new m.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(X.createInstance(a.ExtensionsDownloader));const Ee=this._register(new E.ExtensionsWatcher(this,this.extensionsScannerService,me,Q,he,te,U));this._register(Ee.onDidChangeExtensionsByAnotherSource(be=>this.onDidChangeExtensionsFromAnotherSource(be))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,t.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(V){this.logService.trace("ExtensionManagementService#zip",V.identifier.id);const $=await this.collectFiles(V),U=await(0,f.zip)((0,g.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,$);return p.URI.file(U)}async unzip(V){return this.logService.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:$,cleanup:U}=await this.downloadVsix(V),W=P.resolve($.fsPath);try{return await(0,l.getManifest)(W)}finally{await U()}}getInstalled(V,$){return this.extensionsScanner.scanExtensions(V??null,$)}getAllUserInstalled(){return this.extensionsScanner.scanAllUserExtensions(!1)}async install(V,$={}){this.logService.trace("ExtensionManagementService#install",V.toString());const{location:U,cleanup:W}=await this.downloadVsix(V);try{const B=await(0,l.getManifest)(P.resolve(U.fsPath));if(B.engines&&B.engines.vscode&&!(0,O.isEngineValid)(B.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,(0,t.getGalleryExtensionId)(B.publisher,B.name),this.productService.version));return await this.installExtension(B,U,$)}finally{await W()}}async installFromLocation(V,$){this.logService.trace("ExtensionManagementService#installFromLocation",V.toString());const U=await this.extensionsScanner.scanUserExtensionAtLocation(V);if(!U)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.addExtensionsToProfile([U],$),this.logService.info("Successfully installed extension",U.identifier.id,$.toString()),U}getMetadata(V,$=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanMetadata(V,$)}async updateMetadata(V,$,U=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",V.identifier.id),$.isPreReleaseVersion&&($.preRelease=!0),$.isMachineScoped=$.isMachineScoped||void 0,$.isBuiltin=$.isBuiltin||void 0,$.pinned=$.pinned||void 0,V=await this.extensionsScanner.updateMetadata(V,$,U),this.manifestCache.invalidate(),this._onDidUpdateExtensionMetadata.fire(V),V}async reinstallFromGallery(V){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(1,null));const $=await this.getTargetPlatform(),[U]=await this.galleryService.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:$,compatible:!0},_.CancellationToken.None);if(!U)throw new Error(v.localize(2,null));await this.extensionsScanner.setUninstalled(V);try{await this.extensionsScanner.removeUninstalledExtension(V)}catch(W){throw new Error(v.localize(3,null,(0,c.toErrorMessage)(W)))}return this.installFromGallery(U)}markAsUninstalled(...V){return this.extensionsScanner.setUninstalled(...V)}removeUninstalledExtensions(){return this.extensionsScanner.cleanUp()}async download(V,$){const{location:U}=await this.extensionsDownloader.download(V,$);return U}async downloadVsix(V){if(V.scheme===w.Schemas.file)return{location:V,async cleanup(){}};this.logService.trace("Downloading extension from",V.toString());const $=(0,g.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)());return await this.downloadService.download(V,$),this.logService.info("Downloaded extension to",$.toString()),{location:$,cleanup:async()=>{try{await this.fileService.del($)}catch(W){this.logService.error(W)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(V,$,U){let W;if(p.URI.isUri($))W=new Y(V,$,U,this.galleryService,this.extensionsScanner,this.logService);else{const B=t.ExtensionKey.create($).toString();W=this.installGalleryExtensionsTasks.get(B),W||(this.installGalleryExtensionsTasks.set(B,W=new x(V,$,U,this.extensionsDownloader,this.extensionsScanner,this.logService)),W.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(B)))}return new ee(W,U.profileLocation,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService)}createUninstallExtensionTask(V,$){return new re(V,$.profileLocation,this.extensionsProfileScannerService)}async collectFiles(V){const $=async W=>{let B=await u.Promises.readdir(W);B=B.map(X=>P.join(W,X));const Q=await Promise.all(B.map(X=>u.Promises.stat(X)));let H=Promise.resolve([]);return Q.forEach((X,te)=>{const le=B[te];X.isFile()&&(H=H.then(he=>[...he,le])),X.isDirectory()&&(H=H.then(he=>$(le).then(me=>[...he,...me])))}),H};return(await $(V.location.fsPath)).map(W=>({path:`extension/${P.relative(V.location.fsPath,W)}`,localPath:W}))}async onDidChangeExtensionsFromAnotherSource({added:V,removed:$}){if($)for(const U of $.extensions)this.logService.info("Extensions removed from another source",U.id,$.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:U,profileLocation:$.profileLocation});if(V){const W=(await this.extensionsScanner.scanExtensions(1,V.profileLocation)).filter(B=>V.extensions.some(Q=>(0,t.areSameExtensions)(Q,B.identifier)));this._onDidInstallExtensions.fire(W.map(B=>(this.logService.info("Extensions added from another source",B.identifier.id,V.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:V.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract($=>this.knownDirectories.add($)));const V=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const $ of V.children??[])$.isDirectory&&this.knownDirectories.add($.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange($=>this.onDidFilesChange($)))}async onDidFilesChange(V){if(!V.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const $=[];for(const U of V.rawAdded){if(this.knownDirectories.has(U)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(U),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(U,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(U).startsWith(".")||!(await this.fileService.stat(U)).isDirectory)continue;const W=await this.extensionsScanner.scanUserExtensionAtLocation(U);W&&W.installedTimestamp===void 0&&(this.knownDirectories.add(U),$.push(W))}$.length&&(await this.addExtensionsToProfile($,this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",$.map(U=>U.identifier.id)))}async addExtensionsToProfile(V,$){await this.extensionsProfileScannerService.addExtensionsToProfile(V.map(U=>[U,void 0]),$),this._onDidInstallExtensions.fire(V.map(U=>({local:U,identifier:U.identifier,operation:1,profileLocation:$})))}};ne=Se([K(0,s.IExtensionGalleryService),K(1,z.ITelemetryService),K(2,k.ILogService),K(3,I.INativeEnvironmentService),K(4,r.IExtensionsScannerService),K(5,n.IExtensionsProfileScannerService),K(6,b.IDownloadService),K(7,M.IInstantiationService),K(8,F.IFileService),K(9,N.IProductService),K(10,j.IUriIdentityService),K(11,J.IUserDataProfilesService)],ne),e.ExtensionManagementService=ne;let G=class extends D.Disposable{constructor(V,$,U,W,B){super(),this.beforeRemovingExtension=V,this.fileService=$,this.extensionsScannerService=U,this.extensionsProfileScannerService=W,this.logService=B,this._onExtract=this._register(new L.Emitter),this.onExtract=this._onExtract.event,this.uninstalledPath=(0,g.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions()}async scanExtensions(V,$){const U={includeInvalid:!0,profileLocation:$};let W=[];return V===null||V===0?W.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},U,!1)):V===1&&W.push(...await this.extensionsScannerService.scanUserExtensions(U)),W=V!==null?W.filter(B=>B.type===V):W,Promise.all(W.map(B=>this.toLocalExtension(B)))}async scanAllUserExtensions(V){const $=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all($.map(U=>this.toLocalExtension(U)))}async scanUserExtensionAtLocation(V){try{const $=await this.extensionsScannerService.scanExistingExtension(V,1,{includeInvalid:!0});if($)return await this.toLocalExtension($)}catch($){this.logService.error($)}return null}async extractUserExtension(V,$,U,W){const B=V.toString(),Q=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`),H=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,B);try{await u.Promises.rm(H)}catch{throw new s.ExtensionManagementError(v.localize(4,null,H,V.id),s.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(V,$,Q,W),await this.extensionsScannerService.updateMetadata(p.URI.file(Q),U);try{this._onExtract.fire(p.URI.file(H)),await this.rename(V,Q,H,Date.now()+2*60*1e3),this.logService.info("Renamed to",H)}catch(X){try{await u.Promises.rm(Q)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(X)}. Deleted from extracted location`,Q),X}return this.scanLocalExtension(p.URI.file(H),1)}async scanMetadata(V,$){return $?(await this.extensionsProfileScannerService.scanProfileExtensions($)).find(W=>(0,t.areSameExtensions)(W.identifier,V.identifier))?.metadata:this.extensionsScannerService.scanMetadata(V.location)}async updateMetadata(V,$,U){return U?await this.extensionsProfileScannerService.updateMetadata([[V,$]],U):await this.extensionsScannerService.updateMetadata(V.location,$),this.scanLocalExtension(V.location,V.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...V){const $=V.map(U=>t.ExtensionKey.create(U));await this.withUninstalledExtensions(U=>$.forEach(W=>{U[W.toString()]=!0,this.logService.info("Marked extension as uninstalled",W.toString())}))}async setInstalled(V){await this.withUninstalledExtensions(W=>delete W[V.toString()]);const U=(await this.scanAllUserExtensions(!0)).find(W=>t.ExtensionKey.create(W).equals(V))||null;return U?this.updateMetadata(U,{installedTimestamp:Date.now()}):null}async removeExtension(V,$){this.logService.trace(`Deleting ${$} extension from disk`,V.identifier.id,V.location.fsPath),await u.Promises.rm(V.location.fsPath),this.logService.info("Deleted from disk",V.identifier.id,V.location.fsPath)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.withUninstalledExtensions($=>delete $[t.ExtensionKey.create(V).toString()])}async withUninstalledExtensions(V){return this.uninstalledFileLimiter.queue(async()=>{let $;try{$=await u.Promises.readFile(this.uninstalledPath,"utf8")}catch(W){if(W.code!=="ENOENT")throw W}let U={};if($)try{U=JSON.parse($)}catch{}return V&&(V(U),Object.keys(U).length?await u.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await u.Promises.rm(this.uninstalledPath)),U})}async extractAtLocation(V,$,U,W){this.logService.trace(`Started extracting the extension from ${$} to ${U}`);try{await u.Promises.rm(U)}catch(B){throw new s.ExtensionManagementError(this.joinErrors(B).message,s.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)($,U,{sourcePath:"extension",overwrite:!0},W),this.logService.info(`Extracted extension to ${U}:`,V.id)}catch(B){try{await u.Promises.rm(U)}catch{}let Q=s.ExtensionManagementErrorCode.Extract;throw B instanceof f.ExtractError&&(B.type==="CorruptZip"?Q=s.ExtensionManagementErrorCode.CorruptZip:B.type==="Incomplete"&&(Q=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(B.message,Q)}}async rename(V,$,U,W){try{await u.Promises.rename($,U)}catch(B){if(y.isWindows&&B&&B.code==="EPERM"&&Date.now()<W)return this.logService.info(`Failed renaming ${$} to ${U} with 'EPERM' error. Trying again...`,V.id),this.rename(V,$,U,W);throw new s.ExtensionManagementError(B.message||v.localize(5,null,$,U),B.code||s.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(V,$){const U=await this.extensionsScannerService.scanExistingExtension(V,$,{includeInvalid:!0});if(U)return this.toLocalExtension(U);throw new Error(v.localize(6,null,V.path))}async toLocalExtension(V){const $=await this.fileService.resolve(V.location);let U,W;return $.children&&(U=$.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,W=$.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:U,changelogUrl:W,publisherDisplayName:V.metadata?.publisherDisplayName||null,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned}}async removeUninstalledExtensions(){const V=await this.getUninstalledExtensions(),$=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const Q of $)V[t.ExtensionKey.create(Q).toString()]||U.add(Q.identifier.id.toLowerCase());const W=(0,t.groupByExtension)($,Q=>Q.identifier);await R.Promises.settled(W.map(async Q=>{const H=Q.sort((X,te)=>S.rcompare(X.manifest.version,te.manifest.version))[0];U.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}));const B=$.filter(Q=>Q.metadata&&V[t.ExtensionKey.create(Q).toString()]);await R.Promises.settled(B.map(Q=>this.removeUninstalledExtension(Q)))}joinErrors(V){const $=Array.isArray(V)?V:[V];return $.length===1?$[0]instanceof Error?$[0]:new Error($[0]):$.reduce((U,W)=>new Error(`${U.message}${U.message?",":""}${W instanceof Error?W.message:W}`),new Error(""))}};G=Se([K(1,F.IFileService),K(2,r.IExtensionsScannerService),K(3,n.IExtensionsProfileScannerService),K(4,k.ILogService)],G),e.ExtensionsScanner=G;class q extends i.AbstractExtensionTask{get verificationStatus(){return this._verificationStatus}get operation(){return(0,d.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(V,$,U,W,B){super(),this.identifier=V,this.source=$,this.options=U,this.extensionsScanner=W,this.logService=B,this._verificationStatus="Unverified",this._operation=2}async installExtension(V,$){try{const U=await this.unsetUninstalledAndGetLocal(V.key);if(U)return this.extensionsScanner.updateMetadata(U,V.metadata)}catch{throw y.isMacintosh?new s.ExtensionManagementError(v.localize(7,null),s.ExtensionManagementErrorCode.Internal):new s.ExtensionManagementError(v.localize(8,null),s.ExtensionManagementErrorCode.Internal)}return this.extract(V,$)}async unsetUninstalledAndGetLocal(V){if(!await this.isUninstalled(V))return null;this.logService.trace("Removing the extension from uninstalled list:",V.id);const U=await this.extensionsScanner.setInstalled(V);return this.logService.info("Removed the extension from uninstalled list:",V.id),U}async isUninstalled(V){return!!(await this.extensionsScanner.getUninstalledExtensions())[V.toString()]}async extract({zipPath:V,key:$,metadata:U},W){const B=await this.extensionsScanner.extractUserExtension($,V,U,W);return this.logService.info("Extracting completed.",$.id),B}}class x extends q{constructor(V,$,U,W,B,Q){super($.identifier,$,U,B,Q),this.manifest=V,this.gallery=$,this.extensionsDownloader=W}async doRun(V){const U=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(H=>(0,t.areSameExtensions)(H.identifier,this.gallery.identifier));U&&(this._operation=3);const W={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,A.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||U?.isMachineScoped,isBuiltin:this.options.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,d.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(U,W),metadata:W};const{location:B,verificationStatus:Q}=await this.extensionsDownloader.download(this.gallery,this._operation);try{return this._verificationStatus=Q,this.validateManifest(B.fsPath),{local:await this.installExtension({zipPath:B.fsPath,key:t.ExtensionKey.create(this.gallery),metadata:W},V),metadata:W}}catch(H){try{await this.extensionsDownloader.delete(B)}catch(X){this.logService.warn("Error while deleting the downloaded file",B.toString(),(0,T.getErrorMessage)(X))}throw H}}async validateManifest(V){try{await(0,l.getManifest)(V)}catch($){throw new s.ExtensionManagementError((0,i.joinErrors)($).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=x;class Y extends q{constructor(V,$,U,W,B,Q){super({id:(0,t.getGalleryExtensionId)(V.publisher,V.name)},$,U,B,Q),this.manifest=V,this.location=$,this.galleryService=W}async doRun(V){const $=new t.ExtensionKey(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(H=>(0,t.areSameExtensions)(this.identifier,H.identifier)),B=await this.getMetadata(this.identifier.id,this.manifest.version,V);if(B.isApplicationScoped=(0,A.isApplicationScopedExtension)(this.manifest),B.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,B.isBuiltin=this.options.isBuiltin||W?.isBuiltin,B.installedTimestamp=Date.now(),B.pinned=this.options.installGivenVersion?!0:void 0,W)if(this._operation=3,$.equals(new t.ExtensionKey(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(v.localize(9,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&S.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const H=await this.unsetUninstalledAndGetLocal($);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(v.localize(10,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:$,metadata:B},V),metadata:B}}async getMetadata(V,$,U){try{let[W]=await this.galleryService.getExtensions([{id:V,version:$}],U);if(W||([W]=await this.galleryService.getExtensions([{id:V}],U)),W)return{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId,isPreReleaseVersion:W.properties.isPreReleaseVersion,preRelease:W.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class ee{get operation(){return this.task.operation}get verificationStatus(){return this.task.verificationStatus}constructor(V,$,U,W,B,Q){this.task=V,this.profileLocation=$,this.uriIdentityService=U,this.userDataProfilesService=W,this.extensionsScannerService=B,this.extensionsProfileScannerService=Q,this.identifier=this.task.identifier,this.source=this.task.source,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const V=await this.task.waitUntilTaskIsFinished();return this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[V.local,V.metadata]],this.profileLocation),V}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class re extends i.AbstractExtensionTask{constructor(V,$,U){super(),this.extension=V,this.profileLocation=$,this.extensionsProfileScannerService=U}async doRun(V){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(se[290],oe([0,1,2,30,80,239,128,8,20]),function(Z,e,R,_,c,T,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let w=class extends R.Disposable{constructor(y,g,S,d,p,h){super(),y.removeUninstalledExtensions(),(0,T.migrateUnsupportedExtensions)(y,g,S,d,h),c.ExtensionStorageService.removeOutdatedExtensionVersions(y,p)}};w=Se([K(0,L.INativeServerExtensionManagementService),K(1,_.IExtensionGalleryService),K(2,c.IExtensionStorageService),K(3,_.IGlobalExtensionEnablementService),K(4,C.IStorageService),K(5,D.ILogService)],w),e.ExtensionsContributions=w}),define(se[299],oe([0,1,94,34,38,9,2,22,23,11,39,153,216,217,209,210,288,198,201,16,222,97,237,98,229,15,234,119,274,30,99,200,275,128,100,196,14,212,213,55,5,207,72,208,57,73,243,8,105,58,106,26,60,20,276,111,19,112,113,114,47,246,116,252,255,80,117,24,78,279,266,267,81,280,283,284,285,286,278,62,268,110,236,77,257,226,256,109,233,29,258,4,259,202,220,219,79,273,18,51,215,59,277,231,245,269,238,108,104,282,290,271,7,214]),function(Z,e,R,_,c,T,L,D,C,w,P,y,g,S,d,p,h,u,f,v,b,I,i,s,t,n,r,a,o,l,m,E,A,O,F,M,k,N,z,j,J,ne,G,q,x,Y,ee,re,ae,V,$,U,W,B,Q,H,X,te,le,he,me,pe,Ee,be,Re,ke,We,$e,ce,fe,ge,Ce,Ie,_e,Le,Fe,Oe,Ne,ze,Te,Ue,ie,ue,de,ve,ye,Pe,De,Be,xe,Ae,qe,He,et,st,pt,Lt,Tt,yt,_t,At,wt,Ot,Ut,Mt,Nt,Ft,Et,bt,xt,$t,Wt,Ct,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class qt extends L.Disposable{constructor(we){super(),this.configuration=we,this.server=this._register(new y.Server),this.sharedProcessWorkerService=void 0,this.lifecycleService=void 0,this.registerListeners()}registerListeners(){const we=async()=>{this.lifecycleService&&(await this.lifecycleService.fireOnWillShutdown(),this.lifecycleService.dispose(),this.lifecycleService=void 0),this.dispose()};process.once("exit",we),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",we);const Me="vscode:electron-main->shared-process=disposeWorker",Ge=(Je,it)=>{this.onDisposeWorker(it)};R.ipcRenderer.on(Me,Ge),this._register((0,L.toDisposable)(()=>R.ipcRenderer.removeListener(Me,Ge)))}onDisposeWorker(we){this.sharedProcessWorkerService?.disposeWorker(we)}async open(){const we=await this.initServices();(0,$e.registerConfiguration)(),we.invokeFunction(Me=>{const Ge=Me.get(re.ILogService);Ge.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(Ge)}),this._register((0,L.combinedDisposable)(we.createInstance(g.CodeCacheCleaner,this.configuration.codeCachePath),we.createInstance(S.LanguagePackCachedDataCleaner),we.createInstance(h.UnusedWorkspaceStorageDataCleaner),we.createInstance(p.LogsDataCleaner),we.createInstance(d.LocalizationsUpdater),we.createInstance($t.ExtensionsContributions),we.createInstance(Nt.UserDataProfilesCleaner)))}async initServices(){const we=new G.ServiceCollection,Me={_serviceBrand:void 0,...$.default};we.set(U.IProductService,Me);const Ge=new P.StaticRouter(Ye=>Ye==="main"),Je=new q.MessagePortMainProcessService(this.server,Ge);we.set(x.IMainProcessService,Je);const it=this.configuration.policiesData?new At.PolicyChannelClient(this.configuration.policiesData,Je.getChannel("policy")):new wt.NullPolicyService;we.set(wt.IPolicyService,it);const Ke=new r.SharedProcessEnvironmentService(this.configuration.args,Me);we.set(n.INativeEnvironmentService,Ke);const tt=new ae.LoggerChannelClient(void 0,this.configuration.logLevel,this.configuration.loggers.map(Ye=>({...Ye,resource:w.URI.revive(Ye.resource)})),Je.getChannel("logger"));we.set(re.ILoggerService,tt);const ct=this._register(tt.createLogger((0,C.joinPath)(w.URI.file(Ke.logsPath),"sharedprocess.log"),{id:"sharedLog",name:(0,Ct.localize)(0,null)})),ht=this._register(new re.ConsoleLogger(ct.getLevel())),je=this._register(new zt.LogService(ct,[ht]));we.set(re.ILogService,je),this.lifecycleService=new bt.SharedProcessLifecycleService(je),we.set(bt.ISharedProcessLifecycleService,this.lifecycleService),this.sharedProcessWorkerService=new Be.SharedProcessWorkerService(je),we.set(De.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ze=this._register(new N.FileService(je));we.set(k.IFileService,Ze);const dt=this._register(new z.DiskFileSystemProvider(je));Ze.registerProvider(D.Schemas.file,dt);const ft=this._register(new He.FileUserDataProvider(D.Schemas.file,this._register(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),D.Schemas.vscodeUserData,je));Ze.registerProvider(D.Schemas.vscodeUserData,ft);const nt=this._register(new Ot.UserDataProfilesNativeService(this.configuration.profiles,Je,Ke));we.set(yt.IUserDataProfilesService,nt);const Xe=this._register(new b.ConfigurationService(nt.defaultProfile.settingsResource,Ze,it,je));we.set(v.IConfigurationService,Xe);const ot=new Q.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);we.set(B.IStorageService,ot),this._register((0,L.toDisposable)(()=>ot.flush())),await Promise.all([Xe.initialize(),ot.initialize()]);const gt=new Ae.UriIdentityService(Ze);we.set(xe.IUriIdentityService,gt),we.set(W.IRequestService,new Ut.SharedProcessRequestService(Je,Xe,Me,je)),we.set(u.IChecksumService,new j.SyncDescriptor(f.ChecksumService,void 0,!1)),we.set(pt.IV8InspectProfilingService,new j.SyncDescriptor(st.InspectProfilingService,void 0,!1));const lt=P.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.configuration.windowId});we.set(V.INativeHostService,lt),we.set(s.IDownloadService,new j.SyncDescriptor(t.DownloadService,void 0,!0));const mt=this._register(new Ue.ActiveWindowManager(lt)),Vt=new P.StaticRouter(Ye=>mt.getActiveClientId().then(vt=>Ye===vt));we.set(F.IExtensionRecommendationNotificationService,new M.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Vt)));let ut;const at=[],It=(0,me.isInternalTelemetry)(Me,Xe);if((0,me.supportsTelemetry)(Me,Ke)){const Ye=new le.TelemetryLogAppender(je,tt,Ke,Me);at.push(Ye);const{installSourcePath:vt}=Ke;if(Me.aiConfig?.ariaKey){const Rt=new Mt.OneDataSystemAppender(It,"monacoworkbench",null,Me.aiConfig.ariaKey);this._register((0,L.toDisposable)(()=>Rt.flush())),at.push(Rt)}ut=new he.TelemetryService({appenders:at,commonProperties:(0,H.resolveCommonProperties)(Ze,(0,_.release)(),(0,_.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,It,vt),sendErrorTelemetry:!0,piiPaths:(0,me.getPiiPathsFromEnvironment)(Ke)},Xe,Me)}else{ut=me.NullTelemetryService;const Ye=me.NullAppender;at.push(Ye)}this.server.registerChannel("telemetryAppender",new te.TelemetryAppenderChannel(at)),we.set(X.ITelemetryService,ut);const Bt=new pe.CustomEndpointTelemetryService(Xe,ut,je,tt,Ke,Me);we.set(X.ICustomEndpointTelemetryService,Bt),we.set(_t.IExtensionsProfileScannerService,new j.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),we.set(Lt.IExtensionsScannerService,new j.SyncDescriptor(Tt.ExtensionsScannerService,void 0,!0)),we.set(m.IExtensionSignatureVerificationService,new j.SyncDescriptor(m.ExtensionSignatureVerificationService,void 0,!0)),we.set(O.INativeServerExtensionManagementService,new j.SyncDescriptor(O.ExtensionManagementService,void 0,!0)),we.set(l.IExtensionGalleryService,new j.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),we.set(l.IExtensionTipsService,new j.SyncDescriptor(A.ExtensionTipsService,void 0,!1)),we.set(Y.ILanguagePackService,new j.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1)),we.set(I.IDiagnosticsService,new j.SyncDescriptor(i.DiagnosticsService,void 0,!1)),we.set(ce.IUserDataSyncAccountService,new j.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),we.set($e.IUserDataSyncLogService,new j.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),we.set($e.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),we.set(l.IGlobalExtensionEnablementService,new j.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),we.set(We.IIgnoredExtensionsManagementService,new j.SyncDescriptor(We.IgnoredExtensionsManagementService,void 0,!0)),we.set(ke.IExtensionStorageService,new j.SyncDescriptor(ke.ExtensionStorageService)),we.set($e.IUserDataSyncStoreManagementService,new j.SyncDescriptor(Oe.UserDataSyncStoreManagementService,void 0,!0)),we.set($e.IUserDataSyncStoreService,new j.SyncDescriptor(Oe.UserDataSyncStoreService,void 0,!0)),we.set(Ie.IUserDataSyncMachinesService,new j.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),we.set($e.IUserDataSyncBackupStoreService,new j.SyncDescriptor(fe.UserDataSyncBackupStoreService,void 0,!1)),we.set($e.IUserDataSyncEnablementService,new j.SyncDescriptor(_e.UserDataSyncEnablementService,void 0,!0)),we.set($e.IUserDataSyncService,new j.SyncDescriptor(Le.UserDataSyncService,void 0,!1)),we.set(Te.IUserDataProfileStorageService,new j.SyncDescriptor(ze.UserDataProfileStorageService,void 0,!0)),we.set($e.IUserDataSyncResourceProviderService,new j.SyncDescriptor(xt.UserDataSyncResourceProviderService,void 0,!0));const Dt=new Re.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,Ct.localize)(1,null),Xe,Ke,je,tt);return Dt.initialize(),we.set(be.ILocalPtyService,this._register(Dt)),we.set(ie.ISignService,new j.SyncDescriptor(ue.SignService,void 0,!1)),we.set(de.ISharedTunnelsService,new j.SyncDescriptor(ve.SharedTunnelsService)),we.set(ye.ISharedProcessTunnelService,new j.SyncDescriptor(Pe.SharedProcessTunnelService)),we.set(Et.IRemoteTunnelService,new j.SyncDescriptor(Ft.RemoteTunnelService)),new ne.InstantiationService(we)}initChannels(we){const Me=new E.ExtensionManagementChannel(we.get(l.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const Ge=P.ProxyChannel.fromService(we.get(Y.ILanguagePackService));this.server.registerChannel("languagePacks",Ge);const Je=P.ProxyChannel.fromService(we.get(I.IDiagnosticsService));this.server.registerChannel("diagnostics",Je);const it=new E.ExtensionTipsChannel(we.get(l.IExtensionTipsService));this.server.registerChannel("extensionTipsService",it);const Ke=P.ProxyChannel.fromService(we.get(u.IChecksumService));this.server.registerChannel("checksum",Ke);const tt=P.ProxyChannel.fromService(we.get(pt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",tt);const ct=new ge.UserDataSyncMachinesServiceChannel(we.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ct);const ht=P.ProxyChannel.fromService(we.get(X.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ht);const je=new ge.UserDataSyncAccountServiceChannel(we.get(ce.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",je);const Ze=new ge.UserDataSyncStoreManagementServiceChannel(we.get($e.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ze);const dt=new Fe.UserDataSyncChannel(we.get($e.IUserDataSyncService),we.get(yt.IUserDataProfilesService),we.get(re.ILogService));this.server.registerChannel("userDataSync",dt);const ft=this._register(we.get(J.IInstantiationService).createInstance(Ne.UserDataAutoSyncService)),nt=new ge.UserDataAutoSyncChannel(ft);this.server.registerChannel("userDataAutoSync",nt);const Xe=we.get(be.ILocalPtyService),ot=P.ProxyChannel.fromService(Xe);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,ot);const gt=P.ProxyChannel.fromService(we.get(ye.ISharedProcessTunnelService));this.server.registerChannel(ye.ipcSharedProcessTunnelChannelName,gt);const lt=P.ProxyChannel.fromService(we.get(De.ISharedProcessWorkerService));this.server.registerChannel(De.ipcSharedProcessWorkerChannelName,lt);const mt=P.ProxyChannel.fromService(we.get(Et.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",mt)}registerErrorHandler(we){window.addEventListener("unhandledrejection",Me=>{(0,T.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Me=>{const Ge=(0,c.toErrorMessage)(Me,!0);!Ge||we.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}}async function jt(Pt){const we=new qt(Pt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await we.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=jt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c6a9727b801542499d2b59cb7db4224e060fc578/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
