/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/map","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/dialogs/common/dialogs","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/utilityProcess/electron-main/utilityProcess","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(j){for(var e=[],E=0,D=j.length;E<D;E++)e[E]=ee[j[E]];return e};define(ee[124],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,g){const h=Math.pow(10,g);return Math.round(P*h)/h}class D{constructor(g,h,y,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=E(Math.max(Math.min(1,w),0),3)}static equals(g,h){return g.r===h.r&&g.g===h.g&&g.b===h.b&&g.a===h.a}}e.RGBA=D;class n{constructor(g,h,y,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,h),0),3),this.l=E(Math.max(Math.min(1,y),0),3),this.a=E(Math.max(Math.min(1,w),0),3)}static equals(g,h){return g.h===h.h&&g.s===h.s&&g.l===h.l&&g.a===h.a}static fromRGBA(g){const h=g.r/255,y=g.g/255,w=g.b/255,S=g.a,f=Math.max(h,y,w),p=Math.min(h,y,w);let v=0,o=0;const d=(p+f)/2,m=f-p;if(m>0){switch(o=Math.min(d<=.5?m/(2*d):m/(2-2*d),1),f){case h:v=(y-w)/m+(y<w?6:0);break;case y:v=(w-h)/m+2;break;case w:v=(h-y)/m+4;break}v*=60,v=Math.round(v)}return new n(v,o,d,S)}static _hue2rgb(g,h,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?g+(h-g)*6*y:y<1/2?h:y<2/3?g+(h-g)*(2/3-y)*6:g}static toRGBA(g){const h=g.h/360,{s:y,l:w,a:S}=g;let f,p,v;if(y===0)f=p=v=w;else{const o=w<.5?w*(1+y):w+y-w*y,d=2*w-o;f=n._hue2rgb(d,o,h+1/3),p=n._hue2rgb(d,o,h),v=n._hue2rgb(d,o,h-1/3)}return new D(Math.round(f*255),Math.round(p*255),Math.round(v*255),S)}}e.HSLA=n;class M{constructor(g,h,y,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,h),0),3),this.v=E(Math.max(Math.min(1,y),0),3),this.a=E(Math.max(Math.min(1,w),0),3)}static equals(g,h){return g.h===h.h&&g.s===h.s&&g.v===h.v&&g.a===h.a}static fromRGBA(g){const h=g.r/255,y=g.g/255,w=g.b/255,S=Math.max(h,y,w),f=Math.min(h,y,w),p=S-f,v=S===0?0:p/S;let o;return p===0?o=0:S===h?o=((y-w)/p%6+6)%6:S===y?o=(w-h)/p+2:o=(h-y)/p+4,new M(Math.round(o*60),v,S,g.a)}static toRGBA(g){const{h,s:y,v:w,a:S}=g,f=w*y,p=f*(1-Math.abs(h/60%2-1)),v=w-f;let[o,d,m]=[0,0,0];return h<60?(o=f,d=p):h<120?(o=p,d=f):h<180?(d=f,m=p):h<240?(d=p,m=f):h<300?(o=p,m=f):h<=360&&(o=f,m=p),o=Math.round((o+v)*255),d=Math.round((d+v)*255),m=Math.round((m+v)*255),new D(o,d,m,S)}}e.HSVA=M;class k{static fromHex(g){return k.Format.CSS.parseHex(g)||k.red}static equals(g,h){return!g&&!h?!0:!g||!h?!1:g.equals(h)}get hsla(){return this._hsla?this._hsla:n.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:M.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof D)this.rgba=g;else if(g instanceof n)this._hsla=g,this.rgba=n.toRGBA(g);else if(g instanceof M)this._hsva=g,this.rgba=M.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&D.equals(this.rgba,g.rgba)&&n.equals(this.hsla,g.hsla)&&M.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=k._relativeLuminanceForComponent(this.rgba.r),h=k._relativeLuminanceForComponent(this.rgba.g),y=k._relativeLuminanceForComponent(this.rgba.b),w=.2126*g+.7152*h+.0722*y;return E(w,4)}static _relativeLuminanceForComponent(g){const h=g/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(g){const h=this.getRelativeLuminance(),y=g.getRelativeLuminance();return h>y?(h+.05)/(y+.05):(y+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const h=this.getRelativeLuminance(),y=g.getRelativeLuminance();return h>y}isDarkerThan(g){const h=this.getRelativeLuminance(),y=g.getRelativeLuminance();return h<y}lighten(g){return new k(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new k(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:h,g:y,b:w,a:S}=this.rgba;return new k(new D(h,y,w,S*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new k(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const h=g.rgba,y=this.rgba.a,w=h.a,S=y+w*(1-y);if(S<1e-6)return k.transparent;const f=this.rgba.r*y/S+h.r*w*(1-y)/S,p=this.rgba.g*y/S+h.g*w*(1-y)/S,v=this.rgba.b*y/S+h.b*w*(1-y)/S;return new k(new D(f,p,v,S))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:h,g:y,b:w,a:S}=this.rgba;return new k(new D(g.rgba.r-S*(g.rgba.r-h),g.rgba.g-S*(g.rgba.g-y),g.rgba.b-S*(g.rgba.b-w),1))}flatten(...g){const h=g.reduceRight((y,w)=>k._flatten(w,y));return k._flatten(this,h)}static _flatten(g,h){const y=1-g.rgba.a;return new k(new D(y*h.rgba.r+g.rgba.a*g.rgba.r,y*h.rgba.g+g.rgba.a*g.rgba.g,y*h.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this._toString||(this._toString=k.Format.CSS.format(this)),this._toString}static getLighterColor(g,h,y){if(g.isLighterThan(h))return g;y=y||.5;const w=g.getRelativeLuminance(),S=h.getRelativeLuminance();return y=y*(S-w)/S,g.lighten(y)}static getDarkerColor(g,h,y){if(g.isDarkerThan(h))return g;y=y||.5;const w=g.getRelativeLuminance(),S=h.getRelativeLuminance();return y=y*(w-S)/w,g.darken(y)}}k.white=new k(new D(255,255,255,1)),k.black=new k(new D(0,0,0,1)),k.red=new k(new D(255,0,0,1)),k.blue=new k(new D(0,0,255,1)),k.green=new k(new D(0,255,0,1)),k.cyan=new k(new D(0,255,255,1)),k.lightgrey=new k(new D(211,211,211,1)),k.transparent=new k(new D(0,0,0,0)),e.Color=k,function(P){let g;(function(h){let y;(function(w){function S(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}w.formatRGB=S;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}w.formatRGBA=f;function p(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}w.formatHSL=p;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}w.formatHSLA=v;function o(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function d(t){return`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}`}w.formatHex=d;function m(t,a=!1){return a&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}${o(Math.round(t.rgba.a*255))}`}w.formatHexA=m;function C(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}w.format=C;function I(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const i=16*R(t.charCodeAt(1))+R(t.charCodeAt(2)),s=16*R(t.charCodeAt(3))+R(t.charCodeAt(4)),l=16*R(t.charCodeAt(5))+R(t.charCodeAt(6));return new P(new D(i,s,l,1))}if(a===9){const i=16*R(t.charCodeAt(1))+R(t.charCodeAt(2)),s=16*R(t.charCodeAt(3))+R(t.charCodeAt(4)),l=16*R(t.charCodeAt(5))+R(t.charCodeAt(6)),u=16*R(t.charCodeAt(7))+R(t.charCodeAt(8));return new P(new D(i,s,l,u/255))}if(a===4){const i=R(t.charCodeAt(1)),s=R(t.charCodeAt(2)),l=R(t.charCodeAt(3));return new P(new D(16*i+i,16*s+s,16*l+l))}if(a===5){const i=R(t.charCodeAt(1)),s=R(t.charCodeAt(2)),l=R(t.charCodeAt(3)),u=R(t.charCodeAt(4));return new P(new D(16*i+i,16*s+s,16*l+l,(16*u+u)/255))}return null}w.parseHex=I;function R(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=h.CSS||(h.CSS={}))})(g=P.Format||(P.Format={}))}(k=e.Color||(e.Color={})),e.Color=k}),define(ee[55],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(k){return(P,g,h)=>{let y=null,w=null;if(typeof h.value=="function"?(y="value",w=h.value):typeof h.get=="function"&&(y="get",w=h.get),!w)throw new Error("not supported");h[y]=k(w,g)}}function D(k,P,g){let h=null,y=null;if(typeof g.value=="function"?(h="value",y=g.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(h="get",y=g.get),!y)throw new Error("not supported");const w=`$memoize$${P}`;g[h]=function(...S){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,S)}),this[w]}}e.memoize=D;function n(k,P,g){return E((h,y)=>{const w=`$debounce$${y}`,S=`$debounce$result$${y}`;return function(...f){this[S]||(this[S]=g?g():void 0),clearTimeout(this[w]),P&&(this[S]=P(this[S],...f),f=[this[S]]),this[w]=setTimeout(()=>{h.apply(this,f),this[S]=g?g():void 0},k)}})}e.debounce=n;function M(k,P,g){return E((h,y)=>{const w=`$throttle$timer$${y}`,S=`$throttle$result$${y}`,f=`$throttle$lastRun$${y}`,p=`$throttle$pending$${y}`;return function(...v){if(this[S]||(this[S]=g?g():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[S]=P(this[S],...v)),this[p])return;const o=this[f]+k;o<=Date.now()?(this[f]=Date.now(),h.apply(this,[this[S]]),this[S]=g?g():void 0):(this[p]=!0,this[w]=setTimeout(()=>{this[p]=!1,this[f]=Date.now(),h.apply(this,[this[S]]),this[S]=g?g():void 0},o-Date.now()))}})}e.throttle=M}),define(ee[13],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?I.isErrorNoTelemetry(a)?new I(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(i=>{i(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=E,e.errorHandler=new E;function D(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=D;function n(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function M(t){h(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=M;function k(t){h(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=k;function P(t){if(t instanceof Error){const{name:a,message:i}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:s,noTelemetry:I.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const g="Canceled";function h(t){return t instanceof y?!0:t instanceof Error&&t.name===g&&t.message===g}e.isCancellationError=h;class y extends Error{constructor(){super(g),this.name=this.message}}e.CancellationError=y;function w(){const t=new Error(g);return t.name=t.message,t}e.canceled=w;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function f(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=f;function p(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function v(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=v;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=o;class d extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=d;class m extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=m;class C extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=C;class I extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof I)return a;const i=new I;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=I;class R extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,R.prototype);debugger}}e.BugIndicatingError=R}),define(ee[25],te([0,1,13]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function D(U,$=0){return U[U.length-(1+$)]}e.tail=D;function n(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=n;function M(U,$,H=(oe,fe)=>oe===fe){if(U===$)return!0;if(!U||!$||U.length!==$.length)return!1;for(let oe=0,fe=U.length;oe<fe;oe++)if(!H(U[oe],$[oe]))return!1;return!0}e.equals=M;function k(U,$){const H=U.length-1;$<H&&(U[$]=U[H]),U.pop()}e.removeFastWithoutKeepingOrder=k;function P(U,$,H){return g(U.length,oe=>H(U[oe],$))}e.binarySearch=P;function g(U,$){let H=0,oe=U-1;for(;H<=oe;){const fe=(H+oe)/2|0,pe=$(fe);if(pe<0)H=fe+1;else if(pe>0)oe=fe-1;else return fe}return-(H+1)}e.binarySearch2=g;function h(U,$){let H=0,oe=U.length;if(oe===0)return 0;for(;H<oe;){const fe=Math.floor((H+oe)/2);$(U[fe])?oe=fe:H=fe+1}return H}e.findFirstInSorted=h;function y(U,$,H){if(U=U|0,U>=$.length)throw new TypeError("invalid index");const oe=$[Math.floor($.length*Math.random())],fe=[],pe=[],ye=[];for(const Le of $){const _e=H(Le,oe);_e<0?fe.push(Le):_e>0?pe.push(Le):ye.push(Le)}return U<fe.length?y(U,fe,H):U<fe.length+ye.length?ye[0]:y(U-(fe.length+ye.length),pe,H)}e.quickSelect=y;function w(U,$){const H=[];let oe;for(const fe of U.slice(0).sort($))!oe||$(oe[0],fe)!==0?(oe=[fe],H.push(oe)):oe.push(fe);return H}e.groupBy=w;function S(U,$,H){const oe=[];function fe(Le,_e,Oe){if(_e===0&&Oe.length===0)return;const ve=oe[oe.length-1];ve&&ve.start+ve.deleteCount===Le?(ve.deleteCount+=_e,ve.toInsert.push(...Oe)):oe.push({start:Le,deleteCount:_e,toInsert:Oe})}let pe=0,ye=0;for(;;){if(pe===U.length){fe(pe,0,$.slice(ye));break}if(ye===$.length){fe(pe,U.length-pe,[]);break}const Le=U[pe],_e=$[ye],Oe=H(Le,_e);Oe===0?(pe+=1,ye+=1):Oe<0?(fe(pe,1,[]),pe+=1):Oe>0&&(fe(pe,0,[_e]),ye+=1)}return oe}e.sortedDiff=S;function f(U,$,H){const oe=S(U,$,H),fe=[],pe=[];for(const ye of oe)fe.push(...U.slice(ye.start,ye.start+ye.deleteCount)),pe.push(...ye.toInsert);return{removed:fe,added:pe}}e.delta=f;function p(U,$,H){if(H===0)return[];const oe=U.slice(0,H).sort($);return o(U,$,oe,H,U.length),oe}e.top=p;function v(U,$,H,oe,fe){return H===0?Promise.resolve([]):new Promise((pe,ye)=>{(async()=>{const Le=U.length,_e=U.slice(0,H).sort($);for(let Oe=H,ve=Math.min(H+oe,Le);Oe<Le;Oe=ve,ve=Math.min(ve+oe,Le)){if(Oe>H&&await new Promise(Me=>setTimeout(Me)),fe&&fe.isCancellationRequested)throw new E.CancellationError;o(U,$,_e,Oe,ve)}return _e})().then(pe,ye)})}e.topAsync=v;function o(U,$,H,oe,fe){for(const pe=H.length;oe<fe;oe++){const ye=U[oe];if($(ye,H[pe-1])<0){H.pop();const Le=h(H,_e=>$(ye,_e)<0);H.splice(Le,0,ye)}}}function d(U){return U.filter($=>!!$)}e.coalesce=d;function m(U){let $=0;for(let H=0;H<U.length;H++)U[H]&&(U[$]=U[H],$+=1);U.length=$}e.coalesceInPlace=m;function C(U,$,H){U.splice(H,0,U.splice($,1)[0])}e.move=C;function I(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=I;function R(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=R;function t(U,$=H=>H){const H=new Set;return U.filter(oe=>{const fe=$(oe);return H.has(fe)?!1:(H.add(fe),!0)})}e.distinct=t;function a(U){const $=new Set;return H=>{const oe=U(H);return $.has(oe)?!1:($.add(oe),!0)}}e.uniqueFilter=a;function i(U,$){const H=s(U,$);if(H!==-1)return U[H]}e.findLast=i;function s(U,$){for(let H=U.length-1;H>=0;H--){const oe=U[H];if($(oe))return H}return-1}e.lastIndex=s;function l(U,$){return U.length>0?U[0]:$}e.firstOrDefault=l;function u(U,$){return U.length>0?U[U.length-1]:$}e.lastOrDefault=u;function r(U,$,H=(oe,fe)=>oe===fe){let oe=0;for(let fe=0,pe=Math.min(U.length,$.length);fe<pe&&H(U[fe],$[fe]);fe++)oe++;return oe}e.commonPrefixLength=r;function c(U){return[].concat(...U)}e.flatten=c;function b(U,$){let H=typeof $=="number"?U:0;typeof $=="number"?H=U:(H=0,$=U);const oe=[];if(H<=$)for(let fe=H;fe<$;fe++)oe.push(fe);else for(let fe=H;fe>$;fe--)oe.push(fe);return oe}e.range=b;function L(U,$,H){return U.reduce((oe,fe)=>(oe[$(fe)]=H?H(fe):fe,oe),Object.create(null))}e.index=L;function T(U,$){return U.push($),()=>F(U,$)}e.insert=T;function F(U,$){const H=U.indexOf($);if(H>-1)return U.splice(H,1),$}e.remove=F;function Y(U,$,H){const oe=U.slice(0,$),fe=U.slice($);return oe.concat(H,fe)}e.arrayInsert=Y;function V(U,$){let H;if(typeof $=="number"){let oe=$;H=()=>{const fe=Math.sin(oe++)*179426549;return fe-Math.floor(fe)}}else H=Math.random;for(let oe=U.length-1;oe>0;oe-=1){const fe=Math.floor(H()*(oe+1)),pe=U[oe];U[oe]=U[fe],U[fe]=pe}}e.shuffle=V;function G(U,$){const H=U.indexOf($);H>-1&&(U.splice(H,1),U.unshift($))}e.pushToStart=G;function ie(U,$){const H=U.indexOf($);H>-1&&(U.splice(H,1),U.push($))}e.pushToEnd=ie;function re(U,$){for(const H of $)U.push(H)}e.pushMany=re;function de(U,$){return Array.isArray(U)?U.map($):$(U)}e.mapArrayOrNot=de;function ce(U){return Array.isArray(U)?U:[U]}e.asArray=ce;function ge(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=ge;function x(U,$){for(const H of U){const oe=$(H);if(oe!==void 0)return oe}}e.mapFind=x;function B(U,$,H){const oe=z(U,$),fe=U.length,pe=H.length;U.length=fe+pe;for(let ye=fe-1;ye>=oe;ye--)U[ye+pe]=U[ye];for(let ye=0;ye<pe;ye++)U[ye+oe]=H[ye]}e.insertInto=B;function O(U,$,H,oe){const fe=z(U,$),pe=U.splice(fe,H);return B(U,fe,oe),pe}e.splice=O;function z(U,$){return $<0?Math.max($+U.length,0):Math.min($,U.length)}var K;(function(U){function $(fe){return fe<0}U.isLessThan=$;function H(fe){return fe>0}U.isGreaterThan=H;function oe(fe){return fe===0}U.isNeitherLessOrGreaterThan=oe,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(K=e.CompareResult||(e.CompareResult={}));function ne(U,$){return(H,oe)=>$(U(H),U(oe))}e.compareBy=ne;function se(...U){return($,H)=>{for(const oe of U){const fe=oe($,H);if(!K.isNeitherLessOrGreaterThan(fe))return fe}return K.neitherLessOrGreaterThan}}e.tieBreakComparators=se;const J=(U,$)=>U-$;e.numberComparator=J;function W(U,$){if(U.length===0)return;let H=U[0];for(let oe=1;oe<U.length;oe++){const fe=U[oe];$(fe,H)>0&&(H=fe)}return H}e.findMaxBy=W;function A(U,$){if(U.length===0)return;let H=U[0];for(let oe=1;oe<U.length;oe++){const fe=U[oe];$(fe,H)>=0&&(H=fe)}return H}e.findLastMaxBy=A;function _(U,$){return W(U,(H,oe)=>-$(H,oe))}e.findMinBy=_;class N{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let H=this.firstIdx;for(;H<this.items.length&&$(this.items[H]);)H++;const oe=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,oe}takeFromEndWhile($){let H=this.lastIdx;for(;H>=0&&$(this.items[H]);)H--;const oe=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,oe}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}removeLast(){const $=this.items[this.lastIdx];return this.lastIdx--,$}takeCount($){const H=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,H}}e.ArrayQueue=N;class q{constructor($){this.iterate=$}forEach($){this.iterate(H=>($(H),!0))}toArray(){const $=[];return this.iterate(H=>($.push(H),!0)),$}filter($){return new q(H=>this.iterate(oe=>$(oe)?H(oe):!0))}map($){return new q(H=>this.iterate(oe=>H($(oe))))}some($){let H=!1;return this.iterate(oe=>(H=$(oe),!H)),H}findFirst($){let H;return this.iterate(oe=>$(oe)?(H=oe,!1):!0),H}findLast($){let H;return this.iterate(oe=>($(oe)&&(H=oe),!0)),H}findLastMaxBy($){let H,oe=!0;return this.iterate(fe=>((oe||K.isGreaterThan($(fe,H)))&&(oe=!1,H=fe),!0)),H}}q.empty=new q(U=>{}),e.CallbackIterable=q}),define(ee[125],te([0,1,13]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function D(g,h){if(!g)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}e.ok=D;function n(g,h="Unreachable"){throw new Error(h)}e.assertNever=n;function M(g){if(!g)throw new E.BugIndicatingError("Assertion Failed")}e.assert=M;function k(g){if(!g()){debugger;g(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function P(g,h){let y=0;for(;y<g.length-1;){const w=g[y],S=g[y+1];if(!h(w,S))return!1;y++}return!0}e.checkAdjacentItems=P}),define(ee[50],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(D){const n=this;let M=!1,k;return function(){return M||(M=!0,k=D.apply(n,arguments)),k}}e.once=E}),define(ee[70],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(D){function n(I){return I&&typeof I=="object"&&typeof I[Symbol.iterator]=="function"}D.is=n;const M=Object.freeze([]);function k(){return M}D.empty=k;function*P(I){yield I}D.single=P;function g(I){return n(I)?I:P(I)}D.wrap=g;function h(I){return I||M}D.from=h;function y(I){return!I||I[Symbol.iterator]().next().done===!0}D.isEmpty=y;function w(I){return I[Symbol.iterator]().next().value}D.first=w;function S(I,R){for(const t of I)if(R(t))return!0;return!1}D.some=S;function f(I,R){for(const t of I)if(R(t))return t}D.find=f;function*p(I,R){for(const t of I)R(t)&&(yield t)}D.filter=p;function*v(I,R){let t=0;for(const a of I)yield R(a,t++)}D.map=v;function*o(...I){for(const R of I)for(const t of R)yield t}D.concat=o;function d(I,R,t){let a=t;for(const i of I)a=R(a,i);return a}D.reduce=d;function*m(I,R,t=I.length){for(R<0&&(R+=I.length),t<0?t+=I.length:t>I.length&&(t=I.length);R<t;R++)yield I[R]}D.slice=m;function C(I,R=Number.POSITIVE_INFINITY){const t=[];if(R===0)return[t,I];const a=I[Symbol.iterator]();for(let i=0;i<R;i++){const s=a.next();if(s.done)return[t,D.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return a}}]}D.consume=C})(E=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function k(t,a=!1){let i=0;const s=t.length;let l="",u=0,r=16,c=0;function b(ie){let re=0,de=0;for(;re<ie;){const ce=t.charCodeAt(i);if(ce>=48&&ce<=57)de=de*16+ce-48;else if(ce>=65&&ce<=70)de=de*16+ce-65+10;else if(ce>=97&&ce<=102)de=de*16+ce-97+10;else break;i++,re++}return re<ie&&(de=-1),de}function L(ie){i=ie,l="",u=0,r=16,c=0}function T(){const ie=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&h(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&h(t.charCodeAt(i)))for(i++;i<t.length&&h(t.charCodeAt(i));)i++;else return c=3,t.substring(ie,i);let re=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&h(t.charCodeAt(i))){for(i++;i<t.length&&h(t.charCodeAt(i));)i++;re=i}else c=3;return t.substring(ie,re)}function F(){let ie="",re=i;for(;;){if(i>=s){ie+=t.substring(re,i),c=2;break}const de=t.charCodeAt(i);if(de===34){ie+=t.substring(re,i),i++;break}if(de===92){if(ie+=t.substring(re,i),i++,i>=s){c=2;break}switch(t.charCodeAt(i++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const ge=b(4);ge>=0?ie+=String.fromCharCode(ge):c=4;break}default:c=5}re=i;continue}if(de>=0&&de<=31)if(g(de)){ie+=t.substring(re,i),c=2;break}else c=6;i++}return ie}function Y(){if(l="",c=0,u=i,i>=s)return u=s,r=17;let ie=t.charCodeAt(i);if(P(ie)){do i++,l+=String.fromCharCode(ie),ie=t.charCodeAt(i);while(P(ie));return r=15}if(g(ie))return i++,l+=String.fromCharCode(ie),ie===13&&t.charCodeAt(i)===10&&(i++,l+=`
`),r=14;switch(ie){case 123:return i++,r=1;case 125:return i++,r=2;case 91:return i++,r=3;case 93:return i++,r=4;case 58:return i++,r=6;case 44:return i++,r=5;case 34:return i++,l=F(),r=10;case 47:{const re=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!g(t.charCodeAt(i));)i++;return l=t.substring(re,i),r=12}if(t.charCodeAt(i+1)===42){i+=2;const de=s-1;let ce=!1;for(;i<de;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ce=!0;break}i++}return ce||(i++,c=1),l=t.substring(re,i),r=13}return l+=String.fromCharCode(ie),i++,r=16}case 45:if(l+=String.fromCharCode(ie),i++,i===s||!h(t.charCodeAt(i)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=T(),r=11;default:for(;i<s&&V(ie);)i++,ie=t.charCodeAt(i);if(u!==i){switch(l=t.substring(u,i),l){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return l+=String.fromCharCode(ie),i++,r=16}}function V(ie){if(P(ie)||g(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let ie;do ie=Y();while(ie>=12&&ie<=15);return ie}return{setPosition:L,getPosition:()=>i,scan:a?G:Y,getToken:()=>r,getTokenValue:()=>l,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>c}}e.createScanner=k;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function h(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function w(t,a){const i=[],s=new Object;let l;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function c(b,L,T,F){u.value=b,u.offset=L,u.length=T,u.type=F,u.colonOffset=void 0,l=u}try{C(t,{onObjectBegin:(b,L)=>{if(a<=b)throw s;l=void 0,r=a>b,i.push("")},onObjectProperty:(b,L,T)=>{if(a<L||(c(b,L,T,"property"),i[i.length-1]=b,a<=L+T))throw s},onObjectEnd:(b,L)=>{if(a<=b)throw s;l=void 0,i.pop()},onArrayBegin:(b,L)=>{if(a<=b)throw s;l=void 0,i.push(0)},onArrayEnd:(b,L)=>{if(a<=b)throw s;l=void 0,i.pop()},onLiteralValue:(b,L,T)=>{if(a<L||(c(b,L,T,R(b)),a<=L+T))throw s},onSeparator:(b,L,T)=>{if(a<=L)throw s;if(b===":"&&l&&l.type==="property")l.colonOffset=L,r=!1,l=void 0;else if(b===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(r=!0,i[i.length-1]=""),l=void 0}}})}catch(b){if(b!==s)throw b}return{path:i,previousNode:l,isAtPropertyKey:r,matches:b=>{let L=0;for(let T=0;L<b.length&&T<i.length;T++)if(b[L]===i[T]||b[L]==="*")L++;else if(b[L]!=="**")return!1;return L===b.length}}}e.getLocation=w;function S(t,a=[],i=M.DEFAULT){let s=null,l=[];const u=[];function r(b){Array.isArray(l)?l.push(b):s!==null&&(l[s]=b)}return C(t,{onObjectBegin:()=>{const b={};r(b),u.push(l),l=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{const b=[];r(b),u.push(l),l=b,s=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:r,onError:(b,L,T)=>{a.push({error:b,offset:L,length:T})}},i),l[0]}e.parse=S;function f(t,a=[],i=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(b){s.type==="property"&&(s.length=b-s.offset,s=s.parent)}function u(b){return s.children.push(b),b}C(t,{onObjectBegin:b=>{s=u({type:"object",offset:b,length:-1,parent:s,children:[]})},onObjectProperty:(b,L,T)=>{s=u({type:"property",offset:L,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:b,offset:L,length:T,parent:s})},onObjectEnd:(b,L)=>{s.length=b+L-s.offset,s=s.parent,l(b+L)},onArrayBegin:(b,L)=>{s=u({type:"array",offset:b,length:-1,parent:s,children:[]})},onArrayEnd:(b,L)=>{s.length=b+L-s.offset,s=s.parent,l(b+L)},onLiteralValue:(b,L,T)=>{u({type:R(b),offset:L,length:T,parent:s,value:b}),l(L+T)},onSeparator:(b,L,T)=>{s.type==="property"&&(b===":"?s.colonOffset=L:b===","&&l(L))},onError:(b,L,T)=>{a.push({error:b,offset:L,length:T})}},i);const c=s.children[0];return c&&delete c.parent,c}e.parseTree=f;function p(t,a){if(!t)return;let i=t;for(const s of a)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let l=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===s){i=u.children[1],l=!0;break}if(!l)return}else{const l=s;if(i.type!=="array"||l<0||!Array.isArray(i.children)||l>=i.children.length)return;i=i.children[l]}return i}e.findNodeAtLocation=p;function v(t){if(!t.parent||!t.parent.children)return[];const a=v(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=v;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const a=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(a[i.children[0].value]=o(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function d(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=d;function m(t,a,i=!1){if(d(t,a,i)){const s=t.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=a;l++){const u=m(s[l],a,i);if(u)return u}return t}}e.findNodeAtOffset=m;function C(t,a,i=M.DEFAULT){const s=k(t,!1);function l(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function u(ne){return ne?se=>ne(se,s.getTokenOffset(),s.getTokenLength()):()=>!0}const r=l(a.onObjectBegin),c=u(a.onObjectProperty),b=l(a.onObjectEnd),L=l(a.onArrayBegin),T=l(a.onArrayEnd),F=u(a.onLiteralValue),Y=u(a.onSeparator),V=l(a.onComment),G=u(a.onError),ie=i&&i.disallowComments,re=i&&i.allowTrailingComma;function de(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ie||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(ne){case 12:case 13:ie?ce(10):V();break;case 16:ce(1);break;case 15:case 14:break;default:return ne}}}function ce(ne,se=[],J=[]){if(G(ne),se.length+J.length>0){let W=s.getToken();for(;W!==17;){if(se.indexOf(W)!==-1){de();break}else if(J.indexOf(W)!==-1)break;W=de()}}}function ge(ne){const se=s.getTokenValue();return ne?F(se):c(se),de(),!0}function x(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(ce(2),ne=0)}catch{ce(2)}F(ne);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return de(),!0}function B(){return s.getToken()!==10?(ce(3,[],[2,5]),!1):(ge(!1),s.getToken()===6?(Y(":"),de(),K()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function O(){r(),de();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||ce(4,[],[]),Y(","),de(),s.getToken()===2&&re)break}else ne&&ce(6,[],[]);B()||ce(4,[],[2,5]),ne=!0}return b(),s.getToken()!==2?ce(7,[2],[]):de(),!0}function z(){L(),de();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||ce(4,[],[]),Y(","),de(),s.getToken()===4&&re)break}else ne&&ce(6,[],[]);K()||ce(4,[],[4,5]),ne=!0}return T(),s.getToken()!==4?ce(8,[4],[]):de(),!0}function K(){switch(s.getToken()){case 3:return z();case 1:return O();case 10:return ge(!0);default:return x()}}return de(),s.getToken()===17?i.allowEmptyContent?!0:(ce(4,[],[]),!1):K()?(s.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.visit=C;function I(t,a){const i=k(t),s=[];let l,u=0,r;do switch(r=i.getPosition(),l=i.scan(),l){case 12:case 13:case 17:u!==r&&s.push(t.substring(u,r)),a!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,a)),u=i.getPosition();break}while(l!==17);return s.join("")}e.stripComments=I;function R(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(ee[126],te([0,1,43]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function D(h,y,w){let S,f,p,v,o;if(y){for(v=y.offset,o=v+y.length,p=v;p>0&&!g(h,p-1);)p--;let r=o;for(;r<h.length&&!g(h,r);)r++;f=h.substring(p,r),S=k(f,w)}else f=h,S=0,p=0,v=0,o=h.length;const d=P(w,h);let m=!1,C=0,I;w.insertSpaces?I=M(" ",w.tabSize||4):I="	";const R=(0,E.createScanner)(f,!1);let t=!1;function a(){return d+M(I,S+C)}function i(){let r=R.scan();for(m=!1;r===15||r===14;)m=m||r===14,r=R.scan();return t=r===16||R.getTokenError()!==0,r}const s=[];function l(r,c,b){!t&&c<o&&b>v&&h.substring(c,b)!==r&&s.push({offset:c,length:b-c,content:r})}let u=i();if(u!==17){const r=R.getTokenOffset()+p,c=M(I,S);l(c,p,r)}for(;u!==17;){let r=R.getTokenOffset()+R.getTokenLength()+p,c=i(),b="";for(;!m&&(c===12||c===13);){const T=R.getTokenOffset()+p;l(" ",r,T),r=R.getTokenOffset()+R.getTokenLength()+p,b=c===12?a():"",c=i()}if(c===2)u!==1&&(C--,b=a());else if(c===4)u!==3&&(C--,b=a());else{switch(u){case 3:case 1:C++,b=a();break;case 5:case 12:b=a();break;case 13:m?b=a():b=" ";break;case 6:b=" ";break;case 10:if(c===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?b=" ":c!==5&&c!==17&&(t=!0);break;case 16:t=!0;break}m&&(c===12||c===13)&&(b=a())}const L=R.getTokenOffset()+p;l(b,r,L),u=c}return s}e.format=D;function n(h,y){const w=JSON.stringify(h,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?w.replace(/\r\n|\r|\n/g,y.eol):w}e.toFormattedString=n;function M(h,y){let w="";for(let S=0;S<y;S++)w+=h;return w}function k(h,y){let w=0,S=0;const f=y.tabSize||4;for(;w<h.length;){const p=h.charAt(w);if(p===" ")S++;else if(p==="	")S+=f;else break;w++}return Math.floor(S/f)}function P(h,y){for(let w=0;w<y.length;w++){const S=y.charAt(w);if(S==="\r")return w+1<y.length&&y.charAt(w+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=P;function g(h,y){return`\r
`.indexOf(h.charAt(y))!==-1}e.isEOL=g}),define(ee[127],te([0,1,43,126]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(h,y,w){return M(h,y,void 0,w)}e.removeProperty=n;function M(h,y,w,S,f){const p=y.slice(),v=[],o=(0,E.parseTree)(h,v);let d,m;for(;p.length>0&&(m=p.pop(),d=(0,E.findNodeAtLocation)(o,p),d===void 0&&w!==void 0);)typeof m=="string"?w={[m]:w}:w=[w];if(d)if(d.type==="object"&&typeof m=="string"&&Array.isArray(d.children)){const C=(0,E.findNodeAtLocation)(d,[m]);if(C!==void 0)if(w===void 0){if(!C.parent)throw new Error("Malformed AST");const I=d.children.indexOf(C.parent);let R,t=C.parent.offset+C.parent.length;if(I>0){const a=d.children[I-1];R=a.offset+a.length}else R=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return k(h,{offset:R,length:t-R,content:""},S)}else return k(h,{offset:C.offset,length:C.length,content:JSON.stringify(w)},S);else{if(w===void 0)return[];const I=`${JSON.stringify(m)}: ${JSON.stringify(w)}`,R=f?f(d.children.map(a=>a.children[0].value)):d.children.length;let t;if(R>0){const a=d.children[R-1];t={offset:a.offset+a.length,length:0,content:","+I}}else d.children.length===0?t={offset:d.offset+1,length:0,content:I}:t={offset:d.offset+1,length:0,content:I+","};return k(h,t,S)}}else if(d.type==="array"&&typeof m=="number"&&Array.isArray(d.children))if(w!==void 0){const C=`${JSON.stringify(w)}`;let I;if(d.children.length===0||m===0)I={offset:d.offset+1,length:0,content:d.children.length===0?C:C+","};else{const R=m===-1||m>d.children.length?d.children.length:m,t=d.children[R-1];I={offset:t.offset+t.length,length:0,content:","+C}}return k(h,I,S)}else{const C=m,I=d.children[C];let R;if(d.children.length===1)R={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===C){const t=d.children[C-1],a=t.offset+t.length,i=d.offset+d.length;R={offset:a,length:i-2-a,content:""}}else R={offset:I.offset,length:d.children[C+1].offset-I.offset,content:""};return k(h,R,S)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${d.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return k(h,{offset:o?o.offset:0,length:o?o.length:0,content:JSON.stringify(w)},S)}}e.setProperty=M;function k(h,y,w){let S=P(h,y),f=y.offset,p=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;f>0&&!(0,D.isEOL)(S,f-1);)f--;for(;p<S.length&&!(0,D.isEOL)(S,p);)p++}const v=(0,D.format)(S,{offset:f,length:p-f},w);for(let d=v.length-1;d>=0;d--){const m=v[d];S=P(S,m),f=Math.min(f,m.offset),p=Math.max(p,m.offset+m.length),p+=m.content.length-m.length}const o=h.length-(S.length-p)-f;return[{offset:f,length:o,content:S.substring(f,p)}]}e.withFormatting=k;function P(h,y){return h.substring(0,y.offset)+y.content+h.substring(y.offset+y.length)}e.applyEdit=P;function g(h,y){const w=y.slice(0).sort((f,p)=>{const v=f.offset-p.offset;return v===0?f.length-p.length:v});let S=h.length;for(let f=w.length-1;f>=0;f--){const p=w[f];if(p.offset+p.length<=S)h=P(h,p);else throw new Error("Overlapping edit");S=p.offset}return h}e.applyEdits=g}),define(ee[128],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(n){this.executor=n,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(n){this._error=n}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=E}),define(ee[2],te([0,1,50,70]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let M=null;function k(u){M=u}if(e.setDisposableTracker=k,n){const u="__is_disposable_tracked__";k(new class{trackDisposable(r){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[u]||console.log(c)},3e3)}setParent(r,c){if(r&&r!==m.None)try{r[u]=!0}catch{}}markAsDisposed(r){if(r&&r!==m.None)try{r[u]=!0}catch{}}markAsSingleton(r){}})}function P(u){return M?.trackDisposable(u),u}function g(u){M?.markAsDisposed(u)}function h(u,r){M?.setParent(u,r)}function y(u,r){if(!!M)for(const c of u)M.setParent(c,r)}function w(u){return M?.markAsSingleton(u),u}e.markAsSingleton=w;function S(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=S;function f(u){if(D.Iterable.is(u)){const r=[];for(const c of u)if(c)try{c.dispose()}catch(b){r.push(b)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=f;function p(u){for(const r of u)S(r)&&r.dispose();return[]}e.disposeIfDisposable=p;function v(...u){const r=o(()=>f(u));return y(u,r),r}e.combinedDisposable=v;function o(u){const r=P({dispose:(0,E.once)(()=>{g(r),u()})});return r}e.toDisposable=o;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{f(this._toDispose)}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return h(r,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class m{constructor(){this._store=new d,P(this),h(this._store,this)}dispose(){g(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}m.None=Object.freeze({dispose(){}}),e.Disposable=m;class C{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&h(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&h(r,null),r}}e.MutableDisposable=C;class I{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=I;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(r){let c=r;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,g(this))},this}}e.SafeDisposable=R;class t{constructor(){this.references=new Map}acquire(r,...c){let b=this.references.get(r);b||(b={counter:0,object:this.createReferencedObject(r,...c)},this.references.set(r,b));const{object:L}=b,T=(0,E.once)(()=>{--b.counter===0&&(this.destroyReferencedObject(r,b.object),this.references.delete(r))});return b.counter++,{object:L,dispose:T}}}e.ReferenceCollection=t;class a{constructor(r){this.referenceCollection=r}async acquire(r,...c){const b=this.referenceCollection.acquire(r,...c);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(L){throw b.dispose(),L}}}e.AsyncReferenceCollection=a;class i{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=i;function s(u){const r=new d;try{u(r)}finally{r.dispose()}}e.disposeOnReturn=s;class l{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{f(this._store.values())}finally{this._store.clear()}}has(r){return this._store.has(r)}get(r){return this._store.get(r)}set(r,c,b=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||this._store.get(r)?.dispose(),this._store.set(r,c)}deleteAndDispose(r){this._store.get(r)?.dispose(),this._store.delete(r)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=l}),define(ee[99],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(M){this.element=M,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class D{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let M=this._first;for(;M!==E.Undefined;){const k=M.next;M.prev=E.Undefined,M.next=E.Undefined,M=k}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,k){const P=new E(M);if(this._first===E.Undefined)this._first=P,this._last=P;else if(k){const h=this._last;this._last=P,P.prev=h,h.next=P}else{const h=this._first;this._first=P,P.next=h,h.prev=P}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(P))}}shift(){if(this._first!==E.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==E.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==E.Undefined&&M.next!==E.Undefined){const k=M.prev;k.next=M.next,M.next.prev=k}else M.prev===E.Undefined&&M.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):M.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):M.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==E.Undefined;)yield M.element,M=M.next}}e.LinkedList=D}),define(ee[35],te([0,1]),function(j,e){"use strict";var E,D,n;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(p,v,o){let d=p.get(v);return d===void 0&&(d=o,p.set(v,d)),d}e.getOrSet=M;function k(p){const v=[];return p.forEach((o,d)=>{v.push(`${d} => ${o}`)}),`Map(${p.size}) {${v.join(", ")}}`}e.mapToString=k;function P(p){const v=[];return p.forEach(o=>{v.push(o)}),`Set(${p.size}) {${v.join(", ")}}`}e.setToString=P;class g{constructor(v,o){this.uri=v,this.value=o}}class h{constructor(v,o){this[E]="ResourceMap",v instanceof h?(this.map=new Map(v.map),this.toKey=o??h.defaultToKey):(this.map=new Map,this.toKey=v??h.defaultToKey)}set(v,o){return this.map.set(this.toKey(v),new g(v,o)),this}get(v){return this.map.get(this.toKey(v))?.value}has(v){return this.map.has(this.toKey(v))}get size(){return this.map.size}clear(){this.map.clear()}delete(v){return this.map.delete(this.toKey(v))}forEach(v,o){typeof o<"u"&&(v=v.bind(o));for(const[d,m]of this.map)v(m.value,m.uri,this)}*values(){for(const v of this.map.values())yield v.value}*keys(){for(const v of this.map.values())yield v.uri}*entries(){for(const v of this.map.values())yield[v.uri,v.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.map)yield[v.uri,v.value]}}h.defaultToKey=p=>p.toString(),e.ResourceMap=h;class y{constructor(v,o){this[D]="ResourceSet",!v||typeof v=="function"?this._map=new h(v):(this._map=new h(o),v.forEach(this.add,this))}get size(){return this._map.size}add(v){return this._map.set(v,v),this}clear(){this._map.clear()}delete(v){return this._map.delete(v)}forEach(v,o){this._map.forEach((d,m)=>v.call(o,m,m,this))}has(v){return this._map.has(v)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var w;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class S{constructor(){this[n]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(v){return this._map.has(v)}get(v,o=0){const d=this._map.get(v);if(!!d)return o!==0&&this.touch(d,o),d.value}set(v,o,d=0){let m=this._map.get(v);if(m)m.value=o,d!==0&&this.touch(m,d);else{switch(m={key:v,value:o,next:void 0,previous:void 0},d){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(v,m),this._size++}return this}delete(v){return!!this.remove(v)}remove(v){const o=this._map.get(v);if(!!o)return this._map.delete(v),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const v=this._head;return this._map.delete(v.key),this.removeItem(v),this._size--,v.value}forEach(v,o){const d=this._state;let m=this._head;for(;m;){if(o?v.bind(o)(m.value,m.key,this):v(m.value,m.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const v=this,o=this._state;let d=this._head;const m={[Symbol.iterator](){return m},next(){if(v._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const C={value:d.key,done:!1};return d=d.next,C}else return{value:void 0,done:!0}}};return m}values(){const v=this,o=this._state;let d=this._head;const m={[Symbol.iterator](){return m},next(){if(v._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const C={value:d.value,done:!1};return d=d.next,C}else return{value:void 0,done:!0}}};return m}entries(){const v=this,o=this._state;let d=this._head;const m={[Symbol.iterator](){return m},next(){if(v._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const C={value:[d.key,d.value],done:!1};return d=d.next,C}else return{value:void 0,done:!0}}};return m}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(v){if(v>=this.size)return;if(v===0){this.clear();return}let o=this._head,d=this.size;for(;o&&d>v;)this._map.delete(o.key),o=o.next,d--;this._head=o,this._size=d,o&&(o.previous=void 0),this._state++}addItemFirst(v){if(!this._head&&!this._tail)this._tail=v;else if(this._head)v.next=this._head,this._head.previous=v;else throw new Error("Invalid list");this._head=v,this._state++}addItemLast(v){if(!this._head&&!this._tail)this._head=v;else if(this._tail)v.previous=this._tail,this._tail.next=v;else throw new Error("Invalid list");this._tail=v,this._state++}removeItem(v){if(v===this._head&&v===this._tail)this._head=void 0,this._tail=void 0;else if(v===this._head){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this._head=v.next}else if(v===this._tail){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this._tail=v.previous}else{const o=v.next,d=v.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}v.next=void 0,v.previous=void 0,this._state++}touch(v,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(v===this._head)return;const d=v.next,m=v.previous;v===this._tail?(m.next=void 0,this._tail=m):(d.previous=m,m.next=d),v.previous=void 0,v.next=this._head,this._head.previous=v,this._head=v,this._state++}else if(o===2){if(v===this._tail)return;const d=v.next,m=v.previous;v===this._head?(d.previous=void 0,this._head=d):(d.previous=m,m.next=d),v.next=void 0,v.previous=this._tail,this._tail.next=v,this._tail=v,this._state++}}}toJSON(){const v=[];return this.forEach((o,d)=>{v.push([d,o])}),v}fromJSON(v){this.clear();for(const[o,d]of v)this.set(o,d)}}e.LinkedMap=S;class f extends S{constructor(v,o=1){super(),this._limit=v,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(v){this._limit=v,this.checkTrim()}get ratio(){return this._ratio}set ratio(v){this._ratio=Math.min(Math.max(0,v),1),this.checkTrim()}get(v,o=2){return super.get(v,o)}peek(v){return super.get(v,0)}set(v,o){return super.set(v,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f}),define(ee[79],te([0,1,35]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const D=new E.LRUCache(1e4);function n(h){return g(h,"NFC",D)}e.normalizeNFC=n;const M=new E.LRUCache(1e4);function k(h){return g(h,"NFD",M)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function g(h,y,w){if(!h)return h;const S=w.get(h);if(S)return S;let f;return P.test(h)?f=h.normalize(y):f=h,w.set(h,f),f}e.removeAccents=function(){const h=/[\u0300-\u036f]/g;return function(y){return k(y).replace(h,"")}}()}),define(ee[129],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,g,h){return Math.min(Math.max(P,g),h)}e.clamp=E;function D(P,g){return(g+P%g)%g}e.rot=D;class n{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=n;class M{constructor(){this._n=1,this._val=0}update(g){return this._val=this._val+(g-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class k{constructor(g){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(g),this._values.fill(0,0,g)}update(g){const h=this._values[this._index];return this._values[this._index]=g,this._index=(this._index+1)%this._values.length,this._sum-=h,this._sum+=g,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=k}),function(){function j(n){const M=[];typeof n=="number"&&M.push("code/timeOrigin",n);function k(g){M.push(g,Date.now())}function P(){const g=[];for(let h=0;h<M.length;h+=2)g.push({name:M[h],startTime:M[h+1]});return g}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const k of performance.getEntriesByType("mark"))M.push({name:k.name,startTime:Math.round(n+k.startTime)});return M}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function E(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=E(D))}(),function(j,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var D in E)(typeof exports=="object"?exports:j)[D]=E[D]}}(typeof self<"u"?self:this,function(){return function(j){var e={};function E(D){if(e[D])return e[D].exports;var n=e[D]={i:D,l:!1,exports:{}};return j[D].call(n.exports,n,n.exports,E),n.l=!0,n.exports}return E.m=j,E.c=e,E.d=function(D,n,M){E.o(D,n)||Object.defineProperty(D,n,{enumerable:!0,get:M})},E.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},E.t=function(D,n){if(1&n&&(D=E(D)),8&n||4&n&&typeof D=="object"&&D&&D.__esModule)return D;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:D}),2&n&&typeof D!="string")for(var k in D)E.d(M,k,function(P){return D[P]}.bind(null,k));return M},E.n=function(D){var n=D&&D.__esModule?function(){return D.default}:function(){return D};return E.d(n,"a",n),n},E.o=function(D,n){return Object.prototype.hasOwnProperty.call(D,n)},E.p="",E(E.s=0)}([function(j,e,E){(function(D){var n;e=j.exports=J,n=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],g=e.src=[],h=0,y=h++;g[y]="0|[1-9]\\d*";var w=h++;g[w]="[0-9]+";var S=h++;g[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=h++;g[f]="("+g[y]+")\\.("+g[y]+")\\.("+g[y]+")";var p=h++;g[p]="("+g[w]+")\\.("+g[w]+")\\.("+g[w]+")";var v=h++;g[v]="(?:"+g[y]+"|"+g[S]+")";var o=h++;g[o]="(?:"+g[w]+"|"+g[S]+")";var d=h++;g[d]="(?:-("+g[v]+"(?:\\."+g[v]+")*))";var m=h++;g[m]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var C=h++;g[C]="[0-9A-Za-z-]+";var I=h++;g[I]="(?:\\+("+g[C]+"(?:\\."+g[C]+")*))";var R=h++,t="v?"+g[f]+g[d]+"?"+g[I]+"?";g[R]="^"+t+"$";var a="[v=\\s]*"+g[p]+g[m]+"?"+g[I]+"?",i=h++;g[i]="^"+a+"$";var s=h++;g[s]="((?:<|>)?=?)";var l=h++;g[l]=g[w]+"|x|X|\\*";var u=h++;g[u]=g[y]+"|x|X|\\*";var r=h++;g[r]="[v=\\s]*("+g[u]+")(?:\\.("+g[u]+")(?:\\.("+g[u]+")(?:"+g[d]+")?"+g[I]+"?)?)?";var c=h++;g[c]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[m]+")?"+g[I]+"?)?)?";var b=h++;g[b]="^"+g[s]+"\\s*"+g[r]+"$";var L=h++;g[L]="^"+g[s]+"\\s*"+g[c]+"$";var T=h++;g[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=h++;g[F]="(?:~>?)";var Y=h++;g[Y]="(\\s*)"+g[F]+"\\s+",P[Y]=new RegExp(g[Y],"g");var V=h++;g[V]="^"+g[F]+g[r]+"$";var G=h++;g[G]="^"+g[F]+g[c]+"$";var ie=h++;g[ie]="(?:\\^)";var re=h++;g[re]="(\\s*)"+g[ie]+"\\s+",P[re]=new RegExp(g[re],"g");var de=h++;g[de]="^"+g[ie]+g[r]+"$";var ce=h++;g[ce]="^"+g[ie]+g[c]+"$";var ge=h++;g[ge]="^"+g[s]+"\\s*("+a+")$|^$";var x=h++;g[x]="^"+g[s]+"\\s*("+t+")$|^$";var B=h++;g[B]="(\\s*)"+g[s]+"\\s*("+a+"|"+g[r]+")",P[B]=new RegExp(g[B],"g");var O=h++;g[O]="^\\s*("+g[r]+")\\s+-\\s+("+g[r]+")\\s*$";var z=h++;g[z]="^\\s*("+g[c]+")\\s+-\\s+("+g[c]+")\\s*$";var K=h++;g[K]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)n(ne,g[ne]),P[ne]||(P[ne]=new RegExp(g[ne]));function se(X,ae){if(X instanceof J)return X;if(typeof X!="string"||X.length>M||!(ae?P[i]:P[R]).test(X))return null;try{return new J(X,ae)}catch{return null}}function J(X,ae){if(X instanceof J){if(X.loose===ae)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof J))return new J(X,ae);n("SemVer",X,ae),this.loose=ae;var he=X.trim().match(ae?P[i]:P[R]);if(!he)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Re=+Ie;if(Re>=0&&Re<k)return Re}return Ie}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=se,e.valid=function(X,ae){var he=se(X,ae);return he?he.version:null},e.clean=function(X,ae){var he=se(X.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(X){return n("SemVer.compare",this.version,this.loose,X),X instanceof J||(X=new J(X,this.loose)),this.compareMain(X)||this.comparePre(X)},J.prototype.compareMain=function(X){return X instanceof J||(X=new J(X,this.loose)),A(this.major,X.major)||A(this.minor,X.minor)||A(this.patch,X.patch)},J.prototype.comparePre=function(X){if(X instanceof J||(X=new J(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],Ie=X.prerelease[ae];if(n("prerelease compare",ae,he,Ie),he===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(he===void 0)return-1;if(he!==Ie)return A(he,Ie)}while(++ae)},J.prototype.inc=function(X,ae){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ae,he,Ie){typeof he=="string"&&(Ie=he,he=void 0);try{return new J(X,he).inc(ae,Ie).version}catch{return null}},e.diff=function(X,ae){if(U(X,ae))return null;var he=se(X),Ie=se(ae);if(he.prerelease.length||Ie.prerelease.length){for(var Re in he)if((Re==="major"||Re==="minor"||Re==="patch")&&he[Re]!==Ie[Re])return"pre"+Re;return"prerelease"}for(var Re in he)if((Re==="major"||Re==="minor"||Re==="patch")&&he[Re]!==Ie[Re])return Re},e.compareIdentifiers=A;var W=/^[0-9]+$/;function A(X,ae){var he=W.test(X),Ie=W.test(ae);return he&&Ie&&(X=+X,ae=+ae),he&&!Ie?-1:Ie&&!he?1:X<ae?-1:X>ae?1:0}function _(X,ae,he){return new J(X,he).compare(new J(ae,he))}function N(X,ae,he){return _(X,ae,he)>0}function q(X,ae,he){return _(X,ae,he)<0}function U(X,ae,he){return _(X,ae,he)===0}function $(X,ae,he){return _(X,ae,he)!==0}function H(X,ae,he){return _(X,ae,he)>=0}function oe(X,ae,he){return _(X,ae,he)<=0}function fe(X,ae,he,Ie){var Re;switch(ae){case"===":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Re=X===he;break;case"!==":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Re=X!==he;break;case"":case"=":case"==":Re=U(X,he,Ie);break;case"!=":Re=$(X,he,Ie);break;case">":Re=N(X,he,Ie);break;case">=":Re=H(X,he,Ie);break;case"<":Re=q(X,he,Ie);break;case"<=":Re=oe(X,he,Ie);break;default:throw new TypeError("Invalid operator: "+ae)}return Re}function pe(X,ae){if(X instanceof pe){if(X.loose===ae)return X;X=X.value}if(!(this instanceof pe))return new pe(X,ae);n("comparator",X,ae),this.loose=ae,this.parse(X),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(X,ae){return A(ae,X)},e.major=function(X,ae){return new J(X,ae).major},e.minor=function(X,ae){return new J(X,ae).minor},e.patch=function(X,ae){return new J(X,ae).patch},e.compare=_,e.compareLoose=function(X,ae){return _(X,ae,!0)},e.rcompare=function(X,ae,he){return _(ae,X,he)},e.sort=function(X,ae){return X.sort(function(he,Ie){return e.compare(he,Ie,ae)})},e.rsort=function(X,ae){return X.sort(function(he,Ie){return e.rcompare(he,Ie,ae)})},e.gt=N,e.lt=q,e.eq=U,e.neq=$,e.gte=H,e.lte=oe,e.cmp=fe,e.Comparator=pe;var ye={};function Le(X,ae){if(X instanceof Le)return X.loose===ae?X:new Le(X.raw,ae);if(X instanceof pe)return new Le(X.value,ae);if(!(this instanceof Le))return new Le(X,ae);if(this.loose=ae,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function _e(X){return!X||X.toLowerCase()==="x"||X==="*"}function Oe(X,ae,he,Ie,Re,Ae,We,qe,Ue,$e,Ve,Fe,je){return((ae=_e(he)?"":_e(Ie)?">="+he+".0.0":_e(Re)?">="+he+"."+Ie+".0":">="+ae)+" "+(qe=_e(Ue)?"":_e($e)?"<"+(+Ue+1)+".0.0":_e(Ve)?"<"+Ue+"."+(+$e+1)+".0":Fe?"<="+Ue+"."+$e+"."+Ve+"-"+Fe:"<="+qe)).trim()}function ve(X,ae){for(var he=0;he<X.length;he++)if(!X[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<X.length;he++)if(n(X[he].semver),X[he].semver!==ye&&X[he].semver.prerelease.length>0){var Ie=X[he].semver;if(Ie.major===ae.major&&Ie.minor===ae.minor&&Ie.patch===ae.patch)return!0}return!1}return!0}function Me(X,ae,he){try{ae=new Le(ae,he)}catch{return!1}return ae.test(X)}function De(X,ae,he,Ie){var Re,Ae,We,qe,Ue;switch(X=new J(X,Ie),ae=new Le(ae,Ie),he){case">":Re=N,Ae=oe,We=q,qe=">",Ue=">=";break;case"<":Re=q,Ae=H,We=N,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(X,ae,Ie))return!1;for(var $e=0;$e<ae.set.length;++$e){var Ve=ae.set[$e],Fe=null,je=null;if(Ve.forEach(function(Q){Q.semver===ye&&(Q=new pe(">=0.0.0")),Fe=Fe||Q,je=je||Q,Re(Q.semver,Fe.semver,Ie)?Fe=Q:We(Q.semver,je.semver,Ie)&&(je=Q)}),Fe.operator===qe||Fe.operator===Ue||(!je.operator||je.operator===qe)&&Ae(X,je.semver)||je.operator===Ue&&We(X,je.semver))return!1}return!0}pe.prototype.parse=function(X){var ae=this.loose?P[ge]:P[x],he=X.match(ae);if(!he)throw new TypeError("Invalid comparator: "+X);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new J(he[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(X){return n("Comparator.test",X,this.loose),this.semver===ye||(typeof X=="string"&&(X=new J(X,this.loose)),fe(X,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(X,ae){if(!(X instanceof pe))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Le(X.value,ae),Me(this.value,he,ae);if(X.operator==="")return he=new Le(this.value,ae),Me(X.semver,he,ae);var Ie=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Ae=this.semver.version===X.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),qe=fe(this.semver,"<",X.semver,ae)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),Ue=fe(this.semver,">",X.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return Ie||Re||Ae&&We||qe||Ue},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(X){var ae=this.loose;X=X.trim(),n("range",X,ae);var he=ae?P[z]:P[O];X=X.replace(he,Oe),n("hyphen replace",X),X=X.replace(P[B],"$1$2$3"),n("comparator trim",X,P[B]),X=(X=(X=X.replace(P[Y],"$1~")).replace(P[re],"$1^")).split(/\s+/).join(" ");var Ie=ae?P[ge]:P[x],Re=X.split(" ").map(function(Ae){return function(We,qe){return n("comp",We),We=function(Ue,$e){return Ue.trim().split(/\s+/).map(function(Ve){return function(Fe,je){n("caret",Fe,je);var Q=je?P[ce]:P[de];return Fe.replace(Q,function(le,ue,me,be,Te){var ze;return n("caret",Fe,le,ue,me,be,Te),_e(ue)?ze="":_e(me)?ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":_e(be)?ze=ue==="0"?">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+".0 <"+(+ue+1)+".0.0":Te?(n("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),ze=ue==="0"?me==="0"?">="+ue+"."+me+"."+be+Te+" <"+ue+"."+me+"."+(+be+1):">="+ue+"."+me+"."+be+Te+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+be+Te+" <"+(+ue+1)+".0.0"):(n("no pr"),ze=ue==="0"?me==="0"?">="+ue+"."+me+"."+be+" <"+ue+"."+me+"."+(+be+1):">="+ue+"."+me+"."+be+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+be+" <"+(+ue+1)+".0.0"),n("caret return",ze),ze})}(Ve,$e)}).join(" ")}(We,qe),n("caret",We),We=function(Ue,$e){return Ue.trim().split(/\s+/).map(function(Ve){return function(Fe,je){var Q=je?P[G]:P[V];return Fe.replace(Q,function(le,ue,me,be,Te){var ze;return n("tilde",Fe,le,ue,me,be,Te),_e(ue)?ze="":_e(me)?ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":_e(be)?ze=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":Te?(n("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),ze=">="+ue+"."+me+"."+be+Te+" <"+ue+"."+(+me+1)+".0"):ze=">="+ue+"."+me+"."+be+" <"+ue+"."+(+me+1)+".0",n("tilde return",ze),ze})}(Ve,$e)}).join(" ")}(We,qe),n("tildes",We),We=function(Ue,$e){return n("replaceXRanges",Ue,$e),Ue.split(/\s+/).map(function(Ve){return function(Fe,je){Fe=Fe.trim();var Q=je?P[L]:P[b];return Fe.replace(Q,function(le,ue,me,be,Te,ze){n("xRange",Fe,le,ue,me,be,Te,ze);var tt=_e(me),Xe=tt||_e(be),Ke=Xe||_e(Te);return ue==="="&&Ke&&(ue=""),tt?le=ue===">"||ue==="<"?"<0.0.0":"*":ue&&Ke?(Xe&&(be=0),Ke&&(Te=0),ue===">"?(ue=">=",Xe?(me=+me+1,be=0,Te=0):Ke&&(be=+be+1,Te=0)):ue==="<="&&(ue="<",Xe?me=+me+1:be=+be+1),le=ue+me+"."+be+"."+Te):Xe?le=">="+me+".0.0 <"+(+me+1)+".0.0":Ke&&(le=">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0"),n("xRange return",le),le})}(Ve,$e)}).join(" ")}(We,qe),n("xrange",We),We=function(Ue,$e){return n("replaceStars",Ue,$e),Ue.trim().replace(P[K],"")}(We,qe),n("stars",We),We}(Ae,ae)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Ae){return!!Ae.match(Ie)})),Re=Re.map(function(Ae){return new pe(Ae,ae)})},Le.prototype.intersects=function(X,ae){if(!(X instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Ie){return X.set.some(function(Re){return Re.every(function(Ae){return Ie.intersects(Ae,ae)})})})})},e.toComparators=function(X,ae){return new Le(X,ae).set.map(function(he){return he.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new J(X,this.loose));for(var ae=0;ae<this.set.length;ae++)if(ve(this.set[ae],X))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(X,ae,he){var Ie=null,Re=null;try{var Ae=new Le(ae,he)}catch{return null}return X.forEach(function(We){Ae.test(We)&&(Ie&&Re.compare(We)!==-1||(Re=new J(Ie=We,he)))}),Ie},e.minSatisfying=function(X,ae,he){var Ie=null,Re=null;try{var Ae=new Le(ae,he)}catch{return null}return X.forEach(function(We){Ae.test(We)&&(Ie&&Re.compare(We)!==1||(Re=new J(Ie=We,he)))}),Ie},e.validRange=function(X,ae){try{return new Le(X,ae).range||"*"}catch{return null}},e.ltr=function(X,ae,he){return De(X,ae,"<",he)},e.gtr=function(X,ae,he){return De(X,ae,">",he)},e.outside=De,e.prerelease=function(X,ae){var he=se(X,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(X,ae,he){return X=new Le(X,he),ae=new Le(ae,he),X.intersects(ae)},e.coerce=function(X){if(X instanceof J)return X;if(typeof X!="string")return null;var ae=X.match(P[T]);return ae==null?null:se((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,E(1))},function(j,e){var E,D,n=j.exports={};function M(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(o){if(E===setTimeout)return setTimeout(o,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{D=typeof clearTimeout=="function"?clearTimeout:k}catch{D=k}})();var g,h=[],y=!1,w=-1;function S(){y&&g&&(y=!1,g.length?h=g.concat(h):w=-1,h.length&&f())}function f(){if(!y){var o=P(S);y=!0;for(var d=h.length;d;){for(g=h,h=[];++w<d;)g&&g[w].run();w=-1,d=h.length}g=null,y=!1,function(m){if(D===clearTimeout)return clearTimeout(m);if((D===k||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(m);try{D(m)}catch{try{return D.call(null,m)}catch{return D.call(this,m)}}}(o)}}function p(o,d){this.fun=o,this.array=d}function v(){}n.nextTick=function(o){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];h.push(new p(o,d)),h.length!==1||y||P(f)},p.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=v,n.addListener=v,n.once=v,n.off=v,n.removeListener=v,n.removeAllListeners=v,n.emit=v,n.prependListener=v,n.prependOnceListener=v,n.listeners=function(o){return[]},n.binding=function(o){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(o){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(ee[130],te([0,1]),function(j,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class D{constructor(P,g,h){this.level=P,this.key=g,this.value=h,this.forward=[]}}const n=void 0;class M{constructor(P,g=2**16){this.comparator=P,this[E]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(g)|0),this._header=new D(this._maxLevel,n,n)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,n,n)}has(P){return Boolean(M._search(this,P,this.comparator))}get(P){return M._search(this,P,this.comparator)?.value}set(P,g){return M._insert(this,P,g,this.comparator)&&(this._size+=1),this}delete(P){const g=M._delete(this,P,this.comparator);return g&&(this._size-=1),g}forEach(P,g){let h=this._header.forward[0];for(;h;)P.call(g,h.value,h.key,this),h=h.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",g=this._header.forward[0];for(;g;)P+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return P}static _search(P,g,h){let y=P._header;for(let w=P._level-1;w>=0;w--)for(;y.forward[w]&&h(y.forward[w].key,g)<0;)y=y.forward[w];if(y=y.forward[0],y&&h(y.key,g)===0)return y}static _insert(P,g,h,y){const w=[];let S=P._header;for(let f=P._level-1;f>=0;f--){for(;S.forward[f]&&y(S.forward[f].key,g)<0;)S=S.forward[f];w[f]=S}if(S=S.forward[0],S&&y(S.key,g)===0)return S.value=h,!1;{const f=M._randomLevel(P);if(f>P._level){for(let p=P._level;p<f;p++)w[p]=P._header;P._level=f}S=new D(f,g,h);for(let p=0;p<f;p++)S.forward[p]=w[p].forward[p],w[p].forward[p]=S;return!0}}static _randomLevel(P,g=.5){let h=1;for(;Math.random()<g&&h<P._maxLevel;)h+=1;return h}static _delete(P,g,h){const y=[];let w=P._header;for(let S=P._level-1;S>=0;S--){for(;w.forward[S]&&h(w.forward[S].key,g)<0;)w=w.forward[S];y[S]=w}if(w=w.forward[0],!w||h(w.key,g)!==0)return!1;for(let S=0;S<P._level&&y[S].forward[S]===w;S++)y[S].forward[S]=w.forward[S];for(;P._level>0&&P._header.forward[P._level-1]===n;)P._level-=1;return!0}}e.SkipList=M}),define(ee[60],te([0,1,13,2]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(I){const R=I;return R?typeof R.read=="function":!1}e.isReadable=n;function M(I){const R=I;return R?[R.on,R.pause,R.resume,R.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=M;function k(I){const R=I;return R?M(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=k;function P(I,R){return new g(I,R)}e.newWriteableStream=P;class g{constructor(R,t){this.reducer=R,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(R){if(!this.state.destroyed){if(this.state.flowing)this.emitData(R);else if(this.buffer.data.push(R),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(R){this.state.destroyed||(this.state.flowing?this.emitError(R):this.buffer.error.push(R))}end(R){this.state.destroyed||(typeof R<"u"&&this.write(R),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(R){this.listeners.data.slice(0).forEach(t=>t(R))}emitError(R){this.listeners.error.length===0?(0,E.onUnexpectedError)(R):this.listeners.error.slice(0).forEach(t=>t(R))}emitEnd(){this.listeners.end.slice(0).forEach(R=>R())}on(R,t){if(!this.state.destroyed)switch(R){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(R,t){if(this.state.destroyed)return;let a;switch(R){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const R=this.reducer(this.buffer.data);this.emitData(R),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const R of this.buffer.error)this.emitError(R);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(I,R){const t=[];let a;for(;(a=I.read())!==null;)t.push(a);return R(t)}e.consumeReadable=h;function y(I,R,t){const a=[];let i;for(;(i=I.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?R(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return I.read()}}}e.peekReadable=y;function w(I,R){return new Promise((t,a)=>{const i=[];S(I,{onData:s=>{R&&i.push(s)},onError:s=>{R?a(s):t(void 0)},onEnd:()=>{t(R?R(i):void 0)}})})}e.consumeStream=w;function S(I,R){let t=!1;return I.on("error",a=>{t||R.onError(a)}),I.on("end",()=>{t||R.onEnd()}),I.on("data",a=>{t||R.onData(a)}),(0,D.toDisposable)(()=>t=!0)}e.listenStream=S;function f(I,R){return new Promise((t,a)=>{const i=new D.DisposableStore,s=[],l=c=>{if(s.push(c),s.length>R)return i.dispose(),I.pause(),t({stream:I,buffer:s,ended:!1})},u=c=>a(c),r=()=>t({stream:I,buffer:s,ended:!0});i.add((0,D.toDisposable)(()=>I.removeListener("error",u))),I.on("error",u),i.add((0,D.toDisposable)(()=>I.removeListener("end",r))),I.on("end",r),i.add((0,D.toDisposable)(()=>I.removeListener("data",l))),I.on("data",l)})}e.peekStream=f;function p(I,R){const t=P(R);return t.end(I),t}e.toStream=p;function v(){const I=P(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=v;function o(I){let R=!1;return{read:()=>R?null:(R=!0,I)}}e.toReadable=o;function d(I,R,t){const a=P(t);return S(I,{onData:i=>a.write(R.data(i)),onError:i=>a.error(R.error?R.error(i):i),onEnd:()=>a.end()}),a}e.transform=d;function m(I,R,t){let a=!1;return{read:()=>{const i=R.read();return a?i:(a=!0,i!==null?t([I,i]):I)}}}e.prefixedReadable=m;function C(I,R,t){let a=!1;const i=P(t);return S(R,{onData:s=>a?i.write(s):(a=!0,i.write(t([I,s]))),onError:s=>i.error(s),onEnd:()=>{a||(a=!0,i.write(I)),i.end()}}),i}e.prefixedStream=C}),define(ee[17],te([0,1,60]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let n,M;class k{static alloc(c){return D?new k(Buffer.allocUnsafe(c)):new k(new Uint8Array(c))}static wrap(c){return D&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new k(c)}static fromString(c,b){return!(b?.dontUseNodeBuffer||!1)&&D?new k(Buffer.from(c)):(n||(n=new TextEncoder),new k(n.encode(c)))}static fromByteArray(c){const b=k.alloc(c.length);for(let L=0,T=c.length;L<T;L++)b.buffer[L]=c[L];return b}static concat(c,b){if(typeof b>"u"){b=0;for(let F=0,Y=c.length;F<Y;F++)b+=c[F].byteLength}const L=k.alloc(b);let T=0;for(let F=0,Y=c.length;F<Y;F++){const V=c[F];L.set(V,T),T+=V.byteLength}return L}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=k.alloc(this.byteLength);return c.set(this),c}toString(){return D?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(c,b){return new k(this.buffer.subarray(c,b))}set(c,b){if(c instanceof k)this.buffer.set(c.buffer,b);else if(c instanceof Uint8Array)this.buffer.set(c,b);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),b);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return h(this.buffer,c)}writeUInt32BE(c,b){y(this.buffer,c,b)}readUInt32LE(c){return w(this.buffer,c)}writeUInt32LE(c,b){S(this.buffer,c,b)}readUInt8(c){return f(this.buffer,c)}writeUInt8(c,b){p(this.buffer,c,b)}}e.VSBuffer=k;function P(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0}e.readUInt16LE=P;function g(r,c,b){r[b+0]=c&255,c=c>>>8,r[b+1]=c&255}e.writeUInt16LE=g;function h(r,c){return r[c]*2**24+r[c+1]*2**16+r[c+2]*2**8+r[c+3]}e.readUInt32BE=h;function y(r,c,b){r[b+3]=c,c=c>>>8,r[b+2]=c,c=c>>>8,r[b+1]=c,c=c>>>8,r[b]=c}e.writeUInt32BE=y;function w(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0|r[c+2]<<16>>>0|r[c+3]<<24>>>0}e.readUInt32LE=w;function S(r,c,b){r[b+0]=c&255,c=c>>>8,r[b+1]=c&255,c=c>>>8,r[b+2]=c&255,c=c>>>8,r[b+3]=c&255}e.writeUInt32LE=S;function f(r,c){return r[c]}e.readUInt8=f;function p(r,c,b){r[b]=c}e.writeUInt8=p;function v(r){return E.consumeReadable(r,c=>k.concat(c))}e.readableToBuffer=v;function o(r){return E.toReadable(r)}e.bufferToReadable=o;function d(r){return E.consumeStream(r,c=>k.concat(c))}e.streamToBuffer=d;async function m(r){return r.ended?k.concat(r.buffer):k.concat([...r.buffer,await d(r.stream)])}e.bufferedStreamToBuffer=m;function C(r){return E.toStream(r,c=>k.concat(c))}e.bufferToStream=C;function I(r){return E.transform(r,{data:c=>typeof c=="string"?k.fromString(c):k.wrap(c)},c=>k.concat(c))}e.streamToBufferReadableStream=I;function R(r){return E.newWriteableStream(c=>k.concat(c),r)}e.newWriteableBufferStream=R;function t(r,c){return E.prefixedReadable(r,c,b=>k.concat(b))}e.prefixedBufferReadable=t;function a(r,c){return E.prefixedStream(r,c,b=>k.concat(b))}e.prefixedBufferStream=a;function i(r){let c=0,b=0,L=0;const T=new Uint8Array(Math.floor(r.length/4*3)),F=V=>{switch(b){case 3:T[L++]=c|V,b=0;break;case 2:T[L++]=c|V>>>2,c=V<<6,b=3;break;case 1:T[L++]=c|V>>>4,c=V<<4,b=2;break;default:c=V<<2,b=1}};for(let V=0;V<r.length;V++){const G=r.charCodeAt(V);if(G>=65&&G<=90)F(G-65);else if(G>=97&&G<=122)F(G-97+26);else if(G>=48&&G<=57)F(G-48+52);else if(G===43||G===45)F(62);else if(G===47||G===95)F(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${r[V]}`)}}const Y=L;for(;b>0;)F(0);return k.wrap(T).slice(0,Y)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:r},c=!0,b=!1){const L=b?l:s;let T="";const F=r.byteLength%3;let Y=0;for(;Y<r.byteLength-F;Y+=3){const V=r[Y+0],G=r[Y+1],ie=r[Y+2];T+=L[V>>>2],T+=L[(V<<4|G>>>4)&63],T+=L[(G<<2|ie>>>6)&63],T+=L[ie&63]}if(F===1){const V=r[Y+0];T+=L[V>>>2],T+=L[V<<4&63],c&&(T+="==")}else if(F===2){const V=r[Y+0],G=r[Y+1];T+=L[V>>>2],T+=L[(V<<4|G>>>4)&63],T+=L[G<<2&63],c&&(T+="=")}return T}e.encodeBase64=u}),define(ee[131],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[10],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(a){return typeof a=="string"}e.isString=E;function D(a){return Array.isArray(a)&&a.every(i=>E(i))}e.isStringArray=D;function n(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=n;function M(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=M;function k(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=k;function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=P;function g(a){return a===!0||a===!1}e.isBoolean=g;function h(a){return typeof a>"u"}e.isUndefined=h;function y(a){return!w(a)}e.isDefined=y;function w(a){return h(a)||a===null}e.isUndefinedOrNull=w;function S(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=S;function f(a){if(w(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=f;function p(...a){const i=[];for(let s=0;s<a.length;s++){const l=a[s];if(w(l))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(l)}return i}e.assertAllDefined=p;const v=Object.prototype.hasOwnProperty;function o(a){if(!n(a))return!1;for(const i in a)if(v.call(a,i))return!1;return!0}e.isEmptyObject=o;function d(a){return typeof a=="function"}e.isFunction=d;function m(...a){return a.length>0&&a.every(d)}e.areFunctions=m;function C(a,i){const s=Math.min(a.length,i.length);for(let l=0;l<s;l++)I(a[l],i[l])}e.validateConstraints=C;function I(a,i){if(E(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(d(i)){try{if(a instanceof i)return}catch{}if(!w(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=I;function R(a){return a===null?void 0:a}e.withNullAsUndefined=R;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(ee[132],te([0,1,10]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const D=Object.create(null);function n(P,g){if((0,E.isString)(g)){const h=D[g];if(h===void 0)throw new Error(`${P} references an unknown codicon: ${g}`);g=h}return D[P]=g,{id:P}}function M(){return D}e.getCodiconFontCharacters=M;function k(){return Object.values(e.Codicon)}e.getAllCodicons=k,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(ee[40],te([0,1,10]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([C,I])=>{m[C]=I&&typeof I=="object"?D(I):I}),m}e.deepClone=D;function n(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const C=m.shift();Object.freeze(C);for(const I in C)if(M.call(C,I)){const R=C[I];typeof R=="object"&&!Object.isFrozen(R)&&!(0,E.isTypedArray)(R)&&m.push(R)}}return d}e.deepFreeze=n;const M=Object.prototype.hasOwnProperty;function k(d,m){return P(d,m,new Set)}e.cloneAndChange=k;function P(d,m,C){if((0,E.isUndefinedOrNull)(d))return d;const I=m(d);if(typeof I<"u")return I;if(Array.isArray(d)){const R=[];for(const t of d)R.push(P(t,m,C));return R}if((0,E.isObject)(d)){if(C.has(d))throw new Error("Cannot clone recursive data-structure");C.add(d);const R={};for(const t in d)M.call(d,t)&&(R[t]=P(d[t],m,C));return C.delete(d),R}return d}function g(d,m,C=!0){return(0,E.isObject)(d)?((0,E.isObject)(m)&&Object.keys(m).forEach(I=>{I in d?C&&((0,E.isObject)(d[I])&&(0,E.isObject)(m[I])?g(d[I],m[I],C):d[I]=m[I]):d[I]=m[I]}),d):m}e.mixin=g;function h(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let C,I;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(C=0;C<d.length;C++)if(!h(d[C],m[C]))return!1}else{const R=[];for(I in d)R.push(I);R.sort();const t=[];for(I in m)t.push(I);if(t.sort(),!h(R,t))return!1;for(C=0;C<R.length;C++)if(!h(d[R[C]],m[R[C]]))return!1}return!0}e.equals=h;function y(d){const m=new Set;return JSON.stringify(d,(C,I)=>{if((0,E.isObject)(I)||Array.isArray(I)){if(m.has(I))return"[Circular]";m.add(I)}return I})}e.safeStringify=y;function w(d,m){const C=Object.create(null);return!d||!m||Object.keys(m).forEach(R=>{const t=d[R],a=m[R];h(t,a)||(C[R]=a)}),C}e.distinct=w;function S(d,m){const C=m.toLowerCase(),I=Object.keys(d).find(R=>R.toLowerCase()===C);return I?d[I]:d[m]}e.getCaseInsensitive=S;function f(d,m){const C=Object.create(null);for(const[I,R]of Object.entries(d))m(I,R)&&(C[I]=R);return C}e.filter=f;function p(d){let m=[],C=Object.getPrototypeOf(d);for(;Object.prototype!==C;)m=m.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return m}e.getAllPropertyNames=p;function v(d){const m=[];for(const C of p(d))typeof d[C]=="function"&&m.push(C);return m}e.getAllMethodNames=v;function o(d,m){const C=R=>function(){const t=Array.prototype.slice.call(arguments,0);return m(R,t)},I={};for(const R of d)I[R]=C(R);return I}e.createProxyObject=o}),define(ee[133],te([0,1,132]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var D;(function(k){function P(g){return g&&typeof g=="object"&&typeof g.id=="string"}k.isThemeColor=P})(D=e.ThemeColor||(e.ThemeColor={}));function n(k){return{id:k}}e.themeColorFromId=n;var M;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function g(m){const C=P.exec(m.id);if(!C)return g(E.Codicon.error);const[,I,R]=C,t=["codicon","codicon-"+I];return R&&t.push("codicon-modifier-"+R.substring(1)),t}k.asClassNameArray=g;function h(m){return g(m).join(" ")}k.asClassName=h;function y(m){return"."+g(m).join(".")}k.asCSSSelector=y;function w(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||D.isThemeColor(m.color))}k.isThemeIcon=w;const S=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function f(m){const C=S.exec(m);if(!C)return;const[,I]=C;return{id:I}}k.fromString=f;function p(m){return{id:m}}k.fromId=p;function v(m,C){let I=m.id;const R=I.lastIndexOf("~");return R!==-1&&(I=I.substring(0,R)),C&&(I=`${I}~${C}`),{id:I}}k.modify=v;function o(m){const C=m.id.lastIndexOf("~");if(C!==-1)return m.id.substring(C+1)}k.getModifier=o;function d(m,C){return m.id===C.id&&m.color?.id===C.color?.id}k.isEqual=d})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(ee[31],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(n){return E.test(n)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(P){for(let g=0;g<P.length;g++)P[g]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),k=[];for(let P=0;P<256;P++)k.push(P.toString(16).padStart(2,"0"));return function(){n(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let g=0,h="";return h+=k[M[g++]],h+=k[M[g++]],h+=k[M[g++]],h+=k[M[g++]],h+="-",h+=k[M[g++]],h+=k[M[g++]],h+="-",h+=k[M[g++]],h+=k[M[g++]],h+="-",h+=k[M[g++]],h+=k[M[g++]],h+="-",h+=k[M[g++]],h+=k[M[g++]],h+=k[M[g++]],h+=k[M[g++]],h+=k[M[g++]],h+=k[M[g++]],h}}()}),define(ee[134],te([0,1,80,41,50]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(k,P){if(await new Promise((y,w)=>{const S=D.createReadStream(k),f=E.createHash("sha1");S.pipe(f);const p=(0,n.once)((v,o)=>{S.removeAllListeners(),f.removeAllListeners(),v?w(v):y(o)});S.once("error",p),S.once("end",p),f.once("error",p),f.once("data",v=>p(void 0,v.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=M}),define(ee[135],te([0,1,26]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(k){const P=k.replace(/\-/g,":").toLowerCase();return!D.has(P)}function M(){const k=(0,E.networkInterfaces)();for(const P in k){const g=k[P];if(g){for(const{mac:h}of g)if(n(h))return h}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=M}),define(ee[100],te([0,1,81]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function D(P,g,h,y=1){let w=!1;return new Promise(S=>{const f=setTimeout(()=>{if(!w)return w=!0,S(0)},h);n(P,g,y,p=>{if(!w)return w=!0,clearTimeout(f),S(p)})})}e.findFreePort=D;function n(P,g,h,y){if(g===0)return y(0);const w=new E.Socket;w.once("connect",()=>(k(w),n(P+h,g-1,h,y))),w.once("data",()=>{}),w.once("error",S=>(k(w),S.code!=="ECONNREFUSED"?n(P+h,g-1,h,y):y(P))),w.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,g,h,y="127.0.0.1"){let w=!1,S,f=1;const p=E.createServer({pauseOnConnect:!0});function v(o,d){w||(w=!0,p.removeAllListeners(),p.close(),S&&clearTimeout(S),d(o))}return new Promise(o=>{S=setTimeout(()=>{v(0,o)},h),p.on("listening",()=>{v(P,o)}),p.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&f<g?(P++,f++,p.listen(P,y)):v(0,o)}),p.on("close",()=>{v(0,o)}),p.listen(P,y)})}e.findFreePortFaster=M;function k(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(g){console.error(g)}}}),define(ee[136],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[137],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(n,M){this.sender=n,this.onMessage=M}send(n){try{this.sender.send("vscode:message",n.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=E}),define(ee[42],te([0,1,15,13]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.mapListenerToWrapper=new WeakMap}on(k,P){const g=(h,...y)=>{this.validateEvent(k,h)&&P(h,...y)};return this.mapListenerToWrapper.set(P,g),E.ipcMain.on(k,g),this}once(k,P){return E.ipcMain.once(k,(g,...h)=>{this.validateEvent(k,g)&&P(g,...h)}),this}handle(k,P){return E.ipcMain.handle(k,(g,...h)=>this.validateEvent(k,g)?P(g,...h):Promise.reject(`Invalid channel '${k}' or sender for ipcMain.handle() usage.`)),this}removeHandler(k){return E.ipcMain.removeHandler(k),this}removeListener(k,P){const g=this.mapListenerToWrapper.get(P);return g&&(E.ipcMain.removeListener(k,g),this.mapListenerToWrapper.delete(P)),this}validateEvent(k,P){if(!k||!k.startsWith("vscode:"))return(0,D.onUnexpectedError)(`Refused to handle ipcMain event for channel '${k}' because the channel is unknown.`),!1;const g=P.senderFrame,h=g.url;if(!h)return!0;let y="unknown";try{y=new URL(h).host}catch{return(0,D.onUnexpectedError)(`Refused to handle ipcMain event for channel '${k}' because of a malformed URL '${h}'.`),!1}return y!=="vscode-app"?((0,D.onUnexpectedError)(`Refused to handle ipcMain event for channel '${k}' because of a bad origin of '${y}'.`),!1):g.parent!==null?((0,D.onUnexpectedError)(`Refused to handle ipcMain event for channel '${k}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(ee[138],te([0,1,15,42,10,136]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function k(){D.validatedIpcMain.on(M.CONTEXT_MENU_CHANNEL,(g,h,y,w,S)=>{const f=P(g,w,y);f.popup({window:(0,n.withNullAsUndefined)(E.BrowserWindow.fromWebContents(g.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{f&&g.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=k;function P(g,h,y){const w=new E.Menu;return y.forEach(S=>{let f;S.type==="separator"?f=new E.MenuItem({type:S.type}):Array.isArray(S.submenu)?f=new E.MenuItem({submenu:P(g,h,S.submenu),label:S.label}):f=new E.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(p,v,o)=>g.sender.send(h,S.id,o)}),w.append(f)}),w}}),define(ee[101],te([0,1,15]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=E.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(ee[139],te([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(ee[140],te([0,1,139]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,n=D*60,M=n*24,k=M*7,P=M*30,g=M*365;function h(w,S,f,p){typeof w!="number"&&(w=w.getTime());const v=Math.round((new Date().getTime()-w)/1e3);if(v<-30)return(0,E.localize)(0,null,h(new Date().getTime()+v*1e3,!1));if(!p&&v<30)return(0,E.localize)(1,null);let o;return v<D?(o=v,S?o===1?f?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):f?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?f?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):f?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):v<n?(o=Math.floor(v/D),S?o===1?f?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):f?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?f?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):f?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):v<M?(o=Math.floor(v/n),S?o===1?f?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):f?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?f?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):f?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):v<k?(o=Math.floor(v/M),S?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):v<P?(o=Math.floor(v/k),S?o===1?f?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):f?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?f?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):f?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):v<g?(o=Math.floor(v/P),S?o===1?f?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):f?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?f?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):f?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(v/g),S?o===1?f?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):f?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?f?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):f?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.fromNow=h;function y(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(ee[141],te([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(ee[44],te([0,1,25,10,141]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(w,S){return S&&(w.stack||w.stacktrace)?n.localize(0,null,P(w),k(w.stack)||k(w.stacktrace)):P(w)}function k(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?n.localize(1,null,w.message):w.message||n.localize(2,null)}function g(w=null,S=!1){if(!w)return n.localize(3,null);if(Array.isArray(w)){const f=E.coalesce(w),p=g(f[0],S);return f.length>1?n.localize(4,null,p,f.length):p}if(D.isString(w))return w;if(w.detail){const f=w.detail;if(f.error)return M(f.error,S);if(f.exception)return M(f.exception,S)}return w.stack?M(w,S):w.message?w.message:n.localize(5,null)}e.toErrorMessage=g;function h(w){const S=w;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=h;function y(w,S){let f;return typeof w=="string"?f=new Error(w):f=w,f.actions=S,f}e.createErrorWithActions=y}),define(ee[142],te([12,11]),function(j,e){return j.create("vs/base/common/jsonErrorMessages",e)}),define(ee[143],te([0,1,142]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(n){switch(n){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=D}),define(ee[144],te([12,11]),function(j,e){return j.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,144]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let D=!1,n=!1,M=!1,k=!1,P=!1,g=!1,h=!1,y=!1,w=!1,S=!1,f,p=e.LANGUAGE_DEFAULT,v,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const m=typeof d?.versions?.electron=="string",C=m&&d?.type==="renderer";if(typeof navigator=="object"&&!C)o=navigator.userAgent,D=o.indexOf("Windows")>=0,n=o.indexOf("Macintosh")>=0,y=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=o.indexOf("Linux")>=0,S=o?.indexOf("Mobi")>=0,g=!0,f=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,p=f;else if(typeof d=="object"){D=d.platform==="win32",n=d.platform==="darwin",M=d.platform==="linux",k=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,h=m,w=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const c=JSON.parse(r),b=c.availableLanguages["*"];f=c.locale,p=b||e.LANGUAGE_DEFAULT,v=c._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var I;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function R(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=R;let t=0;n?t=1:D?t=3:M&&(t=2),e.isWindows=D,e.isMacintosh=n,e.isLinux=M,e.isLinuxSnap=k,e.isNative=P,e.isElectron=h,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=S,e.isCI=w,e.platform=t,e.userAgent=o,e.language=p;var a;(function(r){function c(){return e.language}r.value=c;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=b;function L(){return e.language==="en"}r.isDefault=L})(a=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let L=0,T=r.length;L<T;L++){const F=r[L];if(F.id===b.data.vscodeScheduleAsyncWork){r.splice(L,1),F.callback();return}}});let c=0;return b=>{const L=++c;r.push({id:L,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return r=>setTimeout(r)})();var i;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=n||y?2:D?1:3;let s=!0,l=!1;function u(){if(!l){l=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,s=new Uint16Array(r.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let D;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const n=E.globals.vscode.process;D={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.arch=D.arch}),define(ee[9],te([0,1,36]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,n=97,M=90,k=122,P=46,g=47,h=92,y=58,w=63;class S extends Error{constructor(a,i,s){let l;typeof i=="string"&&i.indexOf("not ")===0?(l="must not be",i=i.replace(/^not /,"")):l="must be";const u=a.indexOf(".")!==-1?"property":"argument";let r=`The "${a}" ${u} ${l} of type ${i}`;r+=`. Received type ${typeof s}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,a){if(t===null||typeof t!="object")throw new S(a,"Object",t)}function p(t,a){if(typeof t!="string")throw new S(a,"string",t)}const v=E.platform==="win32";function o(t){return t===g||t===h}function d(t){return t===g}function m(t){return t>=D&&t<=M||t>=n&&t<=k}function C(t,a,i,s){let l="",u=0,r=-1,c=0,b=0;for(let L=0;L<=t.length;++L){if(L<t.length)b=t.charCodeAt(L);else{if(s(b))break;b=g}if(s(b)){if(!(r===L-1||c===1))if(c===2){if(l.length<2||u!==2||l.charCodeAt(l.length-1)!==P||l.charCodeAt(l.length-2)!==P){if(l.length>2){const T=l.lastIndexOf(i);T===-1?(l="",u=0):(l=l.slice(0,T),u=l.length-1-l.lastIndexOf(i)),r=L,c=0;continue}else if(l.length!==0){l="",u=0,r=L,c=0;continue}}a&&(l+=l.length>0?`${i}..`:"..",u=2)}else l.length>0?l+=`${i}${t.slice(r+1,L)}`:l=t.slice(r+1,L),u=L-r-1;r=L,c=0}else b===P&&c!==-1?++c:c=-1}return l}function I(t,a){f(a,"pathObject");const i=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${s}`:`${i}${t}${s}`:s}e.win32={resolve(...t){let a="",i="",s=!1;for(let l=t.length-1;l>=-1;l--){let u;if(l>=0){if(u=t[l],p(u,"path"),u.length===0)continue}else a.length===0?u=E.cwd():(u=E.env[`=${a}`]||E.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==a.toLowerCase()&&u.charCodeAt(2)===h)&&(u=`${a}\\`));const r=u.length;let c=0,b="",L=!1;const T=u.charCodeAt(0);if(r===1)o(T)&&(c=1,L=!0);else if(o(T))if(L=!0,o(u.charCodeAt(1))){let F=2,Y=F;for(;F<r&&!o(u.charCodeAt(F));)F++;if(F<r&&F!==Y){const V=u.slice(Y,F);for(Y=F;F<r&&o(u.charCodeAt(F));)F++;if(F<r&&F!==Y){for(Y=F;F<r&&!o(u.charCodeAt(F));)F++;(F===r||F!==Y)&&(b=`\\\\${V}\\${u.slice(Y,F)}`,c=F)}}}else c=1;else m(T)&&u.charCodeAt(1)===y&&(b=u.slice(0,2),c=2,r>2&&o(u.charCodeAt(2))&&(L=!0,c=3));if(b.length>0)if(a.length>0){if(b.toLowerCase()!==a.toLowerCase())continue}else a=b;if(s){if(a.length>0)break}else if(i=`${u.slice(c)}\\${i}`,s=L,L&&a.length>0)break}return i=C(i,!s,"\\",o),s?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){p(t,"path");const a=t.length;if(a===0)return".";let i=0,s,l=!1;const u=t.charCodeAt(0);if(a===1)return d(u)?"\\":t;if(o(u))if(l=!0,o(t.charCodeAt(1))){let c=2,b=c;for(;c<a&&!o(t.charCodeAt(c));)c++;if(c<a&&c!==b){const L=t.slice(b,c);for(b=c;c<a&&o(t.charCodeAt(c));)c++;if(c<a&&c!==b){for(b=c;c<a&&!o(t.charCodeAt(c));)c++;if(c===a)return`\\\\${L}\\${t.slice(b)}\\`;c!==b&&(s=`\\\\${L}\\${t.slice(b,c)}`,i=c)}}}else i=1;else m(u)&&t.charCodeAt(1)===y&&(s=t.slice(0,2),i=2,a>2&&o(t.charCodeAt(2))&&(l=!0,i=3));let r=i<a?C(t.slice(i),!l,"\\",o):"";return r.length===0&&!l&&(r="."),r.length>0&&o(t.charCodeAt(a-1))&&(r+="\\"),s===void 0?l?`\\${r}`:r:l?`${s}\\${r}`:`${s}${r}`},isAbsolute(t){p(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return o(i)||a>2&&m(i)&&t.charCodeAt(1)===y&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let u=0;u<t.length;++u){const r=t[u];p(r,"path"),r.length>0&&(a===void 0?a=i=r:a+=`\\${r}`)}if(a===void 0)return".";let s=!0,l=0;if(typeof i=="string"&&o(i.charCodeAt(0))){++l;const u=i.length;u>1&&o(i.charCodeAt(1))&&(++l,u>2&&(o(i.charCodeAt(2))?++l:s=!1))}if(s){for(;l<a.length&&o(a.charCodeAt(l));)l++;l>=2&&(a=`\\${a.slice(l)}`)}return e.win32.normalize(a)},relative(t,a){if(p(t,"from"),p(a,"to"),t===a)return"";const i=e.win32.resolve(t),s=e.win32.resolve(a);if(i===s||(t=i.toLowerCase(),a=s.toLowerCase(),t===a))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===h;)l++;let u=t.length;for(;u-1>l&&t.charCodeAt(u-1)===h;)u--;const r=u-l;let c=0;for(;c<a.length&&a.charCodeAt(c)===h;)c++;let b=a.length;for(;b-1>c&&a.charCodeAt(b-1)===h;)b--;const L=b-c,T=r<L?r:L;let F=-1,Y=0;for(;Y<T;Y++){const G=t.charCodeAt(l+Y);if(G!==a.charCodeAt(c+Y))break;G===h&&(F=Y)}if(Y!==T){if(F===-1)return s}else{if(L>T){if(a.charCodeAt(c+Y)===h)return s.slice(c+Y+1);if(Y===2)return s.slice(c+Y)}r>T&&(t.charCodeAt(l+Y)===h?F=Y:Y===2&&(F=3)),F===-1&&(F=0)}let V="";for(Y=l+F+1;Y<=u;++Y)(Y===u||t.charCodeAt(Y)===h)&&(V+=V.length===0?"..":"\\..");return c+=F,V.length>0?`${V}${s.slice(c,b)}`:(s.charCodeAt(c)===h&&++c,s.slice(c,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===h){if(a.charCodeAt(1)===h){const i=a.charCodeAt(2);if(i!==w&&i!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(m(a.charCodeAt(0))&&a.charCodeAt(1)===y&&a.charCodeAt(2)===h)return`\\\\?\\${a}`;return t},dirname(t){p(t,"path");const a=t.length;if(a===0)return".";let i=-1,s=0;const l=t.charCodeAt(0);if(a===1)return o(l)?t:".";if(o(l)){if(i=s=1,o(t.charCodeAt(1))){let c=2,b=c;for(;c<a&&!o(t.charCodeAt(c));)c++;if(c<a&&c!==b){for(b=c;c<a&&o(t.charCodeAt(c));)c++;if(c<a&&c!==b){for(b=c;c<a&&!o(t.charCodeAt(c));)c++;if(c===a)return t;c!==b&&(i=s=c+1)}}}}else m(l)&&t.charCodeAt(1)===y&&(i=a>2&&o(t.charCodeAt(2))?3:2,s=i);let u=-1,r=!0;for(let c=a-1;c>=s;--c)if(o(t.charCodeAt(c))){if(!r){u=c;break}}else r=!1;if(u===-1){if(i===-1)return".";u=i}return t.slice(0,u)},basename(t,a){a!==void 0&&p(a,"ext"),p(t,"path");let i=0,s=-1,l=!0,u;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let r=a.length-1,c=-1;for(u=t.length-1;u>=i;--u){const b=t.charCodeAt(u);if(o(b)){if(!l){i=u+1;break}}else c===-1&&(l=!1,c=u+1),r>=0&&(b===a.charCodeAt(r)?--r===-1&&(s=u):(r=-1,s=c))}return i===s?s=c:s===-1&&(s=t.length),t.slice(i,s)}for(u=t.length-1;u>=i;--u)if(o(t.charCodeAt(u))){if(!l){i=u+1;break}}else s===-1&&(l=!1,s=u+1);return s===-1?"":t.slice(i,s)},extname(t){p(t,"path");let a=0,i=-1,s=0,l=-1,u=!0,r=0;t.length>=2&&t.charCodeAt(1)===y&&m(t.charCodeAt(0))&&(a=s=2);for(let c=t.length-1;c>=a;--c){const b=t.charCodeAt(c);if(o(b)){if(!u){s=c+1;break}continue}l===-1&&(u=!1,l=c+1),b===P?i===-1?i=c:r!==1&&(r=1):i!==-1&&(r=-1)}return i===-1||l===-1||r===0||r===1&&i===l-1&&i===s+1?"":t.slice(i,l)},format:I.bind(null,"\\"),parse(t){p(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let s=0,l=t.charCodeAt(0);if(i===1)return o(l)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(o(l)){if(s=1,o(t.charCodeAt(1))){let F=2,Y=F;for(;F<i&&!o(t.charCodeAt(F));)F++;if(F<i&&F!==Y){for(Y=F;F<i&&o(t.charCodeAt(F));)F++;if(F<i&&F!==Y){for(Y=F;F<i&&!o(t.charCodeAt(F));)F++;F===i?s=F:F!==Y&&(s=F+1)}}}}else if(m(l)&&t.charCodeAt(1)===y){if(i<=2)return a.root=a.dir=t,a;if(s=2,o(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;s=3}}s>0&&(a.root=t.slice(0,s));let u=-1,r=s,c=-1,b=!0,L=t.length-1,T=0;for(;L>=s;--L){if(l=t.charCodeAt(L),o(l)){if(!b){r=L+1;break}continue}c===-1&&(b=!1,c=L+1),l===P?u===-1?u=L:T!==1&&(T=1):u!==-1&&(T=-1)}return c!==-1&&(u===-1||T===0||T===1&&u===c-1&&u===r+1?a.base=a.name=t.slice(r,c):(a.name=t.slice(r,u),a.base=t.slice(r,c),a.ext=t.slice(u,c))),r>0&&r!==s?a.dir=t.slice(0,r-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(v){const t=/\\/g;return()=>{const a=E.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let s=t.length-1;s>=-1&&!i;s--){const l=s>=0?t[s]:R();p(l,"path"),l.length!==0&&(a=`${l}/${a}`,i=l.charCodeAt(0)===g)}return a=C(a,!i,"/",d),i?`/${a}`:a.length>0?a:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===g,i=t.charCodeAt(t.length-1)===g;return t=C(t,!a,"/",d),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===g},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const s=t[i];p(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(p(t,"from"),p(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,s=t.length,l=s-i,u=1,r=a.length-u,c=l<r?l:r;let b=-1,L=0;for(;L<c;L++){const F=t.charCodeAt(i+L);if(F!==a.charCodeAt(u+L))break;F===g&&(b=L)}if(L===c)if(r>c){if(a.charCodeAt(u+L)===g)return a.slice(u+L+1);if(L===0)return a.slice(u+L)}else l>c&&(t.charCodeAt(i+L)===g?b=L:L===0&&(b=0));let T="";for(L=i+b+1;L<=s;++L)(L===s||t.charCodeAt(L)===g)&&(T+=T.length===0?"..":"/..");return`${T}${a.slice(u+b)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===g;let i=-1,s=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===g){if(!s){i=l;break}}else s=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&p(a,"ext"),p(t,"path");let i=0,s=-1,l=!0,u;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let r=a.length-1,c=-1;for(u=t.length-1;u>=0;--u){const b=t.charCodeAt(u);if(b===g){if(!l){i=u+1;break}}else c===-1&&(l=!1,c=u+1),r>=0&&(b===a.charCodeAt(r)?--r===-1&&(s=u):(r=-1,s=c))}return i===s?s=c:s===-1&&(s=t.length),t.slice(i,s)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===g){if(!l){i=u+1;break}}else s===-1&&(l=!1,s=u+1);return s===-1?"":t.slice(i,s)},extname(t){p(t,"path");let a=-1,i=0,s=-1,l=!0,u=0;for(let r=t.length-1;r>=0;--r){const c=t.charCodeAt(r);if(c===g){if(!l){i=r+1;break}continue}s===-1&&(l=!1,s=r+1),c===P?a===-1?a=r:u!==1&&(u=1):a!==-1&&(u=-1)}return a===-1||s===-1||u===0||u===1&&a===s-1&&a===i+1?"":t.slice(a,s)},format:I.bind(null,"/"),parse(t){p(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===g;let s;i?(a.root="/",s=1):s=0;let l=-1,u=0,r=-1,c=!0,b=t.length-1,L=0;for(;b>=s;--b){const T=t.charCodeAt(b);if(T===g){if(!c){u=b+1;break}continue}r===-1&&(c=!1,r=b+1),T===P?l===-1?l=b:L!==1&&(L=1):l!==-1&&(L=-1)}if(r!==-1){const T=u===0&&i?1:u;l===-1||L===0||L===1&&l===r-1&&l===u+1?a.base=a.name=t.slice(T,r):(a.name=t.slice(T,l),a.base=t.slice(T,r),a.ext=t.slice(l,r))}return u>0?a.dir=t.slice(0,u-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(ee[82],te([0,1,4]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var n;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(P,...g){const h=g.reduce((S,f)=>(S[f]=!0,S),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(S=>!h[S]).forEach(S=>{for(let f=0;f<y.length;f++)if(S.search(y[f])!==-1){delete P[S];break}})}e.sanitizeProcessEnvironment=M;function k(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(ee[71],te([0,1,4]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=E.globals.performance&&typeof E.globals.performance.now=="function";class n{static create(k=!0){return new n(k)}constructor(k){this._highResolution=D&&k,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=n}),define(ee[3],te([0,1,13,50,2,99,71]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,g=!1;var h;(function(u){u.None=()=>n.Disposable.None;function r(_){if(g){const{onDidAddListener:N}=_,q=p.create();let U=0;_.onDidAddListener=()=>{++U===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),q.print()),N?.()}}}function c(_,N){return re(_,()=>{},0,void 0,void 0,N)}u.defer=c;function b(_){return(N,q=null,U)=>{let $=!1,H;return H=_(oe=>{if(!$)return H?H.dispose():$=!0,N.call(q,oe)},null,U),$&&H.dispose(),H}}u.once=b;function L(_,N,q){return ie((U,$=null,H)=>_(oe=>U.call($,N(oe)),null,H),q)}u.map=L;function T(_,N,q){return ie((U,$=null,H)=>_(oe=>{N(oe),U.call($,oe)},null,H),q)}u.forEach=T;function F(_,N,q){return ie((U,$=null,H)=>_(oe=>N(oe)&&U.call($,oe),null,H),q)}u.filter=F;function Y(_){return _}u.signal=Y;function V(..._){return(N,q=null,U)=>(0,n.combinedDisposable)(..._.map($=>$(H=>N.call(q,H),null,U)))}u.any=V;function G(_,N,q,U){let $=q;return L(_,H=>($=N($,H),$),U)}u.reduce=G;function ie(_,N){let q;const U={onWillAddFirstListener(){q=_($.fire,$)},onDidRemoveLastListener(){q?.dispose()}};N||r(U);const $=new o(U);return N?.add($),$.event}function re(_,N,q=100,U=!1,$,H){let oe,fe,pe,ye=0;const Le={leakWarningThreshold:$,onWillAddFirstListener(){oe=_(Oe=>{ye++,fe=N(fe,Oe),U&&!pe&&(_e.fire(fe),fe=void 0);const ve=()=>{const Me=fe;fe=void 0,pe=void 0,(!U||ye>1)&&_e.fire(Me),ye=0};typeof q=="number"?(clearTimeout(pe),pe=setTimeout(ve,q)):pe===void 0&&(pe=0,queueMicrotask(ve))})},onDidRemoveLastListener(){oe.dispose()}};H||r(Le);const _e=new o(Le);return H?.add(_e),_e.event}u.debounce=re;function de(_,N=0,q){return u.debounce(_,(U,$)=>U?(U.push($),U):[$],N,void 0,void 0,q)}u.accumulate=de;function ce(_,N=(U,$)=>U===$,q){let U=!0,$;return F(_,H=>{const oe=U||!N(H,$);return U=!1,$=H,oe},q)}u.latch=ce;function ge(_,N,q){return[u.filter(_,N,q),u.filter(_,U=>!N(U),q)]}u.split=ge;function x(_,N=!1,q=[]){let U=q.slice(),$=_(fe=>{U?U.push(fe):oe.fire(fe)});const H=()=>{U?.forEach(fe=>oe.fire(fe)),U=null},oe=new o({onWillAddFirstListener(){$||($=_(fe=>oe.fire(fe)))},onDidAddFirstListener(){U&&(N?setTimeout(H):H())},onDidRemoveLastListener(){$&&$.dispose(),$=null}});return oe.event}u.buffer=x;class B{constructor(N){this.event=N,this.disposables=new n.DisposableStore}map(N){return new B(L(this.event,N,this.disposables))}forEach(N){return new B(T(this.event,N,this.disposables))}filter(N){return new B(F(this.event,N,this.disposables))}reduce(N,q){return new B(G(this.event,N,q,this.disposables))}latch(){return new B(ce(this.event,void 0,this.disposables))}debounce(N,q=100,U=!1,$){return new B(re(this.event,N,q,U,$,this.disposables))}on(N,q,U){return this.event(N,q,U)}once(N,q,U){return b(this.event)(N,q,U)}dispose(){this.disposables.dispose()}}function O(_){return new B(_)}u.chain=O;function z(_,N,q=U=>U){const U=(...fe)=>oe.fire(q(...fe)),$=()=>_.on(N,U),H=()=>_.removeListener(N,U),oe=new o({onWillAddFirstListener:$,onDidRemoveLastListener:H});return oe.event}u.fromNodeEventEmitter=z;function K(_,N,q=U=>U){const U=(...fe)=>oe.fire(q(...fe)),$=()=>_.addEventListener(N,U),H=()=>_.removeEventListener(N,U),oe=new o({onWillAddFirstListener:$,onDidRemoveLastListener:H});return oe.event}u.fromDOMEventEmitter=K;function ne(_){return new Promise(N=>b(_)(N))}u.toPromise=ne;function se(_,N){return N(void 0),_(q=>N(q))}u.runAndSubscribe=se;function J(_,N){let q=null;function U(H){q?.dispose(),q=new n.DisposableStore,N(H,q)}U(void 0);const $=_(H=>U(H));return(0,n.toDisposable)(()=>{$.dispose(),q?.dispose()})}u.runAndSubscribeWithStore=J;class W{constructor(N,q){this.obs=N,this._counter=0,this._hasChanged=!1;const U={onWillAddFirstListener:()=>{N.addObserver(this)},onDidRemoveLastListener:()=>{N.removeObserver(this)}};q||r(U),this.emitter=new o(U),q&&q.add(this.emitter)}beginUpdate(N){this._counter++}handleChange(N,q){this._hasChanged=!0}endUpdate(N){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function A(_,N){return new W(_,N).emitter.event}u.fromObservable=A})(h=e.Event||(e.Event={}));class y{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${y._idPool++}`,y.all.add(this)}start(r){this._stopWatch=new k.StopWatch(!0),this.listenerCount=r}stop(){if(this._stopWatch){const r=this._stopWatch.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this._stopWatch=void 0}}}y.all=new Set,y._idPool=0,e.EventProfiling=y;let w=-1;function S(u){const r=w;return w=u,{dispose(){w=r}}}e.setGlobalLeakWarningThreshold=S;class f{constructor(r,c=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=c,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(r,c){const b=this.threshold;if(b<=0||c<b)return;this._stacks||(this._stacks=new Map);const L=this._stacks.get(r.value)||0;if(this._stacks.set(r.value,L+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=b*.5;let T,F=0;for(const[Y,V]of this._stacks)(!T||F<V)&&(T=Y,F=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${F}):`),console.warn(T)}return()=>{const T=this._stacks.get(r.value)||0;this._stacks.set(r.value,T-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(r,c,b){this.callback=r,this.callbackThis=c,this.stack=b,this.subscription=new n.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class o{constructor(r){this._disposed=!1,this._options=r,this._leakageMon=w>0||this._options?.leakWarningThreshold?new f(this._options?.leakWarningThreshold??w):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const r=Array.from(this._listeners);queueMicrotask(()=>{for(const c of r)c.subscription.isset()&&(c.subscription.unset(),c.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(r,c,b)=>{if(this._listeners||(this._listeners=new M.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;const L=this._listeners.isEmpty();L&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let T,F;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(F=p.create(),T=this._leakageMon.check(F,this._listeners.size+1)),P&&(F=F??p.create());const Y=new v(r,c,F),V=this._listeners.push(Y);L&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,r,c);const G=Y.subscription.set(()=>{T?.(),this._disposed||(V(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return b instanceof n.DisposableStore?b.add(G):Array.isArray(b)&&b.push(G),G}),this._event}fire(r){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const c of this._listeners)this._deliveryQueue.push(this,c,r);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=o;class d{constructor(){this._queue=new M.LinkedList}get size(){return this._queue.size}push(r,c,b){this._queue.push(new C(r,c,b))}clear(r){const c=new M.LinkedList;for(const b of this._queue)b.emitter!==r&&c.push(b);this._queue=c}deliver(){for(;this._queue.size>0;){const r=this._queue.shift();try{r.listener.invoke(r.event)}catch(c){(0,E.onUnexpectedError)(c)}}}}e.EventDeliveryQueue=d;class m extends d{clear(r){this._queue.clear()}}class C{constructor(r,c,b){this.emitter=r,this.listener=c,this.event=b}}class I extends o{async fireAsync(r,c,b){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const L of this._listeners)this._asyncDeliveryQueue.push([L,r]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[L,T]=this._asyncDeliveryQueue.shift(),F=[],Y={...T,token:c,waitUntil:V=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");b&&(V=b(V,L.callback)),F.push(V)}};try{L.invoke(Y)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(F),await Promise.allSettled(F).then(V=>{for(const G of V)G.status==="rejected"&&(0,E.onUnexpectedError)(G.reason)})}}}}e.AsyncEmitter=I;class R extends o{constructor(r){super(r),this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=r?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const r=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(r))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(r){this._listeners&&(this._isPaused!==0?this._eventQueue.push(r):super.fire(r))}}e.PauseableEmitter=R;class t extends R{constructor(r){super(r),this._delay=r.delay??100}fire(r){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(r)}}e.DebounceEmitter=t;class a extends o{constructor(r){super(r),this._queuedEvents=[],this._mergeFn=r?.merge}fire(r){!this.hasListeners()||(this._queuedEvents.push(r),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(c=>super.fire(c)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(r){const c={event:r,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const b=()=>{this.hasListeners&&this.unhook(c);const L=this.events.indexOf(c);this.events.splice(L,1)};return(0,n.toDisposable)((0,D.once)(b))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(r=>this.hook(r))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(r=>this.unhook(r))}hook(r){r.listener=r.event(c=>this.emitter.fire(c))}unhook(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.buffers=[]}wrapEvent(r){return(c,b,L)=>r(T=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>c.call(b,T)):c.call(b,T)},void 0,L)}bufferEvents(r){const c=[];this.buffers.push(c);const b=r();return this.buffers.pop(),c.forEach(L=>L()),b}}e.EventBufferer=s;class l{constructor(){this.listening=!1,this.inputEvent=h.None,this.inputEventListener=n.Disposable.None,this.emitter=new o({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(r){this.inputEvent=r,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=r(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(ee[22],te([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(P,g){const h=setTimeout(P.bind(g),0);return{dispose(){clearTimeout(h)}}});var n;(function(P){function g(h){return h===P.None||h===P.Cancelled||h instanceof M?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}P.isCancellationToken=g,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(n=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=n.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=n.None}}e.CancellationTokenSource=k}),define(ee[145],te([0,1,22]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class D{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new E.CancellationTokenSource,g=this.task(P.token);return this.result={promise:g,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=D;class n{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const g=JSON.stringify(P);return this.lastArgKey!==g&&(this.lastArgKey=g,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=n;class M{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const g=this.fn(P);return this._map.set(P,g),g}}e.CachedFunction=M}),define(ee[27],te([0,1,145,128]),function(j,e,E,D){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function M(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=M;const k=/{(\d+)}/g;function P(Q,...le){return le.length===0?Q:Q.replace(k,function(ue,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=le.length?ue:le[be]})}e.format=P;const g=/{([^}]+)}/g;function h(Q,le){return Q.replace(g,(ue,me)=>le[me]??ue)}e.format2=h;function y(Q){return Q.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=y;function w(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function S(Q,le){let ue=0;const me=le.charCodeAt(0);for(let be=Q.length-1;be>=0;be--)Q.charCodeAt(be)===me&&ue++;return ue}e.count=S;function f(Q,le,ue="\u2026"){return Q.length<=le?Q:`${Q.substr(0,le)}${ue}`}e.truncate=f;function p(Q,le=" "){const ue=v(Q,le);return o(ue,le)}e.trim=p;function v(Q,le){if(!Q||!le)return Q;const ue=le.length;if(ue===0||Q.length===0)return Q;let me=0;for(;Q.indexOf(le,me)===me;)me=me+ue;return Q.substring(me)}e.ltrim=v;function o(Q,le){if(!Q||!le)return Q;const ue=le.length,me=Q.length;if(ue===0||me===0)return Q;let be=me,Te=-1;for(;Te=Q.lastIndexOf(le,be-1),!(Te===-1||Te+ue!==be);){if(Te===0)return"";be=Te}return Q.substring(0,be)}e.rtrim=o;function d(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function m(Q){return Q.replace(/\*/g,"")}e.stripWildcards=m;function C(Q,le,ue={}){if(!Q)throw new Error("Cannot create regex from empty string");le||(Q=w(Q)),ue.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(Q,me)}e.createRegExp=C;function I(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function R(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function t(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=t;function a(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Q){for(let le=0,ue=Q.length;le<ue;le++){const me=Q.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function s(Q,le=0,ue=Q.length){for(let me=le;me<ue;me++){const be=Q.charCodeAt(me);if(be!==32&&be!==9)return Q.substring(le,me)}return Q.substring(le,ue)}e.getLeadingWhitespace=s;function l(Q,le=Q.length-1){for(let ue=le;ue>=0;ue--){const me=Q.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=l;function u(Q,le,ue){const me=[];let be=0;for(const Te of Q.matchAll(le)){if(me.push(Q.slice(be,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");be=Te.index+Te[0].length,me.push(ue(Te[0],...Te.slice(1),Te.index,Q,Te.groups))}return me.push(Q.slice(be)),Promise.all(me).then(Te=>Te.join(""))}e.replaceAsync=u;function r(Q,le){return Q<le?-1:Q>le?1:0}e.compare=r;function c(Q,le,ue=0,me=Q.length,be=0,Te=le.length){for(;ue<me&&be<Te;ue++,be++){const Xe=Q.charCodeAt(ue),Ke=le.charCodeAt(be);if(Xe<Ke)return-1;if(Xe>Ke)return 1}const ze=me-ue,tt=Te-be;return ze<tt?-1:ze>tt?1:0}e.compareSubstring=c;function b(Q,le){return L(Q,le,0,Q.length,0,le.length)}e.compareIgnoreCase=b;function L(Q,le,ue=0,me=Q.length,be=0,Te=le.length){for(;ue<me&&be<Te;ue++,be++){let Xe=Q.charCodeAt(ue),Ke=le.charCodeAt(be);if(Xe===Ke)continue;if(Xe>=128||Ke>=128)return c(Q.toLowerCase(),le.toLowerCase(),ue,me,be,Te);F(Xe)&&(Xe-=32),F(Ke)&&(Ke-=32);const et=Xe-Ke;if(et!==0)return et}const ze=me-ue,tt=Te-be;return ze<tt?-1:ze>tt?1:0}e.compareSubstringIgnoreCase=L;function T(Q){return Q>=48&&Q<=57}e.isAsciiDigit=T;function F(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=F;function Y(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=Y;function V(Q,le){return Q.length===le.length&&L(Q,le)===0}e.equalsIgnoreCase=V;function G(Q,le){const ue=le.length;return le.length>Q.length?!1:L(Q,le,0,ue)===0}e.startsWithIgnoreCase=G;function ie(Q,le){const ue=Math.min(Q.length,le.length);let me;for(me=0;me<ue;me++)if(Q.charCodeAt(me)!==le.charCodeAt(me))return me;return ue}e.commonPrefixLength=ie;function re(Q,le){const ue=Math.min(Q.length,le.length);let me;const be=Q.length-1,Te=le.length-1;for(me=0;me<ue;me++)if(Q.charCodeAt(be-me)!==le.charCodeAt(Te-me))return me;return ue}e.commonSuffixLength=re;function de(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=de;function ce(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=ce;function ge(Q,le){return(Q-55296<<10)+(le-56320)+65536}e.computeCodePoint=ge;function x(Q,le,ue){const me=Q.charCodeAt(ue);if(de(me)&&ue+1<le){const be=Q.charCodeAt(ue+1);if(ce(be))return ge(me,be)}return me}e.getNextCodePoint=x;function B(Q,le){const ue=Q.charCodeAt(le-1);if(ce(ue)&&le>1){const me=Q.charCodeAt(le-2);if(de(me))return ge(me,ue)}return ue}class O{get offset(){return this._offset}constructor(le,ue=0){this._str=le,this._len=le.length,this._offset=ue}setOffset(le){this._offset=le}prevCodePoint(){const le=B(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=x(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=O;class z{get offset(){return this._iterator.offset}constructor(le,ue=0){this._iterator=new O(le,ue)}nextGraphemeLength(){const le=Ae.getInstance(),ue=this._iterator,me=ue.offset;let be=le.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Te=ue.offset,ze=le.getGraphemeBreakType(ue.nextCodePoint());if(Ie(be,ze)){ue.setOffset(Te);break}be=ze}return ue.offset-me}prevGraphemeLength(){const le=Ae.getInstance(),ue=this._iterator,me=ue.offset;let be=le.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Te=ue.offset,ze=le.getGraphemeBreakType(ue.prevCodePoint());if(Ie(ze,be)){ue.setOffset(Te);break}be=ze}return me-ue.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function K(Q,le){return new z(Q,le).nextGraphemeLength()}e.nextCharLength=K;function ne(Q,le){return new z(Q,le).prevGraphemeLength()}e.prevCharLength=ne;function se(Q,le){le>0&&ce(Q.charCodeAt(le))&&le--;const ue=le+K(Q,le);return[ue-ne(Q,ue),ue]}e.getCharContainingOffset=se;function J(Q){const le=new z(Q);let ue=0;for(;!le.eol();)ue++,le.nextGraphemeLength();return ue}e.charCount=J;let W;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Q){return W||(W=A()),W.test(Q)}e.containsRTL=_;const N=/^[\t\n\r\x20-\x7E]*$/;function q(Q){return N.test(Q)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function U(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=U;function $(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=$;function H(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=H;function oe(Q,le){if(Q.length<le)return Q;const ue=/\b/g;let me=0;for(;ue.test(Q)&&!(Q.length-ue.lastIndex<le);)me=ue.lastIndex,ue.lastIndex+=1;return Q.substring(me).replace(/^\s/,"")}e.lcut=oe;const fe=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,ye=/\x1b\[0?m/g;function Le(Q){return Q&&(Q=Q.replace(fe,""),Q=Q.replace(pe,""),Q=Q.replace(ye,"")),Q}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=_e;function Oe(Q){return _e(Q)?Q.substr(1):Q}e.stripUTF8BOM=Oe;function ve(Q,le){if(!Q||!le||Q.length<le.length)return!1;const ue=le.length,me=Q.toLowerCase();let be=0,Te=-1;for(;be<ue;){const ze=me.indexOf(le[be],Te+1);if(ze<0)return!1;Te=ze,be++}return!0}e.fuzzyContains=ve;function Me(Q,le=!1){return Q?(le&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Me;function De(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=De;function X(Q,le=1){if(le===0)return"";let ue=-1;do ue=Q.indexOf(`
`,ue+1),le--;while(le>0&&ue>=0);return ue===-1?Q:(Q[ue-1]==="\r"&&ue--,Q.substr(0,ue))}e.getNLines=X;function ae(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=ae;function he(Q){return Ae.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=he;function Ie(Q,le){return Q===0?le!==5&&le!==7:Q===2&&le===3?!1:Q===4||Q===2||Q===3||le===4||le===2||le===3?!0:!(Q===8&&(le===8||le===9||le===11||le===12)||(Q===11||Q===9)&&(le===9||le===10)||(Q===12||Q===10)&&le===10||le===5||le===13||le===7||Q===1||Q===13&&le===14||Q===6&&le===6)}var Re;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(Re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae._INSTANCE||(Ae._INSTANCE=new Ae),Ae._INSTANCE}constructor(){this._data=We()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const ue=this._data,me=ue.length/3;let be=1;for(;be<=me;)if(le<ue[3*be])be=2*be;else if(le>ue[3*be+1])be=2*be+1;else return ue[3*be+2];return 0}}Ae._INSTANCE=null;function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(Q,le){if(Q===0)return 0;const ue=Ue(Q,le);if(ue!==void 0)return ue;const me=new O(le,Q);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=qe;function Ue(Q,le){const ue=new O(le,Q);let me=ue.prevCodePoint();for(;$e(me)||me===65039||me===8419;){if(ue.offset===0)return;me=ue.prevCodePoint()}if(!H(me))return;let be=ue.offset;return be>0&&ue.prevCodePoint()===8205&&(be=ue.offset),be}function $e(Q){return 127995<=Q&&Q<=127999}var Ve;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),e.noBreakWhitespace="\xA0";class Fe{static getInstance(le){return Fe.cache.get(Array.from(le))}static getLocales(){return Fe._locales.value}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n=Fe,Fe.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Fe.cache=new E.LRUCachedFunction(Q=>{function le(Ke){const et=new Map;for(let it=0;it<Ke.length;it+=2)et.set(Ke[it],Ke[it+1]);return et}function ue(Ke,et){const it=new Map(Ke);for(const[ot,ut]of et)it.set(ot,ut);return it}function me(Ke,et){if(!Ke)return et;const it=new Map;for(const[ot,ut]of Ke)et.has(ot)&&it.set(ot,ut);return it}const be=n.ambiguousCharacterData.value;let Te=Q.filter(Ke=>!Ke.startsWith("_")&&Ke in be);Te.length===0&&(Te=["_default"]);let ze;for(const Ke of Te){const et=le(be[Ke]);ze=me(ze,et)}const tt=le(be._common),Xe=ue(tt,ze);return new Fe(Xe)}),Fe._locales=new D.Lazy(()=>Object.keys(Fe.ambiguousCharacterData.value).filter(Q=>!Q.startsWith("_"))),e.AmbiguousCharacters=Fe;class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(le){return je.getData().has(le)}static get codePoints(){return je.getData()}}je._data=void 0,e.InvisibleCharacters=je}),define(ee[32],te([0,1,9,4,27,10]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(l){return l===47||l===92}e.isPathSeparator=k;function P(l){return l.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function g(l){return l.indexOf("/")===-1&&(l=P(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=g;function h(l,u=E.posix.sep){if(!l)return"";const r=l.length,c=l.charCodeAt(0);if(k(c)){if(k(l.charCodeAt(1))&&!k(l.charCodeAt(2))){let L=3;const T=L;for(;L<r&&!k(l.charCodeAt(L));L++);if(T!==L&&!k(l.charCodeAt(L+1))){for(L+=1;L<r;L++)if(k(l.charCodeAt(L)))return l.slice(0,L+1).replace(/[\\/]/g,u)}}return u}else if(d(c)&&l.charCodeAt(1)===58)return k(l.charCodeAt(2))?l.slice(0,2)+u:l.slice(0,2);let b=l.indexOf("://");if(b!==-1){for(b+=3;b<r;b++)if(k(l.charCodeAt(b)))return l.slice(0,b+1)}return""}e.getRoot=h;function y(l){if(!D.isWindows||!l||l.length<5)return!1;let u=l.charCodeAt(0);if(u!==92||(u=l.charCodeAt(1),u!==92))return!1;let r=2;const c=r;for(;r<l.length&&(u=l.charCodeAt(r),u!==92);r++);return!(c===r||(u=l.charCodeAt(r+1),isNaN(u)||u===92))}e.isUNC=y;const w=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(l,u=D.isWindows){const r=u?w:S;return!(!l||l.length===0||/^\s+$/.test(l)||(r.lastIndex=0,r.test(l))||u&&f.test(l)||l==="."||l===".."||u&&l[l.length-1]==="."||u&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=p;function v(l,u,r){const c=l===u;return!r||c?c:!l||!u?!1:(0,n.equalsIgnoreCase)(l,u)}e.isEqual=v;function o(l,u,r,c=E.sep){if(l===u)return!0;if(!l||!u||u.length>l.length)return!1;if(r){if(!(0,n.startsWithIgnoreCase)(l,u))return!1;if(u.length===l.length)return!0;let L=u.length;return u.charAt(u.length-1)===c&&L--,l.charAt(L)===c}return u.charAt(u.length-1)!==c&&(u+=c),l.indexOf(u)===0}e.isEqualOrParent=o;function d(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=d;function m(l,u){return D.isWindows&&l.endsWith(":")&&(l+=E.sep),(0,E.isAbsolute)(l)||(l=(0,E.join)(u,l)),l=(0,E.normalize)(l),D.isWindows?(l=(0,n.rtrim)(l,E.sep),l.endsWith(":")&&(l+=E.sep)):(l=(0,n.rtrim)(l,E.sep),l||(l=E.sep)),l}e.sanitizeFilePath=m;function C(l){const u=(0,E.normalize)(l);return D.isWindows?l.length>3?!1:I(u)&&(l.length===2||u.charCodeAt(2)===92):u===E.posix.sep}e.isRootOrDriveLetter=C;function I(l,u=D.isWindows){return u?d(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function R(l){return I(l)?l[0]:void 0}e.getDriveLetter=R;function t(l,u,r){return u.length>l.length?-1:l===u?0:(r&&(l=l.toLowerCase(),u=u.toLowerCase()),l.indexOf(u))}e.indexOfPath=t;function a(l){const u=l.split(":");let r,c,b;for(const L of u){const T=Number(L);(0,M.isNumber)(T)?c===void 0?c=T:b===void 0&&(b=T):r=r?[r,L].join(":"):L}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:c!==void 0?c:void 0,column:b!==void 0?b:c!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(l,u,r=8){let c="";for(let L=0;L<r;L++)c+=i.charAt(Math.floor(Math.random()*i.length));let b;return u?b=`${u}-${c}`:b=c,l?(0,E.join)(l,b):b}e.randomPath=s}),define(ee[72],te([0,1,27]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(d){return n(d,0)}e.hash=D;function n(d,m){switch(typeof d){case"object":return d===null?M(349,m):Array.isArray(d)?g(d,m):h(d,m);case"string":return P(d,m);case"boolean":return k(d,m);case"number":return M(d,m);case"undefined":return M(937,m);default:return M(617,m)}}e.doHash=n;function M(d,m){return(m<<5)-m+d|0}e.numberHash=M;function k(d,m){return M(d?433:863,m)}function P(d,m){m=M(149417,m);for(let C=0,I=d.length;C<I;C++)m=M(d.charCodeAt(C),m);return m}e.stringHash=P;function g(d,m){return m=M(104579,m),d.reduce((C,I)=>n(I,C),m)}function h(d,m){return m=M(181387,m),Object.keys(d).sort().reduce((C,I)=>(C=P(I,C),n(d[I],C)),m)}class y{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=n(m,this._value),this._value}}e.Hasher=y;var w;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function S(d,m,C=32){const I=C-m,R=~((1<<I)-1);return(d<<m|(R&d)>>>I)>>>0}function f(d,m=0,C=d.byteLength,I=0){for(let R=0;R<C;R++)d[m+R]=I}function p(d,m,C="0"){for(;d.length<m;)d=C+d;return d}function v(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(C=>C.toString(16).padStart(2,"0")).join(""):p((d>>>0).toString(16),m/4)}e.toHexString=v;class o{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const C=m.length;if(C===0)return;const I=this._buff;let R=this._buffLen,t=this._leftoverHighSurrogate,a,i;for(t!==0?(a=t,i=-1,t=0):(a=m.charCodeAt(0),i=0);;){let s=a;if(E.isHighSurrogate(a))if(i+1<C){const l=m.charCodeAt(i+1);E.isLowSurrogate(l)?(i++,s=E.computeCodePoint(a,l)):s=65533}else{t=a;break}else E.isLowSurrogate(a)&&(s=65533);if(R=this._push(I,R,s),i++,i<C)a=m.charCodeAt(i);else break}this._buffLen=R,this._leftoverHighSurrogate=t}_push(m,C,I){return I<128?m[C++]=I:I<2048?(m[C++]=192|(I&1984)>>>6,m[C++]=128|(I&63)>>>0):I<65536?(m[C++]=224|(I&61440)>>>12,m[C++]=128|(I&4032)>>>6,m[C++]=128|(I&63)>>>0):(m[C++]=240|(I&1835008)>>>18,m[C++]=128|(I&258048)>>>12,m[C++]=128|(I&4032)>>>6,m[C++]=128|(I&63)>>>0),C>=64&&(this._step(),C-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),C}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=o._bigBlock32,C=this._buffDV;for(let r=0;r<64;r+=4)m.setUint32(r,C.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)m.setUint32(r,S(m.getUint32(r-12,!1)^m.getUint32(r-32,!1)^m.getUint32(r-56,!1)^m.getUint32(r-64,!1),1),!1);let I=this._h0,R=this._h1,t=this._h2,a=this._h3,i=this._h4,s,l,u;for(let r=0;r<80;r++)r<20?(s=R&t|~R&a,l=1518500249):r<40?(s=R^t^a,l=1859775393):r<60?(s=R&t|R&a|t&a,l=2400959708):(s=R^t^a,l=3395469782),u=S(I,5)+s+i+l+m.getUint32(r*4,!1)&4294967295,i=a,a=t,t=S(R,30),R=I,I=u;this._h0=this._h0+I&4294967295,this._h1=this._h1+R&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}o._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=o}),define(ee[83],te([0,1,27]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(D||(D={})),function(n){const M="error",k="warning",P="warn",g="info",h="ignore";function y(S){return S?E.equalsIgnoreCase(M,S)?n.Error:E.equalsIgnoreCase(k,S)||E.equalsIgnoreCase(P,S)?n.Warning:E.equalsIgnoreCase(g,S)?n.Info:n.Ignore:n.Ignore}n.fromValue=y;function w(S){switch(S){case n.Error:return M;case n.Warning:return k;case n.Info:return g;default:return h}}n.toString=w}(D||(D={})),e.default=D}),define(ee[61],te([0,1,25,27]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this._value="",this._pos=0}reset(f){return this._value=f,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(f){const p=f.charCodeAt(0),v=this._value.charCodeAt(this._pos);return p-v}value(){return this._value[this._pos]}}e.StringIterator=n;class M{constructor(f=!0){this._caseSensitive=f}reset(f){return this._value=f,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let f=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(f)this._from++;else break;else f=!1;return this}cmp(f){return this._caseSensitive?(0,D.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class k{constructor(f=!0,p=!0){this._splitOnBackslash=f,this._caseSensitive=p}reset(f){this._from=0,this._to=0,this._value=f,this._valueLen=f.length;for(let p=f.length-1;p>=0;p--,this._valueLen--){const v=this._value.charCodeAt(p);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let f=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(f)this._from++;else break;else f=!1}return this}cmp(f){return this._caseSensitive?(0,D.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var P;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(P||(P={}));class g{constructor(f,p){this._ignorePathCasing=f,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(f){return this._value=f,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(f)),this._pathIterator.reset(f.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(f)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(f){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(f,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(f,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(f);if(this._states[this._stateIdx]===4)return(0,D.compare)(f,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(f,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(y||(y={}));class w{static forUris(f=()=>!1,p=()=>!1){return new w(new g(f,p))}static forPaths(f=!1){return new w(new k(void 0,!f))}static forStrings(){return new w(new n)}static forConfigKeys(){return new w(new M)}constructor(f){this._iter=f}clear(){this._root=void 0}fill(f,p){if(p){const v=p.slice(0);(0,E.shuffle)(v);for(const o of v)this.set(o,f)}else{const v=f.slice(0);(0,E.shuffle)(v);for(const o of v)this.set(o[0],o[1])}}set(f,p){const v=this._iter.reset(f);let o;this._root||(this._root=new h,this._root.segment=v.value());const d=[];for(o=this._root;;){const C=v.cmp(o.segment);if(C>0)o.left||(o.left=new h,o.left.segment=v.value()),d.push([-1,o]),o=o.left;else if(C<0)o.right||(o.right=new h,o.right.segment=v.value()),d.push([1,o]),o=o.right;else if(v.hasNext())v.next(),o.mid||(o.mid=new h,o.mid.segment=v.value()),d.push([0,o]),o=o.mid;else break}const m=o.value;o.value=p,o.key=f;for(let C=d.length-1;C>=0;C--){const I=d[C][1];I.updateHeight();const R=I.balanceFactor();if(R<-1||R>1){const t=d[C][0],a=d[C+1][0];if(t===1&&a===1)d[C][1]=I.rotateLeft();else if(t===-1&&a===-1)d[C][1]=I.rotateRight();else if(t===1&&a===-1)I.right=d[C+1][1]=d[C+1][1].rotateRight(),d[C][1]=I.rotateLeft();else if(t===-1&&a===1)I.left=d[C+1][1]=d[C+1][1].rotateLeft(),d[C][1]=I.rotateRight();else throw new Error;if(C>0)switch(d[C-1][0]){case-1:d[C-1][1].left=d[C][1];break;case 1:d[C-1][1].right=d[C][1];break;case 0:d[C-1][1].mid=d[C][1];break}else this._root=d[0][1]}}return m}get(f){return this._getNode(f)?.value}_getNode(f){const p=this._iter.reset(f);let v=this._root;for(;v;){const o=p.cmp(v.segment);if(o>0)v=v.left;else if(o<0)v=v.right;else if(p.hasNext())p.next(),v=v.mid;else break}return v}has(f){const p=this._getNode(f);return!(p?.value===void 0&&p?.mid===void 0)}delete(f){return this._delete(f,!1)}deleteSuperstr(f){return this._delete(f,!0)}_delete(f,p){const v=this._iter.reset(f),o=[];let d=this._root;for(;d;){const m=v.cmp(d.segment);if(m>0)o.push([-1,d]),d=d.left;else if(m<0)o.push([1,d]),d=d.right;else if(v.hasNext())v.next(),o.push([0,d]),d=d.mid;else break}if(!!d){if(p?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const m=this._min(d.right);if(m.key){const{key:C,value:I,segment:R}=m;this._delete(m.key,!1),d.key=C,d.value=I,d.segment=R}}else{const m=d.left??d.right;if(o.length>0){const[C,I]=o[o.length-1];switch(C){case-1:I.left=m;break;case 0:I.mid=m;break;case 1:I.right=m;break}}else this._root=m}for(let m=o.length-1;m>=0;m--){const C=o[m][1];C.updateHeight();const I=C.balanceFactor();if(I>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),o[m][1]=C.rotateLeft()):I<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),o[m][1]=C.rotateRight()),m>0)switch(o[m-1][0]){case-1:o[m-1][1].left=o[m][1];break;case 1:o[m-1][1].right=o[m][1];break;case 0:o[m-1][1].mid=o[m][1];break}else this._root=o[0][1]}}}_min(f){for(;f.left;)f=f.left;return f}findSubstr(f){const p=this._iter.reset(f);let v=this._root,o;for(;v;){const d=p.cmp(v.segment);if(d>0)v=v.left;else if(d<0)v=v.right;else if(p.hasNext())p.next(),o=v.value||o,v=v.mid;else break}return v&&v.value||o}findSuperstr(f){return this._findSuperstrOrElement(f,!1)}_findSuperstrOrElement(f,p){const v=this._iter.reset(f);let o=this._root;for(;o;){const d=v.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(v.hasNext())v.next(),o=o.mid;else return o.mid?this._entries(o.mid):p?o.value:void 0}}hasElementOrSubtree(f){return this._findSuperstrOrElement(f,!0)!==void 0}forEach(f){for(const[p,v]of this)f(v,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(f){const p=[];return this._dfsEntries(f,p),p[Symbol.iterator]()}_dfsEntries(f,p){!f||(f.left&&this._dfsEntries(f.left,p),f.value&&p.push([f.key,f.value]),f.mid&&this._dfsEntries(f.mid,p),f.right&&this._dfsEntries(f.right,p))}_isBalanced(){const f=p=>{if(!p)return!0;const v=p.balanceFactor();return v<-1||v>1?!1:f(p.left)&&f(p.right)};return f(this._root)}}e.TernarySearchTree=w}),define(ee[7],te([0,1,9,4]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,M=/^\//,k=/^\/\//;function P(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,s){return!i&&!s?"file":i}function h(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==w&&(s=w+s):s=w;break}return s}const y="",w="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(s){return s instanceof f?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,l,u,r,c,b=!1){typeof s=="object"?(this.scheme=s.scheme||y,this.authority=s.authority||y,this.path=s.path||y,this.query=s.query||y,this.fragment=s.fragment||y):(this.scheme=g(s,b),this.authority=l||y,this.path=h(this.scheme,u||y),this.query=r||y,this.fragment=c||y,P(this,b))}get fsPath(){return C(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:u,path:r,query:c,fragment:b}=s;return l===void 0?l=this.scheme:l===null&&(l=y),u===void 0?u=this.authority:u===null&&(u=y),r===void 0?r=this.path:r===null&&(r=y),c===void 0?c=this.query:c===null&&(c=y),b===void 0?b=this.fragment:b===null&&(b=y),l===this.scheme&&u===this.authority&&r===this.path&&c===this.query&&b===this.fragment?this:new v(l,u,r,c,b)}static parse(s,l=!1){const u=S.exec(s);return u?new v(u[2]||y,a(u[4]||y),a(u[5]||y),a(u[7]||y),a(u[9]||y),l):new v(y,y,y,y,y)}static file(s){let l=y;if(D.isWindows&&(s=s.replace(/\\/g,w)),s[0]===w&&s[1]===w){const u=s.indexOf(w,2);u===-1?(l=s.substring(2),s=w):(l=s.substring(2,u),s=s.substring(u)||w)}return new v("file",l,s,y,y)}static from(s){const l=new v(s.scheme,s.authority,s.path,s.query,s.fragment);return P(l,!0),l}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return D.isWindows&&s.scheme==="file"?u=f.file(E.win32.join(C(s,!0),...l)).path:u=E.posix.join(s.path,...l),s.with({path:u})}toString(s=!1){return I(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof f)return s;{const l=new v(s);return l._formatted=s.external,l._fsPath=s._sep===p?s.fsPath:null,l}}else return s}}e.URI=f;const p=D.isWindows?1:void 0;class v extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=C(this,!1)),this._fsPath}toString(s=!1){return s?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=p),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,s,l){let u,r=-1;for(let c=0;c<i.length;c++){const b=i.charCodeAt(c);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||s&&b===47||l&&b===91||l&&b===93||l&&b===58)r!==-1&&(u+=encodeURIComponent(i.substring(r,c)),r=-1),u!==void 0&&(u+=i.charAt(c));else{u===void 0&&(u=i.substr(0,c));const L=o[b];L!==void 0?(r!==-1&&(u+=encodeURIComponent(i.substring(r,c)),r=-1),u+=L):r===-1&&(r=c)}}return r!==-1&&(u+=encodeURIComponent(i.substring(r))),u!==void 0?u:i}function m(i){let s;for(let l=0;l<i.length;l++){const u=i.charCodeAt(l);u===35||u===63?(s===void 0&&(s=i.substr(0,l)),s+=o[u]):s!==void 0&&(s+=i[l])}return s!==void 0?s:i}function C(i,s){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,D.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=C;function I(i,s){const l=s?m:d;let u="",{scheme:r,authority:c,path:b,query:L,fragment:T}=i;if(r&&(u+=r,u+=":"),(c||r==="file")&&(u+=w,u+=w),c){let F=c.indexOf("@");if(F!==-1){const Y=c.substr(0,F);c=c.substr(F+1),F=Y.lastIndexOf(":"),F===-1?u+=l(Y,!1,!1):(u+=l(Y.substr(0,F),!1,!1),u+=":",u+=l(Y.substr(F+1),!1,!0)),u+="@"}c=c.toLowerCase(),F=c.lastIndexOf(":"),F===-1?u+=l(c,!1,!0):(u+=l(c.substr(0,F),!1,!0),u+=c.substr(F))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const F=b.charCodeAt(1);F>=65&&F<=90&&(b=`/${String.fromCharCode(F+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const F=b.charCodeAt(0);F>=65&&F<=90&&(b=`${String.fromCharCode(F+32)}:${b.substr(2)}`)}u+=l(b,!0,!1)}return L&&(u+="?",u+=l(L,!1,!1)),T&&(u+="#",u+=s?T:d(T,!1,!1)),u}function R(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+R(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,s=>R(s)):i}}),define(ee[146],te([0,1,7]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(h){const y=h;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=D;function n(h){const y=[];let w;try{const S=JSON.parse(h.arguments),f=S[S.length-1];f&&f.__$stack&&(S.pop(),w=f.__$stack),y.push(...S)}catch{y.push("Unable to log remote console arguments",h.arguments)}return{args:y,stack:w}}e.parse=n;function M(h){if(typeof h!="string")return M(n(h).stack);const y=h;if(y){const w=k(y),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(S&&S.length===4)return{uri:E.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=M;function k(h){if(!h)return h;const y=h.indexOf(`
`);return y===-1?h:h.substring(0,y)}function P(h,y){const{args:w,stack:S}=n(h),f=typeof w[0]=="string"&&w.length===1;let p=k(S);p&&(p=`(${p.trim()})`);let v=[];if(typeof w[0]=="string"?p&&f?v=[`%c[${y}] %c${w[0]} %c${p}`,g("blue"),g(""),g("grey")]:v=[`%c[${y}] %c${w[0]}`,g("blue"),g(""),...w.slice(1)]:v=[`%c[${y}]%`,g("blue"),...w],p&&!f&&v.push(p),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,v)}e.log=P;function g(h){return`color: ${h}`}}),define(ee[84],te([0,1,17,27,7]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(h){return JSON.stringify(h,P)}e.stringify=M;function k(h){let y=JSON.parse(h);return y=g(y),y}e.parse=k;function P(h,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,D.regExpFlags)(y)}:y}function g(h,y=0){if(!h||y>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return n.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof E.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let w=0;w<h.length;++w)h[w]=g(h[w],y+1);else for(const w in h)Object.hasOwnProperty.call(h,w)&&(h[w]=g(h[w],y+1))}return h}e.revive=g}),define(ee[14],te([0,1,13,4,7]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}setServerRootPath(y){this._remoteResourcesPath=`${y}/${M.vscodeRemoteResource}`}set(y,w,S){this._hosts[y]=w,this._ports[y]=S}setConnectionToken(y,w){this._connectionTokens[y]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)try{return this._delegate(y)}catch(o){return E.onUnexpectedError(o),y}const w=y.authority;let S=this._hosts[w];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const f=this._ports[w],p=this._connectionTokens[w];let v=`path=${encodeURIComponent(y.path)}`;return typeof p=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${S}:${f}`,path:this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(y){const w=this.toUri(y,j);return this.uriToBrowserUri(w)}uriToBrowserUri(y){return y.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===M.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${M.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?y.with({scheme:M.vscodeFileResource,authority:y.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(y){const w=this.toUri(y,j);return this.uriToFileUri(w)}uriToFileUri(y){return y.scheme===M.vscodeFileResource?y.with({scheme:M.file,authority:y.authority!==P.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(y,w){return n.URI.isUri(y)?y:n.URI.parse(w.toUrl(y))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P;var g;(function(h){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(y.get("3"));const w="vscode-coi";function S(p){let v;typeof p=="string"?v=new URL(p).searchParams:p instanceof URL?v=p.searchParams:n.URI.isUri(p)&&(v=new URL(p.toString(!0)).searchParams);const o=v?.get(w);if(!!o)return y.get(o)}h.getHeadersFromQuery=S;function f(p,v,o){if(!globalThis.crossOriginIsolated)return;const d=v&&o?"3":o?"2":"1";p instanceof URLSearchParams?p.set(w,d):p[w]=d}h.addSearchParam=f})(g=e.COI||(e.COI={}))}),define(ee[18],te([0,1,32,14,9,4,27,7]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(f){return(0,P.uriToFsPath)(f,!0)}e.originalFSPath=g;class h{constructor(p){this._ignorePathCasing=p}compare(p,v,o=!1){return p===v?0:(0,k.compare)(this.getComparisonKey(p,o),this.getComparisonKey(v,o))}isEqual(p,v,o=!1){return p===v?!0:!p||!v?!1:this.getComparisonKey(p,o)===this.getComparisonKey(v,o)}getComparisonKey(p,v=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,v,o=!1){if(p.scheme===v.scheme){if(p.scheme===D.Schemas.file)return E.isEqualOrParent(g(p),g(v),this._ignorePathCasing(p))&&p.query===v.query&&(o||p.fragment===v.fragment);if((0,e.isEqualAuthority)(p.authority,v.authority))return E.isEqualOrParent(p.path,v.path,this._ignorePathCasing(p),"/")&&p.query===v.query&&(o||p.fragment===v.fragment)}return!1}joinPath(p,...v){return P.URI.joinPath(p,...v)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return n.posix.basename(p.path)}extname(p){return n.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let v;return p.scheme===D.Schemas.file?v=P.URI.file(n.dirname(g(p))).path:(v=n.posix.dirname(p.path),p.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),v="/")),p.with({path:v})}normalizePath(p){if(!p.path.length)return p;let v;return p.scheme===D.Schemas.file?v=P.URI.file(n.normalize(g(p))).path:v=n.posix.normalize(p.path),p.with({path:v})}relativePath(p,v){if(p.scheme!==v.scheme||!(0,e.isEqualAuthority)(p.authority,v.authority))return;if(p.scheme===D.Schemas.file){const m=n.relative(g(p),g(v));return M.isWindows?E.toSlashes(m):m}let o=p.path||"/";const d=v.path||"/";if(this._ignorePathCasing(p)){let m=0;for(const C=Math.min(o.length,d.length);m<C&&!(o.charCodeAt(m)!==d.charCodeAt(m)&&o.charAt(m).toLowerCase()!==d.charAt(m).toLowerCase());m++);o=d.substr(0,m)+o.substr(m)}return n.posix.relative(o,d)}resolvePath(p,v){if(p.scheme===D.Schemas.file){const o=P.URI.file(n.resolve(g(p),v));return p.with({authority:o.authority,path:o.path})}return v=E.toPosixPath(v),p.with({path:n.posix.resolve(p.path,v)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,v){return p===v||p!==void 0&&v!==void 0&&(0,k.equalsIgnoreCase)(p,v)}hasTrailingPathSeparator(p,v=n.sep){if(p.scheme===D.Schemas.file){const o=g(p);return o.length>E.getRoot(o).length&&o[o.length-1]===v}else{const o=p.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,v=n.sep){return(0,e.hasTrailingPathSeparator)(p,v)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,v=n.sep){let o=!1;if(p.scheme===D.Schemas.file){const d=g(p);o=d!==void 0&&d.length===E.getRoot(d).length&&d[d.length-1]===v}else{v="/";const d=p.path;o=d.length===1&&d.charCodeAt(d.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(p,v)?p.with({path:p.path+"/"}):p}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(f=>f.scheme===D.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new h(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(f,p){const v=[];for(let o=0;o<f.length;o++){const d=p(f[o]);f.some((m,C)=>C===o?!1:(0,e.isEqualOrParent)(d,p(m)))||v.push(f[o])}return v}e.distinctParents=y;var w;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function p(v){const o=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(C=>{const[I,R]=C.split(":");I&&R&&o.set(I,R)});const m=v.path.substring(0,v.path.indexOf(";"));return m&&o.set(f.META_DATA_MIME,m),o}f.parseMetaData=p})(w=e.DataUri||(e.DataUri={}));function S(f,p,v){if(p){let o=f.path;return o&&o[0]!==n.posix.sep&&(o=n.posix.sep+o),f.with({scheme:v,authority:p,path:o})}return f.with({scheme:v})}e.toLocalResource=S}),define(ee[8],te([0,1,22,13,3,2,18,4,131]),function(j,e,E,D,n,M,k,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(J){return!!J&&typeof J.then=="function"}e.isThenable=h;function y(J){const W=new E.CancellationTokenSource,A=J(W.token),_=new Promise((N,q)=>{const U=W.token.onCancellationRequested(()=>{U.dispose(),W.dispose(),q(new D.CancellationError)});Promise.resolve(A).then($=>{U.dispose(),W.dispose(),N($)},$=>{U.dispose(),W.dispose(),q($)})});return new class{cancel(){W.cancel()}then(N,q){return _.then(N,q)}catch(N){return this.then(void 0,N)}finally(N){return _.finally(N)}}}e.createCancelablePromise=y;function w(J,W,A){return new Promise((_,N)=>{const q=W.onCancellationRequested(()=>{q.dispose(),_(A)});J.then(_,N).finally(()=>q.dispose())})}e.raceCancellation=w;function S(J,W){return new Promise((A,_)=>{const N=W.onCancellationRequested(()=>{N.dispose(),_(new D.CancellationError)});J.then(A,_).finally(()=>N.dispose())})}e.raceCancellationError=S;async function f(J){let W=-1;const A=J.map((N,q)=>N.then(U=>(W=q,U))),_=await Promise.race(A);return J.forEach((N,q)=>{q!==W&&N.cancel()}),_}e.raceCancellablePromises=f;function p(J,W,A){let _;const N=setTimeout(()=>{_?.(void 0),A?.()},W);return Promise.race([J.finally(()=>clearTimeout(N)),new Promise(q=>_=q)])}e.raceTimeout=p;function v(J){return new Promise((W,A)=>{const _=J();h(_)?_.then(W,A):W(_)})}e.asPromise=v;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const A=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(A,A).then(_)})}return new Promise((A,_)=>{this.queuedPromise.then(A,_)})}return this.activePromise=W(),new Promise((A,_)=>{this.activePromise.then(N=>{this.activePromise=null,A(N)},N=>{this.activePromise=null,_(N)})})}}e.Throttler=o;class d{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=d;class m{constructor(){this.promiseMap=new Map}queue(W,A){const N=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.promiseMap.get(W)===N&&this.promiseMap.delete(W)});return this.promiseMap.set(W,N),N}}e.SequencerByKey=m;const C=(J,W)=>{let A=!0;const _=setTimeout(()=>{A=!1,W()},J);return{isTriggered:()=>A,dispose:()=>{clearTimeout(_),A=!1}}},I=J=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,J())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};class R{constructor(W){this.defaultDelay=W,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,A=this.defaultDelay){this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,q)=>{this.doResolve=N,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=A===g.MicrotaskDelay?I(_):C(A,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new D.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=R;class t{constructor(W){this.delayer=new R(W),this.throttler=new o}trigger(W,A){return this.delayer.trigger(()=>this.throttler.queue(W),A)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this._isOpen=!1,this._promise=new Promise((W,A)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class i extends a{constructor(W){super(),this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=i;function s(J,W){return W?new Promise((A,_)=>{const N=setTimeout(()=>{q.dispose(),A()},J),q=W.onCancellationRequested(()=>{clearTimeout(N),q.dispose(),_(new D.CancellationError)})}):y(A=>s(J,A))}e.timeout=s;function l(J,W=0){const A=setTimeout(J,W);return(0,M.toDisposable)(()=>clearTimeout(A))}e.disposableTimeout=l;function u(J){const W=[];let A=0;const _=J.length;function N(){return A<_?J[A++]():null}function q(U){U!=null&&W.push(U);const $=N();return $?$.then(q):Promise.resolve(W)}return Promise.resolve(null).then(q)}e.sequence=u;function r(J,W=_=>!!_,A=null){let _=0;const N=J.length,q=()=>{if(_>=N)return Promise.resolve(A);const U=J[_++];return Promise.resolve(U()).then(H=>W(H)?Promise.resolve(H):q())};return q()}e.first=r;function c(J,W=_=>!!_,A=null){if(J.length===0)return Promise.resolve(A);let _=J.length;const N=()=>{_=-1;for(const q of J)q.cancel?.()};return new Promise((q,U)=>{for(const $ of J)$.then(H=>{--_>=0&&W(H)?(N(),q(H)):_===0&&q(A)}).catch(H=>{--_>=0&&(N(),U(H))})})}e.firstParallel=c;class b{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new n.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(W){return this._size++,new Promise((A,_)=>{this.outstandingPromises.push({factory:W,c:A,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const A=W.factory();A.then(W.c,W.e),A.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=b;class L extends b{constructor(){super(1)}}e.Queue=L;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const W=new B;return this.drainers.add(W),W.p}isDrained(){for(const[,W]of this.queues)if(W.size>0)return!1;return!0}queueFor(W,A=k.extUri){const _=A.getComparisonKey(W);let N=this.queues.get(_);return N||(N=new L,n.Event.once(N.onDrained)(()=>{N?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,N)),N}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const W of this.drainers)W.complete();this.drainers.clear()}dispose(){for(const[,W]of this.queues)W.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class F{constructor(W,A){this._token=-1,typeof W=="function"&&typeof A=="number"&&this.setIfNotSet(W,A)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,A){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},A)}setIfNotSet(W,A){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},A))}}e.TimeoutTimer=F;class Y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,A){this.cancel(),this._token=setInterval(()=>{W()},A)}}e.IntervalTimer=Y;class V{constructor(W,A){this.timeoutToken=-1,this.runner=W,this.timeout=A,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=V;class G{constructor(W,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=A,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class ie extends V{constructor(W,A){super(W,A),this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner?.(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ie;class re extends M.Disposable{constructor(W,A){super(),this.options=W,this.handler=A,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.options.maxBufferedWork)return!1}else if(this.pending+W.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const A of W)this.pendingWork.push(A);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new V(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=J=>{(0,P.setTimeout0)(()=>{if(W)return;const A=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.runWhenIdle=(J,W)=>{const A=requestIdleCallback(J,typeof W=="number"?{timeout:W}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(A))}}}}();class de{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(A){this._error=A}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=de;async function ce(J,W,A){let _;for(let N=0;N<A;N++)try{return await J()}catch(q){_=q,await s(W)}throw _}e.retry=ce;class ge{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(W,A,_){return this._pending={taskId:W,cancel:()=>_?.(),promise:A},A.then(()=>this.donePending(W),()=>this.donePending(W)),A}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let A,_;const N=new Promise((q,U)=>{A=q,_=U});this._next={run:W,promise:N,promiseResolve:A,promiseReject:_}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=ge;class x{constructor(W,A=()=>Date.now()){this.interval=W,this.nowFn=A,this.lastIncrementTime=0,this.value=0}increment(){const W=this.nowFn();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class B{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,A)=>{this.completeCallback=W,this.errorCallback=A})}complete(W){return new Promise(A=>{this.completeCallback(W),this.resolved=!0,A()})}error(W){return new Promise(A=>{this.errorCallback(W),this.rejected=!0,A()})}cancel(){new Promise(W=>{this.errorCallback(new D.CancellationError),this.rejected=!0,W()})}}e.DeferredPromise=B;var O;(function(J){async function W(_){let N;const q=await Promise.all(_.map(U=>U.then($=>$,$=>{N||(N=$)})));if(typeof N<"u")throw N;return q}J.settled=W;function A(_){return new Promise(async(N,q)=>{try{await _(N,q)}catch(U){q(U)}})}J.withAsyncBody=A})(O=e.Promises||(e.Promises={}));var z;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(z||(z={}));class K{static fromArray(W){return new K(A=>{A.emitMany(W)})}static fromPromise(W){return new K(async A=>{A.emitMany(await W)})}static fromPromises(W){return new K(async A=>{await Promise.all(W.map(async _=>A.emitOne(await _)))})}static merge(W){return new K(async A=>{await Promise.all(W.map(async _=>{for await(const N of _)A.emitOne(N)}))})}constructor(W){this._state=0,this._results=[],this._error=null,this._onStateChanged=new n.Emitter,queueMicrotask(async()=>{const A={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(W(A)),this.resolve()}catch(_){this.reject(_)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(W<this._results.length)return{done:!1,value:this._results[W++]};if(this._state===1)return{done:!0,value:void 0};await n.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(W,A){return new K(async _=>{for await(const N of W)_.emitOne(A(N))})}map(W){return K.map(this,W)}static filter(W,A){return new K(async _=>{for await(const N of W)A(N)&&_.emitOne(N)})}filter(W){return K.filter(this,W)}static coalesce(W){return K.filter(W,A=>!!A)}coalesce(){return K.coalesce(this)}static async toPromise(W){const A=[];for await(const _ of W)A.push(_);return A}toPromise(){return K.toPromise(this)}emitOne(W){this._state===0&&(this._results.push(W),this._onStateChanged.fire())}emitMany(W){this._state===0&&(this._results=this._results.concat(W),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(W){this._state===0&&(this._state=2,this._error=W,this._onStateChanged.fire())}}K.EMPTY=K.fromArray([]),e.AsyncIterableObject=K;class ne extends K{constructor(W,A){super(A),this._source=W}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function se(J){const W=new E.CancellationTokenSource,A=J(W.token);return new ne(W,async _=>{const N=W.token.onCancellationRequested(()=>{N.dispose(),W.dispose(),_.reject(new D.CancellationError)});try{for await(const q of A){if(W.token.isCancellationRequested)return;_.emitOne(q)}N.dispose(),W.dispose()}catch(q){N.dispose(),W.dispose(),_.reject(q)}})}e.createCancelableAsyncIterable=se}),define(ee[102],te([0,1,25,8,32,35,9,4,27]),function(j,e,E,D,n,M,k,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",w="[^/\\\\]",S=/\//g;function f(x,B){switch(x){case 0:return"";case 1:return`${w}*?`;default:return`(?:${y}|${w}+${y}${B?`|${y}${w}+`:""})*?`}}function p(x,B){if(!x)return[];const O=[];let z=!1,K=!1,ne="";for(const se of x){switch(se){case B:if(!z&&!K){O.push(ne),ne="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":K=!0;break;case"]":K=!1;break}ne+=se}return ne&&O.push(ne),O}e.splitGlobAware=p;function v(x){if(!x)return"";let B="";const O=p(x,e.GLOB_SPLIT);if(O.every(z=>z===e.GLOBSTAR))B=".*";else{let z=!1;O.forEach((K,ne)=>{if(K===e.GLOBSTAR){if(z)return;B+=f(2,ne===O.length-1)}else{let se=!1,J="",W=!1,A="";for(const _ of K){if(_!=="}"&&se){J+=_;continue}if(W&&(_!=="]"||!A)){let N;_==="-"?N=_:(_==="^"||_==="!")&&!A?N="^":_===e.GLOB_SPLIT?N="":N=(0,g.escapeRegExpCharacters)(_),A+=N;continue}switch(_){case"{":se=!0;continue;case"[":W=!0;continue;case"}":{B+=`(?:${p(J,",").map(U=>v(U)).join("|")})`,se=!1,J="";break}case"]":{B+="["+A+"]",W=!1,A="";break}case"?":B+=w;continue;case"*":B+=f(1);continue;default:B+=(0,g.escapeRegExpCharacters)(_)}}ne<O.length-1&&(O[ne+1]!==e.GLOBSTAR||ne+2<O.length)&&(B+=y)}z=K===e.GLOBSTAR})}return B}const o=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,C=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,I=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),a=function(){return!1},i=function(){return null};function s(x,B){if(!x)return i;let O;typeof x!="string"?O=x.pattern:O=x,O=O.trim();const z=`${O}_${!!B.trimForExclusions}`;let K=t.get(z);if(K)return l(K,x);let ne;return o.test(O)?K=r(O.substr(4),O):(ne=d.exec(u(O,B)))?K=c(ne[1],O):(B.trimForExclusions?C:m).test(O)?K=b(O,B):(ne=I.exec(u(O,B)))?K=L(ne[1].substr(1),O,!0):(ne=R.exec(u(O,B)))?K=L(ne[1],O,!1):K=T(O),t.set(z,K),l(K,x)}function l(x,B){if(typeof B=="string")return x;const O=function(z,K){return(0,n.isEqualOrParent)(z,B.base,!P.isLinux)?x((0,g.ltrim)(z.substr(B.base.length),k.sep),K):null};return O.allBasenames=x.allBasenames,O.allPaths=x.allPaths,O.basenames=x.basenames,O.patterns=x.patterns,O}function u(x,B){return B.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function r(x,B){return function(O,z){return typeof O=="string"&&O.endsWith(x)?B:null}}function c(x,B){const O=`/${x}`,z=`\\${x}`,K=function(se,J){return typeof se!="string"?null:J?J===x?B:null:se===x||se.endsWith(O)||se.endsWith(z)?B:null},ne=[x];return K.basenames=ne,K.patterns=[B],K.allBasenames=ne,K}function b(x,B){const O=ce(x.slice(1,-1).split(",").map(J=>s(J,B)).filter(J=>J!==i),x),z=O.length;if(!z)return i;if(z===1)return O[0];const K=function(J,W){for(let A=0,_=O.length;A<_;A++)if(O[A](J,W))return x;return null},ne=O.find(J=>!!J.allBasenames);ne&&(K.allBasenames=ne.allBasenames);const se=O.reduce((J,W)=>W.allPaths?J.concat(W.allPaths):J,[]);return se.length&&(K.allPaths=se),K}function L(x,B,O){const z=k.sep===k.posix.sep,K=z?x:x.replace(S,k.sep),ne=k.sep+K,se=k.posix.sep+x;let J;return O?J=function(W,A){return typeof W=="string"&&(W===K||W.endsWith(ne)||!z&&(W===x||W.endsWith(se)))?B:null}:J=function(W,A){return typeof W=="string"&&(W===K||!z&&W===x)?B:null},J.allPaths=[(O?"*/":"./")+x],J}function T(x){try{const B=new RegExp(`^${v(x)}$`);return function(O){return B.lastIndex=0,typeof O=="string"&&B.test(O)?x:null}}catch{return i}}function F(x,B,O){return!x||typeof B!="string"?!1:Y(x)(B,void 0,O)}e.match=F;function Y(x,B={}){if(!x)return a;if(typeof x=="string"||V(x)){const O=s(x,B);if(O===i)return a;const z=function(K,ne){return!!O(K,ne)};return O.allBasenames&&(z.allBasenames=O.allBasenames),O.allPaths&&(z.allPaths=O.allPaths),z}return re(x,B)}e.parse=Y;function V(x){const B=x;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=V;function G(x){return x.allBasenames||[]}e.getBasenameTerms=G;function ie(x){return x.allPaths||[]}e.getPathTerms=ie;function re(x,B){const O=ce(Object.getOwnPropertyNames(x).map(J=>de(J,x[J],B)).filter(J=>J!==i)),z=O.length;if(!z)return i;if(!O.some(J=>!!J.requiresSiblings)){if(z===1)return O[0];const J=function(_,N){let q;for(let U=0,$=O.length;U<$;U++){const H=O[U](_,N);if(typeof H=="string")return H;(0,D.isThenable)(H)&&(q||(q=[]),q.push(H))}return q?(async()=>{for(const U of q){const $=await U;if(typeof $=="string")return $}return null})():null},W=O.find(_=>!!_.allBasenames);W&&(J.allBasenames=W.allBasenames);const A=O.reduce((_,N)=>N.allPaths?_.concat(N.allPaths):_,[]);return A.length&&(J.allPaths=A),J}const K=function(J,W,A){let _,N;for(let q=0,U=O.length;q<U;q++){const $=O[q];$.requiresSiblings&&A&&(W||(W=(0,k.basename)(J)),_||(_=W.substr(0,W.length-(0,k.extname)(J).length)));const H=$(J,W,_,A);if(typeof H=="string")return H;(0,D.isThenable)(H)&&(N||(N=[]),N.push(H))}return N?(async()=>{for(const q of N){const U=await q;if(typeof U=="string")return U}return null})():null},ne=O.find(J=>!!J.allBasenames);ne&&(K.allBasenames=ne.allBasenames);const se=O.reduce((J,W)=>W.allPaths?J.concat(W.allPaths):J,[]);return se.length&&(K.allPaths=se),K}function de(x,B,O){if(B===!1)return i;const z=s(x,O);if(z===i)return i;if(typeof B=="boolean")return z;if(B){const K=B.when;if(typeof K=="string"){const ne=(se,J,W,A)=>{if(!A||!z(se,J))return null;const _=K.replace("$(basename)",()=>W),N=A(_);return(0,D.isThenable)(N)?N.then(q=>q?x:null):N?x:null};return ne.requiresSiblings=!0,ne}}return z}function ce(x,B){const O=x.filter(J=>!!J.basenames);if(O.length<2)return x;const z=O.reduce((J,W)=>{const A=W.basenames;return A?J.concat(A):J},[]);let K;if(B){K=[];for(let J=0,W=z.length;J<W;J++)K.push(B)}else K=O.reduce((J,W)=>{const A=W.patterns;return A?J.concat(A):J},[]);const ne=function(J,W){if(typeof J!="string")return null;if(!W){let _;for(_=J.length;_>0;_--){const N=J.charCodeAt(_-1);if(N===47||N===92)break}W=J.substr(_)}const A=z.indexOf(W);return A!==-1?K[A]:null};ne.basenames=z,ne.patterns=K,ne.allBasenames=z;const se=x.filter(J=>!J.basenames);return se.push(ne),se}function ge(x,B){return(0,E.equals)(x,B,(O,z)=>typeof O=="string"&&typeof z=="string"?O===z:typeof O!="string"&&typeof z!="string"?O.base===z.base&&O.pattern===z.pattern:!1)}e.patternsEquals=ge}),define(ee[45],te([0,1,25,32,9,4,18,27]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function g(i,s){const{os:l,tildify:u,relative:r}=s;if(r){const L=h(i,r,l);if(typeof L=="string")return L}let c=i.fsPath;if(l===1&&!M.isWindows?c=c.replace(/\//g,"\\"):l!==1&&M.isWindows&&(c=c.replace(/\\/g,"/")),l!==1&&u?.userHome){const L=u.userHome.fsPath;let T;i.scheme!==u.userHome.scheme&&i.path.startsWith(n.posix.sep)?T=u.userHome.with({path:i.path}).fsPath:T=i.fsPath,c=S(T,L,l)}return(l===1?n.win32:n.posix).normalize(y(c,l===1))}e.getPathLabel=g;function h(i,s,l){const u=l===1?n.win32:n.posix,r=l===3?k.extUri:k.extUriIgnorePathCase,c=s.getWorkspace(),b=(0,E.firstOrDefault)(c.folders);if(!b)return;i.scheme!==b.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=b.uri.with({path:i.path}));const L=s.getWorkspaceFolder(i);if(!L)return;let T;if(r.isEqual(L.uri,i)?T="":T=r.relativePath(L.uri,i)??"",T&&(T=u.normalize(T)),c.folders.length>1&&!s.noPrefix){const F=L.name?L.name:r.basenameOrAuthority(L.uri);T=T?`${F} \u2022 ${T}`:F}return T}function y(i,s=M.isWindows){return(0,D.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=y;let w=Object.create(null);function S(i,s,l=M.OS){if(l===1||!i||!s)return i;let u=w.original===s?w.normalized:void 0;u||(u=s,M.isWindows&&(u=(0,D.toSlashes)(u)),u=`${(0,P.rtrim)(u,n.posix.sep)}${n.posix.sep}`,w={original:s,normalized:u});let r=i;return M.isWindows&&(r=(0,D.toSlashes)(r)),(l===3?r.startsWith(u):(0,P.startsWithIgnoreCase)(r,u))?`~/${r.substr(u.length)}`:i}e.tildify=S;function f(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=f;const p="\u2026",v="\\\\",o="~";function d(i,s=n.sep){const l=new Array(i.length);let u=!1;for(let r=0;r<i.length;r++){const c=i[r];if(c===""){l[r]=`.${s}`;continue}if(!c){l[r]=c;continue}u=!0;let b="",L=c;L.indexOf(v)===0?(b=L.substr(0,L.indexOf(v)+v.length),L=L.substr(L.indexOf(v)+v.length)):L.indexOf(s)===0?(b=L.substr(0,L.indexOf(s)+s.length),L=L.substr(L.indexOf(s)+s.length)):L.indexOf(o)===0&&(b=L.substr(0,L.indexOf(o)+o.length),L=L.substr(L.indexOf(o)+o.length));const T=L.split(s);for(let F=1;u&&F<=T.length;F++)for(let Y=T.length-F;u&&Y>=0;Y--){u=!1;let V=T.slice(Y,Y+F).join(s);for(let G=0;!u&&G<i.length;G++)if(G!==r&&i[G]&&i[G].indexOf(V)>-1){const ie=Y+F===T.length,re=Y>0&&i[G].indexOf(s)>-1?s+V:V,de=i[G].endsWith(re);u=!ie||de}if(!u){let G="";(T[0].endsWith(":")||b!=="")&&(Y===1&&(Y=0,F++,V=T[0]+s+V),Y>0&&(G=T[0]+s),G=b+G),Y>0&&(G=G+p+s),G=G+V,Y+F<T.length&&(G=G+s+p),l[r]=G}}u&&(l[r]=c)}return l}e.shorten=d;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function C(i,s=Object.create(null)){const l=[];let u=!1,r="";for(const c of i)if(c==="$"||u&&c==="{")r&&l.push({value:r,type:m.TEXT}),r="",u=!0;else if(c==="}"&&u){const b=s[r];if(typeof b=="string")b.length&&l.push({value:b,type:m.VARIABLE});else if(b){const L=l[l.length-1];(!L||L.type!==m.SEPARATOR)&&l.push({value:b.label,type:m.SEPARATOR})}r="",u=!1}else r+=c;return r&&!u&&l.push({value:r,type:m.TEXT}),l.filter((c,b)=>{if(c.type===m.SEPARATOR){const L=l[b-1],T=l[b+1];return[L,T].every(F=>F&&(F.type===m.VARIABLE||F.type===m.TEXT)&&F.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=C;function I(i,s){return M.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function R(i,s){return M.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=R;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(i){const s=i.indexOf("/")!==-1?n.posix:n.win32,l=s.basename(i),u=s.dirname(i);return l.length?{name:l,parentPath:u}:{name:u,parentPath:""}}e.splitName=a}),define(ee[147],te([0,1,17,7]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(w){return w.toJSON()}class M{constructor(S){this._uriTransformer=S}transformIncoming(S){const f=this._uriTransformer.transformIncoming(S);return f===S?S:n(D.URI.from(f))}transformOutgoing(S){const f=this._uriTransformer.transformOutgoing(S);return f===S?S:n(D.URI.from(f))}transformOutgoingURI(S){const f=this._uriTransformer.transformOutgoing(S);return f===S?S:D.URI.from(f)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function k(w,S,f){if(!w||f>200)return null;if(typeof w=="object"){if(w instanceof D.URI)return S.transformOutgoing(w);for(const p in w)if(Object.hasOwnProperty.call(w,p)){const v=k(w[p],S,f+1);v!==null&&(w[p]=v)}}return null}function P(w,S){const f=k(w,S,0);return f===null?w:f}e.transformOutgoingURIs=P;function g(w,S,f,p){if(!w||p>200)return null;if(typeof w=="object"){if(w.$mid===1)return f?D.URI.revive(S.transformIncoming(w)):S.transformIncoming(w);if(w instanceof E.VSBuffer)return null;for(const v in w)if(Object.hasOwnProperty.call(w,v)){const o=g(w[v],S,f,p+1);o!==null&&(w[v]=o)}}return null}function h(w,S){const f=g(w,S,!1,0);return f===null?w:f}e.transformIncomingURIs=h;function y(w,S){const f=g(w,S,!0,0);return f===null?w:f}e.transformAndReviveIncomingURIs=y}),define(ee[85],te([0,1,26,13,61,31,135]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=n.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,w=0;const S=(0,E.networkInterfaces)();for(const f in S){const p=S[f];if(p)for(const{mac:v,internal:o}of p)o||(w+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(y+=1))}this._value=w>0?y/w:0}return this._value}};let P;async function g(){return P||(P=(async()=>await h()||M.generateUuid())()),P}e.getMachineId=g;async function h(){try{const y=await new Promise((S,f)=>{j(["crypto"],S,f)}),w=(0,k.getMac)();return y.createHash("sha256").update(w,"utf8").digest("hex")}catch(y){D.onUnexpectedError(y);return}}}),define(ee[23],te([0,1,41,26,148,8,32,79,9,4,18,7]),function(j,e,E,D,n,M,k,P,g,h,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function f(re,de=S.UNLINK){if((0,k.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return de===S.UNLINK?v(re):p(re)}async function p(re){try{const de=(0,k.randomPath)((0,D.tmpdir)());try{await E.promises.rename(re,de)}catch(ce){return ce.code==="ENOENT"?void 0:v(re)}v(de).catch(ce=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function v(re){return(0,n.promisify)(E.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function o(re){if((0,k.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function d(re,de){return I(await(de?m(re):(0,n.promisify)(E.readdir)(re)))}async function m(re){try{return await(0,n.promisify)(E.readdir)(re,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const de=[],ce=await d(re);for(const ge of ce){let x=!1,B=!1,O=!1;try{const z=await e.Promises.lstat((0,g.join)(re,ge));x=z.isFile(),B=z.isDirectory(),O=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}de.push({name:ge,isFile:()=>x,isDirectory:()=>B,isSymbolicLink:()=>O})}return de}function C(re){return I(E.readdirSync(re))}e.readdirSync=C;function I(re){return re.map(de=>typeof de=="string"?h.isMacintosh?(0,P.normalizeNFC)(de):de:(de.name=h.isMacintosh?(0,P.normalizeNFC)(de.name):de.name,de))}async function R(re){const de=await d(re),ce=[];for(const ge of de)await a.existsDirectory((0,g.join)(re,ge))&&ce.push(ge);return ce}function t(re,de=1e3){return new Promise(ce=>{let ge=!1;const x=setInterval(()=>{ge||(ge=!0,E.access(re,B=>{ge=!1,B&&(clearInterval(x),ce(void 0))}))},de)})}e.whenDeleted=t;var a;(function(re){async function de(x){let B;try{if(B=await e.Promises.lstat(x),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(h.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw z}throw O}}re.stat=de;async function ce(x){try{const{stat:B,symbolicLink:O}=await re.stat(x);return B.isFile()&&O?.dangling!==!0}catch{}return!1}re.existsFile=ce;async function ge(x){try{const{stat:B,symbolicLink:O}=await re.stat(x);return B.isDirectory()&&O?.dangling!==!0}catch{}return!1}re.existsDirectory=ge})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new M.ResourceQueue;function s(re,de,ce){return i.queueFor(w.URI.file(re),y.extUriBiasedIgnorePathCase).queue(()=>{const ge=b(ce);return new Promise((x,B)=>r(re,de,ge,O=>O?B(O):x()))})}let l=!0;function u(re){l=re}e.configureFlushOnWrite=u;function r(re,de,ce,ge){if(!l)return E.writeFile(re,de,{mode:ce.mode,flag:ce.flag},ge);E.open(re,ce.flag,ce.mode,(x,B)=>{if(x)return ge(x);E.writeFile(B,de,O=>{if(O)return E.close(B,()=>ge(O));E.fdatasync(B,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),u(!1)),E.close(B,K=>ge(K))))})})}function c(re,de,ce){const ge=b(ce);if(!l)return E.writeFileSync(re,de,{mode:ge.mode,flag:ge.flag});const x=E.openSync(re,ge.flag,ge.mode);try{E.writeFileSync(x,de);try{E.fdatasyncSync(x)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),u(!1)}}finally{E.closeSync(x)}}e.writeFileSync=c;function b(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function L(re,de){if(re!==de)try{await e.Promises.rename(re,de)}catch(ce){if(re.toLowerCase()!==de.toLowerCase()&&ce.code==="EXDEV"||re.endsWith("."))await T(re,de,{preserveSymlinks:!1}),await f(re,S.MOVE);else throw ce}}async function T(re,de,ce){return Y(re,de,{root:{source:re,target:de},options:ce,handledSourcePaths:new Set})}const F=511;async function Y(re,de,ce){if(ce.handledSourcePaths.has(re))return;ce.handledSourcePaths.add(re);const{stat:ge,symbolicLink:x}=await a.stat(re);if(x){if(ce.options.preserveSymlinks)try{return await ie(re,de,ce)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(x.dangling)return}return ge.isDirectory()?V(re,de,ge.mode&F,ce):G(re,de,ge.mode&F)}async function V(re,de,ce,ge){await e.Promises.mkdir(de,{recursive:!0,mode:ce});const x=await d(re);for(const B of x)await Y((0,g.join)(re,B),(0,g.join)(de,B),ge)}async function G(re,de,ce){await e.Promises.copyFile(re,de),await e.Promises.chmod(de,ce)}async function ie(re,de,ce){let ge=await e.Promises.readlink(re);(0,k.isEqualOrParent)(ge,ce.root.source,!h.isLinux)&&(ge=(0,g.join)(ce.root.target,ge.substr(ce.root.source.length+1))),await e.Promises.symlink(ge,de)}e.Promises=new class{get access(){return(0,n.promisify)(E.access)}get stat(){return(0,n.promisify)(E.stat)}get lstat(){return(0,n.promisify)(E.lstat)}get utimes(){return(0,n.promisify)(E.utimes)}get read(){return(re,de,ce,ge,x)=>new Promise((B,O)=>{E.read(re,de,ce,ge,x,(z,K,ne)=>z?O(z):B({bytesRead:K,buffer:ne}))})}get readFile(){return(0,n.promisify)(E.readFile)}get write(){return(re,de,ce,ge,x)=>new Promise((B,O)=>{E.write(re,de,ce,ge,x,(z,K,ne)=>z?O(z):B({bytesWritten:K,buffer:ne}))})}get appendFile(){return(0,n.promisify)(E.appendFile)}get fdatasync(){return(0,n.promisify)(E.fdatasync)}get truncate(){return(0,n.promisify)(E.truncate)}get rename(){return(0,n.promisify)(E.rename)}get copyFile(){return(0,n.promisify)(E.copyFile)}get open(){return(0,n.promisify)(E.open)}get close(){return(0,n.promisify)(E.close)}get symlink(){return(0,n.promisify)(E.symlink)}get readlink(){return(0,n.promisify)(E.readlink)}get chmod(){return(0,n.promisify)(E.chmod)}get mkdir(){return(0,n.promisify)(E.mkdir)}get unlink(){return(0,n.promisify)(E.unlink)}get rmdir(){return(0,n.promisify)(E.rmdir)}get realpath(){return(0,n.promisify)(E.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return R}get writeFile(){return s}get rm(){return f}get move(){return L}get copy(){return T}}}),define(ee[103],te([0,1,41,9,4,27,23]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(S){if(n.isLinux)return S;const f=(0,D.dirname)(S);if(S===f)return S;const p=((0,D.basename)(S)||S).toLowerCase();try{const o=(0,k.readdirSync)(f).filter(d=>d.toLowerCase()===p);if(o.length===1){const d=P(f);if(d)return(0,D.join)(d,o[0])}else if(o.length>1){const d=o.indexOf(p);if(d>=0){const m=P(f);if(m)return(0,D.join)(m,o[d])}}}catch{}return null}e.realcaseSync=P;async function g(S){if(n.isLinux)return S;const f=(0,D.dirname)(S);if(S===f)return S;const p=((0,D.basename)(S)||S).toLowerCase();try{const o=(await k.Promises.readdir(f)).filter(d=>d.toLowerCase()===p);if(o.length===1){const d=await g(f);if(d)return(0,D.join)(d,o[0])}else if(o.length>1){const d=o.indexOf(p);if(d>=0){const m=await g(f);if(m)return(0,D.join)(m,o[d])}}}catch{}return null}e.realcase=g;async function h(S){try{return await k.Promises.realpath(S)}catch{const p=w(S);return await k.Promises.access(p,E.constants.R_OK),p}}e.realpath=h;function y(S){try{return E.realpathSync(S)}catch{const p=w(S);return E.accessSync(p,E.constants.R_OK),p}}e.realpathSync=y;function w(S){return(0,M.rtrim)((0,D.normalize)(S),D.sep)}}),define(ee[149],te([0,1,26,9,23]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var g;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(g||(g={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class w{constructor(R,t,a){this.exePath=R,this.displayName=t,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await n.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:I=!1}={}){return I?h===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:I=!1,findPreview:R=!1}={}){const t=S({useAlternateBitness:I});if(!t)return null;const a=D.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(a))return null;let i=-1,s=null;for(const r of await n.Promises.readdir(a)){let c=-1;if(R){const L=r.indexOf("-");if(L<0)continue;const T=r.substring(0,L);if(!M.test(T)||r.substring(L+1)!=="preview")continue;c=parseInt(T,10)}else{if(!M.test(r))continue;c=parseInt(r,10)}if(c<=i)continue;const b=D.join(a,r,"pwsh.exe");!await n.SymlinkSupport.existsFile(b)||(s=b,i=c)}if(!s)return null;const l=t.includes("x86")?" (x86)":"",u=R?" Preview":"";return new w(s,`PowerShell${u}${l}`,!0)}async function p({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const R=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(R))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=I?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await n.Promises.readdir(R))if(t.test(i)){const s=D.join(R,i,"pwsh.exe");return new w(s,a)}return null}function v(){const I=D.join(E.homedir(),".dotnet","tools","pwsh.exe");return new w(I,".NET Core PowerShell Global Tool")}function o(){const I=D.join(process.env.windir,h===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(I,"Windows PowerShell",!0)}async function*d(){let I=await f();I&&(yield I),I=await f({useAlternateBitness:!0}),I&&(yield I),I=await p(),I&&(yield I),I=v(),I&&(yield I),I=await f({findPreview:!0}),I&&(yield I),I=await p({findPreview:!0}),I&&(yield I),I=await f({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=o(),I&&(yield I)}async function*m(){for await(const I of d())await I.exists()&&(yield I)}e.enumeratePowerShellInstallations=m;async function C(){for await(const I of m())return I;return null}e.getFirstAvailablePowerShellInstallation=C}),define(ee[86],te([0,1,9,4,36,82,10,23]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function g(w=n.env){return w.comspec||"cmd.exe"}e.getWindowsShell=g;function h(w){let S=[],f=!1;const p=function(v){if(f){S.push(v);return}(!w.send(v,d=>{if(d&&console.error(d),f=!1,S.length>0){const m=S.slice(0);S=[],m.forEach(C=>p(C))}})||D.isWindows)&&(f=!0)};return{send:p}}e.createQueuedSender=h;var y;(function(w){async function S(f,p,v){if(E.isAbsolute(f))return f;if(p===void 0&&(p=n.cwd()),E.dirname(f)!=="."||(v===void 0&&k.isString(n.env.PATH)&&(v=n.env.PATH.split(E.delimiter)),v===void 0||v.length===0))return E.join(p,f);async function d(m){if(await P.Promises.exists(m)){let C;try{C=await P.Promises.stat(m)}catch(I){I.message.startsWith("EACCES")&&(C=await P.Promises.lstat(m))}return C?!C.isDirectory():!1}return!1}for(const m of v){let C;if(E.isAbsolute(m)?C=E.join(m,f):C=E.join(p,m,f),await d(C))return C;let I=C+".com";if(await d(I)||(I=C+".exe",await d(I)))return I}return E.join(p,f)}w.findExecutable=S})(y=e.win32||(e.win32={}))}),define(ee[104],te([0,1,46,14]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(k){return new Promise((P,g)=>{let h;const y=new Map;function w(f,p,v,o,d){const m=y.get(p);if(f===k||m){const C={name:S(v),cmd:v,pid:f,ppid:p,load:o,mem:d};y.set(f,C),f===k&&(h=C),m&&(m.children||(m.children=[]),m.children.push(C),m.children.length>1&&(m.children=m.children.sort((I,R)=>I.pid-R.pid)))}}function S(f){const p=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,o=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,C=/--crashes-directory/,I=/\\pipe\\winpty-control/,R=/conhost\.exe/,t=/--type=([a-zA-Z-]+)/;if(C.exec(f))return"electron-crash-reporter";if(I.exec(f))return"winpty-process";if(R.exec(f))return"console-window-host (Windows internal process)";let a=t.exec(f);if(a&&a.length===2){if(a[1]==="renderer")return p.exec(f)?"shared-process":v.exec(f)?"issue-reporter":o.exec(f)?"process-explorer":"window";if(a[1]==="utility"){if(d.exec(f))return"utility-network-service";if(m.exec(f))return"extension-host"}else if(a[1]==="extensionHost")return"extension-host";return a[1]}const i=/[a-zA-Z-]+\.js/g;let s="";do a=i.exec(f),a&&(s+=a+" ");while(a);return s&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${s}`:f}if(process.platform==="win32"){const f=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,v)=>{j(["windows-process-tree"],p,v)}).then(p=>{p.getProcessList(k,v=>{if(!v){g(new Error(`Root process ${k} not found`));return}p.getProcessCpuUsage(v,o=>{const d=new Map;o.forEach(m=>{const C=f(m.commandLine||"");d.set(m.pid,{name:S(C),cmd:C,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),h=d.get(k),h?(d.forEach(m=>{const C=d.get(m.ppid);C&&(C.children||(C.children=[]),C.children.push(m))}),d.forEach(m=>{m.children&&(m.children=m.children.sort((C,I)=>C.pid-I.pid))}),P(h)):g(new Error(`Root process ${k} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let f=function(){let p=[h];const v=[];for(;p.length;){const d=p.shift();d&&(v.push(d.pid),d.children&&(p=p.concat(d.children)))}let o=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+v.join(" "),(0,E.exec)(o,{},(d,m,C)=>{if(d||C)g(d||new Error(C.toString()));else{const I=m.toString().split(`
`);for(let R=0;R<v.length;R++){const t=y.get(v[R]);t.load=parseFloat(I[R])}if(!h){g(new Error(`Root process ${k} not found`));return}P(h)}})};(0,E.exec)("which ps",{},(p,v,o)=>{if(p||o)if(process.platform!=="linux")g(p||new Error(o.toString()));else{const d=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(d,{},(m,C,I)=>{m||I?g(m||new Error(I.toString())):(M(C,w),f())})}else{const d=v.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${d} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(C,I,R)=>{C||R&&!R.includes("screen size is bogus")?g(C||new Error(R.toString())):(M(I,w),process.platform==="linux"?f():h?P(h):g(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=n;function M(k,P){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,h=k.toString().split(`
`);for(const y of h){const w=g.exec(y.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ee[150],te([0,1,26,4,149,86]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function k(w,S){return w===1?D.isWindows?y():M.getWindowsShell(S):g(w,S)}e.getSystemShell=k;let P=null;function g(w,S){if(D.isLinux&&w===2||D.isMacintosh&&w===3)return"/bin/bash";if(!P){let f;if(D.isWindows)f="/bin/bash";else{if(f=S.SHELL,!f)try{f=(0,E.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}P=f}return P}let h=null;async function y(){return h||(h=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),h}});var we=this&&this.__decorate||function(j,e,E,D){var n=arguments.length,M=n<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,E):D,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(j,e,E,D);else for(var P=j.length-1;P>=0;P--)(k=j[P])&&(M=(n<3?k(M):n>3?k(e,E,M):k(e,E))||M);return n>3&&M&&Object.defineProperty(e,E,M),M};define(ee[47],te([0,1,25,8,17,22,55,13,3,2,84,27,10]),function(j,e,E,D,n,M,k,P,g,h,y,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(f||(f={}));function p(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(v||(v={}));function o(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(d||(d={}));function m(B){let O=0;for(let z=0;;z+=7){const K=B.read(1);if(O|=(K.buffer[0]&127)<<z,!(K.buffer[0]&128))return O}}const C=i(0);function I(B,O){if(O===0){B.write(C);return}let z=0;for(let ne=O;ne!==0;ne=ne>>>7)z++;const K=n.VSBuffer.alloc(z);for(let ne=0;O!==0;ne++)K.buffer[ne]=O&127,O=O>>>7,O>0&&(K.buffer[ne]|=128);B.write(K)}class R{constructor(O){this.buffer=O,this.pos=0}read(O){const z=this.buffer.slice(this.pos,this.pos+O);return this.pos+=z.byteLength,z}}e.BufferReader=R;class t{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}e.BufferWriter=t;var a;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(a||(a={}));function i(B){const O=n.VSBuffer.alloc(1);return O.writeUInt8(B,0),O}const s={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},l=typeof Buffer<"u";function u(B,O){if(typeof O>"u")B.write(s.Undefined);else if(typeof O=="string"){const z=n.VSBuffer.fromString(O);B.write(s.String),I(B,z.byteLength),B.write(z)}else if(l&&Buffer.isBuffer(O)){const z=n.VSBuffer.wrap(O);B.write(s.Buffer),I(B,z.byteLength),B.write(z)}else if(O instanceof n.VSBuffer)B.write(s.VSBuffer),I(B,O.byteLength),B.write(O);else if(Array.isArray(O)){B.write(s.Array),I(B,O.length);for(const z of O)u(B,z)}else if(typeof O=="number"&&(O|0)===O)B.write(s.Uint),I(B,O);else{const z=n.VSBuffer.fromString(JSON.stringify(O));B.write(s.Object),I(B,z.byteLength),B.write(z)}}e.serialize=u;function r(B){switch(B.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return B.read(m(B)).toString();case a.Buffer:return B.read(m(B)).buffer;case a.VSBuffer:return B.read(m(B));case a.Array:{const z=m(B),K=[];for(let ne=0;ne<z;ne++)K.push(r(B));return K}case a.Object:return JSON.parse(B.read(m(B)).toString());case a.Int:return m(B)}}e.deserialize=r;class c{constructor(O,z,K=null,ne=1e3){this.protocol=O,this.ctx=z,this.logger=K,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(se=>this.onRawMessage(se)),this.sendResponse({type:200})}registerChannel(O,z){this.channels.set(O,z),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const z=this.send([O.type]);this.logger?.logOutgoing(z,0,1,o(O.type));return}case 201:case 202:case 204:case 203:{const z=this.send([O.type,O.id],O.data);this.logger?.logOutgoing(z,O.id,1,o(O.type),O.data);return}}}send(O,z=void 0){const K=new t;return u(K,O),u(K,z),this.sendBuffer(K.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onRawMessage(O){const z=new R(O),K=r(z),ne=r(z),se=K[0];switch(se){case 100:return this.logger?.logIncoming(O.byteLength,K[1],1,`${p(se)}: ${K[2]}.${K[3]}`,ne),this.onPromise({type:se,id:K[1],channelName:K[2],name:K[3],arg:ne});case 102:return this.logger?.logIncoming(O.byteLength,K[1],1,`${p(se)}: ${K[2]}.${K[3]}`,ne),this.onEventListen({type:se,id:K[1],channelName:K[2],name:K[3],arg:ne});case 101:return this.logger?.logIncoming(O.byteLength,K[1],1,`${p(se)}`),this.disposeActiveRequest({type:se,id:K[1]});case 103:return this.logger?.logIncoming(O.byteLength,K[1],1,`${p(se)}`),this.disposeActiveRequest({type:se,id:K[1]})}}onPromise(O){const z=this.channels.get(O.channelName);if(!z){this.collectPendingRequest(O);return}const K=new M.CancellationTokenSource;let ne;try{ne=z.call(this.ctx,O.name,O.arg,K.token)}catch(W){ne=Promise.reject(W)}const se=O.id;ne.then(W=>{this.sendResponse({id:se,data:W,type:201}),this.activeRequests.delete(O.id)},W=>{W instanceof Error?this.sendResponse({id:se,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:se,data:W,type:203}),this.activeRequests.delete(O.id)});const J=(0,h.toDisposable)(()=>K.cancel());this.activeRequests.set(O.id,J)}onEventListen(O){const z=this.channels.get(O.channelName);if(!z){this.collectPendingRequest(O);return}const K=O.id,se=z.listen(this.ctx,O.name,O.arg)(J=>this.sendResponse({id:K,data:J,type:204}));this.activeRequests.set(O.id,se)}disposeActiveRequest(O){const z=this.activeRequests.get(O.id);z&&(z.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let z=this.pendingRequests.get(O.channelName);z||(z=[],this.pendingRequests.set(O.channelName,z));const K=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:O,timeoutTimer:K})}flushPendingRequests(O){const z=this.pendingRequests.get(O);if(z){for(const K of z)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var b;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(O,z=null){this.protocol=O,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=z}getChannel(O){const z=this;return{call(K,ne,se){return z.isDisposed?Promise.reject(new P.CancellationError):z.requestPromise(O,K,ne,se)},listen(K,ne){return z.isDisposed?g.Event.None:z.requestEvent(O,K,ne)}}}requestPromise(O,z,K,ne=M.CancellationToken.None){const se=this.lastRequestId++,W={id:se,type:100,channelName:O,name:z,arg:K};if(ne.isCancellationRequested)return Promise.reject(new P.CancellationError);let A;return new Promise((N,q)=>{if(ne.isCancellationRequested)return q(new P.CancellationError);const U=()=>{const fe=pe=>{switch(pe.type){case 201:this.handlers.delete(se),N(pe.data);break;case 202:{this.handlers.delete(se);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,q(ye);break}case 203:this.handlers.delete(se),q(pe.data);break}};this.handlers.set(se,fe),this.sendRequest(W)};let $=null;this.state===d.Idle?U():($=(0,D.createCancelablePromise)(fe=>this.whenInitialized()),$.then(()=>{$=null,U()}));const H=()=>{$?($.cancel(),$=null):this.sendRequest({id:se,type:101}),q(new P.CancellationError)},oe=ne.onCancellationRequested(H);A=(0,h.combinedDisposable)((0,h.toDisposable)(H),oe),this.activeRequests.add(A)}).finally(()=>{this.activeRequests.delete(A)})}requestEvent(O,z,K){const ne=this.lastRequestId++,J={id:ne,type:102,channelName:O,name:z,arg:K};let W=null;const A=new g.Emitter({onWillAddFirstListener:()=>{W=(0,D.createCancelablePromise)(N=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(A),this.sendRequest(J)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(A),this.sendRequest({id:ne,type:103}))}}),_=N=>A.fire(N.data);return this.handlers.set(ne,_),A.event}sendRequest(O){switch(O.type){case 100:case 102:{const z=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger?.logOutgoing(z,O.id,0,`${p(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const z=this.send([O.type,O.id]);this.logger?.logOutgoing(z,O.id,0,p(O.type));return}}}send(O,z=void 0){const K=new t;return u(K,O),u(K,z),this.sendBuffer(K.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onBuffer(O){const z=new R(O),K=r(z),ne=r(z),se=K[0];switch(se){case 200:return this.logger?.logIncoming(O.byteLength,0,0,o(se)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(O.byteLength,K[1],0,o(se),ne),this.onResponse({type:K[0],id:K[1],data:ne})}}onResponse(O){if(O.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(O.id)?.(O)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}we([k.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class T{get connections(){const O=[];return this._connections.forEach(z=>O.push(z)),O}constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:z,onDidClientDisconnect:K})=>{g.Event.once(z.onMessage)(se=>{const J=new R(se),W=r(J),A=new c(z,W),_=new L(z);this.channels.forEach((q,U)=>A.registerChannel(U,q));const N={channelServer:A,channelClient:_,ctx:W};this._connections.add(N),this._onDidAddConnection.fire(N),K(()=>{A.dispose(),_.dispose(),this._connections.delete(N),this._onDidRemoveConnection.fire(N)})})})}getChannel(O,z){const K=this;return{call(ne,se,J){let W;if((0,S.isFunction)(z)){const _=(0,E.getRandomElement)(K.connections.filter(z));W=_?Promise.resolve(_):g.Event.toPromise(g.Event.filter(K.onDidAddConnection,z))}else W=z.routeCall(K,ne,se);const A=W.then(_=>_.channelClient.getChannel(O));return Y(A).call(ne,se,J)},listen(ne,se){if((0,S.isFunction)(z))return K.getMulticastEvent(O,z,ne,se);const J=z.routeEvent(K,ne,se).then(W=>W.channelClient.getChannel(O));return Y(J).listen(ne,se)}}}getMulticastEvent(O,z,K,ne){const se=this;let J=new h.DisposableStore;const W=new g.Emitter({onWillAddFirstListener:()=>{J=new h.DisposableStore;const A=new g.EventMultiplexer,_=new Map,N=U=>{const H=U.channelClient.getChannel(O).listen(K,ne),oe=A.add(H);_.set(U,oe)},q=U=>{const $=_.get(U);!$||($.dispose(),_.delete(U))};se.connections.filter(z).forEach(N),g.Event.filter(se.onDidAddConnection,z)(N,void 0,J),se.onDidRemoveConnection(q,void 0,J),A.event(W.fire,W,J),J.add(A)},onDidRemoveLastListener:()=>{J.dispose()}});return W.event}registerChannel(O,z){this.channels.set(O,z),this._connections.forEach(K=>{K.channelServer.registerChannel(O,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class F{constructor(O,z,K=null){const ne=new t;u(ne,z),O.send(ne.buffer),this.channelClient=new L(O,K),this.channelServer=new c(O,z,K)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,z){this.channelServer.registerChannel(O,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function Y(B){return{call(O,z,K){return B.then(ne=>ne.call(O,z,K))},listen(O,z){const K=new g.Relay;return B.then(ne=>K.input=ne.listen(O,z)),K.event}}}e.getDelayedChannel=Y;function V(B){let O=!1;return{call(z,K,ne){return O?B.call(z,K,ne):(0,D.timeout)(0).then(()=>O=!0).then(()=>B.call(z,K,ne))},listen(z,K){if(O)return B.listen(z,K);const ne=new g.Relay;return(0,D.timeout)(0).then(()=>O=!0).then(()=>ne.input=B.listen(z,K)),ne.event}}}e.getNextTickChannel=V;class G{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const z of O.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await g.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=G;var ie;(function(B){function O(se,J){const W=se,A=J&&J.disableMarshalling,_=new Map;for(const N in W)K(N)&&_.set(N,g.Event.buffer(W[N],!0));return new class{listen(N,q,U){const $=_.get(q);if($)return $;if(ne(q)){const H=W[q];if(typeof H=="function")return H.call(W,U)}throw new Error(`Event not found: ${q}`)}call(N,q,U){const $=W[q];if(typeof $=="function"){if(!A&&Array.isArray(U))for(let H=0;H<U.length;H++)U[H]=(0,y.revive)(U[H]);return $.apply(W,U)}throw new Error(`Method not found: ${q}`)}}}B.fromService=O;function z(se,J){const W=J&&J.disableMarshalling;return new Proxy({},{get(A,_){if(typeof _=="string")return J?.properties?.has(_)?J.properties.get(_):ne(_)?function(N){return se.listen(_,N)}:K(_)?se.listen(_):async function(...N){let q;J&&!(0,S.isUndefinedOrNull)(J.context)?q=[J.context,...N]:q=N;const U=await se.call(_,q);return W?U:(0,y.revive)(U)};throw new Error(`Property not found: ${String(_)}`)}})}B.toService=z;function K(se){return se[0]==="o"&&se[1]==="n"&&w.isUpperAsciiLetter(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&w.isUpperAsciiLetter(se.charCodeAt(9))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const O=B.toString();if(O!=="[object Object]")return O}return B}function ce(B){return Array.isArray(B)?B.map(de):de(B)}function ge(B,O,z,K,ne,se,J){J=ce(J);const W=re[ne],A=W[K%W.length];let _=[`%c[${B}]%c[${String(O).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(se)?(_=_.concat(J),_.push(")")):_.push(J),console.log.apply(console,_)}class x{constructor(O,z){this._outgoingPrefix=O,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,z,K,ne,se){this._totalOutgoing+=O,ge(this._outgoingPrefix,this._totalOutgoing,O,z,K,ne,se)}logIncoming(O,z,K,ne,se){this._totalIncoming+=O,ge(this._incomingPrefix,this._totalIncoming,O,z,K,ne,se)}}e.IPCLogger=x}),define(ee[151],te([0,1,17,3,47]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(g){this.port=g,this.onMessage=D.Event.fromDOMEventEmitter(this.port,"message",h=>E.VSBuffer.wrap(h.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class k extends n.IPCClient{constructor(g,h){const y=new M(g);super(y,h),this.protocol=y}dispose(){this.protocol.disconnect()}}e.Client=k}),define(ee[105],te([0,1,8,17,3,2,47]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(L){L.Created="created",L.Read="read",L.Write="write",L.Open="open",L.Error="error",L.Close="close",L.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",L.NodeEndReceived="nodeEndReceived",L.NodeEndSent="nodeEndSent",L.NodeDrainBegin="nodeDrainBegin",L.NodeDrainEnd="nodeDrainEnd",L.zlibInflateError="zlibInflateError",L.zlibInflateData="zlibInflateData",L.zlibInflateInitialWrite="zlibInflateInitialWrite",L.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",L.zlibInflateWrite="zlibInflateWrite",L.zlibInflateFlushFired="zlibInflateFlushFired",L.zlibDeflateError="zlibDeflateError",L.zlibDeflateData="zlibDeflateData",L.zlibDeflateWrite="zlibDeflateWrite",L.zlibDeflateFlushFired="zlibDeflateFlushFired",L.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",L.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",L.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",L.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",L.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",L.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",L.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",L.ProtocolHeaderRead="protocolHeaderRead",L.ProtocolMessageRead="protocolMessageRead",L.ProtocolHeaderWrite="protocolHeaderWrite",L.ProtocolMessageWrite="protocolMessageWrite",L.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var g;(function(L){L.enableDiagnostics=!1,L.records=[];const T=new WeakMap;let F=0;function Y(G,ie){if(!T.has(G)){const re=String(++F);T.set(G,re)}return T.get(G)}function V(G,ie,re,de){if(!L.enableDiagnostics)return;const ce=Y(G,ie);if(de instanceof D.VSBuffer||de instanceof Uint8Array||de instanceof ArrayBuffer||ArrayBuffer.isView(de)){const ge=D.VSBuffer.alloc(de.byteLength);ge.set(de),L.records.push({timestamp:Date.now(),id:ce,label:ie,type:re,buff:ge})}else L.records.push({timestamp:Date.now(),id:ce,label:ie,type:re,data:de})}L.traceSocketEvent=V})(g=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(L){L[L.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",L[L.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function w(){return y||(y=D.VSBuffer.alloc(0)),y}class S{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(T){this._chunks.push(T),this._totalLength+=T.byteLength}read(T){return this._read(T,!0)}peek(T){return this._read(T,!1)}_read(T,F){if(T===0)return w();if(T>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===T){const ie=this._chunks[0];return F&&(this._chunks.shift(),this._totalLength-=T),ie}if(this._chunks[0].byteLength>T){const ie=this._chunks[0].slice(0,T);return F&&(this._chunks[0]=this._chunks[0].slice(T),this._totalLength-=T),ie}const Y=D.VSBuffer.alloc(T);let V=0,G=0;for(;T>0;){const ie=this._chunks[G];if(ie.byteLength>T){const re=ie.slice(0,T);Y.set(re,V),V+=T,F&&(this._chunks[G]=ie.slice(T),this._totalLength-=T),T-=T}else Y.set(ie,V),V+=ie.byteLength,F?(this._chunks.shift(),this._totalLength-=ie.byteLength):G++,T-=ie.byteLength}return Y}}e.ChunkStream=S;var f;(function(L){L[L.None=0]="None",L[L.Regular=1]="Regular",L[L.Control=2]="Control",L[L.Ack=3]="Ack",L[L.Disconnect=5]="Disconnect",L[L.ReplayRequest=6]="ReplayRequest",L[L.Pause=7]="Pause",L[L.Resume=8]="Resume",L[L.KeepAlive=9]="KeepAlive",L[L.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",L[L.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function p(L){switch(L){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(L){L[L.HeaderLength=13]="HeaderLength",L[L.AcknowledgeTime=2e3]="AcknowledgeTime",L[L.TimeoutTime=2e4]="TimeoutTime",L[L.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",L[L.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",L[L.KeepAliveSendTime=5e3]="KeepAliveSendTime",L[L.LatencySampleTime=6e4]="LatencySampleTime",L[L.LatencySampleCount=5]="LatencySampleCount",L[L.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",L[L.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class o{constructor(T,F,Y,V){this.type=T,this.id=F,this.ack=Y,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends M.Disposable{constructor(T){super(),this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=T,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(T);this._incomingData.byteLength>=this._state.readLen;){const F=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=F.readUInt32BE(9),this._state.messageType=F.readUInt8(0),this._state.id=F.readUInt32BE(1),this._state.ack=F.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const Y=this._state.messageType,V=this._state.id,G=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",F),this._onMessage.fire(new o(Y,V,G,F)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(T){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=T,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(T){if(this._isDisposed)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=D.VSBuffer.alloc(13);F.writeUInt8(T.type,0),F.writeUInt32BE(T.id,1),F.writeUInt32BE(T.ack,5),F.writeUInt32BE(T.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",T.data),this._writeSoon(F,T.data)}_bufferAdd(T,F){const Y=this._totalLength===0;return this._data.push(T,F),this._totalLength+=T.byteLength+F.byteLength,Y}_bufferTake(){const T=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,T}_writeSoon(T,F){this._bufferAdd(T,F)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const T=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this._socket.write(T)}}class C extends M.Disposable{constructor(T){super(),this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=T,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(F=>{F.type===1&&this._onMessage.fire(F.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(T){this._socketWriter.write(new o(1,0,0,T))}}e.Protocol=C;class I extends k.IPCClient{static fromSocket(T,F){return new I(new C(T),F)}get onDidDispose(){return this.protocol.onDidDispose}constructor(T,F,Y=null){super(T,F,Y),this.protocol=T}dispose(){super.dispose();const T=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),T.end()}}e.Client=I;class R{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(T){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(T):this._emitter.fire(T):this._bufferedMessages.push(T)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=R;class t{constructor(T){this.data=T,this.next=null}}class a{constructor(){this._first=null,this._last=null}length(){let T=0,F=this._first;for(;F;)F=F.next,T++;return T}peek(){return this._first?this._first.data:null}toArray(){const T=[];let F=0,Y=this._first;for(;Y;)T[F++]=Y.data,Y=Y.next;return T}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(T){const F=new t(T);if(!this._first){this._first=F,this._last=F;return}this._last.next=F,this._last=F}}class i{static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}constructor(){this.lastRuns=[];const T=Date.now();for(let F=0;F<i._HISTORY_LENGTH;F++)this.lastRuns[F]=T-1e3*F;setInterval(()=>{for(let F=i._HISTORY_LENGTH;F>=1;F--)this.lastRuns[F]=this.lastRuns[F-1];this.lastRuns[0]=Date.now()},1e3)}load(){const T=Date.now(),F=(1+i._HISTORY_LENGTH)*1e3;let Y=0;for(let V=0;V<i._HISTORY_LENGTH;V++)T-this.lastRuns[V]<=F&&Y++;return 1-Y/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;var s;(function(L){L[L.Good=0]="Good",L[L.Poor=1]="Poor"})(s=e.ConnectionHealth||(e.ConnectionHealth={}));function l(L){switch(L){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=l;class u{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=u;class r{constructor(T,F){this.roundTripTime=T,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=r;class c{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(T){this._onControlMessage=new R,this.onControlMessage=this._onControlMessage.event,this._onMessage=new R,this.onMessage=this._onMessage.event,this._onDidDispose=new R,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new R,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new R,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new R,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new R,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=T.loadEstimator??i.getInstance(),this._measureRoundTripTime=T.measureRoundTripTime??!1,this._shouldSendKeepAlive=T.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new M.DisposableStore,this._socket=T.socket,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(F=>this._receiveMessage(F))),this._socketDisposables.add(this._socket.onClose(F=>this._onSocketClose.fire(F))),this._socketLatencyMonitor=this._socketDisposables.add(new b),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(F=>this._sendLatencyMeasurementRequest(F))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(F=>this._onHighRoundTripTime.fire(F))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(F=>this._onDidChangeConnectionHealth.fire(F))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),T.initialChunk&&this._socketReader.acceptChunk(T.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const T=new o(5,0,0,w());this._socketWriter.write(T),this._socketWriter.flush()}sendPause(){const T=new o(7,0,0,w());this._socketWriter.write(T)}sendResume(){const T=new o(8,0,0,w());this._socketWriter.write(T)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(T,F){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new M.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=T,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(Y=>this._receiveMessage(Y))),this._socketDisposables.add(this._socket.onClose(Y=>this._onSocketClose.fire(Y))),this._socketLatencyMonitor=this._socketDisposables.add(new b),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(Y=>this._sendLatencyMeasurementRequest(Y))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(Y=>this._onHighRoundTripTime.fire(Y))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(Y=>this._onDidChangeConnectionHealth.fire(Y))),this._socketReader.acceptChunk(F)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const T=new o(3,0,this._incomingAckId,w());this._socketWriter.write(T);const F=this._outgoingUnackMsg.toArray();for(let Y=0,V=F.length;Y<V;Y++)this._socketWriter.write(F[Y]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(T){if(T.ack>this._outgoingAckId){this._outgoingAckId=T.ack;do{const F=this._outgoingUnackMsg.peek();if(F&&F.id<=T.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this._incomingMsgId)if(T.id!==this._incomingMsgId+1){const F=Date.now();F-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=F,this._socketWriter.write(new o(6,0,0,w())))}else this._incomingMsgId=T.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(T.data);break}case 2:{this._onControlMessage.fire(T.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const F=this._outgoingUnackMsg.toArray();for(let Y=0,V=F.length;Y<V;Y++)this._socketWriter.write(F[Y]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(T.data);break}case 11:{this._socketLatencyMonitor.handleResponse(T.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(T){const F=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const Y=new o(1,F,this._incomingAckId,T);this._outgoingUnackMsg.push(Y),this._isReconnecting||(this._socketWriter.write(Y),this._recvAckCheck())}sendControl(T){const F=new o(2,0,0,T);this._socketWriter.write(F)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const T=Date.now()-this._incomingMsgLastTime;if(T>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-T+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const T=this._outgoingUnackMsg.peek(),F=Date.now()-T.writtenTime,Y=Date.now()-this._socketReader.lastReadTime,V=Date.now()-this._lastSocketTimeoutTime;if(F>=2e4&&Y>=2e4&&V>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:Y});return}const G=Math.max(2e4-F,2e4-Y,2e4-V,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},G)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const T=new o(3,0,this._incomingAckId,w());this._socketWriter.write(T)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const T=new o(9,0,this._incomingAckId,w());this._socketWriter.write(T)}_sendLatencyMeasurementRequest(T){this._incomingAckId=this._incomingMsgId;const F=new o(10,0,this._incomingAckId,T);this._socketWriter.write(F)}_sendLatencyMeasurementResponse(T){this._incomingAckId=this._incomingMsgId;const F=new o(11,0,this._incomingAckId,T);this._socketWriter.write(F)}}e.PersistentProtocol=c;class b extends M.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new n.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new n.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new n.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new E.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},T=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const T=++this._lastLatencyMeasurementId,F=D.VSBuffer.alloc(4);F.writeUInt32BE(T,0),this._onSendLatencyRequest.fire(F)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const F=T.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||F!==this._lastLatencyMeasurementId)return;const Y=Date.now()-this._lastLatencyMeasurementSent,V=this._latencySampleIndex++;this._latencySamples[V%this._latencySamples.length]=Y;const G=this._connectionHealth,ie=this._latencySamples.filter(re=>re>=1e3).length;this._connectionHealth=ie>=3?1:0,Y>1e3&&this._onHighRoundTripTime.fire(new r(Y,ie)),G!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(ee[152],te([0,1,42,17,3,2,47,137]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(y,w){const S=n.Event.fromNodeEventEmitter(E.validatedIpcMain,w,(p,v)=>({event:p,message:v})),f=n.Event.filter(S,({event:p})=>p.sender.id===y);return n.Event.map(f,({message:p})=>p&&D.VSBuffer.wrap(p))}class h extends k.IPCServer{static getOnDidClientConnect(){const w=n.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:S})=>S);return n.Event.map(w,S=>{const f=S.id;h.Clients.get(f)?.dispose();const v=new n.Emitter;h.Clients.set(f,(0,M.toDisposable)(()=>v.fire()));const o=g(f,"vscode:message"),d=n.Event.any(n.Event.signal(g(f,"vscode:disconnect")),v.event);return{protocol:new P.Protocol(S,o),onDidClientDisconnect:d}})}constructor(){super(h.getOnDidClientConnect())}}h.Clients=new Map,e.Server=h}),define(ee[106],te([0,1,42,3,31,151]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends M.Client{constructor(h,y){super({addEventListener:(w,S)=>h.addListener(w,S),removeEventListener:(w,S)=>h.removeListener(w,S),postMessage:w=>h.postMessage(w),start:()=>h.start(),close:()=>h.close()},y)}}e.Client=k;async function P(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const h=(0,n.generateUuid)();g.webContents.send("vscode:createMessageChannel",h);const y=D.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(S,f)=>({nonce:f,port:S.ports[0]})),{port:w}=await D.Event.toPromise(D.Event.once(D.Event.filter(y,S=>S.nonce===h)));return w}e.connect=P}),define(ee[153],te([0,1,46,8,17,22,146,13,3,2,40,86,82,47]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",m=>n.VSBuffer.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=p;class v{constructor(d,m){this.modulePath=d,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const C=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new D.Delayer(C),this.child=null,this._client=null}getChannel(d){const m=this;return{call(C,I,R){return m.requestPromise(d,C,I,R)},listen(C,I){return m.requestEvent(d,C,I)}}}requestPromise(d,m,C,I=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const R=this.getCachedChannel(d),t=(0,D.createCancelablePromise)(s=>R.call(m,C,s)),a=I.onCancellationRequested(()=>t.cancel()),i=(0,h.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{a.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(d,m,C){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let I;const R=new g.Emitter({onWillAddFirstListener:()=>{I=this.getCachedChannel(d).listen(m,C)(R.fire,R),this.activeRequests.add(I)},onDidRemoveLastListener:()=>{this.activeRequests.delete(I),I.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return R.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),(0,S.removeDangerousEnvVariables)(m.env),this.child=(0,E.fork)(this.modulePath,d,m);const C=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,k.isRemoteConsoleLog)(l)){(0,k.log)(l,`IPC Library: ${this.options.serverName}`);return}C.fire(n.VSBuffer.wrap(Buffer.from(l,"base64")))});const R=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&R.send(l.buffer.toString("base64")),a=C.event,i={send:t,onMessage:a};this._client=new f.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,u)=>{process.removeListener("exit",s),this.activeRequests.forEach(r=>(0,h.dispose)(r)),this.activeRequests.clear(),l!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:u})})}return this._client}getCachedChannel(d){let m=this.channels.get(d);return m||(m=this.client.getChannel(d),this.channels.set(d,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(ee[87],te([0,1,17,13,3,2,9,4,31,47,105]),function(j,e,E,D,n,M,k,P,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class S{traceSocketEvent(r,c){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,c)}constructor(r,c=""){this._canWrite=!0,this.debugLabel=c,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=b=>{if(this.traceSocketEvent("error",{code:b?.code,message:b?.message}),b){if(b.code==="EPIPE")return;(0,D.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener),this._closeListener=b=>{this.traceSocketEvent("close",{hadError:b}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(r){const c=b=>{this.traceSocketEvent("read",b),r(E.VSBuffer.wrap(b))};return this.socket.on("data",c),{dispose:()=>this.socket.off("data",c)}}onClose(r){const c=b=>{r({type:0,hadError:b,error:void 0})};return this.socket.on("close",c),{dispose:()=>this.socket.off("close",c)}}onEnd(r){const c=()=>{r()};return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(r){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,c=>{if(c){if(c.code==="EPIPE")return;(0,D.onUnexpectedError)(c)}})}catch(c){if(c.code==="EPIPE")return;(0,D.onUnexpectedError)(c)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,c)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=S;var f;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var p;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(p||(p={}));class v extends M.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(r,c){this.socket.traceSocketEvent(r,c)}constructor(r,c,b,L){super(),this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:c,inflateBytesLength:b?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new o(this,c,b,L,this._onData,(T,F)=>this._write(T,F))),this._register(this._flowManager.onError(T=>{console.error(T),(0,D.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this._onData.event(r)}onClose(r){return this._onClose.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this._flowManager.writeMessage(r)}_write(r,c){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let b=2;r.byteLength<126?b+=0:r.byteLength<2**16?b+=2:b+=8;const L=E.VSBuffer.alloc(b);if(c?L.writeUInt8(194,0):L.writeUInt8(130,0),r.byteLength<126)L.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){L.writeUInt8(126,1);let T=1;L.writeUInt8(r.byteLength>>>8&255,++T),L.writeUInt8(r.byteLength>>>0&255,++T)}else{L.writeUInt8(127,1);let T=1;L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(r.byteLength>>>24&255,++T),L.writeUInt8(r.byteLength>>>16&255,++T),L.writeUInt8(r.byteLength>>>8&255,++T),L.writeUInt8(r.byteLength>>>0&255,++T)}this.socket.write(E.VSBuffer.concat([L,r]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(r){if(r.byteLength!==0){for(this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const c=this._incomingData.peek(this._state.readLen),b=c.readUInt8(0),L=(b&128)>>>7,T=(b&64)>>>6,F=c.readUInt8(1),Y=(F&128)>>>7,V=F&127;this._state.state=2,this._state.readLen=2+(Y?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const c=this._incomingData.read(this._state.readLen),b=c.readUInt8(1),L=(b&128)>>>7;let T=b&127,F=1;T===126?T=c.readUInt8(++F)*2**8+c.readUInt8(++F):T===127&&(T=c.readUInt8(++F)*0+c.readUInt8(++F)*0+c.readUInt8(++F)*0+c.readUInt8(++F)*0+c.readUInt8(++F)*2**24+c.readUInt8(++F)*2**16+c.readUInt8(++F)*2**8+c.readUInt8(++F));let Y=0;L&&(Y=c.readUInt8(++F)*2**24+c.readUInt8(++F)*2**16+c.readUInt8(++F)*2**8+c.readUInt8(++F)),this._state.state=3,this._state.readLen=T,this._state.mask=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const c=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",c),C(c,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",c),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(c,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await n.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class o extends M.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(r,c,b,L,T,F){super(),this._tracer=r,this._onData=T,this._writeFn=F,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new n.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,c?(this._zlibInflateStream=this._register(new d(this._tracer,L,b,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Y=>this._onError.fire(Y))),this._register(this._zlibDeflateStream.onError(Y=>this._onError.fire(Y)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(r){this._writeQueue.push(r),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const r=this._writeQueue.shift();if(this._zlibDeflateStream){const c=await this._deflateMessage(this._zlibDeflateStream,r);this._writeFn(c,!0)}else this._writeFn(r,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(r,c){return new Promise((b,L)=>{r.write(c),r.flush(T=>b(T))})}acceptFrame(r,c,b){this._readQueue.push({data:r,isCompressed:c,isLastFrameOfMessage:b}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const r=this._readQueue.shift();if(this._zlibInflateStream&&r.isCompressed){const c=await this._inflateFrame(this._zlibInflateStream,r.data,r.isLastFrameOfMessage);this._onData.fire(c)}else this._onData.fire(r.data)}this._isProcessingReadQueue=!1}}_inflateFrame(r,c,b){return new Promise((L,T)=>{r.write(c),b&&r.write(E.VSBuffer.fromByteArray([0,0,255,255])),r.flush(F=>L(F))})}}class d extends M.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?E.VSBuffer.concat(this._recordedInflateBytes):E.VSBuffer.alloc(0)}constructor(r,c,b,L){super(),this._tracer=r,this._recordInflateBytes=c,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w().zlib.createInflateRaw(L),this._zlibInflate.on("error",T=>{this._tracer.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibInflate.on("data",T=>{this._tracer.traceSocketEvent("zlibInflateData",T),this._pendingInflateData.push(E.VSBuffer.wrap(T))}),b&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",b.buffer),this._zlibInflate.write(b.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(r){this._recordInflateBytes&&this._recordedInflateBytes.push(r.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",r),this._zlibInflate.write(r.buffer)}flush(r){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const c=E.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,r(c)})}}class m extends M.Disposable{constructor(r,c){super(),this._tracer=r,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",b=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:b?.message,code:b?.code}),this._onError.fire(b)}),this._zlibDeflate.on("data",b=>{this._tracer.traceSocketEvent("zlibDeflateData",b),this._pendingDeflateData.push(E.VSBuffer.wrap(b))})}write(r){this._tracer.traceSocketEvent("zlibDeflateWrite",r.buffer),this._zlibDeflate.write(r.buffer)}flush(r){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let c=E.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,c=c.slice(0,c.byteLength-4),r(c)})}}function C(u,r){if(r===0)return;const c=u.byteLength>>>2;for(let V=0;V<c;V++){const G=u.readUInt32BE(V*4);u.writeUInt32BE(G^r,V*4)}const b=c*4,L=u.byteLength-b,T=r>>>24&255,F=r>>>16&255,Y=r>>>8&255;L>=1&&u.writeUInt8(u.readUInt8(b)^T,b),L>=2&&u.writeUInt8(u.readUInt8(b+1)^F,b+1),L>=3&&u.writeUInt8(u.readUInt8(b+2)^Y,b+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const I={[2]:107,[1]:103};function R(){const u=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):r=(0,k.join)(w().os.tmpdir(),`vscode-ipc-${u}.sock`),a(r),r}e.createRandomIPCHandle=R;function t(u,r,c){const b=w().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${c}-${r}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${c}-${r}.sock`):L=(0,k.join)(u,`${c}-${r}.sock`),a(L),L}e.createStaticIPCHandle=t;function a(u){const r=I[P.platform];typeof r=="number"&&u.length>=r&&console.warn(`WARNING: IPC handle "${u}" is longer than ${r} chars, try a shorter --user-data-dir`)}class i extends h.IPCServer{static toClientConnectionEvent(r){const c=n.Event.fromNodeEventEmitter(r,"connection");return n.Event.map(c,b=>({protocol:new y.Protocol(new S(b,"ipc-server-connection")),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(b,"close"))}))}constructor(r){super(i.toClientConnectionEvent(r)),this.server=r}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function s(u){return new Promise((r,c)=>{const b=w().net.createServer();b.on("error",c),b.listen(u,()=>{b.removeListener("error",c),r(new i(b))})})}e.serve=s;function l(u,r){return new Promise((c,b)=>{const L=w().net.createConnection(u,()=>{L.removeListener("error",b),c(y.Client.fromSocket(new S(L,`ipc-client${r}`),r))});L.once("error",b)})}e.connect=l}),define(ee[107],te([0,1,8,3,2,10]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k=e.StorageHint||(e.StorageHint={}));function P(w){const S=w;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var g;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class h extends n.Disposable{constructor(S,f=Object.create(null)){super(),this.database=S,this.options=f,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((f,p)=>this.accept(p,f)),S.deleted?.forEach(f=>this.accept(f,void 0))}accept(S,f){if(this.state===g.Closed)return;let p=!1;(0,M.isUndefinedOrNull)(f)?p=this.cache.delete(S):this.cache.get(S)!==f&&(this.cache.set(S,f),p=!0),p&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,f){const p=this.cache.get(S);return(0,M.isUndefinedOrNull)(p)?f:p}getBoolean(S,f){const p=this.get(S);return(0,M.isUndefinedOrNull)(p)?f:p==="true"}getNumber(S,f){const p=this.get(S);return(0,M.isUndefinedOrNull)(p)?f:parseInt(p,10)}async set(S,f){if(this.state===g.Closed)return;if((0,M.isUndefinedOrNull)(f))return this.delete(S);const p=String(f);if(this.cache.get(S)!==p)return this.cache.set(S,p),this.pendingInserts.set(S,p),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===g.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}isInMemory(){return this.options.hint===k.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}h.DEFAULT_FLUSH_DELAY=100,e.Storage=h;class y{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((f,p)=>this.items.set(p,f)),S.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=y}),define(ee[154],te([0,1,8,3,35,9,23]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return D.Event.None}constructor(y,w=Object.create(null)){this.path=y,this.options=w,this.name=(0,M.basename)(this.path),this.logger=new g(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const y=await this.whenConnected,w=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(f=>w.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${w.size} rows`),w}async updateItems(y){const w=await this.whenConnected;return this.doUpdateItems(w,y)}doUpdateItems(y,w){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${w.insert?(0,n.mapToString)(w.insert):"0"}), delete(${w.delete?(0,n.setToString)(w.delete):"0"})`),this.transaction(y,()=>{const S=w.insert,f=w.delete;if(S&&S.size>0){const p=[];p.push([]);let v=0;S.forEach((o,d)=>{let m=p[v];m.length>P.MAX_HOST_PARAMETERS&&(v++,m=[],p.push(m)),m.push(d,o)}),p.forEach(o=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(o.length/2).fill("(?,?)").join(",")}`,d=>d.run(o),()=>{const d=[];let m=0;return S.forEach((C,I)=>{d.push(I),m+=C.length}),`Keys: ${d.join(", ")} Length: ${m}`})})}if(f&&f.size){const p=[];p.push([]);let v=0;f.forEach(o=>{let d=p[v];d.length>P.MAX_HOST_PARAMETERS&&(v++,d=[],p.push(d)),d.push(o)}),p.forEach(o=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(o.length).fill("?").join(",")})`,d=>d.run(o),()=>{const d=[];return f.forEach(m=>{d.push(m)}),`Keys: ${d.join(", ")}`})})}})}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const w=await this.whenConnected;return this.doClose(w,y)}doClose(y,w){return new Promise((S,f)=>{y.db.close(p=>(p&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${p}`),this.path===P.IN_MEMORY_PATH?S():!y.isErroneous&&!y.isInMemory?this.backup().then(S,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),S())):typeof w=="function"?k.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const o=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:w()}).then(()=>o(),d=>(o(),Promise.reject(d)))})).then(S,f):f(p||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return k.Promises.copy(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const w=await this.whenConnected,S=await this.get(w,y?"PRAGMA integrity_check":"PRAGMA quick_check"),f=y?S.integrity_check:S.quick_check;return w.isErroneous?`${f} (last error: ${w.lastError})`:w.isInMemory?`${f} (in-memory!)`:f}async connect(y,w=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${w})`);try{return await this.doConnect(y)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&w)return await(0,E.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await k.Promises.unlink(y);try{await k.Promises.rename(this.toBackupPath(y),y)}catch{}return await this.doConnect(y)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(y,w){y.isErroneous=!0,y.lastError=w,this.logger.error(w)}doConnect(y){return new Promise((w,S)=>{new Promise((f,p)=>{j(["@vscode/sqlite3"],f,p)}).then(f=>{const p={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(y,v=>v?p.db&&v.code!=="SQLITE_CANTOPEN"?p.db.close(()=>S(v)):S(v):this.exec(p,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(p),o=>p.db.close(()=>S(o)))),isInMemory:y===P.IN_MEMORY_PATH};p.db.on("error",v=>this.handleSQLiteError(p,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&p.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},S)})}exec(y,w){return new Promise((S,f)=>{y.db.exec(w,p=>p?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${p}`),f(p)):S())})}get(y,w){return new Promise((S,f)=>{y.db.get(w,(p,v)=>p?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${p}`),f(p)):S(v))})}all(y,w){return new Promise((S,f)=>{y.db.all(w,(p,v)=>p?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${p}`),f(p)):S(v))})}transaction(y,w){return new Promise((S,f)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),w(),y.db.run("END TRANSACTION",p=>p?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${p}`),f(p)):S())})})}prepare(y,w,S,f){const p=y.db.prepare(w),v=o=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${o} (${w}). Details: ${f()}`)};p.on("error",v),S(p),p.finalize(o=>{o&&v(o),p.removeListener("error",v)})}}P.IN_MEMORY_PATH=":memory:",P.BUSY_OPEN_TIMEOUT=2e3,P.MAX_HOST_PARAMETERS=256,e.SQLiteStorageDatabase=P;class g{constructor(y){y&&typeof y.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace?.(y)}error(y){this.logError?.(y)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[155],te([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(ee[156],te([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[157],te([12,11]),function(j,e){return j.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[158],te([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[159],te([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(ee[160],te([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(ee[161],te([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[162],te([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[163],te([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[164],te([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[165],te([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[166],te([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(ee[167],te([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(ee[168],te([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(ee[169],te([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[170],te([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[171],te([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[172],te([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[173],te([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[174],te([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(ee[175],te([12,11]),function(j,e){return j.create("vs/platform/shell/node/shellEnv",e)}),define(ee[176],te([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[177],te([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[178],te([12,11]),function(j,e){return j.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[179],te([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[180],te([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[181],te([12,11]),function(j,e){return j.create("vs/platform/workspace/common/workspace",e)}),define(ee[182],te([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[183],te([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[184],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function D(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=D}),define(ee[185],te([0,1,7]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function D(k){return typeof k?.backupFolder=="string"}e.isEmptyWindowBackupInfo=D;function n(k){let P=[];try{Array.isArray(k.workspaces)&&(P=k.workspaces.map(g=>({workspace:{id:g.id,configPath:E.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=n;function M(k){let P=[];try{Array.isArray(k.folders)&&(P=k.folders.map(g=>({folderUri:E.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=M}),define(ee[186],te([0,1,3,2]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}call(P,g,h){switch(g){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:h[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:h[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:h[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:h[0],port:h[1],subId:h[2]}))}throw new Error("Method not implemented.")}listen(P,g,h){switch(g){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}n.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=n;class M extends D.Disposable{constructor(P){super(),this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,g,h){this.channel.call("attach",[P,g,h])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,g){this.channel.call("terminate",[P,g])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,g){return this.channel.call("openExtensionDevelopmentHostWindow",[P,g])}}e.ExtensionHostDebugChannelClient=M}),define(ee[187],te([0,1,140,55,14,9,36,18,7]),function(j,e,E,D,n,M,k,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class h{get appRoot(){return(0,M.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,M.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(g.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=k.env.VSCODE_PORTABLE;return p?g.URI.file((0,M.join)(p,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,M.resolve)(p):(0,M.normalize)((0,M.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?g.URI.file((0,M.resolve)(p)):g.URI.file((0,M.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,M.resolve)(p);const v=k.env.VSCODE_EXTENSIONS;if(v)return v;const o=k.env.VSCODE_PORTABLE;return o?(0,M.join)(o,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(v=>/^[^:/?#]+?:\/\//.test(v)?g.URI.parse(v):g.URI.file((0,M.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,M.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(p))}get extensionLogLevel(){const p=[];for(const v of this.args.log||[]){const o=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);o&&o[1]&&o[2]&&p.push([o[1],o[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=k.env.VSCODE_PORTABLE;return p?g.URI.file((0,M.join)(p,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this._args}constructor(p,v,o){this._args=p,this.paths=v,this.productService=o,this.editSessionId=this.args.editSessionId}}we([D.memoize],h.prototype,"appRoot",null),we([D.memoize],h.prototype,"userHome",null),we([D.memoize],h.prototype,"userDataPath",null),we([D.memoize],h.prototype,"appSettingsHome",null),we([D.memoize],h.prototype,"tmpDir",null),we([D.memoize],h.prototype,"cacheHome",null),we([D.memoize],h.prototype,"stateResource",null),we([D.memoize],h.prototype,"userRoamingDataHome",null),we([D.memoize],h.prototype,"userDataSyncHome",null),we([D.memoize],h.prototype,"userDataSyncLogResource",null),we([D.memoize],h.prototype,"editSessionsLogResource",null),we([D.memoize],h.prototype,"sync",null),we([D.memoize],h.prototype,"machineSettingsResource",null),we([D.memoize],h.prototype,"workspaceStorageHome",null),we([D.memoize],h.prototype,"localHistoryHome",null),we([D.memoize],h.prototype,"keyboardLayoutResource",null),we([D.memoize],h.prototype,"argvResource",null),we([D.memoize],h.prototype,"isExtensionDevelopment",null),we([D.memoize],h.prototype,"untitledWorkspacesHome",null),we([D.memoize],h.prototype,"installSourcePath",null),we([D.memoize],h.prototype,"builtinExtensionsPath",null),we([D.memoize],h.prototype,"extensionsPath",null),we([D.memoize],h.prototype,"extensionDevelopmentLocationURI",null),we([D.memoize],h.prototype,"extensionDevelopmentKind",null),we([D.memoize],h.prototype,"extensionTestsLocationURI",null),we([D.memoize],h.prototype,"debugExtensionHost",null),we([D.memoize],h.prototype,"logLevel",null),we([D.memoize],h.prototype,"extensionLogLevel",null),we([D.memoize],h.prototype,"serviceMachineIdResource",null),we([D.memoize],h.prototype,"telemetryLogResource",null),we([D.memoize],h.prototype,"disableWorkspaceTrust",null),we([D.memoize],h.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=h;function y(f,p){return S(f["inspect-extensions"],f["inspect-brk-extensions"],5870,p,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=y;function w(f,p){return S(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,p,f.extensionEnvironment)}e.parsePtyHostPort=w;function S(f,p,v,o,d,m){const I=Number(p||f)||(o?null:v),R=I?Boolean(!!p):!1;let t;if(m)try{t=JSON.parse(m)}catch{}return{port:I,break:R,debugId:d,env:t}}}),define(ee[108],te([0,1,288,4,159]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},category:{type:"string",cat:"e",description:(0,n.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,n.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(v,o,d=k){const m=v.find(u=>u.length>0&&u[0]!=="-"),C={},I=["_"],R=[],t={};let a;for(const u in o){const r=o[u];r.type==="subcommand"?u===m&&(a=r):(r.alias&&(C[u]=r.alias),r.type==="string"||r.type==="string[]"?(I.push(u),r.deprecates&&I.push(...r.deprecates)):r.type==="boolean"&&(R.push(u),r.deprecates&&R.push(...r.deprecates)),r.global&&(t[u]=r))}if(a&&m){const u=t;for(const L in a.options)u[L]=a.options[L];const r=v.filter(L=>L!==m),c=d.getSubcommandReporter?d.getSubcommandReporter(m):void 0,b=P(r,u,c);return{[m]:b,_:[]}}const i=E(v,{string:I,boolean:R,alias:C}),s={},l=i;s._=i._.map(u=>String(u)).filter(u=>u.length>0),delete l._;for(const u in o){const r=o[u];if(r.type==="subcommand")continue;r.alias&&delete l[r.alias];let c=l[u];if(r.deprecates)for(const b of r.deprecates)l.hasOwnProperty(b)&&(c||(c=l[b],c&&d.onDeprecatedOption(b,r.deprecationMessage||(0,n.localize)(36,null,u))),delete l[b]);if(typeof c<"u"){if(r.type==="string[]"){if(Array.isArray(c)||(c=[c]),!r.allowEmptyValue){const b=c.filter(L=>L.length>0);b.length!==c.length&&(d.onEmptyValue(u),c=b.length>0?b:void 0)}}else r.type==="string"&&(Array.isArray(c)?(c=c.pop(),d.onMultipleValues(u,c)):!c&&!r.allowEmptyValue&&(d.onEmptyValue(u),c=void 0));s[u]=c,r.deprecationMessage&&d.onDeprecatedOption(u,r.deprecationMessage)}delete l[u]}for(const u in l)d.onUnknownOption(u);return s}e.parseArgs=P;function g(v,o){let d="";return o.args&&(Array.isArray(o.args)?d=` <${o.args.join("> <")}>`:d=` <${o.args}>`),o.alias?`-${o.alias} --${v}${d}`:`--${v}${d}`}function h(v,o){const d=[];for(const m in v){const C=v[m],I=g(m,C);d.push([I,C.description])}return y(d,o)}e.formatOptions=h;function y(v,o){const m=v.reduce((R,t)=>Math.max(R,t[0].length),12)+2+1;if(o-m<25)return v.reduce((R,t)=>R.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const C=o-m-1,I=[];for(const R of v){const t=R[0],a=S(R[1],C),i=w(m-t.length-2);I.push("  "+t+i+a[0]);for(let s=1;s<a.length;s++)I.push(w(m)+a[s])}return I}function w(v){return" ".repeat(v)}function S(v,o){const d=[];for(;v.length;){const m=v.length<o?v.length:v.lastIndexOf(" ",o),C=v.slice(0,m).trim();v=v.slice(m),d.push(C)}return d}function f(v,o,d,m,C){const I=process.stdout.isTTY&&process.stdout.columns||80,R=C?.noInputFiles!==!0?`[${(0,n.localize)(37,null)}...]`:"",t=[`${v} ${d}`];t.push(""),t.push(`${(0,n.localize)(38,null)}: ${o} [${(0,n.localize)(39,null)}]${R}`),t.push(""),C?.noPipe!==!0&&(D.isWindows?t.push((0,n.localize)(40,null,o)):t.push((0,n.localize)(41,null,o)),t.push(""));const a={},i=[];for(const s in m){const l=m[s];if(l.type==="subcommand")l.description&&i.push({command:s,description:l.description});else if(l.description&&l.cat){let u=a[l.cat];u||(a[l.cat]=u={}),u[s]=l}}for(const s in a){const l=s,u=a[l];u&&(t.push(M[l]),t.push(...h(u,I)),t.push(""))}return i.length&&(t.push((0,n.localize)(42,null)),t.push(...y(i.map(s=>[s.command,s.description]),I)),t.push("")),t.join(`
`)}e.buildHelpMessage=f;function p(v,o){return`${v||(0,n.localize)(43,null)}
${o||(0,n.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=p}),define(ee[188],te([0,1,81,186,108]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends D.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.windowsMainService=P}call(P,g,h){return g==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(h[0],h[1]):super.call(P,g,h)}async openExtensionDevelopmentHostWindow(P,g){const h=(0,n.parseArgs)(P,n.OPTIONS);h.debugRenderer=g;const y=h.extensionDevelopmentPath;if(!y)return{success:!1};const[w]=await this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!g)return{success:!0};const S=w.win;if(!S)return{success:!0};const f=S.webContents.debugger;let p=f.isAttached()?1/0:0;const v=(0,E.createServer)(o=>{p++===0&&f.attach();let d=!1;const m=R=>{d||o.write(JSON.stringify(R)+"\0")},C=(R,t,a,i)=>m({method:t,params:a,sessionId:i});S.on("close",()=>{f.removeListener("message",C),o.end(),d=!0}),f.addListener("message",C);let I=Buffer.alloc(0);o.on("data",R=>{I=Buffer.concat([I,R]);for(let t=I.indexOf(0);t!==-1;t=I.indexOf(0)){let a;try{const i=I.slice(0,t).toString("utf8");I=I.slice(t+1),a=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}f.sendCommand(a.method,a.params,a.sessionId).then(i=>m({id:a.id,sessionId:a.sessionId,result:i})).catch(i=>m({id:a.id,sessionId:a.sessionId,error:{code:0,message:i.message}}))}}),o.on("error",R=>{console.error("error on cdp pipe:",R)}),o.on("close",()=>{d=!0,--p===0&&f.detach()})});return await new Promise(o=>v.listen(0,o)),S.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),define(ee[62],te([0,1,289,160,108]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const M=2048;function k(S,f){const p=(I,R)=>{console.warn((0,D.localize)(0,null,I,R))},v=I=>{console.warn((0,D.localize)(1,null,I))},o=(I,R)=>{console.warn((0,D.localize)(2,null,I,R))},d=I=>({onUnknownOption:R=>{I!=="tunnel"&&console.warn((0,D.localize)(3,null,R,I))},onMultipleValues:p,onEmptyValue:v,onDeprecatedOption:o,getSubcommandReporter:I!=="tunnel"?d:void 0}),m={onUnknownOption:I=>{console.warn((0,D.localize)(4,null,I))},onMultipleValues:p,onEmptyValue:v,onDeprecatedOption:o,getSubcommandReporter:d},C=(0,n.parseArgs)(S,n.OPTIONS,f?m:void 0);return C.goto&&C._.forEach(I=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,D.localize)(5,null))),C["max-memory"]&&E(parseInt(C["max-memory"])>=M,`The max-memory argument cannot be specified lower than ${M} MB.`),C}function P(S){const f=S.findIndex(p=>!/^-/.test(p));if(f>-1)return[...S.slice(0,f),...S.slice(f+1)]}function g(S){let[,...f]=S;process.env.VSCODE_DEV&&(f=P(f)||[]);const p=!w(process.env);return k(f,p)}e.parseMainProcessArgv=g;function h(S){let[,,...f]=S;return process.env.VSCODE_DEV&&(f=P(f)||[]),k(f,!0)}e.parseCLIProcessArgv=h;function y(S,...f){const p=S.indexOf("--");return p===-1?S.push(...f):S.splice(p,0,...f),S}e.addArg=y;function w(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function j(e,E,D){function n(k,P){const g=M(k,P),h=[g];return e.isAbsolute(g)||h.unshift(D),e.resolve(...h)}function M(k,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return e.join(h,P);const y=k["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=e.join(w,"AppData","Roaming")}break;case"darwin":h=e.join(E.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(h,P)}return{getUserDataPath:n}}if(typeof define=="function")define(ee[109],te([189,26,36]),function(e,E,D){return j(e,E,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=j(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[190],te([0,1,26,187,109]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends D.AbstractNativeEnvironmentService{constructor(P,g){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,n.getUserDataPath)(P,g.nameShort)},g)}}e.NativeEnvironmentService=M}),define(ee[191],te([0,1,41,26,32]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function M(k){const P=(0,n.randomPath)((0,D.tmpdir)());try{return(0,E.writeFileSync)(P,""),k&&console.log(`Marker file for --wait created: ${P}`),P}catch(g){k&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFileSync=M}),define(ee[192],te([0,1,10,162]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(k,P,g){try{M(k,P,g)}catch(h){console.error(h?.message??h)}return k}e.localizeManifest=n;function M(k,P,g){const h=(y,w,S)=>{const f=y[w];if((0,E.isString)(f)){const p=f,v=p.length;if(v>1&&p[0]==="%"&&p[v-1]==="%"){const o=p.substr(1,v-2);let d=P[o];d===void 0&&g&&(d=g[o]);const m=typeof d=="string"?d:d?.message,C=g?.[o],I=typeof C=="string"?C:C?.message;if(!m){I||console.warn(`[${k.name}]: ${(0,D.localize)(0,null,o)}`);return}if(S&&(w==="title"||w==="category")&&I&&I!==m){const R={value:m,original:I};y[w]=R}else y[w]=m}}else if((0,E.isObject)(f))for(const p in f)f.hasOwnProperty(p)&&(p==="commands"?h(f,p,!0):h(f,p,S));else if(Array.isArray(f))for(let p=0;p<f.length;p++)h(f,p,S)};for(const y in k)k.hasOwnProperty(y)&&h(k,y)}}),define(ee[193],te([0,1,13]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this._generators=new Map}register(M,k){this._generators.set(M,k)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const k in M.contributes){const P=this._generators.get(k);if(!P)continue;const g=M.contributes[k],h=Array.isArray(g)?g:[g];try{P(h,M.activationEvents)}catch(y){(0,E.onUnexpectedError)(y)}}}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(ee[194],te([0,1,18,83,164,195]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function g(d){return d=d.trim(),d==="*"||k.test(d)}e.isValidVersionStr=g;function h(d){if(!g(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=d.match(k);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=h;function y(d){if(!d)return null;const m=d.majorBase,C=d.majorMustEqual,I=d.minorBase;let R=d.minorMustEqual;const t=d.patchBase;let a=d.patchMustEqual;d.hasCaret&&(m===0||(R=!1),a=!1);let i=0;if(d.preRelease){const s=P.exec(d.preRelease);if(s){const[,l,u,r]=s;i=Date.UTC(Number(l),Number(u)-1,Number(r))}}return{majorBase:m,majorMustEqual:C,minorBase:I,minorMustEqual:R,patchBase:t,patchMustEqual:a,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=y;function w(d,m,C){let I;typeof d=="string"?I=y(h(d)):I=d;let R;m instanceof Date?R=m.getTime():typeof m=="string"&&(R=new Date(m).getTime());let t;if(typeof C=="string"?t=y(h(C)):t=C,!I||!t)return!1;const a=I.majorBase,i=I.minorBase,s=I.patchBase;let l=t.majorBase,u=t.minorBase,r=t.patchBase;const c=t.notBefore;let b=t.majorMustEqual,L=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?a>l?!0:a<l?!1:i>u?!0:i<u||R&&R<c?!1:s>=r:(a===1&&l===0&&(!b||!L||!T)&&(l=1,u=0,r=0,b=!0,L=!1,T=!1),a<l?!1:a>l?!b:i<u?!1:i>u?!L:s<r?!1:s>r?!T:!(R&&R<c))}e.isValidVersion=w;function S(d,m,C,I,R){const t=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return t.push([D.default.Error,n.localize(0,null)]),t;if(typeof I.name!="string")return t.push([D.default.Error,n.localize(1,null,"name")]),t;if(typeof I.version!="string")return t.push([D.default.Error,n.localize(2,null,"version")]),t;if(!I.engines)return t.push([D.default.Error,n.localize(3,null,"engines")]),t;if(typeof I.engines.vscode!="string")return t.push([D.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof I.extensionDependencies<"u"&&!o(I.extensionDependencies))return t.push([D.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof I.activationEvents<"u"){if(!o(I.activationEvents))return t.push([D.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof I.main>"u"&&typeof I.browser>"u")return t.push([D.default.Error,n.localize(7,null,"activationEvents","main")]),t}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&t.push([D.default.Warning,n.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return t.push([D.default.Error,n.localize(9,null,"main")]),t;{const s=(0,E.joinPath)(C,I.main);(0,E.isEqualOrParent)(s,C)||t.push([D.default.Warning,n.localize(10,null,s.path,C.path)])}if(typeof I.activationEvents>"u")return t.push([D.default.Error,n.localize(11,null,"activationEvents","main")]),t}if(typeof I.browser<"u"){if(typeof I.browser!="string")return t.push([D.default.Error,n.localize(12,null,"browser")]),t;{const s=(0,E.joinPath)(C,I.browser);(0,E.isEqualOrParent)(s,C)||t.push([D.default.Warning,n.localize(13,null,s.path,C.path)])}if(typeof I.activationEvents>"u")return t.push([D.default.Error,n.localize(14,null,"activationEvents","browser")]),t}if(!M.valid(I.version))return t.push([D.default.Error,n.localize(15,null)]),t;const a=[];if(!f(d,m,I,R,a))for(const s of a)t.push([D.default.Error,s]);return t}e.validateExtensionManifest=S;function f(d,m,C,I,R){return I||typeof C.main>"u"&&typeof C.browser>"u"?!0:v(d,m,C.engines.vscode,R)}e.isValidExtensionVersion=f;function p(d,m,C){return d==="*"||v(m,C,d)}e.isEngineValid=p;function v(d,m,C,I=[]){const R=y(h(C));if(!R)return I.push(n.localize(16,null,C)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return I.push(n.localize(17,null,C)),!1}else if(!R.majorMustEqual)return I.push(n.localize(18,null,C)),!1;return w(d,m,R)?!0:(I.push(n.localize(19,null,d,C)),!1)}function o(d){if(!Array.isArray(d))return!1;for(let m=0,C=d.length;m<C;m++)if(typeof d[m]!="string")return!1;return!0}}),define(ee[196],te([0,1,17,31]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(M,k,P){let g=P&&P.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const y=(await k.readFile(M.serviceMachineIdResource)).value.toString();g=(0,D.isUUID)(y)?y:null}catch{g=null}if(!g){g=(0,D.generateUuid)();try{await k.writeFile(M.serviceMachineIdResource,E.VSBuffer.fromString(g))}catch{}}return P?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=n}),define(ee[73],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(n,M=[],k=!1){this.ctor=n,this.staticArguments=M,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=E}),define(ee[197],te([0,1,73]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var n;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(n=e.InstantiationType||(e.InstantiationType={}));function M(P,g,h){g instanceof E.SyncDescriptor||(g=new E.SyncDescriptor(g,[],Boolean(h))),D.push([P,g])}e.registerSingleton=M;function k(){return D}e.getSingletonServiceDescriptors=k}),define(ee[198],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(M,k){this.key=M,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class D{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const k of this._nodes.values())k.outgoing.size===0&&M.push(k);return M}insertEdge(M,k){const P=this.lookupOrInsertNode(M),g=this.lookupOrInsertNode(k);P.outgoing.set(g.key,g),g.incoming.set(P.key,P)}removeNode(M){const k=this._hashFn(M);this._nodes.delete(k);for(const P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(M){const k=this._hashFn(M);let P=this._nodes.get(k);return P||(P=new E(k,M),this._nodes.set(k,P)),P}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[k,P]of this._nodes)M.push(`${k}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,k]of this._nodes){const P=new Set([M]),g=this._findCycle(k,P);if(g)return g}}_findCycle(M,k){for(const[P,g]of M.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const h=this._findCycle(g,k);if(h)return h;k.delete(P)}}}e.Graph=D}),define(ee[6],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(g){return g[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=n("instantiationService");function D(k,P,g){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:k,index:g}):(P[E.DI_DEPENDENCIES]=[{id:k,index:g}],P[E.DI_TARGET]=P)}function n(k){if(E.serviceIds.has(k))return E.serviceIds.get(k);const P=function(g,h,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(P,g,y)};return P.toString=()=>k,E.serviceIds.set(k,P),P}e.createDecorator=n;function M(k){return k}e.refineServiceDecorator=M}),define(ee[63],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ee[19],te([0,1,10,7,6]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof D.URI)}e.isConfigurationOverrides=M;function k(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=k;var P;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function h(o,d){const m=Object.create(null);for(const C in o)y(m,C,o[C],d);return m}e.toValuesTree=h;function y(o,d,m,C){const I=d.split("."),R=I.pop();let t=o;for(let a=0;a<I.length;a++){const i=I[a];let s=t[i];switch(typeof s){case"undefined":s=t[i]=Object.create(null);break;case"object":break;default:C(`Ignoring ${d} as ${I.slice(0,a+1).join(".")} is ${JSON.stringify(s)}`);return}t=s}if(typeof t=="object"&&t!==null)try{t[R]=m}catch{C(`Ignoring ${d} as ${I.join(".")} is ${JSON.stringify(t)}`)}else C(`Ignoring ${d} as ${I.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=y;function w(o,d){const m=d.split(".");S(o,m)}e.removeFromValueTree=w;function S(o,d){const m=d.shift();if(d.length===0){delete o[m];return}if(Object.keys(o).indexOf(m)!==-1){const C=o[m];typeof C=="object"&&!Array.isArray(C)&&(S(C,d),Object.keys(C).length===0&&delete o[m])}}function f(o,d,m){function C(t,a){let i=t;for(const s of a){if(typeof i!="object"||i===null)return;i=i[s]}return i}const I=d.split("."),R=C(o,I);return typeof R>"u"?m:R}e.getConfigurationValue=f;function p(o,d,m){Object.keys(d).forEach(C=>{C!=="__proto__"&&(C in o?E.isObject(o[C])&&E.isObject(d[C])?p(o[C],d[C],m):m&&(o[C]=d[C]):o[C]=d[C])})}e.merge=p;function v(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(ee[74],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class D{constructor(){this.secretVault={}}async getPassword(M,k){return this.secretVault[M]?.[k]??null}async setPassword(M,k,P){this.secretVault[M]=this.secretVault[M]??{},this.secretVault[M][k]=P}async deletePassword(M,k){return this.secretVault[M]?.[k]?(delete this.secretVault[M][k],Object.keys(this.secretVault[M]).length===0&&delete this.secretVault[M],!0):!1}async findPassword(M){return JSON.stringify(this.secretVault[M])??null}async findCredentials(M){const k=[];for(const P of Object.keys(this.secretVault[M]||{}))k.push({account:P,password:this.secretVault[M][P]});return k}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=D}),define(ee[88],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function D(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=D;class n{async getPerformanceInfo(k,P){return{}}async getSystemInfo(k,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,P){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=n}),define(ee[48],te([0,1,18,157,6,45,4,40]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.IDialogService=void 0,e.IDialogService=(0,n.createDecorator)("dialogService"),e.IFileDialogService=(0,n.createDecorator)("fileDialogService");var g;(function(S){S[S.SAVE=0]="SAVE",S[S.DONT_SAVE=1]="DONT_SAVE",S[S.CANCEL=2]="CANCEL"})(g=e.ConfirmResult||(e.ConfirmResult={}));const h=10;function y(S){const f=[];return f.push(...S.slice(0,h).map(p=>typeof p=="string"?p:(0,E.basename)(p))),S.length>h&&(S.length-h===1?f.push((0,D.localize)(0,null)):f.push((0,D.localize)(1,null,S.length-h))),f.push(""),f.join(`
`)}e.getFileNamesMessage=y;function w(S,f){const p=(0,P.deepClone)(S);let v=(p.buttons??[]).map(C=>(0,M.mnemonicButtonLabel)(C)),o=(S.buttons||[]).map((C,I)=>I),d=0,m=p.cancelId??v.length-1;if(v.length>1)if(k.isLinux){const C=typeof m=="number"?v[m]:void 0;if(v=v.reverse(),o=o.reverse(),d=v.length-1,typeof C=="string"&&(m=v.indexOf(C),m!==v.length-2)){v.splice(m,1),v.splice(v.length-1,0,C);const I=o[m];o.splice(m,1),o.splice(o.length-1,0,I),m=v.length-2}}else if(k.isWindows){const C=typeof m=="number"?v[m]:void 0;if(typeof C=="string"&&(m=v.indexOf(C),m!==v.length-1)){v.splice(m,1),v.push(C);const I=o[m];o.splice(m,1),o.push(I),m=v.length-1}}else k.isMacintosh;return p.buttons=v,p.defaultId=d,p.cancelId=m,p.noLink=!0,p.title=p.title||f.nameLong,{options:p,buttonIndeces:o}}e.massageMessageBoxOptions=w}),define(ee[110],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ee[33],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[28],te([0,1,55,9,87,33,190,6]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(M.IEnvironmentService);class g extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,D.join)(this.userDataPath,"clp")}get backupHome(){return(0,D.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,D.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}we([E.memoize],g.prototype,"cachedLanguagesPath",null),we([E.memoize],g.prototype,"backupHome",null),we([E.memoize],g.prototype,"mainIPCHandle",null),we([E.memoize],g.prototype,"mainLockfile",null),we([E.memoize],g.prototype,"disableUpdates",null),we([E.memoize],g.prototype,"disableKeytar",null),we([E.memoize],g.prototype,"crossOriginIsolated",null),we([E.memoize],g.prototype,"codeCachePath",null),we([E.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(ee[199],te([0,1,161,6]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function n(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function M(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function k(d,m){switch(d){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function P(d,m){return m==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function g(d,m,C){return P(m,C)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===C?!0:h(C).includes(d)}e.isTargetPlatformCompatible=g;function h(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function y(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=y;var w;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var S;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var f;(function(d){d.Install="install",d.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var p;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var v;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(m,C){super(m),this.code=C,this.name=C}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[200],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ee[201],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[111],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ee[202],te([0,1,46,14,9,4,82,23,86,165,111]),function(j,e,E,D,n,M,k,P,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const w=h.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends S{openTerminal(I,R){return this.spawnTerminal(E,I,g.getWindowsShell(),R)}spawnTerminal(I,R,t,a){const i=R.windowsExec||f.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=n.basename(i,".exe").toLowerCase();if(s==="cmder")return I.spawn(i,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return i.indexOf(" ")>=0&&l.push('""'),l.push(i),s==="wt"&&l.push("-d ."),new Promise((u,r)=>{const c=o(process),b=I.spawn(t,l,{cwd:a,env:c});b.on("error",r),b.on("exit",()=>u())})}runInTerminal(I,R,t,a,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows();return new Promise((l,u)=>{const r=`"${R} - ${w}"`,c=`""${t.join('" "')}" & pause"`,b=Object.assign({},o(process),a);Object.keys(b).filter(V=>b[V]===null).forEach(V=>delete b[V]);const L={cwd:R,env:b,windowsVerbatimArguments:!0};let T,F;n.basename(s,".exe")==="wt"?(T=s,F=["-d",".",f.CMD,"/c",c]):(T=f.CMD,F=["/c","start",r,"/wait",s,"/c",c]),E.spawn(T,F,L).on("error",V=>{u(d(V))}),l(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const I=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${I?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}f.CMD="cmd.exe",e.WindowsExternalTerminalService=f;class p extends S{openTerminal(I,R){return this.spawnTerminal(E,I,R)}runInTerminal(I,R,t,a,i){const s=i.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((l,u)=>{if(s===y.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const r=s===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",b=[D.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${r}.scpt`).fsPath,"-t",I||w,"-w",R];for(const F of t)b.push("-a"),b.push(F);if(a){const F=Object.assign({},o(process),a);for(const Y in F){const V=F[Y];V===null?(b.push("-u"),b.push(Y)):(b.push("-e"),b.push(`${Y}=${V}`))}}let L="";const T=E.spawn(p.OSASCRIPT,b);T.on("error",F=>{u(d(F))}),T.stderr.on("data",F=>{L+=F.toString()}),T.on("exit",F=>{if(F===0)l(void 0);else if(L){const Y=L.split(`
`,1);u(new Error(Y[0]))}else u(new Error(h.localize(1,null,r,F)))})}else u(new Error(h.localize(2,null,s)))})}spawnTerminal(I,R,t){const a=R.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{const l=["-a",a];t&&l.push(t);const u=o(process),r=I.spawn("/usr/bin/open",l,{cwd:t,env:u});r.on("error",s),r.on("exit",()=>i())})}}p.OSASCRIPT="/usr/bin/osascript",e.MacExternalTerminalService=p;class v extends S{openTerminal(I,R){return this.spawnTerminal(E,I,R)}runInTerminal(I,R,t,a,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,u)=>{const r=[];s.then(c=>{c.indexOf("gnome-terminal")>=0?r.push("-x"):r.push("-e"),r.push("bash"),r.push("-c");const b=`${m(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;r.push(`''${b}''`);const L=Object.assign({},o(process),a);Object.keys(L).filter(V=>L[V]===null).forEach(V=>delete L[V]);const T={cwd:R,env:L};let F="";const Y=E.spawn(c,r,T);Y.on("error",V=>{u(d(V))}),Y.stderr.on("data",V=>{F+=V.toString()}),Y.on("exit",V=>{if(V===0)l(void 0);else if(F){const G=F.split(`
`,1);u(new Error(G[0]))}else u(new Error(h.localize(4,null,c,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const I=await P.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(R=>{I?R("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?R("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?R("konsole"):process.env.COLORTERM?R(process.env.COLORTERM):process.env.TERM?R(process.env.TERM):R("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(I,R,t){const a=R.linuxExec?Promise.resolve(R.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{a.then(l=>{const u=o(process),r=I.spawn(l,[],{cwd:t,env:u});r.on("error",s),r.on("exit",()=>i())})})}}v.WAIT_MESSAGE=h.localize(3,null),e.LinuxExternalTerminalService=v;function o(C){const I={...C.env};return(0,k.sanitizeProcessEnvironment)(I),I}function d(C){return"errno"in C&&C.errno==="ENOENT"&&"path"in C&&typeof C.path=="string"?new Error(h.localize(5,null,C.path)):C}function m(C){let I="";for(const R of C)R.indexOf(" ")>=0?I+='"'+R+'"':I+=R,I+=" ";return I}}),define(ee[16],te([0,1,61,9,27,10,7,167,6,4,14]),function(j,e,E,D,n,M,k,P,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function w(O){return O.create===!0}e.isFileOpenForWriteOptions=w;var S;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var f;(function(O){O[O.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var p;(function(O){O[O.None=0]="None",O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock",O[O.FileAtomicRead=16384]="FileAtomicRead",O[O.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=v;function o(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=o;function d(O){return!!(O.capabilities&32768)}e.hasFileCloneCapability=d;function m(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function C(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=C;function I(O){return v(O)?!!(O.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;var R;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(R=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{constructor(z,K){super(z),this.code=K}}e.FileSystemProviderError=t;function a(O,z){const K=new t(O.toString(),z);return s(K,z),K}e.createFileSystemProviderError=a;function i(O){return O||a((0,P.localize)(0,null),R.Unknown)}e.ensureFileSystemProviderError=i;function s(O,z){return O.name=z?`${z} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=s;function l(O){if(!O)return R.Unknown;if(O instanceof t)return O.code;const z=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!z)return R.Unknown;switch(z[1]){case R.FileExists:return R.FileExists;case R.FileIsADirectory:return R.FileIsADirectory;case R.FileNotADirectory:return R.FileNotADirectory;case R.FileNotFound:return R.FileNotFound;case R.FileExceedsMemoryLimit:return R.FileExceedsMemoryLimit;case R.FileTooLarge:return R.FileTooLarge;case R.FileWriteLocked:return R.FileWriteLocked;case R.NoPermissions:return R.NoPermissions;case R.Unavailable:return R.Unavailable}return R.Unknown}e.toFileSystemProviderErrorCode=l;function u(O){if(O instanceof F)return O.fileOperationResult;switch(l(O)){case R.FileNotFound:return 1;case R.FileIsADirectory:return 0;case R.FileNotADirectory:return 10;case R.FileWriteLocked:return 5;case R.NoPermissions:return 6;case R.FileExists:return 4;case R.FileExceedsMemoryLimit:return 9;case R.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY",O[O.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(z,K,ne){this.resource=z,this.operation=K,this.target=ne}isOperation(z){return this.operation===z}}e.FileOperationEvent=c;var b;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(b=e.FileChangeType||(e.FileChangeType={}));class L{constructor(z,K){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const se of z){const J=ne.get(se.type);switch(J?J.push([se.resource,se]):ne.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,J]of ne)switch(se){case 1:this.added=E.TernarySearchTree.forUris(()=>K),this.added.fill(J);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>K),this.updated.fill(J);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>K),this.deleted.fill(J);break}}contains(z,...K){return this.doContains(z,{includeChildren:!1},...K)}affects(z,...K){return this.doContains(z,{includeChildren:!0},...K)}doContains(z,K,...ne){if(!z)return!1;const se=ne.length>0;return!!((!se||ne.includes(1))&&(this.added?.get(z)||K.includeChildren&&this.added?.findSuperstr(z))||(!se||ne.includes(0))&&(this.updated?.get(z)||K.includeChildren&&this.updated?.findSuperstr(z))||(!se||ne.includes(2))&&(this.deleted?.findSubstr(z)||K.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=L;function T(O,z,K){return!O||!z||O===z||z.length>O.length?!1:(z.charAt(z.length-1)!==D.sep&&(z+=D.sep),K?(0,n.startsWithIgnoreCase)(O,z):O.indexOf(z)===0)}e.isParent=T;class F extends Error{constructor(z,K,ne){super(z),this.fileOperationResult=K,this.options=ne}}e.FileOperationError=F;class Y extends F{constructor(z,K,ne,se){super(z,K,se),this.fileOperationResult=K,this.size=ne}}e.TooLargeFileOperationError=Y;class V extends F{constructor(z,K,ne){super(z,2,ne),this.stat=K}}e.NotModifiedSinceFileOperationError=V;var G;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(G=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ie;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(ie=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=re;async function de(O,z){if(!z.hasProvider(k.URI.from({scheme:O.scheme})))return new Promise(K=>{const ne=z.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===O.scheme&&se.added&&(ne.dispose(),K())})})}e.whenProviderRegistered=de,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ce{static formatSize(z){return(0,M.isNumber)(z)||(z=0),z<ce.KB?(0,P.localize)(1,null,z.toFixed(0)):z<ce.MB?(0,P.localize)(2,null,(z/ce.KB).toFixed(2)):z<ce.GB?(0,P.localize)(3,null,(z/ce.MB).toFixed(2)):z<ce.TB?(0,P.localize)(4,null,(z/ce.GB).toFixed(2)):(0,P.localize)(5,null,(z/ce.TB).toFixed(2))}}ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB,e.ByteSize=ce;var ge;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(ge=e.Arch||(e.Arch={}));function x(O){return{maxFileSize:O===0?300*ce.MB:16*ce.GB,maxHeapSize:O===0?700*ce.MB:2*700*ce.MB}}e.getPlatformFileLimits=x;function B(O){const z=typeof O=="string"||O?.scheme===y.Schemas.vscodeRemote;return typeof O!="string"&&O?.scheme===y.Schemas.file?1024*ce.MB:z?10*ce.MB:h.isWeb?50*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=B}),define(ee[203],te([0,1,17,44,13,3,2,60,7,31,16]),function(j,e,E,D,n,M,k,P,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends k.Disposable{constructor(f,p){super(),this.channel=f,this.extraCapabilities=p,this.onDidChangeCapabilities=M.Event.None,this._onDidChange=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,h.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,p){const{buffer:v}=await this.channel.call("readFile",[f,p]);return v}readFileStream(f,p,v){const o=(0,P.newWriteableStream)(m=>E.VSBuffer.concat(m.map(C=>E.VSBuffer.wrap(C))).buffer),d=this.channel.listen("readFileStream",[f,p])(m=>{if(m instanceof E.VSBuffer)o.write(m.buffer);else{if(m==="end")o.end();else{let C;if(m instanceof Error)C=m;else{const I=m;C=(0,y.createFileSystemProviderError)(I.message??(0,D.toErrorMessage)(I),I.code??y.FileSystemProviderErrorCode.Unknown)}o.error(C),o.end()}d.dispose()}});return v.onCancellationRequested(()=>{o.error((0,n.canceled)()),o.end(),d.dispose()}),o}writeFile(f,p,v){return this.channel.call("writeFile",[f,E.VSBuffer.wrap(p),v])}open(f,p){return this.channel.call("open",[f,p])}close(f){return this.channel.call("close",[f])}async read(f,p,v,o,d){const[m,C]=await this.channel.call("read",[f,p,d]);return v.set(m.buffer.slice(0,C),o),C}write(f,p,v,o,d){return this.channel.call("write",[f,p,E.VSBuffer.wrap(v),o,d])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,p){return this.channel.call("delete",[f,p])}rename(f,p,v){return this.channel.call("rename",[f,p,v])}copy(f,p,v){return this.channel.call("copy",[f,p,v])}cloneFile(f,p){return this.channel.call("cloneFile",[f,p])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const p=f;this._onDidChange.fire(p.map(v=>({resource:g.URI.revive(v.resource),type:v.type})))}else{const p=f;this._onDidWatchError.fire(p)}}))}watch(f,p){const v=(0,h.generateUuid)();return this.channel.call("watch",[this.sessionId,v,f,p]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=w}),define(ee[112],te([0,1,17,13,168,16]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(y,w,S,f,p,v){let o;try{await P(y,w,S,f,p,v)}catch(d){o=d}finally{o&&p.errorTransformer&&(o=p.errorTransformer(o)),typeof o<"u"&&S.error(o),S.end()}}e.readFileIntoStream=k;async function P(y,w,S,f,p,v){g(v);const o=await y.open(w,{create:!1});try{g(v);let d=0,m=0,C=p&&typeof p.length=="number"?p.length:void 0,I=E.VSBuffer.alloc(Math.min(p.bufferSize,typeof C=="number"?C:p.bufferSize)),R=p&&typeof p.position=="number"?p.position:0,t=0;do m=await y.read(o,R,I.buffer,t,I.byteLength-t),R+=m,t+=m,d+=m,typeof C=="number"&&(C-=m),t===I.byteLength&&(await S.write(f(I)),I=E.VSBuffer.alloc(Math.min(p.bufferSize,typeof C=="number"?C:p.bufferSize)),t=0);while(m>0&&(typeof C!="number"||C>0)&&g(v)&&h(d,p));if(t>0){let a=t;typeof C=="number"&&(a=Math.min(t,C)),S.write(f(I.slice(0,a)))}}catch(d){throw(0,M.ensureFileSystemProviderError)(d)}finally{await y.close(o)}}function g(y){if(y.isCancellationRequested)throw(0,D.canceled)();return!0}function h(y,w){if(w?.limits){if(typeof w.limits.memory=="number"&&y>w.limits.memory)throw(0,M.createFileSystemProviderError)((0,n.localize)(0,null),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&y>w.limits.size)throw(0,M.createFileSystemProviderError)((0,n.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[75],te([0,1,102,2,9,4,7,16]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function g(d){return d.recursive===!0}e.isRecursiveWatchRequest=g;class h extends D.Disposable{constructor(m,C,I,R){super(),this.onFileChanges=m,this.onLogMessage=C,this.verboseLogging=I,this.options=R,this.watcherDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new D.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(C=>this.onFileChanges(C))),m.add(this.watcher.onDidLogMessage(C=>this.onLogMessage(C))),m.add(this.watcher.onDidError(C=>this.onError(C)))}onError(m){this.options.restartOnError?this.restartCounter<h.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}h.MAX_RESTARTS=5,e.AbstractWatcherClient=h;class y extends h{constructor(m,C,I){super(m,C,I,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class w extends h{constructor(m,C,I){super(m,C,I,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function S(d){return d.map(m=>({type:m.type,resource:k.URI.file(m.path)}))}e.toFileChanges=S;function f(d){const m=new o;for(const C of d)m.processEvent(C);return m.coalesce()}e.coalesceEvents=f;function p(d,m){return typeof m=="string"&&!m.startsWith(E.GLOBSTAR)&&!(0,n.isAbsolute)(m)?{base:d,pattern:m}:m}e.normalizeWatcherPattern=p;function v(d,m){const C=[];for(const I of m)C.push((0,E.parse)(p(d,I)));return C}e.parseWatcherPatterns=v;class o{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return M.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const C=this.mapPathToChange.get(this.toKey(m));let I=!1;if(C){const R=C.type,t=m.type;C.path!==m.path&&(m.type===2||m.type===1)?I=!0:R===1&&t===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(C)):R===2&&t===1?C.type=0:R===1&&t===0||(C.type=t)}else I=!0;I&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],C=[];return Array.from(this.coalesced).filter(I=>I.type!==2?(m.push(I),!1):!0).sort((I,R)=>I.path.length-R.path.length).filter(I=>C.some(R=>(0,P.isParent)(I.path,R,!M.isLinux))?!1:(C.push(I.path),!0)).concat(m)}}}),define(ee[204],te([0,1,41,8,22,32,2,79,9,4,103,23,75]),function(j,e,E,D,n,M,k,P,g,h,y,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends k.Disposable{constructor(o,d,m,C){super(),this.request=o,this.onDidFilesChange=d,this.onLogMessage=m,this.verboseLogging=C,this.throttledFileChangesEmitter=this._register(new D.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},I=>this.onDidFilesChange(I))),this.fileChangesAggregator=this._register(new D.RunOnceWorker(I=>this.handleFileChanges(I),f.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new n.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const o=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await w.Promises.stat(o);this._register(await this.doWatch(o,d.isDirectory()))}catch(o){o.code!=="ENOENT"?this.error(o):this.trace(o)}}async normalizePath(o){let d=o.path;try{d=await w.Promises.realpath(o.path),o.path===d&&(d=await(0,y.realcase)(o.path)??o.path),o.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${d})`)}catch{}return d}async doWatch(o,d){if(h.isMacintosh&&(0,M.isEqualOrParent)(o,"/Volumes/",!0))return this.error(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const m=new n.CancellationTokenSource(this.cts.token),C=new k.DisposableStore;try{const I=(0,g.basename)(o),R=(0,E.watch)(o);C.add((0,k.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.trace(`Started watching: '${o}'`);const t=new Set;if(d)try{for(const i of await w.Promises.readdir(o))t.add(i)}catch(i){this.error(i)}const a=new Map;C.add((0,k.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),R.on("error",(i,s)=>{this.error(`Failed to watch ${o} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),R.on("change",(i,s)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${s}`);let l="";if(s&&(l=s.toString(),h.isMacintosh&&(l=(0,P.normalizeNFC)(l))),!(!l||i!=="change"&&i!=="rename"))if(d)if(i==="rename"){a.get(l)?.dispose();const u=setTimeout(async()=>{if(a.delete(l),l===I&&!await w.Promises.exists(o)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const r=await this.existsChildStrictCase((0,g.join)(o,l));if(m.token.isCancellationRequested)return;let c;r?t.has(l)?c=0:(c=1,t.add(l)):(t.delete(l),c=2),this.onFileChange({path:(0,g.join)(this.request.path,l),type:c})},f.FILE_DELETE_HANDLER_DELAY);a.set(l,(0,k.toDisposable)(()=>clearTimeout(u)))}else{let u;t.has(l)?u=0:(u=1,t.add(l)),this.onFileChange({path:(0,g.join)(this.request.path,l),type:u})}else if(i==="rename"||l!==I){const u=setTimeout(async()=>{const r=await w.Promises.exists(o);m.token.isCancellationRequested||(r?(this.onFileChange({path:this.request.path,type:0},!0),C.add(await this.doWatch(o,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);C.clear(),C.add((0,k.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(I){await w.Promises.exists(o)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${o} for changes using fs.watch() (${I.toString()})`)}return(0,k.toDisposable)(()=>{m.dispose(!0),C.dispose()})}onFileChange(o,d=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!d&&this.excludes.some(m=>m(o.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${o.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(o.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${o.path}`):this.fileChangesAggregator.work(o))}handleFileChanges(o){const d=(0,S.coalesceEvents)(o);if(d.length>0){if(this.verboseLogging)for(const C of d)this.trace(`>> normalized ${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`);this.throttledFileChangesEmitter.work(d)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(o){if(h.isLinux)return w.Promises.exists(o);try{const d=(0,g.basename)(o);return(await w.Promises.readdir((0,g.dirname)(o))).some(C=>C===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(o){this.verboseLogging=o}error(o){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}warn(o){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}trace(o){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=75,e.NodeJSFileWatcherLibrary=f;async function p(v,o,d,m,C=512){const I=await w.Promises.open(v,"r"),R=Buffer.allocUnsafe(C),t=new n.CancellationTokenSource(m);let a,i=!1;const s={path:v,excludes:[],recursive:!1},l=new f(s,u=>{(async()=>{for(const{type:r}of u)if(r===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:c}=await w.Promises.read(I,R,0,C,null);if(!c||t.token.isCancellationRequested)break;o(R.slice(0,c))}}catch(c){a=new Error(c),t.dispose(!0)}finally{i=!1}}})()});return await l.ready,d(),new Promise((u,r)=>{t.token.onCancellationRequested(async()=>{l.dispose();try{await w.Promises.close(I)}catch(c){a=new Error(c)}a?r(a):u()})})}e.watchFileContents=p}),define(ee[205],te([0,1,3,102,2,4,204]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends n.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new E.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=E.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(h){const y=this.normalizeRequests(h),w=y.filter(f=>{const p=this.watchers.get(f.path);return p?!(0,D.patternsEquals)(p.request.excludes,f.excludes)||!(0,D.patternsEquals)(p.request.includes,f.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:f})=>!y.find(p=>p.path===f.path&&(0,D.patternsEquals)(p.excludes,f.excludes)&&(0,D.patternsEquals)(p.includes,f.includes))).map(({request:f})=>f.path);w.length&&this.trace(`Request to start watching: ${w.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const f of S)this.stopWatching(f);for(const f of w)this.startWatching(f)}startWatching(h){const y=new k.NodeJSFileWatcherLibrary(h,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),w={request:h,instance:y};this.watchers.set(h.path,w)}async stop(){for(const[h]of this.watchers)this.stopWatching(h);this.watchers.clear()}stopWatching(h){const y=this.watchers.get(h);y&&(this.watchers.delete(h),y.instance.dispose())}normalizeRequests(h){const y=new Map;for(const w of h){const S=M.isLinux?w.path:w.path.toLowerCase();y.set(S,w)}return Array.from(y.values())}async setVerboseLogging(h){this.verboseLogging=h;for(const[,y]of this.watchers)y.instance.setVerboseLogging(h)}trace(h){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(h)})}toMessage(h,y){return y?`[File Watcher (node.js)] ${h} (path: ${y.request.path})`:`[File Watcher (node.js)] ${h}`}}e.NodeJSWatcher=P}),define(ee[206],te([0,1,75,205]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends E.AbstractNonRecursiveWatcherClient{constructor(k,P,g){super(k,P,g),this.init()}createWatcher(){return new D.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(ee[207],te([0,1,14,47,153,75]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends M.AbstractUniversalWatcherClient{constructor(g,h,y){super(g,h,y),this.init()}createWatcher(g){const h=g.add(new n.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(h.onDidProcessExit(({code:y,signal:w})=>this.onError(`terminated by itself with code ${y}, signal: ${w}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(h.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(ee[89],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...n){this._entries=new Map;for(const[M,k]of n)this.set(M,k)}set(n,M){const k=this._entries.get(n);return this._entries.set(n,M),k}has(n){return this._entries.has(n)}get(n){return this._entries.get(n)}}e.ServiceCollection=E}),define(ee[208],te([0,1,8,13,2,73,198,6,89,99]),function(j,e,E,D,n,M,k,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class w extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class S{constructor(o=new g.ServiceCollection,d=!1,m,C=y){this._services=o,this._strict=d,this._parent=m,this._enableTracing=C,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=C?m?._globalGraph??new k.Graph(I=>I):void 0}createChild(o){return new S(o,this._strict,this,this._enableTracing)}invokeFunction(o,...d){const m=p.traceInvocation(this._enableTracing,o);let C=!1;try{return o({get:R=>{if(C)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(R,m);if(!t)throw new Error(`[invokeFunction] unknown service '${R}'`);return t}},...d)}finally{C=!0,m.stop()}}createInstance(o,...d){let m,C;return o instanceof M.SyncDescriptor?(m=p.traceCreation(this._enableTracing,o.ctor),C=this._createInstance(o.ctor,o.staticArguments.concat(d),m)):(m=p.traceCreation(this._enableTracing,o),C=this._createInstance(o,d,m)),m.stop(),C}_createInstance(o,d=[],m){const C=P._util.getServiceDependencies(o).sort((t,a)=>t.index-a.index),I=[];for(const t of C){const a=this._getOrCreateServiceInstance(t.id,m);a||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),I.push(a)}const R=C.length>0?C[0].index:d.length;if(d.length!==R){console.trace(`[createInstance] First service dependency of ${o.name} at position ${R+1} conflicts with ${d.length} static arguments`);const t=R-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,R)}return Reflect.construct(o,d.concat(I))}_setServiceInstance(o,d){if(this._services.get(o)instanceof M.SyncDescriptor)this._services.set(o,d);else if(this._parent)this._parent._setServiceInstance(o,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const d=this._services.get(o);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):d}_getOrCreateServiceInstance(o,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const m=this._getServiceInstanceOrDescriptor(o);return m instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,m,d.branch(o,!0)):(d.branch(o,!1),m)}_safeCreateAndCacheServiceInstance(o,d,m){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,d,m)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,d,m){const C=new k.Graph(t=>t.id.toString());let I=0;const R=[{id:o,desc:d,_trace:m}];for(;R.length;){const t=R.pop();if(C.lookupOrInsertNode(t),I++>1e3)throw new w(C);for(const a of P._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(a.id);if(i||this._throwIfStrict(`[createInstance] ${o} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof M.SyncDescriptor){const s={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};C.insertEdge(t,s),R.push(s)}}}for(;;){const t=C.roots();if(t.length===0){if(!C.isEmpty())throw new w(C);break}for(const{data:a}of t){if(this._getServiceInstanceOrDescriptor(a.id)instanceof M.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}C.removeNode(a)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,d,m=[],C,I){if(this._services.get(o)instanceof M.SyncDescriptor)return this._createServiceInstance(o,d,m,C,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,d,m,C,I);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(o,d,m=[],C,I){if(C){const R=new S(void 0,this._strict,this,this._enableTracing);R._globalGraphImplicitDependency=String(o);const t=new Map,a=new E.IdleValue(()=>{const i=R._createInstance(d,m,I);for(const[s,l]of t){const u=i[s];if(typeof u=="function")for(const r of l)u.apply(i,r)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let r=t.get(s);return r||(r=new h.LinkedList,t.set(s,r)),(b,L,T)=>{const F=r.push([b,L,T]);return(0,n.toDisposable)(F)}}if(s in i)return i[s];const l=a.value;let u=l[s];return typeof u!="function"||(u=u.bind(l),i[s]=u),u},set(i,s,l){return a.value[s]=l,!0},getPrototypeOf(i){return d.prototype}})}else return this._createInstance(d,m,I)}_throwIfStrict(o,d){if(d&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=S;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class p{static traceInvocation(o,d){return o?new p(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(o,d){return o?new p(1,d.name):p._None}constructor(o,d){this.type=o,this.name=d,this._start=Date.now(),this._dep=[]}branch(o,d){const m=new p(3,o.toString());return this._dep.push([o,d,m]),m}stop(){const o=Date.now()-this._start;p._totals+=o;let d=!1;function m(I,R){const t=[],a=new Array(I+1).join("	");for(const[i,s,l]of R._dep)if(s&&l){d=!0,t.push(`${a}CREATES -> ${i}`);const u=m(I+1,l);u&&t.push(u)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const C=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(o>2||d)&&p.all.add(C.join(`
`))}}p.all=new Set,p._None=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p._totals=0,e.Trace=p}),define(ee[5],te([0,1,44,3,2,35,4,10,7,6]),function(j,e,E,D,n,M,k,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function y(){return new Date().toISOString()}function w(r){return(0,P.isNumber)(r)}e.isLogLevel=w;var S;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function f(r,c,b){switch(c){case S.Trace:r.trace(b);break;case S.Debug:r.debug(b);break;case S.Info:r.info(b);break;case S.Warning:r.warn(b);break;case S.Error:r.error(b);break;case S.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=f;function p(r){let c="";for(let b=0;b<r.length;b++){let L=r[b];if(typeof L=="object")try{L=JSON.stringify(L)}catch{}c+=(b>0?" ":"")+L}return c}e.format=p;class v extends n.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(c){this.level!==c&&(this.level=c,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(c){return this.level!==S.Off&&this.level<=c}}e.AbstractLogger=v;class o extends v{constructor(c){super(),this.logAlways=c}checkLogLevel(c){return this.logAlways||super.checkLogLevel(c)}trace(c,...b){this.checkLogLevel(S.Trace)&&this.log(S.Trace,p([c,...b]))}debug(c,...b){this.checkLogLevel(S.Debug)&&this.log(S.Debug,p([c,...b]))}info(c,...b){this.checkLogLevel(S.Info)&&this.log(S.Info,p([c,...b]))}warn(c,...b){this.checkLogLevel(S.Warning)&&this.log(S.Warning,p([c,...b]))}error(c,...b){if(this.checkLogLevel(S.Error))if(c instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=c.stack,this.log(S.Error,p(L))}else this.log(S.Error,p([c,...b]))}flush(){}}e.AbstractMessageLogger=o;class d extends v{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.useColors=!k.isWindows}trace(c,...b){this.checkLogLevel(S.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,c,...b):console.log(`[main ${y()}]`,c,...b))}debug(c,...b){this.checkLogLevel(S.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,c,...b):console.log(`[main ${y()}]`,c,...b))}info(c,...b){this.checkLogLevel(S.Info)&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,c,...b):console.log(`[main ${y()}]`,c,...b))}warn(c,...b){this.checkLogLevel(S.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,c,...b):console.warn(`[main ${y()}]`,c,...b))}error(c,...b){this.checkLogLevel(S.Error)&&(this.useColors?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,c,...b):console.error(`[main ${y()}]`,c,...b))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class m extends v{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c)}trace(c,...b){this.checkLogLevel(S.Trace)&&console.log("%cTRACE","color: #888",c,...b)}debug(c,...b){this.checkLogLevel(S.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",c,...b)}info(c,...b){this.checkLogLevel(S.Info)&&console.log("%c INFO","color: #33f",c,...b)}warn(c,...b){this.checkLogLevel(S.Warning)&&console.log("%c WARN","color: #993",c,...b)}error(c,...b){this.checkLogLevel(S.Error)&&console.log("%c  ERR","color: #f33",c,...b)}dispose(){}flush(){}}e.ConsoleLogger=m;class C extends v{constructor(c,b=e.DEFAULT_LOG_LEVEL){super(),this.adapter=c,this.setLevel(b)}trace(c,...b){this.checkLogLevel(S.Trace)&&this.adapter.log(S.Trace,[this.extractMessage(c),...b])}debug(c,...b){this.checkLogLevel(S.Debug)&&this.adapter.log(S.Debug,[this.extractMessage(c),...b])}info(c,...b){this.checkLogLevel(S.Info)&&this.adapter.log(S.Info,[this.extractMessage(c),...b])}warn(c,...b){this.checkLogLevel(S.Warning)&&this.adapter.log(S.Warning,[this.extractMessage(c),...b])}error(c,...b){this.checkLogLevel(S.Error)&&this.adapter.log(S.Error,[this.extractMessage(c),...b])}extractMessage(c){return typeof c=="string"?c:(0,E.toErrorMessage)(c,this.checkLogLevel(S.Trace))}dispose(){}flush(){}}e.AdapterLogger=C;class I extends v{constructor(c){super(),this.loggers=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const b of this.loggers)b.setLevel(c);super.setLevel(c)}trace(c,...b){for(const L of this.loggers)L.trace(c,...b)}debug(c,...b){for(const L of this.loggers)L.debug(c,...b)}info(c,...b){for(const L of this.loggers)L.info(c,...b)}warn(c,...b){for(const L of this.loggers)L.warn(c,...b)}error(c,...b){for(const L of this.loggers)L.error(c,...b)}flush(){for(const c of this.loggers)c.flush()}dispose(){for(const c of this.loggers)c.dispose()}}e.MultiplexLogger=I;class R extends n.Disposable{constructor(c,b){if(super(),this.logLevel=c,this._loggers=new M.ResourceMap,this._loggerResources=new M.ResourceMap,this._onDidChangeLoggers=this._register(new D.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,b)for(const L of b)this._loggerResources.set(L.resource,L)}getLogger(c){return this._loggers.get(c)}createLogger(c,b){let L=this._loggers.get(c);const T=b?.logLevel==="always"?S.Trace:b?.logLevel;return L||(L=this.doCreateLogger(c,T??this.getLogLevel(c)??this.logLevel,b),this._loggers.set(c,L)),this.registerLogger({resource:c,id:b?.id??c.toString(),logLevel:T,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId}),L}setLogLevel(c,b){if(g.URI.isUri(c)){const L=c,T=b,F=this._loggerResources.get(L);F&&T!==F.logLevel&&(F.logLevel=T===this.logLevel?void 0:T,this._loggers.get(L)?.setLevel(T),this._loggerResources.set(F.resource,F),this._onDidChangeLogLevel.fire([L,T]))}else{this.logLevel=c;for(const[L,T]of this._loggers.entries())this._loggerResources.get(L)?.logLevel===void 0&&T.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(c,b){const L=this._loggerResources.get(c);L&&b!==!L.hidden&&(L.hidden=!b,this._loggerResources.set(L.resource,L),this._onDidChangeVisibility.fire([c,b]))}getLogLevel(c){let b;return c&&(b=this._loggerResources.get(c)?.logLevel),b??this.logLevel}registerLogger(c){const b=this._loggerResources.get(c.resource);b?b.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this._loggerResources.set(c.resource,c),this._onDidChangeLoggers.fire({added:[c],removed:[]}))}deregisterLogger(c){const b=this._loggerResources.get(c);if(b){this._loggerResources.delete(c);const L=this._loggers.get(c);L&&(this._loggers.delete(c),L.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[b]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(c){return this._loggerResources.get(c)}dispose(){this._loggers.forEach(c=>c.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=R;class t{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(c){}getLevel(){return S.Info}trace(c,...b){}debug(c,...b){}info(c,...b){}warn(c,...b){}error(c,...b){}critical(c,...b){}dispose(){}flush(){}}e.NullLogger=t;class a extends t{}e.NullLogService=a;class i extends R{constructor(){super(S.Info)}doCreateLogger(c,b,L){return new t}}e.NullLoggerService=i;function s(r){if(r.verbose)return S.Trace;if(typeof r.logLevel=="string"){const c=u(r.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function l(r){switch(r){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}e.LogLevelToString=l;function u(r){switch(r){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.parseLogLevel=u});var Z=this&&this.__param||function(j,e){return function(E,D){e(E,D,j)}};define(ee[209],te([0,1,74,3,2,5,4,8]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let g=class ht extends n.Disposable{constructor(y){super(),this.logService=y,this._onDidChangePassword=this._register(new D.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(y,w){this.logService.trace("Getting password from keytar:",y,w);let S;try{S=await this.withKeytar()}catch{return null}const f=await(0,P.retry)(()=>S.getPassword(y,w),50,3);if(!f)return this.logService.trace("Did not get a password from keytar for account:",w),f;let p,v;try{const o=JSON.parse(f);p=o.content,v=o.hasNextChunk}catch{}if(!p||!v)return this.logService.trace("Got password from keytar for account:",w),f;try{let o=1;for(;v;){const d=await(0,P.retry)(()=>S.getPassword(y,`${w}-${o}`),50,3),m=JSON.parse(d);p+=m.content,v=m.hasNextChunk,o++}return this.logService.trace(`Got ${o}-chunked password from keytar for account:`,w),p}catch(o){return this.logService.error(o),f}}async setPassword(y,w,S){this.logService.trace("Setting password using keytar:",y,w);let f;try{f=await this.withKeytar()}catch(p){throw this.surfaceKeytarLoadError?.(p),p}if(k.isWindows&&S.length>ht.MAX_PASSWORD_LENGTH){let p=0,v=0,o=!0;for(;o;){const d=S.substring(p,p+ht.PASSWORD_CHUNK_SIZE);p+=ht.PASSWORD_CHUNK_SIZE,o=S.length-p>0;const m={content:d,hasNextChunk:o};await(0,P.retry)(()=>f.setPassword(y,v?`${w}-${v}`:w,JSON.stringify(m)),50,3),v++}this.logService.trace(`Got${v?` ${v}-chunked`:""} password from keytar for account:`,w)}else await(0,P.retry)(()=>f.setPassword(y,w,S),50,3),this.logService.trace("Got password from keytar for account:",w);this._onDidChangePassword.fire({service:y,account:w})}async deletePassword(y,w){this.logService.trace("Deleting password using keytar:",y,w);let S;try{S=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const f=await S.getPassword(y,w);if(!f)return this.logService.trace("Did not get a password to delete from keytar for account:",w),!1;let p,v;try{const d=JSON.parse(f);p=d.content,v=d.hasNextChunk}catch{}let o=0;if(p&&v)try{for(o++;v;){const d=`${w}-${o}`,m=await S.getPassword(y,d);await S.deletePassword(y,d),v=JSON.parse(m).hasNextChunk,o++}}catch(d){this.logService.error(d)}return await S.deletePassword(y,w)?(this._onDidChangePassword.fire({service:y,account:w}),this.logService.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,w),!0):(this.logService.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,w),!1)}async findPassword(y){let w;try{w=await this.withKeytar()}catch{return null}return await w.findPassword(y)}async findCredentials(y){let w;try{w=await this.withKeytar()}catch{return[]}return await w.findCredentials(y)}clear(){return this._keytarCache instanceof E.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};g.MAX_PASSWORD_LENGTH=2500,g.PASSWORD_CHUNK_SIZE=g.MAX_PASSWORD_LENGTH-100,g=we([Z(0,M.ILogService)],g),e.BaseCredentialsMainService=g}),define(ee[210],te([0,1,5]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let D=class{constructor(M,k){this.machineId=M,this.logService=k}encryption(){return new Promise((M,k)=>j(["vscode-encrypt"],M,k))}async encrypt(M){let k;try{k=await this.encryption()}catch{return M}try{return k.encrypt(this.machineId,M)}catch(P){return this.logService.error(P),M}}async decrypt(M){let k;try{k=await this.encryption()}catch{return M}try{return k.decrypt(this.machineId,M)}catch(P){return this.logService.error(P),M}}};D=we([Z(1,E.ILogService)],D),e.EncryptionMainService=D}),define(ee[211],te([0,1,25,8,13,3,2,9,75,5]),function(j,e,E,D,n,M,k,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends k.Disposable{constructor(S,f){super(),this.logService=S,this.options=f,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(S,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,f):this.watchNonRecursive(S,f)}watchUniversal(S,f){const p={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:f.recursive},v=(0,E.insert)(this.universalPathsToWatch,p);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,n.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,g.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const f of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const f of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(f)&&S.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,f){const p={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:!1},v=(0,E.insert)(this.nonRecursivePathsToWatch,p);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,n.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,g.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,P.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(ee[212],te([0,1,25,8,17,22,3,72,70,2,61,14,64,18,60,166,16,112,5,13]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class extends h.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(t,a){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const i=new h.DisposableStore;return this.provider.set(t,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(s=>this._onDidFilesChange.fire(new o.FileChangesEvent(s,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),i.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:t}))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:a}),this.provider.delete(t),(0,h.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){a.push(i)}}),!this.provider.has(t)&&await D.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,a){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return g.Iterable.map(this.provider,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async withProvider(t){if(!(0,f.isAbsolutePath)(t))throw new o.FileOperationError((0,v.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const a=this.provider.get(t.scheme);if(!a){const i=new C.ErrorNoTelemetry;throw i.message=(0,v.localize)(1,null,t.toString()),i}return a}async withReadProvider(t){const a=await this.withProvider(t);if((0,o.hasOpenReadWriteCloseCapability)(a)||(0,o.hasReadWriteCapability)(a)||(0,o.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const a=await this.withProvider(t);if((0,o.hasOpenReadWriteCloseCapability)(a)||(0,o.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.doResolveFile(t,a)}catch(i){throw(0,o.toFileSystemProviderErrorCode)(i)===o.FileSystemProviderErrorCode.FileNotFound?new o.FileOperationError((0,v.localize)(2,null,this.resourceForError(t)),1):(0,o.ensureFileSystemProviderError)(i)}}async doResolveFile(t,a){const i=await this.withProvider(t),s=this.isPathCaseSensitive(i),l=a?.resolveTo,u=a?.resolveSingleChildDescendants,r=a?.resolveMetadata,c=await i.stat(t);let b;return this.toFileStat(i,t,c,void 0,!!r,(L,T)=>(b||(b=y.TernarySearchTree.forUris(()=>!s),b.set(t,!0),l&&b.fill(!0,l)),b.get(L.resource)||b.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&u?T===1:!1))}async toFileStat(t,a,i,s,l,u){const{providerExtUri:r}=this.getExtUri(t),c={resource:a,name:r.basename(a),isFile:(i.type&o.FileType.File)!==0,isDirectory:(i.type&o.FileType.Directory)!==0,isSymbolicLink:(i.type&o.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&o.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,o.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(c.isDirectory&&u(c,s)){try{const b=await t.readdir(a),L=await D.Promises.settled(b.map(async([T,F])=>{try{const Y=r.joinPath(a,T),V=l?await t.stat(Y):{type:F};return await this.toFileStat(t,Y,V,b.length,l,u)}catch(Y){return this.logService.trace(Y),null}}));c.children=(0,E.coalesce)(L)}catch(b){this.logService.trace(b),c.children=[]}return c}return c}async resolveAll(t){return D.Promises.settled(t.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.withProvider(t),i=await a.stat(t);return this.toFileStat(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.withProvider(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.doValidateCreateFile(t,a)}catch(i){return i}return!0}async doValidateCreateFile(t,a){if(!a?.overwrite&&await this.exists(t))throw new o.FileOperationError((0,v.localize)(3,null,this.resourceForError(t)),3,a)}async createFile(t,a=n.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const s=await this.writeFile(t,a);return this._onDidRunOperation.fire(new o.FileOperationEvent(t,0,s)),s}async writeFile(t,a,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:l}=this.getExtUri(s);try{await this.validateWriteFile(s,t,i)||await this.mkdirp(s,l.dirname(t));let r;if((0,o.hasReadWriteCapability)(s)&&!(a instanceof n.VSBuffer))if((0,p.isReadableStream)(a)){const c=await(0,p.peekStream)(a,3);c.ended?r=n.VSBuffer.concat(c.buffer):r=c}else r=(0,p.peekReadable)(a,c=>n.VSBuffer.concat(c),3);else r=a;!(0,o.hasOpenReadWriteCloseCapability)(s)||(0,o.hasReadWriteCapability)(s)&&r instanceof n.VSBuffer?await this.doWriteUnbuffered(s,t,i,r):await this.doWriteBuffered(s,t,i,r instanceof n.VSBuffer?(0,n.bufferToReadable)(r):r),this._onDidRunOperation.fire(new o.FileOperationEvent(t,4))}catch(u){throw new o.FileOperationError((0,v.localize)(4,null,this.resourceForError(t),(0,o.ensureFileSystemProviderError)(u).toString()),(0,o.toFileOperationResult)(u),i)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(a)));let l;try{l=await t.stat(a)}catch{return}if((l.type&o.FileType.Directory)!==0)throw new o.FileOperationError((0,v.localize)(6,null,this.resourceForError(a)),0,i);if(this.throwIfFileIsReadonly(a,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==o.ETAG_DISABLED&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,o.etag)({mtime:i.mtime,size:l.size}))throw new o.FileOperationError((0,v.localize)(7,null),3,i);return l}async readFile(t,a,i){const s=await this.withReadProvider(t);return a?.atomic?this.doReadFileAtomic(s,t,a,i):this.doReadFile(s,t,a,i)}async doReadFileAtomic(t,a,i,s){return new Promise((l,u)=>{this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(t,a,i,s);l(r)}catch(r){u(r)}})})}async doReadFile(t,a,i,s){const l=await this.doReadFileStream(t,a,{...i,preferUnbuffered:!0},s);return{...l,value:await(0,n.streamToBuffer)(l.value)}}async readFileStream(t,a,i){const s=await this.withReadProvider(t);return this.doReadFileStream(s,t,a,i)}async doReadFileStream(t,a,i,s){const l=new M.CancellationTokenSource(s),u=this.validateReadFile(a,i).then(c=>c,c=>{throw l.cancel(),c});let r;try{return typeof i?.etag=="string"&&i.etag!==o.ETAG_DISABLED&&await u,i?.atomic&&(0,o.hasFileAtomicReadCapability)(t)||!((0,o.hasOpenReadWriteCloseCapability)(t)||(0,o.hasFileReadStreamCapability)(t))||(0,o.hasReadWriteCapability)(t)&&i?.preferUnbuffered?r=this.readFileUnbuffered(t,a,i):(0,o.hasFileReadStreamCapability)(t)?r=this.readFileStreamed(t,a,l.token,i):r=this.readFileBuffered(t,a,l.token,i),{...await u,value:r}}catch(c){throw r&&await(0,p.consumeStream)(r),this.restoreReadError(c,a,i)}}restoreReadError(t,a,i){const s=(0,v.localize)(8,null,this.resourceForError(a),(0,o.ensureFileSystemProviderError)(t).toString());return t instanceof o.NotModifiedSinceFileOperationError?new o.NotModifiedSinceFileOperationError(s,t.stat,i):t instanceof o.TooLargeFileOperationError?new o.TooLargeFileOperationError(s,t.fileOperationResult,t.size,t.options):new o.FileOperationError(s,(0,o.toFileOperationResult)(t),i)}readFileStreamed(t,a,i,s=Object.create(null)){const l=t.readFileStream(a,s,i);return(0,p.transform)(l,{data:u=>u instanceof n.VSBuffer?u:n.VSBuffer.wrap(u),error:u=>this.restoreReadError(u,a,s)},u=>n.VSBuffer.concat(u))}readFileBuffered(t,a,i,s=Object.create(null)){const l=(0,n.newWriteableBufferStream)();return(0,d.readFileIntoStream)(t,a,l,u=>u,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:u=>this.restoreReadError(u,a,s)},i),l}readFileUnbuffered(t,a,i){const s=(0,p.newWriteableStream)(l=>n.VSBuffer.concat(l));return(async()=>{try{let l;i?.atomic&&(0,o.hasFileAtomicReadCapability)(t)?l=await t.readFile(a,{atomic:!0}):l=await t.readFile(a),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.validateReadFileLimits(a,l.byteLength,i),s.end(n.VSBuffer.wrap(l))}catch(l){s.error(l),s.end()}})(),s}async validateReadFile(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new o.FileOperationError((0,v.localize)(9,null,this.resourceForError(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==o.ETAG_DISABLED&&a.etag===i.etag)throw new o.NotModifiedSinceFileOperationError((0,v.localize)(10,null),i,a);return this.validateReadFileLimits(t,i.size,a),i}validateReadFileLimits(t,a,i){if(i?.limits){let s;if(typeof i.limits.memory=="number"&&a>i.limits.memory&&(s=9),typeof i.limits.size=="number"&&a>i.limits.size&&(s=7),typeof s=="number")throw new o.TooLargeFileOperationError((0,v.localize)(11,null,this.resourceForError(t)),s,a,i)}}async canMove(t,a,i){return this.doCanMoveCopy(t,a,"move",i)}async canCopy(t,a,i){return this.doCanMoveCopy(t,a,"copy",i)}async doCanMoveCopy(t,a,i,s){if(t.toString()!==a.toString())try{const l=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(l,t,u,a,i,s)}catch(l){return l}return!0}async move(t,a,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),u=await this.doMoveCopy(s,t,l,a,"move",!!i),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new o.FileOperationEvent(t,u==="move"?2:3,r)),r}async copy(t,a,i){const s=await this.withReadProvider(t),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),u=await this.doMoveCopy(s,t,l,a,"copy",!!i),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new o.FileOperationEvent(t,u==="copy"?3:2,r)),r}async doMoveCopy(t,a,i,s,l,u){if(a.toString()===s.toString())return l;const{exists:r,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(t,a,i,s,l,u);if(r&&!c&&u&&await this.del(s,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s)),l==="copy"){if(t===i&&(0,o.hasFileFolderCopyCapability)(t))await t.copy(a,s,{overwrite:u});else{const b=await this.resolve(a);b.isDirectory?await this.doCopyFolder(t,b,i,s):await this.doCopyFile(t,a,i,s)}return l}else return t===i?(await t.rename(a,s,{overwrite:u}),l):(await this.doMoveCopy(t,a,i,s,"copy",u),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(t,a,i,s){if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,a,i,s);if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,a,i,s);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,a,i,s);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,a,i,s)}async doCopyFolder(t,a,i,s){await i.mkdir(s),Array.isArray(a.children)&&await D.Promises.settled(a.children.map(async l=>{const u=this.getExtUri(i).providerExtUri.joinPath(s,l.name);return l.isDirectory?this.doCopyFolder(t,await this.resolve(l.resource),i,u):this.doCopyFile(t,l.resource,i,u)}))}async doValidateMoveCopy(t,a,i,s,l,u){let r=!1;if(t===i){const{providerExtUri:b,isPathCaseSensitive:L}=this.getExtUri(t);if(L||(r=b.isEqual(a,s)),r&&l==="copy")throw new Error((0,v.localize)(12,null,this.resourceForError(a),this.resourceForError(s)));if(!r&&b.isEqualOrParent(s,a))throw new Error((0,v.localize)(13,null,this.resourceForError(a),this.resourceForError(s)))}const c=await this.exists(s);if(c&&!r){if(!u)throw new o.FileOperationError((0,v.localize)(14,null,this.resourceForError(a),this.resourceForError(s)),4);if(t===i){const{providerExtUri:b}=this.getExtUri(t);if(b.isEqualOrParent(a,s))throw new Error((0,v.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:c,isSameResourceWithDifferentPathCase:r}}getExtUri(t){const a=this.isPathCaseSensitive(t);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new o.FileOperationEvent(t,0,i)),i}async mkdirp(t,a){const i=[],{providerExtUri:s}=this.getExtUri(t);for(;!s.isEqual(a,s.dirname(a));)try{if(((await t.stat(a)).type&o.FileType.Directory)===0)throw new Error((0,v.localize)(16,null,this.resourceForError(a)));break}catch(l){if((0,o.toFileSystemProviderErrorCode)(l)!==o.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(s.basename(a)),a=s.dirname(a)}for(let l=i.length-1;l>=0;l--){a=s.joinPath(a,i[l]);try{await t.mkdir(a)}catch(u){if((0,o.toFileSystemProviderErrorCode)(u)!==o.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(t,a){try{await this.doValidateDelete(t,a)}catch(i){return i}return!0}async doValidateDelete(t,a){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,v.localize)(17,null,this.resourceForError(t)));let l;try{l=await i.stat(t)}catch{}if(l)this.throwIfFileIsReadonly(t,l);else throw new o.FileOperationError((0,v.localize)(18,null,this.resourceForError(t)),1);if(!!!a?.recursive){const r=await this.resolve(t);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,v.localize)(19,null,this.resourceForError(t)))}return i}async del(t,a){const i=await this.doValidateDelete(t,a),s=!!a?.useTrash,l=!!a?.recursive;await i.delete(t,{recursive:l,useTrash:s}),this._onDidRunOperation.fire(new o.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.withProvider(t),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);if(i===s&&this.getExtUri(i).providerExtUri.isEqual(t,a))return;if(i===s&&(0,o.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(a));const l=this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri);return i===s&&(0,o.hasFileFolderCopyCapability)(i)?l.queue(()=>i.copy(t,a,{overwrite:!0})):l.queue(()=>this.doCopyFile(i,t,s,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new h.DisposableStore;let s=!1,l=()=>{s=!0};return i.add((0,h.toDisposable)(()=>l())),(async()=>{try{const u=await this.doWatch(t,a);s?(0,h.dispose)(u):l=()=>(0,h.dispose)(u)}catch(u){this.logService.error(u)}})(),i}async doWatch(t,a){const i=await this.withProvider(t),s=(0,P.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),a]);let l=this.activeWatchers.get(s);return l||(l={count:0,disposable:i.watch(t,a)},this.activeWatchers.set(s,l)),l.count+=1,(0,h.toDisposable)(()=>{l&&(l.count--,l.count===0&&((0,h.dispose)(l.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,h.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,a,i,s){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{const l=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,p.isReadableStream)(s)||(0,p.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(t,l,s):await this.doWriteReadableBufferedQueued(t,l,s)}catch(u){throw(0,o.ensureFileSystemProviderError)(u)}finally{await t.close(l)}})}async doWriteStreamBufferedQueued(t,a,i){let s=0,l;if((0,p.isReadableBufferedStream)(i)){if(i.buffer.length>0){const u=n.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,a,u,u.byteLength,s,0),s+=u.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise((u,r)=>{(0,p.listenStream)(l,{onData:async c=>{l.pause();try{await this.doWriteBuffer(t,a,c,c.byteLength,s,0)}catch(b){return r(b)}s+=c.byteLength,setTimeout(()=>l.resume())},onError:c=>r(c),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(t,a,i){let s=0,l;for(;(l=i.read())!==null;)await this.doWriteBuffer(t,a,l,l.byteLength,s,0),s+=l.byteLength}async doWriteBuffer(t,a,i,s,l,u){let r=0;for(;r<s;)r+=await t.write(a,l+r,i.buffer,u+r,s-r)}async doWriteUnbuffered(t,a,i,s){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,a,i,s))}async doWriteUnbufferedQueued(t,a,i,s){let l;s instanceof n.VSBuffer?l=s:(0,p.isReadableStream)(s)?l=await(0,n.streamToBuffer)(s):(0,p.isReadableBufferedStream)(s)?l=await(0,n.bufferedStreamToBuffer)(s):l=(0,n.readableToBuffer)(s),await t.writeFile(a,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(t,a,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,a,i,s))}async doPipeBufferedQueued(t,a,i,s){let l,u;try{l=await t.open(a,{create:!1}),u=await i.open(s,{create:!0,unlock:!1});const r=n.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,b=0,L=0;do L=await t.read(l,c,r.buffer,b,r.byteLength-b),await this.doWriteBuffer(i,u,r,L,c,b),c+=L,b+=L,b===r.byteLength&&(b=0);while(L>0)}catch(r){throw(0,o.ensureFileSystemProviderError)(r)}finally{await D.Promises.settled([typeof l=="number"?t.close(l):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async doPipeUnbuffered(t,a,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,a,i,s))}async doPipeUnbufferedQueued(t,a,i,s){return i.writeFile(s,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(t,a,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,a,i,s))}async doPipeUnbufferedToBufferedQueued(t,a,i,s){const l=await i.open(s,{create:!0,unlock:!1});try{const u=await t.readFile(a);await this.doWriteBuffer(i,l,n.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,o.ensureFileSystemProviderError)(u)}finally{await i.close(l)}}async doPipeBufferedToUnbuffered(t,a,i,s){const l=await(0,n.streamToBuffer)(this.readFileBuffered(t,a,M.CancellationToken.None));await this.doWriteUnbuffered(i,s,void 0,l)}throwIfFileSystemIsReadonly(t,a){if(t.capabilities&2048)throw new o.FileOperationError((0,v.localize)(20,null,this.resourceForError(a)),6);return t}throwIfFileIsReadonly(t,a){if((a.permissions??0)&o.FilePermission.Readonly)throw new o.FileOperationError((0,v.localize)(21,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===w.Schemas.file?t.fsPath:t.toString(!0)}};I=we([Z(0,m.ILogService)],I),e.FileService=I}),define(ee[90],te([0,1,41,290,8,35,17,3,32,2,9,4,18,60,23,170,16,112,211,44,207,206]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(E)}catch(a){console.error(`Error enabling graceful-fs: ${(0,C.toErrorMessage)(a)}`)}})();class t extends m.AbstractDiskFileSystemProvider{constructor(i,s){super(i,s),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new M.ResourceMap(l=>S.extUriBiasedIgnorePathCase.getComparisonKey(l)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:l}=await p.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,l),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await p.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),l=[];return await Promise.all(s.map(async u=>{try{let r;u.isSymbolicLink()?r=(await this.stat((0,S.joinPath)(i,u.name))).type:r=this.toType(u),l.push([u.name,r])}catch(r){this.logService.trace(r)}})),l}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let l;return s?.dangling?l=o.FileType.Unknown:i.isFile()?l=o.FileType.File:i.isDirectory()?l=o.FileType.Directory:l=o.FileType.Unknown,s&&(l|=o.FileType.SymbolicLink),l}async createResourceLock(i){const s=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let l;for(;l=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await l.wait();const u=new n.Barrier;return this.resourceLocks.set(i,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,h.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(i)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),u.open()})}async readFile(i,s){let l;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),l=await this.createResourceLock(i));const u=this.toFilePath(i);return await p.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{l?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,s,l){const u=(0,f.newWriteableStream)(r=>k.VSBuffer.concat(r.map(c=>k.VSBuffer.wrap(c))).buffer);return(0,d.readFileIntoStream)(this,i,u,r=>r.buffer,{...s,bufferSize:256*1024},l),u}async writeFile(i,s,l){let u;try{const r=this.toFilePath(i);if(!l.create||!l.overwrite){if(await p.Promises.exists(r)){if(!l.overwrite)throw(0,o.createFileSystemProviderError)((0,v.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,o.createFileSystemProviderError)((0,v.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:l.unlock}),await this.write(u,0,s,0,s.byteLength)}catch(r){throw await this.toFileSystemProviderWriteError(i,r)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(i){t.canFlush=i}async open(i,s){const l=this.toFilePath(i);let u;(0,o.isFileOpenForWriteOptions)(s)&&(u=await this.createResourceLock(i));let r;try{if((0,o.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:b}=await p.SymlinkSupport.stat(l);b.mode&128||await p.Promises.chmod(l,b.mode|128)}catch(b){this.logService.trace(b)}let c;if((0,o.isFileOpenForWriteOptions)(s)){if(w.isWindows)try{await p.Promises.truncate(l,0),c="r+"}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}c||(c="w")}else c="r";r=await p.Promises.open(l,c)}catch(c){throw u?.dispose(),(0,o.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}if(this.mapHandleToPos.set(r,0),(0,o.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(r,i),u){const c=this.mapHandleToLock.get(r);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${l})`),this.mapHandleToLock.set(r,u),c&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${l})`),c.dispose())}return r}async close(i){const s=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await p.Promises.fdatasync(i)}catch(l){t.configureFlushOnWrite(!1),this.logService.error(l)}return await p.Promises.close(i)}catch(l){throw this.toFileSystemProviderError(l)}finally{s&&(this.mapHandleToLock.get(i)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,l,u,r){const c=this.normalizePos(i,s);let b=null;try{b=(await p.Promises.read(i,l,u,r,c)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(i,c,b)}return b}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,l){const u=this.mapHandleToPos.get(i);typeof u=="number"&&(typeof s=="number"||(typeof l=="number"?this.mapHandleToPos.set(i,u+l):this.mapHandleToPos.delete(i)))}async write(i,s,l,u,r){return(0,n.retry)(()=>this.doWrite(i,s,l,u,r),100,3)}async doWrite(i,s,l,u,r){const c=this.normalizePos(i,s);let b=null;try{b=(await p.Promises.write(i,l,u,r,c)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),L)}finally{this.updatePos(i,c,b)}return b}async mkdir(i){try{await p.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const l=this.toFilePath(i);s.recursive?await p.Promises.rm(l,p.RimRafMode.MOVE):await p.Promises.unlink(l)}catch(l){throw this.toFileSystemProviderError(l)}}async rename(i,s,l){const u=this.toFilePath(i),r=this.toFilePath(s);if(u!==r)try{await this.validateTargetDeleted(i,s,"move",l.overwrite),await p.Promises.move(u,r)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,v.localize)(2,null,(0,y.basename)(u),(0,y.basename)((0,y.dirname)(r)),c.toString()))),this.toFileSystemProviderError(c)}}async copy(i,s,l){const u=this.toFilePath(i),r=this.toFilePath(s);if(u!==r)try{await this.validateTargetDeleted(i,s,"copy",l.overwrite),await p.Promises.copy(u,r,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,v.localize)(3,null,(0,y.basename)(u),(0,y.basename)((0,y.dirname)(r)),c.toString()))),this.toFileSystemProviderError(c)}}async validateTargetDeleted(i,s,l,u){const r=this.toFilePath(i),c=this.toFilePath(s);let b=!1;if(!!(this.capabilities&1024)||(b=(0,g.isEqual)(r,c,!0)),b&&l==="copy")throw(0,o.createFileSystemProviderError)((0,v.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(!b&&await p.Promises.exists(c)){if(!u)throw(0,o.createFileSystemProviderError)((0,v.localize)(5,null),o.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(i,s){return this.doCloneFile(i,s,!1)}async doCloneFile(i,s,l){const u=this.toFilePath(i),r=this.toFilePath(s),c=!!(this.capabilities&1024);if((0,g.isEqual)(u,r,!c))return;const b=new h.DisposableStore;try{const[L,T]=await Promise.all([this.createResourceLock(i),this.createResourceLock(s)]);b.add(L),b.add(T),l&&await p.Promises.mkdir((0,y.dirname)(r),{recursive:!0}),await p.Promises.copyFile(u,r)}catch(L){if(L.code==="ENOENT"&&!l)return this.doCloneFile(i,s,!0);throw this.toFileSystemProviderError(L)}finally{b.dispose()}}createUniversalWatcher(i,s,l){return new I.UniversalWatcherClient(u=>i(u),u=>s(u),l)}createNonRecursiveWatcher(i,s,l){return new R.NodeJSWatcherClient(u=>i(u),u=>s(u),l)}toFileSystemProviderError(i){if(i instanceof o.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=o.FileSystemProviderErrorCode.NoPermissions;break;default:s=o.FileSystemProviderErrorCode.Unknown}return(0,o.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let l=this.toFileSystemProviderError(s);if(i&&l.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await p.SymlinkSupport.stat(this.toFilePath(i));u.mode&128||(l=(0,o.createFileSystemProviderError)(s,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return l}}t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0,e.DiskFileSystemProvider=t}),define(ee[213],te([0,1,3,90,2,17,60,22]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends n.Disposable{constructor(w,S){super(),this.provider=w,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(w,S,f){const p=this.getUriTransformer(w);switch(S){case"stat":return this.stat(p,f[0]);case"readdir":return this.readdir(p,f[0]);case"open":return this.open(p,f[0],f[1]);case"close":return this.close(f[0]);case"read":return this.read(f[0],f[1],f[2]);case"readFile":return this.readFile(p,f[0],f[1]);case"write":return this.write(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.writeFile(p,f[0],f[1],f[2]);case"rename":return this.rename(p,f[0],f[1],f[2]);case"copy":return this.copy(p,f[0],f[1],f[2]);case"cloneFile":return this.cloneFile(p,f[0],f[1]);case"mkdir":return this.mkdir(p,f[0]);case"delete":return this.delete(p,f[0],f[1]);case"watch":return this.watch(p,f[0],f[1],f[2],f[3]);case"unwatch":return this.unwatch(f[0],f[1])}throw new Error(`IPC Command ${S} not found`)}listen(w,S,f){const p=this.getUriTransformer(w);switch(S){case"fileChange":return this.onFileChange(p,f[0]);case"readFileStream":return this.onReadFileStream(p,f[0],f[1])}throw new Error(`Unknown event ${S}`)}stat(w,S){const f=this.transformIncoming(w,S,!0);return this.provider.stat(f)}readdir(w,S){const f=this.transformIncoming(w,S);return this.provider.readdir(f)}async readFile(w,S,f){const p=this.transformIncoming(w,S,!0),v=await this.provider.readFile(p,f);return M.VSBuffer.wrap(v)}onReadFileStream(w,S,f){const p=this.transformIncoming(w,S,!0),v=new P.CancellationTokenSource,o=new E.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),d=this.provider.readFileStream(p,f,v.token);return(0,k.listenStream)(d,{onData:m=>o.fire(M.VSBuffer.wrap(m)),onError:m=>o.fire(m),onEnd:()=>{o.fire("end"),o.dispose(),v.dispose()}}),o.event}writeFile(w,S,f,p){const v=this.transformIncoming(w,S);return this.provider.writeFile(v,f.buffer,p)}open(w,S,f){const p=this.transformIncoming(w,S,!0);return this.provider.open(p,f)}close(w){return this.provider.close(w)}async read(w,S,f){const p=M.VSBuffer.alloc(f),v=0,o=await this.provider.read(w,S,p.buffer,v,f);return[p,o]}write(w,S,f,p,v){return this.provider.write(w,S,f.buffer,p,v)}mkdir(w,S){const f=this.transformIncoming(w,S);return this.provider.mkdir(f)}delete(w,S,f){const p=this.transformIncoming(w,S);return this.provider.delete(p,f)}rename(w,S,f,p){const v=this.transformIncoming(w,S),o=this.transformIncoming(w,f);return this.provider.rename(v,o,p)}copy(w,S,f,p){const v=this.transformIncoming(w,S),o=this.transformIncoming(w,f);return this.provider.copy(v,o,p)}cloneFile(w,S,f){const p=this.transformIncoming(w,S),v=this.transformIncoming(w,f);return this.provider.cloneFile(p,v)}onFileChange(w,S){const f=new E.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(w,f))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return f.event}async watch(w,S,f,p,v){const o=this.sessionToWatcher.get(S);if(o){const d=this.transformIncoming(w,p),m=o.watch(f,d,v);this.watchRequests.set(S+f,m)}}async unwatch(w,S){const f=w+S,p=this.watchRequests.get(f);p&&((0,n.dispose)(p),this.watchRequests.delete(f))}dispose(){super.dispose();for(const[,w]of this.watchRequests)w.dispose();this.watchRequests.clear();for(const[,w]of this.sessionToWatcher)w.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class h extends n.Disposable{constructor(w,S,f,p){super(),this.uriTransformer=w,this.logService=f,this.environmentService=p,this.watcherRequests=new Map,this.fileWatcher=this._register(new D.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(w){const S=this._register(new E.Emitter);this._register(S.event(f=>{w.fire(f.map(p=>({resource:this.uriTransformer.transformOutgoingURI(p.resource),type:p.type})))})),this._register(this.fileWatcher.onDidChangeFile(f=>S.fire(f))),this._register(this.fileWatcher.onDidWatchError(f=>w.fire(f)))}getRecursiveWatcherOptions(w){}getExtraExcludes(w){}watch(w,S,f){const p=this.getExtraExcludes(this.environmentService);return Array.isArray(p)&&(f.excludes=[...f.excludes,...p]),this.watcherRequests.set(w,this.fileWatcher.watch(S,f)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.watcherRequests.get(w)),this.watcherRequests.delete(w)})}dispose(){super.dispose();for(const[,w]of this.watcherRequests)w.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=h}),define(ee[214],te([0,1,15,169,4,7,16,9,213,147]),function(j,e,E,D,n,M,k,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class y extends g.AbstractDiskFileSystemProviderChannel{constructor(f,p,v){super(f,p),this.environmentService=v}getUriTransformer(f){return h.DefaultURITransformer}transformIncoming(f,p){return M.URI.revive(p)}async delete(f,p,v){if(!v.useTrash)return super.delete(f,p,v);const o=this.transformIncoming(f,p),d=(0,P.normalize)(o.fsPath);try{await E.shell.trashItem(d)}catch{throw(0,k.createFileSystemProviderError)(n.isWindows?(0,D.localize)(0,null,(0,P.basename)(d)):(0,D.localize)(1,null,(0,P.basename)(d)),k.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,p){return new w(f,p,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=y;class w extends g.AbstractSessionFileWatcher{watch(f,p,v){if(v.recursive)throw(0,k.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",k.FileSystemProviderErrorCode.Unavailable);return super.watch(f,p,v)}}}),define(ee[215],te([0,1,5]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class D extends E.AbstractMessageLogger{constructor(M=E.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(k=>{this._logger?.setLevel(k)}))}set logger(M){this._logger=M;for(const{level:k,message:P}of this.buffer)(0,E.log)(M,k,P);this.buffer=[]}log(M,k){this._logger?(0,E.log)(this._logger,M,k):this.getLevel()<=M&&this.buffer.push({level:M,message:k})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=D}),define(ee[216],te([0,1,2,5]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends E.Disposable{constructor(k,P=[]){super(),this.logger=new D.MultiplexLogger([k,...P]),this._register(k.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...P){this.logger.trace(k,...P)}debug(k,...P){this.logger.debug(k,...P)}info(k,...P){this.logger.info(k,...P)}warn(k,...P){this.logger.warn(k,...P)}error(k,...P){this.logger.error(k,...P)}flush(){this.logger.flush()}}e.LogService=n}),define(ee[217],te([0,1,35,7,5]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class M{constructor(P){this.loggerService=P,this.loggers=new E.ResourceMap}listen(P,g,h){switch(g){case"onDidChangeLoggers":return h?this.loggerService.getOnDidChangeLoggersEvent(h):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return h?this.loggerService.getOnDidChangeLogLevelEvent(h):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return h?this.loggerService.getOnDidChangeVisibilityEvent(h):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${g}`)}async call(P,g,h){switch(g){case"createLogger":this.createLogger(D.URI.revive(h[0]),h[1],h[2]);return;case"log":return this.log(D.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1]);case"setLogLevel":return(0,n.isLogLevel)(h[0])?this.loggerService.setLogLevel(h[0]):this.loggerService.setLogLevel(D.URI.revive(h[0]),h[1]);case"setVisibility":return this.loggerService.setVisibility(D.URI.revive(h[0]),h[1]);case"registerLogger":return this.loggerService.registerLogger({...h[0],resource:D.URI.revive(h[0].resource)},h[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(D.URI.revive(h[0]))}throw new Error(`Call not found: ${g}`)}createLogger(P,g,h){this.loggers.set(P,this.loggerService.createLogger(P,g,h))}consoleLog(P,g){let h=console.log;switch(P){case n.LogLevel.Error:h=console.error;break;case n.LogLevel.Warning:h=console.warn;break;case n.LogLevel.Info:h=console.info;break}h.call(console,...g)}log(P,g){const h=this.loggers.get(P);if(!h)throw new Error("Create the logger before logging");for(const[y,w]of g)(0,n.log)(h,y,w)}}e.LoggerChannel=M}),define(ee[218],te([0,1,16,5]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(n||(n={}));async function M(h,y,w,S,f){try{const p=await new Promise((o,d)=>{j(["spdlog"],o,d)});p.setFlushOn(n.Trace);const v=await p.createAsyncRotatingLogger(h,y,w,S);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(p){console.error(p)}return null}function k(h,y,w){switch(y){case D.LogLevel.Trace:h.trace(w);break;case D.LogLevel.Debug:h.debug(w);break;case D.LogLevel.Info:h.info(w);break;case D.LogLevel.Warning:h.warn(w);break;case D.LogLevel.Error:h.error(w);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function P(h,y){switch(y){case D.LogLevel.Trace:h.setLevel(n.Trace);break;case D.LogLevel.Debug:h.setLevel(n.Debug);break;case D.LogLevel.Info:h.setLevel(n.Info);break;case D.LogLevel.Warning:h.setLevel(n.Warning);break;case D.LogLevel.Error:h.setLevel(n.Error);break;case D.LogLevel.Off:h.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class g extends D.AbstractMessageLogger{constructor(y,w,S,f,p){super(),this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(y,w,S,f),this._register(this.onDidChangeLogLevel(v=>{this._logger&&P(this._logger,v)}))}async _createSpdLogLogger(y,w,S,f){const p=S?6:1,v=30/p*E.ByteSize.MB,o=await M(y,w,v,p,f);if(o){this._logger=o,P(this._logger,this.getLevel());for(const{level:d,message:m}of this.buffer)k(this._logger,d,m);this.buffer=[]}}log(y,w){this._logger?k(this._logger,y,w):this.getLevel()<=y&&this.buffer.push({level:y,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=g}),define(ee[219],te([0,1,31,5,218]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class M extends D.AbstractLoggerService{doCreateLogger(P,g,h){return new n.SpdLogLogger((0,E.generateUuid)(),P.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,g)}}e.LoggerService=M}),define(ee[65],te([0,1,35,3,6,5,219]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(M.ILoggerService);class P extends k.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new E.ResourceMap}createLogger(h,y,w){w!==void 0&&this.loggerResourcesByWindow.set(h,w);try{return super.createLogger(h,y)}catch(S){throw this.loggerResourcesByWindow.delete(h),S}}registerLogger(h,y){y!==void 0&&this.loggerResourcesByWindow.set(h.resource,y),super.registerLogger(h)}deregisterLogger(h){this.loggerResourcesByWindow.delete(h),super.deregisterLogger(h)}getRegisteredLoggers(h){const y=[];for(const w of super.getRegisteredLoggers())h===this.loggerResourcesByWindow.get(w.resource)&&y.push(w);return y}getOnDidChangeLogLevelEvent(h){return D.Event.filter(this.onDidChangeLogLevel,y=>(0,M.isLogLevel)(y)||this.isInterestedLoggerResource(y[0],h))}getOnDidChangeVisibilityEvent(h){return D.Event.filter(this.onDidChangeVisibility,([y])=>this.isInterestedLoggerResource(y,h))}getOnDidChangeLoggersEvent(h){return D.Event.filter(D.Event.map(this.onDidChangeLoggers,y=>({added:[...y.added].filter(S=>this.isInterestedLoggerResource(S.resource,h)),removed:[...y.removed].filter(S=>this.isInterestedLoggerResource(S.resource,h))})),y=>y.added.length>0||y.removed.length>0)}deregisterLoggers(h){for(const[y,w]of this.loggerResourcesByWindow)w===h&&this.deregisterLogger(y)}isInterestedLoggerResource(h,y){const w=this.loggerResourcesByWindow.get(h);return w===void 0||w===y}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=P}),define(ee[220],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function D(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=D;function n(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function M(k){return!E(k)&&!D(k)&&!n(k)}e.isMenubarMenuItemAction=M}),define(ee[37],te([0,1,3,70,2,6]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,M.createDecorator)("policy");class k extends n.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(h){const y=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...h,...this.policyDefinitions},y!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(h),D.Iterable.reduce(this.policies.entries(),(w,[S,f])=>({...w,[S]:f}),{})}getPolicyValue(h){return this.policies.get(h)}serialize(){return D.Iterable.reduce(Object.entries(this.policyDefinitions),(h,[y,w])=>({...h,[y]:{definition:w,value:this.policies.get(y)}}),{})}}e.AbstractPolicyService=k;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ee[221],te([0,1,8,3,70,10,16,5,37]),function(j,e,E,D,n,M,k,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function h(w,S){const f=[];for(const p of new Set(n.Iterable.concat(w.keys(),S.keys())))w.get(p)!==S.get(p)&&f.push(p);return f}let y=class extends g.AbstractPolicyService{constructor(S,f,p){super(),this.file=S,this.fileService=f,this.logService=p,this.throttledDelayer=this._register(new E.ThrottledDelayer(500));const v=D.Event.filter(f.onDidFilesChange,o=>o.affects(S));this._register(f.watch(S)),this._register(v(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const S=new Map;try{const f=await this.fileService.readFile(this.file),p=JSON.parse(f.value.toString());if(!(0,M.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(p))this.policyDefinitions[v]&&S.set(v,p[v])}catch(f){f.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return S}async refresh(){const S=await this.read(),f=h(this.policies,S);this.policies=S,f.length>0&&this._onDidChange.fire(f)}};y=we([Z(1,k.IFileService),Z(2,P.ILogService)],y),e.FilePolicyService=y}),define(ee[222],te([0,1,3,2,37]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class M{constructor(g){this.service=g,this.disposables=new D.DisposableStore}listen(g,h){switch(h){case"onDidChange":return E.Event.map(this.service.onDidChange,y=>y.reduce((w,S)=>({...w,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${h}`)}call(g,h,y){switch(h){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${h}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=M;class k extends n.AbstractPolicyService{constructor(g,h){super(),this.channel=h;for(const y in g){const{definition:w,value:S}=g[y];this.policyDefinitions[y]=w,S!==void 0&&this.policies.set(y,S)}this.channel.listen("onDidChange")(y=>{for(const w in y){const S=y[w];S===null?this.policies.delete(w):this.policies.set(w,S)}this._onDidChange.fire(Object.keys(y))})}async _updatePolicyDefinitions(g){const h=await this.channel.call("updatePolicyDefinitions",g);for(const y in h)this.policies.set(y,h[y])}}e.PolicyChannelClient=k}),define(ee[66],te([0,1,14,4,36,109]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.context<"u"){const P=D.globals.vscode.context.configuration();if(P)k=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){k=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:P,searchUrl:g,itemUrl:h,controlUrl:y}=k.extensionsGallery||{};Object.assign(k,{extensionsGallery:{serviceUrl:n.env.VSCODE_GALLERY_SERVICE_URL||P,searchUrl:n.env.VSCODE_GALLERY_SEARCH_URL||g,itemUrl:n.env.VSCODE_GALLERY_ITEM_URL||h,controlUrl:n.env.VSCODE_GALLERY_CONTROL_URL||y}});try{const w=(...v)=>v.reduce((o,d)=>(Object.keys(d).forEach(m=>{Array.isArray(o[m])&&Array.isArray(d[m])?o[m]=d[m]:typeof o[m]=="object"&&typeof d[m]=="object"?o[m]=w(o[m],d[m]):o[m]=d[m]}),o),{}),S=(0,M.getUserDataPath)({},k.nameShort),f=D.isWindows?`file:///${S}/product.json`:`file://${S}/product.json`,p=j.__$__nodeRequire(E.FileAccess.asFileUri(f).fsPath);k=w(k,p)}catch{}if(n.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const w=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:w.version,release:w.release})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(ee[20],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[223],te([0,1,80,5,20]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(P,g){this.productService=P,this.logService=g,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(P,g){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const h=/^(.*)#([^#]+)$/.exec(g);if(!h)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,y,w]=h;let S=this.trustedExtensionUrlPublicKeys.get(P);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[P],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.trustedExtensionUrlPublicKeys.set(P,[...S])}const f=Buffer.from(decodeURIComponent(w),"base64");if(f.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const p=f.slice(0,6),v=f.readUIntBE(0,6),o=Date.now()-v;if(o<0||o>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const d=f.slice(6),m=E.createVerify("SHA256");m.write(p),m.write(Buffer.from(y)),m.end();for(let C=0;C<S.length;C++){let I=S[C];if(I!==null){if(typeof I=="string")try{I=E.createPublicKey({key:Buffer.from(I,"base64"),format:"der",type:"spki"}),S[C]=I}catch(R){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${C+1} for ${P}:`,R),S[C]=null;continue}if(m.verify(I,d))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};M=we([Z(0,n.IProductService),Z(1,D.ILogService)],M),e.ExtensionUrlTrustService=M}),define(ee[224],te([0,1,8,5]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=class{constructor(k,P,g){this._window=k,this._sessionId=P,this._logService=g}async inspect(k){await this._connect();const P=this._window.webContents.debugger;await P.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,E.timeout)(k);const g=await P.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),g.profile}async _connect(){const k=this._window.webContents.debugger;k.attach(),await k.sendCommand("Profiler.enable")}async _disconnect(){const k=this._window.webContents.debugger;await k.sendCommand("Profiler.disable"),k.detach()}};n=we([Z(2,D.ILogService)],n),e.WindowProfiler=n}),define(ee[67],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ee[51],te([0,1,125,10]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.data=new Map}add(k,P){E.ok(D.isString(k)),E.ok(D.isObject(P)),E.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new n}),define(ee[225],te([0,1,3,51]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,h){this.schemasById[n(g)]=h,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new M;D.Registry.add(e.Extensions.JSONContribution,k)}),define(ee[68],te([0,1,25,3,10,156,19,225,51]),function(j,e,E,D,n,M,k,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=g.Registry.as(P.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.doRegisterConfigurations(t,a,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.doDeregisterConfigurations(t,a),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.doDeregisterConfigurations(a,i),this.doRegisterConfigurations(t,!1,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.doRegisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,a){const i=[];for(const{overrides:s,source:l}of t)for(const u in s)if(a.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const r=this.configurationDefaultsOverrides.get(u),c=r?.valuesSources??new Map;if(l)for(const F of Object.keys(s[u]))c.set(F,l);const b={...r?.value||{},...s[u]};this.configurationDefaultsOverrides.set(u,{source:l,value:b,valuesSources:c});const L=(0,k.getLanguageTagSettingPlainKey)(u),T={type:"object",default:b,description:M.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:n.isString(l)?void 0:l,defaultValueSource:l};i.push(...v(u)),this.configurationProperties[u]=T,this.defaultLanguageConfigurationOverridesNode.properties[u]=T}else{this.configurationDefaultsOverrides.set(u,{value:s[u],source:l});const r=this.configurationProperties[u];r&&(this.updatePropertyDefaultValue(u,r),this.updateSchema(u,r))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(t){const a=new Set;this.doDeregisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,a){for(const{overrides:i,source:s}of t)for(const l in i){const u=this.configurationDefaultsOverrides.get(l),r=n.isString(s)?s:s?.id,c=n.isString(u?.source)?u?.source:u?.source?.id;if(r===c)if(a.add(l),this.configurationDefaultsOverrides.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const b=this.configurationProperties[l];b&&(this.updatePropertyDefaultValue(l,b),this.updateSchema(l,b))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,i),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const a of t)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,a,i){t.forEach(s=>{this.validateAndRegisterProperties(s,a,s.extensionInfo,s.restrictedProperties,void 0,i),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(t,a){const i=s=>{if(s.properties)for(const l in s.properties){a.add(l);const u=this.configurationProperties[l];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[l],this.removeFromSchema(l,s.properties[l])}s.allOf?.forEach(l=>i(l))};for(const s of t){i(s);const l=this.configurationContributors.indexOf(s);l!==-1&&this.configurationContributors.splice(l,1)}}validateAndRegisterProperties(t,a=!0,i,s,l=3,u){l=n.isUndefinedOrNull(t.scope)?l:t.scope;const r=t.properties;if(r)for(const b in r){const L=r[b];if(a&&C(b,L)){delete r[b];continue}if(L.source=i,L.defaultDefaultValue=r[b].default,this.updatePropertyDefaultValue(b,L),e.OVERRIDE_PROPERTY_REGEX.test(b)?L.scope=void 0:(L.scope=n.isUndefinedOrNull(L.scope)?l:L.scope,L.restricted=n.isUndefinedOrNull(L.restricted)?!!s?.includes(b):L.restricted),r[b].hasOwnProperty("included")&&!r[b].included){this.excludedConfigurationProperties[b]=r[b],delete r[b];continue}else this.configurationProperties[b]=r[b],r[b].policy?.name&&this.policyConfigurations.set(r[b].policy.name,b);!r[b].deprecationMessage&&r[b].markdownDeprecationMessage&&(r[b].deprecationMessage=r[b].markdownDeprecationMessage),u.add(b)}const c=t.allOf;if(c)for(const b of c)this.validateAndRegisterProperties(b,a,i,s,l,u)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const a=i=>{const s=i.properties;if(s)for(const u in s)this.updateSchema(u,s[u]);i.allOf?.forEach(a)};a(t)}updateSchema(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.resourceLanguageSettingsSchema.properties[t]=a;break}}removeFromSchema(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const a=`[${t}]`,i={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}registerOverridePropertyPatternKey(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,a){const i=this.configurationDefaultsOverrides.get(t);let s=i?.value,l=i?.source;n.isUndefined(s)&&(s=a.defaultDefaultValue,l=void 0),n.isUndefined(s)&&(s=d(a.type)),a.default=s,a.defaultValueSource=l}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(R){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let a=p.exec(R);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=p.exec(R)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=v;function o(R){return R.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=o;function d(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const m=new S;g.Registry.add(e.Extensions.Configuration,m);function C(R,t){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?M.localize(7,null,R):m.getConfigurationProperties()[R]!==void 0?M.localize(8,null,R):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,R,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.validateProperty=C;function I(){const R=[],t=m.getConfigurationProperties();for(const a of Object.keys(t))R.push([a,t[a].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=I}),define(ee[113],te([0,1,25,3,43,2,35,40,10,7,19,68,51]),function(j,e,E,D,n,M,k,P,g,h,y,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(a){return Object.isFrozen(a)?a:P.deepFreeze(a)}class p{constructor(i={},s=[],l=[],u){this._contents=i,this._keys=s,this._overrides=l,this.raw=u,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof p)return s;const l=new v("");return l.parseRaw(s),l.configurationModel});this._rawConfiguration=i.reduce((s,l)=>l===s?l:s.merge(l),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,y.getConfigurationValue)(this.contents,i):this.contents}inspect(i,s){const l=this.rawConfiguration.getValue(i),u=s?this.rawConfiguration.getOverrideValue(i,s):void 0,r=s?this.rawConfiguration.override(s).getValue(i):l;return{value:l,override:u,merged:r}}getOverrideValue(i,s){const l=this.getContentsForOverrideIdentifer(s);return l?i?(0,y.getConfigurationValue)(l,i):l:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const l of this.overrides)l.identifiers.includes(i)&&s.push(...l.keys);return E.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return E.distinct(i)}override(i){let s=this.overrideConfigurations.get(i);return s||(s=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,s)),s}merge(...i){const s=P.deepClone(this.contents),l=P.deepClone(this.overrides),u=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const c of i)if(r.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.mergeContents(s,c.contents);for(const b of c.overrides){const[L]=l.filter(T=>E.equals(T.identifiers,b.identifiers));L?(this.mergeContents(L.contents,b.contents),L.keys.push(...b.keys),L.keys=E.distinct(L.keys)):l.push(P.deepClone(b))}for(const b of c.keys)u.indexOf(b)===-1&&u.push(b)}return new p(s,u,l,r.every(c=>c instanceof p)?void 0:r)}createOverrideConfigurationModel(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const l={};for(const u of E.distinct([...Object.keys(this.contents),...Object.keys(s)])){let r=this.contents[u];const c=s[u];c&&(typeof r=="object"&&typeof c=="object"?(r=P.deepClone(r),this.mergeContents(r,c)):r=c),l[u]=r}return new p(l,this.keys,this.overrides)}mergeContents(i,s){for(const l of Object.keys(s)){if(l in i&&g.isObject(i[l])&&g.isObject(s[l])){this.mergeContents(i[l],s[l]);continue}i[l]=P.deepClone(s[l])}}getContentsForOverrideIdentifer(i){let s=null,l=null;const u=r=>{r&&(l?this.mergeContents(l,r):l=P.deepClone(r))};for(const r of this.overrides)E.equals(r.identifiers,[i])?s=r.contents:r.identifiers.includes(i)&&u(r.contents);return u(s),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.updateValue(i,s,!0)}setValue(i,s){this.updateValue(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,y.removeFromValueTree)(this.contents,i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(l=>E.equals(l.identifiers,(0,w.overrideIdentifiersFromKey)(i))),1))}updateValue(i,s,l){(0,y.addToValueTree)(this.contents,i,s,u=>console.error(u)),l=l||this.keys.indexOf(i)===-1,l&&this.keys.push(i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,y.toValuesTree)(this.contents[i],u=>console.error(u))})}}e.ConfigurationModel=p;class v{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!g.isUndefinedOrNull(i)){const l=this.doParseContent(i);this.parseRaw(l,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:l,keys:u,overrides:r,restricted:c,hasExcludedProperties:b}=this.doParseRaw(i,s);this._configurationModel=new p(l,u,r,b?[i]:void 0),this._restrictedConfigurations=c||[]}doParseContent(i){let s={},l=null,u=[];const r=[],c=[];function b(T){Array.isArray(u)?u.push(T):l!==null&&(u[l]=T)}const L={onObjectBegin:()=>{const T={};b(T),r.push(u),u=T,l=null},onObjectProperty:T=>{l=T},onObjectEnd:()=>{u=r.pop()},onArrayBegin:()=>{const T=[];b(T),r.push(u),u=T,l=null},onArrayEnd:()=>{u=r.pop()},onLiteralValue:b,onError:(T,F,Y)=>{c.push({error:T,offset:F,length:Y})}};if(i)try{n.visit(i,L),s=u[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return s}doParseRaw(i,s){const l=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),u=this.filter(i,l,!0,s);i=u.raw;const r=(0,y.toValuesTree)(i,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),c=Object.keys(i),b=this.toOverrides(i,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:r,keys:c,overrides:b,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}filter(i,s,l,u){let r=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:r};const c={},b=[];for(const L in i)if(w.OVERRIDE_PROPERTY_REGEX.test(L)&&l){const T=this.filter(i[L],s,!1,u);c[L]=T.raw,r=r||T.hasExcludedProperties,b.push(...T.restricted)}else{const T=s[L],F=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&b.push(L),(F===void 0||u.scopes===void 0||u.scopes.includes(F))&&!(u.skipRestricted&&T?.restricted)?c[L]=i[L]:r=!0}return{raw:c,restricted:b,hasExcludedProperties:r}}toOverrides(i,s){const l=[];for(const u of Object.keys(i))if(w.OVERRIDE_PROPERTY_REGEX.test(u)){const r={};for(const c in i[u])r[c]=i[u][c];l.push({identifiers:(0,w.overrideIdentifiersFromKey)(u),keys:Object.keys(r),contents:(0,y.toValuesTree)(r,s)})}return l}}e.ConfigurationModelParser=v;class o extends M.Disposable{constructor(i,s,l,u){super(),this.userSettingsResource=i,this.scopes=s,this.fileService=u,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&l.isEqual(r.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=o;class d{constructor(i,s,l,u,r,c,b,L,T,F,Y,V,G){this.key=i,this.overrides=s,this._value=l,this.overrideIdentifiers=u,this.defaultConfiguration=r,this.policyConfiguration=c,this.applicationConfiguration=b,this.userConfiguration=L,this.localUserConfiguration=T,this.remoteUserConfiguration=F,this.workspaceConfiguration=Y,this.folderConfigurationModel=V,this.memoryConfigurationModel=G}get value(){return f(this._value)}inspect(i,s,l){const u=i.inspect(s,l);return{get value(){return f(u.value)},get override(){return f(u.override)},get merged(){return f(u.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class m{constructor(i,s,l,u,r=new p,c=new p,b=new k.ResourceMap,L=new p,T=new k.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=s,this._applicationConfiguration=l,this._localUserConfiguration=u,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=b,this._memoryConfiguration=L,this._memoryConfigurationByResource=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(i,s,l){return this.getConsolidatedConfigurationModel(i,s,l).getValue(i)}updateValue(i,s,l={}){let u;l.resource?(u=this._memoryConfigurationByResource.get(l.resource),u||(u=new p,this._memoryConfigurationByResource.set(l.resource,u))):u=this._memoryConfiguration,s===void 0?u.removeValue(i):u.setValue(i,s),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,l){const u=this.getConsolidatedConfigurationModel(i,s,l),r=this.getFolderConfigurationModelForResource(s.resource,l),c=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,b=new Set;for(const L of u.overrides)for(const T of L.identifiers)u.getOverrideValue(i,T)!==void 0&&b.add(T);return new d(i,s,u.getValue(i),b.size?[...b]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this._workspaceConfiguration:void 0,r||void 0,c)}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const l=[];if(!s){const{added:u,updated:r,removed:c}=R(this._defaultConfiguration,i);s=[...u,...r,...c]}for(const u of s)for(const r of(0,w.overrideIdentifiersFromKey)(u)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(r),b=i.getKeysForOverrideIdentifier(r),L=[...b.filter(T=>c.indexOf(T)===-1),...c.filter(T=>b.indexOf(T)===-1),...c.filter(T=>!P.equals(this._defaultConfiguration.override(r).getValue(T),i.override(r).getValue(T)))];l.push([r,L])}return this.updateDefaultConfiguration(i),{keys:s,overrides:l}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:l,removed:u}=R(this._policyConfiguration,i),r=[...s,...l,...u];return r.length&&this.updatePolicyConfiguration(i),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:l,removed:u,overrides:r}=R(this.applicationConfiguration,i),c=[...s,...l,...u];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:l,removed:u,overrides:r}=R(this.localUserConfiguration,i),c=[...s,...l,...u];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:r}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:l,removed:u,overrides:r}=R(this.remoteUserConfiguration,i),c=[...s,...l,...u];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:r}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:l,removed:u,overrides:r}=R(this.workspaceConfiguration,i),c=[...s,...l,...u];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:r}}compareAndUpdateFolderConfiguration(i,s){const l=this.folderConfigurations.get(i),{added:u,updated:r,removed:c,overrides:b}=R(l,s),L=[...u,...r,...c];return(L.length||!l)&&this.updateFolderConfiguration(i,s),{keys:L,overrides:b}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:l,updated:u,removed:r,overrides:c}=R(s,void 0);return{keys:[...l,...u,...r],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,s,l){let u=this.getConsolidatedConfigurationModelForResource(s,l);return s.overrideIdentifier&&(u=u.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(u=u.merge(this._policyConfiguration)),u}getConsolidatedConfigurationModelForResource({resource:i},s){let l=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const u=s.getFolder(i);u&&(l=this.getFolderConsolidatedConfiguration(u.uri)||l);const r=this._memoryConfigurationByResource.get(i);r&&(l=l.merge(r))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const l=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(i);u?(s=l.merge(u),this._foldersConsolidatedConfigurations.set(i,s)):s=l}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const l=s.getFolder(i);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:l,overrides:u,keys:r}=this._folderConfigurations.get(s);return i.push([s,{contents:l,overrides:u,keys:r}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this._workspaceConfiguration.keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(l=>i.add(l))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(l=>i.add(l))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(l=>s.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(l=>s.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(l=>s.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(i).forEach(u=>s.add(u))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),l=this.parseConfigurationModel(i.policy),u=this.parseConfigurationModel(i.application),r=this.parseConfigurationModel(i.user),c=this.parseConfigurationModel(i.workspace),b=i.folders.reduce((L,T)=>(L.set(h.URI.revive(T[0]),this.parseConfigurationModel(T[1])),L),new k.ResourceMap);return new m(s,l,u,r,new p,c,b,new p,new k.ResourceMap)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides)}}e.Configuration=m;function C(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,s=new Map;for(const u of a)u.keys.forEach(r=>i.add(r)),u.overrides.forEach(([r,c])=>{const b=(0,k.getOrSet)(s,r,new Set);c.forEach(L=>b.add(L))});const l=[];return s.forEach((u,r)=>l.push([r,[...u.values()]])),{keys:[...i.values()],overrides:l}}e.mergeChanges=C;class I{constructor(i,s,l,u){this.change=i,this.previous=s,this.currentConfiguraiton=l,this.currentWorkspace=u,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const r of i.keys)this.affectedKeys.add(r);for(const[,r]of i.overrides)for(const c of r)this.affectedKeys.add(c);this._affectsConfigStr=this._marker;for(const r of this.affectedKeys)this._affectsConfigStr+=r+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){const l=this._marker+i,u=this._affectsConfigStr.indexOf(l);if(u<0)return!1;const r=u+l.length;if(r>=this._affectsConfigStr.length)return!1;const c=this._affectsConfigStr.charCodeAt(r);if(c!==this._markerCode1&&c!==this._markerCode2)return!1;if(s){const b=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,L=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!P.equals(b,L)}return!0}}e.ConfigurationChangeEvent=I;function R(a,i){const{added:s,removed:l,updated:u}=t(i?.rawConfiguration,a?.rawConfiguration),r=[],c=a?.getAllOverrideIdentifiers()||[],b=i?.getAllOverrideIdentifiers()||[];if(i){const L=b.filter(T=>!c.includes(T));for(const T of L)r.push([T,i.getKeysForOverrideIdentifier(T)])}if(a){const L=c.filter(T=>!b.includes(T));for(const T of L)r.push([T,a.getKeysForOverrideIdentifier(T)])}if(i&&a){for(const L of c)if(b.includes(L)){const T=t({contents:a.getOverrideValue(void 0,L)||{},keys:a.getKeysForOverrideIdentifier(L)},{contents:i.getOverrideValue(void 0,L)||{},keys:i.getKeysForOverrideIdentifier(L)});r.push([L,[...T.added,...T.removed,...T.updated]])}}return{added:s,removed:l,updated:u,overrides:r}}function t(a,i){const s=a?i?a.keys.filter(r=>i.keys.indexOf(r)===-1):[...a.keys]:[],l=i?a?i.keys.filter(r=>a.keys.indexOf(r)===-1):[...i.keys]:[],u=[];if(a&&i){for(const r of i.keys)if(a.keys.indexOf(r)!==-1){const c=(0,y.getConfigurationValue)(i.contents,r),b=(0,y.getConfigurationValue)(a.contents,r);P.equals(c,b)||u.push(r)}}return{added:s,removed:l,updated:u}}}),define(ee[226],te([0,1,25,3,2,40,10,113,68,5,37,51]),function(j,e,E,D,n,M,k,P,g,h,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends n.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(w.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:d})=>this.onDidUpdateConfiguration(Array.from(o),d))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(o,d){this.updateConfigurationModel(o,w.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:o})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new P.ConfigurationModel;const o=w.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(o),o)}updateConfigurationModel(o,d){const m=this.getConfigurationDefaultOverrides();for(const C of o){const I=m[C],R=d[C];I!==void 0?this._configurationModel.addValue(C,I):R?this._configurationModel.addValue(C,R.default):this._configurationModel.removeValue(C)}}}e.DefaultConfiguration=S;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let p=class extends n.Disposable{get configurationModel(){return this._configurationModel}constructor(o,d,m){super(),this.defaultConfiguration=o,this.policyService=d,this.logService=m,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(o=>this.onDidChangePolicies(o))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:o})=>this.update(await this.updatePolicyDefinitions(o),!0))),this._configurationModel}async updatePolicyDefinitions(o){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",o);const d={},m=[],C=w.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const I of o){const R=C[I];if(!R){m.push(I);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.logService.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}m.push(I),d[R.policy.name]={type:R.type}}}return(0,k.isEmptyObject)(d)||await this.policyService.updatePolicyDefinitions(d),m}onDidChangePolicies(o){this.logService.trace("PolicyConfiguration#onDidChangePolicies",o);const d=w.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),m=(0,E.coalesce)(o.map(C=>d.get(C)));this.update(m,!0)}update(o,d){this.logService.trace("PolicyConfiguration#update",o);const m=w.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),C=[],I=this._configurationModel.isEmpty();for(const R of o){const t=m[R]?.policy?.name;if(t){const a=this.policyService.getPolicyValue(t);(I?a!==void 0:!(0,M.equals)(this._configurationModel.getValue(R),a))&&C.push([R,a])}else this._configurationModel.getValue(R)!==void 0&&C.push([R,void 0])}if(C.length){this.logService.trace("PolicyConfiguration#changed",C);const R=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const t of R.keys)this._configurationModel.setValue(t,R.getValue(t));for(const[t,a]of C)a===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,a);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};p=we([Z(1,y.IPolicyService),Z(2,h.ILogService)],p),e.PolicyConfiguration=p}),define(ee[227],te([0,1,8,3,2,18,19,113,226,37]),function(j,e,E,D,n,M,k,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends n.Disposable{constructor(S,f,p,v){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new g.DefaultConfiguration),this.policyConfiguration=p instanceof h.NullPolicyService?new g.NullPolicyConfiguration:this._register(new g.PolicyConfiguration(this.defaultConfiguration,p,v)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,f)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:o,properties:d})=>this.onDidDefaultConfigurationChange(o,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(o=>this.onDidPolicyConfigurationChange(o))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,f,p]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(S,f,new P.ConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(S,f){const p=typeof S=="string"?S:void 0,v=(0,k.isConfigurationOverrides)(S)?S:(0,k.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(p,v,void 0)}updateValue(S,f,p,v){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const f=this.configuration.toData(),p=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(p,f,2)}onDidDefaultConfigurationChange(S,f){const p=this.configuration.toData(),v=this.configuration.compareAndUpdateDefaultConfiguration(S,f);this.trigger(v,p,7)}onDidPolicyConfigurationChange(S){const f=this.configuration.toData(),p=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(p,f,7)}trigger(S,f,p){const v=new P.ConfigurationChangeEvent(S,{data:f},this.configuration);v.source=p,v.sourceConfig=this.getTargetConfiguration(p),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(ee[228],te([0,1,13,6]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var n;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends E.ErrorNoTelemetry{static isNotAvailable(g){return g instanceof M&&g._code===n.NotAvailable}static isTemporarilyNotAvailable(g){return g instanceof M&&g._code===n.TemporarilyNotAvailable}static isNoResolverFound(g){return g instanceof M&&g._code===n.NoResolverFound}static isHandled(g){return g instanceof M&&g.isHandled}constructor(g,h=n.Unknown,y){super(g),this._message=g,this._code=h,this._detail=y,this.isHandled=h===n.NotAvailable&&y===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function k(P){const g=P.indexOf("+");return g===-1?P:P.substring(0,g)}e.getRemoteAuthorityPrefix=k}),define(ee[56],te([0,1,14]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(h){return h.scheme===E.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=D;function n(h){if(!h)return;const y=h.indexOf("+");return y<0?h:h.substr(0,y)}e.getRemoteName=n;function M(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=M;function k(h){const{host:y,port:w}=g(h);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:y,port:w}}e.parseAuthorityWithPort=k;function P(h,y){let{host:w,port:S}=g(h);return typeof S>"u"&&(S=y),{host:w,port:S}}e.parseAuthorityWithOptionalPort=P;function g(h){const y=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const w=h.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const S=h.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:h,port:void 0}}}),define(ee[91],te([0,1,27,6,56]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=M;function k(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var g;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class h{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,o){if(typeof v>"u"||v===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof v=="string"||typeof o=="string"){const d=typeof v=="string"?v:v.value,m=typeof o=="string"?o:o.value;return E.equalsIgnoreCase(d,m)}return v._lower===o._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=h;function y(p){return w(p)}e.isApplicationScopedExtension=y;function w(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function S(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function f(p,v){if(v){const o=`onResolveRemoteAuthority:${(0,n.getRemoteName)(v)}`;return p.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[229],te([0,1,8,17,22,13,3,2,64,71,31,105,228,56]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var v;(function(A){A[A.Management=1]="Management",A[A.ExtensionHost=2]="ExtensionHost",A[A.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function o(A){switch(A){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(A){const _=new n.CancellationTokenSource;return setTimeout(()=>_.cancel(),A),_.token}function m(A,_){if(A.isCancellationRequested||_.isCancellationRequested)return n.CancellationToken.Cancelled;const N=new n.CancellationTokenSource;return A.onCancellationRequested(()=>N.cancel()),_.onCancellationRequested(()=>N.cancel()),N.token}class C{get didTimeout(){return this._state==="timedout"}constructor(_){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((N,q)=>{this._resolvePromise=N,this._rejectPromise=q}),_.isCancellationRequested?this._timeout():this._disposables.add(_.onCancellationRequested(()=>this._timeout()))}registerDisposable(_){this._state==="pending"?this._disposables.add(_):_.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const _=new Error("Time limit reached");return _.code="ETIMEDOUT",_.syscall="connect",_}resolve(_){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(_))}reject(_){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(_))}}function I(A,_){const N=new C(_);return N.registerDisposable(A.onControlMessage(q=>{const U=JSON.parse(q.toString()),$=z(U);$?N.reject($):N.resolve(U)})),N.promise}function R(A,_,N,q,U,$,H,oe,fe){const pe=new C(fe),ye=h.StopWatch.create(!1);return A.info(`Creating a socket (${oe})...`),g.mark(`code/willCreateSocket/${H}`),_.connect(N,q,U,$,oe,(Le,_e)=>{pe.didTimeout?(g.mark(`code/didCreateSocketError/${H}`),A.info(`Creating a socket (${oe}) finished after ${ye.elapsed()} ms, but this is too late and has timed out already.`),Le&&A.error(Le),_e?.dispose()):Le||!_e?(g.mark(`code/didCreateSocketError/${H}`),A.info(`Creating a socket (${oe}) returned an error after ${ye.elapsed()} ms.`),pe.reject(Le)):(g.mark(`code/didCreateSocketOK/${H}`),A.info(`Creating a socket (${oe}) was successful after ${ye.elapsed()} ms.`),pe.resolve(_e))}),pe.promise}function t(A,_){const N=new C(_);return A.then(q=>{N.didTimeout||N.resolve(q)},q=>{N.didTimeout||N.reject(q)}),N.promise}async function a(A,_,N,q){const U=J(A,_);A.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let $;try{$=await R(A.logService,A.socketFactory,A.host,A.port,(0,f.getRemoteServerRootPath)(A),`reconnectionToken=${A.reconnectionToken}&reconnection=${A.reconnectionProtocol?"true":"false"}`,o(_),`renderer-${o(_)}-${A.reconnectionToken}`,q)}catch(ye){throw A.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),A.logService.error(ye),ye}A.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let H,oe;A.reconnectionProtocol?(A.reconnectionProtocol.beginAcceptReconnection($,null),H=A.reconnectionProtocol,oe=!1):(H=new w.PersistentProtocol({socket:$,measureRoundTripTime:!0}),oe=!0),A.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const fe=await t(A.signService.createNewMessage((0,y.generateUuid)()),q),pe={type:"auth",auth:A.connectionToken||"00000000000000000000",data:fe.data};H.sendControl(D.VSBuffer.fromString(JSON.stringify(pe)));try{const ye=await I(H,m(q,d(1e4)));if(ye.type!=="sign"||typeof ye.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(A.logService.trace(`${U} 4/6. received SignRequest control message.`),!await t(A.signService.validate(fe,ye.signedData),q)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const _e=await t(A.signService.sign(ye.data),q),Oe={type:"connectionType",commit:A.commit,signedData:_e,desiredConnectionType:_};return N&&(Oe.args=N),A.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(D.VSBuffer.fromString(JSON.stringify(Oe))),{protocol:H,ownsProtocol:oe}}catch(ye){throw ye&&ye.code==="ETIMEDOUT"&&(A.logService.error(`${U} the handshake timed out. Error:`),A.logService.error(ye)),ye&&ye.code==="VSCODE_CONNECTION_ERROR"&&(A.logService.error(`${U} received error control message when negotiating connection. Error:`),A.logService.error(ye)),oe&&O(H),ye}}async function i(A,_,N,q){const U=Date.now(),$=J(A,_),{protocol:H,ownsProtocol:oe}=await a(A,_,N,q),fe=new C(q);return fe.registerDisposable(H.onControlMessage(pe=>{const ye=JSON.parse(pe.toString()),Le=z(ye);Le?(A.logService.error(`${$} received error control message when negotiating connection. Error:`),A.logService.error(Le),oe&&O(H),fe.reject(Le)):(A.reconnectionProtocol?.endAcceptReconnection(),A.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${W(U)}!`),fe.resolve({protocol:H,firstMessage:ye}))})),fe.promise}async function s(A,_){const{protocol:N}=await i(A,1,void 0,_);return{protocol:N}}async function l(A,_,N){const{protocol:q,firstMessage:U}=await i(A,2,_,N),$=U&&U.debugPort;return{protocol:q,debugPort:$}}async function u(A,_,N){const q=Date.now(),U=J(A,3),{protocol:$}=await a(A,3,_,N);return A.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${W(q)}!`),$}async function r(A,_,N){const{host:q,port:U,connectionToken:$}=await A.addressProvider.getAddress();return{commit:A.commit,quality:A.quality,host:q,port:U,connectionToken:$,reconnectionToken:_,reconnectionProtocol:N,socketFactory:A.socketFactory,signService:A.signService,logService:A.logService}}async function c(A,_,N){return L(A,async q=>{const{protocol:U}=await s(q,n.CancellationToken.None);return new x(A,_,N,q.reconnectionToken,U)})}e.connectRemoteAgentManagement=c;async function b(A,_){return L(A,async N=>{const{protocol:q,debugPort:U}=await l(N,_,n.CancellationToken.None);return new B(A,_,N.reconnectionToken,q,U)})}e.connectRemoteAgentExtensionHost=b;async function L(A,_){for(let q=1;;q++)try{const U=(0,y.generateUuid)(),$=await r(A,U,null);return await _($)}catch(U){if(q<5)A.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),A.logService.error(U);else throw A.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),A.logService.error(U),ge.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(U)),U}}async function T(A,_,N){const q=await r(A,(0,y.generateUuid)(),null);return await u(q,{host:_,port:N},n.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function F(A){return(0,E.createCancelablePromise)(_=>new Promise((N,q)=>{const U=setTimeout(N,A*1e3);_.onCancellationRequested(()=>{clearTimeout(U),N()})}))}var Y;(function(A){A[A.ConnectionLost=0]="ConnectionLost",A[A.ReconnectionWait=1]="ReconnectionWait",A[A.ReconnectionRunning=2]="ReconnectionRunning",A[A.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",A[A.ConnectionGain=4]="ConnectionGain",A[A.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(Y=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class V{constructor(_,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=V;class G{constructor(_,N,q,U){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.durationSeconds=q,this.cancellableTimer=U,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=G;class ie{constructor(_,N,q){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=ie;class re{constructor(_,N,q){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.attempt=q,this.type=4}}e.ConnectionGainEvent=re;class de{constructor(_,N){this.reconnectionToken=_,this.connectionHealth=N,this.type=5}}e.ConnectionHealthChangedEvent=de;class ce{constructor(_,N,q,U){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.attempt=q,this.handled=U,this.type=3}}e.ReconnectionPermanentFailureEvent=ce;class ge extends P.Disposable{static triggerPermanentFailure(_,N,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=_,this._permanentFailureAttempt=N,this._permanentFailureHandled=q,this._instances.forEach(U=>U._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(_=>_._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(_=>_._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||ge._permanentFailure}constructor(_,N,q,U,$){super(),this._connectionType=_,this._options=N,this.reconnectionToken=q,this.protocol=U,this._reconnectionFailureIsFatal=$,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new re(this.reconnectionToken,0,0)),this._register(U.onSocketClose(H=>{const oe=se(this._connectionType,this.reconnectionToken,!0);H?H.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${H.hadError}).`),H.error&&this._options.logService.error(H.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this._options.logService.error(H.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(U.onSocketTimeout(H=>{const oe=se(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(U.onHighRoundTripTime(H=>{const oe=ne(this._connectionType,this.reconnectionToken);this._options.logService.info(`${oe} high roundtrip time: ${H.roundTripTime}ms (${H.recentHighRoundTripCount} of ${5} recent samples)`)})),this._register(U.onDidChangeConnectionHealth(H=>{this._onDidStateChange.fire(new de(this.reconnectionToken,H))})),ge._instances.push(this),this._register((0,P.toDisposable)(()=>{const H=ge._instances.indexOf(this);H>=0&&ge._instances.splice(H,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ge._permanentFailureMillisSinceLastIncomingData,ge._permanentFailureAttempt,ge._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const _=se(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${_} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const U=q<N.length?N[q]:N[N.length-1];try{if(U>0){const H=F(U);this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,H)),this._options.logService.info(`${_} waiting for ${U} seconds before reconnecting...`);try{await H}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${_} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${_} resolving connection...`);const $=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${_} connecting to ${$.host}:${$.port}...`),await this._reconnect($,d(p)),this._options.logService.info(`${_} reconnected!`),this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${_} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${_} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${_} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${_} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,M.isCancellationError)($)){this._options.logService.info(`${_} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${_} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,S.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${_} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(_,N,q){this._reconnectionFailureIsFatal?ge.triggerPermanentFailure(_,N,q):this._gotoPermanentFailure(_,N,q)}_gotoPermanentFailure(_,N,q){this._onDidStateChange.fire(new ce(this.reconnectionToken,_,N,q)),O(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}ge._permanentFailure=!1,ge._permanentFailureMillisSinceLastIncomingData=0,ge._permanentFailureAttempt=0,ge._permanentFailureHandled=!1,ge._instances=[],e.PersistentConnection=ge;class x extends ge{constructor(_,N,q,U,$){super(1,_,U,$,!0),this.client=this._register(new w.Client($,{remoteAuthority:N,clientId:q},_.ipcLogger))}async _reconnect(_,N){await s(_,N)}}e.ManagementPersistentConnection=x;class B extends ge{constructor(_,N,q,U,$){super(2,_,q,U,!1),this._startArguments=N,this.debugPort=$}async _reconnect(_,N){await l(_,this._startArguments,N)}}e.ExtensionHostPersistentConnection=B;function O(A){try{A.acceptDisconnect();const _=A.getSocket();A.dispose(),_.dispose()}catch(_){(0,M.onUnexpectedError)(_)}}function z(A){if(A&&A.type==="error"){const _=new Error(`Connection error: ${A.reason}`);return _.code="VSCODE_CONNECTION_ERROR",_}return null}function K(A,_){for(;A.length<_;)A+=" ";return A}function ne(A,_){return`[remote-connection][${K(o(A),13)}][${_.substr(0,5)}\u2026]`}function se(A,_,N){return`${ne(A,_)}[${N?"reconnect":"initial"}]`}function J(A,_){return`${se(_,A.reconnectionToken,!!A.reconnectionProtocol)}[${A.host}:${A.port}]`}function W(A){return`${Date.now()-A} ms`}}),define(ee[230],te([0,1,81,87]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(n,M,k,P,g,h){const y=S=>h(S,void 0),w=E.createConnection({host:n,port:M},()=>{w.removeListener("error",y);const S=Buffer.alloc(16);for(let o=0;o<16;o++)S[o]=Math.round(Math.random()*256);const f=S.toString("base64"),p=[`GET ws://${/:/.test(n)?`[${n}]`:n}:${M}${k}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];w.write(p.join(`\r
`)+`\r
\r
`);const v=o=>{o.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",v),h(void 0,new D.NodeSocket(w,g)))};w.on("data",v)});w.setNoDelay(!0),w.once("error",y)}}}),define(ee[231],te([0,1,26,46,41,189]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let k;async function P(f=!1){return(k===void 0||f)&&(k=g()),k}e.hasWSLFeatureInstalled=P;async function g(){const f=h();if(f===void 0)return!1;if(f>=22e3){const p=w();if(p)return new Promise(v=>{D.execFile(p,["--status"],o=>v(!o))})}else{const p=S();if(p)try{if((await n.promises.stat(p)).isFile())return!0}catch{}}return!1}function h(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(f)return parseInt(f[3])}function y(f){const p=process.env.SystemRoot;if(p){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(p,v?"Sysnative":"System32",f)}}function w(){return y("wsl.exe")}function S(){return y("lxss\\LxssManager.dll")}}),define(ee[57],te([0,1,17,174,68,6,51]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function P(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=P;function g(v){return v.res.statusCode===204}async function h(v){return g(v)?null:(await(0,E.streamToBuffer)(v.stream)).toString()}e.asText=h;async function y(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);return h(v)}e.asTextOrError=y;async function w(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);if(g(v))return null;const d=(await(0,E.streamToBuffer)(v.stream)).toString();try{return JSON.parse(d)}catch(m){throw m.message+=`:
`+d,m}}e.asJson=w;function S(v){p(v)}e.updateProxyConfigurationsScope=S;let f;function p(v){const o=k.Registry.as(n.Extensions.Configuration),d=f;f={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},o.updateConfigurations({add:[f],remove:d?[d]:[]})}p(2)}),define(ee[232],te([0,1,17,22]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(P){this.service=P}listen(P,g){throw new Error("Invalid listen")}call(P,g,h,y=D.CancellationToken.None){switch(g){case"request":return this.service.request(h[0],y).then(async({res:w,stream:S})=>{const f=await(0,E.streamToBuffer)(S);return[{statusCode:w.statusCode,headers:w.headers},f]});case"resolveProxy":return this.service.resolveProxy(h[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class M{constructor(P){this.channel=P}async request(P,g){const[h,y]=await this.channel.call("request",[P],g);return{res:h,stream:(0,E.bufferToStream)(y)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=M}),define(ee[233],te([0,1,234,10]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(k,P){return k.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:k.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(k,P,g={}){const h=(0,E.parse)(k),y=g.proxyUrl||n(h,P);if(!y)return null;const w=(0,E.parse)(y);if(!/^https?:$/.test(w.protocol||""))return null;const S={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,D.isBoolean)(g.strictSSL)?g.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((f,p)=>{j(["http-proxy-agent"],f,p)}))(S):new(await new Promise((f,p)=>{j(["https-proxy-agent"],f,p)}))(S)}e.getProxyAgent=M}),define(ee[114],te([0,1,46,9,175,22,44,13,4,31,150,62,8,129]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function v(d,m,C,I){return C["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(I)&&!C["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(I)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=S.Promises.withAsyncBody(async(R,t)=>{const a=new M.CancellationTokenSource;let i=1e4;const s=d.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,f.clamp)(s,1,120)*1e3);const l=setTimeout(()=>{a.dispose(!0),t(new Error((0,n.localize)(0,null)))},i);try{R(await o(m,a.token))}catch(u){!(0,P.isCancellationError)(u)&&!a.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,k.toErrorMessage)(u)))):R({})}finally{clearTimeout(l),a.dispose()}})),p)}e.getResolvedShellEnv=v;async function o(d,m){const C=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",C);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",I);const R=(0,h.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(R+"({.*})"+R),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",a);const i=await(0,y.getSystemShell)(g.OS,a);return d.trace("getUnixShellEnvironment#shell",i),new Promise((s,l)=>{if(m.isCancellationRequested)return l(new P.CancellationError);const u=(0,D.basename)(i);let r,c;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(r=`& '${process.execPath}' ${b} -p '''${R}'' + JSON.stringify(process.env) + ''${R}'''`,c=["-Login","-Command"]):(r=`'${process.execPath}' ${b} -p '"${R}" + JSON.stringify(process.env) + "${R}"'`,u==="tcsh"||u==="csh"?c=["-ic"]:c=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),r);const L=(0,E.spawn)(i,[...c,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});m.onCancellationRequested(()=>(L.kill(),l(new P.CancellationError))),L.on("error",Y=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Y)),l(Y)});const T=[];L.stdout.on("data",Y=>T.push(Y));const F=[];L.stderr.on("data",Y=>F.push(Y)),L.on("close",(Y,V)=>{const G=Buffer.concat(T).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const ie=Buffer.concat(F).toString("utf8");if(ie.trim()&&d.trace("getUnixShellEnvironment#stderr",ie),Y||V)return l(new Error((0,n.localize)(2,null,Y,V)));const re=t.exec(G),de=re?re[1]:"{}";try{const ce=JSON.parse(de);C?ce.ELECTRON_RUN_AS_NODE=C:delete ce.ELECTRON_RUN_AS_NODE,I?ce.ELECTRON_NO_ATTACH_CONSOLE=I:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ce),s(ce)}catch(ce){d.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(ce)),l(ce)}})})}}),define(ee[92],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[235],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.validators=new Map}vsda(){return new Promise((n,M)=>j(["vsda"],n,M))}async createNewMessage(n){try{const M=await this.vsda(),k=new M.validator;if(k){const P=String(E._nextId++);return this.validators.set(P,k),{id:P,data:k.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,M){if(!n.id)return!0;const k=this.validators.get(n.id);if(!k)return!1;this.validators.delete(n.id);try{return k.validate(M)==="ok"}catch{return!1}}async sign(n){try{const M=await this.vsda(),k=new M.signer;if(k)return k.sign(n)}catch{}return n}}E._nextId=1,e.SignService=E}),define(ee[34],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ee[21],te([0,1,15,42,8,3,2,4,36,10,6,5,34,28]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var p;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(p=e.ShutdownReason||(e.ShutdownReason={}));var v;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let o=class ft extends k.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(m,C,I){super(),this.logService=m,this.stateMainService=C,this.environmentMainService=I,this._onBeforeShutdown=this._register(new M.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new M.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new M.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new M.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ft.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ft.QUIT_AND_RESTART_KEY)}registerListeners(){const m=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};E.app.addListener("before-quit",m);const C=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",C),E.app.once("will-quit",I=>{this.trace("Lifecycle#app.on(will-quit)"),I.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),E.app.removeListener("before-quit",m),E.app.removeListener("window-all-closed",C),E.app.quit()})})}fireOnWillShutdown(m){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const C=[];return this._onWillShutdown.fire({reason:m,join(I){C.push(I)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(C)}catch(I){this.logService.error(I)}try{await this.stateMainService.close()}catch(I){this.logService.error(I)}})(),this.pendingWillShutdownPromise}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===m)return;this.trace(`lifecycle (main): phase changed (value: ${m})`),this._phase=m;const C=this.phaseWhen.get(this._phase);C&&(C.open(),this.phaseWhen.delete(this._phase))}async when(m){if(m<=this._phase)return;let C=this.phaseWhen.get(m);C||(C=new n.Barrier,this.phaseWhen.set(m,C)),await C.wait()}registerWindow(m){const C=new k.DisposableStore;this.windowCounter++,C.add(m.onWillLoad(R=>this._onWillLoadWindow.fire({window:m,workspace:R.workspace,reason:R.reason})));const I=(0,h.assertIsDefined)(m.win);I.on("close",R=>{const t=m.id;if(this.windowToCloseRequest.has(t)){this.windowToCloseRequest.delete(t);return}this.trace(`Lifecycle#window.on('close') - window ID ${m.id}`),R.preventDefault(),this.unload(m,1).then(a=>{if(a){this.windowToCloseRequest.delete(t);return}this.windowToCloseRequest.add(t),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this._onBeforeCloseWindow.fire(m),m.close()})}),I.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.windowCounter--,C.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(m,C){await this.unload(m,3)||m.reload(C)}unload(m,C){const I=this.mapWindowIdToPendingUnload.get(m.id);if(I)return I;const R=this.doUnload(m,C).finally(()=>{this.mapWindowIdToPendingUnload.delete(m.id)});return this.mapWindowIdToPendingUnload.set(m.id,R),R}async doUnload(m,C){if(!m.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${m.id}`);const I=this._quitRequested?2:C,R=await this.onBeforeUnloadWindowInRenderer(m,I);return R?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.handleWindowUnloadVeto(R)):(await this.onWillUnloadWindowInRenderer(m,I),!1)}handleWindowUnloadVeto(m){return m?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(m){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(m),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(m,C){return new Promise(I=>{const R=this.oneTimeListenerTokenGenerator++,t=`vscode:ok${R}`,a=`vscode:cancel${R}`;D.validatedIpcMain.once(t,()=>{I(!1)}),D.validatedIpcMain.once(a,()=>{I(!0)}),m.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:a,reason:C})})}onWillUnloadWindowInRenderer(m,C){return new Promise(I=>{const t=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;D.validatedIpcMain.once(t,()=>I()),m.send("vscode:onWillUnload",{replyChannel:t,reason:C})})}quit(m){return this.trace(`Lifecycle#quit() - begin (willRestart: ${m})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(m&&this.stateMainService.setItem(ft.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(C=>{this.pendingQuitPromiseResolve=C,this.trace("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.pendingQuitPromise)}trace(m){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(m):this.logService.trace(m)}async relaunch(m){this.trace("Lifecycle#relaunch()");const C=process.argv.slice(1);if(m?.addArgs&&C.push(...m.addArgs),m?.removeArgs)for(const t of m.removeArgs){const a=C.indexOf(t);a>=0&&C.splice(a,1)}const I=()=>{try{if(P.isWindows){const t=(0,g.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.logService.error(t)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:C})};E.app.once("quit",I),await this.quit(!0)&&E.app.removeListener("quit",I)}async kill(m){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const C of E.BrowserWindow.getAllWindows())if(C&&!C.isDestroyed()){let I;C.webContents&&!C.webContents.isDestroyed()?I=new Promise(R=>C.once("closed",R)):I=Promise.resolve(),C.destroy(),await I}})()]),E.app.exit(m)}};o.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",o=we([Z(0,w.ILogService),Z(1,S.IStateMainService),Z(2,f.IEnvironmentMainService)],o),e.LifecycleMainService=o}),define(ee[236],te([0,1,4,3,2,6,21]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let P=class extends n.Disposable{constructor(y){super(),this._onDidChangeKeyboardLayout=this._register(new D.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((w,S)=>{j(["native-keymap"],w,S)});this._keyboardLayoutData=g(y),E.isCI||y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=g(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=we([Z(0,k.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function g(h){const y=h.getKeyMap(),w=h.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:w}}}),define(ee[237],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ee[238],te([0,1,8,17,10,33,16,5]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(w,S,f){this.storagePath=w,this.logService=S,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new E.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,S){const f=this.storage[w];return(0,n.isUndefinedOrNull)(f)?S:f}setItem(w,S){this.setItems([{key:w,data:S}])}setItems(w){let S=!1;for(const{key:f,data:p}of w)this.storage[f]!==p&&((0,n.isUndefinedOrNull)(p)?(0,n.isUndefined)(this.storage[f])||(this.storage[f]=void 0,S=!0):(this.storage[f]=p,S=!0));S&&this.save()}removeItem(w){(0,n.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(S){this.logService.error(S)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=g;let h=class{constructor(w,S,f){this.fileStorage=new g(w.stateResource,S,f)}async init(){await this.fileStorage.init()}getItem(w,S){return this.fileStorage.getItem(w,S)}};h=we([Z(0,M.IEnvironmentService),Z(1,P.ILogService),Z(2,k.IFileService)],h),e.StateService=h}),define(ee[239],te([0,1,238]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class D extends E.StateService{setItem(M,k){this.fileStorage.setItem(M,k)}setItems(M){this.fileStorage.setItems(M)}removeItem(M){this.fileStorage.removeItem(M)}close(){return this.fileStorage.close()}}e.StateMainService=D}),define(ee[93],te([0,1,4,36,7,31]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(h){if(E.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function P(h,y,w,S,f,p,v,o,d,m){const C=Object.create(null);C["common.machineId"]=v,C.sessionID=(0,M.generateUuid)()+Date.now(),C.commitHash=f,C.version=p,C["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),C["common.platform"]=(0,E.PlatformToString)(E.platform),C["common.nodePlatform"]=D.platform,C["common.nodeArch"]=S,C["common.product"]=m||"desktop",o&&(C["common.msftInternal"]=o);let I=0;const R=Date.now();Object.defineProperties(C,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),E.isLinuxSnap&&(C["common.snap"]="true");const t=k(w);t&&(C["common.platformDetail"]=t);try{const a=await h.readFile(n.URI.file(d));C["common.source"]=a.value.toString().slice(0,30)}catch{}return C}e.resolveCommonProperties=P;function g(h){const y=D.env.USERDNSDOMAIN;if(!y)return!1;const w=y.toLowerCase();return h.some(S=>w===S)}e.verifyMicrosoftInternalDomain=g}),define(ee[24],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var n;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(n=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[240],te([0,1,26,8,43,14,9,4,7,85,23,104,88,16,20,24]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const o=new Map;async function d(t,a){const i=`${t}::${a.join(":")}`,s=o.get(i);if(s)return s;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,r=new Map,c=2e4;function b(T,F,Y,V){const G=F.substring(T.length+1);return D.Promises.withAsyncBody(async ie=>{let re;try{re=await y.Promises.readdir(F,{withFileTypes:!0})}catch{ie();return}if(V.count>=c){V.count+=re.length,V.maxReached=!0,ie();return}let de=re.length;if(de===0){ie();return}let ce=re;V.count+re.length>c&&(V.maxReached=!0,de=c-V.count,ce=re.slice(0,de)),V.count+=re.length;for(const ge of ce)if(ge.isDirectory()){if(Y.includes(ge.name)||await b(T,(0,k.join)(F,ge.name),Y,V),--de===0){ie();return}}else{const x=ge.name.lastIndexOf(".");if(x>=0){const B=ge.name.substring(x+1);B&&u.set(B,(u.get(B)??0)+1)}for(const B of l)B.relativePathPattern?.test(G)!==!1&&B.filePattern.test(ge.name)&&r.set(B.tag,(r.get(B.tag)??0)+1);if(--de===0){ie();return}}})}const L=D.Promises.withAsyncBody(async T=>{const F={count:0,maxReached:!1};await b(t,t,a,F);const Y=await I(t);T({configFiles:m(r),fileTypes:m(u),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:Y})});return o.set(i,L),L}e.collectWorkspaceStats=d;function m(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function C(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.virtualMachineHint.value()*100)}%`},a=E.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=C;async function I(t){try{const a=new Map,i=(0,k.join)(t,".vscode","launch.json"),s=await y.Promises.readFile(i),l=[],u=(0,n.parse)(s.toString(),l);if(l.length)return console.log(`Unable to parse ${i}`),[];if((0,n.getNodeType)(u)==="object"&&u.configurations)for(const r of u.configurations){const c=r.type;c&&(a.has(c)?a.set(c,a.get(c)+1):a.set(c,1))}return m(a)}catch{return[]}}e.collectLaunchConfigs=I;let R=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const s=E.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${E.loadavg().map(l=>Math.round(l)).join(", ")}`),i.push(`VM:               ${Math.round(h.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,w.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async s=>{let[l,u]=s,r=this.formatProcessList(a,l);return i.forEach(c=>{if((0,S.isRemoteDiagnosticError)(c))r+=`
${c.errorMessage}`,u+=`
${c.errorMessage}`;else if(r+=`

Remote: ${c.hostName}`,c.processes&&(r+=`
${this.formatProcessList(a,c.processes)}`),c.workspaceMetadata){u+=`
|  Remote: ${c.hostName}`;for(const b of Object.keys(c.workspaceMetadata)){const L=c.workspaceMetadata[b];let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${b}): ${T}`,u+=this.formatWorkspaceStats(L)}}}),{processInfo:r,workspaceInfo:u}})}async getSystemInfo(a,i){const{memory:s,vmHint:l,os:u,cpus:r}=C(),c={os:u,memory:s,cpus:r,vmHint:l,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(c.load=`${E.loadavg().map(b=>Math.round(b)).join(", ")}`),P.isLinux&&(c.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(c)}async getDiagnostics(a,i){const s=[];return(0,w.listProcesses)(a.mainPID).then(async l=>(s.push(""),s.push(this.formatEnvironment(a)),s.push(""),s.push(this.formatProcessList(a,l)),a.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(a))),i.forEach(u=>{if((0,S.isRemoteDiagnosticError)(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.formatMachineInfo(u.machineInfo)),u.processes&&s.push(this.formatProcessList(a,u.processes)),u.workspaceMetadata)for(const r of Object.keys(u.workspaceMetadata)){const c=u.workspaceMetadata[r];let b=`${c.fileCount} files`;c.maxFilesReached&&(b=`more than ${b}`),s.push(`Folder (${r}): ${b}`),s.push(this.formatWorkspaceStats(c))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(a){const i=[];let l=0;const u=(L,T)=>{const F=` ${L}(${T})`;l+F.length>60?(i.push(r),r="|                 ",l=r.length):l+=F.length,r+=F};let r="|      File types:";const c=10,b=a.fileTypes.length>c?c:a.fileTypes.length;for(let L=0;L<b;L++){const T=a.fileTypes[L];u(T.name,T.count)}if(i.push(r),a.configFiles.length>=0&&(r="|      Conf files:",l=0,a.configFiles.forEach(L=>{u(L.name,L.count)}),i.push(r)),a.launchConfigFiles.length>0){let L="|      Launch Configs:";a.launchConfigFiles.forEach(T=>{L+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(L)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(s=>s.length));return Object.keys(a).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${a[s]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],s=[];return a.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(i.push(`|  Window (${l.title})`),l.folderURIs.forEach(u=>{const r=g.URI.revive(u);if(r.scheme===M.Schemas.file){const c=r.fsPath;s.push(d(c,["node_modules",".git"]).then(b=>{let L=`${b.fileCount} files`;b.maxFilesReached&&(L=`more than ${L}`),i.push(`|    Folder (${(0,k.basename)(c)}): ${L}`),i.push(this.formatWorkspaceStats(b))}).catch(b=>{i.push(`|      Error: Unable to collect workspace stats for folder ${c} (${b.toString()})`)}))}else i.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(l=>i.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(a,i){const s=new Map;a.windows.forEach(u=>s.set(u.pid,u.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,s,l,i,0),l.join(`
`)}formatProcessItem(a,i,s,l,u){const r=u===0;let c;r?c=l.pid===a?`${this.productService.applicationName} main`:"remote agent":(c=`${"  ".repeat(u)} ${l.name}`,l.name==="window"&&(c=`${c} (${i.get(l.pid)})`));const b=process.platform==="win32"?l.mem:E.totalmem()*(l.mem/100);s.push(`${l.load.toFixed(0).padStart(5," ")}	${(b/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${c}`),Array.isArray(l.children)&&l.children.forEach(L=>this.formatProcessItem(a,i,s,L,u+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:s}of a.folders){const l=g.URI.revive(s);if(l.scheme!==M.Schemas.file)continue;const u=l.fsPath;try{(await d(u,["node_modules",".git"])).fileTypes.forEach(c=>i.add(c.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const s=g.URI.revive(i);if(s.scheme!==M.Schemas.file)continue;const l=s.fsPath;try{const u=await d(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),u.fileTypes.forEach(r=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:r.name,count:r.count})}),u.launchConfigFiles.forEach(r=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:r.name,count:r.count})}),u.configFiles.forEach(r=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:r.name,count:r.count})})}catch{}}}};R=we([Z(0,v.ITelemetryService),Z(1,p.IProductService)],R),e.DiagnosticsService=R}),define(ee[241],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(M){this.appenders=M}listen(M,k){throw new Error(`Event not found: ${k}`)}call(M,k,{eventName:P,data:g}){return this.appenders.forEach(h=>h.log(P,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class D{constructor(M){this.channel=M}log(M,k){return this.channel.call("log",{eventName:M,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=D}),define(ee[52],te([0,1,40,10,3,19,56,93,24]),function(j,e,E,D,n,M,k,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(r){this.value=r}}e.TelemetryTrustedValue=h;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,c){return Promise.resolve(void 0)}publicLog2(r,c){return this.publicLog(r,c)}publicLogError(r,c){return Promise.resolve(void 0)}publicLogError2(r,c){return this.publicLogError(r,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class w{async publicLog(r,c,b){}async publicLogError(r,c,b){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(u,r){return n.Event.debounce(r.onDidChangeConfiguration,(b,L)=>{const T=b?new Set([...b.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:T}},1e3,!0)(b=>{b.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(b.source),configurationKeys:I(b.affectedKeys)})})}e.configurationTelemetry=S;function f(u,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!u.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=f;function p(u,r){return!(r.isBuilt||r.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=p;function v(u){const r=u.getValue(g.TELEMETRY_SETTING_ID),c=u.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function o(u){const r={},c={},b={};C(u,b);for(let L in b){L=L.length>150?L.substr(L.length-149):L;const T=b[L];typeof T=="number"?c[L]=T:typeof T=="boolean"?c[L]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${T.length}`),r[L]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(r[L]=T)}return{properties:r,measurements:c}}e.validateTelemetryData=o;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(u){if(!u)return"none";const r=(0,k.getRemoteName)(u);return d.has(r)?r:"other"}e.cleanRemoteAuthority=m;function C(u,r,c=0,b){if(!!u)for(const L of Object.getOwnPropertyNames(u)){const T=u[L],F=b?b+L:L;Array.isArray(T)?r[F]=(0,E.safeStringify)(T):T instanceof Date?r[F]=T.toISOString():(0,D.isObject)(T)?c<2?C(T,r,c+1,F+"."):r[F]=(0,E.safeStringify)(T):r[F]=T}}function I(u){if(!u)return[];const r=[];return R(r,"",u),r}function R(u,r,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(b=>R(u,r?`${r}.${b}`:b,c[b])):u.push(r)}function t(u,r){const c=u.msftInternalDomains||[],b=r.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(c)||b}e.isInternalTelemetry=t;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=a;function i(u,r){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let c=u;const b=[];for(const Y of r)for(;;){const V=Y.exec(u);if(!V)break;b.push([V.index,Y.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let F=0;for(c="";;){const Y=T.exec(u);if(!Y)break;const V=b.some(([G,ie])=>Y.index<ie&&G<T.lastIndex);!L.test(Y[0])&&!V&&(c+=u.substring(F,Y.index)+"<REDACTED: user-file-path>",F=T.lastIndex)}return F<u.length&&(c+=u.substr(F)),c}function s(u){if(!u)return u;const r=u.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const b of c)if(b.regex.test(r))return`<REDACTED: ${b.label}>`;return u}function l(u,r){return(0,E.cloneAndChange)(u,c=>{if(c instanceof h)return c.value;if(typeof c=="string"){let b=c.replaceAll("%20"," ");b=i(b,r);for(const L of r)b=b.replace(L,"");return b=s(b),b}})}e.cleanData=l}),define(ee[115],te([0,1,27,199,91,4,7,13,36,52]),function(j,e,E,D,n,M,k,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function y(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,E.compareIgnoreCase)(i.id,s.id)===0}e.areSameExtensions=y;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(s){const l=s.manifest?s.manifest.version:s.version,u=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new S(s.identifier,l,u)}static parse(s){const l=w.exec(s);return l&&l[1]&&l[2]?new S({id:l[1]},l[2],l[4]||void 0):null}constructor(s,l,u="undefined"){this.version=l,this.targetPlatform=u,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof S?y(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=S;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(i){const s=f.exec(i);return s&&s[1]?[o(s[1]),s[2]]:[o(i),void 0]}e.getIdAndVersion=p;function v(i,s){return`${i}.${s}`}e.getExtensionId=v;function o(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function d(i,s){return o(v(i,s))}e.getGalleryExtensionId=d;function m(i,s){const l=[],u=r=>{for(const c of l)if(c.some(b=>y(s(b),s(r))))return c;return null};for(const r of i){const c=u(r);c?c.push(r):l.push([r])}return l}e.groupByExtension=m;function C(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=C;function I(i){return{id:new h.TelemetryTrustedValue(i.identifier.id),name:new h.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function R(i,s){const l=[],u=s.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const r=u.shift();if(r&&l.every(c=>!y(c.identifier,{id:r}))){const c=i.filter(b=>y(b.identifier,{id:r}));c.length===1&&(l.push(c[0]),u.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=R;async function t(i,s){if(!M.isLinux)return!1;let l;try{l=(await i.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await i.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){s.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(r))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function a(i,s){const l=await t(i,s),u=(0,D.getTargetPlatform)(l?"alpine":M.platform,g.arch);return s.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=a}),define(ee[242],te([0,1,196,52]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(M,k,P,g,h,y,w){const S={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${k.nameShort})`};if((0,D.supportsTelemetry)(k,P)&&(0,D.getTelemetryLevel)(g)===3){const f=await(0,E.getServiceMachineId)(P,h,y),{machineId:p}=await w.getTelemetryInfo();S["X-Market-User-Id"]=f,S["VSCode-SessionId"]=p||f}return S}e.resolveMarketplaceHeaders=n}),define(ee[243],te([0,1,13,40,52]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const M="https://0.0.0.0/OneCollector/1.0",k="https://0.0.0.0/ping";async function P(h,y,w){const S=await new Promise((d,m)=>{j(["@microsoft/1ds-core-js"],d,m)}),f=await new Promise((d,m)=>{j(["@microsoft/1ds-post-js"],d,m)}),p=new S.AppInsightsCore,v=new f.PostChannel,o={instrumentationKey:h,endpointUrl:M,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(w){o.extensionConfig={};const d={alwaysUseXhrOverride:!0,httpXHROverride:w};o.extensionConfig[v.identifier]=d}return p.initialize(o,[]),p.addTelemetryInitializer(d=>{y&&(d.ext=d.ext??{},d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),p}class g{constructor(y,w,S,f,p){this._isInternalTelemetry=y,this._eventPrefix=w,this._defaultData=S,this._xhrOverride=p,this.endPointUrl=M,this.endPointHealthUrl=k,this._defaultData||(this._defaultData={}),typeof f=="function"?this._aiCoreOrKey=f():this._aiCoreOrKey=f,this._asyncAiCore=null}_withAIClient(y){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){y(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=P(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(w=>{y(w)},w=>{(0,E.onUnexpectedError)(w),console.error(w)})}}log(y,w){if(!this._aiCoreOrKey)return;w=(0,D.mixin)(w,this._defaultData),w=(0,n.validateTelemetryData)(w);const S=this._eventPrefix+"/"+y;try{this._withAIClient(f=>{f.pluginVersionString=w?.properties.version??"Unknown",f.track({name:S,baseData:{name:S,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(y=>{this._withAIClient(w=>{w.unload(!0,()=>{this._aiCoreOrKey=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(ee[116],te([0,1,2,40,4,27,176,19,68,66,20,51,24,52]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(d,m,C){this._configurationService=m,this._productService=C,this._experimentProperties={},this._disposables=new E.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(I=>{(I.affectsConfiguration(S.TELEMETRY_SETTING_ID)||I.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||I.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(d,m){this._experimentProperties[d]=m}_updateTelemetryLevel(){let d=(0,f.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const C=m.usage?3:m.error?2:0;d=Math.min(d,C)}this._telemetryLevel=d}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties,m=d.sessionID,C=d["common.machineId"],I=d["common.firstSessionDate"],R=d["common.msftInternal"];return{sessionId:m,machineId:C,firstSessionDate:I,msftInternal:R}}dispose(){this._disposables.dispose()}_log(d,m,C){return this._telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(I=>{C=(0,D.mixin)(C,this._experimentProperties),C=(0,f.cleanData)(C,this._cleanupPatterns),C=(0,D.mixin)(C,I),this._appenders.forEach(R=>R.log(d,C))},I=>{console.error(I)})}publicLog(d,m){return this._log(d,3,m)}publicLog2(d,m){return this.publicLog(d,m)}publicLogError(d,m){return this._sendErrorTelemetry?this._log(d,2,m):Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=we([Z(1,P.IConfigurationService),Z(2,y.IProductService)],p),e.TelemetryService=p;function v(){const o=(0,k.localize)(0,null,h.default.nameLong),d=h.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",h.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=n.isWeb?"":(0,k.localize)(3,null),C=(0,k.localize)(4,null),I=(0,k.localize)(5,null),R=(0,k.localize)(6,null),t=(0,k.localize)(7,null),a=`
|       | ${C} | ${I} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,k.localize)(8,null);return`
${o} ${d} ${m}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}w.Registry.as(g.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:v(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(g.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,k.localize)(16,null,h.default.nameLong,h.default.privacyStatementUrl):(0,k.localize)(15,null,h.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[244],te([0,1,291,243]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class n extends D.AbstractOneDataSystemAppender{constructor(k,P,g,h){const y={sendPOST:(w,S)=>{const f={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const p=E.request(w.urlString,f,v=>{v.on("data",function(o){S(v.statusCode??200,v.headers,o.toString())}),v.on("error",function(o){S(0,{})})});p.write(w.data),p.end()}catch{S(0,{})}}};super(k,P,g,h,y)}}e.OneDataSystemAppender=n}),define(ee[245],te([0,1,4,85,24]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function M(k){let P=k.getItem(n.machineIdKey);return(typeof P!="string"||E.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,D.getMachineId)()),P}e.resolveMachineId=M}),define(ee[117],te([0,1,24,245]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(M){const k=await(0,D.resolveMachineId)(M);return M.setItem(E.machineIdKey,k),k}e.resolveMachineId=n}),define(ee[69],te([0,1,15,3,2,4,19,6,34]),function(j,e,E,D,n,M,k,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const h="#FFFFFF",y="#1E1E1E",w="#000000",S="#FFFFFF",f="theme",p="themeBackground",v="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let o=class extends n.Disposable{constructor(m,C){super(),this.stateMainService=m,this.configurationService=C,this._onDidChangeColorScheme=this._register(new D.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,E.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(M.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const m=this.getColorScheme();if(m.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return m.dark?w:S;let C=this.stateMainService.getItem(p,null);if(!C)switch(this.stateMainService.getItem(f,"vs-dark").split(" ")[0]){case"vs":C=h;break;case"hc-black":C=w;break;case"hc-light":C=S;break;default:C=y}return M.isMacintosh&&C.toUpperCase()===y&&(C="#171717"),C}saveWindowSplash(m,C){this.stateMainService.setItems([{key:f,data:C.baseTheme},{key:p,data:C.colorInfo.background},{key:v,data:C}]),typeof m=="number"&&this.updateBackgroundColor(m,C)}updateBackgroundColor(m,C){for(const I of E.BrowserWindow.getAllWindows())if(I.id===m){I.setBackgroundColor(C.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(v)}};o=we([Z(0,g.IStateMainService),Z(1,k.IConfigurationService)],o),e.ThemeMainService=o}),define(ee[118],te([0,1,3,19,6,5]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var k;(function(v){v.Http="http",v.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function h(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=w;function S(v,o,d,m){if(d===1)return!1;if(d===2&&w(o)){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(C?.length===4&&parseInt(C[1])>=18)return!1}return v<1024}e.isPortPrivileged=S;class f{constructor(o,d,m){this.remoteAddress=o,this.localAddress=d,this._dispose=m,this._onDispose=new E.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let p=class{constructor(o,d){this.logService=o,this.configurationService=d,this._onTunnelOpened=new E.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new E.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new E.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],d=Array.from(this._tunnels.values());for(const m of d){const C=Array.from(m.values());for(const I of C){const R=await I.value;R&&o.push(R)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:d}of o.values())await d.then(m=>m?.dispose());o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,d,m,C,I){this.addTunnelToMap(o,d,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:d,localAddress:m,privacy:C,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,d){(w(o)||y(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const m=this.getTunnelFromMap(o,d);if(m)return++m.refcount,m.value}openTunnel(o,d,m,C,I,R=!1,t,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${m} on local port ${I}.`),!o)return;if(d||(d="localhost"),C||(C=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.retainOrCreateTunnel(o,d,m,C,I,R,t,a);return i?i.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(s);return(s.tunnelRemoteHost!==d||s.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const d=this._tunnels.get(o.tunnelRemoteHost);if(d){const m=d.get(o.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,m))}}}}async tryDisposeTunnel(o,d,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${d}.`);const C=m.value.then(async I=>{I&&(await I.dispose(!0),this._onTunnelClosed.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(d),C}}async closeTunnel(o,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${d} `);const m=this._tunnels.get(o);if(m&&m.has(d)){const C=m.get(d);C.refcount=0,await this.tryDisposeTunnel(o,d,C)}}addTunnelToMap(o,d,m){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(d,{refcount:1,value:m})}async removeEmptyTunnelFromMap(o,d){const m=this._tunnels.get(o);m&&(await m.get(d)||m.delete(d),m.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,d){const m=[o];y(o)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):w(o)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const C=m.map(I=>this._tunnels.get(I));for(const I of C){const R=I?.get(d);if(R)return R}}canTunnel(o){return!!h(o)}createWithProvider(o,d,m,C,I,R,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${m} on local port ${C}.`);const a=m;this._factoryInProgress.add(a);const i=C===void 0?m:C,s={elevationRequired:I?this.isPortPrivileged(i):!1},l={remoteAddress:{host:d,port:m},localAddressPort:C,privacy:R,public:R?R!==P.Private:void 0,protocol:t},u=o.forwardPort(l,s);return u?(this.addTunnelToMap(d,m,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(a)})):this._factoryInProgress.delete(a),u}};p=we([Z(0,M.ILogService),Z(1,D.IConfigurationService)],p),e.AbstractTunnelService=p}),define(ee[246],te([0,1,81,26,100,230,8,2,19,5,20,229,118,92,4]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(I,R,t,a,i){let s;for(let l=3;l&&(s?.dispose(),s=await new o(I,R,t,a,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));l--);return s}class o extends P.Disposable{constructor(R,t,a,i,s){super(),this.defaultTunnelHost=t,this.suggestedLocalPort=s,this.privacy=S.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=R,this._server=E.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=l=>this._onConnection(l),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(t=>{t()})}async waitForReady(){const R=this.suggestedLocalPort??this.tunnelRemotePort,t=(0,S.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let a=await(0,n.findFreePortFaster)(R,2,1e3,t),i=null;return this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(a=0,this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(R){R.pause();const t=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,w.connectRemoteAgentTunnel)(this._options,t,this.tunnelRemotePort),i=a.getSocket().socket,s=a.readEntireBuffer();a.dispose(),s.byteLength>0&&R.write(s.buffer),R.on("end",()=>{R.localAddress&&this._socketsDispose.delete(R.localAddress),i.end()}),R.on("close",()=>i.end()),R.on("error",()=>{R.localAddress&&this._socketsDispose.delete(R.localAddress),i.destroy()}),i.on("end",()=>R.end()),i.on("close",()=>R.end()),i.on("error",()=>{R.destroy()}),R.pipe(i),i.pipe(R),R.localAddress&&this._socketsDispose.set(R.localAddress,()=>{R.end(),i.end()})}}let d=class extends S.AbstractTunnelService{constructor(R,t,a,i,s){super(t,s),this.socketFactory=R,this.signService=a,this.productService=i}isPortPrivileged(R){return(0,S.isPortPrivileged)(R,this.defaultTunnelHost,p.OS,D.release())}retainOrCreateTunnel(R,t,a,i,s,l,u,r){const c=this.getTunnelFromMap(t,a);if(c)return++c.refcount,c.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,t,a,s,l,u,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${s}.`);const b={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:R,signService:this.signService,logService:this.logService,ipcLogger:null},L=v(b,i,t,a,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(t,a,L),L}}};d=we([Z(1,h.ILogService),Z(2,f.ISignService),Z(3,y.IProductService),Z(4,g.IConfigurationService)],d),e.BaseTunnelService=d;let m=class extends d{constructor(R,t,a,i){super(M.nodeSocketFactory,R,t,a,i)}};m=we([Z(0,h.ILogService),Z(1,f.ISignService),Z(2,y.IProductService),Z(3,g.IConfigurationService)],m),e.TunnelService=m;let C=class extends P.Disposable{constructor(R,t,a,i){super(),this.logService=R,this.productService=t,this.signService=a,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(R,t,a,i,s,l,u,r,c){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${l}.`),!this._tunnelServices.has(R)){const b=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(b),this._tunnelServices.set(R,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this._tunnelServices.delete(R))})}return this._tunnelServices.get(R).openTunnel(t,a,i,s,l,u,r,c)}};C=we([Z(0,h.ILogService),Z(1,y.IProductService),Z(2,f.ISignService),Z(3,g.IConfigurationService)],C),e.SharedTunnelsService=C}),define(ee[49],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var D;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(D=e.StateType||(e.StateType={}));var n;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap",M[M.WindowsInstaller=3]="WindowsInstaller"})(n=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,k)=>({type:"idle",updateType:M,error:k}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ee[247],te([0,1,4,177,68,51]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[248],te([0,1,3,49]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(P){this.service=P}listen(P,g){switch(g){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${g}`)}call(P,g,h){switch(g){case"checkForUpdates":return this.service.checkForUpdates(h);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(h)}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=n;class M{get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}constructor(P){this.channel=P,this._onStateChange=new E.Emitter,this.onStateChange=this._onStateChange.event,this._state=D.State.Uninitialized,this.channel.listen("onStateChange")(g=>this.state=g),this.channel.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(P){return this.channel.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=M}),define(ee[94],te([0,1,8,22,3,19,28,21,5,20,57,49]),function(j,e,E,D,n,M,k,P,g,h,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(p,v,o){return`${o.updateUrl}/api/update/${p}/${v}/${o.commit}`}e.createUpdateURL=S;let f=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,o,d,m,C,I){this.lifecycleMainService=v,this.configurationService=o,this.environmentMainService=d,this.requestService=m,this.logService=C,this.productService=I,this._state=w.State.Uninitialized,this._onStateChange=new n.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.configurationService.getValue("update.mode"),o=this.getProductQuality(v);if(!o){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(o),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(w.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,d=>this.logService.error(d))}getProductQuality(v){return v==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(v=60*60*1e3){return(0,E.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},D.CancellationToken.None)).res.statusCode===204}catch(o){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(o);return}}async _applySpecificUpdate(v){}getUpdateType(){return 1}doQuitAndInstall(){}};f=we([Z(0,P.ILifecycleMainService),Z(1,M.IConfigurationService),Z(2,k.IEnvironmentMainService),Z(3,y.IRequestService),Z(4,g.ILogService),Z(5,h.IProductService)],f),e.AbstractUpdateService=f}),define(ee[249],te([0,1,15,55,3,2,19,28,21,5,20,57,24,49,94]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends p.AbstractUpdateService{get onRawError(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"error",(d,m)=>m)}get onRawUpdateNotAvailable(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(d,m,C)=>({url:m,version:C,productVersion:C}))}get onRawUpdateDownloaded(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(d,m,C,I)=>({releaseNotes:m,version:C,productVersion:C,date:I}))}constructor(d,m,C,I,R,t,a){super(d,m,I,R,t,a),this.telemetryService=C,this.disposables=new M.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(d){this.logService.error("UpdateService error:",d);const C=(this.state.type==="checking for updates"?this.state.explicit:!0)?d:void 0;this.setState(f.State.Idle(1,C))}buildUpdateFeedUrl(d){let m;this.productService.darwinUniversalAssetId?m=this.productService.darwinUniversalAssetId:m=process.arch==="x64"?"darwin":"darwin-arm64";const C=(0,p.createUpdateURL)(m,d,this.productService);try{E.autoUpdater.setFeedURL({url:C})}catch(I){this.logService.error("Failed to set update feed URL",I);return}return C}doCheckForUpdates(d){this.setState(f.State.CheckingForUpdates(d)),E.autoUpdater.checkForUpdates()}onUpdateAvailable(d){this.state.type==="checking for updates"&&this.setState(f.State.Downloading(d))}onUpdateDownloaded(d){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:d.version}),this.setState(f.State.Ready(d)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};we([D.memoize],v.prototype,"onRawError",null),we([D.memoize],v.prototype,"onRawUpdateNotAvailable",null),we([D.memoize],v.prototype,"onRawUpdateAvailable",null),we([D.memoize],v.prototype,"onRawUpdateDownloaded",null),v=we([Z(0,g.ILifecycleMainService),Z(1,k.IConfigurationService),Z(2,S.ITelemetryService),Z(3,P.IEnvironmentMainService),Z(4,w.IRequestService),Z(5,h.ILogService),Z(6,y.IProductService)],v),e.DarwinUpdateService=v}),define(ee[250],te([0,1,46,41,8,3,9,28,21,5,24,49]),function(j,e,E,D,n,M,k,P,g,h,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,o,d){if(this.lifecycleMainService=v,this.logService=d,this._state=w.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,o.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(w.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}scheduleCheckForUpdates(v=60*60*1e3){return(0,n.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(v){}};S=we([Z(0,g.ILifecycleMainService),Z(1,P.IEnvironmentMainService),Z(2,h.ILogService)],S);let f=class extends S{constructor(v,o,d,m,C,I){super(d,m,C),this.snap=v,this.snapRevision=o,this.telemetryService=I;const R=(0,D.watch)(k.dirname(this.snap)),t=M.Event.fromNodeEventEmitter(R,"change",(l,u)=>u),a=M.Event.filter(t,l=>l==="current"),s=M.Event.debounce(a,(l,u)=>u,2e3)(()=>this.checkForUpdates(!1));d.onWillShutdown(()=>{s.dispose(),R.close()})}doCheckForUpdates(){this.setState(w.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(v=>{v?this.setState(w.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(w.State.Idle(2)))},v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(w.State.Idle(2,v.message||v))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+k.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((d,m)=>(0,D.realpath)(`${k.dirname(this.snap)}/current`,(C,I)=>C?m(C):d(I))),o=k.basename(v);return this.snapRevision!==o}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=we([Z(2,g.ILifecycleMainService),Z(3,P.IEnvironmentMainService),Z(4,h.ILogService),Z(5,y.ITelemetryService)],f),e.SnapUpdateService=f}),define(ee[38],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ee[251],te([0,1,38,197,16,18,130,3,2]),function(j,e,E,D,n,M,k,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class h{constructor(S){this.uri=S,this.time=h._clock++}touch(){return this.time=h._clock++,this}}h._clock=0;let y=class{constructor(S){this._fileService=S,this._dispooables=new g.DisposableStore,this._limit=2**16;const f=new Map,p=v=>{let o=f.get(v.scheme);return o===void 0&&(o=S.hasProvider(v)&&!this._fileService.hasCapability(v,1024),f.set(v.scheme,o)),o};this._dispooables.add(P.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new M.ExtUri(p),this._canonicalUris=new k.SkipList((v,o)=>this.extUri.compare(v,o,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,M.normalizePath)(S));const f=this._canonicalUris.get(S);return f?f.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new h(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((p,v)=>p[1].touch<v[1].touch?1:p[1].touch>v[1].touch?-1:0);h._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let p=0;p<f;p++)this._canonicalUris.set(S[p][0],S[p][1].touch())}};y=we([Z(0,n.IFileService)],y),e.UriIdentityService=y,(0,D.registerSingleton)(E.IUriIdentityService,y,1)}),define(ee[119],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ee[252],te([0,1,7]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class D{constructor(P){this.handler=P}listen(P,g){throw new Error(`Event not found: ${g}`)}call(P,g,h){switch(g){case"handleURL":return this.handler.handleURL(E.URI.revive(h[0]),h[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=D;class n{constructor(P){this.channel=P}handleURL(P,g){return this.channel.call("handleURL",[P.toJSON(),g])}}e.URLHandlerChannelClient=n;class M{constructor(P,g){this.next=P,this.logService=g}async routeCall(P,g,h,y){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(Array.isArray(h)&&h.length>0){const w=E.URI.revive(h[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const S=/\bwindowId=(\d+)/.exec(w.query);if(S){const f=S[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,w.toString(!0));const p=new RegExp(`window:${f}`),v=P.connections.find(o=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",o.ctx),p.test(o.ctx)));if(v)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),v;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(P,g,h,y)}routeEvent(P,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=M}),define(ee[253],te([0,1,8,2,7,20]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends D.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(h,y){const w=[...this.handlers.values()];return(0,E.first)(w.map(S=>()=>S.handleURL(h,y)),void 0,!1).then(S=>S||!1)}registerHandler(h){return this.handlers.add(h),(0,D.toDisposable)(()=>this.handlers.delete(h))}}e.AbstractURLService=k;let P=class extends k{constructor(h){super(),this.productService=h}create(h){let{authority:y,path:w,query:S,fragment:f}=h||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&w&&w.indexOf("/")!==0&&(w=`/${w}`),n.URI.from({scheme:this.productService.urlProtocol,authority:y,path:w,query:S,fragment:f})}};P=we([Z(0,M.IProductService)],P),e.NativeURLService=P}),define(ee[254],te([0,1,15,8,3,2,4,7]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class g{constructor(y,w,S,f,p,v){if(this.urlService=w,this.logService=v,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,y&&(v.trace("ElectronURLListener initialUrisToHandle:",y.map(m=>m.originalUrl)),this.uris=y),k.isWindows){const m=f.isBuilt?[]:[`"${f.appRoot}"`];m.push("--open-url","--"),E.app.setAsDefaultProtocolClient(p.urlProtocol,process.execPath,m)}const o=n.Event.map(n.Event.fromNodeEventEmitter(E.app,"open-url",(m,C)=>({event:m,url:C})),({event:m,url:C})=>(m.preventDefault(),C));this.disposables.add(o(m=>{const C=this.uriFromRawUrl(m);!C||this.urlService.open(C,{originalUrl:m})})),S.getWindows().filter(m=>m.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables))}uriFromRawUrl(y){try{return P.URI.parse(y)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const y=[];for(const w of this.uris)await this.urlService.open(w.uri,{originalUrl:w.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),y.push(w));y.length!==0&&(this.uris=y,this.flushDisposable=(0,D.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=g}),define(ee[255],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ee[256],te([0,1,15,2,14,7]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class k extends D.Disposable{constructor(){super();const g=this.handleWebviewRequest.bind(this);E.protocol.registerFileProtocol(n.Schemas.vscodeWebview,g)}handleWebviewRequest(g,h){try{const y=M.URI.parse(g.url),w=k.validWebviewFilePaths.get(y.path);if(typeof w=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${w}`,f=n.FileAccess.asFileUri(S);return h({path:decodeURIComponent(f.fsPath),headers:{...n.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return h({error:-10})}catch{}return h({error:-2})}}k.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=k}),define(ee[76],te([0,1,4]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(y){return!!y.workspaceUri}e.isWorkspaceToOpen=D;function n(y){return!!y.folderUri}e.isFolderToOpen=n;function M(y){return!!y.fileUri}e.isFileToOpen=M;function k(y){const w=P(y),S=y.getValue("window.menuBarVisibility");return S==="default"||w==="native"&&S==="compact"||E.isMacintosh&&E.isNative?"classic":S}e.getMenuBarVisibility=k;function P(y){if(E.isWeb)return"custom";const w=y.getValue("window");if(w){if(E.isMacintosh&&w.nativeTabs===!0||E.isMacintosh&&w.nativeFullScreen===!1)return"native";const p=w.titleBarStyle;if(p==="native"||p==="custom")return p}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function g(y){if(!E.isWindows||E.isWeb||P(y)==="native")return!1;const w=y.getValue("window.experimental.windowControlsOverlay.enabled");return typeof w=="boolean"?w:!0}e.useWindowControlsOverlay=g;function h(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=h}),define(ee[120],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var D;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));const n=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=n;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M=e.WindowMode||(e.WindowMode={}));var k;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(k=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var D;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(D=e.OpenContext||(e.OpenContext={}))}),define(ee[257],te([0,1,15,22,3,72,2,31,74,110,5,20,30]),function(j,e,E,D,n,M,k,P,g,h,y,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let p=class extends k.Disposable{constructor(o,d,m,C,I){super(),this.logService=o,this.windowsMainService=d,this.credentialsService=m,this.encryptionMainService=C,this.productService=I,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=f.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const o=n.Event.fromNodeEventEmitter(E.app,"login",(d,m,C,I,R)=>({event:d,webContents:m,req:C,authInfo:I,callback:R}));this._register(o(this.onLogin,this))}async onLogin({event:o,authInfo:d,req:m,callback:C}){if(!d.isProxy)return;if(!this.pendingProxyResolve&&this.state===f.LoginDialogShown&&m.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}o.preventDefault();let I;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),I=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(d);try{I=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}C(I?.username,I?.password)}async resolveProxyCredentials(o){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const d=await this.doResolveProxyCredentials(o);if(d)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),d;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(o){this.logService.trace("auth#doResolveProxyCredentials - enter",o);const d=String((0,M.hash)({scheme:o.scheme,host:o.host,port:o.port}));let m,C;try{const a=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,d);if(a){const i=JSON.parse(await this.encryptionMainService.decrypt(a));m=i.username,C=i.password}}catch(a){this.logService.error(a)}if(this.state!==f.StoredCredentialsUsed&&typeof m=="string"&&typeof C=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=f.StoredCredentialsUsed,{username:m,password:C};const I=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!I){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${I.id} to handle proxy login`);const R={authInfo:o,username:this.sessionCredentials?.username??m,password:this.sessionCredentials?.password??C,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};I.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,R),this.state=f.LoginDialogShown;const t=await new Promise(a=>{const i=async(s,l,u)=>{if(l===R.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${I.id}`),I.win?.webContents.off("ipc-message",i),u){const r={username:u.username,password:u.password};try{if(u.remember){const c=await this.encryptionMainService.encrypt(JSON.stringify(r));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,d,c)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,d)}catch(c){this.logService.error(c)}a({username:r.username,password:r.password})}else a(void 0)};I.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=t,t}};p=we([Z(0,y.ILogService),Z(1,S.IWindowsMainService),Z(2,g.ICredentialsMainService),Z(3,h.IEncryptionMainService),Z(4,w.IProductService)],p),e.ProxyAuthHandler=p}),define(ee[258],te([0,1,74,5,33,20,30,209]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let g=class extends P.BaseCredentialsMainService{constructor(y,w,S,f){super(y),this.environmentMainService=w,this.productService=S,this.windowsMainService=f,this.surfaceKeytarLoadError=p=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",p.message??p)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new E.InMemoryCredentialsProvider,this._keytarCache;const y=await new Promise((w,S)=>{j(["keytar"],w,S)});return await y.findCredentials("test-keytar-loads"),this._keytarCache=y,this._keytarCache}};g=we([Z(0,D.ILogService),Z(1,n.INativeEnvironmentService),Z(2,M.IProductService),Z(3,k.IWindowsMainService)],g),e.CredentialsNativeMainService=g}),define(ee[259],te([0,1,15,25,4,7,23,19,62,6,5,119,30]),function(j,e,E,D,n,M,k,P,g,h,y,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,h.createDecorator)(e.ID);let f=class{constructor(v,o,d,m){this.logService=v,this.windowsMainService=o,this.urlService=d,this.configurationService=m}async start(v,o){this.logService.trace("Received data from other instance: ",v,o),n.isMacintosh&&E.app.focus({steal:!0});const d=this.parseOpenUrl(v);if(d.length){let m=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const C=(0,D.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));C&&(m=C.ready())}m.then(()=>{for(const{uri:C,originalUrl:I}of d)this.urlService.open(C,{originalUrl:I})})}else return this.startOpenWindow(v,o)}parseOpenUrl(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,D.coalesce)(v._urls.map(o=>{try{return{uri:M.URI.parse(o),originalUrl:o}}catch{return null}})):[]}async startOpenWindow(v,o){const d=(0,g.isLaunchedFromCli)(o)?0:4;let m=[];const C=v.wait&&v.waitMarkerFilePath?M.URI.file(v.waitMarkerFilePath):void 0,I=v.remote||void 0,R={context:d,cli:v,userEnv:o,waitMarkerFileURI:C,remoteAuthority:I,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,R);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||R.forceProfile||R.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)m=await this.windowsMainService.open({...R,forceNewWindow:!0,forceEmpty:!0});else{const a=this.windowsMainService.getLastActiveWindow();a?(this.windowsMainService.openExistingWindow(a,R),m=[a]):m=await this.windowsMainService.open({...R,forceEmpty:!0})}}else m=await this.windowsMainService.open({...R,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(C&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,k.whenDeleted)(C.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};f=we([Z(0,y.ILogService),Z(1,S.IWindowsMainService),Z(2,w.IURLService),Z(3,P.IConfigurationService)],f),e.LaunchMainService=f}),define(ee[260],te([0,1,15,2,3,5,261,8,14,101,30,83,24]),function(j,e,E,D,n,M,k,P,g,h,y,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let f=class It extends D.Disposable{constructor(v,o,d){super(),this.logService=v,this.windowsMainService=o,this.telemetryService=d,this.id=String(++It.ID_COUNTER),this._onStdout=this._register(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new n.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new n.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0,this.didExit=!1}log(v,o){let d;switch(this.configuration?.correlationId?d=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${v}`:d=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${v}`,o){case w.default.Error:this.logService.error(d);break;case w.default.Warning:this.logService.warn(d);break;case w.default.Info:this.logService.info(d);break}}validateCanStart(v){if(!h.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");if(this.process){this.log("Cannot start utility process because it is already running...",w.default.Error);return}const o=this.windowsMainService.getWindowById(v.responseWindowId)?.win;if(!o||o.isDestroyed()||o.webContents.isDestroyed()){this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",w.default.Error);return}return o}start(v){const o=this.validateCanStart(v);if(!o)return;this.configuration=v;const d=`${this.configuration.type}-${this.id}`,m=g.FileAccess.asFileUri("bootstrap-fork.js").fsPath,C=[...this.configuration.args??[],`--type=${this.configuration.type}`],I=this.configuration.execArgv,R=this.configuration.allowLoadingUnsignedLibraries,t="pipe";let a=this.configuration.env;if(a){a={...a};for(const i of Object.keys(a))a[i]=String(a[i])}this.log("creating new...",w.default.Info),this.process=h.UtilityProcess.fork(m,C,{serviceName:d,env:a,execArgv:I,allowLoadingUnsignedLibraries:R,stdio:t}),this.registerListeners(this.process,this.configuration,d),this.exchangeMessagePorts(this.process,this.configuration,o)}registerListeners(v,o,d){if(v.stdout){const m=new k.StringDecoder("utf-8");this._register(n.Event.fromNodeEventEmitter(v.stdout,"data")(C=>this._onStdout.fire(typeof C=="string"?C:m.write(C))))}if(v.stderr){const m=new k.StringDecoder("utf-8");this._register(n.Event.fromNodeEventEmitter(v.stderr,"data")(C=>this._onStderr.fire(typeof C=="string"?C:m.write(C))))}this._register(n.Event.fromNodeEventEmitter(v,"message")(m=>this._onMessage.fire(m))),this._register(n.Event.fromNodeEventEmitter(v,"spawn")(()=>{this.processPid=v.pid,this.log("successfully created",w.default.Info)})),this._register(n.Event.fromNodeEventEmitter(v,"exit")(m=>{this.log(`received exit event with code ${m}`,w.default.Info),this.didExit=!0,this._onExit.fire({pid:this.processPid,code:m,signal:"unknown"})})),this._register(n.Event.fromNodeEventEmitter(E.app,"child-process-gone",(m,C)=>({event:m,details:C}))(({details:m})=>{m.type==="Utility"&&m.name===d&&(this.log(`crashed with code ${m.exitCode} and reason '${m.reason}'`,w.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:o.type,reason:m.reason,code:m.exitCode}),this._onCrash.fire({pid:this.processPid,code:m.exitCode,reason:m.reason}))}))}exchangeMessagePorts(v,o,d){const{port1:m,port2:C}=new E.MessageChannelMain;v.postMessage("null",[C]),d.webContents.postMessage(o.responseChannel,o.responseNonce,[m])}enableInspectPort(){if(typeof this.processPid!="number")return!1;this.log("enabling inspect port",w.default.Info);const v=process;return typeof v._debugProcess=="function"?(v._debugProcess(this.processPid),!0):!1}kill(){if(!this.process){this.log("no running process to kill",w.default.Warning);return}this.log("attempting to kill the process...",w.default.Info),this.process.kill()?this.log("successfully killed the process",w.default.Info):this.log("unable to kill the process",w.default.Warning)}async waitForExit(v){if(!this.process){this.log("no running process to wait for exit",w.default.Warning);return}this.didExit||(this.log("waiting to exit...",w.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,P.timeout)(v)]),this.didExit||(this.log("did not exit within ${maxWaitTimeMs}ms, will kill it now...",w.default.Info),this.kill()))}};f.ID_COUNTER=0,f=we([Z(0,M.ILogService),Z(1,y.IWindowsMainService),Z(2,S.ITelemetryService)],f),e.UtilityProcess=f}),define(ee[262],te([0,1,13,2,3,5,21,71,46,261,8,14,40,4,36,101,260,30,24]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let C=class Pt{constructor(t,a,i,s){this._logService=t,this._windowsMainService=i,this._telemetryService=s,this._shutdown=!1,this._extHosts=new Map,a.onWillShutdown(l=>{this._shutdown=!0,l.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(t){const a=this._extHosts.get(t);if(!a)throw new Error("Unknown extension host!");return a}onDynamicStdout(t){return this._getExtHost(t).onStdout}onDynamicStderr(t){return this._getExtHost(t).onStderr}onDynamicMessage(t){return this._getExtHost(t).onMessage}onDynamicError(t){const a=this._getExtHost(t);return a instanceof o.UtilityProcess?n.Event.None:a.onError}onDynamicExit(t){return this._getExtHost(t).onExit}async canUseUtilityProcess(){return v.canUseUtilityProcess}async createExtensionHost(t){if(this._shutdown)throw(0,E.canceled)();const a=String(++Pt._lastId);let i;if(t){if(!v.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");i=new o.UtilityProcess(this._logService,this._windowsMainService,this._telemetryService)}else i=new I(a,this._logService);return this._extHosts.set(a,i),i.onExit(({pid:s,code:l,signal:u})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${l}, signal: ${u}.`),setTimeout(()=>{i.dispose(),this._extHosts.delete(a)})}),{id:a}}async start(t,a){if(this._shutdown)throw(0,E.canceled)();return this._getExtHost(t).start({...a,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:a.execArgv??[],allowLoadingUnsignedLibraries:!0,correlationId:t})}async enableInspectPort(t){if(this._shutdown)throw(0,E.canceled)();const a=this._extHosts.get(t);return a?a.enableInspectPort():!1}async kill(t){if(this._shutdown)throw(0,E.canceled)();const a=this._extHosts.get(t);!a||a.kill()}async _killAllNow(){for(const[,t]of this._extHosts)t.kill()}async _waitForAllExit(t){const a=[];for(const[,i]of this._extHosts)a.push(i.waitForExit(t));return y.Promises.settled(a).then(()=>{})}};C._lastId=0,C=we([Z(0,M.ILogService),Z(1,k.ILifecycleMainService),Z(2,d.IWindowsMainService),Z(3,m.ITelemetryService)],C),e.ExtensionHostStarter=C;let I=class extends D.Disposable{constructor(t,a){super(),this.id=t,this._logService=a,this._onStdout=this._register(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this._onExit=this._register(new n.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(t){f.isCI&&this._logService.info("Calling fork to start extension host...");const a=P.StopWatch.create(!1);this._process=(0,g.fork)(w.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,S.mixin)({cwd:(0,p.cwd)()},t));const i=a.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${i} ms).`);const l=new h.StringDecoder("utf-8");this._process.stdout?.on("data",r=>{const c=typeof r=="string"?r:l.write(r);this._onStdout.fire(c)});const u=new h.StringDecoder("utf-8");this._process.stderr?.on("data",r=>{const c=typeof r=="string"?r:u.write(r);this._onStderr.fire(c)}),this._process.on("message",r=>{this._onMessage.fire(r)}),this._process.on("error",r=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(r)})}),this._process.on("exit",(r,c)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:r,signal:c})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):f.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(t){if(!this._process)return;const a=this._process.pid;this._logService.info(`Waiting for extension host with pid ${a} to exit.`),await Promise.race([n.Event.toPromise(this.onExit),(0,y.timeout)(t)]),this._hasExited||(this._logService.info(`Extension host with pid ${a} did not exit within ${t}ms.`),this._process.kill())}};I=we([Z(1,M.ILogService)],I)}),define(ee[263],te([0,1,15,3,2,256,30]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends n.Disposable{constructor(h){super(),this.windowsMainService=h,this._onFoundInFrame=this._register(new D.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(h,y){let w;if(typeof h.windowId=="number"){const{windowId:S}=h,f=this.windowsMainService.getWindowById(S);if(!f?.win)throw new Error(`Invalid windowId: ${S}`);w=f.win.webContents}else{const{webContentsId:S}=h;if(w=E.webContents.fromId(S),!w)throw new Error(`Invalid webContentsId: ${S}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(y)}async findInFrame(h,y,w,S){const p=this.getFrameByName(h,y);if(typeof p.findInFrame=="function"){p.findInFrame(w,{findNext:S.findNext,forward:S.forward});const v=(o,d)=>{d.finalUpdate&&(this._onFoundInFrame.fire(d),p.removeListener("found-in-frame",v))};p.on("found-in-frame",v)}}async stopFindInFrame(h,y,w){const f=this.getFrameByName(h,y);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}getFrameByName(h,y){const w=this.windowsMainService.getWindowById(h.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${h}`);const S=w.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===y);if(!S)throw new Error(`Unknown frame: ${y}`);return S}};P=we([Z(0,k.IWindowsMainService)],P),e.WebviewMainService=P}),define(ee[264],te([0,1,8,3,2]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends n.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:g,getActiveWindowId:h}){super(),this.disposables=this._register(new n.DisposableStore),D.Event.latch(D.Event.any(P,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,E.createCancelablePromise)(()=>h()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(ee[29],te([0,1,181,9,61,18,7,6,14]),function(j,e,E,D,n,M,k,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function h(i){const s=i;return typeof s?.id=="string"&&k.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=h;function y(i){return typeof i?.id=="string"&&!h(i)&&!S(i)}e.isEmptyWorkspaceIdentifier=y,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.basename)(i)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=w;function S(i){const s=i;return typeof s?.id=="string"&&k.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=S;function f(i){const s=i;if(s?.uri)return{id:s.id,uri:k.URI.revive(s.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:k.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=f;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function v(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=v;function o(i){const s=i;return!!(s&&typeof s=="object"&&k.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=o;class d{constructor(s,l,u,r,c){this._id=s,this._transient=u,this._configuration=r,this._ignorePathCasing=c,this._foldersMap=n.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=n.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class m{constructor(s,l){this.raw=l,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,M.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function C(i){return new m({uri:i,index:0,name:(0,M.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=C,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(i,s){return M.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function R(i){let s;return k.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=R;function t(i,s){return!I(i,s)&&!R(i)}e.isSavedWorkspace=t;function a(i){return(typeof i=="string"?(0,D.extname)(i):(0,M.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(ee[58],te([0,1,15,8,72,45,2,79,4,10,23,158,6,5,29]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let v=class{constructor(d){this.logService=d,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(d,m){return this.doPick({...d,pickFolders:!0,pickFiles:!0,title:(0,w.localize)(0,null)},m)}pickFolder(d,m){return this.doPick({...d,pickFolders:!0,title:(0,w.localize)(1,null)},m)}pickFile(d,m){return this.doPick({...d,pickFiles:!0,title:(0,w.localize)(2,null)},m)}pickWorkspace(d,m){const C=(0,w.localize)(3,null),I=(0,M.mnemonicButtonLabel)((0,w.localize)(4,null)),R=p.WORKSPACE_FILTER;return this.doPick({...d,pickFiles:!0,title:C,filters:R,buttonLabel:I},m)}async doPick(d,m){const C={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(C.properties=void 0,d.pickFiles&&d.pickFolders&&(C.properties=["multiSelections","openDirectory","openFile","createDirectory"])),C.properties||(C.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&C.properties.push("treatPackageAsDirectory");const I=await this.showOpenDialog(C,(0,h.withNullAsUndefined)(m||E.BrowserWindow.getFocusedWindow()));if(I&&I.filePaths&&I.filePaths.length>0)return I.filePaths}getWindowDialogQueue(d){if(d){let m=this.windowDialogQueues.get(d.id);return m||(m=new D.Queue,this.windowDialogQueues.set(d.id,m)),m}else return this.noWindowDialogueQueue}showMessageBox(d,m){return this.getWindowDialogQueue(m).queue(async()=>m?E.dialog.showMessageBox(m,d):E.dialog.showMessageBox(d))}async showSaveDialog(d,m){const C=this.acquireFileDialogLock(d,m);if(!C)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(m).queue(async()=>{let I;return m?I=await E.dialog.showSaveDialog(m,d):I=await E.dialog.showSaveDialog(d),I.filePath=this.normalizePath(I.filePath),I})}finally{(0,k.dispose)(C)}}normalizePath(d){return d&&g.isMacintosh&&(d=(0,P.normalizeNFC)(d)),d}normalizePaths(d){return d.map(m=>this.normalizePath(m))}async showOpenDialog(d,m){d.defaultPath&&(await y.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const C=this.acquireFileDialogLock(d,m);if(!C)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(m).queue(async()=>{let I;return m?I=await E.dialog.showOpenDialog(m,d):I=await E.dialog.showOpenDialog(d),I.filePaths=this.normalizePaths(I.filePaths),I})}finally{(0,k.dispose)(C)}}acquireFileDialogLock(d,m){if(!m)return k.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",d);let C=this.windowFileDialogLocks.get(m.id);C||(C=new Set,this.windowFileDialogLocks.set(m.id,C));const I=(0,n.hash)(d);if(!C.has(I))return this.logService.trace("[DialogMainService]: new file dialog lock created",d),C.add(I),(0,k.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",d),C?.delete(I),C?.size===0&&this.windowFileDialogLocks.delete(m.id)})}};v=we([Z(0,f.ILogService)],v),e.DialogMainService=v}),define(ee[265],te([0,1,3,2,84,29]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class k extends D.Disposable{constructor(g,h){super(),this.logService=g,this.storageMainService=h,this.onDidChangeApplicationStorageEmitter=this._register(new E.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(h.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(g,h){this._register(E.Event.debounce(g.onDidChangeStorage,(y,w)=>(y?y.push(w):y=[w],y),k.STORAGE_CHANGE_DEBOUNCE_TIME)(y=>{y.length&&h.fire(this.serializeStorageChangeEvents(y,g))}))}serializeStorageChangeEvents(g,h){const y=new Map,w=new Set;return g.forEach(S=>{const f=h.get(S.key);typeof f=="string"?y.set(S.key,f):w.add(S.key)}),{changed:Array.from(y.entries()),deleted:Array.from(w.values())}}listen(g,h,y){switch(h){case"onDidChangeStorage":{const w=y.profile?(0,n.revive)(y.profile):void 0;if(!w)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(w.id);return S||(S=this._register(new E.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(w),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(w.id,S)),S.event}}throw new Error(`Event not found: ${h}`)}async call(g,h,y){const w=y.profile?(0,n.revive)(y.profile):void 0,S=(0,M.reviveIdentifier)(y.workspace),f=await this.withStorageInitialized(w,S);switch(h){case"getItems":return Array.from(f.items.entries());case"updateItems":{const p=y;if(p.insert)for(const[v,o]of p.insert)f.set(v,o);p.delete?.forEach(v=>f.delete(v));break}case"isUsed":{const p=y.payload;if(typeof p=="string")return this.storageMainService.isUsed(p)}default:throw new Error(`Call not found: ${h}`)}}async withStorageInitialized(g,h){let y;h?y=this.storageMainService.workspaceStorage(h):g?y=this.storageMainService.profileStorage(g):y=this.storageMainService.applicationStorage;try{await y.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${h?"workspace":g?"profile":"application"} storage due to ${w}`)}return y}}k.STORAGE_CHANGE_DEBOUNCE_TIME=100,e.StorageDatabaseChannel=k}),define(ee[39],te([0,1,72,3,2,18,7,178,33,16,6,5,29,35,38,8,31,27,10]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function C(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&k.URI.isUri(s.location)&&k.URI.isUri(s.globalStorageHome)&&k.URI.isUri(s.settingsResource)&&k.URI.isUri(s.keybindingsResource)&&k.URI.isUri(s.tasksResource)&&k.URI.isUri(s.snippetsHome)&&k.URI.isUri(s.extensionsResource))}e.isUserDataProfile=C,e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function I(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:k.URI.revive(i.location).with({scheme:s}),globalStorageHome:k.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:k.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:k.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:k.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:k.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:k.URI.revive(i.extensionsResource)?.with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=I;function R(i,s,l,u){return{id:i,name:s,location:l,isDefault:!1,shortName:u?.shortName,globalStorageHome:(0,M.joinPath)(l,"globalStorage"),settingsResource:(0,M.joinPath)(l,"settings.json"),keybindingsResource:(0,M.joinPath)(l,"keybindings.json"),tasksResource:(0,M.joinPath)(l,"tasks.json"),snippetsHome:(0,M.joinPath)(l,"snippets"),extensionsResource:(0,M.joinPath)(l,"extensions.json"),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}e.toUserDataProfile=R;let t=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(s,l,u,r){super(),this.environmentService=s,this.fileService=l,this.uriIdentityService=u,this.logService=r,this.enabled=!0,this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new D.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new D.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new D.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,M.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}init(){this._profilesObject=void 0}setEnablement(s){this.enabled!==s&&(this._profilesObject=void 0,this.enabled=s)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const s=[];if(this.enabled)for(const c of this.getStoredProfiles()){if(!c.name||!(0,m.isString)(c.name)||!c.location){this.logService.warn("Skipping the invalid stored profile",c.location||c.name);continue}s.push(R((0,M.basename)(c.location),c.name,c.location,{shortName:c.shortName,useDefaultFlags:c.useDefaultFlags}))}const l=new f.ResourceMap,u=new Map,r=this.createDefaultProfile();if(s.unshift({...r,extensionsResource:this.getDefaultProfileExtensionsLocation()??r.extensionsResource,isDefault:!0}),s.length){const c=this.getStoredProfileAssociations();if(c.workspaces)for(const[b,L]of Object.entries(c.workspaces)){const T=k.URI.parse(b),F=s.find(Y=>Y.id===L);F&&l.set(T,F)}if(c.emptyWindows)for(const[b,L]of Object.entries(c.emptyWindows)){const T=s.find(F=>F.id===L);T&&u.set(b,T)}}this._profilesObject={profiles:s,workspaces:l,emptyWindows:u}}return this._profilesObject}createDefaultProfile(){return R("__default__profile__",(0,P.localize)(0,null),this.environmentService.userRoamingDataHome)}async createTransientProfile(s){const l="Temp",u=new RegExp(`${(0,d.escapeRegExpCharacters)(l)}\\s(\\d+)`);let r=0;for(const b of this.profiles){const L=u.exec(b.name),T=L?parseInt(L[1]):0;r=T>r?T:r}const c=`${l} ${r+1}`;return this.createProfile((0,E.hash)((0,o.generateUuid)()).toString(16),c,{transient:!0},s)}async createNamedProfile(s,l,u){return this.createProfile((0,E.hash)((0,o.generateUuid)()).toString(16),s,l,u)}async createProfile(s,l,u,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const c=await this.doCreateProfile(s,l,u);return r&&await this.setProfileForWorkspace(r,c),c}async doCreateProfile(s,l,u){if(!(0,m.isString)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let r=this.profileCreationPromises.get(l);return r||(r=(async()=>{try{const c=this.profiles.find(T=>T.name===l||T.id===s);if(c)return c;const b=R(s,l,(0,M.joinPath)(this.profilesHome,s),u);await this.fileService.createFolder(b.location);const L=[];return this._onWillCreateProfile.fire({profile:b,join(T){L.push(T)}}),await v.Promises.settled(L),this.updateProfiles([b],[],[]),b}finally{this.profileCreationPromises.delete(l)}})(),this.profileCreationPromises.set(l,r)),r}async updateProfile(s,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(r=>r.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=R(u.id,l.name??u.name,u.location,{shortName:l.shortName??u.shortName,transient:l.transient??u.isTransient,useDefaultFlags:l.useDefaultFlags??u.useDefaultFlags}),this.updateProfiles([],[],[u]),u}async removeProfile(s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(r=>r.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:l,join(r){u.push(r)}});try{await Promise.allSettled(u)}catch(r){this.logService.error(r)}for(const r of[...this.profilesObject.emptyWindows.keys()])l.id===this.profilesObject.emptyWindows.get(r)?.id&&this.profilesObject.emptyWindows.delete(r);for(const r of[...this.profilesObject.workspaces.keys()])l.id===this.profilesObject.workspaces.get(r)?.id&&this.profilesObject.workspaces.delete(r);this.updateStoredProfileAssociations(),this.updateProfiles([],[l],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(l.location,{recursive:!0})}catch(r){this.logService.error(r)}}async setProfileForWorkspace(s,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(r=>r.id===l.id);if(!u)throw new Error(`Profile '${l.name}' does not exist`);this.updateWorkspaceAssociation(s,u)}unsetWorkspace(s,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(s,void 0,l)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const s=await this.fileService.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(l=>l.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,l.resource))).map(l=>this.fileService.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const s=this.transientProfilesObject.profiles.filter(l=>!this.isProfileAssociatedToWorkspace(l));await Promise.allSettled(s.map(l=>this.removeProfile(l)))}getProfileForWorkspace(s){const l=this.getWorkspace(s);return k.URI.isUri(l)?this.transientProfilesObject.workspaces.get(l)??this.profilesObject.workspaces.get(l):this.transientProfilesObject.emptyWindows.get(l)??this.profilesObject.emptyWindows.get(l)}getWorkspace(s){return(0,S.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,S.isWorkspaceIdentifier)(s)?s.configPath:s.id}isProfileAssociatedToWorkspace(s){return!!([...this.transientProfilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,s.location))||[...this.transientProfilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,s.location))||[...this.profilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,s.location))||[...this.profilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,s.location)))}updateProfiles(s,l,u){const r=[...this.profiles,...s],c=[];this.transientProfilesObject.profiles=[];for(let b of r)b.isDefault||l.some(L=>b.id===L.id)||(b=u.find(L=>b.id===L.id)??b,b.isTransient?this.transientProfilesObject.profiles.push(b):c.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.saveStoredProfiles(c),this._profilesObject=void 0,this.triggerProfilesChanges(s,l,u)}triggerProfilesChanges(s,l,u){this._onDidChangeProfiles.fire({added:s,removed:l,updated:u,all:this.profiles})}updateWorkspaceAssociation(s,l,u){u=l?.isTransient?!0:u,u||this.updateWorkspaceAssociation(s,void 0,!0);const r=this.getWorkspace(s),c=u?this.transientProfilesObject:this.profilesObject;k.URI.isUri(r)?(c.workspaces.delete(r),l&&c.workspaces.set(r,l)):(c.emptyWindows.delete(r),l&&c.emptyWindows.set(r,l)),u||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const s={};for(const[u,r]of this.profilesObject.workspaces.entries())s[u.toString()]=r.id;const l={};for(const[u,r]of this.profilesObject.emptyWindows.entries())l[u.toString()]=r.id;this.saveStoredProfileAssociations({workspaces:s,emptyWindows:l}),this._profilesObject=void 0}migrateStoredProfileAssociations(s){const l={},u=this.createDefaultProfile();if(s.workspaces)for(const[c,b]of Object.entries(s.workspaces)){const L=k.URI.parse(b);l[c]=this.uriIdentityService.extUri.isEqual(L,u.location)?u.id:this.uriIdentityService.extUri.basename(L)}const r={};if(s.emptyWindows)for(const[c,b]of Object.entries(s.emptyWindows)){const L=k.URI.parse(b);r[c]=this.uriIdentityService.extUri.isEqual(L,u.location)?u.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:l,emptyWindows:r}}getStoredProfiles(){return[]}saveStoredProfiles(s){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(s){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",t=we([Z(0,g.IEnvironmentService),Z(1,h.IFileService),Z(2,p.IUriIdentityService),Z(3,w.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(s){this.storedProfiles=s}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(s){this.storedProfileAssociations=s}}e.InMemoryUserDataProfilesService=a}),define(ee[77],te([0,1,8,17,2,3,35,7,115,91,16,6,5,39,38,10,13,24]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class C extends Error{constructor(i,s){super(i),this.code=s}}e.ExtensionsProfileScanningError=C,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let I=class extends n.Disposable{constructor(i,s,l,u,r,c){super(),this.extensionsLocation=i,this.fileService=s,this.userDataProfilesService=l,this.uriIdentityService=u,this.telemetryService=r,this.logService=c,this._onAddExtensions=this._register(new M.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new M.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new M.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new M.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(i,s){return this.withProfileExtensions(i,void 0,s)}async addExtensionsToProfile(i,s){const l=[],u=[];try{return await this.withProfileExtensions(s,r=>{const c=[];for(const b of r)i.some(([L])=>(0,g.areSameExtensions)(L.identifier,b.identifier)&&L.manifest.version!==b.version)?l.push(b):c.push(b);for(const[b,L]of i)if(!c.some(T=>(0,g.areSameExtensions)(T.identifier,b.identifier)&&T.version===b.manifest.version)){const T={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:L};u.push(T),c.push(T)}return u.length&&this._onAddExtensions.fire({extensions:u,profileLocation:s}),l.length&&this._onRemoveExtensions.fire({extensions:l,profileLocation:s}),c}),u.length&&this._onDidAddExtensions.fire({extensions:u,profileLocation:s}),l.length&&this._onDidRemoveExtensions.fire({extensions:l,profileLocation:s}),u}catch(r){throw u.length&&this._onDidAddExtensions.fire({extensions:u,error:r,profileLocation:s}),l.length&&this._onDidRemoveExtensions.fire({extensions:l,error:r,profileLocation:s}),r}}async updateMetadata(i,s){const l=[];return await this.withProfileExtensions(s,u=>{const r=[];for(const c of u){const b=i.find(([L])=>(0,g.areSameExtensions)(L.identifier,c.identifier)&&L.manifest.version===c.version);b&&(c.metadata={...c.metadata,...b[1]},l.push(c)),r.push(c)}return r}),l}async removeExtensionFromProfile(i,s){const l=[];this._onRemoveExtensions.fire({extensions:l,profileLocation:s});try{await this.withProfileExtensions(s,u=>{const r=[];for(const c of u)(0,g.areSameExtensions)(c.identifier,i.identifier)?l.push(c):r.push(c);return l.length&&this._onRemoveExtensions.fire({extensions:l,profileLocation:s}),r}),l.length&&this._onDidRemoveExtensions.fire({extensions:l,profileLocation:s})}catch(u){throw l.length&&this._onDidRemoveExtensions.fire({extensions:l,error:u,profileLocation:s}),u}}async withProfileExtensions(i,s,l){return this.getResourceAccessQueue(i).queue(async()=>{let u=[],r;try{const c=await this.fileService.readFile(i);r=JSON.parse(c.value.toString())}catch(c){if((0,y.toFileOperationResult)(c)!==1)throw c;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(r=await this.migrateFromOldDefaultProfileExtensionsLocation()),!r&&l?.bailOutWhenFileNotFound)throw new C((0,o.getErrorMessage)(c),"ERROR_PROFILE_NOT_FOUND")}if(r){Array.isArray(r)||this.reportAndThrowInvalidConentError(i);let c=!1;for(const b of r){R(b)||this.reportAndThrowInvalidConentError(i);let L;if((0,v.isString)(b.relativeLocation))L=this.resolveExtensionLocation(b.relativeLocation);else if((0,v.isString)(b.location))L=this.resolveExtensionLocation(b.location),c=!0,b.relativeLocation=b.location,b.location=L.toJSON();else{L=P.URI.revive(b.location);const T=this.toRelativePath(L);T&&(c=!0,b.relativeLocation=T)}u.push({identifier:b.identifier,location:L,version:b.version,metadata:b.metadata})}c&&await this.fileService.writeFile(i,D.VSBuffer.fromString(JSON.stringify(r)))}if(s){u=s(u);const c=u.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.toRelativePath(b.location),metadata:b.metadata}));await this.fileService.writeFile(i,D.VSBuffer.fromString(JSON.stringify(c)))}return u})}reportAndThrowInvalidConentError(i){const s=new C(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}toRelativePath(i){return this.uriIdentityService.extUri.isEqualOrParent(i,this.extensionsLocation)?this.uriIdentityService.extUri.relativePath(this.extensionsLocation,i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json");let s;try{s=(await this.fileService.readFile(i)).value.toString()}catch(u){if((0,y.toFileOperationResult)(u)===1)return;throw u}this.logService.info("Migrating extensions from old default profile location",i.toString());let l;try{const u=JSON.parse(s);Array.isArray(u)&&u.every(r=>R(r))?l=u:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.logService.error(u)}if(l)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(u){if((0,y.toFileOperationResult)(u)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw u}try{await this.fileService.del(i)}catch(u){(0,y.toFileOperationResult)(u)!==1&&this.logService.error(u)}return l})()),this._migrationPromise}getResourceAccessQueue(i){let s=this.resourcesAccessQueueMap.get(i);return s||(s=new E.Queue,this.resourcesAccessQueueMap.set(i,s)),s}};I=we([Z(1,y.IFileService),Z(2,f.IUserDataProfilesService),Z(3,p.IUriIdentityService),Z(4,d.ITelemetryService),Z(5,S.ILogService)],I),e.AbstractExtensionsProfileScannerService=I;function R(a){return(0,v.isObject)(a)&&(0,h.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,v.isString)(a.location))&&((0,v.isUndefined)(a.relativeLocation)||(0,v.isString)(a.relativeLocation))&&a.version&&(0,v.isString)(a.version)}function t(a){return a?(0,v.isString)(a.path)&&(0,v.isString)(a.scheme):!1}}),define(ee[121],te([0,1,25,8,40,17,13,43,143,2,14,9,4,18,195,83,10,7,163,33,115,91,194,16,6,5,20,3,84,77,39,38,192,193]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t,a,i,s,l,u,r,c,b,L,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Y;(function(ge){function x(B,O){if(B===O)return!0;const z=Object.keys(B),K=new Set;for(const ne of Object.keys(O))K.add(ne);if(z.length!==K.size)return!1;for(const ne of z){if(B[ne]!==O[ne])return!1;K.delete(ne)}return K.size===0}ge.equals=x})(Y=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let V=class extends h.Disposable{constructor(x,B,O,z,K,ne,se,J,W,A,_,N){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=B,this.extensionsControlLocation=O,this.cacheLocation=z,this.userDataProfilesService=K,this.extensionsProfileScannerService=ne,this.fileService=se,this.logService=J,this.environmentService=W,this.productService=A,this.uriIdentityService=_,this.instantiationService=N,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,(0,f.joinPath)(this.cacheLocation,R.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,(0,f.joinPath)(this.cacheLocation,R.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ie,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,I.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(x,B,O){const[z,K]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(B)]),ne=O?await this.scanExtensionsUnderDevelopment(x,[...z,...K]):[];return this.dedupExtensions(z,K,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const B=[];B.push(this.scanDefaultSystemExtensions(!!x.useCache,x.language)),B.push(this.scanDevSystemExtensions(x.language,!!x.checkControlFile));const[O,z]=await Promise.all(B);return this.applyScanOptions([...O,...z],0,x,!1)}async scanUserExtensions(x){const B=x.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",B);const O=this.uriIdentityService.extUri.isEqual(x.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.createExtensionScannerInput(B,!!x.profileLocation,1,!x.includeUninstalled,x.language,!0,O),K=x.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ne;try{ne=await K.scanExtensions(z)}catch(se){if(se instanceof c.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ne=await K.scanExtensions(z);else throw se}return ne=await this.applyScanOptions(ne,1,x,!0),this.logService.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(x,B){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const O=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===y.Schemas.file).map(async z=>{const K=await this.createExtensionScannerInput(z,!1,1,!0,x.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(K)).map(se=>(se.type=B.find(J=>(0,I.areSameExtensions)(J.identifier,se.identifier))?.type??se.type,this.extensionsScanner.validate(se,K)))}))).flat();return this.applyScanOptions(O,"development",x,!0)}return[]}async scanExistingExtension(x,B,O){const z=await this.createExtensionScannerInput(x,!1,B,!0,O.language,!0,void 0),K=await this.extensionsScanner.scanExtension(z);return!K||!O.includeInvalid&&!K.isValid?null:K}async scanOneOrMultipleExtensions(x,B,O){const z=await this.createExtensionScannerInput(x,!1,B,!0,O.language,!0,void 0),K=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions(K,B,O,!0)}async scanMetadata(x){const B=(0,f.joinPath)(x,"package.json"),O=(await this.fileService.readFile(B)).value.toString();return JSON.parse(O).__metadata}async updateMetadata(x,B){const O=(0,f.joinPath)(x,"package.json"),z=(await this.fileService.readFile(O)).value.toString(),K=JSON.parse(z);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.installedTimestamp=B.installedTimestamp||void 0,K.__metadata={...K.__metadata,...B},await this.fileService.writeFile((0,f.joinPath)(x,"package.json"),M.VSBuffer.fromString(JSON.stringify(K,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof c.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw x}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.extensionsProfileScannerService.addExtensionsToProfile(x.map(B=>[B,B.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify([])))}catch(B){(0,a.toFileOperationResult)(B)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(B))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.logService.error(x)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(x,B,O,z){return O.includeAllVersions||(x=this.dedupExtensions(B===0?x:void 0,B===1?x:void 0,B==="development"?x:void 0,await this.getTargetPlatform(),z)),O.includeInvalid||(x=x.filter(K=>K.isValid)),x.sort((K,ne)=>{const se=w.basename(K.location.fsPath),J=w.basename(ne.location.fsPath);return se<J?-1:se>J?1:0})}dedupExtensions(x,B,O,z,K){const ne=(J,W,A)=>{if(J.isValid&&!W.isValid)return!1;if(J.isValid===W.isValid){if(K&&p.gt(J.manifest.version,W.manifest.version))return this.logService.debug(`Skipping extension ${W.location.path} with lower version ${W.manifest.version} in favour of ${J.location.path} with version ${J.manifest.version}`),!1;if(p.eq(J.manifest.version,W.manifest.version)){if(J.type===0)return this.logService.debug(`Skipping extension ${W.location.path} in favour of system extension ${J.location.path} with same version`),!1;if(J.targetPlatform===z)return this.logService.debug(`Skipping extension ${W.location.path} from different target platform ${W.targetPlatform}`),!1}}return A?this.logService.warn(`Overwriting user extension ${J.location.path} with ${W.location.path}.`):this.logService.debug(`Overwriting user extension ${J.location.path} with ${W.location.path}.`),!0},se=new Map;return x?.forEach(J=>{const W=R.ExtensionIdentifier.toKey(J.identifier.id),A=se.get(W);(!A||ne(A,J,!1))&&se.set(W,J)}),B?.forEach(J=>{const W=R.ExtensionIdentifier.toKey(J.identifier.id),A=se.get(W);if(!A&&x&&J.type===0){this.logService.debug(`Skipping obsolete system extension ${J.location.path}.`);return}(!A||ne(A,J,!1))&&se.set(W,J)}),O?.forEach(J=>{const W=R.ExtensionIdentifier.toKey(J.identifier.id),A=se.get(W);(!A||ne(A,J,!0))&&se.set(W,J),se.set(W,J)}),[...se.values()]}async scanDefaultSystemExtensions(x,B){this.logService.trace("Started scanning system extensions");const O=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,B,!0,void 0),K=await(x&&!O.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(O);return this.logService.trace("Scanned system extensions:",K.length),K}async scanDevSystemExtensions(x,B){const O=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!O?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=B?await this.getBuiltInExtensionControl():{},K=[],ne=d.URI.file(w.normalize(w.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const J of O){const W=z[J.name]||"marketplace";switch(W){case"disabled":break;case"marketplace":K.push((0,f.joinPath)(ne,J.name));break;default:K.push(d.URI.file(W));break}}const se=await Promise.all(K.map(async J=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(J,!1,0,!0,x,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",se.length),(0,E.coalesce)(se)}async getBuiltInExtensionControl(){try{const x=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(x.value.toString())}catch{return{}}}async createExtensionScannerInput(x,B,O,z,K,ne,se){const J=await this.getTranslations(K??S.language),W=await this.getMtime(x),A=B&&!this.uriIdentityService.extUri.isEqual(x,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,_=A?await this.getMtime(A):void 0;return new G(x,W,A,_,B,se,O,z,ne,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,K,J)}async getMtime(x){try{const B=await this.fileService.stat(x);if(typeof B.mtime=="number")return B.mtime}catch{}}};V=we([Z(4,b.IUserDataProfilesService),Z(5,c.IExtensionsProfileScannerService),Z(6,a.IFileService),Z(7,s.ILogService),Z(8,C.IEnvironmentService),Z(9,l.IProductService),Z(10,L.IUriIdentityService),Z(11,i.IInstantiationService)],V),e.AbstractExtensionsScannerService=V;class G{constructor(x,B,O,z,K,ne,se,J,W,A,_,N,q,U,$){this.location=x,this.mtime=B,this.applicationExtensionslocation=O,this.applicationExtensionslocationMtime=z,this.profile=K,this.profileScanOptions=ne,this.type=se,this.excludeObsolete=J,this.validate=W,this.productVersion=A,this.productDate=_,this.productCommit=N,this.devMode=q,this.language=U,this.translations=$}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,B){return(0,f.isEqual)(x.location,B.location)&&x.mtime===B.mtime&&(0,f.isEqual)(x.applicationExtensionslocation,B.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&x.profile===B.profile&&n.equals(x.profileScanOptions,B.profileScanOptions)&&x.type===B.type&&x.excludeObsolete===B.excludeObsolete&&x.validate===B.validate&&x.productVersion===B.productVersion&&x.productDate===B.productDate&&x.productCommit===B.productCommit&&x.devMode===B.devMode&&x.language===B.language&&Y.equals(x.translations,B.translations)}}e.ExtensionScannerInput=G;let ie=class extends h.Disposable{constructor(x,B,O,z,K){super(),this.obsoleteFile=x,this.extensionsProfileScannerService=B,this.uriIdentityService=O,this.fileService=z,this.logService=K}async scanExtensions(x){const B=x.profile?await this.scanExtensionsFromProfile(x):await this.scanExtensionsFromLocation(x);let O={};if(x.excludeObsolete&&x.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();O=JSON.parse(z)}catch{}return(0,o.isEmptyObject)(O)?B:B.filter(z=>!O[I.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(x){const B=await this.fileService.resolve(x.location);if(!B.children?.length)return[];const O=await Promise.all(B.children.map(async z=>{if(!z.isDirectory||x.type===1&&(0,f.basename)(z.resource).indexOf(".")===0)return null;const K=new G(z.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(K)}));return(0,E.coalesce)(O).sort((z,K)=>z.location.path<K.location.path?-1:1)}async scanExtensionsFromProfile(x){let B=await this.scanExtensionsFromProfileResource(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(x.location,x.applicationExtensionslocation)){B=B.filter(z=>!z.metadata?.isApplicationScoped);const O=await this.scanExtensionsFromProfileResource(x.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,x);B.push(...O)}return B}async scanExtensionsFromProfileResource(x,B,O){const z=await this.extensionsProfileScannerService.scanProfileExtensions(x,O.profileScanOptions);if(!z.length)return[];const K=await Promise.all(z.map(async ne=>{if(B(ne)){const se=new G(ne.location,O.mtime,O.applicationExtensionslocation,O.applicationExtensionslocationMtime,O.profile,O.profileScanOptions,O.type,O.excludeObsolete,O.validate,O.productVersion,O.productDate,O.productCommit,O.devMode,O.language,O.translations);return this.scanExtension(se,ne.metadata)}return null}));return(0,E.coalesce)(K)}async scanOneOrMultipleExtensions(x){try{if(await this.fileService.exists((0,f.joinPath)(x.location,"package.json"))){const B=await this.scanExtension(x);return B?[B]:[]}else return await this.scanExtensions(x)}catch(B){return this.logService.error(`Error scanning extensions at ${x.location.path}:`,(0,k.getErrorMessage)(B)),[]}}async scanExtension(x,B){try{let O=await this.scanExtensionManifest(x.location);if(O){O.publisher||(O.publisher=R.UNDEFINED_PUBLISHER),B=B??O.__metadata,delete O.__metadata;const z=(0,I.getGalleryExtensionId)(O.publisher,O.name),K=B?.id?{id:z,uuid:B.id}:{id:z},ne=B?.isSystem?0:x.type,se=ne===0||!!B?.isBuiltin;F.ImplicitActivationEvents.updateManifest(O),O=await this.translateManifest(x.location,O,G.createNlsConfiguration(x));const J={type:ne,identifier:K,manifest:O,location:x.location,isBuiltin:se,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return x.validate?this.validate(J,x):J}}catch(O){x.type!==0&&this.logService.error(O)}return null}validate(x,B){let O=!0;const z=(0,t.validateExtensionManifest)(B.productVersion,B.productDate,B.location,x.manifest,x.isBuiltin);for(const[K,ne]of z)K===v.default.Error&&(O=!1,this.logService.error(this.formatMessage(B.location,ne)));return x.isValid=O,x.validations=z,x}async scanExtensionManifest(x){const B=(0,f.joinPath)(x,"package.json");let O;try{O=(await this.fileService.readFile(B)).value.toString()}catch(K){return(0,a.toFileOperationResult)(K)!==1&&this.logService.error(this.formatMessage(x,(0,m.localize)(0,null,B.path,K.message))),null}let z;try{z=JSON.parse(O)}catch{const ne=[];(0,P.parse)(O,ne);for(const se of ne)this.logService.error(this.formatMessage(x,(0,m.localize)(1,null,B.path,se.offset,se.length,(0,g.getParseErrorMessage)(se.error))));return null}return(0,P.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(x,(0,m.localize)(2,null,B.path))),null):z}async translateManifest(x,B,O){const z=await this.getLocalizedMessages(x,B,O);if(z)try{const K=[],ne=await this.resolveOriginalMessageBundle(z.default,K);if(K.length>0)return K.forEach(J=>{this.logService.error(this.formatMessage(x,(0,m.localize)(3,null,z.default?.path,(0,g.getParseErrorMessage)(J.error))))}),B;if((0,P.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(x,(0,m.localize)(4,null,z.default?.path))),B;const se=z.values||Object.create(null);return(0,T.localizeManifest)(B,se,ne)}catch{}return B}async getLocalizedMessages(x,B,O){const z=(0,f.joinPath)(x,"package.nls.json"),K=(W,A)=>{A.forEach(_=>{this.logService.error(this.formatMessage(x,(0,m.localize)(5,null,W?.path,(0,g.getParseErrorMessage)(_.error))))})},ne=W=>{this.logService.error(this.formatMessage(x,(0,m.localize)(6,null,W?.path)))},se=`${B.publisher}.${B.name}`,J=O.translations[se];if(J)try{const W=d.URI.file(J),A=(await this.fileService.readFile(W)).value.toString(),_=[],N=(0,P.parse)(A,_);return _.length>0?(K(W,_),{values:void 0,default:z}):(0,P.getNodeType)(N)!=="object"?(ne(W),{values:void 0,default:z}):{values:N.contents?N.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let A;try{A=await this.findMessageBundles(x,O)}catch{return}if(!A.localized)return{values:void 0,default:A.original};try{const _=(await this.fileService.readFile(A.localized)).value.toString(),N=[],q=(0,P.parse)(_,N);return N.length>0?(K(A.localized,N),{values:void 0,default:A.original}):(0,P.getNodeType)(q)!=="object"?(ne(A.localized),{values:void 0,default:A.original}):{values:q,default:A.original}}catch{return{values:void 0,default:A.original}}}}async resolveOriginalMessageBundle(x,B){if(x)try{const O=(await this.fileService.readFile(x)).value.toString();return(0,P.parse)(O,B)}catch{}}findMessageBundles(x,B){return new Promise((O,z)=>{const K=ne=>{const se=(0,f.joinPath)(x,`package.nls.${ne}.json`);this.fileService.exists(se).then(J=>{J&&O({localized:se,original:(0,f.joinPath)(x,"package.nls.json")});const W=ne.lastIndexOf("-");W===-1?O({localized:(0,f.joinPath)(x,"package.nls.json"),original:null}):(ne=ne.substring(0,W),K(ne))})};if(B.devMode||B.pseudo||!B.language)return O({localized:(0,f.joinPath)(x,"package.nls.json"),original:null});K(B.language)})}formatMessage(x,B){return`[${x.path}]: ${B}`}};ie=we([Z(1,c.IExtensionsProfileScannerService),Z(2,L.IUriIdentityService),Z(3,a.IFileService),Z(4,s.ILogService)],ie);let re=class extends ie{constructor(x,B,O,z,K,ne){super(B,O,z,K,ne),this.cacheFile=x,this.cacheValidatorThrottler=this._register(new D.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(x){const B=await this.readExtensionCache();if(this.input=x,B&&B.input&&G.equals(B.input,this.input))return this.logService.debug("Using cached extensions scan result",x.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),B.result.map(z=>(z.location=d.URI.revive(z.location),z));const O=await super.scanExtensions(x);return await this.writeExtensionCache({input:x,result:O}),O}async readExtensionCache(){try{const x=await this.fileService.readFile(this.cacheFile),B=JSON.parse(x.value.toString());return{result:B.result,input:(0,r.revive)(B.input)}}catch(x){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(x))}return null}async writeExtensionCache(x){try{await this.fileService.writeFile(this.cacheFile,M.VSBuffer.fromString(JSON.stringify(x)))}catch(B){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(B))}}async validateCache(){if(!this.input)return;const x=await this.readExtensionCache();if(!x)return;const B=x.result,O=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!n.equals(O,B))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}};re=we([Z(2,c.IExtensionsProfileScannerService),Z(3,L.IUriIdentityService),Z(4,a.IFileService),Z(5,s.ILogService)],re);function de(ge,x){const B=(0,I.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:B,identifier:new R.ExtensionIdentifier(B),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:x,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=de;class ce extends V{constructor(x,B,O,z,K,ne,se,J,W,A,_,N){super(x,B,(0,f.joinPath)(O,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(z,R.MANIFEST_CACHE_FOLDER),K,ne,se,J,W,A,_,N),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const q=await this.fileService.readFile(d.URI.file(S.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}getTranslations(x){return this.translationsPromise}}e.NativeExtensionsScannerService=ce}),define(ee[266],te([0,1,5,39,38,24,77,16,33,7]),function(j,e,E,D,n,M,k,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let y=class extends k.AbstractExtensionsProfileScannerService{constructor(S,f,p,v,o,d){super(h.URI.file(S.extensionsPath),f,p,v,o,d)}};y=we([Z(0,g.INativeEnvironmentService),Z(1,P.IFileService),Z(2,D.IUserDataProfilesService),Z(3,n.IUriIdentityService),Z(4,M.ITelemetryService),Z(5,E.ILogService)],y),e.ExtensionsProfileScannerService=y}),define(ee[267],te([0,1,7,33,77,121,16,6,5,20,38,39]),function(j,e,E,D,n,M,k,P,g,h,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends M.NativeExtensionsScannerService{constructor(p,v,o,d,m,C,I,R){super(E.URI.file(m.builtinExtensionsPath),E.URI.file(m.extensionsPath),m.userHome,E.URI.file(m.userDataPath),p,v,o,d,m,C,I,R)}};S=we([Z(0,w.IUserDataProfilesService),Z(1,n.IExtensionsProfileScannerService),Z(2,k.IFileService),Z(3,g.ILogService),Z(4,D.INativeEnvironmentService),Z(5,h.IProductService),Z(6,y.IUriIdentityService),Z(7,P.IInstantiationService)],S),e.ExtensionsScannerService=S}),define(ee[268],te([0,1,15,2,14,9,4,61,7,31,42,33,5,39]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let p=class extends D.Disposable{constructor(o,d,m){super(),this.environmentService=o,this.logService=m,this.validRoots=P.TernarySearchTree.forPaths(!k.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(o.appRoot),this.addValidFileRoot(o.extensionsPath),this.addValidFileRoot(d.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(o.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:o}=E.session;o.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(d,m)=>this.handleResourceRequest(d,m)),o.protocol.interceptFileProtocol(n.Schemas.file,(d,m)=>this.handleFileRequest(d,m)),this._register((0,D.toDisposable)(()=>{o.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),o.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(o){const d=(0,M.normalize)(o);return this.validRoots.get(d)?D.Disposable.None:(this.validRoots.set(d,!0),(0,D.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(o,d){const m=g.URI.parse(o.url);return this.logService.error(`Refused to load resource ${m.fsPath} from ${n.Schemas.file}: protocol (original URL: ${o.url})`),d({error:-3})}handleResourceRequest(o,d){const m=this.requestToNormalizedFilePath(o);let C;return this.environmentService.crossOriginIsolated&&((0,M.basename)(m)==="workbench.html"||(0,M.basename)(m)==="workbench-dev.html"?C=n.COI.CoopAndCoep:C=n.COI.getHeadersFromQuery(o.url)),this.validRoots.findSubstr(m)?d({path:m,headers:C}):this.validExtensions.has((0,M.extname)(m).toLowerCase())?d({path:m}):(this.logService.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${o.url})`),d({error:-3}))}requestToNormalizedFilePath(o){const d=g.URI.parse(o.url),m=n.FileAccess.uriToFileUri(d);return(0,M.normalize)(m.fsPath)}createIPCObjectUrl(){let o;const d=g.URI.from({scheme:"vscode",path:(0,h.generateUuid)()}),m=d.toString(),C=async()=>o;return y.validatedIpcMain.handle(m,C),this.logService.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:d,update:I=>o=I,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${m}.`),y.validatedIpcMain.removeHandler(m)}}}};p=we([Z(0,w.INativeEnvironmentService),Z(1,f.IUserDataProfilesService),Z(2,S.ILogService)],p),e.ProtocolMainService=p}),define(ee[269],te([0,1,15,42,8,3,2,14,10,106,28,21,5,66,67,69,44,39,37,65]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let I=class extends k.Disposable{constructor(t,a,i,s,l,u,r,c,b,L){super(),this.machineId=t,this.userEnv=a,this.environmentMainService=i,this.userDataProfilesService=s,this.lifecycleMainService=l,this.logService=u,this.loggerMainService=r,this.policyService=c,this.themeMainService=b,this.protocolMainService=L,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new M.Emitter),this.onDidError=M.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){D.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(t,a)=>this.onWindowConnection(t,a)),D.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(t,a)=>this.onWorkerConnection(t,a)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(t,a){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const i=await this.connect();if(t.sender.isDestroyed())return i.close();t.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[i])}onWorkerConnection(t,a){this.logService.trace("SharedProcess: onWorkerConnection",a);const i=new k.DisposableStore,s=u=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${u}')`,a),i.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",a))},l=E.BrowserWindow.fromId(a.reply.windowId);if(!l||l.isDestroyed()||l.webContents.isDestroyed()||!a.reply.channel){s("unavailable");return}i.add(M.Event.filter(this.lifecycleMainService.onWillLoadWindow,u=>u.window.win===l)(()=>s("load"))),i.add(M.Event.fromNodeEventEmitter(l,"closed")(()=>s("closed"))),l.webContents.postMessage(a.reply.channel,a.reply.nonce,t.ports)}onWillShutdown(){const t=this.window;!t||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(t.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{t.close()}catch{}this.window=void 0},0))}send(t,...a){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${t}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(t,...a)}catch(i){this.logService.warn(`Error sending IPC message to channel '${t}' of shared process: ${(0,o.toErrorMessage)(i)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(t=>D.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),t()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(t=>D.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),t()}))})()),this._whenIpcReady}createWindow(){const t=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new E.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),t.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),product:f.default,policiesData:this.policyService.serialize()}),this.window.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=t=>{this.logService.trace("SharedProcess#close prevented"),t.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(t,a)=>this._onDidError.fire({type:2,details:a})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(t,a,i)=>this._onDidError.fire({type:3,details:{reason:i,exitCode:a}})))}async connect(){await this.whenIpcReady;const t=(0,g.assertIsDefined)(this.window);return(0,h.connect)(t)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const t=this.window;return t?!t.isDestroyed()&&!t.webContents.isDestroyed():!1}};I=we([Z(2,y.IEnvironmentMainService),Z(3,d.IUserDataProfilesService),Z(4,w.ILifecycleMainService),Z(5,S.ILogService),Z(6,C.ILoggerMainService),Z(7,m.IPolicyService),Z(8,v.IThemeMainService),Z(9,p.IProtocolMainService)],I),e.SharedProcess=I}),define(ee[95],te([0,1,8,3,2,64,10,107,6,39]),function(j,e,E,D,n,M,k,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var y;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var S;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function f(m){const C=m.get(e.TARGET_KEY);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}e.loadKeyTargets=f;class p extends n.Disposable{constructor(C={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super(),this.options=C,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new E.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new n.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,E.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,n.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,M.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(C,I){if(I===e.TARGET_KEY){switch(C){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:C})}else this._onDidChangeValue.fire({scope:C,key:I,target:this.getKeyTargets(C)[I]})}emitWillSaveState(C){this._onWillSaveState.fire({reason:C})}get(C,I,R){return this.getStorage(I)?.get(C,R)}getBoolean(C,I,R){return this.getStorage(I)?.getBoolean(C,R)}getNumber(C,I,R){return this.getStorage(I)?.getNumber(C,R)}store(C,I,R,t){if((0,k.isUndefinedOrNull)(I)){this.remove(C,R);return}this.withPausedEmitters(()=>{this.updateKeyTarget(C,R,t),this.getStorage(R)?.set(C,I)})}remove(C,I){this.withPausedEmitters(()=>{this.updateKeyTarget(C,I,void 0),this.getStorage(I)?.delete(C)})}withPausedEmitters(C){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{C()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(C,I){const R=[],t=this.getKeyTargets(C);for(const a of Object.keys(t))t[a]===I&&R.push(a);return R}updateKeyTarget(C,I,R){const t=this.getKeyTargets(I);typeof R=="number"?t[C]!==R&&(t[C]=R,this.getStorage(I)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[C]=="number"&&(delete t[C],this.getStorage(I)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(C){switch(C){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(C){const I=this.getStorage(C);return I?f(I):Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(C=y.NONE){this._onWillSaveState.fire({reason:C});const I=this.getStorage(-1),R=this.getStorage(0),t=this.getStorage(1);switch(C){case y.NONE:await E.Promises.settled([I?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await E.Promises.settled([I?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const C=this.getStorage(-1)?.items??new Map,I=this.getStorage(0)?.items??new Map,R=this.getStorage(1)?.items??new Map;return d(C,I,R,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(C,I){return this.emitWillSaveState(y.NONE),(0,h.isUserDataProfile)(C)?this.switchToProfile(C,I):this.switchToWorkspace(C,I)}canSwitchProfile(C,I){return!(C.id===I.id||v(I)&&v(C))}switchData(C,I,R,t){this.withPausedEmitters(()=>{if(t)for(const[a,i]of C)I.set(a,i);else{const a=new Set;for(const[i,s]of C)a.add(i),I.get(i)!==s&&this.emitDidChangeValue(R,i);for(const[i]of I.items)a.has(i)||this.emitDidChangeValue(R,i)}})}}p.DEFAULT_FLUSH_INTERVAL=60*1e3,e.AbstractStorageService=p;function v(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class o extends p{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(C=>this.emitDidChangeValue(1,C))),this._register(this.profileStorage.onDidChangeStorage(C=>this.emitDidChangeValue(0,C))),this._register(this.applicationStorage.onDidChangeStorage(C=>this.emitDidChangeValue(-1,C)))}getStorage(C){switch(C){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(C){return!1}}e.InMemoryStorageService=o;async function d(m,C,I,R,t,a){const i=F=>{try{return JSON.parse(F)}catch{return F}},s=new Map,l=new Map;m.forEach((F,Y)=>{s.set(Y,F),l.set(Y,i(F))});const u=new Map,r=new Map;C.forEach((F,Y)=>{u.set(Y,F),r.set(Y,i(F))});const c=new Map,b=new Map;I.forEach((F,Y)=>{c.set(Y,F),b.set(Y,i(F))}),console.group(R!==t?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const L=[];if(s.forEach((F,Y)=>{L.push({key:Y,value:F})}),console.table(L),console.groupEnd(),console.log(l),R!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const F=[];u.forEach((Y,V)=>{F.push({key:V,value:Y})}),console.table(F),console.groupEnd(),console.log(r)}console.group(`Storage: Workspace (path: ${a})`);const T=[];c.forEach((F,Y)=>{T.push({key:Y,value:F})}),console.table(T),console.groupEnd(),console.log(b)}e.logStorage=d}),define(ee[270],te([0,1,25,8,3,2,9,71,7,23,107,154,5,95,24,29]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class o extends M.Disposable{get storage(){return this._storage}constructor(a,i){super(),this.logService=a,this.fileService=i,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY}),this.initializePromise=void 0,this.whenInitPromise=new D.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=y.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===y.StorageState.None)try{const a=await this.doCreate();this._storage.dispose(),this._storage=a,this._register(a.onDidChangeStorage(s=>this._onDidChangeStorage.fire({key:s}))),await this.doInit(a);const i=a.getBoolean(f.IS_NEW_KEY);i===void 0?a.set(f.IS_NEW_KEY,!0):i&&a.set(f.IS_NEW_KEY,!1)}catch(a){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.state=y.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this._storage.items}get(a,i){return this._storage.get(a,i)}set(a,i){return this._storage.set(a,i)}delete(a){return this._storage.delete(a)}async close(){const a=new P.StopWatch(!1);await this.doClose(),a.stop(),a.elapsed()>o.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(a),this._onDidCloseStorage.fire()}async logSlowClose(a){if(!!this.path)try{const i=(0,E.top)(Array.from(this._storage.items.entries()).map(([l,u])=>({key:l,length:u.length})),(l,u)=>u.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),s=(await this.fileService.stat(g.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=y.StorageState.Closed,await this._storage.close()}}o.LOG_SLOW_CLOSE_THRESHOLD=2e3;class d extends o{get path(){if(!this.options.useInMemoryStorage)return(0,k.join)(this.profile.globalStorageHome.fsPath,d.STORAGE_NAME)}constructor(a,i,s,l){super(s,l),this.profile=a,this.options=i}async doCreate(){return new y.Storage(new w.SQLiteStorageDatabase(this.path??w.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}d.STORAGE_NAME="state.vscdb";class m extends d{constructor(a,i,s,l){super(a,i,s,l)}}e.ProfileStorageMain=m;class C extends d{constructor(a,i,s,l){super(i.defaultProfile,a,s,l)}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(p.firstSessionDateStorageKey,void 0)===void 0&&a.set(p.firstSessionDateStorageKey,new Date().toUTCString());const s=a.get(p.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();a.set(p.lastSessionDateStorageKey,typeof s>"u"?null:s),a.set(p.currentSessionDateStorageKey,l)}}e.ApplicationStorageMain=C;class I extends o{get path(){if(!this.options.useInMemoryStorage)return(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,I.WORKSPACE_STORAGE_NAME)}constructor(a,i,s,l,u){super(s,u),this.workspace=a,this.options=i,this.environmentService=l}async doCreate(){const{storageFilePath:a,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new y.Storage(new w.SQLiteStorageDatabase(a,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:i?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:w.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,k.join)(a,I.WORKSPACE_STORAGE_NAME);return await h.Promises.exists(a)?{storageFilePath:i,wasCreated:!1}:(await h.Promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let i;if((0,v.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const s=(0,k.join)(a,I.WORKSPACE_META_NAME);await h.Promises.exists(s)||await h.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}I.WORKSPACE_STORAGE_NAME="state.vscdb",I.WORKSPACE_META_NAME="workspace.json",e.WorkspaceStorageMain=I;class R extends o{get path(){}async doCreate(){return new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=R}),define(ee[271],te([0,1,3,2,95]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class M extends D.Disposable{constructor(P,g,h){super(),this.storageMainService=P,this.userDataProfilesService=g,this.logService=h;const y=this._register(new D.MutableDisposable);this._onDidChange=this._register(new E.Emitter({onWillAddFirstListener:()=>y.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>y.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new D.DisposableStore;return P.add(E.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(g,h)=>(g?g.push(h.key):g=[h.key],g),100)(g=>this.onDidChangeApplicationStorage(g))),P.add(E.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(g,h)=>{g||(g=new Map);let y=g.get(h.profile.id);return y||g.set(h.profile.id,y={profile:h.profile,keys:[],storage:h.storage}),y.keys.push(h.key),g},100)(g=>this.onDidChangeProfileStorage(g))),P}onDidChangeApplicationStorage(P){const g=P.includes(n.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],h=[];if(P=P.filter(y=>y!==n.TARGET_KEY),P.length){const y=(0,n.loadKeyTargets)(this.storageMainService.applicationStorage.storage);h.push({profile:this.userDataProfilesService.defaultProfile,changes:P.map(w=>({key:w,scope:0,target:y[w]}))})}this.triggerEvents(g,h)}onDidChangeProfileStorage(P){const g=[],h=new Map;for(const[y,w]of P.entries()){w.keys.includes(n.TARGET_KEY)&&g.push(w.profile);const S=w.keys.filter(f=>f!==n.TARGET_KEY);if(S.length){const f=(0,n.loadKeyTargets)(w.storage.storage);h.set(y,{profile:w.profile,changes:S.map(p=>({key:p,scope:0,target:f[p]}))})}}this.triggerEvents(g,[...h.values()])}triggerEvents(P,g){(P.length||g.length)&&this._onDidChange.fire({valueChanges:g,targetChanges:P})}listen(P,g,h){switch(g){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${g}`)}async call(P,g){throw new Error(`Call not found: ${g}`)}}e.ProfileStorageChangesListenerChannel=M}),define(ee[272],te([0,1,10,7,33,16,5,237,38,39]),function(j,e,E,D,n,M,k,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let y=class extends h.UserDataProfilesService{constructor(f,p,v,o){super(p,v,f,o),this.nativeEnvironmentService=p}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(D.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=we([Z(0,g.IUriIdentityService),Z(1,n.INativeEnvironmentService),Z(2,M.IFileService),Z(3,k.ILogService)],y),e.ServerUserDataProfilesService=y;let w=class gt extends y{constructor(f,p,v,o,d){super(p,v,o,d),this.stateService=f}getStoredProfiles(){return this.stateService.getItem(gt.PROFILES_KEY,[]).map(p=>({...p,location:(0,E.isString)(p.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,p.location):D.URI.revive(p.location)}))}getStoredProfileAssociations(){const f=this.stateService.getItem(gt.PROFILE_ASSOCIATIONS_KEY,{});return this.stateService.getItem(gt.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?f:this.migrateStoredProfileAssociations(f)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(D.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};w.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",w=we([Z(0,P.IStateService),Z(1,g.IUriIdentityService),Z(2,n.INativeEnvironmentService),Z(3,M.IFileService),Z(4,k.ILogService)],w),e.UserDataProfilesService=w}),define(ee[53],te([0,1,7,33,16,6,5,34,38,39,272]),function(j,e,E,D,n,M,k,P,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,M.refineServiceDecorator)(h.IUserDataProfilesService);let w=class at extends y.UserDataProfilesService{constructor(f,p,v,o,d){super(f,p,v,o,d),this.stateMainService=f}getAssociatedEmptyWindows(){const f=[];for(const p of this.profilesObject.emptyWindows.keys())f.push({id:p});return f}saveStoredProfiles(f){f.length?this.stateMainService.setItem(at.PROFILES_KEY,f.map(p=>({...p,location:this.uriIdentityService.extUri.basename(p.location)}))):this.stateMainService.removeItem(at.PROFILES_KEY)}getStoredProfiles(){const f=super.getStoredProfiles();return this.stateMainService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(f),this.stateMainService.setItem("userDataProfilesMigration",!0)),f}saveStoredProfileAssociations(f){f.emptyWindows||f.workspaces?this.stateMainService.setItem(at.PROFILE_ASSOCIATIONS_KEY,f):this.stateMainService.removeItem(at.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const f="workspaceAndProfileInfo",p=this.stateMainService.getItem(f,void 0);if(p){this.stateMainService.removeItem(f);const o=p.reduce((d,{workspace:m,profile:C})=>(d[E.URI.revive(m).toString()]=E.URI.revive(C).toString(),d),{});this.stateMainService.setItem(at.PROFILE_ASSOCIATIONS_KEY,{workspaces:o})}const v=super.getStoredProfileAssociations();return this.stateMainService.getItem(y.UserDataProfilesService.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(v),this.stateMainService.setItem(y.UserDataProfilesService.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),v}};w=we([Z(0,P.IStateMainService),Z(1,g.IUriIdentityService),Z(2,D.INativeEnvironmentService),Z(3,n.IFileService),Z(4,k.ILogService)],w),e.UserDataProfilesMainService=w}),define(ee[96],te([0,1,7,50,3,2,33,16,6,21,5,95,270,39,53,38]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,g.createDecorator)("storageMainService");let o=class extends M.Disposable{constructor(C,I,R,t,a,i){super(),this.logService=C,this.environmentService=I,this.userDataProfilesService=R,this.lifecycleMainService=t,this.fileService=a,this.uriIdentityService=i,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new n.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(C=>{C.window.profile&&this.profileStorage(C.window.profile).init(),C.workspace&&this.workspaceStorage(C.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(C=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=C.reason,C.join(this.applicationStorage.close());for(const[,I]of this.mapProfileToStorage)C.join(I.close());for(const[,I]of this.mapWorkspaceToStorage)C.join(I.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(C=>{C.join((async()=>{await this.fileService.exists(C.profile.globalStorageHome)||await this.fileService.createFolder(C.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(C=>{const I=this.mapProfileToStorage.get(C.profile.id);I&&C.join(I.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const C=new S.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,D.once)(C.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),C}profileStorage(C){if((0,w.isProfileUsingDefaultStorage)(C))return this.applicationStorage;let I=this.mapProfileToStorage.get(C.id);if(!I){this.logService.trace(`StorageMainService: creating profile storage (${C.name})`),I=this.createProfileStorage(C),this.mapProfileToStorage.set(C.id,I);const R=this._register(I.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:I,profile:C})));(0,D.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${C.name})`),this.mapProfileToStorage.delete(C.id),R.dispose()})}return I}createProfileStorage(C){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.ProfileStorageMain(C,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(C){let I=this.mapWorkspaceToStorage.get(C.id);return I||(this.logService.trace(`StorageMainService: creating workspace storage (${C.id})`),I=this.createWorkspaceStorage(C),this.mapWorkspaceToStorage.set(C.id,I),(0,D.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${C.id})`),this.mapWorkspaceToStorage.delete(C.id)})),I}createWorkspaceStorage(C){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.WorkspaceStorageMain(C,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(C){const I=E.URI.file(C);for(const R of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!R.path&&this.uriIdentityService.extUri.isEqualOrParent(E.URI.file(R.path),I))return!0;return!1}};o=we([Z(0,y.ILogService),Z(1,k.IEnvironmentService),Z(2,p.IUserDataProfilesMainService),Z(3,h.ILifecycleMainService),Z(4,P.IFileService),Z(5,v.IUriIdentityService)],o),e.StorageMainService=o,e.IApplicationStorageMainService=(0,g.createDecorator)("applicationStorageMainService");let d=class extends w.AbstractStorageService{constructor(C,I){super(),this.userDataProfilesService=C,this.storageMainService=I,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(C){if(C===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(C){if(C===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};d=we([Z(0,f.IUserDataProfilesService),Z(1,e.IStorageMainService)],d),e.ApplicationStorageMainService=d}),define(ee[273],te([0,1,2,21,53,29,8,30]),function(j,e,E,D,n,M,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let g=class extends E.Disposable{constructor(y,w,S){super(),this.userDataProfilesService=w,this.windowsMainService=S,this._register(y.onWillLoadWindow(f=>{f.reason===2&&this.unsetProfileForWorkspace(f.window)})),this._register(y.onBeforeCloseWindow(f=>this.unsetProfileForWorkspace(f))),this._register(new k.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(y){const w=this.getWorkspace(y),S=this.userDataProfilesService.getProfileForWorkspace(w);S?.isTransient&&(this.userDataProfilesService.unsetWorkspace(w,S.isTransient),S.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(y){return y.openedWorkspace??(0,M.toWorkspaceIdentifier)(y.backupPath,y.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const y=this.userDataProfilesService.getAssociatedEmptyWindows();if(y.length===0)return;const w=this.windowsMainService.getWindows().map(S=>this.getWorkspace(S));for(const S of y)w.some(f=>f.id===S.id)||this.userDataProfilesService.unsetWorkspace(S,!1)}};g=we([Z(0,D.ILifecycleMainService),Z(1,n.IUserDataProfilesMainService),Z(2,P.IWindowsMainService)],g),e.UserDataProfilesHandler=g}),define(ee[122],te([0,1,18,7,29]),function(j,e,E,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function M(g,h,y){for(const S of g){const f=S.openedWorkspace;if((0,n.isWorkspaceIdentifier)(f)){const p=await y(f);if(p){if(p.folders.some(v=>E.extUriBiasedIgnorePathCase.isEqualOrParent(h,v.uri)))return S}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(h,f.configPath))return S}}const w=g.filter(S=>(0,n.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(h,S.openedWorkspace.uri));if(w.length)return w.sort((S,f)=>-(S.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function k(g,h){for(const y of g)if((0,n.isWorkspaceIdentifier)(y.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,h)||(0,n.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,h))return y}e.findWindowOnWorkspaceOrFolder=k;function P(g,h){const y=w=>h.some(S=>E.extUriBiasedIgnorePathCase.isEqual(D.URI.file(S),D.URI.file(w)));for(const w of g)if(w.config?.extensionDevelopmentPath?.some(S=>y(S)))return w}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[274],te([0,1,15,2,4,18,7,19,21,5,34,30,120,29]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class vt extends D.Disposable{get state(){return this._state}constructor(I,R,t,a,i){super(),this.windowsMainService=I,this.stateMainService=R,this.lifecycleMainService=t,this.logService=a,this.configurationService=i,this._state=v(this.stateMainService.getItem(vt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){E.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(I=>this.onBeforeCloseWindow(I)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(I=>{I.newCount-I.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(I=>this.onBeforeCloseWindow(I))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const I=new Set,R={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!R.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(R.lastActiveWindow=this.toWindowState(i),R.lastActiveWindow.uiState.mode===3&&I.add(R.lastActiveWindow.uiState.display))}const t=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(R.lastPluginDevelopmentHostWindow=this.toWindowState(t),R.lastPluginDevelopmentHostWindow.uiState.mode===3&&(I.has(R.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!t.win?.isSimpleFullScreen()&&(R.lastPluginDevelopmentHostWindow.uiState.mode=1):I.add(R.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(R.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.toWindowState(i);return s.uiState.mode===3&&(I.has(s.uiState.display)?n.isMacintosh&&s.windowId!==R.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):I.add(s.uiState.display)),s}));const a=d(R);this.stateMainService.setItem(vt.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(I){if(this.lifecycleMainService.quitRequested)return;const R=this.toWindowState(I);I.isExtensionDevelopmentHost&&!I.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=R:!I.isExtensionDevelopmentHost&&I.openedWorkspace&&this._state.openedWindows.forEach(t=>{const a=(0,f.isWorkspaceIdentifier)(I.openedWorkspace)&&t.workspace?.id===I.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&t.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(t.folderUri,I.openedWorkspace.uri);(a||i)&&(t.uiState=R.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=R)}toWindowState(I){return{windowId:I.id,workspace:(0,f.isWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace.uri:void 0,backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.serializeWindowState()}}getNewWindowState(I){const R=this.doGetNewWindowState(I),t=this.configurationService.getValue("window");if(R.mode===3){let a;R.hasDefaultState?a=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):a=!!(this.lifecycleMainService.wasRestarted||t?.restoreFullscreen),a||(R.mode=1)}return R}doGetNewWindowState(I){const R=this.windowsMainService.getLastActiveWindow();if(!I.extensionTestsPath){if(!!I.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=I.workspace;if((0,f.isWorkspaceIdentifier)(u)){const c=this.state.openedWindows.filter(b=>b.workspace&&b.workspace.id===u.id).map(b=>b.uiState);if(c.length)return c[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(u)){const c=this.state.openedWindows.filter(b=>b.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(b.folderUri,u.uri)).map(b=>b.uiState);if(c.length)return c[0]}else if(I.backupPath){const c=this.state.openedWindows.filter(b=>b.backupPath===I.backupPath).map(b=>b.uiState);if(c.length)return c[0]}const r=this.lastClosedState||this.state.lastActiveWindow;if(!R&&r)return r.uiState}let t;const a=E.screen.getAllDisplays();if(a.length===1)t=a[0];else{if(n.isMacintosh){const u=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(u)}!t&&R&&(t=E.screen.getDisplayMatching(R.getBounds())),t||(t=E.screen.getPrimaryDisplay()||a[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const s=this.configurationService.getValue("window");let l=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,l=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,l=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&R){const u=R.serializeWindowState();u.mode===3?i.mode=3:i=u,l=i.mode!==3&&s.newWindowDimensions==="offset"}}return l&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(I){if(this.windowsMainService.getWindows().length===0)return I;I.x=typeof I.x=="number"?I.x:0,I.y=typeof I.y=="number"?I.y:0;const R=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;R.some(t=>t.x===I.x||t.y===I.y);)I.x+=30,I.y+=30;return I}};p.windowsStateStorageKey="windowsState",p=we([Z(0,w.IWindowsMainService),Z(1,y.IStateMainService),Z(2,g.ILifecycleMainService),Z(3,h.ILogService),Z(4,P.IConfigurationService)],p),e.WindowsStateHandler=p;function v(C){const I={openedWindows:[]},R=C||{openedWindows:[]};return R.lastActiveWindow&&(I.lastActiveWindow=o(R.lastActiveWindow)),R.lastPluginDevelopmentHostWindow&&(I.lastPluginDevelopmentHostWindow=o(R.lastPluginDevelopmentHostWindow)),Array.isArray(R.openedWindows)&&(I.openedWindows=R.openedWindows.map(t=>o(t))),I}e.restoreWindowsState=v;function o(C){const I={uiState:C.uiState};return C.backupPath&&(I.backupPath=C.backupPath),C.remoteAuthority&&(I.remoteAuthority=C.remoteAuthority),C.folder&&(I.folderUri=k.URI.parse(C.folder)),C.workspaceIdentifier&&(I.workspace={id:C.workspaceIdentifier.id,configPath:k.URI.parse(C.workspaceIdentifier.configURIPath)}),I}function d(C){return{lastActiveWindow:C.lastActiveWindow&&m(C.lastActiveWindow),lastPluginDevelopmentHostWindow:C.lastPluginDevelopmentHostWindow&&m(C.lastPluginDevelopmentHostWindow),openedWindows:C.openedWindows.map(I=>m(I))}}e.getWindowsStateStoreData=d;function m(C){return{workspaceIdentifier:C.workspace&&{id:C.workspace.id,configURIPath:C.workspace.configPath.toString()},folder:C.folderUri&&C.folderUri.toString(),backupPath:C.backupPath,remoteAuthority:C.remoteAuthority,uiState:C.uiState}}}),define(ee[97],te([0,1,32,43,127,45,14,9,4,18,7,6,56,29]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function p(b){return b.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function v(b){return b.hasOwnProperty("folderUri")}e.isRecentFolder=v;function o(b){return b.hasOwnProperty("fileUri")}e.isRecentFile=o;function d(b){return m(b)||C(b)}e.isStoredWorkspaceFolder=d;function m(b){const L=b;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function C(b){const L=b;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function I(b,L,T,F,Y){if(b.scheme!==F.scheme)return{name:T,uri:b.toString(!0)};let V=L?void 0:Y.relativePath(F,b);if(V!==void 0)V.length===0?V=".":g.isWindows&&(V=R(V));else if(b.scheme===k.Schemas.file)V=b.fsPath,g.isWindows&&(V=R(V));else if(Y.isEqualAuthority(b.authority,F.authority))V=b.path;else return{name:T,uri:b.toString(!0)};return{name:T,path:V}}e.getStoredWorkspaceFolder=I;function R(b){return b=(0,M.normalizeDriveLetter)(b),(0,E.isUNC)(b)||(b=(0,E.toSlashes)(b)),b}function t(b,L,T){const F=[],Y=new Set,V=T.dirname(L);for(const G of b){let ie;if(m(G))G.path&&(ie=T.resolvePath(V,G.path));else if(C(G))try{ie=y.URI.parse(G.uri),ie.path[0]!==P.posix.sep&&(ie=ie.with({path:P.posix.sep+ie.path}))}catch(re){console.warn(re)}if(ie){const re=T.getComparisonKey(ie);if(!Y.has(re)){Y.add(re);const de=G.name||T.basenameOrAuthority(ie);F.push(new f.WorkspaceFolder({uri:ie,name:de,index:F.length},G))}}}return F}e.toWorkspaceFolders=t;function a(b,L,T,F,Y){const V=i(L,b),G=Y.dirname(L),ie=Y.dirname(F),re=[];for(const x of V.folders){const B=m(x)?Y.resolvePath(G,x.path):y.URI.parse(x.uri);let O;T?O=!1:O=!m(x)||(0,P.isAbsolute)(x.path),re.push(I(B,O,x.name,ie,Y))}const de={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},ce=n.setProperty(b,["folders"],re,de);let ge=n.applyEdits(b,ce);return(0,h.isEqualAuthority)(V.remoteAuthority,(0,S.getRemoteAuthority)(F))&&(ge=n.applyEdits(ge,n.removeProperty(ge,["remoteAuthority"],de))),ge}e.rewriteWorkspaceFileForNewLocation=a;function i(b,L){const T=D.parse(L);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(F=>d(F));else throw new Error(`${b} looks like an invalid workspace file.`);return T}function s(b){return b.workspace&&typeof b.workspace=="object"&&typeof b.workspace.id=="string"&&typeof b.workspace.configPath=="string"}function l(b){return typeof b.folderUri=="string"}function u(b){return typeof b.fileUri=="string"}function r(b,L){const T={workspaces:[],files:[]};if(b){const F=function(V,G){for(let ie=0;ie<V.length;ie++)try{G(V[ie],ie)}catch(re){L.warn(`Error restoring recent entry ${JSON.stringify(V[ie])}: ${re.toString()}. Skip entry.`)}},Y=b;Array.isArray(Y.entries)&&F(Y.entries,V=>{const G=V.label,ie=V.remoteAuthority;s(V)?T.workspaces.push({label:G,remoteAuthority:ie,workspace:{id:V.workspace.id,configPath:y.URI.parse(V.workspace.configPath)}}):l(V)?T.workspaces.push({label:G,remoteAuthority:ie,folderUri:y.URI.parse(V.folderUri)}):u(V)&&T.files.push({label:G,remoteAuthority:ie,fileUri:y.URI.parse(V.fileUri)})})}return T}e.restoreRecentlyOpened=r;function c(b){const L={entries:[]};for(const T of b.workspaces)v(T)?L.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):L.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of b.files)L.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return L}e.toStoreData=c}),define(ee[98],te([0,1,80,14,4,18]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function k(h){function y(){let w=h.scheme===D.Schemas.file?(0,M.originalFSPath)(h):h.toString();return n.isLinux||(w=w.toLowerCase()),(0,E.createHash)("md5").update(w).digest("hex")}return{id:y(),configPath:h}}e.getWorkspaceIdentifier=k;function P(h,y){function w(){if(h.scheme!==D.Schemas.file)return(0,E.createHash)("md5").update(h.toString()).digest("hex");if(!y)return;let f;return n.isLinux?f=y.ino:n.isMacintosh?f=y.birthtime.getTime():n.isWindows&&(typeof y.birthtimeMs=="number"?f=Math.floor(y.birthtimeMs):f=y.birthtime.getTime()),(0,E.createHash)("md5").update(h.fsPath).update(f?String(f):"").digest("hex")}const S=w();if(typeof S=="string")return{id:S,uri:h}}e.getSingleFolderWorkspaceIdentifier=P;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=g}),define(ee[275],te([0,1,80,32,14,9,4,18,23,185,19,28,34,16,5,184,29,98]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let m=class wt{constructor(I,R,t,a){this.environmentMainService=I,this.configurationService=R,this.logService=t,this.stateMainService=a,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,s)=>(0,D.isEqual)(i,s,!k.isLinux)}}async initialize(){const I=this.stateMainService.getItem(wt.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(I.emptyWindows),this.workspaces=await this.validateWorkspaces((0,h.deserializeWorkspaceInfos)(I)),this.folders=await this.validateFolders((0,h.deserializeFolderInfos)(I)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==f.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(I,R){this.workspaces.some(a=>I.workspace.id===a.workspace.id)||(this.workspaces.push(I),this.storeWorkspacesMetadata());const t=(0,M.join)(this.backupHome,I.workspace.id);return R?this.moveBackupFolder(t,R).then(()=>t):t}async moveBackupFolder(I,R){if(await g.Promises.exists(I)&&await this.convertToEmptyWindowBackup(I),await g.Promises.exists(R))try{await g.Promises.rename(R,I)}catch(t){this.logService.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(I){return this.folders.some(R=>this.backupUriComparer.isEqual(I.folderUri,R.folderUri))||(this.folders.push(I),this.storeWorkspacesMetadata()),(0,M.join)(this.backupHome,this.getFolderHash(I))}registerEmptyWindowBackup(I){return this.emptyWindows.some(R=>!!R.backupFolder&&this.backupPathComparer.isEqual(R.backupFolder,I.backupFolder))||(this.emptyWindows.push(I),this.storeWorkspacesMetadata()),(0,M.join)(this.backupHome,I.backupFolder)}async validateWorkspaces(I){if(!Array.isArray(I))return[];const R=new Set,t=[];for(const a of I){const i=a.workspace;if(!(0,o.isWorkspaceIdentifier)(i))return[];if(!R.has(i.id)){R.add(i.id);const s=(0,M.join)(this.backupHome,i.id);await this.doHasBackups(s)?i.configPath.scheme!==n.Schemas.file||await g.Promises.exists(i.configPath.fsPath)?t.push(a):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return t}async validateFolders(I){if(!Array.isArray(I))return[];const R=[],t=new Set;for(const a of I){const i=a.folderUri,s=this.backupUriComparer.getComparisonKey(i);if(!t.has(s)){t.add(s);const l=(0,M.join)(this.backupHome,this.getFolderHash(a));await this.doHasBackups(l)?i.scheme!==n.Schemas.file||await g.Promises.exists(i.fsPath)?R.push(a):await this.convertToEmptyWindowBackup(l):await this.deleteStaleBackup(l)}}return R}async validateEmptyWorkspaces(I){if(!Array.isArray(I))return[];const R=[],t=new Set;for(const a of I){const i=a.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const s=(0,M.join)(this.backupHome,i);await this.doHasBackups(s)?R.push(a):await this.deleteStaleBackup(s)}}return R}async deleteStaleBackup(I){try{await g.Promises.rm(I,g.RimRafMode.MOVE)}catch(R){this.logService.error(`Backup: Could not delete stale backup: ${R.toString()}`)}}prepareNewEmptyWindowBackup(){let I=(0,d.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(R=>!!R.backupFolder&&this.backupPathComparer.isEqual(R.backupFolder,I.id));)I=(0,d.createEmptyWorkspaceIdentifier)();return{backupFolder:I.id}}async convertToEmptyWindowBackup(I){const R=this.prepareNewEmptyWindowBackup(),t=(0,M.join)(this.backupHome,R.backupFolder);try{await g.Promises.rename(I,t)}catch(a){return this.logService.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.emptyWindows.push(R),!0}async getDirtyWorkspaces(){const I=[];for(const R of this.workspaces)await this.hasBackups(R)&&I.push(R);for(const R of this.folders)await this.hasBackups(R)&&I.push(R);return I}hasBackups(I){let R;return(0,h.isEmptyWindowBackupInfo)(I)?R=(0,M.join)(this.backupHome,I.backupFolder):(0,v.isFolderBackupInfo)(I)?R=(0,M.join)(this.backupHome,this.getFolderHash(I)):R=(0,M.join)(this.backupHome,I.workspace.id),this.doHasBackups(R)}async doHasBackups(I){try{const R=await g.Promises.readdir(I);for(const t of R)try{if((await g.Promises.readdir((0,M.join)(I,t))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const I={workspaces:this.workspaces.map(({workspace:R,remoteAuthority:t})=>{const a={id:R.id,configURIPath:R.configPath.toString()};return t&&(a.remoteAuthority=t),a}),folders:this.folders.map(({folderUri:R,remoteAuthority:t})=>{const a={folderUri:R.toString()};return t&&(a.remoteAuthority=t),a}),emptyWindows:this.emptyWindows.map(({backupFolder:R,remoteAuthority:t})=>{const a={backupFolder:R};return t&&(a.remoteAuthority=t),a})};this.stateMainService.setItem(wt.backupWorkspacesMetadataStorageKey,I)}getFolderHash(I){const R=I.folderUri;let t;return R.scheme===n.Schemas.file?t=k.isLinux?R.fsPath:R.fsPath.toLowerCase():t=R.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};m.backupWorkspacesMetadataStorageKey="backupWorkspaces",m=we([Z(0,w.IEnvironmentMainService),Z(1,y.IConfigurationService),Z(2,p.ILogService),Z(3,S.IStateMainService)],m),e.BackupMainService=m}),define(ee[54],te([0,1,15,3,43,2,14,9,18,10,23,183,63,48,58,28,6,5,20,53,122,29,97,98]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,o.createDecorator)("workspacesManagementMainService");let i=class extends M.Disposable{constructor(l,u,r,c,b,L){super(),this.environmentMainService=l,this.logService=u,this.userDataProfilesMainService=r,this.backupMainService=c,this.dialogMainService=b,this.productService=L,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const l=(await y.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(u=>(0,g.joinPath)(this.untitledWorkspacesHome,u,R.UNTITLED_WORKSPACE_NAME));for(const u of l){const r=(0,a.getWorkspaceIdentifier)(u),c=await this.resolveLocalWorkspace(u);c?this.untitledWorkspaces.push({workspace:r,remoteAuthority:c.remoteAuthority}):await this.deleteUntitledWorkspace(r)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,u=>y.Promises.readFile(u,"utf8"))}doResolveLocalWorkspace(l,u){if(!!this.isWorkspacePath(l)&&l.scheme===k.Schemas.file)try{const r=u(l.fsPath);return r instanceof Promise?r.then(c=>this.doResolveWorkspace(l,c),c=>{}):this.doResolveWorkspace(l,r)}catch{return}}isWorkspacePath(l){return(0,R.isUntitledWorkspace)(l,this.environmentMainService)||(0,R.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,u){try{const r=this.doParseStoredWorkspace(l,u),c=(0,a.getWorkspaceIdentifier)(l);return{id:c.id,configPath:c.configPath,folders:(0,t.toWorkspaceFolders)(r.folders,c.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:r.remoteAuthority,transient:r.transient}}catch(r){this.logService.warn(r.toString())}}doParseStoredWorkspace(l,u){const r=(0,n.parse)(u);if(r&&Array.isArray(r.folders))r.folders=r.folders.filter(c=>(0,t.isStoredWorkspaceFolder)(c));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return r}async createUntitledWorkspace(l,u){const{workspace:r,storedWorkspace:c}=this.newUntitledWorkspace(l,u),b=r.configPath.fsPath;return await y.Promises.mkdir((0,P.dirname)(b),{recursive:!0}),await y.Promises.writeFile(b,JSON.stringify(c,null,"	")),this.untitledWorkspaces.push({workspace:r,remoteAuthority:u}),r}newUntitledWorkspace(l=[],u){const r=(Date.now()+Math.round(Math.random()*1e3)).toString(),c=(0,g.joinPath)(this.untitledWorkspacesHome,r),b=(0,g.joinPath)(c,R.UNTITLED_WORKSPACE_NAME),L=[];for(const T of l)L.push((0,t.getStoredWorkspaceFolder)(T.uri,!0,T.name,c,g.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(b),storedWorkspace:{folders:L,remoteAuthority:u}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,R.isUntitledWorkspace)(l.configPath,this.environmentMainService)}async deleteUntitledWorkspace(l){!this.isUntitledWorkspace(l)||(await this.doDeleteUntitledWorkspace(l),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(l),this._onDidDeleteUntitledWorkspace.fire(l))}async doDeleteUntitledWorkspace(l){const u=(0,g.originalFSPath)(l.configPath);try{await y.Promises.rm((0,P.dirname)(u));const r=(0,P.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);await y.Promises.exists(r)&&await y.Promises.writeFile((0,P.join)(r,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(c=>c.workspace.id!==l.id)}catch(r){this.logService.warn(`Unable to delete untitled workspace ${u} (${r}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(l,u,r){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,u,r))return;const b=await this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(r));if(!!b)return this._onDidEnterWorkspace.fire({window:l,workspace:b.workspace}),b}async isValidTargetWorkspacePath(l,u,r){return r?(0,R.isWorkspaceIdentifier)(l.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,r)?!1:(0,I.findWindowOnWorkspaceOrFolder)(u,r)?(await this.dialogMainService.showMessageBox((0,f.massageMessageBoxOptions)({type:"info",buttons:[(0,w.localize)(0,null)],message:(0,w.localize)(1,null,(0,g.basename)(r)),detail:(0,w.localize)(2,null)},this.productService).options,(0,h.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async doEnterWorkspace(l,u){if(!l.config)return;l.focus();let r;return l.config.extensionDevelopmentPath||(l.config.backupPath?r=await this.backupMainService.registerWorkspaceBackup({workspace:u,remoteAuthority:l.remoteAuthority},l.config.backupPath):r=this.backupMainService.registerWorkspaceBackup({workspace:u,remoteAuthority:l.remoteAuthority})),(0,R.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&await this.deleteUntitledWorkspace(l.openedWorkspace),l.config.workspace=u,l.config.backupPath=r,{workspace:u,backupPath:r}}};i=we([Z(0,v.IEnvironmentMainService),Z(1,d.ILogService),Z(2,C.IUserDataProfilesMainService),Z(3,S.IBackupMainService),Z(4,p.IDialogMainService),Z(5,m.IProductService)],i),e.WorkspacesManagementMainService=i}),define(ee[123],te([0,1,15,42,22,6,30,29,54,10,5]),function(j,e,E,D,n,M,k,P,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,M.createDecorator)(e.ID);let w=class{constructor(f,p,v){this.windowsMainService=f,this.workspacesManagementMainService=p,this.logService=v}async getRemoteDiagnostics(f){const p=this.windowsMainService.getWindows();return(await Promise.all(p.map(async o=>{const d=o.remoteAuthority;if(!d)return;const m=`vscode:getDiagnosticInfoResponse${o.id}`,C={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.getFolderURIs(o):void 0};return new Promise(I=>{o.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:m,args:C}),D.validatedIpcMain.once(m,(R,t)=>{t||I({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),I(t)}),setTimeout(()=>{I({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter(o=>!!o)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const f=[];for(const p of E.BrowserWindow.getAllWindows()){const v=this.windowsMainService.getWindowById(p.id);v?f.push(await this.codeWindowToInfo(v)):f.push(this.browserWindowToInfo(p))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async codeWindowToInfo(f){const p=await this.getFolderURIs(f),v=(0,h.assertIsDefined)(f.win);return this.browserWindowToInfo(v,p,f.remoteAuthority)}browserWindowToInfo(f,p=[],v){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:p,remoteAuthority:v}}async getFolderURIs(f){const p=[],v=f.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(v))p.push(v.uri);else if((0,P.isWorkspaceIdentifier)(v)){const o=await this.workspacesManagementMainService.resolveLocalWorkspace(v.configPath);o&&o.folders.forEach(m=>{p.push(m.uri)})}return p}};w=we([Z(0,k.IWindowsMainService),Z(1,g.IWorkspacesManagementMainService),Z(2,y.ILogService)],w),e.DiagnosticsMainService=w}),define(ee[59],te([0,1,46,15,26,148,55,3,2,14,9,4,7,103,85,23,100,173,48,58,28,6,21,5,20,69,30,29,54,17,231,224,34]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t,a,i,s,l,u,r,c,b,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,R.createDecorator)("nativeHostMainService");let F=class extends g.Disposable{constructor(V,G,ie,re,de,ce,ge,x,B,O){super(),this.sharedProcess=V,this.windowsMainService=G,this.dialogMainService=ie,this.lifecycleMainService=re,this.environmentMainService=de,this.logService=ce,this.productService=ge,this.themeMainService=x,this.stateMainService=B,this.workspacesManagementMainService=O,this.onDidOpenWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:z,x:K,y:ne})=>({windowId:z.id,x:K,y:ne})),({windowId:z})=>!!this.windowsMainService.getWindowById(z)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(z,K)=>K.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(z,K)=>K.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(z,K)=>K.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),z=>!!z),z=>z.id),P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(z,K)=>K.id),z=>!!this.windowsMainService.getWindowById(z))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(z,K,ne)=>ne),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),P.Event.fromNodeEventEmitter(D.screen,"display-added"),P.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(G=>({id:G.id,workspace:G.openedWorkspace??(0,u.toWorkspaceIdentifier)(G.backupPath,G.isExtensionDevelopmentHost),title:G.win?.getTitle()??"",filename:G.getRepresentedFilename(),dirty:G.isDocumentEdited()}))}async getWindowCount(V){return this.windowsMainService.getWindowCount()}async getActiveWindowId(V){const G=D.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(G)return G.id}openWindow(V,G,ie){return Array.isArray(G)?this.doOpenWindow(V,G,ie):this.doOpenEmptyWindow(V,G)}async doOpenWindow(V,G,ie=Object.create(null)){G.length>0&&await this.windowsMainService.open({context:5,contextWindowId:V,urisToOpen:G,cli:this.environmentMainService.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async doOpenEmptyWindow(V,G){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:V},G)}async toggleFullScreen(V){this.windowById(V)?.toggleFullScreen()}async handleTitleDoubleClick(V){this.windowById(V)?.handleTitleDoubleClick()}async isMaximized(V){const G=this.windowById(V);return G?.win?G.win.isMaximized():!1}async maximizeWindow(V){const G=this.windowById(V);G?.win&&G.win.maximize()}async unmaximizeWindow(V){const G=this.windowById(V);G?.win&&G.win.unmaximize()}async minimizeWindow(V){const G=this.windowById(V);G?.win&&G.win.minimize()}async updateWindowControls(V,G){const ie=this.windowById(V);ie&&ie.updateWindowControls(G)}async focusWindow(V,G){G&&typeof G.windowId=="number"&&(V=G.windowId),this.windowById(V)?.focus({force:G?.force??!1})}async setMinimumSize(V,G,ie){const re=this.windowById(V);if(re?.win){const[de,ce]=re.win.getSize(),[ge,x]=re.win.getMinimumSize(),[B,O]=[G??ge,ie??x],[z,K]=[Math.max(de,B),Math.max(ce,O)];(ge!==B||x!==O)&&re.win.setMinimumSize(B,O),(de!==z||ce!==K)&&re.win.setSize(z,K)}}async saveWindowSplash(V,G){this.themeMainService.saveWindowSplash(V,G)}async installShellCommand(V){const{source:G,target:ie}=await this.getShellCommandLink();try{const{symbolicLink:re}=await v.SymlinkSupport.stat(G);if(re&&!re.dangling){const de=await(0,f.realpath)(G);if(ie===de)return}await v.Promises.unlink(G)}catch(re){if(re.code!=="ENOENT")throw re}try{await v.Promises.symlink(ie,G)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{options:de,buttonIndeces:ce}=(0,m.massageMessageBoxOptions)({type:"info",message:(0,d.localize)(0,null,this.productService.nameShort),buttons:[(0,d.localize)(1,null),(0,d.localize)(2,null)]},this.productService),{response:ge}=await this.showMessageBox(V,de);if(ce[ge]===0)try{const x=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${G}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(x)}catch{throw new Error((0,d.localize)(3,null,G))}}}async uninstallShellCommand(V){const{source:G}=await this.getShellCommandLink();try{await v.Promises.unlink(G)}catch(ie){switch(ie.code){case"EACCES":{const{options:re,buttonIndeces:de}=(0,m.massageMessageBoxOptions)({type:"info",message:(0,d.localize)(4,null,this.productService.nameShort),buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null)]},this.productService),{response:ce}=await this.showMessageBox(V,re);if(de[ce]===0)try{const ge=`osascript -e "do shell script \\"rm '${G}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(ge)}catch{throw new Error((0,d.localize)(7,null,G))}break}case"ENOENT":break;default:throw ie}}}async getShellCommandLink(){const V=(0,y.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),G=`/usr/local/bin/${this.productService.applicationName}`;if(!await v.Promises.exists(V))throw new Error((0,d.localize)(8,null,V));return{source:G,target:V}}async showMessageBox(V,G){return this.dialogMainService.showMessageBox(G,this.toBrowserWindow(V))}async showSaveDialog(V,G){return this.dialogMainService.showSaveDialog(G,this.toBrowserWindow(V))}async showOpenDialog(V,G){return this.dialogMainService.showOpenDialog(G,this.toBrowserWindow(V))}toBrowserWindow(V){const G=this.windowById(V);if(G?.win)return G.win}async pickFileFolderAndOpen(V,G){const ie=await this.dialogMainService.pickFileFolder(G);ie&&await this.doOpenPicked(await Promise.all(ie.map(async re=>await v.SymlinkSupport.existsDirectory(re)?{folderUri:S.URI.file(re)}:{fileUri:S.URI.file(re)})),G,V)}async pickFolderAndOpen(V,G){const ie=await this.dialogMainService.pickFolder(G);ie&&await this.doOpenPicked(ie.map(re=>({folderUri:S.URI.file(re)})),G,V)}async pickFileAndOpen(V,G){const ie=await this.dialogMainService.pickFile(G);ie&&await this.doOpenPicked(ie.map(re=>({fileUri:S.URI.file(re)})),G,V)}async pickWorkspaceAndOpen(V,G){const ie=await this.dialogMainService.pickWorkspace(G);ie&&await this.doOpenPicked(ie.map(re=>({workspaceUri:S.URI.file(re)})),G,V)}async doOpenPicked(V,G,ie){await this.windowsMainService.open({context:3,contextWindowId:ie,cli:this.environmentMainService.args,urisToOpen:V,forceNewWindow:G.forceNewWindow})}async showItemInFolder(V,G){D.shell.showItemInFolder(G)}async setRepresentedFilename(V,G){this.windowById(V)?.setRepresentedFilename(G)}async setDocumentEdited(V,G){this.windowById(V)?.setDocumentEdited(G)}async openExternal(V,G){return w.isLinuxSnap?this.safeSnapOpenExternal(G):D.shell.openExternal(G),!0}safeSnapOpenExternal(V){const G=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,D.shell.openExternal(V),process.env.GDK_PIXBUF_MODULE_FILE=G,process.env.GDK_PIXBUF_MODULEDIR=ie}moveItemToTrash(V,G){return D.shell.trashItem(G)}async isAdmin(){let V;return w.isWindows?V=(await new Promise((G,ie)=>{j(["native-is-elevated"],G,ie)}))():V=process.getuid()===0,V}async writeElevated(V,G,ie,re){const de=await new Promise((ce,ge)=>{j(["@vscode/sudo-prompt"],ce,ge)});return new Promise((ce,ge)=>{const x=[`"${this.cliPath}"`];re?.unlock&&x.push("--file-chmod"),x.push("--file-write",`"${G.fsPath}"`,`"${ie.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:w.isMacintosh&&this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};de.exec(x.join(" "),B,(O,z,K)=>{z&&this.logService.trace(`[sudo-prompt] received stdout: ${z}`),K&&this.logService.trace(`[sudo-prompt] received stderr: ${K}`),O?ge(O):ce(void 0)})})}get cliPath(){return w.isWindows?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):w.isLinux?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,y.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return p.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return w.isWindows&&(0,b.hasWSLFeatureInstalled)()}async killProcess(V,G,ie){process.kill(G,ie)}async readClipboardText(V,G){return D.clipboard.readText(G)}async writeClipboardText(V,G,ie){return D.clipboard.writeText(G,ie)}async readClipboardFindText(V){return D.clipboard.readFindText()}async writeClipboardFindText(V,G){return D.clipboard.writeFindText(G)}async writeClipboardBuffer(V,G,ie,re){return D.clipboard.writeBuffer(G,Buffer.from(ie.buffer),re)}async readClipboardBuffer(V,G){return c.VSBuffer.wrap(D.clipboard.readBuffer(G))}async hasClipboard(V,G,ie){return D.clipboard.has(G,ie)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(V,G){this.windowById(V)?.updateTouchBar(G)}async notifyReady(V){this.windowById(V)?.setReady()}async relaunch(V,G){return this.lifecycleMainService.relaunch(G)}async reload(V,G){const ie=this.windowById(V);if(ie){if((0,u.isWorkspaceIdentifier)(ie.openedWorkspace)){const re=ie.openedWorkspace.configPath;if(re.scheme===h.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(ie,G?.disableExtensions!==void 0?{_:[],"disable-extensions":G.disableExtensions}:void 0)}}async closeWindow(V){this.closeWindowById(V,V)}async closeWindowById(V,G){const ie=this.windowById(G);if(ie?.win)return ie.win.close()}async quit(V){const G=this.windowsMainService.getLastActiveWindow();G?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&G.win?G.win.close():this.lifecycleMainService.quit()}async exit(V,G){await this.lifecycleMainService.kill(G)}async resolveProxy(V,G){const re=this.windowById(V)?.win?.webContents?.session;if(re)return re.resolveProxy(G)}findFreePort(V,G,ie,re,de=1){return(0,o.findFreePort)(G,ie,re,de)}async openDevTools(V,G){const ie=this.windowById(V);ie?.win&&ie.win.webContents.openDevTools(G)}async toggleDevTools(V){const G=this.windowById(V);G?.win&&G.win.webContents.toggleDevTools()}async sendInputEvent(V,G){const ie=this.windowById(V);ie?.win&&(G.type==="mouseDown"||G.type==="mouseUp")&&ie.win.webContents.sendInputEvent(G)}async enableSandbox(V,G){G?this.stateMainService.setItem("window.experimental.useSandbox",!0):this.stateMainService.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async profileRenderer(V,G,ie){const re=this.windowById(V);if(!re||!re.win)throw new Error;return await new L.WindowProfiler(re.win,G,this.logService).inspect(ie)}async windowsGetStringRegKey(V,G,ie,re){if(!w.isWindows)return;const de=await new Promise((ce,ge)=>{j(["@vscode/windows-registry"],ce,ge)});try{return de.GetStringRegKey(G,ie,re)}catch{return}}windowById(V){if(typeof V=="number")return this.windowsMainService.getWindowById(V)}};we([k.memoize],F.prototype,"cliPath",null),F=we([Z(1,l.IWindowsMainService),Z(2,C.IDialogMainService),Z(3,t.ILifecycleMainService),Z(4,I.IEnvironmentMainService),Z(5,a.ILogService),Z(6,i.IProductService),Z(7,s.IThemeMainService),Z(8,T.IStateMainService),Z(9,r.IWorkspacesManagementMainService)],F),e.NativeHostMainService=F}),define(ee[276],te([0,1,15,42,26,2,14,4,104,171,88,123,58,28,6,5,59,66,20,67,76,32,10,34,48]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");const s="issue.processExplorerWindowState";let l=class Ct{constructor(c,b,L,T,F,Y,V,G,ie,re){this.userEnv=c,this.environmentMainService=b,this.logService=L,this.diagnosticsService=T,this.diagnosticsMainService=F,this.dialogMainService=Y,this.nativeHostMainService=V,this.protocolMainService=G,this.productService=ie,this.stateMainService=re,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){D.validatedIpcMain.on("vscode:issueSystemInfoRequest",async c=>{const[b,L]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),T=await this.diagnosticsService.getSystemInfo(b,L);this.safeSend(c,"vscode:issueSystemInfoResponse",T)}),D.validatedIpcMain.on("vscode:listProcesses",async c=>{const b=[];try{b.push({name:(0,h.localize)(0,null),rootProcess:await(0,g.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,y.isRemoteDiagnosticError)(T)?b.push({name:T.hostName,rootProcess:T}):T.processes&&b.push({name:T.hostName,rootProcess:T.processes})})}catch(L){this.logService.error(`Listing processes failed: ${L}`)}this.safeSend(c,"vscode:listProcessesResponse",b)}),D.validatedIpcMain.on("vscode:issueReporterClipboard",async c=>{if(this.issueReporterWindow){const{options:b,buttonIndeces:L}=(0,i.massageMessageBoxOptions)({message:(0,h.localize)(1,null),type:"warning",buttons:[(0,h.localize)(2,null),(0,h.localize)(3,null)]},this.productService),T=await this.dialogMainService.showMessageBox(b,this.issueReporterWindow);this.safeSend(c,"vscode:issueReporterClipboardResponse",L[T.response]===0)}}),D.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async c=>{const b=await this.getPerformanceInfo();this.safeSend(c,"vscode:issuePerformanceInfoResponse",b)}),D.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.issueReporterWindow){const{options:c,buttonIndeces:b}=(0,i.massageMessageBoxOptions)({message:(0,h.localize)(4,null),type:"warning",buttons:[(0,h.localize)(5,null),(0,h.localize)(6,null)]},this.productService),L=await this.dialogMainService.showMessageBox(c,this.issueReporterWindow);b[L.response]===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}),D.validatedIpcMain.on("vscode:workbenchCommand",(c,b)=>{const{id:L,from:T,args:F}=b;let Y;switch(T){case"issueReporter":Y=this.issueReporterParentWindow;break;case"processExplorer":Y=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${T}`)}Y?.webContents.send("vscode:runAction",{id:L,from:T,args:F})}),D.validatedIpcMain.on("vscode:openExternal",(c,b)=>{this.nativeHostMainService.openExternal(void 0,b)}),D.validatedIpcMain.on("vscode:closeIssueReporter",c=>{this.issueReporterWindow?.close()}),D.validatedIpcMain.on("vscode:closeProcessExplorer",c=>{this.processExplorerWindow?.close()}),D.validatedIpcMain.on("vscode:windowsInfoRequest",async c=>{const b=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(c,"vscode:windowsInfoResponse",b.windows)})}safeSend(c,b,...L){c.sender.isDestroyed()||c.sender.send(b,...L)}async openReporter(c){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=E.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const b=new M.DisposableStore,L=b.add(this.protocolMainService.createIPCObjectUrl()),T=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(T,L,{backgroundColor:c.styles.backgroundColor,title:(0,h.localize)(7,null),zoomLevel:c.zoomLevel,alwaysOnTop:!1},"issue-reporter"),L.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:c,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:d.default}),this.issueReporterWindow.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,b.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,b.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(c){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=E.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const b=new M.DisposableStore,L=b.add(this.protocolMainService.createIPCObjectUrl()),T=this.stateMainService.getItem(s,void 0),F=u(T)?T:this.getWindowPosition(this.processExplorerParentWindow,800,500),Y=E.screen.getDisplayNearestPoint({x:F.x,y:F.y});F.width/=Y.scaleFactor,F.height/=Y.scaleFactor,this.processExplorerWindow=this.createBrowserWindow(F,L,{backgroundColor:c.styles.backgroundColor,title:(0,h.localize)(8,null),zoomLevel:c.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:c,product:d.default}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,b.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,b.dispose())});const V=()=>{if(!this.processExplorerWindow)return;const G=this.processExplorerWindow.getSize(),ie=this.processExplorerWindow.getPosition();if(!G||!ie)return;const re={width:G[0],height:G[1],x:ie[0],y:ie[1]};this.stateMainService.setItem(s,re)};this.processExplorerWindow.on("moved",V),this.processExplorerWindow.on("resized",V)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(c){c.isMinimized()&&c.restore(),c.focus()}createBrowserWindow(c,b,L,T){const F=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:c.width,height:c.height,minWidth:300,minHeight:200,x:c.x,y:c.y,title:L.title,backgroundColor:L.backgroundColor||Ct.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${b.resource.toString()}`,`--vscode-window-kind=${T}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.zoomLevelToZoomFactor)(L.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return F.setMenuBarVisibility(!1),F}async getSystemStatus(){const[c,b]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(c,b)}getWindowPosition(c,b,L){let T;const F=E.screen.getAllDisplays();if(F.length===1)T=F[0];else{if(P.isMacintosh){const G=E.screen.getCursorScreenPoint();T=E.screen.getDisplayNearestPoint(G)}!T&&c&&(T=E.screen.getDisplayMatching(c.getBounds())),T||(T=E.screen.getPrimaryDisplay()||F[0])}const Y=T.bounds,V={width:b,height:L,x:Y.x+Y.width/2-b/2,y:Y.y+Y.height/2-L/2};return Y.width>0&&Y.height>0&&(V.x<Y.x&&(V.x=Y.x),V.y<Y.y&&(V.y=Y.y),V.x>Y.x+Y.width&&(V.x=Y.x),V.y>Y.y+Y.height&&(V.y=Y.y),V.width>Y.width&&(V.width=Y.width),V.height>Y.height&&(V.height=Y.height)),V}async getPerformanceInfo(){try{const[c,b]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(c,b)}catch(c){throw this.logService.warn("issueService#getPerformanceInfo ",c.message),c}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const c=await E.contentTracing.stopRecording(`${(0,R.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`),{options:b}=(0,i.massageMessageBoxOptions)({type:"info",message:(0,h.localize)(9,null),detail:(0,h.localize)(10,null,c),buttons:[(0,h.localize)(11,null)]},this.productService);await this.dialogMainService.showMessageBox(b,(0,t.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,c)}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=we([Z(1,f.IEnvironmentMainService),Z(2,v.ILogService),Z(3,y.IDiagnosticsService),Z(4,w.IDiagnosticsMainService),Z(5,S.IDialogMainService),Z(6,o.INativeHostMainService),Z(7,C.IProtocolMainService),Z(8,m.IProductService),Z(9,a.IStateMainService)],l),e.IssueMainService=l;function u(r){return typeof r!="object"||r===null?!1:"x"in r&&"y"in r&&"width"in r&&"height"in r}}),define(ee[277],te([0,1,22,19,28,21,5,59,20,57,24,49,94]),function(j,e,E,D,n,M,k,P,g,h,y,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends S.AbstractUpdateService{constructor(v,o,d,m,C,I,R,t){super(v,o,m,C,I,t),this.telemetryService=d,this.nativeHostMainService=R}buildUpdateFeedUrl(v){return(0,S.createUpdateURL)(`linux-${process.arch}`,v,this.productService)}doCheckForUpdates(v){!this.url||(this.setState(w.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},E.CancellationToken.None).then(h.asJson).then(o=>{!o||!o.url||!o.version||!o.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(w.State.Idle(1))):this.setState(w.State.AvailableForDownload(o))}).then(void 0,o=>{this.logService.error(o),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const d=v?o.message||o:void 0;this.setState(w.State.Idle(1,d))}))}async doDownloadUpdate(v){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(w.State.Idle(1))}};f=we([Z(0,M.ILifecycleMainService),Z(1,D.IConfigurationService),Z(2,y.ITelemetryService),Z(3,n.IEnvironmentMainService),Z(4,h.IRequestService),Z(5,k.ILogService),Z(6,P.INativeHostMainService),Z(7,g.IProductService)],f),e.LinuxUpdateService=f}),define(ee[278],te([0,1,46,41,26,8,22,55,9,7,134,23,19,28,16,21,5,59,20,57,24,49,94]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(u,r=1e3){for(;!u();)await(0,M.timeout)(r)}let i;function s(){return typeof i>"u"&&(D.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?i=0:g.basename(g.normalize(g.join(process.execPath,"..","..")))==="Program Files"?i=3:i=1),i}let l=class extends t.AbstractUpdateService{get cachePath(){const r=g.join((0,n.tmpdir)(),`${this.productService.applicationName}-update-${this.productService.target}-${process.arch}`);return w.Promises.mkdir(r,{recursive:!0}).then(()=>r)}constructor(r,c,b,L,T,F,Y,V,G){super(r,c,L,T,F,G),this.telemetryService=b,this.fileService=Y,this.nativeHostMainService=V}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(r){let c="win32";switch(process.arch!=="ia32"&&(c+=`-${process.arch}`),s()){case 1:c+="-archive";break;case 3:c+="-msi";break;default:this.productService.target==="user"&&(c+="-user")}return(0,t.createUpdateURL)(c,r,this.productService)}doCheckForUpdates(r){!this.url||(this.setState(R.State.CheckingForUpdates(r)),this.requestService.request({url:this.url},k.CancellationToken.None).then(C.asJson).then(c=>{const b=s();return!c||!c.url||!c.version||!c.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!r}),this.setState(R.State.Idle(b)),Promise.resolve(null)):b===1?(this.setState(R.State.AvailableForDownload(c)),Promise.resolve(null)):(this.setState(R.State.Downloading(c)),this.cleanup(c.version).then(()=>this.getUpdatePackagePath(c.version).then(L=>w.Promises.exists(L).then(T=>{if(T)return Promise.resolve(L);const F=c.url,Y=c.hash,V=`${L}.tmp`;return this.requestService.request({url:F},k.CancellationToken.None).then(G=>this.fileService.writeFile(h.URI.file(V),G.stream)).then(Y?()=>(0,y.checksum)(V,c.hash):()=>{}).then(()=>w.Promises.rename(V,L)).then(()=>L)})).then(L=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},T&&c.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(R.State.Downloaded(c)):this.setState(R.State.Ready(c))})))}).then(void 0,c=>{this.logService.error(c),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!r});const b=r?c.message||c:void 0;this.setState(R.State.Idle(s(),b))}))}async doDownloadUpdate(r){r.update.url&&this.nativeHostMainService.openExternal(void 0,r.update.url),this.setState(R.State.Idle(s()))}async getUpdatePackagePath(r){const c=await this.cachePath;return g.join(c,`CodeSetup-${this.productService.quality}-${r}.exe`)}async cleanup(r=null){const c=r?F=>!new RegExp(`${this.productService.quality}-${r}\\.exe$`).test(F):()=>!0,b=await this.cachePath,T=(await w.Promises.readdir(b)).filter(c).map(async F=>{try{await w.Promises.unlink(g.join(b,F))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const r=this.state.update;this.setState(R.State.Updating(r));const c=await this.cachePath;this.availableUpdate.updateFilePath=g.join(c,`CodeSetup-${this.productService.quality}-${r.version}.flag`),await w.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,E.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(R.State.Idle(s()))});const L=`${this.productService.win32MutexName}-ready`,T=await new Promise((F,Y)=>{j(["windows-mutex"],F,Y)});a(()=>T.isActive(L)).then(()=>this.setState(R.State.Ready(r)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?D.unlinkSync(this.availableUpdate.updateFilePath):s()==3?(0,E.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,E.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}async _applySpecificUpdate(r){if(this.state.type!=="idle")return;const c=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),b={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!c};this.setState(R.State.Downloading(b)),this.availableUpdate={packagePath:r},c?this.productService.target==="user"?this.doApplyUpdate():this.setState(R.State.Downloaded(b)):this.setState(R.State.Ready(b))}};we([P.memoize],l.prototype,"cachePath",null),l=we([Z(0,v.ILifecycleMainService),Z(1,S.IConfigurationService),Z(2,I.ITelemetryService),Z(3,f.IEnvironmentMainService),Z(4,C.IRequestService),Z(5,o.ILogService),Z(6,p.IFileService),Z(7,d.INativeHostMainService),Z(8,m.IProductService)],l),e.Win32UpdateService=l}),define(ee[279],te([0,1,15,8,22,44,3,2,14,9,64,4,7,179,63,19,58,28,62,16,21,5,20,67,242,96,24,133,69,76,30,29,54,120,124,37,34,53,59,244,116,52,93,26,117,65,48]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t,a,i,s,l,u,r,c,b,L,T,F,Y,V,G,ie,re,de,ce,ge,x,B,O,z,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function(J){J[J.NONE=0]="NONE",J[J.NAVIGATING=1]="NAVIGATING",J[J.READY=2]="READY"})(ne||(ne={}));let se=class ct extends P.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const W=this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,L.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(W,A,_,N,q,U,$,H,oe,fe,pe,ye,Le,_e,Oe,ve,Me,De,X,ae,he){super(),this.logService=A,this.loggerMainService=_,this.environmentMainService=N,this.policyService=q,this.userDataProfilesService=U,this.fileService=$,this.applicationStorageMainService=H,this.storageMainService=oe,this.configurationService=fe,this.themeMainService=pe,this.workspacesManagementMainService=ye,this.backupMainService=Le,this.telemetryService=_e,this.dialogMainService=Oe,this.lifecycleMainService=ve,this.productService=Me,this.protocolMainService=De,this.windowsMainService=X,this.stateMainService=ae,this.nativeHostMainService=he,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new k.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;let Ie=!1;{const[Re,Ae]=this.restoreWindowState(W.state);this.windowState=Re,this.logService.trace("window#ctor: using window state",Re);const We=this.windowState.mode===0||this.windowState.mode===3;typeof ct.sandboxState>"u"&&(ct.sandboxState=this.stateMainService.getItem("window.experimental.useSandbox",!1));const qe=this.configurationService.getValue("window");typeof qe?.experimental?.useSandbox=="boolean"?Ie=qe.experimental.useSandbox:this.productService.quality==="stable"&&ct.sandboxState?Ie=!0:Ie=typeof this.productService.quality=="string"&&this.productService.quality!=="stable";const Ue={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:c.WindowMinimumSize.WIDTH,minHeight:c.WindowMinimumSize.HEIGHT,show:!We,title:this.productService.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(qe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...Ie?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};w.isLinux?Ue.icon=(0,h.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):w.isWindows&&!this.environmentMainService.isBuilt&&(Ue.icon=(0,h.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),w.isMacintosh&&!this.useNativeFullScreen()&&(Ue.fullscreenable=!1),w.isMacintosh&&(Ue.acceptFirstMouse=!0,qe?.clickThroughInactive===!1&&(Ue.acceptFirstMouse=!1));const $e=w.isMacintosh&&qe?.nativeTabs===!0;$e&&(Ue.tabbingIdentifier=this.productService.nameShort);const Ve=(0,c.getTitleBarStyle)(this.configurationService)==="custom";if(Ve&&(Ue.titleBarStyle="hidden",w.isMacintosh||(Ue.frame=!1),(0,c.useWindowControlsOverlay)(this.configurationService))){const Fe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),je=Y.Color.fromHex(Fe).isDarker()?"#FFFFFF":"#000000";Ue.titleBarOverlay={height:29,color:Fe,symbolColor:je},this.hasWindowControlOverlay=!0}if((0,y.mark)("code/willCreateCodeBrowserWindow"),this._win=new E.BrowserWindow(Ue),(0,y.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,w.isMacintosh&&Ve&&this._win.setSheetOffset(22),Ve&&(w.isWindows&&(0,c.useWindowControlsOverlay)(this.configurationService)||w.isMacintosh)){const Fe=this.stateMainService.getItem(ct.windowControlHeightStateStorageKey);Fe&&this.updateWindowControls({height:Fe})}w.isWindows&&Ve&&this._win.hookWindowMessage(278,()=>{const[je,Q]=this._win.getPosition(),le=E.screen.getCursorScreenPoint(),ue=le.x-je,me=le.y-Q;return(()=>!(ue>30&&me>=0&&me<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:ue,y:me})),0}),(w.isMacintosh||w.isWindows)&&Ae&&(!$e||E.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Fe=>typeof Fe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),We&&((0,y.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,y.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners(Ie)}setRepresentedFilename(W){w.isMacintosh?this._win.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return w.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){w.isMacintosh&&this._win.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return w.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(W){w.isMacintosh&&W?.force&&E.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(W=>{function A(){_.dispose(),N.dispose(),W()}const _=this.onDidClose(()=>A()),N=this.onWillLoad(()=>A())})}registerListeners(W){this._win.on("unresponsive",()=>this.onWindowError(1,{sandboxed:W})),this._win.webContents.on("render-process-gone",(_,N)=>this.onWindowError(2,{...N,sandboxed:W})),this._win.webContents.on("did-fail-load",(_,N,q)=>this.onWindowError(3,{reason:q,exitCode:N,sandboxed:W})),this._win.webContents.on("will-prevent-unload",_=>{_.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",_=>{this._config&&(this._config.maximized=!0),E.app.emit("browser-window-maximize",_,this._win)}),this._win.on("unmaximize",_=>{this._config&&(this._config.maximized=!1),E.app.emit("browser-window-unmaximize",_,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(_=>this.onConfigurationUpdated(_))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(_=>this.onDidDeleteUntitledWorkspace(_)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(_,N)=>{const q=await this.getMarketplaceHeaders();N({cancel:!1,requestHeaders:Object.assign(_.requestHeaders,q)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(W,A){switch(W){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${A?.reason||"<unknown>"}, code: ${A?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${A?.reason||"<unknown>"}, code: ${A?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:W,reason:A?.reason,code:A?.exitCode,sandboxed:A?.sandboxed?"1":"0"}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{options:_,buttonIndeces:N}=(0,K.massageMessageBoxOptions)({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this._config?.workspace?(0,f.localize)(5,null):void 0},this.productService),q=await this.dialogMainService.showMessageBox(_,this._win),U=N[q.response];if(U!==1){const $=U===0;await this.destroyWindow($,q.checkboxChecked)}}else if(W===2)if(w.isWindows&&A?.reason==="launch-failed"&&A.exitCode===18&&await this.nativeHostMainService.isAdmin(void 0))await this.handleWindowsAdminCrash(A);else{let _;A?_=(0,f.localize)(7,null,A.reason,A.exitCode??"<unknown>"):_=(0,f.localize)(6,null);const{options:N,buttonIndeces:q}=(0,K.massageMessageBoxOptions)({type:"warning",buttons:[this._config?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:_,detail:this._config?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this._config?.workspace?(0,f.localize)(13,null):void 0},this.productService),U=await this.dialogMainService.showMessageBox(N,this._win),$=q[U.response]===0;await this.destroyWindow($,U.checkboxChecked)}break}}async handleWindowsAdminCrash(W){const A=[],_=(0,ge.isInternalTelemetry)(this.productService,this.configurationService);if((0,ge.supportsTelemetry)(this.productService,this.environmentMainService)){this.productService.aiConfig&&this.productService.aiConfig.ariaKey&&A.push(new de.OneDataSystemAppender(_,"monacoworkbench",null,this.productService.aiConfig.ariaKey));const{installSourcePath:$}=this.environmentMainService,H=await(0,O.resolveMachineId)(this.stateMainService),oe={appenders:A,sendErrorTelemetry:!1,commonProperties:(0,x.resolveCommonProperties)(this.fileService,(0,B.release)(),(0,B.hostname)(),process.arch,this.productService.commit,this.productService.version,H,_,$),piiPaths:(0,ge.getPiiPathsFromEnvironment)(this.environmentMainService)};await new ce.TelemetryService(oe,this.configurationService,this.productService).publicLog2("windowadminerror",{reason:W.reason,code:W.exitCode})}const{options:N,buttonIndeces:q}=(0,K.massageMessageBoxOptions)({type:"error",buttons:[(0,f.localize)(14,null),(0,f.localize)(15,null)],message:(0,f.localize)(16,null),detail:(0,f.localize)(17,null,this.productService.nameLong)},this.productService),U=await this.dialogMainService.showMessageBox(N,this._win);q[U.response]===0&&await this.nativeHostMainService.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(A.map($=>$.flush())),await this.destroyWindow(!1,!1)}async destroyWindow(W,A){const _=this._config?.workspace;if(A&&_)try{const N=this.storageMainService.workspaceStorage(_);await N.init(),N.delete("memento/workbench.parts.editor"),await N.close()}catch(N){this.logService.error(N)}if(this._onDidDestroy.fire(),this._win?.destroy(),W&&this._config){let N,q;(0,L.isSingleFolderWorkspaceIdentifier)(_)?N={folderUri:_.uri}:(0,L.isWorkspaceIdentifier)(_)?N={workspaceUri:_.configPath}:q=!0;const[U]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:N?[N]:void 0,forceEmpty:q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});U.focus()}}onDidDeleteUntitledWorkspace(W){this._config?.workspace?.id===W.id&&(this._config.workspace=void 0)}onConfigurationUpdated(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const A=this.getMenuBarVisibility();A!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=A,this.setMenuBarVisibility(A))}if(!W||W.affectsConfiguration("http.proxy")){let A=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;A?.endsWith("/")&&(A=A.substr(0,A.length-1));const _=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((A||"").indexOf("@")===-1&&(A!==this.currentHttpProxy||_!==this.currentNoProxy)){this.currentHttpProxy=A,this.currentNoProxy=_;const N=A||"",q=_?`${_},<local>`:"<local>";this.logService.trace(`Setting proxy to '${N}', bypassing '${q}'`),this._win.webContents.session.setProxy({proxyRules:N,proxyBypassRules:q,pacScript:""})}}}addTabbedWindow(W){w.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,A=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!A.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),A.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,A),this.readyState===0?this._config=W:this.pendingLoadConfig=W,this.readyState=1,this._win.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const _=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new D.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:W.workspace,reason:A.isReload?3:_?2:1})}updateConfiguration(W,A){const _=(this._config??this.pendingLoadConfig)?.userEnv;if(_){const N=(0,m.isLaunchedFromCli)(_)&&!(0,m.isLaunchedFromCli)(W.userEnv),q=this.isExtensionDevelopmentHost;(N||q)&&(W.userEnv={..._,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),A.disableExtensions!==void 0&&(W["disable-extensions"]=A.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),(0,y.mark)("code/willOpenNewWindow"),W.perfMarks=(0,y.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const A=Object.assign({},this._config);A.workspace=await this.validateWorkspaceBeforeReload(A),delete A.filesToOpenOrCreate,delete A.filesToDiff,delete A.filesToMerge,delete A.filesToWait,this.isExtensionDevelopmentHost&&W&&(A.verbose=W.verbose,A.debugId=W.debugId,A.extensionEnvironment=W.extensionEnvironment,A["inspect-extensions"]=W["inspect-extensions"],A["inspect-brk-extensions"]=W["inspect-brk-extensions"],A["extensions-dir"]=W["extensions-dir"]),A.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),A.isInitialStartup=!1,A.policiesData=this.policyService.serialize(),A.continueOn=this.environmentMainService.continueOn,A.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},A.logLevel=this.loggerMainService.getLogLevel(),A.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(A,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async validateWorkspaceBeforeReload(W){if((0,L.isWorkspaceIdentifier)(W.workspace)){const A=W.workspace.configPath;if(A.scheme===g.Schemas.file&&!await this.fileService.exists(A))return}else if((0,L.isSingleFolderWorkspaceIdentifier)(W.workspace)){const A=W.workspace.uri;if(A.scheme===g.Schemas.file&&!await this.fileService.exists(A))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,F.defaultWindowState)();if(this.isFullScreen){let _;try{_=E.screen.getDisplayMatching(this.getBounds())}catch{}const N=(0,F.defaultWindowState)();return{mode:3,display:_?_.id:void 0,width:this.windowState.width||N.width,height:this.windowState.height||N.height,x:this.windowState.x||0,y:this.windowState.y||0}}const W=Object.create(null);let A;if(!w.isMacintosh&&this._win.isMaximized()?A=0:A=1,A===0?W.mode=0:W.mode=1,A===1||A===0){let _;A===1?_=this.getBounds():_=this._win.getNormalBounds(),W.x=_.x,W.y=_.y,W.width=_.width,W.height=_.height}return W}updateWindowControls(W){if(W.height&&this.stateMainService.setItem(ct.windowControlHeightStateStorageKey,W.height),w.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(w.isMacintosh&&W.height!==void 0){const A=(W.height-15)/2;this._win.setTrafficLightPosition({x:A,y:A})}}restoreWindowState(W){(0,y.mark)("code/willRestoreCodeWindowState");let A=!1;if(W)try{const _=E.screen.getAllDisplays();A=_.length>1,W=this.validateWindowState(W,_)}catch(_){this.logService.warn(`Unexpected error validating window state: ${_}
${_.stack}`)}return(0,y.mark)("code/didRestoreCodeWindowState"),[W||(0,F.defaultWindowState)(),A]}validateWindowState(W,A){if(this.logService.trace(`window#validateWindowState: validating window state on ${A.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(A.length===1){const q=this.getWorkingArea(A[0]);if(q){let U=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!q||(W.x<q.x&&(W.x=q.x),W.y<q.y&&(W.y=q.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",q),U(),W.width>q.width&&(W.width=q.width),W.height>q.height&&(W.height=q.height),W.x>q.x+q.width-128&&(W.x=q.x+q.width-W.width),W.y>q.y+q.height-128&&(W.y=q.y+q.height-W.height),U()}return W}if(W.display&&W.mode===3){const q=A.find(U=>U.id===W.display);if(q&&typeof q.bounds?.x=="number"&&typeof q.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const U=(0,F.defaultWindowState)(3);return U.x=q.bounds.x,U.y=q.bounds.y,U}}let _,N;try{_=E.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),N=this.getWorkingArea(_)}catch{}if(_&&N&&W.x+W.width>N.x&&W.y+W.height>N.y&&W.x<N.x+N.width&&W.y<N.y+N.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",N),W}getWorkingArea(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,A]=this._win.getPosition(),[_,N]=this._win.getSize();return{x:W,y:A,width:_,height:N}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(W){this.useNativeFullScreen()?this.setNativeFullScreen(W):this.setSimpleFullScreen(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return w.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(W){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(W)}doSetNativeFullScreen(W){w.isMacintosh&&(this.transientIsNativeFullScreen=W,this.joinNativeFullScreenTransition=new D.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,D.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(W)}setSimpleFullScreen(W){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(W),this._win.webContents.focus()}useNativeFullScreen(){const W=this.configurationService.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let W=(0,c.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,A=!0){w.isMacintosh||(W==="toggle"&&A&&this.send("vscode:showInfoMessage",(0,f.localize)(18,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const A=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!A),this._win.autoHideMenuBar=A;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(w.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(W,A,..._){this.isReady?this.send(W,..._):this.ready().then(()=>{A.isCancellationRequested||this.send(W,..._)})}send(W,...A){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this._win.webContents.send(W,...A)}catch(_){this.logService.warn(`Error sending IPC message to channel '${W}' of window ${this._id}: ${(0,M.toErrorMessage)(_)}`)}}}updateTouchBar(W){!w.isMacintosh||this.touchBarGroups.forEach((A,_)=>{const N=W[_];A.segments=this.createTouchBarGroupSegments(N)})}createTouchBar(){if(!!w.isMacintosh){for(let W=0;W<10;W++){const A=this.createTouchBarGroup();this.touchBarGroups.push(A)}this._win.setTouchBar(new E.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const A=this.createTouchBarGroupSegments(W),_=new E.TouchBar.TouchBarSegmentedControl({segments:A,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:_.segments[N].id,from:"touchbar"})}});return _}createTouchBarGroupSegments(W=[]){return W.map(_=>{let N;_.icon&&!u.ThemeIcon.isThemeIcon(_.icon)&&_.icon?.dark?.scheme===g.Schemas.file&&(N=E.nativeImage.createFromPath(S.URI.revive(_.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let q;return typeof _.title=="string"?q=_.title:q=_.title.value,{id:_.id,label:N?void 0:q,icon:N}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};se.windowControlHeightStateStorageKey="windowControlHeight",se.sandboxState=void 0,se=we([Z(1,R.ILogService),Z(2,z.ILoggerMainService),Z(3,d.IEnvironmentMainService),Z(4,V.IPolicyService),Z(5,ie.IUserDataProfilesMainService),Z(6,C.IFileService),Z(7,s.IApplicationStorageMainService),Z(8,s.IStorageMainService),Z(9,v.IConfigurationService),Z(10,r.IThemeMainService),Z(11,T.IWorkspacesManagementMainService),Z(12,p.IBackupMainService),Z(13,l.ITelemetryService),Z(14,o.IDialogMainService),Z(15,I.ILifecycleMainService),Z(16,t.IProductService),Z(17,a.IProtocolMainService),Z(18,b.IWindowsMainService),Z(19,G.IStateMainService),Z(20,re.INativeHostMainService)],se),e.CodeWindow=se}),define(ee[78],te([0,1,15,25,8,3,45,2,14,4,18,7,23,182,6,21,5,96,97,29,54,35]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,p.createDecorator)("workspacesHistoryMainService");let t=class nt extends P.Disposable{constructor(i,s,l,u){super(),this.logService=i,this.workspacesManagementMainService=s,this.lifecycleMainService=l,this.applicationStorageMainService=u,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new n.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let s=[],l=[];for(const r of i)if((0,m.isRecentWorkspace)(r))!this.workspacesManagementMainService.isUntitledWorkspace(r.workspace)&&!this.containsWorkspace(s,r.workspace)&&s.push(r);else if((0,m.isRecentFolder)(r))this.containsFolder(s,r.folderUri)||s.push(r);else{const c=this.containsFile(l,r.fileUri),b=r.fileUri.scheme===g.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,y.basename)(r.fileUri))>=0;!c&&!b&&(l.push(r),h.isWindows&&r.fileUri.scheme===g.Schemas.file&&E.app.addRecentDocument(r.fileUri.fsPath))}const u=await this.mergeEntriesFromStorage({workspaces:s,files:l});s=u.workspaces,l=u.files,s.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=nt.MAX_TOTAL_RECENT_ENTRIES),l.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(l.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:s,files:l}),this._onDidChangeRecentlyOpened.fire(),h.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const s=c=>{const b=this.location(c);for(const L of i)if(y.extUriBiasedIgnorePathCase.isEqual(L,b))return!1;return!0},l=await this.getRecentlyOpened(),u=l.workspaces.filter(s),r=l.files.filter(s);(u.length!==l.workspaces.length||r.length!==l.files.length)&&(await this.saveRecentlyOpened({files:r,workspaces:u}),this._onDidChangeRecentlyOpened.fire(),h.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const s=new R.ResourceMap(r=>y.extUriBiasedIgnorePathCase.getComparisonKey(r));if(i?.workspaces)for(const r of i.workspaces)s.set(this.location(r),r);const l=new R.ResourceMap(r=>y.extUriBiasedIgnorePathCase.getComparisonKey(r));if(i?.files)for(const r of i.files)l.set(this.location(r),r);const u=await this.getRecentlyOpenedFromStorage();for(const r of u.workspaces){const c=s.get(this.location(r));c?c.label=c.label??r.label:s.set(this.location(r),r)}for(const r of u.files){const c=l.get(this.location(r));c?c.label=c.label??r.label:l.set(this.location(r),r)}return{workspaces:[...s.values()],files:[...l.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const s=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof s=="string")try{i=JSON.parse(s)}catch(l){this.logService.error("Unexpected error parsing opened paths list",l)}return(0,m.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,m.toStoreData)(i)),-1,1)}location(i){return(0,m.isRecentFolder)(i)?i.folderUri:(0,m.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,s){return!!i.find(l=>(0,m.isRecentWorkspace)(l)&&l.workspace.id===s.id)}containsFolder(i,s){return!!i.find(l=>(0,m.isRecentFolder)(l)&&y.extUriBiasedIgnorePathCase.isEqual(l.folderUri,s))}containsFile(i,s){return!!i.find(l=>y.extUriBiasedIgnorePathCase.isEqual(l.fileUri,s))}async handleWindowsJumpList(){!h.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!h.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const s=[];for(const r of E.app.getJumpListSettings().removedItems){const c=r.args;if(c){const b=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(c);b&&s.push(w.URI.parse(b[2]))}}await this.removeRecentlyOpened(s);let l=!1;const u=(0,D.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(r=>{const c=(0,m.isRecentWorkspace)(r)?r.workspace:r.folderUri,{title:b,description:L}=this.getWindowsJumpListLabel(c,r.label);let T;return w.URI.isUri(c)?T=`--folder-uri "${c.toString()}"`:(l=!0,T=`--file-uri "${c.configPath.toString()}"`),{type:"task",title:b.substr(0,255),description:L.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));u.length>0&&i.push({type:"custom",name:l?(0,f.localize)(2,null):(0,f.localize)(3,null),items:u})}i.push({type:"recent"});try{const s=E.app.setJumpList(i);s&&s!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${s}`)}catch(s){this.logService.warn("updateWindowsJumpList#setJumpList",s)}}getWindowsJumpListLabel(i,s){if(s)return{title:(0,k.splitName)(s).name,description:s};if(w.URI.isUri(i))return{title:(0,y.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let l=(0,y.basename)(i.configPath);return l.endsWith(C.WORKSPACE_EXTENSION)&&(l=l.substr(0,l.length-C.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,l),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,k.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!h.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),s=[];let l=0;for(let r=0;r<i.workspaces.length&&l<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;r++){const c=this.location(i.workspaces[r]);if(c.scheme===g.Schemas.file){const b=(0,y.originalFSPath)(c);await S.Promises.exists(b)&&(s.push(b),l++)}}const u=[];for(let r=0;r<i.files.length&&l<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;r++){const c=this.location(i.files[r]);if(c.scheme===g.Schemas.file){const b=(0,y.originalFSPath)(c);if(nt.COMMON_FILES_FILTER.includes((0,y.basename)(c))||s.includes(b))continue;await S.Promises.exists(b)&&(u.push(b),l++)}}u.reverse().forEach(r=>E.app.addRecentDocument(r)),s.reverse().forEach(r=>E.app.addRecentDocument(r))}};t.MAX_TOTAL_RECENT_ENTRIES=500,t.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",t.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,t.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,t.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,t.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],t=we([Z(0,o.ILogService),Z(1,I.IWorkspacesManagementMainService),Z(2,v.ILifecycleMainService),Z(3,d.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(ee[280],te([0,1,15,8,22,45,4,7,172,19,48,28,21,5,220,59,20,34,24,49,76,30,78]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const a="menu";let i=class St{constructor(u,r,c,b,L,T,F,Y,V,G,ie){this.updateService=u,this.configurationService=r,this.windowsMainService=c,this.environmentMainService=b,this.telemetryService=L,this.workspacesHistoryMainService=T,this.stateMainService=F,this.lifecycleMainService=Y,this.logService=V,this.nativeHostMainService=G,this.productService=ie,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new D.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new D.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(k.isMacintosh||(0,I.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const u=this.stateMainService.getItem(St.lastKnownMenubarStorageKey);u&&(u.menus&&(this.menubarMenus=u.menus),u.keybindings&&(this.keybindings=u.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,F,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,F,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,F,Y)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,F,Y)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,F,Y)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const u=this.productService.twitterUrl;u&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(u,"openTwitterUrl"));const r=this.productService.requestFeatureUrl;r&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(r,"openUserVoiceUrl"));const c=this.productService.reportIssueUrl;c&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(c,"openReportIssues"));const b=this.productService.licenseUrl;b&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(k.language){const T=b.indexOf("?")>0?"&":"?";this.openUrl(`${b}${T}lang=${k.language}`,"openLicenseUrl")}else this.openUrl(b,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&b&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(u=>this.onDidChangeWindowsCount(u)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const u=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof u!="boolean"?!0:u}get currentEnableNativeTabs(){if(!k.isMacintosh)return!1;const u=this.configurationService.getValue("window.nativeTabs");return typeof u!="boolean"?!1:u}updateMenu(u,r){this.menubarMenus=u.menus,this.keybindings=u.keybindings,this.stateMainService.setItem(St.lastKnownMenubarStorageKey,u),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(u){!k.isMacintosh||(u.oldCount===0&&u.newCount>0||u.oldCount>0&&u.newCount===0)&&(this.closedLastWindow=u.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!k.isMacintosh||(this.noActiveWindow=!E.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const u=E.Menu.getApplicationMenu();if(u&&this.oldMenus.push(u),Object.keys(this.menubarMenus).length===0){E.Menu.setApplicationMenu(k.isMacintosh?new E.Menu:null);return}const r=new E.Menu;let c;if(k.isMacintosh){const L=new E.Menu;c=new E.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),r.append(c)}if(k.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new E.Menu;L.append(new E.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),E.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:L});this.setMenuById(L,"File"),r.append(T)}if(this.shouldDrawMenu("Edit")){const L=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),r.append(T)}if(this.shouldDrawMenu("Selection")){const L=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),r.append(T)}if(this.shouldDrawMenu("View")){const L=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:L});this.setMenuById(L,"View"),r.append(T)}if(this.shouldDrawMenu("Go")){const L=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),r.append(T)}if(this.shouldDrawMenu("Run")){const L=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),r.append(T)}if(this.shouldDrawMenu("Terminal")){const L=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),r.append(T)}let b;if(this.shouldDrawMenu("Window")){const L=new E.Menu;b=new E.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(b&&r.append(b),this.shouldDrawMenu("Help")){const L=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),r.append(T)}r.items&&r.items.length>0?E.Menu.setApplicationMenu(r):E.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(u){const r=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),c=this.getUpdateMenuItems();let b;if(this.shouldDrawMenu("Preferences")){const re=new E.Menu;this.setMenuById(re,"Preferences"),b=new E.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:re})}const L=new E.Menu,T=new E.MenuItem({label:g.localize(12,null),role:"services",submenu:L}),F=new E.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Y=new E.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),V=new E.MenuItem({label:g.localize(15,null),role:"unhide"}),G=new E.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:async(re,de,ce)=>{const ge=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||ge?.isMinimized())&&await this.confirmBeforeQuit(ce)&&this.nativeHostMainService.quit(void 0)}})),ie=[r];ie.push(...c),b&&ie.push(s(),b),ie.push(s(),T,s(),F,Y,V,s(),G),ie.forEach(re=>u.append(re))}async confirmBeforeQuit(u){if(this.windowsMainService.getWindowCount()===0)return!0;const r=this.configurationService.getValue("window.confirmBeforeClose");if(r==="always"||r==="keyboardOnly"&&this.isKeyboardEvent(u)){const{options:c,buttonIndeces:b}=(0,y.massageMessageBoxOptions)({type:"question",buttons:[g.localize(17,null),g.localize(18,null)],message:g.localize(19,null)},this.productService),{response:L}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,c);return b[L]===0}return!0}shouldDrawMenu(u){if(!k.isMacintosh&&(0,I.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(u){case"File":case"Help":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[u];case"Window":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[u]}}setMenu(u,r){r.forEach(c=>{if((0,p.isMenubarMenuItemSeparator)(c))u.append(s());else if((0,p.isMenubarMenuItemSubmenu)(c)){const b=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(c.label),submenu:b});this.setMenu(b,c.submenu.items),u.append(L)}else(0,p.isMenubarMenuItemRecentAction)(c)?u.append(this.createOpenRecentMenuItem(c)):(0,p.isMenubarMenuItemAction)(c)&&(c.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(u),k.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[c.id]?u.append(new E.MenuItem(this.likeAction(c.id,{label:this.mnemonicLabel(c.label),click:this.fallbackMenuHandlers[c.id]}))):u.append(this.createMenuItem(c.label,c.id,!1,c.checked)):u.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)):u.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)))})}setMenuById(u,r){this.menubarMenus&&this.menubarMenus[r]&&this.setMenu(u,this.menubarMenus[r].items)}insertCheckForUpdatesItems(u){const r=this.getUpdateMenuItems();r.length&&(r.forEach(c=>u.append(c)),u.append(s()))}createOpenRecentMenuItem(u){const r=P.URI.revive(u.uri),c=u.id,b=c==="openRecentFile"?{fileUri:r}:c==="openRecentWorkspace"?{workspaceUri:r}:{folderUri:r};return new E.MenuItem(this.likeAction(c,{label:u.label,click:async(L,T,F)=>{const Y=this.isOptionClick(F);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[b],forceNewWindow:Y,gotoLineMode:!1,remoteAuthority:u.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([r])}},!1))}isOptionClick(u){return!!(u&&(!k.isMacintosh&&(u.ctrlKey||u.shiftKey)||k.isMacintosh&&(u.metaKey||u.altKey)))}isKeyboardEvent(u){return!!(u.triggeredByAccelerator||u.altKey||u.ctrlKey||u.metaKey||u.shiftKey)}createRoleMenuItem(u,r,c){const b={label:this.mnemonicLabel(u),role:c,enabled:!0};return new E.MenuItem(this.withKeybinding(r,b))}setMacWindowMenu(u){const r=new E.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),c=new E.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),b=new E.MenuItem({label:g.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(g.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(s()),T.push(this.createMenuItem(g.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[r,c,s(),L,...T,s(),b].forEach(F=>u.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.mnemonicLabel(g.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.mnemonicLabel(g.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.mnemonicLabel(g.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new E.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.mnemonicLabel(g.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(u,r,c,b){const L=this.mnemonicLabel(u),T=typeof r=="function"?r:(ie,re,de)=>{const ce=ie?ie.userSettingsLabel:null;let ge=r;Array.isArray(r)&&(ge=this.isOptionClick(de)?r[1]:r[0]),ce&&de.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ce}):this.runActionInRenderer({type:"commandId",commandId:ge})},F=typeof c=="boolean"?c:this.windowsMainService.getWindowCount()>0,Y=typeof b=="boolean"?b:!1,V={label:L,click:T,enabled:F};Y&&(V.type="checkbox",V.checked=Y);let G;return typeof r=="string"?G=r:Array.isArray(r)&&(G=r[0]),k.isMacintosh&&(G==="editor.action.clipboardCutAction"?V.role="cut":G==="editor.action.clipboardCopyAction"?V.role="copy":G==="editor.action.clipboardPasteAction"&&(V.role="paste"),G==="undo"?V.click=this.makeContextAwareClickHandler(T,{inDevTools:ie=>ie.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):G==="redo"?V.click=this.makeContextAwareClickHandler(T,{inDevTools:ie=>ie.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):G==="editor.action.selectAll"&&(V.click=this.makeContextAwareClickHandler(T,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.withKeybinding(G,V))}makeContextAwareClickHandler(u,r){return(c,b,L)=>{const T=E.BrowserWindow.getFocusedWindow();if(!T)return r.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return r.inDevTools(T.webContents.devToolsWebContents);u(c,b||T,L)}}runActionInRenderer(u){let r=E.BrowserWindow.getFocusedWindow();if(!r){const b=this.windowsMainService.getLastActiveWindow();b?.isMinimized()&&(r=b.win)}const c=r?this.windowsMainService.getWindowById(r.id):void 0;if(c){if(this.logService.trace("menubar#runActionInRenderer",u),k.isMacintosh&&!this.environmentMainService.isBuilt&&!c.isReady&&(u.type==="commandId"&&u.commandId==="workbench.action.toggleDevTools"||u.type!=="commandId"&&u.userSettingsLabel==="alt+cmd+i"))return;if(u.type==="commandId"){const b={id:u.commandId,from:"menu"};c.sendWhenReady("vscode:runAction",n.CancellationToken.None,b)}else{const b={userSettingsLabel:u.userSettingsLabel};c.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,b)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",u)}withKeybinding(u,r){const c=typeof u=="string"?this.keybindings[u]:void 0;if(c?.label){if(c.isNative!==!1)r.accelerator=c.label,r.userSettingsLabel=c.userSettingsLabel;else if(typeof r.label=="string"){const b=r.label.indexOf("[");b>=0?r.label=`${r.label.substr(0,b)} [${c.label}]`:r.label=`${r.label} [${c.label}]`}}else r.accelerator=void 0;return r}likeAction(u,r,c=!r.accelerator){c&&(r=this.withKeybinding(u,r));const b=r.click;return r.click=(L,T,F)=>{this.reportMenuActionTelemetry(u),b?.(L,T,F)},r}openUrl(u,r){this.nativeHostMainService.openExternal(void 0,u),this.reportMenuActionTelemetry(r)}reportMenuActionTelemetry(u){this.telemetryService.publicLog2("workbenchActionExecuted",{id:u,from:a})}mnemonicLabel(u){return(0,M.mnemonicMenuLabel)(u,!this.currentEnableMenuBarMnemonics)}};i.lastKnownMenubarStorageKey="lastKnownMenubarData",i=we([Z(0,C.IUpdateService),Z(1,h.IConfigurationService),Z(2,R.IWindowsMainService),Z(3,w.IEnvironmentMainService),Z(4,m.ITelemetryService),Z(5,t.IWorkspacesHistoryMainService),Z(6,d.IStateMainService),Z(7,S.ILifecycleMainService),Z(8,f.ILogService),Z(9,v.INativeHostMainService),Z(10,o.IProductService)],i),e.Menubar=i;function s(){return new E.MenuItem({type:"separator"})}}),define(ee[281],te([0,1,6,21,5,280]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let k=class{constructor(g,h,y){this.instantiationService=g,this.lifecycleMainService=h,this.logService=y,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(g,h){this.logService.trace("menubarService#updateMenubar",g),(await this.menubar).updateMenu(h,g)}};k=we([Z(0,E.IInstantiationService),Z(1,D.ILifecycleMainService),Z(2,n.ILogService)],k),e.MenubarMainService=k}),define(ee[282],te([0,1,15,23,26,25,22,3,32,50,45,2,14,9,64,4,36,18,10,7,180,63,19,58,28,16,6,21,5,66,20,67,56,34,76,279,122,274,29,98,78,54,69,37,53,65,48]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t,a,i,s,l,u,r,c,b,L,T,F,Y,V,G,ie,re,de,ce,ge,x,B,O,z,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function ne(W){return(0,re.isWorkspaceIdentifier)(W?.workspace)}function se(W){return(0,re.isSingleFolderWorkspaceIdentifier)(W?.workspace)}let J=class lt extends w.Disposable{constructor(A,_,N,q,U,$,H,oe,fe,pe,ye,Le,_e,Oe,ve,Me,De,X,ae){super(),this.machineId=A,this.initialUserEnv=_,this.logService=N,this.loggerService=q,this.stateMainService=U,this.policyService=$,this.environmentMainService=H,this.userDataProfilesMainService=oe,this.lifecycleMainService=fe,this.backupMainService=pe,this.configurationService=ye,this.workspacesHistoryMainService=Le,this.workspacesManagementMainService=_e,this.instantiationService=Oe,this.dialogMainService=ve,this.fileService=Me,this.productService=De,this.protocolMainService=X,this.themeMainService=ae,this._onDidOpenWindow=this._register(new P.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new P.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new P.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new P.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new P.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ie.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const _=new w.DisposableStore;if(_.add(P.Event.any(A.onDidClose,A.onDidDestroy)(()=>_.dispose())),A.config.extensionDevelopmentPath)for(const N of A.config.extensionDevelopmentPath)_.add(this.protocolMainService.addValidFileRoot(N));A.config.extensionTestsPath&&_.add(this.protocolMainService.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,_){const N=this.environmentMainService.args,q=_?.remoteAuthority||void 0,U=!0,$=_?.forceReuseWindow,H=!$;return this.open({...A,cli:N,forceEmpty:U,forceNewWindow:H,forceReuseWindow:$,remoteAuthority:q})}openExistingWindow(A,_){A.focus(),this.handleWaitMarkerFile(_,[A])}async open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const _=[],N=[],q=[],U=[],$=[];let H,oe=0;const fe=await this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",fe);for(const Oe of fe)se(Oe)?A.addMode?_.push(Oe):N.push(Oe):ne(Oe)?q.push(Oe):Oe.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Oe.remoteAuthority}),H.filesToOpenOrCreate.push(Oe)):Oe.backupPath?$.push({backupFolder:(0,f.basename)(Oe.backupPath),remoteAuthority:Oe.remoteAuthority}):oe++;A.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),A.mergeMode&&H&&H.filesToOpenOrCreate.length===4&&(H.filesToMerge=H.filesToOpenOrCreate.slice(0,4),H.filesToOpenOrCreate=[],H.filesToDiff=[]),H&&A.waitMarkerFileURI&&(H.filesToWait={paths:(0,M.coalesce)([...H.filesToDiff,H.filesToMerge[3],...H.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(U.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),q.push(...U),$.push(...this.backupMainService.getEmptyWindowBackups())):$.length=0;const{windows:pe,filesOpenedInWindow:ye}=await this.doOpen(A,q,N,$,oe,H,_);if(this.logService.trace(`windowsManager#open used window count ${pe.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${N.length}, emptyToRestore: ${$.length}, emptyToOpen: ${oe})`),pe.length>1)if(ye)ye.focus();else{const Oe=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ve=!0,Me=!0;if(Oe){const De=pe.filter(X=>this.windowsStateHandler.state.lastActiveWindow&&X.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);De.length&&(De[0].focus(),ve=!1,Me=!1)}if(ve)for(let De=pe.length-1;De>=0;De--){const X=pe[De];if(!(X.openedWorkspace&&U.some(ae=>X.openedWorkspace&&ae.workspace.id===X.openedWorkspace.id)||X.backupPath&&$.some(ae=>X.backupPath&&ae.backupFolder===(0,f.basename)(X.backupPath)))){X.focus(),Me=!1;break}}Me&&pe[pe.length-1].focus()}const Le=H&&H.filesToDiff.length>0,_e=H&&H.filesToMerge.length>0;if(!pe.some(Oe=>Oe.isExtensionDevelopmentHost)&&!Le&&!_e&&!A.noRecentEntry){const Oe=[];for(const ve of fe)ne(ve)&&!ve.transient?Oe.push({label:ve.label,workspace:ve.workspace,remoteAuthority:ve.remoteAuthority}):se(ve)?Oe.push({label:ve.label,folderUri:ve.workspace.uri,remoteAuthority:ve.remoteAuthority}):ve.fileUri&&Oe.push({label:ve.label,fileUri:ve.fileUri,remoteAuthority:ve.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Oe)}return this.handleWaitMarkerFile(A,pe),pe}handleWaitMarkerFile(A,_){const N=A.waitMarkerFileURI;A.context===0&&N&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch{}})()}async doOpen(A,_,N,q,U,$,H){const oe=[];let fe;function pe(De,X){oe.push(De),X&&(fe=De,$=void 0)}let{openFolderInNewWindow:ye,openFilesInNewWindow:Le}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&H.length>0){const De=H[0].remoteAuthority,X=this.getLastActiveWindowForAuthority(De);X&&pe(this.doAddFoldersToExistingWindow(X,H.map(ae=>ae.workspace.uri)))}const _e=N.length+_.length+q.length;if($&&_e===0){const De=$.filesToOpenOrCreate[0]||$.filesToDiff[0]||$.filesToMerge[3],X=this.getWindows().filter(he=>$&&(0,d.isEqualAuthority)(he.remoteAuthority,$.remoteAuthority));let ae;De?.fileUri&&!Le&&((A.context===4||A.context===0||A.context===1)&&(ae=await(0,G.findWindowOnFile)(X,De.fileUri,async he=>he.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(he.configPath):void 0)),ae||(ae=this.doGetLastActiveWindow(X))),ae?(0,re.isWorkspaceIdentifier)(ae.openedWorkspace)?_.push({workspace:ae.openedWorkspace,remoteAuthority:ae.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(ae.openedWorkspace)?N.push({workspace:ae.openedWorkspace,remoteAuthority:ae.remoteAuthority}):pe(this.doOpenFilesInExistingWindow(A,ae,$),!0):pe(await this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:$,forceNewWindow:!0,remoteAuthority:$.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Oe=(0,M.distinct)(_,De=>De.workspace.id);if(Oe.length>0){const De=(0,M.coalesce)(Oe.map(X=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),X.workspace.configPath)));if(De.length>0){const X=De[0],ae=(0,d.isEqualAuthority)($?.remoteAuthority,X.remoteAuthority)?$:void 0;pe(this.doOpenFilesInExistingWindow(A,X,ae),!!ae),ye=!0}for(const X of Oe){if(De.some(Ie=>Ie.openedWorkspace&&Ie.openedWorkspace.id===X.workspace.id))continue;const ae=X.remoteAuthority,he=(0,d.isEqualAuthority)($?.remoteAuthority,ae)?$:void 0;pe(await this.doOpenFolderOrWorkspace(A,X,ye,he),!!he),ye=!0}}const ve=(0,M.distinct)(N,De=>d.extUriBiasedIgnorePathCase.getComparisonKey(De.workspace.uri));if(ve.length>0){const De=(0,M.coalesce)(ve.map(X=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),X.workspace.uri)));if(De.length>0){const X=De[0],ae=(0,d.isEqualAuthority)($?.remoteAuthority,X.remoteAuthority)?$:void 0;pe(this.doOpenFilesInExistingWindow(A,X,ae),!!ae),ye=!0}for(const X of ve){if(De.some(Ie=>(0,re.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(Ie.openedWorkspace.uri,X.workspace.uri)))continue;const ae=X.remoteAuthority,he=(0,d.isEqualAuthority)($?.remoteAuthority,ae)?$:void 0;pe(await this.doOpenFolderOrWorkspace(A,X,ye,he),!!he),ye=!0}}const Me=(0,M.distinct)(q,De=>De.backupFolder);if(Me.length>0)for(const De of Me){const X=De.remoteAuthority,ae=(0,d.isEqualAuthority)($?.remoteAuthority,X)?$:void 0;pe(await this.doOpenEmpty(A,!0,X,ae,De),!!ae),ye=!0}if(oe.length===0||$){$&&!U&&U++;const De=$?$.remoteAuthority:A.remoteAuthority;for(let X=0;X<U;X++)pe(await this.doOpenEmpty(A,ye,De,$),!!$),ye=!0}return{windows:(0,M.distinct)(oe),filesOpenedInWindow:fe}}doOpenFilesInExistingWindow(A,_,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),_.focus();const q={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",k.CancellationToken.None,q),_}doAddFoldersToExistingWindow(A,_){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:_}),A.focus();const N={foldersToAdd:_};return A.sendWhenReady("vscode:addFolders",k.CancellationToken.None,N),A}doOpenEmpty(A,_,N,q,U){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!U,remoteAuthority:N,filesToOpen:q,forceNewWindow:_});let $;return!_&&typeof A.contextWindowId=="number"&&($=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:q,windowToUse:$,emptyWindowBackupInfo:U,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}doOpenFolderOrWorkspace(A,_,N,q,U){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:_,filesToOpen:q}),!N&&!U&&typeof A.contextWindowId=="number"&&(U=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:_.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:q,windowToUse:U,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async getPathsToOpen(A){let _,N=!1,q=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(_=await this.doExtractPathsFromAPI(A),N=!0):A.forceEmpty?_=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(_=await this.doExtractPathsFromCLI(A.cli),_.length===0&&_.push(Object.create(null)),N=!0):(_=await this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),q=!0),!A.addMode&&N){const U=_.filter($=>se($));if(U.length>1){const $=U[0].remoteAuthority;if(U.every(H=>(0,d.isEqualAuthority)(H.remoteAuthority,$))){const H=await this.workspacesManagementMainService.createUntitledWorkspace(U.map(oe=>({uri:oe.workspace.uri})));_.push({workspace:H,remoteAuthority:$}),_=_.filter(oe=>!se(oe))}}}if(A.initialStartup&&!q&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const U=await this.doGetPathsFromLastSession();_.unshift(...U.filter($=>ne($)||se($)||$.backupPath))}return _}async doExtractPathsFromAPI(A){const _={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},N=await Promise.all((0,M.coalesce)(A.urisToOpen||[]).map(async q=>{const U=await this.resolveOpenable(q,_);if(U)return U.label=q.label,U;const $=this.resourceFromOpenable(q);this.dialogMainService.showMessageBox((0,K.massageMessageBoxOptions)({type:"info",buttons:[(0,I.localize)(0,null)],message:$.scheme===S.Schemas.file?(0,I.localize)(1,null):(0,I.localize)(2,null),detail:$.scheme===S.Schemas.file?(0,I.localize)(3,null,(0,y.getPathLabel)($,{os:v.OS,tildify:this.environmentMainService})):(0,I.localize)(4,null,$.toString(!0))},this.productService).options,(0,m.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,M.coalesce)(N)}async doExtractPathsFromCLI(A){const _=[],N={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},q=A["folder-uri"];if(q){const H=await Promise.all(q.map(oe=>{const fe=this.cliArgToUri(oe);if(!!fe)return this.resolveOpenable({folderUri:fe},N)}));_.push(...(0,M.coalesce)(H))}const U=A["file-uri"];if(U){const H=await Promise.all(U.map(oe=>{const fe=this.cliArgToUri(oe);if(!!fe)return this.resolveOpenable((0,re.hasWorkspaceFileExtension)(oe)?{workspaceUri:fe}:{fileUri:fe},N)}));_.push(...(0,M.coalesce)(H))}const $=await Promise.all(A._.map(H=>N.remoteAuthority?this.doResolveRemotePath(H,N):this.doResolveFilePath(H,N)));return _.push(...(0,M.coalesce)($)),_}cliArgToUri(A){try{const _=C.URI.parse(A);if(!_.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return _}catch(_){this.logService.error(`Invalid URI input string: ${A}, ${_.message}`)}}async doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const _=[];A!=="one"&&_.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&_.push(this.windowsStateHandler.state.lastActiveWindow);const N=await Promise.all(_.map(async q=>{if(q.workspace){const U=await this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(ne(U))return U}else if(q.folderUri){const U=await this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(se(U))return U}else if(A!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,M.coalesce)(N)}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async resolveOpenable(A,_=Object.create(null)){const N=this.resourceFromOpenable(A);return N.scheme===S.Schemas.file?((0,Y.isFileToOpen)(A)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,_)):this.doResolveRemoteOpenable(A,_)}doResolveRemoteOpenable(A,_){let N=this.resourceFromOpenable(A);const q=(0,T.getRemoteAuthority)(N)||_.remoteAuthority;if(N=(0,d.removeTrailingPathSeparator)((0,d.normalizePath)(N)),(0,Y.isFileToOpen)(A)){if(_.gotoLineMode){const{path:U,line:$,column:H}=(0,g.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:U}),options:{selection:$?{startLineNumber:$,startColumn:H||1}:void 0},remoteAuthority:q}}return{fileUri:N,remoteAuthority:q}}else if((0,Y.isWorkspaceToOpen)(A))return{workspace:(0,de.getWorkspaceIdentifier)(N),remoteAuthority:q};return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:q}}resourceFromOpenable(A){return(0,Y.isWorkspaceToOpen)(A)?A.workspaceUri:(0,Y.isFolderToOpen)(A)?A.folderUri:A.fileUri}async doResolveFilePath(A,_){let N,q;_.gotoLineMode&&({path:A,line:N,column:q}=(0,g.parseLineAndColumnAware)(A)),A=(0,g.sanitizeFilePath)((0,f.normalize)(A),(0,o.cwd)());try{const U=await D.Promises.stat(A);if(U.isFile()){if(!_.forceOpenWorkspaceAsFile){const $=await this.workspacesManagementMainService.resolveLocalWorkspace(C.URI.file(A));if($)return $.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:s.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:C.URI.file(A),type:s.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:q||1}:void 0}}}else{if(U.isDirectory())return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(C.URI.file(A),U),type:s.FileType.Directory,exists:!0};if(!v.isWindows&&A==="/dev/null")return{fileUri:C.URI.file(A),type:s.FileType.File,exists:!0}}}catch{const $=C.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([$]),_.ignoreFileNotFound)return{fileUri:$,type:s.FileType.File,exists:!1}}}doResolveRemotePath(A,_){const N=A.charCodeAt(0),q=_.remoteAuthority;let U,$;_.gotoLineMode&&({path:A,line:U,column:$}=(0,g.parseLineAndColumnAware)(A)),N!==47&&((0,g.isWindowsDriveLetter)(N)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,g.toSlashes)(A)),A=`/${A}`);const H=C.URI.from({scheme:S.Schemas.vscodeRemote,authority:q,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(A))return _.forceOpenWorkspaceAsFile?{fileUri:H,options:{selection:U?{startLineNumber:U,startColumn:$||1}:void 0},remoteAuthority:_.remoteAuthority}:{workspace:(0,de.getWorkspaceIdentifier)(H),remoteAuthority:q};if(_.gotoLineMode||f.posix.basename(A).indexOf(".")!==-1)return{fileUri:H,options:{selection:U?{startLineNumber:U,startColumn:$||1}:void 0},remoteAuthority:q}}return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:q}}shouldOpenNewWindow(A){const _=this.configurationService.getValue("window"),N=_?.openFoldersInNewWindow||"default",q=_?.openFilesInNewWindow||"off";let U=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(N==="on"||N==="off")&&(U=N==="on");let $=!1;return A.forceNewWindow||A.forceReuseWindow?$=!!A.forceNewWindow&&!A.forceReuseWindow:(v.isMacintosh?A.context===1&&($=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&($=!0),!A.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&($=q==="on")),{openFolderInNewWindow:!!U,openFilesInNewWindow:$}}async openExtensionDevelopmentHostWindow(A,_){const N=(0,G.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(N)return this.lifecycleMainService.reload(N,_.cli),N.focus(),[N];let q=_.cli["folder-uri"]||[],U=_.cli["file-uri"]||[],$=_.cli._;if(!$.length&&!q.length&&!U.length&&!_.cli.extensionTestsPath){const fe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,pe=fe?.workspace??fe?.folderUri;pe&&(C.URI.isUri(pe)?pe.scheme===S.Schemas.file?$=[pe.fsPath]:q=[pe.toString()]:pe.configPath.scheme===S.Schemas.file?$=[(0,d.originalFSPath)(pe.configPath)]:U=[pe.configPath.toString()])}let H=_.remoteAuthority;for(const fe of A)if(fe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const pe=C.URI.parse(fe),ye=(0,T.getRemoteAuthority)(pe);ye&&(H?(0,d.isEqualAuthority)(ye,H)||this.logService.error("more than one extension development path authority"):H=ye)}$=$.filter(fe=>{const pe=C.URI.file(fe);return(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe)?!1:(0,d.isEqualAuthority)((0,T.getRemoteAuthority)(pe),H)}),q=q.filter(fe=>{const pe=this.cliArgToUri(fe);return pe&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe)?!1:pe?(0,d.isEqualAuthority)((0,T.getRemoteAuthority)(pe),H):!1}),U=U.filter(fe=>{const pe=this.cliArgToUri(fe);return pe&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe)?!1:pe?(0,d.isEqualAuthority)((0,T.getRemoteAuthority)(pe),H):!1}),_.cli._=$,_.cli["folder-uri"]=q,_.cli["file-uri"]=U;const oe={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:!$.length&&!q.length&&!U.length,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:H,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile};return this.open(oe)}async openInBrowserWindow(A){const _=this.configurationService.getValue("window"),N=this.getLastActiveWindow(),q=N?.profile??this.userDataProfilesMainService.defaultProfile;let U;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(U=A.windowToUse||N,U&&U.focus());const $={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,f.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:q},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsPath,product:c.default,isInitialStartup:A.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,n.release)(),hostname:(0,n.hostname)()},zoomLevel:typeof _?.zoomLevel=="number"?_.zoomLevel:void 0,autoDetectHighContrast:_?.autoDetectHighContrast??!0,autoDetectColorScheme:_?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(U){const H=U.config;!$.extensionDevelopmentPath&&H?.extensionDevelopmentPath&&($.extensionDevelopmentPath=H.extensionDevelopmentPath,$.extensionDevelopmentKind=H.extensionDevelopmentKind,$["enable-proposed-api"]=H["enable-proposed-api"],$.verbose=H.verbose,$["inspect-extensions"]=H["inspect-extensions"],$["inspect-brk-extensions"]=H["inspect-brk-extensions"],$.debugId=H.debugId,$.extensionEnvironment=H.extensionEnvironment,$["extensions-dir"]=H["extensions-dir"],$["disable-extensions"]=H["disable-extensions"]),$.loggers=H?.loggers??$.loggers}else{const H=this.windowsStateHandler.getNewWindowState($);(0,p.mark)("code/willCreateCodeWindow");const oe=U=this.instantiationService.createInstance(V.CodeWindow,{state:H,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(oe),lt.WINDOWS.push(oe),this._onDidOpenWindow.fire(oe),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,h.once)(oe.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(oe)),(0,h.once)(oe.onDidClose)(()=>this.onWindowClosed(oe)),(0,h.once)(oe.onDidDestroy)(()=>this._onDidDestroyWindow.fire(oe)),oe.onDidTriggerSystemContextMenu(({x:pe,y:ye})=>this._onDidTriggerSystemContextMenu.fire({window:oe,x:pe,y:ye}));const fe=(0,m.assertIsDefined)(oe.win?.webContents);fe.removeAllListeners("devtools-reload-page"),fe.on("devtools-reload-page",()=>this.lifecycleMainService.reload(oe)),this.lifecycleMainService.registerWindow(oe)}return $.windowId=U.id,U.isReady?this.lifecycleMainService.unload(U,4).then(async H=>{H||await this.doOpenInBrowserWindow(U,$,A,q)}):await this.doOpenInBrowserWindow(U,$,A,q),U}async doOpenInBrowserWindow(A,_,N,q){if(_.extensionDevelopmentPath||((0,re.isWorkspaceIdentifier)(_.workspace)?_.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:_.workspace,remoteAuthority:_.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(_.workspace)?_.backupPath=this.backupMainService.registerFolderBackup({folderUri:_.workspace.uri,remoteAuthority:_.remoteAuthority}):_.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:N.emptyWindowBackupInfo?.backupFolder??(0,de.createEmptyWorkspaceIdentifier)().id,remoteAuthority:_.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const U=_.workspace??(0,re.toWorkspaceIdentifier)(_.backupPath,!1),$=this.resolveProfileForBrowserWindow(N,U,q),H=$ instanceof Promise?await $:$;_.profiles.profile=H,_.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(U,H)}A.load(_)}resolveProfileForBrowserWindow(A,_,N){return A.forceProfile?this.userDataProfilesMainService.profiles.find(q=>q.name===A.forceProfile)??this.userDataProfilesMainService.createNamedProfile(A.forceProfile):A.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(_)??N}onWindowClosed(A){const _=lt.WINDOWS.indexOf(A);lt.WINDOWS.splice(_,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=E.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(_=>(0,d.isEqualAuthority)(_.remoteAuthority,A)))}doGetLastActiveWindow(A){const _=Math.max.apply(Math,A.map(N=>N.lastFocusTime));return A.find(N=>N.lastFocusTime===_)}sendToFocused(A,..._){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,k.CancellationToken.None,..._)}sendToAll(A,_,N){for(const q of this.getWindows())N&&N.indexOf(q.id)>=0||q.sendWhenReady(A,k.CancellationToken.None,_)}getWindows(){return lt.WINDOWS}getWindowCount(){return lt.WINDOWS.length}getWindowById(A){const _=this.getWindows().filter(N=>N.id===A);return(0,M.firstOrDefault)(_)}getWindowByWebContents(A){const _=E.BrowserWindow.fromWebContents(A);if(!!_)return this.getWindowById(_.id)}};J.WINDOWS=[],J=we([Z(2,r.ILogService),Z(3,z.ILoggerMainService),Z(4,F.IStateMainService),Z(5,B.IPolicyService),Z(6,i.IEnvironmentMainService),Z(7,O.IUserDataProfilesMainService),Z(8,u.ILifecycleMainService),Z(9,R.IBackupMainService),Z(10,t.IConfigurationService),Z(11,ce.IWorkspacesHistoryMainService),Z(12,ge.IWorkspacesManagementMainService),Z(13,l.IInstantiationService),Z(14,a.IDialogMainService),Z(15,s.IFileService),Z(16,b.IProductService),Z(17,L.IProtocolMainService),Z(18,x.IThemeMainService)],J),e.WindowsMainService=J}),define(ee[283],te([0,1,63,30,78,54]),function(j,e,E,D,n,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(g,h,y,w){this.workspacesManagementMainService=g,this.windowsMainService=h,this.workspacesHistoryMainService=y,this.backupMainService=w,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(g,h){const y=this.windowsMainService.getWindowById(g);if(y)return this.workspacesManagementMainService.enterWorkspace(y,this.windowsMainService.getWindows(),h)}createUntitledWorkspace(g,h,y){return this.workspacesManagementMainService.createUntitledWorkspace(h,y)}deleteUntitledWorkspace(g,h){return this.workspacesManagementMainService.deleteUntitledWorkspace(h)}getWorkspaceIdentifier(g,h){return this.workspacesManagementMainService.getWorkspaceIdentifier(h)}getRecentlyOpened(g){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(g,h){return this.workspacesHistoryMainService.addRecentlyOpened(h)}removeRecentlyOpened(g,h){return this.workspacesHistoryMainService.removeRecentlyOpened(h)}clearRecentlyOpened(g){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=we([Z(0,M.IWorkspacesManagementMainService),Z(1,D.IWindowsMainService),Z(2,n.IWorkspacesHistoryMainService),Z(3,E.IBackupMainService)],k),e.WorkspacesMainService=k}),define(ee[284],te([0,1,15,42,26,17,44,13,32,50,43,45,2,14,9,4,10,7,31,138,47,152,106,257,155,63,275,19,74,188,88,123,58,110,210,28,62,114,200,223,201,262,111,202,203,16,214,90,73,6,89,276,236,259,21,5,281,59,20,56,269,92,34,265,96,93,24,241,116,52,49,248,249,277,250,278,119,252,253,254,255,263,30,282,264,29,97,78,283,54,258,37,222,53,232,57,77,121,267,273,271,8,117,266,217,65,48]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t,a,i,s,l,u,r,c,b,L,T,F,Y,V,G,ie,re,de,ce,ge,x,B,O,z,K,ne,se,J,W,A,_,N,q,U,$,H,oe,fe,pe,ye,Le,_e,Oe,ve,Me,De,X,ae,he,Ie,Re,Ae,We,qe,Ue,$e,Ve,Fe,je,Q,le,ue,me,be,Te,ze,tt,Xe,Ke,et,it,ot,ut,kt,Mt,Dt,Rt,Lt,At,mt,Tt,Ot,_t,Wt,Ft){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends S.Disposable{constructor(Ce,Pe,Se,Ee,ke,Ne,Ge,Qe,He,Be,xe){super(),this.mainProcessNodeIpcServer=Ce,this.userEnv=Pe,this.mainInstantiationService=Se,this.logService=Ee,this.environmentMainService=ke,this.lifecycleMainService=Ne,this.configurationService=Ge,this.stateMainService=Qe,this.fileService=He,this.productService=Be,this.userDataProfilesMainService=xe,this.configureSession(),this.registerListeners()}configureSession(){const Ce=He=>He?.startsWith(`${f.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((He,Be,xe,Ye)=>Ce(Ye.requestingUrl)?xe(Pe.has(Be)):xe(!1)),E.session.defaultSession.setPermissionCheckHandler((He,Be,xe,Ye)=>Ce(Ye.requestingUrl)?Pe.has(Be):!1);const Se=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Ee=He=>{for(let Be=He;Be;Be=Be.parent)if(Be.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},ke=He=>He.resourceType==="xhr"||Ee(He.frame),Ne=He=>{const Be=He.frame;if(!Be||!this.windowsMainService)return!1;const xe=E.BrowserWindow.getAllWindows();for(const Ye of xe)if(Be.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Ge=(He,Be)=>{if(He.path!=="/index.html")return!0;const xe=Be.frame;if(!xe||!this.windowsMainService)return!1;for(const Ye of this.windowsMainService.getWindows())if(Ye.win&&xe.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((He,Be)=>{const xe=d.URI.parse(He.url);return xe.scheme===f.Schemas.vscodeWebview&&!Ge(xe,He)?(this.logService.error("Blocked vscode-webview request",He.url),Be({cancel:!0})):xe.scheme===f.Schemas.vscodeFileResource&&!Ne(He)?(this.logService.error("Blocked vscode-file request",He.url),Be({cancel:!0})):xe.path.endsWith(".svg")&&!Se.has(xe.scheme)?Be({cancel:!ke(He)}):Be({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((He,Be)=>{const xe=He.responseHeaders,Ye=xe["content-type"]||xe["Content-Type"];if(Ye&&Array.isArray(Ye)){const Je=d.URI.parse(He.url);if(Je.path.endsWith(".svg")&&Se.has(Je.scheme))return xe["Content-Type"]=["image/svg+xml"],Be({cancel:!1,responseHeaders:xe});if(!Je.path.endsWith(f.Schemas.vscodeRemoteResource)&&Ye.some(st=>st.toLowerCase().includes("image/svg")))return Be({cancel:!ke(He)})}return Be({cancel:!1})});const Qe=E.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Qe.setCodeCachePath((0,p.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,P.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,P.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,P.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,C.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Se,Ee)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),E.app.on("activate",async(Se,Ee)=>{this.logService.trace("app#activate"),Ee||await this.windowsMainService?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Se,Ee)=>{Ee.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Ee.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let Ce=[],Pe;E.app.on("open-file",(Se,Ee)=>{this.logService.trace("app#open-file: ",Ee),Se.preventDefault(),Ce.push((0,be.hasWorkspaceFileExtension)(Ee)?{workspaceUri:d.URI.file(Ee)}:{fileUri:d.URI.file(Ee)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],Pe=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),D.validatedIpcMain.handle("vscode:fetchShellEnv",Se=>{const Ee=this.windowsMainService?.getWindowByWebContents(Se.sender);let ke,Ne;return Ee?.config?(ke=Ee.config,Ne={...process.env,...Ee.config.userEnv}):(ke=this.environmentMainService.args,Ne=process.env),this.resolveShellEnvironment(ke,Ne,!1)}),D.validatedIpcMain.handle("vscode:writeNlsFile",(Se,Ee,ke)=>{const Ne=this.validateNlsPath([Ee]);if(!Ne||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ne,M.VSBuffer.fromString(ke))}),D.validatedIpcMain.handle("vscode:readNlsFile",async(Se,...Ee)=>{const ke=this.validateNlsPath(Ee);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),D.validatedIpcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),D.validatedIpcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),D.validatedIpcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(Ce){let Pe;for(const Se of Ce)typeof Se=="string"&&(typeof Pe!="string"?Pe=Se:Pe=(0,p.join)(Pe,Se));if(!(typeof Pe!="string"||!(0,p.isAbsolute)(Pe)||!(0,g.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!v.isLinux)))return d.URI.file(Pe)}onUnexpectedError(Ce){if(Ce){const Pe={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.logService.error(Ce.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ce=this.productService.win32AppUserModelId;v.isWindows&&Ce&&E.app.setAppUserModelId(Ce);try{v.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Be){this.logService.error(Be)}const Pe=new R.Server;this.lifecycleMainService.onWillShutdown(Be=>{Be.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Se=await(0,Tt.resolveMachineId)(this.stateMainService);this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:Ee,sharedProcessReady:ke,sharedProcessClient:Ne}=this.setupSharedProcess(Se),Ge=await this.initServices(Se,Ee,ke);this._register(Ge.createInstance(a.ProxyAuthHandler)),this._register(Ge.createInstance(Lt.UserDataProfilesHandler)),Ge.invokeFunction(Be=>this.initChannels(Be,Pe,Ne));const Qe=Ge.invokeFunction(Be=>this.setupProtocolUrlHandlers(Be,Pe));this.lifecycleMainService.phase=2,await Ge.invokeFunction(Be=>this.openFirstWindow(Be,Qe)),this.lifecycleMainService.phase=3,Ge.invokeFunction(Be=>this.afterWindowOpen(Be,Ee)),this._register(new mt.RunOnceScheduler(()=>{this._register((0,mt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setupProtocolUrlHandlers(Ce,Pe){const Se=this.windowsMainService=Ce.get(le.IWindowsMainService),Ee=Ce.get(Ue.IURLService),ke=this.nativeHostMainService=Ce.get(H.INativeHostMainService),Ne=this;Ee.registerHandler({async handleURL(Ye,Je){return Ne.handleProtocolUrl(Se,Ee,Ye,Je)}});const Ge=this._register(new me.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Qe=new I.StaticRouter(Ye=>Ge.getActiveClientId().then(Je=>Ye===Je)),He=new $e.URLHandlerRouter(Qe,this.logService),Be=Pe.getChannel("urlHandler",He);Ee.registerHandler(new $e.URLHandlerChannelClient(Be));const xe=this.resolveInitialProtocolUrls();return this._register(new Fe.ElectronURLListener(xe?.urls,Ee,Se,this.environmentMainService,this.productService,this.logService)),xe}resolveInitialProtocolUrls(){const Ce=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Ce.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),Ce.length+Pe.length===0)return;const Se=[];return{urls:[...Ce,...Pe].map(ke=>{try{return{uri:d.URI.parse(ke),originalUrl:ke}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",ke);return}}).filter(ke=>{if(!ke)return!1;if(this.shouldBlockURI(ke.uri))return this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",ke.uri.toString(!0)),!1;const Ne=this.getWindowOpenableFromProtocolUrl(ke.uri);return Ne?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",ke.uri.toString(!0),Ne),Se.push(Ne),!1):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",ke.uri.toString(!0)),!0)}),openables:Se}}shouldBlockURI(Ce){if(Ce.authority===f.Schemas.file&&v.isWindows){const{options:Pe,buttonIndeces:Se}=(0,Ft.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,w.getPathLabel)(Ce,{os:v.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,i.localize)(3,null)},this.productService);if(Se[E.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}getWindowOpenableFromProtocolUrl(Ce){if(!!Ce.path){if(Ce.authority===f.Schemas.file){const Pe=d.URI.file(Ce.fsPath);return(0,be.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ce.authority===f.Schemas.vscodeRemote){const Pe=Ce.path.indexOf(p.posix.sep,1);if(Pe!==-1){const Se=Ce.path.substring(1,Pe),Ee=Ce.path.substring(Pe),ke=d.URI.from({scheme:f.Schemas.vscodeRemote,authority:Se,path:Ee,query:Ce.query,fragment:Ce.fragment});return(0,be.hasWorkspaceFileExtension)(Ee)?{workspaceUri:ke}:/:[\d]+$/.test(Ee)?{fileUri:ke}:{folderUri:ke}}}}}async handleProtocolUrl(Ce,Pe,Se,Ee){if(this.logService.trace("app#handleProtocolUrl():",Se.toString(!0),Ee),Se.scheme===this.productService.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:d.URI.parse(Se.query).path,query:""})),this.shouldBlockURI(Se))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0;let ke=!1;const Ne=new URLSearchParams(Se.query);Ne.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Ne.delete("windowId"),Se=Se.with({query:Ne.toString()}),ke=!0):v.isMacintosh&&Ce.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),ke=!0);const Ge=Ne.get("continueOn");Ge!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),Ne.delete("continueOn"),Se=Se.with({query:Ne.toString()}),this.environmentMainService.continueOn=Ge??void 0);const Qe=this.getWindowOpenableFromProtocolUrl(Se);if(Qe){this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,Se.toString(!0));const[He]=await Ce.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Qe],forceNewWindow:ke,gotoLineMode:!0});return He.focus(),!0}if(ke){this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0));const[He]=await Ce.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.getRemoteAuthority)(Se)});return await He.ready(),Pe.open(Se,Ee)}return this.logService.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Ee),!1}setupSharedProcess(Ce){const Pe=this._register(this.mainInstantiationService.createInstance(pe.SharedProcess,Ce,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new t.Client(ke,"main")})(),Ee=(async()=>(await Pe.whenReady(),Se))();return{sharedProcess:Pe,sharedProcessReady:Ee,sharedProcessClient:Se}}async initServices(Ce,Pe,Se){const Ee=new W.ServiceCollection;switch(process.platform){case"win32":Ee.set(he.IUpdateService,new se.SyncDescriptor(qe.Win32UpdateService));break;case"linux":v.isLinuxSnap?Ee.set(he.IUpdateService,new se.SyncDescriptor(We.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(he.IUpdateService,new se.SyncDescriptor(Ae.LinuxUpdateService));break;case"darwin":Ee.set(he.IUpdateService,new se.SyncDescriptor(Re.DarwinUpdateService));break}Ee.set(le.IWindowsMainService,new se.SyncDescriptor(ue.WindowsMainService,[Ce,this.userEnv],!1));const ke=new T.DialogMainService(this.logService);Ee.set(T.IDialogMainService,ke),Ee.set(N.ILaunchMainService,new se.SyncDescriptor(N.LaunchMainService,void 0,!1)),Ee.set(L.IDiagnosticsMainService,new se.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ee.set(b.IDiagnosticsService,I.ProxyChannel.toService((0,I.getDelayedChannel)(Se.then(Qe=>Qe.getChannel("diagnostics"))))),Ee.set(A.IIssueMainService,new se.SyncDescriptor(A.IssueMainService,[this.userEnv])),Ee.set(F.IEncryptionMainService,new se.SyncDescriptor(Y.EncryptionMainService,[Ce])),Ee.set(_.IKeyboardLayoutMainService,new se.SyncDescriptor(_.KeyboardLayoutMainService)),Ee.set(H.INativeHostMainService,new se.SyncDescriptor(H.NativeHostMainService,[Pe],!1)),Ee.set(r.ICredentialsMainService,new se.SyncDescriptor(Ke.CredentialsNativeMainService)),Ee.set(je.IWebviewManagerService,new se.SyncDescriptor(Q.WebviewMainService)),Ee.set($.IMenubarMainService,new se.SyncDescriptor($.MenubarMainService)),Ee.set(re.IExtensionUrlTrustService,new se.SyncDescriptor(de.ExtensionUrlTrustService)),Ee.set(ce.IExtensionHostStarter,new se.SyncDescriptor(ge.ExtensionHostStarter)),Ee.set(Oe.IStorageMainService,new se.SyncDescriptor(Oe.StorageMainService)),Ee.set(Oe.IApplicationStorageMainService,new se.SyncDescriptor(Oe.ApplicationStorageMainService)),v.isWindows?Ee.set(x.IExternalTerminalMainService,new se.SyncDescriptor(B.WindowsExternalTerminalService)):v.isMacintosh?Ee.set(x.IExternalTerminalMainService,new se.SyncDescriptor(B.MacExternalTerminalService)):v.isLinux&&Ee.set(x.IExternalTerminalMainService,new se.SyncDescriptor(B.LinuxExternalTerminalService));const Ne=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ee.set(s.IBackupMainService,Ne);const Ge=new Xe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ne,ke,this.productService);if(Ee.set(Xe.IWorkspacesManagementMainService,Ge),Ee.set(Te.IWorkspacesService,new se.SyncDescriptor(tt.WorkspacesMainService,void 0,!1)),Ee.set(ze.IWorkspacesHistoryMainService,new se.SyncDescriptor(ze.WorkspacesHistoryMainService,void 0,!1)),Ee.set(Ue.IURLService,new se.SyncDescriptor(Ve.NativeURLService,void 0,!1)),(0,ae.supportsTelemetry)(this.productService,this.environmentMainService)){const Qe=(0,ae.isInternalTelemetry)(this.productService,this.configurationService),He=(0,I.getDelayedChannel)(Se.then(st=>st.getChannel("telemetryAppender"))),Be=new De.TelemetryAppenderClient(He),xe=(0,ve.resolveCommonProperties)(this.fileService,(0,n.release)(),(0,n.hostname)(),process.arch,this.productService.commit,this.productService.version,Ce,Qe,this.environmentMainService.installSourcePath),Ye=(0,ae.getPiiPathsFromEnvironment)(this.environmentMainService),Je={appenders:[Be],commonProperties:xe,piiPaths:Ye,sendErrorTelemetry:!0};Ee.set(Me.ITelemetryService,new se.SyncDescriptor(X.TelemetryService,[Je],!1))}else Ee.set(Me.ITelemetryService,ae.NullTelemetryService);return Ee.set(Mt.IExtensionsProfileScannerService,new se.SyncDescriptor(Ot.ExtensionsProfileScannerService,void 0,!0)),Ee.set(Dt.IExtensionsScannerService,new se.SyncDescriptor(Rt.ExtensionsScannerService,void 0,!0)),await mt.Promises.settled([Ne.initialize(),Ge.initialize()]),this.mainInstantiationService.createChild(Ee)}initChannels(Ce,Pe,Se){const Ee=I.ProxyChannel.fromService(Ce.get(N.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ee);const ke=I.ProxyChannel.fromService(Ce.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",ke);const Ne=new it.PolicyChannel(Ce.get(et.IPolicyService));Pe.registerChannel("policy",Ne),Se.then(Ze=>Ze.registerChannel("policy",Ne));const Ge=this.fileService.getProvider(f.Schemas.file);(0,o.assertType)(Ge instanceof ne.DiskFileSystemProvider);const Qe=new K.DiskFileSystemProviderChannel(Ge,this.logService,this.environmentMainService);Pe.registerChannel(O.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),Se.then(Ze=>Ze.registerChannel(O.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const He=I.ProxyChannel.fromService(Ce.get(ot.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",He),Se.then(Ze=>Ze.registerChannel("userDataProfiles",He));const Be=new ut.RequestChannel(Ce.get(kt.IRequestService));Se.then(Ze=>Ze.registerChannel("request",Be));const xe=new Ie.UpdateChannel(Ce.get(he.IUpdateService));Pe.registerChannel("update",xe);const Ye=I.ProxyChannel.fromService(Ce.get(A.IIssueMainService));Pe.registerChannel("issue",Ye);const Je=I.ProxyChannel.fromService(Ce.get(F.IEncryptionMainService));Pe.registerChannel("encryption",Je);const st=I.ProxyChannel.fromService(Ce.get(r.ICredentialsMainService));Pe.registerChannel("credentials",st);const rt=I.ProxyChannel.fromService(Ce.get(ye.ISignService));Pe.registerChannel("sign",rt);const dt=I.ProxyChannel.fromService(Ce.get(_.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",dt),this.nativeHostMainService=Ce.get(H.INativeHostMainService);const yt=I.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",yt),Se.then(Ze=>Ze.registerChannel("nativeHost",yt));const Ut=I.ProxyChannel.fromService(Ce.get(Te.IWorkspacesService));Pe.registerChannel("workspaces",Ut);const Nt=I.ProxyChannel.fromService(Ce.get($.IMenubarMainService));Pe.registerChannel("menubar",Nt);const Bt=I.ProxyChannel.fromService(Ce.get(Ue.IURLService));Pe.registerChannel("url",Bt);const $t=I.ProxyChannel.fromService(Ce.get(re.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",$t);const zt=I.ProxyChannel.fromService(Ce.get(je.IWebviewManagerService));Pe.registerChannel("webview",zt);const bt=this._register(new _e.StorageDatabaseChannel(this.logService,Ce.get(Oe.IStorageMainService)));Pe.registerChannel("storage",bt),Se.then(Ze=>Ze.registerChannel("storage",bt));const Ht=this._register(new At.ProfileStorageChangesListenerChannel(Ce.get(Oe.IStorageMainService),Ce.get(ot.IUserDataProfilesMainService),this.logService));Se.then(Ze=>Ze.registerChannel("profileStorageListener",Ht));const qt=I.ProxyChannel.fromService(Ce.get(x.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",qt);const Et=new _t.LoggerChannel(Ce.get(Wt.ILoggerMainService));Pe.registerChannel("logger",Et),Se.then(Ze=>Ze.registerChannel("logger",Et));const jt=new c.ElectronExtensionHostDebugBroadcastChannel(Ce.get(le.IWindowsMainService));Pe.registerChannel("extensionhostdebugservice",jt);const xt=I.ProxyChannel.fromService(Ce.get(ce.IExtensionHostStarter));Pe.registerChannel(ce.ipcExtensionHostStarterChannelName,xt)}async openFirstWindow(Ce,Pe){const Se=this.windowsMainService=Ce.get(le.IWindowsMainService),Ee=(0,G.isLaunchedFromCli)(process.env)?0:4,ke=this.environmentMainService.args;if(Pe){if(Pe.openables.length>0)return Se.open({context:Ee,cli:ke,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const rt of Pe.urls){const dt=new URLSearchParams(rt.uri.query);if(dt.get("windowId")==="_blank")return dt.delete("windowId"),rt.originalUrl=rt.uri.toString(!0),rt.uri=rt.uri.with({query:dt.toString()}),Se.open({context:Ee,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,Ge=ke._.length,Qe=!!ke["folder-uri"],He=!!ke["file-uri"],Be=ke["skip-add-to-recently-opened"]===!0,xe=ke.wait&&ke.waitMarkerFilePath?d.URI.file(ke.waitMarkerFilePath):void 0,Ye=ke.remote||void 0,Je=ke.profile,st=ke["profile-temp"];if(!Ge&&!Qe&&!He){if(ke["new-window"]||Je||st)return Se.open({context:Ee,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Be,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Ye,forceProfile:Je,forceTempProfile:st});if(Ne.length)return Se.open({context:1,cli:ke,urisToOpen:Ne.map(rt=>(0,be.hasWorkspaceFileExtension)(rt)?{workspaceUri:d.URI.file(rt)}:{fileUri:d.URI.file(rt)}),noRecentEntry:Be,waitMarkerFileURI:xe,initialStartup:!0})}return Se.open({context:Ee,cli:ke,forceNewWindow:ke["new-window"]||!Ge&&ke["unity-launch"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:Be,waitMarkerFileURI:xe,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:Je,forceTempProfile:st})}afterWindowOpen(Ce,Pe){const Se=Ce.get(Me.ITelemetryService),Ee=Ce.get(he.IUpdateService);this.handleSharedProcessErrors(Se,Pe),this.installMutex(),E.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(ke,Ne)=>{Ne({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),(Ee instanceof qe.Win32UpdateService||Ee instanceof Ae.LinuxUpdateService||Ee instanceof Re.DarwinUpdateService)&&Ee.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const Ce=this.productService.win32MutexName;if(v.isWindows&&Ce)try{const Pe=await new Promise((Ee,ke)=>{j(["windows-mutex"],Ee,ke)}),Se=new Pe.Mutex(Ce);(0,h.once)(this.lifecycleMainService.onWillShutdown)(()=>Se.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(Ce,Pe){let Se=!1;(0,h.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0),this._register(Pe.onDidError(({type:Ee,details:ke})=>{let Ne;switch(Ee){case 1:Ne="SharedProcess: detected unresponsive window";break;case 2:Ne=`SharedProcess: renderer process gone (detail: ${ke?.reason??"<unknown>"}, code: ${ke?.exitCode??"<unknown>"})`;break;case 3:Ne=`SharedProcess: failed to load (detail: ${ke?.reason??"<unknown>"}, code: ${ke?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(Ne)),Ce.publicLog2("sharedprocesserror",{type:Ee,reason:ke?.reason,code:ke?.exitCode,visible:Pe.isVisible(),shuttingdown:Se})}))}async resolveShellEnvironment(Ce,Pe,Se){try{return await(0,ie.getResolvedShellEnv)(this.configurationService,this.logService,Ce,Pe)}catch(Ee){const ke=(0,k.toErrorMessage)(Ee);Se?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Se=JSON.parse((0,y.stripComments)(Pe)),ke=(0,ae.getTelemetryLevel)(this.configurationService)>=1;if(Se["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,m.generateUuid)()}"`,"}"],Ge=Pe.substring(0,Pe.length-2).concat(`,
`,Ne.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ge))}else{const Ne=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);Ne!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ne))}}catch(Ce){this.logService.error(Ce)}}};pt=we([Z(2,J.IInstantiationService),Z(3,U.ILogService),Z(4,V.IEnvironmentMainService),Z(5,q.ILifecycleMainService),Z(6,u.IConfigurationService),Z(7,Le.IStateMainService),Z(8,z.IFileService),Z(9,oe.IProductService),Z(10,ot.IUserDataProfilesMainService)],pt),e.CodeApplication=pt}),define(ee[285],te([0,1,37,8,292,2,5]),function(j,e,E,D,n,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends E.AbstractPolicyService{constructor(h,y){super(),this.logService=h,this.productName=y,this.throttler=new D.Throttler,this.watcher=this._register(new M.MutableDisposable)}async _updatePolicyDefinitions(h){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`),await this.throttler.queue(()=>new Promise((y,w)=>{try{this.watcher.value=(0,n.createWatcher)(this.productName,h,S=>{this._onDidPolicyChange(S),y()})}catch(S){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",S),w(S)}}))}_onDidPolicyChange(h){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const y in h){const w=h[y];w===void 0?this.policies.delete(y):this.policies.set(y,w)}this._onDidChange.fire(Object.keys(h))}};P=we([Z(0,k.ILogService)],P),e.NativePolicyService=P}),define(ee[286],te([0,1,234,8,17,13,2,10,19,33,114,5,233,293]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends k.Disposable{constructor(o,d,m){super(),this.configurationService=o,this.environmentService=d,this.logService=m,this.configure(),this._register(o.onDidChangeConfiguration(C=>{C.affectsConfiguration("http")&&this.configure()}))}configure(){const o=this.configurationService.getValue("http");this.proxyUrl=o?.proxy,this.strictSSL=!!o?.proxyStrictSSL,this.authorization=o?.proxyAuthorization}async request(o,d){this.logService.trace("RequestService#request (node) - begin",o.url);const{proxyUrl:m,strictSSL:C}=this;let I;try{I=await(0,y.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(a){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",a))}const R={...process.env,...I},t=o.agent?o.agent:await(0,S.getProxyAgent)(o.url||"",R,{proxyUrl:m,strictSSL:C});o.agent=t,o.strictSSL=C,this.authorization&&(o.headers={...o.headers||{},"Proxy-Authorization":this.authorization});try{const a=await this._request(o,d);return this.logService.trace("RequestService#request (node) - success",o.url),a}catch(a){throw this.logService.trace("RequestService#request (node) - error",o.url,a),a}}async getNodeRequest(o){return((0,E.parse)(o.url).protocol==="https:"?await new Promise((C,I)=>{j(["https"],C,I)}):await new Promise((C,I)=>{j(["http"],C,I)})).request}_request(o,d){return D.Promises.withAsyncBody(async(m,C)=>{const I=(0,E.parse)(o.url),R=o.getRawRequest?o.getRawRequest(o):await this.getNodeRequest(o),t={hostname:I.hostname,port:I.port?parseInt(I.port):I.protocol==="https:"?443:80,protocol:I.protocol,path:I.path,method:o.type||"GET",headers:o.headers,agent:o.agent,rejectUnauthorized:(0,P.isBoolean)(o.strictSSL)?o.strictSSL:!0};o.user&&o.password&&(t.auth=o.user+":"+o.password);const a=R(t,i=>{const s=(0,P.isNumber)(o.followRedirects)?o.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this._request({...o,url:i.headers.location,followRedirects:s-1},d).then(m,C);else{let l=i;!o.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,f.createGunzip)())),m({res:i,stream:(0,n.streamToBufferReadableStream)(l)})}});a.on("error",C),o.timeout&&a.setTimeout(o.timeout),o.isChromiumNetwork&&a.removeHeader("Content-Length"),o.data&&typeof o.data=="string"&&a.write(o.data),a.end(),d.onCancellationRequested(()=>{a.abort(),C(new M.CancellationError)})})}async resolveProxy(o){}};p=we([Z(0,g.IConfigurationService),Z(1,h.INativeEnvironmentService),Z(2,w.ILogService)],p),e.RequestService=p}),define(ee[287],te([0,1,15,286]),function(j,e,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(k){return E.net.request}class M extends D.RequestService{request(P,g){return super.request({...P||{},getRawRequest:n,isChromiumNetwork:!0},g)}}e.RequestMainService=M}),define(ee[294],te([0,1,15,41,7,25,8,44,13,32,50,45,14,9,64,4,36,27,23,47,87,284,11,19,227,240,28,62,191,16,212,90,73,208,89,21,215,5,66,20,67,268,118,246,57,287,92,235,34,239,52,69,53,37,285,221,2,38,251,65,216,48,247]),function(j,e,E,D,n,M,k,P,g,h,y,w,S,f,p,v,o,d,m,C,I,R,t,a,i,s,l,u,r,c,b,L,T,F,Y,V,G,ie,re,de,ce,ge,x,B,O,z,K,ne,se,J,W,A,_,N,q,U,$,H,oe,fe,pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Le{main(){try{this.startup()}catch(ve){console.error(ve.message),E.app.exit(1)}}async startup(){(0,g.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[ve,Me,De,X,ae,he,Ie,Re]=this.createServices();try{try{await this.initServices(De,Re,X,ae,Ie)}catch(Ae){throw this.handleStartupDataDirError(De,Ie,Ae),Ae}await ve.invokeFunction(async Ae=>{const We=Ae.get(ie.ILogService),qe=Ae.get(V.ILifecycleMainService),Ue=Ae.get(c.IFileService),$e=Ae.get(ie.ILoggerService),Ve=await this.claimInstance(We,De,qe,ve,Ie,!0);return m.Promises.writeFile(De.mainLockfile,String(process.pid)).catch(Fe=>{We.warn(`Error writing main lockfile: ${Fe.stack}`)}),he.logger=$e.createLogger(n.URI.file((0,f.join)(De.logsPath,"main.log")),{id:"mainLog",name:(0,t.localize)(0,null)}),(0,y.once)(qe.onWillShutdown)(Fe=>{Ue.dispose(),X.dispose(),Fe.join(m.Promises.unlink(De.mainLockfile).catch(()=>{}))}),ve.createInstance(R.CodeApplication,Ve,Me).startup()})}catch(Ae){ve.invokeFunction(this.quit,Ae)}}createServices(){const ve=new Y.ServiceCollection,Me=new $.DisposableStore;process.once("exit",()=>Me.dispose());const De={_serviceBrand:void 0,...re.default};ve.set(de.IProductService,De);const X=new l.EnvironmentMainService(this.resolveArgs(),De),ae=this.patchEnvironment(X);ve.set(l.IEnvironmentMainService,X);const he=new fe.LoggerMainService((0,ie.getLogLevel)(X));ve.set(fe.ILoggerMainService,he);const Ie=new G.BufferLogger(he.getLogLevel()),Re=Me.add(new pe.LogService(Ie,[new ie.ConsoleMainLogger(he.getLogLevel())]));ve.set(ie.ILogService,Re);const Ae=new b.FileService(Re);ve.set(c.IFileService,Ae);const We=new L.DiskFileSystemProvider(Re);Ae.registerProvider(S.Schemas.file,We);const qe=new oe.UriIdentityService(Ae);ve.set(H.IUriIdentityService,qe);const Ue=new J.StateMainService(X,Re,Ae);ve.set(se.IStateMainService,Ue);const $e=new _.UserDataProfilesMainService(Ue,qe,X,Ae,Re);ve.set(_.IUserDataProfilesMainService,$e);const Ve=v.isWindows&&De.win32RegValueName?Me.add(new q.NativePolicyService(Re,De.win32RegValueName)):X.policyFile?Me.add(new U.FilePolicyService(X.policyFile,Ae,Re)):new N.NullPolicyService;ve.set(N.IPolicyService,Ve);const Fe=new i.ConfigurationService($e.defaultProfile.settingsResource,Ae,Ve,Re);return ve.set(a.IConfigurationService,Fe),ve.set(V.ILifecycleMainService,new T.SyncDescriptor(V.LifecycleMainService,void 0,!1)),ve.set(O.IRequestService,new T.SyncDescriptor(z.RequestMainService,void 0,!0)),ve.set(A.IThemeMainService,new T.SyncDescriptor(A.ThemeMainService)),ve.set(K.ISignService,new T.SyncDescriptor(ne.SignService,void 0,!1)),ve.set(x.ITunnelService,new T.SyncDescriptor(B.TunnelService)),ve.set(ce.IProtocolMainService,new ge.ProtocolMainService(X,$e,Re)),[new F.InstantiationService(ve,!0),ae,X,Fe,Ue,Ie,De,$e]}patchEnvironment(ve){const Me={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(De=>{const X=process.env[De];typeof X=="string"&&(Me[De]=X)}),Object.assign(process.env,Me),Me}async initServices(ve,Me,De,X,ae){await k.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,Me.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(he=>he?m.Promises.mkdir(he,{recursive:!0}):void 0)),X.init(),De.initialize()]),Me.init()}async claimInstance(ve,Me,De,X,ae,he){let Ie;try{(0,p.mark)("code/willStartMainServer"),Ie=await(0,I.serve)(Me.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,y.once)(De.onWillShutdown)(()=>Ie.dispose())}catch(Re){if(Re.code!=="EADDRINUSE")throw this.handleStartupDataDirError(Me,ae,Re),Re;let Ae;try{Ae=await(0,I.connect)(Me.mainIPCHandle,"main")}catch($e){if(!he||v.isWindows||$e.code!=="ECONNREFUSED")throw $e.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,ae.nameShort),(0,t.localize)(2,null),ae),$e;try{(0,D.unlinkSync)(Me.mainIPCHandle)}catch(Ve){throw ve.warn("Could not delete obsolete instance handle",Ve),Ve}return this.claimInstance(ve,Me,De,X,ae,!1)}if(Me.extensionTestsLocationURI&&!Me.debugExtensionHost.break){const $e=`Running extension tests from the command line is currently only supported if no other instance of ${ae.nameShort} is running.`;throw ve.error($e),Ae.dispose(),new Error($e)}let We;!Me.args.wait&&!Me.args.status&&(We=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,ae.nameShort),(0,t.localize)(4,null),ae)},1e4));const qe=C.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Ue=C.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(Me.args.status)return X.invokeFunction(async()=>{const $e=new s.DiagnosticsService(W.NullTelemetryService,ae),Ve=await Ue.getMainDiagnostics(),Fe=await Ue.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),je=await $e.getDiagnostics(Ve,Fe);throw console.log(je),new g.ExpectedError});throw v.isWindows&&await this.windowsAllowSetForegroundWindow(qe,ve),ve.trace("Sending env to running instance..."),await qe.start(Me.args,process.env),Ae.dispose(),We&&clearTimeout(We),new g.ExpectedError("Sent env to running instance. Terminating...")}if(Me.args.status)throw ve.warn(`Warning: The --status argument can only be used if ${ae.nameShort} is already running. Please run it again after {0} has started.`),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ie}handleStartupDataDirError(ve,Me,De){if(De.code==="EACCES"||De.code==="EPERM"){const X=(0,M.coalesce)([ve.userDataPath,ve.extensionsPath,I.XDG_RUNTIME_DIR]).map(ae=>(0,w.getPathLabel)(n.URI.file(ae),{os:v.OS,tildify:ve}));this.showStartupWarningDialog((0,t.localize)(5,null),(0,t.localize)(6,null,(0,P.toErrorMessage)(De),X.join(`
`)),Me)}}showStartupWarningDialog(ve,Me,De){E.dialog.showMessageBoxSync((0,ye.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:ve,detail:Me},De).options)}async windowsAllowSetForegroundWindow(ve,Me){if(v.isWindows){const De=await ve.getMainProcessId();Me.trace("Sending some foreground love to the running instance:",De);try{(await new Promise((X,ae)=>{j(["windows-foreground-love"],X,ae)})).allowSetForegroundWindow(De)}catch(X){Me.error(X)}}}quit(ve,Me){const De=ve.get(ie.ILogService),X=ve.get(V.ILifecycleMainService);let ae=0;Me&&(Me.isExpected?Me.message&&De.trace(Me.message):(ae=1,Me.stack?De.error(Me.stack):De.error(`Startup error: ${Me.toString()}`))),X.kill(ae)}resolveArgs(){const ve=this.validatePaths((0,u.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const Me=(0,r.createWaitMarkerFileSync)(ve.verbose);Me&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",Me),ve.waitMarkerFilePath=Me)}return ve}validatePaths(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const Me=this.doValidatePaths(ve._,ve.goto);ve._=Me}return ve}doValidatePaths(ve,Me){const De=(0,o.cwd)(),X=ve.map(Ie=>{let Re=String(Ie),Ae;Me&&(Ae=(0,h.parseLineAndColumnAware)(Re),Re=Ae.path),Re&&(Re=this.preparePath(De,Re));const We=(0,h.sanitizeFilePath)(Re,De),qe=(0,f.basename)(We);return qe&&!(0,h.isValidBasename)(qe)?null:Me&&Ae?(Ae.path=We,this.toPath(Ae)):We}),ae=v.isWindows||v.isMacintosh,he=(0,M.distinct)(X,Ie=>Ie&&ae?Ie.toLowerCase():Ie||"");return(0,M.coalesce)(he)}preparePath(ve,Me){return v.isWindows&&(Me=(0,d.rtrim)(Me,'"')),Me=(0,d.trim)((0,d.trim)(Me," "),"	"),v.isWindows&&(Me=(0,f.resolve)(ve,Me),Me=(0,d.rtrim)(Me,".")),Me}toPath(ve){const Me=[ve.path];return typeof ve.line=="number"&&Me.push(String(ve.line)),typeof ve.column=="number"&&Me.push(String(ve.column)),Me.join(":")}}new Le().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c6a9727b801542499d2b59cb7db4224e060fc578/core/vs/code/electron-main/main.js.map
