/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/errorMessage","vs/base/common/map","vs/platform/registry/common/platform","os","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/platform/environment/node/userDataPath","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function($){for(var e=[],L=0,D=$.length;L<D;L++)e[L]=J[$[L]];return e};define(J[48],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(R){return(w,g,u)=>{let P=null,p=null;if(typeof u.value=="function"?(P="value",p=u.value):typeof u.get=="function"&&(P="get",p=u.get),!p)throw new Error("not supported");u[P]=R(p,g)}}function D(R,w,g){let u=null,P=null;if(typeof g.value=="function"?(u="value",P=g.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(u="get",P=g.get),!P)throw new Error("not supported");const p=`$memoize$${w}`;g[u]=function(...d){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,d)}),this[p]}}e.memoize=D;function I(R,w,g){return L((u,P)=>{const p=`$debounce$${P}`,d=`$debounce$result$${P}`;return function(...b){this[d]||(this[d]=g?g():void 0),clearTimeout(this[p]),w&&(this[d]=w(this[d],...b),b=[this[d]]),this[p]=setTimeout(()=>{u.apply(this,b),this[d]=g?g():void 0},R)}})}e.debounce=I;function C(R,w,g){return L((u,P)=>{const p=`$throttle$timer$${P}`,d=`$throttle$result$${P}`,b=`$throttle$lastRun$${P}`,v=`$throttle$pending$${P}`;return function(...T){if(this[d]||(this[d]=g?g():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),w&&(this[d]=w(this[d],...T)),this[v])return;const c=this[b]+R;c<=Date.now()?(this[b]=Date.now(),u.apply(this,[this[d]]),this[d]=g?g():void 0):(this[v]=!0,this[p]=setTimeout(()=>{this[v]=!1,this[b]=Date.now(),u.apply(this,[this[d]]),this[d]=g?g():void 0},c-Date.now()))}})}e.throttle=C}),define(J[70],Z([0,1,7]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function D(g,u){if(!g)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=D;function I(g,u="Unreachable"){throw new Error(u)}e.assertNever=I;function C(g){if(!g)throw new L.BugIndicatingError("Assertion Failed")}e.assert=C;function R(g){if(!g()){debugger;g(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function w(g,u){let P=0;for(;P<g.length-1;){const p=g[P],d=g[P+1];if(!u(p,d))return!1;P++}return!0}e.checkAdjacentItems=w}),define(J[49],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function R(t,s=!1){let i=0;const n=t.length;let r="",o=0,a=16,l=0;function h(ne){let ae=0,ue=0;for(;ae<ne;){const se=t.charCodeAt(i);if(se>=48&&se<=57)ue=ue*16+se-48;else if(se>=65&&se<=70)ue=ue*16+se-65+10;else if(se>=97&&se<=102)ue=ue*16+se-97+10;else break;i++,ae++}return ae<ne&&(ue=-1),ue}function A(ne){i=ne,r="",o=0,a=16,l=0}function x(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return l=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;ae=i}else l=3;return t.substring(ne,ae)}function Y(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),l=2;break}const ue=t.charCodeAt(i);if(ue===34){ne+=t.substring(ae,i),i++;break}if(ue===92){if(ne+=t.substring(ae,i),i++,i>=n){l=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const pe=h(4);pe>=0?ne+=String.fromCharCode(pe):l=4;break}default:l=5}ae=i;continue}if(ue>=0&&ue<=31)if(g(ue)){ne+=t.substring(ae,i),l=2;break}else l=6;i++}return ne}function Q(){if(r="",l=0,o=i,i>=n)return o=n,a=17;let ne=t.charCodeAt(i);if(w(ne)){do i++,r+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(w(ne));return a=15}if(g(ne))return i++,r+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),a=14;switch(ne){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,r=Y(),a=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(t.charCodeAt(i));)i++;return r=t.substring(ae,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=n-1;let se=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,se=!0;break}i++}return se||(i++,l=1),r=t.substring(ae,i),a=13}return r+=String.fromCharCode(ne),i++,a=16}case 45:if(r+=String.fromCharCode(ne),i++,i===n||!u(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=x(),a=11;default:for(;i<n&&te(ne);)i++,ne=t.charCodeAt(i);if(o!==i){switch(r=t.substring(o,i),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(ne),i++,a=16}}function te(ne){if(w(ne)||g(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=Q();while(ne>=12&&ne<=15);return ne}return{setPosition:A,getPosition:()=>i,scan:s?ie:Q,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>l}}e.createScanner=R;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function p(t,s){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function l(h,A,x,Y){o.value=h,o.offset=A,o.length=x,o.type=Y,o.colonOffset=void 0,r=o}try{E(t,{onObjectBegin:(h,A)=>{if(s<=h)throw n;r=void 0,a=s>h,i.push("")},onObjectProperty:(h,A,x)=>{if(s<A||(l(h,A,x,"property"),i[i.length-1]=h,s<=A+x))throw n},onObjectEnd:(h,A)=>{if(s<=h)throw n;r=void 0,i.pop()},onArrayBegin:(h,A)=>{if(s<=h)throw n;r=void 0,i.push(0)},onArrayEnd:(h,A)=>{if(s<=h)throw n;r=void 0,i.pop()},onLiteralValue:(h,A,x)=>{if(s<A||(l(h,A,x,m(h)),s<=A+x))throw n},onSeparator:(h,A,x)=>{if(s<=A)throw n;if(h===":"&&r&&r.type==="property")r.colonOffset=A,a=!1,r=void 0;else if(h===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(a=!0,i[i.length-1]=""),r=void 0}}})}catch(h){if(h!==n)throw h}return{path:i,previousNode:r,isAtPropertyKey:a,matches:h=>{let A=0;for(let x=0;A<h.length&&x<i.length;x++)if(h[A]===i[x]||h[A]==="*")A++;else if(h[A]!=="**")return!1;return A===h.length}}}e.getLocation=p;function d(t,s=[],i=C.DEFAULT){let n=null,r=[];const o=[];function a(h){Array.isArray(r)?r.push(h):n!==null&&(r[n]=h)}return E(t,{onObjectBegin:()=>{const h={};a(h),o.push(r),r=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const h=[];a(h),o.push(r),r=h,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:a,onError:(h,A,x)=>{s.push({error:h,offset:A,length:x})}},i),r[0]}e.parse=d;function b(t,s=[],i=C.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function o(h){return n.children.push(h),h}E(t,{onObjectBegin:h=>{n=o({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,A,x)=>{n=o({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:A,length:x,parent:n})},onObjectEnd:(h,A)=>{n.length=h+A-n.offset,n=n.parent,r(h+A)},onArrayBegin:(h,A)=>{n=o({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,A)=>{n.length=h+A-n.offset,n=n.parent,r(h+A)},onLiteralValue:(h,A,x)=>{o({type:m(h),offset:A,length:x,parent:n,value:h}),r(A+x)},onSeparator:(h,A,x)=>{n.type==="property"&&(h===":"?n.colonOffset=A:h===","&&r(A))},onError:(h,A,x)=>{s.push({error:h,offset:A,length:x})}},i);const l=n.children[0];return l&&delete l.parent,l}e.parseTree=b;function v(t,s){if(!t)return;let i=t;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=v;function T(t){if(!t.parent||!t.parent.children)return[];const s=T(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=T;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const s=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(s[i.children[0].value]=c(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=c;function f(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=f;function y(t,s,i=!1){if(f(t,s,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const o=y(n[r],s,i);if(o)return o}return t}}e.findNodeAtOffset=y;function E(t,s,i=C.DEFAULT){const n=R(t,!1);function r(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(B){return B?X=>B(X,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=r(s.onObjectBegin),l=o(s.onObjectProperty),h=r(s.onObjectEnd),A=r(s.onArrayBegin),x=r(s.onArrayEnd),Y=o(s.onLiteralValue),Q=o(s.onSeparator),te=r(s.onComment),ie=o(s.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function ue(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:ne||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(B){case 12:case 13:ne?se(10):te();break;case 16:se(1);break;case 15:case 14:break;default:return B}}}function se(B,X=[],N=[]){if(ie(B),X.length+N.length>0){let k=n.getToken();for(;k!==17;){if(X.indexOf(k)!==-1){ue();break}else if(N.indexOf(k)!==-1)break;k=ue()}}}function pe(B){const X=n.getTokenValue();return B?Y(X):l(X),ue(),!0}function V(){switch(n.getToken()){case 11:{let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(se(2),B=0)}catch{se(2)}Y(B);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return ue(),!0}function M(){return n.getToken()!==10?(se(3,[],[2,5]),!1):(pe(!1),n.getToken()===6?(Q(":"),ue(),z()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function F(){a(),ue();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||se(4,[],[]),Q(","),ue(),n.getToken()===2&&ae)break}else B&&se(6,[],[]);M()||se(4,[],[2,5]),B=!0}return h(),n.getToken()!==2?se(7,[2],[]):ue(),!0}function j(){A(),ue();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||se(4,[],[]),Q(","),ue(),n.getToken()===4&&ae)break}else B&&se(6,[],[]);z()||se(4,[],[4,5]),B=!0}return x(),n.getToken()!==4?se(8,[4],[]):ue(),!0}function z(){switch(n.getToken()){case 3:return j();case 1:return F();case 10:return pe(!0);default:return V()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(se(4,[],[]),!1):z()?(n.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=E;function S(t,s){const i=R(t),n=[];let r,o=0,a;do switch(a=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==a&&n.push(t.substring(o,a)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=S;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(J[71],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(w,g,u){return Math.min(Math.max(w,g),u)}e.clamp=L;function D(w,g){return(g+w%g)%g}e.rot=D;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class C{constructor(){this._n=1,this._val=0}update(g){return this._val=this._val+(g-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=C;class R{constructor(g){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(g),this._values.fill(0,0,g)}update(g){const u=this._values[this._index];return this._values[this._index]=g,this._index=(this._index+1)%this._values.length,this._sum-=u,this._sum+=g,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function $(I){const C=[];typeof I=="number"&&C.push("code/timeOrigin",I);function R(g){C.push(g,Date.now())}function w(){const g=[];for(let u=0;u<C.length;u+=2)g.push({name:C[u],startTime:C[u+1]});return g}return{mark:R,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))C.push({name:R.name,startTime:Math.round(I+R.startTime)});return C}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function L(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function($,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:$)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function($){var e={};function L(D){if(e[D])return e[D].exports;var I=e[D]={i:D,l:!1,exports:{}};return $[D].call(I.exports,I,I.exports,L),I.l=!0,I.exports}return L.m=$,L.c=e,L.d=function(D,I,C){L.o(D,I)||Object.defineProperty(D,I,{enumerable:!0,get:C})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,I){if(1&I&&(D=L(D)),8&I||4&I&&typeof D=="object"&&D&&D.__esModule)return D;var C=Object.create(null);if(L.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:D}),2&I&&typeof D!="string")for(var R in D)L.d(C,R,function(w){return D[w]}.bind(null,R));return C},L.n=function(D){var I=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(I,"a",I),I},L.o=function(D,I){return Object.prototype.hasOwnProperty.call(D,I)},L.p="",L(L.s=0)}([function($,e,L){(function(D){var I;e=$.exports=N,I=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],g=e.src=[],u=0,P=u++;g[P]="0|[1-9]\\d*";var p=u++;g[p]="[0-9]+";var d=u++;g[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=u++;g[b]="("+g[P]+")\\.("+g[P]+")\\.("+g[P]+")";var v=u++;g[v]="("+g[p]+")\\.("+g[p]+")\\.("+g[p]+")";var T=u++;g[T]="(?:"+g[P]+"|"+g[d]+")";var c=u++;g[c]="(?:"+g[p]+"|"+g[d]+")";var f=u++;g[f]="(?:-("+g[T]+"(?:\\."+g[T]+")*))";var y=u++;g[y]="(?:-?("+g[c]+"(?:\\."+g[c]+")*))";var E=u++;g[E]="[0-9A-Za-z-]+";var S=u++;g[S]="(?:\\+("+g[E]+"(?:\\."+g[E]+")*))";var m=u++,t="v?"+g[b]+g[f]+"?"+g[S]+"?";g[m]="^"+t+"$";var s="[v=\\s]*"+g[v]+g[y]+"?"+g[S]+"?",i=u++;g[i]="^"+s+"$";var n=u++;g[n]="((?:<|>)?=?)";var r=u++;g[r]=g[p]+"|x|X|\\*";var o=u++;g[o]=g[P]+"|x|X|\\*";var a=u++;g[a]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[f]+")?"+g[S]+"?)?)?";var l=u++;g[l]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[y]+")?"+g[S]+"?)?)?";var h=u++;g[h]="^"+g[n]+"\\s*"+g[a]+"$";var A=u++;g[A]="^"+g[n]+"\\s*"+g[l]+"$";var x=u++;g[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=u++;g[Y]="(?:~>?)";var Q=u++;g[Q]="(\\s*)"+g[Y]+"\\s+",w[Q]=new RegExp(g[Q],"g");var te=u++;g[te]="^"+g[Y]+g[a]+"$";var ie=u++;g[ie]="^"+g[Y]+g[l]+"$";var ne=u++;g[ne]="(?:\\^)";var ae=u++;g[ae]="(\\s*)"+g[ne]+"\\s+",w[ae]=new RegExp(g[ae],"g");var ue=u++;g[ue]="^"+g[ne]+g[a]+"$";var se=u++;g[se]="^"+g[ne]+g[l]+"$";var pe=u++;g[pe]="^"+g[n]+"\\s*("+s+")$|^$";var V=u++;g[V]="^"+g[n]+"\\s*("+t+")$|^$";var M=u++;g[M]="(\\s*)"+g[n]+"\\s*("+s+"|"+g[a]+")",w[M]=new RegExp(g[M],"g");var F=u++;g[F]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var j=u++;g[j]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var z=u++;g[z]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)I(B,g[B]),w[B]||(w[B]=new RegExp(g[B]));function X(_,q){if(_ instanceof N)return _;if(typeof _!="string"||_.length>C||!(q?w[i]:w[m]).test(_))return null;try{return new N(_,q)}catch{return null}}function N(_,q){if(_ instanceof N){if(_.loose===q)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof N))return new N(_,q);I("SemVer",_,q),this.loose=q;var K=_.trim().match(q?w[i]:w[m]);if(!K)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var ve=+he;if(ve>=0&&ve<R)return ve}return he}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=X,e.valid=function(_,q){var K=X(_,q);return K?K.version:null},e.clean=function(_,q){var K=X(_.trim().replace(/^[=v]+/,""),q);return K?K.version:null},e.SemVer=N,N.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},N.prototype.toString=function(){return this.version},N.prototype.compare=function(_){return I("SemVer.compare",this.version,this.loose,_),_ instanceof N||(_=new N(_,this.loose)),this.compareMain(_)||this.comparePre(_)},N.prototype.compareMain=function(_){return _ instanceof N||(_=new N(_,this.loose)),O(this.major,_.major)||O(this.minor,_.minor)||O(this.patch,_.patch)},N.prototype.comparePre=function(_){if(_ instanceof N||(_=new N(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var q=0;do{var K=this.prerelease[q],he=_.prerelease[q];if(I("prerelease compare",q,K,he),K===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(K===void 0)return-1;if(K!==he)return O(K,he)}while(++q)},N.prototype.inc=function(_,q){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,q,K,he){typeof K=="string"&&(he=K,K=void 0);try{return new N(_,K).inc(q,he).version}catch{return null}},e.diff=function(_,q){if(H(_,q))return null;var K=X(_),he=X(q);if(K.prerelease.length||he.prerelease.length){for(var ve in K)if((ve==="major"||ve==="minor"||ve==="patch")&&K[ve]!==he[ve])return"pre"+ve;return"prerelease"}for(var ve in K)if((ve==="major"||ve==="minor"||ve==="patch")&&K[ve]!==he[ve])return ve},e.compareIdentifiers=O;var k=/^[0-9]+$/;function O(_,q){var K=k.test(_),he=k.test(q);return K&&he&&(_=+_,q=+q),K&&!he?-1:he&&!K?1:_<q?-1:_>q?1:0}function U(_,q,K){return new N(_,K).compare(new N(q,K))}function W(_,q,K){return U(_,q,K)>0}function G(_,q,K){return U(_,q,K)<0}function H(_,q,K){return U(_,q,K)===0}function re(_,q,K){return U(_,q,K)!==0}function ce(_,q,K){return U(_,q,K)>=0}function Ee(_,q,K){return U(_,q,K)<=0}function me(_,q,K,he){var ve;switch(q){case"===":typeof _=="object"&&(_=_.version),typeof K=="object"&&(K=K.version),ve=_===K;break;case"!==":typeof _=="object"&&(_=_.version),typeof K=="object"&&(K=K.version),ve=_!==K;break;case"":case"=":case"==":ve=H(_,K,he);break;case"!=":ve=re(_,K,he);break;case">":ve=W(_,K,he);break;case">=":ve=ce(_,K,he);break;case"<":ve=G(_,K,he);break;case"<=":ve=Ee(_,K,he);break;default:throw new TypeError("Invalid operator: "+q)}return ve}function le(_,q){if(_ instanceof le){if(_.loose===q)return _;_=_.value}if(!(this instanceof le))return new le(_,q);I("comparator",_,q),this.loose=q,this.parse(_),this.semver===de?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(_,q){return O(q,_)},e.major=function(_,q){return new N(_,q).major},e.minor=function(_,q){return new N(_,q).minor},e.patch=function(_,q){return new N(_,q).patch},e.compare=U,e.compareLoose=function(_,q){return U(_,q,!0)},e.rcompare=function(_,q,K){return U(q,_,K)},e.sort=function(_,q){return _.sort(function(K,he){return e.compare(K,he,q)})},e.rsort=function(_,q){return _.sort(function(K,he){return e.rcompare(K,he,q)})},e.gt=W,e.lt=G,e.eq=H,e.neq=re,e.gte=ce,e.lte=Ee,e.cmp=me,e.Comparator=le;var de={};function ge(_,q){if(_ instanceof ge)return _.loose===q?_:new ge(_.raw,q);if(_ instanceof le)return new ge(_.value,q);if(!(this instanceof ge))return new ge(_,q);if(this.loose=q,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function oe(_){return!_||_.toLowerCase()==="x"||_==="*"}function Se(_,q,K,he,ve,Le,Ie,Ae,Re,Oe,Ue,De,ke){return((q=oe(K)?"":oe(he)?">="+K+".0.0":oe(ve)?">="+K+"."+he+".0":">="+q)+" "+(Ae=oe(Re)?"":oe(Oe)?"<"+(+Re+1)+".0.0":oe(Ue)?"<"+Re+"."+(+Oe+1)+".0":De?"<="+Re+"."+Oe+"."+Ue+"-"+De:"<="+Ae)).trim()}function we(_,q){for(var K=0;K<_.length;K++)if(!_[K].test(q))return!1;if(q.prerelease.length){for(K=0;K<_.length;K++)if(I(_[K].semver),_[K].semver!==de&&_[K].semver.prerelease.length>0){var he=_[K].semver;if(he.major===q.major&&he.minor===q.minor&&he.patch===q.patch)return!0}return!1}return!0}function Te(_,q,K){try{q=new ge(q,K)}catch{return!1}return q.test(_)}function xe(_,q,K,he){var ve,Le,Ie,Ae,Re;switch(_=new N(_,he),q=new ge(q,he),K){case">":ve=W,Le=Ee,Ie=G,Ae=">",Re=">=";break;case"<":ve=G,Le=ce,Ie=W,Ae="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(_,q,he))return!1;for(var Oe=0;Oe<q.set.length;++Oe){var Ue=q.set[Oe],De=null,ke=null;if(Ue.forEach(function(Ne){Ne.semver===de&&(Ne=new le(">=0.0.0")),De=De||Ne,ke=ke||Ne,ve(Ne.semver,De.semver,he)?De=Ne:Ie(Ne.semver,ke.semver,he)&&(ke=Ne)}),De.operator===Ae||De.operator===Re||(!ke.operator||ke.operator===Ae)&&Le(_,ke.semver)||ke.operator===Re&&Ie(_,ke.semver))return!1}return!0}le.prototype.parse=function(_){var q=this.loose?w[pe]:w[V],K=_.match(q);if(!K)throw new TypeError("Invalid comparator: "+_);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new N(K[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(_){return I("Comparator.test",_,this.loose),this.semver===de||(typeof _=="string"&&(_=new N(_,this.loose)),me(_,this.operator,this.semver,this.loose))},le.prototype.intersects=function(_,q){if(!(_ instanceof le))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ge(_.value,q),Te(this.value,K,q);if(_.operator==="")return K=new ge(this.value,q),Te(_.semver,K,q);var he=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Le=this.semver.version===_.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),Ae=me(this.semver,"<",_.semver,q)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),Re=me(this.semver,">",_.semver,q)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return he||ve||Le&&Ie||Ae||Re},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(_){var q=this.loose;_=_.trim(),I("range",_,q);var K=q?w[j]:w[F];_=_.replace(K,Se),I("hyphen replace",_),_=_.replace(w[M],"$1$2$3"),I("comparator trim",_,w[M]),_=(_=(_=_.replace(w[Q],"$1~")).replace(w[ae],"$1^")).split(/\s+/).join(" ");var he=q?w[pe]:w[V],ve=_.split(" ").map(function(Le){return function(Ie,Ae){return I("comp",Ie),Ie=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ue){return function(De,ke){I("caret",De,ke);var Ne=ke?w[se]:w[ue];return De.replace(Ne,function(Me,ye,Pe,be,Ce){var Fe;return I("caret",De,Me,ye,Pe,be,Ce),oe(ye)?Fe="":oe(Pe)?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":oe(be)?Fe=ye==="0"?">="+ye+"."+Pe+".0 <"+ye+"."+(+Pe+1)+".0":">="+ye+"."+Pe+".0 <"+(+ye+1)+".0.0":Ce?(I("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Fe=ye==="0"?Pe==="0"?">="+ye+"."+Pe+"."+be+Ce+" <"+ye+"."+Pe+"."+(+be+1):">="+ye+"."+Pe+"."+be+Ce+" <"+ye+"."+(+Pe+1)+".0":">="+ye+"."+Pe+"."+be+Ce+" <"+(+ye+1)+".0.0"):(I("no pr"),Fe=ye==="0"?Pe==="0"?">="+ye+"."+Pe+"."+be+" <"+ye+"."+Pe+"."+(+be+1):">="+ye+"."+Pe+"."+be+" <"+ye+"."+(+Pe+1)+".0":">="+ye+"."+Pe+"."+be+" <"+(+ye+1)+".0.0"),I("caret return",Fe),Fe})}(Ue,Oe)}).join(" ")}(Ie,Ae),I("caret",Ie),Ie=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ue){return function(De,ke){var Ne=ke?w[ie]:w[te];return De.replace(Ne,function(Me,ye,Pe,be,Ce){var Fe;return I("tilde",De,Me,ye,Pe,be,Ce),oe(ye)?Fe="":oe(Pe)?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":oe(be)?Fe=">="+ye+"."+Pe+".0 <"+ye+"."+(+Pe+1)+".0":Ce?(I("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Fe=">="+ye+"."+Pe+"."+be+Ce+" <"+ye+"."+(+Pe+1)+".0"):Fe=">="+ye+"."+Pe+"."+be+" <"+ye+"."+(+Pe+1)+".0",I("tilde return",Fe),Fe})}(Ue,Oe)}).join(" ")}(Ie,Ae),I("tildes",Ie),Ie=function(Re,Oe){return I("replaceXRanges",Re,Oe),Re.split(/\s+/).map(function(Ue){return function(De,ke){De=De.trim();var Ne=ke?w[A]:w[h];return De.replace(Ne,function(Me,ye,Pe,be,Ce,Fe){I("xRange",De,Me,ye,Pe,be,Ce,Fe);var ze=oe(Pe),_e=ze||oe(be),Ve=_e||oe(Ce);return ye==="="&&Ve&&(ye=""),ze?Me=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ve?(_e&&(be=0),Ve&&(Ce=0),ye===">"?(ye=">=",_e?(Pe=+Pe+1,be=0,Ce=0):Ve&&(be=+be+1,Ce=0)):ye==="<="&&(ye="<",_e?Pe=+Pe+1:be=+be+1),Me=ye+Pe+"."+be+"."+Ce):_e?Me=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ve&&(Me=">="+Pe+"."+be+".0 <"+Pe+"."+(+be+1)+".0"),I("xRange return",Me),Me})}(Ue,Oe)}).join(" ")}(Ie,Ae),I("xrange",Ie),Ie=function(Re,Oe){return I("replaceStars",Re,Oe),Re.trim().replace(w[z],"")}(Ie,Ae),I("stars",Ie),Ie}(Le,q)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Le){return!!Le.match(he)})),ve=ve.map(function(Le){return new le(Le,q)})},ge.prototype.intersects=function(_,q){if(!(_ instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(he){return _.set.some(function(ve){return ve.every(function(Le){return he.intersects(Le,q)})})})})},e.toComparators=function(_,q){return new ge(_,q).set.map(function(K){return K.map(function(he){return he.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new N(_,this.loose));for(var q=0;q<this.set.length;q++)if(we(this.set[q],_))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(_,q,K){var he=null,ve=null;try{var Le=new ge(q,K)}catch{return null}return _.forEach(function(Ie){Le.test(Ie)&&(he&&ve.compare(Ie)!==-1||(ve=new N(he=Ie,K)))}),he},e.minSatisfying=function(_,q,K){var he=null,ve=null;try{var Le=new ge(q,K)}catch{return null}return _.forEach(function(Ie){Le.test(Ie)&&(he&&ve.compare(Ie)!==1||(ve=new N(he=Ie,K)))}),he},e.validRange=function(_,q){try{return new ge(_,q).range||"*"}catch{return null}},e.ltr=function(_,q,K){return xe(_,q,"<",K)},e.gtr=function(_,q,K){return xe(_,q,">",K)},e.outside=xe,e.prerelease=function(_,q){var K=X(_,q);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(_,q,K){return _=new ge(_,K),q=new ge(q,K),_.intersects(q)},e.coerce=function(_){if(_ instanceof N)return _;if(typeof _!="string")return null;var q=_.match(w[x]);return q==null?null:X((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,L(1))},function($,e){var L,D,I=$.exports={};function C(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(c){if(L===setTimeout)return setTimeout(c,0);if((L===C||!L)&&setTimeout)return L=setTimeout,setTimeout(c,0);try{return L(c,0)}catch{try{return L.call(null,c,0)}catch{return L.call(this,c,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:C}catch{L=C}try{D=typeof clearTimeout=="function"?clearTimeout:R}catch{D=R}})();var g,u=[],P=!1,p=-1;function d(){P&&g&&(P=!1,g.length?u=g.concat(u):p=-1,u.length&&b())}function b(){if(!P){var c=w(d);P=!0;for(var f=u.length;f;){for(g=u,u=[];++p<f;)g&&g[p].run();p=-1,f=u.length}g=null,P=!1,function(y){if(D===clearTimeout)return clearTimeout(y);if((D===R||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(y);try{D(y)}catch{try{return D.call(null,y)}catch{return D.call(this,y)}}}(c)}}function v(c,f){this.fun=c,this.array=f}function T(){}I.nextTick=function(c){var f=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)f[y-1]=arguments[y];u.push(new v(c,f)),u.length!==1||P||w(b)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=T,I.addListener=T,I.once=T,I.off=T,I.removeListener=T,I.removeAllListeners=T,I.emit=T,I.prependListener=T,I.prependOnceListener=T,I.listeners=function(c){return[]},I.binding=function(c){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(c){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(J[72],Z([0,1]),function($,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class D{constructor(w,g,u){this.level=w,this.key=g,this.value=u,this.forward=[]}}const I=void 0;class C{constructor(w,g=2**16){this.comparator=w,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(g)|0),this._header=new D(this._maxLevel,I,I)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,I,I)}has(w){return Boolean(C._search(this,w,this.comparator))}get(w){return C._search(this,w,this.comparator)?.value}set(w,g){return C._insert(this,w,g,this.comparator)&&(this._size+=1),this}delete(w){const g=C._delete(this,w,this.comparator);return g&&(this._size-=1),g}forEach(w,g){let u=this._header.forward[0];for(;u;)w.call(g,u.value,u.key,this),u=u.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",g=this._header.forward[0];for(;g;)w+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return w}static _search(w,g,u){let P=w._header;for(let p=w._level-1;p>=0;p--)for(;P.forward[p]&&u(P.forward[p].key,g)<0;)P=P.forward[p];if(P=P.forward[0],P&&u(P.key,g)===0)return P}static _insert(w,g,u,P){const p=[];let d=w._header;for(let b=w._level-1;b>=0;b--){for(;d.forward[b]&&P(d.forward[b].key,g)<0;)d=d.forward[b];p[b]=d}if(d=d.forward[0],d&&P(d.key,g)===0)return d.value=u,!1;{const b=C._randomLevel(w);if(b>w._level){for(let v=w._level;v<b;v++)p[v]=w._header;w._level=b}d=new D(b,g,u);for(let v=0;v<b;v++)d.forward[v]=p[v].forward[v],p[v].forward[v]=d;return!0}}static _randomLevel(w,g=.5){let u=1;for(;Math.random()<g&&u<w._maxLevel;)u+=1;return u}static _delete(w,g,u){const P=[];let p=w._header;for(let d=w._level-1;d>=0;d--){for(;p.forward[d]&&u(p.forward[d].key,g)<0;)p=p.forward[d];P[d]=p}if(p=p.forward[0],!p||u(p.key,g)!==0)return!1;for(let d=0;d<w._level&&P[d].forward[d]===p;d++)P[d].forward[d]=p.forward[d];for(;w._level>0&&w._header.forward[w._level-1]===I;)w._level-=1;return!0}}e.SkipList=C}),define(J[43],Z([0,1,7,2]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(S){const m=S;return m?typeof m.read=="function":!1}e.isReadable=I;function C(S){const m=S;return m?[m.on,m.pause,m.resume,m.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=C;function R(S){const m=S;return m?C(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=R;function w(S,m){return new g(S,m)}e.newWriteableStream=w;class g{constructor(m,t){this.reducer=m,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m<"u"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(t=>t(m))}emitError(m){this.listeners.error.length===0?(0,L.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(t=>t(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,t){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(m,t){if(this.state.destroyed)return;let s;switch(m){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const i=s.indexOf(t);i>=0&&s.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(S,m){const t=[];let s;for(;(s=S.read())!==null;)t.push(s);return m(t)}e.consumeReadable=u;function P(S,m,t){const s=[];let i;for(;(i=S.read())!==null&&s.length<t;)s.push(i);return i===null&&s.length>0?m(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return S.read()}}}e.peekReadable=P;function p(S,m){return new Promise((t,s)=>{const i=[];d(S,{onData:n=>{m&&i.push(n)},onError:n=>{m?s(n):t(void 0)},onEnd:()=>{t(m?m(i):void 0)}})})}e.consumeStream=p;function d(S,m){let t=!1;return S.on("error",s=>{t||m.onError(s)}),S.on("end",()=>{t||m.onEnd()}),S.on("data",s=>{t||m.onData(s)}),(0,D.toDisposable)(()=>t=!0)}e.listenStream=d;function b(S,m){return new Promise((t,s)=>{const i=new D.DisposableStore,n=[],r=l=>{if(n.push(l),n.length>m)return i.dispose(),S.pause(),t({stream:S,buffer:n,ended:!1})},o=l=>s(l),a=()=>t({stream:S,buffer:n,ended:!0});i.add((0,D.toDisposable)(()=>S.removeListener("error",o))),S.on("error",o),i.add((0,D.toDisposable)(()=>S.removeListener("end",a))),S.on("end",a),i.add((0,D.toDisposable)(()=>S.removeListener("data",r))),S.on("data",r)})}e.peekStream=b;function v(S,m){const t=w(m);return t.end(S),t}e.toStream=v;function T(){const S=w(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=T;function c(S){let m=!1;return{read:()=>m?null:(m=!0,S)}}e.toReadable=c;function f(S,m,t){const s=w(t);return d(S,{onData:i=>s.write(m.data(i)),onError:i=>s.error(m.error?m.error(i):i),onEnd:()=>s.end()}),s}e.transform=f;function y(S,m,t){let s=!1;return{read:()=>{const i=m.read();return s?i:(s=!0,i!==null?t([S,i]):S)}}}e.prefixedReadable=y;function E(S,m,t){let s=!1;const i=w(t);return d(m,{onData:n=>s?i.write(n):(s=!0,i.write(t([S,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(S)),i.end()}}),i}e.prefixedStream=E}),define(J[15],Z([0,1,43]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let I,C;class R{static alloc(l){return D?new R(Buffer.allocUnsafe(l)):new R(new Uint8Array(l))}static wrap(l){return D&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new R(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&D?new R(Buffer.from(l)):(I||(I=new TextEncoder),new R(I.encode(l)))}static fromByteArray(l){const h=R.alloc(l.length);for(let A=0,x=l.length;A<x;A++)h.buffer[A]=l[A];return h}static concat(l,h){if(typeof h>"u"){h=0;for(let Y=0,Q=l.length;Y<Q;Y++)h+=l[Y].byteLength}const A=R.alloc(h);let x=0;for(let Y=0,Q=l.length;Y<Q;Y++){const te=l[Y];A.set(te,x),x+=te.byteLength}return A}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=R.alloc(this.byteLength);return l.set(this),l}toString(){return D?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(l,h){return new R(this.buffer.subarray(l,h))}set(l,h){if(l instanceof R)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return u(this.buffer,l)}writeUInt32BE(l,h){P(this.buffer,l,h)}readUInt32LE(l){return p(this.buffer,l)}writeUInt32LE(l,h){d(this.buffer,l,h)}readUInt8(l){return b(this.buffer,l)}writeUInt8(l,h){v(this.buffer,l,h)}}e.VSBuffer=R;function w(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=w;function g(a,l,h){a[h+0]=l&255,l=l>>>8,a[h+1]=l&255}e.writeUInt16LE=g;function u(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=u;function P(a,l,h){a[h+3]=l,l=l>>>8,a[h+2]=l,l=l>>>8,a[h+1]=l,l=l>>>8,a[h]=l}e.writeUInt32BE=P;function p(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=p;function d(a,l,h){a[h+0]=l&255,l=l>>>8,a[h+1]=l&255,l=l>>>8,a[h+2]=l&255,l=l>>>8,a[h+3]=l&255}e.writeUInt32LE=d;function b(a,l){return a[l]}e.readUInt8=b;function v(a,l,h){a[h]=l}e.writeUInt8=v;function T(a){return L.consumeReadable(a,l=>R.concat(l))}e.readableToBuffer=T;function c(a){return L.toReadable(a)}e.bufferToReadable=c;function f(a){return L.consumeStream(a,l=>R.concat(l))}e.streamToBuffer=f;async function y(a){return a.ended?R.concat(a.buffer):R.concat([...a.buffer,await f(a.stream)])}e.bufferedStreamToBuffer=y;function E(a){return L.toStream(a,l=>R.concat(l))}e.bufferToStream=E;function S(a){return L.transform(a,{data:l=>typeof l=="string"?R.fromString(l):R.wrap(l)},l=>R.concat(l))}e.streamToBufferReadableStream=S;function m(a){return L.newWriteableStream(l=>R.concat(l),a)}e.newWriteableBufferStream=m;function t(a,l){return L.prefixedReadable(a,l,h=>R.concat(h))}e.prefixedBufferReadable=t;function s(a,l){return L.prefixedStream(a,l,h=>R.concat(h))}e.prefixedBufferStream=s;function i(a){let l=0,h=0,A=0;const x=new Uint8Array(Math.floor(a.length/4*3)),Y=te=>{switch(h){case 3:x[A++]=l|te,h=0;break;case 2:x[A++]=l|te>>>2,l=te<<6,h=3;break;case 1:x[A++]=l|te>>>4,l=te<<4,h=2;break;default:l=te<<2,h=1}};for(let te=0;te<a.length;te++){const ie=a.charCodeAt(te);if(ie>=65&&ie<=90)Y(ie-65);else if(ie>=97&&ie<=122)Y(ie-97+26);else if(ie>=48&&ie<=57)Y(ie-48+52);else if(ie===43||ie===45)Y(62);else if(ie===47||ie===95)Y(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${a[te]}`)}}const Q=A;for(;h>0;)Y(0);return R.wrap(x).slice(0,Q)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:a},l=!0,h=!1){const A=h?r:n;let x="";const Y=a.byteLength%3;let Q=0;for(;Q<a.byteLength-Y;Q+=3){const te=a[Q+0],ie=a[Q+1],ne=a[Q+2];x+=A[te>>>2],x+=A[(te<<4|ie>>>4)&63],x+=A[(ie<<2|ne>>>6)&63],x+=A[ne&63]}if(Y===1){const te=a[Q+0];x+=A[te>>>2],x+=A[te<<4&63],l&&(x+="==")}else if(Y===2){const te=a[Q+0],ie=a[Q+1];x+=A[te>>>2],x+=A[(te<<4|ie>>>4)&63],x+=A[ie<<2&63],l&&(x+="=")}return x}e.encodeBase64=o}),define(J[29],Z([0,1,3]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const y=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([E,S])=>{y[E]=S&&typeof S=="object"?D(S):S}),y}e.deepClone=D;function I(f){if(!f||typeof f!="object")return f;const y=[f];for(;y.length>0;){const E=y.shift();Object.freeze(E);for(const S in E)if(C.call(E,S)){const m=E[S];typeof m=="object"&&!Object.isFrozen(m)&&!(0,L.isTypedArray)(m)&&y.push(m)}}return f}e.deepFreeze=I;const C=Object.prototype.hasOwnProperty;function R(f,y){return w(f,y,new Set)}e.cloneAndChange=R;function w(f,y,E){if((0,L.isUndefinedOrNull)(f))return f;const S=y(f);if(typeof S<"u")return S;if(Array.isArray(f)){const m=[];for(const t of f)m.push(w(t,y,E));return m}if((0,L.isObject)(f)){if(E.has(f))throw new Error("Cannot clone recursive data-structure");E.add(f);const m={};for(const t in f)C.call(f,t)&&(m[t]=w(f[t],y,E));return E.delete(f),m}return f}function g(f,y,E=!0){return(0,L.isObject)(f)?((0,L.isObject)(y)&&Object.keys(y).forEach(S=>{S in f?E&&((0,L.isObject)(f[S])&&(0,L.isObject)(y[S])?g(f[S],y[S],E):f[S]=y[S]):f[S]=y[S]}),f):y}e.mixin=g;function u(f,y){if(f===y)return!0;if(f==null||y===null||y===void 0||typeof f!=typeof y||typeof f!="object"||Array.isArray(f)!==Array.isArray(y))return!1;let E,S;if(Array.isArray(f)){if(f.length!==y.length)return!1;for(E=0;E<f.length;E++)if(!u(f[E],y[E]))return!1}else{const m=[];for(S in f)m.push(S);m.sort();const t=[];for(S in y)t.push(S);if(t.sort(),!u(m,t))return!1;for(E=0;E<m.length;E++)if(!u(f[m[E]],y[m[E]]))return!1}return!0}e.equals=u;function P(f){const y=new Set;return JSON.stringify(f,(E,S)=>{if((0,L.isObject)(S)||Array.isArray(S)){if(y.has(S))return"[Circular]";y.add(S)}return S})}e.safeStringify=P;function p(f,y){const E=Object.create(null);return!f||!y||Object.keys(y).forEach(m=>{const t=f[m],s=y[m];u(t,s)||(E[m]=s)}),E}e.distinct=p;function d(f,y){const E=y.toLowerCase(),S=Object.keys(f).find(m=>m.toLowerCase()===E);return S?f[S]:f[y]}e.getCaseInsensitive=d;function b(f,y){const E=Object.create(null);for(const[S,m]of Object.entries(f))y(S,m)&&(E[S]=m);return E}e.filter=b;function v(f){let y=[],E=Object.getPrototypeOf(f);for(;Object.prototype!==E;)y=y.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return y}e.getAllPropertyNames=v;function T(f){const y=[];for(const E of v(f))typeof f[E]=="function"&&y.push(E);return y}e.getAllMethodNames=T;function c(f,y){const E=m=>function(){const t=Array.prototype.slice.call(arguments,0);return y(m,t)},S={};for(const m of f)S[m]=E(m);return S}e.createProxyObject=c}),define(J[30],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(I){return L.test(I)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(w){for(let g=0;g<w.length;g++)w[g]=Math.floor(Math.random()*256);return w};const C=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));return function(){I(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let g=0,u="";return u+=R[C[g++]],u+=R[C[g++]],u+=R[C[g++]],u+=R[C[g++]],u+="-",u+=R[C[g++]],u+=R[C[g++]],u+="-",u+=R[C[g++]],u+=R[C[g++]],u+="-",u+=R[C[g++]],u+=R[C[g++]],u+="-",u+=R[C[g++]],u+=R[C[g++]],u+=R[C[g++]],u+=R[C[g++]],u+=R[C[g++]],u+=R[C[g++]],u}}()}),define(J[73],Z([0,1,36]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(R){const w=R.replace(/\-/g,":").toLowerCase();return!D.has(w)}function C(){const R=(0,L.networkInterfaces)();for(const w in R){const g=R[w];if(g){for(const{mac:u}of g)if(I(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(J[74],Z([8,9]),function($,e){return $.create("vs/base/common/date",e)}),define(J[75],Z([0,1,74]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,I=D*60,C=I*24,R=C*7,w=C*30,g=C*365;function u(p,d,b,v){typeof p!="number"&&(p=p.getTime());const T=Math.round((new Date().getTime()-p)/1e3);if(T<-30)return(0,L.localize)(0,null,u(new Date().getTime()+T*1e3,!1));if(!v&&T<30)return(0,L.localize)(1,null);let c;return T<D?(c=T,d?c===1?b?(0,L.localize)(2,null,c):(0,L.localize)(3,null,c):b?(0,L.localize)(4,null,c):(0,L.localize)(5,null,c):c===1?b?(0,L.localize)(6,null,c):(0,L.localize)(7,null,c):b?(0,L.localize)(8,null,c):(0,L.localize)(9,null,c)):T<I?(c=Math.floor(T/D),d?c===1?b?(0,L.localize)(10,null,c):(0,L.localize)(11,null,c):b?(0,L.localize)(12,null,c):(0,L.localize)(13,null,c):c===1?b?(0,L.localize)(14,null,c):(0,L.localize)(15,null,c):b?(0,L.localize)(16,null,c):(0,L.localize)(17,null,c)):T<C?(c=Math.floor(T/I),d?c===1?b?(0,L.localize)(18,null,c):(0,L.localize)(19,null,c):b?(0,L.localize)(20,null,c):(0,L.localize)(21,null,c):c===1?b?(0,L.localize)(22,null,c):(0,L.localize)(23,null,c):b?(0,L.localize)(24,null,c):(0,L.localize)(25,null,c)):T<R?(c=Math.floor(T/C),d?c===1?(0,L.localize)(26,null,c):(0,L.localize)(27,null,c):c===1?(0,L.localize)(28,null,c):(0,L.localize)(29,null,c)):T<w?(c=Math.floor(T/R),d?c===1?b?(0,L.localize)(30,null,c):(0,L.localize)(31,null,c):b?(0,L.localize)(32,null,c):(0,L.localize)(33,null,c):c===1?b?(0,L.localize)(34,null,c):(0,L.localize)(35,null,c):b?(0,L.localize)(36,null,c):(0,L.localize)(37,null,c)):T<g?(c=Math.floor(T/w),d?c===1?b?(0,L.localize)(38,null,c):(0,L.localize)(39,null,c):b?(0,L.localize)(40,null,c):(0,L.localize)(41,null,c):c===1?b?(0,L.localize)(42,null,c):(0,L.localize)(43,null,c):b?(0,L.localize)(44,null,c):(0,L.localize)(45,null,c)):(c=Math.floor(T/g),d?c===1?b?(0,L.localize)(46,null,c):(0,L.localize)(47,null,c):b?(0,L.localize)(48,null,c):(0,L.localize)(49,null,c):c===1?b?(0,L.localize)(50,null,c):(0,L.localize)(51,null,c):b?(0,L.localize)(52,null,c):(0,L.localize)(53,null,c))}e.fromNow=u;function P(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(J[76],Z([8,9]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(J[33],Z([0,1,19,3,76]),function($,e,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(p,d){return d&&(p.stack||p.stacktrace)?I.localize(0,null,w(p),R(p.stack)||R(p.stacktrace)):w(p)}function R(p){return Array.isArray(p)?p.join(`
`):p}function w(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?I.localize(1,null,p.message):p.message||I.localize(2,null)}function g(p=null,d=!1){if(!p)return I.localize(3,null);if(Array.isArray(p)){const b=L.coalesce(p),v=g(b[0],d);return b.length>1?I.localize(4,null,v,b.length):v}if(D.isString(p))return p;if(p.detail){const b=p.detail;if(b.error)return C(b.error,d);if(b.exception)return C(b.exception,d)}return p.stack?C(p,d):p.message?p.message:I.localize(5,null)}e.toErrorMessage=g;function u(p){const d=p;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=u;function P(p,d){let b;return typeof p=="string"?b=new Error(p):b=p,b.actions=d,b}e.createErrorWithActions=P}),define(J[77],Z([8,9]),function($,e){return $.create("vs/base/common/jsonErrorMessages",e)}),define(J[78],Z([0,1,77]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(I){switch(I){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=D}),define(J[50],Z([0,1,12]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var I;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(w,...g){const u=g.reduce((d,b)=>(d[b]=!0,d),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(d=>!u[d]).forEach(d=>{for(let b=0;b<P.length;b++)if(d.search(P[b])!==-1){delete w[d];break}})}e.sanitizeProcessEnvironment=C;function R(w){!w||(delete w.DEBUG,L.isMacintosh&&delete w.DYLD_LIBRARY_PATH,L.isLinux&&delete w.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(J[51],Z([0,1,31]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(f){return I(f,0)}e.hash=D;function I(f,y){switch(typeof f){case"object":return f===null?C(349,y):Array.isArray(f)?g(f,y):u(f,y);case"string":return w(f,y);case"boolean":return R(f,y);case"number":return C(f,y);case"undefined":return C(937,y);default:return C(617,y)}}e.doHash=I;function C(f,y){return(y<<5)-y+f|0}e.numberHash=C;function R(f,y){return C(f?433:863,y)}function w(f,y){y=C(149417,y);for(let E=0,S=f.length;E<S;E++)y=C(f.charCodeAt(E),y);return y}e.stringHash=w;function g(f,y){return y=C(104579,y),f.reduce((E,S)=>I(S,E),y)}function u(f,y){return y=C(181387,y),Object.keys(f).sort().reduce((E,S)=>(E=w(S,E),I(f[S],E)),y)}class P{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=I(y,this._value),this._value}}e.Hasher=P;var p;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function d(f,y,E=32){const S=E-y,m=~((1<<S)-1);return(f<<y|(m&f)>>>S)>>>0}function b(f,y=0,E=f.byteLength,S=0){for(let m=0;m<E;m++)f[y+m]=S}function v(f,y,E="0"){for(;f.length<y;)f=E+f;return f}function T(f,y=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(E=>E.toString(16).padStart(2,"0")).join(""):v((f>>>0).toString(16),y/4)}e.toHexString=T;class c{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const E=y.length;if(E===0)return;const S=this._buff;let m=this._buffLen,t=this._leftoverHighSurrogate,s,i;for(t!==0?(s=t,i=-1,t=0):(s=y.charCodeAt(0),i=0);;){let n=s;if(L.isHighSurrogate(s))if(i+1<E){const r=y.charCodeAt(i+1);L.isLowSurrogate(r)?(i++,n=L.computeCodePoint(s,r)):n=65533}else{t=s;break}else L.isLowSurrogate(s)&&(n=65533);if(m=this._push(S,m,n),i++,i<E)s=y.charCodeAt(i);else break}this._buffLen=m,this._leftoverHighSurrogate=t}_push(y,E,S){return S<128?y[E++]=S:S<2048?(y[E++]=192|(S&1984)>>>6,y[E++]=128|(S&63)>>>0):S<65536?(y[E++]=224|(S&61440)>>>12,y[E++]=128|(S&4032)>>>6,y[E++]=128|(S&63)>>>0):(y[E++]=240|(S&1835008)>>>18,y[E++]=128|(S&258048)>>>12,y[E++]=128|(S&4032)>>>6,y[E++]=128|(S&63)>>>0),E>=64&&(this._step(),E-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),T(this._h0)+T(this._h1)+T(this._h2)+T(this._h3)+T(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=c._bigBlock32,E=this._buffDV;for(let a=0;a<64;a+=4)y.setUint32(a,E.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)y.setUint32(a,d(y.getUint32(a-12,!1)^y.getUint32(a-32,!1)^y.getUint32(a-56,!1)^y.getUint32(a-64,!1),1),!1);let S=this._h0,m=this._h1,t=this._h2,s=this._h3,i=this._h4,n,r,o;for(let a=0;a<80;a++)a<20?(n=m&t|~m&s,r=1518500249):a<40?(n=m^t^s,r=1859775393):a<60?(n=m&t|m&s|t&s,r=2400959708):(n=m^t^s,r=3395469782),o=d(S,5)+n+i+r+y.getUint32(a*4,!1)&4294967295,i=s,s=t,t=d(m,30),m=S,S=o;this._h0=this._h0+S&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}c._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=c}),define(J[52],Z([0,1,31]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(D||(D={})),function(I){const C="error",R="warning",w="warn",g="info",u="ignore";function P(d){return d?L.equalsIgnoreCase(C,d)?I.Error:L.equalsIgnoreCase(R,d)||L.equalsIgnoreCase(w,d)?I.Warning:L.equalsIgnoreCase(g,d)?I.Info:I.Ignore:I.Ignore}I.fromValue=P;function p(d){switch(d){case I.Error:return C;case I.Warning:return R;case I.Info:return g;default:return u}}I.toString=p}(D||(D={})),e.default=D}),define(J[79],Z([0,1,11]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(u){const P=u;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=D;function I(u){const P=[];let p;try{const d=JSON.parse(u.arguments),b=d[d.length-1];b&&b.__$stack&&(d.pop(),p=b.__$stack),P.push(...d)}catch{P.push("Unable to log remote console arguments",u.arguments)}return{args:P,stack:p}}e.parse=I;function C(u){if(typeof u!="string")return C(I(u).stack);const P=u;if(P){const p=R(P),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=C;function R(u){if(!u)return u;const P=u.indexOf(`
`);return P===-1?u:u.substring(0,P)}function w(u,P){const{args:p,stack:d}=I(u),b=typeof p[0]=="string"&&p.length===1;let v=R(d);v&&(v=`(${v.trim()})`);let T=[];if(typeof p[0]=="string"?v&&b?T=[`%c[${P}] %c${p[0]} %c${v}`,g("blue"),g(""),g("grey")]:T=[`%c[${P}] %c${p[0]}`,g("blue"),g(""),...p.slice(1)]:T=[`%c[${P}]%`,g("blue"),...p],v&&!b&&T.push(v),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,T)}e.log=w;function g(u){return`color: ${u}`}}),define(J[53],Z([0,1,15,31,11]),function($,e,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(u){return JSON.stringify(u,w)}e.stringify=C;function R(u){let P=JSON.parse(u);return P=g(P),P}e.parse=R;function w(u,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,D.regExpFlags)(P)}:P}function g(u,P=0){if(!u||P>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return I.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof L.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let p=0;p<u.length;++p)u[p]=g(u[p],P+1);else for(const p in u)Object.hasOwnProperty.call(u,p)&&(u[p]=g(u[p],P+1))}return u}e.revive=g}),define(J[80],Z([0,1,36,7,54,30,73]),function($,e,L,D,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=I.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,p=0;const d=(0,L.networkInterfaces)();for(const b in d){const v=d[b];if(v)for(const{mac:T,internal:c}of v)c||(p+=1,this._isVirtualMachineMacAddress(T.toUpperCase())&&(P+=1))}this._value=p>0?P/p:0}return this._value}};let w;async function g(){return w||(w=(async()=>await u()||C.generateUuid())()),w}e.getMachineId=g;async function u(){try{const P=await new Promise((d,b)=>{$(["crypto"],d,b)}),p=(0,R.getMac)();return P.createHash("sha256").update(p,"utf8").digest("hex")}catch(P){D.onUnexpectedError(P);return}}}),define(J[81],Z([0,1,36,14,20]),function($,e,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,R=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var g;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(g||(g={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class p{constructor(m,t,s){this.exePath=m,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await I.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:S=!1}={}){return S?u===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:S=!1,findPreview:m=!1}={}){const t=d({useAlternateBitness:S});if(!t)return null;const s=D.join(t,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const a of await I.Promises.readdir(s)){let l=-1;if(m){const A=a.indexOf("-");if(A<0)continue;const x=a.substring(0,A);if(!C.test(x)||a.substring(A+1)!=="preview")continue;l=parseInt(x,10)}else{if(!C.test(a))continue;l=parseInt(a,10)}if(l<=i)continue;const h=D.join(s,a,"pwsh.exe");!await I.SymlinkSupport.existsFile(h)||(n=h,i=l)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",o=m?" Preview":"";return new p(n,`PowerShell${o}${r}`,!0)}async function v({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const m=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=S?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const i of await I.Promises.readdir(m))if(t.test(i)){const n=D.join(m,i,"pwsh.exe");return new p(n,s)}return null}function T(){const S=D.join(L.homedir(),".dotnet","tools","pwsh.exe");return new p(S,".NET Core PowerShell Global Tool")}function c(){const S=D.join(process.env.windir,u===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(S,"Windows PowerShell",!0)}async function*f(){let S=await b();S&&(yield S),S=await b({useAlternateBitness:!0}),S&&(yield S),S=await v(),S&&(yield S),S=T(),S&&(yield S),S=await b({findPreview:!0}),S&&(yield S),S=await v({findPreview:!0}),S&&(yield S),S=await b({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=c(),S&&(yield S)}async function*y(){for await(const S of f())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=y;async function E(){for await(const S of y())return S;return null}e.getFirstAvailablePowerShellInstallation=E}),define(J[55],Z([0,1,14,12,37,50,3,20]),function($,e,L,D,I,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function g(p=I.env){return p.comspec||"cmd.exe"}e.getWindowsShell=g;function u(p){let d=[],b=!1;const v=function(T){if(b){d.push(T);return}(!p.send(T,f=>{if(f&&console.error(f),b=!1,d.length>0){const y=d.slice(0);d=[],y.forEach(E=>v(E))}})||D.isWindows)&&(b=!0)};return{send:v}}e.createQueuedSender=u;var P;(function(p){async function d(b,v,T){if(L.isAbsolute(b))return b;if(v===void 0&&(v=I.cwd()),L.dirname(b)!=="."||(T===void 0&&R.isString(I.env.PATH)&&(T=I.env.PATH.split(L.delimiter)),T===void 0||T.length===0))return L.join(v,b);async function f(y){if(await w.Promises.exists(y)){let E;try{E=await w.Promises.stat(y)}catch(S){S.message.startsWith("EACCES")&&(E=await w.Promises.lstat(y))}return E?!E.isDirectory():!1}return!1}for(const y of T){let E;if(L.isAbsolute(y)?E=L.join(y,b):E=L.join(v,y,b),await f(E))return E;let S=E+".com";if(await f(S)||(S=E+".exe",await f(S)))return S}return L.join(v,b)}p.findExecutable=d})(P=e.win32||(e.win32={}))}),define(J[82],Z([0,1,36,12,81,55]),function($,e,L,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(p,d){return p===1?D.isWindows?P():C.getWindowsShell(d):g(p,d)}e.getSystemShell=R;let w=null;function g(p,d){if(D.isLinux&&p===2||D.isMacintosh&&p===3)return"/bin/bash";if(!w){let b;if(D.isWindows)b="/bin/bash";else{if(b=d.SHELL,!b)try{b=(0,L.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}w=b}return w}let u=null;async function P(){return u||(u=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),u}});var fe=this&&this.__decorate||function($,e,L,D){var I=arguments.length,C=I<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate($,e,L,D);else for(var w=$.length-1;w>=0;w--)(R=$[w])&&(C=(I<3?R(C):I>3?R(e,L,C):R(e,L))||C);return I>3&&C&&Object.defineProperty(e,L,C),C};define(J[56],Z([0,1,19,5,15,22,48,7,4,2,53,31,3]),function($,e,L,D,I,C,R,w,g,u,P,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var b;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(b||(b={}));function v(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var T;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(T||(T={}));function c(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(f||(f={}));function y(M){let F=0;for(let j=0;;j+=7){const z=M.read(1);if(F|=(z.buffer[0]&127)<<j,!(z.buffer[0]&128))return F}}const E=i(0);function S(M,F){if(F===0){M.write(E);return}let j=0;for(let B=F;B!==0;B=B>>>7)j++;const z=I.VSBuffer.alloc(j);for(let B=0;F!==0;B++)z.buffer[B]=F&127,F=F>>>7,F>0&&(z.buffer[B]|=128);M.write(z)}class m{constructor(F){this.buffer=F,this.pos=0}read(F){const j=this.buffer.slice(this.pos,this.pos+F);return this.pos+=j.byteLength,j}}e.BufferReader=m;class t{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}e.BufferWriter=t;var s;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(s||(s={}));function i(M){const F=I.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object),Uint:i(s.Int)},r=typeof Buffer<"u";function o(M,F){if(typeof F>"u")M.write(n.Undefined);else if(typeof F=="string"){const j=I.VSBuffer.fromString(F);M.write(n.String),S(M,j.byteLength),M.write(j)}else if(r&&Buffer.isBuffer(F)){const j=I.VSBuffer.wrap(F);M.write(n.Buffer),S(M,j.byteLength),M.write(j)}else if(F instanceof I.VSBuffer)M.write(n.VSBuffer),S(M,F.byteLength),M.write(F);else if(Array.isArray(F)){M.write(n.Array),S(M,F.length);for(const j of F)o(M,j)}else if(typeof F=="number"&&(F|0)===F)M.write(n.Uint),S(M,F);else{const j=I.VSBuffer.fromString(JSON.stringify(F));M.write(n.Object),S(M,j.byteLength),M.write(j)}}e.serialize=o;function a(M){switch(M.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return M.read(y(M)).toString();case s.Buffer:return M.read(y(M)).buffer;case s.VSBuffer:return M.read(y(M));case s.Array:{const j=y(M),z=[];for(let B=0;B<j;B++)z.push(a(M));return z}case s.Object:return JSON.parse(M.read(y(M)).toString());case s.Int:return y(M)}}e.deserialize=a;class l{constructor(F,j,z=null,B=1e3){this.protocol=F,this.ctx=j,this.logger=z,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(F,j){this.channels.set(F,j),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const j=this.send([F.type]);this.logger?.logOutgoing(j,0,1,c(F.type));return}case 201:case 202:case 204:case 203:{const j=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(j,F.id,1,c(F.type),F.data);return}}}send(F,j=void 0){const z=new t;return o(z,F),o(z,j),this.sendBuffer(z.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const j=new m(F),z=a(j),B=a(j),X=z[0];switch(X){case 100:return this.logger?.logIncoming(F.byteLength,z[1],1,`${v(X)}: ${z[2]}.${z[3]}`,B),this.onPromise({type:X,id:z[1],channelName:z[2],name:z[3],arg:B});case 102:return this.logger?.logIncoming(F.byteLength,z[1],1,`${v(X)}: ${z[2]}.${z[3]}`,B),this.onEventListen({type:X,id:z[1],channelName:z[2],name:z[3],arg:B});case 101:return this.logger?.logIncoming(F.byteLength,z[1],1,`${v(X)}`),this.disposeActiveRequest({type:X,id:z[1]});case 103:return this.logger?.logIncoming(F.byteLength,z[1],1,`${v(X)}`),this.disposeActiveRequest({type:X,id:z[1]})}}onPromise(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const z=new C.CancellationTokenSource;let B;try{B=j.call(this.ctx,F.name,F.arg,z.token)}catch(k){B=Promise.reject(k)}const X=F.id;B.then(k=>{this.sendResponse({id:X,data:k,type:201}),this.activeRequests.delete(F.id)},k=>{k instanceof Error?this.sendResponse({id:X,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:X,data:k,type:203}),this.activeRequests.delete(F.id)});const N=(0,u.toDisposable)(()=>z.cancel());this.activeRequests.set(F.id,N)}onEventListen(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const z=F.id,X=j.listen(this.ctx,F.name,F.arg)(N=>this.sendResponse({id:z,data:N,type:204}));this.activeRequests.set(F.id,X)}disposeActiveRequest(F){const j=this.activeRequests.get(F.id);j&&(j.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let j=this.pendingRequests.get(F.channelName);j||(j=[],this.pendingRequests.set(F.channelName,j));const z=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:F,timeoutTimer:z})}flushPendingRequests(F){const j=this.pendingRequests.get(F);if(j){for(const z of j)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var h;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(F,j=null){this.protocol=F,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=j}getChannel(F){const j=this;return{call(z,B,X){return j.isDisposed?Promise.reject(new w.CancellationError):j.requestPromise(F,z,B,X)},listen(z,B){return j.isDisposed?g.Event.None:j.requestEvent(F,z,B)}}}requestPromise(F,j,z,B=C.CancellationToken.None){const X=this.lastRequestId++,k={id:X,type:100,channelName:F,name:j,arg:z};if(B.isCancellationRequested)return Promise.reject(new w.CancellationError);let O;return new Promise((W,G)=>{if(B.isCancellationRequested)return G(new w.CancellationError);const H=()=>{const me=le=>{switch(le.type){case 201:this.handlers.delete(X),W(le.data);break;case 202:{this.handlers.delete(X);const de=new Error(le.data.message);de.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,de.name=le.data.name,G(de);break}case 203:this.handlers.delete(X),G(le.data);break}};this.handlers.set(X,me),this.sendRequest(k)};let re=null;this.state===f.Idle?H():(re=(0,D.createCancelablePromise)(me=>this.whenInitialized()),re.then(()=>{re=null,H()}));const ce=()=>{re?(re.cancel(),re=null):this.sendRequest({id:X,type:101}),G(new w.CancellationError)},Ee=B.onCancellationRequested(ce);O=(0,u.combinedDisposable)((0,u.toDisposable)(ce),Ee),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(F,j,z){const B=this.lastRequestId++,N={id:B,type:102,channelName:F,name:j,arg:z};let k=null;const O=new g.Emitter({onWillAddFirstListener:()=>{k=(0,D.createCancelablePromise)(W=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(O),this.sendRequest(N)})},onDidRemoveLastListener:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(O),this.sendRequest({id:B,type:103}))}}),U=W=>O.fire(W.data);return this.handlers.set(B,U),O.event}sendRequest(F){switch(F.type){case 100:case 102:{const j=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(j,F.id,0,`${v(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const j=this.send([F.type,F.id]);this.logger?.logOutgoing(j,F.id,0,v(F.type));return}}}send(F,j=void 0){const z=new t;return o(z,F),o(z,j),this.sendBuffer(z.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const j=new m(F),z=a(j),B=a(j),X=z[0];switch(X){case 200:return this.logger?.logIncoming(F.byteLength,0,0,c(X)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,z[1],0,c(X),B),this.onResponse({type:z[0],id:z[1],data:B})}}onResponse(F){if(F.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}fe([R.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class x{get connections(){const F=[];return this._connections.forEach(j=>F.push(j)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:j,onDidClientDisconnect:z})=>{g.Event.once(j.onMessage)(X=>{const N=new m(X),k=a(N),O=new l(j,k),U=new A(j);this.channels.forEach((G,H)=>O.registerChannel(H,G));const W={channelServer:O,channelClient:U,ctx:k};this._connections.add(W),this._onDidAddConnection.fire(W),z(()=>{O.dispose(),U.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}getChannel(F,j){const z=this;return{call(B,X,N){let k;if((0,d.isFunction)(j)){const U=(0,L.getRandomElement)(z.connections.filter(j));k=U?Promise.resolve(U):g.Event.toPromise(g.Event.filter(z.onDidAddConnection,j))}else k=j.routeCall(z,B,X);const O=k.then(U=>U.channelClient.getChannel(F));return Q(O).call(B,X,N)},listen(B,X){if((0,d.isFunction)(j))return z.getMulticastEvent(F,j,B,X);const N=j.routeEvent(z,B,X).then(k=>k.channelClient.getChannel(F));return Q(N).listen(B,X)}}}getMulticastEvent(F,j,z,B){const X=this;let N=new u.DisposableStore;const k=new g.Emitter({onWillAddFirstListener:()=>{N=new u.DisposableStore;const O=new g.EventMultiplexer,U=new Map,W=H=>{const ce=H.channelClient.getChannel(F).listen(z,B),Ee=O.add(ce);U.set(H,Ee)},G=H=>{const re=U.get(H);!re||(re.dispose(),U.delete(H))};X.connections.filter(j).forEach(W),g.Event.filter(X.onDidAddConnection,j)(W,void 0,N),X.onDidRemoveConnection(G,void 0,N),O.event(k.fire,k,N),N.add(O)},onDidRemoveLastListener:()=>{N.dispose()}});return k.event}registerChannel(F,j){this.channels.set(F,j),this._connections.forEach(z=>{z.channelServer.registerChannel(F,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=x;class Y{constructor(F,j,z=null){const B=new t;o(B,j),F.send(B.buffer),this.channelClient=new A(F,z),this.channelServer=new l(F,j,z)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,j){this.channelServer.registerChannel(F,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=Y;function Q(M){return{call(F,j,z){return M.then(B=>B.call(F,j,z))},listen(F,j){const z=new g.Relay;return M.then(B=>z.input=B.listen(F,j)),z.event}}}e.getDelayedChannel=Q;function te(M){let F=!1;return{call(j,z,B){return F?M.call(j,z,B):(0,D.timeout)(0).then(()=>F=!0).then(()=>M.call(j,z,B))},listen(j,z){if(F)return M.listen(j,z);const B=new g.Relay;return(0,D.timeout)(0).then(()=>F=!0).then(()=>B.input=M.listen(j,z)),B.event}}}e.getNextTickChannel=te;class ie{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const j of F.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await g.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=ie;var ne;(function(M){function F(X,N){const k=X,O=N&&N.disableMarshalling,U=new Map;for(const W in k)z(W)&&U.set(W,g.Event.buffer(k[W],!0));return new class{listen(W,G,H){const re=U.get(G);if(re)return re;if(B(G)){const ce=k[G];if(typeof ce=="function")return ce.call(k,H)}throw new Error(`Event not found: ${G}`)}call(W,G,H){const re=k[G];if(typeof re=="function"){if(!O&&Array.isArray(H))for(let ce=0;ce<H.length;ce++)H[ce]=(0,P.revive)(H[ce]);return re.apply(k,H)}throw new Error(`Method not found: ${G}`)}}}M.fromService=F;function j(X,N){const k=N&&N.disableMarshalling;return new Proxy({},{get(O,U){if(typeof U=="string")return N?.properties?.has(U)?N.properties.get(U):B(U)?function(W){return X.listen(U,W)}:z(U)?X.listen(U):async function(...W){let G;N&&!(0,d.isUndefinedOrNull)(N.context)?G=[N.context,...W]:G=W;const H=await X.call(U,G);return k?H:(0,P.revive)(H)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=j;function z(X){return X[0]==="o"&&X[1]==="n"&&p.isUpperAsciiLetter(X.charCodeAt(2))}function B(X){return/^onDynamic/.test(X)&&p.isUpperAsciiLetter(X.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const F=M.toString();if(F!=="[object Object]")return F}return M}function se(M){return Array.isArray(M)?M.map(ue):ue(M)}function pe(M,F,j,z,B,X,N){N=se(N);const k=ae[B],O=k[z%k.length];let U=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(X)?(U=U.concat(N),U.push(")")):U.push(N),console.log.apply(console,U)}class V{constructor(F,j){this._outgoingPrefix=F,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,j,z,B,X){this._totalOutgoing+=F,pe(this._outgoingPrefix,this._totalOutgoing,F,j,z,B,X)}logIncoming(F,j,z,B,X){this._totalIncoming+=F,pe(this._incomingPrefix,this._totalIncoming,F,j,z,B,X)}}e.IPCLogger=V}),define(J[83],Z([0,1,57,5,15,22,79,7,4,2,29,55,50,56]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends b.ChannelServer{constructor(f){super({send:y=>{try{process.send?.(y.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",y=>I.VSBuffer.wrap(Buffer.from(y,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=v;class T{constructor(f,y){this.modulePath=f,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new D.Delayer(E),this.child=null,this._client=null}getChannel(f){const y=this;return{call(E,S,m){return y.requestPromise(f,E,S,m)},listen(E,S){return y.requestEvent(f,E,S)}}}requestPromise(f,y,E,S=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const m=this.getCachedChannel(f),t=(0,D.createCancelablePromise)(n=>m.call(y,E,n)),s=S.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{s.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(f,y,E){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let S;const m=new g.Emitter({onWillAddFirstListener:()=>{S=this.getCachedChannel(f).listen(y,E)(m.fire,m),this.activeRequests.add(S)},onDidRemoveLastListener:()=>{this.activeRequests.delete(S),S.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return m.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,d.removeDangerousEnvVariables)(y.env),this.child=(0,L.fork)(this.modulePath,f,y);const E=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,R.isRemoteConsoleLog)(r)){(0,R.log)(r,`IPC Library: ${this.options.serverName}`);return}E.fire(I.VSBuffer.wrap(Buffer.from(r,"base64")))});const m=this.options.useQueue?(0,p.createQueuedSender)(this.child):this.child,t=r=>this.child&&this.child.connected&&m.send(r.buffer.toString("base64")),s=E.event,i={send:t,onMessage:s};this._client=new b.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,o)=>{process.removeListener("exit",n),this.activeRequests.forEach(a=>(0,u.dispose)(a)),this.activeRequests.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:o})})}return this._client}getCachedChannel(f){let y=this.channels.get(f);return y||(y=this.client.getChannel(f),this.channels.set(f,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=T}),define(J[84],Z([0,1,5,4,2,3]),function($,e,L,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R=e.StorageHint||(e.StorageHint={}));function w(p){const d=p;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=w;var g;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class u extends I.Disposable{constructor(d,b=Object.create(null)){super(),this.database=d,this.options=b,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((b,v)=>this.accept(v,b)),d.deleted?.forEach(b=>this.accept(b,void 0))}accept(d,b){if(this.state===g.Closed)return;let v=!1;(0,C.isUndefinedOrNull)(b)?v=this.cache.delete(d):this.cache.get(d)!==b&&(this.cache.set(d,b),v=!0),v&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,b){const v=this.cache.get(d);return(0,C.isUndefinedOrNull)(v)?b:v}getBoolean(d,b){const v=this.get(d);return(0,C.isUndefinedOrNull)(v)?b:v==="true"}getNumber(d,b){const v=this.get(d);return(0,C.isUndefinedOrNull)(v)?b:parseInt(v,10)}async set(d,b){if(this.state===g.Closed)return;if((0,C.isUndefinedOrNull)(b))return this.delete(d);const v=String(b);if(this.cache.get(d)!==v)return this.cache.set(d,v),this.pendingInserts.set(d,v),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===g.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}u.DEFAULT_FLUSH_DELAY=100,e.Storage=u;class P{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert?.forEach((b,v)=>this.items.set(v,b)),d.delete?.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=P}),define(J[85],Z([8,9]),function($,e){return $.create("vs/base/node/zip",e)}),define(J[86],Z([8,9]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[87],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(J[88],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[89],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(J[90],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(J[91],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(J[92],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(J[93],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(J[94],Z([8,9]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[95],Z([8,9]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(J[96],Z([8,9]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(J[97],Z([8,9]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[98],Z([8,9]),function($,e){return $.create("vs/platform/languagePacks/common/languagePacks",e)}),define(J[99],Z([8,9]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(J[100],Z([8,9]),function($,e){return $.create("vs/platform/shell/node/shellEnv",e)}),define(J[101],Z([8,9]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[102],Z([8,9]),function($,e){return $.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(J[103],Z([8,9]),function($,e){return $.create("vs/platform/workspace/common/workspace",e)}),define(J[104],Z([0,1,75,48,16,14,37,18,11]),function($,e,L,D,I,C,R,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,C.dirname)(I.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,w.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,C.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(g.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,w.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,w.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=R.env.VSCODE_PORTABLE;return v?g.URI.file((0,C.join)(v,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,C.resolve)(v):(0,C.normalize)((0,C.join)(I.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?g.URI.file((0,C.resolve)(v)):g.URI.file((0,C.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,C.resolve)(v);const T=R.env.VSCODE_EXTENSIONS;if(T)return T;const c=R.env.VSCODE_PORTABLE;return c?(0,C.join)(c,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(T=>/^[^:/?#]+?:\/\//.test(T)?g.URI.parse(T):g.URI.file((0,C.normalize)(T)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?g.URI.parse(v):g.URI.file((0,C.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const T of this.args.log||[]){const c=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(T);c&&c[1]&&c[2]&&v.push([c[1],c[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,w.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=R.env.VSCODE_PORTABLE;return v?g.URI.file((0,C.join)(v,"policy.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this._args}constructor(v,T,c){this._args=v,this.paths=T,this.productService=c,this.editSessionId=this.args.editSessionId}}fe([D.memoize],u.prototype,"appRoot",null),fe([D.memoize],u.prototype,"userHome",null),fe([D.memoize],u.prototype,"userDataPath",null),fe([D.memoize],u.prototype,"appSettingsHome",null),fe([D.memoize],u.prototype,"tmpDir",null),fe([D.memoize],u.prototype,"cacheHome",null),fe([D.memoize],u.prototype,"stateResource",null),fe([D.memoize],u.prototype,"userRoamingDataHome",null),fe([D.memoize],u.prototype,"userDataSyncHome",null),fe([D.memoize],u.prototype,"userDataSyncLogResource",null),fe([D.memoize],u.prototype,"editSessionsLogResource",null),fe([D.memoize],u.prototype,"sync",null),fe([D.memoize],u.prototype,"machineSettingsResource",null),fe([D.memoize],u.prototype,"workspaceStorageHome",null),fe([D.memoize],u.prototype,"localHistoryHome",null),fe([D.memoize],u.prototype,"keyboardLayoutResource",null),fe([D.memoize],u.prototype,"argvResource",null),fe([D.memoize],u.prototype,"isExtensionDevelopment",null),fe([D.memoize],u.prototype,"untitledWorkspacesHome",null),fe([D.memoize],u.prototype,"installSourcePath",null),fe([D.memoize],u.prototype,"builtinExtensionsPath",null),fe([D.memoize],u.prototype,"extensionsPath",null),fe([D.memoize],u.prototype,"extensionDevelopmentLocationURI",null),fe([D.memoize],u.prototype,"extensionDevelopmentKind",null),fe([D.memoize],u.prototype,"extensionTestsLocationURI",null),fe([D.memoize],u.prototype,"debugExtensionHost",null),fe([D.memoize],u.prototype,"logLevel",null),fe([D.memoize],u.prototype,"extensionLogLevel",null),fe([D.memoize],u.prototype,"serviceMachineIdResource",null),fe([D.memoize],u.prototype,"telemetryLogResource",null),fe([D.memoize],u.prototype,"disableWorkspaceTrust",null),fe([D.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function P(b,v){return d(b["inspect-extensions"],b["inspect-brk-extensions"],5870,v,b.debugId,b.extensionEnvironment)}e.parseExtensionHostPort=P;function p(b,v){return d(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,v,b.extensionEnvironment)}e.parsePtyHostPort=p;function d(b,v,T,c,f,y){const S=Number(v||b)||(c?null:T),m=S?Boolean(!!v):!1;let t;if(y)try{t=JSON.parse(y)}catch{}return{port:S,break:m,debugId:f,env:t}}}),define(J[105],Z([0,1,36,104,156]),function($,e,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends D.AbstractNativeEnvironmentService{constructor(w,g){super(w,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,I.getUserDataPath)(w,g.nameShort)},g)}}e.NativeEnvironmentService=C}),define(J[106],Z([0,1,3,90]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function I(R,w,g){try{C(R,w,g)}catch(u){console.error(u?.message??u)}return R}e.localizeManifest=I;function C(R,w,g){const u=(P,p,d)=>{const b=P[p];if((0,L.isString)(b)){const v=b,T=v.length;if(T>1&&v[0]==="%"&&v[T-1]==="%"){const c=v.substr(1,T-2);let f=w[c];f===void 0&&g&&(f=g[c]);const y=typeof f=="string"?f:f?.message,E=g?.[c],S=typeof E=="string"?E:E?.message;if(!y){S||console.warn(`[${R.name}]: ${(0,D.localize)(0,null,c)}`);return}if(d&&(p==="title"||p==="category")&&S&&S!==y){const m={value:y,original:S};P[p]=m}else P[p]=y}}else if((0,L.isObject)(b))for(const v in b)b.hasOwnProperty(v)&&(v==="commands"?u(b,v,!0):u(b,v,d));else if(Array.isArray(b))for(let v=0;v<b.length;v++)u(b,v,d)};for(const P in R)R.hasOwnProperty(P)&&u(R,P)}}),define(J[107],Z([0,1,7]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this._generators=new Map}register(C,R){this._generators.set(C,R)}updateManifest(C){if(!(typeof C.main>"u"&&typeof C.browser>"u")&&(C.activationEvents===void 0&&Object.assign(C,{activationEvents:[]}),!(!Array.isArray(C.activationEvents)||!C.contributes)))for(const R in C.contributes){const w=this._generators.get(R);if(!w)continue;const g=C.contributes[R],u=Array.isArray(g)?g:[g];try{w(u,C.activationEvents)}catch(P){(0,L.onUnexpectedError)(P)}}}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(J[44],Z([0,1,18,52,94,41]),function($,e,L,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||R.test(f)}e.isValidVersionStr=g;function u(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const y=f.match(R);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=u;function P(f){if(!f)return null;const y=f.majorBase,E=f.majorMustEqual,S=f.minorBase;let m=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(y===0||(m=!1),s=!1);let i=0;if(f.preRelease){const n=w.exec(f.preRelease);if(n){const[,r,o,a]=n;i=Date.UTC(Number(r),Number(o)-1,Number(a))}}return{majorBase:y,majorMustEqual:E,minorBase:S,minorMustEqual:m,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=P;function p(f,y,E){let S;typeof f=="string"?S=P(u(f)):S=f;let m;y instanceof Date?m=y.getTime():typeof y=="string"&&(m=new Date(y).getTime());let t;if(typeof E=="string"?t=P(u(E)):t=E,!S||!t)return!1;const s=S.majorBase,i=S.minorBase,n=S.patchBase;let r=t.majorBase,o=t.minorBase,a=t.patchBase;const l=t.notBefore;let h=t.majorMustEqual,A=t.minorMustEqual,x=t.patchMustEqual;return t.isMinimum?s>r?!0:s<r?!1:i>o?!0:i<o||m&&m<l?!1:n>=a:(s===1&&r===0&&(!h||!A||!x)&&(r=1,o=0,a=0,h=!0,A=!1,x=!1),s<r?!1:s>r?!h:i<o?!1:i>o?!A:n<a?!1:n>a?!x:!(m&&m<l))}e.isValidVersion=p;function d(f,y,E,S,m){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([D.default.Error,I.localize(0,null)]),t;if(typeof S.name!="string")return t.push([D.default.Error,I.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([D.default.Error,I.localize(2,null,"version")]),t;if(!S.engines)return t.push([D.default.Error,I.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([D.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!c(S.extensionDependencies))return t.push([D.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!c(S.activationEvents))return t.push([D.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([D.default.Error,I.localize(7,null,"activationEvents","main")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([D.default.Warning,I.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([D.default.Error,I.localize(9,null,"main")]),t;{const n=(0,L.joinPath)(E,S.main);(0,L.isEqualOrParent)(n,E)||t.push([D.default.Warning,I.localize(10,null,n.path,E.path)])}if(typeof S.activationEvents>"u")return t.push([D.default.Error,I.localize(11,null,"activationEvents","main")]),t}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([D.default.Error,I.localize(12,null,"browser")]),t;{const n=(0,L.joinPath)(E,S.browser);(0,L.isEqualOrParent)(n,E)||t.push([D.default.Warning,I.localize(13,null,n.path,E.path)])}if(typeof S.activationEvents>"u")return t.push([D.default.Error,I.localize(14,null,"activationEvents","browser")]),t}if(!C.valid(S.version))return t.push([D.default.Error,I.localize(15,null)]),t;const s=[];if(!b(f,y,S,m,s))for(const n of s)t.push([D.default.Error,n]);return t}e.validateExtensionManifest=d;function b(f,y,E,S,m){return S||typeof E.main>"u"&&typeof E.browser>"u"?!0:T(f,y,E.engines.vscode,m)}e.isValidExtensionVersion=b;function v(f,y,E){return f==="*"||T(y,E,f)}e.isEngineValid=v;function T(f,y,E,S=[]){const m=P(u(E));if(!m)return S.push(I.localize(16,null,E)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return S.push(I.localize(17,null,E)),!1}else if(!m.majorMustEqual)return S.push(I.localize(18,null,E)),!1;return p(f,y,m)?!0:(S.push(I.localize(19,null,f,E)),!1)}function c(f){if(!Array.isArray(f))return!1;for(let y=0,E=f.length;y<E;y++)if(typeof f[y]!="string")return!1;return!0}}),define(J[108],Z([0,1,15,30]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function I(C,R,w){let g=w&&w.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const P=(await R.readFile(C.serviceMachineIdResource)).value.toString();g=(0,D.isUUID)(P)?P:null}catch{g=null}if(!g){g=(0,D.generateUuid)();try{await R.writeFile(C.serviceMachineIdResource,L.VSBuffer.fromString(g))}catch{}}return w?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=I}),define(J[45],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(I,C=[],R=!1){this.ctor=I,this.staticArguments=C,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=L}),define(J[109],Z([0,1,45]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var I;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function C(w,g,u){g instanceof L.SyncDescriptor||(g=new L.SyncDescriptor(g,[],Boolean(u))),D.push([w,g])}e.registerSingleton=C;function R(){return D}e.getSingletonServiceDescriptors=R}),define(J[110],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(C,R){this.key=C,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class D{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(const R of this._nodes.values())R.outgoing.size===0&&C.push(R);return C}insertEdge(C,R){const w=this.lookupOrInsertNode(C),g=this.lookupOrInsertNode(R);w.outgoing.set(g.key,g),g.incoming.set(w.key,w)}removeNode(C){const R=this._hashFn(C);this._nodes.delete(R);for(const w of this._nodes.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(C){const R=this._hashFn(C);let w=this._nodes.get(R);return w||(w=new L(R,C),this._nodes.set(R,w)),w}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){const C=[];for(const[R,w]of this._nodes)C.push(`${R}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,R]of this._nodes){const w=new Set([C]),g=this._findCycle(R,w);if(g)return g}}_findCycle(C,R){for(const[w,g]of C.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const u=this._findCycle(g,R);if(u)return u;R.delete(w)}}}e.Graph=D}),define(J[23],Z([0,1,3,11,10]),function($,e,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function C(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}e.isConfigurationOverrides=C;function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=R;var w;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function u(c,f){const y=Object.create(null);for(const E in c)P(y,E,c[E],f);return y}e.toValuesTree=u;function P(c,f,y,E){const S=f.split("."),m=S.pop();let t=c;for(let s=0;s<S.length;s++){const i=S[s];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${f} as ${S.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[m]=y}catch{E(`Ignoring ${f} as ${S.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${f} as ${S.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=P;function p(c,f){const y=f.split(".");d(c,y)}e.removeFromValueTree=p;function d(c,f){const y=f.shift();if(f.length===0){delete c[y];return}if(Object.keys(c).indexOf(y)!==-1){const E=c[y];typeof E=="object"&&!Array.isArray(E)&&(d(E,f),Object.keys(E).length===0&&delete c[y])}}function b(c,f,y){function E(t,s){let i=t;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const S=f.split("."),m=E(c,S);return typeof m>"u"?y:m}e.getConfigurationValue=b;function v(c,f,y){Object.keys(f).forEach(E=>{E!=="__proto__"&&(E in c?L.isObject(c[E])&&L.isObject(f[E])?v(c[E],f[E],y):y&&(c[E]=f[E]):c[E]=f[E])})}e.merge=v;function T(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=T}),define(J[58],Z([0,1,10]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(J[17],Z([0,1,10]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(J[24],Z([0,1,88,10]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function I(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function C(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function R(f,y){switch(f){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function w(f,y){return y==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function g(f,y,E){return w(y,E)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===E?!0:u(E).includes(f)}e.isTargetPlatformCompatible=g;function u(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function P(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=P;var p;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var d;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var b;(function(f){f.Install="install",f.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var T;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(T=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(y,E){super(y),this.code=E,this.name=E}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(J[59],Z([0,1,10]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class D{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((C,R)=>$(["node-vsce-sign"],async w=>C(w),R))),this.moduleLoadingPromise}async verify(C,R){let w;try{w=await this.vsceSign()}catch{return!1}return w.verify(C,R)}}e.ExtensionSignatureVerificationService=D}),define(J[60],Z([0,1,15,7,96,13]),function($,e,L,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(P,p,d,b,v,T){let c;try{await w(P,p,d,b,v,T)}catch(f){c=f}finally{c&&v.errorTransformer&&(c=v.errorTransformer(c)),typeof c<"u"&&d.error(c),d.end()}}e.readFileIntoStream=R;async function w(P,p,d,b,v,T){g(T);const c=await P.open(p,{create:!1});try{g(T);let f=0,y=0,E=v&&typeof v.length=="number"?v.length:void 0,S=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof E=="number"?E:v.bufferSize)),m=v&&typeof v.position=="number"?v.position:0,t=0;do y=await P.read(c,m,S.buffer,t,S.byteLength-t),m+=y,t+=y,f+=y,typeof E=="number"&&(E-=y),t===S.byteLength&&(await d.write(b(S)),S=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof E=="number"?E:v.bufferSize)),t=0);while(y>0&&(typeof E!="number"||E>0)&&g(T)&&u(f,v));if(t>0){let s=t;typeof E=="number"&&(s=Math.min(t,E)),d.write(b(S.slice(0,s)))}}catch(f){throw(0,C.ensureFileSystemProviderError)(f)}finally{await P.close(c)}}function g(P){if(P.isCancellationRequested)throw(0,D.canceled)();return!0}function u(P,p){if(p?.limits){if(typeof p.limits.memory=="number"&&P>p.limits.memory)throw(0,C.createFileSystemProviderError)((0,I.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&P>p.limits.size)throw(0,C.createFileSystemProviderError)((0,I.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[111],Z([0,1,4,157,2,12,158]),function($,e,L,D,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends I.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new L.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=L.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(u){const P=this.normalizeRequests(u),p=P.filter(b=>{const v=this.watchers.get(b.path);return v?!(0,D.patternsEquals)(v.request.excludes,b.excludes)||!(0,D.patternsEquals)(v.request.includes,b.includes):!0}),d=Array.from(this.watchers.values()).filter(({request:b})=>!P.find(v=>v.path===b.path&&(0,D.patternsEquals)(v.excludes,b.excludes)&&(0,D.patternsEquals)(v.includes,b.includes))).map(({request:b})=>b.path);p.length&&this.trace(`Request to start watching: ${p.map(b=>`${b.path} (excludes: ${b.excludes.length>0?b.excludes:"<none>"}, includes: ${b.includes&&b.includes.length>0?JSON.stringify(b.includes):"<all>"})`).join(",")}`),d.length&&this.trace(`Request to stop watching: ${d.join(",")}`);for(const b of d)this.stopWatching(b);for(const b of p)this.startWatching(b)}startWatching(u){const P=new R.NodeJSFileWatcherLibrary(u,d=>this._onDidChangeFile.fire(d),d=>this._onDidLogMessage.fire(d),this.verboseLogging),p={request:u,instance:P};this.watchers.set(u.path,p)}async stop(){for(const[u]of this.watchers)this.stopWatching(u);this.watchers.clear()}stopWatching(u){const P=this.watchers.get(u);P&&(this.watchers.delete(u),P.instance.dispose())}normalizeRequests(u){const P=new Map;for(const p of u){const d=C.isLinux?p.path:p.path.toLowerCase();P.set(d,p)}return Array.from(P.values())}async setVerboseLogging(u){this.verboseLogging=u;for(const[,P]of this.watchers)P.instance.setVerboseLogging(u)}trace(u){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(u)})}toMessage(u,P){return P?`[File Watcher (node.js)] ${u} (path: ${P.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=w}),define(J[112],Z([0,1,61,111]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class I extends L.AbstractNonRecursiveWatcherClient{constructor(R,w,g){super(R,w,g),this.init()}createWatcher(){return new D.NodeJSWatcher}}e.NodeJSWatcherClient=I}),define(J[113],Z([0,1,16,56,83,61]),function($,e,L,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends C.AbstractUniversalWatcherClient{constructor(g,u,P){super(g,u,P),this.init()}createWatcher(g){const u=g.add(new I.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(u.onDidProcessExit(({code:P,signal:p})=>this.onError(`terminated by itself with code ${P}, signal: ${p}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(J[62],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...I){this._entries=new Map;for(const[C,R]of I)this.set(C,R)}set(I,C){const R=this._entries.get(I);return this._entries.set(I,C),R}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=L}),define(J[114],Z([0,1,5,7,2,45,110,10,62,159]),function($,e,L,D,I,C,R,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class p extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class d{constructor(c=new g.ServiceCollection,f=!1,y,E=P){this._services=c,this._strict=f,this._parent=y,this._enableTracing=E,this._activeInstantiations=new Set,this._services.set(w.IInstantiationService,this),this._globalGraph=E?y?._globalGraph??new R.Graph(S=>S):void 0}createChild(c){return new d(c,this._strict,this,this._enableTracing)}invokeFunction(c,...f){const y=v.traceInvocation(this._enableTracing,c);let E=!1;try{return c({get:m=>{if(E)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(m,y);if(!t)throw new Error(`[invokeFunction] unknown service '${m}'`);return t}},...f)}finally{E=!0,y.stop()}}createInstance(c,...f){let y,E;return c instanceof C.SyncDescriptor?(y=v.traceCreation(this._enableTracing,c.ctor),E=this._createInstance(c.ctor,c.staticArguments.concat(f),y)):(y=v.traceCreation(this._enableTracing,c),E=this._createInstance(c,f,y)),y.stop(),E}_createInstance(c,f=[],y){const E=w._util.getServiceDependencies(c).sort((t,s)=>t.index-s.index),S=[];for(const t of E){const s=this._getOrCreateServiceInstance(t.id,y);s||this._throwIfStrict(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(s)}const m=E.length>0?E[0].index:f.length;if(f.length!==m){console.trace(`[createInstance] First service dependency of ${c.name} at position ${m+1} conflicts with ${f.length} static arguments`);const t=m-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,m)}return Reflect.construct(c,f.concat(S))}_setServiceInstance(c,f){if(this._services.get(c)instanceof C.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){const f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(c));const y=this._getServiceInstanceOrDescriptor(c);return y instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,y,f.branch(c,!0)):(f.branch(c,!1),y)}_safeCreateAndCacheServiceInstance(c,f,y){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,y)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,y){const E=new R.Graph(t=>t.id.toString());let S=0;const m=[{id:c,desc:f,_trace:y}];for(;m.length;){const t=m.pop();if(E.lookupOrInsertNode(t),S++>1e3)throw new p(E);for(const s of w._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(s.id);if(i||this._throwIfStrict(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),i instanceof C.SyncDescriptor){const n={id:s.id,desc:i,_trace:t._trace.branch(s.id,!0)};E.insertEdge(t,n),m.push(n)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new p(E);break}for(const{data:s}of t){if(this._getServiceInstanceOrDescriptor(s.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}E.removeNode(s)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,y=[],E,S){if(this._services.get(c)instanceof C.SyncDescriptor)return this._createServiceInstance(c,f,y,E,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,y,E,S);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f,y=[],E,S){if(E){const m=new d(void 0,this._strict,this,this._enableTracing);m._globalGraphImplicitDependency=String(c);const t=new Map,s=new L.IdleValue(()=>{const i=m._createInstance(f,y,S);for(const[n,r]of t){const o=i[n];if(typeof o=="function")for(const a of r)o.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new u.LinkedList,t.set(n,a)),(h,A,x)=>{const Y=a.push([h,A,x]);return(0,I.toDisposable)(Y)}}if(n in i)return i[n];const r=s.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),i[n]=o),o},set(i,n,r){return s.value[n]=r,!0},getPrototypeOf(i){return f.prototype}})}else return this._createInstance(f,y,S)}_throwIfStrict(c,f){if(f&&console.warn(c),this._strict)throw new Error(c)}}e.InstantiationService=d;var b;(function(T){T[T.None=0]="None",T[T.Creation=1]="Creation",T[T.Invocation=2]="Invocation",T[T.Branch=3]="Branch"})(b||(b={}));class v{static traceInvocation(c,f){return c?new v(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v._None}static traceCreation(c,f){return c?new v(1,f.name):v._None}constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}branch(c,f){const y=new v(3,c.toString());return this._dep.push([c,f,y]),y}stop(){const c=Date.now()-this._start;v._totals+=c;let f=!1;function y(S,m){const t=[],s=new Array(S+1).join("	");for(const[i,n,r]of m._dep)if(n&&r){f=!0,t.push(`${s}CREATES -> ${i}`);const o=y(S+1,r);o&&t.push(o)}else t.push(`${s}uses -> ${i}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(c>2||f)&&v.all.add(E.join(`
`))}}v.all=new Set,v._None=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v._totals=0,e.Trace=v});var ee=this&&this.__param||function($,e){return function(L,D){e(L,D,$)}};define(J[63],Z([0,1,22,2,12,98,24,10]),function($,e,L,D,I,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function g(P){return P.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=g,e.ILanguagePackService=(0,w.createDecorator)("languagePackService");let u=class extends D.Disposable{constructor(p){super(),this.extensionGalleryService=p}async getAvailableLanguages(){const p=new L.CancellationTokenSource;setTimeout(()=>p.cancel(),1e3);let d;try{d=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const v=d.firstPage.filter(T=>T.properties.localizedLanguages?.length&&T.tags.some(c=>c.startsWith("lp-"))).map(T=>{const c=T.properties.localizedLanguages?.[0],f=g(T);return{...this.createQuickPickItem(f,c,T),extensionId:T.identifier.id,galleryExtension:T}});return v.push(this.createQuickPickItem("en","English")),v}createQuickPickItem(p,d,b){const v=d??p;let T;if(v!==p&&(T=`(${p})`),p.toLowerCase()===I.language.toLowerCase()&&(T??="",T+=(0,C.localize)(0,null)),b?.installCount){T??="";const c=b.installCount;let f;c>1e6?f=`${Math.floor(c/1e5)/10}M`:c>1e3?f=`${Math.floor(c/1e3)}K`:f=String(c),T+=` $(cloud-download) ${f}`}return{id:p,label:v,description:T}}};u=fe([ee(0,R.IExtensionGalleryService)],u),e.LanguagePackBaseService=u}),define(J[6],Z([0,1,33,4,2,34,12,3,11,10]),function($,e,L,D,I,C,R,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,u.createDecorator)("logService"),e.ILoggerService=(0,u.createDecorator)("loggerService");function P(){return new Date().toISOString()}function p(a){return(0,w.isNumber)(a)}e.isLogLevel=p;var d;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function b(a,l,h){switch(l){case d.Trace:a.trace(h);break;case d.Debug:a.debug(h);break;case d.Info:a.info(h);break;case d.Warning:a.warn(h);break;case d.Error:a.error(h);break;case d.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=b;function v(a){let l="";for(let h=0;h<a.length;h++){let A=a[h];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}l+=(h>0?" ":"")+A}return l}e.format=v;class T extends I.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(l){this.level!==l&&(this.level=l,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(l){return this.level!==d.Off&&this.level<=l}}e.AbstractLogger=T;class c extends T{constructor(l){super(),this.logAlways=l}checkLogLevel(l){return this.logAlways||super.checkLogLevel(l)}trace(l,...h){this.checkLogLevel(d.Trace)&&this.log(d.Trace,v([l,...h]))}debug(l,...h){this.checkLogLevel(d.Debug)&&this.log(d.Debug,v([l,...h]))}info(l,...h){this.checkLogLevel(d.Info)&&this.log(d.Info,v([l,...h]))}warn(l,...h){this.checkLogLevel(d.Warning)&&this.log(d.Warning,v([l,...h]))}error(l,...h){if(this.checkLogLevel(d.Error))if(l instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=l.stack,this.log(d.Error,v(A))}else this.log(d.Error,v([l,...h]))}flush(){}}e.AbstractMessageLogger=c;class f extends T{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.useColors=!R.isWindows}trace(l,...h){this.checkLogLevel(d.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,l,...h):console.log(`[main ${P()}]`,l,...h))}debug(l,...h){this.checkLogLevel(d.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,l,...h):console.log(`[main ${P()}]`,l,...h))}info(l,...h){this.checkLogLevel(d.Info)&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,l,...h):console.log(`[main ${P()}]`,l,...h))}warn(l,...h){this.checkLogLevel(d.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,l,...h):console.warn(`[main ${P()}]`,l,...h))}error(l,...h){this.checkLogLevel(d.Error)&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,l,...h):console.error(`[main ${P()}]`,l,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class y extends T{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...h){this.checkLogLevel(d.Trace)&&console.log("%cTRACE","color: #888",l,...h)}debug(l,...h){this.checkLogLevel(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...h)}info(l,...h){this.checkLogLevel(d.Info)&&console.log("%c INFO","color: #33f",l,...h)}warn(l,...h){this.checkLogLevel(d.Warning)&&console.log("%c WARN","color: #993",l,...h)}error(l,...h){this.checkLogLevel(d.Error)&&console.log("%c  ERR","color: #f33",l,...h)}dispose(){}flush(){}}e.ConsoleLogger=y;class E extends T{constructor(l,h=e.DEFAULT_LOG_LEVEL){super(),this.adapter=l,this.setLevel(h)}trace(l,...h){this.checkLogLevel(d.Trace)&&this.adapter.log(d.Trace,[this.extractMessage(l),...h])}debug(l,...h){this.checkLogLevel(d.Debug)&&this.adapter.log(d.Debug,[this.extractMessage(l),...h])}info(l,...h){this.checkLogLevel(d.Info)&&this.adapter.log(d.Info,[this.extractMessage(l),...h])}warn(l,...h){this.checkLogLevel(d.Warning)&&this.adapter.log(d.Warning,[this.extractMessage(l),...h])}error(l,...h){this.checkLogLevel(d.Error)&&this.adapter.log(d.Error,[this.extractMessage(l),...h])}extractMessage(l){return typeof l=="string"?l:(0,L.toErrorMessage)(l,this.checkLogLevel(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=E;class S extends T{constructor(l){super(),this.loggers=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const h of this.loggers)h.setLevel(l);super.setLevel(l)}trace(l,...h){for(const A of this.loggers)A.trace(l,...h)}debug(l,...h){for(const A of this.loggers)A.debug(l,...h)}info(l,...h){for(const A of this.loggers)A.info(l,...h)}warn(l,...h){for(const A of this.loggers)A.warn(l,...h)}error(l,...h){for(const A of this.loggers)A.error(l,...h)}flush(){for(const l of this.loggers)l.flush()}dispose(){for(const l of this.loggers)l.dispose()}}e.MultiplexLogger=S;class m extends I.Disposable{constructor(l,h){if(super(),this.logLevel=l,this._loggers=new C.ResourceMap,this._loggerResources=new C.ResourceMap,this._onDidChangeLoggers=this._register(new D.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,h)for(const A of h)this._loggerResources.set(A.resource,A)}getLogger(l){return this._loggers.get(l)}createLogger(l,h){let A=this._loggers.get(l);const x=h?.logLevel==="always"?d.Trace:h?.logLevel;return A||(A=this.doCreateLogger(l,x??this.getLogLevel(l)??this.logLevel,h),this._loggers.set(l,A)),this.registerLogger({resource:l,id:h?.id??l.toString(),logLevel:x,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId}),A}setLogLevel(l,h){if(g.URI.isUri(l)){const A=l,x=h,Y=this._loggerResources.get(A);Y&&x!==Y.logLevel&&(Y.logLevel=x===this.logLevel?void 0:x,this._loggers.get(A)?.setLevel(x),this._loggerResources.set(Y.resource,Y),this._onDidChangeLogLevel.fire([A,x]))}else{this.logLevel=l;for(const[A,x]of this._loggers.entries())this._loggerResources.get(A)?.logLevel===void 0&&x.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(l,h){const A=this._loggerResources.get(l);A&&h!==!A.hidden&&(A.hidden=!h,this._loggerResources.set(A.resource,A),this._onDidChangeVisibility.fire([l,h]))}getLogLevel(l){let h;return l&&(h=this._loggerResources.get(l)?.logLevel),h??this.logLevel}registerLogger(l){const h=this._loggerResources.get(l.resource);h?h.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this._loggerResources.set(l.resource,l),this._onDidChangeLoggers.fire({added:[l],removed:[]}))}deregisterLogger(l){const h=this._loggerResources.get(l);if(h){this._loggerResources.delete(l);const A=this._loggers.get(l);A&&(this._loggers.delete(l),A.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[h]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(l){return this._loggerResources.get(l)}dispose(){this._loggers.forEach(l=>l.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=m;class t{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(l){}getLevel(){return d.Info}trace(l,...h){}debug(l,...h){}info(l,...h){}warn(l,...h){}error(l,...h){}critical(l,...h){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;class i extends m{constructor(){super(d.Info)}doCreateLogger(l,h,A){return new t}}e.NullLoggerService=i;function n(a){if(a.verbose)return d.Trace;if(typeof a.logLevel=="string"){const l=o(a.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(a){switch(a){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=r;function o(a){switch(a){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=o}),define(J[115],Z([0,1,19,5,7,4,2,14,61,6]),function($,e,L,D,I,C,R,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends R.Disposable{constructor(d,b){super(),this.logService=d,this.options=b,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(d,b){return b.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,b):this.watchNonRecursive(d,b)}watchUniversal(d,b){const v={path:this.toFilePath(d),excludes:b.excludes,includes:b.includes,recursive:b.recursive},T=(0,L.insert)(this.universalPathsToWatch,v);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{T(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,I.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(b=>this._onDidChangeFile.fire((0,g.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===u.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const b of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(b)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const b of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(b)&&d.includes(b.path)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,b){const v={path:this.toFilePath(d),excludes:b.excludes,includes:b.includes,recursive:!1},T=(0,L.insert)(this.nonRecursivePathsToWatch,v);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{T(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,I.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,g.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===u.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,w.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(J[116],Z([0,1,19,5,15,22,4,51,64,2,54,16,117,18,43,95,13,60,6,7]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends u.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(t,s){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${t}`);const i=new u.DisposableStore;return this.provider.set(t,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:s}),i.add(s.onDidChangeFile(n=>this._onDidFilesChange.fire(new c.FileChangesEvent(n,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:t}))),(0,u.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:s}),this.provider.delete(t),(0,u.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){s.push(i)}}),!this.provider.has(t)&&await D.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,s){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return g.Iterable.map(this.provider,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async withProvider(t){if(!(0,b.isAbsolutePath)(t))throw new c.FileOperationError((0,T.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const s=this.provider.get(t.scheme);if(!s){const i=new E.ErrorNoTelemetry;throw i.message=(0,T.localize)(1,null,t.toString()),i}return s}async withReadProvider(t){const s=await this.withProvider(t);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)||(0,c.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const s=await this.withProvider(t);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.doResolveFile(t,s)}catch(i){throw(0,c.toFileSystemProviderErrorCode)(i)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,T.localize)(2,null,this.resourceForError(t)),1):(0,c.ensureFileSystemProviderError)(i)}}async doResolveFile(t,s){const i=await this.withProvider(t),n=this.isPathCaseSensitive(i),r=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,l=await i.stat(t);let h;return this.toFileStat(i,t,l,void 0,!!a,(A,x)=>(h||(h=P.TernarySearchTree.forUris(()=>!n),h.set(t,!0),r&&h.fill(!0,r)),h.get(A.resource)||h.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&o?x===1:!1))}async toFileStat(t,s,i,n,r,o){const{providerExtUri:a}=this.getExtUri(t),l={resource:s,name:a.basename(s),isFile:(i.type&c.FileType.File)!==0,isDirectory:(i.type&c.FileType.Directory)!==0,isSymbolicLink:(i.type&c.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&c.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,c.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(l.isDirectory&&o(l,n)){try{const h=await t.readdir(s),A=await D.Promises.settled(h.map(async([x,Y])=>{try{const Q=a.joinPath(s,x),te=r?await t.stat(Q):{type:Y};return await this.toFileStat(t,Q,te,h.length,r,o)}catch(Q){return this.logService.trace(Q),null}}));l.children=(0,L.coalesce)(A)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(t){return D.Promises.settled(t.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.withProvider(t),i=await s.stat(t);return this.toFileStat(s,t,i,void 0,!0,()=>!1)}async exists(t){const s=await this.withProvider(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.doValidateCreateFile(t,s)}catch(i){return i}return!0}async doValidateCreateFile(t,s){if(!s?.overwrite&&await this.exists(t))throw new c.FileOperationError((0,T.localize)(3,null,this.resourceForError(t)),3,s)}async createFile(t,s=I.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const n=await this.writeFile(t,s);return this._onDidRunOperation.fire(new c.FileOperationEvent(t,0,n)),n}async writeFile(t,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,t,i)||await this.mkdirp(n,r.dirname(t));let a;if((0,c.hasReadWriteCapability)(n)&&!(s instanceof I.VSBuffer))if((0,v.isReadableStream)(s)){const l=await(0,v.peekStream)(s,3);l.ended?a=I.VSBuffer.concat(l.buffer):a=l}else a=(0,v.peekReadable)(s,l=>I.VSBuffer.concat(l),3);else a=s;!(0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)&&a instanceof I.VSBuffer?await this.doWriteUnbuffered(n,t,i,a):await this.doWriteBuffered(n,t,i,a instanceof I.VSBuffer?(0,I.bufferToReadable)(a):a),this._onDidRunOperation.fire(new c.FileOperationEvent(t,4))}catch(o){throw new c.FileOperationError((0,T.localize)(4,null,this.resourceForError(t),(0,c.ensureFileSystemProviderError)(o).toString()),(0,c.toFileOperationResult)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,s,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,T.localize)(5,null,this.resourceForError(s)));let r;try{r=await t.stat(s)}catch{return}if((r.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,T.localize)(6,null,this.resourceForError(s)),0,i);if(this.throwIfFileIsReadonly(s,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==c.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,c.etag)({mtime:i.mtime,size:r.size}))throw new c.FileOperationError((0,T.localize)(7,null),3,i);return r}async readFile(t,s,i){const n=await this.withReadProvider(t);return s?.atomic?this.doReadFileAtomic(n,t,s,i):this.doReadFile(n,t,s,i)}async doReadFileAtomic(t,s,i,n){return new Promise((r,o)=>{this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(t,s,i,n);r(a)}catch(a){o(a)}})})}async doReadFile(t,s,i,n){const r=await this.doReadFileStream(t,s,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,I.streamToBuffer)(r.value)}}async readFileStream(t,s,i){const n=await this.withReadProvider(t);return this.doReadFileStream(n,t,s,i)}async doReadFileStream(t,s,i,n){const r=new C.CancellationTokenSource(n),o=this.validateReadFile(s,i).then(l=>l,l=>{throw r.cancel(),l});let a;try{return typeof i?.etag=="string"&&i.etag!==c.ETAG_DISABLED&&await o,i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)||!((0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasFileReadStreamCapability)(t))||(0,c.hasReadWriteCapability)(t)&&i?.preferUnbuffered?a=this.readFileUnbuffered(t,s,i):(0,c.hasFileReadStreamCapability)(t)?a=this.readFileStreamed(t,s,r.token,i):a=this.readFileBuffered(t,s,r.token,i),{...await o,value:a}}catch(l){throw a&&await(0,v.consumeStream)(a),this.restoreReadError(l,s,i)}}restoreReadError(t,s,i){const n=(0,T.localize)(8,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(t).toString());return t instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new c.FileOperationError(n,(0,c.toFileOperationResult)(t),i)}readFileStreamed(t,s,i,n=Object.create(null)){const r=t.readFileStream(s,n,i);return(0,v.transform)(r,{data:o=>o instanceof I.VSBuffer?o:I.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,s,n)},o=>I.VSBuffer.concat(o))}readFileBuffered(t,s,i,n=Object.create(null)){const r=(0,I.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,s,r,o=>o,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,s,n)},i),r}readFileUnbuffered(t,s,i){const n=(0,v.newWriteableStream)(r=>I.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)?r=await t.readFile(s,{atomic:!0}):r=await t.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(s,r.byteLength,i),n.end(I.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(t,s){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new c.FileOperationError((0,T.localize)(9,null,this.resourceForError(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&s.etag===i.etag)throw new c.NotModifiedSinceFileOperationError((0,T.localize)(10,null),i,s);return this.validateReadFileLimits(t,i.size,s),i}validateReadFileLimits(t,s,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&s>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&s>i.limits.size&&(n=7),typeof n=="number")throw new c.TooLargeFileOperationError((0,T.localize)(11,null,this.resourceForError(t)),n,s,i)}}async canMove(t,s,i){return this.doCanMoveCopy(t,s,"move",i)}async canCopy(t,s,i){return this.doCanMoveCopy(t,s,"copy",i)}async doCanMoveCopy(t,s,i,n){if(t.toString()!==s.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(r,t,o,s,i,n)}catch(r){return r}return!0}async move(t,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(n,t,r,s,"move",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,o==="move"?2:3,a)),a}async copy(t,s,i){const n=await this.withReadProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(n,t,r,s,"copy",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,o==="copy"?3:2,a)),a}async doMoveCopy(t,s,i,n,r,o){if(s.toString()===n.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(t,s,i,n,r,o);if(a&&!l&&o&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,c.hasFileFolderCopyCapability)(t))await t.copy(s,n,{overwrite:o});else{const h=await this.resolve(s);h.isDirectory?await this.doCopyFolder(t,h,i,n):await this.doCopyFile(t,s,i,n)}return r}else return t===i?(await t.rename(s,n,{overwrite:o}),r):(await this.doMoveCopy(t,s,i,n,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(t,s,i,n){if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,s,i,n);if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,s,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,s,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,s,i,n)}async doCopyFolder(t,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await D.Promises.settled(s.children.map(async r=>{const o=this.getExtUri(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(t,await this.resolve(r.resource),i,o):this.doCopyFile(t,r.resource,i,o)}))}async doValidateMoveCopy(t,s,i,n,r,o){let a=!1;if(t===i){const{providerExtUri:h,isPathCaseSensitive:A}=this.getExtUri(t);if(A||(a=h.isEqual(s,n)),a&&r==="copy")throw new Error((0,T.localize)(12,null,this.resourceForError(s),this.resourceForError(n)));if(!a&&h.isEqualOrParent(n,s))throw new Error((0,T.localize)(13,null,this.resourceForError(s),this.resourceForError(n)))}const l=await this.exists(n);if(l&&!a){if(!o)throw new c.FileOperationError((0,T.localize)(14,null,this.resourceForError(s),this.resourceForError(n)),4);if(t===i){const{providerExtUri:h}=this.getExtUri(t);if(h.isEqualOrParent(s,n))throw new Error((0,T.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(t){const s=this.isPathCaseSensitive(t);return{providerExtUri:s?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(s,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,0,i)),i}async mkdirp(t,s){const i=[],{providerExtUri:n}=this.getExtUri(t);for(;!n.isEqual(s,n.dirname(s));)try{if(((await t.stat(s)).type&c.FileType.Directory)===0)throw new Error((0,T.localize)(16,null,this.resourceForError(s)));break}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(s)),s=n.dirname(s)}for(let r=i.length-1;r>=0;r--){s=n.joinPath(s,i[r]);try{await t.mkdir(s)}catch(o){if((0,c.toFileSystemProviderErrorCode)(o)!==c.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,s){try{await this.doValidateDelete(t,s)}catch(i){return i}return!0}async doValidateDelete(t,s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);if(!!s?.useTrash&&!(i.capabilities&4096))throw new Error((0,T.localize)(17,null,this.resourceForError(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.throwIfFileIsReadonly(t,r);else throw new c.FileOperationError((0,T.localize)(18,null,this.resourceForError(t)),1);if(!!!s?.recursive){const a=await this.resolve(t);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,T.localize)(19,null,this.resourceForError(t)))}return i}async del(t,s){const i=await this.doValidateDelete(t,s),n=!!s?.useTrash,r=!!s?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new c.FileOperationEvent(t,1))}async cloneFile(t,s){const i=await this.withProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(i===n&&this.getExtUri(i).providerExtUri.isEqual(t,s))return;if(i===n&&(0,c.hasFileCloneCapability)(i))return i.cloneFile(t,s);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s));const r=this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri);return i===n&&(0,c.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,s,{overwrite:!0})):r.queue(()=>this.doCopyFile(i,t,n,s))}watch(t,s={recursive:!1,excludes:[]}){const i=new u.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,u.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(t,s);n?(0,u.dispose)(o):r=()=>(0,u.dispose)(o)}catch(o){this.logService.error(o)}})(),i}async doWatch(t,s){const i=await this.withProvider(t),n=(0,w.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),s]);let r=this.activeWatchers.get(n);return r||(r={count:0,disposable:i.watch(t,s)},this.activeWatchers.set(n,r)),r.count+=1,(0,u.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,u.dispose)(r.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,u.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,s,i,n){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(async()=>{const r=await t.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,v.isReadableStream)(n)||(0,v.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(t,r,n):await this.doWriteReadableBufferedQueued(t,r,n)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async doWriteStreamBufferedQueued(t,s,i){let n=0,r;if((0,v.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=I.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,s,o,o.byteLength,n,0),n+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,a)=>{(0,v.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(t,s,l,l.byteLength,n,0)}catch(h){return a(h)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>a(l),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(t,s,i){let n=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(t,s,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(t,s,i,n,r,o){let a=0;for(;a<n;)a+=await t.write(s,r+a,i.buffer,o+a,n-a)}async doWriteUnbuffered(t,s,i,n){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,s,i,n))}async doWriteUnbufferedQueued(t,s,i,n){let r;n instanceof I.VSBuffer?r=n:(0,v.isReadableStream)(n)?r=await(0,I.streamToBuffer)(n):(0,v.isReadableBufferedStream)(n)?r=await(0,I.bufferedStreamToBuffer)(n):r=(0,I.readableToBuffer)(n),await t.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(t,s,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,s,i,n))}async doPipeBufferedQueued(t,s,i,n){let r,o;try{r=await t.open(s,{create:!1}),o=await i.open(n,{create:!0,unlock:!1});const a=I.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,A=0;do A=await t.read(r,l,a.buffer,h,a.byteLength-h),await this.doWriteBuffer(i,o,a,A,l,h),l+=A,h+=A,h===a.byteLength&&(h=0);while(A>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await D.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async doPipeUnbuffered(t,s,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,s,i,n))}async doPipeUnbufferedQueued(t,s,i,n){return i.writeFile(n,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(t,s,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,s,i,n))}async doPipeUnbufferedToBufferedQueued(t,s,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const o=await t.readFile(s);await this.doWriteBuffer(i,r,I.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(t,s,i,n){const r=await(0,I.streamToBuffer)(this.readFileBuffered(t,s,C.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,r)}throwIfFileSystemIsReadonly(t,s){if(t.capabilities&2048)throw new c.FileOperationError((0,T.localize)(20,null,this.resourceForError(s)),6);return t}throwIfFileIsReadonly(t,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,T.localize)(21,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};S=fe([ee(0,y.ILogService)],S),e.FileService=S}),define(J[118],Z([0,1,119,160,5,34,15,4,161,2,14,12,18,43,20,97,13,60,115,33,113,112]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f,y,E,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(s){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(s)}`)}})();class t extends y.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=w.Event.None,this.resourceLocks=new C.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,p.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:r}=await v.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await v.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,d.joinPath)(i,o.name))).type:a=this.toType(o),r.push([o.name,a])}catch(a){this.logService.trace(a)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let r;return n?.dangling?r=c.FileType.Unknown:i.isFile()?r=c.FileType.File:i.isDirectory()?r=c.FileType.Directory:r=c.FileType.Unknown,n&&(r|=c.FileType.SymbolicLink),r}async createResourceLock(i){const n=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new I.Barrier;return this.resourceLocks.set(i,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const o=this.toFilePath(i);return await v.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,n,r){const o=(0,b.newWriteableStream)(a=>R.VSBuffer.concat(a.map(l=>R.VSBuffer.wrap(l))).buffer);return(0,f.readFileIntoStream)(this,i,o,a=>a.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const a=this.toFilePath(i);if(!r.create||!r.overwrite){if(await v.Promises.exists(a)){if(!r.overwrite)throw(0,c.createFileSystemProviderError)((0,T.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,c.createFileSystemProviderError)((0,T.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){t.canFlush=i}async open(i,n){const r=this.toFilePath(i);let o;(0,c.isFileOpenForWriteOptions)(n)&&(o=await this.createResourceLock(i));let a;try{if((0,c.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:h}=await v.SymlinkSupport.stat(r);h.mode&128||await v.Promises.chmod(r,h.mode|128)}catch(h){this.logService.trace(h)}let l;if((0,c.isFileOpenForWriteOptions)(n)){if(p.isWindows)try{await v.Promises.truncate(r,0),l="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}l||(l="w")}else l="r";a=await v.Promises.open(r,l)}catch(l){throw o?.dispose(),(0,c.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(a,0),(0,c.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,i),o){const l=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.mapHandleToLock.set(a,o),l&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),l.dispose())}return a}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await v.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.logService.error(r)}return await v.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,o,a){const l=this.normalizePos(i,n);let h=null;try{h=(await v.Promises.read(i,r,o,a,l)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(i,l,h)}return h}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,r){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,o+r):this.mapHandleToPos.delete(i)))}async write(i,n,r,o,a){return(0,I.retry)(()=>this.doWrite(i,n,r,o,a),100,3)}async doWrite(i,n,r,o,a){const l=this.normalizePos(i,n);let h=null;try{h=(await v.Promises.write(i,r,o,a,l)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),A)}finally{this.updatePos(i,l,h)}return h}async mkdir(i){try{await v.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const r=this.toFilePath(i);n.recursive?await v.Promises.rm(r,v.RimRafMode.MOVE):await v.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,n,r){const o=this.toFilePath(i),a=this.toFilePath(n);if(o!==a)try{await this.validateTargetDeleted(i,n,"move",r.overwrite),await v.Promises.move(o,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,T.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(i,n,r){const o=this.toFilePath(i),a=this.toFilePath(n);if(o!==a)try{await this.validateTargetDeleted(i,n,"copy",r.overwrite),await v.Promises.copy(o,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,T.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(i,n,r,o){const a=this.toFilePath(i),l=this.toFilePath(n);let h=!1;if(!!(this.capabilities&1024)||(h=(0,g.isEqual)(a,l,!0)),h&&r==="copy")throw(0,c.createFileSystemProviderError)((0,T.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!h&&await v.Promises.exists(l)){if(!o)throw(0,c.createFileSystemProviderError)((0,T.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,r){const o=this.toFilePath(i),a=this.toFilePath(n),l=!!(this.capabilities&1024);if((0,g.isEqual)(o,a,!l))return;const h=new u.DisposableStore;try{const[A,x]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);h.add(A),h.add(x),r&&await v.Promises.mkdir((0,P.dirname)(a),{recursive:!0}),await v.Promises.copyFile(o,a)}catch(A){if(A.code==="ENOENT"&&!r)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(A)}finally{h.dispose()}}createUniversalWatcher(i,n,r){return new S.UniversalWatcherClient(o=>i(o),o=>n(o),r)}createNonRecursiveWatcher(i,n,r){return new m.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}toFileSystemProviderError(i){if(i instanceof c.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=c.FileSystemProviderErrorCode.NoPermissions;break;default:n=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let r=this.toFileSystemProviderError(n);if(i&&r.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await v.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(r=(0,c.createFileSystemProviderError)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0,e.DiskFileSystemProvider=t}),define(J[120],Z([0,1,2,6]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends L.Disposable{constructor(R,w=[]){super(),this.logger=new D.MultiplexLogger([R,...w]),this._register(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...w){this.logger.trace(R,...w)}debug(R,...w){this.logger.debug(R,...w)}info(R,...w){this.logger.info(R,...w)}warn(R,...w){this.logger.warn(R,...w)}error(R,...w){this.logger.error(R,...w)}flush(){this.logger.flush()}}e.LogService=I}),define(J[121],Z([0,1,13,6]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(I||(I={}));async function C(u,P,p,d,b){try{const v=await new Promise((c,f)=>{$(["spdlog"],c,f)});v.setFlushOn(I.Trace);const T=await v.createAsyncRotatingLogger(u,P,p,d);return b?T.clearFormatters():T.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),T}catch(v){console.error(v)}return null}function R(u,P,p){switch(P){case D.LogLevel.Trace:u.trace(p);break;case D.LogLevel.Debug:u.debug(p);break;case D.LogLevel.Info:u.info(p);break;case D.LogLevel.Warning:u.warn(p);break;case D.LogLevel.Error:u.error(p);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function w(u,P){switch(P){case D.LogLevel.Trace:u.setLevel(I.Trace);break;case D.LogLevel.Debug:u.setLevel(I.Debug);break;case D.LogLevel.Info:u.setLevel(I.Info);break;case D.LogLevel.Warning:u.setLevel(I.Warning);break;case D.LogLevel.Error:u.setLevel(I.Error);break;case D.LogLevel.Off:u.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class g extends D.AbstractMessageLogger{constructor(P,p,d,b,v){super(),this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(P,p,d,b),this._register(this.onDidChangeLogLevel(T=>{this._logger&&w(this._logger,T)}))}async _createSpdLogLogger(P,p,d,b){const v=d?6:1,T=30/v*L.ByteSize.MB,c=await C(P,p,T,v,b);if(c){this._logger=c,w(this._logger,this.getLevel());for(const{level:f,message:y}of this.buffer)R(this._logger,f,y);this.buffer=[]}}log(P,p){this._logger?R(this._logger,P,p):this.getLevel()<=P&&this.buffer.push({level:P,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=g}),define(J[38],Z([0,1,4,64,2,10]),function($,e,L,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class R extends I.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(u){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...u,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(u),D.Iterable.reduce(this.policies.entries(),(p,[d,b])=>({...p,[d]:b}),{})}getPolicyValue(u){return this.policies.get(u)}serialize(){return D.Iterable.reduce(Object.entries(this.policyDefinitions),(u,[P,p])=>({...u,[P]:{definition:p,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=R;class w{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=w}),define(J[122],Z([0,1,5,4,64,3,13,6,38]),function($,e,L,D,I,C,R,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(p,d){const b=[];for(const v of new Set(I.Iterable.concat(p.keys(),d.keys())))p.get(v)!==d.get(v)&&b.push(v);return b}let P=class extends g.AbstractPolicyService{constructor(d,b,v){super(),this.file=d,this.fileService=b,this.logService=v,this.throttledDelayer=this._register(new L.ThrottledDelayer(500));const T=D.Event.filter(b.onDidFilesChange,c=>c.affects(d));this._register(b.watch(d)),this._register(T(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const d=new Map;try{const b=await this.fileService.readFile(this.file),v=JSON.parse(b.value.toString());if(!(0,C.isObject)(v))throw new Error("Policy file isn't a JSON object");for(const T of Object.keys(v))this.policyDefinitions[T]&&d.set(T,v[T])}catch(b){b.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",b)}return d}async refresh(){const d=await this.read(),b=u(this.policies,d);this.policies=d,b.length>0&&this._onDidChange.fire(b)}};P=fe([ee(1,R.IFileService),ee(2,w.ILogService)],P),e.FilePolicyService=P}),define(J[32],Z([0,1,10]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[35],Z([0,1,70,3]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(R,w){L.ok(D.isString(R)),L.ok(D.isObject(w)),L.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,w)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new I}),define(J[123],Z([0,1,4,35]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class C{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,u){this.schemasById[I(g)]=u,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new C;D.Registry.add(e.Extensions.JSONContribution,R)}),define(J[42],Z([0,1,19,4,3,86,23,123,35]),function($,e,L,D,I,C,R,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=g.Registry.as(w.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const i=new Set;this.doRegisterConfigurations(t,s,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const s=new Set;this.doDeregisterConfigurations(t,s),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:t,remove:s}){const i=new Set;this.doDeregisterConfigurations(s,i),this.doRegisterConfigurations(t,!1,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(t){const s=new Set;this.doRegisterDefaultConfigurations(t,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,s){const i=[];for(const{overrides:n,source:r}of t)for(const o in n)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const a=this.configurationDefaultsOverrides.get(o),l=a?.valuesSources??new Map;if(r)for(const Y of Object.keys(n[o]))l.set(Y,r);const h={...a?.value||{},...n[o]};this.configurationDefaultsOverrides.set(o,{source:r,value:h,valuesSources:l});const A=(0,R.getLanguageTagSettingPlainKey)(o),x={type:"object",default:h,description:C.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:I.isString(r)?void 0:r,defaultValueSource:r};i.push(...T(o)),this.configurationProperties[o]=x,this.defaultLanguageConfigurationOverridesNode.properties[o]=x}else{this.configurationDefaultsOverrides.set(o,{value:n[o],source:r});const a=this.configurationProperties[o];a&&(this.updatePropertyDefaultValue(o,a),this.updateSchema(o,a))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(t){const s=new Set;this.doDeregisterDefaultConfigurations(t,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,s){for(const{overrides:i,source:n}of t)for(const r in i){const o=this.configurationDefaultsOverrides.get(r),a=I.isString(n)?n:n?.id,l=I.isString(o?.source)?o?.source:o?.source?.id;if(a===l)if(s.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const h=this.configurationProperties[r];h&&(this.updatePropertyDefaultValue(r,h),this.updateSchema(r,h))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let s=!1;const i=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,i),s=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,i),s=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,i),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const s of t)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,s,i){t.forEach(n=>{this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties,void 0,i),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,s){const i=n=>{if(n.properties)for(const r in n.properties){s.add(r);const o=this.configurationProperties[r];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.configurationContributors.indexOf(n);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(t,s=!0,i,n,r=3,o){r=I.isUndefinedOrNull(t.scope)?r:t.scope;const a=t.properties;if(a)for(const h in a){const A=a[h];if(s&&E(h,A)){delete a[h];continue}if(A.source=i,A.defaultDefaultValue=a[h].default,this.updatePropertyDefaultValue(h,A),e.OVERRIDE_PROPERTY_REGEX.test(h)?A.scope=void 0:(A.scope=I.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=I.isUndefinedOrNull(A.restricted)?!!n?.includes(h):A.restricted),a[h].hasOwnProperty("included")&&!a[h].included){this.excludedConfigurationProperties[h]=a[h],delete a[h];continue}else this.configurationProperties[h]=a[h],a[h].policy?.name&&this.policyConfigurations.set(a[h].policy.name,h);!a[h].deprecationMessage&&a[h].markdownDeprecationMessage&&(a[h].deprecationMessage=a[h].markdownDeprecationMessage),o.add(h)}const l=t.allOf;if(l)for(const h of l)this.validateAndRegisterProperties(h,s,i,n,r,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const s=i=>{const n=i.properties;if(n)for(const o in n)this.updateSchema(o,n[o]);i.allOf?.forEach(s)};s(t)}updateSchema(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.resourceLanguageSettingsSchema.properties[t]=s;break}}removeFromSchema(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const s=`[${t}]`,i={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}registerOverridePropertyPatternKey(){const t={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,s){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,r=i?.source;I.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),I.isUndefined(n)&&(n=f(s.type)),s.default=n,s.defaultValueSource=r}}const b="\\[([^\\]]+)\\]",v=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function T(m){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let s=v.exec(m);for(;s?.length;){const i=s[1].trim();i&&t.push(i),s=v.exec(m)}}return(0,L.distinct)(t)}e.overrideIdentifiersFromKey=T;function c(m){return m.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=c;function f(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const y=new d;g.Registry.add(e.Extensions.Configuration,y);function E(m,t){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?C.localize(7,null,m):y.getConfigurationProperties()[m]!==void 0?C.localize(8,null,m):t.policy?.name&&y.getPolicyConfigurations().get(t.policy?.name)!==void 0?C.localize(9,null,m,t.policy?.name,y.getPolicyConfigurations().get(t.policy?.name)):null:C.localize(6,null)}e.validateProperty=E;function S(){const m=[],t=y.getConfigurationProperties();for(const s of Object.keys(t))m.push([s,t[s].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=S}),define(J[65],Z([0,1,19,4,49,2,34,29,3,11,23,42,35]),function($,e,L,D,I,C,R,w,g,u,P,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(s){return Object.isFrozen(s)?s:w.deepFreeze(s)}class v{constructor(i={},n=[],r=[],o){this._contents=i,this._keys=n,this._overrides=r,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof v)return n;const r=new T("");return r.parseRaw(n),r.configurationModel});this._rawConfiguration=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),o=n?this.rawConfiguration.getOverrideValue(i,n):void 0,a=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:o,merged:a}}getOverrideValue(i,n){const r=this.getContentsForOverrideIdentifer(n);return r?i?(0,P.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return L.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return L.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=w.deepClone(this.contents),r=w.deepClone(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const l of i)if(a.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.mergeContents(n,l.contents);for(const h of l.overrides){const[A]=r.filter(x=>L.equals(x.identifiers,h.identifiers));A?(this.mergeContents(A.contents,h.contents),A.keys.push(...h.keys),A.keys=L.distinct(A.keys)):r.push(w.deepClone(h))}for(const h of l.keys)o.indexOf(h)===-1&&o.push(h)}return new v(n,o,r,a.every(l=>l instanceof v)?void 0:a)}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o];const l=n[o];l&&(typeof a=="object"&&typeof l=="object"?(a=w.deepClone(a),this.mergeContents(a,l)):a=l),r[o]=a}return new v(r,this.keys,this.overrides)}mergeContents(i,n){for(const r of Object.keys(n)){if(r in i&&g.isObject(i[r])&&g.isObject(n[r])){this.mergeContents(i[r],n[r]);continue}i[r]=w.deepClone(n[r])}}getContentsForOverrideIdentifer(i){let n=null,r=null;const o=a=>{a&&(r?this.mergeContents(r,a):r=w.deepClone(a))};for(const a of this.overrides)L.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&o(a.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.updateValue(i,n,!0)}setValue(i,n){this.updateValue(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,P.removeFromValueTree)(this.contents,i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>L.equals(r.identifiers,(0,p.overrideIdentifiersFromKey)(i))),1))}updateValue(i,n,r){(0,P.addToValueTree)(this.contents,i,n,o=>console.error(o)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,p.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,P.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=v;class T{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!g.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:r,keys:o,overrides:a,restricted:l,hasExcludedProperties:h}=this.doParseRaw(i,n);this._configurationModel=new v(r,o,a,h?[i]:void 0),this._restrictedConfigurations=l||[]}doParseContent(i){let n={},r=null,o=[];const a=[],l=[];function h(x){Array.isArray(o)?o.push(x):r!==null&&(o[r]=x)}const A={onObjectBegin:()=>{const x={};h(x),a.push(o),o=x,r=null},onObjectProperty:x=>{r=x},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const x=[];h(x),a.push(o),o=x,r=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:h,onError:(x,Y,Q)=>{l.push({error:x,offset:Y,length:Q})}};if(i)try{I.visit(i,A),n=o[0]||{}}catch(x){console.error(`Error while parsing settings file ${this._name}: ${x}`),this._parseErrors=[x]}return n}doParseRaw(i,n){const r=d.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,r,!0,n);i=o.raw;const a=(0,P.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),l=Object.keys(i),h=this.toOverrides(i,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:a,keys:l,overrides:h,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(i,n,r,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const l={},h=[];for(const A in i)if(p.OVERRIDE_PROPERTY_REGEX.test(A)&&r){const x=this.filter(i[A],n,!1,o);l[A]=x.raw,a=a||x.hasExcludedProperties,h.push(...x.restricted)}else{const x=n[A],Y=x?typeof x.scope<"u"?x.scope:3:void 0;x?.restricted&&h.push(A),(Y===void 0||o.scopes===void 0||o.scopes.includes(Y))&&!(o.skipRestricted&&x?.restricted)?l[A]=i[A]:a=!0}return{raw:l,restricted:h,hasExcludedProperties:a}}toOverrides(i,n){const r=[];for(const o of Object.keys(i))if(p.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const l in i[o])a[l]=i[o][l];r.push({identifiers:(0,p.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,n)})}return r}}e.ConfigurationModelParser=T;class c extends C.Disposable{constructor(i,n,r,o){super(),this.userSettingsResource=i,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new T(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class f{constructor(i,n,r,o,a,l,h,A,x,Y,Q,te,ie){this.key=i,this.overrides=n,this._value=r,this.overrideIdentifiers=o,this.defaultConfiguration=a,this.policyConfiguration=l,this.applicationConfiguration=h,this.userConfiguration=A,this.localUserConfiguration=x,this.remoteUserConfiguration=Y,this.workspaceConfiguration=Q,this.folderConfigurationModel=te,this.memoryConfigurationModel=ie}get value(){return b(this._value)}inspect(i,n,r){const o=i.inspect(n,r);return{get value(){return b(o.value)},get override(){return b(o.override)},get merged(){return b(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class y{constructor(i,n,r,o,a=new v,l=new v,h=new R.ResourceMap,A=new v,x=new R.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=n,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=l,this._folderConfigurations=h,this._memoryConfiguration=A,this._memoryConfigurationByResource=x,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,n,r){return this.getConsolidatedConfigurationModel(i,n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new v,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,r){const o=this.getConsolidatedConfigurationModel(i,n,r),a=this.getFolderConfigurationModelForResource(n.resource,r),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,h=new Set;for(const A of o.overrides)for(const x of A.identifiers)o.getOverrideValue(i,x)!==void 0&&h.add(x);return new f(i,n,o.getValue(i),h.size?[...h]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,a||void 0,l)}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:a,removed:l}=m(this._defaultConfiguration,i);n=[...o,...a,...l]}for(const o of n)for(const a of(0,p.overrideIdentifiersFromKey)(o)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),h=i.getKeysForOverrideIdentifier(a),A=[...h.filter(x=>l.indexOf(x)===-1),...l.filter(x=>h.indexOf(x)===-1),...l.filter(x=>!w.equals(this._defaultConfiguration.override(a).getValue(x),i.override(a).getValue(x)))];r.push([a,A])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:o}=m(this._policyConfiguration,i),a=[...n,...r,...o];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=m(this.applicationConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=m(this.localUserConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=m(this.remoteUserConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=m(this.workspaceConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const r=this.folderConfigurations.get(i),{added:o,updated:a,removed:l,overrides:h}=m(r,n),A=[...o,...a,...l];return(A.length||!r)&&this.updateFolderConfiguration(i,n),{keys:A,overrides:h}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:a,overrides:l}=m(n,void 0);return{keys:[...r,...o,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,n,r){let o=this.getConsolidatedConfigurationModelForResource(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:i},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const o=n.getFolder(i);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const a=this._memoryConfigurationByResource.get(i);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(n=r.merge(o),this._foldersConsolidatedConfigurations.set(i,n)):n=r}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:a}=this._folderConfigurations.get(n);return i.push([n,{contents:r,overrides:o,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this._workspaceConfiguration.keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.policy),o=this.parseConfigurationModel(i.application),a=this.parseConfigurationModel(i.user),l=this.parseConfigurationModel(i.workspace),h=i.folders.reduce((A,x)=>(A.set(u.URI.revive(x[0]),this.parseConfigurationModel(x[1])),A),new R.ResourceMap);return new y(n,r,o,a,new v,l,h,new v,new R.ResourceMap)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides)}}e.Configuration=y;function E(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const o of s)o.keys.forEach(a=>i.add(a)),o.overrides.forEach(([a,l])=>{const h=(0,R.getOrSet)(n,a,new Set);l.forEach(A=>h.add(A))});const r=[];return n.forEach((o,a)=>r.push([a,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=E;class S{constructor(i,n,r,o){this.change=i,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const l of a)this.affectedKeys.add(l);this._affectsConfigStr=this._marker;for(const a of this.affectedKeys)this._affectsConfigStr+=a+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){const r=this._marker+i,o=this._affectsConfigStr.indexOf(r);if(o<0)return!1;const a=o+r.length;if(a>=this._affectsConfigStr.length)return!1;const l=this._affectsConfigStr.charCodeAt(a);if(l!==this._markerCode1&&l!==this._markerCode2)return!1;if(n){const h=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,A=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!w.equals(h,A)}return!0}}e.ConfigurationChangeEvent=S;function m(s,i){const{added:n,removed:r,updated:o}=t(i?.rawConfiguration,s?.rawConfiguration),a=[],l=s?.getAllOverrideIdentifiers()||[],h=i?.getAllOverrideIdentifiers()||[];if(i){const A=h.filter(x=>!l.includes(x));for(const x of A)a.push([x,i.getKeysForOverrideIdentifier(x)])}if(s){const A=l.filter(x=>!h.includes(x));for(const x of A)a.push([x,s.getKeysForOverrideIdentifier(x)])}if(i&&s){for(const A of l)if(h.includes(A)){const x=t({contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});a.push([A,[...x.added,...x.removed,...x.updated]])}}return{added:n,removed:r,updated:o,overrides:a}}function t(s,i){const n=s?i?s.keys.filter(a=>i.keys.indexOf(a)===-1):[...s.keys]:[],r=i?s?i.keys.filter(a=>s.keys.indexOf(a)===-1):[...i.keys]:[],o=[];if(s&&i){for(const a of i.keys)if(s.keys.indexOf(a)!==-1){const l=(0,P.getConfigurationValue)(i.contents,a),h=(0,P.getConfigurationValue)(s.contents,a);w.equals(l,h)||o.push(a)}}return{added:n,removed:r,updated:o}}}),define(J[124],Z([0,1,19,4,2,29,3,65,42,6,38,35]),function($,e,L,D,I,C,R,w,g,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends I.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new w.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(p.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:f})=>this.onDidUpdateConfiguration(Array.from(c),f))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(c,f){this.updateConfigurationModel(c,p.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:c})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new w.ConfigurationModel;const c=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(c),c)}updateConfigurationModel(c,f){const y=this.getConfigurationDefaultOverrides();for(const E of c){const S=y[E],m=f[E];S!==void 0?this._configurationModel.addValue(E,S):m?this._configurationModel.addValue(E,m.default):this._configurationModel.removeValue(E)}}}e.DefaultConfiguration=d;class b{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=b;let v=class extends I.Disposable{get configurationModel(){return this._configurationModel}constructor(c,f,y){super(),this.defaultConfiguration=c,this.policyService=f,this.logService=y,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new w.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(c=>this.onDidChangePolicies(c))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:c})=>this.update(await this.updatePolicyDefinitions(c),!0))),this._configurationModel}async updatePolicyDefinitions(c){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",c);const f={},y=[],E=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const S of c){const m=E[S];if(!m){y.push(S);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.logService.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}y.push(S),f[m.policy.name]={type:m.type}}}return(0,R.isEmptyObject)(f)||await this.policyService.updatePolicyDefinitions(f),y}onDidChangePolicies(c){this.logService.trace("PolicyConfiguration#onDidChangePolicies",c);const f=p.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),y=(0,L.coalesce)(c.map(E=>f.get(E)));this.update(y,!0)}update(c,f){this.logService.trace("PolicyConfiguration#update",c);const y=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),E=[],S=this._configurationModel.isEmpty();for(const m of c){const t=y[m]?.policy?.name;if(t){const s=this.policyService.getPolicyValue(t);(S?s!==void 0:!(0,C.equals)(this._configurationModel.getValue(m),s))&&E.push([m,s])}else this._configurationModel.getValue(m)!==void 0&&E.push([m,void 0])}if(E.length){this.logService.trace("PolicyConfiguration#changed",E);const m=this._configurationModel;this._configurationModel=new w.ConfigurationModel;for(const t of m.keys)this._configurationModel.setValue(t,m.getValue(t));for(const[t,s]of E)s===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,s);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};v=fe([ee(1,P.IPolicyService),ee(2,u.ILogService)],v),e.PolicyConfiguration=v}),define(J[125],Z([0,1,5,4,2,18,23,65,124,38]),function($,e,L,D,I,C,R,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends I.Disposable{constructor(d,b,v,T){super(),this.settingsResource=d,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new g.DefaultConfiguration),this.policyConfiguration=v instanceof u.NullPolicyService?new g.NullPolicyConfiguration:this._register(new g.PolicyConfiguration(this.defaultConfiguration,v,T)),this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,b)),this.configuration=new w.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new w.ConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:c,properties:f})=>this.onDidDefaultConfigurationChange(c,f))),this._register(this.policyConfiguration.onDidChangeConfiguration(c=>this.onDidPolicyConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[d,b,v]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new w.Configuration(d,b,new w.ConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(d,b){const v=typeof d=="string"?d:void 0,T=(0,R.isConfigurationOverrides)(d)?d:(0,R.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(v,T,void 0)}updateValue(d,b,v,T){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const b=this.configuration.toData(),v=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(v,b,2)}onDidDefaultConfigurationChange(d,b){const v=this.configuration.toData(),T=this.configuration.compareAndUpdateDefaultConfiguration(d,b);this.trigger(T,v,7)}onDidPolicyConfigurationChange(d){const b=this.configuration.toData(),v=this.configuration.compareAndUpdatePolicyConfiguration(d);this.trigger(v,b,7)}trigger(d,b,v){const T=new w.ConfigurationChangeEvent(d,{data:b},this.configuration);T.source=v,T.sourceConfig=this.getTargetConfiguration(v),this._onDidChangeConfiguration.fire(T)}getTargetConfiguration(d){switch(d){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(J[66],Z([0,1,16]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(u){return u.scheme===L.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=D;function I(u){if(!u)return;const P=u.indexOf("+");return P<0?u:u.substr(0,P)}e.getRemoteName=I;function C(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=C;function R(u){const{host:P,port:p}=g(u);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:p}}e.parseAuthorityWithPort=R;function w(u,P){let{host:p,port:d}=g(u);return typeof d>"u"&&(d=P),{host:p,port:d}}e.parseAuthorityWithOptionalPort=w;function g(u){const P=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const p=u.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const d=u.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:u,port:void 0}}}),define(J[28],Z([0,1,31,10,66]),function($,e,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=C;function R(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(w=e.ExtensionType||(e.ExtensionType={}));var g;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class u{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,c){if(typeof T>"u"||T===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof T=="string"||typeof c=="string"){const f=typeof T=="string"?T:T.value,y=typeof c=="string"?c:c.value;return L.equalsIgnoreCase(f,y)}return T._lower===c._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=u;function P(v){return p(v)}e.isApplicationScopedExtension=P;function p(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function b(v,T){if(T){const c=`onResolveRemoteAuthority:${(0,I.getRemoteName)(T)}`;return v.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[126],Z([0,1,2,14,20,28]),function($,e,L,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class R extends L.Disposable{constructor(g,u){super(),this.environmentService=g,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(u.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(u.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(g){g.some(u=>!!u.local)&&this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){I.Promises.rm(this.extensionsManifestCache,I.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=R}),define(J[46],Z([0,1,15,99,42,10,35]),function($,e,L,D,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function w(T){return T.res.statusCode&&T.res.statusCode>=200&&T.res.statusCode<300||T.res.statusCode===1223}e.isSuccess=w;function g(T){return T.res.statusCode===204}async function u(T){return g(T)?null:(await(0,L.streamToBuffer)(T.stream)).toString()}e.asText=u;async function P(T){if(!w(T))throw new Error("Server returned "+T.res.statusCode);return u(T)}e.asTextOrError=P;async function p(T){if(!w(T))throw new Error("Server returned "+T.res.statusCode);if(g(T))return null;const f=(await(0,L.streamToBuffer)(T.stream)).toString();try{return JSON.parse(f)}catch(y){throw y.message+=`:
`+f,y}}e.asJson=p;function d(T){v(T)}e.updateProxyConfigurationsScope=d;let b;function v(T){const c=R.Registry.as(I.Extensions.Configuration),f=b;b={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:T,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[b],remove:f?[f]:[]})}v(2)}),define(J[127],Z([0,1,22,16,13,46]),function($,e,L,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let R=class{constructor(g,u){this.requestService=g,this.fileService=u}async download(g,u,P=L.CancellationToken.None){if(g.scheme===D.Schemas.file||g.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(g,u);return}const p={type:"GET",url:g.toString(!0)},d=await this.requestService.request(p,P);if(d.res.statusCode===200)await this.fileService.writeFile(u,d.stream);else{const b=await(0,C.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${b}`)}}};R=fe([ee(0,C.IRequestService),ee(1,I.IFileService)],R),e.DownloadService=R}),define(J[128],Z([0,1,129,3]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function I(R,w){return R.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:R.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function C(R,w,g={}){const u=(0,L.parse)(R),P=g.proxyUrl||I(u,w);if(!P)return null;const p=(0,L.parse)(P);if(!/^https?:$/.test(p.protocol||""))return null;const d={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,D.isBoolean)(g.strictSSL)?g.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((b,v)=>{$(["http-proxy-agent"],b,v)}))(d):new(await new Promise((b,v)=>{$(["https-proxy-agent"],b,v)}))(d)}e.getProxyAgent=C}),define(J[130],Z([0,1,57,14,100,22,33,7,12,30,82,162,5,71]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let v;async function T(f,y,E,S){return E["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(S)&&!E["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(S)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=d.Promises.withAsyncBody(async(m,t)=>{const s=new C.CancellationTokenSource;let i=1e4;const n=f.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,b.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),t(new Error((0,I.localize)(0,null)))},i);try{m(await c(y,s.token))}catch(o){!(0,w.isCancellationError)(o)&&!s.token.isCancellationRequested?t(new Error((0,I.localize)(1,null,(0,R.toErrorMessage)(o)))):m({})}finally{clearTimeout(r),s.dispose()}})),v)}e.getResolvedShellEnv=T;async function c(f,y){const E=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",E);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",S);const m=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(m+"({.*})"+m),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const i=await(0,P.getSystemShell)(g.OS,s);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(y.isCancellationRequested)return r(new w.CancellationError);const o=(0,D.basename)(i);let a,l;const h=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' ${h} -p '''${m}'' + JSON.stringify(process.env) + ''${m}'''`,l=["-Login","-Command"]):(a=`'${process.execPath}' ${h} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,o==="tcsh"||o==="csh"?l=["-ic"]:l=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),a);const A=(0,L.spawn)(i,[...l,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});y.onCancellationRequested(()=>(A.kill(),r(new w.CancellationError))),A.on("error",Q=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(Q)),r(Q)});const x=[];A.stdout.on("data",Q=>x.push(Q));const Y=[];A.stderr.on("data",Q=>Y.push(Q)),A.on("close",(Q,te)=>{const ie=Buffer.concat(x).toString("utf8");f.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&f.trace("getUnixShellEnvironment#stderr",ne),Q||te)return r(new Error((0,I.localize)(2,null,Q,te)));const ae=t.exec(ie),ue=ae?ae[1]:"{}";try{const se=JSON.parse(ue);E?se.ELECTRON_RUN_AS_NODE=E:delete se.ELECTRON_RUN_AS_NODE,S?se.ELECTRON_NO_ATTACH_CONSOLE=S:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",se),n(se)}catch(se){f.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(se)),r(se)}})})}}),define(J[67],Z([0,1,10]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,L.createDecorator)("stateService")}),define(J[131],Z([0,1,5,15,3,17,13,6]),function($,e,L,D,I,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(p,d,b){this.storagePath=p,this.logService=d,this.fileService=b,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new L.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,d){const b=this.storage[p];return(0,I.isUndefinedOrNull)(b)?d:b}setItem(p,d){this.setItems([{key:p,data:d}])}setItems(p){let d=!1;for(const{key:b,data:v}of p)this.storage[b]!==v&&((0,I.isUndefinedOrNull)(v)?(0,I.isUndefined)(this.storage[b])||(this.storage[b]=void 0,d=!0):(this.storage[b]=v,d=!0));d&&this.save()}removeItem(p){(0,I.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=g;let u=class{constructor(p,d,b){this.fileStorage=new g(p.stateResource,d,b)}async init(){await this.fileStorage.init()}getItem(p,d){return this.fileStorage.getItem(p,d)}};u=fe([ee(0,C.IEnvironmentService),ee(1,w.ILogService),ee(2,R.IFileService)],u),e.StateService=u}),define(J[68],Z([0,1,12,37,11,30]),function($,e,L,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(u){if(L.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function w(u,P,p,d,b,v,T,c,f,y){const E=Object.create(null);E["common.machineId"]=T,E.sessionID=(0,C.generateUuid)()+Date.now(),E.commitHash=b,E.version=v,E["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,L.PlatformToString)(L.platform),E["common.nodePlatform"]=D.platform,E["common.nodeArch"]=d,E["common.product"]=y||"desktop",c&&(E["common.msftInternal"]=c);let S=0;const m=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),L.isLinuxSnap&&(E["common.snap"]="true");const t=R(p);t&&(E["common.platformDetail"]=t);try{const s=await u.readFile(I.URI.file(f));E["common.source"]=s.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=w;function g(u){const P=D.env.USERDNSDOMAIN;if(!P)return!1;const p=P.toLowerCase();return u.some(d=>p===d)}e.verifyMicrosoftInternalDomain=g}),define(J[25],Z([0,1,10]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[39],Z([0,1,29,3,4,23,66,68,25]),function($,e,L,D,I,C,R,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class u{constructor(a){this.value=a}}e.TelemetryTrustedValue=u;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,l){return Promise.resolve(void 0)}publicLog2(a,l){return this.publicLog(a,l)}publicLogError(a,l){return Promise.resolve(void 0)}publicLogError2(a,l){return this.publicLogError(a,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class p{async publicLog(a,l,h){}async publicLogError(a,l,h){}}e.NullEndpointTelemetryService=p,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(o,a){return I.Event.debounce(a.onDidChangeConfiguration,(h,A)=>{const x=h?new Set([...h.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:x}},1e3,!0)(h=>{h.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(h.source),configurationKeys:S(h.affectedKeys)})})}e.configurationTelemetry=d;function b(o,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!o.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=b;function v(o,a){return!(a.isBuilt||a.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=v;function T(o){const a=o.getValue(g.TELEMETRY_SETTING_ID),l=o.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=T;function c(o){const a={},l={},h={};E(o,h);for(let A in h){A=A.length>150?A.substr(A.length-149):A;const x=h[A];typeof x=="number"?l[A]=x:typeof x=="boolean"?l[A]=x?1:0:typeof x=="string"?(x.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${x.length}`),a[A]=x.substring(0,8191)):typeof x<"u"&&x!==null&&(a[A]=x)}return{properties:a,measurements:l}}e.validateTelemetryData=c;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function y(o){if(!o)return"none";const a=(0,R.getRemoteName)(o);return f.has(a)?a:"other"}e.cleanRemoteAuthority=y;function E(o,a,l=0,h){if(!!o)for(const A of Object.getOwnPropertyNames(o)){const x=o[A],Y=h?h+A:A;Array.isArray(x)?a[Y]=(0,L.safeStringify)(x):x instanceof Date?a[Y]=x.toISOString():(0,D.isObject)(x)?l<2?E(x,a,l+1,Y+"."):a[Y]=(0,L.safeStringify)(x):a[Y]=x}}function S(o){if(!o)return[];const a=[];return m(a,"",o),a}function m(o,a,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(h=>m(o,a?`${a}.${h}`:h,l[h])):o.push(a)}function t(o,a){const l=o.msftInternalDomains||[],h=a.getValue("telemetry.internalTesting");return(0,w.verifyMicrosoftInternalDomain)(l)||h}e.isInternalTelemetry=t;function s(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(o,a){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let l=o;const h=[];for(const Q of a)for(;;){const te=Q.exec(o);if(!te)break;h.push([te.index,Q.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,x=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Y=0;for(l="";;){const Q=x.exec(o);if(!Q)break;const te=h.some(([ie,ne])=>Q.index<ne&&ie<x.lastIndex);!A.test(Q[0])&&!te&&(l+=o.substring(Y,Q.index)+"<REDACTED: user-file-path>",Y=x.lastIndex)}return Y<o.length&&(l+=o.substr(Y)),l}function n(o){if(!o)return o;const a=o.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(a))return`<REDACTED: ${h.label}>`;return o}function r(o,a){return(0,L.cloneAndChange)(o,l=>{if(l instanceof u)return l.value;if(typeof l=="string"){let h=l.replaceAll("%20"," ");h=i(h,a);for(const A of a)h=h.replace(A,"");return h=n(h),h}})}e.cleanData=r}),define(J[26],Z([0,1,31,24,28,12,11,7,37,39]),function($,e,L,D,I,C,R,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,L.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=P;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,r,o)}static parse(n){const r=p.exec(n);return r&&r[1]&&r[2]?new d({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=d;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(i){const n=b.exec(i);return n&&n[1]?[c(n[1]),n[2]]:[c(i),void 0]}e.getIdAndVersion=v;function T(i,n){return`${i}.${n}`}e.getExtensionId=T;function c(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function f(i,n){return c(T(i,n))}e.getGalleryExtensionId=f;function y(i,n){const r=[],o=a=>{for(const l of r)if(l.some(h=>P(n(h),n(a))))return l;return null};for(const a of i){const l=o(a);l?l.push(a):r.push([a])}return r}e.groupByExtension=y;function E(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function S(i){return{id:new u.TelemetryTrustedValue(i.identifier.id),name:new u.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function m(i,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&r.every(l=>!P(l.identifier,{id:a}))){const l=i.filter(h=>P(h.identifier,{id:a}));l.length===1&&(r.push(l[0]),o.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=m;async function t(i,n){if(!C.isLinux)return!1;let r;try{r=(await i.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,w.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function s(i,n){const r=await t(i,n),o=(0,D.getTargetPlatform)(r?"alpine":C.platform,g.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(J[132],Z([0,1,22,7,16,18,41,11,89,24,26,28]),function($,e,L,D,I,C,R,w,g,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=c=>(0,g.localize)(0,null,c),b=(0,g.localize)(1,null,"ms-dotnettools.csharp");function v(c,f){return f?`${c.publisher}.${c.name}@${c.version}`:`${c.publisher}.${c.name}`}let T=class{constructor(f,y){this.extensionManagementService=f,this.extensionGalleryService=y}get location(){}async listExtensions(f,y,E,S=console){let m=await this.extensionManagementService.getInstalled(1,E);const t=p.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(y&&y!==""){if(t.indexOf(y.toLowerCase())<0){S.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(y.toLowerCase())>-1:!1)}else if(y===""){S.log("Possible Categories: "),t.forEach(i=>{S.log(i)});return}this.location&&S.log((0,g.localize)(2,null,this.location)),m=m.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let s;for(const i of m)s!==i.identifier.id&&(s=i.identifier.id,S.log(v(i.manifest,f)))}async installExtensions(f,y,E,S,m=console){const t=[],s=[];f.length&&m.log(this.location?(0,g.localize)(3,null,this.location):(0,g.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1,E.profileLocation),n=(l,h)=>{const A=i.find(x=>(0,P.areSameExtensions)(x.identifier,{id:l}));if(A){if(!S&&(!h||h==="prerelease"&&A.preRelease))return m.log((0,g.localize)(5,null,l,A.manifest.version,l)),!1;if(h&&A.manifest.version===h)return m.log((0,g.localize)(6,null,`${l}@${h}`)),!1}return!0},r=(l,h,A)=>{a.push({id:l,version:h!=="prerelease"?h:void 0,installOptions:{...E,isBuiltin:A,installPreReleaseVersion:h==="prerelease"||E.installPreReleaseVersion}})},o=[],a=[];for(const l of f)if(l instanceof w.URI)o.push(l);else{const[h,A]=(0,P.getIdAndVersion)(l);n(h,A)&&r(h,A,!1)}for(const l of y){const[h,A]=(0,P.getIdAndVersion)(l);n(h,A)&&r(h,A,!0)}if(o.length&&await Promise.all(o.map(async l=>{try{const h=await this.installVSIX(l,{...E,isBuiltin:!1},S,m);h&&s.push(h)}catch(h){m.error(h.message||h.stack||h),t.push(l.toString())}})),a.length){const l=await this.getGalleryExtensions(a);await Promise.all(a.map(async h=>{const A=l.get(h.id.toLowerCase());if(A)try{const x=await this.installFromGallery(h,A,i,S,m);x&&s.push(x)}catch(x){m.error(x.message||x.stack||x),t.push(h.id)}else m.error(`${d(h.version?`${h.id}@${h.version}`:h.id)}
${b}`),t.push(h.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async installVSIX(f,y,E,S){const m=await this.extensionManagementService.getManifest(f);if(!m)throw new Error("Invalid vsix");if(await this.validateVSIX(m,E,y.profileLocation,S))try{return await this.extensionManagementService.install(f,y),S.log((0,g.localize)(8,null,(0,C.basename)(f))),m}catch(s){if((0,D.isCancellationError)(s))return S.log((0,g.localize)(9,null,(0,C.basename)(f))),null;throw s}return null}async getGalleryExtensions(f){const y=new Map,E=f.some(m=>m.installOptions.installPreReleaseVersion),S=await this.extensionGalleryService.getExtensions(f.map(m=>({...m,preRelease:E})),L.CancellationToken.None);for(const m of S)y.set(m.identifier.id.toLowerCase(),m);return y}async installFromGallery({id:f,version:y,installOptions:E},S,m,t,s){const i=await this.extensionGalleryService.getManifest(S,L.CancellationToken.None);if(i&&!this.validateExtensionKind(i,s))return null;const n=m.find(r=>(0,P.areSameExtensions)(r.identifier,S.identifier));if(n){if(S.version===n.manifest.version)return s.log((0,g.localize)(10,null,y?`${f}@${y}`:f)),null;s.log((0,g.localize)(11,null,f,S.version))}try{E.isBuiltin?s.log(y?(0,g.localize)(12,null,f,y):(0,g.localize)(13,null,f)):s.log(y?(0,g.localize)(14,null,f,y):(0,g.localize)(15,null,f));const r=await this.extensionManagementService.installFromGallery(S,{...E,installGivenVersion:!!y});return s.log((0,g.localize)(16,null,f,r.manifest.version)),i}catch(r){if((0,D.isCancellationError)(r))return s.log((0,g.localize)(17,null,f)),null;throw r}}validateExtensionKind(f,y){return!0}async validateVSIX(f,y,E,S){const m={id:(0,P.getGalleryExtensionId)(f.publisher,f.name)},s=(await this.extensionManagementService.getInstalled(1,E)).find(i=>(0,P.areSameExtensions)(m,i.identifier)&&(0,R.gt)(i.manifest.version,f.version));return s&&!y?(S.log((0,g.localize)(18,null,s.identifier.id,s.manifest.version,f.version)),!1):this.validateExtensionKind(f,S)}async uninstallExtensions(f,y,E,S=console){const m=async s=>{if(s instanceof w.URI){const i=await this.extensionManagementService.getManifest(s);return v(i)}return s},t=[];for(const s of f){const i=await m(s),r=(await this.extensionManagementService.getInstalled(void 0,E)).filter(o=>(0,P.areSameExtensions)(o.identifier,{id:i}));if(!r.length)throw new Error(`${this.notInstalled(i)}
${b}`);if(r.some(o=>o.type===0)){S.log((0,g.localize)(19,null,i));return}if(!y&&r.some(o=>o.isBuiltin)){S.log((0,g.localize)(20,null,i));return}S.log((0,g.localize)(21,null,i));for(const o of r)await this.extensionManagementService.uninstall(o,{profileLocation:E}),t.push(o);this.location?S.log((0,g.localize)(22,null,i,this.location)):S.log((0,g.localize)(23,null,i))}}async locateExtension(f,y=console){const E=await this.extensionManagementService.getInstalled();f.forEach(S=>{E.forEach(m=>{if(m.identifier.id===S&&m.location.scheme===I.Schemas.file){y.log(m.location.fsPath);return}})})}notInstalled(f){return this.location?(0,g.localize)(24,null,f,this.location):(0,g.localize)(25,null,f)}};T=fe([ee(0,u.IExtensionManagementService),ee(1,u.IExtensionGalleryService)],T),e.ExtensionManagementCLI=T}),define(J[133],Z([0,1,5,7,2,16,12,18,41,3,30,20,23,17,24,26,59,13,6]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let E=class je extends I.Disposable{constructor(m,t,s,i,n,r){super(),this.fileService=t,this.extensionGalleryService=s,this.configurationService=i,this.extensionSignatureVerificationService=n,this.logService=r,this.extensionsDownloadDir=m.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(m,t){await this.cleanUpPromise;const s=(0,w.joinPath)(this.extensionsDownloadDir,this.getName(m));try{await this.downloadFile(m,s,n=>this.extensionGalleryService.download(m,n,t))}catch(n){throw new v.ExtensionManagementError(n.message,v.ExtensionManagementErrorCode.Download)}let i="Unverified";if(await this.shouldVerifySignature(m)){const n=await this.downloadSignatureArchive(m);try{await this.extensionSignatureVerificationService.verify(s.fsPath,n.fsPath)&&(i="Verified"),this.logService.info(`Extension signature verification: ${m.identifier.id}. Verification status: ${i}.`)}catch(r){const o=r,a=o.code;if(a==="UnknownError")i="UnknownError",this.logService.warn(`Extension signature verification: ${m.identifier.id}. Verification status: ${i}.`);else if(!o.didExecute)this.logService.warn(`Extension signature verification: ${m.identifier.id}. Verification status: ${i} (${a})`);else throw await this.delete(n),await this.delete(s),new v.ExtensionManagementError(a,v.ExtensionManagementErrorCode.Signature)}}return{location:s,verificationStatus:i}}async shouldVerifySignature(m){if(!m.isSigned)return!1;const t=this.configurationService.getValue("extensions.verifySignature");return(0,u.isBoolean)(t)?t:!0}async downloadSignatureArchive(m){await this.cleanUpPromise;const t=(0,w.joinPath)(this.extensionsDownloadDir,`${this.getName(m)}${je.SignatureArchiveExtension}`);return await this.downloadFile(m,t,s=>this.extensionGalleryService.downloadSignatureArchive(m,s)),t}async downloadFile(m,t,s){if(await this.fileService.exists(t))return;if(t.scheme!==C.Schemas.file){await s(t);return}const i=(0,w.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(i)||await s(i);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",m.identifier.id,t.path);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,t,s){try{await p.Promises.rename(m.fsPath,t.fsPath)}catch(i){if(R.isWindows&&i&&i.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${m} to ${t} with 'EPERM' error. Trying again...`),this.rename(m,t,s);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const t=[],s=[],i=[];for(const o of m.children)if(o.name.endsWith(je.SignatureArchiveExtension))i.push(o.resource);else{const a=T.ExtensionKey.parse(o.name);a&&s.push([a,o])}const n=(0,T.groupByExtension)(s,([o])=>o),r=[];for(const o of n)o.sort((a,l)=>g.rcompare(a[0].version,l[0].version)),t.push(...o.slice(1).map(a=>a[1].resource)),r.push(o[0][1]);r.sort((o,a)=>o.mtime-a.mtime),t.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(o=>o.resource)),t.push(...i),await L.Promises.settled(t.map(o=>(this.logService.trace("Deleting from cache",o.path),this.fileService.del(o))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?T.ExtensionKey.create(m).toString().toLowerCase():(0,P.generateUuid)()}};E.SignatureArchiveExtension=".sigzip",E=fe([ee(0,b.INativeEnvironmentService),ee(1,f.IFileService),ee(2,v.IExtensionGalleryService),ee(3,d.IConfigurationService),ee(4,c.IExtensionSignatureVerificationService),ee(5,y.ILogService)],E),e.ExtensionsDownloader=E}),define(J[134],Z([0,1,4,2,34,26,28]),function($,e,L,D,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class w extends D.Disposable{constructor(u,P,p,d,b,v,T){super(),this.extensionManagementService=u,this.extensionsScannerService=P,this.userDataProfilesService=p,this.extensionsProfileScannerService=d,this.uriIdentityService=b,this.fileService=v,this.logService=T,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new D.DisposableMap),this.initialize().then(null,c=>T.error(c))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(u=>this.onDidChangeProfiles(u.added,u.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(u=>this.onAddExtensions(u))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(u=>this.onDidAddExtensions(u))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(u=>this.onRemoveExtensions(u))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(u=>this.onDidRemoveExtensions(u))),this._register(this.fileService.onDidFilesChange(u=>this.onDidFilesChange(u)))}async onDidChangeProfiles(u,P){try{await Promise.all(P.map(p=>(this.extensionsProfileWatchDisposables.deleteAndDispose(p.id),this.removeExtensionsFromProfile(p.extensionsResource)))),u.length&&await Promise.all(u.map(p=>(this.extensionsProfileWatchDisposables.set(p.id,(0,D.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(p.extensionsResource)),this.fileService.watch(p.extensionsResource))),this.populateExtensionsFromProfile(p.extensionsResource))))}catch(p){throw this.logService.error(p),p}}async onAddExtensions(u){for(const P of u.extensions)this.addExtensionWithKey(this.getKey(P.identifier,P.version),u.profileLocation)}async onDidAddExtensions(u){for(const P of u.extensions){const p=this.getKey(P.identifier,P.version);u.error?this.removeExtensionWithKey(p,u.profileLocation):this.addExtensionWithKey(p,u.profileLocation)}}async onRemoveExtensions(u){for(const P of u.extensions)this.removeExtensionWithKey(this.getKey(P.identifier,P.version),u.profileLocation)}async onDidRemoveExtensions(u){let P=!1;for(const p of u.extensions){const d=this.getKey(p.identifier,p.version);u.error?this.addExtensionWithKey(d,u.profileLocation):(this.removeExtensionWithKey(d,u.profileLocation),P=P||!this.allExtensions.has(d))}P&&await this.uninstallExtensionsNotInProfiles()}onDidFilesChange(u){for(const P of this.userDataProfilesService.profiles)u.contains(P.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(P.extensionsResource)}async onDidExtensionsProfileChange(u){const P=[],p=[],d=await this.extensionsProfileScannerService.scanProfileExtensions(u),b=new Set,v=new Set;for(const[T,c]of this.allExtensions)c.has(u)&&v.add(T);for(const T of d){const c=this.getKey(T.identifier,T.version);b.add(c),v.has(c)||(P.push(T.identifier),this.addExtensionWithKey(c,u))}for(const T of v)if(!b.has(T)){const c=this.fromKey(T);c&&(p.push(c.identifier),this.removeExtensionWithKey(T,u))}(P.length||p.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P.length?{extensions:P,profileLocation:u}:void 0,removed:p.length?{extensions:p,profileLocation:u}:void 0})}async populateExtensionsFromProfile(u){const P=await this.extensionsProfileScannerService.scanProfileExtensions(u);for(const p of P)this.addExtensionWithKey(this.getKey(p.identifier,p.version),u)}async removeExtensionsFromProfile(u){for(const P of[...this.allExtensions.keys()])this.removeExtensionWithKey(P,u);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(){const P=(await this.extensionManagementService.getAllUserInstalled()).filter(p=>p.installedTimestamp&&!this.allExtensions.has(this.getKey(p.identifier,p.manifest.version)));P.length&&await this.extensionManagementService.markAsUninstalled(...P)}addExtensionWithKey(u,P){let p=this.allExtensions.get(u);p||this.allExtensions.set(u,p=new I.ResourceSet(d=>this.uriIdentityService.extUri.getComparisonKey(d))),p.add(P)}removeExtensionWithKey(u,P){const p=this.allExtensions.get(u);p&&p.delete(P),p?.size||this.allExtensions.delete(u)}getKey(u,P){return`${R.ExtensionIdentifier.toKey(u.id)}@${P}`}fromKey(u){const[P,p]=(0,C.getIdAndVersion)(u);return p?{identifier:{id:P},version:p}:void 0}}e.ExtensionsWatcher=w}),define(J[135],Z([0,1,108,39]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function I(C,R,w,g,u,P,p){const d={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${R.nameShort})`};if((0,D.supportsTelemetry)(R,w)&&(0,D.getTelemetryLevel)(g)===3){const b=await(0,L.getServiceMachineId)(w,u,P),{machineId:v}=await p.getTelemetryInfo();d["X-Market-User-Id"]=b,d["VSCode-SessionId"]=v||b}return d}e.resolveMarketplaceHeaders=I}),define(J[136],Z([0,1,163,19,5,2,16,14,20,17,24,26,6,63,12,11]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let c=class extends b.LanguagePackBaseService{constructor(S,m,t,s){super(t),this.extensionManagementService=S,this.logService=s,this.cache=this._register(new f(m,s)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getBuiltInExtensionTranslationsUri(S){const t=(await this.cache.getLanguagePacks())[v.Language.value()];if(!t){this.logService.warn(`No language pack found for ${v.Language.value()}`);return}const s=t.translations[S];return s?T.URI.file(s):void 0}async getInstalledLanguages(){const S=await this.cache.getLanguagePacks(),m=Object.keys(S).map(t=>{const s=S[t];return{...this.createQuickPickItem(t,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.createQuickPickItem("en","English")),m.sort((t,s)=>t.label.localeCompare(s.label)),m}async postInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",S.identifier.id),await this.update())}async postUninstallExtension(S){const m=await this.cache.getLanguagePacks();Object.keys(m).some(t=>m[t]&&m[t].extensions.some(s=>(0,p.areSameExtensions)(s.extensionIdentifier,S.identifier)))&&(this.logService.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),t=await this.cache.update(m);return!(0,D.equals)(Object.keys(S),Object.keys(t))}};c=fe([ee(0,P.IExtensionManagementService),ee(1,u.INativeEnvironmentService),ee(2,P.IExtensionGalleryService),ee(3,d.ILogService)],c),e.NativeLanguagePackService=c;let f=class extends C.Disposable{constructor(S,m){super(),this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new I.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(m=>{Object.keys(m).forEach(t=>delete m[t]),this.createLanguagePacksFromExtensions(m,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...m){for(const t of m)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,t);Object.keys(S).forEach(t=>this.updateHash(S[t]))}createLanguagePacksFromExtension(S,m){const t=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const i of s)if(m.location.scheme===R.Schemas.file&&y(i)){let n=S[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},S[i.languageId]=n);const r=n.extensions.filter(o=>(0,p.areSameExtensions)(o.extensionIdentifier,t))[0];r?r.version=m.manifest.version:n.extensions.push({extensionIdentifier:t,version:m.manifest.version});for(const o of i.translations)n.translations[o.id]=(0,w.join)(m.location.fsPath,o.path)}}updateHash(S){if(S){const m=(0,L.createHash)("md5");for(const t of S.extensions)m.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);S.hash=m.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return g.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(m=S(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.languagePacks=t,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),g.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>m,t=>this.logService.error(t))})}};f=fe([ee(0,u.INativeEnvironmentService),ee(1,d.ILogService)],f);function y(E){if(typeof E.languageId!="string"||!Array.isArray(E.translations)||E.translations.length===0)return!1;for(const S of E.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(E.languageName&&typeof E.languageName!="string"||E.localizedLanguageName&&typeof E.localizedLanguageName!="string")}}),define(J[137],Z([0,1,7,29,39]),function($,e,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function w(u,P,p){const d=await new Promise((f,y)=>{$(["@microsoft/1ds-core-js"],f,y)}),b=await new Promise((f,y)=>{$(["@microsoft/1ds-post-js"],f,y)}),v=new d.AppInsightsCore,T=new b.PostChannel,c={instrumentationKey:u,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[T]]};if(p){c.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:p};c.extensionConfig[T.identifier]=f}return v.initialize(c,[]),v.addTelemetryInitializer(f=>{P&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),v}class g{constructor(P,p,d,b,v){this._isInternalTelemetry=P,this._eventPrefix=p,this._defaultData=d,this._xhrOverride=v,this.endPointUrl=C,this.endPointHealthUrl=R,this._defaultData||(this._defaultData={}),typeof b=="function"?this._aiCoreOrKey=b():this._aiCoreOrKey=b,this._asyncAiCore=null}_withAIClient(P){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=w(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(p=>{P(p)},p=>{(0,L.onUnexpectedError)(p),console.error(p)})}}log(P,p){if(!this._aiCoreOrKey)return;p=(0,D.mixin)(p,this._defaultData),p=(0,I.validateTelemetryData)(p);const d=this._eventPrefix+"/"+P;try{this._withAIClient(b=>{b.pluginVersionString=p?.properties.version??"Unknown",b.track({name:d,baseData:{name:d,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(p=>{p.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(J[138],Z([0,1,2,29,12,31,101,23,42,139,32,35,25,39]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(f,y,E){this._configurationService=y,this._productService=E,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(S=>{(S.affectsConfiguration(d.TELEMETRY_SETTING_ID)||S.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(f,y){this._experimentProperties[f]=y}_updateTelemetryLevel(){let f=(0,b.getTelemetryLevel)(this._configurationService);const y=this._productService.enabledTelemetryLevels;if(y){this._sendErrorTelemetry=this.sendErrorTelemetry?y.error:!1;const E=y.usage?3:y.error?2:0;f=Math.min(f,E)}this._telemetryLevel=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties,y=f.sessionID,E=f["common.machineId"],S=f["common.firstSessionDate"],m=f["common.msftInternal"];return{sessionId:y,machineId:E,firstSessionDate:S,msftInternal:m}}dispose(){this._disposables.dispose()}_log(f,y,E){return this._telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(S=>{E=(0,D.mixin)(E,this._experimentProperties),E=(0,b.cleanData)(E,this._cleanupPatterns),E=(0,D.mixin)(E,S),this._appenders.forEach(m=>m.log(f,E))},S=>{console.error(S)})}publicLog(f,y){return this._log(f,3,y)}publicLog2(f,y){return this.publicLog(f,y)}publicLogError(f,y){return this._sendErrorTelemetry?this._log(f,2,y):Promise.resolve(void 0)}publicLogError2(f,y){return this.publicLogError(f,y)}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=fe([ee(1,w.IConfigurationService),ee(2,P.IProductService)],v),e.TelemetryService=v;function T(){const c=(0,R.localize)(0,null,u.default.nameLong),f=u.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=I.isWeb?"":(0,R.localize)(3,null),E=(0,R.localize)(4,null),S=(0,R.localize)(5,null),m=(0,R.localize)(6,null),t=(0,R.localize)(7,null),s=`
|       | ${E} | ${S} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,R.localize)(8,null);return`
${c} ${f} ${y}

&nbsp;

${t}
${s}

&nbsp;

${i}
`}p.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:T(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,R.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,R.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[140],Z([0,1,164,137]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class I extends D.AbstractOneDataSystemAppender{constructor(R,w,g,u){const P={sendPOST:(p,d)=>{const b={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const v=L.request(p.urlString,b,T=>{T.on("data",function(c){d(T.statusCode??200,T.headers,c.toString())}),T.on("error",function(c){d(0,{})})});v.write(p.data),v.end()}catch{d(0,{})}}};super(R,w,g,u,P)}}e.OneDataSystemAppender=I}),define(J[141],Z([0,1,14,20]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function I(C,R){const w=Object.create(null),g=(P,p)=>{const d=JSON.parse(P);w[p]=d};if(R){const P=[],p=await D.Promises.readdir(R);for(const b of p)try{(await D.Promises.stat((0,L.join)(R,b))).isDirectory()&&P.push(b)}catch{}const d=[];for(const b of P)(await D.Promises.readdir((0,L.join)(R,b))).filter(T=>T==="telemetry.json").length===1&&d.push(b);for(const b of d){const v=(await D.Promises.readFile((0,L.join)(R,b,"telemetry.json"))).toString();g(v,b)}}let u=(await D.Promises.readFile((0,L.join)(C,"telemetry-core.json"))).toString();return g(u,"vscode-core"),u=(await D.Promises.readFile((0,L.join)(C,"telemetry-extensions.json"))).toString(),g(u,"vscode-extensions"),JSON.stringify(w,null,4)}e.buildTelemetryMessage=I}),define(J[142],Z([0,1,12,80,25]),function($,e,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function C(R){let w=R.getItem(I.machineIdKey);return(typeof w!="string"||L.isMacintosh&&w==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(w=await(0,D.getMachineId)()),w}e.resolveMachineId=C}),define(J[27],Z([0,1,10]),function($,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(J[143],Z([0,1,27,109,13,18,72,4,2]),function($,e,L,D,I,C,R,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(d){this.uri=d,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let P=class{constructor(d){this._fileService=d,this._dispooables=new g.DisposableStore,this._limit=2**16;const b=new Map,v=T=>{let c=b.get(T.scheme);return c===void 0&&(c=d.hasProvider(T)&&!this._fileService.hasCapability(T,1024),b.set(T.scheme,c)),c};this._dispooables.add(w.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(T=>{b.delete(T.scheme)})),this.extUri=new C.ExtUri(v),this._canonicalUris=new R.SkipList((T,c)=>this.extUri.compare(T,c,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,C.normalizePath)(d));const b=this._canonicalUris.get(d);return b?b.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new u(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((v,T)=>v[1].touch<T[1].touch?1:v[1].touch>T[1].touch?-1:0);u._clock=0,this._canonicalUris.clear();const b=this._limit*.5;for(let v=0;v<b;v++)this._canonicalUris.set(d[v][0],d[v][1].touch())}};P=fe([ee(0,I.IFileService)],P),e.UriIdentityService=P,(0,D.registerSingleton)(L.IUriIdentityService,P,1)}),define(J[144],Z([0,1,103,14,54,18,11,10,16]),function($,e,L,D,I,C,R,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,w.createDecorator)("contextService");function u(i){const n=i;return typeof n?.id=="string"&&R.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=u;function P(i){return typeof i?.id=="string"&&!u(i)&&!d(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function p(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=p;function d(i){const n=i;return typeof n?.id=="string"&&R.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=d;function b(i){const n=i;if(n?.uri)return{id:n.id,uri:R.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:R.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=b;var v;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function T(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=T;function c(i){const n=i;return!!(n&&typeof n=="object"&&R.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=c;class f{constructor(n,r,o,a,l){this._id=n,this._transient=o,this._configuration=a,this._ignorePathCasing=l,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,C.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function E(i){return new y({uri:i,index:0,name:(0,C.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(i,n){return C.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function m(i){let n;return R.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=m;function t(i,n){return!S(i,n)&&!m(i)}e.isSavedWorkspace=t;function s(i){return(typeof i=="string"?(0,D.extname)(i):(0,C.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(J[21],Z([0,1,51,4,2,18,11,102,17,13,10,6,144,34,27,5,30,31,3]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&R.URI.isUri(n.location)&&R.URI.isUri(n.globalStorageHome)&&R.URI.isUri(n.settingsResource)&&R.URI.isUri(n.keybindingsResource)&&R.URI.isUri(n.tasksResource)&&R.URI.isUri(n.snippetsHome)&&R.URI.isUri(n.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function S(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:R.URI.revive(i.location).with({scheme:n}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:R.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=S;function m(i,n,r,o){return{id:i,name:n,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,C.joinPath)(r,"globalStorage"),settingsResource:(0,C.joinPath)(r,"settings.json"),keybindingsResource:(0,C.joinPath)(r,"keybindings.json"),tasksResource:(0,C.joinPath)(r,"tasks.json"),snippetsHome:(0,C.joinPath)(r,"snippets"),extensionsResource:(0,C.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=m;let t=class extends I.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,r,o,a){super(),this.environmentService=n,this.fileService=r,this.uriIdentityService=o,this.logService=a,this.enabled=!0,this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new D.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new D.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new D.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new b.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,C.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=[];if(this.enabled)for(const l of this.getStoredProfiles()){if(!l.name||!(0,y.isString)(l.name)||!l.location){this.logService.warn("Skipping the invalid stored profile",l.location||l.name);continue}n.push(m((0,C.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}const r=new b.ResourceMap,o=new Map,a=this.createDefaultProfile();if(n.unshift({...a,extensionsResource:this.getDefaultProfileExtensionsLocation()??a.extensionsResource,isDefault:!0}),n.length){const l=this.getStoredProfileAssociations();if(l.workspaces)for(const[h,A]of Object.entries(l.workspaces)){const x=R.URI.parse(h),Y=n.find(Q=>Q.id===A);Y&&r.set(x,Y)}if(l.emptyWindows)for(const[h,A]of Object.entries(l.emptyWindows)){const x=n.find(Y=>Y.id===A);x&&o.set(h,x)}}this._profilesObject={profiles:n,workspaces:r,emptyWindows:o}}return this._profilesObject}createDefaultProfile(){return m("__default__profile__",(0,w.localize)(0,null),this.environmentService.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",o=new RegExp(`${(0,f.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const h of this.profiles){const A=o.exec(h.name),x=A?parseInt(A[1]):0;a=x>a?x:a}const l=`${r} ${a+1}`;return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),l,{transient:!0},n)}async createNamedProfile(n,r,o){return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),n,r,o)}async createProfile(n,r,o,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const l=await this.doCreateProfile(n,r,o);return a&&await this.setProfileForWorkspace(a,l),l}async doCreateProfile(n,r,o){if(!(0,y.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.profileCreationPromises.get(r);return a||(a=(async()=>{try{const l=this.profiles.find(x=>x.name===r||x.id===n);if(l)return l;const h=m(n,r,(0,C.joinPath)(this.profilesHome,n),o);await this.fileService.createFolder(h.location);const A=[];return this._onWillCreateProfile.fire({profile:h,join(x){A.push(x)}}),await T.Promises.settled(A),this.updateProfiles([h],[],[]),h}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,a)),a}async updateProfile(n,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=m(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.updateProfiles([],[],[o]),o}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(a){o.push(a)}});try{await Promise.allSettled(o)}catch(a){this.logService.error(a)}for(const a of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(a)?.id&&this.profilesObject.emptyWindows.delete(a);for(const a of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(a){this.logService.error(a)}}async setProfileForWorkspace(n,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(n,o)}unsetWorkspace(n,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.getWorkspace(n);return R.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(n){return(0,d.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,d.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location)))}updateProfiles(n,r,o){const a=[...this.profiles,...n],l=[];this.transientProfilesObject.profiles=[];for(let h of a)h.isDefault||r.some(A=>h.id===A.id)||(h=o.find(A=>h.id===A.id)??h,h.isTransient?this.transientProfilesObject.profiles.push(h):l.push({location:h.location,name:h.name,shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}));this.saveStoredProfiles(l),this._profilesObject=void 0,this.triggerProfilesChanges(n,r,o)}triggerProfilesChanges(n,r,o){this._onDidChangeProfiles.fire({added:n,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(n,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(n,void 0,!0);const a=this.getWorkspace(n),l=o?this.transientProfilesObject:this.profilesObject;R.URI.isUri(a)?(l.workspaces.delete(a),r&&l.workspaces.set(a,r)):(l.emptyWindows.delete(a),r&&l.emptyWindows.set(a,r)),o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[o,a]of this.profilesObject.workspaces.entries())n[o.toString()]=a.id;const r={};for(const[o,a]of this.profilesObject.emptyWindows.entries())r[o.toString()]=a.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const r={},o=this.createDefaultProfile();if(n.workspaces)for(const[l,h]of Object.entries(n.workspaces)){const A=R.URI.parse(h);r[l]=this.uriIdentityService.extUri.isEqual(A,o.location)?o.id:this.uriIdentityService.extUri.basename(A)}const a={};if(n.emptyWindows)for(const[l,h]of Object.entries(n.emptyWindows)){const A=R.URI.parse(h);a[l]=this.uriIdentityService.extUri.isEqual(A,o.location)?o.id:this.uriIdentityService.extUri.basename(A)}return{workspaces:r,emptyWindows:a}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",t=fe([ee(0,g.IEnvironmentService),ee(1,u.IFileService),ee(2,v.IUriIdentityService),ee(3,p.ILogService)],t),e.UserDataProfilesService=t;class s extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(J[145],Z([0,1,19,5,22,7,4,2,12,11,87,24,26,28,6,32,25,21]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var y;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(y=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let E=class extends w.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(n,r,o,a,l){super(),this.galleryService=n,this.telemetryService=r,this.logService=o,this.productService=a,this.userDataProfilesService=l,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(({task:h})=>h.cancel()),this.uninstallingExtensions.forEach(h=>h.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,p.isTargetPlatformCompatible)(o,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.galleryService.isEnabled())throw new p.ExtensionManagementError(P.localize(0,null),p.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw t(this.telemetryService,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(n),error:o}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(o),m(o)}}async uninstall(n,r={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,r,o){const a={...o,installOnlyNewlyAddedFromExtensionPack:u.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,b.isApplicationScopedExtension)(n)?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},l=te=>`${d.ExtensionKey.create(te).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!u.URI.isUri(r)){const te=this.installingExtensions.get(l(r));if(te){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await te.task.waitUntilTaskIsFinished();return ie}}const h=[],A=[],x=[],Y=this.createInstallExtensionTask(n,r,a);u.URI.isUri(r)||this.installingExtensions.set(l(r),{task:Y,waitingTasks:[]}),this._onInstallExtension.fire({identifier:Y.identifier,source:r,profileLocation:a.profileLocation}),this.logService.info("Installing extension:",Y.identifier.id),h.push({task:Y,manifest:n});let Q=!1;try{if(a.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ie=await this.getAllDepsAndPackExtensions(Y.identifier,n,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),ne=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:ae,manifest:ue}of(0,L.distinct)(ie,({gallery:se})=>se.identifier.id)){Q=Q||!!ue.extensionDependencies?.some(V=>(0,d.areSameExtensions)({id:V},Y.identifier));const se=l(ae),pe=this.installingExtensions.get(se);if(pe){if(this.canWaitForTask(Y,pe.task)){const V=pe.task.identifier;this.logService.info("Waiting for already requested installing extension",V.id,Y.identifier.id),pe.waitingTasks.push(Y),A.push(R.Event.toPromise(R.Event.filter(this.onDidInstallExtensions,M=>M.some(F=>(0,d.areSameExtensions)(F.identifier,V)))).then(M=>{if(this.logService.info("Finished waiting for already requested installing extension",V.id,Y.identifier.id),!M.find(j=>(0,d.areSameExtensions)(j.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!ne.some(({identifier:V})=>(0,d.areSameExtensions)(V,ae.identifier))){const V=this.createInstallExtensionTask(ue,ae,{...a,donotIncludePackAndDependencies:!0});this.installingExtensions.set(se,{task:V,waitingTasks:[Y]}),this._onInstallExtension.fire({identifier:V.identifier,source:ae,profileLocation:a.profileLocation}),this.logService.info("Installing extension:",V.identifier.id,Y.identifier.id),h.push({task:V,manifest:ue})}}}catch(ie){if(u.URI.isUri(Y.source))(0,L.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",Y.identifier.id,ie.message),(0,L.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",Y.identifier.id,ie.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ie}const te=h.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;te.size;){let ie;const ne=[...te.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(ue=>te.has(ue.toLowerCase())));ne.length?ie=te.size===1?ne:ne.filter(({task:ae})=>!(ae===Y&&!Q)):(this.logService.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...te.values()]),await this.joinAllSettled(ie.map(async({task:ae})=>{const ue=new Date().getTime();try{const{local:se}=await ae.run();if(await this.joinAllSettled(this.participants.map(pe=>pe.postInstall(se,ae.source,a,I.CancellationToken.None))),!u.URI.isUri(ae.source)){const pe=ae.operation===3,V=pe?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.telemetryService,pe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,durationSinceUpdate:V}),g.isWeb&&ae.operation!==3)try{await this.galleryService.reportStatistic(se.manifest.publisher,se.manifest.name,se.manifest.version,"install")}catch{}}x.push({local:se,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:se.isApplicationScoped})}catch(se){throw u.URI.isUri(ae.source)||t(this.telemetryService,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,error:se}),this.logService.error("Error while installing the extension:",ae.identifier.id),se}finally{te.delete(ae.identifier.id.toLowerCase())}}))}return A.length&&await this.joinAllSettled(A),x.forEach(({identifier:ie})=>this.logService.info("Extension installed successfully:",ie.id)),this._onDidInstallExtensions.fire(x),x.filter(({identifier:ie})=>(0,d.areSameExtensions)(ie,Y.identifier))[0].local}catch(te){if(h.forEach(({task:ie})=>ie.cancel()),x.length)try{const ie=await Promise.allSettled(x.map(({local:ne})=>this.createUninstallExtensionTask(ne,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:ue}=x[ne];ae.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ue.id):this.logService.warn("Rollback: Error while uninstalling extension",ue.id,(0,C.getErrorMessage)(ae.reason))}}catch(ie){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(ie),x.map(({identifier:ne})=>ne.id))}throw this._onDidInstallExtensions.fire(h.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:a.context,profileLocation:a.profileLocation}))),te}finally{for(const{task:te}of h)te.source&&!u.URI.isUri(te.source)&&this.installingExtensions.delete(l(te.source))}}canWaitForTask(n,r){for(const[,{task:o,waitingTasks:a}]of this.installingExtensions.entries())if(o===n&&(a.includes(r)||a.some(l=>this.canWaitForTask(l,r)))||o===r&&a[0]&&!this.canWaitForTask(n,a[0]))return!1;return!0}async joinAllSettled(n){const r=[],o=[],a=await Promise.allSettled(n);for(const l of a)l.status==="fulfilled"?r.push(l.value):o.push(l.reason);if(o.length)throw S(o);return r}async getAllDepsAndPackExtensions(n,r,o,a,l){if(!this.galleryService.isEnabled())return[];const h=await this.getInstalled(void 0,l),A=[],x=[],Y=async(Q,te)=>{A.push(Q);const ie=te.extensionDependencies||[],ne=[...ie];if(te.extensionPack){const ae=o?h.find(ue=>(0,d.areSameExtensions)(ue.identifier,Q)):void 0;for(const ue of te.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(se=>(0,d.areSameExtensions)({id:se},{id:ue}))||ne.every(se=>!(0,d.areSameExtensions)({id:se},{id:ue}))&&ne.push(ue)}if(ne.length){const ae=ne.filter(ue=>A.every(se=>!(0,d.areSameExtensions)(se,{id:ue})));if(ae.length){const ue=await this.galleryService.getExtensions(ae.map(se=>({id:se,preRelease:a})),I.CancellationToken.None);for(const se of ue){if(A.find(M=>(0,d.areSameExtensions)(M,se.identifier)))continue;const pe=ie.some(M=>(0,d.areSameExtensions)({id:M},se.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(se,!1,a)}catch(M){if(M instanceof p.ExtensionManagementError&&M.code===p.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!pe){this.logService.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw M}x.push({gallery:V.extension,manifest:V.manifest}),await Y(V.extension.identifier,V.manifest)}}}};return await Y(n,r),x}async checkAndGetCompatibleVersion(n,r,o){if((await this.getExtensionsControlManifest()).malicious.some(A=>(0,d.areSameExtensions)(n.identifier,A)))throw new p.ExtensionManagementError(P.localize(1,null,n.identifier.id),p.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const A=await this.getTargetPlatform();throw new p.ExtensionManagementError(P.localize(2,null,n.identifier.id,this.productService.nameLong,(0,p.TargetPlatformToString)(A)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(n,r,o);if(l){if(o&&!r&&n.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new p.ExtensionManagementError(P.localize(3,null,n.identifier.id,this.productService.nameLong,this.productService.version),p.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],I.CancellationToken.None))[0]?new p.ExtensionManagementError(P.localize(4,null,n.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.ExtensionManagementError(P.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),p.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const h=await this.galleryService.getManifest(l,I.CancellationToken.None);if(h===null)throw new p.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(h.version!==l.version)throw new p.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:h}}async getCompatibleVersion(n,r,o){const a=await this.getTargetPlatform();let l=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(l=(await this.galleryService.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:a,compatible:!0},I.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(n,o,a)&&(l=n),l||(r?l=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},I.CancellationToken.None))[0]||null:l=await this.galleryService.getCompatibleExtension(n,o,a)),l}async uninstallExtension(n,r){const o={...r,profileLocation:n.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},a=Q=>`${Q.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,l=this.uninstallingExtensions.get(a(n.identifier));if(l)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),l.waitUntilTaskIsFinished();const h=Q=>{const te=this.createUninstallExtensionTask(Q,o);return this.uninstallingExtensions.set(a(te.extension.identifier),te),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${Q.identifier.id}@${Q.manifest.version}`),this._onUninstallExtension.fire({identifier:Q.identifier,profileLocation:o.profileLocation,applicationScoped:Q.isApplicationScoped}),te},A=(Q,te)=>{te?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,o.profileLocation.toString(),te.message):this.logService.error("Failed to uninstall extension:",`${Q.identifier.id}@${Q.manifest.version}`,te.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${Q.identifier.id}@${Q.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${Q.identifier.id}@${Q.manifest.version}`),t(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(Q),error:te}),this._onDidUninstallExtension.fire({identifier:Q.identifier,error:te?.code,profileLocation:o.profileLocation,applicationScoped:Q.isApplicationScoped})},x=[],Y=[];try{x.push(h(n));const Q=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const te=this.getAllPackExtensionsToUninstall(n,Q);for(const ie of te)this.uninstallingExtensions.has(a(ie.identifier))?this.logService.info("Extensions is already requested to uninstall",ie.identifier.id):x.push(h(ie))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(x.map(te=>te.extension),Q,n),await this.joinAllSettled(x.map(async te=>{try{if(await te.run(),await this.joinAllSettled(this.participants.map(ie=>ie.postUninstall(te.extension,o,I.CancellationToken.None))),te.extension.identifier.uuid)try{await this.galleryService.reportStatistic(te.extension.manifest.publisher,te.extension.manifest.name,te.extension.manifest.version,"uninstall")}catch{}A(te.extension)}catch(ie){const ne=ie instanceof p.ExtensionManagementError?ie:new p.ExtensionManagementError((0,C.getErrorMessage)(ie),p.ExtensionManagementErrorCode.Internal);throw A(te.extension,ne),ne}finally{Y.push(te)}}))}catch(Q){const te=Q instanceof p.ExtensionManagementError?Q:new p.ExtensionManagementError((0,C.getErrorMessage)(Q),p.ExtensionManagementErrorCode.Internal);for(const ie of x){try{ie.cancel()}catch{}Y.includes(ie)||A(ie.extension,te)}throw te}finally{for(const Q of x)this.uninstallingExtensions.delete(a(Q.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",Q.extension.identifier.id)}}checkForDependents(n,r,o){for(const a of n){const l=this.getDependents(a,r);if(l.length){const h=l.filter(A=>!n.some(x=>(0,d.areSameExtensions)(x.identifier,A.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(a,h,o))}}}getDependentsErrorMessage(n,r,o){return o===n?r.length===1?P.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?P.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(n,r,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const l=r.filter(A=>!A.isBuiltin&&a.some(x=>(0,d.areSameExtensions)({id:x},A.identifier))),h=[];for(const A of l)h.push(...this.getAllPackExtensionsToUninstall(A,r,o));return[...l,...h]}return[]}getDependents(n,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,d.areSameExtensions)({id:a},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};E=fe([ee(0,p.IExtensionGalleryService),ee(1,c.ITelemetryService),ee(2,v.ILogService),ee(3,T.IProductService),ee(4,f.IUserDataProfilesService)],E),e.AbstractExtensionManagementService=E;function S(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=S;function m(i){if(i instanceof p.ExtensionManagementError)return i;const n=new p.ExtensionManagementError(i.message,p.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:o,duration:a,error:l,durationSinceUpdate:h}){let A,x;l&&(l instanceof p.ExtensionManagementError?(A=l.code,l.code===p.ExtensionManagementErrorCode.Signature&&(x=l.message)):A=p.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:o,success:!l,duration:a,errorcode:A,errorcodeDetail:x,durationSinceUpdate:h})}e.reportTelemetry=t;class s{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(n=>new Promise((r,o)=>{const a=n.onCancellationRequested(()=>{a.dispose(),o(new C.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=s}),define(J[40],Z([0,1,5,15,2,4,34,11,26,28,13,10,6,21,27,3,7,25]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var y;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(y=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class E extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=E,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let S=class extends I.Disposable{constructor(i,n,r,o,a,l){super(),this.extensionsLocation=i,this.fileService=n,this.userDataProfilesService=r,this.uriIdentityService=o,this.telemetryService=a,this.logService=l,this._onAddExtensions=this._register(new C.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new C.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new C.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new C.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(i,n){return this.withProfileExtensions(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],o=[];try{return await this.withProfileExtensions(n,a=>{const l=[];for(const h of a)i.some(([A])=>(0,g.areSameExtensions)(A.identifier,h.identifier)&&A.manifest.version!==h.version)?r.push(h):l.push(h);for(const[h,A]of i)if(!l.some(x=>(0,g.areSameExtensions)(x.identifier,h.identifier)&&x.version===h.manifest.version)){const x={identifier:h.identifier,version:h.manifest.version,location:h.location,metadata:A};o.push(x),l.push(x)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:n}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),l}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n}),o}catch(a){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:a,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:a,profileLocation:n}),a}}async updateMetadata(i,n){const r=[];return await this.withProfileExtensions(n,o=>{const a=[];for(const l of o){const h=i.find(([A])=>(0,g.areSameExtensions)(A.identifier,l.identifier)&&A.manifest.version===l.version);h&&(l.metadata={...l.metadata,...h[1]},r.push(l)),a.push(l)}return a}),r}async removeExtensionFromProfile(i,n){const r=[];this._onRemoveExtensions.fire({extensions:r,profileLocation:n});try{await this.withProfileExtensions(n,o=>{const a=[];for(const l of o)(0,g.areSameExtensions)(l.identifier,i.identifier)?r.push(l):a.push(l);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),a}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:o,profileLocation:n}),o}}async withProfileExtensions(i,n,r){return this.getResourceAccessQueue(i).queue(async()=>{let o=[],a;try{const l=await this.fileService.readFile(i);a=JSON.parse(l.value.toString())}catch(l){if((0,P.toFileOperationResult)(l)!==1)throw l;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&r?.bailOutWhenFileNotFound)throw new E((0,c.getErrorMessage)(l),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(i);let l=!1;for(const h of a){m(h)||this.reportAndThrowInvalidConentError(i);let A;if((0,T.isString)(h.relativeLocation))A=this.resolveExtensionLocation(h.relativeLocation);else if((0,T.isString)(h.location))A=this.resolveExtensionLocation(h.location),l=!0,h.relativeLocation=h.location,h.location=A.toJSON();else{A=w.URI.revive(h.location);const x=this.toRelativePath(A);x&&(l=!0,h.relativeLocation=x)}o.push({identifier:h.identifier,location:A,version:h.version,metadata:h.metadata})}l&&await this.fileService.writeFile(i,D.VSBuffer.fromString(JSON.stringify(a)))}if(n){o=n(o);const l=o.map(h=>({identifier:h.identifier,version:h.version,location:h.location.toJSON(),relativeLocation:this.toRelativePath(h.location),metadata:h.metadata}));await this.fileService.writeFile(i,D.VSBuffer.fromString(JSON.stringify(l)))}return o})}reportAndThrowInvalidConentError(i){const n=new E(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(i){return this.uriIdentityService.extUri.isEqualOrParent(i,this.extensionsLocation)?this.uriIdentityService.extUri.relativePath(this.extensionsLocation,i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json");let n;try{n=(await this.fileService.readFile(i)).value.toString()}catch(o){if((0,P.toFileOperationResult)(o)===1)return;throw o}this.logService.info("Migrating extensions from old default profile location",i.toString());let r;try{const o=JSON.parse(n);Array.isArray(o)&&o.every(a=>m(a))?r=o:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.logService.error(o)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(o){if((0,P.toFileOperationResult)(o)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw o}try{await this.fileService.del(i)}catch(o){(0,P.toFileOperationResult)(o)!==1&&this.logService.error(o)}return r})()),this._migrationPromise}getResourceAccessQueue(i){let n=this.resourcesAccessQueueMap.get(i);return n||(n=new L.Queue,this.resourcesAccessQueueMap.set(i,n)),n}};S=fe([ee(1,P.IFileService),ee(2,b.IUserDataProfilesService),ee(3,v.IUriIdentityService),ee(4,f.ITelemetryService),ee(5,d.ILogService)],S),e.AbstractExtensionsProfileScannerService=S;function m(s){return(0,T.isObject)(s)&&(0,u.isIExtensionIdentifier)(s.identifier)&&(t(s.location)||(0,T.isString)(s.location))&&((0,T.isUndefined)(s.relativeLocation)||(0,T.isString)(s.relativeLocation))&&s.version&&(0,T.isString)(s.version)}function t(s){return s?(0,T.isString)(s.path)&&(0,T.isString)(s.scheme):!1}}),define(J[47],Z([0,1,19,5,29,15,7,49,78,2,16,14,12,18,41,52,3,11,91,17,26,28,44,13,10,6,32,4,53,40,21,27,106,107]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f,y,E,S,m,t,s,i,n,r,o,a,l,h,A,x,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Q;(function(pe){function V(M,F){if(M===F)return!0;const j=Object.keys(M),z=new Set;for(const B of Object.keys(F))z.add(B);if(j.length!==z.size)return!1;for(const B of j){if(M[B]!==F[B])return!1;z.delete(B)}return z.size===0}pe.equals=V})(Q=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let te=class extends u.Disposable{constructor(V,M,F,j,z,B,X,N,k,O,U,W){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=M,this.extensionsControlLocation=F,this.cacheLocation=j,this.userDataProfilesService=z,this.extensionsProfileScannerService=B,this.fileService=X,this.logService=N,this.environmentService=k,this.productService=O,this.uriIdentityService=U,this.instantiationService=W,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,b.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ae,(0,b.joinPath)(this.cacheLocation,m.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ae,(0,b.joinPath)(this.cacheLocation,m.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ne,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,S.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,M,F){const[j,z]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(M)]),B=F?await this.scanExtensionsUnderDevelopment(V,[...j,...z]):[];return this.dedupExtensions(j,z,B,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const M=[];M.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),M.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[F,j]=await Promise.all(M);return this.applyScanOptions([...F,...j],0,V,!1)}async scanUserExtensions(V){const M=V.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",M);const F=this.uriIdentityService.extUri.isEqual(V.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.createExtensionScannerInput(M,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,F),z=V.useCache&&!j.devMode&&j.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let B;try{B=await z.scanExtensions(j)}catch(X){if(X instanceof l.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),B=await z.scanExtensions(j);else throw X}return B=await this.applyScanOptions(B,1,V,!0),this.logService.trace("Scanned user extensions:",B.length),B}async scanExtensionsUnderDevelopment(V,M){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(j=>j.scheme===P.Schemas.file).map(async j=>{const z=await this.createExtensionScannerInput(j,!1,1,!0,V.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(X=>(X.type=M.find(N=>(0,S.areSameExtensions)(N.identifier,X.identifier))?.type??X.type,this.extensionsScanner.validate(X,z)))}))).flat();return this.applyScanOptions(F,"development",V,!0)}return[]}async scanExistingExtension(V,M,F){const j=await this.createExtensionScannerInput(V,!1,M,!0,F.language,!0,void 0),z=await this.extensionsScanner.scanExtension(j);return!z||!F.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(V,M,F){const j=await this.createExtensionScannerInput(V,!1,M,!0,F.language,!0,void 0),z=await this.extensionsScanner.scanOneOrMultipleExtensions(j);return this.applyScanOptions(z,M,F,!0)}async scanMetadata(V){const M=(0,b.joinPath)(V,"package.json"),F=(await this.fileService.readFile(M)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(V,M){const F=(0,b.joinPath)(V,"package.json"),j=(await this.fileService.readFile(F)).value.toString(),z=JSON.parse(j);M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,M.installedTimestamp=M.installedTimestamp||void 0,z.__metadata={...z.__metadata,...M},await this.fileService.writeFile((0,b.joinPath)(V,"package.json"),C.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof l.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw V}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.extensionsProfileScannerService.addExtensionsToProfile(V.map(M=>[M,M.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify([])))}catch(M){(0,s.toFileOperationResult)(M)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(M))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.logService.error(V)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(V,M,F,j){return F.includeAllVersions||(V=this.dedupExtensions(M===0?V:void 0,M===1?V:void 0,M==="development"?V:void 0,await this.getTargetPlatform(),j)),F.includeInvalid||(V=V.filter(z=>z.isValid)),V.sort((z,B)=>{const X=p.basename(z.location.fsPath),N=p.basename(B.location.fsPath);return X<N?-1:X>N?1:0})}dedupExtensions(V,M,F,j,z){const B=(N,k,O)=>{if(N.isValid&&!k.isValid)return!1;if(N.isValid===k.isValid){if(z&&v.gt(N.manifest.version,k.manifest.version))return this.logService.debug(`Skipping extension ${k.location.path} with lower version ${k.manifest.version} in favour of ${N.location.path} with version ${N.manifest.version}`),!1;if(v.eq(N.manifest.version,k.manifest.version)){if(N.type===0)return this.logService.debug(`Skipping extension ${k.location.path} in favour of system extension ${N.location.path} with same version`),!1;if(N.targetPlatform===j)return this.logService.debug(`Skipping extension ${k.location.path} from different target platform ${k.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${N.location.path} with ${k.location.path}.`):this.logService.debug(`Overwriting user extension ${N.location.path} with ${k.location.path}.`),!0},X=new Map;return V?.forEach(N=>{const k=m.ExtensionIdentifier.toKey(N.identifier.id),O=X.get(k);(!O||B(O,N,!1))&&X.set(k,N)}),M?.forEach(N=>{const k=m.ExtensionIdentifier.toKey(N.identifier.id),O=X.get(k);if(!O&&V&&N.type===0){this.logService.debug(`Skipping obsolete system extension ${N.location.path}.`);return}(!O||B(O,N,!1))&&X.set(k,N)}),F?.forEach(N=>{const k=m.ExtensionIdentifier.toKey(N.identifier.id),O=X.get(k);(!O||B(O,N,!0))&&X.set(k,N),X.set(k,N)}),[...X.values()]}async scanDefaultSystemExtensions(V,M){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,M,!0,void 0),z=await(V&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(V,M){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const j=M?await this.getBuiltInExtensionControl():{},z=[],B=f.URI.file(p.normalize(p.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const N of F){const k=j[N.name]||"marketplace";switch(k){case"disabled":break;case"marketplace":z.push((0,b.joinPath)(B,N.name));break;default:z.push(f.URI.file(k));break}}const X=await Promise.all(z.map(async N=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(N,!1,0,!0,V,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",X.length),(0,L.coalesce)(X)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,M,F,j,z,B,X){const N=await this.getTranslations(z??d.language),k=await this.getMtime(V),O=M&&!this.uriIdentityService.extUri.isEqual(V,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,U=O?await this.getMtime(O):void 0;return new ie(V,k,O,U,M,X,F,j,B,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,N)}async getMtime(V){try{const M=await this.fileService.stat(V);if(typeof M.mtime=="number")return M.mtime}catch{}}};te=fe([ee(4,h.IUserDataProfilesService),ee(5,l.IExtensionsProfileScannerService),ee(6,s.IFileService),ee(7,n.ILogService),ee(8,E.IEnvironmentService),ee(9,r.IProductService),ee(10,A.IUriIdentityService),ee(11,i.IInstantiationService)],te),e.AbstractExtensionsScannerService=te;class ie{constructor(V,M,F,j,z,B,X,N,k,O,U,W,G,H,re){this.location=V,this.mtime=M,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=j,this.profile=z,this.profileScanOptions=B,this.type=X,this.excludeObsolete=N,this.validate=k,this.productVersion=O,this.productDate=U,this.productCommit=W,this.devMode=G,this.language=H,this.translations=re}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,M){return(0,b.isEqual)(V.location,M.location)&&V.mtime===M.mtime&&(0,b.isEqual)(V.applicationExtensionslocation,M.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===M.applicationExtensionslocationMtime&&V.profile===M.profile&&I.equals(V.profileScanOptions,M.profileScanOptions)&&V.type===M.type&&V.excludeObsolete===M.excludeObsolete&&V.validate===M.validate&&V.productVersion===M.productVersion&&V.productDate===M.productDate&&V.productCommit===M.productCommit&&V.devMode===M.devMode&&V.language===M.language&&Q.equals(V.translations,M.translations)}}e.ExtensionScannerInput=ie;let ne=class extends u.Disposable{constructor(V,M,F,j,z){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=M,this.uriIdentityService=F,this.fileService=j,this.logService=z}async scanExtensions(V){const M=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let F={};if(V.excludeObsolete&&V.type===1)try{const j=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(j)}catch{}return(0,c.isEmptyObject)(F)?M:M.filter(j=>!F[S.ExtensionKey.create(j).toString()])}async scanExtensionsFromLocation(V){const M=await this.fileService.resolve(V.location);if(!M.children?.length)return[];const F=await Promise.all(M.children.map(async j=>{if(!j.isDirectory||V.type===1&&(0,b.basename)(j.resource).indexOf(".")===0)return null;const z=new ie(j.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(z)}));return(0,L.coalesce)(F).sort((j,z)=>j.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(V){let M=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){M=M.filter(j=>!j.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,j=>!!j.metadata?.isApplicationScoped,V);M.push(...F)}return M}async scanExtensionsFromProfileResource(V,M,F){const j=await this.extensionsProfileScannerService.scanProfileExtensions(V,F.profileScanOptions);if(!j.length)return[];const z=await Promise.all(j.map(async B=>{if(M(B)){const X=new ie(B.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(X,B.metadata)}return null}));return(0,L.coalesce)(z)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,b.joinPath)(V.location,"package.json"))){const M=await this.scanExtension(V);return M?[M]:[]}else return await this.scanExtensions(V)}catch(M){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,R.getErrorMessage)(M)),[]}}async scanExtension(V,M){try{let F=await this.scanExtensionManifest(V.location);if(F){F.publisher||(F.publisher=m.UNDEFINED_PUBLISHER),M=M??F.__metadata,delete F.__metadata;const j=(0,S.getGalleryExtensionId)(F.publisher,F.name),z=M?.id?{id:j,uuid:M.id}:{id:j},B=M?.isSystem?0:V.type,X=B===0||!!M?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(F),F=await this.translateManifest(V.location,F,ie.createNlsConfiguration(V));const N={type:B,identifier:z,manifest:F,location:V.location,isBuiltin:X,targetPlatform:M?.targetPlatform??"undefined",metadata:M,isValid:!0,validations:[]};return V.validate?this.validate(N,V):N}}catch(F){V.type!==0&&this.logService.error(F)}return null}validate(V,M){let F=!0;const j=(0,t.validateExtensionManifest)(M.productVersion,M.productDate,M.location,V.manifest,V.isBuiltin);for(const[z,B]of j)z===T.default.Error&&(F=!1,this.logService.error(this.formatMessage(M.location,B)));return V.isValid=F,V.validations=j,V}async scanExtensionManifest(V){const M=(0,b.joinPath)(V,"package.json");let F;try{F=(await this.fileService.readFile(M)).value.toString()}catch(z){return(0,s.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(V,(0,y.localize)(0,null,M.path,z.message))),null}let j;try{j=JSON.parse(F)}catch{const B=[];(0,w.parse)(F,B);for(const X of B)this.logService.error(this.formatMessage(V,(0,y.localize)(1,null,M.path,X.offset,X.length,(0,g.getParseErrorMessage)(X.error))));return null}return(0,w.getNodeType)(j)!=="object"?(this.logService.error(this.formatMessage(V,(0,y.localize)(2,null,M.path))),null):j}async translateManifest(V,M,F){const j=await this.getLocalizedMessages(V,M,F);if(j)try{const z=[],B=await this.resolveOriginalMessageBundle(j.default,z);if(z.length>0)return z.forEach(N=>{this.logService.error(this.formatMessage(V,(0,y.localize)(3,null,j.default?.path,(0,g.getParseErrorMessage)(N.error))))}),M;if((0,w.getNodeType)(j)!=="object")return this.logService.error(this.formatMessage(V,(0,y.localize)(4,null,j.default?.path))),M;const X=j.values||Object.create(null);return(0,x.localizeManifest)(M,X,B)}catch{}return M}async getLocalizedMessages(V,M,F){const j=(0,b.joinPath)(V,"package.nls.json"),z=(k,O)=>{O.forEach(U=>{this.logService.error(this.formatMessage(V,(0,y.localize)(5,null,k?.path,(0,g.getParseErrorMessage)(U.error))))})},B=k=>{this.logService.error(this.formatMessage(V,(0,y.localize)(6,null,k?.path)))},X=`${M.publisher}.${M.name}`,N=F.translations[X];if(N)try{const k=f.URI.file(N),O=(await this.fileService.readFile(k)).value.toString(),U=[],W=(0,w.parse)(O,U);return U.length>0?(z(k,U),{values:void 0,default:j}):(0,w.getNodeType)(W)!=="object"?(B(k),{values:void 0,default:j}):{values:W.contents?W.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.fileService.exists(j))return;let O;try{O=await this.findMessageBundles(V,F)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const U=(await this.fileService.readFile(O.localized)).value.toString(),W=[],G=(0,w.parse)(U,W);return W.length>0?(z(O.localized,W),{values:void 0,default:O.original}):(0,w.getNodeType)(G)!=="object"?(B(O.localized),{values:void 0,default:O.original}):{values:G,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(V,M){if(V)try{const F=(await this.fileService.readFile(V)).value.toString();return(0,w.parse)(F,M)}catch{}}findMessageBundles(V,M){return new Promise((F,j)=>{const z=B=>{const X=(0,b.joinPath)(V,`package.nls.${B}.json`);this.fileService.exists(X).then(N=>{N&&F({localized:X,original:(0,b.joinPath)(V,"package.nls.json")});const k=B.lastIndexOf("-");k===-1?F({localized:(0,b.joinPath)(V,"package.nls.json"),original:null}):(B=B.substring(0,k),z(B))})};if(M.devMode||M.pseudo||!M.language)return F({localized:(0,b.joinPath)(V,"package.nls.json"),original:null});z(M.language)})}formatMessage(V,M){return`[${V.path}]: ${M}`}};ne=fe([ee(1,l.IExtensionsProfileScannerService),ee(2,A.IUriIdentityService),ee(3,s.IFileService),ee(4,n.ILogService)],ne);let ae=class extends ne{constructor(V,M,F,j,z,B){super(M,F,j,z,B),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new D.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const M=await this.readExtensionCache();if(this.input=V,M&&M.input&&ie.equals(M.input,this.input))return this.logService.debug("Using cached extensions scan result",V.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),M.result.map(j=>(j.location=f.URI.revive(j.location),j));const F=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:F}),F}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),M=JSON.parse(V.value.toString());return{result:M.result,input:(0,a.revive)(M.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,R.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,C.VSBuffer.fromString(JSON.stringify(V)))}catch(M){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,R.getErrorMessage)(M))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const M=V.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!I.equals(F,M))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(j){this.logService.error(j)}}};ae=fe([ee(2,l.IExtensionsProfileScannerService),ee(3,A.IUriIdentityService),ee(4,s.IFileService),ee(5,n.ILogService)],ae);function ue(pe,V){const M=(0,S.getExtensionId)(pe.manifest.publisher,pe.manifest.name);return{id:M,identifier:new m.ExtensionIdentifier(M),isBuiltin:pe.type===0,isUserBuiltin:pe.type===1&&pe.isBuiltin,isUnderDevelopment:V,extensionLocation:pe.location,uuid:pe.identifier.uuid,targetPlatform:pe.targetPlatform,...pe.manifest}}e.toExtensionDescription=ue;class se extends te{constructor(V,M,F,j,z,B,X,N,k,O,U,W){super(V,M,(0,b.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,b.joinPath)(j,m.MANIFEST_CACHE_FOLDER),z,B,X,N,k,O,U,W),this.translationsPromise=(async()=>{if(d.translationsConfigFile)try{const G=await this.fileService.readFile(f.URI.file(d.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}e.NativeExtensionsScannerService=se}),define(J[146],Z([0,1,57,5,33,4,2,16,14,20,6,21]),function($,e,L,D,I,C,R,w,g,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends R.Disposable{constructor(v,T){super(),this.userDataProfilesService=v,this.logService=T,this.processesLimiter=new D.Limiter(5)}async postUninstall(v){const T=this.parseScript(v,"uninstall");return T&&(this.logService.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(T.script,"uninstall",T.args,!0,v).then(()=>this.logService.info(v.identifier.id,v.manifest.version,"Finished running post uninstall script"),c=>this.logService.error(v.identifier.id,v.manifest.version,`Failed to run post uninstall script: ${c}`)))),u.Promises.rm(this.getExtensionStoragePath(v)).then(void 0,c=>this.logService.error("Error while removing extension storage path",c))}parseScript(v,T){const c=`vscode:${T}`;if(v.location.scheme===w.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[c]=="string"){const f=v.manifest.scripts[c].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(v.identifier.id,v.manifest.version,`${c} should be a node script`),null):{script:(0,g.join)(v.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(v,T,c,f,y){return new Promise((E,S)=>{const m=this.start(v,T,c,y);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?S(i):E(void 0)};m.on("error",i=>{s((0,I.toErrorMessage)(i)||"Unknown")}),m.on("exit",(i,n)=>{s(i?`post-${T} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,m.kill(),S("timed out")},5e3))})}start(v,T,c,f){const y={silent:!0,execArgv:void 0},E=(0,L.fork)(v,[`--type=extension-post-${T}`,...c],y);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const S=C.Event.fromNodeEventEmitter(E.stdout,"data"),m=C.Event.fromNodeEventEmitter(E.stderr,"data");S(i=>this.logService.info(f.identifier.id,f.manifest.version,`post-${T}`,i)),m(i=>this.logService.error(f.identifier.id,f.manifest.version,`post-${T}`,i));const t=C.Event.any(C.Event.map(S,i=>({data:`%c${i}`,format:[""]})),C.Event.map(m,i=>({data:`%c${i}`,format:["color: red"]})));return C.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),E}getExtensionStoragePath(v){return(0,g.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};d=fe([ee(0,p.IUserDataProfilesService),ee(1,P.ILogService)],d),e.ExtensionsLifecycle=d}),define(J[147],Z([0,1,6,21,27,25,40,13,17,11]),function($,e,L,D,I,C,R,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends R.AbstractExtensionsProfileScannerService{constructor(d,b,v,T,c,f){super(u.URI.file(d.extensionsPath),b,v,T,c,f)}};P=fe([ee(0,g.INativeEnvironmentService),ee(1,w.IFileService),ee(2,D.IUserDataProfilesService),ee(3,I.IUriIdentityService),ee(4,C.ITelemetryService),ee(5,L.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(J[148],Z([0,1,11,17,40,47,13,10,6,32,27,21]),function($,e,L,D,I,C,R,w,g,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends C.NativeExtensionsScannerService{constructor(v,T,c,f,y,E,S,m){super(L.URI.file(y.builtinExtensionsPath),L.URI.file(y.extensionsPath),y.userHome,L.URI.file(y.userDataPath),v,T,c,f,y,E,S,m)}};d=fe([ee(0,p.IUserDataProfilesService),ee(1,I.IExtensionsProfileScannerService),ee(2,R.IFileService),ee(3,g.ILogService),ee(4,D.INativeEnvironmentService),ee(5,u.IProductService),ee(6,P.IUriIdentityService),ee(7,w.IInstantiationService)],d),e.ExtensionsScannerService=d}),define(J[149],Z([0,1,5,4,2,117,3,84,10,21]),function($,e,L,D,I,C,R,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var P;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(y){y[y.APPLICATION=-1]="APPLICATION",y[y.PROFILE=0]="PROFILE",y[y.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var d;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));function b(y){const E=y.get(e.TARGET_KEY);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}e.loadKeyTargets=b;class v extends I.Disposable{constructor(E={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super(),this.options=E,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,S){if(S===e.TARGET_KEY){switch(E){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:E})}else this._onDidChangeValue.fire({scope:E,key:S,target:this.getKeyTargets(E)[S]})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,S,m){return this.getStorage(S)?.get(E,m)}getBoolean(E,S,m){return this.getStorage(S)?.getBoolean(E,m)}getNumber(E,S,m){return this.getStorage(S)?.getNumber(E,m)}store(E,S,m,t){if((0,R.isUndefinedOrNull)(S)){this.remove(E,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(E,m,t),this.getStorage(m)?.set(E,S)})}remove(E,S){this.withPausedEmitters(()=>{this.updateKeyTarget(E,S,void 0),this.getStorage(S)?.delete(E)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,S){const m=[],t=this.getKeyTargets(E);for(const s of Object.keys(t))t[s]===S&&m.push(s);return m}updateKeyTarget(E,S,m){const t=this.getKeyTargets(S);typeof m=="number"?t[E]!==m&&(t[E]=m,this.getStorage(S)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[E]=="number"&&(delete t[E],this.getStorage(S)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(E){switch(E){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(E){const S=this.getStorage(E);return S?b(S):Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=P.NONE){this._onWillSaveState.fire({reason:E});const S=this.getStorage(-1),m=this.getStorage(0),t=this.getStorage(1);switch(E){case P.NONE:await L.Promises.settled([S?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([S?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.getStorage(-1)?.items??new Map,S=this.getStorage(0)?.items??new Map,m=this.getStorage(1)?.items??new Map;return f(E,S,m,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(E,S){return this.emitWillSaveState(P.NONE),(0,u.isUserDataProfile)(E)?this.switchToProfile(E,S):this.switchToWorkspace(E,S)}canSwitchProfile(E,S){return!(E.id===S.id||T(S)&&T(E))}switchData(E,S,m,t){this.withPausedEmitters(()=>{if(t)for(const[s,i]of E)S.set(s,i);else{const s=new Set;for(const[i,n]of E)s.add(i),S.get(i)!==n&&this.emitDidChangeValue(m,i);for(const[i]of S.items)s.has(i)||this.emitDidChangeValue(m,i)}})}}v.DEFAULT_FLUSH_INTERVAL=60*1e3,e.AbstractStorageService=v;function T(y){return y.isDefault||!!y.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=T;class c extends v{constructor(){super(),this.applicationStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(1,E))),this._register(this.profileStorage.onDidChangeStorage(E=>this.emitDidChangeValue(0,E))),this._register(this.applicationStorage.onDidChangeStorage(E=>this.emitDidChangeValue(-1,E)))}getStorage(E){switch(E){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(E){switch(E){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(E){return!1}}e.InMemoryStorageService=c;async function f(y,E,S,m,t,s){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},n=new Map,r=new Map;y.forEach((Y,Q)=>{n.set(Q,Y),r.set(Q,i(Y))});const o=new Map,a=new Map;E.forEach((Y,Q)=>{o.set(Q,Y),a.set(Q,i(Y))});const l=new Map,h=new Map;S.forEach((Y,Q)=>{l.set(Q,Y),h.set(Q,i(Y))}),console.group(m!==t?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const A=[];if(n.forEach((Y,Q)=>{A.push({key:Q,value:Y})}),console.table(A),console.groupEnd(),console.log(r),m!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];o.forEach((Q,te)=>{Y.push({key:te,value:Q})}),console.table(Y),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${s})`);const x=[];l.forEach((Y,Q)=>{x.push({key:Q,value:Y})}),console.table(x),console.groupEnd(),console.log(h)}e.logStorage=f}),define(J[150],Z([0,1,19,22,7,12,37,3,11,23,17,24,26,44,13,6,32,46,135,149,25]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f,y,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const m=C.isWeb?"web":(0,p.getTargetPlatform)(C.platform,R.arch),t="X-Market-Search-Activity-Id";var s;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...k){return String(k.reduce((O,U)=>O|U,0))}var n;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class h{constructor(O=l){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(O,U=this.state.pageSize){return new h({...this.state,pageNumber:O,pageSize:U})}withFilter(O,...U){const W=[...this.state.criteria,...U.length?U.map(G=>({filterType:O,value:G})):[{filterType:O}]];return new h({...this.state,criteria:W})}withSortBy(O){return new h({...this.state,sortBy:O})}withSortOrder(O){return new h({...this.state,sortOrder:O})}withFlags(...O){return new h({...this.state,flags:O.reduce((U,W)=>U|W,0)})}withAssetTypes(...O){return new h({...this.state,assetTypes:O})}withSource(O){return new h({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:U,pageSize:W,sortBy:G,sortOrder:H,flags:re,assetTypes:ce}=this.state;return{filters:[{criteria:O,pageNumber:U,pageSize:W,sortBy:G,sortOrder:H}],assetTypes:ce,flags:re}}get searchText(){const O=this.state.criteria.filter(U=>U.filterType===n.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function A(k,O){const U=(k||[]).filter(W=>W.statisticName===O)[0];return U?U.value:0}function x(k){const O="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(W=>W.assetType.indexOf(O)===0).reduce((W,G)=>{const H=te(k,G.assetType);return H&&W.push([G.assetType.substring(O.length),H]),W},[])}function Y(k){if(k.properties){const O=k.properties.filter(G=>G.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=O.filter(G=>U.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return te(k,r.Repository)}function Q(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function te(k,O){return k.files.filter(W=>W.assetType===O)[0]?{uri:`${k.assetUri}/${O}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${O}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function ie(k,O){const U=k.properties?k.properties.filter(G=>G.key===O):[],W=U.length>0&&U[0].value;return W?W.split(",").map(G=>(0,d.adoptToGalleryExtensionId)(G)):[]}function ne(k){const O=k.properties?k.properties.filter(U=>U.key===o.Engine):[];return O.length>0&&O[0].value||""}function ae(k){const O=k.properties?k.properties.filter(U=>U.key===o.PreRelease):[];return O.length>0&&O[0].value==="true"}function ue(k){const O=k.properties?k.properties.filter(W=>W.key===o.LocalizedLanguages):[],U=O.length>0&&O[0].value||"";return U?U.split(","):[]}function se(k){return k.properties?.find(O=>O.key===o.SponsorLink)?.value}function pe(k){return k.indexOf("preview")!==-1}function V(k){return k.targetPlatform?(0,p.toTargetPlatform)(k.targetPlatform):"undefined"}function M(k){const O=(0,L.distinct)(k.versions.map(V)),U=!!k.tags?.includes(p.WEB_EXTENSION_TAG),W=O.indexOf("web");return U?W===-1&&O.push("web"):W!==-1&&O.splice(W,1),O}function F(k,O){const U=(0,p.getFallbackTargetPlarforms)(O);for(let W=0;W<k.length;W++){const G=k[W];if(G.version===k[W-1]?.version){let H=W;const re=V(G);if(re===O)for(;H>0&&k[H-1].version===G.version;)H--;else if(U.includes(re))for(;H>0&&k[H-1].version===G.version&&V(k[H-1])!==O;)H--;H!==W&&(k.splice(W,1),k.splice(H,0,G))}}return k}e.sortExtensionVersions=F;function j(k,O,U){k.telemetryData={index:O,querySource:U,queryActivityId:k.queryContext?.[t]}}function z(k,O,U,W){const G=k.versions[0],H={manifest:te(O,r.Manifest),readme:te(O,r.Details),changelog:te(O,r.Changelog),license:te(O,r.License),repository:Y(O),download:Q(O),icon:te(O,r.Icon),signature:te(O,r.Signature),coreTranslations:x(O)};return{identifier:{id:(0,d.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:O.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:se(G),description:k.shortDescription||"",installCount:A(k.statistics,"install"),rating:A(k.statistics,"averagerating"),ratingCount:A(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:U,assets:H,properties:{dependencies:ie(O,o.Dependency),extensionPack:ie(O,o.ExtensionPack),engine:ne(O),localizedLanguages:ue(O),targetPlatform:V(O),isPreReleaseVersion:ae(O)},hasPreReleaseVersion:ae(G),hasReleaseVersion:!0,preview:pe(k.flags),isSigned:!!H.signature,queryContext:W}}let B=class{constructor(O,U,W,G,H,re,ce,Ee){this.requestService=U,this.logService=W,this.environmentService=G,this.telemetryService=H,this.fileService=re,this.productService=ce,this.configurationService=Ee;const me=ce.extensionsGallery,le=me?.servicePPEUrl&&Ee.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=le?me.servicePPEUrl:me?.serviceUrl,this.extensionsGallerySearchUrl=le?void 0:me?.searchUrl,this.extensionsControlUrl=me?.controlUrl,this.commonHeadersPromise=(0,y.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,U,W){const G=D.CancellationToken.isCancellationToken(U)?{}:U,H=D.CancellationToken.isCancellationToken(U)?U:W,re=[],ce=[],Ee=[],me=[];let le=!0;for(const oe of O){oe.uuid?ce.push(oe.uuid):re.push(oe.id);const Se=!!(oe.version||oe.preRelease);Ee.push({id:oe.id,uuid:oe.uuid,includePreRelease:Se}),oe.version&&me.push({id:oe.id,uuid:oe.uuid,version:oe.version}),le=le&&!!oe.hasPreRelease&&!Se}if(!ce.length&&!re.length)return[];let de=new h().withPage(1,O.length);ce.length&&(de=de.withFilter(n.ExtensionId,...ce)),re.length&&(de=de.withFilter(n.ExtensionName,...re)),(G.queryAllVersions||le)&&(de=de.withFlags(de.flags,s.IncludeVersions)),G.source&&(de=de.withSource(G.source));const{extensions:ge}=await this.queryGalleryExtensions(de,{targetPlatform:G.targetPlatform??m,includePreRelease:Ee,versions:me,compatible:!!G.compatible},H);return G.source&&ge.forEach((oe,Se)=>j(oe,Se,G.source)),ge}async getCompatibleExtension(O,U,W){if((0,p.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(O,U,W))return O;const G=new h().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,O.identifier.uuid),{extensions:H}=await this.queryGalleryExtensions(G,{targetPlatform:W,compatible:!0,includePreRelease:U},D.CancellationToken.None);return H[0]||null}async isExtensionCompatible(O,U,W){if(!(0,p.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,W)||!U&&O.properties.isPreReleaseVersion)return!1;let G=O.properties.engine;if(!G){const H=await this.getManifest(O,D.CancellationToken.None);if(!H)throw new Error("Manifest was not found");G=H.engines.vscode}return(0,b.isEngineValid)(G,this.productService.version,this.productService.date)}async isValidVersion(O,U,W,G,H){if(!(0,p.isTargetPlatformCompatible)(V(O),G,H)||U!=="any"&&ae(O)!==(U==="prerelease"))return!1;if(W)try{const re=await this.getEngine(O);if(!(0,b.isEngineValid)(re,this.productService.version,this.productService.date))return!1}catch(re){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,I.getErrorMessage)(re)),!1}return!0}async query(O,U){let W=O.text||"";const G=O.pageSize??50;let H=new h().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,de,ge)=>(H=H.withFilter(n.Category,ge||de),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,de,ge)=>(H=H.withFilter(n.Tag,ge||de),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),H=H.withFilter(n.SearchText,W)),H=H.withSortBy(0)):O.ids?H=H.withFilter(n.ExtensionId,...O.ids):O.names?H=H.withFilter(n.ExtensionName,...O.names):H=H.withSortBy(4),typeof O.sortBy=="number"&&(H=H.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(H=H.withSortOrder(O.sortOrder)),O.source&&(H=H.withSource(O.source));const re=async(le,de)=>{const{extensions:ge,total:oe}=await this.queryGalleryExtensions(le,{targetPlatform:m,compatible:!1,includePreRelease:!!O.includePreRelease},de);return ge.forEach((Se,we)=>j(Se,(le.pageNumber-1)*le.pageSize+we,O.source)),{extensions:ge,total:oe}},{extensions:ce,total:Ee}=await re(H,U),me=async(le,de)=>{if(de.isCancellationRequested)throw new I.CancellationError;const{extensions:ge}=await re(H.withPage(le+1),de);return ge};return{firstPage:ce,total:Ee,pageSize:H.pageSize,getPage:me}}async queryGalleryExtensions(O,U,W){const G=O.flags;!!(O.flags&s.IncludeLatestVersionOnly)&&!!(O.flags&s.IncludeVersions)&&(O=O.withFlags(O.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(O.flags&s.IncludeLatestVersionOnly)&&!(O.flags&s.IncludeVersions)&&(O=O.withFlags(O.flags,s.IncludeLatestVersionOnly)),U.versions?.length&&(O=O.withFlags(O.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),O=O.withFlags(O.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:H,total:re,context:ce}=await this.queryRawGalleryExtensions(O,W);if(!(O.flags&s.IncludeLatestVersionOnly)){const de=[];for(const ge of H){const oe=await this.toGalleryExtensionWithCriteria(ge,U,ce);oe&&de.push(oe)}return{extensions:de,total:re}}const me=[],le=new Map;for(let de=0;de<H.length;de++){const ge=H[de],oe={id:(0,d.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},Se=(0,w.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Te=>(0,d.areSameExtensions)(Te,oe))?.includePreRelease;if(U.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(M(ge),U.targetPlatform))continue;const we=await this.toGalleryExtensionWithCriteria(ge,U,ce);!we||we.properties.isPreReleaseVersion&&(!Se||!we.hasReleaseVersion)||!we.properties.isPreReleaseVersion&&we.properties.targetPlatform!==U.targetPlatform&&we.hasPreReleaseVersion?le.set(ge.extensionId,de):me.push([de,we])}if(le.size){const de=new Date().getTime(),ge=new h().withFlags(G&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,le.size).withFilter(n.ExtensionId,...le.keys()),{extensions:oe}=await this.queryGalleryExtensions(ge,U,W);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:le.size});for(const Se of oe){const we=le.get(Se.identifier.uuid);me.push([we,Se])}}return{extensions:me.sort((de,ge)=>de[0]-ge[0]).map(([,de])=>de),total:re}}async toGalleryExtensionWithCriteria(O,U,W){const G={id:(0,d.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},H=U.versions?.find(me=>(0,d.areSameExtensions)(me,G))?.version,re=(0,w.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(me=>(0,d.areSameExtensions)(me,G))?.includePreRelease,ce=M(O),Ee=F(O.versions,U.targetPlatform);if(U.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(ce,U.targetPlatform))return null;for(let me=0;me<Ee.length;me++){const le=Ee[me];if(!(H&&le.version!==H)){if(await this.isValidVersion(le,re?"any":"release",U.compatible,ce,U.targetPlatform))return z(O,le,ce,W);if(H&&le.version===H)return null}}return H||U.compatible?null:z(O,O.versions[0],ce)}async queryRawGalleryExtensions(O,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const W=await this.commonHeadersPromise,G=JSON.stringify(O.raw),H={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},re=new Date().getTime();let ce,Ee,me=0;try{if(ce=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&O.criteria.some(de=>de.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:G,headers:H},U),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:me};const le=await(0,f.asJson)(ce);if(le){const de=le.results[0],ge=de.extensions,oe=de.resultMetadata&&de.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return me=oe&&oe.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:me,context:{[t]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(le){throw Ee=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-re,success:!!ce&&(0,f.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:Ee?(0,I.isCancellationError)(Ee)?"canceled":(0,I.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(O,U,W,G){if(!this.isEnabled())return;const H=C.isWeb?this.api(`/itemName/${O}.${U}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${U}/${W}/stats?statType=${G}`),re=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.commonHeadersPromise,Accept:re};try{await this.requestService.request({type:"POST",url:H,headers:Ee},D.CancellationToken.None)}catch{}}async download(O,U,W){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const G=(0,d.getGalleryExtensionTelemetryData)(O),H=new Date().getTime(),re=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...G,duration:de}),ce=W===2?"install":W===3?"update":"",Ee=ce?{uri:`${O.assets.download.uri}${g.URI.parse(O.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${O.assets.download.fallbackUri}${g.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:O.assets.download,me=O.queryContext?.[t]?{[t]:O.queryContext[t]}:void 0,le=await this.getAsset(Ee,me?{headers:me}:void 0);await this.fileService.writeFile(U,le.stream),re(new Date().getTime()-H)}async downloadSignatureArchive(O,U){if(!O.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",O.identifier.id);const W=await this.getAsset(O.assets.signature);await this.fileService.writeFile(U,W.stream)}async getReadme(O,U){if(O.assets.readme){const W=await this.getAsset(O.assets.readme,{},U);return await(0,f.asTextOrError)(W)||""}return""}async getManifest(O,U){if(O.assets.manifest){const W=await this.getAsset(O.assets.manifest,{},U),G=await(0,f.asTextOrError)(W);return G?JSON.parse(G):null}return null}async getManifestFromRawExtensionVersion(O,U){const W=te(O,r.Manifest);if(!W)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},H=await this.getAsset(W,{headers:G});return await(0,f.asJson)(H)}async getCoreTranslation(O,U){const W=O.assets.coreTranslations.filter(G=>G[0]===U.toUpperCase())[0];if(W){const G=await this.getAsset(W[1]),H=await(0,f.asTextOrError)(G);return H?JSON.parse(H):null}return null}async getChangelog(O,U){if(O.assets.changelog){const W=await this.getAsset(O.assets.changelog,{},U);return await(0,f.asTextOrError)(W)||""}return""}async getAllCompatibleVersions(O,U,W){let G=new h().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?G=G.withFilter(n.ExtensionId,O.identifier.uuid):G=G.withFilter(n.ExtensionName,O.identifier.id);const{galleryExtensions:H}=await this.queryRawGalleryExtensions(G,D.CancellationToken.None);if(!H.length)return[];const re=M(H[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(re,W))return[];const ce=[];await Promise.all(H[0].versions.map(async le=>{try{await this.isValidVersion(le,U?"any":"release",!0,re,W)&&ce.push(le)}catch{}}));const Ee=[],me=new Set;for(const le of F(ce,W))me.has(le.version)||(me.add(le.version),Ee.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:ae(le)}));return Ee}async getAsset(O,U={},W=D.CancellationToken.None){const G=await this.commonHeadersPromise,H={type:"GET"},re={...G,...U.headers||{}};U={...U,...H,headers:re};const ce=O.uri,Ee=O.fallbackUri,me={...U,url:ce};try{const le=await this.requestService.request(me,W);if(le.res.statusCode===200)return le;const de=await(0,f.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${de}`)}catch(le){if((0,I.isCancellationError)(le))throw le;const de=(0,I.getErrorMessage)(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:de});const ge={...U,url:Ee};return this.requestService.request(ge,W)}}async getEngine(O){let U=ne(O);if(!U){const W=await this.getManifestFromRawExtensionVersion(O,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");U=W.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.asJson)(O),W=[],G={};if(U){for(const H of U.malicious)W.push({id:H});if(U.migrateToPreRelease)for(const[H,re]of Object.entries(U.migrateToPreRelease))(!re.engine||(0,b.isEngineValid)(re.engine,this.productService.version,this.productService.date))&&(G[H.toLowerCase()]={disallowInstall:!0,extension:{id:re.id,displayName:re.displayName,autoMigrate:{storage:!!re.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[H,re]of Object.entries(U.deprecated))re&&(G[H.toLowerCase()]=(0,w.isBoolean)(re)?{}:re)}return{malicious:W,deprecated:G}}};B=fe([ee(1,f.IRequestService),ee(2,T.ILogService),ee(3,P.IEnvironmentService),ee(4,S.ITelemetryService),ee(5,v.IFileService),ee(6,c.IProductService),ee(7,u.IConfigurationService)],B);let X=class extends B{constructor(O,U,W,G,H,re,ce,Ee){super(O,U,W,G,H,re,ce,Ee)}};X=fe([ee(0,E.IStorageService),ee(1,f.IRequestService),ee(2,T.ILogService),ee(3,P.IEnvironmentService),ee(4,S.ITelemetryService),ee(5,v.IFileService),ee(6,c.IProductService),ee(7,u.IConfigurationService)],X),e.ExtensionGalleryService=X;let N=class extends B{constructor(O,U,W,G,H,re,ce){super(void 0,O,U,W,G,H,re,ce)}};N=fe([ee(0,f.IRequestService),ee(1,T.ILogService),ee(2,P.IEnvironmentService),ee(3,S.ITelemetryService),ee(4,v.IFileService),ee(5,c.IProductService),ee(6,u.IConfigurationService)],N),e.ExtensionGalleryServiceWithNoStorageService=N}),define(J[151],Z([0,1,3,11,17,13,6,67,27,21]),function($,e,L,D,I,C,R,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let P=class extends u.UserDataProfilesService{constructor(b,v,T,c){super(v,T,b,c),this.nativeEnvironmentService=v}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(D.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};P=fe([ee(0,g.IUriIdentityService),ee(1,I.INativeEnvironmentService),ee(2,C.IFileService),ee(3,R.ILogService)],P),e.ServerUserDataProfilesService=P;let p=class We extends P{constructor(b,v,T,c,f){super(v,T,c,f),this.stateService=b}getStoredProfiles(){return this.stateService.getItem(We.PROFILES_KEY,[]).map(v=>({...v,location:(0,L.isString)(v.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,v.location):D.URI.revive(v.location)}))}getStoredProfileAssociations(){const b=this.stateService.getItem(We.PROFILE_ASSOCIATIONS_KEY,{});return this.stateService.getItem(We.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?b:this.migrateStoredProfileAssociations(b)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(D.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",p=fe([ee(0,w.IStateService),ee(1,g.IUriIdentityService),ee(2,I.INativeEnvironmentService),ee(3,C.IFileService),ee(4,R.ILogService)],p),e.UserDataProfilesService=p}),define(J[152],Z([0,1,38,5,165,2,6]),function($,e,L,D,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let w=class extends L.AbstractPolicyService{constructor(u,P){super(),this.logService=u,this.productName=P,this.throttler=new D.Throttler,this.watcher=this._register(new C.MutableDisposable)}async _updatePolicyDefinitions(u){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.throttler.queue(()=>new Promise((P,p)=>{try{this.watcher.value=(0,I.createWatcher)(this.productName,u,d=>{this._onDidPolicyChange(d),P()})}catch(d){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),p(d)}}))}_onDidPolicyChange(u){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const P in u){const p=u[P];p===void 0?this.policies.delete(P):this.policies.set(P,p)}this._onDidChange.fire(Object.keys(u))}};w=fe([ee(0,R.ILogService)],w),e.NativePolicyService=w}),define(J[69],Z([0,1,119,5,14,3,20,85,166,167]),function($,e,L,D,I,C,R,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(t,s){let i=s.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=s}}e.ExtractError=P;function p(m){const t=m.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,i)=>s+i,t&61440)}function d(m){if(m instanceof P)return m;let t;return/end of central directory record signature not found/.test(m.message)&&(t="CorruptZip"),new P(t,m)}function b(m,t,s,i,n,r){const o=I.dirname(t),a=I.join(i,o);if(!a.startsWith(i))return Promise.reject(new Error(w.localize(0,null,t)));const l=I.join(i,t);let h;return r.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(R.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,x)=>{if(!r.isCancellationRequested)try{h=(0,L.createWriteStream)(l,{mode:s}),h.once("close",()=>A()),h.once("error",x),m.once("error",x),m.pipe(h)}catch(Y){x(Y)}}))}function v(m,t,s,i){let n=(0,D.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),m.close()}),new Promise((o,a)=>{const l=new D.Sequencer,h=A=>{A.isCancellationRequested||(r++,m.readEntry())};m.once("error",a),m.once("close",()=>n.then(()=>{i.isCancellationRequested||m.entryCount===r?o():a(new P("Incomplete",new Error(w.localize(1,null,r,m.entryCount))))},a)),m.readEntry(),m.on("entry",A=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){h(i);return}const x=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(x)){const te=I.join(t,x);n=(0,D.createCancelablePromise)(ie=>R.Promises.mkdir(te,{recursive:!0}).then(()=>h(ie)).then(void 0,a));return}const Y=c(m,A),Q=p(A);n=(0,D.createCancelablePromise)(te=>l.queue(()=>Y.then(ie=>b(ie,x,Q,t,s,te).then(()=>h(te)))).then(null,a))})})}function T(m,t=!1){return new Promise((s,i)=>{(0,g.open)(m,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):s((0,C.assertIsDefined)(r))})})}function c(m,t){return new Promise((s,i)=>{m.openReadStream(t,(n,r)=>{n?i(d(n)):s((0,C.assertIsDefined)(r))})})}function f(m,t){return new Promise((s,i)=>{const n=new u.ZipFile;t.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,L.createWriteStream)(m);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(m))})}e.zip=f;function y(m,t,s={},i){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=T(m,!0);return s.overwrite&&(r=r.then(o=>R.Promises.rm(t).then(()=>o))),r.then(o=>v(o,t,{sourcePathRegex:n},i))}e.extract=y;function E(m,t){return T(m).then(s=>new Promise((i,n)=>{s.on("entry",r=>{r.fileName===t&&c(s,r).then(o=>i(o),o=>n(o))}),s.once("close",()=>n(new Error(w.localize(2,null,t))))}))}function S(m,t){return E(m,t).then(s=>new Promise((i,n)=>{const r=[];s.once("error",n),s.on("data",o=>r.push(o)),s.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=S}),define(J[153],Z([0,1,69,93]),function($,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function I(C){return(0,L.buffer)(C,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.getManifest=I}),define(J[154],Z([0,1,5,22,33,7,4,2,34,16,14,12,18,41,3,11,30,20,69,92,58,17,145,24,26,40,47,133,146,153,126,134,28,44,13,10,6,32,25,27,21]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f,y,E,S,m,t,s,i,n,r,o,a,l,h,A,x,Y,Q,te,ie,ne,ae,ue,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,te.refineServiceDecorator)(s.IExtensionManagementService);let pe=class extends t.AbstractExtensionManagementService{constructor(N,k,O,U,W,G,H,re,ce,Ee,me,le){super(N,k,O,Ee,le),this.extensionsScannerService=W,this.extensionsProfileScannerService=G,this.downloadService=H,this.fileService=ce,this.uriIdentityService=me,this._onDidUpdateExtensionMetadata=this._register(new R.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new g.ResourceSet;const de=this._register(re.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(re.createInstance(V,oe=>de.postUninstall(oe))),this.manifestCache=this._register(new h.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(re.createInstance(o.ExtensionsDownloader));const ge=this._register(new A.ExtensionsWatcher(this,this.extensionsScannerService,le,G,me,ce,O));this._register(ge.onDidChangeExtensionsByAnotherSource(oe=>this.onDidChangeExtensionsFromAnotherSource(oe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(N){this.logService.trace("ExtensionManagementService#zip",N.identifier.id);const k=await this.collectFiles(N),O=await(0,y.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)()).fsPath,k);return T.URI.file(O)}async unzip(N){return this.logService.trace("ExtensionManagementService#unzip",N.toString()),(await this.install(N)).identifier}async getManifest(N){const{location:k,cleanup:O}=await this.downloadVsix(N),U=P.resolve(k.fsPath);try{return await(0,l.getManifest)(U)}finally{await O()}}getInstalled(N,k){return this.extensionsScanner.scanExtensions(N??null,k)}getAllUserInstalled(){return this.extensionsScanner.scanAllUserExtensions(!1)}async install(N,k={}){this.logService.trace("ExtensionManagementService#install",N.toString());const{location:O,cleanup:U}=await this.downloadVsix(N);try{const W=await(0,l.getManifest)(P.resolve(O.fsPath));if(W.engines&&W.engines.vscode&&!(0,Y.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(E.localize(0,null,(0,i.getGalleryExtensionId)(W.publisher,W.name),this.productService.version));return await this.installExtension(W,O,k)}finally{await U()}}async installFromLocation(N,k){this.logService.trace("ExtensionManagementService#installFromLocation",N.toString());const O=await this.extensionsScanner.scanUserExtensionAtLocation(N);if(!O)throw new Error(`Cannot find a valid extension from the location ${N.toString()}`);return await this.addExtensionsToProfile([O],k),this.logService.info("Successfully installed extension",O.identifier.id,k.toString()),O}getMetadata(N,k=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanMetadata(N,k)}async updateMetadata(N,k,O=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",N.identifier.id),k.isPreReleaseVersion&&(k.preRelease=!0),k.isMachineScoped=k.isMachineScoped||void 0,k.isBuiltin=k.isBuiltin||void 0,k.pinned=k.pinned||void 0,N=await this.extensionsScanner.updateMetadata(N,k,O),this.manifestCache.invalidate(),this._onDidUpdateExtensionMetadata.fire(N),N}async reinstallFromGallery(N){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",N.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const k=await this.getTargetPlatform(),[O]=await this.galleryService.getExtensions([{...N.identifier,preRelease:N.preRelease}],{targetPlatform:k,compatible:!0},D.CancellationToken.None);if(!O)throw new Error(E.localize(2,null));await this.extensionsScanner.setUninstalled(N);try{await this.extensionsScanner.removeUninstalledExtension(N)}catch(U){throw new Error(E.localize(3,null,(0,I.toErrorMessage)(U)))}return this.installFromGallery(O)}markAsUninstalled(...N){return this.extensionsScanner.setUninstalled(...N)}removeUninstalledExtensions(){return this.extensionsScanner.cleanUp()}async download(N,k){const{location:O}=await this.extensionsDownloader.download(N,k);return O}async downloadVsix(N){if(N.scheme===u.Schemas.file)return{location:N,async cleanup(){}};this.logService.trace("Downloading extension from",N.toString());const k=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)());return await this.downloadService.download(N,k),this.logService.info("Downloaded extension to",k.toString()),{location:k,cleanup:async()=>{try{await this.fileService.del(k)}catch(U){this.logService.error(U)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(N,k,O){let U;if(T.URI.isUri(k))U=new j(N,k,O,this.galleryService,this.extensionsScanner,this.logService);else{const W=i.ExtensionKey.create(k).toString();U=this.installGalleryExtensionsTasks.get(W),U||(this.installGalleryExtensionsTasks.set(W,U=new F(N,k,O,this.extensionsDownloader,this.extensionsScanner,this.logService)),U.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(W)))}return new z(U,O.profileLocation,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService)}createUninstallExtensionTask(N,k){return new B(N,k.profileLocation,this.extensionsProfileScannerService)}async collectFiles(N){const k=async U=>{let W=await f.Promises.readdir(U);W=W.map(re=>P.join(U,re));const G=await Promise.all(W.map(re=>f.Promises.stat(re)));let H=Promise.resolve([]);return G.forEach((re,ce)=>{const Ee=W[ce];re.isFile()&&(H=H.then(me=>[...me,Ee])),re.isDirectory()&&(H=H.then(me=>k(Ee).then(le=>[...me,...le])))}),H};return(await k(N.location.fsPath)).map(U=>({path:`extension/${P.relative(N.location.fsPath,U)}`,localPath:U}))}async onDidChangeExtensionsFromAnotherSource({added:N,removed:k}){if(k)for(const O of k.extensions)this.logService.info("Extensions removed from another source",O.id,k.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:O,profileLocation:k.profileLocation});if(N){const U=(await this.extensionsScanner.scanExtensions(1,N.profileLocation)).filter(W=>N.extensions.some(G=>(0,i.areSameExtensions)(G,W.identifier)));this._onDidInstallExtensions.fire(U.map(W=>(this.logService.info("Extensions added from another source",W.identifier.id,N.profileLocation.toString()),{identifier:W.identifier,local:W,profileLocation:N.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(k=>this.knownDirectories.add(k)));const N=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const k of N.children??[])k.isDirectory&&this.knownDirectories.add(k.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(k=>this.onDidFilesChange(k)))}async onDidFilesChange(N){if(!N.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const k=[];for(const O of N.rawAdded){if(this.knownDirectories.has(O)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(O),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(O,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(O).startsWith(".")||!(await this.fileService.stat(O)).isDirectory)continue;const U=await this.extensionsScanner.scanUserExtensionAtLocation(O);U&&U.installedTimestamp===void 0&&(this.knownDirectories.add(O),k.push(U))}k.length&&(await this.addExtensionsToProfile(k,this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",k.map(O=>O.identifier.id)))}async addExtensionsToProfile(N,k){await this.extensionsProfileScannerService.addExtensionsToProfile(N.map(O=>[O,void 0]),k),this._onDidInstallExtensions.fire(N.map(O=>({local:O,identifier:O.identifier,operation:1,profileLocation:k})))}};pe=fe([ee(0,s.IExtensionGalleryService),ee(1,ae.ITelemetryService),ee(2,ie.ILogService),ee(3,m.INativeEnvironmentService),ee(4,r.IExtensionsScannerService),ee(5,n.IExtensionsProfileScannerService),ee(6,S.IDownloadService),ee(7,te.IInstantiationService),ee(8,Q.IFileService),ee(9,ne.IProductService),ee(10,ue.IUriIdentityService),ee(11,se.IUserDataProfilesService)],pe),e.ExtensionManagementService=pe;let V=class extends w.Disposable{constructor(N,k,O,U,W){super(),this.beforeRemovingExtension=N,this.fileService=k,this.extensionsScannerService=O,this.extensionsProfileScannerService=U,this.logService=W,this._onExtract=this._register(new R.Emitter),this.onExtract=this._onExtract.event,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions()}async scanExtensions(N,k){const O={includeInvalid:!0,profileLocation:k};let U=[];return N===null||N===0?U.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O,!1)):N===1&&U.push(...await this.extensionsScannerService.scanUserExtensions(O)),U=N!==null?U.filter(W=>W.type===N):U,Promise.all(U.map(W=>this.toLocalExtension(W)))}async scanAllUserExtensions(N){const k=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!N,includeInvalid:!0});return Promise.all(k.map(O=>this.toLocalExtension(O)))}async scanUserExtensionAtLocation(N){try{const k=await this.extensionsScannerService.scanExistingExtension(N,1,{includeInvalid:!0});if(k)return await this.toLocalExtension(k)}catch(k){this.logService.error(k)}return null}async extractUserExtension(N,k,O,U){const W=N.toString(),G=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,c.generateUuid)()}`),H=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,W);try{await f.Promises.rm(H)}catch{throw new s.ExtensionManagementError(E.localize(4,null,H,N.id),s.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(N,k,G,U),await this.extensionsScannerService.updateMetadata(T.URI.file(G),O);try{this._onExtract.fire(T.URI.file(H)),await this.rename(N,G,H,Date.now()+2*60*1e3),this.logService.info("Renamed to",H)}catch(re){try{await f.Promises.rm(G)}catch{}if(re.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",N.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(re)}. Deleted from extracted location`,G),re}return this.scanLocalExtension(T.URI.file(H),1)}async scanMetadata(N,k){return k?(await this.extensionsProfileScannerService.scanProfileExtensions(k)).find(U=>(0,i.areSameExtensions)(U.identifier,N.identifier))?.metadata:this.extensionsScannerService.scanMetadata(N.location)}async updateMetadata(N,k,O){return O?await this.extensionsProfileScannerService.updateMetadata([[N,k]],O):await this.extensionsScannerService.updateMetadata(N.location,k),this.scanLocalExtension(N.location,N.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...N){const k=N.map(O=>i.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>k.forEach(U=>{O[U.toString()]=!0,this.logService.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(N){await this.withUninstalledExtensions(U=>delete U[N.toString()]);const O=(await this.scanAllUserExtensions(!0)).find(U=>i.ExtensionKey.create(U).equals(N))||null;return O?this.updateMetadata(O,{installedTimestamp:Date.now()}):null}async removeExtension(N,k){this.logService.trace(`Deleting ${k} extension from disk`,N.identifier.id,N.location.fsPath),await f.Promises.rm(N.location.fsPath),this.logService.info("Deleted from disk",N.identifier.id,N.location.fsPath)}async removeUninstalledExtension(N){await this.removeExtension(N,"uninstalled"),await this.withUninstalledExtensions(k=>delete k[i.ExtensionKey.create(N).toString()])}async withUninstalledExtensions(N){return this.uninstalledFileLimiter.queue(async()=>{let k;try{k=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let O={};if(k)try{O=JSON.parse(k)}catch{}return N&&(N(O),Object.keys(O).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await f.Promises.rm(this.uninstalledPath)),O})}async extractAtLocation(N,k,O,U){this.logService.trace(`Started extracting the extension from ${k} to ${O}`);try{await f.Promises.rm(O)}catch(W){throw new s.ExtensionManagementError(this.joinErrors(W).message,s.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(k,O,{sourcePath:"extension",overwrite:!0},U),this.logService.info(`Extracted extension to ${O}:`,N.id)}catch(W){try{await f.Promises.rm(O)}catch{}let G=s.ExtensionManagementErrorCode.Extract;throw W instanceof y.ExtractError&&(W.type==="CorruptZip"?G=s.ExtensionManagementErrorCode.CorruptZip:W.type==="Incomplete"&&(G=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(W.message,G)}}async rename(N,k,O,U){try{await f.Promises.rename(k,O)}catch(W){if(p.isWindows&&W&&W.code==="EPERM"&&Date.now()<U)return this.logService.info(`Failed renaming ${k} to ${O} with 'EPERM' error. Trying again...`,N.id),this.rename(N,k,O,U);throw new s.ExtensionManagementError(W.message||E.localize(5,null,k,O),W.code||s.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(N,k){const O=await this.extensionsScannerService.scanExistingExtension(N,k,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(E.localize(6,null,N.path))}async toLocalExtension(N){const k=await this.fileService.resolve(N.location);let O,U;return k.children&&(O=k.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,U=k.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource),{identifier:N.identifier,type:N.type,isBuiltin:N.isBuiltin||!!N.metadata?.isBuiltin,location:N.location,manifest:N.manifest,targetPlatform:N.targetPlatform,validations:N.validations,isValid:N.isValid,readmeUrl:O,changelogUrl:U,publisherDisplayName:N.metadata?.publisherDisplayName||null,publisherId:N.metadata?.publisherId||null,isApplicationScoped:!!N.metadata?.isApplicationScoped,isMachineScoped:!!N.metadata?.isMachineScoped,isPreReleaseVersion:!!N.metadata?.isPreReleaseVersion,preRelease:!!N.metadata?.preRelease,installedTimestamp:N.metadata?.installedTimestamp,updated:!!N.metadata?.updated,pinned:!!N.metadata?.pinned}}async removeUninstalledExtensions(){const N=await this.getUninstalledExtensions(),k=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const G of k)N[i.ExtensionKey.create(G).toString()]||O.add(G.identifier.id.toLowerCase());const U=(0,i.groupByExtension)(k,G=>G.identifier);await L.Promises.settled(U.map(async G=>{const H=G.sort((re,ce)=>b.rcompare(re.manifest.version,ce.manifest.version))[0];O.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}));const W=k.filter(G=>G.metadata&&N[i.ExtensionKey.create(G).toString()]);await L.Promises.settled(W.map(G=>this.removeUninstalledExtension(G)))}joinErrors(N){const k=Array.isArray(N)?N:[N];return k.length===1?k[0]instanceof Error?k[0]:new Error(k[0]):k.reduce((O,U)=>new Error(`${O.message}${O.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};V=fe([ee(1,Q.IFileService),ee(2,r.IExtensionsScannerService),ee(3,n.IExtensionsProfileScannerService),ee(4,ie.ILogService)],V),e.ExtensionsScanner=V;class M extends t.AbstractExtensionTask{get verificationStatus(){return this._verificationStatus}get operation(){return(0,v.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(N,k,O,U,W){super(),this.identifier=N,this.source=k,this.options=O,this.extensionsScanner=U,this.logService=W,this._verificationStatus="Unverified",this._operation=2}async installExtension(N,k){try{const O=await this.unsetUninstalledAndGetLocal(N.key);if(O)return this.extensionsScanner.updateMetadata(O,N.metadata)}catch{throw p.isMacintosh?new s.ExtensionManagementError(E.localize(7,null),s.ExtensionManagementErrorCode.Internal):new s.ExtensionManagementError(E.localize(8,null),s.ExtensionManagementErrorCode.Internal)}return this.extract(N,k)}async unsetUninstalledAndGetLocal(N){if(!await this.isUninstalled(N))return null;this.logService.trace("Removing the extension from uninstalled list:",N.id);const O=await this.extensionsScanner.setInstalled(N);return this.logService.info("Removed the extension from uninstalled list:",N.id),O}async isUninstalled(N){return!!(await this.extensionsScanner.getUninstalledExtensions())[N.toString()]}async extract({zipPath:N,key:k,metadata:O},U){const W=await this.extensionsScanner.extractUserExtension(k,N,O,U);return this.logService.info("Extracting completed.",k.id),W}}class F extends M{constructor(N,k,O,U,W,G){super(k.identifier,k,O,W,G),this.manifest=N,this.gallery=k,this.extensionsDownloader=U}async doRun(N){const O=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(H=>(0,i.areSameExtensions)(H.identifier,this.gallery.identifier));O&&(this._operation=3);const U={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,x.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,v.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(O,U),metadata:U};const{location:W,verificationStatus:G}=await this.extensionsDownloader.download(this.gallery,this._operation);try{return this._verificationStatus=G,this.validateManifest(W.fsPath),{local:await this.installExtension({zipPath:W.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:U},N),metadata:U}}catch(H){try{await this.extensionsDownloader.delete(W)}catch(re){this.logService.warn("Error while deleting the downloaded file",W.toString(),(0,C.getErrorMessage)(re))}throw H}}async validateManifest(N){try{await(0,l.getManifest)(N)}catch(k){throw new s.ExtensionManagementError((0,t.joinErrors)(k).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=F;class j extends M{constructor(N,k,O,U,W,G){super({id:(0,i.getGalleryExtensionId)(N.publisher,N.name)},k,O,W,G),this.manifest=N,this.location=k,this.galleryService=U}async doRun(N){const k=new i.ExtensionKey(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(H=>(0,i.areSameExtensions)(this.identifier,H.identifier)),W=await this.getMetadata(this.identifier.id,this.manifest.version,N);if(W.isApplicationScoped=(0,x.isApplicationScopedExtension)(this.manifest),W.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,W.isBuiltin=this.options.isBuiltin||U?.isBuiltin,W.installedTimestamp=Date.now(),W.pinned=this.options.installGivenVersion?!0:void 0,U)if(this._operation=3,k.equals(new i.ExtensionKey(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(E.localize(9,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&b.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const H=await this.unsetUninstalledAndGetLocal(k);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(E.localize(10,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:k,metadata:W},N),metadata:W}}async getMetadata(N,k,O){try{let[U]=await this.galleryService.getExtensions([{id:N,version:k}],O);if(U||([U]=await this.galleryService.getExtensions([{id:N}],O)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class z{get operation(){return this.task.operation}get verificationStatus(){return this.task.verificationStatus}constructor(N,k,O,U,W,G){this.task=N,this.profileLocation=k,this.uriIdentityService=O,this.userDataProfilesService=U,this.extensionsScannerService=W,this.extensionsProfileScannerService=G,this.identifier=this.task.identifier,this.source=this.task.source,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const N=await this.task.waitUntilTaskIsFinished();return this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[N.local,N.metadata]],this.profileLocation),N}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class B extends t.AbstractExtensionTask{constructor(N,k,O){super(),this.extension=N,this.profileLocation=k,this.extensionsProfileScannerService=O}async doRun(N){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(J[155],Z([0,1,129,5,15,7,2,3,23,17,130,6,128,168]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends R.Disposable{constructor(c,f,y){super(),this.configurationService=c,this.environmentService=f,this.logService=y,this.configure(),this._register(c.onDidChangeConfiguration(E=>{E.affectsConfiguration("http")&&this.configure()}))}configure(){const c=this.configurationService.getValue("http");this.proxyUrl=c?.proxy,this.strictSSL=!!c?.proxyStrictSSL,this.authorization=c?.proxyAuthorization}async request(c,f){this.logService.trace("RequestService#request (node) - begin",c.url);const{proxyUrl:y,strictSSL:E}=this;let S;try{S=await(0,P.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(s){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",s))}const m={...process.env,...S},t=c.agent?c.agent:await(0,d.getProxyAgent)(c.url||"",m,{proxyUrl:y,strictSSL:E});c.agent=t,c.strictSSL=E,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization});try{const s=await this._request(c,f);return this.logService.trace("RequestService#request (node) - success",c.url),s}catch(s){throw this.logService.trace("RequestService#request (node) - error",c.url,s),s}}async getNodeRequest(c){return((0,L.parse)(c.url).protocol==="https:"?await new Promise((E,S)=>{$(["https"],E,S)}):await new Promise((E,S)=>{$(["http"],E,S)})).request}_request(c,f){return D.Promises.withAsyncBody(async(y,E)=>{const S=(0,L.parse)(c.url),m=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),t={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,w.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(t.auth=c.user+":"+c.password);const s=m(t,i=>{const n=(0,w.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...c,url:i.headers.location,followRedirects:n-1},f).then(y,E);else{let r=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,b.createGunzip)())),y({res:i,stream:(0,I.streamToBufferReadableStream)(r)})}});s.on("error",E),c.timeout&&s.setTimeout(c.timeout),c.isChromiumNetwork&&s.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&s.write(c.data),s.end(),f.onCancellationRequested(()=>{s.abort(),E(new C.CancellationError)})})}async resolveProxy(c){}};v=fe([ee(0,g.IConfigurationService),ee(1,u.INativeEnvironmentService),ee(2,p.ILogService)],v),e.RequestService=v}),define(J[169],Z([0,1,36,5,15,33,7,2,16,14,12,37,11,20,23,125,58,127,17,105,150,24,59,132,40,47,154,148,13,116,118,45,114,62,63,136,6,121,122,38,152,139,32,46,155,67,131,68,25,138,39,140,141,27,143,21,151,142,147,120]),function($,e,L,D,I,C,R,w,g,u,P,p,d,b,v,T,c,f,y,E,S,m,t,s,i,n,r,o,a,l,h,A,x,Y,Q,te,ie,ne,ae,ue,se,pe,V,M,F,j,z,B,X,N,k,O,U,W,G,H,re,ce,Ee,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class le extends w.Disposable{constructor(oe){super(),this.argv=oe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[oe,Se]=await this.initServices();return oe.invokeFunction(async we=>{const Te=we.get(ie.ILogService),xe=we.get(a.IFileService),_=we.get(y.INativeEnvironmentService),q=we.get(H.IUserDataProfilesService);Te.info("CLI main",this.argv),this.registerErrorHandler(Te),await this.doRun(_,xe,q,oe),await Promise.all(Se.map(K=>{(0,D.raceTimeout)(K.flush(),1e3)}))})}async initServices(){const oe=new Y.ServiceCollection,Se={_serviceBrand:void 0,...pe.default};oe.set(V.IProductService,Se);const we=new E.NativeEnvironmentService(this.argv,Se);oe.set(y.INativeEnvironmentService,we),await Promise.all([we.appSettingsHome.fsPath,we.extensionsPath].map(De=>De?b.Promises.mkdir(De,{recursive:!0}):void 0));const Te=(0,ie.getLogLevel)(we),xe=new ne.SpdLogLogger("cli",(0,u.join)(we.logsPath,"cli.log"),!0,!1,Te),_=[];Te===ie.LogLevel.Trace&&_.push(new ie.ConsoleLogger(Te));const q=this._register(new me.LogService(xe,_));oe.set(ie.ILogService,q);const K=this._register(new l.FileService(q));oe.set(a.IFileService,K);const he=this._register(new h.DiskFileSystemProvider(q));K.registerProvider(g.Schemas.file,he);const ve=new z.StateService(we,q,K);oe.set(j.IStateService,ve);const Le=new G.UriIdentityService(K);oe.set(W.IUriIdentityService,Le);const Ie=new re.UserDataProfilesService(ve,Le,we,K,q);oe.set(H.IUserDataProfilesService,Ie);const Ae=P.isWindows&&Se.win32RegValueName?this._register(new se.NativePolicyService(q,Se.win32RegValueName)):we.policyFile?this._register(new ae.FilePolicyService(we.policyFile,K,q)):new ue.NullPolicyService;oe.set(ue.IPolicyService,Ae);const Re=this._register(new T.ConfigurationService(Ie.defaultProfile.settingsResource,K,Ae,q));oe.set(v.IConfigurationService,Re),await Promise.all([ve.init(),Re.initialize()]),Ie.init(),oe.set(W.IUriIdentityService,new G.UriIdentityService(K)),oe.set(M.IRequestService,new A.SyncDescriptor(F.RequestService,void 0,!0)),oe.set(c.IDownloadService,new A.SyncDescriptor(f.DownloadService,void 0,!0)),oe.set(i.IExtensionsProfileScannerService,new A.SyncDescriptor(Ee.ExtensionsProfileScannerService,void 0,!0)),oe.set(n.IExtensionsScannerService,new A.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),oe.set(t.IExtensionSignatureVerificationService,new A.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),oe.set(r.INativeServerExtensionManagementService,new A.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),oe.set(m.IExtensionGalleryService,new A.SyncDescriptor(S.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(Q.ILanguagePackService,new A.SyncDescriptor(te.NativeLanguagePackService,void 0,!1));const Oe=[],Ue=(0,k.isInternalTelemetry)(Se,Re);if((0,k.supportsTelemetry)(Se,we)){Se.aiConfig&&Se.aiConfig.ariaKey&&Oe.push(new O.OneDataSystemAppender(Ue,"monacoworkbench",null,Se.aiConfig.ariaKey));const{installSourcePath:De}=we,ke={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ne;try{Ne=await(0,ce.resolveMachineId)(ve)}catch(Me){Me.code!=="ENOENT"&&q.error(Me)}return(0,B.resolveCommonProperties)(K,(0,L.release)(),(0,L.hostname)(),process.arch,Se.commit,Se.version,Ne,Ue,De)})(),piiPaths:(0,k.getPiiPathsFromEnvironment)(we)};oe.set(X.ITelemetryService,new A.SyncDescriptor(N.TelemetryService,[ke],!1))}else oe.set(X.ITelemetryService,k.NullTelemetryService);return[new x.InstantiationService(oe),Oe]}registerErrorHandler(oe){(0,R.setUnexpectedErrorHandler)(Se=>{const we=(0,C.toErrorMessage)(Se,!0);!we||oe.error(`[uncaught exception in CLI]: ${we}`)}),process.on("uncaughtException",Se=>{(0,R.isSigPipeError)(Se)||(0,R.onUnexpectedError)(Se)}),process.on("unhandledRejection",Se=>(0,R.onUnexpectedError)(Se))}async doRun(oe,Se,we,Te){let xe;if(oe.args.profile&&(xe=we.profiles.find(q=>q.name===oe.args.profile),!xe))throw new Error(`Profile '${oe.args.profile}' not found.`);const _=(xe??we.defaultProfile).extensionsResource;if(this.argv["install-source"])return this.setInstallSource(oe,Se,this.argv["install-source"]);if(this.argv["list-extensions"])return Te.createInstance(s.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,_);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const q={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:_};return Te.createInstance(s.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],q,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return Te.createInstance(s.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,_);if(this.argv["locate-extension"])return Te.createInstance(s.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}asExtensionIdOrVSIX(oe){return oe.map(Se=>/\.vsix$/i.test(Se)?d.URI.file((0,u.isAbsolute)(Se)?Se:(0,u.join)((0,p.cwd)(),Se)):Se)}async setInstallSource(oe,Se,we){await Se.writeFile(d.URI.file(oe.installSourcePath),I.VSBuffer.fromString(we.slice(0,30)))}}async function de(ge){const oe=new le(ge);try{await oe.run()}finally{oe.dispose()}}e.main=de})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c6a9727b801542499d2b59cb7db4224e060fc578/core/vs/code/node/cliProcessMain.js.map
