/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/process","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","path","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(ie){for(var e=[],a=0,P=ie.length;a<P;a++)e[a]=_e[ie[a]];return e};define(_e[61],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(_,T){const S=Object.create(null);for(const D of _){const R=T(D);let I=S[R];I||(I=S[R]=[]),I.push(D)}return S}e.groupBy=a;function P(_,T){const S=[],D=[];for(const R of _)T.has(R)||S.push(R);for(const R of T)_.has(R)||D.push(R);return{removed:S,added:D}}e.diffSets=P;function u(_,T){const S=[],D=[];for(const[R,I]of _)T.has(R)||S.push(I);for(const[R,I]of T)_.has(R)||D.push(I);return{removed:S,added:D}}e.diffMaps=u;class A{constructor(){this.map=new Map}add(T,S){let D=this.map.get(T);D||(D=new Set,this.map.set(T,D)),D.add(S)}delete(T,S){const D=this.map.get(T);!D||(D.delete(S),D.size===0&&this.map.delete(T))}forEach(T,S){const D=this.map.get(T);!D||D.forEach(S)}}e.SetMap=A}),define(_e[62],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(_){return(T,S,D)=>{let R=null,I=null;if(typeof D.value=="function"?(R="value",I=D.value):typeof D.get=="function"&&(R="get",I=D.get),!I)throw new Error("not supported");D[R]=_(I,S)}}function P(_,T,S){let D=null,R=null;if(typeof S.value=="function"?(D="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(D="get",R=S.get),!R)throw new Error("not supported");const I=`$memoize$${T}`;S[D]=function(...b){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,b)}),this[I]}}e.memoize=P;function u(_,T,S){return a((D,R)=>{const I=`$debounce$${R}`,b=`$debounce$result$${R}`;return function(...k){this[b]||(this[b]=S?S():void 0),clearTimeout(this[I]),T&&(this[b]=T(this[b],...k),k=[this[b]]),this[I]=setTimeout(()=>{D.apply(this,k),this[b]=S?S():void 0},_)}})}e.debounce=u;function A(_,T,S){return a((D,R)=>{const I=`$throttle$timer$${R}`,b=`$throttle$result$${R}`,k=`$throttle$lastRun$${R}`,w=`$throttle$pending$${R}`;return function(...f){if(this[b]||(this[b]=S?S():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),T&&(this[b]=T(this[b],...f)),this[w])return;const d=this[k]+_;d<=Date.now()?(this[k]=Date.now(),D.apply(this,[this[b]]),this[b]=S?S():void 0):(this[w]=!0,this[I]=setTimeout(()=>{this[w]=!1,this[k]=Date.now(),D.apply(this,[this[b]]),this[b]=S?S():void 0},d-Date.now()))}})}e.throttle=A}),define(_e[11],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?C.isErrorNoTelemetry(o)?new C(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(s=>{s(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=a,e.errorHandler=new a;function P(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=P;function u(i){if(!i||typeof i!="object")return!1;const o=i;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=u;function A(i){D(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=A;function _(i){D(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=_;function T(i){if(i instanceof Error){const{name:o,message:s}=i,l=i.stacktrace||i.stack;return{$isError:!0,name:o,message:s,stack:l,noTelemetry:C.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=T;const S="Canceled";function D(i){return i instanceof R?!0:i instanceof Error&&i.name===S&&i.message===S}e.isCancellationError=D;class R extends Error{constructor(){super(S),this.name=this.message}}e.CancellationError=R;function I(){const i=new Error(S);return i.name=i.message,i}e.canceled=I;function b(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=b;function k(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=k;function w(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function f(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.disposed=f;function d(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=d;class h extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=h;class g extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=g;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class C extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof C)return o;const s=new C;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=C;class p extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(_e[16],ye([1,0,11]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function P(oe,ae=0){return oe[oe.length-(1+ae)]}e.tail=P;function u(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=u;function A(oe,ae,fe=(ee,le)=>ee===le){if(oe===ae)return!0;if(!oe||!ae||oe.length!==ae.length)return!1;for(let ee=0,le=oe.length;ee<le;ee++)if(!fe(oe[ee],ae[ee]))return!1;return!0}e.equals=A;function _(oe,ae){const fe=oe.length-1;ae<fe&&(oe[ae]=oe[fe]),oe.pop()}e.removeFastWithoutKeepingOrder=_;function T(oe,ae,fe){return S(oe.length,ee=>fe(oe[ee],ae))}e.binarySearch=T;function S(oe,ae){let fe=0,ee=oe-1;for(;fe<=ee;){const le=(fe+ee)/2|0,re=ae(le);if(re<0)fe=le+1;else if(re>0)ee=le-1;else return le}return-(fe+1)}e.binarySearch2=S;function D(oe,ae){let fe=0,ee=oe.length;if(ee===0)return 0;for(;fe<ee;){const le=Math.floor((fe+ee)/2);ae(oe[le])?ee=le:fe=le+1}return fe}e.findFirstInSorted=D;function R(oe,ae,fe){if(oe=oe|0,oe>=ae.length)throw new TypeError("invalid index");const ee=ae[Math.floor(ae.length*Math.random())],le=[],re=[],O=[];for(const W of ae){const G=fe(W,ee);G<0?le.push(W):G>0?re.push(W):O.push(W)}return oe<le.length?R(oe,le,fe):oe<le.length+O.length?O[0]:R(oe-(le.length+O.length),re,fe)}e.quickSelect=R;function I(oe,ae){const fe=[];let ee;for(const le of oe.slice(0).sort(ae))!ee||ae(ee[0],le)!==0?(ee=[le],fe.push(ee)):ee.push(le);return fe}e.groupBy=I;function b(oe,ae,fe){const ee=[];function le(W,G,Q){if(G===0&&Q.length===0)return;const he=ee[ee.length-1];he&&he.start+he.deleteCount===W?(he.deleteCount+=G,he.toInsert.push(...Q)):ee.push({start:W,deleteCount:G,toInsert:Q})}let re=0,O=0;for(;;){if(re===oe.length){le(re,0,ae.slice(O));break}if(O===ae.length){le(re,oe.length-re,[]);break}const W=oe[re],G=ae[O],Q=fe(W,G);Q===0?(re+=1,O+=1):Q<0?(le(re,1,[]),re+=1):Q>0&&(le(re,0,[G]),O+=1)}return ee}e.sortedDiff=b;function k(oe,ae,fe){const ee=b(oe,ae,fe),le=[],re=[];for(const O of ee)le.push(...oe.slice(O.start,O.start+O.deleteCount)),re.push(...O.toInsert);return{removed:le,added:re}}e.delta=k;function w(oe,ae,fe){if(fe===0)return[];const ee=oe.slice(0,fe).sort(ae);return d(oe,ae,ee,fe,oe.length),ee}e.top=w;function f(oe,ae,fe,ee,le){return fe===0?Promise.resolve([]):new Promise((re,O)=>{(async()=>{const W=oe.length,G=oe.slice(0,fe).sort(ae);for(let Q=fe,he=Math.min(fe+ee,W);Q<W;Q=he,he=Math.min(he+ee,W)){if(Q>fe&&await new Promise(Ee=>setTimeout(Ee)),le&&le.isCancellationRequested)throw new a.CancellationError;d(oe,ae,G,Q,he)}return G})().then(re,O)})}e.topAsync=f;function d(oe,ae,fe,ee,le){for(const re=fe.length;ee<le;ee++){const O=oe[ee];if(ae(O,fe[re-1])<0){fe.pop();const W=D(fe,G=>ae(O,G)<0);fe.splice(W,0,O)}}}function h(oe){return oe.filter(ae=>!!ae)}e.coalesce=h;function g(oe){let ae=0;for(let fe=0;fe<oe.length;fe++)oe[fe]&&(oe[ae]=oe[fe],ae+=1);oe.length=ae}e.coalesceInPlace=g;function v(oe,ae,fe){oe.splice(fe,0,oe.splice(ae,1)[0])}e.move=v;function C(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=C;function p(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=p;function i(oe,ae=fe=>fe){const fe=new Set;return oe.filter(ee=>{const le=ae(ee);return fe.has(le)?!1:(fe.add(le),!0)})}e.distinct=i;function o(oe){const ae=new Set;return fe=>{const ee=oe(fe);return ae.has(ee)?!1:(ae.add(ee),!0)}}e.uniqueFilter=o;function s(oe,ae){const fe=l(oe,ae);if(fe!==-1)return oe[fe]}e.findLast=s;function l(oe,ae){for(let fe=oe.length-1;fe>=0;fe--){const ee=oe[fe];if(ae(ee))return fe}return-1}e.lastIndex=l;function r(oe,ae){return oe.length>0?oe[0]:ae}e.firstOrDefault=r;function m(oe,ae){return oe.length>0?oe[oe.length-1]:ae}e.lastOrDefault=m;function n(oe,ae,fe=(ee,le)=>ee===le){let ee=0;for(let le=0,re=Math.min(oe.length,ae.length);le<re&&fe(oe[le],ae[le]);le++)ee++;return ee}e.commonPrefixLength=n;function t(oe){return[].concat(...oe)}e.flatten=t;function c(oe,ae){let fe=typeof ae=="number"?oe:0;typeof ae=="number"?fe=oe:(fe=0,ae=oe);const ee=[];if(fe<=ae)for(let le=fe;le<ae;le++)ee.push(le);else for(let le=fe;le>ae;le--)ee.push(le);return ee}e.range=c;function E(oe,ae,fe){return oe.reduce((ee,le)=>(ee[ae(le)]=fe?fe(le):le,ee),Object.create(null))}e.index=E;function y(oe,ae){return oe.push(ae),()=>M(oe,ae)}e.insert=y;function M(oe,ae){const fe=oe.indexOf(ae);if(fe>-1)return oe.splice(fe,1),ae}e.remove=M;function j(oe,ae,fe){const ee=oe.slice(0,ae),le=oe.slice(ae);return ee.concat(fe,le)}e.arrayInsert=j;function $(oe,ae){let fe;if(typeof ae=="number"){let ee=ae;fe=()=>{const le=Math.sin(ee++)*179426549;return le-Math.floor(le)}}else fe=Math.random;for(let ee=oe.length-1;ee>0;ee-=1){const le=Math.floor(fe()*(ee+1)),re=oe[ee];oe[ee]=oe[le],oe[le]=re}}e.shuffle=$;function N(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.unshift(ae))}e.pushToStart=N;function x(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.push(ae))}e.pushToEnd=x;function L(oe,ae){for(const fe of ae)oe.push(fe)}e.pushMany=L;function F(oe,ae){return Array.isArray(oe)?oe.map(ae):ae(oe)}e.mapArrayOrNot=F;function U(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=U;function H(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=H;function de(oe,ae){for(const fe of oe){const ee=ae(fe);if(ee!==void 0)return ee}}e.mapFind=de;function Y(oe,ae,fe){const ee=X(oe,ae),le=oe.length,re=fe.length;oe.length=le+re;for(let O=le-1;O>=ee;O--)oe[O+re]=oe[O];for(let O=0;O<re;O++)oe[O+ee]=fe[O]}e.insertInto=Y;function V(oe,ae,fe,ee){const le=X(oe,ae),re=oe.splice(le,fe);return Y(oe,le,ee),re}e.splice=V;function X(oe,ae){return ae<0?Math.max(ae+oe.length,0):Math.min(ae,oe.length)}var Z;(function(oe){function ae(le){return le<0}oe.isLessThan=ae;function fe(le){return le>0}oe.isGreaterThan=fe;function ee(le){return le===0}oe.isNeitherLessOrGreaterThan=ee,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(Z=e.CompareResult||(e.CompareResult={}));function te(oe,ae){return(fe,ee)=>ae(oe(fe),oe(ee))}e.compareBy=te;function K(...oe){return(ae,fe)=>{for(const ee of oe){const le=ee(ae,fe);if(!Z.isNeitherLessOrGreaterThan(le))return le}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=K;const J=(oe,ae)=>oe-ae;e.numberComparator=J;function ne(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let ee=1;ee<oe.length;ee++){const le=oe[ee];ae(le,fe)>0&&(fe=le)}return fe}e.findMaxBy=ne;function pe(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let ee=1;ee<oe.length;ee++){const le=oe[ee];ae(le,fe)>=0&&(fe=le)}return fe}e.findLastMaxBy=pe;function be(oe,ae){return ne(oe,(fe,ee)=>-ae(fe,ee))}e.findMinBy=be;class Ie{constructor(ae){this.items=ae,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ae){let fe=this.firstIdx;for(;fe<this.items.length&&ae(this.items[fe]);)fe++;const ee=fe===this.firstIdx?null:this.items.slice(this.firstIdx,fe);return this.firstIdx=fe,ee}takeFromEndWhile(ae){let fe=this.lastIdx;for(;fe>=0&&ae(this.items[fe]);)fe--;const ee=fe===this.lastIdx?null:this.items.slice(fe+1,this.lastIdx+1);return this.lastIdx=fe,ee}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ae=this.items[this.firstIdx];return this.firstIdx++,ae}removeLast(){const ae=this.items[this.lastIdx];return this.lastIdx--,ae}takeCount(ae){const fe=this.items.slice(this.firstIdx,this.firstIdx+ae);return this.firstIdx+=ae,fe}}e.ArrayQueue=Ie;class Le{constructor(ae){this.iterate=ae}forEach(ae){this.iterate(fe=>(ae(fe),!0))}toArray(){const ae=[];return this.iterate(fe=>(ae.push(fe),!0)),ae}filter(ae){return new Le(fe=>this.iterate(ee=>ae(ee)?fe(ee):!0))}map(ae){return new Le(fe=>this.iterate(ee=>fe(ae(ee))))}some(ae){let fe=!1;return this.iterate(ee=>(fe=ae(ee),!fe)),fe}findFirst(ae){let fe;return this.iterate(ee=>ae(ee)?(fe=ee,!1):!0),fe}findLast(ae){let fe;return this.iterate(ee=>(ae(ee)&&(fe=ee),!0)),fe}findLastMaxBy(ae){let fe,ee=!0;return this.iterate(le=>((ee||Z.isGreaterThan(ae(le,fe)))&&(ee=!1,fe=le),!0)),fe}}Le.empty=new Le(oe=>{}),e.CallbackIterable=Le}),define(_e[50],ye([1,0,11]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function P(S,D){if(!S)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=P;function u(S,D="Unreachable"){throw new Error(D)}e.assertNever=u;function A(S){if(!S)throw new a.BugIndicatingError("Assertion Failed")}e.assert=A;function _(S){if(!S()){debugger;S(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function T(S,D){let R=0;for(;R<S.length-1;){const I=S[R],b=S[R+1];if(!D(I,b))return!1;R++}return!0}e.checkAdjacentItems=T}),define(_e[63],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(P){const u=this;let A=!1,_;return function(){return A||(A=!0,_=P.apply(u,arguments)),_}}e.once=a}),define(_e[101],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(u){this._prefix=u,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(_e[64],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(P){function u(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}P.is=u;const A=Object.freeze([]);function _(){return A}P.empty=_;function*T(C){yield C}P.single=T;function S(C){return u(C)?C:T(C)}P.wrap=S;function D(C){return C||A}P.from=D;function R(C){return!C||C[Symbol.iterator]().next().done===!0}P.isEmpty=R;function I(C){return C[Symbol.iterator]().next().value}P.first=I;function b(C,p){for(const i of C)if(p(i))return!0;return!1}P.some=b;function k(C,p){for(const i of C)if(p(i))return i}P.find=k;function*w(C,p){for(const i of C)p(i)&&(yield i)}P.filter=w;function*f(C,p){let i=0;for(const o of C)yield p(o,i++)}P.map=f;function*d(...C){for(const p of C)for(const i of p)yield i}P.concat=d;function h(C,p,i){let o=i;for(const s of C)o=p(o,s);return o}P.reduce=h;function*g(C,p,i=C.length){for(p<0&&(p+=C.length),i<0?i+=C.length:i>C.length&&(i=C.length);p<i;p++)yield C[p]}P.slice=g;function v(C,p=Number.POSITIVE_INFINITY){const i=[];if(p===0)return[i,C];const o=C[Symbol.iterator]();for(let s=0;s<p;s++){const l=o.next();if(l.done)return[i,P.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return o}}]}P.consume=v})(a=e.Iterable||(e.Iterable={}))}),define(_e[146],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var u;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(u=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function _(i,o=!1){let s=0;const l=i.length;let r="",m=0,n=16,t=0;function c(x){let L=0,F=0;for(;L<x;){const U=i.charCodeAt(s);if(U>=48&&U<=57)F=F*16+U-48;else if(U>=65&&U<=70)F=F*16+U-65+10;else if(U>=97&&U<=102)F=F*16+U-97+10;else break;s++,L++}return L<x&&(F=-1),F}function E(x){s=x,r="",m=0,n=16,t=0}function y(){const x=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&D(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&D(i.charCodeAt(s)))for(s++;s<i.length&&D(i.charCodeAt(s));)s++;else return t=3,i.substring(x,s);let L=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&D(i.charCodeAt(s))){for(s++;s<i.length&&D(i.charCodeAt(s));)s++;L=s}else t=3;return i.substring(x,L)}function M(){let x="",L=s;for(;;){if(s>=l){x+=i.substring(L,s),t=2;break}const F=i.charCodeAt(s);if(F===34){x+=i.substring(L,s),s++;break}if(F===92){if(x+=i.substring(L,s),s++,s>=l){t=2;break}switch(i.charCodeAt(s++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const H=c(4);H>=0?x+=String.fromCharCode(H):t=4;break}default:t=5}L=s;continue}if(F>=0&&F<=31)if(S(F)){x+=i.substring(L,s),t=2;break}else t=6;s++}return x}function j(){if(r="",t=0,m=s,s>=l)return m=l,n=17;let x=i.charCodeAt(s);if(T(x)){do s++,r+=String.fromCharCode(x),x=i.charCodeAt(s);while(T(x));return n=15}if(S(x))return s++,r+=String.fromCharCode(x),x===13&&i.charCodeAt(s)===10&&(s++,r+=`
`),n=14;switch(x){case 123:return s++,n=1;case 125:return s++,n=2;case 91:return s++,n=3;case 93:return s++,n=4;case 58:return s++,n=6;case 44:return s++,n=5;case 34:return s++,r=M(),n=10;case 47:{const L=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<l&&!S(i.charCodeAt(s));)s++;return r=i.substring(L,s),n=12}if(i.charCodeAt(s+1)===42){s+=2;const F=l-1;let U=!1;for(;s<F;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,t=1),r=i.substring(L,s),n=13}return r+=String.fromCharCode(x),s++,n=16}case 45:if(r+=String.fromCharCode(x),s++,s===l||!D(i.charCodeAt(s)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=y(),n=11;default:for(;s<l&&$(x);)s++,x=i.charCodeAt(s);if(m!==s){switch(r=i.substring(m,s),r){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return r+=String.fromCharCode(x),s++,n=16}}function $(x){if(T(x)||S(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let x;do x=j();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>s,scan:o?N:j,getToken:()=>n,getTokenValue:()=>r,getTokenOffset:()=>m,getTokenLength:()=>s-m,getTokenError:()=>t}}e.createScanner=_;function T(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function D(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function I(i,o){const s=[],l=new Object;let r;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function t(c,E,y,M){m.value=c,m.offset=E,m.length=y,m.type=M,m.colonOffset=void 0,r=m}try{v(i,{onObjectBegin:(c,E)=>{if(o<=c)throw l;r=void 0,n=o>c,s.push("")},onObjectProperty:(c,E,y)=>{if(o<E||(t(c,E,y,"property"),s[s.length-1]=c,o<=E+y))throw l},onObjectEnd:(c,E)=>{if(o<=c)throw l;r=void 0,s.pop()},onArrayBegin:(c,E)=>{if(o<=c)throw l;r=void 0,s.push(0)},onArrayEnd:(c,E)=>{if(o<=c)throw l;r=void 0,s.pop()},onLiteralValue:(c,E,y)=>{if(o<E||(t(c,E,y,p(c)),o<=E+y))throw l},onSeparator:(c,E,y)=>{if(o<=E)throw l;if(c===":"&&r&&r.type==="property")r.colonOffset=E,n=!1,r=void 0;else if(c===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(n=!0,s[s.length-1]=""),r=void 0}}})}catch(c){if(c!==l)throw c}return{path:s,previousNode:r,isAtPropertyKey:n,matches:c=>{let E=0;for(let y=0;E<c.length&&y<s.length;y++)if(c[E]===s[y]||c[E]==="*")E++;else if(c[E]!=="**")return!1;return E===c.length}}}e.getLocation=I;function b(i,o=[],s=A.DEFAULT){let l=null,r=[];const m=[];function n(c){Array.isArray(r)?r.push(c):l!==null&&(r[l]=c)}return v(i,{onObjectBegin:()=>{const c={};n(c),m.push(r),r=c,l=null},onObjectProperty:c=>{l=c},onObjectEnd:()=>{r=m.pop()},onArrayBegin:()=>{const c=[];n(c),m.push(r),r=c,l=null},onArrayEnd:()=>{r=m.pop()},onLiteralValue:n,onError:(c,E,y)=>{o.push({error:c,offset:E,length:y})}},s),r[0]}e.parse=b;function k(i,o=[],s=A.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(c){l.type==="property"&&(l.length=c-l.offset,l=l.parent)}function m(c){return l.children.push(c),c}v(i,{onObjectBegin:c=>{l=m({type:"object",offset:c,length:-1,parent:l,children:[]})},onObjectProperty:(c,E,y)=>{l=m({type:"property",offset:E,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:c,offset:E,length:y,parent:l})},onObjectEnd:(c,E)=>{l.length=c+E-l.offset,l=l.parent,r(c+E)},onArrayBegin:(c,E)=>{l=m({type:"array",offset:c,length:-1,parent:l,children:[]})},onArrayEnd:(c,E)=>{l.length=c+E-l.offset,l=l.parent,r(c+E)},onLiteralValue:(c,E,y)=>{m({type:p(c),offset:E,length:y,parent:l,value:c}),r(E+y)},onSeparator:(c,E,y)=>{l.type==="property"&&(c===":"?l.colonOffset=E:c===","&&r(E))},onError:(c,E,y)=>{o.push({error:c,offset:E,length:y})}},s);const t=l.children[0];return t&&delete t.parent,t}e.parseTree=k;function w(i,o){if(!i)return;let s=i;for(const l of o)if(typeof l=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const m of s.children)if(Array.isArray(m.children)&&m.children[0].value===l){s=m.children[1],r=!0;break}if(!r)return}else{const r=l;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=w;function f(i){if(!i.parent||!i.parent.children)return[];const o=f(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;o.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&o.push(s)}return o}e.getNodePath=f;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const o=Object.create(null);for(const s of i.children){const l=s.children[1];l&&(o[s.children[0].value]=d(l))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=d;function h(i,o,s=!1){return o>=i.offset&&o<i.offset+i.length||s&&o===i.offset+i.length}e.contains=h;function g(i,o,s=!1){if(h(i,o,s)){const l=i.children;if(Array.isArray(l))for(let r=0;r<l.length&&l[r].offset<=o;r++){const m=g(l[r],o,s);if(m)return m}return i}}e.findNodeAtOffset=g;function v(i,o,s=A.DEFAULT){const l=_(i,!1);function r(te){return te?()=>te(l.getTokenOffset(),l.getTokenLength()):()=>!0}function m(te){return te?K=>te(K,l.getTokenOffset(),l.getTokenLength()):()=>!0}const n=r(o.onObjectBegin),t=m(o.onObjectProperty),c=r(o.onObjectEnd),E=r(o.onArrayBegin),y=r(o.onArrayEnd),M=m(o.onLiteralValue),j=m(o.onSeparator),$=r(o.onComment),N=m(o.onError),x=s&&s.disallowComments,L=s&&s.allowTrailingComma;function F(){for(;;){const te=l.scan();switch(l.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:x||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(te){case 12:case 13:x?U(10):$();break;case 16:U(1);break;case 15:case 14:break;default:return te}}}function U(te,K=[],J=[]){if(N(te),K.length+J.length>0){let ne=l.getToken();for(;ne!==17;){if(K.indexOf(ne)!==-1){F();break}else if(J.indexOf(ne)!==-1)break;ne=F()}}}function H(te){const K=l.getTokenValue();return te?M(K):t(K),F(),!0}function de(){switch(l.getToken()){case 11:{let te=0;try{te=JSON.parse(l.getTokenValue()),typeof te!="number"&&(U(2),te=0)}catch{U(2)}M(te);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return F(),!0}function Y(){return l.getToken()!==10?(U(3,[],[2,5]),!1):(H(!1),l.getToken()===6?(j(":"),F(),Z()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){n(),F();let te=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(te||U(4,[],[]),j(","),F(),l.getToken()===2&&L)break}else te&&U(6,[],[]);Y()||U(4,[],[2,5]),te=!0}return c(),l.getToken()!==2?U(7,[2],[]):F(),!0}function X(){E(),F();let te=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(te||U(4,[],[]),j(","),F(),l.getToken()===4&&L)break}else te&&U(6,[],[]);Z()||U(4,[],[4,5]),te=!0}return y(),l.getToken()!==4?U(8,[4],[]):F(),!0}function Z(){switch(l.getToken()){case 3:return X();case 1:return V();case 10:return H(!0);default:return de()}}return F(),l.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):Z()?(l.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=v;function C(i,o){const s=_(i),l=[];let r,m=0,n;do switch(n=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:m!==n&&l.push(i.substring(m,n)),o!==void 0&&l.push(s.getTokenValue().replace(/[^\r\n]/g,o)),m=s.getPosition();break}while(r!==17);return l.join("")}e.stripComments=C;function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(_e[65],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(u){this.executor=u,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(u){this._error=u}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=a}),define(_e[6],ye([1,0,63,64]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const u=!1;let A=null;function _(m){A=m}if(e.setDisposableTracker=_,u){const m="__is_disposable_tracked__";_(new class{trackDisposable(n){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[m]||console.log(t)},3e3)}setParent(n,t){if(n&&n!==g.None)try{n[m]=!0}catch{}}markAsDisposed(n){if(n&&n!==g.None)try{n[m]=!0}catch{}}markAsSingleton(n){}})}function T(m){return A?.trackDisposable(m),m}function S(m){A?.markAsDisposed(m)}function D(m,n){A?.setParent(m,n)}function R(m,n){if(!!A)for(const t of m)A.setParent(t,n)}function I(m){return A?.markAsSingleton(m),m}e.markAsSingleton=I;function b(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=b;function k(m){if(P.Iterable.is(m)){const n=[];for(const t of m)if(t)try{t.dispose()}catch(c){n.push(c)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.dispose=k;function w(m){for(const n of m)b(n)&&n.dispose();return[]}e.disposeIfDisposable=w;function f(...m){const n=d(()=>k(m));return R(m,n),n}e.combinedDisposable=f;function d(m){const n=T({dispose:(0,a.once)(()=>{S(n),m()})});return n}e.toDisposable=d;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,T(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{k(this._toDispose)}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return D(n,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class g{constructor(){this._store=new h,T(this),D(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class v{constructor(){this._isDisposed=!1,T(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&D(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&D(n,null),n}}e.MutableDisposable=v;class C{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=C;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let t=n;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,S(this))},this}}e.SafeDisposable=p;class i{constructor(){this.references=new Map}acquire(n,...t){let c=this.references.get(n);c||(c={counter:0,object:this.createReferencedObject(n,...t)},this.references.set(n,c));const{object:E}=c,y=(0,a.once)(()=>{--c.counter===0&&(this.destroyReferencedObject(n,c.object),this.references.delete(n))});return c.counter++,{object:E,dispose:y}}}e.ReferenceCollection=i;class o{constructor(n){this.referenceCollection=n}async acquire(n,...t){const c=this.referenceCollection.acquire(n,...t);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(E){throw c.dispose(),E}}}e.AsyncReferenceCollection=o;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s;function l(m){const n=new h;try{m(n)}finally{n.dispose()}}e.disposeOnReturn=l;class r{constructor(){this._store=new Map,this._isDisposed=!1,T(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{k(this._store.values())}finally{this._store.clear()}}has(n){return this._store.has(n)}get(n){return this._store.get(n)}set(n,t,c=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),c||this._store.get(n)?.dispose(),this._store.set(n,t)}deleteAndDispose(n){this._store.get(n)?.dispose(),this._store.delete(n)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(_e[66],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(A){this.element=A,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class P{constructor(){this._first=a.Undefined,this._last=a.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===a.Undefined}clear(){let A=this._first;for(;A!==a.Undefined;){const _=A.next;A.prev=a.Undefined,A.next=a.Undefined,A=_}this._first=a.Undefined,this._last=a.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,_){const T=new a(A);if(this._first===a.Undefined)this._first=T,this._last=T;else if(_){const D=this._last;this._last=T,T.prev=D,D.next=T}else{const D=this._first;this._first=T,T.next=D,D.prev=T}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(T))}}shift(){if(this._first!==a.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==a.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==a.Undefined&&A.next!==a.Undefined){const _=A.prev;_.next=A.next,A.next.prev=_}else A.prev===a.Undefined&&A.next===a.Undefined?(this._first=a.Undefined,this._last=a.Undefined):A.next===a.Undefined?(this._last=this._last.prev,this._last.next=a.Undefined):A.prev===a.Undefined&&(this._first=this._first.next,this._first.prev=a.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==a.Undefined;)yield A.element,A=A.next}}e.LinkedList=P}),define(_e[28],ye([1,0]),function(ie,e){"use strict";var a,P,u;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(w,f,d){let h=w.get(f);return h===void 0&&(h=d,w.set(f,h)),h}e.getOrSet=A;function _(w){const f=[];return w.forEach((d,h)=>{f.push(`${h} => ${d}`)}),`Map(${w.size}) {${f.join(", ")}}`}e.mapToString=_;function T(w){const f=[];return w.forEach(d=>{f.push(d)}),`Set(${w.size}) {${f.join(", ")}}`}e.setToString=T;class S{constructor(f,d){this.uri=f,this.value=d}}class D{constructor(f,d){this[a]="ResourceMap",f instanceof D?(this.map=new Map(f.map),this.toKey=d??D.defaultToKey):(this.map=new Map,this.toKey=f??D.defaultToKey)}set(f,d){return this.map.set(this.toKey(f),new S(f,d)),this}get(f){return this.map.get(this.toKey(f))?.value}has(f){return this.map.has(this.toKey(f))}get size(){return this.map.size}clear(){this.map.clear()}delete(f){return this.map.delete(this.toKey(f))}forEach(f,d){typeof d<"u"&&(f=f.bind(d));for(const[h,g]of this.map)f(g.value,g.uri,this)}*values(){for(const f of this.map.values())yield f.value}*keys(){for(const f of this.map.values())yield f.uri}*entries(){for(const f of this.map.values())yield[f.uri,f.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.map)yield[f.uri,f.value]}}D.defaultToKey=w=>w.toString(),e.ResourceMap=D;class R{constructor(f,d){this[P]="ResourceSet",!f||typeof f=="function"?this._map=new D(f):(this._map=new D(d),f.forEach(this.add,this))}get size(){return this._map.size}add(f){return this._map.set(f,f),this}clear(){this._map.clear()}delete(f){return this._map.delete(f)}forEach(f,d){this._map.forEach((h,g)=>f.call(d,g,g,this))}has(f){return this._map.has(f)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var I;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class b{constructor(){this[u]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(f){return this._map.has(f)}get(f,d=0){const h=this._map.get(f);if(!!h)return d!==0&&this.touch(h,d),h.value}set(f,d,h=0){let g=this._map.get(f);if(g)g.value=d,h!==0&&this.touch(g,h);else{switch(g={key:f,value:d,next:void 0,previous:void 0},h){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(f,g),this._size++}return this}delete(f){return!!this.remove(f)}remove(f){const d=this._map.get(f);if(!!d)return this._map.delete(f),this.removeItem(d),this._size--,d.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const f=this._head;return this._map.delete(f.key),this.removeItem(f),this._size--,f.value}forEach(f,d){const h=this._state;let g=this._head;for(;g;){if(d?f.bind(d)(g.value,g.key,this):f(g.value,g.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const f=this,d=this._state;let h=this._head;const g={[Symbol.iterator](){return g},next(){if(f._state!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:h.key,done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return g}values(){const f=this,d=this._state;let h=this._head;const g={[Symbol.iterator](){return g},next(){if(f._state!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:h.value,done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return g}entries(){const f=this,d=this._state;let h=this._head;const g={[Symbol.iterator](){return g},next(){if(f._state!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:[h.key,h.value],done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return g}[(u=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(f){if(f>=this.size)return;if(f===0){this.clear();return}let d=this._head,h=this.size;for(;d&&h>f;)this._map.delete(d.key),d=d.next,h--;this._head=d,this._size=h,d&&(d.previous=void 0),this._state++}addItemFirst(f){if(!this._head&&!this._tail)this._tail=f;else if(this._head)f.next=this._head,this._head.previous=f;else throw new Error("Invalid list");this._head=f,this._state++}addItemLast(f){if(!this._head&&!this._tail)this._head=f;else if(this._tail)f.previous=this._tail,this._tail.next=f;else throw new Error("Invalid list");this._tail=f,this._state++}removeItem(f){if(f===this._head&&f===this._tail)this._head=void 0,this._tail=void 0;else if(f===this._head){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this._head=f.next}else if(f===this._tail){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this._tail=f.previous}else{const d=f.next,h=f.previous;if(!d||!h)throw new Error("Invalid list");d.previous=h,h.next=d}f.next=void 0,f.previous=void 0,this._state++}touch(f,d){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(f===this._head)return;const h=f.next,g=f.previous;f===this._tail?(g.next=void 0,this._tail=g):(h.previous=g,g.next=h),f.previous=void 0,f.next=this._head,this._head.previous=f,this._head=f,this._state++}else if(d===2){if(f===this._tail)return;const h=f.next,g=f.previous;f===this._head?(h.previous=void 0,this._head=h):(h.previous=g,g.next=h),f.next=void 0,f.previous=this._tail,this._tail.next=f,this._tail=f,this._state++}}}toJSON(){const f=[];return this.forEach((d,h)=>{f.push([h,d])}),f}fromJSON(f){this.clear();for(const[d,h]of f)this.set(d,h)}}e.LinkedMap=b;class k extends b{constructor(f,d=1){super(),this._limit=f,this._ratio=Math.min(Math.max(0,d),1)}get limit(){return this._limit}set limit(f){this._limit=f,this.checkTrim()}get ratio(){return this._ratio}set ratio(f){this._ratio=Math.min(Math.max(0,f),1),this.checkTrim()}get(f,d=2){return super.get(f,d)}peek(f){return super.get(f,0)}set(f,d){return super.set(f,d,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=k}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(_e[147],ye([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(oe,ae){for(var fe=0;fe<ae.length;fe++){var ee=ae[fe];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(oe,ee.key,ee)}}function a(oe,ae,fe){return ae&&e(oe.prototype,ae),fe&&e(oe,fe),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function P(oe,ae){if(!!oe){if(typeof oe=="string")return u(oe,ae);var fe=Object.prototype.toString.call(oe).slice(8,-1);if(fe==="Object"&&oe.constructor&&(fe=oe.constructor.name),fe==="Map"||fe==="Set")return Array.from(oe);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return u(oe,ae)}}function u(oe,ae){(ae==null||ae>oe.length)&&(ae=oe.length);for(var fe=0,ee=new Array(ae);fe<ae;fe++)ee[fe]=oe[fe];return ee}function A(oe,ae){var fe=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(fe)return(fe=fe.call(oe)).next.bind(fe);if(Array.isArray(oe)||(fe=P(oe))||ae&&oe&&typeof oe.length=="number"){fe&&(oe=fe);var ee=0;return function(){return ee>=oe.length?{done:!0}:{done:!1,value:oe[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=_();function T(oe){ie.defaults=oe}var S=/[&<>"']/,D=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ae){return b[ae]};function w(oe,ae){if(ae){if(S.test(oe))return oe.replace(D,k)}else if(R.test(oe))return oe.replace(I,k);return oe}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(oe){return oe.replace(f,function(ae,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(oe,ae){oe=typeof oe=="string"?oe:oe.source,ae=ae||"";var fe={replace:function(le,re){return re=re.source||re,re=re.replace(h,"$1"),oe=oe.replace(le,re),fe},getRegex:function(){return new RegExp(oe,ae)}};return fe}var v=/[^\w:]/g,C=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(oe,ae,fe){if(oe){var ee;try{ee=decodeURIComponent(d(fe)).replace(v,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ae&&!C.test(fe)&&(fe=r(ae,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(oe,ae){i[" "+oe]||(o.test(oe)?i[" "+oe]=oe+"/":i[" "+oe]=c(oe,"/",!0)),oe=i[" "+oe];var fe=oe.indexOf(":")===-1;return ae.substring(0,2)==="//"?fe?ae:oe.replace(s,"$1")+ae:ae.charAt(0)==="/"?fe?ae:oe.replace(l,"$1")+ae:oe+ae}var m={exec:function(){}};function n(oe){for(var ae=1,fe,ee;ae<arguments.length;ae++){fe=arguments[ae];for(ee in fe)Object.prototype.hasOwnProperty.call(fe,ee)&&(oe[ee]=fe[ee])}return oe}function t(oe,ae){var fe=oe.replace(/\|/g,function(re,O,W){for(var G=!1,Q=O;--Q>=0&&W[Q]==="\\";)G=!G;return G?"|":" |"}),ee=fe.split(/ \|/),le=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ae)ee.splice(ae);else for(;ee.length<ae;)ee.push("");for(;le<ee.length;le++)ee[le]=ee[le].trim().replace(/\\\|/g,"|");return ee}function c(oe,ae,fe){var ee=oe.length;if(ee===0)return"";for(var le=0;le<ee;){var re=oe.charAt(ee-le-1);if(re===ae&&!fe)le++;else if(re!==ae&&fe)le++;else break}return oe.slice(0,ee-le)}function E(oe,ae){if(oe.indexOf(ae[1])===-1)return-1;for(var fe=oe.length,ee=0,le=0;le<fe;le++)if(oe[le]==="\\")le++;else if(oe[le]===ae[0])ee++;else if(oe[le]===ae[1]&&(ee--,ee<0))return le;return-1}function y(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(oe,ae){if(ae<1)return"";for(var fe="";ae>1;)ae&1&&(fe+=oe),ae>>=1,oe+=oe;return fe+oe}function j(oe,ae,fe,ee){var le=ae.href,re=ae.title?w(ae.title):null,O=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){ee.state.inLink=!0;var W={type:"link",raw:fe,href:le,title:re,text:O,tokens:ee.inlineTokens(O)};return ee.state.inLink=!1,W}return{type:"image",raw:fe,href:le,title:re,text:w(O)}}function $(oe,ae){var fe=oe.match(/^(\s+)(?:```)/);if(fe===null)return ae;var ee=fe[1];return ae.split(`
`).map(function(le){var re=le.match(/^\s+/);if(re===null)return le;var O=re[0];return O.length>=ee.length?le.slice(ee.length):le}).join(`
`)}var N=function(){function oe(fe){this.options=fe||ie.defaults}var ae=oe.prototype;return ae.space=function(ee){var le=this.rules.block.newline.exec(ee);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},ae.code=function(ee){var le=this.rules.block.code.exec(ee);if(le){var re=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?re:c(re,`
`)}}},ae.fences=function(ee){var le=this.rules.block.fences.exec(ee);if(le){var re=le[0],O=$(re,le[3]||"");return{type:"code",raw:re,lang:le[2]?le[2].trim():le[2],text:O}}},ae.heading=function(ee){var le=this.rules.block.heading.exec(ee);if(le){var re=le[2].trim();if(/#$/.test(re)){var O=c(re,"#");(this.options.pedantic||!O||/ $/.test(O))&&(re=O.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:re,tokens:this.lexer.inline(re)}}},ae.hr=function(ee){var le=this.rules.block.hr.exec(ee);if(le)return{type:"hr",raw:le[0]}},ae.blockquote=function(ee){var le=this.rules.block.blockquote.exec(ee);if(le){var re=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},ae.list=function(ee){var le=this.rules.block.list.exec(ee);if(le){var re,O,W,G,Q,he,Ee,Pe,ve,Ce,ke,$e,je=le[1].trim(),et=je.length>1,Xe={type:"list",raw:"",ordered:et,start:et?+je.slice(0,-1):"",loose:!1,items:[]};je=et?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=et?je:"[*+-]");for(var nt=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&($e=!1,!(!(le=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(re=le[0],ee=ee.substring(re.length),Pe=le[2].split(`
`,1)[0],ve=ee.split(`
`,1)[0],this.options.pedantic?(G=2,ke=Pe.trimLeft()):(G=le[2].search(/[^ ]/),G=G>4?1:G,ke=Pe.slice(G),G+=le[1].length),he=!1,!Pe&&/^ *$/.test(ve)&&(re+=ve+`
`,ee=ee.substring(ve.length+1),$e=!0),!$e)for(var st=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");ee&&(Ce=ee.split(`
`,1)[0],Pe=Ce,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(Pe)||rt.test(Pe)||st.test(Pe)||ht.test(ee)));){if(Pe.search(/[^ ]/)>=G||!Pe.trim())ke+=`
`+Pe.slice(G);else if(!he)ke+=`
`+Pe;else break;!he&&!Pe.trim()&&(he=!0),re+=Ce+`
`,ee=ee.substring(Ce.length+1)}Xe.loose||(Ee?Xe.loose=!0:/\n *\n *$/.test(re)&&(Ee=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ke),O&&(W=O[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:re,task:!!O,checked:W,loose:!1,text:ke}),Xe.raw+=re}Xe.items[Xe.items.length-1].raw=re.trimRight(),Xe.items[Xe.items.length-1].text=ke.trimRight(),Xe.raw=Xe.raw.trimRight();var ce=Xe.items.length;for(Q=0;Q<ce;Q++){this.lexer.state.top=!1,Xe.items[Q].tokens=this.lexer.blockTokens(Xe.items[Q].text,[]);var B=Xe.items[Q].tokens.filter(function(De){return De.type==="space"}),ue=B.every(function(De){for(var Re=De.raw.split(""),xe=0,Ge=A(Re),Ze;!(Ze=Ge()).done;){var pt=Ze.value;if(pt===`
`&&(xe+=1),xe>1)return!0}return!1});!Xe.loose&&B.length&&ue&&(Xe.loose=!0,Xe.items[Q].loose=!0)}return Xe}},ae.html=function(ee){var le=this.rules.block.html.exec(ee);if(le){var re={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(le[0]):w(le[0]);re.type="paragraph",re.text=O,re.tokens=this.lexer.inline(O)}return re}},ae.def=function(ee){var le=this.rules.block.def.exec(ee);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var re=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:le[0],href:le[2],title:le[3]}}},ae.table=function(ee){var le=this.rules.block.table.exec(ee);if(le){var re={type:"table",header:t(le[1]).map(function(Ee){return{text:Ee}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=le[0];var O=re.align.length,W,G,Q,he;for(W=0;W<O;W++)/^ *-+: *$/.test(re.align[W])?re.align[W]="right":/^ *:-+: *$/.test(re.align[W])?re.align[W]="center":/^ *:-+ *$/.test(re.align[W])?re.align[W]="left":re.align[W]=null;for(O=re.rows.length,W=0;W<O;W++)re.rows[W]=t(re.rows[W],re.header.length).map(function(Ee){return{text:Ee}});for(O=re.header.length,G=0;G<O;G++)re.header[G].tokens=this.lexer.inline(re.header[G].text);for(O=re.rows.length,G=0;G<O;G++)for(he=re.rows[G],Q=0;Q<he.length;Q++)he[Q].tokens=this.lexer.inline(he[Q].text);return re}}},ae.lheading=function(ee){var le=this.rules.block.lheading.exec(ee);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},ae.paragraph=function(ee){var le=this.rules.block.paragraph.exec(ee);if(le){var re=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:re,tokens:this.lexer.inline(re)}}},ae.text=function(ee){var le=this.rules.block.text.exec(ee);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},ae.escape=function(ee){var le=this.rules.inline.escape.exec(ee);if(le)return{type:"escape",raw:le[0],text:w(le[1])}},ae.tag=function(ee){var le=this.rules.inline.tag.exec(ee);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):w(le[0]):le[0]}},ae.link=function(ee){var le=this.rules.inline.link.exec(ee);if(le){var re=le[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var O=c(re.slice(0,-1),"\\");if((re.length-O.length)%2===0)return}else{var W=E(le[2],"()");if(W>-1){var G=le[0].indexOf("!")===0?5:4,Q=G+le[1].length+W;le[2]=le[2].substring(0,W),le[0]=le[0].substring(0,Q).trim(),le[3]=""}}var he=le[2],Ee="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Pe&&(he=Pe[1],Ee=Pe[3])}else Ee=le[3]?le[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(re)?he=he.slice(1):he=he.slice(1,-1)),j(le,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:Ee&&Ee.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ae.reflink=function(ee,le){var re;if((re=this.rules.inline.reflink.exec(ee))||(re=this.rules.inline.nolink.exec(ee))){var O=(re[2]||re[1]).replace(/\s+/g," ");if(O=le[O.toLowerCase()],!O||!O.href){var W=re[0].charAt(0);return{type:"text",raw:W,text:W}}return j(re,O,re[0],this.lexer)}},ae.emStrong=function(ee,le,re){re===void 0&&(re="");var O=this.rules.inline.emStrong.lDelim.exec(ee);if(!!O&&!(O[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=O[1]||O[2]||"";if(!W||W&&(re===""||this.rules.inline.punctuation.exec(re))){var G=O[0].length-1,Q,he,Ee=G,Pe=0,ve=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ve.lastIndex=0,le=le.slice(-1*ee.length+G);(O=ve.exec(le))!=null;)if(Q=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Q){if(he=Q.length,O[3]||O[4]){Ee+=he;continue}else if((O[5]||O[6])&&G%3&&!((G+he)%3)){Pe+=he;continue}if(Ee-=he,!(Ee>0)){if(he=Math.min(he,he+Ee+Pe),Math.min(G,he)%2){var Ce=ee.slice(1,G+O.index+he);return{type:"em",raw:ee.slice(0,G+O.index+he+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ke=ee.slice(2,G+O.index+he-1);return{type:"strong",raw:ee.slice(0,G+O.index+he+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ae.codespan=function(ee){var le=this.rules.inline.code.exec(ee);if(le){var re=le[2].replace(/\n/g," "),O=/[^ ]/.test(re),W=/^ /.test(re)&&/ $/.test(re);return O&&W&&(re=re.substring(1,re.length-1)),re=w(re,!0),{type:"codespan",raw:le[0],text:re}}},ae.br=function(ee){var le=this.rules.inline.br.exec(ee);if(le)return{type:"br",raw:le[0]}},ae.del=function(ee){var le=this.rules.inline.del.exec(ee);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},ae.autolink=function(ee,le){var re=this.rules.inline.autolink.exec(ee);if(re){var O,W;return re[2]==="@"?(O=w(this.options.mangle?le(re[1]):re[1]),W="mailto:"+O):(O=w(re[1]),W=O),{type:"link",raw:re[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},ae.url=function(ee,le){var re;if(re=this.rules.inline.url.exec(ee)){var O,W;if(re[2]==="@")O=w(this.options.mangle?le(re[0]):re[0]),W="mailto:"+O;else{var G;do G=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(G!==re[0]);O=w(re[0]),re[1]==="www."?W="http://"+O:W=O}return{type:"link",raw:re[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},ae.inlineText=function(ee,le){var re=this.rules.inline.text.exec(ee);if(re){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):w(re[0]):re[0]:O=w(this.options.smartypants?le(re[0]):re[0]),{type:"text",raw:re[0],text:O}}},oe}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=g(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=g(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=g(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=g(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=g(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=g(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=n({},x),x.gfm=n({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=g(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=g(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=n({},x.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:g(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=g(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=g(x._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=g(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=g(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=g(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=g(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=g(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=g(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=g(L.reflink).replace("label",L._label).replace("ref",x._label).getRegex(),L.nolink=g(L.nolink).replace("ref",x._label).getRegex(),L.reflinkSearch=g(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=n({},L),L.pedantic=n({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=n({},L.normal,{escape:g(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=g(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=n({},L.gfm,{br:g(L.br).replace("{2,}","*").getRegex(),text:g(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(oe){var ae="",fe,ee,le=oe.length;for(fe=0;fe<le;fe++)ee=oe.charCodeAt(fe),Math.random()>.5&&(ee="x"+ee.toString(16)),ae+="&#"+ee+";";return ae}var H=function(){function oe(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ie.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:x.normal,inline:L.normal};this.options.pedantic?(ee.block=x.pedantic,ee.inline=L.pedantic):this.options.gfm&&(ee.block=x.gfm,this.options.breaks?ee.inline=L.breaks:ee.inline=L.gfm),this.tokenizer.rules=ee}oe.lex=function(ee,le){var re=new oe(le);return re.lex(ee)},oe.lexInline=function(ee,le){var re=new oe(le);return re.inlineTokens(ee)};var ae=oe.prototype;return ae.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ae.blockTokens=function(ee,le){var re=this;le===void 0&&(le=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(Ee,Pe,ve){return Pe+"    ".repeat(ve.length)});for(var O,W,G,Q;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ee){return(O=Ee.call({lexer:re},ee,le))?(ee=ee.substring(O.raw.length),le.push(O),!0):!1}))){if(O=this.tokenizer.space(ee)){ee=ee.substring(O.raw.length),O.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(O);continue}if(O=this.tokenizer.code(ee)){ee=ee.substring(O.raw.length),W=le[le.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):le.push(O);continue}if(O=this.tokenizer.fences(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.heading(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.hr(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.blockquote(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.list(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.html(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.def(ee)){ee=ee.substring(O.raw.length),W=le[le.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.lheading(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(G=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ee=1/0,Pe=ee.slice(1),ve=void 0;re.options.extensions.startBlock.forEach(function(Ce){ve=Ce.call({lexer:this},Pe),typeof ve=="number"&&ve>=0&&(Ee=Math.min(Ee,ve))}),Ee<1/0&&Ee>=0&&(G=ee.substring(0,Ee+1))}(),this.state.top&&(O=this.tokenizer.paragraph(G))){W=le[le.length-1],Q&&W.type==="paragraph"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):le.push(O),Q=G.length!==ee.length,ee=ee.substring(O.raw.length);continue}if(O=this.tokenizer.text(ee)){ee=ee.substring(O.raw.length),W=le[le.length-1],W&&W.type==="text"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):le.push(O);continue}if(ee){var he="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,le},ae.inline=function(ee,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ee,tokens:le}),le},ae.inlineTokens=function(ee,le){var re=this;le===void 0&&(le=[]);var O,W,G,Q=ee,he,Ee,Pe;if(this.tokens.links){var ve=Object.keys(this.tokens.links);if(ve.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(Q))!=null;)ve.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(Q=Q.slice(0,he.index)+"["+M("a",he[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(Q))!=null;)Q=Q.slice(0,he.index)+"["+M("a",he[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(Q))!=null;)Q=Q.slice(0,he.index)+"++"+Q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(Ee||(Pe=""),Ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(O=ke.call({lexer:re},ee,le))?(ee=ee.substring(O.raw.length),le.push(O),!0):!1}))){if(O=this.tokenizer.escape(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.tag(ee)){ee=ee.substring(O.raw.length),W=le[le.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):le.push(O);continue}if(O=this.tokenizer.link(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(O.raw.length),W=le[le.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):le.push(O);continue}if(O=this.tokenizer.emStrong(ee,Q,Pe)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.codespan(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.br(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.del(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.autolink(ee,U)){ee=ee.substring(O.raw.length),le.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(ee,U))){ee=ee.substring(O.raw.length),le.push(O);continue}if(G=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,$e=ee.slice(1),je=void 0;re.options.extensions.startInline.forEach(function(et){je=et.call({lexer:this},$e),typeof je=="number"&&je>=0&&(ke=Math.min(ke,je))}),ke<1/0&&ke>=0&&(G=ee.substring(0,ke+1))}(),O=this.tokenizer.inlineText(G,F)){ee=ee.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Pe=O.raw.slice(-1)),Ee=!0,W=le[le.length-1],W&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):le.push(O);continue}if(ee){var Ce="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return le},a(oe,null,[{key:"rules",get:function(){return{block:x,inline:L}}}]),oe}(),de=function(){function oe(fe){this.options=fe||ie.defaults}var ae=oe.prototype;return ae.code=function(ee,le,re){var O=(le||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(ee,O);W!=null&&W!==ee&&(re=!0,ee=W)}return ee=ee.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+w(O,!0)+'">'+(re?ee:w(ee,!0))+`</code></pre>
`:"<pre><code>"+(re?ee:w(ee,!0))+`</code></pre>
`},ae.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ae.html=function(ee){return ee},ae.heading=function(ee,le,re,O){if(this.options.headerIds){var W=this.options.headerPrefix+O.slug(re);return"<h"+le+' id="'+W+'">'+ee+"</h"+le+`>
`}return"<h"+le+">"+ee+"</h"+le+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(ee,le,re){var O=le?"ol":"ul",W=le&&re!==1?' start="'+re+'"':"";return"<"+O+W+`>
`+ee+"</"+O+`>
`},ae.listitem=function(ee){return"<li>"+ee+`</li>
`},ae.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(ee){return"<p>"+ee+`</p>
`},ae.table=function(ee,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+le+`</table>
`},ae.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ae.tablecell=function(ee,le){var re=le.header?"th":"td",O=le.align?"<"+re+' align="'+le.align+'">':"<"+re+">";return O+ee+("</"+re+`>
`)},ae.strong=function(ee){return"<strong>"+ee+"</strong>"},ae.em=function(ee){return"<em>"+ee+"</em>"},ae.codespan=function(ee){return"<code>"+ee+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(ee){return"<del>"+ee+"</del>"},ae.link=function(ee,le,re){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return re;var O='<a href="'+w(ee)+'"';return le&&(O+=' title="'+le+'"'),O+=">"+re+"</a>",O},ae.image=function(ee,le,re){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return re;var O='<img src="'+ee+'" alt="'+re+'"';return le&&(O+=' title="'+le+'"'),O+=this.options.xhtml?"/>":">",O},ae.text=function(ee){return ee},oe}(),Y=function(){function oe(){}var ae=oe.prototype;return ae.strong=function(ee){return ee},ae.em=function(ee){return ee},ae.codespan=function(ee){return ee},ae.del=function(ee){return ee},ae.html=function(ee){return ee},ae.text=function(ee){return ee},ae.link=function(ee,le,re){return""+re},ae.image=function(ee,le,re){return""+re},ae.br=function(){return""},oe}(),V=function(){function oe(){this.seen={}}var ae=oe.prototype;return ae.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(ee,le){var re=ee,O=0;if(this.seen.hasOwnProperty(re)){O=this.seen[ee];do O++,re=ee+"-"+O;while(this.seen.hasOwnProperty(re))}return le||(this.seen[ee]=O,this.seen[re]=0),re},ae.slug=function(ee,le){le===void 0&&(le={});var re=this.serialize(ee);return this.getNextSafeSlug(re,le.dryrun)},oe}(),X=function(){function oe(fe){this.options=fe||ie.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new V}oe.parse=function(ee,le){var re=new oe(le);return re.parse(ee)},oe.parseInline=function(ee,le){var re=new oe(le);return re.parseInline(ee)};var ae=oe.prototype;return ae.parse=function(ee,le){le===void 0&&(le=!0);var re="",O,W,G,Q,he,Ee,Pe,ve,Ce,ke,$e,je,et,Xe,nt,st,ht,Fe,rt,ce=ee.length;for(O=0;O<ce;O++){if(ke=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(rt=this.options.extensions.renderers[ke.type].call({parser:this},ke),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){re+=rt||"";continue}switch(ke.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,d(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(ve="",Pe="",Q=ke.header.length,W=0;W<Q;W++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[W].tokens),{header:!0,align:ke.align[W]});for(ve+=this.renderer.tablerow(Pe),Ce="",Q=ke.rows.length,W=0;W<Q;W++){for(Ee=ke.rows[W],Pe="",he=Ee.length,G=0;G<he;G++)Pe+=this.renderer.tablecell(this.parseInline(Ee[G].tokens),{header:!1,align:ke.align[G]});Ce+=this.renderer.tablerow(Pe)}re+=this.renderer.table(ve,Ce);continue}case"blockquote":{Ce=this.parse(ke.tokens),re+=this.renderer.blockquote(Ce);continue}case"list":{for($e=ke.ordered,je=ke.start,et=ke.loose,Q=ke.items.length,Ce="",W=0;W<Q;W++)nt=ke.items[W],st=nt.checked,ht=nt.task,Xe="",nt.task&&(Fe=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Fe+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Fe+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(nt.tokens,et),Ce+=this.renderer.listitem(Xe,ht,st);re+=this.renderer.list(Ce,$e,je);continue}case"html":{re+=this.renderer.html(ke.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ce=ke.tokens?this.parseInline(ke.tokens):ke.text;O+1<ce&&ee[O+1].type==="text";)ke=ee[++O],Ce+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);re+=le?this.renderer.paragraph(Ce):Ce;continue}default:{var B='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return re},ae.parseInline=function(ee,le){le=le||this.renderer;var re="",O,W,G,Q=ee.length;for(O=0;O<Q;O++){if(W=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(G=this.options.extensions.renderers[W.type].call({parser:this},W),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){re+=G||"";continue}switch(W.type){case"escape":{re+=le.text(W.text);break}case"html":{re+=le.html(W.text);break}case"link":{re+=le.link(W.href,W.title,this.parseInline(W.tokens,le));break}case"image":{re+=le.image(W.href,W.title,W.text);break}case"strong":{re+=le.strong(this.parseInline(W.tokens,le));break}case"em":{re+=le.em(this.parseInline(W.tokens,le));break}case"codespan":{re+=le.codespan(W.text);break}case"br":{re+=le.br();break}case"del":{re+=le.del(this.parseInline(W.tokens,le));break}case"text":{re+=le.text(W.text);break}default:{var he='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return re},oe}();function Z(oe,ae,fe){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof ae=="function"&&(fe=ae,ae=null),ae=n({},Z.defaults,ae||{}),y(ae),fe){var ee=ae.highlight,le;try{le=H.lex(oe,ae)}catch(Q){return fe(Q)}var re=function(he){var Ee;if(!he)try{ae.walkTokens&&Z.walkTokens(le,ae.walkTokens),Ee=X.parse(le,ae)}catch(Pe){he=Pe}return ae.highlight=ee,he?fe(he):fe(null,Ee)};if(!ee||ee.length<3||(delete ae.highlight,!le.length))return re();var O=0;Z.walkTokens(le,function(Q){Q.type==="code"&&(O++,setTimeout(function(){ee(Q.text,Q.lang,function(he,Ee){if(he)return re(he);Ee!=null&&Ee!==Q.text&&(Q.text=Ee,Q.escaped=!0),O--,O===0&&re()})},0))}),O===0&&re();return}function W(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(Q.message+"",!0)+"</pre>";throw Q}try{var G=H.lex(oe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(Z.walkTokens(G,ae.walkTokens)).then(function(){return X.parse(G,ae)}).catch(W);Z.walkTokens(G,ae.walkTokens)}return X.parse(G,ae)}catch(Q){W(Q)}}Z.options=Z.setOptions=function(oe){return n(Z.defaults,oe),T(Z.defaults),Z},Z.getDefaults=_,Z.defaults=ie.defaults,Z.use=function(){for(var oe=arguments.length,ae=new Array(oe),fe=0;fe<oe;fe++)ae[fe]=arguments[fe];var ee=n.apply(void 0,[{}].concat(ae)),le=Z.defaults.extensions||{renderers:{},childTokens:{}},re;ae.forEach(function(O){if(O.extensions&&(re=!0,O.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var Q=le.renderers?le.renderers[G.name]:null;Q?le.renderers[G.name]=function(){for(var he=arguments.length,Ee=new Array(he),Pe=0;Pe<he;Pe++)Ee[Pe]=arguments[Pe];var ve=G.renderer.apply(this,Ee);return ve===!1&&(ve=Q.apply(this,Ee)),ve}:le.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[G.level]?le[G.level].unshift(G.tokenizer):le[G.level]=[G.tokenizer],G.start&&(G.level==="block"?le.startBlock?le.startBlock.push(G.start):le.startBlock=[G.start]:G.level==="inline"&&(le.startInline?le.startInline.push(G.start):le.startInline=[G.start]))}G.childTokens&&(le.childTokens[G.name]=G.childTokens)})),O.renderer&&function(){var G=Z.defaults.renderer||new de,Q=function(Pe){var ve=G[Pe];G[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),$e=0;$e<Ce;$e++)ke[$e]=arguments[$e];var je=O.renderer[Pe].apply(G,ke);return je===!1&&(je=ve.apply(G,ke)),je}};for(var he in O.renderer)Q(he);ee.renderer=G}(),O.tokenizer&&function(){var G=Z.defaults.tokenizer||new N,Q=function(Pe){var ve=G[Pe];G[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),$e=0;$e<Ce;$e++)ke[$e]=arguments[$e];var je=O.tokenizer[Pe].apply(G,ke);return je===!1&&(je=ve.apply(G,ke)),je}};for(var he in O.tokenizer)Q(he);ee.tokenizer=G}(),O.walkTokens){var W=Z.defaults.walkTokens;ee.walkTokens=function(G){var Q=[];return Q.push(O.walkTokens.call(this,G)),W&&(Q=Q.concat(W.call(this,G))),Q}}re&&(ee.extensions=le),Z.setOptions(ee)})},Z.walkTokens=function(oe,ae){for(var fe=[],ee=function(){var W=re.value;switch(fe=fe.concat(ae.call(Z,W)),W.type){case"table":{for(var G=A(W.header),Q;!(Q=G()).done;){var he=Q.value;fe=fe.concat(Z.walkTokens(he.tokens,ae))}for(var Ee=A(W.rows),Pe;!(Pe=Ee()).done;)for(var ve=Pe.value,Ce=A(ve),ke;!(ke=Ce()).done;){var $e=ke.value;fe=fe.concat(Z.walkTokens($e.tokens,ae))}break}case"list":{fe=fe.concat(Z.walkTokens(W.items,ae));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[W.type]?Z.defaults.extensions.childTokens[W.type].forEach(function(je){fe=fe.concat(Z.walkTokens(W[je],ae))}):W.tokens&&(fe=fe.concat(Z.walkTokens(W.tokens,ae)))}},le=A(oe),re;!(re=le()).done;)ee();return fe},Z.parseInline=function(oe,ae){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");ae=n({},Z.defaults,ae||{}),y(ae);try{var fe=H.lexInline(oe,ae);return ae.walkTokens&&Z.walkTokens(fe,ae.walkTokens),X.parseInline(fe,ae)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(ee.message+"",!0)+"</pre>";throw ee}},Z.Parser=X,Z.parser=X.parse,Z.Renderer=de,Z.TextRenderer=Y,Z.Lexer=H,Z.lexer=H.lex,Z.Tokenizer=N,Z.Slugger=V,Z.parse=Z;var te=Z.options,K=Z.setOptions,J=Z.use,ne=Z.walkTokens,pe=Z.parseInline,be=Z,Ie=X.parse,Le=H.lex;ie.Lexer=H,ie.Parser=X,ie.Renderer=de,ie.Slugger=V,ie.TextRenderer=Y,ie.Tokenizer=N,ie.getDefaults=_,ie.lexer=Le,ie.marked=Z,ie.options=te,ie.parse=be,ie.parseInline=pe,ie.parser=Ie,ie.setOptions=K,ie.use=J,ie.walkTokens=ne,Object.defineProperty(ie,"__esModule",{value:!0})}),define(_e[86],ye([1,0,28]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const P=new a.LRUCache(1e4);function u(D){return S(D,"NFC",P)}e.normalizeNFC=u;const A=new a.LRUCache(1e4);function _(D){return S(D,"NFD",A)}e.normalizeNFD=_;const T=/[^\u0000-\u0080]/;function S(D,R,I){if(!D)return D;const b=I.get(D);if(b)return b;let k;return T.test(D)?k=D.normalize(R):k=D,I.set(D,k),k}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(R){return _(R).replace(D,"")}}()}),define(_e[102],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(T,S,D){return Math.min(Math.max(T,S),D)}e.clamp=a;function P(T,S){return(S+T%S)%S}e.rot=P;class u{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=u;class A{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class _{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const D=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=D,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ie(u){const A=[];typeof u=="number"&&A.push("code/timeOrigin",u);function _(S){A.push(S,Date.now())}function T(){const S=[];for(let D=0;D<A.length;D+=2)S.push({name:A[D],startTime:A[D+1]});return S}return{mark:_,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(u){performance.mark(u)},getMarks(){let u=performance.timeOrigin;typeof u!="number"&&(u=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(u)}];for(const _ of performance.getEntriesByType("mark"))A.push({name:_.name,startTime:Math.round(u+_.startTime)});return A}};if(typeof process=="object"){const u=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(u)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function a(u){return u.MonacoPerformanceMarks||(u.MonacoPerformanceMarks=e()),u.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=a(P))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var P in a)(typeof exports=="object"?exports:ie)[P]=a[P]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function a(P){if(e[P])return e[P].exports;var u=e[P]={i:P,l:!1,exports:{}};return ie[P].call(u.exports,u,u.exports,a),u.l=!0,u.exports}return a.m=ie,a.c=e,a.d=function(P,u,A){a.o(P,u)||Object.defineProperty(P,u,{enumerable:!0,get:A})},a.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},a.t=function(P,u){if(1&u&&(P=a(P)),8&u||4&u&&typeof P=="object"&&P&&P.__esModule)return P;var A=Object.create(null);if(a.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:P}),2&u&&typeof P!="string")for(var _ in P)a.d(A,_,function(T){return P[T]}.bind(null,_));return A},a.n=function(P){var u=P&&P.__esModule?function(){return P.default}:function(){return P};return a.d(u,"a",u),u},a.o=function(P,u){return Object.prototype.hasOwnProperty.call(P,u)},a.p="",a(a.s=0)}([function(ie,e,a){(function(P){var u;e=ie.exports=J,u=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var ve=Array.prototype.slice.call(arguments,0);ve.unshift("SEMVER"),console.log.apply(console,ve)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],D=0,R=D++;S[R]="0|[1-9]\\d*";var I=D++;S[I]="[0-9]+";var b=D++;S[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=D++;S[k]="("+S[R]+")\\.("+S[R]+")\\.("+S[R]+")";var w=D++;S[w]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var f=D++;S[f]="(?:"+S[R]+"|"+S[b]+")";var d=D++;S[d]="(?:"+S[I]+"|"+S[b]+")";var h=D++;S[h]="(?:-("+S[f]+"(?:\\."+S[f]+")*))";var g=D++;S[g]="(?:-?("+S[d]+"(?:\\."+S[d]+")*))";var v=D++;S[v]="[0-9A-Za-z-]+";var C=D++;S[C]="(?:\\+("+S[v]+"(?:\\."+S[v]+")*))";var p=D++,i="v?"+S[k]+S[h]+"?"+S[C]+"?";S[p]="^"+i+"$";var o="[v=\\s]*"+S[w]+S[g]+"?"+S[C]+"?",s=D++;S[s]="^"+o+"$";var l=D++;S[l]="((?:<|>)?=?)";var r=D++;S[r]=S[I]+"|x|X|\\*";var m=D++;S[m]=S[R]+"|x|X|\\*";var n=D++;S[n]="[v=\\s]*("+S[m]+")(?:\\.("+S[m]+")(?:\\.("+S[m]+")(?:"+S[h]+")?"+S[C]+"?)?)?";var t=D++;S[t]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[g]+")?"+S[C]+"?)?)?";var c=D++;S[c]="^"+S[l]+"\\s*"+S[n]+"$";var E=D++;S[E]="^"+S[l]+"\\s*"+S[t]+"$";var y=D++;S[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=D++;S[M]="(?:~>?)";var j=D++;S[j]="(\\s*)"+S[M]+"\\s+",T[j]=new RegExp(S[j],"g");var $=D++;S[$]="^"+S[M]+S[n]+"$";var N=D++;S[N]="^"+S[M]+S[t]+"$";var x=D++;S[x]="(?:\\^)";var L=D++;S[L]="(\\s*)"+S[x]+"\\s+",T[L]=new RegExp(S[L],"g");var F=D++;S[F]="^"+S[x]+S[n]+"$";var U=D++;S[U]="^"+S[x]+S[t]+"$";var H=D++;S[H]="^"+S[l]+"\\s*("+o+")$|^$";var de=D++;S[de]="^"+S[l]+"\\s*("+i+")$|^$";var Y=D++;S[Y]="(\\s*)"+S[l]+"\\s*("+o+"|"+S[n]+")",T[Y]=new RegExp(S[Y],"g");var V=D++;S[V]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var X=D++;S[X]="^\\s*("+S[t]+")\\s+-\\s+("+S[t]+")\\s*$";var Z=D++;S[Z]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)u(te,S[te]),T[te]||(T[te]=new RegExp(S[te]));function K(ve,Ce){if(ve instanceof J)return ve;if(typeof ve!="string"||ve.length>A||!(Ce?T[s]:T[p]).test(ve))return null;try{return new J(ve,Ce)}catch{return null}}function J(ve,Ce){if(ve instanceof J){if(ve.loose===Ce)return ve;ve=ve.version}else if(typeof ve!="string")throw new TypeError("Invalid Version: "+ve);if(ve.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof J))return new J(ve,Ce);u("SemVer",ve,Ce),this.loose=Ce;var ke=ve.trim().match(Ce?T[s]:T[p]);if(!ke)throw new TypeError("Invalid Version: "+ve);if(this.raw=ve,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var je=+$e;if(je>=0&&je<_)return je}return $e}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=K,e.valid=function(ve,Ce){var ke=K(ve,Ce);return ke?ke.version:null},e.clean=function(ve,Ce){var ke=K(ve.trim().replace(/^[=v]+/,""),Ce);return ke?ke.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(ve){return u("SemVer.compare",this.version,this.loose,ve),ve instanceof J||(ve=new J(ve,this.loose)),this.compareMain(ve)||this.comparePre(ve)},J.prototype.compareMain=function(ve){return ve instanceof J||(ve=new J(ve,this.loose)),pe(this.major,ve.major)||pe(this.minor,ve.minor)||pe(this.patch,ve.patch)},J.prototype.comparePre=function(ve){if(ve instanceof J||(ve=new J(ve,this.loose)),this.prerelease.length&&!ve.prerelease.length)return-1;if(!this.prerelease.length&&ve.prerelease.length)return 1;if(!this.prerelease.length&&!ve.prerelease.length)return 0;var Ce=0;do{var ke=this.prerelease[Ce],$e=ve.prerelease[Ce];if(u("prerelease compare",Ce,ke,$e),ke===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ke===void 0)return-1;if(ke!==$e)return pe(ke,$e)}while(++Ce)},J.prototype.inc=function(ve,Ce){switch(ve){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ve)}return this.format(),this.raw=this.version,this},e.inc=function(ve,Ce,ke,$e){typeof ke=="string"&&($e=ke,ke=void 0);try{return new J(ve,ke).inc(Ce,$e).version}catch{return null}},e.diff=function(ve,Ce){if(oe(ve,Ce))return null;var ke=K(ve),$e=K(Ce);if(ke.prerelease.length||$e.prerelease.length){for(var je in ke)if((je==="major"||je==="minor"||je==="patch")&&ke[je]!==$e[je])return"pre"+je;return"prerelease"}for(var je in ke)if((je==="major"||je==="minor"||je==="patch")&&ke[je]!==$e[je])return je},e.compareIdentifiers=pe;var ne=/^[0-9]+$/;function pe(ve,Ce){var ke=ne.test(ve),$e=ne.test(Ce);return ke&&$e&&(ve=+ve,Ce=+Ce),ke&&!$e?-1:$e&&!ke?1:ve<Ce?-1:ve>Ce?1:0}function be(ve,Ce,ke){return new J(ve,ke).compare(new J(Ce,ke))}function Ie(ve,Ce,ke){return be(ve,Ce,ke)>0}function Le(ve,Ce,ke){return be(ve,Ce,ke)<0}function oe(ve,Ce,ke){return be(ve,Ce,ke)===0}function ae(ve,Ce,ke){return be(ve,Ce,ke)!==0}function fe(ve,Ce,ke){return be(ve,Ce,ke)>=0}function ee(ve,Ce,ke){return be(ve,Ce,ke)<=0}function le(ve,Ce,ke,$e){var je;switch(Ce){case"===":typeof ve=="object"&&(ve=ve.version),typeof ke=="object"&&(ke=ke.version),je=ve===ke;break;case"!==":typeof ve=="object"&&(ve=ve.version),typeof ke=="object"&&(ke=ke.version),je=ve!==ke;break;case"":case"=":case"==":je=oe(ve,ke,$e);break;case"!=":je=ae(ve,ke,$e);break;case">":je=Ie(ve,ke,$e);break;case">=":je=fe(ve,ke,$e);break;case"<":je=Le(ve,ke,$e);break;case"<=":je=ee(ve,ke,$e);break;default:throw new TypeError("Invalid operator: "+Ce)}return je}function re(ve,Ce){if(ve instanceof re){if(ve.loose===Ce)return ve;ve=ve.value}if(!(this instanceof re))return new re(ve,Ce);u("comparator",ve,Ce),this.loose=Ce,this.parse(ve),this.semver===O?this.value="":this.value=this.operator+this.semver.version,u("comp",this)}e.rcompareIdentifiers=function(ve,Ce){return pe(Ce,ve)},e.major=function(ve,Ce){return new J(ve,Ce).major},e.minor=function(ve,Ce){return new J(ve,Ce).minor},e.patch=function(ve,Ce){return new J(ve,Ce).patch},e.compare=be,e.compareLoose=function(ve,Ce){return be(ve,Ce,!0)},e.rcompare=function(ve,Ce,ke){return be(Ce,ve,ke)},e.sort=function(ve,Ce){return ve.sort(function(ke,$e){return e.compare(ke,$e,Ce)})},e.rsort=function(ve,Ce){return ve.sort(function(ke,$e){return e.rcompare(ke,$e,Ce)})},e.gt=Ie,e.lt=Le,e.eq=oe,e.neq=ae,e.gte=fe,e.lte=ee,e.cmp=le,e.Comparator=re;var O={};function W(ve,Ce){if(ve instanceof W)return ve.loose===Ce?ve:new W(ve.raw,Ce);if(ve instanceof re)return new W(ve.value,Ce);if(!(this instanceof W))return new W(ve,Ce);if(this.loose=Ce,this.raw=ve,this.set=ve.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ve);this.format()}function G(ve){return!ve||ve.toLowerCase()==="x"||ve==="*"}function Q(ve,Ce,ke,$e,je,et,Xe,nt,st,ht,Fe,rt,ce){return((Ce=G(ke)?"":G($e)?">="+ke+".0.0":G(je)?">="+ke+"."+$e+".0":">="+Ce)+" "+(nt=G(st)?"":G(ht)?"<"+(+st+1)+".0.0":G(Fe)?"<"+st+"."+(+ht+1)+".0":rt?"<="+st+"."+ht+"."+Fe+"-"+rt:"<="+nt)).trim()}function he(ve,Ce){for(var ke=0;ke<ve.length;ke++)if(!ve[ke].test(Ce))return!1;if(Ce.prerelease.length){for(ke=0;ke<ve.length;ke++)if(u(ve[ke].semver),ve[ke].semver!==O&&ve[ke].semver.prerelease.length>0){var $e=ve[ke].semver;if($e.major===Ce.major&&$e.minor===Ce.minor&&$e.patch===Ce.patch)return!0}return!1}return!0}function Ee(ve,Ce,ke){try{Ce=new W(Ce,ke)}catch{return!1}return Ce.test(ve)}function Pe(ve,Ce,ke,$e){var je,et,Xe,nt,st;switch(ve=new J(ve,$e),Ce=new W(Ce,$e),ke){case">":je=Ie,et=ee,Xe=Le,nt=">",st=">=";break;case"<":je=Le,et=fe,Xe=Ie,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(ve,Ce,$e))return!1;for(var ht=0;ht<Ce.set.length;++ht){var Fe=Ce.set[ht],rt=null,ce=null;if(Fe.forEach(function(B){B.semver===O&&(B=new re(">=0.0.0")),rt=rt||B,ce=ce||B,je(B.semver,rt.semver,$e)?rt=B:Xe(B.semver,ce.semver,$e)&&(ce=B)}),rt.operator===nt||rt.operator===st||(!ce.operator||ce.operator===nt)&&et(ve,ce.semver)||ce.operator===st&&Xe(ve,ce.semver))return!1}return!0}re.prototype.parse=function(ve){var Ce=this.loose?T[H]:T[de],ke=ve.match(Ce);if(!ke)throw new TypeError("Invalid comparator: "+ve);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new J(ke[2],this.loose):this.semver=O},re.prototype.toString=function(){return this.value},re.prototype.test=function(ve){return u("Comparator.test",ve,this.loose),this.semver===O||(typeof ve=="string"&&(ve=new J(ve,this.loose)),le(ve,this.operator,this.semver,this.loose))},re.prototype.intersects=function(ve,Ce){if(!(ve instanceof re))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new W(ve.value,Ce),Ee(this.value,ke,Ce);if(ve.operator==="")return ke=new W(this.value,Ce),Ee(ve.semver,ke,Ce);var $e=!(this.operator!==">="&&this.operator!==">"||ve.operator!==">="&&ve.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||ve.operator!=="<="&&ve.operator!=="<"),et=this.semver.version===ve.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ve.operator!==">="&&ve.operator!=="<="),nt=le(this.semver,"<",ve.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ve.operator==="<="||ve.operator==="<"),st=le(this.semver,">",ve.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ve.operator===">="||ve.operator===">");return $e||je||et&&Xe||nt||st},e.Range=W,W.prototype.format=function(){return this.range=this.set.map(function(ve){return ve.join(" ").trim()}).join("||").trim(),this.range},W.prototype.toString=function(){return this.range},W.prototype.parseRange=function(ve){var Ce=this.loose;ve=ve.trim(),u("range",ve,Ce);var ke=Ce?T[X]:T[V];ve=ve.replace(ke,Q),u("hyphen replace",ve),ve=ve.replace(T[Y],"$1$2$3"),u("comparator trim",ve,T[Y]),ve=(ve=(ve=ve.replace(T[j],"$1~")).replace(T[L],"$1^")).split(/\s+/).join(" ");var $e=Ce?T[H]:T[de],je=ve.split(" ").map(function(et){return function(Xe,nt){return u("comp",Xe),Xe=function(st,ht){return st.trim().split(/\s+/).map(function(Fe){return function(rt,ce){u("caret",rt,ce);var B=ce?T[U]:T[F];return rt.replace(B,function(ue,De,Re,xe,Ge){var Ze;return u("caret",rt,ue,De,Re,xe,Ge),G(De)?Ze="":G(Re)?Ze=">="+De+".0.0 <"+(+De+1)+".0.0":G(xe)?Ze=De==="0"?">="+De+"."+Re+".0 <"+De+"."+(+Re+1)+".0":">="+De+"."+Re+".0 <"+(+De+1)+".0.0":Ge?(u("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=De==="0"?Re==="0"?">="+De+"."+Re+"."+xe+Ge+" <"+De+"."+Re+"."+(+xe+1):">="+De+"."+Re+"."+xe+Ge+" <"+De+"."+(+Re+1)+".0":">="+De+"."+Re+"."+xe+Ge+" <"+(+De+1)+".0.0"):(u("no pr"),Ze=De==="0"?Re==="0"?">="+De+"."+Re+"."+xe+" <"+De+"."+Re+"."+(+xe+1):">="+De+"."+Re+"."+xe+" <"+De+"."+(+Re+1)+".0":">="+De+"."+Re+"."+xe+" <"+(+De+1)+".0.0"),u("caret return",Ze),Ze})}(Fe,ht)}).join(" ")}(Xe,nt),u("caret",Xe),Xe=function(st,ht){return st.trim().split(/\s+/).map(function(Fe){return function(rt,ce){var B=ce?T[N]:T[$];return rt.replace(B,function(ue,De,Re,xe,Ge){var Ze;return u("tilde",rt,ue,De,Re,xe,Ge),G(De)?Ze="":G(Re)?Ze=">="+De+".0.0 <"+(+De+1)+".0.0":G(xe)?Ze=">="+De+"."+Re+".0 <"+De+"."+(+Re+1)+".0":Ge?(u("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=">="+De+"."+Re+"."+xe+Ge+" <"+De+"."+(+Re+1)+".0"):Ze=">="+De+"."+Re+"."+xe+" <"+De+"."+(+Re+1)+".0",u("tilde return",Ze),Ze})}(Fe,ht)}).join(" ")}(Xe,nt),u("tildes",Xe),Xe=function(st,ht){return u("replaceXRanges",st,ht),st.split(/\s+/).map(function(Fe){return function(rt,ce){rt=rt.trim();var B=ce?T[E]:T[c];return rt.replace(B,function(ue,De,Re,xe,Ge,Ze){u("xRange",rt,ue,De,Re,xe,Ge,Ze);var pt=G(Re),gt=pt||G(xe),ct=gt||G(Ge);return De==="="&&ct&&(De=""),pt?ue=De===">"||De==="<"?"<0.0.0":"*":De&&ct?(gt&&(xe=0),ct&&(Ge=0),De===">"?(De=">=",gt?(Re=+Re+1,xe=0,Ge=0):ct&&(xe=+xe+1,Ge=0)):De==="<="&&(De="<",gt?Re=+Re+1:xe=+xe+1),ue=De+Re+"."+xe+"."+Ge):gt?ue=">="+Re+".0.0 <"+(+Re+1)+".0.0":ct&&(ue=">="+Re+"."+xe+".0 <"+Re+"."+(+xe+1)+".0"),u("xRange return",ue),ue})}(Fe,ht)}).join(" ")}(Xe,nt),u("xrange",Xe),Xe=function(st,ht){return u("replaceStars",st,ht),st.trim().replace(T[Z],"")}(Xe,nt),u("stars",Xe),Xe}(et,Ce)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(et){return!!et.match($e)})),je=je.map(function(et){return new re(et,Ce)})},W.prototype.intersects=function(ve,Ce){if(!(ve instanceof W))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function($e){return ve.set.some(function(je){return je.every(function(et){return $e.intersects(et,Ce)})})})})},e.toComparators=function(ve,Ce){return new W(ve,Ce).set.map(function(ke){return ke.map(function($e){return $e.value}).join(" ").trim().split(" ")})},W.prototype.test=function(ve){if(!ve)return!1;typeof ve=="string"&&(ve=new J(ve,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(he(this.set[Ce],ve))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(ve,Ce,ke){var $e=null,je=null;try{var et=new W(Ce,ke)}catch{return null}return ve.forEach(function(Xe){et.test(Xe)&&($e&&je.compare(Xe)!==-1||(je=new J($e=Xe,ke)))}),$e},e.minSatisfying=function(ve,Ce,ke){var $e=null,je=null;try{var et=new W(Ce,ke)}catch{return null}return ve.forEach(function(Xe){et.test(Xe)&&($e&&je.compare(Xe)!==1||(je=new J($e=Xe,ke)))}),$e},e.validRange=function(ve,Ce){try{return new W(ve,Ce).range||"*"}catch{return null}},e.ltr=function(ve,Ce,ke){return Pe(ve,Ce,"<",ke)},e.gtr=function(ve,Ce,ke){return Pe(ve,Ce,">",ke)},e.outside=Pe,e.prerelease=function(ve,Ce){var ke=K(ve,Ce);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(ve,Ce,ke){return ve=new W(ve,ke),Ce=new W(Ce,ke),ve.intersects(Ce)},e.coerce=function(ve){if(ve instanceof J)return ve;if(typeof ve!="string")return null;var Ce=ve.match(T[y]);return Ce==null?null:K((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,a(1))},function(ie,e){var a,P,u=ie.exports={};function A(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function T(d){if(a===setTimeout)return setTimeout(d,0);if((a===A||!a)&&setTimeout)return a=setTimeout,setTimeout(d,0);try{return a(d,0)}catch{try{return a.call(null,d,0)}catch{return a.call(this,d,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:A}catch{a=A}try{P=typeof clearTimeout=="function"?clearTimeout:_}catch{P=_}})();var S,D=[],R=!1,I=-1;function b(){R&&S&&(R=!1,S.length?D=S.concat(D):I=-1,D.length&&k())}function k(){if(!R){var d=T(b);R=!0;for(var h=D.length;h;){for(S=D,D=[];++I<h;)S&&S[I].run();I=-1,h=D.length}S=null,R=!1,function(g){if(P===clearTimeout)return clearTimeout(g);if((P===_||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(g);try{P(g)}catch{try{return P.call(null,g)}catch{return P.call(this,g)}}}(d)}}function w(d,h){this.fun=d,this.array=h}function f(){}u.nextTick=function(d){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];D.push(new w(d,h)),D.length!==1||R||T(k)},w.prototype.run=function(){this.fun.apply(null,this.array)},u.title="browser",u.browser=!0,u.env={},u.argv=[],u.version="",u.versions={},u.on=f,u.addListener=f,u.once=f,u.off=f,u.removeListener=f,u.removeAllListeners=f,u.emit=f,u.prependListener=f,u.prependOnceListener=f,u.listeners=function(d){return[]},u.binding=function(d){throw new Error("process.binding is not supported")},u.cwd=function(){return"/"},u.chdir=function(d){throw new Error("process.chdir is not supported")},u.umask=function(){return 0}}])}),define(_e[103],ye([1,0,11,6]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function u(C){const p=C;return p?typeof p.read=="function":!1}e.isReadable=u;function A(C){const p=C;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=A;function _(C){const p=C;return p?A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=_;function T(C,p){return new S(C,p)}e.newWriteableStream=T;class S{constructor(p,i){this.reducer=p,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(i=>i(p))}emitError(p){this.listeners.error.length===0?(0,a.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(i=>i(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,i){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(p,i){if(this.state.destroyed)return;let o;switch(p){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const s=o.indexOf(i);s>=0&&o.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(C,p){const i=[];let o;for(;(o=C.read())!==null;)i.push(o);return p(i)}e.consumeReadable=D;function R(C,p,i){const o=[];let s;for(;(s=C.read())!==null&&o.length<i;)o.push(s);return s===null&&o.length>0?p(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const l=s;return s=void 0,l}return C.read()}}}e.peekReadable=R;function I(C,p){return new Promise((i,o)=>{const s=[];b(C,{onData:l=>{p&&s.push(l)},onError:l=>{p?o(l):i(void 0)},onEnd:()=>{i(p?p(s):void 0)}})})}e.consumeStream=I;function b(C,p){let i=!1;return C.on("error",o=>{i||p.onError(o)}),C.on("end",()=>{i||p.onEnd()}),C.on("data",o=>{i||p.onData(o)}),(0,P.toDisposable)(()=>i=!0)}e.listenStream=b;function k(C,p){return new Promise((i,o)=>{const s=new P.DisposableStore,l=[],r=t=>{if(l.push(t),l.length>p)return s.dispose(),C.pause(),i({stream:C,buffer:l,ended:!1})},m=t=>o(t),n=()=>i({stream:C,buffer:l,ended:!0});s.add((0,P.toDisposable)(()=>C.removeListener("error",m))),C.on("error",m),s.add((0,P.toDisposable)(()=>C.removeListener("end",n))),C.on("end",n),s.add((0,P.toDisposable)(()=>C.removeListener("data",r))),C.on("data",r)})}e.peekStream=k;function w(C,p){const i=T(p);return i.end(C),i}e.toStream=w;function f(){const C=T(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=f;function d(C){let p=!1;return{read:()=>p?null:(p=!0,C)}}e.toReadable=d;function h(C,p,i){const o=T(i);return b(C,{onData:s=>o.write(p.data(s)),onError:s=>o.error(p.error?p.error(s):s),onEnd:()=>o.end()}),o}e.transform=h;function g(C,p,i){let o=!1;return{read:()=>{const s=p.read();return o?s:(o=!0,s!==null?i([C,s]):C)}}}e.prefixedReadable=g;function v(C,p,i){let o=!1;const s=T(i);return b(p,{onData:l=>o?s.write(l):(o=!0,s.write(i([C,l]))),onError:l=>s.error(l),onEnd:()=>{o||(o=!0,s.write(C)),s.end()}}),s}e.prefixedStream=v}),define(_e[22],ye([1,0,103]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer<"u";let u,A;class _{static alloc(t){return P?new _(Buffer.allocUnsafe(t)):new _(new Uint8Array(t))}static wrap(t){return P&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new _(t)}static fromString(t,c){return!(c?.dontUseNodeBuffer||!1)&&P?new _(Buffer.from(t)):(u||(u=new TextEncoder),new _(u.encode(t)))}static fromByteArray(t){const c=_.alloc(t.length);for(let E=0,y=t.length;E<y;E++)c.buffer[E]=t[E];return c}static concat(t,c){if(typeof c>"u"){c=0;for(let M=0,j=t.length;M<j;M++)c+=t[M].byteLength}const E=_.alloc(c);let y=0;for(let M=0,j=t.length;M<j;M++){const $=t[M];E.set($,y),y+=$.byteLength}return E}constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}clone(){const t=_.alloc(this.byteLength);return t.set(this),t}toString(){return P?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(t,c){return new _(this.buffer.subarray(t,c))}set(t,c){if(t instanceof _)this.buffer.set(t.buffer,c);else if(t instanceof Uint8Array)this.buffer.set(t,c);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),c);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),c);else throw new Error("Unknown argument 'array'")}readUInt32BE(t){return D(this.buffer,t)}writeUInt32BE(t,c){R(this.buffer,t,c)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,c){b(this.buffer,t,c)}readUInt8(t){return k(this.buffer,t)}writeUInt8(t,c){w(this.buffer,t,c)}}e.VSBuffer=_;function T(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=T;function S(n,t,c){n[c+0]=t&255,t=t>>>8,n[c+1]=t&255}e.writeUInt16LE=S;function D(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=D;function R(n,t,c){n[c+3]=t,t=t>>>8,n[c+2]=t,t=t>>>8,n[c+1]=t,t=t>>>8,n[c]=t}e.writeUInt32BE=R;function I(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=I;function b(n,t,c){n[c+0]=t&255,t=t>>>8,n[c+1]=t&255,t=t>>>8,n[c+2]=t&255,t=t>>>8,n[c+3]=t&255}e.writeUInt32LE=b;function k(n,t){return n[t]}e.readUInt8=k;function w(n,t,c){n[c]=t}e.writeUInt8=w;function f(n){return a.consumeReadable(n,t=>_.concat(t))}e.readableToBuffer=f;function d(n){return a.toReadable(n)}e.bufferToReadable=d;function h(n){return a.consumeStream(n,t=>_.concat(t))}e.streamToBuffer=h;async function g(n){return n.ended?_.concat(n.buffer):_.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=g;function v(n){return a.toStream(n,t=>_.concat(t))}e.bufferToStream=v;function C(n){return a.transform(n,{data:t=>typeof t=="string"?_.fromString(t):_.wrap(t)},t=>_.concat(t))}e.streamToBufferReadableStream=C;function p(n){return a.newWriteableStream(t=>_.concat(t),n)}e.newWriteableBufferStream=p;function i(n,t){return a.prefixedReadable(n,t,c=>_.concat(c))}e.prefixedBufferReadable=i;function o(n,t){return a.prefixedStream(n,t,c=>_.concat(c))}e.prefixedBufferStream=o;function s(n){let t=0,c=0,E=0;const y=new Uint8Array(Math.floor(n.length/4*3)),M=$=>{switch(c){case 3:y[E++]=t|$,c=0;break;case 2:y[E++]=t|$>>>2,t=$<<6,c=3;break;case 1:y[E++]=t|$>>>4,t=$<<4,c=2;break;default:t=$<<2,c=1}};for(let $=0;$<n.length;$++){const N=n.charCodeAt($);if(N>=65&&N<=90)M(N-65);else if(N>=97&&N<=122)M(N-97+26);else if(N>=48&&N<=57)M(N-48+52);else if(N===43||N===45)M(62);else if(N===47||N===95)M(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${n[$]}`)}}const j=E;for(;c>0;)M(0);return _.wrap(y).slice(0,j)}e.decodeBase64=s;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:n},t=!0,c=!1){const E=c?r:l;let y="";const M=n.byteLength%3;let j=0;for(;j<n.byteLength-M;j+=3){const $=n[j+0],N=n[j+1],x=n[j+2];y+=E[$>>>2],y+=E[($<<4|N>>>4)&63],y+=E[(N<<2|x>>>6)&63],y+=E[x&63]}if(M===1){const $=n[j+0];y+=E[$>>>2],y+=E[$<<4&63],t&&(y+="==")}else if(M===2){const $=n[j+0],N=n[j+1];y+=E[$>>>2],y+=E[($<<4|N>>>4)&63],y+=E[N<<2&63],t&&(y+="=")}return y}e.encodeBase64=m}),define(_e[148],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(_e[9],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(o){return typeof o=="string"}e.isString=a;function P(o){return Array.isArray(o)&&o.every(s=>a(s))}e.isStringArray=P;function u(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=u;function A(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}e.isTypedArray=A;function _(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=_;function T(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=T;function S(o){return o===!0||o===!1}e.isBoolean=S;function D(o){return typeof o>"u"}e.isUndefined=D;function R(o){return!I(o)}e.isDefined=R;function I(o){return D(o)||o===null}e.isUndefinedOrNull=I;function b(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=b;function k(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=k;function w(...o){const s=[];for(let l=0;l<o.length;l++){const r=o[l];if(I(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);s.push(r)}return s}e.assertAllDefined=w;const f=Object.prototype.hasOwnProperty;function d(o){if(!u(o))return!1;for(const s in o)if(f.call(o,s))return!1;return!0}e.isEmptyObject=d;function h(o){return typeof o=="function"}e.isFunction=h;function g(...o){return o.length>0&&o.every(h)}e.areFunctions=g;function v(o,s){const l=Math.min(o.length,s.length);for(let r=0;r<l;r++)C(o[r],s[r])}e.validateConstraints=v;function C(o,s){if(a(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(h(s)){try{if(o instanceof s)return}catch{}if(!I(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=C;function p(o){return o===null?void 0:o}e.withNullAsUndefined=p;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(_e[67],ye([1,0,9]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const P=Object.create(null);function u(T,S){if((0,a.isString)(S)){const D=P[S];if(D===void 0)throw new Error(`${T} references an unknown codicon: ${S}`);S=D}return P[T]=S,{id:T}}function A(){return P}e.getCodiconFontCharacters=A;function _(){return Object.values(e.Codicon)}e.getAllCodicons=_,e.Codicon={add:u("add",6e4),plus:u("plus",6e4),gistNew:u("gist-new",6e4),repoCreate:u("repo-create",6e4),lightbulb:u("lightbulb",60001),lightBulb:u("light-bulb",60001),repo:u("repo",60002),repoDelete:u("repo-delete",60002),gistFork:u("gist-fork",60003),repoForked:u("repo-forked",60003),gitPullRequest:u("git-pull-request",60004),gitPullRequestAbandoned:u("git-pull-request-abandoned",60004),recordKeys:u("record-keys",60005),keyboard:u("keyboard",60005),tag:u("tag",60006),tagAdd:u("tag-add",60006),tagRemove:u("tag-remove",60006),person:u("person",60007),personFollow:u("person-follow",60007),personOutline:u("person-outline",60007),personFilled:u("person-filled",60007),gitBranch:u("git-branch",60008),gitBranchCreate:u("git-branch-create",60008),gitBranchDelete:u("git-branch-delete",60008),sourceControl:u("source-control",60008),mirror:u("mirror",60009),mirrorPublic:u("mirror-public",60009),star:u("star",60010),starAdd:u("star-add",60010),starDelete:u("star-delete",60010),starEmpty:u("star-empty",60010),comment:u("comment",60011),commentAdd:u("comment-add",60011),alert:u("alert",60012),warning:u("warning",60012),search:u("search",60013),searchSave:u("search-save",60013),logOut:u("log-out",60014),signOut:u("sign-out",60014),logIn:u("log-in",60015),signIn:u("sign-in",60015),eye:u("eye",60016),eyeUnwatch:u("eye-unwatch",60016),eyeWatch:u("eye-watch",60016),circleFilled:u("circle-filled",60017),primitiveDot:u("primitive-dot",60017),closeDirty:u("close-dirty",60017),debugBreakpoint:u("debug-breakpoint",60017),debugBreakpointDisabled:u("debug-breakpoint-disabled",60017),debugHint:u("debug-hint",60017),primitiveSquare:u("primitive-square",60018),edit:u("edit",60019),pencil:u("pencil",60019),info:u("info",60020),issueOpened:u("issue-opened",60020),gistPrivate:u("gist-private",60021),gitForkPrivate:u("git-fork-private",60021),lock:u("lock",60021),mirrorPrivate:u("mirror-private",60021),close:u("close",60022),removeClose:u("remove-close",60022),x:u("x",60022),repoSync:u("repo-sync",60023),sync:u("sync",60023),clone:u("clone",60024),desktopDownload:u("desktop-download",60024),beaker:u("beaker",60025),microscope:u("microscope",60025),vm:u("vm",60026),deviceDesktop:u("device-desktop",60026),file:u("file",60027),fileText:u("file-text",60027),more:u("more",60028),ellipsis:u("ellipsis",60028),kebabHorizontal:u("kebab-horizontal",60028),mailReply:u("mail-reply",60029),reply:u("reply",60029),organization:u("organization",60030),organizationFilled:u("organization-filled",60030),organizationOutline:u("organization-outline",60030),newFile:u("new-file",60031),fileAdd:u("file-add",60031),newFolder:u("new-folder",60032),fileDirectoryCreate:u("file-directory-create",60032),trash:u("trash",60033),trashcan:u("trashcan",60033),history:u("history",60034),clock:u("clock",60034),folder:u("folder",60035),fileDirectory:u("file-directory",60035),symbolFolder:u("symbol-folder",60035),logoGithub:u("logo-github",60036),markGithub:u("mark-github",60036),github:u("github",60036),terminal:u("terminal",60037),console:u("console",60037),repl:u("repl",60037),zap:u("zap",60038),symbolEvent:u("symbol-event",60038),error:u("error",60039),stop:u("stop",60039),variable:u("variable",60040),symbolVariable:u("symbol-variable",60040),array:u("array",60042),symbolArray:u("symbol-array",60042),symbolModule:u("symbol-module",60043),symbolPackage:u("symbol-package",60043),symbolNamespace:u("symbol-namespace",60043),symbolObject:u("symbol-object",60043),symbolMethod:u("symbol-method",60044),symbolFunction:u("symbol-function",60044),symbolConstructor:u("symbol-constructor",60044),symbolBoolean:u("symbol-boolean",60047),symbolNull:u("symbol-null",60047),symbolNumeric:u("symbol-numeric",60048),symbolNumber:u("symbol-number",60048),symbolStructure:u("symbol-structure",60049),symbolStruct:u("symbol-struct",60049),symbolParameter:u("symbol-parameter",60050),symbolTypeParameter:u("symbol-type-parameter",60050),symbolKey:u("symbol-key",60051),symbolText:u("symbol-text",60051),symbolReference:u("symbol-reference",60052),goToFile:u("go-to-file",60052),symbolEnum:u("symbol-enum",60053),symbolValue:u("symbol-value",60053),symbolRuler:u("symbol-ruler",60054),symbolUnit:u("symbol-unit",60054),activateBreakpoints:u("activate-breakpoints",60055),archive:u("archive",60056),arrowBoth:u("arrow-both",60057),arrowDown:u("arrow-down",60058),arrowLeft:u("arrow-left",60059),arrowRight:u("arrow-right",60060),arrowSmallDown:u("arrow-small-down",60061),arrowSmallLeft:u("arrow-small-left",60062),arrowSmallRight:u("arrow-small-right",60063),arrowSmallUp:u("arrow-small-up",60064),arrowUp:u("arrow-up",60065),bell:u("bell",60066),bold:u("bold",60067),book:u("book",60068),bookmark:u("bookmark",60069),debugBreakpointConditionalUnverified:u("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:u("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:u("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:u("debug-breakpoint-data-unverified",60072),debugBreakpointData:u("debug-breakpoint-data",60073),debugBreakpointDataDisabled:u("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:u("debug-breakpoint-log-unverified",60074),debugBreakpointLog:u("debug-breakpoint-log",60075),debugBreakpointLogDisabled:u("debug-breakpoint-log-disabled",60075),briefcase:u("briefcase",60076),broadcast:u("broadcast",60077),browser:u("browser",60078),bug:u("bug",60079),calendar:u("calendar",60080),caseSensitive:u("case-sensitive",60081),check:u("check",60082),checklist:u("checklist",60083),chevronDown:u("chevron-down",60084),dropDownButton:u("drop-down-button",60084),chevronLeft:u("chevron-left",60085),chevronRight:u("chevron-right",60086),chevronUp:u("chevron-up",60087),chromeClose:u("chrome-close",60088),chromeMaximize:u("chrome-maximize",60089),chromeMinimize:u("chrome-minimize",60090),chromeRestore:u("chrome-restore",60091),circle:u("circle",60092),circleOutline:u("circle-outline",60092),debugBreakpointUnverified:u("debug-breakpoint-unverified",60092),circleSlash:u("circle-slash",60093),circuitBoard:u("circuit-board",60094),clearAll:u("clear-all",60095),clippy:u("clippy",60096),closeAll:u("close-all",60097),cloudDownload:u("cloud-download",60098),cloudUpload:u("cloud-upload",60099),code:u("code",60100),collapseAll:u("collapse-all",60101),colorMode:u("color-mode",60102),commentDiscussion:u("comment-discussion",60103),compareChanges:u("compare-changes",60157),creditCard:u("credit-card",60105),dash:u("dash",60108),dashboard:u("dashboard",60109),database:u("database",60110),debugContinue:u("debug-continue",60111),debugDisconnect:u("debug-disconnect",60112),debugPause:u("debug-pause",60113),debugRestart:u("debug-restart",60114),debugStart:u("debug-start",60115),debugStepInto:u("debug-step-into",60116),debugStepOut:u("debug-step-out",60117),debugStepOver:u("debug-step-over",60118),debugStop:u("debug-stop",60119),debug:u("debug",60120),deviceCameraVideo:u("device-camera-video",60121),deviceCamera:u("device-camera",60122),deviceMobile:u("device-mobile",60123),diffAdded:u("diff-added",60124),diffIgnored:u("diff-ignored",60125),diffModified:u("diff-modified",60126),diffRemoved:u("diff-removed",60127),diffRenamed:u("diff-renamed",60128),diff:u("diff",60129),discard:u("discard",60130),editorLayout:u("editor-layout",60131),emptyWindow:u("empty-window",60132),exclude:u("exclude",60133),extensions:u("extensions",60134),eyeClosed:u("eye-closed",60135),fileBinary:u("file-binary",60136),fileCode:u("file-code",60137),fileMedia:u("file-media",60138),filePdf:u("file-pdf",60139),fileSubmodule:u("file-submodule",60140),fileSymlinkDirectory:u("file-symlink-directory",60141),fileSymlinkFile:u("file-symlink-file",60142),fileZip:u("file-zip",60143),files:u("files",60144),filter:u("filter",60145),flame:u("flame",60146),foldDown:u("fold-down",60147),foldUp:u("fold-up",60148),fold:u("fold",60149),folderActive:u("folder-active",60150),folderOpened:u("folder-opened",60151),gear:u("gear",60152),gift:u("gift",60153),gistSecret:u("gist-secret",60154),gist:u("gist",60155),gitCommit:u("git-commit",60156),gitCompare:u("git-compare",60157),gitMerge:u("git-merge",60158),githubAction:u("github-action",60159),githubAlt:u("github-alt",60160),globe:u("globe",60161),grabber:u("grabber",60162),graph:u("graph",60163),gripper:u("gripper",60164),heart:u("heart",60165),home:u("home",60166),horizontalRule:u("horizontal-rule",60167),hubot:u("hubot",60168),inbox:u("inbox",60169),issueClosed:u("issue-closed",60324),issueReopened:u("issue-reopened",60171),issues:u("issues",60172),italic:u("italic",60173),jersey:u("jersey",60174),json:u("json",60175),bracket:u("bracket",60175),kebabVertical:u("kebab-vertical",60176),key:u("key",60177),law:u("law",60178),lightbulbAutofix:u("lightbulb-autofix",60179),linkExternal:u("link-external",60180),link:u("link",60181),listOrdered:u("list-ordered",60182),listUnordered:u("list-unordered",60183),liveShare:u("live-share",60184),loading:u("loading",60185),location:u("location",60186),mailRead:u("mail-read",60187),mail:u("mail",60188),markdown:u("markdown",60189),megaphone:u("megaphone",60190),mention:u("mention",60191),milestone:u("milestone",60192),mortarBoard:u("mortar-board",60193),move:u("move",60194),multipleWindows:u("multiple-windows",60195),mute:u("mute",60196),noNewline:u("no-newline",60197),note:u("note",60198),octoface:u("octoface",60199),openPreview:u("open-preview",60200),package_:u("package",60201),paintcan:u("paintcan",60202),pin:u("pin",60203),play:u("play",60204),run:u("run",60204),plug:u("plug",60205),preserveCase:u("preserve-case",60206),preview:u("preview",60207),project:u("project",60208),pulse:u("pulse",60209),question:u("question",60210),quote:u("quote",60211),radioTower:u("radio-tower",60212),reactions:u("reactions",60213),references:u("references",60214),refresh:u("refresh",60215),regex:u("regex",60216),remoteExplorer:u("remote-explorer",60217),remote:u("remote",60218),remove:u("remove",60219),replaceAll:u("replace-all",60220),replace:u("replace",60221),repoClone:u("repo-clone",60222),repoForcePush:u("repo-force-push",60223),repoPull:u("repo-pull",60224),repoPush:u("repo-push",60225),report:u("report",60226),requestChanges:u("request-changes",60227),rocket:u("rocket",60228),rootFolderOpened:u("root-folder-opened",60229),rootFolder:u("root-folder",60230),rss:u("rss",60231),ruby:u("ruby",60232),saveAll:u("save-all",60233),saveAs:u("save-as",60234),save:u("save",60235),screenFull:u("screen-full",60236),screenNormal:u("screen-normal",60237),searchStop:u("search-stop",60238),server:u("server",60240),settingsGear:u("settings-gear",60241),settings:u("settings",60242),shield:u("shield",60243),smiley:u("smiley",60244),sortPrecedence:u("sort-precedence",60245),splitHorizontal:u("split-horizontal",60246),splitVertical:u("split-vertical",60247),squirrel:u("squirrel",60248),starFull:u("star-full",60249),starHalf:u("star-half",60250),symbolClass:u("symbol-class",60251),symbolColor:u("symbol-color",60252),symbolCustomColor:u("symbol-customcolor",60252),symbolConstant:u("symbol-constant",60253),symbolEnumMember:u("symbol-enum-member",60254),symbolField:u("symbol-field",60255),symbolFile:u("symbol-file",60256),symbolInterface:u("symbol-interface",60257),symbolKeyword:u("symbol-keyword",60258),symbolMisc:u("symbol-misc",60259),symbolOperator:u("symbol-operator",60260),symbolProperty:u("symbol-property",60261),wrench:u("wrench",60261),wrenchSubaction:u("wrench-subaction",60261),symbolSnippet:u("symbol-snippet",60262),tasklist:u("tasklist",60263),telescope:u("telescope",60264),textSize:u("text-size",60265),threeBars:u("three-bars",60266),thumbsdown:u("thumbsdown",60267),thumbsup:u("thumbsup",60268),tools:u("tools",60269),triangleDown:u("triangle-down",60270),triangleLeft:u("triangle-left",60271),triangleRight:u("triangle-right",60272),triangleUp:u("triangle-up",60273),twitter:u("twitter",60274),unfold:u("unfold",60275),unlock:u("unlock",60276),unmute:u("unmute",60277),unverified:u("unverified",60278),verified:u("verified",60279),versions:u("versions",60280),vmActive:u("vm-active",60281),vmOutline:u("vm-outline",60282),vmRunning:u("vm-running",60283),watch:u("watch",60284),whitespace:u("whitespace",60285),wholeWord:u("whole-word",60286),window:u("window",60287),wordWrap:u("word-wrap",60288),zoomIn:u("zoom-in",60289),zoomOut:u("zoom-out",60290),listFilter:u("list-filter",60291),listFlat:u("list-flat",60292),listSelection:u("list-selection",60293),selection:u("selection",60293),listTree:u("list-tree",60294),debugBreakpointFunctionUnverified:u("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:u("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:u("debug-breakpoint-function-disabled",60296),debugStackframeActive:u("debug-stackframe-active",60297),circleSmallFilled:u("circle-small-filled",60298),debugStackframeDot:u("debug-stackframe-dot",60298),debugStackframe:u("debug-stackframe",60299),debugStackframeFocused:u("debug-stackframe-focused",60299),debugBreakpointUnsupported:u("debug-breakpoint-unsupported",60300),symbolString:u("symbol-string",60301),debugReverseContinue:u("debug-reverse-continue",60302),debugStepBack:u("debug-step-back",60303),debugRestartFrame:u("debug-restart-frame",60304),callIncoming:u("call-incoming",60306),callOutgoing:u("call-outgoing",60307),menu:u("menu",60308),expandAll:u("expand-all",60309),feedback:u("feedback",60310),groupByRefType:u("group-by-ref-type",60311),ungroupByRefType:u("ungroup-by-ref-type",60312),account:u("account",60313),bellDot:u("bell-dot",60314),debugConsole:u("debug-console",60315),library:u("library",60316),output:u("output",60317),runAll:u("run-all",60318),syncIgnored:u("sync-ignored",60319),pinned:u("pinned",60320),githubInverted:u("github-inverted",60321),debugAlt:u("debug-alt",60305),serverProcess:u("server-process",60322),serverEnvironment:u("server-environment",60323),pass:u("pass",60324),stopCircle:u("stop-circle",60325),playCircle:u("play-circle",60326),record:u("record",60327),debugAltSmall:u("debug-alt-small",60328),vmConnect:u("vm-connect",60329),cloud:u("cloud",60330),merge:u("merge",60331),exportIcon:u("export",60332),graphLeft:u("graph-left",60333),magnet:u("magnet",60334),notebook:u("notebook",60335),redo:u("redo",60336),checkAll:u("check-all",60337),pinnedDirty:u("pinned-dirty",60338),passFilled:u("pass-filled",60339),circleLargeFilled:u("circle-large-filled",60340),circleLarge:u("circle-large",60341),circleLargeOutline:u("circle-large-outline",60341),combine:u("combine",60342),gather:u("gather",60342),table:u("table",60343),variableGroup:u("variable-group",60344),typeHierarchy:u("type-hierarchy",60345),typeHierarchySub:u("type-hierarchy-sub",60346),typeHierarchySuper:u("type-hierarchy-super",60347),gitPullRequestCreate:u("git-pull-request-create",60348),runAbove:u("run-above",60349),runBelow:u("run-below",60350),notebookTemplate:u("notebook-template",60351),debugRerun:u("debug-rerun",60352),workspaceTrusted:u("workspace-trusted",60353),workspaceUntrusted:u("workspace-untrusted",60354),workspaceUnspecified:u("workspace-unspecified",60355),terminalCmd:u("terminal-cmd",60356),terminalDebian:u("terminal-debian",60357),terminalLinux:u("terminal-linux",60358),terminalPowershell:u("terminal-powershell",60359),terminalTmux:u("terminal-tmux",60360),terminalUbuntu:u("terminal-ubuntu",60361),terminalBash:u("terminal-bash",60362),arrowSwap:u("arrow-swap",60363),copy:u("copy",60364),personAdd:u("person-add",60365),filterFilled:u("filter-filled",60366),wand:u("wand",60367),debugLineByLine:u("debug-line-by-line",60368),inspect:u("inspect",60369),layers:u("layers",60370),layersDot:u("layers-dot",60371),layersActive:u("layers-active",60372),compass:u("compass",60373),compassDot:u("compass-dot",60374),compassActive:u("compass-active",60375),azure:u("azure",60376),issueDraft:u("issue-draft",60377),gitPullRequestClosed:u("git-pull-request-closed",60378),gitPullRequestDraft:u("git-pull-request-draft",60379),debugAll:u("debug-all",60380),debugCoverage:u("debug-coverage",60381),runErrors:u("run-errors",60382),folderLibrary:u("folder-library",60383),debugContinueSmall:u("debug-continue-small",60384),beakerStop:u("beaker-stop",60385),graphLine:u("graph-line",60386),graphScatter:u("graph-scatter",60387),pieChart:u("pie-chart",60388),bracketDot:u("bracket-dot",60389),bracketError:u("bracket-error",60390),lockSmall:u("lock-small",60391),azureDevops:u("azure-devops",60392),verifiedFilled:u("verified-filled",60393),newLine:u("newline",60394),layout:u("layout",60395),layoutActivitybarLeft:u("layout-activitybar-left",60396),layoutActivitybarRight:u("layout-activitybar-right",60397),layoutPanelLeft:u("layout-panel-left",60398),layoutPanelCenter:u("layout-panel-center",60399),layoutPanelJustify:u("layout-panel-justify",60400),layoutPanelRight:u("layout-panel-right",60401),layoutPanel:u("layout-panel",60402),layoutSidebarLeft:u("layout-sidebar-left",60403),layoutSidebarRight:u("layout-sidebar-right",60404),layoutStatusbar:u("layout-statusbar",60405),layoutMenubar:u("layout-menubar",60406),layoutCentered:u("layout-centered",60407),layoutSidebarRightOff:u("layout-sidebar-right-off",60416),layoutPanelOff:u("layout-panel-off",60417),layoutSidebarLeftOff:u("layout-sidebar-left-off",60418),target:u("target",60408),indent:u("indent",60409),recordSmall:u("record-small",60410),errorSmall:u("error-small",60411),arrowCircleDown:u("arrow-circle-down",60412),arrowCircleLeft:u("arrow-circle-left",60413),arrowCircleRight:u("arrow-circle-right",60414),arrowCircleUp:u("arrow-circle-up",60415),heartFilled:u("heart-filled",60420),map:u("map",60421),mapFilled:u("map-filled",60422),circleSmall:u("circle-small",60423),bellSlash:u("bell-slash",60424),bellSlashDot:u("bell-slash-dot",60425),commentUnresolved:u("comment-unresolved",60426),gitPullRequestGoToChanges:u("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:u("git-pull-request-new-changes",60428),searchFuzzy:u("search-fuzzy",60429),commentDraft:u("comment-draft",60430),dialogError:u("dialog-error","error"),dialogWarning:u("dialog-warning","warning"),dialogInfo:u("dialog-info","info"),dialogClose:u("dialog-close","close"),treeItemExpanded:u("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:u("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:u("tree-filter-on-type-off","list-selection"),treeFilterClear:u("tree-filter-clear","close"),treeItemLoading:u("tree-item-loading","loading"),menuSelection:u("menu-selection","check"),menuSubmenu:u("menu-submenu","chevron-right"),menuBarMore:u("menubar-more","more"),scrollbarButtonLeft:u("scrollbar-button-left","triangle-left"),scrollbarButtonRight:u("scrollbar-button-right","triangle-right"),scrollbarButtonUp:u("scrollbar-button-up","triangle-up"),scrollbarButtonDown:u("scrollbar-button-down","triangle-down"),toolBarMore:u("toolbar-more","more"),quickInputBack:u("quick-input-back","arrow-left")}}),define(_e[23],ye([1,0,9]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function P(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([v,C])=>{g[v]=C&&typeof C=="object"?P(C):C}),g}e.deepClone=P;function u(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const v=g.shift();Object.freeze(v);for(const C in v)if(A.call(v,C)){const p=v[C];typeof p=="object"&&!Object.isFrozen(p)&&!(0,a.isTypedArray)(p)&&g.push(p)}}return h}e.deepFreeze=u;const A=Object.prototype.hasOwnProperty;function _(h,g){return T(h,g,new Set)}e.cloneAndChange=_;function T(h,g,v){if((0,a.isUndefinedOrNull)(h))return h;const C=g(h);if(typeof C<"u")return C;if(Array.isArray(h)){const p=[];for(const i of h)p.push(T(i,g,v));return p}if((0,a.isObject)(h)){if(v.has(h))throw new Error("Cannot clone recursive data-structure");v.add(h);const p={};for(const i in h)A.call(h,i)&&(p[i]=T(h[i],g,v));return v.delete(h),p}return h}function S(h,g,v=!0){return(0,a.isObject)(h)?((0,a.isObject)(g)&&Object.keys(g).forEach(C=>{C in h?v&&((0,a.isObject)(h[C])&&(0,a.isObject)(g[C])?S(h[C],g[C],v):h[C]=g[C]):h[C]=g[C]}),h):g}e.mixin=S;function D(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let v,C;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(v=0;v<h.length;v++)if(!D(h[v],g[v]))return!1}else{const p=[];for(C in h)p.push(C);p.sort();const i=[];for(C in g)i.push(C);if(i.sort(),!D(p,i))return!1;for(v=0;v<p.length;v++)if(!D(h[p[v]],g[p[v]]))return!1}return!0}e.equals=D;function R(h){const g=new Set;return JSON.stringify(h,(v,C)=>{if((0,a.isObject)(C)||Array.isArray(C)){if(g.has(C))return"[Circular]";g.add(C)}return C})}e.safeStringify=R;function I(h,g){const v=Object.create(null);return!h||!g||Object.keys(g).forEach(p=>{const i=h[p],o=g[p];D(i,o)||(v[p]=o)}),v}e.distinct=I;function b(h,g){const v=g.toLowerCase(),C=Object.keys(h).find(p=>p.toLowerCase()===v);return C?h[C]:h[g]}e.getCaseInsensitive=b;function k(h,g){const v=Object.create(null);for(const[C,p]of Object.entries(h))g(C,p)&&(v[C]=p);return v}e.filter=k;function w(h){let g=[],v=Object.getPrototypeOf(h);for(;Object.prototype!==v;)g=g.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return g}e.getAllPropertyNames=w;function f(h){const g=[];for(const v of w(h))typeof h[v]=="function"&&g.push(v);return g}e.getAllMethodNames=f;function d(h,g){const v=p=>function(){const i=Array.prototype.slice.call(arguments,0);return g(p,i)},C={};for(const p of h)C[p]=v(p);return C}e.createProxyObject=d}),define(_e[51],ye([1,0,67]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var P;(function(_){function T(S){return S&&typeof S=="object"&&typeof S.id=="string"}_.isThemeColor=T})(P=e.ThemeColor||(e.ThemeColor={}));function u(_){return{id:_}}e.themeColorFromId=u;var A;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function S(g){const v=T.exec(g.id);if(!v)return S(a.Codicon.error);const[,C,p]=v,i=["codicon","codicon-"+C];return p&&i.push("codicon-modifier-"+p.substring(1)),i}_.asClassNameArray=S;function D(g){return S(g).join(" ")}_.asClassName=D;function R(g){return"."+S(g).join(".")}_.asCSSSelector=R;function I(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||P.isThemeColor(g.color))}_.isThemeIcon=I;const b=new RegExp(`^\\$\\((${_.iconNameExpression}(?:${_.iconModifierExpression})?)\\)$`);function k(g){const v=b.exec(g);if(!v)return;const[,C]=v;return{id:C}}_.fromString=k;function w(g){return{id:g}}_.fromId=w;function f(g,v){let C=g.id;const p=C.lastIndexOf("~");return p!==-1&&(C=C.substring(0,p)),v&&(C=`${C}~${v}`),{id:C}}_.modify=f;function d(g){const v=g.id.lastIndexOf("~");if(v!==-1)return g.id.substring(v+1)}_.getModifier=d;function h(g,v){return g.id===v.id&&g.color?.id===v.color?.id}_.isEqual=h})(A=e.ThemeIcon||(e.ThemeIcon={}))}),define(_e[104],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function P(A){return A<0?0:A>255?255:A|0}e.toUint8=P;function u(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=u}),define(_e[30],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(u){return a.test(u)}e.isUUID=P,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let u;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?u=crypto.getRandomValues.bind(crypto):u=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const A=new Uint8Array(16),_=[];for(let T=0;T<256;T++)_.push(T.toString(16).padStart(2,"0"));return function(){u(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,D="";return D+=_[A[S++]],D+=_[A[S++]],D+=_[A[S++]],D+=_[A[S++]],D+="-",D+=_[A[S++]],D+=_[A[S++]],D+="-",D+=_[A[S++]],D+=_[A[S++]],D+="-",D+=_[A[S++]],D+=_[A[S++]],D+="-",D+=_[A[S++]],D+=_[A[S++]],D+=_[A[S++]],D+=_[A[S++]],D+=_[A[S++]],D+=_[A[S++]],D}}()}),define(_e[149],ye([1,0,16,30]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function u(T){return{id:(0,P.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=u;function A(T,S,D){return{id:(0,P.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:S,data:D}),value:void 0}}e.createFileDataTransferItem=A;class _{constructor(){this._entries=new Map}get size(){return this._entries.size}has(S){return this._entries.has(this.toKey(S))}get(S){return this._entries.get(this.toKey(S))?.[0]}append(S,D){const R=this._entries.get(S);R?R.push(D):this._entries.set(this.toKey(S),[D])}replace(S,D){this._entries.set(this.toKey(S),[D])}delete(S){this._entries.delete(this.toKey(S))}*entries(){for(const[S,D]of this._entries.entries())for(const R of D)yield[S,R]}values(){return Array.from(this._entries.values()).flat()}forEach(S){for(const[D,R]of this.entries())S(R,D)}toKey(S){return S.toLowerCase()}}e.VSDataTransfer=_,e.UriList=Object.freeze({create:T=>(0,a.distinct)(T.map(S=>S.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(S=>!S.startsWith("#"))})}),define(_e[105],ye([1,0,104]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class P{constructor(T){const S=(0,a.toUint8)(T);this._defaultValue=S,this._asciiMap=P._createAsciiMap(S),this._map=new Map}static _createAsciiMap(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const D=(0,a.toUint8)(S);T>=0&&T<256?this._asciiMap[T]=D:this._map.set(T,D)}get(T){return T>=0&&T<256?this._asciiMap[T]:this._map.get(T)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=P;var u;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(u||(u={}));class A{constructor(){this._actual=new P(0)}add(T){this._actual.set(T,1)}has(T){return this._actual.get(T)===1}clear(){return this._actual.clear()}}e.CharacterSet=A}),define(_e[52],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(u,A){this.lineNumber=u,this.column=A}with(u=this.lineNumber,A=this.column){return u===this.lineNumber&&A===this.column?this:new a(u,A)}delta(u=0,A=0){return this.with(this.lineNumber+u,this.column+A)}equals(u){return a.equals(this,u)}static equals(u,A){return!u&&!A?!0:!!u&&!!A&&u.lineNumber===A.lineNumber&&u.column===A.column}isBefore(u){return a.isBefore(this,u)}static isBefore(u,A){return u.lineNumber<A.lineNumber?!0:A.lineNumber<u.lineNumber?!1:u.column<A.column}isBeforeOrEqual(u){return a.isBeforeOrEqual(this,u)}static isBeforeOrEqual(u,A){return u.lineNumber<A.lineNumber?!0:A.lineNumber<u.lineNumber?!1:u.column<=A.column}static compare(u,A){const _=u.lineNumber|0,T=A.lineNumber|0;if(_===T){const S=u.column|0,D=A.column|0;return S-D}return _-T}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(u){return new a(u.lineNumber,u.column)}static isIPosition(u){return u&&typeof u.lineNumber=="number"&&typeof u.column=="number"}}e.Position=a}),define(_e[32],ye([1,0,52]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class P{constructor(A,_,T,S){A>T||A===T&&_>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=A,this.endColumn=_):(this.startLineNumber=A,this.startColumn=_,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return P.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return P.containsPosition(this,A)}static containsPosition(A,_){return!(_.lineNumber<A.startLineNumber||_.lineNumber>A.endLineNumber||_.lineNumber===A.startLineNumber&&_.column<A.startColumn||_.lineNumber===A.endLineNumber&&_.column>A.endColumn)}static strictContainsPosition(A,_){return!(_.lineNumber<A.startLineNumber||_.lineNumber>A.endLineNumber||_.lineNumber===A.startLineNumber&&_.column<=A.startColumn||_.lineNumber===A.endLineNumber&&_.column>=A.endColumn)}containsRange(A){return P.containsRange(this,A)}static containsRange(A,_){return!(_.startLineNumber<A.startLineNumber||_.endLineNumber<A.startLineNumber||_.startLineNumber>A.endLineNumber||_.endLineNumber>A.endLineNumber||_.startLineNumber===A.startLineNumber&&_.startColumn<A.startColumn||_.endLineNumber===A.endLineNumber&&_.endColumn>A.endColumn)}strictContainsRange(A){return P.strictContainsRange(this,A)}static strictContainsRange(A,_){return!(_.startLineNumber<A.startLineNumber||_.endLineNumber<A.startLineNumber||_.startLineNumber>A.endLineNumber||_.endLineNumber>A.endLineNumber||_.startLineNumber===A.startLineNumber&&_.startColumn<=A.startColumn||_.endLineNumber===A.endLineNumber&&_.endColumn>=A.endColumn)}plusRange(A){return P.plusRange(this,A)}static plusRange(A,_){let T,S,D,R;return _.startLineNumber<A.startLineNumber?(T=_.startLineNumber,S=_.startColumn):_.startLineNumber===A.startLineNumber?(T=_.startLineNumber,S=Math.min(_.startColumn,A.startColumn)):(T=A.startLineNumber,S=A.startColumn),_.endLineNumber>A.endLineNumber?(D=_.endLineNumber,R=_.endColumn):_.endLineNumber===A.endLineNumber?(D=_.endLineNumber,R=Math.max(_.endColumn,A.endColumn)):(D=A.endLineNumber,R=A.endColumn),new P(T,S,D,R)}intersectRanges(A){return P.intersectRanges(this,A)}static intersectRanges(A,_){let T=A.startLineNumber,S=A.startColumn,D=A.endLineNumber,R=A.endColumn;const I=_.startLineNumber,b=_.startColumn,k=_.endLineNumber,w=_.endColumn;return T<I?(T=I,S=b):T===I&&(S=Math.max(S,b)),D>k?(D=k,R=w):D===k&&(R=Math.min(R,w)),T>D||T===D&&S>R?null:new P(T,S,D,R)}equalsRange(A){return P.equalsRange(this,A)}static equalsRange(A,_){return!A&&!_?!0:!!A&&!!_&&A.startLineNumber===_.startLineNumber&&A.startColumn===_.startColumn&&A.endLineNumber===_.endLineNumber&&A.endColumn===_.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(A){return new a.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(A){return new a.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,_){return new P(this.startLineNumber,this.startColumn,A,_)}setStartPosition(A,_){return new P(A,_,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(A){return new P(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return P.collapseToEnd(this)}static collapseToEnd(A){return new P(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new P(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,_=A){return new P(A.lineNumber,A.column,_.lineNumber,_.column)}static lift(A){return A?new P(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,_){return!(A.endLineNumber<_.startLineNumber||A.endLineNumber===_.startLineNumber&&A.endColumn<_.startColumn||_.endLineNumber<A.startLineNumber||_.endLineNumber===A.startLineNumber&&_.endColumn<A.startColumn)}static areIntersecting(A,_){return!(A.endLineNumber<_.startLineNumber||A.endLineNumber===_.startLineNumber&&A.endColumn<=_.startColumn||_.endLineNumber<A.startLineNumber||_.endLineNumber===A.startLineNumber&&_.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,_){if(A&&_){const D=A.startLineNumber|0,R=_.startLineNumber|0;if(D===R){const I=A.startColumn|0,b=_.startColumn|0;if(I===b){const k=A.endLineNumber|0,w=_.endLineNumber|0;if(k===w){const f=A.endColumn|0,d=_.endColumn|0;return f-d}return k-w}return I-b}return D-R}return(A?1:0)-(_?1:0)}static compareRangesUsingEnds(A,_){return A.endLineNumber===_.endLineNumber?A.endColumn===_.endColumn?A.startLineNumber===_.startLineNumber?A.startColumn-_.startColumn:A.startLineNumber-_.startLineNumber:A.endColumn-_.endColumn:A.endLineNumber-_.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=P}),define(_e[150],ye([1,0,52,32]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var u;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(u=e.SelectionDirection||(e.SelectionDirection={}));class A extends P.Range{constructor(T,S,D,R){super(T,S,D,R),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=D,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return A.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,T,S):new A(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new A(T,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new A(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new A(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new A(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new A(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let D=0,R=T.length;D<R;D++)if(!this.selectionsEqual(T[D],S[D]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,D,R,I){return I===0?new A(T,S,D,R):new A(D,R,T,S)}}e.Selection=A}),define(_e[151],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(_e[152],ye([1,0,105]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var P;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(P=e.WordCharacterClass||(e.WordCharacterClass={}));class u extends a.CharacterClassifier{constructor(T){super(0);for(let S=0,D=T.length;S<D;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=u;function A(_){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=_(S)),T[S])}e.getMapForWordSeparators=A(_=>new u(_))}),define(_e[106],ye([1,0,64,6,66]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(I=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)I.indexOf(k)>=0||(b+="\\"+k);return b+="\\s]+)",new RegExp(b,"g")}e.DEFAULT_WORD_REGEXP=A();function _(I){let b=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)b=I;else{let k="g";I.ignoreCase&&(k+="i"),I.multiline&&(k+="m"),I.unicode&&(k+="u"),b=new RegExp(I.source,k)}return b.lastIndex=0,b}e.ensureValidWordDefinition=_;const T=new u.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(I){const b=T.unshift(I);return(0,P.toDisposable)(b)}e.setDefaultGetWordAtTextConfig=S;function D(I,b,k,w,f){if(f||(f=a.Iterable.first(T)),k.length>f.maxLen){let C=I-f.maxLen/2;return C<0?C=0:w+=C,k=k.substring(C,I+f.maxLen/2),D(I,b,k,w,f)}const d=Date.now(),h=I-1-w;let g=-1,v=null;for(let C=1;!(Date.now()-d>=f.timeBudget);C++){const p=h-f.windowSize*C;b.lastIndex=Math.max(0,p);const i=R(b,k,h,g);if(!i&&v||(v=i,p<=0))break;g=p}if(v){const C={word:v[0],startColumn:w+1+v.index,endColumn:w+1+v.index+v[0].length};return b.lastIndex=0,C}return null}e.getWordAtText=D;function R(I,b,k,w){let f;for(;f=I.exec(b);){const d=f.index||0;if(d<=k&&I.lastIndex>=k)return f;if(w>0&&d>w)return null}return null}}),define(_e[153],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class P{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(T.notIn))for(let S=0,D=T.notIn.length;S<D;S++)switch(T.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const D=T.findTokenIndexAtOffset(S-2),R=T.getStandardTokenType(D);return this.isOK(R)}_findNeutralCharacterInRange(T,S){for(let D=T;D<=S;D++){const R=String.fromCharCode(D);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=P;class u{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=u;function A(_,T,S){_.has(T)?_.get(T).push(S):_.set(T,[S])}}),define(_e[154],ye([1,0,105]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var P;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(P=e.State||(e.State={}));class u{constructor(w,f,d){const h=new Uint8Array(w*f);for(let g=0,v=w*f;g<v;g++)h[g]=d;this._data=h,this.rows=w,this.cols=f}get(w,f){return this._data[w*this.cols+f]}set(w,f,d){this._data[w*this.cols+f]=d}}class A{constructor(w){let f=0,d=0;for(let g=0,v=w.length;g<v;g++){const[C,p,i]=w[g];p>f&&(f=p),C>d&&(d=C),i>d&&(d=i)}f++,d++;const h=new u(d,f,0);for(let g=0,v=w.length;g<v;g++){const[C,p,i]=w[g];h.set(C,p,i)}this._states=h,this._maxCharCode=f}nextState(w,f){return f<0||f>=this._maxCharCode?0:this._states.get(w,f)}}e.StateMachine=A;let _=null;function T(){return _===null&&(_=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var S;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let D=null;function R(){if(D===null){D=new a.CharacterClassifier(0);const k=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<k.length;f++)D.set(k.charCodeAt(f),1);const w=".;:";for(let f=0;f<w.length;f++)D.set(w.charCodeAt(f),2)}return D}class I{static _createLink(w,f,d,h,g){let v=g-1;do{const C=f.charCodeAt(v);if(w.get(C)!==2)break;v--}while(v>h);if(h>0){const C=f.charCodeAt(h-1),p=f.charCodeAt(v);(C===40&&p===41||C===91&&p===93||C===123&&p===125)&&v--}return{range:{startLineNumber:d,startColumn:h+1,endLineNumber:d,endColumn:v+2},url:f.substring(h,v+1)}}static computeLinks(w,f=T()){const d=R(),h=[];for(let g=1,v=w.getLineCount();g<=v;g++){const C=w.getLineContent(g),p=C.length;let i=0,o=0,s=0,l=1,r=!1,m=!1,n=!1,t=!1;for(;i<p;){let c=!1;const E=C.charCodeAt(i);if(l===13){let y;switch(E){case 40:r=!0,y=0;break;case 41:y=r?0:1;break;case 91:n=!0,m=!0,y=0;break;case 93:n=!1,y=m?0:1;break;case 123:t=!0,y=0;break;case 125:y=t?0:1;break;case 39:case 34:case 96:s===E?y=1:s===39||s===34||s===96?y=0:y=1;break;case 42:y=s===42?1:0;break;case 124:y=s===124?1:0;break;case 32:y=n?0:1;break;default:y=d.get(E)}y===1&&(h.push(I._createLink(d,C,g,o,i)),c=!0)}else if(l===12){let y;E===91?(m=!0,y=0):y=d.get(E),y===1?c=!0:l=13}else l=f.nextState(l,E),l===0&&(c=!0);c&&(l=1,r=!1,m=!1,t=!1,o=i+1,s=E),i++}l===13&&h.push(I._createLink(d,C,g,o,p))}return h}}e.LinkComputer=I;function b(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:I.computeLinks(k)}e.computeLinks=b}),define(_e[107],ye([1,0,23]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var P;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(P=e.OverviewRulerLane||(e.OverviewRulerLane={}));var u;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(u=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(v){v[v.Both=0]="Both",v[v.Right=1]="Right",v[v.Left=2]="Left",v[v.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var _;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(_=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(C){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,C.tabSize|0),C.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,C.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=Boolean(C.insertSpaces),this.defaultEOL=C.defaultEOL|0,this.trimAutoWhitespace=Boolean(C.trimAutoWhitespace),this.bracketPairColorizationOptions=C.bracketPairColorizationOptions}equals(C){return this.tabSize===C.tabSize&&this._indentSizeIsTabSize===C._indentSizeIsTabSize&&this.indentSize===C.indentSize&&this.insertSpaces===C.insertSpaces&&this.defaultEOL===C.defaultEOL&&this.trimAutoWhitespace===C.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,C.bracketPairColorizationOptions)}createChangeEvent(C){return{tabSize:this.tabSize!==C.tabSize,indentSize:this.indentSize!==C.indentSize,insertSpaces:this.insertSpaces!==C.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==C.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class R{constructor(C,p){this._findMatchBrand=void 0,this.range=C,this.matches=p}}e.FindMatch=R;var I;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function b(v){return v&&typeof v.read=="function"}e.isITextSnapshot=b;var k;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None",v[v.LeftOfInjectedText=3]="LeftOfInjectedText",v[v.RightOfInjectedText=4]="RightOfInjectedText"})(k=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class f{constructor(C,p,i,o,s,l){this.identifier=C,this.range=p,this.text=i,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=s,this._isTracked=l}}e.ValidAnnotatedEditOperation=f;class d{constructor(C,p,i){this.regex=C,this.wordSeparators=p,this.simpleSearch=i}}e.SearchData=d;class h{constructor(C,p,i){this.reverseEdits=C,this.changes=p,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=h;function g(v){return!v.isTooLargeForSyncing()&&!v.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(_e[155],ye([1,0,16,104]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class u{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,P.toUint32)(S);const R=this.values,I=this.prefixSum,b=D.length;return b===0?!1:(this.values=new Uint32Array(R.length+b),this.values.set(R.subarray(0,S),0),this.values.set(R.subarray(S),S+b),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,D){return S=(0,P.toUint32)(S),D=(0,P.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,P.toUint32)(S),D=(0,P.toUint32)(D);const R=this.values,I=this.prefixSum;if(S>=R.length)return!1;const b=R.length-S;return D>=b&&(D=b),D===0?!1:(this.values=new Uint32Array(R.length-D),this.values.set(R.subarray(0,S),0),this.values.set(R.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,P.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let R=D;R<=S;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let D=0,R=this.values.length-1,I=0,b=0,k=0;for(;D<=R;)if(I=D+(R-D)/2|0,b=this.prefixSum[I],k=b-this.values[I],S<k)R=I-1;else if(S>=b)D=I+1;else break;return new _(I,S-k)}}e.PrefixSumComputer=u;class A{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const D=this._indexBySum[S],R=D>0?this._prefixSum[D-1]:0;return new _(D,S-R)}removeValues(S,D){this._values.splice(S,D),this._invalidate(S)}insertValues(S,D){this._values=(0,a.arrayInsert)(this._values,S,D),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,D=this._values.length;S<D;S++){const R=this._values[S],I=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=I+R;for(let b=0;b<R;b++)this._indexBySum[I+b]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,D){this._values[S]!==D&&(this._values[S]=D,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=A;class _{constructor(S,D){this.index=S,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=_}),define(_e[156],ye([17,18]),function(ie,e){return ie.create("vs/base/common/actions",e)}),define(_e[157],ye([17,18]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(_e[158],ye([1,0,157]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,u=P*60,A=u*24,_=A*7,T=A*30,S=A*365;function D(I,b,k,w){typeof I!="number"&&(I=I.getTime());const f=Math.round((new Date().getTime()-I)/1e3);if(f<-30)return(0,a.localize)(0,null,D(new Date().getTime()+f*1e3,!1));if(!w&&f<30)return(0,a.localize)(1,null);let d;return f<P?(d=f,b?d===1?k?(0,a.localize)(2,null,d):(0,a.localize)(3,null,d):k?(0,a.localize)(4,null,d):(0,a.localize)(5,null,d):d===1?k?(0,a.localize)(6,null,d):(0,a.localize)(7,null,d):k?(0,a.localize)(8,null,d):(0,a.localize)(9,null,d)):f<u?(d=Math.floor(f/P),b?d===1?k?(0,a.localize)(10,null,d):(0,a.localize)(11,null,d):k?(0,a.localize)(12,null,d):(0,a.localize)(13,null,d):d===1?k?(0,a.localize)(14,null,d):(0,a.localize)(15,null,d):k?(0,a.localize)(16,null,d):(0,a.localize)(17,null,d)):f<A?(d=Math.floor(f/u),b?d===1?k?(0,a.localize)(18,null,d):(0,a.localize)(19,null,d):k?(0,a.localize)(20,null,d):(0,a.localize)(21,null,d):d===1?k?(0,a.localize)(22,null,d):(0,a.localize)(23,null,d):k?(0,a.localize)(24,null,d):(0,a.localize)(25,null,d)):f<_?(d=Math.floor(f/A),b?d===1?(0,a.localize)(26,null,d):(0,a.localize)(27,null,d):d===1?(0,a.localize)(28,null,d):(0,a.localize)(29,null,d)):f<T?(d=Math.floor(f/_),b?d===1?k?(0,a.localize)(30,null,d):(0,a.localize)(31,null,d):k?(0,a.localize)(32,null,d):(0,a.localize)(33,null,d):d===1?k?(0,a.localize)(34,null,d):(0,a.localize)(35,null,d):k?(0,a.localize)(36,null,d):(0,a.localize)(37,null,d)):f<S?(d=Math.floor(f/T),b?d===1?k?(0,a.localize)(38,null,d):(0,a.localize)(39,null,d):k?(0,a.localize)(40,null,d):(0,a.localize)(41,null,d):d===1?k?(0,a.localize)(42,null,d):(0,a.localize)(43,null,d):k?(0,a.localize)(44,null,d):(0,a.localize)(45,null,d)):(d=Math.floor(f/S),b?d===1?k?(0,a.localize)(46,null,d):(0,a.localize)(47,null,d):k?(0,a.localize)(48,null,d):(0,a.localize)(49,null,d):d===1?k?(0,a.localize)(50,null,d):(0,a.localize)(51,null,d):k?(0,a.localize)(52,null,d):(0,a.localize)(53,null,d))}e.fromNow=D;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(_e[159],ye([17,18]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(_e[45],ye([1,0,16,9,159]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(I,b){return b&&(I.stack||I.stacktrace)?u.localize(0,null,T(I),_(I.stack)||_(I.stacktrace)):T(I)}function _(I){return Array.isArray(I)?I.join(`
`):I}function T(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?u.localize(1,null,I.message):I.message||u.localize(2,null)}function S(I=null,b=!1){if(!I)return u.localize(3,null);if(Array.isArray(I)){const k=a.coalesce(I),w=S(k[0],b);return k.length>1?u.localize(4,null,w,k.length):w}if(P.isString(I))return I;if(I.detail){const k=I.detail;if(k.error)return A(k.error,b);if(k.exception)return A(k.exception,b)}return I.stack?A(I,b):I.message?I.message:u.localize(5,null)}e.toErrorMessage=S;function D(I){const b=I;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=D;function R(I,b){let k;return typeof I=="string"?k=new Error(I):k=I,k.actions=b,k}e.createErrorWithActions=R}),define(_e[160],ye([17,18]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(_e[12],ye([1,0,160]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let P=!1,u=!1,A=!1,_=!1,T=!1,S=!1,D=!1,R=!1,I=!1,b=!1,k,w=e.LANGUAGE_DEFAULT,f,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const g=typeof h?.versions?.electron=="string",v=g&&h?.type==="renderer";if(typeof navigator=="object"&&!v)d=navigator.userAgent,P=d.indexOf("Windows")>=0,u=d.indexOf("Macintosh")>=0,R=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=d.indexOf("Linux")>=0,b=d?.indexOf("Mobi")>=0,S=!0,k=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,w=k;else if(typeof h=="object"){P=h.platform==="win32",u=h.platform==="darwin",A=h.platform==="linux",_=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,D=g,I=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),c=t.availableLanguages["*"];k=t.locale,w=c||e.LANGUAGE_DEFAULT,f=t._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var C;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function p(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let i=0;u?i=1:P?i=3:A&&(i=2),e.isWindows=P,e.isMacintosh=u,e.isLinux=A,e.isLinuxSnap=_,e.isNative=T,e.isElectron=D,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=b,e.isCI=I,e.platform=i,e.userAgent=d,e.language=w;var o;(function(n){function t(){return e.language}n.value=t;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=c;function E(){return e.language==="en"}n.isDefault=E})(o=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let E=0,y=n.length;E<y;E++){const M=n[E];if(M.id===c.data.vscodeScheduleAsyncWork){n.splice(E,1),M.callback();return}}});let t=0;return c=>{const E=++t;n.push({id:E,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return n=>setTimeout(n)})();var s;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=u||R?2:P?1:3;let l=!0,r=!1;function m(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,l=new Uint16Array(n.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=m,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(_e[33],ye([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let P;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const u=a.globals.vscode.process;P={get platform(){return u.platform},get arch(){return u.arch},get env(){return u.env},cwd(){return u.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=P.cwd,e.env=P.env,e.platform=P.platform,e.arch=P.arch}),define(_e[10],ye([1,0,33]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const P=65,u=97,A=90,_=122,T=46,S=47,D=92,R=58,I=63;class b extends Error{constructor(o,s,l){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const m=o.indexOf(".")!==-1?"property":"argument";let n=`The "${o}" ${m} ${r} of type ${s}`;n+=`. Received type ${typeof l}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function k(i,o){if(i===null||typeof i!="object")throw new b(o,"Object",i)}function w(i,o){if(typeof i!="string")throw new b(o,"string",i)}const f=a.platform==="win32";function d(i){return i===S||i===D}function h(i){return i===S}function g(i){return i>=P&&i<=A||i>=u&&i<=_}function v(i,o,s,l){let r="",m=0,n=-1,t=0,c=0;for(let E=0;E<=i.length;++E){if(E<i.length)c=i.charCodeAt(E);else{if(l(c))break;c=S}if(l(c)){if(!(n===E-1||t===1))if(t===2){if(r.length<2||m!==2||r.charCodeAt(r.length-1)!==T||r.charCodeAt(r.length-2)!==T){if(r.length>2){const y=r.lastIndexOf(s);y===-1?(r="",m=0):(r=r.slice(0,y),m=r.length-1-r.lastIndexOf(s)),n=E,t=0;continue}else if(r.length!==0){r="",m=0,n=E,t=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",m=2)}else r.length>0?r+=`${s}${i.slice(n+1,E)}`:r=i.slice(n+1,E),m=E-n-1;n=E,t=0}else c===T&&t!==-1?++t:t=-1}return r}function C(i,o){k(o,"pathObject");const s=o.dir||o.root,l=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${l}`:`${s}${i}${l}`:l}e.win32={resolve(...i){let o="",s="",l=!1;for(let r=i.length-1;r>=-1;r--){let m;if(r>=0){if(m=i[r],w(m,"path"),m.length===0)continue}else o.length===0?m=a.cwd():(m=a.env[`=${o}`]||a.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==o.toLowerCase()&&m.charCodeAt(2)===D)&&(m=`${o}\\`));const n=m.length;let t=0,c="",E=!1;const y=m.charCodeAt(0);if(n===1)d(y)&&(t=1,E=!0);else if(d(y))if(E=!0,d(m.charCodeAt(1))){let M=2,j=M;for(;M<n&&!d(m.charCodeAt(M));)M++;if(M<n&&M!==j){const $=m.slice(j,M);for(j=M;M<n&&d(m.charCodeAt(M));)M++;if(M<n&&M!==j){for(j=M;M<n&&!d(m.charCodeAt(M));)M++;(M===n||M!==j)&&(c=`\\\\${$}\\${m.slice(j,M)}`,t=M)}}}else t=1;else g(y)&&m.charCodeAt(1)===R&&(c=m.slice(0,2),t=2,n>2&&d(m.charCodeAt(2))&&(E=!0,t=3));if(c.length>0)if(o.length>0){if(c.toLowerCase()!==o.toLowerCase())continue}else o=c;if(l){if(o.length>0)break}else if(s=`${m.slice(t)}\\${s}`,l=E,E&&o.length>0)break}return s=v(s,!l,"\\",d),l?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){w(i,"path");const o=i.length;if(o===0)return".";let s=0,l,r=!1;const m=i.charCodeAt(0);if(o===1)return h(m)?"\\":i;if(d(m))if(r=!0,d(i.charCodeAt(1))){let t=2,c=t;for(;t<o&&!d(i.charCodeAt(t));)t++;if(t<o&&t!==c){const E=i.slice(c,t);for(c=t;t<o&&d(i.charCodeAt(t));)t++;if(t<o&&t!==c){for(c=t;t<o&&!d(i.charCodeAt(t));)t++;if(t===o)return`\\\\${E}\\${i.slice(c)}\\`;t!==c&&(l=`\\\\${E}\\${i.slice(c,t)}`,s=t)}}}else s=1;else g(m)&&i.charCodeAt(1)===R&&(l=i.slice(0,2),s=2,o>2&&d(i.charCodeAt(2))&&(r=!0,s=3));let n=s<o?v(i.slice(s),!r,"\\",d):"";return n.length===0&&!r&&(n="."),n.length>0&&d(i.charCodeAt(o-1))&&(n+="\\"),l===void 0?r?`\\${n}`:n:r?`${l}\\${n}`:`${l}${n}`},isAbsolute(i){w(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return d(s)||o>2&&g(s)&&i.charCodeAt(1)===R&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let m=0;m<i.length;++m){const n=i[m];w(n,"path"),n.length>0&&(o===void 0?o=s=n:o+=`\\${n}`)}if(o===void 0)return".";let l=!0,r=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++r;const m=s.length;m>1&&d(s.charCodeAt(1))&&(++r,m>2&&(d(s.charCodeAt(2))?++r:l=!1))}if(l){for(;r<o.length&&d(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(i,o){if(w(i,"from"),w(o,"to"),i===o)return"";const s=e.win32.resolve(i),l=e.win32.resolve(o);if(s===l||(i=s.toLowerCase(),o=l.toLowerCase(),i===o))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===D;)r++;let m=i.length;for(;m-1>r&&i.charCodeAt(m-1)===D;)m--;const n=m-r;let t=0;for(;t<o.length&&o.charCodeAt(t)===D;)t++;let c=o.length;for(;c-1>t&&o.charCodeAt(c-1)===D;)c--;const E=c-t,y=n<E?n:E;let M=-1,j=0;for(;j<y;j++){const N=i.charCodeAt(r+j);if(N!==o.charCodeAt(t+j))break;N===D&&(M=j)}if(j!==y){if(M===-1)return l}else{if(E>y){if(o.charCodeAt(t+j)===D)return l.slice(t+j+1);if(j===2)return l.slice(t+j)}n>y&&(i.charCodeAt(r+j)===D?M=j:j===2&&(M=3)),M===-1&&(M=0)}let $="";for(j=r+M+1;j<=m;++j)(j===m||i.charCodeAt(j)===D)&&($+=$.length===0?"..":"\\..");return t+=M,$.length>0?`${$}${l.slice(t,c)}`:(l.charCodeAt(t)===D&&++t,l.slice(t,c))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===D){if(o.charCodeAt(1)===D){const s=o.charCodeAt(2);if(s!==I&&s!==T)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===R&&o.charCodeAt(2)===D)return`\\\\?\\${o}`;return i},dirname(i){w(i,"path");const o=i.length;if(o===0)return".";let s=-1,l=0;const r=i.charCodeAt(0);if(o===1)return d(r)?i:".";if(d(r)){if(s=l=1,d(i.charCodeAt(1))){let t=2,c=t;for(;t<o&&!d(i.charCodeAt(t));)t++;if(t<o&&t!==c){for(c=t;t<o&&d(i.charCodeAt(t));)t++;if(t<o&&t!==c){for(c=t;t<o&&!d(i.charCodeAt(t));)t++;if(t===o)return i;t!==c&&(s=l=t+1)}}}}else g(r)&&i.charCodeAt(1)===R&&(s=o>2&&d(i.charCodeAt(2))?3:2,l=s);let m=-1,n=!0;for(let t=o-1;t>=l;--t)if(d(i.charCodeAt(t))){if(!n){m=t;break}}else n=!1;if(m===-1){if(s===-1)return".";m=s}return i.slice(0,m)},basename(i,o){o!==void 0&&w(o,"ext"),w(i,"path");let s=0,l=-1,r=!0,m;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(m=i.length-1;m>=s;--m){const c=i.charCodeAt(m);if(d(c)){if(!r){s=m+1;break}}else t===-1&&(r=!1,t=m+1),n>=0&&(c===o.charCodeAt(n)?--n===-1&&(l=m):(n=-1,l=t))}return s===l?l=t:l===-1&&(l=i.length),i.slice(s,l)}for(m=i.length-1;m>=s;--m)if(d(i.charCodeAt(m))){if(!r){s=m+1;break}}else l===-1&&(r=!1,l=m+1);return l===-1?"":i.slice(s,l)},extname(i){w(i,"path");let o=0,s=-1,l=0,r=-1,m=!0,n=0;i.length>=2&&i.charCodeAt(1)===R&&g(i.charCodeAt(0))&&(o=l=2);for(let t=i.length-1;t>=o;--t){const c=i.charCodeAt(t);if(d(c)){if(!m){l=t+1;break}continue}r===-1&&(m=!1,r=t+1),c===T?s===-1?s=t:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||r===-1||n===0||n===1&&s===r-1&&s===l+1?"":i.slice(s,r)},format:C.bind(null,"\\"),parse(i){w(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let l=0,r=i.charCodeAt(0);if(s===1)return d(r)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(d(r)){if(l=1,d(i.charCodeAt(1))){let M=2,j=M;for(;M<s&&!d(i.charCodeAt(M));)M++;if(M<s&&M!==j){for(j=M;M<s&&d(i.charCodeAt(M));)M++;if(M<s&&M!==j){for(j=M;M<s&&!d(i.charCodeAt(M));)M++;M===s?l=M:M!==j&&(l=M+1)}}}}else if(g(r)&&i.charCodeAt(1)===R){if(s<=2)return o.root=o.dir=i,o;if(l=2,d(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;l=3}}l>0&&(o.root=i.slice(0,l));let m=-1,n=l,t=-1,c=!0,E=i.length-1,y=0;for(;E>=l;--E){if(r=i.charCodeAt(E),d(r)){if(!c){n=E+1;break}continue}t===-1&&(c=!1,t=E+1),r===T?m===-1?m=E:y!==1&&(y=1):m!==-1&&(y=-1)}return t!==-1&&(m===-1||y===0||y===1&&m===t-1&&m===n+1?o.base=o.name=i.slice(n,t):(o.name=i.slice(n,m),o.base=i.slice(n,t),o.ext=i.slice(m,t))),n>0&&n!==l?o.dir=i.slice(0,n-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(f){const i=/\\/g;return()=>{const o=a.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...i){let o="",s=!1;for(let l=i.length-1;l>=-1&&!s;l--){const r=l>=0?i[l]:p();w(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===S)}return o=v(o,!s,"/",h),s?`/${o}`:o.length>0?o:"."},normalize(i){if(w(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S,s=i.charCodeAt(i.length-1)===S;return i=v(i,!o,"/",h),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return w(i,"path"),i.length>0&&i.charCodeAt(0)===S},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const l=i[s];w(l,"path"),l.length>0&&(o===void 0?o=l:o+=`/${l}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(w(i,"from"),w(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const s=1,l=i.length,r=l-s,m=1,n=o.length-m,t=r<n?r:n;let c=-1,E=0;for(;E<t;E++){const M=i.charCodeAt(s+E);if(M!==o.charCodeAt(m+E))break;M===S&&(c=E)}if(E===t)if(n>t){if(o.charCodeAt(m+E)===S)return o.slice(m+E+1);if(E===0)return o.slice(m+E)}else r>t&&(i.charCodeAt(s+E)===S?c=E:E===0&&(c=0));let y="";for(E=s+c+1;E<=l;++E)(E===l||i.charCodeAt(E)===S)&&(y+=y.length===0?"..":"/..");return`${y}${o.slice(m+c)}`},toNamespacedPath(i){return i},dirname(i){if(w(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S;let s=-1,l=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===S){if(!l){s=r;break}}else l=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&w(o,"ext"),w(i,"path");let s=0,l=-1,r=!0,m;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(m=i.length-1;m>=0;--m){const c=i.charCodeAt(m);if(c===S){if(!r){s=m+1;break}}else t===-1&&(r=!1,t=m+1),n>=0&&(c===o.charCodeAt(n)?--n===-1&&(l=m):(n=-1,l=t))}return s===l?l=t:l===-1&&(l=i.length),i.slice(s,l)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===S){if(!r){s=m+1;break}}else l===-1&&(r=!1,l=m+1);return l===-1?"":i.slice(s,l)},extname(i){w(i,"path");let o=-1,s=0,l=-1,r=!0,m=0;for(let n=i.length-1;n>=0;--n){const t=i.charCodeAt(n);if(t===S){if(!r){s=n+1;break}continue}l===-1&&(r=!1,l=n+1),t===T?o===-1?o=n:m!==1&&(m=1):o!==-1&&(m=-1)}return o===-1||l===-1||m===0||m===1&&o===l-1&&o===s+1?"":i.slice(o,l)},format:C.bind(null,"/"),parse(i){w(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===S;let l;s?(o.root="/",l=1):l=0;let r=-1,m=0,n=-1,t=!0,c=i.length-1,E=0;for(;c>=l;--c){const y=i.charCodeAt(c);if(y===S){if(!t){m=c+1;break}continue}n===-1&&(t=!1,n=c+1),y===T?r===-1?r=c:E!==1&&(E=1):r!==-1&&(E=-1)}if(n!==-1){const y=m===0&&s?1:m;r===-1||E===0||E===1&&r===n-1&&r===m+1?o.base=o.name=i.slice(y,n):(o.name=i.slice(y,r),o.base=i.slice(y,n),o.ext=i.slice(r,n))}return m>0?o.dir=i.slice(0,m-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(_e[108],ye([1,0,65,10]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const u=new a.Lazy(()=>{const t=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:t,collatorIsNumeric:t.resolvedOptions().numeric}}),A=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(t,c,E=!1){const y=t||"",M=c||"",j=u.value.collator.compare(y,M);return u.value.collatorIsNumeric&&j===0&&y!==M?y<M?-1:1:j}e.compareFileNames=T;function S(t,c){const E=A.value.collator;return t=t||"",c=c||"",C(E,t,c)}e.compareFileNamesDefault=S;function D(t,c){const E=A.value.collator;return t=t||"",c=c||"",s(t,c)||C(E,t,c)}e.compareFileNamesUpper=D;function R(t,c){const E=A.value.collator;return t=t||"",c=c||"",o(t,c)||C(E,t,c)}e.compareFileNamesLower=R;function I(t,c){return t=t||"",c=c||"",t===c?0:t<c?-1:1}e.compareFileNamesUnicode=I;function b(t,c){const[E,y]=g(t),[M,j]=g(c);let $=u.value.collator.compare(y,j);if($===0){if(u.value.collatorIsNumeric&&y!==j)return y<j?-1:1;if($=u.value.collator.compare(E,M),u.value.collatorIsNumeric&&$===0&&E!==M)return E<M?-1:1}return $}e.compareFileExtensions=b;function k(t,c){t=t||"",c=c||"";const E=v(t),y=v(c),M=A.value.collator,j=_.value.collator;return C(j,E,y)||C(M,t,c)}e.compareFileExtensionsDefault=k;function w(t,c){t=t||"",c=c||"";const E=v(t),y=v(c),M=A.value.collator,j=_.value.collator;return C(j,E,y)||s(t,c)||C(M,t,c)}e.compareFileExtensionsUpper=w;function f(t,c){t=t||"",c=c||"";const E=v(t),y=v(c),M=A.value.collator,j=_.value.collator;return C(j,E,y)||o(t,c)||C(M,t,c)}e.compareFileExtensionsLower=f;function d(t,c){t=t||"",c=c||"";const E=v(t).toLowerCase(),y=v(c).toLowerCase();return E!==y?E<y?-1:1:t!==c?t<c?-1:1:0}e.compareFileExtensionsUnicode=d;const h=/^(.*?)(\.([^.]*))?$/;function g(t,c=!1){const E=t?h.exec(t):[];let y=[E&&E[1]||"",E&&E[3]||""];return c&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function v(t){const c=t?h.exec(t):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function C(t,c,E){const y=t.compare(c,E);return y!==0?y:c.length!==E.length?c.length<E.length?-1:1:0}function p(t){const c=t.charAt(0);return c.toLocaleUpperCase()!==c}function i(t){const c=t.charAt(0);return c.toLocaleLowerCase()!==c}function o(t,c){return p(t)&&i(c)?-1:i(t)&&p(c)?1:0}function s(t,c){return i(t)&&p(c)?-1:p(t)&&i(c)?1:0}function l(t,c,E=!1){return E||(t=t&&t.toLowerCase(),c=c&&c.toLowerCase()),t===c?0:t<c?-1:1}function r(t,c,E=!1){const y=t.split(P.sep),M=c.split(P.sep),j=y.length-1,$=M.length-1;let N,x;for(let L=0;;L++){if(N=j===L,x=$===L,N&&x)return T(y[L],M[L],E);if(N)return-1;if(x)return 1;const F=l(y[L],M[L],E);if(F!==0)return F}}e.comparePaths=r;function m(t,c,E){const y=t.toLowerCase(),M=c.toLowerCase(),j=n(t,c,E);if(j)return j;const $=y.endsWith(E),N=M.endsWith(E);if($!==N)return $?-1:1;const x=T(y,M);return x!==0?x:y.localeCompare(M)}e.compareAnything=m;function n(t,c,E){const y=t.toLowerCase(),M=c.toLowerCase(),j=y.startsWith(E),$=M.startsWith(E);if(j!==$)return j?-1:1;if(j&&$){if(y.length<M.length)return-1;if(y.length>M.length)return 1}return 0}e.compareByPrefix=n}),define(_e[87],ye([1,0,10]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},u={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const I=(0,a.extname)(R),b=P[I.toLowerCase()];return b!==void 0?b:_(R)}e.getMediaOrTextMime=A;function _(R){const I=(0,a.extname)(R);return u[I.toLowerCase()]}e.getMediaMime=_;function T(R){for(const I in u)if(u[I]===R)return I}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function D(R,I){const b=S.exec(R);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:I?void 0:R}e.normalizeMimeType=D}),define(_e[109],ye([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var P;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(P=e.Source||(e.Source={}));var u;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(u=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(T,...S){const D=S.reduce((b,k)=>(b[k]=!0,b),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(b=>!D[b]).forEach(b=>{for(let k=0;k<R.length;k++)if(b.search(R[k])!==-1){delete T[b];break}})}e.sanitizeProcessEnvironment=A;function _(T){!T||(delete T.DEBUG,a.isMacintosh&&delete T.DYLD_LIBRARY_PATH,a.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(_e[43],ye([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=a.globals.performance&&typeof a.globals.performance.now=="function";class u{static create(_=!0){return new u(_)}constructor(_){this._highResolution=P&&_,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?a.globals.performance.now():Date.now()}}e.StopWatch=u}),define(_e[3],ye([1,0,11,63,6,66,43]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var D;(function(m){m.None=()=>u.Disposable.None;function n(be){if(S){const{onDidAddListener:Ie}=be,Le=w.create();let oe=0;be.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Le.print()),Ie?.()}}}function t(be,Ie){return L(be,()=>{},0,void 0,void 0,Ie)}m.defer=t;function c(be){return(Ie,Le=null,oe)=>{let ae=!1,fe;return fe=be(ee=>{if(!ae)return fe?fe.dispose():ae=!0,Ie.call(Le,ee)},null,oe),ae&&fe.dispose(),fe}}m.once=c;function E(be,Ie,Le){return x((oe,ae=null,fe)=>be(ee=>oe.call(ae,Ie(ee)),null,fe),Le)}m.map=E;function y(be,Ie,Le){return x((oe,ae=null,fe)=>be(ee=>{Ie(ee),oe.call(ae,ee)},null,fe),Le)}m.forEach=y;function M(be,Ie,Le){return x((oe,ae=null,fe)=>be(ee=>Ie(ee)&&oe.call(ae,ee),null,fe),Le)}m.filter=M;function j(be){return be}m.signal=j;function $(...be){return(Ie,Le=null,oe)=>(0,u.combinedDisposable)(...be.map(ae=>ae(fe=>Ie.call(Le,fe),null,oe)))}m.any=$;function N(be,Ie,Le,oe){let ae=Le;return E(be,fe=>(ae=Ie(ae,fe),ae),oe)}m.reduce=N;function x(be,Ie){let Le;const oe={onWillAddFirstListener(){Le=be(ae.fire,ae)},onDidRemoveLastListener(){Le?.dispose()}};Ie||n(oe);const ae=new d(oe);return Ie?.add(ae),ae.event}function L(be,Ie,Le=100,oe=!1,ae,fe){let ee,le,re,O=0;const W={leakWarningThreshold:ae,onWillAddFirstListener(){ee=be(Q=>{O++,le=Ie(le,Q),oe&&!re&&(G.fire(le),le=void 0);const he=()=>{const Ee=le;le=void 0,re=void 0,(!oe||O>1)&&G.fire(Ee),O=0};typeof Le=="number"?(clearTimeout(re),re=setTimeout(he,Le)):re===void 0&&(re=0,queueMicrotask(he))})},onDidRemoveLastListener(){ee.dispose()}};fe||n(W);const G=new d(W);return fe?.add(G),G.event}m.debounce=L;function F(be,Ie=0,Le){return m.debounce(be,(oe,ae)=>oe?(oe.push(ae),oe):[ae],Ie,void 0,void 0,Le)}m.accumulate=F;function U(be,Ie=(oe,ae)=>oe===ae,Le){let oe=!0,ae;return M(be,fe=>{const ee=oe||!Ie(fe,ae);return oe=!1,ae=fe,ee},Le)}m.latch=U;function H(be,Ie,Le){return[m.filter(be,Ie,Le),m.filter(be,oe=>!Ie(oe),Le)]}m.split=H;function de(be,Ie=!1,Le=[]){let oe=Le.slice(),ae=be(le=>{oe?oe.push(le):ee.fire(le)});const fe=()=>{oe?.forEach(le=>ee.fire(le)),oe=null},ee=new d({onWillAddFirstListener(){ae||(ae=be(le=>ee.fire(le)))},onDidAddFirstListener(){oe&&(Ie?setTimeout(fe):fe())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return ee.event}m.buffer=de;class Y{constructor(Ie){this.event=Ie,this.disposables=new u.DisposableStore}map(Ie){return new Y(E(this.event,Ie,this.disposables))}forEach(Ie){return new Y(y(this.event,Ie,this.disposables))}filter(Ie){return new Y(M(this.event,Ie,this.disposables))}reduce(Ie,Le){return new Y(N(this.event,Ie,Le,this.disposables))}latch(){return new Y(U(this.event,void 0,this.disposables))}debounce(Ie,Le=100,oe=!1,ae){return new Y(L(this.event,Ie,Le,oe,ae,this.disposables))}on(Ie,Le,oe){return this.event(Ie,Le,oe)}once(Ie,Le,oe){return c(this.event)(Ie,Le,oe)}dispose(){this.disposables.dispose()}}function V(be){return new Y(be)}m.chain=V;function X(be,Ie,Le=oe=>oe){const oe=(...le)=>ee.fire(Le(...le)),ae=()=>be.on(Ie,oe),fe=()=>be.removeListener(Ie,oe),ee=new d({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return ee.event}m.fromNodeEventEmitter=X;function Z(be,Ie,Le=oe=>oe){const oe=(...le)=>ee.fire(Le(...le)),ae=()=>be.addEventListener(Ie,oe),fe=()=>be.removeEventListener(Ie,oe),ee=new d({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return ee.event}m.fromDOMEventEmitter=Z;function te(be){return new Promise(Ie=>c(be)(Ie))}m.toPromise=te;function K(be,Ie){return Ie(void 0),be(Le=>Ie(Le))}m.runAndSubscribe=K;function J(be,Ie){let Le=null;function oe(fe){Le?.dispose(),Le=new u.DisposableStore,Ie(fe,Le)}oe(void 0);const ae=be(fe=>oe(fe));return(0,u.toDisposable)(()=>{ae.dispose(),Le?.dispose()})}m.runAndSubscribeWithStore=J;class ne{constructor(Ie,Le){this.obs=Ie,this._counter=0,this._hasChanged=!1;const oe={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Le||n(oe),this.emitter=new d(oe),Le&&Le.add(this.emitter)}beginUpdate(Ie){this._counter++}handleChange(Ie,Le){this._hasChanged=!0}endUpdate(Ie){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function pe(be,Ie){return new ne(be,Ie).emitter.event}m.fromObservable=pe})(D=e.Event||(e.Event={}));class R{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${R._idPool++}`,R.all.add(this)}start(n){this._stopWatch=new _.StopWatch(!0),this.listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this._stopWatch=void 0}}}R.all=new Set,R._idPool=0,e.EventProfiling=R;let I=-1;function b(m){const n=I;return I=m,{dispose(){I=n}}}e.setGlobalLeakWarningThreshold=b;class k{constructor(n,t=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=t,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(n,t){const c=this.threshold;if(c<=0||t<c)return;this._stacks||(this._stacks=new Map);const E=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,E+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let y,M=0;for(const[j,$]of this._stacks)(!y||M<$)&&(y=j,M=$);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${M}):`),console.warn(y)}return()=>{const y=this._stacks.get(n.value)||0;this._stacks.set(n.value,y-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(n,t,c){this.callback=n,this.callbackThis=t,this.stack=c,this.subscription=new u.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class d{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=I>0||this._options?.leakWarningThreshold?new k(this._options?.leakWarningThreshold??I):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(T){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const t of n)t.subscription.isset()&&(t.subscription.unset(),t.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,t,c)=>{if(this._listeners||(this._listeners=new A.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),u.Disposable.None;const E=this._listeners.isEmpty();E&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let y,M;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(M=w.create(),y=this._leakageMon.check(M,this._listeners.size+1)),T&&(M=M??w.create());const j=new f(n,t,M),$=this._listeners.push(j);E&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,n,t);const N=j.subscription.set(()=>{y?.(),this._disposed||($(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return c instanceof u.DisposableStore?c.add(N):Array.isArray(c)&&c.push(N),N}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const t of this._listeners)this._deliveryQueue.push(this,t,n);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=d;class h{constructor(){this._queue=new A.LinkedList}get size(){return this._queue.size}push(n,t,c){this._queue.push(new v(n,t,c))}clear(n){const t=new A.LinkedList;for(const c of this._queue)c.emitter!==n&&t.push(c);this._queue=t}deliver(){for(;this._queue.size>0;){const n=this._queue.shift();try{n.listener.invoke(n.event)}catch(t){(0,a.onUnexpectedError)(t)}}}}e.EventDeliveryQueue=h;class g extends h{clear(n){this._queue.clear()}}class v{constructor(n,t,c){this.emitter=n,this.listener=t,this.event=c}}class C extends d{async fireAsync(n,t,c){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const E of this._listeners)this._asyncDeliveryQueue.push([E,n]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[E,y]=this._asyncDeliveryQueue.shift(),M=[],j={...y,token:t,waitUntil:$=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");c&&($=c($,E.callback)),M.push($)}};try{E.invoke(j)}catch($){(0,a.onUnexpectedError)($);continue}Object.freeze(M),await Promise.allSettled(M).then($=>{for(const N of $)N.status==="rejected"&&(0,a.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=C;class p extends d{constructor(n){super(n),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=p;class i extends p{constructor(n){super(n),this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=i;class o extends d{constructor(n){super(n),this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){!this.hasListeners()||(this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const t={event:n,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const c=()=>{this.hasListeners&&this.unhook(t);const E=this.events.indexOf(t);this.events.splice(E,1)};return(0,u.toDisposable)((0,P.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(t=>this.emitter.fire(t))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class l{constructor(){this.buffers=[]}wrapEvent(n){return(t,c,E)=>n(y=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>t.call(c,y)):t.call(c,y)},void 0,E)}bufferEvents(n){const t=[];this.buffers.push(t);const c=n();return this.buffers.pop(),t.forEach(E=>E()),c}}e.EventBufferer=l;class r{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=u.Disposable.None,this.emitter=new d({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(_e[161],ye([1,0,3,6,156]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class A extends P.Disposable{constructor(b,k="",w="",f=!0,d){super(),this._onDidChange=this._register(new a.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=b,this._label=k,this._cssClass=w,this._enabled=f,this._actionCallback=d}get id(){return this._id}get label(){return this._label}set label(b){this._setLabel(b)}_setLabel(b){this._label!==b&&(this._label=b,this._onDidChange.fire({label:b}))}get tooltip(){return this._tooltip||""}set tooltip(b){this._setTooltip(b)}_setTooltip(b){this._tooltip!==b&&(this._tooltip=b,this._onDidChange.fire({tooltip:b}))}get class(){return this._cssClass}set class(b){this._setClass(b)}_setClass(b){this._cssClass!==b&&(this._cssClass=b,this._onDidChange.fire({class:b}))}get enabled(){return this._enabled}set enabled(b){this._setEnabled(b)}_setEnabled(b){this._enabled!==b&&(this._enabled=b,this._onDidChange.fire({enabled:b}))}get checked(){return this._checked}set checked(b){this._setChecked(b)}_setChecked(b){this._checked!==b&&(this._checked=b,this._onDidChange.fire({checked:b}))}async run(b,k){this._actionCallback&&await this._actionCallback(b)}}e.Action=A;class _ extends P.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new a.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new a.Emitter),this.onDidRun=this._onDidRun.event}async run(b,k){if(!b.enabled)return;this._onWillRun.fire({action:b});let w;try{await this.runAction(b,k)}catch(f){w=f}this._onDidRun.fire({action:b,error:w})}async runAction(b,k){await b.run(k)}}e.ActionRunner=_;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let k=[];for(const w of b)w.length&&(k.length?k=[...k,new T,...w]:k=w);return k}async run(){}}T.ID="vs.actions.separator",e.Separator=T;class S{get actions(){return this._actions}constructor(b,k,w,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=k,this.class=f,this._actions=w}async run(){}}e.SubmenuAction=S;class D extends A{constructor(){super(D.ID,u.localize(0,null),void 0,!1)}}D.ID="vs.actions.empty",e.EmptySubmenuAction=D;function R(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.toAction=R}),define(_e[21],ye([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const P=Object.freeze(function(T,S){const D=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(D)}}});var u;(function(T){function S(D){return D===T.None||D===T.Cancelled||D instanceof A?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(u=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new a.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=u.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=u.None}}e.CancellationTokenSource=_}),define(_e[162],ye([1,0,21]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class P{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new a.CancellationTokenSource,S=this.task(T.token);return this.result={promise:S,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=P;class u{constructor(T){this.fn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const S=JSON.stringify(T);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.fn(T)),this.lastCache}}e.LRUCachedFunction=u;class A{get cachedValues(){return this._map}constructor(T){this.fn=T,this._map=new Map}get(T){if(this._map.has(T))return this._map.get(T);const S=this.fn(T);return this._map.set(T,S),S}}e.CachedFunction=A}),define(_e[8],ye([1,0,162,65]),function(ie,e,a,P){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=A;const _=/{(\d+)}/g;function T(B,...ue){return ue.length===0?B:B.replace(_,function(De,Re){const xe=parseInt(Re,10);return isNaN(xe)||xe<0||xe>=ue.length?De:ue[xe]})}e.format=T;const S=/{([^}]+)}/g;function D(B,ue){return B.replace(S,(De,Re)=>ue[Re]??De)}e.format2=D;function R(B){return B.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=R;function I(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function b(B,ue){let De=0;const Re=ue.charCodeAt(0);for(let xe=B.length-1;xe>=0;xe--)B.charCodeAt(xe)===Re&&De++;return De}e.count=b;function k(B,ue,De="\u2026"){return B.length<=ue?B:`${B.substr(0,ue)}${De}`}e.truncate=k;function w(B,ue=" "){const De=f(B,ue);return d(De,ue)}e.trim=w;function f(B,ue){if(!B||!ue)return B;const De=ue.length;if(De===0||B.length===0)return B;let Re=0;for(;B.indexOf(ue,Re)===Re;)Re=Re+De;return B.substring(Re)}e.ltrim=f;function d(B,ue){if(!B||!ue)return B;const De=ue.length,Re=B.length;if(De===0||Re===0)return B;let xe=Re,Ge=-1;for(;Ge=B.lastIndexOf(ue,xe-1),!(Ge===-1||Ge+De!==xe);){if(Ge===0)return"";xe=Ge}return B.substring(0,xe)}e.rtrim=d;function h(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g(B){return B.replace(/\*/g,"")}e.stripWildcards=g;function v(B,ue,De={}){if(!B)throw new Error("Cannot create regex from empty string");ue||(B=I(B)),De.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let Re="";return De.global&&(Re+="g"),De.matchCase||(Re+="i"),De.multiline&&(Re+="m"),De.unicode&&(Re+="u"),new RegExp(B,Re)}e.createRegExp=v;function C(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function p(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function i(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=i;function o(B){return B.split(/\r\n|\r|\n/)}e.splitLines=o;function s(B){for(let ue=0,De=B.length;ue<De;ue++){const Re=B.charCodeAt(ue);if(Re!==32&&Re!==9)return ue}return-1}e.firstNonWhitespaceIndex=s;function l(B,ue=0,De=B.length){for(let Re=ue;Re<De;Re++){const xe=B.charCodeAt(Re);if(xe!==32&&xe!==9)return B.substring(ue,Re)}return B.substring(ue,De)}e.getLeadingWhitespace=l;function r(B,ue=B.length-1){for(let De=ue;De>=0;De--){const Re=B.charCodeAt(De);if(Re!==32&&Re!==9)return De}return-1}e.lastNonWhitespaceIndex=r;function m(B,ue,De){const Re=[];let xe=0;for(const Ge of B.matchAll(ue)){if(Re.push(B.slice(xe,Ge.index)),Ge.index===void 0)throw new Error("match.index should be defined");xe=Ge.index+Ge[0].length,Re.push(De(Ge[0],...Ge.slice(1),Ge.index,B,Ge.groups))}return Re.push(B.slice(xe)),Promise.all(Re).then(Ge=>Ge.join(""))}e.replaceAsync=m;function n(B,ue){return B<ue?-1:B>ue?1:0}e.compare=n;function t(B,ue,De=0,Re=B.length,xe=0,Ge=ue.length){for(;De<Re&&xe<Ge;De++,xe++){const gt=B.charCodeAt(De),ct=ue.charCodeAt(xe);if(gt<ct)return-1;if(gt>ct)return 1}const Ze=Re-De,pt=Ge-xe;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstring=t;function c(B,ue){return E(B,ue,0,B.length,0,ue.length)}e.compareIgnoreCase=c;function E(B,ue,De=0,Re=B.length,xe=0,Ge=ue.length){for(;De<Re&&xe<Ge;De++,xe++){let gt=B.charCodeAt(De),ct=ue.charCodeAt(xe);if(gt===ct)continue;if(gt>=128||ct>=128)return t(B.toLowerCase(),ue.toLowerCase(),De,Re,xe,Ge);M(gt)&&(gt-=32),M(ct)&&(ct-=32);const wt=gt-ct;if(wt!==0)return wt}const Ze=Re-De,pt=Ge-xe;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstringIgnoreCase=E;function y(B){return B>=48&&B<=57}e.isAsciiDigit=y;function M(B){return B>=97&&B<=122}e.isLowerAsciiLetter=M;function j(B){return B>=65&&B<=90}e.isUpperAsciiLetter=j;function $(B,ue){return B.length===ue.length&&E(B,ue)===0}e.equalsIgnoreCase=$;function N(B,ue){const De=ue.length;return ue.length>B.length?!1:E(B,ue,0,De)===0}e.startsWithIgnoreCase=N;function x(B,ue){const De=Math.min(B.length,ue.length);let Re;for(Re=0;Re<De;Re++)if(B.charCodeAt(Re)!==ue.charCodeAt(Re))return Re;return De}e.commonPrefixLength=x;function L(B,ue){const De=Math.min(B.length,ue.length);let Re;const xe=B.length-1,Ge=ue.length-1;for(Re=0;Re<De;Re++)if(B.charCodeAt(xe-Re)!==ue.charCodeAt(Ge-Re))return Re;return De}e.commonSuffixLength=L;function F(B){return 55296<=B&&B<=56319}e.isHighSurrogate=F;function U(B){return 56320<=B&&B<=57343}e.isLowSurrogate=U;function H(B,ue){return(B-55296<<10)+(ue-56320)+65536}e.computeCodePoint=H;function de(B,ue,De){const Re=B.charCodeAt(De);if(F(Re)&&De+1<ue){const xe=B.charCodeAt(De+1);if(U(xe))return H(Re,xe)}return Re}e.getNextCodePoint=de;function Y(B,ue){const De=B.charCodeAt(ue-1);if(U(De)&&ue>1){const Re=B.charCodeAt(ue-2);if(F(Re))return H(Re,De)}return De}class V{get offset(){return this._offset}constructor(ue,De=0){this._str=ue,this._len=ue.length,this._offset=De}setOffset(ue){this._offset=ue}prevCodePoint(){const ue=Y(this._str,this._offset);return this._offset-=ue>=65536?2:1,ue}nextCodePoint(){const ue=de(this._str,this._len,this._offset);return this._offset+=ue>=65536?2:1,ue}eol(){return this._offset>=this._len}}e.CodePointIterator=V;class X{get offset(){return this._iterator.offset}constructor(ue,De=0){this._iterator=new V(ue,De)}nextGraphemeLength(){const ue=et.getInstance(),De=this._iterator,Re=De.offset;let xe=ue.getGraphemeBreakType(De.nextCodePoint());for(;!De.eol();){const Ge=De.offset,Ze=ue.getGraphemeBreakType(De.nextCodePoint());if($e(xe,Ze)){De.setOffset(Ge);break}xe=Ze}return De.offset-Re}prevGraphemeLength(){const ue=et.getInstance(),De=this._iterator,Re=De.offset;let xe=ue.getGraphemeBreakType(De.prevCodePoint());for(;De.offset>0;){const Ge=De.offset,Ze=ue.getGraphemeBreakType(De.prevCodePoint());if($e(Ze,xe)){De.setOffset(Ge);break}xe=Ze}return Re-De.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function Z(B,ue){return new X(B,ue).nextGraphemeLength()}e.nextCharLength=Z;function te(B,ue){return new X(B,ue).prevGraphemeLength()}e.prevCharLength=te;function K(B,ue){ue>0&&U(B.charCodeAt(ue))&&ue--;const De=ue+Z(B,ue);return[De-te(B,De),De]}e.getCharContainingOffset=K;function J(B){const ue=new X(B);let De=0;for(;!ue.eol();)De++,ue.nextGraphemeLength();return De}e.charCount=J;let ne;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(B){return ne||(ne=pe()),ne.test(B)}e.containsRTL=be;const Ie=/^[\t\n\r\x20-\x7E]*$/;function Le(B){return Ie.test(B)}e.isBasicASCII=Le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=oe;function ae(B){return B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=ae;function fe(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129008||B>=129280&&B<=129535||B>=129648&&B<=129782}e.isEmojiImprecise=fe;function ee(B,ue){if(B.length<ue)return B;const De=/\b/g;let Re=0;for(;De.test(B)&&!(B.length-De.lastIndex<ue);)Re=De.lastIndex,De.lastIndex+=1;return B.substring(Re).replace(/^\s/,"")}e.lcut=ee;const le=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function W(B){return B&&(B=B.replace(le,""),B=B.replace(re,""),B=B.replace(O,"")),B}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function Q(B){return G(B)?B.substr(1):B}e.stripUTF8BOM=Q;function he(B,ue){if(!B||!ue||B.length<ue.length)return!1;const De=ue.length,Re=B.toLowerCase();let xe=0,Ge=-1;for(;xe<De;){const Ze=Re.indexOf(ue[xe],Ge+1);if(Ze<0)return!1;Ge=Ze,xe++}return!0}e.fuzzyContains=he;function Ee(B,ue=!1){return B?(ue&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=Ee;function Pe(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Pe;function ve(B,ue=1){if(ue===0)return"";let De=-1;do De=B.indexOf(`
`,De+1),ue--;while(ue>0&&De>=0);return De===-1?B:(B[De-1]==="\r"&&De--,B.substr(0,De))}e.getNLines=ve;function Ce(B){return B=B%(2*26),B<26?String.fromCharCode(97+B):String.fromCharCode(65+B-26)}e.singleLetterHash=Ce;function ke(B){return et.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=ke;function $e(B,ue){return B===0?ue!==5&&ue!==7:B===2&&ue===3?!1:B===4||B===2||B===3||ue===4||ue===2||ue===3?!0:!(B===8&&(ue===8||ue===9||ue===11||ue===12)||(B===11||B===9)&&(ue===9||ue===10)||(B===12||B===10)&&ue===10||ue===5||ue===13||ue===7||B===1||B===13&&ue===14||B===6&&ue===6)}var je;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et._INSTANCE||(et._INSTANCE=new et),et._INSTANCE}constructor(){this._data=Xe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const De=this._data,Re=De.length/3;let xe=1;for(;xe<=Re;)if(ue<De[3*xe])xe=2*xe;else if(ue>De[3*xe+1])xe=2*xe+1;else return De[3*xe+2];return 0}}et._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(B,ue){if(B===0)return 0;const De=st(B,ue);if(De!==void 0)return De;const Re=new V(ue,B);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=nt;function st(B,ue){const De=new V(ue,B);let Re=De.prevCodePoint();for(;ht(Re)||Re===65039||Re===8419;){if(De.offset===0)return;Re=De.prevCodePoint()}if(!fe(Re))return;let xe=De.offset;return xe>0&&De.prevCodePoint()===8205&&(xe=De.offset),xe}function ht(B){return 127995<=B&&B<=127999}var Fe;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class rt{static getInstance(ue){return rt.cache.get(Array.from(ue))}static getLocales(){return rt._locales.value}constructor(ue){this.confusableDictionary=ue}isAmbiguous(ue){return this.confusableDictionary.has(ue)}getPrimaryConfusable(ue){return this.confusableDictionary.get(ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}u=rt,rt.ambiguousCharacterData=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),rt.cache=new a.LRUCachedFunction(B=>{function ue(ct){const wt=new Map;for(let tt=0;tt<ct.length;tt+=2)wt.set(ct[tt],ct[tt+1]);return wt}function De(ct,wt){const tt=new Map(ct);for(const[ft,Pt]of wt)tt.set(ft,Pt);return tt}function Re(ct,wt){if(!ct)return wt;const tt=new Map;for(const[ft,Pt]of ct)wt.has(ft)&&tt.set(ft,Pt);return tt}const xe=u.ambiguousCharacterData.value;let Ge=B.filter(ct=>!ct.startsWith("_")&&ct in xe);Ge.length===0&&(Ge=["_default"]);let Ze;for(const ct of Ge){const wt=ue(xe[ct]);Ze=Re(Ze,wt)}const pt=ue(xe._common),gt=De(pt,Ze);return new rt(gt)}),rt._locales=new P.Lazy(()=>Object.keys(rt.ambiguousCharacterData.value).filter(B=>!B.startsWith("_"))),e.AmbiguousCharacters=rt;class ce{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ce.getRawData())),this._data}static isInvisibleCharacter(ue){return ce.getData().has(ue)}static get codePoints(){return ce.getData()}}ce._data=void 0,e.InvisibleCharacters=ce}),define(_e[34],ye([1,0,10,12,8,9]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function T(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=T;function S(r){return r.indexOf("/")===-1&&(r=T(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function D(r,m=a.posix.sep){if(!r)return"";const n=r.length,t=r.charCodeAt(0);if(_(t)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let E=3;const y=E;for(;E<n&&!_(r.charCodeAt(E));E++);if(y!==E&&!_(r.charCodeAt(E+1))){for(E+=1;E<n;E++)if(_(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,m)}}return m}else if(h(t)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+m:r.slice(0,2);let c=r.indexOf("://");if(c!==-1){for(c+=3;c<n;c++)if(_(r.charCodeAt(c)))return r.slice(0,c+1)}return""}e.getRoot=D;function R(r){if(!P.isWindows||!r||r.length<5)return!1;let m=r.charCodeAt(0);if(m!==92||(m=r.charCodeAt(1),m!==92))return!1;let n=2;const t=n;for(;n<r.length&&(m=r.charCodeAt(n),m!==92);n++);return!(t===n||(m=r.charCodeAt(n+1),isNaN(m)||m===92))}e.isUNC=R;const I=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(r,m=P.isWindows){const n=m?I:b;return!(!r||r.length===0||/^\s+$/.test(r)||(n.lastIndex=0,n.test(r))||m&&k.test(r)||r==="."||r===".."||m&&r[r.length-1]==="."||m&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=w;function f(r,m,n){const t=r===m;return!n||t?t:!r||!m?!1:(0,u.equalsIgnoreCase)(r,m)}e.isEqual=f;function d(r,m,n,t=a.sep){if(r===m)return!0;if(!r||!m||m.length>r.length)return!1;if(n){if(!(0,u.startsWithIgnoreCase)(r,m))return!1;if(m.length===r.length)return!0;let E=m.length;return m.charAt(m.length-1)===t&&E--,r.charAt(E)===t}return m.charAt(m.length-1)!==t&&(m+=t),r.indexOf(m)===0}e.isEqualOrParent=d;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=h;function g(r,m){return P.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(m,r)),r=(0,a.normalize)(r),P.isWindows?(r=(0,u.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,u.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=g;function v(r){const m=(0,a.normalize)(r);return P.isWindows?r.length>3?!1:C(m)&&(r.length===2||m.charCodeAt(2)===92):m===a.posix.sep}e.isRootOrDriveLetter=v;function C(r,m=P.isWindows){return m?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=C;function p(r){return C(r)?r[0]:void 0}e.getDriveLetter=p;function i(r,m,n){return m.length>r.length?-1:r===m?0:(n&&(r=r.toLowerCase(),m=m.toLowerCase()),r.indexOf(m))}e.indexOfPath=i;function o(r){const m=r.split(":");let n,t,c;for(const E of m){const y=Number(E);(0,A.isNumber)(y)?t===void 0?t=y:c===void 0&&(c=y):n=n?[n,E].join(":"):E}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:t!==void 0?t:void 0,column:c!==void 0?c:t!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(r,m,n=8){let t="";for(let E=0;E<n;E++)t+=s.charAt(Math.floor(Math.random()*s.length));let c;return m?c=`${m}-${t}`:c=t,r?(0,a.join)(r,c):c}e.randomPath=l}),define(_e[110],ye([1,0,28,8]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function u(...re){return function(O,W){for(let G=0,Q=re.length;G<Q;G++){const he=re[G](O,W);if(he)return he}return null}}e.or=u,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(re,O,W){if(!W||W.length<O.length)return null;let G;return re?G=P.startsWithIgnoreCase(W,O):G=W.indexOf(O)===0,G?O.length>0?[{start:0,end:O.length}]:[]:null}function _(re,O){const W=O.toLowerCase().indexOf(re.toLowerCase());return W===-1?null:[{start:W,end:W+re.length}]}e.matchesContiguousSubString=_;function T(re,O){return S(re.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=T;function S(re,O,W,G){if(W===re.length)return[];if(G===O.length)return null;if(re[W]===O[G]){let Q=null;return(Q=S(re,O,W+1,G+1))?h({start:G,end:G+1},Q):null}return S(re,O,W,G+1)}function D(re){return 97<=re&&re<=122}function R(re){return 65<=re&&re<=90}e.isUpper=R;function I(re){return 48<=re&&re<=57}function b(re){return re===32||re===9||re===10||re===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>k.add(re.charCodeAt(0)));function w(re){return b(re)||k.has(re)}function f(re,O){return re===O||w(re)&&w(O)}function d(re){return D(re)||R(re)||I(re)}function h(re,O){return O.length===0?O=[re]:re.end===O[0].start?O[0].start=re.start:O.unshift(re),O}function g(re,O){for(let W=O;W<re.length;W++){const G=re.charCodeAt(W);if(R(G)||I(G)||W>0&&!d(re.charCodeAt(W-1)))return W}return re.length}function v(re,O,W,G){if(W===re.length)return[];if(G===O.length)return null;if(re[W]!==O[G].toLowerCase())return null;{let Q=null,he=G+1;for(Q=v(re,O,W+1,G+1);!Q&&(he=g(O,he))<O.length;)Q=v(re,O,W+1,he),he++;return Q===null?null:h({start:G,end:G+1},Q)}}function C(re){let O=0,W=0,G=0,Q=0,he=0;for(let ke=0;ke<re.length;ke++)he=re.charCodeAt(ke),R(he)&&O++,D(he)&&W++,d(he)&&G++,I(he)&&Q++;const Ee=O/re.length,Pe=W/re.length,ve=G/re.length,Ce=Q/re.length;return{upperPercent:Ee,lowerPercent:Pe,alphaPercent:ve,numericPercent:Ce}}function p(re){const{upperPercent:O,lowerPercent:W}=re;return W===0&&O>.6}function i(re){const{upperPercent:O,lowerPercent:W,alphaPercent:G,numericPercent:Q}=re;return W>.2&&O<.8&&G>.6&&Q<.2}function o(re){let O=0,W=0,G=0,Q=0;for(let he=0;he<re.length;he++)G=re.charCodeAt(he),R(G)&&O++,D(G)&&W++,b(G)&&Q++;return(O===0||W===0)&&Q===0?re.length<=30:O<=5}function s(re,O){if(!O||(O=O.trim(),O.length===0)||!o(re)||O.length>60)return null;const W=C(O);if(!i(W)){if(!p(W))return null;O=O.toLowerCase()}let G=null,Q=0;for(re=re.toLowerCase();Q<O.length&&(G=v(re,O,0,Q))===null;)Q=g(O,Q+1);return G}e.matchesCamelCase=s;function l(re,O,W=!1){if(!O||O.length===0)return null;let G=null,Q=0;for(re=re.toLowerCase(),O=O.toLowerCase();Q<O.length&&(G=r(re,O,0,Q,W))===null;)Q=m(O,Q+1);return G}e.matchesWords=l;function r(re,O,W,G,Q){if(W===re.length)return[];if(G===O.length)return null;if(f(re.charCodeAt(W),O.charCodeAt(G))){let he=null,Ee=G+1;if(he=r(re,O,W+1,G+1,Q),!Q)for(;!he&&(Ee=m(O,Ee))<O.length;)he=r(re,O,W+1,Ee,Q),Ee++;return he?re.charCodeAt(W)!==O.charCodeAt(G)?he:h({start:G,end:G+1},he):null}else return null}function m(re,O){for(let W=O;W<re.length;W++)if(w(re.charCodeAt(W))||W>0&&w(re.charCodeAt(W-1)))return W;return re.length}const n=u(e.matchesPrefix,s,_),t=u(e.matchesPrefix,s,T),c=new a.LRUCache(1e4);function E(re,O,W=!1){if(typeof re!="string"||typeof O!="string")return null;let G=c.get(re);G||(G=new RegExp(P.convertSimple2RegExpPattern(re),"i"),c.set(re,G));const Q=G.exec(O);return Q?[{start:Q.index,end:Q.index+Q[0].length}]:W?t(re,O):n(re,O)}e.matchesFuzzy=E;function y(re,O){const W=Ie(re,re.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?j(W):null}e.matchesFuzzy2=y;function M(re,O,W,G,Q,he){const Ee=Math.min(13,re.length);for(;W<Ee;W++){const Pe=Ie(re,O,W,G,Q,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,he]}e.anyScore=M;function j(re){if(typeof re>"u")return[];const O=[],W=re[1];for(let G=re.length-1;G>1;G--){const Q=re[G]+W,he=O[O.length-1];he&&he.end===Q?he.end=Q+1:O.push({start:Q,end:Q+1})}return O}e.createMatches=j;const $=128;function N(){const re=[],O=[];for(let W=0;W<=$;W++)O[W]=0;for(let W=0;W<=$;W++)re.push(O.slice(0));return re}function x(re){const O=[];for(let W=0;W<=re;W++)O[W]=0;return O}const L=x(2*$),F=x(2*$),U=N(),H=N(),de=N(),Y=!1;function V(re,O,W,G,Q){function he(Pe,ve,Ce=" "){for(;Pe.length<ve;)Pe=Ce+Pe;return Pe}let Ee=` |   |${G.split("").map(Pe=>he(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=W;Pe++)Pe===0?Ee+=" |":Ee+=`${O[Pe-1]}|`,Ee+=re[Pe].slice(0,Q+1).map(ve=>he(ve.toString(),3)).join("|")+`
`;return Ee}function X(re,O,W,G){re=re.substr(O),W=W.substr(G),console.log(V(H,re,re.length,W,W.length)),console.log(V(de,re,re.length,W,W.length)),console.log(V(U,re,re.length,W,W.length))}function Z(re,O){if(O<0||O>=re.length)return!1;const W=re.codePointAt(O);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(W)}}function te(re,O){if(O<0||O>=re.length)return!1;switch(re.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function K(re,O,W){return O[re]!==W[re]}function J(re,O,W,G,Q,he,Ee=!1){for(;O<W&&Q<he;)re[O]===G[Q]&&(Ee&&(L[O]=Q),O+=1),Q+=1;return O===W}e.isPatternInWord=J;var ne;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(ne||(ne={}));var pe;(function(re){re.Default=[-100,0];function O(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}re.isDefault=O})(pe=e.FuzzyScore||(e.FuzzyScore={}));class be{constructor(O,W){this.firstMatchCanBeWeak=O,this.boostFullMatch=W}}be.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=be;function Ie(re,O,W,G,Q,he,Ee=be.default){const Pe=re.length>$?$:re.length,ve=G.length>$?$:G.length;if(W>=Pe||he>=ve||Pe-W>ve-he||!J(O,W,Pe,Q,he,ve,!0))return;Le(Pe,ve,W,he,O,Q);let Ce=1,ke=1,$e=W,je=he;const et=[!1];for(Ce=1,$e=W;$e<Pe;Ce++,$e++){const Fe=L[$e],rt=F[$e],ce=$e+1<Pe?F[$e+1]:ve;for(ke=Fe-he+1,je=Fe;je<ce;ke++,je++){let B=Number.MIN_SAFE_INTEGER,ue=!1;je<=rt&&(B=oe(re,O,$e,W,G,Q,je,ve,he,U[Ce-1][ke-1]===0,et));let De=0;B!==Number.MAX_SAFE_INTEGER&&(ue=!0,De=B+H[Ce-1][ke-1]);const Re=je>Fe,xe=Re?H[Ce][ke-1]+(U[Ce][ke-1]>0?-5:0):0,Ge=je>Fe+1&&U[Ce][ke-1]>0,Ze=Ge?H[Ce][ke-2]+(U[Ce][ke-2]>0?-5:0):0;if(Ge&&(!Re||Ze>=xe)&&(!ue||Ze>=De))H[Ce][ke]=Ze,de[Ce][ke]=3,U[Ce][ke]=0;else if(Re&&(!ue||xe>=De))H[Ce][ke]=xe,de[Ce][ke]=2,U[Ce][ke]=0;else if(ue)H[Ce][ke]=De,de[Ce][ke]=1,U[Ce][ke]=U[Ce-1][ke-1]+1;else throw new Error("not possible")}}if(Y&&X(re,W,G,he),!et[0]&&!Ee.firstMatchCanBeWeak)return;Ce--,ke--;const Xe=[H[Ce][ke],he];let nt=0,st=0;for(;Ce>=1;){let Fe=ke;do{const rt=de[Ce][Fe];if(rt===3)Fe=Fe-2;else if(rt===2)Fe=Fe-1;else break}while(Fe>=1);nt>1&&O[W+Ce-1]===Q[he+ke-1]&&!K(Fe+he-1,G,Q)&&nt+1>U[Ce][Fe]&&(Fe=ke),Fe===ke?nt++:nt=1,st||(st=Fe),Ce--,ke=Fe-1,Xe.push(ke)}ve===Pe&&Ee.boostFullMatch&&(Xe[0]+=2);const ht=st-Pe;return Xe[0]-=ht,Xe}e.fuzzyScore=Ie;function Le(re,O,W,G,Q,he){let Ee=re-1,Pe=O-1;for(;Ee>=W&&Pe>=G;)Q[Ee]===he[Pe]&&(F[Ee]=Pe,Ee--),Pe--}function oe(re,O,W,G,Q,he,Ee,Pe,ve,Ce,ke){if(O[W]!==he[Ee])return Number.MIN_SAFE_INTEGER;let $e=1,je=!1;return Ee===W-G?$e=re[W]===Q[Ee]?7:5:K(Ee,Q,he)&&(Ee===0||!K(Ee-1,Q,he))?($e=re[W]===Q[Ee]?7:5,je=!0):Z(he,Ee)&&(Ee===0||!Z(he,Ee-1))?$e=5:(Z(he,Ee-1)||te(he,Ee-1))&&($e=5,je=!0),$e>1&&W===G&&(ke[0]=!0),je||(je=K(Ee,Q,he)||Z(he,Ee-1)||te(he,Ee-1)),W===G?Ee>ve&&($e-=je?3:5):Ce?$e+=je?2:0:$e+=je?0:1,Ee+1===Pe&&($e-=je?3:5),$e}function ae(re,O,W,G,Q,he,Ee){return ee(re,O,W,G,Q,he,!0,Ee)}e.fuzzyScoreGracefulAggressive=ae;function fe(re,O,W,G,Q,he,Ee){return ee(re,O,W,G,Q,he,!1,Ee)}e.fuzzyScoreGraceful=fe;function ee(re,O,W,G,Q,he,Ee,Pe){let ve=Ie(re,O,W,G,Q,he,Pe);if(ve&&!Ee)return ve;if(re.length>=3){const Ce=Math.min(7,re.length-1);for(let ke=W+1;ke<Ce;ke++){const $e=le(re,ke);if($e){const je=Ie($e,$e.toLowerCase(),W,G,Q,he,Pe);je&&(je[0]-=3,(!ve||je[0]>ve[0])&&(ve=je))}}}return ve}function le(re,O){if(O+1>=re.length)return;const W=re[O],G=re[O+1];if(W!==G)return re.slice(0,O)+G+W+re.slice(O+2)}}),define(_e[88],ye([1,0,8]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function P(h){return u(h,0)}e.hash=P;function u(h,g){switch(typeof h){case"object":return h===null?A(349,g):Array.isArray(h)?S(h,g):D(h,g);case"string":return T(h,g);case"boolean":return _(h,g);case"number":return A(h,g);case"undefined":return A(937,g);default:return A(617,g)}}e.doHash=u;function A(h,g){return(g<<5)-g+h|0}e.numberHash=A;function _(h,g){return A(h?433:863,g)}function T(h,g){g=A(149417,g);for(let v=0,C=h.length;v<C;v++)g=A(h.charCodeAt(v),g);return g}e.stringHash=T;function S(h,g){return g=A(104579,g),h.reduce((v,C)=>u(C,v),g)}function D(h,g){return g=A(181387,g),Object.keys(h).sort().reduce((v,C)=>(v=T(C,v),u(h[C],v)),g)}class R{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=u(g,this._value),this._value}}e.Hasher=R;var I;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function b(h,g,v=32){const C=v-g,p=~((1<<C)-1);return(h<<g|(p&h)>>>C)>>>0}function k(h,g=0,v=h.byteLength,C=0){for(let p=0;p<v;p++)h[g+p]=C}function w(h,g,v="0"){for(;h.length<g;)h=v+h;return h}function f(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(v=>v.toString(16).padStart(2,"0")).join(""):w((h>>>0).toString(16),g/4)}e.toHexString=f;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const v=g.length;if(v===0)return;const C=this._buff;let p=this._buffLen,i=this._leftoverHighSurrogate,o,s;for(i!==0?(o=i,s=-1,i=0):(o=g.charCodeAt(0),s=0);;){let l=o;if(a.isHighSurrogate(o))if(s+1<v){const r=g.charCodeAt(s+1);a.isLowSurrogate(r)?(s++,l=a.computeCodePoint(o,r)):l=65533}else{i=o;break}else a.isLowSurrogate(o)&&(l=65533);if(p=this._push(C,p,l),s++,s<v)o=g.charCodeAt(s);else break}this._buffLen=p,this._leftoverHighSurrogate=i}_push(g,v,C){return C<128?g[v++]=C:C<2048?(g[v++]=192|(C&1984)>>>6,g[v++]=128|(C&63)>>>0):C<65536?(g[v++]=224|(C&61440)>>>12,g[v++]=128|(C&4032)>>>6,g[v++]=128|(C&63)>>>0):(g[v++]=240|(C&1835008)>>>18,g[v++]=128|(C&258048)>>>12,g[v++]=128|(C&4032)>>>6,g[v++]=128|(C&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,k(this._buff,this._buffLen),this._buffLen>56&&(this._step(),k(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=d._bigBlock32,v=this._buffDV;for(let n=0;n<64;n+=4)g.setUint32(n,v.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)g.setUint32(n,b(g.getUint32(n-12,!1)^g.getUint32(n-32,!1)^g.getUint32(n-56,!1)^g.getUint32(n-64,!1),1),!1);let C=this._h0,p=this._h1,i=this._h2,o=this._h3,s=this._h4,l,r,m;for(let n=0;n<80;n++)n<20?(l=p&i|~p&o,r=1518500249):n<40?(l=p^i^o,r=1859775393):n<60?(l=p&i|p&o|i&o,r=2400959708):(l=p^i^o,r=3395469782),m=b(C,5)+l+s+r+g.getUint32(n*4,!1)&4294967295,s=o,o=i,i=b(p,30),p=C,C=m;this._h0=this._h0+C&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}d._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=d}),define(_e[111],ye([1,0,108,110,88,10,12,8]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,D=[S,[]];function R(U,H,de,Y){if(!U||!H)return D;const V=U.length,X=H.length;if(V<X)return D;const Z=U.toLowerCase();return I(H,de,X,U,Z,V,Y)}e.scoreFuzzy=R;function I(U,H,de,Y,V,X,Z){const te=[],K=[];for(let be=0;be<de;be++){const Ie=be*X,Le=Ie-X,oe=be>0,ae=U[be],fe=H[be];for(let ee=0;ee<X;ee++){const le=ee>0,re=Ie+ee,O=re-1,W=Le+ee-1,G=le?te[O]:0,Q=oe&&le?te[W]:0,he=oe&&le?K[W]:0;let Ee;!Q&&oe?Ee=0:Ee=b(ae,fe,Y,V,ee,he),Ee&&Q+Ee>=G&&(Z||oe||V.startsWith(H,ee))?(K[re]=he+1,te[re]=Q+Ee):(K[re]=S,te[re]=G)}}const J=[];let ne=de-1,pe=X-1;for(;ne>=0&&pe>=0;){const be=ne*X+pe;K[be]===S||(J.push(pe),ne--),pe--}return[te[de*X-1],J.reverse()]}function b(U,H,de,Y,V,X){let Z=0;if(!k(H,Y[V]))return Z;if(Z+=1,X>0&&(Z+=X*5),U===de[V]&&(Z+=1),V===0)Z+=8;else{const te=w(de.charCodeAt(V-1));te?Z+=te:(0,P.isUpper)(de.charCodeAt(V))&&X===0&&(Z+=2)}return Z}function k(U,H){return U===H?!0:U==="/"||U==="\\"?H==="/"||H==="\\":!1}function w(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function d(U,H,de=0,Y=0){const V=H;return V.values&&V.values.length>1?h(U,V.values,de,Y):g(U,H,de,Y)}e.scoreFuzzy2=d;function h(U,H,de,Y){let V=0;const X=[];for(const Z of H){const[te,K]=g(U,Z,de,Y);if(typeof te!="number")return f;V+=te,X.push(...K)}return[V,t(X)]}function g(U,H,de,Y){const V=(0,P.fuzzyScore)(H.original,H.originalLowercase,de,U,U.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?[V[0],(0,P.createMatches)(V)]:f}const v=Object.freeze({score:0}),C=1<<18,p=1<<17,i=1<<16;function o(U,H,de,Y){const V=Y.values?Y.values:[Y];return(0,u.hash)({[Y.normalized]:{values:V.map(Z=>({value:Z.normalized,expectContiguousMatch:Z.expectContiguousMatch})),label:U,description:H,allowNonContiguousMatches:de}})}function s(U,H,de,Y,V){if(!U||!H.normalized)return v;const X=Y.getItemLabel(U);if(!X)return v;const Z=Y.getItemDescription(U),te=o(X,Z,de,H),K=V[te];if(K)return K;const J=l(X,Z,Y.getItemPath(U),H,de);return V[te]=J,J}e.scoreItemFuzzy=s;function l(U,H,de,Y,V){const X=!de||!Y.containsPathSeparator;return de&&(_.isLinux?Y.pathNormalized===de:(0,T.equalsIgnoreCase)(Y.pathNormalized,de))?{score:C,labelMatch:[{start:0,end:U.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:Y.values&&Y.values.length>1?r(U,H,de,Y.values,X,V):m(U,H,de,Y,X,V)}function r(U,H,de,Y,V,X){let Z=0;const te=[],K=[];for(const J of Y){const{score:ne,labelMatch:pe,descriptionMatch:be}=m(U,H,de,J,V,X);if(ne===S)return v;Z+=ne,pe&&te.push(...pe),be&&K.push(...be)}return{score:Z,labelMatch:t(te),descriptionMatch:t(K)}}function m(U,H,de,Y,V,X){if(V||!H){const[Z,te]=R(U,Y.normalized,Y.normalizedLowercase,X&&!Y.expectContiguousMatch);if(Z){const K=(0,P.matchesPrefix)(Y.normalized,U);let J;return K?(J=p,J+=Math.round(Y.normalized.length/U.length*100)):J=i,{score:J+Z,labelMatch:K||n(te)}}}if(H){let Z=H;de&&(Z=`${H}${A.sep}`);const te=Z.length,K=`${Z}${U}`,[J,ne]=R(K,Y.normalized,Y.normalizedLowercase,X&&!Y.expectContiguousMatch);if(J){const pe=n(ne),be=[],Ie=[];return pe.forEach(Le=>{Le.start<te&&Le.end>te?(be.push({start:0,end:Le.end-te}),Ie.push({start:Le.start,end:te})):Le.start>=te?be.push({start:Le.start-te,end:Le.end-te}):Ie.push(Le)}),{score:J,labelMatch:be,descriptionMatch:Ie}}}return v}function n(U){const H=[];if(!U)return H;let de;for(const Y of U)de&&de.end===Y?de.end+=1:(de={start:Y,end:Y+1},H.push(de));return H}function t(U){const H=U.sort((V,X)=>V.start-X.start),de=[];let Y;for(const V of H)!Y||!c(Y,V)?(Y=V,de.push(V)):(Y.start=Math.min(Y.start,V.start),Y.end=Math.max(Y.end,V.end));return de}function c(U,H){return!(U.end<H.start||H.end<U.start)}function E(U,H,de,Y,V,X){const Z=s(U,de,Y,V,X),te=s(H,de,Y,V,X),K=Z.score,J=te.score;if((K===C||J===C)&&K!==J)return K===C?-1:1;if(K>i||J>i){if(K!==J)return K>J?-1:1;if(K<p&&J<p){const ae=M(Z.labelMatch,te.labelMatch);if(ae!==0)return ae}const Le=V.getItemLabel(U)||"",oe=V.getItemLabel(H)||"";if(Le.length!==oe.length)return Le.length-oe.length}if(K!==J)return K>J?-1:1;const ne=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0,pe=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(ne&&!pe)return-1;if(pe&&!ne)return 1;const be=y(U,Z,V),Ie=y(H,te,V);return be&&Ie&&be!==Ie?Ie>be?-1:1:j(U,H,de,V)}e.compareItemsByFuzzyScore=E;function y(U,H,de){let Y=-1,V=-1;if(H.descriptionMatch&&H.descriptionMatch.length?Y=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(Y=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(V=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const X=de.getItemDescription(U);X&&(V+=X.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(V=H.descriptionMatch[H.descriptionMatch.length-1].end);return V-Y}function M(U,H){if(!U&&!H||(!U||!U.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!U||!U.length)return 1;const de=U[0].start,V=U[U.length-1].end-de,X=H[0].start,te=H[H.length-1].end-X;return V===te?0:te<V?1:-1}function j(U,H,de,Y){const V=Y.getItemLabel(U)||"",X=Y.getItemLabel(H)||"",Z=Y.getItemDescription(U),te=Y.getItemDescription(H),K=V.length+(Z?Z.length:0),J=X.length+(te?te.length:0);if(K!==J)return K-J;const ne=Y.getItemPath(U),pe=Y.getItemPath(H);return ne&&pe&&ne.length!==pe.length?ne.length-pe.length:V!==X?(0,a.compareAnything)(V,X,de.normalized):Z&&te&&Z!==te?(0,a.compareAnything)(Z,te,de.normalized):ne&&pe&&ne!==pe?(0,a.compareAnything)(ne,pe,de.normalized):0}function $(U){return U.startsWith('"')&&U.endsWith('"')}const N=" ";function x(U){typeof U!="string"&&(U="");const H=U.toLowerCase(),{pathNormalized:de,normalized:Y,normalizedLowercase:V}=L(U),X=de.indexOf(A.sep)>=0,Z=$(U);let te;const K=U.split(N);if(K.length>1)for(const J of K){const ne=$(J),{pathNormalized:pe,normalized:be,normalizedLowercase:Ie}=L(J);be&&(te||(te=[]),te.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:pe,normalized:be,normalizedLowercase:Ie,expectContiguousMatch:ne}))}return{original:U,originalLowercase:H,pathNormalized:de,normalized:Y,normalizedLowercase:V,values:te,containsPathSeparator:X,expectContiguousMatch:Z}}e.prepareQuery=x;function L(U){let H;_.isWindows?H=U.replace(/\//g,A.sep):H=U.replace(/\\/g,A.sep);const de=(0,T.stripWildcards)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:de,normalizedLowercase:de.toLowerCase()}}function F(U){return Array.isArray(U)?x(U.map(H=>H.original).join(N)):x(U.original)}e.pieceToQuery=F}),define(_e[163],ye([1,0,110,8,51]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",_=new RegExp(`\\$\\(${u.ThemeIcon.iconNameExpression}(?:${u.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${_.source}`,"g");function S(h){return h.replace(T,(g,v)=>v?g:`\\${g}`)}e.escapeIcons=S;const D=new RegExp(`\\\\${_.source}`,"g");function R(h){return h.replace(D,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=R;const I=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function b(h){return h.indexOf(A)===-1?h:h.replace(I,(g,v,C,p)=>C?g:v||p||"")}e.stripIcons=b;function k(h){return h?h.replace(/\$\((.*?)\)/g,(g,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=k;const w=new RegExp(`\\$\\(${u.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(h){w.lastIndex=0;let g="";const v=[];let C=0;for(;;){const p=w.lastIndex,i=w.exec(h),o=h.substring(p,i?.index);if(o.length>0){g+=o;for(let s=0;s<o.length;s++)v.push(C)}if(!i)break;C+=i[0].length}return{text:g,iconOffsets:v}}e.parseLabelWithIcons=f;function d(h,g,v=!1){const{text:C,iconOffsets:p}=g;if(!p||p.length===0)return(0,a.matchesFuzzy)(h,C,v);const i=(0,P.ltrim)(C," "),o=C.length-i.length,s=(0,a.matchesFuzzy)(h,i,v);if(s)for(const l of s){const r=p[l.start+o]+o;l.start+=r,l.end+=r}return s}e.matchesFuzzyIconAware=d}),define(_e[37],ye([1,0,8]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(u){u[u.Ignore=0]="Ignore",u[u.Info=1]="Info",u[u.Warning=2]="Warning",u[u.Error=3]="Error"})(P||(P={})),function(u){const A="error",_="warning",T="warn",S="info",D="ignore";function R(b){return b?a.equalsIgnoreCase(A,b)?u.Error:a.equalsIgnoreCase(_,b)||a.equalsIgnoreCase(T,b)?u.Warning:a.equalsIgnoreCase(S,b)?u.Info:u.Ignore:u.Ignore}u.fromValue=R;function I(b){switch(b){case u.Error:return A;case u.Warning:return _;case u.Info:return S;default:return D}}u.toString=I}(P||(P={})),e.default=P}),define(_e[68],ye([1,0,16,8]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class u{constructor(){this._value="",this._pos=0}reset(k){return this._value=k,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(k){const w=k.charCodeAt(0),f=this._value.charCodeAt(this._pos);return w-f}value(){return this._value[this._pos]}}e.StringIterator=u;class A{constructor(k=!0){this._caseSensitive=k}reset(k){return this._value=k,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let k=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(k)this._from++;else break;else k=!1;return this}cmp(k){return this._caseSensitive?(0,P.compareSubstring)(k,this._value,0,k.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(k,this._value,0,k.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class _{constructor(k=!0,w=!0){this._splitOnBackslash=k,this._caseSensitive=w}reset(k){this._from=0,this._to=0,this._value=k,this._valueLen=k.length;for(let w=k.length-1;w>=0;w--,this._valueLen--){const f=this._value.charCodeAt(w);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let k=!0;for(;this._to<this._valueLen;this._to++){const w=this._value.charCodeAt(this._to);if(w===47||this._splitOnBackslash&&w===92)if(k)this._from++;else break;else k=!1}return this}cmp(k){return this._caseSensitive?(0,P.compareSubstring)(k,this._value,0,k.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(k,this._value,0,k.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var T;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(k,w){this._ignorePathCasing=k,this._ignoreQueryAndFragment=w,this._states=[],this._stateIdx=0}reset(k){return this._value=k,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(k)),this._pathIterator.reset(k.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(k)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(k){if(this._states[this._stateIdx]===1)return(0,P.compareIgnoreCase)(k,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,P.compareIgnoreCase)(k,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(k);if(this._states[this._stateIdx]===4)return(0,P.compare)(k,this._value.query);if(this._states[this._stateIdx]===5)return(0,P.compare)(k,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(R||(R={}));class I{static forUris(k=()=>!1,w=()=>!1){return new I(new S(k,w))}static forPaths(k=!1){return new I(new _(void 0,!k))}static forStrings(){return new I(new u)}static forConfigKeys(){return new I(new A)}constructor(k){this._iter=k}clear(){this._root=void 0}fill(k,w){if(w){const f=w.slice(0);(0,a.shuffle)(f);for(const d of f)this.set(d,k)}else{const f=k.slice(0);(0,a.shuffle)(f);for(const d of f)this.set(d[0],d[1])}}set(k,w){const f=this._iter.reset(k);let d;this._root||(this._root=new D,this._root.segment=f.value());const h=[];for(d=this._root;;){const v=f.cmp(d.segment);if(v>0)d.left||(d.left=new D,d.left.segment=f.value()),h.push([-1,d]),d=d.left;else if(v<0)d.right||(d.right=new D,d.right.segment=f.value()),h.push([1,d]),d=d.right;else if(f.hasNext())f.next(),d.mid||(d.mid=new D,d.mid.segment=f.value()),h.push([0,d]),d=d.mid;else break}const g=d.value;d.value=w,d.key=k;for(let v=h.length-1;v>=0;v--){const C=h[v][1];C.updateHeight();const p=C.balanceFactor();if(p<-1||p>1){const i=h[v][0],o=h[v+1][0];if(i===1&&o===1)h[v][1]=C.rotateLeft();else if(i===-1&&o===-1)h[v][1]=C.rotateRight();else if(i===1&&o===-1)C.right=h[v+1][1]=h[v+1][1].rotateRight(),h[v][1]=C.rotateLeft();else if(i===-1&&o===1)C.left=h[v+1][1]=h[v+1][1].rotateLeft(),h[v][1]=C.rotateRight();else throw new Error;if(v>0)switch(h[v-1][0]){case-1:h[v-1][1].left=h[v][1];break;case 1:h[v-1][1].right=h[v][1];break;case 0:h[v-1][1].mid=h[v][1];break}else this._root=h[0][1]}}return g}get(k){return this._getNode(k)?.value}_getNode(k){const w=this._iter.reset(k);let f=this._root;for(;f;){const d=w.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(w.hasNext())w.next(),f=f.mid;else break}return f}has(k){const w=this._getNode(k);return!(w?.value===void 0&&w?.mid===void 0)}delete(k){return this._delete(k,!1)}deleteSuperstr(k){return this._delete(k,!0)}_delete(k,w){const f=this._iter.reset(k),d=[];let h=this._root;for(;h;){const g=f.cmp(h.segment);if(g>0)d.push([-1,h]),h=h.left;else if(g<0)d.push([1,h]),h=h.right;else if(f.hasNext())f.next(),d.push([0,h]),h=h.mid;else break}if(!!h){if(w?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this._min(h.right);if(g.key){const{key:v,value:C,segment:p}=g;this._delete(g.key,!1),h.key=v,h.value=C,h.segment=p}}else{const g=h.left??h.right;if(d.length>0){const[v,C]=d[d.length-1];switch(v){case-1:C.left=g;break;case 0:C.mid=g;break;case 1:C.right=g;break}}else this._root=g}for(let g=d.length-1;g>=0;g--){const v=d[g][1];v.updateHeight();const C=v.balanceFactor();if(C>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),d[g][1]=v.rotateLeft()):C<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),d[g][1]=v.rotateRight()),g>0)switch(d[g-1][0]){case-1:d[g-1][1].left=d[g][1];break;case 1:d[g-1][1].right=d[g][1];break;case 0:d[g-1][1].mid=d[g][1];break}else this._root=d[0][1]}}}_min(k){for(;k.left;)k=k.left;return k}findSubstr(k){const w=this._iter.reset(k);let f=this._root,d;for(;f;){const h=w.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(w.hasNext())w.next(),d=f.value||d,f=f.mid;else break}return f&&f.value||d}findSuperstr(k){return this._findSuperstrOrElement(k,!1)}_findSuperstrOrElement(k,w){const f=this._iter.reset(k);let d=this._root;for(;d;){const h=f.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(f.hasNext())f.next(),d=d.mid;else return d.mid?this._entries(d.mid):w?d.value:void 0}}hasElementOrSubtree(k){return this._findSuperstrOrElement(k,!0)!==void 0}forEach(k){for(const[w,f]of this)k(f,w)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(k){const w=[];return this._dfsEntries(k,w),w[Symbol.iterator]()}_dfsEntries(k,w){!k||(k.left&&this._dfsEntries(k.left,w),k.value&&w.push([k.key,k.value]),k.mid&&this._dfsEntries(k.mid,w),k.right&&this._dfsEntries(k.right,w))}_isBalanced(){const k=w=>{if(!w)return!0;const f=w.balanceFactor();return f<-1||f>1?!1:k(w.left)&&k(w.right)};return k(this._root)}}e.TernarySearchTree=I}),define(_e[2],ye([1,0,10,12]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const u=/^\w[\w\d+.-]*$/,A=/^\//,_=/^\/\//;function T(s,l){if(!s.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!u.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,l){return!s&&!l?"file":s}function D(s,l){switch(s){case"https":case"http":case"file":l?l[0]!==I&&(l=I+l):l=I;break}return l}const R="",I="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(l){return l instanceof k?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,r,m,n,t,c=!1){typeof l=="object"?(this.scheme=l.scheme||R,this.authority=l.authority||R,this.path=l.path||R,this.query=l.query||R,this.fragment=l.fragment||R):(this.scheme=S(l,c),this.authority=r||R,this.path=D(this.scheme,m||R),this.query=n||R,this.fragment=t||R,T(this,c))}get fsPath(){return v(this,!1)}with(l){if(!l)return this;let{scheme:r,authority:m,path:n,query:t,fragment:c}=l;return r===void 0?r=this.scheme:r===null&&(r=R),m===void 0?m=this.authority:m===null&&(m=R),n===void 0?n=this.path:n===null&&(n=R),t===void 0?t=this.query:t===null&&(t=R),c===void 0?c=this.fragment:c===null&&(c=R),r===this.scheme&&m===this.authority&&n===this.path&&t===this.query&&c===this.fragment?this:new f(r,m,n,t,c)}static parse(l,r=!1){const m=b.exec(l);return m?new f(m[2]||R,o(m[4]||R),o(m[5]||R),o(m[7]||R),o(m[9]||R),r):new f(R,R,R,R,R)}static file(l){let r=R;if(P.isWindows&&(l=l.replace(/\\/g,I)),l[0]===I&&l[1]===I){const m=l.indexOf(I,2);m===-1?(r=l.substring(2),l=I):(r=l.substring(2,m),l=l.substring(m)||I)}return new f("file",r,l,R,R)}static from(l){const r=new f(l.scheme,l.authority,l.path,l.query,l.fragment);return T(r,!0),r}static joinPath(l,...r){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return P.isWindows&&l.scheme==="file"?m=k.file(a.win32.join(v(l,!0),...r)).path:m=a.posix.join(l.path,...r),l.with({path:m})}toString(l=!1){return C(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof k)return l;{const r=new f(l);return r._formatted=l.external,r._fsPath=l._sep===w?l.fsPath:null,r}}else return l}}e.URI=k;const w=P.isWindows?1:void 0;class f extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(l=!1){return l?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=w),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(s,l,r){let m,n=-1;for(let t=0;t<s.length;t++){const c=s.charCodeAt(t);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||l&&c===47||r&&c===91||r&&c===93||r&&c===58)n!==-1&&(m+=encodeURIComponent(s.substring(n,t)),n=-1),m!==void 0&&(m+=s.charAt(t));else{m===void 0&&(m=s.substr(0,t));const E=d[c];E!==void 0?(n!==-1&&(m+=encodeURIComponent(s.substring(n,t)),n=-1),m+=E):n===-1&&(n=t)}}return n!==-1&&(m+=encodeURIComponent(s.substring(n))),m!==void 0?m:s}function g(s){let l;for(let r=0;r<s.length;r++){const m=s.charCodeAt(r);m===35||m===63?(l===void 0&&(l=s.substr(0,r)),l+=d[m]):l!==void 0&&(l+=s[r])}return l!==void 0?l:s}function v(s,l){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?l?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,P.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=v;function C(s,l){const r=l?g:h;let m="",{scheme:n,authority:t,path:c,query:E,fragment:y}=s;if(n&&(m+=n,m+=":"),(t||n==="file")&&(m+=I,m+=I),t){let M=t.indexOf("@");if(M!==-1){const j=t.substr(0,M);t=t.substr(M+1),M=j.lastIndexOf(":"),M===-1?m+=r(j,!1,!1):(m+=r(j.substr(0,M),!1,!1),m+=":",m+=r(j.substr(M+1),!1,!0)),m+="@"}t=t.toLowerCase(),M=t.lastIndexOf(":"),M===-1?m+=r(t,!1,!0):(m+=r(t.substr(0,M),!1,!0),m+=t.substr(M))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const M=c.charCodeAt(1);M>=65&&M<=90&&(c=`/${String.fromCharCode(M+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const M=c.charCodeAt(0);M>=65&&M<=90&&(c=`${String.fromCharCode(M+32)}:${c.substr(2)}`)}m+=r(c,!0,!1)}return E&&(m+="?",m+=r(E,!1,!1)),y&&(m+="#",m+=l?y:h(y,!1,!1)),m}function p(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+p(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(i)?s.replace(i,l=>p(l)):s}}),define(_e[69],ye([1,0,22,8,2]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(D){return JSON.stringify(D,T)}e.stringify=A;function _(D){let R=JSON.parse(D);return R=S(R),R}e.parse=_;function T(D,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,P.regExpFlags)(R)}:R}function S(D,R=0){if(!D||R>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return u.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 16:return new Date(D.source)}if(D instanceof a.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let I=0;I<D.length;++I)D[I]=S(D[I],R+1);else for(const I in D)Object.hasOwnProperty.call(D,I)&&(D[I]=S(D[I],R+1))}return D}e.revive=S}),define(_e[14],ye([1,0,11,12,2]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls",D.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(R){this._preferredWebSchema=R}setDelegate(R){this._delegate=R}setServerRootPath(R){this._remoteResourcesPath=`${R}/${A.vscodeRemoteResource}`}set(R,I,b){this._hosts[R]=I,this._ports[R]=b}setConnectionToken(R,I){this._connectionTokens[R]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(R){if(this._delegate)try{return this._delegate(R)}catch(d){return a.onUnexpectedError(d),R}const I=R.authority;let b=this._hosts[I];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const k=this._ports[I],w=this._connectionTokens[I];let f=`path=${encodeURIComponent(R.path)}`;return typeof w=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),u.URI.from({scheme:P.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${b}:${k}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new _,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class T{asBrowserUri(R){const I=this.toUri(R,ie);return this.uriToBrowserUri(I)}uriToBrowserUri(R){return R.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===A.file&&(P.isNative||P.isWebWorker&&P.globals.origin===`${A.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?R.with({scheme:A.vscodeFileResource,authority:R.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(R){const I=this.toUri(R,ie);return this.uriToFileUri(I)}uriToFileUri(R){return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==T.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(R,I){return u.URI.isUri(R)?R:u.URI.parse(I.toUrl(R))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var S;(function(D){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);D.CoopAndCoep=Object.freeze(R.get("3"));const I="vscode-coi";function b(w){let f;typeof w=="string"?f=new URL(w).searchParams:w instanceof URL?f=w.searchParams:u.URI.isUri(w)&&(f=new URL(w.toString(!0)).searchParams);const d=f?.get(I);if(!!d)return R.get(d)}D.getHeadersFromQuery=b;function k(w,f,d){if(!globalThis.crossOriginIsolated)return;const h=f&&d?"3":d?"2":"1";w instanceof URLSearchParams?w.set(I,h):w[I]=h}D.addSearchParam=k})(S=e.COI||(e.COI={}))}),define(_e[24],ye([1,0,34,14,10,12,8,2]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(k){return(0,T.uriToFsPath)(k,!0)}e.originalFSPath=S;class D{constructor(w){this._ignorePathCasing=w}compare(w,f,d=!1){return w===f?0:(0,_.compare)(this.getComparisonKey(w,d),this.getComparisonKey(f,d))}isEqual(w,f,d=!1){return w===f?!0:!w||!f?!1:this.getComparisonKey(w,d)===this.getComparisonKey(f,d)}getComparisonKey(w,f=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,f,d=!1){if(w.scheme===f.scheme){if(w.scheme===P.Schemas.file)return a.isEqualOrParent(S(w),S(f),this._ignorePathCasing(w))&&w.query===f.query&&(d||w.fragment===f.fragment);if((0,e.isEqualAuthority)(w.authority,f.authority))return a.isEqualOrParent(w.path,f.path,this._ignorePathCasing(w),"/")&&w.query===f.query&&(d||w.fragment===f.fragment)}return!1}joinPath(w,...f){return T.URI.joinPath(w,...f)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return u.posix.basename(w.path)}extname(w){return u.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let f;return w.scheme===P.Schemas.file?f=T.URI.file(u.dirname(S(w))).path:(f=u.posix.dirname(w.path),w.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),f="/")),w.with({path:f})}normalizePath(w){if(!w.path.length)return w;let f;return w.scheme===P.Schemas.file?f=T.URI.file(u.normalize(S(w))).path:f=u.posix.normalize(w.path),w.with({path:f})}relativePath(w,f){if(w.scheme!==f.scheme||!(0,e.isEqualAuthority)(w.authority,f.authority))return;if(w.scheme===P.Schemas.file){const g=u.relative(S(w),S(f));return A.isWindows?a.toSlashes(g):g}let d=w.path||"/";const h=f.path||"/";if(this._ignorePathCasing(w)){let g=0;for(const v=Math.min(d.length,h.length);g<v&&!(d.charCodeAt(g)!==h.charCodeAt(g)&&d.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);d=h.substr(0,g)+d.substr(g)}return u.posix.relative(d,h)}resolvePath(w,f){if(w.scheme===P.Schemas.file){const d=T.URI.file(u.resolve(S(w),f));return w.with({authority:d.authority,path:d.path})}return f=a.toPosixPath(f),w.with({path:u.posix.resolve(w.path,f)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,f){return w===f||w!==void 0&&f!==void 0&&(0,_.equalsIgnoreCase)(w,f)}hasTrailingPathSeparator(w,f=u.sep){if(w.scheme===P.Schemas.file){const d=S(w);return d.length>a.getRoot(d).length&&d[d.length-1]===f}else{const d=w.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,f=u.sep){return(0,e.hasTrailingPathSeparator)(w,f)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,f=u.sep){let d=!1;if(w.scheme===P.Schemas.file){const h=S(w);d=h!==void 0&&h.length===a.getRoot(h).length&&h[h.length-1]===f}else{f="/";const h=w.path;d=h.length===1&&h.charCodeAt(h.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(w,f)?w.with({path:w.path+"/"}):w}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(k=>k.scheme===P.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new D(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(k,w){const f=[];for(let d=0;d<k.length;d++){const h=w(k[d]);k.some((g,v)=>v===d?!1:(0,e.isEqualOrParent)(h,w(g)))||f.push(k[d])}return f}e.distinctParents=R;var I;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function w(f){const d=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(v=>{const[C,p]=v.split(":");C&&p&&d.set(C,p)});const g=f.path.substring(0,f.path.indexOf(";"));return g&&d.set(k.META_DATA_MIME,g),d}k.parseMetaData=w})(I=e.DataUri||(e.DataUri={}));function b(k,w,f){if(w){let d=k.path;return d&&d[0]!==u.posix.sep&&(d=u.posix.sep+d),k.with({scheme:f,authority:w,path:d})}return k.with({scheme:f})}e.toLocalResource=b}),define(_e[19],ye([1,0,21,11,3,6,24,12,148]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(J){return!!J&&typeof J.then=="function"}e.isThenable=D;function R(J){const ne=new a.CancellationTokenSource,pe=J(ne.token),be=new Promise((Ie,Le)=>{const oe=ne.token.onCancellationRequested(()=>{oe.dispose(),ne.dispose(),Le(new P.CancellationError)});Promise.resolve(pe).then(ae=>{oe.dispose(),ne.dispose(),Ie(ae)},ae=>{oe.dispose(),ne.dispose(),Le(ae)})});return new class{cancel(){ne.cancel()}then(Ie,Le){return be.then(Ie,Le)}catch(Ie){return this.then(void 0,Ie)}finally(Ie){return be.finally(Ie)}}}e.createCancelablePromise=R;function I(J,ne,pe){return new Promise((be,Ie)=>{const Le=ne.onCancellationRequested(()=>{Le.dispose(),be(pe)});J.then(be,Ie).finally(()=>Le.dispose())})}e.raceCancellation=I;function b(J,ne){return new Promise((pe,be)=>{const Ie=ne.onCancellationRequested(()=>{Ie.dispose(),be(new P.CancellationError)});J.then(pe,be).finally(()=>Ie.dispose())})}e.raceCancellationError=b;async function k(J){let ne=-1;const pe=J.map((Ie,Le)=>Ie.then(oe=>(ne=Le,oe))),be=await Promise.race(pe);return J.forEach((Ie,Le)=>{Le!==ne&&Ie.cancel()}),be}e.raceCancellablePromises=k;function w(J,ne,pe){let be;const Ie=setTimeout(()=>{be?.(void 0),pe?.()},ne);return Promise.race([J.finally(()=>clearTimeout(Ie)),new Promise(Le=>be=Le)])}e.raceTimeout=w;function f(J){return new Promise((ne,pe)=>{const be=J();D(be)?be.then(ne,pe):ne(be)})}e.asPromise=f;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(pe,pe).then(be)})}return new Promise((pe,be)=>{this.queuedPromise.then(pe,be)})}return this.activePromise=ne(),new Promise((pe,be)=>{this.activePromise.then(Ie=>{this.activePromise=null,pe(Ie)},Ie=>{this.activePromise=null,be(Ie)})})}}e.Throttler=d;class h{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=h;class g{constructor(){this.promiseMap=new Map}queue(ne,pe){const Ie=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(ne)===Ie&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Ie),Ie}}e.SequencerByKey=g;const v=(J,ne)=>{let pe=!0;const be=setTimeout(()=>{pe=!1,ne()},J);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(be),pe=!1}}},C=J=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,J())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};class p{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,pe=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ie,Le)=>{this.doResolve=Ie,this.doReject=Le}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ie=this.task;return this.task=null,Ie()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===S.MicrotaskDelay?C(be):v(pe,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new P.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class i{constructor(ne){this.delayer=new p(ne),this.throttler=new d}trigger(ne,pe){return this.delayer.trigger(()=>this.throttler.queue(ne),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=i;class o{constructor(){this._isOpen=!1,this._promise=new Promise((ne,pe)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class s extends o{constructor(ne){super(),this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function l(J,ne){return ne?new Promise((pe,be)=>{const Ie=setTimeout(()=>{Le.dispose(),pe()},J),Le=ne.onCancellationRequested(()=>{clearTimeout(Ie),Le.dispose(),be(new P.CancellationError)})}):R(pe=>l(J,pe))}e.timeout=l;function r(J,ne=0){const pe=setTimeout(J,ne);return(0,A.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=r;function m(J){const ne=[];let pe=0;const be=J.length;function Ie(){return pe<be?J[pe++]():null}function Le(oe){oe!=null&&ne.push(oe);const ae=Ie();return ae?ae.then(Le):Promise.resolve(ne)}return Promise.resolve(null).then(Le)}e.sequence=m;function n(J,ne=be=>!!be,pe=null){let be=0;const Ie=J.length,Le=()=>{if(be>=Ie)return Promise.resolve(pe);const oe=J[be++];return Promise.resolve(oe()).then(fe=>ne(fe)?Promise.resolve(fe):Le())};return Le()}e.first=n;function t(J,ne=be=>!!be,pe=null){if(J.length===0)return Promise.resolve(pe);let be=J.length;const Ie=()=>{be=-1;for(const Le of J)Le.cancel?.()};return new Promise((Le,oe)=>{for(const ae of J)ae.then(fe=>{--be>=0&&ne(fe)?(Ie(),Le(fe)):be===0&&Le(pe)}).catch(fe=>{--be>=0&&(Ie(),oe(fe))})})}e.firstParallel=t;class c{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new u.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ne){return this._size++,new Promise((pe,be)=>{this.outstandingPromises.push({factory:ne,c:pe,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const pe=ne.factory();pe.then(ne.c,ne.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=c;class E extends c{constructor(){super(1)}}e.Queue=E;class y{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new Y;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,pe=_.extUri){const be=pe.getComparisonKey(ne);let Ie=this.queues.get(be);return Ie||(Ie=new E,u.Event.once(Ie.onDrained)(()=>{Ie?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,Ie)),Ie}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=y;class M{constructor(ne,pe){this._token=-1,typeof ne=="function"&&typeof pe=="number"&&this.setIfNotSet(ne,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},pe)}setIfNotSet(ne,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},pe))}}e.TimeoutTimer=M;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setInterval(()=>{ne()},pe)}}e.IntervalTimer=j;class ${constructor(ne,pe){this.timeoutToken=-1,this.runner=ne,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class N{constructor(ne,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=N;class x extends ${constructor(ne,pe){super(ne,pe),this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner?.(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class L extends A.Disposable{constructor(ne,pe){super(),this.options=ne,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const pe of ne)this.pendingWork.push(pe);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=J=>{(0,T.setTimeout0)(()=>{if(ne)return;const pe=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(J,ne)=>{const pe=requestIdleCallback(J,typeof ne=="number"?{timeout:ne}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(pe))}}}}();class F{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function U(J,ne,pe){let be;for(let Ie=0;Ie<pe;Ie++)try{return await J()}catch(Le){be=Le,await l(ne)}throw be}e.retry=U;class H{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(ne,pe,be){return this._pending={taskId:ne,cancel:()=>be?.(),promise:pe},pe.then(()=>this.donePending(ne),()=>this.donePending(ne)),pe}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let pe,be;const Ie=new Promise((Le,oe)=>{pe=Le,be=oe});this._next={run:ne,promise:Ie,promiseResolve:pe,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=H;class de{constructor(ne,pe=()=>Date.now()){this.interval=ne,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=de;class Y{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,pe)=>{this.completeCallback=ne,this.errorCallback=pe})}complete(ne){return new Promise(pe=>{this.completeCallback(ne),this.resolved=!0,pe()})}error(ne){return new Promise(pe=>{this.errorCallback(ne),this.rejected=!0,pe()})}cancel(){new Promise(ne=>{this.errorCallback(new P.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=Y;var V;(function(J){async function ne(be){let Ie;const Le=await Promise.all(be.map(oe=>oe.then(ae=>ae,ae=>{Ie||(Ie=ae)})));if(typeof Ie<"u")throw Ie;return Le}J.settled=ne;function pe(be){return new Promise(async(Ie,Le)=>{try{await be(Ie,Le)}catch(oe){Le(oe)}})}J.withAsyncBody=pe})(V=e.Promises||(e.Promises={}));var X;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(X||(X={}));class Z{static fromArray(ne){return new Z(pe=>{pe.emitMany(ne)})}static fromPromise(ne){return new Z(async pe=>{pe.emitMany(await ne)})}static fromPromises(ne){return new Z(async pe=>{await Promise.all(ne.map(async be=>pe.emitOne(await be)))})}static merge(ne){return new Z(async pe=>{await Promise.all(ne.map(async be=>{for await(const Ie of be)pe.emitOne(Ie)}))})}constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new u.Emitter,queueMicrotask(async()=>{const pe={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(ne(pe)),this.resolve()}catch(be){this.reject(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await u.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,pe){return new Z(async be=>{for await(const Ie of ne)be.emitOne(pe(Ie))})}map(ne){return Z.map(this,ne)}static filter(ne,pe){return new Z(async be=>{for await(const Ie of ne)pe(Ie)&&be.emitOne(Ie)})}filter(ne){return Z.filter(this,ne)}static coalesce(ne){return Z.filter(ne,pe=>!!pe)}coalesce(){return Z.coalesce(this)}static async toPromise(ne){const pe=[];for await(const be of ne)pe.push(be);return pe}toPromise(){return Z.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}Z.EMPTY=Z.fromArray([]),e.AsyncIterableObject=Z;class te extends Z{constructor(ne,pe){super(pe),this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function K(J){const ne=new a.CancellationTokenSource,pe=J(ne.token);return new te(ne,async be=>{const Ie=ne.token.onCancellationRequested(()=>{Ie.dispose(),ne.dispose(),be.reject(new P.CancellationError)});try{for await(const Le of pe){if(ne.token.isCancellationRequested)return;be.emitOne(Le)}Ie.dispose(),ne.dispose()}catch(Le){Ie.dispose(),ne.dispose(),be.reject(Le)}})}e.createCancelableAsyncIterable=K}),define(_e[38],ye([1,0,16,19,34,28,10,12,8]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",I="[^/\\\\]",b=/\//g;function k(de,Y){switch(de){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${Y?`|${R}${I}+`:""})*?`}}function w(de,Y){if(!de)return[];const V=[];let X=!1,Z=!1,te="";for(const K of de){switch(K){case Y:if(!X&&!Z){V.push(te),te="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}te+=K}return te&&V.push(te),V}e.splitGlobAware=w;function f(de){if(!de)return"";let Y="";const V=w(de,e.GLOB_SPLIT);if(V.every(X=>X===e.GLOBSTAR))Y=".*";else{let X=!1;V.forEach((Z,te)=>{if(Z===e.GLOBSTAR){if(X)return;Y+=k(2,te===V.length-1)}else{let K=!1,J="",ne=!1,pe="";for(const be of Z){if(be!=="}"&&K){J+=be;continue}if(ne&&(be!=="]"||!pe)){let Ie;be==="-"?Ie=be:(be==="^"||be==="!")&&!pe?Ie="^":be===e.GLOB_SPLIT?Ie="":Ie=(0,S.escapeRegExpCharacters)(be),pe+=Ie;continue}switch(be){case"{":K=!0;continue;case"[":ne=!0;continue;case"}":{Y+=`(?:${w(J,",").map(oe=>f(oe)).join("|")})`,K=!1,J="";break}case"]":{Y+="["+pe+"]",ne=!1,pe="";break}case"?":Y+=I;continue;case"*":Y+=k(1);continue;default:Y+=(0,S.escapeRegExpCharacters)(be)}}te<V.length-1&&(V[te+1]!==e.GLOBSTAR||te+2<V.length)&&(Y+=R)}X=Z===e.GLOBSTAR})}return Y}const d=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.LRUCache(1e4),o=function(){return!1},s=function(){return null};function l(de,Y){if(!de)return s;let V;typeof de!="string"?V=de.pattern:V=de,V=V.trim();const X=`${V}_${!!Y.trimForExclusions}`;let Z=i.get(X);if(Z)return r(Z,de);let te;return d.test(V)?Z=n(V.substr(4),V):(te=h.exec(m(V,Y)))?Z=t(te[1],V):(Y.trimForExclusions?v:g).test(V)?Z=c(V,Y):(te=C.exec(m(V,Y)))?Z=E(te[1].substr(1),V,!0):(te=p.exec(m(V,Y)))?Z=E(te[1],V,!1):Z=y(V),i.set(X,Z),r(Z,de)}function r(de,Y){if(typeof Y=="string")return de;const V=function(X,Z){return(0,u.isEqualOrParent)(X,Y.base,!T.isLinux)?de((0,S.ltrim)(X.substr(Y.base.length),_.sep),Z):null};return V.allBasenames=de.allBasenames,V.allPaths=de.allPaths,V.basenames=de.basenames,V.patterns=de.patterns,V}function m(de,Y){return Y.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function n(de,Y){return function(V,X){return typeof V=="string"&&V.endsWith(de)?Y:null}}function t(de,Y){const V=`/${de}`,X=`\\${de}`,Z=function(K,J){return typeof K!="string"?null:J?J===de?Y:null:K===de||K.endsWith(V)||K.endsWith(X)?Y:null},te=[de];return Z.basenames=te,Z.patterns=[Y],Z.allBasenames=te,Z}function c(de,Y){const V=U(de.slice(1,-1).split(",").map(J=>l(J,Y)).filter(J=>J!==s),de),X=V.length;if(!X)return s;if(X===1)return V[0];const Z=function(J,ne){for(let pe=0,be=V.length;pe<be;pe++)if(V[pe](J,ne))return de;return null},te=V.find(J=>!!J.allBasenames);te&&(Z.allBasenames=te.allBasenames);const K=V.reduce((J,ne)=>ne.allPaths?J.concat(ne.allPaths):J,[]);return K.length&&(Z.allPaths=K),Z}function E(de,Y,V){const X=_.sep===_.posix.sep,Z=X?de:de.replace(b,_.sep),te=_.sep+Z,K=_.posix.sep+de;let J;return V?J=function(ne,pe){return typeof ne=="string"&&(ne===Z||ne.endsWith(te)||!X&&(ne===de||ne.endsWith(K)))?Y:null}:J=function(ne,pe){return typeof ne=="string"&&(ne===Z||!X&&ne===de)?Y:null},J.allPaths=[(V?"*/":"./")+de],J}function y(de){try{const Y=new RegExp(`^${f(de)}$`);return function(V){return Y.lastIndex=0,typeof V=="string"&&Y.test(V)?de:null}}catch{return s}}function M(de,Y,V){return!de||typeof Y!="string"?!1:j(de)(Y,void 0,V)}e.match=M;function j(de,Y={}){if(!de)return o;if(typeof de=="string"||$(de)){const V=l(de,Y);if(V===s)return o;const X=function(Z,te){return!!V(Z,te)};return V.allBasenames&&(X.allBasenames=V.allBasenames),V.allPaths&&(X.allPaths=V.allPaths),X}return L(de,Y)}e.parse=j;function $(de){const Y=de;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.isRelativePattern=$;function N(de){return de.allBasenames||[]}e.getBasenameTerms=N;function x(de){return de.allPaths||[]}e.getPathTerms=x;function L(de,Y){const V=U(Object.getOwnPropertyNames(de).map(J=>F(J,de[J],Y)).filter(J=>J!==s)),X=V.length;if(!X)return s;if(!V.some(J=>!!J.requiresSiblings)){if(X===1)return V[0];const J=function(be,Ie){let Le;for(let oe=0,ae=V.length;oe<ae;oe++){const fe=V[oe](be,Ie);if(typeof fe=="string")return fe;(0,P.isThenable)(fe)&&(Le||(Le=[]),Le.push(fe))}return Le?(async()=>{for(const oe of Le){const ae=await oe;if(typeof ae=="string")return ae}return null})():null},ne=V.find(be=>!!be.allBasenames);ne&&(J.allBasenames=ne.allBasenames);const pe=V.reduce((be,Ie)=>Ie.allPaths?be.concat(Ie.allPaths):be,[]);return pe.length&&(J.allPaths=pe),J}const Z=function(J,ne,pe){let be,Ie;for(let Le=0,oe=V.length;Le<oe;Le++){const ae=V[Le];ae.requiresSiblings&&pe&&(ne||(ne=(0,_.basename)(J)),be||(be=ne.substr(0,ne.length-(0,_.extname)(J).length)));const fe=ae(J,ne,be,pe);if(typeof fe=="string")return fe;(0,P.isThenable)(fe)&&(Ie||(Ie=[]),Ie.push(fe))}return Ie?(async()=>{for(const Le of Ie){const oe=await Le;if(typeof oe=="string")return oe}return null})():null},te=V.find(J=>!!J.allBasenames);te&&(Z.allBasenames=te.allBasenames);const K=V.reduce((J,ne)=>ne.allPaths?J.concat(ne.allPaths):J,[]);return K.length&&(Z.allPaths=K),Z}function F(de,Y,V){if(Y===!1)return s;const X=l(de,V);if(X===s)return s;if(typeof Y=="boolean")return X;if(Y){const Z=Y.when;if(typeof Z=="string"){const te=(K,J,ne,pe)=>{if(!pe||!X(K,J))return null;const be=Z.replace("$(basename)",()=>ne),Ie=pe(be);return(0,P.isThenable)(Ie)?Ie.then(Le=>Le?de:null):Ie?de:null};return te.requiresSiblings=!0,te}}return X}function U(de,Y){const V=de.filter(J=>!!J.basenames);if(V.length<2)return de;const X=V.reduce((J,ne)=>{const pe=ne.basenames;return pe?J.concat(pe):J},[]);let Z;if(Y){Z=[];for(let J=0,ne=X.length;J<ne;J++)Z.push(Y)}else Z=V.reduce((J,ne)=>{const pe=ne.patterns;return pe?J.concat(pe):J},[]);const te=function(J,ne){if(typeof J!="string")return null;if(!ne){let be;for(be=J.length;be>0;be--){const Ie=J.charCodeAt(be-1);if(Ie===47||Ie===92)break}ne=J.substr(be)}const pe=X.indexOf(ne);return pe!==-1?Z[pe]:null};te.basenames=X,te.patterns=Z,te.allBasenames=X;const K=de.filter(J=>!J.basenames);return K.push(te),K}function H(de,Y){return(0,a.equals)(de,Y,(V,X)=>typeof V=="string"&&typeof X=="string"?V===X:typeof V!="string"&&typeof X!="string"?V.base===X.base&&V.pattern===X.pattern:!1)}e.patternsEquals=H}),define(_e[112],ye([1,0,11,163,24,8,2]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",g=!1){if(this.value=h,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(h,g=0){return this.value+=b(this.supportThemeIcons?(0,P.escapeIcons)(h):h).replace(/([ \t]+)/g,(v,C)=>"&nbsp;".repeat(C.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,g){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(h,g,v){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(h),")"),v&&(this.value+=` "${this._escape(this._escape(v,'"'),")")}"`),this.value+=")",this}_escape(h,g){const v=new RegExp((0,A.escapeRegExpCharacters)(g),"g");return h.replace(v,(C,p)=>h.charAt(p-1)!=="\\"?`\\${C}`:C)}}e.MarkdownString=S;function D(d){return R(d)?!d.value:Array.isArray(d)?d.every(D):!0}e.isEmptyMarkdownString=D;function R(d){return d instanceof S?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function I(d,h){return d===h?!0:!d||!h?!1:d.value===h.value&&d.isTrusted===h.isTrusted&&d.supportThemeIcons===h.supportThemeIcons&&d.supportHtml===h.supportHtml&&(d.baseUri===h.baseUri||!!d.baseUri&&!!h.baseUri&&(0,u.isEqual)(_.URI.from(d.baseUri),_.URI.from(h.baseUri)))}e.markdownStringEqual=I;function b(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function k(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function w(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=w;function f(d){const h=[],g=d.split("|").map(C=>C.trim());d=g[0];const v=g[1];if(v){const C=/height=(\d+)/.exec(v),p=/width=(\d+)/.exec(v),i=C?C[1]:"",o=p?p[1]:"",s=isFinite(parseInt(o)),l=isFinite(parseInt(i));s&&h.push(`width="${o}"`),l&&h.push(`height="${i}"`)}return{href:d,dimensions:h}}e.parseHrefAndDimensions=f}),define(_e[113],ye([1,0,16,34,10,12,24,8]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(s,l){const{os:r,tildify:m,relative:n}=l;if(n){const E=D(s,n,r);if(typeof E=="string")return E}let t=s.fsPath;if(r===1&&!A.isWindows?t=t.replace(/\//g,"\\"):r!==1&&A.isWindows&&(t=t.replace(/\\/g,"/")),r!==1&&m?.userHome){const E=m.userHome.fsPath;let y;s.scheme!==m.userHome.scheme&&s.path.startsWith(u.posix.sep)?y=m.userHome.with({path:s.path}).fsPath:y=s.fsPath,t=b(y,E,r)}return(r===1?u.win32:u.posix).normalize(R(t,r===1))}e.getPathLabel=S;function D(s,l,r){const m=r===1?u.win32:u.posix,n=r===3?_.extUri:_.extUriIgnorePathCase,t=l.getWorkspace(),c=(0,a.firstOrDefault)(t.folders);if(!c)return;s.scheme!==c.uri.scheme&&s.path.startsWith(u.posix.sep)&&(s=c.uri.with({path:s.path}));const E=l.getWorkspaceFolder(s);if(!E)return;let y;if(n.isEqual(E.uri,s)?y="":y=n.relativePath(E.uri,s)??"",y&&(y=m.normalize(y)),t.folders.length>1&&!l.noPrefix){const M=E.name?E.name:n.basenameOrAuthority(E.uri);y=y?`${M} \u2022 ${y}`:M}return y}function R(s,l=A.isWindows){return(0,P.hasDriveLetter)(s,l)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=R;let I=Object.create(null);function b(s,l,r=A.OS){if(r===1||!s||!l)return s;let m=I.original===l?I.normalized:void 0;m||(m=l,A.isWindows&&(m=(0,P.toSlashes)(m)),m=`${(0,T.rtrim)(m,u.posix.sep)}${u.posix.sep}`,I={original:l,normalized:m});let n=s;return A.isWindows&&(n=(0,P.toSlashes)(n)),(r===3?n.startsWith(m):(0,T.startsWithIgnoreCase)(n,m))?`~/${n.substr(m.length)}`:s}e.tildify=b;function k(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=k;const w="\u2026",f="\\\\",d="~";function h(s,l=u.sep){const r=new Array(s.length);let m=!1;for(let n=0;n<s.length;n++){const t=s[n];if(t===""){r[n]=`.${l}`;continue}if(!t){r[n]=t;continue}m=!0;let c="",E=t;E.indexOf(f)===0?(c=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length)):E.indexOf(l)===0?(c=E.substr(0,E.indexOf(l)+l.length),E=E.substr(E.indexOf(l)+l.length)):E.indexOf(d)===0&&(c=E.substr(0,E.indexOf(d)+d.length),E=E.substr(E.indexOf(d)+d.length));const y=E.split(l);for(let M=1;m&&M<=y.length;M++)for(let j=y.length-M;m&&j>=0;j--){m=!1;let $=y.slice(j,j+M).join(l);for(let N=0;!m&&N<s.length;N++)if(N!==n&&s[N]&&s[N].indexOf($)>-1){const x=j+M===y.length,L=j>0&&s[N].indexOf(l)>-1?l+$:$,F=s[N].endsWith(L);m=!x||F}if(!m){let N="";(y[0].endsWith(":")||c!=="")&&(j===1&&(j=0,M++,$=y[0]+l+$),j>0&&(N=y[0]+l),N=c+N),j>0&&(N=N+w+l),N=N+$,j+M<y.length&&(N=N+l+w),r[n]=N}}m&&(r[n]=t)}return r}e.shorten=h;var g;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function v(s,l=Object.create(null)){const r=[];let m=!1,n="";for(const t of s)if(t==="$"||m&&t==="{")n&&r.push({value:n,type:g.TEXT}),n="",m=!0;else if(t==="}"&&m){const c=l[n];if(typeof c=="string")c.length&&r.push({value:c,type:g.VARIABLE});else if(c){const E=r[r.length-1];(!E||E.type!==g.SEPARATOR)&&r.push({value:c.label,type:g.SEPARATOR})}n="",m=!1}else n+=t;return n&&!m&&r.push({value:n,type:g.TEXT}),r.filter((t,c)=>{if(t.type===g.SEPARATOR){const E=r[c-1],y=r[c+1];return[E,y].every(M=>M&&(M.type===g.VARIABLE||M.type===g.TEXT)&&M.value.length>0)}return!0}).map(t=>t.value).join("")}e.template=v;function C(s,l){return A.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):s.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function p(s,l){return A.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):A.isWindows?s.replace(/&&|&/g,r=>r==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(s){const l=s.indexOf("/")!==-1?u.posix:u.win32,r=l.basename(s),m=l.dirname(s);return r.length?{name:r,parentPath:m}:{name:m,parentPath:""}}e.splitName=o}),define(_e[114],ye([1,0,22,2]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function u(I){return I.toJSON()}class A{constructor(b){this._uriTransformer=b}transformIncoming(b){const k=this._uriTransformer.transformIncoming(b);return k===b?b:u(P.URI.from(k))}transformOutgoing(b){const k=this._uriTransformer.transformOutgoing(b);return k===b?b:u(P.URI.from(k))}transformOutgoingURI(b){const k=this._uriTransformer.transformOutgoing(b);return k===b?b:P.URI.from(k)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function _(I,b,k){if(!I||k>200)return null;if(typeof I=="object"){if(I instanceof P.URI)return b.transformOutgoing(I);for(const w in I)if(Object.hasOwnProperty.call(I,w)){const f=_(I[w],b,k+1);f!==null&&(I[w]=f)}}return null}function T(I,b){const k=_(I,b,0);return k===null?I:k}e.transformOutgoingURIs=T;function S(I,b,k,w){if(!I||w>200)return null;if(typeof I=="object"){if(I.$mid===1)return k?P.URI.revive(b.transformIncoming(I)):b.transformIncoming(I);if(I instanceof a.VSBuffer)return null;for(const f in I)if(Object.hasOwnProperty.call(I,f)){const d=S(I[f],b,k,w+1);d!==null&&(I[f]=d)}}return null}function D(I,b){const k=S(I,b,!1,0);return k===null?I:k}e.transformIncomingURIs=D;function R(I,b){const k=S(I,b,!0,0);return k===null?I:k}e.transformAndReviveIncomingURIs=R}),define(_e[29],ye([1,0,70,71,319,19,34,86,10,12,24,2]),function(ie,e,a,P,u,A,_,T,S,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(L){L[L.UNLINK=0]="UNLINK",L[L.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function k(L,F=b.UNLINK){if((0,_.isRootOrDriveLetter)(L))throw new Error("rimraf - will refuse to recursively delete root");return F===b.UNLINK?f(L):w(L)}async function w(L){try{const F=(0,_.randomPath)((0,P.tmpdir)());try{await a.promises.rename(L,F)}catch(U){return U.code==="ENOENT"?void 0:f(L)}f(F).catch(U=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function f(L){return(0,u.promisify)(a.rm)(L,{recursive:!0,force:!0,maxRetries:3})}function d(L){if((0,_.isRootOrDriveLetter)(L))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(L,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function h(L,F){return C(await(F?g(L):(0,u.promisify)(a.readdir)(L)))}async function g(L){try{return await(0,u.promisify)(a.readdir)(L,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const F=[],U=await h(L);for(const H of U){let de=!1,Y=!1,V=!1;try{const X=await e.Promises.lstat((0,S.join)(L,H));de=X.isFile(),Y=X.isDirectory(),V=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}F.push({name:H,isFile:()=>de,isDirectory:()=>Y,isSymbolicLink:()=>V})}return F}function v(L){return C(a.readdirSync(L))}e.readdirSync=v;function C(L){return L.map(F=>typeof F=="string"?D.isMacintosh?(0,T.normalizeNFC)(F):F:(F.name=D.isMacintosh?(0,T.normalizeNFC)(F.name):F.name,F))}async function p(L){const F=await h(L),U=[];for(const H of F)await o.existsDirectory((0,S.join)(L,H))&&U.push(H);return U}function i(L,F=1e3){return new Promise(U=>{let H=!1;const de=setInterval(()=>{H||(H=!0,a.access(L,Y=>{H=!1,Y&&(clearInterval(de),U(void 0))}))},F)})}e.whenDeleted=i;var o;(function(L){async function F(de){let Y;try{if(Y=await e.Promises.lstat(de),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(de),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(D.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(de)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw X}throw V}}L.stat=F;async function U(de){try{const{stat:Y,symbolicLink:V}=await L.stat(de);return Y.isFile()&&V?.dangling!==!0}catch{}return!1}L.existsFile=U;async function H(de){try{const{stat:Y,symbolicLink:V}=await L.stat(de);return Y.isDirectory()&&V?.dangling!==!0}catch{}return!1}L.existsDirectory=H})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new A.ResourceQueue;function l(L,F,U){return s.queueFor(I.URI.file(L),R.extUriBiasedIgnorePathCase).queue(()=>{const H=c(U);return new Promise((de,Y)=>n(L,F,H,V=>V?Y(V):de()))})}let r=!0;function m(L){r=L}e.configureFlushOnWrite=m;function n(L,F,U,H){if(!r)return a.writeFile(L,F,{mode:U.mode,flag:U.flag},H);a.open(L,U.flag,U.mode,(de,Y)=>{if(de)return H(de);a.writeFile(Y,F,V=>{if(V)return a.close(Y,()=>H(V));a.fdatasync(Y,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),m(!1)),a.close(Y,Z=>H(Z))))})})}function t(L,F,U){const H=c(U);if(!r)return a.writeFileSync(L,F,{mode:H.mode,flag:H.flag});const de=a.openSync(L,H.flag,H.mode);try{a.writeFileSync(de,F);try{a.fdatasyncSync(de)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),m(!1)}}finally{a.closeSync(de)}}e.writeFileSync=t;function c(L){return L?{mode:typeof L.mode=="number"?L.mode:438,flag:typeof L.flag=="string"?L.flag:"w"}:{mode:438,flag:"w"}}async function E(L,F){if(L!==F)try{await e.Promises.rename(L,F)}catch(U){if(L.toLowerCase()!==F.toLowerCase()&&U.code==="EXDEV"||L.endsWith("."))await y(L,F,{preserveSymlinks:!1}),await k(L,b.MOVE);else throw U}}async function y(L,F,U){return j(L,F,{root:{source:L,target:F},options:U,handledSourcePaths:new Set})}const M=511;async function j(L,F,U){if(U.handledSourcePaths.has(L))return;U.handledSourcePaths.add(L);const{stat:H,symbolicLink:de}=await o.stat(L);if(de){if(U.options.preserveSymlinks)try{return await x(L,F,U)}catch(Y){console.warn("[node.js fs] copy of symlink failed: ",Y)}if(de.dangling)return}return H.isDirectory()?$(L,F,H.mode&M,U):N(L,F,H.mode&M)}async function $(L,F,U,H){await e.Promises.mkdir(F,{recursive:!0,mode:U});const de=await h(L);for(const Y of de)await j((0,S.join)(L,Y),(0,S.join)(F,Y),H)}async function N(L,F,U){await e.Promises.copyFile(L,F),await e.Promises.chmod(F,U)}async function x(L,F,U){let H=await e.Promises.readlink(L);(0,_.isEqualOrParent)(H,U.root.source,!D.isLinux)&&(H=(0,S.join)(U.root.target,H.substr(U.root.source.length+1))),await e.Promises.symlink(H,F)}e.Promises=new class{get access(){return(0,u.promisify)(a.access)}get stat(){return(0,u.promisify)(a.stat)}get lstat(){return(0,u.promisify)(a.lstat)}get utimes(){return(0,u.promisify)(a.utimes)}get read(){return(L,F,U,H,de)=>new Promise((Y,V)=>{a.read(L,F,U,H,de,(X,Z,te)=>X?V(X):Y({bytesRead:Z,buffer:te}))})}get readFile(){return(0,u.promisify)(a.readFile)}get write(){return(L,F,U,H,de)=>new Promise((Y,V)=>{a.write(L,F,U,H,de,(X,Z,te)=>X?V(X):Y({bytesWritten:Z,buffer:te}))})}get appendFile(){return(0,u.promisify)(a.appendFile)}get fdatasync(){return(0,u.promisify)(a.fdatasync)}get truncate(){return(0,u.promisify)(a.truncate)}get rename(){return(0,u.promisify)(a.rename)}get copyFile(){return(0,u.promisify)(a.copyFile)}get open(){return(0,u.promisify)(a.open)}get close(){return(0,u.promisify)(a.close)}get symlink(){return(0,u.promisify)(a.symlink)}get readlink(){return(0,u.promisify)(a.readlink)}get chmod(){return(0,u.promisify)(a.chmod)}get mkdir(){return(0,u.promisify)(a.mkdir)}get unlink(){return(0,u.promisify)(a.unlink)}get rmdir(){return(0,u.promisify)(a.rmdir)}get realpath(){return(0,u.promisify)(a.realpath)}async exists(L){try{return await e.Promises.access(L),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return p}get writeFile(){return l}get rm(){return k}get move(){return E}get copy(){return y}}}),define(_e[115],ye([1,0,70,10,12,8,29]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(b){if(u.isLinux)return b;const k=(0,P.dirname)(b);if(b===k)return b;const w=((0,P.basename)(b)||b).toLowerCase();try{const d=(0,_.readdirSync)(k).filter(h=>h.toLowerCase()===w);if(d.length===1){const h=T(k);if(h)return(0,P.join)(h,d[0])}else if(d.length>1){const h=d.indexOf(w);if(h>=0){const g=T(k);if(g)return(0,P.join)(g,d[h])}}}catch{}return null}e.realcaseSync=T;async function S(b){if(u.isLinux)return b;const k=(0,P.dirname)(b);if(b===k)return b;const w=((0,P.basename)(b)||b).toLowerCase();try{const d=(await _.Promises.readdir(k)).filter(h=>h.toLowerCase()===w);if(d.length===1){const h=await S(k);if(h)return(0,P.join)(h,d[0])}else if(d.length>1){const h=d.indexOf(w);if(h>=0){const g=await S(k);if(g)return(0,P.join)(g,d[h])}}}catch{}return null}e.realcase=S;async function D(b){try{return await _.Promises.realpath(b)}catch{const w=I(b);return await _.Promises.access(w,a.constants.R_OK),w}}e.realpath=D;function R(b){try{return a.realpathSync(b)}catch{const w=I(b);return a.accessSync(w,a.constants.R_OK),w}}e.realpathSync=R;function I(b){return(0,A.rtrim)((0,P.normalize)(b),P.sep)}}),define(_e[116],ye([1,0,10,12,33,109,9,29]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(I=u.env){return I.comspec||"cmd.exe"}e.getWindowsShell=S;function D(I){let b=[],k=!1;const w=function(f){if(k){b.push(f);return}(!I.send(f,h=>{if(h&&console.error(h),k=!1,b.length>0){const g=b.slice(0);b=[],g.forEach(v=>w(v))}})||P.isWindows)&&(k=!0)};return{send:w}}e.createQueuedSender=D;var R;(function(I){async function b(k,w,f){if(a.isAbsolute(k))return k;if(w===void 0&&(w=u.cwd()),a.dirname(k)!=="."||(f===void 0&&_.isString(u.env.PATH)&&(f=u.env.PATH.split(a.delimiter)),f===void 0||f.length===0))return a.join(w,k);async function h(g){if(await T.Promises.exists(g)){let v;try{v=await T.Promises.stat(g)}catch(C){C.message.startsWith("EACCES")&&(v=await T.Promises.lstat(g))}return v?!v.isDirectory():!1}return!1}for(const g of f){let v;if(a.isAbsolute(g)?v=a.join(g,k):v=a.join(w,g,k),await h(v))return v;let C=v+".com";if(await h(C)||(C=v+".exe",await h(C)))return C}return a.join(w,k)}I.findExecutable=b})(R=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(ie,e,a,P){var u=arguments.length,A=u<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,a):P,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,a,P);else for(var T=ie.length-1;T>=0;T--)(_=ie[T])&&(A=(u<3?_(A):u>3?_(e,a,A):_(e,a))||A);return u>3&&A&&Object.defineProperty(e,a,A),A};define(_e[117],ye([1,0,16,19,22,21,62,11,3,6,69,8,9]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var k;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(k||(k={}));function w(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(f||(f={}));function d(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(h||(h={}));function g(Y){let V=0;for(let X=0;;X+=7){const Z=Y.read(1);if(V|=(Z.buffer[0]&127)<<X,!(Z.buffer[0]&128))return V}}const v=s(0);function C(Y,V){if(V===0){Y.write(v);return}let X=0;for(let te=V;te!==0;te=te>>>7)X++;const Z=u.VSBuffer.alloc(X);for(let te=0;V!==0;te++)Z.buffer[te]=V&127,V=V>>>7,V>0&&(Z.buffer[te]|=128);Y.write(Z)}class p{constructor(V){this.buffer=V,this.pos=0}read(V){const X=this.buffer.slice(this.pos,this.pos+V);return this.pos+=X.byteLength,X}}e.BufferReader=p;class i{constructor(){this.buffers=[]}get buffer(){return u.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}e.BufferWriter=i;var o;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(o||(o={}));function s(Y){const V=u.VSBuffer.alloc(1);return V.writeUInt8(Y,0),V}const l={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},r=typeof Buffer<"u";function m(Y,V){if(typeof V>"u")Y.write(l.Undefined);else if(typeof V=="string"){const X=u.VSBuffer.fromString(V);Y.write(l.String),C(Y,X.byteLength),Y.write(X)}else if(r&&Buffer.isBuffer(V)){const X=u.VSBuffer.wrap(V);Y.write(l.Buffer),C(Y,X.byteLength),Y.write(X)}else if(V instanceof u.VSBuffer)Y.write(l.VSBuffer),C(Y,V.byteLength),Y.write(V);else if(Array.isArray(V)){Y.write(l.Array),C(Y,V.length);for(const X of V)m(Y,X)}else if(typeof V=="number"&&(V|0)===V)Y.write(l.Uint),C(Y,V);else{const X=u.VSBuffer.fromString(JSON.stringify(V));Y.write(l.Object),C(Y,X.byteLength),Y.write(X)}}e.serialize=m;function n(Y){switch(Y.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return Y.read(g(Y)).toString();case o.Buffer:return Y.read(g(Y)).buffer;case o.VSBuffer:return Y.read(g(Y));case o.Array:{const X=g(Y),Z=[];for(let te=0;te<X;te++)Z.push(n(Y));return Z}case o.Object:return JSON.parse(Y.read(g(Y)).toString());case o.Int:return g(Y)}}e.deserialize=n;class t{constructor(V,X,Z=null,te=1e3){this.protocol=V,this.ctx=X,this.logger=Z,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(V,X){this.channels.set(V,X),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const X=this.send([V.type]);this.logger?.logOutgoing(X,0,1,d(V.type));return}case 201:case 202:case 204:case 203:{const X=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(X,V.id,1,d(V.type),V.data);return}}}send(V,X=void 0){const Z=new i;return m(Z,V),m(Z,X),this.sendBuffer(Z.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const X=new p(V),Z=n(X),te=n(X),K=Z[0];switch(K){case 100:return this.logger?.logIncoming(V.byteLength,Z[1],1,`${w(K)}: ${Z[2]}.${Z[3]}`,te),this.onPromise({type:K,id:Z[1],channelName:Z[2],name:Z[3],arg:te});case 102:return this.logger?.logIncoming(V.byteLength,Z[1],1,`${w(K)}: ${Z[2]}.${Z[3]}`,te),this.onEventListen({type:K,id:Z[1],channelName:Z[2],name:Z[3],arg:te});case 101:return this.logger?.logIncoming(V.byteLength,Z[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:Z[1]});case 103:return this.logger?.logIncoming(V.byteLength,Z[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:Z[1]})}}onPromise(V){const X=this.channels.get(V.channelName);if(!X){this.collectPendingRequest(V);return}const Z=new A.CancellationTokenSource;let te;try{te=X.call(this.ctx,V.name,V.arg,Z.token)}catch(ne){te=Promise.reject(ne)}const K=V.id;te.then(ne=>{this.sendResponse({id:K,data:ne,type:201}),this.activeRequests.delete(V.id)},ne=>{ne instanceof Error?this.sendResponse({id:K,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:K,data:ne,type:203}),this.activeRequests.delete(V.id)});const J=(0,D.toDisposable)(()=>Z.cancel());this.activeRequests.set(V.id,J)}onEventListen(V){const X=this.channels.get(V.channelName);if(!X){this.collectPendingRequest(V);return}const Z=V.id,K=X.listen(this.ctx,V.name,V.arg)(J=>this.sendResponse({id:Z,data:J,type:204}));this.activeRequests.set(V.id,K)}disposeActiveRequest(V){const X=this.activeRequests.get(V.id);X&&(X.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let X=this.pendingRequests.get(V.channelName);X||(X=[],this.pendingRequests.set(V.channelName,X));const Z=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:V,timeoutTimer:Z})}flushPendingRequests(V){const X=this.pendingRequests.get(V);if(X){for(const Z of X)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.onPromise(Z.request);break;case 102:this.onEventListen(Z.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=t;var c;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(V,X=null){this.protocol=V,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Z=>this.onBuffer(Z)),this.logger=X}getChannel(V){const X=this;return{call(Z,te,K){return X.isDisposed?Promise.reject(new T.CancellationError):X.requestPromise(V,Z,te,K)},listen(Z,te){return X.isDisposed?S.Event.None:X.requestEvent(V,Z,te)}}}requestPromise(V,X,Z,te=A.CancellationToken.None){const K=this.lastRequestId++,ne={id:K,type:100,channelName:V,name:X,arg:Z};if(te.isCancellationRequested)return Promise.reject(new T.CancellationError);let pe;return new Promise((Ie,Le)=>{if(te.isCancellationRequested)return Le(new T.CancellationError);const oe=()=>{const le=re=>{switch(re.type){case 201:this.handlers.delete(K),Ie(re.data);break;case 202:{this.handlers.delete(K);const O=new Error(re.data.message);O.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,O.name=re.data.name,Le(O);break}case 203:this.handlers.delete(K),Le(re.data);break}};this.handlers.set(K,le),this.sendRequest(ne)};let ae=null;this.state===h.Idle?oe():(ae=(0,P.createCancelablePromise)(le=>this.whenInitialized()),ae.then(()=>{ae=null,oe()}));const fe=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:K,type:101}),Le(new T.CancellationError)},ee=te.onCancellationRequested(fe);pe=(0,D.combinedDisposable)((0,D.toDisposable)(fe),ee),this.activeRequests.add(pe)}).finally(()=>{this.activeRequests.delete(pe)})}requestEvent(V,X,Z){const te=this.lastRequestId++,J={id:te,type:102,channelName:V,name:X,arg:Z};let ne=null;const pe=new S.Emitter({onWillAddFirstListener:()=>{ne=(0,P.createCancelablePromise)(Ie=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(pe),this.sendRequest(J)})},onDidRemoveLastListener:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(pe),this.sendRequest({id:te,type:103}))}}),be=Ie=>pe.fire(Ie.data);return this.handlers.set(te,be),pe.event}sendRequest(V){switch(V.type){case 100:case 102:{const X=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger?.logOutgoing(X,V.id,0,`${w(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const X=this.send([V.type,V.id]);this.logger?.logOutgoing(X,V.id,0,w(V.type));return}}}send(V,X=void 0){const Z=new i;return m(Z,V),m(Z,X),this.sendBuffer(Z.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const X=new p(V),Z=n(X),te=n(X),K=Z[0];switch(K){case 200:return this.logger?.logIncoming(V.byteLength,0,0,d(K)),this.onResponse({type:Z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(V.byteLength,Z[1],0,d(K),te),this.onResponse({type:Z[0],id:Z[1],data:te})}}onResponse(V){if(V.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(V.id)?.(V)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ve([_.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class y{get connections(){const V=[];return this._connections.forEach(X=>V.push(X)),V}constructor(V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,V(({protocol:X,onDidClientDisconnect:Z})=>{S.Event.once(X.onMessage)(K=>{const J=new p(K),ne=n(J),pe=new t(X,ne),be=new E(X);this.channels.forEach((Le,oe)=>pe.registerChannel(oe,Le));const Ie={channelServer:pe,channelClient:be,ctx:ne};this._connections.add(Ie),this._onDidAddConnection.fire(Ie),Z(()=>{pe.dispose(),be.dispose(),this._connections.delete(Ie),this._onDidRemoveConnection.fire(Ie)})})})}getChannel(V,X){const Z=this;return{call(te,K,J){let ne;if((0,b.isFunction)(X)){const be=(0,a.getRandomElement)(Z.connections.filter(X));ne=be?Promise.resolve(be):S.Event.toPromise(S.Event.filter(Z.onDidAddConnection,X))}else ne=X.routeCall(Z,te,K);const pe=ne.then(be=>be.channelClient.getChannel(V));return j(pe).call(te,K,J)},listen(te,K){if((0,b.isFunction)(X))return Z.getMulticastEvent(V,X,te,K);const J=X.routeEvent(Z,te,K).then(ne=>ne.channelClient.getChannel(V));return j(J).listen(te,K)}}}getMulticastEvent(V,X,Z,te){const K=this;let J=new D.DisposableStore;const ne=new S.Emitter({onWillAddFirstListener:()=>{J=new D.DisposableStore;const pe=new S.EventMultiplexer,be=new Map,Ie=oe=>{const fe=oe.channelClient.getChannel(V).listen(Z,te),ee=pe.add(fe);be.set(oe,ee)},Le=oe=>{const ae=be.get(oe);!ae||(ae.dispose(),be.delete(oe))};K.connections.filter(X).forEach(Ie),S.Event.filter(K.onDidAddConnection,X)(Ie,void 0,J),K.onDidRemoveConnection(Le,void 0,J),pe.event(ne.fire,ne,J),J.add(pe)},onDidRemoveLastListener:()=>{J.dispose()}});return ne.event}registerChannel(V,X){this.channels.set(V,X),this._connections.forEach(Z=>{Z.channelServer.registerChannel(V,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class M{constructor(V,X,Z=null){const te=new i;m(te,X),V.send(te.buffer),this.channelClient=new E(V,Z),this.channelServer=new t(V,X,Z)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,X){this.channelServer.registerChannel(V,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=M;function j(Y){return{call(V,X,Z){return Y.then(te=>te.call(V,X,Z))},listen(V,X){const Z=new S.Relay;return Y.then(te=>Z.input=te.listen(V,X)),Z.event}}}e.getDelayedChannel=j;function $(Y){let V=!1;return{call(X,Z,te){return V?Y.call(X,Z,te):(0,P.timeout)(0).then(()=>V=!0).then(()=>Y.call(X,Z,te))},listen(X,Z){if(V)return Y.listen(X,Z);const te=new S.Relay;return(0,P.timeout)(0).then(()=>V=!0).then(()=>te.input=Y.listen(X,Z)),te.event}}}e.getNextTickChannel=$;class N{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const X of V.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await S.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=N;var x;(function(Y){function V(K,J){const ne=K,pe=J&&J.disableMarshalling,be=new Map;for(const Ie in ne)Z(Ie)&&be.set(Ie,S.Event.buffer(ne[Ie],!0));return new class{listen(Ie,Le,oe){const ae=be.get(Le);if(ae)return ae;if(te(Le)){const fe=ne[Le];if(typeof fe=="function")return fe.call(ne,oe)}throw new Error(`Event not found: ${Le}`)}call(Ie,Le,oe){const ae=ne[Le];if(typeof ae=="function"){if(!pe&&Array.isArray(oe))for(let fe=0;fe<oe.length;fe++)oe[fe]=(0,R.revive)(oe[fe]);return ae.apply(ne,oe)}throw new Error(`Method not found: ${Le}`)}}}Y.fromService=V;function X(K,J){const ne=J&&J.disableMarshalling;return new Proxy({},{get(pe,be){if(typeof be=="string")return J?.properties?.has(be)?J.properties.get(be):te(be)?function(Ie){return K.listen(be,Ie)}:Z(be)?K.listen(be):async function(...Ie){let Le;J&&!(0,b.isUndefinedOrNull)(J.context)?Le=[J.context,...Ie]:Le=Ie;const oe=await K.call(be,Le);return ne?oe:(0,R.revive)(oe)};throw new Error(`Property not found: ${String(be)}`)}})}Y.toService=X;function Z(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}function te(K){return/^onDynamic/.test(K)&&I.isUpperAsciiLetter(K.charCodeAt(9))}})(x=e.ProxyChannel||(e.ProxyChannel={}));const L=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const V=Y.toString();if(V!=="[object Object]")return V}return Y}function U(Y){return Array.isArray(Y)?Y.map(F):F(Y)}function H(Y,V,X,Z,te,K,J){J=U(J);const ne=L[te],pe=ne[Z%ne.length];let be=[`%c[${Y}]%c[${String(V).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(K)?(be=be.concat(J),be.push(")")):be.push(J),console.log.apply(console,be)}class de{constructor(V,X){this._outgoingPrefix=V,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,X,Z,te,K){this._totalOutgoing+=V,H(this._outgoingPrefix,this._totalOutgoing,V,X,Z,te,K)}logIncoming(V,X,Z,te,K){this._totalIncoming+=V,H(this._incomingPrefix,this._totalIncoming,V,X,Z,te,K)}}e.IPCLogger=de}),define(_e[118],ye([1,0,19,22,3,6,117]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(E){E.enableDiagnostics=!1,E.records=[];const y=new WeakMap;let M=0;function j(N,x){if(!y.has(N)){const L=String(++M);y.set(N,L)}return y.get(N)}function $(N,x,L,F){if(!E.enableDiagnostics)return;const U=j(N,x);if(F instanceof P.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const H=P.VSBuffer.alloc(F.byteLength);H.set(F),E.records.push({timestamp:Date.now(),id:U,label:x,type:L,buff:H})}else E.records.push({timestamp:Date.now(),id:U,label:x,type:L,data:F})}E.traceSocketEvent=$})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var D;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let R=null;function I(){return R||(R=P.VSBuffer.alloc(0)),R}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(y){this._chunks.push(y),this._totalLength+=y.byteLength}read(y){return this._read(y,!0)}peek(y){return this._read(y,!1)}_read(y,M){if(y===0)return I();if(y>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===y){const x=this._chunks[0];return M&&(this._chunks.shift(),this._totalLength-=y),x}if(this._chunks[0].byteLength>y){const x=this._chunks[0].slice(0,y);return M&&(this._chunks[0]=this._chunks[0].slice(y),this._totalLength-=y),x}const j=P.VSBuffer.alloc(y);let $=0,N=0;for(;y>0;){const x=this._chunks[N];if(x.byteLength>y){const L=x.slice(0,y);j.set(L,$),$+=y,M&&(this._chunks[N]=x.slice(y),this._totalLength-=y),y-=y}else j.set(x,$),$+=x.byteLength,M?(this._chunks.shift(),this._totalLength-=x.byteLength):N++,y-=x.byteLength}return j}}e.ChunkStream=b;var k;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(k||(k={}));function w(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var f;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(y,M,j,$){this.type=y,this.id=M,this.ack=j,this.data=$,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends A.Disposable{constructor(y){super(),this._onMessage=this._register(new u.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=y,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(M=>this.acceptChunk(M))),this.lastReadTime=Date.now()}acceptChunk(y){if(!(!y||y.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(y);this._incomingData.byteLength>=this._state.readLen;){const M=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=M.readUInt32BE(9),this._state.messageType=M.readUInt8(0),this._state.id=M.readUInt32BE(1),this._state.ack=M.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const j=this._state.messageType,$=this._state.id,N=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",M),this._onMessage.fire(new d(j,$,N,M)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(y){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=y,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(y){if(this._isDisposed)return;y.writtenTime=Date.now(),this.lastWriteTime=Date.now();const M=P.VSBuffer.alloc(13);M.writeUInt8(y.type,0),M.writeUInt32BE(y.id,1),M.writeUInt32BE(y.ack,5),M.writeUInt32BE(y.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(y.type),id:y.id,ack:y.ack,messageSize:y.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",y.data),this._writeSoon(M,y.data)}_bufferAdd(y,M){const j=this._totalLength===0;return this._data.push(y,M),this._totalLength+=y.byteLength+M.byteLength,j}_bufferTake(){const y=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,y}_writeSoon(y,M){this._bufferAdd(y,M)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const y=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:y.byteLength}),this._socket.write(y)}}class v extends A.Disposable{constructor(y){super(),this._onMessage=new u.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new u.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=y,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(M=>{M.type===1&&this._onMessage.fire(M.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(y){this._socketWriter.write(new d(1,0,0,y))}}e.Protocol=v;class C extends _.IPCClient{static fromSocket(y,M){return new C(new v(y),M)}get onDidDispose(){return this.protocol.onDidDispose}constructor(y,M,j=null){super(y,M,j),this.protocol=y}dispose(){super.dispose();const y=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),y.end()}}e.Client=C;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new u.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(y){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(y):this._emitter.fire(y):this._bufferedMessages.push(y)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class i{constructor(y){this.data=y,this.next=null}}class o{constructor(){this._first=null,this._last=null}length(){let y=0,M=this._first;for(;M;)M=M.next,y++;return y}peek(){return this._first?this._first.data:null}toArray(){const y=[];let M=0,j=this._first;for(;j;)y[M++]=j.data,j=j.next;return y}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(y){const M=new i(y);if(!this._first){this._first=M,this._last=M;return}this._last.next=M,this._last=M}}class s{static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}constructor(){this.lastRuns=[];const y=Date.now();for(let M=0;M<s._HISTORY_LENGTH;M++)this.lastRuns[M]=y-1e3*M;setInterval(()=>{for(let M=s._HISTORY_LENGTH;M>=1;M--)this.lastRuns[M]=this.lastRuns[M-1];this.lastRuns[0]=Date.now()},1e3)}load(){const y=Date.now(),M=(1+s._HISTORY_LENGTH)*1e3;let j=0;for(let $=0;$<s._HISTORY_LENGTH;$++)y-this.lastRuns[$]<=M&&j++;return 1-j/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;var l;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(l=e.ConnectionHealth||(e.ConnectionHealth={}));function r(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class m{constructor(y){this.connectionHealth=y}}e.ConnectionHealthChangedEvent=m;class n{constructor(y,M){this.roundTripTime=y,this.recentHighRoundTripCount=M}}e.HighRoundTripTimeEvent=n;class t{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(y){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new p,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new p,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=y.loadEstimator??s.getInstance(),this._measureRoundTripTime=y.measureRoundTripTime??!1,this._shouldSendKeepAlive=y.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=y.socket,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new h(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(M=>this._receiveMessage(M))),this._socketDisposables.add(this._socket.onClose(M=>this._onSocketClose.fire(M))),this._socketLatencyMonitor=this._socketDisposables.add(new c),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(M=>this._sendLatencyMeasurementRequest(M))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(M=>this._onHighRoundTripTime.fire(M))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(M=>this._onDidChangeConnectionHealth.fire(M))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),y.initialChunk&&this._socketReader.acceptChunk(y.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const y=new d(5,0,0,I());this._socketWriter.write(y),this._socketWriter.flush()}sendPause(){const y=new d(7,0,0,I());this._socketWriter.write(y)}sendResume(){const y=new d(8,0,0,I());this._socketWriter.write(y)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(y,M){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=y,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new h(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(j=>this._receiveMessage(j))),this._socketDisposables.add(this._socket.onClose(j=>this._onSocketClose.fire(j))),this._socketLatencyMonitor=this._socketDisposables.add(new c),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(j=>this._sendLatencyMeasurementRequest(j))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(j=>this._onHighRoundTripTime.fire(j))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(j=>this._onDidChangeConnectionHealth.fire(j))),this._socketReader.acceptChunk(M)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const y=new d(3,0,this._incomingAckId,I());this._socketWriter.write(y);const M=this._outgoingUnackMsg.toArray();for(let j=0,$=M.length;j<$;j++)this._socketWriter.write(M[j]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(y){if(y.ack>this._outgoingAckId){this._outgoingAckId=y.ack;do{const M=this._outgoingUnackMsg.peek();if(M&&M.id<=y.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(y.type){case 0:break;case 1:{if(y.id>this._incomingMsgId)if(y.id!==this._incomingMsgId+1){const M=Date.now();M-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=M,this._socketWriter.write(new d(6,0,0,I())))}else this._incomingMsgId=y.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(y.data);break}case 2:{this._onControlMessage.fire(y.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const M=this._outgoingUnackMsg.toArray();for(let j=0,$=M.length;j<$;j++)this._socketWriter.write(M[j]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(y.data);break}case 11:{this._socketLatencyMonitor.handleResponse(y.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(y){const M=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const j=new d(1,M,this._incomingAckId,y);this._outgoingUnackMsg.push(j),this._isReconnecting||(this._socketWriter.write(j),this._recvAckCheck())}sendControl(y){const M=new d(2,0,0,y);this._socketWriter.write(M)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const y=Date.now()-this._incomingMsgLastTime;if(y>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-y+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const y=this._outgoingUnackMsg.peek(),M=Date.now()-y.writtenTime,j=Date.now()-this._socketReader.lastReadTime,$=Date.now()-this._lastSocketTimeoutTime;if(M>=2e4&&j>=2e4&&$>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:M,timeSinceLastReceivedSomeData:j});return}const N=Math.max(2e4-M,2e4-j,2e4-$,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},N)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const y=new d(3,0,this._incomingAckId,I());this._socketWriter.write(y)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const y=new d(9,0,this._incomingAckId,I());this._socketWriter.write(y)}_sendLatencyMeasurementRequest(y){this._incomingAckId=this._incomingMsgId;const M=new d(10,0,this._incomingAckId,y);this._socketWriter.write(M)}_sendLatencyMeasurementResponse(y){this._incomingAckId=this._incomingMsgId;const M=new d(11,0,this._incomingAckId,y);this._socketWriter.write(M)}}e.PersistentProtocol=t;class c extends A.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new u.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new u.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new u.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new a.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},y=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const y=++this._lastLatencyMeasurementId,M=P.VSBuffer.alloc(4);M.writeUInt32BE(y,0),this._onSendLatencyRequest.fire(M)},6e4)}handleResponse(y){if(y.byteLength!==4)return;const M=y.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||M!==this._lastLatencyMeasurementId)return;const j=Date.now()-this._lastLatencyMeasurementSent,$=this._latencySampleIndex++;this._latencySamples[$%this._latencySamples.length]=j;const N=this._connectionHealth,x=this._latencySamples.filter(L=>L>=1e3).length;this._connectionHealth=x>=3?1:0,j>1e3&&this._onHighRoundTripTime.fire(new n(j,x)),N!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(_e[119],ye([1,0,22,11,3,6,10,12,30,117,118]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class b{traceSocketEvent(n,t){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,t)}constructor(n,t=""){this._canWrite=!0,this.debugLabel=t,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=c=>{if(this.traceSocketEvent("error",{code:c?.code,message:c?.message}),c){if(c.code==="EPIPE")return;(0,P.onUnexpectedError)(c)}},this.socket.on("error",this._errorListener),this._closeListener=c=>{this.traceSocketEvent("close",{hadError:c}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(n){const t=c=>{this.traceSocketEvent("read",c),n(a.VSBuffer.wrap(c))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(n){const t=c=>{n({type:0,hadError:c,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(n){const t=()=>{n()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(n){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,P.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,P.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const c=()=>{this.socket.off("close",c),this.socket.off("end",c),this.socket.off("error",c),this.socket.off("timeout",c),this.socket.off("drain",c),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",c),this.socket.on("end",c),this.socket.on("error",c),this.socket.on("timeout",c),this.socket.on("drain",c)})}}e.NodeSocket=b;var k;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(k||(k={}));var w;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(w||(w={}));class f extends A.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(n,t){this.socket.traceSocketEvent(n,t)}constructor(n,t,c,E){super(),this._onData=this._register(new u.Emitter),this._onClose=this._register(new u.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:c?.byteLength||0,recordInflateBytes:E}),this._flowManager=this._register(new d(this,t,c,E,this._onData,(y,M)=>this._write(y,M))),this._register(this._flowManager.onError(y=>{console.error(y),(0,P.onUnexpectedError)(y),this._onClose.fire({type:0,hadError:!0,error:y})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData(y=>this._acceptChunk(y))),this._register(this.socket.onClose(y=>this._onClose.fire(y)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this._onData.event(n)}onClose(n){return this._onClose.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this._flowManager.writeMessage(n)}_write(n,t){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let c=2;n.byteLength<126?c+=0:n.byteLength<2**16?c+=2:c+=8;const E=a.VSBuffer.alloc(c);if(t?E.writeUInt8(194,0):E.writeUInt8(130,0),n.byteLength<126)E.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){E.writeUInt8(126,1);let y=1;E.writeUInt8(n.byteLength>>>8&255,++y),E.writeUInt8(n.byteLength>>>0&255,++y)}else{E.writeUInt8(127,1);let y=1;E.writeUInt8(0,++y),E.writeUInt8(0,++y),E.writeUInt8(0,++y),E.writeUInt8(0,++y),E.writeUInt8(n.byteLength>>>24&255,++y),E.writeUInt8(n.byteLength>>>16&255,++y),E.writeUInt8(n.byteLength>>>8&255,++y),E.writeUInt8(n.byteLength>>>0&255,++y)}this.socket.write(a.VSBuffer.concat([E,n]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(n){if(n.byteLength!==0){for(this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const t=this._incomingData.peek(this._state.readLen),c=t.readUInt8(0),E=(c&128)>>>7,y=(c&64)>>>6,M=t.readUInt8(1),j=(M&128)>>>7,$=M&127;this._state.state=2,this._state.readLen=2+(j?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=E,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(y)),this._state.firstFrameOfMessage=Boolean(E),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const t=this._incomingData.read(this._state.readLen),c=t.readUInt8(1),E=(c&128)>>>7;let y=c&127,M=1;y===126?y=t.readUInt8(++M)*2**8+t.readUInt8(++M):y===127&&(y=t.readUInt8(++M)*0+t.readUInt8(++M)*0+t.readUInt8(++M)*0+t.readUInt8(++M)*0+t.readUInt8(++M)*2**24+t.readUInt8(++M)*2**16+t.readUInt8(++M)*2**8+t.readUInt8(++M));let j=0;E&&(j=t.readUInt8(++M)*2**24+t.readUInt8(++M)*2**16+t.readUInt8(++M)*2**8+t.readUInt8(++M)),this._state.state=3,this._state.readLen=y,this._state.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const t=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),v(t,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(t,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await u.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class d extends A.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(n,t,c,E,y,M){super(),this._tracer=n,this._onData=y,this._writeFn=M,this._onError=this._register(new u.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new u.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,t?(this._zlibInflateStream=this._register(new h(this._tracer,E,c,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(j=>this._onError.fire(j))),this._register(this._zlibDeflateStream.onError(j=>this._onError.fire(j)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(n){this._writeQueue.push(n),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const n=this._writeQueue.shift();if(this._zlibDeflateStream){const t=await this._deflateMessage(this._zlibDeflateStream,n);this._writeFn(t,!0)}else this._writeFn(n,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(n,t){return new Promise((c,E)=>{n.write(t),n.flush(y=>c(y))})}acceptFrame(n,t,c){this._readQueue.push({data:n,isCompressed:t,isLastFrameOfMessage:c}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const n=this._readQueue.shift();if(this._zlibInflateStream&&n.isCompressed){const t=await this._inflateFrame(this._zlibInflateStream,n.data,n.isLastFrameOfMessage);this._onData.fire(t)}else this._onData.fire(n.data)}this._isProcessingReadQueue=!1}}_inflateFrame(n,t,c){return new Promise((E,y)=>{n.write(t),c&&n.write(a.VSBuffer.fromByteArray([0,0,255,255])),n.flush(M=>E(M))})}}class h extends A.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?a.VSBuffer.concat(this._recordedInflateBytes):a.VSBuffer.alloc(0)}constructor(n,t,c,E){super(),this._tracer=n,this._recordInflateBytes=t,this._onError=this._register(new u.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=I().zlib.createInflateRaw(E),this._zlibInflate.on("error",y=>{this._tracer.traceSocketEvent("zlibInflateError",{message:y?.message,code:y?.code}),this._onError.fire(y)}),this._zlibInflate.on("data",y=>{this._tracer.traceSocketEvent("zlibInflateData",y),this._pendingInflateData.push(a.VSBuffer.wrap(y))}),c&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",c.buffer),this._zlibInflate.write(c.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(n){this._recordInflateBytes&&this._recordedInflateBytes.push(n.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",n),this._zlibInflate.write(n.buffer)}flush(n){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const t=a.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,n(t)})}}class g extends A.Disposable{constructor(n,t){super(),this._tracer=n,this._onError=this._register(new u.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=I().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",c=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:c?.message,code:c?.code}),this._onError.fire(c)}),this._zlibDeflate.on("data",c=>{this._tracer.traceSocketEvent("zlibDeflateData",c),this._pendingDeflateData.push(a.VSBuffer.wrap(c))})}write(n){this._tracer.traceSocketEvent("zlibDeflateWrite",n.buffer),this._zlibDeflate.write(n.buffer)}flush(n){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let t=a.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,t=t.slice(0,t.byteLength-4),n(t)})}}function v(m,n){if(n===0)return;const t=m.byteLength>>>2;for(let $=0;$<t;$++){const N=m.readUInt32BE($*4);m.writeUInt32BE(N^n,$*4)}const c=t*4,E=m.byteLength-c,y=n>>>24&255,M=n>>>16&255,j=n>>>8&255;E>=1&&m.writeUInt8(m.readUInt8(c)^y,c),E>=2&&m.writeUInt8(m.readUInt8(c+1)^M,c+1),E>=3&&m.writeUInt8(m.readUInt8(c+2)^j,c+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const C={[2]:107,[1]:103};function p(){const m=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):n=(0,_.join)(I().os.tmpdir(),`vscode-ipc-${m}.sock`),o(n),n}e.createRandomIPCHandle=p;function i(m,n,t){const c=I().crypto.createHash("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${c}-${t}-${n}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-${c.substr(0,8)}-${t}-${n}.sock`):E=(0,_.join)(m,`${t}-${n}.sock`),o(E),E}e.createStaticIPCHandle=i;function o(m){const n=C[T.platform];typeof n=="number"&&m.length>=n&&console.warn(`WARNING: IPC handle "${m}" is longer than ${n} chars, try a shorter --user-data-dir`)}class s extends D.IPCServer{static toClientConnectionEvent(n){const t=u.Event.fromNodeEventEmitter(n,"connection");return u.Event.map(t,c=>({protocol:new R.Protocol(new b(c,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(c,"close"))}))}constructor(n){super(s.toClientConnectionEvent(n)),this.server=n}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function l(m){return new Promise((n,t)=>{const c=I().net.createServer();c.on("error",t),c.listen(m,()=>{c.removeListener("error",t),n(new s(c))})})}e.serve=l;function r(m,n){return new Promise((t,c)=>{const E=I().net.createConnection(m,()=>{E.removeListener("error",c),t(R.Client.fromSocket(new b(E,`ipc-client${n}`),n))});E.once("error",c)})}e.connect=r}),define(_e[164],ye([1,0,38,10]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function u(A,_,T,S,D,R){if(Array.isArray(A)){let I=0;for(const b of A){const k=u(b,_,T,S,D,R);if(k===10)return k;k>I&&(I=k)}return I}else{if(typeof A=="string")return S?A==="*"?5:A===T?10:0:0;if(A){const{language:I,pattern:b,scheme:k,hasAccessToAllModels:w,notebookType:f}=A;if(!S&&!w)return 0;f&&D&&(_=D);let d=0;if(k)if(k===_.scheme)d=10;else if(k==="*")d=5;else return 0;if(I)if(I===T)d=10;else if(I==="*")d=Math.max(d,5);else return 0;if(f)if(f===R)d=10;else if(f==="*"&&R!==void 0)d=Math.max(d,5);else return 0;if(b){let h;if(typeof b=="string"?h=b:h={...b,base:(0,P.normalize)(b.base)},h===_.fsPath||(0,a.match)(h,_.fsPath))d=10;else return 0}return d}else return 0}}e.score=u}),define(_e[165],ye([1,0,8,52,155]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(T,S,D,R){this._uri=T,this._lines=S,this._eol=D,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(T){T.eol&&T.eol!==this._eol&&(this._eol=T.eol,this._lineStarts=null);const S=T.changes;for(const D of S)this._acceptDeleteRange(D.range),this._acceptInsertText(new P.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=T.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const T=this._eol.length,S=this._lines.length,D=new Uint32Array(S);for(let R=0;R<S;R++)D[R]=this._lines[R].length+T;this._lineStarts=new u.PrefixSumComputer(D)}}_setLineText(T,S){this._lines[T]=S,this._lineStarts&&this._lineStarts.setValue(T,this._lines[T].length+this._eol.length)}_acceptDeleteRange(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this._setLineText(T.startLineNumber-1,this._lines[T.startLineNumber-1].substring(0,T.startColumn-1)+this._lines[T.startLineNumber-1].substring(T.endColumn-1));return}this._setLineText(T.startLineNumber-1,this._lines[T.startLineNumber-1].substring(0,T.startColumn-1)+this._lines[T.endLineNumber-1].substring(T.endColumn-1)),this._lines.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}_acceptInsertText(T,S){if(S.length===0)return;const D=(0,a.splitLines)(S);if(D.length===1){this._setLineText(T.lineNumber-1,this._lines[T.lineNumber-1].substring(0,T.column-1)+D[0]+this._lines[T.lineNumber-1].substring(T.column-1));return}D[D.length-1]+=this._lines[T.lineNumber-1].substring(T.column-1),this._setLineText(T.lineNumber-1,this._lines[T.lineNumber-1].substring(0,T.column-1)+D[0]);const R=new Uint32Array(D.length-1);for(let I=1;I<D.length;I++)this._lines.splice(T.lineNumber+I-1,0,D[I]),R[I-1]=D[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(T.lineNumber,R)}}e.MirrorTextModel=A}),define(_e[166],ye([1,0,8,152,52,32,107]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(g,v,C,p){this.searchString=g,this.isRegex=v,this.matchCase=C,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=D(this.searchString):g=this.searchString.indexOf(`
`)>=0;let v=null;try{v=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!v)return null;let C=!this.isRegex&&!g;return C&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(C=this.matchCase),new _.SearchData(v,this.wordSeparators?(0,P.getMapForWordSeparators)(this.wordSeparators):null,C?this.searchString:null)}}e.SearchParams=S;function D(h){if(!h||h.length===0)return!1;for(let g=0,v=h.length;g<v;g++){const C=h.charCodeAt(g);if(C===10)return!0;if(C===92){if(g++,g>=v)break;const p=h.charCodeAt(g);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=D;function R(h,g,v){if(!v)return new _.FindMatch(h,null);const C=[];for(let p=0,i=g.length;p<i;p++)C[p]=g[p];return new _.FindMatch(h,C)}e.createFindMatch=R;class I{constructor(g){const v=[];let C=0;for(let p=0,i=g.length;p<i;p++)g.charCodeAt(p)===10&&(v[C++]=p);this._lineFeedsOffsets=v}findLineFeedCountBeforeOffset(g){const v=this._lineFeedsOffsets;let C=0,p=v.length-1;if(p===-1||g<=v[0])return 0;for(;C<p;){const i=C+((p-C)/2>>0);v[i]>=g?p=i-1:v[i+1]>=g?(C=i,p=i):C=i+1}return C+1}}class b{static findMatches(g,v,C,p,i){const o=v.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(g,C,new d(o.wordSeparators,o.regex),p,i):this._doFindMatchesLineByLine(g,C,o,p,i):[]}static _getMultilineMatchRange(g,v,C,p,i,o){let s,l=0;p?(l=p.findLineFeedCountBeforeOffset(i),s=v+i+l):s=v+i;let r;if(p){const c=p.findLineFeedCountBeforeOffset(i+o.length)-l;r=s+o.length+c}else r=s+o.length;const m=g.getPositionAt(s),n=g.getPositionAt(r);return new A.Range(m.lineNumber,m.column,n.lineNumber,n.column)}static _doFindMatchesMultiline(g,v,C,p,i){const o=g.getOffsetAt(v.getStartPosition()),s=g.getValueInRange(v,1),l=g.getEOL()===`\r
`?new I(s):null,r=[];let m=0,n;for(C.reset(0);n=C.next(s);)if(r[m++]=R(this._getMultilineMatchRange(g,o,s,l,n.index,n[0]),n,p),m>=i)return r;return r}static _doFindMatchesLineByLine(g,v,C,p,i){const o=[];let s=0;if(v.startLineNumber===v.endLineNumber){const r=g.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return s=this._findMatchesInLine(C,r,v.startLineNumber,v.startColumn-1,s,o,p,i),o}const l=g.getLineContent(v.startLineNumber).substring(v.startColumn-1);s=this._findMatchesInLine(C,l,v.startLineNumber,v.startColumn-1,s,o,p,i);for(let r=v.startLineNumber+1;r<v.endLineNumber&&s<i;r++)s=this._findMatchesInLine(C,g.getLineContent(r),r,0,s,o,p,i);if(s<i){const r=g.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);s=this._findMatchesInLine(C,r,v.endLineNumber,0,s,o,p,i)}return o}static _findMatchesInLine(g,v,C,p,i,o,s,l){const r=g.wordSeparators;if(!s&&g.simpleSearch){const t=g.simpleSearch,c=t.length,E=v.length;let y=-c;for(;(y=v.indexOf(t,y+c))!==-1;)if((!r||f(r,v,E,y,c))&&(o[i++]=new _.FindMatch(new A.Range(C,y+1+p,C,y+1+c+p),null),i>=l))return i;return i}const m=new d(g.wordSeparators,g.regex);let n;m.reset(0);do if(n=m.next(v),n&&(o[i++]=R(new A.Range(C,n.index+1+p,C,n.index+1+n[0].length+p),n,s),i>=l))return i;while(n);return i}static findNextMatch(g,v,C,p){const i=v.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(g,C,o,p):this._doFindNextMatchLineByLine(g,C,o,p)}static _doFindNextMatchMultiline(g,v,C,p){const i=new u.Position(v.lineNumber,1),o=g.getOffsetAt(i),s=g.getLineCount(),l=g.getValueInRange(new A.Range(i.lineNumber,i.column,s,g.getLineMaxColumn(s)),1),r=g.getEOL()===`\r
`?new I(l):null;C.reset(v.column-1);const m=C.next(l);return m?R(this._getMultilineMatchRange(g,o,l,r,m.index,m[0]),m,p):v.lineNumber!==1||v.column!==1?this._doFindNextMatchMultiline(g,new u.Position(1,1),C,p):null}static _doFindNextMatchLineByLine(g,v,C,p){const i=g.getLineCount(),o=v.lineNumber,s=g.getLineContent(o),l=this._findFirstMatchInLine(C,s,o,v.column,p);if(l)return l;for(let r=1;r<=i;r++){const m=(o+r-1)%i,n=g.getLineContent(m+1),t=this._findFirstMatchInLine(C,n,m+1,1,p);if(t)return t}return null}static _findFirstMatchInLine(g,v,C,p,i){g.reset(p-1);const o=g.next(v);return o?R(new A.Range(C,o.index+1,C,o.index+1+o[0].length),o,i):null}static findPreviousMatch(g,v,C,p){const i=v.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(g,C,o,p):this._doFindPreviousMatchLineByLine(g,C,o,p)}static _doFindPreviousMatchMultiline(g,v,C,p){const i=this._doFindMatchesMultiline(g,new A.Range(1,1,v.lineNumber,v.column),C,p,10*T);if(i.length>0)return i[i.length-1];const o=g.getLineCount();return v.lineNumber!==o||v.column!==g.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(g,new u.Position(o,g.getLineMaxColumn(o)),C,p):null}static _doFindPreviousMatchLineByLine(g,v,C,p){const i=g.getLineCount(),o=v.lineNumber,s=g.getLineContent(o).substring(0,v.column-1),l=this._findLastMatchInLine(C,s,o,p);if(l)return l;for(let r=1;r<=i;r++){const m=(i+o-r-1)%i,n=g.getLineContent(m+1),t=this._findLastMatchInLine(C,n,m+1,p);if(t)return t}return null}static _findLastMatchInLine(g,v,C,p){let i=null,o;for(g.reset(0);o=g.next(v);)i=R(new A.Range(C,o.index+1,C,o.index+1+o[0].length),o,p);return i}}e.TextModelSearch=b;function k(h,g,v,C,p){if(C===0)return!0;const i=g.charCodeAt(C-1);if(h.get(i)!==0||i===13||i===10)return!0;if(p>0){const o=g.charCodeAt(C);if(h.get(o)!==0)return!0}return!1}function w(h,g,v,C,p){if(C+p===v)return!0;const i=g.charCodeAt(C+p);if(h.get(i)!==0||i===13||i===10)return!0;if(p>0){const o=g.charCodeAt(C+p-1);if(h.get(o)!==0)return!0}return!1}function f(h,g,v,C,p){return k(h,g,v,C,p)&&w(h,g,v,C,p)}e.isValidMatch=f;class d{constructor(g,v){this._wordSeparators=g,this._searchRegex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(g){this._searchRegex.lastIndex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(g){const v=g.length;let C;do{if(this._prevMatchStartIndex+this._prevMatchLength===v||(C=this._searchRegex.exec(g),!C))return null;const p=C.index,i=C[0].length;if(p===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){a.getNextCodePoint(g,v,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=p,this._prevMatchLength=i,!this._wordSeparators||f(this._wordSeparators,g,v,p,i))return C}while(C);return null}}e.Searcher=d}),define(_e[120],ye([1,0,22,12]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var u;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(u||(u={}));function A(I){for(let b=0,k=I.length;b<k;b+=4){const w=I[b+0],f=I[b+1],d=I[b+2],h=I[b+3];I[b+0]=h,I[b+1]=d,I[b+2]=f,I[b+3]=w}}function _(I){const b=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return P.isLittleEndian()||A(b),a.VSBuffer.wrap(b)}function T(I){const b=I.buffer;if(P.isLittleEndian()||A(b),b.byteOffset%4===0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const k=new Uint8Array(b.byteLength);return k.set(b),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function S(I){const b=new Uint32Array(D(I));let k=0;if(b[k++]=I.id,I.type==="full")b[k++]=1,b[k++]=I.data.length,b.set(I.data,k),k+=I.data.length;else{b[k++]=2,b[k++]=I.deltas.length;for(const w of I.deltas)b[k++]=w.start,b[k++]=w.deleteCount,w.data?(b[k++]=w.data.length,b.set(w.data,k),k+=w.data.length):b[k++]=0}return _(b)}e.encodeSemanticTokensDto=S;function D(I){let b=0;if(b+=1+1,I.type==="full")b+=1+I.data.length;else{b+=1,b+=(1+1+1)*I.deltas.length;for(const k of I.deltas)k.data&&(b+=k.data.length)}return b}function R(I){const b=T(I);let k=0;const w=b[k++];if(b[k++]===1){const g=b[k++],v=b.subarray(k,k+g);return k+=g,{id:w,type:"full",data:v}}const d=b[k++],h=[];for(let g=0;g<d;g++){const v=b[k++],C=b[k++],p=b[k++];let i;p>0&&(i=b.subarray(k,k+p),k+=p),h[g]={start:v,deleteCount:C,data:i}}return{id:w,type:"delta",deltas:h}}e.decodeSemanticTokensDto=R}),define(_e[167],ye([1,0,3,6]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class u{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new a.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this._map.set(T,S),this.fire([T]),(0,P.toDisposable)(()=>{this._map.get(T)===S&&(this._map.delete(T),this.fire([T]))})}registerFactory(T,S){this._factories.get(T)?.dispose();const D=new A(this,T,S);return this._factories.set(T,D),(0,P.toDisposable)(()=>{const R=this._factories.get(T);!R||R!==D||(this._factories.delete(T),R.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const D=this._factories.get(T);return!D||D.isResolved?null:(await D.resolve(),this.get(T))}get(T){return this._map.get(T)||null}isResolved(T){if(this.get(T))return!0;const D=this._factories.get(T);return!!(!D||D.isResolved)}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=u;class A extends P.Disposable{get isResolved(){return this._isResolved}constructor(T,S,D){super(),this._registry=T,this._languageId=S,this._factory=D,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const T=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,T&&!this._isDisposed&&this._register(this._registry.register(this._languageId,T))}}}),define(_e[72],ye([1,0,67,2,32,167]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class _{constructor(c,E,y){this._tokenBrand=void 0,this.offset=c,this.type=E,this.language=y}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=_;class T{constructor(c,E){this._tokenizationResultBrand=void 0,this.tokens=c,this.endState=E}}e.TokenizationResult=T;class S{constructor(c,E){this._encodedTokenizationResultBrand=void 0,this.tokens=c,this.endState=E}}e.EncodedTokenizationResult=S;var D;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(t){const c=new Map;c.set(0,a.Codicon.symbolMethod),c.set(1,a.Codicon.symbolFunction),c.set(2,a.Codicon.symbolConstructor),c.set(3,a.Codicon.symbolField),c.set(4,a.Codicon.symbolVariable),c.set(5,a.Codicon.symbolClass),c.set(6,a.Codicon.symbolStruct),c.set(7,a.Codicon.symbolInterface),c.set(8,a.Codicon.symbolModule),c.set(9,a.Codicon.symbolProperty),c.set(10,a.Codicon.symbolEvent),c.set(11,a.Codicon.symbolOperator),c.set(12,a.Codicon.symbolUnit),c.set(13,a.Codicon.symbolValue),c.set(15,a.Codicon.symbolEnum),c.set(14,a.Codicon.symbolConstant),c.set(15,a.Codicon.symbolEnum),c.set(16,a.Codicon.symbolEnumMember),c.set(17,a.Codicon.symbolKeyword),c.set(27,a.Codicon.symbolSnippet),c.set(18,a.Codicon.symbolText),c.set(19,a.Codicon.symbolColor),c.set(20,a.Codicon.symbolFile),c.set(21,a.Codicon.symbolReference),c.set(22,a.Codicon.symbolCustomColor),c.set(23,a.Codicon.symbolFolder),c.set(24,a.Codicon.symbolTypeParameter),c.set(25,a.Codicon.account),c.set(26,a.Codicon.issues);function E(j){let $=c.get(j);return $||(console.info("No codicon found for CompletionItemKind "+j),$=a.Codicon.symbolProperty),$}t.toIcon=E;const y=new Map;y.set("method",0),y.set("function",1),y.set("constructor",2),y.set("field",3),y.set("variable",4),y.set("class",5),y.set("struct",6),y.set("interface",7),y.set("module",8),y.set("property",9),y.set("event",10),y.set("operator",11),y.set("unit",12),y.set("value",13),y.set("constant",14),y.set("enum",15),y.set("enum-member",16),y.set("enumMember",16),y.set("keyword",17),y.set("snippet",27),y.set("text",18),y.set("color",19),y.set("file",20),y.set("reference",21),y.set("customcolor",22),y.set("folder",23),y.set("type-parameter",24),y.set("typeParameter",24),y.set("account",25),y.set("issue",26);function M(j,$){let N=y.get(j);return typeof N>"u"&&!$&&(N=9),N}t.fromString=M})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(t){t[t.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var k;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(t){return t&&P.URI.isUri(t.uri)&&u.Range.isIRange(t.range)&&(u.Range.isIRange(t.originSelectionRange)||u.Range.isIRange(t.targetSelectionRange))}e.isLocationLink=g;var v;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(v=e.SymbolKind||(e.SymbolKind={}));var C;(function(t){t[t.Deprecated=1]="Deprecated"})(C=e.SymbolTag||(e.SymbolTag={}));var p;(function(t){const c=new Map;c.set(0,a.Codicon.symbolFile),c.set(1,a.Codicon.symbolModule),c.set(2,a.Codicon.symbolNamespace),c.set(3,a.Codicon.symbolPackage),c.set(4,a.Codicon.symbolClass),c.set(5,a.Codicon.symbolMethod),c.set(6,a.Codicon.symbolProperty),c.set(7,a.Codicon.symbolField),c.set(8,a.Codicon.symbolConstructor),c.set(9,a.Codicon.symbolEnum),c.set(10,a.Codicon.symbolInterface),c.set(11,a.Codicon.symbolFunction),c.set(12,a.Codicon.symbolVariable),c.set(13,a.Codicon.symbolConstant),c.set(14,a.Codicon.symbolString),c.set(15,a.Codicon.symbolNumber),c.set(16,a.Codicon.symbolBoolean),c.set(17,a.Codicon.symbolArray),c.set(18,a.Codicon.symbolObject),c.set(19,a.Codicon.symbolKey),c.set(20,a.Codicon.symbolNull),c.set(21,a.Codicon.symbolEnumMember),c.set(22,a.Codicon.symbolStruct),c.set(23,a.Codicon.symbolEvent),c.set(24,a.Codicon.symbolOperator),c.set(25,a.Codicon.symbolTypeParameter);function E(y){let M=c.get(y);return M||(console.info("No codicon found for SymbolKind "+y),M=a.Codicon.symbolProperty),M}t.toIcon=E})(p=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(c){this.value=c}}i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region"),e.FoldingRangeKind=i;var o;(function(t){function c(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}t.is=c})(o=e.Command||(e.Command={}));var s;(function(t){t[t.Collapsed=0]="Collapsed",t[t.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(t){t[t.Unresolved=0]="Unresolved",t[t.Resolved=1]="Resolved"})(l=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(t){t[t.Editing=0]="Editing",t[t.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var m;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var n;(function(t){t[t.None=0]="None",t[t.Option=1]="Option",t[t.Default=2]="Default",t[t.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(_e[168],ye([17,18]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(_e[121],ye([1,0,168,12,106,16,23,151]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(B){this._values=B}hasChanged(B){return this._values[B]}}e.ConfigurationChangedEvent=D;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(B,ue,De,Re){this.id=B,this.name=ue,this.defaultValue=De,this.schema=Re}applyUpdate(B,ue){return k(B,ue)}compute(B,ue,De){return De}}class b{constructor(B,ue){this.newValue=B,this.didChange=ue}}e.ApplyUpdateResult=b;function k(ce,B){if(typeof ce!="object"||typeof B!="object"||!ce||!B)return new b(B,ce!==B);if(Array.isArray(ce)||Array.isArray(B)){const De=Array.isArray(ce)&&Array.isArray(B)&&A.equals(ce,B);return new b(B,!De)}let ue=!1;for(const De in B)if(B.hasOwnProperty(De)){const Re=k(ce[De],B[De]);Re.didChange&&(ce[De]=Re.newValue,ue=!0)}return new b(ce,ue)}class w{constructor(B){this.schema=void 0,this.id=B,this.name="_never_",this.defaultValue=void 0}applyUpdate(B,ue){return k(B,ue)}validate(B){return this.defaultValue}}class f{constructor(B,ue,De,Re){this.id=B,this.name=ue,this.defaultValue=De,this.schema=Re}applyUpdate(B,ue){return k(B,ue)}validate(B){return typeof B>"u"?this.defaultValue:B}compute(B,ue,De){return De}}function d(ce,B){return typeof ce>"u"?B:ce==="false"?!1:Boolean(ce)}e.boolean=d;class h extends f{constructor(B,ue,De,Re=void 0){typeof Re<"u"&&(Re.type="boolean",Re.default=De),super(B,ue,De,Re)}validate(B){return d(B,this.defaultValue)}}function g(ce,B,ue,De){if(typeof ce>"u")return B;let Re=parseInt(ce,10);return isNaN(Re)?B:(Re=Math.max(ue,Re),Re=Math.min(De,Re),Re|0)}e.clampedInt=g;class v extends f{static clampedInt(B,ue,De,Re){return g(B,ue,De,Re)}constructor(B,ue,De,Re,xe,Ge=void 0){typeof Ge<"u"&&(Ge.type="integer",Ge.default=De,Ge.minimum=Re,Ge.maximum=xe),super(B,ue,De,Ge),this.minimum=Re,this.maximum=xe}validate(B){return v.clampedInt(B,this.defaultValue,this.minimum,this.maximum)}}class C extends f{static clamp(B,ue,De){return B<ue?ue:B>De?De:B}static float(B,ue){if(typeof B=="number")return B;if(typeof B>"u")return ue;const De=parseFloat(B);return isNaN(De)?ue:De}constructor(B,ue,De,Re,xe){typeof xe<"u"&&(xe.type="number",xe.default=De),super(B,ue,De,xe),this.validationFn=Re}validate(B){return this.validationFn(C.float(B,this.defaultValue))}}class p extends f{static string(B,ue){return typeof B!="string"?ue:B}constructor(B,ue,De,Re=void 0){typeof Re<"u"&&(Re.type="string",Re.default=De),super(B,ue,De,Re)}validate(B){return p.string(B,this.defaultValue)}}function i(ce,B,ue){return typeof ce!="string"||ue.indexOf(ce)===-1?B:ce}e.stringSet=i;class o extends f{constructor(B,ue,De,Re,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=Re,xe.default=De),super(B,ue,De,xe),this._allowedValues=Re}validate(B){return i(B,this.defaultValue,this._allowedValues)}}class s extends I{constructor(B,ue,De,Re,xe,Ge,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=xe,Ze.default=Re),super(B,ue,De,Ze),this._allowedValues=xe,this._convert=Ge}validate(B){return typeof B!="string"?this.defaultValue:this._allowedValues.indexOf(B)===-1?this.defaultValue:this._convert(B)}}function l(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(B){switch(B){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(B,ue,De){return De===0?B.accessibilitySupport:De}}class m extends I{constructor(){const B={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",B,{"editor.comments.insertSpace":{type:"boolean",default:B.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:B.ignoreEmptyLines,description:a.localize(5,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{insertSpace:d(ue.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ue.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(ce){switch(ce){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function y(ce){switch(ce){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class M extends w{constructor(){super(135)}compute(B,ue,De){const Re=["monaco-editor"];return ue.get(36)&&Re.push(ue.get(36)),B.extraEditorClassName&&Re.push(B.extraEditorClassName),ue.get(70)==="default"?Re.push("mouse-default"):ue.get(70)==="copy"&&Re.push("mouse-copy"),ue.get(105)&&Re.push("showUnused"),ue.get(133)&&Re.push("showDeprecated"),Re.join(" ")}}class j extends h{constructor(){super(34,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(B,ue,De){return De&&B.emptySelectionClipboard}}class $ extends I{constructor(){const B={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",B,{"editor.find.cursorMoveOnType":{type:"boolean",default:B.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:B.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:B.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:B.globalFindClipboard,description:a.localize(16,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:B.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:B.loop,description:a.localize(18,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{cursorMoveOnType:d(ue.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof B.seedSearchStringFromSelection=="boolean"?B.seedSearchStringFromSelection?"always":"never":i(ue.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof B.autoFindInSelection=="boolean"?B.autoFindInSelection?"always":"never":i(ue.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ue.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ue.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ue.loop,this.defaultValue.loop)}}}class N extends I{constructor(){super(48,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(B){return typeof B>"u"?this.defaultValue:typeof B=="string"?B==="false"?N.OFF:B==="true"?N.ON:B:Boolean(B)?N.ON:N.OFF}}N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on',e.EditorFontLigatures=N;class x extends I{constructor(){super(51,"fontVariations",x.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(B){return typeof B>"u"?this.defaultValue:typeof B=="string"?B==="false"?x.OFF:B==="true"?x.TRANSLATE:B:Boolean(B)?x.TRANSLATE:x.OFF}compute(B,ue,De){return B.fontInfo.fontVariationSettings}}x.OFF="normal",x.TRANSLATE="translate",e.EditorFontVariations=x;class L extends w{constructor(){super(47)}compute(B,ue,De){return B.fontInfo}}class F extends f{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(B){const ue=C.float(B,this.defaultValue);return ue===0?e.EDITOR_FONT_DEFAULTS.fontSize:C.clamp(ue,6,100)}compute(B,ue,De){return B.fontInfo.fontSize}}class U extends I{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(B){return B==="normal"||B==="bold"?B:String(v.clampedInt(B,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class H extends I{constructor(){const B={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ue={type:"string",enum:["peek","gotoAndPeek","goto"],default:B.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},De=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",B,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...ue},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...ue},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...ue},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...ue},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...ue},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:B.alternativeDefinitionCommand,enum:De,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:B.alternativeTypeDefinitionCommand,enum:De,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:B.alternativeDeclarationCommand,enum:De,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:B.alternativeImplementationCommand,enum:De,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:B.alternativeReferenceCommand,enum:De,description:a.localize(41,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{multiple:i(ue.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ue.multipleDefinitions??i(ue.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ue.multipleTypeDefinitions??i(ue.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ue.multipleDeclarations??i(ue.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ue.multipleImplementations??i(ue.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ue.multipleReferences??i(ue.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ue.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ue.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ue.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ue.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ue.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends I{constructor(){const B={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",B,{"editor.hover.enabled":{type:"boolean",default:B.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:B.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:B.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:B.above,description:a.localize(45,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{enabled:d(ue.enabled,this.defaultValue.enabled),delay:v.clampedInt(ue.delay,this.defaultValue.delay,0,1e4),sticky:d(ue.sticky,this.defaultValue.sticky),above:d(ue.above,this.defaultValue.above)}}}var Y;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(Y=e.RenderMinimap||(e.RenderMinimap={}));class V extends w{constructor(){super(138)}compute(B,ue,De){return V.computeLayout(ue,{memory:B.memory,outerWidth:B.outerWidth,outerHeight:B.outerHeight,isDominatedByLongLines:B.isDominatedByLongLines,lineHeight:B.fontInfo.lineHeight,viewLineCount:B.viewLineCount,lineNumbersDigitCount:B.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:B.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:B.fontInfo.maxDigitWidth,pixelRatio:B.pixelRatio})}static computeContainedMinimapLineCount(B){const ue=B.height/B.lineHeight,De=Math.floor(B.paddingTop/B.lineHeight);let Re=Math.floor(B.paddingBottom/B.lineHeight);B.scrollBeyondLastLine&&(Re=Math.max(Re,ue-1));const xe=(De+B.viewLineCount+Re)/(B.pixelRatio*B.height),Ge=Math.floor(B.viewLineCount/xe);return{typicalViewportLineCount:ue,extraLinesBeforeFirstLine:De,extraLinesBeyondLastLine:Re,desiredRatio:xe,minimapLineCount:Ge}}static _computeMinimapLayout(B,ue){const De=B.outerWidth,Re=B.outerHeight,xe=B.pixelRatio;if(!B.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Re),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Re};const Ge=ue.stableMinimapLayoutInput,Ze=Ge&&B.outerHeight===Ge.outerHeight&&B.lineHeight===Ge.lineHeight&&B.typicalHalfwidthCharacterWidth===Ge.typicalHalfwidthCharacterWidth&&B.pixelRatio===Ge.pixelRatio&&B.scrollBeyondLastLine===Ge.scrollBeyondLastLine&&B.paddingTop===Ge.paddingTop&&B.paddingBottom===Ge.paddingBottom&&B.minimap.enabled===Ge.minimap.enabled&&B.minimap.side===Ge.minimap.side&&B.minimap.size===Ge.minimap.size&&B.minimap.showSlider===Ge.minimap.showSlider&&B.minimap.renderCharacters===Ge.minimap.renderCharacters&&B.minimap.maxColumn===Ge.minimap.maxColumn&&B.minimap.scale===Ge.minimap.scale&&B.verticalScrollbarWidth===Ge.verticalScrollbarWidth&&B.isViewportWrapping===Ge.isViewportWrapping,pt=B.lineHeight,gt=B.typicalHalfwidthCharacterWidth,ct=B.scrollBeyondLastLine,wt=B.minimap.renderCharacters;let tt=xe>=2?Math.round(B.minimap.scale*2):B.minimap.scale;const ft=B.minimap.maxColumn,Pt=B.minimap.size,Gt=B.minimap.side,At=B.verticalScrollbarWidth,mt=B.viewLineCount,kt=B.remainingWidth,xt=B.isViewportWrapping,Ot=wt?2:3;let Ke=Math.floor(xe*Re);const Nt=Ke/xe;let Ft=!1,Wt=!1,vt=Ot*tt,Ae=tt/xe,Oe=1;if(Pt==="fill"||Pt==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:lt,extraLinesBeyondLastLine:Tt,desiredRatio:St,minimapLineCount:_t}=V.computeContainedMinimapLineCount({viewLineCount:mt,scrollBeyondLastLine:ct,paddingTop:B.paddingTop,paddingBottom:B.paddingBottom,height:Re,lineHeight:pt,pixelRatio:xe});if(mt/_t>1)Ft=!0,Wt=!0,tt=1,vt=1,Ae=tt/xe;else{let yt=!1,Ct=tt+1;if(Pt==="fit"){const Vt=Math.ceil((lt+mt+Tt)*vt);xt&&Ze&&kt<=ue.stableFitRemainingWidth?(yt=!0,Ct=ue.stableFitMaxMinimapScale):yt=Vt>Ke}if(Pt==="fill"||yt){Ft=!0;const Vt=tt;vt=Math.min(pt*xe,Math.max(1,Math.floor(1/St))),xt&&Ze&&kt<=ue.stableFitRemainingWidth&&(Ct=ue.stableFitMaxMinimapScale),tt=Math.min(Ct,Math.max(1,Math.floor(vt/Ot))),tt>Vt&&(Oe=Math.min(2,tt/Vt)),Ae=tt/xe/Oe,Ke=Math.ceil(Math.max(it,lt+mt+Tt)*vt),xt?(ue.stableMinimapLayoutInput=B,ue.stableFitRemainingWidth=kt,ue.stableFitMaxMinimapScale=tt):(ue.stableMinimapLayoutInput=null,ue.stableFitRemainingWidth=0)}}}const Se=Math.floor(ft*Ae),se=Math.min(Se,Math.max(0,Math.floor((kt-At-2)*Ae/(gt+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Me=Math.floor(xe*se);const ze=Me/xe;Me=Math.floor(Me*Oe);const Qe=wt?1:2,He=Gt==="left"?0:De-se-At;return{renderMinimap:Qe,minimapLeft:He,minimapWidth:se,minimapHeightIsEditorHeight:Ft,minimapIsSampling:Wt,minimapScale:tt,minimapLineHeight:vt,minimapCanvasInnerWidth:Me,minimapCanvasInnerHeight:Ke,minimapCanvasOuterWidth:ze,minimapCanvasOuterHeight:Nt}}static computeLayout(B,ue){const De=ue.outerWidth|0,Re=ue.outerHeight|0,xe=ue.lineHeight|0,Ge=ue.lineNumbersDigitCount|0,Ze=ue.typicalHalfwidthCharacterWidth,pt=ue.maxDigitWidth,gt=ue.pixelRatio,ct=ue.viewLineCount,wt=B.get(130),tt=wt==="inherit"?B.get(129):wt,ft=tt==="inherit"?B.get(125):tt,Pt=B.get(128),Gt=ue.isDominatedByLongLines,At=B.get(54),mt=B.get(64).renderType!==0,kt=B.get(65),xt=B.get(99),Ot=B.get(80),Ke=B.get(69),Nt=B.get(97),Ft=Nt.verticalScrollbarSize,Wt=Nt.verticalHasArrows,vt=Nt.arrowSize,Ae=Nt.horizontalScrollbarSize,Oe=B.get(40),Se=B.get(104)!=="never";let se=B.get(62);Oe&&Se&&(se+=16);let Me=0;if(mt){const Et=Math.max(Ge,kt);Me=Math.round(Et*pt)}let ze=0;At&&(ze=xe);let Qe=0,He=Qe+ze,it=He+Me,lt=it+se;const Tt=De-ze-Me-se;let St=!1,_t=!1,It=-1;tt==="inherit"&&Gt?(St=!0,_t=!0):ft==="on"||ft==="bounded"?_t=!0:ft==="wordWrapColumn"&&(It=Pt);const yt=V._computeMinimapLayout({outerWidth:De,outerHeight:Re,lineHeight:xe,typicalHalfwidthCharacterWidth:Ze,pixelRatio:gt,scrollBeyondLastLine:xt,paddingTop:Ot.top,paddingBottom:Ot.bottom,minimap:Ke,verticalScrollbarWidth:Ft,viewLineCount:ct,remainingWidth:Tt,isViewportWrapping:_t},ue.memory||new R);yt.renderMinimap!==0&&yt.minimapLeft===0&&(Qe+=yt.minimapWidth,He+=yt.minimapWidth,it+=yt.minimapWidth,lt+=yt.minimapWidth);const Ct=Tt-yt.minimapWidth,Vt=Math.max(1,Math.floor((Ct-Ft-2)/Ze)),Jt=Wt?vt:0;return _t&&(It=Math.max(1,Vt),ft==="bounded"&&(It=Math.min(It,Pt))),{width:De,height:Re,glyphMarginLeft:Qe,glyphMarginWidth:ze,lineNumbersLeft:He,lineNumbersWidth:Me,decorationsLeft:it,decorationsWidth:se,contentLeft:lt,contentWidth:Ct,minimap:yt,viewportColumn:Vt,isWordWrapMinified:St,isViewportWrapping:_t,wrappingColumn:It,verticalScrollbarWidth:Ft,horizontalScrollbarHeight:Ae,overviewRuler:{top:Jt,width:Ft,height:Re-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=V;class X extends I{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(B){return i(B,"simple",["simple","advanced"])}compute(B,ue,De){return ue.get(2)===2?"advanced":De}}class Z extends I{constructor(){const B={enabled:!0};super(61,"lightbulb",B,{"editor.lightbulb.enabled":{type:"boolean",default:B.enabled,description:a.localize(49,null)}})}validate(B){return!B||typeof B!="object"?this.defaultValue:{enabled:d(B.enabled,this.defaultValue.enabled)}}}class te extends I{constructor(){const B={enabled:!1,maxLineCount:5};super(109,"stickyScroll",B,{"editor.stickyScroll.enabled":{type:"boolean",default:B.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:B.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{enabled:d(ue.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(ue.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class K extends I{constructor(){const B={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",B,{"editor.inlayHints.enabled":{type:"string",default:B.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:B.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:B.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:B.padding,description:a.localize(59,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return typeof ue.enabled=="boolean"&&(ue.enabled=ue.enabled?"on":"off"),{enabled:i(ue.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(ue.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ue.fontFamily,this.defaultValue.fontFamily),padding:d(ue.padding,this.defaultValue.padding)}}}class J extends I{constructor(){super(62,"lineDecorationsWidth",10)}validate(B){return typeof B=="string"&&/^\d+(\.\d+)?ch$/.test(B)?-parseFloat(B.substring(0,B.length-2)):v.clampedInt(B,this.defaultValue,0,1e3)}compute(B,ue,De){return De<0?v.clampedInt(-De*B.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):De}}class ne extends C{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,B=>C.clamp(B,0,150),{markdownDescription:a.localize(60,null)})}compute(B,ue,De){return B.fontInfo.lineHeight}}class pe extends I{constructor(){const B={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",B,{"editor.minimap.enabled":{type:"boolean",default:B.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:B.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:B.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:B.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:B.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:B.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:B.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:B.maxColumn,description:a.localize(71,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{enabled:d(ue.enabled,this.defaultValue.enabled),autohide:d(ue.autohide,this.defaultValue.autohide),size:i(ue.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(ue.side,this.defaultValue.side,["right","left"]),showSlider:i(ue.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ue.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(ue.scale,1,1,3),maxColumn:v.clampedInt(ue.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(ce){return ce==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ie extends I{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{top:v.clampedInt(ue.top,0,0,1e3),bottom:v.clampedInt(ue.bottom,0,0,1e3)}}}class Le extends I{constructor(){const B={enabled:!0,cycle:!0};super(81,"parameterHints",B,{"editor.parameterHints.enabled":{type:"boolean",default:B.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:B.cycle,description:a.localize(75,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{enabled:d(ue.enabled,this.defaultValue.enabled),cycle:d(ue.cycle,this.defaultValue.cycle)}}}class oe extends w{constructor(){super(136)}compute(B,ue,De){return B.pixelRatio}}class ae extends I{constructor(){const B={other:"on",comments:"off",strings:"off"},ue=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(84,"quickSuggestions",B,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ue,default:B.strings,description:a.localize(79,null)},comments:{anyOf:ue,default:B.comments,description:a.localize(80,null)},other:{anyOf:ue,default:B.other,description:a.localize(81,null)}},default:B,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=B}validate(B){if(typeof B=="boolean"){const gt=B?"on":"off";return{comments:gt,strings:gt,other:gt}}if(!B||typeof B!="object")return this.defaultValue;const{other:ue,comments:De,strings:Re}=B,xe=["on","inline","off"];let Ge,Ze,pt;return typeof ue=="boolean"?Ge=ue?"on":"off":Ge=i(ue,this.defaultValue.other,xe),typeof De=="boolean"?Ze=De?"on":"off":Ze=i(De,this.defaultValue.comments,xe),typeof Re=="boolean"?pt=Re?"on":"off":pt=i(Re,this.defaultValue.strings,xe),{other:Ge,comments:Ze,strings:pt}}}var fe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends I{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate(B){let ue=this.defaultValue.renderType,De=this.defaultValue.renderFn;return typeof B<"u"&&(typeof B=="function"?(ue=4,De=B):B==="interval"?ue=3:B==="relative"?ue=2:B==="on"?ue=1:ue=0),{renderType:ue,renderFn:De}}}function le(ce){const B=ce.get(92);return B==="editable"?ce.get(86):B!=="on"}e.filterValidationDecorations=le;class re extends I{constructor(){const B=[],ue={type:"number",description:a.localize(88,null)};super(96,"rulers",B,{type:"array",items:{anyOf:[ue,{type:["object"],properties:{column:ue,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:B,description:a.localize(90,null)})}validate(B){if(Array.isArray(B)){const ue=[];for(const De of B)if(typeof De=="number")ue.push({column:v.clampedInt(De,0,0,1e4),color:null});else if(De&&typeof De=="object"){const Re=De;ue.push({column:v.clampedInt(Re.column,0,0,1e4),color:Re.color})}return ue.sort((De,Re)=>De.column-Re.column),ue}return this.defaultValue}}function O(ce,B){if(typeof ce!="string")return B;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends I{constructor(){const B={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",B,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:B.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:B.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:B.scrollByPage,description:a.localize(101,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B,De=v.clampedInt(ue.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Re=v.clampedInt(ue.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(ue.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ue.vertical,this.defaultValue.vertical),horizontal:O(ue.horizontal,this.defaultValue.horizontal),useShadows:d(ue.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ue.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ue.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ue.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ue.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:De,horizontalSliderSize:v.clampedInt(ue.horizontalSliderSize,De,0,1e3),verticalScrollbarSize:Re,verticalSliderSize:v.clampedInt(ue.verticalSliderSize,Re,0,1e3),scrollByPage:d(ue.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends I{constructor(){const B={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",B,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:B.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:B.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:B.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:B.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:B.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:B.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:B.allowedLocales,description:a.localize(108,null)}})}applyUpdate(B,ue){let De=!1;ue.allowedCharacters&&B&&(_.equals(B.allowedCharacters,ue.allowedCharacters)||(B={...B,allowedCharacters:ue.allowedCharacters},De=!0)),ue.allowedLocales&&B&&(_.equals(B.allowedLocales,ue.allowedLocales)||(B={...B,allowedLocales:ue.allowedLocales},De=!0));const Re=super.applyUpdate(B,ue);return De?new b(Re.newValue,!0):Re}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{nonBasicASCII:Pe(ue.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(ue.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(ue.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(ue.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(ue.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(B.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(B.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(B,ue){if(typeof B!="object"||!B)return ue;const De={};for(const[Re,xe]of Object.entries(B))xe===!0&&(De[Re]=!0);return De}}class Q extends I{constructor(){const B={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",B,{"editor.inlineSuggest.enabled":{type:"boolean",default:B.enabled,description:a.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:B.showToolbar,enum:["always","onHover"],enumDescriptions:[a.localize(110,null),a.localize(111,null)],description:a.localize(112,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{enabled:d(ue.enabled,this.defaultValue.enabled),mode:i(ue.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(ue.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class he extends I{constructor(){const B={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",B,{"editor.bracketPairColorization.enabled":{type:"boolean",default:B.enabled,markdownDescription:a.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:B.independentColorPoolPerBracketType,description:a.localize(114,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{enabled:d(ue.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(ue.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ee extends I{constructor(){const B={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",B,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(115,null),a.localize(116,null),a.localize(117,null)],default:B.bracketPairs,description:a.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(119,null),a.localize(120,null),a.localize(121,null)],default:B.bracketPairsHorizontal,description:a.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:B.highlightActiveBracketPair,description:a.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:B.indentation,description:a.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(125,null),a.localize(126,null),a.localize(127,null)],default:B.highlightActiveIndentation,description:a.localize(128,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{bracketPairs:Pe(ue.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(ue.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(ue.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(ue.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(ue.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe(ce,B,ue){const De=ue.indexOf(ce);return De===-1?B:ue[De]}class ve extends I{constructor(){const B={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",B,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(129,null),a.localize(130,null)],default:B.insertMode,description:a.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:B.filterGraceful,description:a.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:B.localityBonus,description:a.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:B.shareSuggestSelections,markdownDescription:a.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(135,null),a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:B.selectionMode,markdownDescription:a.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:B.snippetsPreventQuickSuggestions,description:a.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:B.showIcons,description:a.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:B.showStatusBar,description:a.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:B.preview,description:a.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:B.showInlineDetails,description:a.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)}})}validate(B){if(!B||typeof B!="object")return this.defaultValue;const ue=B;return{insertMode:i(ue.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ue.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ue.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ue.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ue.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(ue.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(ue.showIcons,this.defaultValue.showIcons),showStatusBar:d(ue.showStatusBar,this.defaultValue.showStatusBar),preview:d(ue.preview,this.defaultValue.preview),previewMode:i(ue.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(ue.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ue.showMethods,this.defaultValue.showMethods),showFunctions:d(ue.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ue.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ue.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(ue.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(ue.showFields,this.defaultValue.showFields),showVariables:d(ue.showVariables,this.defaultValue.showVariables),showClasses:d(ue.showClasses,this.defaultValue.showClasses),showStructs:d(ue.showStructs,this.defaultValue.showStructs),showInterfaces:d(ue.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ue.showModules,this.defaultValue.showModules),showProperties:d(ue.showProperties,this.defaultValue.showProperties),showEvents:d(ue.showEvents,this.defaultValue.showEvents),showOperators:d(ue.showOperators,this.defaultValue.showOperators),showUnits:d(ue.showUnits,this.defaultValue.showUnits),showValues:d(ue.showValues,this.defaultValue.showValues),showConstants:d(ue.showConstants,this.defaultValue.showConstants),showEnums:d(ue.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ue.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ue.showKeywords,this.defaultValue.showKeywords),showWords:d(ue.showWords,this.defaultValue.showWords),showColors:d(ue.showColors,this.defaultValue.showColors),showFiles:d(ue.showFiles,this.defaultValue.showFiles),showReferences:d(ue.showReferences,this.defaultValue.showReferences),showFolders:d(ue.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ue.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ue.showSnippets,this.defaultValue.showSnippets),showUsers:d(ue.showUsers,this.defaultValue.showUsers),showIssues:d(ue.showIssues,this.defaultValue.showIssues)}}}class Ce extends I{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(177,null),default:!0,type:"boolean"}})}validate(B){return!B||typeof B!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(B.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends w{constructor(){super(137)}compute(B,ue,De){return ue.get(86)?!0:B.tabFocusMode}}var $e;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})($e=e.WrappingIndent||(e.WrappingIndent={}));class je extends I{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(178,null),a.localize(179,null),a.localize(180,null),a.localize(181,null)],description:a.localize(182,null),default:"same"}})}validate(B){switch(B){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(B,ue,De){return ue.get(2)===2?0:De}}class et extends w{constructor(){super(139)}compute(B,ue,De){const Re=ue.get(138);return{isDominatedByLongLines:B.isDominatedByLongLines,isWordWrapMinified:Re.isWordWrapMinified,isViewportWrapping:Re.isViewportWrapping,wrappingColumn:Re.wrappingColumn}}}class Xe extends I{constructor(){const B={enabled:!0};super(33,"dropIntoEditor",B,{"editor.dropIntoEditor.enabled":{type:"boolean",default:B.enabled,markdownDescription:a.localize(183,null)}})}validate(B){return!B||typeof B!="object"?this.defaultValue:{enabled:d(B.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?st:P.isLinux?ht:nt,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var rt;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.autoClosingBrackets=5]="autoClosingBrackets",ce[ce.autoClosingDelete=6]="autoClosingDelete",ce[ce.autoClosingOvertype=7]="autoClosingOvertype",ce[ce.autoClosingQuotes=8]="autoClosingQuotes",ce[ce.autoIndent=9]="autoIndent",ce[ce.automaticLayout=10]="automaticLayout",ce[ce.autoSurround=11]="autoSurround",ce[ce.bracketPairColorization=12]="bracketPairColorization",ce[ce.guides=13]="guides",ce[ce.codeLens=14]="codeLens",ce[ce.codeLensFontFamily=15]="codeLensFontFamily",ce[ce.codeLensFontSize=16]="codeLensFontSize",ce[ce.colorDecorators=17]="colorDecorators",ce[ce.colorDecoratorsLimit=18]="colorDecoratorsLimit",ce[ce.columnSelection=19]="columnSelection",ce[ce.comments=20]="comments",ce[ce.contextmenu=21]="contextmenu",ce[ce.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=23]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=25]="cursorStyle",ce[ce.cursorSurroundingLines=26]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=28]="cursorWidth",ce[ce.disableLayerHinting=29]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",ce[ce.domReadOnly=31]="domReadOnly",ce[ce.dragAndDrop=32]="dragAndDrop",ce[ce.dropIntoEditor=33]="dropIntoEditor",ce[ce.emptySelectionClipboard=34]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=36]="extraEditorClassName",ce[ce.fastScrollSensitivity=37]="fastScrollSensitivity",ce[ce.find=38]="find",ce[ce.fixedOverflowWidgets=39]="fixedOverflowWidgets",ce[ce.folding=40]="folding",ce[ce.foldingStrategy=41]="foldingStrategy",ce[ce.foldingHighlight=42]="foldingHighlight",ce[ce.foldingImportsByDefault=43]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=44]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=46]="fontFamily",ce[ce.fontInfo=47]="fontInfo",ce[ce.fontLigatures=48]="fontLigatures",ce[ce.fontSize=49]="fontSize",ce[ce.fontWeight=50]="fontWeight",ce[ce.fontVariations=51]="fontVariations",ce[ce.formatOnPaste=52]="formatOnPaste",ce[ce.formatOnType=53]="formatOnType",ce[ce.glyphMargin=54]="glyphMargin",ce[ce.gotoLocation=55]="gotoLocation",ce[ce.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",ce[ce.hover=57]="hover",ce[ce.inDiffEditor=58]="inDiffEditor",ce[ce.inlineSuggest=59]="inlineSuggest",ce[ce.letterSpacing=60]="letterSpacing",ce[ce.lightbulb=61]="lightbulb",ce[ce.lineDecorationsWidth=62]="lineDecorationsWidth",ce[ce.lineHeight=63]="lineHeight",ce[ce.lineNumbers=64]="lineNumbers",ce[ce.lineNumbersMinChars=65]="lineNumbersMinChars",ce[ce.linkedEditing=66]="linkedEditing",ce[ce.links=67]="links",ce[ce.matchBrackets=68]="matchBrackets",ce[ce.minimap=69]="minimap",ce[ce.mouseStyle=70]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=72]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=74]="multiCursorModifier",ce[ce.multiCursorPaste=75]="multiCursorPaste",ce[ce.multiCursorLimit=76]="multiCursorLimit",ce[ce.occurrencesHighlight=77]="occurrencesHighlight",ce[ce.overviewRulerBorder=78]="overviewRulerBorder",ce[ce.overviewRulerLanes=79]="overviewRulerLanes",ce[ce.padding=80]="padding",ce[ce.parameterHints=81]="parameterHints",ce[ce.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=84]="quickSuggestions",ce[ce.quickSuggestionsDelay=85]="quickSuggestionsDelay",ce[ce.readOnly=86]="readOnly",ce[ce.renameOnType=87]="renameOnType",ce[ce.renderControlCharacters=88]="renderControlCharacters",ce[ce.renderFinalNewline=89]="renderFinalNewline",ce[ce.renderLineHighlight=90]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=92]="renderValidationDecorations",ce[ce.renderWhitespace=93]="renderWhitespace",ce[ce.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",ce[ce.roundedSelection=95]="roundedSelection",ce[ce.rulers=96]="rulers",ce[ce.scrollbar=97]="scrollbar",ce[ce.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=99]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=100]="scrollPredominantAxis",ce[ce.selectionClipboard=101]="selectionClipboard",ce[ce.selectionHighlight=102]="selectionHighlight",ce[ce.selectOnLineNumbers=103]="selectOnLineNumbers",ce[ce.showFoldingControls=104]="showFoldingControls",ce[ce.showUnused=105]="showUnused",ce[ce.snippetSuggestions=106]="snippetSuggestions",ce[ce.smartSelect=107]="smartSelect",ce[ce.smoothScrolling=108]="smoothScrolling",ce[ce.stickyScroll=109]="stickyScroll",ce[ce.stickyTabStops=110]="stickyTabStops",ce[ce.stopRenderingLineAfter=111]="stopRenderingLineAfter",ce[ce.suggest=112]="suggest",ce[ce.suggestFontSize=113]="suggestFontSize",ce[ce.suggestLineHeight=114]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",ce[ce.suggestSelection=116]="suggestSelection",ce[ce.tabCompletion=117]="tabCompletion",ce[ce.tabIndex=118]="tabIndex",ce[ce.unicodeHighlighting=119]="unicodeHighlighting",ce[ce.unusualLineTerminators=120]="unusualLineTerminators",ce[ce.useShadowDOM=121]="useShadowDOM",ce[ce.useTabStops=122]="useTabStops",ce[ce.wordBreak=123]="wordBreak",ce[ce.wordSeparators=124]="wordSeparators",ce[ce.wordWrap=125]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=128]="wordWrapColumn",ce[ce.wordWrapOverride1=129]="wordWrapOverride1",ce[ce.wordWrapOverride2=130]="wordWrapOverride2",ce[ce.wrappingIndent=131]="wrappingIndent",ce[ce.wrappingStrategy=132]="wrappingStrategy",ce[ce.showDeprecated=133]="showDeprecated",ce[ce.inlayHints=134]="inlayHints",ce[ce.editorClassName=135]="editorClassName",ce[ce.pixelRatio=136]="pixelRatio",ce[ce.tabFocusMode=137]="tabFocusMode",ce[ce.layoutInfo=138]="layoutInfo",ce[ce.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(184,null)})),acceptSuggestionOnEnter:Fe(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(185,null),""],markdownDescription:a.localize(186,null)})),accessibilitySupport:Fe(new r),accessibilityPageSize:Fe(new v(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(187,null),tags:["accessibility"]})),ariaLabel:Fe(new p(4,"ariaLabel",a.localize(188,null))),autoClosingBrackets:Fe(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(189,null),a.localize(190,null),""],description:a.localize(191,null)})),autoClosingDelete:Fe(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(192,null),""],description:a.localize(193,null)})),autoClosingOvertype:Fe(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(194,null),""],description:a.localize(195,null)})),autoClosingQuotes:Fe(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(196,null),a.localize(197,null),""],description:a.localize(198,null)})),autoIndent:Fe(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[a.localize(199,null),a.localize(200,null),a.localize(201,null),a.localize(202,null),a.localize(203,null)],description:a.localize(204,null)})),automaticLayout:Fe(new h(10,"automaticLayout",!1)),autoSurround:Fe(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(205,null),a.localize(206,null),a.localize(207,null),""],description:a.localize(208,null)})),bracketPairColorization:Fe(new he),bracketPairGuides:Fe(new Ee),stickyTabStops:Fe(new h(110,"stickyTabStops",!1,{description:a.localize(209,null)})),codeLens:Fe(new h(14,"codeLens",!0,{description:a.localize(210,null)})),codeLensFontFamily:Fe(new p(15,"codeLensFontFamily","",{description:a.localize(211,null)})),codeLensFontSize:Fe(new v(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(212,null)})),colorDecorators:Fe(new h(17,"colorDecorators",!0,{description:a.localize(213,null)})),colorDecoratorsLimit:Fe(new v(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(214,null)})),columnSelection:Fe(new h(19,"columnSelection",!1,{description:a.localize(215,null)})),comments:Fe(new m),contextmenu:Fe(new h(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new h(22,"copyWithSyntaxHighlighting",!0,{description:a.localize(216,null)})),cursorBlinking:Fe(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:a.localize(217,null)})),cursorSmoothCaretAnimation:Fe(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(218,null),a.localize(219,null),a.localize(220,null)],description:a.localize(221,null)})),cursorStyle:Fe(new s(25,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],y,{description:a.localize(222,null)})),cursorSurroundingLines:Fe(new v(26,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(223,null)})),cursorSurroundingLinesStyle:Fe(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(224,null),a.localize(225,null)],description:a.localize(226,null)})),cursorWidth:Fe(new v(28,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(227,null)})),disableLayerHinting:Fe(new h(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new h(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new h(31,"domReadOnly",!1)),dragAndDrop:Fe(new h(32,"dragAndDrop",!0,{description:a.localize(228,null)})),emptySelectionClipboard:Fe(new j),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new te),experimentalWhitespaceRendering:Fe(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(229,null),a.localize(230,null),a.localize(231,null)],description:a.localize(232,null)})),extraEditorClassName:Fe(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new C(37,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:a.localize(233,null)})),find:Fe(new $),fixedOverflowWidgets:Fe(new h(39,"fixedOverflowWidgets",!1)),folding:Fe(new h(40,"folding",!0,{description:a.localize(234,null)})),foldingStrategy:Fe(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(235,null),a.localize(236,null)],description:a.localize(237,null)})),foldingHighlight:Fe(new h(42,"foldingHighlight",!0,{description:a.localize(238,null)})),foldingImportsByDefault:Fe(new h(43,"foldingImportsByDefault",!1,{description:a.localize(239,null)})),foldingMaximumRegions:Fe(new v(44,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(240,null)})),unfoldOnClickAfterEndOfLine:Fe(new h(45,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(241,null)})),fontFamily:Fe(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(242,null)})),fontInfo:Fe(new L),fontLigatures2:Fe(new N),fontSize:Fe(new F),fontWeight:Fe(new U),fontVariations:Fe(new x),formatOnPaste:Fe(new h(52,"formatOnPaste",!1,{description:a.localize(243,null)})),formatOnType:Fe(new h(53,"formatOnType",!1,{description:a.localize(244,null)})),glyphMargin:Fe(new h(54,"glyphMargin",!0,{description:a.localize(245,null)})),gotoLocation:Fe(new H),hideCursorInOverviewRuler:Fe(new h(56,"hideCursorInOverviewRuler",!1,{description:a.localize(246,null)})),hover:Fe(new de),inDiffEditor:Fe(new h(58,"inDiffEditor",!1)),letterSpacing:Fe(new C(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>C.clamp(ce,-5,20),{description:a.localize(247,null)})),lightbulb:Fe(new Z),lineDecorationsWidth:Fe(new J),lineHeight:Fe(new ne),lineNumbers:Fe(new ee),lineNumbersMinChars:Fe(new v(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new h(66,"linkedEditing",!1,{description:a.localize(248,null)})),links:Fe(new h(67,"links",!0,{description:a.localize(249,null)})),matchBrackets:Fe(new o(68,"matchBrackets","always",["always","near","never"],{description:a.localize(250,null)})),minimap:Fe(new pe),mouseStyle:Fe(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new C(71,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:a.localize(251,null)})),mouseWheelZoom:Fe(new h(72,"mouseWheelZoom",!1,{markdownDescription:a.localize(252,null)})),multiCursorMergeOverlapping:Fe(new h(73,"multiCursorMergeOverlapping",!0,{description:a.localize(253,null)})),multiCursorModifier:Fe(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[a.localize(254,null),a.localize(255,null)],markdownDescription:a.localize(256,null)})),multiCursorPaste:Fe(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(257,null),a.localize(258,null)],markdownDescription:a.localize(259,null)})),multiCursorLimit:Fe(new v(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(260,null)})),occurrencesHighlight:Fe(new h(77,"occurrencesHighlight",!0,{description:a.localize(261,null)})),overviewRulerBorder:Fe(new h(78,"overviewRulerBorder",!0,{description:a.localize(262,null)})),overviewRulerLanes:Fe(new v(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Ie),parameterHints:Fe(new Le),peekWidgetDefaultFocus:Fe(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],description:a.localize(265,null)})),definitionLinkOpensInPeek:Fe(new h(83,"definitionLinkOpensInPeek",!1,{description:a.localize(266,null)})),quickSuggestions:Fe(new ae),quickSuggestionsDelay:Fe(new v(85,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(267,null)})),readOnly:Fe(new h(86,"readOnly",!1)),renameOnType:Fe(new h(87,"renameOnType",!1,{description:a.localize(268,null),markdownDeprecationMessage:a.localize(269,null)})),renderControlCharacters:Fe(new h(88,"renderControlCharacters",!0,{description:a.localize(270,null),restricted:!0})),renderFinalNewline:Fe(new o(89,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(271,null)})),renderLineHighlight:Fe(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(272,null)],description:a.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Fe(new h(91,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(274,null)})),renderValidationDecorations:Fe(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(275,null),a.localize(276,null),a.localize(277,null),""],description:a.localize(278,null)})),revealHorizontalRightPadding:Fe(new v(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new h(95,"roundedSelection",!0,{description:a.localize(279,null)})),rulers:Fe(new re),scrollbar:Fe(new W),scrollBeyondLastColumn:Fe(new v(98,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(280,null)})),scrollBeyondLastLine:Fe(new h(99,"scrollBeyondLastLine",!0,{description:a.localize(281,null)})),scrollPredominantAxis:Fe(new h(100,"scrollPredominantAxis",!0,{description:a.localize(282,null)})),selectionClipboard:Fe(new h(101,"selectionClipboard",!0,{description:a.localize(283,null),included:P.isLinux})),selectionHighlight:Fe(new h(102,"selectionHighlight",!0,{description:a.localize(284,null)})),selectOnLineNumbers:Fe(new h(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(285,null),a.localize(286,null),a.localize(287,null)],description:a.localize(288,null)})),showUnused:Fe(new h(105,"showUnused",!0,{description:a.localize(289,null)})),showDeprecated:Fe(new h(133,"showDeprecated",!0,{description:a.localize(290,null)})),inlayHints:Fe(new K),snippetSuggestions:Fe(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(291,null),a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),smartSelect:Fe(new Ce),smoothScrolling:Fe(new h(108,"smoothScrolling",!1,{description:a.localize(296,null)})),stopRenderingLineAfter:Fe(new v(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ve),inlineSuggest:Fe(new Q),suggestFontSize:Fe(new v(113,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new v(114,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new h(115,"suggestOnTriggerCharacters",!0,{description:a.localize(299,null)})),suggestSelection:Fe(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(300,null),a.localize(301,null),a.localize(302,null)],description:a.localize(303,null)})),tabCompletion:Fe(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(304,null),a.localize(305,null),a.localize(306,null)],description:a.localize(307,null)})),tabIndex:Fe(new v(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new G),unusualLineTerminators:Fe(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(308,null),a.localize(309,null),a.localize(310,null)],description:a.localize(311,null)})),useShadowDOM:Fe(new h(121,"useShadowDOM",!0)),useTabStops:Fe(new h(122,"useTabStops",!0,{description:a.localize(312,null)})),wordBreak:Fe(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(313,null),a.localize(314,null)],description:a.localize(315,null)})),wordSeparators:Fe(new p(124,"wordSeparators",u.USUAL_WORD_SEPARATORS,{description:a.localize(316,null)})),wordWrap:Fe(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(317,null),a.localize(318,null),a.localize(319,null),a.localize(320,null)],description:a.localize(321,null)})),wordWrapBreakAfterCharacters:Fe(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new v(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(322,null)})),wordWrapOverride1:Fe(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new M),pixelRatio:Fe(new oe),tabFocusMode:Fe(new ke),layoutInfo:Fe(new V),wrappingInfo:Fe(new et),wrappingIndent:Fe(new je),wrappingStrategy:Fe(new X)}}),define(_e[169],ye([17,18]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(_e[170],ye([17,18]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(_e[171],ye([17,18]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(_e[172],ye([17,18]),function(ie,e){return ie.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(_e[173],ye([17,18]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(_e[174],ye([17,18]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(_e[175],ye([17,18]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(_e[176],ye([17,18]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(_e[177],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(_e[178],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(_e[179],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(_e[180],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(_e[181],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTelemetry",e)}),define(_e[182],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(_e[183],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(_e[184],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(_e[185],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/node/extHostDebugService",e)}),define(_e[186],ye([17,18]),function(ie,e){return ie.create("vs/workbench/api/node/extHostTunnelService",e)}),define(_e[187],ye([17,18]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(_e[188],ye([17,18]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(_e[189],ye([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(_e[190],ye([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(_e[191],ye([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(_e[192],ye([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(_e[193],ye([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(_e[194],ye([17,18]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(_e[195],ye([17,18]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(_e[196],ye([17,18]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),function(){"use strict";function ie(e,a,P){function u(_,T){const S=A(_,T),D=[S];return e.isAbsolute(S)||D.unshift(P),e.resolve(...D)}function A(_,T){process.env.VSCODE_DEV&&(T="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let D=process.env.VSCODE_APPDATA;if(D)return e.join(D,T);const R=_["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(D=process.env.APPDATA,!D){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");D=e.join(I,"AppData","Roaming")}break;case"darwin":D=e.join(a.homedir(),"Library","Application Support");break;case"linux":D=process.env.XDG_CONFIG_HOME||e.join(a.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(D,T)}return{getUserDataPath:u}}if(typeof define=="function")define(_e[197],ye([320,71,33]),function(e,a,P){return ie(e,a,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),a=require("os");module.exports=ie(e,a,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(_e[198],ye([1,0,11]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class P{constructor(){this._generators=new Map}register(A,_){this._generators.set(A,_)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const _ in A.contributes){const T=this._generators.get(_);if(!T)continue;const S=A.contributes[_],D=Array.isArray(S)?S:[S];try{T(D,A.activationEvents)}catch(R){(0,a.onUnexpectedError)(R)}}}}e.ImplicitActivationEventsImpl=P,e.ImplicitActivationEvents=new P}),define(_e[199],ye([1,0,24,37,171,321]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||_.test(h)}e.isValidVersionStr=S;function D(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(_);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=D;function R(h){if(!h)return null;const g=h.majorBase,v=h.majorMustEqual,C=h.minorBase;let p=h.minorMustEqual;const i=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(g===0||(p=!1),o=!1);let s=0;if(h.preRelease){const l=T.exec(h.preRelease);if(l){const[,r,m,n]=l;s=Date.UTC(Number(r),Number(m)-1,Number(n))}}return{majorBase:g,majorMustEqual:v,minorBase:C,minorMustEqual:p,patchBase:i,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:s}}e.normalizeVersion=R;function I(h,g,v){let C;typeof h=="string"?C=R(D(h)):C=h;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let i;if(typeof v=="string"?i=R(D(v)):i=v,!C||!i)return!1;const o=C.majorBase,s=C.minorBase,l=C.patchBase;let r=i.majorBase,m=i.minorBase,n=i.patchBase;const t=i.notBefore;let c=i.majorMustEqual,E=i.minorMustEqual,y=i.patchMustEqual;return i.isMinimum?o>r?!0:o<r?!1:s>m?!0:s<m||p&&p<t?!1:l>=n:(o===1&&r===0&&(!c||!E||!y)&&(r=1,m=0,n=0,c=!0,E=!1,y=!1),o<r?!1:o>r?!c:s<m?!1:s>m?!E:l<n?!1:l>n?!y:!(p&&p<t))}e.isValidVersion=I;function b(h,g,v,C,p){const i=[];if(typeof C.publisher<"u"&&typeof C.publisher!="string")return i.push([P.default.Error,u.localize(0,null)]),i;if(typeof C.name!="string")return i.push([P.default.Error,u.localize(1,null,"name")]),i;if(typeof C.version!="string")return i.push([P.default.Error,u.localize(2,null,"version")]),i;if(!C.engines)return i.push([P.default.Error,u.localize(3,null,"engines")]),i;if(typeof C.engines.vscode!="string")return i.push([P.default.Error,u.localize(4,null,"engines.vscode")]),i;if(typeof C.extensionDependencies<"u"&&!d(C.extensionDependencies))return i.push([P.default.Error,u.localize(5,null,"extensionDependencies")]),i;if(typeof C.activationEvents<"u"){if(!d(C.activationEvents))return i.push([P.default.Error,u.localize(6,null,"activationEvents")]),i;if(typeof C.main>"u"&&typeof C.browser>"u")return i.push([P.default.Error,u.localize(7,null,"activationEvents","main")]),i}if(typeof C.extensionKind<"u"&&typeof C.main>"u"&&i.push([P.default.Warning,u.localize(8,null,"extensionKind")]),typeof C.main<"u"){if(typeof C.main!="string")return i.push([P.default.Error,u.localize(9,null,"main")]),i;{const l=(0,a.joinPath)(v,C.main);(0,a.isEqualOrParent)(l,v)||i.push([P.default.Warning,u.localize(10,null,l.path,v.path)])}if(typeof C.activationEvents>"u")return i.push([P.default.Error,u.localize(11,null,"activationEvents","main")]),i}if(typeof C.browser<"u"){if(typeof C.browser!="string")return i.push([P.default.Error,u.localize(12,null,"browser")]),i;{const l=(0,a.joinPath)(v,C.browser);(0,a.isEqualOrParent)(l,v)||i.push([P.default.Warning,u.localize(13,null,l.path,v.path)])}if(typeof C.activationEvents>"u")return i.push([P.default.Error,u.localize(14,null,"activationEvents","browser")]),i}if(!A.valid(C.version))return i.push([P.default.Error,u.localize(15,null)]),i;const o=[];if(!k(h,g,C,p,o))for(const l of o)i.push([P.default.Error,l]);return i}e.validateExtensionManifest=b;function k(h,g,v,C,p){return C||typeof v.main>"u"&&typeof v.browser>"u"?!0:f(h,g,v.engines.vscode,p)}e.isValidExtensionVersion=k;function w(h,g,v){return h==="*"||f(g,v,h)}e.isEngineValid=w;function f(h,g,v,C=[]){const p=R(D(v));if(!p)return C.push(u.localize(16,null,v)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return C.push(u.localize(17,null,v)),!1}else if(!p.majorMustEqual)return C.push(u.localize(18,null,v)),!1;return I(h,g,p)?!0:(C.push(u.localize(19,null,h,v)),!1)}function d(h){if(!Array.isArray(h))return!1;for(let g=0,v=h.length;g<v;g++)if(typeof h[g]!="string")return!1;return!0}}),define(_e[122],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(u,A=[],_=!1){this.ctor=u,this.staticArguments=A,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=a}),define(_e[89],ye([1,0,122]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const P=[];var u;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(u=e.InstantiationType||(e.InstantiationType={}));function A(T,S,D){S instanceof a.SyncDescriptor||(S=new a.SyncDescriptor(S,[],Boolean(D))),P.push([T,S])}e.registerSingleton=A;function _(){return P}e.getSingletonServiceDescriptors=_}),define(_e[200],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(A,_){this.key=A,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class P{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const _ of this._nodes.values())_.outgoing.size===0&&A.push(_);return A}insertEdge(A,_){const T=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(_);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(A){const _=this._hashFn(A);this._nodes.delete(_);for(const T of this._nodes.values())T.outgoing.delete(_),T.incoming.delete(_)}lookupOrInsertNode(A){const _=this._hashFn(A);let T=this._nodes.get(_);return T||(T=new a(_,A),this._nodes.set(_,T)),T}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[_,T]of this._nodes)A.push(`${_}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,_]of this._nodes){const T=new Set([A]),S=this._findCycle(_,T);if(S)return S}}_findCycle(A,_){for(const[T,S]of A.outgoing){if(_.has(T))return[..._,T].join(" -> ");_.add(T);const D=this._findCycle(S,_);if(D)return D;_.delete(T)}}}e.Graph=P}),define(_e[4],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=T})(a=e._util||(e._util={})),e.IInstantiationService=u("instantiationService");function P(_,T,S){T[a.DI_TARGET]===T?T[a.DI_DEPENDENCIES].push({id:_,index:S}):(T[a.DI_DEPENDENCIES]=[{id:_,index:S}],T[a.DI_TARGET]=T)}function u(_){if(a.serviceIds.has(_))return a.serviceIds.get(_);const T=function(S,D,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(T,S,R)};return T.toString=()=>_,a.serviceIds.set(_,T),T}e.createDecorator=u;function A(_){return _}e.refineServiceDecorator=A}),define(_e[53],ye([1,0,9,2,4]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,u.createDecorator)("configurationService");function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof P.URI)}e.isConfigurationOverrides=A;function _(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof P.URI)}e.isConfigurationUpdateOverrides=_;var T;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function D(d,h){const g=Object.create(null);for(const v in d)R(g,v,d[v],h);return g}e.toValuesTree=D;function R(d,h,g,v){const C=h.split("."),p=C.pop();let i=d;for(let o=0;o<C.length;o++){const s=C[o];let l=i[s];switch(typeof l){case"undefined":l=i[s]=Object.create(null);break;case"object":break;default:v(`Ignoring ${h} as ${C.slice(0,o+1).join(".")} is ${JSON.stringify(l)}`);return}i=l}if(typeof i=="object"&&i!==null)try{i[p]=g}catch{v(`Ignoring ${h} as ${C.join(".")} is ${JSON.stringify(i)}`)}else v(`Ignoring ${h} as ${C.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=R;function I(d,h){const g=h.split(".");b(d,g)}e.removeFromValueTree=I;function b(d,h){const g=h.shift();if(h.length===0){delete d[g];return}if(Object.keys(d).indexOf(g)!==-1){const v=d[g];typeof v=="object"&&!Array.isArray(v)&&(b(v,h),Object.keys(v).length===0&&delete d[g])}}function k(d,h,g){function v(i,o){let s=i;for(const l of o){if(typeof s!="object"||s===null)return;s=s[l]}return s}const C=h.split("."),p=v(d,C);return typeof p>"u"?g:p}e.getConfigurationValue=k;function w(d,h,g){Object.keys(h).forEach(v=>{v!=="__proto__"&&(v in d?a.isObject(d[v])&&a.isObject(h[v])?w(d[v],h[v],g):g&&(d[v]=h[v]):d[v]=h[v])})}e.merge=w;function f(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(_e[54],ye([1,0,12,8,4]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",a.isMacintosh),A.set("isLinux",a.isLinux),A.set("isWindows",a.isWindows),A.set("isWeb",a.isWeb),A.set("isMacNative",a.isMacintosh&&!a.isWeb),A.set("isEdge",a.isEdge),A.set("isFirefox",a.isFirefox),A.set("isChrome",a.isChrome),A.set("isSafari",a.isSafari);const _=Object.prototype.hasOwnProperty;var T;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return I.INSTANCE}static true(){return b.INSTANCE}static has(N){return k.create(N)}static equals(N,x){return w.create(N,x)}static notEquals(N,x){return h.create(N,x)}static regex(N,x){return s.create(N,x)}static in(N,x){return f.create(N,x)}static notIn(N,x){return d.create(N,x)}static not(N){return g.create(N)}static and(...N){return m.create(N,null,!0)}static or(...N){return n.create(N,null,!0)}static greater(N,x){return C.create(N,x)}static greaterEquals(N,x){return p.create(N,x)}static smaller(N,x){return i.create(N,x)}static smallerEquals(N,x){return o.create(N,x)}static deserialize(N,x=!1){if(!!N)return this._deserializeOrExpression(N,x)}static _deserializeOrExpression(N,x){const L=N.split("||");return n.create(L.map(F=>this._deserializeAndExpression(F,x)),null,!0)}static _deserializeAndExpression(N,x){const L=N.split("&&");return m.create(L.map(F=>this._deserializeOne(F,x)),null,!0)}static _deserializeOne(N,x){if(N=N.trim(),N.indexOf("!=")>=0){const L=N.split("!=");return h.create(L[0].trim(),this._deserializeValue(L[1],x))}if(N.indexOf("==")>=0){const L=N.split("==");return w.create(L[0].trim(),this._deserializeValue(L[1],x))}if(N.indexOf("=~")>=0){const L=N.split("=~");return s.create(L[0].trim(),this._deserializeRegexValue(L[1],x))}if(N.indexOf(" not in ")>=0){const L=N.split(" not in ");return d.create(L[0].trim(),this._deserializeValue(L[1],x))}if(N.indexOf(" in ")>=0){const L=N.split(" in ");return f.create(L[0].trim(),this._deserializeValue(L[1],x))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const L=N.split(">=");return p.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const L=N.split(">");return C.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const L=N.split("<=");return o.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const L=N.split("<");return i.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(N)?g.create(N.substr(1).trim()):k.create(N)}static _deserializeValue(N,x){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const L=/^'([^']*)'$/.exec(N);return L?L[1].trim():N}static _deserializeRegexValue(N,x){if((0,P.isFalsyOrWhitespace)(N)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const L=N.indexOf("/"),F=N.lastIndexOf("/");if(L===F||L<0){if(x)throw new Error(`bad regexp-value '${N}', missing /-enclosure`);return console.warn(`bad regexp-value '${N}', missing /-enclosure`),null}const U=N.slice(L+1,F),H=N[F+1]==="i"?"i":"";try{return new RegExp(U,H)}catch(de){if(x)throw new Error(`bad regexp-value '${N}', parse error: ${de}`);return console.warn(`bad regexp-value '${N}', parse error: ${de}`),null}}}e.ContextKeyExpr=S;function D($,N){const x=$?$.substituteConstants():void 0,L=N?N.substituteConstants():void 0;return!x&&!L?!0:!x||!L?!1:x.equals(L)}e.expressionsAreEqualWithConstantSubstitution=D;function R($,N){return $.cmp(N)}class I{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return b.INSTANCE}}I.INSTANCE=new I,e.ContextKeyFalseExpr=I;class b{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return I.INSTANCE}}b.INSTANCE=new b,e.ContextKeyTrueExpr=b;class k{static create(N,x=null){const L=A.get(N);return typeof L=="boolean"?L?b.INSTANCE:I.INSTANCE:new k(N,x)}constructor(N,x){this.key=N,this.negated=x,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:c(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=A.get(this.key);return typeof N=="boolean"?N?b.INSTANCE:I.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class w{static create(N,x,L=null){if(typeof x=="boolean")return x?k.create(N,L):g.create(N,L);const F=A.get(N);return typeof F=="boolean"?x===(F?"true":"false")?b.INSTANCE:I.INSTANCE:new w(N,x,L)}constructor(N,x,L){this.key=N,this.value=x,this.negated=L,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:E(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=A.get(this.key);if(typeof N=="boolean"){const x=N?"true":"false";return this.value===x?b.INSTANCE:I.INSTANCE}return this}evaluate(N){return N.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(N){return N.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class f{static create(N,x){return new f(N,x)}constructor(N,x){this.key=N,this.valueKey=x,this.type=10,this.negated=null}cmp(N){return N.type!==this.type?this.type-N.type:E(this.key,this.valueKey,N.key,N.valueKey)}equals(N){return N.type===this.type?this.key===N.key&&this.valueKey===N.valueKey:!1}substituteConstants(){return this}evaluate(N){const x=N.getValue(this.valueKey),L=N.getValue(this.key);return Array.isArray(x)?x.includes(L):typeof L=="string"&&typeof x=="object"&&x!==null?_.call(x,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(N){return N.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=f;class d{static create(N,x){return new d(N,x)}constructor(N,x){this.key=N,this.valueKey=x,this.type=11,this._negated=f.create(N,x)}cmp(N){return N.type!==this.type?this.type-N.type:this._negated.cmp(N._negated)}equals(N){return N.type===this.type?this._negated.equals(N._negated):!1}substituteConstants(){return this}evaluate(N){return!this._negated.evaluate(N)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(N){return N.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class h{static create(N,x,L=null){if(typeof x=="boolean")return x?g.create(N,L):k.create(N,L);const F=A.get(N);return typeof F=="boolean"?x===(F?"true":"false")?I.INSTANCE:b.INSTANCE:new h(N,x,L)}constructor(N,x,L){this.key=N,this.value=x,this.negated=L,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:E(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=A.get(this.key);if(typeof N=="boolean"){const x=N?"true":"false";return this.value===x?I.INSTANCE:b.INSTANCE}return this}evaluate(N){return N.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(N){return N.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=h;class g{static create(N,x=null){const L=A.get(N);return typeof L=="boolean"?L?I.INSTANCE:b.INSTANCE:new g(N,x)}constructor(N,x){this.key=N,this.negated=x,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:c(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=A.get(this.key);return typeof N=="boolean"?N?I.INSTANCE:b.INSTANCE:this}evaluate(N){return!N.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(N){return N.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function v($,N){if(typeof $=="string"){const x=parseFloat($);isNaN(x)||($=x)}return typeof $=="string"||typeof $=="number"?N($):I.INSTANCE}class C{static create(N,x,L=null){return v(x,F=>new C(N,F,L))}constructor(N,x,L){this.key=N,this.value=x,this.negated=L,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:E(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=C;class p{static create(N,x,L=null){return v(x,F=>new p(N,F,L))}constructor(N,x,L){this.key=N,this.value=x,this.negated=L,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:E(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=p;class i{static create(N,x,L=null){return v(x,F=>new i(N,F,L))}constructor(N,x,L){this.key=N,this.value=x,this.negated=L,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:E(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class o{static create(N,x,L=null){return v(x,F=>new o(N,F,L))}constructor(N,x,L){this.key=N,this.value=x,this.negated=L,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:E(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class s{static create(N,x){return new s(N,x)}constructor(N,x){this.key=N,this.regexp=x,this.type=7,this.negated=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.key<N.key)return-1;if(this.key>N.key)return 1;const x=this.regexp?this.regexp.source:"",L=N.regexp?N.regexp.source:"";return x<L?-1:x>L?1:0}equals(N){if(N.type===this.type){const x=this.regexp?this.regexp.source:"",L=N.regexp?N.regexp.source:"";return this.key===N.key&&x===L}return!1}substituteConstants(){return this}evaluate(N){const x=N.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const N=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${N}`}keys(){return[this.key]}map(N){return N.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class l{static create(N){return new l(N)}constructor(N){this._actual=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this._actual.cmp(N._actual)}equals(N){return N.type===this.type?this._actual.equals(N._actual):!1}substituteConstants(){return this}evaluate(N){return!this._actual.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(N){return new l(this._actual.map(N))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;function r($){let N=null;for(let x=0,L=$.length;x<L;x++){const F=$[x].substituteConstants();if($[x]!==F&&N===null){N=[];for(let U=0;U<x;U++)N[U]=$[U]}N!==null&&(N[x]=F)}return N===null?$:N}class m{static create(N,x,L){return m._normalizeArr(N,x,L)}constructor(N,x){this.expr=N,this.negated=x,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let x=0,L=this.expr.length;x<L;x++){const F=R(this.expr[x],N.expr[x]);if(F!==0)return F}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].equals(N.expr[x]))return!1;return!0}return!1}substituteConstants(){const N=r(this.expr);return N===this.expr?this:m.create(N,this.negated,!1)}evaluate(N){for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].evaluate(N))return!1;return!0}static _normalizeArr(N,x,L){const F=[];let U=!1;for(const H of N)if(!!H){if(H.type===1){U=!0;continue}if(H.type===0)return I.INSTANCE;if(H.type===6){F.push(...H.expr);continue}F.push(H)}if(F.length===0&&U)return b.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(R);for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];for(;F.length>1;){const H=F[F.length-1];if(H.type!==9)break;F.pop();const de=F.pop(),Y=F.length===0,V=n.create(H.expr.map(X=>m.create([X,de],null,L)),null,Y);V&&(F.push(V),F.sort(R))}if(F.length===1)return F[0];if(L){for(let H=0;H<F.length;H++)for(let de=H+1;de<F.length;de++)if(F[H].negate().equals(F[de]))return I.INSTANCE;if(F.length===1)return F[0]}return new m(F,x)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const x of this.expr)N.push(...x.keys());return N}map(N){return new m(this.expr.map(x=>x.map(N)),null)}negate(){if(!this.negated){const N=[];for(const x of this.expr)N.push(x.negate());this.negated=n.create(N,this,!0)}return this.negated}}class n{static create(N,x,L){return n._normalizeArr(N,x,L)}constructor(N,x){this.expr=N,this.negated=x,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let x=0,L=this.expr.length;x<L;x++){const F=R(this.expr[x],N.expr[x]);if(F!==0)return F}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].equals(N.expr[x]))return!1;return!0}return!1}substituteConstants(){const N=r(this.expr);return N===this.expr?this:n.create(N,this.negated,!1)}evaluate(N){for(let x=0,L=this.expr.length;x<L;x++)if(this.expr[x].evaluate(N))return!0;return!1}static _normalizeArr(N,x,L){let F=[],U=!1;if(N){for(let H=0,de=N.length;H<de;H++){const Y=N[H];if(!!Y){if(Y.type===0){U=!0;continue}if(Y.type===1)return b.INSTANCE;if(Y.type===9){F=F.concat(Y.expr);continue}F.push(Y)}}if(F.length===0&&U)return I.INSTANCE;F.sort(R)}if(F.length!==0){if(F.length===1)return F[0];for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];if(L){for(let H=0;H<F.length;H++)for(let de=H+1;de<F.length;de++)if(F[H].negate().equals(F[de]))return b.INSTANCE;if(F.length===1)return F[0]}return new n(F,x)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const x of this.expr)N.push(...x.keys());return N}map(N){return new n(this.expr.map(x=>x.map(N)),null)}negate(){if(!this.negated){const N=[];for(const x of this.expr)N.push(x.negate());for(;N.length>1;){const x=N.shift(),L=N.shift(),F=[];for(const U of j(x))for(const H of j(L))F.push(m.create([U,H],null,!1));N.unshift(n.create(F,null,!1))}this.negated=n.create(N,this,!0)}return this.negated}}class t extends k{static all(){return t._info.values()}constructor(N,x,L){super(N,null),this._defaultValue=x,typeof L=="object"?t._info.push({...L,key:N}):L!==!0&&t._info.push({key:N,description:L,type:x!=null?typeof x:void 0})}bindTo(N){return N.createKey(this.key,this._defaultValue)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return w.create(this.key,N)}notEqualsTo(N){return h.create(this.key,N)}}t._info=[],e.RawContextKey=t,e.IContextKeyService=(0,u.createDecorator)("contextKeyService");function c($,N){return $<N?-1:$>N?1:0}function E($,N,x,L){return $<x?-1:$>x?1:N<L?-1:N>L?1:0}function y($,N){if($.type===0||N.type===1)return!0;if($.type===9)return N.type===9?M($.expr,N.expr):!1;if(N.type===9){for(const x of N.expr)if(y($,x))return!0;return!1}if($.type===6){if(N.type===6)return M(N.expr,$.expr);for(const x of $.expr)if(y(x,N))return!0;return!1}return $.equals(N)}e.implies=y;function M($,N){let x=0,L=0;for(;x<$.length&&L<N.length;){const F=$[x].cmp(N[L]);if(F<0)return!1;F===0&&x++,L++}return x===$.length}function j($){return $.type===9?$.expr:[$]}}),define(_e[201],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(_e[123],ye([1,0,170,4]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function u(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=u;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function _(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function T(h,g){return g==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(h,g,v){return T(g,v)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===v?!0:D(v).includes(h)}e.isTargetPlatformCompatible=S;function D(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function R(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=R;var I;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var b;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var k;(function(h){h.Install="install",h.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var w;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var f;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(g,v){super(g),this.code=v,this.name=v}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(_e[202],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(_e[203],ye([1,0,46,14,10,12,109,29,116,172,202]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=D.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends b{openTerminal(C,p){return this.spawnTerminal(a,C,S.getWindowsShell(),p)}spawnTerminal(C,p,i,o){const s=p.windowsExec||k.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const l=u.basename(s,".exe").toLowerCase();if(l==="cmder")return C.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),l==="wt"&&r.push("-d ."),new Promise((m,n)=>{const t=d(process),c=C.spawn(i,r,{cwd:o,env:t});c.on("error",n),c.on("exit",()=>m())})}runInTerminal(C,p,i,o,s){const l="windowsExec"in s&&s.windowsExec?s.windowsExec:k.getDefaultTerminalWindows();return new Promise((r,m)=>{const n=`"${p} - ${I}"`,t=`""${i.join('" "')}" & pause"`,c=Object.assign({},d(process),o);Object.keys(c).filter($=>c[$]===null).forEach($=>delete c[$]);const E={cwd:p,env:c,windowsVerbatimArguments:!0};let y,M;u.basename(l,".exe")==="wt"?(y=l,M=["-d",".",k.CMD,"/c",t]):(y=k.CMD,M=["/c","start",n,"/wait",l,"/c",t]),a.spawn(y,M,E).on("error",$=>{m(h($))}),r(void 0)})}static getDefaultTerminalWindows(){if(!k._DEFAULT_TERMINAL_WINDOWS){const C=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${C?"Sysnative":"System32"}\\cmd.exe`}return k._DEFAULT_TERMINAL_WINDOWS}}k.CMD="cmd.exe",e.WindowsExternalTerminalService=k;class w extends b{openTerminal(C,p){return this.spawnTerminal(a,C,p)}runInTerminal(C,p,i,o,s){const l=s.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,m)=>{if(l===R.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const n=l===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",c=[P.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",C||I,"-w",p];for(const M of i)c.push("-a"),c.push(M);if(o){const M=Object.assign({},d(process),o);for(const j in M){const $=M[j];$===null?(c.push("-u"),c.push(j)):(c.push("-e"),c.push(`${j}=${$}`))}}let E="";const y=a.spawn(w.OSASCRIPT,c);y.on("error",M=>{m(h(M))}),y.stderr.on("data",M=>{E+=M.toString()}),y.on("exit",M=>{if(M===0)r(void 0);else if(E){const j=E.split(`
`,1);m(new Error(j[0]))}else m(new Error(D.localize(1,null,n,M)))})}else m(new Error(D.localize(2,null,l)))})}spawnTerminal(C,p,i){const o=p.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{const r=["-a",o];i&&r.push(i);const m=d(process),n=C.spawn("/usr/bin/open",r,{cwd:i,env:m});n.on("error",l),n.on("exit",()=>s())})}}w.OSASCRIPT="/usr/bin/osascript",e.MacExternalTerminalService=w;class f extends b{openTerminal(C,p){return this.spawnTerminal(a,C,p)}runInTerminal(C,p,i,o,s){const l=s.linuxExec?Promise.resolve(s.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,m)=>{const n=[];l.then(t=>{t.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const c=`${g(i)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;n.push(`''${c}''`);const E=Object.assign({},d(process),o);Object.keys(E).filter($=>E[$]===null).forEach($=>delete E[$]);const y={cwd:p,env:E};let M="";const j=a.spawn(t,n,y);j.on("error",$=>{m(h($))}),j.stderr.on("data",$=>{M+=$.toString()}),j.on("exit",$=>{if($===0)r(void 0);else if(M){const N=M.split(`
`,1);m(new Error(N[0]))}else m(new Error(D.localize(4,null,t,$)))})})})}static async getDefaultTerminalLinuxReady(){if(!f._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)f._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const C=await T.Promises.exists("/etc/debian_version");f._DEFAULT_TERMINAL_LINUX_READY=new Promise(p=>{C?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(C,p,i){const o=p.linuxExec?Promise.resolve(p.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{o.then(r=>{const m=d(process),n=C.spawn(r,[],{cwd:i,env:m});n.on("error",l),n.on("exit",()=>s())})})}}f.WAIT_MESSAGE=D.localize(3,null),e.LinuxExternalTerminalService=f;function d(v){const C={...v.env};return(0,_.sanitizeProcessEnvironment)(C),C}function h(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(D.localize(5,null,v.path)):v}function g(v){let C="";for(const p of v)p.indexOf(" ")>=0?C+='"'+p+'"':C+=p,C+=" ";return C}}),define(_e[44],ye([1,0,68,10,8,9,2,173,4,12,14]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function I(V){return V.create===!0}e.isFileOpenForWriteOptions=I;var b;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var k;(function(V){V[V.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var w;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=f;function d(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=d;function h(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=h;function g(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function v(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=v;function C(V){return f(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;var p;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{constructor(X,Z){super(X),this.code=Z}}e.FileSystemProviderError=i;function o(V,X){const Z=new i(V.toString(),X);return l(Z,X),Z}e.createFileSystemProviderError=o;function s(V){return V||o((0,T.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=s;function l(V,X){return V.name=X?`${X} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=l;function r(V){if(!V)return p.Unknown;if(V instanceof i)return V.code;const X=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!X)return p.Unknown;switch(X[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=r;function m(V){if(V instanceof M)return V.fileOperationResult;switch(r(V)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=m;var n;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(X,Z,te){this.resource=X,this.operation=Z,this.target=te}isOperation(X){return this.operation===X}}e.FileOperationEvent=t;var c;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class E{constructor(X,Z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const K of X){const J=te.get(K.type);switch(J?J.push([K.resource,K]):te.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,J]of te)switch(K){case 1:this.added=a.TernarySearchTree.forUris(()=>Z),this.added.fill(J);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>Z),this.updated.fill(J);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>Z),this.deleted.fill(J);break}}contains(X,...Z){return this.doContains(X,{includeChildren:!1},...Z)}affects(X,...Z){return this.doContains(X,{includeChildren:!0},...Z)}doContains(X,Z,...te){if(!X)return!1;const K=te.length>0;return!!((!K||te.includes(1))&&(this.added?.get(X)||Z.includeChildren&&this.added?.findSuperstr(X))||(!K||te.includes(0))&&(this.updated?.get(X)||Z.includeChildren&&this.updated?.findSuperstr(X))||(!K||te.includes(2))&&(this.deleted?.findSubstr(X)||Z.includeChildren&&this.deleted?.findSuperstr(X)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=E;function y(V,X,Z){return!V||!X||V===X||X.length>V.length?!1:(X.charAt(X.length-1)!==P.sep&&(X+=P.sep),Z?(0,u.startsWithIgnoreCase)(V,X):V.indexOf(X)===0)}e.isParent=y;class M extends Error{constructor(X,Z,te){super(X),this.fileOperationResult=Z,this.options=te}}e.FileOperationError=M;class j extends M{constructor(X,Z,te,K){super(X,Z,K),this.fileOperationResult=Z,this.size=te}}e.TooLargeFileOperationError=j;class $ extends M{constructor(X,Z,te){super(X,2,te),this.stat=Z}}e.NotModifiedSinceFileOperationError=$;var N;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=L;async function F(V,X){if(!X.hasProvider(_.URI.from({scheme:V.scheme})))return new Promise(Z=>{const te=X.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===V.scheme&&K.added&&(te.dispose(),Z())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(X){return(0,A.isNumber)(X)||(X=0),X<U.KB?(0,T.localize)(1,null,X.toFixed(0)):X<U.MB?(0,T.localize)(2,null,(X/U.KB).toFixed(2)):X<U.GB?(0,T.localize)(3,null,(X/U.MB).toFixed(2)):X<U.TB?(0,T.localize)(4,null,(X/U.GB).toFixed(2)):(0,T.localize)(5,null,(X/U.TB).toFixed(2))}}U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB,e.ByteSize=U;var H;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function de(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformFileLimits=de;function Y(V){const X=typeof V=="string"||V?.scheme===R.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===R.Schemas.file?1024*U.MB:X?10*U.MB:D.isWeb?50*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=Y}),define(_e[90],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...u){this._entries=new Map;for(const[A,_]of u)this.set(A,_)}set(u,A){const _=this._entries.get(u);return this._entries.set(u,A),_}has(u){return this._entries.has(u)}get(u){return this._entries.get(u)}}e.ServiceCollection=a}),define(_e[204],ye([1,0,19,11,6,122,200,4,90,66]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class I extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class b{constructor(d=new S.ServiceCollection,h=!1,g,v=R){this._services=d,this._strict=h,this._parent=g,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=v?g?._globalGraph??new _.Graph(C=>C):void 0}createChild(d){return new b(d,this._strict,this,this._enableTracing)}invokeFunction(d,...h){const g=w.traceInvocation(this._enableTracing,d);let v=!1;try{return d({get:p=>{if(v)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(p,g);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...h)}finally{v=!0,g.stop()}}createInstance(d,...h){let g,v;return d instanceof A.SyncDescriptor?(g=w.traceCreation(this._enableTracing,d.ctor),v=this._createInstance(d.ctor,d.staticArguments.concat(h),g)):(g=w.traceCreation(this._enableTracing,d),v=this._createInstance(d,h,g)),g.stop(),v}_createInstance(d,h=[],g){const v=T._util.getServiceDependencies(d).sort((i,o)=>i.index-o.index),C=[];for(const i of v){const o=this._getOrCreateServiceInstance(i.id,g);o||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${i.id}.`,!1),C.push(o)}const p=v.length>0?v[0].index:h.length;if(h.length!==p){console.trace(`[createInstance] First service dependency of ${d.name} at position ${p+1} conflicts with ${h.length} static arguments`);const i=p-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,p)}return Reflect.construct(d,h.concat(C))}_setServiceInstance(d,h){if(this._services.get(d)instanceof A.SyncDescriptor)this._services.set(d,h);else if(this._parent)this._parent._setServiceInstance(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const h=this._services.get(d);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):h}_getOrCreateServiceInstance(d,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(d));const g=this._getServiceInstanceOrDescriptor(d);return g instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,g,h.branch(d,!0)):(h.branch(d,!1),g)}_safeCreateAndCacheServiceInstance(d,h,g){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,h,g)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,h,g){const v=new _.Graph(i=>i.id.toString());let C=0;const p=[{id:d,desc:h,_trace:g}];for(;p.length;){const i=p.pop();if(v.lookupOrInsertNode(i),C++>1e3)throw new I(v);for(const o of T._util.getServiceDependencies(i.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(o.id);if(s||this._throwIfStrict(`[createInstance] ${d} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof A.SyncDescriptor){const l={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};v.insertEdge(i,l),p.push(l)}}}for(;;){const i=v.roots();if(i.length===0){if(!v.isEmpty())throw new I(v);break}for(const{data:o}of i){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const l=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,l)}v.removeNode(o)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,h,g=[],v,C){if(this._services.get(d)instanceof A.SyncDescriptor)return this._createServiceInstance(d,h,g,v,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,h,g,v,C);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(d,h,g=[],v,C){if(v){const p=new b(void 0,this._strict,this,this._enableTracing);p._globalGraphImplicitDependency=String(d);const i=new Map,o=new a.IdleValue(()=>{const s=p._createInstance(h,g,C);for(const[l,r]of i){const m=s[l];if(typeof m=="function")for(const n of r)m.apply(s,n)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,l){if(!o.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let n=i.get(l);return n||(n=new D.LinkedList,i.set(l,n)),(c,E,y)=>{const M=n.push([c,E,y]);return(0,u.toDisposable)(M)}}if(l in s)return s[l];const r=o.value;let m=r[l];return typeof m!="function"||(m=m.bind(r),s[l]=m),m},set(s,l,r){return o.value[l]=r,!0},getPrototypeOf(s){return h.prototype}})}else return this._createInstance(h,g,C)}_throwIfStrict(d,h){if(h&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=b;var k;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(k||(k={}));class w{static traceInvocation(d,h){return d?new w(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w._None}static traceCreation(d,h){return d?new w(1,h.name):w._None}constructor(d,h){this.type=d,this.name=h,this._start=Date.now(),this._dep=[]}branch(d,h){const g=new w(3,d.toString());return this._dep.push([d,h,g]),g}stop(){const d=Date.now()-this._start;w._totals+=d;let h=!1;function g(C,p){const i=[],o=new Array(C+1).join("	");for(const[s,l,r]of p._dep)if(l&&r){h=!0,i.push(`${o}CREATES -> ${s}`);const m=g(C+1,r);m&&i.push(m)}else i.push(`${o}uses -> ${s}`);return i.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(d>2||h)&&w.all.add(v.join(`
`))}}w.all=new Set,w._None=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}},w._totals=0,e.Trace=w}),define(_e[13],ye([1,0,45,3,6,28,12,9,2,4]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function R(){return new Date().toISOString()}function I(n){return(0,T.isNumber)(n)}e.isLogLevel=I;var b;(function(n){n[n.Off=0]="Off",n[n.Trace=1]="Trace",n[n.Debug=2]="Debug",n[n.Info=3]="Info",n[n.Warning=4]="Warning",n[n.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function k(n,t,c){switch(t){case b.Trace:n.trace(c);break;case b.Debug:n.debug(c);break;case b.Info:n.info(c);break;case b.Warning:n.warn(c);break;case b.Error:n.error(c);break;case b.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=k;function w(n){let t="";for(let c=0;c<n.length;c++){let E=n[c];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}t+=(c>0?" ":"")+E}return t}e.format=w;class f extends u.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(t){return this.level!==b.Off&&this.level<=t}}e.AbstractLogger=f;class d extends f{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||super.checkLogLevel(t)}trace(t,...c){this.checkLogLevel(b.Trace)&&this.log(b.Trace,w([t,...c]))}debug(t,...c){this.checkLogLevel(b.Debug)&&this.log(b.Debug,w([t,...c]))}info(t,...c){this.checkLogLevel(b.Info)&&this.log(b.Info,w([t,...c]))}warn(t,...c){this.checkLogLevel(b.Warning)&&this.log(b.Warning,w([t,...c]))}error(t,...c){if(this.checkLogLevel(b.Error))if(t instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=t.stack,this.log(b.Error,w(E))}else this.log(b.Error,w([t,...c]))}flush(){}}e.AbstractMessageLogger=d;class h extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!_.isWindows}trace(t,...c){this.checkLogLevel(b.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${R()}]\x1B[0m`,t,...c):console.log(`[main ${R()}]`,t,...c))}debug(t,...c){this.checkLogLevel(b.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${R()}]\x1B[0m`,t,...c):console.log(`[main ${R()}]`,t,...c))}info(t,...c){this.checkLogLevel(b.Info)&&(this.useColors?console.log(`\x1B[90m[main ${R()}]\x1B[0m`,t,...c):console.log(`[main ${R()}]`,t,...c))}warn(t,...c){this.checkLogLevel(b.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${R()}]\x1B[0m`,t,...c):console.warn(`[main ${R()}]`,t,...c))}error(t,...c){this.checkLogLevel(b.Error)&&(this.useColors?console.error(`\x1B[91m[main ${R()}]\x1B[0m`,t,...c):console.error(`[main ${R()}]`,t,...c))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class g extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...c){this.checkLogLevel(b.Trace)&&console.log("%cTRACE","color: #888",t,...c)}debug(t,...c){this.checkLogLevel(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...c)}info(t,...c){this.checkLogLevel(b.Info)&&console.log("%c INFO","color: #33f",t,...c)}warn(t,...c){this.checkLogLevel(b.Warning)&&console.log("%c WARN","color: #993",t,...c)}error(t,...c){this.checkLogLevel(b.Error)&&console.log("%c  ERR","color: #f33",t,...c)}dispose(){}flush(){}}e.ConsoleLogger=g;class v extends f{constructor(t,c=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(c)}trace(t,...c){this.checkLogLevel(b.Trace)&&this.adapter.log(b.Trace,[this.extractMessage(t),...c])}debug(t,...c){this.checkLogLevel(b.Debug)&&this.adapter.log(b.Debug,[this.extractMessage(t),...c])}info(t,...c){this.checkLogLevel(b.Info)&&this.adapter.log(b.Info,[this.extractMessage(t),...c])}warn(t,...c){this.checkLogLevel(b.Warning)&&this.adapter.log(b.Warning,[this.extractMessage(t),...c])}error(t,...c){this.checkLogLevel(b.Error)&&this.adapter.log(b.Error,[this.extractMessage(t),...c])}extractMessage(t){return typeof t=="string"?t:(0,a.toErrorMessage)(t,this.checkLogLevel(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=v;class C extends f{constructor(t){super(),this.loggers=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const c of this.loggers)c.setLevel(t);super.setLevel(t)}trace(t,...c){for(const E of this.loggers)E.trace(t,...c)}debug(t,...c){for(const E of this.loggers)E.debug(t,...c)}info(t,...c){for(const E of this.loggers)E.info(t,...c)}warn(t,...c){for(const E of this.loggers)E.warn(t,...c)}error(t,...c){for(const E of this.loggers)E.error(t,...c)}flush(){for(const t of this.loggers)t.flush()}dispose(){for(const t of this.loggers)t.dispose()}}e.MultiplexLogger=C;class p extends u.Disposable{constructor(t,c){if(super(),this.logLevel=t,this._loggers=new A.ResourceMap,this._loggerResources=new A.ResourceMap,this._onDidChangeLoggers=this._register(new P.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,c)for(const E of c)this._loggerResources.set(E.resource,E)}getLogger(t){return this._loggers.get(t)}createLogger(t,c){let E=this._loggers.get(t);const y=c?.logLevel==="always"?b.Trace:c?.logLevel;return E||(E=this.doCreateLogger(t,y??this.getLogLevel(t)??this.logLevel,c),this._loggers.set(t,E)),this.registerLogger({resource:t,id:c?.id??t.toString(),logLevel:y,name:c?.name,hidden:c?.hidden,extensionId:c?.extensionId}),E}setLogLevel(t,c){if(S.URI.isUri(t)){const E=t,y=c,M=this._loggerResources.get(E);M&&y!==M.logLevel&&(M.logLevel=y===this.logLevel?void 0:y,this._loggers.get(E)?.setLevel(y),this._loggerResources.set(M.resource,M),this._onDidChangeLogLevel.fire([E,y]))}else{this.logLevel=t;for(const[E,y]of this._loggers.entries())this._loggerResources.get(E)?.logLevel===void 0&&y.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(t,c){const E=this._loggerResources.get(t);E&&c!==!E.hidden&&(E.hidden=!c,this._loggerResources.set(E.resource,E),this._onDidChangeVisibility.fire([t,c]))}getLogLevel(t){let c;return t&&(c=this._loggerResources.get(t)?.logLevel),c??this.logLevel}registerLogger(t){const c=this._loggerResources.get(t.resource);c?c.hidden!==t.hidden&&this.setVisibility(t.resource,!t.hidden):(this._loggerResources.set(t.resource,t),this._onDidChangeLoggers.fire({added:[t],removed:[]}))}deregisterLogger(t){const c=this._loggerResources.get(t);if(c){this._loggerResources.delete(t);const E=this._loggers.get(t);E&&(this._loggers.delete(t),E.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[c]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(t){return this._loggerResources.get(t)}dispose(){this._loggers.forEach(t=>t.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=p;class i{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(t){}getLevel(){return b.Info}trace(t,...c){}debug(t,...c){}info(t,...c){}warn(t,...c){}error(t,...c){}critical(t,...c){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;class s extends p{constructor(){super(b.Info)}doCreateLogger(t,c,E){return new i}}e.NullLoggerService=s;function l(n){if(n.verbose)return b.Trace;if(typeof n.logLevel=="string"){const t=m(n.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function r(n){switch(n){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=r;function m(n){switch(n){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=m}),define(_e[205],ye([1,0,6,13]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class u extends a.Disposable{constructor(_,T=[]){super(),this.logger=new P.MultiplexLogger([_,...T]),this._register(_.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(_){this.logger.setLevel(_)}getLevel(){return this.logger.getLevel()}trace(_,...T){this.logger.trace(_,...T)}debug(_,...T){this.logger.debug(_,...T)}info(_,...T){this.logger.info(_,...T)}warn(_,...T){this.logger.warn(_,...T)}error(_,...T){this.logger.error(_,...T)}flush(){this.logger.flush()}}e.LogService=u}),define(_e[206],ye([1,0,44,13]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var u;(function(D){D[D.Trace=0]="Trace",D[D.Debug=1]="Debug",D[D.Info=2]="Info",D[D.Warning=3]="Warning",D[D.Error=4]="Error",D[D.Critical=5]="Critical",D[D.Off=6]="Off"})(u||(u={}));async function A(D,R,I,b,k){try{const w=await new Promise((d,h)=>{ie(["spdlog"],d,h)});w.setFlushOn(u.Trace);const f=await w.createAsyncRotatingLogger(D,R,I,b);return k?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(w){console.error(w)}return null}function _(D,R,I){switch(R){case P.LogLevel.Trace:D.trace(I);break;case P.LogLevel.Debug:D.debug(I);break;case P.LogLevel.Info:D.info(I);break;case P.LogLevel.Warning:D.warn(I);break;case P.LogLevel.Error:D.error(I);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function T(D,R){switch(R){case P.LogLevel.Trace:D.setLevel(u.Trace);break;case P.LogLevel.Debug:D.setLevel(u.Debug);break;case P.LogLevel.Info:D.setLevel(u.Info);break;case P.LogLevel.Warning:D.setLevel(u.Warning);break;case P.LogLevel.Error:D.setLevel(u.Error);break;case P.LogLevel.Off:D.setLevel(u.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class S extends P.AbstractMessageLogger{constructor(R,I,b,k,w){super(),this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(R,I,b,k),this._register(this.onDidChangeLogLevel(f=>{this._logger&&T(this._logger,f)}))}async _createSpdLogLogger(R,I,b,k){const w=b?6:1,f=30/w*a.ByteSize.MB,d=await A(R,I,f,w,k);if(d){this._logger=d,T(this._logger,this.getLevel());for(const{level:h,message:g}of this.buffer)_(this._logger,h,g);this.buffer=[]}}log(R,I){this._logger?_(this._logger,R,I):this.getLevel()<=R&&this.buffer.push({level:R,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=S}),define(_e[124],ye([1,0,37,174,4]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var _;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function D(w,f){return f-w}S.compare=D;const R=Object.create(null);R[S.Error]=(0,P.localize)(0,null),R[S.Warning]=(0,P.localize)(1,null),R[S.Info]=(0,P.localize)(2,null);function I(w){return R[w]||""}S.toString=I;function b(w){switch(w){case a.default.Error:return S.Error;case a.default.Warning:return S.Warning;case a.default.Info:return S.Info;case a.default.Ignore:return S.Hint}}S.fromSeverity=b;function k(w){switch(w){case S.Error:return a.default.Error;case S.Warning:return a.default.Warning;case S.Info:return a.default.Info;case S.Hint:return a.default.Ignore}}S.toSeverity=k}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const D="";function R(b){return I(b,!0)}S.makeKey=R;function I(b,k){const w=[D];return b.source?w.push(b.source.replace("\xA6","\\\xA6")):w.push(D),b.code?typeof b.code=="string"?w.push(b.code.replace("\xA6","\\\xA6")):w.push(b.code.value.replace("\xA6","\\\xA6")):w.push(D),b.severity!==void 0&&b.severity!==null?w.push(_.toString(b.severity)):w.push(D),b.message&&k?w.push(b.message.replace("\xA6","\\\xA6")):w.push(D),b.startLineNumber!==void 0&&b.startLineNumber!==null?w.push(b.startLineNumber.toString()):w.push(D),b.startColumn!==void 0&&b.startColumn!==null?w.push(b.startColumn.toString()):w.push(D),b.endLineNumber!==void 0&&b.endLineNumber!==null?w.push(b.endLineNumber.toString()):w.push(D),b.endColumn!==void 0&&b.endColumn!==null?w.push(b.endColumn.toString()):w.push(D),w.push(D),w.join("\xA6")}S.makeKeyOptionalMessage=I})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,u.createDecorator)("markerService")}),define(_e[207],ye([1,0,3,37,4]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=P.default,e.INotificationService=(0,u.createDecorator)("notificationService");var A;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(_e[125],ye([1,0,8,2,4]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,u.createDecorator)("openerService");function A(D,R){return P.URI.isUri(D)?(0,a.equalsIgnoreCase)(D.scheme,R):(0,a.startsWithIgnoreCase)(D,R+":")}e.matchesScheme=A;function _(D,...R){return R.some(I=>A(D,I))}e.matchesSomeScheme=_;function T(D,R){return D.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=T;function S(D){let R;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(D.fragment);return I&&(R={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},D=D.with({fragment:""})),{selection:R,uri:D}}e.extractSelection=S}),define(_e[208],ye([1,0,14,12,33,197]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.context<"u"){const T=P.globals.vscode.context.configuration();if(T)_=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){_=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:T,searchUrl:S,itemUrl:D,controlUrl:R}=_.extensionsGallery||{};Object.assign(_,{extensionsGallery:{serviceUrl:u.env.VSCODE_GALLERY_SERVICE_URL||T,searchUrl:u.env.VSCODE_GALLERY_SEARCH_URL||S,itemUrl:u.env.VSCODE_GALLERY_ITEM_URL||D,controlUrl:u.env.VSCODE_GALLERY_CONTROL_URL||R}});try{const I=(...f)=>f.reduce((d,h)=>(Object.keys(h).forEach(g=>{Array.isArray(d[g])&&Array.isArray(h[g])?d[g]=h[g]:typeof d[g]=="object"&&typeof h[g]=="object"?d[g]=I(d[g],h[g]):d[g]=h[g]}),d),{}),b=(0,A.getUserDataPath)({},_.nameShort),k=P.isWindows?`file:///${b}/product.json`:`file://${b}/product.json`,w=ie.__$__nodeRequire(a.FileAccess.asFileUri(k).fsPath);_=I(_,w)}catch{}if(u.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),!_.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(_,{version:I.version,release:I.release})}}else _={},Object.keys(_).length===0&&Object.assign(_,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(_e[209],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ie,e){return function(a,P){e(a,P,ie)}};define(_e[126],ye([1,0,19,21,6,4]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var _;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this._value}constructor(I){this.callback=I}report(I){this._value=I,this.callback(this._value)}}T.None=Object.freeze({report(){}}),e.Progress=T;let S=class extends u.Disposable{constructor(I,b){super(),this.deferred=new a.DeferredPromise,b.withProgress(I,k=>(this.reporter=k,this.lastStep&&k.report(this.lastStep),this.deferred.p)),this._register((0,u.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=Ve([We(1,e.IProgressService)],S),e.UnmanagedProgress=S;class D extends u.Disposable{constructor(I){super(),this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new u.DisposableStore)}start(I){this.stop();const b=++this.currentOperationId,k=new P.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,u.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,u.toDisposable)(()=>k.cancel())),this.currentOperationDisposables.add((0,u.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:k.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(_e[39],ye([1,0,50,9]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class u{constructor(){this.data=new Map}add(_,T){a.ok(P.isString(_)),a.ok(P.isObject(T)),a.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,T)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new u}),define(_e[91],ye([1,0,3,39]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function u(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,D){this.schemasById[u(S)]=D,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new A;P.Registry.add(e.Extensions.JSONContribution,_)}),define(_e[127],ye([1,0,16,3,9,169,53,91,39]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=S.Registry.as(T.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const s=new Set;this.doRegisterConfigurations(i,o,s),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(i){const o=new Set;this.doDeregisterConfigurations(i,o),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const s=new Set;this.doDeregisterConfigurations(o,s),this.doRegisterConfigurations(i,!1,s),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(i){const o=new Set;this.doRegisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,o){const s=[];for(const{overrides:l,source:r}of i)for(const m in l)if(o.add(m),e.OVERRIDE_PROPERTY_REGEX.test(m)){const n=this.configurationDefaultsOverrides.get(m),t=n?.valuesSources??new Map;if(r)for(const M of Object.keys(l[m]))t.set(M,r);const c={...n?.value||{},...l[m]};this.configurationDefaultsOverrides.set(m,{source:r,value:c,valuesSources:t});const E=(0,_.getLanguageTagSettingPlainKey)(m),y={type:"object",default:c,description:A.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:u.isString(r)?void 0:r,defaultValueSource:r};s.push(...f(m)),this.configurationProperties[m]=y,this.defaultLanguageConfigurationOverridesNode.properties[m]=y}else{this.configurationDefaultsOverrides.set(m,{value:l[m],source:r});const n=this.configurationProperties[m];n&&(this.updatePropertyDefaultValue(m,n),this.updateSchema(m,n))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(i){const o=new Set;this.doDeregisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,o){for(const{overrides:s,source:l}of i)for(const r in s){const m=this.configurationDefaultsOverrides.get(r),n=u.isString(l)?l:l?.id,t=u.isString(m?.source)?m?.source:m?.source?.id;if(n===t)if(o.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const c=this.configurationProperties[r];c&&(this.updatePropertyDefaultValue(r,c),this.updateSchema(r,c))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let o=!1;const s=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,s),o=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,s),o=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,s),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o,s){i.forEach(l=>{this.validateAndRegisterProperties(l,o,l.extensionInfo,l.restrictedProperties,void 0,s),this.configurationContributors.push(l),this.registerJSONConfiguration(l)})}doDeregisterConfigurations(i,o){const s=l=>{if(l.properties)for(const r in l.properties){o.add(r);const m=this.configurationProperties[r];m?.policy?.name&&this.policyConfigurations.delete(m.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,l.properties[r])}l.allOf?.forEach(r=>s(r))};for(const l of i){s(l);const r=this.configurationContributors.indexOf(l);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(i,o=!0,s,l,r=3,m){r=u.isUndefinedOrNull(i.scope)?r:i.scope;const n=i.properties;if(n)for(const c in n){const E=n[c];if(o&&v(c,E)){delete n[c];continue}if(E.source=s,E.defaultDefaultValue=n[c].default,this.updatePropertyDefaultValue(c,E),e.OVERRIDE_PROPERTY_REGEX.test(c)?E.scope=void 0:(E.scope=u.isUndefinedOrNull(E.scope)?r:E.scope,E.restricted=u.isUndefinedOrNull(E.restricted)?!!l?.includes(c):E.restricted),n[c].hasOwnProperty("included")&&!n[c].included){this.excludedConfigurationProperties[c]=n[c],delete n[c];continue}else this.configurationProperties[c]=n[c],n[c].policy?.name&&this.policyConfigurations.set(n[c].policy.name,c);!n[c].deprecationMessage&&n[c].markdownDeprecationMessage&&(n[c].deprecationMessage=n[c].markdownDeprecationMessage),m.add(c)}const t=i.allOf;if(t)for(const c of t)this.validateAndRegisterProperties(c,o,s,l,r,m)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=s=>{const l=s.properties;if(l)for(const m in l)this.updateSchema(m,l[m]);s.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}registerOverridePropertyPatternKey(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const s=this.configurationDefaultsOverrides.get(i);let l=s?.value,r=s?.source;u.isUndefined(l)&&(l=o.defaultDefaultValue,r=void 0),u.isUndefined(l)&&(l=h(o.type)),o.default=l,o.defaultValueSource=r}}const k="\\[([^\\]]+)\\]",w=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(p){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let o=w.exec(p);for(;o?.length;){const s=o[1].trim();s&&i.push(s),o=w.exec(p)}}return(0,a.distinct)(i)}e.overrideIdentifiersFromKey=f;function d(p){return p.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=d;function h(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const g=new b;S.Registry.add(e.Extensions.Configuration,g);function v(p,i){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?A.localize(7,null,p):g.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,p,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.validateProperty=v;function C(){const p=[],i=g.getConfigurationProperties();for(const o of Object.keys(i))p.push([o,i[o].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=C}),define(_e[210],ye([1,0,16,3,146,6,28,23,9,2,53,127,39]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function k(o){return Object.isFrozen(o)?o:T.deepFreeze(o)}class w{constructor(s={},l=[],r=[],m){this._contents=s,this._keys=l,this._overrides=r,this.raw=m,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(l=>{if(l instanceof w)return l;const r=new f("");return r.parseRaw(l),r.configurationModel});this._rawConfiguration=s.reduce((l,r)=>r===l?r:l.merge(r),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,R.getConfigurationValue)(this.contents,s):this.contents}inspect(s,l){const r=this.rawConfiguration.getValue(s),m=l?this.rawConfiguration.getOverrideValue(s,l):void 0,n=l?this.rawConfiguration.override(l).getValue(s):r;return{value:r,override:m,merged:n}}getOverrideValue(s,l){const r=this.getContentsForOverrideIdentifer(l);return r?s?(0,R.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const l=[];for(const r of this.overrides)r.identifiers.includes(s)&&l.push(...r.keys);return a.distinct(l)}getAllOverrideIdentifiers(){const s=[];for(const l of this.overrides)s.push(...l.identifiers);return a.distinct(s)}override(s){let l=this.overrideConfigurations.get(s);return l||(l=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,l)),l}merge(...s){const l=T.deepClone(this.contents),r=T.deepClone(this.overrides),m=[...this.keys],n=this.raw?.length?[...this.raw]:[this];for(const t of s)if(n.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.mergeContents(l,t.contents);for(const c of t.overrides){const[E]=r.filter(y=>a.equals(y.identifiers,c.identifiers));E?(this.mergeContents(E.contents,c.contents),E.keys.push(...c.keys),E.keys=a.distinct(E.keys)):r.push(T.deepClone(c))}for(const c of t.keys)m.indexOf(c)===-1&&m.push(c)}return new w(l,m,r,n.every(t=>t instanceof w)?void 0:n)}createOverrideConfigurationModel(s){const l=this.getContentsForOverrideIdentifer(s);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const r={};for(const m of a.distinct([...Object.keys(this.contents),...Object.keys(l)])){let n=this.contents[m];const t=l[m];t&&(typeof n=="object"&&typeof t=="object"?(n=T.deepClone(n),this.mergeContents(n,t)):n=t),r[m]=n}return new w(r,this.keys,this.overrides)}mergeContents(s,l){for(const r of Object.keys(l)){if(r in s&&S.isObject(s[r])&&S.isObject(l[r])){this.mergeContents(s[r],l[r]);continue}s[r]=T.deepClone(l[r])}}getContentsForOverrideIdentifer(s){let l=null,r=null;const m=n=>{n&&(r?this.mergeContents(r,n):r=T.deepClone(n))};for(const n of this.overrides)a.equals(n.identifiers,[s])?l=n.contents:n.identifiers.includes(s)&&m(n.contents);return m(l),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,l){this.updateValue(s,l,!0)}setValue(s,l){this.updateValue(s,l,!1)}removeValue(s){const l=this.keys.indexOf(s);l!==-1&&(this.keys.splice(l,1),(0,R.removeFromValueTree)(this.contents,s),I.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>a.equals(r.identifiers,(0,I.overrideIdentifiersFromKey)(s))),1))}updateValue(s,l,r){(0,R.addToValueTree)(this.contents,s,l,m=>console.error(m)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),I.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,R.toValuesTree)(this.contents[s],m=>console.error(m))})}}e.ConfigurationModel=w;class f{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,l){if(!S.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,l)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,l){this._raw=s;const{contents:r,keys:m,overrides:n,restricted:t,hasExcludedProperties:c}=this.doParseRaw(s,l);this._configurationModel=new w(r,m,n,c?[s]:void 0),this._restrictedConfigurations=t||[]}doParseContent(s){let l={},r=null,m=[];const n=[],t=[];function c(y){Array.isArray(m)?m.push(y):r!==null&&(m[r]=y)}const E={onObjectBegin:()=>{const y={};c(y),n.push(m),m=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{m=n.pop()},onArrayBegin:()=>{const y=[];c(y),n.push(m),m=y,r=null},onArrayEnd:()=>{m=n.pop()},onLiteralValue:c,onError:(y,M,j)=>{t.push({error:y,offset:M,length:j})}};if(s)try{u.visit(s,E),l=m[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return l}doParseRaw(s,l){const r=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),m=this.filter(s,r,!0,l);s=m.raw;const n=(0,R.toValuesTree)(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),t=Object.keys(s),c=this.toOverrides(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:n,keys:t,overrides:c,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}filter(s,l,r,m){let n=!1;if(!m?.scopes&&!m?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:n};const t={},c=[];for(const E in s)if(I.OVERRIDE_PROPERTY_REGEX.test(E)&&r){const y=this.filter(s[E],l,!1,m);t[E]=y.raw,n=n||y.hasExcludedProperties,c.push(...y.restricted)}else{const y=l[E],M=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&c.push(E),(M===void 0||m.scopes===void 0||m.scopes.includes(M))&&!(m.skipRestricted&&y?.restricted)?t[E]=s[E]:n=!0}return{raw:t,restricted:c,hasExcludedProperties:n}}toOverrides(s,l){const r=[];for(const m of Object.keys(s))if(I.OVERRIDE_PROPERTY_REGEX.test(m)){const n={};for(const t in s[m])n[t]=s[m][t];r.push({identifiers:(0,I.overrideIdentifiersFromKey)(m),keys:Object.keys(n),contents:(0,R.toValuesTree)(n,l)})}return r}}e.ConfigurationModelParser=f;class d extends A.Disposable{constructor(s,l,r,m){super(),this.userSettingsResource=s,this.scopes=l,this.fileService=m,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.any(P.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource)),P.Event.filter(this.fileService.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&r.isEqual(n.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class h{constructor(s,l,r,m,n,t,c,E,y,M,j,$,N){this.key=s,this.overrides=l,this._value=r,this.overrideIdentifiers=m,this.defaultConfiguration=n,this.policyConfiguration=t,this.applicationConfiguration=c,this.userConfiguration=E,this.localUserConfiguration=y,this.remoteUserConfiguration=M,this.workspaceConfiguration=j,this.folderConfigurationModel=$,this.memoryConfigurationModel=N}get value(){return k(this._value)}inspect(s,l,r){const m=s.inspect(l,r);return{get value(){return k(m.value)},get override(){return k(m.override)},get merged(){return k(m.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class g{constructor(s,l,r,m,n=new w,t=new w,c=new _.ResourceMap,E=new w,y=new _.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=l,this._applicationConfiguration=r,this._localUserConfiguration=m,this._remoteUserConfiguration=n,this._workspaceConfiguration=t,this._folderConfigurations=c,this._memoryConfiguration=E,this._memoryConfigurationByResource=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(s,l,r){return this.getConsolidatedConfigurationModel(s,l,r).getValue(s)}updateValue(s,l,r={}){let m;r.resource?(m=this._memoryConfigurationByResource.get(r.resource),m||(m=new w,this._memoryConfigurationByResource.set(r.resource,m))):m=this._memoryConfiguration,l===void 0?m.removeValue(s):m.setValue(s,l),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,l,r){const m=this.getConsolidatedConfigurationModel(s,l,r),n=this.getFolderConfigurationModelForResource(l.resource,r),t=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,c=new Set;for(const E of m.overrides)for(const y of E.identifiers)m.getOverrideValue(s,y)!==void 0&&c.add(y);return new h(s,l,m.getValue(s),c.size?[...c]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,n||void 0,t)}keys(s){const l=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,l){this._folderConfigurations.set(s,l),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,l){const r=[];if(!l){const{added:m,updated:n,removed:t}=p(this._defaultConfiguration,s);l=[...m,...n,...t]}for(const m of l)for(const n of(0,I.overrideIdentifiersFromKey)(m)){const t=this._defaultConfiguration.getKeysForOverrideIdentifier(n),c=s.getKeysForOverrideIdentifier(n),E=[...c.filter(y=>t.indexOf(y)===-1),...t.filter(y=>c.indexOf(y)===-1),...t.filter(y=>!T.equals(this._defaultConfiguration.override(n).getValue(y),s.override(n).getValue(y)))];r.push([n,E])}return this.updateDefaultConfiguration(s),{keys:l,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:l,updated:r,removed:m}=p(this._policyConfiguration,s),n=[...l,...r,...m];return n.length&&this.updatePolicyConfiguration(s),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:l,updated:r,removed:m,overrides:n}=p(this.applicationConfiguration,s),t=[...l,...r,...m];return t.length&&this.updateApplicationConfiguration(s),{keys:t,overrides:n}}compareAndUpdateLocalUserConfiguration(s){const{added:l,updated:r,removed:m,overrides:n}=p(this.localUserConfiguration,s),t=[...l,...r,...m];return t.length&&this.updateLocalUserConfiguration(s),{keys:t,overrides:n}}compareAndUpdateRemoteUserConfiguration(s){const{added:l,updated:r,removed:m,overrides:n}=p(this.remoteUserConfiguration,s),t=[...l,...r,...m];return t.length&&this.updateRemoteUserConfiguration(s),{keys:t,overrides:n}}compareAndUpdateWorkspaceConfiguration(s){const{added:l,updated:r,removed:m,overrides:n}=p(this.workspaceConfiguration,s),t=[...l,...r,...m];return t.length&&this.updateWorkspaceConfiguration(s),{keys:t,overrides:n}}compareAndUpdateFolderConfiguration(s,l){const r=this.folderConfigurations.get(s),{added:m,updated:n,removed:t,overrides:c}=p(r,l),E=[...m,...n,...t];return(E.length||!r)&&this.updateFolderConfiguration(s,l),{keys:E,overrides:c}}compareAndDeleteFolderConfiguration(s){const l=this.folderConfigurations.get(s);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:m,removed:n,overrides:t}=p(l,void 0);return{keys:[...r,...m,...n],overrides:t}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,l,r){let m=this.getConsolidatedConfigurationModelForResource(l,r);return l.overrideIdentifier&&(m=m.override(l.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(m=m.merge(this._policyConfiguration)),m}getConsolidatedConfigurationModelForResource({resource:s},l){let r=this.getWorkspaceConsolidatedConfiguration();if(l&&s){const m=l.getFolder(s);m&&(r=this.getFolderConsolidatedConfiguration(m.uri)||r);const n=this._memoryConfigurationByResource.get(s);n&&(r=r.merge(n))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let l=this._foldersConsolidatedConfigurations.get(s);if(!l){const r=this.getWorkspaceConsolidatedConfiguration(),m=this._folderConfigurations.get(s);m?(l=r.merge(m),this._foldersConsolidatedConfigurations.set(s,l)):l=r}return l}getFolderConfigurationModelForResource(s,l){if(l&&s){const r=l.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,l)=>{const{contents:r,overrides:m,keys:n}=this._folderConfigurations.get(l);return s.push([l,{contents:r,overrides:m,keys:n}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(l=>s.add(l)),this.userConfiguration.keys.forEach(l=>s.add(l)),this._workspaceConfiguration.keys.forEach(l=>s.add(l)),this._folderConfigurations.forEach(l=>l.keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this._folderConfigurations.forEach(l=>l.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>l.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>l.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>l.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(m=>l.add(m))),[...l.values()]}static parse(s){const l=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.policy),m=this.parseConfigurationModel(s.application),n=this.parseConfigurationModel(s.user),t=this.parseConfigurationModel(s.workspace),c=s.folders.reduce((E,y)=>(E.set(D.URI.revive(y[0]),this.parseConfigurationModel(y[1])),E),new _.ResourceMap);return new g(l,r,m,n,new w,t,c,new w,new _.ResourceMap)}static parseConfigurationModel(s){return new w(s.contents,s.keys,s.overrides)}}e.Configuration=g;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,l=new Map;for(const m of o)m.keys.forEach(n=>s.add(n)),m.overrides.forEach(([n,t])=>{const c=(0,_.getOrSet)(l,n,new Set);t.forEach(E=>c.add(E))});const r=[];return l.forEach((m,n)=>r.push([n,[...m.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=v;class C{constructor(s,l,r,m){this.change=s,this.previous=l,this.currentConfiguraiton=r,this.currentWorkspace=m,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const n of s.keys)this.affectedKeys.add(n);for(const[,n]of s.overrides)for(const t of n)this.affectedKeys.add(t);this._affectsConfigStr=this._marker;for(const n of this.affectedKeys)this._affectsConfigStr+=n+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,l){const r=this._marker+s,m=this._affectsConfigStr.indexOf(r);if(m<0)return!1;const n=m+r.length;if(n>=this._affectsConfigStr.length)return!1;const t=this._affectsConfigStr.charCodeAt(n);if(t!==this._markerCode1&&t!==this._markerCode2)return!1;if(l){const c=this.previousConfiguration?this.previousConfiguration.getValue(s,l,this.previous?.workspace):void 0,E=this.currentConfiguraiton.getValue(s,l,this.currentWorkspace);return!T.equals(c,E)}return!0}}e.ConfigurationChangeEvent=C;function p(o,s){const{added:l,removed:r,updated:m}=i(s?.rawConfiguration,o?.rawConfiguration),n=[],t=o?.getAllOverrideIdentifiers()||[],c=s?.getAllOverrideIdentifiers()||[];if(s){const E=c.filter(y=>!t.includes(y));for(const y of E)n.push([y,s.getKeysForOverrideIdentifier(y)])}if(o){const E=t.filter(y=>!c.includes(y));for(const y of E)n.push([y,o.getKeysForOverrideIdentifier(y)])}if(s&&o){for(const E of t)if(c.includes(E)){const y=i({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)});n.push([E,[...y.added,...y.removed,...y.updated]])}}return{added:l,removed:r,updated:m,overrides:n}}function i(o,s){const l=o?s?o.keys.filter(n=>s.keys.indexOf(n)===-1):[...o.keys]:[],r=s?o?s.keys.filter(n=>o.keys.indexOf(n)===-1):[...s.keys]:[],m=[];if(o&&s){for(const n of s.keys)if(o.keys.indexOf(n)!==-1){const t=(0,R.getConfigurationValue)(s.contents,n),c=(0,R.getConfigurationValue)(o.contents,n);T.equals(t,c)||m.push(n)}}return{added:l,removed:r,updated:m}}}),define(_e[128],ye([1,0,11,4]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,P.createDecorator)("remoteAuthorityResolverService");var u;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(u=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends a.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof A&&S._code===u.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof A&&S._code===u.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof A&&S._code===u.NoResolverFound}static isHandled(S){return S instanceof A&&S.isHandled}constructor(S,D=u.Unknown,R){super(S),this._message=S,this._code=D,this._detail=R,this.isHandled=D===u.NotAvailable&&R===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function _(T){const S=T.indexOf("+");return S===-1?T:T.substring(0,S)}e.getRemoteAuthorityPrefix=_}),define(_e[73],ye([1,0,14]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function P(D){return D.scheme===a.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=P;function u(D){if(!D)return;const R=D.indexOf("+");return R<0?D:D.substr(0,R)}e.getRemoteName=u;function A(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=A;function _(D){const{host:R,port:I}=S(D);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.parseAuthorityWithPort=_;function T(D,R){let{host:I,port:b}=S(D);return typeof b>"u"&&(b=R),{host:I,port:b}}e.parseAuthorityWithOptionalPort=T;function S(D){const R=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=D.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const b=D.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:D,port:void 0}}}),define(_e[26],ye([1,0,8,4,73]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=A;function _(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,d){if(typeof f>"u"||f===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof f=="string"||typeof d=="string"){const h=typeof f=="string"?f:f.value,g=typeof d=="string"?d:d.value;return a.equalsIgnoreCase(h,g)}return f._lower===d._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=D;function R(w){return I(w)}e.isApplicationScopedExtension=R;function I(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function b(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function k(w,f){if(f){const d=`onResolveRemoteAuthority:${(0,u.getRemoteName)(f)}`;return w.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(_e[211],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.validators=new Map}vsda(){return new Promise((u,A)=>ie(["vsda"],u,A))}async createNewMessage(u){try{const A=await this.vsda(),_=new A.validator;if(_){const T=String(a._nextId++);return this.validators.set(T,_),{id:T,data:_.createNewMessage(u)}}}catch{}return{id:"",data:u}}async validate(u,A){if(!u.id)return!0;const _=this.validators.get(u.id);if(!_)return!1;this.validators.delete(u.id);try{return _.validate(A)==="ok"}catch{return!1}}async sign(u){try{const A=await this.vsda(),_=new A.signer;if(_)return _.sign(u)}catch{}return u}}a._nextId=1,e.SignService=a}),define(_e[212],ye([1,0,12,33,2,30]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(D){if(a.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function T(D,R,I,b,k,w,f,d,h,g){const v=Object.create(null);v["common.machineId"]=f,v.sessionID=(0,A.generateUuid)()+Date.now(),v.commitHash=k,v.version=w,v["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,a.PlatformToString)(a.platform),v["common.nodePlatform"]=P.platform,v["common.nodeArch"]=b,v["common.product"]=g||"desktop",d&&(v["common.msftInternal"]=d);let C=0;const p=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>C++,enumerable:!0}}),a.isLinuxSnap&&(v["common.snap"]="true");const i=_(I);i&&(v["common.platformDetail"]=i);try{const o=await D.readFile(u.URI.file(h));v["common.source"]=o.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=T;function S(D){const R=P.env.USERDNSDOMAIN;if(!R)return!1;const I=R.toLowerCase();return D.some(b=>I===b)}e.verifyMicrosoftInternalDomain=S}),define(_e[213],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(P=e.TelemetryLevel||(e.TelemetryLevel={}));var u;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(u=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(_e[74],ye([1,0,23,9,3,53,73,212,213]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class D{constructor(n){this.value=n}}e.TelemetryTrustedValue=D;class R{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,t){return Promise.resolve(void 0)}publicLog2(n,t){return this.publicLog(n,t)}publicLogError(n,t){return Promise.resolve(void 0)}publicLogError2(n,t){return this.publicLogError(n,t)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class I{async publicLog(n,t,c){}async publicLogError(n,t,c){}}e.NullEndpointTelemetryService=I,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(m,n){return u.Event.debounce(n.onDidChangeConfiguration,(c,E)=>{const y=c?new Set([...c.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:y}},1e3,!0)(c=>{c.source!==7&&m.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(c.source),configurationKeys:C(c.affectedKeys)})})}e.configurationTelemetry=b;function k(m,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!m.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=k;function w(m,n){return!(n.isBuilt||n.disableTelemetry||m.enableTelemetry&&m.aiConfig?.ariaKey)}e.isLoggingOnly=w;function f(m){const n=m.getValue(S.TELEMETRY_SETTING_ID),t=m.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(m.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function d(m){const n={},t={},c={};v(m,c);for(let E in c){E=E.length>150?E.substr(E.length-149):E;const y=c[E];typeof y=="number"?t[E]=y:typeof y=="boolean"?t[E]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${y.length}`),n[E]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(n[E]=y)}return{properties:n,measurements:t}}e.validateTelemetryData=d;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(m){if(!m)return"none";const n=(0,_.getRemoteName)(m);return h.has(n)?n:"other"}e.cleanRemoteAuthority=g;function v(m,n,t=0,c){if(!!m)for(const E of Object.getOwnPropertyNames(m)){const y=m[E],M=c?c+E:E;Array.isArray(y)?n[M]=(0,a.safeStringify)(y):y instanceof Date?n[M]=y.toISOString():(0,P.isObject)(y)?t<2?v(y,n,t+1,M+"."):n[M]=(0,a.safeStringify)(y):n[M]=y}}function C(m){if(!m)return[];const n=[];return p(n,"",m),n}function p(m,n,t){t&&typeof t=="object"&&!Array.isArray(t)?Object.keys(t).forEach(c=>p(m,n?`${n}.${c}`:c,t[c])):m.push(n)}function i(m,n){const t=m.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(t)||c}e.isInternalTelemetry=i;function o(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=o;function s(m,n){if(!m||!m.includes("/")&&!m.includes("\\"))return m;let t=m;const c=[];for(const j of n)for(;;){const $=j.exec(m);if(!$)break;c.push([$.index,j.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(t="";;){const j=y.exec(m);if(!j)break;const $=c.some(([N,x])=>j.index<x&&N<y.lastIndex);!E.test(j[0])&&!$&&(t+=m.substring(M,j.index)+"<REDACTED: user-file-path>",M=y.lastIndex)}return M<m.length&&(t+=m.substr(M)),t}function l(m){if(!m)return m;const n=m.toLowerCase(),t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of t)if(c.regex.test(n))return`<REDACTED: ${c.label}>`;return m}function r(m,n){return(0,a.cloneAndChange)(m,t=>{if(t instanceof D)return t.value;if(typeof t=="string"){let c=t.replaceAll("%20"," ");c=s(c,n);for(const E of n)c=c.replace(E,"");return c=l(c),c}})}e.cleanData=r}),define(_e[214],ye([1,0,8,123,26,12,2,11,33,74]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(s,l){return s.uuid&&l.uuid?s.uuid===l.uuid:s.id===l.id?!0:(0,a.compareIgnoreCase)(s.id,l.id)===0}e.areSameExtensions=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(l){const r=l.manifest?l.manifest.version:l.version,m=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new b(l.identifier,r,m)}static parse(l){const r=I.exec(l);return r&&r[1]&&r[2]?new b({id:r[1]},r[2],r[4]||void 0):null}constructor(l,r,m="undefined"){this.version=r,this.targetPlatform=m,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof b?R(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=b;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(s){const l=k.exec(s);return l&&l[1]?[d(l[1]),l[2]]:[d(s),void 0]}e.getIdAndVersion=w;function f(s,l){return`${s}.${l}`}e.getExtensionId=f;function d(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function h(s,l){return d(f(s,l))}e.getGalleryExtensionId=h;function g(s,l){const r=[],m=n=>{for(const t of r)if(t.some(c=>R(l(c),l(n))))return t;return null};for(const n of s){const t=m(n);t?t.push(n):r.push([n])}return r}e.groupByExtension=g;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function C(s){return{id:new D.TelemetryTrustedValue(s.identifier.id),name:new D.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new u.ExtensionIdentifier("pprice.better-merge");function p(s,l){const r=[],m=l.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const n=m.shift();if(n&&r.every(t=>!R(t.identifier,{id:n}))){const t=s.filter(c=>R(c.identifier,{id:n}));t.length===1&&(r.push(t[0]),m.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=p;async function i(s,l){if(!A.isLinux)return!1;let r;try{r=(await s.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){l.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(n))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function o(s,l){const r=await i(s,l),m=(0,P.getTargetPlatform)(r?"alpine":A.platform,S.arch);return l.debug("ComputeTargetPlatform:",m),m}e.computeTargetPlatform=o}),define(_e[215],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=a;function P(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=P;function u(_){return Array.from(_.entries()).map(T=>[T[0],a(T[1].map)])}e.serializeEnvironmentVariableCollections=u;function A(_){return new Map(_.map(T=>[T[0],{map:P(T[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(_e[216],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(u){this._callback=u,this._terminalBufferMap=new Map}dispose(){for(const u of this._terminalBufferMap.values())u.dispose()}startBuffering(u,A,_=5){const T=A(S=>{const D=typeof S=="string"?S:S.data;let R=this._terminalBufferMap.get(u);if(R){R.data.push(D);return}const I=setTimeout(()=>this.flushBuffer(u),_);R={data:[D],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(u),T.dispose()}},this._terminalBufferMap.set(u,R)});return T}stopBuffering(u){this._terminalBufferMap.get(u)?.dispose()}flushBuffer(u){const A=this._terminalBufferMap.get(u);A&&(this._terminalBufferMap.delete(u),this._callback(u,A.data.join("")))}}e.TerminalDataBufferer=a}),define(_e[217],ye([1,0,19,67,51,3,9,2,175,91,39]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var I;(function(C){function p(i,o){let s=i.defaults;for(;u.ThemeIcon.isThemeIcon(s);){const l=w.getIcon(s.id);if(!l)return;s=l.defaults}return s}C.getDefinition=p})(I=e.IconContribution||(e.IconContribution={}));var b;(function(C){function p(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}C.toJSONObject=p;function i(o){const s=l=>(0,_.isString)(l)?l:void 0;if(o&&Array.isArray(o.src)&&o.src.every(l=>(0,_.isString)(l.format)&&(0,_.isString)(l.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(l=>({format:l.format,location:T.URI.parse(l.location)}))}}C.fromJSONObject=i})(b=e.IconFontDefinition||(e.IconFontDefinition={}));class k{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${u.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,i,o,s){const l=this.iconsById[p];if(l){if(o&&!l.description){l.description=o,this.iconSchema.properties[p].markdownDescription=`${o} $(${p})`;const n=this.iconReferenceSchema.enum.indexOf(p);n!==-1&&(this.iconReferenceSchema.enumDescriptions[n]=o),this._onDidChange.fire()}return l}const r={id:p,description:o,defaults:i,deprecationMessage:s};this.iconsById[p]=r;const m={$ref:"#/definitions/icons"};return s&&(m.deprecationMessage=s),o&&(m.markdownDescription=`${o}: $(${p})`),this.iconSchema.properties[p]=m,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const i=this.iconReferenceSchema.enum.indexOf(p);i!==-1&&(this.iconReferenceSchema.enum.splice(i,1),this.iconReferenceSchema.enumDescriptions.splice(i,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,i){const o=this.iconFontsById[p];return o||(this.iconFontsById[p]=i,this._onDidChange.fire(),i)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(l,r)=>l.id.localeCompare(r.id),i=l=>{for(;u.ThemeIcon.isThemeIcon(l.defaults);)l=this.iconsById[l.defaults.id];return`codicon codicon-${l?l.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(l=>this.iconsById[l]);for(const l of s.filter(r=>!!r.description).sort(p))o.push(`|<i class="${i(l)}"></i>|${l.id}|${u.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const l of s.filter(r=>!u.ThemeIcon.isThemeIcon(r.defaults)).sort(p))o.push(`|<i class="${i(l)}"></i>|${l.id}|`);return o.join(`
`)}}const w=new k;R.Registry.add(e.Extensions.IconContribution,w);function f(C,p,i,o){return w.registerIcon(C,p,i,o)}e.registerIcon=f;function d(){return w}e.getIconRegistry=d;function h(){const C=(0,P.getCodiconFontCharacters)();for(const p in C){const i="\\"+C[p].toString(16);w.registerIcon(p,{fontCharacter:i})}}h(),e.iconsSchemaId="vscode://schemas/icons";const g=R.Registry.as(D.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,w.getIconSchema());const v=new a.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);w.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=f("widget-close",P.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",P.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",P.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=u.ThemeIcon.modify(P.Codicon.sync,"spin"),e.spinningLoading=u.ThemeIcon.modify(P.Codicon.loading,"spin")}),define(_e[129],ye([1,0,3,53,4,13]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,u.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,u.createDecorator)("sharedTunnelsService");var _;(function(f){f.Http="http",f.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=I;function b(f,d,h,g){if(h===1)return!1;if(h===2&&I(d)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(v?.length===4&&parseInt(v[1])>=18)return!1}return f<1024}e.isPortPrivileged=b;class k{constructor(d,h,g){this.remoteAddress=d,this.localAddress=h,this._dispose=g,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=k;let w=class{constructor(d,h){this.logService=d,this.configurationService=h,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],h=Array.from(this._tunnels.values());for(const g of h){const v=Array.from(g.values());for(const C of v){const p=await C.value;p&&d.push(p)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:h}of d.values())await h.then(g=>g?.dispose());d.clear()}this._tunnels.clear()}setEnvironmentTunnel(d,h,g,v,C){this.addTunnelToMap(d,h,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:h,localAddress:g,privacy:v,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,h){(I(d)||R(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const g=this.getTunnelFromMap(d,h);if(g)return++g.refcount,g.value}openTunnel(d,h,g,v,C,p=!1,i,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${g} on local port ${C}.`),!d)return;if(h||(h="localhost"),v||(v=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(d,h,g,v,C,p,i,o);return s?s.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(l);return(l.tunnelRemoteHost!==h||l.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const h=this._tunnels.get(d.tunnelRemoteHost);if(h){const g=h.get(d.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,g))}}}}async tryDisposeTunnel(d,h,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${h}.`);const v=g.value.then(async C=>{C&&(await C.dispose(!0),this._onTunnelClosed.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(h),v}}async closeTunnel(d,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${h} `);const g=this._tunnels.get(d);if(g&&g.has(h)){const v=g.get(h);v.refcount=0,await this.tryDisposeTunnel(d,h,v)}}addTunnelToMap(d,h,g){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(h,{refcount:1,value:g})}async removeEmptyTunnelFromMap(d,h){const g=this._tunnels.get(d);g&&(await g.get(h)||g.delete(h),g.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,h){const g=[d];R(d)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):I(d)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const v=g.map(C=>this._tunnels.get(C));for(const C of v){const p=C?.get(h);if(p)return p}}canTunnel(d){return!!D(d)}createWithProvider(d,h,g,v,C,p,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${g} on local port ${v}.`);const o=g;this._factoryInProgress.add(o);const s=v===void 0?g:v,l={elevationRequired:C?this.isPortPrivileged(s):!1},r={remoteAddress:{host:h,port:g},localAddressPort:v,privacy:p,public:p?p!==T.Private:void 0,protocol:i},m=d.forwardPort(r,l);return m?(this.addTunnelToMap(h,g,m),m.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),m}};w=Ve([We(0,A.ILogService),We(1,P.IConfigurationService)],w),e.AbstractTunnelService=w}),define(_e[218],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var P;(function(u){u[u.Complete=100]="Complete",u[u.Partial=50]="Partial",u[u.None=0]="None"})(P=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(_e[219],ye([1,0,14]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function P(S){return S.scheme!==a.Schemas.file&&S.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=P;function u(S){if(S.folders.length)return S.folders.every(D=>P(D.uri))?S.folders[0].uri:void 0;if(S.configuration&&P(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=u;function A(S){return u(S)?.scheme}e.getVirtualWorkspaceScheme=A;function _(S){return u(S)?.authority}e.getVirtualWorkspaceAuthority=_;function T(S){return u(S)!==void 0}e.isVirtualWorkspace=T}),define(_e[47],ye([1,0,176,10,68,24,2,4,14]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function D(s){const l=s;return typeof l?.id=="string"&&_.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=D;function R(s){return typeof s?.id=="string"&&!D(s)&&!b(s)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(s,l){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,P.basename)(s)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=I;function b(s){const l=s;return typeof l?.id=="string"&&_.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=b;function k(s){const l=s;if(l?.uri)return{id:l.id,uri:_.URI.revive(l.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=k;var w;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function f(s){const l=s;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=f;function d(s){const l=s;return!!(l&&typeof l=="object"&&_.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=d;class h{constructor(l,r,m,n,t){this._id=l,this._transient=m,this._configuration=n,this._ignorePathCasing=t,this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l)||null}updateFoldersMap(){this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class g{constructor(l,r){this.raw=r,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,A.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function v(s){return new g({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(s,l){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,l.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function p(s){let l;return _.URI.isUri(s)?l=s:l=s.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=p;function i(s,l){return!C(s,l)&&!p(s)}e.isSavedWorkspace=i;function o(s){return(typeof s=="string"?(0,P.extname)(s):(0,A.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(_e[75],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(u){this.id=u,this._data=new Map,this._idPool=1}add(u){const A=this._idPool++;return this._data.set(A,u),this.logDebugInfo(),A}get(u,A){return this._data.has(u)?this._data.get(u)[A]:void 0}delete(u){this._data.delete(u),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}a.enableDebugLogging=!1,e.Cache=a}),define(_e[48],ye([1,0,14,24,4]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new P.ExtUri(T=>{const S=this._providerInfo.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this._providerInfo.delete(T.scheme):this._providerInfo.set(T.scheme,S)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,u.createDecorator)("IExtHostFileSystemInfo")}),define(_e[25],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(_e[220],ye([1,0,13,205,25]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends P.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:S.logName}))}};A=Ve([We(0,a.ILoggerService),We(1,u.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(_e[221],ye([1,0,19]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class P{constructor(_,T,S){this._deferredPromises=new Map,this._id=_,this._shared=T,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of D.values())R.complete()}catch(R){for(const I of D.values())I.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,T){let S=this._value[_];return typeof S>"u"&&(S=T),S}update(_,T){this._value[_]=T;const S=this._deferredPromises.get(_);if(S!==void 0)return S.p;const D=new a.DeferredPromise;return this._deferredPromises.set(_,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=P;class u extends P{setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}constructor(_,T){super(_.identifier.value,!0,T),this._extension=_}}e.ExtensionGlobalMemento=u}),define(_e[222],ye([1,0,3,2]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class u{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new a.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,T,S,D){const I=this._notebooksAndEditors.getNotebookDocument(P.URI.revive(_)).acceptModelChanged(T.value,S,D);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(_,T){this._notebooksAndEditors.getNotebookDocument(P.URI.revive(_)).acceptDirty(T)}$acceptModelSaved(_){const T=this._notebooksAndEditors.getNotebookDocument(P.URI.revive(_));this._onDidSaveNotebookDocument.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=u}),define(_e[20],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class P{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=P});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[223],ye([1,0,26,3]),function(ie,e,a,P){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(T,S){u.set(this,void 0),this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(T.identifier),Je(this,u,S,"f"),Ue(this,u,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(T){return Ue(this,u,"f").get(this._id,T)}store(T,S){return Ue(this,u,"f").store(this._id,T,S)}delete(T){return Ue(this,u,"f").delete(this._id,T)}}e.ExtensionSecrets=A,u=new WeakMap}),define(_e[55],ye([1,0,4,129,3,20]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(S){function D(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?P.TunnelPrivacyId.Public:P.TunnelPrivacyId.Private),protocol:I.protocol}}S.fromApiTunnel=D;function R(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==P.TunnelPrivacyId.ConstantPrivate&&I.privacy!==P.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}S.fromServiceTunnel=R})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let T=class{constructor(D){this.onDidChangeTunnels=new u.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,R){}async getTunnels(){return[]}async setTunnelFactory(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,R){return{dispose:()=>{}}}async $providePortAttributes(D,R,I,b,k){return[]}async $forwardPort(D,R){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([We(0,A.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(_e[56],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class P{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=P}),define(_e[224],ye([1,0,22]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(S){let D=this.buffers.indexOf(S);return D<0&&(D=this.buffers.length,this.buffers.push(S)),D}}function u(T,S){if(S.serializeBuffersForPostMessage){const D=new P,R=(k,w)=>{if(w instanceof ArrayBuffer){const f=D.add(w);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(w)){const f=A(w);if(f){const d=D.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:f,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},I=JSON.stringify(T,R),b=D.buffers.map(k=>{const w=new Uint8Array(k);return a.VSBuffer.wrap(w)});return{message:I,buffers:b}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=u;function A(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(T,S){const D=S.map(b=>{const k=new ArrayBuffer(b.byteLength);return new Uint8Array(k).set(b.buffer),k}),R=S.length?(b,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const w=k,{index:f}=w,d=D[f];if(w.view)switch(w.view.type){case 1:return new Int8Array(d,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return k}:void 0;return{message:JSON.parse(T,R),arrayBuffers:D}}e.deserializeWebviewMessage=_}),define(_e[225],ye([1,0,114]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function P(A){return{transformIncoming:_=>_.scheme==="vscode-remote"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="file"?{scheme:"vscode-local",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoing:_=>_.scheme==="file"?{scheme:"vscode-remote",authority:A,path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="vscode-local"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoingScheme:_=>_==="file"?"vscode-remote":_==="vscode-local"?"file":_}}function u(A){return new a.URITransformer(P(A))}e.createURITransformer=u}),define(_e[130],ye([1,0,187,9,2,6,4,39,44,14,45,161,37]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var w;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(w=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(K){const J=K;return!!J&&typeof J.getSelection=="function"&&!!J.onDidChangeSelection}e.isEditorPaneWithSelection=f;function d(K,J,ne){for(const pe of ne.visibleEditorPanes)if(pe.group.id===J&&K.matches(pe.input))return pe.getViewState()}e.findViewStateForEditor=d;function h(K){if(t(K))return!1;const J=K;return u.URI.isUri(J?.resource)}e.isResourceEditorInput=h;function g(K){if(t(K))return!1;const J=K;return J?.original!==void 0&&J.modified!==void 0}e.isResourceDiffEditorInput=g;function v(K){if(t(K)||g(K))return!1;const J=K;return J?.primary!==void 0&&J.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function C(K){if(t(K))return!1;const J=K;return J?J.resource===void 0||J.resource.scheme===D.Schemas.untitled||J.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=C;const p=/Untitled-\d+/;function i(K){return K.scheme===D.Schemas.untitled&&K.path.length>1&&!p.test(K.path)}e.isUntitledWithAssociatedResource=i;function o(K){if(t(K))return!1;const J=K;return u.URI.isUri(J?.base?.resource)&&u.URI.isUri(J?.input1?.resource)&&u.URI.isUri(J?.input2?.resource)&&u.URI.isUri(J?.result?.resource)}e.isResourceMergeEditorInput=o;var s;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var l;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.mapIdToSaveSource=new Map}registerSource(J,ne){let pe=this.mapIdToSaveSource.get(J);return pe||(pe={source:J,label:ne},this.mapIdToSaveSource.set(J,pe)),pe.source}getSourceLabel(J){return this.mapIdToSaveSource.get(J)?.label??J}}e.SaveSourceRegistry=new r;var m;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends A.Disposable{}e.AbstractEditorInput=n;function t(K){return K instanceof n}e.isEditorInput=t;function c(K){const J=K;return u.URI.isUri(J?.preferredResource)}function E(K){const J=K;return t(J?.primary)&&t(J?.secondary)}e.isSideBySideEditorInput=E;function y(K){const J=K;return t(J?.modified)&&t(J?.original)}e.isDiffEditorInput=y;function M(K,J,ne,pe,be){return te(pe,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const Ie={...ne,limits:{size:Number.MAX_VALUE}};K.openEditor(J,Ie)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}e.createTooLargeFileError=M;function j(K){return t(K?.editor)}e.isEditorInputWithOptions=j;function $(K){const J=K;return j(K)&&J?.group!==void 0}e.isEditorInputWithOptionsAndGroup=$;function N(K){const J=K;return typeof J?.groupId=="number"&&t(J.editor)}e.isEditorIdentifier=N;var x;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(x=e.EditorCloseContext||(e.EditorCloseContext={}));var L;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(L=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class U{getOriginalUri(J,ne){if(!J)return;if(o(J))return e.EditorResourceAccessor.getOriginalUri(J.result,ne);if(ne?.supportSideBySide){const{primary:be,secondary:Ie}=this.getSideEditors(J);if(be&&Ie){if(ne?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(Ie,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===F.ANY)return this.getOriginalUri(be,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(Ie,{filterByScheme:ne.filterByScheme});J=ne.supportSideBySide===F.PRIMARY?be:Ie}}if(g(J)||v(J)||o(J))return;const pe=c(J)?J.preferredResource:J.resource;return!pe||!ne||!ne.filterByScheme?pe:this.filterUri(pe,ne.filterByScheme)}getSideEditors(J){return E(J)||v(J)?{primary:J.primary,secondary:J.secondary}:y(J)||g(J)?{primary:J.modified,secondary:J.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(J,ne){if(!J)return;if(o(J))return e.EditorResourceAccessor.getCanonicalUri(J.result,ne);if(ne?.supportSideBySide){const{primary:be,secondary:Ie}=this.getSideEditors(J);if(be&&Ie){if(ne?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(Ie,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===F.ANY)return this.getCanonicalUri(be,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(Ie,{filterByScheme:ne.filterByScheme});J=ne.supportSideBySide===F.PRIMARY?be:Ie}}if(g(J)||v(J)||o(J))return;const pe=J.resource;return!pe||!ne||!ne.filterByScheme?pe:this.filterUri(pe,ne.filterByScheme)}filterUri(J,ne){if(Array.isArray(ne)){if(ne.some(pe=>J.scheme===pe))return J}else if(ne===J.scheme)return J}}e.EditorResourceAccessor=new U;var H;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(H=e.CloseDirection||(e.CloseDirection={}));class de{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(J){const ne=this.instantiationService=J.get(_.IInstantiationService);for(const[pe,be]of this.editorSerializerConstructors)this.createEditorSerializer(pe,be,ne);this.editorSerializerConstructors.clear()}createEditorSerializer(J,ne,pe){const be=pe.createInstance(ne);this.editorSerializerInstances.set(J,be)}registerFileEditorFactory(J){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=J}getFileEditorFactory(){return(0,P.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(J,ne){if(this.editorSerializerConstructors.has(J)||this.editorSerializerInstances.has(J))throw new Error(`A editor serializer with type ID '${J}' was already registered.`);return this.instantiationService?this.createEditorSerializer(J,ne,this.instantiationService):this.editorSerializerConstructors.set(J,ne),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(J),this.editorSerializerInstances.delete(J)})}getEditorSerializer(J){return this.editorSerializerInstances.get(typeof J=="string"?J:J.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new de);async function Y(K,J,ne){return!K||!K.length?[]:await Promise.all(K.map(async pe=>{const be=u.URI.revive(pe.fileUri);if(!be){ne.info("Cannot resolve the path because it is not valid.",pe);return}if(!await J.canHandleResource(be)){ne.info("Cannot resolve the path because it cannot be handled",pe);return}let Le=pe.exists,oe=pe.type;if(typeof Le!="boolean"||typeof oe!="number")try{oe=(await J.stat(be)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Le=!0}catch(fe){ne.error(fe),Le=!1}if(!Le&&pe.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",pe);return}if(oe===S.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",pe);return}const ae={...pe.options,pinned:!0};return Le?{resource:be,options:ae}:{resource:be,options:ae,forceUntitled:!0}}))}e.pathsToEditors=Y;var V;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(V=e.EditorsOrder||(e.EditorsOrder={}));function X(K){const J=K;if(!J)return!1;const ne=J;if(ne.modified)return X(ne.modified);const pe=J;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}e.isTextEditorViewState=X;function Z(K){return(0,R.isErrorWithActions)(K)}e.isEditorOpenError=Z;function te(K,J,ne){const pe=(0,R.createErrorWithActions)(K,J);return pe.forceMessage=ne?.forceMessage,pe.forceSeverity=ne?.forceSeverity,pe.allowDialog=ne?.allowDialog,pe}e.createEditorOpenError=te}),define(_e[226],ye([1,0,3,188,4,6,28,39,16,61,23,67,217]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,b.registerIcon)("default-view-icon",I.Codicon.window,(0,P.localize)(0,null));var k;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(k=e.Extensions||(e.Extensions={}));var w;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function f(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=f;class d extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new a.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new a.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,S.flatten)([...this.viewContainers.values()])}registerViewContainer(l,r,m){const n=this.get(l.id);if(n)return n;const t=l;return t.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:t.openCommandActionDescriptor??{id:t.id},(0,_.getOrSet)(this.viewContainers,r,[]).push(t),m?.isDefault&&this.defaultViewContainers.push(t),this._onDidRegister.fire({viewContainer:t,viewContainerLocation:r}),t}deregisterViewContainer(l){for(const r of this.viewContainers.keys()){const m=this.viewContainers.get(r),n=m?.indexOf(l);if(n!==-1){m?.splice(n,1),m.length===0&&this.viewContainers.delete(r),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:r});return}}}get(l){return this.all.filter(r=>r.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(r=>this.getViewContainers(r).filter(m=>m?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(r=>this.getViewContainerLocation(r)===l)}}T.Registry.add(k.ViewContainersRegistry,new d);var h;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(h=e.ViewContentGroups||(e.ViewContentGroups={}));function g(s,l){const r=s.group??h.More,m=l.group??h.More;return r!==m?r.localeCompare(m):(s.order??5)-(l.order??5)}class v extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new a.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new a.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new a.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new a.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new D.SetMap}registerViews(l,r){this.registerViews2([{views:l,viewContainer:r}])}registerViews2(l){l.forEach(({views:r,viewContainer:m})=>this.addViews(r,m)),this._onViewsRegistered.fire(l)}deregisterViews(l,r){const m=this.removeViews(l,r);m.length&&this._onViewsDeregistered.fire({views:m,viewContainer:r})}moveViews(l,r){for(const m of this._views.keys())if(m!==r){const n=this.removeViews(l,m);n.length&&(this.addViews(n,r),this._onDidChangeContainer.fire({views:n,from:m,to:r}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const r of this._viewContainers){const m=(this._views.get(r)||[]).filter(n=>n.id===l)[0];if(m)return m}return null}getViewContainer(l){for(const r of this._viewContainers)if((this._views.get(r)||[]).filter(n=>n.id===l)[0])return r;return null}registerViewWelcomeContent(l,r){return this._viewWelcomeContents.add(l,r),this._onDidChangeViewWelcomeContent.fire(l),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(l,r),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,r){const m=new Map;for(const[n,t]of r)this._viewWelcomeContents.add(l,t),m.set(n,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(l,t),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),m}getViewWelcomeContent(l){const r=[];return this._viewWelcomeContents.forEach(l,m=>r.push(m)),r.sort(g)}addViews(l,r){let m=this._views.get(r);m||(m=[],this._views.set(r,m),this._viewContainers.push(r));for(const n of l){if(this.getView(n.id)!==null)throw new Error((0,P.localize)(1,null,n.id));m.push(n)}}removeViews(l,r){const m=this._views.get(r);if(!m)return[];const n=[],t=[];for(const c of m)l.includes(c)?n.push(c):t.push(c);return n.length&&(t.length?this._views.set(r,t):(this._views.delete(r),this._viewContainers.splice(this._viewContainers.indexOf(r),1))),n}}T.Registry.add(k.ViewsRegistry,new v),e.IViewsService=(0,u.createDecorator)("viewsService"),e.IViewDescriptorService=(0,u.createDecorator)("viewDescriptorService");var C;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(C=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(l,r){this.resolved=!1,this._hasResolve=!1,(0,R.mixin)(this,l),this._hasResolve=!!r,this.resolve=async m=>{if(r&&!this.resolved){const n=await r(m);n&&(this.tooltip=this.tooltip??n.tooltip,this.command=this.command??n.command)}m.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class o extends Error{constructor(l){super((0,P.localize)(2,null,l))}}e.NoTreeViewError=o}),define(_e[131],ye([1,0,3,19,189]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,S,D,R){const I={command:T};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof R=="number"){const b=setTimeout(()=>{clearTimeout(b);const k=this.pendingRequests.get(I.seq);if(k){this.pendingRequests.delete(I.seq);const w={type:"response",seq:0,request_seq:I.seq,success:!1,command:T,message:(0,u.localize)(0,null,R,T)};k(w)}},R)}return D&&this.pendingRequests.set(I.seq,D),I.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,S){return T.type!=="event"||S.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,P.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback?.(T);break;case"request":this.requestCallback?.(T);break;case"response":{const S=T,D=this.pendingRequests.get(S.request_seq);D&&(this.pendingRequests.delete(S.request_seq),D(S));break}}}}internalSend(T,S){S.type=T,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((S,D)=>T.set(D,S)),await(0,P.timeout)(500),T.forEach((S,D)=>{S({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(_e[227],ye([1,0,190,54,4]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const A=b=>a.localize(51,null,b);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var _;(function(b){b[b.Inactive=0]="Inactive",b[b.Initializing=1]="Initializing",b[b.Stopped=2]="Stopped",b[b.Running=3]="Running"})(_=e.State||(e.State={}));function T(b){switch(b){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(b){b[b.Valid=0]="Valid",b[b.Unreadable=1]="Unreadable",b[b.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var D;(function(b){b[b.Initial=1]="Initial",b[b.Dynamic=2]="Dynamic"})(D=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(b){b.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,u.createDecorator)("debugService");var I;(function(b){b[b.CONDITION=0]="CONDITION",b[b.HIT_COUNT=1]="HIT_COUNT",b[b.LOG_MESSAGE=2]="LOG_MESSAGE"})(I=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(_e[228],ye([1,0,8,2,10,23,14,32,21,16]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function I(n,t,c){return n.replace(R,function(E,y){return t&&y.length>0&&y[0]!=="_"?E:c&&c.hasOwnProperty(y)?c[y]:E})}e.formatPII=I;function b(n){const t={};for(const c of Object.keys(n))c.startsWith("!")||(t[c]=n[c]);return t}e.filterExceptionsFromTelemetry=b;function k(n){return n.configuration.request==="attach"&&!w(n)&&(!n.parentSession||k(n.parentSession))}e.isSessionAttach=k;function w(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(t,"extensionhost")||(0,a.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?w(n.parentSession):void 0}e.getExtensionHostDebugSession=w;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function d(n,t,c){let E,y=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=M.exec(n);){const $=j.index+1,N=$+j[0].length;if($<=t&&N>=c){E=j[0],y=$;break}}if(E){const $=/\w+/g;let N=null;for(;(N=$.exec(E))&&!(N.index+1+y+N[0].length>=c););N&&(E=E.substring(0,$.lastIndex))}return E?{start:y,end:y+E.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;async function h(n,t,c,E){if(n.evaluatableExpressionProvider.has(t)){const y=n.evaluatableExpressionProvider.ordered(t),M=(0,D.coalesce)(await Promise.all(y.map(async j=>{try{return await j.provideEvaluatableExpression(t,c,E??S.CancellationToken.None)}catch{return}})));if(M.length>0){let j=M[0].expression;const $=M[0].range;return j||(j=t.getLineContent(c.lineNumber).substring($.startColumn-1,$.endColumn-1)),{range:$,matchingExpression:j}}}else{const y=t.getLineContent(c.lineNumber),{start:M,end:j}=d(y,c.column,c.column),$=y.substring(M-1,j);return{matchingExpression:$,range:new T.Range(c.lineNumber,M,c.lineNumber,M+$.length)}}return null}e.getEvaluatableExpressionAtPosition=h;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(n){return!!(n&&n.match(g))}e.isUri=v;function C(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(v(n.path))return P.URI.parse(n.path);if((0,u.isAbsolute)(n.path))return P.URI.file(n.path)}return n.path}function p(n){if(typeof n.path=="object"){const t=P.URI.revive(n.path);if(t)return t.scheme===_.Schemas.file?t.fsPath:t.toString()}return n.path}function i(n,t){const c=t?C:p,E=(0,A.deepClone)(n);return s(E,(y,M)=>{y&&M&&(M.path=c(M))}),E}e.convertToDAPaths=i;function o(n,t){const c=t?C:p,E=(0,A.deepClone)(n);return s(E,(y,M)=>{!y&&M&&(M.path=c(M))}),E}e.convertToVSCPaths=o;function s(n,t){switch(n.type){case"event":{const c=n;switch(c.event){case"output":t(!1,c.body.source);break;case"loadedSource":t(!1,c.body.source);break;case"breakpoint":t(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=n;switch(c.command){case"setBreakpoints":t(!0,c.arguments.source);break;case"breakpointLocations":t(!0,c.arguments.source);break;case"source":t(!0,c.arguments.source);break;case"gotoTargets":t(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(E=>t(!1,E));break;default:break}break}case"response":{const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(E=>t(!1,E.source));break;case"loadedSources":c.body.sources.forEach(E=>t(!1,E));break;case"scopes":c.body.scopes.forEach(E=>t(!1,E.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(E=>t(!1,E.source));break;case"setBreakpoints":c.body.breakpoints.forEach(E=>t(!1,E.source));break;case"disassemble":c.body?.instructions.forEach(y=>t(!1,y.location));break;default:break}break}}}function l(n){return n.filter(t=>!t.presentation?.hidden).sort((t,c)=>t.presentation?c.presentation?t.presentation.group?c.presentation.group?t.presentation.group!==c.presentation.group?t.presentation.group.localeCompare(c.presentation.group):r(t.presentation.order,c.presentation.order):-1:c.presentation.group?1:r(t.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=l;function r(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function m(n,t){const c=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(c!=="none"&&(await t.saveAll(),c==="allEditorsInActiveGroup")){const E=t.activeEditorPane;E&&E.input.resource?.scheme===_.Schemas.untitled&&await t.save({editor:E.input,groupId:E.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=m}),define(_e[229],ye([1,0,46,230,23,10,12,8,29,191,131]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class I extends R.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(h,g){this.outputStream=g,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,h.on("data",v=>this.handleData(v))}sendMessage(h){if(this.outputStream){const g=JSON.stringify(h);this.outputStream.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${I.TWO_CRLF}${g}`,"utf8")}}handleData(h){for(this.rawData=Buffer.concat([this.rawData,h]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const g=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(v){this._onError.fire(new Error((v.message||v)+`
`+g))}continue}}else{const g=this.rawData.indexOf(I.TWO_CRLF);if(g!==-1){const C=this.rawData.toString("utf8",0,g).split(I.HEADER_LINESEPARATOR);for(const p of C){const i=p.split(I.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(g+I.TWO_CRLF.length);continue}}break}}}I.TWO_CRLF=`\r
\r
`,I.HEADER_LINESEPARATOR=/\r?\n/,I.HEADER_FIELDSEPARATOR=/: */,e.StreamDebugAdapter=I;class b extends I{startSession(){return new Promise((h,g)=>{let v=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),h(),v=!0}),this.socket.on("close",()=>{v?this._onError.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.socket.on("error",C=>{v?this._onError.fire(C):g(C)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class k extends b{constructor(h){super(),this.adapterServer=h}createConnection(h){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",h)}}e.SocketDebugAdapter=k;class w extends b{constructor(h){super(),this.adapterServer=h}createConnection(h){return P.createConnection(this.adapterServer.path,h)}}e.NamedPipeDebugAdapter=w;class f extends I{constructor(h,g){super(),this.adapterExecutable=h,this.debugType=g}async startSession(){const h=this.adapterExecutable.command,g=this.adapterExecutable.args,v=this.adapterExecutable.options||{};try{if(h)if(A.isAbsolute(h)){if(!await S.Promises.exists(h))throw new Error(D.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let C=process.env;if(v.env&&Object.keys(v.env).length>0&&(C=u.mixin(u.deepClone(process.env),v.env)),h==="node")if(Array.isArray(g)&&g.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:C,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};v.cwd&&(i.cwd=v.cwd);const o=a.fork(g[0],g.slice(1),i);if(!o.pid)throw new Error(D.localize(2,null,g[0]));this.serverProcess=o}else throw new Error(D.localize(3,null));else{const p={env:C};v.cwd&&(p.cwd=v.cwd),this.serverProcess=a.spawn(h,g,p)}this.serverProcess.on("error",p=>{this._onError.fire(p)}),this.serverProcess.on("exit",(p,i)=>{this._onExit.fire(p)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stdin.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(C){this._onError.fire(C)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),_.isWindows?new Promise((h,g)=>{const v=a.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(C,p,i){if(C)return g(C)});v.on("exit",h),v.on("error",g)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(h,g){if(!h)return;const v=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?v.runtime=A.join(g,h.runtime):v.runtime=h.runtime),h.runtimeArgs&&(v.runtimeArgs=h.runtimeArgs),h.program&&(A.isAbsolute(h.program)?v.program=h.program:v.program=A.join(g,h.program)),h.args&&(v.args=h.args);const C=h;return C.win&&(v.win=f.extract(C.win,g)),C.winx86&&(v.winx86=f.extract(C.winx86,g)),C.windows&&(v.windows=f.extract(C.windows,g)),C.osx&&(v.osx=f.extract(C.osx,g)),C.linux&&(v.linux=f.extract(C.linux,g)),v}static platformAdapterExecutable(h,g){let v=Object.create(null);g=g.toLowerCase();for(const l of h)if(l.contributes){const r=l.contributes.debuggers;r&&r.length>0&&r.filter(m=>typeof m.type=="string"&&T.equalsIgnoreCase(m.type,g)).forEach(m=>{const n=f.extract(m,l.extensionLocation.fsPath);v=u.mixin(v,n,l.isBuiltin)})}let C;_.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?C=v.winx86||v.win||v.windows:_.isWindows?C=v.win||v.windows:_.isMacintosh?C=v.osx:_.isLinux&&(C=v.linux),C=C||v;const p=C.program||v.program,i=C.args||v.args,o=C.runtime||v.runtime,s=C.runtimeArgs||v.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof p=="string"?[p]:[]).concat(i||[])};if(p)return{type:"executable",command:p,args:i||[]}}}e.ExecutableDebugAdapter=f}),define(_e[231],ye([1,0,46,34,12]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(D,R){return new Promise((I,b)=>{let k="";const w=a.spawn(D,R);w.pid&&w.stdout.on("data",f=>{k+=f.toString()}),w.on("error",f=>{b(f)}),w.on("close",f=>{I(k)})})}async function _(D){if(D)if(u.isWindows){const R=await new Promise((I,b)=>{ie(["windows-process-tree"],I,b)});return new Promise(I=>{R.getProcessTree(D,b=>{I(!!b&&b.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(D)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=_;var T;(function(D){D[D.cmd=0]="cmd",D[D.powershell=1]="powershell",D[D.bash=2]="bash"})(T||(T={}));function S(D,R,I,b,k){D=D.trim().toLowerCase();let w;D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0?w=1:D.indexOf("cmd.exe")>=0?w=0:D.indexOf("bash")>=0?w=2:u.isWindows?w=0:w=2;let f,d=" ";switch(w){case 1:if(f=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),b){const h=(0,P.getDriveLetter)(b);h&&(d+=`${h}:; `),d+=`cd ${f(b)}; `}if(k)for(const h in k){const g=k[h];g===null?d+=`Remove-Item env:${h}; `:d+=`\${env:${h}}='${g}'; `}if(R.length>0){const h=R.shift(),g=I?h:f(h);d+=g[0]==="'"?`& ${g} `:`${g} `;for(const v of R)d+=v==="<"||v===">"||I?v:f(v),d+=" "}break;case 0:if(f=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>h.includes(g))||h.length===0?`"${h}"`:h),b){const h=(0,P.getDriveLetter)(b);h&&(d+=`${h}: && `),d+=`cd ${f(b)} && `}if(k){d+='cmd /C "';for(const h in k){let g=k[h];g===null?d+=`set "${h}=" && `:(g=g.replace(/[&^|<>]/g,v=>`^${v}`),d+=`set "${h}=${g}" && `)}}for(const h of R)d+=h==="<"||h===">"||I?h:f(h),d+=" ";k&&(d+='"');break;case 2:{f=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),g.length===0?'""':g);const h=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(b&&(d+=`cd ${f(b)} ; `),k){d+="/usr/bin/env";for(const g in k){const v=k[g];v===null?d+=` -u ${h(g)}`:d+=` ${h(`${g}=${v}`)}`}d+=" "}for(const g of R)d+=g==="<"||g===">"||I?g:f(g),d+=" ";break}}return d}e.prepareCommand=S}),define(_e[92],ye([1,0,22,38,64,87,14,10,12,54]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var b;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(b=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var g;(function(F){F.scheme=_.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${U.join("")}]+`),de=7;function Y(J,ne){const pe=ne.toString(de),Ie=`${pe.length<U.length?U[pe.length-1]:"z"}${pe}s${(0,a.encodeBase64)(a.VSBuffer.fromString(J.scheme),!0,!0)}`;return J.with({scheme:F.scheme,fragment:Ie})}F.generate=Y;function V(J){if(J.scheme!==F.scheme)return;const ne=J.fragment.indexOf("s");if(ne<0)return;const pe=parseInt(J.fragment.substring(0,ne).replace(H,""),de),be=(0,a.decodeBase64)(J.fragment.substring(ne+1)).toString();if(!isNaN(pe))return{handle:pe,notebook:J.with({scheme:be,fragment:null})}}F.parse=V;function X(J,ne){return J.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${ne??""},${J.scheme!==_.Schemas.file?J.scheme:""}`})}F.generateCellOutputUri=X;function Z(J){if(J.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const ne=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(J.fragment);if(!ne)return;const pe=ne[1]&&ne[1]!==""?ne[1]:void 0,be=ne[2];return{outputId:pe,notebook:J.with({scheme:be||_.Schemas.file,fragment:null})}}F.parseCellOutputUri=Z;function te(J,ne,pe){return F.generate(J,ne).with({scheme:pe})}F.generateCellPropertyUri=te;function K(J,ne){if(J.scheme===ne)return F.parse(J.with({scheme:F.scheme}))}F.parseCellPropertyUri=K})(g=e.CellUri||(e.CellUri={}));const v=F=>S.isWindows?F.replace(/\//g,"\\"):F;class C{constructor(U=[],H=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=H,this.order=[...new Set(U)].map(de=>({pattern:de,matches:P.parse(v(de))}))}sort(U){const H=new Map(u.Iterable.map(U,Y=>[Y,v(Y)]));let de=[];for(const{matches:Y}of this.order)for(const[V,X]of H)if(Y(X)){de.push(V),H.delete(V);break}return H.size&&(de=de.concat([...H.keys()].sort((Y,V)=>this.defaultOrder.indexOf(Y)-this.defaultOrder.indexOf(V)))),de}prioritize(U,H){const de=this.findIndex(U);if(de===-1){this.order.unshift({pattern:U,matches:P.parse(v(U))});return}const Y=new Set(H.map(X=>this.findIndex(X,de)));Y.delete(-1);const V=Array.from(Y).sort();this.order.splice(de+1,0,...V.map(X=>this.order[X]));for(let X=V.length-1;X>=0;X--)this.order.splice(V[X],1)}toArray(){return this.order.map(U=>U.pattern)}findIndex(U,H=this.order.length){const de=v(U);for(let Y=0;Y<H;Y++)if(this.order[Y].matches(de))return Y;return-1}}e.MimeTypeDisplayOrder=C;function p(F,U,H,de=(Y,V)=>Y===V){const Y=[];function V(te,K,J){if(K===0&&J.length===0)return;const ne=Y[Y.length-1];ne&&ne.start+ne.deleteCount===te?(ne.deleteCount+=K,ne.toInsert.push(...J)):Y.push({start:te,deleteCount:K,toInsert:J})}let X=0,Z=0;for(;;){if(X===F.length){V(X,0,U.slice(Z));break}if(Z===U.length){V(X,F.length-X,[]);break}const te=F[X],K=U[Z];if(de(te,K)){X+=1,Z+=1;continue}H(K)?(V(X,1,[]),X+=1):(V(X,0,[K]),Z+=1)}return Y}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(F){F.default="default",F.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(F){const U=F;return!!((typeof U.include=="string"||P.isRelativePattern(U.include))&&(typeof U.exclude=="string"||P.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=o;function s(F,U,H){if(Array.isArray(F.viewType)&&F.viewType.indexOf(U)>=0||F.viewType===U)return!0;if(F.filenamePattern){const de=o(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,Y=o(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(P.match(de,(0,T.basename)(H.fsPath).toLowerCase()))return!(Y&&P.match(Y,(0,T.basename)(H.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var l;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(U){return`${r._prefix}${U}`}static parse(U){if(U.startsWith(r._prefix))return U.substring(r._prefix.length)}}r._prefix="notebook/",e.NotebookWorkingCopyTypeIdentifier=r;function m(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=m;const n=new TextDecoder;function t(F){const U=[];let H=!1;for(const de of F)(U.length===0||H)&&(U.push(de),H=!0);return M(U),L(a.VSBuffer.concat(U.map(de=>a.VSBuffer.wrap(de))))}e.compressOutputItemStreams=t;const c=`${String.fromCharCode(27)}[A`,E=c.split("").map(F=>F.charCodeAt(0)),y=10;function M(F){F.forEach((U,H)=>{if(H===0||U.length<c.length)return;const de=F[H-1],Y=U.subarray(0,c.length);if(Y[0]===E[0]&&Y[1]===E[1]&&Y[2]===E[2]){const V=de.lastIndexOf(y);if(V===-1)return;F[H-1]=de.subarray(0,V),F[H]=U.subarray(c.length)}})}function j(F){let U=F;do F=U,U=F.replace(/[^\n]\x08/gm,"");while(U.length<F.length);return F}function $(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const U=F.match(/^(.*)\r+/m)[1];let H=F.match(/\r+(.*)$/m)[1];H=H+U.slice(H.length,U.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return F}const N="\b".charCodeAt(0),x="\r".charCodeAt(0);function L(F){return!F.buffer.includes(N)&&!F.buffer.includes(x)?F:a.VSBuffer.fromString($(j(n.decode(F.buffer))))}}),define(_e[232],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var P;(function(u){u[u.Output=1]="Output",u[u.OutputItems=2]="OutputItems",u[u.ExecutionState=3]="ExecutionState"})(P=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(_e[57],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(A){A.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var P;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(P=e.TestPosition||(e.TestPosition={}));class u{static fromExtHostTestItem(_,T,S=_.parent){if(_._isRoot)return new u([T]);const D=[_.id];for(let R=S;R&&R.id!==T;R=R.parent)D.push(R.id);return D.push(T),new u(D.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const T=_.indexOf("\0");return T===-1?_:_.slice(0,T)}static fromString(_){return new u(_.split("\0"))}static join(_,T){return new u([..._.path,T])}static joinToString(_,T){return _.toString()+"\0"+T}static parentId(_){const T=_.lastIndexOf("\0");return T===-1?void 0:_.slice(0,T)}static localId(_){const T=_.lastIndexOf("\0");return T===-1?_:_.slice(T+1)}static compare(_,T){return _===T?0:T.startsWith(_+"\0")?2:_.startsWith(T+"\0")?3:1}constructor(_,T=_.length){if(this.path=_,this.viewEnd=T,_.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new u(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new u(this.path,_)}*idsToRoot(){for(let _=this.viewEnd;_>0;_--)yield new u(this.path,_)}compare(_){if(typeof _=="string")return u.compare(this.toString(),_);for(let T=0;T<_.viewEnd&&T<this.viewEnd;T++)if(_.path[T]!==this.path[T])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=u}),define(_e[76],ye([1,0,2,32,57]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var _;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable",n[n.SupportsContinuousRun=64]="SupportsContinuousRun"})(_=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const T=n=>"runId"in n;e.isStartControllerTests=T;var S;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:P.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var D;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(D=e.TestMessageType||(e.TestMessageType={}));var R;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.deserialize(t.location)})})(R=e.ITestErrorMessage||(e.ITestErrorMessage={}));const I=(n,t)=>`${t?"s":"e"}${n}`;e.getMarkId=I;var b;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.deserialize(t.location)})})(b=e.ITestOutputMessage||(e.ITestOutputMessage={}));var k;(function(n){n.serialize=t=>t.type===0?R.serialize(t):b.serialize(t),n.deserialize=t=>t.type===0?R.deserialize(t):b.deserialize(t)})(k=e.ITestMessage||(e.ITestMessage={}));var w;(function(n){n.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(k.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(k.deserialize)})})(w=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",d=(n,t)=>n+f+t;e.namespaceTestTag=d;const h=n=>{const t=n.indexOf(f);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=h;var g;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?P.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(g=e.ITestItem||(e.ITestItem={}));var v;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var C;(function(n){n.serialize=t=>({expand:t.expand,item:g.serialize(t.item)}),n.deserialize=t=>({controllerId:u.TestId.root(t.item.extId),expand:t.expand,item:g.deserialize(t.item)})})(C=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(n){n.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}},n.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?P.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=i;var o;(function(n){n.serializeWithoutMessages=t=>({...C.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(w.serializeWithoutMessages),retired:t.retired}),n.serialize=t=>({...C.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(w.serialize),retired:t.retired}),n.deserialize=t=>({...C.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(w.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var s;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var l;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var r;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:C.deserialize(t.item)}:t.op===1?{op:t.op,item:p.deserialize(t.item)}:t.op===2?{op:t.op,uri:a.URI.revive(t.uri),docv:t.docv}:t,n.serialize=t=>t.op===0?{op:t.op,item:C.serialize(t.item)}:t.op===1?{op:t.op,item:p.serialize(t.item)}:t})(r=e.TestsDiffOp||(e.TestsDiffOp={}));class m{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const E of t)switch(E.op){case 0:this.add(C.deserialize(E.item),c);break;case 1:this.update(p.deserialize(E.item),c);break;case 3:this.remove(E.itemId,c);break;case 5:this.retireTest(E.itemId);break;case 4:this.updatePendingRoots(E.amount);break;case 6:this._tags.set(E.tag.id,E.tag);break;case 7:this._tags.delete(E.id);break}c.complete?.()}add(t,c){const E=u.TestId.parentId(t.item.extId)?.toString();let y;if(!E)y=this.createItem(t),this.roots.add(y),this.items.set(t.item.extId,y);else if(this.items.has(E)){const M=this.items.get(E);M.children.add(t.item.extId),y=this.createItem(t,M),this.items.set(t.item.extId,y)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return c.add?.(y),t.expand===2&&this.busyControllerCount++,y}update(t,c){const E=this.items.get(t.extId);if(!!E)return t.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,t.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,t),c.update?.(E),E}remove(t,c){const E=this.items.get(t);if(!E)return;const y=u.TestId.parentId(E.item.extId)?.toString();y?this.items.get(y).children.delete(E.item.extId):this.roots.delete(E);const M=[[t]];for(;M.length;)for(const j of M.pop()){const $=this.items.get(j);$&&(M.push($.children),this.items.delete(j),c.remove?.($,$!==E),$.expand===2&&this.busyControllerCount--)}}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=m}),define(_e[93],ye([1,0,19,3,6,50,76,57]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(g,v)=>g===v,I=Object.entries({range:(g,v)=>g===v?!0:!g||!v?!1:g.equalsRange(v),busy:D,label:D,description:D,error:D,sortText:D,tags:(g,v)=>!(g.length!==v.length||g.some(C=>!v.includes(C)))}),b=(g,v)=>{let C;for(const[p,i]of I)i(g[p],v[p])||(C?C[p]=v[p]:C={[p]:v[p]});return C};class k extends u.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new P.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const C of this.tree.values())this.updateExpandability(C)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const C of this.diff)if(C.op===2&&C.uri===v.uri){C.docv=v.docv;return}break}case 1:{const C=this.diff[this.diff.length-1];if(C){if(C.op===1&&C.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(C.item,v.item);return}if(C.op===0&&C.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(C.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,C){const p=this.tree.get(v);if(!!p){if((p.expandLevels===void 0||C>p.expandLevels)&&(p.expandLevels=C),p.expand===1){const i=this.resolveChildren(p);return i.isOpen()?this.expandChildren(p,C-1):i.wait().then(()=>this.expandChildren(p,C-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,C-1)):this.expandChildren(p,C-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,C){switch(C.op){case 3:this.removeItem(T.TestId.joinToString(v.fullId,C.id));break;case 0:this.upsertItem(C.item,v);break;case 5:for(const p of C.ops)this.onTestItemEvent(v,p);break;case 1:this.diffTagRefs(C.new,C.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:C.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,A.assertNever)(C)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,C){const p=T.TestId.fromExtHostTestItem(v,this.root.id,C?.actual),i=this.options.getApiFor(v);i.parent&&i.parent!==C?.actual&&this.options.getChildren(i.parent).delete(v.id);let o=this.tree.get(p.toString());if(!o){o={fullId:p,actual:v,expandLevels:C?.expandLevels?C.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(o.fullId.toString(),o),this.setItemParent(v,C),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:o.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,o,C);return}if(o.actual===v){this.connectItem(v,o,C);return}if(o.actual.uri?.toString()!==v.uri?.toString())return this.removeItem(p.toString()),this.upsertItem(v,C);const s=this.options.getChildren(o.actual),l=o.actual,r=b(this.options.toITestItem(l),this.options.toITestItem(v));this.options.getApiFor(l).listener=void 0,o.actual=v,o.expand=0,r&&(r.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,l.tags,p.toString()),delete r.tags),this.onTestItemEvent(o,{op:4,update:r})),this.connectItemAndChildren(v,o,C);for(const[m,n]of s)this.options.getChildren(v).get(n.id)||this.removeItem(T.TestId.joinToString(p,n.id));this.documentSynced(o.actual.uri)}diffTagRefs(v,C,p){const i=new Set(C.map(o=>o.id));for(const o of v)i.delete(o.id)||this.incrementTagRefs(o);this.pushDiff({op:1,item:{extId:p,item:{tags:v.map(o=>(0,_.namespaceTestTag)(this.options.controllerId,o.id))}}}),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const C=this.tags.get(v.id);C?C.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const C=this.tags.get(v);C&&!--C.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,C){this.options.getApiFor(v).parent=C&&C.actual!==this.root?C.actual:void 0}connectItem(v,C,p){this.setItemParent(v,p);const i=this.options.getApiFor(v);i.parent=p?.actual,i.listener=o=>this.onTestItemEvent(C,o),this.updateExpandability(C)}connectItemAndChildren(v,C,p){this.connectItem(v,C,p);for(const[i,o]of this.options.getChildren(v))this.upsertItem(o,C)}updateExpandability(v){let C;this._resolveHandler?v.resolveBarrier?C=v.resolveBarrier.isOpen()?3:2:C=v.actual.canResolveChildren?1:0:C=0,C!==v.expand&&(v.expand=C,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:C}}),C===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,C){if(C<0)return;const p=[];for(const[i,o]of this.options.getChildren(v.actual)){const s=this.expand(T.TestId.joinToString(v.fullId,o.id),C);(0,a.isThenable)(s)&&p.push(s)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const o=new a.Barrier;return o.open(),o}v.expand=2,this.pushExpandStateUpdate(v);const C=v.resolveBarrier=new a.Barrier,p=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,o)};let i;try{i=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(o){p(o)}return(0,a.isThenable)(i)?i.catch(p).then(()=>{C.open(),this.updateExpandability(v)}):(C.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const C=this.tree.get(v);if(!C)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const p=[C];for(;p.length;){const i=p.pop();if(!!i){this.options.getApiFor(i.actual).listener=void 0;for(const o of i.actual.tags)this.decrementTagRefs(o.id);this.tree.delete(i.fullId.toString());for(const[o,s]of this.options.getChildren(i.actual))p.push(this.tree.get(T.TestId.joinToString(i.fullId,s.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=k;class w extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=w;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class d extends Error{constructor(v,C,p){super(`TestItem with ID "${v}" is from controller "${C}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=d;const h=(g,v,C)=>{let p=new Map;return{get size(){return p.size},forEach(i,o){for(const s of p.values())i.call(o,s,this)},[Symbol.iterator](){return p.entries()},replace(i){const o=new Map,s=new Set(p.keys()),l={op:5,ops:[]};for(const r of i){if(!(r instanceof C))throw new f(r.id);const m=v(r).controllerId;if(m!==g.controllerId)throw new d(r.id,m,g.controllerId);if(o.has(r.id))throw new w(r.id);o.set(r.id,r),s.delete(r.id),l.ops.push({op:0,item:r})}for(const r of s.keys())l.ops.push({op:3,id:r});g.listener?.(l),p=o},add(i){if(!(i instanceof C))throw new f(i.id);p.set(i.id,i),g.listener?.({op:0,item:i})},delete(i){p.delete(i)&&g.listener?.({op:3,id:i})},get(i){return p.get(i)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=h}),define(_e[132],ye([1,0,93]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const P=new WeakMap,u=(_,T)=>{const S={controllerId:T};return P.set(_,S),S};e.createPrivateApiFor=u;const A=_=>{const T=P.get(_);if(!T)throw new a.InvalidTestItemError(_?.id||"<unknown>");return T};e.getPrivateApiFor=A}),define(_e[94],ye([1,0,14,2]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function u(T,S){return T.scheme===a.Schemas.http||T.scheme===a.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===a.Schemas.file&&(T=P.URI.from({scheme:a.Schemas.vscodeRemote,authority:S.authority,path:T.path})),P.URI.from({scheme:a.Schemas.https,authority:`${T.scheme}+${A(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=u;function A(T){return T.replace(/./g,S=>{const D=S.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?S:"-"+D.toString(16).padStart(4,"0")})}function _(T){return T.replace(/-([0-9a-f]{4})/g,(S,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=_}),define(_e[233],ye([1,0,3,6,94]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(T,S,D){this._proxy=T,this._editors=S,this._remoteInfo=D,this._handlePool=0,this._disposables=new P.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const I of this._insets.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,S,D,R,I){let b;for(const v of this._editors.getVisibleTextEditors(!0))if(v.value===T){b=v;break}if(!b)throw new Error("not a visible editor");const k=this,w=this._handlePool++,f=new a.Emitter,d=new a.Emitter,h=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(v){return(0,u.asWebviewUri)(v,k._remoteInfo)}get cspSource(){return u.webviewGenericCspSource}set options(v){this._options=v,k._proxy.$setOptions(w,v)}get options(){return this._options}set html(v){this._html=v,k._proxy.$setHtml(w,v)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(v){return k._proxy.$postMessage(w,v)}},g=new class{constructor(){this.editor=T,this.line=S,this.height=D,this.webview=h,this.onDidDispose=d.event}dispose(){k._insets.has(w)&&(k._insets.delete(w),k._proxy.$disposeEditorInset(w),d.fire(),d.dispose(),f.dispose())}};return this._proxy.$createEditorInset(w,b.id,b.value.document.uri,S+1,D,R||{},I.identifier,I.extensionLocation),this._insets.set(w,{editor:T,inset:g,onDidReceiveMessage:f}),g}$onDidDispose(T){const S=this._insets.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this._insets.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(_e[234],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var P;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(P=e.VariableKind||(e.VariableKind={}));class u extends Error{constructor(_,T){super(T),this.variable=_}}e.VariableError=u}),define(_e[235],ye([1,0,10,33,9,23,12,113,194,234,8]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(k,w,f,d){this._contributedVariables=new Map,this._context=k,this._labelService=w,this._userHomePromise=f,d&&(this._envVariablesPromise=d.then(h=>this.prepareEnv(h)))}prepareEnv(k){if(_.isWindows){const w=Object.create(null);return Object.keys(k).forEach(f=>{w[f.toLowerCase()]=k[f]}),w}return k}resolveWithEnvironment(k,w,f){return this.recursiveResolve({env:this.prepareEnv(k),userHome:void 0},w?w.uri:void 0,f)}async resolveAsync(k,w){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,k?k.uri:void 0,w)}async resolveAnyBase(k,w,f,d){const h=A.deepClone(w);_.isWindows&&h.windows?Object.keys(h.windows).forEach(v=>h[v]=h.windows[v]):_.isMacintosh&&h.osx?Object.keys(h.osx).forEach(v=>h[v]=h.osx[v]):_.isLinux&&h.linux&&Object.keys(h.linux).forEach(v=>h[v]=h.linux[v]),delete h.windows,delete h.osx,delete h.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,k?k.uri:void 0,h,f,d)}async resolveAnyAsync(k,w,f){return this.resolveAnyBase(k,w,f)}async resolveAnyMap(k,w,f){const d=new Map;return{newConfig:await this.resolveAnyBase(k,w,f,d),resolvedVariables:d}}resolveWithInteractionReplace(k,w,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,w,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,w){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,w)}async recursiveResolve(k,w,f,d,h){if(u.isString(f))return this.resolveString(k,w,f,d,h);if(Array.isArray(f))return Promise.all(f.map(g=>this.recursiveResolve(k,w,g,d,h)));if(u.isObject(f)){const g=Object.create(null),v=await Promise.all(Object.keys(f).map(async C=>[await this.resolveString(k,w,C,d,h),await this.recursiveResolve(k,w,f[C],d,h)]));for(const[C,p]of v)g[C]=p;return g}return f}resolveString(k,w,f,d,h){return(0,R.replaceAsync)(f,I.VARIABLE_REGEXP,async(g,v)=>{if(v.includes(I.VARIABLE_LHS))return g;let C=await this.evaluateSingleVariable(k,g,v,w,d);return h?.set(v,C),C!==g&&u.isString(C)&&C.match(I.VARIABLE_REGEXP)&&(C=await this.resolveString(k,w,C,d,h)),C})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}async evaluateSingleVariable(k,w,f,d,h){let g;const v=f.split(":");v.length>1&&(f=v[0],g=v[1]);const C=o=>{const s=this._context.getFilePath();if(s)return(0,T.normalizeDriveLetter)(s);throw new D.VariableError(o,(0,S.localize)(0,null,w))},p=o=>{const s=C(o);if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return(0,T.normalizeDriveLetter)(l)}throw new D.VariableError(o,(0,S.localize)(1,null,w,a.basename(s)))},i=o=>{if(g){const s=this._context.getFolderUri(g);if(s)return s;throw new D.VariableError(o,(0,S.localize)(2,null,w,g))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new D.VariableError(o,(0,S.localize)(3,null,w)):new D.VariableError(o,(0,S.localize)(4,null,w))};switch(f){case"env":if(g){if(k.env){const o=k.env[_.isWindows?g.toLowerCase():g];if(u.isString(o))return o}return""}throw new D.VariableError(D.VariableKind.Env,(0,S.localize)(5,null,w));case"config":if(g){const o=this._context.getConfigurationValue(d,g);if(u.isUndefinedOrNull(o))throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(6,null,w,g));if(u.isObject(o))throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(7,null,w,g));return o}throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(8,null,w));case"command":return this.resolveFromMap(D.VariableKind.Command,w,g,h,"command");case"input":return this.resolveFromMap(D.VariableKind.Input,w,g,h,"input");case"extensionInstallFolder":if(g){const o=await this._context.getExtension(g);if(!o)throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,w,g));return this.fsPath(o.extensionLocation)}throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,w));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(i(D.VariableKind.WorkspaceFolder)));case"cwd":return d||g?(0,T.normalizeDriveLetter)(this.fsPath(i(D.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.normalizeDriveLetter)(a.basename(this.fsPath(i(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new D.VariableError(D.VariableKind.UserHome,(0,S.localize)(11,null,w))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new D.VariableError(D.VariableKind.LineNumber,(0,S.localize)(12,null,w))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new D.VariableError(D.VariableKind.SelectedText,(0,S.localize)(13,null,w))}case"file":return C(D.VariableKind.File);case"fileWorkspaceFolder":return p(D.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||g?a.relative(this.fsPath(i(D.VariableKind.RelativeFile)),C(D.VariableKind.RelativeFile)):C(D.VariableKind.RelativeFile);case"relativeFileDirname":{const o=a.dirname(C(D.VariableKind.RelativeFileDirname));if(d||g){const s=a.relative(this.fsPath(i(D.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return a.dirname(C(D.VariableKind.FileDirname));case"fileExtname":return a.extname(C(D.VariableKind.FileExtname));case"fileBasename":return a.basename(C(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=a.basename(C(D.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-a.extname(o).length)}case"fileDirnameBasename":return a.basename(a.dirname(C(D.VariableKind.FileDirnameBasename)));case"execPath":{const o=this._context.getExecPath();return o||w}case"execInstallFolder":{const o=this._context.getAppRoot();return o||w}case"pathSeparator":return a.sep;default:try{const o=g?`${f}:${g}`:f;return this.resolveFromMap(D.VariableKind.Unknown,w,o,h,void 0)}catch{return w}}}}resolveFromMap(k,w,f,d,h){if(f&&d){const g=h===void 0?d[f]:d[h+":"+f];if(typeof g=="string")return g;throw new D.VariableError(k,(0,S.localize)(14,null,w))}return w}}I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=I}),define(_e[133],ye([1,0,4,130]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var u;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(u=e.GroupDirection||(e.GroupDirection={}));var A;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var T;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function D(w){const f=w;return(0,P.isEditorInput)(f?.editor)&&(0,P.isEditorInput)(f?.replacement)}e.isEditorReplacement=D;var R;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function b(w){const f=w;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=b;function k(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(_e[236],ye([1,0,4,133]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function u(A){const _=A;return typeof A=="number"||(0,P.isEditorGroup)(_)}e.isPreferredGroup=u}),define(_e[237],ye([1,0,4,201]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(P.IEnvironmentService)}),define(_e[134],ye([1,0,26,3,10]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(I){this.removedDueToLooping=I}}e.DeltaExtensionsResult=A;class _{static isHostExtension(I,b,k){if(b.getExtensionDescription(I))return!1;const w=k.getExtensionDescription(I);return w?!!((w.main||w.browser)&&w.api==="none"):!1}constructor(I){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=I,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const I of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(I.identifier))){console.error("Extension `"+I.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(I.identifier),I),this._extensionsArr.push(I),Array.isArray(I.activationEvents))for(let b of I.activationEvents)b==="onUri"&&(b=`onUri:${a.ExtensionIdentifier.toKey(I.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(I)}}set(I){this._extensionDescriptions=I,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(I,b){this._extensionDescriptions=D(this._extensionDescriptions,b),this._extensionDescriptions=this._extensionDescriptions.concat(I);const k=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=D(this._extensionDescriptions,k.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new A(k)}static _findLoopingExtensions(I){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,g){this.addNode(h),this.addNode(g),this._arcs.has(h)?this._arcs.get(h).push(g):this._arcs.set(h,[g])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,g){const v=b.getArcs(h);for(let C=0;C<v.length;C++)if(!g.has(v[C]))return!1;return!0}getNodes(){return this._nodesArr}},k=new Map;for(const h of I){const g=a.ExtensionIdentifier.toKey(h.identifier);if(k.set(g,h),h.extensionDependencies)for(const v of h.extensionDependencies){const C=a.ExtensionIdentifier.toKey(v);b.addArc(g,C)}}const w=new Set;b.getNodes().filter(h=>b.getArcs(h).length===0).forEach(h=>w.add(h));const f=b.getNodes().filter(h=>!w.has(h));let d;do{d=!1;for(let h=0;h<f.length;h++){const g=f[h];b.hasOnlyGoodArcs(g,w)&&(f.splice(h,1),h--,w.add(g),d=!0)}}while(d);return f.map(h=>k.get(h))}containsActivationEvent(I){return this._activationMap.has(I)}containsExtension(I){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(I))}getExtensionDescriptionsForActivationEvent(I){const b=this._activationMap.get(I);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(I){const b=this._extensionsMap.get(a.ExtensionIdentifier.toKey(I));return b||void 0}getExtensionDescriptionByUUID(I){for(const b of this._extensionsArr)if(b.uuid===I)return b}getExtensionDescriptionByIdOrUUID(I,b){return this.getExtensionDescription(I)??(b?this.getExtensionDescriptionByUUID(b):void 0)}}e.ExtensionDescriptionRegistry=_;var T;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(T||(T={}));function S(R,I){const b=R.isBuiltin?0:R.isUnderDevelopment?2:1,k=I.isBuiltin?0:I.isUnderDevelopment?2:1;if(b!==k)return b-k;const w=u.posix.basename(R.extensionLocation.path),f=u.posix.basename(I.extensionLocation.path);return w<f?-1:w>f?1:0}function D(R,I){const b=new Set;return I.forEach(k=>b.add(a.ExtensionIdentifier.toKey(k))),R.filter(k=>!b.has(a.ExtensionIdentifier.toKey(k.identifier)))}}),define(_e[238],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class P{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[P.ENV_KEY]=this.pipeName}}P.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=P;class u{constructor(){this.type=2}serialize(I){I[u.ENV_KEY]="1"}}u.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=u;class A{constructor(){this.type=3}serialize(I){I[A.ENV_KEY]="1"}}A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=A;function _(R){delete R[P.ENV_KEY],delete R[u.ENV_KEY],delete R[A.ENV_KEY]}function T(R,I){_(I),R.serialize(I)}e.writeExtHostConnection=T;function S(R){if(R[P.ENV_KEY])return D(R,new P(R[P.ENV_KEY]));if(R[u.ENV_KEY])return D(R,new u);if(R[A.ENV_KEY])return D(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function D(R,I){return _(R),I}}),define(_e[95],ye([1,0,22]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var P;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var u;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(u=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function _(D){const R=a.VSBuffer.alloc(1);switch(D){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=_;function T(D,R){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=T;var S;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(_e[96],ye([1,0,4,3,13,25,95,73,74,23,2,6,181]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class extends I.Disposable{constructor(h,g){super(),this.initData=h,this.loggerService=g,this._onDidChangeTelemetryEnabled=this._register(new P.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new P.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=g.createLogger(this.extHostTelemetryLogFile,{id:S.extensionTelemetryLogChannelId,name:(0,b.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(g.onDidChangeLogLevel(v=>{(0,u.isLogLevel)(v)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===u.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(h,g,v){const C=this.getTelemetryDetails(),p=new w(g,v,h,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(h),{isUsageEnabled:C.isUsageEnabled,isErrorsEnabled:C.isErrorsEnabled});return this._telemetryLoggers.set(h.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(h,g,v){this._level=h,this._telemetryIsSupported=g,this._productConfig=v??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(h){const g={};switch(g["common.extname"]=`${h.publisher}.${h.name}`,g["common.extversion"]=h.version,g["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,g["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,g["common.vscodeversion"]=this.initData.version,g["common.isnewappinstall"]=f(this.initData.telemetryInfo.firstSessionDate),g["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case _.UIKind.Web:g["common.uikind"]="web";break;case _.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.initData.remote.authority)),g}$onDidChangeTelemetryLevel(h){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=h;const g=this.getTelemetryDetails();this._telemetryLoggers.forEach(v=>{v.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(h,g){const v=this._telemetryLoggers.get(h.value);return!v||v.ignoreUnhandledExtHostErrors?!1:(v.logError(g),!0)}};k=Ve([We(0,A.IExtHostInitDataService),We(1,u.ILoggerService)],k),e.ExtHostTelemetry=k;class w{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,g,v,C,p,i,o){this._extension=v,this._logger=C,this._inLoggingOnlyMode=p,this._commonProperties=i,this._onDidChangeEnableStates=new P.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=g?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=g?.additionalCommonProperties,this._sender=h,this._telemetryEnablements={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(h,g){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:h,isErrorsEnabled:g},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(h){let g=h.properties??h;return g=(0,S.cleanData)(g,[]),this._additionalCommonProperties&&(g=(0,D.mixin)(g,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(g=(0,D.mixin)(g,this._commonProperties)),h.properties?h.properties=g:h=g,h}logEvent(h,g){this._extension.publisher==="vscode"?h=this._extension.name+"/"+h:h=this._extension.identifier.value+"/"+h,g=this.mixInCommonPropsAndCleanData(g||{}),this._inLoggingOnlyMode||this._sender.sendEventData(h,g),this._logger.trace(h,g)}logUsage(h,g){!this._telemetryEnablements.isUsageEnabled||this.logEvent(h,g)}logError(h,g){!this._telemetryEnablements.isErrorsEnabled||(typeof h=="string"?this.logEvent(h,g):this._sender.sendErrorData(h,g))}get apiTelemetryLogger(){if(!this._apiObject){const h=this,g={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return h._telemetryEnablements.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h._onDidChangeEnableStates.event.bind(h)};this._apiObject=Object.freeze(g)}return this._apiObject}dispose(){this._sender?.flush&&this._sender.flush()}}e.ExtHostTelemetryLogger=w;function f(d){const h=Date.now()-new Date(d).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=f,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(_e[27],ye([1,0,3,2,4,26,214]),function(ie,e,a,P,u,A,_){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,u.createDecorator)("extensionService");class S{constructor(m){this.affinity=m,this.kind=1}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class D{constructor(m){this.affinity=m,this.kind=2}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=D;class R{constructor(){this.kind=3,this.affinity=0}equals(m){return this.kind===m.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class I{constructor(m){this.dependency=m}}e.MissingExtensionDependency=I;var b;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(b=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=k;class w{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(m,n){const t=[],c=[],E=[],y=[],M=h(this._allExtensions),j=h(m),$=(F,U)=>F.extensionLocation.toString()===U.extensionLocation.toString()||F.isBuiltin===U.isBuiltin||F.isUserBuiltin===U.isUserBuiltin||F.isUnderDevelopment===U.isUnderDevelopment;for(const F of this._allExtensions){const U=j.get(A.ExtensionIdentifier.toKey(F.identifier));if(!U){t.push(F.identifier),M.delete(A.ExtensionIdentifier.toKey(F.identifier));continue}if(!$(F,U)){t.push(F.identifier),M.delete(A.ExtensionIdentifier.toKey(F.identifier));continue}}for(const F of m){const U=M.get(A.ExtensionIdentifier.toKey(F.identifier));if(!U){c.push(F);continue}if(!$(U,F)){t.push(U.identifier),M.delete(A.ExtensionIdentifier.toKey(U.identifier));continue}}const N=d(this._myExtensions),x=d(n);for(const F of this._myExtensions)x.has(A.ExtensionIdentifier.toKey(F))||E.push(F);for(const F of n)N.has(A.ExtensionIdentifier.toKey(F))||y.push(F);const L={toRemove:t,toAdd:c,myToRemove:E,myToAdd:y};return this.delta(L),L}delta(m){const{toRemove:n,toAdd:t,myToRemove:c,myToAdd:E}=m,y=d(n),M=d(c);for(let j=0;j<this._allExtensions.length;j++)y.has(A.ExtensionIdentifier.toKey(this._allExtensions[j].identifier))&&(this._allExtensions.splice(j,1),j--);for(let j=0;j<this._myExtensions.length;j++)M.has(A.ExtensionIdentifier.toKey(this._myExtensions[j]))&&(this._myExtensions.splice(j,1),j--);for(const j of t)this._allExtensions.push(j);for(const j of E)this._myExtensions.push(j)}containsExtension(m){for(const n of this._myExtensions)if(A.ExtensionIdentifier.equals(n,m))return!0;return!1}}e.ExtensionHostExtensions=w;class f{constructor(m){if(this[T]="ExtensionIdentifierSet",this._map=new Map,this._toKey=A.ExtensionIdentifier.toKey,m)for(const n of m)this.add(n)}get size(){return this._map.size}add(m){return this._map.set(this._toKey(m),m),this}clear(){this._map.clear()}delete(m){return this._map.delete(this._toKey(m))}has(m){return this._map.has(this._toKey(m))}forEach(m,n){this._map.forEach(t=>m.call(n,t,t,this))}*entries(){for(const[m,n]of this._map)yield[n,n]}keys(){return this._map.values()}values(){return this._map.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=f;function d(r){const m=new Set;for(const n of r)m.add(A.ExtensionIdentifier.toKey(n));return m}e.extensionIdentifiersArrayToSet=d;function h(r){const m=new Map;for(const n of r)m.set(A.ExtensionIdentifier.toKey(n.identifier),n);return m}function g(r,m){return r.enabledApiProposals?r.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=g;function v(r,m){if(!g(r,m))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=v;class C{constructor(m,n,t,c){this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=t,this.activationReason=c}}e.ActivationTimes=C;class p{constructor(m,n){this.description=m,this.value=n}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var i;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function s(r,m){return{identifier:new A.ExtensionIdentifier((0,_.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!m,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=s;class l{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m,n){return Promise.resolve(0)}getInspectPorts(m,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(_e[239],ye([1,0,11,134,26,27,13,19]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(h,g,v,C){this.startup=h,this.codeLoadingTime=g,this.activateCallTime=v,this.activateResolvedTime=C}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class D{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,g){return h===-1||g===-1?-1:g-h}build(){return new S(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class R{constructor(h,g,v,C,p,i){this.activationFailed=h,this.activationFailedError=g,this.activationTimes=v,this.module=C,this.exports=p,this.subscriptions=i}}e.ActivatedExtension=R;class I extends R{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class b extends R{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class k extends R{constructor(h){super(!0,h,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(h,g,v,C){this._logService=C,this._registry=h,this._globalRegistry=g,this._host=v,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[h,g]of this._operations)g.dispose()}isActivated(h){const g=this._operations.get(u.ExtensionIdentifier.toKey(h));return Boolean(g&&g.value)}getActivatedExtension(h){const g=this._operations.get(u.ExtensionIdentifier.toKey(h));if(!g||!g.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return g.value}async activateByEvent(h,g){if(this._alreadyActivatedEvents[h])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(h);await this._activateExtensions(v.map(C=>({id:C.identifier,reason:{startup:g,extensionId:C.identifier,activationEvent:h}}))),this._alreadyActivatedEvents[h]=!0}activateById(h,g){const v=this._registry.getExtensionDescription(h);if(!v)throw new Error(`Extension '${h}' is not known`);return this._activateExtensions([{id:v.identifier,reason:g}])}async _activateExtensions(h){const g=h.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(g.map(v=>v.wait()))}_handleActivationRequest(h){if(this._operations.has(u.ExtensionIdentifier.toKey(h.id)))return this._operations.get(u.ExtensionIdentifier.toKey(h.id));if(this._isHostExtension(h.id))return this._createAndSaveOperation(h,null,[],null);const g=this._registry.getExtensionDescription(h.id);if(!g){const p=new Error(`Cannot activate unknown extension '${h.id.value}'`),i=this._createAndSaveOperation(h,null,[],new k(p));return this._host.onExtensionActivationError(h.id,p,new A.MissingExtensionDependency(h.id.value)),i}const v=[],C=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const p of C){if(this._isResolvedExtension(p))continue;const i=this._operations.get(u.ExtensionIdentifier.toKey(p));if(i){v.push(i);continue}if(this._isHostExtension(p)){v.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(p).identifier,reason:h.reason}));continue}const o=this._registry.getExtensionDescription(p);if(o){if(!o.main&&!o.browser)continue;v.push(this._handleActivationRequest({id:o.identifier,reason:h.reason}));continue}const s=g.displayName||g.identifier.value,l=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${p}'`),r=this._createAndSaveOperation(h,g.displayName,[],new k(l));return this._host.onExtensionActivationError(g.identifier,l,new A.MissingExtensionDependency(p)),r}return this._createAndSaveOperation(h,g.displayName,v,null)}_createAndSaveOperation(h,g,v,C){const p=new f(h.id,g,h.reason,v,C,this._host,this._logService);return this._operations.set(u.ExtensionIdentifier.toKey(h.id),p),p}_isHostExtension(h){return P.ExtensionDescriptionRegistry.isHostExtension(h,this._registry,this._globalRegistry)}_isResolvedExtension(h){const g=this._globalRegistry.getExtensionDescription(h);return g?!g.main&&!g.browser:!1}};w=Ve([We(3,_.ILogService)],w),e.ExtensionsActivator=w;let f=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(h,g,v,C,p,i,o){this._id=h,this._displayName=g,this._reason=v,this._deps=C,this._value=p,this._host=i,this._logService=o,this._barrier=new T.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let h=0;h<this._deps.length;h++){const g=this._deps[h];if(g.value&&!g.value.activationFailed){this._deps.splice(h,1),h--;continue}if(g.value&&g.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);v.detail=g.value.activationFailedError,this._value=new k(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(h=>h.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(h){const g=new Error;if(h&&h.name&&(g.name=h.name),h&&h.message?g.message=`Activating extension '${this._id.value}' failed: ${h.message}.`:g.message=`Activating extension '${this._id.value}' failed: ${h}.`,h&&h.stack&&(g.stack=h.stack),this._value=new k(g),this._isDisposed&&a.isCancellationError(h))return;this._host.onExtensionActivationError(this._id,g,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(h)}}};f=Ve([We(6,_.ILogService)],f)});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[7],ye([1,0,16,11,112,28,87,8,9,2,30,44,128,92,27]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w){"use strict";var f,d,h,g,v,C,p,i,o,s,l,r,m,n,t,c,E,y,M,j,$,N,x;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function L(q){return Object.assign(q,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(q,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(q,[]);{const[me,...Te]=arguments;return Reflect.construct(q,Te,me.constructor)}}})}var F;(function(q){q[q.Top=0]="Top",q[q.Bottom=1]="Bottom"})(F=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var U;(function(q){q[q.Command=0]="Command",q[q.Opener=1]="Opener"})(U=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let H=C=class{static from(...z){let me=z;return new C(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}constructor(z){f.set(this,void 0),Je(this,f,z,"f")}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),Je(this,f,void 0,"f"))}};f=new WeakMap,H=C=Ve([L],H),e.Disposable=H;let de=p=class{static Min(...z){if(z.length===0)throw new TypeError;let me=z[0];for(let Te=1;Te<z.length;Te++){const qe=z[Te];qe.isBefore(me)&&(me=qe)}return me}static Max(...z){if(z.length===0)throw new TypeError;let me=z[0];for(let Te=1;Te<z.length;Te++){const qe=z[Te];qe.isAfter(me)&&(me=qe)}return me}static isPosition(z){if(!z)return!1;if(z instanceof p)return!0;const{line:me,character:Te}=z;return typeof me=="number"&&typeof Te=="number"}static of(z){if(z instanceof p)return z;if(this.isPosition(z))return new p(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(z,me){if(z<0)throw(0,P.illegalArgument)("line must be non-negative");if(me<0)throw(0,P.illegalArgument)("character must be non-negative");this._line=z,this._character=me}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,me=0){if(z===null||me===null)throw(0,P.illegalArgument)();let Te;return typeof z>"u"?Te=0:typeof z=="number"?Te=z:(Te=typeof z.lineDelta=="number"?z.lineDelta:0,me=typeof z.characterDelta=="number"?z.characterDelta:0),Te===0&&me===0?this:new p(this.line+Te,this.character+me)}with(z,me=this.character){if(z===null||me===null)throw(0,P.illegalArgument)();let Te;return typeof z>"u"?Te=this.line:typeof z=="number"?Te=z:(Te=typeof z.line=="number"?z.line:this.line,me=typeof z.character=="number"?z.character:this.character),Te===this.line&&me===this.character?this:new p(Te,me)}toJSON(){return{line:this.line,character:this.character}}};de=p=Ve([L],de),e.Position=de;let Y=i=class{static isRange(z){return z instanceof i?!0:z?de.isPosition(z.start)&&de.isPosition(z.end):!1}static of(z){if(z instanceof i)return z;if(this.isRange(z))return new i(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(z,me,Te,qe){let Ye,at;if(typeof z=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof qe=="number"?(Ye=new de(z,me),at=new de(Te,qe)):de.isPosition(z)&&de.isPosition(me)&&(Ye=de.of(z),at=de.of(me)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this._start=Ye,this._end=at):(this._start=at,this._end=Ye)}contains(z){return i.isRange(z)?this.contains(z.start)&&this.contains(z.end):de.isPosition(z)?!(de.of(z).isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const me=de.Max(z.start,this._start),Te=de.Min(z.end,this._end);if(!me.isAfter(Te))return new i(me,Te)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const me=de.Min(z.start,this._start),Te=de.Max(z.end,this.end);return new i(me,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,me=this.end){if(z===null||me===null)throw(0,P.illegalArgument)();let Te;return z?de.isPosition(z)?Te=z:(Te=z.start||this.start,me=z.end||this.end):Te=this.start,Te.isEqual(this._start)&&me.isEqual(this.end)?this:new i(Te,me)}toJSON(){return[this.start,this.end]}};Y=i=Ve([L],Y),e.Range=Y;let V=o=class extends Y{static isSelection(z){return z instanceof o?!0:z?Y.isRange(z)&&de.isPosition(z.anchor)&&de.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(z,me,Te,qe){let Ye,at;if(typeof z=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof qe=="number"?(Ye=new de(z,me),at=new de(Te,qe)):de.isPosition(z)&&de.isPosition(me)&&(Ye=de.of(z),at=de.of(me)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this._anchor=Ye,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=o=Ve([L],V),e.Selection=V;class X{constructor(z,me,Te){if(typeof z!="string"||z.length===0)throw(0,P.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,P.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,P.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(me),this.connectionToken=Te}}e.ResolvedAuthority=X;class Z extends Error{static NotAvailable(z,me){return new Z(z,b.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(z){return new Z(z,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,me=b.RemoteAuthorityResolverErrorCode.Unknown,Te){super(z),this._message=z,this._code=me,this._detail=Te,Object.setPrototypeOf(this,Z.prototype)}}e.RemoteAuthorityResolverError=Z;var te;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(te=e.EndOfLine||(e.EndOfLine={}));var K;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(K=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=s=class{static isTextEdit(z){return z instanceof s?!0:z?Y.isRange(z)&&typeof z.newText=="string":!1}static replace(z,me){return new s(z,me)}static insert(z,me){return s.replace(new Y(z,z),me)}static delete(z){return s.replace(z,"")}static setEndOfLine(z){const me=new s(new Y(new de(0,0),new de(0,0)),"");return me.newEol=z,me}get range(){return this._range}set range(z){if(z&&!Y.isRange(z))throw(0,P.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,P.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,P.illegalArgument)("newEol");this._newEol=z}constructor(z,me){this._range=z,this._newText=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};J=s=Ve([L],J),e.TextEdit=J;let ne=l=class{static isNotebookCellEdit(z){return z instanceof l?!0:z?jt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,me){return new l(z,me)}static insertCells(z,me){return new l(new jt(z,z),me)}static deleteCells(z){return new l(z,[])}static updateCellMetadata(z,me){const Te=new l(new jt(z,z),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(z){const me=new l(new jt(0,0),[]);return me.newNotebookMetadata=z,me}constructor(z,me){this.range=z,this.newCells=me}};ne=l=Ve([L],ne),e.NotebookEdit=ne;class pe{static isSnippetTextEdit(z){return z instanceof pe?!0:z?Y.isRange(z.range)&&Le.isSnippetString(z.snippet):!1}static replace(z,me){return new pe(z,me)}static insert(z,me){return pe.replace(new Y(z,z),me)}constructor(z,me){this.range=z,this.snippet=me}}e.SnippetTextEdit=pe;var be;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(be=e.FileEditType||(e.FileEditType={}));let Ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,me,Te,qe){this._edits.push({_type:1,from:z,to:me,options:Te,metadata:qe})}createFile(z,me,Te){this._edits.push({_type:1,from:void 0,to:z,options:me,metadata:Te})}deleteFile(z,me,Te){this._edits.push({_type:1,from:z,to:void 0,options:me,metadata:Te})}replaceNotebookMetadata(z,me,Te){this._edits.push({_type:3,metadata:Te,uri:z,edit:{editType:5,metadata:me},notebookMetadata:me})}replaceNotebookCells(z,me,Te,qe){const Ye=me.start,at=me.end;(Ye!==at||Te.length>0)&&this._edits.push({_type:5,uri:z,index:Ye,count:at-Ye,cells:Te,metadata:qe})}replaceNotebookCellMetadata(z,me,Te,qe){this._edits.push({_type:3,metadata:qe,uri:z,edit:{editType:8,index:me,metadata:Te}})}replace(z,me,Te,qe){this._edits.push({_type:2,uri:z,edit:new J(me,Te),metadata:qe})}insert(z,me,Te,qe){this.replace(z,new Y(me,me),Te,qe)}delete(z,me,Te){this.replace(z,me,"",Te)}has(z){return this._edits.some(me=>me._type===2&&me.uri.toString()===z.toString())}set(z,me){if(me)for(const Te of me){if(!Te)continue;let qe,Ye;Array.isArray(Te)?(qe=Te[0],Ye=Te[1]):qe=Te,ne.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(z,qe.range.start,qe.newCellMetadata,Ye):qe.newNotebookMetadata?this.replaceNotebookMetadata(z,qe.newNotebookMetadata,Ye):this.replaceNotebookCells(z,qe.range,qe.newCells,Ye):pe.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:z,range:qe.range,edit:qe.snippet,metadata:Ye}):this._edits.push({_type:2,uri:z,edit:qe,metadata:Ye})}else{for(let Te=0;Te<this._edits.length;Te++){const qe=this._edits[Te];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===z.toString()&&(this._edits[Te]=void 0);break}}(0,a.coalesceInPlace)(this._edits)}}get(z){const me=[];for(const Te of this._edits)Te._type===2&&Te.uri.toString()===z.toString()&&me.push(Te.edit);return me}entries(){const z=new A.ResourceMap;for(const me of this._edits)if(me._type===2){let Te=z.get(me.uri);Te||(Te=[me.uri,[]],z.set(me.uri,Te)),Te[1].push(me.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ie=Ve([L],Ie),e.WorkspaceEdit=Ie;let Le=r=class{static isSnippetString(z){return z instanceof r?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this._tabstop=1,this.value=z||""}appendText(z){return this.value+=r._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,me=this._tabstop++){if(typeof z=="function"){const Te=new r;Te._tabstop=this._tabstop,z(Te),this._tabstop=Te._tabstop,z=Te.value}else z=r._escape(z);return this.value+="${",this.value+=me,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,me=this._tabstop++){const Te=z.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(z,me){if(typeof me=="function"){const Te=new r;Te._tabstop=this._tabstop,me(Te),this._tabstop=Te._tabstop,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Le=r=Ve([L],Le),e.SnippetString=Le;var oe;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=m=class{static isLocation(z){return z instanceof m?!0:z?Y.isRange(z.range)&&D.URI.isUri(z.uri):!1}constructor(z,me){if(this.uri=z,me)if(Y.isRange(me))this.range=Y.of(me);else if(de.isPosition(me))this.range=new Y(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};fe=m=Ve([L],fe),e.Location=fe;let ee=class{static is(z){return z?typeof z.message=="string"&&z.location&&Y.isRange(z.location.range)&&D.URI.isUri(z.location.uri):!1}constructor(z,me){this.location=z,this.message=me}static isEqual(z,me){return z===me?!0:!z||!me?!1:z.message===me.message&&z.location.range.isEqual(me.location.range)&&z.location.uri.toString()===me.location.uri.toString()}};ee=Ve([L],ee),e.DiagnosticRelatedInformation=ee;let le=class{constructor(z,me,Te=ae.Error){if(!Y.isRange(z))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=z,this.message=me,this.severity=Te}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,me){return z===me?!0:!z||!me?!1:z.message===me.message&&z.severity===me.severity&&z.code===me.code&&z.severity===me.severity&&z.source===me.source&&z.range.isEqual(me.range)&&(0,a.equals)(z.tags,me.tags)&&(0,a.equals)(z.relatedInformation,me.relatedInformation,ee.isEqual)}};le=Ve([L],le),e.Diagnostic=le;let re=class{constructor(z,me){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=me}};re=Ve([L],re),e.Hover=re;var O;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(O=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let W=class{constructor(z,me=O.Text){this.range=z,this.kind=me}toJSON(){return{range:this.range,kind:O[this.kind]}}};W=Ve([L],W),e.DocumentHighlight=W;var G;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(G=e.SymbolKind||(e.SymbolKind={}));var Q;(function(q){q[q.Deprecated=1]="Deprecated"})(Q=e.SymbolTag||(e.SymbolTag={}));let he=n=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,me,Te,qe,Ye){this.name=z,this.kind=me,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),qe instanceof fe?this.location=qe:Te instanceof Y&&(this.location=new fe(qe,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:G[this.kind],location:this.location,containerName:this.containerName}}};he=n=Ve([L],he),e.SymbolInformation=he;let Ee=t=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(t.validate)}constructor(z,me,Te,qe,Ye){this.name=z,this.detail=me,this.kind=Te,this.range=qe,this.selectionRange=Ye,this.children=[],t.validate(this)}};Ee=t=Ve([L],Ee),e.DocumentSymbol=Ee;var Pe;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ve=class{constructor(z,me){this.title=z,this.kind=me}};ve=Ve([L],ve),e.CodeAction=ve;let Ce=c=class{constructor(z){this.value=z}append(z){return new c(this.value?this.value+c.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+c.sep)}};Ce.sep=".",Ce=c=Ve([L],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let ke=class{constructor(z,me){if(this.range=z,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=Ve([L],ke),e.SelectionRange=ke;class $e{constructor(z,me,Te,qe,Ye,at){this.kind=z,this.name=me,this.detail=Te,this.uri=qe,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=$e;class je{constructor(z,me){this.fromRanges=me,this.from=z}}e.CallHierarchyIncomingCall=je;class et{constructor(z,me){this.fromRanges=me,this.to=z}}e.CallHierarchyOutgoingCall=et;var Xe;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(z,me){this.range=z,this.command=me}get isResolved(){return!!this.command}};nt=Ve([L],nt),e.CodeLens=nt;let st=E=class{static isMarkdownString(z){return z instanceof E?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,me=!1){d.set(this,void 0),Je(this,d,new u.MarkdownString(z,{supportThemeIcons:me}),"f")}get value(){return Ue(this,d,"f").value}set value(z){Ue(this,d,"f").value=z}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(z){Ue(this,d,"f").isTrusted=z}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}set supportThemeIcons(z){Ue(this,d,"f").supportThemeIcons=z}get supportHtml(){return Ue(this,d,"f").supportHtml}set supportHtml(z){Ue(this,d,"f").supportHtml=z}get baseUri(){return Ue(this,d,"f").baseUri}set baseUri(z){Ue(this,d,"f").baseUri=z}appendText(z){return Ue(this,d,"f").appendText(z),this}appendMarkdown(z){return Ue(this,d,"f").appendMarkdown(z),this}appendCodeblock(z,me){return Ue(this,d,"f").appendCodeblock(me??"",z),this}};d=new WeakMap,st=E=Ve([L],st),e.MarkdownString=st;let ht=class{constructor(z,me){this.label=z,this.documentation=me}};ht=Ve([L],ht),e.ParameterInformation=ht;let Fe=class{constructor(z,me){this.label=z,this.documentation=me,this.parameters=[]}};Fe=Ve([L],Fe),e.SignatureInformation=Fe;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=Ve([L],rt),e.SignatureHelp=rt;var ce;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(ce=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var B;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(B=e.InlayHintKind||(e.InlayHintKind={}));let ue=class{constructor(z){this.value=z}};ue=Ve([L],ue),e.InlayHintLabelPart=ue;let De=class{constructor(z,me,Te){this.position=z,this.label=me,this.kind=Te}};De=Ve([L],De),e.InlayHint=De;var Re;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var xe;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(xe=e.CompletionItemKind||(e.CompletionItemKind={}));var Ge;(function(q){q[q.Deprecated=1]="Deprecated"})(Ge=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(z,me){this.label=z,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=Ve([L],Ze),e.CompletionItem=Ze;let pt=class{constructor(z=[],me=!1){this.items=z,this.isIncomplete=me}};pt=Ve([L],pt),e.CompletionList=pt;let gt=class{constructor(z,me,Te){this.insertText=z,this.range=me,this.command=Te}};gt=Ve([L],gt),e.InlineSuggestion=gt;let ct=class{constructor(z){this.commands=void 0,this.items=z}};ct=Ve([L],ct),e.InlineSuggestionList=ct;var wt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(wt=e.ViewColumn||(e.ViewColumn={}));var tt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pt;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Pt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Gt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Gt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var At;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(At=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var mt;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(mt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function z(me){switch(me){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=z}(At=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let xt=class{constructor(z,me){if(me&&!D.URI.isUri(me))throw(0,P.illegalArgument)("target");if(!Y.isRange(z)||z.isEmpty)throw(0,P.illegalArgument)("range");this.range=z,this.target=me}};xt=Ve([L],xt),e.DocumentLink=xt;let Ot=class{constructor(z,me,Te,qe){this.red=z,this.green=me,this.blue=Te,this.alpha=qe}};Ot=Ve([L],Ot),e.Color=Ot;let Ke=class{constructor(z,me){if(me&&!(me instanceof Ot))throw(0,P.illegalArgument)("color");if(!Y.isRange(z)||z.isEmpty)throw(0,P.illegalArgument)("range");this.range=z,this.color=me}};Ke=Ve([L],Ke),e.ColorInformation=Ke;let Nt=class{constructor(z){if(!z||typeof z!="string")throw(0,P.illegalArgument)("label");this.label=z}};Nt=Ve([L],Nt),e.ColorPresentation=Nt;var Ft;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ft=e.ColorFormat||(e.ColorFormat={}));var Wt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var vt;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(vt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(z,me,Te){if(this.startIndex=z,this.length=me,this.tooltip=Te,typeof z!="number"||z<0)throw(0,P.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,P.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,P.illegalArgument)("tooltip")}}e.TerminalLink=Ae;class Oe{constructor(z){this.uri=z}}e.TerminalQuickFixOpener=Oe;class Se{constructor(z){this.terminalCommand=z}}e.TerminalQuickFixCommand=Se;var se;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(se=e.TerminalLocation||(e.TerminalLocation={}));class Me{constructor(z){if(this.options=z,typeof z!="object")throw(0,P.illegalArgument)("options")}}e.TerminalProfile=Me;var ze;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ze=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let He=y=class{static from(z){switch(z){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(z,me){if(this.label=me,typeof z!="string"||typeof me!="string")throw(0,P.illegalArgument)("name");this._id=z}get id(){return this._id}};He.Clean=new y("clean","Clean"),He.Build=new y("build","Build"),He.Rebuild=new y("rebuild","Rebuild"),He.Test=new y("test","Test"),He=y=Ve([L],He),e.TaskGroup=He;function it(q){let z="";for(let me=0;me<q.length;me++)z+=q[me].replace(/,/g,",,")+",";return z}let lt=class{constructor(z,me,Te){if(typeof z!="string")throw(0,P.illegalArgument)("process");this._args=[],this._process=z,me!==void 0&&(Array.isArray(me)?(this._args=me,this._options=Te):this._options=me)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,P.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(const me of this._args)z.push(me);return it(z)}};lt=Ve([L],lt),e.ProcessExecution=lt;let Tt=class{constructor(z,me,Te){if(this._args=[],Array.isArray(me)){if(!z)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,P.illegalArgument)("command");this._command=z,this._args=me,this._options=Te}else{if(typeof z!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=z,this._options=me}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,P.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const me of this._args)z.push(typeof me=="string"?me:me.value);return it(z)}};Tt=Ve([L],Tt),e.ShellExecution=Tt;var St;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class It{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=It;let yt=M=class{constructor(z,me,Te,qe,Ye,at){this.__deprecated=!1,this._definition=this.definition=z;let dt;typeof me=="string"?(this._name=this.name=me,this._source=this.source=Te,this.execution=qe,dt=Ye,this.__deprecated=!0):me===_t.Global||me===_t.Workspace?(this.target=me,this._name=this.name=Te,this._source=this.source=qe,this.execution=Ye,dt=at):(this.target=me,this._name=this.name=Te,this._source=this.source=qe,this.execution=Ye,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof lt?this._definition={type:M.ProcessType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:M.ShellType,id:this._execution.computeId()}:this._execution instanceof It?this._definition={type:M.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:M.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,P.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const me=this._definition.type;(M.EmptyType===me||M.ProcessType===me||M.ShellType===me||M.ExtensionCallbackType===me)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};yt.ExtensionCallbackType="customExecution",yt.ProcessType="process",yt.ShellType="shell",yt.EmptyType="$empty",yt=M=Ve([L],yt),e.Task=yt;var Ct;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(Ct=e.ProgressLocation||(e.ProgressLocation={}));var Vt;(function(q){function z(me){const Te=me;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}q.isViewBadge=z})(Vt=e.ViewBadge||(e.ViewBadge={}));let Jt=j=class{static isTreeItem(z,me){if(z instanceof j)return!0;const Te=z;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!D.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const qe=Te.iconPath;if(!qe||!(0,S.isString)(qe.light)&&!D.URI.isUri(qe.light)&&!(0,S.isString)(qe.dark)&&!D.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!D.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<Et.None&&Te.collapsibleState>Et.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,w.checkProposedApiEnabled)(me,"treeItemCheckbox");const qe=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(qe===void 0||qe!==si.Checked&&qe!==si.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(z,me=Et.None){this.collapsibleState=me,D.URI.isUri(z)?this.resourceUri=z:this.label=z}};Jt=j=Ve([L],Jt),e.TreeItem=Jt;var Et;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z,me){this.value=z,this.id=me??(0,R.generateUuid)()}};oi=Ve([L],oi),e.DataTransferItem=oi;let Zt=class{constructor(z){h.set(this,new Map);for(const[me,Te]of z??[]){const qe=Ue(this,h,"f").get(me);qe?qe.push(Te):Ue(this,h,"f").set(me,[Te])}}get(z){return Ue(this,h,"f").get(z)?.[0]}set(z,me){Ue(this,h,"f").set(z,[me])}forEach(z,me){for(const[Te,qe]of Ue(this,h,"f"))for(const Ye of qe)z.call(me,Ye,Te,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[z,me]of Ue(this,h,"f"))for(const Te of me)yield[z,Te]}};Zt=Ve([L],Zt),e.DataTransfer=Zt;let vi=class{constructor(z){this.insertText=z}};vi=Ve([L],vi),e.DocumentDropEdit=vi;let Rt=class{constructor(z){this.insertText=z}};Rt=Ve([L],Rt),e.DocumentPasteEdit=Rt;let zt=class{constructor(z,me){this.id=z,this.color=me}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};zt=Ve([L],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let bi=class{constructor(z){this.id=z}};bi=Ve([L],bi),e.ThemeColor=bi;var ai;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this._base}set base(z){this._base=z,this._baseUri=D.URI.file(z)}get baseUri(){return this._baseUri}set baseUri(z){this._baseUri=z,this._base=z.fsPath}constructor(z,me){if(typeof z!="string"&&(!z||!D.URI.isUri(z)&&!D.URI.isUri(z.uri)))throw(0,P.illegalArgument)("base");if(typeof me!="string")throw(0,P.illegalArgument)("pattern");typeof z=="string"?this.baseUri=D.URI.file(z):D.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=Ve([L],ei),e.RelativePattern=ei;const ut=new WeakMap;function Ui(q,z){ut.set(q,z)}e.setBreakpointId=Ui;let Ut=class{constructor(z,me,Te,qe){this.enabled=typeof z=="boolean"?z:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=ut.get(this)??(0,R.generateUuid)()),this._id}};Ut=Ve([L],Ut),e.Breakpoint=Ut;let Xt=class extends Ut{constructor(z,me,Te,qe,Ye){if(super(me,Te,qe,Ye),z===null)throw(0,P.illegalArgument)("location");this.location=z}};Xt=Ve([L],Xt),e.SourceBreakpoint=Xt;let ci=class extends Ut{constructor(z,me,Te,qe,Ye){super(me,Te,qe,Ye),this.functionName=z}};ci=Ve([L],ci),e.FunctionBreakpoint=ci;let Ei=class extends Ut{constructor(z,me,Te,qe,Ye,at,dt){if(super(qe,Ye,at,dt),!me)throw(0,P.illegalArgument)("dataId");this.label=z,this.dataId=me,this.canPersist=Te}};Ei=Ve([L],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(z,me,Te){this.command=z,this.args=me||[],this.options=Te}};wi=Ve([L],wi),e.DebugAdapterExecutable=wi;let li=class{constructor(z,me){this.port=z,this.host=me}};li=Ve([L],li),e.DebugAdapterServer=li;let Si=class{constructor(z){this.path=z}};Si=Ve([L],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(z){this.implementation=z}};ui=Ve([L],ui),e.DebugAdapterInlineImplementation=ui;let ti=class{constructor(z,me){this.range=z,this.expression=me}};ti=Ve([L],ti),e.EvaluatableExpression=ti;var xi;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(xi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(z,me){this.range=z,this.text=me}};ii=Ve([L],ii),e.InlineValueText=ii;let ni=class{constructor(z,me,Te=!0){this.range=z,this.variableName=me,this.caseSensitiveLookup=Te}};ni=Ve([L],ni),e.InlineValueVariableLookup=ni;let _i=class{constructor(z,me){this.range=z,this.expression=me}};_i=Ve([L],_i),e.InlineValueEvaluatableExpression=_i;let yi=class{constructor(z,me){this.frameId=z,this.stoppedLocation=me}};yi=Ve([L],yi),e.InlineValueContext=yi;var ri;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ci=$=class extends Error{static FileExists(z){return new $(z,I.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(z){return new $(z,I.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(z){return new $(z,I.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(z){return new $(z,I.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(z){return new $(z,I.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(z){return new $(z,I.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(z,me=I.FileSystemProviderErrorCode.Unknown,Te){super(D.URI.isUri(z)?z.toString(!0):z),this.code=Te?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Ci=$=Ve([L],Ci),e.FileSystemError=Ci;let Di=class{constructor(z,me,Te){this.start=z,this.end=me,this.kind=Te}};Di=Ve([L],Di),e.FoldingRange=Di;var Bi;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var zi;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(zi=e.CommentMode||(e.CommentMode={}));var Ii;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(Ii=e.CommentThreadState||(e.CommentThreadState={}));class Ai{constructor(z,me=[]){this.tokenTypes=z,this.tokenModifiers=me}}e.SemanticTokensLegend=Ai;function Ri(q){return typeof q>"u"||(0,S.isStringArray)(q)}class Be{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let me=0,Te=z.tokenTypes.length;me<Te;me++)this._tokenTypeStrToInt.set(z.tokenTypes[me],me);for(let me=0,Te=z.tokenModifiers.length;me<Te;me++)this._tokenModifierStrToInt.set(z.tokenModifiers[me],me)}}push(z,me,Te,qe,Ye){if(typeof z=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof qe=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(z,me,Te,qe,Ye);if(Y.isRange(z)&&typeof me=="string"&&Ri(Te))return this._push(z,me,Te);throw(0,P.illegalArgument)()}_push(z,me,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(me))throw new Error("`tokenType` is not in the provided legend");const qe=z.start.line,Ye=z.start.character,at=z.end.character-z.start.character,dt=this._tokenTypeStrToInt.get(me);let Mt=0;if(Te)for(const $t of Te){if(!this._tokenModifierStrToInt.has($t))throw new Error("`tokenModifier` is not in the provided legend");const qt=this._tokenModifierStrToInt.get($t);Mt|=1<<qt>>>0}this._pushEncoded(qe,Ye,at,dt,Mt)}_pushEncoded(z,me,Te,qe,Ye){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&me<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Mt=this._data.length/5|0;let $t=0,qt=0;for(let Kt=0;Kt<Mt;Kt++){let Qt=this._data[5*Kt],Ti=this._data[5*Kt+1];Qt===0?(Qt=$t,Ti+=qt):Qt+=$t,this._data[5*Kt]=Qt,this._data[5*Kt+1]=Ti,$t=Qt,qt=Ti}}let at=z,dt=me;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Ye,this._prevLine=z,this._prevChar=me}static _sortAndDeltaEncode(z){const me=[],Te=z.length/5|0;for(let dt=0;dt<Te;dt++)me[dt]=dt;me.sort((dt,Mt)=>{const $t=z[5*dt],qt=z[5*Mt];if($t===qt){const Kt=z[5*dt+1],Qt=z[5*Mt+1];return Kt-Qt}return $t-qt});const qe=new Uint32Array(z.length);let Ye=0,at=0;for(let dt=0;dt<Te;dt++){const Mt=5*me[dt],$t=z[Mt+0],qt=z[Mt+1],Kt=z[Mt+2],Qt=z[Mt+3],Ti=z[Mt+4],sn=$t-Ye,An=sn===0?qt-at:qt,Pi=5*dt;qe[Pi+0]=sn,qe[Pi+1]=An,qe[Pi+2]=Kt,qe[Pi+3]=Qt,qe[Pi+4]=Ti,Ye=$t,at=qt}return qe}build(z){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),z):new Ht(Be._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=Be;class Ht{constructor(z,me){this.resultId=me,this.data=z}}e.SemanticTokens=Ht;class Li{constructor(z,me,Te){this.start=z,this.deleteCount=me,this.data=Te}}e.SemanticTokensEdit=Li;class bt{constructor(z,me){this.resultId=me,this.edits=z}}e.SemanticTokensEdits=bt;var Hi;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Hi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new zt("arrow-left")},di=Ve([L],di),e.QuickInputButtons=di;var Oi;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(Oi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var $i;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})($i=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class Vi{static validate(z){if(typeof z.badge=="string"){let me=(0,T.nextCharLength)(z.badge,0);if(me<z.badge.length&&(me+=(0,T.nextCharLength)(z.badge,me)),z.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!zt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,me,Te){this.badge=z,this.tooltip=me,this.color=Te}}e.FileDecoration=Vi;let ki=class{constructor(z){this.kind=z}};ki=Ve([L],ki),e.ColorTheme=ki;var ji;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(ji=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange(z){return z instanceof jt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(z,me){if(z<0)throw(0,P.illegalArgument)("start must be positive");if(me<0)throw(0,P.illegalArgument)("end must be positive");z<=me?(this._start=z,this._end=me):(this._start=me,this._end=z)}with(z){let me=this._start,Te=this._end;return z.start!==void 0&&(me=z.start),z.end!==void 0&&(Te=z.end),me===this._start&&Te===this._end?this:new jt(me,Te)}}e.NotebookRange=jt;class fi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(me=>fi.isNotebookCellData(me))}static isNotebookCellData(z){return!0}constructor(z,me,Te,qe,Ye,at,dt){this.kind=z,this.value=me,this.languageId=Te,this.mime=qe,this.outputs=Ye??[],this.metadata=at,this.executionSummary=dt,fi.validate(this)}}e.NotebookCellData=fi;class qi{constructor(z){this.cells=z}}e.NotebookData=qi;class Bt{static isNotebookCellOutputItem(z){return z instanceof Bt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const me={name:z.name,message:z.message,stack:z.stack};return Bt.json(me,"application/vnd.code.notebook.error")}static stdout(z){return Bt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Bt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,me="application/octet-stream"){return new Bt(z,me)}static text(z,me=_.Mimes.text){const Te=Ue(Bt,g,"f",v).encode(String(z));return new Bt(Te,me)}static json(z,me="text/x-json"){const Te=JSON.stringify(z,void 0,"	");return Bt.text(Te,me)}constructor(z,me){this.data=z,this.mime=me;const Te=(0,_.normalizeMimeType)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}g=Bt,v={value:new TextEncoder},e.NotebookCellOutputItem=Bt;class mi{static isNotebookCellOutput(z){return z instanceof mi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,me=!1){const Te=new Set,qe=new Set;for(let Ye=0;Ye<z.length;Ye++){const at=z[Ye],dt=(0,_.normalizeMimeType)(at.mime);if(!Te.has(dt)||(0,k.isTextStreamMime)(dt)){Te.add(dt);continue}qe.add(Ye),me&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return qe.size===0?z:z.filter((Ye,at)=>!qe.has(at))}constructor(z,me,Te){this.items=mi.ensureUniqueMimeTypes(z,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,R.generateUuid)(),this.metadata=me??Te)}}e.NotebookCellOutput=mi;var Gi;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Gi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ki;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ge;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ge=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var we;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(we=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ne{constructor(z,me){this.text=z,this.alignment=me}}e.NotebookCellStatusBarItem=Ne;var ot;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Lt{constructor(z,me=[]){this.uri=z,this.provides=(0,a.asArray)(me)}}e.NotebookRendererScript=Lt;class ln{constructor(z){this.label=z}}e.NotebookKernelSourceAction=ln;let Xi=class{constructor(z,me){this.label=z,this.timestamp=me}};Xi=Ve([L],Xi),e.TimelineItem=Xi;var un;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(z,me){this.ranges=z,this.wordPattern=me}}e.LinkedEditingRanges=fn;class mn{constructor(z,me){this._port=z,this._autoForwardAction=me}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=mn;var gn;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Mi=class{constructor(z=void 0,me=void 0,Te=void 0){this.include=z,this.exclude=me,this.profile=Te}};Mi=Ve([L],Mi),e.TestRunRequest=Mi;let Qi=class extends Mi{constructor(z=void 0,me=void 0,Te=void 0,qe=!1){super(z,me,Te),this.continuous=qe}};Qi=Ve([L],Qi),e.TestRunRequest2=Qi;let Yi=N=class{static diff(z,me,Te){const qe=new N(z);return qe.expectedOutput=me,qe.actualOutput=Te,qe}constructor(z){this.message=z}};Yi=N=Ve([L],Yi),e.TestMessage=Yi;let Ji=class{constructor(z){this.id=z}};Ji=Ve([L],Ji),e.TestTag=Ji;let gi=class{constructor(z,me){this.covered=z,this.total=me}};gi=Ve([L],gi),e.CoveredCount=gi;let Zi=x=class{static fromDetails(z,me){const Te=new gi(0,0),qe=new gi(0,0),Ye=new gi(0,0);for(const dt of me)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Mt of dt.branches)qe.total+=1,qe.covered+=Mt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const at=new x(z,Te,qe.total>0?qe:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=me,at}constructor(z,me,Te,qe){this.uri=z,this.statementCoverage=me,this.branchCoverage=Te,this.functionCoverage=qe}};Zi=x=Ve([L],Zi),e.FileCoverage=Zi;let en=class{constructor(z,me,Te=[]){this.executionCount=z,this.location=me,this.branches=Te}};en=Ve([L],en),e.StatementCoverage=en;let tn=class{constructor(z,me){this.executionCount=z,this.location=me}};tn=Ve([L],tn),e.BranchCoverage=tn;let nn=class{constructor(z,me){this.executionCount=z,this.location=me}};nn=Ve([L],nn),e.FunctionCoverage=nn;var vn;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(z,me,Te,qe,Ye,at){this.kind=z,this.name=me,this.detail=Te,this.uri=qe,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=wn;class Sn{constructor(z){this.uri=z}}e.TextTabInput=Sn;class _n{constructor(z,me){this.original=z,this.modified=me}}e.TextDiffTabInput=_n;class yn{constructor(z,me,Te,qe){this.base=z,this.input1=me,this.input2=Te,this.result=qe}}e.TextMergeTabInput=yn;class Cn{constructor(z,me){this.uri=z,this.viewType=me}}e.CustomEditorTabInput=Cn;class Dn{constructor(z){this.viewType=z}}e.WebviewEditorTabInput=Dn;class In{constructor(z,me){this.uri=z,this.notebookType=me}}e.NotebookEditorTabInput=In;class kn{constructor(z,me,Te){this.original=z,this.modified=me,this.notebookType=Te}}e.NotebookDiffEditorTabInput=kn;class Tn{constructor(){}}e.TerminalEditorTabInput=Tn;class Pn{constructor(z,me){this.uri=z,this.inputBoxUri=me}}e.InteractiveWindowInput=Pn}),define(_e[135],ye([1,0,50,14,8,165,106,7,16]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const D=new Map;function R(w,f){f?D.set(w,f):D.delete(w)}e.setWordDefinitionFor=R;function I(w){return D.get(w)}class b extends A.MirrorTextModel{constructor(f,d,h,g,v,C,p,i){super(d,h,g,v),this._proxy=f,this._languageId=C,this._isDirty=p,this.notebook=i,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,S.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===P.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},save(){return f._save()},getText(d){return d?f._getTextInRange(d):f.getText()},get eol(){return f._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(d){return f._lineAt(d)},offsetAt(d){return f._offsetAt(d)},positionAt(d){return f._positionAt(d)},validateRange(d){return f._validateRange(d)},validatePosition(d){return f._validatePosition(d)},getWordRangeAtPosition(d,h){return f._getWordRangeAtPosition(d,h)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,a.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,a.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const d=this._validateRange(f);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const h=this._eol,g=d.start.line,v=d.end.line,C=[];C.push(this._lines[g].substring(d.start.character));for(let p=g+1;p<v;p++)C.push(this._lines[p]);return C.push(this._lines[v].substring(0,d.end.character)),C.join(h)}_lineAt(f){let d;if(f instanceof T.Position?d=f.line:typeof f=="number"&&(d=f),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new k(d,this._lines[d],d===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getPrefixSum(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(f),h=this._lines[d.index].length;return new T.Position(d.index,Math.min(d.remainder,h))}_validateRange(f){if(!(f instanceof T.Range))throw new Error("Invalid argument");const d=this._validatePosition(f.start),h=this._validatePosition(f.end);return d===f.start&&h===f.end?f:new T.Range(d.line,d.character,h.line,h.character)}_validatePosition(f){if(!(f instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:d,character:h}=f,g=!1;if(d<0)d=0,h=0,g=!0;else if(d>=this._lines.length)d=this._lines.length-1,h=this._lines[d].length,g=!0;else{const v=this._lines[d].length;h<0?(h=0,g=!0):h>v&&(h=v,g=!0)}return g?new T.Position(d,h):f}_getWordRangeAtPosition(f,d){const h=this._validatePosition(f);if(!d)d=I(this._languageId);else if((0,u.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const g=(0,_.getWordAtText)(h.character+1,(0,_.ensureValidWordDefinition)(d),this._lines[h.line],0);if(g)return new T.Range(h.line,g.startColumn-1,h.line,g.endColumn-1)}}e.ExtHostDocumentData=b;class k{constructor(f,d,h){this._line=f,this._text=d,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=k}),define(_e[240],ye([1,0,7,20,3]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(T){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new u.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let S;switch(T){case"light":S=a.ColorThemeKind.Light;break;case"hcDark":S=a.ColorThemeKind.HighContrast;break;case"hcLight":S=a.ColorThemeKind.HighContrastLight;break;default:S=a.ColorThemeKind.Dark}this._actual=new a.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ve([We(0,P.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(_e[15],ye([1,0,16,22,149,63,112,28,147,69,87,23,9,2,32,72,124,132,130,92,57,76,236,7]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C,p,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ae){function Oe(se){const{selectionStartLineNumber:Me,selectionStartColumn:ze,positionLineNumber:Qe,positionColumn:He}=se,it=new o.Position(Me-1,ze-1),lt=new o.Position(Qe-1,He-1);return new o.Selection(it,lt)}Ae.to=Oe;function Se(se){const{anchor:Me,active:ze}=se;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Ae.from=Se})(s=e.Selection||(e.Selection={}));var l;(function(Ae){function Oe(se){if(!se)return;const{start:Me,end:ze}=se;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Ae.from=Oe;function Se(se){if(!se)return;const{startLineNumber:Me,startColumn:ze,endLineNumber:Qe,endColumn:He}=se;return new o.Range(Me-1,ze-1,Qe-1,He-1)}Ae.to=Se})(l=e.Range||(e.Range={}));var r;(function(Ae){function Oe(Se){switch(Se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Ae.to=Oe})(r=e.TokenType||(e.TokenType={}));var m;(function(Ae){function Oe(se){return new o.Position(se.lineNumber-1,se.column-1)}Ae.to=Oe;function Se(se){return{lineNumber:se.line+1,column:se.character+1}}Ae.from=Se})(m=e.Position||(e.Position={}));var n;(function(Ae){function Oe(Me,ze){return(0,a.coalesce)((0,a.asArray)(Me).map(Qe=>Se(Qe,ze)))}Ae.from=Oe;function Se(Me,ze){if(typeof Me=="string")return{$serialized:!0,language:Me};if(Me)return{$serialized:!0,language:Me.language,scheme:se(Me.scheme,ze),pattern:B.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType}}function se(Me,ze){return ze&&typeof Me=="string"?ze.transformOutgoingScheme(Me):Me}})(n=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Ae){function Oe(se){switch(se){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Se(se){switch(se){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Ae.to=Se})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Ae){function Oe(se){let Me;return se.code&&((0,b.isString)(se.code)||(0,b.isNumber)(se.code)?Me=String(se.code):Me={value:String(se.code.value),target:se.code.target}),{...l.from(se.range),message:se.message,source:se.source,code:Me,severity:y.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(E.from),tags:Array.isArray(se.tags)?(0,a.coalesce)(se.tags.map(t.from)):void 0}}Ae.from=Oe;function Se(se){const Me=new o.Diagnostic(l.to(se),se.message,y.to(se.severity));return Me.source=se.source,Me.code=(0,b.isString)(se.code)?se.code:se.code?.value,Me.relatedInformation=se.relatedInformation&&se.relatedInformation.map(E.to),Me.tags=se.tags&&(0,a.coalesce)(se.tags.map(t.to)),Me}Ae.to=Se})(c=e.Diagnostic||(e.Diagnostic={}));var E;(function(Ae){function Oe(se){return{...l.from(se.location.range),message:se.message,resource:se.location.uri}}Ae.from=Oe;function Se(se){return new o.DiagnosticRelatedInformation(new o.Location(se.resource,l.to(se)),se.message)}Ae.to=Se})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var y;(function(Ae){function Oe(se){switch(se){case o.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Ae.from=Oe;function Se(se){switch(se){case d.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Ae.to=Se})(y=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var M;(function(Ae){function Oe(se){return typeof se=="number"&&se>=o.ViewColumn.One?se-1:se===o.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Ae.from=Oe;function Se(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Se})(M=e.ViewColumn||(e.ViewColumn={}));function j(Ae){return typeof Ae.range<"u"}function $(Ae){return Ae.length===0?!0:!!j(Ae[0])}e.isDecorationOptionsArr=$;var N;(function(Ae){function Oe(He){return He.map(Ae.from)}Ae.fromMany=Oe;function Se(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function se(He){let it;if(Se(He)){const{language:_t,value:It}=He;it={value:"```"+_t+`
`+It+"\n```\n"}}else o.MarkdownString.isMarkdownString(He)?it={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?it={value:He}:it={value:""};const lt=Object.create(null);it.uris=lt;const Tt=_t=>{try{let It=k.URI.parse(_t,!0);It=It.with({query:Me(It.query,lt)}),lt[_t]=It}catch{}return""},St=new S.marked.Renderer;return St.link=Tt,St.image=_t=>typeof _t=="string"?Tt(_.parseHrefAndDimensions(_t).href):"",(0,S.marked)(it.value,{renderer:St}),it}Ae.from=se;function Me(He,it){if(!He)return He;let lt;try{lt=(0,D.parse)(He)}catch{}if(!lt)return He;let Tt=!1;return lt=(0,I.cloneAndChange)(lt,St=>{if(k.URI.isUri(St)){const _t=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[_t]=St,Tt=!0,_t}else return}),Tt?JSON.stringify(lt):He}function ze(He){const it=new o.MarkdownString(He.value,He.supportThemeIcons);return it.isTrusted=He.isTrusted,it.supportHtml=He.supportHtml,it.baseUri=He.baseUri?k.URI.from(He.baseUri):void 0,it}Ae.to=ze;function Qe(He){if(!!He)return typeof He=="string"?He:Ae.from(He)}Ae.fromStrict=Qe})(N=e.MarkdownString||(e.MarkdownString={}));function x(Ae){return $(Ae)?Ae.map(Oe=>({range:l.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?N.fromMany(Oe.hoverMessage):Oe.hoverMessage?N.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:l.from(Oe)}))}e.fromRangeOrRangeWithMessage=x;function L(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?k.URI.file(Ae):Ae}e.pathOrURIToURI=L;var F;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?L(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Ae.from=Oe})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?L(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Ae.from=Oe})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(Ae){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var de;(function(Ae){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?H.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?U.from(Se.light):void 0,dark:Se.dark?U.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?L(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Ae.from=Oe})(de=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Y;(function(Ae){function Oe(se){return{text:se.newText,eol:se.newEol&&st.from(se.newEol),range:l.from(se.range)}}Ae.from=Oe;function Se(se){const Me=new o.TextEdit(l.to(se.range),se.text);return Me.newEol=typeof se.eol>"u"?void 0:st.to(se.eol),Me}Ae.to=Se})(Y=e.TextEdit||(e.TextEdit={}));var V;(function(Ae){function Oe(se,Me){const ze={edits:[]};if(se instanceof o.WorkspaceEdit){const Qe=new T.ResourceSet;for(const He of se._allEntries())He._type===1&&k.URI.isUri(He.to)&&He.from===void 0&&Qe.add(He.to);for(const He of se._allEntries())He._type===1?ze.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contentsBase64:He.options?.contents&&(0,P.encodeBase64)(P.VSBuffer.wrap(He.options.contents))},metadata:He.metadata}):He._type===2?ze.edits.push({resource:He.uri,textEdit:Y.from(He.edit),versionId:Qe.has(He.uri)?void 0:Me?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?ze.edits.push({resource:He.uri,textEdit:{range:l.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Qe.has(He.uri)?void 0:Me?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?ze.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(He.uri)}):He._type===5&&ze.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Me?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(pt.from)}})}return ze}Ae.from=Oe;function Se(se){const Me=new o.WorkspaceEdit;for(const ze of se.edits)ze.textEdit?Me.replace(k.URI.revive(ze.resource),l.to(ze.textEdit.range),ze.textEdit.text):Me.renameFile(k.URI.revive(ze.oldResource),k.URI.revive(ze.newResource),ze.options);return Me}Ae.to=Se})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var X;(function(Ae){const Oe=Object.create(null);Oe[o.SymbolKind.File]=0,Oe[o.SymbolKind.Module]=1,Oe[o.SymbolKind.Namespace]=2,Oe[o.SymbolKind.Package]=3,Oe[o.SymbolKind.Class]=4,Oe[o.SymbolKind.Method]=5,Oe[o.SymbolKind.Property]=6,Oe[o.SymbolKind.Field]=7,Oe[o.SymbolKind.Constructor]=8,Oe[o.SymbolKind.Enum]=9,Oe[o.SymbolKind.Interface]=10,Oe[o.SymbolKind.Function]=11,Oe[o.SymbolKind.Variable]=12,Oe[o.SymbolKind.Constant]=13,Oe[o.SymbolKind.String]=14,Oe[o.SymbolKind.Number]=15,Oe[o.SymbolKind.Boolean]=16,Oe[o.SymbolKind.Array]=17,Oe[o.SymbolKind.Object]=18,Oe[o.SymbolKind.Key]=19,Oe[o.SymbolKind.Null]=20,Oe[o.SymbolKind.EnumMember]=21,Oe[o.SymbolKind.Struct]=22,Oe[o.SymbolKind.Event]=23,Oe[o.SymbolKind.Operator]=24,Oe[o.SymbolKind.TypeParameter]=25;function Se(Me){return typeof Oe[Me]=="number"?Oe[Me]:6}Ae.from=Se;function se(Me){for(const ze in Oe)if(Oe[ze]===Me)return Number(ze);return o.SymbolKind.Property}Ae.to=se})(X=e.SymbolKind||(e.SymbolKind={}));var Z;(function(Ae){function Oe(se){switch(se){case o.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Se(se){switch(se){case 1:return o.SymbolTag.Deprecated}}Ae.to=Se})(Z=e.SymbolTag||(e.SymbolTag={}));var te;(function(Ae){function Oe(se){return{name:se.name,kind:X.from(se.kind),tags:se.tags&&se.tags.map(Z.from),containerName:se.containerName,location:be.from(se.location)}}Ae.from=Oe;function Se(se){const Me=new o.SymbolInformation(se.name,X.to(se.kind),se.containerName,be.to(se.location));return Me.tags=se.tags&&se.tags.map(Z.to),Me}Ae.to=Se})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(Ae){function Oe(se){const Me={name:se.name||"!!MISSING: name!!",detail:se.detail,range:l.from(se.range),selectionRange:l.from(se.selectionRange),kind:X.from(se.kind),tags:se.tags?.map(Z.from)??[]};return se.children&&(Me.children=se.children.map(Oe)),Me}Ae.from=Oe;function Se(se){const Me=new o.DocumentSymbol(se.name,se.detail,X.to(se.kind),l.to(se.range),l.to(se.selectionRange));return(0,a.isNonEmptyArray)(se.tags)&&(Me.tags=se.tags.map(Z.to)),se.children&&(Me.children=se.children.map(Se)),Me}Ae.to=Se})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(Ae){function Oe(se){const Me=new o.CallHierarchyItem(X.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Me._sessionId=se._sessionId,Me._itemId=se._itemId,Me}Ae.to=Oe;function Se(se,Me,ze){if(Me=Me??se._sessionId,ze=ze??se._itemId,Me===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:ze,name:se.name,detail:se.detail,kind:X.from(se.kind),uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(Z.from)}}Ae.from=Se})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ne;(function(Ae){function Oe(Se){return new o.CallHierarchyIncomingCall(J.to(Se.from),Se.fromRanges.map(se=>l.to(se)))}Ae.to=Oe})(ne=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var pe;(function(Ae){function Oe(Se){return new o.CallHierarchyOutgoingCall(J.to(Se.to),Se.fromRanges.map(se=>l.to(se)))}Ae.to=Oe})(pe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var be;(function(Ae){function Oe(se){return{range:se.range&&l.from(se.range),uri:se.uri}}Ae.from=Oe;function Se(se){return new o.Location(k.URI.revive(se.uri),l.to(se.range))}Ae.to=Se})(be=e.location||(e.location={}));var Ie;(function(Ae){function Oe(se){const Me=se,ze=se;return{originSelectionRange:Me.originSelectionRange?l.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:ze.uri,range:l.from(Me.targetRange?Me.targetRange:ze.range),targetSelectionRange:Me.targetSelectionRange?l.from(Me.targetSelectionRange):void 0}}Ae.from=Oe;function Se(se){return{targetUri:k.URI.revive(se.uri),targetRange:l.to(se.range),targetSelectionRange:se.targetSelectionRange?l.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?l.to(se.originSelectionRange):void 0}}Ae.to=Se})(Ie=e.DefinitionLink||(e.DefinitionLink={}));var Le;(function(Ae){function Oe(se){return{range:l.from(se.range),contents:N.fromMany(se.contents)}}Ae.from=Oe;function Se(se){return new o.Hover(se.contents.map(N.to),l.to(se.range))}Ae.to=Se})(Le=e.Hover||(e.Hover={}));var oe;(function(Ae){function Oe(se){return{range:l.from(se.range),expression:se.expression}}Ae.from=Oe;function Se(se){return new o.EvaluatableExpression(l.to(se.range),se.expression)}Ae.to=Se})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ae;(function(Ae){function Oe(se){if(se instanceof o.InlineValueText)return{type:"text",range:l.from(se.range),text:se.text};if(se instanceof o.InlineValueVariableLookup)return{type:"variable",range:l.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Se(se){switch(se.type){case"text":return{range:l.to(se.range),text:se.text};case"variable":return{range:l.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:l.to(se.range),expression:se.expression}}}Ae.to=Se})(ae=e.InlineValue||(e.InlineValue={}));var fe;(function(Ae){function Oe(se){return{frameId:se.frameId,stoppedLocation:l.from(se.stoppedLocation)}}Ae.from=Oe;function Se(se){return new o.InlineValueContext(se.frameId,l.to(se.stoppedLocation))}Ae.to=Se})(fe=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Ae){function Oe(se){return{range:l.from(se.range),kind:se.kind}}Ae.from=Oe;function Se(se){return new o.DocumentHighlight(l.to(se.range),se.kind)}Ae.to=Se})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var le;(function(Ae){function Oe(Se){switch(Se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Ae.to=Oe})(le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var re;(function(Ae){function Oe(Se){return{triggerKind:le.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Ae.to=Oe})(re=e.CompletionContext||(e.CompletionContext={}));var O;(function(Ae){function Oe(se){switch(se){case o.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Se(se){switch(se){case 1:return o.CompletionItemTag.Deprecated}}Ae.to=Se})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Ae){const Oe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Se(ze){return Oe.get(ze)??9}Ae.from=Se;const se=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Me(ze){return se.get(ze)??o.CompletionItemKind.Property}Ae.to=Me})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(Ae){function Oe(Se,se){const Me=new o.CompletionItem(Se.label);return Me.insertText=Se.insertText,Me.kind=W.to(Se.kind),Me.tags=Se.tags?.map(O.to),Me.detail=Se.detail,Me.documentation=_.isMarkdownString(Se.documentation)?N.to(Se.documentation):Se.documentation,Me.sortText=Se.sortText,Me.filterText=Se.filterText,Me.preselect=Se.preselect,Me.commitCharacters=Se.commitCharacters,w.Range.isIRange(Se.range)?Me.range=l.to(Se.range):typeof Se.range=="object"&&(Me.range={inserting:l.to(Se.range.insert),replacing:l.to(Se.range.replace)}),Me.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Me.insertText=new o.SnippetString(Se.insertText):(Me.insertText=Se.insertText,Me.textEdit=Me.range instanceof o.Range?new o.TextEdit(Me.range,Me.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Me.additionalTextEdits=Se.additionalTextEdits.map(ze=>Y.to(ze))),Me.command=se&&Se.command?se.fromInternal(Se.command):void 0,Me}Ae.to=Oe})(G=e.CompletionItem||(e.CompletionItem={}));var Q;(function(Ae){function Oe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:N.fromStrict(se.documentation)}}Ae.from=Oe;function Se(se){return{label:se.label,documentation:_.isMarkdownString(se.documentation)?N.to(se.documentation):se.documentation}}Ae.to=Se})(Q=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Ae){function Oe(se){return{label:se.label,documentation:N.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Q.from):[],activeParameter:se.activeParameter}}Ae.from=Oe;function Se(se){return{label:se.label,documentation:_.isMarkdownString(se.documentation)?N.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Q.to):[],activeParameter:se.activeParameter}}Ae.to=Se})(he=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(Ae){function Oe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(he.from):[]}}Ae.from=Oe;function Se(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(he.to):[]}}Ae.to=Se})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Ae){function Oe(Se,se){const Me=new o.InlayHint(m.to(se.position),typeof se.label=="string"?se.label:se.label.map(ve.to.bind(void 0,Se)),se.kind&&Ce.to(se.kind));return Me.textEdits=se.textEdits&&se.textEdits.map(Y.to),Me.tooltip=_.isMarkdownString(se.tooltip)?N.to(se.tooltip):se.tooltip,Me.paddingLeft=se.paddingLeft,Me.paddingRight=se.paddingRight,Me}Ae.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var ve;(function(Ae){function Oe(Se,se){const Me=new o.InlayHintLabelPart(se.label);return Me.tooltip=_.isMarkdownString(se.tooltip)?N.to(se.tooltip):se.tooltip,f.Command.is(se.command)&&(Me.command=Se.fromInternal(se.command)),se.location&&(Me.location=be.to(se.location)),Me}Ae.to=Oe})(ve=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Ae){function Oe(se){return se}Ae.from=Oe;function Se(se){return se}Ae.to=Se})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Ae){function Oe(se){return{range:l.from(se.range),url:se.target,tooltip:se.tooltip}}Ae.from=Oe;function Se(se){let Me;if(se.url)try{Me=typeof se.url=="string"?k.URI.parse(se.url,!0):k.URI.revive(se.url)}catch{}return new o.DocumentLink(l.to(se.range),Me)}Ae.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var $e;(function(Ae){function Oe(se){const Me=new o.ColorPresentation(se.label);return se.textEdit&&(Me.textEdit=Y.to(se.textEdit)),se.additionalTextEdits&&(Me.additionalTextEdits=se.additionalTextEdits.map(ze=>Y.to(ze))),Me}Ae.to=Oe;function Se(se){return{label:se.label,textEdit:se.textEdit?Y.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Me=>Y.from(Me)):void 0}}Ae.from=Se})($e=e.ColorPresentation||(e.ColorPresentation={}));var je;(function(Ae){function Oe(se){return new o.Color(se[0],se[1],se[2],se[3])}Ae.to=Oe;function Se(se){return[se.red,se.green,se.blue,se.alpha]}Ae.from=Se})(je=e.Color||(e.Color={}));var et;(function(Ae){function Oe(se){return{range:l.from(se.range)}}Ae.from=Oe;function Se(se){return new o.SelectionRange(l.to(se.range))}Ae.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Ae){function Oe(Se){switch(Se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Ae){function Oe(se){switch(se){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Se(se){switch(se){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Ae.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Ae){function Oe(se){if(se===o.EndOfLine.CRLF)return 1;if(se===o.EndOfLine.LF)return 0}Ae.from=Oe;function Se(se){if(se===1)return o.EndOfLine.CRLF;if(se===0)return o.EndOfLine.LF}Ae.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Ae){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(Ae){function Oe(Se){const se={start:Se.start+1,end:Se.end+1};return Se.kind&&(se.kind=rt.from(Se.kind)),se}Ae.from=Oe})(Fe=e.FoldingRange||(e.FoldingRange={}));var rt;(function(Ae){function Oe(Se){if(Se)switch(Se){case o.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}Ae.from=Oe})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ce;(function(Ae){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?l.from(Se.selection):void 0,override:typeof Se.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var B;(function(Ae){function Oe(ze){return ze instanceof o.RelativePattern?ze.toJSON():typeof ze=="string"?ze:Se(ze)||se(ze)?new o.RelativePattern(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Ae.from=Oe;function Se(ze){const Qe=ze;return Qe?k.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function se(ze){const Qe=ze;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Me(ze){return typeof ze=="string"?ze:new o.RelativePattern(k.URI.revive(ze.baseUri),ze.pattern)}Ae.to=Me})(B=e.GlobPattern||(e.GlobPattern={}));var ue;(function(Ae){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const se=Se;return{language:se.language,scheme:se.scheme,pattern:B.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Ae.from=Oe})(ue=e.LanguageSelector||(e.LanguageSelector={}));var De;(function(Ae){function Oe(se){return{start:se.start,end:se.end}}Ae.from=Oe;function Se(se){return new o.NotebookRange(se.start,se.end)}Ae.to=Se})(De=e.NotebookRange||(e.NotebookRange={}));var Re;(function(Ae){function Oe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Ae.to=Oe;function Se(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Ae.from=Se})(Re=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var xe;(function(Ae){function Oe(Se){if(Se===v.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Se===v.NotebookCellExecutionState.Pending)return;if(Se===v.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Ae.to=Oe})(xe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ge;(function(Ae){function Oe(se){switch(se){case o.NotebookCellKind.Markup:return v.CellKind.Markup;case o.NotebookCellKind.Code:default:return v.CellKind.Code}}Ae.from=Oe;function Se(se){switch(se){case v.CellKind.Markup:return o.NotebookCellKind.Markup;case v.CellKind.Code:default:return o.NotebookCellKind.Code}}Ae.to=Se})(Ge=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Ae){function Oe(se){const Me={metadata:se.metadata??Object.create(null),cells:[]};for(const ze of se.cells)o.NotebookCellData.validate(ze),Me.cells.push(pt.from(ze));return Me}Ae.from=Oe;function Se(se){const Me=new o.NotebookData(se.cells.map(pt.to));return(0,b.isEmptyObject)(se.metadata)||(Me.metadata=se.metadata),Me}Ae.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var pt;(function(Ae){function Oe(se){return{cellKind:Ge.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Re.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(ct.from):[]}}Ae.from=Oe;function Se(se){return new o.NotebookCellData(Ge.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(ct.to):void 0,se.metadata,se.internalMetadata?Re.to(se.internalMetadata):void 0)}Ae.to=Se})(pt=e.NotebookCellData||(e.NotebookCellData={}));var gt;(function(Ae){function Oe(se){return{mime:se.mime,valueBytes:P.VSBuffer.wrap(se.data)}}Ae.from=Oe;function Se(se){return new o.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Ae.to=Se})(gt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ct;(function(Ae){function Oe(se){return{outputId:se.id,items:se.items.map(gt.from),metadata:se.metadata}}Ae.from=Oe;function Se(se){const Me=se.items.map(gt.to);return new o.NotebookCellOutput(Me,se.outputId,se.metadata)}Ae.to=Se})(ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var wt;(function(Ae){function Oe(Me){return se(Me)?{include:(0,b.withNullAsUndefined)(B.from(Me.include)),exclude:(0,b.withNullAsUndefined)(B.from(Me.exclude))}:(0,b.withNullAsUndefined)(B.from(Me))}Ae.from=Oe;function Se(Me){return se(Me)?{include:B.to(Me.include),exclude:B.to(Me.exclude)}:B.to(Me)}Ae.to=Se;function se(Me){const ze=Me;return ze?!(0,b.isUndefinedOrNull)(ze.include)&&!(0,b.isUndefinedOrNull)(ze.exclude):!1}})(wt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var tt;(function(Ae){function Oe(Se,se,Me){const ze=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(ze,Me),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Ae.from=Oe})(tt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Ae){function Oe(Se,se,Me){const ze=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:se.toInternal(ze,Me),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Ae.from=Oe})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Pt;(function(Ae){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Ae.from=Oe})(Pt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Gt;(function(Ae){function Oe(se){return{uri:se.uri,provides:se.provides}}Ae.from=Oe;function Se(se){return new o.NotebookRendererScript(k.URI.revive(se.uri),se.provides)}Ae.to=Se})(Gt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var At;(function(Ae){function Oe(se){return{message:N.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:l.from(se.location.range),uri:se.location.uri}}}Ae.from=Oe;function Se(se){const Me=new o.TestMessage(typeof se.message=="string"?se.message:N.to(se.message));return Me.actualOutput=se.actual,Me.expectedOutput=se.expected,Me.location=se.location?be.to(se.location):void 0,Me}Ae.to=Se})(At=e.TestMessage||(e.TestMessage={}));var mt;(function(Ae){Ae.namespace=p.namespaceTestTag,Ae.denamespace=p.denamespaceTestTag})(mt=e.TestTag||(e.TestTag={}));var kt;(function(Ae){function Oe(se){const Me=(0,h.getPrivateApiFor)(se).controllerId;return{extId:C.TestId.fromExtHostTestItem(se,Me).toString(),label:se.label,uri:k.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(ze=>mt.namespace(Me,ze.id)),range:w.Range.lift(l.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&N.fromStrict(se.error)||null}}Ae.from=Oe;function Se(se){return{parent:void 0,error:void 0,id:C.TestId.fromString(se.extId).localId,label:se.label,uri:k.URI.revive(se.uri),tags:(se.tags||[]).map(Me=>{const{tagId:ze}=mt.denamespace(Me);return new o.TestTag(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Ae.toPlain=Se})(kt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(se){return{id:se.id}}Ae.from=Oe;function Se(se){return new o.TestTag(se.id)}Ae.to=Se}(mt=e.TestTag||(e.TestTag={}));var xt;(function(Ae){const Oe=(se,Me)=>{const ze=[];for(const[He,it]of Me)C.TestId.compare(it.item.extId,He)===2&&(Me.delete(He),ze.push(it));const Qe={...kt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(it=>it.type===0).map(At.to)})),children:ze.map(He=>Oe(He,Me))};for(const He of Qe.children)He.parent=Qe;return Qe};function Se(se){const Me=[],ze=new Map;for(const Qe of se.items){ze.set(Qe.item.extId,Qe);const He=C.TestId.root(Qe.item.extId);se.request.targets.some(it=>it.controllerId===He&&it.testIds.includes(Qe.item.extId))&&Me.push(Qe)}return{completedAt:se.completedAt,results:Me.map(Qe=>Oe(Qe,ze))}}Ae.to=Se})(xt=e.TestResults||(e.TestResults={}));var Ot;(function(Ae){function Oe(ze){return{covered:ze.covered,total:ze.covered}}function Se(ze){return"line"in ze?m.from(ze):l.from(ze)}function se(ze){return"branches"in ze?{count:ze.executionCount,location:Se(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Se(Qe.location)})):void 0}:{type:0,count:ze.executionCount,location:Se(ze.location)}}Ae.fromDetailed=se;function Me(ze){return{uri:ze.uri,statement:Oe(ze.statementCoverage),branch:ze.branchCoverage&&Oe(ze.branchCoverage),function:ze.functionCoverage&&Oe(ze.functionCoverage),details:ze.detailedCoverage?.map(se)}}Ae.fromFile=Me})(Ot=e.TestCoverage||(e.TestCoverage={}));var Ke;(function(Ae){function Oe(Se){switch(Se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Ke=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(Ae){function Oe(se){const Me=new o.TypeHierarchyItem(X.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Me._sessionId=se._sessionId,Me._itemId=se._itemId,Me}Ae.to=Oe;function Se(se,Me,ze){if(Me=Me??se._sessionId,ze=ze??se._itemId,Me===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:ze,kind:X.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(Z.from)}}Ae.from=Se})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ft;(function(Ae){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Ae.from=Oe})(Ft=e.ViewBadge||(e.ViewBadge={}));var Wt;(function(Ae){function Oe(ze,Qe,He){const it=Qe.fileData;return it?new class extends o.DataTransferItem{asFile(){return{name:it.name,uri:k.URI.revive(it.uri),data:(0,A.once)(()=>He())}}}("",Qe.id):ze===R.Mimes.uriList&&Qe.uriListData?new o.DataTransferItem(Me(Qe.uriListData)):new o.DataTransferItem(Qe.asString)}Ae.to=Oe;async function Se(ze,Qe){const He=await Qe.asString();if(ze===R.Mimes.uriList)return{id:Qe.id,asString:He,fileData:void 0,uriListData:se(He)};const it=Qe.asFile();return{id:Qe.id,asString:He,fileData:it?{name:it.name,uri:it.uri}:void 0}}Ae.from=Se;function se(ze){return u.UriList.split(ze).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return k.URI.parse(Qe)}catch{}return Qe})}function Me(ze){return u.UriList.create(ze.map(Qe=>typeof Qe=="string"?Qe:k.URI.revive(Qe)))}})(Wt=e.DataTransferItem||(e.DataTransferItem={}));var vt;(function(Ae){function Oe(se,Me){const ze=se.items.map(([Qe,He])=>[Qe,Wt.to(Qe,He,()=>Me(He.id))]);return new o.DataTransfer(ze)}Ae.toDataTransfer=Oe;async function Se(se){const Me={items:[]},ze=[];return se.forEach((Qe,He)=>{ze.push((async()=>{Me.items.push([He,await Wt.from(He,Qe)])})())}),await Promise.all(ze),Me}Ae.toDataTransferDTO=Se})(vt=e.DataTransfer||(e.DataTransfer={}))}),define(_e[241],ye([1,0,2,11,7,15,66]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(D,R,I,b={timeout:1500,errors:3}){this._logService=D,this._documents=R,this._mainThreadBulkEdits=I,this._thresholds=b,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(R,I,b)=>{const w={dispose:this._callbacks.push([R,I,D])};return Array.isArray(b)&&b.push(w),w}}async $participateInSave(D,R){const I=a.URI.revive(D);let b=!1;const k=setTimeout(()=>b=!0,this._thresholds.timeout),w=[];try{for(const f of[...this._callbacks]){if(b)break;const d=this._documents.getDocument(I),h=await this._deliverEventAsyncAndBlameBadListeners(f,{document:d,reason:A.TextDocumentSaveReason.to(R)});w.push(h)}}finally{clearTimeout(k)}return w}_deliverEventAsyncAndBlameBadListeners([D,R,I],b){const k=this._badListeners.get(D);return typeof k=="number"&&k>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,D,R,b).then(()=>!0,w=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const f=this._badListeners.get(D);this._badListeners.set(D,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,R,I,b){const k=[],w=Date.now(),{document:f,reason:d}=b,{version:h}=f,g=Object.freeze({document:f,reason:d,waitUntil(v){if(Object.isFrozen(k))throw(0,P.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(v))}});try{R.apply(I,[g])}catch(v){return Promise.reject(v)}return Object.freeze(k),new Promise((v,C)=>{const p=setTimeout(()=>C(new Error("timeout")),this._thresholds.timeout);return Promise.all(k).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(p),v(i)}).catch(i=>{clearTimeout(p),C(i)})}).then(v=>{const C={edits:[]};for(const p of v)if(Array.isArray(p)&&p.every(i=>i instanceof u.TextEdit))for(const{newText:i,newEol:o,range:s}of p)C.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:s&&A.Range.from(s),text:i,eol:o&&A.EndOfLine.from(o)}});if(C.edits.length!==0)return h===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(C):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(_e[242],ye([1,0,14,2,15,7,92]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(I,b,k,w){this.start=I,this.deletedCount=b,this.deletedItems=k,this.items=w}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(I,b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,b,k){this.notebook=I,this._extHostDocument=b,this._cellData=k,this.handle=k.handle,this.uri=P.URI.revive(k.uri),this.cellKind=k.cellKind,this._outputs=k.outputs.map(u.NotebookCellOutput.to),this._internalMetadata=k.internalMetadata??{},this._metadata=Object.freeze(k.metadata??{}),this._previousResult=Object.freeze(u.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,b=this._extHostDocument.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:u.NotebookCellKind.to(this._cellData.cellKind),document:b.document,get mime(){return I._mime},set mime(w){I._mime=w},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(k)}return this._apiCell}setOutputs(I){this._outputs=I.map(u.NotebookCellOutput.to)}setOutputItems(I,b,k){const w=k.map(u.NotebookCellOutputItem.to),f=this._outputs.find(d=>d.id===I);if(f&&(b||(f.items.length=0),f.items.push(...w),f.items.length>1&&f.items.every(d=>_.isTextStreamMime(d.mime)))){const d=new Map,h=[];f.items.forEach(g=>{let v;d.has(g.mime)?v=d.get(g.mime):(v=[],d.set(g.mime,v),h.push(g.mime)),v.push(g.data)}),f.items.length=0,h.forEach(g=>{const v=_.compressOutputItemStreams(d.get(g));f.items.push({mime:g,data:v.buffer})})}}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(u.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=S;class D{constructor(I,b,k,w,f){this._proxy=I,this._textDocumentsAndEditors=b,this._textDocuments=k,this.uri=w,this.handle=D._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=f.viewType,this._metadata=Object.freeze(f.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,f.cells]],!0,void 0),this._versionId=f.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const I=this,b={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===a.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(k){return k=I._validateIndex(k),I._cells[k].apiCell},getCells(k){return(k?I._getCells(k):I._cells).map(f=>f.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(b)}return this._notebook}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,b,k){this._versionId=I.versionId,this._isDirty=b,this.acceptDocumentPropertiesChanged({metadata:k});const w={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},f=[];for(const h of I.rawEvents)h.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1,w.contentChanges):h.kind===_.NotebookCellsChangeType.Move?this._moveCells(h.index,h.length,h.newIdx,w.contentChanges):h.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(h.index,h.outputs),f.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems),f.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(h.index,h.language),f.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document})):h.kind===_.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document}):h.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(h.index,h.metadata),f.push({cell:this._cells[h.index].apiCell,metadata:this._cells[h.index].apiCell.metadata})):h.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(h.index,h.internalMetadata),f.push({cell:this._cells[h.index].apiCell,executionSummary:this._cells[h.index].apiCell.executionSummary}));const d=new Map;for(let h=0;h<f.length;h++){const g=f[h],v=d.get(g.cell);if(v===void 0){const C=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});d.set(g.cell,C-1)}else w.cellChanges[v]={...w.cellChanges[v],...g}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let b=I.start|0,k=I.end|0;return b<0&&(b=0),k>this._cells.length&&(k=this._cells.length),I.with({start:b,end:k})}_getCells(I){I=this._validateRange(I);const b=[];for(let k=I.start;k<I.end;k++)b.push(this._cells[k]);return b}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,b,k){if(this._disposed)return;const w=[],f=[],d=[];if(I.reverse().forEach(h=>{const v=h[2].map(i=>{const o=new S(this,this._textDocumentsAndEditors,i);return b||f.push(S.asModelAddData(this.apiNotebook,i)),o}),C=new T(h[0],h[1],[],v),p=this._cells.splice(h[0],h[1],...v);for(const i of p)d.push(i.uri),C.deletedItems.push(i.apiCell);w.push(C)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:d}),k)for(const h of w)k.push(h.asApiEvent())}_moveCells(I,b,k,w){const f=this._cells.splice(I,b);this._cells.splice(k,0,...f);const d=[new T(I,b,f.map(h=>h.apiCell),[]),new T(k,0,[],f)];for(const h of d)w.push(h.asApiEvent())}_setCellOutputs(I,b){this._cells[I].setOutputs(b)}_setCellOutputItems(I,b,k,w){this._cells[I].setOutputItems(b,k,w)}_changeCellLanguage(I,b){const k=this._cells[I];k.apiCell.document.languageId!==b&&this._textDocuments.$acceptModelLanguageChanged(k.uri,b)}_changeCellMime(I,b){const k=this._cells[I];k.apiCell.mime=b}_changeCellMetadata(I,b){this._cells[I].setMetadata(b)}_changeCellInternalMetadata(I,b){this._cells[I].setInternalMetadata(b)}getCellFromApiCell(I){return this._cells.find(b=>b.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(b=>b.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}D._handlePool=0,e.ExtHostNotebookDocument=D}),define(_e[136],ye([1,0,11,15,7]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(T,S,D,R,I,b){this.id=T,this._proxy=S,this.notebookData=D,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=I,this._visibleRanges=R,this._viewColumn=b}get apiEditor(){if(!this._editor){const T=this;this._editor={get notebook(){return T.notebookData.apiNotebook},get selection(){return T._selections[0]},set selection(S){this.selections=[S]},get selections(){return T._selections},set selections(S){if(!Array.isArray(S)||!S.every(u.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");T._selections=S,T._trySetSelections(S)},get visibleRanges(){return T._visibleRanges},revealRange(S,D){T._proxy.$tryRevealRange(T.id,P.NotebookRange.from(S),D??u.NotebookEditorRevealType.Default)},get viewColumn(){return T._viewColumn}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(T){this._visible=T}_acceptVisibleRanges(T){this._visibleRanges=T}_acceptSelections(T){this._selections=T}_trySetSelections(T){this._proxy.$trySetSelections(this.id,T.map(P.NotebookRange.from))}_acceptViewColumn(T){this._viewColumn=T}}A.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=A}),define(_e[243],ye([1,0,3,13,15]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(T,S){this._logService=T,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(T,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const D=this._notebooksAndEditors.getEditorById(T);S.visibleRanges&&D._acceptVisibleRanges(S.visibleRanges.ranges.map(u.NotebookRange.to)),S.selections&&D._acceptSelections(S.selections.selections.map(u.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(u.ViewColumn.to(T[S]))}};A=Ve([We(0,P.ILogService)],A),e.ExtHostNotebookEditors=A}),define(_e[244],ye([1,0,15,126,179,21,62,11]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(b){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=b}async withProgress(b,k,w){const f=this._handles++,{title:d,location:h,cancellable:g}=k,v={label:(0,u.localize)(0,null,b.displayName||b.name),id:b.identifier.value};return this._proxy.$startProgress(f,{location:a.ProgressLocation.from(h),title:d,source:v,cancellable:g},b.isUnderDevelopment?void 0:b.identifier.value).catch(T.onUnexpectedExternalError),this._withProgress(f,w,!!g)}_withProgress(b,k,w){let f;w&&(f=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(b,f));const d=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),f?.dispose()};let h;try{h=k(new R(this._proxy,b),w&&f?f.token:A.CancellationToken.None)}catch(g){throw d(b),g}return h.then(g=>d(b),g=>d(b)),h}$acceptProgressCanceled(b){const k=this._mapHandleToCancellationSource.get(b);k&&(k.cancel(),this._mapHandleToCancellationSource.delete(b))}}e.ExtHostProgress=S;function D(I,b){return I.message=b.message,typeof b.increment=="number"&&(typeof I.increment=="number"?I.increment+=b.increment:I.increment=b.increment),I}class R extends P.Progress{constructor(b,k){super(w=>this.throttledReport(w)),this._proxy=b,this._handle=k}throttledReport(b){this._proxy.$progressReport(this._handle,b)}}Ve([(0,_.throttle)(100,(I,b)=>D(I,b),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(_e[137],ye([1,0,32,132,57,93,76,15,2]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(v,C,p,i)=>{let o=C;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!p(o,s)){const l=o;o=s,v.listener?.(i(s,l))}}}},R=(v,C)=>v===C,I={range:(v,C)=>v===C?!0:!v||!C?!1:v.isEqual(C),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(v,C)=>!(v.length!==C.length||v.some(p=>!C.find(i=>p.id===i.id)))},b=v=>C=>({op:4,update:v(C)}),k=(v,C)=>({range:(()=>{let p;const i=b(o=>({range:a.Range.lift(T.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return p},set(o){v.listener?.({op:6}),I.range(p,o)||(p=o,v.listener?.(i(o)))}}})(),label:D(v,C,I.label,b(p=>({label:p}))),description:D(v,void 0,I.description,b(p=>({description:p}))),sortText:D(v,void 0,I.sortText,b(p=>({sortText:p}))),canResolveChildren:D(v,!1,I.canResolveChildren,p=>({op:2,state:p})),busy:D(v,!1,I.busy,b(p=>({busy:p}))),error:D(v,void 0,I.error,b(p=>({error:T.MarkdownString.fromStrict(p)||null}))),tags:D(v,[],I.tags,(p,i)=>({op:1,new:p.map(T.TestTag.from),old:i.map(T.TestTag.from)}))}),w=v=>{const C=u.TestId.fromString(v.extId),p=new d(C.controllerId,C.localId,v.label,S.URI.revive(v.uri)||void 0);return p.range=T.Range.to(v.range||void 0),p.description=v.description||void 0,p.sortText=v.sortText||void 0,p.tags=v.tags.map(i=>T.TestTag.to({id:(0,_.denamespaceTestTag)(i).tagId})),p},f=v=>{let C;for(const p of v.tests){const i=w(p.item);(0,P.getPrivateApiFor)(i).parent=C,C=i}return C};e.toItemFromContext=f;class d{constructor(C,p,i,o){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const s=(0,P.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof h?void 0:s.parent}},children:{value:(0,A.createTestItemChildren)(s,P.getPrivateApiFor,d),enumerable:!0,writable:!1},...k(s,i)})}}e.TestItemImpl=d;class h extends d{constructor(C,p){super(C,C,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class g extends A.TestItemCollection{constructor(C,p,i){super({controllerId:C,getDocumentVersion:o=>o&&i.getDocument(o)?.version,getApiFor:P.getPrivateApiFor,getChildren:o=>o.children,root:new h(C,p),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(_e[138],ye([1,0,50,11,101,15,7]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class T{constructor(b,k,w){const f=T._Keys.nextId();b.$registerTextEditorDecorationType(k.identifier,f,A.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:f,dispose(){b.$removeTextEditorDecorationType(f)}})}}T._Keys=new u.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=T;class S{constructor(b,k){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=k.undoStopBefore,this._undoStopAfter=k.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,k){this._throwIfFinalized();let w=null;if(b instanceof _.Position)w=new _.Range(b,b);else if(b instanceof _.Range)w=b;else throw new Error("Unrecognized location");this._pushEdit(w,k,!1)}insert(b,k){this._throwIfFinalized(),this._pushEdit(new _.Range(b,b),k,!0)}delete(b){this._throwIfFinalized();let k=null;if(b instanceof _.Range)k=b;else throw new Error("Unrecognized location");this._pushEdit(k,null,!0)}_pushEdit(b,k,w){const f=this._document.validateRange(b);this._collectedEdits.push({range:f,text:k,forceMoveMarkers:w})}setEndOfLine(b){if(this._throwIfFinalized(),b!==_.EndOfLine.LF&&b!==_.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this._setEndOfLine=b}}class D{constructor(b,k,w,f){this._proxy=b,this._id=k,this._accept(w),this._logService=f;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(h){d._setTabSize(h)},get indentSize(){return d._indentSize},set indentSize(h){d._setIndentSize(h)},get insertSpaces(){return d._insertSpaces},set insertSpaces(h){d._setInsertSpaces(h)},get cursorStyle(){return d._cursorStyle},set cursorStyle(h){d._setCursorStyle(h)},get lineNumbers(){return d._lineNumbers},set lineNumbers(h){d._setLineNumbers(h)}}}_accept(b){this._tabSize=b.tabSize,this._indentSize=b.indentSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const k=Math.floor(b);return k>0?k:null}if(typeof b=="string"){const k=parseInt(b,10);return isNaN(k)?null:k>0?k:null}return null}_setTabSize(b){const k=this._validateTabSize(b);if(k!==null){if(typeof k=="number"){if(this._tabSize===k)return;this._tabSize=k}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:k}))}}_validateIndentSize(b){if(b==="tabSize")return"tabSize";if(typeof b=="number"){const k=Math.floor(b);return k>0?k:null}if(typeof b=="string"){const k=parseInt(b,10);return isNaN(k)?null:k>0?k:null}return null}_setIndentSize(b){const k=this._validateIndentSize(b);if(k!==null){if(typeof k=="number"){if(this._indentSize===k)return;this._indentSize=k}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:k}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:Boolean(b)}_setInsertSpaces(b){const k=this._validateInsertSpaces(b);if(typeof k=="boolean"){if(this._insertSpaces===k)return;this._insertSpaces=k}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:k}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(b)})))}assign(b){const k={};let w=!1;if(typeof b.tabSize<"u"){const f=this._validateTabSize(b.tabSize);f==="auto"?(w=!0,k.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,w=!0,k.tabSize=f)}if(typeof b.indentSize<"u"){const f=this._validateIndentSize(b.indentSize);f==="tabSize"?(w=!0,k.indentSize=f):typeof f=="number"&&this._indentSize!==f&&(this._indentSize=f,w=!0,k.indentSize=f)}if(typeof b.insertSpaces<"u"){const f=this._validateInsertSpaces(b.insertSpaces);f==="auto"?(w=!0,k.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,w=!0,k.insertSpaces=f)}typeof b.cursorStyle<"u"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,w=!0,k.cursorStyle=b.cursorStyle),typeof b.lineNumbers<"u"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,w=!0,k.lineNumbers=A.TextEditorLineNumbersStyle.from(b.lineNumbers)),w&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,k))}_warnOnError(b,k){k.catch(w=>{this._logService.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this._logService.warn(w)})}}e.ExtHostTextEditorOptions=D;class R{constructor(b,k,w,f,d,h,g,v){this.id=b,this._proxy=k,this._logService=w,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new D(this._proxy,this.id,h,w),this._visibleRanges=g,this._viewColumn=v;const C=this;this.value=Object.freeze({get document(){return f.value},set document(p){throw(0,P.readonly)("document")},get selection(){return C._selections&&C._selections[0]},set selection(p){if(!(p instanceof _.Selection))throw(0,P.illegalArgument)("selection");C._selections=[p],C._trySetSelection()},get selections(){return C._selections},set selections(p){if(!Array.isArray(p)||p.some(i=>!(i instanceof _.Selection)))throw(0,P.illegalArgument)("selections");C._selections=p,C._trySetSelection()},get visibleRanges(){return C._visibleRanges},set visibleRanges(p){throw(0,P.readonly)("visibleRanges")},get options(){return C._options.value},set options(p){C._disposed||C._options.assign(p)},get viewColumn(){return C._viewColumn},set viewColumn(p){throw(0,P.readonly)("viewColumn")},edit(p,i={undoStopBefore:!0,undoStopAfter:!0}){if(C._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(f.value,i);return p(o),C._applyEdit(o)},insertSnippet(p,i,o={undoStopBefore:!0,undoStopAfter:!0}){if(C._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!i||Array.isArray(i)&&i.length===0)s=C._selections.map(l=>A.Range.from(l));else if(i instanceof _.Position){const{lineNumber:l,column:r}=A.Position.from(i);s=[{startLineNumber:l,startColumn:r,endLineNumber:l,endColumn:r}]}else if(i instanceof _.Range)s=[A.Range.from(i)];else{s=[];for(const l of i)if(l instanceof _.Range)s.push(A.Range.from(l));else{const{lineNumber:r,column:m}=A.Position.from(l);s.push({startLineNumber:r,startColumn:m,endLineNumber:r,endColumn:m})}}return k.$tryInsertSnippet(b,f.value.version,p.value,s,o)},setDecorations(p,i){const o=i.length===0;o&&!C._hasDecorationsForKey.has(p.key)||(o?C._hasDecorationsForKey.delete(p.key):C._hasDecorationsForKey.add(p.key),C._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return k.$trySetDecorations(b,p.key,A.fromRangeOrRangeWithMessage(i));{const s=new Array(4*i.length);for(let l=0,r=i.length;l<r;l++){const m=i[l];s[4*l]=m.start.line+1,s[4*l+1]=m.start.character+1,s[4*l+2]=m.end.line+1,s[4*l+3]=m.end.character+1}return k.$trySetDecorationsFast(b,p.key,s)}}))},revealRange(p,i){C._runOnProxy(()=>k.$tryRevealRange(b,A.Range.from(p),i||_.TextEditorRevealType.Default))},show(p){k.$tryShowEditor(b,A.ViewColumn.from(p))},hide(){k.$tryHideEditor(b)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,a.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,a.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,a.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,a.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const k=b.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const w=k.edits.map(d=>d.range);w.sort((d,h)=>d.end.line===h.end.line?d.end.character===h.end.character?d.start.line===h.start.line?d.start.character-h.start.character:d.start.line-h.start.line:d.end.character-h.end.character:d.end.line-h.end.line);for(let d=0,h=w.length-1;d<h;d++){const g=w[d].end;if(w[d+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=k.edits.map(d=>({range:A.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,f,{setEndOfLine:typeof k.setEndOfLine=="number"?A.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this._logService.warn(k),null))}}e.ExtHostTextEditor=R}),define(_e[245],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(_e[246],ye([1,0,195,11,37,123,91,39,26,245,209,198]),function(ie,e,a,P,u,A,_,T,S,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const b=T.Registry.as(_.Extensions.JSONContribution);class k{constructor(p,i,o){this._messageHandler=p,this._extension=i,this._extensionPointId=o}_msg(p,i){this._messageHandler({type:p,message:i,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(p){this._msg(u.default.Error,p)}warn(p){this._msg(u.default.Warning,p)}info(p){this._msg(u.default.Info,p)}}e.ExtensionMessageCollector=k;class w{static _toSet(p){const i=new Set;for(let o=0,s=p.length;o<s;o++)i.add(S.ExtensionIdentifier.toKey(p[o].description.identifier));return i}static compute(p,i){if(!p||!p.length)return new w(i,[]);if(!i||!i.length)return new w([],p);const o=this._toSet(p),s=this._toSet(i),l=i.filter(m=>!o.has(S.ExtensionIdentifier.toKey(m.description.identifier))),r=p.filter(m=>!s.has(S.ExtensionIdentifier.toKey(m.description.identifier)));return new w(l,r)}constructor(p,i){this.added=p,this.removed=i}}e.ExtensionPointUserDelta=w;class f{constructor(p,i){this.name=p,this.defaultExtensionKind=i,this._handler=null,this._users=null,this._delta=null}setHandler(p){if(this._handler!==null)throw new Error("Handler already set!");this._handler=p,this._handle()}acceptUsers(p){this._delta=w.compute(this._users,p),this._users=p,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(p){(0,P.onUnexpectedError)(p)}}}e.ExtensionPoint=f;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class g{constructor(){this._extensionPoints=new Map}registerExtensionPoint(p){if(this._extensionPoints.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const i=new f(p.extensionPoint,p.defaultExtensionKind);return this._extensionPoints.set(p.extensionPoint,i),p.activationEventsGenerator&&I.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,b.registerSchema(h,e.schema),i}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=g;const v={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(v.ExtensionsRegistry,new g),e.ExtensionsRegistry=T.Registry.as(v.ExtensionsRegistry),b.registerSchema(h,e.schema),b.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(_e[247],ye([1,0,192,9,23,246,54,3]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var D;(function(b){function k(w,f,d){if(!w)return;const h=P.isString(w.type)?w.type:void 0;if(!h||h.length===0){d.error(a.localize(3,null));return}const g=[];if(Array.isArray(w.required))for(const v of w.required)P.isString(v)&&g.push(v);return{extensionId:f.value,taskType:h,required:g,properties:w.properties?u.deepClone(w.properties):{},when:w.when?_.ContextKeyExpr.deserialize(w.when):void 0}}b.from=k})(D||(D={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:S}});class I{constructor(){this._onDefinitionsChanged=new T.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((k,w)=>{R.setHandler((f,d)=>{this._schema=void 0;try{for(const h of d.removed){const g=h.value;for(const v of g)this.taskTypes&&v.type&&this.taskTypes[v.type]&&delete this.taskTypes[v.type]}for(const h of d.added){const g=h.value;for(const v of g){const C=D.from(v,h.description.identifier,h.collector);C&&(this.taskTypes[C.taskType]=C)}}(d.removed.length>0||d.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}k(void 0)})})}onReady(){return this.readyPromise}get(k){return this.taskTypes[k]}all(){return Object.keys(this.taskTypes).map(k=>this.taskTypes[k])}getJsonSchema(){if(this._schema===void 0){const k=[];for(const w of this.all()){const f={type:"object",additionalProperties:!1};w.required.length>0&&(f.required=w.required.slice(0)),w.properties!==void 0?f.properties=u.deepClone(w.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[w.taskType]},k.push(f)}this._schema={oneOf:k}}return this._schema}}e.TaskDefinitionRegistry=new I}),define(_e[248],ye([1,0,193,9,24,23,54,247]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var S;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(L){function F(U){if(!U)return L.Strong;switch(U.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=F}(S=e.ShellQuoting||(e.ShellQuoting={}));var D;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(D=e.CommandOptions||(e.CommandOptions={}));var R;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(L){function F(U){switch(U.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=F}(R=e.RevealKind||(e.RevealKind={}));var I;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(I=e.RevealProblemKind||(e.RevealProblemKind={})),function(L){function F(U){switch(U.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=F}(I=e.RevealProblemKind||(e.RevealProblemKind={}));var b;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(b=e.PanelKind||(e.PanelKind={})),function(L){function F(U){switch(U.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=F}(b=e.PanelKind||(e.PanelKind={}));var k;(function(L){L.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:b.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(L){function F(H){switch(H.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=F;function U(H){switch(H){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=U}(w=e.RuntimeType||(e.RuntimeType={}));var f;(function(L){function F(U){return P.isString(U)?U:U.value}L.value=F})(f=e.CommandString||(e.CommandString={}));var d;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function F(H){return H===L.Clean._id||H===L.Build._id||H===L.Rebuild._id||H===L.Test._id}L.is=F;function U(H){if(H!==void 0)return P.isString(H)?F(H)?{_id:H,isDefault:!1}:void 0:H}L.from=U})(d=e.TaskGroup||(e.TaskGroup={}));var h;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var g;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function F(U){switch(U){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=F})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var v;(function(L){L.parallel="parallel",L.sequence="sequence"})(v=e.DependsOrder||(e.DependsOrder={}));var C;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(C=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:C.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class i{constructor(F,U,H,de,Y,V){this._label="",this._id=F,U&&(this._label=U),H&&(this.type=H),this.runOptions=de,this.configurationProperties=Y,this._source=V}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.getFolderId(),id:this._id};return JSON.stringify(F)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,U=!1){if(F===void 0)return!1;if(P.isString(F))return F===this._label||F===this.configurationProperties.identifier||U&&F===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),F&&(this._taskLoadMessages=this._taskLoadMessages.concat(F))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class o extends i{constructor(F,U,H,de,Y,V,X,Z){super(F,H,void 0,X,Z,U),this.command={},this._source=U,this.hasDefinedMatchers=V,Y&&(this.command=Y)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case w.Shell:U="shell";break;case w.Process:U="process";break;case w.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(F){return F instanceof o}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.getFolderId();if(!F)return;let U=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(U+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:U};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(F){return new o(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=o;class s extends i{constructor(F,U,H,de,Y,V,X){super(F,H,de,V,X,U),this._source=U,this.configures=Y}static is(F){return F instanceof s}fromObject(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.getFolderId();if(!F)return;let U=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(U+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:U};return JSON.stringify(H)}}e.ConfiguringTask=s;class l extends i{constructor(F,U,H,de,Y,V,X,Z,te){super(F,H,de,Z,te,U),this.defines=Y,this.hasDefinedMatchers=X,this.command=V,this.icon=te.icon,this.hide=te.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof l}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.getFolderId(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(F){return new l(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=l;class r extends i{constructor(F,U,H,de,Y,V){super(F,H,de,Y,V,U),this._source=U}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(F){return new r(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=r;var m;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(m=e.ExecutionEngine||(e.ExecutionEngine={})),function(L){L._default=L.Terminal}(m=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class t{constructor(F){this._order=new Map;for(let U=0;U<F.length;U++)this._order.set(F[U].uri.toString(),U)}compare(F,U){const H=F.getWorkspaceFolder(),de=U.getWorkspaceFolder();if(H&&de){let Y=this._order.get(H.uri.toString());Y=Y===void 0?0:Y+1;let V=this._order.get(de.uri.toString());return V=V===void 0?0:V+1,Y===V?F._label.localeCompare(U._label):Y-V}else return!H&&de?-1:H&&!de?1:0}}e.TaskSorter=t;var c;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(c=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(L){L.SingleRun="singleRun",L.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var y;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(y=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(L){function F(U,H,de,Y){if(H){const V={kind:U,taskId:H._id,taskName:H.configurationProperties.name,runType:H.configurationProperties.isBackground?"background":"singleRun",group:H.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:de,__task:H};return U==="start"?V.resolvedVariables=Y:U==="processStarted"?V.processId=Y:U==="processEnded"&&(V.exitCode=Y),Object.freeze(V)}else return Object.freeze({kind:"changed"})}L.create=F})(M=e.TaskEvent||(e.TaskEvent={}));var j;(function(L){function F(H){const de=Object.keys(H).sort();let Y="";for(const V of de){let X=H[V];X instanceof Object?X=F(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Y+=V+","+X+","}return Y}function U(H){const Y={_key:F(H),type:H.taskType};return Object.assign(Y,H),Y}L.create=U})(j=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var $;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection"})($=e.TaskSettingId||(e.TaskSettingId={}));var N;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(N=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var x;(function(L){function F(U,H){const de=T.TaskDefinitionRegistry.get(U.type);if(de===void 0){const Z=A.deepClone(U);return delete Z._key,j.create(Z)}const Y=Object.create(null);Y.type=de.taskType;const V=new Set;de.required.forEach(Z=>V.add(Z));const X=de.properties;for(const Z of Object.keys(X)){const te=U[Z];if(te!=null)Y[Z]=te;else if(V.has(Z)){const K=X[Z];if(K.default!==void 0)Y[Z]=A.deepClone(K.default);else switch(K.type){case"boolean":Y[Z]=!1;break;case"number":case"integer":Y[Z]=0;break;case"string":Y[Z]="";break;default:H.error(a.localize(2,null,JSON.stringify(U,void 0,0),Z));return}}}return j.create(Y)}L.createTaskIdentifier=F})(x=e.TaskDefinition||(e.TaskDefinition={}))}),define(_e[249],ye([1,0,11]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class P{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,T)=>{this._actualOk=_,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,a.onUnexpectedError)(_))}then(_,T){return this._ensureActual().then(_,T)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=P;class u extends P{constructor(){super(),this._hasErr=!0,this._err=new a.CancellationError}}e.CanceledLazyPromise=u}),define(_e[58],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++a.count}}a.count=0,e.ProxyIdentifier=a;const P=[];function u(T){const S=new a(T);return P[S.nid]=S,S}e.createProxyIdentifier=u;function A(T){return P[T].sid}e.getStringIdentifierForProxy=A;class _{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=_}),define(_e[5],ye([1,0,58]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var u;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(u=e.TabInputKind||(e.TabInputKind={}));var A;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(d){return d._id=I._n++,d}}I._n=0,e.IdObject=I;var b;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(b=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var k;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(k=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,a.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(_e[77],ye([1,0,4,13,5,20]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(S,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(u.MainContext.MainThreadTelemetry)}report(S,D,R){const I=this.getUsageKey(S,D);this._reportedUsages.has(I)||(this._reportedUsages.add(I),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:S}))}getUsageKey(S,D){return`${S}-${D.identifier.value}`}};_=Ve([We(0,A.IExtHostRpcService),We(1,P.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,D){}})}),define(_e[250],ye([1,0,3,5,7,26]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,D,R,I={}){const b=A.ExtensionIdentifier.toKey(S.identifier),k=this._inFlightRequests.get(b)||[],w=[...R].sort().join(" ");let f=k.find(d=>d.providerId===D&&d.scopes===w);if(f)return f.result;{const d=this._getSession(S,b,D,R,I);f={providerId:D,scopes:w,result:d},k.push(f),this._inFlightRequests.set(b,k);try{await d}finally{const h=k.findIndex(g=>g.providerId===D&&g.scopes===w);h>-1&&(k.splice(h),this._inFlightRequests.set(b,k))}return d}}async _getSession(S,D,R,I,b={}){await this._proxy.$ensureProvider(R);const k=S.displayName||S.name;return this._proxy.$getSession(R,I,D,k,b)}async removeSession(S,D){const R=this._authenticationProviders.get(S);return R?R.provider.removeSession(D):this._proxy.$removeSession(S,D)}registerAuthenticationProvider(S,D,R,I){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:D,provider:R,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(k=>k.id===S)||this._providers.push({id:S,label:D});const b=R.onDidChangeSessions(k=>{this._proxy.$sendDidChangeSessions(S,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,D,I?.supportsMultipleAccounts??!1),new u.Disposable(()=>{b.dispose(),this._authenticationProviders.delete(S);const k=this._providers.findIndex(w=>w.id===S);k>-1&&this._providers.splice(k),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,D){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,D){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,D){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,D){return this._onDidChangeSessions.fire({provider:{id:S,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(_e[251],ye([1,0,5,20,15]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(T,S){this._proxy=T.getProxy(a.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:D=>S.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,D){const R=u.WorkspaceEdit.from(T,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,D?.isRefactoring??!1)}};A=Ve([We(0,P.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(_e[252],ye([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(A){const _=A.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(T){return _.$writeText(T)}})}}e.ExtHostClipboard=P});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[40],ye([1,0,9,7,15,23,5,16,13,69,32,52,2,6,4,20,137,22,58,45,43,74]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C,p){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(c,E){i.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,o.set(this,void 0),Je(this,i,c.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=E,Je(this,o,c.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,y=>{const M=this._apiCommands.get(y);return M?.result===m.Void?M:void 0},E),this._argumentProcessors=[{processArgument(y){return(0,D.revive)(y)}},{processArgument(y){return(0,A.cloneAndChange)(y,function(M){if(R.Range.isIRange(M))return u.Range.to(M);if(I.Position.isIPosition(M))return u.Position.to(M);if(R.Range.isIRange(M.range)&&b.URI.isUri(M.uri))return u.location.to(M);if(M instanceof h.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const E=this.registerCommand(!1,c.id,async(...y)=>{const M=c.args.map(($,N)=>{if(!$.validate(y[N]))throw new Error(`Invalid argument '${$.name}' when running '${c.id}', received: ${y[N]}`);return $.convert(y[N])}),j=await this.executeCommand(c.internalId,...M);return c.result.convert(j,y,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new P.Disposable(()=>{E.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,E,y,M,j,$){if(this._logService.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this._commands.has(E))throw new Error(`command '${E}' already exists`);return this._commands.set(E,{callback:y,thisArg:M,description:j,extension:$}),c&&Ue(this,i,"f").$registerCommand(E),new P.Disposable(()=>{this._commands.delete(E)&&c&&Ue(this,i,"f").$unregisterCommand(E)})}executeCommand(c,...E){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,E,!0)}async _doExecuteCommand(c,E,y){if(this._commands.has(c))return Ue(this,i,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,E,!1);{let M=!1;const j=(0,A.cloneAndChange)(E,function($){if($ instanceof P.Position)return u.Position.from($);if($ instanceof P.Range)return u.Range.from($);if($ instanceof P.Location)return u.location.from($);if(P.NotebookRange.isNotebookRange($))return u.NotebookRange.from($);if($ instanceof ArrayBuffer)return M=!0,h.VSBuffer.wrap(new Uint8Array($));if($ instanceof Uint8Array)return M=!0,h.VSBuffer.wrap($);if($ instanceof h.VSBuffer)return M=!0,$;if(!Array.isArray($))return $});try{const $=await Ue(this,i,"f").$executeCommand(c,M?new g.SerializableObjectWithBuffers(j):j,y);return(0,D.revive)($)}catch($){if($ instanceof Error&&$.message==="$executeCommand:retry")return this._doExecuteCommand(c,E,!1);throw $}}}async _executeContributedCommand(c,E,y){const M=this._commands.get(c);if(!M)throw new Error("Unknown command");const{callback:j,thisArg:$,description:N}=M;if(N)for(let L=0;L<N.args.length;L++)try{(0,a.validateConstraint)(E[L],N.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${N.args[L].name}' - ${N.args[L].description}`)}const x=C.StopWatch.create();try{return await j.apply($,E)}catch(L){if(c===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...E);F&&(c=F.command)}throw this._logService.error(L,c,M.extension?.identifier),y?new class extends Error{constructor(){super((0,v.toErrorMessage)(L)),this.id=c,this.source=M.extension?.displayName??M.extension?.name}}:L}finally{this._reportTelemetry(M,c,x.elapsed())}}_reportTelemetry(c,E,y){!c.extension||Ue(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:new p.TelemetryTrustedValue(E),duration:y})}$executeContributedCommand(c,...E){this._logService.trace("ExtHostCommands#$executeContributedCommand",c);const y=this._commands.get(c);return y?(E=E.map(M=>this._argumentProcessors.reduce((j,$)=>$.processArgument(j,y.extension?.identifier),M)),this._executeContributedCommand(c,E,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Ue(this,i,"f").$getCommands().then(E=>(c&&(E=E.filter(y=>y[0]!=="_")),E))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[E,y]of this._commands){const{description:M}=y;M&&(c[E]=M)}return Promise.resolve(c)}};i=new WeakMap,o=new WeakMap,s=Ve([We(0,f.IExtHostRpcService),We(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class l{constructor(c,E,y){this._commands=c,this._lookupApiCommand=E,this._logService=y,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,E){if(!c)return;const y={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return y;const M=this._lookupApiCommand(c.command);if(M)y.id=M.internalId,y.arguments=M.args.map((j,$)=>j.convert(c.arguments&&c.arguments[$]));else if((0,T.isNonEmptyArray)(c.arguments)){const j=`${c.command}/${++this._cachIdPool}`;this._cache.set(j,c),E.add((0,k.toDisposable)(()=>{this._cache.delete(j),this._logService.trace("CommandsConverter#DISPOSE",j)})),y.$ident=j,y.id=this.delegatingCommandId,y.arguments=[j],this._logService.trace("CommandsConverter#CREATE",c.command,j)}return y}fromInternal(c){return typeof c.$ident=="string"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const E=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],E?E.command:"MISSING"),E?this._commands.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${c[0]}`)}}e.CommandsConverter=l;class r{constructor(c,E,y,M){this.name=c,this.description=E,this.validate=y,this.convert=M}optional(){return new r(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,E){return new r(c??this.name,E??this.description,this.validate,this.convert)}}r.Uri=new r("uri","Uri of a text document",t=>b.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>P.Position.isPosition(t),u.Position.from),r.Range=new r("range","A range in a text document",t=>P.Range.isRange(t),u.Range.from),r.Selection=new r("selection","A selection in a text document",t=>P.Selection.isSelection(t),u.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof P.CallHierarchyItem,u.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof P.TypeHierarchyItem,u.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof d.TestItemImpl,u.TestItem.from),e.ApiCommandArgument=r;class m{constructor(c,E){this.description=c,this.convert=E}}m.Void=new m("no result",t=>t),e.ApiCommandResult=m;class n{constructor(c,E,y,M,j){this.id=c,this.internalId=E,this.description=y,this.args=M,this.result=j}}e.ApiCommand=n}),define(_e[253],ye([1,0,2,15,7,72,40,16,120,125,14]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",k(P.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,d)=>{if((0,T.isFalsyOrEmpty)(f))return;class h extends u.SymbolInformation{static to(v){const C=new h(v.name,P.SymbolKind.to(v.kind),v.containerName||"",new u.Location(d[0],P.Range.to(v.range)));return C.detail=v.detail,C.range=C.location.range,C.selectionRange=P.Range.to(v.selectionRange),C.children=v.children?v.children.map(h.to):[],C}}return f.map(h.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(P.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(P.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new _.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(P.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",k(P.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",k(P.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(d=>u.Position.isPosition(d)),f=>f.map(P.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(d=>{let h;for(const g of d.reverse())h=new u.SelectionRange(P.Range.to(g),h);return h}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(P.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(P.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(P.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(P.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:P.Range.to(f.range),placeholder:f.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return P.WorkspaceEdit.to(f)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(P.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new u.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,S.decodeSemanticTokensDto)(f);if(d.type==="full")return new u.SemanticTokens(d.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new u.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,S.decodeSemanticTokensDto)(f);if(d.type==="full")return new u.SemanticTokens(d.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,d,h)=>{if(!f)return new u.CompletionList([]);const g=f.suggestions.map(v=>P.CompletionItem.to(v,h));return new u.CompletionList(g,f.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return P.SignatureHelp.to(f)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,d,h)=>k(g=>new u.CodeLens(P.Range.to(g.range),g.command&&h.fromInternal(g.command)))(f))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>u.Range.isRange(f),f=>u.Selection.isSelection(f)?P.Selection.from(f):P.Range.from(f)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,d,h)=>k(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(g.command)}else{const v=new u.CodeAction(g.title,g.kind?new u.CodeActionKind(g.kind):void 0);return g.edit&&(v.edit=P.WorkspaceEdit.to(g.edit)),g.command&&(v.command=h.fromInternal(g.command)),v.isPreferred=g.isPreferred,v}})(f))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(d=>new u.ColorInformation(P.Range.to(d.range),P.Color.to(d.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",f=>f instanceof u.Color,P.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:P.Range.from(f.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(P.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,d,h)=>f.map(P.InlayHint.to.bind(void 0,h)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",k(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(d=>P.NotebookExclusiveDocumentPattern.to(d))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(P.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>a.URI.isUri(f)||typeof f=="string"&&(0,D.matchesSomeScheme)(f,R.Schemas.http,R.Schemas.https),f=>f),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[P.ViewColumn.from(f),void 0]:[P.ViewColumn.from(f.viewColumn),P.TextEditorOpenOptions.from(f)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[P.ViewColumn.from(f),void 0]:[P.ViewColumn.from(f.viewColumn),P.TextEditorOpenOptions.from(f)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[P.ViewColumn.from(f.viewColumn),P.TextEditorOpenOptions.from(f)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(P.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(P.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(P.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void),new _.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[_.ApiCommandArgument.String.with("name","The context key name"),new _.ApiCommandArgument("value","The context key value",()=>!0,f=>f)],_.ApiCommandResult.Void)];class b{static register(d){I.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=b;function k(f){return d=>{if(Array.isArray(d))return d.map(f)}}function w(f){if(!Array.isArray(f))return;const d=[];for(const h of f)A.isLocationLink(h)?d.push(P.DefinitionLink.to(h)):d.push(P.location.to(h));return d}}),define(_e[254],ye([1,0,19,62,3,6,2,72,26,15,7,5]),function(ie,e,a,P,u,A,_,T,S,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function b(k,w,f){const d=k.getProxy(I.MainContext.MainThreadComments);class h{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,w.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const m=this._commentControllers.get(r.handle);return m?m.value:r}else if(r&&r.$mid===7){const m=this._commentControllers.get(r.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.commentThreadHandle);return n?n.value:r}else if(r&&(r.$mid===9||r.$mid===8)){const m=this._commentControllers.get(r.thread.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.thread.commentThreadHandle);return n?r.$mid===8?n.value:{thread:n.value,text:r.text}:r}else if(r&&r.$mid===10){const m=this._commentControllers.get(r.thread.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;const t=r.commentUniqueId,c=n.getCommentByUniqueId(t);return c||r}else if(r&&r.$mid===11){const m=this._commentControllers.get(r.thread.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;const t=r.text,c=r.commentUniqueId,E=n.getCommentByUniqueId(c);return E?(typeof E.body=="string"?E.body=t:E.body=new R.MarkdownString(t),E):r}return r}})}createCommentController(r,m,n){const t=h.handlePool++,c=new v(r,t,m,n);this._commentControllers.set(c.handle,c);const E=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(r.identifier))||[];return E.push(c),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(r.identifier),E),c.value}$createCommentThreadTemplate(r,m,n){const t=this._commentControllers.get(r);!t||t.$createCommentThreadTemplate(m,n)}async $updateCommentThreadTemplate(r,m,n){const t=this._commentControllers.get(r);!t||t.$updateCommentThreadTemplate(m,n)}$deleteCommentThread(r,m){this._commentControllers.get(r)?.$deleteCommentThread(m)}$provideCommentingRanges(r,m,n){const t=this._commentControllers.get(r);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const c=f.getDocument(_.URI.revive(m));return(0,a.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(c,n)).then(E=>E?E.map(y=>D.Range.from(y)):void 0)}$toggleReaction(r,m,n,t,c){const E=this._commentControllers.get(r);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const y=E.getCommentThread(m);if(y){const M=y.getCommentByUniqueId(t.uniqueIdInThread);if(E!==void 0&&M&&E.reactionHandler)return E.reactionHandler(M,i(c))}return Promise.resolve(void 0)})}dispose(){}}h.handlePool=0;class g{set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(r){this._state=r,this.modifications.state=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(r,m,n,t,c,E,y,M){this._commentControllerHandle=m,this._id=n,this._uri=t,this._range=c,this._comments=E,this.extensionDescription=y,this._isTemplate=M,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new u.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),d.$createCommentThread(m,this.handle,this._id,this._uri,D.Range.from(this._range),y.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(m,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range($){j.range=$},get comments(){return j.comments},set comments($){j.comments=$},get collapsibleState(){return j.collapsibleState},set collapsibleState($){j.collapsibleState=$},get canReply(){return j.canReply},set canReply($){j.canReply=$},get contextValue(){return j.contextValue},set contextValue($){j.contextValue=$},get label(){return j.label},set label($){j.label=$},get state(){return j.state},set state($){j.state=$},dispose:()=>{j.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const r=n=>Object.prototype.hasOwnProperty.call(this.modifications,n),m={};r("range")&&(m.range=D.Range.from(this._range)),r("label")&&(m.label=this.label),r("contextValue")&&(m.contextValue=this.contextValue??null),r("comments")&&(m.comments=this._comments.map(n=>C(this,n,this._commentsMap))),r("collapsibleState")&&(m.collapseState=o(this._collapseState)),r("canReply")&&(m.canReply=this.canReply),r("state")&&(m.state=s(this._state)),r("isTemplate")&&(m.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(r){for(const m of this._commentsMap){const n=m[0],t=m[1];if(r===t)return n}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}g._handlePool=0,Ve([(0,P.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class v{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(r){this._commentingRangeProvider=r,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(r,m,n,t){this._extension=r,this._handle=m,this._id=n,this._label=t,this._threads=new Map,d.$registerCommentController(this.handle,n,t);const c=this;this.value=Object.freeze({id:c.id,label:c.label,get options(){return c.options},set options(E){c.options=E},get commentingRangeProvider(){return c.commentingRangeProvider},set commentingRangeProvider(E){c.commentingRangeProvider=E},get reactionHandler(){return c.reactionHandler},set reactionHandler(E){c.reactionHandler=E},createCommentThread(E,y,M){return c.createCommentThread(E,y,M).value},dispose:()=>{c.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(r,m,n,t){if(typeof r=="string"){const c=new g(this.id,this.handle,r,m,n,t,this._extension,!1);return this._threads.set(c.handle,c),c}else{const c=new g(this.id,this.handle,void 0,r,m,n,this._extension,!1);return this._threads.set(c.handle,c),c}}$createCommentThreadTemplate(r,m){const n=new g(this.id,this.handle,void 0,_.URI.revive(r),D.Range.to(m),[],this._extension,!0);return n.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(n.handle,n),n}$updateCommentThreadTemplate(r,m){const n=this._threads.get(r);n&&(n.range=D.Range.to(m))}$deleteCommentThread(r){this._threads.get(r)?.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function C(l,r,m){let n=m.get(r);n||(n=++l.commentHandle,m.set(r,n));const t=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:n,body:typeof r.body=="string"?r.body:D.MarkdownString.from(r.body),userName:r.author.name,userIconPath:t,label:r.label,commentReactions:r.reactions?r.reactions.map(c=>p(c)):void 0,timestamp:r.timestamp?.toJSON()}}function p(l){return{label:l.label,iconPath:l.iconPath?D.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function i(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?_.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function o(l){if(l!==void 0)switch(l){case R.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function s(l){if(l!==void 0)switch(l){case R.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new h}e.createExtHostComments=b}),define(_e[255],ye([1,0,23,5,25,20]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(R,I){this._mainThreadConsole=R.getProxy(P.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,I){const b=this,k=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){b._handleConsoleCall(R,I,k,arguments)}})}_handleConsoleCall(R,I,b,k){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:S(k,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,b,k)}};_=Ve([We(0,A.IExtHostRpcService),We(1,u.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const T=1e5;function S(D,R){const I=[];if(D.length)for(let b=0;b<D.length;b++){let k=D[b];if(typeof k>"u")k="undefined";else if(k instanceof Error){const w=k;w.stack?k=w.stack:k=w.toString()}I.push(k)}if(R){const b=new Error().stack;b&&I.push({__$stack:b.split(`
`).slice(3).join(`
`)})}try{const b=(0,a.safeStringify)(I);return b.length>T?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}),define(_e[139],ye([1,0,2,5,7,4,20,13,16,8,10,27]),function(ie,e,a,P,u,A,_,T,S,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class Ni{constructor(w,f){this._logService=f,this._provider=new Map,this._proxy=w.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(w,f){const d=Ni._handlePool++;this._provider.set(d,{provider:w,extensionDescription:f}),this._proxy.$registerDecorationProvider(d,f.identifier.value);const h=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(d,null);return}const v=(0,S.asArray)(g);if(v.length<=Ni._maxEventSize){this._proxy.$onDidChange(d,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,v.length);const C=v.map(o=>({uri:o,rank:(0,D.count)(o.path,"/")})),p=(0,S.groupBy)(C,(o,s)=>o.rank-s.rank||(0,D.compare)(o.uri.path,s.uri.path)),i=[];e:for(const o of p){let s;for(const l of o){const r=(0,R.dirname)(l.uri.path);if(s!==r&&(s=r,i.push(l.uri)>=Ni._maxEventSize))break e}}this._proxy.$onDidChange(d,i)});return new u.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(w,f,d){if(!this._provider.has(w))return Object.create(null);const h=Object.create(null),{provider:g,extensionDescription:v}=this._provider.get(w);return await Promise.all(f.map(async C=>{try{const{uri:p,id:i}=C,o=await Promise.resolve(g.provideFileDecoration(a.URI.revive(p),d));if(!o)return;try{u.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,I.checkProposedApiEnabled)(v,"codiconDecoration"),h[i]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${v}': ${s}`)}}catch(p){this._logService.error(p)}})),h}};b._handlePool=0,b._maxEventSize=250,b=Ve([We(0,_.IExtHostRpcService),We(1,T.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[256],ye([1,0,177,124,2,5,7,15,3,13,28,48]),function(ie,e,a,P,u,A,_,T,S,D,R,I){"use strict";var b,k,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(g,v,C,p,i,o,s){this._name=g,this._owner=v,this._maxDiagnosticsPerFile=C,this._modelVersionIdProvider=p,b.set(this,void 0),k.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,Je(this,w,new R.ResourceMap(l=>i.getComparisonKey(l)),"f"),Je(this,b,o,"f"),Je(this,k,s,"f")}dispose(){this._isDisposed||(Ue(this,k,"f").fire([...Ue(this,w,"f").keys()]),Ue(this,b,"f")?.$clear(this._owner),Ue(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,v){if(!g){this.clear();return}this._checkDisposed();let C=[];if(u.URI.isUri(g)){if(!v){this.delete(g);return}Ue(this,w,"f").set(g,v.slice()),C=[g]}else if(Array.isArray(g)){C=[];let i;g=[...g].sort(f._compareIndexedTuplesByUri);for(const o of g){const[s,l]=o;if((!i||s.toString()!==i.toString())&&(i&&Ue(this,w,"f").get(i).length===0&&Ue(this,w,"f").delete(i),i=s,C.push(s),Ue(this,w,"f").set(s,[])),l)Ue(this,w,"f").get(s)?.push(...l);else{const r=Ue(this,w,"f").get(s);r&&(r.length=0)}}}if(Ue(this,k,"f").fire(C),!Ue(this,b,"f"))return;const p=[];for(const i of C){let o=[];const s=Ue(this,w,"f").get(i);if(s)if(s.length>this._maxDiagnosticsPerFile){o=[];const l=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const m of s)if(m.severity===l[r]&&o.push({...T.Diagnostic.from(m),modelVersionId:this._modelVersionIdProvider(i)})===this._maxDiagnosticsPerFile)break e;o.push({severity:P.MarkerSeverity.Info,message:(0,a.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(l=>({...T.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(i)}));p.push([i,o])}Ue(this,b,"f").$changeMany(this._owner,p)}delete(g){this._checkDisposed(),Ue(this,k,"f").fire([g]),Ue(this,w,"f").delete(g),Ue(this,b,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Ue(this,k,"f").fire([...Ue(this,w,"f").keys()]),Ue(this,w,"f").clear(),Ue(this,b,"f")?.$clear(this._owner)}forEach(g,v){this._checkDisposed();for(const[C,p]of this)g.call(v,C,p,this)}*[(b=new WeakMap,k=new WeakMap,w=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Ue(this,w,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const v=Ue(this,w,"f").get(g);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Ue(this,w,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,v){return g[0].toString()<v[0].toString()?-1:g[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=f;let d=class pi{static _mapper(g){const v=new R.ResourceMap;for(const C of g)v.set(C,C);return{uris:Object.freeze(Array.from(v.values()))}}constructor(g,v,C,p){this._logService=v,this._fileSystemInfoService=C,this._extHostDocumentsAndEditors=p,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,pi._mapper),this._proxy=g.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,v){const{_collections:C,_proxy:p,_onDidChangeDiagnostics:i,_logService:o,_fileSystemInfoService:s,_extHostDocumentsAndEditors:l}=this,r=new class{$changeMany(t,c){p.$changeMany(t,c),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,t,c.length===0?"CLEARING":c)}$clear(t){p.$clear(t),o.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,t)}dispose(){p.dispose()}};let m;if(!v)v="_generated_diagnostic_collection_name_#"+pi._idPool++,m=v;else if(!C.has(v))m=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do m=v+pi._idPool++;while(C.has(m))}return new class extends f{constructor(){super(v,m,pi._maxDiagnosticsPerFile,t=>l.getDocument(t)?.version,s.extUri,r,i),C.set(m,this)}dispose(){super.dispose(),C.delete(m)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const v=new Map,C=[];for(const p of this._collections.values())p.forEach((i,o)=>{let s=v.get(i.toString());typeof s>"u"&&(s=C.length,v.set(i.toString(),s),C.push([i,[]])),C[s][1]=C[s][1].concat(...o)});return C}}_getDiagnostics(g){let v=[];for(const C of this._collections.values())C.has(g)&&(v=v.concat(C.get(g)));return v}$acceptMarkersChange(g){if(!this._mirrorCollection){const v="_generated_mirror",C=new f(v,v,pi._maxDiagnosticsPerFile,p=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(v,C),this._mirrorCollection=C}for(const[v,C]of g)this._mirrorCollection.set(u.URI.revive(v),C.map(T.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Ve([We(1,D.ILogService),We(2,I.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(_e[257],ye([1,0,2,5]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class u{constructor(_){this._proxy=_.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(T=>T?T.map(S=>a.URI.revive(S)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(T=>T?a.URI.revive(T):void 0)}}e.ExtHostDialogs=u}),define(_e[258],ye([1,0,11,2,7,5,14,21,8]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(I,b,k){this._documentsAndEditors=b,this._logService=k,this._documentContentProviders=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,b){if(Object.keys(_.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const k=D._handlePool++;this._documentContentProviders.set(k,b),this._proxy.$registerTextContentProvider(k,I);let w;return typeof b.onDidChange=="function"&&(w=b.onDidChange(f=>{if(f.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(k,f).then(d=>{if(!d&&typeof d!="string")return;const h=this._documentsAndEditors.getDocument(f);if(!h)return;const g=(0,S.splitLines)(d);if(!h.equalLines(g))return this._proxy.$onVirtualDocumentChange(f,d)},a.onUnexpectedError)})),new u.Disposable(()=>{this._documentContentProviders.delete(k)&&this._proxy.$unregisterTextContentProvider(k),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(I,b){const k=this._documentContentProviders.get(I);return k?Promise.resolve(k.provideTextDocumentContent(P.URI.revive(b),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}D._handlePool=0,e.ExtHostDocumentContentProvider=D}),define(_e[259],ye([1,0,3,6,2,5,135,15,9,23,7]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(k,w){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new P.DisposableStore,this._documentLoader=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(f=>{for(const d of f)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(f=>{for(const d of f)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(k){if(!k)return;const w=this._documentsAndEditors.getDocument(k);if(w)return w}getDocument(k){const w=this.getDocumentData(k);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return w.document}ensureDocumentData(k){const w=this._documentsAndEditors.getDocument(k);if(w)return Promise.resolve(w);let f=this._documentLoader.get(k.toString());return f||(f=this._proxy.$tryOpenDocument(k).then(d=>{this._documentLoader.delete(k.toString());const h=u.URI.revive(d);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(h))},d=>(this._documentLoader.delete(k.toString()),Promise.reject(d))),this._documentLoader.set(k.toString(),f)),f}createDocumentData(k){return this._proxy.$tryCreateDocument(k).then(w=>u.URI.revive(w))}$acceptModelLanguageChanged(k,w){const f=u.URI.revive(k),d=this._documentsAndEditors.getDocument(f);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(w),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(k){const w=u.URI.revive(k),f=this._documentsAndEditors.getDocument(w);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this._onDidSaveDocument.fire(f.document)}$acceptDirtyStateChanged(k,w){const f=u.URI.revive(k),d=this._documentsAndEditors.getDocument(f);if(!d)throw new Error("unknown document");d._acceptIsDirty(w),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,w,f){const d=u.URI.revive(k),h=this._documentsAndEditors.getDocument(d);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),h.onEvents(w);let g;w.isUndoing?g=R.TextDocumentChangeReason.Undo:w.isRedoing&&(g=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:h.document,contentChanges:w.changes.map(v=>({range:T.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text})),reason:g}))}setWordDefinitionFor(k,w){(0,_.setWordDefinitionFor)(k,w)}}e.ExtHostDocuments=I}),define(_e[59],ye([1,0,50,3,6,2,4,5,135,20,138,15,13,28,14,64,65]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(C){this.value=C,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(C,p){this._extHostRpc=C,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new k.ResourceMap,this._onDidAddDocuments=new P.Emitter,this._onDidRemoveDocuments=new P.Emitter,this._onDidChangeVisibleTextEditors=new P.Emitter,this._onDidChangeActiveTextEditor=new P.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(C){this.acceptDocumentsAndEditorsDelta(C)}acceptDocumentsAndEditorsDelta(C){const p=[],i=[],o=[];if(C.removedDocuments)for(const s of C.removedDocuments){const l=A.URI.revive(s),r=this._documents.get(l);r?.unref()&&(this._documents.delete(l),p.push(r.value))}if(C.addedDocuments)for(const s of C.addedDocuments){const l=A.URI.revive(s.uri);let r=this._documents.get(l);if(r&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);r||(r=new h(new S.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),l,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(l,r),i.push(r.value)),r.ref()}if(C.removedEditors)for(const s of C.removedEditors){const l=this._editors.get(s);this._editors.delete(s),l&&o.push(l)}if(C.addedEditors)for(const s of C.addedEditors){const l=A.URI.revive(s.documentUri);a.ok(this._documents.has(l),`document '${l}' does not exist`),a.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const r=this._documents.get(l).value,m=new R.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>r.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(n=>I.Range.to(n)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,m)}C.newActiveEditor!==void 0&&(a.ok(C.newActiveEditor===null||this._editors.has(C.newActiveEditor),`active editor '${C.newActiveEditor}' does not exist`),this._activeEditorId=C.newActiveEditor),(0,u.dispose)(p),(0,u.dispose)(o),C.removedDocuments&&this._onDidRemoveDocuments.fire(p),C.addedDocuments&&this._onDidAddDocuments.fire(i),(C.removedEditors||C.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),C.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(C){return this._documents.get(C)?.value}allDocuments(){return f.Iterable.map(this._documents.values(),C=>C.value)}getEditor(C){return this._editors.get(C)}activeEditor(C){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return C?p:p?.value}allEditors(){return[...this._editors.values()]}};g=Ve([We(0,D.IExtHostRpcService),We(1,b.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(_e[60],ye([1,0,15,5,2,3,4,7,20,9,61]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class I{constructor(d,h,g){this._activeTabIdGetter=g,this._parentGroup=h,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,h={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(h)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new T.TextTabInput(u.URI.revive(this._dto.input.uri));case 2:return new T.TextDiffTabInput(u.URI.revive(this._dto.input.original),u.URI.revive(this._dto.input.modified));case 3:return new T.TextMergeTabInput(u.URI.revive(this._dto.input.base),u.URI.revive(this._dto.input.input1),u.URI.revive(this._dto.input.input2),u.URI.revive(this._dto.input.result));case 6:return new T.CustomEditorTabInput(u.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new T.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new T.NotebookEditorTabInput(u.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(u.URI.revive(this._dto.input.original),u.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(u.URI.revive(this._dto.input.uri),u.URI.revive(this._dto.input.inputBoxUri));default:return}}}class b{constructor(d,h){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=h;for(const g of d.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new I(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,h={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(g=>g.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(h)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const g=new I(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,g),d.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(d.kind===1){const g=this._tabs.splice(d.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(d.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,g),g}const h=this._tabs.find(g=>g.tabId===d.tabDto.id);if(!h)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),h.acceptDtoUpdate(d.tabDto),h}activeTabId(){return this._activeTabId}}let k=class{constructor(d){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(P.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,h={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=d._activeGroupId;return(0,D.assertIsDefined)(d._extHostTabGroups.find(C=>C.groupId===g)?.apiObject)},close:async(g,v)=>{const C=Array.isArray(g)?g:[g];return C.length?w(C[0])?this._closeGroups(C,v):this._closeTabs(C,v):!0}};this._apiObject=Object.freeze(h)}return this._apiObject}$acceptEditorTabModel(d){const h=new Set(this._extHostTabGroups.map(s=>s.groupId)),g=new Set(d.map(s=>s.groupId)),v=(0,R.diffSets)(h,g),C=this._extHostTabGroups.filter(s=>v.removed.includes(s.groupId)).map(s=>s.apiObject),p=[],i=[];this._extHostTabGroups=d.map(s=>{const l=new b(s,()=>this._activeGroupId);return v.added.includes(l.groupId)?p.push(l.apiObject):i.push(l.apiObject),l});const o=(0,D.assertIsDefined)(d.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this._activeGroupId!==o&&(this._activeGroupId=o),this._onDidChangeTabGroups.fire(Object.freeze({opened:p,closed:C,changed:i}))}$acceptTabGroupUpdate(d){const h=this._extHostTabGroups.find(g=>g.groupId===d.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const h=this._extHostTabGroups.find(v=>v.groupId===d.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const g=h.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(d){for(const h of this._extHostTabGroups)for(const g of h.tabs)if(g.apiObject===d)return g}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(h=>h.apiObject===d)}async _closeTabs(d,h){const g=[];for(const v of d){const C=this._findExtHostTabFromApi(v);if(!C)throw new Error("Tab close: Invalid tab not found!");g.push(C.tabId)}return this._proxy.$closeTab(g,h)}async _closeGroups(d,h){const g=[];for(const v of d){const C=this._findExtHostTabGroupFromApi(v);if(!C)throw new Error("Group close: Invalid group not found!");g.push(C.groupId)}return this._proxy.$closeGroup(g,h)}};k=Ve([We(0,S.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function w(f){return f.tabs!==void 0}}),define(_e[260],ye([1,0,2,5,6,7,15,154,8,22,27]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const f=this._schemes.indexOf(w);f>=0&&(this._schemes.splice(f,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),f=[];let d,h,g=14,v=14;for(const C of w){let p=d?(0,S.commonPrefixLength)(d,C):0;for(p===0?h=1:h=v;p<C.length;p++)p+1===C.length?(g=v,v=9):v+=1,f.push([h,C.toUpperCase().charCodeAt(p),v]),f.push([h,C.toLowerCase().charCodeAt(p),v]),h=v;d=C,v=g}f.push([9,58,10]),f.push([10,47,12]),this._stateMachine=new T.StateMachine(f)}}provideDocumentLinks(w){this._initStateMachine();const f=[],d=T.LinkComputer.computeLinks({getLineContent(h){return w.lineAt(h-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const h of d){const g=_.DocumentLink.to(h);g.target&&f.push(g)}return f}}class b{constructor(w,f){this._extHostLanguageFeatures=f,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,f,d,h={}){if(this._registeredSchemes.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(f),this._registeredSchemes.add(f),this._fsProvider.set(g,d);let v=2;h.isCaseSensitive&&(v+=1024),h.isReadonly&&(v+=2048),typeof d.copy=="function"&&(v+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,R.checkProposedApiEnabled)(w,"fsChunks"),v+=4),this._proxy.$registerFileSystemProvider(g,f,v).catch(p=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${f}`),console.error(p)});const C=d.onDidChangeFile(p=>{const i=[];for(const o of p){const{uri:s,type:l}=o;if(s.scheme!==f)continue;let r;switch(l){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:s,type:r})}this._proxy.$onFileSystemChange(g,i)});return(0,u.toDisposable)(()=>{C.dispose(),this._linkProvider.delete(f),this._registeredSchemes.delete(f),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(w){const{type:f,ctime:d,mtime:h,size:g,permissions:v}=w;return{type:f,ctime:d,mtime:h,size:g,permissions:v}}$stat(w,f){return Promise.resolve(this._getFsProvider(w).stat(a.URI.revive(f))).then(d=>b._asIStat(d))}$readdir(w,f){return Promise.resolve(this._getFsProvider(w).readDirectory(a.URI.revive(f)))}$readFile(w,f){return Promise.resolve(this._getFsProvider(w).readFile(a.URI.revive(f))).then(d=>D.VSBuffer.wrap(d))}$writeFile(w,f,d,h){return Promise.resolve(this._getFsProvider(w).writeFile(a.URI.revive(f),d.buffer,h))}$delete(w,f,d){return Promise.resolve(this._getFsProvider(w).delete(a.URI.revive(f),d))}$rename(w,f,d,h){return Promise.resolve(this._getFsProvider(w).rename(a.URI.revive(f),a.URI.revive(d),h))}$copy(w,f,d,h){const g=this._getFsProvider(w);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(a.URI.revive(f),a.URI.revive(d),h))}$mkdir(w,f){return Promise.resolve(this._getFsProvider(w).createDirectory(a.URI.revive(f)))}$watch(w,f,d,h){const g=this._getFsProvider(w).watch(a.URI.revive(d),h);this._watches.set(f,g)}$unwatch(w,f){const d=this._watches.get(f);d&&(d.dispose(),this._watches.delete(f))}$open(w,f,d){const h=this._getFsProvider(w);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(a.URI.revive(f),d))}$close(w,f){const d=this._getFsProvider(w);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(f))}$read(w,f,d,h){const g=this._getFsProvider(w);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const v=D.VSBuffer.alloc(h);return Promise.resolve(g.read(f,d,v.buffer,0,h)).then(C=>v.slice(0,C))}$write(w,f,d,h){const g=this._getFsProvider(w);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(f,d,h.buffer,0,h.byteLength))}_getFsProvider(w){const f=this._fsProvider.get(w);if(!f){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return f}}e.ExtHostFileSystem=b}),define(_e[78],ye([1,0,5,44,7,22,4,20,48,6]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Yt{constructor(b,k){this._fileSystemProvider=new Map,this._proxy=b.getProxy(a.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(f){try{const d=w._fileSystemProvider.get(f.scheme);if(!d)return await w._proxy.$stat(f);await w._proxy.$ensureActivation(f.scheme);const h=await d.stat(f);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(d){Yt._handleError(d)}},async readDirectory(f){try{const d=w._fileSystemProvider.get(f.scheme);return d?(await w._proxy.$ensureActivation(f.scheme),(await d.readDirectory(f)).slice()):await w._proxy.$readdir(f)}catch(d){return Yt._handleError(d)}},async createDirectory(f){try{return await w._proxy.$mkdir(f)}catch(d){return Yt._handleError(d)}},async readFile(f){try{const d=w._fileSystemProvider.get(f.scheme);return d?(await w._proxy.$ensureActivation(f.scheme),(await d.readFile(f)).slice()):(await w._proxy.$readFile(f)).buffer}catch(d){return Yt._handleError(d)}},async writeFile(f,d){try{return await w._proxy.$writeFile(f,A.VSBuffer.wrap(d))}catch(h){return Yt._handleError(h)}},async delete(f,d){try{const h=w._fileSystemProvider.get(f.scheme);return h?(await w._proxy.$ensureActivation(f.scheme),await h.delete(f,{recursive:!1,...d})):await w._proxy.$delete(f,{recursive:!1,useTrash:!1,...d})}catch(h){return Yt._handleError(h)}},async rename(f,d,h){try{return await w._proxy.$rename(f,d,{overwrite:!1,...h})}catch(g){return Yt._handleError(g)}},async copy(f,d,h){try{return await w._proxy.$copy(f,d,{overwrite:!1,...h})}catch(g){return Yt._handleError(g)}},isWritableFileSystem(f){const d=k.getCapabilities(f);if(typeof d=="number")return!(d&2048)}})}static _handleError(b){if(b instanceof u.FileSystemError)throw b;if(!(b instanceof Error))throw new u.FileSystemError(String(b));if(b.name==="ENOPRO"||b.message.includes("ENOPRO"))throw u.FileSystemError.Unavailable(b.message);switch(b.name){case P.FileSystemProviderErrorCode.FileExists:throw u.FileSystemError.FileExists(b.message);case P.FileSystemProviderErrorCode.FileNotFound:throw u.FileSystemError.FileNotFound(b.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw u.FileSystemError.FileNotADirectory(b.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw u.FileSystemError.FileIsADirectory(b.message);case P.FileSystemProviderErrorCode.NoPermissions:throw u.FileSystemError.NoPermissions(b.message);case P.FileSystemProviderErrorCode.Unavailable:throw u.FileSystemError.Unavailable(b.message);default:throw new u.FileSystemError(b.message,b.name)}}addFileSystemProvider(b,k){return this._fileSystemProvider.set(b,k),(0,D.toDisposable)(()=>this._fileSystemProvider.delete(b))}};R=Ve([We(0,T.IExtHostRpcService),We(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(_e[261],ye([1,0,3,38,2,5,15,7]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(I,b,k,w,f,d,h,g){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter;const v=this.ensureWatching(I,k,f);this._config=0,d&&(this._config+=1),h&&(this._config+=2),g&&(this._config+=4);const C=(0,P.parse)(f),p=typeof f=="string",i=w(o=>{if(!d)for(const s of o.created){const l=u.URI.revive(s);C(l.fsPath)&&(!p||b.getWorkspaceFolder(l))&&this._onDidCreate.fire(l)}if(!h)for(const s of o.changed){const l=u.URI.revive(s);C(l.fsPath)&&(!p||b.getWorkspaceFolder(l))&&this._onDidChange.fire(l)}if(!g)for(const s of o.deleted){const l=u.URI.revive(s);C(l.fsPath)&&(!p||b.getWorkspaceFolder(l))&&this._onDidDelete.fire(l)}});this._disposable=T.Disposable.from(v,this._onDidCreate,this._onDidChange,this._onDidDelete,i)}ensureWatching(I,b,k){const w=T.Disposable.from();if(typeof k=="string")return w;const f=I.getProxy(A.MainContext.MainThreadFileSystem);let d=!1;(k.pattern.includes(P.GLOBSTAR)||k.pattern.includes(P.GLOB_SPLIT))&&(d=!0);const h=Math.random();return f.$watch(b.identifier.value,h,k.baseUri,{recursive:d,excludes:[]}),T.Disposable.from({dispose:()=>f.$unwatch(h)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(I,b,k){this._mainContext=I,this._logService=b,this._extHostDocumentsAndEditors=k,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,b,k,w,f,d){return new S(this._mainContext,I,b,this._onFileSystemEvent.event,_.GlobPattern.from(k),w,f,d)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,b){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(k=>({oldUri:u.URI.revive(k.source),newUri:u.URI.revive(k.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(k=>u.URI.revive(k.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:b.map(k=>u.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,b){return(k,w,f)=>{const d=function(g){k.call(w,g)};return d.extension=I,b.event(d,void 0,f)}}async $onWillRunFileOperation(I,b,k,w){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(f=>({oldUri:u.URI.revive(f.source),newUri:u.URI.revive(f.target)}))},k,w);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(f=>u.URI.revive(f.target))},k,w);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(f=>u.URI.revive(f.target))},k,w)}}async _fireWillEvent(I,b,k,w){const f=new Set,d=[];if(await I.fireAsync(b,w,async(g,v)=>{const C=Date.now(),p=await Promise.resolve(g);p instanceof T.WorkspaceEdit&&(d.push([v.extension,p]),f.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-C>k&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),w.isCancellationRequested||d.length===0)return;const h={edits:[]};for(const[,g]of d){const{edits:v}=_.WorkspaceEdit.from(g,{getTextDocumentVersion:C=>this._extHostDocumentsAndEditors.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(v)}return{edit:h,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=D}),define(_e[262],ye([1,0,2,40]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class u{constructor(_,T,S,D,R){this._extHostNotebooks=T,this._textDocumentsAndEditors=S,this._commands=D;const I=new P.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new P.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new P.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new P.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new P.ApiCommandResult("Notebook and input URI",b=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",b.notebookEditorId),b.notebookEditorId!==void 0){const k=this._extHostNotebooks.getEditorById(b.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:a.URI.revive(b.notebookUri),inputUri:a.URI.revive(b.inputUri),notebookEditor:k.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",b.notebookUri,b.inputUri),{notebookUri:a.URI.revive(b.notebookUri),inputUri:a.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(_,T,S,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=u}),define(_e[263],ye([1,0,6,5]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class u{constructor(_){this._handlePool=0,this._proxy=_.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,_),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=u}),define(_e[264],ye([1,0,2,23,15,7,72,5,8,32,16,9,150,21,6,120,101,75,43,11,19,27]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentSymbols(O,W){const G=this._documents.getDocument(O),Q=await this._provider.provideDocumentSymbols(G,W);if(!(0,R.isFalsyOrEmpty)(Q))return Q[0]instanceof A.DocumentSymbol?Q.map(u.DocumentSymbol.from):i._asDocumentSymbolTree(Q)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((Q,he)=>{let Ee=Q.location.range.start.compareTo(he.location.range.start);return Ee===0&&(Ee=he.location.range.end.compareTo(Q.location.range.end)),Ee});const W=[],G=[];for(const Q of O){const he={name:Q.name||"!!MISSING: name!!",kind:u.SymbolKind.from(Q.kind),tags:Q.tags?.map(u.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:u.Range.from(Q.location.range),selectionRange:u.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(he),W.push(he);break}const Ee=G[G.length-1];if(D.Range.containsRange(Ee.range,he.range)&&!D.Range.equalsRange(Ee.range,he.range)){Ee.children?.push(he),G.push(he);break}G.pop()}}return W}}class o{constructor(O,W,G){this._documents=O,this._commands=W,this._provider=G,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,W){const G=this._documents.getDocument(O),Q=await this._provider.provideCodeLenses(G,W);if(!Q||W.isCancellationRequested)return;const he=this._cache.add(Q),Ee=new w.DisposableStore;this._disposables.set(he,Ee);const Pe={cacheId:he,lenses:[]};for(let ve=0;ve<Q.length;ve++)Pe.lenses.push({cacheId:[he,ve],range:u.Range.from(Q[ve].range),command:this._commands.toInternal(Q[ve].command,Ee)});return Pe}async resolveCodeLens(O,W){const G=O.cacheId&&this._cache.get(...O.cacheId);if(!G)return;let Q;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this._provider.resolveCodeLens(G,W),Q||(Q=G),W.isCancellationRequested)return;const he=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!he)return O.command=this._commands.toInternal(Q.command??o._badCmd,he),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(re){return Array.isArray(re)?re.map(u.DefinitionLink.from):re?[u.DefinitionLink.from(re)]:[]}class l{constructor(O,W){this._documents=O,this._provider=W}async provideDefinition(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.provideDefinition(Q,he,G);return s(Ee)}}class r{constructor(O,W){this._documents=O,this._provider=W}async provideDeclaration(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.provideDeclaration(Q,he,G);return s(Ee)}}class m{constructor(O,W){this._documents=O,this._provider=W}async provideImplementation(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.provideImplementation(Q,he,G);return s(Ee)}}class n{constructor(O,W){this._documents=O,this._provider=W}async provideTypeDefinition(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.provideTypeDefinition(Q,he,G);return s(Ee)}}class t{constructor(O,W){this._documents=O,this._provider=W}async provideHover(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.provideHover(Q,he,G);if(!(!Ee||(0,R.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=Q.getWordRangeAtPosition(he)),Ee.range||(Ee.range=new A.Range(he,he)),u.Hover.from(Ee)}}class c{constructor(O,W){this._documents=O,this._provider=W}async provideEvaluatableExpression(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.provideEvaluatableExpression(Q,he,G);if(Ee)return u.EvaluatableExpression.from(Ee)}}class E{constructor(O,W){this._documents=O,this._provider=W}async provideInlineValues(O,W,G,Q){const he=this._documents.getDocument(O),Ee=await this._provider.provideInlineValues(he,u.Range.to(W),u.InlineValueContext.to(G),Q);if(Array.isArray(Ee))return Ee.map(Pe=>u.InlineValue.from(Pe))}}class y{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentHighlights(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.provideDocumentHighlights(Q,he,G);if(Array.isArray(Ee))return Ee.map(u.DocumentHighlight.from)}}class M{constructor(O,W){this._documents=O,this._provider=W}async provideLinkedEditingRanges(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.provideLinkedEditingRanges(Q,he,G);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,R.coalesce)(Ee.ranges.map(u.Range.from)),wordPattern:Ee.wordPattern}}}class j{constructor(O,W){this._documents=O,this._provider=W}async provideReferences(O,W,G,Q){const he=this._documents.getDocument(O),Ee=u.Position.to(W),Pe=await this._provider.provideReferences(he,Ee,G,Q);if(Array.isArray(Pe))return Pe.map(u.location.from)}}class ${constructor(O,W,G,Q,he,Ee,Pe){this._documents=O,this._commands=W,this._diagnostics=G,this._provider=Q,this._logService=he,this._extension=Ee,this._apiDeprecation=Pe,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,W,G,Q){const he=this._documents.getDocument(O),Ee=b.Selection.isISelection(W)?u.Selection.to(W):u.Range.to(W),Pe=[];for(const et of this._diagnostics.getDiagnostics(O))if(Ee.intersection(et.range)&&Pe.push(et)>$._maxCodeActionsPerFile)break;const ve={diagnostics:Pe,only:G.only?new A.CodeActionKind(G.only):void 0,triggerKind:u.CodeActionTriggerKind.to(G.trigger)},Ce=await this._provider.provideCodeActions(he,Ee,ve,Q);if(!(0,R.isNonEmptyArray)(Ce)||Q.isCancellationRequested)return;const ke=this._cache.add(Ce),$e=new w.DisposableStore;this._disposables.set(ke,$e);const je=[];for(let et=0;et<Ce.length;et++){const Xe=Ce[et];!Xe||($._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,$e)})):(ve.only&&(Xe.kind?ve.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[ke,et],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,$e),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(u.Diagnostic.from),edit:Xe.edit&&u.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:ke,actions:je}}async resolveCodeAction(O,W){const[G,Q]=O,he=this._cache.get(G,Q);if(!he||$._isCommand(he)||!this._provider.resolveCodeAction)return;const Ee=await this._provider.resolveCodeAction(he,W)??he;return Ee?.edit?u.WorkspaceEdit.from(Ee.edit,void 0):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}$._maxCodeActionsPerFile=1e3;class N{constructor(O,W,G,Q){this._proxy=O,this._documents=W,this._provider=G,this._handle=Q}async prepareDocumentPaste(O,W,G,Q){if(!this._provider.prepareDocumentPaste)return;const he=this._documents.getDocument(O),Ee=W.map(ve=>u.Range.to(ve)),Pe=u.DataTransfer.toDataTransfer(G,()=>{throw new v.NotImplementedError});return await this._provider.prepareDocumentPaste(he,Ee,Pe,Q),u.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(O,W,G,Q,he){const Ee=this._documents.getDocument(W),Pe=G.map(ke=>u.Range.to(ke)),ve=u.DataTransfer.toDataTransfer(Q,async ke=>(await this._proxy.$resolvePasteFileData(this._handle,O,ke)).buffer),Ce=await this._provider.provideDocumentPasteEdits(Ee,Pe,ve,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?u.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class x{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentFormattingEdits(O,W,G){const Q=this._documents.getDocument(O),he=await this._provider.provideDocumentFormattingEdits(Q,W,G);if(Array.isArray(he))return he.map(u.TextEdit.from)}}class L{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentRangeFormattingEdits(O,W,G,Q){const he=this._documents.getDocument(O),Ee=u.Range.to(W),Pe=await this._provider.provideDocumentRangeFormattingEdits(he,Ee,G,Q);if(Array.isArray(Pe))return Pe.map(u.TextEdit.from)}}class F{constructor(O,W){this._documents=O,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,W,G,Q,he){const Ee=this._documents.getDocument(O),Pe=u.Position.to(W),ve=await this._provider.provideOnTypeFormattingEdits(Ee,Pe,G,Q,he);if(Array.isArray(ve))return ve.map(u.TextEdit.from)}}class U{constructor(O,W){this._provider=O,this._logService=W,this._cache=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,W){const G=await this._provider.provideWorkspaceSymbols(O,W);if(!(0,R.isNonEmptyArray)(G))return{symbols:[]};const Q=this._cache.add(G),he={cacheId:Q,symbols:[]};for(let Ee=0;Ee<G.length;Ee++){const Pe=G[Ee];if(!Pe||!Pe.name){this._logService.warn("INVALID SymbolInformation",Pe);continue}he.symbols.push({...u.WorkspaceSymbol.from(Pe),cacheId:[Q,Ee]})}return he}async resolveWorkspaceSymbol(O,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const G=this._cache.get(...O.cacheId);if(G){const Q=await this._provider.resolveWorkspaceSymbol(G,W);return Q&&(0,P.mixin)(O,u.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class H{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,W,G){this._documents=O,this._provider=W,this._logService=G}async provideRenameEdits(O,W,G,Q){const he=this._documents.getDocument(O),Ee=u.Position.to(W);try{const Pe=await this._provider.provideRenameEdits(he,Ee,G,Q);return Pe?u.WorkspaceEdit.from(Pe):void 0}catch(Pe){const ve=H._asMessage(Pe);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(O,W,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Q=this._documents.getDocument(O),he=u.Position.to(W);try{const Ee=await this._provider.prepareRename(Q,he,G);let Pe,ve;if(A.Range.isRange(Ee)?(Pe=Ee,ve=Q.getText(Ee)):(0,I.isObject)(Ee)&&(Pe=Ee.range,ve=Ee.placeholder),!Pe||!ve)return;if(Pe.start.line>he.line||Pe.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:u.Range.from(Pe),text:ve}}catch(Ee){const Pe=H._asMessage(Ee);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(Ee)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class de{constructor(O,W){this.resultId=O,this.tokens=W}}class Y{constructor(O,W){this._documents=O,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,W,G){const Q=this._documents.getDocument(O),he=W!==0?this._previousResults.get(W):null;let Ee=typeof he?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Q,he.resultId,G):await this._provider.provideDocumentSemanticTokens(Q,G);return he&&this._previousResults.delete(W),Ee?(Ee=Y._fixProvidedSemanticTokens(Ee),this._send(Y._convertToEdits(he,Ee),Ee)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return Y._isSemanticTokens(O)?Y._isCorrectSemanticTokens(O)?O:new A.SemanticTokens(new Uint32Array(O.data),O.resultId):Y._isSemanticTokensEdits(O)?Y._isCorrectSemanticTokensEdits(O)?O:new A.SemanticTokensEdits(O.edits.map(W=>new A.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const W of O.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,W){if(!Y._isSemanticTokens(W)||!O||!O.tokens)return W;const G=O.tokens,Q=G.length,he=W.data,Ee=he.length;let Pe=0;const ve=Math.min(Q,Ee);for(;Pe<ve&&G[Pe]===he[Pe];)Pe++;if(Pe===Q&&Pe===Ee)return new A.SemanticTokensEdits([],W.resultId);let Ce=0;const ke=ve-Pe;for(;Ce<ke&&G[Q-Ce-1]===he[Ee-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Pe,deleteCount:Q-Pe-Ce,data:he.subarray(Pe,Ee-Ce)}],W.resultId)}_send(O,W){if(Y._isSemanticTokens(O)){const G=this._nextResultId++;return this._previousResults.set(G,new de(O.resultId,O.data)),(0,f.encodeSemanticTokensDto)({id:G,type:"full",data:O.data})}if(Y._isSemanticTokensEdits(O)){const G=this._nextResultId++;return Y._isSemanticTokens(W)?this._previousResults.set(G,new de(W.resultId,W.data)):this._previousResults.set(G,new de(O.resultId)),(0,f.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(O.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class V{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentRangeSemanticTokens(O,W,G){const Q=this._documents.getDocument(O),he=await this._provider.provideDocumentRangeSemanticTokens(Q,u.Range.to(W),G);return he?this._send(he):null}_send(O){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class X{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,W,G,Q,he){this._documents=O,this._commands=W,this._provider=G,this._apiDeprecation=Q,this._extension=he,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,W,G,Q){const he=this._documents.getDocument(O),Ee=u.Position.to(W),Pe=he.getWordRangeAtPosition(Ee)||new A.Range(Ee,Ee),ve=Pe.with({end:Ee}),Ce=new g.StopWatch(!0),ke=await this._provider.provideCompletionItems(he,Ee,Q,u.CompletionContext.to(G));if(!ke||Q.isCancellationRequested)return;const $e=Array.isArray(ke)?new A.CompletionList(ke):ke,je=X.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),et=new w.DisposableStore;this._disposables.set(je,et);const Xe=[],nt={x:je,b:Xe,a:{replace:u.Range.from(Pe),insert:u.Range.from(ve)},c:$e.isIncomplete||void 0,d:Ce.elapsed()};for(let st=0;st<$e.items.length;st++){const ht=$e.items[st],Fe=this._convertCompletionItem(ht,[je,st],ve,Pe);Xe.push(Fe)}return nt}async resolveCompletionItem(O,W){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...O);if(!G)return;const Q=await this._provider.resolveCompletionItem(G,W);if(!!Q)return this._convertCompletionItem(Q,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,W,G,Q){const he=this._disposables.get(W[0]);if(!he)throw Error("DisposableStore is missing...");const Ee=this._commands.toInternal(O.command,he),Pe={x:W,a:O.label,b:O.kind!==void 0?u.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(u.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:u.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(u.TextEdit.from),n:Ee?.$ident,o:Ee?.id,p:Ee?.$ident?void 0:Ee?.arguments};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=O.textEdit.newText):typeof O.insertText=="string"?Pe.h=O.insertText:O.insertText instanceof A.SnippetString&&(Pe.h=O.insertText.value,Pe.i|=4);let ve;return O.textEdit?ve=O.textEdit.range:O.range&&(ve=O.range),A.Range.isRange(ve)?Pe.j=u.Range.from(ve):ve&&(!G?.isEqual(ve.inserting)||!Q?.isEqual(ve.replacing))&&(Pe.j={insert:u.Range.from(ve.inserting),replace:u.Range.from(ve.replacing)}),Pe}}class Z{async provideInlineCompletions(O,W,G,Q){}disposeCompletions(O){}handleDidShowCompletionItem(O,W){}handlePartialAccept(O,W,G){}}class te extends Z{constructor(O,W,G,Q){super(),this._extension=O,this._documents=W,this._provider=G,this._commands=Q,this._references=new K,this._isAdditionsProposedApiEnabled=(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,W,G,Q){const he=this._documents.getDocument(O),Ee=u.Position.to(W),Pe=await this._provider.provideInlineCompletionItems(he,Ee,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:u.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},Q);if(!Pe||Q.isCancellationRequested)return;const ve=Array.isArray(Pe)?Pe:Pe.items,Ce=this._isAdditionsProposedApiEnabled?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this._references.createReferenceId({dispose(){ke?.dispose()},items:ve}),items:ve.map((je,et)=>{let Xe;je.command&&(ke||(ke=new w.DisposableStore),Xe=this._commands.toInternal(je.command,ke));const nt=je.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:je.filterText,range:je.range?u.Range.from(je.range):void 0,command:Xe,idx:et,completeBracketPairs:this._isAdditionsProposedApiEnabled?je.completeBracketPairs:!1}}),commands:Ce.map(je=>(ke||(ke=new w.DisposableStore),this._commands.toInternal(je,ke)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,W){const G=this._references.get(O)?.items[W];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}handlePartialAccept(O,W,G){const Q=this._references.get(O)?.items[W];Q&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(Q,G)}}class K{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const W=this._idPool++;return this._references.set(W,O),W}disposeReferenceId(O){const W=this._references.get(O);return this._references.delete(O),W}get(O){return this._references.get(O)}}class J{constructor(O,W){this._documents=O,this._provider=W,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(O,W,G,Q){const he=this._documents.getDocument(O),Ee=u.Position.to(W),Pe=this.reviveContext(G),ve=await this._provider.provideSignatureHelp(he,Ee,Q,Pe);if(ve){const Ce=this._cache.add([ve]);return{...u.SignatureHelp.from(ve),id:Ce}}}reviveContext(O){let W;if(O.activeSignatureHelp){const G=u.SignatureHelp.to(O.activeSignatureHelp),Q=this._cache.get(O.activeSignatureHelp.id,0);Q?(W=Q,W.activeSignature=G.activeSignature,W.activeParameter=G.activeParameter):W=G}return{...O,activeSignatureHelp:W}}releaseSignatureHelp(O){this._cache.delete(O)}}class ne{constructor(O,W,G,Q,he){this._documents=O,this._commands=W,this._provider=G,this._logService=Q,this._extension=he,this._cache=new h.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,W,G){const Q=this._documents.getDocument(O),he=u.Range.to(W),Ee=await this._provider.provideInlayHints(Q,he,G);if(!Array.isArray(Ee)||Ee.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(G.isCancellationRequested)return;const Pe=this._cache.add(Ee);this._disposables.set(Pe,new w.DisposableStore);const ve={hints:[],cacheId:Pe};for(let Ce=0;Ce<Ee.length;Ce++)this._isValidInlayHint(Ee[Ce],he)&&ve.hints.push(this._convertInlayHint(Ee[Ce],[Pe,Ce]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),ve}async resolveInlayHint(O,W){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...O);if(!G)return;const Q=await this._provider.resolveInlayHint(G,W);if(!!Q&&!!this._isValidInlayHint(Q))return this._convertInlayHint(Q,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,W){return O.label.length===0||Array.isArray(O.label)&&O.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(W&&!W.contains(O.position))}_convertInlayHint(O,W){const G=this._disposables.get(W[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:W,tooltip:u.MarkdownString.fromStrict(O.tooltip),position:u.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(u.TextEdit.from),kind:O.kind&&u.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Q.label=O.label:Q.label=O.label.map(he=>{const Ee={label:he.value};return Ee.tooltip=u.MarkdownString.fromStrict(he.tooltip),A.Location.isLocation(he.location)&&(Ee.location=u.location.from(he.location)),he.command&&(Ee.command=this._commands.toInternal(he.command,G)),Ee}),Q}}class pe{constructor(O,W){this._documents=O,this._provider=W,this._cache=new h.Cache("DocumentLink")}async provideLinks(O,W){const G=this._documents.getDocument(O),Q=await this._provider.provideDocumentLinks(G,W);if(!(!Array.isArray(Q)||Q.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Q.filter(pe._validateLink).map(u.DocumentLink.from)};{const he=this._cache.add(Q),Ee={links:[],cacheId:he};for(let Pe=0;Pe<Q.length;Pe++){if(!pe._validateLink(Q[Pe]))continue;const ve=u.DocumentLink.from(Q[Pe]);ve.cacheId=[he,Pe],Ee.links.push(ve)}return Ee}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,W){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...O);if(!G)return;const Q=await this._provider.resolveDocumentLink(G,W);if(!(!Q||!pe._validateLink(Q)))return u.DocumentLink.from(Q)}releaseLinks(O){this._cache.delete(O)}}class be{constructor(O,W){this._documents=O,this._provider=W}async provideColors(O,W){const G=this._documents.getDocument(O),Q=await this._provider.provideDocumentColors(G,W);return Array.isArray(Q)?Q.map(Ee=>({color:u.Color.from(Ee.color),range:u.Range.from(Ee.range)})):[]}async provideColorPresentations(O,W,G){const Q=this._documents.getDocument(O),he=u.Range.to(W.range),Ee=u.Color.to(W.color),Pe=await this._provider.provideColorPresentations(Ee,{document:Q,range:he},G);if(!!Array.isArray(Pe))return Pe.map(u.ColorPresentation.from)}}class Ie{constructor(O,W){this._documents=O,this._provider=W}async provideFoldingRanges(O,W,G){const Q=this._documents.getDocument(O),he=await this._provider.provideFoldingRanges(Q,W,G);if(!!Array.isArray(he))return he.map(u.FoldingRange.from)}}class Le{constructor(O,W,G){this._documents=O,this._provider=W,this._logService=G}async provideSelectionRanges(O,W,G){const Q=this._documents.getDocument(O),he=W.map(u.Position.to),Ee=await this._provider.provideSelectionRanges(Q,he,G);if(!(0,R.isNonEmptyArray)(Ee))return[];if(Ee.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let ve=0;ve<he.length;ve++){const Ce=[];Pe.push(Ce);let ke=he[ve],$e=Ee[ve];for(;;){if(!$e.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(u.SelectionRange.from($e)),!$e.parent)break;ke=$e.range,$e=$e.parent}}return Pe}}class oe{constructor(O,W){this._documents=O,this._provider=W,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.prepareCallHierarchy(Q,he,G);if(!Ee)return;const Pe=this._idPool.nextId();return this._cache.set(Pe,new Map),Array.isArray(Ee)?Ee.map(ve=>this._cacheAndConvertItem(Pe,ve)):[this._cacheAndConvertItem(Pe,Ee)]}async provideCallsTo(O,W,G){const Q=this._itemFromCache(O,W);if(!Q)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(Q,G);if(!!he)return he.map(Ee=>({from:this._cacheAndConvertItem(O,Ee.from),fromRanges:Ee.fromRanges.map(Pe=>u.Range.from(Pe))}))}async provideCallsFrom(O,W,G){const Q=this._itemFromCache(O,W);if(!Q)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(Q,G);if(!!he)return he.map(Ee=>({to:this._cacheAndConvertItem(O,Ee.to),fromRanges:Ee.fromRanges.map(Pe=>u.Range.from(Pe))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,W){const G=this._cache.get(O),Q=u.CallHierarchyItem.from(W,O,G.size.toString(36));return G.set(Q._itemId,W),Q}_itemFromCache(O,W){return this._cache.get(O)?.get(W)}}class ae{constructor(O,W){this._documents=O,this._provider=W,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(O,W,G){const Q=this._documents.getDocument(O),he=u.Position.to(W),Ee=await this._provider.prepareTypeHierarchy(Q,he,G);if(!Ee)return;const Pe=this._idPool.nextId();return this._cache.set(Pe,new Map),Array.isArray(Ee)?Ee.map(ve=>this._cacheAndConvertItem(Pe,ve)):[this._cacheAndConvertItem(Pe,Ee)]}async provideSupertypes(O,W,G){const Q=this._itemFromCache(O,W);if(!Q)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySupertypes(Q,G);if(!!he)return he.map(Ee=>this._cacheAndConvertItem(O,Ee))}async provideSubtypes(O,W,G){const Q=this._itemFromCache(O,W);if(!Q)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySubtypes(Q,G);if(!!he)return he.map(Ee=>this._cacheAndConvertItem(O,Ee))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,W){const G=this._cache.get(O),Q=u.TypeHierarchyItem.from(W,O,G.size.toString(36));return G.set(Q._itemId,W),Q}_itemFromCache(O,W){return this._cache.get(O)?.get(W)}}class fe{constructor(O,W,G,Q){this._proxy=O,this._documents=W,this._provider=G,this._handle=Q}async provideDocumentOnDropEdits(O,W,G,Q,he){const Ee=this._documents.getDocument(W),Pe=u.Position.to(G),ve=u.DataTransfer.toDataTransfer(Q,async ke=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,ke)).buffer),Ce=await this._provider.provideDocumentDropEdits(Ee,Pe,ve,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?u.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ee{constructor(O,W){this.adapter=O,this.extension=W}}class le{constructor(O,W,G,Q,he,Ee,Pe,ve){this._uriTransformer=W,this._documents=G,this._commands=Q,this._diagnostics=he,this._logService=Ee,this._apiDeprecation=Pe,this._extensionTelemetry=ve,this._adapter=new Map,this._proxy=O.getProxy(T.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O){return u.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new A.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return le._handlePool++}async _withAdapter(O,W,G,Q,he,Ee=!1){const Pe=this._adapter.get(O);if(!Pe||!(Pe.adapter instanceof W))return Q;const ve=Date.now();Ee||this._logService.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ce=G(Pe.adapter,Pe.extension);return Promise.resolve(Ce).catch(ke=>{(0,v.isCancellationError)(ke)||(this._logService.error(`[${Pe.extension.identifier.value}] provider FAILED`),this._logService.error(ke),this._extensionTelemetry.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{Ee||this._logService.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-ve}ms`)}),k.CancellationToken.isCancellationToken(he)?(0,C.raceCancellationError)(Ce,he):Ce}_addNewAdapter(O,W){const G=this._nextHandle();return this._adapter.set(G,new ee(O,W)),G}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,W,G,Q){const he=this._addNewAdapter(new i(this._documents,G),O),Ee=Q&&Q.label||le._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector(W),Ee),this._createDisposable(he)}$provideDocumentSymbols(O,W,G){return this._withAdapter(O,i,Q=>Q.provideDocumentSymbols(a.URI.revive(W),G),void 0,G)}registerCodeLensProvider(O,W,G){const Q=this._nextHandle(),he=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Q,new ee(new o(this._documents,this._commands.converter,G),O)),this._proxy.$registerCodeLensSupport(Q,this._transformDocumentSelector(W),he);let Ee=this._createDisposable(Q);if(he!==void 0){const Pe=G.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(he));Ee=A.Disposable.from(Ee,Pe)}return Ee}$provideCodeLenses(O,W,G){return this._withAdapter(O,o,Q=>Q.provideCodeLenses(a.URI.revive(W),G),void 0,G)}$resolveCodeLens(O,W,G){return this._withAdapter(O,o,Q=>Q.resolveCodeLens(W,G),void 0,void 0)}$releaseCodeLenses(O,W){this._withAdapter(O,o,G=>Promise.resolve(G.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(O,W,G){const Q=this._addNewAdapter(new l(this._documents,G),O);return this._proxy.$registerDefinitionSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDefinition(O,W,G,Q){return this._withAdapter(O,l,he=>he.provideDefinition(a.URI.revive(W),G,Q),[],Q)}registerDeclarationProvider(O,W,G){const Q=this._addNewAdapter(new r(this._documents,G),O);return this._proxy.$registerDeclarationSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDeclaration(O,W,G,Q){return this._withAdapter(O,r,he=>he.provideDeclaration(a.URI.revive(W),G,Q),[],Q)}registerImplementationProvider(O,W,G){const Q=this._addNewAdapter(new m(this._documents,G),O);return this._proxy.$registerImplementationSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideImplementation(O,W,G,Q){return this._withAdapter(O,m,he=>he.provideImplementation(a.URI.revive(W),G,Q),[],Q)}registerTypeDefinitionProvider(O,W,G){const Q=this._addNewAdapter(new n(this._documents,G),O);return this._proxy.$registerTypeDefinitionSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideTypeDefinition(O,W,G,Q){return this._withAdapter(O,n,he=>he.provideTypeDefinition(a.URI.revive(W),G,Q),[],Q)}registerHoverProvider(O,W,G,Q){const he=this._addNewAdapter(new t(this._documents,G),O);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector(W)),this._createDisposable(he)}$provideHover(O,W,G,Q){return this._withAdapter(O,t,he=>he.provideHover(a.URI.revive(W),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(O,W,G,Q){const he=this._addNewAdapter(new c(this._documents,G),O);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector(W)),this._createDisposable(he)}$provideEvaluatableExpression(O,W,G,Q){return this._withAdapter(O,c,he=>he.provideEvaluatableExpression(a.URI.revive(W),G,Q),void 0,Q)}registerInlineValuesProvider(O,W,G,Q){const he=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new E(this._documents,G),O);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(W),he);let Pe=this._createDisposable(Ee);if(he!==void 0){const ve=G.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(he));Pe=A.Disposable.from(Pe,ve)}return Pe}$provideInlineValues(O,W,G,Q,he){return this._withAdapter(O,E,Ee=>Ee.provideInlineValues(a.URI.revive(W),G,Q,he),void 0,he)}registerDocumentHighlightProvider(O,W,G){const Q=this._addNewAdapter(new y(this._documents,G),O);return this._proxy.$registerDocumentHighlightProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDocumentHighlights(O,W,G,Q){return this._withAdapter(O,y,he=>he.provideDocumentHighlights(a.URI.revive(W),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(O,W,G){const Q=this._addNewAdapter(new M(this._documents,G),O);return this._proxy.$registerLinkedEditingRangeProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideLinkedEditingRanges(O,W,G,Q){return this._withAdapter(O,M,async he=>{const Ee=await he.provideLinkedEditingRanges(a.URI.revive(W),G,Q);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?le._serializeRegExp(Ee.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(O,W,G){const Q=this._addNewAdapter(new j(this._documents,G),O);return this._proxy.$registerReferenceSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideReferences(O,W,G,Q,he){return this._withAdapter(O,j,Ee=>Ee.provideReferences(a.URI.revive(W),G,Q,he),void 0,he)}registerCodeActionProvider(O,W,G,Q){const he=new w.DisposableStore,Ee=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,G,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(Ee,this._transformDocumentSelector(W),{providedKinds:Q?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:Q?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this._commands.converter.toInternal(Pe.command,he)}))},le._extLabel(O),Boolean(G.resolveCodeAction)),he.add(this._createDisposable(Ee)),he}$provideCodeActions(O,W,G,Q,he){return this._withAdapter(O,$,Ee=>Ee.provideCodeActions(a.URI.revive(W),G,Q,he),void 0,he)}$resolveCodeAction(O,W,G){return this._withAdapter(O,$,Q=>Q.resolveCodeAction(W,G),void 0,void 0)}$releaseCodeActions(O,W){this._withAdapter(O,$,G=>Promise.resolve(G.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(O,W,G){const Q=this._addNewAdapter(new x(this._documents,G),O);return this._proxy.$registerDocumentFormattingSupport(Q,this._transformDocumentSelector(W),O.identifier,O.displayName||O.name),this._createDisposable(Q)}$provideDocumentFormattingEdits(O,W,G,Q){return this._withAdapter(O,x,he=>he.provideDocumentFormattingEdits(a.URI.revive(W),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(O,W,G){const Q=this._addNewAdapter(new L(this._documents,G),O);return this._proxy.$registerRangeFormattingSupport(Q,this._transformDocumentSelector(W),O.identifier,O.displayName||O.name),this._createDisposable(Q)}$provideDocumentRangeFormattingEdits(O,W,G,Q,he){return this._withAdapter(O,L,Ee=>Ee.provideDocumentRangeFormattingEdits(a.URI.revive(W),G,Q,he),void 0,he)}registerOnTypeFormattingEditProvider(O,W,G,Q){const he=this._addNewAdapter(new F(this._documents,G),O);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector(W),Q,O.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits(O,W,G,Q,he,Ee){return this._withAdapter(O,F,Pe=>Pe.provideOnTypeFormattingEdits(a.URI.revive(W),G,Q,he,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(O,W){const G=this._addNewAdapter(new U(W,this._logService),O);return this._proxy.$registerNavigateTypeSupport(G,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(O,W,G){return this._withAdapter(O,U,Q=>Q.provideWorkspaceSymbols(W,G),{symbols:[]},G)}$resolveWorkspaceSymbol(O,W,G){return this._withAdapter(O,U,Q=>Q.resolveWorkspaceSymbol(W,G),void 0,void 0)}$releaseWorkspaceSymbols(O,W){this._withAdapter(O,U,G=>G.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(O,W,G){const Q=this._addNewAdapter(new H(this._documents,G,this._logService),O);return this._proxy.$registerRenameSupport(Q,this._transformDocumentSelector(W),H.supportsResolving(G)),this._createDisposable(Q)}$provideRenameEdits(O,W,G,Q,he){return this._withAdapter(O,H,Ee=>Ee.provideRenameEdits(a.URI.revive(W),G,Q,he),void 0,he)}$resolveRenameLocation(O,W,G,Q){return this._withAdapter(O,H,he=>he.resolveRenameLocation(a.URI.revive(W),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(O,W,G,Q){const he=this._addNewAdapter(new Y(this._documents,G),O),Ee=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector(W),Q,Ee);let Pe=this._createDisposable(he);if(Ee){const ve=G.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Pe=A.Disposable.from(Pe,ve)}return Pe}$provideDocumentSemanticTokens(O,W,G,Q){return this._withAdapter(O,Y,he=>he.provideDocumentSemanticTokens(a.URI.revive(W),G,Q),null,Q)}$releaseDocumentSemanticTokens(O,W){this._withAdapter(O,Y,G=>G.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,W,G,Q){const he=this._addNewAdapter(new V(this._documents,G),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector(W),Q),this._createDisposable(he)}$provideDocumentRangeSemanticTokens(O,W,G,Q){return this._withAdapter(O,V,he=>he.provideDocumentRangeSemanticTokens(a.URI.revive(W),G,Q),null,Q)}registerCompletionItemProvider(O,W,G,Q){const he=this._addNewAdapter(new X(this._documents,this._commands.converter,G,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(he,this._transformDocumentSelector(W),Q,X.supportsResolving(G),`${O.identifier.value}(${Q.join("")})`),this._createDisposable(he)}$provideCompletionItems(O,W,G,Q,he){return this._withAdapter(O,X,Ee=>Ee.provideCompletionItems(a.URI.revive(W),G,Q,he),void 0,he)}$resolveCompletionItem(O,W,G){return this._withAdapter(O,X,Q=>Q.resolveCompletionItem(W,G),void 0,G)}$releaseCompletionItems(O,W){this._withAdapter(O,X,G=>G.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(O,W,G){const Q=new te(O,this._documents,G,this._commands.converter),he=this._addNewAdapter(Q,O);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(W),Q.supportsHandleEvents),this._createDisposable(he)}$provideInlineCompletions(O,W,G,Q,he){return this._withAdapter(O,Z,Ee=>Ee.provideInlineCompletions(a.URI.revive(W),G,Q,he),void 0,he)}$handleInlineCompletionDidShow(O,W,G){this._withAdapter(O,Z,async Q=>{Q.handleDidShowCompletionItem(W,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,W,G,Q){this._withAdapter(O,Z,async he=>{he.handlePartialAccept(W,G,Q)},void 0,void 0)}$freeInlineCompletionsList(O,W){this._withAdapter(O,Z,async G=>{G.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(O,W,G,Q){const he=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,Ee=this._addNewAdapter(new J(this._documents,G),O);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(W),he),this._createDisposable(Ee)}$provideSignatureHelp(O,W,G,Q,he){return this._withAdapter(O,J,Ee=>Ee.provideSignatureHelp(a.URI.revive(W),G,Q,he),void 0,he)}$releaseSignatureHelp(O,W){this._withAdapter(O,J,G=>G.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(O,W,G){const Q=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new ne(this._documents,this._commands.converter,G,this._logService,O),O);this._proxy.$registerInlayHintsProvider(he,this._transformDocumentSelector(W),typeof G.resolveInlayHint=="function",Q,le._extLabel(O));let Ee=this._createDisposable(he);if(Q!==void 0){const Pe=G.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(Q));Ee=A.Disposable.from(Ee,Pe)}return Ee}$provideInlayHints(O,W,G,Q){return this._withAdapter(O,ne,he=>he.provideInlayHints(a.URI.revive(W),G,Q),void 0,Q)}$resolveInlayHint(O,W,G){return this._withAdapter(O,ne,Q=>Q.resolveInlayHint(W,G),void 0,G)}$releaseInlayHints(O,W){this._withAdapter(O,ne,G=>G.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(O,W,G){const Q=this._addNewAdapter(new pe(this._documents,G),O);return this._proxy.$registerDocumentLinkProvider(Q,this._transformDocumentSelector(W),typeof G.resolveDocumentLink=="function"),this._createDisposable(Q)}$provideDocumentLinks(O,W,G){return this._withAdapter(O,pe,Q=>Q.provideLinks(a.URI.revive(W),G),void 0,G,W.scheme==="output")}$resolveDocumentLink(O,W,G){return this._withAdapter(O,pe,Q=>Q.resolveLink(W,G),void 0,void 0,!0)}$releaseDocumentLinks(O,W){this._withAdapter(O,pe,G=>G.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(O,W,G){const Q=this._addNewAdapter(new be(this._documents,G),O);return this._proxy.$registerDocumentColorProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDocumentColors(O,W,G){return this._withAdapter(O,be,Q=>Q.provideColors(a.URI.revive(W),G),[],G)}$provideColorPresentations(O,W,G,Q){return this._withAdapter(O,be,he=>he.provideColorPresentations(a.URI.revive(W),G,Q),void 0,Q)}registerFoldingRangeProvider(O,W,G){const Q=this._nextHandle(),he=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Q,new ee(new Ie(this._documents,G),O)),this._proxy.$registerFoldingRangeProvider(Q,this._transformDocumentSelector(W),O.identifier,he);let Ee=this._createDisposable(Q);if(he!==void 0){const Pe=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));Ee=A.Disposable.from(Ee,Pe)}return Ee}$provideFoldingRanges(O,W,G,Q){return this._withAdapter(O,Ie,he=>he.provideFoldingRanges(a.URI.revive(W),G,Q),void 0,Q)}registerSelectionRangeProvider(O,W,G){const Q=this._addNewAdapter(new Le(this._documents,G,this._logService),O);return this._proxy.$registerSelectionRangeProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideSelectionRanges(O,W,G,Q){return this._withAdapter(O,Le,he=>he.provideSelectionRanges(a.URI.revive(W),G,Q),[],Q)}registerCallHierarchyProvider(O,W,G){const Q=this._addNewAdapter(new oe(this._documents,G),O);return this._proxy.$registerCallHierarchyProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$prepareCallHierarchy(O,W,G,Q){return this._withAdapter(O,oe,he=>Promise.resolve(he.prepareSession(a.URI.revive(W),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(O,W,G,Q){return this._withAdapter(O,oe,he=>he.provideCallsTo(W,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(O,W,G,Q){return this._withAdapter(O,oe,he=>he.provideCallsFrom(W,G,Q),void 0,Q)}$releaseCallHierarchy(O,W){this._withAdapter(O,oe,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(O,W,G){const Q=this._addNewAdapter(new ae(this._documents,G),O);return this._proxy.$registerTypeHierarchyProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$prepareTypeHierarchy(O,W,G,Q){return this._withAdapter(O,ae,he=>Promise.resolve(he.prepareSession(a.URI.revive(W),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(O,W,G,Q){return this._withAdapter(O,ae,he=>he.provideSupertypes(W,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(O,W,G,Q){return this._withAdapter(O,ae,he=>he.provideSubtypes(W,G,Q),void 0,Q)}$releaseTypeHierarchy(O,W){this._withAdapter(O,ae,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(O,W,G){const Q=this._nextHandle();return this._adapter.set(Q,new ee(new fe(this._proxy,this._documents,G,Q),O)),this._proxy.$registerDocumentOnDropEditProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDocumentOnDropEdits(O,W,G,Q,he,Ee){return this._withAdapter(O,fe,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits(W,a.URI.revive(G),Q,he,Ee)),void 0,void 0)}registerDocumentPasteEditProvider(O,W,G,Q){const he=this._nextHandle();return this._adapter.set(he,new ee(new N(this._proxy,this._documents,G,he),O)),this._proxy.$registerPasteEditProvider(he,this._transformDocumentSelector(W),!!G.prepareDocumentPaste,Q.pasteMimeTypes),this._createDisposable(he)}$prepareDocumentPaste(O,W,G,Q,he){return this._withAdapter(O,N,Ee=>Ee.prepareDocumentPaste(a.URI.revive(W),G,Q,he),void 0,he)}$providePasteEdits(O,W,G,Q,he,Ee){return this._withAdapter(O,N,Pe=>Pe.providePasteEdits(W,a.URI.revive(G),Q,he,Ee),void 0,Ee)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:le._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:le._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?le._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?le._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:le._serializeRegExp(O.beforeText),afterText:O.afterText?le._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?le._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(le._serializeOnEnterRule)}setLanguageConfiguration(O,W,G){const{wordPattern:Q}=G;if(Q&&(0,S.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this._documents.setWordDefinitionFor(W,Q):this._documents.setWordDefinitionFor(W,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const he=this._nextHandle(),Ee={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?le._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?le._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?le._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(he,W,Ee),this._createDisposable(he)}$setWordDefinitions(O){for(const W of O)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}le._handlePool=0,e.ExtHostLanguageFeatures=le}),define(_e[265],ye([1,0,5,15,7,37,19,6]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,I,b,k){this._documents=I,this._commands=b,this._uriTransformer=k,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,I){await this._proxy.$changeLanguage(R,I);const b=this._documents.getDocumentData(R);if(!b)throw new Error(`document '${R.toString()}' NOT found`);return b.document}async tokenAtPosition(R,I){const b=R.version,k=P.Position.from(I),w=await this._proxy.$tokensAtPosition(R.uri,k),f={type:u.StandardTokenType.Other,range:R.getWordRangeAtPosition(I)??new u.Range(I.line,I.character,I.line,I.character)};if(!w)return f;const d={range:P.Range.to(w.range),type:P.TokenType.to(w.type)};return!d.range.contains(I)||b!==R.version?f:d}createLanguageStatusItem(R,I,b){const k=this._handlePool++,w=this._proxy,f=this._ids,d=`${R.identifier.value}/${I}`;if(f.has(d))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);f.add(d);const h={selector:b,id:I,name:R.displayName??R.name,severity:u.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const v=new T.DisposableStore,C=()=>{g?.dispose(),g=(0,_.disposableTimeout)(()=>{v.clear(),this._proxy.$setLanguageStatus(k,{id:d,name:h.name??R.displayName??R.name,source:R.displayName??R.name,selector:P.DocumentSelector.from(h.selector,this._uriTransformer),label:h.text,detail:h.detail??"",severity:h.severity===u.LanguageStatusSeverity.Error?A.default.Error:h.severity===u.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:h.command&&this._commands.toInternal(h.command,v),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},p={dispose(){v.dispose(),g?.dispose(),w.$removeLanguageStatus(k),f.delete(d)},get id(){return h.id},get name(){return h.name},set name(i){h.name=i,C()},get selector(){return h.selector},set selector(i){h.selector=i,C()},get text(){return h.text},set text(i){h.text=i,C()},get detail(){return h.detail},set detail(i){h.detail=i,C()},get severity(){return h.severity},set severity(i){h.severity=i,C()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(i){h.accessibilityInformation=i,C()},get command(){return h.command},set command(i){h.command=i,C()},get busy(){return h.busy},set busy(i){h.busy=i,C()}};return C(),p}}e.ExtHostLanguages=S}),define(_e[97],ye([1,0,12,8,2,4,13,5,25,20]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(b,k,w){this.logService=w,this.bundleCache=new Map,this._proxy=k.getProxy(T.MainContext.MainThreadLocalization),this.currentLanguage=b.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===a.LANGUAGE_DEFAULT}getMessage(b,k){const{message:w,args:f,comment:d}=k;if(this.isDefaultLanguage)return(0,P.format2)(w,f??{});let h=w;d&&d.length>0&&(h+=`/${Array.isArray(d)?d.join(""):d}`);const g=this.bundleCache.get(b)?.contents[h];return g||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,P.format2)(g??w,f??{})}getBundle(b){return this.bundleCache.get(b)?.contents}getBundleUri(b){return this.bundleCache.get(b)?.uri}async initializeLocalizedMessages(b){if(this.isDefaultLanguage||!b.l10n&&!b.isBuiltin||this.bundleCache.has(b.identifier.value))return;let k;const w=await this.getBundleLocation(b);if(!w){this.logService.error(`No bundle location found for extension ${b.identifier.value}`);return}try{const f=await this._proxy.$fetchBundleContents(w),d=JSON.parse(f);k=b.isBuiltin?d.contents?.bundle:d}catch(f){this.logService.error(`Failed to load translations for ${b.identifier.value} from ${w}: ${f.message}`);return}k&&this.bundleCache.set(b.identifier.value,{contents:k,uri:w})}async getBundleLocation(b){if(b.isBuiltin){const k=await this._proxy.$fetchBuiltInBundleUri(b.identifier.value);return u.URI.revive(k)}return b.l10n?u.URI.joinPath(b.extensionLocation,b.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};R=Ve([We(0,S.IExtHostInitDataService),We(1,D.IExtHostRpcService),We(2,_.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(_e[140],ye([1,0,13,5,25,20,2,69]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends a.AbstractLoggerService{constructor(I,b){super(b.logLevel,b.loggers.map(k=>(0,T.revive)(k))),this._proxy=I.getProxy(P.MainContext.MainThreadLogger)}$setLogLevel(I,b){b?this.setLogLevel(_.URI.revive(b),I):this.setLogLevel(I)}setVisibility(I,b){super.setVisibility(I,b),this._proxy.$setVisibility(I,b)}doCreateLogger(I,b,k){return new D(this._proxy,I,b,k)}};S=Ve([We(0,A.IExtHostRpcService),We(1,u.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class D extends a.AbstractMessageLogger{constructor(I,b,k,w){super(w?.logLevel==="always"),this.proxy=I,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(k),this.proxy.$createLogger(b,w).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,b){const k=[[I,b]];this.isLoggerCreated?this.doLog(k):this.buffer.push(...k)}doLog(I){this.proxy.$log(this.file,I)}}}),define(_e[266],ye([1,0,5,13,27]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(T){return T&&T.title}let _=class{constructor(S,D){this._logService=D,this._proxy=S.getProxy(a.MainContext.MainThreadMessageService)}showMessage(S,D,R,I,b){const k={source:{identifier:S.identifier,label:S.displayName||S.name}};let w;typeof I=="string"||A(I)?w=[I,...b]:(k.modal=I?.modal,k.useCustom=I?.useCustom,k.detail=I?.detail,w=b),k.useCustom&&(0,u.checkProposedApiEnabled)(S,"resolvers");const f=[];for(let d=0;d<w.length;d++){const h=w[d];if(typeof h=="string")f.push({title:h,handle:d,isCloseAffordance:!1});else if(typeof h=="object"){const{title:g,isCloseAffordance:v}=h;f.push({title:g,isCloseAffordance:!!v,handle:d})}else this._logService.warn("Invalid message item:",h)}return this._proxy.$showMessage(D,R,k,f).then(d=>{if(typeof d=="number")return w[d]})}};_=Ve([We(1,P.ILogService)],_),e.ExtHostMessageService=_}),define(_e[267],ye([1,0,22,3,6,28,8,9,2,75,5,40,15,7,58,242,136]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(v=>v.apiEditor)}constructor(v,C,p,i){this._textDocumentsAndEditors=p,this._textDocuments=i,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new P.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=v.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=v.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=v.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=C.converter,C.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const s=o.notebookEditor?.notebookUri,l=o.cell.handle,m=this._documents.get(s)?.getCell(l);if(m)return m.apiCell}if(o&&o.$mid===14){const s=o.uri,l=this._documents.get(s);if(l)return l.apiNotebook}return o}}),h._registerApiCommands(C)}getEditorById(v){const C=this._editors.get(v);if(!C)throw new Error(`unknown text editor: ${v}. known editors: ${[...this._editors.keys()]} `);return C}getIdByEditor(v){for(const[C,p]of this._editors)if(p.apiEditor===v)return C}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(v,C){const p=this._documents.get(v);if(!p&&!C)throw new Error(`NO notebook document for '${v}'`);return p}static _convertNotebookRegistrationData(v,C){if(!C)return;const p=C.filenamePattern.map(i=>b.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(C.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${C.filenamePattern}`);return}return{extension:v.identifier,providerDisplayName:v.displayName||v.name,displayName:C.displayName,filenamePattern:p,exclusive:C.exclusive||!1}}registerNotebookCellStatusBarItemProvider(v,C,p){const i=h._notebookStatusBarItemProviderHandlePool++,o=typeof p.onDidChangeCellStatusBarItems=="function"?h._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,o,C);let s;return o!==void 0&&(s=p.onDidChangeCellStatusBarItems(l=>this._notebookProxy.$emitCellStatusBarEvent(o))),new k.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,o),s?.dispose()})}async createNotebookDocument(v){const C=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:v.viewType,content:v.content&&b.NotebookData.from(v.content)});return S.URI.revive(C)}async openNotebookDocument(v){const C=this._documents.get(v);if(C)return C.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(v),i=this._documents.get(S.URI.revive(p));return(0,T.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(v,C){S.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let p;typeof C=="object"?p={position:b.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selections:C.selections&&C.selections.map(b.NotebookRange.from),pinned:typeof C.preview=="boolean"?!C.preview:void 0}:p={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(v.uri,v.notebookType,p),o=i&&this._editors.get(i)?.apiEditor;if(o)return o;throw i?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(v,C,p,i){const o=this._notebookStatusBarItemProviders.get(v),s=S.URI.revive(C),l=this._documents.get(s);if(!l||!o)return;const r=l.getCellFromIndex(p);if(!r)return;const m=await o.provideCellStatusBarItems(r.apiCell,i);if(!m)return;const n=new u.DisposableStore,t=this._statusBarCache.add([n]),E=(Array.isArray(m)?m:[m]).map(y=>b.NotebookStatusBarItem.from(y,this._commandsConverter,n));return{cacheId:t,items:E}}$releaseNotebookCellStatusBarItems(v){this._statusBarCache.delete(v)}registerNotebookSerializer(v,C,p,i,o){if((0,_.isFalsyOrWhitespace)(C))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,p),this._notebookProxy.$registerNotebookSerializer(s,{id:v.identifier,location:v.extensionLocation},C,b.NotebookDocumentContentOptions.from(i),h._convertNotebookRegistrationData(v,o)),(0,u.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(v,C,p){const i=this._notebookSerializer.get(v);if(!i)throw new Error("NO serializer found");const o=await i.deserializeNotebook(C.buffer,p);return new w.SerializableObjectWithBuffers(b.NotebookData.from(o))}async $notebookToData(v,C,p){const i=this._notebookSerializer.get(v);if(!i)throw new Error("NO serializer found");const o=await i.serializeNotebook(b.NotebookData.to(C.value),p);return a.VSBuffer.wrap(o)}_createExtHostEditor(v,C,p){if(this._editors.has(C))throw new Error(`editor with id ALREADY EXSIST: ${C}`);const i=new d.ExtHostNotebookEditor(C,this._notebookEditorsProxy,v,p.visibleRanges.map(b.NotebookRange.to),p.selections.map(b.NotebookRange.to),typeof p.viewColumn=="number"?b.ViewColumn.to(p.viewColumn):void 0);this._editors.set(C,i)}$acceptDocumentAndEditorsDelta(v){if(v.value.removedDocuments)for(const p of v.value.removedDocuments){const i=S.URI.revive(p),o=this._documents.get(i);o&&(o.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(o.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===i.toString()&&this._editors.delete(s.id)}if(v.value.addedDocuments){const p=[];for(const i of v.value.addedDocuments){const o=S.URI.revive(i.uri);if(this._documents.has(o))throw new Error(`adding EXISTING notebook ${o} `);const s=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,o,i);p.push(...i.cells.map(l=>f.ExtHostCell.asModelAddData(s.apiNotebook,l))),this._documents.get(o)?.dispose(),this._documents.set(o,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(v.value.addedEditors)for(const p of v.value.addedEditors){if(this._editors.has(p.id))return;const i=S.URI.revive(p.documentUri),o=this._documents.get(i);o&&this._createExtHostEditor(o,p.id,p)}const C=[];if(v.value.removedEditors)for(const p of v.value.removedEditors){const i=this._editors.get(p);i&&(this._editors.delete(p),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),C.push(i))}if(v.value.visibleEditors){this._visibleNotebookEditors=v.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const p=new Set;this._visibleNotebookEditors.forEach(i=>p.add(i.id));for(const i of this._editors.values()){const o=p.has(i.id);i._acceptVisibility(o)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}v.value.newActiveEditor===null?this._activeNotebookEditor=void 0:v.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(v.value.newActiveEditor)),v.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(v){const C=I.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new I.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[C,new I.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>a.VSBuffer.wrap(o))],new I.ApiCommandResult("Notebook Data",o=>b.NotebookData.to(o.value))),i=new I.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[C,new I.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new w.SerializableObjectWithBuffers(b.NotebookData.from(o)))],new I.ApiCommandResult("Bytes",o=>o.buffer));v.registerApiCommand(p),v.registerApiCommand(i)}}h._notebookStatusBarItemProviderHandlePool=0,e.ExtHostNotebookController=h}),define(_e[268],ye([1,0,16,19,21,3,6,28,2,26,13,75,5,40,15,7,94,232,27,58]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let C=class{constructor(r,m,n,t,c){this._initData=m,this._extHostNotebook=n,this._commands=t,this._logService=c,this._activeExecutions=new T.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new I.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(b.MainContext.MainThreadNotebookKernels);const E=new k.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.ApiCommandArgument("options","Select kernel options",y=>!0,y=>{if(y&&"notebookEditor"in y&&"id"in y){const M=this._extHostNotebook.getIdByEditor(y.notebookEditor);return{id:y.id,extension:y.extension,notebookEditorId:M}}else if(y&&"notebookEditor"in y){const M=this._extHostNotebook.getIdByEditor(y.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${y.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return y})],k.ApiCommandResult.Void);this._commands.registerApiCommand(E)}createNotebookController(r,m,n,t,c,E){for(const Z of this._kernelData.values())if(Z.controller.id===m&&D.ExtensionIdentifier.equals(r.identifier,Z.extensionId))throw new Error(`notebook controller with id '${m}' ALREADY exist`);const y=this._handlePool++,M=this;this._logService.trace(`NotebookController[${y}], CREATED by ${r.identifier.value}, ${m}`);const j=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${r.identifier}'`);let $=!1;const N=new _.DisposableStore,x=new A.Emitter,L=new A.Emitter,F={id:s(r.identifier,m),notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:t||r.identifier.value,preloads:E?E.map(w.NotebookRendererScript.from):[]};let U=c??j,H;this._proxy.$addKernel(y,F).catch(Z=>{console.log(Z),$=!0});let de=0;const Y=()=>{if($)return;const Z=++de;Promise.resolve().then(()=>{Z===de&&this._proxy.$updateKernel(y,F)})},V=new T.ResourceMap,X={get id(){return m},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return F.label},set label(Z){F.label=Z??r.displayName??r.name,Y()},get detail(){return F.detail??""},set detail(Z){F.detail=Z,Y()},get description(){return F.description??""},set description(Z){F.description=Z,Y()},get kind(){return(0,g.checkProposedApiEnabled)(r,"notebookControllerKind"),F.kind??""},set kind(Z){(0,g.checkProposedApiEnabled)(r,"notebookControllerKind"),F.kind=Z,Y()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(Z){F.supportedLanguages=Z,Y()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){F.supportsExecutionOrder=Z,Y()},get rendererScripts(){return F.preloads?F.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(Z){U=Z??j},get interruptHandler(){return H},set interruptHandler(Z){H=Z,F.supportsInterrupt=Boolean(Z),Y()},createNotebookCellExecution(Z){if($)throw new Error("notebook controller is DISPOSED");if(!V.has(Z.notebook.uri))throw M._logService.trace(`NotebookController[${y}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return M._createNotebookCellExecution(Z,s(r.identifier,this.id))},dispose:()=>{$||(this._logService.trace(`NotebookController[${y}], DISPOSED`),$=!0,this._kernelData.delete(y),N.dispose(),x.dispose(),L.dispose(),this._proxy.$removeKernel(y))},updateNotebookAffinity(Z,te){te===f.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(r,"notebookControllerAffinityHidden"),M._proxy.$updateNotebookPriority(y,Z.uri,te)},onDidReceiveMessage:L.event,postMessage(Z,te){return(0,g.checkProposedApiEnabled)(r,"notebookMessaging"),M._proxy.$postMessage(y,te&&M._extHostNotebook.getIdByEditor(te),Z)},asWebviewUri(Z){return(0,g.checkProposedApiEnabled)(r,"notebookMessaging"),(0,d.asWebviewUri)(Z,M._initData.remote)}};return this._kernelData.set(y,{extensionId:r.identifier,controller:X,onDidReceiveMessage:L,onDidChangeSelection:x,associatedNotebooks:V}),X}getIdByController(r){for(const[m,n]of this._kernelData)if(n.controller===r)return s(n.extensionId,r.id);return null}createNotebookControllerDetectionTask(r,m){const n=this._kernelDetectionTaskHandlePool++,t=this;this._logService.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${r.identifier.value}`),this._proxy.$addKernelDetectionTask(n,m);const c={dispose:()=>{this._kernelDetectionTask.delete(n),t._proxy.$removeKernelDetectionTask(n)}};return this._kernelDetectionTask.set(n,c),c}registerKernelSourceActionProvider(r,m,n){const t=this._kernelSourceActionProviderHandlePool++,c=typeof n.onDidChangeNotebookKernelSourceActions=="function"?t:void 0,E=this;this._kernelSourceActionProviders.set(t,n),this._logService.trace(`NotebookKernelSourceActionProvider[${t}], CREATED by ${r.identifier.value}`),this._proxy.$addKernelSourceActionProvider(t,t,m);let y;return c!==void 0&&(y=n.onDidChangeNotebookKernelSourceActions(M=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(c))),{dispose:()=>{this._kernelSourceActionProviders.delete(t),E._proxy.$removeKernelSourceActionProvider(t,t),y?.dispose()}}}async $provideKernelSourceActions(r,m){const n=this._kernelSourceActionProviders.get(r);if(n){const t=new _.DisposableStore;return this._kernelSourceActionProviderCache.add([t]),(await n.provideNotebookKernelSourceActions(m)??[]).map(E=>w.NotebookKernelSourceAction.from(E,this._commands.converter,t))}return[]}$acceptNotebookAssociation(r,m,n){const t=this._kernelData.get(r);if(t){const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(m));n?t.associatedNotebooks.set(c.uri,!0):t.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,c.uri.toString(),n),t.onDidChangeSelection.fire({selected:n,notebook:c.apiNotebook})}}async $executeCells(r,m,n){const t=this._kernelData.get(r);if(!t)return;const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(m)),E=[];for(const y of n){const M=c.getCell(y);M&&E.push(M.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,c.uri.toString(),E.length),await t.controller.executeHandler.call(t.controller,E,c.apiNotebook,t.controller)}catch(y){this._logService.error(`NotebookController[${r}] execute cells FAILED`,y),console.error(y)}}async $cancelCells(r,m,n){const t=this._kernelData.get(r);if(!t)return;const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(m));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,c.apiNotebook);else for(const E of n){const y=c.getCell(E);y&&this._activeExecutions.get(y.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,m,n){const t=this._kernelData.get(r);if(!t)return;const c=this._extHostNotebook.getEditorById(m);t.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:n}))}$cellExecutionChanged(r,m,n){const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)).getCell(m);if(c){const E=n?w.NotebookCellExecutionState.to(n):f.NotebookCellExecutionState.Idle;E!==void 0&&this._onDidChangeCellExecutionState.fire({cell:c.apiCell,state:E})}}_createNotebookCellExecution(r,m){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const c=new i(m,t,this._proxy);this._activeExecutions.set(t.uri,c);const E=c.onDidChangeState(()=>{c.state===p.Resolved&&(c.dispose(),E.dispose(),this._activeExecutions.delete(t.uri))});return c.asApiObject()}};C=Ve([We(4,R.ILogService)],C),e.ExtHostNotebookKernels=C;var p;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(p||(p={}));class i extends _.Disposable{get state(){return this._state}constructor(r,m,n){super(),this._cell=m,this._proxy=n,this._handle=i.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new u.CancellationTokenSource),this._collector=new o(10,t=>this.update(t)),this._executionOrder=m.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,r,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const m=Array.isArray(r)?r:[r];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(m))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let m=this._cell;if(r&&(m=this._cell.notebook.getCellFromApiCell(r)),!m)throw new Error("INVALID cell");return m.handle}validateAndConvertOutputs(r){return r.map(m=>{const n=f.NotebookCellOutput.ensureUniqueMimeTypes(m.items,!0);return n===m.items?w.NotebookCellOutput.from(m):w.NotebookCellOutput.from({items:n,id:m.id,metadata:m.metadata})})}async updateOutputs(r,m,n){const t=this.cellIndexToHandle(m),c=this.validateAndConvertOutputs((0,a.asArray)(r));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,cellHandle:t,append:n,outputs:c})}async updateOutputItems(r,m,n){return r=f.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(r),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,items:r.map(w.NotebookCellOutputItem.from),outputId:m.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(n){r._executionOrder=n,r.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:r._executionOrder}])},start(n){if(r._state===p.Resolved||r._state===p.Started)throw new Error("Cannot call start again");r._state=p.Started,r._onDidChangeState.fire(),r.update({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,t){if(r._state===p.Resolved)throw new Error("Cannot call resolve twice");r._state=p.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._handle,new v.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:n}))},clearOutput(n){return r.verifyStateForOutput(),r.updateOutputs([],n,!1)},appendOutput(n,t){return r.verifyStateForOutput(),r.updateOutputs(n,t,!0)},replaceOutput(n,t){return r.verifyStateForOutput(),r.updateOutputs(n,t,!1)},appendOutputItems(n,t){return r.verifyStateForOutput(),r.updateOutputItems(n,t,!0)},replaceOutputItems(n,t){return r.verifyStateForOutput(),r.updateOutputItems(n,t,!1)}})}}i.HANDLE=0;class o{constructor(r,m){this.delay=r,this.callback=m,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new P.DeferredPromise,this.startedTimer=Date.now(),(0,P.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const m=this.batch;return this.batch=[],this.callback(m).finally(()=>r.complete())}}function s(l,r){return`${l.value}/${r}`}e.createKernelId=s}),define(_e[269],ye([1,0,3,5,136]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(T,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=T.getProxy(P.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,D){const R=this._extHostNotebook.getEditorById(T);this._rendererMessageEmitters.get(S)?.fire({editor:R.apiEditor,message:D})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(R=>R.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(R,I,b)=>this.getOrCreateEmitterFor(S).event(R,I,b),postMessage:(R,I)=>{u.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const b=I&&u.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(b?.id,S,R)}}}getOrCreateEmitterFor(T){let S=this._rendererMessageEmitters.get(T);return S||(S=new a.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this._rendererMessageEmitters.delete(T)}}),this._rendererMessageEmitters.set(T,S),S)}}e.ExtHostNotebookRenderers=A}),define(_e[270],ye([1,0,6,9,2,27,5]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class T{constructor(D){this.handlers=new Map,this.proxy=D.getProxy(_.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(D,R,I){if((0,A.checkProposedApiEnabled)(D,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,I),this.proxy.$registerProfileContentHandler(R,I.name,I.description,D.identifier.value),(0,a.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(D,R,I,b){const k=this.handlers.get(D);if(!k)throw new Error(`Unknown handler with id: ${D}`);return k.saveProfile(R,I,b)}async $readProfile(D,R,I){const b=this.handlers.get(D);if(!b)throw new Error(`Unknown handler with id: ${D}`);return b.readProfile((0,P.isString)(R)?R:u.URI.revive(R),I)}}e.ExtHostProfileContentHandlers=T}),define(_e[271],ye([1,0,2,5,19,15]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class _{constructor(S,D){this.uriTransformer=D,this.providers=new Map,this.proxy=S.getProxy(P.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,D,R){const I=a.URI.revive(D),b=this.providers.get(S);return b?(0,u.asPromise)(()=>b.provideOriginalResource(I,R)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(S,D,R,I){const b=_.handlePool++;return this.providers.set(b,D),this.proxy.$registerQuickDiffProvider(b,A.DocumentSelector.from(S,this.uriTransformer),R,I),{dispose:()=>this.providers.delete(b)}}}_.handlePool=0,e.ExtHostQuickDiff=_}),define(_e[272],ye([1,0,21,3,6,5,2,7,11,16,37,51]),function(ie,e,a,P,u,A,_,T,S,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(k,w,f){const d=k.getProxy(A.MainContext.MainThreadQuickOpen);class h{constructor(r,m){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=m}showQuickPick(r,m,n=a.CancellationToken.None){this._onDidSelectItem=void 0;const t=Promise.resolve(r),c=++this._instances,E=d.$show(c,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},n),y={},M=E.then(()=>y);return Promise.race([M,t]).then(j=>{if(j!==y)return t.then($=>{const N=[];for(let x=0;x<$.length;x++){const L=$[x];typeof L=="string"?N.push({label:L,handle:x}):L.kind===T.QuickPickItemKind.Separator?N.push({type:"separator",label:L.label}):N.push({label:L.label,description:L.description,detail:L.detail,picked:L.picked,alwaysShow:L.alwaysShow,handle:x})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{m.onDidSelectItem($[x])}),d.$setItems(c,N),E.then(x=>{if(typeof x=="number")return $[x];if(Array.isArray(x))return x.map(L=>$[L])})})}).then(void 0,j=>{if(!(0,S.isCancellationError)(j))return d.$setError(c,j),Promise.reject(j)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,m=a.CancellationToken.None){return this._validateInput=r?.validateInput,d.$input(r,typeof this._validateInput=="function",m).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(r){if(!this._validateInput)return;const m=await this._validateInput(r);if(!m||typeof m=="string")return m;let n;switch(m.severity){case T.InputBoxValidationSeverity.Info:n=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=R.default.Error;break;default:n=m.message?R.default.Error:R.default.Ignore;break}return{content:m.message,severity:n}}async showWorkspaceFolderPick(r,m=a.CancellationToken.None){const n=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!n)return;const t=await this._workspace.getWorkspaceFolders2();if(!!t)return t.find(c=>c.uri.toString()===n.uri.toString())}createQuickPick(r){const m=new o(r,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(r){const m=new s(r,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(r,m){this._sessions.get(r)?._fireDidChangeValue(m)}$onDidAccept(r){this._sessions.get(r)?._fireDidAccept()}$onDidChangeActive(r,m){const n=this._sessions.get(r);n instanceof o&&n._fireDidChangeActive(m)}$onDidChangeSelection(r,m){const n=this._sessions.get(r);n instanceof o&&n._fireDidChangeSelection(m)}$onDidTriggerButton(r,m){this._sessions.get(r)?._fireDidTriggerButton(m)}$onDidTriggerItemButton(r,m,n){const t=this._sessions.get(r);t instanceof o&&t._fireDidTriggerItemButton(m,n)}$onDidHide(r){this._sessions.get(r)?._fireDidHide()}}class g{constructor(r,m){this._extensionId=r,this._onDidDispose=m,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new P.Emitter,this._onDidChangeValueEmitter=new P.Emitter,this._onDidTriggerButtonEmitter=new P.Emitter,this._onDidHideEmitter=new P.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((m,n)=>{const t=m===T.QuickInputButtons.Back?-1:n;this._handlesToButtons.set(t,m)}),this.update({buttons:r.map((m,n)=>({...i(m),tooltip:m.tooltip,handle:m===T.QuickInputButtons.Back?-1:n}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const m=this._handlesToButtons.get(r);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,u.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(r){if(!this._disposed){for(const m of Object.keys(r)){const n=r[m];this._pendingUpdate[m]=n===void 0?null:n}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function v(l){if(l instanceof T.ThemeIcon)return{id:l.id};const r=p(l),m=C(l);return{dark:typeof r=="string"?_.URI.file(r):r,light:typeof m=="string"?_.URI.file(m):m}}function C(l){return typeof l=="object"&&"light"in l?l.light:l}function p(l){return typeof l=="object"&&"dark"in l?l.dark:l}function i(l){const r=v(l.iconPath);let m,n;return"id"in r?n=I.ThemeIcon.asClassName(r):m=r,{iconPath:m,iconClass:n}}class o extends g{constructor(r,m){super(r.identifier,m),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new P.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new P.Emitter,this._onDidTriggerItemButtonEmitter=new P.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((n,t)=>{this._handlesToItems.set(t,n),this._itemsToHandles.set(n,t)});const m=[];for(let n=0;n<r.length;n++){const t=r[n];t.kind===T.QuickPickItemKind.Separator?m.push({type:"separator",label:t.label}):m.push({handle:n,label:t.label,description:t.description,detail:t.detail,picked:t.picked,alwaysShow:t.alwaysShow,buttons:t.buttons?.map((c,E)=>({...i(c),tooltip:c.tooltip,handle:E}))})}this.update({items:m})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(r){const m=(0,D.coalesce)(r.map(n=>this._handlesToItems.get(n)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(r){const m=(0,D.coalesce)(r.map(n=>this._handlesToItems.get(n)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(r,m){const n=this._handlesToItems.get(r);if(!n||!n.buttons||!n.buttons.length)return;const t=n.buttons[m];t&&this._onDidTriggerItemButtonEmitter.fire({button:t,item:n})}}class s extends g{constructor(r,m){super(r.identifier,m),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get valueSelection(){return this._valueSelection}set valueSelection(r){this._valueSelection=r,this.update({valueSelection:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:R.default.Error}):this.update({validationMessage:r.message,severity:r.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new h(w,f)}e.createExtHostQuickOpen=b});var Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a};define(_e[273],ye([1,0,2,3,62,6,19,5,16,108,13,26,51,15,27]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w){"use strict";var f,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(t){if(t)return typeof t.iconPath=="string"?a.URI.file(t.iconPath):a.URI.isUri(t.iconPath)||b.ThemeIcon.isThemeIcon(t.iconPath)?t.iconPath:void 0}function g(t,c){if(!t.iconPath&&!c.iconPath)return 0;if(t.iconPath){if(!c.iconPath)return 1}else return-1;const E=typeof t.iconPath=="string"?t.iconPath:a.URI.isUri(t.iconPath)?t.iconPath.fsPath:t.iconPath.id,y=typeof c.iconPath=="string"?c.iconPath:a.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,D.comparePaths)(E,y)}function v(t,c){let E=0;if(t.strikeThrough!==c.strikeThrough)return t.strikeThrough?1:-1;if(t.faded!==c.faded)return t.faded?1:-1;if(t.tooltip!==c.tooltip)return(t.tooltip||"").localeCompare(c.tooltip||"");if(E=g(t,c),E!==0)return E;if(t.light&&c.light)E=g(t.light,c.light);else{if(t.light)return 1;if(c.light)return-1}if(E!==0)return E;if(t.dark&&c.dark)E=g(t.dark,c.dark);else{if(t.dark)return 1;if(c.dark)return-1}return E}function C(t,c){if(t.command!==c.command)return t.command<c.command?-1:1;if(t.title!==c.title)return t.title<c.title?-1:1;if(t.tooltip!==c.tooltip){if(t.tooltip!==void 0&&c.tooltip!==void 0)return t.tooltip<c.tooltip?-1:1;if(t.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(t.arguments===c.arguments)return 0;if(t.arguments)if(c.arguments){if(t.arguments.length!==c.arguments.length)return t.arguments.length-c.arguments.length}else return 1;else return-1;for(let E=0;E<t.arguments.length;E++){const y=t.arguments[E],M=c.arguments[E];if(y!==M)return y<M?-1:1}return 0}function p(t,c){let E=(0,D.comparePaths)(t.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(E!==0)return E;if(t.command&&c.command)E=C(t.command,c.command);else{if(t.command)return 1;if(c.command)return-1}if(E!==0)return E;if(t.decorations&&c.decorations)E=v(t.decorations,c.decorations);else{if(t.decorations)return 1;if(c.decorations)return-1}return E}function i(t,c){for(let E=0;E<t.length;E++)if(t[E]!==c[E])return!1;return!0}function o(t,c){return t.command===c.command&&t.title===c.title&&t.tooltip===c.tooltip&&(t.arguments&&c.arguments?i(t.arguments,c.arguments):t.arguments===c.arguments)}function s(t,c){return(0,S.equals)(t,c,o)}class l{get value(){return this._value}set value(c){c=c??"",Ue(this,f,"f").$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){Ue(this,f,"f").$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(c){if((0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,Ue(this,f,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get enabled(){return this._enabled}set enabled(c){c=!!c,this._enabled!==c&&(this._enabled=c,Ue(this,f,"f").$setInputBoxEnablement(this._sourceControlHandle,c))}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,Ue(this,f,"f").$setInputBoxVisibility(this._sourceControlHandle,c))}constructor(c,E,y){this._extension=c,this._sourceControlHandle=y,f.set(this,void 0),this._value="",this._onDidChange=new P.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,f,E,"f")}showValidationMessage(c,E){(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,f,"f").$showValidationMessage(this._sourceControlHandle,c,E)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=l,f=new WeakMap;class r{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}constructor(c,E,y,M,j){this._proxy=c,this._commands=E,this._sourceControlHandle=y,this._id=M,this._label=j,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new P.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new P.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,E){const y=this._resourceStatesCommandsMap.get(c);return y?(0,_.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(p),y=(0,S.sortedDiff)(this._resourceSnapshot,c,p).map($=>{const N=$.toInsert.map(x=>{const L=this._resourceHandlePool++;this._resourceStatesMap.set(L,x);const F=x.resourceUri;let U;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const ne=new A.DisposableStore;U=this._commands.converter.toInternal(x.command,ne),this._resourceStatesDisposablesMap.set(L,ne)}else this._resourceStatesCommandsMap.set(L,x.command);const H=h(x.decorations),de=x.decorations&&h(x.decorations.light)||H,Y=x.decorations&&h(x.decorations.dark)||H,V=[de,Y],X=x.decorations&&x.decorations.tooltip||"",Z=x.decorations&&!!x.decorations.strikeThrough,te=x.decorations&&!!x.decorations.faded,K=x.contextValue||"";return{rawResource:[L,F,V,X,Z,te,K,U],handle:L}});return{start:$.start,deleteCount:$.deleteCount,toInsert:N}}),M=y.map(({start:$,deleteCount:N,toInsert:x})=>[$,N,x.map(L=>L.rawResource)]),j=y.reverse();for(const{start:$,deleteCount:N,toInsert:x}of j){const L=x.map(U=>U.handle),F=this._handlesSnapshot.splice($,N,...L);for(const U of F)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=c,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class m{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,Ue(this,d,"f").$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,Ue(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,Ue(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=c;const E=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);Ue(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:E})}get actionButton(){return(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(c){(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=c;const E=c!==void 0?{command:this._commands.converter.toInternal(c.command,this._actionButtonDisposables.value),secondaryCommands:c.secondaryCommands?.map(y=>y.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:c.description,enabled:c.enabled}:void 0;Ue(this,d,"f").$updateSourceControl(this.handle,{actionButton:E??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&s(this._statusBarCommands,c))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=c;const E=(c||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));Ue(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:E})}get selected(){return this._selected}constructor(c,E,y,M,j,$){this._extension=c,this._commands=y,this._id=M,this._label=j,this._rootUri=$,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new P.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=m._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,d,E,"f"),this._inputBox=new l(c,Ue(this,d,"f"),this.handle),Ue(this,d,"f").$registerSourceControl(this.handle,M,j,$)}createResourceGroup(c,E){const y=new r(Ue(this,d,"f"),this._commands,this.handle,c,E),M=P.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,M),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const c=[],E=[];for(const[y,M]of this.createdResourceGroups){M.dispose();const j=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});P.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),j.dispose(),this._groups.delete(y.handle),Ue(this,d,"f").$unregisterGroup(this.handle,y.handle)}),c.push([y.handle,y.id,y.label,y.features]);const $=y._takeResourceStateSnapshot();$.length>0&&E.push([y.handle,$]),this._groups.set(y.handle,y)}Ue(this,d,"f").$registerGroups(this.handle,c,E),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(E=>{const y=E._takeResourceStateSnapshot();y.length!==0&&c.push([E.handle,y])}),c.length>0&&Ue(this,d,"f").$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),Ue(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,m._handlePool=0,Ve([(0,u.debounce)(100)],m.prototype,"eventuallyAddResourceGroups",null),Ve([(0,u.debounce)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let n=class on{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(c,E,y){this._commands=E,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new P.Emitter,this._proxy=c.getProxy(T.MainContext.MainThreadSCM),this._telemetry=c.getProxy(T.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this._sourceControls.get(M.sourceControlHandle);if(!j)return M;const $=j.getResourceGroup(M.groupHandle);return $?$.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this._sourceControls.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this._sourceControls.get(M.handle);return j||M}return M}})}createSourceControl(c,E,y,M){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,E,y,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const j=on._handlePool++,$=new m(c,this._proxy,this._commands,E,y,M);this._sourceControls.set(j,$);const N=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier))||[];return N.push($),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(c.identifier),N),$}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const E=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier)),y=E&&E[E.length-1];return y&&y.inputBox}$provideOriginalResource(c,E,y){const M=a.URI.revive(E);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,M.toString());const j=this._sourceControls.get(c);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>j.quickDiffProvider.provideOriginalResource(M,y)).then($=>$||null)}$onInputBoxValueChange(c,E){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const y=this._sourceControls.get(c);return y&&y.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(c,E,y,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,E,y);const j=this._sourceControls.get(c);if(!j)return Promise.resolve(void 0);const $=j.getResourceGroup(E);return $?$.$executeResourceCommand(y,M):Promise.resolve(void 0)}$validateInput(c,E,y){this.logService.trace("ExtHostSCM#$validateInput",c);const M=this._sourceControls.get(c);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>M.inputBox.validateInput(E,y)).then(j=>{if(!j)return Promise.resolve(void 0);const $=k.MarkdownString.fromStrict(j.message);return $?Promise.resolve([$,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};n._handlePool=0,n=Ve([We(2,R.ILogService)],n),e.ExtHostSCM=n}),define(_e[98],ye([1,0,5,3,4]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(T){this._onDidChangePassword=new P.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,S){return this._proxy.$getPassword(T,S)}store(T,S,D){return this._proxy.$setPassword(T,S,D)}delete(T,S){return this._proxy.$deletePassword(T,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,u.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[274],ye([1,0,7,5,180,6,15,9]),function(ie,e,a,P,u,A,_,T){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(w,f,d,h,g=a.StatusBarAlignment.Left,v){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,Je(this,S,w,"f"),Je(this,D,f,"f"),this._entryId=R.ID_GEN++,this._extension=d,this._id=h,this._alignment=g,this._priority=this.validatePriority(v)}validatePriority(w){if(!!(0,T.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set name(w){this._name=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!R.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){this._command?.fromApi!==w&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof w=="string"?this._command={fromApi:w,internal:Ue(this,D,"f").toInternal({title:"",command:w},this._latestCommandRegistration)}:w?this._command={fromApi:w,internal:Ue(this,D,"f").toInternal(w,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let w;this._extension?this._id?w=`${this._extension.identifier.value}.${this._id}`:w=this._extension.identifier.value:w=this._id;let f;this._name?f=this._name:f=(0,u.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const h=_.MarkdownString.fromStrict(this._tooltip);Ue(this,S,"f").$setEntry(this._entryId,w,f,this._text,h,this._command?.internal,d,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}S=new WeakMap,D=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=R;class I{constructor(w){this._messages=[],this._item=w.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,u.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const f={message:w};return this._messages.unshift(f),this._update(),new a.Disposable(()=>{const d=this._messages.indexOf(f);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class b{constructor(w,f){this._proxy=w.getProxy(P.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new I(this)}createStatusBarEntry(w,f,d,h){return new R(this._proxy,this._commands,w,f,d,h)}setStatusBarMessage(w,f){const d=this._statusMessage.setMessage(w);let h;return typeof f=="number"?h=setTimeout(()=>d.dispose(),f):typeof f<"u"&&f.then(()=>d.dispose(),()=>d.dispose()),new a.Disposable(()=>{d.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=b}),define(_e[99],ye([1,0,5,3,4]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(T,S){this._logService=S,this._onDidChangeStorage=new P.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this._proxy.$registerExtensionStorageKeysToSync(T,S)}async initializeExtensionStorage(T,S,D){const R=await this._proxy.$initializeExtensionStorage(T,S);let I;return R&&(I=this.safeParseValue(T,S,R)),I||D}setValue(T,S,D){return this._proxy.$setValue(T,S,D)}$acceptValue(T,S,D){const R=this.safeParseValue(T,S,D);R&&this._onDidChangeStorage.fire({shared:T,key:S,value:R})}safeParseValue(T,S,D){try{return JSON.parse(D)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${T}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,u.createDecorator)("IExtHostStorage")}),define(_e[79],ye([1,0,4,25,13,78,2]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let T=class{constructor(D,R,I){this._logService=R,this._extHostFileSystem=I,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(b=>this._value=b)}async _getWorkspaceStorageURI(D){return _.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,R=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(D){if(this._value)return _.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return _.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ve([We(0,P.IExtHostInitDataService),We(1,u.ILogService),We(2,A.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(_e[41],ye([1,0,3,5,4,2,20,6,7,182,11,215,21,30,216,51,9,19,15]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,u.createDecorator)("IExtHostTerminalService");class v{constructor(n,t,c,E){this._proxy=n,this._id=t,this._creationOptions=c,this._name=E,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(M,j=!0){y._checkDisposed(),y._proxy.$sendText(y._id,M,j)},show(M){y._checkDisposed(),y._proxy.$show(y._id,M)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(n,t){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,d.withNullAsUndefined)(n.shellPath),shellArgs:(0,d.withNullAsUndefined)(n.shellArgs),cwd:(0,d.withNullAsUndefined)(n.cwd),env:(0,d.withNullAsUndefined)(n.env),icon:(0,d.withNullAsUndefined)(l(n.iconPath)),color:f.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,d.withNullAsUndefined)(n.message),strictEnv:(0,d.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(t?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(t?.useShellEnvironment),location:t?.location||this._serializeParentTerminal(n.location,t?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,t,c,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:c,color:f.ThemeColor.isThemeColor(E)?E.id:void 0,location:this._serializeParentTerminal(n,t),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,t){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&t?{parentTerminal:t}:"viewColumn"in n?{viewColumn:g.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,t){this._exitStatus=Object.freeze({code:n,reason:t})}setDimensions(n,t){return n===this._cols&&t===this._rows||n===0||t===0?!1:(this._cols=n,this._rows=t,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(t=>{t!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=v;class C{get onProcessReady(){return this._onProcessReady.event}constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,t){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${t}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,t){this._pty.setDimensions?.({columns:n,rows:t})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(t=>this._onProcessData.fire(t)),this._pty.onDidClose?.((t=void 0)=>{this._onProcessExit.fire(t===void 0?void 0:t)}),this._pty.onDidOverrideDimensions?.(t=>{t&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:t.columns,rows:t.rows}})}),this._pty.onDidChangeName?.(t=>{this._onDidChangeProperty.fire({type:"title",value:t})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}let p=1,i=class extends T.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(n,t){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new a.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=t.getProxy(P.MainContext.MainThreadTerminalService),this._bufferer=new w.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[c,E]of this._terminalProcesses)E.shutdown(!0)}})}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,t){const c=new v(this._proxy,(0,k.generateUuid)(),n,n.name),E=new C(n.pty);return c.createExtensionTerminal(n.location,this._serializeParentTerminal(n,t).resolvedExtHostIdentifier,l(n.iconPath),r(n.color)).then(y=>{const M=this._setupExtHostProcessListeners(y,E);this._terminalProcessDisposables[y]=M}),this._terminals.push(c),c.value}_serializeParentTerminal(n,t){if(t=t||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const c=n.location.parentTerminal;if(c){const E=this._terminals.find(y=>y.value===c);E&&(t.resolvedExtHostIdentifier=E._id)}}else n.location&&typeof n.location!="object"?t.location=n.location:t.location&&typeof t.location=="object"&&"splitActiveTerminal"in t.location&&(t.location={splitActiveTerminal:!0});return t}attachPtyToTerminal(n,t){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const E=new C(t),y=this._setupExtHostProcessListeners(n,E);this._terminalProcessDisposables[n]=y}async $acceptActiveTerminalChanged(n){const t=this._activeTerminal;if(n===null){this._activeTerminal=void 0,t!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const c=this._getTerminalById(n);c&&(this._activeTerminal=c,t!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,t){const c=this._getTerminalById(n);c&&this._onDidWriteTerminalData.fire({terminal:c.value,data:t})}async $acceptTerminalDimensions(n,t,c){const E=this._getTerminalById(n);E&&E.setDimensions(t,c)&&this._onDidChangeTerminalDimensions.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(n,t,c){this._terminalProcesses.get(n)?.resize(t,c)}async $acceptTerminalTitleChange(n,t){const c=this._getTerminalById(n);c&&(c.name=t)}async $acceptTerminalClosed(n,t,c){const E=this._getTerminalObjectIndexById(this._terminals,n);if(E!==null){const y=this._terminals.splice(E,1)[0];y.setExitStatus(t,c),this._onDidCloseTerminal.fire(y.value)}}$acceptTerminalOpened(n,t,c,E){if(t){const j=this._getTerminalObjectIndexById(this._terminals,t);if(j!==null){this._terminals[j]._id=n,this._onDidOpenTerminal.fire(this.terminals[j]),this._terminals[j].isOpen=!0;return}}const y={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:A.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},M=new v(this._proxy,n,y,c);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(n,t){this._getTerminalById(n)?._setProcessId(t)}async $startExtensionTerminal(n,t){const c=this._getTerminalById(n);if(!c)return{message:(0,D.localize)(0,null,n)};c.isOpen||await new Promise(y=>{const M=this.onDidOpenTerminal(async j=>{j===c.value&&(M.dispose(),y())})});const E=this._terminalProcesses.get(n);E?E.startSendingEvents(t):this._extensionTerminalAwaitingStart[n]={initialDimensions:t}}_setupExtHostProcessListeners(n,t){const c=new T.DisposableStore;c.add(t.onProcessReady(y=>this._proxy.$sendProcessReady(n,y.pid,y.cwd))),c.add(t.onDidChangeProperty(y=>this._proxy.$sendProcessProperty(n,y))),this._bufferer.startBuffering(n,t.onProcessData),c.add(t.onProcessExit(y=>this._onProcessExit(n,y))),this._terminalProcesses.set(n,t);const E=this._extensionTerminalAwaitingStart[n];return E&&t instanceof C&&(t.startSendingEvents(E.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),c}$acceptProcessAckDataEvent(n,t){this._terminalProcesses.get(n)?.acknowledgeDataEvent(t)}$acceptProcessInput(n,t){this._terminalProcesses.get(n)?.input(t)}$acceptTerminalInteraction(n){const t=this._getTerminalById(n);t?.setInteractedWith()&&this._onDidChangeTerminalState.fire(t.value)}$acceptProcessResize(n,t,c){try{this._terminalProcesses.get(n)?.resize(t,c)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(n,t){this._terminalProcesses.get(n)?.shutdown(t)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(t=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:t}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(t=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:t}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,t,c){if(this._profileProviders.has(t))throw new Error(`Terminal profile provider "${t}" already registered`);return this._profileProviders.set(t,c),this._proxy.$registerProfileProvider(t,n.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(t),this._proxy.$unregisterProfileProvider(t)})}registerTerminalQuickFixProvider(n,t,c){if(this._quickFixProviders.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this._quickFixProviders.set(n,c),this._proxy.$registerQuickFixProvider(n,t),new S.Disposable(()=>{this._quickFixProviders.delete(n),this._proxy.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,t){const c=new b.CancellationTokenSource().token;if(c.isCancellationRequested)return;const E=this._quickFixProviders.get(n);if(!E)return;const y=await E.provideTerminalQuickFixes(t,c);if(y!==null)return y}async $createContributedProfileTerminal(n,t){const c=new b.CancellationTokenSource().token;let E=await this._profileProviders.get(n)?.provideTerminalProfile(c);if(!c.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,t);return}this.createTerminalFromOptions(E.options,t)}}async $provideLinks(n,t){const c=this._getTerminalById(n);if(!c)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const y=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,y);const M=[],j={terminal:c.value,line:t},$=[];for(const L of this._linkProviders)$.push(h.Promises.withAsyncBody(async F=>{y.token.onCancellationRequested(()=>F({provider:L,links:[]}));const U=await L.provideTerminalLinks(j,y.token)||[];y.token.isCancellationRequested||F({provider:L,links:U})}));const N=await Promise.all($);if(y.token.isCancellationRequested)return[];const x=new Map;for(const L of N)L&&L.links.length>0&&M.push(...L.links.map(F=>{const U={id:p++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return x.set(U.id,{provider:L.provider,link:F}),U}));return this._terminalLinkCache.set(n,x),M}$activateLink(n,t){const c=this._terminalLinkCache.get(n)?.get(t);!c||c.provider.handleTerminalLink(c.link)}_onProcessExit(n,t){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const c=this._terminalProcessDisposables[n];c&&(c.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,t)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,t){const c=this._getTerminalObjectIndexById(n,t);return c!==null?n[c]:null}_getTerminalObjectIndexById(n,t){let c=null;return n.some((E,y)=>E._id===t?(c=y,!0):!1),c}getEnvironmentVariableCollection(n){let t=this._environmentVariableCollections.get(n.identifier.value);return t||(t=new o,this._setEnvironmentVariableCollection(n.identifier.value,t)),t}_syncEnvironmentVariableCollection(n,t){const c=(0,I.serializeEnvironmentVariableCollection)(t.map);this._proxy.$setEnvironmentVariableCollection(n,t.persistent,c.length===0?void 0:c)}$initEnvironmentVariableCollections(n){n.forEach(t=>{const c=t[0],E=new o(t[1]);this._setEnvironmentVariableCollection(c,E)})}$acceptDefaultProfile(n,t){const c=this._defaultProfile;this._defaultProfile=n,this._defaultAutomationProfile=t,c?.path!==n.path&&this._onDidChangeShell.fire(n.path)}_setEnvironmentVariableCollection(n,t){this._environmentVariableCollections.set(n,t),t.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,t)})}};i=Ve([We(1,_.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class o{get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,t){this._setIfDiffers(n,{value:t,type:S.EnvironmentVariableMutatorType.Replace})}append(n,t){this._setIfDiffers(n,{value:t,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,t){this._setIfDiffers(n,{value:t,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,t){const c=this.map.get(n);(!c||c.value!==t.value||c.type!==t.type)&&(this.map.set(n,t),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,t){this.map.forEach((c,E)=>n.call(t,E,c,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}let s=class extends i{constructor(n){super(!1,n)}createTerminal(n,t,c){throw new R.NotSupportedError}createTerminalFromOptions(n,t){throw new R.NotSupportedError}};s=Ve([We(0,_.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function l(m){if(!(!m||typeof m=="string"))return"id"in m?{id:m.id,color:m.color}:m}function r(m){return f.ThemeColor.isThemeColor(m)?m:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a};define(_e[275],ye([1,0,16,19,22,21,3,63,88,6,23,9,30,5,20,137,15,7,57,93,76,27]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C,p){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(L,F,U){this.editors=U,this.resultsChangedEmitter=new _.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(k.MainContext.MainThreadTesting),this.observer=new j(this.proxy),this.runTracker=new n(this.proxy),F.registerArgumentProcessor({processArgument:H=>{if(H?.$mid!==15)return H;const de=H,Y=de.tests[de.tests.length-1].item.extId;return this.controllers.get(g.TestId.root(Y))?.collection.tree.get(Y)?.actual??(0,f.toItemFromContext)(H)}})}createTestController(L,F,U,H){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const de=new D.DisposableStore,Y=de.add(new f.ExtHostTestItemCollection(F,U,this.editors));Y.root.label=U;const V=new Map,X=this.proxy,Z={items:Y.root.children,get label(){return U},set label(K){U=K,Y.root.label=K,X.$updateController(F,{label:U})},get refreshHandler(){return H},set refreshHandler(K){H=K,X.$updateController(F,{canRefresh:!!K})},get id(){return F},createRunProfile:(K,J,ne,pe,be,Ie)=>{let Le=(0,S.hash)(K);for(;V.has(Le);)Le++;return Ie!==void 0&&(0,p.checkProposedApiEnabled)(L,"testContinuousRun"),new $(this.proxy,V,F,Le,K,J,ne,pe,be,Ie)},createTestItem(K,J,ne){return new f.TestItemImpl(F,K,J,ne)},createTestRun:(K,J,ne=!0)=>this.runTracker.createTestRun(F,Y,K,J,ne),set resolveHandler(K){Y.resolveHandler=K},get resolveHandler(){return Y.resolveHandler},dispose:()=>{de.dispose()}};X.$registerTestController(F,U,!!H),de.add((0,D.toDisposable)(()=>X.$unregisterTestController(F)));const te={controller:Z,collection:Y,profiles:V};return this.controllers.set(F,te),de.add((0,D.toDisposable)(()=>this.controllers.delete(F))),de.add(Y.onDidGenerateDiff(K=>X.$publishDiff(F,K.map(C.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.observer.checkout()}async runTests(L,F=A.CancellationToken.None){const U=t(L);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(U.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(de=>g.TestId.fromExtHostTestItem(de,H.collection.root.id).toString())??[H.collection.root.id],profileGroup:N[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:L.exclude?.map(de=>de.id)},F)}$syncTests(){for(const{collection:L}of this.controllers.values())L.flushDiff();return Promise.resolve()}$provideFileCoverage(L,F,U){return(0,a.mapFind)(this.runTracker.trackers,de=>de.id===L?de.getCoverage(F):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(L,F,U,H){return(0,a.mapFind)(this.runTracker.trackers,Y=>Y.id===L?Y.getCoverage(F):void 0)?.resolveFileCoverage(U,H)??Promise.resolve([])}$configureRunProfile(L,F){this.controllers.get(L)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(L,F){await this.controllers.get(L)?.controller.refreshHandler?.(F)}$publishTestResults(L){this.results=Object.freeze(L.map(F=>(0,R.deepFreeze)(d.TestResults.to(F))).concat(this.results).sort((F,U)=>U.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,F){const U=this.controllers.get(g.TestId.fromString(L).controllerId)?.collection;U&&(await U.expand(L,F<0?1/0:F),U.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(C.TestsDiffOp.deserialize))}async $runControllerTests(L,F){return Promise.all(L.map(U=>this.runControllerTestRequest(U,!1,F)))}async $startContinuousRun(L,F){const U=new A.CancellationTokenSource(F),H=await Promise.all(L.map(de=>this.runControllerTestRequest(de,!0,U.token)));return!F.isCancellationRequested&&!H.some(de=>de.error)&&await new Promise(de=>F.onCancellationRequested(de)),U.dispose(!0),H}async runControllerTestRequest(L,F,U){const H=this.controllers.get(L.controllerId);if(!H)return{};const{collection:de,profiles:Y}=H,V=Y.get(L.profileId);if(!V)return{};const X=L.testIds.map(J=>de.tree.get(J)).filter(I.isDefined),Z=L.excludeExtIds.map(J=>H.collection.tree.get(J)).filter(I.isDefined).filter(J=>X.some(ne=>ne.fullId.compare(J.fullId)===2));if(!X.length)return{};const te=new h.TestRunRequest2(X.some(J=>J.actual instanceof f.TestItemRootImpl)?void 0:X.map(J=>J.actual),Z.map(J=>J.actual),V,F),K=(0,C.isStartControllerTests)(L)&&this.runTracker.prepareForMainThreadTestRun(te,c.fromInternal(L,H.collection),U);try{return await V.runHandler(te,U),{}}catch(J){return{error:String(J)}}finally{K&&(K.hasRunningTasks&&!U.isCancellationRequested&&await _.Event.toPromise(K.onEnd),K.dispose())}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};s=Ve([We(0,w.IExtHostRpcService)],s),e.ExtHostTesting=s;const l=1e4;var r;(function(x){x[x.Running=0]="Running",x[x.Cancelling=1]="Cancelling",x[x.Ended=2]="Ended"})(r||(r={}));class m extends D.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(L,F,U){super(),this.dto=L,this.proxy=F,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new _.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new A.CancellationTokenSource(U));const H=this._register(new P.RunOnceScheduler(()=>this.forciblyEndTasks(),l));this._register(this.cts.token.onCancellationRequested(()=>H.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const F=this.dto.id,U=this.dto.controllerId,H=(0,b.generateUuid)(),de=new E(this.proxy,F,H),Y=te=>(K,...J)=>{if(X){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),te(K,...J))},V=(te,K)=>{const J=K instanceof Array?K.map(d.TestMessage.from):[d.TestMessage.from(K)];if(te.uri&&te.range){const ne={range:d.Range.from(te.range),uri:te.uri};for(const pe of J)pe.location=pe.location||ne}this.proxy.$appendTestMessagesInRun(F,H,g.TestId.fromExtHostTestItem(te,U).toString(),J)};let X=!1;const Z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return de.coverageProvider},set coverageProvider(te){de.coverageProvider=te},enqueued:Y(te=>{this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(te,U).toString(),1)}),skipped:Y(te=>{this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(te,U).toString(),5)}),started:Y(te=>{this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(te,U).toString(),2)}),errored:Y((te,K,J)=>{V(te,K),this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(te,U).toString(),6,J)}),failed:Y((te,K,J)=>{V(te,K),this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(te,U).toString(),4,J)}),passed:Y((te,K)=>{this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(te,this.dto.controllerId).toString(),3,K)}),appendOutput:(te,K,J)=>{X||(J&&(this.dto.isIncluded(J)?this.ensureTestIsKnown(J):J=void 0),this.proxy.$appendOutputToRun(F,H,u.VSBuffer.fromString(te),K&&d.location.from(K),J&&g.TestId.fromExtHostTestItem(J,U).toString()))},end:()=>{X||(X=!0,this.proxy.$finishedTestRunTask(F,H),this.tasks.delete(H),this.tasks.size||this.markEnded())}};return this.tasks.set(H,{run:Z,coverage:de}),this.proxy.$startedTestRunTask(F,{id:H,name:L,running:!0}),Z}forciblyEndTasks(){for(const{run:L}of this.tasks.values())L.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(L){if(!(L instanceof f.TestItemImpl))throw new v.InvalidTestItemError(L.id);if(this.sharedTestIds.has(g.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const F=[],U=this.dto.colllection.root;for(;;){const H=d.TestItem.from(L);if(F.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),L===U))break;L=L.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class n{get trackers(){return this.tracked.values()}constructor(L){this.proxy=L,this.tracked=new Map}prepareForMainThreadTestRun(L,F,U){return this.getTracker(L,F,U)}cancelRunById(L){for(const F of this.tracked.values())if(F.id===L){F.cancel();return}}cancelAllRuns(){for(const L of this.tracked.values())L.cancel()}createTestRun(L,F,U,H,de){const Y=this.tracked.get(U);if(Y)return Y.createRun(H);const V=c.fromPublic(L,F,U,de),X=t(U);this.proxy.$startedExtensionTestRun({controllerId:L,continuous:!!U.continuous,profile:X&&{group:N[X.kind],id:X.profileId},exclude:U.exclude?.map(te=>g.TestId.fromExtHostTestItem(te,F.root.id).toString())??[],id:V.id,include:U.include?.map(te=>g.TestId.fromExtHostTestItem(te,F.root.id).toString())??[F.root.id],persist:de});const Z=this.getTracker(U,V);return Z.onEnd(()=>{this.proxy.$finishedExtensionTestRun(V.id),Z.dispose()}),Z.createRun(H)}getTracker(L,F,U){const H=new m(F,this.proxy,U);return this.tracked.set(L,H),H.onEnd(()=>this.tracked.delete(L)),H}}e.TestRunCoordinator=n;const t=x=>{if(!!x.profile){if(!(x.profile instanceof $))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return x.profile}};class c{static fromPublic(L,F,U,H){return new c(L,(0,b.generateUuid)(),U.include?.map(de=>g.TestId.fromExtHostTestItem(de,L).toString())??[L],U.exclude?.map(de=>g.TestId.fromExtHostTestItem(de,L).toString())??[],H,F)}static fromInternal(L,F){return new c(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,F)}constructor(L,F,U,H,de,Y){this.controllerId=L,this.id=F,this.isPersisted=de,this.colllection=Y,this.includePrefix=U.map(V=>V+"\0"),this.excludePrefix=H.map(V=>V+"\0")}isIncluded(L){const F=g.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(F===U||F.startsWith(U))return!1;for(const U of this.includePrefix)if(F===U||F.startsWith(U))return!0;return!1}}e.TestRunDto=c;class E{set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(L,F,U){this.proxy=L,this.runId=F,this.taskId=U}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(L,F){const U=await this.fileCoverage;let H=U?.[L];return!this._coverageProvider||!U||!H?[]:(H.detailedCoverage||(H=U[L]=await this._coverageProvider.resolveFileCoverage?.(H,F)??H),H.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class y{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(L){this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(L){this.added.add(L)}update(L){Object.assign(L.revived,d.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}this.updated.delete(L);const F=g.TestId.parentId(L.item.extId);if(F&&this.alreadyRemoved.has(F.toString())){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:F,removed:U}=this;return{get added(){return[...L].map(H=>H.revived)},get updated(){return[...F].map(H=>H.revived)},get removed(){return[...U].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class M extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new _.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,F){return{...L,revived:d.TestItem.toPlain(L.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new y(this.changeEmitter)}}class j{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(F=>F.revived)},dispose:(0,T.once)(()=>{--L.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new M;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class ${get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(L){L!==this._supportsContinuousRun&&(this._supportsContinuousRun=L,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?d.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}constructor(L,F,U,H,de,Y,V,X=!1,Z=void 0,te=!1){this.controllerId=U,this.profileId=H,this._label=de,this.kind=Y,this.runHandler=V,this._isDefault=X,this._tag=Z,this._supportsContinuousRun=te,i.set(this,void 0),o.set(this,void 0),Je(this,i,L,"f"),Je(this,o,F,"f"),F.set(H,this);const K=N[Y];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);Ue(this,i,"f").$publishTestRunProfile({profileId:H,controllerId:U,tag:Z?d.TestTag.namespace(this.controllerId,Z.id):null,label:de,group:K,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){Ue(this,o,"f")?.delete(this.profileId)&&(Je(this,o,void 0,"f"),Ue(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=$,i=new WeakMap,o=new WeakMap;const N={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(_e[276],ye([1,0,16,3,5,138,15,7]),function(ie,e,a,P,u,A,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new P.Emitter,this._onDidChangeTextEditorOptions=new P.Emitter,this._onDidChangeTextEditorVisibleRanges=new P.Emitter,this._onDidChangeTextEditorViewColumn=new P.Emitter,this._onDidChangeActiveTextEditor=new P.Emitter,this._onDidChangeVisibleTextEditors=new P.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(u.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(b=>this._onDidChangeVisibleTextEditors.fire(b)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(b=>this._onDidChangeActiveTextEditor.fire(b))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const I=this._extHostDocumentsAndEditors.allEditors();return R?I:I.map(b=>b.value)}async showTextDocument(R,I,b){let k;typeof I=="number"?k={position:_.ViewColumn.from(I),preserveFocus:b}:typeof I=="object"?k={position:_.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?_.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:k={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(R.uri,k),f=w&&this._extHostDocumentsAndEditors.getEditor(w);if(f)return f.value;throw w?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,I){return new A.TextEditorDecorationType(this._proxy,R,I).value}$acceptEditorPropertiesChanged(R,I){const b=this._extHostDocumentsAndEditors.getEditor(R);if(!b)throw new Error("unknown text editor");if(I.options&&b._acceptOptions(I.options),I.selections){const k=I.selections.selections.map(_.Selection.to);b._acceptSelections(k)}if(I.visibleRanges){const k=a.coalesce(I.visibleRanges.map(_.Range.to));b._acceptVisibleRanges(k)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:b.value,options:{...I.options,lineNumbers:_.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const k=T.TextEditorSelectionChangeKind.fromValue(I.selections.source),w=I.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:b.value,selections:w,kind:k})}if(I.visibleRanges){const k=a.coalesce(I.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:b.value,visibleRanges:k})}}$acceptEditorPositionData(R){for(const I in R){const b=this._extHostDocumentsAndEditors.getEditor(I);if(!b)throw new Error("Unknown text editor");const k=_.ViewColumn.to(R[I]);b.value.viewColumn!==k&&(b._acceptViewColumn(k),this._onDidChangeTextEditorViewColumn.fire({textEditor:b.value,viewColumn:k}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(_e[277],ye([1,0,2,4,5,6,7,15,26,9]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class R{constructor(k,w){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=k.getProxy(u.MainContext.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(f,d)=>{if(f&&f.$mid===12)if(this._providers.get(f.source)&&S.ExtensionIdentifier.equals(d,this._providers.get(f.source)?.extension)){const h=f.uri===void 0?void 0:a.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(I(h))?.get(f.handle)}else return;return f}})}async $getTimeline(k,w,f,d){return this._providers.get(k)?.provider.provideTimeline(a.URI.revive(w),f,d)}registerTimelineProvider(k,w,f,d){const h=new A.DisposableStore,g=this.convertTimelineItem(w.id,d,h).bind(this);let v;w.onDidChange&&(v=w.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:w.id}),this));const C=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...w,scheme:k,onDidChange:void 0,async provideTimeline(p,i,o){i?.resetCache&&(h.clear(),C.get(w.id)?.clear());const s=await w.provideTimeline(p,i,o);if(s==null)return;const l=g(p,i);return{...s,source:w.id,items:s.items.map(l)}},dispose(){for(const p of C.values())p.get(w.id)?.clear();v?.dispose(),h.dispose()}},f)}convertTimelineItem(k,w,f){return(d,h)=>{let g;if(h?.cacheResults){let v=this._itemsBySourceAndUriMap.get(k);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(k,v));const C=I(d);g=v.get(C),g===void 0&&(g=new Map,v.set(C,g))}return v=>{const{iconPath:C,...p}=v,i=`${k}|${v.id??v.timestamp}`;g?.set(i,v);let o,s,l;v.iconPath&&(C instanceof _.ThemeIcon?l={id:C.id,color:C.color}:a.URI.isUri(C)?(o=C,s=C):{light:o,dark:s}=C);let r;return _.MarkdownString.isMarkdownString(p.tooltip)?r=T.MarkdownString.from(p.tooltip):(0,D.isString)(p.tooltip)?r=p.tooltip:_.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=T.MarkdownString.from(p.detail)):(0,D.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=p.detail),{...p,id:p.id??void 0,handle:i,source:k,command:v.command?w.toInternal(v.command,f):void 0,icon:o,iconDark:s,themeIcon:l,tooltip:r,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(k,w){if(this._providers.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this._proxy.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this._providers.set(k.id,{provider:k,extension:w}),(0,A.toDisposable)(()=>{for(const d of this._itemsBySourceAndUriMap.values())d.get(k.id)?.clear();this._providers.delete(k.id),this._proxy.$unregisterTimelineProvider(k.id),k.dispose()})}}e.ExtHostTimeline=R;function I(b){return b?.toString()}}),define(_e[278],ye([1,0,6,14,2,5]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,D,R,I){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const b=I.schemes.find(k=>!_.supportedSchemes.has(k));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,R),this._proxy.$registerUriOpener(D,I.schemes,S,I.label),(0,a.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(S,D,R){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const b=u.URI.revive(D);return I.canOpenExternalUri(b,R)}async $openUri(S,D,R){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(u.URI.revive(D.resolvedUri),{sourceUri:u.URI.revive(D.sourceUri)},R)}}_.supportedSchemes=new Set([P.Schemas.http,P.Schemas.https]),e.ExtHostUriOpeners=_}),define(_e[279],ye([1,0,5,2,6,11,26]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(D,R){if(this.handles.has(_.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const I=T.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(D)),this.handlers.set(I,R),this._proxy.$registerUriHandler(I,D),(0,u.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(D)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(D,R){const I=this.handlers.get(D);if(!I)return Promise.resolve(void 0);try{I.handleUri(P.URI.revive(R))}catch(b){(0,A.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(D){return P.URI.revive(await this._proxy.$createAppUri(D))}}T.HandlePool=0,e.ExtHostUrls=T});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[80],ye([1,0,3,14,23,2,199,224,94,5]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";var R,I,b,k,w,f,d,h,g,v,C,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(y,M,j,$,N,x,L){R.set(this,void 0),I.set(this,void 0),b.set(this,void 0),k.set(this,void 0),w.set(this,void 0),f.set(this,void 0),d.set(this,""),h.set(this,void 0),g.set(this,!1),v.set(this,!1),C.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new a.Emitter),this._onDidDispose=Ue(this,i,"f").event,Je(this,R,y,"f"),Je(this,I,M,"f"),Je(this,h,j,"f"),Je(this,k,$,"f"),Je(this,w,N,"f"),Je(this,f,x,"f"),Je(this,C,s(x),"f"),Je(this,p,l(x),"f"),Je(this,b,L,"f")}dispose(){Je(this,g,!0,"f"),Ue(this,i,"f").fire(),Ue(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(y){return Je(this,v,!0,"f"),(0,S.asWebviewUri)(y,Ue(this,k,"f"))}get cspSource(){const y=Ue(this,f,"f").extensionLocation;if(y.scheme===P.Schemas.https||y.scheme===P.Schemas.http){let M=y.toString();return M.endsWith("/")||(M+="/"),M+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,d,"f")}set html(y){this.assertNotDisposed(),Ue(this,d,"f")!==y&&(Je(this,d,y,"f"),Ue(this,p,"f")&&!Ue(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(y)&&(Je(this,v,!0,"f"),Ue(this,b,"f").report("Webview vscode-resource: uris",Ue(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,I,"f").$setHtml(Ue(this,R,"f"),this.rewriteOldResourceUrlsIfNeeded(y)))}get options(){return this.assertNotDisposed(),Ue(this,h,"f")}set options(y){this.assertNotDisposed(),u.equals(Ue(this,h,"f"),y)||Ue(this,I,"f").$setOptions(Ue(this,R,"f"),n(Ue(this,f,"f"),Ue(this,w,"f"),y)),Je(this,h,y,"f")}async postMessage(y){if(Ue(this,g,"f"))return!1;const M=(0,T.serializeWebviewMessage)(y,{serializeBuffersForPostMessage:Ue(this,C,"f")});return Ue(this,I,"f").$postMessage(Ue(this,R,"f"),M.message,...M.buffers)}assertNotDisposed(){if(Ue(this,g,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(y){if(!Ue(this,p,"f"))return y;const M=Ue(this,f,"f").extensionLocation?.scheme===P.Schemas.vscodeRemote,j=Ue(this,f,"f").extensionLocation.scheme===P.Schemas.vscodeRemote?Ue(this,f,"f").extensionLocation.authority:void 0;return y.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,N,x,L,F,U)=>{const H=A.URI.from({scheme:L||"file",path:decodeURIComponent(F)}),de=(0,S.asWebviewUri)(H,{isRemote:M,authority:j}).toString();return`${N}${de}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,N,x,L,F,U)=>{const H=A.URI.from({scheme:L||"file",path:decodeURIComponent(F)}),de=(0,S.asWebviewUri)(H,{isRemote:M,authority:j}).toString();return`${N}${de}${U}`})}}e.ExtHostWebview=o,R=new WeakMap,I=new WeakMap,b=new WeakMap,k=new WeakMap,w=new WeakMap,f=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap,v=new WeakMap,C=new WeakMap,p=new WeakMap,i=new WeakMap;function s(E){try{const y=(0,_.normalizeVersion)((0,_.parseVersion)(E.engines.vscode));return!!y&&y.majorBase>=1&&y.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function l(E){try{const y=(0,_.normalizeVersion)((0,_.parseVersion)(E.engines.vscode));return y?y.majorBase<1||y.majorBase===1&&y.minorBase<60:!1}catch{return!1}}class r{constructor(y,M,j,$,N){this.remoteInfo=M,this.workspace=j,this._logService=$,this._deprecationService=N,this._webviews=new Map,this._webviewProxy=y.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(y,M,j){const $=this.getWebview(y);if($){const{message:N}=(0,T.deserializeWebviewMessage)(M,j.value);$._onMessageEmitter.fire(N)}}$onMissingCsp(y,M){this._logService.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(y,M,j){const $=new o(y,this._webviewProxy,t(M),this.remoteInfo,this.workspace,j,this._deprecationService);return this._webviews.set(y,$),$._onDidDispose(()=>{this._webviews.delete(y)}),$}deleteWebview(y){this._webviews.delete(y)}getWebview(y){return this._webviews.get(y)}}e.ExtHostWebviews=r;function m(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=m;function n(E,y,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||c(E,y)}}e.serializeWebviewOptions=n;function t(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(y=>A.URI.from(y))}}function c(E,y){return[...(y?.getWorkspaceFolders()||[]).map(M=>M.uri),E.extensionLocation]}}),define(_e[280],ye([1,0,21,88,6,14,24,2,15,80,75,5,7]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(o,s){this.document=o,this._storagePath=s,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,s){await this.getEdit(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.getEdit(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=p(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const s=this._edits.get(o,0);if(!s)throw new Error("No edit found");return s}}class w{constructor(){this._documents=new Map}get(o,s){return this._documents.get(this.key(o,s))}add(o,s,l){const r=this.key(o,s.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const m=new k(s,l);return this._documents.set(r,m),m}delete(o,s){const l=this.key(o,s.uri);this._documents.delete(l)}key(o,s){return`${o}@@@${s}`}}var f;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(f||(f={}));class d{constructor(){this._providers=new Map}addTextProvider(o,s,l){return this.add(0,o,s,l)}addCustomProvider(o,s,l){return this.add(1,o,s,l)}get(o){return this._providers.get(o)}add(o,s,l,r){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:o,extension:l,provider:r}),new b.Disposable(()=>this._providers.delete(s))}}class h{constructor(o,s,l,r,m){this._extHostDocuments=s,this._extensionStoragePaths=l,this._extHostWebview=r,this._extHostWebviewPanels=m,this._editorProviders=new d,this._documents=new w,this._proxy=o.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,l,r){const m=new u.DisposableStore;return v(l)?(m.add(this._editorProviders.addTextProvider(s,o,l)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(o),s,r.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(o))):(m.add(this._editorProviders.addCustomProvider(s,o,l)),g(l)&&m.add(l.onDidChangeCustomDocument(n=>{const t=this.getCustomDocumentEntry(s,n.document.uri);if(C(n)){const c=t.addEdit(n);this._proxy.$onDidEdit(n.document.uri,s,c,n.label)}else this._proxy.$onContentChange(n.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(o),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(o))),b.Disposable.from(m,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,l,r,m){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${s}'`);const t=T.URI.revive(o),c=await n.provider.openCustomDocument(t,{backupId:l,untitledDocumentData:r?.buffer},m);let E;return g(n.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(s,c,E),{editable:g(n.provider)}}async $disposeCustomDocument(o,s){const l=this._editorProviders.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=T.URI.revive(o),{document:m}=this.getCustomDocumentEntry(s,r);this._documents.delete(s,m),m.dispose()}async $resolveCustomEditor(o,s,l,r,m,n){const t=this._editorProviders.get(l);if(!t)throw new Error(`No provider found for '${l}'`);const c=S.ViewColumn.to(m),E=this._extHostWebview.createNewWebview(s,r.contentOptions,t.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(s,l,r.title,c,r.options,E,!0),M=T.URI.revive(o);switch(t.type){case 1:{const{document:j}=this.getCustomDocumentEntry(l,M);return t.provider.resolveCustomEditor(j,y,n)}case 0:{const j=this._extHostDocuments.getDocument(M);return t.provider.resolveCustomTextEditor(j,y,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,l){this.getCustomDocumentEntry(s,o).disposeEdits(l)}async $onMoveCustomEditor(o,s,l){const r=this._editorProviders.get(l);if(!r)throw new Error(`No provider found for '${l}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const m=this._extHostWebviewPanels.getWebviewPanel(o);if(!m)throw new Error("No webview found");const n=T.URI.revive(s),t=this._extHostDocuments.getDocument(n);await r.provider.moveCustomTextEditor(t,m,a.CancellationToken.None)}async $undo(o,s,l,r){return this.getCustomDocumentEntry(s,o).undo(l,r)}async $redo(o,s,l,r){return this.getCustomDocumentEntry(s,o).redo(l,r)}async $revert(o,s,l){const r=this.getCustomDocumentEntry(s,o);await this.getCustomEditorProvider(s).revertCustomDocument(r.document,l),r.disposeBackup()}async $onSave(o,s,l){const r=this.getCustomDocumentEntry(s,o);await this.getCustomEditorProvider(s).saveCustomDocument(r.document,l),r.disposeBackup()}async $onSaveAs(o,s,l,r){const m=this.getCustomDocumentEntry(s,o);return this.getCustomEditorProvider(s).saveCustomDocumentAs(m.document,T.URI.revive(l),r)}async $backup(o,s,l){const r=this.getCustomDocumentEntry(s,o),n=await this.getCustomEditorProvider(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},l);return r.updateBackup(n),n.id}getCustomDocumentEntry(o,s){const l=this._documents.get(o,T.URI.revive(s));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(o){const l=this._editorProviders.get(o)?.provider;if(!l||!g(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=h;function g(i){return!!i.onDidChangeCustomDocument}function v(i){return typeof i.resolveCustomTextEditor=="function"}function C(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function p(i){const o=i.scheme===A.Schemas.file||i.scheme===A.Schemas.untitled?i.fsPath:i.toString();return(0,P.hash)(o)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[281],ye([1,0,3,6,2,30,15,80,5,7]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";var R,I,b,k,w,f,d,h,g,v,C,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends P.Disposable{constructor(m,n,t,c){super(),R.set(this,void 0),I.set(this,void 0),b.set(this,void 0),k.set(this,void 0),w.set(this,void 0),f.set(this,void 0),d.set(this,void 0),h.set(this,void 0),g.set(this,!0),v.set(this,void 0),C.set(this,!1),p.set(this,this._register(new a.Emitter)),this.onDidDispose=Ue(this,p,"f").event,i.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Ue(this,i,"f").event,Je(this,R,m,"f"),Je(this,I,n,"f"),Je(this,k,t,"f"),Je(this,b,c.viewType,"f"),Je(this,w,c.panelOptions,"f"),Je(this,h,c.viewColumn,"f"),Je(this,f,c.title,"f"),Je(this,v,c.active,"f")}dispose(){Ue(this,C,"f")||(Je(this,C,!0,"f"),Ue(this,p,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,R,"f")),Ue(this,k,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,k,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,b,"f")}get title(){return this.assertNotDisposed(),Ue(this,f,"f")}set title(m){this.assertNotDisposed(),Ue(this,f,"f")!==m&&(Je(this,f,m,"f"),Ue(this,I,"f").$setTitle(Ue(this,R,"f"),m))}get iconPath(){return this.assertNotDisposed(),Ue(this,d,"f")}set iconPath(m){this.assertNotDisposed(),Ue(this,d,"f")!==m&&(Je(this,d,m,"f"),Ue(this,I,"f").$setIconPath(Ue(this,R,"f"),u.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Ue(this,w,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,h,"f")=="number"&&Ue(this,h,"f")<0))return Ue(this,h,"f")}get active(){return this.assertNotDisposed(),Ue(this,v,"f")}get visible(){return this.assertNotDisposed(),Ue(this,g,"f")}_updateViewState(m){Ue(this,C,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(Je(this,v,m.active,"f"),Je(this,g,m.visible,"f"),Je(this,h,m.viewColumn,"f"),Ue(this,i,"f").fire({webviewPanel:this}))}reveal(m,n){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,R,"f"),{viewColumn:typeof m>"u"?void 0:_.ViewColumn.from(m),preserveFocus:!!n})}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,I=new WeakMap,b=new WeakMap,k=new WeakMap,w=new WeakMap,f=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap,v=new WeakMap,C=new WeakMap,p=new WeakMap,i=new WeakMap;class s{static newHandle(){return(0,A.generateUuid)()}constructor(m,n,t){this.webviews=n,this.workspace=t,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(m,n,t,c,E={}){const y=typeof c=="object"?c.viewColumn:c,M={viewColumn:_.ViewColumn.from(y),preserveFocus:typeof c=="object"&&!!c.preserveFocus},j=(0,T.shouldSerializeBuffersForPostMessage)(m),$=s.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(m),$,n,{title:t,panelOptions:l(E),webviewOptions:(0,T.serializeWebviewOptions)(m,this.workspace,E),serializeBuffersForPostMessage:j},M);const N=this.webviews.createNewWebview($,E,m);return this.createNewWebviewPanel($,n,t,y,E,N,!0)}$onDidChangeWebviewPanelViewStates(m){const n=Object.keys(m);n.sort((t,c)=>{const E=m[t],y=m[c];return E.active?1:y.active?-1:+E.visible-+y.visible});for(const t of n){const c=this.getWebviewPanel(t);if(!c)continue;const E=m[t];c._updateViewState({active:E.active,visible:E.visible,viewColumn:_.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,n,t){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:t,extension:m}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(m)}),new D.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(m,n,t,c){const E=this._serializers.get(n);if(!E)throw new Error(`No serializer found for '${n}'`);const{serializer:y,extension:M}=E,j=this.webviews.createNewWebview(m,t.webviewOptions,M),$=this.createNewWebviewPanel(m,n,t.title,c,t.panelOptions,j,t.active);await y.deserializeWebviewPanel($,t.state)}createNewWebviewPanel(m,n,t,c,E,y,M){const j=new o(m,this._proxy,y,{viewType:n,title:t,viewColumn:c,panelOptions:E,active:M});return this._webviewPanels.set(m,j),j}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=s;function l(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[282],ye([1,0,3,6,80,15,5,7]),function(ie,e,a,P,u,A,_,T){"use strict";var S,D,R,I,b,k,w,f,d,h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends P.Disposable{constructor(i,o,s,l,r,m){super(),S.set(this,void 0),D.set(this,void 0),R.set(this,void 0),I.set(this,void 0),b.set(this,!1),k.set(this,void 0),w.set(this,void 0),f.set(this,void 0),d.set(this,void 0),h.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Ue(this,h,"f").event,g.set(this,this._register(new a.Emitter)),this.onDidDispose=Ue(this,g,"f").event,Je(this,R,s,"f"),Je(this,w,l,"f"),Je(this,S,i,"f"),Je(this,D,o,"f"),Je(this,I,r,"f"),Je(this,k,m,"f")}dispose(){Ue(this,b,"f")||(Je(this,b,!0,"f"),Ue(this,g,"f").fire(),Ue(this,I,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,w,"f")}set title(i){this.assertNotDisposed(),Ue(this,w,"f")!==i&&(Je(this,w,i,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,S,"f"),i))}get description(){return this.assertNotDisposed(),Ue(this,f,"f")}set description(i){this.assertNotDisposed(),Ue(this,f,"f")!==i&&(Je(this,f,i,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,S,"f"),i))}get visible(){return Ue(this,k,"f")}get webview(){return Ue(this,I,"f")}get viewType(){return Ue(this,R,"f")}_setVisible(i){i===Ue(this,k,"f")||Ue(this,b,"f")||(Je(this,k,i,"f"),Ue(this,h,"f").fire())}get badge(){return this.assertNotDisposed(),Ue(this,d,"f")}set badge(i){this.assertNotDisposed(),!(i?.value===Ue(this,d,"f")?.value&&i?.tooltip===Ue(this,d,"f")?.tooltip)&&(Je(this,d,A.ViewBadge.from(i),"f"),Ue(this,D,"f").$setWebviewViewBadge(Ue(this,S,"f"),i))}show(i){this.assertNotDisposed(),Ue(this,D,"f").$show(Ue(this,S,"f"),!!i)}assertNotDisposed(){if(Ue(this,b,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,D=new WeakMap,R=new WeakMap,I=new WeakMap,b=new WeakMap,k=new WeakMap,w=new WeakMap,f=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap;class C{constructor(i,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,s,l){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:s,extension:i}),this._proxy.$registerWebviewViewProvider((0,u.toExtensionData)(i),o,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,u.shouldSerializeBuffersForPostMessage)(i)}),new T.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,s,l,r){const m=this._viewProviders.get(o);if(!m)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:t}=m,c=this._extHostWebview.createNewWebview(i,{},t),E=new v(i,this._proxy,o,s,c,!0);this._webviewViews.set(i,E),await n.resolveWebviewView(E,{state:l},r)}async $onDidChangeWebviewViewVisibility(i,o){this.getWebviewView(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.getWebviewView(i);this._webviewViews.delete(i),o.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const o=this._webviewViews.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=C}),define(_e[141],ye([1,0,3,5,2,14,8,4,20]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class an{get state(){return this._state}constructor(I){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=an.InitialState,this._proxy=I.getProxy(P.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(b=>this.$onDidChangeWindowFocus(b))}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,b){let k;if(typeof I=="string"){k=I;try{I=u.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,_.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,k,b)}async asExternalUri(I,b){if((0,_.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this._proxy.$asExternalUri(I,b);return u.URI.from(k)}};D.InitialState={focused:!0},D=Ve([We(0,S.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(_e[283],ye([1,0,119,284,70,40,2,13,47]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(b,k,w){this._commands=b,this.logService=k,this._ipcHandlePath=w,this._server=P.createServer((f,d)=>this.onRequest(f,d)),this.setup().catch(f=>(k.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",b=>this.logService.error(b))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(b,k){const w=(d,h)=>{k.writeHead(d,{"content-type":"application/json"}),k.end(JSON.stringify(h||null),g=>g&&this.logService.error(g))},f=[];b.setEncoding("utf8"),b.on("data",d=>f.push(d)),b.on("end",async()=>{try{const d=JSON.parse(f.join(""));let h;switch(d.type){case"open":h=await this.open(d);break;case"openExternal":h=await this.openExternal(d);break;case"status":h=await this.getStatus(d);break;case"extensionManagement":h=await this.manageExtensions(d);break;default:w(404,`Unknown message type: ${d.type}`);break}w(200,h)}catch(d){const h=d instanceof Error?d.message:JSON.stringify(d);w(500,h),this.logService.error("Error while processing pipe request",d)}})}async open(b){const{fileURIs:k,folderURIs:w,forceNewWindow:f,diffMode:d,mergeMode:h,addMode:g,forceReuseWindow:v,gotoLineMode:C,waitMarkerFilePath:p,remoteAuthority:i}=b,o=[];if(Array.isArray(w))for(const m of w)try{o.push({folderUri:_.URI.parse(m)})}catch{}if(Array.isArray(k))for(const m of k)try{(0,S.hasWorkspaceFileExtension)(m)?o.push({workspaceUri:_.URI.parse(m)}):o.push({fileUri:_.URI.parse(m)})}catch{}const s=p?_.URI.file(p):void 0,r={forceNewWindow:f,diffMode:d,mergeMode:h,addMode:g,gotoLineMode:C,forceReuseWindow:v,preferNewWindow:!v&&!s&&!g,waitMarkerFileURI:s,remoteAuthority:i};return this._commands.executeCommand("_remoteCLI.windowOpen",o,r),""}async openExternal(b){for(const k of b.uris){const w=_.URI.parse(k),f=w.scheme==="file"?w:k;await this._commands.executeCommand("_remoteCLI.openExternal",f)}}async manageExtensions(b){const k=f=>f?.map(d=>/\.vsix$/i.test(d)?_.URI.parse(d):d),w={list:b.list,install:k(b.install),uninstall:k(b.uninstall),force:b.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",w)}async getStatus(b){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&u.existsSync(this._ipcHandlePath)&&u.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let R=class extends D{constructor(b,k){super(b,k,(0,a.createRandomIPCHandle)())}};R=Ve([We(0,A.IExtHostCommands),We(1,T.ILogService)],R),e.CLIServer=R}),define(_e[285],ye([1,0,255,25,20]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let _=class extends a.AbstractExtHostConsoleForwarder{constructor(S,D){super(S,D),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(S,D,R){const I=S==="error"||S==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),D.apply(console,R),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(S,D){const R=process[S],I=R.write;let b="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(k,w,f)=>{if(!this._isMakingConsoleCall){b+=k.toString(w);const d=b.length>A?b.length:b.lastIndexOf(`
`);d!==-1&&(console[D](b.slice(0,d)),b=b.slice(d+1))}I.call(R,k,w,f)}})}};_=Ve([We(0,u.IExtHostRpcService),We(1,P.IExtHostInitDataService)],_),e.ExtHostConsoleForwarder=_}),define(_e[286],ye([1,0,10,71,30,40,6,5,2,20]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends _.Disposable{constructor(b,k){super();const w=b.getProxy(T.MainContext.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async f=>{const d=S.URI.file((0,a.join)((0,P.tmpdir)(),(0,u.generateUuid)()));return await w.$download(f,d),d})}};R=Ve([We(0,D.IExtHostRpcService),We(1,A.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(_e[287],ye([1,0,140,14,206,30]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class _ extends a.ExtHostLoggerService{doCreateLogger(S,D,R){return S.scheme===P.Schemas.file?new u.SpdLogLogger(R?.name||(0,A.generateUuid)(),S.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,D):super.doCreateLogger(S,D,R)}registerLogger(S){super.registerLogger(S),this._proxy.$registerLogger(S)}deregisterLogger(S){super.deregisterLogger(S),this._proxy.$deregisterLogger(S)}}e.ExtHostLoggerService=_}),define(_e[288],ye([1,0,70,10,2,79,6,14,19,29]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(i){const o=await super._getWorkspaceStorageURI(i);if(o.scheme!==T.Schemas.file)return o;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const s=o.fsPath;let l=0;do{let r;l===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${l}`:`${s}-${l}`,await I(r);const m=P.join(r,"vscode.lock"),n=await f(this._logService,m,!1);if(n)return this._workspaceStorageLock=n,process.on("exit",()=>{n.dispose()}),u.URI.file(r);l++}while(l<10);return o}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function I(p){try{await D.Promises.stat(p);return}catch{}try{await D.Promises.mkdir(p,{recursive:!0})}catch{}}const b=1e3,k=10*60*1e3;class w extends _.Disposable{constructor(i,o){super(),this.logService=i,this.filename=o,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await d(i,o);(!s||s.pid!==process.pid)&&(i.info(`Lock '${o}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(o,new Date,new Date)}catch(l){i.error(l),i.info(`Lock '${o}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{a.unlinkSync(this.filename)}catch{}}async setWillRelease(i){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+i};await D.Promises.writeFile(this.filename,JSON.stringify(o),{flag:"w"})}catch(o){this.logService.error(o)}}}async function f(p,i,o){try{const l={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(i,JSON.stringify(l),{flag:"wx"})}catch(l){p.error(l)}const s=await d(p,i);return!s||s.pid!==process.pid?o?(p.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),v(p,i)):(p.info(`Lock '${i}': Lock acquired.`),new w(p,i))}async function d(p,i){let o;try{o=await D.Promises.readFile(i)}catch(s){return p.error(s),null}try{return JSON.parse(String(o))}catch(s){return p.error(s),null}}async function h(p,i){let o;try{o=await D.Promises.stat(i)}catch(s){return p.error(s),0}return o.mtime.getTime()}function g(p){try{return process.kill(p,0),!0}catch{return!1}}async function v(p,i){const o=await d(p,i);if(!o)return p.info(`Lock '${i}': Could not read pid of lock holder.`),C(p,i);if(o.willReleaseAt){let n=o.willReleaseAt-Date.now();if(n<5e3){for(n>0?p.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):p.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await h(p,i)===0)return C(p,i);n=o.willReleaseAt-Date.now()}return C(p,i)}}if(!g(o.pid))return p.info(`Lock '${i}': The pid ${o.pid} appears to be gone.`),C(p,i);const s=await h(p,i),l=Date.now()-s;if(l<=k)return p.info(`Lock '${i}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;p.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await h(p,i),m=Date.now()-r;return m<=k?(p.info(`Lock '${i}': The lock does not look stale, elapsed: ${m} ms, giving up.`),null):(p.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),C(p,i))}async function C(p,i){p.info(`Lock '${i}': Deleting a stale lock.`);try{await D.Promises.unlink(i)}catch{}return f(p,i,!0)}}),define(_e[289],ye([1,0,30,20,41]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends u.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,D){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:D})}createTerminalFromOptions(T,S){const D=new u.ExtHostTerminal(this._proxy,(0,a.generateUuid)(),T,T.name);return this._terminals.push(D),D.create(T,this._serializeParentTerminal(T,S)),D.value}};A=Ve([We(0,P.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(_e[290],ye([1,0,5,20,186,6,25,2,46,24,29,7,12,55,3,129,102,13]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class g extends f.DisposableTunnel{}function v(n){const t=n.trim().split(`
`),c=[];return t.forEach(y=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(y);M&&M.length>=3&&c.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),c.reduce((y,M)=>(y[M.socket]=M,y),{})}e.getSockets=v;function C(...n){const t=[].concat(...n.map(i));return[...new Map(t.filter(c=>c.st==="0A").map(c=>{const E=c.local_address.split(":");return{socket:parseInt(c.inode,10),ip:p(E[0]),port:parseInt(E[1],16)}}).map(c=>[c.ip+":"+c.port,c])).values()]}e.loadListeningPorts=C;function p(n){let t="";if(n.length===8)for(let c=n.length-2;c>=0;c-=2)t+=parseInt(n.substr(c,2),16),c!==0&&(t+=".");else for(let c=n.length-4;c>=0;c-=4)t+=parseInt(n.substr(c,4),16).toString(16),c!==0&&(t+=":");return t}function i(n){const t=n.trim().split(`
`),c=t.shift().trim().split(/\s+/).filter(y=>y!=="rx_queue"&&y!=="tm->when");return t.map(y=>y.trim().split(/\s+/).reduce((M,j,$)=>(M[c[$]||$]=j,M),{}))}e.loadConnectionTable=i;function o(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function s(n){const t=n.trim().split(`
`),c=[];return t.forEach(E=>{const y=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);y&&y.length>=4&&c.push({pid:parseInt(y[1],10),ppid:parseInt(y[2]),cmd:y[3]})}),c}e.getRootProcesses=s;async function l(n,t,c){const E=c.reduce((M,j)=>(M[j.pid]=j,M),{}),y=[];return n.forEach(({socket:M,ip:j,port:$})=>{const N=t[M]?t[M].pid:void 0,x=N?E[N]?.cmd:void 0;N&&x&&!o(x)&&y.push({host:j,port:$,detail:x,pid:N})}),y}e.findPorts=l;function r(n,t,c){const E=new Map,y=s(t);for(const M of n){const j=c.get(M.port);if(j){E.set(M.port,j);continue}const $=y.find(N=>N.cmd.includes(`${M.port}`));if($){let N=$,x;do x=y.find(L=>L.ppid===N.pid),x&&(N=x);while(x);E.set(M.port,{host:M.ip,port:M.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else E.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=r;let m=class extends A.Disposable{constructor(t,c,E){super(),this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new w.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=t.getProxy(a.MainContext.MainThreadTunnelService),b.isLinux&&c.remote.isRemote&&c.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(t,c){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(c,t.displayName);if(E){const y=new g(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(y),y}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(t){return Math.max(t*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(t,c){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:t,provider:c}),this._proxy.$registerPortsAttributesProvider(t,E),new I.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(t,c,E,y,M){const j=[];for(const N of t){const x=this._portAttributesProviders.get(N);if(!x)return[];j.push(...await Promise.all(c.map(async L=>x.provider.providePortAttributes(L,E,y,M))))}const $=j.filter(N=>!!N);return $.length>0?$.map(N=>({autoForwardAction:N.autoForwardAction,port:N.port})):[]}async $registerCandidateFinder(t){if(t&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=t;const c=new d.MovingAverage;let E;for(;this._candidateFindingEnabled;){const y=new Date().getTime(),M=(await this.findCandidatePorts()).filter($=>(0,f.isLocalhost)($.host)||(0,f.isAllInterfaces)($.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map($=>$.port).join(", ")}`);const j=new Date().getTime()-y;c.update(j),(!E||JSON.stringify(E)!==JSON.stringify(M))&&(E=M,await this._proxy.$onFoundNewCandidates(E)),await new Promise($=>setTimeout(()=>$(),this.calculateDelay(c.value)))}}async setTunnelFactory(t){if(t){if(t.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this._showCandidatePort=t.showCandidatePort,this._proxy.$setCandidateFilter()),t.tunnelFactory){this._forwardPortProvider=t.tunnelFactory;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:u.localize(0,null),themeIcon:"lock"},{id:"public",label:u.localize(1,null),themeIcon:"eye"}]);const E=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this._proxy.$setTunnelProvider(E)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(t,c){if(this._extensionTunnels.has(t.host)){const E=this._extensionTunnels.get(t.host);E.has(t.port)&&(c&&E.get(t.port).disposeListener.dispose(),await E.get(t.port).tunnel.dispose(),E.delete(t.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(t,c){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(t,c);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const y=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(t.remoteAddress.host)||this._extensionTunnels.set(t.remoteAddress.host,new Map);const M=this._register(y.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(y.remoteAddress))));return this._extensionTunnels.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:y,disposeListener:M}),k.TunnelDtoConverter.fromApiTunnel(y)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(t){const c=await Promise.all(t.map(y=>this._showCandidatePort(y.host,y.port,y.detail??""))),E=t.filter((y,M)=>c[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(y=>y.port).join(", ")} to ${E.map(y=>y.port).join(", ")}`),E}async findCandidatePorts(){let t="",c="";try{t=await R.Promises.readFile("/proc/net/tcp","utf8"),c=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=C(t,c),y=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(H,de,Y)=>{U(de)})}),M=v(y),j=await R.Promises.readdir("/proc"),$=[];for(const U of j)try{const H=Number(U),de=D.joinPath(T.URI.file("/proc"),U);if((await R.Promises.stat(de.fsPath)).isDirectory()&&!isNaN(H)){const V=await R.Promises.readlink(D.joinPath(de,"cwd").fsPath),X=await R.Promises.readFile(D.joinPath(de,"cmdline").fsPath,"utf8");$.push({pid:H,cwd:V,cmd:X})}}catch{}const N=[],x=E.filter(U=>{const H=M[U.socket];return H||N.push(U),H}),L=l(x,M,$);let F;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const U=await new Promise(H=>{(0,S.exec)("ps -F -A -l | grep root",(de,Y,V)=>{H(Y)})});this._foundRootPorts=r(N,U,this._foundRootPorts),F=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${F.map(H=>H.port).join(", ")}`)}return L.then(U=>F?U.concat(F):U)}};m=Ve([We(0,P.IExtHostRpcService),We(1,_.IExtHostInitDataService),We(2,h.ILogService)],m),e.ExtHostTunnelService=m}),define(_e[291],ye([1,0,19,22,21,11,3,6,114,249,58]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function b(E,y){try{return JSON.stringify(E,y)}catch{return"null"}}const k="$$ref$$",w={[k]:-1};class f{constructor(y,M){this.jsonString=y,this.referencedBuffers=M}}function d(E,y=null,M=!1){const j=[];return{jsonString:(M?b:JSON.stringify)(E,(N,x)=>{if(typeof x>"u")return w;if(typeof x=="object"){if(x instanceof P.VSBuffer){const L=j.push(x)-1;return{[k]:L}}if(y)return y(N,x)}return x}),referencedBuffers:j}}e.stringifyJsonWithBufferRefs=d;function h(E,y,M){return JSON.parse(E,(j,$)=>{if($){const N=$[k];if(typeof N=="number")return y[N];if(M&&$.$mid===1)return M.transformIncoming($)}return $})}e.parseJsonAndRestoreBufferRefs=h;function g(E,y){return JSON.stringify(E,y)}function v(E){return E?(y,M)=>M&&M.$mid===1?E.transformOutgoing(M):M:null}var C;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class l extends T.Disposable{constructor(y,M=null,j=null){super(),this[I]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=y,this._logger=M,this._uriTransformer=j,this._uriReplacer=v(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,N=R.ProxyIdentifier.count;$<N;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(y=>{this._pendingRPCReplies[y].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(y){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(y){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(y){this._responsiveState!==y&&(this._responsiveState=y,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(y){return this._uriTransformer?(0,S.transformIncomingURIs)(y,this._uriTransformer):y}getProxy(y){const{nid:M,sid:j}=y;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,j)),this._proxies[M]}_createProxy(y,M){const j={get:($,N)=>(typeof N=="string"&&!$[N]&&N.charCodeAt(0)===36&&($[N]=(...x)=>this._remoteCall(y,N,x)),N===s?M:$[N])};return new Proxy(Object.create(null),j)}set(y,M){return this._locals[y.nid]=M,M}assertRegistered(y){for(let M=0,j=y.length;M<j;M++){const $=y[M];if(!this._locals[$.nid])throw new Error(`Missing proxy instance ${$.sid}`)}}_receiveOneMessage(y){if(this._isDisposed)return;const M=y.byteLength,j=r.read(y,0),$=j.readUInt8(),N=j.readUInt32();switch($){case 1:case 2:{let{rpcId:x,method:L,args:F}=n.deserializeRequestJSONArgs(j);this._uriTransformer&&(F=(0,S.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(M,N,x,L,F,$===2);break}case 3:case 4:{let{rpcId:x,method:L,args:F}=n.deserializeRequestMixedArgs(j);this._uriTransformer&&(F=(0,S.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(M,N,x,L,F,$===4);break}case 5:{this._logger?.logIncoming(M,N,0,"ack"),this._onDidReceiveAcknowledge(N);break}case 6:{this._receiveCancel(M,N);break}case 7:{this._receiveReply(M,N,void 0);break}case 9:{let x=n.deserializeReplyOKJSON(j);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(M,N,x);break}case 10:{const x=n.deserializeReplyOKJSONWithBuffers(j,this._uriTransformer);this._receiveReply(M,N,x);break}case 8:{const x=n.deserializeReplyOKVSBuffer(j);this._receiveReply(M,N,x);break}case 11:{let x=n.deserializeReplyErrError(j);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(M,N,x);break}case 12:{this._receiveReplyErr(M,N,void 0);break}default:console.error("received unexpected message"),console.error(y)}}_receiveRequest(y,M,j,$,N,x){this._logger?.logIncoming(y,M,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(j)}.${$}(`,N);const L=String(M);let F,U;if(x){const de=new u.CancellationTokenSource;N.push(de.token),F=this._invokeHandler(j,$,N),U=()=>de.cancel()}else F=this._invokeHandler(j,$,N),U=i;this._cancelInvokedHandlers[L]=U;const H=n.serializeAcknowledged(M);this._logger?.logOutgoing(H.byteLength,M,1,"ack"),this._protocol.send(H),F.then(de=>{delete this._cancelInvokedHandlers[L];const Y=n.serializeReplyOK(M,de,this._uriReplacer);this._logger?.logOutgoing(Y.byteLength,M,1,"reply:",de),this._protocol.send(Y)},de=>{delete this._cancelInvokedHandlers[L];const Y=n.serializeReplyErr(M,de);this._logger?.logOutgoing(Y.byteLength,M,1,"replyErr:",de),this._protocol.send(Y)})}_receiveCancel(y,M){this._logger?.logIncoming(y,M,1,"receiveCancel");const j=String(M);this._cancelInvokedHandlers[j]?.()}_receiveReply(y,M,j){this._logger?.logIncoming(y,M,0,"receiveReply:",j);const $=String(M);if(!this._pendingRPCReplies.hasOwnProperty($))return;const N=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],N.resolveOk(j)}_receiveReplyErr(y,M,j){this._logger?.logIncoming(y,M,0,"receiveReplyErr:",j);const $=String(M);if(!this._pendingRPCReplies.hasOwnProperty($))return;const N=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let x;j&&(j.$isError?(x=new Error,x.name=j.name,x.message=j.message,x.stack=j.stack):x=j),N.resolveErr(x)}_invokeHandler(y,M,j){try{return Promise.resolve(this._doInvokeHandler(y,M,j))}catch($){return Promise.reject($)}}_doInvokeHandler(y,M,j){const $=this._locals[y];if(!$)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(y));const N=$[M];if(typeof N!="function")throw new Error("Unknown method "+M+" on actor "+(0,R.getStringIdentifierForProxy)(y));return N.apply($,j)}_remoteCall(y,M,j){if(this._isDisposed)return new D.CanceledLazyPromise;let $=null;if(j.length>0&&u.CancellationToken.isCancellationToken(j[j.length-1])&&($=j.pop()),$&&$.isCancellationRequested)return Promise.reject(A.canceled());const N=n.serializeRequestArguments(j,this._uriReplacer),x=++this._lastMessageId,L=String(x),F=new D.LazyPromise;$&&$.onCancellationRequested(()=>{const H=n.serializeCancel(x);this._logger?.logOutgoing(H.byteLength,x,0,"cancel"),this._protocol.send(n.serializeCancel(x))}),this._pendingRPCReplies[L]=F,this._onWillSendRequest(x);const U=n.serializeRequest(x,y,M,N,!!$);return this._logger?.logOutgoing(U.byteLength,x,0,`request: ${(0,R.getStringIdentifierForProxy)(y)}.${M}(`,j),this._protocol.send(U),F}}I=o,l.UNRESPONSIVE_TIME=3*1e3,e.RPCProtocol=l;class r{static alloc(y,M,j){const $=new r(P.VSBuffer.alloc(j+1+4),0);return $.writeUInt8(y),$.writeUInt32(M),$}static read(y,M){return new r(y,M)}get buffer(){return this._buff}constructor(y,M){this._buff=y,this._offset=M}static sizeUInt8(){return 1}writeUInt8(y){this._buff.writeUInt8(y,this._offset),this._offset+=1}readUInt8(){const y=this._buff.readUInt8(this._offset);return this._offset+=1,y}writeUInt32(y){this._buff.writeUInt32BE(y,this._offset),this._offset+=4}readUInt32(){const y=this._buff.readUInt32BE(this._offset);return this._offset+=4,y}static sizeShortString(y){return 1+y.byteLength}writeShortString(y){this._buff.writeUInt8(y.byteLength,this._offset),this._offset+=1,this._buff.set(y,this._offset),this._offset+=y.byteLength}readShortString(){const y=this._buff.readUInt8(this._offset);this._offset+=1;const j=this._buff.slice(this._offset,this._offset+y).toString();return this._offset+=y,j}static sizeLongString(y){return 4+y.byteLength}writeLongString(y){this._buff.writeUInt32BE(y.byteLength,this._offset),this._offset+=4,this._buff.set(y,this._offset),this._offset+=y.byteLength}readLongString(){const y=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+y).toString();return this._offset+=y,j}writeBuffer(y){this._buff.writeUInt32BE(y.byteLength,this._offset),this._offset+=4,this._buff.set(y,this._offset),this._offset+=y.byteLength}static sizeVSBuffer(y){return 4+y.byteLength}writeVSBuffer(y){this._buff.writeUInt32BE(y.byteLength,this._offset),this._offset+=4,this._buff.set(y,this._offset),this._offset+=y.byteLength}readVSBuffer(){const y=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+y);return this._offset+=y,M}static sizeMixedArray(y){let M=0;M+=1;for(let j=0,$=y.length;j<$;j++){const N=y[j];switch(M+=1,N.type){case 1:M+=this.sizeLongString(N.value);break;case 2:M+=this.sizeVSBuffer(N.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(N.value);for(let x=0;x<N.buffers.length;++x)M+=this.sizeVSBuffer(N.buffers[x]);break;case 4:break}}return M}writeMixedArray(y){this._buff.writeUInt8(y.length,this._offset),this._offset+=1;for(let M=0,j=y.length;M<j;M++){const $=y[M];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt32($.buffers.length),this.writeLongString($.value);for(let N=0;N<$.buffers.length;++N)this.writeBuffer($.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const y=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(y);for(let j=0;j<y;j++)switch(this.readUInt8()){case 1:M[j]=this.readLongString();break;case 2:M[j]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),x=this.readLongString(),L=[];for(let F=0;F<N;++F)L.push(this.readVSBuffer());M[j]=new R.SerializableObjectWithBuffers(h(x,L,null));break}case 4:M[j]=void 0;break}return M}}r.sizeUInt32=4;var m;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(m||(m={}));class n{static _useMixedArgSerialization(y){for(let M=0,j=y.length;M<j;M++)if(y[M]instanceof P.VSBuffer||y[M]instanceof R.SerializableObjectWithBuffers||typeof y[M]>"u")return!0;return!1}static serializeRequestArguments(y,M){if(this._useMixedArgSerialization(y)){const j=[];for(let $=0,N=y.length;$<N;$++){const x=y[$];if(x instanceof P.VSBuffer)j[$]={type:2,value:x};else if(typeof x>"u")j[$]={type:4};else if(x instanceof R.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:F}=d(x.value,M);j[$]={type:3,value:P.VSBuffer.fromString(L),buffers:F}}else j[$]={type:1,value:P.VSBuffer.fromString(g(x,M))}}return{type:1,args:j}}return{type:0,args:g(y,M)}}static serializeRequest(y,M,j,$,N){switch($.type){case 0:return this._requestJSONArgs(y,M,j,$.args,N);case 1:return this._requestMixedArgs(y,M,j,$.args,N)}}static _requestJSONArgs(y,M,j,$,N){const x=P.VSBuffer.fromString(j),L=P.VSBuffer.fromString($);let F=0;F+=r.sizeUInt8(),F+=r.sizeShortString(x),F+=r.sizeLongString(L);const U=r.alloc(N?2:1,y,F);return U.writeUInt8(M),U.writeShortString(x),U.writeLongString(L),U.buffer}static deserializeRequestJSONArgs(y){const M=y.readUInt8(),j=y.readShortString(),$=y.readLongString();return{rpcId:M,method:j,args:JSON.parse($)}}static _requestMixedArgs(y,M,j,$,N){const x=P.VSBuffer.fromString(j);let L=0;L+=r.sizeUInt8(),L+=r.sizeShortString(x),L+=r.sizeMixedArray($);const F=r.alloc(N?4:3,y,L);return F.writeUInt8(M),F.writeShortString(x),F.writeMixedArray($),F.buffer}static deserializeRequestMixedArgs(y){const M=y.readUInt8(),j=y.readShortString(),$=y.readMixedArray(),N=new Array($.length);for(let x=0,L=$.length;x<L;x++){const F=$[x];typeof F=="string"?N[x]=JSON.parse(F):N[x]=F}return{rpcId:M,method:j,args:N}}static serializeAcknowledged(y){return r.alloc(5,y,0).buffer}static serializeCancel(y){return r.alloc(6,y,0).buffer}static serializeReplyOK(y,M,j){if(typeof M>"u")return this._serializeReplyOKEmpty(y);if(M instanceof P.VSBuffer)return this._serializeReplyOKVSBuffer(y,M);if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:N}=d(M.value,j,!0);return this._serializeReplyOKJSONWithBuffers(y,$,N)}else return this._serializeReplyOKJSON(y,b(M,j))}static _serializeReplyOKEmpty(y){return r.alloc(7,y,0).buffer}static _serializeReplyOKVSBuffer(y,M){let j=0;j+=r.sizeVSBuffer(M);const $=r.alloc(8,y,j);return $.writeVSBuffer(M),$.buffer}static deserializeReplyOKVSBuffer(y){return y.readVSBuffer()}static _serializeReplyOKJSON(y,M){const j=P.VSBuffer.fromString(M);let $=0;$+=r.sizeLongString(j);const N=r.alloc(9,y,$);return N.writeLongString(j),N.buffer}static _serializeReplyOKJSONWithBuffers(y,M,j){const $=P.VSBuffer.fromString(M);let N=0;N+=r.sizeUInt32,N+=r.sizeLongString($);for(const L of j)N+=r.sizeVSBuffer(L);const x=r.alloc(10,y,N);x.writeUInt32(j.length),x.writeLongString($);for(const L of j)x.writeBuffer(L);return x.buffer}static deserializeReplyOKJSON(y){const M=y.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(y,M){const j=y.readUInt32(),$=y.readLongString(),N=[];for(let x=0;x<j;++x)N.push(y.readVSBuffer());return new R.SerializableObjectWithBuffers(h($,N,M))}static serializeReplyErr(y,M){const j=M?b(A.transformErrorForSerialization(M),null):void 0;if(typeof j!="string")return this._serializeReplyErrEmpty(y);const $=P.VSBuffer.fromString(j);let N=0;N+=r.sizeLongString($);const x=r.alloc(11,y,N);return x.writeLongString($),x.buffer}static deserializeReplyErrError(y){const M=y.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(y){return r.alloc(12,y,0).buffer}}var t;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(t||(t={}));var c;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(c||(c={}))}),define(_e[292],ye([1,0,3,39,54,4]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new u.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new u.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new u.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var _;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(_=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.channels=new Map,this._onDidRegisterChannel=new a.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new a.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(D){this.channels.has(D.id)||(this.channels.set(D.id,D),this._onDidRegisterChannel.fire(D.id))}getChannels(){const D=[];return this.channels.forEach(R=>D.push(R)),D}getChannel(D){return this.channels.get(D)}removeChannel(D){this.channels.delete(D),this._onDidRemoveChannel.fire(D)}}P.Registry.add(e.Extensions.OutputChannels,new T),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new u.RawContextKey("activeOutputChannel","")}),define(_e[142],ye([1,0,5,4,20,26,13,292,78,25,48,158,22,9,44,3,6]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends _.AbstractMessageLogger{get disposed(){return this._disposed}constructor(p,i,o,s,l){super(),this.id=p,this.name=i,this.logger=o,this.proxy=s,this.extension=l,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(o.getLevel()),this._register(o.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,p)}replace(p){const i=this.offset;this.info(p),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,i),this.visible&&this.logger.flush()}show(p,i){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:i))}hide(){this.proxy.$close(this.id)}log(p,i){this.offset+=b.VSBuffer.fromString(i).byteLength,(0,_.log)(this.logger,p,i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class g extends h{appendLine(p){this.append(p)}}let v=class{constructor(p,i,o,s,l,r){this.initData=i,this.extHostFileSystem=o,this.extHostFileSystemInfo=s,this.loggerService=l,this.logService=r,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(i.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[i,o]of this.channels)o.visible=i===this.visibleChannelId}createOutputChannel(p,i,o){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const s=typeof i=="object"&&i.log,l=(0,k.isString)(i)?i:void 0;if((0,k.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const m=this.initData.environment.extensionLogLevel?.find(([t])=>A.ExtensionIdentifier.equals(o.identifier,t))?.[1];m&&(r=(0,_.parseLogLevel)(m));const n=s?this.doCreateLogOutputChannel(p,r,o):this.doCreateOutputChannel(p,l,o);return n.then(t=>{this.channels.set(t.id,t),t.visible=t.id===this.visibleChannelId}),s?this.createExtHostLogOutputChannel(p,r??this.logService.getLevel(),n):this.createExtHostOutputChannel(p,n)}async doCreateOutputChannel(p,i,o){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const s=await this.outputDirectoryPromise,l=this.extHostFileSystemInfo.extUri.joinPath(s,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.proxy.$register(p,l,i,o.identifier.value);return new h(m,p,r,this.proxy,o)}async doCreateLogOutputChannel(p,i,o){const s=await this.createExtensionLogDirectory(o),l=this.extHostFileSystemInfo.extUri.joinPath(s,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=l.toString(),m=this.loggerService.createLogger(l,{id:r,name:p,logLevel:i,extensionId:o.identifier.value});return new g(r,p,m,this.proxy,o)}createExtensionLogDirectory(p){let i=this.extensionLogDirectoryPromise.get(p.identifier.value);if(!i){const o=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,p.identifier.value);this.extensionLogDirectoryPromise.set(p.identifier.value,i=(async()=>{try{await this.extHostFileSystem.value.createDirectory(o)}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return i}createExtHostOutputChannel(p,i){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return p},append(l){s(),i.then(r=>r.append(l))},appendLine(l){s(),i.then(r=>r.appendLine(l))},clear(){s(),i.then(l=>l.clear())},replace(l){s(),i.then(r=>r.replace(l))},show(l,r){s(),i.then(m=>m.show(l,r))},hide(){s(),i.then(l=>l.hide())},dispose(){o=!0,i.then(l=>l.dispose())}}}createExtHostLogOutputChannel(p,i,o){const s=new d.DisposableStore,l=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},r=s.add(new f.Emitter);function m(n){i=n,r.fire(n)}return o.then(n=>{s.add(n),n.logLevel!==i&&m(n.logLevel),s.add(n.onDidChangeLogLevel(t=>m(t)))}),{...this.createExtHostOutputChannel(p,o),get logLevel(){return i},onDidChangeLogLevel:r.event,trace(n,...t){l(),o.then(c=>c.trace(n,...t))},debug(n,...t){l(),o.then(c=>c.debug(n,...t))},info(n,...t){l(),o.then(c=>c.info(n,...t))},warn(n,...t){l(),o.then(c=>c.warn(n,...t))},error(n,...t){l(),o.then(c=>c.error(n,...t))},dispose(){s.dispose()}}}};v=Ve([We(0,u.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,S.IExtHostConsumerFileSystem),We(3,R.IExtHostFileSystemInfo),We(4,_.ILoggerService),We(5,_.ILogService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=(0,P.createDecorator)("IExtHostOutputService")}),define(_e[293],ye([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(_e[294],ye([1,0,34,14,10,12,24,2,4,219,47,237,293]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let k=class cn{constructor(f,d,h,g){this.localUserHome=f,this.remoteAgentService=d,this.environmentService=h,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const v=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=v?.userHome??f})()}hasValidBasename(f,d,h){return typeof d=="string"||typeof d>"u"?this.resolveOS.then(g=>this.doHasValidBasename(f,g,d)):this.doHasValidBasename(f,d,h)}doHasValidBasename(f,d,h){return f.scheme===P.Schemas.file||f.scheme===P.Schemas.vscodeRemote?(0,a.isValidBasename)(h??(0,_.basename)(f),d===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,d){if(f.remoteAuthority)return P.Schemas.vscodeRemote;const h=(0,D.getVirtualWorkspaceScheme)(d.getWorkspace());if(h)return h;const g=d.getWorkspace().folders[0];if(g)return g.uri.scheme;const v=d.getWorkspace().configuration;return v?v.scheme:P.Schemas.file}userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?u.win32:u.posix)}async fileURI(f){let d="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const g=f.indexOf("/",2);g===-1?(d=f.substring(2),f="/"):(d=f.substring(2,g),f=f.substring(g)||"/")}return T.URI.from({scheme:P.Schemas.file,authority:d,path:f,query:"",fragment:""})}};k=Ve([We(1,b.IRemoteAgentService),We(2,I.IWorkbenchEnvironmentService),We(3,R.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(_e[81],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(_,T){this.line=_,this.character=T}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,T){return new a(0,0)}with(_){return new a(0,0)}}e.Position=a;class P{constructor(_,T,S,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(_,T),this.end=new a(S,D)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new P(0,0,0,0)}with(_){return new P(0,0,0,0)}}e.Range=P;var u;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(u=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(_e[31],ye([1,0,16,38,23,34,8,4,10,11,81,19]),function(ie,e,a,P,u,A,_,T,S,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const b="\u27EA ",k=" characters skipped \u27EB",w=(b.length+k.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var f;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function h(X){return!!X.preview}e.resultIsMatch=h;function g(X){return!!X.resource}e.isFileMatch=g;function v(X){return!!X.message}e.isProgressMessage=v;var C;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(C=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(Z){this.resource=Z,this.results=[]}}e.FileMatch=p;class i{constructor(Z,te,K){this.ranges=te;const J=Array.isArray(te)?te:[te];if(K&&K.matchLines===1&&o(J)){Z=(0,_.getNLines)(Z,K.matchLines);let ne="",pe=0,be=0;const Ie=Math.floor(K.charsPerLine/5),Le=[];for(const oe of J){const ae=Math.max(oe.startColumn-Ie,0),fe=oe.startColumn+K.charsPerLine;if(ae>be+Ie+w){const ee=b+(ae-be)+k;ne+=ee+Z.slice(ae,fe),pe+=ae-(be+ee.length)}else ne+=Z.slice(be,fe);Le.push(new l(0,oe.startColumn-pe,oe.endColumn-pe)),be=fe}this.preview={text:ne,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const ne=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:Z,matches:(0,a.mapArrayOrNot)(te,pe=>new s(pe.startLineNumber-ne,pe.startColumn,pe.endLineNumber-ne,pe.endColumn))}}}}e.TextSearchMatch=i;function o(X){const Z=X[0].startLineNumber;for(const te of X)if(te.startLineNumber!==Z||te.endLineNumber!==Z)return!1;return!0}class s{constructor(Z,te,K,J){this.startLineNumber=Z,this.startColumn=te,this.endLineNumber=K,this.endColumn=J}}e.SearchRange=s;class l extends s{constructor(Z,te,K){super(Z,te,Z,K)}}e.OneLineRange=l;var r;(function(X){X.List="list",X.Tree="tree"})(r=e.ViewMode||(e.ViewMode={}));var m;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function n(X,Z=!0){const te=X&&X.files&&X.files.exclude,K=Z&&X&&X.search&&X.search.exclude;if(!te&&!K)return;if(!te||!K)return te||K;let J=Object.create(null);return J=u.mixin(J,u.deepClone(te)),J=u.mixin(J,u.deepClone(K),!0),J}e.getExcludes=n;function t(X,Z){return X.excludePattern&&P.match(X.excludePattern,Z)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&P.match(X.includePattern,Z)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(te=>{const K=te.folder.fsPath;if(A.isEqualOrParent(Z,K)){const J=S.relative(K,Z);return!te.includePattern||!!P.match(te.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=t;var c;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(c=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(Z,te){super(Z),this.code=te}}e.SearchError=E;function y(X){const Z=X.message;if((0,D.isCancellationError)(X))return new E(Z,c.canceled);try{const te=JSON.parse(Z);return new E(te.message,te.code)}catch{return new E(Z,c.other)}}e.deserializeSearchError=y;function M(X){const Z={message:X.message,code:X.code};return new Error(JSON.stringify(Z))}e.serializeSearchError=M;function j(X){return X.type==="error"?!0:X.type==="success"}e.isSerializedSearchComplete=j;function $(X){return X.type==="success"}e.isSerializedSearchSuccess=$;function N(X){return!!X.path}e.isSerializedFileMatch=N;function x(X,Z){const te=X.searchPath?X.searchPath:X.relativePath;return(0,_.fuzzyContains)(te,Z)}e.isFilePatternMatch=x;class L{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function F(X,Z){const te={...X||{},...Z||{}};return Object.keys(te).filter(K=>{const J=te[K];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=F;class U{constructor(Z,te){this._parsedIncludeExpression=null,this._excludeExpression={...Z.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=P.parse(this._excludeExpression);let K=Z.includePattern;te.includePattern&&(K?K={...K,...te.includePattern}:K=te.includePattern),K&&(this._parsedIncludeExpression=P.parse(K))}matchesExcludesSync(Z,te,K){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Z,te,K))}includedInQuerySync(Z,te,K){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Z,te,K)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Z,te,K))}includedInQuery(Z,te,K){const J=this._parsedExcludeExpression(Z,te,K),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Z,te,K):!0;return(0,I.isThenable)(J)?J.then(pe=>pe?!1:ne()):ne()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=U;function H(X){for(const Z in X)if(typeof X[Z]!="boolean")return!0;return!1}function de(X){if(!X)return;let Z;return te=>(Z||(Z=(X()||Promise.resolve([])).then(K=>K?V(K):{})),Z.then(K=>!!K[te]))}e.hasSiblingPromiseFn=de;function Y(X){if(!X)return;let Z;return te=>{if(!Z){const K=X();Z=K?V(K):{}}return!!Z[te]}}e.hasSiblingFn=Y;function V(X){const Z={};for(const te of X)Z[te]=!0;return Z}}),define(_e[35],ye([1,0,16,19,21,3,6,68,14,102,24,8,9,2,184,4,13,207,47,48,25,20,15,7,56,31,5]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C,p,i,o,s,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function m($,N,x){return new R.ExtUri(L=>E(L,x)).isEqual($,N)}function n($,N,x){return m($.uri,N.uri,x)?0:(0,I.compare)($.uri.toString(),N.uri.toString())}function t($,N,x){return $.index!==N.index?$.index<N.index?-1:1:m($.uri,N.uri,x)?(0,I.compare)($.name,N.name):(0,I.compare)($.uri.toString(),N.uri.toString())}function c($,N,x,L){const F=$.slice(0).sort((H,de)=>x(H,de,L)),U=N.slice(0).sort((H,de)=>x(H,de,L));return(0,a.delta)(F,U,(H,de)=>x(H,de,L))}function E($,N){const x=N.getCapabilities($.scheme);return!(x&&x&1024)}class y extends g.Workspace{static toExtHostWorkspace(N,x,L,F){if(!N)return{workspace:null,added:[],removed:[]};const{id:U,name:H,folders:de,configuration:Y,transient:V,isUntitled:X}=N,Z=[],te=x;x?de.forEach((pe,be)=>{const Ie=k.URI.revive(pe.uri),Le=y._findFolder(L||x,Ie,F);Le?(Le.name=pe.name,Le.index=pe.index,Z.push(Le)):Z.push({uri:Ie,name:pe.name,index:be})}):Z.push(...de.map(({uri:pe,name:be,index:Ie})=>({uri:k.URI.revive(pe),name:be,index:Ie}))),Z.sort((pe,be)=>pe.index<be.index?-1:1);const K=new y(U,H,Z,!!V,Y?k.URI.revive(Y):null,!!X,pe=>E(pe,F)),{added:J,removed:ne}=c(te?te.workspaceFolders:[],K.workspaceFolders,n,F);return{workspace:K,added:J,removed:ne}}static _findFolder(N,x,L){for(let F=0;F<N.folders.length;F++){const U=N.workspaceFolders[F];if(m(U.uri,x,L))return U}}constructor(N,x,L,F,U,H,de){super(N,L.map(Y=>new g.WorkspaceFolder(Y)),F,U,de),this._name=x,this._isUntitled=H,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(de),L.forEach(Y=>{this._workspaceFolders.push(Y),this._structure.set(Y.uri,Y)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,x){return x&&this._structure.get(N)&&(N=(0,R.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let M=class{constructor(N,x,L,F,U){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._logService=F,this._extHostFileSystemInfo=L,this._uriTransformerService=U,this._requestIdProvider=new D.Counter,this._barrier=new P.Barrier,this._proxy=N.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(r.MainContext.MainThreadMessageService);const H=x.workspace;this._confirmedWorkspace=H?new y(H.id,H.name,[],!!H.transient,H.configuration?k.URI.revive(H.configuration):null,!!H.isUntitled,de=>E(de,L)):void 0}$initializeWorkspace(N,x){this._trusted=x,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?k.URI.from({scheme:S.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,x,L,...F){const U=[];if(Array.isArray(F)&&F.forEach(X=>{k.URI.isUri(X.uri)&&!U.some(Z=>m(Z.uri,X.uri,this._extHostFileSystemInfo))&&U.push({uri:X.uri,name:X.name||(0,R.basenameOrAuthority)(X.uri)})}),this._unconfirmedWorkspace||[x,L].some(X=>typeof X!="number"||X<0)||L===0&&U.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+L>H.length)return!1;const de=H.slice(0);de.splice(x,L,...U.map(X=>({uri:X.uri,name:X.name||(0,R.basenameOrAuthority)(X.uri),index:void 0})));for(let X=0;X<de.length;X++){const Z=de[X];if(de.some((te,K)=>K!==X&&m(Z.uri,te.uri,this._extHostFileSystemInfo)))return!1}de.forEach((X,Z)=>X.index=Z);const{added:Y,removed:V}=c(H,de,t,this._extHostFileSystemInfo);if(Y.length===0&&V.length===0)return!1;if(this._proxy){const X=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(X,x,L,U).then(void 0,Z=>{this._unconfirmedWorkspace=void 0;const te={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(h.Severity.Error,(0,w.localize)(0,null,X,Z.toString()),te,[])})}return this.trySetWorkspaceFolders(de),!0}getWorkspaceFolder(N,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,x)}async getWorkspaceFolder2(N,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,x)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,x){let L,F="";if(typeof N=="string"?(L=k.URI.file(N),F=N):typeof N<"u"&&(L=N,F=N.fsPath),!L)return F;const U=this.getWorkspaceFolder(L,!0);if(!U)return F;typeof x>"u"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let H=(0,R.relativePath)(U.uri,L);return x&&U.name&&(H=`${U.name}/${H}`),H}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=y.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:x,added:L,removed:F}=y.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:F}))}findFiles(N,x,L,F,U=u.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let H;if(x===null?H=!1:x&&(typeof x=="string"?H=x:H=x.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:Y}=j(i.GlobPattern.from(N));return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(de),(0,b.withUndefinedAsNull)(Y),(0,b.withUndefinedAsNull)(H),(0,b.withUndefinedAsNull)(L),U).then(V=>Array.isArray(V)?V.map(X=>k.URI.revive(X)):[])}async findTextInFiles(N,x,L,F,U=u.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),de=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:Y,folder:V}=j(i.GlobPattern.from(x.include)),X=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,Z={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:de,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:Y,excludePattern:X},te=!1;if(this._activeSearchCallbacks[H]=K=>{if(te)return;const J=k.URI.revive(K.resource);K.results.forEach(ne=>{(0,l.resultIsMatch)(ne)?L({uri:J,preview:{text:ne.preview.text,matches:(0,a.mapArrayOrNot)(ne.preview.matches,pe=>new o.Range(pe.startLineNumber,pe.startColumn,pe.endLineNumber,pe.endColumn))},ranges:(0,a.mapArrayOrNot)(ne.ranges,pe=>new o.Range(pe.startLineNumber,pe.startColumn,pe.endLineNumber,pe.endColumn))}):L({uri:J,text:ne.text,lineNumber:ne.lineNumber})})},U.isCancellationRequested)return{};try{const K=await this._proxy.$startTextSearch(N,(0,b.withUndefinedAsNull)(V),Z,H,U);return delete this._activeSearchCallbacks[H],K||{}}catch(K){throw delete this._activeSearchCallbacks[H],K}}$handleTextSearchResult(N,x){this._activeSearchCallbacks[x]?.(N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(N,x){if(this._editSessionIdentityProviders.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this._editSessionIdentityProviders.set(N,x);const L=this._uriTransformerService.transformOutgoingScheme(N),F=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(F,L),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(N),this._proxy.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(N,x){this._logService.info("Getting edit session identifier for workspaceFolder",N);const L=await this.resolveWorkspaceFolder(k.URI.revive(N));if(!L){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const F=this._editSessionIdentityProviders.get(L.uri.scheme);if(this._logService.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!F),!F)return;const U=await F.provideEditSessionIdentity(L,x);if(this._logService.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(N,x,L,F){this._logService.info("Getting edit session identifier for workspaceFolder",N);const U=await this.resolveWorkspaceFolder(k.URI.revive(N));if(!U){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const H=this._editSessionIdentityProviders.get(U.uri.scheme);if(this._logService.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!H),!H)return;const de=await H.provideEditSessionIdentityMatch?.(x,L,F);if(this._logService.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(N){return(x,L,F)=>{const U=function(de){x.call(L,de)};return U.extension=N,this._onWillCreateEditSessionIdentityEvent.event(U,void 0,F)}}async $onWillCreateEditSessionIdentity(N,x,L){const F=await this.resolveWorkspaceFolder(k.URI.revive(N));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:F},x,async(U,H)=>{const de=Date.now();await Promise.resolve(U),Date.now()-de>L&&this._logService.warn("SLOW edit session create-participant",H.extension.identifier)}),x.isCancellationRequested}};M=Ve([We(0,p.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,v.IExtHostFileSystemInfo),We(3,d.ILogService),We(4,s.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function j($){let N,x;return $&&(typeof $=="string"?N=$:(N=$.pattern,x=k.URI.revive($.baseUri))),{includePattern:N,folder:x}}}),define(_e[36],ye([1,0,23,3,35,5,7,210,127,9,19,4,20,13,2]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(o,s){if(s){const l=s.split(".");let r=o;for(let m=0;r&&m<l.length;m++)r=r[l[m]];return r}}function d(o){return o instanceof w.URI}function h(o){return o&&o.uri instanceof w.URI&&o.languageId&&typeof o.languageId=="string"}function g(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function v(o){return o&&o.uri instanceof w.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function C(o){if(d(o))return{resource:o};if(h(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(g(o))return{overrideIdentifier:o.languageId};if(v(o))return{resource:o.uri};if(o===null)return{resource:null}}let p=class{constructor(s,l,r){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=r,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new i(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,l){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,l))}};p=Ve([We(0,b.IExtHostRpcService),We(1,u.IExtHostWorkspace),We(2,k.ILogService)],p),e.ExtHostConfiguration=p;class i{constructor(s,l,r,m){this._onDidChangeConfiguration=new P.Emitter,this._proxy=s,this._logService=m,this._extHostWorkspace=l,this._configuration=T.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,l){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,r))}getConfiguration(s,l,r){const m=C(l)||{},n=this._toReadonlyValue(s?f(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,m,r?.identifier);function t(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const c={has(E){return typeof f(n,E)<"u"},get:(E,y)=>{this._validateConfigurationAccess(s?`${s}.${E}`:E,m,r?.identifier);let M=f(n,E);if(typeof M>"u")M=y;else{let j;const $=(N,x)=>{let L;const F=()=>{j=j||(0,a.deepClone)(n),L=L||f(j,x)};return(0,D.isObject)(N)?new Proxy(N,{get:(U,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return F(),()=>L;if(j)return L=L||f(j,x),L[H];const de=U[H];return typeof H=="string"?$(de,`${x}.${H}`):de},set:(U,H,de)=>(F(),L&&(L[H]=de),!0),deleteProperty:(U,H)=>(F(),L&&delete L[H],!0),defineProperty:(U,H,de)=>(F(),L&&Object.defineProperty(L,H,de),!0)}):N};M=$(M,E)}return M},update:(E,y,M,j)=>{E=s?`${s}.${E}`:E;const $=t(M);return y!==void 0?this._proxy.$updateConfigurationOption($,E,y,m,j):this._proxy.$removeConfigurationOption($,E,m,j)},inspect:E=>{E=s?`${s}.${E}`:E;const y=this._configuration.inspect(E,m,this._extHostWorkspace.workspace);if(y)return{key:E,defaultValue:(0,a.deepClone)(y.policy?.value??y.default?.value),globalValue:(0,a.deepClone)(y.user?.value??y.application?.value),workspaceValue:(0,a.deepClone)(y.workspace?.value),workspaceFolderValue:(0,a.deepClone)(y.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(y.default?.override),globalLanguageValue:(0,a.deepClone)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,a.deepClone)(y.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(y.workspaceFolder?.override),languageIds:(0,a.deepClone)(y.overrideIdentifiers)}}};return typeof n=="object"&&(0,a.mixin)(c,n,!1),Object.freeze(c)}_toReadonlyValue(s){const l=r=>(0,D.isObject)(r)?new Proxy(r,{get:(m,n)=>l(m[n]),set:(m,n,t)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(m,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(m,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return l(s)}_validateConfigurationAccess(s,l,r){const m=S.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),n=r?`[${r.value}] `:"";if(m===4){typeof l?.resource>"u"&&this._logService.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){l?.resource&&this._logService.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,l){const r=new T.ConfigurationChangeEvent(s,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,n)=>r.affectsConfiguration(m,C(n))})}_toMap(s){return s.reduce((l,r)=>(l.set(r[0],r[1]),l),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[82],ye([1,0,2,19,3,5,7,35,59,36,21,41,20,25,4,14,12,13,77,248,11]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(N){function x(F){if(F!=null)return F}N.from=x;function L(F){if(F!=null)return F}N.to=L})(i||(i={}));var o;(function(N){function x(F){if(F!=null)return F}N.from=x;function L(F){if(F!=null)return F}N.to=L})(o||(o={}));var s;(function(N){function x(F){if(F!=null)return F}N.from=x;function L(F){if(F!=null)return F}N.to=L})(s||(s={}));var l;(function(N){function x(U){if(U){const H=U;return H&&!!H.process}else return!1}N.is=x;function L(U){if(U==null)return;const H={process:U.process,args:U.args};return U.options&&(H.options=s.from(U.options)),H}N.from=L;function F(U){if(U!=null)return new _.ProcessExecution(U.process,U.args,U.options)}N.to=F})(l||(l={}));var r;(function(N){function x(F){if(F!=null)return F}N.from=x;function L(F){if(F!=null)return F}N.to=L})(r||(r={}));var m;(function(N){function x(U){if(U){const H=U;return H&&(!!H.commandLine||!!H.command)}else return!1}N.is=x;function L(U){if(U==null)return;const H={};return U.commandLine!==void 0?H.commandLine=U.commandLine:(H.command=U.command,H.args=U.args),U.options&&(H.options=r.from(U.options)),H}N.from=L;function F(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new _.ShellExecution(U.commandLine,U.options):new _.ShellExecution(U.command,U.args?U.args:[],U.options)}N.to=F})(m||(m={}));var n;(function(N){function x(U){if(U){const H=U;return H&&H.customExecution==="customExecution"}else return!1}N.is=x;function L(U){return{customExecution:"customExecution"}}N.from=L;function F(U,H){return H.get(U)}N.to=F})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var t;(function(N){function x(L,F){let U;return L.scope!==void 0&&typeof L.scope!="number"?U=L.scope.uri:L.scope!==void 0&&typeof L.scope=="number"&&(L.scope===_.TaskScope.Workspace&&F&&F.workspaceFile?U=F.workspaceFile:U=v.USER_TASKS_GROUP_KEY),{id:L._id,workspaceFolder:U}}N.from=x})(t=e.TaskHandleDTO||(e.TaskHandleDTO={}));var c;(function(N){function x(L){if(L!=null)return{_id:L.id,isDefault:L.isDefault}}N.from=x})(c||(c={}));var E;(function(N){function x(U,H){if(U==null)return[];const de=[];for(const Y of U){const V=L(Y,H);V&&de.push(V)}return de}N.fromMany=x;function L(U,H){if(U==null)return;let de;U.execution instanceof _.ProcessExecution?de=l.from(U.execution):U.execution instanceof _.ShellExecution?de=m.from(U.execution):U.execution&&U.execution instanceof _.CustomExecution&&(de=n.from(U.execution));const Y=i.from(U.definition);let V;return U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=_.TaskScope.Workspace,!Y||!V?void 0:{_id:U._id,definition:Y,name:U.name,source:{extensionId:H.identifier.value,label:U.source,scope:V},execution:de,isBackground:U.isBackground,group:c.from(U.group),presentationOptions:o.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}N.from=L;async function F(U,H,de){if(U==null)return;let Y;l.is(U.execution)?Y=l.to(U.execution):m.is(U.execution)?Y=m.to(U.execution):n.is(U.execution)&&(Y=n.to(U._id,de));const V=i.to(U.definition);let X;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?X=U.source.scope:X=await H.resolveWorkspaceFolder(a.URI.revive(U.source.scope)):X=_.TaskScope.Workspace),!V||!X)return;const Z=new _.Task(V,X,U.name,U.source.label,Y,U.problemMatchers);return U.isBackground!==void 0&&(Z.isBackground=U.isBackground),U.group!==void 0&&(Z.group=_.TaskGroup.from(U.group._id),Z.group&&U.group.isDefault&&(Z.group=new _.TaskGroup(Z.group.id,Z.group.label),U.group.isDefault===!0&&(Z.group.isDefault=U.group.isDefault))),U.presentationOptions&&(Z.presentationOptions=o.to(U.presentationOptions)),U._id&&(Z._id=U._id),U.detail&&(Z.detail=U.detail),Z}N.to=F})(E=e.TaskDTO||(e.TaskDTO={}));var y;(function(N){function x(F){return F}N.from=x;function L(F){if(!!F)return Object.assign(Object.create(null),F)}N.to=L})(y||(y={}));class M{constructor(x,L,F){this._id=L,this._task=F,p.set(this,void 0),Je(this,p,x,"f")}get task(){return this._task}terminate(){Ue(this,p,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}p=new WeakMap;let j=class{constructor(x,L,F,U,H,de,Y,V){this._onDidExecuteTask=new u.Emitter,this._onDidTerminateTask=new u.Emitter,this._onDidTaskProcessStarted=new u.Emitter,this._onDidTaskProcessEnded=new u.Emitter,this._proxy=x.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=U,this._configurationService=H,this._terminalService=de,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Y,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,L,F){if(!F)return new _.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:L,provider:F,extension:x}),this._proxy.$registerTaskProvider(U,L),new _.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(x,L){this._proxy.$registerTaskSystem(x,L)}fetchTasks(x){return this._proxy.$fetchTasks(y.from(x)).then(async L=>{const F=[];for(const U of L){const H=await E.to(U,this._workspaceProvider,this._providedCustomExecutions2);H&&F.push(H)}return F})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(L=>x.push(L)),x}terminateTask(x){if(!(x instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,L,F){const U=this._providedCustomExecutions2.get(x.id);U&&(this._activeCustomExecutions2.set(x.id,U),this._terminalService.attachPtyToTerminal(L,await U.callback(F))),this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const L=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:L})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const L=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:L,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const L=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:L,exitCode:x.exitCode})}$provideTasks(x,L){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));const U=[],H=(0,P.asPromise)(()=>F.provider.provideTasks(R.CancellationToken.None)).then(de=>this.provideTasksInternal(L,U,F,de));return new Promise(de=>{H.then(Y=>{Promise.all(U).then(()=>{de(Y)})})})}async $resolveTask(x,L){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));if(L.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${L.definition.type}] cannot be resolved by provider of type [${F.type}].`);const U=await E.to(L,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const H=await F.provider.resolveTask(U,R.CancellationToken.None);if(!H)return;this.checkDeprecation(H,F);const de=E.from(H,F.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(de.execution)&&await this.addCustomExecution(de,H,!0),await this.resolveTaskInternal(de)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,L,F){const U=await this._proxy.$createTaskId(x);!F&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,L.execution)),this._providedCustomExecutions2.set(U,L.execution)}async getTaskExecution(x,L){if(typeof x=="string"){const H=this._taskExecutionPromises.get(x);if(!H)throw new C.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const F=this._taskExecutionPromises.get(x.id);if(F)return F;const U=new Promise((H,de)=>{function Y(V,X,Z){Z?H(new M(V,X.id,Z)):de("Unexpected: Task does not exist.")}L?Y(this,x,L):E.to(x.task,this._workspaceProvider,this._providedCustomExecutions2).then(V=>Y(this,x,V))});return this._taskExecutionPromises.set(x.id,U),U.then(H=>(this._taskExecutions.set(x.id,H),H),H=>Promise.reject(H))}checkDeprecation(x,L){x._deprecated&&this._deprecationService.report("Task.constructor",L.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));const F=this._notProvidedCustomExecutions.values();let U=F.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=F.next()}};j=Ve([We(0,b.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,h.ILogService),We(7,g.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let $=class extends j{constructor(x,L,F,U,H,de,Y,V){super(x,L,F,U,H,de,Y,V),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(x,L){if(!L.execution)throw new Error("Tasks to execute must include an execution");const F=E.from(L,x);if(F===void 0)throw new Error("Task is not valid");if(n.is(F.execution))await this.addCustomExecution(F,L,!1);else throw new C.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),L);return this._proxy.$executeTask(F).catch(H=>{throw new Error(H)}),U}provideTasksInternal(x,L,F,U){const H=[];if(U)for(const de of U){this.checkDeprecation(de,F),(!de.definition||!x[de.definition.type])&&this._logService.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=E.from(de,F.extension);Y&&n.is(Y.execution)?(H.push(Y),L.push(this.addCustomExecution(Y,de,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:F.extension}}async resolveTaskInternal(x){if(n.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,L){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,L,F){}};$=Ve([We(0,b.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,h.ILogService),We(7,g.IExtHostApiDeprecationService)],$),e.WorkerExtHostTask=$,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(_e[295],ye([1,0,10,21,45,38,24,43,31]),function(ie,e,a,P,u,A,_,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(b,k,w){this.config=b,this.provider=k,this.sessionToken=w,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=b.filePattern,this.includePattern=b.includePattern&&A.parse(b.includePattern),this.maxResults=b.maxResults||void 0,this.exists=b.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=b.excludePattern&&A.parse(b.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(b=>b.cancel()),this.activeCancellationTokens=new Set}search(b){const k=this.config.folderQueries||[];return new Promise((w,f)=>{const d=h=>{this.resultCount++,b(h)};if(this.isCanceled)return w({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(h=>{const g=h.toString(),v=a.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,v)||this.matchFile(d,{base:h,basename:v})}),Promise.all(k.map(h=>this.searchInFolder(h,d))).then(h=>{w({limitHit:this.isLimitHit,stats:h[0]||void 0})},h=>{f(new Error((0,u.toErrorMessage)(h)))})})}async searchInFolder(b,k){const w=new P.CancellationTokenSource,f=this.getSearchOptionsForFolder(b),d=this.initDirectoryTree(),h=new S.QueryGlobTester(this.config,b),g=!h.hasSiblingExcludeClauses();let v;try{this.activeCancellationTokens.add(w),v=T.StopWatch.create();const C=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,w.token),p=v.elapsed(),i=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(C&&C.forEach(o=>{const s=a.posix.relative(b.folder.path,o.path);if(g){const l=a.basename(o.path);this.matchFile(k,{base:b.folder,relativePath:s,basename:l});return}this.addDirectoryEntries(d,b.folder,s,k)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,h,k),{providerTime:p,postProcessTime:i.elapsed()})}finally{w.dispose(),this.activeCancellationTokens.delete(w)}}getSearchOptionsForFolder(b){const k=(0,S.resolvePatternsForProvider)(this.config.includePattern,b.includePattern),w=(0,S.resolvePatternsForProvider)(this.config.excludePattern,b.excludePattern);return{folder:b.folder,excludes:w,includes:k,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}addDirectoryEntries({pathToEntries:b},k,w,f){if(w===this.filePattern){const h=a.basename(this.filePattern);this.matchFile(f,{base:k,relativePath:this.filePattern,basename:h})}function d(h){const g=a.basename(h),v=a.dirname(h);let C=b[v];C||(C=b[v]=[],d(v)),C.push({base:k,relativePath:h,basename:g})}d(w)}matchDirectoryTree({rootEntries:b,pathToEntries:k},w,f){const d=this,h=this.filePattern;function g(v){const C=(0,S.hasSiblingFn)(()=>v.map(p=>p.basename));for(let p=0,i=v.length;p<i;p++){const o=v[p],{relativePath:s,basename:l}=o;if(w.matchesExcludesSync(s,l,h!==l?C:void 0))continue;const r=k[s];if(r)g(r);else{if(s===h)continue;d.matchFile(f,o)}if(d.isLimitHit)break}}g(b)}matchFile(b,k){(!this.includePattern||k.relativePath&&this.includePattern(k.relativePath,k.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||b(k))}}class R{constructor(){this.sessions=new Map}fileSearch(b,k,w,f){const d=this.getSessionTokenSource(b.cacheKey),h=new D(b,k,d&&d.token);let g=0;const v=C=>{g+=C.length,w(C.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(h,R.BATCH_SIZE,v,f).then(C=>({limitHit:C.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:C.stats}}))}clearCache(b){this.getSessionTokenSource(b)?.cancel()}getSessionTokenSource(b){if(!!b)return this.sessions.has(b)||this.sessions.set(b,new P.CancellationTokenSource),this.sessions.get(b)}rawMatchToSearchItem(b){return b.relativePath?{resource:_.joinPath(b.base,b.relativePath)}:{resource:b.base}}doSearch(b,k,w,f){f.onCancellationRequested(()=>{b.cancel()});const d=g=>{g&&(h.push(g),k>0&&h.length>=k&&(w(h),h=[]))};let h=[];return b.search(d).then(g=>(h.length&&w(h),g),g=>(h.length&&w(h),Promise.reject(g)))}}R.BATCH_SIZE=512,e.FileSearchManager=R}),define(_e[296],ye([1,0,16,61,38,113,28,14,10,24,8,9,2,166,196,53,13,47,133,294,31]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(c,E,y,M,j){this.configurationService=c,this.workspaceContextService=E,this.editorGroupsService=y,this.logService=M,this.pathService=j}text(c,E,y={}){c=this.getContentPattern(c,y);const M=this.configurationService.getValue(),j=E&&E.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(E?.map(h.toWorkspaceFolder),y),type:2,contentPattern:c,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:M.search.usePCRE2||j||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles}}getContentPattern(c,E){const y=this.configurationService.getValue();c.isRegExp&&(c.pattern=c.pattern.replace(/\r?\n/g,"\\n"));const M={...c,wordSeparators:y.editor.wordSeparators};return this.isCaseSensitive(c,E)&&(M.isCaseSensitive=!0),this.isMultiline(c)&&(M.isMultiline=!0),M}file(c,E={}){return{...this.commonQuery(c,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(c,E){return c?(c=Array.isArray(c)?c.map(r):r(c),E?this.parseSearchPaths(c):{pattern:o(...Array.isArray(c)?c:[c])}):{}}commonQuery(c=[],E={}){const y=this.handleIncludeExclude(E.includePattern,E.expandPatterns),M=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),j=c.length>1,$=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(L=>this.getFolderQueryForSearchPath(L,E,M)):c.map(L=>this.getFolderQueryForRoot(L,E,M,j))).filter(L=>!!L),N={_reason:E._reason,folderQueries:$,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:M.pattern,includePattern:y.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const L=a.coalesce(a.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(de=>de.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const F=L.filter(H=>(0,C.pathIncludedInQuery)(N,H.fsPath)),U=this.commonQueryFromFileList(F);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...N,...U}}const x=E.extraFileResources&&E.extraFileResources.filter(L=>(0,C.pathIncludedInQuery)(N,L.fsPath));return N.extraFileResources=x&&x.length?x:void 0,N}commonQueryFromFileList(c){const E=[],y=new _.ResourceMap,M={};let j=!1;return c.forEach($=>{if($.scheme===T.Schemas.walkThrough)return;if((0,D.isAbsolutePath)($)){const x=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:S.dirname($.fsPath)});let L=y.get(x);L||(j=!0,L={folder:x,includePattern:{}},E.push(L),y.set(x,L));const F=S.relative(x.fsPath,$.fsPath);(0,I.assertIsDefined)(L.includePattern)[F.replace(/\\/g,"/")]=!0}else $.fsPath&&(j=!0,M[$.fsPath]=!0)}),{folderQueries:E,includePattern:M,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}isCaseSensitive(c,E){if(E.isSmartCase){if(c.isRegExp){if(R.containsUppercaseCharacter(c.pattern,!0))return!0}else if(R.containsUppercaseCharacter(c.pattern))return!0}return!!c.isCaseSensitive}isMultiline(c){return c.isMultiline||c.isRegExp&&(0,k.isMultilineRegexSource)(c.pattern)||c.pattern.indexOf(`
`)>=0?!0:!!c.isMultiline}parseSearchPaths(c){const E=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),M=(Array.isArray(c)?c:s(c)).map(U=>{const H=this.pathService.resolvedUserHome;return H?(0,A.untildify)(U,H.scheme===T.Schemas.file?H.fsPath:H.path):U}),j=P.groupBy(M,U=>E(U)?"searchPaths":"exprSegments"),$=(j.exprSegments||[]).map(U=>R.rtrim(U,"/")).map(U=>R.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),l(U))),N={},x=this.expandSearchPathPatterns(j.searchPaths||[]);x&&x.length&&(N.searchPaths=x);const L=a.flatten($),F=o(...L);return F&&(N.pattern=F),N}getExcludesForFolder(c,E){return E.disregardExcludeSettings?void 0:(0,C.getExcludes)(c,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(c){if(!c||!c.length)return[];const E=c.flatMap(M=>{let{pathPortion:j,globPortion:$}=i(M);return $&&($=m($)),this.expandOneSearchPath(j).flatMap(x=>this.resolveOneSearchPathPattern(x,$))}),y=new Map;return E.forEach(M=>{const j=M.searchPath.toString(),$=y.get(j);$?M.pattern&&($.pattern=$.pattern||{},$.pattern[M.pattern]=!0):y.set(j,{searchPath:M.searchPath,pattern:M.pattern?o(M.pattern):void 0})}),Array.from(y.values())}expandOneSearchPath(c){if(S.isAbsolute(c)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==T.Schemas.file?[{searchPath:E[0].uri.with({path:c})}]:[{searchPath:b.URI.file(S.normalize(c))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(c=r(c),c.startsWith("../")||c===".."){const M=S.posix.resolve(E.path,c);return[{searchPath:E.with({path:M})}]}const y=m(c);return[{searchPath:E,pattern:y}]}else{if(c==="./"||c===".\\")return[];{const E=c.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(j=>{const $=E.match(new RegExp(`^${R.escapeRegExpCharacters(j.name)}(?:/(.*)|$)`));return $?{match:$,folder:j}:null}).filter(I.isDefined);if(M.length)return M.map(j=>{const $=j.match[1];return{searchPath:j.folder.uri,pattern:$&&m($)}});{const j=c.match(/\.[\/\\](.+)[\/\\]?/),$=j?j[1]:c,N=w.localize(0,null,$);throw new Error(N)}}}}resolveOneSearchPathPattern(c,E){const y=c.pattern&&E?`${c.pattern}/${E}`:c.pattern||E,M=[{searchPath:c.searchPath,pattern:y}];return y&&!y.endsWith("**")&&M.push({searchPath:c.searchPath,pattern:y+"/**"}),M}getFolderQueryForSearchPath(c,E,y){const M=this.getFolderQueryForRoot((0,h.toWorkspaceFolder)(c.searchPath),E,y,!1);return M?{...M,includePattern:c.pattern}:null}getFolderQueryForRoot(c,E,y,M){let j;const $=b.URI.isUri(c)?c:c.uri;if(y.searchPaths){const U=y.searchPaths.filter(H=>(0,D.isEqual)(H.searchPath,$))[0];if(U&&!U.pattern)return null;U&&(j=U.pattern)}const N=this.configurationService.getValue({resource:$}),L={...this.getExcludesForFolder(N,E)||{},...j||{}},F=b.URI.isUri(c)?(0,D.basename)(c):c.name;return{folder:$,folderName:M?F:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!N.search.followSymlinks}}};p=Ve([We(0,f.IConfigurationService),We(1,h.IWorkspaceContextService),We(2,g.IEditorGroupsService),We(3,d.ILogService),We(4,v.IPathService)],p),e.QueryBuilder=p;function i(t){const c=t.match(/[\*\{\}\(\)\[\]\?]/);if(c){const E=c.index,y=t.substr(0,E).match(/[/|\\][^/\\]*$/);if(y){let M=t.substr(0,y.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:t.substr((y.index||0)+1)}}}return{pathPortion:t}}function o(...t){return t.length?t.reduce((c,E)=>(c[E]=!0,c),Object.create(null)):void 0}function s(t){return u.splitGlobAware(t,",").map(c=>c.trim()).filter(c=>!!c.length)}function l(t){return[`**/${t}/**`,`**/${t}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function r(t){return t.replace(/\\/g,"/")}function m(t){return r(t).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(t,c){t=a.distinct(t,M=>M.toString());const E=[],y=c.getWorkspace();return t&&t.forEach(M=>{let j;if(c.getWorkbenchState()===2)j=(0,D.relativePath)(y.folders[0].uri,M),j&&j!=="."&&(j="./"+j);else{const $=c.getWorkspaceFolder(M);if($){const N=$.name;if(y.folders.filter(L=>L.name===N).length===1){const L=(0,D.relativePath)($.uri,M);L===""?j=`./${$.name}`:j=`./${$.name}/${L}`}else j=M.fsPath}}j&&E.push(j)}),E}e.resolveResourcesForSearchIncludes=n}),define(_e[297],ye([1,0,24,2,21,11,4,296,31,47]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function I(f,d){const h=d.activationEvents;if(!h)return Promise.resolve(void 0);const g=[],v=[];for(const l of h)if(/^workspaceContains:/.test(l)){const r=l.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||f.forceUsingSearch?v.push(r):g.push(r)}if(g.length===0&&v.length===0)return Promise.resolve(void 0);let C;const p=new Promise((l,r)=>{C=l}),i=l=>C({activationEvent:l}),o=Promise.all(g.map(l=>b(f,l,i))).then(()=>{}),s=k(f,d.identifier,v,i);return Promise.all([o,s]).then(()=>{C(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function b(f,d,h){for(const g of f.folders)if(await f.exists(a.joinPath(P.URI.revive(g),d))){h(`workspaceContains:${d}`);return}}async function k(f,d,h,g){if(h.length===0)return Promise.resolve(void 0);const v=new u.CancellationTokenSource,C=f.checkExists(f.folders,h,v.token),p=setTimeout(async()=>{v.cancel(),f.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},R);let i=!1;try{i=await C}catch(o){A.isCancellationError(o)||A.onUnexpectedError(o)}v.dispose(),clearTimeout(p),i&&g(`workspaceContains:${h.join(",")}`)}function w(f,d,h,g){const v=f.get(_.IInstantiationService),C=f.get(S.ISearchService),i=v.createInstance(T.QueryBuilder).file(d.map(o=>(0,D.toWorkspaceFolder)(P.URI.revive(o))),{_reason:"checkExists",includePattern:h,exists:!0});return C.fileSearch(i,g).then(o=>!!o.limitHit,o=>A.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=w});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,P,u){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!u:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?u.call(ie,a):u?u.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(ie):P?P.value:e.get(ie)};define(_e[42],ye([1,0,178,10,83,24,19,6,68,2,13,5,36,239,99,35,27,134,11,26,22,221,7,128,4,25,79,20,90,55,41,3,297,98,223,14,97,43]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C,p,i,o,s,l,r,m,n,t,c,E,y,M,j,$,N,x){"use strict";var L,F,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let H=class Fi extends T.Disposable{constructor(te,K,J,ne,pe,be,Ie,Le,oe,ae,fe){super(),this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=K,this._extHostContext=J,this._initData=Ie,this._extHostWorkspace=ne,this._extHostConfiguration=pe,this._logService=be,this._extHostTunnelService=oe,this._extHostTerminalService=ae,this._extHostLocalizationService=fe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new h.ExtensionDescriptionRegistry(this._initData.allExtensions);const ee=(0,d.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new h.ExtensionDescriptionRegistry(V(this._globalRegistry,ee)),this._storage=new w.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=Le,this._instaService=te.createChild(new n.ServiceCollection([w.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState])),this._activator=this._register(new k.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(le,re,O)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(le,g.transformErrorForSerialization(re),O)},actualActivateExtension:async(le,re)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(le,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(le,re),new k.HostExtension;const O=this._myRegistry.getExtensionDescription(le);return this._activateExtension(O,re)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),u.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){g.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch{}await Promise.all(te)}terminate(te,K=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(ne=>{this._logService.error(ne)}),this._extHostContext.dispose();const J=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),J]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`):this._logService.info(`Extension host exiting with code ${K}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(K)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const K=await this._mainThreadExtensionsProxy.$getExtension(te);let J;if(K?.browserNlsBundleUris){J={};for(const ne of Object.keys(K.browserNlsBundleUris))J[ne]=D.URI.revive(K.browserNlsBundleUris[ne])}return K&&{...K,identifier:new v.ExtensionIdentifier(K.identifier.value),extensionLocation:D.URI.revive(K.extensionLocation),browserNlsBundleUris:J}}_activateByEvent(te,K){return this._activator.activateByEvent(te,K)}_activateById(te,K){return this._activator.activateById(te,K)}activateByIdWithErrors(te,K){return this._activateById(te,K).then(()=>{const J=this._activator.getActivatedExtension(te);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==$.Schemas.file)return te;const K=await this._hostUtils.realpath(te.fsPath);return D.URI.file(K)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new X(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const K=S.TernarySearchTree.forUris(J=>A.extUriBiasedIgnorePathCase.ignorePathCasing(J));return await Promise.all(te.map(async J=>{if(this._getEntryPoint(J)){const ne=await this._realPathExtensionUri(J.extensionLocation);K.set(ne,J)}})),K}_deactivate(te){let K=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return K;const J=this._activator.getActivatedExtension(te);if(!J)return K;try{typeof J.module.deactivate=="function"&&(K=Promise.resolve(J.module.deactivate()).then(void 0,ne=>(this._logService.error(ne),Promise.resolve(void 0))))}catch(ne){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(ne)}try{(0,T.dispose)(J.subscriptions)}catch(ne){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(ne)}return K}async _activateExtension(te,K){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,K).then(J=>{const ne=J.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,K),this._logExtensionActivationTimes(te,K,"success",ne),J},J=>{throw this._logExtensionActivationTimes(te,K,"failure"),J})}_logExtensionActivationTimes(te,K,J,ne){const pe=de(te,K);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...pe,...ne||{},outcome:J})}_doActivateExtension(te,K){const J=de(te,K);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",J);const ne=this._getEntryPoint(te);if(!ne)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${K.startup}, activationEvent: '${K.activationEvent}'${te.identifier.value!==K.extensionId.value?`, root cause: ${K.extensionId.value}`:""}`),this._logService.flush();const pe=new k.ExtensionActivationTimesBuilder(K.startup);return Promise.all([this._loadCommonJSModule(te,(0,A.joinPath)(te.extensionLocation,ne),pe),this._loadExtensionContext(te)]).then(be=>(u.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Fi._callActivate(this._logService,te.identifier,be[0],be[1],pe))).then(be=>(u.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),be))}_loadExtensionContext(te){const K=new p.ExtensionGlobalMemento(te,this._storage),J=new p.ExtensionMemento(te.identifier.value,!1,this._storage),ne=new j.ExtensionSecrets(te,this._secretState),pe=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,be=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([K.whenReady,J.whenReady,this._storagePath.whenReady]).then(()=>{const Ie=this;let Le,oe;const ae=(0,d.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(v.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:K,workspaceState:J,secrets:ne,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(fe){return P.join(te.extensionLocation.fsPath,fe)},get storagePath(){return Ie._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Ie._storagePath.globalValue(te).fsPath},get logPath(){return P.join(Ie._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return D.URI.joinPath(Ie._initData.logsLocation,te.identifier.value)},get storageUri(){return Ie._storagePath.workspaceValue(te)},get globalStorageUri(){return Ie._storagePath.globalValue(te)},get extensionMode(){return pe},get extension(){return Le===void 0&&(Le=new Y(Ie,te.identifier,te,be,!1)),Le},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(te,"extensionRuntime"),Ie.extensionRuntime},get environmentVariableCollection(){return Ie._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!oe){if(!ae)return;const fe=E.Event.buffer(E.Event.fromDOMEventEmitter(ae,"message",ee=>ee.data));ae.start(),oe={onDidReceiveMessage:fe,postMessage:ae.postMessage.bind(ae)}}return oe}})})}static _callActivate(te,K,J,ne,pe){return J=J||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,K,J,ne,pe).then(be=>new k.ActivatedExtension(!1,null,pe.build(),J,be,ne.subscriptions))}static _callActivateOptional(te,K,J,ne,pe){if(typeof J.activate=="function")try{pe.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${K.value}`);const be=typeof global=="object"?global:self,Ie=J.activate.apply(be,[ne]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(Ie).then(Le=>(pe.activateResolveStop(),Le))}catch(be){return Promise.reject(be)}else return Promise.resolve(J)}_activateOneStartupFinished(te,K){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:K}).then(void 0,J=>{this._logService.error(J)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(u.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const K of te.activationEvents)K==="onStartupFinished"&&this._activateOneStartupFinished(te,K)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const K=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],J=this._handleWorkspaceContainsEagerExtensions(K),ne=Promise.all([te,J]).then(()=>{});return Promise.race([ne,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(K=>this._handleWorkspaceContainsEagerExtension(te,K))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,K){if(this.isActivated(K.identifier))return;const J=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={logService:this._logService,folders:te.map(be=>be.uri),forceUsingSearch:J,exists:be=>this._hostUtils.exists(be.fsPath),checkExists:(be,Ie,Le)=>this._mainThreadWorkspaceProxy.$checkExists(be,Ie,Le)},pe=await(0,y.checkActivateWorkspaceContainsExtension)(ne,K);if(!!pe)return this._activateById(K.identifier,{startup:!0,extensionId:K.identifier,activationEvent:pe.activationEvent}).then(void 0,be=>this._logService.error(be))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:K}=this._initData.environment;if(!te||!K)throw new Error(a.localize(0,null));const J=await this._loadCommonJSModule(null,K,new k.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(a.localize(1,null,K.toString()));return new Promise((ne,pe)=>{const be=(oe,ae)=>{oe?pe(oe):ne(typeof ae=="number"&&ae>0?1:0)},Ie=(0,A.originalFSPath)(K),Le=J.run(Ie,be);Le&&Le.then&&Le.then(()=>{ne(0)}).catch(oe=>{pe(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,K){return this._resolvers[te]=K,(0,T.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const K=te.indexOf("+");if(K===-1)throw new Error("Not an authority that can be resolved!");const J=te.substr(0,K);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this._resolvers[J]}}async $resolveAuthority(te,K){const J=x.StopWatch.create(!1),ne=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(te)},${K})][${J.elapsed()}ms] `,pe=ae=>this._logService.info(`${ne()}${ae}`),be=(ae,fe=void 0)=>this._logService.error(`${ne()}${ae}`,fe);pe("activating resolver...");const{authorityPrefix:Ie,resolver:Le}=await this._activateAndGetResolver(te);if(!Le)return be("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ie}.`,detail:void 0}};const oe=new _.IntervalTimer;try{pe("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(Le)),oe.cancelAndSet(()=>pe("waiting..."),1e3),pe("invoking resolve()..."),u.mark(`code/extHost/willResolveAuthority/${Ie}`);const ae=await Le.resolve(te,{resolveAttempt:K});u.mark(`code/extHost/didResolveAuthorityOK/${Ie}`),oe.dispose(),pe(`returned ${ae.host}:${ae.port}`);const fe={authority:te,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},ee={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:fe,options:ee,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(u.mark(`code/extHost/didResolveAuthorityError/${Ie}`),oe.dispose(),be("returned an error",ae),ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(te,K){this._logService.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(te)})`);const{resolver:J}=await this._activateAndGetResolver(te);if(!J)return null;const ne=D.URI.revive(K);if(typeof J.getCanonicalURI>"u")return ne;const pe=await(0,_.asPromise)(()=>J.getCanonicalURI(ne));return pe||ne}static _applyExtensionsDelta(te,K,J){const ne=new h.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ne.deltaExtensions(J.toAdd,J.toRemove);const pe=(0,d.extensionIdentifiersArrayToSet)(K.getAllExtensionDescriptions().map(Ie=>Ie.identifier));for(const Ie of J.myToRemove)pe.delete(v.ExtensionIdentifier.toKey(Ie));for(const Ie of J.myToAdd)pe.add(v.ExtensionIdentifier.toKey(Ie));const be=V(ne,pe);return{globalRegistry:ne,myExtensions:be}}$startExtensionHost(te){te.toAdd.forEach(ne=>ne.extensionLocation=D.URI.revive(ne.extensionLocation));const{globalRegistry:K,myExtensions:J}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(K.getAllExtensionDescriptions()),this._myRegistry.set(J),this._startExtensionHost()}$activateByEvent(te,K){return K===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(J=>this._activateByEvent(te,!1))}async $activate(te,K){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,K),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(be=>be.extensionLocation=D.URI.revive(be.extensionLocation));const{globalRegistry:K,myExtensions:J}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),ne=await this._createExtensionPathIndex(J);return(await this.getExtensionPathIndex()).setSearchTree(ne),this._globalRegistry.set(K.getAllExtensionDescriptions()),this._myRegistry.set(J),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const K=C.VSBuffer.alloc(te),J=Math.random()%256;for(let ne=0;ne<te;ne++)K.writeUInt8(J,ne);return K}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};H=Ve([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,m.IExtHostRpcService),We(3,f.IExtHostWorkspace),We(4,b.IExtHostConfiguration),We(5,R.ILogService),We(6,l.IExtHostInitDataService),We(7,r.IExtensionStoragePaths),We(8,t.IExtHostTunnelService),We(9,c.IExtHostTerminalService),We(10,N.IExtHostLocalizationService)],H),e.AbstractExtHostExtensionService=H;function de(Z,te){return{id:Z.identifier.value,name:Z.name,extensionVersion:Z.version,publisherDisplayName:Z.publisher,activationEvents:Z.activationEvents?Z.activationEvents.join(","):null,isBuiltin:Z.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class Y{constructor(te,K,J,ne,pe){L.set(this,void 0),F.set(this,void 0),U.set(this,void 0),Je(this,L,te,"f"),Je(this,F,K,"f"),Je(this,U,J.identifier,"f"),this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=P.normalize((0,A.originalFSPath)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=ne,this.isFromDifferentExtensionHost=pe}get isActive(){return Ue(this,L,"f").isActivated(Ue(this,U,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,L,"f").getExtensionExports(Ue(this,U,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,L,"f").activateByIdWithErrors(Ue(this,U,"f"),{startup:!1,extensionId:Ue(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=Y,L=new WeakMap,F=new WeakMap,U=new WeakMap;function V(Z,te){return Z.getAllExtensionDescriptions().filter(K=>te.has(v.ExtensionIdentifier.toKey(K.identifier)))}class X{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=X}),define(_e[298],ye([1,0,83,2,5,36,27,26,20,25,4,42,33,13,8]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(p,i,o,s,l,r,m){this._apiFactory=p,this._extensionRegistry=i,this._instaService=o,this._extHostConfiguration=s,this._extHostExtensionService=l,this._initData=r,this._logService=m,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,i,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(g,i)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,i,this._initData.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const i of p.nodeModuleName)this._factories.set(i,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(i=>p.alternativeModuleName(i))}};f=Ve([We(2,R.IInstantiationService),We(3,A.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,D.IExtHostInitDataService),We(6,k.ILogService)],f),e.RequireInterceptor=f;let d=class rn{constructor(p){if(p.environment.appRoot&&rn.aliased.size){const i=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(p.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${l}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(p){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(p));if(!i)return;const[,o,s,l]=i,r=rn.aliased.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),o+r+l}forceForwardSlashes(p){return p.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=Ve([We(0,D.IExtHostInitDataService)],d);class h{constructor(p,i,o,s,l){this._apiFactory=p,this._extensionPaths=i,this._extensionRegistry=o,this._configProvider=s,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(p,i){const o=this._extensionPaths.findSubstr(i);if(o){let s=this._extApiImpl.get(T.ExtensionIdentifier.toKey(o.identifier));return s||(s=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(o.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((l,r)=>s+=`	${r} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(p,i,o){this._extensionPaths=p,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(u.MainContext.MainThreadTelemetry);const{environment:s}=o,l=i.getProxy(u.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;b.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,m)=>l.$getPassword(r,m),setPassword:(r,m,n)=>l.$setPassword(r,m,n),deletePassword:(r,m)=>l.$deletePassword(r,m),findPassword:r=>l.$findPassword(r),findCredentials(r){return l.$findCredentials(r)}}}load(p,i){const o=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(p){const i=p.length;if(i<=7||!this.alternativeNames)return;const o=i-7;if((p.charAt(o)==="/"||p.charAt(o)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}};g=Ve([We(1,S.IExtHostRpcService),We(2,D.IExtHostInitDataService)],g);let v=class{constructor(p,i,o){this._extensionPaths=p,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(u.MainContext.MainThreadTelemetry);const s=o.getProxy(u.MainContext.MainThreadWindow);this._impl=(l,r)=>{const m=P.URI.parse(l);return r?this.callOriginal(l,r):m.scheme==="http"||m.scheme==="https"?s.$openUri(m,l,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this._appUriScheme?s.$openUri(m,l,{}):this.callOriginal(l,r)}}load(p,i,o){const s=this._extensionPaths.findSubstr(i);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=o(p),this._impl}callOriginal(p,i){return this.sendNoForwardTelemetry(),this._original(p,i)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=Ve([We(2,S.IExtHostRpcService)],v)}),define(_e[49],ye([1,0,65,6,10,33,4,59,60,42,7,35,235,36]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class w extends b.AbstractVariableResolverService{constructor(h,g,v,C,p,i,o){function s(){if(v){const l=v.activeEditor();if(l)return l.document.uri;const r=C.tabGroups.all.find(m=>m.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:l=>{const r=i.folders.filter(m=>m.name===l);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,r)=>p.getConfiguration(void 0,l).get(r),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=s();if(l)return u.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const l=s();if(l){const r=g.getWorkspaceFolder(l);if(r)return u.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(v){const l=v.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(v){const l=v.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>h.getExtension(l)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(A.env))}}let f=class extends P.Disposable{constructor(h,g,v,C,p){super(),this.extensionService=h,this.workspaceService=g,this.editorService=v,this.configurationService=C,this.editorTabs=p,this._resolver=new a.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async l=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new w(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,s,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};f=Ve([We(0,D.IExtHostExtensionService),We(1,I.IExtHostWorkspace),We(2,T.IExtHostDocumentsAndEditors),We(3,k.IExtHostConfiguration),We(4,S.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(_e[84],ye([1,0,19,3,9,2,4,5,60,42,20,7,35,131,228,36,49]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(s,l,r,m,n,t){this._workspaceService=l,this._extensionService=r,this._configurationService=m,this._editorTabs=n,this._variableResolver=t,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new P.Emitter,this._onDidTerminateDebugSession=new P.Emitter,this._onDidChangeActiveDebugSession=new P.Emitter,this._onDidReceiveDebugSessionCustomEvent=new P.Emitter,this._debugServiceProxy=s.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new P.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new v(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(c=>{c.onDidChange(E=>{this.registerAllDebugTypes(c)}),this.registerAllDebugTypes(c)})}asDebugSourceUri(s,l){const r=s;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let m=`debug:${encodeURIComponent(r.path||"")}`,n="?";return l&&(m+=`${n}session=${encodeURIComponent(l.id)}`,n="&"),m+=`${n}ref=${r.sourceReference}`,A.URI.parse(m)}else{if(r.path)return A.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const l=[];for(const r of s.getAllExtensionDescriptions())if(r.contributes){const m=r.contributes.debuggers;if(m&&m.length>0)for(const n of m)(0,w.isDebuggerMainContribution)(n)&&l.push(n.type)}this._debugServiceProxy.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(l=>s.push(l)),s}addBreakpoints(s){this.startBreakpoints();const l=s.filter(n=>{const t=n.id;return this._breakpoints.has(t)?!1:(this._breakpoints.set(t,n),!0)});this.fireBreakpointChanges(l,[],[]);const r=[],m=new Map;for(const n of l)if(n instanceof I.SourceBreakpoint){let t=m.get(n.location.uri.toString());t||(t={type:"sourceMulti",uri:n.location.uri,lines:[]},m.set(n.location.uri.toString(),t),r.push(t)),t.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof I.FunctionBreakpoint&&r.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(s){this.startBreakpoints();const l=s.filter(t=>this._breakpoints.delete(t.id));this.fireBreakpointChanges([],l,[]);const r=l.filter(t=>t instanceof I.SourceBreakpoint).map(t=>t.id),m=l.filter(t=>t instanceof I.FunctionBreakpoint).map(t=>t.id),n=l.filter(t=>t instanceof I.DataBreakpoint).map(t=>t.id);return this._debugServiceProxy.$unregisterBreakpoints(r,m,n)}startDebugging(s,l,r){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,l,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,suppressSaveBeforeStart:r.suppressSaveBeforeStart,suppressDebugStatusbar:r.suppressDebugStatusbar??r.debugUI?.simple,suppressDebugToolbar:r.suppressDebugToolbar??r.debugUI?.simple,suppressDebugView:r.suppressDebugView??r.debugUI?.simple})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,l,r){if(!l)return new I.Disposable(()=>{});const m=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:m,provider:l}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,r,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,m),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(n=>n.provider!==l),this._debugServiceProxy.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(s,l,r){if(!r)return new I.Disposable(()=>{});if(!this.definesDebugType(s,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.getAdapterDescriptorFactoryByType(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:l,handle:m,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(l,m),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(n=>n.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(s,l){if(!l)return new I.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:r,factory:l}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(m=>m.factory!==l)})}async $runInTerminal(s,l){return Promise.resolve(void 0)}async $substituteVariables(s,l){let r;const m=await this.getFolder(s);return m&&(r={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,l)}createDebugAdapter(s,l){if(s.type==="implementation")return new p(s.implementation)}createSignService(){}async $startDASession(s,l){const r=this,m=await this.getSession(l);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(m.type),m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const t=this.convertToDto(n),c=this.createDebugAdapter(t,m);if(!c)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const E=c;return this._debugAdapters.set(s,E),this.getDebugAdapterTrackers(m).then(y=>(y&&this._debugAdaptersTrackers.set(s,y),E.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const j=M,$={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(j.arguments.value);$.body={signature:N},E.sendResponse($)}else throw new Error("no signer")}catch(N){$.success=!1,$.message=N.message,E.sendResponse($)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(M),M=(0,w.convertToVSCPaths)(M,!0),r._debugServiceProxy.$acceptDAMessage(s,M)}),E.onError(M=>{y&&y.onError&&y.onError(M),this._debugServiceProxy.$acceptDAError(s,M.name,M.message,M.stack)}),E.onExit(M=>{y&&y.onExit&&y.onExit((0,u.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,u.withNullAsUndefined)(M),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),E.startSession()))})}$sendDAMessage(s,l){l=(0,w.convertToDAPaths)(l,!1);const r=this._debugAdaptersTrackers.get(s);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(l),this._debugAdapters.get(s)?.sendMessage(l)}$stopDASession(s){const l=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),l&&l.onWillStopSession&&l.onWillStopSession();const r=this._debugAdapters.get(s);return this._debugAdapters.delete(s),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const l=[],r=[],m=[];if(s.added)for(const n of s.added){const t=n.id;if(t&&!this._breakpoints.has(t)){let c;if(n.type==="function")c=new I.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")c=new I.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const E=A.URI.revive(n.uri);c=new I.SourceBreakpoint(new I.Location(E,new I.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,I.setBreakpointId)(c,t),this._breakpoints.set(t,c),l.push(c)}}if(s.removed)for(const n of s.removed){const t=this._breakpoints.get(n);t&&(this._breakpoints.delete(n),r.push(t))}if(s.changed){for(const n of s.changed)if(n.id){const t=this._breakpoints.get(n.id);if(t){if(t instanceof I.FunctionBreakpoint&&n.type==="function"){const c=t;c.enabled=n.enabled,c.condition=n.condition,c.hitCondition=n.hitCondition,c.logMessage=n.logMessage,c.functionName=n.functionName}else if(t instanceof I.SourceBreakpoint&&n.type==="source"){const c=t;c.enabled=n.enabled,c.condition=n.condition,c.hitCondition=n.hitCondition,c.logMessage=n.logMessage,c.location=new I.Location(A.URI.revive(n.uri),new I.Position(n.line,n.character))}m.push(t)}}}this.fireBreakpointChanges(l,r,m)}$provideDebugConfigurations(s,l,r){return(0,a.asPromise)(async()=>{const m=this.getConfigProviderByHandle(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.getFolder(l);return m.provideDebugConfigurations(n,r)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(s,l,r,m){return(0,a.asPromise)(async()=>{const n=this.getConfigProviderByHandle(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const t=await this.getFolder(l);return n.resolveDebugConfiguration(t,r,m)})}$resolveDebugConfigurationWithSubstitutedVariables(s,l,r,m){return(0,a.asPromise)(async()=>{const n=this.getConfigProviderByHandle(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const t=await this.getFolder(l);return n.resolveDebugConfigurationWithSubstitutedVariables(t,r,m)})}async $provideDebugAdapter(s,l){const r=this.getAdapterDescriptorFactoryByHandle(s);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.getSession(l);return this.getAdapterDescriptor(r,m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.convertToDto(n)})}async $acceptDebugSessionStarted(s){const l=await this.getSession(s);this._onDidStartDebugSession.fire(l)}async $acceptDebugSessionTerminated(s){const l=await this.getSession(s);l&&(this._onDidTerminateDebugSession.fire(l),this._debugSessions.delete(l.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,l){(await this.getSession(s))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(s,l){const m={session:await this.getSession(s),event:l.event,body:l.body};this._onDidReceiveDebugSessionCustomEvent.fire(m)}convertToDto(s){if(s instanceof I.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof I.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const l=this._adapterFactories.filter(r=>r.type===s);if(l.length>0)return l[0].factory}getAdapterDescriptorFactoryByHandle(s){const l=this._adapterFactories.filter(r=>r.handle===s);if(l.length>0)return l[0].factory}getConfigProviderByHandle(s){const l=this._configProviders.filter(r=>r.handle===s);if(l.length>0)return l[0].provider}definesDebugType(s,l){if(s.contributes){const r=s.contributes.debuggers;if(r&&r.length>0){for(const m of r)if(m.label&&m.type&&m.type===l)return!0}}return!1}getDebugAdapterTrackers(s){const r=s.configuration.type,m=this._trackerFactories.filter(n=>n.type===r||n.type==="*").map(n=>(0,a.asPromise)(()=>n.factory.createDebugAdapterTracker(s)).then(t=>t,t=>null));return Promise.race([Promise.all(m).then(n=>{const t=n.filter(c=>!!c);if(t.length>0)return new C(t)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async getAdapterDescriptor(s,l){const r=l.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new I.DebugAdapterServer(r));if(s){const n=await this._extensionService.getExtensionRegistry();return(0,a.asPromise)(()=>s.createDebugAdapterDescriptor(l,this.daExecutableFromPackage(l,n))).then(t=>{if(t)return t})}const m=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(l,m))}daExecutableFromPackage(s,l){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,l,r){(s.length>0||l.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:l,changed:r}))}async getSession(s){if(s)if(typeof s=="string"){const l=this._debugSessions.get(s);if(l)return l}else{let l=this._debugSessions.get(s.id);if(!l){const r=await this.getFolder(s.folderUri),m=s.parent?this._debugSessions.get(s.parent):void 0;l=new g(this._debugServiceProxy,s.id,s.type,s.name,r,s.configuration,m),this._debugSessions.set(l.id,l),this._debugServiceProxy.$sessionCached(l.id)}return l}throw new Error("cannot find session")}getFolder(s){if(s){const l=A.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};h=Ve([We(0,R.IExtHostRpcService),We(1,b.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class g{constructor(s,l,r,m,n,t,c){this._debugServiceProxy=s,this._id=l,this._type=r,this._name=m,this._workspaceFolder=n,this._configuration=t,this._parentSession=c}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,l){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,l)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=g;class v{constructor(s){this.value=Object.freeze({append(l){s.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=v;class C{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(l=>l.onError?l.onError(s):void 0)}onExit(s,l){this.trackers.forEach(r=>r.onExit?r.onExit(s,l):void 0)}}class p extends k.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends h{constructor(s,l,r,m,n,t){super(s,l,r,m,n,t)}};i=Ve([We(0,R.IExtHostRpcService),We(1,b.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(_e[299],ye([1,0,11,83,2,5,291,13,89,90,25,204,20,56,42,96]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(v){const C=v.get(T.ILogService),i=v.get(b.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(o=>{C.error(o);const s=a.transformErrorForSerialization(o);i.$onUnexpectedError(s)})}static async installFullHandler(v){const C=v.get(T.ILogService),p=v.get(b.IExtHostRpcService),i=v.get(w.IExtHostExtensionService),o=v.get(f.IExtHostTelemetry),s=p.getProxy(A.MainContext.MainThreadExtensionService),l=p.getProxy(A.MainContext.MainThreadErrors),r=await i.getExtensionPathIndex(),m=new WeakMap;Error.prepareStackTrace=(n,t)=>{let c="",E,y;for(const M of t)c+=`
	at ${M.toString()}`,y=M.getFileName(),!E&&y&&(E=r.findSubstr(u.URI.file(y)));return m.set(n,E?.identifier),`${n.name||"Error"}: ${n.message||""}${c}`},a.setUnexpectedErrorHandler(n=>{C.error(n);const t=a.transformErrorForSerialization(n),c=m.get(n);if(!c){l.$onUnexpectedError(t);return}s.$onExtensionRuntimeError(c,t);const E=o.onExtensionError(c,n);C.trace("forwarded error to extension?",E,c)})}}Error.stackTraceLimit=100;class h{constructor(v,C,p,i,o){this._hostUtils=p,this._rpcProtocol=new _.RPCProtocol(v,null,i),C=h._transform(C,this._rpcProtocol);const s=new D.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());s.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...C,messagePorts:o}),s.set(b.IExtHostRpcService,new b.ExtHostRpcService(this._rpcProtocol)),s.set(k.IURITransformerService,new k.URITransformerService(i)),s.set(w.IHostUtils,p);const l=new I.InstantiationService(s,!0);l.invokeFunction(d.installEarlyHandler),this._logService=l.invokeFunction(r=>r.get(T.ILogService)),P.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",C),this._extensionService=l.invokeFunction(r=>r.get(w.IExtHostExtensionService)),this._extensionService.initialize(),l.invokeFunction(d.installFullHandler)}async asBrowserUri(v){const C=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return u.URI.revive(await C.$asBrowserUri(v))}terminate(v){this._extensionService.terminate(v)}static _transform(v,C){v.allExtensions.forEach(i=>{i.extensionLocation=u.URI.revive(C.transformIncomingURIs(i.extensionLocation));const o={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(s=>o[s]=u.URI.revive(C.transformIncomingURIs(i.browserNlsBundleUris[s]))),i.browserNlsBundleUris=o)}),v.environment.appRoot=u.URI.revive(C.transformIncomingURIs(v.environment.appRoot));const p=v.environment.extensionDevelopmentLocationURI;return p&&(v.environment.extensionDevelopmentLocationURI=p.map(i=>u.URI.revive(C.transformIncomingURIs(i)))),v.environment.extensionTestsLocationURI=u.URI.revive(C.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=u.URI.revive(C.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=u.URI.revive(C.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=u.URI.revive(C.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=u.URI.revive(C.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=u.URI.revive(C.transformIncomingURIs(v.logsLocation)),v.logFile=u.URI.revive(C.transformIncomingURIs(v.logFile)),v.workspace=C.transformIncomingURIs(v.workspace),v}}e.ExtensionHostMain=h}),define(_e[300],ye([1,0,19,12,185,203,211,84,60,42,20,41,7,49,35,229,231,36]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let g=class extends T.ExtHostDebugServiceBase{constructor(o,s,l,r,m,n,t){super(o,s,l,r,n,t),this._terminalService=m,this._integratedTerminalInstances=new p}createDebugAdapter(o,s){switch(o.type){case"server":return new f.SocketDebugAdapter(o);case"pipeServer":return new f.NamedPipeDebugAdapter(o);case"executable":return new f.ExecutableDebugAdapter(o,s.type)}return super.createDebugAdapter(o,s)}daExecutableFromPackage(o,s){const l=f.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(l)return new b.DebugAdapterExecutable(l.command,l.args,l.options)}createSignService(){return new _.SignService}async $runInTerminal(o,s){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(N=>{this._integratedTerminalInstances.onTerminalClosed(N)}));const l=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),m=this._terminalService.getDefaultShellArgs(!0),n=o.title||u.localize(0,null),t=JSON.stringify({shell:r,shellArgs:m});let c=await this._integratedTerminalInstances.checkout(t,n),E,y=!1;if(c)E=o.cwd;else{const N={shellPath:r,shellArgs:m,cwd:o.cwd,name:n,iconPath:new b.ThemeIcon("debug")};y=!0,c=this._terminalService.createTerminalFromOptions(N,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(c,t)}c.show(!0);const M=await c.processId;y?await new Promise(N=>setTimeout(N,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?c.sendText("cls"):r.indexOf("bash")>=0?c.sendText("clear"):P.isWindows?c.sendText("cls"):c.sendText("clear"));const j=(0,d.prepareCommand)(r,o.args,!!o.argsCanBeInterpretedByShell,E,o.env);c.sendText(j);const $=this.onDidTerminateDebugSession(N=>{N.id===s&&(this._integratedTerminalInstances.free(c),$.dispose())});return M}else if(o.kind==="external")return C(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,s)}};g=Ve([We(0,R.IExtHostRpcService),We(1,w.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,h.IExtHostConfiguration),We(4,I.IExtHostTerminalService),We(5,S.IExtHostEditorTabs),We(6,k.IExtHostVariableResolverProvider)],g),e.ExtHostDebugService=g;let v;function C(i,o){if(!v)if(P.isWindows)v=new A.WindowsExternalTerminalService;else if(P.isMacintosh)v=new A.MacExternalTerminalService;else if(P.isLinux)v=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return v.runInTerminal(i.title,i.cwd,i.args,i.env||{},s.external||{})}class p{constructor(){this._terminalInstances=new Map}async checkout(o,s){const r=[...this._terminalInstances.entries()].map(([m,n])=>(0,a.createCancelablePromise)(async t=>{if(m.name!==s||n.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await m.processId))return null;const c=Date.now();return n.lastUsedAt+p.minUseDelay>c||t.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=c,m)}));return await(0,a.firstParallel)(r,m=>!!m)}insert(o,s){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this._terminalInstances.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}p.minUseDelay=1e3}),define(_e[301],ye([1,0,10,2,116,35,59,36,47,41,20,25,82,14,13,77,24,71,49]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let v=class extends b.ExtHostTaskBase{constructor(p,i,o,s,l,r,m,n,t){super(p,i,o,s,l,r,m,n),this.workspaceService=o,this.variableResolver=t,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,i){const o=i;if(!i.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const s=b.TaskHandleDTO.from(o,this.workspaceService),l=await this._proxy.$getTaskExecution(s);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(l,i);return this._proxy.$executeTask(s).catch(()=>{}),r}else{const s=b.TaskDTO.from(i,p);if(s===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,i,!1);const l=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),i);return this._proxy.$executeTask(s).catch(()=>{}),l}}provideTasksInternal(p,i,o,s){const l=[];if(s)for(const r of s){this.checkDeprecation(r,o),(!r.definition||!p[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const m=b.TaskDTO.from(r,o.extension);m&&(l.push(m),b.CustomExecutionDTO.is(m.execution)&&i.push(this.addCustomExecution(m,r,!0)))}return{tasks:l,extension:o.extension}}async resolveTaskInternal(p){return p}async getAFolder(p){let i=p&&p.length>0?p[0]:void 0;if(!i){const o=P.URI.file((0,h.homedir)());i=new S.WorkspaceFolder({uri:o,name:d.basename(o),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,i){const o=P.URI.revive(p),s={process:void 0,variables:Object.create(null)},l=await this._workspaceProvider.resolveWorkspaceFolder(o),r=await this._workspaceProvider.getWorkspaceFolders2()??[],m=await this.variableResolver.getResolver(),n=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(r);for(const t of i.variables)s.variables[t]=await m.resolveAsync(n,t);if(i.process!==void 0){let t;if(i.process.path!==void 0){t=i.process.path.split(a.delimiter);for(let c=0;c<t.length;c++)t[c]=await m.resolveAsync(n,t[c])}s.process=await u.win32.findExecutable(await m.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await m.resolveAsync(n,i.process.cwd):void 0,t)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(p,i,o){return u.win32.findExecutable(p,i,o)}};v=Ve([We(0,R.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,D.IExtHostTerminalService),We(6,w.ILogService),We(7,f.IExtHostApiDeprecationService),We(8,g.IExtHostVariableResolverProvider)],v),e.ExtHostTask=v}),define(_e[302],ye([1,0,71,49]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class u extends P.ExtHostVariableResolverProviderService{homeDir(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=u}),define(_e[143],ye([1,0,16,19,21,45,14,10,24,2,31]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(g,v,C,p){this.query=g,this.provider=v,this.fileUtils=C,this.processType=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,v){const C=this.query.folderQueries||[],p=new u.CancellationTokenSource;return v.onCancellationRequested(()=>p.cancel()),new Promise((i,o)=>{this.collector=new k(g);let s=!1;const l=(r,m)=>{if(!s&&!this.isLimitHit){const n=this.resultSize(r);f(r)&&typeof this.query.maxResults=="number"&&this.resultCount+n>this.query.maxResults&&(this.isLimitHit=!0,s=!0,p.cancel(),r=this.trimResultToSize(r,this.query.maxResults-this.resultCount));const t=this.resultSize(r);this.resultCount+=t,(t>0||!f(r))&&this.collector.add(r,m)}};Promise.all(C.map((r,m)=>this.searchInFolder(r,n=>l(n,m),p.token))).then(r=>{p.dispose(),this.collector.flush();const m=r.some(n=>!!n&&!!n.limitHit);i({limitHit:this.isLimitHit||m,messages:(0,a.flatten)(r.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.processType}})},r=>{p.dispose();const m=(0,A.toErrorMessage)(r);o(new Error(m))})})}resultSize(g){return f(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,v){const C=Array.isArray(g.ranges)?g.ranges:[g.ranges],p=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:C.slice(0,v),preview:{matches:p.slice(0,v),text:g.preview.text},uri:g.uri}}async searchInFolder(g,v,C){const p=new R.QueryGlobTester(this.query,g),i=[],o={report:r=>{if(!this.validateProviderResult(r))return;const m=g.folder.scheme===_.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(r.uri))):void 0,n=S.relativePath(g.folder,r.uri);if(n){const t=p.includedInQuery(n,T.basename(n),m);(0,P.isThenable)(t)?i.push(t.then(c=>{c&&v(r)})):t&&v(r)}}},s=this.getSearchOptionsForFolder(g),l=await this.provider.provideTextSearchResults(b(this.query.contentPattern),s,o,C);return i.length&&await Promise.all(i),l}validateProviderResult(g){if(f(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const v=(0,R.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),C=(0,R.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),p={folder:D.URI.from(g.folder),excludes:C,includes:v,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return p.usePCRE2=this.query.usePCRE2,p}}e.TextSearchManager=I;function b(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class k{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new d(512,v=>this.sendItems(v))}add(g,v){this._currentFileMatch&&(this._currentFolderIdx!==v||!S.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=v,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(w(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=k;function w(h){return f(h)?{preview:{matches:(0,a.mapArrayOrNot)(h.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:h.preview.text},ranges:(0,a.mapArrayOrNot)(h.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function f(h){return!!h.preview}e.extensionResultIsMatch=f;class d{constructor(g,v){this.maxBatchSize=g,this.cb=v,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,v){!g||this.addItemToBatch(g,v)}addItems(g,v){!g||this.addItemsToBatch(g,v)}addItemToBatch(g,v){this.batch.push(g),this.batchSize+=v,this.onUpdate()}addItemsToBatch(g,v){this.batch=this.batch.concat(g),this.batchSize+=v,this.onUpdate()}onUpdate(){this.totalNumberCompleted<d.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},d.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}d.TIMEOUT=4e3,d.START_BATCH_AFTER_COUNT=50,e.BatchedCollector=d}),define(_e[85],ye([1,0,6,5,4,295,20,56,13,2,143]),function(ie,e,a,P,u,A,_,T,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,u.createDecorator)("IExtHostSearch");let I=class{constructor(f,d,h){this.extHostRpc=f,this._uriTransformer=d,this._logService=h,this._proxy=this.extHostRpc.getProxy(P.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,d){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const h=this._handlePool++;return this._textSearchProvider.set(h,d),this._proxy.$registerTextSearchProvider(h,this._transformScheme(f)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(f,d){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const h=this._handlePool++;return this._fileSearchProvider.set(h,d),this._proxy.$registerFileSearchProvider(h,this._transformScheme(f)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(f,d,h,g){const v=b(h),C=this._fileSearchProvider.get(f);if(C)return this._fileSearchManager.fileSearch(v,C,p=>{this._proxy.$handleFileMatch(f,d,p.map(i=>i.resource))},g);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,d,h,g){const v=this._textSearchProvider.get(f);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const C=b(h);return this.createTextSearchManager(C,v).search(i=>this._proxy.$handleTextMatch(f,d,i),g)}$enableExtensionHostSearch(){}createTextSearchManager(f,d){return new R.TextSearchManager(f,d,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};I=Ve([We(0,_.IExtHostRpcService),We(1,T.IURITransformerService),We(2,S.ILogService)],I),e.ExtHostSearch=I;function b(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(k),extraFileResources:w.extraFileResources&&w.extraFileResources.map(f=>D.URI.revive(f))}}e.reviveQuery=b;function k(w){return{...w,folder:D.URI.revive(w.folder)}}}),define(_e[303],ye([1,0,89,142,35,139,36,40,59,41,82,84,85,99,55,77,141,78,48,98,96,60,140,13,220,49,97]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C,p,i,o,s,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(r.IExtHostLocalizationService,r.ExtHostLocalizationService,1),(0,a.registerSingleton)(o.ILoggerService,i.ExtHostLoggerService,1),(0,a.registerSingleton)(o.ILogService,s.ExtHostLogService,1),(0,a.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,a.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,0),(0,a.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,a.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,a.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService,1),(0,a.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch,0),(0,a.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,0),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,a.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService,0),(0,a.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,a.registerSingleton)(u.IExtHostWorkspace,u.ExtHostWorkspace,0),(0,a.registerSingleton)(v.IExtHostSecretState,v.ExtHostSecretState,0),(0,a.registerSingleton)(C.IExtHostTelemetry,C.ExtHostTelemetry,0),(0,a.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,a.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(_e[100],ye([1,0,16,13,31,81]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function _(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=_;function T(I,b,k,w){const f=(0,a.mapArrayOrNot)(k,S),d=new u.TextSearchMatch(b,f,w),h=d.preview.matches;return{ranges:(0,a.mapArrayOrNot)(f,D),uri:I,preview:{text:d.preview.text,matches:(0,a.mapArrayOrNot)(h,D)}}}e.createTextSearchResult=T;function S(I){return new u.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function D(I){return new A.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(b,k){this.prefix=b,this.logService=k}appendLine(b){this.logService.debug(`${this.prefix}#search`,b)}};R=Ve([We(1,P.ILogService)],R),e.OutputChannel=R}),define(_e[304],ye([1,0,46,10,86,34,12,8,100,305]),function(ie,e,a,P,u,A,_,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const R=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(v,C,p,i){const o=b(v,C,p,i),s=C.folder.fsPath;return{cmd:a.spawn(R,o.args,{cwd:s}),rgDiskPath:R,siblingClauses:o.siblingClauses,rgArgs:o,cwd:s}}e.spawnRipgrepCmd=I;function b(v,C,p,i){const o=["--files","--hidden","--case-sensitive"];w([C],p,!1).forEach(l=>{const r=(0,S.anchorGlob)(l);if(o.push("-g",r),_.isMacintosh){const m=(0,u.normalizeNFD)(r);m!==r&&o.push("-g",m)}});const s=k([C],i,void 0,!1);return s.globArgs.forEach(l=>{const r=`!${(0,S.anchorGlob)(l)}`;if(o.push("-g",r),_.isMacintosh){const m=(0,u.normalizeNFD)(r);m!==r&&o.push("-g",m)}}),C.disregardIgnoreFiles!==!1?o.push("--no-ignore"):C.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),C.ignoreSymlinks||o.push("--follow"),v.exists&&o.push("--quiet"),o.push("--no-config"),C.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:s.siblingClauses}}function k(v,C,p,i=!0){const o=[];let s={};return v.forEach(l=>{const r=Object.assign({},l.excludePattern||{},C||{}),m=f(r,i?l.folder.fsPath:void 0,p);o.push(...m.globArgs),m.siblingClauses&&(s=Object.assign(s,m.siblingClauses))}),{globArgs:o,siblingClauses:s}}function w(v,C,p=!0){const i=[];return v.forEach(o=>{const s=Object.assign({},C||{},o.includePattern||{}),l=f(s,p?o.folder.fsPath:void 0);i.push(...l.globArgs)}),i}function f(v,C,p){const i=[],o={};return Object.keys(v).forEach(s=>{if(p&&p.has(s)||!s)return;const l=v[s];s=h(C?d(C,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof l=="boolean"&&l?(s.startsWith("\\\\")&&(s+="**"),i.push(g(s))):l&&l.when&&(o[s]=l)}),{globArgs:i,siblingClauses:o}}function d(v,C){return P.isAbsolute(C)?C:P.join(v,C)}e.getAbsoluteGlob=d;function h(v){return v=T.rtrim(v,"\\"),T.rtrim(v,"/")}function g(v){return A.getRoot(v).toLowerCase()==="c:/"?v.replace(/^c:[/\\]/i,"/"):v}e.fixDriveC=g}),define(_e[306],ye([1,0,46,70,10,307,16,45,38,86,34,12,43,8,9,29,31,304,111]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const v=new Set;process.on("exit",()=>{v.forEach(s=>s())});class C{constructor(l){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=l,this.filePattern=l.filePattern||"",this.includePattern=l.includePattern&&S.parse(l.includePattern),this.maxResults=l.maxResults||null,this.exists=!!l.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,g.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=l.excludePattern&&S.parse(l.excludePattern),this.folderExcludePatterns=new Map,l.folderQueries.forEach(r=>{const m=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),n=r.folder.fsPath;l.folderQueries.map(t=>t.folder.fsPath).filter(t=>t!==n).forEach(t=>{(0,R.isEqualOrParent)(t,n)&&(m[u.relative(n,t)]=!0)}),this.folderExcludePatterns.set(n,new i(m,n))})}cancel(){this.isCanceled=!0,v.forEach(l=>l())}walk(l,r,m,n,t){if(this.fileWalkSW=b.StopWatch.create(!1),this.isCanceled)return t(null,this.isLimitHit);r.forEach(c=>{const E=u.basename(c.fsPath);this.globalExcludePattern&&this.globalExcludePattern(c.fsPath,E)||this.matchFile(m,{relativePath:c.fsPath,searchPath:void 0})}),this.cmdSW=b.StopWatch.create(!1),this.parallel(l,(c,E)=>{this.call(this.cmdTraversal,this,c,m,n,y=>{if(y){const M=(0,T.toErrorMessage)(y);console.error(M),this.errors.push(M),E(y,void 0)}else E(null,void 0)})},(c,E)=>{this.fileWalkSW.stop();const y=c?_.coalesce(c)[0]:null;t(y,this.isLimitHit)})}parallel(l,r,m){const n=new Array(l.length),t=new Array(l.length);let c=!1,E=0;if(l.length===0)return m(null,[]);l.forEach((y,M)=>{r(y,(j,$)=>{if(j?(c=!0,n[M]=null,t[M]=j):(n[M]=$,t[M]=null),++E===l.length)return m(c?t:null,n)})})}call(l,r,...m){try{l.apply(r,m)}catch(n){m[m.length-1](n)}}cmdTraversal(l,r,m,n){const t=l.folder.fsPath,c=I.isMacintosh,E=()=>N&&N.kill();v.add(E);let y=U=>{v.delete(E),y=()=>{},n(U)},M="";const j=this.initDirectoryTree(),$=(0,h.spawnRipgrepCmd)(this.config,l,this.config.includePattern,this.folderExcludePatterns.get(l.folder.fsPath).expression),N=$.cmd,x=!Object.keys($.siblingClauses).length,L=$.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let F=`${$.rgDiskPath} ${L}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),m({message:F}),this.cmdResultCount=0,this.collectStdout(N,"utf8",m,(U,H,de)=>{if(U){y(U);return}if(this.isLimitHit){y();return}const V=(M+(c?D.normalizeNFC(H||""):H)).split(`
`);if(de){const X=V.length;V[X-1]=V[X-1].trim(),V[X-1]||V.pop()}else M=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,x){for(const X of V)if(this.matchFile(r,{base:t,relativePath:X,searchPath:this.getSearchPath(l,X)}),this.isLimitHit){E();break}(de||this.isLimitHit)&&y();return}this.addDirectoryEntries(l,j,t,V,r),de&&(this.matchDirectoryTree(j,t,r),y())})}spawnFindCmd(l){const r=this.folderExcludePatterns.get(l.folder.fsPath),m=r.getBasenameTerms(),n=r.getPathTerms(),t=["-L","."];if(m.length||n.length){t.push("-not","(","(");for(const c of m)t.push("-name",c),t.push("-o");for(const c of n)t.push("-path",c),t.push("-o");t.pop(),t.push(")","-prune",")")}return t.push("-type","f"),a.spawn("find",t,{cwd:l.folder.fsPath})}readStdout(l,r,m){let n="";this.collectStdout(l,r,()=>{},(t,c,E)=>{if(t){m(t);return}n+=c,E&&m(null,n)})}collectStdout(l,r,m,n){let t=(y,M,j)=>{(y||j)&&(t=()=>{},this.cmdSW?.stop()),n(y,M,j)},c=!1;l.stdout?(this.forwardData(l.stdout,r,t),l.stdout.once("data",()=>c=!0)):m({message:"stdout is null"});let E;l.stderr?E=this.collectData(l.stderr):m({message:"stderr is null"}),l.on("error",y=>{t(y)}),l.on("close",y=>{let M;!c&&(M=this.decodeData(E,r))&&o(M)?t(new Error(`command failed with error code ${y}: ${this.decodeData(E,r)}`)):(this.exists&&y===0&&(this.isLimitHit=!0),t(null,"",!0))})}forwardData(l,r,m){const n=new A.StringDecoder(r);return l.on("data",t=>{m(null,n.write(t))}),n}collectData(l){const r=[];return l.on("data",m=>{r.push(m)}),r}decodeData(l,r){const m=new A.StringDecoder(r);return l.map(n=>m.write(n)).join("")}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries(l,{pathToEntries:r},m,n,t){n.indexOf(this.filePattern)!==-1&&this.matchFile(t,{base:m,relativePath:this.filePattern,searchPath:this.getSearchPath(l,this.filePattern)});const c=E=>{const y=u.basename(E),M=u.dirname(E);let j=r[M];j||(j=r[M]=[],c(M)),j.push({base:m,relativePath:E,basename:y,searchPath:this.getSearchPath(l,E)})};n.forEach(c)}matchDirectoryTree({rootEntries:l,pathToEntries:r},m,n){const t=this,c=this.folderExcludePatterns.get(m),E=this.filePattern;function y(M){t.directoriesWalked++;const j=(0,d.hasSiblingFn)(()=>M.map($=>$.basename));for(let $=0,N=M.length;$<N;$++){const x=M[$],{relativePath:L,basename:F}=x;if(c.test(L,F,E!==F?j:void 0))continue;const U=r[L];if(U)y(U);else{if(t.filesWalked++,L===E)continue;t.matchFile(n,x)}if(t.isLimitHit)break}}y(l)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(l,r,m,n,t){const c=l.folder,E=(0,d.hasSiblingFn)(()=>m);this.parallel(m,(y,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const j=r?[r,y].join(u.sep):y;if(this.folderExcludePatterns.get(l.folder.fsPath).test(j,y,this.config.filePattern!==y?E:void 0))return M(null);const $=[c.fsPath,j].join(u.sep);P.lstat($,(N,x)=>{if(N||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded($,x,(L,F)=>L||this.isCanceled||this.isLimitHit?M(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded($,x,(U,H)=>U||this.isCanceled||this.isLimitHit||(H=H||"",this.walkedPaths[H])?M(null):(this.walkedPaths[H]=!0,f.Promises.readdir($).then(de=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(l,j,de,n,Y=>M(Y||null))},de=>{M(null)})))):(this.filesWalked++,j===this.filePattern||this.maxFilesize&&w.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(n,{base:c.fsPath,relativePath:j,searchPath:this.getSearchPath(l,j)}),M(null,void 0)))})},y=>{const M=y&&_.coalesce(y);return t(M&&M.length>0?M[0]:void 0)})}matchFile(l,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,u.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||l(r))}isFileMatch(l){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,d.isFilePatternMatch)(l,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(l,r,m){return r.isSymbolicLink()?P.stat(l,m):m(null,r)}realPathIfNeeded(l,r,m){return r.isSymbolicLink()?P.realpath(l,(n,t)=>n?m(n):m(null,t)):m(null,l)}getSearchPath(l,r){return l.folderName?u.join(l.folderName,r):r}}e.FileWalker=C;class p{constructor(l){this.folderQueries=l.folderQueries,this.extraFiles=l.extraFileResources||[],this.walker=new C(l)}search(l,r,m){this.walker.walk(this.folderQueries,this.extraFiles,l,r,(n,t)=>{m(n,{limitHit:t,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class i{constructor(l,r){this.expression=l,this.root=r,this.init(l)}init(l){let r,m;Object.keys(l).filter(n=>l[n]).forEach(n=>{u.isAbsolute(n)?(r=r||S.getEmptyExpression(),r[n]=l[n]):(m=m||S.getEmptyExpression(),m[n]=l[n])}),this.absoluteParsedExpr=r&&S.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=m&&S.parse(m,{trimForExclusions:!0})}test(l,r,m){return this.relativeParsedExpr&&this.relativeParsedExpr(l,r,m)||this.absoluteParsedExpr&&this.absoluteParsedExpr(u.join(this.root,l),r,m)}getBasenameTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...S.getBasenameTerms(this.relativeParsedExpr)),l}getPathTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...S.getPathTerms(this.relativeParsedExpr)),l}}function o(s){const l=s.trim().split(`
`),r=l[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return k.uppercaseFirstLetter(l[l.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(_e[308],ye([1,0,103,22]),function(ie,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function u(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===s)}e.isUTFEncoding=u,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,_=512,T=512*8,S=512*128;var D;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(l,r){super(l),this.decodeStreamErrorKind=r}}e.DecodeStreamError=R;class I{static async create(l){let r;if(l!==e.UTF8)r=(await new Promise((n,t)=>{ie(["@vscode/iconv-lite-umd"],n,t)})).getDecoder(f(l));else{const m=new TextDecoder;r={write(n){return m.decode(n,{stream:!0})},end(){return m.decode()}}}return new I(r)}constructor(l){this.iconvLiteDecoder=l}write(l){return this.iconvLiteDecoder.write(l)}end(){return this.iconvLiteDecoder.end()}}function b(s,l){const r=l.minBytesRequiredForDetection??l.guessEncoding?T:_;return new Promise((m,n)=>{const t=(0,a.newWriteableStream)($=>$.join("")),c=[];let E=0,y;const M=async()=>{try{const $=await o({buffer:P.VSBuffer.concat(c),bytesRead:E},l.guessEncoding);if($.seemsBinary&&l.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);$.encoding=await l.overwriteEncoding($.encoding),y=await I.create($.encoding);const N=y.write(P.VSBuffer.concat(c).buffer);t.write(N),c.length=0,E=0,m({stream:t,detected:$})}catch($){j?.dispose(),t.destroy(),n($)}},j=(0,a.listenStream)(s,{onData:async $=>{y?t.write(y.write($.buffer)):(c.push($),E+=$.byteLength,E>=r&&(s.pause(),await M(),setTimeout(()=>s.resume())))},onError:$=>t.error($),onEnd:async()=>{y||await M(),t.end(y?.end())}})})}e.toDecodeStream=b;async function k(s,l,r){const n=(await new Promise((E,y)=>{ie(["@vscode/iconv-lite-umd"],E,y)})).getEncoder(f(l),r);let t=!1,c=!1;return{read(){if(c)return null;const E=s.read();if(typeof E!="string"){if(c=!0,!t&&r?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return P.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=n.end();return y&&y.length>0?(t=!0,P.VSBuffer.wrap(y)):null}return t=!0,P.VSBuffer.wrap(n.write(E))}}}e.toEncodeReadable=k;async function w(s){return(await new Promise((r,m)=>{ie(["@vscode/iconv-lite-umd"],r,m)})).encodingExists(f(s))}e.encodingExists=w;function f(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=f;function d(s,l){if(!s||l<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),m=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&m===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&m===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const n=s.readUInt8(2);return r===e.UTF8_BOM[0]&&m===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const h=["ascii","utf-16","utf-32"];async function g(s){const l=await new Promise((c,E)=>{ie(["jschardet"],c,E)}),r=s.slice(0,S),m=p(r.buffer),n=l.detect(m);if(!n||!n.encoding)return null;const t=n.encoding.toLowerCase();return 0<=h.indexOf(t)?null:C(n.encoding)}const v={ibm866:"cp866",big5:"cp950"};function C(s){const l=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[l]||l}function p(s){let l="";for(let r=0;r<s.length;r++)l+=String.fromCharCode(s[r]);return l}function i(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=s.match(/windows(\d+)/);return l?"windows-"+l[1]:s}}}e.toCanonicalName=i;function o({buffer:s,bytesRead:l},r){let m=d(s,l),n=!1;if(m!==e.UTF16be&&m!==e.UTF16le&&s){let t=!0,c=!0,E=!1;for(let y=0;y<l&&y<A;y++){const M=y%2===1,j=s.readUInt8(y)===0;if(j&&(E=!0),t&&(M&&!j||!M&&j)&&(t=!1),c&&(M&&j||!M&&!j)&&(c=!1),j&&!t&&!c)break}E&&(t?m=e.UTF16le:c?m=e.UTF16be:n=!0)}return r&&!n&&!m&&s?g(s.slice(0,l)).then(t=>({seemsBinary:!1,encoding:t})):{seemsBinary:n,encoding:m}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(_e[144],ye([1,0,308,29,143]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends u.TextSearchManager{constructor(T,S,D=P,R="searchProcess"){super(T,S,{readdir:I=>D.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,a.toCanonicalName)(I)},R)}}e.NativeTextSearchManager=A}),define(_e[309],ye([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(u){if(u&&this._dragOperations.has(u)){const A=this._dragOperations.get(u);return this._dragOperations.delete(u),A}}addDragOperationTransfer(u,A){this._dragOperations.set(u,A)}getRenderedTreeElement(u){if(this._renderedElements.has(u))return this._renderedElements.get(u)}addRenderedTreeItemElement(u,A){this._renderedElements.set(u,A)}removeRenderedTreeItemElement(u){this._renderedElements.has(u)&&this._renderedElements.delete(u)}}e.TreeviewsService=a}),define(_e[310],ye([1,0,183,7,24,2,3,6,226,19,7,9,16,15,21,309,27]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(C,p){if((0,I.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let i;return Array.isArray(C.highlights)&&(i=C.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),i=i.length?i:void 0),{label:C.label,highlights:i}}}class g{constructor(p,i,o){this._proxy=p,this.commands=i,this.logService=o,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function s(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>s(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(r=>s(r)?this.convertArgument(r):r):l})}registerTreeDataProvider(p,i,o){const s=this.createTreeView(p,{treeDataProvider:i},o);return{dispose:()=>s.dispose()}}createTreeView(p,i,o){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],r=!!i.dragAndDropController?.handleDrag,m=!!i.dragAndDropController?.handleDrop,n=this.createExtHostTreeView(p,i,o),t=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:s,dragMimeTypes:l,hasHandleDrag:r,hasHandleDrop:m});return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(o,"treeItemCheckbox"),n.onDidChangeCheckboxState},get message(){return n.message},set message(c){n.message=c},get title(){return n.title},set title(c){n.title=c},get description(){return n.description},set description(c){n.description=c},get badge(){return n.badge},set badge(c){c!==void 0&&R.ViewBadge.isViewBadge(c)?n.badge={value:Math.floor(Math.abs(c.value)),tooltip:c.tooltip}:c===void 0&&(n.badge=void 0)},reveal:(c,E)=>n.reveal(c,E),dispose:async()=>{await t,this.treeViews.delete(p),n.dispose()}}}$getChildren(p,i){const o=this.treeViews.get(p);return o?o.getChildren(i):Promise.reject(new S.NoTreeViewError(p))}async $handleDrop(p,i,o,s,l,r,m,n){const t=this.treeViews.get(p);if(!t)return Promise.reject(new S.NoTreeViewError(p));const c=k.DataTransfer.toDataTransfer(o,async E=>(await this._proxy.$resolveDropFileData(p,i,E)).buffer);return m===p&&n&&await this.addAdditionalTransferItems(c,t,n,l,r),t.onDrop(c,s,l)}async addAdditionalTransferItems(p,i,o,s,l){const r=this.treeDragAndDropService.removeDragOperationTransfer(l);if(r)(await r)?.forEach((m,n)=>{m&&p.set(n,m)});else if(l&&i.handleDrag){const m=i.handleDrag(o,p,s);this.treeDragAndDropService.addDragOperationTransfer(l,m),await m}return p}async $handleDrag(p,i,o,s){const l=this.treeViews.get(p);if(!l)return Promise.reject(new S.NoTreeViewError(p));const r=await this.addAdditionalTransferItems(new P.DataTransfer,l,i,s,o);if(!!r)return k.DataTransfer.toDataTransferDTO(r)}async $hasResolve(p){const i=this.treeViews.get(p);if(!i)throw new S.NoTreeViewError(p);return i.hasResolve}$resolve(p,i,o){const s=this.treeViews.get(p);if(!s)throw new S.NoTreeViewError(p);return s.resolveTreeItem(i,o)}$setExpanded(p,i,o){const s=this.treeViews.get(p);if(!s)throw new S.NoTreeViewError(p);s.setExpanded(i,o)}$setSelection(p,i){const o=this.treeViews.get(p);if(!o)throw new S.NoTreeViewError(p);o.setSelection(i)}$setFocus(p,i){const o=this.treeViews.get(p);if(!o)throw new S.NoTreeViewError(p);o.setFocus(i)}$setVisible(p,i){const o=this.treeViews.get(p);if(!o)throw new S.NoTreeViewError(p);o.setVisible(i)}$changeCheckboxState(p,i){const o=this.treeViews.get(p);if(!o)throw new S.NoTreeViewError(p);o.setCheckboxState(i)}createExtHostTreeView(p,i,o){const s=new v(p,i,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(p,s),s}convertArgument(p){const i=this.treeViews.get(p.$treeViewId);return i&&"$treeItemHandle"in p?i.getExtensionElement(p.$treeItemHandle):i&&"$focusedTreeItem"in p&&p.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=g;class v extends T.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,I.isUndefinedOrNull)(p))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(p,i,o,s,l,r){if(super(),this.viewId=p,this.proxy=o,this.commands=s,this.logService=l,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new _.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new w.CancellationTokenSource,r.contributes&&r.contributes.views)for(const t in r.contributes.views)for(const c of r.contributes.views[t])c.id===p&&(this._title=c.name);this.dataProvider=i.treeDataProvider,this.dndController=i.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let m,n;this._register(_.Event.debounce(this._onDidChangeData.event,(t,c)=>(t||(t={message:!1,elements:[]}),c.element!==!1&&(m||(m=new Promise(E=>n=E),this.refreshPromise=this.refreshPromise.then(()=>m)),Array.isArray(c.element)?t.elements.push(...c.element):t.elements.push(c.element)),c.message&&(t.message=!0),t),200,!0)(({message:t,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const E=n;return m=null,this.refresh(c).then(()=>E())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(p){const i=p?this.getExtensionElement(p):void 0;if(p&&!i)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(p);return o||(o=await this.fetchChildrenNodes(i)),o?o.map(s=>s.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,i){i=i||{select:!0,focus:!1};const o=(0,I.isUndefinedOrNull)(i.select)?!0:i.select,s=(0,I.isUndefinedOrNull)(i.focus)?!1:i.focus,l=(0,I.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(r=>this.resolveTreeNode(p,r[r.length-1]).then(m=>this.proxy.$reveal(this.viewId,{item:m.item,parentChain:r.map(n=>n.item)},{select:o,focus:s,expand:l})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:s,expand:l})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}get badge(){return this._badge}set badge(p){this._badge?.value===p?.value&&this._badge?.tooltip===p?.tooltip||(this._badge=k.ViewBadge.from(p),this.proxy.$setBadge(this.viewId,p))}setExpanded(p,i){const o=this.getExtensionElement(p);o&&(i?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(p){(0,b.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this._focusedHandle=p}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(p){const i=(await Promise.all(p.map(async o=>{const s=this.getExtensionElement(o.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:o.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);i.forEach(o=>{o.treeItem.checkboxState=o.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:i.map(o=>[o.extensionItem,o.newState])})}async handleDrag(p,i,o){const s=[];for(const l of p){const r=this.getExtensionElement(l);r&&s.push(r)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,i,o),i}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(p,i,o){const s=i?this.getExtensionElement(i):void 0;if(!(!s&&i||!this.dndController?.handleDrop))return(0,D.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,p,o):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,i){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(p);if(o){const s=this.nodes.get(o);if(s){const l=await this.dataProvider.resolveTreeItem(s.extensionItem,o,i)??s.extensionItem;return this.validateTreeItem(l),s.item.tooltip=this.getTooltip(l.tooltip),s.item.command=this.getCommand(s.disposableStore,l.command),s.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(i=>i?this.resolveUnknownParentChain(i).then(o=>this.resolveTreeNode(i,o[o.length-1]).then(s=>(o.push(s),o))):Promise.resolve([]))}resolveParent(p){const i=this.nodes.get(p);return i?Promise.resolve(i.parent?this.elements.get(i.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,i){const o=this.nodes.get(p);return o?Promise.resolve(o):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(s=>this.createHandle(p,s,i,!0)).then(s=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(s);if(l){const r=this.nodes.get(l);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}getChildrenNodes(p){if(p){let i;if(typeof p=="string"){const o=this.getExtensionElement(p);i=o?this.nodes.get(o):void 0}else i=p;return i&&i.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const i=new w.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=p?this.nodes.get(p):void 0,s=await this.dataProvider.getChildren(p);if(i.token.isCancellationRequested)return;const l=await Promise.all((0,b.coalesce)(s||[]).map(async r=>{const m=await this.dataProvider.getTreeItem(r);return m&&!i.token.isCancellationRequested?this.createAndRegisterTreeNode(r,m,o):null}));return i.token.isCancellationRequested?void 0:(0,b.coalesce)(l)}finally{i.dispose()}}refresh(p){if(p.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new w.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(p);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const i=new Set,o=p.map(l=>this.nodes.get(l));for(const l of o)if(l&&!i.has(l.item.handle)){let r=l;for(;r&&r.parent&&o.findIndex(m=>r&&r.parent&&m&&m.item.handle===r.parent.item.handle)===-1;){const m=this.elements.get(r.parent.item.handle);r=m?this.nodes.get(m):void 0}r&&!r.parent&&i.add(l.item.handle)}const s=[];return i.forEach(l=>{const r=this.elements.get(l);if(r){const m=this.nodes.get(r);m&&(!m.parent||!i.has(m.parent.item.handle))&&s.push(l)}}),s}refreshHandles(p){const i={};return Promise.all(p.map(o=>this.refreshNode(o).then(s=>{s&&(i[o]=s.item)}))).then(()=>Object.keys(i).length?this.proxy.$refresh(this.viewId,i):void 0)}refreshNode(p){const i=this.getExtensionElement(p);if(i){const o=this.nodes.get(i);if(o)return this.clearChildren(i),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(i)).then(s=>{if(s){const l=this.createTreeNode(i,s,o.parent);return this.updateNodeCache(i,l,o,o.parent),o.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,i,o){const s=this.createTreeNode(p,i,o);if(i.id&&this.elements.has(s.item.handle))throw new Error((0,a.localize)(0,null,i.id));return this.addNodeToCache(p,s),this.addNodeToParentCache(s,o),s}getTooltip(p){return R.MarkdownString.isMarkdownString(p)?k.MarkdownString.from(p):p}getCommand(p,i){return i?{...this.commands.toInternal(i,p),originalId:i.command}:void 0}getCheckbox(p){if(!p.checkboxState)return;let i,o;return typeof p.checkboxState=="number"?i=p.checkboxState:(i=p.checkboxState.state,o=p.checkboxState.tooltip),{isChecked:i===R.TreeItemCheckboxState.Checked,tooltip:o}}validateTreeItem(p){if(!R.TreeItem.isTreeItem(p,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(p,i,o){this.validateTreeItem(i);const s=new T.DisposableStore,l=this.createHandle(p,i,o),r=this.getLightIconPath(i);return{item:{handle:l,parentHandle:o?o.item.handle:void 0,label:h(i.label,this.extension),description:i.description,resourceUri:i.resourceUri,tooltip:this.getTooltip(i.tooltip),command:this.getCommand(s,i.command),contextValue:i.contextValue,icon:r,iconDark:this.getDarkIconPath(i)||r,themeIcon:this.getThemeIcon(i),collapsibleState:(0,I.isUndefinedOrNull)(i.collapsibleState)?R.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.getCheckbox(i)},extensionItem:i,parent:o,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(p){return p.iconPath instanceof R.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:i,label:o,resourceUri:s},l,r){if(i)return`${v.ID_HANDLE_PREFIX}/${i}`;const m=h(o,this.extension),n=l?l.item.handle:v.LABEL_HANDLE_PREFIX;let t=m?m.label:s?(0,u.basename)(s):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const c=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,E=this.getChildrenNodes(l)||[];let y,M=0;do{if(y=`${n}/${M}:${t}`,r||!this.elements.has(y)||c===y)break;M++}while(M<=E.length);return y}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof R.ThemeIcon))return typeof p.iconPath=="string"||A.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof R.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return A.URI.isUri(p)?p:A.URI.file(p)}addNodeToCache(p,i){this.elements.set(i.item.handle,p),this.nodes.set(p,i)}updateNodeCache(p,i,o,s){this.elements.delete(i.item.handle),this.nodes.delete(p),i.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(p,i);const l=this.getChildrenNodes(s)||[],r=l.filter(m=>m.item.handle===o.item.handle)[0];r&&l.splice(l.indexOf(r),1,i)}addNodeToParentCache(p,i){i?(i.children||(i.children=[]),i.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const i=this.nodes.get(p);if(i){if(i.children)for(const o of i.children){const s=this.elements.get(o.item.handle);s&&this.clear(s)}i.children=void 0}}else this.clearAll()}clear(p){const i=this.nodes.get(p);if(i){if(i.children)for(const o of i.children){const s=this.elements.get(o.item.handle);s&&this.clear(s)}this.nodes.delete(p),this.elements.delete(i.item.handle),i.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(_e[311],ye([1,0,21,11,3,37,2,121,107,153,164,44,5,95,253,252,40,254,36,256,257,258,241,259,59,42,260,261,264,265,266,142,244,272,273,274,99,41,276,310,15,7,74,279,80,141,35,233,263,73,139,82,84,85,13,56,20,25,267,240,55,77,250,277,79,78,282,280,281,251,48,275,278,98,60,96,268,81,269,14,125,243,222,262,6,27,227,97,218,270,271]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C,p,i,o,s,l,r,m,n,t,c,E,y,M,j,$,N,x,L,F,U,H,de,Y,V,X,Z,te,K,J,ne,pe,be,Ie,Le,oe,ae,fe,ee,le,re,O,W,G,Q,he,Ee,Pe,ve,Ce,ke,$e,je,et,Xe,nt,st,ht,Fe,rt,ce,B,ue,De,Re,xe,Ge,Ze,pt,gt,ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function wt(tt){const ft=tt.get(fe.IExtHostInitDataService),Pt=tt.get(ke.IExtHostFileSystemInfo),Gt=tt.get(he.IExtHostConsumerFileSystem),At=tt.get(l.IExtHostExtensionService),mt=tt.get(Z.IExtHostWorkspace),kt=tt.get(nt.IExtHostTelemetry),xt=tt.get(g.IExtHostConfiguration),Ot=tt.get(oe.IURITransformerService),Ke=tt.get(ae.IExtHostRpcService),Nt=tt.get(N.IExtHostStorage),Ft=tt.get(Q.IExtensionStoragePaths),Wt=tt.get(Le.ILoggerService),vt=tt.get(Le.ILogService),Ae=tt.get(re.IExtHostTunnelService),Oe=tt.get(O.IExtHostApiDeprecationService),Se=tt.get(X.IExtHostWindow),se=tt.get(et.IExtHostSecretState),Me=tt.get(Xe.IExtHostEditorTabs);Ke.set(b.ExtHostContext.ExtHostFileSystemInfo,Pt),Ke.set(b.ExtHostContext.ExtHostLogLevelServiceShape,Wt),Ke.set(b.ExtHostContext.ExtHostWorkspace,mt),Ke.set(b.ExtHostContext.ExtHostConfiguration,xt),Ke.set(b.ExtHostContext.ExtHostExtensionService,At),Ke.set(b.ExtHostContext.ExtHostStorage,Nt),Ke.set(b.ExtHostContext.ExtHostTunnelService,Ae),Ke.set(b.ExtHostContext.ExtHostWindow,Se),Ke.set(b.ExtHostContext.ExtHostSecretState,se),Ke.set(b.ExtHostContext.ExtHostTelemetry,kt),Ke.set(b.ExtHostContext.ExtHostEditorTabs,Me);const ze=Ke.set(b.ExtHostContext.ExtHostDecorations,tt.get(ne.IExtHostDecorations)),Qe=Ke.set(b.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(s.IExtHostDocumentsAndEditors)),He=Ke.set(b.ExtHostContext.ExtHostCommands,tt.get(d.IExtHostCommands)),it=Ke.set(b.ExtHostContext.ExtHostTerminalService,tt.get(x.IExtHostTerminalService)),lt=Ke.set(b.ExtHostContext.ExtHostDebugService,tt.get(be.IExtHostDebugService)),Tt=Ke.set(b.ExtHostContext.ExtHostSearch,tt.get(Ie.IExtHostSearch)),St=Ke.set(b.ExtHostContext.ExtHostTask,tt.get(pe.IExtHostTask)),_t=Ke.set(b.ExtHostContext.ExtHostOutputService,tt.get(E.IExtHostOutputService)),It=Ke.set(b.ExtHostContext.ExtHostLocalization,tt.get(Ze.IExtHostLocalizationService)),yt=Ke.set(b.ExtHostContext.ExtHostUrls,new Y.ExtHostUrls(Ke)),Ct=Ke.set(b.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Ke,Qe)),Vt=Ke.set(b.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ke,Qe,vt)),Jt=Ke.set(b.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(vt,Ct,Ke.getProxy(b.MainContext.MainThreadBulkEdits))),Et=Ke.set(b.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(Ke,He,Qe,Ct)),si=Ke.set(b.ExtHostContext.ExtHostNotebookDocuments,new ue.ExtHostNotebookDocuments(Et)),oi=Ke.set(b.ExtHostContext.ExtHostNotebookEditors,new B.ExtHostNotebookEditors(vt,Et)),Zt=Ke.set(b.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Ke,ft,Et,He,vt)),vi=Ke.set(b.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ke,Et)),Rt=Ke.set(b.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(Ke,Qe)),zt=Ke.set(b.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(Ke.getProxy(b.MainContext.MainThreadTreeViews),He,vt)),bi=Ke.set(b.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Ke.getProxy(b.MainContext.MainThreadEditorInsets),Rt,ft.remote)),ai=Ke.set(b.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Ke,vt,Pt,Qe)),ei=Ke.set(b.ExtHostContext.ExtHostLanguages,new t.ExtHostLanguages(Ke,Ct,He.converter,Ot)),ut=Ke.set(b.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Ke,Ot,Ct,He,ai,vt,Oe,kt)),Ui=Ke.set(b.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Ke,ut)),Ut=Ke.set(b.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(Ke,vt,Qe)),Xt=Ke.set(b.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Ke,mt,He)),ci=Ke.set(b.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(Ke,He,vt)),Ei=Ke.set(b.ExtHostContext.ExtHostQuickDiff,new ct.ExtHostQuickDiff(Ke,Ot)),wi=Ke.set(b.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Ke,He,Ct)),li=Ke.set(b.ExtHostContext.ExtHostProgress,new y.ExtHostProgress(Ke.getProxy(b.MainContext.MainThreadProgress))),Si=Ke.set(b.ExtHostContext.ExtHosLabelService,new K.ExtHostLabelService(Ke)),ui=Ke.set(b.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(Ke)),ti=Ke.set(b.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(Ke)),xi=Ke.set(b.ExtHostContext.ExtHostTimeline,new G.ExtHostTimeline(Ke,He)),ii=Ke.set(b.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ke,ft.remote,mt,vt,Oe)),ni=Ke.set(b.ExtHostContext.ExtHostWebviewPanels,new ve.ExtHostWebviewPanels(Ke,ii,mt)),_i=Ke.set(b.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(Ke,Ct,Ft,ii,ni)),yi=Ke.set(b.ExtHostContext.ExtHostWebviewViews,new Ee.ExtHostWebviewViews(Ke,ii)),ri=Ke.set(b.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(Ke,He,Qe)),Ci=Ke.set(b.ExtHostContext.ExtHostUriOpeners,new je.ExtHostUriOpeners(Ke)),Di=Ke.set(b.ExtHostContext.ExtHostProfileContentHandlers,new gt.ExtHostProfileContentHandlers(Ke));Ke.set(b.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(Ke,Et,Qe,He,vt));const Bi=Object.values(b.ExtHostContext);Ke.assertRegistered(Bi);const Wi=new Ce.ExtHostBulkEdits(Ke,Qe),zi=new f.ExtHostClipboard(Ke),Ii=new c.ExtHostMessageService(Ke,vt),Ai=new C.ExtHostDialogs(Ke),Ri=new $.ExtHostStatusBar(Ke,He.converter);return w.ExtHostApiCommands.register(He),function(Be,Ht,Li){const bt=function(){let ge=!Be.isUnderDevelopment;function we(){ge||(vt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ne(ot){if(Array.isArray(ot))ot.forEach(Ne);else if(typeof ot=="string")we();else{const Dt=ot;typeof Dt.scheme>"u"&&we(),typeof Dt.exclusive=="boolean"&&(0,xe.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return ot}}(),Hi={getSession(ge,we,Ne){return ti.getSession(Be,ge,we,Ne)},async hasSession(ge,we){return(0,xe.checkProposedApiEnabled)(Be,"authSession"),!!await ti.getSession(Be,ge,we,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ge,we,Ne,ot){return ti.registerAuthenticationProvider(ge,we,Ne,ot)}},di={registerCommand(ge,we,Ne){return He.registerCommand(!0,ge,we,Ne,void 0,Be)},registerTextEditorCommand(ge,we,Ne){return He.registerCommand(!0,ge,(...ot)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){vt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return Dt.edit(Lt=>{we.apply(Ne,[Dt,Lt,...ot])}).then(Lt=>{Lt||vt.warn("Edits from command "+ge+" were not applied.")},Lt=>{vt.warn("An error occurred while running command "+ge,Lt)})},void 0,void 0,Be)},registerDiffInformationCommand:(ge,we,Ne)=>((0,xe.checkProposedApiEnabled)(Be,"diffCommand"),He.registerCommand(!0,ge,async(...ot)=>{const Dt=Qe.activeEditor(!0);if(!Dt){vt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Lt=await Rt.getDiffInformation(Dt.id);we.apply(Ne,[Lt,...ot])},void 0,void 0,Be)),executeCommand(ge,...we){return He.executeCommand(ge,...we)},getCommands(ge=!1){return He.getCommands(ge)}},Oi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return it.getDefaultShell(!1)},get onDidChangeShell(){return(0,xe.checkProposedApiEnabled)(Be,"envShellEvent"),it.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,xe.checkProposedApiEnabled)(Be,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.checkProposedApiEnabled)(Be,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return nt.ExtHostTelemetryLogger.validateSender(ge),kt.instantiateLogger(Be,ge)},openExternal(ge,we){return Se.openUri(ge,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===ft.environment.appUriScheme)return yt.createAppUri(ge);try{return await Se.asExternalUri(ge,{allowTunneling:!!ft.remote.authority})}catch(we){if((0,ce.matchesScheme)(ge,rt.Schemas.http)||(0,ce.matchesScheme)(ge,rt.Schemas.https))return ge;throw we}},get remoteName(){return(0,J.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,xe.checkProposedApiEnabled)(Be,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return vt.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(Oi);const $i={createTestController(ge,we,Ne){return ri.createTestController(Be,ge,we,Ne)},createTestObserver(){return(0,xe.checkProposedApiEnabled)(Be,"testObserver"),ri.createTestObserver()},runTests(ge){return(0,xe.checkProposedApiEnabled)(Be,"testObserver"),ri.runTests(ge)},get onDidChangeTestResults(){return(0,xe.checkProposedApiEnabled)(Be,"testObserver"),ri.onResultsChanged},get testResults(){return(0,xe.checkProposedApiEnabled)(Be,"testObserver"),ri.results}},hi=ft.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Vi={getExtension(ge,we){(0,xe.isProposedApiEnabled)(Be,"extensionsAny")||(we=!1);const Ne=Ht.mine.getExtensionDescription(ge);if(Ne)return new l.Extension(At,Be.identifier,Ne,hi,!1);if(we){const ot=Ht.all.getExtensionDescription(ge);if(ot)return new l.Extension(At,Be.identifier,ot,hi,!0)}},get all(){const ge=[];for(const we of Ht.mine.getAllExtensionDescriptions())ge.push(new l.Extension(At,Be.identifier,we,hi,!1));return ge},get allAcrossExtensionHosts(){(0,xe.checkProposedApiEnabled)(Be,"extensionsAny");const ge=new xe.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),we=[];for(const Ne of Ht.all.getAllExtensionDescriptions()){const ot=!ge.has(Ne.identifier);we.push(new l.Extension(At,Be.identifier,Ne,hi,ot))}return we},get onDidChange(){return(0,xe.isProposedApiEnabled)(Be,"extensionsAny")?u.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},ki={createDiagnosticCollection(ge){return ai.createDiagnosticCollection(Be.identifier,ge)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ge=>ai.getDiagnostics(ge),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ge,we){return ei.changeLanguage(ge.uri,we)},match(ge,we){const Ne=Ct.getDocumentData(we.uri)?.notebook;return(0,R.score)(U.LanguageSelector.from(ge),we.uri,we.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ge,we,Ne){return ut.registerCodeActionProvider(Be,bt(ge),we,Ne)},registerDocumentPasteEditProvider(ge,we,Ne){return(0,xe.checkProposedApiEnabled)(Be,"documentPaste"),ut.registerDocumentPasteEditProvider(Be,bt(ge),we,Ne)},registerCodeLensProvider(ge,we){return ut.registerCodeLensProvider(Be,bt(ge),we)},registerDefinitionProvider(ge,we){return ut.registerDefinitionProvider(Be,bt(ge),we)},registerDeclarationProvider(ge,we){return ut.registerDeclarationProvider(Be,bt(ge),we)},registerImplementationProvider(ge,we){return ut.registerImplementationProvider(Be,bt(ge),we)},registerTypeDefinitionProvider(ge,we){return ut.registerTypeDefinitionProvider(Be,bt(ge),we)},registerHoverProvider(ge,we){return ut.registerHoverProvider(Be,bt(ge),we,Be.identifier)},registerEvaluatableExpressionProvider(ge,we){return ut.registerEvaluatableExpressionProvider(Be,bt(ge),we,Be.identifier)},registerInlineValuesProvider(ge,we){return ut.registerInlineValuesProvider(Be,bt(ge),we,Be.identifier)},registerDocumentHighlightProvider(ge,we){return ut.registerDocumentHighlightProvider(Be,bt(ge),we)},registerLinkedEditingRangeProvider(ge,we){return ut.registerLinkedEditingRangeProvider(Be,bt(ge),we)},registerReferenceProvider(ge,we){return ut.registerReferenceProvider(Be,bt(ge),we)},registerRenameProvider(ge,we){return ut.registerRenameProvider(Be,bt(ge),we)},registerDocumentSymbolProvider(ge,we,Ne){return ut.registerDocumentSymbolProvider(Be,bt(ge),we,Ne)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(Be,ge)},registerDocumentFormattingEditProvider(ge,we){return ut.registerDocumentFormattingEditProvider(Be,bt(ge),we)},registerDocumentRangeFormattingEditProvider(ge,we){return ut.registerDocumentRangeFormattingEditProvider(Be,bt(ge),we)},registerOnTypeFormattingEditProvider(ge,we,Ne,...ot){return ut.registerOnTypeFormattingEditProvider(Be,bt(ge),we,[Ne].concat(ot))},registerDocumentSemanticTokensProvider(ge,we,Ne){return ut.registerDocumentSemanticTokensProvider(Be,bt(ge),we,Ne)},registerDocumentRangeSemanticTokensProvider(ge,we,Ne){return ut.registerDocumentRangeSemanticTokensProvider(Be,bt(ge),we,Ne)},registerSignatureHelpProvider(ge,we,Ne,...ot){return typeof Ne=="object"?ut.registerSignatureHelpProvider(Be,bt(ge),we,Ne):ut.registerSignatureHelpProvider(Be,bt(ge),we,typeof Ne>"u"?[]:[Ne,...ot])},registerCompletionItemProvider(ge,we,...Ne){return ut.registerCompletionItemProvider(Be,bt(ge),we,Ne)},registerInlineCompletionItemProvider(ge,we){return we.handleDidShowCompletionItem&&(0,xe.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),we.handleDidPartiallyAcceptCompletionItem&&(0,xe.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Be,bt(ge),we)},registerDocumentLinkProvider(ge,we){return ut.registerDocumentLinkProvider(Be,bt(ge),we)},registerColorProvider(ge,we){return ut.registerColorProvider(Be,bt(ge),we)},registerFoldingRangeProvider(ge,we){return ut.registerFoldingRangeProvider(Be,bt(ge),we)},registerSelectionRangeProvider(ge,we){return ut.registerSelectionRangeProvider(Be,ge,we)},registerCallHierarchyProvider(ge,we){return ut.registerCallHierarchyProvider(Be,ge,we)},registerTypeHierarchyProvider(ge,we){return ut.registerTypeHierarchyProvider(Be,ge,we)},setLanguageConfiguration:(ge,we)=>ut.setLanguageConfiguration(Be,ge,we),getTokenInformationAtPosition(ge,we){return(0,xe.checkProposedApiEnabled)(Be,"tokenInformation"),ei.tokenAtPosition(ge,we)},registerInlayHintsProvider(ge,we){return ut.registerInlayHintsProvider(Be,ge,we)},createLanguageStatusItem(ge,we){return ei.createLanguageStatusItem(Be,ge,we)},registerDocumentDropEditProvider(ge,we){return ut.registerDocumentOnDropEditProvider(Be,ge,we)}},ji={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(ge,we,Ne){const ot=await(_.URI.isUri(ge)?Promise.resolve(jt.openTextDocument(ge)):Promise.resolve(ge));return Rt.showTextDocument(ot,we,Ne)},createTextEditorDecorationType(ge){return Rt.createTextEditorDecorationType(Be,ge)},onDidChangeActiveTextEditor(ge,we,Ne){return Rt.onDidChangeActiveTextEditor(ge,we,Ne)},onDidChangeVisibleTextEditors(ge,we,Ne){return Rt.onDidChangeVisibleTextEditors(ge,we,Ne)},onDidChangeTextEditorSelection(ge,we,Ne){return Rt.onDidChangeTextEditorSelection(ge,we,Ne)},onDidChangeTextEditorOptions(ge,we,Ne){return Rt.onDidChangeTextEditorOptions(ge,we,Ne)},onDidChangeTextEditorVisibleRanges(ge,we,Ne){return Rt.onDidChangeTextEditorVisibleRanges(ge,we,Ne)},onDidChangeTextEditorViewColumn(ge,we,Ne){return Rt.onDidChangeTextEditorViewColumn(ge,we,Ne)},onDidCloseTerminal(ge,we,Ne){return it.onDidCloseTerminal(ge,we,Ne)},onDidOpenTerminal(ge,we,Ne){return it.onDidOpenTerminal(ge,we,Ne)},onDidChangeActiveTerminal(ge,we,Ne){return it.onDidChangeActiveTerminal(ge,we,Ne)},onDidChangeTerminalDimensions(ge,we,Ne){return(0,xe.checkProposedApiEnabled)(Be,"terminalDimensions"),it.onDidChangeTerminalDimensions(ge,we,Ne)},onDidChangeTerminalState(ge,we,Ne){return it.onDidChangeTerminalState(ge,we,Ne)},onDidWriteTerminalData(ge,we,Ne){return(0,xe.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),it.onDidWriteTerminalData(ge,we,Ne)},get state(){return Se.state},onDidChangeWindowState(ge,we,Ne){return Se.onDidChangeWindowState(ge,we,Ne)},showInformationMessage(ge,...we){return Ii.showMessage(Be,A.default.Info,ge,we[0],we.slice(1))},showWarningMessage(ge,...we){return Ii.showMessage(Be,A.default.Warning,ge,we[0],we.slice(1))},showErrorMessage(ge,...we){return Ii.showMessage(Be,A.default.Error,ge,we[0],we.slice(1))},showQuickPick(ge,we,Ne){return Xt.showQuickPick(ge,we,Ne)},showWorkspaceFolderPick(ge){return Xt.showWorkspaceFolderPick(ge)},showInputBox(ge,we){return Xt.showInput(ge,we)},showOpenDialog(ge){return Ai.showOpenDialog(ge)},showSaveDialog(ge){return Ai.showSaveDialog(ge)},createStatusBarItem(ge,we,Ne){let ot,Dt,Lt;return typeof ge=="string"?(ot=ge,Dt=we,Lt=Ne):(Dt=ge,Lt=we),Ri.createStatusBarEntry(Be,ot,Dt,Lt)},setStatusBarMessage(ge,we){return Ri.setStatusBarMessage(ge,we)},withScmProgress(ge){return Oe.report("window.withScmProgress",Be,"Use 'withProgress' instead."),li.withProgress(Be,{location:H.ProgressLocation.SourceControl},(we,Ne)=>ge({report(ot){}}))},withProgress(ge,we){return li.withProgress(Be,ge,we)},createOutputChannel(ge,we){return _t.createOutputChannel(ge,we,Be)},createWebviewPanel(ge,we,Ne,ot){return ni.createWebviewPanel(Be,ge,we,Ne,ot)},createWebviewTextEditorInset(ge,we,Ne,ot){return(0,xe.checkProposedApiEnabled)(Be,"editorInsets"),bi.createWebviewEditorInset(ge,we,Ne,ot,Be)},createTerminal(ge,we,Ne){return typeof ge=="object"?"pty"in ge?it.createExtensionTerminal(ge):it.createTerminalFromOptions(ge):it.createTerminal(ge,we,Ne)},registerTerminalLinkProvider(ge){return it.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,we){return it.registerProfileProvider(Be,ge,we)},registerTerminalQuickFixProvider(ge,we){return(0,xe.checkProposedApiEnabled)(Be,"terminalQuickFixProvider"),it.registerTerminalQuickFixProvider(ge,Be.identifier.value,we)},registerTreeDataProvider(ge,we){return zt.registerTreeDataProvider(ge,we,Be)},createTreeView(ge,we){return zt.createTreeView(ge,we,Be)},registerWebviewPanelSerializer:(ge,we)=>ni.registerWebviewPanelSerializer(Be,ge,we),registerCustomEditorProvider:(ge,we,Ne={})=>_i.registerCustomEditorProvider(Be,ge,we,Ne),registerFileDecorationProvider(ge){return ze.registerFileDecorationProvider(ge,Be)},registerUriHandler(ge){return yt.registerUriHandler(Be.identifier,ge)},createQuickPick(){return Xt.createQuickPick(Be)},createInputBox(){return Xt.createInputBox(Be)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ge,we,Ne){return ui.onDidChangeActiveColorTheme(ge,we,Ne)},registerWebviewViewProvider(ge,we,Ne){return yi.registerWebviewViewProvider(Be,ge,we,Ne?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,we,Ne){return Et.onDidChangeActiveNotebookEditor(ge,we,Ne)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,we,Ne){return oi.onDidChangeNotebookEditorSelection(ge,we,Ne)},onDidChangeNotebookEditorVisibleRanges(ge,we,Ne){return oi.onDidChangeNotebookEditorVisibleRanges(ge,we,Ne)},showNotebookDocument(ge,we){return Et.showNotebookDocument(ge,we)},registerExternalUriOpener(ge,we,Ne){return(0,xe.checkProposedApiEnabled)(Be,"externalUriOpener"),Ci.registerExternalUriOpener(Be.identifier,ge,we,Ne)},registerProfileContentHandler(ge,we){return(0,xe.checkProposedApiEnabled)(Be,"profileContentHandlers"),Di.registrProfileContentHandler(Be,ge,we)},registerQuickDiffProvider(ge,we,Ne,ot){return(0,xe.checkProposedApiEnabled)(Be,"quickDiffProvider"),Ei.registerQuickDiffProvider(bt(ge),we,Ne,ot)},get tabGroups(){return Me.tabGroups}},jt={get rootPath(){return Oe.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw P.readonly()},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw P.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw P.readonly()},updateWorkspaceFolders:(ge,we,...Ne)=>mt.updateWorkspaceFolders(Be,ge,we||0,...Ne),onDidChangeWorkspaceFolders:function(ge,we,Ne){return mt.onDidChangeWorkspace(ge,we,Ne)},asRelativePath:(ge,we)=>mt.getRelativePath(ge,we),findFiles:(ge,we,Ne,ot)=>mt.findFiles(ge,we,Ne,Be.identifier,ot),findTextInFiles:(ge,we,Ne,ot)=>{(0,xe.checkProposedApiEnabled)(Be,"findTextInFiles");let Dt,Lt;return typeof we=="object"?(Dt=we,Lt=Ne):(Dt={},Lt=we,ot=Ne),mt.findTextInFiles(ge,Dt||{},Lt,Be.identifier,ot)},saveAll:ge=>mt.saveAll(ge),applyEdit(ge,we){return Wi.applyWorkspaceEdit(ge,Be,we)},createFileSystemWatcher:(ge,we,Ne,ot)=>Ut.createFileSystemWatcher(mt,Be,ge,we,Ne,ot),get textDocuments(){return Ct.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw P.readonly()},openTextDocument(ge){let we;const Ne=ge;if(typeof ge=="string")we=Promise.resolve(_.URI.file(ge));else if(_.URI.isUri(ge))we=Promise.resolve(ge);else if(!Ne||typeof Ne=="object")we=Ct.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(ot=>Ct.ensureDocumentData(ot).then(Dt=>Dt.document))},onDidOpenTextDocument:(ge,we,Ne)=>Ct.onDidAddDocument(ge,we,Ne),onDidCloseTextDocument:(ge,we,Ne)=>Ct.onDidRemoveDocument(ge,we,Ne),onDidChangeTextDocument:(ge,we,Ne)=>Ct.onDidChangeDocument(ge,we,Ne),onDidSaveTextDocument:(ge,we,Ne)=>Ct.onDidSaveDocument(ge,we,Ne),onWillSaveTextDocument:(ge,we,Ne)=>Jt.getOnWillSaveTextDocumentEvent(Be)(ge,we,Ne),get notebookDocuments(){return Et.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,we){let Ne;if(_.URI.isUri(ge))Ne=ge,await Et.openNotebookDocument(ge);else if(typeof ge=="string")Ne=_.URI.revive(await Et.createNotebookDocument({viewType:ge,content:we}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ge,we,Ne){return si.onDidSaveNotebookDocument(ge,we,Ne)},onDidChangeNotebookDocument(ge,we,Ne){return si.onDidChangeNotebookDocument(ge,we,Ne)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ge,we,Ne,ot){return Et.registerNotebookSerializer(Be,ge,we,Ne,(0,xe.isProposedApiEnabled)(Be,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ge,we,Ne)=>Li.onDidChangeConfiguration(ge,we,Ne),getConfiguration(ge,we){return we=arguments.length===1?void 0:we,Li.getConfiguration(ge,we,Be)},registerTextDocumentContentProvider(ge,we){return Vt.registerTextDocumentContentProvider(ge,we)},registerTaskProvider:(ge,we)=>(Oe.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Be,ge,we)),registerFileSystemProvider(ge,we,Ne){return(0,Re.combinedDisposable)(Ui.registerFileSystemProvider(Be,ge,we,Ne),Gt.addFileSystemProvider(ge,we))},get fs(){return Gt.value},registerFileSearchProvider:(ge,we)=>((0,xe.checkProposedApiEnabled)(Be,"fileSearchProvider"),Tt.registerFileSearchProvider(ge,we)),registerTextSearchProvider:(ge,we)=>((0,xe.checkProposedApiEnabled)(Be,"textSearchProvider"),Tt.registerTextSearchProvider(ge,we)),registerRemoteAuthorityResolver:(ge,we)=>((0,xe.checkProposedApiEnabled)(Be,"resolvers"),At.registerRemoteAuthorityResolver(ge,we)),registerResourceLabelFormatter:ge=>((0,xe.checkProposedApiEnabled)(Be,"resolvers"),Si.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,we,Ne)=>Ut.onDidCreateFile(ge,we,Ne),onDidDeleteFiles:(ge,we,Ne)=>Ut.onDidDeleteFile(ge,we,Ne),onDidRenameFiles:(ge,we,Ne)=>Ut.onDidRenameFile(ge,we,Ne),onWillCreateFiles:(ge,we,Ne)=>Ut.getOnWillCreateFileEvent(Be)(ge,we,Ne),onWillDeleteFiles:(ge,we,Ne)=>Ut.getOnWillDeleteFileEvent(Be)(ge,we,Ne),onWillRenameFiles:(ge,we,Ne)=>Ut.getOnWillRenameFileEvent(Be)(ge,we,Ne),openTunnel:ge=>((0,xe.checkProposedApiEnabled)(Be,"tunnels"),Ae.openTunnel(Be,ge).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,xe.checkProposedApiEnabled)(Be,"tunnels"),Ae.getTunnels()},onDidChangeTunnels:(ge,we,Ne)=>((0,xe.checkProposedApiEnabled)(Be,"tunnels"),Ae.onDidChangeTunnels(ge,we,Ne)),registerPortAttributesProvider:(ge,we)=>((0,xe.checkProposedApiEnabled)(Be,"portsAttributes"),Ae.registerPortsAttributesProvider(ge,we)),registerTimelineProvider:(ge,we)=>((0,xe.checkProposedApiEnabled)(Be,"timeline"),xi.registerTimelineProvider(ge,we,Be.identifier,He.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,xe.checkProposedApiEnabled)(Be,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,we,Ne)=>mt.onDidGrantWorkspaceTrust(ge,we,Ne),registerEditSessionIdentityProvider:(ge,we)=>((0,xe.checkProposedApiEnabled)(Be,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,we)),onWillCreateEditSessionIdentity:(ge,we,Ne)=>((0,xe.checkProposedApiEnabled)(Be,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(Be)(ge,we,Ne))},fi={get inputBox(){return Oe.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Be)},createSourceControl(ge,we,Ne){return ci.createSourceControl(Be,ge,we,Ne)}},qi={createCommentController(ge,we){return wi.createCommentController(Be,ge,we)}},Bt={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ge,we,Ne){return lt.onDidStartDebugSession(ge,we,Ne)},onDidTerminateDebugSession(ge,we,Ne){return lt.onDidTerminateDebugSession(ge,we,Ne)},onDidChangeActiveDebugSession(ge,we,Ne){return lt.onDidChangeActiveDebugSession(ge,we,Ne)},onDidReceiveDebugSessionCustomEvent(ge,we,Ne){return lt.onDidReceiveDebugSessionCustomEvent(ge,we,Ne)},onDidChangeBreakpoints(ge,we,Ne){return lt.onDidChangeBreakpoints(ge,we,Ne)},registerDebugConfigurationProvider(ge,we,Ne){return lt.registerDebugConfigurationProvider(ge,we,Ne||Ge.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,we){return lt.registerDebugAdapterDescriptorFactory(Be,ge,we)},registerDebugAdapterTrackerFactory(ge,we){return lt.registerDebugAdapterTrackerFactory(ge,we)},startDebugging(ge,we,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?lt.startDebugging(ge,we,{parentSession:Ne}):lt.startDebugging(ge,we,Ne||{})},stopDebugging(ge){return lt.stopDebugging(ge)},addBreakpoints(ge){return lt.addBreakpoints(ge)},removeBreakpoints(ge){return lt.removeBreakpoints(ge)},asDebugSourceUri(ge,we){return lt.asDebugSourceUri(ge,we)}},mi={registerTaskProvider:(ge,we)=>St.registerTaskProvider(Be,ge,we),fetchTasks:ge=>St.fetchTasks(ge),executeTask:ge=>St.executeTask(Be,ge),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ge,we,Ne)=>St.onDidStartTask(ge,we,Ne),onDidEndTask:(ge,we,Ne)=>St.onDidEndTask(ge,we,Ne),onDidStartTaskProcess:(ge,we,Ne)=>St.onDidStartTaskProcess(ge,we,Ne),onDidEndTaskProcess:(ge,we,Ne)=>St.onDidEndTaskProcess(ge,we,Ne)},Gi={createNotebookController(ge,we,Ne,ot,Dt){return Zt.createNotebookController(Be,ge,we,Ne,ot,(0,xe.isProposedApiEnabled)(Be,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,we)=>Et.registerNotebookCellStatusBarItemProvider(Be,ge,we),createRendererMessaging(ge){return vi.createRendererMessaging(Be,ge)},createNotebookControllerDetectionTask(ge){return(0,xe.checkProposedApiEnabled)(Be,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Be,ge)},registerKernelSourceActionProvider(ge,we){return(0,xe.checkProposedApiEnabled)(Be,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Be,ge,we)},onDidChangeNotebookCellExecutionState(ge,we,Ne){return(0,xe.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ge,we,Ne)}},Ki={t(...ge){if(typeof ge[0]=="string"){const we=ge.shift(),Ne=!ge||typeof ge[0]!="object"?ge:ge[0];return It.getMessage(Be.identifier.value,{message:we,args:Ne})}return It.getMessage(Be.identifier.value,ge[0])},get bundle(){return It.getBundle(Be.identifier.value)},get uri(){return It.getBundleUri(Be.identifier.value)}};return{version:ft.version,authentication:Hi,commands:di,comments:qi,debug:Bt,env:Oi,extensions:Vi,l10n:Ki,languages:ki,notebooks:Gi,scm:fi,tasks:mi,tests:$i,window:ji,workspace:jt,Breakpoint:H.Breakpoint,TerminalOutputAnchor:H.TerminalOutputAnchor,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:b.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ge.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:u.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileDecoration2:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestionList,Hover:H.Hover,IndentAction:D.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalQuickFixCommand:H.TerminalQuickFixCommand,TerminalQuickFixOpener:H.TerminalQuickFixOpener,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TerminalExitReason:H.TerminalExitReason,TerminalQuickFixType:H.TerminalQuickFixType,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,SnippetTextEdit:H.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItem2:H.TreeItem,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:k.UIKind,Uri:_.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,DocumentDropEdit:H.DocumentDropEdit,DocumentPasteEdit:H.DocumentPasteEdit,InlayHint:H.InlayHint,InlayHintLabelPart:H.InlayHintLabelPart,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.NotebookEdit,NotebookKernelSourceAction:H.NotebookKernelSourceAction,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestRunRequest2:H.TestRunRequest2,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:H.DataTransfer,DataTransferItem:H.DataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.TextTabInput,TabInputTextDiff:H.TextDiffTabInput,TabInputTextMerge:H.TextMergeTabInput,TabInputCustom:H.CustomEditorTabInput,TabInputNotebook:H.NotebookEditorTabInput,TabInputNotebookDiff:H.NotebookDiffEditorTabInput,TabInputWebview:H.WebviewEditorTabInput,TabInputTerminal:H.TerminalEditorTabInput,TabInputInteractiveWindow:H.InteractiveWindowInput,TelemetryTrustedValue:de.TelemetryTrustedValue,LogLevel:Le.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=wt}),define(_e[312],ye([1,0,284,322,323,2,324]),function(ie,e,a,P,u,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(I,b,k,w,f,d){const h=d.environment.useHostProxy,g=typeof h=="boolean"?h:!d.remote.isRemote,v=(0,_.createProxyResolver)({resolveProxy:p=>I.resolveProxy(p),getHttpProxySetting:()=>b.getConfiguration("http").get("proxy"),log:(p,i,...o)=>{switch(p){case _.LogLevel.Trace:w.trace(i,...o);break;case _.LogLevel.Debug:w.debug(i,...o);break;case _.LogLevel.Info:w.info(i,...o);break;case _.LogLevel.Warning:w.warn(i,...o);break;case _.LogLevel.Error:w.error(i,...o);break;case _.LogLevel.Critical:w.error(i,...o);break;case _.LogLevel.Off:break;default:s(p,i,o);break}function s(l,r,...m){w.error("Unknown log level",l),w.error(r,...m)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:g,env:process.env}),C=S(b,v);return R(k,C)}e.connectProxyResolver=T;function S(I,b){const k={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(f=>{k.config=I.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(f=>{w.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,_.createHttpPatch)(a,b,{config:"off"},w,!0)),on:Object.assign({},a,(0,_.createHttpPatch)(a,b,{config:"on"},w,!0)),override:Object.assign({},a,(0,_.createHttpPatch)(a,b,{config:"override"},w,!0)),onRequest:Object.assign({},a,(0,_.createHttpPatch)(a,b,k,w,!0)),default:Object.assign(a,(0,_.createHttpPatch)(a,b,k,w,!1))},https:{off:Object.assign({},P,(0,_.createHttpPatch)(P,b,{config:"off"},w,!0)),on:Object.assign({},P,(0,_.createHttpPatch)(P,b,{config:"on"},w,!0)),override:Object.assign({},P,(0,_.createHttpPatch)(P,b,{config:"override"},w,!0)),onRequest:Object.assign({},P,(0,_.createHttpPatch)(P,b,k,w,!0)),default:Object.assign(P,(0,_.createHttpPatch)(P,b,k,w,!1))},tls:Object.assign(u,(0,_.createTlsPatch)(u))}}const D=new Map;function R(I,b){return I.getExtensionPathIndex().then(k=>{const w=globalThis._VSCODE_NODE_MODULES.module,f=w._load;w._load=function(h,g,v){if(h==="tls")return b.tls;if(h!=="http"&&h!=="https")return f.apply(this,arguments);const C=b[h],p=k.findSubstr(A.URI.file(g.filename));let i=D.get(p);if(i||D.set(p,i={}),!i[h]){const o=C.default;i[h]={...o}}return i[h]}})}}),define(_e[313],ye([1,0,83,311,298,312,42,286,2,14,7,283,115,285]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends u.RequireInterceptor{_installInterceptor(){const h=this,g=globalThis._VSCODE_NODE_MODULES.module,v=g._load;g._load=function(o,s,l){return o=p(o),h._factories.has(o)?h._factories.get(o).load(o,S.URI.file((0,b.realpathSync)(s.filename)),r=>v.apply(this,[r,s,l])):v.apply(this,arguments)};const C=g._resolveLookupPaths;g._resolveLookupPaths=(i,o)=>C.call(this,p(i),o);const p=i=>{for(const o of h._alternatives){const s=o(i);if(s){i=s;break}}return i}}}class f extends _.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(k.ExtHostConsoleForwarder);const h=this._instaService.invokeFunction(P.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(T.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const C=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=C.ipcHandlePath}await this._instaService.createInstance(w,h,{mine:this._myRegistry,all:this._globalRegistry}).install(),a.mark("code/extHost/didInitAPI");const v=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,v,this,this._logService,this._mainThreadTelemetryProxy,this._initData),a.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(h){return h.main}async _loadCommonJSModule(h,g,v){if(g.scheme!==D.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let C=null;v.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this._logService.flush();const p=h?.identifier.value;h&&await this._extHostLocalizationService.initializeLocalizedMessages(h);try{p&&a.mark(`code/extHost/willLoadExtensionCode/${p}`),C=ie.__$__nodeRequire(g.fsPath)}finally{p&&a.mark(`code/extHost/didLoadExtensionCode/${p}`),v.codeLoadingStop()}return C}async $setRemoteEnvironment(h){if(!!this._initData.remote.isRemote)for(const g in h){const v=h[g];v===null?delete process.env[g]:process.env[g]=v}}}e.ExtHostExtensionService=f}),define(_e[145],ye([1,0,46,325,307,16,61,38,10,8,2,31,81,326,305,100]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(c){this.outputChannel=c}provideTextSearchResults(c,E,y,M){return this.outputChannel.appendLine(`provideTextSearchResults ${c.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((j,$)=>{M.onCancellationRequested(()=>Y());const N=o(c,E),x=E.folder.fsPath,L=N.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.outputChannel.appendLine(`${d} ${L}
 - cwd: ${x}`);let F=a.spawn(d,N,{cwd:x});F.on("error",K=>{console.error(K),this.outputChannel.appendLine("Error: "+(K&&K.message)),$((0,I.serializeSearchError)(new I.SearchError(K&&K.message,I.SearchErrorCode.rgProcessError)))});let U=!1;const H=new C(E.maxResults,x,E.previewOptions);H.on("result",K=>{U=!0,X="",y.report(K)});let de=!1;const Y=()=>{de=!0,F?.kill(),H?.cancel()};let V=!1;H.on("hitLimit",()=>{V=!0,Y()});let X="";F.stdout.on("data",K=>{H.handleData(K),U||(X+=K)});let Z=!1;F.stdout.once("data",()=>Z=!0);let te="";F.stderr.on("data",K=>{const J=K.toString();this.outputChannel.appendLine(J),te.length+J.length<1e6&&(te+=J)}),F.on("close",()=>{if(this.outputChannel.appendLine(Z?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),X&&this.outputChannel.appendLine(`Got data without result: ${X}`),this.outputChannel.appendLine(""),de)j({limitHit:V});else{H.flush(),F=null;let K;te&&!Z&&(K=g(te))?$((0,I.serializeSearchError)(new I.SearchError(K.message,K.code))):j({limitHit:V})}})})}}e.RipgrepTextSearchEngine=h;function g(t){const c=t.split(`
`),E=c[0].trim();if(c.some(M=>M.startsWith("regex parse error")))return new I.SearchError(v(c),I.SearchErrorCode.regexParseError);const y=E.match(/grep config error: unknown encoding: (.*)/);if(y)return new I.SearchError(`Unknown encoding: ${y[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}function v(t){const c=["Regex parse error"],E=t.filter(y=>y.startsWith("PCRE2:"));if(E.length>=1){const y=E[0].replace("PCRE2:","");if(y.indexOf(":")!==-1&&y.split(":").length>=2){const M=y.split(":")[1];c.push(":"+M)}}return c.join("")}class C extends P.EventEmitter{constructor(c,E,y){super(),this.maxResults=c,this.rootFolder=E,this.previewOptions=y,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new u.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(c,E){return super.on(c,E),this}handleData(c){if(this.isDone)return;const E=typeof c=="string"?c:this.stringDecoder.write(c);this.handleDecodedData(E)}handleDecodedData(c){let E=c.indexOf(`
`);const y=this.remainder+c;if(E>=0)E+=this.remainder.length;else{this.remainder=y;return}let M=0;for(;E>=0;)this.handleLine(y.substring(M,E).trim()),M=E+1,E=y.indexOf(`
`,M);this.remainder=y.substring(M)}handleLine(c){if(this.isDone||!c)return;let E;try{E=JSON.parse(c)}catch{throw new Error(`malformed line from rg: ${c}`)}if(E.type==="match"){const y=p(E.data.path),M=R.URI.file(S.join(this.rootFolder,y)),j=this.createTextSearchMatch(E.data,M);this.onResult(j),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const y=p(E.data.path),M=R.URI.file(S.join(this.rootFolder,y));this.createTextSearchContext(E.data,M).forEach($=>this.onResult($))}}createTextSearchMatch(c,E){const y=c.line_number-1,M=p(c.lines),j=Buffer.from(M);let $=0,N=0,x=y;c.submatches.length===0&&c.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const L=(0,A.coalesce)(c.submatches.map((F,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const H=p(F.match),de=j.slice($,F.start).toString(),Y=i(de),V=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+N,X=i(H),Z=Y.numLines+x,te=X.numLines+Z,K=X.numLines>0?X.lastLineLength:X.lastLineLength+V;return $=F.end,N=K,x=te,new b.Range(Z,V,te,K)}));return(0,f.createTextSearchResult)(E,M,L,this.previewOptions)}createTextSearchContext(c,E){const y=p(c.lines),M=c.line_number;return y.replace(/\r?\n$/,"").split(`
`).map((j,$)=>({text:j,uri:E,lineNumber:M+$}))}onResult(c){this.emit("result",c)}}e.RipgrepParser=C;function p(t){return t.bytes?Buffer.from(t.bytes,"base64").toString():t.text}function i(t){const c=/\n/g;let E=0,y=-1,M;for(;M=c.exec(t);)E++,y=M.index;const j=y>=0?t.length-y-1:t.length;return{numLines:E,lastLineLength:j}}function o(t,c){const E=["--hidden"];E.push(t.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:y,otherIncludes:M}=(0,_.groupBy)(c.includes,$=>$.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const $=new Set;M.forEach(N=>{$.add(N)}),E.push("-g","!*"),$.forEach(N=>{s(N).map(f.anchorGlob).forEach(x=>{E.push("-g",x)})})}y&&y.length&&y.forEach($=>{E.push("-g",$)}),c.excludes.map(f.anchorGlob).forEach($=>E.push("-g",`!${$}`)),c.maxFileSize&&E.push("--max-filesize",c.maxFileSize+""),c.useIgnoreFiles?c.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),c.followSymlinks&&E.push("--follow"),c.encoding&&c.encoding!=="utf8"&&E.push("--encoding",c.encoding),t.pattern==="--"&&(t.isRegExp=!0,t.pattern="\\-\\-"),t.isMultiline&&!t.isRegExp&&(t.pattern=(0,D.escapeRegExpCharacters)(t.pattern),t.isRegExp=!0),c.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),t.isRegExp&&(t.pattern=l(t.pattern),E.push("--engine","auto"));let j;if(t.isWordMatch){const N=(0,D.createRegExp)(t.pattern,!!t.isRegExp,{wholeWord:t.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",N)}else if(t.isRegExp){let $=m(t.pattern);$=n($),E.push("--regexp",$)}else j=t.pattern,E.push("--fixed-strings");return E.push("--no-config"),c.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),t.isMultiline&&E.push("--multiline"),c.beforeContext&&E.push("--before-context",c.beforeContext+""),c.afterContext&&E.push("--after-context",c.afterContext+""),E.push("--"),j&&E.push(j),E.push("."),E}function s(t){const c=(0,T.splitGlobAware)(t,"/");return c.map((E,y)=>c.slice(0,y+1).join("/"))}function l(t){const c=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;t.match(c);)t=t.replace(c,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;t.match(E);)t=t.replace(E,"$1\\x{$2}");return t}e.unicodeEscapesToPCRE2=l;const r=t=>t.type==="Assertion"&&t.kind==="lookbehind";function m(t){let c;try{c=new k.RegExpParser().parsePattern(t)}catch{return t}let E="",y=0;const M=(N,x,L)=>{E+=t.slice(y,N)+L,y=x},j=[];return new k.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const x=j[0];if(!x)M(N.start,N.end,"\\r?\\n");else if(!j.some(r))if(x.type==="CharacterClass")if(x.negate){const L=t.slice(x.start+2,N.start)+t.slice(N.end,x.end-1);x.parent?.type==="Quantifier"?M(x.start,x.end,L?`[^${L}]`:"."):M(x.start,x.end,"(?!\\r?\\n"+(L?`|[${L}]`:"")+")")}else{const L=t.slice(x.start+1,N.start)+t.slice(N.end,x.end-1);M(x.start,x.end,L===""?"\\r?\\n":`(?:[${L}]|\\r?\\n)`)}else x.type==="Quantifier"&&M(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){j.unshift(N)},onQuantifierLeave(){j.shift()},onCharacterClassRangeEnter(N){j.unshift(N)},onCharacterClassRangeLeave(){j.shift()},onCharacterClassEnter(N){j.unshift(N)},onCharacterClassLeave(){j.shift()},onAssertionEnter(N){r(N)&&j.push(N)},onAssertionLeave(N){j[0]===N&&j.shift()}}).visit(c),E+=t.slice(y),E}e.fixRegexNewline=m;function n(t){return t.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(_e[314],ye([1,0,21,145,126,14]),function(ie,e,a,P,u,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class _{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,R,I,b){const k=new P.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===A.Schemas.vscodeUserData){const w={...R,folder:R.folder.with({scheme:A.Schemas.file})},f=new u.Progress(d=>I.report({...d,uri:d.uri.with({scheme:R.folder.scheme})}));return this.withToken(b,d=>k.provideTextSearchResults(D,w,f,d))}else return this.withToken(b,w=>k.provideTextSearchResults(D,R,I,w))}async withToken(D,R){const I=T(D);this.inProgress.add(I);const b=await R(I.token);return this.inProgress.delete(I),b}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=_;function T(S){const D=new a.CancellationTokenSource;return S.onCancellationRequested(()=>D.cancel()),D}}),define(_e[315],ye([1,0,29,145,144]),function(ie,e,a,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.query=S}search(S,D,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(k){R({message:k})}},b=new u.NativeTextSearchManager(this.query,new P.RipgrepTextSearchEngine(I),a);return new Promise((k,w)=>b.search(f=>{D(f.map(_))},S).then(f=>k({limitHit:f.limitHit,type:"success",stats:f.stats}),w))}}e.TextSearchEngineAdapter=A;function _(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,D)=>{if(D.ranges){const R=D;return S+(Array.isArray(R.ranges)?R.ranges.length:1)}else return S+1},0)}}}),define(_e[316],ye([1,0,16,19,11,3,111,10,43,2,44,31,306,315]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(C="searchProcess"){this.processType=C,this.caches=Object.create(null)}fileSearch(C){let p;const i=h(C),o=new A.Emitter({onDidAddFirstListener:()=>{p=(0,P.createCancelablePromise)(s=>this.doFileSearchWithEngine(b.Engine,i,l=>o.fire(l),s)),p.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}textSearch(C){let p;const i=h(C),o=new A.Emitter({onDidAddFirstListener:()=>{p=(0,P.createCancelablePromise)(s=>this.ripgrepTextSearch(i,l=>o.fire(l),s)),p.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}ripgrepTextSearch(C,p,i){return C.maxFileSize=(0,R.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new k.TextSearchEngineAdapter(C).search(i,p,p)}doFileSearch(C,p,i){return this.doFileSearchWithEngine(b.Engine,C,p,i)}doFileSearchWithEngine(C,p,i,o,s=w.BATCH_SIZE){let l=0;const r=n=>{Array.isArray(n)?(l+=n.length,i(n.map(t=>this.rawMatchToSearchItem(t)))):n.relativePath?(l++,i(this.rawMatchToSearchItem(n))):i(n)};if(p.sortByScore){let n=this.trySortedSearchFromCache(p,r,o);if(!n){const t=p.maxResults?Object.assign({},p,{maxResults:null}):p,c=new C(t);n=this.doSortedSearch(c,p,i,r,o)}return new Promise((t,c)=>{n.then(([E,y])=>{const M=y.map(j=>this.rawMatchToSearchItem(j));this.sendProgress(M,i,s),t(E)},c)})}const m=new C(p);return this.doSearch(m,r,s,o).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.processType,fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(C){return{path:C.base?(0,T.join)(C.base,C.relativePath):C.relativePath}}doSortedSearch(C,p,i,o,s){const l=new A.Emitter;let r=(0,P.createCancelablePromise)(n=>{let t=[];const c=E=>{Array.isArray(E)?t=E:(o(E),l.fire(E))};return this.doSearch(C,c,-1,n).then(E=>[E,t])}),m;if(p.cacheKey){m=this.getOrCreateCache(p.cacheKey);const n={promise:r,event:l.event,resolved:!1};m.resultsToSearchCache[p.filePattern||""]=n,r.then(()=>{n.resolved=!0},t=>{delete m.resultsToSearchCache[p.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([n,t])=>{const c=m?m.scorerCache:Object.create(null),E=(typeof p.maxResults!="number"||p.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(p,t,c,s).then(y=>{const M=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:p.folderQueries.length,resultCount:y.length},messages:n.messages,limitHit:n.limitHit||typeof p.maxResults=="number"&&t.length>p.maxResults},y]})})}getOrCreateCache(C){const p=this.caches[C];return p||(this.caches[C]=new f)}trySortedSearchFromCache(C,p,i){const o=C.cacheKey&&this.caches[C.cacheKey];if(!o)return;const s=this.getResultsFromCache(o,C.filePattern||"",p,i);if(s)return s.then(([l,r,m])=>{const n=S.StopWatch.create(!1);return this.sortResults(C,r,o.scorerCache,i).then(t=>{const c=n.elapsed(),E={fromCache:!0,detailStats:m,type:this.processType,resultCount:r.length,sortingTime:c};return[{type:"success",limitHit:l.limitHit||typeof C.maxResults=="number"&&r.length>C.maxResults,stats:E},t]})})}sortResults(C,p,i,o){const s=(0,_.prepareQuery)(C.filePattern||""),l=(m,n)=>(0,_.compareItemsByFuzzyScore)(m,n,s,!0,d,i),r=typeof C.maxResults=="number"?C.maxResults:Number.MAX_VALUE;return a.topAsync(p,l,r,1e4,o)}sendProgress(C,p,i){if(i&&i>0)for(let o=0;o<C.length;o+=i)p(C.slice(o,o+i));else p(C)}getResultsFromCache(C,p,i,o){const s=S.StopWatch.create(!1),l=p.indexOf(T.sep)>=0;let r;for(const c in C.resultsToSearchCache)if(p.startsWith(c)){if(l&&c.indexOf(T.sep)<0&&c!=="")continue;const E=C.resultsToSearchCache[c];r={promise:this.preventCancellation(E.promise),event:E.event,resolved:E.resolved};break}if(!r)return null;const m=s.elapsed(),n=S.StopWatch.create(!1),t=r.event(i);return o&&o.onCancellationRequested(()=>{t.dispose()}),r.promise.then(([c,E])=>{if(o&&o.isCancellationRequested)throw(0,u.canceled)();const y=[],M=(0,_.prepareQuery)(p).normalizedLowercase;for(const j of E)!(0,I.isFilePatternMatch)(j,M)||y.push(j);return[c,y,{cacheWasResolved:r.resolved,cacheLookupTime:m,cacheFilterTime:n.elapsed(),cacheEntryCount:E.length}]})}doSearch(C,p,i,o){return new Promise((s,l)=>{let r=[];o?.onCancellationRequested(()=>C.cancel()),C.search(m=>{m&&(i?(r.push(m),i>0&&r.length>=i&&(p(r),r=[])):p(m))},m=>{p(m)},(m,n)=>{r.length&&p(r),m?l(m):s(n)})})}clearCache(C){return delete this.caches[C],Promise.resolve(void 0)}preventCancellation(C){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,i){return C.then(p,i)}catch(p){return this.then(void 0,p)}finally(p){return C.finally(p)}}}}w.BATCH_SIZE=512,e.SearchService=w;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(v){return(0,T.basename)(v.relativePath)}getItemDescription(v){return(0,T.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function h(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(g),extraFileResources:v.extraFileResources&&v.extraFileResources.map(C=>D.URI.revive(C))}}function g(v){return{...v,folder:D.URI.revive(v.folder)}}}),define(_e[317],ye([1,0,6,14,2,29,13,25,20,85,56,31,316,314,100,144]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends D.ExtHostSearch{constructor(g,v,C,p){super(g,C,p),this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const i=new w.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(P.Schemas.vscodeUserData,new k.RipgrepSearchProvider(i)),v.remote.isRemote&&v.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const g=new w.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(P.Schemas.file,new k.RipgrepSearchProvider(g)),this.registerInternalFileSearchProvider(P.Schemas.file,new b.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(g,v){const C=this._handlePool++;return this._internalFileSearchProvider=v,this._internalFileSearchHandle=C,this._proxy.$registerFileSearchProvider(C,this._transformScheme(g)),(0,a.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(C)})}$provideFileSearchResults(g,v,C,p){const i=(0,D.reviveQuery)(C);return g===this._internalFileSearchHandle?this.doInternalFileSearch(g,v,i,p):super.$provideFileSearchResults(g,v,C,p)}doInternalFileSearch(g,v,C,p){const i=o=>{if((0,I.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this._proxy.$handleFileMatch(g,v,o.map(s=>u.URI.file(s.path)));return}o.message&&this._logService.debug("ExtHostSearch",o.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(C,i,p)}$clearCache(g){return this._internalFileSearchProvider?.clearCache(g),super.$clearCache(g)}createTextSearchManager(g,v){return new f.NativeTextSearchManager(g,v,void 0,"textSearchProvider")}};d=Ve([We(0,S.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,R.IURITransformerService),We(3,_.ILogService)],d),e.NativeExtHostSearch=d}),define(_e[318],ye([1,0,89,289,301,300,317,313,290,84,42,85,82,41,55,79,288,287,13,302,49]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h,g,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(R.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,a.registerSingleton)(g.ILoggerService,h.ExtHostLoggerService,1),(0,a.registerSingleton)(f.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,a.registerSingleton)(D.IExtHostDebugService,A.ExtHostDebugService,0),(0,a.registerSingleton)(I.IExtHostSearch,_.NativeExtHostSearch,0),(0,a.registerSingleton)(b.IExtHostTask,u.ExtHostTask,0),(0,a.registerSingleton)(k.IExtHostTerminalService,P.ExtHostTerminalService,0),(0,a.registerSingleton)(w.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,a.registerSingleton)(C.IExtHostVariableResolverProvider,v.NodeExtHostVariableResolverProviderService,0)}),define(_e[327],ye([1,0,230,328,83,11,118,119,208,95,299,22,29,115,19,121,225,238,303,318]),function(ie,e,a,P,u,A,_,T,S,D,R,I,b,k,w,f,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const g=P(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,m=r._load;r._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const v=process.exit.bind(process);function C(r){process.exit=function(m){if(r)v(m);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(r){v()};function i(){const r=(0,h.readExtHostConnection)(process.env);if(r.type===3)return new Promise((m,n)=>{const t=c=>{const E=c[0],y=new _.BufferedEmitter;E.on("message",M=>y.fire(I.VSBuffer.wrap(M.data))),E.on("close",()=>{p("renderer closed the MessagePort")}),E.start(),m({onMessage:y.event,send:M=>E.postMessage(M.buffer)})};process.parentPort.on("message",c=>t(c.ports))});if(r.type===2)return new Promise((m,n)=>{let t=null;const c=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,y=3e5,M=new w.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),E),j=new w.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),y);process.on("message",(N,x)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const L=I.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let F;if(N.skipWebSocketFrames)F=new T.NodeSocket(x,"extHost-socket");else{const U=I.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));F=new T.WebSocketNodeSocket(new T.NodeSocket(x,"extHost-socket"),N.permessageDeflate,U,!1)}t?(M.cancel(),j.cancel(),t.beginAcceptReconnection(F,L),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(c),t=new _.PersistentProtocol({socket:F,initialChunk:L}),t.sendResume(),t.onDidDispose(()=>p("renderer disconnected")),m(t),t.onSocketClose(()=>{M.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;M.isScheduled()&&j.schedule()}});const $={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.($)});{const m=r.pipeName;return new Promise((n,t)=>{const c=a.createConnection(m,()=>{c.removeListener("error",t);const E=new _.PersistentProtocol({socket:new T.NodeSocket(c,"extHost-renderer")});E.sendResume(),n(E)});c.once("error",t),c.on("close",()=>{p("renderer closed the socket")})})}}async function o(){const r=await i();return new class{constructor(){this._onMessage=new _.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(m=>{(0,D.isMessageOfType)(m,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(m)})}send(m){this._terminating||r.send(m)}async drain(){if(r.drain)return r.drain()}}}function s(r){return new Promise(m=>{const n=r.onMessage(t=>{n.dispose();const c=JSON.parse(t.toString()),E=c.commit,y=S.default.commit;if(E&&y&&E!==y&&v(55),c.parentPid){let M=0;setInterval(function(){try{process.kill(c.parentPid,0),M=0}catch($){$&&$.code==="EPERM"?(M++,M>=3&&p(`parent process ${c.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):p(`parent process ${c.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(c.parentPid)}catch($){(0,A.onUnexpectedError)($)}}r.send((0,D.createMessageOfType)(0)),m({protocol:r,initData:c})});r.send((0,D.createMessageOfType)(1))})}async function l(){const r=[];process.on("unhandledRejection",(M,j)=>{r.push(j),setTimeout(()=>{const $=r.indexOf(j);$>=0&&j.catch(N=>{r.splice($,1),(0,A.isCancellationError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),M&&(0,A.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const j=r.indexOf(M);j>=0&&r.splice(j,1)}),process.on("uncaughtException",function(M){(0,A.isSigPipeError)(M)||(0,A.onUnexpectedError)(M)}),u.mark("code/extHost/willConnectToRenderer");const m=await o();u.mark("code/extHost/didConnectToRenderer");const n=await s(m);u.mark("code/extHost/didWaitForInitData");const{initData:t}=n;C(!!t.environment.extensionTestsLocationURI),t.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,t.environment.skipWorkspaceStorageLock=(0,f.boolean)(g.skipWorkspaceStorageLock,!1);const c=new class{constructor(){this.pid=process.pid}exit(j){v(j)}exists(j){return b.Promises.exists(j)}realpath(j){return(0,k.realpath)(j)}};let E=null;t.remote.authority&&g.transformURIs&&(E=(0,d.createURITransformer)(t.remote.authority));const y=new R.ExtensionHostMain(n.protocol,t,c,E);p=M=>y.terminate(M)}l().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c6a9727b801542499d2b59cb7db4224e060fc578/core/vs/workbench/api/node/extensionHostProcess.js.map
