/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(te){for(var e=[],n=0,C=te.length;n<C;n++)e[n]=Ce[te[n]];return e};define(Ce[62],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(S,P){const _=Object.create(null);for(const I of S){const L=P(I);let w=_[L];w||(w=_[L]=[]),w.push(I)}return _}e.groupBy=n;function C(S,P){const _=[],I=[];for(const L of S)P.has(L)||_.push(L);for(const L of P)S.has(L)||I.push(L);return{removed:_,added:I}}e.diffSets=C;function y(S,P){const _=[],I=[];for(const[L,w]of S)P.has(L)||_.push(w);for(const[L,w]of P)S.has(L)||I.push(w);return{removed:_,added:I}}e.diffMaps=y;class N{constructor(){this.map=new Map}add(P,_){let I=this.map.get(P);I||(I=new Set,this.map.set(P,I)),I.add(_)}delete(P,_){const I=this.map.get(P);!I||(I.delete(_),I.size===0&&this.map.delete(P))}forEach(P,_){const I=this.map.get(P);!I||I.forEach(_)}}e.SetMap=N}),define(Ce[63],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(S){return(P,_,I)=>{let L=null,w=null;if(typeof I.value=="function"?(L="value",w=I.value):typeof I.get=="function"&&(L="get",w=I.get),!w)throw new Error("not supported");I[L]=S(w,_)}}function C(S,P,_){let I=null,L=null;if(typeof _.value=="function"?(I="value",L=_.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(I="get",L=_.get),!L)throw new Error("not supported");const w=`$memoize$${P}`;_[I]=function(...f){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,f)}),this[w]}}e.memoize=C;function y(S,P,_){return n((I,L)=>{const w=`$debounce$${L}`,f=`$debounce$result$${L}`;return function(...E){this[f]||(this[f]=_?_():void 0),clearTimeout(this[w]),P&&(this[f]=P(this[f],...E),E=[this[f]]),this[w]=setTimeout(()=>{I.apply(this,E),this[f]=_?_():void 0},S)}})}e.debounce=y;function N(S,P,_){return n((I,L)=>{const w=`$throttle$timer$${L}`,f=`$throttle$result$${L}`,E=`$throttle$lastRun$${L}`,m=`$throttle$pending$${L}`;return function(...a){if(this[f]||(this[f]=_?_():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...a)),this[m])return;const o=this[E]+S;o<=Date.now()?(this[E]=Date.now(),I.apply(this,[this[f]]),this[f]=_?_():void 0):(this[m]=!0,this[w]=setTimeout(()=>{this[m]=!1,this[E]=Date.now(),I.apply(this,[this[f]]),this[f]=_?_():void 0},o-Date.now()))}})}e.throttle=N}),define(Ce[83],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Ce[111],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N=e.ParseOptions||(e.ParseOptions={}));function S(t,h=!1){let r=0;const l=t.length;let i="",p=0,c=16,s=0;function d(B){let T=0,F=0;for(;T<B;){const z=t.charCodeAt(r);if(z>=48&&z<=57)F=F*16+z-48;else if(z>=65&&z<=70)F=F*16+z-65+10;else if(z>=97&&z<=102)F=F*16+z-97+10;else break;r++,T++}return T<B&&(F=-1),F}function k(B){r=B,i="",p=0,c=16,s=0}function A(){const B=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&I(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&I(t.charCodeAt(r)))for(r++;r<t.length&&I(t.charCodeAt(r));)r++;else return s=3,t.substring(B,r);let T=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&I(t.charCodeAt(r))){for(r++;r<t.length&&I(t.charCodeAt(r));)r++;T=r}else s=3;return t.substring(B,T)}function W(){let B="",T=r;for(;;){if(r>=l){B+=t.substring(T,r),s=2;break}const F=t.charCodeAt(r);if(F===34){B+=t.substring(T,r),r++;break}if(F===92){if(B+=t.substring(T,r),r++,r>=l){s=2;break}switch(t.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const H=d(4);H>=0?B+=String.fromCharCode(H):s=4;break}default:s=5}T=r;continue}if(F>=0&&F<=31)if(_(F)){B+=t.substring(T,r),s=2;break}else s=6;r++}return B}function J(){if(i="",s=0,p=r,r>=l)return p=l,c=17;let B=t.charCodeAt(r);if(P(B)){do r++,i+=String.fromCharCode(B),B=t.charCodeAt(r);while(P(B));return c=15}if(_(B))return r++,i+=String.fromCharCode(B),B===13&&t.charCodeAt(r)===10&&(r++,i+=`
`),c=14;switch(B){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,i=W(),c=10;case 47:{const T=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<l&&!_(t.charCodeAt(r));)r++;return i=t.substring(T,r),c=12}if(t.charCodeAt(r+1)===42){r+=2;const F=l-1;let z=!1;for(;r<F;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,z=!0;break}r++}return z||(r++,s=1),i=t.substring(T,r),c=13}return i+=String.fromCharCode(B),r++,c=16}case 45:if(i+=String.fromCharCode(B),r++,r===l||!I(t.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=A(),c=11;default:for(;r<l&&j(B);)r++,B=t.charCodeAt(r);if(p!==r){switch(i=t.substring(p,r),i){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return i+=String.fromCharCode(B),r++,c=16}}function j(B){if(P(B)||_(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let B;do B=J();while(B>=12&&B<=15);return B}return{setPosition:k,getPosition:()=>r,scan:h?O:J,getToken:()=>c,getTokenValue:()=>i,getTokenOffset:()=>p,getTokenLength:()=>r-p,getTokenError:()=>s}}e.createScanner=S;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function w(t,h){const r=[],l=new Object;let i;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function s(d,k,A,W){p.value=d,p.offset=k,p.length=A,p.type=W,p.colonOffset=void 0,i=p}try{b(t,{onObjectBegin:(d,k)=>{if(h<=d)throw l;i=void 0,c=h>d,r.push("")},onObjectProperty:(d,k,A)=>{if(h<k||(s(d,k,A,"property"),r[r.length-1]=d,h<=k+A))throw l},onObjectEnd:(d,k)=>{if(h<=d)throw l;i=void 0,r.pop()},onArrayBegin:(d,k)=>{if(h<=d)throw l;i=void 0,r.push(0)},onArrayEnd:(d,k)=>{if(h<=d)throw l;i=void 0,r.pop()},onLiteralValue:(d,k,A)=>{if(h<k||(s(d,k,A,v(d)),h<=k+A))throw l},onSeparator:(d,k,A)=>{if(h<=k)throw l;if(d===":"&&i&&i.type==="property")i.colonOffset=k,c=!1,i=void 0;else if(d===","){const W=r[r.length-1];typeof W=="number"?r[r.length-1]=W+1:(c=!0,r[r.length-1]=""),i=void 0}}})}catch(d){if(d!==l)throw d}return{path:r,previousNode:i,isAtPropertyKey:c,matches:d=>{let k=0;for(let A=0;k<d.length&&A<r.length;A++)if(d[k]===r[A]||d[k]==="*")k++;else if(d[k]!=="**")return!1;return k===d.length}}}e.getLocation=w;function f(t,h=[],r=N.DEFAULT){let l=null,i=[];const p=[];function c(d){Array.isArray(i)?i.push(d):l!==null&&(i[l]=d)}return b(t,{onObjectBegin:()=>{const d={};c(d),p.push(i),i=d,l=null},onObjectProperty:d=>{l=d},onObjectEnd:()=>{i=p.pop()},onArrayBegin:()=>{const d=[];c(d),p.push(i),i=d,l=null},onArrayEnd:()=>{i=p.pop()},onLiteralValue:c,onError:(d,k,A)=>{h.push({error:d,offset:k,length:A})}},r),i[0]}e.parse=f;function E(t,h=[],r=N.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(d){l.type==="property"&&(l.length=d-l.offset,l=l.parent)}function p(d){return l.children.push(d),d}b(t,{onObjectBegin:d=>{l=p({type:"object",offset:d,length:-1,parent:l,children:[]})},onObjectProperty:(d,k,A)=>{l=p({type:"property",offset:k,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:d,offset:k,length:A,parent:l})},onObjectEnd:(d,k)=>{l.length=d+k-l.offset,l=l.parent,i(d+k)},onArrayBegin:(d,k)=>{l=p({type:"array",offset:d,length:-1,parent:l,children:[]})},onArrayEnd:(d,k)=>{l.length=d+k-l.offset,l=l.parent,i(d+k)},onLiteralValue:(d,k,A)=>{p({type:v(d),offset:k,length:A,parent:l,value:d}),i(k+A)},onSeparator:(d,k,A)=>{l.type==="property"&&(d===":"?l.colonOffset=k:d===","&&i(k))},onError:(d,k,A)=>{h.push({error:d,offset:k,length:A})}},r);const s=l.children[0];return s&&delete s.parent,s}e.parseTree=E;function m(t,h){if(!t)return;let r=t;for(const l of h)if(typeof l=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let i=!1;for(const p of r.children)if(Array.isArray(p.children)&&p.children[0].value===l){r=p.children[1],i=!0;break}if(!i)return}else{const i=l;if(r.type!=="array"||i<0||!Array.isArray(r.children)||i>=r.children.length)return;r=r.children[i]}return r}e.findNodeAtLocation=m;function a(t){if(!t.parent||!t.parent.children)return[];const h=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;h.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&h.push(r)}return h}e.getNodePath=a;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const h=Object.create(null);for(const r of t.children){const l=r.children[1];l&&(h[r.children[0].value]=o(l))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function u(t,h,r=!1){return h>=t.offset&&h<t.offset+t.length||r&&h===t.offset+t.length}e.contains=u;function g(t,h,r=!1){if(u(t,h,r)){const l=t.children;if(Array.isArray(l))for(let i=0;i<l.length&&l[i].offset<=h;i++){const p=g(l[i],h,r);if(p)return p}return t}}e.findNodeAtOffset=g;function b(t,h,r=N.DEFAULT){const l=S(t,!1);function i(se){return se?()=>se(l.getTokenOffset(),l.getTokenLength()):()=>!0}function p(se){return se?Q=>se(Q,l.getTokenOffset(),l.getTokenLength()):()=>!0}const c=i(h.onObjectBegin),s=p(h.onObjectProperty),d=i(h.onObjectEnd),k=i(h.onArrayBegin),A=i(h.onArrayEnd),W=p(h.onLiteralValue),J=p(h.onSeparator),j=i(h.onComment),O=p(h.onError),B=r&&r.disallowComments,T=r&&r.allowTrailingComma;function F(){for(;;){const se=l.scan();switch(l.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:B||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(se){case 12:case 13:B?z(10):j();break;case 16:z(1);break;case 15:case 14:break;default:return se}}}function z(se,Q=[],K=[]){if(O(se),Q.length+K.length>0){let Z=l.getToken();for(;Z!==17;){if(Q.indexOf(Z)!==-1){F();break}else if(K.indexOf(Z)!==-1)break;Z=F()}}}function H(se){const Q=l.getTokenValue();return se?W(Q):s(Q),F(),!0}function de(){switch(l.getToken()){case 11:{let se=0;try{se=JSON.parse(l.getTokenValue()),typeof se!="number"&&(z(2),se=0)}catch{z(2)}W(se);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return F(),!0}function pe(){return l.getToken()!==10?(z(3,[],[2,5]),!1):(H(!1),l.getToken()===6?(J(":"),F(),ae()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function re(){c(),F();let se=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(se||z(4,[],[]),J(","),F(),l.getToken()===2&&T)break}else se&&z(6,[],[]);pe()||z(4,[],[2,5]),se=!0}return d(),l.getToken()!==2?z(7,[2],[]):F(),!0}function le(){k(),F();let se=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(se||z(4,[],[]),J(","),F(),l.getToken()===4&&T)break}else se&&z(6,[],[]);ae()||z(4,[],[4,5]),se=!0}return A(),l.getToken()!==4?z(8,[4],[]):F(),!0}function ae(){switch(l.getToken()){case 3:return le();case 1:return re();case 10:return H(!0);default:return de()}}return F(),l.getToken()===17?r.allowEmptyContent?!0:(z(4,[],[]),!1):ae()?(l.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=b;function R(t,h){const r=S(t),l=[];let i,p=0,c;do switch(c=r.getPosition(),i=r.scan(),i){case 12:case 13:case 17:p!==c&&l.push(t.substring(p,c)),h!==void 0&&l.push(r.getTokenValue().replace(/[^\r\n]/g,h)),p=r.getPosition();break}while(i!==17);return l.join("")}e.stripComments=R;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ce[28],Ie([1,0]),function(te,e){"use strict";var n,C,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function N(m,a,o){let u=m.get(a);return u===void 0&&(u=o,m.set(a,u)),u}e.getOrSet=N;function S(m){const a=[];return m.forEach((o,u)=>{a.push(`${u} => ${o}`)}),`Map(${m.size}) {${a.join(", ")}}`}e.mapToString=S;function P(m){const a=[];return m.forEach(o=>{a.push(o)}),`Set(${m.size}) {${a.join(", ")}}`}e.setToString=P;class _{constructor(a,o){this.uri=a,this.value=o}}class I{constructor(a,o){this[n]="ResourceMap",a instanceof I?(this.map=new Map(a.map),this.toKey=o??I.defaultToKey):(this.map=new Map,this.toKey=a??I.defaultToKey)}set(a,o){return this.map.set(this.toKey(a),new _(a,o)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,o){typeof o<"u"&&(a=a.bind(o));for(const[u,g]of this.map)a(g.value,g.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}I.defaultToKey=m=>m.toString(),e.ResourceMap=I;class L{constructor(a,o){this[C]="ResourceSet",!a||typeof a=="function"?this._map=new I(a):(this._map=new I(o),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,o){this._map.forEach((u,g)=>a.call(o,g,g,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var w;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class f{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,o=0){const u=this._map.get(a);if(!!u)return o!==0&&this.touch(u,o),u.value}set(a,o,u=0){let g=this._map.get(a);if(g)g.value=o,u!==0&&this.touch(g,u);else{switch(g={key:a,value:o,next:void 0,previous:void 0},u){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(a,g),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const o=this._map.get(a);if(!!o)return this._map.delete(a),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,o){const u=this._state;let g=this._head;for(;g;){if(o?a.bind(o)(g.value,g.key,this):a(g.value,g.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const a=this,o=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(a._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.key,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return g}values(){const a=this,o=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(a._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.value,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return g}entries(){const a=this,o=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(a._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:[u.key,u.value],done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return g}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let o=this._head,u=this.size;for(;o&&u>a;)this._map.delete(o.key),o=o.next,u--;this._head=o,this._size=u,o&&(o.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const o=a.next,u=a.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}a.next=void 0,a.previous=void 0,this._state++}touch(a,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(a===this._head)return;const u=a.next,g=a.previous;a===this._tail?(g.next=void 0,this._tail=g):(u.previous=g,g.next=u),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(o===2){if(a===this._tail)return;const u=a.next,g=a.previous;a===this._head?(u.previous=void 0,this._head=u):(u.previous=g,g.next=u),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((o,u)=>{a.push([u,o])}),a}fromJSON(a){this.clear();for(const[o,u]of a)this.set(o,u)}}e.LinkedMap=f;class E extends f{constructor(a,o=1){super(),this._limit=a,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,o=2){return super.get(a,o)}peek(a){return super.get(a,0)}set(a,o){return super.set(a,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=E}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[112],Ie([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Te,Se){for(var De=0;De<Se.length;De++){var oe=Se[De];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Te,oe.key,oe)}}function n(Te,Se,De){return Se&&e(Te.prototype,Se),De&&e(Te,De),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function C(Te,Se){if(!!Te){if(typeof Te=="string")return y(Te,Se);var De=Object.prototype.toString.call(Te).slice(8,-1);if(De==="Object"&&Te.constructor&&(De=Te.constructor.name),De==="Map"||De==="Set")return Array.from(Te);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return y(Te,Se)}}function y(Te,Se){(Se==null||Se>Te.length)&&(Se=Te.length);for(var De=0,oe=new Array(Se);De<Se;De++)oe[De]=Te[De];return oe}function N(Te,Se){var De=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(De)return(De=De.call(Te)).next.bind(De);if(Array.isArray(Te)||(De=C(Te))||Se&&Te&&typeof Te.length=="number"){De&&(Te=De);var oe=0;return function(){return oe>=Te.length?{done:!0}:{done:!1,value:Te[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=S();function P(Te){te.defaults=Te}var _=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Se){return f[Se]};function m(Te,Se){if(Se){if(_.test(Te))return Te.replace(I,E)}else if(L.test(Te))return Te.replace(w,E);return Te}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Te){return Te.replace(a,function(Se,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var u=/(^|[^\[])\^/g;function g(Te,Se){Te=typeof Te=="string"?Te:Te.source,Se=Se||"";var De={replace:function(ue,Y){return Y=Y.source||Y,Y=Y.replace(u,"$1"),Te=Te.replace(ue,Y),De},getRegex:function(){return new RegExp(Te,Se)}};return De}var b=/[^\w:]/g,R=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Te,Se,De){if(Te){var oe;try{oe=decodeURIComponent(o(De)).replace(b,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Se&&!R.test(De)&&(De=i(Se,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var t={},h=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Te,Se){t[" "+Te]||(h.test(Te)?t[" "+Te]=Te+"/":t[" "+Te]=d(Te,"/",!0)),Te=t[" "+Te];var De=Te.indexOf(":")===-1;return Se.substring(0,2)==="//"?De?Se:Te.replace(r,"$1")+Se:Se.charAt(0)==="/"?De?Se:Te.replace(l,"$1")+Se:Te+Se}var p={exec:function(){}};function c(Te){for(var Se=1,De,oe;Se<arguments.length;Se++){De=arguments[Se];for(oe in De)Object.prototype.hasOwnProperty.call(De,oe)&&(Te[oe]=De[oe])}return Te}function s(Te,Se){var De=Te.replace(/\|/g,function(Y,D,U){for(var $=!1,V=D;--V>=0&&U[V]==="\\";)$=!$;return $?"|":" |"}),oe=De.split(/ \|/),ue=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>Se)oe.splice(Se);else for(;oe.length<Se;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function d(Te,Se,De){var oe=Te.length;if(oe===0)return"";for(var ue=0;ue<oe;){var Y=Te.charAt(oe-ue-1);if(Y===Se&&!De)ue++;else if(Y!==Se&&De)ue++;else break}return Te.slice(0,oe-ue)}function k(Te,Se){if(Te.indexOf(Se[1])===-1)return-1;for(var De=Te.length,oe=0,ue=0;ue<De;ue++)if(Te[ue]==="\\")ue++;else if(Te[ue]===Se[0])oe++;else if(Te[ue]===Se[1]&&(oe--,oe<0))return ue;return-1}function A(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(Te,Se){if(Se<1)return"";for(var De="";Se>1;)Se&1&&(De+=Te),Se>>=1,Te+=Te;return De+Te}function J(Te,Se,De,oe){var ue=Se.href,Y=Se.title?m(Se.title):null,D=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){oe.state.inLink=!0;var U={type:"link",raw:De,href:ue,title:Y,text:D,tokens:oe.inlineTokens(D)};return oe.state.inLink=!1,U}return{type:"image",raw:De,href:ue,title:Y,text:m(D)}}function j(Te,Se){var De=Te.match(/^(\s+)(?:```)/);if(De===null)return Se;var oe=De[1];return Se.split(`
`).map(function(ue){var Y=ue.match(/^\s+/);if(Y===null)return ue;var D=Y[0];return D.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var O=function(){function Te(De){this.options=De||te.defaults}var Se=Te.prototype;return Se.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},Se.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var Y=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:d(Y,`
`)}}},Se.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var Y=ue[0],D=j(Y,ue[3]||"");return{type:"code",raw:Y,lang:ue[2]?ue[2].trim():ue[2],text:D}}},Se.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var Y=ue[2].trim();if(/#$/.test(Y)){var D=d(Y,"#");(this.options.pedantic||!D||/ $/.test(D))&&(Y=D.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:Y,tokens:this.lexer.inline(Y)}}},Se.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},Se.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var Y=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},Se.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var Y,D,U,$,V,ee,me,_e,ce,Ee,be,$e,We=ue[1].trim(),tt=We.length>1,Ge={type:"list",raw:"",ordered:tt,start:tt?+We.slice(0,-1):"",loose:!1,items:[]};We=tt?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=tt?We:"[*+-]");for(var et=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&($e=!1,!(!(ue=et.exec(oe))||this.rules.block.hr.test(oe)));){if(Y=ue[0],oe=oe.substring(Y.length),_e=ue[2].split(`
`,1)[0],ce=oe.split(`
`,1)[0],this.options.pedantic?($=2,be=_e.trimLeft()):($=ue[2].search(/[^ ]/),$=$>4?1:$,be=_e.slice($),$+=ue[1].length),ee=!1,!_e&&/^ *$/.test(ce)&&(Y+=ce+`
`,oe=oe.substring(ce.length+1),$e=!0),!$e)for(var it=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,$-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Le=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,$-1)+"}#");oe&&(Ee=oe.split(`
`,1)[0],_e=Ee,this.options.pedantic&&(_e=_e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Le.test(_e)||ot.test(_e)||it.test(_e)||dt.test(oe)));){if(_e.search(/[^ ]/)>=$||!_e.trim())be+=`
`+_e.slice($);else if(!ee)be+=`
`+_e;else break;!ee&&!_e.trim()&&(ee=!0),Y+=Ee+`
`,oe=oe.substring(Ee.length+1)}Ge.loose||(me?Ge.loose=!0:/\n *\n *$/.test(Y)&&(me=!0)),this.options.gfm&&(D=/^\[[ xX]\] /.exec(be),D&&(U=D[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:Y,task:!!D,checked:U,loose:!1,text:be}),Ge.raw+=Y}Ge.items[Ge.items.length-1].raw=Y.trimRight(),Ge.items[Ge.items.length-1].text=be.trimRight(),Ge.raw=Ge.raw.trimRight();var X=Ge.items.length;for(V=0;V<X;V++){this.lexer.state.top=!1,Ge.items[V].tokens=this.lexer.blockTokens(Ge.items[V].text,[]);var G=Ge.items[V].tokens.filter(function(Ne){return Ne.type==="space"}),ve=G.every(function(Ne){for(var xe=Ne.raw.split(""),ze=0,Qe=N(xe),nt;!(nt=Qe()).done;){var vt=nt.value;if(vt===`
`&&(ze+=1),ze>1)return!0}return!1});!Ge.loose&&G.length&&ve&&(Ge.loose=!0,Ge.items[V].loose=!0)}return Ge}},Se.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue){var Y={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var D=this.options.sanitizer?this.options.sanitizer(ue[0]):m(ue[0]);Y.type="paragraph",Y.text=D,Y.tokens=this.lexer.inline(D)}return Y}},Se.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Y=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ue[0],href:ue[2],title:ue[3]}}},Se.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var Y={type:"table",header:s(ue[1]).map(function(me){return{text:me}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ue[0];var D=Y.align.length,U,$,V,ee;for(U=0;U<D;U++)/^ *-+: *$/.test(Y.align[U])?Y.align[U]="right":/^ *:-+: *$/.test(Y.align[U])?Y.align[U]="center":/^ *:-+ *$/.test(Y.align[U])?Y.align[U]="left":Y.align[U]=null;for(D=Y.rows.length,U=0;U<D;U++)Y.rows[U]=s(Y.rows[U],Y.header.length).map(function(me){return{text:me}});for(D=Y.header.length,$=0;$<D;$++)Y.header[$].tokens=this.lexer.inline(Y.header[$].text);for(D=Y.rows.length,$=0;$<D;$++)for(ee=Y.rows[$],V=0;V<ee.length;V++)ee[V].tokens=this.lexer.inline(ee[V].text);return Y}}},Se.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},Se.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue){var Y=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:Y,tokens:this.lexer.inline(Y)}}},Se.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},Se.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:m(ue[1])}},Se.tag=function(oe){var ue=this.rules.inline.tag.exec(oe);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):m(ue[0]):ue[0]}},Se.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var Y=ue[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var D=d(Y.slice(0,-1),"\\");if((Y.length-D.length)%2===0)return}else{var U=k(ue[2],"()");if(U>-1){var $=ue[0].indexOf("!")===0?5:4,V=$+ue[1].length+U;ue[2]=ue[2].substring(0,U),ue[0]=ue[0].substring(0,V).trim(),ue[3]=""}}var ee=ue[2],me="";if(this.options.pedantic){var _e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);_e&&(ee=_e[1],me=_e[3])}else me=ue[3]?ue[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(Y)?ee=ee.slice(1):ee=ee.slice(1,-1)),J(ue,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Se.reflink=function(oe,ue){var Y;if((Y=this.rules.inline.reflink.exec(oe))||(Y=this.rules.inline.nolink.exec(oe))){var D=(Y[2]||Y[1]).replace(/\s+/g," ");if(D=ue[D.toLowerCase()],!D||!D.href){var U=Y[0].charAt(0);return{type:"text",raw:U,text:U}}return J(Y,D,Y[0],this.lexer)}},Se.emStrong=function(oe,ue,Y){Y===void 0&&(Y="");var D=this.rules.inline.emStrong.lDelim.exec(oe);if(!!D&&!(D[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=D[1]||D[2]||"";if(!U||U&&(Y===""||this.rules.inline.punctuation.exec(Y))){var $=D[0].length-1,V,ee,me=$,_e=0,ce=D[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ue=ue.slice(-1*oe.length+$);(D=ce.exec(ue))!=null;)if(V=D[1]||D[2]||D[3]||D[4]||D[5]||D[6],!!V){if(ee=V.length,D[3]||D[4]){me+=ee;continue}else if((D[5]||D[6])&&$%3&&!(($+ee)%3)){_e+=ee;continue}if(me-=ee,!(me>0)){if(ee=Math.min(ee,ee+me+_e),Math.min($,ee)%2){var Ee=oe.slice(1,$+D.index+ee);return{type:"em",raw:oe.slice(0,$+D.index+ee+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var be=oe.slice(2,$+D.index+ee-1);return{type:"strong",raw:oe.slice(0,$+D.index+ee+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},Se.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var Y=ue[2].replace(/\n/g," "),D=/[^ ]/.test(Y),U=/^ /.test(Y)&&/ $/.test(Y);return D&&U&&(Y=Y.substring(1,Y.length-1)),Y=m(Y,!0),{type:"codespan",raw:ue[0],text:Y}}},Se.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},Se.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},Se.autolink=function(oe,ue){var Y=this.rules.inline.autolink.exec(oe);if(Y){var D,U;return Y[2]==="@"?(D=m(this.options.mangle?ue(Y[1]):Y[1]),U="mailto:"+D):(D=m(Y[1]),U=D),{type:"link",raw:Y[0],text:D,href:U,tokens:[{type:"text",raw:D,text:D}]}}},Se.url=function(oe,ue){var Y;if(Y=this.rules.inline.url.exec(oe)){var D,U;if(Y[2]==="@")D=m(this.options.mangle?ue(Y[0]):Y[0]),U="mailto:"+D;else{var $;do $=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while($!==Y[0]);D=m(Y[0]),Y[1]==="www."?U="http://"+D:U=D}return{type:"link",raw:Y[0],text:D,href:U,tokens:[{type:"text",raw:D,text:D}]}}},Se.inlineText=function(oe,ue){var Y=this.rules.inline.text.exec(oe);if(Y){var D;return this.lexer.state.inRawBlock?D=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]:D=m(this.options.smartypants?ue(Y[0]):Y[0]),{type:"text",raw:Y[0],text:D}}},Te}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=g(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=g(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=g(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=g(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=g(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=c({},B),B.gfm=c({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=g(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=c({},B.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:g(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=g(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=g(B._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=g(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=g(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=g(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=g(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=g(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=g(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=g(T.reflink).replace("label",T._label).replace("ref",B._label).getRegex(),T.nolink=g(T.nolink).replace("ref",B._label).getRegex(),T.reflinkSearch=g(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=c({},T),T.pedantic=c({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=c({},T.normal,{escape:g(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=g(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=c({},T.gfm,{br:g(T.br).replace("{2,}","*").getRegex(),text:g(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Te){var Se="",De,oe,ue=Te.length;for(De=0;De<ue;De++)oe=Te.charCodeAt(De),Math.random()>.5&&(oe="x"+oe.toString(16)),Se+="&#"+oe+";";return Se}var H=function(){function Te(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||te.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:B.normal,inline:T.normal};this.options.pedantic?(oe.block=B.pedantic,oe.inline=T.pedantic):this.options.gfm&&(oe.block=B.gfm,this.options.breaks?oe.inline=T.breaks:oe.inline=T.gfm),this.tokenizer.rules=oe}Te.lex=function(oe,ue){var Y=new Te(ue);return Y.lex(oe)},Te.lexInline=function(oe,ue){var Y=new Te(ue);return Y.inlineTokens(oe)};var Se=Te.prototype;return Se.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Se.blockTokens=function(oe,ue){var Y=this;ue===void 0&&(ue=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(me,_e,ce){return _e+"    ".repeat(ce.length)});for(var D,U,$,V;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(D=me.call({lexer:Y},oe,ue))?(oe=oe.substring(D.raw.length),ue.push(D),!0):!1}))){if(D=this.tokenizer.space(oe)){oe=oe.substring(D.raw.length),D.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(D);continue}if(D=this.tokenizer.code(oe)){oe=oe.substring(D.raw.length),U=ue[ue.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+D.raw,U.text+=`
`+D.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):ue.push(D);continue}if(D=this.tokenizer.fences(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.heading(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.hr(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.blockquote(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.list(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.html(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.def(oe)){oe=oe.substring(D.raw.length),U=ue[ue.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+D.raw,U.text+=`
`+D.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[D.tag]||(this.tokens.links[D.tag]={href:D.href,title:D.title});continue}if(D=this.tokenizer.table(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.lheading(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if($=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,_e=oe.slice(1),ce=void 0;Y.options.extensions.startBlock.forEach(function(Ee){ce=Ee.call({lexer:this},_e),typeof ce=="number"&&ce>=0&&(me=Math.min(me,ce))}),me<1/0&&me>=0&&($=oe.substring(0,me+1))}(),this.state.top&&(D=this.tokenizer.paragraph($))){U=ue[ue.length-1],V&&U.type==="paragraph"?(U.raw+=`
`+D.raw,U.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ue.push(D),V=$.length!==oe.length,oe=oe.substring(D.raw.length);continue}if(D=this.tokenizer.text(oe)){oe=oe.substring(D.raw.length),U=ue[ue.length-1],U&&U.type==="text"?(U.raw+=`
`+D.raw,U.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ue.push(D);continue}if(oe){var ee="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,ue},Se.inline=function(oe,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:oe,tokens:ue}),ue},Se.inlineTokens=function(oe,ue){var Y=this;ue===void 0&&(ue=[]);var D,U,$,V=oe,ee,me,_e;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)ce.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,ee.index)+"["+W("a",ee[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,ee.index)+"["+W("a",ee[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,ee.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(me||(_e=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(D=be.call({lexer:Y},oe,ue))?(oe=oe.substring(D.raw.length),ue.push(D),!0):!1}))){if(D=this.tokenizer.escape(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.tag(oe)){oe=oe.substring(D.raw.length),U=ue[ue.length-1],U&&D.type==="text"&&U.type==="text"?(U.raw+=D.raw,U.text+=D.text):ue.push(D);continue}if(D=this.tokenizer.link(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(D.raw.length),U=ue[ue.length-1],U&&D.type==="text"&&U.type==="text"?(U.raw+=D.raw,U.text+=D.text):ue.push(D);continue}if(D=this.tokenizer.emStrong(oe,V,_e)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.codespan(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.br(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.del(oe)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(D=this.tokenizer.autolink(oe,z)){oe=oe.substring(D.raw.length),ue.push(D);continue}if(!this.state.inLink&&(D=this.tokenizer.url(oe,z))){oe=oe.substring(D.raw.length),ue.push(D);continue}if($=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,$e=oe.slice(1),We=void 0;Y.options.extensions.startInline.forEach(function(tt){We=tt.call({lexer:this},$e),typeof We=="number"&&We>=0&&(be=Math.min(be,We))}),be<1/0&&be>=0&&($=oe.substring(0,be+1))}(),D=this.tokenizer.inlineText($,F)){oe=oe.substring(D.raw.length),D.raw.slice(-1)!=="_"&&(_e=D.raw.slice(-1)),me=!0,U=ue[ue.length-1],U&&U.type==="text"?(U.raw+=D.raw,U.text+=D.text):ue.push(D);continue}if(oe){var Ee="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},n(Te,null,[{key:"rules",get:function(){return{block:B,inline:T}}}]),Te}(),de=function(){function Te(De){this.options=De||te.defaults}var Se=Te.prototype;return Se.code=function(oe,ue,Y){var D=(ue||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(oe,D);U!=null&&U!==oe&&(Y=!0,oe=U)}return oe=oe.replace(/\n$/,"")+`
`,D?'<pre><code class="'+this.options.langPrefix+m(D,!0)+'">'+(Y?oe:m(oe,!0))+`</code></pre>
`:"<pre><code>"+(Y?oe:m(oe,!0))+`</code></pre>
`},Se.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Se.html=function(oe){return oe},Se.heading=function(oe,ue,Y,D){if(this.options.headerIds){var U=this.options.headerPrefix+D.slug(Y);return"<h"+ue+' id="'+U+'">'+oe+"</h"+ue+`>
`}return"<h"+ue+">"+oe+"</h"+ue+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(oe,ue,Y){var D=ue?"ol":"ul",U=ue&&Y!==1?' start="'+Y+'"':"";return"<"+D+U+`>
`+oe+"</"+D+`>
`},Se.listitem=function(oe){return"<li>"+oe+`</li>
`},Se.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(oe){return"<p>"+oe+`</p>
`},Se.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},Se.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Se.tablecell=function(oe,ue){var Y=ue.header?"th":"td",D=ue.align?"<"+Y+' align="'+ue.align+'">':"<"+Y+">";return D+oe+("</"+Y+`>
`)},Se.strong=function(oe){return"<strong>"+oe+"</strong>"},Se.em=function(oe){return"<em>"+oe+"</em>"},Se.codespan=function(oe){return"<code>"+oe+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(oe){return"<del>"+oe+"</del>"},Se.link=function(oe,ue,Y){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var D='<a href="'+m(oe)+'"';return ue&&(D+=' title="'+ue+'"'),D+=">"+Y+"</a>",D},Se.image=function(oe,ue,Y){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var D='<img src="'+oe+'" alt="'+Y+'"';return ue&&(D+=' title="'+ue+'"'),D+=this.options.xhtml?"/>":">",D},Se.text=function(oe){return oe},Te}(),pe=function(){function Te(){}var Se=Te.prototype;return Se.strong=function(oe){return oe},Se.em=function(oe){return oe},Se.codespan=function(oe){return oe},Se.del=function(oe){return oe},Se.html=function(oe){return oe},Se.text=function(oe){return oe},Se.link=function(oe,ue,Y){return""+Y},Se.image=function(oe,ue,Y){return""+Y},Se.br=function(){return""},Te}(),re=function(){function Te(){this.seen={}}var Se=Te.prototype;return Se.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(oe,ue){var Y=oe,D=0;if(this.seen.hasOwnProperty(Y)){D=this.seen[oe];do D++,Y=oe+"-"+D;while(this.seen.hasOwnProperty(Y))}return ue||(this.seen[oe]=D,this.seen[Y]=0),Y},Se.slug=function(oe,ue){ue===void 0&&(ue={});var Y=this.serialize(oe);return this.getNextSafeSlug(Y,ue.dryrun)},Te}(),le=function(){function Te(De){this.options=De||te.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new re}Te.parse=function(oe,ue){var Y=new Te(ue);return Y.parse(oe)},Te.parseInline=function(oe,ue){var Y=new Te(ue);return Y.parseInline(oe)};var Se=Te.prototype;return Se.parse=function(oe,ue){ue===void 0&&(ue=!0);var Y="",D,U,$,V,ee,me,_e,ce,Ee,be,$e,We,tt,Ge,et,it,dt,Le,ot,X=oe.length;for(D=0;D<X;D++){if(be=oe[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(ot=this.options.extensions.renderers[be.type].call({parser:this},be),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){Y+=ot||"";continue}switch(be.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(be.tokens),be.depth,o(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(ce="",_e="",V=be.header.length,U=0;U<V;U++)_e+=this.renderer.tablecell(this.parseInline(be.header[U].tokens),{header:!0,align:be.align[U]});for(ce+=this.renderer.tablerow(_e),Ee="",V=be.rows.length,U=0;U<V;U++){for(me=be.rows[U],_e="",ee=me.length,$=0;$<ee;$++)_e+=this.renderer.tablecell(this.parseInline(me[$].tokens),{header:!1,align:be.align[$]});Ee+=this.renderer.tablerow(_e)}Y+=this.renderer.table(ce,Ee);continue}case"blockquote":{Ee=this.parse(be.tokens),Y+=this.renderer.blockquote(Ee);continue}case"list":{for($e=be.ordered,We=be.start,tt=be.loose,V=be.items.length,Ee="",U=0;U<V;U++)et=be.items[U],it=et.checked,dt=et.task,Ge="",et.task&&(Le=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Le+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Le+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Le}):Ge+=Le),Ge+=this.parse(et.tokens,tt),Ee+=this.renderer.listitem(Ge,dt,it);Y+=this.renderer.list(Ee,$e,We);continue}case"html":{Y+=this.renderer.html(be.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(Ee=be.tokens?this.parseInline(be.tokens):be.text;D+1<X&&oe[D+1].type==="text";)be=oe[++D],Ee+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);Y+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var G='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return Y},Se.parseInline=function(oe,ue){ue=ue||this.renderer;var Y="",D,U,$,V=oe.length;for(D=0;D<V;D++){if(U=oe[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&($=this.options.extensions.renderers[U.type].call({parser:this},U),$!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){Y+=$||"";continue}switch(U.type){case"escape":{Y+=ue.text(U.text);break}case"html":{Y+=ue.html(U.text);break}case"link":{Y+=ue.link(U.href,U.title,this.parseInline(U.tokens,ue));break}case"image":{Y+=ue.image(U.href,U.title,U.text);break}case"strong":{Y+=ue.strong(this.parseInline(U.tokens,ue));break}case"em":{Y+=ue.em(this.parseInline(U.tokens,ue));break}case"codespan":{Y+=ue.codespan(U.text);break}case"br":{Y+=ue.br();break}case"del":{Y+=ue.del(this.parseInline(U.tokens,ue));break}case"text":{Y+=ue.text(U.text);break}default:{var ee='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return Y},Te}();function ae(Te,Se,De){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Se=="function"&&(De=Se,Se=null),Se=c({},ae.defaults,Se||{}),A(Se),De){var oe=Se.highlight,ue;try{ue=H.lex(Te,Se)}catch(V){return De(V)}var Y=function(ee){var me;if(!ee)try{Se.walkTokens&&ae.walkTokens(ue,Se.walkTokens),me=le.parse(ue,Se)}catch(_e){ee=_e}return Se.highlight=oe,ee?De(ee):De(null,me)};if(!oe||oe.length<3||(delete Se.highlight,!ue.length))return Y();var D=0;ae.walkTokens(ue,function(V){V.type==="code"&&(D++,setTimeout(function(){oe(V.text,V.lang,function(ee,me){if(ee)return Y(ee);me!=null&&me!==V.text&&(V.text=me,V.escaped=!0),D--,D===0&&Y()})},0))}),D===0&&Y();return}function U(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(V.message+"",!0)+"</pre>";throw V}try{var $=H.lex(Te,Se);if(Se.walkTokens){if(Se.async)return Promise.all(ae.walkTokens($,Se.walkTokens)).then(function(){return le.parse($,Se)}).catch(U);ae.walkTokens($,Se.walkTokens)}return le.parse($,Se)}catch(V){U(V)}}ae.options=ae.setOptions=function(Te){return c(ae.defaults,Te),P(ae.defaults),ae},ae.getDefaults=S,ae.defaults=te.defaults,ae.use=function(){for(var Te=arguments.length,Se=new Array(Te),De=0;De<Te;De++)Se[De]=arguments[De];var oe=c.apply(void 0,[{}].concat(Se)),ue=ae.defaults.extensions||{renderers:{},childTokens:{}},Y;Se.forEach(function(D){if(D.extensions&&(Y=!0,D.extensions.forEach(function($){if(!$.name)throw new Error("extension name required");if($.renderer){var V=ue.renderers?ue.renderers[$.name]:null;V?ue.renderers[$.name]=function(){for(var ee=arguments.length,me=new Array(ee),_e=0;_e<ee;_e++)me[_e]=arguments[_e];var ce=$.renderer.apply(this,me);return ce===!1&&(ce=V.apply(this,me)),ce}:ue.renderers[$.name]=$.renderer}if($.tokenizer){if(!$.level||$.level!=="block"&&$.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[$.level]?ue[$.level].unshift($.tokenizer):ue[$.level]=[$.tokenizer],$.start&&($.level==="block"?ue.startBlock?ue.startBlock.push($.start):ue.startBlock=[$.start]:$.level==="inline"&&(ue.startInline?ue.startInline.push($.start):ue.startInline=[$.start]))}$.childTokens&&(ue.childTokens[$.name]=$.childTokens)})),D.renderer&&function(){var $=ae.defaults.renderer||new de,V=function(_e){var ce=$[_e];$[_e]=function(){for(var Ee=arguments.length,be=new Array(Ee),$e=0;$e<Ee;$e++)be[$e]=arguments[$e];var We=D.renderer[_e].apply($,be);return We===!1&&(We=ce.apply($,be)),We}};for(var ee in D.renderer)V(ee);oe.renderer=$}(),D.tokenizer&&function(){var $=ae.defaults.tokenizer||new O,V=function(_e){var ce=$[_e];$[_e]=function(){for(var Ee=arguments.length,be=new Array(Ee),$e=0;$e<Ee;$e++)be[$e]=arguments[$e];var We=D.tokenizer[_e].apply($,be);return We===!1&&(We=ce.apply($,be)),We}};for(var ee in D.tokenizer)V(ee);oe.tokenizer=$}(),D.walkTokens){var U=ae.defaults.walkTokens;oe.walkTokens=function($){var V=[];return V.push(D.walkTokens.call(this,$)),U&&(V=V.concat(U.call(this,$))),V}}Y&&(oe.extensions=ue),ae.setOptions(oe)})},ae.walkTokens=function(Te,Se){for(var De=[],oe=function(){var U=Y.value;switch(De=De.concat(Se.call(ae,U)),U.type){case"table":{for(var $=N(U.header),V;!(V=$()).done;){var ee=V.value;De=De.concat(ae.walkTokens(ee.tokens,Se))}for(var me=N(U.rows),_e;!(_e=me()).done;)for(var ce=_e.value,Ee=N(ce),be;!(be=Ee()).done;){var $e=be.value;De=De.concat(ae.walkTokens($e.tokens,Se))}break}case"list":{De=De.concat(ae.walkTokens(U.items,Se));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[U.type]?ae.defaults.extensions.childTokens[U.type].forEach(function(We){De=De.concat(ae.walkTokens(U[We],Se))}):U.tokens&&(De=De.concat(ae.walkTokens(U.tokens,Se)))}},ue=N(Te),Y;!(Y=ue()).done;)oe();return De},ae.parseInline=function(Te,Se){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Se=c({},ae.defaults,Se||{}),A(Se);try{var De=H.lexInline(Te,Se);return Se.walkTokens&&ae.walkTokens(De,Se.walkTokens),le.parseInline(De,Se)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(oe.message+"",!0)+"</pre>";throw oe}},ae.Parser=le,ae.parser=le.parse,ae.Renderer=de,ae.TextRenderer=pe,ae.Lexer=H,ae.lexer=H.lex,ae.Tokenizer=O,ae.Slugger=re,ae.parse=ae;var se=ae.options,Q=ae.setOptions,K=ae.use,Z=ae.walkTokens,he=ae.parseInline,ke=ae,Fe=le.parse,je=H.lex;te.Lexer=H,te.Parser=le,te.Renderer=de,te.Slugger=re,te.TextRenderer=pe,te.Tokenizer=O,te.getDefaults=S,te.lexer=je,te.marked=ae,te.options=se,te.parse=ke,te.parseInline=he,te.parser=Fe,te.setOptions=Q,te.use=K,te.walkTokens=Z,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ce[113],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(P,_,I){return Math.min(Math.max(P,_),I)}e.clamp=n;function C(P,_){return(_+P%_)%_}e.rot=C;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class N{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=N;class S{constructor(_){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(_),this._values.fill(0,0,_)}update(_){const I=this._values[this._index];return this._values[this._index]=_,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=_,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=S}),function(){function te(y){const N=[];typeof y=="number"&&N.push("code/timeOrigin",y);function S(_){N.push(_,Date.now())}function P(){const _=[];for(let I=0;I<N.length;I+=2)_.push({name:N[I],startTime:N[I+1]});return _}return{mark:S,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const S of performance.getEntriesByType("mark"))N.push({name:S.name,startTime:Math.round(y+S.startTime)});return N}};if(typeof process=="object"){const y=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=n(C))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var C in n)(typeof exports=="object"?exports:te)[C]=n[C]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(C){if(e[C])return e[C].exports;var y=e[C]={i:C,l:!1,exports:{}};return te[C].call(y.exports,y,y.exports,n),y.l=!0,y.exports}return n.m=te,n.c=e,n.d=function(C,y,N){n.o(C,y)||Object.defineProperty(C,y,{enumerable:!0,get:N})},n.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},n.t=function(C,y){if(1&y&&(C=n(C)),8&y||4&y&&typeof C=="object"&&C&&C.__esModule)return C;var N=Object.create(null);if(n.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:C}),2&y&&typeof C!="string")for(var S in C)n.d(N,S,function(P){return C[P]}.bind(null,S));return N},n.n=function(C){var y=C&&C.__esModule?function(){return C.default}:function(){return C};return n.d(y,"a",y),y},n.o=function(C,y){return Object.prototype.hasOwnProperty.call(C,y)},n.p="",n(n.s=0)}([function(te,e,n){(function(C){var y;e=te.exports=K,y=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],_=e.src=[],I=0,L=I++;_[L]="0|[1-9]\\d*";var w=I++;_[w]="[0-9]+";var f=I++;_[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=I++;_[E]="("+_[L]+")\\.("+_[L]+")\\.("+_[L]+")";var m=I++;_[m]="("+_[w]+")\\.("+_[w]+")\\.("+_[w]+")";var a=I++;_[a]="(?:"+_[L]+"|"+_[f]+")";var o=I++;_[o]="(?:"+_[w]+"|"+_[f]+")";var u=I++;_[u]="(?:-("+_[a]+"(?:\\."+_[a]+")*))";var g=I++;_[g]="(?:-?("+_[o]+"(?:\\."+_[o]+")*))";var b=I++;_[b]="[0-9A-Za-z-]+";var R=I++;_[R]="(?:\\+("+_[b]+"(?:\\."+_[b]+")*))";var v=I++,t="v?"+_[E]+_[u]+"?"+_[R]+"?";_[v]="^"+t+"$";var h="[v=\\s]*"+_[m]+_[g]+"?"+_[R]+"?",r=I++;_[r]="^"+h+"$";var l=I++;_[l]="((?:<|>)?=?)";var i=I++;_[i]=_[w]+"|x|X|\\*";var p=I++;_[p]=_[L]+"|x|X|\\*";var c=I++;_[c]="[v=\\s]*("+_[p]+")(?:\\.("+_[p]+")(?:\\.("+_[p]+")(?:"+_[u]+")?"+_[R]+"?)?)?";var s=I++;_[s]="[v=\\s]*("+_[i]+")(?:\\.("+_[i]+")(?:\\.("+_[i]+")(?:"+_[g]+")?"+_[R]+"?)?)?";var d=I++;_[d]="^"+_[l]+"\\s*"+_[c]+"$";var k=I++;_[k]="^"+_[l]+"\\s*"+_[s]+"$";var A=I++;_[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=I++;_[W]="(?:~>?)";var J=I++;_[J]="(\\s*)"+_[W]+"\\s+",P[J]=new RegExp(_[J],"g");var j=I++;_[j]="^"+_[W]+_[c]+"$";var O=I++;_[O]="^"+_[W]+_[s]+"$";var B=I++;_[B]="(?:\\^)";var T=I++;_[T]="(\\s*)"+_[B]+"\\s+",P[T]=new RegExp(_[T],"g");var F=I++;_[F]="^"+_[B]+_[c]+"$";var z=I++;_[z]="^"+_[B]+_[s]+"$";var H=I++;_[H]="^"+_[l]+"\\s*("+h+")$|^$";var de=I++;_[de]="^"+_[l]+"\\s*("+t+")$|^$";var pe=I++;_[pe]="(\\s*)"+_[l]+"\\s*("+h+"|"+_[c]+")",P[pe]=new RegExp(_[pe],"g");var re=I++;_[re]="^\\s*("+_[c]+")\\s+-\\s+("+_[c]+")\\s*$";var le=I++;_[le]="^\\s*("+_[s]+")\\s+-\\s+("+_[s]+")\\s*$";var ae=I++;_[ae]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)y(se,_[se]),P[se]||(P[se]=new RegExp(_[se]));function Q(ce,Ee){if(ce instanceof K)return ce;if(typeof ce!="string"||ce.length>N||!(Ee?P[r]:P[v]).test(ce))return null;try{return new K(ce,Ee)}catch{return null}}function K(ce,Ee){if(ce instanceof K){if(ce.loose===Ee)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof K))return new K(ce,Ee);y("SemVer",ce,Ee),this.loose=Ee;var be=ce.trim().match(Ee?P[r]:P[v]);if(!be)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var We=+$e;if(We>=0&&We<S)return We}return $e}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ce,Ee){var be=Q(ce,Ee);return be?be.version:null},e.clean=function(ce,Ee){var be=Q(ce.trim().replace(/^[=v]+/,""),Ee);return be?be.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ce){return y("SemVer.compare",this.version,this.loose,ce),ce instanceof K||(ce=new K(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},K.prototype.compareMain=function(ce){return ce instanceof K||(ce=new K(ce,this.loose)),he(this.major,ce.major)||he(this.minor,ce.minor)||he(this.patch,ce.patch)},K.prototype.comparePre=function(ce){if(ce instanceof K||(ce=new K(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Ee=0;do{var be=this.prerelease[Ee],$e=ce.prerelease[Ee];if(y("prerelease compare",Ee,be,$e),be===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(be===void 0)return-1;if(be!==$e)return he(be,$e)}while(++Ee)},K.prototype.inc=function(ce,Ee){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ee),this.inc("pre",Ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ee),this.inc("pre",Ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}Ee&&(this.prerelease[0]===Ee?isNaN(this.prerelease[1])&&(this.prerelease=[Ee,0]):this.prerelease=[Ee,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Ee,be,$e){typeof be=="string"&&($e=be,be=void 0);try{return new K(ce,be).inc(Ee,$e).version}catch{return null}},e.diff=function(ce,Ee){if(Te(ce,Ee))return null;var be=Q(ce),$e=Q(Ee);if(be.prerelease.length||$e.prerelease.length){for(var We in be)if((We==="major"||We==="minor"||We==="patch")&&be[We]!==$e[We])return"pre"+We;return"prerelease"}for(var We in be)if((We==="major"||We==="minor"||We==="patch")&&be[We]!==$e[We])return We},e.compareIdentifiers=he;var Z=/^[0-9]+$/;function he(ce,Ee){var be=Z.test(ce),$e=Z.test(Ee);return be&&$e&&(ce=+ce,Ee=+Ee),be&&!$e?-1:$e&&!be?1:ce<Ee?-1:ce>Ee?1:0}function ke(ce,Ee,be){return new K(ce,be).compare(new K(Ee,be))}function Fe(ce,Ee,be){return ke(ce,Ee,be)>0}function je(ce,Ee,be){return ke(ce,Ee,be)<0}function Te(ce,Ee,be){return ke(ce,Ee,be)===0}function Se(ce,Ee,be){return ke(ce,Ee,be)!==0}function De(ce,Ee,be){return ke(ce,Ee,be)>=0}function oe(ce,Ee,be){return ke(ce,Ee,be)<=0}function ue(ce,Ee,be,$e){var We;switch(Ee){case"===":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),We=ce===be;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),We=ce!==be;break;case"":case"=":case"==":We=Te(ce,be,$e);break;case"!=":We=Se(ce,be,$e);break;case">":We=Fe(ce,be,$e);break;case">=":We=De(ce,be,$e);break;case"<":We=je(ce,be,$e);break;case"<=":We=oe(ce,be,$e);break;default:throw new TypeError("Invalid operator: "+Ee)}return We}function Y(ce,Ee){if(ce instanceof Y){if(ce.loose===Ee)return ce;ce=ce.value}if(!(this instanceof Y))return new Y(ce,Ee);y("comparator",ce,Ee),this.loose=Ee,this.parse(ce),this.semver===D?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(ce,Ee){return he(Ee,ce)},e.major=function(ce,Ee){return new K(ce,Ee).major},e.minor=function(ce,Ee){return new K(ce,Ee).minor},e.patch=function(ce,Ee){return new K(ce,Ee).patch},e.compare=ke,e.compareLoose=function(ce,Ee){return ke(ce,Ee,!0)},e.rcompare=function(ce,Ee,be){return ke(Ee,ce,be)},e.sort=function(ce,Ee){return ce.sort(function(be,$e){return e.compare(be,$e,Ee)})},e.rsort=function(ce,Ee){return ce.sort(function(be,$e){return e.rcompare(be,$e,Ee)})},e.gt=Fe,e.lt=je,e.eq=Te,e.neq=Se,e.gte=De,e.lte=oe,e.cmp=ue,e.Comparator=Y;var D={};function U(ce,Ee){if(ce instanceof U)return ce.loose===Ee?ce:new U(ce.raw,Ee);if(ce instanceof Y)return new U(ce.value,Ee);if(!(this instanceof U))return new U(ce,Ee);if(this.loose=Ee,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function $(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function V(ce,Ee,be,$e,We,tt,Ge,et,it,dt,Le,ot,X){return((Ee=$(be)?"":$($e)?">="+be+".0.0":$(We)?">="+be+"."+$e+".0":">="+Ee)+" "+(et=$(it)?"":$(dt)?"<"+(+it+1)+".0.0":$(Le)?"<"+it+"."+(+dt+1)+".0":ot?"<="+it+"."+dt+"."+Le+"-"+ot:"<="+et)).trim()}function ee(ce,Ee){for(var be=0;be<ce.length;be++)if(!ce[be].test(Ee))return!1;if(Ee.prerelease.length){for(be=0;be<ce.length;be++)if(y(ce[be].semver),ce[be].semver!==D&&ce[be].semver.prerelease.length>0){var $e=ce[be].semver;if($e.major===Ee.major&&$e.minor===Ee.minor&&$e.patch===Ee.patch)return!0}return!1}return!0}function me(ce,Ee,be){try{Ee=new U(Ee,be)}catch{return!1}return Ee.test(ce)}function _e(ce,Ee,be,$e){var We,tt,Ge,et,it;switch(ce=new K(ce,$e),Ee=new U(Ee,$e),be){case">":We=Fe,tt=oe,Ge=je,et=">",it=">=";break;case"<":We=je,tt=De,Ge=Fe,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(ce,Ee,$e))return!1;for(var dt=0;dt<Ee.set.length;++dt){var Le=Ee.set[dt],ot=null,X=null;if(Le.forEach(function(G){G.semver===D&&(G=new Y(">=0.0.0")),ot=ot||G,X=X||G,We(G.semver,ot.semver,$e)?ot=G:Ge(G.semver,X.semver,$e)&&(X=G)}),ot.operator===et||ot.operator===it||(!X.operator||X.operator===et)&&tt(ce,X.semver)||X.operator===it&&Ge(ce,X.semver))return!1}return!0}Y.prototype.parse=function(ce){var Ee=this.loose?P[H]:P[de],be=ce.match(Ee);if(!be)throw new TypeError("Invalid comparator: "+ce);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new K(be[2],this.loose):this.semver=D},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ce){return y("Comparator.test",ce,this.loose),this.semver===D||(typeof ce=="string"&&(ce=new K(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ce,Ee){if(!(ce instanceof Y))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new U(ce.value,Ee),me(this.value,be,Ee);if(ce.operator==="")return be=new U(this.value,Ee),me(ce.semver,be,Ee);var $e=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),tt=this.semver.version===ce.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),et=ue(this.semver,"<",ce.semver,Ee)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),it=ue(this.semver,">",ce.semver,Ee)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return $e||We||tt&&Ge||et||it},e.Range=U,U.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},U.prototype.toString=function(){return this.range},U.prototype.parseRange=function(ce){var Ee=this.loose;ce=ce.trim(),y("range",ce,Ee);var be=Ee?P[le]:P[re];ce=ce.replace(be,V),y("hyphen replace",ce),ce=ce.replace(P[pe],"$1$2$3"),y("comparator trim",ce,P[pe]),ce=(ce=(ce=ce.replace(P[J],"$1~")).replace(P[T],"$1^")).split(/\s+/).join(" ");var $e=Ee?P[H]:P[de],We=ce.split(" ").map(function(tt){return function(Ge,et){return y("comp",Ge),Ge=function(it,dt){return it.trim().split(/\s+/).map(function(Le){return function(ot,X){y("caret",ot,X);var G=X?P[z]:P[F];return ot.replace(G,function(ve,Ne,xe,ze,Qe){var nt;return y("caret",ot,ve,Ne,xe,ze,Qe),$(Ne)?nt="":$(xe)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":$(ze)?nt=Ne==="0"?">="+Ne+"."+xe+".0 <"+Ne+"."+(+xe+1)+".0":">="+Ne+"."+xe+".0 <"+(+Ne+1)+".0.0":Qe?(y("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),nt=Ne==="0"?xe==="0"?">="+Ne+"."+xe+"."+ze+Qe+" <"+Ne+"."+xe+"."+(+ze+1):">="+Ne+"."+xe+"."+ze+Qe+" <"+Ne+"."+(+xe+1)+".0":">="+Ne+"."+xe+"."+ze+Qe+" <"+(+Ne+1)+".0.0"):(y("no pr"),nt=Ne==="0"?xe==="0"?">="+Ne+"."+xe+"."+ze+" <"+Ne+"."+xe+"."+(+ze+1):">="+Ne+"."+xe+"."+ze+" <"+Ne+"."+(+xe+1)+".0":">="+Ne+"."+xe+"."+ze+" <"+(+Ne+1)+".0.0"),y("caret return",nt),nt})}(Le,dt)}).join(" ")}(Ge,et),y("caret",Ge),Ge=function(it,dt){return it.trim().split(/\s+/).map(function(Le){return function(ot,X){var G=X?P[O]:P[j];return ot.replace(G,function(ve,Ne,xe,ze,Qe){var nt;return y("tilde",ot,ve,Ne,xe,ze,Qe),$(Ne)?nt="":$(xe)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":$(ze)?nt=">="+Ne+"."+xe+".0 <"+Ne+"."+(+xe+1)+".0":Qe?(y("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),nt=">="+Ne+"."+xe+"."+ze+Qe+" <"+Ne+"."+(+xe+1)+".0"):nt=">="+Ne+"."+xe+"."+ze+" <"+Ne+"."+(+xe+1)+".0",y("tilde return",nt),nt})}(Le,dt)}).join(" ")}(Ge,et),y("tildes",Ge),Ge=function(it,dt){return y("replaceXRanges",it,dt),it.split(/\s+/).map(function(Le){return function(ot,X){ot=ot.trim();var G=X?P[k]:P[d];return ot.replace(G,function(ve,Ne,xe,ze,Qe,nt){y("xRange",ot,ve,Ne,xe,ze,Qe,nt);var vt=$(xe),wt=vt||$(ze),Ct=wt||$(Qe);return Ne==="="&&Ct&&(Ne=""),vt?ve=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Ct?(wt&&(ze=0),Ct&&(Qe=0),Ne===">"?(Ne=">=",wt?(xe=+xe+1,ze=0,Qe=0):Ct&&(ze=+ze+1,Qe=0)):Ne==="<="&&(Ne="<",wt?xe=+xe+1:ze=+ze+1),ve=Ne+xe+"."+ze+"."+Qe):wt?ve=">="+xe+".0.0 <"+(+xe+1)+".0.0":Ct&&(ve=">="+xe+"."+ze+".0 <"+xe+"."+(+ze+1)+".0"),y("xRange return",ve),ve})}(Le,dt)}).join(" ")}(Ge,et),y("xrange",Ge),Ge=function(it,dt){return y("replaceStars",it,dt),it.trim().replace(P[ae],"")}(Ge,et),y("stars",Ge),Ge}(tt,Ee)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(tt){return!!tt.match($e)})),We=We.map(function(tt){return new Y(tt,Ee)})},U.prototype.intersects=function(ce,Ee){if(!(ce instanceof U))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function($e){return ce.set.some(function(We){return We.every(function(tt){return $e.intersects(tt,Ee)})})})})},e.toComparators=function(ce,Ee){return new U(ce,Ee).set.map(function(be){return be.map(function($e){return $e.value}).join(" ").trim().split(" ")})},U.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new K(ce,this.loose));for(var Ee=0;Ee<this.set.length;Ee++)if(ee(this.set[Ee],ce))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(ce,Ee,be){var $e=null,We=null;try{var tt=new U(Ee,be)}catch{return null}return ce.forEach(function(Ge){tt.test(Ge)&&($e&&We.compare(Ge)!==-1||(We=new K($e=Ge,be)))}),$e},e.minSatisfying=function(ce,Ee,be){var $e=null,We=null;try{var tt=new U(Ee,be)}catch{return null}return ce.forEach(function(Ge){tt.test(Ge)&&($e&&We.compare(Ge)!==1||(We=new K($e=Ge,be)))}),$e},e.validRange=function(ce,Ee){try{return new U(ce,Ee).range||"*"}catch{return null}},e.ltr=function(ce,Ee,be){return _e(ce,Ee,"<",be)},e.gtr=function(ce,Ee,be){return _e(ce,Ee,">",be)},e.outside=_e,e.prerelease=function(ce,Ee){var be=Q(ce,Ee);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ce,Ee,be){return ce=new U(ce,be),Ee=new U(Ee,be),ce.intersects(Ee)},e.coerce=function(ce){if(ce instanceof K)return ce;if(typeof ce!="string")return null;var Ee=ce.match(P[A]);return Ee==null?null:Q((Ee[1]||"0")+"."+(Ee[2]||"0")+"."+(Ee[3]||"0"))}}).call(this,n(1))},function(te,e){var n,C,y=te.exports={};function N(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function P(o){if(n===setTimeout)return setTimeout(o,0);if((n===N||!n)&&setTimeout)return n=setTimeout,setTimeout(o,0);try{return n(o,0)}catch{try{return n.call(null,o,0)}catch{return n.call(this,o,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:N}catch{n=N}try{C=typeof clearTimeout=="function"?clearTimeout:S}catch{C=S}})();var _,I=[],L=!1,w=-1;function f(){L&&_&&(L=!1,_.length?I=_.concat(I):w=-1,I.length&&E())}function E(){if(!L){var o=P(f);L=!0;for(var u=I.length;u;){for(_=I,I=[];++w<u;)_&&_[w].run();w=-1,u=I.length}_=null,L=!1,function(g){if(C===clearTimeout)return clearTimeout(g);if((C===S||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(g);try{C(g)}catch{try{return C.call(null,g)}catch{return C.call(this,g)}}}(o)}}function m(o,u){this.fun=o,this.array=u}function a(){}y.nextTick=function(o){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];I.push(new m(o,u)),I.length!==1||L||P(E)},m.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=a,y.addListener=a,y.once=a,y.off=a,y.removeListener=a,y.removeAllListeners=a,y.emit=a,y.prependListener=a,y.prependOnceListener=a,y.listeners=function(o){return[]},y.binding=function(o){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(o){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ce[114],Ie([1,0,12,6]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(R){const v=R;return v?typeof v.read=="function":!1}e.isReadable=y;function N(R){const v=R;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=N;function S(R){const v=R;return v?N(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=S;function P(R,v){return new _(R,v)}e.newWriteableStream=P;class _{constructor(v,t){this.reducer=v,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v<"u"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(t=>t(v))}emitError(v){this.listeners.error.length===0?(0,n.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(t=>t(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,t){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(v,t){if(this.state.destroyed)return;let h;switch(v){case"data":h=this.listeners.data;break;case"end":h=this.listeners.end;break;case"error":h=this.listeners.error;break}if(h){const r=h.indexOf(t);r>=0&&h.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(h=>h())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(R,v){const t=[];let h;for(;(h=R.read())!==null;)t.push(h);return v(t)}e.consumeReadable=I;function L(R,v,t){const h=[];let r;for(;(r=R.read())!==null&&h.length<t;)h.push(r);return r===null&&h.length>0?v(h):{read:()=>{if(h.length>0)return h.shift();if(typeof r<"u"){const l=r;return r=void 0,l}return R.read()}}}e.peekReadable=L;function w(R,v){return new Promise((t,h)=>{const r=[];f(R,{onData:l=>{v&&r.push(l)},onError:l=>{v?h(l):t(void 0)},onEnd:()=>{t(v?v(r):void 0)}})})}e.consumeStream=w;function f(R,v){let t=!1;return R.on("error",h=>{t||v.onError(h)}),R.on("end",()=>{t||v.onEnd()}),R.on("data",h=>{t||v.onData(h)}),(0,C.toDisposable)(()=>t=!0)}e.listenStream=f;function E(R,v){return new Promise((t,h)=>{const r=new C.DisposableStore,l=[],i=s=>{if(l.push(s),l.length>v)return r.dispose(),R.pause(),t({stream:R,buffer:l,ended:!1})},p=s=>h(s),c=()=>t({stream:R,buffer:l,ended:!0});r.add((0,C.toDisposable)(()=>R.removeListener("error",p))),R.on("error",p),r.add((0,C.toDisposable)(()=>R.removeListener("end",c))),R.on("end",c),r.add((0,C.toDisposable)(()=>R.removeListener("data",i))),R.on("data",i)})}e.peekStream=E;function m(R,v){const t=P(v);return t.end(R),t}e.toStream=m;function a(){const R=P(()=>{throw new Error("not supported")});return R.end(),R}e.emptyStream=a;function o(R){let v=!1;return{read:()=>v?null:(v=!0,R)}}e.toReadable=o;function u(R,v,t){const h=P(t);return f(R,{onData:r=>h.write(v.data(r)),onError:r=>h.error(v.error?v.error(r):r),onEnd:()=>h.end()}),h}e.transform=u;function g(R,v,t){let h=!1;return{read:()=>{const r=v.read();return h?r:(h=!0,r!==null?t([R,r]):R)}}}e.prefixedReadable=g;function b(R,v,t){let h=!1;const r=P(t);return f(v,{onData:l=>h?r.write(l):(h=!0,r.write(t([R,l]))),onError:l=>r.error(l),onEnd:()=>{h||(h=!0,r.write(R)),r.end()}}),r}e.prefixedStream=b}),define(Ce[23],Ie([1,0,114]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let y,N;class S{static alloc(s){return C?new S(Buffer.allocUnsafe(s)):new S(new Uint8Array(s))}static wrap(s){return C&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new S(s)}static fromString(s,d){return!(d?.dontUseNodeBuffer||!1)&&C?new S(Buffer.from(s)):(y||(y=new TextEncoder),new S(y.encode(s)))}static fromByteArray(s){const d=S.alloc(s.length);for(let k=0,A=s.length;k<A;k++)d.buffer[k]=s[k];return d}static concat(s,d){if(typeof d>"u"){d=0;for(let W=0,J=s.length;W<J;W++)d+=s[W].byteLength}const k=S.alloc(d);let A=0;for(let W=0,J=s.length;W<J;W++){const j=s[W];k.set(j,A),A+=j.byteLength}return k}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=S.alloc(this.byteLength);return s.set(this),s}toString(){return C?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(s,d){return new S(this.buffer.subarray(s,d))}set(s,d){if(s instanceof S)this.buffer.set(s.buffer,d);else if(s instanceof Uint8Array)this.buffer.set(s,d);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),d);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return I(this.buffer,s)}writeUInt32BE(s,d){L(this.buffer,s,d)}readUInt32LE(s){return w(this.buffer,s)}writeUInt32LE(s,d){f(this.buffer,s,d)}readUInt8(s){return E(this.buffer,s)}writeUInt8(s,d){m(this.buffer,s,d)}}e.VSBuffer=S;function P(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0}e.readUInt16LE=P;function _(c,s,d){c[d+0]=s&255,s=s>>>8,c[d+1]=s&255}e.writeUInt16LE=_;function I(c,s){return c[s]*2**24+c[s+1]*2**16+c[s+2]*2**8+c[s+3]}e.readUInt32BE=I;function L(c,s,d){c[d+3]=s,s=s>>>8,c[d+2]=s,s=s>>>8,c[d+1]=s,s=s>>>8,c[d]=s}e.writeUInt32BE=L;function w(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0|c[s+2]<<16>>>0|c[s+3]<<24>>>0}e.readUInt32LE=w;function f(c,s,d){c[d+0]=s&255,s=s>>>8,c[d+1]=s&255,s=s>>>8,c[d+2]=s&255,s=s>>>8,c[d+3]=s&255}e.writeUInt32LE=f;function E(c,s){return c[s]}e.readUInt8=E;function m(c,s,d){c[d]=s}e.writeUInt8=m;function a(c){return n.consumeReadable(c,s=>S.concat(s))}e.readableToBuffer=a;function o(c){return n.toReadable(c)}e.bufferToReadable=o;function u(c){return n.consumeStream(c,s=>S.concat(s))}e.streamToBuffer=u;async function g(c){return c.ended?S.concat(c.buffer):S.concat([...c.buffer,await u(c.stream)])}e.bufferedStreamToBuffer=g;function b(c){return n.toStream(c,s=>S.concat(s))}e.bufferToStream=b;function R(c){return n.transform(c,{data:s=>typeof s=="string"?S.fromString(s):S.wrap(s)},s=>S.concat(s))}e.streamToBufferReadableStream=R;function v(c){return n.newWriteableStream(s=>S.concat(s),c)}e.newWriteableBufferStream=v;function t(c,s){return n.prefixedReadable(c,s,d=>S.concat(d))}e.prefixedBufferReadable=t;function h(c,s){return n.prefixedStream(c,s,d=>S.concat(d))}e.prefixedBufferStream=h;function r(c){let s=0,d=0,k=0;const A=new Uint8Array(Math.floor(c.length/4*3)),W=j=>{switch(d){case 3:A[k++]=s|j,d=0;break;case 2:A[k++]=s|j>>>2,s=j<<6,d=3;break;case 1:A[k++]=s|j>>>4,s=j<<4,d=2;break;default:s=j<<2,d=1}};for(let j=0;j<c.length;j++){const O=c.charCodeAt(j);if(O>=65&&O<=90)W(O-65);else if(O>=97&&O<=122)W(O-97+26);else if(O>=48&&O<=57)W(O-48+52);else if(O===43||O===45)W(62);else if(O===47||O===95)W(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${c[j]}`)}}const J=k;for(;d>0;)W(0);return S.wrap(A).slice(0,J)}e.decodeBase64=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:c},s=!0,d=!1){const k=d?i:l;let A="";const W=c.byteLength%3;let J=0;for(;J<c.byteLength-W;J+=3){const j=c[J+0],O=c[J+1],B=c[J+2];A+=k[j>>>2],A+=k[(j<<4|O>>>4)&63],A+=k[(O<<2|B>>>6)&63],A+=k[B&63]}if(W===1){const j=c[J+0];A+=k[j>>>2],A+=k[j<<4&63],s&&(A+="==")}else if(W===2){const j=c[J+0],O=c[J+1];A+=k[j>>>2],A+=k[(j<<4|O>>>4)&63],A+=k[O<<2&63],s&&(A+="=")}return A}e.encodeBase64=p}),define(Ce[115],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[38],Ie([1,0,84]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var C;(function(S){function P(_){return _&&typeof _=="object"&&typeof _.id=="string"}S.isThemeColor=P})(C=e.ThemeColor||(e.ThemeColor={}));function y(S){return{id:S}}e.themeColorFromId=y;var N;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function _(g){const b=P.exec(g.id);if(!b)return _(n.Codicon.error);const[,R,v]=b,t=["codicon","codicon-"+R];return v&&t.push("codicon-modifier-"+v.substring(1)),t}S.asClassNameArray=_;function I(g){return _(g).join(" ")}S.asClassName=I;function L(g){return"."+_(g).join(".")}S.asCSSSelector=L;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||C.isThemeColor(g.color))}S.isThemeIcon=w;const f=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function E(g){const b=f.exec(g);if(!b)return;const[,R]=b;return{id:R}}S.fromString=E;function m(g){return{id:g}}S.fromId=m;function a(g,b){let R=g.id;const v=R.lastIndexOf("~");return v!==-1&&(R=R.substring(0,v)),b&&(R=`${R}~${b}`),{id:R}}S.modify=a;function o(g){const b=g.id.lastIndexOf("~");if(b!==-1)return g.id.substring(b+1)}S.getModifier=o;function u(g,b){return g.id===b.id&&g.color?.id===b.color?.id}S.isEqual=u})(N=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ce[34],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(y){return n.test(y)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(P){for(let _=0;_<P.length;_++)P[_]=Math.floor(Math.random()*256);return P};const N=new Uint8Array(16),S=[];for(let P=0;P<256;P++)S.push(P.toString(16).padStart(2,"0"));return function(){y(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let _=0,I="";return I+=S[N[_++]],I+=S[N[_++]],I+=S[N[_++]],I+=S[N[_++]],I+="-",I+=S[N[_++]],I+=S[N[_++]],I+="-",I+=S[N[_++]],I+=S[N[_++]],I+="-",I+=S[N[_++]],I+=S[N[_++]],I+="-",I+=S[N[_++]],I+=S[N[_++]],I+=S[N[_++]],I+=S[N[_++]],I+=S[N[_++]],I+=S[N[_++]],I}}()}),define(Ce[116],Ie([1,0,16,34]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(P){return{id:(0,C.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=y;function N(P,_,I){return{id:(0,C.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:_,data:I}),value:void 0}}e.createFileDataTransferItem=N;class S{constructor(){this._entries=new Map}get size(){return this._entries.size}has(_){return this._entries.has(this.toKey(_))}get(_){return this._entries.get(this.toKey(_))?.[0]}append(_,I){const L=this._entries.get(_);L?L.push(I):this._entries.set(this.toKey(_),[I])}replace(_,I){this._entries.set(this.toKey(_),[I])}delete(_){this._entries.delete(this.toKey(_))}*entries(){for(const[_,I]of this._entries.entries())for(const L of I)yield[_,L]}values(){return Array.from(this._entries.values()).flat()}forEach(_){for(const[I,L]of this.entries())_(L,I)}toKey(_){return _.toLowerCase()}}e.VSDataTransfer=S,e.UriList=Object.freeze({create:P=>(0,n.distinct)(P.map(_=>_.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(_=>!_.startsWith("#"))})}),define(Ce[117],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[118],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class C{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let _=0,I=P.notIn.length;_<I;_++)switch(P.notIn[_]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,_){if(P.getTokenCount()===0)return!0;const I=P.findTokenIndexAtOffset(_-2),L=P.getStandardTokenType(I);return this.isOK(L)}_findNeutralCharacterInRange(P,_){for(let I=P;I<=_;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=C;class y{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of P)N(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),N(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),N(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),N(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&N(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=y;function N(S,P,_){S.has(P)?S.get(P).push(_):S.set(P,[_])}}),define(Ce[119],Ie([13,14]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Ce[120],Ie([13,14]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ce[121],Ie([1,0,120]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,y=C*60,N=y*24,S=N*7,P=N*30,_=N*365;function I(w,f,E,m){typeof w!="number"&&(w=w.getTime());const a=Math.round((new Date().getTime()-w)/1e3);if(a<-30)return(0,n.localize)(0,null,I(new Date().getTime()+a*1e3,!1));if(!m&&a<30)return(0,n.localize)(1,null);let o;return a<C?(o=a,f?o===1?E?(0,n.localize)(2,null,o):(0,n.localize)(3,null,o):E?(0,n.localize)(4,null,o):(0,n.localize)(5,null,o):o===1?E?(0,n.localize)(6,null,o):(0,n.localize)(7,null,o):E?(0,n.localize)(8,null,o):(0,n.localize)(9,null,o)):a<y?(o=Math.floor(a/C),f?o===1?E?(0,n.localize)(10,null,o):(0,n.localize)(11,null,o):E?(0,n.localize)(12,null,o):(0,n.localize)(13,null,o):o===1?E?(0,n.localize)(14,null,o):(0,n.localize)(15,null,o):E?(0,n.localize)(16,null,o):(0,n.localize)(17,null,o)):a<N?(o=Math.floor(a/y),f?o===1?E?(0,n.localize)(18,null,o):(0,n.localize)(19,null,o):E?(0,n.localize)(20,null,o):(0,n.localize)(21,null,o):o===1?E?(0,n.localize)(22,null,o):(0,n.localize)(23,null,o):E?(0,n.localize)(24,null,o):(0,n.localize)(25,null,o)):a<S?(o=Math.floor(a/N),f?o===1?(0,n.localize)(26,null,o):(0,n.localize)(27,null,o):o===1?(0,n.localize)(28,null,o):(0,n.localize)(29,null,o)):a<P?(o=Math.floor(a/S),f?o===1?E?(0,n.localize)(30,null,o):(0,n.localize)(31,null,o):E?(0,n.localize)(32,null,o):(0,n.localize)(33,null,o):o===1?E?(0,n.localize)(34,null,o):(0,n.localize)(35,null,o):E?(0,n.localize)(36,null,o):(0,n.localize)(37,null,o)):a<_?(o=Math.floor(a/P),f?o===1?E?(0,n.localize)(38,null,o):(0,n.localize)(39,null,o):E?(0,n.localize)(40,null,o):(0,n.localize)(41,null,o):o===1?E?(0,n.localize)(42,null,o):(0,n.localize)(43,null,o):E?(0,n.localize)(44,null,o):(0,n.localize)(45,null,o)):(o=Math.floor(a/_),f?o===1?E?(0,n.localize)(46,null,o):(0,n.localize)(47,null,o):E?(0,n.localize)(48,null,o):(0,n.localize)(49,null,o):o===1?E?(0,n.localize)(50,null,o):(0,n.localize)(51,null,o):E?(0,n.localize)(52,null,o):(0,n.localize)(53,null,o))}e.fromNow=I;function L(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Ce[122],Ie([13,14]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ce[39],Ie([1,0,16,9,122]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(w,f){return f&&(w.stack||w.stacktrace)?y.localize(0,null,P(w),S(w.stack)||S(w.stacktrace)):P(w)}function S(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?y.localize(1,null,w.message):w.message||y.localize(2,null)}function _(w=null,f=!1){if(!w)return y.localize(3,null);if(Array.isArray(w)){const E=n.coalesce(w),m=_(E[0],f);return E.length>1?y.localize(4,null,m,E.length):m}if(C.isString(w))return w;if(w.detail){const E=w.detail;if(E.error)return N(E.error,f);if(E.exception)return N(E.exception,f)}return w.stack?N(w,f):w.message?w.message:y.localize(5,null)}e.toErrorMessage=_;function I(w){const f=w;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=I;function L(w,f){let E;return typeof w=="string"?E=new Error(w):E=w,E.actions=f,E}e.createErrorWithActions=L}),define(Ce[123],Ie([1,0,85,19]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new n.Lazy(()=>{const s=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:s,collatorIsNumeric:s.resolvedOptions().numeric}}),N=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(s,d,k=!1){const A=s||"",W=d||"",J=y.value.collator.compare(A,W);return y.value.collatorIsNumeric&&J===0&&A!==W?A<W?-1:1:J}e.compareFileNames=P;function _(s,d){const k=N.value.collator;return s=s||"",d=d||"",R(k,s,d)}e.compareFileNamesDefault=_;function I(s,d){const k=N.value.collator;return s=s||"",d=d||"",r(s,d)||R(k,s,d)}e.compareFileNamesUpper=I;function L(s,d){const k=N.value.collator;return s=s||"",d=d||"",h(s,d)||R(k,s,d)}e.compareFileNamesLower=L;function w(s,d){return s=s||"",d=d||"",s===d?0:s<d?-1:1}e.compareFileNamesUnicode=w;function f(s,d){const[k,A]=g(s),[W,J]=g(d);let j=y.value.collator.compare(A,J);if(j===0){if(y.value.collatorIsNumeric&&A!==J)return A<J?-1:1;if(j=y.value.collator.compare(k,W),y.value.collatorIsNumeric&&j===0&&k!==W)return k<W?-1:1}return j}e.compareFileExtensions=f;function E(s,d){s=s||"",d=d||"";const k=b(s),A=b(d),W=N.value.collator,J=S.value.collator;return R(J,k,A)||R(W,s,d)}e.compareFileExtensionsDefault=E;function m(s,d){s=s||"",d=d||"";const k=b(s),A=b(d),W=N.value.collator,J=S.value.collator;return R(J,k,A)||r(s,d)||R(W,s,d)}e.compareFileExtensionsUpper=m;function a(s,d){s=s||"",d=d||"";const k=b(s),A=b(d),W=N.value.collator,J=S.value.collator;return R(J,k,A)||h(s,d)||R(W,s,d)}e.compareFileExtensionsLower=a;function o(s,d){s=s||"",d=d||"";const k=b(s).toLowerCase(),A=b(d).toLowerCase();return k!==A?k<A?-1:1:s!==d?s<d?-1:1:0}e.compareFileExtensionsUnicode=o;const u=/^(.*?)(\.([^.]*))?$/;function g(s,d=!1){const k=s?u.exec(s):[];let A=[k&&k[1]||"",k&&k[3]||""];return d&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function b(s){const d=s?u.exec(s):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function R(s,d,k){const A=s.compare(d,k);return A!==0?A:d.length!==k.length?d.length<k.length?-1:1:0}function v(s){const d=s.charAt(0);return d.toLocaleUpperCase()!==d}function t(s){const d=s.charAt(0);return d.toLocaleLowerCase()!==d}function h(s,d){return v(s)&&t(d)?-1:t(s)&&v(d)?1:0}function r(s,d){return t(s)&&v(d)?-1:v(s)&&t(d)?1:0}function l(s,d,k=!1){return k||(s=s&&s.toLowerCase(),d=d&&d.toLowerCase()),s===d?0:s<d?-1:1}function i(s,d,k=!1){const A=s.split(C.sep),W=d.split(C.sep),J=A.length-1,j=W.length-1;let O,B;for(let T=0;;T++){if(O=J===T,B=j===T,O&&B)return P(A[T],W[T],k);if(O)return-1;if(B)return 1;const F=l(A[T],W[T],k);if(F!==0)return F}}e.comparePaths=i;function p(s,d,k){const A=s.toLowerCase(),W=d.toLowerCase(),J=c(s,d,k);if(J)return J;const j=A.endsWith(k),O=W.endsWith(k);if(j!==O)return j?-1:1;const B=P(A,W);return B!==0?B:A.localeCompare(W)}e.compareAnything=p;function c(s,d,k){const A=s.toLowerCase(),W=d.toLowerCase(),J=A.startsWith(k),j=W.startsWith(k);if(J!==j)return J?-1:1;if(J&&j){if(A.length<W.length)return-1;if(A.length>W.length)return 1}return 0}e.compareByPrefix=c}),define(Ce[64],Ie([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(L){const w=(0,n.extname)(L),f=C[w.toLowerCase()];return f!==void 0?f:S(L)}e.getMediaOrTextMime=N;function S(L){const w=(0,n.extname)(L);return y[w.toLowerCase()]}e.getMediaMime=S;function P(L){for(const w in y)if(y[w]===L)return w}e.getExtensionForMimeType=P;const _=/^(.+)\/(.+?)(;.+)?$/;function I(L,w){const f=_.exec(L);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:w?void 0:L}e.normalizeMimeType=I}),define(Ce[124],Ie([1,0,4,6,119]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class N extends C.Disposable{constructor(f,E="",m="",a=!0,o){super(),this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=f,this._label=E,this._cssClass=m,this._enabled=a,this._actionCallback=o}get id(){return this._id}get label(){return this._label}set label(f){this._setLabel(f)}_setLabel(f){this._label!==f&&(this._label=f,this._onDidChange.fire({label:f}))}get tooltip(){return this._tooltip||""}set tooltip(f){this._setTooltip(f)}_setTooltip(f){this._tooltip!==f&&(this._tooltip=f,this._onDidChange.fire({tooltip:f}))}get class(){return this._cssClass}set class(f){this._setClass(f)}_setClass(f){this._cssClass!==f&&(this._cssClass=f,this._onDidChange.fire({class:f}))}get enabled(){return this._enabled}set enabled(f){this._setEnabled(f)}_setEnabled(f){this._enabled!==f&&(this._enabled=f,this._onDidChange.fire({enabled:f}))}get checked(){return this._checked}set checked(f){this._setChecked(f)}_setChecked(f){this._checked!==f&&(this._checked=f,this._onDidChange.fire({checked:f}))}async run(f,E){this._actionCallback&&await this._actionCallback(f)}}e.Action=N;class S extends C.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new n.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new n.Emitter),this.onDidRun=this._onDidRun.event}async run(f,E){if(!f.enabled)return;this._onWillRun.fire({action:f});let m;try{await this.runAction(f,E)}catch(a){m=a}this._onDidRun.fire({action:f,error:m})}async runAction(f,E){await f.run(E)}}e.ActionRunner=S;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let E=[];for(const m of f)m.length&&(E.length?E=[...E,new P,...m]:E=m);return E}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class _{get actions(){return this._actions}constructor(f,E,m,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=E,this.class=a,this._actions=m}async run(){}}e.SubmenuAction=_;class I extends N{constructor(){super(I.ID,y.localize(0,null),void 0,!1)}}I.ID="vs.actions.empty",e.EmptySubmenuAction=I;function L(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=L}),define(Ce[40],Ie([1,0,19,21,10,9]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(i){return i===47||i===92}e.isPathSeparator=S;function P(i){return i.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=P;function _(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=_;function I(i,p=n.posix.sep){if(!i)return"";const c=i.length,s=i.charCodeAt(0);if(S(s)){if(S(i.charCodeAt(1))&&!S(i.charCodeAt(2))){let k=3;const A=k;for(;k<c&&!S(i.charCodeAt(k));k++);if(A!==k&&!S(i.charCodeAt(k+1))){for(k+=1;k<c;k++)if(S(i.charCodeAt(k)))return i.slice(0,k+1).replace(/[\\/]/g,p)}}return p}else if(u(s)&&i.charCodeAt(1)===58)return S(i.charCodeAt(2))?i.slice(0,2)+p:i.slice(0,2);let d=i.indexOf("://");if(d!==-1){for(d+=3;d<c;d++)if(S(i.charCodeAt(d)))return i.slice(0,d+1)}return""}e.getRoot=I;function L(i){if(!C.isWindows||!i||i.length<5)return!1;let p=i.charCodeAt(0);if(p!==92||(p=i.charCodeAt(1),p!==92))return!1;let c=2;const s=c;for(;c<i.length&&(p=i.charCodeAt(c),p!==92);c++);return!(s===c||(p=i.charCodeAt(c+1),isNaN(p)||p===92))}e.isUNC=L;const w=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(i,p=C.isWindows){const c=p?w:f;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||p&&E.test(i)||i==="."||i===".."||p&&i[i.length-1]==="."||p&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=m;function a(i,p,c){const s=i===p;return!c||s?s:!i||!p?!1:(0,y.equalsIgnoreCase)(i,p)}e.isEqual=a;function o(i,p,c,s=n.sep){if(i===p)return!0;if(!i||!p||p.length>i.length)return!1;if(c){if(!(0,y.startsWithIgnoreCase)(i,p))return!1;if(p.length===i.length)return!0;let k=p.length;return p.charAt(p.length-1)===s&&k--,i.charAt(k)===s}return p.charAt(p.length-1)!==s&&(p+=s),i.indexOf(p)===0}e.isEqualOrParent=o;function u(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=u;function g(i,p){return C.isWindows&&i.endsWith(":")&&(i+=n.sep),(0,n.isAbsolute)(i)||(i=(0,n.join)(p,i)),i=(0,n.normalize)(i),C.isWindows?(i=(0,y.rtrim)(i,n.sep),i.endsWith(":")&&(i+=n.sep)):(i=(0,y.rtrim)(i,n.sep),i||(i=n.sep)),i}e.sanitizeFilePath=g;function b(i){const p=(0,n.normalize)(i);return C.isWindows?i.length>3?!1:R(p)&&(i.length===2||p.charCodeAt(2)===92):p===n.posix.sep}e.isRootOrDriveLetter=b;function R(i,p=C.isWindows){return p?u(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=R;function v(i){return R(i)?i[0]:void 0}e.getDriveLetter=v;function t(i,p,c){return p.length>i.length?-1:i===p?0:(c&&(i=i.toLowerCase(),p=p.toLowerCase()),i.indexOf(p))}e.indexOfPath=t;function h(i){const p=i.split(":");let c,s,d;for(const k of p){const A=Number(k);(0,N.isNumber)(A)?s===void 0?s=A:d===void 0&&(d=A):c=c?[c,k].join(":"):k}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:s!==void 0?s:void 0,column:d!==void 0?d:s!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(i,p,c=8){let s="";for(let k=0;k<c;k++)s+=r.charAt(Math.floor(Math.random()*r.length));let d;return p?d=`${p}-${s}`:d=s,i?(0,n.join)(i,d):d}e.randomPath=l}),define(Ce[125],Ie([1,0,28,10]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Y){return function(D,U){for(let $=0,V=Y.length;$<V;$++){const ee=Y[$](D,U);if(ee)return ee}return null}}e.or=y,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(Y,D,U){if(!U||U.length<D.length)return null;let $;return Y?$=C.startsWithIgnoreCase(U,D):$=U.indexOf(D)===0,$?D.length>0?[{start:0,end:D.length}]:[]:null}function S(Y,D){const U=D.toLowerCase().indexOf(Y.toLowerCase());return U===-1?null:[{start:U,end:U+Y.length}]}e.matchesContiguousSubString=S;function P(Y,D){return _(Y.toLowerCase(),D.toLowerCase(),0,0)}e.matchesSubString=P;function _(Y,D,U,$){if(U===Y.length)return[];if($===D.length)return null;if(Y[U]===D[$]){let V=null;return(V=_(Y,D,U+1,$+1))?u({start:$,end:$+1},V):null}return _(Y,D,U,$+1)}function I(Y){return 97<=Y&&Y<=122}function L(Y){return 65<=Y&&Y<=90}e.isUpper=L;function w(Y){return 48<=Y&&Y<=57}function f(Y){return Y===32||Y===9||Y===10||Y===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>E.add(Y.charCodeAt(0)));function m(Y){return f(Y)||E.has(Y)}function a(Y,D){return Y===D||m(Y)&&m(D)}function o(Y){return I(Y)||L(Y)||w(Y)}function u(Y,D){return D.length===0?D=[Y]:Y.end===D[0].start?D[0].start=Y.start:D.unshift(Y),D}function g(Y,D){for(let U=D;U<Y.length;U++){const $=Y.charCodeAt(U);if(L($)||w($)||U>0&&!o(Y.charCodeAt(U-1)))return U}return Y.length}function b(Y,D,U,$){if(U===Y.length)return[];if($===D.length)return null;if(Y[U]!==D[$].toLowerCase())return null;{let V=null,ee=$+1;for(V=b(Y,D,U+1,$+1);!V&&(ee=g(D,ee))<D.length;)V=b(Y,D,U+1,ee),ee++;return V===null?null:u({start:$,end:$+1},V)}}function R(Y){let D=0,U=0,$=0,V=0,ee=0;for(let be=0;be<Y.length;be++)ee=Y.charCodeAt(be),L(ee)&&D++,I(ee)&&U++,o(ee)&&$++,w(ee)&&V++;const me=D/Y.length,_e=U/Y.length,ce=$/Y.length,Ee=V/Y.length;return{upperPercent:me,lowerPercent:_e,alphaPercent:ce,numericPercent:Ee}}function v(Y){const{upperPercent:D,lowerPercent:U}=Y;return U===0&&D>.6}function t(Y){const{upperPercent:D,lowerPercent:U,alphaPercent:$,numericPercent:V}=Y;return U>.2&&D<.8&&$>.6&&V<.2}function h(Y){let D=0,U=0,$=0,V=0;for(let ee=0;ee<Y.length;ee++)$=Y.charCodeAt(ee),L($)&&D++,I($)&&U++,f($)&&V++;return(D===0||U===0)&&V===0?Y.length<=30:D<=5}function r(Y,D){if(!D||(D=D.trim(),D.length===0)||!h(Y)||D.length>60)return null;const U=R(D);if(!t(U)){if(!v(U))return null;D=D.toLowerCase()}let $=null,V=0;for(Y=Y.toLowerCase();V<D.length&&($=b(Y,D,0,V))===null;)V=g(D,V+1);return $}e.matchesCamelCase=r;function l(Y,D,U=!1){if(!D||D.length===0)return null;let $=null,V=0;for(Y=Y.toLowerCase(),D=D.toLowerCase();V<D.length&&($=i(Y,D,0,V,U))===null;)V=p(D,V+1);return $}e.matchesWords=l;function i(Y,D,U,$,V){if(U===Y.length)return[];if($===D.length)return null;if(a(Y.charCodeAt(U),D.charCodeAt($))){let ee=null,me=$+1;if(ee=i(Y,D,U+1,$+1,V),!V)for(;!ee&&(me=p(D,me))<D.length;)ee=i(Y,D,U+1,me,V),me++;return ee?Y.charCodeAt(U)!==D.charCodeAt($)?ee:u({start:$,end:$+1},ee):null}else return null}function p(Y,D){for(let U=D;U<Y.length;U++)if(m(Y.charCodeAt(U))||U>0&&m(Y.charCodeAt(U-1)))return U;return Y.length}const c=y(e.matchesPrefix,r,S),s=y(e.matchesPrefix,r,P),d=new n.LRUCache(1e4);function k(Y,D,U=!1){if(typeof Y!="string"||typeof D!="string")return null;let $=d.get(Y);$||($=new RegExp(C.convertSimple2RegExpPattern(Y),"i"),d.set(Y,$));const V=$.exec(D);return V?[{start:V.index,end:V.index+V[0].length}]:U?s(Y,D):c(Y,D)}e.matchesFuzzy=k;function A(Y,D){const U=Fe(Y,Y.toLowerCase(),0,D,D.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?J(U):null}e.matchesFuzzy2=A;function W(Y,D,U,$,V,ee){const me=Math.min(13,Y.length);for(;U<me;U++){const _e=Fe(Y,D,U,$,V,ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(_e)return _e}return[0,ee]}e.anyScore=W;function J(Y){if(typeof Y>"u")return[];const D=[],U=Y[1];for(let $=Y.length-1;$>1;$--){const V=Y[$]+U,ee=D[D.length-1];ee&&ee.end===V?ee.end=V+1:D.push({start:V,end:V+1})}return D}e.createMatches=J;const j=128;function O(){const Y=[],D=[];for(let U=0;U<=j;U++)D[U]=0;for(let U=0;U<=j;U++)Y.push(D.slice(0));return Y}function B(Y){const D=[];for(let U=0;U<=Y;U++)D[U]=0;return D}const T=B(2*j),F=B(2*j),z=O(),H=O(),de=O(),pe=!1;function re(Y,D,U,$,V){function ee(_e,ce,Ee=" "){for(;_e.length<ce;)_e=Ee+_e;return _e}let me=` |   |${$.split("").map(_e=>ee(_e,3)).join("|")}
`;for(let _e=0;_e<=U;_e++)_e===0?me+=" |":me+=`${D[_e-1]}|`,me+=Y[_e].slice(0,V+1).map(ce=>ee(ce.toString(),3)).join("|")+`
`;return me}function le(Y,D,U,$){Y=Y.substr(D),U=U.substr($),console.log(re(H,Y,Y.length,U,U.length)),console.log(re(de,Y,Y.length,U,U.length)),console.log(re(z,Y,Y.length,U,U.length))}function ae(Y,D){if(D<0||D>=Y.length)return!1;const U=Y.codePointAt(D);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(U)}}function se(Y,D){if(D<0||D>=Y.length)return!1;switch(Y.charCodeAt(D)){case 32:case 9:return!0;default:return!1}}function Q(Y,D,U){return D[Y]!==U[Y]}function K(Y,D,U,$,V,ee,me=!1){for(;D<U&&V<ee;)Y[D]===$[V]&&(me&&(T[D]=V),D+=1),V+=1;return D===U}e.isPatternInWord=K;var Z;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Z||(Z={}));var he;(function(Y){Y.Default=[-100,0];function D(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}Y.isDefault=D})(he=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(D,U){this.firstMatchCanBeWeak=D,this.boostFullMatch=U}}ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ke;function Fe(Y,D,U,$,V,ee,me=ke.default){const _e=Y.length>j?j:Y.length,ce=$.length>j?j:$.length;if(U>=_e||ee>=ce||_e-U>ce-ee||!K(D,U,_e,V,ee,ce,!0))return;je(_e,ce,U,ee,D,V);let Ee=1,be=1,$e=U,We=ee;const tt=[!1];for(Ee=1,$e=U;$e<_e;Ee++,$e++){const Le=T[$e],ot=F[$e],X=$e+1<_e?F[$e+1]:ce;for(be=Le-ee+1,We=Le;We<X;be++,We++){let G=Number.MIN_SAFE_INTEGER,ve=!1;We<=ot&&(G=Te(Y,D,$e,U,$,V,We,ce,ee,z[Ee-1][be-1]===0,tt));let Ne=0;G!==Number.MAX_SAFE_INTEGER&&(ve=!0,Ne=G+H[Ee-1][be-1]);const xe=We>Le,ze=xe?H[Ee][be-1]+(z[Ee][be-1]>0?-5:0):0,Qe=We>Le+1&&z[Ee][be-1]>0,nt=Qe?H[Ee][be-2]+(z[Ee][be-2]>0?-5:0):0;if(Qe&&(!xe||nt>=ze)&&(!ve||nt>=Ne))H[Ee][be]=nt,de[Ee][be]=3,z[Ee][be]=0;else if(xe&&(!ve||ze>=Ne))H[Ee][be]=ze,de[Ee][be]=2,z[Ee][be]=0;else if(ve)H[Ee][be]=Ne,de[Ee][be]=1,z[Ee][be]=z[Ee-1][be-1]+1;else throw new Error("not possible")}}if(pe&&le(Y,U,$,ee),!tt[0]&&!me.firstMatchCanBeWeak)return;Ee--,be--;const Ge=[H[Ee][be],ee];let et=0,it=0;for(;Ee>=1;){let Le=be;do{const ot=de[Ee][Le];if(ot===3)Le=Le-2;else if(ot===2)Le=Le-1;else break}while(Le>=1);et>1&&D[U+Ee-1]===V[ee+be-1]&&!Q(Le+ee-1,$,V)&&et+1>z[Ee][Le]&&(Le=be),Le===be?et++:et=1,it||(it=Le),Ee--,be=Le-1,Ge.push(be)}ce===_e&&me.boostFullMatch&&(Ge[0]+=2);const dt=it-_e;return Ge[0]-=dt,Ge}e.fuzzyScore=Fe;function je(Y,D,U,$,V,ee){let me=Y-1,_e=D-1;for(;me>=U&&_e>=$;)V[me]===ee[_e]&&(F[me]=_e,me--),_e--}function Te(Y,D,U,$,V,ee,me,_e,ce,Ee,be){if(D[U]!==ee[me])return Number.MIN_SAFE_INTEGER;let $e=1,We=!1;return me===U-$?$e=Y[U]===V[me]?7:5:Q(me,V,ee)&&(me===0||!Q(me-1,V,ee))?($e=Y[U]===V[me]?7:5,We=!0):ae(ee,me)&&(me===0||!ae(ee,me-1))?$e=5:(ae(ee,me-1)||se(ee,me-1))&&($e=5,We=!0),$e>1&&U===$&&(be[0]=!0),We||(We=Q(me,V,ee)||ae(ee,me-1)||se(ee,me-1)),U===$?me>ce&&($e-=We?3:5):Ee?$e+=We?2:0:$e+=We?0:1,me+1===_e&&($e-=We?3:5),$e}function Se(Y,D,U,$,V,ee,me){return oe(Y,D,U,$,V,ee,!0,me)}e.fuzzyScoreGracefulAggressive=Se;function De(Y,D,U,$,V,ee,me){return oe(Y,D,U,$,V,ee,!1,me)}e.fuzzyScoreGraceful=De;function oe(Y,D,U,$,V,ee,me,_e){let ce=Fe(Y,D,U,$,V,ee,_e);if(ce&&!me)return ce;if(Y.length>=3){const Ee=Math.min(7,Y.length-1);for(let be=U+1;be<Ee;be++){const $e=ue(Y,be);if($e){const We=Fe($e,$e.toLowerCase(),U,$,V,ee,_e);We&&(We[0]-=3,(!ce||We[0]>ce[0])&&(ce=We))}}}return ce}function ue(Y,D){if(D+1>=Y.length)return;const U=Y[D],$=Y[D+1];if(U!==$)return Y.slice(0,D)+$+U+Y.slice(D+2)}}),define(Ce[126],Ie([1,0,125,10,38]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const N="$(",S=new RegExp(`\\$\\(${y.ThemeIcon.iconNameExpression}(?:${y.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${S.source}`,"g");function _(u){return u.replace(P,(g,b)=>b?g:`\\${g}`)}e.escapeIcons=_;const I=new RegExp(`\\\\${S.source}`,"g");function L(u){return u.replace(I,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=L;const w=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function f(u){return u.indexOf(N)===-1?u:u.replace(w,(g,b,R,v)=>R?g:b||v||"")}e.stripIcons=f;function E(u){return u?u.replace(/\$\((.*?)\)/g,(g,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=E;const m=new RegExp(`\\$\\(${y.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(u){m.lastIndex=0;let g="";const b=[];let R=0;for(;;){const v=m.lastIndex,t=m.exec(u),h=u.substring(v,t?.index);if(h.length>0){g+=h;for(let r=0;r<h.length;r++)b.push(R)}if(!t)break;R+=t[0].length}return{text:g,iconOffsets:b}}e.parseLabelWithIcons=a;function o(u,g,b=!1){const{text:R,iconOffsets:v}=g;if(!v||v.length===0)return(0,n.matchesFuzzy)(u,R,b);const t=(0,C.ltrim)(R," "),h=R.length-t.length,r=(0,n.matchesFuzzy)(u,t,b);if(r)for(const l of r){const i=v[l.start+h]+h;l.start+=i,l.end+=i}return r}e.matchesFuzzyIconAware=o}),define(Ce[29],Ie([1,0,10]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(C||(C={})),function(y){const N="error",S="warning",P="warn",_="info",I="ignore";function L(f){return f?n.equalsIgnoreCase(N,f)?y.Error:n.equalsIgnoreCase(S,f)||n.equalsIgnoreCase(P,f)?y.Warning:n.equalsIgnoreCase(_,f)?y.Info:y.Ignore:y.Ignore}y.fromValue=L;function w(f){switch(f){case y.Error:return N;case y.Warning:return S;case y.Info:return _;default:return I}}y.toString=w}(C||(C={})),e.default=C}),define(Ce[48],Ie([1,0,16,10]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const m=E.charCodeAt(0),a=this._value.charCodeAt(this._pos);return m-a}value(){return this._value[this._pos]}}e.StringIterator=y;class N{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,C.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=N;class S{constructor(E=!0,m=!0){this._splitOnBackslash=E,this._caseSensitive=m}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let m=E.length-1;m>=0;m--,this._valueLen--){const a=this._value.charCodeAt(m);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,C.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var P;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(P||(P={}));class _{constructor(E,m){this._ignorePathCasing=E,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,C.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=_;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(L||(L={}));class w{static forUris(E=()=>!1,m=()=>!1){return new w(new _(E,m))}static forPaths(E=!1){return new w(new S(void 0,!E))}static forStrings(){return new w(new y)}static forConfigKeys(){return new w(new N)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,m){if(m){const a=m.slice(0);(0,n.shuffle)(a);for(const o of a)this.set(o,E)}else{const a=E.slice(0);(0,n.shuffle)(a);for(const o of a)this.set(o[0],o[1])}}set(E,m){const a=this._iter.reset(E);let o;this._root||(this._root=new I,this._root.segment=a.value());const u=[];for(o=this._root;;){const b=a.cmp(o.segment);if(b>0)o.left||(o.left=new I,o.left.segment=a.value()),u.push([-1,o]),o=o.left;else if(b<0)o.right||(o.right=new I,o.right.segment=a.value()),u.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new I,o.mid.segment=a.value()),u.push([0,o]),o=o.mid;else break}const g=o.value;o.value=m,o.key=E;for(let b=u.length-1;b>=0;b--){const R=u[b][1];R.updateHeight();const v=R.balanceFactor();if(v<-1||v>1){const t=u[b][0],h=u[b+1][0];if(t===1&&h===1)u[b][1]=R.rotateLeft();else if(t===-1&&h===-1)u[b][1]=R.rotateRight();else if(t===1&&h===-1)R.right=u[b+1][1]=u[b+1][1].rotateRight(),u[b][1]=R.rotateLeft();else if(t===-1&&h===1)R.left=u[b+1][1]=u[b+1][1].rotateLeft(),u[b][1]=R.rotateRight();else throw new Error;if(b>0)switch(u[b-1][0]){case-1:u[b-1][1].left=u[b][1];break;case 1:u[b-1][1].right=u[b][1];break;case 0:u[b-1][1].mid=u[b][1];break}else this._root=u[0][1]}}return g}get(E){return this._getNode(E)?.value}_getNode(E){const m=this._iter.reset(E);let a=this._root;for(;a;){const o=m.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(m.hasNext())m.next(),a=a.mid;else break}return a}has(E){const m=this._getNode(E);return!(m?.value===void 0&&m?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,m){const a=this._iter.reset(E),o=[];let u=this._root;for(;u;){const g=a.cmp(u.segment);if(g>0)o.push([-1,u]),u=u.left;else if(g<0)o.push([1,u]),u=u.right;else if(a.hasNext())a.next(),o.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this._min(u.right);if(g.key){const{key:b,value:R,segment:v}=g;this._delete(g.key,!1),u.key=b,u.value=R,u.segment=v}}else{const g=u.left??u.right;if(o.length>0){const[b,R]=o[o.length-1];switch(b){case-1:R.left=g;break;case 0:R.mid=g;break;case 1:R.right=g;break}}else this._root=g}for(let g=o.length-1;g>=0;g--){const b=o[g][1];b.updateHeight();const R=b.balanceFactor();if(R>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),o[g][1]=b.rotateLeft()):R<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),o[g][1]=b.rotateRight()),g>0)switch(o[g-1][0]){case-1:o[g-1][1].left=o[g][1];break;case 1:o[g-1][1].right=o[g][1];break;case 0:o[g-1][1].mid=o[g][1];break}else this._root=o[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const m=this._iter.reset(E);let a=this._root,o;for(;a;){const u=m.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(m.hasNext())m.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(E){return this._findSuperstrOrElement(E,!1)}_findSuperstrOrElement(E,m){const a=this._iter.reset(E);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):m?o.value:void 0}}hasElementOrSubtree(E){return this._findSuperstrOrElement(E,!0)!==void 0}forEach(E){for(const[m,a]of this)E(a,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const m=[];return this._dfsEntries(E,m),m[Symbol.iterator]()}_dfsEntries(E,m){!E||(E.left&&this._dfsEntries(E.left,m),E.value&&m.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,m),E.right&&this._dfsEntries(E.right,m))}_isBalanced(){const E=m=>{if(!m)return!0;const a=m.balanceFactor();return a<-1||a>1?!1:E(m.left)&&E(m.right)};return E(this._root)}}e.TernarySearchTree=w}),define(Ce[65],Ie([1,0,23,10,2]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(I){return JSON.stringify(I,P)}e.stringify=N;function S(I){let L=JSON.parse(I);return L=_(L),L}e.parse=S;function P(I,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,C.regExpFlags)(L)}:L}function _(I,L=0){if(!I||L>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return y.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 16:return new Date(I.source)}if(I instanceof n.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let w=0;w<I.length;++w)I[w]=_(I[w],L+1);else for(const w in I)Object.hasOwnProperty.call(I,w)&&(I[w]=_(I[w],L+1))}return I}e.revive=_}),define(Ce[15],Ie([1,0,12,21,2]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var N;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(N=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${N.vscodeRemoteResource}`}setPreferredWebSchema(L){this._preferredWebSchema=L}setDelegate(L){this._delegate=L}setServerRootPath(L){this._remoteResourcesPath=`${L}/${N.vscodeRemoteResource}`}set(L,w,f){this._hosts[L]=w,this._ports[L]=f}setConnectionToken(L,w){this._connectionTokens[L]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(L){if(this._delegate)try{return this._delegate(L)}catch(o){return n.onUnexpectedError(o),L}const w=L.authority;let f=this._hosts[w];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const E=this._ports[w],m=this._connectionTokens[w];let a=`path=${encodeURIComponent(L.path)}`;return typeof m=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),y.URI.from({scheme:C.isWeb?this._preferredWebSchema:N.vscodeRemoteResource,authority:`${f}:${E}`,path:this._remoteResourcesPath,query:a})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(L){const w=this.toUri(L,te);return this.uriToBrowserUri(w)}uriToBrowserUri(L){return L.scheme===N.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===N.file&&(C.isNative||C.isWebWorker&&C.globals.origin===`${N.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?L.with({scheme:N.vscodeFileResource,authority:L.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(L){const w=this.toUri(L,te);return this.uriToFileUri(w)}uriToFileUri(L){return L.scheme===N.vscodeFileResource?L.with({scheme:N.file,authority:L.authority!==P.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(L,w){return y.URI.isUri(L)?L:y.URI.parse(w.toUrl(L))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P;var _;(function(I){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(L.get("3"));const w="vscode-coi";function f(m){let a;typeof m=="string"?a=new URL(m).searchParams:m instanceof URL?a=m.searchParams:y.URI.isUri(m)&&(a=new URL(m.toString(!0)).searchParams);const o=a?.get(w);if(!!o)return L.get(o)}I.getHeadersFromQuery=f;function E(m,a,o){if(!globalThis.crossOriginIsolated)return;const u=a&&o?"3":o?"2":"1";m instanceof URLSearchParams?m.set(w,u):m[w]=u}I.addSearchParam=E})(_=e.COI||(e.COI={}))}),define(Ce[24],Ie([1,0,40,15,19,21,10,2]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(E){return(0,P.uriToFsPath)(E,!0)}e.originalFSPath=_;class I{constructor(m){this._ignorePathCasing=m}compare(m,a,o=!1){return m===a?0:(0,S.compare)(this.getComparisonKey(m,o),this.getComparisonKey(a,o))}isEqual(m,a,o=!1){return m===a?!0:!m||!a?!1:this.getComparisonKey(m,o)===this.getComparisonKey(a,o)}getComparisonKey(m,a=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,a,o=!1){if(m.scheme===a.scheme){if(m.scheme===C.Schemas.file)return n.isEqualOrParent(_(m),_(a),this._ignorePathCasing(m))&&m.query===a.query&&(o||m.fragment===a.fragment);if((0,e.isEqualAuthority)(m.authority,a.authority))return n.isEqualOrParent(m.path,a.path,this._ignorePathCasing(m),"/")&&m.query===a.query&&(o||m.fragment===a.fragment)}return!1}joinPath(m,...a){return P.URI.joinPath(m,...a)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return y.posix.basename(m.path)}extname(m){return y.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let a;return m.scheme===C.Schemas.file?a=P.URI.file(y.dirname(_(m))).path:(a=y.posix.dirname(m.path),m.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),a="/")),m.with({path:a})}normalizePath(m){if(!m.path.length)return m;let a;return m.scheme===C.Schemas.file?a=P.URI.file(y.normalize(_(m))).path:a=y.posix.normalize(m.path),m.with({path:a})}relativePath(m,a){if(m.scheme!==a.scheme||!(0,e.isEqualAuthority)(m.authority,a.authority))return;if(m.scheme===C.Schemas.file){const g=y.relative(_(m),_(a));return N.isWindows?n.toSlashes(g):g}let o=m.path||"/";const u=a.path||"/";if(this._ignorePathCasing(m)){let g=0;for(const b=Math.min(o.length,u.length);g<b&&!(o.charCodeAt(g)!==u.charCodeAt(g)&&o.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);o=u.substr(0,g)+o.substr(g)}return y.posix.relative(o,u)}resolvePath(m,a){if(m.scheme===C.Schemas.file){const o=P.URI.file(y.resolve(_(m),a));return m.with({authority:o.authority,path:o.path})}return a=n.toPosixPath(a),m.with({path:y.posix.resolve(m.path,a)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,a){return m===a||m!==void 0&&a!==void 0&&(0,S.equalsIgnoreCase)(m,a)}hasTrailingPathSeparator(m,a=y.sep){if(m.scheme===C.Schemas.file){const o=_(m);return o.length>n.getRoot(o).length&&o[o.length-1]===a}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,a=y.sep){return(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,a=y.sep){let o=!1;if(m.scheme===C.Schemas.file){const u=_(m);o=u!==void 0&&u.length===n.getRoot(u).length&&u[u.length-1]===a}else{a="/";const u=m.path;o=u.length===1&&u.charCodeAt(u.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path+"/"}):m}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(E=>E.scheme===C.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new I(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(E,m){const a=[];for(let o=0;o<E.length;o++){const u=m(E[o]);E.some((g,b)=>b===o?!1:(0,e.isEqualOrParent)(u,m(g)))||a.push(E[o])}return a}e.distinctParents=L;var w;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function m(a){const o=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(b=>{const[R,v]=b.split(":");R&&v&&o.set(R,v)});const g=a.path.substring(0,a.path.indexOf(";"));return g&&o.set(E.META_DATA_MIME,g),o}E.parseMetaData=m})(w=e.DataUri||(e.DataUri={}));function f(E,m,a){if(m){let o=E.path;return o&&o[0]!==y.posix.sep&&(o=y.posix.sep+o),E.with({scheme:a,authority:m,path:o})}return E.with({scheme:a})}e.toLocalResource=f}),define(Ce[17],Ie([1,0,20,12,4,6,24,21,115]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(K){return!!K&&typeof K.then=="function"}e.isThenable=I;function L(K){const Z=new n.CancellationTokenSource,he=K(Z.token),ke=new Promise((Fe,je)=>{const Te=Z.token.onCancellationRequested(()=>{Te.dispose(),Z.dispose(),je(new C.CancellationError)});Promise.resolve(he).then(Se=>{Te.dispose(),Z.dispose(),Fe(Se)},Se=>{Te.dispose(),Z.dispose(),je(Se)})});return new class{cancel(){Z.cancel()}then(Fe,je){return ke.then(Fe,je)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return ke.finally(Fe)}}}e.createCancelablePromise=L;function w(K,Z,he){return new Promise((ke,Fe)=>{const je=Z.onCancellationRequested(()=>{je.dispose(),ke(he)});K.then(ke,Fe).finally(()=>je.dispose())})}e.raceCancellation=w;function f(K,Z){return new Promise((he,ke)=>{const Fe=Z.onCancellationRequested(()=>{Fe.dispose(),ke(new C.CancellationError)});K.then(he,ke).finally(()=>Fe.dispose())})}e.raceCancellationError=f;async function E(K){let Z=-1;const he=K.map((Fe,je)=>Fe.then(Te=>(Z=je,Te))),ke=await Promise.race(he);return K.forEach((Fe,je)=>{je!==Z&&Fe.cancel()}),ke}e.raceCancellablePromises=E;function m(K,Z,he){let ke;const Fe=setTimeout(()=>{ke?.(void 0),he?.()},Z);return Promise.race([K.finally(()=>clearTimeout(Fe)),new Promise(je=>ke=je)])}e.raceTimeout=m;function a(K){return new Promise((Z,he)=>{const ke=K();I(ke)?ke.then(Z,he):Z(ke)})}e.asPromise=a;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Z){if(this.activePromise){if(this.queuedPromiseFactory=Z,!this.queuedPromise){const he=()=>{this.queuedPromise=null;const ke=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ke};this.queuedPromise=new Promise(ke=>{this.activePromise.then(he,he).then(ke)})}return new Promise((he,ke)=>{this.queuedPromise.then(he,ke)})}return this.activePromise=Z(),new Promise((he,ke)=>{this.activePromise.then(Fe=>{this.activePromise=null,he(Fe)},Fe=>{this.activePromise=null,ke(Fe)})})}}e.Throttler=o;class u{constructor(){this.current=Promise.resolve(null)}queue(Z){return this.current=this.current.then(()=>Z(),()=>Z())}}e.Sequencer=u;class g{constructor(){this.promiseMap=new Map}queue(Z,he){const Fe=(this.promiseMap.get(Z)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.promiseMap.get(Z)===Fe&&this.promiseMap.delete(Z)});return this.promiseMap.set(Z,Fe),Fe}}e.SequencerByKey=g;const b=(K,Z)=>{let he=!0;const ke=setTimeout(()=>{he=!1,Z()},K);return{isTriggered:()=>he,dispose:()=>{clearTimeout(ke),he=!1}}},R=K=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,K())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class v{constructor(Z){this.defaultDelay=Z,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Z,he=this.defaultDelay){this.task=Z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,je)=>{this.doResolve=Fe,this.doReject=je}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const ke=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=he===_.MicrotaskDelay?R(ke):b(he,ke),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new C.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=v;class t{constructor(Z){this.delayer=new v(Z),this.throttler=new o}trigger(Z,he){return this.delayer.trigger(()=>this.throttler.queue(Z),he)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class h{constructor(){this._isOpen=!1,this._promise=new Promise((Z,he)=>{this._completePromise=Z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class r extends h{constructor(Z){super(),this._timeout=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function l(K,Z){return Z?new Promise((he,ke)=>{const Fe=setTimeout(()=>{je.dispose(),he()},K),je=Z.onCancellationRequested(()=>{clearTimeout(Fe),je.dispose(),ke(new C.CancellationError)})}):L(he=>l(K,he))}e.timeout=l;function i(K,Z=0){const he=setTimeout(K,Z);return(0,N.toDisposable)(()=>clearTimeout(he))}e.disposableTimeout=i;function p(K){const Z=[];let he=0;const ke=K.length;function Fe(){return he<ke?K[he++]():null}function je(Te){Te!=null&&Z.push(Te);const Se=Fe();return Se?Se.then(je):Promise.resolve(Z)}return Promise.resolve(null).then(je)}e.sequence=p;function c(K,Z=ke=>!!ke,he=null){let ke=0;const Fe=K.length,je=()=>{if(ke>=Fe)return Promise.resolve(he);const Te=K[ke++];return Promise.resolve(Te()).then(De=>Z(De)?Promise.resolve(De):je())};return je()}e.first=c;function s(K,Z=ke=>!!ke,he=null){if(K.length===0)return Promise.resolve(he);let ke=K.length;const Fe=()=>{ke=-1;for(const je of K)je.cancel?.()};return new Promise((je,Te)=>{for(const Se of K)Se.then(De=>{--ke>=0&&Z(De)?(Fe(),je(De)):ke===0&&je(he)}).catch(De=>{--ke>=0&&(Fe(),Te(De))})})}e.firstParallel=s;class d{constructor(Z){this._size=0,this.maxDegreeOfParalellism=Z,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new y.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Z){return this._size++,new Promise((he,ke)=>{this.outstandingPromises.push({factory:Z,c:he,e:ke}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Z=this.outstandingPromises.shift();this.runningPromises++;const he=Z.factory();he.then(Z.c,Z.e),he.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class k extends d{constructor(){super(1)}}e.Queue=k;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Z=new pe;return this.drainers.add(Z),Z.p}isDrained(){for(const[,Z]of this.queues)if(Z.size>0)return!1;return!0}queueFor(Z,he=S.extUri){const ke=he.getComparisonKey(Z);let Fe=this.queues.get(ke);return Fe||(Fe=new k,y.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(ke),this.onDidQueueDrain()}),this.queues.set(ke,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Z of this.drainers)Z.complete();this.drainers.clear()}dispose(){for(const[,Z]of this.queues)Z.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class W{constructor(Z,he){this._token=-1,typeof Z=="function"&&typeof he=="number"&&this.setIfNotSet(Z,he)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Z,he){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Z()},he)}setIfNotSet(Z,he){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Z()},he))}}e.TimeoutTimer=W;class J{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Z,he){this.cancel(),this._token=setInterval(()=>{Z()},he)}}e.IntervalTimer=J;class j{constructor(Z,he){this.timeoutToken=-1,this.runner=Z,this.timeout=he,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Z)}get delay(){return this.timeout}set delay(Z){this.timeout=Z}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=j;class O{constructor(Z,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.runner=Z,this.timeout=he,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Z=this.timeout){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=O;class B extends j{constructor(Z,he){super(Z,he),this.units=[]}work(Z){this.units.push(Z),this.isScheduled()||this.schedule()}doRun(){const Z=this.units;this.units=[],this.runner?.(Z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class T extends N.Disposable{constructor(Z,he){super(),this.options=Z,this.handler=he,this.pendingWork=[],this.throttler=this._register(new N.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Z){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Z.length>this.options.maxBufferedWork)return!1}else if(this.pending+Z.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const he of Z)this.pendingWork.push(he);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new j(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,P.setTimeout0)(()=>{if(Z)return;const he=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(K,Z)=>{const he=requestIdleCallback(K,typeof Z=="number"?{timeout:Z}:void 0);let ke=!1;return{dispose(){ke||(ke=!0,cancelIdleCallback(he))}}}}();class F{constructor(Z){this._didRun=!1,this._executor=()=>{try{this._value=Z()}catch(he){this._error=he}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function z(K,Z,he){let ke;for(let Fe=0;Fe<he;Fe++)try{return await K()}catch(je){ke=je,await l(Z)}throw ke}e.retry=z;class H{hasPending(Z){return this._pending?typeof Z=="number"?this._pending.taskId===Z:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Z,he,ke){return this._pending={taskId:Z,cancel:()=>ke?.(),promise:he},he.then(()=>this.donePending(Z),()=>this.donePending(Z)),he}donePending(Z){this._pending&&Z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Z=this._next;this._next=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this._next)this._next.run=Z;else{let he,ke;const Fe=new Promise((je,Te)=>{he=je,ke=Te});this._next={run:Z,promise:Fe,promiseResolve:he,promiseReject:ke}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=H;class de{constructor(Z,he=()=>Date.now()){this.interval=Z,this.nowFn=he,this.lastIncrementTime=0,this.value=0}increment(){const Z=this.nowFn();return Z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Z,this.value=0),this.value++,this.value}}e.IntervalCounter=de;class pe{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Z,he)=>{this.completeCallback=Z,this.errorCallback=he})}complete(Z){return new Promise(he=>{this.completeCallback(Z),this.resolved=!0,he()})}error(Z){return new Promise(he=>{this.errorCallback(Z),this.rejected=!0,he()})}cancel(){new Promise(Z=>{this.errorCallback(new C.CancellationError),this.rejected=!0,Z()})}}e.DeferredPromise=pe;var re;(function(K){async function Z(ke){let Fe;const je=await Promise.all(ke.map(Te=>Te.then(Se=>Se,Se=>{Fe||(Fe=Se)})));if(typeof Fe<"u")throw Fe;return je}K.settled=Z;function he(ke){return new Promise(async(Fe,je)=>{try{await ke(Fe,je)}catch(Te){je(Te)}})}K.withAsyncBody=he})(re=e.Promises||(e.Promises={}));var le;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(le||(le={}));class ae{static fromArray(Z){return new ae(he=>{he.emitMany(Z)})}static fromPromise(Z){return new ae(async he=>{he.emitMany(await Z)})}static fromPromises(Z){return new ae(async he=>{await Promise.all(Z.map(async ke=>he.emitOne(await ke)))})}static merge(Z){return new ae(async he=>{await Promise.all(Z.map(async ke=>{for await(const Fe of ke)he.emitOne(Fe)}))})}constructor(Z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const he={emitOne:ke=>this.emitOne(ke),emitMany:ke=>this.emitMany(ke),reject:ke=>this.reject(ke)};try{await Promise.resolve(Z(he)),this.resolve()}catch(ke){this.reject(ke)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Z<this._results.length)return{done:!1,value:this._results[Z++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Z,he){return new ae(async ke=>{for await(const Fe of Z)ke.emitOne(he(Fe))})}map(Z){return ae.map(this,Z)}static filter(Z,he){return new ae(async ke=>{for await(const Fe of Z)he(Fe)&&ke.emitOne(Fe)})}filter(Z){return ae.filter(this,Z)}static coalesce(Z){return ae.filter(Z,he=>!!he)}coalesce(){return ae.coalesce(this)}static async toPromise(Z){const he=[];for await(const ke of Z)he.push(ke);return he}toPromise(){return ae.toPromise(this)}emitOne(Z){this._state===0&&(this._results.push(Z),this._onStateChanged.fire())}emitMany(Z){this._state===0&&(this._results=this._results.concat(Z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Z){this._state===0&&(this._state=2,this._error=Z,this._onStateChanged.fire())}}ae.EMPTY=ae.fromArray([]),e.AsyncIterableObject=ae;class se extends ae{constructor(Z,he){super(he),this._source=Z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function Q(K){const Z=new n.CancellationTokenSource,he=K(Z.token);return new se(Z,async ke=>{const Fe=Z.token.onCancellationRequested(()=>{Fe.dispose(),Z.dispose(),ke.reject(new C.CancellationError)});try{for await(const je of he){if(Z.token.isCancellationRequested)return;ke.emitOne(je)}Fe.dispose(),Z.dispose()}catch(je){Fe.dispose(),Z.dispose(),ke.reject(je)}})}e.createCancelableAsyncIterable=Q}),define(Ce[35],Ie([1,0,16,17,40,28,19,21,10]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",w="[^/\\\\]",f=/\//g;function E(de,pe){switch(de){case 0:return"";case 1:return`${w}*?`;default:return`(?:${L}|${w}+${L}${pe?`|${L}${w}+`:""})*?`}}function m(de,pe){if(!de)return[];const re=[];let le=!1,ae=!1,se="";for(const Q of de){switch(Q){case pe:if(!le&&!ae){re.push(se),se="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}se+=Q}return se&&re.push(se),re}e.splitGlobAware=m;function a(de){if(!de)return"";let pe="";const re=m(de,e.GLOB_SPLIT);if(re.every(le=>le===e.GLOBSTAR))pe=".*";else{let le=!1;re.forEach((ae,se)=>{if(ae===e.GLOBSTAR){if(le)return;pe+=E(2,se===re.length-1)}else{let Q=!1,K="",Z=!1,he="";for(const ke of ae){if(ke!=="}"&&Q){K+=ke;continue}if(Z&&(ke!=="]"||!he)){let Fe;ke==="-"?Fe=ke:(ke==="^"||ke==="!")&&!he?Fe="^":ke===e.GLOB_SPLIT?Fe="":Fe=(0,_.escapeRegExpCharacters)(ke),he+=Fe;continue}switch(ke){case"{":Q=!0;continue;case"[":Z=!0;continue;case"}":{pe+=`(?:${m(K,",").map(Te=>a(Te)).join("|")})`,Q=!1,K="";break}case"]":{pe+="["+he+"]",Z=!1,he="";break}case"?":pe+=w;continue;case"*":pe+=E(1);continue;default:pe+=(0,_.escapeRegExpCharacters)(ke)}}se<re.length-1&&(re[se+1]!==e.GLOBSTAR||se+2<re.length)&&(pe+=L)}le=ae===e.GLOBSTAR})}return pe}const o=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,R=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.LRUCache(1e4),h=function(){return!1},r=function(){return null};function l(de,pe){if(!de)return r;let re;typeof de!="string"?re=de.pattern:re=de,re=re.trim();const le=`${re}_${!!pe.trimForExclusions}`;let ae=t.get(le);if(ae)return i(ae,de);let se;return o.test(re)?ae=c(re.substr(4),re):(se=u.exec(p(re,pe)))?ae=s(se[1],re):(pe.trimForExclusions?b:g).test(re)?ae=d(re,pe):(se=R.exec(p(re,pe)))?ae=k(se[1].substr(1),re,!0):(se=v.exec(p(re,pe)))?ae=k(se[1],re,!1):ae=A(re),t.set(le,ae),i(ae,de)}function i(de,pe){if(typeof pe=="string")return de;const re=function(le,ae){return(0,y.isEqualOrParent)(le,pe.base,!P.isLinux)?de((0,_.ltrim)(le.substr(pe.base.length),S.sep),ae):null};return re.allBasenames=de.allBasenames,re.allPaths=de.allPaths,re.basenames=de.basenames,re.patterns=de.patterns,re}function p(de,pe){return pe.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function c(de,pe){return function(re,le){return typeof re=="string"&&re.endsWith(de)?pe:null}}function s(de,pe){const re=`/${de}`,le=`\\${de}`,ae=function(Q,K){return typeof Q!="string"?null:K?K===de?pe:null:Q===de||Q.endsWith(re)||Q.endsWith(le)?pe:null},se=[de];return ae.basenames=se,ae.patterns=[pe],ae.allBasenames=se,ae}function d(de,pe){const re=z(de.slice(1,-1).split(",").map(K=>l(K,pe)).filter(K=>K!==r),de),le=re.length;if(!le)return r;if(le===1)return re[0];const ae=function(K,Z){for(let he=0,ke=re.length;he<ke;he++)if(re[he](K,Z))return de;return null},se=re.find(K=>!!K.allBasenames);se&&(ae.allBasenames=se.allBasenames);const Q=re.reduce((K,Z)=>Z.allPaths?K.concat(Z.allPaths):K,[]);return Q.length&&(ae.allPaths=Q),ae}function k(de,pe,re){const le=S.sep===S.posix.sep,ae=le?de:de.replace(f,S.sep),se=S.sep+ae,Q=S.posix.sep+de;let K;return re?K=function(Z,he){return typeof Z=="string"&&(Z===ae||Z.endsWith(se)||!le&&(Z===de||Z.endsWith(Q)))?pe:null}:K=function(Z,he){return typeof Z=="string"&&(Z===ae||!le&&Z===de)?pe:null},K.allPaths=[(re?"*/":"./")+de],K}function A(de){try{const pe=new RegExp(`^${a(de)}$`);return function(re){return pe.lastIndex=0,typeof re=="string"&&pe.test(re)?de:null}}catch{return r}}function W(de,pe,re){return!de||typeof pe!="string"?!1:J(de)(pe,void 0,re)}e.match=W;function J(de,pe={}){if(!de)return h;if(typeof de=="string"||j(de)){const re=l(de,pe);if(re===r)return h;const le=function(ae,se){return!!re(ae,se)};return re.allBasenames&&(le.allBasenames=re.allBasenames),re.allPaths&&(le.allPaths=re.allPaths),le}return T(de,pe)}e.parse=J;function j(de){const pe=de;return pe?typeof pe.base=="string"&&typeof pe.pattern=="string":!1}e.isRelativePattern=j;function O(de){return de.allBasenames||[]}e.getBasenameTerms=O;function B(de){return de.allPaths||[]}e.getPathTerms=B;function T(de,pe){const re=z(Object.getOwnPropertyNames(de).map(K=>F(K,de[K],pe)).filter(K=>K!==r)),le=re.length;if(!le)return r;if(!re.some(K=>!!K.requiresSiblings)){if(le===1)return re[0];const K=function(ke,Fe){let je;for(let Te=0,Se=re.length;Te<Se;Te++){const De=re[Te](ke,Fe);if(typeof De=="string")return De;(0,C.isThenable)(De)&&(je||(je=[]),je.push(De))}return je?(async()=>{for(const Te of je){const Se=await Te;if(typeof Se=="string")return Se}return null})():null},Z=re.find(ke=>!!ke.allBasenames);Z&&(K.allBasenames=Z.allBasenames);const he=re.reduce((ke,Fe)=>Fe.allPaths?ke.concat(Fe.allPaths):ke,[]);return he.length&&(K.allPaths=he),K}const ae=function(K,Z,he){let ke,Fe;for(let je=0,Te=re.length;je<Te;je++){const Se=re[je];Se.requiresSiblings&&he&&(Z||(Z=(0,S.basename)(K)),ke||(ke=Z.substr(0,Z.length-(0,S.extname)(K).length)));const De=Se(K,Z,ke,he);if(typeof De=="string")return De;(0,C.isThenable)(De)&&(Fe||(Fe=[]),Fe.push(De))}return Fe?(async()=>{for(const je of Fe){const Te=await je;if(typeof Te=="string")return Te}return null})():null},se=re.find(K=>!!K.allBasenames);se&&(ae.allBasenames=se.allBasenames);const Q=re.reduce((K,Z)=>Z.allPaths?K.concat(Z.allPaths):K,[]);return Q.length&&(ae.allPaths=Q),ae}function F(de,pe,re){if(pe===!1)return r;const le=l(de,re);if(le===r)return r;if(typeof pe=="boolean")return le;if(pe){const ae=pe.when;if(typeof ae=="string"){const se=(Q,K,Z,he)=>{if(!he||!le(Q,K))return null;const ke=ae.replace("$(basename)",()=>Z),Fe=he(ke);return(0,C.isThenable)(Fe)?Fe.then(je=>je?de:null):Fe?de:null};return se.requiresSiblings=!0,se}}return le}function z(de,pe){const re=de.filter(K=>!!K.basenames);if(re.length<2)return de;const le=re.reduce((K,Z)=>{const he=Z.basenames;return he?K.concat(he):K},[]);let ae;if(pe){ae=[];for(let K=0,Z=le.length;K<Z;K++)ae.push(pe)}else ae=re.reduce((K,Z)=>{const he=Z.patterns;return he?K.concat(he):K},[]);const se=function(K,Z){if(typeof K!="string")return null;if(!Z){let ke;for(ke=K.length;ke>0;ke--){const Fe=K.charCodeAt(ke-1);if(Fe===47||Fe===92)break}Z=K.substr(ke)}const he=le.indexOf(Z);return he!==-1?ae[he]:null};se.basenames=le,se.patterns=ae,se.allBasenames=le;const Q=de.filter(K=>!K.basenames);return Q.push(se),Q}function H(de,pe){return(0,n.equals)(de,pe,(re,le)=>typeof re=="string"&&typeof le=="string"?re===le:typeof re!="string"&&typeof le!="string"?re.base===le.base&&re.pattern===le.pattern:!1)}e.patternsEquals=H}),define(Ce[86],Ie([1,0,12,126,24,10,2]),function(te,e,n,C,y,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(u="",g=!1){if(this.value=u,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(u,g=0){return this.value+=f(this.supportThemeIcons?(0,C.escapeIcons)(u):u).replace(/([ \t]+)/g,(b,R)=>"&nbsp;".repeat(R.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,g){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(u,g,b){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(u),")"),b&&(this.value+=` "${this._escape(this._escape(b,'"'),")")}"`),this.value+=")",this}_escape(u,g){const b=new RegExp((0,N.escapeRegExpCharacters)(g),"g");return u.replace(b,(R,v)=>u.charAt(v-1)!=="\\"?`\\${R}`:R)}}e.MarkdownString=_;function I(o){return L(o)?!o.value:Array.isArray(o)?o.every(I):!0}e.isEmptyMarkdownString=I;function L(o){return o instanceof _?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function w(o,u){return o===u?!0:!o||!u?!1:o.value===u.value&&o.isTrusted===u.isTrusted&&o.supportThemeIcons===u.supportThemeIcons&&o.supportHtml===u.supportHtml&&(o.baseUri===u.baseUri||!!o.baseUri&&!!u.baseUri&&(0,y.isEqual)(S.URI.from(o.baseUri),S.URI.from(u.baseUri)))}e.markdownStringEqual=w;function f(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function E(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function m(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=m;function a(o){const u=[],g=o.split("|").map(R=>R.trim());o=g[0];const b=g[1];if(b){const R=/height=(\d+)/.exec(b),v=/width=(\d+)/.exec(b),t=R?R[1]:"",h=v?v[1]:"",r=isFinite(parseInt(h)),l=isFinite(parseInt(t));r&&u.push(`width="${h}"`),l&&u.push(`height="${t}"`)}return{href:o,dimensions:u}}e.parseHrefAndDimensions=a}),define(Ce[87],Ie([1,0,16,40,19,21,24,10]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function _(r,l){const{os:i,tildify:p,relative:c}=l;if(c){const k=I(r,c,i);if(typeof k=="string")return k}let s=r.fsPath;if(i===1&&!N.isWindows?s=s.replace(/\//g,"\\"):i!==1&&N.isWindows&&(s=s.replace(/\\/g,"/")),i!==1&&p?.userHome){const k=p.userHome.fsPath;let A;r.scheme!==p.userHome.scheme&&r.path.startsWith(y.posix.sep)?A=p.userHome.with({path:r.path}).fsPath:A=r.fsPath,s=f(A,k,i)}return(i===1?y.win32:y.posix).normalize(L(s,i===1))}e.getPathLabel=_;function I(r,l,i){const p=i===1?y.win32:y.posix,c=i===3?S.extUri:S.extUriIgnorePathCase,s=l.getWorkspace(),d=(0,n.firstOrDefault)(s.folders);if(!d)return;r.scheme!==d.uri.scheme&&r.path.startsWith(y.posix.sep)&&(r=d.uri.with({path:r.path}));const k=l.getWorkspaceFolder(r);if(!k)return;let A;if(c.isEqual(k.uri,r)?A="":A=c.relativePath(k.uri,r)??"",A&&(A=p.normalize(A)),s.folders.length>1&&!l.noPrefix){const W=k.name?k.name:c.basenameOrAuthority(k.uri);A=A?`${W} \u2022 ${A}`:W}return A}function L(r,l=N.isWindows){return(0,C.hasDriveLetter)(r,l)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=L;let w=Object.create(null);function f(r,l,i=N.OS){if(i===1||!r||!l)return r;let p=w.original===l?w.normalized:void 0;p||(p=l,N.isWindows&&(p=(0,C.toSlashes)(p)),p=`${(0,P.rtrim)(p,y.posix.sep)}${y.posix.sep}`,w={original:l,normalized:p});let c=r;return N.isWindows&&(c=(0,C.toSlashes)(c)),(i===3?c.startsWith(p):(0,P.startsWithIgnoreCase)(c,p))?`~/${c.substr(p.length)}`:r}e.tildify=f;function E(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=E;const m="\u2026",a="\\\\",o="~";function u(r,l=y.sep){const i=new Array(r.length);let p=!1;for(let c=0;c<r.length;c++){const s=r[c];if(s===""){i[c]=`.${l}`;continue}if(!s){i[c]=s;continue}p=!0;let d="",k=s;k.indexOf(a)===0?(d=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length)):k.indexOf(l)===0?(d=k.substr(0,k.indexOf(l)+l.length),k=k.substr(k.indexOf(l)+l.length)):k.indexOf(o)===0&&(d=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length));const A=k.split(l);for(let W=1;p&&W<=A.length;W++)for(let J=A.length-W;p&&J>=0;J--){p=!1;let j=A.slice(J,J+W).join(l);for(let O=0;!p&&O<r.length;O++)if(O!==c&&r[O]&&r[O].indexOf(j)>-1){const B=J+W===A.length,T=J>0&&r[O].indexOf(l)>-1?l+j:j,F=r[O].endsWith(T);p=!B||F}if(!p){let O="";(A[0].endsWith(":")||d!=="")&&(J===1&&(J=0,W++,j=A[0]+l+j),J>0&&(O=A[0]+l),O=d+O),J>0&&(O=O+m+l),O=O+j,J+W<A.length&&(O=O+l+m),i[c]=O}}p&&(i[c]=s)}return i}e.shorten=u;var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function b(r,l=Object.create(null)){const i=[];let p=!1,c="";for(const s of r)if(s==="$"||p&&s==="{")c&&i.push({value:c,type:g.TEXT}),c="",p=!0;else if(s==="}"&&p){const d=l[c];if(typeof d=="string")d.length&&i.push({value:d,type:g.VARIABLE});else if(d){const k=i[i.length-1];(!k||k.type!==g.SEPARATOR)&&i.push({value:d.label,type:g.SEPARATOR})}c="",p=!1}else c+=s;return c&&!p&&i.push({value:c,type:g.TEXT}),i.filter((s,d)=>{if(s.type===g.SEPARATOR){const k=i[d-1],A=i[d+1];return[k,A].every(W=>W&&(W.type===g.VARIABLE||W.type===g.TEXT)&&W.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=b;function R(r,l){return N.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):r.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=R;function v(r,l){return N.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):N.isWindows?r.replace(/&&|&/g,i=>i==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function h(r){const l=r.indexOf("/")!==-1?y.posix:y.win32,i=l.basename(r),p=l.dirname(r);return i.length?{name:i,parentPath:p}:{name:p,parentPath:""}}e.splitName=h}),define(Ce[127],Ie([1,0,23,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function y(w){return w.toJSON()}class N{constructor(f){this._uriTransformer=f}transformIncoming(f){const E=this._uriTransformer.transformIncoming(f);return E===f?f:y(C.URI.from(E))}transformOutgoing(f){const E=this._uriTransformer.transformOutgoing(f);return E===f?f:y(C.URI.from(E))}transformOutgoingURI(f){const E=this._uriTransformer.transformOutgoing(f);return E===f?f:C.URI.from(E)}transformOutgoingScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}}e.URITransformer=N,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function S(w,f,E){if(!w||E>200)return null;if(typeof w=="object"){if(w instanceof C.URI)return f.transformOutgoing(w);for(const m in w)if(Object.hasOwnProperty.call(w,m)){const a=S(w[m],f,E+1);a!==null&&(w[m]=a)}}return null}function P(w,f){const E=S(w,f,0);return E===null?w:E}e.transformOutgoingURIs=P;function _(w,f,E,m){if(!w||m>200)return null;if(typeof w=="object"){if(w.$mid===1)return E?C.URI.revive(f.transformIncoming(w)):f.transformIncoming(w);if(w instanceof n.VSBuffer)return null;for(const a in w)if(Object.hasOwnProperty.call(w,a)){const o=_(w[a],f,E,m+1);o!==null&&(w[a]=o)}}return null}function I(w,f){const E=_(w,f,!1,0);return E===null?w:E}e.transformIncomingURIs=I;function L(w,f){const E=_(w,f,!0,0);return E===null?w:E}e.transformAndReviveIncomingURIs=L}),define(Ce[128],Ie([1,0,35,19]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(N,S,P,_,I,L){if(Array.isArray(N)){let w=0;for(const f of N){const E=y(f,S,P,_,I,L);if(E===10)return E;E>w&&(w=E)}return w}else{if(typeof N=="string")return _?N==="*"?5:N===P?10:0:0;if(N){const{language:w,pattern:f,scheme:E,hasAccessToAllModels:m,notebookType:a}=N;if(!_&&!m)return 0;a&&I&&(S=I);let o=0;if(E)if(E===S.scheme)o=10;else if(E==="*")o=5;else return 0;if(w)if(w===P)o=10;else if(w==="*")o=Math.max(o,5);else return 0;if(a)if(a===L)o=10;else if(a==="*"&&L!==void 0)o=Math.max(o,5);else return 0;if(f){let u;if(typeof f=="string"?u=f:u={...f,base:(0,C.normalize)(f.base)},u===S.fsPath||(0,n.match)(u,S.fsPath))o=10;else return 0}return o}else return 0}}e.score=y}),define(Ce[88],Ie([1,0,23,21]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(y||(y={}));function N(w){for(let f=0,E=w.length;f<E;f+=4){const m=w[f+0],a=w[f+1],o=w[f+2],u=w[f+3];w[f+0]=u,w[f+1]=o,w[f+2]=a,w[f+3]=m}}function S(w){const f=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return C.isLittleEndian()||N(f),n.VSBuffer.wrap(f)}function P(w){const f=w.buffer;if(C.isLittleEndian()||N(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const E=new Uint8Array(f.byteLength);return E.set(f),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function _(w){const f=new Uint32Array(I(w));let E=0;if(f[E++]=w.id,w.type==="full")f[E++]=1,f[E++]=w.data.length,f.set(w.data,E),E+=w.data.length;else{f[E++]=2,f[E++]=w.deltas.length;for(const m of w.deltas)f[E++]=m.start,f[E++]=m.deleteCount,m.data?(f[E++]=m.data.length,f.set(m.data,E),E+=m.data.length):f[E++]=0}return S(f)}e.encodeSemanticTokensDto=_;function I(w){let f=0;if(f+=1+1,w.type==="full")f+=1+w.data.length;else{f+=1,f+=(1+1+1)*w.deltas.length;for(const E of w.deltas)E.data&&(f+=E.data.length)}return f}function L(w){const f=P(w);let E=0;const m=f[E++];if(f[E++]===1){const g=f[E++],b=f.subarray(E,E+g);return E+=g,{id:m,type:"full",data:b}}const o=f[E++],u=[];for(let g=0;g<o;g++){const b=f[E++],R=f[E++],v=f[E++];let t;v>0&&(t=f.subarray(E,E+v),E+=v),u[g]={start:b,deleteCount:R,data:t}}return{id:m,type:"delta",deltas:u}}e.decodeSemanticTokensDto=L}),define(Ce[129],Ie([13,14]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ce[130],Ie([1,0,129,21,131,16,22,117]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(_=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(G){this._values=G}hasChanged(G){return this._values[G]}}e.ConfigurationChangedEvent=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class w{constructor(G,ve,Ne,xe){this.id=G,this.name=ve,this.defaultValue=Ne,this.schema=xe}applyUpdate(G,ve){return E(G,ve)}compute(G,ve,Ne){return Ne}}class f{constructor(G,ve){this.newValue=G,this.didChange=ve}}e.ApplyUpdateResult=f;function E(X,G){if(typeof X!="object"||typeof G!="object"||!X||!G)return new f(G,X!==G);if(Array.isArray(X)||Array.isArray(G)){const Ne=Array.isArray(X)&&Array.isArray(G)&&N.equals(X,G);return new f(G,!Ne)}let ve=!1;for(const Ne in G)if(G.hasOwnProperty(Ne)){const xe=E(X[Ne],G[Ne]);xe.didChange&&(X[Ne]=xe.newValue,ve=!0)}return new f(X,ve)}class m{constructor(G){this.schema=void 0,this.id=G,this.name="_never_",this.defaultValue=void 0}applyUpdate(G,ve){return E(G,ve)}validate(G){return this.defaultValue}}class a{constructor(G,ve,Ne,xe){this.id=G,this.name=ve,this.defaultValue=Ne,this.schema=xe}applyUpdate(G,ve){return E(G,ve)}validate(G){return typeof G>"u"?this.defaultValue:G}compute(G,ve,Ne){return Ne}}function o(X,G){return typeof X>"u"?G:X==="false"?!1:Boolean(X)}e.boolean=o;class u extends a{constructor(G,ve,Ne,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ne),super(G,ve,Ne,xe)}validate(G){return o(G,this.defaultValue)}}function g(X,G,ve,Ne){if(typeof X>"u")return G;let xe=parseInt(X,10);return isNaN(xe)?G:(xe=Math.max(ve,xe),xe=Math.min(Ne,xe),xe|0)}e.clampedInt=g;class b extends a{static clampedInt(G,ve,Ne,xe){return g(G,ve,Ne,xe)}constructor(G,ve,Ne,xe,ze,Qe=void 0){typeof Qe<"u"&&(Qe.type="integer",Qe.default=Ne,Qe.minimum=xe,Qe.maximum=ze),super(G,ve,Ne,Qe),this.minimum=xe,this.maximum=ze}validate(G){return b.clampedInt(G,this.defaultValue,this.minimum,this.maximum)}}class R extends a{static clamp(G,ve,Ne){return G<ve?ve:G>Ne?Ne:G}static float(G,ve){if(typeof G=="number")return G;if(typeof G>"u")return ve;const Ne=parseFloat(G);return isNaN(Ne)?ve:Ne}constructor(G,ve,Ne,xe,ze){typeof ze<"u"&&(ze.type="number",ze.default=Ne),super(G,ve,Ne,ze),this.validationFn=xe}validate(G){return this.validationFn(R.float(G,this.defaultValue))}}class v extends a{static string(G,ve){return typeof G!="string"?ve:G}constructor(G,ve,Ne,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ne),super(G,ve,Ne,xe)}validate(G){return v.string(G,this.defaultValue)}}function t(X,G,ve){return typeof X!="string"||ve.indexOf(X)===-1?G:X}e.stringSet=t;class h extends a{constructor(G,ve,Ne,xe,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.enum=xe,ze.default=Ne),super(G,ve,Ne,ze),this._allowedValues=xe}validate(G){return t(G,this.defaultValue,this._allowedValues)}}class r extends w{constructor(G,ve,Ne,xe,ze,Qe,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=ze,nt.default=xe),super(G,ve,Ne,nt),this._allowedValues=ze,this._convert=Qe}validate(G){return typeof G!="string"?this.defaultValue:this._allowedValues.indexOf(G)===-1?this.defaultValue:this._convert(G)}}function l(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(G){switch(G){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(G,ve,Ne){return Ne===0?G.accessibilitySupport:Ne}}class p extends w{constructor(){const G={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",G,{"editor.comments.insertSpace":{type:"boolean",default:G.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:G.ignoreEmptyLines,description:n.localize(5,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{insertSpace:o(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function k(X){switch(X){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function A(X){switch(X){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class W extends m{constructor(){super(135)}compute(G,ve,Ne){const xe=["monaco-editor"];return ve.get(36)&&xe.push(ve.get(36)),G.extraEditorClassName&&xe.push(G.extraEditorClassName),ve.get(70)==="default"?xe.push("mouse-default"):ve.get(70)==="copy"&&xe.push("mouse-copy"),ve.get(105)&&xe.push("showUnused"),ve.get(133)&&xe.push("showDeprecated"),xe.join(" ")}}class J extends u{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(G,ve,Ne){return Ne&&G.emptySelectionClipboard}}class j extends w{constructor(){const G={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",G,{"editor.find.cursorMoveOnType":{type:"boolean",default:G.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:G.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:G.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:G.globalFindClipboard,description:n.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:G.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:G.loop,description:n.localize(18,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{cursorMoveOnType:o(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof G.seedSearchStringFromSelection=="boolean"?G.seedSearchStringFromSelection?"always":"never":t(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof G.autoFindInSelection=="boolean"?G.autoFindInSelection?"always":"never":t(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ve.loop,this.defaultValue.loop)}}}class O extends w{constructor(){super(48,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(G){return typeof G>"u"?this.defaultValue:typeof G=="string"?G==="false"?O.OFF:G==="true"?O.ON:G:Boolean(G)?O.ON:O.OFF}}O.OFF='"liga" off, "calt" off',O.ON='"liga" on, "calt" on',e.EditorFontLigatures=O;class B extends w{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(G){return typeof G>"u"?this.defaultValue:typeof G=="string"?G==="false"?B.OFF:G==="true"?B.TRANSLATE:G:Boolean(G)?B.TRANSLATE:B.OFF}compute(G,ve,Ne){return G.fontInfo.fontVariationSettings}}B.OFF="normal",B.TRANSLATE="translate",e.EditorFontVariations=B;class T extends m{constructor(){super(47)}compute(G,ve,Ne){return G.fontInfo}}class F extends a{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(G){const ve=R.float(G,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:R.clamp(ve,6,100)}compute(G,ve,Ne){return G.fontInfo.fontSize}}class z extends w{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(G){return G==="normal"||G==="bold"?G:String(b.clampedInt(G,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class H extends w{constructor(){const G={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:G.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",G,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:G.alternativeDefinitionCommand,enum:Ne,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:G.alternativeTypeDefinitionCommand,enum:Ne,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:G.alternativeDeclarationCommand,enum:Ne,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:G.alternativeImplementationCommand,enum:Ne,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:G.alternativeReferenceCommand,enum:Ne,description:n.localize(41,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{multiple:t(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??t(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??t(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??t(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??t(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??t(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends w{constructor(){const G={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",G,{"editor.hover.enabled":{type:"boolean",default:G.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:G.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:G.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:G.above,description:n.localize(45,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{enabled:o(ve.enabled,this.defaultValue.enabled),delay:b.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:o(ve.sticky,this.defaultValue.sticky),above:o(ve.above,this.defaultValue.above)}}}var pe;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(pe=e.RenderMinimap||(e.RenderMinimap={}));class re extends m{constructor(){super(138)}compute(G,ve,Ne){return re.computeLayout(ve,{memory:G.memory,outerWidth:G.outerWidth,outerHeight:G.outerHeight,isDominatedByLongLines:G.isDominatedByLongLines,lineHeight:G.fontInfo.lineHeight,viewLineCount:G.viewLineCount,lineNumbersDigitCount:G.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:G.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:G.fontInfo.maxDigitWidth,pixelRatio:G.pixelRatio})}static computeContainedMinimapLineCount(G){const ve=G.height/G.lineHeight,Ne=Math.floor(G.paddingTop/G.lineHeight);let xe=Math.floor(G.paddingBottom/G.lineHeight);G.scrollBeyondLastLine&&(xe=Math.max(xe,ve-1));const ze=(Ne+G.viewLineCount+xe)/(G.pixelRatio*G.height),Qe=Math.floor(G.viewLineCount/ze);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Ne,extraLinesBeyondLastLine:xe,desiredRatio:ze,minimapLineCount:Qe}}static _computeMinimapLayout(G,ve){const Ne=G.outerWidth,xe=G.outerHeight,ze=G.pixelRatio;if(!G.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ze*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Qe=ve.stableMinimapLayoutInput,nt=Qe&&G.outerHeight===Qe.outerHeight&&G.lineHeight===Qe.lineHeight&&G.typicalHalfwidthCharacterWidth===Qe.typicalHalfwidthCharacterWidth&&G.pixelRatio===Qe.pixelRatio&&G.scrollBeyondLastLine===Qe.scrollBeyondLastLine&&G.paddingTop===Qe.paddingTop&&G.paddingBottom===Qe.paddingBottom&&G.minimap.enabled===Qe.minimap.enabled&&G.minimap.side===Qe.minimap.side&&G.minimap.size===Qe.minimap.size&&G.minimap.showSlider===Qe.minimap.showSlider&&G.minimap.renderCharacters===Qe.minimap.renderCharacters&&G.minimap.maxColumn===Qe.minimap.maxColumn&&G.minimap.scale===Qe.minimap.scale&&G.verticalScrollbarWidth===Qe.verticalScrollbarWidth&&G.isViewportWrapping===Qe.isViewportWrapping,vt=G.lineHeight,wt=G.typicalHalfwidthCharacterWidth,Ct=G.scrollBeyondLastLine,Ht=G.minimap.renderCharacters;let rt=ze>=2?Math.round(G.minimap.scale*2):G.minimap.scale;const mt=G.minimap.maxColumn,Lt=G.minimap.size,Kt=G.minimap.side,Tt=G.verticalScrollbarWidth,ht=G.viewLineCount,It=G.remainingWidth,Ut=G.isViewportWrapping,Rt=Ht?2:3;let Ke=Math.floor(ze*xe);const Ft=Ke/ze;let Nt=!1,xt=!1,ft=Rt*rt,ye=rt/ze,Pe=1;if(Lt==="fill"||Lt==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:kt,desiredRatio:Et,minimapLineCount:bt}=re.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:Ct,paddingTop:G.paddingTop,paddingBottom:G.paddingBottom,height:xe,lineHeight:vt,pixelRatio:ze});if(ht/bt>1)Nt=!0,xt=!0,rt=1,ft=1,ye=rt/ze;else{let St=!1,_t=rt+1;if(Lt==="fit"){const Vt=Math.ceil((ct+ht+kt)*ft);Ut&&nt&&It<=ve.stableFitRemainingWidth?(St=!0,_t=ve.stableFitMaxMinimapScale):St=Vt>Ke}if(Lt==="fill"||St){Nt=!0;const Vt=rt;ft=Math.min(vt*ze,Math.max(1,Math.floor(1/Et))),Ut&&nt&&It<=ve.stableFitRemainingWidth&&(_t=ve.stableFitMaxMinimapScale),rt=Math.min(_t,Math.max(1,Math.floor(ft/Rt))),rt>Vt&&(Pe=Math.min(2,rt/Vt)),ye=rt/ze/Pe,Ke=Math.ceil(Math.max(Ze,ct+ht+kt)*ft),Ut?(ve.stableMinimapLayoutInput=G,ve.stableFitRemainingWidth=It,ve.stableFitMaxMinimapScale=rt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const ge=Math.floor(mt*ye),q=Math.min(ge,Math.max(0,Math.floor((It-Tt-2)*ye/(wt+ye)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(ze*q);const Ue=Ae/ze;Ae=Math.floor(Ae*Pe);const Xe=Ht?1:2,Be=Kt==="left"?0:Ne-q-Tt;return{renderMinimap:Xe,minimapLeft:Be,minimapWidth:q,minimapHeightIsEditorHeight:Nt,minimapIsSampling:xt,minimapScale:rt,minimapLineHeight:ft,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Ke,minimapCanvasOuterWidth:Ue,minimapCanvasOuterHeight:Ft}}static computeLayout(G,ve){const Ne=ve.outerWidth|0,xe=ve.outerHeight|0,ze=ve.lineHeight|0,Qe=ve.lineNumbersDigitCount|0,nt=ve.typicalHalfwidthCharacterWidth,vt=ve.maxDigitWidth,wt=ve.pixelRatio,Ct=ve.viewLineCount,Ht=G.get(130),rt=Ht==="inherit"?G.get(129):Ht,mt=rt==="inherit"?G.get(125):rt,Lt=G.get(128),Kt=ve.isDominatedByLongLines,Tt=G.get(54),ht=G.get(64).renderType!==0,It=G.get(65),Ut=G.get(99),Rt=G.get(80),Ke=G.get(69),Ft=G.get(97),Nt=Ft.verticalScrollbarSize,xt=Ft.verticalHasArrows,ft=Ft.arrowSize,ye=Ft.horizontalScrollbarSize,Pe=G.get(40),ge=G.get(104)!=="never";let q=G.get(62);Pe&&ge&&(q+=16);let Ae=0;if(ht){const pt=Math.max(Qe,It);Ae=Math.round(pt*vt)}let Ue=0;Tt&&(Ue=ze);let Xe=0,Be=Xe+Ue,Ze=Be+Ae,ct=Ze+q;const kt=Ne-Ue-Ae-q;let Et=!1,bt=!1,Dt=-1;rt==="inherit"&&Kt?(Et=!0,bt=!0):mt==="on"||mt==="bounded"?bt=!0:mt==="wordWrapColumn"&&(Dt=Lt);const St=re._computeMinimapLayout({outerWidth:Ne,outerHeight:xe,lineHeight:ze,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:Ut,paddingTop:Rt.top,paddingBottom:Rt.bottom,minimap:Ke,verticalScrollbarWidth:Nt,viewLineCount:Ct,remainingWidth:kt,isViewportWrapping:bt},ve.memory||new L);St.renderMinimap!==0&&St.minimapLeft===0&&(Xe+=St.minimapWidth,Be+=St.minimapWidth,Ze+=St.minimapWidth,ct+=St.minimapWidth);const _t=kt-St.minimapWidth,Vt=Math.max(1,Math.floor((_t-Nt-2)/nt)),Jt=xt?ft:0;return bt&&(Dt=Math.max(1,Vt),mt==="bounded"&&(Dt=Math.min(Dt,Lt))),{width:Ne,height:xe,glyphMarginLeft:Xe,glyphMarginWidth:Ue,lineNumbersLeft:Be,lineNumbersWidth:Ae,decorationsLeft:Ze,decorationsWidth:q,contentLeft:ct,contentWidth:_t,minimap:St,viewportColumn:Vt,isWordWrapMinified:Et,isViewportWrapping:bt,wrappingColumn:Dt,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:ye,overviewRuler:{top:Jt,width:Nt,height:xe-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=re;class le extends w{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(G){return t(G,"simple",["simple","advanced"])}compute(G,ve,Ne){return ve.get(2)===2?"advanced":Ne}}class ae extends w{constructor(){const G={enabled:!0};super(61,"lightbulb",G,{"editor.lightbulb.enabled":{type:"boolean",default:G.enabled,description:n.localize(49,null)}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{enabled:o(G.enabled,this.defaultValue.enabled)}}}class se extends w{constructor(){const G={enabled:!1,maxLineCount:5};super(109,"stickyScroll",G,{"editor.stickyScroll.enabled":{type:"boolean",default:G.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:G.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{enabled:o(ve.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Q extends w{constructor(){const G={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",G,{"editor.inlayHints.enabled":{type:"string",default:G.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:G.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:G.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:G.padding,description:n.localize(59,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:t(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(ve.fontFamily,this.defaultValue.fontFamily),padding:o(ve.padding,this.defaultValue.padding)}}}class K extends w{constructor(){super(62,"lineDecorationsWidth",10)}validate(G){return typeof G=="string"&&/^\d+(\.\d+)?ch$/.test(G)?-parseFloat(G.substring(0,G.length-2)):b.clampedInt(G,this.defaultValue,0,1e3)}compute(G,ve,Ne){return Ne<0?b.clampedInt(-Ne*G.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ne}}class Z extends R{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,G=>R.clamp(G,0,150),{markdownDescription:n.localize(60,null)})}compute(G,ve,Ne){return G.fontInfo.lineHeight}}class he extends w{constructor(){const G={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",G,{"editor.minimap.enabled":{type:"boolean",default:G.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:G.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:G.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:G.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:G.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:G.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:G.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:G.maxColumn,description:n.localize(71,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{enabled:o(ve.enabled,this.defaultValue.enabled),autohide:o(ve.autohide,this.defaultValue.autohide),size:t(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(ve.side,this.defaultValue.side,["right","left"]),showSlider:t(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ve.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ve.scale,1,1,3),maxColumn:b.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ke(X){return X==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Fe extends w{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{top:b.clampedInt(ve.top,0,0,1e3),bottom:b.clampedInt(ve.bottom,0,0,1e3)}}}class je extends w{constructor(){const G={enabled:!0,cycle:!0};super(81,"parameterHints",G,{"editor.parameterHints.enabled":{type:"boolean",default:G.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:G.cycle,description:n.localize(75,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{enabled:o(ve.enabled,this.defaultValue.enabled),cycle:o(ve.cycle,this.defaultValue.cycle)}}}class Te extends m{constructor(){super(136)}compute(G,ve,Ne){return G.pixelRatio}}class Se extends w{constructor(){const G={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",G,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:G.strings,description:n.localize(79,null)},comments:{anyOf:ve,default:G.comments,description:n.localize(80,null)},other:{anyOf:ve,default:G.other,description:n.localize(81,null)}},default:G,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=G}validate(G){if(typeof G=="boolean"){const wt=G?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!G||typeof G!="object")return this.defaultValue;const{other:ve,comments:Ne,strings:xe}=G,ze=["on","inline","off"];let Qe,nt,vt;return typeof ve=="boolean"?Qe=ve?"on":"off":Qe=t(ve,this.defaultValue.other,ze),typeof Ne=="boolean"?nt=Ne?"on":"off":nt=t(Ne,this.defaultValue.comments,ze),typeof xe=="boolean"?vt=xe?"on":"off":vt=t(xe,this.defaultValue.strings,ze),{other:Qe,comments:nt,strings:vt}}}var De;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(De=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends w{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(G){let ve=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof G<"u"&&(typeof G=="function"?(ve=4,Ne=G):G==="interval"?ve=3:G==="relative"?ve=2:G==="on"?ve=1:ve=0),{renderType:ve,renderFn:Ne}}}function ue(X){const G=X.get(92);return G==="editable"?X.get(86):G!=="on"}e.filterValidationDecorations=ue;class Y extends w{constructor(){const G=[],ve={type:"number",description:n.localize(88,null)};super(96,"rulers",G,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:G,description:n.localize(90,null)})}validate(G){if(Array.isArray(G)){const ve=[];for(const Ne of G)if(typeof Ne=="number")ve.push({column:b.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const xe=Ne;ve.push({column:b.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ve.sort((Ne,xe)=>Ne.column-xe.column),ve}return this.defaultValue}}function D(X,G){if(typeof X!="string")return G;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends w{constructor(){const G={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",G,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:G.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:G.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:G.scrollByPage,description:n.localize(101,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G,Ne=b.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=b.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:D(ve.vertical,this.defaultValue.vertical),horizontal:D(ve.horizontal,this.defaultValue.horizontal),useShadows:o(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:b.clampedInt(ve.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:b.clampedInt(ve.verticalSliderSize,xe,0,1e3),scrollByPage:o(ve.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class $ extends w{constructor(){const G={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",G,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:G.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:G.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:G.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:G.allowedLocales,description:n.localize(108,null)}})}applyUpdate(G,ve){let Ne=!1;ve.allowedCharacters&&G&&(S.equals(G.allowedCharacters,ve.allowedCharacters)||(G={...G,allowedCharacters:ve.allowedCharacters},Ne=!0)),ve.allowedLocales&&G&&(S.equals(G.allowedLocales,ve.allowedLocales)||(G={...G,allowedLocales:ve.allowedLocales},Ne=!0));const xe=super.applyUpdate(G,ve);return Ne?new f(xe.newValue,!0):xe}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{nonBasicASCII:_e(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_e(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_e(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(G.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(G.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(G,ve){if(typeof G!="object"||!G)return ve;const Ne={};for(const[xe,ze]of Object.entries(G))ze===!0&&(Ne[xe]=!0);return Ne}}class V extends w{constructor(){const G={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",G,{"editor.inlineSuggest.enabled":{type:"boolean",default:G.enabled,description:n.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:G.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(110,null),n.localize(111,null)],description:n.localize(112,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{enabled:o(ve.enabled,this.defaultValue.enabled),mode:t(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class ee extends w{constructor(){const G={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",G,{"editor.bracketPairColorization.enabled":{type:"boolean",default:G.enabled,markdownDescription:n.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:G.independentColorPoolPerBracketType,description:n.localize(114,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{enabled:o(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class me extends w{constructor(){const G={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",G,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(115,null),n.localize(116,null),n.localize(117,null)],default:G.bracketPairs,description:n.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(119,null),n.localize(120,null),n.localize(121,null)],default:G.bracketPairsHorizontal,description:n.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:G.highlightActiveBracketPair,description:n.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:G.indentation,description:n.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(125,null),n.localize(126,null),n.localize(127,null)],default:G.highlightActiveIndentation,description:n.localize(128,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{bracketPairs:_e(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_e(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:_e(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _e(X,G,ve){const Ne=ve.indexOf(X);return Ne===-1?G:ve[Ne]}class ce extends w{constructor(){const G={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",G,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(129,null),n.localize(130,null)],default:G.insertMode,description:n.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:G.filterGraceful,description:n.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:G.localityBonus,description:n.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:G.shareSuggestSelections,markdownDescription:n.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(135,null),n.localize(136,null),n.localize(137,null),n.localize(138,null)],default:G.selectionMode,markdownDescription:n.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:G.snippetsPreventQuickSuggestions,description:n.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:G.showIcons,description:n.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:G.showStatusBar,description:n.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:G.preview,description:n.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:G.showInlineDetails,description:n.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const ve=G;return{insertMode:t(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ve.showIcons,this.defaultValue.showIcons),showStatusBar:o(ve.showStatusBar,this.defaultValue.showStatusBar),preview:o(ve.preview,this.defaultValue.preview),previewMode:t(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ve.showMethods,this.defaultValue.showMethods),showFunctions:o(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ve.showFields,this.defaultValue.showFields),showVariables:o(ve.showVariables,this.defaultValue.showVariables),showClasses:o(ve.showClasses,this.defaultValue.showClasses),showStructs:o(ve.showStructs,this.defaultValue.showStructs),showInterfaces:o(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ve.showModules,this.defaultValue.showModules),showProperties:o(ve.showProperties,this.defaultValue.showProperties),showEvents:o(ve.showEvents,this.defaultValue.showEvents),showOperators:o(ve.showOperators,this.defaultValue.showOperators),showUnits:o(ve.showUnits,this.defaultValue.showUnits),showValues:o(ve.showValues,this.defaultValue.showValues),showConstants:o(ve.showConstants,this.defaultValue.showConstants),showEnums:o(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ve.showKeywords,this.defaultValue.showKeywords),showWords:o(ve.showWords,this.defaultValue.showWords),showColors:o(ve.showColors,this.defaultValue.showColors),showFiles:o(ve.showFiles,this.defaultValue.showFiles),showReferences:o(ve.showReferences,this.defaultValue.showReferences),showFolders:o(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ve.showSnippets,this.defaultValue.showSnippets),showUsers:o(ve.showUsers,this.defaultValue.showUsers),showIssues:o(ve.showIssues,this.defaultValue.showIssues)}}}class Ee extends w{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(177,null),default:!0,type:"boolean"}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(G.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class be extends m{constructor(){super(137)}compute(G,ve,Ne){return ve.get(86)?!0:G.tabFocusMode}}var $e;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})($e=e.WrappingIndent||(e.WrappingIndent={}));class We extends w{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(178,null),n.localize(179,null),n.localize(180,null),n.localize(181,null)],description:n.localize(182,null),default:"same"}})}validate(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(G,ve,Ne){return ve.get(2)===2?0:Ne}}class tt extends m{constructor(){super(139)}compute(G,ve,Ne){const xe=ve.get(138);return{isDominatedByLongLines:G.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class Ge extends w{constructor(){const G={enabled:!0};super(33,"dropIntoEditor",G,{"editor.dropIntoEditor.enabled":{type:"boolean",default:G.enabled,markdownDescription:n.localize(183,null)}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{enabled:o(G.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?it:C.isLinux?dt:et,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(X){return e.editorOptionsRegistry[X.id]=X,X}var ot;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.colorDecoratorsLimit=18]="colorDecoratorsLimit",X[X.columnSelection=19]="columnSelection",X[X.comments=20]="comments",X[X.contextmenu=21]="contextmenu",X[X.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",X[X.cursorBlinking=23]="cursorBlinking",X[X.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",X[X.cursorStyle=25]="cursorStyle",X[X.cursorSurroundingLines=26]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",X[X.cursorWidth=28]="cursorWidth",X[X.disableLayerHinting=29]="disableLayerHinting",X[X.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",X[X.domReadOnly=31]="domReadOnly",X[X.dragAndDrop=32]="dragAndDrop",X[X.dropIntoEditor=33]="dropIntoEditor",X[X.emptySelectionClipboard=34]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",X[X.extraEditorClassName=36]="extraEditorClassName",X[X.fastScrollSensitivity=37]="fastScrollSensitivity",X[X.find=38]="find",X[X.fixedOverflowWidgets=39]="fixedOverflowWidgets",X[X.folding=40]="folding",X[X.foldingStrategy=41]="foldingStrategy",X[X.foldingHighlight=42]="foldingHighlight",X[X.foldingImportsByDefault=43]="foldingImportsByDefault",X[X.foldingMaximumRegions=44]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=46]="fontFamily",X[X.fontInfo=47]="fontInfo",X[X.fontLigatures=48]="fontLigatures",X[X.fontSize=49]="fontSize",X[X.fontWeight=50]="fontWeight",X[X.fontVariations=51]="fontVariations",X[X.formatOnPaste=52]="formatOnPaste",X[X.formatOnType=53]="formatOnType",X[X.glyphMargin=54]="glyphMargin",X[X.gotoLocation=55]="gotoLocation",X[X.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",X[X.hover=57]="hover",X[X.inDiffEditor=58]="inDiffEditor",X[X.inlineSuggest=59]="inlineSuggest",X[X.letterSpacing=60]="letterSpacing",X[X.lightbulb=61]="lightbulb",X[X.lineDecorationsWidth=62]="lineDecorationsWidth",X[X.lineHeight=63]="lineHeight",X[X.lineNumbers=64]="lineNumbers",X[X.lineNumbersMinChars=65]="lineNumbersMinChars",X[X.linkedEditing=66]="linkedEditing",X[X.links=67]="links",X[X.matchBrackets=68]="matchBrackets",X[X.minimap=69]="minimap",X[X.mouseStyle=70]="mouseStyle",X[X.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=72]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",X[X.multiCursorModifier=74]="multiCursorModifier",X[X.multiCursorPaste=75]="multiCursorPaste",X[X.multiCursorLimit=76]="multiCursorLimit",X[X.occurrencesHighlight=77]="occurrencesHighlight",X[X.overviewRulerBorder=78]="overviewRulerBorder",X[X.overviewRulerLanes=79]="overviewRulerLanes",X[X.padding=80]="padding",X[X.parameterHints=81]="parameterHints",X[X.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",X[X.quickSuggestions=84]="quickSuggestions",X[X.quickSuggestionsDelay=85]="quickSuggestionsDelay",X[X.readOnly=86]="readOnly",X[X.renameOnType=87]="renameOnType",X[X.renderControlCharacters=88]="renderControlCharacters",X[X.renderFinalNewline=89]="renderFinalNewline",X[X.renderLineHighlight=90]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=92]="renderValidationDecorations",X[X.renderWhitespace=93]="renderWhitespace",X[X.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",X[X.roundedSelection=95]="roundedSelection",X[X.rulers=96]="rulers",X[X.scrollbar=97]="scrollbar",X[X.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=99]="scrollBeyondLastLine",X[X.scrollPredominantAxis=100]="scrollPredominantAxis",X[X.selectionClipboard=101]="selectionClipboard",X[X.selectionHighlight=102]="selectionHighlight",X[X.selectOnLineNumbers=103]="selectOnLineNumbers",X[X.showFoldingControls=104]="showFoldingControls",X[X.showUnused=105]="showUnused",X[X.snippetSuggestions=106]="snippetSuggestions",X[X.smartSelect=107]="smartSelect",X[X.smoothScrolling=108]="smoothScrolling",X[X.stickyScroll=109]="stickyScroll",X[X.stickyTabStops=110]="stickyTabStops",X[X.stopRenderingLineAfter=111]="stopRenderingLineAfter",X[X.suggest=112]="suggest",X[X.suggestFontSize=113]="suggestFontSize",X[X.suggestLineHeight=114]="suggestLineHeight",X[X.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",X[X.suggestSelection=116]="suggestSelection",X[X.tabCompletion=117]="tabCompletion",X[X.tabIndex=118]="tabIndex",X[X.unicodeHighlighting=119]="unicodeHighlighting",X[X.unusualLineTerminators=120]="unusualLineTerminators",X[X.useShadowDOM=121]="useShadowDOM",X[X.useTabStops=122]="useTabStops",X[X.wordBreak=123]="wordBreak",X[X.wordSeparators=124]="wordSeparators",X[X.wordWrap=125]="wordWrap",X[X.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=128]="wordWrapColumn",X[X.wordWrapOverride1=129]="wordWrapOverride1",X[X.wordWrapOverride2=130]="wordWrapOverride2",X[X.wrappingIndent=131]="wrappingIndent",X[X.wrappingStrategy=132]="wrappingStrategy",X[X.showDeprecated=133]="showDeprecated",X[X.inlayHints=134]="inlayHints",X[X.editorClassName=135]="editorClassName",X[X.pixelRatio=136]="pixelRatio",X[X.tabFocusMode=137]="tabFocusMode",X[X.layoutInfo=138]="layoutInfo",X[X.wrappingInfo=139]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(184,null)})),acceptSuggestionOnEnter:Le(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(185,null),""],markdownDescription:n.localize(186,null)})),accessibilitySupport:Le(new i),accessibilityPageSize:Le(new b(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(187,null),tags:["accessibility"]})),ariaLabel:Le(new v(4,"ariaLabel",n.localize(188,null))),autoClosingBrackets:Le(new h(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(189,null),n.localize(190,null),""],description:n.localize(191,null)})),autoClosingDelete:Le(new h(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(192,null),""],description:n.localize(193,null)})),autoClosingOvertype:Le(new h(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(194,null),""],description:n.localize(195,null)})),autoClosingQuotes:Le(new h(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(196,null),n.localize(197,null),""],description:n.localize(198,null)})),autoIndent:Le(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[n.localize(199,null),n.localize(200,null),n.localize(201,null),n.localize(202,null),n.localize(203,null)],description:n.localize(204,null)})),automaticLayout:Le(new u(10,"automaticLayout",!1)),autoSurround:Le(new h(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),""],description:n.localize(208,null)})),bracketPairColorization:Le(new ee),bracketPairGuides:Le(new me),stickyTabStops:Le(new u(110,"stickyTabStops",!1,{description:n.localize(209,null)})),codeLens:Le(new u(14,"codeLens",!0,{description:n.localize(210,null)})),codeLensFontFamily:Le(new v(15,"codeLensFontFamily","",{description:n.localize(211,null)})),codeLensFontSize:Le(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(212,null)})),colorDecorators:Le(new u(17,"colorDecorators",!0,{description:n.localize(213,null)})),colorDecoratorsLimit:Le(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(214,null)})),columnSelection:Le(new u(19,"columnSelection",!1,{description:n.localize(215,null)})),comments:Le(new p),contextmenu:Le(new u(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new u(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(216,null)})),cursorBlinking:Le(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:n.localize(217,null)})),cursorSmoothCaretAnimation:Le(new h(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(218,null),n.localize(219,null),n.localize(220,null)],description:n.localize(221,null)})),cursorStyle:Le(new r(25,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:n.localize(222,null)})),cursorSurroundingLines:Le(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(223,null)})),cursorSurroundingLinesStyle:Le(new h(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(224,null),n.localize(225,null)],description:n.localize(226,null)})),cursorWidth:Le(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(227,null)})),disableLayerHinting:Le(new u(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new u(30,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new u(31,"domReadOnly",!1)),dragAndDrop:Le(new u(32,"dragAndDrop",!0,{description:n.localize(228,null)})),emptySelectionClipboard:Le(new J),dropIntoEditor:Le(new Ge),stickyScroll:Le(new se),experimentalWhitespaceRendering:Le(new h(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(229,null),n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),extraEditorClassName:Le(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Le(new R(37,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:n.localize(233,null)})),find:Le(new j),fixedOverflowWidgets:Le(new u(39,"fixedOverflowWidgets",!1)),folding:Le(new u(40,"folding",!0,{description:n.localize(234,null)})),foldingStrategy:Le(new h(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(235,null),n.localize(236,null)],description:n.localize(237,null)})),foldingHighlight:Le(new u(42,"foldingHighlight",!0,{description:n.localize(238,null)})),foldingImportsByDefault:Le(new u(43,"foldingImportsByDefault",!1,{description:n.localize(239,null)})),foldingMaximumRegions:Le(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(240,null)})),unfoldOnClickAfterEndOfLine:Le(new u(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(241,null)})),fontFamily:Le(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(242,null)})),fontInfo:Le(new T),fontLigatures2:Le(new O),fontSize:Le(new F),fontWeight:Le(new z),fontVariations:Le(new B),formatOnPaste:Le(new u(52,"formatOnPaste",!1,{description:n.localize(243,null)})),formatOnType:Le(new u(53,"formatOnType",!1,{description:n.localize(244,null)})),glyphMargin:Le(new u(54,"glyphMargin",!0,{description:n.localize(245,null)})),gotoLocation:Le(new H),hideCursorInOverviewRuler:Le(new u(56,"hideCursorInOverviewRuler",!1,{description:n.localize(246,null)})),hover:Le(new de),inDiffEditor:Le(new u(58,"inDiffEditor",!1)),letterSpacing:Le(new R(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>R.clamp(X,-5,20),{description:n.localize(247,null)})),lightbulb:Le(new ae),lineDecorationsWidth:Le(new K),lineHeight:Le(new Z),lineNumbers:Le(new oe),lineNumbersMinChars:Le(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new u(66,"linkedEditing",!1,{description:n.localize(248,null)})),links:Le(new u(67,"links",!0,{description:n.localize(249,null)})),matchBrackets:Le(new h(68,"matchBrackets","always",["always","near","never"],{description:n.localize(250,null)})),minimap:Le(new he),mouseStyle:Le(new h(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new R(71,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:n.localize(251,null)})),mouseWheelZoom:Le(new u(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(252,null)})),multiCursorMergeOverlapping:Le(new u(73,"multiCursorMergeOverlapping",!0,{description:n.localize(253,null)})),multiCursorModifier:Le(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ke,{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorPaste:Le(new h(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorLimit:Le(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(260,null)})),occurrencesHighlight:Le(new u(77,"occurrencesHighlight",!0,{description:n.localize(261,null)})),overviewRulerBorder:Le(new u(78,"overviewRulerBorder",!0,{description:n.localize(262,null)})),overviewRulerLanes:Le(new b(79,"overviewRulerLanes",3,0,3)),padding:Le(new Fe),parameterHints:Le(new je),peekWidgetDefaultFocus:Le(new h(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(263,null),n.localize(264,null)],description:n.localize(265,null)})),definitionLinkOpensInPeek:Le(new u(83,"definitionLinkOpensInPeek",!1,{description:n.localize(266,null)})),quickSuggestions:Le(new Se),quickSuggestionsDelay:Le(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(267,null)})),readOnly:Le(new u(86,"readOnly",!1)),renameOnType:Le(new u(87,"renameOnType",!1,{description:n.localize(268,null),markdownDeprecationMessage:n.localize(269,null)})),renderControlCharacters:Le(new u(88,"renderControlCharacters",!0,{description:n.localize(270,null),restricted:!0})),renderFinalNewline:Le(new h(89,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(271,null)})),renderLineHighlight:Le(new h(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(272,null)],description:n.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Le(new u(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(274,null)})),renderValidationDecorations:Le(new h(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new h(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(275,null),n.localize(276,null),n.localize(277,null),""],description:n.localize(278,null)})),revealHorizontalRightPadding:Le(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new u(95,"roundedSelection",!0,{description:n.localize(279,null)})),rulers:Le(new Y),scrollbar:Le(new U),scrollBeyondLastColumn:Le(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(280,null)})),scrollBeyondLastLine:Le(new u(99,"scrollBeyondLastLine",!0,{description:n.localize(281,null)})),scrollPredominantAxis:Le(new u(100,"scrollPredominantAxis",!0,{description:n.localize(282,null)})),selectionClipboard:Le(new u(101,"selectionClipboard",!0,{description:n.localize(283,null),included:C.isLinux})),selectionHighlight:Le(new u(102,"selectionHighlight",!0,{description:n.localize(284,null)})),selectOnLineNumbers:Le(new u(103,"selectOnLineNumbers",!0)),showFoldingControls:Le(new h(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(285,null),n.localize(286,null),n.localize(287,null)],description:n.localize(288,null)})),showUnused:Le(new u(105,"showUnused",!0,{description:n.localize(289,null)})),showDeprecated:Le(new u(133,"showDeprecated",!0,{description:n.localize(290,null)})),inlayHints:Le(new Q),snippetSuggestions:Le(new h(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),smartSelect:Le(new Ee),smoothScrolling:Le(new u(108,"smoothScrolling",!1,{description:n.localize(296,null)})),stopRenderingLineAfter:Le(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ce),inlineSuggest:Le(new V),suggestFontSize:Le(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new u(115,"suggestOnTriggerCharacters",!0,{description:n.localize(299,null)})),suggestSelection:Le(new h(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(300,null),n.localize(301,null),n.localize(302,null)],description:n.localize(303,null)})),tabCompletion:Le(new h(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(304,null),n.localize(305,null),n.localize(306,null)],description:n.localize(307,null)})),tabIndex:Le(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new $),unusualLineTerminators:Le(new h(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(308,null),n.localize(309,null),n.localize(310,null)],description:n.localize(311,null)})),useShadowDOM:Le(new u(121,"useShadowDOM",!0)),useTabStops:Le(new u(122,"useTabStops",!0,{description:n.localize(312,null)})),wordBreak:Le(new h(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(313,null),n.localize(314,null)],description:n.localize(315,null)})),wordSeparators:Le(new v(124,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:n.localize(316,null)})),wordWrap:Le(new h(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(317,null),n.localize(318,null),n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordWrapBreakAfterCharacters:Le(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(322,null)})),wordWrapOverride1:Le(new h(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new h(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new W),pixelRatio:Le(new Te),tabFocusMode:Le(new be),layoutInfo:Le(new re),wrappingInfo:Le(new tt),wrappingIndent:Le(new We),wrappingStrategy:Le(new le)}}),define(Ce[132],Ie([13,14]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[133],Ie([13,14]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[134],Ie([13,14]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[135],Ie([13,14]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ce[136],Ie([13,14]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ce[137],Ie([13,14]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[138],Ie([13,14]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ce[139],Ie([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[140],Ie([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[141],Ie([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[142],Ie([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[143],Ie([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[144],Ie([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[145],Ie([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[146],Ie([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[147],Ie([13,14]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ce[148],Ie([13,14]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ce[149],Ie([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[150],Ie([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[151],Ie([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[152],Ie([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[153],Ie([13,14]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[154],Ie([13,14]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[155],Ie([13,14]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[156],Ie([1,0,12]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this._generators=new Map}register(N,S){this._generators.set(N,S)}updateManifest(N){if(!(typeof N.main>"u"&&typeof N.browser>"u")&&(N.activationEvents===void 0&&Object.assign(N,{activationEvents:[]}),!(!Array.isArray(N.activationEvents)||!N.contributes)))for(const S in N.contributes){const P=this._generators.get(S);if(!P)continue;const _=N.contributes[S],I=Array.isArray(_)?_:[_];try{P(I,N.activationEvents)}catch(L){(0,n.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Ce[157],Ie([1,0,24,29,134,257]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function _(u){return u=u.trim(),u==="*"||S.test(u)}e.isValidVersionStr=_;function I(u){if(!_(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(S);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=I;function L(u){if(!u)return null;const g=u.majorBase,b=u.majorMustEqual,R=u.minorBase;let v=u.minorMustEqual;const t=u.patchBase;let h=u.patchMustEqual;u.hasCaret&&(g===0||(v=!1),h=!1);let r=0;if(u.preRelease){const l=P.exec(u.preRelease);if(l){const[,i,p,c]=l;r=Date.UTC(Number(i),Number(p)-1,Number(c))}}return{majorBase:g,majorMustEqual:b,minorBase:R,minorMustEqual:v,patchBase:t,patchMustEqual:h,isMinimum:u.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function w(u,g,b){let R;typeof u=="string"?R=L(I(u)):R=u;let v;g instanceof Date?v=g.getTime():typeof g=="string"&&(v=new Date(g).getTime());let t;if(typeof b=="string"?t=L(I(b)):t=b,!R||!t)return!1;const h=R.majorBase,r=R.minorBase,l=R.patchBase;let i=t.majorBase,p=t.minorBase,c=t.patchBase;const s=t.notBefore;let d=t.majorMustEqual,k=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?h>i?!0:h<i?!1:r>p?!0:r<p||v&&v<s?!1:l>=c:(h===1&&i===0&&(!d||!k||!A)&&(i=1,p=0,c=0,d=!0,k=!1,A=!1),h<i?!1:h>i?!d:r<p?!1:r>p?!k:l<c?!1:l>c?!A:!(v&&v<s))}e.isValidVersion=w;function f(u,g,b,R,v){const t=[];if(typeof R.publisher<"u"&&typeof R.publisher!="string")return t.push([C.default.Error,y.localize(0,null)]),t;if(typeof R.name!="string")return t.push([C.default.Error,y.localize(1,null,"name")]),t;if(typeof R.version!="string")return t.push([C.default.Error,y.localize(2,null,"version")]),t;if(!R.engines)return t.push([C.default.Error,y.localize(3,null,"engines")]),t;if(typeof R.engines.vscode!="string")return t.push([C.default.Error,y.localize(4,null,"engines.vscode")]),t;if(typeof R.extensionDependencies<"u"&&!o(R.extensionDependencies))return t.push([C.default.Error,y.localize(5,null,"extensionDependencies")]),t;if(typeof R.activationEvents<"u"){if(!o(R.activationEvents))return t.push([C.default.Error,y.localize(6,null,"activationEvents")]),t;if(typeof R.main>"u"&&typeof R.browser>"u")return t.push([C.default.Error,y.localize(7,null,"activationEvents","main")]),t}if(typeof R.extensionKind<"u"&&typeof R.main>"u"&&t.push([C.default.Warning,y.localize(8,null,"extensionKind")]),typeof R.main<"u"){if(typeof R.main!="string")return t.push([C.default.Error,y.localize(9,null,"main")]),t;{const l=(0,n.joinPath)(b,R.main);(0,n.isEqualOrParent)(l,b)||t.push([C.default.Warning,y.localize(10,null,l.path,b.path)])}if(typeof R.activationEvents>"u")return t.push([C.default.Error,y.localize(11,null,"activationEvents","main")]),t}if(typeof R.browser<"u"){if(typeof R.browser!="string")return t.push([C.default.Error,y.localize(12,null,"browser")]),t;{const l=(0,n.joinPath)(b,R.browser);(0,n.isEqualOrParent)(l,b)||t.push([C.default.Warning,y.localize(13,null,l.path,b.path)])}if(typeof R.activationEvents>"u")return t.push([C.default.Error,y.localize(14,null,"activationEvents","browser")]),t}if(!N.valid(R.version))return t.push([C.default.Error,y.localize(15,null)]),t;const h=[];if(!E(u,g,R,v,h))for(const l of h)t.push([C.default.Error,l]);return t}e.validateExtensionManifest=f;function E(u,g,b,R,v){return R||typeof b.main>"u"&&typeof b.browser>"u"?!0:a(u,g,b.engines.vscode,v)}e.isValidExtensionVersion=E;function m(u,g,b){return u==="*"||a(g,b,u)}e.isEngineValid=m;function a(u,g,b,R=[]){const v=L(I(b));if(!v)return R.push(y.localize(16,null,b)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return R.push(y.localize(17,null,b)),!1}else if(!v.majorMustEqual)return R.push(y.localize(18,null,b)),!1;return w(u,g,v)?!0:(R.push(y.localize(19,null,u,b)),!1)}function o(u){if(!Array.isArray(u))return!1;for(let g=0,b=u.length;g<b;g++)if(typeof u[g]!="string")return!1;return!0}}),define(Ce[89],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(y,N=[],S=!1){this.ctor=y,this.staticArguments=N,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=n}),define(Ce[66],Ie([1,0,89]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var y;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function N(P,_,I){_ instanceof n.SyncDescriptor||(_=new n.SyncDescriptor(_,[],Boolean(I))),C.push([P,_])}e.registerSingleton=N;function S(){return C}e.getSingletonServiceDescriptors=S}),define(Ce[158],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(N,S){this.key=N,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class C{constructor(N){this._hashFn=N,this._nodes=new Map}roots(){const N=[];for(const S of this._nodes.values())S.outgoing.size===0&&N.push(S);return N}insertEdge(N,S){const P=this.lookupOrInsertNode(N),_=this.lookupOrInsertNode(S);P.outgoing.set(_.key,_),_.incoming.set(P.key,P)}removeNode(N){const S=this._hashFn(N);this._nodes.delete(S);for(const P of this._nodes.values())P.outgoing.delete(S),P.incoming.delete(S)}lookupOrInsertNode(N){const S=this._hashFn(N);let P=this._nodes.get(S);return P||(P=new n(S,N),this._nodes.set(S,P)),P}lookup(N){return this._nodes.get(this._hashFn(N))}isEmpty(){return this._nodes.size===0}toString(){const N=[];for(const[S,P]of this._nodes)N.push(`${S}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,S]of this._nodes){const P=new Set([N]),_=this._findCycle(S,P);if(_)return _}}_findCycle(N,S){for(const[P,_]of N.outgoing){if(S.has(P))return[...S,P].join(" -> ");S.add(P);const I=this._findCycle(_,S);if(I)return I;S.delete(P)}}}e.Graph=C}),define(Ce[3],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function P(_){return _[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=P})(n=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function C(S,P,_){P[n.DI_TARGET]===P?P[n.DI_DEPENDENCIES].push({id:S,index:_}):(P[n.DI_DEPENDENCIES]=[{id:S,index:_}],P[n.DI_TARGET]=P)}function y(S){if(n.serviceIds.has(S))return n.serviceIds.get(S);const P=function(_,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(P,_,L)};return P.toString=()=>S,n.serviceIds.set(S,P),P}e.createDecorator=y;function N(S){return S}e.refineServiceDecorator=N}),define(Ce[41],Ie([1,0,9,2,3]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function N(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof C.URI)}e.isConfigurationOverrides=N;function S(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=S;var P;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function _(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=_;function I(o,u){const g=Object.create(null);for(const b in o)L(g,b,o[b],u);return g}e.toValuesTree=I;function L(o,u,g,b){const R=u.split("."),v=R.pop();let t=o;for(let h=0;h<R.length;h++){const r=R[h];let l=t[r];switch(typeof l){case"undefined":l=t[r]=Object.create(null);break;case"object":break;default:b(`Ignoring ${u} as ${R.slice(0,h+1).join(".")} is ${JSON.stringify(l)}`);return}t=l}if(typeof t=="object"&&t!==null)try{t[v]=g}catch{b(`Ignoring ${u} as ${R.join(".")} is ${JSON.stringify(t)}`)}else b(`Ignoring ${u} as ${R.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=L;function w(o,u){const g=u.split(".");f(o,g)}e.removeFromValueTree=w;function f(o,u){const g=u.shift();if(u.length===0){delete o[g];return}if(Object.keys(o).indexOf(g)!==-1){const b=o[g];typeof b=="object"&&!Array.isArray(b)&&(f(b,u),Object.keys(b).length===0&&delete o[g])}}function E(o,u,g){function b(t,h){let r=t;for(const l of h){if(typeof r!="object"||r===null)return;r=r[l]}return r}const R=u.split("."),v=b(o,R);return typeof v>"u"?g:v}e.getConfigurationValue=E;function m(o,u,g){Object.keys(u).forEach(b=>{b!=="__proto__"&&(b in o?n.isObject(o[b])&&n.isObject(u[b])?m(o[b],u[b],g):g&&(o[b]=u[b]):o[b]=u[b])})}e.merge=m;function a(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(Ce[42],Ie([1,0,21,10,3]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const N=new Map;N.set("false",!1),N.set("true",!0),N.set("isMac",n.isMacintosh),N.set("isLinux",n.isLinux),N.set("isWindows",n.isWindows),N.set("isWeb",n.isWeb),N.set("isMacNative",n.isMacintosh&&!n.isWeb),N.set("isEdge",n.isEdge),N.set("isFirefox",n.isFirefox),N.set("isChrome",n.isChrome),N.set("isSafari",n.isSafari);const S=Object.prototype.hasOwnProperty;var P;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class _{static false(){return w.INSTANCE}static true(){return f.INSTANCE}static has(O){return E.create(O)}static equals(O,B){return m.create(O,B)}static notEquals(O,B){return u.create(O,B)}static regex(O,B){return r.create(O,B)}static in(O,B){return a.create(O,B)}static notIn(O,B){return o.create(O,B)}static not(O){return g.create(O)}static and(...O){return p.create(O,null,!0)}static or(...O){return c.create(O,null,!0)}static greater(O,B){return R.create(O,B)}static greaterEquals(O,B){return v.create(O,B)}static smaller(O,B){return t.create(O,B)}static smallerEquals(O,B){return h.create(O,B)}static deserialize(O,B=!1){if(!!O)return this._deserializeOrExpression(O,B)}static _deserializeOrExpression(O,B){const T=O.split("||");return c.create(T.map(F=>this._deserializeAndExpression(F,B)),null,!0)}static _deserializeAndExpression(O,B){const T=O.split("&&");return p.create(T.map(F=>this._deserializeOne(F,B)),null,!0)}static _deserializeOne(O,B){if(O=O.trim(),O.indexOf("!=")>=0){const T=O.split("!=");return u.create(T[0].trim(),this._deserializeValue(T[1],B))}if(O.indexOf("==")>=0){const T=O.split("==");return m.create(T[0].trim(),this._deserializeValue(T[1],B))}if(O.indexOf("=~")>=0){const T=O.split("=~");return r.create(T[0].trim(),this._deserializeRegexValue(T[1],B))}if(O.indexOf(" not in ")>=0){const T=O.split(" not in ");return o.create(T[0].trim(),this._deserializeValue(T[1],B))}if(O.indexOf(" in ")>=0){const T=O.split(" in ");return a.create(T[0].trim(),this._deserializeValue(T[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(O)){const T=O.split(">=");return v.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(O)){const T=O.split(">");return R.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(O)){const T=O.split("<=");return h.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(O)){const T=O.split("<");return t.create(T[0].trim(),T[1].trim())}return/^\!\s*/.test(O)?g.create(O.substr(1).trim()):E.create(O)}static _deserializeValue(O,B){if(O=O.trim(),O==="true")return!0;if(O==="false")return!1;const T=/^'([^']*)'$/.exec(O);return T?T[1].trim():O}static _deserializeRegexValue(O,B){if((0,C.isFalsyOrWhitespace)(O)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const T=O.indexOf("/"),F=O.lastIndexOf("/");if(T===F||T<0){if(B)throw new Error(`bad regexp-value '${O}', missing /-enclosure`);return console.warn(`bad regexp-value '${O}', missing /-enclosure`),null}const z=O.slice(T+1,F),H=O[F+1]==="i"?"i":"";try{return new RegExp(z,H)}catch(de){if(B)throw new Error(`bad regexp-value '${O}', parse error: ${de}`);return console.warn(`bad regexp-value '${O}', parse error: ${de}`),null}}}e.ContextKeyExpr=_;function I(j,O){const B=j?j.substituteConstants():void 0,T=O?O.substituteConstants():void 0;return!B&&!T?!0:!B||!T?!1:B.equals(T)}e.expressionsAreEqualWithConstantSubstitution=I;function L(j,O){return j.cmp(O)}class w{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return f.INSTANCE}}w.INSTANCE=new w,e.ContextKeyFalseExpr=w;class f{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return w.INSTANCE}}f.INSTANCE=new f,e.ContextKeyTrueExpr=f;class E{static create(O,B=null){const T=N.get(O);return typeof T=="boolean"?T?f.INSTANCE:w.INSTANCE:new E(O,B)}constructor(O,B){this.key=O,this.negated=B,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:d(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=N.get(this.key);return typeof O=="boolean"?O?f.INSTANCE:w.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class m{static create(O,B,T=null){if(typeof B=="boolean")return B?E.create(O,T):g.create(O,T);const F=N.get(O);return typeof F=="boolean"?B===(F?"true":"false")?f.INSTANCE:w.INSTANCE:new m(O,B,T)}constructor(O,B,T){this.key=O,this.value=B,this.negated=T,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:k(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=N.get(this.key);if(typeof O=="boolean"){const B=O?"true":"false";return this.value===B?f.INSTANCE:w.INSTANCE}return this}evaluate(O){return O.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(O){return O.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class a{static create(O,B){return new a(O,B)}constructor(O,B){this.key=O,this.valueKey=B,this.type=10,this.negated=null}cmp(O){return O.type!==this.type?this.type-O.type:k(this.key,this.valueKey,O.key,O.valueKey)}equals(O){return O.type===this.type?this.key===O.key&&this.valueKey===O.valueKey:!1}substituteConstants(){return this}evaluate(O){const B=O.getValue(this.valueKey),T=O.getValue(this.key);return Array.isArray(B)?B.includes(T):typeof T=="string"&&typeof B=="object"&&B!==null?S.call(B,T):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(O){return O.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=o.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=a;class o{static create(O,B){return new o(O,B)}constructor(O,B){this.key=O,this.valueKey=B,this.type=11,this._negated=a.create(O,B)}cmp(O){return O.type!==this.type?this.type-O.type:this._negated.cmp(O._negated)}equals(O){return O.type===this.type?this._negated.equals(O._negated):!1}substituteConstants(){return this}evaluate(O){return!this._negated.evaluate(O)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(O){return O.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=o;class u{static create(O,B,T=null){if(typeof B=="boolean")return B?g.create(O,T):E.create(O,T);const F=N.get(O);return typeof F=="boolean"?B===(F?"true":"false")?w.INSTANCE:f.INSTANCE:new u(O,B,T)}constructor(O,B,T){this.key=O,this.value=B,this.negated=T,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:k(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=N.get(this.key);if(typeof O=="boolean"){const B=O?"true":"false";return this.value===B?w.INSTANCE:f.INSTANCE}return this}evaluate(O){return O.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(O){return O.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class g{static create(O,B=null){const T=N.get(O);return typeof T=="boolean"?T?w.INSTANCE:f.INSTANCE:new g(O,B)}constructor(O,B){this.key=O,this.negated=B,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:d(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=N.get(this.key);return typeof O=="boolean"?O?w.INSTANCE:f.INSTANCE:this}evaluate(O){return!O.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(O){return O.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function b(j,O){if(typeof j=="string"){const B=parseFloat(j);isNaN(B)||(j=B)}return typeof j=="string"||typeof j=="number"?O(j):w.INSTANCE}class R{static create(O,B,T=null){return b(B,F=>new R(O,F,T))}constructor(O,B,T){this.key=O,this.value=B,this.negated=T,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:k(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=R;class v{static create(O,B,T=null){return b(B,F=>new v(O,F,T))}constructor(O,B,T){this.key=O,this.value=B,this.negated=T,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:k(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=v;class t{static create(O,B,T=null){return b(B,F=>new t(O,F,T))}constructor(O,B,T){this.key=O,this.value=B,this.negated=T,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:k(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class h{static create(O,B,T=null){return b(B,F=>new h(O,F,T))}constructor(O,B,T){this.key=O,this.value=B,this.negated=T,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:k(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=h;class r{static create(O,B){return new r(O,B)}constructor(O,B){this.key=O,this.regexp=B,this.type=7,this.negated=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.key<O.key)return-1;if(this.key>O.key)return 1;const B=this.regexp?this.regexp.source:"",T=O.regexp?O.regexp.source:"";return B<T?-1:B>T?1:0}equals(O){if(O.type===this.type){const B=this.regexp?this.regexp.source:"",T=O.regexp?O.regexp.source:"";return this.key===O.key&&B===T}return!1}substituteConstants(){return this}evaluate(O){const B=O.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const O=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${O}`}keys(){return[this.key]}map(O){return O.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class l{static create(O){return new l(O)}constructor(O){this._actual=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this._actual.cmp(O._actual)}equals(O){return O.type===this.type?this._actual.equals(O._actual):!1}substituteConstants(){return this}evaluate(O){return!this._actual.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(O){return new l(this._actual.map(O))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;function i(j){let O=null;for(let B=0,T=j.length;B<T;B++){const F=j[B].substituteConstants();if(j[B]!==F&&O===null){O=[];for(let z=0;z<B;z++)O[z]=j[z]}O!==null&&(O[B]=F)}return O===null?j:O}class p{static create(O,B,T){return p._normalizeArr(O,B,T)}constructor(O,B){this.expr=O,this.negated=B,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let B=0,T=this.expr.length;B<T;B++){const F=L(this.expr[B],O.expr[B]);if(F!==0)return F}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let B=0,T=this.expr.length;B<T;B++)if(!this.expr[B].equals(O.expr[B]))return!1;return!0}return!1}substituteConstants(){const O=i(this.expr);return O===this.expr?this:p.create(O,this.negated,!1)}evaluate(O){for(let B=0,T=this.expr.length;B<T;B++)if(!this.expr[B].evaluate(O))return!1;return!0}static _normalizeArr(O,B,T){const F=[];let z=!1;for(const H of O)if(!!H){if(H.type===1){z=!0;continue}if(H.type===0)return w.INSTANCE;if(H.type===6){F.push(...H.expr);continue}F.push(H)}if(F.length===0&&z)return f.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(L);for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];for(;F.length>1;){const H=F[F.length-1];if(H.type!==9)break;F.pop();const de=F.pop(),pe=F.length===0,re=c.create(H.expr.map(le=>p.create([le,de],null,T)),null,pe);re&&(F.push(re),F.sort(L))}if(F.length===1)return F[0];if(T){for(let H=0;H<F.length;H++)for(let de=H+1;de<F.length;de++)if(F[H].negate().equals(F[de]))return w.INSTANCE;if(F.length===1)return F[0]}return new p(F,B)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const B of this.expr)O.push(...B.keys());return O}map(O){return new p(this.expr.map(B=>B.map(O)),null)}negate(){if(!this.negated){const O=[];for(const B of this.expr)O.push(B.negate());this.negated=c.create(O,this,!0)}return this.negated}}class c{static create(O,B,T){return c._normalizeArr(O,B,T)}constructor(O,B){this.expr=O,this.negated=B,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let B=0,T=this.expr.length;B<T;B++){const F=L(this.expr[B],O.expr[B]);if(F!==0)return F}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let B=0,T=this.expr.length;B<T;B++)if(!this.expr[B].equals(O.expr[B]))return!1;return!0}return!1}substituteConstants(){const O=i(this.expr);return O===this.expr?this:c.create(O,this.negated,!1)}evaluate(O){for(let B=0,T=this.expr.length;B<T;B++)if(this.expr[B].evaluate(O))return!0;return!1}static _normalizeArr(O,B,T){let F=[],z=!1;if(O){for(let H=0,de=O.length;H<de;H++){const pe=O[H];if(!!pe){if(pe.type===0){z=!0;continue}if(pe.type===1)return f.INSTANCE;if(pe.type===9){F=F.concat(pe.expr);continue}F.push(pe)}}if(F.length===0&&z)return w.INSTANCE;F.sort(L)}if(F.length!==0){if(F.length===1)return F[0];for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];if(T){for(let H=0;H<F.length;H++)for(let de=H+1;de<F.length;de++)if(F[H].negate().equals(F[de]))return f.INSTANCE;if(F.length===1)return F[0]}return new c(F,B)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const B of this.expr)O.push(...B.keys());return O}map(O){return new c(this.expr.map(B=>B.map(O)),null)}negate(){if(!this.negated){const O=[];for(const B of this.expr)O.push(B.negate());for(;O.length>1;){const B=O.shift(),T=O.shift(),F=[];for(const z of J(B))for(const H of J(T))F.push(p.create([z,H],null,!1));O.unshift(c.create(F,null,!1))}this.negated=c.create(O,this,!0)}return this.negated}}class s extends E{static all(){return s._info.values()}constructor(O,B,T){super(O,null),this._defaultValue=B,typeof T=="object"?s._info.push({...T,key:O}):T!==!0&&s._info.push({key:O,description:T,type:B!=null?typeof B:void 0})}bindTo(O){return O.createKey(this.key,this._defaultValue)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return m.create(this.key,O)}notEqualsTo(O){return u.create(this.key,O)}}s._info=[],e.RawContextKey=s,e.IContextKeyService=(0,y.createDecorator)("contextKeyService");function d(j,O){return j<O?-1:j>O?1:0}function k(j,O,B,T){return j<B?-1:j>B?1:O<T?-1:O>T?1:0}function A(j,O){if(j.type===0||O.type===1)return!0;if(j.type===9)return O.type===9?W(j.expr,O.expr):!1;if(O.type===9){for(const B of O.expr)if(A(j,B))return!0;return!1}if(j.type===6){if(O.type===6)return W(O.expr,j.expr);for(const B of j.expr)if(A(B,O))return!0;return!1}return j.equals(O)}e.implies=A;function W(j,O){let B=0,T=0;for(;B<j.length&&T<O.length;){const F=j[B].cmp(O[T]);if(F<0)return!1;F===0&&B++,T++}return B===j.length}function J(j){return j.type===9?j.expr:[j]}}),define(Ce[159],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[90],Ie([1,0,133,3]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function y(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function N(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function S(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function P(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function _(u,g,b){return P(g,b)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===b?!0:I(b).includes(u)}e.isTargetPlatformCompatible=_;function I(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function L(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=L;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var f;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var E;(function(u){u.Install="install",u.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var a;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(g,b){super(g),this.code=b,this.name=b}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[43],Ie([1,0,48,19,10,9,2,135,3,21,15]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function w(re){return re.create===!0}e.isFileOpenForWriteOptions=w;var f;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(f=e.FileType||(e.FileType={}));var E;(function(re){re[re.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var m;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function a(re){return!!(re.capabilities&2)}e.hasReadWriteCapability=a;function o(re){return!!(re.capabilities&8)}e.hasFileFolderCopyCapability=o;function u(re){return!!(re.capabilities&32768)}e.hasFileCloneCapability=u;function g(re){return!!(re.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(re){return!!(re.capabilities&16)}e.hasFileReadStreamCapability=b;function R(re){return a(re)?!!(re.capabilities&16384):!1}e.hasFileAtomicReadCapability=R;var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{constructor(le,ae){super(le),this.code=ae}}e.FileSystemProviderError=t;function h(re,le){const ae=new t(re.toString(),le);return l(ae,le),ae}e.createFileSystemProviderError=h;function r(re){return re||h((0,P.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=r;function l(re,le){return re.name=le?`${le} (FileSystemError)`:"FileSystemError",re}e.markAsFileSystemProviderError=l;function i(re){if(!re)return v.Unknown;if(re instanceof t)return re.code;const le=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!le)return v.Unknown;switch(le[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=i;function p(re){if(re instanceof W)return re.fileOperationResult;switch(i(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=p;var c;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class s{constructor(le,ae,se){this.resource=le,this.operation=ae,this.target=se}isOperation(le){return this.operation===le}}e.FileOperationEvent=s;var d;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class k{constructor(le,ae){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const Q of le){const K=se.get(Q.type);switch(K?K.push([Q.resource,Q]):se.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,K]of se)switch(Q){case 1:this.added=n.TernarySearchTree.forUris(()=>ae),this.added.fill(K);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>ae),this.updated.fill(K);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>ae),this.deleted.fill(K);break}}contains(le,...ae){return this.doContains(le,{includeChildren:!1},...ae)}affects(le,...ae){return this.doContains(le,{includeChildren:!0},...ae)}doContains(le,ae,...se){if(!le)return!1;const Q=se.length>0;return!!((!Q||se.includes(1))&&(this.added?.get(le)||ae.includeChildren&&this.added?.findSuperstr(le))||(!Q||se.includes(0))&&(this.updated?.get(le)||ae.includeChildren&&this.updated?.findSuperstr(le))||(!Q||se.includes(2))&&(this.deleted?.findSubstr(le)||ae.includeChildren&&this.deleted?.findSuperstr(le)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=k;function A(re,le,ae){return!re||!le||re===le||le.length>re.length?!1:(le.charAt(le.length-1)!==C.sep&&(le+=C.sep),ae?(0,y.startsWithIgnoreCase)(re,le):re.indexOf(le)===0)}e.isParent=A;class W extends Error{constructor(le,ae,se){super(le),this.fileOperationResult=ae,this.options=se}}e.FileOperationError=W;class J extends W{constructor(le,ae,se,Q){super(le,ae,Q),this.fileOperationResult=ae,this.size=se}}e.TooLargeFileOperationError=J;class j extends W{constructor(le,ae,se){super(le,2,se),this.stat=ae}}e.NotModifiedSinceFileOperationError=j;var O;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",re[re.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.etag=T;async function F(re,le){if(!le.hasProvider(S.URI.from({scheme:re.scheme})))return new Promise(ae=>{const se=le.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===re.scheme&&Q.added&&(se.dispose(),ae())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(le){return(0,N.isNumber)(le)||(le=0),le<z.KB?(0,P.localize)(1,null,le.toFixed(0)):le<z.MB?(0,P.localize)(2,null,(le/z.KB).toFixed(2)):le<z.GB?(0,P.localize)(3,null,(le/z.MB).toFixed(2)):le<z.TB?(0,P.localize)(4,null,(le/z.GB).toFixed(2)):(0,P.localize)(5,null,(le/z.TB).toFixed(2))}}z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB,e.ByteSize=z;var H;(function(re){re[re.IA32=0]="IA32",re[re.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function de(re){return{maxFileSize:re===0?300*z.MB:16*z.GB,maxHeapSize:re===0?700*z.MB:2*700*z.MB}}e.getPlatformFileLimits=de;function pe(re){const le=typeof re=="string"||re?.scheme===L.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===L.Schemas.file?1024*z.MB:le?10*z.MB:I.isWeb?50*z.MB:1024*z.MB}e.getLargeFileConfirmationLimit=pe}),define(Ce[67],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...y){this._entries=new Map;for(const[N,S]of y)this.set(N,S)}set(y,N){const S=this._entries.get(y);return this._entries.set(y,N),S}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=n}),define(Ce[160],Ie([1,0,17,12,6,89,158,3,67,161]),function(te,e,n,C,y,N,S,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class w extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class f{constructor(o=new _.ServiceCollection,u=!1,g,b=L){this._services=o,this._strict=u,this._parent=g,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=b?g?._globalGraph??new S.Graph(R=>R):void 0}createChild(o){return new f(o,this._strict,this,this._enableTracing)}invokeFunction(o,...u){const g=m.traceInvocation(this._enableTracing,o);let b=!1;try{return o({get:v=>{if(b)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(v,g);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...u)}finally{b=!0,g.stop()}}createInstance(o,...u){let g,b;return o instanceof N.SyncDescriptor?(g=m.traceCreation(this._enableTracing,o.ctor),b=this._createInstance(o.ctor,o.staticArguments.concat(u),g)):(g=m.traceCreation(this._enableTracing,o),b=this._createInstance(o,u,g)),g.stop(),b}_createInstance(o,u=[],g){const b=P._util.getServiceDependencies(o).sort((t,h)=>t.index-h.index),R=[];for(const t of b){const h=this._getOrCreateServiceInstance(t.id,g);h||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),R.push(h)}const v=b.length>0?b[0].index:u.length;if(u.length!==v){console.trace(`[createInstance] First service dependency of ${o.name} at position ${v+1} conflicts with ${u.length} static arguments`);const t=v-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,v)}return Reflect.construct(o,u.concat(R))}_setServiceInstance(o,u){if(this._services.get(o)instanceof N.SyncDescriptor)this._services.set(o,u);else if(this._parent)this._parent._setServiceInstance(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const u=this._services.get(o);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):u}_getOrCreateServiceInstance(o,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const g=this._getServiceInstanceOrDescriptor(o);return g instanceof N.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,g,u.branch(o,!0)):(u.branch(o,!1),g)}_safeCreateAndCacheServiceInstance(o,u,g){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,u,g)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,u,g){const b=new S.Graph(t=>t.id.toString());let R=0;const v=[{id:o,desc:u,_trace:g}];for(;v.length;){const t=v.pop();if(b.lookupOrInsertNode(t),R++>1e3)throw new w(b);for(const h of P._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(h.id);if(r||this._throwIfStrict(`[createInstance] ${o} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),r instanceof N.SyncDescriptor){const l={id:h.id,desc:r,_trace:t._trace.branch(h.id,!0)};b.insertEdge(t,l),v.push(l)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new w(b);break}for(const{data:h}of t){if(this._getServiceInstanceOrDescriptor(h.id)instanceof N.SyncDescriptor){const l=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,l)}b.removeNode(h)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,u,g=[],b,R){if(this._services.get(o)instanceof N.SyncDescriptor)return this._createServiceInstance(o,u,g,b,R);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,u,g,b,R);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(o,u,g=[],b,R){if(b){const v=new f(void 0,this._strict,this,this._enableTracing);v._globalGraphImplicitDependency=String(o);const t=new Map,h=new n.IdleValue(()=>{const r=v._createInstance(u,g,R);for(const[l,i]of t){const p=r[l];if(typeof p=="function")for(const c of i)p.apply(r,c)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,l){if(!h.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let c=t.get(l);return c||(c=new I.LinkedList,t.set(l,c)),(d,k,A)=>{const W=c.push([d,k,A]);return(0,y.toDisposable)(W)}}if(l in r)return r[l];const i=h.value;let p=i[l];return typeof p!="function"||(p=p.bind(i),r[l]=p),p},set(r,l,i){return h.value[l]=i,!0},getPrototypeOf(r){return u.prototype}})}else return this._createInstance(u,g,R)}_throwIfStrict(o,u){if(u&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=f;var E;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(E||(E={}));class m{static traceInvocation(o,u){return o?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(o,u){return o?new m(1,u.name):m._None}constructor(o,u){this.type=o,this.name=u,this._start=Date.now(),this._dep=[]}branch(o,u){const g=new m(3,o.toString());return this._dep.push([o,u,g]),g}stop(){const o=Date.now()-this._start;m._totals+=o;let u=!1;function g(R,v){const t=[],h=new Array(R+1).join("	");for(const[r,l,i]of v._dep)if(l&&i){u=!0,t.push(`${h}CREATES -> ${r}`);const p=g(R+1,i);p&&t.push(p)}else t.push(`${h}uses -> ${r}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(o>2||u)&&m.all.add(b.join(`
`))}}m.all=new Set,m._None=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m._totals=0,e.Trace=m}),define(Ce[11],Ie([1,0,39,4,6,28,21,9,2,3]),function(te,e,n,C,y,N,S,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function L(){return new Date().toISOString()}function w(c){return(0,P.isNumber)(c)}e.isLogLevel=w;var f;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function E(c,s,d){switch(s){case f.Trace:c.trace(d);break;case f.Debug:c.debug(d);break;case f.Info:c.info(d);break;case f.Warning:c.warn(d);break;case f.Error:c.error(d);break;case f.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=E;function m(c){let s="";for(let d=0;d<c.length;d++){let k=c[d];if(typeof k=="object")try{k=JSON.stringify(k)}catch{}s+=(d>0?" ":"")+k}return s}e.format=m;class a extends y.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(s){return this.level!==f.Off&&this.level<=s}}e.AbstractLogger=a;class o extends a{constructor(s){super(),this.logAlways=s}checkLogLevel(s){return this.logAlways||super.checkLogLevel(s)}trace(s,...d){this.checkLogLevel(f.Trace)&&this.log(f.Trace,m([s,...d]))}debug(s,...d){this.checkLogLevel(f.Debug)&&this.log(f.Debug,m([s,...d]))}info(s,...d){this.checkLogLevel(f.Info)&&this.log(f.Info,m([s,...d]))}warn(s,...d){this.checkLogLevel(f.Warning)&&this.log(f.Warning,m([s,...d]))}error(s,...d){if(this.checkLogLevel(f.Error))if(s instanceof Error){const k=Array.prototype.slice.call(arguments);k[0]=s.stack,this.log(f.Error,m(k))}else this.log(f.Error,m([s,...d]))}flush(){}}e.AbstractMessageLogger=o;class u extends a{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.useColors=!S.isWindows}trace(s,...d){this.checkLogLevel(f.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,s,...d):console.log(`[main ${L()}]`,s,...d))}debug(s,...d){this.checkLogLevel(f.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,s,...d):console.log(`[main ${L()}]`,s,...d))}info(s,...d){this.checkLogLevel(f.Info)&&(this.useColors?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,s,...d):console.log(`[main ${L()}]`,s,...d))}warn(s,...d){this.checkLogLevel(f.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${L()}]\x1B[0m`,s,...d):console.warn(`[main ${L()}]`,s,...d))}error(s,...d){this.checkLogLevel(f.Error)&&(this.useColors?console.error(`\x1B[91m[main ${L()}]\x1B[0m`,s,...d):console.error(`[main ${L()}]`,s,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class g extends a{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...d){this.checkLogLevel(f.Trace)&&console.log("%cTRACE","color: #888",s,...d)}debug(s,...d){this.checkLogLevel(f.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...d)}info(s,...d){this.checkLogLevel(f.Info)&&console.log("%c INFO","color: #33f",s,...d)}warn(s,...d){this.checkLogLevel(f.Warning)&&console.log("%c WARN","color: #993",s,...d)}error(s,...d){this.checkLogLevel(f.Error)&&console.log("%c  ERR","color: #f33",s,...d)}dispose(){}flush(){}}e.ConsoleLogger=g;class b extends a{constructor(s,d=e.DEFAULT_LOG_LEVEL){super(),this.adapter=s,this.setLevel(d)}trace(s,...d){this.checkLogLevel(f.Trace)&&this.adapter.log(f.Trace,[this.extractMessage(s),...d])}debug(s,...d){this.checkLogLevel(f.Debug)&&this.adapter.log(f.Debug,[this.extractMessage(s),...d])}info(s,...d){this.checkLogLevel(f.Info)&&this.adapter.log(f.Info,[this.extractMessage(s),...d])}warn(s,...d){this.checkLogLevel(f.Warning)&&this.adapter.log(f.Warning,[this.extractMessage(s),...d])}error(s,...d){this.checkLogLevel(f.Error)&&this.adapter.log(f.Error,[this.extractMessage(s),...d])}extractMessage(s){return typeof s=="string"?s:(0,n.toErrorMessage)(s,this.checkLogLevel(f.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class R extends a{constructor(s){super(),this.loggers=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const d of this.loggers)d.setLevel(s);super.setLevel(s)}trace(s,...d){for(const k of this.loggers)k.trace(s,...d)}debug(s,...d){for(const k of this.loggers)k.debug(s,...d)}info(s,...d){for(const k of this.loggers)k.info(s,...d)}warn(s,...d){for(const k of this.loggers)k.warn(s,...d)}error(s,...d){for(const k of this.loggers)k.error(s,...d)}flush(){for(const s of this.loggers)s.flush()}dispose(){for(const s of this.loggers)s.dispose()}}e.MultiplexLogger=R;class v extends y.Disposable{constructor(s,d){if(super(),this.logLevel=s,this._loggers=new N.ResourceMap,this._loggerResources=new N.ResourceMap,this._onDidChangeLoggers=this._register(new C.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,d)for(const k of d)this._loggerResources.set(k.resource,k)}getLogger(s){return this._loggers.get(s)}createLogger(s,d){let k=this._loggers.get(s);const A=d?.logLevel==="always"?f.Trace:d?.logLevel;return k||(k=this.doCreateLogger(s,A??this.getLogLevel(s)??this.logLevel,d),this._loggers.set(s,k)),this.registerLogger({resource:s,id:d?.id??s.toString(),logLevel:A,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId}),k}setLogLevel(s,d){if(_.URI.isUri(s)){const k=s,A=d,W=this._loggerResources.get(k);W&&A!==W.logLevel&&(W.logLevel=A===this.logLevel?void 0:A,this._loggers.get(k)?.setLevel(A),this._loggerResources.set(W.resource,W),this._onDidChangeLogLevel.fire([k,A]))}else{this.logLevel=s;for(const[k,A]of this._loggers.entries())this._loggerResources.get(k)?.logLevel===void 0&&A.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(s,d){const k=this._loggerResources.get(s);k&&d!==!k.hidden&&(k.hidden=!d,this._loggerResources.set(k.resource,k),this._onDidChangeVisibility.fire([s,d]))}getLogLevel(s){let d;return s&&(d=this._loggerResources.get(s)?.logLevel),d??this.logLevel}registerLogger(s){const d=this._loggerResources.get(s.resource);d?d.hidden!==s.hidden&&this.setVisibility(s.resource,!s.hidden):(this._loggerResources.set(s.resource,s),this._onDidChangeLoggers.fire({added:[s],removed:[]}))}deregisterLogger(s){const d=this._loggerResources.get(s);if(d){this._loggerResources.delete(s);const k=this._loggers.get(s);k&&(this._loggers.delete(s),k.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[d]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(s){return this._loggerResources.get(s)}dispose(){this._loggers.forEach(s=>s.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=v;class t{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(s){}getLevel(){return f.Info}trace(s,...d){}debug(s,...d){}info(s,...d){}warn(s,...d){}error(s,...d){}critical(s,...d){}dispose(){}flush(){}}e.NullLogger=t;class h extends t{}e.NullLogService=h;class r extends v{constructor(){super(f.Info)}doCreateLogger(s,d,k){return new t}}e.NullLoggerService=r;function l(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const s=p(c.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function i(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.LogLevelToString=i;function p(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.parseLogLevel=p}),define(Ce[162],Ie([1,0,6,11]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class y extends n.Disposable{constructor(S,P=[]){super(),this.logger=new C.MultiplexLogger([S,...P]),this._register(S.onDidChangeLogLevel(_=>this.setLevel(_)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(S){this.logger.setLevel(S)}getLevel(){return this.logger.getLevel()}trace(S,...P){this.logger.trace(S,...P)}debug(S,...P){this.logger.debug(S,...P)}info(S,...P){this.logger.info(S,...P)}warn(S,...P){this.logger.warn(S,...P)}error(S,...P){this.logger.error(S,...P)}flush(){this.logger.flush()}}e.LogService=y}),define(Ce[91],Ie([1,0,29,136,3]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(N=e.MarkerTag||(e.MarkerTag={}));var S;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function I(m,a){return a-m}_.compare=I;const L=Object.create(null);L[_.Error]=(0,C.localize)(0,null),L[_.Warning]=(0,C.localize)(1,null),L[_.Info]=(0,C.localize)(2,null);function w(m){return L[m]||""}_.toString=w;function f(m){switch(m){case n.default.Error:return _.Error;case n.default.Warning:return _.Warning;case n.default.Info:return _.Info;case n.default.Ignore:return _.Hint}}_.fromSeverity=f;function E(m){switch(m){case _.Error:return n.default.Error;case _.Warning:return n.default.Warning;case _.Info:return n.default.Info;case _.Hint:return n.default.Ignore}}_.toSeverity=E}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(_){const I="";function L(f){return w(f,!0)}_.makeKey=L;function w(f,E){const m=[I];return f.source?m.push(f.source.replace("\xA6","\\\xA6")):m.push(I),f.code?typeof f.code=="string"?m.push(f.code.replace("\xA6","\\\xA6")):m.push(f.code.value.replace("\xA6","\\\xA6")):m.push(I),f.severity!==void 0&&f.severity!==null?m.push(S.toString(f.severity)):m.push(I),f.message&&E?m.push(f.message.replace("\xA6","\\\xA6")):m.push(I),f.startLineNumber!==void 0&&f.startLineNumber!==null?m.push(f.startLineNumber.toString()):m.push(I),f.startColumn!==void 0&&f.startColumn!==null?m.push(f.startColumn.toString()):m.push(I),f.endLineNumber!==void 0&&f.endLineNumber!==null?m.push(f.endLineNumber.toString()):m.push(I),f.endColumn!==void 0&&f.endColumn!==null?m.push(f.endColumn.toString()):m.push(I),m.push(I),m.join("\xA6")}_.makeKeyOptionalMessage=w})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ce[163],Ie([1,0,4,29,3]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,y.createDecorator)("notificationService");var N;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(N=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new _,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=P;class _{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=_}),define(Ce[92],Ie([1,0,10,2,3]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function N(I,L){return C.URI.isUri(I)?(0,n.equalsIgnoreCase)(I.scheme,L):(0,n.startsWithIgnoreCase)(I,L+":")}e.matchesScheme=N;function S(I,...L){return L.some(w=>N(I,w))}e.matchesSomeScheme=S;function P(I,L){return I.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=P;function _(I){let L;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(I.fragment);return w&&(L={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},I=I.with({fragment:""})),{selection:L,uri:I}}e.extractSelection=_}),define(Ce[164],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function(te,e,n,C){var y=arguments.length,N=y<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,n):C,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(te,e,n,C);else for(var P=te.length-1;P>=0;P--)(S=te[P])&&(N=(y<3?S(N):y>3?S(e,n,N):S(e,n))||N);return y>3&&N&&Object.defineProperty(e,n,N),N},He=this&&this.__param||function(te,e){return function(n,C){e(n,C,te)}};define(Ce[165],Ie([1,0,17,20,6,3]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var S;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this._value}constructor(w){this.callback=w}report(w){this._value=w,this.callback(this._value)}}P.None=Object.freeze({report(){}}),e.Progress=P;let _=class extends y.Disposable{constructor(w,f){super(),this.deferred=new n.DeferredPromise,f.withProgress(w,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(w){this.reporter?this.reporter.report(w):this.lastStep=w}};_=Ve([He(1,e.IProgressService)],_),e.UnmanagedProgress=_;class I extends y.Disposable{constructor(w){super(),this.progressIndicator=w,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(w){this.stop();const f=++this.currentOperationId,E=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{f===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},w),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:f,token:E.token,stop:()=>this.doStop(f),isCurrent:()=>this.currentOperationId===f}}stop(){this.doStop(this.currentOperationId)}doStop(w){this.currentOperationId===w&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Ce[30],Ie([1,0,49,9]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(S,P){n.ok(C.isString(S)),n.ok(C.isObject(P)),n.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,P)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new y}),define(Ce[68],Ie([1,0,4,30]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class N{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,I){this.schemasById[y(_)]=I,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new N;C.Registry.add(e.Extensions.JSONContribution,S)}),define(Ce[93],Ie([1,0,16,4,9,132,41,68,30]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=_.Registry.as(P.Extensions.JSONContribution);class f{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const r=new Set;this.doRegisterConfigurations(t,h,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const h=new Set;this.doDeregisterConfigurations(t,h),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}updateConfigurations({add:t,remove:h}){const r=new Set;this.doDeregisterConfigurations(h,r),this.doRegisterConfigurations(t,!1,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const h=new Set;this.doRegisterDefaultConfigurations(t,h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,h){const r=[];for(const{overrides:l,source:i}of t)for(const p in l)if(h.add(p),e.OVERRIDE_PROPERTY_REGEX.test(p)){const c=this.configurationDefaultsOverrides.get(p),s=c?.valuesSources??new Map;if(i)for(const W of Object.keys(l[p]))s.set(W,i);const d={...c?.value||{},...l[p]};this.configurationDefaultsOverrides.set(p,{source:i,value:d,valuesSources:s});const k=(0,S.getLanguageTagSettingPlainKey)(p),A={type:"object",default:d,description:N.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:y.isString(i)?void 0:i,defaultValueSource:i};r.push(...a(p)),this.configurationProperties[p]=A,this.defaultLanguageConfigurationOverridesNode.properties[p]=A}else{this.configurationDefaultsOverrides.set(p,{value:l[p],source:i});const c=this.configurationProperties[p];c&&(this.updatePropertyDefaultValue(p,c),this.updateSchema(p,c))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const h=new Set;this.doDeregisterDefaultConfigurations(t,h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,h){for(const{overrides:r,source:l}of t)for(const i in r){const p=this.configurationDefaultsOverrides.get(i),c=y.isString(l)?l:l?.id,s=y.isString(p?.source)?p?.source:p?.source?.id;if(c===s)if(h.add(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const d=this.configurationProperties[i];d&&(this.updatePropertyDefaultValue(i,d),this.updateSchema(i,d))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let h=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),h=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),h=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const h of t)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,h,r){t.forEach(l=>{this.validateAndRegisterProperties(l,h,l.extensionInfo,l.restrictedProperties,void 0,r),this.configurationContributors.push(l),this.registerJSONConfiguration(l)})}doDeregisterConfigurations(t,h){const r=l=>{if(l.properties)for(const i in l.properties){h.add(i);const p=this.configurationProperties[i];p?.policy?.name&&this.policyConfigurations.delete(p.policy.name),delete this.configurationProperties[i],this.removeFromSchema(i,l.properties[i])}l.allOf?.forEach(i=>r(i))};for(const l of t){r(l);const i=this.configurationContributors.indexOf(l);i!==-1&&this.configurationContributors.splice(i,1)}}validateAndRegisterProperties(t,h=!0,r,l,i=3,p){i=y.isUndefinedOrNull(t.scope)?i:t.scope;const c=t.properties;if(c)for(const d in c){const k=c[d];if(h&&b(d,k)){delete c[d];continue}if(k.source=r,k.defaultDefaultValue=c[d].default,this.updatePropertyDefaultValue(d,k),e.OVERRIDE_PROPERTY_REGEX.test(d)?k.scope=void 0:(k.scope=y.isUndefinedOrNull(k.scope)?i:k.scope,k.restricted=y.isUndefinedOrNull(k.restricted)?!!l?.includes(d):k.restricted),c[d].hasOwnProperty("included")&&!c[d].included){this.excludedConfigurationProperties[d]=c[d],delete c[d];continue}else this.configurationProperties[d]=c[d],c[d].policy?.name&&this.policyConfigurations.set(c[d].policy.name,d);!c[d].deprecationMessage&&c[d].markdownDeprecationMessage&&(c[d].deprecationMessage=c[d].markdownDeprecationMessage),p.add(d)}const s=t.allOf;if(s)for(const d of s)this.validateAndRegisterProperties(d,h,r,l,i,p)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const h=r=>{const l=r.properties;if(l)for(const p in l)this.updateSchema(p,l[p]);r.allOf?.forEach(h)};h(t)}updateSchema(t,h){switch(e.allSettings.properties[t]=h,h.scope){case 1:e.applicationSettings.properties[t]=h;break;case 2:e.machineSettings.properties[t]=h;break;case 6:e.machineOverridableSettings.properties[t]=h;break;case 3:e.windowSettings.properties[t]=h;break;case 4:e.resourceSettings.properties[t]=h;break;case 5:e.resourceSettings.properties[t]=h,this.resourceLanguageSettingsSchema.properties[t]=h;break}}removeFromSchema(t,h){switch(delete e.allSettings.properties[t],h.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const h=`[${t}]`,r={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,r),e.allSettings.properties[h]=r,e.applicationSettings.properties[h]=r,e.machineSettings.properties[h]=r,e.machineOverridableSettings.properties[h]=r,e.windowSettings.properties[h]=r,e.resourceSettings.properties[h]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,h){const r=this.configurationDefaultsOverrides.get(t);let l=r?.value,i=r?.source;y.isUndefined(l)&&(l=h.defaultDefaultValue,i=void 0),y.isUndefined(l)&&(l=u(h.type)),h.default=l,h.defaultValueSource=i}}const E="\\[([^\\]]+)\\]",m=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(v){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let h=m.exec(v);for(;h?.length;){const r=h[1].trim();r&&t.push(r),h=m.exec(v)}}return(0,n.distinct)(t)}e.overrideIdentifiersFromKey=a;function o(v){return v.reduce((t,h)=>`${t}[${h}]`,"")}e.keyFromOverrideIdentifiers=o;function u(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new f;_.Registry.add(e.Extensions.Configuration,g);function b(v,t){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?N.localize(7,null,v):g.getConfigurationProperties()[v]!==void 0?N.localize(8,null,v):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,v,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}e.validateProperty=b;function R(){const v=[],t=g.getConfigurationProperties();for(const h of Object.keys(t))v.push([h,t[h].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=R}),define(Ce[166],Ie([1,0,16,4,111,6,28,22,9,2,41,93,30]),function(te,e,n,C,y,N,S,P,_,I,L,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function E(h){return Object.isFrozen(h)?h:P.deepFreeze(h)}class m{constructor(r={},l=[],i=[],p){this._contents=r,this._keys=l,this._overrides=i,this.raw=p,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(l=>{if(l instanceof m)return l;const i=new a("");return i.parseRaw(l),i.configurationModel});this._rawConfiguration=r.reduce((l,i)=>i===l?i:l.merge(i),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}inspect(r,l){const i=this.rawConfiguration.getValue(r),p=l?this.rawConfiguration.getOverrideValue(r,l):void 0,c=l?this.rawConfiguration.override(l).getValue(r):i;return{value:i,override:p,merged:c}}getOverrideValue(r,l){const i=this.getContentsForOverrideIdentifer(l);return i?r?(0,L.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){const l=[];for(const i of this.overrides)i.identifiers.includes(r)&&l.push(...i.keys);return n.distinct(l)}getAllOverrideIdentifiers(){const r=[];for(const l of this.overrides)r.push(...l.identifiers);return n.distinct(r)}override(r){let l=this.overrideConfigurations.get(r);return l||(l=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,l)),l}merge(...r){const l=P.deepClone(this.contents),i=P.deepClone(this.overrides),p=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const s of r)if(c.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.mergeContents(l,s.contents);for(const d of s.overrides){const[k]=i.filter(A=>n.equals(A.identifiers,d.identifiers));k?(this.mergeContents(k.contents,d.contents),k.keys.push(...d.keys),k.keys=n.distinct(k.keys)):i.push(P.deepClone(d))}for(const d of s.keys)p.indexOf(d)===-1&&p.push(d)}return new m(l,p,i,c.every(s=>s instanceof m)?void 0:c)}createOverrideConfigurationModel(r){const l=this.getContentsForOverrideIdentifer(r);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const i={};for(const p of n.distinct([...Object.keys(this.contents),...Object.keys(l)])){let c=this.contents[p];const s=l[p];s&&(typeof c=="object"&&typeof s=="object"?(c=P.deepClone(c),this.mergeContents(c,s)):c=s),i[p]=c}return new m(i,this.keys,this.overrides)}mergeContents(r,l){for(const i of Object.keys(l)){if(i in r&&_.isObject(r[i])&&_.isObject(l[i])){this.mergeContents(r[i],l[i]);continue}r[i]=P.deepClone(l[i])}}getContentsForOverrideIdentifer(r){let l=null,i=null;const p=c=>{c&&(i?this.mergeContents(i,c):i=P.deepClone(c))};for(const c of this.overrides)n.equals(c.identifiers,[r])?l=c.contents:c.identifiers.includes(r)&&p(c.contents);return p(l),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,l){this.updateValue(r,l,!0)}setValue(r,l){this.updateValue(r,l,!1)}removeValue(r){const l=this.keys.indexOf(r);l!==-1&&(this.keys.splice(l,1),(0,L.removeFromValueTree)(this.contents,r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(i=>n.equals(i.identifiers,(0,w.overrideIdentifiersFromKey)(r))),1))}updateValue(r,l,i){(0,L.addToValueTree)(this.contents,r,l,p=>console.error(p)),i=i||this.keys.indexOf(r)===-1,i&&this.keys.push(r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,L.toValuesTree)(this.contents[r],p=>console.error(p))})}}e.ConfigurationModel=m;class a{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,l){if(!_.isUndefinedOrNull(r)){const i=this.doParseContent(r);this.parseRaw(i,l)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,l){this._raw=r;const{contents:i,keys:p,overrides:c,restricted:s,hasExcludedProperties:d}=this.doParseRaw(r,l);this._configurationModel=new m(i,p,c,d?[r]:void 0),this._restrictedConfigurations=s||[]}doParseContent(r){let l={},i=null,p=[];const c=[],s=[];function d(A){Array.isArray(p)?p.push(A):i!==null&&(p[i]=A)}const k={onObjectBegin:()=>{const A={};d(A),c.push(p),p=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{p=c.pop()},onArrayBegin:()=>{const A=[];d(A),c.push(p),p=A,i=null},onArrayEnd:()=>{p=c.pop()},onLiteralValue:d,onError:(A,W,J)=>{s.push({error:A,offset:W,length:J})}};if(r)try{y.visit(r,k),l=p[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return l}doParseRaw(r,l){const i=f.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),p=this.filter(r,i,!0,l);r=p.raw;const c=(0,L.toValuesTree)(r,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),s=Object.keys(r),d=this.toOverrides(r,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:c,keys:s,overrides:d,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}filter(r,l,i,p){let c=!1;if(!p?.scopes&&!p?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const s={},d=[];for(const k in r)if(w.OVERRIDE_PROPERTY_REGEX.test(k)&&i){const A=this.filter(r[k],l,!1,p);s[k]=A.raw,c=c||A.hasExcludedProperties,d.push(...A.restricted)}else{const A=l[k],W=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&d.push(k),(W===void 0||p.scopes===void 0||p.scopes.includes(W))&&!(p.skipRestricted&&A?.restricted)?s[k]=r[k]:c=!0}return{raw:s,restricted:d,hasExcludedProperties:c}}toOverrides(r,l){const i=[];for(const p of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(p)){const c={};for(const s in r[p])c[s]=r[p][s];i.push({identifiers:(0,w.overrideIdentifiersFromKey)(p),keys:Object.keys(c),contents:(0,L.toValuesTree)(c,l)})}return i}}e.ConfigurationModelParser=a;class o extends N.Disposable{constructor(r,l,i,p){super(),this.userSettingsResource=r,this.scopes=l,this.fileService=p,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&i.isEqual(c.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=o;class u{constructor(r,l,i,p,c,s,d,k,A,W,J,j,O){this.key=r,this.overrides=l,this._value=i,this.overrideIdentifiers=p,this.defaultConfiguration=c,this.policyConfiguration=s,this.applicationConfiguration=d,this.userConfiguration=k,this.localUserConfiguration=A,this.remoteUserConfiguration=W,this.workspaceConfiguration=J,this.folderConfigurationModel=j,this.memoryConfigurationModel=O}get value(){return E(this._value)}inspect(r,l,i){const p=r.inspect(l,i);return{get value(){return E(p.value)},get override(){return E(p.override)},get merged(){return E(p.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class g{constructor(r,l,i,p,c=new m,s=new m,d=new S.ResourceMap,k=new m,A=new S.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=l,this._applicationConfiguration=i,this._localUserConfiguration=p,this._remoteUserConfiguration=c,this._workspaceConfiguration=s,this._folderConfigurations=d,this._memoryConfiguration=k,this._memoryConfigurationByResource=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new S.ResourceMap,this._userConfiguration=null}getValue(r,l,i){return this.getConsolidatedConfigurationModel(r,l,i).getValue(r)}updateValue(r,l,i={}){let p;i.resource?(p=this._memoryConfigurationByResource.get(i.resource),p||(p=new m,this._memoryConfigurationByResource.set(i.resource,p))):p=this._memoryConfiguration,l===void 0?p.removeValue(r):p.setValue(r,l),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,l,i){const p=this.getConsolidatedConfigurationModel(r,l,i),c=this.getFolderConfigurationModelForResource(l.resource,i),s=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,d=new Set;for(const k of p.overrides)for(const A of k.identifiers)p.getOverrideValue(r,A)!==void 0&&d.add(A);return new u(r,l,p.getValue(r),d.size?[...d]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this._workspaceConfiguration:void 0,c||void 0,s)}keys(r){const l=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,l){this._folderConfigurations.set(r,l),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,l){const i=[];if(!l){const{added:p,updated:c,removed:s}=v(this._defaultConfiguration,r);l=[...p,...c,...s]}for(const p of l)for(const c of(0,w.overrideIdentifiersFromKey)(p)){const s=this._defaultConfiguration.getKeysForOverrideIdentifier(c),d=r.getKeysForOverrideIdentifier(c),k=[...d.filter(A=>s.indexOf(A)===-1),...s.filter(A=>d.indexOf(A)===-1),...s.filter(A=>!P.equals(this._defaultConfiguration.override(c).getValue(A),r.override(c).getValue(A)))];i.push([c,k])}return this.updateDefaultConfiguration(r),{keys:l,overrides:i}}compareAndUpdatePolicyConfiguration(r){const{added:l,updated:i,removed:p}=v(this._policyConfiguration,r),c=[...l,...i,...p];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:l,updated:i,removed:p,overrides:c}=v(this.applicationConfiguration,r),s=[...l,...i,...p];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:l,updated:i,removed:p,overrides:c}=v(this.localUserConfiguration,r),s=[...l,...i,...p];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:l,updated:i,removed:p,overrides:c}=v(this.remoteUserConfiguration,r),s=[...l,...i,...p];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:l,updated:i,removed:p,overrides:c}=v(this.workspaceConfiguration,r),s=[...l,...i,...p];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:c}}compareAndUpdateFolderConfiguration(r,l){const i=this.folderConfigurations.get(r),{added:p,updated:c,removed:s,overrides:d}=v(i,l),k=[...p,...c,...s];return(k.length||!i)&&this.updateFolderConfiguration(r,l),{keys:k,overrides:d}}compareAndDeleteFolderConfiguration(r){const l=this.folderConfigurations.get(r);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:p,removed:c,overrides:s}=v(l,void 0);return{keys:[...i,...p,...c],overrides:s}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,l,i){let p=this.getConsolidatedConfigurationModelForResource(l,i);return l.overrideIdentifier&&(p=p.override(l.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(p=p.merge(this._policyConfiguration)),p}getConsolidatedConfigurationModelForResource({resource:r},l){let i=this.getWorkspaceConsolidatedConfiguration();if(l&&r){const p=l.getFolder(r);p&&(i=this.getFolderConsolidatedConfiguration(p.uri)||i);const c=this._memoryConfigurationByResource.get(r);c&&(i=i.merge(c))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let l=this._foldersConsolidatedConfigurations.get(r);if(!l){const i=this.getWorkspaceConsolidatedConfiguration(),p=this._folderConfigurations.get(r);p?(l=i.merge(p),this._foldersConsolidatedConfigurations.set(r,l)):l=i}return l}getFolderConfigurationModelForResource(r,l){if(l&&r){const i=l.getFolder(r);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,l)=>{const{contents:i,overrides:p,keys:c}=this._folderConfigurations.get(l);return r.push([l,{contents:i,overrides:p,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(l=>r.add(l)),this.userConfiguration.keys.forEach(l=>r.add(l)),this._workspaceConfiguration.keys.forEach(l=>r.add(l)),this._folderConfigurations.forEach(l=>l.keys.forEach(i=>r.add(i))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this._folderConfigurations.forEach(l=>l.getAllOverrideIdentifiers().forEach(i=>r.add(i))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>l.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>l.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>l.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(p=>l.add(p))),[...l.values()]}static parse(r){const l=this.parseConfigurationModel(r.defaults),i=this.parseConfigurationModel(r.policy),p=this.parseConfigurationModel(r.application),c=this.parseConfigurationModel(r.user),s=this.parseConfigurationModel(r.workspace),d=r.folders.reduce((k,A)=>(k.set(I.URI.revive(A[0]),this.parseConfigurationModel(A[1])),k),new S.ResourceMap);return new g(l,i,p,c,new m,s,d,new m,new S.ResourceMap)}static parseConfigurationModel(r){return new m(r.contents,r.keys,r.overrides)}}e.Configuration=g;function b(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const r=new Set,l=new Map;for(const p of h)p.keys.forEach(c=>r.add(c)),p.overrides.forEach(([c,s])=>{const d=(0,S.getOrSet)(l,c,new Set);s.forEach(k=>d.add(k))});const i=[];return l.forEach((p,c)=>i.push([c,[...p.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=b;class R{constructor(r,l,i,p){this.change=r,this.previous=l,this.currentConfiguraiton=i,this.currentWorkspace=p,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const s of c)this.affectedKeys.add(s);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,l){const i=this._marker+r,p=this._affectsConfigStr.indexOf(i);if(p<0)return!1;const c=p+i.length;if(c>=this._affectsConfigStr.length)return!1;const s=this._affectsConfigStr.charCodeAt(c);if(s!==this._markerCode1&&s!==this._markerCode2)return!1;if(l){const d=this.previousConfiguration?this.previousConfiguration.getValue(r,l,this.previous?.workspace):void 0,k=this.currentConfiguraiton.getValue(r,l,this.currentWorkspace);return!P.equals(d,k)}return!0}}e.ConfigurationChangeEvent=R;function v(h,r){const{added:l,removed:i,updated:p}=t(r?.rawConfiguration,h?.rawConfiguration),c=[],s=h?.getAllOverrideIdentifiers()||[],d=r?.getAllOverrideIdentifiers()||[];if(r){const k=d.filter(A=>!s.includes(A));for(const A of k)c.push([A,r.getKeysForOverrideIdentifier(A)])}if(h){const k=s.filter(A=>!d.includes(A));for(const A of k)c.push([A,h.getKeysForOverrideIdentifier(A)])}if(r&&h){for(const k of s)if(d.includes(k)){const A=t({contents:h.getOverrideValue(void 0,k)||{},keys:h.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});c.push([k,[...A.added,...A.removed,...A.updated]])}}return{added:l,removed:i,updated:p,overrides:c}}function t(h,r){const l=h?r?h.keys.filter(c=>r.keys.indexOf(c)===-1):[...h.keys]:[],i=r?h?r.keys.filter(c=>h.keys.indexOf(c)===-1):[...r.keys]:[],p=[];if(h&&r){for(const c of r.keys)if(h.keys.indexOf(c)!==-1){const s=(0,L.getConfigurationValue)(r.contents,c),d=(0,L.getConfigurationValue)(h.contents,c);P.equals(s,d)||p.push(c)}}return{added:l,removed:i,updated:p}}}),define(Ce[94],Ie([1,0,12,3]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var y;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class N extends n.ErrorNoTelemetry{static isNotAvailable(_){return _ instanceof N&&_._code===y.NotAvailable}static isTemporarilyNotAvailable(_){return _ instanceof N&&_._code===y.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof N&&_._code===y.NoResolverFound}static isHandled(_){return _ instanceof N&&_.isHandled}constructor(_,I=y.Unknown,L){super(_),this._message=_,this._code=I,this._detail=L,this.isHandled=I===y.NotAvailable&&L===!0,Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N;function S(P){const _=P.indexOf("+");return _===-1?P:P.substring(0,_)}e.getRemoteAuthorityPrefix=S}),define(Ce[50],Ie([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(I){return I.scheme===n.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=C;function y(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=y;function N(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=N;function S(I){const{host:L,port:w}=_(I);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:w}}e.parseAuthorityWithPort=S;function P(I,L){let{host:w,port:f}=_(I);return typeof f>"u"&&(f=L),{host:w,port:f}}e.parseAuthorityWithOptionalPort=P;function _(I){const L=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const w=I.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const f=I.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:I,port:void 0}}}),define(Ce[25],Ie([1,0,10,3,50]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=N;function S(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var _;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,o){if(typeof a>"u"||a===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof a=="string"||typeof o=="string"){const u=typeof a=="string"?a:a.value,g=typeof o=="string"?o:o.value;return n.equalsIgnoreCase(u,g)}return a._lower===o._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=I;function L(m){return w(m)}e.isApplicationScopedExtension=L;function w(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function E(m,a){if(a){const o=`onResolveRemoteAuthority:${(0,y.getRemoteName)(a)}`;return m.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[167],Ie([1,0,21,51,2,34]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function S(I){if(n.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function P(I,L,w,f,E,m,a,o,u,g){const b=Object.create(null);b["common.machineId"]=a,b.sessionID=(0,N.generateUuid)()+Date.now(),b.commitHash=E,b.version=m,b["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,n.PlatformToString)(n.platform),b["common.nodePlatform"]=C.platform,b["common.nodeArch"]=f,b["common.product"]=g||"desktop",o&&(b["common.msftInternal"]=o);let R=0;const v=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),n.isLinuxSnap&&(b["common.snap"]="true");const t=S(w);t&&(b["common.platformDetail"]=t);try{const h=await I.readFile(y.URI.file(u));b["common.source"]=h.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=P;function _(I){const L=C.env.USERDNSDOMAIN;if(!L)return!1;const w=L.toLowerCase();return I.some(f=>w===f)}e.verifyMicrosoftInternalDomain=_}),define(Ce[168],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[52],Ie([1,0,22,9,4,41,50,167,168]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class I{constructor(c){this.value=c}}e.TelemetryTrustedValue=I;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,s){return Promise.resolve(void 0)}publicLog2(c,s){return this.publicLog(c,s)}publicLogError(c,s){return Promise.resolve(void 0)}publicLogError2(c,s){return this.publicLogError(c,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class w{async publicLog(c,s,d){}async publicLogError(c,s,d){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(p,c){return y.Event.debounce(c.onDidChangeConfiguration,(d,k)=>{const A=d?new Set([...d.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:A}},1e3,!0)(d=>{d.source!==7&&p.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(d.source),configurationKeys:R(d.affectedKeys)})})}e.configurationTelemetry=f;function E(p,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!p.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=E;function m(p,c){return!(c.isBuilt||c.disableTelemetry||p.enableTelemetry&&p.aiConfig?.ariaKey)}e.isLoggingOnly=m;function a(p){const c=p.getValue(_.TELEMETRY_SETTING_ID),s=p.getValue(_.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(p.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=a;function o(p){const c={},s={},d={};b(p,d);for(let k in d){k=k.length>150?k.substr(k.length-149):k;const A=d[k];typeof A=="number"?s[k]=A:typeof A=="boolean"?s[k]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${A.length}`),c[k]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(c[k]=A)}return{properties:c,measurements:s}}e.validateTelemetryData=o;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(p){if(!p)return"none";const c=(0,S.getRemoteName)(p);return u.has(c)?c:"other"}e.cleanRemoteAuthority=g;function b(p,c,s=0,d){if(!!p)for(const k of Object.getOwnPropertyNames(p)){const A=p[k],W=d?d+k:k;Array.isArray(A)?c[W]=(0,n.safeStringify)(A):A instanceof Date?c[W]=A.toISOString():(0,C.isObject)(A)?s<2?b(A,c,s+1,W+"."):c[W]=(0,n.safeStringify)(A):c[W]=A}}function R(p){if(!p)return[];const c=[];return v(c,"",p),c}function v(p,c,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(d=>v(p,c?`${c}.${d}`:d,s[d])):p.push(c)}function t(p,c){const s=p.msftInternalDomains||[],d=c.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(s)||d}e.isInternalTelemetry=t;function h(p){return[p.appRoot,p.extensionsPath,p.userHome.fsPath,p.tmpDir.fsPath,p.userDataPath]}e.getPiiPathsFromEnvironment=h;function r(p,c){if(!p||!p.includes("/")&&!p.includes("\\"))return p;let s=p;const d=[];for(const J of c)for(;;){const j=J.exec(p);if(!j)break;d.push([j.index,J.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let W=0;for(s="";;){const J=A.exec(p);if(!J)break;const j=d.some(([O,B])=>J.index<B&&O<A.lastIndex);!k.test(J[0])&&!j&&(s+=p.substring(W,J.index)+"<REDACTED: user-file-path>",W=A.lastIndex)}return W<p.length&&(s+=p.substr(W)),s}function l(p){if(!p)return p;const c=p.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of s)if(d.regex.test(c))return`<REDACTED: ${d.label}>`;return p}function i(p,c){return(0,n.cloneAndChange)(p,s=>{if(s instanceof I)return s.value;if(typeof s=="string"){let d=s.replaceAll("%20"," ");d=r(d,c);for(const k of c)d=d.replace(k,"");return d=l(d),d}})}e.cleanData=i}),define(Ce[169],Ie([1,0,10,90,25,21,2,12,51,52]),function(te,e,n,C,y,N,S,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(r,l){return r.uuid&&l.uuid?r.uuid===l.uuid:r.id===l.id?!0:(0,n.compareIgnoreCase)(r.id,l.id)===0}e.areSameExtensions=L;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(l){const i=l.manifest?l.manifest.version:l.version,p=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new f(l.identifier,i,p)}static parse(l){const i=w.exec(l);return i&&i[1]&&i[2]?new f({id:i[1]},i[2],i[4]||void 0):null}constructor(l,i,p="undefined"){this.version=i,this.targetPlatform=p,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof f?L(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=f;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const l=E.exec(r);return l&&l[1]?[o(l[1]),l[2]]:[o(r),void 0]}e.getIdAndVersion=m;function a(r,l){return`${r}.${l}`}e.getExtensionId=a;function o(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function u(r,l){return o(a(r,l))}e.getGalleryExtensionId=u;function g(r,l){const i=[],p=c=>{for(const s of i)if(s.some(d=>L(l(d),l(c))))return s;return null};for(const c of r){const s=p(c);s?s.push(c):i.push([c])}return i}e.groupByExtension=g;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function R(r){return{id:new I.TelemetryTrustedValue(r.identifier.id),name:new I.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=R,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function v(r,l){const i=[],p=l.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const c=p.shift();if(c&&i.every(s=>!L(s.identifier,{id:c}))){const s=r.filter(d=>L(d.identifier,{id:c}));s.length===1&&(i.push(s[0]),p.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=v;async function t(r,l){if(!N.isLinux)return!1;let i;try{i=(await r.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await r.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){l.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function h(r,l){const i=await t(r,l),p=(0,C.getTargetPlatform)(i?"alpine":N.platform,_.arch);return l.debug("ComputeTargetPlatform:",p),p}e.computeTargetPlatform=h}),define(Ce[170],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=n;function C(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=C;function y(S){return Array.from(S.entries()).map(P=>[P[0],n(P[1].map)])}e.serializeEnvironmentVariableCollections=y;function N(S){return new Map(S.map(P=>[P[0],{map:C(P[1])}]))}e.deserializeEnvironmentVariableCollections=N}),define(Ce[171],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,N,S=5){const P=N(_=>{const I=typeof _=="string"?_:_.data;let L=this._terminalBufferMap.get(y);if(L){L.data.push(I);return}const w=setTimeout(()=>this.flushBuffer(y),S);L={data:[I],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(y),P.dispose()}},this._terminalBufferMap.set(y,L)});return P}stopBuffering(y){this._terminalBufferMap.get(y)?.dispose()}flushBuffer(y){const N=this._terminalBufferMap.get(y);N&&(this._terminalBufferMap.delete(y),this._callback(y,N.data.join("")))}}e.TerminalDataBufferer=n}),define(Ce[172],Ie([1,0,17,84,38,4,9,2,137,68,30]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(R){function v(t,h){let r=t.defaults;for(;y.ThemeIcon.isThemeIcon(r);){const l=m.getIcon(r.id);if(!l)return;r=l.defaults}return r}R.getDefinition=v})(w=e.IconContribution||(e.IconContribution={}));var f;(function(R){function v(h){return{weight:h.weight,style:h.style,src:h.src.map(r=>({format:r.format,location:r.location.toString()}))}}R.toJSONObject=v;function t(h){const r=l=>(0,S.isString)(l)?l:void 0;if(h&&Array.isArray(h.src)&&h.src.every(l=>(0,S.isString)(l.format)&&(0,S.isString)(l.location)))return{weight:r(h.weight),style:r(h.style),src:h.src.map(l=>({format:l.format,location:P.URI.parse(l.location)}))}}R.fromJSONObject=t})(f=e.IconFontDefinition||(e.IconFontDefinition={}));class E{constructor(){this._onDidChange=new N.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,_.localize)(0,null)},fontCharacter:{type:"string",description:(0,_.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,t,h,r){const l=this.iconsById[v];if(l){if(h&&!l.description){l.description=h,this.iconSchema.properties[v].markdownDescription=`${h} $(${v})`;const c=this.iconReferenceSchema.enum.indexOf(v);c!==-1&&(this.iconReferenceSchema.enumDescriptions[c]=h),this._onDidChange.fire()}return l}const i={id:v,description:h,defaults:t,deprecationMessage:r};this.iconsById[v]=i;const p={$ref:"#/definitions/icons"};return r&&(p.deprecationMessage=r),h&&(p.markdownDescription=`${h}: $(${v})`),this.iconSchema.properties[v]=p,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(h||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const t=this.iconReferenceSchema.enum.indexOf(v);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,t){const h=this.iconFontsById[v];return h||(this.iconFontsById[v]=t,this._onDidChange.fire(),t)}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(l,i)=>l.id.localeCompare(i.id),t=l=>{for(;y.ThemeIcon.isThemeIcon(l.defaults);)l=this.iconsById[l.defaults.id];return`codicon codicon-${l?l.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(l=>this.iconsById[l]);for(const l of r.filter(i=>!!i.description).sort(v))h.push(`|<i class="${t(l)}"></i>|${l.id}|${y.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const l of r.filter(i=>!y.ThemeIcon.isThemeIcon(i.defaults)).sort(v))h.push(`|<i class="${t(l)}"></i>|${l.id}|`);return h.join(`
`)}}const m=new E;L.Registry.add(e.Extensions.IconContribution,m);function a(R,v,t,h){return m.registerIcon(R,v,t,h)}e.registerIcon=a;function o(){return m}e.getIconRegistry=o;function u(){const R=(0,C.getCodiconFontCharacters)();for(const v in R){const t="\\"+R[v].toString(16);m.registerIcon(v,{fontCharacter:t})}}u(),e.iconsSchemaId="vscode://schemas/icons";const g=L.Registry.as(I.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,m.getIconSchema());const b=new n.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);m.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=a("widget-close",C.Codicon.close,(0,_.localize)(2,null)),e.gotoPreviousLocation=a("goto-previous-location",C.Codicon.arrowUp,(0,_.localize)(3,null)),e.gotoNextLocation=a("goto-next-location",C.Codicon.arrowDown,(0,_.localize)(4,null)),e.syncing=y.ThemeIcon.modify(C.Codicon.sync,"spin"),e.spinningLoading=y.ThemeIcon.modify(C.Codicon.loading,"spin")}),define(Ce[173],Ie([1,0,4,41,3,11]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var S;(function(a){a.Http="http",a.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=w;function f(a,o,u,g){if(u===1)return!1;if(u===2&&w(o)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(b?.length===4&&parseInt(b[1])>=18)return!1}return a<1024}e.isPortPrivileged=f;class E{constructor(o,u,g){this.remoteAddress=o,this.localAddress=u,this._dispose=g,this._onDispose=new n.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let m=class{constructor(o,u){this.logService=o,this.configurationService=u,this._onTunnelOpened=new n.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new n.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new n.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],u=Array.from(this._tunnels.values());for(const g of u){const b=Array.from(g.values());for(const R of b){const v=await R.value;v&&o.push(v)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:u}of o.values())await u.then(g=>g?.dispose());o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,u,g,b,R){this.addTunnelToMap(o,u,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:u,localAddress:g,privacy:b,protocol:R,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,u){(w(o)||L(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const g=this.getTunnelFromMap(o,u);if(g)return++g.refcount,g.value}openTunnel(o,u,g,b,R,v=!1,t,h){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${R}.`),!o)return;if(u||(u="localhost"),b||(b=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(o,u,g,b,R,v,t,h);return r?r.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(l);return(l.tunnelRemoteHost!==u||l.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const u=this._tunnels.get(o.tunnelRemoteHost);if(u){const g=u.get(o.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,g))}}}}async tryDisposeTunnel(o,u,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${u}.`);const b=g.value.then(async R=>{R&&(await R.dispose(!0),this._onTunnelClosed.fire({host:R.tunnelRemoteHost,port:R.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(u),b}}async closeTunnel(o,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${u} `);const g=this._tunnels.get(o);if(g&&g.has(u)){const b=g.get(u);b.refcount=0,await this.tryDisposeTunnel(o,u,b)}}addTunnelToMap(o,u,g){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(u,{refcount:1,value:g})}async removeEmptyTunnelFromMap(o,u){const g=this._tunnels.get(o);g&&(await g.get(u)||g.delete(u),g.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,u){const g=[o];L(o)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(o)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const b=g.map(R=>this._tunnels.get(R));for(const R of b){const v=R?.get(u);if(v)return v}}canTunnel(o){return!!I(o)}createWithProvider(o,u,g,b,R,v,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${b}.`);const h=g;this._factoryInProgress.add(h);const r=b===void 0?g:b,l={elevationRequired:R?this.isPortPrivileged(r):!1},i={remoteAddress:{host:u,port:g},localAddressPort:b,privacy:v,public:v?v!==P.Private:void 0,protocol:t},p=o.forwardPort(i,l);return p?(this.addTunnelToMap(u,g,p),p.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(h)})):this._factoryInProgress.delete(h),p}};m=Ve([He(0,N.ILogService),He(1,C.IConfigurationService)],m),e.AbstractTunnelService=m}),define(Ce[174],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var C;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(C=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ce[175],Ie([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(_){return _.scheme!==n.Schemas.file&&_.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=C;function y(_){if(_.folders.length)return _.folders.every(I=>C(I.uri))?_.folders[0].uri:void 0;if(_.configuration&&C(_.configuration))return _.configuration}e.getVirtualWorkspaceLocation=y;function N(_){return y(_)?.scheme}e.getVirtualWorkspaceScheme=N;function S(_){return y(_)?.authority}e.getVirtualWorkspaceAuthority=S;function P(_){return y(_)!==void 0}e.isVirtualWorkspace=P}),define(Ce[53],Ie([1,0,138,19,48,24,2,3,15]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function I(r){const l=r;return typeof l?.id=="string"&&S.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=I;function L(r){return typeof r?.id=="string"&&!I(r)&&!f(r)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(r,l){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,C.basename)(r)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const i=r;return i.configuration?{id:i.id,configPath:i.configuration}:i.folders.length===1?{id:i.id,uri:i.folders[0].uri}:{id:i.id}}e.toWorkspaceIdentifier=w;function f(r){const l=r;return typeof l?.id=="string"&&S.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=f;function E(r){const l=r;if(l?.uri)return{id:l.id,uri:S.URI.revive(l.uri)};const i=r;if(i?.configPath)return{id:i.id,configPath:S.URI.revive(i.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=E;var m;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function a(r){const l=r;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=a;function o(r){const l=r;return!!(l&&typeof l=="object"&&S.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=o;class u{constructor(l,i,p,c,s){this._id=l,this._transient=p,this._configuration=c,this._ignorePathCasing=s,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l)||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(l,i){this.raw=i,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,N.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function b(r){return new g({uri:r,index:0,name:(0,N.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function R(r,l){return N.extUriBiasedIgnorePathCase.isEqualOrParent(r,l.untitledWorkspacesHome)}e.isUntitledWorkspace=R;function v(r){let l;return S.URI.isUri(r)?l=r:l=r.configuration,l?.scheme===_.Schemas.tmp}e.isTemporaryWorkspace=v;function t(r,l){return!R(r,l)&&!v(r)}e.isSavedWorkspace=t;function h(r){return(typeof r=="string"?(0,C.extname)(r):(0,N.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=h}),define(Ce[54],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const N=this._idPool++;return this._data.set(N,y),this.logDebugInfo(),N}get(y,N){return this._data.has(y)?this._data.get(y)[N]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!n.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}n.enableDebugLogging=!1,e.Cache=n}),define(Ce[36],Ie([1,0,15,24,3]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this._systemSchemes=new Set(Object.keys(n.Schemas)),this._providerInfo=new Map,this.extUri=new C.ExtUri(P=>{const _=this._providerInfo.get(P.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(P,_){_===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,_)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Ce[176],Ie([1,0,11,162,26]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let N=class extends C.LogService{constructor(P,_){super(P.createLogger(_.logFile,{name:_.logName}))}};N=Ve([He(0,n.ILoggerService),He(1,y.IExtHostInitDataService)],N),e.ExtHostLogService=N}),define(Ce[177],Ie([1,0,17]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(S,P,_){this._deferredPromises=new Map,this._id=S,this._shared=P,this._storage=_,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new n.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of I.values())L.complete()}catch(L){for(const w of I.values())w.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this._init}get(S,P){let _=this._value[S];return typeof _>"u"&&(_=P),_}update(S,P){this._value[S]=P;const _=this._deferredPromises.get(S);if(_!==void 0)return _.p;const I=new n.DeferredPromise;return this._deferredPromises.set(S,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=C;class y extends C{setKeysForSync(S){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},S)}constructor(S,P){super(S.identifier.value,!0,P),this._extension=S}}e.ExtensionGlobalMemento=y}),define(Ce[178],Ie([1,0,4,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(S){this._notebooksAndEditors=S,this._onDidSaveNotebookDocument=new n.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new n.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(S,P,_,I){const w=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(S)).acceptModelChanged(P.value,_,I);this._onDidChangeNotebookDocument.fire(w)}$acceptDirtyStateChanged(S,P){this._notebooksAndEditors.getNotebookDocument(C.URI.revive(S)).acceptDirty(P)}$acceptModelSaved(S){const P=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(S));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ce[18],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class C{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[179],Ie([1,0,25,4]),function(te,e,n,C){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(P,_){y.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=n.ExtensionIdentifier.toKey(P.identifier),Je(this,y,_,"f"),Oe(this,y,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(P){return Oe(this,y,"f").get(this._id,P)}store(P,_){return Oe(this,y,"f").store(this._id,P,_)}delete(P){return Oe(this,y,"f").delete(this._id,P)}}e.ExtensionSecrets=N,y=new WeakMap}),define(Ce[69],Ie([1,0,3,173,4,18]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(_){function I(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:w.protocol}}_.fromApiTunnel=I;function L(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==C.TunnelPrivacyId.ConstantPrivate&&w.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}_.fromServiceTunnel=L})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let P=class{constructor(I){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,w,f,E){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Ve([He(0,N.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(Ce[55],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class C{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=C}),define(Ce[180],Ie([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(_){let I=this.buffers.indexOf(_);return I<0&&(I=this.buffers.length,this.buffers.push(_)),I}}function y(P,_){if(_.serializeBuffersForPostMessage){const I=new C,L=(E,m)=>{if(m instanceof ArrayBuffer){const a=I.add(m);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(m)){const a=N(m);if(a){const o=I.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:a,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},w=JSON.stringify(P,L),f=I.buffers.map(E=>{const m=new Uint8Array(E);return n.VSBuffer.wrap(m)});return{message:w,buffers:f}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=y;function N(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(P,_){const I=_.map(f=>{const E=new ArrayBuffer(f.byteLength);return new Uint8Array(E).set(f.buffer),E}),L=_.length?(f,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const m=E,{index:a}=m,o=I[a];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return E}:void 0;return{message:JSON.parse(P,L),arrayBuffers:I}}e.deserializeWebviewMessage=S}),define(Ce[95],Ie([1,0,147,9,2,6,3,30,43,15,39,124,29]),function(te,e,n,C,y,N,S,P,_,I,L,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var E;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(E=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function a(Q){const K=Q;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.isEditorPaneWithSelection=a;function o(Q,K,Z){for(const he of Z.visibleEditorPanes)if(he.group.id===K&&Q.matches(he.input))return he.getViewState()}e.findViewStateForEditor=o;function u(Q){if(s(Q))return!1;const K=Q;return y.URI.isUri(K?.resource)}e.isResourceEditorInput=u;function g(Q){if(s(Q))return!1;const K=Q;return K?.original!==void 0&&K.modified!==void 0}e.isResourceDiffEditorInput=g;function b(Q){if(s(Q)||g(Q))return!1;const K=Q;return K?.primary!==void 0&&K.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function R(Q){if(s(Q))return!1;const K=Q;return K?K.resource===void 0||K.resource.scheme===I.Schemas.untitled||K.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=R;const v=/Untitled-\d+/;function t(Q){return Q.scheme===I.Schemas.untitled&&Q.path.length>1&&!v.test(Q.path)}e.isUntitledWithAssociatedResource=t;function h(Q){if(s(Q))return!1;const K=Q;return y.URI.isUri(K?.base?.resource)&&y.URI.isUri(K?.input1?.resource)&&y.URI.isUri(K?.input2?.resource)&&y.URI.isUri(K?.result?.resource)}e.isResourceMergeEditorInput=h;var r;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var l;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.mapIdToSaveSource=new Map}registerSource(K,Z){let he=this.mapIdToSaveSource.get(K);return he||(he={source:K,label:Z},this.mapIdToSaveSource.set(K,he)),he.source}getSourceLabel(K){return this.mapIdToSaveSource.get(K)?.label??K}}e.SaveSourceRegistry=new i;var p;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors"})(p=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class c extends N.Disposable{}e.AbstractEditorInput=c;function s(Q){return Q instanceof c}e.isEditorInput=s;function d(Q){const K=Q;return y.URI.isUri(K?.preferredResource)}function k(Q){const K=Q;return s(K?.primary)&&s(K?.secondary)}e.isSideBySideEditorInput=k;function A(Q){const K=Q;return s(K?.modified)&&s(K?.original)}e.isDiffEditorInput=A;function W(Q,K,Z,he,ke){return se(he,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const Fe={...Z,limits:{size:Number.MAX_VALUE}};Q.openEditor(K,Fe)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>ke.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.createTooLargeFileError=W;function J(Q){return s(Q?.editor)}e.isEditorInputWithOptions=J;function j(Q){const K=Q;return J(Q)&&K?.group!==void 0}e.isEditorInputWithOptionsAndGroup=j;function O(Q){const K=Q;return typeof K?.groupId=="number"&&s(K.editor)}e.isEditorIdentifier=O;var B;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var T;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LOCKED=2]="GROUP_LOCKED",Q[Q.EDITOR_OPEN=3]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=4]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=5]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=7]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=9]="EDITOR_PIN",Q[Q.EDITOR_STICKY=10]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=11]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(K,Z){if(!K)return;if(h(K))return e.EditorResourceAccessor.getOriginalUri(K.result,Z);if(Z?.supportSideBySide){const{primary:ke,secondary:Fe}=this.getSideEditors(K);if(ke&&Fe){if(Z?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(ke,{filterByScheme:Z.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===F.ANY)return this.getOriginalUri(ke,{filterByScheme:Z.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:Z.filterByScheme});K=Z.supportSideBySide===F.PRIMARY?ke:Fe}}if(g(K)||b(K)||h(K))return;const he=d(K)?K.preferredResource:K.resource;return!he||!Z||!Z.filterByScheme?he:this.filterUri(he,Z.filterByScheme)}getSideEditors(K){return k(K)||b(K)?{primary:K.primary,secondary:K.secondary}:A(K)||g(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,Z){if(!K)return;if(h(K))return e.EditorResourceAccessor.getCanonicalUri(K.result,Z);if(Z?.supportSideBySide){const{primary:ke,secondary:Fe}=this.getSideEditors(K);if(ke&&Fe){if(Z?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(ke,{filterByScheme:Z.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===F.ANY)return this.getCanonicalUri(ke,{filterByScheme:Z.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:Z.filterByScheme});K=Z.supportSideBySide===F.PRIMARY?ke:Fe}}if(g(K)||b(K)||h(K))return;const he=K.resource;return!he||!Z||!Z.filterByScheme?he:this.filterUri(he,Z.filterByScheme)}filterUri(K,Z){if(Array.isArray(Z)){if(Z.some(he=>K.scheme===he))return K}else if(Z===K.scheme)return K}}e.EditorResourceAccessor=new z;var H;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(H=e.CloseDirection||(e.CloseDirection={}));class de{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(K){const Z=this.instantiationService=K.get(S.IInstantiationService);for(const[he,ke]of this.editorSerializerConstructors)this.createEditorSerializer(he,ke,Z);this.editorSerializerConstructors.clear()}createEditorSerializer(K,Z,he){const ke=he.createInstance(Z);this.editorSerializerInstances.set(K,ke)}registerFileEditorFactory(K){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=K}getFileEditorFactory(){return(0,C.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(K,Z){if(this.editorSerializerConstructors.has(K)||this.editorSerializerInstances.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.instantiationService?this.createEditorSerializer(K,Z,this.instantiationService):this.editorSerializerConstructors.set(K,Z),(0,N.toDisposable)(()=>{this.editorSerializerConstructors.delete(K),this.editorSerializerInstances.delete(K)})}getEditorSerializer(K){return this.editorSerializerInstances.get(typeof K=="string"?K:K.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new de);async function pe(Q,K,Z){return!Q||!Q.length?[]:await Promise.all(Q.map(async he=>{const ke=y.URI.revive(he.fileUri);if(!ke){Z.info("Cannot resolve the path because it is not valid.",he);return}if(!await K.canHandleResource(ke)){Z.info("Cannot resolve the path because it cannot be handled",he);return}let je=he.exists,Te=he.type;if(typeof je!="boolean"||typeof Te!="number")try{Te=(await K.stat(ke)).isDirectory?_.FileType.Directory:_.FileType.Unknown,je=!0}catch(De){Z.error(De),je=!1}if(!je&&he.openOnlyIfExists){Z.info("Cannot resolve the path because it does not exist",he);return}if(Te===_.FileType.Directory){Z.info("Cannot resolve the path because it is a directory",he);return}const Se={...he.options,pinned:!0};return je?{resource:ke,options:Se}:{resource:ke,options:Se,forceUntitled:!0}}))}e.pathsToEditors=pe;var re;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(re=e.EditorsOrder||(e.EditorsOrder={}));function le(Q){const K=Q;if(!K)return!1;const Z=K;if(Z.modified)return le(Z.modified);const he=K;return!!(he.contributionsState&&he.viewState&&Array.isArray(he.cursorState))}e.isTextEditorViewState=le;function ae(Q){return(0,L.isErrorWithActions)(Q)}e.isEditorOpenError=ae;function se(Q,K,Z){const he=(0,L.createErrorWithActions)(Q,K);return he.forceMessage=Z?.forceMessage,he.forceSeverity=Z?.forceSeverity,he.allowDialog=Z?.allowDialog,he}e.createEditorOpenError=se}),define(Ce[181],Ie([1,0,4,148,3,6,28,30,16,62,22,84,172]),function(te,e,n,C,y,N,S,P,_,I,L,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",w.Codicon.window,(0,C.localize)(0,null));var E;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(E=e.Extensions||(e.Extensions={}));var m;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function a(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=a;class o extends N.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new n.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new n.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,_.flatten)([...this.viewContainers.values()])}registerViewContainer(l,i,p){const c=this.get(l.id);if(c)return c;const s=l;return s.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,S.getOrSet)(this.viewContainers,i,[]).push(s),p?.isDefault&&this.defaultViewContainers.push(s),this._onDidRegister.fire({viewContainer:s,viewContainerLocation:i}),s}deregisterViewContainer(l){for(const i of this.viewContainers.keys()){const p=this.viewContainers.get(i),c=p?.indexOf(l);if(c!==-1){p?.splice(c,1),p.length===0&&this.viewContainers.delete(i),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:i});return}}}get(l){return this.all.filter(i=>i.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(i=>this.getViewContainers(i).filter(p=>p?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(i=>this.getViewContainerLocation(i)===l)}}P.Registry.add(E.ViewContainersRegistry,new o);var u;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function g(r,l){const i=r.group??u.More,p=l.group??u.More;return i!==p?i.localeCompare(p):(r.order??5)-(l.order??5)}class b extends N.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new n.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new n.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new n.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new n.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new I.SetMap}registerViews(l,i){this.registerViews2([{views:l,viewContainer:i}])}registerViews2(l){l.forEach(({views:i,viewContainer:p})=>this.addViews(i,p)),this._onViewsRegistered.fire(l)}deregisterViews(l,i){const p=this.removeViews(l,i);p.length&&this._onViewsDeregistered.fire({views:p,viewContainer:i})}moveViews(l,i){for(const p of this._views.keys())if(p!==i){const c=this.removeViews(l,p);c.length&&(this.addViews(c,i),this._onDidChangeContainer.fire({views:c,from:p,to:i}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const i of this._viewContainers){const p=(this._views.get(i)||[]).filter(c=>c.id===l)[0];if(p)return p}return null}getViewContainer(l){for(const i of this._viewContainers)if((this._views.get(i)||[]).filter(c=>c.id===l)[0])return i;return null}registerViewWelcomeContent(l,i){return this._viewWelcomeContents.add(l,i),this._onDidChangeViewWelcomeContent.fire(l),(0,N.toDisposable)(()=>{this._viewWelcomeContents.delete(l,i),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,i){const p=new Map;for(const[c,s]of i)this._viewWelcomeContents.add(l,s),p.set(c,(0,N.toDisposable)(()=>{this._viewWelcomeContents.delete(l,s),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),p}getViewWelcomeContent(l){const i=[];return this._viewWelcomeContents.forEach(l,p=>i.push(p)),i.sort(g)}addViews(l,i){let p=this._views.get(i);p||(p=[],this._views.set(i,p),this._viewContainers.push(i));for(const c of l){if(this.getView(c.id)!==null)throw new Error((0,C.localize)(1,null,c.id));p.push(c)}}removeViews(l,i){const p=this._views.get(i);if(!p)return[];const c=[],s=[];for(const d of p)l.includes(d)?c.push(d):s.push(d);return c.length&&(s.length?this._views.set(i,s):(this._views.delete(i),this._viewContainers.splice(this._viewContainers.indexOf(i),1))),c}}P.Registry.add(E.ViewsRegistry,new b),e.IViewsService=(0,y.createDecorator)("viewsService"),e.IViewDescriptorService=(0,y.createDecorator)("viewDescriptorService");var R;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(R=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(l,i){this.resolved=!1,this._hasResolve=!1,(0,L.mixin)(this,l),this._hasResolve=!!i,this.resolve=async p=>{if(i&&!this.resolved){const c=await i(p);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}p.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class h extends Error{constructor(l){super((0,C.localize)(2,null,l))}}e.NoTreeViewError=h}),define(Ce[182],Ie([1,0,4,17,149]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new n.Emitter,this._onExit=new n.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,_,I,L){const w={command:P};if(_&&Object.keys(_).length>0&&(w.arguments=_),this.internalSend("request",w),typeof L=="number"){const f=setTimeout(()=>{clearTimeout(f);const E=this.pendingRequests.get(w.seq);if(E){this.pendingRequests.delete(w.seq);const m={type:"response",seq:0,request_seq:w.seq,success:!1,command:P,message:(0,y.localize)(0,null,L,P)};E(m)}},L)}return I&&this.pendingRequests.set(w.seq,I),w.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,_){return P.type!=="event"||_.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,C.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const _=P,I=this.pendingRequests.get(_.request_seq);I&&(this.pendingRequests.delete(_.request_seq),I(_));break}}}}internalSend(P,_){_.type=P,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((_,I)=>P.set(I,_)),await(0,C.timeout)(500),P.forEach((_,I)=>{_({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=N}),define(Ce[183],Ie([1,0,150,42,3]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new C.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const N=f=>n.localize(51,null,f);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var S;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(S=e.State||(e.State={}));function P(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var _;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(_=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var w;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[184],Ie([1,0,10,2,19,22,15,44,20,16]),function(te,e,n,C,y,N,S,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function w(c,s,d){return c.replace(L,function(k,A){return s&&A.length>0&&A[0]!=="_"?k:d&&d.hasOwnProperty(A)?d[A]:k})}e.formatPII=w;function f(c){const s={};for(const d of Object.keys(c))d.startsWith("!")||(s[d]=c[d]);return s}e.filterExceptionsFromTelemetry=f;function E(c){return c.configuration.request==="attach"&&!m(c)&&(!c.parentSession||E(c.parentSession))}e.isSessionAttach=E;function m(c){let s=c.configuration.type;if(!!s)return s==="vslsShare"&&(s=c.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(s,"extensionhost")||(0,n.equalsIgnoreCase)(s,"pwa-extensionhost")?c:c.parentSession?m(c.parentSession):void 0}e.getExtensionHostDebugSession=m;function a(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=a;function o(c,s,d){let k,A=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let J=null;for(;J=W.exec(c);){const j=J.index+1,O=j+J[0].length;if(j<=s&&O>=d){k=J[0],A=j;break}}if(k){const j=/\w+/g;let O=null;for(;(O=j.exec(k))&&!(O.index+1+A+O[0].length>=d););O&&(k=k.substring(0,j.lastIndex))}return k?{start:A,end:A+k.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=o;async function u(c,s,d,k){if(c.evaluatableExpressionProvider.has(s)){const A=c.evaluatableExpressionProvider.ordered(s),W=(0,I.coalesce)(await Promise.all(A.map(async J=>{try{return await J.provideEvaluatableExpression(s,d,k??_.CancellationToken.None)}catch{return}})));if(W.length>0){let J=W[0].expression;const j=W[0].range;return J||(J=s.getLineContent(d.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:J}}}else{const A=s.getLineContent(d.lineNumber),{start:W,end:J}=o(A,d.column,d.column),j=A.substring(W-1,J);return{matchingExpression:j,range:new P.Range(d.lineNumber,W,d.lineNumber,W+j.length)}}return null}e.getEvaluatableExpressionAtPosition=u;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(c){return!!(c&&c.match(g))}e.isUri=b;function R(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(b(c.path))return C.URI.parse(c.path);if((0,y.isAbsolute)(c.path))return C.URI.file(c.path)}return c.path}function v(c){if(typeof c.path=="object"){const s=C.URI.revive(c.path);if(s)return s.scheme===S.Schemas.file?s.fsPath:s.toString()}return c.path}function t(c,s){const d=s?R:v,k=(0,N.deepClone)(c);return r(k,(A,W)=>{A&&W&&(W.path=d(W))}),k}e.convertToDAPaths=t;function h(c,s){const d=s?R:v,k=(0,N.deepClone)(c);return r(k,(A,W)=>{!A&&W&&(W.path=d(W))}),k}e.convertToVSCPaths=h;function r(c,s){switch(c.type){case"event":{const d=c;switch(d.event){case"output":s(!1,d.body.source);break;case"loadedSource":s(!1,d.body.source);break;case"breakpoint":s(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=c;switch(d.command){case"setBreakpoints":s(!0,d.arguments.source);break;case"breakpointLocations":s(!0,d.arguments.source);break;case"source":s(!0,d.arguments.source);break;case"gotoTargets":s(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(k=>s(!1,k));break;default:break}break}case"response":{const d=c;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(k=>s(!1,k.source));break;case"loadedSources":d.body.sources.forEach(k=>s(!1,k));break;case"scopes":d.body.scopes.forEach(k=>s(!1,k.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(k=>s(!1,k.source));break;case"setBreakpoints":d.body.breakpoints.forEach(k=>s(!1,k.source));break;case"disassemble":d.body?.instructions.forEach(A=>s(!1,A.location));break;default:break}break}}}function l(c){return c.filter(s=>!s.presentation?.hidden).sort((s,d)=>s.presentation?d.presentation?s.presentation.group?d.presentation.group?s.presentation.group!==d.presentation.group?s.presentation.group.localeCompare(d.presentation.group):i(s.presentation.order,d.presentation.order):-1:d.presentation.group?1:i(s.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.getVisibleAndSorted=l;function i(c,s){return typeof c!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:c-s}async function p(c,s){const d=c.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(d!=="none"&&(await s.saveAll(),d==="allEditorsInActiveGroup")){const k=s.activeEditorPane;k&&k.input.resource?.scheme===S.Schemas.untitled&&await s.save({editor:k.input,groupId:k.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=p}),define(Ce[70],Ie([1,0,23,35,185,64,15,19,21,42]),function(te,e,n,C,y,N,S,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json",N.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var f;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var g;(function(F){F.scheme=S.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${z.join("")}]+`),de=7;function pe(K,Z){const he=Z.toString(de),Fe=`${he.length<z.length?z[he.length-1]:"z"}${he}s${(0,n.encodeBase64)(n.VSBuffer.fromString(K.scheme),!0,!0)}`;return K.with({scheme:F.scheme,fragment:Fe})}F.generate=pe;function re(K){if(K.scheme!==F.scheme)return;const Z=K.fragment.indexOf("s");if(Z<0)return;const he=parseInt(K.fragment.substring(0,Z).replace(H,""),de),ke=(0,n.decodeBase64)(K.fragment.substring(Z+1)).toString();if(!isNaN(he))return{handle:he,notebook:K.with({scheme:ke,fragment:null})}}F.parse=re;function le(K,Z){return K.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${Z??""},${K.scheme!==S.Schemas.file?K.scheme:""}`})}F.generateCellOutputUri=le;function ae(K){if(K.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const Z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(K.fragment);if(!Z)return;const he=Z[1]&&Z[1]!==""?Z[1]:void 0,ke=Z[2];return{outputId:he,notebook:K.with({scheme:ke||S.Schemas.file,fragment:null})}}F.parseCellOutputUri=ae;function se(K,Z,he){return F.generate(K,Z).with({scheme:he})}F.generateCellPropertyUri=se;function Q(K,Z){if(K.scheme===Z)return F.parse(K.with({scheme:F.scheme}))}F.parseCellPropertyUri=Q})(g=e.CellUri||(e.CellUri={}));const b=F=>_.isWindows?F.replace(/\//g,"\\"):F;class R{constructor(z=[],H=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=H,this.order=[...new Set(z)].map(de=>({pattern:de,matches:C.parse(b(de))}))}sort(z){const H=new Map(y.Iterable.map(z,pe=>[pe,b(pe)]));let de=[];for(const{matches:pe}of this.order)for(const[re,le]of H)if(pe(le)){de.push(re),H.delete(re);break}return H.size&&(de=de.concat([...H.keys()].sort((pe,re)=>this.defaultOrder.indexOf(pe)-this.defaultOrder.indexOf(re)))),de}prioritize(z,H){const de=this.findIndex(z);if(de===-1){this.order.unshift({pattern:z,matches:C.parse(b(z))});return}const pe=new Set(H.map(le=>this.findIndex(le,de)));pe.delete(-1);const re=Array.from(pe).sort();this.order.splice(de+1,0,...re.map(le=>this.order[le]));for(let le=re.length-1;le>=0;le--)this.order.splice(re[le],1)}toArray(){return this.order.map(z=>z.pattern)}findIndex(z,H=this.order.length){const de=b(z);for(let pe=0;pe<H;pe++)if(this.order[pe].matches(de))return pe;return-1}}e.MimeTypeDisplayOrder=R;function v(F,z,H,de=(pe,re)=>pe===re){const pe=[];function re(se,Q,K){if(Q===0&&K.length===0)return;const Z=pe[pe.length-1];Z&&Z.start+Z.deleteCount===se?(Z.deleteCount+=Q,Z.toInsert.push(...K)):pe.push({start:se,deleteCount:Q,toInsert:K})}let le=0,ae=0;for(;;){if(le===F.length){re(le,0,z.slice(ae));break}if(ae===z.length){re(le,F.length-le,[]);break}const se=F[le],Q=z[ae];if(de(se,Q)){le+=1,ae+=1;continue}H(Q)?(re(le,1,[]),le+=1):(re(le,0,[Q]),ae+=1)}return pe}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(F){F.default="default",F.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(F){const z=F;return!!((typeof z.include=="string"||C.isRelativePattern(z.include))&&(typeof z.exclude=="string"||C.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=h;function r(F,z,H){if(Array.isArray(F.viewType)&&F.viewType.indexOf(z)>=0||F.viewType===z)return!0;if(F.filenamePattern){const de=h(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,pe=h(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(C.match(de,(0,P.basename)(H.fsPath).toLowerCase()))return!(pe&&C.match(pe,(0,P.basename)(H.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var l;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class i{static create(z){return`${i._prefix}${z}`}static parse(z){if(z.startsWith(i._prefix))return z.substring(i._prefix.length)}}i._prefix="notebook/",e.NotebookWorkingCopyTypeIdentifier=i;function p(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=p;const c=new TextDecoder;function s(F){const z=[];let H=!1;for(const de of F)(z.length===0||H)&&(z.push(de),H=!0);return W(z),T(n.VSBuffer.concat(z.map(de=>n.VSBuffer.wrap(de))))}e.compressOutputItemStreams=s;const d=`${String.fromCharCode(27)}[A`,k=d.split("").map(F=>F.charCodeAt(0)),A=10;function W(F){F.forEach((z,H)=>{if(H===0||z.length<d.length)return;const de=F[H-1],pe=z.subarray(0,d.length);if(pe[0]===k[0]&&pe[1]===k[1]&&pe[2]===k[2]){const re=de.lastIndexOf(A);if(re===-1)return;F[H-1]=de.subarray(0,re),F[H]=z.subarray(d.length)}})}function J(F){let z=F;do F=z,z=F.replace(/[^\n]\x08/gm,"");while(z.length<F.length);return F}function j(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const z=F.match(/^(.*)\r+/m)[1];let H=F.match(/\r+(.*)$/m)[1];H=H+z.slice(H.length,z.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return F}const O="\b".charCodeAt(0),B="\r".charCodeAt(0);function T(F){return!F.buffer.includes(O)&&!F.buffer.includes(B)?F:n.VSBuffer.fromString(j(J(c.decode(F.buffer))))}}),define(Ce[186],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Ce[45],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(N){N.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(S,P,_=S.parent){if(S._isRoot)return new y([P]);const I=[S.id];for(let L=_;L&&L.id!==P;L=L.parent)I.push(L.id);return I.push(P),new y(I.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const P=S.indexOf("\0");return P===-1?S:S.slice(0,P)}static fromString(S){return new y(S.split("\0"))}static join(S,P){return new y([...S.path,P])}static joinToString(S,P){return S.toString()+"\0"+P}static parentId(S){const P=S.lastIndexOf("\0");return P===-1?void 0:S.slice(0,P)}static localId(S){const P=S.lastIndexOf("\0");return P===-1?S:S.slice(P+1)}static compare(S,P){return S===P?0:P.startsWith(S+"\0")?2:S.startsWith(P+"\0")?3:1}constructor(S,P=S.length){if(this.path=S,this.viewEnd=P,S.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let S=1;S<=this.viewEnd;S++)yield new y(this.path,S)}*idsToRoot(){for(let S=this.viewEnd;S>0;S--)yield new y(this.path,S)}compare(S){if(typeof S=="string")return y.compare(this.toString(),S);for(let P=0;P<S.viewEnd&&P<this.viewEnd;P++)if(S.path[P]!==this.path[P])return 1;return S.viewEnd>this.viewEnd?2:S.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let S=1;S<this.viewEnd;S++)this.stringifed+="\0",this.stringifed+=this.path[S]}return this.stringifed}}e.TestId=y}),define(Ce[56],Ie([1,0,2,44,45]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var N;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(N=e.TestResultState||(e.TestResultState={}));var S;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable",c[c.SupportsContinuousRun=64]="SupportsContinuousRun"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=c=>"runId"in c;e.isStartControllerTests=P;var _;(function(c){c.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),c.deserialize=s=>({range:C.Range.lift(s.range),uri:n.URI.revive(s.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var I;(function(c){c[c.Error=0]="Error",c[c.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var L;(function(c){c.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&_.serialize(s.location)}),c.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&_.deserialize(s.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const w=(c,s)=>`${s?"s":"e"}${c}`;e.getMarkId=w;var f;(function(c){c.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&_.serialize(s.location)}),c.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&_.deserialize(s.location)})})(f=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(c){c.serialize=s=>s.type===0?L.serialize(s):f.serialize(s),c.deserialize=s=>s.type===0?L.deserialize(s):f.deserialize(s)})(E=e.ITestMessage||(e.ITestMessage={}));var m;(function(c){c.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),c.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(E.serialize)}),c.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(E.deserialize)})})(m=e.ITestTaskState||(e.ITestTaskState={}));const a="\0",o=(c,s)=>c+a+s;e.namespaceTestTag=o;const u=c=>{const s=c.indexOf(a);return{ctrlId:c.slice(0,s),tagId:c.slice(s+1)}};e.denamespaceTestTag=u;var g;(function(c){c.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),c.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?n.URI.revive(s.uri):void 0,range:s.range?C.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(g=e.ITestItem||(e.ITestItem={}));var b;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var R;(function(c){c.serialize=s=>({expand:s.expand,item:g.serialize(s.item)}),c.deserialize=s=>({controllerId:y.TestId.root(s.item.extId),expand:s.expand,item:g.deserialize(s.item)})})(R=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(c){c.serialize=s=>{let d;return s.item&&(d={},s.item.label!==void 0&&(d.label=s.item.label),s.item.tags!==void 0&&(d.tags=s.item.tags),s.item.busy!==void 0&&(d.busy=s.item.busy),s.item.uri!==void 0&&(d.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(d.range=s.item.range?.toJSON()),s.item.description!==void 0&&(d.description=s.item.description),s.item.error!==void 0&&(d.error=s.item.error),s.item.sortText!==void 0&&(d.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:d}},c.deserialize=s=>{let d;return s.item&&(d={},s.item.label!==void 0&&(d.label=s.item.label),s.item.tags!==void 0&&(d.tags=s.item.tags),s.item.busy!==void 0&&(d.busy=s.item.busy),s.item.range!==void 0&&(d.range=s.item.range?C.Range.lift(s.item.range):null),s.item.description!==void 0&&(d.description=s.item.description),s.item.error!==void 0&&(d.error=s.item.error),s.item.sortText!==void 0&&(d.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:d}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(c,s)=>{s.expand!==void 0&&(c.expand=s.expand),s.item!==void 0&&(c.item=c.item?Object.assign(c.item,s.item):s.item)};e.applyTestItemUpdate=t;var h;(function(c){c.serializeWithoutMessages=s=>({...R.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.serializeWithoutMessages),retired:s.retired}),c.serialize=s=>({...R.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.serialize),retired:s.retired}),c.deserialize=s=>({...R.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.deserialize),retired:!0})})(h=e.TestResultItem||(e.TestResultItem={}));var r;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var l;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.DocumentSynced=2]="DocumentSynced",c[c.Remove=3]="Remove",c[c.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",c[c.Retire=5]="Retire",c[c.AddTag=6]="AddTag",c[c.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var i;(function(c){c.deserialize=s=>s.op===0?{op:s.op,item:R.deserialize(s.item)}:s.op===1?{op:s.op,item:v.deserialize(s.item)}:s.op===2?{op:s.op,uri:n.URI.revive(s.uri),docv:s.docv}:s,c.serialize=s=>s.op===0?{op:s.op,item:R.serialize(s.item)}:s.op===1?{op:s.op,item:v.serialize(s.item)}:s})(i=e.TestsDiffOp||(e.TestsDiffOp={}));class p{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(s){const d=this.createChangeCollector();for(const k of s)switch(k.op){case 0:this.add(R.deserialize(k.item),d);break;case 1:this.update(v.deserialize(k.item),d);break;case 3:this.remove(k.itemId,d);break;case 5:this.retireTest(k.itemId);break;case 4:this.updatePendingRoots(k.amount);break;case 6:this._tags.set(k.tag.id,k.tag);break;case 7:this._tags.delete(k.id);break}d.complete?.()}add(s,d){const k=y.TestId.parentId(s.item.extId)?.toString();let A;if(!k)A=this.createItem(s),this.roots.add(A),this.items.set(s.item.extId,A);else if(this.items.has(k)){const W=this.items.get(k);W.children.add(s.item.extId),A=this.createItem(s,W),this.items.set(s.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return d.add?.(A),s.expand===2&&this.busyControllerCount++,A}update(s,d){const k=this.items.get(s.extId);if(!!k)return s.expand!==void 0&&(k.expand===2&&this.busyControllerCount--,s.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(k,s),d.update?.(k),k}remove(s,d){const k=this.items.get(s);if(!k)return;const A=y.TestId.parentId(k.item.extId)?.toString();A?this.items.get(A).children.delete(k.item.extId):this.roots.delete(k);const W=[[s]];for(;W.length;)for(const J of W.pop()){const j=this.items.get(J);j&&(W.push(j.children),this.items.delete(J),d.remove?.(j,j!==k),j.expand===2&&this.busyControllerCount--)}}retireTest(s){}updatePendingRoots(s){this.pendingRootCount+=s}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=p}),define(Ce[71],Ie([1,0,17,4,6,49,56,45]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var _;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(_=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(g,b)=>g===b,w=Object.entries({range:(g,b)=>g===b?!0:!g||!b?!1:g.equalsRange(b),busy:I,label:I,description:I,error:I,sortText:I,tags:(g,b)=>!(g.length!==b.length||g.some(R=>!b.includes(R)))}),f=(g,b)=>{let R;for(const[v,t]of w)t(g[v],b[v])||(R?R[v]=b[v]:R={[v]:b[v]});return R};class E extends y.Disposable{get root(){return this.options.root}constructor(b){super(),this.options=b,this.debounceSendDiff=this._register(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const R of this.tree.values())this.updateExpandability(R)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){switch(b.op){case 2:{for(const R of this.diff)if(R.op===2&&R.uri===b.uri){R.docv=b.docv;return}break}case 1:{const R=this.diff[this.diff.length-1];if(R){if(R.op===1&&R.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(R.item,b.item);return}if(R.op===0&&R.item.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(R.item,b.item);return}}break}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,R){const v=this.tree.get(b);if(!!v){if((v.expandLevels===void 0||R>v.expandLevels)&&(v.expandLevels=R),v.expand===1){const t=this.resolveChildren(v);return t.isOpen()?this.expandChildren(v,R-1):t.wait().then(()=>this.expandChildren(v,R-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.expandChildren(v,R-1)):this.expandChildren(v,R-1)}}dispose(){for(const b of this.tree.values())this.options.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,R){switch(R.op){case 3:this.removeItem(P.TestId.joinToString(b.fullId,R.id));break;case 0:this.upsertItem(R.item,b);break;case 5:for(const v of R.ops)this.onTestItemEvent(b,v);break;case 1:this.diffTagRefs(R.new,R.old,b.fullId.toString());break;case 2:this.updateExpandability(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:R.update}});break;case 6:this.documentSynced(b.actual.uri);break;default:(0,N.assertNever)(R)}}documentSynced(b){b&&this.pushDiff({op:2,uri:b,docv:this.options.getDocumentVersion(b)})}upsertItem(b,R){const v=P.TestId.fromExtHostTestItem(b,this.root.id,R?.actual),t=this.options.getApiFor(b);t.parent&&t.parent!==R?.actual&&this.options.getChildren(t.parent).delete(b.id);let h=this.tree.get(v.toString());if(!h){h={fullId:v,actual:b,expandLevels:R?.expandLevels?R.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(h.fullId.toString(),h),this.setItemParent(b,R),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:h.expand,item:this.options.toITestItem(b)}}),this.connectItemAndChildren(b,h,R);return}if(h.actual===b){this.connectItem(b,h,R);return}if(h.actual.uri?.toString()!==b.uri?.toString())return this.removeItem(v.toString()),this.upsertItem(b,R);const r=this.options.getChildren(h.actual),l=h.actual,i=f(this.options.toITestItem(l),this.options.toITestItem(b));this.options.getApiFor(l).listener=void 0,h.actual=b,h.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(b.tags,l.tags,v.toString()),delete i.tags),this.onTestItemEvent(h,{op:4,update:i})),this.connectItemAndChildren(b,h,R);for(const[p,c]of r)this.options.getChildren(b).get(c.id)||this.removeItem(P.TestId.joinToString(v,c.id));this.documentSynced(h.actual.uri)}diffTagRefs(b,R,v){const t=new Set(R.map(h=>h.id));for(const h of b)t.delete(h.id)||this.incrementTagRefs(h);this.pushDiff({op:1,item:{extId:v,item:{tags:b.map(h=>(0,S.namespaceTestTag)(this.options.controllerId,h.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const R=this.tags.get(b.id);R?R.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.namespaceTestTag)(this.options.controllerId,b.id)}}))}decrementTagRefs(b){const R=this.tags.get(b);R&&!--R.refCount&&(this.tags.delete(b),this.pushDiff({op:7,id:(0,S.namespaceTestTag)(this.options.controllerId,b)}))}setItemParent(b,R){this.options.getApiFor(b).parent=R&&R.actual!==this.root?R.actual:void 0}connectItem(b,R,v){this.setItemParent(b,v);const t=this.options.getApiFor(b);t.parent=v?.actual,t.listener=h=>this.onTestItemEvent(R,h),this.updateExpandability(R)}connectItemAndChildren(b,R,v){this.connectItem(b,R,v);for(const[t,h]of this.options.getChildren(b))this.upsertItem(h,R)}updateExpandability(b){let R;this._resolveHandler?b.resolveBarrier?R=b.resolveBarrier.isOpen()?3:2:R=b.actual.canResolveChildren?1:0:R=0,R!==b.expand&&(b.expand=R,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:R}}),R===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,R){if(R<0)return;const v=[];for(const[t,h]of this.options.getChildren(b.actual)){const r=this.expand(P.TestId.joinToString(b.fullId,h.id),R);(0,n.isThenable)(r)&&v.push(r)}if(v.length)return Promise.all(v).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const h=new n.Barrier;return h.open(),h}b.expand=2,this.pushExpandStateUpdate(b);const R=b.resolveBarrier=new n.Barrier,v=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,h)};let t;try{t=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(h){v(h)}return(0,n.isThenable)(t)?t.catch(v).then(()=>{R.open(),this.updateExpandability(b)}):(R.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const R=this.tree.get(b);if(!R)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const v=[R];for(;v.length;){const t=v.pop();if(!!t){this.options.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.decrementTagRefs(h.id);this.tree.delete(t.fullId.toString());for(const[h,r]of this.options.getChildren(t.actual))v.push(this.tree.get(P.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.TestItemCollection=E;class m extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=m;class a extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=a;class o extends Error{constructor(b,R,v){super(`TestItem with ID "${b}" is from controller "${R}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=o;const u=(g,b,R)=>{let v=new Map;return{get size(){return v.size},forEach(t,h){for(const r of v.values())t.call(h,r,this)},[Symbol.iterator](){return v.entries()},replace(t){const h=new Map,r=new Set(v.keys()),l={op:5,ops:[]};for(const i of t){if(!(i instanceof R))throw new a(i.id);const p=b(i).controllerId;if(p!==g.controllerId)throw new o(i.id,p,g.controllerId);if(h.has(i.id))throw new m(i.id);h.set(i.id,i),r.delete(i.id),l.ops.push({op:0,item:i})}for(const i of r.keys())l.ops.push({op:3,id:i});g.listener?.(l),v=h},add(t){if(!(t instanceof R))throw new a(t.id);v.set(t.id,t),g.listener?.({op:0,item:t})},delete(t){v.delete(t)&&g.listener?.({op:3,id:t})},get(t){return v.get(t)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=u}),define(Ce[96],Ie([1,0,71]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,y=(S,P)=>{const _={controllerId:P};return C.set(S,_),_};e.createPrivateApiFor=y;const N=S=>{const P=C.get(S);if(!P)throw new n.InvalidTestItemError(S?.id||"<unknown>");return P};e.getPrivateApiFor=N}),define(Ce[72],Ie([1,0,15,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(P,_){return P.scheme===n.Schemas.http||P.scheme===n.Schemas.https?P:(_&&_.authority&&_.isRemote&&P.scheme===n.Schemas.file&&(P=C.URI.from({scheme:n.Schemas.vscodeRemote,authority:_.authority,path:P.path})),C.URI.from({scheme:n.Schemas.https,authority:`${P.scheme}+${N(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=y;function N(P){return P.replace(/./g,_=>{const I=_.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?_:"-"+I.toString(16).padStart(4,"0")})}function S(P){return P.replace(/-([0-9a-f]{4})/g,(_,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=S}),define(Ce[187],Ie([1,0,4,6,72]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(P,_,I){this._proxy=P,this._editors=_,this._remoteInfo=I,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const L=_.getVisibleTextEditors();for(const w of this._insets.values())L.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,_,I,L,w){let f;for(const b of this._editors.getVisibleTextEditors(!0))if(b.value===P){f=b;break}if(!f)throw new Error("not a visible editor");const E=this,m=this._handlePool++,a=new n.Emitter,o=new n.Emitter,u=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(b){return(0,y.asWebviewUri)(b,E._remoteInfo)}get cspSource(){return y.webviewGenericCspSource}set options(b){this._options=b,E._proxy.$setOptions(m,b)}get options(){return this._options}set html(b){this._html=b,E._proxy.$setHtml(m,b)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(b){return E._proxy.$postMessage(m,b)}},g=new class{constructor(){this.editor=P,this.line=_,this.height=I,this.webview=u,this.onDidDispose=o.event}dispose(){E._insets.has(m)&&(E._insets.delete(m),E._proxy.$disposeEditorInset(m),o.fire(),o.dispose(),a.dispose())}};return this._proxy.$createEditorInset(m,f.id,f.value.document.uri,_+1,I,L||{},w.identifier,w.extensionLocation),this._insets.set(m,{editor:P,inset:g,onDidReceiveMessage:a}),g}$onDidDispose(P){const _=this._insets.get(P);_&&_.inset.dispose()}$onDidReceiveMessage(P,_){this._insets.get(P)?.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=N}),define(Ce[188],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var C;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(S,P){super(P),this.variable=S}}e.VariableError=y}),define(Ce[189],Ie([1,0,19,51,9,22,21,87,153,188,10]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(E,m,a,o){this._contributedVariables=new Map,this._context=E,this._labelService=m,this._userHomePromise=a,o&&(this._envVariablesPromise=o.then(u=>this.prepareEnv(u)))}prepareEnv(E){if(S.isWindows){const m=Object.create(null);return Object.keys(E).forEach(a=>{m[a.toLowerCase()]=E[a]}),m}return E}resolveWithEnvironment(E,m,a){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},m?m.uri:void 0,a)}async resolveAsync(E,m){const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,E?E.uri:void 0,m)}async resolveAnyBase(E,m,a,o){const u=N.deepClone(m);S.isWindows&&u.windows?Object.keys(u.windows).forEach(b=>u[b]=u.windows[b]):S.isMacintosh&&u.osx?Object.keys(u.osx).forEach(b=>u[b]=u.osx[b]):S.isLinux&&u.linux&&Object.keys(u.linux).forEach(b=>u[b]=u.linux[b]),delete u.windows,delete u.osx,delete u.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,E?E.uri:void 0,u,a,o)}async resolveAnyAsync(E,m,a){return this.resolveAnyBase(E,m,a)}async resolveAnyMap(E,m,a){const o=new Map;return{newConfig:await this.resolveAnyBase(E,m,a,o),resolvedVariables:o}}resolveWithInteractionReplace(E,m,a,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,m,a,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,m){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,m)}async recursiveResolve(E,m,a,o,u){if(y.isString(a))return this.resolveString(E,m,a,o,u);if(Array.isArray(a))return Promise.all(a.map(g=>this.recursiveResolve(E,m,g,o,u)));if(y.isObject(a)){const g=Object.create(null),b=await Promise.all(Object.keys(a).map(async R=>[await this.resolveString(E,m,R,o,u),await this.recursiveResolve(E,m,a[R],o,u)]));for(const[R,v]of b)g[R]=v;return g}return a}resolveString(E,m,a,o,u){return(0,L.replaceAsync)(a,w.VARIABLE_REGEXP,async(g,b)=>{if(b.includes(w.VARIABLE_LHS))return g;let R=await this.evaluateSingleVariable(E,g,b,m,o);return u?.set(b,R),R!==g&&y.isString(R)&&R.match(w.VARIABLE_REGEXP)&&(R=await this.resolveString(E,m,R,o,u)),R})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,m,a,o,u){let g;const b=a.split(":");b.length>1&&(a=b[0],g=b[1]);const R=h=>{const r=this._context.getFilePath();if(r)return(0,P.normalizeDriveLetter)(r);throw new I.VariableError(h,(0,_.localize)(0,null,m))},v=h=>{const r=R(h);if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return(0,P.normalizeDriveLetter)(l)}throw new I.VariableError(h,(0,_.localize)(1,null,m,n.basename(r)))},t=h=>{if(g){const r=this._context.getFolderUri(g);if(r)return r;throw new I.VariableError(h,(0,_.localize)(2,null,m,g))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new I.VariableError(h,(0,_.localize)(3,null,m)):new I.VariableError(h,(0,_.localize)(4,null,m))};switch(a){case"env":if(g){if(E.env){const h=E.env[S.isWindows?g.toLowerCase():g];if(y.isString(h))return h}return""}throw new I.VariableError(I.VariableKind.Env,(0,_.localize)(5,null,m));case"config":if(g){const h=this._context.getConfigurationValue(o,g);if(y.isUndefinedOrNull(h))throw new I.VariableError(I.VariableKind.Config,(0,_.localize)(6,null,m,g));if(y.isObject(h))throw new I.VariableError(I.VariableKind.Config,(0,_.localize)(7,null,m,g));return h}throw new I.VariableError(I.VariableKind.Config,(0,_.localize)(8,null,m));case"command":return this.resolveFromMap(I.VariableKind.Command,m,g,u,"command");case"input":return this.resolveFromMap(I.VariableKind.Input,m,g,u,"input");case"extensionInstallFolder":if(g){const h=await this._context.getExtension(g);if(!h)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,_.localize)(9,null,m,g));return this.fsPath(h.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,_.localize)(10,null,m));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(t(I.VariableKind.WorkspaceFolder)));case"cwd":return o||g?(0,P.normalizeDriveLetter)(this.fsPath(t(I.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(n.basename(this.fsPath(t(I.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,_.localize)(11,null,m))}case"lineNumber":{const h=this._context.getLineNumber();if(h)return h;throw new I.VariableError(I.VariableKind.LineNumber,(0,_.localize)(12,null,m))}case"selectedText":{const h=this._context.getSelectedText();if(h)return h;throw new I.VariableError(I.VariableKind.SelectedText,(0,_.localize)(13,null,m))}case"file":return R(I.VariableKind.File);case"fileWorkspaceFolder":return v(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||g?n.relative(this.fsPath(t(I.VariableKind.RelativeFile)),R(I.VariableKind.RelativeFile)):R(I.VariableKind.RelativeFile);case"relativeFileDirname":{const h=n.dirname(R(I.VariableKind.RelativeFileDirname));if(o||g){const r=n.relative(this.fsPath(t(I.VariableKind.RelativeFileDirname)),h);return r.length===0?".":r}return h}case"fileDirname":return n.dirname(R(I.VariableKind.FileDirname));case"fileExtname":return n.extname(R(I.VariableKind.FileExtname));case"fileBasename":return n.basename(R(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=n.basename(R(I.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-n.extname(h).length)}case"fileDirnameBasename":return n.basename(n.dirname(R(I.VariableKind.FileDirnameBasename)));case"execPath":{const h=this._context.getExecPath();return h||m}case"execInstallFolder":{const h=this._context.getAppRoot();return h||m}case"pathSeparator":return n.sep;default:try{const h=g?`${a}:${g}`:a;return this.resolveFromMap(I.VariableKind.Unknown,m,h,u,void 0)}catch{return m}}}}resolveFromMap(E,m,a,o,u){if(a&&o){const g=u===void 0?o[a]:o[u+":"+a];if(typeof g=="string")return g;throw new I.VariableError(E,(0,_.localize)(14,null,m))}return m}}w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=w}),define(Ce[97],Ie([1,0,3,95]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var y;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var N;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(N=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var P;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function I(m){const a=m;return(0,C.isEditorInput)(a?.editor)&&(0,C.isEditorInput)(a?.replacement)}e.isEditorReplacement=I;var L;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function f(m){const a=m;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=f;function E(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(Ce[190],Ie([1,0,3,97]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(N){const S=N;return typeof N=="number"||(0,C.isEditorGroup)(S)}e.isPreferredGroup=y}),define(Ce[191],Ie([1,0,3,159]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(C.IEnvironmentService)}),define(Ce[98],Ie([1,0,25,4,19]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class N{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=N;class S{static isHostExtension(w,f,E){if(f.getExtensionDescription(w))return!1;const m=E.getExtensionDescription(w);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(w){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=w,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const w of this._extensionDescriptions){if(this._extensionsMap.has(n.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(n.ExtensionIdentifier.toKey(w.identifier),w),this._extensionsArr.push(w),Array.isArray(w.activationEvents))for(let f of w.activationEvents)f==="onUri"&&(f=`onUri:${n.ExtensionIdentifier.toKey(w.identifier)}`),this._activationMap.has(f)||this._activationMap.set(f,[]),this._activationMap.get(f).push(w)}}set(w){this._extensionDescriptions=w,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(w,f){this._extensionDescriptions=I(this._extensionDescriptions,f),this._extensionDescriptions=this._extensionDescriptions.concat(w);const E=S._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=I(this._extensionDescriptions,E.map(m=>m.identifier)),this._initialize(),this._onDidChange.fire(void 0),new N(E)}static _findLoopingExtensions(w){const f=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(u){this._nodesSet.has(u)||(this._nodesSet.add(u),this._nodesArr.push(u))}addArc(u,g){this.addNode(u),this.addNode(g),this._arcs.has(u)?this._arcs.get(u).push(g):this._arcs.set(u,[g])}getArcs(u){return this._arcs.has(u)?this._arcs.get(u):[]}hasOnlyGoodArcs(u,g){const b=f.getArcs(u);for(let R=0;R<b.length;R++)if(!g.has(b[R]))return!1;return!0}getNodes(){return this._nodesArr}},E=new Map;for(const u of w){const g=n.ExtensionIdentifier.toKey(u.identifier);if(E.set(g,u),u.extensionDependencies)for(const b of u.extensionDependencies){const R=n.ExtensionIdentifier.toKey(b);f.addArc(g,R)}}const m=new Set;f.getNodes().filter(u=>f.getArcs(u).length===0).forEach(u=>m.add(u));const a=f.getNodes().filter(u=>!m.has(u));let o;do{o=!1;for(let u=0;u<a.length;u++){const g=a[u];f.hasOnlyGoodArcs(g,m)&&(a.splice(u,1),u--,m.add(g),o=!0)}}while(o);return a.map(u=>E.get(u))}containsActivationEvent(w){return this._activationMap.has(w)}containsExtension(w){return this._extensionsMap.has(n.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const f=this._activationMap.get(w);return f?f.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(w){const f=this._extensionsMap.get(n.ExtensionIdentifier.toKey(w));return f||void 0}getExtensionDescriptionByUUID(w){for(const f of this._extensionsArr)if(f.uuid===w)return f}getExtensionDescriptionByIdOrUUID(w,f){return this.getExtensionDescription(w)??(f?this.getExtensionDescriptionByUUID(f):void 0)}}e.ExtensionDescriptionRegistry=S;var P;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(P||(P={}));function _(L,w){const f=L.isBuiltin?0:L.isUnderDevelopment?2:1,E=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(f!==E)return f-E;const m=y.posix.basename(L.extensionLocation.path),a=y.posix.basename(w.extensionLocation.path);return m<a?-1:m>a?1:0}function I(L,w){const f=new Set;return w.forEach(E=>f.add(n.ExtensionIdentifier.toKey(E))),L.filter(E=>!f.has(n.ExtensionIdentifier.toKey(E.identifier)))}}),define(Ce[73],Ie([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var y;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var N;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(N=e.MessageType||(e.MessageType={}));function S(I){const L=n.VSBuffer.alloc(1);switch(I){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=S;function P(I,L){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=P;var _;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(_=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[74],Ie([1,0,3,4,11,26,73,50,52,22,2,6,143]),function(te,e,n,C,y,N,S,P,_,I,L,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class extends w.Disposable{constructor(u,g){super(),this.initData=u,this.loggerService=g,this._onDidChangeTelemetryEnabled=this._register(new C.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new C.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=L.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=g.createLogger(this.extHostTelemetryLogFile,{id:_.extensionTelemetryLogChannelId,name:(0,f.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(g.onDidChangeLogLevel(b=>{(0,y.isLogLevel)(b)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===y.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(u,g,b){const R=this.getTelemetryDetails(),v=new m(g,b,u,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(u),{isUsageEnabled:R.isUsageEnabled,isErrorsEnabled:R.isErrorsEnabled});return this._telemetryLoggers.set(u.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(u,g,b){this._level=u,this._telemetryIsSupported=g,this._productConfig=b??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(u){const g={};switch(g["common.extname"]=`${u.publisher}.${u.name}`,g["common.extversion"]=u.version,g["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,g["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,g["common.vscodeversion"]=this.initData.version,g["common.isnewappinstall"]=a(this.initData.telemetryInfo.firstSessionDate),g["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case S.UIKind.Web:g["common.uikind"]="web";break;case S.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,P.getRemoteName)((0,_.cleanRemoteAuthority)(this.initData.remote.authority)),g}$onDidChangeTelemetryLevel(u){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=u;const g=this.getTelemetryDetails();this._telemetryLoggers.forEach(b=>{b.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(u,g){const b=this._telemetryLoggers.get(u.value);return!b||b.ignoreUnhandledExtHostErrors?!1:(b.logError(g),!0)}};E=Ve([He(0,N.IExtHostInitDataService),He(1,y.ILoggerService)],E),e.ExtHostTelemetry=E;class m{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,g,b,R,v,t,h){this._extension=b,this._logger=R,this._inLoggingOnlyMode=v,this._commonProperties=t,this._onDidChangeEnableStates=new C.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=g?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=g?.additionalCommonProperties,this._sender=u,this._telemetryEnablements={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(u,g){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:u,isErrorsEnabled:g},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(u){let g=u.properties??u;return g=(0,_.cleanData)(g,[]),this._additionalCommonProperties&&(g=(0,I.mixin)(g,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(g=(0,I.mixin)(g,this._commonProperties)),u.properties?u.properties=g:u=g,u}logEvent(u,g){this._extension.publisher==="vscode"?u=this._extension.name+"/"+u:u=this._extension.identifier.value+"/"+u,g=this.mixInCommonPropsAndCleanData(g||{}),this._inLoggingOnlyMode||this._sender.sendEventData(u,g),this._logger.trace(u,g)}logUsage(u,g){!this._telemetryEnablements.isUsageEnabled||this.logEvent(u,g)}logError(u,g){!this._telemetryEnablements.isErrorsEnabled||(typeof u=="string"?this.logEvent(u,g):this._sender.sendErrorData(u,g))}get apiTelemetryLogger(){if(!this._apiObject){const u=this,g={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return u._telemetryEnablements.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u._onDidChangeEnableStates.event.bind(u)};this._apiObject=Object.freeze(g)}return this._apiObject}dispose(){this._sender?.flush&&this._sender.flush()}}e.ExtHostTelemetryLogger=m;function a(o){const u=Date.now()-new Date(o).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.isNewAppInstall=a,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Ce[27],Ie([1,0,4,2,3,25,169]),function(te,e,n,C,y,N,S){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new N.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class _{constructor(p){this.affinity=p,this.kind=1}equals(p){return this.kind===p.kind&&this.affinity===p.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=_;class I{constructor(p){this.affinity=p,this.kind=2}equals(p){return this.kind===p.kind&&this.affinity===p.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=I;class L{constructor(){this.kind=3,this.affinity=0}equals(p){return this.kind===p.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class w{constructor(p){this.dependency=p}}e.MissingExtensionDependency=w;var f;(function(i){i[i.LocalProcess=1]="LocalProcess",i[i.LocalWebWorker=2]="LocalWebWorker",i[i.Remote=3]="Remote"})(f=e.ExtensionHostKind||(e.ExtensionHostKind={}));function E(i){if(i===null)return"None";switch(i){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=E;class m{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(p,c){const s=[],d=[],k=[],A=[],W=u(this._allExtensions),J=u(p),j=(F,z)=>F.extensionLocation.toString()===z.extensionLocation.toString()||F.isBuiltin===z.isBuiltin||F.isUserBuiltin===z.isUserBuiltin||F.isUnderDevelopment===z.isUnderDevelopment;for(const F of this._allExtensions){const z=J.get(N.ExtensionIdentifier.toKey(F.identifier));if(!z){s.push(F.identifier),W.delete(N.ExtensionIdentifier.toKey(F.identifier));continue}if(!j(F,z)){s.push(F.identifier),W.delete(N.ExtensionIdentifier.toKey(F.identifier));continue}}for(const F of p){const z=W.get(N.ExtensionIdentifier.toKey(F.identifier));if(!z){d.push(F);continue}if(!j(z,F)){s.push(z.identifier),W.delete(N.ExtensionIdentifier.toKey(z.identifier));continue}}const O=o(this._myExtensions),B=o(c);for(const F of this._myExtensions)B.has(N.ExtensionIdentifier.toKey(F))||k.push(F);for(const F of c)O.has(N.ExtensionIdentifier.toKey(F))||A.push(F);const T={toRemove:s,toAdd:d,myToRemove:k,myToAdd:A};return this.delta(T),T}delta(p){const{toRemove:c,toAdd:s,myToRemove:d,myToAdd:k}=p,A=o(c),W=o(d);for(let J=0;J<this._allExtensions.length;J++)A.has(N.ExtensionIdentifier.toKey(this._allExtensions[J].identifier))&&(this._allExtensions.splice(J,1),J--);for(let J=0;J<this._myExtensions.length;J++)W.has(N.ExtensionIdentifier.toKey(this._myExtensions[J]))&&(this._myExtensions.splice(J,1),J--);for(const J of s)this._allExtensions.push(J);for(const J of k)this._myExtensions.push(J)}containsExtension(p){for(const c of this._myExtensions)if(N.ExtensionIdentifier.equals(c,p))return!0;return!1}}e.ExtensionHostExtensions=m;class a{constructor(p){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=N.ExtensionIdentifier.toKey,p)for(const c of p)this.add(c)}get size(){return this._map.size}add(p){return this._map.set(this._toKey(p),p),this}clear(){this._map.clear()}delete(p){return this._map.delete(this._toKey(p))}has(p){return this._map.has(this._toKey(p))}forEach(p,c){this._map.forEach(s=>p.call(c,s,s,this))}*entries(){for(const[p,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=a;function o(i){const p=new Set;for(const c of i)p.add(N.ExtensionIdentifier.toKey(c));return p}e.extensionIdentifiersArrayToSet=o;function u(i){const p=new Map;for(const c of i)p.set(N.ExtensionIdentifier.toKey(c.identifier),c);return p}function g(i,p){return i.enabledApiProposals?i.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=g;function b(i,p){if(!g(i,p))throw new Error(`Extension '${i.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${i.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${i.identifier.value}`)}e.checkProposedApiEnabled=b;class R{constructor(p,c,s,d){this.codeLoadingTime=p,this.activateCallTime=c,this.activateResolvedTime=s,this.activationReason=d}}e.ActivationTimes=R;class v{constructor(p,c){this.description=p,this.value=c}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var t;(function(i){i[i.Normal=0]="Normal",i[i.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function h(i){return{type:i.isBuiltin?0:1,isBuiltin:i.isBuiltin||i.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(i.publisher,i.name),uuid:i.uuid},manifest:i,location:i.extensionLocation,targetPlatform:i.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function r(i,p){return{identifier:new N.ExtensionIdentifier((0,S.getExtensionId)(i.manifest.publisher,i.manifest.name)),isBuiltin:i.type===0,isUserBuiltin:i.type===1&&i.isBuiltin,isUnderDevelopment:!!p,extensionLocation:i.location,...i.manifest,uuid:i.identifier.uuid,targetPlatform:i.targetPlatform,browserNlsBundleUris:i.browserNlsBundleUris}}e.toExtensionDescription=r;class l{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(p,c){return Promise.resolve(0)}getInspectPorts(p,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(Ce[192],Ie([1,0,12,98,25,27,11,17]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class _{constructor(u,g,b,R){this.startup=u,this.codeLoadingTime=g,this.activateCallTime=b,this.activateResolvedTime=R}}_.NONE=new _(!1,-1,-1,-1),e.ExtensionActivationTimes=_;class I{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,g){return u===-1||g===-1?-1:g-u}build(){return new _(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class L{constructor(u,g,b,R,v,t){this.activationFailed=u,this.activationFailedError=g,this.activationTimes=b,this.module=R,this.exports=v,this.subscriptions=t}}e.ActivatedExtension=L;class w extends L{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class f extends L{constructor(){super(!1,null,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=f;class E extends L{constructor(u){super(!0,u,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(u,g,b,R){this._logService=R,this._registry=u,this._globalRegistry=g,this._host=b,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[u,g]of this._operations)g.dispose()}isActivated(u){const g=this._operations.get(y.ExtensionIdentifier.toKey(u));return Boolean(g&&g.value)}getActivatedExtension(u){const g=this._operations.get(y.ExtensionIdentifier.toKey(u));if(!g||!g.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return g.value}async activateByEvent(u,g){if(this._alreadyActivatedEvents[u])return;const b=this._registry.getExtensionDescriptionsForActivationEvent(u);await this._activateExtensions(b.map(R=>({id:R.identifier,reason:{startup:g,extensionId:R.identifier,activationEvent:u}}))),this._alreadyActivatedEvents[u]=!0}activateById(u,g){const b=this._registry.getExtensionDescription(u);if(!b)throw new Error(`Extension '${u}' is not known`);return this._activateExtensions([{id:b.identifier,reason:g}])}async _activateExtensions(u){const g=u.filter(b=>!this.isActivated(b.id)).map(b=>this._handleActivationRequest(b));await Promise.all(g.map(b=>b.wait()))}_handleActivationRequest(u){if(this._operations.has(y.ExtensionIdentifier.toKey(u.id)))return this._operations.get(y.ExtensionIdentifier.toKey(u.id));if(this._isHostExtension(u.id))return this._createAndSaveOperation(u,null,[],null);const g=this._registry.getExtensionDescription(u.id);if(!g){const v=new Error(`Cannot activate unknown extension '${u.id.value}'`),t=this._createAndSaveOperation(u,null,[],new E(v));return this._host.onExtensionActivationError(u.id,v,new N.MissingExtensionDependency(u.id.value)),t}const b=[],R=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const v of R){if(this._isResolvedExtension(v))continue;const t=this._operations.get(y.ExtensionIdentifier.toKey(v));if(t){b.push(t);continue}if(this._isHostExtension(v)){b.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(v).identifier,reason:u.reason}));continue}const h=this._registry.getExtensionDescription(v);if(h){if(!h.main&&!h.browser)continue;b.push(this._handleActivationRequest({id:h.identifier,reason:u.reason}));continue}const r=g.displayName||g.identifier.value,l=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${v}'`),i=this._createAndSaveOperation(u,g.displayName,[],new E(l));return this._host.onExtensionActivationError(g.identifier,l,new N.MissingExtensionDependency(v)),i}return this._createAndSaveOperation(u,g.displayName,b,null)}_createAndSaveOperation(u,g,b,R){const v=new a(u.id,g,u.reason,b,R,this._host,this._logService);return this._operations.set(y.ExtensionIdentifier.toKey(u.id),v),v}_isHostExtension(u){return C.ExtensionDescriptionRegistry.isHostExtension(u,this._registry,this._globalRegistry)}_isResolvedExtension(u){const g=this._globalRegistry.getExtensionDescription(u);return g?!g.main&&!g.browser:!1}};m=Ve([He(3,S.ILogService)],m),e.ExtensionsActivator=m;let a=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(u,g,b,R,v,t,h){this._id=u,this._displayName=g,this._reason=b,this._deps=R,this._value=v,this._host=t,this._logService=h,this._barrier=new P.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let u=0;u<this._deps.length;u++){const g=this._deps[u];if(g.value&&!g.value.activationFailed){this._deps.splice(u,1),u--;continue}if(g.value&&g.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);b.detail=g.value.activationFailedError,this._value=new E(b),this._host.onExtensionActivationError(this._id,b,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(u=>u.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(u){const g=new Error;if(u&&u.name&&(g.name=u.name),u&&u.message?g.message=`Activating extension '${this._id.value}' failed: ${u.message}.`:g.message=`Activating extension '${this._id.value}' failed: ${u}.`,u&&u.stack&&(g.stack=u.stack),this._value=new E(g),this._isDisposed&&n.isCancellationError(u))return;this._host.onExtensionActivationError(this._id,g,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(u)}}};a=Ve([He(6,S.ILogService)],a)});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[7],Ie([1,0,16,12,86,28,64,10,9,2,34,43,94,70,27]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m){"use strict";var a,o,u,g,b,R,v,t,h,r,l,i,p,c,s,d,k,A,W,J,j,O,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function T(x){return Object.assign(x,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(x,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[ie,...we]=arguments;return Reflect.construct(x,we,ie.constructor)}}})}var F;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(F=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let H=R=class{static from(...M){let ie=M;return new R(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(M){a.set(this,void 0),Je(this,a,M,"f")}dispose(){typeof Oe(this,a,"f")=="function"&&(Oe(this,a,"f").call(this),Je(this,a,void 0,"f"))}};a=new WeakMap,H=R=Ve([T],H),e.Disposable=H;let de=v=class{static Min(...M){if(M.length===0)throw new TypeError;let ie=M[0];for(let we=1;we<M.length;we++){const qe=M[we];qe.isBefore(ie)&&(ie=qe)}return ie}static Max(...M){if(M.length===0)throw new TypeError;let ie=M[0];for(let we=1;we<M.length;we++){const qe=M[we];qe.isAfter(ie)&&(ie=qe)}return ie}static isPosition(M){if(!M)return!1;if(M instanceof v)return!0;const{line:ie,character:we}=M;return typeof ie=="number"&&typeof we=="number"}static of(M){if(M instanceof v)return M;if(this.isPosition(M))return new v(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(M,ie){if(M<0)throw(0,C.illegalArgument)("line must be non-negative");if(ie<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=M,this._character=ie}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ie=0){if(M===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof M>"u"?we=0:typeof M=="number"?we=M:(we=typeof M.lineDelta=="number"?M.lineDelta:0,ie=typeof M.characterDelta=="number"?M.characterDelta:0),we===0&&ie===0?this:new v(this.line+we,this.character+ie)}with(M,ie=this.character){if(M===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof M>"u"?we=this.line:typeof M=="number"?we=M:(we=typeof M.line=="number"?M.line:this.line,ie=typeof M.character=="number"?M.character:this.character),we===this.line&&ie===this.character?this:new v(we,ie)}toJSON(){return{line:this.line,character:this.character}}};de=v=Ve([T],de),e.Position=de;let pe=t=class{static isRange(M){return M instanceof t?!0:M?de.isPosition(M.start)&&de.isPosition(M.end):!1}static of(M){if(M instanceof t)return M;if(this.isRange(M))return new t(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(M,ie,we,qe){let Ye,at;if(typeof M=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof qe=="number"?(Ye=new de(M,ie),at=new de(we,qe)):de.isPosition(M)&&de.isPosition(ie)&&(Ye=de.of(M),at=de.of(ie)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this._start=Ye,this._end=at):(this._start=at,this._end=Ye)}contains(M){return t.isRange(M)?this.contains(M.start)&&this.contains(M.end):de.isPosition(M)?!(de.of(M).isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ie=de.Max(M.start,this._start),we=de.Min(M.end,this._end);if(!ie.isAfter(we))return new t(ie,we)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ie=de.Min(M.start,this._start),we=de.Max(M.end,this.end);return new t(ie,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ie=this.end){if(M===null||ie===null)throw(0,C.illegalArgument)();let we;return M?de.isPosition(M)?we=M:(we=M.start||this.start,ie=M.end||this.end):we=this.start,we.isEqual(this._start)&&ie.isEqual(this.end)?this:new t(we,ie)}toJSON(){return[this.start,this.end]}};pe=t=Ve([T],pe),e.Range=pe;let re=h=class extends pe{static isSelection(M){return M instanceof h?!0:M?pe.isRange(M)&&de.isPosition(M.anchor)&&de.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(M,ie,we,qe){let Ye,at;if(typeof M=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof qe=="number"?(Ye=new de(M,ie),at=new de(we,qe)):de.isPosition(M)&&de.isPosition(ie)&&(Ye=de.of(M),at=de.of(ie)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this._anchor=Ye,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};re=h=Ve([T],re),e.Selection=re;class le{constructor(M,ie,we){if(typeof M!="string"||M.length===0)throw(0,C.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=le;class ae extends Error{static NotAvailable(M,ie){return new ae(M,f.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(M){return new ae(M,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,ie=f.RemoteAuthorityResolverErrorCode.Unknown,we){super(M),this._message=M,this._code=ie,this._detail=we,Object.setPrototypeOf(this,ae.prototype)}}e.RemoteAuthorityResolverError=ae;var se;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(se=e.EndOfLine||(e.EndOfLine={}));var Q;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(Q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=r=class{static isTextEdit(M){return M instanceof r?!0:M?pe.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ie){return new r(M,ie)}static insert(M,ie){return r.replace(new pe(M,M),ie)}static delete(M){return r.replace(M,"")}static setEndOfLine(M){const ie=new r(new pe(new de(0,0),new de(0,0)),"");return ie.newEol=M,ie}get range(){return this._range}set range(M){if(M&&!pe.isRange(M))throw(0,C.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,C.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,C.illegalArgument)("newEol");this._newEol=M}constructor(M,ie){this._range=M,this._newText=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=r=Ve([T],K),e.TextEdit=K;let Z=l=class{static isNotebookCellEdit(M){return M instanceof l?!0:M?jt.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,ie){return new l(M,ie)}static insertCells(M,ie){return new l(new jt(M,M),ie)}static deleteCells(M){return new l(M,[])}static updateCellMetadata(M,ie){const we=new l(new jt(M,M),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(M){const ie=new l(new jt(0,0),[]);return ie.newNotebookMetadata=M,ie}constructor(M,ie){this.range=M,this.newCells=ie}};Z=l=Ve([T],Z),e.NotebookEdit=Z;class he{static isSnippetTextEdit(M){return M instanceof he?!0:M?pe.isRange(M.range)&&je.isSnippetString(M.snippet):!1}static replace(M,ie){return new he(M,ie)}static insert(M,ie){return he.replace(new pe(M,M),ie)}constructor(M,ie){this.range=M,this.snippet=ie}}e.SnippetTextEdit=he;var ke;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(ke=e.FileEditType||(e.FileEditType={}));let Fe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ie,we,qe){this._edits.push({_type:1,from:M,to:ie,options:we,metadata:qe})}createFile(M,ie,we){this._edits.push({_type:1,from:void 0,to:M,options:ie,metadata:we})}deleteFile(M,ie,we){this._edits.push({_type:1,from:M,to:void 0,options:ie,metadata:we})}replaceNotebookMetadata(M,ie,we){this._edits.push({_type:3,metadata:we,uri:M,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(M,ie,we,qe){const Ye=ie.start,at=ie.end;(Ye!==at||we.length>0)&&this._edits.push({_type:5,uri:M,index:Ye,count:at-Ye,cells:we,metadata:qe})}replaceNotebookCellMetadata(M,ie,we,qe){this._edits.push({_type:3,metadata:qe,uri:M,edit:{editType:8,index:ie,metadata:we}})}replace(M,ie,we,qe){this._edits.push({_type:2,uri:M,edit:new K(ie,we),metadata:qe})}insert(M,ie,we,qe){this.replace(M,new pe(ie,ie),we,qe)}delete(M,ie,we){this.replace(M,ie,"",we)}has(M){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===M.toString())}set(M,ie){if(ie)for(const we of ie){if(!we)continue;let qe,Ye;Array.isArray(we)?(qe=we[0],Ye=we[1]):qe=we,Z.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(M,qe.range.start,qe.newCellMetadata,Ye):qe.newNotebookMetadata?this.replaceNotebookMetadata(M,qe.newNotebookMetadata,Ye):this.replaceNotebookCells(M,qe.range,qe.newCells,Ye):he.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:M,range:qe.range,edit:qe.snippet,metadata:Ye}):this._edits.push({_type:2,uri:M,edit:qe,metadata:Ye})}else{for(let we=0;we<this._edits.length;we++){const qe=this._edits[we];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===M.toString()&&(this._edits[we]=void 0);break}}(0,n.coalesceInPlace)(this._edits)}}get(M){const ie=[];for(const we of this._edits)we._type===2&&we.uri.toString()===M.toString()&&ie.push(we.edit);return ie}entries(){const M=new N.ResourceMap;for(const ie of this._edits)if(ie._type===2){let we=M.get(ie.uri);we||(we=[ie.uri,[]],M.set(ie.uri,we)),we[1].push(ie.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Fe=Ve([T],Fe),e.WorkspaceEdit=Fe;let je=i=class{static isSnippetString(M){return M instanceof i?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this._tabstop=1,this.value=M||""}appendText(M){return this.value+=i._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ie=this._tabstop++){if(typeof M=="function"){const we=new i;we._tabstop=this._tabstop,M(we),this._tabstop=we._tabstop,M=we.value}else M=i._escape(M);return this.value+="${",this.value+=ie,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ie=this._tabstop++){const we=M.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(M,ie){if(typeof ie=="function"){const we=new i;we._tabstop=this._tabstop,ie(we),this._tabstop=we._tabstop,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};je=i=Ve([T],je),e.SnippetString=je;var Te;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let De=p=class{static isLocation(M){return M instanceof p?!0:M?pe.isRange(M.range)&&I.URI.isUri(M.uri):!1}constructor(M,ie){if(this.uri=M,ie)if(pe.isRange(ie))this.range=pe.of(ie);else if(de.isPosition(ie))this.range=new pe(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};De=p=Ve([T],De),e.Location=De;let oe=class{static is(M){return M?typeof M.message=="string"&&M.location&&pe.isRange(M.location.range)&&I.URI.isUri(M.location.uri):!1}constructor(M,ie){this.location=M,this.message=ie}static isEqual(M,ie){return M===ie?!0:!M||!ie?!1:M.message===ie.message&&M.location.range.isEqual(ie.location.range)&&M.location.uri.toString()===ie.location.uri.toString()}};oe=Ve([T],oe),e.DiagnosticRelatedInformation=oe;let ue=class{constructor(M,ie,we=Se.Error){if(!pe.isRange(M))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=M,this.message=ie,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ie){return M===ie?!0:!M||!ie?!1:M.message===ie.message&&M.severity===ie.severity&&M.code===ie.code&&M.severity===ie.severity&&M.source===ie.source&&M.range.isEqual(ie.range)&&(0,n.equals)(M.tags,ie.tags)&&(0,n.equals)(M.relatedInformation,ie.relatedInformation,oe.isEqual)}};ue=Ve([T],ue),e.Diagnostic=ue;let Y=class{constructor(M,ie){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ie}};Y=Ve([T],Y),e.Hover=Y;var D;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let U=class{constructor(M,ie=D.Text){this.range=M,this.kind=ie}toJSON(){return{range:this.range,kind:D[this.kind]}}};U=Ve([T],U),e.DocumentHighlight=U;var $;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})($=e.SymbolKind||(e.SymbolKind={}));var V;(function(x){x[x.Deprecated=1]="Deprecated"})(V=e.SymbolTag||(e.SymbolTag={}));let ee=c=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,ie,we,qe,Ye){this.name=M,this.kind=ie,this.containerName=Ye,typeof we=="string"&&(this.containerName=we),qe instanceof De?this.location=qe:we instanceof pe&&(this.location=new De(qe,we)),c.validate(this)}toJSON(){return{name:this.name,kind:$[this.kind],location:this.location,containerName:this.containerName}}};ee=c=Ve([T],ee),e.SymbolInformation=ee;let me=s=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(s.validate)}constructor(M,ie,we,qe,Ye){this.name=M,this.detail=ie,this.kind=we,this.range=qe,this.selectionRange=Ye,this.children=[],s.validate(this)}};me=s=Ve([T],me),e.DocumentSymbol=me;var _e;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(_e=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ce=class{constructor(M,ie){this.title=M,this.kind=ie}};ce=Ve([T],ce),e.CodeAction=ce;let Ee=d=class{constructor(M){this.value=M}append(M){return new d(this.value?this.value+d.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+d.sep)}};Ee.sep=".",Ee=d=Ve([T],Ee),e.CodeActionKind=Ee,Ee.Empty=new Ee(""),Ee.QuickFix=Ee.Empty.append("quickfix"),Ee.Refactor=Ee.Empty.append("refactor"),Ee.RefactorExtract=Ee.Refactor.append("extract"),Ee.RefactorInline=Ee.Refactor.append("inline"),Ee.RefactorMove=Ee.Refactor.append("move"),Ee.RefactorRewrite=Ee.Refactor.append("rewrite"),Ee.Source=Ee.Empty.append("source"),Ee.SourceOrganizeImports=Ee.Source.append("organizeImports"),Ee.SourceFixAll=Ee.Source.append("fixAll");let be=class{constructor(M,ie){if(this.range=M,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=Ve([T],be),e.SelectionRange=be;class $e{constructor(M,ie,we,qe,Ye,at){this.kind=M,this.name=ie,this.detail=we,this.uri=qe,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=$e;class We{constructor(M,ie){this.fromRanges=ie,this.from=M}}e.CallHierarchyIncomingCall=We;class tt{constructor(M,ie){this.fromRanges=ie,this.to=M}}e.CallHierarchyOutgoingCall=tt;var Ge;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Ge=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(M,ie){this.range=M,this.command=ie}get isResolved(){return!!this.command}};et=Ve([T],et),e.CodeLens=et;let it=k=class{static isMarkdownString(M){return M instanceof k?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,ie=!1){o.set(this,void 0),Je(this,o,new y.MarkdownString(M,{supportThemeIcons:ie}),"f")}get value(){return Oe(this,o,"f").value}set value(M){Oe(this,o,"f").value=M}get isTrusted(){return Oe(this,o,"f").isTrusted}set isTrusted(M){Oe(this,o,"f").isTrusted=M}get supportThemeIcons(){return Oe(this,o,"f").supportThemeIcons}set supportThemeIcons(M){Oe(this,o,"f").supportThemeIcons=M}get supportHtml(){return Oe(this,o,"f").supportHtml}set supportHtml(M){Oe(this,o,"f").supportHtml=M}get baseUri(){return Oe(this,o,"f").baseUri}set baseUri(M){Oe(this,o,"f").baseUri=M}appendText(M){return Oe(this,o,"f").appendText(M),this}appendMarkdown(M){return Oe(this,o,"f").appendMarkdown(M),this}appendCodeblock(M,ie){return Oe(this,o,"f").appendCodeblock(ie??"",M),this}};o=new WeakMap,it=k=Ve([T],it),e.MarkdownString=it;let dt=class{constructor(M,ie){this.label=M,this.documentation=ie}};dt=Ve([T],dt),e.ParameterInformation=dt;let Le=class{constructor(M,ie){this.label=M,this.documentation=ie,this.parameters=[]}};Le=Ve([T],Le),e.SignatureInformation=Le;let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ot=Ve([T],ot),e.SignatureHelp=ot;var X;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var G;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(G=e.InlayHintKind||(e.InlayHintKind={}));let ve=class{constructor(M){this.value=M}};ve=Ve([T],ve),e.InlayHintLabelPart=ve;let Ne=class{constructor(M,ie,we){this.position=M,this.label=ie,this.kind=we}};Ne=Ve([T],Ne),e.InlayHint=Ne;var xe;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var Qe;(function(x){x[x.Deprecated=1]="Deprecated"})(Qe=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(M,ie){this.label=M,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=Ve([T],nt),e.CompletionItem=nt;let vt=class{constructor(M=[],ie=!1){this.items=M,this.isIncomplete=ie}};vt=Ve([T],vt),e.CompletionList=vt;let wt=class{constructor(M,ie,we){this.insertText=M,this.range=ie,this.command=we}};wt=Ve([T],wt),e.InlineSuggestion=wt;let Ct=class{constructor(M){this.commands=void 0,this.items=M}};Ct=Ve([T],Ct),e.InlineSuggestionList=Ct;var Ht;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Ht=e.ViewColumn||(e.ViewColumn={}));var rt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Lt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Lt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Kt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Tt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Tt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var It;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(It=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function M(ie){switch(ie){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=M}(Tt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ut=class{constructor(M,ie){if(ie&&!I.URI.isUri(ie))throw(0,C.illegalArgument)("target");if(!pe.isRange(M)||M.isEmpty)throw(0,C.illegalArgument)("range");this.range=M,this.target=ie}};Ut=Ve([T],Ut),e.DocumentLink=Ut;let Rt=class{constructor(M,ie,we,qe){this.red=M,this.green=ie,this.blue=we,this.alpha=qe}};Rt=Ve([T],Rt),e.Color=Rt;let Ke=class{constructor(M,ie){if(ie&&!(ie instanceof Rt))throw(0,C.illegalArgument)("color");if(!pe.isRange(M)||M.isEmpty)throw(0,C.illegalArgument)("range");this.range=M,this.color=ie}};Ke=Ve([T],Ke),e.ColorInformation=Ke;let Ft=class{constructor(M){if(!M||typeof M!="string")throw(0,C.illegalArgument)("label");this.label=M}};Ft=Ve([T],Ft),e.ColorPresentation=Ft;var Nt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Nt=e.ColorFormat||(e.ColorFormat={}));var xt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(xt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ft;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(ft=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(M,ie,we){if(this.startIndex=M,this.length=ie,this.tooltip=we,typeof M!="number"||M<0)throw(0,C.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=ye;class Pe{constructor(M){this.uri=M}}e.TerminalQuickFixOpener=Pe;class ge{constructor(M){this.terminalCommand=M}}e.TerminalQuickFixCommand=ge;var q;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(q=e.TerminalLocation||(e.TerminalLocation={}));class Ae{constructor(M){if(this.options=M,typeof M!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Ae;var Ue;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Ue=e.TaskRevealKind||(e.TaskRevealKind={}));var Xe;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Xe=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=A=class{static from(M){switch(M){case"clean":return A.Clean;case"build":return A.Build;case"rebuild":return A.Rebuild;case"test":return A.Test;default:return}}constructor(M,ie){if(this.label=ie,typeof M!="string"||typeof ie!="string")throw(0,C.illegalArgument)("name");this._id=M}get id(){return this._id}};Be.Clean=new A("clean","Clean"),Be.Build=new A("build","Build"),Be.Rebuild=new A("rebuild","Rebuild"),Be.Test=new A("test","Test"),Be=A=Ve([T],Be),e.TaskGroup=Be;function Ze(x){let M="";for(let ie=0;ie<x.length;ie++)M+=x[ie].replace(/,/g,",,")+",";return M}let ct=class{constructor(M,ie,we){if(typeof M!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=M,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=we):this._options=ie)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,C.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(const ie of this._args)M.push(ie);return Ze(M)}};ct=Ve([T],ct),e.ProcessExecution=ct;let kt=class{constructor(M,ie,we){if(this._args=[],Array.isArray(ie)){if(!M)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,C.illegalArgument)("command");this._command=M,this._args=ie,this._options=we}else{if(typeof M!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=M,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,C.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ie of this._args)M.push(typeof ie=="string"?ie:ie.value);return Ze(M)}};kt=Ve([T],kt),e.ShellExecution=kt;var Et;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Et=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class Dt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Dt;let St=W=class{constructor(M,ie,we,qe,Ye,at){this.__deprecated=!1,this._definition=this.definition=M;let ut;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=we,this.execution=qe,ut=Ye,this.__deprecated=!0):ie===bt.Global||ie===bt.Workspace?(this.target=ie,this._name=this.name=we,this._source=this.source=qe,this.execution=Ye,ut=at):(this.target=ie,this._name=this.name=we,this._source=this.source=qe,this.execution=Ye,ut=at),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ct?this._definition={type:W.ProcessType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:W.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:W.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:W.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ie=this._definition.type;(W.EmptyType===ie||W.ProcessType===ie||W.ShellType===ie||W.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};St.ExtensionCallbackType="customExecution",St.ProcessType="process",St.ShellType="shell",St.EmptyType="$empty",St=W=Ve([T],St),e.Task=St;var _t;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));var Vt;(function(x){function M(ie){const we=ie;return(0,_.isNumber)(we.value)?we.tooltip&&!(0,_.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}x.isViewBadge=M})(Vt=e.ViewBadge||(e.ViewBadge={}));let Jt=J=class{static isTreeItem(M,ie){if(M instanceof J)return!0;const we=M;if(we.label!==void 0&&!(0,_.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,_.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,_.isString)(we.iconPath)&&!I.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,_.isString)(we.iconPath.id))){const qe=we.iconPath;if(!qe||!(0,_.isString)(qe.light)&&!I.URI.isUri(qe.light)&&!(0,_.isString)(qe.dark)&&!I.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,_.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!I.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,_.isString)(we.tooltip)&&!(we.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<pt.None&&we.collapsibleState>pt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,_.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(ie,"treeItemCheckbox");const qe=(0,_.isNumber)(we.checkboxState)?we.checkboxState:(0,_.isObject)(we.checkboxState)&&(0,_.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Ye=!(0,_.isNumber)(we.checkboxState)&&(0,_.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(qe===void 0||qe!==si.Checked&&qe!==si.Unchecked||Ye!==void 0&&!(0,_.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(M,ie=pt.None){this.collapsibleState=ie,I.URI.isUri(M)?this.resourceUri=M:this.label=M}};Jt=J=Ve([T],Jt),e.TreeItem=Jt;var pt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M,ie){this.value=M,this.id=ie??(0,L.generateUuid)()}};oi=Ve([T],oi),e.DataTransferItem=oi;let Zt=class{constructor(M){u.set(this,new Map);for(const[ie,we]of M??[]){const qe=Oe(this,u,"f").get(ie);qe?qe.push(we):Oe(this,u,"f").set(ie,[we])}}get(M){return Oe(this,u,"f").get(M)?.[0]}set(M,ie){Oe(this,u,"f").set(M,[ie])}forEach(M,ie){for(const[we,qe]of Oe(this,u,"f"))for(const Ye of qe)M.call(ie,Ye,we,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[M,ie]of Oe(this,u,"f"))for(const we of ie)yield[M,we]}};Zt=Ve([T],Zt),e.DataTransfer=Zt;let vi=class{constructor(M){this.insertText=M}};vi=Ve([T],vi),e.DocumentDropEdit=vi;let Pt=class{constructor(M){this.insertText=M}};Pt=Ve([T],Pt),e.DocumentPasteEdit=Pt;let $t=class{constructor(M,ie){this.id=M,this.color=ie}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};$t=Ve([T],$t),e.ThemeIcon=$t,$t.File=new $t("file"),$t.Folder=new $t("folder");let Ei=class{constructor(M){this.id=M}};Ei=Ve([T],Ei),e.ThemeColor=Ei;var ai;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this._base}set base(M){this._base=M,this._baseUri=I.URI.file(M)}get baseUri(){return this._baseUri}set baseUri(M){this._baseUri=M,this._base=M.fsPath}constructor(M,ie){if(typeof M!="string"&&(!M||!I.URI.isUri(M)&&!I.URI.isUri(M.uri)))throw(0,C.illegalArgument)("base");if(typeof ie!="string")throw(0,C.illegalArgument)("pattern");typeof M=="string"?this.baseUri=I.URI.file(M):I.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=Ve([T],ei),e.RelativePattern=ei;const lt=new WeakMap;function Ui(x,M){lt.set(x,M)}e.setBreakpointId=Ui;let Mt=class{constructor(M,ie,we,qe){this.enabled=typeof M=="boolean"?M:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=lt.get(this)??(0,L.generateUuid)()),this._id}};Mt=Ve([T],Mt),e.Breakpoint=Mt;let Xt=class extends Mt{constructor(M,ie,we,qe,Ye){if(super(ie,we,qe,Ye),M===null)throw(0,C.illegalArgument)("location");this.location=M}};Xt=Ve([T],Xt),e.SourceBreakpoint=Xt;let ci=class extends Mt{constructor(M,ie,we,qe,Ye){super(ie,we,qe,Ye),this.functionName=M}};ci=Ve([T],ci),e.FunctionBreakpoint=ci;let bi=class extends Mt{constructor(M,ie,we,qe,Ye,at,ut){if(super(qe,Ye,at,ut),!ie)throw(0,C.illegalArgument)("dataId");this.label=M,this.dataId=ie,this.canPersist=we}};bi=Ve([T],bi),e.DataBreakpoint=bi;let wi=class{constructor(M,ie,we){this.command=M,this.args=ie||[],this.options=we}};wi=Ve([T],wi),e.DebugAdapterExecutable=wi;let li=class{constructor(M,ie){this.port=M,this.host=ie}};li=Ve([T],li),e.DebugAdapterServer=li;let Si=class{constructor(M){this.path=M}};Si=Ve([T],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(M){this.implementation=M}};ui=Ve([T],ui),e.DebugAdapterInlineImplementation=ui;let ti=class{constructor(M,ie){this.range=M,this.expression=ie}};ti=Ve([T],ti),e.EvaluatableExpression=ti;var Bi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(M,ie){this.range=M,this.text=ie}};ii=Ve([T],ii),e.InlineValueText=ii;let ni=class{constructor(M,ie,we=!0){this.range=M,this.variableName=ie,this.caseSensitiveLookup=we}};ni=Ve([T],ni),e.InlineValueVariableLookup=ni;let _i=class{constructor(M,ie){this.range=M,this.expression=ie}};_i=Ve([T],_i),e.InlineValueEvaluatableExpression=_i;let yi=class{constructor(M,ie){this.frameId=M,this.stoppedLocation=ie}};yi=Ve([T],yi),e.InlineValueContext=yi;var ri;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Di=j=class extends Error{static FileExists(M){return new j(M,w.FileSystemProviderErrorCode.FileExists,j.FileExists)}static FileNotFound(M){return new j(M,w.FileSystemProviderErrorCode.FileNotFound,j.FileNotFound)}static FileNotADirectory(M){return new j(M,w.FileSystemProviderErrorCode.FileNotADirectory,j.FileNotADirectory)}static FileIsADirectory(M){return new j(M,w.FileSystemProviderErrorCode.FileIsADirectory,j.FileIsADirectory)}static NoPermissions(M){return new j(M,w.FileSystemProviderErrorCode.NoPermissions,j.NoPermissions)}static Unavailable(M){return new j(M,w.FileSystemProviderErrorCode.Unavailable,j.Unavailable)}constructor(M,ie=w.FileSystemProviderErrorCode.Unknown,we){super(I.URI.isUri(M)?M.toString(!0):M),this.code=we?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,j.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};Di=j=Ve([T],Di),e.FileSystemError=Di;let Ci=class{constructor(M,ie,we){this.start=M,this.end=ie,this.kind=we}};Ci=Ve([T],Ci),e.FoldingRange=Ci;var xi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(xi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $i;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})($i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var zi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(zi=e.CommentMode||(e.CommentMode={}));var Ii;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Ii=e.CommentThreadState||(e.CommentThreadState={}));class Ai{constructor(M,ie=[]){this.tokenTypes=M,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ai;function Ri(x){return typeof x>"u"||(0,_.isStringArray)(x)}class Me{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ie=0,we=M.tokenTypes.length;ie<we;ie++)this._tokenTypeStrToInt.set(M.tokenTypes[ie],ie);for(let ie=0,we=M.tokenModifiers.length;ie<we;ie++)this._tokenModifierStrToInt.set(M.tokenModifiers[ie],ie)}}push(M,ie,we,qe,Ye){if(typeof M=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof qe=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(M,ie,we,qe,Ye);if(pe.isRange(M)&&typeof ie=="string"&&Ri(we))return this._push(M,ie,we);throw(0,C.illegalArgument)()}_push(M,ie,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const qe=M.start.line,Ye=M.start.character,at=M.end.character-M.start.character,ut=this._tokenTypeStrToInt.get(ie);let Ot=0;if(we)for(const Wt of we){if(!this._tokenModifierStrToInt.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this._tokenModifierStrToInt.get(Wt);Ot|=1<<qt>>>0}this._pushEncoded(qe,Ye,at,ut,Ot)}_pushEncoded(M,ie,we,qe,Ye){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ot=this._data.length/5|0;let Wt=0,qt=0;for(let Gt=0;Gt<Ot;Gt++){let Qt=this._data[5*Gt],Ti=this._data[5*Gt+1];Qt===0?(Qt=Wt,Ti+=qt):Qt+=Wt,this._data[5*Gt]=Qt,this._data[5*Gt+1]=Ti,Wt=Qt,qt=Ti}}let at=M,ut=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=we,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Ye,this._prevLine=M,this._prevChar=ie}static _sortAndDeltaEncode(M){const ie=[],we=M.length/5|0;for(let ut=0;ut<we;ut++)ie[ut]=ut;ie.sort((ut,Ot)=>{const Wt=M[5*ut],qt=M[5*Ot];if(Wt===qt){const Gt=M[5*ut+1],Qt=M[5*Ot+1];return Gt-Qt}return Wt-qt});const qe=new Uint32Array(M.length);let Ye=0,at=0;for(let ut=0;ut<we;ut++){const Ot=5*ie[ut],Wt=M[Ot+0],qt=M[Ot+1],Gt=M[Ot+2],Qt=M[Ot+3],Ti=M[Ot+4],sn=Wt-Ye,An=sn===0?qt-at:qt,Pi=5*ut;qe[Pi+0]=sn,qe[Pi+1]=An,qe[Pi+2]=Gt,qe[Pi+3]=Qt,qe[Pi+4]=Ti,Ye=Wt,at=qt}return qe}build(M){return this._dataIsSortedAndDeltaEncoded?new zt(new Uint32Array(this._data),M):new zt(Me._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Me;class zt{constructor(M,ie){this.resultId=ie,this.data=M}}e.SemanticTokens=zt;class Oi{constructor(M,ie,we){this.start=M,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Oi;class gt{constructor(M,ie){this.resultId=ie,this.edits=M}}e.SemanticTokensEdits=gt;var Wi;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Wi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new $t("arrow-left")},di=Ve([T],di),e.QuickInputButtons=di;var Li;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Li=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Hi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Hi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class Vi{static validate(M){if(typeof M.badge=="string"){let ie=(0,P.nextCharLength)(M.badge,0);if(ie<M.badge.length&&(ie+=(0,P.nextCharLength)(M.badge,ie)),M.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!$t.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,ie,we){this.badge=M,this.tooltip=ie,this.color=we}}e.FileDecoration=Vi;let ki=class{constructor(M){this.kind=M}};ki=Ve([T],ki),e.ColorTheme=ki;var ji;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(ji=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange(M){return M instanceof jt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(M,ie){if(M<0)throw(0,C.illegalArgument)("start must be positive");if(ie<0)throw(0,C.illegalArgument)("end must be positive");M<=ie?(this._start=M,this._end=ie):(this._start=ie,this._end=M)}with(M){let ie=this._start,we=this._end;return M.start!==void 0&&(ie=M.start),M.end!==void 0&&(we=M.end),ie===this._start&&we===this._end?this:new jt(ie,we)}}e.NotebookRange=jt;class fi{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ie=>fi.isNotebookCellData(ie))}static isNotebookCellData(M){return!0}constructor(M,ie,we,qe,Ye,at,ut){this.kind=M,this.value=ie,this.languageId=we,this.mime=qe,this.outputs=Ye??[],this.metadata=at,this.executionSummary=ut,fi.validate(this)}}e.NotebookCellData=fi;class qi{constructor(M){this.cells=M}}e.NotebookData=qi;class Bt{static isNotebookCellOutputItem(M){return M instanceof Bt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ie={name:M.name,message:M.message,stack:M.stack};return Bt.json(ie,"application/vnd.code.notebook.error")}static stdout(M){return Bt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Bt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ie="application/octet-stream"){return new Bt(M,ie)}static text(M,ie=S.Mimes.text){const we=Oe(Bt,g,"f",b).encode(String(M));return new Bt(we,ie)}static json(M,ie="text/x-json"){const we=JSON.stringify(M,void 0,"	");return Bt.text(we,ie)}constructor(M,ie){this.data=M,this.mime=ie;const we=(0,S.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}g=Bt,b={value:new TextEncoder},e.NotebookCellOutputItem=Bt;class mi{static isNotebookCellOutput(M){return M instanceof mi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,ie=!1){const we=new Set,qe=new Set;for(let Ye=0;Ye<M.length;Ye++){const at=M[Ye],ut=(0,S.normalizeMimeType)(at.mime);if(!we.has(ut)||(0,E.isTextStreamMime)(ut)){we.add(ut);continue}qe.add(Ye),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return qe.size===0?M:M.filter((Ye,at)=>!qe.has(at))}constructor(M,ie,we){this.items=mi.ensureUniqueMimeTypes(M,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,L.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=mi;var Ki;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Gi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Gi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ne;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var fe;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(fe=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Re{constructor(M,ie){this.text=M,this.alignment=ie}}e.NotebookCellStatusBarItem=Re;var st;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var yt;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(yt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class At{constructor(M,ie=[]){this.uri=M,this.provides=(0,n.asArray)(ie)}}e.NotebookRendererScript=At;class ln{constructor(M){this.label=M}}e.NotebookKernelSourceAction=ln;let Xi=class{constructor(M,ie){this.label=M,this.timestamp=ie}};Xi=Ve([T],Xi),e.TimelineItem=Xi;var un;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(M,ie){this.ranges=M,this.wordPattern=ie}}e.LinkedEditingRanges=fn;class mn{constructor(M,ie){this._port=M,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=mn;var gn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(M=void 0,ie=void 0,we=void 0){this.include=M,this.exclude=ie,this.profile=we}};Fi=Ve([T],Fi),e.TestRunRequest=Fi;let Qi=class extends Fi{constructor(M=void 0,ie=void 0,we=void 0,qe=!1){super(M,ie,we),this.continuous=qe}};Qi=Ve([T],Qi),e.TestRunRequest2=Qi;let Yi=O=class{static diff(M,ie,we){const qe=new O(M);return qe.expectedOutput=ie,qe.actualOutput=we,qe}constructor(M){this.message=M}};Yi=O=Ve([T],Yi),e.TestMessage=Yi;let Ji=class{constructor(M){this.id=M}};Ji=Ve([T],Ji),e.TestTag=Ji;let gi=class{constructor(M,ie){this.covered=M,this.total=ie}};gi=Ve([T],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(M,ie){const we=new gi(0,0),qe=new gi(0,0),Ye=new gi(0,0);for(const ut of ie)if("branches"in ut){we.total+=1,we.covered+=ut.executionCount>0?1:0;for(const Ot of ut.branches)qe.total+=1,qe.covered+=Ot.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ut.executionCount>0?1:0;const at=new B(M,we,qe.total>0?qe:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=ie,at}constructor(M,ie,we,qe){this.uri=M,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=qe}};Zi=B=Ve([T],Zi),e.FileCoverage=Zi;let en=class{constructor(M,ie,we=[]){this.executionCount=M,this.location=ie,this.branches=we}};en=Ve([T],en),e.StatementCoverage=en;let tn=class{constructor(M,ie){this.executionCount=M,this.location=ie}};tn=Ve([T],tn),e.BranchCoverage=tn;let nn=class{constructor(M,ie){this.executionCount=M,this.location=ie}};nn=Ve([T],nn),e.FunctionCoverage=nn;var vn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var En;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(En=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(M,ie,we,qe,Ye,at){this.kind=M,this.name=ie,this.detail=we,this.uri=qe,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=wn;class Sn{constructor(M){this.uri=M}}e.TextTabInput=Sn;class _n{constructor(M,ie){this.original=M,this.modified=ie}}e.TextDiffTabInput=_n;class yn{constructor(M,ie,we,qe){this.base=M,this.input1=ie,this.input2=we,this.result=qe}}e.TextMergeTabInput=yn;class Dn{constructor(M,ie){this.uri=M,this.viewType=ie}}e.CustomEditorTabInput=Dn;class Cn{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=Cn;class In{constructor(M,ie){this.uri=M,this.notebookType=ie}}e.NotebookEditorTabInput=In;class kn{constructor(M,ie,we){this.original=M,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=kn;class Tn{constructor(){}}e.TerminalEditorTabInput=Tn;class Pn{constructor(M,ie){this.uri=M,this.inputBoxUri=ie}}e.InteractiveWindowInput=Pn}),define(Ce[99],Ie([1,0,49,15,10,258,131,7,16]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const I=new Map;function L(m,a){a?I.set(m,a):I.delete(m)}e.setWordDefinitionFor=L;function w(m){return I.get(m)}class f extends N.MirrorTextModel{constructor(a,o,u,g,b,R,v,t){super(o,u,g,b),this._proxy=a,this._languageId=R,this._isDirty=v,this.notebook=t,this._isDisposed=!1}dispose(){(0,n.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,_.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===C.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},save(){return a._save()},getText(o){return o?a._getTextInRange(o):a.getText()},get eol(){return a._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(o){return a._lineAt(o)},offsetAt(o){return a._offsetAt(o)},positionAt(o){return a._positionAt(o)},validateRange(o){return a._validateRange(o)},validatePosition(o){return a._validatePosition(o)},getWordRangeAtPosition(o,u){return a._getWordRangeAtPosition(o,u)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,n.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,n.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const o=this._validateRange(a);if(o.isEmpty)return"";if(o.isSingleLine)return this._lines[o.start.line].substring(o.start.character,o.end.character);const u=this._eol,g=o.start.line,b=o.end.line,R=[];R.push(this._lines[g].substring(o.start.character));for(let v=g+1;v<b;v++)R.push(this._lines[v]);return R.push(this._lines[b].substring(0,o.end.character)),R.join(u)}_lineAt(a){let o;if(a instanceof P.Position?o=a.line:typeof a=="number"&&(o=a),typeof o!="number"||o<0||o>=this._lines.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new E(o,this._lines[o],o===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(a),u=this._lines[o.index].length;return new P.Position(o.index,Math.min(o.remainder,u))}_validateRange(a){if(!(a instanceof P.Range))throw new Error("Invalid argument");const o=this._validatePosition(a.start),u=this._validatePosition(a.end);return o===a.start&&u===a.end?a:new P.Range(o.line,o.character,u.line,u.character)}_validatePosition(a){if(!(a instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:o,character:u}=a,g=!1;if(o<0)o=0,u=0,g=!0;else if(o>=this._lines.length)o=this._lines.length-1,u=this._lines[o].length,g=!0;else{const b=this._lines[o].length;u<0?(u=0,g=!0):u>b&&(u=b,g=!0)}return g?new P.Position(o,u):a}_getWordRangeAtPosition(a,o){const u=this._validatePosition(a);if(!o)o=w(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const g=(0,S.getWordAtText)(u.character+1,(0,S.ensureValidWordDefinition)(o),this._lines[u.line],0);if(g)return new P.Range(u.line,g.startColumn-1,u.line,g.endColumn-1)}}e.ExtHostDocumentData=f;class E{constructor(a,o,u){this._line=a,this._text=o,this._isLastLine=u}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(Ce[193],Ie([1,0,7,18,4]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(P){this._actual=new n.ColorTheme(n.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let _;switch(P){case"light":_=n.ColorThemeKind.Light;break;case"hcDark":_=n.ColorThemeKind.HighContrast;break;case"hcLight":_=n.ColorThemeKind.HighContrastLight;break;default:_=n.ColorThemeKind.Dark}this._actual=new n.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};N=Ve([He(0,C.IExtHostRpcService)],N),e.ExtHostTheming=N}),define(Ce[8],Ie([1,0,16,23,116,194,86,28,112,65,64,22,9,2,44,75,91,96,95,70,45,56,190,7]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R,v,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(ye){function Pe(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Ue,positionLineNumber:Xe,positionColumn:Be}=q,Ze=new h.Position(Ae-1,Ue-1),ct=new h.Position(Xe-1,Be-1);return new h.Selection(Ze,ct)}ye.to=Pe;function ge(q){const{anchor:Ae,active:Ue}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}ye.from=ge})(r=e.Selection||(e.Selection={}));var l;(function(ye){function Pe(q){if(!q)return;const{start:Ae,end:Ue}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}ye.from=Pe;function ge(q){if(!q)return;const{startLineNumber:Ae,startColumn:Ue,endLineNumber:Xe,endColumn:Be}=q;return new h.Range(Ae-1,Ue-1,Xe-1,Be-1)}ye.to=ge})(l=e.Range||(e.Range={}));var i;(function(ye){function Pe(ge){switch(ge){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}ye.to=Pe})(i=e.TokenType||(e.TokenType={}));var p;(function(ye){function Pe(q){return new h.Position(q.lineNumber-1,q.column-1)}ye.to=Pe;function ge(q){return{lineNumber:q.line+1,column:q.character+1}}ye.from=ge})(p=e.Position||(e.Position={}));var c;(function(ye){function Pe(Ae,Ue){return(0,n.coalesce)((0,n.asArray)(Ae).map(Xe=>ge(Xe,Ue)))}ye.from=Pe;function ge(Ae,Ue){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:q(Ae.scheme,Ue),pattern:G.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function q(Ae,Ue){return Ue&&typeof Ae=="string"?Ue.transformOutgoingScheme(Ae):Ae}})(c=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(ye){function Pe(q){switch(q){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}ye.from=Pe;function ge(q){switch(q){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}ye.to=ge})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var d;(function(ye){function Pe(q){let Ae;return q.code&&((0,f.isString)(q.code)||(0,f.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...l.from(q.range),message:q.message,source:q.source,code:Ae,severity:A.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(k.from),tags:Array.isArray(q.tags)?(0,n.coalesce)(q.tags.map(s.from)):void 0}}ye.from=Pe;function ge(q){const Ae=new h.Diagnostic(l.to(q),q.message,A.to(q.severity));return Ae.source=q.source,Ae.code=(0,f.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(k.to),Ae.tags=q.tags&&(0,n.coalesce)(q.tags.map(s.to)),Ae}ye.to=ge})(d=e.Diagnostic||(e.Diagnostic={}));var k;(function(ye){function Pe(q){return{...l.from(q.location.range),message:q.message,resource:q.location.uri}}ye.from=Pe;function ge(q){return new h.DiagnosticRelatedInformation(new h.Location(q.resource,l.to(q)),q.message)}ye.to=ge})(k=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var A;(function(ye){function Pe(q){switch(q){case h.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}ye.from=Pe;function ge(q){switch(q){case o.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}ye.to=ge})(A=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var W;(function(ye){function Pe(q){return typeof q=="number"&&q>=h.ViewColumn.One?q-1:q===h.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}ye.from=Pe;function ge(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=ge})(W=e.ViewColumn||(e.ViewColumn={}));function J(ye){return typeof ye.range<"u"}function j(ye){return ye.length===0?!0:!!J(ye[0])}e.isDecorationOptionsArr=j;var O;(function(ye){function Pe(Be){return Be.map(ye.from)}ye.fromMany=Pe;function ge(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function q(Be){let Ze;if(ge(Be)){const{language:bt,value:Dt}=Be;Ze={value:"```"+bt+`
`+Dt+"\n```\n"}}else h.MarkdownString.isMarkdownString(Be)?Ze={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ze={value:Be}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const kt=bt=>{try{let Dt=E.URI.parse(bt,!0);Dt=Dt.with({query:Ae(Dt.query,ct)}),ct[bt]=Dt}catch{}return""},Et=new _.marked.Renderer;return Et.link=kt,Et.image=bt=>typeof bt=="string"?kt(S.parseHrefAndDimensions(bt).href):"",(0,_.marked)(Ze.value,{renderer:Et}),Ze}ye.from=q;function Ae(Be,Ze){if(!Be)return Be;let ct;try{ct=(0,I.parse)(Be)}catch{}if(!ct)return Be;let kt=!1;return ct=(0,w.cloneAndChange)(ct,Et=>{if(E.URI.isUri(Et)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[bt]=Et,kt=!0,bt}else return}),kt?JSON.stringify(ct):Be}function Ue(Be){const Ze=new h.MarkdownString(Be.value,Be.supportThemeIcons);return Ze.isTrusted=Be.isTrusted,Ze.supportHtml=Be.supportHtml,Ze.baseUri=Be.baseUri?E.URI.from(Be.baseUri):void 0,Ze}ye.to=Ue;function Xe(Be){if(!!Be)return typeof Be=="string"?Be:ye.from(Be)}ye.fromStrict=Xe})(O=e.MarkdownString||(e.MarkdownString={}));function B(ye){return j(ye)?ye.map(Pe=>({range:l.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?O.fromMany(Pe.hoverMessage):Pe.hoverMessage?O.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):ye.map(Pe=>({range:l.from(Pe)}))}e.fromRangeOrRangeWithMessage=B;function T(ye){return typeof ye>"u"?ye:typeof ye=="string"?E.URI.file(ye):ye}e.pathOrURIToURI=T;var F;(function(ye){function Pe(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?T(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}ye.from=Pe})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(ye){function Pe(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?T(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?F.from(ge.before):void 0,after:ge.after?F.from(ge.after):void 0}}ye.from=Pe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(ye){function Pe(ge){if(typeof ge>"u")return ge;switch(ge){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Pe})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var de;(function(ye){function Pe(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?H.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?z.from(ge.light):void 0,dark:ge.dark?z.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?T(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?F.from(ge.before):void 0,after:ge.after?F.from(ge.after):void 0}}ye.from=Pe})(de=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var pe;(function(ye){function Pe(q){return{text:q.newText,eol:q.newEol&&it.from(q.newEol),range:l.from(q.range)}}ye.from=Pe;function ge(q){const Ae=new h.TextEdit(l.to(q.range),q.text);return Ae.newEol=typeof q.eol>"u"?void 0:it.to(q.eol),Ae}ye.to=ge})(pe=e.TextEdit||(e.TextEdit={}));var re;(function(ye){function Pe(q,Ae){const Ue={edits:[]};if(q instanceof h.WorkspaceEdit){const Xe=new P.ResourceSet;for(const Be of q._allEntries())Be._type===1&&E.URI.isUri(Be.to)&&Be.from===void 0&&Xe.add(Be.to);for(const Be of q._allEntries())Be._type===1?Ue.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?Ue.edits.push({resource:Be.uri,textEdit:pe.from(Be.edit),versionId:Xe.has(Be.uri)?void 0:Ae?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Ue.edits.push({resource:Be.uri,textEdit:{range:l.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Xe.has(Be.uri)?void 0:Ae?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Ue.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Ue.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(vt.from)}})}return Ue}ye.from=Pe;function ge(q){const Ae=new h.WorkspaceEdit;for(const Ue of q.edits)Ue.textEdit?Ae.replace(E.URI.revive(Ue.resource),l.to(Ue.textEdit.range),Ue.textEdit.text):Ae.renameFile(E.URI.revive(Ue.oldResource),E.URI.revive(Ue.newResource),Ue.options);return Ae}ye.to=ge})(re=e.WorkspaceEdit||(e.WorkspaceEdit={}));var le;(function(ye){const Pe=Object.create(null);Pe[h.SymbolKind.File]=0,Pe[h.SymbolKind.Module]=1,Pe[h.SymbolKind.Namespace]=2,Pe[h.SymbolKind.Package]=3,Pe[h.SymbolKind.Class]=4,Pe[h.SymbolKind.Method]=5,Pe[h.SymbolKind.Property]=6,Pe[h.SymbolKind.Field]=7,Pe[h.SymbolKind.Constructor]=8,Pe[h.SymbolKind.Enum]=9,Pe[h.SymbolKind.Interface]=10,Pe[h.SymbolKind.Function]=11,Pe[h.SymbolKind.Variable]=12,Pe[h.SymbolKind.Constant]=13,Pe[h.SymbolKind.String]=14,Pe[h.SymbolKind.Number]=15,Pe[h.SymbolKind.Boolean]=16,Pe[h.SymbolKind.Array]=17,Pe[h.SymbolKind.Object]=18,Pe[h.SymbolKind.Key]=19,Pe[h.SymbolKind.Null]=20,Pe[h.SymbolKind.EnumMember]=21,Pe[h.SymbolKind.Struct]=22,Pe[h.SymbolKind.Event]=23,Pe[h.SymbolKind.Operator]=24,Pe[h.SymbolKind.TypeParameter]=25;function ge(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}ye.from=ge;function q(Ae){for(const Ue in Pe)if(Pe[Ue]===Ae)return Number(Ue);return h.SymbolKind.Property}ye.to=q})(le=e.SymbolKind||(e.SymbolKind={}));var ae;(function(ye){function Pe(q){switch(q){case h.SymbolTag.Deprecated:return 1}}ye.from=Pe;function ge(q){switch(q){case 1:return h.SymbolTag.Deprecated}}ye.to=ge})(ae=e.SymbolTag||(e.SymbolTag={}));var se;(function(ye){function Pe(q){return{name:q.name,kind:le.from(q.kind),tags:q.tags&&q.tags.map(ae.from),containerName:q.containerName,location:ke.from(q.location)}}ye.from=Pe;function ge(q){const Ae=new h.SymbolInformation(q.name,le.to(q.kind),q.containerName,ke.to(q.location));return Ae.tags=q.tags&&q.tags.map(ae.to),Ae}ye.to=ge})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(ye){function Pe(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:l.from(q.range),selectionRange:l.from(q.selectionRange),kind:le.from(q.kind),tags:q.tags?.map(ae.from)??[]};return q.children&&(Ae.children=q.children.map(Pe)),Ae}ye.from=Pe;function ge(q){const Ae=new h.DocumentSymbol(q.name,q.detail,le.to(q.kind),l.to(q.range),l.to(q.selectionRange));return(0,n.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(ae.to)),q.children&&(Ae.children=q.children.map(ge)),Ae}ye.to=ge})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var K;(function(ye){function Pe(q){const Ae=new h.CallHierarchyItem(le.to(q.kind),q.name,q.detail||"",E.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}ye.to=Pe;function ge(q,Ae,Ue){if(Ae=Ae??q._sessionId,Ue=Ue??q._itemId,Ae===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ue,name:q.name,detail:q.detail,kind:le.from(q.kind),uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(ae.from)}}ye.from=ge})(K=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Z;(function(ye){function Pe(ge){return new h.CallHierarchyIncomingCall(K.to(ge.from),ge.fromRanges.map(q=>l.to(q)))}ye.to=Pe})(Z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var he;(function(ye){function Pe(ge){return new h.CallHierarchyOutgoingCall(K.to(ge.to),ge.fromRanges.map(q=>l.to(q)))}ye.to=Pe})(he=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ke;(function(ye){function Pe(q){return{range:q.range&&l.from(q.range),uri:q.uri}}ye.from=Pe;function ge(q){return new h.Location(E.URI.revive(q.uri),l.to(q.range))}ye.to=ge})(ke=e.location||(e.location={}));var Fe;(function(ye){function Pe(q){const Ae=q,Ue=q;return{originSelectionRange:Ae.originSelectionRange?l.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ue.uri,range:l.from(Ae.targetRange?Ae.targetRange:Ue.range),targetSelectionRange:Ae.targetSelectionRange?l.from(Ae.targetSelectionRange):void 0}}ye.from=Pe;function ge(q){return{targetUri:E.URI.revive(q.uri),targetRange:l.to(q.range),targetSelectionRange:q.targetSelectionRange?l.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?l.to(q.originSelectionRange):void 0}}ye.to=ge})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var je;(function(ye){function Pe(q){return{range:l.from(q.range),contents:O.fromMany(q.contents)}}ye.from=Pe;function ge(q){return new h.Hover(q.contents.map(O.to),l.to(q.range))}ye.to=ge})(je=e.Hover||(e.Hover={}));var Te;(function(ye){function Pe(q){return{range:l.from(q.range),expression:q.expression}}ye.from=Pe;function ge(q){return new h.EvaluatableExpression(l.to(q.range),q.expression)}ye.to=ge})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(ye){function Pe(q){if(q instanceof h.InlineValueText)return{type:"text",range:l.from(q.range),text:q.text};if(q instanceof h.InlineValueVariableLookup)return{type:"variable",range:l.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Pe;function ge(q){switch(q.type){case"text":return{range:l.to(q.range),text:q.text};case"variable":return{range:l.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:l.to(q.range),expression:q.expression}}}ye.to=ge})(Se=e.InlineValue||(e.InlineValue={}));var De;(function(ye){function Pe(q){return{frameId:q.frameId,stoppedLocation:l.from(q.stoppedLocation)}}ye.from=Pe;function ge(q){return new h.InlineValueContext(q.frameId,l.to(q.stoppedLocation))}ye.to=ge})(De=e.InlineValueContext||(e.InlineValueContext={}));var oe;(function(ye){function Pe(q){return{range:l.from(q.range),kind:q.kind}}ye.from=Pe;function ge(q){return new h.DocumentHighlight(l.to(q.range),q.kind)}ye.to=ge})(oe=e.DocumentHighlight||(e.DocumentHighlight={}));var ue;(function(ye){function Pe(ge){switch(ge){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}ye.to=Pe})(ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(ye){function Pe(ge){return{triggerKind:ue.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}ye.to=Pe})(Y=e.CompletionContext||(e.CompletionContext={}));var D;(function(ye){function Pe(q){switch(q){case h.CompletionItemTag.Deprecated:return 1}}ye.from=Pe;function ge(q){switch(q){case 1:return h.CompletionItemTag.Deprecated}}ye.to=ge})(D=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(ye){const Pe=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ge(Ue){return Pe.get(Ue)??9}ye.from=ge;const q=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Ae(Ue){return q.get(Ue)??h.CompletionItemKind.Property}ye.to=Ae})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var $;(function(ye){function Pe(ge,q){const Ae=new h.CompletionItem(ge.label);return Ae.insertText=ge.insertText,Ae.kind=U.to(ge.kind),Ae.tags=ge.tags?.map(D.to),Ae.detail=ge.detail,Ae.documentation=S.isMarkdownString(ge.documentation)?O.to(ge.documentation):ge.documentation,Ae.sortText=ge.sortText,Ae.filterText=ge.filterText,Ae.preselect=ge.preselect,Ae.commitCharacters=ge.commitCharacters,m.Range.isIRange(ge.range)?Ae.range=l.to(ge.range):typeof ge.range=="object"&&(Ae.range={inserting:l.to(ge.range.insert),replacing:l.to(ge.range.replace)}),Ae.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Ae.insertText=new h.SnippetString(ge.insertText):(Ae.insertText=ge.insertText,Ae.textEdit=Ae.range instanceof h.Range?new h.TextEdit(Ae.range,Ae.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ge.additionalTextEdits.map(Ue=>pe.to(Ue))),Ae.command=q&&ge.command?q.fromInternal(ge.command):void 0,Ae}ye.to=Pe})($=e.CompletionItem||(e.CompletionItem={}));var V;(function(ye){function Pe(q){if(typeof q.label!="string"&&!Array.isArray(q.label))throw new TypeError("Invalid label");return{label:q.label,documentation:O.fromStrict(q.documentation)}}ye.from=Pe;function ge(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?O.to(q.documentation):q.documentation}}ye.to=ge})(V=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(ye){function Pe(q){return{label:q.label,documentation:O.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(V.from):[],activeParameter:q.activeParameter}}ye.from=Pe;function ge(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?O.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(V.to):[],activeParameter:q.activeParameter}}ye.to=ge})(ee=e.SignatureInformation||(e.SignatureInformation={}));var me;(function(ye){function Pe(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(ee.from):[]}}ye.from=Pe;function ge(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(ee.to):[]}}ye.to=ge})(me=e.SignatureHelp||(e.SignatureHelp={}));var _e;(function(ye){function Pe(ge,q){const Ae=new h.InlayHint(p.to(q.position),typeof q.label=="string"?q.label:q.label.map(ce.to.bind(void 0,ge)),q.kind&&Ee.to(q.kind));return Ae.textEdits=q.textEdits&&q.textEdits.map(pe.to),Ae.tooltip=S.isMarkdownString(q.tooltip)?O.to(q.tooltip):q.tooltip,Ae.paddingLeft=q.paddingLeft,Ae.paddingRight=q.paddingRight,Ae}ye.to=Pe})(_e=e.InlayHint||(e.InlayHint={}));var ce;(function(ye){function Pe(ge,q){const Ae=new h.InlayHintLabelPart(q.label);return Ae.tooltip=S.isMarkdownString(q.tooltip)?O.to(q.tooltip):q.tooltip,a.Command.is(q.command)&&(Ae.command=ge.fromInternal(q.command)),q.location&&(Ae.location=ke.to(q.location)),Ae}ye.to=Pe})(ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ee;(function(ye){function Pe(q){return q}ye.from=Pe;function ge(q){return q}ye.to=ge})(Ee=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(ye){function Pe(q){return{range:l.from(q.range),url:q.target,tooltip:q.tooltip}}ye.from=Pe;function ge(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?E.URI.parse(q.url,!0):E.URI.revive(q.url)}catch{}return new h.DocumentLink(l.to(q.range),Ae)}ye.to=ge})(be=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ye){function Pe(q){const Ae=new h.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=pe.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Ue=>pe.to(Ue))),Ae}ye.to=Pe;function ge(q){return{label:q.label,textEdit:q.textEdit?pe.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>pe.from(Ae)):void 0}}ye.from=ge})($e=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(ye){function Pe(q){return new h.Color(q[0],q[1],q[2],q[3])}ye.to=Pe;function ge(q){return[q.red,q.green,q.blue,q.alpha]}ye.from=ge})(We=e.Color||(e.Color={}));var tt;(function(ye){function Pe(q){return{range:l.from(q.range)}}ye.from=Pe;function ge(q){return new h.SelectionRange(l.to(q.range))}ye.to=ge})(tt=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(ye){function Pe(ge){switch(ge){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}ye.to=Pe})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(ye){function Pe(q){switch(q){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Pe;function ge(q){switch(q){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}ye.to=ge})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(ye){function Pe(q){if(q===h.EndOfLine.CRLF)return 1;if(q===h.EndOfLine.LF)return 0}ye.from=Pe;function ge(q){if(q===1)return h.EndOfLine.CRLF;if(q===0)return h.EndOfLine.LF}ye.to=ge})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(ye){function Pe(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(ye){function Pe(ge){const q={start:ge.start+1,end:ge.end+1};return ge.kind&&(q.kind=ot.from(ge.kind)),q}ye.from=Pe})(Le=e.FoldingRange||(e.FoldingRange={}));var ot;(function(ye){function Pe(ge){if(ge)switch(ge){case h.FoldingRangeKind.Comment:return a.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return a.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return a.FoldingRangeKind.Region}}ye.from=Pe})(ot=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(ye){function Pe(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?l.from(ge.selection):void 0,override:typeof ge.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Pe})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var G;(function(ye){function Pe(Ue){return Ue instanceof h.RelativePattern?Ue.toJSON():typeof Ue=="string"?Ue:ge(Ue)||q(Ue)?new h.RelativePattern(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}ye.from=Pe;function ge(Ue){const Xe=Ue;return Xe?E.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function q(Ue){const Xe=Ue;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ae(Ue){return typeof Ue=="string"?Ue:new h.RelativePattern(E.URI.revive(Ue.baseUri),Ue.pattern)}ye.to=Ae})(G=e.GlobPattern||(e.GlobPattern={}));var ve;(function(ye){function Pe(ge){if(ge){if(Array.isArray(ge))return ge.map(Pe);if(typeof ge=="string")return ge;{const q=ge;return{language:q.language,scheme:q.scheme,pattern:G.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}ye.from=Pe})(ve=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(ye){function Pe(q){return{start:q.start,end:q.end}}ye.from=Pe;function ge(q){return new h.NotebookRange(q.start,q.end)}ye.to=ge})(Ne=e.NotebookRange||(e.NotebookRange={}));var xe;(function(ye){function Pe(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}ye.to=Pe;function ge(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}ye.from=ge})(xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ze;(function(ye){function Pe(ge){if(ge===b.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ge===b.NotebookCellExecutionState.Pending)return;if(ge===b.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}ye.to=Pe})(ze=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Qe;(function(ye){function Pe(q){switch(q){case h.NotebookCellKind.Markup:return b.CellKind.Markup;case h.NotebookCellKind.Code:default:return b.CellKind.Code}}ye.from=Pe;function ge(q){switch(q){case b.CellKind.Markup:return h.NotebookCellKind.Markup;case b.CellKind.Code:default:return h.NotebookCellKind.Code}}ye.to=ge})(Qe=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(ye){function Pe(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(const Ue of q.cells)h.NotebookCellData.validate(Ue),Ae.cells.push(vt.from(Ue));return Ae}ye.from=Pe;function ge(q){const Ae=new h.NotebookData(q.cells.map(vt.to));return(0,f.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}ye.to=ge})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(ye){function Pe(q){return{cellKind:Qe.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:xe.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(Ct.from):[]}}ye.from=Pe;function ge(q){return new h.NotebookCellData(Qe.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(Ct.to):void 0,q.metadata,q.internalMetadata?xe.to(q.internalMetadata):void 0)}ye.to=ge})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(ye){function Pe(q){return{mime:q.mime,valueBytes:C.VSBuffer.wrap(q.data)}}ye.from=Pe;function ge(q){return new h.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}ye.to=ge})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(ye){function Pe(q){return{outputId:q.id,items:q.items.map(wt.from),metadata:q.metadata}}ye.from=Pe;function ge(q){const Ae=q.items.map(wt.to);return new h.NotebookCellOutput(Ae,q.outputId,q.metadata)}ye.to=ge})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ht;(function(ye){function Pe(Ae){return q(Ae)?{include:(0,f.withNullAsUndefined)(G.from(Ae.include)),exclude:(0,f.withNullAsUndefined)(G.from(Ae.exclude))}:(0,f.withNullAsUndefined)(G.from(Ae))}ye.from=Pe;function ge(Ae){return q(Ae)?{include:G.to(Ae.include),exclude:G.to(Ae.exclude)}:G.to(Ae)}ye.to=ge;function q(Ae){const Ue=Ae;return Ue?!(0,f.isUndefinedOrNull)(Ue.include)&&!(0,f.isUndefinedOrNull)(Ue.exclude):!1}})(Ht=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(ye){function Pe(ge,q,Ae){const Ue=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Ue,Ae),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}ye.from=Pe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var mt;(function(ye){function Pe(ge,q,Ae){const Ue=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:q.toInternal(Ue,Ae),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}ye.from=Pe})(mt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Lt;(function(ye){function Pe(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}ye.from=Pe})(Lt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Kt;(function(ye){function Pe(q){return{uri:q.uri,provides:q.provides}}ye.from=Pe;function ge(q){return new h.NotebookRendererScript(E.URI.revive(q.uri),q.provides)}ye.to=ge})(Kt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(ye){function Pe(q){return{message:O.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:l.from(q.location.range),uri:q.location.uri}}}ye.from=Pe;function ge(q){const Ae=new h.TestMessage(typeof q.message=="string"?q.message:O.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?ke.to(q.location):void 0,Ae}ye.to=ge})(Tt=e.TestMessage||(e.TestMessage={}));var ht;(function(ye){ye.namespace=v.namespaceTestTag,ye.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var It;(function(ye){function Pe(q){const Ae=(0,u.getPrivateApiFor)(q).controllerId;return{extId:R.TestId.fromExtHostTestItem(q,Ae).toString(),label:q.label,uri:E.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(Ue=>ht.namespace(Ae,Ue.id)),range:m.Range.lift(l.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&O.fromStrict(q.error)||null}}ye.from=Pe;function ge(q){return{parent:void 0,error:void 0,id:R.TestId.fromString(q.extId).localId,label:q.label,uri:E.URI.revive(q.uri),tags:(q.tags||[]).map(Ae=>{const{tagId:Ue}=ht.denamespace(Ae);return new h.TestTag(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}ye.toPlain=ge})(It=e.TestItem||(e.TestItem={})),function(ye){function Pe(q){return{id:q.id}}ye.from=Pe;function ge(q){return new h.TestTag(q.id)}ye.to=ge}(ht=e.TestTag||(e.TestTag={}));var Ut;(function(ye){const Pe=(q,Ae)=>{const Ue=[];for(const[Be,Ze]of Ae)R.TestId.compare(Ze.item.extId,Be)===2&&(Ae.delete(Be),Ue.push(Ze));const Xe={...It.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ze=>Ze.type===0).map(Tt.to)})),children:Ue.map(Be=>Pe(Be,Ae))};for(const Be of Xe.children)Be.parent=Xe;return Xe};function ge(q){const Ae=[],Ue=new Map;for(const Xe of q.items){Ue.set(Xe.item.extId,Xe);const Be=R.TestId.root(Xe.item.extId);q.request.targets.some(Ze=>Ze.controllerId===Be&&Ze.testIds.includes(Xe.item.extId))&&Ae.push(Xe)}return{completedAt:q.completedAt,results:Ae.map(Xe=>Pe(Xe,Ue))}}ye.to=ge})(Ut=e.TestResults||(e.TestResults={}));var Rt;(function(ye){function Pe(Ue){return{covered:Ue.covered,total:Ue.covered}}function ge(Ue){return"line"in Ue?p.from(Ue):l.from(Ue)}function q(Ue){return"branches"in Ue?{count:Ue.executionCount,location:ge(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&ge(Xe.location)})):void 0}:{type:0,count:Ue.executionCount,location:ge(Ue.location)}}ye.fromDetailed=q;function Ae(Ue){return{uri:Ue.uri,statement:Pe(Ue.statementCoverage),branch:Ue.branchCoverage&&Pe(Ue.branchCoverage),function:Ue.functionCoverage&&Pe(Ue.functionCoverage),details:Ue.detailedCoverage?.map(q)}}ye.fromFile=Ae})(Rt=e.TestCoverage||(e.TestCoverage={}));var Ke;(function(ye){function Pe(ge){switch(ge){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}ye.to=Pe})(Ke=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(ye){function Pe(q){const Ae=new h.TypeHierarchyItem(le.to(q.kind),q.name,q.detail||"",E.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}ye.to=Pe;function ge(q,Ae,Ue){if(Ae=Ae??q._sessionId,Ue=Ue??q._itemId,Ae===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ue,kind:le.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(ae.from)}}ye.from=ge})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Nt;(function(ye){function Pe(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}ye.from=Pe})(Nt=e.ViewBadge||(e.ViewBadge={}));var xt;(function(ye){function Pe(Ue,Xe,Be){const Ze=Xe.fileData;return Ze?new class extends h.DataTransferItem{asFile(){return{name:Ze.name,uri:E.URI.revive(Ze.uri),data:(0,N.once)(()=>Be())}}}("",Xe.id):Ue===L.Mimes.uriList&&Xe.uriListData?new h.DataTransferItem(Ae(Xe.uriListData)):new h.DataTransferItem(Xe.asString)}ye.to=Pe;async function ge(Ue,Xe){const Be=await Xe.asString();if(Ue===L.Mimes.uriList)return{id:Xe.id,asString:Be,fileData:void 0,uriListData:q(Be)};const Ze=Xe.asFile();return{id:Xe.id,asString:Be,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=ge;function q(Ue){return y.UriList.split(Ue).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return E.URI.parse(Xe)}catch{}return Xe})}function Ae(Ue){return y.UriList.create(Ue.map(Xe=>typeof Xe=="string"?Xe:E.URI.revive(Xe)))}})(xt=e.DataTransferItem||(e.DataTransferItem={}));var ft;(function(ye){function Pe(q,Ae){const Ue=q.items.map(([Xe,Be])=>[Xe,xt.to(Xe,Be,()=>Ae(Be.id))]);return new h.DataTransfer(Ue)}ye.toDataTransfer=Pe;async function ge(q){const Ae={items:[]},Ue=[];return q.forEach((Xe,Be)=>{Ue.push((async()=>{Ae.items.push([Be,await xt.from(Be,Xe)])})())}),await Promise.all(Ue),Ae}ye.toDataTransferDTO=ge})(ft=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[195],Ie([1,0,2,12,7,8,161]),function(te,e,n,C,y,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(I,L,w,f={timeout:1500,errors:3}){this._logService=I,this._documents=L,this._mainThreadBulkEdits=w,this._thresholds=f,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(L,w,f)=>{const m={dispose:this._callbacks.push([L,w,I])};return Array.isArray(f)&&f.push(m),m}}async $participateInSave(I,L){const w=n.URI.revive(I);let f=!1;const E=setTimeout(()=>f=!0,this._thresholds.timeout),m=[];try{for(const a of[...this._callbacks]){if(f)break;const o=this._documents.getDocument(w),u=await this._deliverEventAsyncAndBlameBadListeners(a,{document:o,reason:N.TextDocumentSaveReason.to(L)});m.push(u)}}finally{clearTimeout(E)}return m}_deliverEventAsyncAndBlameBadListeners([I,L,w],f){const E=this._badListeners.get(I);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(w,I,L,f).then(()=>!0,m=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this._logService.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const a=this._badListeners.get(I);this._badListeners.set(I,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,L,w,f){const E=[],m=Date.now(),{document:a,reason:o}=f,{version:u}=a,g=Object.freeze({document:a,reason:o,waitUntil(b){if(Object.isFrozen(E))throw(0,C.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(b))}});try{L.apply(w,[g])}catch(b){return Promise.reject(b)}return Object.freeze(E),new Promise((b,R)=>{const v=setTimeout(()=>R(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(v),b(t)}).catch(t=>{clearTimeout(v),R(t)})}).then(b=>{const R={edits:[]};for(const v of b)if(Array.isArray(v)&&v.every(t=>t instanceof y.TextEdit))for(const{newText:t,newEol:h,range:r}of v)R.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:r&&N.Range.from(r),text:t,eol:h&&N.EndOfLine.from(h)}});if(R.edits.length!==0)return u===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(R):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Ce[196],Ie([1,0,15,2,8,7,70]),function(te,e,n,C,y,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(w,f,E,m){this.start=w,this.deletedCount=f,this.deletedItems=E,this.items=m}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class _{static asModelAddData(w,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,f,E){this.notebook=w,this._extHostDocument=f,this._cellData=E,this.handle=E.handle,this.uri=C.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return w._mime},set mime(m){w._mime=m},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(w){this._outputs=w.map(y.NotebookCellOutput.to)}setOutputItems(w,f,E){const m=E.map(y.NotebookCellOutputItem.to),a=this._outputs.find(o=>o.id===w);if(a&&(f||(a.items.length=0),a.items.push(...m),a.items.length>1&&a.items.every(o=>S.isTextStreamMime(o.mime)))){const o=new Map,u=[];a.items.forEach(g=>{let b;o.has(g.mime)?b=o.get(g.mime):(b=[],o.set(g.mime,b),u.push(g.mime)),b.push(g.data)}),a.items.length=0,u.forEach(g=>{const b=S.compressOutputItemStreams(o.get(g));a.items.push({mime:g,data:b.buffer})})}}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=_;class I{constructor(w,f,E,m,a){this._proxy=w,this._textDocumentsAndEditors=f,this._textDocuments=E,this.uri=m,this.handle=I._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=a.viewType,this._metadata=Object.freeze(a.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,a.cells]],!0,void 0),this._versionId=a.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const w=this,f={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===n.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(E){return E=w._validateIndex(E),w._cells[E].apiCell},getCells(E){return(E?w._getCells(E):w._cells).map(a=>a.apiCell)},save(){return w._save()}};this._notebook=Object.freeze(f)}return this._notebook}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,f,E){this._versionId=w.versionId,this._isDirty=f,this.acceptDocumentPropertiesChanged({metadata:E});const m={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},a=[];for(const u of w.rawEvents)u.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1,m.contentChanges):u.kind===S.NotebookCellsChangeType.Move?this._moveCells(u.index,u.length,u.newIdx,m.contentChanges):u.kind===S.NotebookCellsChangeType.Output?(this._setCellOutputs(u.index,u.outputs),a.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===S.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems),a.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===S.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(u.index,u.language),a.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document})):u.kind===S.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document}):u.kind===S.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===S.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(u.index,u.metadata),a.push({cell:this._cells[u.index].apiCell,metadata:this._cells[u.index].apiCell.metadata})):u.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(u.index,u.internalMetadata),a.push({cell:this._cells[u.index].apiCell,executionSummary:this._cells[u.index].apiCell.executionSummary}));const o=new Map;for(let u=0;u<a.length;u++){const g=a[u],b=o.get(g.cell);if(b===void 0){const R=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});o.set(g.cell,R-1)}else m.cellChanges[b]={...m.cellChanges[b],...g}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let f=w.start|0,E=w.end|0;return f<0&&(f=0),E>this._cells.length&&(E=this._cells.length),w.with({start:f,end:E})}_getCells(w){w=this._validateRange(w);const f=[];for(let E=w.start;E<w.end;E++)f.push(this._cells[E]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,f,E){if(this._disposed)return;const m=[],a=[],o=[];if(w.reverse().forEach(u=>{const b=u[2].map(t=>{const h=new _(this,this._textDocumentsAndEditors,t);return f||a.push(_.asModelAddData(this.apiNotebook,t)),h}),R=new P(u[0],u[1],[],b),v=this._cells.splice(u[0],u[1],...b);for(const t of v)o.push(t.uri),R.deletedItems.push(t.apiCell);m.push(R)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:o}),E)for(const u of m)E.push(u.asApiEvent())}_moveCells(w,f,E,m){const a=this._cells.splice(w,f);this._cells.splice(E,0,...a);const o=[new P(w,f,a.map(u=>u.apiCell),[]),new P(E,0,[],a)];for(const u of o)m.push(u.asApiEvent())}_setCellOutputs(w,f){this._cells[w].setOutputs(f)}_setCellOutputItems(w,f,E,m){this._cells[w].setOutputItems(f,E,m)}_changeCellLanguage(w,f){const E=this._cells[w];E.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelLanguageChanged(E.uri,f)}_changeCellMime(w,f){const E=this._cells[w];E.apiCell.mime=f}_changeCellMetadata(w,f){this._cells[w].setMetadata(f)}_changeCellInternalMetadata(w,f){this._cells[w].setInternalMetadata(f)}getCellFromApiCell(w){return this._cells.find(f=>f.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(f=>f.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}I._handlePool=0,e.ExtHostNotebookDocument=I}),define(Ce[100],Ie([1,0,12,8,7]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(P,_,I,L,w,f){this.id=P,this._proxy=_,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=w,this._visibleRanges=L,this._viewColumn=f}get apiEditor(){if(!this._editor){const P=this;this._editor={get notebook(){return P.notebookData.apiNotebook},get selection(){return P._selections[0]},set selection(_){this.selections=[_]},get selections(){return P._selections},set selections(_){if(!Array.isArray(_)||!_.every(y.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");P._selections=_,P._trySetSelections(_)},get visibleRanges(){return P._visibleRanges},revealRange(_,I){P._proxy.$tryRevealRange(P.id,C.NotebookRange.from(_),I??y.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn}},N.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_trySetSelections(P){this._proxy.$trySetSelections(this.id,P.map(C.NotebookRange.from))}_acceptViewColumn(P){this._viewColumn=P}}N.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=N}),define(Ce[197],Ie([1,0,4,11,8]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let N=class{constructor(P,_){this._logService=P,this._notebooksAndEditors=_,this._onDidChangeNotebookEditorSelection=new n.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new n.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(P,_){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,_);const I=this._notebooksAndEditors.getEditorById(P);_.visibleRanges&&I._acceptVisibleRanges(_.visibleRanges.ranges.map(y.NotebookRange.to)),_.selections&&I._acceptSelections(_.selections.selections.map(y.NotebookRange.to)),_.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),_.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const _ in P)this._notebooksAndEditors.getEditorById(_)._acceptViewColumn(y.ViewColumn.to(P[_]))}};N=Ve([He(0,C.ILogService)],N),e.ExtHostNotebookEditors=N}),define(Ce[198],Ie([1,0,8,165,141,20,63,12]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(f){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=f}async withProgress(f,E,m){const a=this._handles++,{title:o,location:u,cancellable:g}=E,b={label:(0,y.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this._proxy.$startProgress(a,{location:n.ProgressLocation.from(u),title:o,source:b,cancellable:g},f.isUnderDevelopment?void 0:f.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(a,m,!!g)}_withProgress(f,E,m){let a;m&&(a=new N.CancellationTokenSource,this._mapHandleToCancellationSource.set(f,a));const o=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),a?.dispose()};let u;try{u=E(new L(this._proxy,f),m&&a?a.token:N.CancellationToken.None)}catch(g){throw o(f),g}return u.then(g=>o(f),g=>o(f)),u}$acceptProgressCanceled(f){const E=this._mapHandleToCancellationSource.get(f);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(f))}}e.ExtHostProgress=_;function I(w,f){return w.message=f.message,typeof f.increment=="number"&&(typeof w.increment=="number"?w.increment+=f.increment:w.increment=f.increment),w}class L extends C.Progress{constructor(f,E){super(m=>this.throttledReport(m)),this._proxy=f,this._handle=E}throttledReport(f){this._proxy.$progressReport(this._handle,f)}}Ve([(0,S.throttle)(100,(w,f)=>I(w,f),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Ce[101],Ie([1,0,44,96,45,71,56,8,2]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(b,R,v,t)=>{let h=R;return{enumerable:!0,configurable:!1,get(){return h},set(r){if(!v(h,r)){const l=h;h=r,b.listener?.(t(r,l))}}}},L=(b,R)=>b===R,w={range:(b,R)=>b===R?!0:!b||!R?!1:b.isEqual(R),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(b,R)=>!(b.length!==R.length||b.some(v=>!R.find(t=>v.id===t.id)))},f=b=>R=>({op:4,update:b(R)}),E=(b,R)=>({range:(()=>{let v;const t=f(h=>({range:n.Range.lift(P.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return v},set(h){b.listener?.({op:6}),w.range(v,h)||(v=h,b.listener?.(t(h)))}}})(),label:I(b,R,w.label,f(v=>({label:v}))),description:I(b,void 0,w.description,f(v=>({description:v}))),sortText:I(b,void 0,w.sortText,f(v=>({sortText:v}))),canResolveChildren:I(b,!1,w.canResolveChildren,v=>({op:2,state:v})),busy:I(b,!1,w.busy,f(v=>({busy:v}))),error:I(b,void 0,w.error,f(v=>({error:P.MarkdownString.fromStrict(v)||null}))),tags:I(b,[],w.tags,(v,t)=>({op:1,new:v.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),m=b=>{const R=y.TestId.fromString(b.extId),v=new o(R.controllerId,R.localId,b.label,_.URI.revive(b.uri)||void 0);return v.range=P.Range.to(b.range||void 0),v.description=b.description||void 0,v.sortText=b.sortText||void 0,v.tags=b.tags.map(t=>P.TestTag.to({id:(0,S.denamespaceTestTag)(t).tagId})),v},a=b=>{let R;for(const v of b.tests){const t=m(v.item);(0,C.getPrivateApiFor)(t).parent=R,R=t}return R};e.toItemFromContext=a;class o{constructor(R,v,t,h){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const r=(0,C.createPrivateApiFor)(this,R);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,N.createTestItemChildren)(r,C.getPrivateApiFor,o),enumerable:!0,writable:!1},...E(r,t)})}}e.TestItemImpl=o;class u extends o{constructor(R,v){super(R,R,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class g extends N.TestItemCollection{constructor(R,v,t){super({controllerId:R,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:C.getPrivateApiFor,getChildren:h=>h.children,root:new u(R,v),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(Ce[102],Ie([1,0,49,12,83,8,7]),function(te,e,n,C,y,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(f,E,m){const a=P._Keys.nextId();f.$registerTextEditorDecorationType(E.identifier,a,N.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:a,dispose(){f.$removeTextEditorDecorationType(a)}})}}P._Keys=new y.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=P;class _{constructor(f,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,E){this._throwIfFinalized();let m=null;if(f instanceof S.Position)m=new S.Range(f,f);else if(f instanceof S.Range)m=f;else throw new Error("Unrecognized location");this._pushEdit(m,E,!1)}insert(f,E){this._throwIfFinalized(),this._pushEdit(new S.Range(f,f),E,!0)}delete(f){this._throwIfFinalized();let E=null;if(f instanceof S.Range)E=f;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(f,E,m){const a=this._document.validateRange(f);this._collectedEdits.push({range:a,text:E,forceMoveMarkers:m})}setEndOfLine(f){if(this._throwIfFinalized(),f!==S.EndOfLine.LF&&f!==S.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=f}}class I{constructor(f,E,m,a){this._proxy=f,this._id=E,this._accept(m),this._logService=a;const o=this;this.value={get tabSize(){return o._tabSize},set tabSize(u){o._setTabSize(u)},get indentSize(){return o._indentSize},set indentSize(u){o._setIndentSize(u)},get insertSpaces(){return o._insertSpaces},set insertSpaces(u){o._setInsertSpaces(u)},get cursorStyle(){return o._cursorStyle},set cursorStyle(u){o._setCursorStyle(u)},get lineNumbers(){return o._lineNumbers},set lineNumbers(u){o._setLineNumbers(u)}}}_accept(f){this._tabSize=f.tabSize,this._indentSize=f.indentSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=N.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const E=Math.floor(f);return E>0?E:null}if(typeof f=="string"){const E=parseInt(f,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(f){const E=this._validateTabSize(f);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateIndentSize(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const E=Math.floor(f);return E>0?E:null}if(typeof f=="string"){const E=parseInt(f,10);return isNaN(E)?null:E>0?E:null}return null}_setIndentSize(f){const E=this._validateIndentSize(f);if(E!==null){if(typeof E=="number"){if(this._indentSize===E)return;this._indentSize=E}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:E}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}_setInsertSpaces(f){const E=this._validateInsertSpaces(f);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:N.TextEditorLineNumbersStyle.from(f)})))}assign(f){const E={};let m=!1;if(typeof f.tabSize<"u"){const a=this._validateTabSize(f.tabSize);a==="auto"?(m=!0,E.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,m=!0,E.tabSize=a)}if(typeof f.indentSize<"u"){const a=this._validateIndentSize(f.indentSize);a==="tabSize"?(m=!0,E.indentSize=a):typeof a=="number"&&this._indentSize!==a&&(this._indentSize=a,m=!0,E.indentSize=a)}if(typeof f.insertSpaces<"u"){const a=this._validateInsertSpaces(f.insertSpaces);a==="auto"?(m=!0,E.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,m=!0,E.insertSpaces=a)}typeof f.cursorStyle<"u"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,m=!0,E.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,m=!0,E.lineNumbers=N.TextEditorLineNumbersStyle.from(f.lineNumbers)),m&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(f,E){E.catch(m=>{this._logService.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this._logService.warn(m)})}}e.ExtHostTextEditorOptions=I;class L{constructor(f,E,m,a,o,u,g,b){this.id=f,this._proxy=E,this._logService=m,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._options=new I(this._proxy,this.id,u,m),this._visibleRanges=g,this._viewColumn=b;const R=this;this.value=Object.freeze({get document(){return a.value},set document(v){throw(0,C.readonly)("document")},get selection(){return R._selections&&R._selections[0]},set selection(v){if(!(v instanceof S.Selection))throw(0,C.illegalArgument)("selection");R._selections=[v],R._trySetSelection()},get selections(){return R._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof S.Selection)))throw(0,C.illegalArgument)("selections");R._selections=v,R._trySetSelection()},get visibleRanges(){return R._visibleRanges},set visibleRanges(v){throw(0,C.readonly)("visibleRanges")},get options(){return R._options.value},set options(v){R._disposed||R._options.assign(v)},get viewColumn(){return R._viewColumn},set viewColumn(v){throw(0,C.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(R._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new _(a.value,t);return v(h),R._applyEdit(h)},insertSnippet(v,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(R._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=R._selections.map(l=>N.Range.from(l));else if(t instanceof S.Position){const{lineNumber:l,column:i}=N.Position.from(t);r=[{startLineNumber:l,startColumn:i,endLineNumber:l,endColumn:i}]}else if(t instanceof S.Range)r=[N.Range.from(t)];else{r=[];for(const l of t)if(l instanceof S.Range)r.push(N.Range.from(l));else{const{lineNumber:i,column:p}=N.Position.from(l);r.push({startLineNumber:i,startColumn:p,endLineNumber:i,endColumn:p})}}return E.$tryInsertSnippet(f,a.value.version,v.value,r,h)},setDecorations(v,t){const h=t.length===0;h&&!R._hasDecorationsForKey.has(v.key)||(h?R._hasDecorationsForKey.delete(v.key):R._hasDecorationsForKey.add(v.key),R._runOnProxy(()=>{if(N.isDecorationOptionsArr(t))return E.$trySetDecorations(f,v.key,N.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let l=0,i=t.length;l<i;l++){const p=t[l];r[4*l]=p.start.line+1,r[4*l+1]=p.start.character+1,r[4*l+2]=p.end.line+1,r[4*l+3]=p.end.character+1}return E.$trySetDecorationsFast(f,v.key,r)}}))},revealRange(v,t){R._runOnProxy(()=>E.$tryRevealRange(f,N.Range.from(v),t||S.TextEditorRevealType.Default))},show(v){E.$tryShowEditor(f,N.ViewColumn.from(v))},hide(){E.$tryHideEditor(f)}})}dispose(){(0,n.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,n.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,n.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,n.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,n.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(N.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const E=f.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const m=E.edits.map(o=>o.range);m.sort((o,u)=>o.end.line===u.end.line?o.end.character===u.end.character?o.start.line===u.start.line?o.start.character-u.start.character:o.start.line-u.start.line:o.end.character-u.end.character:o.end.line-u.end.line);for(let o=0,u=m.length-1;o<u;o++){const g=m[o].end;if(m[o+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=E.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,a,{setEndOfLine:typeof E.setEndOfLine=="number"?N.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=L}),define(Ce[199],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[200],Ie([1,0,154,12,29,90,68,30,25,199,164,156]),function(te,e,n,C,y,N,S,P,_,I,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=P.Registry.as(S.Extensions.JSONContribution);class E{constructor(v,t,h){this._messageHandler=v,this._extension=t,this._extensionPointId=h}_msg(v,t){this._messageHandler({type:v,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(v){this._msg(y.default.Error,v)}warn(v){this._msg(y.default.Warning,v)}info(v){this._msg(y.default.Info,v)}}e.ExtensionMessageCollector=E;class m{static _toSet(v){const t=new Set;for(let h=0,r=v.length;h<r;h++)t.add(_.ExtensionIdentifier.toKey(v[h].description.identifier));return t}static compute(v,t){if(!v||!v.length)return new m(t,[]);if(!t||!t.length)return new m([],v);const h=this._toSet(v),r=this._toSet(t),l=t.filter(p=>!h.has(_.ExtensionIdentifier.toKey(p.description.identifier))),i=v.filter(p=>!r.has(_.ExtensionIdentifier.toKey(p.description.identifier)));return new m(l,i)}constructor(v,t){this.added=v,this.removed=t}}e.ExtensionPointUserDelta=m;class a{constructor(v,t){this.name=v,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(v){if(this._handler!==null)throw new Error("Handler already set!");this._handler=v,this._handle()}acceptUsers(v){this._delta=m.compute(this._users,v),this._users=v,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(v){(0,C.onUnexpectedError)(v)}}}e.ExtensionPoint=a;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:_.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class g{constructor(){this._extensionPoints=new Map}registerExtensionPoint(v){if(this._extensionPoints.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const t=new a(v.extensionPoint,v.defaultExtensionKind);return this._extensionPoints.set(v.extensionPoint,t),v.activationEventsGenerator&&w.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,f.registerSchema(u,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=g;const b={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(b.ExtensionsRegistry,new g),e.ExtensionsRegistry=P.Registry.as(b.ExtensionsRegistry),f.registerSchema(u,e.schema),f.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(Ce[201],Ie([1,0,151,9,22,200,42,4]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const _={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var I;(function(f){function E(m,a,o){if(!m)return;const u=C.isString(m.type)?m.type:void 0;if(!u||u.length===0){o.error(n.localize(3,null));return}const g=[];if(Array.isArray(m.required))for(const b of m.required)C.isString(b)&&g.push(b);return{extensionId:a.value,taskType:u,required:g,properties:m.properties?y.deepClone(m.properties):{},when:m.when?S.ContextKeyExpr.deserialize(m.when):void 0}}f.from=E})(I||(I={}));const L=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:n.localize(4,null),type:"array",items:_}});class w{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,m)=>{L.setHandler((a,o)=>{this._schema=void 0;try{for(const u of o.removed){const g=u.value;for(const b of g)this.taskTypes&&b.type&&this.taskTypes[b.type]&&delete this.taskTypes[b.type]}for(const u of o.added){const g=u.value;for(const b of g){const R=I.from(b,u.description.identifier,u.collector);R&&(this.taskTypes[R.taskType]=R)}}(o.removed.length>0||o.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const m of this.all()){const a={type:"object",additionalProperties:!1};m.required.length>0&&(a.required=m.required.slice(0)),m.properties!==void 0?a.properties=y.deepClone(m.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[m.taskType]},E.push(a)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistry=new w}),define(Ce[202],Ie([1,0,152,9,24,22,42,201]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new S.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var _;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(_=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(T){function F(z){if(!z)return T.Strong;switch(z.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=F}(_=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var L;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(T){function F(z){switch(z.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=F}(L=e.RevealKind||(e.RevealKind={}));var w;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(T){function F(z){switch(z.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=F}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(T){function F(z){switch(z.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=F}(f=e.PanelKind||(e.PanelKind={}));var E;(function(T){T.defaults={echo:!0,reveal:L.Always,revealProblems:w.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(E=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(T){function F(H){switch(H.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=F;function z(H){switch(H){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=z}(m=e.RuntimeType||(e.RuntimeType={}));var a;(function(T){function F(z){return C.isString(z)?z:z.value}T.value=F})(a=e.CommandString||(e.CommandString={}));var o;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function F(H){return H===T.Clean._id||H===T.Build._id||H===T.Rebuild._id||H===T.Test._id}T.is=F;function z(H){if(H!==void 0)return C.isString(H)?F(H)?{_id:H,isDefault:!1}:void 0:H}T.from=z})(o=e.TaskGroup||(e.TaskGroup={}));var u;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var g;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function F(z){switch(z){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=F})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(T){T.parallel="parallel",T.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var R;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(R=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:R.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class t{constructor(F,z,H,de,pe,re){this._label="",this._id=F,z&&(this._label=z),H&&(this.type=H),this.runOptions=de,this.configurationProperties=pe,this._source=re}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.getFolderId(),id:this._id};return JSON.stringify(F)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,z=!1){if(F===void 0)return!1;if(C.isString(F))return F===this._label||F===this.configurationProperties.identifier||z&&F===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),F&&(this._taskLoadMessages=this._taskLoadMessages.concat(F))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class h extends t{constructor(F,z,H,de,pe,re,le,ae){super(F,H,void 0,le,ae,z),this.command={},this._source=z,this.hasDefinedMatchers=re,pe&&(this.command=pe)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case m.Shell:z="shell";break;case m.Process:z="process";break;case m.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(F){return F instanceof h}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.getFolderId();if(!F)return;let z=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(z+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:z};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(F){return new h(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=h;class r extends t{constructor(F,z,H,de,pe,re,le){super(F,H,de,re,le,z),this._source=z,this.configures=pe}static is(F){return F instanceof r}fromObject(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.getFolderId();if(!F)return;let z=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(z+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:z};return JSON.stringify(H)}}e.ConfiguringTask=r;class l extends t{constructor(F,z,H,de,pe,re,le,ae,se){super(F,H,de,ae,se,z),this.defines=pe,this.hasDefinedMatchers=le,this.command=re,this.icon=se.icon,this.hide=se.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof l}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.getFolderId(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(F){return new l(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=l;class i extends t{constructor(F,z,H,de,pe,re){super(F,H,de,pe,re,z),this._source=z}clone(){return new i(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof i}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(F){return new i(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=i;var p;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(p=e.ExecutionEngine||(e.ExecutionEngine={})),function(T){T._default=T.Terminal}(p=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class s{constructor(F){this._order=new Map;for(let z=0;z<F.length;z++)this._order.set(F[z].uri.toString(),z)}compare(F,z){const H=F.getWorkspaceFolder(),de=z.getWorkspaceFolder();if(H&&de){let pe=this._order.get(H.uri.toString());pe=pe===void 0?0:pe+1;let re=this._order.get(de.uri.toString());return re=re===void 0?0:re+1,pe===re?F._label.localeCompare(z._label):pe-re}else return!H&&de?-1:H&&!de?1:0}}e.TaskSorter=s;var d;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(d=e.TaskEventKind||(e.TaskEventKind={}));var k;(function(T){T.SingleRun="singleRun",T.Background="background"})(k=e.TaskRunType||(e.TaskRunType={}));var A;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(A=e.TaskRunSource||(e.TaskRunSource={}));var W;(function(T){function F(z,H,de,pe){if(H){const re={kind:z,taskId:H._id,taskName:H.configurationProperties.name,runType:H.configurationProperties.isBackground?"background":"singleRun",group:H.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:de,__task:H};return z==="start"?re.resolvedVariables=pe:z==="processStarted"?re.processId=pe:z==="processEnded"&&(re.exitCode=pe),Object.freeze(re)}else return Object.freeze({kind:"changed"})}T.create=F})(W=e.TaskEvent||(e.TaskEvent={}));var J;(function(T){function F(H){const de=Object.keys(H).sort();let pe="";for(const re of de){let le=H[re];le instanceof Object?le=F(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),pe+=re+","+le+","}return pe}function z(H){const pe={_key:F(H),type:H.taskType};return Object.assign(pe,H),pe}T.create=z})(J=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var j;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection"})(j=e.TaskSettingId||(e.TaskSettingId={}));var O;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(O=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(T){function F(z,H){const de=P.TaskDefinitionRegistry.get(z.type);if(de===void 0){const ae=N.deepClone(z);return delete ae._key,J.create(ae)}const pe=Object.create(null);pe.type=de.taskType;const re=new Set;de.required.forEach(ae=>re.add(ae));const le=de.properties;for(const ae of Object.keys(le)){const se=z[ae];if(se!=null)pe[ae]=se;else if(re.has(ae)){const Q=le[ae];if(Q.default!==void 0)pe[ae]=N.deepClone(Q.default);else switch(Q.type){case"boolean":pe[ae]=!1;break;case"number":case"integer":pe[ae]=0;break;case"string":pe[ae]="";break;default:H.error(n.localize(2,null,JSON.stringify(z,void 0,0),ae));return}}}return J.create(pe)}T.createTaskIdentifier=F})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[203],Ie([1,0,12]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,P)=>{this._actualOk=S,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):(0,n.onUnexpectedError)(S))}then(S,P){return this._ensureActual().then(S,P)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=C;class y extends C{constructor(){super(),this._hasErr=!0,this._err=new n.CancellationError}}e.CanceledLazyPromise=y}),define(Ce[46],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(_){this._proxyIdentifierBrand=void 0,this.sid=_,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const C=[];function y(P){const _=new n(P);return C[_.nid]=_,_}e.createProxyIdentifier=y;function N(P){return C[P].sid}e.getStringIdentifierForProxy=N;class S{constructor(_){this.value=_}}e.SerializableObjectWithBuffers=S}),define(Ce[5],Ie([1,0,46]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var N;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(N=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var _;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(_=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(o){return o._id=w._n++,o}}w._n=0,e.IdObject=w;var f;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[76],Ie([1,0,3,11,5,18]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(_,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(y.MainContext.MainThreadTelemetry)}report(_,I,L){const w=this.getUsageKey(_,I);this._reportedUsages.has(w)||(this._reportedUsages.add(w),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:_}))}getUsageKey(_,I){return`${_}-${I.identifier.value}`}};S=Ve([He(0,N.IExtHostRpcService),He(1,C.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(P,_,I){}})}),define(Ce[204],Ie([1,0,4,5,7,25]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new n.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,I,L,w={}){const f=N.ExtensionIdentifier.toKey(_.identifier),E=this._inFlightRequests.get(f)||[],m=[...L].sort().join(" ");let a=E.find(o=>o.providerId===I&&o.scopes===m);if(a)return a.result;{const o=this._getSession(_,f,I,L,w);a={providerId:I,scopes:m,result:o},E.push(a),this._inFlightRequests.set(f,E);try{await o}finally{const u=E.findIndex(g=>g.providerId===I&&g.scopes===m);u>-1&&(E.splice(u),this._inFlightRequests.set(f,E))}return o}}async _getSession(_,I,L,w,f={}){await this._proxy.$ensureProvider(L);const E=_.displayName||_.name;return this._proxy.$getSession(L,w,I,E,f)}async removeSession(_,I){const L=this._authenticationProviders.get(_);return L?L.provider.removeSession(I):this._proxy.$removeSession(_,I)}registerAuthenticationProvider(_,I,L,w){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:I,provider:L,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===_)||this._providers.push({id:_,label:I});const f=L.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(_,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,I,w?.supportsMultipleAccounts??!1),new y.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(_);const E=this._providers.findIndex(m=>m.id===_);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,I){return this._onDidChangeSessions.fire({provider:{id:_,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(Ce[205],Ie([1,0,5,18,8]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(P,_){this._proxy=P.getProxy(n.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:I=>_.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,_,I){const L=y.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(L,void 0,I?.isRefactoring??!1)}};N=Ve([He(0,C.IExtHostRpcService)],N),e.ExtHostBulkEdits=N}),define(Ce[206],Ie([1,0,5]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(N){const S=N.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(P){return S.$writeText(P)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[37],Ie([1,0,9,7,8,22,5,16,11,65,44,259,2,6,3,18,101,23,46,39,77,52]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R,v){"use strict";var t,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(d,k){t.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,h.set(this,void 0),Je(this,t,d.getProxy(S.MainContext.MainThreadCommands),"f"),this._logService=k,Je(this,h,d.getProxy(S.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,A=>{const W=this._apiCommands.get(A);return W?.result===p.Void?W:void 0},k),this._argumentProcessors=[{processArgument(A){return(0,I.revive)(A)}},{processArgument(A){return(0,N.cloneAndChange)(A,function(W){if(L.Range.isIRange(W))return y.Range.to(W);if(w.Position.isIPosition(W))return y.Position.to(W);if(L.Range.isIRange(W.range)&&f.URI.isUri(W.uri))return y.location.to(W);if(W instanceof u.VSBuffer)return W.buffer.buffer;if(!Array.isArray(W))return W})}}]}registerArgumentProcessor(d){this._argumentProcessors.push(d)}registerApiCommand(d){const k=this.registerCommand(!1,d.id,async(...A)=>{const W=d.args.map((j,O)=>{if(!j.validate(A[O]))throw new Error(`Invalid argument '${j.name}' when running '${d.id}', received: ${A[O]}`);return j.convert(A[O])}),J=await this.executeCommand(d.internalId,...W);return d.result.convert(J,A,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this._apiCommands.set(d.id,d),new C.Disposable(()=>{k.dispose(),this._apiCommands.delete(d.id)})}registerCommand(d,k,A,W,J,j){if(this._logService.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this._commands.has(k))throw new Error(`command '${k}' already exists`);return this._commands.set(k,{callback:A,thisArg:W,description:J,extension:j}),d&&Oe(this,t,"f").$registerCommand(k),new C.Disposable(()=>{this._commands.delete(k)&&d&&Oe(this,t,"f").$unregisterCommand(k)})}executeCommand(d,...k){return this._logService.trace("ExtHostCommands#executeCommand",d),this._doExecuteCommand(d,k,!0)}async _doExecuteCommand(d,k,A){if(this._commands.has(d))return Oe(this,t,"f").$fireCommandActivationEvent(d),this._executeContributedCommand(d,k,!1);{let W=!1;const J=(0,N.cloneAndChange)(k,function(j){if(j instanceof C.Position)return y.Position.from(j);if(j instanceof C.Range)return y.Range.from(j);if(j instanceof C.Location)return y.location.from(j);if(C.NotebookRange.isNotebookRange(j))return y.NotebookRange.from(j);if(j instanceof ArrayBuffer)return W=!0,u.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return W=!0,u.VSBuffer.wrap(j);if(j instanceof u.VSBuffer)return W=!0,j;if(!Array.isArray(j))return j});try{const j=await Oe(this,t,"f").$executeCommand(d,W?new g.SerializableObjectWithBuffers(J):J,A);return(0,I.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(d,k,!1);throw j}}}async _executeContributedCommand(d,k,A){const W=this._commands.get(d);if(!W)throw new Error("Unknown command");const{callback:J,thisArg:j,description:O}=W;if(O)for(let T=0;T<O.args.length;T++)try{(0,n.validateConstraint)(k[T],O.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${O.args[T].name}' - ${O.args[T].description}`)}const B=R.StopWatch.create();try{return await J.apply(j,k)}catch(T){if(d===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...k);F&&(d=F.command)}throw this._logService.error(T,d,W.extension?.identifier),A?new class extends Error{constructor(){super((0,b.toErrorMessage)(T)),this.id=d,this.source=W.extension?.displayName??W.extension?.name}}:T}finally{this._reportTelemetry(W,d,B.elapsed())}}_reportTelemetry(d,k,A){!d.extension||Oe(this,h,"f").$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new v.TelemetryTrustedValue(k),duration:A})}$executeContributedCommand(d,...k){this._logService.trace("ExtHostCommands#$executeContributedCommand",d);const A=this._commands.get(d);return A?(k=k.map(W=>this._argumentProcessors.reduce((J,j)=>j.processArgument(J,A.extension?.identifier),W)),this._executeContributedCommand(d,k,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this._logService.trace("ExtHostCommands#getCommands",d),Oe(this,t,"f").$getCommands().then(k=>(d&&(k=k.filter(A=>A[0]!=="_")),k))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(const[k,A]of this._commands){const{description:W}=A;W&&(d[k]=W)}return Promise.resolve(d)}};t=new WeakMap,h=new WeakMap,r=Ve([He(0,a.IExtHostRpcService),He(1,_.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class l{constructor(d,k,A){this._commands=d,this._lookupApiCommand=k,this._logService=A,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(d,k){if(!d)return;const A={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return A;const W=this._lookupApiCommand(d.command);if(W)A.id=W.internalId,A.arguments=W.args.map((J,j)=>J.convert(d.arguments&&d.arguments[j]));else if((0,P.isNonEmptyArray)(d.arguments)){const J=`${d.command}/${++this._cachIdPool}`;this._cache.set(J,d),k.add((0,E.toDisposable)(()=>{this._cache.delete(J),this._logService.trace("CommandsConverter#DISPOSE",J)})),A.$ident=J,A.id=this.delegatingCommandId,A.arguments=[J],this._logService.trace("CommandsConverter#CREATE",d.command,J)}return A}fromInternal(d){return typeof d.$ident=="string"?this._cache.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this._cache.get(d[0])}_executeConvertedCommand(...d){const k=this.getActualCommand(...d);return this._logService.trace("CommandsConverter#EXECUTE",d[0],k?k.command:"MISSING"),k?this._commands.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.CommandsConverter=l;class i{constructor(d,k,A,W){this.name=d,this.description=k,this.validate=A,this.convert=W}optional(){return new i(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,k){return new i(d??this.name,k??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",s=>f.URI.isUri(s),s=>s),i.Position=new i("position","A position in a text document",s=>C.Position.isPosition(s),y.Position.from),i.Range=new i("range","A range in a text document",s=>C.Range.isRange(s),y.Range.from),i.Selection=new i("selection","A selection in a text document",s=>C.Selection.isSelection(s),y.Selection.from),i.Number=new i("number","",s=>typeof s=="number",s=>s),i.String=new i("string","",s=>typeof s=="string",s=>s),i.CallHierarchyItem=new i("item","A call hierarchy item",s=>s instanceof C.CallHierarchyItem,y.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",s=>s instanceof C.TypeHierarchyItem,y.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",s=>s instanceof o.TestItemImpl,y.TestItem.from),e.ApiCommandArgument=i;class p{constructor(d,k){this.description=d,this.convert=k}}p.Void=new p("no result",s=>s),e.ApiCommandResult=p;class c{constructor(d,k,A,W,J){this.id=d,this.internalId=k,this.description=A,this.args=W,this.result=J}}e.ApiCommand=c}),define(Ce[207],Ie([1,0,2,8,7,75,37,16,88,92,15]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(C.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,o)=>{if((0,P.isFalsyOrEmpty)(a))return;class u extends y.SymbolInformation{static to(b){const R=new u(b.name,C.SymbolKind.to(b.kind),b.containerName||"",new y.Location(o[0],C.Range.to(b.range)));return R.detail=b.detail,R.range=R.location.range,R.selectionRange=C.Range.to(b.selectionRange),R.children=b.children?b.children.map(u.to):[],R}}return a.map(u.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(C.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(C.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(C.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(o=>y.Position.isPosition(o)),a=>a.map(C.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(o=>{let u;for(const g of o.reverse())u=new y.SelectionRange(C.Range.to(g),u);return u}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(C.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(C.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(C.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(C.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:C.Range.to(a.range),placeholder:a.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return C.WorkspaceEdit.to(a)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(C.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new y.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const o=(0,_.decodeSemanticTokensDto)(a);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new y.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const o=(0,_.decodeSemanticTokensDto)(a);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,o,u)=>{if(!a)return new y.CompletionList([]);const g=a.suggestions.map(b=>C.CompletionItem.to(b,u));return new y.CompletionList(g,a.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return C.SignatureHelp.to(a)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,o,u)=>E(g=>new y.CodeLens(C.Range.to(g.range),g.command&&u.fromInternal(g.command)))(a))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>y.Range.isRange(a),a=>y.Selection.isSelection(a)?C.Selection.from(a):C.Range.from(a)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,o,u)=>E(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(g.command)}else{const b=new y.CodeAction(g.title,g.kind?new y.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=C.WorkspaceEdit.to(g.edit)),g.command&&(b.command=u.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(a))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(o=>new y.ColorInformation(C.Range.to(o.range),C.Color.to(o.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",a=>a instanceof y.Color,C.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:C.Range.from(a.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(C.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,o,u)=>a.map(C.InlayHint.to.bind(void 0,u)))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(o=>C.NotebookExclusiveDocumentPattern.to(o))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(C.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>n.URI.isUri(a)||typeof a=="string"&&(0,I.matchesSomeScheme)(a,L.Schemas.http,L.Schemas.https),a=>a),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void),new S.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[S.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],S.ApiCommandResult.Void),new S.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[S.ApiCommandArgument.String.with("name","The context key name"),new S.ApiCommandArgument("value","The context key value",()=>!0,a=>a)],S.ApiCommandResult.Void)];class f{static register(o){w.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=f;function E(a){return o=>{if(Array.isArray(o))return o.map(a)}}function m(a){if(!Array.isArray(a))return;const o=[];for(const u of a)N.isLocationLink(u)?o.push(C.DefinitionLink.to(u)):o.push(C.location.to(u));return o}}),define(Ce[208],Ie([1,0,17,63,4,6,2,75,25,8,7,5]),function(te,e,n,C,y,N,S,P,_,I,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function f(E,m,a){const o=E.getProxy(w.MainContext.MainThreadComments);class u{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,m.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const p=this._commentControllers.get(i.handle);return p?p.value:i}else if(i&&i.$mid===7){const p=this._commentControllers.get(i.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.commentThreadHandle);return c?c.value:i}else if(i&&(i.$mid===9||i.$mid===8)){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);return c?i.$mid===8?c.value:{thread:c.value,text:i.text}:i}else if(i&&i.$mid===10){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;const s=i.commentUniqueId,d=c.getCommentByUniqueId(s);return d||i}else if(i&&i.$mid===11){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;const s=i.text,d=i.commentUniqueId,k=c.getCommentByUniqueId(d);return k?(typeof k.body=="string"?k.body=s:k.body=new L.MarkdownString(s),k):i}return i}})}createCommentController(i,p,c){const s=u.handlePool++,d=new b(i,s,p,c);this._commentControllers.set(d.handle,d);const k=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(i.identifier))||[];return k.push(d),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(i.identifier),k),d.value}$createCommentThreadTemplate(i,p,c){const s=this._commentControllers.get(i);!s||s.$createCommentThreadTemplate(p,c)}async $updateCommentThreadTemplate(i,p,c){const s=this._commentControllers.get(i);!s||s.$updateCommentThreadTemplate(p,c)}$deleteCommentThread(i,p){this._commentControllers.get(i)?.$deleteCommentThread(p)}$provideCommentingRanges(i,p,c){const s=this._commentControllers.get(i);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const d=a.getDocument(S.URI.revive(p));return(0,n.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(d,c)).then(k=>k?k.map(A=>I.Range.from(A)):void 0)}$toggleReaction(i,p,c,s,d){const k=this._commentControllers.get(i);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const A=k.getCommentThread(p);if(A){const W=A.getCommentByUniqueId(s.uniqueIdInThread);if(k!==void 0&&W&&k.reactionHandler)return k.reactionHandler(W,t(d))}return Promise.resolve(void 0)})}dispose(){}}u.handlePool=0;class g{set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(i){this._state=i,this.modifications.state=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(i,p,c,s,d,k,A,W){this._commentControllerHandle=p,this._id=c,this._uri=s,this._range=d,this._comments=k,this.extensionDescription=A,this._isTemplate=W,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputDisposables.value=new N.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),o.$createCommentThread(p,this.handle,this._id,this._uri,I.Range.from(this._range),A.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(p,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(j){J.range=j},get comments(){return J.comments},set comments(j){J.comments=j},get collapsibleState(){return J.collapsibleState},set collapsibleState(j){J.collapsibleState=j},get canReply(){return J.canReply},set canReply(j){J.canReply=j},get contextValue(){return J.contextValue},set contextValue(j){J.contextValue=j},get label(){return J.label},set label(j){J.label=j},get state(){return J.state},set state(j){J.state=j},dispose:()=>{J.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new N.DisposableStore);const i=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),p={};i("range")&&(p.range=I.Range.from(this._range)),i("label")&&(p.label=this.label),i("contextValue")&&(p.contextValue=this.contextValue??null),i("comments")&&(p.comments=this._comments.map(c=>R(this,c,this._commentsMap))),i("collapsibleState")&&(p.collapseState=h(this._collapseState)),i("canReply")&&(p.canReply=this.canReply),i("state")&&(p.state=r(this._state)),i("isTemplate")&&(p.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(i){for(const p of this._commentsMap){const c=p[0],s=p[1];if(i===s)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}g._handlePool=0,Ve([(0,C.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(i,p,c,s){this._extension=i,this._handle=p,this._id=c,this._label=s,this._threads=new Map,o.$registerCommentController(this.handle,c,s);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(k){d.options=k},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(k){d.commentingRangeProvider=k},get reactionHandler(){return d.reactionHandler},set reactionHandler(k){d.reactionHandler=k},createCommentThread(k,A,W){return d.createCommentThread(k,A,W).value},dispose:()=>{d.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(i,p,c,s){if(typeof i=="string"){const d=new g(this.id,this.handle,i,p,c,s,this._extension,!1);return this._threads.set(d.handle,d),d}else{const d=new g(this.id,this.handle,void 0,i,p,c,this._extension,!1);return this._threads.set(d.handle,d),d}}$createCommentThreadTemplate(i,p){const c=new g(this.id,this.handle,void 0,S.URI.revive(i),I.Range.to(p),[],this._extension,!0);return c.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(i,p){const c=this._threads.get(i);c&&(c.range=I.Range.to(p))}$deleteCommentThread(i){this._threads.get(i)?.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function R(l,i,p){let c=p.get(i);c||(c=++l.commentHandle,p.set(i,c));const s=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:c,body:typeof i.body=="string"?i.body:I.MarkdownString.from(i.body),userName:i.author.name,userIconPath:s,label:i.label,commentReactions:i.reactions?i.reactions.map(d=>v(d)):void 0,timestamp:i.timestamp?.toJSON()}}function v(l){return{label:l.label,iconPath:l.iconPath?I.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function t(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?S.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function h(l){if(l!==void 0)switch(l){case L.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function r(l){if(l!==void 0)switch(l){case L.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new u}e.createExtHostComments=f}),define(Ce[209],Ie([1,0,22,5,26,18]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let S=class{constructor(L,w){this._mainThreadConsole=L.getProxy(C.MainContext.MainThreadConsole),this._includeStack=w.consoleForward.includeStack,this._logNative=w.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,w){const f=this,E=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){f._handleConsoleCall(L,w,E,arguments)}})}_handleConsoleCall(L,w,f,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:w,arguments:_(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,f,E)}};S=Ve([He(0,N.IExtHostRpcService),He(1,y.IExtHostInitDataService)],S),e.AbstractExtHostConsoleForwarder=S;const P=1e5;function _(I,L){const w=[];if(I.length)for(let f=0;f<I.length;f++){let E=I[f];if(typeof E>"u")E="undefined";else if(E instanceof Error){const m=E;m.stack?E=m.stack:E=m.toString()}w.push(E)}if(L){const f=new Error().stack;f&&w.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,n.safeStringify)(w);return f.length>P?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Ce[103],Ie([1,0,2,5,7,3,18,11,16,10,19,27]),function(te,e,n,C,y,N,S,P,_,I,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class Ni{constructor(m,a){this._logService=a,this._provider=new Map,this._proxy=m.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const o=Ni._handlePool++;this._provider.set(o,{provider:m,extensionDescription:a}),this._proxy.$registerDecorationProvider(o,a.identifier.value);const u=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(o,null);return}const b=(0,_.asArray)(g);if(b.length<=Ni._maxEventSize){this._proxy.$onDidChange(o,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,b.length);const R=b.map(h=>({uri:h,rank:(0,I.count)(h.path,"/")})),v=(0,_.groupBy)(R,(h,r)=>h.rank-r.rank||(0,I.compare)(h.uri.path,r.uri.path)),t=[];e:for(const h of v){let r;for(const l of h){const i=(0,L.dirname)(l.uri.path);if(r!==i&&(r=i,t.push(l.uri)>=Ni._maxEventSize))break e}}this._proxy.$onDidChange(o,t)});return new y.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(m,a,o){if(!this._provider.has(m))return Object.create(null);const u=Object.create(null),{provider:g,extensionDescription:b}=this._provider.get(m);return await Promise.all(a.map(async R=>{try{const{uri:v,id:t}=R,h=await Promise.resolve(g.provideFileDecoration(n.URI.revive(v),o));if(!h)return;try{y.FileDecoration.validate(h),h.badge&&typeof h.badge!="string"&&(0,w.checkProposedApiEnabled)(b,"codiconDecoration"),u[t]=[h.propagate,h.tooltip,h.badge,h.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${b}': ${r}`)}}catch(v){this._logService.error(v)}})),u}};f._handlePool=0,f._maxEventSize=250,f=Ve([He(0,S.IExtHostRpcService),He(1,P.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[210],Ie([1,0,139,91,2,5,7,8,4,11,28,36]),function(te,e,n,C,y,N,S,P,_,I,L,w){"use strict";var f,E,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(g,b,R,v,t,h,r){this._name=g,this._owner=b,this._maxDiagnosticsPerFile=R,this._modelVersionIdProvider=v,f.set(this,void 0),E.set(this,void 0),m.set(this,void 0),this._isDisposed=!1,Je(this,m,new L.ResourceMap(l=>t.getComparisonKey(l)),"f"),Je(this,f,h,"f"),Je(this,E,r,"f")}dispose(){this._isDisposed||(Oe(this,E,"f").fire([...Oe(this,m,"f").keys()]),Oe(this,f,"f")?.$clear(this._owner),Oe(this,m,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,b){if(!g){this.clear();return}this._checkDisposed();let R=[];if(y.URI.isUri(g)){if(!b){this.delete(g);return}Oe(this,m,"f").set(g,b.slice()),R=[g]}else if(Array.isArray(g)){R=[];let t;g=[...g].sort(a._compareIndexedTuplesByUri);for(const h of g){const[r,l]=h;if((!t||r.toString()!==t.toString())&&(t&&Oe(this,m,"f").get(t).length===0&&Oe(this,m,"f").delete(t),t=r,R.push(r),Oe(this,m,"f").set(r,[])),l)Oe(this,m,"f").get(r)?.push(...l);else{const i=Oe(this,m,"f").get(r);i&&(i.length=0)}}}if(Oe(this,E,"f").fire(R),!Oe(this,f,"f"))return;const v=[];for(const t of R){let h=[];const r=Oe(this,m,"f").get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){h=[];const l=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const p of r)if(p.severity===l[i]&&h.push({...P.Diagnostic.from(p),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;h.push({severity:C.MarkerSeverity.Info,message:(0,n.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=r.map(l=>({...P.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(t)}));v.push([t,h])}Oe(this,f,"f").$changeMany(this._owner,v)}delete(g){this._checkDisposed(),Oe(this,E,"f").fire([g]),Oe(this,m,"f").delete(g),Oe(this,f,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Oe(this,E,"f").fire([...Oe(this,m,"f").keys()]),Oe(this,m,"f").clear(),Oe(this,f,"f")?.$clear(this._owner)}forEach(g,b){this._checkDisposed();for(const[R,v]of this)g.call(b,R,v,this)}*[(f=new WeakMap,E=new WeakMap,m=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Oe(this,m,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const b=Oe(this,m,"f").get(g);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Oe(this,m,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,b){return g[0].toString()<b[0].toString()?-1:g[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=a;let o=class pi{static _mapper(g){const b=new L.ResourceMap;for(const R of g)b.set(R,R);return{uris:Object.freeze(Array.from(b.values()))}}constructor(g,b,R,v){this._logService=b,this._fileSystemInfoService=R,this._extHostDocumentsAndEditors=v,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,pi._mapper),this._proxy=g.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,b){const{_collections:R,_proxy:v,_onDidChangeDiagnostics:t,_logService:h,_fileSystemInfoService:r,_extHostDocumentsAndEditors:l}=this,i=new class{$changeMany(s,d){v.$changeMany(s,d),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,s,d.length===0?"CLEARING":d)}$clear(s){v.$clear(s),h.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,s)}dispose(){v.dispose()}};let p;if(!b)b="_generated_diagnostic_collection_name_#"+pi._idPool++,p=b;else if(!R.has(b))p=b;else{this._logService.warn(`DiagnosticCollection with name '${b}' does already exist.`);do p=b+pi._idPool++;while(R.has(p))}return new class extends a{constructor(){super(b,p,pi._maxDiagnosticsPerFile,s=>l.getDocument(s)?.version,r.extUri,i,t),R.set(p,this)}dispose(){super.dispose(),R.delete(p)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const b=new Map,R=[];for(const v of this._collections.values())v.forEach((t,h)=>{let r=b.get(t.toString());typeof r>"u"&&(r=R.length,b.set(t.toString(),r),R.push([t,[]])),R[r][1]=R[r][1].concat(...h)});return R}}_getDiagnostics(g){let b=[];for(const R of this._collections.values())R.has(g)&&(b=b.concat(R.get(g)));return b}$acceptMarkersChange(g){if(!this._mirrorCollection){const b="_generated_mirror",R=new a(b,b,pi._maxDiagnosticsPerFile,v=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(b,R),this._mirrorCollection=R}for(const[b,R]of g)this._mirrorCollection.set(y.URI.revive(b),R.map(P.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=Ve([He(1,I.ILogService),He(2,w.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(Ce[211],Ie([1,0,2,5]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(S){this._proxy=S.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(P=>P?P.map(_=>n.URI.revive(_)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(P=>P?n.URI.revive(P):void 0)}}e.ExtHostDialogs=y}),define(Ce[212],Ie([1,0,12,2,7,5,15,20,10]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(w,f,E){this._documentsAndEditors=f,this._logService=E,this._documentContentProviders=new Map,this._proxy=w.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,f){if(Object.keys(S.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const E=I._handlePool++;this._documentContentProviders.set(E,f),this._proxy.$registerTextContentProvider(E,w);let m;return typeof f.onDidChange=="function"&&(m=f.onDidChange(a=>{if(a.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(E,a).then(o=>{if(!o&&typeof o!="string")return;const u=this._documentsAndEditors.getDocument(a);if(!u)return;const g=(0,_.splitLines)(o);if(!u.equalLines(g))return this._proxy.$onVirtualDocumentChange(a,o)},n.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(w,f){const E=this._documentContentProviders.get(w);return E?Promise.resolve(E.provideTextDocumentContent(C.URI.revive(f),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}I._handlePool=0,e.ExtHostDocumentContentProvider=I}),define(Ce[213],Ie([1,0,4,6,2,5,99,8,9,22,7]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(E,m){this._onDidAddDocument=new n.Emitter,this._onDidRemoveDocument=new n.Emitter,this._onDidChangeDocument=new n.Emitter,this._onDidSaveDocument=new n.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(N.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const o of a)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const o of a)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const m=this._documentsAndEditors.getDocument(E);if(m)return m}getDocument(E){const m=this.getDocumentData(E);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return m.document}ensureDocumentData(E){const m=this._documentsAndEditors.getDocument(E);if(m)return Promise.resolve(m);let a=this._documentLoader.get(E.toString());return a||(a=this._proxy.$tryOpenDocument(E).then(o=>{this._documentLoader.delete(E.toString());const u=y.URI.revive(o);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(u))},o=>(this._documentLoader.delete(E.toString()),Promise.reject(o))),this._documentLoader.set(E.toString(),a)),a}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(m=>y.URI.revive(m))}$acceptModelLanguageChanged(E,m){const a=y.URI.revive(E),o=this._documentsAndEditors.getDocument(a);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(m),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(E){const m=y.URI.revive(E),a=this._documentsAndEditors.getDocument(m);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(E,m){const a=y.URI.revive(E),o=this._documentsAndEditors.getDocument(a);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,m,a){const o=y.URI.revive(E),u=this._documentsAndEditors.getDocument(o);if(!u)throw new Error("unknown document");u._acceptIsDirty(a),u.onEvents(m);let g;m.isUndoing?g=L.TextDocumentChangeReason.Undo:m.isRedoing&&(g=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:u.document,contentChanges:m.changes.map(b=>({range:P.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:g}))}setWordDefinitionFor(E,m){(0,S.setWordDefinitionFor)(E,m)}}e.ExtHostDocuments=w}),define(Ce[57],Ie([1,0,49,4,6,2,3,5,99,18,102,8,11,28,15,185,85]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(R){this.value=R,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(R,v){this._extHostRpc=R,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(R){this.acceptDocumentsAndEditorsDelta(R)}acceptDocumentsAndEditorsDelta(R){const v=[],t=[],h=[];if(R.removedDocuments)for(const r of R.removedDocuments){const l=N.URI.revive(r),i=this._documents.get(l);i?.unref()&&(this._documents.delete(l),v.push(i.value))}if(R.addedDocuments)for(const r of R.addedDocuments){const l=N.URI.revive(r.uri);let i=this._documents.get(l);if(i&&l.scheme!==m.Schemas.vscodeNotebookCell&&l.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);i||(i=new u(new _.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),l,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(l,i),t.push(i.value)),i.ref()}if(R.removedEditors)for(const r of R.removedEditors){const l=this._editors.get(r);this._editors.delete(r),l&&h.push(l)}if(R.addedEditors)for(const r of R.addedEditors){const l=N.URI.revive(r.documentUri);n.ok(this._documents.has(l),`document '${l}' does not exist`),n.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const i=this._documents.get(l).value,p=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new o.Lazy(()=>i.document),r.selections.map(w.Selection.to),r.options,r.visibleRanges.map(c=>w.Range.to(c)),typeof r.editorPosition=="number"?w.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,p)}R.newActiveEditor!==void 0&&(n.ok(R.newActiveEditor===null||this._editors.has(R.newActiveEditor),`active editor '${R.newActiveEditor}' does not exist`),this._activeEditorId=R.newActiveEditor),(0,y.dispose)(v),(0,y.dispose)(h),R.removedDocuments&&this._onDidRemoveDocuments.fire(v),R.addedDocuments&&this._onDidAddDocuments.fire(t),(R.removedEditors||R.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),R.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(R){return this._documents.get(R)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),R=>R.value)}getEditor(R){return this._editors.get(R)}activeEditor(R){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return R?v:v?.value}allEditors(){return[...this._editors.values()]}};g=Ve([He(0,I.IExtHostRpcService),He(1,f.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[58],Ie([1,0,8,5,2,4,3,7,18,9,62]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class w{constructor(o,u,g){this._activeTabIdGetter=g,this._parentGroup=u,this.acceptDtoUpdate(o)}get apiObject(){if(!this._apiObject){const o=this,u={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get input(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(u)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(y.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified));case 3:return new P.TextMergeTabInput(y.URI.revive(this._dto.input.base),y.URI.revive(this._dto.input.input1),y.URI.revive(this._dto.input.input2),y.URI.revive(this._dto.input.result));case 6:return new P.CustomEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new P.NotebookEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(y.URI.revive(this._dto.input.uri),y.URI.revive(this._dto.input.inputBoxUri));default:return}}}class f{constructor(o,u){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=u;for(const g of o.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new w(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const o=this,u={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return n.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(g=>g.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(u)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabOperation(o){if(o.kind===0){const g=new w(o.tabDto,this,()=>this.activeTabId());return this._tabs.splice(o.index,0,g),o.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(o.kind===1){const g=this._tabs.splice(o.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(o.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this._tabs.splice(o.index,0,g),g}const u=this._tabs.find(g=>g.tabId===o.tabDto.id);if(!u)throw new Error("INVALID tab");return o.tabDto.isActive?this._activeTabId=o.tabDto.id:this._activeTabId===o.tabDto.id&&!o.tabDto.isActive&&(this._activeTabId=""),u.acceptDtoUpdate(o.tabDto),u}activeTabId(){return this._activeTabId}}let E=class{constructor(o){this._onDidChangeTabs=new N.Emitter,this._onDidChangeTabGroups=new N.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,u={onDidChangeTabGroups:o._onDidChangeTabGroups.event,onDidChangeTabs:o._onDidChangeTabs.event,get all(){return Object.freeze(o._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=o._activeGroupId;return(0,I.assertIsDefined)(o._extHostTabGroups.find(R=>R.groupId===g)?.apiObject)},close:async(g,b)=>{const R=Array.isArray(g)?g:[g];return R.length?m(R[0])?this._closeGroups(R,b):this._closeTabs(R,b):!0}};this._apiObject=Object.freeze(u)}return this._apiObject}$acceptEditorTabModel(o){const u=new Set(this._extHostTabGroups.map(r=>r.groupId)),g=new Set(o.map(r=>r.groupId)),b=(0,L.diffSets)(u,g),R=this._extHostTabGroups.filter(r=>b.removed.includes(r.groupId)).map(r=>r.apiObject),v=[],t=[];this._extHostTabGroups=o.map(r=>{const l=new f(r,()=>this._activeGroupId);return b.added.includes(l.groupId)?v.push(l.apiObject):t.push(l.apiObject),l});const h=(0,I.assertIsDefined)(o.find(r=>r.isActive===!0)?.groupId);h!==void 0&&this._activeGroupId!==h&&(this._activeGroupId=h),this._onDidChangeTabGroups.fire(Object.freeze({opened:v,closed:R,changed:t}))}$acceptTabGroupUpdate(o){const u=this._extHostTabGroups.find(g=>g.groupId===o.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(o),o.isActive&&(this._activeGroupId=o.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const u=this._extHostTabGroups.find(b=>b.groupId===o.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const g=u.acceptTabOperation(o);switch(o.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(o){for(const u of this._extHostTabGroups)for(const g of u.tabs)if(g.apiObject===o)return g}_findExtHostTabGroupFromApi(o){return this._extHostTabGroups.find(u=>u.apiObject===o)}async _closeTabs(o,u){const g=[];for(const b of o){const R=this._findExtHostTabFromApi(b);if(!R)throw new Error("Tab close: Invalid tab not found!");g.push(R.tabId)}return this._proxy.$closeTab(g,u)}async _closeGroups(o,u){const g=[];for(const b of o){const R=this._findExtHostTabGroupFromApi(b);if(!R)throw new Error("Group close: Invalid group not found!");g.push(R.groupId)}return this._proxy.$closeGroup(g,u)}};E=Ve([He(0,_.IExtHostRpcService)],E),e.ExtHostEditorTabs=E;function m(a){return a.tabs!==void 0}}),define(Ce[214],Ie([1,0,2,5,6,7,8,260,10,23,27]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const a=this._schemes.indexOf(m);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),a=[];let o,u,g=14,b=14;for(const R of m){let v=o?(0,_.commonPrefixLength)(o,R):0;for(v===0?u=1:u=b;v<R.length;v++)v+1===R.length?(g=b,b=9):b+=1,a.push([u,R.toUpperCase().charCodeAt(v),b]),a.push([u,R.toLowerCase().charCodeAt(v),b]),u=b;o=R,b=g}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new P.StateMachine(a)}}provideDocumentLinks(m){this._initStateMachine();const a=[],o=P.LinkComputer.computeLinks({getLineContent(u){return m.lineAt(u-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const u of o){const g=S.DocumentLink.to(u);g.target&&a.push(g)}return a}}class f{constructor(m,a){this._extHostLanguageFeatures=a,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(m,a,o,u={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(m,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(g,o);let b=2;u.isCaseSensitive&&(b+=1024),u.isReadonly&&(b+=2048),typeof o.copy=="function"&&(b+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,L.checkProposedApiEnabled)(m,"fsChunks"),b+=4),this._proxy.$registerFileSystemProvider(g,a,b).catch(v=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${a}`),console.error(v)});const R=o.onDidChangeFile(v=>{const t=[];for(const h of v){const{uri:r,type:l}=h;if(r.scheme!==a)continue;let i;switch(l){case N.FileChangeType.Changed:i=0;break;case N.FileChangeType.Created:i=1;break;case N.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:i})}this._proxy.$onFileSystemChange(g,t)});return(0,y.toDisposable)(()=>{R.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(m){const{type:a,ctime:o,mtime:u,size:g,permissions:b}=m;return{type:a,ctime:o,mtime:u,size:g,permissions:b}}$stat(m,a){return Promise.resolve(this._getFsProvider(m).stat(n.URI.revive(a))).then(o=>f._asIStat(o))}$readdir(m,a){return Promise.resolve(this._getFsProvider(m).readDirectory(n.URI.revive(a)))}$readFile(m,a){return Promise.resolve(this._getFsProvider(m).readFile(n.URI.revive(a))).then(o=>I.VSBuffer.wrap(o))}$writeFile(m,a,o,u){return Promise.resolve(this._getFsProvider(m).writeFile(n.URI.revive(a),o.buffer,u))}$delete(m,a,o){return Promise.resolve(this._getFsProvider(m).delete(n.URI.revive(a),o))}$rename(m,a,o,u){return Promise.resolve(this._getFsProvider(m).rename(n.URI.revive(a),n.URI.revive(o),u))}$copy(m,a,o,u){const g=this._getFsProvider(m);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(n.URI.revive(a),n.URI.revive(o),u))}$mkdir(m,a){return Promise.resolve(this._getFsProvider(m).createDirectory(n.URI.revive(a)))}$watch(m,a,o,u){const g=this._getFsProvider(m).watch(n.URI.revive(o),u);this._watches.set(a,g)}$unwatch(m,a){const o=this._watches.get(a);o&&(o.dispose(),this._watches.delete(a))}$open(m,a,o){const u=this._getFsProvider(m);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(n.URI.revive(a),o))}$close(m,a){const o=this._getFsProvider(m);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(a))}$read(m,a,o,u){const g=this._getFsProvider(m);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const b=I.VSBuffer.alloc(u);return Promise.resolve(g.read(a,o,b.buffer,0,u)).then(R=>b.slice(0,R))}$write(m,a,o,u){const g=this._getFsProvider(m);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(a,o,u.buffer,0,u.byteLength))}_getFsProvider(m){const a=this._fsProvider.get(m);if(!a){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return a}}e.ExtHostFileSystem=f}),define(Ce[59],Ie([1,0,5,43,7,23,3,18,36,6]),function(te,e,n,C,y,N,S,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Yt{constructor(f,E){this._fileSystemProvider=new Map,this._proxy=f.getProxy(n.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(a){try{const o=m._fileSystemProvider.get(a.scheme);if(!o)return await m._proxy.$stat(a);await m._proxy.$ensureActivation(a.scheme);const u=await o.stat(a);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(o){Yt._handleError(o)}},async readDirectory(a){try{const o=m._fileSystemProvider.get(a.scheme);return o?(await m._proxy.$ensureActivation(a.scheme),(await o.readDirectory(a)).slice()):await m._proxy.$readdir(a)}catch(o){return Yt._handleError(o)}},async createDirectory(a){try{return await m._proxy.$mkdir(a)}catch(o){return Yt._handleError(o)}},async readFile(a){try{const o=m._fileSystemProvider.get(a.scheme);return o?(await m._proxy.$ensureActivation(a.scheme),(await o.readFile(a)).slice()):(await m._proxy.$readFile(a)).buffer}catch(o){return Yt._handleError(o)}},async writeFile(a,o){try{return await m._proxy.$writeFile(a,N.VSBuffer.wrap(o))}catch(u){return Yt._handleError(u)}},async delete(a,o){try{const u=m._fileSystemProvider.get(a.scheme);return u?(await m._proxy.$ensureActivation(a.scheme),await u.delete(a,{recursive:!1,...o})):await m._proxy.$delete(a,{recursive:!1,useTrash:!1,...o})}catch(u){return Yt._handleError(u)}},async rename(a,o,u){try{return await m._proxy.$rename(a,o,{overwrite:!1,...u})}catch(g){return Yt._handleError(g)}},async copy(a,o,u){try{return await m._proxy.$copy(a,o,{overwrite:!1,...u})}catch(g){return Yt._handleError(g)}},isWritableFileSystem(a){const o=E.getCapabilities(a);if(typeof o=="number")return!(o&2048)}})}static _handleError(f){if(f instanceof y.FileSystemError)throw f;if(!(f instanceof Error))throw new y.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw y.FileSystemError.Unavailable(f.message);switch(f.name){case C.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(f.message);case C.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(f.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(f.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(f.message);case C.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(f.message);case C.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(f.message);default:throw new y.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,E){return this._fileSystemProvider.set(f,E),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(f))}};L=Ve([He(0,P.IExtHostRpcService),He(1,_.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[215],Ie([1,0,4,35,2,5,8,7]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(w,f,E,m,a,o,u,g){this._onDidCreate=new n.Emitter,this._onDidChange=new n.Emitter,this._onDidDelete=new n.Emitter;const b=this.ensureWatching(w,E,a);this._config=0,o&&(this._config+=1),u&&(this._config+=2),g&&(this._config+=4);const R=(0,C.parse)(a),v=typeof a=="string",t=m(h=>{if(!o)for(const r of h.created){const l=y.URI.revive(r);R(l.fsPath)&&(!v||f.getWorkspaceFolder(l))&&this._onDidCreate.fire(l)}if(!u)for(const r of h.changed){const l=y.URI.revive(r);R(l.fsPath)&&(!v||f.getWorkspaceFolder(l))&&this._onDidChange.fire(l)}if(!g)for(const r of h.deleted){const l=y.URI.revive(r);R(l.fsPath)&&(!v||f.getWorkspaceFolder(l))&&this._onDidDelete.fire(l)}});this._disposable=P.Disposable.from(b,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(w,f,E){const m=P.Disposable.from();if(typeof E=="string")return m;const a=w.getProxy(N.MainContext.MainThreadFileSystem);let o=!1;(E.pattern.includes(C.GLOBSTAR)||E.pattern.includes(C.GLOB_SPLIT))&&(o=!0);const u=Math.random();return a.$watch(f.identifier.value,u,E.baseUri,{recursive:o,excludes:[]}),P.Disposable.from({dispose:()=>a.$unwatch(u)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class I{constructor(w,f,E){this._mainContext=w,this._logService=f,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new n.Emitter,this._onDidRenameFile=new n.Emitter,this._onDidCreateFile=new n.Emitter,this._onDidDeleteFile=new n.Emitter,this._onWillRenameFile=new n.AsyncEmitter,this._onWillCreateFile=new n.AsyncEmitter,this._onWillDeleteFile=new n.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(w,f,E,m,a,o){return new _(this._mainContext,w,f,this._onFileSystemEvent.event,S.GlobPattern.from(E),m,a,o)}$onFileEvent(w){this._onFileSystemEvent.fire(w)}$onDidRunFileOperation(w,f){switch(w){case 2:this._onDidRenameFile.fire(Object.freeze({files:f.map(E=>({oldUri:y.URI.revive(E.source),newUri:y.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:f.map(E=>y.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:f.map(E=>y.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(w){return this._createWillExecuteEvent(w,this._onWillRenameFile)}getOnWillCreateFileEvent(w){return this._createWillExecuteEvent(w,this._onWillCreateFile)}getOnWillDeleteFileEvent(w){return this._createWillExecuteEvent(w,this._onWillDeleteFile)}_createWillExecuteEvent(w,f){return(E,m,a)=>{const o=function(g){E.call(m,g)};return o.extension=w,f.event(o,void 0,a)}}async $onWillRunFileOperation(w,f,E,m){switch(w){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:f.map(a=>({oldUri:y.URI.revive(a.source),newUri:y.URI.revive(a.target)}))},E,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:f.map(a=>y.URI.revive(a.target))},E,m);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:f.map(a=>y.URI.revive(a.target))},E,m)}}async _fireWillEvent(w,f,E,m){const a=new Set,o=[];if(await w.fireAsync(f,m,async(g,b)=>{const R=Date.now(),v=await Promise.resolve(g);v instanceof P.WorkspaceEdit&&(o.push([b.extension,v]),a.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-R>E&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),m.isCancellationRequested||o.length===0)return;const u={edits:[]};for(const[,g]of o){const{edits:b}=S.WorkspaceEdit.from(g,{getTextDocumentVersion:R=>this._extHostDocumentsAndEditors.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(b)}return{edit:u,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=I}),define(Ce[216],Ie([1,0,2,37]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(S,P,_,I,L){this._extHostNotebooks=P,this._textDocumentsAndEditors=_,this._commands=I;const w=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new C.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new C.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new C.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new C.ApiCommandResult("Notebook and input URI",f=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(f.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri),notebookEditor:E.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri)}}));this._commands.registerApiCommand(w)}$willAddInteractiveDocument(S,P,_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:_,uri:S,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(n.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=y}),define(Ce[217],Ie([1,0,6,5]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(S){this._handlePool=0,this._proxy=S.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,S),(0,n.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=y}),define(Ce[218],Ie([1,0,2,22,8,7,75,5,10,44,16,9,261,20,6,88,83,54,77,12,17,27]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(D,U){this._documents=D,this._provider=U}async provideDocumentSymbols(D,U){const $=this._documents.getDocument(D),V=await this._provider.provideDocumentSymbols($,U);if(!(0,L.isFalsyOrEmpty)(V))return V[0]instanceof N.DocumentSymbol?V.map(y.DocumentSymbol.from):t._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(D){D=D.slice(0).sort((V,ee)=>{let me=V.location.range.start.compareTo(ee.location.range.start);return me===0&&(me=ee.location.range.end.compareTo(V.location.range.end)),me});const U=[],$=[];for(const V of D){const ee={name:V.name||"!!MISSING: name!!",kind:y.SymbolKind.from(V.kind),tags:V.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:y.Range.from(V.location.range),selectionRange:y.Range.from(V.location.range),children:[]};for(;;){if($.length===0){$.push(ee),U.push(ee);break}const me=$[$.length-1];if(I.Range.containsRange(me.range,ee.range)&&!I.Range.equalsRange(me.range,ee.range)){me.children?.push(ee),$.push(ee);break}$.pop()}}return U}}class h{constructor(D,U,$){this._documents=D,this._commands=U,this._provider=$,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(D,U){const $=this._documents.getDocument(D),V=await this._provider.provideCodeLenses($,U);if(!V||U.isCancellationRequested)return;const ee=this._cache.add(V),me=new m.DisposableStore;this._disposables.set(ee,me);const _e={cacheId:ee,lenses:[]};for(let ce=0;ce<V.length;ce++)_e.lenses.push({cacheId:[ee,ce],range:y.Range.from(V[ce].range),command:this._commands.toInternal(V[ce].command,me)});return _e}async resolveCodeLens(D,U){const $=D.cacheId&&this._cache.get(...D.cacheId);if(!$)return;let V;if(typeof this._provider.resolveCodeLens!="function"||$.isResolved?V=$:V=await this._provider.resolveCodeLens($,U),V||(V=$),U.isCancellationRequested)return;const ee=D.cacheId&&this._disposables.get(D.cacheId[0]);if(!!ee)return D.command=this._commands.toInternal(V.command??h._badCmd,ee),D}releaseCodeLenses(D){this._disposables.get(D)?.dispose(),this._disposables.delete(D),this._cache.delete(D)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(Y){return Array.isArray(Y)?Y.map(y.DefinitionLink.from):Y?[y.DefinitionLink.from(Y)]:[]}class l{constructor(D,U){this._documents=D,this._provider=U}async provideDefinition(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.provideDefinition(V,ee,$);return r(me)}}class i{constructor(D,U){this._documents=D,this._provider=U}async provideDeclaration(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.provideDeclaration(V,ee,$);return r(me)}}class p{constructor(D,U){this._documents=D,this._provider=U}async provideImplementation(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.provideImplementation(V,ee,$);return r(me)}}class c{constructor(D,U){this._documents=D,this._provider=U}async provideTypeDefinition(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.provideTypeDefinition(V,ee,$);return r(me)}}class s{constructor(D,U){this._documents=D,this._provider=U}async provideHover(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.provideHover(V,ee,$);if(!(!me||(0,L.isFalsyOrEmpty)(me.contents)))return me.range||(me.range=V.getWordRangeAtPosition(ee)),me.range||(me.range=new N.Range(ee,ee)),y.Hover.from(me)}}class d{constructor(D,U){this._documents=D,this._provider=U}async provideEvaluatableExpression(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.provideEvaluatableExpression(V,ee,$);if(me)return y.EvaluatableExpression.from(me)}}class k{constructor(D,U){this._documents=D,this._provider=U}async provideInlineValues(D,U,$,V){const ee=this._documents.getDocument(D),me=await this._provider.provideInlineValues(ee,y.Range.to(U),y.InlineValueContext.to($),V);if(Array.isArray(me))return me.map(_e=>y.InlineValue.from(_e))}}class A{constructor(D,U){this._documents=D,this._provider=U}async provideDocumentHighlights(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.provideDocumentHighlights(V,ee,$);if(Array.isArray(me))return me.map(y.DocumentHighlight.from)}}class W{constructor(D,U){this._documents=D,this._provider=U}async provideLinkedEditingRanges(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.provideLinkedEditingRanges(V,ee,$);if(me&&Array.isArray(me.ranges))return{ranges:(0,L.coalesce)(me.ranges.map(y.Range.from)),wordPattern:me.wordPattern}}}class J{constructor(D,U){this._documents=D,this._provider=U}async provideReferences(D,U,$,V){const ee=this._documents.getDocument(D),me=y.Position.to(U),_e=await this._provider.provideReferences(ee,me,$,V);if(Array.isArray(_e))return _e.map(y.location.from)}}class j{constructor(D,U,$,V,ee,me,_e){this._documents=D,this._commands=U,this._diagnostics=$,this._provider=V,this._logService=ee,this._extension=me,this._apiDeprecation=_e,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(D,U,$,V){const ee=this._documents.getDocument(D),me=f.Selection.isISelection(U)?y.Selection.to(U):y.Range.to(U),_e=[];for(const tt of this._diagnostics.getDiagnostics(D))if(me.intersection(tt.range)&&_e.push(tt)>j._maxCodeActionsPerFile)break;const ce={diagnostics:_e,only:$.only?new N.CodeActionKind($.only):void 0,triggerKind:y.CodeActionTriggerKind.to($.trigger)},Ee=await this._provider.provideCodeActions(ee,me,ce,V);if(!(0,L.isNonEmptyArray)(Ee)||V.isCancellationRequested)return;const be=this._cache.add(Ee),$e=new m.DisposableStore;this._disposables.set(be,$e);const We=[];for(let tt=0;tt<Ee.length;tt++){const Ge=Ee[tt];!Ge||(j._isCommand(Ge)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),We.push({_isSynthetic:!0,title:Ge.title,command:this._commands.toInternal(Ge,$e)})):(ce.only&&(Ge.kind?ce.only.contains(Ge.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ce.only.value} 'requested but returned code action is of kind '${Ge.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),We.push({cacheId:[be,tt],title:Ge.title,command:Ge.command&&this._commands.toInternal(Ge.command,$e),diagnostics:Ge.diagnostics&&Ge.diagnostics.map(y.Diagnostic.from),edit:Ge.edit&&y.WorkspaceEdit.from(Ge.edit,void 0),kind:Ge.kind&&Ge.kind.value,isPreferred:Ge.isPreferred,disabled:Ge.disabled?.reason})))}return{cacheId:be,actions:We}}async resolveCodeAction(D,U){const[$,V]=D,ee=this._cache.get($,V);if(!ee||j._isCommand(ee)||!this._provider.resolveCodeAction)return;const me=await this._provider.resolveCodeAction(ee,U)??ee;return me?.edit?y.WorkspaceEdit.from(me.edit,void 0):void 0}releaseCodeActions(D){this._disposables.get(D)?.dispose(),this._disposables.delete(D),this._cache.delete(D)}static _isCommand(D){return typeof D.command=="string"&&typeof D.title=="string"}}j._maxCodeActionsPerFile=1e3;class O{constructor(D,U,$,V){this._proxy=D,this._documents=U,this._provider=$,this._handle=V}async prepareDocumentPaste(D,U,$,V){if(!this._provider.prepareDocumentPaste)return;const ee=this._documents.getDocument(D),me=U.map(ce=>y.Range.to(ce)),_e=y.DataTransfer.toDataTransfer($,()=>{throw new b.NotImplementedError});return await this._provider.prepareDocumentPaste(ee,me,_e,V),y.DataTransfer.toDataTransferDTO(_e)}async providePasteEdits(D,U,$,V,ee){const me=this._documents.getDocument(U),_e=$.map(be=>y.Range.to(be)),ce=y.DataTransfer.toDataTransfer(V,async be=>(await this._proxy.$resolvePasteFileData(this._handle,D,be)).buffer),Ee=await this._provider.provideDocumentPasteEdits(me,_e,ce,ee);if(!!Ee)return{insertText:typeof Ee.insertText=="string"?Ee.insertText:{snippet:Ee.insertText.value},additionalEdit:Ee.additionalEdit?y.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}}class B{constructor(D,U){this._documents=D,this._provider=U}async provideDocumentFormattingEdits(D,U,$){const V=this._documents.getDocument(D),ee=await this._provider.provideDocumentFormattingEdits(V,U,$);if(Array.isArray(ee))return ee.map(y.TextEdit.from)}}class T{constructor(D,U){this._documents=D,this._provider=U}async provideDocumentRangeFormattingEdits(D,U,$,V){const ee=this._documents.getDocument(D),me=y.Range.to(U),_e=await this._provider.provideDocumentRangeFormattingEdits(ee,me,$,V);if(Array.isArray(_e))return _e.map(y.TextEdit.from)}}class F{constructor(D,U){this._documents=D,this._provider=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(D,U,$,V,ee){const me=this._documents.getDocument(D),_e=y.Position.to(U),ce=await this._provider.provideOnTypeFormattingEdits(me,_e,$,V,ee);if(Array.isArray(ce))return ce.map(y.TextEdit.from)}}class z{constructor(D,U){this._provider=D,this._logService=U,this._cache=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(D,U){const $=await this._provider.provideWorkspaceSymbols(D,U);if(!(0,L.isNonEmptyArray)($))return{symbols:[]};const V=this._cache.add($),ee={cacheId:V,symbols:[]};for(let me=0;me<$.length;me++){const _e=$[me];if(!_e||!_e.name){this._logService.warn("INVALID SymbolInformation",_e);continue}ee.symbols.push({...y.WorkspaceSymbol.from(_e),cacheId:[V,me]})}return ee}async resolveWorkspaceSymbol(D,U){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!D.cacheId)return D;const $=this._cache.get(...D.cacheId);if($){const V=await this._provider.resolveWorkspaceSymbol($,U);return V&&(0,C.mixin)(D,y.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(D){this._cache.delete(D)}}class H{static supportsResolving(D){return typeof D.prepareRename=="function"}constructor(D,U,$){this._documents=D,this._provider=U,this._logService=$}async provideRenameEdits(D,U,$,V){const ee=this._documents.getDocument(D),me=y.Position.to(U);try{const _e=await this._provider.provideRenameEdits(ee,me,$,V);return _e?y.WorkspaceEdit.from(_e):void 0}catch(_e){const ce=H._asMessage(_e);return ce?{rejectReason:ce,edits:void 0}:Promise.reject(_e)}}async resolveRenameLocation(D,U,$){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(D),ee=y.Position.to(U);try{const me=await this._provider.prepareRename(V,ee,$);let _e,ce;if(N.Range.isRange(me)?(_e=me,ce=V.getText(me)):(0,w.isObject)(me)&&(_e=me.range,ce=me.placeholder),!_e||!ce)return;if(_e.start.line>ee.line||_e.end.line<ee.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(_e),text:ce}}catch(me){const _e=H._asMessage(me);return _e?{rejectReason:_e,range:void 0,text:void 0}:Promise.reject(me)}}static _asMessage(D){return typeof D=="string"?D:D instanceof Error&&typeof D.message=="string"?D.message:void 0}}class de{constructor(D,U){this.resultId=D,this.tokens=U}}class pe{constructor(D,U){this._documents=D,this._provider=U,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(D,U,$){const V=this._documents.getDocument(D),ee=U!==0?this._previousResults.get(U):null;let me=typeof ee?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,ee.resultId,$):await this._provider.provideDocumentSemanticTokens(V,$);return ee&&this._previousResults.delete(U),me?(me=pe._fixProvidedSemanticTokens(me),this._send(pe._convertToEdits(ee,me),me)):null}async releaseDocumentSemanticColoring(D){this._previousResults.delete(D)}static _fixProvidedSemanticTokens(D){return pe._isSemanticTokens(D)?pe._isCorrectSemanticTokens(D)?D:new N.SemanticTokens(new Uint32Array(D.data),D.resultId):pe._isSemanticTokensEdits(D)?pe._isCorrectSemanticTokensEdits(D)?D:new N.SemanticTokensEdits(D.edits.map(U=>new N.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),D.resultId):D}static _isSemanticTokens(D){return D&&!!D.data}static _isCorrectSemanticTokens(D){return D.data instanceof Uint32Array}static _isSemanticTokensEdits(D){return D&&Array.isArray(D.edits)}static _isCorrectSemanticTokensEdits(D){for(const U of D.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(D,U){if(!pe._isSemanticTokens(U)||!D||!D.tokens)return U;const $=D.tokens,V=$.length,ee=U.data,me=ee.length;let _e=0;const ce=Math.min(V,me);for(;_e<ce&&$[_e]===ee[_e];)_e++;if(_e===V&&_e===me)return new N.SemanticTokensEdits([],U.resultId);let Ee=0;const be=ce-_e;for(;Ee<be&&$[V-Ee-1]===ee[me-Ee-1];)Ee++;return new N.SemanticTokensEdits([{start:_e,deleteCount:V-_e-Ee,data:ee.subarray(_e,me-Ee)}],U.resultId)}_send(D,U){if(pe._isSemanticTokens(D)){const $=this._nextResultId++;return this._previousResults.set($,new de(D.resultId,D.data)),(0,a.encodeSemanticTokensDto)({id:$,type:"full",data:D.data})}if(pe._isSemanticTokensEdits(D)){const $=this._nextResultId++;return pe._isSemanticTokens(U)?this._previousResults.set($,new de(U.resultId,U.data)):this._previousResults.set($,new de(D.resultId)),(0,a.encodeSemanticTokensDto)({id:$,type:"delta",deltas:(D.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class re{constructor(D,U){this._documents=D,this._provider=U}async provideDocumentRangeSemanticTokens(D,U,$){const V=this._documents.getDocument(D),ee=await this._provider.provideDocumentRangeSemanticTokens(V,y.Range.to(U),$);return ee?this._send(ee):null}_send(D){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:D.data})}}class le{static supportsResolving(D){return typeof D.resolveCompletionItem=="function"}constructor(D,U,$,V,ee){this._documents=D,this._commands=U,this._provider=$,this._apiDeprecation=V,this._extension=ee,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(D,U,$,V){const ee=this._documents.getDocument(D),me=y.Position.to(U),_e=ee.getWordRangeAtPosition(me)||new N.Range(me,me),ce=_e.with({end:me}),Ee=new g.StopWatch(!0),be=await this._provider.provideCompletionItems(ee,me,V,y.CompletionContext.to($));if(!be||V.isCancellationRequested)return;const $e=Array.isArray(be)?new N.CompletionList(be):be,We=le.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),tt=new m.DisposableStore;this._disposables.set(We,tt);const Ge=[],et={x:We,b:Ge,a:{replace:y.Range.from(_e),insert:y.Range.from(ce)},c:$e.isIncomplete||void 0,d:Ee.elapsed()};for(let it=0;it<$e.items.length;it++){const dt=$e.items[it],Le=this._convertCompletionItem(dt,[We,it],ce,_e);Ge.push(Le)}return et}async resolveCompletionItem(D,U){if(typeof this._provider.resolveCompletionItem!="function")return;const $=this._cache.get(...D);if(!$)return;const V=await this._provider.resolveCompletionItem($,U);if(!!V)return this._convertCompletionItem(V,D)}releaseCompletionItems(D){this._disposables.get(D)?.dispose(),this._disposables.delete(D),this._cache.delete(D)}_convertCompletionItem(D,U,$,V){const ee=this._disposables.get(U[0]);if(!ee)throw Error("DisposableStore is missing...");const me=this._commands.toInternal(D.command,ee),_e={x:U,a:D.label,b:D.kind!==void 0?y.CompletionItemKind.from(D.kind):void 0,m:D.tags&&D.tags.map(y.CompletionItemTag.from),c:D.detail,d:typeof D.documentation>"u"?void 0:y.MarkdownString.fromStrict(D.documentation),e:D.sortText!==D.label?D.sortText:void 0,f:D.filterText!==D.label?D.filterText:void 0,g:D.preselect||void 0,i:D.keepWhitespace?1:0,k:D.commitCharacters?.join(""),l:D.additionalTextEdits&&D.additionalTextEdits.map(y.TextEdit.from),n:me?.$ident,o:me?.id,p:me?.$ident?void 0:me?.arguments};D.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),_e.h=D.textEdit.newText):typeof D.insertText=="string"?_e.h=D.insertText:D.insertText instanceof N.SnippetString&&(_e.h=D.insertText.value,_e.i|=4);let ce;return D.textEdit?ce=D.textEdit.range:D.range&&(ce=D.range),N.Range.isRange(ce)?_e.j=y.Range.from(ce):ce&&(!$?.isEqual(ce.inserting)||!V?.isEqual(ce.replacing))&&(_e.j={insert:y.Range.from(ce.inserting),replace:y.Range.from(ce.replacing)}),_e}}class ae{async provideInlineCompletions(D,U,$,V){}disposeCompletions(D){}handleDidShowCompletionItem(D,U){}handlePartialAccept(D,U,$){}}class se extends ae{constructor(D,U,$,V){super(),this._extension=D,this._documents=U,this._provider=$,this._commands=V,this._references=new Q,this._isAdditionsProposedApiEnabled=(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[S.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[S.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(D,U,$,V){const ee=this._documents.getDocument(D),me=y.Position.to(U),_e=await this._provider.provideInlineCompletionItems(ee,me,{selectedCompletionInfo:$.selectedSuggestionInfo?{range:y.Range.to($.selectedSuggestionInfo.range),text:$.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[$.triggerKind]},V);if(!_e||V.isCancellationRequested)return;const ce=Array.isArray(_e)?_e:_e.items,Ee=this._isAdditionsProposedApiEnabled?Array.isArray(_e)?[]:_e.commands||[]:[];let be;return{pid:this._references.createReferenceId({dispose(){be?.dispose()},items:ce}),items:ce.map((We,tt)=>{let Ge;We.command&&(be||(be=new m.DisposableStore),Ge=this._commands.toInternal(We.command,be));const et=We.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:We.filterText,range:We.range?y.Range.from(We.range):void 0,command:Ge,idx:tt,completeBracketPairs:this._isAdditionsProposedApiEnabled?We.completeBracketPairs:!1}}),commands:Ee.map(We=>(be||(be=new m.DisposableStore),this._commands.toInternal(We,be)))}}disposeCompletions(D){this._references.disposeReferenceId(D)?.dispose()}handleDidShowCompletionItem(D,U){const $=this._references.get(D)?.items[U];$&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem($)}handlePartialAccept(D,U,$){const V=this._references.get(D)?.items[U];V&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(V,$)}}class Q{constructor(){this._references=new Map,this._idPool=1}createReferenceId(D){const U=this._idPool++;return this._references.set(U,D),U}disposeReferenceId(D){const U=this._references.get(D);return this._references.delete(D),U}get(D){return this._references.get(D)}}class K{constructor(D,U){this._documents=D,this._provider=U,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(D,U,$,V){const ee=this._documents.getDocument(D),me=y.Position.to(U),_e=this.reviveContext($),ce=await this._provider.provideSignatureHelp(ee,me,V,_e);if(ce){const Ee=this._cache.add([ce]);return{...y.SignatureHelp.from(ce),id:Ee}}}reviveContext(D){let U;if(D.activeSignatureHelp){const $=y.SignatureHelp.to(D.activeSignatureHelp),V=this._cache.get(D.activeSignatureHelp.id,0);V?(U=V,U.activeSignature=$.activeSignature,U.activeParameter=$.activeParameter):U=$}return{...D,activeSignatureHelp:U}}releaseSignatureHelp(D){this._cache.delete(D)}}class Z{constructor(D,U,$,V,ee){this._documents=D,this._commands=U,this._provider=$,this._logService=V,this._extension=ee,this._cache=new u.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(D,U,$){const V=this._documents.getDocument(D),ee=y.Range.to(U),me=await this._provider.provideInlayHints(V,ee,$);if(!Array.isArray(me)||me.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${U}`);return}if($.isCancellationRequested)return;const _e=this._cache.add(me);this._disposables.set(_e,new m.DisposableStore);const ce={hints:[],cacheId:_e};for(let Ee=0;Ee<me.length;Ee++)this._isValidInlayHint(me[Ee],ee)&&ce.hints.push(this._convertInlayHint(me[Ee],[_e,Ee]));return this._logService.trace(`[InlayHints] ${ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${U}`),ce}async resolveInlayHint(D,U){if(typeof this._provider.resolveInlayHint!="function")return;const $=this._cache.get(...D);if(!$)return;const V=await this._provider.resolveInlayHint($,U);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,D)}releaseHints(D){this._disposables.get(D)?.dispose(),this._disposables.delete(D),this._cache.delete(D)}_isValidInlayHint(D,U){return D.label.length===0||Array.isArray(D.label)&&D.label.every($=>$.value.length===0)?(console.log("INVALID inlay hint, empty label",D),!1):!(U&&!U.contains(D.position))}_convertInlayHint(D,U){const $=this._disposables.get(U[0]);if(!$)throw Error("DisposableStore is missing...");const V={label:"",cacheId:U,tooltip:y.MarkdownString.fromStrict(D.tooltip),position:y.Position.from(D.position),textEdits:D.textEdits&&D.textEdits.map(y.TextEdit.from),kind:D.kind&&y.InlayHintKind.from(D.kind),paddingLeft:D.paddingLeft,paddingRight:D.paddingRight};return typeof D.label=="string"?V.label=D.label:V.label=D.label.map(ee=>{const me={label:ee.value};return me.tooltip=y.MarkdownString.fromStrict(ee.tooltip),N.Location.isLocation(ee.location)&&(me.location=y.location.from(ee.location)),ee.command&&(me.command=this._commands.toInternal(ee.command,$)),me}),V}}class he{constructor(D,U){this._documents=D,this._provider=U,this._cache=new u.Cache("DocumentLink")}async provideLinks(D,U){const $=this._documents.getDocument(D),V=await this._provider.provideDocumentLinks($,U);if(!(!Array.isArray(V)||V.length===0)&&!U.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(he._validateLink).map(y.DocumentLink.from)};{const ee=this._cache.add(V),me={links:[],cacheId:ee};for(let _e=0;_e<V.length;_e++){if(!he._validateLink(V[_e]))continue;const ce=y.DocumentLink.from(V[_e]);ce.cacheId=[ee,_e],me.links.push(ce)}return me}}}static _validateLink(D){return D.target&&D.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(D,U){if(typeof this._provider.resolveDocumentLink!="function")return;const $=this._cache.get(...D);if(!$)return;const V=await this._provider.resolveDocumentLink($,U);if(!(!V||!he._validateLink(V)))return y.DocumentLink.from(V)}releaseLinks(D){this._cache.delete(D)}}class ke{constructor(D,U){this._documents=D,this._provider=U}async provideColors(D,U){const $=this._documents.getDocument(D),V=await this._provider.provideDocumentColors($,U);return Array.isArray(V)?V.map(me=>({color:y.Color.from(me.color),range:y.Range.from(me.range)})):[]}async provideColorPresentations(D,U,$){const V=this._documents.getDocument(D),ee=y.Range.to(U.range),me=y.Color.to(U.color),_e=await this._provider.provideColorPresentations(me,{document:V,range:ee},$);if(!!Array.isArray(_e))return _e.map(y.ColorPresentation.from)}}class Fe{constructor(D,U){this._documents=D,this._provider=U}async provideFoldingRanges(D,U,$){const V=this._documents.getDocument(D),ee=await this._provider.provideFoldingRanges(V,U,$);if(!!Array.isArray(ee))return ee.map(y.FoldingRange.from)}}class je{constructor(D,U,$){this._documents=D,this._provider=U,this._logService=$}async provideSelectionRanges(D,U,$){const V=this._documents.getDocument(D),ee=U.map(y.Position.to),me=await this._provider.provideSelectionRanges(V,ee,$);if(!(0,L.isNonEmptyArray)(me))return[];if(me.length!==ee.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const _e=[];for(let ce=0;ce<ee.length;ce++){const Ee=[];_e.push(Ee);let be=ee[ce],$e=me[ce];for(;;){if(!$e.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(Ee.push(y.SelectionRange.from($e)),!$e.parent)break;be=$e.range,$e=$e.parent}}return _e}}class Te{constructor(D,U){this._documents=D,this._provider=U,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.prepareCallHierarchy(V,ee,$);if(!me)return;const _e=this._idPool.nextId();return this._cache.set(_e,new Map),Array.isArray(me)?me.map(ce=>this._cacheAndConvertItem(_e,ce)):[this._cacheAndConvertItem(_e,me)]}async provideCallsTo(D,U,$){const V=this._itemFromCache(D,U);if(!V)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyIncomingCalls(V,$);if(!!ee)return ee.map(me=>({from:this._cacheAndConvertItem(D,me.from),fromRanges:me.fromRanges.map(_e=>y.Range.from(_e))}))}async provideCallsFrom(D,U,$){const V=this._itemFromCache(D,U);if(!V)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyOutgoingCalls(V,$);if(!!ee)return ee.map(me=>({to:this._cacheAndConvertItem(D,me.to),fromRanges:me.fromRanges.map(_e=>y.Range.from(_e))}))}releaseSession(D){this._cache.delete(D)}_cacheAndConvertItem(D,U){const $=this._cache.get(D),V=y.CallHierarchyItem.from(U,D,$.size.toString(36));return $.set(V._itemId,U),V}_itemFromCache(D,U){return this._cache.get(D)?.get(U)}}class Se{constructor(D,U){this._documents=D,this._provider=U,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(D,U,$){const V=this._documents.getDocument(D),ee=y.Position.to(U),me=await this._provider.prepareTypeHierarchy(V,ee,$);if(!me)return;const _e=this._idPool.nextId();return this._cache.set(_e,new Map),Array.isArray(me)?me.map(ce=>this._cacheAndConvertItem(_e,ce)):[this._cacheAndConvertItem(_e,me)]}async provideSupertypes(D,U,$){const V=this._itemFromCache(D,U);if(!V)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySupertypes(V,$);if(!!ee)return ee.map(me=>this._cacheAndConvertItem(D,me))}async provideSubtypes(D,U,$){const V=this._itemFromCache(D,U);if(!V)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySubtypes(V,$);if(!!ee)return ee.map(me=>this._cacheAndConvertItem(D,me))}releaseSession(D){this._cache.delete(D)}_cacheAndConvertItem(D,U){const $=this._cache.get(D),V=y.TypeHierarchyItem.from(U,D,$.size.toString(36));return $.set(V._itemId,U),V}_itemFromCache(D,U){return this._cache.get(D)?.get(U)}}class De{constructor(D,U,$,V){this._proxy=D,this._documents=U,this._provider=$,this._handle=V}async provideDocumentOnDropEdits(D,U,$,V,ee){const me=this._documents.getDocument(U),_e=y.Position.to($),ce=y.DataTransfer.toDataTransfer(V,async be=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,D,be)).buffer),Ee=await this._provider.provideDocumentDropEdits(me,_e,ce,ee);if(!!Ee)return{insertText:typeof Ee.insertText=="string"?Ee.insertText:{snippet:Ee.insertText.value},additionalEdit:Ee.additionalEdit?y.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}}class oe{constructor(D,U){this.adapter=D,this.extension=U}}class ue{constructor(D,U,$,V,ee,me,_e,ce){this._uriTransformer=U,this._documents=$,this._commands=V,this._diagnostics=ee,this._logService=me,this._apiDeprecation=_e,this._extensionTelemetry=ce,this._adapter=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(D){return y.DocumentSelector.from(D,this._uriTransformer)}_createDisposable(D){return new N.Disposable(()=>{this._adapter.delete(D),this._proxy.$unregister(D)})}_nextHandle(){return ue._handlePool++}async _withAdapter(D,U,$,V,ee,me=!1){const _e=this._adapter.get(D);if(!_e||!(_e.adapter instanceof U))return V;const ce=Date.now();me||this._logService.trace(`[${_e.extension.identifier.value}] INVOKE provider '${$.toString().replace(/[\r\n]/g,"")}'`);const Ee=$(_e.adapter,_e.extension);return Promise.resolve(Ee).catch(be=>{(0,b.isCancellationError)(be)||(this._logService.error(`[${_e.extension.identifier.value}] provider FAILED`),this._logService.error(be),this._extensionTelemetry.onExtensionError(_e.extension.identifier,be))}).finally(()=>{me||this._logService.trace(`[${_e.extension.identifier.value}] provider DONE after ${Date.now()-ce}ms`)}),E.CancellationToken.isCancellationToken(ee)?(0,R.raceCancellationError)(Ee,ee):Ee}_addNewAdapter(D,U){const $=this._nextHandle();return this._adapter.set($,new oe(D,U)),$}static _extLabel(D){return D.displayName||D.name}registerDocumentSymbolProvider(D,U,$,V){const ee=this._addNewAdapter(new t(this._documents,$),D),me=V&&V.label||ue._extLabel(D);return this._proxy.$registerDocumentSymbolProvider(ee,this._transformDocumentSelector(U),me),this._createDisposable(ee)}$provideDocumentSymbols(D,U,$){return this._withAdapter(D,t,V=>V.provideDocumentSymbols(n.URI.revive(U),$),void 0,$)}registerCodeLensProvider(D,U,$){const V=this._nextHandle(),ee=typeof $.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new oe(new h(this._documents,this._commands.converter,$),D)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(U),ee);let me=this._createDisposable(V);if(ee!==void 0){const _e=$.onDidChangeCodeLenses(ce=>this._proxy.$emitCodeLensEvent(ee));me=N.Disposable.from(me,_e)}return me}$provideCodeLenses(D,U,$){return this._withAdapter(D,h,V=>V.provideCodeLenses(n.URI.revive(U),$),void 0,$)}$resolveCodeLens(D,U,$){return this._withAdapter(D,h,V=>V.resolveCodeLens(U,$),void 0,void 0)}$releaseCodeLenses(D,U){this._withAdapter(D,h,$=>Promise.resolve($.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(D,U,$){const V=this._addNewAdapter(new l(this._documents,$),D);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideDefinition(D,U,$,V){return this._withAdapter(D,l,ee=>ee.provideDefinition(n.URI.revive(U),$,V),[],V)}registerDeclarationProvider(D,U,$){const V=this._addNewAdapter(new i(this._documents,$),D);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideDeclaration(D,U,$,V){return this._withAdapter(D,i,ee=>ee.provideDeclaration(n.URI.revive(U),$,V),[],V)}registerImplementationProvider(D,U,$){const V=this._addNewAdapter(new p(this._documents,$),D);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideImplementation(D,U,$,V){return this._withAdapter(D,p,ee=>ee.provideImplementation(n.URI.revive(U),$,V),[],V)}registerTypeDefinitionProvider(D,U,$){const V=this._addNewAdapter(new c(this._documents,$),D);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideTypeDefinition(D,U,$,V){return this._withAdapter(D,c,ee=>ee.provideTypeDefinition(n.URI.revive(U),$,V),[],V)}registerHoverProvider(D,U,$,V){const ee=this._addNewAdapter(new s(this._documents,$),D);return this._proxy.$registerHoverProvider(ee,this._transformDocumentSelector(U)),this._createDisposable(ee)}$provideHover(D,U,$,V){return this._withAdapter(D,s,ee=>ee.provideHover(n.URI.revive(U),$,V),void 0,V)}registerEvaluatableExpressionProvider(D,U,$,V){const ee=this._addNewAdapter(new d(this._documents,$),D);return this._proxy.$registerEvaluatableExpressionProvider(ee,this._transformDocumentSelector(U)),this._createDisposable(ee)}$provideEvaluatableExpression(D,U,$,V){return this._withAdapter(D,d,ee=>ee.provideEvaluatableExpression(n.URI.revive(U),$,V),void 0,V)}registerInlineValuesProvider(D,U,$,V){const ee=typeof $.onDidChangeInlineValues=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new k(this._documents,$),D);this._proxy.$registerInlineValuesProvider(me,this._transformDocumentSelector(U),ee);let _e=this._createDisposable(me);if(ee!==void 0){const ce=$.onDidChangeInlineValues(Ee=>this._proxy.$emitInlineValuesEvent(ee));_e=N.Disposable.from(_e,ce)}return _e}$provideInlineValues(D,U,$,V,ee){return this._withAdapter(D,k,me=>me.provideInlineValues(n.URI.revive(U),$,V,ee),void 0,ee)}registerDocumentHighlightProvider(D,U,$){const V=this._addNewAdapter(new A(this._documents,$),D);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideDocumentHighlights(D,U,$,V){return this._withAdapter(D,A,ee=>ee.provideDocumentHighlights(n.URI.revive(U),$,V),void 0,V)}registerLinkedEditingRangeProvider(D,U,$){const V=this._addNewAdapter(new W(this._documents,$),D);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideLinkedEditingRanges(D,U,$,V){return this._withAdapter(D,W,async ee=>{const me=await ee.provideLinkedEditingRanges(n.URI.revive(U),$,V);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?ue._serializeRegExp(me.wordPattern):void 0}},void 0,V)}registerReferenceProvider(D,U,$){const V=this._addNewAdapter(new J(this._documents,$),D);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideReferences(D,U,$,V,ee){return this._withAdapter(D,J,me=>me.provideReferences(n.URI.revive(U),$,V,ee),void 0,ee)}registerCodeActionProvider(D,U,$,V){const ee=new m.DisposableStore,me=this._addNewAdapter(new j(this._documents,this._commands.converter,this._diagnostics,$,this._logService,D,this._apiDeprecation),D);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(U),{providedKinds:V?.providedCodeActionKinds?.map(_e=>_e.value),documentation:V?.documentation?.map(_e=>({kind:_e.kind.value,command:this._commands.converter.toInternal(_e.command,ee)}))},ue._extLabel(D),Boolean($.resolveCodeAction)),ee.add(this._createDisposable(me)),ee}$provideCodeActions(D,U,$,V,ee){return this._withAdapter(D,j,me=>me.provideCodeActions(n.URI.revive(U),$,V,ee),void 0,ee)}$resolveCodeAction(D,U,$){return this._withAdapter(D,j,V=>V.resolveCodeAction(U,$),void 0,void 0)}$releaseCodeActions(D,U){this._withAdapter(D,j,$=>Promise.resolve($.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(D,U,$){const V=this._addNewAdapter(new B(this._documents,$),D);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(U),D.identifier,D.displayName||D.name),this._createDisposable(V)}$provideDocumentFormattingEdits(D,U,$,V){return this._withAdapter(D,B,ee=>ee.provideDocumentFormattingEdits(n.URI.revive(U),$,V),void 0,V)}registerDocumentRangeFormattingEditProvider(D,U,$){const V=this._addNewAdapter(new T(this._documents,$),D);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(U),D.identifier,D.displayName||D.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(D,U,$,V,ee){return this._withAdapter(D,T,me=>me.provideDocumentRangeFormattingEdits(n.URI.revive(U),$,V,ee),void 0,ee)}registerOnTypeFormattingEditProvider(D,U,$,V){const ee=this._addNewAdapter(new F(this._documents,$),D);return this._proxy.$registerOnTypeFormattingSupport(ee,this._transformDocumentSelector(U),V,D.identifier),this._createDisposable(ee)}$provideOnTypeFormattingEdits(D,U,$,V,ee,me){return this._withAdapter(D,F,_e=>_e.provideOnTypeFormattingEdits(n.URI.revive(U),$,V,ee,me),void 0,me)}registerWorkspaceSymbolProvider(D,U){const $=this._addNewAdapter(new z(U,this._logService),D);return this._proxy.$registerNavigateTypeSupport($,typeof U.resolveWorkspaceSymbol=="function"),this._createDisposable($)}$provideWorkspaceSymbols(D,U,$){return this._withAdapter(D,z,V=>V.provideWorkspaceSymbols(U,$),{symbols:[]},$)}$resolveWorkspaceSymbol(D,U,$){return this._withAdapter(D,z,V=>V.resolveWorkspaceSymbol(U,$),void 0,void 0)}$releaseWorkspaceSymbols(D,U){this._withAdapter(D,z,$=>$.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(D,U,$){const V=this._addNewAdapter(new H(this._documents,$,this._logService),D);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(U),H.supportsResolving($)),this._createDisposable(V)}$provideRenameEdits(D,U,$,V,ee){return this._withAdapter(D,H,me=>me.provideRenameEdits(n.URI.revive(U),$,V,ee),void 0,ee)}$resolveRenameLocation(D,U,$,V){return this._withAdapter(D,H,ee=>ee.resolveRenameLocation(n.URI.revive(U),$,V),void 0,V)}registerDocumentSemanticTokensProvider(D,U,$,V){const ee=this._addNewAdapter(new pe(this._documents,$),D),me=typeof $.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ee,this._transformDocumentSelector(U),V,me);let _e=this._createDisposable(ee);if(me){const ce=$.onDidChangeSemanticTokens(Ee=>this._proxy.$emitDocumentSemanticTokensEvent(me));_e=N.Disposable.from(_e,ce)}return _e}$provideDocumentSemanticTokens(D,U,$,V){return this._withAdapter(D,pe,ee=>ee.provideDocumentSemanticTokens(n.URI.revive(U),$,V),null,V)}$releaseDocumentSemanticTokens(D,U){this._withAdapter(D,pe,$=>$.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(D,U,$,V){const ee=this._addNewAdapter(new re(this._documents,$),D);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ee,this._transformDocumentSelector(U),V),this._createDisposable(ee)}$provideDocumentRangeSemanticTokens(D,U,$,V){return this._withAdapter(D,re,ee=>ee.provideDocumentRangeSemanticTokens(n.URI.revive(U),$,V),null,V)}registerCompletionItemProvider(D,U,$,V){const ee=this._addNewAdapter(new le(this._documents,this._commands.converter,$,this._apiDeprecation,D),D);return this._proxy.$registerCompletionsProvider(ee,this._transformDocumentSelector(U),V,le.supportsResolving($),`${D.identifier.value}(${V.join("")})`),this._createDisposable(ee)}$provideCompletionItems(D,U,$,V,ee){return this._withAdapter(D,le,me=>me.provideCompletionItems(n.URI.revive(U),$,V,ee),void 0,ee)}$resolveCompletionItem(D,U,$){return this._withAdapter(D,le,V=>V.resolveCompletionItem(U,$),void 0,$)}$releaseCompletionItems(D,U){this._withAdapter(D,le,$=>$.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(D,U,$){const V=new se(D,this._documents,$,this._commands.converter),ee=this._addNewAdapter(V,D);return this._proxy.$registerInlineCompletionsSupport(ee,this._transformDocumentSelector(U),V.supportsHandleEvents),this._createDisposable(ee)}$provideInlineCompletions(D,U,$,V,ee){return this._withAdapter(D,ae,me=>me.provideInlineCompletions(n.URI.revive(U),$,V,ee),void 0,ee)}$handleInlineCompletionDidShow(D,U,$){this._withAdapter(D,ae,async V=>{V.handleDidShowCompletionItem(U,$)},void 0,void 0)}$handleInlineCompletionPartialAccept(D,U,$,V){this._withAdapter(D,ae,async ee=>{ee.handlePartialAccept(U,$,V)},void 0,void 0)}$freeInlineCompletionsList(D,U){this._withAdapter(D,ae,async $=>{$.disposeCompletions(U)},void 0,void 0)}registerSignatureHelpProvider(D,U,$,V){const ee=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,me=this._addNewAdapter(new K(this._documents,$),D);return this._proxy.$registerSignatureHelpProvider(me,this._transformDocumentSelector(U),ee),this._createDisposable(me)}$provideSignatureHelp(D,U,$,V,ee){return this._withAdapter(D,K,me=>me.provideSignatureHelp(n.URI.revive(U),$,V,ee),void 0,ee)}$releaseSignatureHelp(D,U){this._withAdapter(D,K,$=>$.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(D,U,$){const V=typeof $.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new Z(this._documents,this._commands.converter,$,this._logService,D),D);this._proxy.$registerInlayHintsProvider(ee,this._transformDocumentSelector(U),typeof $.resolveInlayHint=="function",V,ue._extLabel(D));let me=this._createDisposable(ee);if(V!==void 0){const _e=$.onDidChangeInlayHints(ce=>this._proxy.$emitInlayHintsEvent(V));me=N.Disposable.from(me,_e)}return me}$provideInlayHints(D,U,$,V){return this._withAdapter(D,Z,ee=>ee.provideInlayHints(n.URI.revive(U),$,V),void 0,V)}$resolveInlayHint(D,U,$){return this._withAdapter(D,Z,V=>V.resolveInlayHint(U,$),void 0,$)}$releaseInlayHints(D,U){this._withAdapter(D,Z,$=>$.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(D,U,$){const V=this._addNewAdapter(new he(this._documents,$),D);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(U),typeof $.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(D,U,$){return this._withAdapter(D,he,V=>V.provideLinks(n.URI.revive(U),$),void 0,$,U.scheme==="output")}$resolveDocumentLink(D,U,$){return this._withAdapter(D,he,V=>V.resolveLink(U,$),void 0,void 0,!0)}$releaseDocumentLinks(D,U){this._withAdapter(D,he,$=>$.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(D,U,$){const V=this._addNewAdapter(new ke(this._documents,$),D);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideDocumentColors(D,U,$){return this._withAdapter(D,ke,V=>V.provideColors(n.URI.revive(U),$),[],$)}$provideColorPresentations(D,U,$,V){return this._withAdapter(D,ke,ee=>ee.provideColorPresentations(n.URI.revive(U),$,V),void 0,V)}registerFoldingRangeProvider(D,U,$){const V=this._nextHandle(),ee=typeof $.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new oe(new Fe(this._documents,$),D)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(U),D.identifier,ee);let me=this._createDisposable(V);if(ee!==void 0){const _e=$.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ee));me=N.Disposable.from(me,_e)}return me}$provideFoldingRanges(D,U,$,V){return this._withAdapter(D,Fe,ee=>ee.provideFoldingRanges(n.URI.revive(U),$,V),void 0,V)}registerSelectionRangeProvider(D,U,$){const V=this._addNewAdapter(new je(this._documents,$,this._logService),D);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideSelectionRanges(D,U,$,V){return this._withAdapter(D,je,ee=>ee.provideSelectionRanges(n.URI.revive(U),$,V),[],V)}registerCallHierarchyProvider(D,U,$){const V=this._addNewAdapter(new Te(this._documents,$),D);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$prepareCallHierarchy(D,U,$,V){return this._withAdapter(D,Te,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(U),$,V)),void 0,V)}$provideCallHierarchyIncomingCalls(D,U,$,V){return this._withAdapter(D,Te,ee=>ee.provideCallsTo(U,$,V),void 0,V)}$provideCallHierarchyOutgoingCalls(D,U,$,V){return this._withAdapter(D,Te,ee=>ee.provideCallsFrom(U,$,V),void 0,V)}$releaseCallHierarchy(D,U){this._withAdapter(D,Te,$=>Promise.resolve($.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(D,U,$){const V=this._addNewAdapter(new Se(this._documents,$),D);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$prepareTypeHierarchy(D,U,$,V){return this._withAdapter(D,Se,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(U),$,V)),void 0,V)}$provideTypeHierarchySupertypes(D,U,$,V){return this._withAdapter(D,Se,ee=>ee.provideSupertypes(U,$,V),void 0,V)}$provideTypeHierarchySubtypes(D,U,$,V){return this._withAdapter(D,Se,ee=>ee.provideSubtypes(U,$,V),void 0,V)}$releaseTypeHierarchy(D,U){this._withAdapter(D,Se,$=>Promise.resolve($.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(D,U,$){const V=this._nextHandle();return this._adapter.set(V,new oe(new De(this._proxy,this._documents,$,V),D)),this._proxy.$registerDocumentOnDropEditProvider(V,this._transformDocumentSelector(U)),this._createDisposable(V)}$provideDocumentOnDropEdits(D,U,$,V,ee,me){return this._withAdapter(D,De,_e=>Promise.resolve(_e.provideDocumentOnDropEdits(U,n.URI.revive($),V,ee,me)),void 0,void 0)}registerDocumentPasteEditProvider(D,U,$,V){const ee=this._nextHandle();return this._adapter.set(ee,new oe(new O(this._proxy,this._documents,$,ee),D)),this._proxy.$registerPasteEditProvider(ee,this._transformDocumentSelector(U),!!$.prepareDocumentPaste,V.pasteMimeTypes),this._createDisposable(ee)}$prepareDocumentPaste(D,U,$,V,ee){return this._withAdapter(D,O,me=>me.prepareDocumentPaste(n.URI.revive(U),$,V,ee),void 0,ee)}$providePasteEdits(D,U,$,V,ee,me){return this._withAdapter(D,O,_e=>_e.providePasteEdits(U,n.URI.revive($),V,ee,me),void 0,me)}static _serializeRegExp(D){return{pattern:D.source,flags:(0,_.regExpFlags)(D)}}static _serializeIndentationRule(D){return{decreaseIndentPattern:ue._serializeRegExp(D.decreaseIndentPattern),increaseIndentPattern:ue._serializeRegExp(D.increaseIndentPattern),indentNextLinePattern:D.indentNextLinePattern?ue._serializeRegExp(D.indentNextLinePattern):void 0,unIndentedLinePattern:D.unIndentedLinePattern?ue._serializeRegExp(D.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(D){return{beforeText:ue._serializeRegExp(D.beforeText),afterText:D.afterText?ue._serializeRegExp(D.afterText):void 0,previousLineText:D.previousLineText?ue._serializeRegExp(D.previousLineText):void 0,action:D.action}}static _serializeOnEnterRules(D){return D.map(ue._serializeOnEnterRule)}setLanguageConfiguration(D,U,$){const{wordPattern:V}=$;if(V&&(0,_.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(U,V):this._documents.setWordDefinitionFor(U,void 0),$.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",D,"Do not use."),$.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",D,"Do not use.");const ee=this._nextHandle(),me={comments:$.comments,brackets:$.brackets,wordPattern:$.wordPattern?ue._serializeRegExp($.wordPattern):void 0,indentationRules:$.indentationRules?ue._serializeIndentationRule($.indentationRules):void 0,onEnterRules:$.onEnterRules?ue._serializeOnEnterRules($.onEnterRules):void 0,__electricCharacterSupport:$.__electricCharacterSupport,__characterPairSupport:$.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ee,U,me),this._createDisposable(ee)}$setWordDefinitions(D){for(const U of D)this._documents.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}ue._handlePool=0,e.ExtHostLanguageFeatures=ue}),define(Ce[219],Ie([1,0,5,8,7,29,17,6]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(L,w,f,E){this._documents=w,this._commands=f,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,w){await this._proxy.$changeLanguage(L,w);const f=this._documents.getDocumentData(L);if(!f)throw new Error(`document '${L.toString()}' NOT found`);return f.document}async tokenAtPosition(L,w){const f=L.version,E=C.Position.from(w),m=await this._proxy.$tokensAtPosition(L.uri,E),a={type:y.StandardTokenType.Other,range:L.getWordRangeAtPosition(w)??new y.Range(w.line,w.character,w.line,w.character)};if(!m)return a;const o={range:C.Range.to(m.range),type:C.TokenType.to(m.type)};return!o.range.contains(w)||f!==L.version?a:o}createLanguageStatusItem(L,w,f){const E=this._handlePool++,m=this._proxy,a=this._ids,o=`${L.identifier.value}/${w}`;if(a.has(o))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);a.add(o);const u={selector:f,id:w,name:L.displayName??L.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const b=new P.DisposableStore,R=()=>{g?.dispose(),g=(0,S.disposableTimeout)(()=>{b.clear(),this._proxy.$setLanguageStatus(E,{id:o,name:u.name??L.displayName??L.name,source:L.displayName??L.name,selector:C.DocumentSelector.from(u.selector,this._uriTransformer),label:u.text,detail:u.detail??"",severity:u.severity===y.LanguageStatusSeverity.Error?N.default.Error:u.severity===y.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:u.command&&this._commands.toInternal(u.command,b),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},v={dispose(){b.dispose(),g?.dispose(),m.$removeLanguageStatus(E),a.delete(o)},get id(){return u.id},get name(){return u.name},set name(t){u.name=t,R()},get selector(){return u.selector},set selector(t){u.selector=t,R()},get text(){return u.text},set text(t){u.text=t,R()},get detail(){return u.detail},set detail(t){u.detail=t,R()},get severity(){return u.severity},set severity(t){u.severity=t,R()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(t){u.accessibilityInformation=t,R()},get command(){return u.command},set command(t){u.command=t,R()},get busy(){return u.busy},set busy(t){u.busy=t,R()}};return R(),v}}e.ExtHostLanguages=_}),define(Ce[78],Ie([1,0,21,10,2,3,11,5,26,18]),function(te,e,n,C,y,N,S,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(f,E,m){this.logService=m,this.bundleCache=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadLocalization),this.currentLanguage=f.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===n.LANGUAGE_DEFAULT}getMessage(f,E){const{message:m,args:a,comment:o}=E;if(this.isDefaultLanguage)return(0,C.format2)(m,a??{});let u=m;o&&o.length>0&&(u+=`/${Array.isArray(o)?o.join(""):o}`);const g=this.bundleCache.get(f)?.contents[u];return g||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,C.format2)(g??m,a??{})}getBundle(f){return this.bundleCache.get(f)?.contents}getBundleUri(f){return this.bundleCache.get(f)?.uri}async initializeLocalizedMessages(f){if(this.isDefaultLanguage||!f.l10n&&!f.isBuiltin||this.bundleCache.has(f.identifier.value))return;let E;const m=await this.getBundleLocation(f);if(!m){this.logService.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const a=await this._proxy.$fetchBundleContents(m),o=JSON.parse(a);E=f.isBuiltin?o.contents?.bundle:o}catch(a){this.logService.error(`Failed to load translations for ${f.identifier.value} from ${m}: ${a.message}`);return}E&&this.bundleCache.set(f.identifier.value,{contents:E,uri:m})}async getBundleLocation(f){if(f.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(f.identifier.value);return y.URI.revive(E)}return f.l10n?y.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};L=Ve([He(0,_.IExtHostInitDataService),He(1,I.IExtHostRpcService),He(2,S.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(Ce[220],Ie([1,0,11,5,26,18,2,65]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let _=class extends n.AbstractLoggerService{constructor(w,f){super(f.logLevel,f.loggers.map(E=>(0,P.revive)(E))),this._proxy=w.getProxy(C.MainContext.MainThreadLogger)}$setLogLevel(w,f){f?this.setLogLevel(S.URI.revive(f),w):this.setLogLevel(w)}setVisibility(w,f){super.setVisibility(w,f),this._proxy.$setVisibility(w,f)}doCreateLogger(w,f,E){return new I(this._proxy,w,f,E)}};_=Ve([He(0,N.IExtHostRpcService),He(1,y.IExtHostInitDataService)],_),e.ExtHostLoggerService=_;class I extends n.AbstractMessageLogger{constructor(w,f,E,m){super(m?.logLevel==="always"),this.proxy=w,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(E),this.proxy.$createLogger(f,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,f){const E=[[w,f]];this.isLoggerCreated?this.doLog(E):this.buffer.push(...E)}doLog(w){this.proxy.$log(this.file,w)}}}),define(Ce[221],Ie([1,0,5,11,27]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(P){return P&&P.title}let S=class{constructor(_,I){this._logService=I,this._proxy=_.getProxy(n.MainContext.MainThreadMessageService)}showMessage(_,I,L,w,f){const E={source:{identifier:_.identifier,label:_.displayName||_.name}};let m;typeof w=="string"||N(w)?m=[w,...f]:(E.modal=w?.modal,E.useCustom=w?.useCustom,E.detail=w?.detail,m=f),E.useCustom&&(0,y.checkProposedApiEnabled)(_,"resolvers");const a=[];for(let o=0;o<m.length;o++){const u=m[o];if(typeof u=="string")a.push({title:u,handle:o,isCloseAffordance:!1});else if(typeof u=="object"){const{title:g,isCloseAffordance:b}=u;a.push({title:g,isCloseAffordance:!!b,handle:o})}else this._logService.warn("Invalid message item:",u)}return this._proxy.$showMessage(I,L,E,a).then(o=>{if(typeof o=="number")return m[o]})}};S=Ve([He(1,C.ILogService)],S),e.ExtHostMessageService=S}),define(Ce[222],Ie([1,0,23,4,6,28,10,9,2,54,5,37,8,7,46,196,100]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}constructor(b,R,v,t){this._textDocumentsAndEditors=v,this._textDocuments=t,this._notebookStatusBarItemProviders=new Map,this._documents=new N.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=b.getProxy(L.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(L.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(L.MainContext.MainThreadNotebookEditors),this._commandsConverter=R.converter,R.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===13){const r=h.notebookEditor?.notebookUri,l=h.cell.handle,p=this._documents.get(r)?.getCell(l);if(p)return p.apiCell}if(h&&h.$mid===14){const r=h.uri,l=this._documents.get(r);if(l)return l.apiNotebook}return h}}),u._registerApiCommands(R)}getEditorById(b){const R=this._editors.get(b);if(!R)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return R}getIdByEditor(b){for(const[R,v]of this._editors)if(v.apiEditor===b)return R}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,R){const v=this._documents.get(b);if(!v&&!R)throw new Error(`NO notebook document for '${b}'`);return v}static _convertNotebookRegistrationData(b,R){if(!R)return;const v=R.filenamePattern.map(t=>f.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(R.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${R.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:R.displayName,filenamePattern:v,exclusive:R.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,R,v){const t=u._notebookStatusBarItemProviderHandlePool++,h=typeof v.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,h,R);let r;return h!==void 0&&(r=v.onDidChangeCellStatusBarItems(l=>this._notebookProxy.$emitCellStatusBarEvent(h))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,h),r?.dispose()})}async createNotebookDocument(b){const R=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&f.NotebookData.from(b.content)});return _.URI.revive(R)}async openNotebookDocument(b){const R=this._documents.get(b);if(R)return R.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(b),t=this._documents.get(_.URI.revive(v));return(0,P.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(b,R){_.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let v;typeof R=="object"?v={position:f.ViewColumn.from(R.viewColumn),preserveFocus:R.preserveFocus,selections:R.selections&&R.selections.map(f.NotebookRange.from),pinned:typeof R.preview=="boolean"?!R.preview:void 0}:v={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,v),h=t&&this._editors.get(t)?.apiEditor;if(h)return h;throw t?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,R,v,t){const h=this._notebookStatusBarItemProviders.get(b),r=_.URI.revive(R),l=this._documents.get(r);if(!l||!h)return;const i=l.getCellFromIndex(v);if(!i)return;const p=await h.provideCellStatusBarItems(i.apiCell,t);if(!p)return;const c=new y.DisposableStore,s=this._statusBarCache.add([c]),k=(Array.isArray(p)?p:[p]).map(A=>f.NotebookStatusBarItem.from(A,this._commandsConverter,c));return{cacheId:s,items:k}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,R,v,t,h){if((0,S.isFalsyOrWhitespace)(R))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,v),this._notebookProxy.$registerNotebookSerializer(r,{id:b.identifier,location:b.extensionLocation},R,f.NotebookDocumentContentOptions.from(t),u._convertNotebookRegistrationData(b,h)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(b,R,v){const t=this._notebookSerializer.get(b);if(!t)throw new Error("NO serializer found");const h=await t.deserializeNotebook(R.buffer,v);return new m.SerializableObjectWithBuffers(f.NotebookData.from(h))}async $notebookToData(b,R,v){const t=this._notebookSerializer.get(b);if(!t)throw new Error("NO serializer found");const h=await t.serializeNotebook(f.NotebookData.to(R.value),v);return n.VSBuffer.wrap(h)}_createExtHostEditor(b,R,v){if(this._editors.has(R))throw new Error(`editor with id ALREADY EXSIST: ${R}`);const t=new o.ExtHostNotebookEditor(R,this._notebookEditorsProxy,b,v.visibleRanges.map(f.NotebookRange.to),v.selections.map(f.NotebookRange.to),typeof v.viewColumn=="number"?f.ViewColumn.to(v.viewColumn):void 0);this._editors.set(R,t)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const v of b.value.removedDocuments){const t=_.URI.revive(v),h=this._documents.get(t);h&&(h.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(h.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(b.value.addedDocuments){const v=[];for(const t of b.value.addedDocuments){const h=_.URI.revive(t.uri);if(this._documents.has(h))throw new Error(`adding EXISTING notebook ${h} `);const r=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,h,t);v.push(...t.cells.map(l=>a.ExtHostCell.asModelAddData(r.apiNotebook,l))),this._documents.get(h)?.dispose(),this._documents.set(h,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(b.value.addedEditors)for(const v of b.value.addedEditors){if(this._editors.has(v.id))return;const t=_.URI.revive(v.documentUri),h=this._documents.get(t);h&&this._createExtHostEditor(h,v.id,v)}const R=[];if(b.value.removedEditors)for(const v of b.value.removedEditors){const t=this._editors.get(v);t&&(this._editors.delete(v),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),R.push(t))}if(b.value.visibleEditors){this._visibleNotebookEditors=b.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const v=new Set;this._visibleNotebookEditors.forEach(t=>v.add(t.id));for(const t of this._editors.values()){const h=v.has(t.id);t._acceptVisibility(h)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this._activeNotebookEditor=void 0:b.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(b){const R=w.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[R,new w.ApiCommandArgument("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>n.VSBuffer.wrap(h))],new w.ApiCommandResult("Notebook Data",h=>f.NotebookData.to(h.value))),t=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[R,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new m.SerializableObjectWithBuffers(f.NotebookData.from(h)))],new w.ApiCommandResult("Bytes",h=>h.buffer));b.registerApiCommand(v),b.registerApiCommand(t)}}u._notebookStatusBarItemProviderHandlePool=0,e.ExtHostNotebookController=u}),define(Ce[223],Ie([1,0,16,17,20,4,6,28,2,25,11,54,5,37,8,7,72,186,27,46]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let R=class{constructor(i,p,c,s,d){this._initData=p,this._extHostNotebook=c,this._commands=s,this._logService=d,this._activeExecutions=new P.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new w.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(f.MainContext.MainThreadNotebookKernels);const k=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const W=this._extHostNotebook.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:W}}else if(A&&"notebookEditor"in A){const W=this._extHostNotebook.getIdByEditor(A.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return A})],E.ApiCommandResult.Void);this._commands.registerApiCommand(k)}createNotebookController(i,p,c,s,d,k){for(const ae of this._kernelData.values())if(ae.controller.id===p&&I.ExtensionIdentifier.equals(i.identifier,ae.extensionId))throw new Error(`notebook controller with id '${p}' ALREADY exist`);const A=this._handlePool++,W=this;this._logService.trace(`NotebookController[${A}], CREATED by ${i.identifier.value}, ${p}`);const J=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${i.identifier}'`);let j=!1;const O=new S.DisposableStore,B=new N.Emitter,T=new N.Emitter,F={id:r(i.identifier,p),notebookType:c,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:s||i.identifier.value,preloads:k?k.map(m.NotebookRendererScript.from):[]};let z=d??J,H;this._proxy.$addKernel(A,F).catch(ae=>{console.log(ae),j=!0});let de=0;const pe=()=>{if(j)return;const ae=++de;Promise.resolve().then(()=>{ae===de&&this._proxy.$updateKernel(A,F)})},re=new P.ResourceMap,le={get id(){return p},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return F.label},set label(ae){F.label=ae??i.displayName??i.name,pe()},get detail(){return F.detail??""},set detail(ae){F.detail=ae,pe()},get description(){return F.description??""},set description(ae){F.description=ae,pe()},get kind(){return(0,g.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind??""},set kind(ae){(0,g.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind=ae,pe()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ae){F.supportedLanguages=ae,pe()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){F.supportsExecutionOrder=ae,pe()},get rendererScripts(){return F.preloads?F.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ae){z=ae??J},get interruptHandler(){return H},set interruptHandler(ae){H=ae,F.supportsInterrupt=Boolean(ae),pe()},createNotebookCellExecution(ae){if(j)throw new Error("notebook controller is DISPOSED");if(!re.has(ae.notebook.uri))throw W._logService.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return W._createNotebookCellExecution(ae,r(i.identifier,this.id))},dispose:()=>{j||(this._logService.trace(`NotebookController[${A}], DISPOSED`),j=!0,this._kernelData.delete(A),O.dispose(),B.dispose(),T.dispose(),this._proxy.$removeKernel(A))},updateNotebookAffinity(ae,se){se===a.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(i,"notebookControllerAffinityHidden"),W._proxy.$updateNotebookPriority(A,ae.uri,se)},onDidReceiveMessage:T.event,postMessage(ae,se){return(0,g.checkProposedApiEnabled)(i,"notebookMessaging"),W._proxy.$postMessage(A,se&&W._extHostNotebook.getIdByEditor(se),ae)},asWebviewUri(ae){return(0,g.checkProposedApiEnabled)(i,"notebookMessaging"),(0,o.asWebviewUri)(ae,W._initData.remote)}};return this._kernelData.set(A,{extensionId:i.identifier,controller:le,onDidReceiveMessage:T,onDidChangeSelection:B,associatedNotebooks:re}),le}getIdByController(i){for(const[p,c]of this._kernelData)if(c.controller===i)return r(c.extensionId,i.id);return null}createNotebookControllerDetectionTask(i,p){const c=this._kernelDetectionTaskHandlePool++,s=this;this._logService.trace(`NotebookControllerDetectionTask[${c}], CREATED by ${i.identifier.value}`),this._proxy.$addKernelDetectionTask(c,p);const d={dispose:()=>{this._kernelDetectionTask.delete(c),s._proxy.$removeKernelDetectionTask(c)}};return this._kernelDetectionTask.set(c,d),d}registerKernelSourceActionProvider(i,p,c){const s=this._kernelSourceActionProviderHandlePool++,d=typeof c.onDidChangeNotebookKernelSourceActions=="function"?s:void 0,k=this;this._kernelSourceActionProviders.set(s,c),this._logService.trace(`NotebookKernelSourceActionProvider[${s}], CREATED by ${i.identifier.value}`),this._proxy.$addKernelSourceActionProvider(s,s,p);let A;return d!==void 0&&(A=c.onDidChangeNotebookKernelSourceActions(W=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(d))),{dispose:()=>{this._kernelSourceActionProviders.delete(s),k._proxy.$removeKernelSourceActionProvider(s,s),A?.dispose()}}}async $provideKernelSourceActions(i,p){const c=this._kernelSourceActionProviders.get(i);if(c){const s=new S.DisposableStore;return this._kernelSourceActionProviderCache.add([s]),(await c.provideNotebookKernelSourceActions(p)??[]).map(k=>m.NotebookKernelSourceAction.from(k,this._commands.converter,s))}return[]}$acceptNotebookAssociation(i,p,c){const s=this._kernelData.get(i);if(s){const d=this._extHostNotebook.getNotebookDocument(_.URI.revive(p));c?s.associatedNotebooks.set(d.uri,!0):s.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,d.uri.toString(),c),s.onDidChangeSelection.fire({selected:c,notebook:d.apiNotebook})}}async $executeCells(i,p,c){const s=this._kernelData.get(i);if(!s)return;const d=this._extHostNotebook.getNotebookDocument(_.URI.revive(p)),k=[];for(const A of c){const W=d.getCell(A);W&&k.push(W.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,d.uri.toString(),k.length),await s.controller.executeHandler.call(s.controller,k,d.apiNotebook,s.controller)}catch(A){this._logService.error(`NotebookController[${i}] execute cells FAILED`,A),console.error(A)}}async $cancelCells(i,p,c){const s=this._kernelData.get(i);if(!s)return;const d=this._extHostNotebook.getNotebookDocument(_.URI.revive(p));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,d.apiNotebook);else for(const k of c){const A=d.getCell(k);A&&this._activeExecutions.get(A.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,p,c){const s=this._kernelData.get(i);if(!s)return;const d=this._extHostNotebook.getEditorById(p);s.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:c}))}$cellExecutionChanged(i,p,c){const d=this._extHostNotebook.getNotebookDocument(_.URI.revive(i)).getCell(p);if(d){const k=c?m.NotebookCellExecutionState.to(c):a.NotebookCellExecutionState.Idle;k!==void 0&&this._onDidChangeCellExecutionState.fire({cell:d.apiCell,state:k})}}_createNotebookCellExecution(i,p){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const d=new t(p,s,this._proxy);this._activeExecutions.set(s.uri,d);const k=d.onDidChangeState(()=>{d.state===v.Resolved&&(d.dispose(),k.dispose(),this._activeExecutions.delete(s.uri))});return d.asApiObject()}};R=Ve([He(4,L.ILogService)],R),e.ExtHostNotebookKernels=R;var v;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(v||(v={}));class t extends S.Disposable{get state(){return this._state}constructor(i,p,c){super(),this._cell=p,this._proxy=c,this._handle=t.HANDLE++,this._onDidChangeState=new N.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=v.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new h(10,s=>this.update(s)),this._executionOrder=p.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const p=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(p))}verifyStateForOutput(){if(this._state===v.Init)throw new Error("Must call start before modifying cell output");if(this._state===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let p=this._cell;if(i&&(p=this._cell.notebook.getCellFromApiCell(i)),!p)throw new Error("INVALID cell");return p.handle}validateAndConvertOutputs(i){return i.map(p=>{const c=a.NotebookCellOutput.ensureUniqueMimeTypes(p.items,!0);return c===p.items?m.NotebookCellOutput.from(p):m.NotebookCellOutput.from({items:c,id:p.id,metadata:p.metadata})})}async updateOutputs(i,p,c){const s=this.cellIndexToHandle(p),d=this.validateAndConvertOutputs((0,n.asArray)(i));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,cellHandle:s,append:c,outputs:d})}async updateOutputItems(i,p,c){return i=a.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(i),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:i.map(m.NotebookCellOutputItem.from),outputId:p.id,append:c})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(c){i._executionOrder=c,i.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(c){if(i._state===v.Resolved||i._state===v.Started)throw new Error("Cannot call start again");i._state=v.Started,i._onDidChangeState.fire(),i.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,s){if(i._state===v.Resolved)throw new Error("Cannot call resolve twice");i._state=v.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new b.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:c}))},clearOutput(c){return i.verifyStateForOutput(),i.updateOutputs([],c,!1)},appendOutput(c,s){return i.verifyStateForOutput(),i.updateOutputs(c,s,!0)},replaceOutput(c,s){return i.verifyStateForOutput(),i.updateOutputs(c,s,!1)},appendOutputItems(c,s){return i.verifyStateForOutput(),i.updateOutputItems(c,s,!0)},replaceOutputItems(c,s){return i.verifyStateForOutput(),i.updateOutputItems(c,s,!1)}})}}t.HANDLE=0;class h{constructor(i,p){this.delay=i,this.callback=p,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new C.DeferredPromise,this.startedTimer=Date.now(),(0,C.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const p=this.batch;return this.batch=[],this.callback(p).finally(()=>i.complete())}}function r(l,i){return`${l.value}/${i}`}e.createKernelId=r}),define(Ce[224],Ie([1,0,4,5,100]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(P,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,_,I){const L=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(_)?.fire({editor:L.apiEditor,message:I})}createRendererMessaging(P,_){if(!P.contributes?.notebookRenderer?.some(L=>L.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);return{onDidReceiveMessage:(L,w,f)=>this.getOrCreateEmitterFor(_).event(L,w,f),postMessage:(L,w)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,w]=[w,L]);const f=w&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(f?.id,_,L)}}}getOrCreateEmitterFor(P){let _=this._rendererMessageEmitters.get(P);return _||(_=new n.Emitter({onDidRemoveLastListener:()=>{_?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,_),_)}}e.ExtHostNotebookRenderers=N}),define(Ce[225],Ie([1,0,6,9,2,27,5]),function(te,e,n,C,y,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(I){this.handlers=new Map,this.proxy=I.getProxy(S.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(I,L,w){if((0,N.checkProposedApiEnabled)(I,"profileContentHandlers"),this.handlers.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.handlers.set(L,w),this.proxy.$registerProfileContentHandler(L,w.name,w.description,I.identifier.value),(0,n.toDisposable)(()=>{this.handlers.delete(L),this.proxy.$unregisterProfileContentHandler(L)})}async $saveProfile(I,L,w,f){const E=this.handlers.get(I);if(!E)throw new Error(`Unknown handler with id: ${I}`);return E.saveProfile(L,w,f)}async $readProfile(I,L,w){const f=this.handlers.get(I);if(!f)throw new Error(`Unknown handler with id: ${I}`);return f.readProfile((0,C.isString)(L)?L:y.URI.revive(L),w)}}e.ExtHostProfileContentHandlers=P}),define(Ce[226],Ie([1,0,2,5,17,8]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class S{constructor(_,I){this.uriTransformer=I,this.providers=new Map,this.proxy=_.getProxy(C.MainContext.MainThreadQuickDiff)}$provideOriginalResource(_,I,L){const w=n.URI.revive(I),f=this.providers.get(_);return f?(0,y.asPromise)(()=>f.provideOriginalResource(w,L)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(_,I,L,w){const f=S.handlePool++;return this.providers.set(f,I),this.proxy.$registerQuickDiffProvider(f,N.DocumentSelector.from(_,this.uriTransformer),L,w),{dispose:()=>this.providers.delete(f)}}}S.handlePool=0,e.ExtHostQuickDiff=S}),define(Ce[227],Ie([1,0,20,4,6,5,2,7,12,16,29,38]),function(te,e,n,C,y,N,S,P,_,I,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(E,m,a){const o=E.getProxy(N.MainContext.MainThreadQuickOpen);class u{constructor(i,p){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=p}showQuickPick(i,p,c=n.CancellationToken.None){this._onDidSelectItem=void 0;const s=Promise.resolve(i),d=++this._instances,k=o.$show(d,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},c),A={},W=k.then(()=>A);return Promise.race([W,s]).then(J=>{if(J!==A)return s.then(j=>{const O=[];for(let B=0;B<j.length;B++){const T=j[B];typeof T=="string"?O.push({label:T,handle:B}):T.kind===P.QuickPickItemKind.Separator?O.push({type:"separator",label:T.label}):O.push({label:T.label,description:T.description,detail:T.detail,picked:T.picked,alwaysShow:T.alwaysShow,handle:B})}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{p.onDidSelectItem(j[B])}),o.$setItems(d,O),k.then(B=>{if(typeof B=="number")return j[B];if(Array.isArray(B))return B.map(T=>j[T])})})}).then(void 0,J=>{if(!(0,_.isCancellationError)(J))return o.$setError(d,J),Promise.reject(J)})}$onItemSelected(i){this._onDidSelectItem?.(i)}showInput(i,p=n.CancellationToken.None){return this._validateInput=i?.validateInput,o.$input(i,typeof this._validateInput=="function",p).then(void 0,c=>{if(!(0,_.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(i){if(!this._validateInput)return;const p=await this._validateInput(i);if(!p||typeof p=="string")return p;let c;switch(p.severity){case P.InputBoxValidationSeverity.Info:c=L.default.Info;break;case P.InputBoxValidationSeverity.Warning:c=L.default.Warning;break;case P.InputBoxValidationSeverity.Error:c=L.default.Error;break;default:c=p.message?L.default.Error:L.default.Ignore;break}return{content:p.message,severity:c}}async showWorkspaceFolderPick(i,p=n.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!c)return;const s=await this._workspace.getWorkspaceFolders2();if(!!s)return s.find(d=>d.uri.toString()===c.uri.toString())}createQuickPick(i){const p=new h(i,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}createInputBox(i){const p=new r(i,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}$onDidChangeValue(i,p){this._sessions.get(i)?._fireDidChangeValue(p)}$onDidAccept(i){this._sessions.get(i)?._fireDidAccept()}$onDidChangeActive(i,p){const c=this._sessions.get(i);c instanceof h&&c._fireDidChangeActive(p)}$onDidChangeSelection(i,p){const c=this._sessions.get(i);c instanceof h&&c._fireDidChangeSelection(p)}$onDidTriggerButton(i,p){this._sessions.get(i)?._fireDidTriggerButton(p)}$onDidTriggerItemButton(i,p,c){const s=this._sessions.get(i);s instanceof h&&s._fireDidTriggerItemButton(p,c)}$onDidHide(i){this._sessions.get(i)?._fireDidHide()}}class g{constructor(i,p){this._extensionId=i,this._onDidDispose=p,this._id=h._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((p,c)=>{const s=p===P.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(s,p)}),this.update({buttons:i.map((p,c)=>({...t(p),tooltip:p.tooltip,handle:p===P.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const p=this._handlesToButtons.get(i);p&&this._onDidTriggerButtonEmitter.fire(p)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),o.$dispose(this._id))}update(i){if(!this._disposed){for(const p of Object.keys(i)){const c=i[p];this._pendingUpdate[p]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){o.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function b(l){if(l instanceof P.ThemeIcon)return{id:l.id};const i=v(l),p=R(l);return{dark:typeof i=="string"?S.URI.file(i):i,light:typeof p=="string"?S.URI.file(p):p}}function R(l){return typeof l=="object"&&"light"in l?l.light:l}function v(l){return typeof l=="object"&&"dark"in l?l.dark:l}function t(l){const i=b(l.iconPath);let p,c;return"id"in i?c=w.ThemeIcon.asClassName(i):p=i,{iconPath:p,iconClass:c}}class h extends g{constructor(i,p){super(i.identifier,p),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((c,s)=>{this._handlesToItems.set(s,c),this._itemsToHandles.set(c,s)});const p=[];for(let c=0;c<i.length;c++){const s=i[c];s.kind===P.QuickPickItemKind.Separator?p.push({type:"separator",label:s.label}):p.push({handle:c,label:s.label,description:s.description,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow,buttons:s.buttons?.map((d,k)=>({...t(d),tooltip:d.tooltip,handle:k}))})}this.update({items:p})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(i){this._keepScrollPosition=i,this.update({keepScrollPosition:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(p=>this._itemsToHandles.has(p)),this.update({activeItems:this._activeItems.map(p=>this._itemsToHandles.get(p))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(p=>this._itemsToHandles.has(p)),this.update({selectedItems:this._selectedItems.map(p=>this._itemsToHandles.get(p))})}_fireDidChangeActive(i){const p=(0,I.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._activeItems=p,this._onDidChangeActiveEmitter.fire(p)}_fireDidChangeSelection(i){const p=(0,I.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._selectedItems=p,this._onDidChangeSelectionEmitter.fire(p)}_fireDidTriggerItemButton(i,p){const c=this._handlesToItems.get(i);if(!c||!c.buttons||!c.buttons.length)return;const s=c.buttons[p];s&&this._onDidTriggerItemButtonEmitter.fire({button:s,item:c})}}class r extends g{constructor(i,p){super(i.identifier,p),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get valueSelection(){return this._valueSelection}set valueSelection(i){this._valueSelection=i,this.update({valueSelection:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,i?typeof i=="string"?this.update({validationMessage:i,severity:L.default.Error}):this.update({validationMessage:i.message,severity:i.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new u(m,a)}e.createExtHostQuickOpen=f});var Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n};define(Ce[228],Ie([1,0,2,4,63,6,17,5,16,123,11,25,38,8,27]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m){"use strict";var a,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(s){if(s)return typeof s.iconPath=="string"?n.URI.file(s.iconPath):n.URI.isUri(s.iconPath)||f.ThemeIcon.isThemeIcon(s.iconPath)?s.iconPath:void 0}function g(s,d){if(!s.iconPath&&!d.iconPath)return 0;if(s.iconPath){if(!d.iconPath)return 1}else return-1;const k=typeof s.iconPath=="string"?s.iconPath:n.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id,A=typeof d.iconPath=="string"?d.iconPath:n.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,I.comparePaths)(k,A)}function b(s,d){let k=0;if(s.strikeThrough!==d.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==d.faded)return s.faded?1:-1;if(s.tooltip!==d.tooltip)return(s.tooltip||"").localeCompare(d.tooltip||"");if(k=g(s,d),k!==0)return k;if(s.light&&d.light)k=g(s.light,d.light);else{if(s.light)return 1;if(d.light)return-1}if(k!==0)return k;if(s.dark&&d.dark)k=g(s.dark,d.dark);else{if(s.dark)return 1;if(d.dark)return-1}return k}function R(s,d){if(s.command!==d.command)return s.command<d.command?-1:1;if(s.title!==d.title)return s.title<d.title?-1:1;if(s.tooltip!==d.tooltip){if(s.tooltip!==void 0&&d.tooltip!==void 0)return s.tooltip<d.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(s.arguments===d.arguments)return 0;if(s.arguments)if(d.arguments){if(s.arguments.length!==d.arguments.length)return s.arguments.length-d.arguments.length}else return 1;else return-1;for(let k=0;k<s.arguments.length;k++){const A=s.arguments[k],W=d.arguments[k];if(A!==W)return A<W?-1:1}return 0}function v(s,d){let k=(0,I.comparePaths)(s.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(k!==0)return k;if(s.command&&d.command)k=R(s.command,d.command);else{if(s.command)return 1;if(d.command)return-1}if(k!==0)return k;if(s.decorations&&d.decorations)k=b(s.decorations,d.decorations);else{if(s.decorations)return 1;if(d.decorations)return-1}return k}function t(s,d){for(let k=0;k<s.length;k++)if(s[k]!==d[k])return!1;return!0}function h(s,d){return s.command===d.command&&s.title===d.title&&s.tooltip===d.tooltip&&(s.arguments&&d.arguments?t(s.arguments,d.arguments):s.arguments===d.arguments)}function r(s,d){return(0,_.equals)(s,d,h)}class l{get value(){return this._value}set value(d){d=d??"",Oe(this,a,"f").$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){Oe(this,a,"f").$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(d){if((0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,Oe(this,a,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get enabled(){return this._enabled}set enabled(d){d=!!d,this._enabled!==d&&(this._enabled=d,Oe(this,a,"f").$setInputBoxEnablement(this._sourceControlHandle,d))}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,Oe(this,a,"f").$setInputBoxVisibility(this._sourceControlHandle,d))}constructor(d,k,A){this._extension=d,this._sourceControlHandle=A,a.set(this,void 0),this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,a,k,"f")}showValidationMessage(d,k){(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,a,"f").$showValidationMessage(this._sourceControlHandle,d,k)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=l,a=new WeakMap;class i{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}constructor(d,k,A,W,J){this._proxy=d,this._commands=k,this._sourceControlHandle=A,this._id=W,this._label=J,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=i._handlePool++}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,k){const A=this._resourceStatesCommandsMap.get(d);return A?(0,S.asPromise)(()=>this._commands.executeCommand(A.command,...A.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(v),A=(0,_.sortedDiff)(this._resourceSnapshot,d,v).map(j=>{const O=j.toInsert.map(B=>{const T=this._resourceHandlePool++;this._resourceStatesMap.set(T,B);const F=B.resourceUri;let z;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const Z=new N.DisposableStore;z=this._commands.converter.toInternal(B.command,Z),this._resourceStatesDisposablesMap.set(T,Z)}else this._resourceStatesCommandsMap.set(T,B.command);const H=u(B.decorations),de=B.decorations&&u(B.decorations.light)||H,pe=B.decorations&&u(B.decorations.dark)||H,re=[de,pe],le=B.decorations&&B.decorations.tooltip||"",ae=B.decorations&&!!B.decorations.strikeThrough,se=B.decorations&&!!B.decorations.faded,Q=B.contextValue||"";return{rawResource:[T,F,re,le,ae,se,Q,z],handle:T}});return{start:j.start,deleteCount:j.deleteCount,toInsert:O}}),W=A.map(({start:j,deleteCount:O,toInsert:B})=>[j,O,B.map(T=>T.rawResource)]),J=A.reverse();for(const{start:j,deleteCount:O,toInsert:B}of J){const T=B.map(z=>z.handle),F=this._handlesSnapshot.splice(j,O,...T);for(const z of F)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=d,W}dispose(){this._disposed=!0,this._onDidDispose.fire()}}i._handlePool=0;class p{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,Oe(this,o,"f").$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,Oe(this,o,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,Oe(this,o,"f").$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new N.DisposableStore,this._acceptInputCommand=d;const k=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);Oe(this,o,"f").$updateSourceControl(this.handle,{acceptInputCommand:k})}get actionButton(){return(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(d){(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new N.DisposableStore,this._actionButton=d;const k=d!==void 0?{command:this._commands.converter.toInternal(d.command,this._actionButtonDisposables.value),secondaryCommands:d.secondaryCommands?.map(A=>A.map(W=>this._commands.converter.toInternal(W,this._actionButtonDisposables.value))),description:d.description,enabled:d.enabled}:void 0;Oe(this,o,"f").$updateSourceControl(this.handle,{actionButton:k??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&r(this._statusBarCommands,d))return;this._statusBarDisposables.value=new N.DisposableStore,this._statusBarCommands=d;const k=(d||[]).map(A=>this._commands.converter.toInternal(A,this._statusBarDisposables.value));Oe(this,o,"f").$updateSourceControl(this.handle,{statusBarCommands:k})}get selected(){return this._selected}constructor(d,k,A,W,J,j){this._extension=d,this._commands=A,this._id=W,this._label=J,this._rootUri=j,o.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new N.MutableDisposable,this._statusBarDisposables=new N.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=p._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,o,k,"f"),this._inputBox=new l(d,Oe(this,o,"f"),this.handle),Oe(this,o,"f").$registerSourceControl(this.handle,W,J,j)}createResourceGroup(d,k){const A=new i(Oe(this,o,"f"),this._commands,this.handle,d,k),W=C.Event.once(A.onDidDispose)(()=>this.createdResourceGroups.delete(A));return this.createdResourceGroups.set(A,W),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const d=[],k=[];for(const[A,W]of this.createdResourceGroups){W.dispose();const J=A.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(A),this.eventuallyUpdateResourceStates()});C.Event.once(A.onDidDispose)(()=>{this.updatedResourceGroups.delete(A),J.dispose(),this._groups.delete(A.handle),Oe(this,o,"f").$unregisterGroup(this.handle,A.handle)}),d.push([A.handle,A.id,A.label,A.features]);const j=A._takeResourceStateSnapshot();j.length>0&&k.push([A.handle,j]),this._groups.set(A.handle,A)}Oe(this,o,"f").$registerGroups(this.handle,d,k),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(k=>{const A=k._takeResourceStateSnapshot();A.length!==0&&d.push([k.handle,A])}),d.length>0&&Oe(this,o,"f").$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),Oe(this,o,"f").$unregisterSourceControl(this.handle)}}o=new WeakMap,p._handlePool=0,Ve([(0,y.debounce)(100)],p.prototype,"eventuallyAddResourceGroups",null),Ve([(0,y.debounce)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let c=class on{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(d,k,A){this._commands=k,this.logService=A,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=d.getProxy(P.MainContext.MainThreadSCM),this._telemetry=d.getProxy(P.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const J=this._sourceControls.get(W.sourceControlHandle);if(!J)return W;const j=J.getResourceGroup(W.groupHandle);return j?j.getResourceState(W.handle):W}else if(W&&W.$mid===4){const J=this._sourceControls.get(W.sourceControlHandle);return J?J.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const J=this._sourceControls.get(W.handle);return J||W}return W}})}createSourceControl(d,k,A,W){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,k,A,W),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const J=on._handlePool++,j=new p(d,this._proxy,this._commands,k,A,W);this._sourceControls.set(J,j);const O=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(d.identifier))||[];return O.push(j),this._sourceControlsByExtension.set(w.ExtensionIdentifier.toKey(d.identifier),O),j}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const k=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(d.identifier)),A=k&&k[k.length-1];return A&&A.inputBox}$provideOriginalResource(d,k,A){const W=n.URI.revive(k);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,W.toString());const J=this._sourceControls.get(d);return!J||!J.quickDiffProvider||!J.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>J.quickDiffProvider.provideOriginalResource(W,A)).then(j=>j||null)}$onInputBoxValueChange(d,k){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const A=this._sourceControls.get(d);return A&&A.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(d,k,A,W){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,k,A);const J=this._sourceControls.get(d);if(!J)return Promise.resolve(void 0);const j=J.getResourceGroup(k);return j?j.$executeResourceCommand(A,W):Promise.resolve(void 0)}$validateInput(d,k,A){this.logService.trace("ExtHostSCM#$validateInput",d);const W=this._sourceControls.get(d);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>W.inputBox.validateInput(k,A)).then(J=>{if(!J)return Promise.resolve(void 0);const j=E.MarkdownString.fromStrict(J.message);return j?Promise.resolve([j,J.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};c._handlePool=0,c=Ve([He(2,L.ILogService)],c),e.ExtHostSCM=c}),define(Ce[79],Ie([1,0,5,4,3]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(P){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,_){return this._proxy.$getPassword(P,_)}store(P,_,I){return this._proxy.$setPassword(P,_,I)}delete(P,_){return this._proxy.$deletePassword(P,_)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[229],Ie([1,0,7,5,142,6,8,9]),function(te,e,n,C,y,N,S,P){"use strict";var _,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(m,a,o,u,g=n.StatusBarAlignment.Left,b){_.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._staleCommandRegistrations=new N.DisposableStore,Je(this,_,m,"f"),Je(this,I,a,"f"),this._entryId=L.ID_GEN++,this._extension=o,this._id=u,this._alignment=g,this._priority=this.validatePriority(b)}validatePriority(m){if(!!(0,P.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!L.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new N.DisposableStore,typeof m=="string"?this._command={fromApi:m,internal:Oe(this,I,"f").toInternal({title:"",command:m},this._latestCommandRegistration)}:m?this._command={fromApi:m,internal:Oe(this,I,"f").toInternal(m,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let a;this._name?a=this._name:a=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let o=this._color;this._backgroundColor&&(o=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const u=S.MarkdownString.fromStrict(this._tooltip);Oe(this,_,"f").$setEntry(this._entryId,m,a,this._text,u,this._command?.internal,o,this._backgroundColor,this._alignment===n.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}_=new WeakMap,I=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class w{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const a={message:m};return this._messages.unshift(a),this._update(),new n.Disposable(()=>{const o=this._messages.indexOf(a);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class f{constructor(m,a){this._proxy=m.getProxy(C.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new w(this)}createStatusBarEntry(m,a,o,u){return new L(this._proxy,this._commands,m,a,o,u)}setStatusBarMessage(m,a){const o=this._statusMessage.setMessage(m);let u;return typeof a=="number"?u=setTimeout(()=>o.dispose(),a):typeof a<"u"&&a.then(()=>o.dispose(),()=>o.dispose()),new n.Disposable(()=>{o.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=f}),define(Ce[80],Ie([1,0,5,4,3]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(P,_){this._logService=_,this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,_){this._proxy.$registerExtensionStorageKeysToSync(P,_)}async initializeExtensionStorage(P,_,I){const L=await this._proxy.$initializeExtensionStorage(P,_);let w;return L&&(w=this.safeParseValue(P,_,L)),w||I}setValue(P,_,I){return this._proxy.$setValue(P,_,I)}$acceptValue(P,_,I){const L=this.safeParseValue(P,_,I);L&&this._onDidChangeStorage.fire({shared:P,key:_,value:L})}safeParseValue(P,_,I){try{return JSON.parse(I)}catch(L){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${_}, global: ${P}): ${L}`)}}}e.ExtHostStorage=N,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ce[81],Ie([1,0,3,26,11,59,2]),function(te,e,n,C,y,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let P=class{constructor(I,L,w){this._logService=L,this._extHostFileSystem=w,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getWorkspaceStorageURI(I){return S.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,L=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:S.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(I){if(this._value)return S.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return S.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Ve([He(0,C.IExtHostInitDataService),He(1,y.ILogService),He(2,N.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(Ce[60],Ie([1,0,4,5,3,2,18,6,7,144,12,170,20,34,171,38,9,17,8]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(c,s,d,k){this._proxy=c,this._id=s,this._creationOptions=d,this._name=k,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(W=>this._pidPromiseComplete=W);const A=this;this.value={get name(){return A._name||""},get processId(){return A._pidPromise},get creationOptions(){return A._creationOptions},get exitStatus(){return A._exitStatus},get state(){return A._state},sendText(W,J=!0){A._checkDisposed(),A._proxy.$sendText(A._id,W,J)},show(W){A._checkDisposed(),A._proxy.$show(A._id,W)},hide(){A._checkDisposed(),A._proxy.$hide(A._id)},dispose(){A._disposed||(A._disposed=!0,A._proxy.$dispose(A._id))},get dimensions(){if(!(A._cols===void 0||A._rows===void 0))return{columns:A._cols,rows:A._rows}}}}async create(c,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,o.withNullAsUndefined)(c.shellPath),shellArgs:(0,o.withNullAsUndefined)(c.shellArgs),cwd:(0,o.withNullAsUndefined)(c.cwd),env:(0,o.withNullAsUndefined)(c.env),icon:(0,o.withNullAsUndefined)(l(c.iconPath)),color:a.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,o.withNullAsUndefined)(c.message),strictEnv:(0,o.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(c.location,s?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(c.isTransient)})}async createExtensionTerminal(c,s,d,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:a.ThemeColor.isThemeColor(k)?k.id:void 0,location:this._serializeParentTerminal(c,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,s){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in c?{viewColumn:g.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitStatus(c,s){this._exitStatus=Object.freeze({code:c,reason:s})}setDimensions(c,s){return c===this._cols&&s===this._rows||c===0||s===0?!1:(this._cols=c,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=b;class R{get onProcessReady(){return this._onProcessReady.event}constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new n.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new n.Emitter,this._onDidChangeProperty=new n.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new n.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput?.(c)}resize(c,s){this._pty.setDimensions?.({columns:c,rows:s})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(c||void 0),c&&this._pty.setDimensions?.(c),this._onProcessReady.fire({pid:-1,cwd:""})}}let v=1,t=class extends P.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(c,s){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new n.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new n.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new n.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new n.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new n.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new n.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=s.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new m.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new n.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[d,k]of this._terminalProcesses)k.shutdown(!0)}})}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,s){const d=new b(this._proxy,(0,E.generateUuid)(),c,c.name),k=new R(c.pty);return d.createExtensionTerminal(c.location,this._serializeParentTerminal(c,s).resolvedExtHostIdentifier,l(c.iconPath),i(c.color)).then(A=>{const W=this._setupExtHostProcessListeners(A,k);this._terminalProcessDisposables[A]=W}),this._terminals.push(d),d.value}_serializeParentTerminal(c,s){if(s=s||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const d=c.location.parentTerminal;if(d){const k=this._terminals.find(A=>A.value===d);k&&(s.resolvedExtHostIdentifier=k._id)}}else c.location&&typeof c.location!="object"?s.location=c.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(c,s){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const k=new R(s),A=this._setupExtHostProcessListeners(c,k);this._terminalProcessDisposables[c]=A}async $acceptActiveTerminalChanged(c){const s=this._activeTerminal;if(c===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(c);d&&(this._activeTerminal=d,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,s){const d=this._getTerminalById(c);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:s})}async $acceptTerminalDimensions(c,s,d){const k=this._getTerminalById(c);k&&k.setDimensions(s,d)&&this._onDidChangeTerminalDimensions.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(c,s,d){this._terminalProcesses.get(c)?.resize(s,d)}async $acceptTerminalTitleChange(c,s){const d=this._getTerminalById(c);d&&(d.name=s)}async $acceptTerminalClosed(c,s,d){const k=this._getTerminalObjectIndexById(this._terminals,c);if(k!==null){const A=this._terminals.splice(k,1)[0];A.setExitStatus(s,d),this._onDidCloseTerminal.fire(A.value)}}$acceptTerminalOpened(c,s,d,k){if(s){const J=this._getTerminalObjectIndexById(this._terminals,s);if(J!==null){this._terminals[J]._id=c,this._onDidOpenTerminal.fire(this.terminals[J]),this._terminals[J].isOpen=!0;return}}const A={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:N.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},W=new b(this._proxy,c,A,d);this._terminals.push(W),this._onDidOpenTerminal.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(c,s){this._getTerminalById(c)?._setProcessId(s)}async $startExtensionTerminal(c,s){const d=this._getTerminalById(c);if(!d)return{message:(0,I.localize)(0,null,c)};d.isOpen||await new Promise(A=>{const W=this.onDidOpenTerminal(async J=>{J===d.value&&(W.dispose(),A())})});const k=this._terminalProcesses.get(c);k?k.startSendingEvents(s):this._extensionTerminalAwaitingStart[c]={initialDimensions:s}}_setupExtHostProcessListeners(c,s){const d=new P.DisposableStore;d.add(s.onProcessReady(A=>this._proxy.$sendProcessReady(c,A.pid,A.cwd))),d.add(s.onDidChangeProperty(A=>this._proxy.$sendProcessProperty(c,A))),this._bufferer.startBuffering(c,s.onProcessData),d.add(s.onProcessExit(A=>this._onProcessExit(c,A))),this._terminalProcesses.set(c,s);const k=this._extensionTerminalAwaitingStart[c];return k&&s instanceof R&&(s.startSendingEvents(k.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),d}$acceptProcessAckDataEvent(c,s){this._terminalProcesses.get(c)?.acknowledgeDataEvent(s)}$acceptProcessInput(c,s){this._terminalProcesses.get(c)?.input(s)}$acceptTerminalInteraction(c){const s=this._getTerminalById(c);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(c,s,d){try{this._terminalProcesses.get(c)?.resize(s,d)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(c,s){this._terminalProcesses.get(c)?.shutdown(s)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(c,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(s=>this._proxy.$sendProcessProperty(c,{type:"cwd",value:s}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,s,d){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,d),this._proxy.$registerProfileProvider(s,c.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}registerTerminalQuickFixProvider(c,s,d){if(this._quickFixProviders.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this._quickFixProviders.set(c,d),this._proxy.$registerQuickFixProvider(c,s),new _.Disposable(()=>{this._quickFixProviders.delete(c),this._proxy.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,s){const d=new f.CancellationTokenSource().token;if(d.isCancellationRequested)return;const k=this._quickFixProviders.get(c);if(!k)return;const A=await k.provideTerminalQuickFixes(s,d);if(A!==null)return A}async $createContributedProfileTerminal(c,s){const d=new f.CancellationTokenSource().token;let k=await this._profileProviders.get(c)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(k&&!("options"in k)&&(k={options:k}),!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,s);return}this.createTerminalFromOptions(k.options,s)}}async $provideLinks(c,s){const d=this._getTerminalById(c);if(!d)return[];this._terminalLinkCache.delete(c),this._terminalLinkCancellationSource.get(c)?.dispose(!0);const A=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,A);const W=[],J={terminal:d.value,line:s},j=[];for(const T of this._linkProviders)j.push(u.Promises.withAsyncBody(async F=>{A.token.onCancellationRequested(()=>F({provider:T,links:[]}));const z=await T.provideTerminalLinks(J,A.token)||[];A.token.isCancellationRequested||F({provider:T,links:z})}));const O=await Promise.all(j);if(A.token.isCancellationRequested)return[];const B=new Map;for(const T of O)T&&T.links.length>0&&W.push(...T.links.map(F=>{const z={id:v++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return B.set(z.id,{provider:T.provider,link:F}),z}));return this._terminalLinkCache.set(c,B),W}$activateLink(c,s){const d=this._terminalLinkCache.get(c)?.get(s);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(c,s){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const d=this._terminalProcessDisposables[c];d&&(d.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,s)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,s){const d=this._getTerminalObjectIndexById(c,s);return d!==null?c[d]:null}_getTerminalObjectIndexById(c,s){let d=null;return c.some((k,A)=>k._id===s?(d=A,!0):!1),d}getEnvironmentVariableCollection(c){let s=this._environmentVariableCollections.get(c.identifier.value);return s||(s=new h,this._setEnvironmentVariableCollection(c.identifier.value,s)),s}_syncEnvironmentVariableCollection(c,s){const d=(0,w.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(c,s.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(c){c.forEach(s=>{const d=s[0],k=new h(s[1]);this._setEnvironmentVariableCollection(d,k)})}$acceptDefaultProfile(c,s){const d=this._defaultProfile;this._defaultProfile=c,this._defaultAutomationProfile=s,d?.path!==c.path&&this._onDidChangeShell.fire(c.path)}_setEnvironmentVariableCollection(c,s){this._environmentVariableCollections.set(c,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,s)})}};t=Ve([He(1,S.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class h{get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new n.Emitter,this.map=new Map(c)}get size(){return this.map.size}replace(c,s){this._setIfDiffers(c,{value:s,type:_.EnvironmentVariableMutatorType.Replace})}append(c,s){this._setIfDiffers(c,{value:s,type:_.EnvironmentVariableMutatorType.Append})}prepend(c,s){this._setIfDiffers(c,{value:s,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,s){const d=this.map.get(c);(!d||d.value!==s.value||d.type!==s.type)&&(this.map.set(c,s),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,s){this.map.forEach((d,k)=>c.call(s,k,d,this))}[Symbol.iterator](){return this.map.entries()}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}let r=class extends t{constructor(c){super(!1,c)}createTerminal(c,s,d){throw new L.NotSupportedError}createTerminalFromOptions(c,s){throw new L.NotSupportedError}};r=Ve([He(0,S.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function l(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function i(p){return a.ThemeColor.isThemeColor(p)?p:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n};define(Ce[230],Ie([1,0,16,17,23,20,4,194,231,6,22,9,34,5,18,101,8,7,45,71,56,27]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R,v){"use strict";var t,h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(T,F,z){this.editors=z,this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(E.MainContext.MainThreadTesting),this.observer=new J(this.proxy),this.runTracker=new c(this.proxy),F.registerArgumentProcessor({processArgument:H=>{if(H?.$mid!==15)return H;const de=H,pe=de.tests[de.tests.length-1].item.extId;return this.controllers.get(g.TestId.root(pe))?.collection.tree.get(pe)?.actual??(0,a.toItemFromContext)(H)}})}createTestController(T,F,z,H){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const de=new I.DisposableStore,pe=de.add(new a.ExtHostTestItemCollection(F,z,this.editors));pe.root.label=z;const re=new Map,le=this.proxy,ae={items:pe.root.children,get label(){return z},set label(Q){z=Q,pe.root.label=Q,le.$updateController(F,{label:z})},get refreshHandler(){return H},set refreshHandler(Q){H=Q,le.$updateController(F,{canRefresh:!!Q})},get id(){return F},createRunProfile:(Q,K,Z,he,ke,Fe)=>{let je=(0,_.hash)(Q);for(;re.has(je);)je++;return Fe!==void 0&&(0,v.checkProposedApiEnabled)(T,"testContinuousRun"),new j(this.proxy,re,F,je,Q,K,Z,he,ke,Fe)},createTestItem(Q,K,Z){return new a.TestItemImpl(F,Q,K,Z)},createTestRun:(Q,K,Z=!0)=>this.runTracker.createTestRun(F,pe,Q,K,Z),set resolveHandler(Q){pe.resolveHandler=Q},get resolveHandler(){return pe.resolveHandler},dispose:()=>{de.dispose()}};le.$registerTestController(F,z,!!H),de.add((0,I.toDisposable)(()=>le.$unregisterTestController(F)));const se={controller:ae,collection:pe,profiles:re};return this.controllers.set(F,se),de.add((0,I.toDisposable)(()=>this.controllers.delete(F))),de.add(pe.onDidGenerateDiff(Q=>le.$publishDiff(F,Q.map(R.TestsDiffOp.serialize)))),ae}createTestObserver(){return this.observer.checkout()}async runTests(T,F=N.CancellationToken.None){const z=s(T);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(z.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(de=>g.TestId.fromExtHostTestItem(de,H.collection.root.id).toString())??[H.collection.root.id],profileGroup:O[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:T.exclude?.map(de=>de.id)},F)}$syncTests(){for(const{collection:T}of this.controllers.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,F,z){return(0,n.mapFind)(this.runTracker.trackers,de=>de.id===T?de.getCoverage(F):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(T,F,z,H){return(0,n.mapFind)(this.runTracker.trackers,pe=>pe.id===T?pe.getCoverage(F):void 0)?.resolveFileCoverage(z,H)??Promise.resolve([])}$configureRunProfile(T,F){this.controllers.get(T)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(T,F){await this.controllers.get(T)?.controller.refreshHandler?.(F)}$publishTestResults(T){this.results=Object.freeze(T.map(F=>(0,L.deepFreeze)(o.TestResults.to(F))).concat(this.results).sort((F,z)=>z.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(T,F){const z=this.controllers.get(g.TestId.fromString(T).controllerId)?.collection;z&&(await z.expand(T,F<0?1/0:F),z.flushDiff())}$acceptDiff(T){this.observer.applyDiff(T.map(R.TestsDiffOp.deserialize))}async $runControllerTests(T,F){return Promise.all(T.map(z=>this.runControllerTestRequest(z,!1,F)))}async $startContinuousRun(T,F){const z=new N.CancellationTokenSource(F),H=await Promise.all(T.map(de=>this.runControllerTestRequest(de,!0,z.token)));return!F.isCancellationRequested&&!H.some(de=>de.error)&&await new Promise(de=>F.onCancellationRequested(de)),z.dispose(!0),H}async runControllerTestRequest(T,F,z){const H=this.controllers.get(T.controllerId);if(!H)return{};const{collection:de,profiles:pe}=H,re=pe.get(T.profileId);if(!re)return{};const le=T.testIds.map(K=>de.tree.get(K)).filter(w.isDefined),ae=T.excludeExtIds.map(K=>H.collection.tree.get(K)).filter(w.isDefined).filter(K=>le.some(Z=>Z.fullId.compare(K.fullId)===2));if(!le.length)return{};const se=new u.TestRunRequest2(le.some(K=>K.actual instanceof a.TestItemRootImpl)?void 0:le.map(K=>K.actual),ae.map(K=>K.actual),re,F),Q=(0,R.isStartControllerTests)(T)&&this.runTracker.prepareForMainThreadTestRun(se,d.fromInternal(T,H.collection),z);try{return await re.runHandler(se,z),{}}catch(K){return{error:String(K)}}finally{Q&&(Q.hasRunningTasks&&!z.isCancellationRequested&&await S.Event.toPromise(Q.onEnd),Q.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(T)}};r=Ve([He(0,m.IExtHostRpcService)],r),e.ExtHostTesting=r;const l=1e4;var i;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(i||(i={}));class p extends I.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(T,F,z){super(),this.dto=T,this.proxy=F,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new N.CancellationTokenSource(z));const H=this._register(new C.RunOnceScheduler(()=>this.forciblyEndTasks(),l));this._register(this.cts.token.onCancellationRequested(()=>H.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(T){return this.tasks.get(T)?.coverage}createRun(T){const F=this.dto.id,z=this.dto.controllerId,H=(0,f.generateUuid)(),de=new k(this.proxy,F,H),pe=se=>(Q,...K)=>{if(le){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),se(Q,...K))},re=(se,Q)=>{const K=Q instanceof Array?Q.map(o.TestMessage.from):[o.TestMessage.from(Q)];if(se.uri&&se.range){const Z={range:o.Range.from(se.range),uri:se.uri};for(const he of K)he.location=he.location||Z}this.proxy.$appendTestMessagesInRun(F,H,g.TestId.fromExtHostTestItem(se,z).toString(),K)};let le=!1;const ae={isPersisted:this.dto.isPersisted,token:this.cts.token,name:T,get coverageProvider(){return de.coverageProvider},set coverageProvider(se){de.coverageProvider=se},enqueued:pe(se=>{this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(se,z).toString(),1)}),skipped:pe(se=>{this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(se,z).toString(),5)}),started:pe(se=>{this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(se,z).toString(),2)}),errored:pe((se,Q,K)=>{re(se,Q),this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(se,z).toString(),6,K)}),failed:pe((se,Q,K)=>{re(se,Q),this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(se,z).toString(),4,K)}),passed:pe((se,Q)=>{this.proxy.$updateTestStateInRun(F,H,g.TestId.fromExtHostTestItem(se,this.dto.controllerId).toString(),3,Q)}),appendOutput:(se,Q,K)=>{le||(K&&(this.dto.isIncluded(K)?this.ensureTestIsKnown(K):K=void 0),this.proxy.$appendOutputToRun(F,H,y.VSBuffer.fromString(se),Q&&o.location.from(Q),K&&g.TestId.fromExtHostTestItem(K,z).toString()))},end:()=>{le||(le=!0,this.proxy.$finishedTestRunTask(F,H),this.tasks.delete(H),this.tasks.size||this.markEnded())}};return this.tasks.set(H,{run:ae,coverage:de}),this.proxy.$startedTestRunTask(F,{id:H,name:T,running:!0}),ae}forciblyEndTasks(){for(const{run:T}of this.tasks.values())T.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(T){if(!(T instanceof a.TestItemImpl))throw new b.InvalidTestItemError(T.id);if(this.sharedTestIds.has(g.TestId.fromExtHostTestItem(T,this.dto.controllerId).toString()))return;const F=[],z=this.dto.colllection.root;for(;;){const H=o.TestItem.from(T);if(F.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),T===z))break;T=T.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class c{get trackers(){return this.tracked.values()}constructor(T){this.proxy=T,this.tracked=new Map}prepareForMainThreadTestRun(T,F,z){return this.getTracker(T,F,z)}cancelRunById(T){for(const F of this.tracked.values())if(F.id===T){F.cancel();return}}cancelAllRuns(){for(const T of this.tracked.values())T.cancel()}createTestRun(T,F,z,H,de){const pe=this.tracked.get(z);if(pe)return pe.createRun(H);const re=d.fromPublic(T,F,z,de),le=s(z);this.proxy.$startedExtensionTestRun({controllerId:T,continuous:!!z.continuous,profile:le&&{group:O[le.kind],id:le.profileId},exclude:z.exclude?.map(se=>g.TestId.fromExtHostTestItem(se,F.root.id).toString())??[],id:re.id,include:z.include?.map(se=>g.TestId.fromExtHostTestItem(se,F.root.id).toString())??[F.root.id],persist:de});const ae=this.getTracker(z,re);return ae.onEnd(()=>{this.proxy.$finishedExtensionTestRun(re.id),ae.dispose()}),ae.createRun(H)}getTracker(T,F,z){const H=new p(F,this.proxy,z);return this.tracked.set(T,H),H.onEnd(()=>this.tracked.delete(T)),H}}e.TestRunCoordinator=c;const s=B=>{if(!!B.profile){if(!(B.profile instanceof j))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class d{static fromPublic(T,F,z,H){return new d(T,(0,f.generateUuid)(),z.include?.map(de=>g.TestId.fromExtHostTestItem(de,T).toString())??[T],z.exclude?.map(de=>g.TestId.fromExtHostTestItem(de,T).toString())??[],H,F)}static fromInternal(T,F){return new d(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,F)}constructor(T,F,z,H,de,pe){this.controllerId=T,this.id=F,this.isPersisted=de,this.colllection=pe,this.includePrefix=z.map(re=>re+"\0"),this.excludePrefix=H.map(re=>re+"\0")}isIncluded(T){const F=g.TestId.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(F===z||F.startsWith(z))return!1;for(const z of this.includePrefix)if(F===z||F.startsWith(z))return!0;return!1}}e.TestRunDto=d;class k{set coverageProvider(T){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this._coverageProvider=T,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(T,F,z){this.proxy=T,this.runId=F,this.taskId=z}async provideFileCoverage(T){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(T))());try{return(await this.fileCoverage)?.map(o.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(T,F){const z=await this.fileCoverage;let H=z?.[T];return!this._coverageProvider||!z||!H?[]:(H.detailedCoverage||(H=z[T]=await this._coverageProvider.resolveFileCoverage?.(H,F)??H),H.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class A{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(T){this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(T){this.added.add(T)}update(T){Object.assign(T.revived,o.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}this.updated.delete(T);const F=g.TestId.parentId(T.item.extId);if(F&&this.alreadyRemoved.has(F.toString())){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:F,removed:z}=this;return{get added(){return[...T].map(H=>H.revived)},get updated(){return[...F].map(H=>H.revived)},get removed(){return[...z].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class W extends R.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,F){return{...T,revived:o.TestItem.toPlain(T.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new A(this.changeEmitter)}}class J{constructor(T){this.proxy=T}checkout(){this.current||(this.current=this.createObserverData());const T=this.current;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(F=>F.revived)},dispose:(0,P.once)(()=>{--T.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(T){return this.current?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.current?.tests.apply(T)}createObserverData(){const T=new W;return this.proxy.$subscribeToDiffs(),{observers:0,tests:T}}}class j{get label(){return this._label}set label(T){T!==this._label&&(this._label=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(T){T!==this._supportsContinuousRun&&(this._supportsContinuousRun=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this._isDefault}set isDefault(T){T!==this._isDefault&&(this._isDefault=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?o.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(T){T!==this._configureHandler&&(this._configureHandler=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,F,z,H,de,pe,re,le=!1,ae=void 0,se=!1){this.controllerId=z,this.profileId=H,this._label=de,this.kind=pe,this.runHandler=re,this._isDefault=le,this._tag=ae,this._supportsContinuousRun=se,t.set(this,void 0),h.set(this,void 0),Je(this,t,T,"f"),Je(this,h,F,"f"),F.set(H,this);const Q=O[pe];if(typeof Q!="number")throw new Error(`Unknown TestRunProfile.group ${pe}`);Oe(this,t,"f").$publishTestRunProfile({profileId:H,controllerId:z,tag:ae?o.TestTag.namespace(this.controllerId,ae.id):null,label:de,group:Q,isDefault:le,hasConfigurationHandler:!1,supportsContinuousRun:se})}dispose(){Oe(this,h,"f")?.delete(this.profileId)&&(Je(this,h,void 0,"f"),Oe(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=j,t=new WeakMap,h=new WeakMap;const O={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Ce[232],Ie([1,0,16,4,5,102,8,7]),function(te,e,n,C,y,N,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(L,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new C.Emitter,this._onDidChangeTextEditorOptions=new C.Emitter,this._onDidChangeTextEditorVisibleRanges=new C.Emitter,this._onDidChangeTextEditorViewColumn=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(f=>this._onDidChangeVisibleTextEditors.fire(f)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(f=>this._onDidChangeActiveTextEditor.fire(f))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const w=this._extHostDocumentsAndEditors.allEditors();return L?w:w.map(f=>f.value)}async showTextDocument(L,w,f){let E;typeof w=="number"?E={position:S.ViewColumn.from(w),preserveFocus:f}:typeof w=="object"?E={position:S.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?S.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:E={preserveFocus:!1};const m=await this._proxy.$tryShowTextDocument(L.uri,E),a=m&&this._extHostDocumentsAndEditors.getEditor(m);if(a)return a.value;throw m?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,w){return new N.TextEditorDecorationType(this._proxy,L,w).value}$acceptEditorPropertiesChanged(L,w){const f=this._extHostDocumentsAndEditors.getEditor(L);if(!f)throw new Error("unknown text editor");if(w.options&&f._acceptOptions(w.options),w.selections){const E=w.selections.selections.map(S.Selection.to);f._acceptSelections(E)}if(w.visibleRanges){const E=n.coalesce(w.visibleRanges.map(S.Range.to));f._acceptVisibleRanges(E)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:f.value,options:{...w.options,lineNumbers:S.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const E=P.TextEditorSelectionChangeKind.fromValue(w.selections.source),m=w.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:f.value,selections:m,kind:E})}if(w.visibleRanges){const E=n.coalesce(w.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:f.value,visibleRanges:E})}}$acceptEditorPositionData(L){for(const w in L){const f=this._extHostDocumentsAndEditors.getEditor(w);if(!f)throw new Error("Unknown text editor");const E=S.ViewColumn.to(L[w]);f.value.viewColumn!==E&&(f._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:f.value,viewColumn:E}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=_}),define(Ce[233],Ie([1,0,2,3,5,6,7,8,25,9]),function(te,e,n,C,y,N,S,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class L{constructor(E,m){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(y.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(a,o)=>{if(a&&a.$mid===12)if(this._providers.get(a.source)&&_.ExtensionIdentifier.equals(o,this._providers.get(a.source)?.extension)){const u=a.uri===void 0?void 0:n.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(w(u))?.get(a.handle)}else return;return a}})}async $getTimeline(E,m,a,o){return this._providers.get(E)?.provider.provideTimeline(n.URI.revive(m),a,o)}registerTimelineProvider(E,m,a,o){const u=new N.DisposableStore,g=this.convertTimelineItem(m.id,o,u).bind(this);let b;m.onDidChange&&(b=m.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:m.id}),this));const R=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...m,scheme:E,onDidChange:void 0,async provideTimeline(v,t,h){t?.resetCache&&(u.clear(),R.get(m.id)?.clear());const r=await m.provideTimeline(v,t,h);if(r==null)return;const l=g(v,t);return{...r,source:m.id,items:r.items.map(l)}},dispose(){for(const v of R.values())v.get(m.id)?.clear();b?.dispose(),u.dispose()}},a)}convertTimelineItem(E,m,a){return(o,u)=>{let g;if(u?.cacheResults){let b=this._itemsBySourceAndUriMap.get(E);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(E,b));const R=w(o);g=b.get(R),g===void 0&&(g=new Map,b.set(R,g))}return b=>{const{iconPath:R,...v}=b,t=`${E}|${b.id??b.timestamp}`;g?.set(t,b);let h,r,l;b.iconPath&&(R instanceof S.ThemeIcon?l={id:R.id,color:R.color}:n.URI.isUri(R)?(h=R,r=R):{light:h,dark:r}=R);let i;return S.MarkdownString.isMarkdownString(v.tooltip)?i=P.MarkdownString.from(v.tooltip):(0,I.isString)(v.tooltip)?i=v.tooltip:S.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=P.MarkdownString.from(v.detail)):(0,I.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=v.detail),{...v,id:v.id??void 0,handle:t,source:E,command:b.command?m.toInternal(b.command,a):void 0,icon:h,iconDark:r,themeIcon:l,tooltip:i,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(E,m){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,{provider:E,extension:m}),(0,N.toDisposable)(()=>{for(const o of this._itemsBySourceAndUriMap.values())o.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=L;function w(f){return f?.toString()}}),define(Ce[234],Ie([1,0,6,15,2,5]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(_){this._openers=new Map,this._proxy=_.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,I,L,w){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const f=w.schemes.find(E=>!S.supportedSchemes.has(E));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,L),this._proxy.$registerUriOpener(I,w.schemes,_,w.label),(0,n.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(_,I,L){const w=this._openers.get(_);if(!w)throw new Error(`Unknown opener with id: ${_}`);const f=y.URI.revive(I);return w.canOpenExternalUri(f,L)}async $openUri(_,I,L){const w=this._openers.get(_);if(!w)throw new Error(`Unknown opener id: '${_}'`);return w.openExternalUri(y.URI.revive(I.resolvedUri),{sourceUri:y.URI.revive(I.sourceUri)},L)}}S.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https]),e.ExtHostUriOpeners=S}),define(Ce[235],Ie([1,0,5,2,6,12,25]),function(te,e,n,C,y,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.handles.has(S.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const w=P.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(I)),this.handlers.set(w,L),this._proxy.$registerUriHandler(w,I),(0,y.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(I)),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(I,L){const w=this.handlers.get(I);if(!w)return Promise.resolve(void 0);try{w.handleUri(C.URI.revive(L))}catch(f){(0,N.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(I){return C.URI.revive(await this._proxy.$createAppUri(I))}}P.HandlePool=0,e.ExtHostUrls=P});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[61],Ie([1,0,4,15,22,2,157,180,72,5]),function(te,e,n,C,y,N,S,P,_,I){"use strict";var L,w,f,E,m,a,o,u,g,b,R,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(A,W,J,j,O,B,T){L.set(this,void 0),w.set(this,void 0),f.set(this,void 0),E.set(this,void 0),m.set(this,void 0),a.set(this,void 0),o.set(this,""),u.set(this,void 0),g.set(this,!1),b.set(this,!1),R.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new n.Emitter),this._onDidDispose=Oe(this,t,"f").event,Je(this,L,A,"f"),Je(this,w,W,"f"),Je(this,u,J,"f"),Je(this,E,j,"f"),Je(this,m,O,"f"),Je(this,a,B,"f"),Je(this,R,r(B),"f"),Je(this,v,l(B),"f"),Je(this,f,T,"f")}dispose(){Je(this,g,!0,"f"),Oe(this,t,"f").fire(),Oe(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(A){return Je(this,b,!0,"f"),(0,_.asWebviewUri)(A,Oe(this,E,"f"))}get cspSource(){const A=Oe(this,a,"f").extensionLocation;if(A.scheme===C.Schemas.https||A.scheme===C.Schemas.http){let W=A.toString();return W.endsWith("/")||(W+="/"),W+" "+_.webviewGenericCspSource}return _.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,o,"f")}set html(A){this.assertNotDisposed(),Oe(this,o,"f")!==A&&(Je(this,o,A,"f"),Oe(this,v,"f")&&!Oe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(A)&&(Je(this,b,!0,"f"),Oe(this,f,"f").report("Webview vscode-resource: uris",Oe(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,w,"f").$setHtml(Oe(this,L,"f"),this.rewriteOldResourceUrlsIfNeeded(A)))}get options(){return this.assertNotDisposed(),Oe(this,u,"f")}set options(A){this.assertNotDisposed(),y.equals(Oe(this,u,"f"),A)||Oe(this,w,"f").$setOptions(Oe(this,L,"f"),c(Oe(this,a,"f"),Oe(this,m,"f"),A)),Je(this,u,A,"f")}async postMessage(A){if(Oe(this,g,"f"))return!1;const W=(0,P.serializeWebviewMessage)(A,{serializeBuffersForPostMessage:Oe(this,R,"f")});return Oe(this,w,"f").$postMessage(Oe(this,L,"f"),W.message,...W.buffers)}assertNotDisposed(){if(Oe(this,g,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(A){if(!Oe(this,v,"f"))return A;const W=Oe(this,a,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,J=Oe(this,a,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Oe(this,a,"f").extensionLocation.authority:void 0;return A.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,O,B,T,F,z)=>{const H=N.URI.from({scheme:T||"file",path:decodeURIComponent(F)}),de=(0,_.asWebviewUri)(H,{isRemote:W,authority:J}).toString();return`${O}${de}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,O,B,T,F,z)=>{const H=N.URI.from({scheme:T||"file",path:decodeURIComponent(F)}),de=(0,_.asWebviewUri)(H,{isRemote:W,authority:J}).toString();return`${O}${de}${z}`})}}e.ExtHostWebview=h,L=new WeakMap,w=new WeakMap,f=new WeakMap,E=new WeakMap,m=new WeakMap,a=new WeakMap,o=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,R=new WeakMap,v=new WeakMap,t=new WeakMap;function r(k){try{const A=(0,S.normalizeVersion)((0,S.parseVersion)(k.engines.vscode));return!!A&&A.majorBase>=1&&A.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function l(k){try{const A=(0,S.normalizeVersion)((0,S.parseVersion)(k.engines.vscode));return A?A.majorBase<1||A.majorBase===1&&A.minorBase<60:!1}catch{return!1}}class i{constructor(A,W,J,j,O){this.remoteInfo=W,this.workspace=J,this._logService=j,this._deprecationService=O,this._webviews=new Map,this._webviewProxy=A.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(A,W,J){const j=this.getWebview(A);if(j){const{message:O}=(0,P.deserializeWebviewMessage)(W,J.value);j._onMessageEmitter.fire(O)}}$onMissingCsp(A,W){this._logService.warn(`${W} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(A,W,J){const j=new h(A,this._webviewProxy,s(W),this.remoteInfo,this.workspace,J,this._deprecationService);return this._webviews.set(A,j),j._onDidDispose(()=>{this._webviews.delete(A)}),j}deleteWebview(A){this._webviews.delete(A)}getWebview(A){return this._webviews.get(A)}}e.ExtHostWebviews=i;function p(k){return{id:k.identifier,location:k.extensionLocation}}e.toExtensionData=p;function c(k,A,W){return{enableCommandUris:W.enableCommandUris,enableScripts:W.enableScripts,enableForms:W.enableForms,portMapping:W.portMapping,localResourceRoots:W.localResourceRoots||d(k,A)}}e.serializeWebviewOptions=c;function s(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(A=>N.URI.from(A))}}function d(k,A){return[...(A?.getWorkspaceFolders()||[]).map(W=>W.uri),k.extensionLocation]}}),define(Ce[236],Ie([1,0,20,231,6,15,24,2,8,61,54,5,7]),function(te,e,n,C,y,N,S,P,_,I,L,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(h,r){this.document=h,this._storagePath=r,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(h){return this._edits.add([h])}async undo(h,r){await this.getEdit(h).undo(),r||this.disposeBackup()}async redo(h,r){await this.getEdit(h).redo(),r||this.disposeBackup()}disposeEdits(h){for(const r of h)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const h=v(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,h)}updateBackup(h){this._backup?.delete(),this._backup=h}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(h){const r=this._edits.get(h,0);if(!r)throw new Error("No edit found");return r}}class m{constructor(){this._documents=new Map}get(h,r){return this._documents.get(this.key(h,r))}add(h,r,l){const i=this.key(h,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${h} resource:${r.uri}`);const p=new E(r,l);return this._documents.set(i,p),p}delete(h,r){const l=this.key(h,r.uri);this._documents.delete(l)}key(h,r){return`${h}@@@${r}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class o{constructor(){this._providers=new Map}addTextProvider(h,r,l){return this.add(0,h,r,l)}addCustomProvider(h,r,l){return this.add(1,h,r,l)}get(h){return this._providers.get(h)}add(h,r,l,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:h,extension:l,provider:i}),new f.Disposable(()=>this._providers.delete(r))}}class u{constructor(h,r,l,i,p){this._extHostDocuments=r,this._extensionStoragePaths=l,this._extHostWebview=i,this._extHostWebviewPanels=p,this._editorProviders=new o,this._documents=new m,this._proxy=h.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(h,r,l,i){const p=new y.DisposableStore;return b(l)?(p.add(this._editorProviders.addTextProvider(r,h,l)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(h),r,i.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(h))):(p.add(this._editorProviders.addCustomProvider(r,h,l)),g(l)&&p.add(l.onDidChangeCustomDocument(c=>{const s=this.getCustomDocumentEntry(r,c.document.uri);if(R(c)){const d=s.addEdit(c);this._proxy.$onDidEdit(c.document.uri,r,d,c.label)}else this._proxy.$onContentChange(c.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(h),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(h))),f.Disposable.from(p,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(h,r,l,i,p){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${r}'`);const s=P.URI.revive(h),d=await c.provider.openCustomDocument(s,{backupId:l,untitledDocumentData:i?.buffer},p);let k;return g(c.provider)&&this._extensionStoragePaths&&(k=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(r,d,k),{editable:g(c.provider)}}async $disposeCustomDocument(h,r){const l=this._editorProviders.get(r);if(!l)throw new Error(`No provider found for '${r}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=P.URI.revive(h),{document:p}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,p),p.dispose()}async $resolveCustomEditor(h,r,l,i,p,c){const s=this._editorProviders.get(l);if(!s)throw new Error(`No provider found for '${l}'`);const d=_.ViewColumn.to(p),k=this._extHostWebview.createNewWebview(r,i.contentOptions,s.extension),A=this._extHostWebviewPanels.createNewWebviewPanel(r,l,i.title,d,i.options,k,!0),W=P.URI.revive(h);switch(s.type){case 1:{const{document:J}=this.getCustomDocumentEntry(l,W);return s.provider.resolveCustomEditor(J,A,c)}case 0:{const J=this._extHostDocuments.getDocument(W);return s.provider.resolveCustomTextEditor(J,A,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,r,l){this.getCustomDocumentEntry(r,h).disposeEdits(l)}async $onMoveCustomEditor(h,r,l){const i=this._editorProviders.get(l);if(!i)throw new Error(`No provider found for '${l}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const p=this._extHostWebviewPanels.getWebviewPanel(h);if(!p)throw new Error("No webview found");const c=P.URI.revive(r),s=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(s,p,n.CancellationToken.None)}async $undo(h,r,l,i){return this.getCustomDocumentEntry(r,h).undo(l,i)}async $redo(h,r,l,i){return this.getCustomDocumentEntry(r,h).redo(l,i)}async $revert(h,r,l){const i=this.getCustomDocumentEntry(r,h);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,l),i.disposeBackup()}async $onSave(h,r,l){const i=this.getCustomDocumentEntry(r,h);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,l),i.disposeBackup()}async $onSaveAs(h,r,l,i){const p=this.getCustomDocumentEntry(r,h);return this.getCustomEditorProvider(r).saveCustomDocumentAs(p.document,P.URI.revive(l),i)}async $backup(h,r,l){const i=this.getCustomDocumentEntry(r,h),c=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},l);return i.updateBackup(c),c.id}getCustomDocumentEntry(h,r){const l=this._documents.get(h,P.URI.revive(r));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(h){const l=this._editorProviders.get(h)?.provider;if(!l||!g(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=u;function g(t){return!!t.onDidChangeCustomDocument}function b(t){return typeof t.resolveCustomTextEditor=="function"}function R(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function v(t){const h=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,C.hash)(h)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[237],Ie([1,0,4,6,2,34,8,61,5,7]),function(te,e,n,C,y,N,S,P,_,I){"use strict";var L,w,f,E,m,a,o,u,g,b,R,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends C.Disposable{constructor(p,c,s,d){super(),L.set(this,void 0),w.set(this,void 0),f.set(this,void 0),E.set(this,void 0),m.set(this,void 0),a.set(this,void 0),o.set(this,void 0),u.set(this,void 0),g.set(this,!0),b.set(this,void 0),R.set(this,!1),v.set(this,this._register(new n.Emitter)),this.onDidDispose=Oe(this,v,"f").event,t.set(this,this._register(new n.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,L,p,"f"),Je(this,w,c,"f"),Je(this,E,s,"f"),Je(this,f,d.viewType,"f"),Je(this,m,d.panelOptions,"f"),Je(this,u,d.viewColumn,"f"),Je(this,a,d.title,"f"),Je(this,b,d.active,"f")}dispose(){Oe(this,R,"f")||(Je(this,R,!0,"f"),Oe(this,v,"f").fire(),Oe(this,w,"f").$disposeWebview(Oe(this,L,"f")),Oe(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,E,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,f,"f")}get title(){return this.assertNotDisposed(),Oe(this,a,"f")}set title(p){this.assertNotDisposed(),Oe(this,a,"f")!==p&&(Je(this,a,p,"f"),Oe(this,w,"f").$setTitle(Oe(this,L,"f"),p))}get iconPath(){return this.assertNotDisposed(),Oe(this,o,"f")}set iconPath(p){this.assertNotDisposed(),Oe(this,o,"f")!==p&&(Je(this,o,p,"f"),Oe(this,w,"f").$setIconPath(Oe(this,L,"f"),y.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Oe(this,m,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,u,"f")=="number"&&Oe(this,u,"f")<0))return Oe(this,u,"f")}get active(){return this.assertNotDisposed(),Oe(this,b,"f")}get visible(){return this.assertNotDisposed(),Oe(this,g,"f")}_updateViewState(p){Oe(this,R,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(Je(this,b,p.active,"f"),Je(this,g,p.visible,"f"),Je(this,u,p.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(p,c){this.assertNotDisposed(),Oe(this,w,"f").$reveal(Oe(this,L,"f"),{viewColumn:typeof p>"u"?void 0:S.ViewColumn.from(p),preserveFocus:!!c})}assertNotDisposed(){if(Oe(this,R,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,w=new WeakMap,f=new WeakMap,E=new WeakMap,m=new WeakMap,a=new WeakMap,o=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,R=new WeakMap,v=new WeakMap,t=new WeakMap;class r{static newHandle(){return(0,N.generateUuid)()}constructor(p,c,s){this.webviews=c,this.workspace=s,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(_.MainContext.MainThreadWebviewPanels)}createWebviewPanel(p,c,s,d,k={}){const A=typeof d=="object"?d.viewColumn:d,W={viewColumn:S.ViewColumn.from(A),preserveFocus:typeof d=="object"&&!!d.preserveFocus},J=(0,P.shouldSerializeBuffersForPostMessage)(p),j=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(p),j,c,{title:s,panelOptions:l(k),webviewOptions:(0,P.serializeWebviewOptions)(p,this.workspace,k),serializeBuffersForPostMessage:J},W);const O=this.webviews.createNewWebview(j,k,p);return this.createNewWebviewPanel(j,c,s,A,k,O,!0)}$onDidChangeWebviewPanelViewStates(p){const c=Object.keys(p);c.sort((s,d)=>{const k=p[s],A=p[d];return k.active?1:A.active?-1:+k.visible-+A.visible});for(const s of c){const d=this.getWebviewPanel(s);if(!d)continue;const k=p[s];d._updateViewState({active:k.active,visible:k.visible,viewColumn:S.ViewColumn.to(k.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,c,s){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:s,extension:p}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(p)}),new I.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(p,c,s,d){const k=this._serializers.get(c);if(!k)throw new Error(`No serializer found for '${c}'`);const{serializer:A,extension:W}=k,J=this.webviews.createNewWebview(p,s.webviewOptions,W),j=this.createNewWebviewPanel(p,c,s.title,d,s.panelOptions,J,s.active);await A.deserializeWebviewPanel(j,s.state)}createNewWebviewPanel(p,c,s,d,k,A,W){const J=new h(p,this._proxy,A,{viewType:c,title:s,viewColumn:d,panelOptions:k,active:W});return this._webviewPanels.set(p,J),J}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=r;function l(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[238],Ie([1,0,4,6,61,8,5,7]),function(te,e,n,C,y,N,S,P){"use strict";var _,I,L,w,f,E,m,a,o,u,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends C.Disposable{constructor(t,h,r,l,i,p){super(),_.set(this,void 0),I.set(this,void 0),L.set(this,void 0),w.set(this,void 0),f.set(this,!1),E.set(this,void 0),m.set(this,void 0),a.set(this,void 0),o.set(this,void 0),u.set(this,this._register(new n.Emitter)),this.onDidChangeVisibility=Oe(this,u,"f").event,g.set(this,this._register(new n.Emitter)),this.onDidDispose=Oe(this,g,"f").event,Je(this,L,r,"f"),Je(this,m,l,"f"),Je(this,_,t,"f"),Je(this,I,h,"f"),Je(this,w,i,"f"),Je(this,E,p,"f")}dispose(){Oe(this,f,"f")||(Je(this,f,!0,"f"),Oe(this,g,"f").fire(),Oe(this,w,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,m,"f")}set title(t){this.assertNotDisposed(),Oe(this,m,"f")!==t&&(Je(this,m,t,"f"),Oe(this,I,"f").$setWebviewViewTitle(Oe(this,_,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(t){this.assertNotDisposed(),Oe(this,a,"f")!==t&&(Je(this,a,t,"f"),Oe(this,I,"f").$setWebviewViewDescription(Oe(this,_,"f"),t))}get visible(){return Oe(this,E,"f")}get webview(){return Oe(this,w,"f")}get viewType(){return Oe(this,L,"f")}_setVisible(t){t===Oe(this,E,"f")||Oe(this,f,"f")||(Je(this,E,t,"f"),Oe(this,u,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,o,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,o,"f")?.value&&t?.tooltip===Oe(this,o,"f")?.tooltip)&&(Je(this,o,N.ViewBadge.from(t),"f"),Oe(this,I,"f").$setWebviewViewBadge(Oe(this,_,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,I,"f").$show(Oe(this,_,"f"),!!t)}assertNotDisposed(){if(Oe(this,f,"f"))throw new Error("Webview is disposed")}}_=new WeakMap,I=new WeakMap,L=new WeakMap,w=new WeakMap,f=new WeakMap,E=new WeakMap,m=new WeakMap,a=new WeakMap,o=new WeakMap,u=new WeakMap,g=new WeakMap;class R{constructor(t,h){this._extHostWebview=h,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,h,r,l){if(this._viewProviders.has(h))throw new Error(`View provider for '${h}' already registered`);return this._viewProviders.set(h,{provider:r,extension:t}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(t),h,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._viewProviders.delete(h),this._proxy.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(t,h,r,l,i){const p=this._viewProviders.get(h);if(!p)throw new Error(`No view provider found for '${h}'`);const{provider:c,extension:s}=p,d=this._extHostWebview.createNewWebview(t,{},s),k=new b(t,this._proxy,h,r,d,!0);this._webviewViews.set(t,k),await c.resolveWebviewView(k,{state:l},i)}async $onDidChangeWebviewViewVisibility(t,h){this.getWebviewView(t)._setVisible(h)}async $disposeWebviewView(t){const h=this.getWebviewView(t);this._webviewViews.delete(t),h.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const h=this._webviewViews.get(t);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=R}),define(Ce[104],Ie([1,0,4,5,2,15,10,3,18]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class an{get state(){return this._state}constructor(w){this._onDidChangeWindowState=new n.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=an.InitialState,this._proxy=w.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(w){w!==this._state.focused&&(this._state={...this._state,focused:w},this._onDidChangeWindowState.fire(this._state))}openUri(w,f){let E;if(typeof w=="string"){E=w;try{w=y.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,S.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,E,f)}async asExternalUri(w,f){if((0,S.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(w,f);return y.URI.from(E)}};I.InitialState={focused:!0},I=Ve([He(0,_.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Ce[239],Ie([1,0,209,26,18]),function(te,e,n,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=class extends n.AbstractExtHostConsoleForwarder{constructor(P,_){super(P,_)}_nativeConsoleLogMessage(P,_,I){_.apply(console,I)}};N=Ve([He(0,y.IExtHostRpcService),He(1,C.IExtHostInitDataService)],N),e.ExtHostConsoleForwarder=N}),define(Ce[240],Ie([1,0,17,23,20,12,4,6,127,203,46]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(k,A){try{return JSON.stringify(k,A)}catch{return"null"}}const E="$$ref$$",m={[E]:-1};class a{constructor(A,W){this.jsonString=A,this.referencedBuffers=W}}function o(k,A=null,W=!1){const J=[];return{jsonString:(W?f:JSON.stringify)(k,(O,B)=>{if(typeof B>"u")return m;if(typeof B=="object"){if(B instanceof C.VSBuffer){const T=J.push(B)-1;return{[E]:T}}if(A)return A(O,B)}return B}),referencedBuffers:J}}e.stringifyJsonWithBufferRefs=o;function u(k,A,W){return JSON.parse(k,(J,j)=>{if(j){const O=j[E];if(typeof O=="number")return A[O];if(W&&j.$mid===1)return W.transformIncoming(j)}return j})}e.parseJsonAndRestoreBufferRefs=u;function g(k,A){return JSON.stringify(k,A)}function b(k){return k?(A,W)=>W&&W.$mid===1?k.transformOutgoing(W):W:null}var R;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(R=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},h=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class l extends P.Disposable{constructor(A,W=null,J=null){super(),this[w]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=W,this._uriTransformer=J,this._uriReplacer=b(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let j=0,O=L.ProxyIdentifier.count;j<O;j++)this._locals[j]=null,this._proxies[j]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new n.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(j=>this._receiveOneMessage(j))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(N.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,_.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:W,sid:J}=A;return this._proxies[W]||(this._proxies[W]=this._createProxy(W,J)),this._proxies[W]}_createProxy(A,W){const J={get:(j,O)=>(typeof O=="string"&&!j[O]&&O.charCodeAt(0)===36&&(j[O]=(...B)=>this._remoteCall(A,O,B)),O===r?W:j[O])};return new Proxy(Object.create(null),J)}set(A,W){return this._locals[A.nid]=W,W}assertRegistered(A){for(let W=0,J=A.length;W<J;W++){const j=A[W];if(!this._locals[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}_receiveOneMessage(A){if(this._isDisposed)return;const W=A.byteLength,J=i.read(A,0),j=J.readUInt8(),O=J.readUInt32();switch(j){case 1:case 2:{let{rpcId:B,method:T,args:F}=c.deserializeRequestJSONArgs(J);this._uriTransformer&&(F=(0,_.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(W,O,B,T,F,j===2);break}case 3:case 4:{let{rpcId:B,method:T,args:F}=c.deserializeRequestMixedArgs(J);this._uriTransformer&&(F=(0,_.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(W,O,B,T,F,j===4);break}case 5:{this._logger?.logIncoming(W,O,0,"ack"),this._onDidReceiveAcknowledge(O);break}case 6:{this._receiveCancel(W,O);break}case 7:{this._receiveReply(W,O,void 0);break}case 9:{let B=c.deserializeReplyOKJSON(J);this._uriTransformer&&(B=(0,_.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(W,O,B);break}case 10:{const B=c.deserializeReplyOKJSONWithBuffers(J,this._uriTransformer);this._receiveReply(W,O,B);break}case 8:{const B=c.deserializeReplyOKVSBuffer(J);this._receiveReply(W,O,B);break}case 11:{let B=c.deserializeReplyErrError(J);this._uriTransformer&&(B=(0,_.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(W,O,B);break}case 12:{this._receiveReplyErr(W,O,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,W,J,j,O,B){this._logger?.logIncoming(A,W,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(J)}.${j}(`,O);const T=String(W);let F,z;if(B){const de=new y.CancellationTokenSource;O.push(de.token),F=this._invokeHandler(J,j,O),z=()=>de.cancel()}else F=this._invokeHandler(J,j,O),z=t;this._cancelInvokedHandlers[T]=z;const H=c.serializeAcknowledged(W);this._logger?.logOutgoing(H.byteLength,W,1,"ack"),this._protocol.send(H),F.then(de=>{delete this._cancelInvokedHandlers[T];const pe=c.serializeReplyOK(W,de,this._uriReplacer);this._logger?.logOutgoing(pe.byteLength,W,1,"reply:",de),this._protocol.send(pe)},de=>{delete this._cancelInvokedHandlers[T];const pe=c.serializeReplyErr(W,de);this._logger?.logOutgoing(pe.byteLength,W,1,"replyErr:",de),this._protocol.send(pe)})}_receiveCancel(A,W){this._logger?.logIncoming(A,W,1,"receiveCancel");const J=String(W);this._cancelInvokedHandlers[J]?.()}_receiveReply(A,W,J){this._logger?.logIncoming(A,W,0,"receiveReply:",J);const j=String(W);if(!this._pendingRPCReplies.hasOwnProperty(j))return;const O=this._pendingRPCReplies[j];delete this._pendingRPCReplies[j],O.resolveOk(J)}_receiveReplyErr(A,W,J){this._logger?.logIncoming(A,W,0,"receiveReplyErr:",J);const j=String(W);if(!this._pendingRPCReplies.hasOwnProperty(j))return;const O=this._pendingRPCReplies[j];delete this._pendingRPCReplies[j];let B;J&&(J.$isError?(B=new Error,B.name=J.name,B.message=J.message,B.stack=J.stack):B=J),O.resolveErr(B)}_invokeHandler(A,W,J){try{return Promise.resolve(this._doInvokeHandler(A,W,J))}catch(j){return Promise.reject(j)}}_doInvokeHandler(A,W,J){const j=this._locals[A];if(!j)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(A));const O=j[W];if(typeof O!="function")throw new Error("Unknown method "+W+" on actor "+(0,L.getStringIdentifierForProxy)(A));return O.apply(j,J)}_remoteCall(A,W,J){if(this._isDisposed)return new I.CanceledLazyPromise;let j=null;if(J.length>0&&y.CancellationToken.isCancellationToken(J[J.length-1])&&(j=J.pop()),j&&j.isCancellationRequested)return Promise.reject(N.canceled());const O=c.serializeRequestArguments(J,this._uriReplacer),B=++this._lastMessageId,T=String(B),F=new I.LazyPromise;j&&j.onCancellationRequested(()=>{const H=c.serializeCancel(B);this._logger?.logOutgoing(H.byteLength,B,0,"cancel"),this._protocol.send(c.serializeCancel(B))}),this._pendingRPCReplies[T]=F,this._onWillSendRequest(B);const z=c.serializeRequest(B,A,W,O,!!j);return this._logger?.logOutgoing(z.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(A)}.${W}(`,J),this._protocol.send(z),F}}w=h,l.UNRESPONSIVE_TIME=3*1e3,e.RPCProtocol=l;class i{static alloc(A,W,J){const j=new i(C.VSBuffer.alloc(J+1+4),0);return j.writeUInt8(A),j.writeUInt32(W),j}static read(A,W){return new i(A,W)}get buffer(){return this._buff}constructor(A,W){this._buff=A,this._offset=W}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const J=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,J}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const J=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,J}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,W}static sizeMixedArray(A){let W=0;W+=1;for(let J=0,j=A.length;J<j;J++){const O=A[J];switch(W+=1,O.type){case 1:W+=this.sizeLongString(O.value);break;case 2:W+=this.sizeVSBuffer(O.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(O.value);for(let B=0;B<O.buffers.length;++B)W+=this.sizeVSBuffer(O.buffers[B]);break;case 4:break}}return W}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let W=0,J=A.length;W<J;W++){const j=A[W];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let O=0;O<j.buffers.length;++O)this.writeBuffer(j.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const W=new Array(A);for(let J=0;J<A;J++)switch(this.readUInt8()){case 1:W[J]=this.readLongString();break;case 2:W[J]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),B=this.readLongString(),T=[];for(let F=0;F<O;++F)T.push(this.readVSBuffer());W[J]=new L.SerializableObjectWithBuffers(u(B,T,null));break}case 4:W[J]=void 0;break}return W}}i.sizeUInt32=4;var p;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(p||(p={}));class c{static _useMixedArgSerialization(A){for(let W=0,J=A.length;W<J;W++)if(A[W]instanceof C.VSBuffer||A[W]instanceof L.SerializableObjectWithBuffers||typeof A[W]>"u")return!0;return!1}static serializeRequestArguments(A,W){if(this._useMixedArgSerialization(A)){const J=[];for(let j=0,O=A.length;j<O;j++){const B=A[j];if(B instanceof C.VSBuffer)J[j]={type:2,value:B};else if(typeof B>"u")J[j]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:T,referencedBuffers:F}=o(B.value,W);J[j]={type:3,value:C.VSBuffer.fromString(T),buffers:F}}else J[j]={type:1,value:C.VSBuffer.fromString(g(B,W))}}return{type:1,args:J}}return{type:0,args:g(A,W)}}static serializeRequest(A,W,J,j,O){switch(j.type){case 0:return this._requestJSONArgs(A,W,J,j.args,O);case 1:return this._requestMixedArgs(A,W,J,j.args,O)}}static _requestJSONArgs(A,W,J,j,O){const B=C.VSBuffer.fromString(J),T=C.VSBuffer.fromString(j);let F=0;F+=i.sizeUInt8(),F+=i.sizeShortString(B),F+=i.sizeLongString(T);const z=i.alloc(O?2:1,A,F);return z.writeUInt8(W),z.writeShortString(B),z.writeLongString(T),z.buffer}static deserializeRequestJSONArgs(A){const W=A.readUInt8(),J=A.readShortString(),j=A.readLongString();return{rpcId:W,method:J,args:JSON.parse(j)}}static _requestMixedArgs(A,W,J,j,O){const B=C.VSBuffer.fromString(J);let T=0;T+=i.sizeUInt8(),T+=i.sizeShortString(B),T+=i.sizeMixedArray(j);const F=i.alloc(O?4:3,A,T);return F.writeUInt8(W),F.writeShortString(B),F.writeMixedArray(j),F.buffer}static deserializeRequestMixedArgs(A){const W=A.readUInt8(),J=A.readShortString(),j=A.readMixedArray(),O=new Array(j.length);for(let B=0,T=j.length;B<T;B++){const F=j[B];typeof F=="string"?O[B]=JSON.parse(F):O[B]=F}return{rpcId:W,method:J,args:O}}static serializeAcknowledged(A){return i.alloc(5,A,0).buffer}static serializeCancel(A){return i.alloc(6,A,0).buffer}static serializeReplyOK(A,W,J){if(typeof W>"u")return this._serializeReplyOKEmpty(A);if(W instanceof C.VSBuffer)return this._serializeReplyOKVSBuffer(A,W);if(W instanceof L.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:O}=o(W.value,J,!0);return this._serializeReplyOKJSONWithBuffers(A,j,O)}else return this._serializeReplyOKJSON(A,f(W,J))}static _serializeReplyOKEmpty(A){return i.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,W){let J=0;J+=i.sizeVSBuffer(W);const j=i.alloc(8,A,J);return j.writeVSBuffer(W),j.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,W){const J=C.VSBuffer.fromString(W);let j=0;j+=i.sizeLongString(J);const O=i.alloc(9,A,j);return O.writeLongString(J),O.buffer}static _serializeReplyOKJSONWithBuffers(A,W,J){const j=C.VSBuffer.fromString(W);let O=0;O+=i.sizeUInt32,O+=i.sizeLongString(j);for(const T of J)O+=i.sizeVSBuffer(T);const B=i.alloc(10,A,O);B.writeUInt32(J.length),B.writeLongString(j);for(const T of J)B.writeBuffer(T);return B.buffer}static deserializeReplyOKJSON(A){const W=A.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(A,W){const J=A.readUInt32(),j=A.readLongString(),O=[];for(let B=0;B<J;++B)O.push(A.readVSBuffer());return new L.SerializableObjectWithBuffers(u(j,O,W))}static serializeReplyErr(A,W){const J=W?f(N.transformErrorForSerialization(W),null):void 0;if(typeof J!="string")return this._serializeReplyErrEmpty(A);const j=C.VSBuffer.fromString(J);let O=0;O+=i.sizeLongString(j);const B=i.alloc(11,A,O);return B.writeLongString(j),B.buffer}static deserializeReplyErrError(A){const W=A.readLongString();return JSON.parse(W)}static _serializeReplyErrEmpty(A){return i.alloc(12,A,0).buffer}}var s;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(s||(s={}));var d;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(d||(d={}))}),define(Ce[241],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(N){const S=P=>{self.removeEventListener("message",S);const _=P.data;Object.defineProperties(self,{postMessage:{value(I,L){_.postMessage(I,L)}},onmessage:{get(){return _.onmessage},set(I){_.onmessage=I}}}),_.addEventListener("message",I=>{self.dispatchEvent(new MessageEvent("message",{data:I.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};self.addEventListener("message",S)}.toString();class C extends EventTarget{constructor(N,S,P){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${n})('${S}'))`,I=new Blob([_],{type:"application/javascript"}),L=URL.createObjectURL(I),w=new MessageChannel,f=L,E={type:"_newWorker",id:f,port:w.port2,url:L,options:P};N(E,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{N({type:"_terminateWorker",id:f}),URL.revokeObjectURL(L),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(m){w.port1.onmessage=m}},onmessageerror:{get(){return w.port1.onmessageerror},set(m){w.port1.onmessageerror=m}}}),w.port1.addEventListener("messageerror",m=>{const a=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(a)}),w.port1.addEventListener("message",m=>{const a=new MessageEvent("message",{data:m.data});this.dispatchEvent(a)}),w.port1.start()}}e.NestedWorker=C}),define(Ce[242],Ie([1,0,4,30,42,3]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)(e.OUTPUT_SERVICE_ID);var S;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(S=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.channels=new Map,this._onDidRegisterChannel=new n.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new n.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(I){this.channels.has(I.id)||(this.channels.set(I.id,I),this._onDidRegisterChannel.fire(I.id))}getChannels(){const I=[];return this.channels.forEach(L=>I.push(L)),I}getChannel(I){return this.channels.get(I)}removeChannel(I){this.channels.delete(I),this._onDidRemoveChannel.fire(I)}}C.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(Ce[105],Ie([1,0,5,3,18,25,11,242,59,26,36,121,23,9,43,4,6]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends S.AbstractMessageLogger{get disposed(){return this._disposed}constructor(v,t,h,r,l){super(),this.id=v,this.name=t,this.logger=h,this.proxy=r,this.extension=l,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(h.getLevel()),this._register(h.onDidChangeLogLevel(i=>this.setLevel(i)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,v)}replace(v){const t=this.offset;this.info(v),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(v,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:t))}hide(){this.proxy.$close(this.id)}log(v,t){this.offset+=f.VSBuffer.fromString(t).byteLength,(0,S.log)(this.logger,v,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class g extends u{appendLine(v){this.append(v)}}let b=class{constructor(v,t,h,r,l,i){this.initData=t,this.extHostFileSystem=h,this.extHostFileSystemInfo=r,this.loggerService=l,this.logService=i,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(n.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[t,h]of this.channels)h.visible=t===this.visibleChannelId}createOutputChannel(v,t,h){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,l=(0,E.isString)(t)?t:void 0;if((0,E.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let i;const p=this.initData.environment.extensionLogLevel?.find(([s])=>N.ExtensionIdentifier.equals(h.identifier,s))?.[1];p&&(i=(0,S.parseLogLevel)(p));const c=r?this.doCreateLogOutputChannel(v,i,h):this.doCreateOutputChannel(v,l,h);return c.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(v,i??this.logService.getLevel(),c):this.createExtHostOutputChannel(v,c)}async doCreateOutputChannel(v,t,h){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,l=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=this.loggerService.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.proxy.$register(v,l,t,h.identifier.value);return new u(p,v,i,this.proxy,h)}async doCreateLogOutputChannel(v,t,h){const r=await this.createExtensionLogDirectory(h),l=this.extHostFileSystemInfo.extUri.joinPath(r,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=l.toString(),p=this.loggerService.createLogger(l,{id:i,name:v,logLevel:t,extensionId:h.identifier.value});return new g(i,v,p,this.proxy,h)}createExtensionLogDirectory(v){let t=this.extensionLogDirectoryPromise.get(v.identifier.value);if(!t){const h=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,v.identifier.value);this.extensionLogDirectoryPromise.set(v.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(h)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}return h})())}return t}createExtHostOutputChannel(v,t){let h=!1;const r=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return v},append(l){r(),t.then(i=>i.append(l))},appendLine(l){r(),t.then(i=>i.appendLine(l))},clear(){r(),t.then(l=>l.clear())},replace(l){r(),t.then(i=>i.replace(l))},show(l,i){r(),t.then(p=>p.show(l,i))},hide(){r(),t.then(l=>l.hide())},dispose(){h=!0,t.then(l=>l.dispose())}}}createExtHostLogOutputChannel(v,t,h){const r=new o.DisposableStore,l=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},i=r.add(new a.Emitter);function p(c){t=c,i.fire(c)}return h.then(c=>{r.add(c),c.logLevel!==t&&p(c.logLevel),r.add(c.onDidChangeLogLevel(s=>p(s)))}),{...this.createExtHostOutputChannel(v,h),get logLevel(){return t},onDidChangeLogLevel:i.event,trace(c,...s){l(),h.then(d=>d.trace(c,...s))},debug(c,...s){l(),h.then(d=>d.debug(c,...s))},info(c,...s){l(),h.then(d=>d.info(c,...s))},warn(c,...s){l(),h.then(d=>d.warn(c,...s))},error(c,...s){l(),h.then(d=>d.error(c,...s))},dispose(){r.dispose()}}}};b=Ve([He(0,y.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,_.IExtHostConsumerFileSystem),He(3,L.IExtHostFileSystemInfo),He(4,S.ILoggerService),He(5,S.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ce[243],Ie([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Ce[244],Ie([1,0,40,15,19,21,24,2,3,175,53,191,243]),function(te,e,n,C,y,N,S,P,_,I,L,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let E=class cn{constructor(a,o,u,g){this.localUserHome=a,this.remoteAgentService=o,this.environmentService=u,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||N.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome??a})()}hasValidBasename(a,o,u){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(g=>this.doHasValidBasename(a,g,o)):this.doHasValidBasename(a,o,u)}doHasValidBasename(a,o,u){return a.scheme===C.Schemas.file||a.scheme===C.Schemas.vscodeRemote?(0,n.isValidBasename)(u??(0,S.basename)(a),o===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,o){if(a.remoteAuthority)return C.Schemas.vscodeRemote;const u=(0,I.getVirtualWorkspaceScheme)(o.getWorkspace());if(u)return u;const g=o.getWorkspace().folders[0];if(g)return g.uri.scheme;const b=o.getWorkspace().configuration;return b?b.scheme:C.Schemas.file}userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===1?y.win32:y.posix)}async fileURI(a){let o="";if(await this.resolveOS===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const g=a.indexOf("/",2);g===-1?(o=a.substring(2),a="/"):(o=a.substring(2,g),a=a.substring(g)||"/")}return P.URI.from({scheme:C.Schemas.file,authority:o,path:a,query:"",fragment:""})}};E=Ve([He(1,f.IRemoteAgentService),He(2,w.IWorkbenchEnvironmentService),He(3,L.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(Ce[106],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(S,P){this.line=S,this.character=P}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,P){return new n(0,0)}with(S){return new n(0,0)}}e.Position=n;class C{constructor(S,P,_,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(S,P),this.end=new n(_,I)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new C(0,0,0,0)}with(S){return new C(0,0,0,0)}}e.Range=C;var y;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[47],Ie([1,0,16,35,22,40,10,3,19,12,106,17]),function(te,e,n,C,y,N,S,P,_,I,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",E=" characters skipped \u27EB",m=(f.length+E.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var a;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function u(le){return!!le.preview}e.resultIsMatch=u;function g(le){return!!le.resource}e.isFileMatch=g;function b(le){return!!le.message}e.isProgressMessage=b;var R;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(R=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ae){this.resource=ae,this.results=[]}}e.FileMatch=v;class t{constructor(ae,se,Q){this.ranges=se;const K=Array.isArray(se)?se:[se];if(Q&&Q.matchLines===1&&h(K)){ae=(0,S.getNLines)(ae,Q.matchLines);let Z="",he=0,ke=0;const Fe=Math.floor(Q.charsPerLine/5),je=[];for(const Te of K){const Se=Math.max(Te.startColumn-Fe,0),De=Te.startColumn+Q.charsPerLine;if(Se>ke+Fe+m){const oe=f+(Se-ke)+E;Z+=oe+ae.slice(Se,De),he+=Se-(ke+oe.length)}else Z+=ae.slice(ke,De);je.push(new l(0,Te.startColumn-he,Te.endColumn-he)),ke=De}this.preview={text:Z,matches:Array.isArray(this.ranges)?je:je[0]}}else{const Z=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ae,matches:(0,n.mapArrayOrNot)(se,he=>new r(he.startLineNumber-Z,he.startColumn,he.endLineNumber-Z,he.endColumn))}}}}e.TextSearchMatch=t;function h(le){const ae=le[0].startLineNumber;for(const se of le)if(se.startLineNumber!==ae||se.endLineNumber!==ae)return!1;return!0}class r{constructor(ae,se,Q,K){this.startLineNumber=ae,this.startColumn=se,this.endLineNumber=Q,this.endColumn=K}}e.SearchRange=r;class l extends r{constructor(ae,se,Q){super(ae,se,ae,Q)}}e.OneLineRange=l;var i;(function(le){le.List="list",le.Tree="tree"})(i=e.ViewMode||(e.ViewMode={}));var p;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function c(le,ae=!0){const se=le&&le.files&&le.files.exclude,Q=ae&&le&&le.search&&le.search.exclude;if(!se&&!Q)return;if(!se||!Q)return se||Q;let K=Object.create(null);return K=y.mixin(K,y.deepClone(se)),K=y.mixin(K,y.deepClone(Q),!0),K}e.getExcludes=c;function s(le,ae){return le.excludePattern&&C.match(le.excludePattern,ae)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&C.match(le.includePattern,ae)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(se=>{const Q=se.folder.fsPath;if(N.isEqualOrParent(ae,Q)){const K=_.relative(Q,ae);return!se.includePattern||!!C.match(se.includePattern,K)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var d;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class k extends Error{constructor(ae,se){super(ae),this.code=se}}e.SearchError=k;function A(le){const ae=le.message;if((0,I.isCancellationError)(le))return new k(ae,d.canceled);try{const se=JSON.parse(ae);return new k(se.message,se.code)}catch{return new k(ae,d.other)}}e.deserializeSearchError=A;function W(le){const ae={message:le.message,code:le.code};return new Error(JSON.stringify(ae))}e.serializeSearchError=W;function J(le){return le.type==="error"?!0:le.type==="success"}e.isSerializedSearchComplete=J;function j(le){return le.type==="success"}e.isSerializedSearchSuccess=j;function O(le){return!!le.path}e.isSerializedFileMatch=O;function B(le,ae){const se=le.searchPath?le.searchPath:le.relativePath;return(0,S.fuzzyContains)(se,ae)}e.isFilePatternMatch=B;class T{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=T;function F(le,ae){const se={...le||{},...ae||{}};return Object.keys(se).filter(Q=>{const K=se[Q];return typeof K=="boolean"&&K})}e.resolvePatternsForProvider=F;class z{constructor(ae,se){this._parsedIncludeExpression=null,this._excludeExpression={...ae.excludePattern||{},...se.excludePattern||{}},this._parsedExcludeExpression=C.parse(this._excludeExpression);let Q=ae.includePattern;se.includePattern&&(Q?Q={...Q,...se.includePattern}:Q=se.includePattern),Q&&(this._parsedIncludeExpression=C.parse(Q))}matchesExcludesSync(ae,se,Q){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ae,se,Q))}includedInQuerySync(ae,se,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ae,se,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ae,se,Q))}includedInQuery(ae,se,Q){const K=this._parsedExcludeExpression(ae,se,Q),Z=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ae,se,Q):!0;return(0,w.isThenable)(K)?K.then(he=>he?!1:Z()):Z()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=z;function H(le){for(const ae in le)if(typeof le[ae]!="boolean")return!0;return!1}function de(le){if(!le)return;let ae;return se=>(ae||(ae=(le()||Promise.resolve([])).then(Q=>Q?re(Q):{})),ae.then(Q=>!!Q[se]))}e.hasSiblingPromiseFn=de;function pe(le){if(!le)return;let ae;return se=>{if(!ae){const Q=le();ae=Q?re(Q):{}}return!!ae[se]}}e.hasSiblingFn=pe;function re(le){const ae={};for(const se of le)ae[se]=!0;return ae}}),define(Ce[31],Ie([1,0,16,17,20,4,6,48,15,113,24,10,9,2,146,3,11,163,53,36,26,18,8,7,55,47,5]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R,v,t,h,r,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function p(j,O,B){return new L.ExtUri(T=>k(T,B)).isEqual(j,O)}function c(j,O,B){return p(j.uri,O.uri,B)?0:(0,w.compare)(j.uri.toString(),O.uri.toString())}function s(j,O,B){return j.index!==O.index?j.index<O.index?-1:1:p(j.uri,O.uri,B)?(0,w.compare)(j.name,O.name):(0,w.compare)(j.uri.toString(),O.uri.toString())}function d(j,O,B,T){const F=j.slice(0).sort((H,de)=>B(H,de,T)),z=O.slice(0).sort((H,de)=>B(H,de,T));return(0,n.delta)(F,z,(H,de)=>B(H,de,T))}function k(j,O){const B=O.getCapabilities(j.scheme);return!(B&&B&1024)}class A extends g.Workspace{static toExtHostWorkspace(O,B,T,F){if(!O)return{workspace:null,added:[],removed:[]};const{id:z,name:H,folders:de,configuration:pe,transient:re,isUntitled:le}=O,ae=[],se=B;B?de.forEach((he,ke)=>{const Fe=E.URI.revive(he.uri),je=A._findFolder(T||B,Fe,F);je?(je.name=he.name,je.index=he.index,ae.push(je)):ae.push({uri:Fe,name:he.name,index:ke})}):ae.push(...de.map(({uri:he,name:ke,index:Fe})=>({uri:E.URI.revive(he),name:ke,index:Fe}))),ae.sort((he,ke)=>he.index<ke.index?-1:1);const Q=new A(z,H,ae,!!re,pe?E.URI.revive(pe):null,!!le,he=>k(he,F)),{added:K,removed:Z}=d(se?se.workspaceFolders:[],Q.workspaceFolders,c,F);return{workspace:Q,added:K,removed:Z}}static _findFolder(O,B,T){for(let F=0;F<O.folders.length;F++){const z=O.workspaceFolders[F];if(p(z.uri,B,T))return z}}constructor(O,B,T,F,z,H,de){super(O,T.map(pe=>new g.WorkspaceFolder(pe)),F,z,de),this._name=B,this._isUntitled=H,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(de),T.forEach(pe=>{this._workspaceFolders.push(pe),this._structure.set(pe.uri,pe)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,B){return B&&this._structure.get(O)&&(O=(0,L.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let W=class{constructor(O,B,T,F,z){this._onDidChangeWorkspace=new N.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new N.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new N.AsyncEmitter,this._logService=F,this._extHostFileSystemInfo=T,this._uriTransformerService=z,this._requestIdProvider=new I.Counter,this._barrier=new C.Barrier,this._proxy=O.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(i.MainContext.MainThreadMessageService);const H=B.workspace;this._confirmedWorkspace=H?new A(H.id,H.name,[],!!H.transient,H.configuration?E.URI.revive(H.configuration):null,!!H.isUntitled,de=>k(de,T)):void 0}$initializeWorkspace(O,B){this._trusted=B,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?E.URI.from({scheme:_.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,B,T,...F){const z=[];if(Array.isArray(F)&&F.forEach(le=>{E.URI.isUri(le.uri)&&!z.some(ae=>p(ae.uri,le.uri,this._extHostFileSystemInfo))&&z.push({uri:le.uri,name:le.name||(0,L.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[B,T].some(le=>typeof le!="number"||le<0)||T===0&&z.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+T>H.length)return!1;const de=H.slice(0);de.splice(B,T,...z.map(le=>({uri:le.uri,name:le.name||(0,L.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<de.length;le++){const ae=de[le];if(de.some((se,Q)=>Q!==le&&p(ae.uri,se.uri,this._extHostFileSystemInfo)))return!1}de.forEach((le,ae)=>le.index=ae);const{added:pe,removed:re}=d(H,de,s,this._extHostFileSystemInfo);if(pe.length===0&&re.length===0)return!1;if(this._proxy){const le=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(le,B,T,z).then(void 0,ae=>{this._unconfirmedWorkspace=void 0;const se={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(u.Severity.Error,(0,m.localize)(0,null,le,ae.toString()),se,[])})}return this.trySetWorkspaceFolders(de),!0}getWorkspaceFolder(O,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,B)}async getWorkspaceFolder2(O,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,B)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,B){let T,F="";if(typeof O=="string"?(T=E.URI.file(O),F=O):typeof O<"u"&&(T=O,F=O.fsPath),!T)return F;const z=this.getWorkspaceFolder(T,!0);if(!z)return F;typeof B>"u"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let H=(0,L.relativePath)(z.uri,T);return B&&z.name&&(H=`${z.name}/${H}`),H}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=A.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:B,added:T,removed:F}=A.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:T,removed:F}))}findFiles(O,B,T,F,z=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let H;if(B===null?H=!1:B&&(typeof B=="string"?H=B:H=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:pe}=J(t.GlobPattern.from(O));return this._proxy.$startFileSearch((0,f.withUndefinedAsNull)(de),(0,f.withUndefinedAsNull)(pe),(0,f.withUndefinedAsNull)(H),(0,f.withUndefinedAsNull)(T),z).then(re=>Array.isArray(re)?re.map(le=>E.URI.revive(le)):[])}async findTextInFiles(O,B,T,F,z=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),de=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:pe,folder:re}=J(t.GlobPattern.from(B.include)),le=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ae={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:de,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:pe,excludePattern:le},se=!1;if(this._activeSearchCallbacks[H]=Q=>{if(se)return;const K=E.URI.revive(Q.resource);Q.results.forEach(Z=>{(0,l.resultIsMatch)(Z)?T({uri:K,preview:{text:Z.preview.text,matches:(0,n.mapArrayOrNot)(Z.preview.matches,he=>new h.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,n.mapArrayOrNot)(Z.ranges,he=>new h.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):T({uri:K,text:Z.text,lineNumber:Z.lineNumber})})},z.isCancellationRequested)return{};try{const Q=await this._proxy.$startTextSearch(O,(0,f.withUndefinedAsNull)(re),ae,H,z);return delete this._activeSearchCallbacks[H],Q||{}}catch(Q){throw delete this._activeSearchCallbacks[H],Q}}$handleTextSearchResult(O,B){this._activeSearchCallbacks[B]?.(O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(O,B){if(this._editSessionIdentityProviders.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this._editSessionIdentityProviders.set(O,B);const T=this._uriTransformerService.transformOutgoingScheme(O),F=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(F,T),(0,S.toDisposable)(()=>{this._editSessionIdentityProviders.delete(O),this._proxy.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(O,B){this._logService.info("Getting edit session identifier for workspaceFolder",O);const T=await this.resolveWorkspaceFolder(E.URI.revive(O));if(!T){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const F=this._editSessionIdentityProviders.get(T.uri.scheme);if(this._logService.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!F),!F)return;const z=await F.provideEditSessionIdentity(T,B);if(this._logService.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(O,B,T,F){this._logService.info("Getting edit session identifier for workspaceFolder",O);const z=await this.resolveWorkspaceFolder(E.URI.revive(O));if(!z){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const H=this._editSessionIdentityProviders.get(z.uri.scheme);if(this._logService.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!H),!H)return;const de=await H.provideEditSessionIdentityMatch?.(B,T,F);if(this._logService.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(O){return(B,T,F)=>{const z=function(de){B.call(T,de)};return z.extension=O,this._onWillCreateEditSessionIdentityEvent.event(z,void 0,F)}}async $onWillCreateEditSessionIdentity(O,B,T){const F=await this.resolveWorkspaceFolder(E.URI.revive(O));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:F},B,async(z,H)=>{const de=Date.now();await Promise.resolve(z),Date.now()-de>T&&this._logService.warn("SLOW edit session create-participant",H.extension.identifier)}),B.isCancellationRequested}};W=Ve([He(0,v.IExtHostRpcService),He(1,R.IExtHostInitDataService),He(2,b.IExtHostFileSystemInfo),He(3,o.ILogService),He(4,r.IURITransformerService)],W),e.ExtHostWorkspace=W,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function J(j){let O,B;return j&&(typeof j=="string"?O=j:(O=j.pattern,B=E.URI.revive(j.baseUri))),{includePattern:O,folder:B}}}),define(Ce[32],Ie([1,0,22,4,31,5,7,166,93,9,17,3,18,11,2]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(h,r){if(r){const l=r.split(".");let i=h;for(let p=0;i&&p<l.length;p++)i=i[l[p]];return i}}function o(h){return h instanceof m.URI}function u(h){return h&&h.uri instanceof m.URI&&h.languageId&&typeof h.languageId=="string"}function g(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function b(h){return h&&h.uri instanceof m.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function R(h){if(o(h))return{resource:h};if(u(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(g(h))return{overrideIdentifier:h.languageId};if(b(h))return{resource:h.uri};if(h===null)return{resource:null}}let v=class{constructor(r,l,i){this._proxy=r.getProxy(N.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=i,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,l){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(r,l))}};v=Ve([He(0,f.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,E.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(r,l,i,p){this._onDidChangeConfiguration=new C.Emitter,this._proxy=r,this._logService=p,this._extHostWorkspace=l,this._configuration=P.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,l){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,i))}getConfiguration(r,l,i){const p=R(l)||{},c=this._toReadonlyValue(r?a(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,p,i?.identifier);function s(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case S.ConfigurationTarget.Global:return 2;case S.ConfigurationTarget.Workspace:return 5;case S.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(k){return typeof a(c,k)<"u"},get:(k,A)=>{this._validateConfigurationAccess(r?`${r}.${k}`:k,p,i?.identifier);let W=a(c,k);if(typeof W>"u")W=A;else{let J;const j=(O,B)=>{let T;const F=()=>{J=J||(0,n.deepClone)(c),T=T||a(J,B)};return(0,I.isObject)(O)?new Proxy(O,{get:(z,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return F(),()=>T;if(J)return T=T||a(J,B),T[H];const de=z[H];return typeof H=="string"?j(de,`${B}.${H}`):de},set:(z,H,de)=>(F(),T&&(T[H]=de),!0),deleteProperty:(z,H)=>(F(),T&&delete T[H],!0),defineProperty:(z,H,de)=>(F(),T&&Object.defineProperty(T,H,de),!0)}):O};W=j(W,k)}return W},update:(k,A,W,J)=>{k=r?`${r}.${k}`:k;const j=s(W);return A!==void 0?this._proxy.$updateConfigurationOption(j,k,A,p,J):this._proxy.$removeConfigurationOption(j,k,p,J)},inspect:k=>{k=r?`${r}.${k}`:k;const A=this._configuration.inspect(k,p,this._extHostWorkspace.workspace);if(A)return{key:k,defaultValue:(0,n.deepClone)(A.policy?.value??A.default?.value),globalValue:(0,n.deepClone)(A.user?.value??A.application?.value),workspaceValue:(0,n.deepClone)(A.workspace?.value),workspaceFolderValue:(0,n.deepClone)(A.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(A.default?.override),globalLanguageValue:(0,n.deepClone)(A.user?.override??A.application?.override),workspaceLanguageValue:(0,n.deepClone)(A.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(A.workspaceFolder?.override),languageIds:(0,n.deepClone)(A.overrideIdentifiers)}}};return typeof c=="object"&&(0,n.mixin)(d,c,!1),Object.freeze(d)}_toReadonlyValue(r){const l=i=>(0,I.isObject)(i)?new Proxy(i,{get:(p,c)=>l(p[c]),set:(p,c,s)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(p,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(p,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return l(r)}_validateConfigurationAccess(r,l,i){const p=_.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=i?`[${i.value}] `:"";if(p===4){typeof l?.resource>"u"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){l?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,l){const i=new P.ConfigurationChangeEvent(r,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,c)=>i.affectsConfiguration(p,R(c))})}_toMap(r){return r.reduce((l,i)=>(l.set(i[0],i[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[107],Ie([1,0,2,17,4,5,7,31,57,32,20,60,18,26,3,15,21,11,76,202,12]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(O){function B(F){if(F!=null)return F}O.from=B;function T(F){if(F!=null)return F}O.to=T})(t||(t={}));var h;(function(O){function B(F){if(F!=null)return F}O.from=B;function T(F){if(F!=null)return F}O.to=T})(h||(h={}));var r;(function(O){function B(F){if(F!=null)return F}O.from=B;function T(F){if(F!=null)return F}O.to=T})(r||(r={}));var l;(function(O){function B(z){if(z){const H=z;return H&&!!H.process}else return!1}O.is=B;function T(z){if(z==null)return;const H={process:z.process,args:z.args};return z.options&&(H.options=r.from(z.options)),H}O.from=T;function F(z){if(z!=null)return new S.ProcessExecution(z.process,z.args,z.options)}O.to=F})(l||(l={}));var i;(function(O){function B(F){if(F!=null)return F}O.from=B;function T(F){if(F!=null)return F}O.to=T})(i||(i={}));var p;(function(O){function B(z){if(z){const H=z;return H&&(!!H.commandLine||!!H.command)}else return!1}O.is=B;function T(z){if(z==null)return;const H={};return z.commandLine!==void 0?H.commandLine=z.commandLine:(H.command=z.command,H.args=z.args),z.options&&(H.options=i.from(z.options)),H}O.from=T;function F(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new S.ShellExecution(z.commandLine,z.options):new S.ShellExecution(z.command,z.args?z.args:[],z.options)}O.to=F})(p||(p={}));var c;(function(O){function B(z){if(z){const H=z;return H&&H.customExecution==="customExecution"}else return!1}O.is=B;function T(z){return{customExecution:"customExecution"}}O.from=T;function F(z,H){return H.get(z)}O.to=F})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var s;(function(O){function B(T,F){let z;return T.scope!==void 0&&typeof T.scope!="number"?z=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===S.TaskScope.Workspace&&F&&F.workspaceFile?z=F.workspaceFile:z=b.USER_TASKS_GROUP_KEY),{id:T._id,workspaceFolder:z}}O.from=B})(s=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(O){function B(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}O.from=B})(d||(d={}));var k;(function(O){function B(z,H){if(z==null)return[];const de=[];for(const pe of z){const re=T(pe,H);re&&de.push(re)}return de}O.fromMany=B;function T(z,H){if(z==null)return;let de;z.execution instanceof S.ProcessExecution?de=l.from(z.execution):z.execution instanceof S.ShellExecution?de=p.from(z.execution):z.execution&&z.execution instanceof S.CustomExecution&&(de=c.from(z.execution));const pe=t.from(z.definition);let re;return z.scope?typeof z.scope=="number"?re=z.scope:re=z.scope.uri:re=S.TaskScope.Workspace,!pe||!re?void 0:{_id:z._id,definition:pe,name:z.name,source:{extensionId:H.identifier.value,label:z.source,scope:re},execution:de,isBackground:z.isBackground,group:d.from(z.group),presentationOptions:h.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}O.from=T;async function F(z,H,de){if(z==null)return;let pe;l.is(z.execution)?pe=l.to(z.execution):p.is(z.execution)?pe=p.to(z.execution):c.is(z.execution)&&(pe=c.to(z._id,de));const re=t.to(z.definition);let le;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?le=z.source.scope:le=await H.resolveWorkspaceFolder(n.URI.revive(z.source.scope)):le=S.TaskScope.Workspace),!re||!le)return;const ae=new S.Task(re,le,z.name,z.source.label,pe,z.problemMatchers);return z.isBackground!==void 0&&(ae.isBackground=z.isBackground),z.group!==void 0&&(ae.group=S.TaskGroup.from(z.group._id),ae.group&&z.group.isDefault&&(ae.group=new S.TaskGroup(ae.group.id,ae.group.label),z.group.isDefault===!0&&(ae.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ae.presentationOptions=h.to(z.presentationOptions)),z._id&&(ae._id=z._id),z.detail&&(ae.detail=z.detail),ae}O.to=F})(k=e.TaskDTO||(e.TaskDTO={}));var A;(function(O){function B(F){return F}O.from=B;function T(F){if(!!F)return Object.assign(Object.create(null),F)}O.to=T})(A||(A={}));class W{constructor(B,T,F){this._id=T,this._task=F,v.set(this,void 0),Je(this,v,B,"f")}get task(){return this._task}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}v=new WeakMap;let J=class{constructor(B,T,F,z,H,de,pe,re){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=B.getProxy(N.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=z,this._configurationService=H,this._terminalService=de,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=pe,this._deprecationService=re,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,T,F){if(!F)return new S.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:T,provider:F,extension:B}),this._proxy.$registerTaskProvider(z,T),new S.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(B,T){this._proxy.$registerTaskSystem(B,T)}fetchTasks(B){return this._proxy.$fetchTasks(A.from(B)).then(async T=>{const F=[];for(const z of T){const H=await k.to(z,this._workspaceProvider,this._providedCustomExecutions2);H&&F.push(H)}return F})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(T=>B.push(T)),B}terminateTask(B){if(!(B instanceof W))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,T,F){const z=this._providedCustomExecutions2.get(B.id);z&&(this._activeCustomExecutions2.set(B.id,z),this._terminalService.attachPtyToTerminal(T,await z.callback(F))),this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const T=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:T})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const T=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:T,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const T=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:T,exitCode:B.exitCode})}$provideTasks(B,T){const F=this._handlers.get(B);if(!F)return Promise.reject(new Error("no handler found"));const z=[],H=(0,C.asPromise)(()=>F.provider.provideTasks(L.CancellationToken.None)).then(de=>this.provideTasksInternal(T,z,F,de));return new Promise(de=>{H.then(pe=>{Promise.all(z).then(()=>{de(pe)})})})}async $resolveTask(B,T){const F=this._handlers.get(B);if(!F)return Promise.reject(new Error("no handler found"));if(T.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${F.type}].`);const z=await k.to(T,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const H=await F.provider.resolveTask(z,L.CancellationToken.None);if(!H)return;this.checkDeprecation(H,F);const de=k.from(H,F.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(de.execution)&&await this.addCustomExecution(de,H,!0),await this.resolveTaskInternal(de)}nextHandle(){return this._handleCounter++}async addCustomExecution(B,T,F){const z=await this._proxy.$createTaskId(B);!F&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,T.execution)),this._providedCustomExecutions2.set(z,T.execution)}async getTaskExecution(B,T){if(typeof B=="string"){const H=this._taskExecutionPromises.get(B);if(!H)throw new R.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const F=this._taskExecutionPromises.get(B.id);if(F)return F;const z=new Promise((H,de)=>{function pe(re,le,ae){ae?H(new W(re,le.id,ae)):de("Unexpected: Task does not exist.")}T?pe(this,B,T):k.to(B.task,this._workspaceProvider,this._providedCustomExecutions2).then(re=>pe(this,B,re))});return this._taskExecutionPromises.set(B.id,z),z.then(H=>(this._taskExecutions.set(B.id,H),H),H=>Promise.reject(H))}checkDeprecation(B,T){B._deprecated&&this._deprecationService.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));const F=this._notProvidedCustomExecutions.values();let z=F.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=F.next()}};J=Ve([He(0,f.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,w.IExtHostTerminalService),He(6,u.ILogService),He(7,g.IExtHostApiDeprecationService)],J),e.ExtHostTaskBase=J;let j=class extends J{constructor(B,T,F,z,H,de,pe,re){super(B,T,F,z,H,de,pe,re),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(B,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const F=k.from(T,B);if(F===void 0)throw new Error("Task is not valid");if(c.is(F.execution))await this.addCustomExecution(F,T,!1);else throw new R.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),T);return this._proxy.$executeTask(F).catch(H=>{throw new Error(H)}),z}provideTasksInternal(B,T,F,z){const H=[];if(z)for(const de of z){this.checkDeprecation(de,F),(!de.definition||!B[de.definition.type])&&this._logService.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const pe=k.from(de,F.extension);pe&&c.is(pe.execution)?(H.push(pe),T.push(this.addCustomExecution(pe,de,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:F.extension}}async resolveTaskInternal(B){if(c.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,T,F){}};j=Ve([He(0,f.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,w.IExtHostTerminalService),He(6,u.ILogService),He(7,g.IExtHostApiDeprecationService)],j),e.WorkerExtHostTask=j,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(Ce[245],Ie([1,0,19,20,39,35,24,77,47]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(f,E,m){this.config=f,this.provider=E,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&N.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&N.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const E=this.config.folderQueries||[];return new Promise((m,a)=>{const o=u=>{this.resultCount++,f(u)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(u=>{const g=u.toString(),b=n.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,b)||this.matchFile(o,{base:u,basename:b})}),Promise.all(E.map(u=>this.searchInFolder(u,o))).then(u=>{m({limitHit:this.isLimitHit,stats:u[0]||void 0})},u=>{a(new Error((0,y.toErrorMessage)(u)))})})}async searchInFolder(f,E){const m=new C.CancellationTokenSource,a=this.getSearchOptionsForFolder(f),o=this.initDirectoryTree(),u=new _.QueryGlobTester(this.config,f),g=!u.hasSiblingExcludeClauses();let b;try{this.activeCancellationTokens.add(m),b=P.StopWatch.create();const R=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,m.token),v=b.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(R&&R.forEach(h=>{const r=n.posix.relative(f.folder.path,h.path);if(g){const l=n.basename(h.path);this.matchFile(E,{base:f.folder,relativePath:r,basename:l});return}this.addDirectoryEntries(o,f.folder,r,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(o,u,E),{providerTime:v,postProcessTime:t.elapsed()})}finally{m.dispose(),this.activeCancellationTokens.delete(m)}}getSearchOptionsForFolder(f){const E=(0,_.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),m=(0,_.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:m,includes:E,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},E,m,a){if(m===this.filePattern){const u=n.basename(this.filePattern);this.matchFile(a,{base:E,relativePath:this.filePattern,basename:u})}function o(u){const g=n.basename(u),b=n.dirname(u);let R=f[b];R||(R=f[b]=[],o(b)),R.push({base:E,relativePath:u,basename:g})}o(m)}matchDirectoryTree({rootEntries:f,pathToEntries:E},m,a){const o=this,u=this.filePattern;function g(b){const R=(0,_.hasSiblingFn)(()=>b.map(v=>v.basename));for(let v=0,t=b.length;v<t;v++){const h=b[v],{relativePath:r,basename:l}=h;if(m.matchesExcludesSync(r,l,u!==l?R:void 0))continue;const i=E[r];if(i)g(i);else{if(r===u)continue;o.matchFile(a,h)}if(o.isLimitHit)break}}g(f)}matchFile(f,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(E))}}class L{constructor(){this.sessions=new Map}fileSearch(f,E,m,a){const o=this.getSessionTokenSource(f.cacheKey),u=new I(f,E,o&&o.token);let g=0;const b=R=>{g+=R.length,m(R.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(u,L.BATCH_SIZE,b,a).then(R=>({limitHit:R.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:R.stats}}))}clearCache(f){this.getSessionTokenSource(f)?.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new C.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:S.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,E,m,a){a.onCancellationRequested(()=>{f.cancel()});const o=g=>{g&&(u.push(g),E>0&&u.length>=E&&(m(u),u=[]))};let u=[];return f.search(o).then(g=>(u.length&&m(u),g),g=>(u.length&&m(u),Promise.reject(g)))}}L.BATCH_SIZE=512,e.FileSearchManager=L}),define(Ce[246],Ie([1,0,16,62,35,87,28,15,19,24,10,9,2,262,155,41,11,53,97,244,47]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(d,k,A,W,J){this.configurationService=d,this.workspaceContextService=k,this.editorGroupsService=A,this.logService=W,this.pathService=J}text(d,k,A={}){d=this.getContentPattern(d,A);const W=this.configurationService.getValue(),J=k&&k.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(k?.map(u.toWorkspaceFolder),A),type:2,contentPattern:d,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:W.search.usePCRE2||J||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}getContentPattern(d,k){const A=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const W={...d,wordSeparators:A.editor.wordSeparators};return this.isCaseSensitive(d,k)&&(W.isCaseSensitive=!0),this.isMultiline(d)&&(W.isMultiline=!0),W}file(d,k={}){return{...this.commonQuery(d,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}handleIncludeExclude(d,k){return d?(d=Array.isArray(d)?d.map(i):i(d),k?this.parseSearchPaths(d):{pattern:h(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],k={}){const A=this.handleIncludeExclude(k.includePattern,k.expandPatterns),W=this.handleIncludeExclude(k.excludePattern,k.expandPatterns),J=d.length>1,j=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(T=>this.getFolderQueryForSearchPath(T,k,W)):d.map(T=>this.getFolderQueryForRoot(T,k,W,J))).filter(T=>!!T),O={_reason:k._reason,folderQueries:j,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:W.pattern,includePattern:A.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const T=n.coalesce(n.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(de=>de.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const F=T.filter(H=>(0,R.pathIncludedInQuery)(O,H.fsPath)),z=this.commonQueryFromFileList(F);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...O,...z}}const B=k.extraFileResources&&k.extraFileResources.filter(T=>(0,R.pathIncludedInQuery)(O,T.fsPath));return O.extraFileResources=B&&B.length?B:void 0,O}commonQueryFromFileList(d){const k=[],A=new S.ResourceMap,W={};let J=!1;return d.forEach(j=>{if(j.scheme===P.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(j)){const B=this.workspaceContextService.getWorkspaceFolder(j)?.uri??j.with({path:_.dirname(j.fsPath)});let T=A.get(B);T||(J=!0,T={folder:B,includePattern:{}},k.push(T),A.set(B,T));const F=_.relative(B.fsPath,j.fsPath);(0,w.assertIsDefined)(T.includePattern)[F.replace(/\\/g,"/")]=!0}else j.fsPath&&(J=!0,W[j.fsPath]=!0)}),{folderQueries:k,includePattern:W,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}isCaseSensitive(d,k){if(k.isSmartCase){if(d.isRegExp){if(L.containsUppercaseCharacter(d.pattern,!0))return!0}else if(L.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,E.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const k=z=>_.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),W=(Array.isArray(d)?d:r(d)).map(z=>{const H=this.pathService.resolvedUserHome;return H?(0,N.untildify)(z,H.scheme===P.Schemas.file?H.fsPath:H.path):z}),J=C.groupBy(W,z=>k(z)?"searchPaths":"exprSegments"),j=(J.exprSegments||[]).map(z=>L.rtrim(z,"/")).map(z=>L.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),l(z))),O={},B=this.expandSearchPathPatterns(J.searchPaths||[]);B&&B.length&&(O.searchPaths=B);const T=n.flatten(j),F=h(...T);return F&&(O.pattern=F),O}getExcludesForFolder(d,k){return k.disregardExcludeSettings?void 0:(0,R.getExcludes)(d,!k.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const k=d.flatMap(W=>{let{pathPortion:J,globPortion:j}=t(W);return j&&(j=p(j)),this.expandOneSearchPath(J).flatMap(B=>this.resolveOneSearchPathPattern(B,j))}),A=new Map;return k.forEach(W=>{const J=W.searchPath.toString(),j=A.get(J);j?W.pattern&&(j.pattern=j.pattern||{},j.pattern[W.pattern]=!0):A.set(J,{searchPath:W.searchPath,pattern:W.pattern?h(W.pattern):void 0})}),Array.from(A.values())}expandOneSearchPath(d){if(_.isAbsolute(d)){const k=this.workspaceContextService.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==P.Schemas.file?[{searchPath:k[0].uri.with({path:d})}]:[{searchPath:f.URI.file(_.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const k=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=i(d),d.startsWith("../")||d===".."){const W=_.posix.resolve(k.path,d);return[{searchPath:k.with({path:W})}]}const A=p(d);return[{searchPath:k,pattern:A}]}else{if(d==="./"||d===".\\")return[];{const k=d.replace(/^\.[\/\\]/,""),W=this.workspaceContextService.getWorkspace().folders.map(J=>{const j=k.match(new RegExp(`^${L.escapeRegExpCharacters(J.name)}(?:/(.*)|$)`));return j?{match:j,folder:J}:null}).filter(w.isDefined);if(W.length)return W.map(J=>{const j=J.match[1];return{searchPath:J.folder.uri,pattern:j&&p(j)}});{const J=d.match(/\.[\/\\](.+)[\/\\]?/),j=J?J[1]:d,O=m.localize(0,null,j);throw new Error(O)}}}}resolveOneSearchPathPattern(d,k){const A=d.pattern&&k?`${d.pattern}/${k}`:d.pattern||k,W=[{searchPath:d.searchPath,pattern:A}];return A&&!A.endsWith("**")&&W.push({searchPath:d.searchPath,pattern:A+"/**"}),W}getFolderQueryForSearchPath(d,k,A){const W=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(d.searchPath),k,A,!1);return W?{...W,includePattern:d.pattern}:null}getFolderQueryForRoot(d,k,A,W){let J;const j=f.URI.isUri(d)?d:d.uri;if(A.searchPaths){const z=A.searchPaths.filter(H=>(0,I.isEqual)(H.searchPath,j))[0];if(z&&!z.pattern)return null;z&&(J=z.pattern)}const O=this.configurationService.getValue({resource:j}),T={...this.getExcludesForFolder(O,k)||{},...J||{}},F=f.URI.isUri(d)?(0,I.basename)(d):d.name;return{folder:j,folderName:W?F:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!O.search.followSymlinks}}};v=Ve([He(0,a.IConfigurationService),He(1,u.IWorkspaceContextService),He(2,g.IEditorGroupsService),He(3,o.ILogService),He(4,b.IPathService)],v),e.QueryBuilder=v;function t(s){const d=s.match(/[\*\{\}\(\)\[\]\?]/);if(d){const k=d.index,A=s.substr(0,k).match(/[/|\\][^/\\]*$/);if(A){let W=s.substr(0,A.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:s.substr((A.index||0)+1)}}}return{pathPortion:s}}function h(...s){return s.length?s.reduce((d,k)=>(d[k]=!0,d),Object.create(null)):void 0}function r(s){return y.splitGlobAware(s,",").map(d=>d.trim()).filter(d=>!!d.length)}function l(s){return[`**/${s}/**`,`**/${s}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function i(s){return s.replace(/\\/g,"/")}function p(s){return i(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(s,d){s=n.distinct(s,W=>W.toString());const k=[],A=d.getWorkspace();return s&&s.forEach(W=>{let J;if(d.getWorkbenchState()===2)J=(0,I.relativePath)(A.folders[0].uri,W),J&&J!=="."&&(J="./"+J);else{const j=d.getWorkspaceFolder(W);if(j){const O=j.name;if(A.folders.filter(T=>T.name===O).length===1){const T=(0,I.relativePath)(j.uri,W);T===""?J=`./${j.name}`:J=`./${j.name}/${T}`}else J=W.fsPath}}J&&k.push(J)}),k}e.resolveResourcesForSearchIncludes=c}),define(Ce[247],Ie([1,0,24,2,20,12,3,246,47,53]),function(te,e,n,C,y,N,S,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function w(a,o){const u=o.activationEvents;if(!u)return Promise.resolve(void 0);const g=[],b=[];for(const l of u)if(/^workspaceContains:/.test(l)){const i=l.substr(18);i.indexOf("*")>=0||i.indexOf("?")>=0||a.forceUsingSearch?b.push(i):g.push(i)}if(g.length===0&&b.length===0)return Promise.resolve(void 0);let R;const v=new Promise((l,i)=>{R=l}),t=l=>R({activationEvent:l}),h=Promise.all(g.map(l=>f(a,l,t))).then(()=>{}),r=E(a,o.identifier,b,t);return Promise.all([h,r]).then(()=>{R(void 0)}),v}e.checkActivateWorkspaceContainsExtension=w;async function f(a,o,u){for(const g of a.folders)if(await a.exists(n.joinPath(C.URI.revive(g),o))){u(`workspaceContains:${o}`);return}}async function E(a,o,u,g){if(u.length===0)return Promise.resolve(void 0);const b=new y.CancellationTokenSource,R=a.checkExists(a.folders,u,b.token),v=setTimeout(async()=>{b.cancel(),a.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},L);let t=!1;try{t=await R}catch(h){N.isCancellationError(h)||N.onUnexpectedError(h)}b.dispose(),clearTimeout(v),t&&g(`workspaceContains:${u.join(",")}`)}function m(a,o,u,g){const b=a.get(S.IInstantiationService),R=a.get(_.ISearchService),t=b.createInstance(P.QueryBuilder).file(o.map(h=>(0,I.toWorkspaceFolder)(C.URI.revive(h))),{_reason:"checkExists",includePattern:u,exists:!0});return R.fileSearch(t,g).then(h=>!!h.limitHit,h=>N.isCancellationError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=m});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[33],Ie([1,0,140,19,82,24,17,6,48,2,11,5,32,192,80,31,27,98,12,25,23,177,7,94,3,26,81,18,67,69,60,4,247,79,179,15,78,77]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R,v,t,h,r,l,i,p,c,s,d,k,A,W,J,j,O,B){"use strict";var T,F,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let H=class Mi extends P.Disposable{constructor(se,Q,K,Z,he,ke,Fe,je,Te,Se,De){super(),this._onDidChangeRemoteConnectionData=this._register(new k.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Q,this._extHostContext=K,this._initData=Fe,this._extHostWorkspace=Z,this._extHostConfiguration=he,this._logService=ke,this._extHostTunnelService=Te,this._extHostTerminalService=Se,this._extHostLocalizationService=De,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._globalRegistry=new u.ExtensionDescriptionRegistry(this._initData.allExtensions);const oe=(0,o.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new u.ExtensionDescriptionRegistry(re(this._globalRegistry,oe)),this._storage=new m.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new W.ExtHostSecretState(this._extHostContext),this._storagePath=je,this._instaService=se.createChild(new c.ServiceCollection([m.IExtHostStorage,this._storage],[W.IExtHostSecretState,this._secretState])),this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ue,Y,D)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ue,g.transformErrorForSerialization(Y),D)},actualActivateExtension:async(ue,Y)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(ue,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ue,Y),new E.HostExtension;const D=this._myRegistry.getExtensionDescription(ue);return this._activateExtension(D,Y)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(se){g.onUnexpectedError(se)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let se=[];try{se=this._myRegistry.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this._deactivate(he))}catch{}await Promise.all(se)}terminate(se,Q=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${se}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(Z=>{this._logService.error(Z)}),this._extHostContext.dispose();const K=this._deactivateAll();Promise.race([(0,S.timeout)(5e3),K]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Q}`):this._logService.info(`Extension host exiting with code ${Q}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Q)})}isActivated(se){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(se):!1}async getExtension(se){const Q=await this._mainThreadExtensionsProxy.$getExtension(se);let K;if(Q?.browserNlsBundleUris){K={};for(const Z of Object.keys(Q.browserNlsBundleUris))K[Z]=I.URI.revive(Q.browserNlsBundleUris[Z])}return Q&&{...Q,identifier:new b.ExtensionIdentifier(Q.identifier.value),extensionLocation:I.URI.revive(Q.extensionLocation),browserNlsBundleUris:K}}_activateByEvent(se,Q){return this._activator.activateByEvent(se,Q)}_activateById(se,Q){return this._activator.activateById(se,Q)}activateByIdWithErrors(se,Q){return this._activateById(se,Q).then(()=>{const K=this._activator.getActivatedExtension(se);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(se=>this._myRegistry)}getExtensionExports(se){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(se).exports:null}async _realPathExtensionUri(se){if(se.scheme!==j.Schemas.file)return se;const Q=await this._hostUtils.realpath(se.fsPath);return I.URI.file(Q)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(se=>new le(se))),this._extensionPathIndex}async _createExtensionPathIndex(se){const Q=_.TernarySearchTree.forUris(K=>N.extUriBiasedIgnorePathCase.ignorePathCasing(K));return await Promise.all(se.map(async K=>{if(this._getEntryPoint(K)){const Z=await this._realPathExtensionUri(K.extensionLocation);Q.set(Z,K)}})),Q}_deactivate(se){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(se))return Q;const K=this._activator.getActivatedExtension(se);if(!K)return Q;try{typeof K.module.deactivate=="function"&&(Q=Promise.resolve(K.module.deactivate()).then(void 0,Z=>(this._logService.error(Z),Promise.resolve(void 0))))}catch(Z){this._logService.error(`An error occurred when deactivating the extension '${se.value}':`),this._logService.error(Z)}try{(0,P.dispose)(K.subscriptions)}catch(Z){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${se.value}':`),this._logService.error(Z)}return Q}async _activateExtension(se,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(se.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(se.identifier),this._doActivateExtension(se,Q).then(K=>{const Z=K.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(se.identifier,Z.codeLoadingTime,Z.activateCallTime,Z.activateResolvedTime,Q),this._logExtensionActivationTimes(se,Q,"success",Z),K},K=>{throw this._logExtensionActivationTimes(se,Q,"failure"),K})}_logExtensionActivationTimes(se,Q,K,Z){const he=de(se,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...he,...Z||{},outcome:K})}_doActivateExtension(se,Q){const K=de(se,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",K);const Z=this._getEntryPoint(se);if(!Z)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${se.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${se.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const he=new E.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(se,(0,N.joinPath)(se.extensionLocation,Z),he),this._loadExtensionContext(se)]).then(ke=>(y.mark(`code/extHost/willActivateExtension/${se.identifier.value}`),Mi._callActivate(this._logService,se.identifier,ke[0],ke[1],he))).then(ke=>(y.mark(`code/extHost/didActivateExtension/${se.identifier.value}`),ke))}_loadExtensionContext(se){const Q=new v.ExtensionGlobalMemento(se,this._storage),K=new v.ExtensionMemento(se.identifier.value,!1,this._storage),Z=new J.ExtensionSecrets(se,this._secretState),he=se.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ke=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${se.identifier.value}`),Promise.all([Q.whenReady,K.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let je,Te;const Se=(0,o.isProposedApiEnabled)(se,"ipc")?this._initData.messagePorts?.get(b.ExtensionIdentifier.toKey(se.identifier)):void 0;return Object.freeze({globalState:Q,workspaceState:K,secrets:Z,subscriptions:[],get extensionUri(){return se.extensionLocation},get extensionPath(){return se.extensionLocation.fsPath},asAbsolutePath(De){return C.join(se.extensionLocation.fsPath,De)},get storagePath(){return Fe._storagePath.workspaceValue(se)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(se).fsPath},get logPath(){return C.join(Fe._initData.logsLocation.fsPath,se.identifier.value)},get logUri(){return I.URI.joinPath(Fe._initData.logsLocation,se.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(se)},get globalStorageUri(){return Fe._storagePath.globalValue(se)},get extensionMode(){return he},get extension(){return je===void 0&&(je=new pe(Fe,se.identifier,se,ke,!1)),je},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(se,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(se)},get messagePassingProtocol(){if(!Te){if(!Se)return;const De=k.Event.buffer(k.Event.fromDOMEventEmitter(Se,"message",oe=>oe.data));Se.start(),Te={onDidReceiveMessage:De,postMessage:Se.postMessage.bind(Se)}}return Te}})})}static _callActivate(se,Q,K,Z,he){return K=K||{activate:void 0,deactivate:void 0},this._callActivateOptional(se,Q,K,Z,he).then(ke=>new E.ActivatedExtension(!1,null,he.build(),K,ke,Z.subscriptions))}static _callActivateOptional(se,Q,K,Z,he){if(typeof K.activate=="function")try{he.activateCallStart(),se.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const ke=typeof global=="object"?global:self,Fe=K.activate.apply(ke,[Z]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(Fe).then(je=>(he.activateResolveStop(),je))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(K)}_activateOneStartupFinished(se,Q){this._activateById(se.identifier,{startup:!1,extensionId:se.identifier,activationEvent:Q}).then(void 0,K=>{this._logService.error(K)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const se of this._myRegistry.getAllExtensionDescriptions())if(se.activationEvents)for(const Q of se.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(se,Q)}_handleEagerExtensions(){const se=this._activateByEvent("*",!0).then(void 0,he=>{this._logService.error(he)});this._register(this._extHostWorkspace.onDidChangeWorkspace(he=>this._handleWorkspaceContainsEagerExtensions(he.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],K=this._handleWorkspaceContainsEagerExtensions(Q),Z=Promise.all([se,K]).then(()=>{});return Promise.race([Z,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Z}_handleWorkspaceContainsEagerExtensions(se){return se.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(se,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(se,Q){if(this.isActivated(Q.identifier))return;const K=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Z={logService:this._logService,folders:se.map(ke=>ke.uri),forceUsingSearch:K,exists:ke=>this._hostUtils.exists(ke.fsPath),checkExists:(ke,Fe,je)=>this._mainThreadWorkspaceProxy.$checkExists(ke,Fe,je)},he=await(0,A.checkActivateWorkspaceContainsExtension)(Z,Q);if(!!he)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:he.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(se){throw console.error(se),se}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:se,extensionTestsLocationURI:Q}=this._initData.environment;if(!se||!Q)throw new Error(n.localize(0,null));const K=await this._loadCommonJSModule(null,Q,new E.ExtensionActivationTimesBuilder(!1));if(!K||typeof K.run!="function")throw new Error(n.localize(1,null,Q.toString()));return new Promise((Z,he)=>{const ke=(Te,Se)=>{Te?he(Te):Z(typeof Se=="number"&&Se>0?1:0)},Fe=(0,N.originalFSPath)(Q),je=K.run(Fe,ke);je&&je.then&&je.then(()=>{Z(0)}).catch(Te=>{he(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(se,Q){return this._resolvers[se]=Q,(0,P.toDisposable)(()=>{delete this._resolvers[se]})}async _activateAndGetResolver(se){const Q=se.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const K=se.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this._resolvers[K]}}async $resolveAuthority(se,Q){const K=B.StopWatch.create(!1),Z=()=>`[resolveAuthority(${(0,h.getRemoteAuthorityPrefix)(se)},${Q})][${K.elapsed()}ms] `,he=Se=>this._logService.info(`${Z()}${Se}`),ke=(Se,De=void 0)=>this._logService.error(`${Z()}${Se}`,De);he("activating resolver...");const{authorityPrefix:Fe,resolver:je}=await this._activateAndGetResolver(se);if(!je)return ke("no resolver"),{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Fe}.`,detail:void 0}};const Te=new S.IntervalTimer;try{he("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(je)),Te.cancelAndSet(()=>he("waiting..."),1e3),he("invoking resolve()..."),y.mark(`code/extHost/willResolveAuthority/${Fe}`);const Se=await je.resolve(se,{resolveAttempt:Q});y.mark(`code/extHost/didResolveAuthorityOK/${Fe}`),Te.dispose(),he(`returned ${Se.host}:${Se.port}`);const De={authority:se,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},oe={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:De,options:oe,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(y.mark(`code/extHost/didResolveAuthorityError/${Fe}`),Te.dispose(),ke("returned an error",Se),Se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(se,Q){this._logService.info(`$getCanonicalURI invoked for authority (${(0,h.getRemoteAuthorityPrefix)(se)})`);const{resolver:K}=await this._activateAndGetResolver(se);if(!K)return null;const Z=I.URI.revive(Q);if(typeof K.getCanonicalURI>"u")return Z;const he=await(0,S.asPromise)(()=>K.getCanonicalURI(Z));return he||Z}static _applyExtensionsDelta(se,Q,K){const Z=new u.ExtensionDescriptionRegistry(se.getAllExtensionDescriptions());Z.deltaExtensions(K.toAdd,K.toRemove);const he=(0,o.extensionIdentifiersArrayToSet)(Q.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of K.myToRemove)he.delete(b.ExtensionIdentifier.toKey(Fe));for(const Fe of K.myToAdd)he.add(b.ExtensionIdentifier.toKey(Fe));const ke=re(Z,he);return{globalRegistry:Z,myExtensions:ke}}$startExtensionHost(se){se.toAdd.forEach(Z=>Z.extensionLocation=I.URI.revive(Z.extensionLocation));const{globalRegistry:Q,myExtensions:K}=Mi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,se);return this._globalRegistry.set(Q.getAllExtensionDescriptions()),this._myRegistry.set(K),this._startExtensionHost()}$activateByEvent(se,Q){return Q===1?this._activateByEvent(se,!1):this._readyToRunExtensions.wait().then(K=>this._activateByEvent(se,!1))}async $activate(se,Q){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(se)?(await this._activateById(se,Q),!0):!1}async $deltaExtensions(se){se.toAdd.forEach(ke=>ke.extensionLocation=I.URI.revive(ke.extensionLocation));const{globalRegistry:Q,myExtensions:K}=Mi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,se),Z=await this._createExtensionPathIndex(K);return(await this.getExtensionPathIndex()).setSearchTree(Z),this._globalRegistry.set(Q.getAllExtensionDescriptions()),this._myRegistry.set(K),Promise.resolve(void 0)}async $test_latency(se){return se}async $test_up(se){return se.byteLength}async $test_down(se){const Q=R.VSBuffer.alloc(se),K=Math.random()%256;for(let Z=0;Z<se;Z++)Q.writeUInt8(K,Z);return Q}async $updateRemoteConnectionData(se){this._remoteConnectionData=se,this._onDidChangeRemoteConnectionData.fire()}};H=Ve([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,p.IExtHostRpcService),He(3,a.IExtHostWorkspace),He(4,f.IExtHostConfiguration),He(5,L.ILogService),He(6,l.IExtHostInitDataService),He(7,i.IExtensionStoragePaths),He(8,s.IExtHostTunnelService),He(9,d.IExtHostTerminalService),He(10,O.IExtHostLocalizationService)],H),e.AbstractExtHostExtensionService=H;function de(ae,se){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:se.activationEvent,reasonId:se.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class pe{constructor(se,Q,K,Z,he){T.set(this,void 0),F.set(this,void 0),z.set(this,void 0),Je(this,T,se,"f"),Je(this,F,Q,"f"),Je(this,z,K.identifier,"f"),this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=C.normalize((0,N.originalFSPath)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=Z,this.isFromDifferentExtensionHost=he}get isActive(){return Oe(this,T,"f").isActivated(Oe(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,T,"f").getExtensionExports(Oe(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,T,"f").activateByIdWithErrors(Oe(this,z,"f"),{startup:!1,extensionId:Oe(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=pe,T=new WeakMap,F=new WeakMap,z=new WeakMap;function re(ae,se){return ae.getAllExtensionDescriptions().filter(Q=>se.has(b.ExtensionIdentifier.toKey(Q.identifier)))}class le{constructor(se){this._searchTree=se}setSearchTree(se){this._searchTree=se}findSubstr(se){return this._searchTree.findSubstr(se)}forEach(se){return this._searchTree.forEach(se)}}e.ExtensionPaths=le}),define(Ce[248],Ie([1,0,82,2,5,32,27,25,18,26,3,33,51,11,10]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(v,t,h,r,l,i,p){this._apiFactory=v,this._extensionRegistry=t,this._instaService=h,this._extHostConfiguration=r,this._extHostExtensionService=l,this._initData=i,this._logService=p,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),n.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,t,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(g,t)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,t,this._initData.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const t of v.nodeModuleName)this._factories.set(t,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(t=>v.alternativeModuleName(t))}};a=Ve([He(2,L.IInstantiationService),He(3,N.IExtHostConfiguration),He(4,w.IExtHostExtensionService),He(5,I.IExtHostInitDataService),He(6,E.ILogService)],a),e.RequireInterceptor=a;let o=class rn{constructor(v){if(v.environment.appRoot&&rn.aliased.size){const t=(0,m.escapeRegExpCharacters)(this.forceForwardSlashes(v.environment.appRoot.fsPath)),h="[a-z0-9_.-]",r=`@${h}+\\/${h}+|${h}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${l}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(v){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(v));if(!t)return;const[,h,r,l]=t,i=rn.aliased.get(r);if(i!==void 0)return console.warn(`${r} as been renamed to ${i}, please update your imports`),h+i+l}forceForwardSlashes(v){return v.replace(/\\/g,"/")}};o.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=Ve([He(0,I.IExtHostInitDataService)],o);class u{constructor(v,t,h,r,l){this._apiFactory=v,this._extensionPaths=t,this._extensionRegistry=h,this._configProvider=r,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(v,t){const h=this._extensionPaths.findSubstr(t);if(h){let r=this._extApiImpl.get(P.ExtensionIdentifier.toKey(h.identifier));return r||(r=this._apiFactory(h,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(h.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((l,i)=>r+=`	${i} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(v,t,h){this._extensionPaths=v,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(y.MainContext.MainThreadTelemetry);const{environment:r}=h,l=t.getProxy(y.MainContext.MainThreadKeytar);if(r.appRoot){let i=r.appRoot.fsPath;f.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,p)=>l.$getPassword(i,p),setPassword:(i,p,c)=>l.$setPassword(i,p,c),deletePassword:(i,p)=>l.$deletePassword(i,p),findPassword:i=>l.$findPassword(i),findCredentials(i){return l.$findCredentials(i)}}}load(v,t){const h=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(v){const t=v.length;if(t<=7||!this.alternativeNames)return;const h=t-7;if((v.charAt(h)==="/"||v.charAt(h)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}};g=Ve([He(1,_.IExtHostRpcService),He(2,I.IExtHostInitDataService)],g);let b=class{constructor(v,t,h){this._extensionPaths=v,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=h.getProxy(y.MainContext.MainThreadTelemetry);const r=h.getProxy(y.MainContext.MainThreadWindow);this._impl=(l,i)=>{const p=C.URI.parse(l);return i?this.callOriginal(l,i):p.scheme==="http"||p.scheme==="https"?r.$openUri(p,l,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this._appUriScheme?r.$openUri(p,l,{}):this.callOriginal(l,i)}}load(v,t,h){const r=this._extensionPaths.findSubstr(t);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=h(v),this._impl}callOriginal(v,t){return this.sendNoForwardTelemetry(),this._original(v,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Ve([He(2,_.IExtHostRpcService)],b)}),define(Ce[108],Ie([1,0,85,6,19,51,3,57,58,33,7,31,189,32]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,S.createDecorator)("IExtHostVariableResolverProvider");class m extends f.AbstractVariableResolverService{constructor(u,g,b,R,v,t,h){function r(){if(b){const l=b.activeEditor();if(l)return l.document.uri;const i=R.tabGroups.all.find(p=>p.isActive)?.activeTab;if(i!==void 0){if(i.input instanceof L.TextDiffTabInput||i.input instanceof L.NotebookDiffEditorTabInput)return i.input.modified;if(i.input instanceof L.TextTabInput||i.input instanceof L.NotebookEditorTabInput||i.input instanceof L.CustomEditorTabInput)return i.input.uri}}}super({getFolderUri:l=>{const i=t.folders.filter(p=>p.name===l);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,i)=>v.getConfiguration(void 0,l).get(i),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=r();if(l)return y.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const l=r();if(l){const i=g.getWorkspaceFolder(l);if(i)return y.normalize(i.uri.fsPath)}}},getSelectedText:()=>{if(b){const l=b.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(b){const l=b.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>u.getExtension(l)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(N.env))}}let a=class extends C.Disposable{constructor(u,g,b,R,v){super(),this.extensionService=u,this.workspaceService=g,this.editorService=b,this.configurationService=R,this.editorTabs=v,this._resolver=new n.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async l=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new m(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};a=Ve([He(0,I.IExtHostExtensionService),He(1,w.IExtHostWorkspace),He(2,P.IExtHostDocumentsAndEditors),He(3,E.IExtHostConfiguration),He(4,_.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(Ce[109],Ie([1,0,17,4,9,2,3,5,58,33,18,7,31,182,184,32,108]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,l,i,p,c,s){this._workspaceService=l,this._extensionService=i,this._configurationService=p,this._editorTabs=c,this._variableResolver=s,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=r.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new b(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(d=>{d.onDidChange(k=>{this.registerAllDebugTypes(d)}),this.registerAllDebugTypes(d)})}asDebugSourceUri(r,l){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let p=`debug:${encodeURIComponent(i.path||"")}`,c="?";return l&&(p+=`${c}session=${encodeURIComponent(l.id)}`,c="&"),p+=`${c}ref=${i.sourceReference}`,N.URI.parse(p)}else{if(i.path)return N.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const l=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const p=i.contributes.debuggers;if(p&&p.length>0)for(const c of p)(0,m.isDebuggerMainContribution)(c)&&l.push(c.type)}this._debugServiceProxy.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(l=>r.push(l)),r}addBreakpoints(r){this.startBreakpoints();const l=r.filter(c=>{const s=c.id;return this._breakpoints.has(s)?!1:(this._breakpoints.set(s,c),!0)});this.fireBreakpointChanges(l,[],[]);const i=[],p=new Map;for(const c of l)if(c instanceof w.SourceBreakpoint){let s=p.get(c.location.uri.toString());s||(s={type:"sourceMulti",uri:c.location.uri,lines:[]},p.set(c.location.uri.toString(),s),i.push(s)),s.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof w.FunctionBreakpoint&&i.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(i)}removeBreakpoints(r){this.startBreakpoints();const l=r.filter(s=>this._breakpoints.delete(s.id));this.fireBreakpointChanges([],l,[]);const i=l.filter(s=>s instanceof w.SourceBreakpoint).map(s=>s.id),p=l.filter(s=>s instanceof w.FunctionBreakpoint).map(s=>s.id),c=l.filter(s=>s instanceof w.DataBreakpoint).map(s=>s.id);return this._debugServiceProxy.$unregisterBreakpoints(i,p,c)}startDebugging(r,l,i){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,l,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,l,i){if(!l)return new w.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:p,provider:l}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,i,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,p),new w.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==l),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(r,l,i){if(!i)return new w.Disposable(()=>{});if(!this.definesDebugType(r,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.getAdapterDescriptorFactoryByType(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:l,handle:p,factory:i}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(l,p),new w.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==i),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(r,l){if(!l)return new w.Disposable(()=>{});const i=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:i,factory:l}),new w.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==l)})}async $runInTerminal(r,l){return Promise.resolve(void 0)}async $substituteVariables(r,l){let i;const p=await this.getFolder(r);return p&&(i={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(i,l)}createDebugAdapter(r,l){if(r.type==="implementation")return new v(r.implementation)}createSignService(){}async $startDASession(r,l){const i=this,p=await this.getSession(l);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const s=this.convertToDto(c),d=this.createDebugAdapter(s,p);if(!d)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const k=d;return this._debugAdapters.set(r,k),this.getDebugAdapterTrackers(p).then(A=>(A&&this._debugAdaptersTrackers.set(r,A),k.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const J=W,j={type:"response",seq:0,command:J.command,request_seq:J.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(J.arguments.value);j.body={signature:O},k.sendResponse(j)}else throw new Error("no signer")}catch(O){j.success=!1,j.message=O.message,k.sendResponse(j)}}else A&&A.onDidSendMessage&&A.onDidSendMessage(W),W=(0,m.convertToVSCPaths)(W,!0),i._debugServiceProxy.$acceptDAMessage(r,W)}),k.onError(W=>{A&&A.onError&&A.onError(W),this._debugServiceProxy.$acceptDAError(r,W.name,W.message,W.stack)}),k.onExit(W=>{A&&A.onExit&&A.onExit((0,y.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,y.withNullAsUndefined)(W),void 0)}),A&&A.onWillStartSession&&A.onWillStartSession(),k.startSession()))})}$sendDAMessage(r,l){l=(0,m.convertToDAPaths)(l,!1);const i=this._debugAdaptersTrackers.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(l),this._debugAdapters.get(r)?.sendMessage(l)}$stopDASession(r){const l=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),l&&l.onWillStopSession&&l.onWillStopSession();const i=this._debugAdapters.get(r);return this._debugAdapters.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const l=[],i=[],p=[];if(r.added)for(const c of r.added){const s=c.id;if(s&&!this._breakpoints.has(s)){let d;if(c.type==="function")d=new w.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")d=new w.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const k=N.URI.revive(c.uri);d=new w.SourceBreakpoint(new w.Location(k,new w.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,w.setBreakpointId)(d,s),this._breakpoints.set(s,d),l.push(d)}}if(r.removed)for(const c of r.removed){const s=this._breakpoints.get(c);s&&(this._breakpoints.delete(c),i.push(s))}if(r.changed){for(const c of r.changed)if(c.id){const s=this._breakpoints.get(c.id);if(s){if(s instanceof w.FunctionBreakpoint&&c.type==="function"){const d=s;d.enabled=c.enabled,d.condition=c.condition,d.hitCondition=c.hitCondition,d.logMessage=c.logMessage,d.functionName=c.functionName}else if(s instanceof w.SourceBreakpoint&&c.type==="source"){const d=s;d.enabled=c.enabled,d.condition=c.condition,d.hitCondition=c.hitCondition,d.logMessage=c.logMessage,d.location=new w.Location(N.URI.revive(c.uri),new w.Position(c.line,c.character))}p.push(s)}}}this.fireBreakpointChanges(l,i,p)}$provideDebugConfigurations(r,l,i){return(0,n.asPromise)(async()=>{const p=this.getConfigProviderByHandle(r);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(l);return p.provideDebugConfigurations(c,i)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(r,l,i,p){return(0,n.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const s=await this.getFolder(l);return c.resolveDebugConfiguration(s,i,p)})}$resolveDebugConfigurationWithSubstitutedVariables(r,l,i,p){return(0,n.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const s=await this.getFolder(l);return c.resolveDebugConfigurationWithSubstitutedVariables(s,i,p)})}async $provideDebugAdapter(r,l){const i=this.getAdapterDescriptorFactoryByHandle(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(l);return this.getAdapterDescriptor(i,p).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(r){const l=await this.getSession(r);this._onDidStartDebugSession.fire(l)}async $acceptDebugSessionTerminated(r){const l=await this.getSession(r);l&&(this._onDidTerminateDebugSession.fire(l),this._debugSessions.delete(l.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,l){(await this.getSession(r))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(r,l){const p={session:await this.getSession(r),event:l.event,body:l.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(r){if(r instanceof w.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof w.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const l=this._adapterFactories.filter(i=>i.type===r);if(l.length>0)return l[0].factory}getAdapterDescriptorFactoryByHandle(r){const l=this._adapterFactories.filter(i=>i.handle===r);if(l.length>0)return l[0].factory}getConfigProviderByHandle(r){const l=this._configProviders.filter(i=>i.handle===r);if(l.length>0)return l[0].provider}definesDebugType(r,l){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const p of i)if(p.label&&p.type&&p.type===l)return!0}}return!1}getDebugAdapterTrackers(r){const i=r.configuration.type,p=this._trackerFactories.filter(c=>c.type===i||c.type==="*").map(c=>(0,n.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(s=>s,s=>null));return Promise.race([Promise.all(p).then(c=>{const s=c.filter(d=>!!d);if(s.length>0)return new R(s)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async getAdapterDescriptor(r,l){const i=l.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new w.DebugAdapterServer(i));if(r){const c=await this._extensionService.getExtensionRegistry();return(0,n.asPromise)(()=>r.createDebugAdapterDescriptor(l,this.daExecutableFromPackage(l,c))).then(s=>{if(s)return s})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(l,p))}daExecutableFromPackage(r,l){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,l,i){(r.length>0||l.length>0||i.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:l,changed:i}))}async getSession(r){if(r)if(typeof r=="string"){const l=this._debugSessions.get(r);if(l)return l}else{let l=this._debugSessions.get(r.id);if(!l){const i=await this.getFolder(r.folderUri),p=r.parent?this._debugSessions.get(r.parent):void 0;l=new g(this._debugServiceProxy,r.id,r.type,r.name,i,r.configuration,p),this._debugSessions.set(l.id,l),this._debugServiceProxy.$sessionCached(l.id)}return l}throw new Error("cannot find session")}getFolder(r){if(r){const l=N.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};u=Ve([He(0,L.IExtHostRpcService),He(1,f.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,a.IExtHostConfiguration),He(4,_.IExtHostEditorTabs),He(5,o.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class g{constructor(r,l,i,p,c,s,d){this._debugServiceProxy=r,this._id=l,this._type=i,this._name=p,this._workspaceFolder=c,this._configuration=s,this._parentSession=d}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,l){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,l)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=g;class b{constructor(r){this.value=Object.freeze({append(l){r.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=b;class R{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(l=>l.onError?l.onError(r):void 0)}onExit(r,l){this.trackers.forEach(i=>i.onExit?i.onExit(r,l):void 0)}}class v extends E.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends u{constructor(r,l,i,p,c,s){super(r,l,i,p,c,s)}};t=Ve([He(0,L.IExtHostRpcService),He(1,f.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,a.IExtHostConfiguration),He(4,_.IExtHostEditorTabs),He(5,o.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[249],Ie([1,0,12,82,2,5,240,11,66,67,26,160,18,55,33,74]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(b){const R=b.get(P.ILogService),t=b.get(f.IExtHostRpcService).getProxy(N.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(h=>{R.error(h);const r=n.transformErrorForSerialization(h);t.$onUnexpectedError(r)})}static async installFullHandler(b){const R=b.get(P.ILogService),v=b.get(f.IExtHostRpcService),t=b.get(m.IExtHostExtensionService),h=b.get(a.IExtHostTelemetry),r=v.getProxy(N.MainContext.MainThreadExtensionService),l=v.getProxy(N.MainContext.MainThreadErrors),i=await t.getExtensionPathIndex(),p=new WeakMap;Error.prepareStackTrace=(c,s)=>{let d="",k,A;for(const W of s)d+=`
	at ${W.toString()}`,A=W.getFileName(),!k&&A&&(k=i.findSubstr(y.URI.file(A)));return p.set(c,k?.identifier),`${c.name||"Error"}: ${c.message||""}${d}`},n.setUnexpectedErrorHandler(c=>{R.error(c);const s=n.transformErrorForSerialization(c),d=p.get(c);if(!d){l.$onUnexpectedError(s);return}r.$onExtensionRuntimeError(d,s);const k=h.onExtensionError(d,c);R.trace("forwarded error to extension?",k,d)})}}Error.stackTraceLimit=100;class u{constructor(b,R,v,t,h){this._hostUtils=v,this._rpcProtocol=new S.RPCProtocol(b,null,t),R=u._transform(R,this._rpcProtocol);const r=new I.ServiceCollection(...(0,_.getSingletonServiceDescriptors)());r.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...R,messagePorts:h}),r.set(f.IExtHostRpcService,new f.ExtHostRpcService(this._rpcProtocol)),r.set(E.IURITransformerService,new E.URITransformerService(t)),r.set(m.IHostUtils,v);const l=new w.InstantiationService(r,!0);l.invokeFunction(o.installEarlyHandler),this._logService=l.invokeFunction(i=>i.get(P.ILogService)),C.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",R),this._extensionService=l.invokeFunction(i=>i.get(m.IExtHostExtensionService)),this._extensionService.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(b){const R=this._rpcProtocol.getProxy(N.MainContext.MainThreadExtensionService);return y.URI.revive(await R.$asBrowserUri(b))}terminate(b){this._extensionService.terminate(b)}static _transform(b,R){b.allExtensions.forEach(t=>{t.extensionLocation=y.URI.revive(R.transformIncomingURIs(t.extensionLocation));const h={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(r=>h[r]=y.URI.revive(R.transformIncomingURIs(t.browserNlsBundleUris[r]))),t.browserNlsBundleUris=h)}),b.environment.appRoot=y.URI.revive(R.transformIncomingURIs(b.environment.appRoot));const v=b.environment.extensionDevelopmentLocationURI;return v&&(b.environment.extensionDevelopmentLocationURI=v.map(t=>y.URI.revive(R.transformIncomingURIs(t)))),b.environment.extensionTestsLocationURI=y.URI.revive(R.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=y.URI.revive(R.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=y.URI.revive(R.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=y.URI.revive(R.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=y.URI.revive(R.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=y.URI.revive(R.transformIncomingURIs(b.logsLocation)),b.logFile=y.URI.revive(R.transformIncomingURIs(b.logFile)),b.workspace=R.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=u}),define(Ce[250],Ie([1,0,16,17,20,39,15,19,24,2,47]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(g,b,R,v){this.query=g,this.provider=b,this.fileUtils=R,this.processType=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,b){const R=this.query.folderQueries||[],v=new y.CancellationTokenSource;return b.onCancellationRequested(()=>v.cancel()),new Promise((t,h)=>{this.collector=new E(g);let r=!1;const l=(i,p)=>{if(!r&&!this.isLimitHit){const c=this.resultSize(i);a(i)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,r=!0,v.cancel(),i=this.trimResultToSize(i,this.query.maxResults-this.resultCount));const s=this.resultSize(i);this.resultCount+=s,(s>0||!a(i))&&this.collector.add(i,p)}};Promise.all(R.map((i,p)=>this.searchInFolder(i,c=>l(c,p),v.token))).then(i=>{v.dispose(),this.collector.flush();const p=i.some(c=>!!c&&!!c.limitHit);t({limitHit:this.isLimitHit||p,messages:(0,n.flatten)(i.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},i=>{v.dispose();const p=(0,N.toErrorMessage)(i);h(new Error(p))})})}resultSize(g){return a(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,b){const R=Array.isArray(g.ranges)?g.ranges:[g.ranges],v=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:R.slice(0,b),preview:{matches:v.slice(0,b),text:g.preview.text},uri:g.uri}}async searchInFolder(g,b,R){const v=new L.QueryGlobTester(this.query,g),t=[],h={report:i=>{if(!this.validateProviderResult(i))return;const p=g.folder.scheme===S.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(_.dirname(i.uri))):void 0,c=_.relativePath(g.folder,i.uri);if(c){const s=v.includedInQuery(c,P.basename(c),p);(0,C.isThenable)(s)?t.push(s.then(d=>{d&&b(i)})):s&&b(i)}}},r=this.getSearchOptionsForFolder(g),l=await this.provider.provideTextSearchResults(f(this.query.contentPattern),r,h,R);return t.length&&await Promise.all(t),l}validateProviderResult(g){if(a(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const b=(0,L.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),R=(0,L.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),v={folder:I.URI.from(g.folder),excludes:R,includes:b,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return v.usePCRE2=this.query.usePCRE2,v}}e.TextSearchManager=w;function f(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class E{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new o(512,b=>this.sendItems(b))}add(g,b){this._currentFileMatch&&(this._currentFolderIdx!==b||!_.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=b,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(m(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=E;function m(u){return a(u)?{preview:{matches:(0,n.mapArrayOrNot)(u.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:u.preview.text},ranges:(0,n.mapArrayOrNot)(u.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function a(u){return!!u.preview}e.extensionResultIsMatch=a;class o{constructor(g,b){this.maxBatchSize=g,this.cb=b,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,b){!g||this.addItemToBatch(g,b)}addItems(g,b){!g||this.addItemsToBatch(g,b)}addItemToBatch(g,b){this.batch.push(g),this.batchSize+=b,this.onUpdate()}addItemsToBatch(g,b){this.batch=this.batch.concat(g),this.batchSize+=b,this.onUpdate()}onUpdate(){this.totalNumberCompleted<o.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},o.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}o.TIMEOUT=4e3,o.START_BATCH_AFTER_COUNT=50,e.BatchedCollector=o}),define(Ce[110],Ie([1,0,6,5,3,245,18,55,11,2,250]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let w=class{constructor(a,o,u){this.extHostRpc=a,this._uriTransformer=o,this._logService=u,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new N.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,o){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const u=this._handlePool++;return this._textSearchProvider.set(u,o),this._proxy.$registerTextSearchProvider(u,this._transformScheme(a)),(0,n.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}registerFileSearchProvider(a,o){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const u=this._handlePool++;return this._fileSearchProvider.set(u,o),this._proxy.$registerFileSearchProvider(u,this._transformScheme(a)),(0,n.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(a,o,u,g){const b=f(u),R=this._fileSearchProvider.get(a);if(R)return this._fileSearchManager.fileSearch(b,R,v=>{this._proxy.$handleFileMatch(a,o,v.map(t=>t.resource))},g);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,o,u,g){const b=this._textSearchProvider.get(a);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const R=f(u);return this.createTextSearchManager(R,b).search(t=>this._proxy.$handleTextMatch(a,o,t),g)}$enableExtensionHostSearch(){}createTextSearchManager(a,o){return new L.TextSearchManager(a,o,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};w=Ve([He(0,S.IExtHostRpcService),He(1,P.IURITransformerService),He(2,_.ILogService)],w),e.ExtHostSearch=w;function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(E),extraFileResources:m.extraFileResources&&m.extraFileResources.map(a=>I.URI.revive(a))}}e.reviveQuery=f;function E(m){return{...m,folder:I.URI.revive(m.folder)}}}),define(Ce[251],Ie([1,0,66,105,31,103,32,37,57,60,107,109,110,80,69,76,104,59,36,79,74,58,220,11,176,108,78]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R,v,t,h,r,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(i.IExtHostLocalizationService,i.ExtHostLocalizationService,1),(0,n.registerSingleton)(h.ILoggerService,t.ExtHostLoggerService,1),(0,n.registerSingleton)(h.ILogService,r.ExtHostLogService,1),(0,n.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,n.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration,0),(0,n.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,n.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,0),(0,n.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,n.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,n.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,n.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,n.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,n.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,n.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,n.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,n.registerSingleton)(R.IExtHostTelemetry,R.ExtHostTelemetry,0),(0,n.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,n.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(Ce[252],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(y){if(y&&this._dragOperations.has(y)){const N=this._dragOperations.get(y);return this._dragOperations.delete(y),N}}addDragOperationTransfer(y,N){this._dragOperations.set(y,N)}getRenderedTreeElement(y){if(this._renderedElements.has(y))return this._renderedElements.get(y)}addRenderedTreeItemElement(y,N){this._renderedElements.set(y,N)}removeRenderedTreeItemElement(y){this._renderedElements.has(y)&&this._renderedElements.delete(y)}}e.TreeviewsService=n}),define(Ce[253],Ie([1,0,145,7,24,2,4,6,181,17,7,9,16,8,20,252,27]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(R,v){if((0,w.isString)(R))return{label:R};if(R&&typeof R=="object"&&typeof R.label=="string"){let t;return Array.isArray(R.highlights)&&(t=R.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:R.label,highlights:t}}}class g{constructor(v,t,h){this._proxy=v,this.commands=t,this.logService=h,this.treeViews=new Map,this.treeDragAndDropService=new a.TreeviewsService;function r(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>r(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(i=>r(i)?this.convertArgument(i):i):l})}registerTreeDataProvider(v,t,h){const r=this.createTreeView(v,{treeDataProvider:t},h);return{dispose:()=>r.dispose()}}createTreeView(v,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],i=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,c=this.createExtHostTreeView(v,t,h),s=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:l,hasHandleDrag:i,hasHandleDrop:p});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,o.checkProposedApiEnabled)(h,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(d){c.message=d},get title(){return c.title},set title(d){c.title=d},get description(){return c.description},set description(d){c.description=d},get badge(){return c.badge},set badge(d){d!==void 0&&L.ViewBadge.isViewBadge(d)?c.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(c.badge=void 0)},reveal:(d,k)=>c.reveal(d,k),dispose:async()=>{await s,this.treeViews.delete(v),c.dispose()}}}$getChildren(v,t){const h=this.treeViews.get(v);return h?h.getChildren(t):Promise.reject(new _.NoTreeViewError(v))}async $handleDrop(v,t,h,r,l,i,p,c){const s=this.treeViews.get(v);if(!s)return Promise.reject(new _.NoTreeViewError(v));const d=E.DataTransfer.toDataTransfer(h,async k=>(await this._proxy.$resolveDropFileData(v,t,k)).buffer);return p===v&&c&&await this.addAdditionalTransferItems(d,s,c,l,i),s.onDrop(d,r,l)}async addAdditionalTransferItems(v,t,h,r,l){const i=this.treeDragAndDropService.removeDragOperationTransfer(l);if(i)(await i)?.forEach((p,c)=>{p&&v.set(c,p)});else if(l&&t.handleDrag){const p=t.handleDrag(h,v,r);this.treeDragAndDropService.addDragOperationTransfer(l,p),await p}return v}async $handleDrag(v,t,h,r){const l=this.treeViews.get(v);if(!l)return Promise.reject(new _.NoTreeViewError(v));const i=await this.addAdditionalTransferItems(new C.DataTransfer,l,t,r,h);if(!!i)return E.DataTransfer.toDataTransferDTO(i)}async $hasResolve(v){const t=this.treeViews.get(v);if(!t)throw new _.NoTreeViewError(v);return t.hasResolve}$resolve(v,t,h){const r=this.treeViews.get(v);if(!r)throw new _.NoTreeViewError(v);return r.resolveTreeItem(t,h)}$setExpanded(v,t,h){const r=this.treeViews.get(v);if(!r)throw new _.NoTreeViewError(v);r.setExpanded(t,h)}$setSelection(v,t){const h=this.treeViews.get(v);if(!h)throw new _.NoTreeViewError(v);h.setSelection(t)}$setFocus(v,t){const h=this.treeViews.get(v);if(!h)throw new _.NoTreeViewError(v);h.setFocus(t)}$setVisible(v,t){const h=this.treeViews.get(v);if(!h)throw new _.NoTreeViewError(v);h.setVisible(t)}$changeCheckboxState(v,t){const h=this.treeViews.get(v);if(!h)throw new _.NoTreeViewError(v);h.setCheckboxState(t)}createExtHostTreeView(v,t,h){const r=new b(v,t,this._proxy,this.commands.converter,this.logService,h);return this.treeViews.set(v,r),r}convertArgument(v){const t=this.treeViews.get(v.$treeViewId);return t&&"$treeItemHandle"in v?t.getExtensionElement(v.$treeItemHandle):t&&"$focusedTreeItem"in v&&v.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=g;class b extends P.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,w.isUndefinedOrNull)(v))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(v,t,h,r,l,i){if(super(),this.viewId=v,this.proxy=h,this.commands=r,this.logService=l,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new S.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,i.contributes&&i.contributes.views)for(const s in i.contributes.views)for(const d of i.contributes.views[s])d.id===v&&(this._title=d.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let p,c;this._register(S.Event.debounce(this._onDidChangeData.event,(s,d)=>(s||(s={message:!1,elements:[]}),d.element!==!1&&(p||(p=new Promise(k=>c=k),this.refreshPromise=this.refreshPromise.then(()=>p)),Array.isArray(d.element)?s.elements.push(...d.element):s.elements.push(d.element)),d.message&&(s.message=!0),s),200,!0)(({message:s,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const k=c;return p=null,this.refresh(d).then(()=>k())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(v){const t=v?this.getExtensionElement(v):void 0;if(v&&!t)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let h=this.getChildrenNodes(v);return h||(h=await this.fetchChildrenNodes(t)),h?h.map(r=>r.item):void 0}getExtensionElement(v){return this.elements.get(v)}reveal(v,t){t=t||{select:!0,focus:!1};const h=(0,w.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,w.isUndefinedOrNull)(t.focus)?!1:t.focus,l=(0,w.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(i=>this.resolveTreeNode(v,i[i.length-1]).then(p=>this.proxy.$reveal(this.viewId,{item:p.item,parentChain:i.map(c=>c.item)},{select:h,focus:r,expand:l})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:h,focus:r,expand:l})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}get badge(){return this._badge}set badge(v){this._badge?.value===v?.value&&this._badge?.tooltip===v?.tooltip||(this._badge=E.ViewBadge.from(v),this.proxy.$setBadge(this.viewId,v))}setExpanded(v,t){const h=this.getExtensionElement(v);h&&(t?this._onDidExpandElement.fire(Object.freeze({element:h})):this._onDidCollapseElement.fire(Object.freeze({element:h})))}setSelection(v){(0,f.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this._focusedHandle=v}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(v){const t=(await Promise.all(v.map(async h=>{const r=this.getExtensionElement(h.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:h.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(v,t,h){const r=[];for(const l of v){const i=this.getExtensionElement(l);i&&r.push(i)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,t,h),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(v,t,h){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.dndController?.handleDrop))return(0,I.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,v,h):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,t){if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(v);if(h){const r=this.nodes.get(h);if(r){const l=await this.dataProvider.resolveTreeItem(r.extensionItem,h,t)??r.extensionItem;return this.validateTreeItem(l),r.item.tooltip=this.getTooltip(l.tooltip),r.item.command=this.getCommand(r.disposableStore,l.command),r.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(t=>t?this.resolveUnknownParentChain(t).then(h=>this.resolveTreeNode(t,h[h.length-1]).then(r=>(h.push(r),h))):Promise.resolve([]))}resolveParent(v){const t=this.nodes.get(v);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,t){const h=this.nodes.get(v);return h?Promise.resolve(h):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(r=>this.createHandle(v,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(r);if(l){const i=this.nodes.get(l);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(v){if(v){let t;if(typeof v=="string"){const h=this.getExtensionElement(v);t=h?this.nodes.get(h):void 0}else t=v;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const t=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const h=v?this.nodes.get(v):void 0,r=await this.dataProvider.getChildren(v);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,f.coalesce)(r||[]).map(async i=>{const p=await this.dataProvider.getTreeItem(i);return p&&!t.token.isCancellationRequested?this.createAndRegisterTreeNode(i,p,h):null}));return t.token.isCancellationRequested?void 0:(0,f.coalesce)(l)}finally{t.dispose()}}refresh(v){if(v.some(h=>!h))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const h=this.getHandlesToRefresh(v);if(h.length)return this.refreshHandles(h)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const t=new Set,h=v.map(l=>this.nodes.get(l));for(const l of h)if(l&&!t.has(l.item.handle)){let i=l;for(;i&&i.parent&&h.findIndex(p=>i&&i.parent&&p&&p.item.handle===i.parent.item.handle)===-1;){const p=this.elements.get(i.parent.item.handle);i=p?this.nodes.get(p):void 0}i&&!i.parent&&t.add(l.item.handle)}const r=[];return t.forEach(l=>{const i=this.elements.get(l);if(i){const p=this.nodes.get(i);p&&(!p.parent||!t.has(p.parent.item.handle))&&r.push(l)}}),r}refreshHandles(v){const t={};return Promise.all(v.map(h=>this.refreshNode(h).then(r=>{r&&(t[h]=r.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(v){const t=this.getExtensionElement(v);if(t){const h=this.nodes.get(t);if(h)return this.clearChildren(t),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(r=>{if(r){const l=this.createTreeNode(t,r,h.parent);return this.updateNodeCache(t,l,h,h.parent),h.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,t,h){const r=this.createTreeNode(v,t,h);if(t.id&&this.elements.has(r.item.handle))throw new Error((0,n.localize)(0,null,t.id));return this.addNodeToCache(v,r),this.addNodeToParentCache(r,h),r}getTooltip(v){return L.MarkdownString.isMarkdownString(v)?E.MarkdownString.from(v):v}getCommand(v,t){return t?{...this.commands.toInternal(t,v),originalId:t.command}:void 0}getCheckbox(v){if(!v.checkboxState)return;let t,h;return typeof v.checkboxState=="number"?t=v.checkboxState:(t=v.checkboxState.state,h=v.checkboxState.tooltip),{isChecked:t===L.TreeItemCheckboxState.Checked,tooltip:h}}validateTreeItem(v){if(!L.TreeItem.isTreeItem(v,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(v,t,h){this.validateTreeItem(t);const r=new P.DisposableStore,l=this.createHandle(v,t,h),i=this.getLightIconPath(t);return{item:{handle:l,parentHandle:h?h.item.handle:void 0,label:u(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(r,t.command),contextValue:t.contextValue,icon:i,iconDark:this.getDarkIconPath(t)||i,themeIcon:this.getThemeIcon(t),collapsibleState:(0,w.isUndefinedOrNull)(t.collapsibleState)?L.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:h,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(v){return v.iconPath instanceof L.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:t,label:h,resourceUri:r},l,i){if(t)return`${b.ID_HANDLE_PREFIX}/${t}`;const p=u(h,this.extension),c=l?l.item.handle:b.LABEL_HANDLE_PREFIX;let s=p?p.label:r?(0,y.basename)(r):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const d=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,k=this.getChildrenNodes(l)||[];let A,W=0;do{if(A=`${c}/${W}:${s}`,i||!this.elements.has(A)||d===A)break;W++}while(W<=k.length);return A}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof L.ThemeIcon))return typeof v.iconPath=="string"||N.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof L.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return N.URI.isUri(v)?v:N.URI.file(v)}addNodeToCache(v,t){this.elements.set(t.item.handle,v),this.nodes.set(v,t)}updateNodeCache(v,t,h,r){this.elements.delete(t.item.handle),this.nodes.delete(v),t.item.handle!==h.item.handle&&this.elements.delete(h.item.handle),this.addNodeToCache(v,t);const l=this.getChildrenNodes(r)||[],i=l.filter(p=>p.item.handle===h.item.handle)[0];i&&l.splice(l.indexOf(i),1,t)}addNodeToParentCache(v,t){t?(t.children||(t.children=[]),t.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const t=this.nodes.get(v);if(t){if(t.children)for(const h of t.children){const r=this.elements.get(h.item.handle);r&&this.clear(r)}t.children=void 0}}else this.clearAll()}clear(v){const t=this.nodes.get(v);if(t){if(t.children)for(const h of t.children){const r=this.elements.get(h.item.handle);r&&this.clear(r)}this.nodes.delete(v),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(Ce[254],Ie([1,0,20,12,4,29,2,130,263,118,128,43,5,73,207,206,37,208,32,210,211,212,195,213,57,33,214,215,218,219,221,105,198,227,228,229,80,60,232,253,8,7,52,235,61,104,31,187,217,50,103,107,109,110,11,55,18,26,222,193,69,76,204,233,81,59,238,236,237,205,36,230,234,79,58,74,223,106,224,15,92,197,178,216,6,27,183,78,174,225,226]),function(te,e,n,C,y,N,S,P,_,I,L,w,f,E,m,a,o,u,g,b,R,v,t,h,r,l,i,p,c,s,d,k,A,W,J,j,O,B,T,F,z,H,de,pe,re,le,ae,se,Q,K,Z,he,ke,Fe,je,Te,Se,De,oe,ue,Y,D,U,$,V,ee,me,_e,ce,Ee,be,$e,We,tt,Ge,et,it,dt,Le,ot,X,G,ve,Ne,xe,ze,Qe,nt,vt,wt,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ht(rt){const mt=rt.get(De.IExtHostInitDataService),Lt=rt.get(be.IExtHostFileSystemInfo),Kt=rt.get(ee.IExtHostConsumerFileSystem),Tt=rt.get(l.IExtHostExtensionService),ht=rt.get(ae.IExtHostWorkspace),It=rt.get(et.IExtHostTelemetry),Ut=rt.get(g.IExtHostConfiguration),Rt=rt.get(Te.IURITransformerService),Ke=rt.get(Se.IExtHostRpcService),Ft=rt.get(O.IExtHostStorage),Nt=rt.get(V.IExtensionStoragePaths),xt=rt.get(je.ILoggerService),ft=rt.get(je.ILogService),ye=rt.get(Y.IExtHostTunnelService),Pe=rt.get(D.IExtHostApiDeprecationService),ge=rt.get(le.IExtHostWindow),q=rt.get(tt.IExtHostSecretState),Ae=rt.get(Ge.IExtHostEditorTabs);Ke.set(f.ExtHostContext.ExtHostFileSystemInfo,Lt),Ke.set(f.ExtHostContext.ExtHostLogLevelServiceShape,xt),Ke.set(f.ExtHostContext.ExtHostWorkspace,ht),Ke.set(f.ExtHostContext.ExtHostConfiguration,Ut),Ke.set(f.ExtHostContext.ExtHostExtensionService,Tt),Ke.set(f.ExtHostContext.ExtHostStorage,Ft),Ke.set(f.ExtHostContext.ExtHostTunnelService,ye),Ke.set(f.ExtHostContext.ExtHostWindow,ge),Ke.set(f.ExtHostContext.ExtHostSecretState,q),Ke.set(f.ExtHostContext.ExtHostTelemetry,It),Ke.set(f.ExtHostContext.ExtHostEditorTabs,Ae);const Ue=Ke.set(f.ExtHostContext.ExtHostDecorations,rt.get(Z.IExtHostDecorations)),Xe=Ke.set(f.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(r.IExtHostDocumentsAndEditors)),Be=Ke.set(f.ExtHostContext.ExtHostCommands,rt.get(o.IExtHostCommands)),Ze=Ke.set(f.ExtHostContext.ExtHostTerminalService,rt.get(B.IExtHostTerminalService)),ct=Ke.set(f.ExtHostContext.ExtHostDebugService,rt.get(ke.IExtHostDebugService)),kt=Ke.set(f.ExtHostContext.ExtHostSearch,rt.get(Fe.IExtHostSearch)),Et=Ke.set(f.ExtHostContext.ExtHostTask,rt.get(he.IExtHostTask)),bt=Ke.set(f.ExtHostContext.ExtHostOutputService,rt.get(k.IExtHostOutputService)),Dt=Ke.set(f.ExtHostContext.ExtHostLocalization,rt.get(nt.IExtHostLocalizationService)),St=Ke.set(f.ExtHostContext.ExtHostUrls,new pe.ExtHostUrls(Ke)),_t=Ke.set(f.ExtHostContext.ExtHostDocuments,new h.ExtHostDocuments(Ke,Xe)),Vt=Ke.set(f.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ke,Xe,ft)),Jt=Ke.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(ft,_t,Ke.getProxy(f.MainContext.MainThreadBulkEdits))),pt=Ke.set(f.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(Ke,Be,Xe,_t)),si=Ke.set(f.ExtHostContext.ExtHostNotebookDocuments,new ve.ExtHostNotebookDocuments(pt)),oi=Ke.set(f.ExtHostContext.ExtHostNotebookEditors,new G.ExtHostNotebookEditors(ft,pt)),Zt=Ke.set(f.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ke,mt,pt,Be,ft)),vi=Ke.set(f.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(Ke,pt)),Pt=Ke.set(f.ExtHostContext.ExtHostEditors,new T.ExtHostEditors(Ke,Xe)),$t=Ke.set(f.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(Ke.getProxy(f.MainContext.MainThreadTreeViews),Be,ft)),Ei=Ke.set(f.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(Ke.getProxy(f.MainContext.MainThreadEditorInsets),Pt,mt.remote)),ai=Ke.set(f.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Ke,ft,Lt,Xe)),ei=Ke.set(f.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Ke,_t,Be.converter,Rt)),lt=Ke.set(f.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ke,Rt,_t,Be,ai,ft,Pe,It)),Ui=Ke.set(f.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Ke,lt)),Mt=Ke.set(f.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(Ke,ft,Xe)),Xt=Ke.set(f.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(Ke,ht,Be)),ci=Ke.set(f.ExtHostContext.ExtHostSCM,new J.ExtHostSCM(Ke,Be,ft)),bi=Ke.set(f.ExtHostContext.ExtHostQuickDiff,new Ct.ExtHostQuickDiff(Ke,Rt)),wi=Ke.set(f.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Ke,Be,_t)),li=Ke.set(f.ExtHostContext.ExtHostProgress,new A.ExtHostProgress(Ke.getProxy(f.MainContext.MainThreadProgress))),Si=Ke.set(f.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(Ke)),ui=Ke.set(f.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(Ke)),ti=Ke.set(f.ExtHostContext.ExtHostAuthentication,new U.ExtHostAuthentication(Ke)),Bi=Ke.set(f.ExtHostContext.ExtHostTimeline,new $.ExtHostTimeline(Ke,Be)),ii=Ke.set(f.ExtHostContext.ExtHostWebviews,new re.ExtHostWebviews(Ke,mt.remote,ht,ft,Pe)),ni=Ke.set(f.ExtHostContext.ExtHostWebviewPanels,new ce.ExtHostWebviewPanels(Ke,ii,ht)),_i=Ke.set(f.ExtHostContext.ExtHostCustomEditors,new _e.ExtHostCustomEditors(Ke,_t,Nt,ii,ni)),yi=Ke.set(f.ExtHostContext.ExtHostWebviewViews,new me.ExtHostWebviewViews(Ke,ii)),ri=Ke.set(f.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(Ke,Be,Xe)),Di=Ke.set(f.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Ke)),Ci=Ke.set(f.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ke));Ke.set(f.ExtHostContext.ExtHostInteractive,new Ne.ExtHostInteractive(Ke,pt,Xe,Be,ft));const xi=Object.values(f.ExtHostContext);Ke.assertRegistered(xi);const $i=new Ee.ExtHostBulkEdits(Ke,Xe),zi=new a.ExtHostClipboard(Ke),Ii=new d.ExtHostMessageService(Ke,ft),Ai=new R.ExtHostDialogs(Ke),Ri=new j.ExtHostStatusBar(Ke,Be.converter);return m.ExtHostApiCommands.register(Be),function(Me,zt,Oi){const gt=function(){let ne=!Me.isUnderDevelopment;function fe(){ne||(ft.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")fe();else{const yt=st;typeof yt.scheme>"u"&&fe(),typeof yt.exclusive=="boolean"&&(0,ze.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return st}}(),Wi={getSession(ne,fe,Re){return ti.getSession(Me,ne,fe,Re)},async hasSession(ne,fe){return(0,ze.checkProposedApiEnabled)(Me,"authSession"),!!await ti.getSession(Me,ne,fe,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ne,fe,Re,st){return ti.registerAuthenticationProvider(ne,fe,Re,st)}},di={registerCommand(ne,fe,Re){return Be.registerCommand(!0,ne,fe,Re,void 0,Me)},registerTextEditorCommand(ne,fe,Re){return Be.registerCommand(!0,ne,(...st)=>{const yt=Pt.getActiveTextEditor();if(!yt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(At=>{fe.apply(Re,[yt,At,...st])}).then(At=>{At||ft.warn("Edits from command "+ne+" were not applied.")},At=>{ft.warn("An error occurred while running command "+ne,At)})},void 0,void 0,Me)},registerDiffInformationCommand:(ne,fe,Re)=>((0,ze.checkProposedApiEnabled)(Me,"diffCommand"),Be.registerCommand(!0,ne,async(...st)=>{const yt=Xe.activeEditor(!0);if(!yt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}const At=await Pt.getDiffInformation(yt.id);fe.apply(Re,[At,...st])},void 0,void 0,Me)),executeCommand(ne,...fe){return Be.executeCommand(ne,...fe)},getCommands(ne=!1){return Be.getCommands(ne)}},Li={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,ze.checkProposedApiEnabled)(Me,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(Me,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(Me,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return et.ExtHostTelemetryLogger.validateSender(ne),It.instantiateLogger(Me,ne)},openExternal(ne,fe){return ge.openUri(ne,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===mt.environment.appUriScheme)return St.createAppUri(ne);try{return await ge.asExternalUri(ne,{allowTunneling:!!mt.remote.authority})}catch(fe){if((0,X.matchesScheme)(ne,ot.Schemas.http)||(0,X.matchesScheme)(ne,ot.Schemas.https))return ne;throw fe}},get remoteName(){return(0,K.getRemoteName)(mt.remote.authority)},get remoteAuthority(){return(0,ze.checkProposedApiEnabled)(Me,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel}};mt.environment.extensionTestsLocationURI||Object.freeze(Li);const Hi={createTestController(ne,fe,Re){return ri.createTestController(Me,ne,fe,Re)},createTestObserver(){return(0,ze.checkProposedApiEnabled)(Me,"testObserver"),ri.createTestObserver()},runTests(ne){return(0,ze.checkProposedApiEnabled)(Me,"testObserver"),ri.runTests(ne)},get onDidChangeTestResults(){return(0,ze.checkProposedApiEnabled)(Me,"testObserver"),ri.onResultsChanged},get testResults(){return(0,ze.checkProposedApiEnabled)(Me,"testObserver"),ri.results}},hi=mt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Vi={getExtension(ne,fe){(0,ze.isProposedApiEnabled)(Me,"extensionsAny")||(fe=!1);const Re=zt.mine.getExtensionDescription(ne);if(Re)return new l.Extension(Tt,Me.identifier,Re,hi,!1);if(fe){const st=zt.all.getExtensionDescription(ne);if(st)return new l.Extension(Tt,Me.identifier,st,hi,!0)}},get all(){const ne=[];for(const fe of zt.mine.getAllExtensionDescriptions())ne.push(new l.Extension(Tt,Me.identifier,fe,hi,!1));return ne},get allAcrossExtensionHosts(){(0,ze.checkProposedApiEnabled)(Me,"extensionsAny");const ne=new ze.ExtensionIdentifierSet(zt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),fe=[];for(const Re of zt.all.getAllExtensionDescriptions()){const st=!ne.has(Re.identifier);fe.push(new l.Extension(Tt,Me.identifier,Re,hi,st))}return fe},get onDidChange(){return(0,ze.isProposedApiEnabled)(Me,"extensionsAny")?y.Event.any(zt.mine.onDidChange,zt.all.onDidChange):zt.mine.onDidChange}},ki={createDiagnosticCollection(ne){return ai.createDiagnosticCollection(Me.identifier,ne)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ne=>ai.getDiagnostics(ne),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ne,fe){return ei.changeLanguage(ne.uri,fe)},match(ne,fe){const Re=_t.getDocumentData(fe.uri)?.notebook;return(0,L.score)(z.LanguageSelector.from(ne),fe.uri,fe.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(ne,fe,Re){return lt.registerCodeActionProvider(Me,gt(ne),fe,Re)},registerDocumentPasteEditProvider(ne,fe,Re){return(0,ze.checkProposedApiEnabled)(Me,"documentPaste"),lt.registerDocumentPasteEditProvider(Me,gt(ne),fe,Re)},registerCodeLensProvider(ne,fe){return lt.registerCodeLensProvider(Me,gt(ne),fe)},registerDefinitionProvider(ne,fe){return lt.registerDefinitionProvider(Me,gt(ne),fe)},registerDeclarationProvider(ne,fe){return lt.registerDeclarationProvider(Me,gt(ne),fe)},registerImplementationProvider(ne,fe){return lt.registerImplementationProvider(Me,gt(ne),fe)},registerTypeDefinitionProvider(ne,fe){return lt.registerTypeDefinitionProvider(Me,gt(ne),fe)},registerHoverProvider(ne,fe){return lt.registerHoverProvider(Me,gt(ne),fe,Me.identifier)},registerEvaluatableExpressionProvider(ne,fe){return lt.registerEvaluatableExpressionProvider(Me,gt(ne),fe,Me.identifier)},registerInlineValuesProvider(ne,fe){return lt.registerInlineValuesProvider(Me,gt(ne),fe,Me.identifier)},registerDocumentHighlightProvider(ne,fe){return lt.registerDocumentHighlightProvider(Me,gt(ne),fe)},registerLinkedEditingRangeProvider(ne,fe){return lt.registerLinkedEditingRangeProvider(Me,gt(ne),fe)},registerReferenceProvider(ne,fe){return lt.registerReferenceProvider(Me,gt(ne),fe)},registerRenameProvider(ne,fe){return lt.registerRenameProvider(Me,gt(ne),fe)},registerDocumentSymbolProvider(ne,fe,Re){return lt.registerDocumentSymbolProvider(Me,gt(ne),fe,Re)},registerWorkspaceSymbolProvider(ne){return lt.registerWorkspaceSymbolProvider(Me,ne)},registerDocumentFormattingEditProvider(ne,fe){return lt.registerDocumentFormattingEditProvider(Me,gt(ne),fe)},registerDocumentRangeFormattingEditProvider(ne,fe){return lt.registerDocumentRangeFormattingEditProvider(Me,gt(ne),fe)},registerOnTypeFormattingEditProvider(ne,fe,Re,...st){return lt.registerOnTypeFormattingEditProvider(Me,gt(ne),fe,[Re].concat(st))},registerDocumentSemanticTokensProvider(ne,fe,Re){return lt.registerDocumentSemanticTokensProvider(Me,gt(ne),fe,Re)},registerDocumentRangeSemanticTokensProvider(ne,fe,Re){return lt.registerDocumentRangeSemanticTokensProvider(Me,gt(ne),fe,Re)},registerSignatureHelpProvider(ne,fe,Re,...st){return typeof Re=="object"?lt.registerSignatureHelpProvider(Me,gt(ne),fe,Re):lt.registerSignatureHelpProvider(Me,gt(ne),fe,typeof Re>"u"?[]:[Re,...st])},registerCompletionItemProvider(ne,fe,...Re){return lt.registerCompletionItemProvider(Me,gt(ne),fe,Re)},registerInlineCompletionItemProvider(ne,fe){return fe.handleDidShowCompletionItem&&(0,ze.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,ze.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Me,gt(ne),fe)},registerDocumentLinkProvider(ne,fe){return lt.registerDocumentLinkProvider(Me,gt(ne),fe)},registerColorProvider(ne,fe){return lt.registerColorProvider(Me,gt(ne),fe)},registerFoldingRangeProvider(ne,fe){return lt.registerFoldingRangeProvider(Me,gt(ne),fe)},registerSelectionRangeProvider(ne,fe){return lt.registerSelectionRangeProvider(Me,ne,fe)},registerCallHierarchyProvider(ne,fe){return lt.registerCallHierarchyProvider(Me,ne,fe)},registerTypeHierarchyProvider(ne,fe){return lt.registerTypeHierarchyProvider(Me,ne,fe)},setLanguageConfiguration:(ne,fe)=>lt.setLanguageConfiguration(Me,ne,fe),getTokenInformationAtPosition(ne,fe){return(0,ze.checkProposedApiEnabled)(Me,"tokenInformation"),ei.tokenAtPosition(ne,fe)},registerInlayHintsProvider(ne,fe){return lt.registerInlayHintsProvider(Me,ne,fe)},createLanguageStatusItem(ne,fe){return ei.createLanguageStatusItem(Me,ne,fe)},registerDocumentDropEditProvider(ne,fe){return lt.registerDocumentOnDropEditProvider(Me,ne,fe)}},ji={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(ne,fe,Re){const st=await(S.URI.isUri(ne)?Promise.resolve(jt.openTextDocument(ne)):Promise.resolve(ne));return Pt.showTextDocument(st,fe,Re)},createTextEditorDecorationType(ne){return Pt.createTextEditorDecorationType(Me,ne)},onDidChangeActiveTextEditor(ne,fe,Re){return Pt.onDidChangeActiveTextEditor(ne,fe,Re)},onDidChangeVisibleTextEditors(ne,fe,Re){return Pt.onDidChangeVisibleTextEditors(ne,fe,Re)},onDidChangeTextEditorSelection(ne,fe,Re){return Pt.onDidChangeTextEditorSelection(ne,fe,Re)},onDidChangeTextEditorOptions(ne,fe,Re){return Pt.onDidChangeTextEditorOptions(ne,fe,Re)},onDidChangeTextEditorVisibleRanges(ne,fe,Re){return Pt.onDidChangeTextEditorVisibleRanges(ne,fe,Re)},onDidChangeTextEditorViewColumn(ne,fe,Re){return Pt.onDidChangeTextEditorViewColumn(ne,fe,Re)},onDidCloseTerminal(ne,fe,Re){return Ze.onDidCloseTerminal(ne,fe,Re)},onDidOpenTerminal(ne,fe,Re){return Ze.onDidOpenTerminal(ne,fe,Re)},onDidChangeActiveTerminal(ne,fe,Re){return Ze.onDidChangeActiveTerminal(ne,fe,Re)},onDidChangeTerminalDimensions(ne,fe,Re){return(0,ze.checkProposedApiEnabled)(Me,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(ne,fe,Re)},onDidChangeTerminalState(ne,fe,Re){return Ze.onDidChangeTerminalState(ne,fe,Re)},onDidWriteTerminalData(ne,fe,Re){return(0,ze.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(ne,fe,Re)},get state(){return ge.state},onDidChangeWindowState(ne,fe,Re){return ge.onDidChangeWindowState(ne,fe,Re)},showInformationMessage(ne,...fe){return Ii.showMessage(Me,N.default.Info,ne,fe[0],fe.slice(1))},showWarningMessage(ne,...fe){return Ii.showMessage(Me,N.default.Warning,ne,fe[0],fe.slice(1))},showErrorMessage(ne,...fe){return Ii.showMessage(Me,N.default.Error,ne,fe[0],fe.slice(1))},showQuickPick(ne,fe,Re){return Xt.showQuickPick(ne,fe,Re)},showWorkspaceFolderPick(ne){return Xt.showWorkspaceFolderPick(ne)},showInputBox(ne,fe){return Xt.showInput(ne,fe)},showOpenDialog(ne){return Ai.showOpenDialog(ne)},showSaveDialog(ne){return Ai.showSaveDialog(ne)},createStatusBarItem(ne,fe,Re){let st,yt,At;return typeof ne=="string"?(st=ne,yt=fe,At=Re):(yt=ne,At=fe),Ri.createStatusBarEntry(Me,st,yt,At)},setStatusBarMessage(ne,fe){return Ri.setStatusBarMessage(ne,fe)},withScmProgress(ne){return Pe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),li.withProgress(Me,{location:H.ProgressLocation.SourceControl},(fe,Re)=>ne({report(st){}}))},withProgress(ne,fe){return li.withProgress(Me,ne,fe)},createOutputChannel(ne,fe){return bt.createOutputChannel(ne,fe,Me)},createWebviewPanel(ne,fe,Re,st){return ni.createWebviewPanel(Me,ne,fe,Re,st)},createWebviewTextEditorInset(ne,fe,Re,st){return(0,ze.checkProposedApiEnabled)(Me,"editorInsets"),Ei.createWebviewEditorInset(ne,fe,Re,st,Me)},createTerminal(ne,fe,Re){return typeof ne=="object"?"pty"in ne?Ze.createExtensionTerminal(ne):Ze.createTerminalFromOptions(ne):Ze.createTerminal(ne,fe,Re)},registerTerminalLinkProvider(ne){return Ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,fe){return Ze.registerProfileProvider(Me,ne,fe)},registerTerminalQuickFixProvider(ne,fe){return(0,ze.checkProposedApiEnabled)(Me,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(ne,Me.identifier.value,fe)},registerTreeDataProvider(ne,fe){return $t.registerTreeDataProvider(ne,fe,Me)},createTreeView(ne,fe){return $t.createTreeView(ne,fe,Me)},registerWebviewPanelSerializer:(ne,fe)=>ni.registerWebviewPanelSerializer(Me,ne,fe),registerCustomEditorProvider:(ne,fe,Re={})=>_i.registerCustomEditorProvider(Me,ne,fe,Re),registerFileDecorationProvider(ne){return Ue.registerFileDecorationProvider(ne,Me)},registerUriHandler(ne){return St.registerUriHandler(Me.identifier,ne)},createQuickPick(){return Xt.createQuickPick(Me)},createInputBox(){return Xt.createInputBox(Me)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ne,fe,Re){return ui.onDidChangeActiveColorTheme(ne,fe,Re)},registerWebviewViewProvider(ne,fe,Re){return yi.registerWebviewViewProvider(Me,ne,fe,Re?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,fe,Re){return pt.onDidChangeActiveNotebookEditor(ne,fe,Re)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,fe,Re){return oi.onDidChangeNotebookEditorSelection(ne,fe,Re)},onDidChangeNotebookEditorVisibleRanges(ne,fe,Re){return oi.onDidChangeNotebookEditorVisibleRanges(ne,fe,Re)},showNotebookDocument(ne,fe){return pt.showNotebookDocument(ne,fe)},registerExternalUriOpener(ne,fe,Re){return(0,ze.checkProposedApiEnabled)(Me,"externalUriOpener"),Di.registerExternalUriOpener(Me.identifier,ne,fe,Re)},registerProfileContentHandler(ne,fe){return(0,ze.checkProposedApiEnabled)(Me,"profileContentHandlers"),Ci.registrProfileContentHandler(Me,ne,fe)},registerQuickDiffProvider(ne,fe,Re,st){return(0,ze.checkProposedApiEnabled)(Me,"quickDiffProvider"),bi.registerQuickDiffProvider(gt(ne),fe,Re,st)},get tabGroups(){return Ae.tabGroups}},jt={get rootPath(){return Pe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ne){throw C.readonly()},getWorkspaceFolder(ne){return ht.getWorkspaceFolder(ne)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ne){throw C.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ne){throw C.readonly()},updateWorkspaceFolders:(ne,fe,...Re)=>ht.updateWorkspaceFolders(Me,ne,fe||0,...Re),onDidChangeWorkspaceFolders:function(ne,fe,Re){return ht.onDidChangeWorkspace(ne,fe,Re)},asRelativePath:(ne,fe)=>ht.getRelativePath(ne,fe),findFiles:(ne,fe,Re,st)=>ht.findFiles(ne,fe,Re,Me.identifier,st),findTextInFiles:(ne,fe,Re,st)=>{(0,ze.checkProposedApiEnabled)(Me,"findTextInFiles");let yt,At;return typeof fe=="object"?(yt=fe,At=Re):(yt={},At=fe,st=Re),ht.findTextInFiles(ne,yt||{},At,Me.identifier,st)},saveAll:ne=>ht.saveAll(ne),applyEdit(ne,fe){return $i.applyWorkspaceEdit(ne,Me,fe)},createFileSystemWatcher:(ne,fe,Re,st)=>Mt.createFileSystemWatcher(ht,Me,ne,fe,Re,st),get textDocuments(){return _t.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw C.readonly()},openTextDocument(ne){let fe;const Re=ne;if(typeof ne=="string")fe=Promise.resolve(S.URI.file(ne));else if(S.URI.isUri(ne))fe=Promise.resolve(ne);else if(!Re||typeof Re=="object")fe=_t.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(st=>_t.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(ne,fe,Re)=>_t.onDidAddDocument(ne,fe,Re),onDidCloseTextDocument:(ne,fe,Re)=>_t.onDidRemoveDocument(ne,fe,Re),onDidChangeTextDocument:(ne,fe,Re)=>_t.onDidChangeDocument(ne,fe,Re),onDidSaveTextDocument:(ne,fe,Re)=>_t.onDidSaveDocument(ne,fe,Re),onWillSaveTextDocument:(ne,fe,Re)=>Jt.getOnWillSaveTextDocumentEvent(Me)(ne,fe,Re),get notebookDocuments(){return pt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,fe){let Re;if(S.URI.isUri(ne))Re=ne,await pt.openNotebookDocument(ne);else if(typeof ne=="string")Re=S.URI.revive(await pt.createNotebookDocument({viewType:ne,content:fe}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(ne,fe,Re){return si.onDidSaveNotebookDocument(ne,fe,Re)},onDidChangeNotebookDocument(ne,fe,Re){return si.onDidChangeNotebookDocument(ne,fe,Re)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,fe,Re,st){return pt.registerNotebookSerializer(Me,ne,fe,Re,(0,ze.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ne,fe,Re)=>Oi.onDidChangeConfiguration(ne,fe,Re),getConfiguration(ne,fe){return fe=arguments.length===1?void 0:fe,Oi.getConfiguration(ne,fe,Me)},registerTextDocumentContentProvider(ne,fe){return Vt.registerTextDocumentContentProvider(ne,fe)},registerTaskProvider:(ne,fe)=>(Pe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Me,ne,fe)),registerFileSystemProvider(ne,fe,Re){return(0,xe.combinedDisposable)(Ui.registerFileSystemProvider(Me,ne,fe,Re),Kt.addFileSystemProvider(ne,fe))},get fs(){return Kt.value},registerFileSearchProvider:(ne,fe)=>((0,ze.checkProposedApiEnabled)(Me,"fileSearchProvider"),kt.registerFileSearchProvider(ne,fe)),registerTextSearchProvider:(ne,fe)=>((0,ze.checkProposedApiEnabled)(Me,"textSearchProvider"),kt.registerTextSearchProvider(ne,fe)),registerRemoteAuthorityResolver:(ne,fe)=>((0,ze.checkProposedApiEnabled)(Me,"resolvers"),Tt.registerRemoteAuthorityResolver(ne,fe)),registerResourceLabelFormatter:ne=>((0,ze.checkProposedApiEnabled)(Me,"resolvers"),Si.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,fe,Re)=>Mt.onDidCreateFile(ne,fe,Re),onDidDeleteFiles:(ne,fe,Re)=>Mt.onDidDeleteFile(ne,fe,Re),onDidRenameFiles:(ne,fe,Re)=>Mt.onDidRenameFile(ne,fe,Re),onWillCreateFiles:(ne,fe,Re)=>Mt.getOnWillCreateFileEvent(Me)(ne,fe,Re),onWillDeleteFiles:(ne,fe,Re)=>Mt.getOnWillDeleteFileEvent(Me)(ne,fe,Re),onWillRenameFiles:(ne,fe,Re)=>Mt.getOnWillRenameFileEvent(Me)(ne,fe,Re),openTunnel:ne=>((0,ze.checkProposedApiEnabled)(Me,"tunnels"),ye.openTunnel(Me,ne).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,ze.checkProposedApiEnabled)(Me,"tunnels"),ye.getTunnels()},onDidChangeTunnels:(ne,fe,Re)=>((0,ze.checkProposedApiEnabled)(Me,"tunnels"),ye.onDidChangeTunnels(ne,fe,Re)),registerPortAttributesProvider:(ne,fe)=>((0,ze.checkProposedApiEnabled)(Me,"portsAttributes"),ye.registerPortsAttributesProvider(ne,fe)),registerTimelineProvider:(ne,fe)=>((0,ze.checkProposedApiEnabled)(Me,"timeline"),Bi.registerTimelineProvider(ne,fe,Me.identifier,Be.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ne=>((0,ze.checkProposedApiEnabled)(Me,"workspaceTrust"),ht.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,fe,Re)=>ht.onDidGrantWorkspaceTrust(ne,fe,Re),registerEditSessionIdentityProvider:(ne,fe)=>((0,ze.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ne,fe)),onWillCreateEditSessionIdentity:(ne,fe,Re)=>((0,ze.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Me)(ne,fe,Re))},fi={get inputBox(){return Pe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Me)},createSourceControl(ne,fe,Re){return ci.createSourceControl(Me,ne,fe,Re)}},qi={createCommentController(ne,fe){return wi.createCommentController(Me,ne,fe)}},Bt={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(ne,fe,Re){return ct.onDidStartDebugSession(ne,fe,Re)},onDidTerminateDebugSession(ne,fe,Re){return ct.onDidTerminateDebugSession(ne,fe,Re)},onDidChangeActiveDebugSession(ne,fe,Re){return ct.onDidChangeActiveDebugSession(ne,fe,Re)},onDidReceiveDebugSessionCustomEvent(ne,fe,Re){return ct.onDidReceiveDebugSessionCustomEvent(ne,fe,Re)},onDidChangeBreakpoints(ne,fe,Re){return ct.onDidChangeBreakpoints(ne,fe,Re)},registerDebugConfigurationProvider(ne,fe,Re){return ct.registerDebugConfigurationProvider(ne,fe,Re||Qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,fe){return ct.registerDebugAdapterDescriptorFactory(Me,ne,fe)},registerDebugAdapterTrackerFactory(ne,fe){return ct.registerDebugAdapterTrackerFactory(ne,fe)},startDebugging(ne,fe,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ct.startDebugging(ne,fe,{parentSession:Re}):ct.startDebugging(ne,fe,Re||{})},stopDebugging(ne){return ct.stopDebugging(ne)},addBreakpoints(ne){return ct.addBreakpoints(ne)},removeBreakpoints(ne){return ct.removeBreakpoints(ne)},asDebugSourceUri(ne,fe){return ct.asDebugSourceUri(ne,fe)}},mi={registerTaskProvider:(ne,fe)=>Et.registerTaskProvider(Me,ne,fe),fetchTasks:ne=>Et.fetchTasks(ne),executeTask:ne=>Et.executeTask(Me,ne),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ne,fe,Re)=>Et.onDidStartTask(ne,fe,Re),onDidEndTask:(ne,fe,Re)=>Et.onDidEndTask(ne,fe,Re),onDidStartTaskProcess:(ne,fe,Re)=>Et.onDidStartTaskProcess(ne,fe,Re),onDidEndTaskProcess:(ne,fe,Re)=>Et.onDidEndTaskProcess(ne,fe,Re)},Ki={createNotebookController(ne,fe,Re,st,yt){return Zt.createNotebookController(Me,ne,fe,Re,st,(0,ze.isProposedApiEnabled)(Me,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,fe)=>pt.registerNotebookCellStatusBarItemProvider(Me,ne,fe),createRendererMessaging(ne){return vi.createRendererMessaging(Me,ne)},createNotebookControllerDetectionTask(ne){return(0,ze.checkProposedApiEnabled)(Me,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Me,ne)},registerKernelSourceActionProvider(ne,fe){return(0,ze.checkProposedApiEnabled)(Me,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Me,ne,fe)},onDidChangeNotebookCellExecutionState(ne,fe,Re){return(0,ze.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,fe,Re)}},Gi={t(...ne){if(typeof ne[0]=="string"){const fe=ne.shift(),Re=!ne||typeof ne[0]!="object"?ne:ne[0];return Dt.getMessage(Me.identifier.value,{message:fe,args:Re})}return Dt.getMessage(Me.identifier.value,ne[0])},get bundle(){return Dt.getBundle(Me.identifier.value)},get uri(){return Dt.getBundleUri(Me.identifier.value)}};return{version:mt.version,authentication:Wi,commands:di,comments:qi,debug:Bt,env:Li,extensions:Vi,l10n:Gi,languages:ki,notebooks:Ki,scm:fi,tasks:mi,tests:Hi,window:ji,workspace:jt,Breakpoint:H.Breakpoint,TerminalOutputAnchor:H.TerminalOutputAnchor,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileDecoration2:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestionList,Hover:H.Hover,IndentAction:I.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalQuickFixCommand:H.TerminalQuickFixCommand,TerminalQuickFixOpener:H.TerminalQuickFixOpener,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TerminalExitReason:H.TerminalExitReason,TerminalQuickFixType:H.TerminalQuickFixType,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,SnippetTextEdit:H.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItem2:H.TreeItem,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:E.UIKind,Uri:S.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,DocumentDropEdit:H.DocumentDropEdit,DocumentPasteEdit:H.DocumentPasteEdit,InlayHint:H.InlayHint,InlayHintLabelPart:H.InlayHintLabelPart,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.NotebookEdit,NotebookKernelSourceAction:H.NotebookKernelSourceAction,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestRunRequest2:H.TestRunRequest2,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:H.DataTransfer,DataTransferItem:H.DataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.TextTabInput,TabInputTextDiff:H.TextDiffTabInput,TabInputTextMerge:H.TextMergeTabInput,TabInputCustom:H.CustomEditorTabInput,TabInputNotebook:H.NotebookEditorTabInput,TabInputNotebookDiff:H.NotebookDiffEditorTabInput,TabInputWebview:H.WebviewEditorTabInput,TabInputTerminal:H.TerminalEditorTabInput,TabInputInteractiveWindow:H.InteractiveWindowInput,TelemetryTrustedValue:de.TelemetryTrustedValue,LogLevel:je.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Ht}),define(Ce[255],Ie([1,0,254,33,2,248,7,17,239]),function(te,e,n,C,y,N,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class I extends N.RequireInterceptor{_installInterceptor(){}getModule(E,m){for(const a of this._alternatives){const o=a(E);if(o){E=o;break}}if(this._factories.has(E))return this._factories.get(E).load(E,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class L extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=S.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(_.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(n.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(I,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,m,a){m=m.with({path:w(m.path,".js")});const o=E?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const u=y.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(m)),g=await fetch(u.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),g.status!==200)throw new Error(g.statusText);const b=await g.text(),R=`${m.toString(!0)}#vscode-extension`,v=`${b}
//# sourceURL=${R}`;let t;try{t=new Function("module","exports","require",v)}catch(i){throw console.error(o?`Loading code for extension ${o} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${m.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const h={},r={exports:h},l=i=>{const p=this._fakeModules.getModule(i,m);if(p===void 0)throw new Error(`Cannot load module '${i}'`);return p};try{return a.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(r,h,l),r.exports!==h?r.exports:h}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),a.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+E;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}}e.ExtHostExtensionService=L;function w(f,E){return f.endsWith(E)?f:f+E}}),define(Ce[256],Ie([1,0,66,33,81,255]),function(te,e,n,C,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(C.IExtHostExtensionService,N.ExtHostExtensionService,0),(0,n.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(Ce[264],Ie([1,0,23,4,73,249,241,19,82,15,2,251,256]),function(te,e,n,C,y,N,S,P,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function a(t){self.fetch=async function(h,r){return h instanceof Request||E(String(h))&&(h=(await t(L.URI.parse(String(h)))).toString(!0)),m(h,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,r,l,i,p){(async()=>(E(r.toString())&&(r=(await t(L.URI.parse(r.toString()))).toString(!0)),super.open(h,r,l??!0,i,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(h,r){if(/^file:/i.test(h.toString()))h=I.FileAccess.uriToBrowserUri(L.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const i=`(${function(d){function k(J){return typeof J=="string"||J instanceof URL?String(J).replace(/^file:\/\//i,"vscode-file://vscode-app"):J}const A=fetch.bind(self);self.fetch=function(J,j){return J instanceof Request?A(J,j):A(k(J),j)},self.XMLHttpRequest=class extends XMLHttpRequest{open(J,j,O,B,T){return super.open(J,k(j),O??!0,B,T)}};const W=importScripts.bind(self);self.importScripts=(...J)=>{W(...J.map(k))},W(d)}.toString()}('${h}'))`;r=r||{},r.name=r.name||P.basename(h.toString());const p=new Blob([i],{type:"application/javascript"}),c=URL.createObjectURL(p);return new t(c,r)}}else self.Worker=class extends S.NestedWorker{constructor(t,h){super(f,t,{name:P.basename(t.toString()),...h})}};const o=new class{constructor(){this.pid=void 0}exit(t){w()}async exists(t){return!0}async realpath(t){return t}};class u{constructor(){const h=new MessageChannel,r=new C.Emitter;let l=!1;f(h.port2,[h.port2]),h.port1.onmessage=i=>{const{data:p}=i;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const c=n.VSBuffer.wrap(new Uint8Array(p,0,p.byteLength));if((0,y.isMessageOfType)(c,2)){l=!0,b("received terminate message from renderer");return}r.fire(c)},this.protocol={onMessage:r.event,send:i=>{if(!l){const p=i.buffer.buffer.slice(i.buffer.byteOffset,i.buffer.byteOffset+i.buffer.byteLength);h.port1.postMessage(p,[p])}}}}}function g(t){return new Promise(h=>{const r=t.onMessage(l=>{r.dispose();const i=JSON.parse(l.toString());t.send((0,y.createMessageOfType)(0)),h({protocol:t,initData:i})});t.send((0,y.createMessageOfType)(1))})}let b=t=>w();function R(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function v(){_.mark("code/extHost/willConnectToRenderer");const t=new u;return{onmessage(h){!R(h)||g(t.protocol).then(r=>{_.mark("code/extHost/didWaitForInitData");const l=new N.ExtensionHostMain(r.protocol,r.initData,o,null,h.data);a(i=>l.asBrowserUri(i)),b=i=>l.terminate(i)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c6a9727b801542499d2b59cb7db4224e060fc578/core/vs/workbench/api/worker/extensionHostWorker.js.map
